var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 125712;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 125752;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(126579);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,165,3,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,115,95,114,101,108,44,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,115,95,115,109,97,108,108,41,0,0,0,1,0,0,0,166,3,0,0,1,0,0,0,170,3,0,0,1,0,0,0,200,3,0,0,100,97,109,112,101,114,49,46,115,0,0,0,0,0,0,0,1,0,0,0,201,3,0,0,1,0,0,0,206,3,0,0,1,0,0,0,208,3,0,0,50,46,48,32,42,32,115,113,114,116,40,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,49,93,32,42,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,49,93,32,43,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,50,93,32,42,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,50,93,32,43,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,51,93,32,42,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,51,93,41,0,1,0,0,0,237,3,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,115,95,114,101,108,44,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,115,95,115,109,97,108,108,41,0,0,0,1,0,0,0,241,3,0,0,98,111,100,121,50,46,109,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,70,111,114,99,101,115,46,109,111,0,0,0,0,0,0,10,84,104,101,32,100,105,115,116,97,110,99,101,32,98,101,116,119,101,101,110,32,116,104,101,32,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,97,32,97,110,100,32,116,104,101,32,111,114,105,103,105,110,32,111,102,32,102,114,97,109,101,95,98,10,111,102,32,97,32,76,105,110,101,70,111,114,99,101,87,105,116,104,77,97,115,115,32,99,111,109,112,111,110,101,110,116,32,98,101,99,97,109,101,32,115,109,97,108,108,101,114,32,97,115,32,112,97,114,97,109,101,116,101,114,32,115,95,115,109,97,108,108,10,40,61,32,97,32,115,109,97,108,108,32,110,117,109,98,101,114,44,32,100,101,102,105,110,101,100,32,105,110,32,116,104,101,32,34,65,100,118,97,110,99,101,100,34,32,109,101,110,117,41,46,32,84,104,101,32,100,105,115,116,97,110,99,101,32,105,115,10,115,101,116,32,116,111,32,115,95,115,109,97,108,108,44,32,97,108,116,104,111,117,103,104,32,105,116,32,105,115,32,115,109,97,108,108,101,114,44,32,116,111,32,97,118,111,105,100,32,97,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,10,119,104,101,110,32,99,111,109,112,117,116,105,110,103,32,116,104,101,32,100,105,114,101,99,116,105,111,110,32,111,102,32,116,104,101,32,108,105,110,101,32,102,111,114,99,101,46,32,80,111,115,115,105,98,108,101,32,114,101,97,115,111,110,115,10,102,111,114,32,116,104,105,115,32,115,105,116,117,97,116,105,111,110,58,10,45,32,65,116,32,105,110,105,116,105,97,108,32,116,105,109,101,32,116,104,101,32,100,105,115,116,97,110,99,101,32,109,97,121,32,97,108,114,101,97,100,121,32,98,101,32,122,101,114,111,58,32,67,104,97,110,103,101,32,116,104,101,32,105,110,105,116,105,97,108,10,32,32,112,111,115,105,116,105,111,110,115,32,111,102,32,116,104,101,32,98,111,100,105,101,115,32,99,111,110,110,101,99,116,101,100,32,98,121,32,116,104,105,115,32,101,108,101,109,101,110,116,46,10,45,32,72,97,114,100,119,97,114,101,32,115,116,111,112,115,32,97,114,101,32,110,111,116,32,109,111,100,101,108,101,100,32,111,114,32,97,114,101,32,109,111,100,101,108,101,100,32,110,111,116,32,115,116,105,102,102,32,101,110,111,117,103,104,46,10,32,32,73,110,99,108,117,100,101,32,115,116,111,112,115,44,32,101,46,103,46,44,32,115,116,105,102,102,32,115,112,114,105,110,103,115,44,32,111,114,32,105,110,99,114,101,97,115,101,32,116,104,101,32,115,116,105,102,102,110,101,115,115,10,32,32,105,102,32,97,108,114,101,97,100,121,32,112,114,101,115,101,110,116,46,10,45,32,65,110,111,116,104,101,114,32,101,114,114,111,114,32,105,110,32,121,111,117,114,32,109,111,100,101,108,32,109,97,121,32,108,101,97,100,32,116,111,32,117,110,114,101,97,108,105,115,116,105,99,97,108,108,121,32,108,97,114,103,101,32,102,111,114,99,101,115,10,32,32,97,110,100,32,116,111,114,113,117,101,115,32,116,104,97,116,32,119,111,117,108,100,32,105,110,32,114,101,97,108,105,116,121,32,100,101,115,116,114,111,121,32,116,104,101,32,115,116,111,112,115,46,10,45,32,84,104,101,32,102,108,97,110,103,101,95,98,32,99,111,110,110,101,99,116,111,114,32,109,105,103,104,116,32,98,101,32,100,101,102,105,110,101,100,32,98,121,32,97,32,112,114,101,45,100,101,102,105,110,101,100,32,109,111,116,105,111,110,44,10,32,32,101,46,103,46,44,32,119,105,116,104,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,84,114,97,110,115,108,97,116,105,111,110,97,108,46,80,111,115,105,116,105,111,110,32,97,110,100,32,116,104,101,10,32,32,112,114,101,100,101,102,105,110,101,100,32,102,108,97,110,103,101,95,98,46,115,32,105,115,32,122,101,114,111,32,111,114,32,110,101,103,97,116,105,118,101,46,10,0,0,0,0,0,0,0,40,5,0,0,59,5,0,0,5,0,0,0,76,5,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,69,108,101,109,101,110,116,97,114,121,46,83,112,114,105,110,103,68,97,109,112,101,114,83,121,115,116,101,109,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,69,108,101,109,101,110,116,97,114,121,0,0,0,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,69,108,101,109,101,110,116,97,114,121,46,83,112,114,105,110,103,68,97,109,112,101,114,83,121,115,116,101,109,95,105,110,102,111,46,120,109,108,0,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,16,12,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,51,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,1,0,0,0,80,13,0,0,88,13,0,0,0,0,0,0,1,0,0,0,48,13,0,0,56,13,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,101,109,112,116,121,0,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,98,111,100,121,49,46,81,91,50,93,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,49,93,32,43,32,40,45,98,111,100,121,49,46,81,91,49,93,41,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,50,93,32,43,32,98,111,100,121,49,46,81,91,52,93,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,51,93,32,43,32,40,45,98,111,100,121,49,46,81,91,51,93,41,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,52,93,0,0,0,0,0,40,45,98,111,100,121,49,46,81,91,51,93,41,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,49,93,32,43,32,98,111,100,121,49,46,81,91,52,93,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,50,93,32,43,32,98,111,100,121,49,46,81,91,49,93,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,51,93,32,43,32,40,45,98,111,100,121,49,46,81,91,50,93,41,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,52,93,0,0,0,0,0,98,111,100,121,49,46,81,91,52,93,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,49,93,32,43,32,98,111,100,121,49,46,81,91,51,93,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,50,93,32,43,32,40,45,98,111,100,121,49,46,81,91,50,93,41,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,51,93,32,43,32,40,45,98,111,100,121,49,46,81,91,49,93,41,32,42,32,98,111,100,121,49,46,81,95,115,116,97,114,116,91,52,93,0,0,0,0,0,240,13,0,0,120,14,0,0,0,15,0,0,0,0,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,2,0,0,0,152,19,0,0,160,19,0,0,0,0,0,0,1,0,0,0,112,19,0,0,120,19,0,0,0,0,0,0,1,0,0,0,27,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,115,95,114,101,108,44,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,115,95,115,109,97,108,108,41,0,0,0,1,0,0,0,29,0,0,0,1,0,0,0,31,0,0,0,1,0,0,0,37,0,0,0,100,97,109,112,101,114,49,46,115,0,0,0,0,0,0,0,1,0,0,0,39,0,0,0,1,0,0,0,41,0,0,0,1,0,0,0,48,0,0,0,50,46,48,32,42,32,115,113,114,116,40,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,49,93,32,42,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,49,93,32,43,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,50,93,32,42,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,50,93,32,43,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,51,93,32,42,32,100,97,109,112,101,114,49,46,114,95,114,101,108,95,97,91,51,93,41,0,1,0,0,0,67,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,70,114,97,109,101,115,46,73,110,116,101,114,110,97,108,46,109,97,120,87,105,116,104,111,117,116,69,118,101,110,116,40,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,115,95,114,101,108,44,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,115,95,115,109,97,108,108,41,0,0,0,1,0,0,0,71,0,0,0,98,111,100,121,50,46,109,0,1,0,0,0,137,0,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,142,0,0,0,1,0,0,0,150,0,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,155,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,42,32,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,43,32,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,1,0,0,0,80,19,0,0,88,19,0,0,0,0,0,0,1,0,0,0,48,19,0,0,56,19,0,0,0,0,0,0,1,0,0,0,16,19,0,0,24,19,0,0,0,0,0,0,24,18,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,240,18,0,0,248,18,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,32,90,0,0,40,90,0,0,0,0,0,0,1,0,0,0,0,90,0,0,8,90,0,0,0,0,0,0,1,0,0,0,224,89,0,0,232,89,0,0,0,0,0,0,1,0,0,0,192,89,0,0,200,89,0,0,0,0,0,0,1,0,0,0,220,6,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,42,32,40,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,32,43,32,119,111,114,108,100,46,115,99,97,108,101,100,76,97,98,101,108,41,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,0,0,0,0,0,0,0,200,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,15,7,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,2,0,0,0,112,89,0,0,120,89,0,0,0,0,0,0,1,0,0,0,72,89,0,0,80,89,0,0,0,0,0,0,1,0,0,0,31,7,0,0,1,0,0,0,36,7,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,108,101,110,103,116,104,95,97,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,108,101,110,103,116,104,95,97,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,70,111,114,99,101,115,46,109,111,0,0,0,0,0,0,40,22,0,0,185,8,0,0,5,0,0,0,187,8,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,22,0,0,183,8,0,0,5,0,0,0,184,8,0,0,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,84,104,101,114,109,97,108,47,72,101,97,116,84,114,97,110,115,102,101,114,46,109,111,0,0,0,0,96,23,0,0,141,11,0,0,7,0,0,0,143,11,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,62,61,32,48,46,48,32,97,110,100,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,108,105,110,101,70,111,114,99,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,115,95,114,101,108,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,115,95,114,101,108,48,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,84,114,97,110,115,108,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,62,61,32,48,46,48,32,97,110,100,32,115,112,114,105,110,103,49,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,62,61,32,48,46,48,32,97,110,100,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,22,0,0,239,4,0,0,5,0,0,0,243,4,0,0,109,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,108,105,110,101,70,111,114,99,101,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,40,22,0,0,237,4,0,0,5,0,0,0,238,4,0,0,106,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,115,95,114,101,108,48,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,115,95,114,101,108,48,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,80,25,0,0,5,6,0,0,7,0,0,0,5,6,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,80,25,0,0,3,6,0,0,7,0,0,0,4,6,0,0,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,62,61,32,48,46,48,32,97,110,100,32,115,112,114,105,110,103,50,46,108,101,110,103,116,104,70,114,97,99,116,105,111,110,32,60,61,32,49,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,40,22,0,0,48,8,0,0,5,0,0,0,51,8,0,0,143,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,22,0,0,46,8,0,0,5,0,0,0,47,8,0,0,107,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,99,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,99,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,22,0,0,44,8,0,0,5,0,0,0,44,8,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,50,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,50,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,128,31,0,0,33,0,0,0,5,0,0,0,34,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,50,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,50,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,128,31,0,0,30,0,0,0,5,0,0,0,32,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,112,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,128,31,0,0,41,0,0,0,5,0,0,0,42,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([32,98,111,100,121,50,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,33,0,0,195,0,0,0,5,0,0,0,198,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,33,0,0,190,0,0,0,5,0,0,0,194,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,33,0,0,225,2,0,0,5,0,0,0,229,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,136,33,0,0,214,2,0,0,5,0,0,0,218,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,33,0,0,248,2,0,0,5,0,0,0,251,2,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,98,111,100,121,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,136,33,0,0,190,2,0,0,5,0,0,0,192,2,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,33,0,0,165,2,0,0,5,0,0,0,167,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,33,0,0,162,2,0,0,5,0,0,0,164,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,136,33,0,0,159,2,0,0,5,0,0,0,161,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,33,0,0,156,2,0,0,5,0,0,0,158,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,33,0,0,153,2,0,0,5,0,0,0,155,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,136,33,0,0,150,2,0,0,5,0,0,0,152,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,136,33,0,0,149,2,0,0,5,0,0,0,149,2,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,224,50,0,0,189,4,0,0,3,0,0,0,193,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,224,50,0,0,167,4,0,0,3,0,0,0,169,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,50,0,0,164,4,0,0,3,0,0,0,166,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,50,0,0,243,4,0,0,3,0,0,0,245,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,50,0,0,240,4,0,0,3,0,0,0,242,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,50,0,0,237,4,0,0,3,0,0,0,239,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,50,0,0,198,4,0,0,3,0,0,0,202,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,109,117,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,109,117,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,50,0,0,156,4,0,0,3,0,0,0,160,4,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,78,111,71,114,97,118,105,116,121,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,80,111,105,110,116,71,114,97,118,105,116,121,32,104,97,115,32,118,97,108,117,101,58,32,0,224,50,0,0,148,4,0,0,3,0,0,0,149,4,0,0,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,50,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,50,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,112,50,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,50,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,50,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,112,50,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,112,50,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,112,50,46,98,111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,112,50,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,128,31,0,0,35,0,0,0,5,0,0,0,37,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,50,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,97,114,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,97,114,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,97,114,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,97,114,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,97,114,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,97,114,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,97,114,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,97,114,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,136,33,0,0,205,0,0,0,5,0,0,0,210,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,111,100,121,49,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,136,33,0,0,219,2,0,0,5,0,0,0,224,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,51,93,32,62,61,32,48,32,97,110,100,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,50,93,32,62,61,32,48,32,97,110,100,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,49,93,32,62,61,32,48,32,97,110,100,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,98,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,22,0,0,196,8,0,0,5,0,0,0,197,8,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,51,93,32,62,61,32,48,32,97,110,100,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,50,93,32,62,61,32,48,32,97,110,100,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,49,93,32,62,61,32,48,32,97,110,100,32,100,97,109,112,101,114,49,46,99,111,108,111,114,95,97,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,22,0,0,194,8,0,0,5,0,0,0,195,8,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,49,46,109,97,115,115,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,22,0,0,58,8,0,0,5,0,0,0,60,8,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,115,112,114,105,110,103,50,46,109,97,115,115,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,40,22,0,0,67,8,0,0,5,0,0,0,69,8,0,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,50,0,0,194,4,0,0,3,0,0,0,197,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,224,50,0,0,172,4,0,0,3,0,0,0,174,4,0,0,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,224,50,0,0,203,4,0,0,3,0,0,0,206,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,100,97,109,112,101,114,49,46,100,105,97,109,101,116,101,114,95,98,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,100,97,109,112,101,114,49,46,100,105,97,109,101,116,101,114,95,98,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,40,22,0,0,191,8,0,0,5,0,0,0,193,8,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([46,99,111,105,108,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,99,111,105,108,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,109,97,115,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,109,97,115,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,22,0,0,52,8,0,0,5,0,0,0,53,8,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,99,111,105,108,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,99,111,105,108,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,40,22,0,0,54,8,0,0,5,0,0,0,55,8,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,109,97,115,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,109,97,115,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,40,22,0,0,64,8,0,0,5,0,0,0,66,8,0,0,87,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,85,116,105,108,105,116,105,101,115,47,73,110,116,101,114,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,122,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,122,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,122,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,122,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,121,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,121,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,121,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,121,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,120,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,120,95,97,114,114,111,119,72,101,97,100,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,120,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,120,95,97,114,114,111,119,76,105,110,101,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,224,82,0,0,39,0,0,0,5,0,0,0,41,0,0,0,91,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,122,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,122,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,86,105,115,117,97,108,105,122,101,114,115,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,121,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,121,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,120,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,120,95,108,97,98,101,108,46,115,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,200,87,0,0,76,10,0,0,7,0,0,0,78,10,0,0,28,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,115,95,114,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,50,46,115,112,114,105,110,103,46,115,95,114,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,84,114,97,110,115,108,97,116,105,111,110,97,108,46,109,111,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,115,95,114,101,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,115,112,114,105,110,103,49,46,115,112,114,105,110,103,46,115,95,114,101,108,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,184,90,0,0,136,17,0,0,7,0,0,0,137,17,0,0,56,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,69,108,101,109,101,110,116,97,114,121,95,83,112,114,105,110,103,68,97,109,112,101,114,83,121,115,116,101,109,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,49,52,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,49,52,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,49,52,44,49,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,49,52,44,48,93,32,61,32,122,101,114,111,115,40,49,52,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,48,44,49,52,93,32,61,32,122,101,114,111,115,40,48,44,49,52,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,48,44,48,93,32,61,32,122,101,114,111,115,40,48,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,49,52,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,48,93,59,10,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,119,95,97,108,66,49,114,66,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,119,95,97,108,66,50,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,119,95,97,108,66,51,114,66,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,118,95,48,108,66,49,114,66,32,61,32,120,91,52,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,118,95,48,108,66,50,114,66,32,61,32,120,91,53,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,118,95,48,108,66,51,114,66,32,61,32,120,91,54,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,102,114,97,109,101,95,97,80,114,95,48,108,66,49,114,66,32,61,32,120,91,55,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,102,114,97,109,101,95,97,80,114,95,48,108,66,50,114,66,32,61,32,120,91,56,93,59,10,32,32,82,101,97,108,32,120,95,80,98,111,100,121,49,80,102,114,97,109,101,95,97,80,114,95,48,108,66,51,114,66,32,61,32,120,91,57,93,59,10,32,32,82,101,97,108,32,120,95,80,36,83,84,65,84,69,83,69,84,49,80,120,108,66,49,114,66,32,61,32,120,91,49,48,93,59,10,32,32,82,101,97,108,32,120,95,80,36,83,84,65,84,69,83,69,84,49,80,120,108,66,50,114,66,32,61,32,120,91,49,49,93,59,10,32,32,82,101,97,108,32,120,95,80,36,83,84,65,84,69,83,69,84,49,80,120,108,66,51,114,66,32,61,32,120,91,49,50,93,59,10,32,32,82,101,97,108,32,120,95,80,112,50,80,118,32,61,32,120,91,49,51,93,59,10,32,32,82,101,97,108,32,120,95,80,112,50,80,115,32,61,32,120,91,49,52,93,59,10,32,32,32,32,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,69,108,101,109,101,110,116,97,114,121,95,83,112,114,105,110,103,68,97,109,112,101,114,83,121,115,116,101,109,59,10,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,99,0,0,48,99,0,0,64,99,0,0,88,99,0,0,120,99,0,0,136,99,0,0,160,99,0,0,176,99,0,0,200,99,0,0,232,99,0,0,16,100,0,0,40,100,0,0,72,100,0,0,96,100,0,0,136,100,0,0,168,100,0,0,216,100,0,0,8,101,0,0,32,101,0,0,88,101,0,0,112,101,0,0,160,101,0,0,192,101,0,0,248,101,0,0,32,102,0,0,88,102,0,0,136,102,0,0,152,102,0,0,184,102,0,0,224,102,0,0,0,103,0,0,40,103,0,0,80,103,0,0,104,103,0,0,128,103,0,0,144,103,0,0,168,103,0,0,216,103,0,0,40,104,0,0,104,104,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,152,118,0,0,40,117,0,0,176,115,0,0,56,114,0,0,56,114,0,0,192,112,0,0,176,115,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,96,129,0,0,232,125,0,0,120,124,0,0,8,123,0,0,8,123,0,0,152,121,0,0,120,124,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,168,127,0,0,184,127,0,0,200,127,0,0,152,112,0,0,208,127,0,0,224,127,0,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,64,131,0,0,72,131,0,0,80,131,0,0,88,131,0,0,208,130,0,0,96,131,0,0,112,131,0,0,120,131,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,0,0,0,0,0,0,0,0,232,132,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,72,133,0,0,88,133,0,0,96,133,0,0,104,133,0,0,120,133,0,0,136,133,0,0,144,133,0,0,160,133,0,0,176,133,0,0,192,133,0,0,208,133,0,0,224,133,0,0,240,133,0,0,0,134,0,0,16,134,0,0,24,134,0,0,32,134,0,0,48,134,0,0,56,134,0,0,72,134,0,0,88,134,0,0,104,134,0,0,120,134,0,0,136,134,0,0,152,134,0,0,168,134,0,0,184,134,0,0,200,134,0,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,80,135,0,0,88,135,0,0,88,135,0,0,120,135,0,0,168,135,0,0,200,135,0,0,0,136,0,0,48,136,0,0,96,136,0,0,128,136,0,0,176,136,0,0,200,136,0,0,232,136,0,0,16,137,0,0,48,137,0,0,96,137,0,0,128,137,0,0,168,137,0,0,200,137,0,0,240,137,0,0,32,138,0,0,88,138,0,0,128,138,0,0,176,138,0,0,224,138,0,0,8,139,0,0,56,139,0,0,64,139,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,80,135,0,0,64,142,0,0,72,142,0,0,80,142,0,0,96,133,0,0,88,142,0,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,176,143,0,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,200,143,0,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,224,143,0,0,232,143,0,0,240,143,0,0,0,144,0,0,16,144,0,0,24,144,0,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,95,109,101,109,0,0,0,0,0,0,0,0,101,108,116,115,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,62,61,32,107,0,0,0,0,0,99,97,116,95,97,108,108,111,99,95,114,101,97,108,95,97,114,114,97,121,0,0,0,0,101,108,116,115,91,48,93,45,62,110,100,105,109,115,32,61,61,32,101,108,116,115,91,105,93,45,62,110,100,105,109,115,0,0,0,0,0,0,0,0,101,108,116,115,91,48,93,45,62,100,105,109,95,115,105,122,101,91,106,93,32,61,61,32,101,108,116,115,91,105,93,45,62,100,105,109,95,115,105,122,101,91,106,93,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,40,156,0,0,0,0,0,0,160,155,0,0,0,0,0,0,24,155,0,0,0,0,0,0,144,154,0,0,0,0,0,0,136,153,0,0,0,0,0,0,128,152,0,0,0,0,0,0,120,151,0,0,0,0,0,0,112,150,0,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,16,158,0,0,32,158,0,0,40,158,0,0,48,158,0,0,64,158,0,0,72,158,0,0,80,158,0,0,88,158,0,0,96,158,0,0,104,158,0,0,112,158,0,0,128,158,0,0,136,158,0,0,152,158,0,0,168,158,0,0,184,158,0,0,192,158,0,0,208,158,0,0,216,158,0,0,232,158,0,0,240,158,0,0,8,159,0,0,16,159,0,0,24,159,0,0,40,159,0,0,48,159,0,0,64,159,0,0,80,159,0,0,88,159,0,0,96,159,0,0,104,159,0,0,112,159,0,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,0,160,0,0,8,160,0,0,80,160,0,0,128,160,0,0,176,160,0,0,248,160,0,0,56,161,0,0,128,161,0,0,176,161,0,0,248,161,0,0,16,162,0,0,48,162,0,0,104,162,0,0,144,162,0,0,184,162,0,0,240,162,0,0,64,163,0,0,160,163,0,0,208,163,0,0,8,164,0,0,56,164,0,0,128,164,0,0,168,164,0,0,216,164,0,0,8,165,0,0,96,165,0,0,168,165,0,0,24,166,0,0,72,166,0,0,144,166,0,0,176,166,0,0,112,159,0,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,0,160,0,0,112,167,0,0,24,168,0,0,128,160,0,0,176,160,0,0,128,168,0,0,56,161,0,0,128,161,0,0,8,169,0,0,72,169,0,0,16,162,0,0,48,162,0,0,232,169,0,0,40,170,0,0,104,170,0,0,240,162,0,0,64,163,0,0,168,170,0,0,224,170,0,0,104,171,0,0,144,171,0,0,128,164,0,0,168,164,0,0,216,164,0,0,248,171,0,0,128,172,0,0,128,173,0,0,24,166,0,0,72,166,0,0,144,166,0,0,176,166,0,0,112,159,0,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,178,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,179,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,179,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40104);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,24,197,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+50448);
/* memory initializer */ allocate([152,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,232,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,203,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,204,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,205,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,136,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,206,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,207,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,8,207,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,207,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,242,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,72,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,240,243,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,72,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,80,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,232,244,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,244,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,32,1,1,0,64,2,1,0,72,2,1,0,88,2,1,0,104,2,1,0,120,2,1,0,144,2,1,0,168,2,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,32,1,1,0,40,1,1,0,112,1,1,0,152,1,1,0,184,1,1,0,216,1,1,0,0,2,1,0,40,2,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,144,10,1,0,160,10,1,0,168,10,1,0,176,10,1,0,184,10,1,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,216,10,1,0,224,10,1,0,240,10,1,0,0,11,1,0,184,10,1,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61132);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,192,37,1,0,136,39,1,0,144,39,1,0,152,39,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,192,37,1,0,200,38,1,0,24,39,1,0,72,39,1,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,192,37,1,0,136,38,1,0,144,38,1,0,152,38,1,0,168,38,1,0,176,38,1,0,192,38,1,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,192,37,1,0,200,37,1,0,224,37,1,0,240,37,1,0,56,38,1,0,72,38,1,0,104,38,1,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,112,49,1,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,112,49,1,0,10,0,0,0,11,0,0,0,20,49,1,0,140,49,1,0,160,49,1,0,40,49,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,64,235,1,0,64,49,1,0,200,166,1,0,0,0,0,0,104,0,0,0,0,0,0,0,200,166,1,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,200,166,1,0,14,0,0,0,15,0,0,0,0,0,0,0,24,50,1,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,64,235,1,0,232,49,1,0,192,165,1,0,0,0,0,0,0,0,0,0,160,50,1,0,168,50,1,0,152,50,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,120,50,1,0,136,50,1,0,152,50,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71372);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,248,66,1,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,248,66,1,0,20,0,0,0,21,0,0,0,156,66,1,0,20,67,1,0,40,67,1,0,176,66,1,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,64,235,1,0,200,66,1,0,56,166,1,0,0,0,0,0,108,0,0,0,0,0,0,0,56,166,1,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,56,166,1,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,240,76,1,0,216,78,1,0,224,78,1,0,40,81,1,0,64,79,1,0,80,79,1,0,48,81,1,0,56,81,1,0,64,81,1,0,72,81,1,0,88,81,1,0,104,81,1,0,120,81,1,0,136,81,1,0,152,81,1,0,168,81,1,0,184,81,1,0,208,81,1,0,8,81,1,0,32,81,1,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,240,76,1,0,216,78,1,0,224,78,1,0,240,78,1,0,64,79,1,0,80,79,1,0,96,79,1,0,128,79,1,0,160,79,1,0,192,79,1,0,232,79,1,0,16,80,1,0,56,80,1,0,96,80,1,0,120,80,1,0,152,80,1,0,184,80,1,0,224,80,1,0,8,81,1,0,32,81,1,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,240,76,1,0,184,78,1,0,192,78,1,0,200,78,1,0,240,76,1,0,248,77,1,0,72,78,1,0,120,78,1,0,240,76,1,0,184,77,1,0,192,77,1,0,200,77,1,0,216,77,1,0,224,77,1,0,240,77,1,0,0,0,0,0,240,76,1,0,248,76,1,0,16,77,1,0,32,77,1,0,104,77,1,0,120,77,1,0,152,77,1,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,16,84,1,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,16,84,1,0,28,0,0,0,29,0,0,0,156,83,1,0,44,84,1,0,64,84,1,0,176,83,1,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,64,235,1,0,200,83,1,0,200,166,1,0,0,0,0,0,56,0,0,0,0,0,0,0,200,166,1,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,200,166,1,0,14,0,0,0,15,0,0,0,0,0,0,0,208,84,1,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,64,235,1,0,136,84,1,0,192,165,1,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81612);
/* memory initializer */ allocate([32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,96,105,1,0,96,105,1,0,96,105,1,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,8,108,1,0,24,108,1,0,48,108,1,0,80,108,1,0,112,108,1,0,136,108,1,0,168,108,1,0,192,108,1,0,208,108,1,0,224,108,1,0,248,108,1,0,16,109,1,0,48,109,1,0,80,109,1,0,224,108,1,0,104,109,1,0,136,109,1,0,160,109,1,0,184,109,1,0,208,109,1,0,240,109,1,0,0,110,1,0,32,110,1,0,64,110,1,0,88,110,1,0,112,110,1,0,136,110,1,0,152,110,1,0,176,110,1,0,200,110,1,0,224,110,1,0,0,111,1,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+91852);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+98992);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,8,152,1,0,16,152,1,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,32,152,1,0,40,152,1,0,48,152,1,0,56,152,1,0,144,1,0,0,0,0,0,0,168,152,1,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+104216);
/* memory initializer */ allocate([128,159,1,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,64,235,1,0,96,159,1,0,0,166,1,0,0,0,0,0,0,0,0,0,232,159,1,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,64,235,1,0,208,159,1,0,0,166,1,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,128,160,1,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,64,235,1,0,96,160,1,0,192,165,1,0,0,0,0,0,0,0,0,0,232,160,1,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,64,235,1,0,208,160,1,0,192,165,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,24,235,1,0,248,160,1,0,0,0,0,0,96,161,1,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,8,162,1,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,64,235,1,0,80,161,1,0,0,0,0,0,0,0,0,0,0,0,0,0,160,161,1,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,64,235,1,0,136,161,1,0,96,161,1,0,0,0,0,0,0,0,0,0,224,161,1,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,64,235,1,0,200,161,1,0,96,161,1,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,64,235,1,0,240,161,1,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,80,162,1,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,64,235,1,0,56,162,1,0,8,162,1,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,24,235,1,0,96,162,1,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,64,235,1,0,136,162,1,0,128,162,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,56,165,1,0,48,0,0,0,49,0,0,0,0,0,0,0,192,165,1,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,0,166,1,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,56,166,1,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,56,166,1,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,128,166,1,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,128,166,1,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,200,166,1,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,200,166,1,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,16,167,1,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,16,167,1,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,164,1,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,0,165,1,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,64,235,1,0,184,164,1,0,80,162,1,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,24,235,1,0,232,164,1,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,64,235,1,0,8,165,1,0,0,165,1,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,64,235,1,0,72,165,1,0,0,165,1,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,24,235,1,0,136,165,1,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,24,235,1,0,200,165,1,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,160,235,1,0,8,166,1,0,0,0,0,0,1,0,0,0,56,165,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,160,235,1,0,80,166,1,0,0,0,0,0,1,0,0,0,120,165,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,160,235,1,0,152,166,1,0,0,0,0,0,1,0,0,0,56,165,1,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,160,235,1,0,224,166,1,0,0,0,0,0,1,0,0,0,120,165,1,0,3,244,255,255,0,0,0,0,112,167,1,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,64,235,1,0,80,167,1,0,160,162,1,0,0,0,0,0,0,0,0,0,152,181,1,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,181,1,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,186,1,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,8,187,1,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,187,1,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,188,1,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,136,183,1,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,136,183,1,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,40,184,1,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,40,184,1,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,184,184,1,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,185,1,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,182,1,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,182,1,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,182,1,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,182,1,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,188,1,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,128,189,1,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,16,190,1,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,160,190,1,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,185,1,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,185,1,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,112,181,1,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,178,1,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,179,1,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,181,1,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,72,181,1,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,128,177,1,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,64,235,1,0,104,177,1,0,24,161,1,0,0,0,0,0,0,0,0,0,16,178,1,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,24,235,1,0,240,177,1,0,160,235,1,0,216,177,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,178,1,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,160,235,1,0,48,178,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,178,1,0,2,0,0,0,0,0,0,0,224,178,1,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,24,235,1,0,192,178,1,0,160,235,1,0,152,178,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,216,178,1,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,160,235,1,0,0,179,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,216,178,1,0,2,0,0,0,0,0,0,0,160,179,1,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,160,235,1,0,120,179,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,216,178,1,0,2,0,0,0,0,0,0,0,24,180,1,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,160,235,1,0,240,179,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,216,178,1,0,2,0,0,0,0,0,0,0,144,180,1,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,64,235,1,0,104,180,1,0,24,180,1,0,0,0,0,0,0,0,0,0,248,180,1,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,64,235,1,0,208,180,1,0,24,180,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,64,235,1,0,8,181,1,0,128,177,1,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,64,235,1,0,48,181,1,0,128,177,1,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,64,235,1,0,88,181,1,0,128,177,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,64,235,1,0,128,181,1,0,128,177,1,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,64,235,1,0,168,181,1,0,128,177,1,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,24,235,1,0,240,181,1,0,160,235,1,0,208,181,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,182,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,160,235,1,0,48,182,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,182,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,160,235,1,0,112,182,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,182,1,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,160,235,1,0,176,182,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,182,1,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,24,235,1,0,56,183,1,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,24,235,1,0,88,183,1,0,160,235,1,0,240,182,1,0,0,0,0,0,3,0,0,0,128,177,1,0,2,0,0,0,80,183,1,0,2,0,0,0,128,183,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,24,235,1,0,248,183,1,0,160,235,1,0,176,183,1,0,0,0,0,0,3,0,0,0,128,177,1,0,2,0,0,0,80,183,1,0,2,0,0,0,32,184,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,24,235,1,0,152,184,1,0,160,235,1,0,80,184,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,176,184,1,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,160,235,1,0,216,184,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,176,184,1,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,24,235,1,0,88,185,1,0,160,235,1,0,64,185,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,112,185,1,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,160,235,1,0,152,185,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,112,185,1,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,24,235,1,0,48,186,1,0,160,235,1,0,24,186,1,0,0,0,0,0,1,0,0,0,80,186,1,0,0,0,0,0,160,235,1,0,208,185,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,88,186,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,160,235,1,0,216,186,1,0,0,0,0,0,1,0,0,0,80,186,1,0,0,0,0,0,160,235,1,0,144,186,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,240,186,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,24,235,1,0,136,187,1,0,160,235,1,0,112,187,1,0,0,0,0,0,1,0,0,0,168,187,1,0,0,0,0,0,160,235,1,0,40,187,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,176,187,1,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,160,235,1,0,48,188,1,0,0,0,0,0,1,0,0,0,168,187,1,0,0,0,0,0,160,235,1,0,232,187,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,72,188,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,24,235,1,0,200,188,1,0,160,235,1,0,128,188,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,232,188,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,24,235,1,0,88,189,1,0,160,235,1,0,16,189,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,120,189,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,24,235,1,0,232,189,1,0,160,235,1,0,160,189,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,8,190,1,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,24,235,1,0,120,190,1,0,160,235,1,0,48,190,1,0,0,0,0,0,2,0,0,0,128,177,1,0,2,0,0,0,152,190,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+106268);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,136,232,1,0,110,0,0,0,144,232,1,0,114,0,0,0,152,232,1,0,102,0,0,0,160,232,1,0,97,0,0,0,168,232,1,0,101,0,0,0,176,232,1,0,119,0,0,0,184,232,1,0,87,0,0,0,200,232,1,0,115,0,0,0,216,232,1,0,83,0,0,0,232,232,1,0,100,0,0,0,248,232,1,0,68,0,0,0,8,233,1,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,144,234,1,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,24,235,1,0,104,234,1,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,64,235,1,0,128,234,1,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,64,235,1,0,160,234,1,0,120,234,1,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,64,235,1,0,216,234,1,0,200,234,1,0,0,0,0,0,0,0,0,0,0,235,1,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,136,235,1,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,64,235,1,0,96,235,1,0,0,235,1,0,0,0,0,0,0,0,0,0,232,235,1,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,64,235,1,0,192,235,1,0,0,235,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,238,1,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,64,235,1,0,24,238,1,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+116608);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._lis_matrix_assemble;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_get_values;var Kb=env._lis_vector_destroy;var Lb=env._lis_solver_set_option;var Mb=env._tmpfile;var Nb=env._send;var Ob=env._pow;var Pb=env._lis_matrix_set_size;var Qb=env.___cxa_free_exception;var Rb=env.___cxa_find_matching_catch;var Sb=env._isxdigit_l;var Tb=env.___cxa_guard_release;var Ub=env._truncate;var Vb=env._strtol;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._qsort;var dc=env._putchar;var ec=env._floor;var fc=env._pthread_mutex_unlock;var gc=env._printf;var hc=env._sprintf;var ic=env._fopen;var jc=env._vasprintf;var kc=env._emscripten_get_now;var lc=env._stat;var mc=env._lis_solve;var nc=env._strtoull_l;var oc=env._mkport;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._lis_matrix_set_type;var Wc=env._fseek;var Xc=env._isxdigit;var Yc=env._fclose;var Zc=env._vsnprintf;var _c=env.__parseInt;var $c=env._log;var ad=env._pthread_cond_broadcast;var bd=env._popen;var cd=env._recv;var dd=env._fgetc;var ed=env._sysconf;var fd=env.__getFloat;var gd=env._lis_vector_set_value;var hd=env._abort;var id=env._ceil;var jd=env._isspace;var kd=env._localtime;var ld=env._lis_matrix_destroy;var md=env._pthread_getspecific;var nd=env._pthread_cond_wait;var od=env._llvm_lifetime_start;var pd=env.___cxa_is_number_type;var qd=env._ungetc;var rd=env._system;var sd=env._fmin;var td=env._fmax;var ud=env._fflush;var vd=env._strftime_l;var wd=env._fprintf;var xd=env._sscanf;var yd=env._catgets;var zd=env._lis_solver_destroy;var Ad=env._strdup;var Bd=env._asprintf;var Cd=env.__exit;var Dd=env.___ctype_toupper_loc;var Ed=env._bsearch;var Fd=env.__arraySum;var Gd=env.__formatString;var Hd=env._htonl;var Id=env.___ctype_tolower_loc;var Jd=env._unlink;var Kd=env._fputs;var Ld=env._GC_malloc_atomic;var Md=env._pread;var Nd=env._lis_vector_set_size;var Od=env._fscanf;var Pd=env.__scanString;var Qd=env._pthread_setspecific;var Rd=env._copysign;var Sd=env._fputc;var Td=env.___cxa_throw;var Ud=env._lis_matrix_create;var Vd=env._isdigit;var Wd=env._strerror;var Xd=env._emscripten_longjmp;var Yd=env._lis_vector_create;var Zd=env._atexit;var _d=env._sqrt;var $d=env._strerror_r;var ae=0.0;
// EMSCRIPTEN_START_FUNCS
function JT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 3:{k=ZT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=tT(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=bU(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=tT(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{r=b;if((e-b|0)<3){p=52;break b}b=r+3|0;continue b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function KT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=tT(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=tT(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function LT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=tT(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function MT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=tT(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 3:{n=12;break a;break};case 2:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 10:{n=16;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ZT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=tT(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function NT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=tT(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 10:{n=18;break a;break};case 5:{b=b+2|0;continue a;break};case 9:{n=21;break a;break};case 3:{n=12;break a;break};case 30:{n=15;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=ZT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=_T(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=tT(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function OT(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=tT(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 5:{break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=tT(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function PT(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function QT(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=tT(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function RT(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=tT(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function ST(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=tT(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=tT(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function TT(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=HS(c)|0;k=j;i=b;return k|0}function UT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e]|0)==0){f=a[e+1|0]|0}else{f=-1}if((f|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((f|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function VT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=tT(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=tT(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 5:{b=b+2|0;break};case 6:{b=b+3|0;break};case 7:{b=b+4|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function WT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=tT(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function XT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function YT(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function ZT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=$T(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=tT(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 18:{n=38;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function _T(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=tT(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function $T(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=aU(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=tT(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function aU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=tT(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=tT(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function bU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=tT(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=dU(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=cU(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 17:{k=fU(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=eU(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=tT(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{o=69;break b;break};case 5:{o=39;break b;break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 17:{break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=tT(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 24:case 22:{break};case 5:{o=59;break b;break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 7:{o=45;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=tT(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 11:{o=90;break c;break};case 5:{o=78;break d;break};case 7:{o=84;break d;break};case 24:case 22:{break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 29:{o=75;break d;break};case 6:{o=81;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=gU(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function cU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=tT(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function dU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[29608+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function eU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=tT(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=tT(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{p=28;break b;break};case 15:{p=62;break b;break};case 7:{p=34;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((hU(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=tT(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((hU(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function fU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=tT(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{n=37;break b;break};case 7:{n=34;break b;break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=tT(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function gU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=tT(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 5:{l=10;break a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 14:{break};case 29:{if((c[27288+((d[28568+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=tT(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=n;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=47;break a}}break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){p=d[k+76+(d[o+1|0]|0)|0]|0}else{p=tT(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(p|0){case 7:{l=36;break a;break};case 24:case 22:{break};case 6:{l=33;break a;break};case 5:{l=30;break a;break};case 29:{if((c[27288+((d[27032+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 6:{l=13;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=tT(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}o=r;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[o+1|0]|0)|0]|0}else{s=tT(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}o=s;if((o|0)==(r|0)){break}switch(o|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 2:{l=79;break a;break};case 3:{t=ZT(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[o+1|0]|0)|0]|0}else{u=tT(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 10:case 9:case 21:{break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}o=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[o+1|0]|0)|0]|0}else{v=tT(a[o]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 29:{l=94;break d;break};case 7:{l=103;break a;break};case 6:{l=100;break a;break};case 10:case 9:case 21:{break};case 5:{l=97;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[27288+((d[27032+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function hU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function iU(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=tT(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=tT(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function jU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}if((m|0)==27){k=cU(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=tT(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=tT(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function kU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=tT(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 6:{n=31;break b;break};case 7:{n=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 5:{n=28;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function lU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((xe[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 12:{k=VU(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=LU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{m=18;b=b+1|0;break};case 13:{k=VU(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 15:{k=RU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};case 16:{k=WU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((xe[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 19:{k=XU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((xe[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 10:case 21:{n=15;break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){n=82;break b}p=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=p+4|0;continue b;break};case 33:{n=113;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 6:{if((e-b|0)<3){n=77;break b}q=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=q+3|0;continue b;break};case 29:{n=69;break b;break};case 5:{if((e-b|0)<2){n=72;break b}r=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=r+2|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){n=99;break b}s=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=s+3|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}t=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=t+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{n=91;break b;break};case 7:{if((e-b|0)<4){n=104;break b}u=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=u+4|0;continue b;break};default:{m=19;continue b}}break};case 34:{n=110;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{n=116;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==110){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){u=b;if((m|0)==19){c[f>>2]=u;k=0;l=k;i=h;return l|0}else{c[f>>2]=u+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function mU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 2:{k=OU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=KU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 5:{if((e-b|0)<2){n=41;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};case 7:{if((e-b|0)<4){n=49;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function nU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function oU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=5;break a}l=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 4:{m=b+1|0;b=m;if((m|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}n=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=n+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}o=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=o+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 2:{m=b+1|0;b=m;if((m|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}m=b+1|0;b=m;if((m|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=l;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function pU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 21:{m=23;break a;break};case 3:{m=9;break a;break};case 5:{a=a+2|0;continue a;break};case 2:{m=12;break a;break};case 6:{a=a+3|0;continue a;break};case 7:{a=a+4|0;continue a;break};case 9:{m=16;break a;break};case 10:{m=13;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=KU(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function qU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 3:{m=9;break a;break};case 7:{a=a+4|0;continue a;break};case 30:{m=12;break a;break};case 10:{m=15;break a;break};case 9:{m=18;break a;break};case 5:{a=a+2|0;continue a;break};case 6:{a=a+3|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=KU(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=LU(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function rU(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;h=b;b=h+1|0;if((a[e]|0)!=(a[h]|0)){j=12;break a}else{continue a}break};case 5:{break};case 7:{h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=4;break a}else{j=5}break};case 6:{j=5;break};default:{j=13;break a}}if((j|0)==5){j=0;e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=6;break}}h=b;b=h+1|0;e=c;c=e+1|0;if((a[h]|0)!=(a[e]|0)){j=8;break}e=b;b=e+1|0;h=c;c=h+1|0;if((a[e]|0)!=(a[h]|0)){j=10;break}}if((j|0)==4){k=0;l=k;i=f;return l|0}else if((j|0)==6){k=0;l=k;i=f;return l|0}else if((j|0)==8){k=0;l=k;i=f;return l|0}else if((j|0)==10){k=0;l=k;i=f;return l|0}else if((j|0)==12){k=0;l=k;i=f;return l|0}else if((j|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function sU(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function tU(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 7:{a=a+4|0;continue a;break};default:{break a}}}i=c;return a-b|0}function uU(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function vU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function wU(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=HS(c)|0;g=f;i=b;return g|0}function xU(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){d=a[e]|0;if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function yU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{a=a+4|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 6:{a=a+3|0;break};case 5:{a=a+2|0;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function zU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function AU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function BU(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function CU(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27288+(((d[28568+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function DU(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27288+(((d[28568+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function EU(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function FU(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27288+(((d[27032+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function GU(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[27288+(((d[27032+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function HU(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function IU(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function JU(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function KU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 19:{j=MU(h,a+1|0,b,e)|0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};case 29:{l=25;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function LU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}n=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=n+3|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}o=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=o+4|0;continue b;break};case 29:{l=25;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function MU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=NU(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function NU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function OU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=QU(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=PU(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=RU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=SU(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}n=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=n+2|0;continue b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=68;break b}o=b;if((xe[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=o+4|0;continue b;break};case 29:{m=55;break b;break};case 6:{if((e-b|0)<3){m=63;break b}p=b;if((xe[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=p+3|0;continue b;break};case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}q=b;if((xe[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=q+2|0;continue b;break};default:{m=72;break b}}break};case 17:{break b;break};case 7:{if((e-b|0)<4){m=46;break b}r=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=r+4|0;continue b;break};case 29:{m=33;break b;break};case 11:{m=97;break b;break};case 6:{if((e-b|0)<3){m=41;break b}s=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=s+3|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=76;break d;break};case 24:case 22:{m=77;break d;break};case 6:{m=83;break d;break};case 5:{m=78;break d;break};case 10:case 9:case 21:{break};case 17:{break c;break};case 11:{m=97;break c;break};case 7:{m=88;break d;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=TU(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function PU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=18;break b}n=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=n+4|0;continue b;break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 8:case 1:case 0:{m=22;break b;break};case 6:{if((e-b|0)<3){m=13;break b}p=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=p+3|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function QU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[29984+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function RU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){o=32;break b}p=b;if((xe[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=p+3|0;continue b;break};case 10:case 9:case 21:{o=41;break b;break};case 7:{if((e-b|0)<4){o=37;break b}q=b;if((xe[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=q+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 15:{o=68;break b;break};case 29:{o=24;break b;break};case 5:{if((e-b|0)<2){o=27;break b}r=b;if((xe[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=r+2|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((UU(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 8:case 1:case 0:{o=61;break c;break};case 5:{if((e-b|0)<2){o=47;break c}s=b;if((xe[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((xe[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((xe[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((UU(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function SU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 10:case 9:case 21:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 11:{l=49;break b;break};case 23:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}n=d[h+76+(d[a]|0)|0]|0;if((n|0)==11){l=44;break}else if(!((n|0)==10|(n|0)==9|(n|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function TU(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 14:{break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(xe[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=m+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(xe[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=n+3;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=48;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}o=(xe[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!o){l=19;break a}c[j>>2]=p+4;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}o=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!o){l=36;break a}c[j>>2]=q+3;continue a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}o=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!o){l=31;break a}c[j>>2]=r+2;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}o=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!o){l=41;break a}c[j>>2]=s+4;continue a;break};case 29:{l=26;break a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=43;break a}}break};case 29:{l=4;break a;break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}o=t;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}o=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((o|0)==(t|0)){break}switch(o|0){case 2:{l=80;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}o=(xe[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;u=c[j>>2]|0;if(o){l=63;break a}c[j>>2]=u+2;continue c;break};case 8:case 1:case 0:{l=75;break a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}o=(xe[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(o){l=68;break a}c[j>>2]=v+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}o=(xe[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(o){l=73;break a}c[j>>2]=w+4;continue c;break};case 3:{x=KU(k,(c[j>>2]|0)+1|0,e,j)|0;if((x|0)<=0){l=77;break a}else{continue c}break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 11:{l=106;break a;break};case 17:{l=107;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 29:{l=89;break a;break};case 5:{l=91;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{l=90;break d;break};case 11:{l=106;break a;break};case 6:{l=96;break d;break};case 17:{l=107;break a;break};case 7:{l=101;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}o=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!o){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}o=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!o){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}o=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!o){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=u;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((x|0)==0){c[f>>2]=c[j>>2]}B=x;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function UU(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function VU(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 7:{if((e-b|0)<4){k=15;break a}l=b;if((xe[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=l+4|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((xe[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}n=b;if((xe[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=n+2|0;continue a;break};case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function WU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==27){j=PU(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function XU(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 5:{if((b-a|0)<2){l=27;break b}n=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=n+2|0;continue b;break};case 7:{if((b-a|0)<4){l=37;break b}o=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=o+4|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function YU(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function ZU(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function _U(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}



function hia(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;zia(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ie[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}Wea(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}Wea(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((via(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=qna(J,c[p>>2]|0,j,u)|0;Jka(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ie[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;Nea(o);Nea(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;Nea(o);Nea(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;Nea(o);Nea(n);i=e;return}function iia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];jia(a,0,k,j,f,g,h);i=b;return}function jia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;zia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Wea(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Wea(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((via(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=pna(I,c[o>>2]|0,h,t)|0;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}function kia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];lia(a,0,k,j,f,g,h);i=b;return}function lia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;zia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Wea(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Wea(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((via(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=ona(I,c[o>>2]|0,h,t)|0;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}function mia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];nia(a,0,k,j,f,g,h);i=b;return}function nia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;zia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}Wea(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Wea(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((via(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=nna(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Nea(n);Nea(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Nea(n);Nea(m);i=d;return}function oia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];pia(a,0,k,j,f,g,h);i=b;return}function pia(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Aia(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Wea(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Wea(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Bia(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+mna(L,c[p>>2]|0,j);Jka(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}function qia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ria(a,0,k,j,f,g,h);i=b;return}function ria(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Aia(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Wea(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Wea(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Bia(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+lna(L,c[p>>2]|0,j);Jka(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}function sia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];tia(a,0,k,j,f,g,h);i=b;return}function tia(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;Aia(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}Wea(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}Wea(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((Bia(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+kna(L,c[p>>2]|0,j);Jka(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;Nea(o);Nea(n);i=d;return}function uia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Jfa(o,g);g=o;o=c[g>>2]|0;if(!((c[27504]|0)==-1)){c[l>>2]=110016;c[l+4>>2]=186;c[l+8>>2]=0;yea(110016,l,187)}l=(c[110020>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+48>>2]&63](o,108568,108594|0,y)|0;dea(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}Wea(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Wea(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((via(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);N=c[27478]|0;c[k>>2]=j;if((Zha(H,N,108608,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ie[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;Nea(p);Nea(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;Nea(p);Nea(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;Nea(p);Nea(n);i=d;return}function via(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[108568+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[108568+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function wia(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Jfa(k,d);d=k;k=c[d>>2]|0;if(!((c[27506]|0)==-1)){c[j>>2]=110024;c[j+4>>2]=186;c[j+8>>2]=0;yea(110024,j,187)}j=(c[110028>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;xoa(n);o=125584;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;xoa(n);o=125584;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+32>>2]&63](k,108568,108594|0,e)|0;e=c[d>>2]|0;if(!((c[27542]|0)==-1)){c[h>>2]=110168;c[h+4>>2]=186;c[h+8>>2]=0;yea(110168,h,187)}h=(c[110172>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}else{t=e;a[f]=ie[c[(c[e>>2]|0)+16>>2]&127](t)|0;ge[c[(c[e>>2]|0)+20>>2]&127](b,t);dea(c[d>>2]|0)|0;i=g;return}}function xia(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;Jfa(l,d);d=l;l=c[d>>2]|0;if(!((c[27506]|0)==-1)){c[k>>2]=110024;c[k+4>>2]=186;c[k+8>>2]=0;yea(110024,k,187)}k=(c[110028>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;xoa(o);p=125584;q=127;Td(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;xoa(o);p=125584;q=127;Td(n|0,p|0,q|0)}He[c[(c[l>>2]|0)+32>>2]&63](l,108568,108600|0,e)|0;e=c[d>>2]|0;if(!((c[27542]|0)==-1)){c[j>>2]=110168;c[j+4>>2]=186;c[j+8>>2]=0;yea(110168,j,187)}j=(c[110172>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;xoa(s);t=125584;u=127;Td(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;xoa(s);t=125584;u=127;Td(r|0,t|0,u|0)}else{u=e;a[f]=ie[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ie[c[(c[e>>2]|0)+16>>2]&127](u)|0;ge[c[(c[e>>2]|0)+20>>2]&127](b,u);dea(c[d>>2]|0)|0;i=h;return}}function yia(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[108568+j|0]|0;if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function zia(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;Jfa(j,b);b=j;j=c[b>>2]|0;if(!((c[27504]|0)==-1)){c[h>>2]=110016;c[h+4>>2]=186;c[h+8>>2]=0;yea(110016,h,187)}h=(c[110020>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;xoa(m);n=125584;o=127;Td(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;xoa(m);n=125584;o=127;Td(l|0,n|0,o|0)}He[c[(c[j>>2]|0)+48>>2]&63](j,108568,108594|0,d)|0;d=c[b>>2]|0;if(!((c[27544]|0)==-1)){c[g>>2]=110176;c[g+4>>2]=186;c[g+8>>2]=0;yea(110176,g,187)}g=(c[110180>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}else{s=d;c[e>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](s)|0;ge[c[(c[d>>2]|0)+20>>2]&127](a,s);dea(c[b>>2]|0)|0;i=f;return}}function Aia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;Jfa(k,b);b=k;k=c[b>>2]|0;if(!((c[27504]|0)==-1)){c[j>>2]=110016;c[j+4>>2]=186;c[j+8>>2]=0;yea(110016,j,187)}j=(c[110020>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;xoa(n);o=125584;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;xoa(n);o=125584;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+48>>2]&63](k,108568,108600|0,d)|0;d=c[b>>2]|0;if(!((c[27544]|0)==-1)){c[h>>2]=110176;c[h+4>>2]=186;c[h+8>>2]=0;yea(110176,h,187)}h=(c[110180>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}else{t=d;c[e>>2]=ie[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](t)|0;ge[c[(c[d>>2]|0)+20>>2]&127](a,t);dea(c[b>>2]|0)|0;i=g;return}}function Bia(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[108568+o|0]|0;do{if((o|0)==23|(o|0)==22){a[e]=80}else if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function Cia(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Dia(a){a=a|0;i=i;return}function Eia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}Jfa(n,f);f=n;n=c[f>>2]|0;if(!((c[27542]|0)==-1)){c[l>>2]=110168;c[l+4>>2]=186;c[l+8>>2]=0;yea(110168,l,187)}l=(c[110172>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;xoa(u);v=125584;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;xoa(u);v=125584;w=127;Td(t|0,v|0,w|0)}w=n;dea(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&127](o,w)}else{ge[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((xe[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];Nea(o);i=j;return}function Fia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=108816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);x=c[27478]|0;c[k>>2]=h;h=Gia(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Jfa(q,f);Hia(w,y,k,z,o,p,q);dea(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];kba(b,j,z,e,o,f,g);i=d;return}function Gia(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=Zc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function Hia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27506]|0)==-1)){c[m>>2]=110024;c[m+4>>2]=186;c[m+8>>2]=0;yea(110024,m,187)}m=(c[110028>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27542]|0)==-1)){c[l>>2]=110168;c[l+4>>2]=186;c[l+8>>2]=0;yea(110168,l,187)}l=(c[110172>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;Nea(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;Nea(n);i=k;return}}function Iia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);y=c[27478]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Gia(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Jfa(r,f);Hia(x,z,l,A,p,q,r);dea(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];kba(b,k,A,e,p,f,g);i=d;return}function Jia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=108816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);v=c[27478]|0;c[k>>2]=h;h=Gia(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Jfa(q,f);Hia(w,y,k,z,o,p,q);dea(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];kba(b,j,z,e,o,f,g);i=d;return}function Kia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);w=c[27478]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Gia(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Jfa(r,f);Hia(x,z,l,A,p,q,r);dea(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];kba(b,k,A,e,p,f,g);i=d;return}function Lia(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109920]|0)==0;if(F){do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Mia(s,r,z,n)|0}else{do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);o=c[27478]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Mia(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}dpa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Soa(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}dpa()}}while(0);Jfa(w,f);Nia(N,L,G,P,u,v,w);dea(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];kba(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Toa(O)}if((J|0)==0){i=d;return}Toa(J);i=d;return}function Mia(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=jc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function Nia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27506]|0)==-1)){c[m>>2]=110024;c[m+4>>2]=186;c[m+8>>2]=0;yea(110024,m,187)}m=(c[110028>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27542]|0)==-1)){c[l>>2]=110168;c[l+4>>2]=186;c[l+8>>2]=0;yea(110168,l,187)}l=(c[110172>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[27478]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[27478]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=xe[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);He[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;Nea(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;Nea(n);i=k;return}function Oia(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109920]|0)==0;if(F){do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Mia(s,r,z,n)|0}else{do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);o=c[27478]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Mia(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}dpa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Soa(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}dpa()}}while(0);Jfa(w,f);Nia(N,L,G,P,u,v,w);dea(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];kba(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Toa(O)}if((J|0)==0){i=d;return}Toa(J);i=d;return}function Pia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=108824;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);s=c[27478]|0;c[k>>2]=h;h=Gia(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;Jfa(p,f);r=p;p=c[r>>2]|0;if(!((c[27506]|0)==-1)){c[l>>2]=110024;c[l+4>>2]=186;c[l+8>>2]=0;yea(110024,l,187)}l=(c[110028>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}dea(c[r>>2]|0)|0;He[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];kba(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];kba(b,j,u,z,m,f,g);I=j;i=d;return}function Qia(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Ria(a){a=a|0;i=i;return}function Sia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}Jfa(n,f);f=n;n=c[f>>2]|0;if(!((c[27544]|0)==-1)){c[l>>2]=110176;c[l+4>>2]=186;c[l+8>>2]=0;yea(110176,l,187)}l=(c[110180>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;xoa(u);v=125584;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;xoa(u);v=125584;w=127;Td(t|0,v|0,w|0)}w=n;dea(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&127](o,w)}else{ge[c[f+28>>2]&127](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=xe[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];pfa(o);i=j;return}function Tia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=108816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);v=c[27478]|0;c[k>>2]=h;h=Gia(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Jfa(q,f);Uia(w,y,k,z,o,p,q);dea(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Via(b,j,z,e,o,f,g);i=d;return}function Uia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27504]|0)==-1)){c[m>>2]=110016;c[m+4>>2]=186;c[m+8>>2]=0;yea(110016,m,187)}m=(c[110020>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27544]|0)==-1)){c[l>>2]=110176;c[l+4>>2]=186;c[l+8>>2]=0;yea(110176,l,187)}l=(c[110180>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;Nea(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;Nea(n);i=k;return}function Via(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){ofa(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((le[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){pfa(l);break}c[m>>2]=0;c[b>>2]=0;pfa(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function Wia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);w=c[27478]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=Gia(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Jfa(r,f);Uia(x,z,l,A,p,q,r);dea(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Via(b,k,A,e,p,f,g);i=d;return}function Xia(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=108816;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=117}}while(0);w=m;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);v=c[27478]|0;c[k>>2]=h;h=Gia(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;Jfa(q,f);Uia(w,y,k,z,o,p,q);dea(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];Via(b,j,z,e,o,f,g);i=d;return}function Yia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);y=c[27478]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=Gia(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;Jfa(r,f);Uia(x,z,l,A,p,q,r);dea(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];Via(b,k,A,e,p,f,g);i=d;return}function Zia(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109920]|0)==0;if(F){do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Mia(s,r,z,n)|0}else{do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);o=c[27478]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Mia(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}dpa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Soa(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}dpa()}}while(0);Jfa(w,f);_ia(N,L,G,P,u,v,w);dea(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Via(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Toa(O)}if((J|0)==0){i=d;return}Toa(J);i=d;return}function _ia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[27504]|0)==-1)){c[m>>2]=110016;c[m+4>>2]=186;c[m+8>>2]=0;yea(110016,m,187)}m=(c[110020>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;xoa(r);s=125584;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[27544]|0)==-1)){c[l>>2]=110176;c[l+4>>2]=186;c[l+8>>2]=0;yea(110176,l,187)}l=(c[110180>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;xoa(v);w=125584;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&127](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[27478]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[27478]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=xe[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);He[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;Nea(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;Nea(n);i=k;return}function $ia(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=Gia(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[109920]|0)==0;if(F){do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);r=c[27478]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=Mia(s,r,z,n)|0}else{do{if(o){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);o=c[27478]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=Mia(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}dpa()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=Soa(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}dpa()}}while(0);Jfa(w,f);_ia(N,L,G,P,u,v,w);dea(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];Via(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){Toa(O)}if((J|0)==0){i=d;return}Toa(J);i=d;return}function aja(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=108824;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);s=c[27478]|0;c[k>>2]=h;h=Gia(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else if((r|0)==32){t=k}else{u=10}}while(0);if((u|0)==10){t=m}Jfa(p,f);u=p;p=c[u>>2]|0;if(!((c[27504]|0)==-1)){c[l>>2]=110016;c[l+4>>2]=186;c[l+8>>2]=0;yea(110016,l,187)}l=(c[110020>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}dea(c[u>>2]|0)|0;u=o;He[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Via(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];Via(b,j,u,z,m,f,g);I=j;i=d;return}function bja(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;Jfa(r,h);v=r;r=c[v>>2]|0;if(!((c[27506]|0)==-1)){c[q>>2]=110024;c[q+4>>2]=186;c[q+8>>2]=0;yea(110024,q,187)}q=(c[110028>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;xoa(y);z=125584;A=127;Td(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;xoa(y);z=125584;A=127;Td(x|0,z|0,A|0)}A=r;dea(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((le[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ie[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=xe[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(xe[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=le[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=le[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];we[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ie[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ie[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ie[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function cja(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function dja(a){a=a|0;i=i;return}function eja(a){a=a|0;i=i;return 2}function fja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];bja(a,b,l,k,f,g,h,108928,108936|0);i=j;return}function gja(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];bja(b,d,m,l,g,h,j,s,q);i=k;return}function hja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Jfa(n,f);f=n;n=c[f>>2]|0;if(!((c[27506]|0)==-1)){c[m>>2]=110024;c[m+4>>2]=186;c[m+8>>2]=0;yea(110024,m,187)}m=(c[110028>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}s=n;dea(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Eha(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function ija(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Jfa(n,f);f=n;n=c[f>>2]|0;if(!((c[27506]|0)==-1)){c[m>>2]=110024;c[m+4>>2]=186;c[m+8>>2]=0;yea(110024,m,187)}m=(c[110028>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}s=n;dea(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=Eha(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function jja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Jfa(m,f);f=m;m=c[f>>2]|0;if(!((c[27506]|0)==-1)){c[l>>2]=110024;c[l+4>>2]=186;c[l+8>>2]=0;yea(110024,l,187)}l=(c[110028>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;xoa(p);q=125584;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;xoa(p);q=125584;r=127;Td(o|0,q|0,r|0)}r=m;dea(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=oja(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function kja(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Jfa(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[27506]|0)==-1)){c[ba>>2]=110024;c[ba+4>>2]=186;c[ba+8>>2]=0;yea(110024,ba,187)}ba=(c[110028>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;xoa(Ga);Ha=125584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;xoa(Ga);Ha=125584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;dea(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=oja(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];nja(0,e,m,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=oja(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];bja(ra,d,y,x,g,h,j,108968,108973|0);c[Da>>2]=c[ra>>2];break};case 65:case 97:{Da=c[f>>2]|0;ca=d+8|0;Ha=ie[c[c[ca>>2]>>2]&127](ca)|0;c[aa>>2]=Da;c[Q+0>>2]=c[aa+0>>2];Da=(Eha(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((Da|0)>=168){break a}c[j+24>>2]=((Da|0)/12|0|0)%7|0;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];Da=oja(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(Da|0)<366){c[j+28>>2]=Da;break a}else{c[h>>2]=Ha|4;break a}break};case 88:{Ha=d+8|0;Da=ie[c[(c[Ha>>2]|0)+24>>2]&127](Ha)|0;Ha=e;c[Aa>>2]=c[Ha>>2];c[Ba>>2]=c[f>>2];ca=a[Da]|0;if((ca&1)==0){Ja=Da+1|0;Ka=Da+1|0;La=(ca&255)>>>1}else{ca=c[Da+8>>2]|0;Ja=ca;Ka=ca;La=c[Da+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];bja(za,d,q,p,g,h,j,Ka,Ja+La|0);c[Ha>>2]=c[za>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Ha=oja(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(Ha|0)<61){c[j>>2]=Ha;break a}else{c[h>>2]=Da|4;break a}break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];bja(ja,d,J,I,g,h,j,108944,108952|0);c[Da>>2]=c[ja>>2];break};case 114:{Da=e;c[pa>>2]=c[Da>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];bja(oa,d,A,z,g,h,j,108952,108963|0);c[Da>>2]=c[oa>>2];break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];Ha=oja(e,G,h,Ia,2)|0;ca=c[h>>2]|0;do{if((ca&4|0)==0){if(!((Ha+ -1|0)>>>0<12)){break}c[Da>>2]=Ha;break a}}while(0);c[h>>2]=ca|4;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];mja(d,j+8|0,e,B,h,Ia);break};case 101:case 100:{Ha=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];Da=oja(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((Da+ -1|0)>>>0<31)){break}c[Ha>>2]=Da;break a}}while(0);c[h>>2]=Fa|4;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];lja(0,e,C,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=oja(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 104:case 66:case 98:{Da=c[f>>2]|0;Ha=d+8|0;ca=ie[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=Da;c[P+0>>2]=c[$+0>>2];Da=(Eha(e,P,ca,ca+288|0,Ia,h,0)|0)-ca|0;if((Da|0)>=288){break a}c[j+16>>2]=((Da|0)/12|0|0)%12|0;break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];bja(ua,d,v,u,g,h,j,108976,108984|0);c[Da>>2]=c[ua>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=oja(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[ca&63](b,d,s,r,g,h,j);i=l;return};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=oja(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 99:{Da=d+8|0;ca=ie[c[(c[Da>>2]|0)+12>>2]&127](Da)|0;Da=e;c[ea>>2]=c[Da>>2];c[fa>>2]=c[f>>2];Ha=a[ca]|0;if((Ha&1)==0){Ma=ca+1|0;Na=ca+1|0;Oa=(Ha&255)>>>1}else{Ha=c[ca+8>>2]|0;Ma=Ha;Na=Ha;Oa=c[ca+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];bja(da,d,O,N,g,h,j,Na,Ma+Oa|0);c[Da>>2]=c[da>>2];break};case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];bja(ga,d,L,K,g,h,j,108936,108944|0);c[Da>>2]=c[ga>>2];break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=oja(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function lja(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ie[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ie[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ie[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function mja(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=Eha(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function nja(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((le[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ie[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function oja(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(le[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ie[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((le[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function pja(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;Jfa(p,f);t=p;p=c[t>>2]|0;if(!((c[27504]|0)==-1)){c[o>>2]=110016;c[o+4>>2]=186;c[o+8>>2]=0;yea(110016,o,187)}o=(c[110020>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}y=p;dea(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((le[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=xe[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(xe[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=le[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=le[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];we[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ie[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ie[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ie[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function qja(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function rja(a){a=a|0;i=i;return}function sja(a){a=a|0;i=i;return 2}function tja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];pja(a,b,l,k,f,g,h,109080,109112|0);i=j;return}function uja(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];pja(b,d,m,l,g,h,j,s,q);i=k;return}function vja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Jfa(n,f);f=n;n=c[f>>2]|0;if(!((c[27504]|0)==-1)){c[m>>2]=110016;c[m+4>>2]=186;c[m+8>>2]=0;yea(110016,m,187)}m=(c[110020>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}s=n;dea(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=bia(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function wja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;Jfa(n,f);f=n;n=c[f>>2]|0;if(!((c[27504]|0)==-1)){c[m>>2]=110016;c[m+4>>2]=186;c[m+8>>2]=0;yea(110016,m,187)}m=(c[110020>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;xoa(q);r=125584;s=127;Td(p|0,r|0,s|0)}s=n;dea(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=bia(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function xja(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;Jfa(m,f);f=m;m=c[f>>2]|0;if(!((c[27504]|0)==-1)){c[l>>2]=110016;c[l+4>>2]=186;c[l+8>>2]=0;yea(110016,l,187)}l=(c[110020>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;xoa(p);q=125584;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;xoa(p);q=125584;r=127;Td(o|0,q|0,r|0)}r=m;dea(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=Cja(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}



function yda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;Uda(105920,h,105976);c[26302]=107428;c[105216>>2]=107448;c[105212>>2]=0;Lfa(105216|0,105920);c[105288>>2]=0;c[105292>>2]=-1;j=c[t>>2]|0;c[26506]=107296;tla(106028|0);k=106032|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[26506]=106536;c[106056>>2]=j;ula(g,106028|0);k=xla(g,110088)|0;l=k;vla(g);c[106060>>2]=l;c[106064>>2]=105984;a[106068|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[26324]=107508;c[105300>>2]=107528;Lfa(105300|0,106024);c[105372>>2]=0;c[105376>>2]=-1;l=c[r>>2]|0;c[26518]=107296;tla(106076|0);k=106080|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[26518]=106536;c[106104>>2]=l;ula(f,106076|0);k=xla(f,110088)|0;g=k;vla(f);c[106108>>2]=g;c[106112>>2]=105992;a[106116|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[26346]=107508;c[105388>>2]=107528;Lfa(105388|0,106072);c[105460>>2]=0;c[105464>>2]=-1;g=c[(c[(c[26346]|0)+ -12>>2]|0)+105408>>2]|0;c[26368]=107508;c[105476>>2]=107528;Lfa(105476|0,g);c[105548>>2]=0;c[105552>>2]=-1;c[(c[(c[26302]|0)+ -12>>2]|0)+105280>>2]=105296;g=(c[(c[26346]|0)+ -12>>2]|0)+105388|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[26346]|0)+ -12>>2]|0)+105456>>2]=105296;Gda(106120,h,106e3|0);c[26390]=107468;c[105568>>2]=107488;c[105564>>2]=0;Lfa(105568|0,106120);c[105640>>2]=0;c[105644>>2]=-1;c[26544]=107360;tla(106180|0);h=106184|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[26544]=106280;c[106208>>2]=j;ula(e,106180|0);j=xla(e,110096)|0;h=j;vla(e);c[106212>>2]=h;c[106216>>2]=106008;a[106220|0]=(ie[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[26412]=107548;c[105652>>2]=107568;Lfa(105652|0,106176);c[105724>>2]=0;c[105728>>2]=-1;c[26556]=107360;tla(106228|0);h=106232|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[26556]=106280;c[106256>>2]=l;ula(d,106228|0);l=xla(d,110096)|0;h=l;vla(d);c[106260>>2]=h;c[106264>>2]=106016;a[106268|0]=(ie[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[26434]=107548;c[105740>>2]=107568;Lfa(105740|0,106224);c[105812>>2]=0;c[105816>>2]=-1;h=c[(c[(c[26434]|0)+ -12>>2]|0)+105760>>2]|0;c[26456]=107548;c[105828>>2]=107568;Lfa(105828|0,h);c[105900>>2]=0;c[105904>>2]=-1;c[(c[(c[26390]|0)+ -12>>2]|0)+105632>>2]=105648;h=(c[(c[26434]|0)+ -12>>2]|0)+105740|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[26434]|0)+ -12>>2]|0)+105808>>2]=105648;i=b;return}function zda(a){a=a|0;a=i;Jga(105296)|0;Jga(105472)|0;Qga(105648)|0;Qga(105824)|0;i=a;return}function Ada(a){a=a|0;var b=0;b=i;c[a>>2]=107360;vla(a+4|0);i=b;return}function Bda(a){a=a|0;var b=0;b=i;c[a>>2]=107360;vla(a+4|0);_oa(a);i=b;return}function Cda(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=xla(d,110096)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Dda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Eda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function Fda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Gda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=107360;j=b+4|0;tla(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=106392;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;ula(g,j);j=xla(g,110096)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Fka(106488)}else{vla(g);i=f;return}}function Hda(a){a=a|0;var b=0;b=i;c[a>>2]=107360;vla(a+4|0);i=b;return}function Ida(a){a=a|0;var b=0;b=i;c[a>>2]=107360;vla(a+4|0);_oa(a);i=b;return}function Jda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=xla(d,110096)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Fka(106488)}else{i=e;return}}function Kda(a){a=a|0;var b=0,c=0;b=i;c=Nda(a,0)|0;i=b;return c|0}function Lda(a){a=a|0;var b=0,c=0;b=i;c=Nda(a,1)|0;i=b;return c|0}function Mda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function Nda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=dd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ge[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=dd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((qd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function Oda(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);i=b;return}function Pda(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);_oa(a);i=b;return}function Qda(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=xla(d,110088)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function Rda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function Sda(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function Tda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function Uda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=107296;j=b+4|0;tla(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=106648;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;ula(g,j);j=xla(g,110088)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){Fka(106488)}else{vla(g);i=f;return}}function Vda(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);i=b;return}function Wda(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);_oa(a);i=b;return}function Xda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=xla(d,110088)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){Fka(106488)}else{i=e;return}}function Yda(a){a=a|0;var b=0,c=0;b=i;c=$da(a,0)|0;i=b;return c|0}function Zda(a){a=a|0;var b=0,c=0;b=i;c=$da(a,1)|0;i=b;return c|0}function _da(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}else if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function $da(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=dd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ge[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=dd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((qd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function aea(){var a=0;a=i;yda(0);Zd(185,105912,q|0)|0;i=a;return}function bea(a){a=a|0;i=i;return}function cea(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function dea(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}fe[c[(c[a>>2]|0)+8>>2]&255](a);f=1;i=b;return f|0}function eea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=106792;e=upa(b|0)|0;f=Zoa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;wpa(g|0,b|0,e+1|0)|0;i=d;return}function fea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=106792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}$oa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}function gea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=106792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}$oa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function hea(a){a=a|0;i=i;return c[a+4>>2]|0}function iea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=106816;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=upa(f|0)|0;g=Zoa(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;wpa(h|0,f|0,d+1|0)|0;i=e;return}function jea(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=106816;e=upa(b|0)|0;f=Zoa(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;wpa(g|0,b|0,e+1|0)|0;i=d;return}function kea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=106816;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}$oa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}function lea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=106816;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}$oa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function mea(a){a=a|0;i=i;return c[a+4>>2]|0}function nea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=106792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}$oa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}function oea(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=106792;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}$oa((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;_oa(j);i=b;return}function pea(a){a=a|0;i=i;return}function qea(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function rea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ee[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function sea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function tea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Wd(e|0)|0;e=upa(f|0)|0;if(e>>>0>4294967279){zea(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;wpa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=Yoa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;wpa(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function uea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{efa(e,107032,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ee[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}efa(e,o,p)|0;if((a[g]&1)==0){break}_oa(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function vea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=upa(e|0)|0;if(j>>>0>4294967279){zea(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=Yoa(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}wpa(k|0,e|0,j|0)|0;a[k+j|0]=0;uea(g,d,h);iea(b,g);if(!((a[g]&1)==0)){_oa(c[g+8>>2]|0)}if(!((a[h]&1)==0)){_oa(c[h+8>>2]|0)}c[b>>2]=107048;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function wea(a){a=a|0;var b=0;b=i;lea(a);_oa(a);i=b;return}function xea(a){a=a|0;var b=0;b=i;lea(a);i=b;return}function yea(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(107184)|0;if((c[a>>2]|0)==1){do{nd(107208,107184)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;fc(107184)|0;fe[d&255](b);tc(107184)|0;c[a>>2]=-1;fc(107184)|0;ad(107208)|0;i=e;return}else{fc(107184)|0;i=e;return}}function zea(a){a=a|0;a=Ec(8)|0;eea(a,107256);c[a>>2]=106872;Td(a|0,106912,40)}function Aea(a){a=a|0;a=Ec(8)|0;eea(a,107256);c[a>>2]=106936;Td(a|0,106976,40)}function Bea(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Cea(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Dea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){zea(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=Yoa(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}wpa(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function Eea(b){b=b|0;i=i;return(a[b]&1)!=0|0}function Fea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){zea(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=Yoa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}wpa(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function Gea(a){a=a|0;i=i;return a|0}function Hea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=upa(d|0)|0;if(f>>>0>4294967279){zea(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;wpa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=Yoa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;wpa(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function Iea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){zea(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=Yoa(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}ypa(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function Jea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){zea(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;ypa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=Yoa(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;ypa(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function Kea(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){Aea(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){zea(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;wpa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=Yoa(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;wpa(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function Lea(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Mea(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function Nea(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}_oa(c[b+8>>2]|0);i=d;return}function Oea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}ffa(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}xpa(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function Pea(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Qea(a,b)|0;i=c;return d|0}function Qea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=upa(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}ffa(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}xpa(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function Rea(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function Sea(a){a=a|0;i=i;return a+1|0}function Tea(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function Uea(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function Vea(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function Wea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){Xea(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function Xea(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){gfa(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}ypa(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function Yea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){Xea(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function Zea(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){zea(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=Yoa(f)|0}else{p=Yoa(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}wpa(l|0,n|0,q+1|0)|0;if(o){_oa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function _ea(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function $ea(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function afa(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function bfa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function cfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=efa(b,g,h)|0;i=e;return d|0}function dfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){gfa(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function efa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){ffa(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}wpa(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function ffa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){zea(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=Yoa(q)|0;if((g|0)!=0){wpa(e|0,m|0,g|0)|0}if((j|0)!=0){wpa(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){wpa(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){_oa(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function gfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){zea(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=Yoa(p)|0;if((g|0)!=0){wpa(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){wpa(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}_oa(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function hfa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;Kea(a,b,c,d,0);i=e;return}function ifa(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function jfa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=upa(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function kfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=ppa(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function lfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=upa(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){Aea(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=ppa(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function mfa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){zea(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;wpa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=Yoa(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;wpa(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function nfa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){zea(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=Yoa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}toa(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function ofa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){zea(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=Yoa(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}voa(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function pfa(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}_oa(c[b+8>>2]|0);i=d;return}function qfa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=rfa(a,b,soa(b)|0)|0;i=c;return d|0}function rfa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}ufa(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}uoa(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function sfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){zea(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=Yoa(f)|0}else{p=Yoa(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}toa(l,n,q+1|0)|0;if(o){_oa(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function tfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){vfa(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function ufa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){zea(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=Yoa(q<<2)|0;p=e;if((g|0)!=0){toa(p,m,g)|0}if((j|0)!=0){toa(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){toa(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){_oa(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function vfa(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){zea(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=Yoa(p<<2)|0;o=e;if((g|0)!=0){toa(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){toa(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}_oa(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function wfa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=upa(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){zea(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=Yoa(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}wpa(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=efa(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=efa(b,m,j)|0;i=f;return}}function xfa(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function yfa(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function zfa(a,b){a=a|0;b=b|0;var c=0;c=i;Afa(a,b);i=c;return}function Afa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[107640]|0)==0){if((Za(107640)|0)==0){break}c[26908]=108336;Zd(66,107632,q|0)|0;Tb(107640)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=107632;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];vea(b,f,107688);c[e>>2]=107656;Td(e|0,107736,62)}function Bfa(a,b){a=a|0;b=b|0;var d=0;d=i;Afa(a,c[a+16>>2]|b);i=d;return}function Cfa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=107680;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ee[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}vla(a+28|0);Toa(c[e>>2]|0);Toa(c[f>>2]|0);Toa(c[a+48>>2]|0);Toa(c[a+60>>2]|0);i=b;return}function Dfa(a){a=a|0;var b=0;b=i;Cfa(a);_oa(a);i=b;return}function Efa(a){a=a|0;var b=0;b=i;Cfa(a);i=b;return}function Ffa(a){a=a|0;var b=0;b=i;Cfa(a);i=b;return}function Gfa(a){a=a|0;i=i;return c[a+24>>2]|0}function Hfa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}ula(d,a+28|0);a=xla(d,110024)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;vla(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function Ifa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;ula(e,a+28|0);a=xla(e,110024)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;vla(e);i=d;return f|0}function Jfa(a,b){a=a|0;b=b|0;var c=0;c=i;ula(a,b+28|0);i=c;return}function Kfa(a){a=a|0;c[a>>2]=107280;i=i;return}function Lfa(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));tla(b);i=d;return}function Mfa(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);_oa(a);i=b;return}function Nfa(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);i=b;return}function Ofa(a){a=a|0;var b=0;b=i;c[a>>2]=107296;vla(a+4|0);i=b;return}function Pfa(a,b){a=a|0;b=b|0;var c=0;c=i;ula(a,b+4|0);i=c;return}function Qfa(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function Rfa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=xe[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function Sfa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=le[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function Tfa(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=107296;tla(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function Ufa(a){a=a|0;i=i;return c[a+8>>2]|0}function Vfa(a){a=a|0;i=i;return c[a+12>>2]|0}function Wfa(a){a=a|0;i=i;return c[a+16>>2]|0}function Xfa(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function Yfa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function Zfa(a){a=a|0;i=i;return c[a+20>>2]|0}function _fa(a){a=a|0;i=i;return c[a+24>>2]|0}function $fa(a){a=a|0;i=i;return c[a+28>>2]|0}function aga(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function bga(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function cga(a,b){a=a|0;b=b|0;i=i;return}function dga(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function ega(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function fga(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function gga(a){a=a|0;i=i;return 0}function hga(a){a=a|0;i=i;return 0}function iga(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ie[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function jga(a){a=a|0;i=i;return-1}function kga(a){a=a|0;var b=0,e=0,f=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function lga(a,b){a=a|0;b=b|0;i=i;return-1}function mga(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function nga(a,b){a=a|0;b=b|0;i=i;return-1}function oga(a){a=a|0;var b=0;b=i;c[a>>2]=107360;vla(a+4|0);_oa(a);i=b;return}function pga(a){a=a|0;var b=0;b=i;c[a>>2]=107360;vla(a+4|0);i=b;return}function qga(a,b){a=a|0;b=b|0;i=i;return}function rga(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function sga(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function tga(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function uga(a){a=a|0;i=i;return 0}function vga(a){a=a|0;i=i;return 0}function wga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function xga(a){a=a|0;i=i;return-1}function yga(a){a=a|0;var b=0,d=0,e=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function zga(a,b){a=a|0;b=b|0;i=i;return-1}function Aga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((xe[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function Bga(a,b){a=a|0;b=b|0;i=i;return-1}function Cga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));tla(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Dga(a){a=a|0;var b=0;b=i;Cfa(a+8|0);_oa(a);i=b;return}function Ega(a){a=a|0;var b=0;b=i;Cfa(a+8|0);i=b;return}function Fga(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Cfa(a+(d+8)|0);_oa(a+d|0);i=b;return}function Gga(a){a=a|0;var b=0;b=i;Cfa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Hga(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;Iga(a,b,c);i=d;return}function Iga(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){Afa(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){Jga(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}ula(h,e+(k+28)|0);k=xla(h,110024)|0;vla(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ie[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;Afa(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function Jga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Jga(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;Afa(b+h|0,c[b+(h+16)>>2]|1)}}while(0);Yga(e);i=d;return b|0}function Kga(b){b=b|0;i=i;return(a[b]|0)!=0|0}function Lga(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function Mga(a){a=a|0;var b=0;b=i;Cfa(a+8|0);_oa(a);i=b;return}function Nga(a){a=a|0;var b=0;b=i;Cfa(a+8|0);i=b;return}function Oga(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Cfa(a+(d+8)|0);_oa(a+d|0);i=b;return}function Pga(a){a=a|0;var b=0;b=i;Cfa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function Qga(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{Qga(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;Afa(b+h|0,c[b+(h+16)>>2]|1)}}while(0);iha(e);i=d;return b|0}function Rga(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));tla(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function Sga(a){a=a|0;var b=0;b=i;Cfa(a+4|0);_oa(a);i=b;return}function Tga(a){a=a|0;var b=0;b=i;Cfa(a+4|0);i=b;return}function Uga(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Cfa(a+(d+4)|0);_oa(a+d|0);i=b;return}function Vga(a){a=a|0;var b=0;b=i;Cfa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function Wga(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){Jga(g)|0}a[f]=1;i=e;return}function Xga(a){a=a|0;var b=0;b=i;Yga(a);i=b;return}function Yga(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;Afa(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function Zga(b){b=b|0;i=i;return(a[b]|0)!=0|0}function _ga(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ie[b&127](a)|0;i=c;return d|0}function $ga(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){Yga(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{Jga(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;ula(k,b+(p+28)|0);p=xla(k,108744)|0;m=p;vla(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){ula(h,b+(k+28)|0);r=xla(h,110024)|0;s=xe[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;vla(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];oe[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){Yga(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;Afa(b+l|0,c[b+(l+16)>>2]|5);Yga(j);i=e;return b|0}function aha(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){Yga(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{Jga(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;Yga(f);i=e;return b|0}if((xe[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{Yga(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;Afa(b+d|0,c[b+(d+16)>>2]|1);Yga(f);i=e;return b|0}function bha(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){Yga(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){Jga(k)|0}a[h]=1;if((e|0)==0){Yga(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((le[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){Yga(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;Afa(b+e|0,c[b+(e+16)>>2]|1);Yga(g);i=f;return b|0}function cha(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;re[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function dha(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){Yga(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{Jga(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ie[l&31](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){Yga(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;Afa(b+f|0,c[b+(f+16)>>2]|4);Yga(h);i=e;return b|0}function eha(a){a=a|0;var b=0;b=i;Cfa(a+4|0);_oa(a);i=b;return}function fha(a){a=a|0;var b=0;b=i;Cfa(a+4|0);i=b;return}function gha(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;Cfa(a+(d+4)|0);_oa(a+d|0);i=b;return}function hha(a){a=a|0;var b=0;b=i;Cfa(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function iha(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;Afa(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function jha(a){a=a|0;i=i;return 107576}function kha(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){Fea(a,107592,35);i=d;return}else{tea(a,b,c);i=d;return}}function lha(a){a=a|0;i=i;return}function mha(a){a=a|0;var b=0;b=i;xea(a);_oa(a);i=b;return}function nha(a){a=a|0;var b=0;b=i;xea(a);i=b;return}function oha(a){a=a|0;var b=0;b=i;Cfa(a);_oa(a);i=b;return}function pha(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function qha(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function rha(a){a=a|0;i=i;return}function sha(a){a=a|0;i=i;return}function tha(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function uha(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){zea(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=Yoa(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function vha(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function wha(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function xha(a){a=a|0;i=i;return}function yha(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function zha(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){zea(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=Yoa(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function Aha(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function Bha(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Cha(a){a=a|0;i=i;return}function Dha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==1){a[j]=1}else if((z|0)==0){a[j]=0}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Jfa(u,g);m=u;u=c[m>>2]|0;if(!((c[27506]|0)==-1)){c[p>>2]=110024;c[p+4>>2]=186;c[p+8>>2]=0;yea(110024,p,187)}p=(c[110028>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}F=u;dea(c[m>>2]|0)|0;Jfa(v,g);g=v;v=c[g>>2]|0;if(!((c[27542]|0)==-1)){c[o>>2]=110168;c[o+4>>2]=186;c[o+8>>2]=0;yea(110168,o,187)}o=(c[110172>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}J=v;dea(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&127](g,J);ge[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=Eha(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];Nea(w+12|0);Nea(w);i=k;return}function Eha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Soa(l)|0;if((n|0)!=0){o=n;p=n;break}dpa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ie[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ie[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=xe[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(xe[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ie[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}Toa(o);i=k;return _|0}function Fha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Gha(a,0,k,j,f,g,h);i=b;return}function Gha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;wia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Wea(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Wea(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Yha(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=sna(F,c[o>>2]|0,h,t)|0;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}function Hha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Iha(a,0,k,j,f,g,h);i=b;return}function Iha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;wia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}Wea(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Wea(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((Yha(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=rna(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}function Jha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Kha(a,0,k,j,f,g,h);i=b;return}function Kha(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==8){u=16}else if((t|0)==0){u=0}else if((t|0)==64){u=8}else{u=10}t=l;wia(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}Wea(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}Wea(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((Yha(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=qna(G,c[p>>2]|0,j,u)|0;Jka(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;Nea(o);Nea(n);i=e;return}if((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;Nea(o);Nea(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;Nea(o);Nea(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;Nea(o);Nea(n);i=e;return}function Lha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Mha(a,0,k,j,f,g,h);i=b;return}function Mha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;wia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Wea(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Wea(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Yha(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=pna(F,c[o>>2]|0,h,t)|0;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}function Nha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Oha(a,0,k,j,f,g,h);i=b;return}function Oha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;wia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}Wea(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}Wea(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((Yha(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=ona(F,c[o>>2]|0,h,t)|0;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;Nea(n);Nea(m);i=d;return}function Pha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Qha(a,0,k,j,f,g,h);i=b;return}function Qha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;wia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}Wea(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}Wea(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((Yha(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=nna(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;Nea(n);Nea(m);i=d;return}function Rha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Sha(a,0,k,j,f,g,h);i=b;return}function Sha(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;xia(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Wea(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Wea(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((yia(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+mna(I,c[p>>2]|0,j);Jka(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}function Tha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Uha(a,0,k,j,f,g,h);i=b;return}function Uha(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;xia(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Wea(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Wea(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((yia(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+lna(I,c[p>>2]|0,j);Jka(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}function Vha(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];Wha(a,0,k,j,f,g,h);i=b;return}function Wha(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;xia(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}Wea(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Wea(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((yia(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+kna(I,c[p>>2]|0,j);Jka(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;Nea(o);Nea(n);i=d;return}function Xha(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Jfa(o,g);g=o;o=c[g>>2]|0;if(!((c[27506]|0)==-1)){c[l>>2]=110024;c[l+4>>2]=186;c[l+8>>2]=0;yea(110024,l,187)}l=(c[110028>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;xoa(w);x=125584;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+32>>2]&63](o,108568,108594|0,y)|0;dea(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}Wea(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}Wea(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((Yha(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);K=c[27478]|0;c[k>>2]=j;if((Zha(E,K,108608,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;Nea(p);Nea(n);i=d;return}if((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;Nea(p);Nea(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;Nea(p);Nea(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;Nea(p);Nea(n);i=d;return}function Yha(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[108568+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[108568+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function Zha(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function _ha(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function $ha(a){a=a|0;i=i;return}function aia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}Jfa(u,g);m=u;u=c[m>>2]|0;if(!((c[27504]|0)==-1)){c[p>>2]=110016;c[p+4>>2]=186;c[p+8>>2]=0;yea(110016,p,187)}p=(c[110020>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}F=u;dea(c[m>>2]|0)|0;Jfa(v,g);g=v;v=c[g>>2]|0;if(!((c[27544]|0)==-1)){c[o>>2]=110176;c[o+4>>2]=186;c[o+8>>2]=0;yea(110176,o,187)}o=(c[110180>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}J=v;dea(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&127](g,J);ge[c[(c[v>>2]|0)+28>>2]&127](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=bia(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];pfa(w+12|0);pfa(w);i=k;return}function bia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=Soa(l)|0;if((n|0)!=0){o=n;p=n;break}dpa()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=xe[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(xe[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ie[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}Toa(o);i=k;return ba|0}function cia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dia(a,0,k,j,f,g,h);i=b;return}function dia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;zia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}Wea(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}Wea(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((via(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=sna(I,c[o>>2]|0,h,t)|0;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;Nea(n);Nea(m);i=d;return}function eia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];fia(a,0,k,j,f,g,h);i=b;return}function fia(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;zia(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;Wea(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}Wea(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}Wea(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((via(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=rna(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;Jka(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;Nea(n);Nea(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;Nea(n);Nea(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;Nea(n);Nea(m);i=d;return}function gia(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];hia(a,0,k,j,f,g,h);i=b;return}



function yja(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;Jfa(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[27504]|0)==-1)){c[ba>>2]=110016;c[ba+4>>2]=186;c[ba+8>>2]=0;yea(110016,ba,187)}ba=(c[110020>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;xoa(Ga);Ha=125584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;xoa(Ga);Ha=125584;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;dea(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=Cja(e,G,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];Aja(d,j+8|0,e,B,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=Cja(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 120:{Da=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[Da&63](b,d,s,r,g,h,j);i=l;return};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];Da=Cja(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=Da+ -1900;break};case 82:{Da=e;c[sa>>2]=c[Da>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];pja(ra,d,y,x,g,h,j,109224,109244|0);c[Da>>2]=c[ra>>2];break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Da=Cja(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<61){c[j>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=Cja(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=Cja(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=Cja(e,M,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];pja(oa,d,A,z,g,h,j,109176,109220|0);c[ca>>2]=c[oa>>2];break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];pja(ga,d,L,K,g,h,j,109112,109144|0);c[ca>>2]=c[ga>>2];break};case 65:case 97:{ca=c[f>>2]|0;Da=d+8|0;Ha=ie[c[c[Da>>2]>>2]&127](Da)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(bia(e,Q,Ha,Ha+168|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];zja(0,e,C,h,Ia);break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=Cja(e,F,h,Ia,3)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];pja(ua,d,v,u,g,h,j,109248,109280|0);c[Ha>>2]=c[ua>>2];break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Ha=Cja(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<13){c[j+16>>2]=Ha+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 88:{ca=d+8|0;Ha=ie[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Ka=Ha+4|0;La=Ha+4|0;Ma=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Ka=Da;La=Da;Ma=c[Ha+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];pja(za,d,q,p,g,h,j,La,Ka+(Ma<<2)|0);c[ca>>2]=c[za>>2];break};case 104:case 66:case 98:{ca=c[f>>2]|0;Ha=d+8|0;Da=ie[c[(c[Ha>>2]|0)+4>>2]&127](Ha)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(bia(e,P,Da,Da+288|0,Ia,h,0)|0)-Da|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 99:{ca=d+8|0;Da=ie[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Ha=a[Da]|0;if((Ha&1)==0){Na=Da+4|0;Oa=Da+4|0;Pa=(Ha&255)>>>1}else{Ha=c[Da+8>>2]|0;Na=Ha;Oa=Ha;Pa=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];pja(da,d,O,N,g,h,j,Oa,Na+(Pa<<2)|0);c[ca>>2]=c[da>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];Bja(0,e,m,h,Ia);break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];ca=Cja(e,D,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<60){c[j+4>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 70:{Da=e;c[ka>>2]=c[Da>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];pja(ja,d,J,I,g,h,j,109144,109176|0);c[Da>>2]=c[ja>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function zja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(le[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ie[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Aja(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=bia(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function Bja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ie[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((le[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ie[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function Cja(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ie[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ie[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(le[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ie[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((le[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ie[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function Dja(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);if((f|0)==(c[27478]|0)){g=b;_oa(g);i=d;return}ac(c[e>>2]|0);g=b;_oa(g);i=d;return}function Eja(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);if((b|0)==(c[27478]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function Fja(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(xe[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function Gja(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);if((f|0)==(c[27478]|0)){g=b;_oa(g);i=d;return}ac(c[e>>2]|0);g=b;_oa(g);i=d;return}function Hja(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);if((b|0)==(c[27478]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function Ija(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;Jja(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=xe[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function Jja(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=Vna(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){Fka(110904)}else{c[e>>2]=d+(g<<2);i=j;return}}function Kja(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Lja(a){a=a|0;i=i;return}function Mja(a){a=a|0;i=i;return 127}function Nja(a){a=a|0;i=i;return 127}function Oja(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Pja(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Qja(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function Rja(a,b){a=a|0;b=b|0;b=i;Jea(a,1,45);i=b;return}function Sja(a){a=a|0;i=i;return 0}function Tja(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Uja(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Vja(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Wja(a){a=a|0;i=i;return}function Xja(a){a=a|0;i=i;return 127}function Yja(a){a=a|0;i=i;return 127}function Zja(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function _ja(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function $ja(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function aka(a,b){a=a|0;b=b|0;b=i;Jea(a,1,45);i=b;return}function bka(a){a=a|0;i=i;return 0}function cka(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function dka(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function eka(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function fka(a){a=a|0;i=i;return}function gka(a){a=a|0;i=i;return 2147483647}function hka(a){a=a|0;i=i;return 2147483647}function ika(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function jka(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function kka(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function lka(a,b){a=a|0;b=b|0;b=i;ofa(a,1,45);i=b;return}function mka(a){a=a|0;i=i;return 0}function nka(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function oka(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function pka(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function qka(a){a=a|0;i=i;return}function rka(a){a=a|0;i=i;return 2147483647}function ska(a){a=a|0;i=i;return 2147483647}function tka(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function uka(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function vka(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function wka(a,b){a=a|0;b=b|0;b=i;ofa(a,1,45);i=b;return}function xka(a){a=a|0;i=i;return 0}function yka(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function zka(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Aka(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Bka(a){a=a|0;i=i;return}function Cka(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=188;y=o+100|0;Jfa(r,h);o=r;z=c[o>>2]|0;if(!((c[27506]|0)==-1)){c[n>>2]=110024;c[n+4>>2]=186;c[n+8>>2]=0;yea(110024,n,187)}n=(c[110028>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Eka(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+32>>2]&63](E,109640,109650|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=Soa(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}dpa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[109640+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,109656,m|0)|0)!=1){t=Ec(8)|0;jea(t,109664);Td(t|0,107016,42)}if((F|0)==0){break}Toa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;dea(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&255](o);i=d;return}function Dka(a){a=a|0;i=i;return}function Eka(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Ika(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=188;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}W=c[h>>2]|0;ba=c[W+12>>2]|0;if((ba|0)==(c[W+16>>2]|0)){ca=(ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{ca=a[ba]|0}if(!(ca<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(ca<<24>>24<<1)>>1]&8192)==0){X=25;break a}ba=c[h>>2]|0;W=ba+12|0;da=c[W>>2]|0;if((da|0)==(c[ba+16>>2]|0)){ea=(ie[c[(c[ba>>2]|0)+40>>2]&127](ba)|0)&255}else{c[W>>2]=da+1;ea=a[da]|0}dfa(A,ea);X=26;break};case 3:{da=a[y]|0;W=(da&1)==0;if(W){fa=(da&255)>>>1}else{fa=c[G>>2]|0}ba=a[z]|0;ga=(ba&1)==0;if(ga){ha=(ba&255)>>>1}else{ha=c[g>>2]|0}if((fa|0)==(0-ha|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}if(W){oa=(da&255)>>>1}else{oa=c[G>>2]|0}do{if((oa|0)!=0){if(ga){pa=(ba&255)>>>1}else{pa=c[g>>2]|0}if((pa|0)==0){break}qa=c[h>>2]|0;ra=c[qa+12>>2]|0;sa=c[qa+16>>2]|0;if((ra|0)==(sa|0)){ta=(ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0)&255;ua=c[h>>2]|0;va=ta;wa=c[ua+16>>2]|0;xa=c[ua+12>>2]|0;ya=ua;za=a[y]|0}else{va=a[ra]|0;wa=sa;xa=ra;ya=qa;za=da}qa=ya+12|0;ra=(xa|0)==(wa|0);if(va<<24>>24==(a[(za&1)==0?F:c[H>>2]|0]|0)){if(ra){ie[c[(c[ya>>2]|0)+40>>2]&127](ya)|0}else{c[qa>>2]=xa+1}qa=a[y]|0;if((qa&1)==0){Aa=(qa&255)>>>1}else{Aa=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Aa>>>0>1?y:S;na=T;break b}if(ra){Ba=(ie[c[(c[ya>>2]|0)+36>>2]&127](ya)|0)&255}else{Ba=a[xa]|0}if(!(Ba<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}ra=c[h>>2]|0;qa=ra+12|0;sa=c[qa>>2]|0;if((sa|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[qa>>2]=sa+1}a[l]=1;sa=a[z]|0;if((sa&1)==0){Ca=(sa&255)>>>1}else{Ca=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ca>>>0>1?z:S;na=T;break b}}while(0);if(W){Da=(da&255)>>>1}else{Da=c[G>>2]|0}ga=c[h>>2]|0;sa=c[ga+12>>2]|0;qa=(sa|0)==(c[ga+16>>2]|0);if((Da|0)==0){if(qa){ra=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ea=ra;Fa=a[z]|0}else{Ea=a[sa]|0;Fa=ba}if(!(Ea<<24>>24==(a[(Fa&1)==0?m:c[E>>2]|0]|0))){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0}else{c[ua>>2]=ta+1}a[l]=1;ta=a[z]|0;if((ta&1)==0){Ga=(ta&255)>>>1}else{Ga=c[g>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ga>>>0>1?z:S;na=T;break b}if(qa){qa=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Ha=qa;Ia=a[y]|0}else{Ha=a[sa]|0;Ia=da}if(!(Ha<<24>>24==(a[(Ia&1)==0?F:c[H>>2]|0]|0))){a[l]=1;ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}sa=c[h>>2]|0;qa=sa+12|0;ga=c[qa>>2]|0;if((ga|0)==(c[sa+16>>2]|0)){ie[c[(c[sa>>2]|0)+40>>2]&127](sa)|0}else{c[qa>>2]=ga+1}ga=a[y]|0;if((ga&1)==0){Ja=(ga&255)>>>1}else{Ja=c[G>>2]|0}ia=D;ja=R;ka=r;la=Q;ma=Ja>>>0>1?y:S;na=T;break};case 0:{X=26;break};case 4:{ga=D;qa=R;sa=r;ta=Q;ua=0;ra=T;c:while(1){Ka=c[h>>2]|0;do{if((Ka|0)==0){La=0}else{if((c[Ka+12>>2]|0)!=(c[Ka+16>>2]|0)){La=Ka;break}if((ie[c[(c[Ka>>2]|0)+36>>2]&127](Ka)|0)==-1){c[h>>2]=0;La=0;break}else{La=c[h>>2]|0;break}}}while(0);Ka=(La|0)==0;Ma=c[e>>2]|0;do{if((Ma|0)==0){X=173}else{if((c[Ma+12>>2]|0)!=(c[Ma+16>>2]|0)){if(Ka){break}else{break c}}if((ie[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)==-1){c[e>>2]=0;X=173;break}else{if(Ka){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(Ka){break}}Ma=c[h>>2]|0;Na=c[Ma+12>>2]|0;if((Na|0)==(c[Ma+16>>2]|0)){Oa=(ie[c[(c[Ma>>2]|0)+36>>2]&127](Ma)|0)&255}else{Oa=a[Na]|0}do{if(Oa<<24>>24>-1){if((b[(c[f>>2]|0)+(Oa<<24>>24<<1)>>1]&2048)==0){X=189;break}Na=c[o>>2]|0;if((Na|0)==(ga|0)){Ma=(c[P>>2]|0)!=188;Pa=c[t>>2]|0;Qa=ga-Pa|0;Ra=Qa>>>0<2147483647?Qa<<1:-1;Sa=Voa(Ma?Pa:0,Ra)|0;if((Sa|0)==0){X=182;break a}do{if(Ma){c[t>>2]=Sa;Ta=Sa}else{Pa=c[t>>2]|0;c[t>>2]=Sa;if((Pa|0)==0){Ta=Sa;break}fe[c[P>>2]&255](Pa);Ta=c[t>>2]|0}}while(0);c[P>>2]=163;Sa=Ta+Qa|0;c[o>>2]=Sa;Ua=Sa;Va=(c[t>>2]|0)+Ra|0}else{Ua=Na;Va=ga}c[o>>2]=Ua+1;a[Ua]=Oa;Wa=Va;Xa=qa;Ya=sa;Za=ta;_a=ua+1|0;$a=ra}else{X=189}}while(0);if((X|0)==189){X=0;Ka=a[w]|0;if((Ka&1)==0){ab=(Ka&255)>>>1}else{ab=c[n>>2]|0}if((ab|0)==0|(ua|0)==0){break}if(!(Oa<<24>>24==(a[v]|0))){break}if((sa|0)==(ta|0)){Ka=sa-qa|0;Sa=Ka>>>0<2147483647?Ka<<1:-1;if((ra|0)==188){bb=0}else{bb=qa}Ma=Voa(bb,Sa)|0;if((Ma|0)==0){X=198;break a}cb=Ma;db=Ma+(Ka>>2<<2)|0;eb=Ma+(Sa>>>2<<2)|0;fb=163}else{cb=qa;db=sa;eb=ta;fb=ra}c[db>>2]=ua;Wa=ga;Xa=cb;Ya=db+4|0;Za=eb;_a=0;$a=fb}Sa=c[h>>2]|0;Ma=Sa+12|0;Ka=c[Ma>>2]|0;if((Ka|0)==(c[Sa+16>>2]|0)){ie[c[(c[Sa>>2]|0)+40>>2]&127](Sa)|0;ga=Wa;qa=Xa;sa=Ya;ta=Za;ua=_a;ra=$a;continue}else{c[Ma>>2]=Ka+1;ga=Wa;qa=Xa;sa=Ya;ta=Za;ua=_a;ra=$a;continue}}if((qa|0)==(sa|0)|(ua|0)==0){gb=qa;hb=sa;ib=ta;jb=ra}else{if((sa|0)==(ta|0)){da=sa-qa|0;ba=da>>>0<2147483647?da<<1:-1;if((ra|0)==188){kb=0}else{kb=qa}W=Voa(kb,ba)|0;if((W|0)==0){X=209;break a}lb=W;mb=W+(da>>2<<2)|0;nb=W+(ba>>>2<<2)|0;ob=163}else{lb=qa;mb=sa;nb=ta;ob=ra}c[mb>>2]=ua;gb=lb;hb=mb+4|0;ib=nb;jb=ob}if((c[B>>2]|0)>0){ba=c[h>>2]|0;do{if((ba|0)==0){pb=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){pb=ba;break}if((ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;pb=0;break}else{pb=c[h>>2]|0;break}}}while(0);ba=(pb|0)==0;ua=c[e>>2]|0;do{if((ua|0)==0){X=223}else{if((c[ua+12>>2]|0)!=(c[ua+16>>2]|0)){if(ba){qb=ua;break}else{X=229;break a}}if((ie[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)==-1){c[e>>2]=0;X=223;break}else{if(ba){qb=ua;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ba){X=229;break a}else{qb=0}}ua=c[h>>2]|0;ra=c[ua+12>>2]|0;if((ra|0)==(c[ua+16>>2]|0)){rb=(ie[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)&255}else{rb=a[ra]|0}if(!(rb<<24>>24==(a[u]|0))){X=229;break a}ra=c[h>>2]|0;ua=ra+12|0;ta=c[ua>>2]|0;if((ta|0)==(c[ra+16>>2]|0)){ie[c[(c[ra>>2]|0)+40>>2]&127](ra)|0;sb=qb;tb=qb;ub=ga}else{c[ua>>2]=ta+1;sb=qb;tb=qb;ub=ga}while(1){ta=c[h>>2]|0;do{if((ta|0)==0){vb=0}else{if((c[ta+12>>2]|0)!=(c[ta+16>>2]|0)){vb=ta;break}if((ie[c[(c[ta>>2]|0)+36>>2]&127](ta)|0)==-1){c[h>>2]=0;vb=0;break}else{vb=c[h>>2]|0;break}}}while(0);ta=(vb|0)==0;do{if((tb|0)==0){wb=sb;X=243}else{if((c[tb+12>>2]|0)!=(c[tb+16>>2]|0)){if(ta){xb=sb;yb=tb;break}else{X=250;break a}}if((ie[c[(c[tb>>2]|0)+36>>2]&127](tb)|0)==-1){c[e>>2]=0;wb=0;X=243;break}else{if(ta^(sb|0)==0){xb=sb;yb=sb;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(ta){X=250;break a}else{xb=wb;yb=0}}ua=c[h>>2]|0;ra=c[ua+12>>2]|0;if((ra|0)==(c[ua+16>>2]|0)){zb=(ie[c[(c[ua>>2]|0)+36>>2]&127](ua)|0)&255}else{zb=a[ra]|0}if(!(zb<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(zb<<24>>24<<1)>>1]&2048)==0){X=250;break a}ra=c[o>>2]|0;if((ra|0)==(ub|0)){ua=(c[P>>2]|0)!=188;sa=c[t>>2]|0;qa=ub-sa|0;W=qa>>>0<2147483647?qa<<1:-1;da=Voa(ua?sa:0,W)|0;if((da|0)==0){X=253;break a}do{if(ua){c[t>>2]=da;Ab=da}else{sa=c[t>>2]|0;c[t>>2]=da;if((sa|0)==0){Ab=da;break}fe[c[P>>2]&255](sa);Ab=c[t>>2]|0}}while(0);c[P>>2]=163;da=Ab+qa|0;c[o>>2]=da;Bb=da;Cb=(c[t>>2]|0)+W|0}else{Bb=ra;Cb=ub}da=c[h>>2]|0;ua=c[da+12>>2]|0;if((ua|0)==(c[da+16>>2]|0)){ta=(ie[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255;Db=ta;Eb=c[o>>2]|0}else{Db=a[ua]|0;Eb=Bb}c[o>>2]=Eb+1;a[Eb]=Db;ua=(c[B>>2]|0)+ -1|0;c[B>>2]=ua;ta=c[h>>2]|0;da=ta+12|0;sa=c[da>>2]|0;if((sa|0)==(c[ta+16>>2]|0)){ie[c[(c[ta>>2]|0)+40>>2]&127](ta)|0}else{c[da>>2]=sa+1}if((ua|0)>0){sb=xb;tb=yb;ub=Cb}else{Fb=Cb;break}}}else{Fb=ga}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{ia=Fb;ja=gb;ka=hb;la=ib;ma=S;na=jb}break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Gb=(a[O]|0)!=0}else{Gb=0}if(!(I|Gb)){ia=D;ja=R;ka=r;la=Q;ma=0;na=T;break b}}ba=a[x]|0;ua=(ba&1)==0;sa=ua?j:c[J>>2]|0;d:do{if((p|0)==0){Hb=Y;Ib=Y;Jb=ba;Kb=sa}else{if((d[s+(p+ -1)|0]|0)>=2){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break}da=sa+(ua?(ba&255)>>>1:c[K>>2]|0)|0;ta=sa;while(1){if((ta|0)==(da|0)){Lb=da;break}Ka=a[ta]|0;if(!(Ka<<24>>24>-1)){Lb=ta;break}if((b[(c[f>>2]|0)+(Ka<<24>>24<<1)>>1]&8192)==0){Lb=ta;break}else{ta=ta+1|0}}ta=Lb-sa|0;da=a[A]|0;ra=(da&1)==0;if(ra){Mb=(da&255)>>>1}else{Mb=c[N>>2]|0}if(ta>>>0>Mb>>>0){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break}if(ra){ra=(da&255)>>>1;Nb=A+1+(ra-ta)|0;Ob=L;Pb=ra}else{ra=c[M>>2]|0;da=c[N>>2]|0;Nb=ra+(da-ta)|0;Ob=ra;Pb=da}da=Ob+Pb|0;if((Nb|0)==(da|0)){Hb=Y;Ib=Y;Jb=ba;Kb=Lb;break}else{Qb=sa;Rb=Nb}while(1){if((a[Rb]|0)!=(a[Qb]|0)){Hb=Y;Ib=Y;Jb=ba;Kb=sa;break d}ra=Rb+1|0;if((ra|0)==(da|0)){Hb=Y;Ib=Y;Jb=ba;Kb=Lb;break}else{Qb=Qb+1|0;Rb=ra}}}}while(0);e:while(1){if((Jb&1)==0){Sb=j;Tb=(Jb&255)>>>1}else{Sb=c[J>>2]|0;Tb=c[K>>2]|0}if((Kb|0)==(Sb+Tb|0)){break}ba=c[h>>2]|0;do{if((ba|0)==0){Ub=0}else{if((c[ba+12>>2]|0)!=(c[ba+16>>2]|0)){Ub=ba;break}if((ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)==-1){c[h>>2]=0;Ub=0;break}else{Ub=c[h>>2]|0;break}}}while(0);ba=(Ub|0)==0;do{if((Ib|0)==0){Vb=Hb;X=147}else{if((c[Ib+12>>2]|0)!=(c[Ib+16>>2]|0)){if(ba){Wb=Hb;Xb=Ib;break}else{break e}}if((ie[c[(c[Ib>>2]|0)+36>>2]&127](Ib)|0)==-1){c[e>>2]=0;Vb=0;X=147;break}else{if(ba^(Hb|0)==0){Wb=Hb;Xb=Hb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ba){break}else{Wb=Vb;Xb=0}}sa=c[h>>2]|0;ua=c[sa+12>>2]|0;if((ua|0)==(c[sa+16>>2]|0)){Yb=(ie[c[(c[sa>>2]|0)+36>>2]&127](sa)|0)&255}else{Yb=a[ua]|0}if(!(Yb<<24>>24==(a[Kb]|0))){break}ua=c[h>>2]|0;sa=ua+12|0;ga=c[sa>>2]|0;if((ga|0)==(c[ua+16>>2]|0)){ie[c[(c[ua>>2]|0)+40>>2]&127](ua)|0}else{c[sa>>2]=ga+1}Hb=Wb;Ib=Xb;Jb=a[x]|0;Kb=Kb+1|0}if(!I){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break b}ga=a[x]|0;if((ga&1)==0){Zb=j;_b=(ga&255)>>>1}else{Zb=c[J>>2]|0;_b=c[K>>2]|0}if((Kb|0)==(Zb+_b|0)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T}else{X=162;break a}break};default:{ia=D;ja=R;ka=r;la=Q;ma=S;na=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}if((ie[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}else{dc=cc;ec=0}}ba=c[h>>2]|0;ga=c[ba+12>>2]|0;if((ga|0)==(c[ba+16>>2]|0)){fc=(ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0)&255}else{fc=a[ga]|0}if(!(fc<<24>>24>-1)){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){ia=D;ja=R;ka=r;la=Q;ma=S;na=T;break f}ga=c[h>>2]|0;ba=ga+12|0;sa=c[ba>>2]|0;if((sa|0)==(c[ga+16>>2]|0)){gc=(ie[c[(c[ga>>2]|0)+40>>2]&127](ga)|0)&255}else{c[ba>>2]=sa+1;gc=a[sa]|0}dfa(A,gc);$b=dc;ac=ec}}}while(0);sa=p+1|0;if(sa>>>0<4){Q=la;r=ka;R=ja;D=ia;p=sa;S=ma;T=na}else{Z=ja;_=ka;$=ma;aa=na;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){dpa()}else if((X|0)==198){dpa()}else if((X|0)==209){dpa()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==253){dpa()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=gb;jc=jb}else if((X|0)==269){h:do{if(($|0)!=0){na=$+1|0;ma=$+8|0;ka=$+4|0;ja=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[ka>>2]|0}if(!(ja>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((ie[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=na}else{nc=c[ma>>2]|0}if(!(mc<<24>>24==(a[nc+ja|0]|0))){break}p=ja+1|0;U=c[h>>2]|0;ia=U+12|0;D=c[ia>>2]|0;if((D|0)==(c[U+16>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;ja=p;continue}else{c[ia>>2]=D+1;ja=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;Jka(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);Nea(A);Nea(z);Nea(y);Nea(x);Nea(w);if((ic|0)==0){i=q;return hc|0}fe[jc&255](ic);i=q;return hc|0}function Fka(a){a=a|0;var b=0;b=Ec(8)|0;jea(b,a);Td(b|0,107016,42)}function Gka(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=188;v=n+100|0;Jfa(q,h);n=q;w=c[n>>2]|0;if(!((c[27506]|0)==-1)){c[m>>2]=110024;c[m+4>>2]=186;c[m+8>>2]=0;yea(110024,m,187)}m=(c[110028>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;xoa(z);A=125584;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;xoa(z);A=125584;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Eka(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){dfa(k,xe[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Hka(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ie[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;dea(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&255](n);i=d;return}function Hka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){gfa(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function Ika(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[27366]|0)==-1)){c[p>>2]=109464;c[p+4>>2]=186;c[p+8>>2]=0;yea(109464,p,187)}p=(c[109468>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Zea(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Nea(r);ge[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Zea(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Nea(s);a[f]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Zea(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Nea(t);ge[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Zea(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Nea(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[27350]|0)==-1)){c[o>>2]=109400;c[o+4>>2]=186;c[o+8>>2]=0;yea(109400,o,187)}o=(c[109404>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Zea(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Nea(w);ge[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Zea(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Nea(x);a[f]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Zea(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Nea(y);ge[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Zea(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Nea(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Jka(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function Kka(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Lka(a){a=a|0;i=i;return}function Mka(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=188;y=o+400|0;Jfa(r,h);o=r;z=c[o>>2]|0;if(!((c[27504]|0)==-1)){c[n>>2]=110016;c[n+4>>2]=186;c[n+8>>2]=0;yea(110016,n,187)}n=(c[110020>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=Nka(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+48>>2]&63](E,109720,109730|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=Soa((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}dpa()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[109720+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,109656,m|0)|0)!=1){t=Ec(8)|0;jea(t,109664);Td(t|0,107016,42)}if((F|0)==0){break}Toa(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ie[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];dea(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&255](o);i=d;return}function Nka(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Qka(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=188;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=ie[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){ie[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 3:{P=a[y]|0;R=(P&1)==0;if(R){Ka=(P&255)>>>1}else{Ka=c[D>>2]|0}na=a[z]|0;oa=(na&1)==0;if(oa){La=(na&255)>>>1}else{La=c[e>>2]|0}if((Ka|0)==(0-La|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(R){Ma=(P&255)>>>1}else{Ma=c[D>>2]|0}do{if((Ma|0)!=0){if(oa){Na=(na&255)>>>1}else{Na=c[e>>2]|0}if((Na|0)==0){break}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){wa=ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0;Oa=wa;Pa=a[y]|0}else{Oa=c[qa>>2]|0;Pa=P}qa=c[g>>2]|0;wa=qa+12|0;pa=c[wa>>2]|0;va=(pa|0)==(c[qa+16>>2]|0);if((Oa|0)==(c[((Pa&1)==0?D:c[E>>2]|0)>>2]|0)){if(va){ie[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[wa>>2]=pa+4}wa=a[y]|0;if((wa&1)==0){Qa=(wa&255)>>>1}else{Qa=c[D>>2]|0}$=M;aa=r;ba=L;ca=Qa>>>0>1?y:N;da=O;break b}if(va){Ra=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Ra=c[pa>>2]|0}if((Ra|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}pa=c[g>>2]|0;qa=pa+12|0;va=c[qa>>2]|0;if((va|0)==(c[pa+16>>2]|0)){ie[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[qa>>2]=va+4}a[k]=1;va=a[z]|0;if((va&1)==0){Sa=(va&255)>>>1}else{Sa=c[e>>2]|0}$=M;aa=r;ba=L;ca=Sa>>>0>1?z:N;da=O;break b}}while(0);if(R){Ta=(P&255)>>>1}else{Ta=c[D>>2]|0}oa=c[g>>2]|0;va=c[oa+12>>2]|0;qa=(va|0)==(c[oa+16>>2]|0);if((Ta|0)==0){if(qa){pa=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Ua=pa;Va=a[z]|0}else{Ua=c[va>>2]|0;Va=na}if((Ua|0)!=(c[((Va&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}pa=c[g>>2]|0;wa=pa+12|0;Wa=c[wa>>2]|0;if((Wa|0)==(c[pa+16>>2]|0)){ie[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[wa>>2]=Wa+4}a[k]=1;Wa=a[z]|0;if((Wa&1)==0){Xa=(Wa&255)>>>1}else{Xa=c[e>>2]|0}$=M;aa=r;ba=L;ca=Xa>>>0>1?z:N;da=O;break b}if(qa){qa=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Ya=qa;Za=a[y]|0}else{Ya=c[va>>2]|0;Za=P}if((Ya|0)!=(c[((Za&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}va=c[g>>2]|0;qa=va+12|0;oa=c[qa>>2]|0;if((oa|0)==(c[va+16>>2]|0)){ie[c[(c[va>>2]|0)+40>>2]&127](va)|0}else{c[qa>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){_a=(oa&255)>>>1}else{_a=c[D>>2]|0}$=M;aa=r;ba=L;ca=_a>>>0>1?y:N;da=O;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}oa=c[g>>2]|0;qa=c[oa+12>>2]|0;if((qa|0)==(c[oa+16>>2]|0)){$a=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{$a=c[qa>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,$a)|0)){T=27;break a}qa=c[g>>2]|0;oa=qa+12|0;va=c[oa>>2]|0;if((va|0)==(c[qa+16>>2]|0)){ab=ie[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=va+4;ab=c[va>>2]|0}tfa(A,ab);T=28;break};case 4:{va=M;oa=r;qa=L;Wa=0;wa=O;f:while(1){pa=c[g>>2]|0;do{if((pa|0)==0){bb=1}else{cb=c[pa+12>>2]|0;if((cb|0)==(c[pa+16>>2]|0)){db=ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{db=c[cb>>2]|0}if((db|0)==-1){c[g>>2]=0;bb=1;break}else{bb=(c[g>>2]|0)==0;break}}}while(0);pa=c[b>>2]|0;do{if((pa|0)==0){T=188}else{cb=c[pa+12>>2]|0;if((cb|0)==(c[pa+16>>2]|0)){eb=ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{eb=c[cb>>2]|0}if((eb|0)==-1){c[b>>2]=0;T=188;break}else{if(bb){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(bb){break}}pa=c[g>>2]|0;cb=c[pa+12>>2]|0;if((cb|0)==(c[pa+16>>2]|0)){fb=ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{fb=c[cb>>2]|0}if(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,fb)|0){cb=c[n>>2]|0;if((cb|0)==(c[q>>2]|0)){Rka(m,n,q);gb=c[n>>2]|0}else{gb=cb}c[n>>2]=gb+4;c[gb>>2]=fb;hb=va;ib=oa;jb=qa;kb=Wa+1|0;lb=wa}else{cb=a[w]|0;if((cb&1)==0){mb=(cb&255)>>>1}else{mb=c[K>>2]|0}if((mb|0)==0|(Wa|0)==0){break}if((fb|0)!=(c[v>>2]|0)){break}if((oa|0)==(qa|0)){cb=oa-va|0;pa=cb>>>0<2147483647?cb<<1:-1;if((wa|0)!=188){nb=va}else{nb=0}ob=Voa(nb,pa)|0;if((ob|0)==0){T=206;break a}pb=ob;qb=ob+(cb>>2<<2)|0;rb=ob+(pa>>>2<<2)|0;sb=163}else{pb=va;qb=oa;rb=qa;sb=wa}c[qb>>2]=Wa;hb=pb;ib=qb+4|0;jb=rb;kb=0;lb=sb}pa=c[g>>2]|0;ob=pa+12|0;cb=c[ob>>2]|0;if((cb|0)==(c[pa+16>>2]|0)){ie[c[(c[pa>>2]|0)+40>>2]&127](pa)|0;va=hb;oa=ib;qa=jb;Wa=kb;wa=lb;continue}else{c[ob>>2]=cb+4;va=hb;oa=ib;qa=jb;Wa=kb;wa=lb;continue}}if((va|0)==(oa|0)|(Wa|0)==0){tb=va;ub=oa;vb=qa;wb=wa}else{if((oa|0)==(qa|0)){P=oa-va|0;na=P>>>0<2147483647?P<<1:-1;if((wa|0)!=188){xb=va}else{xb=0}R=Voa(xb,na)|0;if((R|0)==0){T=217;break a}yb=R;zb=R+(P>>2<<2)|0;Ab=R+(na>>>2<<2)|0;Bb=163}else{yb=va;zb=oa;Ab=qa;Bb=wa}c[zb>>2]=Wa;tb=yb;ub=zb+4|0;vb=Ab;wb=Bb}na=c[B>>2]|0;if((na|0)>0){R=c[g>>2]|0;do{if((R|0)==0){Cb=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Db=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Db=c[P>>2]|0}if((Db|0)==-1){c[g>>2]=0;Cb=1;break}else{Cb=(c[g>>2]|0)==0;break}}}while(0);R=c[b>>2]|0;do{if((R|0)==0){T=234}else{Wa=c[R+12>>2]|0;if((Wa|0)==(c[R+16>>2]|0)){Eb=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Eb=c[Wa>>2]|0}if((Eb|0)==-1){c[b>>2]=0;T=234;break}else{if(Cb){Fb=R;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(Cb){T=240;break a}else{Fb=0}}R=c[g>>2]|0;Wa=c[R+12>>2]|0;if((Wa|0)==(c[R+16>>2]|0)){Gb=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Gb=c[Wa>>2]|0}if((Gb|0)!=(c[u>>2]|0)){T=240;break a}Wa=c[g>>2]|0;R=Wa+12|0;wa=c[R>>2]|0;if((wa|0)==(c[Wa+16>>2]|0)){ie[c[(c[Wa>>2]|0)+40>>2]&127](Wa)|0;Hb=Fb;Ib=na;Jb=Fb}else{c[R>>2]=wa+4;Hb=Fb;Ib=na;Jb=Fb}while(1){wa=c[g>>2]|0;do{if((wa|0)==0){Kb=1}else{R=c[wa+12>>2]|0;if((R|0)==(c[wa+16>>2]|0)){Lb=ie[c[(c[wa>>2]|0)+36>>2]&127](wa)|0}else{Lb=c[R>>2]|0}if((Lb|0)==-1){c[g>>2]=0;Kb=1;break}else{Kb=(c[g>>2]|0)==0;break}}}while(0);do{if((Jb|0)==0){Mb=Hb;T=257}else{wa=c[Jb+12>>2]|0;if((wa|0)==(c[Jb+16>>2]|0)){Nb=ie[c[(c[Jb>>2]|0)+36>>2]&127](Jb)|0}else{Nb=c[wa>>2]|0}if((Nb|0)==-1){c[b>>2]=0;Mb=0;T=257;break}else{if(Kb^(Hb|0)==0){Ob=Hb;Pb=Hb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(Kb){T=263;break a}else{Ob=Mb;Pb=0}}wa=c[g>>2]|0;R=c[wa+12>>2]|0;if((R|0)==(c[wa+16>>2]|0)){Qb=ie[c[(c[wa>>2]|0)+36>>2]&127](wa)|0}else{Qb=c[R>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,Qb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){Rka(m,n,q)}R=c[g>>2]|0;wa=c[R+12>>2]|0;if((wa|0)==(c[R+16>>2]|0)){Rb=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Rb=c[wa>>2]|0}wa=c[n>>2]|0;c[n>>2]=wa+4;c[wa>>2]=Rb;wa=Ib+ -1|0;c[B>>2]=wa;R=c[g>>2]|0;Wa=R+12|0;qa=c[Wa>>2]|0;if((qa|0)==(c[R+16>>2]|0)){ie[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[Wa>>2]=qa+4}if((wa|0)>0){Hb=Ob;Ib=wa;Jb=Pb}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=tb;aa=ub;ba=vb;ca=N;da=wb}break};case 0:{T=28;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Sb=V;Tb=V}while(1){na=c[g>>2]|0;do{if((na|0)==0){Ub=1}else{wa=c[na+12>>2]|0;if((wa|0)==(c[na+16>>2]|0)){Vb=ie[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{Vb=c[wa>>2]|0}if((Vb|0)==-1){c[g>>2]=0;Ub=1;break}else{Ub=(c[g>>2]|0)==0;break}}}while(0);do{if((Tb|0)==0){Wb=Sb;T=42}else{na=c[Tb+12>>2]|0;if((na|0)==(c[Tb+16>>2]|0)){Xb=ie[c[(c[Tb>>2]|0)+36>>2]&127](Tb)|0}else{Xb=c[na>>2]|0}if((Xb|0)==-1){c[b>>2]=0;Wb=0;T=42;break}else{if(Ub^(Sb|0)==0){Yb=Sb;Zb=Sb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Ub){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Yb=Wb;Zb=0}}na=c[g>>2]|0;wa=c[na+12>>2]|0;if((wa|0)==(c[na+16>>2]|0)){_b=ie[c[(c[na>>2]|0)+36>>2]&127](na)|0}else{_b=c[wa>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,_b)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}wa=c[g>>2]|0;na=wa+12|0;qa=c[na>>2]|0;if((qa|0)==(c[wa+16>>2]|0)){$b=ie[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[na>>2]=qa+4;$b=c[qa>>2]|0}tfa(A,$b);Sb=Yb;Tb=Zb}}}while(0);qa=o+1|0;if(qa>>>0<4){L=ba;r=aa;M=$;o=qa;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;ac=0;bc=M;cc=O}else if((T|0)==206){dpa()}else if((T|0)==217){dpa()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;ac=0;bc=tb;cc=wb}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){dc=($&255)>>>1}else{dc=c[da>>2]|0}if(!(aa>>>0<dc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){ec=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((fc|0)==-1){c[g>>2]=0;ec=1;break}else{ec=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){gc=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{gc=c[N>>2]|0}if((gc|0)==-1){c[b>>2]=0;T=295;break}else{if(ec){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(ec){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){hc=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{hc=c[N>>2]|0}if((a[Y]&1)==0){ic=da}else{ic=c[ca>>2]|0}if((hc|0)!=(c[ic+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){ie[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z;break h}}while(0);if((W|0)==(X|0)){ac=1;bc=X;cc=Z;break}c[C>>2]=0;Jka(w,W,X,C);if((c[C>>2]|0)==0){ac=1;bc=W;cc=Z;break}c[j>>2]=c[j>>2]|4;ac=0;bc=W;cc=Z}}while(0);pfa(A);pfa(z);pfa(y);pfa(x);Nea(w);if((bc|0)==0){i=p;return ac|0}fe[cc&255](bc);i=p;return ac|0}function Oka(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=188;v=n+400|0;Jfa(q,h);n=q;w=c[n>>2]|0;if(!((c[27504]|0)==-1)){c[m>>2]=110016;c[m+4>>2]=186;c[m+8>>2]=0;yea(110016,m,187)}m=(c[110020>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;xoa(z);A=125584;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;xoa(z);A=125584;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=Nka(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){tfa(k,xe[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Pka(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ie[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];dea(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&255](n);i=d;return}function Pka(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){vfa(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function Qka(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[27398]|0)==-1)){c[p>>2]=109592;c[p+4>>2]=186;c[p+8>>2]=0;yea(109592,p,187)}p=(c[109596>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;xoa(C);D=125584;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&127](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&127](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}sfa(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;pfa(r);ge[c[(c[b>>2]|0)+28>>2]&127](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}sfa(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;pfa(s);c[f>>2]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&127](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Zea(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;Nea(t);ge[c[(c[b>>2]|0)+24>>2]&127](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}sfa(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;pfa(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[27382]|0)==-1)){c[o>>2]=109528;c[o+4>>2]=186;c[o+8>>2]=0;yea(109528,o,187)}o=(c[109532>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;xoa(H);I=125584;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&127](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&127](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}sfa(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;pfa(w);ge[c[(c[E>>2]|0)+28>>2]&127](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}sfa(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;pfa(x);c[f>>2]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&127](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}Zea(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;Nea(y);ge[c[(c[E>>2]|0)+24>>2]&127](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}sfa(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;pfa(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function Rka(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=188;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=Voa(m,l)|0;m=a;if((a|0)==0){dpa()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}fe[c[f>>2]&255](a);n=c[h>>2]|0}}while(0);c[f>>2]=163;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function Ska(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Tka(a){a=a|0;i=i;return}function Uka(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,109776,o|0)|0;do{if(s>>>0>99){do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);o=c[27478]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Mia(r,o,109776,n)|0;o=c[r>>2]|0;if((o|0)==0){dpa()}H=Soa(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}dpa()}else{I=0;J=0;K=q;L=s}}while(0);Jfa(t,g);s=t;q=c[s>>2]|0;if(!((c[27506]|0)==-1)){c[p>>2]=110024;c[p+4>>2]=186;c[p+8>>2]=0;yea(110024,p,187)}p=(c[110028>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;xoa(N);O=125584;P=127;Td(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;xoa(N);O=125584;P=127;Td(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;He[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Vka(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=Soa(V)|0;if((T|0)!=0){W=T;X=T;break}dpa()}else{W=0;X=t}}while(0);Wka(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];kba(b,m,X,e,D,g,j);if((W|0)!=0){Toa(W)}Nea(A);Nea(z);Nea(y);dea(c[s>>2]|0)|0;if((J|0)!=0){Toa(J)}if((I|0)==0){i=d;return}Toa(I);i=d;return}function Vka(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[27366]|0)==-1)){c[p>>2]=109464;c[p+4>>2]=186;c[p+8>>2]=0;yea(109464,p,187)}p=(c[109468>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;xoa(I);J=125584;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;xoa(I);J=125584;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Zea(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;Nea(s)}else{ge[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Zea(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Nea(v)}a[g]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Zea(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Nea(w);ge[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Zea(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Nea(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[27350]|0)==-1)){c[o>>2]=109400;c[o+4>>2]=186;c[o+8>>2]=0;yea(109400,o,187)}o=(c[109404>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;xoa(N);O=125584;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;xoa(N);O=125584;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Zea(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;Nea(A)}else{ge[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}Zea(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;Nea(D)}a[g]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Zea(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Nea(E);ge[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}Zea(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;Nea(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function Wka(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 1:{c[e>>2]=c[f>>2];I=xe[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;K=H;break};case 0:{c[e>>2]=c[f>>2];K=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){L=(I&255)>>>1}else{L=c[A>>2]|0}if((L|0)==0|x){K=H;break a}if(J){M=y;N=(I&255)>>>1}else{M=c[z>>2]|0;N=c[A>>2]|0}I=M+N|0;J=c[f>>2]|0;if((M|0)==(I|0)){O=J}else{P=J;J=M;while(1){a[P]=a[J]|0;Q=J+1|0;R=P+1|0;if((Q|0)==(I|0)){O=R;break}else{J=Q;P=R}}}c[f>>2]=O;K=H;break};case 4:{P=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){I=J;while(1){R=a[I]|0;if(!(R<<24>>24>-1)){S=I;break b}Q=I+1|0;if((b[(c[F>>2]|0)+(R<<24>>24<<1)>>1]&2048)==0){S=I;break b}if(Q>>>0<j>>>0){I=Q}else{S=Q;break}}}else{S=J}}while(0);I=S;if(B){if(S>>>0>J>>>0){Q=J+(0-I)|0;I=Q>>>0<G>>>0?G:Q;Q=I+s|0;R=P;T=S;U=s;while(1){V=T+ -1|0;W=a[V]|0;c[f>>2]=R+1;a[R]=W;W=U+ -1|0;X=(W|0)>0;if(!(V>>>0>J>>>0&X)){break}R=c[f>>2]|0;U=W;T=V}T=S+I|0;if(X){Y=T;Z=Q;_=32}else{$=0;aa=T;ba=Q}}else{Y=S;Z=s;_=32}if((_|0)==32){_=0;$=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;aa=Y;ba=Z}T=c[f>>2]|0;c[f>>2]=T+1;if((ba|0)>0){U=T;R=ba;while(1){a[U]=$;V=R+ -1|0;W=c[f>>2]|0;c[f>>2]=W+1;if((V|0)>0){R=V;U=W}else{ca=W;break}}}else{ca=T}a[ca]=n;da=aa}else{da=S}if((da|0)==(J|0)){U=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;R=c[f>>2]|0;c[f>>2]=R+1;a[R]=U}else{U=a[p]|0;R=(U&1)==0;if(R){ea=(U&255)>>>1}else{ea=c[E>>2]|0}if((ea|0)==0){fa=da;ga=-1;ha=0;ia=0}else{if(R){ja=C}else{ja=c[D>>2]|0}fa=da;ga=a[ja]|0;ha=0;ia=0}while(1){do{if((ia|0)==(ga|0)){R=c[f>>2]|0;c[f>>2]=R+1;a[R]=o;R=ha+1|0;U=a[p]|0;Q=(U&1)==0;if(Q){ka=(U&255)>>>1}else{ka=c[E>>2]|0}if(!(R>>>0<ka>>>0)){la=ga;ma=R;na=0;break}if(Q){oa=C}else{oa=c[D>>2]|0}if((a[oa+R|0]|0)==127){la=-1;ma=R;na=0;break}if(Q){pa=C}else{pa=c[D>>2]|0}la=a[pa+R|0]|0;ma=R;na=0}else{la=ga;ma=ha;na=ia}}while(0);R=fa+ -1|0;Q=a[R]|0;U=c[f>>2]|0;c[f>>2]=U+1;a[U]=Q;if((R|0)==(J|0)){break}else{fa=R;ga=la;ha=ma;ia=na+1|0}}}T=c[f>>2]|0;if((P|0)==(T|0)){K=J;break a}R=T+ -1|0;if(R>>>0>P>>>0){qa=P;ra=R}else{K=J;break a}while(1){R=a[qa]|0;a[qa]=a[ra]|0;a[ra]=R;R=qa+1|0;T=ra+ -1|0;if(R>>>0<T>>>0){ra=T;qa=R}else{K=J;break}}break};case 3:{J=a[r]|0;P=(J&1)==0;if(P){sa=(J&255)>>>1}else{sa=c[w>>2]|0}if((sa|0)==0){K=H;break a}if(P){ta=u}else{ta=c[v>>2]|0}P=a[ta]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=P;K=H;break};default:{K=H}}}while(0);P=h+1|0;if(P>>>0<4){H=K;h=P}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function Xka(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Jfa(m,g);z=m;A=c[z>>2]|0;if(!((c[27506]|0)==-1)){c[l>>2]=110024;c[l+4>>2]=186;c[l+8>>2]=0;yea(110024,l,187)}l=(c[110028>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(xe[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;Vka(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Soa(P)|0;if((N|0)!=0){Q=N;R=N;break}dpa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}Wka(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];kba(b,k,R,e,w,g,h);if((Q|0)==0){Nea(t);Nea(s);Nea(r);U=c[z>>2]|0;V=U;W=V;X=dea(W)|0;i=d;return}Toa(Q);Nea(t);Nea(s);Nea(r);U=c[z>>2]|0;V=U;W=V;X=dea(W)|0;i=d;return}function Yka(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Zka(a){a=a|0;i=i;return}function _ka(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,109776,o|0)|0;do{if(s>>>0>99){do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);o=c[27478]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=Mia(r,o,109776,n)|0;o=c[r>>2]|0;if((o|0)==0){dpa()}H=Soa(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}dpa()}else{J=0;K=0;L=q;M=s}}while(0);Jfa(t,g);s=t;q=c[s>>2]|0;if(!((c[27504]|0)==-1)){c[p>>2]=110016;c[p+4>>2]=186;c[p+8>>2]=0;yea(110016,p,187)}p=(c[110020>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;xoa(O);P=125584;Q=127;Td(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;xoa(O);P=125584;Q=127;Td(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;He[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;$ka(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=Soa(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}dpa()}else{X=0;Y=t}}while(0);ala(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];Via(b,m,Y,e,D,g,j);if((X|0)!=0){Toa(X)}pfa(A);pfa(z);Nea(y);dea(c[s>>2]|0)|0;if((K|0)!=0){Toa(K)}if((J|0)==0){i=d;return}Toa(J);i=d;return}function $ka(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[27398]|0)==-1)){c[p>>2]=109592;c[p+4>>2]=186;c[p+8>>2]=0;yea(109592,p,187)}p=(c[109596>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;xoa(I);J=125584;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;xoa(I);J=125584;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&127](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&127](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}sfa(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;pfa(s)}else{ge[c[J+40>>2]&127](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&127](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}sfa(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;pfa(v)}c[g>>2]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&127](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Zea(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;Nea(w);ge[c[(c[e>>2]|0)+24>>2]&127](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}sfa(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;pfa(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[27382]|0)==-1)){c[o>>2]=109528;c[o+4>>2]=186;c[o+8>>2]=0;yea(109528,o,187)}o=(c[109532>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;xoa(N);O=125584;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;xoa(N);O=125584;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&127](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&127](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}sfa(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;pfa(A)}else{ge[c[O+40>>2]&127](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&127](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}sfa(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;pfa(D)}c[g>>2]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&127](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}Zea(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;Nea(E);ge[c[(c[G>>2]|0)+24>>2]&127](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}sfa(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;pfa(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function ala(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 1:{c[d>>2]=c[e>>2];D=xe[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 3:{D=a[q]|0;E=(D&1)==0;if(E){G=(D&255)>>>1}else{G=c[t>>2]|0}if((G|0)==0){F=C;break a}if(E){H=t}else{H=c[u>>2]|0}E=c[H>>2]|0;D=c[e>>2]|0;c[e>>2]=D+4;c[D>>2]=E;F=C;break};case 2:{E=a[p]|0;D=(E&1)==0;if(D){I=(E&255)>>>1}else{I=c[w>>2]|0}if((I|0)==0|v){F=C;break a}if(D){J=w;K=(E&255)>>>1}else{J=c[x>>2]|0;K=c[w>>2]|0}E=J+(K<<2)|0;D=c[e>>2]|0;if((J|0)==(E|0)){L=D}else{M=(J+(K+ -1<<2)+(0-J)|0)>>>2;N=D;O=J;while(1){c[N>>2]=c[O>>2];P=O+4|0;if((P|0)==(E|0)){break}N=N+4|0;O=P}L=D+(M+1<<2)|0}c[e>>2]=L;F=C;break};case 4:{O=c[e>>2]|0;N=k?C+4|0:C;b:do{if(N>>>0<h>>>0){E=N;while(1){P=E+4|0;if(!(le[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[E>>2]|0)|0)){Q=E;break b}if(P>>>0<h>>>0){E=P}else{Q=P;break}}}else{Q=N}}while(0);if(y){do{if(Q>>>0>N>>>0){M=c[e>>2]|0;D=Q;E=r;while(1){R=D+ -4|0;S=M+4|0;c[M>>2]=c[R>>2];T=E+ -1|0;U=(T|0)>0;if(R>>>0>N>>>0&U){E=T;D=R;M=S}else{break}}c[e>>2]=S;if(U){V=R;W=T;X=34;break}M=c[e>>2]|0;c[e>>2]=M+4;Y=M;Z=R}else{V=Q;W=r;X=34}}while(0);do{if((X|0)==34){X=0;M=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;D=c[e>>2]|0;E=D+4|0;c[e>>2]=E;if((W|0)>0){_=E;$=D;aa=W}else{Y=D;Z=V;break}while(1){c[$>>2]=M;E=aa+ -1|0;if((E|0)>0){aa=E;$=_;_=_+4|0}else{break}}c[e>>2]=D+(W+1<<2);Y=D+(W<<2)|0;Z=V}}while(0);c[Y>>2]=m;ba=Z}else{ba=Q}if((ba|0)==(N|0)){M=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;E=c[e>>2]|0;P=E+4|0;c[e>>2]=P;c[E>>2]=M;ca=P}else{P=a[o]|0;M=(P&1)==0;if(M){da=(P&255)>>>1}else{da=c[B>>2]|0}if((da|0)==0){ea=ba;fa=-1;ga=0;ha=0}else{if(M){ia=z}else{ia=c[A>>2]|0}ea=ba;fa=a[ia]|0;ga=0;ha=0}while(1){M=c[e>>2]|0;do{if((ha|0)==(fa|0)){P=M+4|0;c[e>>2]=P;c[M>>2]=n;E=ga+1|0;ja=a[o]|0;ka=(ja&1)==0;if(ka){la=(ja&255)>>>1}else{la=c[B>>2]|0}if(!(E>>>0<la>>>0)){ma=P;na=fa;oa=E;pa=0;break}if(ka){qa=z}else{qa=c[A>>2]|0}if((a[qa+E|0]|0)==127){ma=P;na=-1;oa=E;pa=0;break}if(ka){ra=z}else{ra=c[A>>2]|0}ma=P;na=a[ra+E|0]|0;oa=E;pa=0}else{ma=M;na=fa;oa=ga;pa=ha}}while(0);M=ea+ -4|0;D=c[M>>2]|0;E=ma+4|0;c[e>>2]=E;c[ma>>2]=D;if((M|0)==(N|0)){ca=E;break}else{ea=M;fa=na;ga=oa;ha=pa+1|0}}}if((O|0)==(ca|0)){F=N;break a}M=ca+ -4|0;if(M>>>0>O>>>0){sa=O;ta=M}else{F=N;break a}while(1){M=c[sa>>2]|0;c[sa>>2]=c[ta>>2];c[ta>>2]=M;M=sa+4|0;E=ta+ -4|0;if(M>>>0<E>>>0){ta=E;sa=M}else{F=N;break}}break};case 0:{c[d>>2]=c[e>>2];F=C;break};default:{F=C}}}while(0);N=g+1|0;if(N>>>0<4){C=F;g=N}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}function bla(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;Jfa(m,g);z=m;A=c[z>>2]|0;if(!((c[27504]|0)==-1)){c[l>>2]=110016;c[l+4>>2]=186;c[l+8>>2]=0;yea(110016,l,187)}l=(c[110020>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;xoa(D);E=125584;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(xe[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;$ka(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=Soa(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}dpa()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}ala(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];Via(b,k,R,e,w,g,h);if((Q|0)==0){pfa(t);pfa(s);Nea(r);U=c[z>>2]|0;V=U;W=V;X=dea(W)|0;i=d;return}Toa(Q);pfa(t);pfa(s);Nea(r);U=c[z>>2]|0;V=U;W=V;X=dea(W)|0;i=d;return}function cla(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function dla(a){a=a|0;i=i;return}function ela(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function fla(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{dfa(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=yd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=upa(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{Nea(j);i=d;return}do{dfa(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);Nea(j);i=d;return}function gla(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function hla(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function ila(a){a=a|0;i=i;return}function jla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function kla(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=111680;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=111680|0;while(1){c[m>>2]=y;A=(Ge[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{dfa(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}Fka(110904)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=yd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=111784;D=upa(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){Nea(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=111784|0;while(1){c[q>>2]=o;h=(Ge[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{tfa(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){Fka(110904)}else if((E|0)==25){Nea(r);i=d;return}}function lla(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function mla(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=110112;e=b+8|0;b=c[e>>2]|0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);if((b|0)==(c[27478]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function nla(a){a=a|0;a=Ec(8)|0;eea(a,109904);c[a>>2]=106872;Td(a|0,106912,40)}



function bba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;kW();do{if((nca(a,b)|0)==0){if((pca(a,b)|0)!=0){break}do{if((c[92848>>2]|0)!=0){w=c[92976>>2]|0;if((qpa(w,84440)|0)==0){qW(1);break}if((qpa(w,84448)|0)==0){qW(0);break}else{c[p>>2]=w;vW(1,0,84456,p);ud(0)|0;Cd(0)}}}while(0);if((c[92804>>2]|0)==0){Raa(0,0);zZ(d);if((d|0)==0){_ga(Waa(105384,84824)|0,105)|0}c[d+300>>2]=Taa(0,0)|0;c[d+292>>2]=Vaa(0,0)|0;F3(d+8|0,d+240|0);FZ(d)|0;NZ(d)|0;ZZ(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}_ga(Waa(105384,84888)|0,105)|0;x=1;i=e;return x|0}}while(0);c[20796]=c[92872>>2];x=0;i=e;return x|0}Hea(u,c[92932>>2]|0);w=1;while(1){y=40832+(w<<2)|0;Hea(v,c[y>>2]|0);z=Saa(u,v)|0;Nea(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=ifa(u)|0;vW(1,0,84728,g);c[f>>2]=c[b>>2];vW(1,0,84768,f);ud(0)|0;Cd(0)}A=c[44856+(w<<2)>>2]|0;do{if((A|0)==1){z=c[44728+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;tW(1,1,84528,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[44728+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;tW(1,1,84568,n);break}else{c[m>>2]=z;vW(1,1,84408,m);break}}}while(0);if((w|0)==29){A=1;do{z=c[84240+(A<<2)>>2]|0;c[h>>2]=c[84128+(A<<2)>>2];c[h+4>>2]=z;tW(1,0,83232,h);A=A+1|0;}while((A|0)<20);D=36376;E=c[9094]|0;fe[E&255](1);F=ud(0)|0;Cd(0)}else if((w|0)==11){A=1;do{z=c[84696+(A<<2)>>2]|0;c[j>>2]=c[84664+(A<<2)>>2];c[j+4>>2]=z;tW(1,0,83232,j);A=A+1|0;}while((A|0)<7);D=36376;E=c[9094]|0;fe[E&255](1);F=ud(0)|0;Cd(0)}else if((w|0)==7){A=1;do{z=c[84648+(A<<2)>>2]|0;c[k>>2]=c[84632+(A<<2)>>2];c[k+4>>2]=z;tW(1,0,83232,k);A=A+1|0;}while((A|0)<4);D=36376;E=c[9094]|0;fe[E&255](1);F=ud(0)|0;Cd(0)}else if((w|0)==19){A=c[8528]|0;if((A|0)<28){G=A}else{D=36376;E=c[9094]|0;fe[E&255](1);F=ud(0)|0;Cd(0)}do{A=c[35696+(G<<2)>>2]|0;c[l>>2]=c[34528+(G<<2)>>2];c[l+4>>2]=A;tW(1,0,83232,l);G=G+1|0;}while((G|0)<28);D=36376;E=c[9094]|0;fe[E&255](1);F=ud(0)|0;Cd(0)}else{D=36376;E=c[9094]|0;fe[E&255](1);F=ud(0)|0;Cd(0)}}}while(0);c[t>>2]=c[b>>2];tW(1,1,84344,t);t=1;do{b=c[44856+(t<<2)>>2]|0;do{if((b|0)==1){F=c[42736+(t<<2)>>2]|0;c[s>>2]=c[40832+(t<<2)>>2];c[s+4>>2]=F;tW(1,0,84360,s)}else{F=c[40832+(t<<2)>>2]|0;if((b|0)==2){E=c[42736+(t<<2)>>2]|0;c[r>>2]=F;c[r+4>>2]=F;c[r+8>>2]=E;tW(1,0,84376,r);break}else{c[q>>2]=F;vW(1,0,84408,q);break}}}while(0);t=t+1|0;}while((t|0)<31);fe[c[9094]&255](1);ud(0)|0;Cd(0);return 0}function cba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[21230]|0;tb(86504)|0;c[l>>2]=c[m+88>>2];gc(84928,l|0)|0;tb(86520)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gc(84952,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gc(84992,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(85024,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(85056,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];gc(85088,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gc(85120,b|0)|0;tb(86544)|0;i=a;return}function dba(a,b){a=a|0;b=+b;i=i;return}function eba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;tpa(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=Hpa(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=Hpa(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[21230]=d;u=0;Ha(61,10,182)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=Hpa(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=Hpa(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=Hpa(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(111,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=Hpa(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(112,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=Hpa(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=Hpa(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(183,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=Hpa(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=Hpa(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=Hpa(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function fba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=md(c[8434]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 2:{if((c[35836>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;rc(85192,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Sd(10,a|0)|0;ud(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 3:{if((c[35892>>2]|0)==0){i=b;return}c[f>>2]=e;n=c[r>>2]|0;rc(85192,7,1,n|0)|0;Dc(n|0,d|0,f|0)|0;Sd(10,n|0)|0;ud(0)|0;i=b;return};case 1:{c[f>>2]=e;e=c[r>>2]|0;rc(85192,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Sd(10,e|0)|0;ud(0)|0;eb(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};default:{xW(g,85200,b)}}}function gba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(85176,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Sd(10,d|0)|0;ud(0)|0;i=a;return}function hba(a,b){a=a|0;b=b|0;var c=0;c=i;jba(a,b);i=c;return}function iba(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function jba(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=Gfa(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function kba(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;g0(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=lba(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((Sfa(b,d,r)|0)==(r|0)){break}g0(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){Iea(l,s,h);if((Sfa(b,Mea(l)|0,s)|0)==(s|0)){Nea(l);break}g0(m);c[o>>2]=0;c[a>>2]=0;Nea(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((Sfa(b,e,l)|0)==(l|0)){break}g0(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);mba(g,0)|0;c[a>>2]=b;i=j;return}function lba(a){a=a|0;i=i;return c[a+12>>2]|0}function mba(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function nba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;oba(g,16);pba(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){qba(a,g);rba(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){Waa($ga(m,+h[b+(p<<3)>>3])|0,86560)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){$ga(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){Waa(m,86568)|0}}while((e|0)<(d|0));qba(a,g);rba(g);i=f;return}function oba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;Kfa(e);f=a;c[f>>2]=86940;g=e;c[g>>2]=86960;e=a+4|0;Rga(a,86972|0,e);c[f>>2]=86940;c[g>>2]=86960;Dba(e,b|16);i=d;return}function pba(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function qba(a,b){a=a|0;b=b|0;var c=0;c=i;xba(a,b+4|0);i=c;return}function rba(a){a=a|0;var b=0;b=i;Hba(a,86968);Ffa(a+56|0);i=b;return}function sba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35880>>2]|0)!=0){tb(87264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(14,0,86576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(14,0,86648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35880>>2]|0)==0){i=d;return 0}tW(14,0,86696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(86712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function tba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35880>>2]|0)!=0){tb(87264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(14,0,86576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(14,0,86648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35880>>2]|0)==0){i=d;return 0}tW(14,0,86696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(86712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function uba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35880>>2]|0)!=0){tb(87264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(14,0,86576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(14,0,86648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35880>>2]|0)==0){i=d;return 0}tW(14,0,86696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(86712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function vba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[35880>>2]|0)!=0){tb(87264)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(14,0,86576,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(14,0,86648,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[35880>>2]|0)==0){i=d;return 0}tW(14,0,86696,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(86712,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function wba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=Uoa(fa(F,F)|0,8)|0;J=I;K=Uoa(fa(G,F)|0,8)|0;L=K;M=Uoa(fa(H,F)|0,8)|0;N=M;O=Uoa(fa(H,G)|0,8)|0;P=O;Bea(p);Bea(q);Bea(r);Bea(s);Bea(t);Bea(u);Bea(v);Q=a+536|0;wW(c[Q>>2]|0,(I|0)!=0|0,86720,o);wW(c[Q>>2]|0,(K|0)!=0|0,86720,n);wW(c[Q>>2]|0,(M|0)!=0|0,86720,m);wW(c[Q>>2]|0,(O|0)!=0|0,86720,l);l=a+540|0;m=a;if((ie[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;sba(a,J)|0;wW(n,1,86736,k)}nba(w,J,F,F);Oea(p,w)|0;Nea(w);if((ie[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;tba(a,L)|0;wW(w,1,86768,j)}nba(x,L,F,G);Oea(q,x)|0;Nea(x);if((ie[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;uba(a,N)|0;wW(x,1,86800,h)}nba(y,N,H,F);Oea(r,y)|0;Nea(y);if((ie[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;vba(a,P)|0;wW(m,1,86832,g)}nba(z,P,H,G);Oea(s,z)|0;Nea(z);if((F|0)==0){Pea(t,86864)|0}else{nba(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);Oea(t,A)|0;Nea(A)}if((G|0)==0){Pea(u,86864)|0}else{nba(B,c[a+432>>2]|0,1,G);Oea(u,B)|0;Nea(B)}Toa(I);Toa(K);Toa(M);Toa(O);Hea(E,c[a+84>>2]|0);wfa(D,86880,E);I3(C,D,86888);Oea(v,C)|0;Nea(C);Nea(D);Nea(E);E=ic(ifa(v)|0,86896)|0;D=c[Q>>2]|0;c[f>>2]=ifa(v)|0;wW(D,(E|0)!=0|0,86904,f);f=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;D=ifa(t)|0;Q=ifa(u)|0;C=ifa(p)|0;a=ifa(q)|0;O=ifa(r)|0;M=ifa(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;wd(E|0,f|0,e|0)|0;if((c[35924>>2]|0)==0){R=ud(E|0)|0;S=Yc(E|0)|0;Nea(v);Nea(u);Nea(t);Nea(s);Nea(r);Nea(q);Nea(p);i=b;return 0}e=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;l=ifa(t)|0;f=ifa(u)|0;M=ifa(p)|0;O=ifa(q)|0;a=ifa(r)|0;C=ifa(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;tW(25,0,e,d);R=ud(E|0)|0;S=Yc(E|0)|0;Nea(v);Nea(u);Nea(t);Nea(s);Nea(r);Nea(q);Nea(p);i=b;return 0}function xba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=_fa(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}yba(a,Zfa(l)|0,n,e);i=d;return}if((h&8|0)==0){Cea(a,g);i=d;return}else{g=b;b=Ufa(g)|0;yba(a,b,Wfa(g)|0,f);i=d;return}}function yba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;zba(a,b,c,0);i=d;return}function zba(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;Aba(a,b,c);i=d;return}function Aba(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=Bba(c,d)|0;if(g>>>0>4294967279){zea(0)}if(g>>>0<11){Tea(b,g);h=Sea(b)|0}else{j=_ea(g)|0;k=j+1|0;j=s4(Gea(b)|0,k)|0;afa(b,j);$ea(b,k);Rea(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;t4(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){t4(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;t4(l,f);i=e;return}function Bba(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Cba(b,c,e)|0;i=d;return g|0}function Cba(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function Dba(a,b){a=a|0;b=b|0;var c=0;c=i;Tba(a,b);i=c;return}function Eba(a){a=a|0;var b=0;b=i;rba(a);_oa(a);i=b;return}function Fba(a){a=a|0;var b=0;b=i;rba(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Gba(a){a=a|0;var b=0;b=i;Eba(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Hba(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Iba(a+4|0);i=d;return}function Iba(a){a=a|0;var b=0;b=i;Jba(a);i=b;return}function Jba(a){a=a|0;var b=0;b=i;c[a>>2]=87120;Nea(a+32|0);Ofa(a);i=b;return}function Kba(a){a=a|0;var b=0;b=i;Iba(a);_oa(a);i=b;return}function Lba(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=_fa(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==24){if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}u$(a,-1,-1);i=h;return}else if((k|0)==0){u$(a,-1,-1);i=h;return}else{if((f|0)==2){o=11;break}else if((f|0)==0){p=0;q=0;break}else if((f|0)!=1){o=12;break}if((g&8|0)==0){m=_fa(l)|0;j=m-(Zfa(l)|0)|0;p=j;q=((j|0)<0)<<31>>31;break}else{j=Vfa(l)|0;m=j-(Ufa(l)|0)|0;p=m;q=((m|0)<0)<<31>>31;break}}}while(0);if((o|0)==11){f=n-(Mea(b+32|0)|0)|0;p=f;q=((f|0)<0)<<31>>31}else if((o|0)==12){u$(a,-1,-1);i=h;return}o=Epa(p|0,q|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&o>>>0<0)){d=n-(Mea(b+32|0)|0)|0;q=((d|0)<0)<<31>>31;if((q|0)<(e|0)|(q|0)==(e|0)&d>>>0<o>>>0){break}d=g&8;do{if(!((o|0)==0&(e|0)==0)){do{if((d|0)!=0){if((Vfa(l)|0)!=0){break}u$(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((_fa(l)|0)!=0){break}u$(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){q=Ufa(l)|0;Yfa(l,q,q+o|0,n)}if((g&16|0)!=0){q=Zfa(l)|0;bga(l,q,$fa(l)|0);aga(l,o)}u$(a,o,e);i=h;return}}while(0);u$(a,-1,-1);i=h;return}function Mba(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=I0(d)|0;re[g&31](a,b,h,J,0,e);i=f;return}function Nba(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=_fa(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((Wfa(g)|0)>>>0<j>>>0){b=Ufa(g)|0;Yfa(g,b,Vfa(g)|0,j)}j=Vfa(g)|0;if(!(j>>>0<(Wfa(g)|0)>>>0)){k=-1;i=d;return k|0}k=e1(a[j]|0)|0;i=d;return k|0}function Oba(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=_fa(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=Ufa(h)|0;j=Vfa(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(a1(d,-1)|0){Yfa(h,g,j+ -1|0,k);l=d1(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=b1(d)|0;do{if(g){if(f1(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=Ufa(h)|0;Yfa(h,j,(Vfa(h)|0)+ -1|0,k);a[Vfa(h)|0]=b;l=d;i=e;return l|0}function Pba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(a1(b,-1)|0){f=d1(b)|0;i=d;return f|0}g=a;h=Vfa(g)|0;j=h-(Ufa(g)|0)|0;h=_fa(g)|0;do{if((h|0)==($fa(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=Zfa(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;dfa(o,0);Yea(o,Vea(o)|0);p=Mea(o)|0;bga(g,p,p+(Lea(o)|0)|0);aga(g,h-l|0);c[m>>2]=(Zfa(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(_fa(g)|0)+1;h=c[(Qba(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=Mea(a+32|0)|0;Yfa(g,q,q+j|0,h)}f=Rfa(g,b&255)|0;i=d;return f|0}function Qba(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=Rba(b,c,e)|0;i=d;return g|0}function Rba(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=Sba(0,a,b)|0;i=c;return(d?b:a)|0}function Sba(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function Tba(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;Tfa(a);c[a>>2]=87120;Bea(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;Bea(e);Uba(a,e);Nea(e);i=d;return}function Uba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;Oea(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=Mea(e)|0;j=g+(Lea(e)|0)|0;c[b>>2]=j;g=Mea(e)|0;Yfa(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=Lea(e)|0;c[b>>2]=(Mea(e)|0)+h;Yea(e,Vea(e)|0);b=a;a=Mea(e)|0;bga(b,a,a+(Lea(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}aga(b,h);i=d;return}function Vba(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ic(d|0,87544)|0;J=bd(87552,87544)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Wd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;wW(M,(I|0)!=0|0,87608,E);rc(87632,17,1,J|0)|0;rc(87656,10,1,J|0)|0;rc(87672,18,1,J|0)|0;Wba(J,f,87696,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,87728)}else{c[G>>2]=Wd(c[L>>2]|0)|0;vW(26,0,87560,G);G=c[b+536>>2]|0;E=Wd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;wW(G,(I|0)!=0|0,87608,F)}rc(87736,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Wd(c[L>>2]|0)|0;vW(26,0,88088,D);Yc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(87288,250,88112,kd(H|0)|0)|0)==0){vW(26,0,88136,C);Yc(I|0)|0;O=1;i=j;return O|0}rc(88160,13,1,I|0)|0;rc(88176,12,1,I|0)|0;Xba(I,2);rc(88192,6,1,I|0)|0;Yba(I,c[b+84>>2]|0);rc(88200,8,1,I|0)|0;Xba(I,2);rc(88216,8,1,I|0)|0;C=b+88|0;Yba(I,c[C>>2]|0);rc(88232,10,1,I|0)|0;Xba(I,2);rc(88248,6,1,I|0)|0;Yba(I,87288);rc(88256,8,1,I|0)|0;Xba(I,2);rc(88272,8,1,I|0)|0;Yba(I,c[b+280>>2]|0);rc(88288,10,1,I|0)|0;Xba(I,2);rc(88304,14,1,I|0)|0;Yba(I,c[b+284>>2]|0);rc(88320,16,1,I|0)|0;Xba(I,2);rc(88344,16,1,I|0)|0;Yba(I,l);rc(88368,18,1,I|0)|0;Xba(I,2);c[B>>2]=Zba(l)|0;wd(I|0,88392,B|0)|0;Xba(I,2);P=+HX(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(I|0,88432,A|0)|0;Xba(I,2);P=+HX(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];wd(I|0,88472,z|0)|0;Xba(I,2);P=+HX(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(I|0,88504,y|0)|0;Xba(I,2);P=+HX(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(I|0,88536,x|0)|0;Xba(I,2);P=+HX(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(I|0,88568,w|0)|0;Xba(I,2);P=+HX(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(I|0,88600,v|0)|0;Xba(I,2);P=+HX(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(I|0,88640,u|0)|0;Xba(I,2);P=+KX(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];wd(I|0,88672,t|0)|0;Xba(I,2);c[s>>2]=FX(2)|0;wd(I|0,88712,s|0)|0;Xba(I,2);P=+JX(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];wd(I|0,88736,r|0)|0;rc(88768,13,1,I|0)|0;rc(88784,16,1,I|0)|0;Xba(I,2);P=+HX(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];wd(I|0,88808,q|0)|0;Xba(I,2);c[p>>2]=CX(8)|0;wd(I|0,88832,p|0)|0;rc(88872,17,1,I|0)|0;rc(88896,22,1,I|0)|0;_ba(I,b);rc(88920,23,1,I|0)|0;rc(88944,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{$ba(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{$ba(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{$ba(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{$ba(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{$ba(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{$ba(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{$ba(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{$ba(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(88960,13,1,I|0)|0;rc(88976,12,1,I|0)|0;aca(I,J,f,c[C>>2]|0,b);rc(88992,13,1,I|0)|0;rc(89008,12,1,I|0)|0;bca(I,c[b+68>>2]|0,b+56|0);rc(89024,13,1,I|0)|0;rc(89040,16,1,I|0)|0;cca(I,J,f,b);rc(89064,17,1,I|0)|0;rc(89088,14,1,I|0)|0;Yc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((upa(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(upa(K|0)|0)<<1}else{Q=0}I=Soa(b+Q|0)|0;if((I|0)==0){cb(89104,89112,404,89136)}if((ab(J|0)|0)!=0){vW(26,0,89152,o)}if(e){e=c[C>>2]|0;c[n>>2]=89184;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;hc(I|0,89200,n|0)|0;if((rd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=89280|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;vW(1,0,89312,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;tW(1,0,89376,g);Toa(I);O=0;i=j;return O|0}function Wba(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=DX(F)|0;H=EX(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+JX(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(87632,17,1,a|0)|0;rc(90544,12,1,a|0)|0;rc(90560,12,1,a|0)|0;rc(90576,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;wd(a|0,90592,D|0)|0;rc(90632,10,1,a|0)|0;rc(90648,11,1,a|0)|0;rc(90664,11,1,a|0)|0;rc(90680,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];wd(a|0,90696,C|0)|0}else{rc(90720,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;wd(a|0,90320,B|0)|0;rc(90744,13,1,a|0)|0;if(E){rc(90560,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(a|0,90760,A|0)|0}else{rc(90720,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;wd(a|0,90784,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;wd(a|0,90440,y|0)|0;rc(90832,10,1,a|0)|0;rc(90848,10,1,a|0)|0;rc(90832,10,1,a|0)|0;rc(90864,11,1,a|0)|0;c[x>>2]=b;wd(a|0,90880,x|0)|0;c[w>>2]=d;wd(a|0,90904,w|0)|0;rc(90920,33,1,a|0)|0;rc(90960,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;wd(a|0,91e3,v|0)|0;rc(90680,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(a|0,90696,u|0)|0}else{rc(90848,10,1,a|0)|0;rc(90832,10,1,a|0)|0;rc(90864,11,1,a|0)|0;c[t>>2]=b;wd(a|0,90880,t|0)|0;c[s>>2]=d;wd(a|0,90904,s|0)|0;rc(90920,33,1,a|0)|0;rc(90960,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;wd(a|0,91e3,r|0)|0;rc(90680,10,1,a|0)|0;rc(90720,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;wd(a|0,90320,q|0)|0;rc(90744,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];wd(a|0,90760,p|0)|0}else{rc(90720,17,1,a|0)|0}rc(91032,32,1,a|0)|0;rc(91072,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;wd(a|0,91104,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;wd(a|0,90440,n|0)|0;i=m;return}function Xba(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Sd(32,a|0)|0;}while((d|0)!=0);i=c;return}function Yba(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==39){rc(90304,6,1,b|0)|0}else if((e|0)==34){rc(90312,6,1,b|0)|0}else if((e|0)==62){rc(90296,4,1,b|0)|0}else if((e|0)==60){rc(90288,4,1,b|0)|0}else{Sd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function Zba(a){a=a|0;var b=0,c=0,d=0;b=i;c=ic(a|0,90280)|0;if((c|0)==0){d=-1;i=b;return d|0}Wc(c|0,0,2)|0;a=yb(c|0)|0;Yc(c|0)|0;d=a;i=b;return d|0}function _ba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=Soa((upa(l|0)|0)+15|0)|0;c[f>>2]=l;hc(m|0,90008,f|0)|0;Xba(a,2);rc(90024,10,1,a|0)|0;Yba(a,m);rc(90040,12,1,a|0)|0;Xba(a,2);c[e>>2]=Zba(m)|0;wd(a|0,90056,e|0)|0;Toa(m);Xba(a,2);rc(90088,9,1,a|0)|0;Xba(a,4);rc(90104,22,1,a|0)|0;Xba(a,4);rc(90128,22,1,a|0)|0;Xba(a,4);rc(90152,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){eca(g,m,n);o=c[l>>2]|0;Xba(a,4);rc(90184,8,1,a|0)|0;Yba(a,o);rc(90200,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{jca(h,m,l);g=c[n>>2]|0;Xba(a,4);rc(90184,8,1,a|0)|0;Yba(a,g);rc(90200,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{eca(j,m,q);b=c[t>>2]|0;Xba(a,4);rc(90224,8,1,a|0)|0;Yba(a,b);rc(90240,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){Xba(a,2);v=90264;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{jca(k,m,s);e=c[u>>2]|0;Xba(a,4);rc(90224,8,1,a|0)|0;Yba(a,e);rc(90240,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));Xba(a,2);v=90264;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function $ba(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;Xba(a,2);c[f>>2]=c[b>>2];wd(a|0,89944,f|0)|0;Yba(a,c[b+4>>2]|0);rc(89976,11,1,a|0)|0;Yba(a,c[b+8>>2]|0);rc(89648,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];dca(a,4,e);Xba(a,2);rc(89992,12,1,a|0)|0;i=d;return}function aca(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{eca(p,r,v);Wba(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,89760);w=v+9|0;NX(w);Xba(a,2);c[o>>2]=c[f>>2];wd(a|0,89768,o|0)|0;Xba(a,4);rc(88192,6,1,a|0)|0;Yba(a,c[s>>2]|0);rc(88200,8,1,a|0)|0;Xba(a,4);c[n>>2]=FX(w)|0;wd(a|0,89544,n|0)|0;Xba(a,4);x=+KX(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(a|0,89568,m|0)|0;Xba(a,4);x=+JX(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(a|0,88736,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];dca(a,6,j);Xba(a,2);rc(89792,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function bca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{Xba(a,2);ica(l,d,x);c[j>>2]=c[q>>2];wd(a|0,89616,j|0)|0;ica(m,d,x);Yba(a,c[r>>2]|0);rc(89648,3,1,a|0)|0;Xba(a,4);rc(89656,7,1,a|0)|0;ica(n,d,x);if((c[s>>2]|0)>0){y=0;do{Xba(a,6);c[g>>2]=0;wd(a|0,89664,g|0)|0;y=y+1|0;ica(n,d,x);}while((y|0)<(c[s>>2]|0))}Xba(a,4);rc(89688,8,1,a|0)|0;Xba(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;ica(o,d,x);z=+HX(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;ica(p,d,x);A=CX(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;wd(a|0,89704,f|0)|0;Xba(a,2);rc(89744,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function cca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{jca(n,o,v-u|0);Wba(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,89496);q=v+9|0;NX(q);Xba(a,2);rc(89504,15,1,a|0)|0;Xba(a,4);c[m>>2]=c[e>>2];wd(a|0,89520,m|0)|0;Xba(a,4);c[l>>2]=FX(q)|0;wd(a|0,89544,l|0)|0;Xba(a,4);w=+KX(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(a|0,89568,j|0)|0;Xba(a,4);w=+JX(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];wd(a|0,88736,g|0)|0;Xba(a,2);rc(89592,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function dca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;Xba(a,b);rc(89808,16,1,a|0)|0;Yba(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?89912:89928;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;wd(a|0,89832,f|0)|0;i=e;return}function eca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){fca(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function fca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ic(c[o>>2]|0,91144)|0;if((p|0)!=0){q=p;break}p=Wd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;xW(0,91152,g)}else{q=0}}while(0);g=oR(0)|0;if((g|0)==0){xW(0,91184,f)}f=a+8|0;c[a+20>>2]=Uoa(c[f>>2]|0,32)|0;p=a+12|0;o=Uoa((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=91216;c[o+12>>2]=0;c[o+16>>2]=0;zR(g,h);AR(g,9,69);h=c[n>>2]|0;do{if((h|0)==0){o=j;ypa(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((BR(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=JR(GR(g)|0)|0;s=HR(g)|0;Yc(q|0)|0;vR(g);r=c[a>>2]|0;c[e>>2]=91320;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;xW(0,91256,e)}else if((t|0)==11){Yc(q|0)|0;break}}else{if((BR(g,h,upa(h|0)|0,1)|0)!=0){break}s=JR(GR(g)|0)|0;o=HR(g)|0;vR(g);r=c[n>>2]|0;c[d>>2]=91320;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;xW(0,91360,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(91424,91320,295,91464)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(91488,91320,297,91464)}}function gca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((qpa(91896,b)|0)==0){if((qpa(c[d>>2]|0,91904)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}wW(0,p,91912,l);l=c[22938]|0;p=c[22992]|0;do{if((l|0)==0|(p|0)==0){c[22992]=32;a=Soa(1152)|0;c[22938]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[22992]=p<<1;a=Voa(l,p*72|0)|0;c[22938]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(mca(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((qpa(91976,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((qpa(91984,u)|0)==0){c[22998]=Ad(c[t+4>>2]|0)|0}else{if((qpa(92016,u)|0)==0){c[91996>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((qpa(92032,u)|0)==0){c[92004>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((qpa(92040,u)|0)==0){c[92e3>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((qpa(92056,u)|0)==0){c[92008>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((qpa(92064,u)|0)!=0){v=23;break a}c[92012>>2]=(qpa(c[t+4>>2]|0,92080)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];xW(0,92088,k)}else if((v|0)==45){i=e;return}}if((qpa(91736,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=91320;c[j+4>>2]=k;c[j+8>>2]=v;xW(0,92120,j)}if((qpa(92184,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=91320;c[h+4>>2]=j;xW(0,92192,h)}h=Vb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=91320;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;xW(0,92248,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=92312;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((qpa(91680,b)|0)!=0){if((qpa(91872,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=92416;m=Ad(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=92424;i=e;return}c[91700>>2]=0;c[91704>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((qpa(m,91904)|0)==0){c[91700>>2]=Ad(c[b+4>>2]|0)|0}else{if((qpa(m,92368)|0)!=0){break}c[91704>>2]=Ad(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[91700>>2]|0)==0){w=0;break}w=(c[91704>>2]|0)!=0|0}}while(0);wW(0,w,92376,f);c[22924]=-1;f=91708|0;w=91992;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function hca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((qpa(91680,b)|0)==0){o=e+0|0;p=91696|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));lca(e);i=d;return}if((qpa(91736,b)|0)==0){e=h+24|0;r=Soa((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=Soa(36)|0;t=s;o=s+0|0;p=(c[22938]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((qpa(91760,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Bd(e+(k*20|0)+8|0,91768,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((qpa(91808,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Bd(h+(k*20|0)+8|0,91824,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((qpa(91872,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function ica(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){fca(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function jca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){fca(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;xW(0,91528,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=91608;p=o;xW(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=91608;p=o;xW(0,p,f)}}function kca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Toa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){Toa(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}Toa(k);c[d>>2]=0;i=b;return}function lca(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=Soa(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=upa(f|0)|0;c[e+64>>2]=k;k=c[22972]|0;do{if((k|0)==0){c[22972]=e;c[e+44>>2]=0;l=Soa(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=Soa(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{ypa(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[22972]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[22972]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=upa(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(upa(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 6:{B=o;C=y;D=17;break};case 3:{E=o;F=x;G=y;D=20;break};case 8:{H=o;D=15;break};case 5:{I=o;J=y;D=18;break};case 1:{K=o;L=x;M=y;D=22;break};case 9:{N=o;D=14;break};case 10:{O=o;D=13;break};case 2:{P=o;Q=x;R=y;D=21;break};case 4:{S=o;T=y;D=19;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;O=z;D=13;break};case 7:{U=o;V=y;D=16;break};default:{W=o;X=x;Y=y}}if((D|0)==13){o=((d[A+9|0]|0)<<16)+O|0;c[p>>2]=o;N=o;D=14}if((D|0)==14){o=((d[A+8|0]|0)<<8)+N|0;c[p>>2]=o;H=o;D=15}if((D|0)==15){U=H;V=((d[A+7|0]|0)<<24)+y|0;D=16}if((D|0)==16){B=U;C=((d[A+6|0]|0)<<16)+V|0;D=17}if((D|0)==17){I=B;J=((d[A+5|0]|0)<<8)+C|0;D=18}if((D|0)==18){S=I;T=(d[A+4|0]|0)+J|0;D=19}if((D|0)==19){E=S;F=((d[A+3|0]|0)<<24)+x|0;G=T;D=20}if((D|0)==20){P=E;Q=((d[A+2|0]|0)<<16)+F|0;R=G;D=21}if((D|0)==21){K=P;L=((d[A+1|0]|0)<<8)+Q|0;M=R;D=22}if((D|0)==22){W=K;X=(d[A]|0)+L|0;Y=M}M=X-Y-W^W>>>13;X=Y-W-M^M<<8;Y=W-M-X^X>>>13;W=M-X-Y^Y>>>12;M=X-Y-W^W<<16;X=Y-W-M^M>>>5;Y=W-M-X^X>>>3;W=M-X-Y^Y<<10;M=X-Y-W^W>>>15;c[p>>2]=M;p=(c[22972]|0)+40|0;W=c[p>>2]|0;Y=M&(c[W+4>>2]|0)+ -1;M=c[W>>2]|0;W=M+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[M+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[22972]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[22972]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=Soa((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}ypa(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;M=c[j>>2]|0;c[Y+24>>2]=(((M<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((M|0)==0){_=e}else{M=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=M}else{W=M;X=j;while(1){j=X+16|0;L=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];K=Z+(A*12|0)+4|0;D=(c[K>>2]|0)+1|0;c[K>>2]=D;R=c[W+24>>2]|0;if(D>>>0>R>>>0){D=W+28|0;c[D>>2]=(c[D>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[K>>2]|0)>>>0)/(R>>>0)|0}c[X+12>>2]=0;R=Z+(A*12|0)|0;c[j>>2]=c[R>>2];j=c[R>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[R>>2]=X;R=c[h>>2]|0;if((L|0)==0){$=R;break}else{W=R;X=L}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){M=$;Y=W;e=X}else{_=W;break}}}Toa(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function mca(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[22972]|0)==0){f=24}else{g=upa(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(upa(a|0)|0)+s|0;switch(v|0){case 10:{x=h;f=6;break};case 5:{y=h;z=u;f=11;break};case 9:{A=h;f=7;break};case 11:{x=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 8:{B=h;f=8;break};case 6:{C=h;D=u;f=10;break};case 7:{E=h;F=u;f=9;break};case 3:{G=h;H=t;I=u;f=13;break};case 2:{J=h;K=t;L=u;f=14;break};case 4:{M=h;N=u;f=12;break};case 1:{O=h;P=t;Q=u;f=15;break};default:{R=h;S=t;T=u}}if((f|0)==6){A=((d[w+9|0]|0)<<16)+x|0;f=7}if((f|0)==7){B=((d[w+8|0]|0)<<8)+A|0;f=8}if((f|0)==8){E=B;F=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){C=E;D=((d[w+6|0]|0)<<16)+F|0;f=10}if((f|0)==10){y=C;z=((d[w+5|0]|0)<<8)+D|0;f=11}if((f|0)==11){M=y;N=(d[w+4|0]|0)+z|0;f=12}if((f|0)==12){G=M;H=((d[w+3|0]|0)<<24)+t|0;I=N;f=13}if((f|0)==13){J=G;K=((d[w+2|0]|0)<<16)+H|0;L=I;f=14}if((f|0)==14){O=J;P=((d[w+1|0]|0)<<8)+K|0;Q=L;f=15}if((f|0)==15){R=O;S=(d[w]|0)+P|0;T=Q}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[22972]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=upa(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((ppa(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,92448)|0)==0){V=0;break}else{W=92472}i=b;return W|0}}while(0);c[e>>2]=a;wW(0,(V|0)!=0|0,92520,e);W=V+4|0;i=b;return W|0}function nca(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((oca(92576,a,b)|0)!=0){d=1;i=c;return d|0}d=(oca(92584,a,b)|0)!=0|0;i=c;return d|0}function oca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((qpa(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function pca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(qpa(c[40956>>2]|0,92592)|0)==0|0;wW(0,m,92608,l);l=(qpa(c[42860>>2]|0,92592)|0)==0|0;wW(0,l,92664,k);k=(qpa(c[44852>>2]|0,92592)|0)==0|0;wW(0,k,92720,j);j=92784|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=92912|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[44856+(k<<2)>>2]|0;if((l|0)==2){q=c[40832+(k<<2)>>2]|0;if(!((oca(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[40832+(k<<2)>>2]|0;if((rca(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((oca(c[40832+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=92784+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=92784+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[92912+(k<<2)>>2]=qca(q,p)|0;t=j}else if((r|0)==13){r=0;l=92784+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[92912+(k<<2)>>2]=sca(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];vW(1,0,93040,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];vW(1,0,93040,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];vW(1,0,93040,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];vW(1,0,93096,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function qca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((qpa(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function rca(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(sca(a,b)|0)!=0|0;i=c;return d|0}function sca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=upa(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((rpa(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function tca(){i=i;return}function uca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(93128,5,1,e|0)|0;f=b;b=0;while(1){Sd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(93136,20,1,e|0)|0;vc(0);return 0}function vca(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;wd(d|0,93160,e|0)|0;if((b|0)==0){vc(1)}else{ud(d|0)|0;Dca();ud(d|0)|0;ib(6,0)|0;hd()}}function wca(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function xca(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function yca(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function zca(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function Aca(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function Bca(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}ypa(p|0,32,b+(d-p)|0)|0;i=f;return}function Cca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=94200+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[94244+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[94240+(e*48|0)>>2]|0)==1){Eca(b)|0}k=94204+(e*48|0)|0;if((c[k>>2]|0)==0){break}Yc(c[f>>2]|0)|0;Toa(c[k>>2]|0)}}while(0);do{if((h|0)==10){Yc(g|0)|0;b=94204+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Jd(k|0)|0;Toa(c[b>>2]|0)}}while(0);c[f>>2]=0}c[94236+(e*48|0)>>2]=0;c[94204+(e*48|0)>>2]=0;i=d;return 0}function Dca(){var a=0,b=0;a=i;if((c[23292]|0)!=0){i=a;return}c[23292]=1;c[93176>>2]=0;b=0;do{c[93172>>2]=b;Cca(93168)|0;b=b+1|0;}while((b|0)<100);i=a;return}function Eca(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[94216+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=94200+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Wc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[94220+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[94228+(d*48|0)>>2]&2|0)!=0){ud(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Wc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){Gca(111,93184);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function Fca(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==24576){e=1;break}else if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function Gca(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;wd(m|0,94096,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;wd(m|0,94128,j|0)|0;l=m;break}else{n=c[93968+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;wd(m|0,94152,h|0)|0;l=m;break}}}while(0);h=c[23540]|0;do{if((h|0)==0){rc(99032,29,1,l|0)|0}else{c[g>>2]=(h-94200|0)/48|0;wd(l|0,94168,g|0)|0;b=c[(c[23540]|0)+4>>2]|0;if((b|0)==0){rc(99016,10,1,l|0)|0;break}else{c[f>>2]=b;wd(l|0,99e3,f|0)|0;break}}}while(0);f=c[24766]|0;if((f|0)!=0){c[d>>2]=f;wd(l|0,99072,d|0)|0}d=(c[24786]|0)!=0?99152:99168;f=(c[24794]|0)!=0?99184:99200;g=(c[24804]|0)!=0?99224:99240;c[e>>2]=(c[24780]|0)!=0?99128:99136;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;wd(l|0,99096,e|0)|0;vca(99256,1)}function Hca(){var a=0,b=0;a=i;c[24816]=1;b=c[r>>2]|0;c[23550]=b;c[94220>>2]=Fca(b)|0;c[94224>>2]=1;c[94240>>2]=1;b=c[s>>2]|0;c[94440>>2]=b;c[94460>>2]=Fca(b)|0;c[94464>>2]=1;c[94480>>2]=0;b=c[t>>2]|0;c[94488>>2]=b;c[94508>>2]=Fca(b)|0;c[94512>>2]=1;c[94528>>2]=1;i=a;return}function Ica(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[104512+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[24818]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[104512+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[24818]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Wc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Wc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function Jca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){Gca(b,d)}d=c[24820]|0;if((d|0)!=0){Ce[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function Kca(a){a=a|0;var b=0,d=0;b=i;c[24850]=0;c[24852]=0;c[24854]=0;d=((Lca(a,0)|0)==0)<<31>>31;i=b;return d|0}function Lca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[24854]|0;c[24854]=j+1;if((j|0)==1){c[24852]=d}if((Qca(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=Rca(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function Mca(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[24850]|0;l=99424+(k<<4)|0;m=c[l>>2]|0;switch(Nca(m)|0){case 22:{c[24828]=1;c[24850]=k+1;continue b;break};case 3:{n=c[26066]|0;o=104272+(n<<2)|0;p=c[o>>2]|0;c[o>>2]=p+ -1;if((p|0)<2){c[26066]=n+ -1;c[26082]=(c[26082]|0)+ -1;c[24850]=k+1;continue b}else{n=c[26082]|0;c[26082]=n+ -1;c[24850]=(c[104336+(n<<2)>>2]|0)+1;continue b}break};case 20:{c[24846]=c[99428+(k<<4)>>2];c[24850]=k+1;continue b;break};case 8:{n=c[26066]|0;q=104272+(n<<2)|0;s=c[q>>2]|0;if((s|0)>=1){t=10;break b}c[26066]=n+ -1;c[24850]=k+1;continue b;break};case 6:{n=c[99428+(k<<4)>>2]|0;p=(c[26066]|0)+1|0;c[26066]=p;c[104272+(p<<2)>>2]=n;c[24850]=k+1;continue b;break};case 21:{c[24828]=0;c[24850]=k+1;continue b;break};case 19:case 17:{c[24826]=0;c[24850]=k+1;continue b;break};case 1:{n=c[99428+(k<<4)>>2]|0;p=(c[26082]|0)+1|0;c[26082]=p;c[104336+(p<<2)>>2]=n;c[24850]=k+1;continue b;break};case 16:{if(b){t=28;break a}c[24850]=k+1;continue b;break};case 33:{c[26094]=1;c[24850]=k+1;continue b;break};case 18:{c[24826]=1;c[24850]=k+1;continue b;break};case 2:{c[26066]=0;c[26082]=0;c[24850]=c[99428+(k<<4)>>2];if(b){t=24;break a}if((c[26078]|0)==0){j=0;t=37;break a}k=Ce[c[24836]&7]()|0;if((k|0)==0){continue b}else{j=k;t=37;break a}break};case 9:{k=(ie[c[24834]&127](l)|0)==0;c[24850]=(c[24850]|0)+1;if(k){break b}else{continue b}break};default:{t=4;break a}}}if((t|0)==10){t=0;if(b){t=11;break}c[q>>2]=s+ -1;c[26078]=1;k=le[c[24832]&63](l,g,d)|0;if((k|0)>0){t=13;break}if((k|0)<0){t=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;t=37;break}}if((t|0)==4){h=c[r>>2]|0;d=c[24766]|0;c[f>>2]=m;c[f+4>>2]=d;wd(h|0,104224,f|0)|0;if((c[c[24822]>>2]|0)==0){Gca(100,104256);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((t|0)==11){j=Ce[c[24820]&7]()|0;i=e;return j|0}else if((t|0)==13){f=c[c[24822]>>2]|0;j=Jca(f,c[(Nc()|0)>>2]|0,104320)|0;i=e;return j|0}else if((t|0)==15){if((c[(c[24822]|0)+8>>2]|0)==0){Gca(-1,104320);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((t|0)==24){j=Ce[c[24820]&7]()|0;i=e;return j|0}else if((t|0)==28){j=Ce[c[24820]&7]()|0;i=e;return j|0}else if((t|0)==37){i=e;return j|0}return 0}function Nca(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function Oca(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=Mca(b,0,0)|0;i=a;return d|0}function Pca(){c[24842]=0;c[24850]=0;c[26082]=0;c[26066]=0;c[26078]=0;c[26084]=0;c[26068]=0;i=i;return}function Qca(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[24850]|0;if((g|0)>299){rc(104400,24,1,c[r>>2]|0)|0;vca(c[24766]|0,1)}else{c[99424+(g<<4)>>2]=a;c[99428+(g<<4)>>2]=b;c[99432+(g<<4)>>2]=d;c[99436+(g<<4)>>2]=e;c[24850]=g+1;i=f;return g|0}return 0}function Rca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=Sca(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==44){j=7;break}else if(e<<24>>24==41){j=9;break a}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[24854]|0)+ -1|0;c[24854]=h;if((h|0)==0){Qca(2,c[24852]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{Qca(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function Sca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((Tca(b,e)|0)!=0){g=c[e>>2]|0;break}if((Uca(b,e)|0)!=0){g=c[e>>2]|0;break}h=Vca(b,f,1)|0;j=Qca(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=Lca(h,j)|0}}while(0);i=d;return g|0}function Tca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 47:{Qca(5,0,0,0)|0;g=b;h=30;break};case 115:case 83:{j=b+1|0;k=a[j]|0;if(k<<24>>24==80|k<<24>>24==112){l=j;m=18}else if(k<<24>>24==83|k<<24>>24==115){l=j;m=19}else{l=b;m=17}Qca(m,0,0,0)|0;g=l;h=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{n=b;o=0;h=14;break};case 39:case 34:case 2:{c[99432+((Qca(11,0,0,0)|0)<<4)>>2]=b;j=Wca(b)|0;c[d>>2]=j;p=(j|0)!=0|0;i=e;return p|0};case 45:{q=1;h=13;break};case 116:case 84:{j=b+1|0;k=a[j]|0;if(k<<24>>24==76|k<<24>>24==108){r=j;s=13}else if(k<<24>>24==82|k<<24>>24==114){r=j;s=14}else{r=b;s=15}j=Vca(r+1|0,f,0)|0;if((j|0)==0){h=15;break a}Qca(s,c[f>>2]|0,0,0)|0;g=j+ -1|0;h=30;break};case 98:case 66:{j=b+1|0;k=a[j]|0;if(k<<24>>24==90|k<<24>>24==122){Qca(22,0,0,0)|0;g=j;h=30;break a}else{Qca(21,0,0,0)|0;g=j;h=30;break a}break};case 112:case 80:{Qca(20,1,0,0)|0;g=b;h=30;break};case 43:{q=0;h=13;break};case 36:{Qca(33,0,0,0)|0;g=b;h=30;break};case 58:{Qca(16,0,0,0)|0;g=b;h=30;break};case 120:case 88:{Qca(4,1,0,0)|0;g=b;h=30;break};default:{p=0;i=e;return p|0}}}while(0);if((h|0)==13){n=b+1|0;o=q;h=14}b:do{if((h|0)==14){q=Vca(n,f,0)|0;if((q|0)==0){h=15;break}switch(a[q]|0){case 112:case 80:{b=c[f>>2]|0;if((o|0)==0){t=b}else{s=0-b|0;c[f>>2]=s;t=s}Qca(20,t,0,0)|0;g=q;h=30;break b;break};case 104:case 72:{s=c[f>>2]|0;c[99432+((Qca(12,s,0,0)|0)<<4)>>2]=q+1;g=q+s|0;h=30;break b;break};case 120:case 88:{Qca(4,c[f>>2]|0,0,0)|0;g=q;h=30;break b;break};default:{p=0;i=e;return p|0}}}}while(0);if((h|0)==15){c[d>>2]=0;p=1;i=e;return p|0}else if((h|0)==30){c[d>>2]=g+1;p=1;i=e;return p|0}return 0}function Uca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=Vca(b,f,1)|0;Qca(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 122:case 90:{l=35;m=36;n=38;break};case 97:case 65:{o=f;while(1){p=a[o]|0;if(p<<24>>24==32){o=o+1|0}else{break}}if(!((p+ -48<<24>>24&255)<10)){Qca(30,0,0,0)|0;q=o;n=45;break a}r=Vca(o,g,1)|0;s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}Qca(31,s,0,0)|0;q=r;n=45;break};case 105:case 73:{l=7;m=10;n=38;break};case 103:case 71:{t=0;n=3;break};case 111:case 79:{l=32;m=34;n=38;break};case 101:case 69:{t=1;n=3;break};case 102:case 70:{r=Vca(f,g,0)|0;if((r|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){q=r;n=45;break a}if((a[r]|0)==46){u=Vca(r+1|0,h,0)|0;if((u|0)==0){n=4;break a}v=u;w=c[h>>2]|0}else{c[h>>2]=0;v=r;w=0}Qca(23,s,w,0)|0;q=v;n=45;break};case 108:case 76:{s=Vca(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}Qca(29,r,0,0)|0;q=s;n=45;break};case 100:case 68:{s=Vca(f,g,0)|0;if((s|0)==0){n=4;break a}r=c[g>>2]|0;if((r|0)==0){q=s;n=45;break a}if((a[s]|0)==46){u=Vca(s+1|0,h,0)|0;if((u|0)==0){n=4;break a}x=u;y=c[h>>2]|0}else{c[h>>2]=0;x=s;y=0}Qca(26,r,y,0)|0;q=x;n=45;break};default:{c[24850]=(c[24850]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=Vca(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){v=Vca(b+1|0,h,0)|0;if((v|0)==0){n=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){Qca((t|0)==1?24:27,x,c[h>>2]|0,0)|0;q=A;n=45;break}y=Vca(A+1|0,j,0)|0;if((y|0)==0){n=4;break}Qca((t|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;q=y;n=45}else if((n|0)==38){y=Vca(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=y;n=45;break}if((a[y]|0)!=46){Qca(l,x,0,0)|0;q=y;n=45;break}b=Vca(y+1|0,h,0)|0;if((b|0)==0){n=4;break}Qca(m,x,c[h>>2]|0,0)|0;q=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=q;z=1;i=e;return z|0}return 0}function Vca(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function Wca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[24822]>>2]|0)==0){Gca(100,104384);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function Xca(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[104454|0]=48;k=104454|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=104432+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function Yca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[24844]|0;f=c[24840]|0;if((e|0)>(f|0)){c[24840]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[26132]|0)){h=g}else{Zca(f,g);h=c[24840]|0}g=c[26134]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Kd(g|0,c[24818]|0)|0;h=upa(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Sd(a[k]|0,c[24818]|0)|0;Kd(h|0,c[24818]|0)|0;b=upa(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function Zca(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[26134]|0;if((f|0)==104616){c[26132]=1024;g=1024}else{g=c[26132]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[26132]=j;h=j}j=Soa(h)|0;if((j|0)==0){Gca(113,105016);k=c[26134]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[26134]|0}else{l=k}if((l|0)==104616){m=104536;c[26134]=j;i=e;return}Toa(l);m=104536;c[26134]=j;i=e;return}function _ca(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[24840]|0;f=c[26132]|0;if((e|0)<(f|0)){g=e}else{Zca(e,f);g=c[24840]|0}c[24840]=g+1;a[(c[26134]|0)+g|0]=b;i=d;return}function $ca(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[24804]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){Gca(101,104544);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[24816]|0)==0){Hca();m=c[f>>2]|0}else{m=k}k=94200+(m*48|0)|0;c[23540]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){eda(k,c[b+12>>2]|0,j);o=fda(j,h)|0;if((o|0)==(c[94208+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[94212+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=Cca(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[94232+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=94216+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[94232+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=94224+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[94224+(m*48|0)>>2]=1;r=1;break}else{c[94224+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];hc(j|0,104552,e|0)|0}else{eda(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){ada(107,104544,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=94244+(m*48|0)|0;c[q>>2]=0;c[94236+(m*48|0)>>2]=0;e=94240+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=94228+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 82:case 114:{break};case 83:case 115:{c[q>>2]=1;o=Mb()|0;c[n>>2]=o;if((o|0)!=0){c[94204+(m*48|0)>>2]=0;c[94212+(m*48|0)>>2]=-1;c[94208+(m*48|0)>>2]=-1;c[94220+(m*48|0)>>2]=1;l=0;i=d;return l|0}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){ada(s,104544,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){ada(128,104544,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){ada(o,104544,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};default:{break b}}}while(0);o=ic(j|0,c[26128]|0)|0;if((o|0)==0){break}Yc(o|0)|0}}while(0);q=Soa((upa(j|0)|0)+1|0)|0;c[94204+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){ada(113,104568,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}Apa(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ic(j|0,c[104512+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ic(j|0,c[104472+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ic(j|0,c[104512+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){Gca(o,104544);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=94220+(m*48|0)|0;c[r>>2]=Fca(u)|0;u=fda(j,94212+(m*48|0)|0)|0;c[94208+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){ada(108,104544,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Wc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){ada(129,104544,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function ada(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){Gca(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[26132]|0)){j=d;k=g}else{Zca(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[26134]|0;c[(c[23540]|0)+4>>2]=f;eda(k,j,f);Gca(a,b);i=e;return}function bda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;hc(j|0,104552,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=upa(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?104584:104592;c[h+24>>2]=(b|0)==5?104600:104608;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=$ca(h)|0;i=e;return a|0}function cda(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=94200+(d*48|0)|0;c[23540]=e;if(d>>>0>99){if((c[a>>2]|0)==0){Gca(101,105032);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((bda(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){Gca(114,105040);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[94224+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){Gca(102,105040);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function dda(){var a=0,b=0;a=i;b=Oca()|0;c[24766]=0;i=a;return b|0}function eda(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function fda(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((lc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function gda(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[24846]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[24826]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hc(p|0,105048,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(upa(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;fe[c[24830]&255](32);}while((A|0)>0)}if((D|0)!=0){fe[c[24830]&255]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{fe[c[24830]&255](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[24846]|0);hc(A|0,105056,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;fe[c[24830]&255](32);}while((z|0)>0)}if((x|0)!=0){fe[c[24830]&255]((w|0)!=0?45:43)}z=c[24846]|0;do{if((z|0)<1){fe[c[24830]&255](46);y=c[24830]|0;if((z|0)<0){G=y;J=z;while(1){fe[G&255](48);I=J+1|0;K=c[24830]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}fe[N&255](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}fe[c[24830]&255](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[24830]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){fe[P&255](a[J]|0);R=Q+ -1|0;S=c[24830]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}fe[T&255](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;fe[c[24830]&255](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){fe[c[24830]&255](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;fe[c[24830]&255](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){fe[c[24830]&255](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;fe[c[24830]&255](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;fe[c[24830]&255](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;fe[c[24830]&255](42);}while((_|0)>0);i=l;return 0}function hda(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[24846]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(hc(n|0,105064,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[24826]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;fe[c[24830]&255](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;fe[c[24830]&255](32);}while((b|0)>0)}do{if(q){if((c[24826]|0)==0){break}fe[c[24830]&255](43)}else{fe[c[24830]&255](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;fe[c[24830]&255](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;fe[c[24830]&255](48);}while((z|0)>0);i=j;return 0}function ida(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==1){h=a[d]|0}else if((f|0)==4){h=c[d>>2]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{fe[c[24830]&255](32);e=e+1|0;}while((e|0)<(d|0))}d=c[24830]|0;if((h|0)==0){fe[d&255](70);i=g;return 0}else{fe[d&255](84);i=g;return 0}return 0}function jda(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[24842]|0)!=0){g=kda()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 32:{lda(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};case 35:{qda(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 36:{qda(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 23:{h=hda(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 29:{ida(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 7:{lda(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 30:{nda(b,d);h=0;i=e;return h|0};case 28:case 27:{h=pda(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 10:{mda(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 31:{oda(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 25:case 24:case 26:{h=gda(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 34:{mda(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;wd(h|0,105072,f|0)|0;vca(c[24766]|0,1)}}return 0}function kda(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[24842]|0;c[24842]=0;if((c[24804]|0)!=0){if((b|0)>0){d=c[24844]|0;e=c[24840]|0;if((d|0)<=(e|0)){f=b;while(1){fe[c[24830]&255](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[24840]=f;h=0;i=a;return h|0}f=b-d+e|0;c[24840]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){fe[c[24830]&255](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[24840]|0;f=j+b|0;if((f|0)>=0){if((c[24844]|0)<(j|0)){c[24844]=j}c[24840]=f;h=0;i=a;return h|0}if((c[c[24822]>>2]|0)==0){Gca(110,105160);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[24840]|0;if((c[24844]|0)<(f|0)){c[24844]=f}j=f+b|0;c[24840]=j;c[24848]=(c[24848]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[24822]>>2]|0)==0){Gca(110,105160);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[24840]|0;f=j+b|0;if((f|0)>=(c[(c[24824]|0)+16>>2]|0)){if((c[c[24822]>>2]|0)==0){Gca(110,105176);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[24844]|0;if((d|0)<=(j|0)){e=b;while(1){fe[c[24830]&255](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[24848]=(c[24848]|0)+b;c[24840]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[24848]=(c[24848]|0)+f;c[24840]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){fe[c[24830]&255](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function lda(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==4){l=c[d>>2]|0}else if((f|0)==1){l=a[d]|0}else{l=b[d>>1]|0}d=Xca(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[24826]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{fe[c[24830]&255](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{fe[c[24830]&255](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[24826]|0)==0){break}fe[c[24830]&255](43)}else{fe[c[24830]&255](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){fe[c[24830]&255](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function mda(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==1){m=a[d]|0}else if((g|0)==4){m=c[d>>2]|0}else{m=b[d>>1]|0}d=Xca(m,k,l,h)|0;h=c[l>>2]|0;g=(c[24826]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{fe[c[24830]&255](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{fe[c[24830]&255](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[24826]|0)==0){break}fe[c[24830]&255](43)}else{fe[c[24830]&255](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){fe[c[24830]&255](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){fe[c[24830]&255](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{fe[c[24830]&255](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function nda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;fe[c[24830]&255](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function oda(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;fe[c[24830]&255](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;fe[c[24830]&255](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function pda(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=gda(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=gda(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[24846]|0;c[24846]=0;p=(e|0)==0?4:e+2|0;e=hda(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{fe[c[24830]&255](32);f=f+1|0;}while((f|0)<(p|0))}c[24846]=o;n=e;i=j;return n|0}function qda(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{fe[c[24830]&255](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;fe[c[24830]&255](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;fe[c[24830]&255](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){fe[c[24830]&255](a[105136+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){fe[c[24830]&255](a[105136+((d[p]|0)>>>4)|0]|0);fe[c[24830]&255](a[105136+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function rda(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 12:{f=tda(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[24842]=(c[24842]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 11:{f=sda(c[a+8>>2]|0)|0;i=b;return f|0};case 5:{f=Ce[c[24838]&7]()|0;i=b;return f|0};case 13:{g=(c[24842]|0)-(c[a+4>>2]|0)|0;h=0-(c[24840]|0)|0;c[24842]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 15:{c[24842]=(c[a+4>>2]|0)+ -1-(c[24840]|0);f=1;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;wd(f|0,105104,d|0)|0;vca(c[24766]|0,1)}}return 0}function sda(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[24842]|0)!=0){e=kda()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}fe[c[24830]&255](e<<24>>24);n=b}else{fe[c[24830]&255](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function tda(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[24842]|0)!=0){f=kda()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;fe[c[24830]&255](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function uda(){var a=0,b=0;a=i;b=Yca(10)|0;c[24842]=0;c[24840]=0;c[24844]=0;i=a;return(b|0)==0|0}function vda(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[24816]|0)==0){Hca()}c[24780]=0;c[24786]=1;c[24794]=1;c[24804]=1;d=cda(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[24822]=a;c[24840]=0;c[24842]=0;c[24844]=0;c[26094]=0;c[24846]=0;d=c[a+12>>2]|0;c[24766]=d;c[24818]=c[c[23540]>>2];if((Kca(d)|0)<0){if((c[a>>2]|0)==0){Gca(100,105184);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[24830]=184;c[24832]=44;c[24834]=113;c[24820]=4;c[24836]=5;c[24838]=6;Pca();c[24826]=0;d=c[23540]|0;c[24828]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((Ica(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){Gca(f,105192);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function wda(){var a=0,b=0;a=i;if((c[26094]|0)==0){b=Yca(10)|0}else{Yca(0)|0;ud(c[24818]|0)|0;b=0}c[24842]=0;c[24840]=0;c[24844]=0;i=a;return b|0}function xda(){var a=0,b=0,d=0;a=i;if((c[26078]|0)==0){b=0}else{d=Yca(10)|0;c[26078]=0;b=d}c[24842]=0;c[24840]=0;c[24844]=0;i=a;return b|0}



function qS(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=NR(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=tR(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=NR(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((wS(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=He[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=xe[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}He[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=_R(k,b,v,w+(xe[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=WR(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=cS(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=RR(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=RR(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=xe[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(NR(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((KR(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((KR(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((KR(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ie[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;wpa(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}fe[c[k+20>>2]&255](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;wpa(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;wpa(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function rS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case-15:{k=3;break a;break};case-2:{k=18;break a;break};case 0:{k=14;break a;break};case 13:{if((kS(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-1:{k=15;break a;break};case 11:{if((jS(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 15:{if((c[j+80>>2]|0)==0){break b}IR(j,c[j+144>>2]|0,b,c[h>>2]|0);break};case-4:{k=7;break a;break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){IR(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}function sS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=He[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case-4:case-1:{r=28;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ee[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}IR(o,b,c[k>>2]|0,c[l>>2]|0);break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}IR(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ee[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ce[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ee[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case 0:{r=24;break a;break};case-2:{r=25;break a;break};case 40:{r=6;break a;break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==3){r=33;break}else if((h|0)==2){r=34;break}}if((r|0)==6){n=o;do{if((c[o+76>>2]|0)!=0){fe[c[n+76>>2]&255](c[o+4>>2]|0)}else{if((c[n+80>>2]|0)==0){break}IR(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function tS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=sS(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=uS(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=YR(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function uS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=nS(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((vS(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function vS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=xe[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}wpa(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function wS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((KR(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((KR(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=NR(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function xS(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(He[c[b+16>>2]&63](b,f,g,l)|0){case-1:{o=7;break a;break};case 7:case 39:{o=31;break};case-4:{o=3;break a;break};case 10:{p=xe[c[b+44>>2]&63](b,f)|0;if((p|0)<0){o=11;break a}do{if(!(e<<24>>24!=0)){if((p|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);p=ES(p,m)|0;if((p|0)==0){o=19;break a}q=0;while(1){if((q|0)>=(p|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((KR(h)|0)<<24>>24!=0)){o=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case 9:{q=(le[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((KR(h)|0)<<24>>24!=0)){o=42;break a}}p=h+12|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=q;break b}q=WR(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){o=44;break a}r=NR(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){o=57;break a}if((a[r+34|0]|0)==0){o=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){o=62;break a}if((c[r+28>>2]|0)!=0){o=66;break a}if((c[r+4>>2]|0)==0){o=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=xS(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){o=74;break a}break};case 0:{o=4;break a;break};case 6:{if((aS(h,b,f,c[l>>2]|0)|0)==0){o=29;break a}break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);o=31;break};default:{o=75;break a}}}while(0);do{if((o|0)==31){o=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((KR(h)|0)<<24>>24!=0)){o=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((o|0)==3){z=0;A=z;i=k;return A|0}else if((o|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((o|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((o|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((o|0)==27){z=1;A=z;i=k;return A|0}else if((o|0)==29){z=1;A=z;i=k;return A|0}else if((o|0)==37){z=1;A=z;i=k;return A|0}else if((o|0)==42){z=1;A=z;i=k;return A|0}else if((o|0)==44){z=1;A=z;i=k;return A|0}else if((o|0)==57){z=11;A=z;i=k;return A|0}else if((o|0)==59){z=24;A=z;i=k;return A|0}else if((o|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((o|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((o|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((o|0)==74){z=y;A=z;i=k;return A|0}else if((o|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function yS(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((le[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=FS()|0;c[g+240>>2]=ie[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=He[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){fe[c[f+1032>>2]&255](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}fe[c[f+1032>>2]&255](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function zS(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=Cpa()|0;i=a;return b|0}function AS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=SR(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=TR(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function BS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ie[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{CS(f+80|0,e);CS(b+104|0,e);DS(b,e);DS(b+20|0,e);DS(b+40|0,e);DS(b+60|0,e);a[b+131|0]=0;DS(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function CS(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function DS(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function ES(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function FS(){i=i;return 1912}function GS(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[33120+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[33196+l|0]|0|0)!=28){if((d[33196+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[33196+q|0]|0|0)!=28){if((d[33196+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[33196+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((HS(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[27288+(((d[27032+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[27288+(((d[28568+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=ES(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=14;c[h+64>>2]=15;n=h;o=n;i=j;return o|0}return 0}function HS(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 0:{if((d[33196+c|0]|0|0)!=0){e=7;break a}f=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){e=7;break a}f=-1;break};case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{f=-1;break};default:{e=7}}}while(0);if((e|0)==7){f=c}i=b;return f|0}function IS(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[27288+(((d[28568+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function JS(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[27288+(((d[27032+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function KS(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=xe[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(HS(a)|0)<0;g=f&1;i=d;return g|0}function LS(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=ES(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function MS(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function NS(){i=i;return 32752}function OS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=PS(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=21;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function PS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((bT(d,c[32656+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function QS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$U(31096,a,0,b,c,d)|0;i=e;return f|0}function RS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$U(31096,a,1,b,c,d)|0;i=e;return f|0}function SS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;yU(31864,b,c,d);i=a;return}function TS(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=US(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function US(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(aV(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,32600)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((aV(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,32608)|0)!=0){h=bV(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=le[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((aV(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,32624)|0)!=0){if((a|0)!=0){break}do{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,32640)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,32648)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((cV(bV(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function VS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((bT(h,28824)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=PS(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[31096+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function WS(){i=i;return 30728}function XS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=PS(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=21;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function YS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$U(28832,a,0,b,c,d)|0;i=e;return f|0}function ZS(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=$U(28832,a,1,b,c,d)|0;i=e;return f|0}function _S(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=US(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function $S(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((bT(h,28824)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=PS(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[28832+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function aT(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=GS(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function bT(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function cT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 13:{k=FT(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;n=18;o=77;break a}if((c[27288+((d[28568+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;n=19;o=77;break};case 10:case 21:{o=25;break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 12:{k=FT(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{n=19;b=b+2|0;o=77;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=tT(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{k=BT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 16:{k=GT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 24:case 22:{n=18;b=b+2|0;o=77;break};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[g]|0)|0]|0}else{q=tT(a[g+1|0]|0,a[b]|0)|0}switch(q|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:{k=vT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 19:{k=HT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}q=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[q]|0)|0]|0}else{s=tT(a[q+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=tT(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 34:{o=116;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=85;break b;break};case 7:{o=91;break b;break};case 23:{b=b+2|0;r=n;if((r|0)==41){n=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}n=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=tT(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 5:{o=105;break b;break};case 7:{o=111;break b;break};case 6:{o=108;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};default:{n=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 6:{o=88;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 33:{o=119;break b;break};case 15:{o=122;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=n;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((n|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-n|0;l=k;i=h;return l|0}}return 0}function dT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 3:{k=uT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=yT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=tT(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=tT(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 7:{r=b;if((e-b|0)<4){p=55;break b}b=r+4|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=52;break b}b=s+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=49;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function eT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=tT(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=tT(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{r=b;if((e-b|0)<4){p=53;break b}b=r+4|0;continue b;break};case 6:{s=b;if((e-b|0)<3){p=50;break b}b=s+3|0;continue b;break};case 5:{t=b;if((e-b|0)<2){p=47;break b}b=t+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function fT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=tT(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function gT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=tT(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 21:{n=29;break a;break};case 9:{n=19;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 2:{n=15;break a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=uT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=tT(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function hT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=tT(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};case 3:{n=12;break a;break};case 7:{b=b+4|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=uT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=vT(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=tT(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function iT(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=tT(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};case 6:{k=8;break};case 5:{break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=tT(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function jT(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function kT(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=tT(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};default:{break a}}}i=e;return b-c|0}function lT(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=tT(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function mT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=tT(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=tT(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function nT(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=HS(c)|0;k=j;i=b;return k|0}function oT(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==103){g=62;h=g;i=b;return h|0}else if((f|0)==108){g=60;h=g;i=b;return h|0}else{break}}else if((c|0)==4){if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else if((j|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}}while(0);g=0;h=g;i=b;return h|0}function pT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=tT(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=tT(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function qT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=tT(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function rT(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function sT(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function tT(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 219:case 218:case 217:case 216:{d=7;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 223:case 222:case 221:case 220:{d=8;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function uT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=wT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=tT(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function vT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=tT(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=32;break b;break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function wT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=xT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=tT(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function xT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=tT(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=tT(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function yT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 17:{k=CT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 15:{k=BT(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=tT(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=zT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=AT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=tT(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 17:{break b;break};case 7:{o=45;break b;break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=tT(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 24:case 22:{break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};case 5:{o=59;break b;break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 5:{o=39;break b;break};case 11:{o=90;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{o=69;break b;break};case 6:{o=42;break b;break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=tT(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 17:{break c;break};case 5:{o=78;break d;break};case 11:{o=90;break c;break};case 29:{o=75;break d;break};case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 10:case 9:case 21:{break};case 24:case 22:{break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=DT(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function zT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=tT(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function AT(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[29232+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function BT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=tT(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=tT(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 15:{p=62;break b;break};case 5:{p=28;break b;break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 7:{p=34;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 10:case 9:case 21:{p=37;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((ET(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=tT(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((ET(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function CT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=tT(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 23:{b=b+2|0;continue b;break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 11:{n=48;break b;break};case 6:{n=31;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=tT(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function DT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=tT(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=tT(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 24:case 22:{break};case 5:{l=30;break a;break};case 6:{l=33;break a;break};case 7:{l=36;break a;break};case 29:{if((c[27288+((d[27032+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=tT(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 5:{l=10;break a;break};case 6:{l=13;break a;break};case 29:{if((c[27288+((d[28568+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 7:{l=16;break a;break};case 14:{break};case 27:case 26:case 25:case 24:case 22:{l=9;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=tT(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=tT(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 2:{l=79;break a;break};case 3:{t=uT(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=tT(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 17:{l=107;break a;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=tT(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 24:case 22:{break d;break};case 7:{l=103;break a;break};case 6:{l=100;break a;break};case 17:{l=107;break a;break};case 5:{l=97;break a;break};case 29:{l=94;break d;break};case 10:case 9:case 21:{break};case 11:{l=106;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[27288+((d[27032+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function ET(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function FT(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=tT(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=tT(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function GT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=tT(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 24:case 22:{break};case 30:{n=16;break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=tT(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==27){k=zT(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function HT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=tT(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[27288+((d[27032+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=tT(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 7:{n=34;break b;break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 29:{if((c[27288+((d[28568+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function IT(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=tT(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=tT(a[g]|0,a[b+1|0]|0)|0}switch(n|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 29:{g=b;if((c[27288+((d[27032+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;o=18;p=77;break a}if((c[27288+((d[28568+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=76;break a}b=b+2|0;o=19;p=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 13:{k=iU(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{o=18;b=b+2|0;p=77;break};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{o=19;b=b+2|0;p=77;break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){q=d[j+76+(d[g+1|0]|0)|0]|0}else{q=tT(a[g]|0,a[b+1|0]|0)|0}switch(q|0){case 16:{k=jU(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=eU(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 10:case 21:{p=25;break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=iU(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=_T(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+2|0)!=(e|0)){p=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 19:{k=kU(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{p=76}}}while(0);if((p|0)==25){while(1){p=0;b=b+2|0;r=b;if((b|0)==(e|0)){p=32;break}q=b;if((a[r]|0)==0){s=d[j+76+(d[q+1|0]|0)|0]|0}else{s=tT(a[q]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){p=25;continue}else if((s|0)!=9){p=31;break}if((b+2|0)!=(e|0)){p=25}else{p=31;break}}if((p|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((p|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((p|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==77){b:while(1){p=0;if((b|0)==(e|0)){p=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=tT(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 34:{p=116;break b;break};case 23:{b=b+2|0;r=o;if((r|0)==41){o=19;p=77;continue b}else if((r|0)!=18){p=77;continue b}if((b|0)==(e|0)){p=97;break b}o=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=tT(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 5:{p=105;break b;break};case 7:{p=111;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=103;break b}break};case 6:{p=108;break b;break};default:{o=19;p=77;continue b}}b=b+2|0;p=77;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{p=94;break b;break};case 7:{p=91;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{p=88;break b;break};case 5:{p=85;break b;break};case 29:{if((c[27288+((d[28568+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=83;break b}break};case 33:{p=119;break b;break};case 15:{p=122;break b;break};default:{p=125;break b}}b=b+2|0;p=77}if((p|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==94){c[f>>2]=b;k=o;l=k;i=h;return l|0}else if((p|0)==97){k=-1;l=k;i=h;return l|0}else if((p|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((p|0)==116){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((p|0)==119){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((p|0)==122){e=b;if((o|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((p|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((p|0)==126){k=0-o|0;l=k;i=h;return l|0}}return 0}



function XX(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==0){c[11542]=2;C=2;while(1){D=C+1|0;if(!((c[k+(C+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[11542]=D;if((D|0)<12){C=D}else{break}}if((c[d>>2]|0)<1){Bca(46224,47920,80,25);C=46528;D=46536;WX(46224,47952,46704,C,46608,d,C,C,D,D,80)|0;break}c[11606]=5;D=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{C=c[D>>2]|0;c[11606]=C;if(!((C+ -1|0)>>>0>4)){E=C;break}Bca(46224,47960,80,34);C=46528;F=46536;WX(46224,48e3,46696,C,46608,46424,C,C,F,F,80)|0;break a}}while(0);c[D>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;C=fa(F,F)|0;c[11592]=C;c[11604]=C+50+(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0);C=q+12|0;if((c[k+16>>2]|0)==0){c[C>>2]=2;break}else{c[C>>2]=1;break}}else{C=c[q>>2]|0;do{if((C|0)>=0){F=c[d>>2]|0;if((C|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){Bca(46224,48784,80,52);I=46528;J=46536;WX(46224,48768,48840,I,46608,G,I,I,J,J,80)|0;break a}c[11592]=fa((C<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[D>>2]|0)+4|0,H)|0;c[11604]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[11592]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[D>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[11604]=F+(c[11592]|0);break b}}}while(0);Bca(46224,48712,80,52);C=46528;F=46536;WX(46224,48768,48776,C,46608,q,C,C,F,F,80)|0;break a}}while(0);c[11596]=(c[d>>2]|0)+20;c[q+64>>2]=c[11592];if((c[p>>2]|0)<(c[11604]|0)){Bca(46224,48008,80,60);D=46528;F=46536;WX(46224,48072,48080,D,46704,46416,p,D,F,F,80)|0;break}if((c[r>>2]|0)<(c[11596]|0)){Bca(46224,48088,80,60);F=46528;D=46536;WX(46224,48072,48152,F,46704,46384,r,F,D,D,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){Bca(46224,48896,80,24);D=46608;F=46528;C=46536;WX(46224,48928,48936,D,D,w,F,F,C,C,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[5793]=K;if(!(K<=0.0)){break}Bca(46224,48392,80,28);C=46528;WX(46224,47104,48424,C,C,C,C,46608,46344,46536,80)|0;break a}}while(0);c[q+60>>2]=0;C=q+36|0;c[C+0>>2]=0;c[C+4>>2]=0;c[C+8>>2]=0;c[C+12>>2]=0;c[n>>2]=1;B=27}else if((A|0)==-1){Bca(46224,46456,80,49);C=46528;F=46536;WX(46224,46512,46520,C,C,C,C,C,F,F,80)|0;Bca(46224,46544,80,47);F=46528;C=46536;WX(46224,46592,46600,F,46608,n,F,F,C,C,80)|0;Bca(46224,46616,80,41);C=46528;F=46536;WX(46224,46664,46672,46608,C,C,C,C,F,F,80)|0;i=y;return 0}else{B=210}}while(0);c:do{if((B|0)==27){a[46400]=0;K=+h[l>>3];h[5804]=K;L=+h[m>>3];h[5797]=L;A=c[d>>2]|0;c[11542]=1;do{if((A|0)>=1){r=k+4|0;p=0;E=1;M=L;N=K;while(1){if((c[r>>2]|0)==1){F=E+ -1|0;O=+h[l+(F<<3)>>3];h[5804]=O;P=+h[m+(F<<3)>>3];h[5797]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[46400]=1;S=1}else{S=p}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}F=E+1|0;c[11542]=F;if((E|0)<(A|0)){p=S;E=F;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}E=c[d>>2]|0;p=E+51|0;c[11552]=p;r=p+(c[w>>2]|0)|0;c[11554]=r;p=r+(c[w>>2]|0)|0;c[11576]=p;F=p+(c[w>>2]|0)|0;c[11546]=F;C=F+(c[d>>2]|0)|0;c[11582]=C;D=C+(c[d>>2]|0)|0;c[11588]=D;c[11578]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+D;c[11602]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){C=o+64|0;h[5806]=+h[C>>3];a[46336]=0;h[5775]=+h[o+24>>3];J=o+16|0;h[5770]=+h[J>>3];do{if((c[w>>2]|0)!=0){YX(46704,v,w,d,46200,j,f,o+(F+ -1<<3)|0,o+(D+ -1<<3)|0,o+224|0,q+28|0,o+(E+50<<3)|0,o+(r+ -1<<3)|0,o+(p+ -1<<3)|0,x,46320,C,0,o,q,s,t)|0;if((c[11672]|0)>0){i=y;return 0}if((c[11580]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=46608;tY(d,o+((c[11546]|0)+ -1<<3)|0,G,g,G)|0;a[46336]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[5770];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[5770]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[5770];if((M-N)*P>0.0){B=220;break}C=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[5805]=O;U=+h[5775];V=U-O;G=V*P>0.0;do{if(C){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[11588]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){bY(46200,j,f,g,d,H,I,X)|0;if((c[11672]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[46336]=1;B=197;break d}}else{Y=46200;bY(Y,Y,f,g,d,H,I,X)|0;if((c[11672]|0)>0){i=y;return 0}else{h[e>>3]=+h[5775];c[n>>2]=1;a[46336]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}bY(46200,j,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[46336]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[5806]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[5770]=W;h[J>>3]=W;break}bY(46200,46440,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[5805];a[46336]=1;B=197;break d}}else{W=+h[5775];if(!C){if(P*(W-N)<0.0){break}bY(46200,j,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[46336]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[11588]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){bY(46200,j,f,g,d,G,X,I)|0;if((c[11672]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[46336]=1;B=197;break d}}else{H=46200;bY(H,H,f,g,d,G,X,I)|0;if((c[11672]|0)>0){i=y;return 0}else{h[e>>3]=+h[5775];c[n>>2]=1;a[46336]=1;B=197;break d}}}}while(0);if(a[46336]&1){B=197}else{B=128}}else{h[5775]=+h[e>>3];c[n>>2]=1;_X(d,k+4|0,l,m,f,o+((c[11582]|0)+ -1<<3)|0,s,t)|0;C=c[d>>2]|0;c[11542]=1;e:do{if((C|0)>=1){J=c[11582]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[11542]=X;if((I|0)<(C|0)){I=X}else{break e}}Bca(46224,48528,80,39);I=46528;J=46536;WX(46224,48200,48568,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+fY(46680,1);h[5806]=U;C=o+64|0;h[C>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[5806]*4.0*(aa>=ba?aa:ba);h[5795]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){Bca(46224,48576,80,60);J=46528;WX(46224,48072,48640,J,J,J,J,46704,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[5774]=ca*.001;U=+$X(d,g,o+((c[11582]|0)+ -1<<3)|0,s,t);if(U>.5/+h[5774]){h[5774]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+yca(46192,z);h[5774]=U;da=U}else{U=+h[o+16>>3];h[5774]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}Bca(46224,48480,80,29);J=46528;I=46536;WX(46224,48512,48520,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[5774]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[5805]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[5774]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{aY(46200,f,g,d,b,u,46192,o+((c[11582]|0)+ -1<<3)|0,n,s,t,o+((c[11588]|0)+ -1<<3)|0,o+400|0,o+((c[11546]|0)+ -1<<3)|0,o+((c[11578]|0)+ -1<<3)|0,q,46360,C,k+36|0,46408)|0;if((c[11672]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[5774]}h[5770]=ja;h[o+16>>3]=ja;J=c[11588]|0;X=(c[d>>2]|0)+J|0;c[11598]=X;G=c[d>>2]|0;c[11542]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[5770]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[11542]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[5770];h[o+232>>3]=+h[5770]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}YX(46608,v,w,d,e,j,f,o+((c[11546]|0)+ -1<<3)|0,o+((c[11588]|0)+ -1<<3)|0,J,Y,o+((c[11552]|0)+ -1<<3)|0,o+((c[11554]|0)+ -1<<3)|0,o+((c[11576]|0)+ -1<<3)|0,x,46320,C,0,o,q,s,t)|0;if((c[11672]|0)>0){i=y;return 0}if((c[11580]|0)!=0){Bca(46224,48944,80,47);la=46528;ma=46536;WX(46224,46592,48992,46608,la,la,la,la,ma,ma,80)|0;Bca(46224,49e3,80,38);ma=46528;la=46536;WX(46224,46752,48992,46608,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}YX(46696,v,w,d,46200,j,f,o+((c[11546]|0)+ -1<<3)|0,o+((c[11588]|0)+ -1<<3)|0,J,Y,o+((c[11552]|0)+ -1<<3)|0,o+((c[11554]|0)+ -1<<3)|0,o+((c[11576]|0)+ -1<<3)|0,x,46320,C,0,o,q,s,t)|0;if((c[11672]|0)>0){i=y;return 0}if((c[11580]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=46608;tY(d,o+((c[11546]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){Bca(46224,48320,80,54);p=46528;WX(46224,48376,48384,p,p,p,p,46704,46440,j,80)|0;break c}else if((B|0)==220){Bca(46224,48432,80,34);p=46528;WX(46224,48e3,48472,p,p,p,p,46704,j,e,80)|0;break c}else if((B|0)==224){Bca(46224,48648,80,49);p=46528;WX(46224,46512,48704,p,p,p,p,46704,46440,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;_X(d,oa,l,m,o+((c[11588]|0)+ -1<<3)|0,o+((c[11582]|0)+ -1<<3)|0,s,t)|0;if((c[11672]|0)>0){B=233;break}p=c[d>>2]|0;c[11542]=1;r=c[11582]|0;if((p|0)>=1){E=1;while(1){D=E+1|0;if(!(+h[o+(E+ -2+r<<3)>>3]>0.0)){B=136;break f}c[11542]=D;if((E|0)<(p|0)){E=D}else{break}}}O=+$X(d,o+((c[11588]|0)+ -1<<3)|0,o+(r+ -1<<3)|0,s,t)*100.0;V=+h[5806];pa=O*V;h[5772]=pa;if(!(pa<=1.0)){B=138;break}O=+h[5775];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[5795]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[5770];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[5770]=V/O}}while(0);cY(46200,f,g,d,b,u,46160,o+((c[11582]|0)+ -1<<3)|0,k,n,s,t,o+((c[11588]|0)+ -1<<3)|0,o+400|0,o+((c[11546]|0)+ -1<<3)|0,o+((c[11578]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,46360,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,46408)|0;if((c[11672]|0)>0){B=233;break}r=c[n>>2]|0;if((r|0)<0){na=r;break}do{if((c[w>>2]|0)!=0){YX(46696,v,w,d,46200,j,f,o+((c[11546]|0)+ -1<<3)|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[11552]|0)+ -1<<3)|0,o+((c[11554]|0)+ -1<<3)|0,o+((c[11576]|0)+ -1<<3)|0,x,46320,o+64|0,0,o,q,s,t)|0;if((c[11672]|0)>0){B=233;break f}if((c[11580]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];r=46608;tY(d,o+((c[11546]|0)+ -1<<3)|0,r,g,r)|0;B=197;continue f}}while(0);r=(c[k+8>>2]|0)!=0;O=+h[5775];V=+h[5770];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!r){if(U<0.0){B=128;continue}bY(46200,j,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}bY(46200,j,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(r){if(U>=0.0){bY(46200,j,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[5805];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[5806]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}bY(46200,46440,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[5805];B=197;continue}if(!(U<0.0)){bY(46200,j,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[5805];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[5806]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[5770]=U-O;B=128;continue}else{bY(46200,46440,f,g,d,q+28|0,o+((c[11588]|0)+ -1<<3)|0,o+224|0)|0;if((c[11672]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[5805];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[5775];h[o+16>>3]=+h[5770];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[5772]*+h[m>>3];c[n>>2]=-2;na=-2;break}r=c[d>>2]|0;c[11542]=1;if((r|0)>=1){O=pa;E=1;p=0;while(1){C=l+(p<<3)|0;h[C>>3]=O*+h[C>>3];C=m+(E+ -1<<3)|0;h[C>>3]=+h[5772]*+h[C>>3];if((E|0)>=(r|0)){break}C=E;O=+h[5772];E=E+1|0;p=C}c[11542]=r+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);p=0-na|0;c[11598]=p;switch(p|0){case 2:{Bca(46224,46840,80,47);p=46528;WX(46224,46592,46888,p,p,p,p,46608,46200,46536,80)|0;Bca(46224,46896,80,48);p=46528;E=46536;WX(46224,46824,46952,p,p,p,p,p,E,E,80)|0;Bca(46224,46960,80,45);E=46528;p=46536;WX(46224,47008,47016,E,E,E,E,E,p,p,80)|0;break};case 3:{Bca(46224,47024,80,38);p=46528;WX(46224,46752,47064,p,p,p,p,46608,46200,46536,80)|0;Bca(46224,47072,80,28);p=46528;E=46536;WX(46224,47104,47112,p,p,p,p,p,E,E,80)|0;break};case 6:{Bca(46224,47120,80,44);E=46528;WX(46224,47168,47176,E,E,E,E,46704,46200,46160,80)|0;Bca(46224,47184,80,57);E=46528;p=46536;WX(46224,47248,47256,E,E,E,E,E,p,p,80)|0;break};case 7:{Bca(46224,47120,80,44);p=46528;WX(46224,47168,47264,p,p,p,p,46704,46200,46160,80)|0;Bca(46224,47272,80,48);p=46528;E=46536;WX(46224,46824,47328,p,p,p,p,p,E,E,80)|0;Bca(46224,47336,80,28);E=46528;p=46536;WX(46224,47104,47368,E,E,E,E,E,p,p,80)|0;break};case 8:{Bca(46224,47120,80,44);p=46528;WX(46224,47168,47376,p,p,p,p,46704,46200,46160,80)|0;Bca(46224,47384,80,37);p=46528;E=46536;WX(46224,47424,47432,p,p,p,p,p,E,E,80)|0;break};case 9:{Bca(46224,47120,80,44);E=46528;WX(46224,47168,47440,E,E,E,E,46704,46200,46160,80)|0;Bca(46224,47448,80,49);E=46528;p=46536;WX(46224,46512,47504,E,E,E,E,E,p,p,80)|0;Bca(46224,47512,80,38);p=46528;E=46536;WX(46224,46752,47552,p,p,p,p,p,E,E,80)|0;break};case 10:{Bca(46224,47120,80,44);E=46528;WX(46224,47168,47560,E,E,E,E,46704,46200,46160,80)|0;Bca(46224,47568,80,45);E=46528;p=46536;WX(46224,47008,47616,E,E,E,E,E,p,p,80)|0;Bca(46224,47624,80,36);p=46528;E=46536;WX(46224,47664,47672,p,p,p,p,p,E,E,80)|0;break};case 11:{Bca(46224,47680,80,40);E=46528;WX(46224,47728,47736,E,E,E,E,46704,46200,46160,80)|0;Bca(46224,47744,80,36);E=46528;p=46536;WX(46224,47664,47784,E,E,E,E,E,p,p,80)|0;break};case 12:{Bca(46224,47120,80,44);p=46528;WX(46224,47168,47792,p,p,p,p,46704,46200,46192,80)|0;Bca(46224,47800,80,45);p=46528;E=46536;WX(46224,47008,47848,p,p,p,p,p,E,E,80)|0;break};case 5:case 4:{break};default:{Bca(46224,46712,80,38);E=46528;WX(46224,46752,46760,E,E,E,E,46608,46200,46536,80)|0;Bca(46224,46768,80,48);E=46528;p=46536;WX(46224,46824,46832,E,E,E,E,E,p,p,80)|0}}c[k>>2]=-1;h[e>>3]=+h[5775];h[o+24>>3]=+h[5775];h[o+16>>3]=+h[5770];i=y;return 0}else if((B|0)==215){Bca(46224,48160,80,39);p=46528;E=46536;WX(46224,48200,48208,p,p,p,p,p,E,E,80)|0;break c}else if((B|0)==216){Bca(46224,48216,80,39);E=46528;p=46536;WX(46224,48200,48256,E,E,E,E,E,p,p,80)|0;break c}}}while(0);Bca(46224,48264,80,47);A=46528;p=46536;WX(46224,46592,48312,A,A,A,A,A,p,p,80)|0}else if((B|0)==210){Bca(46224,47856,80,55);p=46528;A=46536;WX(46224,47912,46608,p,p,p,p,p,A,A,80)|0}}while(0);if((B|0)==227){Bca(46224,48848,80,39);B=46528;WX(46224,48200,48888,B,B,B,B,46704,j,e,80)|0}if((c[k>>2]|0)==-1){Bca(46224,49040,80,46);e=46528;j=46536;WX(46224,49088,49096,e,e,e,e,e,j,j,80)|0;Bca(46224,49104,80,47);j=46528;e=46536;WX(46224,46592,49152,46608,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function YX(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[6145]=C;c[t>>2]=0;D=c[e>>2]|0;c[12292]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[12292]|0;E=F+1|0;c[12292]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[6152]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;bY(g,b,k,l,f,o,m,n)|0;if((c[11672]|0)>0){i=v;return 0}D=d;be[D&7](f,b,k,e,p,y,z)|0;if((c[11672]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[49224]=0;F=c[e>>2]|0;c[12292]=1;if((F|0)<1){break}else{J=0;K=1}while(1){I=+h[p+(K+ -1<<3)>>3];if(!(I>=0.0)){L=-I}else{L=I}if(!(L<=0.0)){M=J}else{a[49224]=1;M=1}if((K|0)<(F|0)){J=M;K=K+1|0}else{break}}c[12292]=F+1;if(!M){break}I=+yca(49216,49160);h[6149]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[6145];do{if((H- +h[g>>3])*I<0.0){bY(g,b,k,l,f,o,m,n)|0;if((c[11672]|0)<=0){break}i=v;return 0}else{G=+h[6149]/I;h[6150]=G;N=c[f>>2]|0;c[12292]=1;if((N|0)<1){break}O=(A<<1)+B|0;P=G;Q=1;while(1){R=k+(Q+ -1<<3)|0;h[R>>3]=+h[R>>3]+P*+h[m+(O+Q<<3)>>3];if((Q|0)>=(N|0)){break}P=+h[6150];Q=Q+1|0}c[12292]=N+1}}while(0);be[D&7](f,b,k,e,p,y,z)|0;if((c[11672]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[49224]=0;F=c[e>>2]|0;c[12292]=1;if((F|0)<1){break}else{S=0;T=1}while(1){Q=T+ -1|0;I=+h[p+(Q<<3)>>3];if(!(I>=0.0)){U=-I}else{U=I}if(U>0.0){V=S;W=T}else{c[s+(Q<<2)>>2]=1;a[49224]=1;V=1;W=c[12292]|0}Q=W+1|0;c[12292]=Q;if((W|0)<(F|0)){S=V;T=Q}else{break}}if(!V){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{X=+h[6145];Y=I;break}}else if((u|0)==3){X=C;Y=+h[g>>3]}else{F=w+320|0;bY(g,F,k,l,f,o,m,n)|0;if((c[11672]|0)>0){i=v;return 0}E=d;be[E&7](f,F,k,e,p,y,z)|0;if((c[11672]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[49224]=0;D=c[e>>2]|0;c[12292]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[49224]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[12292]=D+1;if(!aa){i=v;return 0}I=+yca(49216,49160);h[6149]=I;h[F>>3]=I+ +h[F>>3];I=+h[6149]/+h[6145];h[6150]=I;Q=c[f>>2]|0;c[12292]=1;if((Q|0)>=1){O=(A<<1)+B|0;H=I;R=1;while(1){ba=k+(R+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(O+R<<3)>>3];if((R|0)>=(Q|0)){break}H=+h[6150];R=R+1|0}c[12292]=Q+1}be[E&7](f,F,k,e,p,y,z)|0;if((c[11672]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[49224]=0;R=c[e>>2]|0;c[12292]=1;if((R|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[49224]=1;fa=1}if((da|0)<(R|0)){ca=fa;da=da+1|0}else{break}}c[12292]=R+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-Y)*X>=0.0)){h[6148]=ea;if((ea- +h[w+320>>3])*X<=0.0){i=v;return 0}bY(g,49184,k,l,f,o,m,n)|0;if((c[11672]|0)<=0){break}i=v;return 0}else{h[6148]=Y;j=c[f>>2]|0;c[12292]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[12292]=j+1}}while(0);ga=d;be[ga&7](f,49184,k,e,q,y,z)|0;if((c[11672]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[12302]=0;R=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){ZX(e,49216,49208,R,49184,p,q,r,49176,s,fa,da,x,ca)|0;if((c[11672]|0)>0){ha=76;break}if((c[12302]|0)>1){ha=73;break}bY(g,49176,k,l,f,o,m,n)|0;if((c[11672]|0)>0){ha=76;break}be[ga&7](f,49176,k,e,r,y,z)|0;if((c[11672]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[R>>3]=+h[6147];R=46608;tY(e,r,R,p,R)|0;if((c[12302]|0)==4){i=v;return 0}bY(g,49176,k,l,f,o,m,n)|0;if((c[11672]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function ZX(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[12318]=c[o>>2];c[o>>2]=0;h[6155]=0.0;a[49256]=0;t=c[b>>2]|0;c[12308]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+yca(49288,j+(v<<3)|0);if(w==+yca(49288,l+((c[12308]|0)+ -1<<3)|0)){break}y=c[12308]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[6155]){break}h[6155]=B;c[o>>2]=y}else{a[49256]=1}}while(0);v=c[12308]|0;u=v+1|0;c[12308]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[49264]=1;c[12320]=c[p>>2];h[g>>3]=+h[r>>3];t=46608;tY(b,l,t,k,t)|0;c[p>>2]=1;a[49248]=0;C=0}else{a[49264]=0;c[o>>2]=c[12318];c[12320]=c[p>>2];if(a[49256]&1){h[g>>3]=+h[r>>3];t=46608;tY(b,l,t,k,t)|0;a[49248]=1;C=1;break}else{t=46608;tY(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[49248]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[49248]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=46608;tY(b,k,t,l,t)|0;t=c[b>>2]|0;c[12308]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[12308]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+yca(49288,j+(u<<3)|0);if(!(A!=+yca(49288,k+((c[12308]|0)+ -1<<3)|0))){break}c[n+((c[12308]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[12308]|0;F=u+1|0;c[12308]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[6155]=0.0;a[49256]=0;t=c[b>>2]|0;c[12308]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+yca(49288,j+(v<<3)|0);if(A==+yca(49288,k+((c[12308]|0)+ -1<<3)|0)){break}y=c[12308]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[6155]){break}h[6155]=I;c[o>>2]=y}else{a[49256]=1}}while(0);v=c[12308]|0;u=v+1|0;c[12308]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[49264]=t&1;if(t){a[49248]=0;c[12320]=0;c[p>>2]=1;break}if(!(a[49256]&1)){t=46608;tY(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=46608;tY(b,k,t,l,t)|0;t=c[b>>2]|0;c[12308]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[12308]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[12308]|0}u=K+1|0;c[12308]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[12320]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function _X(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[6164]=+h[d>>3];h[6163]=+h[e>>3];j=c[a>>2]|0;c[12324]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[6164]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[6164]=o;h[6163]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[6163];a=l+1|0;c[12324]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function $X(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[6167]=0.0;e=c[a>>2]|0;c[12330]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[6167]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[12330]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[6166]=0.0;e=c[a>>2]|0;c[12330]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[6166]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[12330]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function aY(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[12348]=0;c[12346]=0;c[12352]=0;h[6179]=+h[b>>3];h[6181]=+$X(f,d,l,0,0);C=c[f>>2]|0;c[12336]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[12336]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[6172]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[12336]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[12336]=G+1}a[49440]=1;c[12338]=0;a[49456]=1;c[C>>2]=(c[C>>2]|0)+1;c[12356]=0;be[B&7](b,d,e,q,49424,n,o)|0;b:do{if((c[12356]|0)<0){K=35}else{while(1){if(a[49440]&1){c[E>>2]=(c[E>>2]|0)+1;a[49440]=0;dY(f,b,d,e,q,49376,k,49400,l,r,s,t,g,49424,v,j,n,o,x)|0;h[6171]=1.0e6;if((c[12356]|0)<0|(c[12350]|0)!=0){K=35;break b}c[12352]=0}H=c[f>>2]|0;c[12336]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[12336]=H+1}eY(f,q,s,t)|0;I=c[f>>2]|0;c[12336]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[6172]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[12336]=I+1}N=+$X(f,q,l,0,0);h[6183]=N;if(N<=+h[v>>3]*100.0*+h[6181]){break}J=c[12338]|0;if((J|0)>0){h[z>>3]=N/+h[6184];h[A>>3]=1.0/+(J|0);O=+wca(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[6171]=P;Q=+h[6183];R=P}else{h[6184]=N;Q=N;R=+h[6171]}if(R*Q<=.33){break}J=c[12338]|0;H=J+1|0;c[12338]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[49440]=1}c[C>>2]=(c[C>>2]|0)+1;c[12356]=0;be[B&7](b,d,e,q,49424,n,o)|0;if((c[12356]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[12336]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[12336]=H+1}N=+$X(f,q,l,0,0);h[6183]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[12336]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[6172]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[12336]=J+1}}while(0);if(!(a[49456]&1)){break}H=c[f>>2]|0;c[12336]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[12336]=H+1}N=+$X(f,r,l,0,0);h[6177]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[49456]=0}h[b>>3]=+h[6179];G=c[f>>2]|0;c[12336]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[12336]=G+1}if(a[49456]&1){I=(c[12348]|0)+1|0;c[12348]=I;N=.9/(+h[6177]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[6170]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[12350]|0)!=0){I=(c[12352]|0)+1|0;c[12352]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[12356]|0)>-2)){K=53;break}I=(c[12346]|0)+1|0;c[12346]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function bY(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[12382]=o;p=+h[b>>3]- +h[a>>3];h[6189]=p;a=c[f>>2]|0;c[12374]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[12374]=a+1;q=+h[6189]}h[6185]=1.0;h[6186]=0.0;p=q/+h[k>>3];h[6190]=p;c[12376]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[6186]=u*t+s/+h[a>>3];p=t*s;h[6185]=p;h[6190]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[12374]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[6186]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[6185];g=g+1|0}c[12374]=a+1}g=v+1|0;c[12376]=g;if((v|0)>=(o|0)){break}r=+h[6189];s=+h[6185];t=+h[6190];u=+h[6186];v=g}i=l;return 0}function cY(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[6212]=+h[b>>3];c[12402]=0;c[12410]=0;c[12404]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[6224]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[12398]=(c[I>>2]|0)+1;c[12400]=(c[I>>2]|0)+2;c[12396]=(c[I>>2]|0)+ -1;h[6212]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[12414]=$+1;$=c[12398]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[6215]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[12384]=2;if(($|0)>=2){Y=2;while(1){h[6216]=+h[y+(Y+ -2<<3)>>3];U=+h[6215];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[6216];U=+h[6216]+ +h[k>>3];h[6215]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[12384]=$+1}h[y+($+ -1<<3)>>3]=+h[6215]}h[6222]=0.0;h[6220]=0.0;Y=c[I>>2]|0;c[12384]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[6222]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[6220]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[12384]=Y+1;da=ea}h[6223]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[6222]- +h[6220];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[6197]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[6197]=ha>=ca?ha:ca;h[6215]=.6;h[6216]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[6223]){h[D>>3]=100.0}aa=c[12398]|0;ba=c[12414]|0;if((aa|0)>=(ba|0)){c[12386]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[12384]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[12384]=ba+1}ja=ia+1|0;c[12386]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[12384]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[12384]=ia+1}aa=c[12398]|0;c[12386]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[12384]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[12384]=$+1}la=ba+1|0;c[12386]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[6219]=+$X(f,d,l,0,0);a[49800]=1;c[12388]=0;c[T>>2]=(c[T>>2]|0)+1;c[12418]=0;be[m&7](b,d,e,r,49672,o,p)|0;if((c[12418]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;dY(f,b,d,e,r,A,k,49624,l,s,t,u,g,49672,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[12418]|0)<0|(c[12406]|0)!=0){X=70;break}c[12410]=0}ba=c[f>>2]|0;c[12384]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[12384]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[6215]=ca;aa=c[f>>2]|0;c[12384]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[6215];ia=ia+1|0;la=ka}c[12384]=aa+1}eY(f,r,t,u)|0;la=c[f>>2]|0;c[12384]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[12384]=la+1}U=+$X(f,r,l,0,0);h[6224]=U;if(U<=+h[F>>3]*100.0*+h[6219]){X=63;break a}ia=c[12388]|0;if((ia|0)>0){h[O>>3]=U/+h[6226];h[P>>3]=1.0/+(ia|0);ca=+wca(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[6224];oa=ga}else{h[6226]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[12388]|0;c[12388]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[12418]=0;be[m&7](b,d,e,r,49672,o,p)|0;if((c[12418]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[12384]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[12384]=ba+1}U=+$X(f,r,l,0,0);h[6224]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[12384]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[12384]=ia+1}}while(0);if((X|0)==70){X=0;a[49800]=0}c[H>>2]=1;if(a[49800]&1){U=+$X(f,s,l,0,0);h[6218]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[6204]=ga;h[6211]=ga*+(ba+1|0);h[6206]=ga;c[12420]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[12384]=1;if((ba|0)>=1){aa=fa(c[12398]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[12384]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+$X(f,r,l,0,0);h[6213]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[6221]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[12384]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[12384]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+$X(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[6221];if((sa>=ca?sa:ca)>+h[6211]){break}ta=+h[6213];ua=Y}else{if(!(ga<=+h[6211]*.5)){break}else{ta=U;ua=ka}}c[12420]=ua+ -1;h[6206]=ta}}while(0);if(!(+h[6197]*+h[6218]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[6212];Y=c[12398]|0;ia=c[12414]|0;if((Y|0)>=(ia|0)){c[12386]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[6215]=ca;ia=c[f>>2]|0;c[12384]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[6215];ja=ja+1|0}c[12384]=ia+1}ja=aa+1|0;c[12386]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[12384]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[12384]=Y+1}if(!(a[49800]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[12406]|0)!=0){aa=(c[12410]|0)+1|0;c[12410]=aa;h[6195]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[12418]|0)>-2)){X=146;break}aa=(c[12402]|0)+1|0;c[12402]=aa;h[6195]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[12404]=(c[12404]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[12404]|0;if((aa|0)<=1){ja=c[12420]|0;c[I>>2]=ja;sa=+(ja+1|0);h[6216]=sa;h[O>>3]=+h[6206]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+wca(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[6195]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[12420];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[12434]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[12420]|0;E=c[12396]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[12398];za=+h[k>>3]*2.0;h[6208]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[12396]|0;Ba=c[12420]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[12398]|0)>=(c[K>>2]|0)|(c[12434]|0)==1){Fa=G;break}G=c[f>>2]|0;c[12384]=1;if((G|0)>=1){E=fa(c[12400]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[12384]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+$X(f,r,l,0,0);h[6214]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[6211];E=xa<=za;if(+h[6221]<=(E?xa:za)){Ea=c[12396]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[6211]*.5){Fa=S;break}}S=c[12398]|0;c[I>>2]=S;h[6206]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[6206]=+h[6213];Fa=Ea}h[6208]=+h[k>>3];ya=+(Fa+1|0);h[6216]=ya;h[O>>3]=+h[6206]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+wca(O,P);h[6195]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[6208];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[6195]=xa;za=+h[k>>3]*xa;h[6208]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[6208]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[12384]=1;if((k|0)<1){break}u=fa(c[12400]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[12384]=k+1}}while(0);Ca=c[f>>2]|0;c[12384]=1;if((Ca|0)>=1){J=fa(c[12398]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[12384]=Ca+1}Ca=c[12398]|0;c[12392]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[12386]=P;s=c[f>>2]|0;c[12384]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[12384]=s+1}P=Ha+1|0;c[12392]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[12418]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[12404]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}bY(b,b,d,e,f,I,q,y)|0;i=N;return 0}function dY(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0.0,U=0.0,W=0,X=0.0,Y=0.0,Z=0.0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==2){c[s>>2]=0;c[12476]=0;h[6239]=+V(+(+h[t>>3]));P=c[b>>2]|0;c[12454]=1;b:do{if((P|0)>=1){Q=r;R=1;while(1){S=R+ -1|0;T=+h[e+(S<<3)>>3];h[N>>3]=T;if(!(T>=0.0)){U=-T}else{U=T}W=f+(S<<3)|0;T=+h[l>>3]*+h[W>>3];if(!(T>=0.0)){X=-T}else{X=T}T=U>=X?U:X;Y=+h[n+(S<<3)>>3];if(!(Y>=0.0)){Z=-Y}else{Z=Y}h[6236]=+h[6239]*(T>=Z?T:Z);h[N>>3]=+h[l>>3]*+h[W>>3];T=+yca(49888,N);h[6236]=T;W=(c[12454]|0)+ -1|0;S=e+(W<<3)|0;Y=+h[S>>3];_=T+Y-Y;h[6236]=_;h[6243]=+h[S>>3];$=f+(W<<3)|0;h[6247]=+h[$>>3];h[S>>3]=_+ +h[S>>3];h[$>>3]=+h[j>>3]*+h[6236]+ +h[$>>3];be[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}_=1.0/+h[6236];h[6245]=_;$=c[b>>2]|0;c[12460]=1;S=c[12476]|0;if(($|0)>=1){Y=_;W=1;aa=0;while(1){h[p+(aa+S<<3)>>3]=(+h[o+(aa<<3)>>3]- +h[g+(aa<<3)>>3])*Y;if((W|0)>=($|0)){break}ba=W;Y=+h[6245];W=W+1|0;aa=ba}c[12460]=$+1}c[12476]=S+(c[b>>2]|0);aa=c[12454]|0;W=aa+ -1|0;h[e+(W<<3)>>3]=+h[6243];h[f+(W<<3)>>3]=+h[6247];R=aa+1|0;c[12454]=R;if((aa|0)>=(P|0)){break b}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){ca=42;break}c[12476]=0;P=c[b>>2]|0;if((c[35880>>2]|0)==0){ca=42;break}R=Soa(P*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];tW(14,1,49984,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];tW(14,0,50008,E);tW(14,1,50016,D);c[12458]=0;if((c[b>>2]|0)>0){Q=0;do{Y=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;aa=C+4|0;h[k>>3]=Y;c[aa>>2]=c[k>>2];c[aa+4>>2]=c[k+4>>2];tW(14,0,50024,C);Q=(c[12458]|0)+1|0;c[12458]=Q;}while((Q|0)<(c[b>>2]|0))}fe[c[9094]&255](14);tW(14,1,50080,B);c[12454]=1;if((P|0)>=1){Q=R+1|0;aa=c[12476]|0;W=1;do{ba=p+(W+ -1+aa<<3)|0;h[ba>>3]=+h[j>>3]+ +h[ba>>3];a[R]=0;a[Q]=0;c[12460]=1;ba=aa;da=0;while(1){Y=+h[p+(da+ba<<3)>>3];c[A>>2]=R;ea=A+4|0;h[k>>3]=Y;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];hc(R|0,50064,A|0)|0;ea=c[12460]|0;c[12460]=ea+1;if((ea|0)>=(P|0)){break}ba=c[12476]|0;da=ea}c[z>>2]=R;tW(14,0,50072,z);da=c[12476]|0;ba=c[12454]|0;ea=p+(da+ -1+ba<<3)|0;h[ea>>3]=+h[ea>>3]- +h[j>>3];aa=da+(c[b>>2]|0)|0;c[12476]=aa;W=ba+1|0;c[12454]=W;}while((ba|0)<(P|0))}fe[c[9094]&255](14);fe[c[9094]&255](14);Toa(R);ca=42}else if((O|0)==3){i=y;return 0}else if((O|0)==5){P=q+4|0;W=(c[P>>2]|0)+(c[q>>2]|0)|0;aa=W+1|0;c[12480]=aa;Q=c[b>>2]|0;c[12470]=(W|0)<(Q|0)?aa:Q;Q=c[q>>2]|0;c[12488]=aa+Q;c[12474]=Q+W;W=(c[b>>2]|0)/(aa|0)|0;c[12484]=W+1;aa=c[x>>2]|0;c[12482]=aa+ -1;c[12492]=aa+W;c[s>>2]=0;h[6239]=+V(+(+h[t>>3]));W=c[12470]|0;c[12456]=1;if((W|0)<1){ca=75;break}aa=r;Q=1;while(1){ba=c[b>>2]|0;da=c[12480]|0;c[12462]=Q;ea=(da|0)<0;c:do{if(ea?(Q|0)>=(ba|0):(Q|0)<=(ba|0)){ga=da;ha=Q;ia=Q;while(1){ja=(ia-ha|0)/(ga|0)|0;c[12458]=ja+1;ka=ia+ -1|0;la=e+(ka<<3)|0;h[p+((c[12482]|0)+ja<<3)>>3]=+h[la>>3];ma=f+(ka<<3)|0;h[p+((c[12492]|0)+ja<<3)>>3]=+h[ma>>3];Y=+h[la>>3];h[N>>3]=Y;if(!(Y>=0.0)){na=-Y}else{na=Y}Y=+h[l>>3]*+h[ma>>3];if(!(Y>=0.0)){oa=-Y}else{oa=Y}Y=na>=oa?na:oa;_=+h[n+(ka<<3)>>3];if(!(_>=0.0)){pa=-_}else{pa=_}h[6236]=+h[6239]*(Y>=pa?Y:pa);h[N>>3]=+h[l>>3]*+h[ma>>3];Y=+yca(49888,N);h[6236]=Y;ma=c[12462]|0;ka=ma+ -1|0;la=e+(ka<<3)|0;_=+h[la>>3];T=Y+_-_;h[6236]=T;h[la>>3]=+h[la>>3]+T;la=f+(ka<<3)|0;h[la>>3]=+h[j>>3]*+h[6236]+ +h[la>>3];la=ma+da|0;c[12462]=la;if(!(ea?(la|0)>=(ba|0):(la|0)<=(ba|0))){break c}ga=c[12480]|0;ha=c[12456]|0;ia=la}}}while(0);be[aa&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ba=c[b>>2]|0;ea=c[12480]|0;da=c[12456]|0;c[12462]=da;ia=(ea|0)<0;d:do{if(ia?(da|0)>=(ba|0):(da|0)<=(ba|0)){ha=ea;ga=da;S=da;while(1){$=(S-ga|0)/(ha|0)|0;c[12458]=$+1;la=S+ -1|0;ma=e+(la<<3)|0;h[ma>>3]=+h[p+((c[12482]|0)+$<<3)>>3];T=+h[p+((c[12492]|0)+$<<3)>>3];$=f+(la<<3)|0;h[$>>3]=T;_=+h[ma>>3];h[N>>3]=_;if(!(_>=0.0)){qa=-_}else{qa=_}_=+h[l>>3]*T;if(!(_>=0.0)){ra=-_}else{ra=_}_=qa>=ra?qa:ra;T=+h[n+(la<<3)>>3];if(!(T>=0.0)){sa=-T}else{sa=T}h[6236]=+h[6239]*(_>=sa?_:sa);h[N>>3]=+h[l>>3]*+h[$>>3];_=+yca(49888,N);h[6236]=_;$=c[12462]|0;T=+h[e+($+ -1<<3)>>3];Y=_+T-T;h[6236]=Y;T=1.0/Y;h[6245]=T;la=$-(c[P>>2]|0)|0;ma=(la|0)>1?la:1;c[12464]=ma;la=c[b>>2]|0;ka=(c[q>>2]|0)+$|0;ja=(la|0)<=(ka|0)?la:ka;c[12466]=ja;ta=fa(c[12474]|0,$)|0;ua=ta-(c[q>>2]|0)|0;c[12468]=ua;c[12454]=ma;if((ma|0)<=(ja|0)){ta=~la;la=~ka;ka=~((ta|0)>(la|0)?ta:la);la=(ma|0)>(ka|0)?ma:ka;Y=T;ka=ma;while(1){ma=ka+ -1|0;h[p+(ma+ua<<3)>>3]=(+h[o+(ma<<3)>>3]- +h[g+(ma<<3)>>3])*Y;if((ka|0)>=(ja|0)){break}Y=+h[6245];ka=ka+1|0}c[12454]=la+1}ka=$+ea|0;c[12462]=ka;ja=c[12456]|0;if(!(ia?(ka|0)>=(ba|0):(ka|0)<=(ba|0))){va=ja;break d}ha=c[12480]|0;ga=ja;S=ka}}else{va=da}}while(0);da=va+1|0;c[12456]=da;if((va|0)<(W|0)){Q=da}else{ca=75;break a}}i=y;return 0}else if((O|0)==4){Q=c[q>>2]|0;W=q+4|0;P=c[W>>2]|0;aa=c[b>>2]|0;R=fa(P+1+(Q<<1)|0,aa)|0;c[12454]=1;if((R|0)>=1){da=fa(aa,P+(Q<<1)+1|0)|0;Q=(da|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(R|0)){P=P+1|0}else{break}}c[12454]=Q?2:da+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[12488]=(c[W>>2]|0)+1+(c[q>>2]<<1);ca=75}else{P=c[b>>2]|0;R=fa(P,P)|0;c[12454]=1;if((R|0)!=0){P=(R|0)<1;aa=1;while(1){h[p+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(R|0)){aa=aa+1|0}else{break}}c[12454]=P?2:R+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){ca=42;break}c[12476]=0;aa=c[b>>2]|0;if((c[35880>>2]|0)==0){ca=42;break}W=Soa(aa*20|0)|0;da=M;h[k>>3]=+h[d>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];tW(14,1,49984,M);da=L;h[k>>3]=+h[j>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];tW(14,0,50008,L);tW(14,1,50016,K);c[12458]=0;if((c[b>>2]|0)>0){da=0;do{Y=+h[e+(da<<3)>>3];c[J>>2]=da+1;Q=J+4|0;h[k>>3]=Y;c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];tW(14,0,50024,J);da=(c[12458]|0)+1|0;c[12458]=da;}while((da|0)<(c[b>>2]|0))}fe[c[9094]&255](14);tW(14,1,50040,I);c[12454]=1;if((aa|0)>=1){da=W+1|0;R=c[12476]|0;P=1;do{Q=p+(P+ -1+R<<3)|0;h[Q>>3]=+h[j>>3]+ +h[Q>>3];a[W]=0;a[da]=0;c[12460]=1;Q=R;ba=0;while(1){Y=+h[p+(ba+Q<<3)>>3];c[H>>2]=W;ia=H+4|0;h[k>>3]=Y;c[ia>>2]=c[k>>2];c[ia+4>>2]=c[k+4>>2];hc(W|0,50064,H|0)|0;ia=c[12460]|0;c[12460]=ia+1;if((ia|0)>=(aa|0)){break}Q=c[12476]|0;ba=ia}c[G>>2]=W;tW(14,0,50072,G);ba=c[12476]|0;Q=c[12454]|0;ia=p+(ba+ -1+Q<<3)|0;h[ia>>3]=+h[ia>>3]- +h[j>>3];R=ba+(c[b>>2]|0)|0;c[12476]=R;P=Q+1|0;c[12454]=P;}while((Q|0)<(aa|0))}fe[c[9094]&255](14);fe[c[9094]&255](14);Toa(W);ca=42}}while(0);if((ca|0)==42){lY(p,b,b,q+80|0,m)|0;i=y;return 0}else if((ca|0)==75){rY(p,49952,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function eY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[e+12>>2]|0;if((g|0)==3){i=f;return 0}else if((g|0)==4|(g|0)==5){g=e+4|0;c[12526]=(c[g>>2]|0)+1+(c[e>>2]<<1);sY(d,50104,a,e,g,e+80|0,b,50112)|0;i=f;return 0}else{pY(d,a,a,e+80|0,b,50112)|0;i=f;return 0}return 0}function fY(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[50120]&1)){a[50120]=1;gY(50168,50136,50216,50152,50200,50224,50208,50232)|0;h[6270]=+(c[12542]|0);f=c[12534]|0;h[6266]=+(f|0);if((c[12554]|0)==0){h[6268]=0.0;c[e>>2]=1-f;g=+xca(50160,e)}else{h[6268]=1.0;c[e>>2]=1-f;g=+xca(50160,e)*.5}h[6269]=g;h[6273]=g*+h[6270];h[6272]=+(c[12550]|0);h[6274]=+(c[12552]|0);j=+h[6278];h[6281]=j;k=1.0/+h[6279];if(!(k>=j)){break}h[6281]=k*(g+1.0)}}while(0);if((yY(b,50256,1,1)|0)!=0){g=+h[6269];h[6280]=g;l=g;i=d;return+l}if((yY(b,50264,1,1)|0)!=0){g=+h[6281];h[6280]=g;l=g;i=d;return+l}if((yY(b,50272,1,1)|0)!=0){g=+h[6270];h[6280]=g;l=g;i=d;return+l}if((yY(b,50280,1,1)|0)!=0){g=+h[6273];h[6280]=g;l=g;i=d;return+l}if((yY(b,50288,1,1)|0)!=0){g=+h[6266];h[6280]=g;l=g;i=d;return+l}if((yY(b,50296,1,1)|0)!=0){g=+h[6268];h[6280]=g;l=g;i=d;return+l}if((yY(b,50304,1,1)|0)!=0){g=+h[6272];h[6280]=g;l=g;i=d;return+l}if((yY(b,50312,1,1)|0)!=0){g=+h[6278];h[6280]=g;l=g;i=d;return+l}if((yY(b,50320,1,1)|0)!=0){g=+h[6274];h[6280]=g;l=g;i=d;return+l}if((yY(b,50328,1,1)|0)==0){l=+h[6280];i=d;return+l}else{g=+h[6279];h[6280]=g;l=g;i=d;return+l}return 0.0}function gY(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[50440]&1){q=50808;r=c[12702]|0;c[b>>2]=r;s=50744;t=c[12686]|0;c[d>>2]=t;u=50784;v=c[12696]|0;c[e>>2]=v;w=50792;x=+h[6349];h[f>>3]=x;y=50824;z=c[12706]|0;c[g>>2]=z;A=50872;B=+h[6359];h[j>>3]=B;C=50832;D=c[12708]|0;c[k>>2]=D;E=50880;F=+h[6360];h[l>>3]=F;i=m;return 0}a[50440]=1;h[6350]=0.0;h[6344]=1.0;h[6345]=2.0;hY(50808,50744,50784,50896)|0;h[6340]=+(c[12702]|0);c[n>>2]=0-(c[12686]|0);G=+xca(50720,n);h[6339]=G;h[6349]=G;H=+h[6345];h[6340]=H/3.0;I=+h[6344];J=I*.5;h[6347]=J;K=-J;h[o>>3]=K;h[6361]=+iY(50720,o);L=50888;h[6358]=+iY(L,L);h[o>>3]=K;h[6340]=+iY(50864,o);K=+iY(50720,50888);h[6340]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[6340]=K;h[6349]=1.0;M=+h[6350];if(K<1.0&K>M){N=K;while(1){h[6349]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+iY(o,p);h[6341]=K;h[o>>3]=-K;h[6341]=+iY(50776,o);K=+iY(50776,50728);h[6340]=K;h[o>>3]=-K;h[6341]=+iY(50776,o);K=+iY(50776,50728);h[6340]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[6349]=G}G=I/+(c[12702]|0);h[6352]=G;h[6356]=I;c[12684]=1;p=1;O=I;do{h[o>>3]=O*G;O=+iY(o,50800);h[6356]=O;p=p+1|0;c[12684]=p;}while((p|0)<4);h[6339]=+iY(50752,50848);jY(50912,50752,50808)|0;h[o>>3]=-+h[6344];jY(50904,o,50808)|0;jY(50856,50712,50808)|0;h[o>>3]=-+h[6339];jY(50840,o,50808)|0;c[12692]=0;p=c[12728]|0;L=c[12726]|0;P=c[12714]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[12710]|0)){if(Q){c[12706]=p;R=0;S=25;break}if((P-p|0)==3){c[12706]=p+ -1+(c[12686]|0);c[12692]=1;R=1;S=25;break}else{c[12706]=(p|0)<=(P|0)?p:P;a[50448]=1;S=26;break}}else{T=Q&(L|0)==(c[12710]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[12706]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[12706]=(p|0)<=(L|0)?p:L;a[50448]=1;S=26;break}}T=c[12710]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[12706]=(V|0)<=(T|0)?V:T;a[50448]=1;S=26;break}if((P-U|0)==3){c[12706]=((p|0)>=(L|0)?p:L)+ -1+(c[12686]|0);R=0;S=25;break}else{c[12706]=U;a[50448]=1;S=26;break}}}while(0);if((S|0)==25){if(a[50448]&1){S=26}else{W=R}}if((S|0)==26){a[50440]=0;vda(50920)|0;Mca(50944,50824,4)|0;dda()|0;W=c[12692]|0}if((W|0)==0){X=(c[12724]|0)!=0|0}else{X=1}c[12692]=X;h[6359]=1.0;X=c[12706]|0;W=1-X|0;c[n>>2]=W;c[12684]=1;if((X|0)<=0){O=+h[6352];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+iY(o,50800);h[6359]=I;n=X+1|0;c[12684]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}kY(50808,50744,50824,50768,50832,50880)|0;q=50808;r=c[12702]|0;c[b>>2]=r;s=50744;t=c[12686]|0;c[d>>2]=t;u=50784;v=c[12696]|0;c[e>>2]=v;w=50792;x=+h[6349];h[f>>3]=x;y=50824;z=c[12706]|0;c[g>>2]=z;A=50872;B=+h[6359];h[j>>3]=B;C=50832;D=c[12708]|0;c[k>>2]=D;E=50880;F=+h[6360];h[l>>3]=F;i=m;return 0}function hY(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[50336]&1){l=a[50408]&1;m=c[12604]|0;c[b>>2]=m;n=50384;o=c[12596]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=50432;r=c[12608]|0;c[f>>2]=r;i=g;return 0}a[50336]=1;h[6299]=1.0;h[6293]=1.0;h[6295]=1.0;s=1.0;do{s=s*2.0;h[6293]=s;h[6295]=+iY(50344,50392);h[j>>3]=-s;t=+iY(50360,j);h[6295]=t;}while(t==1.0);h[6294]=1.0;t=+iY(50344,50352);h[6295]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[6294]=v;w=+iY(50344,50352);h[6295]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[6300]=.25;h[6303]=x;h[j>>3]=-s;t=+iY(50360,j);h[6295]=t;y=~~(t+.25);c[12604]=y;t=+(y|0);h[6294]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[6296]=+iY(j,k);w=+iY(50368,50344);h[6295]=w;z=w==s;a[50408]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[6296]=+iY(j,k);w=+iY(50368,50344);h[6295]=w;if(z&w==s){a[50408]=0;A=0}else{A=z}h[j>>3]=u;w=+iY(j,50344);h[6297]=w;h[j>>3]=u;z=w==s&+iY(j,50424)>x;c[12608]=z?A&1:0;c[12596]=0;h[6293]=1.0;h[6295]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[12596]=k;s=x*t;h[6293]=s;h[6295]=+iY(50344,50392);h[j>>3]=-s;w=+iY(50360,j);h[6295]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=50384;o=c[12596]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=50432;r=c[12608]|0;c[f>>2]=r;i=g;return 0}function iY(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function jY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[6369]=g;j=1.0/+(c[d>>2]|0);h[6378]=j;h[6377]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+iY(f,51016);h[6371]=k;h[6373]=g;h[6374]=g;h[6375]=g;h[6376]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[6369]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+iY(f,51016);h[6371]=g;h[f>>3]=g*k;k=+iY(f,51016);h[6373]=k;h[6375]=0.0;c[12740]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[6375]=q;c[12740]=b+1;n=q}h[f>>3]=m*j;p=+iY(f,51016);h[6372]=p;h[f>>3]=p/j;r=+iY(f,51016);h[6374]=r;h[6376]=0.0;o=c[d>>2]|0;c[12740]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[6376]=v;c[12740]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function kY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[12764]=1;c[12772]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[12764]=q;r=l+1|0;c[12772]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[12768]=n;u=n}else{c[12768]=m;c[12772]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[12774]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[12772]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[6385]=x;y=w+-1.0;h[6381]=y;h[6380]=0.0;v=c[b>>2]|0;c[12758]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[6381]=B;if(w<1.0){h[6383]=w}C=+iY(51040,51048);h[6380]=C;e=b+1|0;c[12758]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[6383];h[6380]=A;z=A}}while(0);v=c[f>>2]|0;c[12758]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+iY(k,51104);h[6380]=z;f=E+1|0;c[12758]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function lY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[12780]=1;m=1;do{c[12786]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=mY(j,a+(m+b+(fa(m,l)|0)<<3)|0,51152)|0;q=c[12780]|0;r=p+ -1+q|0;c[12782]=r;c[e+(q+ -1<<2)>>2]=r;r=c[12782]|0;q=c[12780]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[6392]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[6392];t=q}u=fa(t,l)|0;h[6392]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;nY(j,51136,a+(t-l+u<<3)|0,51152)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[12786]|0;c[12778]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[12782]|0;x=fa(w,l)|0;h[6392]=+h[a+(x+b+v<<3)>>3];y=c[12780]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[6392];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=51152;oY(k,51136,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[12778]|0;w=A+1|0;c[12778]=w;}while((A|0)<(u|0))}}while(0);q=c[12780]|0;m=q+1|0;c[12780]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function mY(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[12878]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[6440]=k;l=(c[d>>2]|0)+1|0;c[12878]=l;m=c[a>>2]|0;c[12876]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[6440]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[12878]=l;a=n+1|0;c[12876]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[6440]=v;c[12876]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[6440]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[12876]=f+1;g=C;i=e;return g|0}function nY(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[12862]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[12862]=l;i=f;return 0}l=(g|0)%5|0;c[12864]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[12862]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[12862]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[12862]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[12862]=o;i=f;return 0}function oY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[12848]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[12846]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[12846]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[12846]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[12846]=s;i=j;return 0}}while(0);c[12850]=1;c[12852]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[12850]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[12852]=s;u=s}else{u=1}s=c[a>>2]|0;c[12846]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[12850]=t;u=x+(c[g>>2]|0)|0;c[12852]=u;a=w+1|0;c[12846]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function pY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[12798]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[12790]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[12792]=o;p=f+(o+ -1<<3)|0;h[6397]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[6397]}c[k>>2]=(c[d>>2]|0)-m;o=51152;oY(k,51176,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[12790]|0;m=o+1|0;c[12790]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[12796]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[12790]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[6397]=-s;c[k>>2]=g;g=51152;oY(k,51176,a+(p-l<<3)|0,g,f,g)|0;g=c[12796]|0;q=g+1|0;c[12796]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[12790]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=51152;s=+qY(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[6397]=s;q=c[12790]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[12790]=n;}while((q|0)<(m|0));t=c[12798]|0}if((t|0)<1){i=j;return 0}c[12796]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[12790]=n;c[k>>2]=(c[d>>2]|0)-n;b=51152;s=+qY(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[12790]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[12792]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[6397]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[6397]}q=c[12796]|0;m=q+1|0;c[12796]=m;}while((q|0)<(t|0));i=j;return 0}function qY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[6437]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[12868]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[12866]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[6437]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[12866]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[12866]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[6437]=t;u=u+5|0;}while((u|0)<=(m|0));c[12866]=u;k=t;i=g;return+k}}while(0);c[12870]=1;c[12872]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[12870]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[12872]=u;y=u}else{y=1}u=c[a>>2]|0;c[12866]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[6437]=t;x=C+(c[d>>2]|0)|0;c[12870]=x;y=B+(c[f>>2]|0)|0;c[12872]=y;a=z+1|0;c[12866]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function rY(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[12808]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[12814]=n;o=c[d>>2]|0;p=c[12808]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[12816]=o;do{if((q|0)>(n|0)){c[12824]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[12812]=s;t=c[e>>2]|0;c[12800]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[12800]=t+1}u=r+1|0;c[12824]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[12824]=o;c[12822]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[12804]=1;t=o;o=1;while(1){c[12826]=o+1;p=t+1|0;c[12824]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[12800]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[12800]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[12818]=s;c[l>>2]=s+1;s=mY(l,a+((c[12808]|0)+b+(fa(o,m)|0)<<3)|0,51152)|0;p=s+ -1|0;c[12806]=p+(c[12808]|0);s=c[12804]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[12806]|0;p=c[12804]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[12808]|0;if((s|0)==(u|0)){y=s}else{h[6405]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[6405];y=u}h[6405]=-1.0/+h[a+(y+b+n<<3)>>3];nY(51272,51240,a+(y-m+n<<3)|0,51152)|0;u=c[12822]|0;z=(c[g+((c[12804]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[12822]=u;A=c[12808]|0;c[12820]=A;z=c[12826]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[12802]=z;B=z;z=A;while(1){A=(c[12806]|0)+ -1|0;c[12806]=A;C=z+ -1|0;c[12820]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[6405]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[6405];F=C}C=51152;oY(51272,51240,a+((c[12808]|0)-m+(fa(c[12804]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[12802]|0;D=C+1|0;c[12802]=D;if((C|0)>=(u|0)){break a}B=D;z=c[12820]|0}}}while(0);n=c[12804]|0;s=n+1|0;c[12804]=s;if((n|0)>=(r|0)){break}t=c[12824]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[12808]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function sY(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[12832]=n;f=c[d>>2]|0;o=f+ -1|0;c[12844]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[12828]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[12842]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[12830]=k;q=j+(k+ -1<<3)|0;h[6417]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[6417]}k=51152;oY(51368,51336,a+((c[12832]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[12828]|0;f=k+1|0;c[12828]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[12836]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[12828]=k;q=c[12832]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[12842]=s;u=q-s|0;c[12838]=u;q=k-s|0;c[12840]=q;h[6417]=-t;s=51152;oY(51368,51336,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[12836]|0;r=s+1|0;c[12836]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[12828]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[12842]=r;s=o-r|0;c[12838]=s;q=n-r|0;c[12840]=q;r=51152;t=+qY(51368,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[6417]=t;r=c[12828]|0;q=j+(r+ -1<<3)|0;o=c[12832]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[12828]=n;}while((r|0)<(f|0));v=o;w=c[12844]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[12836]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[12828]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[12842]=(n|0)<=(b|0)?n:b;b=51152;t=+qY(51368,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[12828]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[12830]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[6417]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[6417]}n=c[12836]|0;b=n+1|0;c[12836]=b;if((n|0)>=(w|0)){break}o=c[12832]|0;v=b}i=l;return 0}function tY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[12856]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[12854]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[12854]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[12854]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[12854]=o;i=g;return 0}}while(0);c[12858]=1;c[12860]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[12858]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[12860]=o;q=o}else{q=1}o=c[a>>2]|0;c[12854]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[12858]=p;q=s+(c[f>>2]|0)|0;c[12860]=q;a=r+1|0;c[12854]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function uY(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+vY(51528);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+wY(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+wY(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+wY(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+wY(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function vY(a){a=a|0;i=i;return+(+h[51536+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function wY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function xY(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+vY(51568);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+wY(b,e);c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){FY(b,b,f,g,51576,N,51568,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+wY(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=Npa(ga|0,0,Z+ -2|0,0)|0;Z=Gpa(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}EY(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Ge[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);uY(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+wY(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Ge[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+wY(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+wY(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+wY(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}HY(b,b,s,t,v,w,x,D)|0;GY(b,b,f,g,w,x)|0;W=51568;GY(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Ge[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function yY(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[51600]=1;f=d[b]|0;c[12896]=f;b=d[e]|0;c[12898]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[12896]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[12898]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function zY(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[61132>>2]=6;vda(61128)|0;Mca(61872,j,4)|0;dda()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[14584]=0;c[15190]=0;c[15178]=0;a[60736]=0;t=c[e>>2]|0;c[14138]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[14584]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[14138]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[14138]=1;if((v|0)>=1){x=1;while(1){h[53024+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[14138]=v+1}c[15182]=2;x=c[e>>2]|0;c[14138]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[14140]=1;if((E|0)<1){F=C}else{G=1;while(1){h[53024+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[14140]=E+1;F=+h[B>>3]}h[53024+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[15182]=G;D=G}G=z+1|0;c[14138]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[14584]|0;y=z+1|0;c[14580]=y;c[14138]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[14140]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[53024+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[14140]=x+1}le[u&63](e,b,56384+(z+ -1<<3)|0)|0;c[15190]=(c[15190]|0)+1;if((c[j>>2]|0)>=1){c[61156>>2]=6;vda(61152)|0;Mca(61872,60760,4)|0;Mca(61872,56384+((c[14138]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[14140]=1;if((v|0)>=1){A=1;do{Mca(61872,b+(A+ -1<<3)|0,8)|0;B=c[14140]|0;A=B+1|0;c[14140]=A;}while((B|0)<(v|0))}dda()|0}v=c[14138]|0;z=v+1|0;c[14138]=z;}while((v|0)<(y|0))}y=c[15178]|0;b:while(1){c[15178]=y+1;c[15090]=1;c[15086]=1;C=+h[7048];h[7544]=C;h[7546]=C;z=c[14580]|0;c[14138]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[56384+(A+ -1<<3)>>3];do{if(!(C<=K)){c[15090]=A;L=+h[56384+(A+ -1<<3)>>3];h[7544]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[15086]=A;L=+h[56384+(A+ -1<<3)>>3];h[7546]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[14138]=z+1;H=O}A=c[e>>2]|0;c[14138]=1;if((A|0)>=1){v=1;while(1){h[58504+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[14138]=A+1}c[14138]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[14140]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=58504+(Q+ -1<<3)|0;h[B>>3]=+h[53024+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[14140]=x+1;P=v}}while(0);v=P+1|0;c[14138]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[14140]=1;if((z|0)>=1){K=+(c[14584]|0);v=1;while(1){A=58504+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[14140]=z+1}v=c[e>>2]|0;c[14138]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[58504+(B<<3)>>3];h[60784+(B<<3)>>3]=K+(K- +h[53024+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[14138]=v+1}le[u&63](e,60784,60776)|0;A=(c[15190]|0)+1|0;c[15190]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[61180>>2]=6;vda(61176)|0;Mca(61872,60760,4)|0;Mca(61872,60776,8)|0;B=c[e>>2]|0;c[14140]=1;if((B|0)>=1){E=1;do{Mca(61872,60784+(E+ -1<<3)|0,8)|0;G=c[14140]|0;E=G+1|0;c[14140]=E;}while((G|0)<(B|0))}dda()|0}}while(0);K=+h[7597];c:do{if(!(K>=+h[7546])){z=c[e>>2]|0;c[14138]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[58504+(v<<3)>>3];h[60952+(v<<3)>>3]=I+(+h[60784+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[14138]=z+1}le[u&63](e,60952,60944)|0;A=(c[15190]|0)+1|0;c[15190]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[61204>>2]=6;vda(61200)|0;Mca(61872,60760,4)|0;Mca(61872,60944,8)|0;B=c[e>>2]|0;c[14140]=1;if((B|0)>=1){E=1;do{Mca(61872,60952+(E+ -1<<3)|0,8)|0;G=c[14140]|0;E=G+1|0;c[14140]=E;}while((G|0)<(B|0))}dda()|0}}while(0);I=+h[7618];if(I>=+h[7546]){R=118;break}v=c[e>>2]|0;c[14138]=1;A=c[15090]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[53024+((z*21|0)+ -22+A<<3)>>3]=+h[60952+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[14138]=v+1}h[56384+(A+ -1<<3)>>3]=I}else{z=c[14580]|0;c[14138]=1;if((z|0)>=1){B=c[15090]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[56384+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[14138]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[7544])){E=c[e>>2]|0;c[14138]=1;z=c[15090]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[53024+((B*21|0)+ -22+z<<3)>>3]=+h[60784+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[14138]=E+1}h[7544]=K;h[56384+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[14138]=1;if((B|0)>=1){A=c[15090]|0;v=1;while(1){x=v+ -1|0;h[60952+(x<<3)>>3]=+h[53024+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[58504+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[14138]=B+1}le[u&63](e,60952,60944)|0;v=(c[15190]|0)+1|0;c[15190]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[61228>>2]=6;vda(61224)|0;Mca(61872,60760,4)|0;Mca(61872,60944,8)|0;z=c[e>>2]|0;c[14140]=1;if((z|0)>=1){E=1;do{Mca(61872,60952+(E+ -1<<3)|0,8)|0;x=c[14140]|0;E=x+1|0;c[14140]=E;}while((x|0)<(z|0))}dda()|0}}while(0);I=+h[7618];if(!(I>+h[7544])){A=c[e>>2]|0;c[14138]=1;v=c[15090]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[53024+((B*21|0)+ -22+v<<3)>>3]=+h[60952+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[14138]=A+1}h[56384+(v+ -1<<3)>>3]=I;break}B=c[14580]|0;c[14138]=1;if((B|0)<1){break}else{S=1}do{z=c[15086]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[14140]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=53024+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[53024+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[53024+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[14140]=E+1}le[u&63](e,b,56384+(S+ -1<<3)|0)|0;G=(c[15190]|0)+1|0;c[15190]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[61252>>2]=6;vda(61248)|0;Mca(61872,60760,4)|0;Mca(61872,56384+((c[14138]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[14140]=1;if((x|0)>=1){G=1;do{Mca(61872,b+(G+ -1<<3)|0,8)|0;T=c[14140]|0;G=T+1|0;c[14140]=G;}while((T|0)<(x|0))}dda()|0}}while(0);z=c[14138]|0;S=z+1|0;c[14138]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[14138]=1;v=c[15090]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[53024+((A*21|0)+ -22+v<<3)>>3]=+h[60784+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[14138]=B+1}h[56384+(v+ -1<<3)>>3]=+h[7597]}A=c[15178]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[7547]=0.0;h[7593]=0.0;A=c[14580]|0;c[14138]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[7593]=0.0/K;c[14138]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[56384+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[7593]=I;c[14138]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[56384+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[7547]=$;c[14138]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[7547]=I;do{if(!(I<=+h[k>>3])){if((c[15190]|0)>(c[g>>2]|0)){break}a[60736]=0;c[15178]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[14138]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[14140]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[53024+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[14140]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[14138]=v+1}le[u&63](e,b,f)|0;B=(c[15190]|0)+1|0;c[15190]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[61276>>2]=6;vda(61272)|0;Mca(61872,60760,4)|0;Mca(61872,s,8)|0;z=c[e>>2]|0;c[14140]=1;if((z|0)>=1){E=1;do{Mca(61872,b+(E+ -1<<3)|0,8)|0;x=c[14140]|0;E=x+1|0;c[14140]=E;}while((x|0)<(z|0))}dda()|0;ba=c[15190]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[61396>>2]=6;vda(61392)|0;dda()|0;c[61420>>2]=6;vda(61416)|0;B=c[e>>2]|0;c[14138]=1;if((B|0)>=1){A=1;do{Mca(61872,b+(A+ -1<<3)|0,8)|0;v=c[14138]|0;A=v+1|0;c[14138]=A;}while((v|0)<(B|0))}dda()|0;c[61444>>2]=6;vda(61440)|0;Mca(61872,s,8)|0;dda()|0}if(a[60736]&1){I=+h[7593];K=+h[7639]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[60736]=1;da=+h[7593]}h[7639]=da;c[15178]=0;y=0}if((c[j>>2]|0)>=0){c[61468>>2]=6;vda(61464)|0;Mca(61872,60760,4)|0;dda()|0;c[61492>>2]=6;vda(61488)|0;y=c[e>>2]|0;c[14138]=1;if((y|0)>=1){B=1;do{Mca(61872,b+(B+ -1<<3)|0,8)|0;A=c[14138]|0;B=A+1|0;c[14138]=B;}while((A|0)<(y|0))}dda()|0;c[61516>>2]=6;vda(61512)|0;Mca(61872,s,8)|0;dda()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[61540>>2]=6;vda(61536)|0;dda()|0}h[7546]=+h[f>>3];c[15192]=0;y=c[14580]|0;c[14138]=1;if((y|0)>=1){B=1;while(1){A=56384+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[14138]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[14140]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=53024+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[60952+(E+ -1<<3)>>3]=+h[53024+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[14140]=v+1}le[u&63](e,60952,A)|0;c[15192]=(c[15192]|0)+1;c[15190]=(c[15190]|0)+1;E=c[14138]|0;I=+h[56384+(E+ -1<<3)>>3];if(I>=+h[7546]){B=E;continue}h[7546]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[61564>>2]=6;vda(61560)|0;Mca(61872,60760,4)|0;Mca(61872,60368,8)|0;E=c[e>>2]|0;c[14140]=1;if((E|0)>=1){z=1;do{Mca(61872,60952+(z+ -1<<3)|0,8)|0;G=c[14140]|0;z=G+1|0;c[14140]=z;}while((G|0)<(E|0))}dda()|0;B=c[14138]|0}}B=c[14584]|0;c[14138]=1;do{if((B|0)<1){h[7073]=+h[7048];c[14138]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[14148]=E;z=c[e>>2]|0;c[14140]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[60784+(A+ -1<<3)>>3]=(+h[53024+(v+ -21<<3)>>3]+ +h[53024+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[14140]=z+1}le[u&63](e,60784,58344+(y+ -1<<3)|0)|0;c[15192]=(c[15192]|0)+1;c[15190]=(c[15190]|0)+1;A=c[14138]|0;y=A+1|0;c[14138]=y;}while((A|0)<(B|0));y=c[14584]|0;I=+h[7048];h[7073]=I;c[14138]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[14148]=A;c[14150]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[14140]=1;E=1;while(1){v=E+1|0;c[14152]=v;G=c[e>>2]|0;c[14142]=1;if((G|0)>=1){x=c[14150]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[60952+(T+ -1<<3)>>3]=(+h[53024+(U+x<<3)>>3]+ +h[53024+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[14142]=G+1}le[u&63](e,60952,60944)|0;c[15192]=(c[15192]|0)+1;c[15190]=(c[15190]|0)+1;T=c[14138]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[14140]|0;la=U+x|0;c[14144]=la;I=+h[7073];h[58664+(la+ -1<<3)>>3]=(+h[7618]+I- +h[58344+(v<<3)>>3]- +h[58344+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[14140]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[14138]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[14584]|0;c[14144]=0;c[14138]=1;E=(y|0)<1;if(E){c[14138]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=Npa(A|0,0,y+ -2|0,0)|0;A=Gpa(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[58664+(U+ -1<<3)>>3]=(+h[56384+(v<<3)>>3]+ka- +h[58344+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[14148]=v+1;c[14144]=(z|1)+A;c[14138]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=58344+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[56384+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[14148]=T+1;c[14138]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[14144]=0;c[14138]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[14138]=1;if((B|0)>=1){A=1;while(1){h[60384+(A+ -1<<3)>>3]=+h[53024+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[14138]=B+1}c[14138]=1;do{if(ma){c[14138]=1}else{A=1;while(1){z=A+1|0;c[14148]=z;v=c[e>>2]|0;c[14140]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=53024+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[53024+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[14140]=v+1}c[14138]=z;if((A|0)<(na|0)){A=z}else{break}}c[14138]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[14148]=A;y=c[e>>2]|0;c[14140]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[53024+(T+oa<<3)>>3]=+h[53024+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[14140]=y+1}c[14138]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=58664;AY(B,58336,B,60544,61120,q,60704)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[61588>>2]=6;vda(61584)|0;dda()|0}c[q>>2]=2;if((c[15190]|0)>(c[g>>2]|0)){R=312;break}c[61612>>2]=6;vda(61608)|0;dda()|0;B=c[e>>2]|0;c[14138]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[14138]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[61300>>2]=6;vda(61296)|0;Mca(61872,g,4)|0;dda()|0;c[61324>>2]=6;vda(61320)|0;Mca(61872,60376,8)|0;dda()|0;c[61348>>2]=6;vda(61344)|0;u=c[e>>2]|0;c[14138]=1;if((u|0)>=1){E=1;do{Mca(61872,b+(E+ -1<<3)|0,8)|0;z=c[14138]|0;E=z+1|0;c[14138]=E;}while((z|0)<(u|0))}dda()|0;c[61372>>2]=6;vda(61368)|0;Mca(61872,s,8)|0;dda()|0;i=r;return 0}else if((R|0)==226){u=c[14584]|0;c[15188]=u-(c[15280]|0);c[14138]=1;E=(u|0)<1;do{if(E){h[7590]=0.0;c[14138]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[56384+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=56384+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[58664+(sa+ -1<<3)>>3]*+h[58344+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[14144]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[14140]=z;h[7590]=0.0;c[14138]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[56384+(v<<3)>>3]*+h[58344+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[7590]=wa;c[14138]=u+1;qa=wa}}while(0);h[7590]=+h[7073]-qa;s=c[e>>2]|0;c[14138]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[60952+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=60952+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[56384+(T+ -1<<3)>>3]*+h[53024+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[14138]=s+1;c[14140]=xa}v=c[e>>2]|0;c[14138]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=60384+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[60952+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[14138]=v+1}if((c[j>>2]|0)>=0){c[61636>>2]=6;vda(61632)|0;Mca(61872,60720,8)|0;z=c[e>>2]|0;c[14138]=1;if((z|0)>=1){s=1;do{Mca(61872,60384+(s+ -1<<3)|0,8)|0;u=c[14138]|0;s=u+1|0;c[14138]=s;}while((u|0)<(z|0))}dda()|0;c[61660>>2]=6;vda(61656)|0;dda()|0}z=c[e>>2]|0;c[14138]=1;if((z|0)>=1){s=c[14584]|0;v=1;while(1){c[14140]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[56384+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=56384+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[58664+(Aa+ -1<<3)>>3]*+h[53024+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[14144]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[14142]=E;c[14140]=s+1}T=c[e>>2]|0;c[14140]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=56640+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[56384+(Ea+ -1<<3)>>3]*+h[53024+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[14140]=T+1;c[14144]=Ca;c[14142]=Da}za=v+1|0;c[14138]=za;if((v|0)<(z|0)){v=za}else{break}}}c[14140]=0;v=c[e>>2]|0;c[14138]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[56640+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[14140]=Ga;c[14138]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[61684>>2]=6;vda(61680)|0;Mca(61872,60752,4)|0;dda()|0;c[14582]=1;z=1;d:while(1){c[14144]=z;do{if((z|0)>(c[e>>2]|0)){s=c[14582]|0;if((s|0)==1){c[61708>>2]=6;vda(61704)|0;dda()|0;AY(56640,58336,58664,60544,61120,q,60704)|0;c[61732>>2]=6;vda(61728)|0;dda()|0;c[14582]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[14582]=2;c[14154]=0;c[14156]=0;s=c[e>>2]|0;c[14138]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=Npa(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=Gpa(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=56640+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=56640+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[56640+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[14158]=Na;c[14156]=Ta;c[14154]=Ia;c[14140]=Ma;c[14138]=s+1}c[61756>>2]=6;vda(61752)|0;dda()|0;c[14154]=0;u=c[e>>2]|0;c[14138]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=56640+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[14154]=Wa;c[14138]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[14154]=T;s=c[e>>2]|0;c[14138]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[14148]=B;Qa=za+la|0;c[14154]=Qa;Pa=B+5|0;c[14150]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[14582]|0)==3){c[61828>>2]=6;vda(61824)|0;Pa=c[14150]|0;Qa=c[14148]|0;c[14140]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{Mca(61872,58664+(B+ -1<<3)|0,8)|0;Qa=c[14140]|0;B=Qa+1|0;c[14140]=B;}while((Qa|0)<(Pa|0))}dda()|0}else{c[61804>>2]=6;vda(61800)|0;Pa=c[14150]|0;B=c[14148]|0;c[14140]=B;if((B|0)<=(Pa|0)){x=B;do{Mca(61872,56640+(x+ -1<<3)|0,8)|0;B=c[14140]|0;x=B+1|0;c[14140]=x;}while((B|0)<(Pa|0))}dda()|0}Pa=c[14138]|0;x=Pa+1|0;c[14138]=x;if((Pa|0)>=(s|0)){break e}E=c[14144]|0;la=c[14154]|0;za=x}}}while(0);c[61852>>2]=6;vda(61848)|0;dda()|0;z=(c[14144]|0)+6|0}c[61780>>2]=6;vda(61776)|0;Mca(61872,60768,4)|0;dda()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);le[p&63](e,b,f)|0;i=r;return 0}function AY(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[15488]=c[b>>2];c[g>>2]=1;if((c[15488]|0)<1){i=k;return 0}c[g>>2]=0;BY(a,61952,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[15488]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[15480]=f;c[15486]=g;c[15492]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=Npa(a|0,0,g+ -2|0,0)|0;m=Gpa(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[15472]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=Npa(p|0,0,a-n|0,0)|0;p=Gpa(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[15472]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[15470]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[15470]=j}c[15482]=g;c[15484]=f;c[15490]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[7739]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[7739]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[7739]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[15490]=D;E=v+ -1|0;c[15482]=E;F=w+ -1|0;c[15484]=F;q=D;v=E;w=F}c[15474]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[15476]=t;c[15486]=0;c[15492]=l-g;i=k;return 0}function BY(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[7753]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[7753]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[7753];c[15496]=1;c[15498]=0;n=c[b>>2]|0;c[15510]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[15500]=0;c[15512]=1;do{if((o|0)>=1){p=1;q=c[15498]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[7752]=m;u=(p|0)==(o|0);if(u){l=m*+h[7753];h[7754]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[7752]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[7754]=+h[7754]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[15500]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[15500]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[7752];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[15512]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[15494]=y;c[15502]=x;c[15498]=s;break}else if((D|0)==26){D=0;c[15494]=y;c[15502]=x;c[15498]=s;break}}}while(0);m=+V(+(+h[7754]));h[7754]=m;H=+h[7752];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[15498]|0)+ -1<<3)>>3]=G;G=+h[7754]/+h[7752];h[j+((c[15494]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[15498]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[15496]|0;O=c[15510]|0}}while(0);b=N+O|0;c[15496]=b;o=O+1|0;c[15510]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[15494]=y;c[15502]=x;c[15498]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function CY(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[15536]=n;o=(c[d>>2]|0)-n|0;c[15558]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[15556]=s;a[62168]=1;t=c[b>>2]|0;u=t+1|0;c[15552]=u;v=c[b>>2]|0;w=u+v|0;c[15550]=w;u=w+(c[b>>2]|0)|0;c[15554]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[15544]=w;x=w+(c[d>>2]|0)|0;c[15538]=x;y=x+(c[b>>2]|0)|0;c[15540]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[15546]=z;A=z+(c[d>>2]|0)|0;c[15560]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[15562]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[15534]=C;D=C+(c[b>>2]|0)|0;c[15548]=D;DY(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,62224,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);vda(62256)|0;dda()|0;i=m;return 0}function DY(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[7867]=.5;h[7858]=1.0;h[7898]=.1;F=(c[a>>2]|0)+1|0;c[15712]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[15704]=H;I=(c[b>>2]|0)-F|0;c[15758]=I;F=c[j>>2]|0;c[15812]=(F|0)<1?1:F;F=c[a>>2]|0;c[15696]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[15698]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[15698]=J+1}L=c[u>>2]|0;c[15694]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[15694]=L+1}K=j+1|0;c[15696]=K;if((j|0)<(F|0)){j=K}else{break}}}c[15700]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[15700]=H+1}H=c[b>>2]|0;c[15698]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[15696]=M;c[15698]=H+1}N=+h[e>>3];O=N*N;h[7903]=O;h[7889]=+h[7858]/O;h[7890]=+V(+(+h[7867]))/O;c[15702]=0;H=y;y=A;M=0;a:while(1){c[15714]=M;F=M-(c[a>>2]|0)|0;c[15738]=F;j=M+1|0;c[15702]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[15788]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[15726]=L;K=L+G|0;c[15724]=K;if((K|0)>(c[a>>2]|0)){c[15788]=L;G=K-(c[a>>2]|0)|0;c[15726]=G;c[15724]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[7880]=O;L=c[15712]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[7880]=N;R=N}else{R=O}O=+h[e>>3];h[7881]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[7881]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[7881];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[15696]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[15696]=S+1}if((M|0)>=(c[15812]|0)){T=j;U=159;break}while(1){le[H&63](a,d,62768)|0;if((c[g>>2]|0)==3){vda(63296)|0;Mca(63464,62808,4)|0;Mca(63464,62768,8)|0;I=c[a>>2]|0;c[15694]=1;if((I|0)>=1){F=1;do{Mca(63464,d+(F+ -1<<3)|0,8)|0;L=c[15694]|0;F=L+1|0;c[15694]=F;}while((L|0)<(I|0))}dda()|0}I=c[15702]|0;do{if((I|0)>(c[b>>2]|0)){F=c[15742]|0;if((F|0)==-1){break a}h[7899]=0.0;c[15700]=0;L=c[a>>2]|0;c[15696]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[7899]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[7872]=N;if((X|0)==(G|0)){ea=N*+h[7867];h[7872]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[7899]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[15700]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[15694]=Y;c[15696]=L+1;W=Z}J=c[b>>2]|0;c[15698]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[7899]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[15698]=J+1;ia=ja}O=+h[7846];ba=+h[7875];N=O-ba-ia;h[7866]=N;h[7885]=+h[7884];h[7884]=+h[7883];if(!(N>=0.0)){ka=-N}else{ka=N}h[7883]=ka;if(+h[7895]>+h[7861]){c[15786]=I}h[7891]=ba;do{if(O<ba){h[7875]=O;h[7908]=0.0;G=c[a>>2]|0;c[15694]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[7908]=+h[7908]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[15694]=G+1;h[A>>3]=ma}}while(0);c[15784]=F;if((F|0)<=0){O=+h[7899];if(O>=0.0){U=190;break a}ba=+h[7846];N=+h[7891];ea=(ba-N)/O;h[7896]=ea;O=+h[7898];do{if(!(ea<=O)){na=+h[7867]*+h[7888];h[A>>3]=na;oa=+h[7895];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[7888]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[7888]=qa;ra=qa;break}}else{qa=+h[7867]*+h[7895];h[7888]=qa;ra=qa}}while(0);ea=+h[7861];if(!(ra<=ea*1.5)){sa=ra}else{h[7888]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[7903]=ea;c[15800]=0;h[7904]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[15756]|0;c[15800]=J;oa=+h[7858];h[7904]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[15698]=1;if((J|0)<1){va=F}else{L=c[15758]|0;oa=ua;K=1;ca=F;while(1){h[7886]=0.0;c[15696]=1;if((L|0)<1){wa=0.0}else{X=c[15718]|0;aa=K+C|0;qa=+h[7858];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[7872]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[7886]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[15696]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[7868]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[7872]=za;h[7907]=0.0;$=c[a>>2]|0;c[15696]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[7907]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[15696]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[7872]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[7904]=Fa;c[15742]=K;Ga=Fa;Ha=K}aa=K+1|0;c[15698]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}JY(a,b,s,t,62872,u,w,62944,62968,x)|0;ca=c[15742]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[7846];c[15700]=0;J=c[a>>2]|0;c[15694]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[7872]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[7872];G=G+1|0;da=da+1|0}da=X+aa|0;c[15700]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[15696]=La;c[15694]=J+1}h[L>>3]=0.0;X=c[15758]|0;c[15696]=1;aa=(X|0)<1;if(!aa){F=c[15718]|0;K=1;while(1){da=fa(K,B)|0;O=+h[7866]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[7872]=Oa;G=c[b>>2]|0;c[15698]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[7872];$=$+1|0}c[15698]=G+1}$=K+1|0;c[15696]=$;if((K|0)<(X|0)){K=$}else{break}}}h[7877]=0.0;K=c[a>>2]|0;c[15694]=1;if((K|0)>=1){F=1;while(1){O=+h[7866]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[7877]=+h[7877]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[15694]=K+1;h[A>>3]=Pa}F=c[15784]|0;do{if((F|0)==0){if(!(+h[7888]==+h[7861])){break}O=+h[7896];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[15804]=0;break}L=c[b>>2]|0;c[15698]=1;if((L|0)>=1){J=o+((c[15756]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[15698]=L+1}h[7870]=0.0;$=c[a>>2]|0;c[15694]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[7864]=0.0;G=c[b>>2]|0;c[15698]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[7864]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[15698]=G+1;Sa=Ta}h[7870]=+h[7870]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[15694]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[7870]*100.0}J=c[15804]|0;c[15804]=J+1;if(+h[7877]<Ra){c[15804]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[15694]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[15694]=J+1}$=c[15704]|0;c[15700]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[15700]=$+1}c[15696]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[15698]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[15698]=Na+1;Ua=Wa}if((L|0)<(c[15718]|0)){h[J>>3]=-Ua}Va=L+1|0;c[15696]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[15698]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[15696]=Xa;c[15698]=L+1}c[15804]=0}}while(0);O=+h[7846];ea=+h[7891];if(O<ea){c[15756]=ca}oa=+h[7898];if(O<=ea+oa*+h[7899]|(F|0)>0){U=54;break}c[15742]=0;Ia=0;Ja=+h[7888];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[7846];oa=+h[7846];do{if((I|0)==1){h[7865]=oa;h[7875]=oa;c[15756]=1;Ya=1}else{if(!(oa<+h[7875])){Ya=I;break}h[7875]=oa;c[15756]=I;Ya=I}}while(0);F=c[15714]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[15724]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[15726]|0;Va=K+aa|0;c[15700]=Va;if(+h[7880]<0.0){aa=X+(c[a>>2]|0)|0;c[15724]=aa;Za=aa}else{Za=X}if(+h[7881]<0.0){X=K+(c[a>>2]|0)|0;c[15726]=X;_a=X}else{_a=K}K=fa(c[15738]|0,B)|0;h[t+(K-B<<3)>>3]=+h[7889];h[t+(Ya+C+K<<3)>>3]=+h[7889];h[t+(Za-B+K<<3)>>3]=-+h[7889];h[t+(_a-B+K<<3)>>3]=-+h[7889];h[q+(Va+ -1<<3)>>3]=(+h[7865]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[7846])/(+h[7880]*+h[7881])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[15738]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[7867]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[7867]/+h[e>>3];ea=+h[7890];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[7890];h[t+(X+K<<3)>>3]=+h[7890];K=(fa(Va+1|0,Va)|0)/2|0;c[15700]=K;ea=(+h[7865]- +h[7846])/+h[e>>3];h[7872]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[7867]*(+h[X>>3]+ +h[7872]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[7865])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[7858]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[7858]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[7867]*+h[7903]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[7861]=oa;h[7888]=oa;c[15718]=1;h[7883]=0.0;h[7884]=0.0;c[15804]=0;h[7908]=0.0;F=c[a>>2]|0;c[15694]=1;if((F|0)<1){U=53;break}ca=c[15756]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[7908]=+h[7908]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[15694]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[15786]=c[15702];U=54;continue}else if((U|0)==54){U=0;c[15742]=0;I=(c[15712]|0)+ -1|0;K=c[a>>2]|0;IY(a,b,l,n,p,q,r,63104,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,63240)|0;h[7860]=0.0;K=c[a>>2]|0;c[15694]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[7860]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[15694]=K+1;ab=cb}oa=+h[7888];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[7895]=O;ea=+h[7861];if(!(O<+h[7867]*ea)){db=ab;U=62;break}c[15742]=-1;O=+h[7898];N=O*oa;h[7888]=N;h[7896]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[7888]=ea;eb=ea}if((c[15702]|0)<=((c[15786]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[7905]*.125*ea;h[7872]=N;oa=+h[7883];ba=+h[7884];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[7885];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[7907]=O;I=c[b>>2]|0;c[15698]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[7864]=0.0;X=c[a>>2]|0;c[15696]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[7864]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[15696]=X+1;jb=lb}if(jb>ea){c[15742]=F;h[7907]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[15698]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[7896]>0.0){U=54;continue}ea=+h[7895];O=+h[7861];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[7867];h[7888]=O;ea=hb/+h[f>>3];h[7896]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[7861]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[7861]=na;ob=na;break}}else{na=+h[f>>3];h[7861]=na;ob=na}}while(0);h[7888]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){vda(63344)|0;dda()|0}vda(63368)|0;Mca(63464,62888,8)|0;Mca(63464,62808,4)|0;dda()|0;vda(63392)|0;Mca(63464,63e3,8)|0;ca=c[a>>2]|0;c[15694]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];Mca(63464,y,8)|0;I=c[15694]|0;F=I+1|0;c[15694]=F;}while((I|0)<(ca|0))}dda()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[7867]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[7861];O=na>=ea?na:ea;h[7897]=O;ea=O*O;h[7860]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[7908];if(db<=ea*.001){h[7901]=ea*.25;ca=c[b>>2]|0;c[15698]=1;if((ca|0)>=1){F=1;while(1){h[7864]=0.0;I=c[a>>2]|0;c[15694]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[7864]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[15694]=I+1;pb=qb}h[7872]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[7867]*+h[7908];h[7864]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[15694]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[7872]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[7867]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[7864]*+h[n+(F+C+Va<<3)>>3]+ +h[7901]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[15706]=aa;c[15696]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[15696]=Va;rb=Va}c[15694]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[15698]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[15758]|0;c[15698]=1;if((F|0)>=1){ca=1;while(1){h[7882]=0.0;X=c[b>>2]|0;c[15694]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[7882]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[15694]=I;if((K|0)>=(X|0)){break b}O=+h[7882];K=I}}}while(0);X=c[a>>2]|0;c[15696]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[7901]*+h[7882]*+h[l+(I<<3)>>3];h[7864]=O;Va=c[b>>2]|0;c[15694]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[7864]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[15694]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[15718]|0)){h[7864]=-+h[7864]}L=c[b>>2]|0;c[15694]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[7864]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[15694]=L+1}J=K+1|0;c[15696]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[15694]=1;if((K|0)>=1){X=c[15718]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[15706]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[7872]=ub;c[15696]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[7872];aa=aa+1|0}aa=J+1|0;c[15696]=aa;vb=aa}c[15694]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[15698]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[15700]=0;ca=c[a>>2]|0;c[15696]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[15698]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[7867]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[15698]=aa+1}c[15694]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[15700]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[15694]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[15696]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[15696]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[15696]=J+1}h[7908]=0.0}if((c[15742]|0)>0){F=(c[15712]|0)+ -1|0;VX(a,b,l,n,s,t,62872,u,62968,63176,v,63096,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[15698]=1;if((F|0)>=1){L=1;while(1){h[7873]=0.0;h[7874]=0.0;h[7864]=0.0;ca=c[a>>2]|0;c[15696]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[7873]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[7874]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[7864]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[15696]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[7867]+Ab);h[w+(K<<3)>>3]=+h[7864];K=L+1|0;c[15698]=K;if((L|0)<(F|0)){L=K}else{break}}}h[7868]=0.0;L=c[15758]|0;c[15698]=1;if((L|0)>=1){F=1;while(1){h[7864]=0.0;J=c[b>>2]|0;c[15694]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[7864]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[15694]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[7868];if((F|0)<(c[15718]|0)){h[7868]=O+ea;na=-Eb;h[7864]=na;Gb=na}else{h[7868]=O-ea;Gb=Eb}K=c[b>>2]|0;c[15694]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[7864];X=X+1|0}c[15694]=K+1}X=F+1|0;c[15698]=X;if((F|0)<(L|0)){F=X}else{break}}}h[7876]=0.0;h[7855]=0.0;F=c[a>>2]|0;c[15696]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[7864]=0.0;X=c[b>>2]|0;c[15694]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[7864]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[15694]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[7876]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[15708]=K;Va=c[a>>2]|0;c[15698]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[7864]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[15698]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[7876]+ +h[7864]*+h[ca>>3];h[7876]=O;na=+h[7855]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[7855]=na;aa=L+1|0;c[15696]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[7860];h[7868]=+h[7868]+(Ib*Ib+ea*(Ib+(Ib+ +h[7908])+ea*+h[7867]))-Hb;L=w+((c[15756]|0)+ -1<<3)|0;h[L>>3]=+h[7858]+ +h[L>>3];L=c[15742]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[7858]+ +h[7887]*+h[7868]/(ea*ea);h[7872]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;UX(a,b,l,n,s,t,62872,u,63024,62968,v,x,w,62944,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[15694]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[15694]=L+1}F=c[15702]|0;aa=F+1|0;c[15702]=aa;if((F|0)>=(c[15812]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[15702]=T+ -1;if((c[g>>2]|0)<=0){break}vda(63272)|0;dda()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}vda(63320)|0;dda()|0}}while(0);Nb=+h[7875];if(Nb<=+h[7846]){U=c[a>>2]|0;c[15694]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[15694]=U+1;Ob=+h[7875]}h[7846]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}vda(63416)|0;Mca(63464,62808,4)|0;dda()|0;vda(63440)|0;Mca(63464,62768,8)|0;g=c[a>>2]|0;c[15694]=1;if((g|0)>=1){a=1;do{Mca(63464,d+(a+ -1<<3)|0,8)|0;U=c[15694]|0;a=U+1|0;c[15694]=a;}while((U|0)<(g|0))}dda()|0;i=z;return 0}function EY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){ypa(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){ypa(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function FY(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+vY(63472);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+wY(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+wY(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+wY(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function GY(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function HY(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+vY(63480);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=Npa(u|0,0,t+ -2|0,0)|0;t=Gpa(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function IY(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[7955]=.5;h[7973]=6.283185307179586;v=+h[l>>3];h[7968]=v*v;c[15932]=0;l=c[b>>2]|0;c[15950]=l;c[15948]=l;w=c[b>>2]|0;c[15872]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[15872]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[15872]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[15872]=w+1}z=c[d>>2]|0;c[15876]=1;if((z|0)>=1){e=1;while(1){h[7959]=0.0;A=c[b>>2]|0;c[15874]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[7959]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[15874]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[7959]=v;C=c[b>>2]|0;c[15872]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[7959];F=F+1|0}c[15872]=C+1}F=e+1|0;c[15876]=F;if((e|0)<(z|0)){e=F}else{break}}}c[15886]=0;e=c[b>>2]|0;c[15874]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[15886]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[15872]=H;c[15874]=e+1}do{if((y|0)==0){h[7957]=0.0;h[7939]=0.0;w=c[b>>2]|0;c[15872]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[7939]=+h[7939]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[15872]=w+1}h[r>>3]=0.0;D=+h[7939];if(D==0.0){O=55;break a}h[7944]=0.0;h[7947]=0.0;h[7942]=D;h[7962]=D;P=D;Q=0.0;R=0.0;S=+h[7968];T=0}else{if((y|0)>(x|0)){h[7941]=0.0;h[7948]=0.0;h[7949]=0.0;z=c[b>>2]|0;c[15872]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7941]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[7948]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[7949]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[15872]=z+1;U=ba;W=$;Z=aa}D=+h[7955];v=D*(+h[7952]-Z);h[7940]=v;_=+h[7945];ca=_+v;h[7956]=ca;h[7960]=ca;h[7958]=ca;c[15942]=0;a[63568]=1;da=+h[7973]/50.0;h[7959]=da;c[15872]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[7958]=ka;c[15942]=w;h[7969]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[7970]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[7964]=ha;h[7950]=ia;h[7953]=ja;h[7961]=ka;c[15872]=50;h[7960]=ka;if((la|0)==0){h[7969]=ka;O=46}else if((la|0)==49){h[7970]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[7970]}h[7964]=0.0;ga=+h[7969];if(ga!=na){ea=ga-ma;h[7969]=ea;ga=na-ma;h[7970]=ga;oa=D*(ea-ga)/(ea+ga);h[7964]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[7964]=oa;ga=+X(+oa);h[7950]=ga;ea=+Y(+oa);h[7953]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[7965]=oa;h[7942]=0.0;w=c[b>>2]|0;c[15872]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[7950]*+h[J>>3]+ +h[7953]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[7942]+sa*sa;h[7942]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[7953];ea=+h[7950];F=F+1|0;z=K}c[15872]=w+1;qa=ta;ra=+h[7965]}ea=ra+ +h[7957];h[7957]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[7948]=0.0;z=c[b>>2]|0;c[15874]=1;do{if((z|0)<1){ea=+h[7972];h[7963]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[7948]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[15874]=z+1;ea=+h[7972];h[7963]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[7939];h[7959]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[7959]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[7963];oa=+h[7942];v=+h[7948];_=oa/v;ca=ea<=_?ea:_;h[7963]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[7942];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[7955]*Ca);h[7954]=ca;h[7957]=+h[7957]+ca;h[7967]=Ba;h[7942]=0.0;z=c[b>>2]|0;c[15872]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[7963]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[7942]+oa*oa;h[7942]=Ga;Ha=+h[7963];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[15872]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[7972]){if(+h[7954]<=+h[7957]*.01){O=55;break a}if(Fa<=+h[7962]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[7967];h[7959]=ca;h[7939]=0.0;h[7944]=0.0;h[7947]=0.0;w=c[b>>2]|0;c[15872]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[7939]+ca*ca;h[7939]=La;J=m+(F<<3)|0;Ma=+h[7944]+ +h[K>>3]*+h[J>>3];h[7944]=Ma;ca=+h[J>>3];Na=+h[7947]+ca*ca;h[7947]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[7959];Ja=Ja+1|0;Ka=J}c[15872]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[7968];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[15948]=y;ua=+h[7942];va=y}if(ua<=+h[7962]*1.0e-4){O=55;break a}h[7945]=0.0;h[7952]=0.0;z=c[b>>2]|0;c[15872]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[7945]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[7952]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[15872]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[7951]=ca;oa=+h[7968];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[15932]=J;_=+V(+(v-ca*ca));h[7959]=_;v=oa/_;h[7969]=v;oa=ca/_;h[7970]=oa;w=c[b>>2]|0;c[15872]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[7970];Ta=+h[7969];Ua=Ua+1|0;Va=K}c[15872]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[15932]=e;v=S-R;h[7959]=v;h[7972]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function JY(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[7982]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[15970]=t;c[15960]=1;c[15954]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[15960]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[7984]=D;C=+h[x>>3]/D;h[7991]=C;z=+h[f+(B+y<<3)>>3]/D;h[7992]=z;B=c[d>>2]|0;c[15952]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[7984]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[7984];if((x|0)>=(B|0)){break}D=+h[7992];z=+h[7991];x=x+1|0}c[15952]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[15954]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[7991]=z;if((c[g>>2]|0)>1){D=-z;h[7991]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[7992]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[15952]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[7992]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[7991];t=t+1|0;x=A}c[15952]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[7989]=z;x=k+(w<<3)|0;H=+h[x>>3];h[7983]=H;D=H*H;h[7993]=D;h[7990]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[7982];a[63888]=0;do{if((u|0)==1){z=+h[7990];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[7984]=z;D=+h[7991]/z;h[7992]=D;H=+h[7983]/z;h[7991]=H;x=c[d>>2]|0;c[15952]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[7992];D=+h[7991];w=w+1|0;t=s}c[15952]=x+1;J=+h[7984]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[15956]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[15956]=u;M=u}t=u+1-M|0;c[15958]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[7990];z=+h[f+(t+w<<3)>>3]/D;h[7984]=z;h[7991]=z*+h[l>>3];H=+h[7983];h[7992]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[7984]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[7982]/+V(+(+h[7993]+z*N*z));h[7987]=C;if(!(D>=0.0)){O=-D}else{O=D}h[7988]=C*+V(+O);t=c[d>>2]|0;c[15952]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[7988]*(+h[A>>3]- +h[7991]*+h[n+(G<<3)>>3]- +h[7992]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[7984];z=+h[7983];H=+h[7987];v=v+1|0}c[15952]=t+1;P=+h[7990]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[63888]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[15952]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[7984]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[7984];K=Q+1|0;c[15952]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[15954]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[15962]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[7983];N=+h[7990];J=(+h[7989]*+h[f>>3]-O*P)/N;h[7991]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[7992]=P;c[15952]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[15952]=q;if((f|0)>=(b|0)){break a}N=+h[7992];O=+h[7991];f=q}}}while(0);b=R+1|0;c[15954]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function KY(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function LY(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((KY(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(63952,63968,116,63992)}else if((s|0)==14){i=g;return o|0}return 0}function MY(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((qpa(w,c[64e3+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[64104+(x<<2)>>2]|0;c[q>>2]=c[64e3+(x<<2)>>2];c[q+4>>2]=y;tW(23,0,64176,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=Uoa(D,8)|0;c[e+40>>2]=B;D=b+536|0;wW(c[D>>2]|0,(B|0)!=0|0,64216,p);B=Uoa(c[A>>2]|0,4)|0;c[e+36>>2]=B;wW(c[D>>2]|0,(B|0)!=0|0,64216,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=Uoa(c[C>>2]|0,4)|0;c[e+24>>2]=Soa(8)|0;C=Soa(4)|0;c[e+20>>2]=C;c[C>>2]=c[35880>>2];wW(c[D>>2]|0,(C|0)!=0|0,64216,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=Soa(C)|0;A=e+44|0;c[A>>2]=Soa(C)|0;C=Uoa(15,4)|0;E=e+12|0;c[E>>2]=C;wW(c[D>>2]|0,(C|0)!=0|0,64216,m);C=Uoa(5,4)|0;c[e+4>>2]=C;wW(c[D>>2]|0,(C|0)!=0|0,64216,l);C=Uoa(5,4)|0;c[e+8>>2]=C;wW(c[D>>2]|0,(C|0)!=0|0,64216,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=Soa(C)|0;c[e+76>>2]=Soa(C)|0;c[e+80>>2]=Soa(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ie[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){tW(23,0,64232,j)}else{tW(1,0,64304,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[35916>>2]|c[8954]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=64136;W=V;xW(Q,W,r)}c[t>>2]=w;vW(23,1,64032,t);t=1;do{w=c[64104+(t<<2)>>2]|0;c[s>>2]=c[64e3+(t<<2)>>2];c[s+4>>2]=w;vW(23,0,64088,s);t=t+1|0;}while((t|0)<8);fe[c[9094]&255](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=64136;W=V;xW(Q,W,r);return 0}function NY(a){a=a|0;var b=0;b=i;Toa(c[a+40>>2]|0);Toa(c[a+36>>2]|0);Toa(c[a+20>>2]|0);Toa(c[a+12>>2]|0);Toa(c[a+4>>2]|0);Toa(c[a+8>>2]|0);Toa(a);i=b;return 0}function OY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;wW(c[N>>2]|0,(c[M>>2]|0)!=0|0,64400,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){tW(3,0,64432,B);tW(3,0,64472,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ie[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tW(3,0,64496,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];tW(23,0,64536,y);if((c[z>>2]|0)==1){BX(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){J_(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 4:{XX(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};case 3:{XX(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{XX(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 7:{XX(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 5:{XX(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){XX(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{XX(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){ud(_|0)|0;ud($|0)|0;vW(3,0,64568,x);tW(3,0,64656,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){ud(_|0)|0;ud($|0)|0;$=XY(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){J_(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ie[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];vW(1,0,64680,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[35836>>2]|0)!=0){tW(3,1,64712,u);c[s>>2]=c[z>>2];tW(3,0,64736,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];tW(3,0,64760,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];tW(3,0,64792,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tW(3,0,64832,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];tW(3,0,64880,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];tW(3,0,64928,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];tW(3,0,64968,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];tW(3,0,65008,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];tW(3,0,65048,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];tW(3,0,65096,f);fe[c[9094]&255](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(65136,65168,410,65200)}tW(3,0,65216,e);S=0;i=d;return S|0}function PY(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;J_(g)|0;a=f+540|0;ie[c[(c[a>>2]|0)+40>>2]&127](g)|0;ie[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function QY(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;J_(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;ZY(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function RY(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];J_(g)|0;l=e+540|0;ie[c[(c[l>>2]|0)+40>>2]&127](g)|0;ie[c[(c[l>>2]|0)+28>>2]&127](g)|0;ie[c[(c[l>>2]|0)+32>>2]&127](g)|0;le[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function SY(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;_Y(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function TY(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;J_(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;YY(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function UY(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function VY(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;$Y(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function WY(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function XY(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-11:{vW(1,0,65624,d);m=-11;i=b;return m|0};case-7:{vW(1,0,65352,h);m=-7;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-9:{vW(1,0,65440,f);m=-9;i=b;return m|0};case-12:{vW(1,0,65712,c);m=-12;i=b;return m|0};case-8:{vW(1,0,65392,g);m=-8;i=b;return m|0};case-1:{vW(3,0,64568,l);m=1;i=b;return m|0};case-6:{vW(1,0,65280,j);m=-6;i=b;return m|0};case-10:{vW(1,0,65528,e);m=-10;i=b;return m|0};case-33:{vW(1,0,65760,b);m=-33;i=b;return m|0};case-2:{vW(1,0,65240,k);m=-2;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function YY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function ZY(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ie[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function _Y(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+td(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+td(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;PY(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}



function _i(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6216>>3];h[b+400>>3]=+h[b+592>>3]*+h[b+344>>3]*d+(+h[b+600>>3]*d*+h[b+352>>3]+ +h[b+608>>3]*d*+h[b+360>>3]);i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=-(+h[b+608>>3]*+h[b+336>>3])- +h[b+600>>3]*+h[b+328>>3]- +h[b+592>>3]*+h[b+320>>3];i=i;return}function aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=-+h[b+400>>3]- +h[b+304>>3];i=i;return}function bj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3]*+h[b+8>>3];e=c[a+416>>2]|0;h[b+480>>3]=d- +h[e+56>>3]*+h[b+544>>3]/-.1- -(+h[e+48>>3]*+h[b+552>>3])/-.1-d;i=i;return}function cj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+480>>3];i=i;return}function dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=(+h[b+504>>3]*+h[b+488>>3]+ +h[b+496>>3]*+h[b+512>>3])*2.0;i=i;return}function ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=(+h[b+504>>3]*+h[b+496>>3]- +h[b+488>>3]*+h[b+512>>3])*2.0;i=i;return}function fj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6216>>3];h[b+408>>3]=+h[b+616>>3]*+h[b+344>>3]*d+(+h[b+624>>3]*d*+h[b+352>>3]+ +h[b+632>>3]*d*+h[b+360>>3]);i=i;return}function gj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=-(+h[b+632>>3]*+h[b+336>>3])- +h[b+624>>3]*+h[b+328>>3]- +h[b+616>>3]*+h[b+320>>3];i=i;return}function hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=-+h[b+408>>3]- +h[b+312>>3];i=i;return}function ij(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3]*+h[b>>3];e=c[a+416>>2]|0;h[b+472>>3]=d- +h[e+48>>3]*+h[b+560>>3]/-.1- -(+h[e+64>>3]*+h[b+544>>3])/-.1-d;i=i;return}function jj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+472>>3];i=i;return}function kj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8>>3]*+h[b+16>>3];e=c[a+416>>2]|0;h[b+464>>3]=d- +h[e+64>>3]*+h[b+552>>3]/-.1- -(+h[e+56>>3]*+h[b+560>>3])/-.1-d;i=i;return}function lj(a){a=a|0;var b=0,d=0,e=0;b=i;RZ(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+528>>3]=+h[d>>3];h[e+536>>3]=+h[d+8>>3];h[e+520>>3]=+h[d+16>>3];i=b;return}function mj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+136>>3]=+h[b+520>>3];i=i;return}function nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+536>>3];i=i;return}function oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+144>>3]=+h[b+528>>3];i=i;return}function pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+464>>3];i=i;return}function qj(a){a=a|0;var b=0,d=0,e=0;b=i;RZ(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+712>>3]=+h[d>>3];h[e+688>>3]=+h[d+8>>3];h[e+704>>3]=+h[d+16>>3];h[e+696>>3]=+h[d+24>>3];i=b;return}function rj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[c[f>>2]>>2]|0;g=c[a+12>>2]|0;j=c[a+8>>2]|0;l=+h[j+712>>3];m=+h[j+704>>3];n=+h[j+696>>3];o=+h[j+688>>3];p=+(c[g>>2]|0)*l+ +(c[g+12>>2]|0)*m+ +(c[g+24>>2]|0)*n+ +(c[g+36>>2]|0)*o;q=l*+(c[g+8>>2]|0)+m*+(c[g+20>>2]|0)+n*+(c[g+32>>2]|0)+o*+(c[g+44>>2]|0);j=d;h[k>>3]=l*+(c[g+4>>2]|0)+m*+(c[g+16>>2]|0)+n*+(c[g+28>>2]|0)+o*+(c[g+40>>2]|0);c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rX(e,3,p,d);oX(e,(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184|0);i=b;return}function sj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[c[f>>2]>>2]|0;g=c[a+12>>2]|0;j=c[a+8>>2]|0;l=+h[j+512>>3];m=+h[j+504>>3];n=+h[j+496>>3];o=+h[j+488>>3];p=+(c[g>>2]|0)*l+ +(c[g+12>>2]|0)*m+ +(c[g+24>>2]|0)*n+ +(c[g+36>>2]|0)*o;q=l*+(c[g+8>>2]|0)+m*+(c[g+20>>2]|0)+n*+(c[g+32>>2]|0)+o*+(c[g+44>>2]|0);j=d;h[k>>3]=l*+(c[g+4>>2]|0)+m*+(c[g+16>>2]|0)+n*+(c[g+28>>2]|0)+o*+(c[g+40>>2]|0);c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rX(e,3,p,d);oX(e,(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+72|0);i=b;return}function tj(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+116>>2]=c[b+112>>2];i=i;return}function uj(a){a=a|0;h[(c[a+416>>2]|0)+1608>>3]=+(c[(c[a+420>>2]|0)+84>>2]|0);i=i;return}function vj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+1568>>3];i=i;return}function wj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+35|0]=a[d+31|0]|0;i=i;return}function xj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+34|0]=a[d+30|0]|0;i=i;return}function yj(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+108>>2]=c[b+104>>2];i=i;return}function zj(a){a=a|0;h[(c[a+416>>2]|0)+1528>>3]=+(c[(c[a+420>>2]|0)+80>>2]|0);i=i;return}function Aj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1520>>3]=+h[b+1488>>3];i=i;return}function Bj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+27|0]=a[d+23|0]|0;i=i;return}function Cj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+26|0]=a[d+22|0]|0;i=i;return}function Dj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+1448>>3];i=i;return}function Ej(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+21|0]=a[d]|0;i=i;return}function Fj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,3);h[(c[a+416>>2]|0)+920>>3]=l;i=b;return}function Gj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,2);h[(c[a+416>>2]|0)+912>>3]=l;i=b;return}function Hj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,1);h[(c[a+416>>2]|0)+904>>3]=l;i=b;return}function Ij(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,0);h[(c[a+416>>2]|0)+896>>3]=l;i=b;return}function Jj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+624>>3];i=i;return}function Kj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+616>>3];i=i;return}function Lj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+608>>3];i=i;return}function Mj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+14|0]=a[d]|0;i=i;return}function Nj(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+88>>2]=c[b+84>>2];i=i;return}function Oj(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+488>>3]- +h[b+512>>3];e=+h[b+496>>3]- +h[b+520>>3];f=+h[b+504>>3]- +h[b+528>>3];h[b+1344>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Pj(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1032>>3];j=+h[f+1344>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,4536,4528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1352>>3]=l;i=d;return}function Qj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1360>>3]=+h[b+1352>>3];i=i;return}function Rj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+13|0]=a[d]|0;i=i;return}function Sj(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+80>>2]=c[b+76>>2];i=i;return}function Tj(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+392>>3]- +h[b+416>>3];e=+h[b+400>>3]- +h[b+424>>3];f=+h[b+408>>3]- +h[b+432>>3];h[b+1312>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Uj(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1032>>3];j=+h[f+1312>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,4536,4568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1320>>3]=l;i=d;return}function Vj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1328>>3]=+h[b+1320>>3];i=i;return}function Wj(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+12|0]=a[d]|0;i=i;return}function Xj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+88>>3];i=i;return}function Yj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+80>>3];i=i;return}function Zj(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+72>>3];i=i;return}function _j(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+6|0]=a[d]|0;i=i;return}function $j(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1072>>3]=+h[b+1024>>3]*.5;i=i;return}function ak(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1040>>3];j=+h[f+1072>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,4584,4576,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1136>>3]=l;i=d;return}function bk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1168>>3]=+h[b+1136>>3]*3.0;i=i;return}function ck(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1176>>3]=+h[b+1136>>3];i=i;return}function dk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1184>>3]=+h[b+1136>>3]*3.0;i=i;return}function ek(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1144>>3]=+h[b+1072>>3]*.5;i=i;return}function fk(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1032>>3];j=+h[f+1144>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,4536,4624,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1192>>3]=l;i=d;return}function gk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1192>>3]*3.0;i=i;return}function hk(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1208>>3]=+sd(+(+h[d+1144>>3]),+(+h[d+1192>>3]*4.0));i=b;return}function ik(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1224>>3]=+td(0.0,+(+h[d+1144>>3]- +h[d+1208>>3]));i=b;return}function jk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+1072>>3]*1.05;i=i;return}function kk(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1160>>3]=+sd(+(+h[d+1072>>3]),+(+h[d+1136>>3]*5.0));i=b;return}function lk(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1200>>3]=+td(0.0,+(+h[d+1072>>3]- +h[d+1160>>3]));i=b;return}function mk(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4552>>3]=+h[b+32>>3]- +h[b+1224>>3];i=i;return}function nk(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+1184>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=d;i=i;return}function ok(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+1184>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=d;i=i;return}function pk(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+1184>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3336|0;w=v;h[w>>3]=j;i=b;return}x=c[21290]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=4808;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,4640,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3336|0;w=v;h[w>>3]=j;i=b;return}function qk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=l;i=b;return}function rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=l;i=b;return}function sk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=l;i=b;return}function tk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=l;i=b;return}function uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=l;i=b;return}function vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=l;i=b;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3240>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+3264>>3]- +h[b+3288>>3]);i=i;return}function xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3232>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+3256>>3]- +h[b+3280>>3]);i=i;return}function yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3224>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+3248>>3]- +h[b+3272>>3]);i=i;return}function zk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3216>>3]=+h[b+1152>>3]+ +h[d+3288>>3]*+h[b+1184>>3];i=i;return}function Ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3208>>3]=+h[b+3280>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Bk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3200>>3]=+h[b+3272>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Ck(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3192>>3]=+h[b+3264>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3184>>3]=+h[b+3256>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3176>>3]=+h[b+3248>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Fk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3168>>3]=+h[b+1152>>3]+ +h[d+3288>>3]*+h[b+1184>>3];i=i;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3160>>3]=+h[b+3280>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3152>>3]=+h[b+3272>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3144>>3]=+h[b+3264>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3136>>3]=+h[b+3256>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3128>>3]=+h[b+3248>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function Lk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=+h[(c[a+416>>2]|0)+1184>>3]*.75;i=i;return}function Mk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=+h[(c[a+416>>2]|0)+1184>>3]*.5;i=i;return}function Nk(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=+h[(c[a+416>>2]|0)+1184>>3]*1.5;i=i;return}function Ok(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=+h[(c[a+416>>2]|0)+1184>>3]*1.5;i=i;return}function Pk(a){a=a|0;var b=0.0,d=0,e=0.0;b=+h[(c[a+416>>2]|0)+1184>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=+h[d+2944>>3];h[d+2760>>3]=+V(+(b*b+e*e));i=i;return}function Qk(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2968>>3];e=+h[b+2976>>3]- +h[b+2960>>3];h[b+2752>>3]=+V(+(d*d+e*e));i=i;return}function Rk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=l;i=b;return}function Sk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=l;i=b;return}function Tk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=l;i=b;return}function Uk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=l;i=b;return}function Vk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=l;i=b;return}function Wk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=l;i=b;return}function Xk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2680>>3]*+h[b+2968>>3]+ +h[b+2704>>3]*(+h[b+2976>>3]- +h[b+2960>>3]);i=i;return}function Yk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2672>>3]*+h[b+2968>>3]+ +h[b+2696>>3]*(+h[b+2976>>3]- +h[b+2960>>3]);i=i;return}function Zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+2664>>3]*+h[b+2968>>3]+ +h[b+2688>>3]*(+h[b+2976>>3]- +h[b+2960>>3]);i=i;return}function _k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+2704>>3]*+h[b+2960>>3];i=i;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[(c[a+416>>2]|0)+1152>>3]+ +h[b+2696>>3]*+h[b+2960>>3];i=i;return}function al(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+2688>>3]*+h[b+2960>>3];i=i;return}function bl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+2680>>3]*+h[(c[a+416>>2]|0)+1184>>3]+ +h[b+2704>>3]*+h[b+2944>>3];i=i;return}function cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+2672>>3]*+h[(c[a+416>>2]|0)+1184>>3]+ +h[b+2696>>3]*+h[b+2944>>3];i=i;return}function dl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+2664>>3]*+h[(c[a+416>>2]|0)+1184>>3]+ +h[b+2688>>3]*+h[b+2944>>3];i=i;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+1184>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2296|0;w=v;h[w>>3]=j;i=b;return}x=c[21290]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=4808;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,4640,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2296|0;w=v;h[w>>3]=j;i=b;return}function fl(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+1184>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2288|0;w=v;h[w>>3]=j;i=b;return}x=c[21290]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=4808;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,4640,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2288|0;w=v;h[w>>3]=j;i=b;return}function gl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2240>>3]=l;i=b;return}function hl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2216>>3]=l;i=b;return}function il(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2232>>3]=l;i=b;return}function jl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2208>>3]=l;i=b;return}function kl(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2224>>3]=l;i=b;return}function ll(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2200>>3]=l;i=b;return}function ml(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2216>>3]- +h[b+2240>>3]);i=i;return}function nl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2208>>3]- +h[b+2232>>3]);i=i;return}function ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2200>>3]- +h[b+2224>>3]);i=i;return}function pl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=+h[b+2240>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function ql(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=+h[b+2232>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function rl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2152>>3]=+h[b+1152>>3]+ +h[d+2224>>3]*+h[b+1184>>3];i=i;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2216>>3]+ +h[b+2240>>3]);i=i;return}function tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2208>>3]+ +h[b+2232>>3]);i=i;return}function ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2200>>3]+ +h[b+2224>>3]);i=i;return}function vl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1128>>3]=+h[b+1024>>3]*.025;i=i;return}function wl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+1024>>3]/9.0;i=i;return}function xl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1112>>3]=+h[b+1024>>3]*.05;i=i;return}function yl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[(c[a+416>>2]|0)+1112>>3]*.6;i=i;return}function zl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+1024>>3]*.05;i=i;return}function Al(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1088>>3]=+h[b+1024>>3]*.1;i=i;return}function Bl(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1080>>3]=+h[b+1024>>3]*.2;i=i;return}function Cl(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+1|0]|0)==0){e=0}else{e=(a[d+3|0]|0)!=0|0}c[(c[b+420>>2]|0)+60>>2]=e;i=i;return}function Dl(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e+1|0]|0)==0){f=0}else{if((a[e+2|0]|0)==0){f=0;break}f=(a[e+5|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+56>>2]=f;i=d;return}function El(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+1|0]|0)==0){e=0}else{e=(a[d+2|0]|0)!=0|0}c[(c[b+420>>2]|0)+52>>2]=e;i=i;return}function Fl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=0.0;i=i;return}function Gl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function Hl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function Il(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6144>>3]=1.0;i=i;return}function Jl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6120>>3]=0.0;i=i;return}function Kl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6096>>3]=0.0;i=i;return}function Ll(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6136>>3]=0.0;i=i;return}function Ml(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6112>>3]=1.0;i=i;return}function Nl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6088>>3]=0.0;i=i;return}function Ol(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function Pl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function Ql(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=1.0;i=i;return}function Rl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6072>>3]=0.0;i=i;return}function Sl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6064>>3]=0.0;i=i;return}function Tl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6056>>3]=0.0;i=i;return}function Ul(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function Vl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6576>>3]=0.0;i=i;return}function Wl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=0.0;i=i;return}function Xl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function Yl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=0.0;i=i;return}function Zl(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6024>>3]=0.0;i=i;return}function _l(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function $l(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=0.0;i=i;return}function am(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6568>>3]=0.0;i=i;return}function bm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6e3>>3]=0.0;i=i;return}function cm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function dm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function em(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function fm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function gm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function hm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function im(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function jm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function km(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function lm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5920>>3]=0.0;i=i;return}function mm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5912>>3]=0.0;i=i;return}function nm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function om(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5896>>3]=0.0;i=i;return}function pm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5888>>3]=0.0;i=i;return}function qm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function rm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=0.0;i=i;return}function sm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=1.0;i=i;return}function tm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5856>>3]=0.0;i=i;return}function um(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function vm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=1.0;i=i;return}function wm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5832>>3]=0.0;i=i;return}function xm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function ym(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function zm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5800>>3]=0.0;i=i;return}function Am(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5760>>3]=0.0;i=i;return}function Bm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=0.0;i=i;return}function Cm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function Dm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function Em(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=0;i=i;return}function Fm(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=0;i=i;return}function Gm(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=255;i=i;return}function Hm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5712>>3]=255.0;i=i;return}function Im(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function Jm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function Km(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function Lm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=1.0;i=i;return}function Mm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function Nm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=0.0;i=i;return}function Om(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=-1.0;i=i;return}function Pm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function Qm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function Rm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5648>>3]=0.0;i=i;return}function Sm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5640>>3]=0.0;i=i;return}function Tm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5632>>3]=0.0;i=i;return}function Um(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5624>>3]=0.0;i=i;return}function Vm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function Wm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=0.0;i=i;return}function Xm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function Ym(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=0.0;i=i;return}function Zm(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5584>>3]=0.0;i=i;return}function _m(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function $m(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function an(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=1.0;i=i;return}function bn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function cn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=0.0;i=i;return}function dn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5536>>3]=0.0;i=i;return}function en(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function fn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function gn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function hn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function jn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=128.0;i=i;return}function kn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=255.0;i=i;return}function ln(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function mn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5496>>3]=128.0;i=i;return}function nn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=255.0;i=i;return}function on(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function pn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5472>>3]=1.0;i=i;return}function qn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5464>>3]=0.0;i=i;return}function rn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function sn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5448>>3]=0.0;i=i;return}function tn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5440>>3]=1.0;i=i;return}function un(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[b+584>>3]+ +h[b+1424>>3]*-.5;i=i;return}function vn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5424>>3]=0.0;i=i;return}function wn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5416>>3]=1.0;i=i;return}function xn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=0.0;i=i;return}function yn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function zn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5392>>3]=0.0;i=i;return}function An(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function Bn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=155;i=i;return}function Cn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=155;i=i;return}function Dn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=155;i=i;return}function En(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=155.0;i=i;return}function Fn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5368>>3]=155.0;i=i;return}function Gn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5376>>3]=155.0;i=i;return}function Hn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function In(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=1.0;i=i;return}function Jn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function Kn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=0.0;i=i;return}function Ln(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=0.0;i=i;return}function Mn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=.6;i=i;return}function Nn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=155;i=i;return}function On(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=155;i=i;return}function Pn(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=155;i=i;return}function Qn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=155.0;i=i;return}function Rn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5296>>3]=155.0;i=i;return}function Sn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=155.0;i=i;return}function Tn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function Un(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5272>>3]=1.0;i=i;return}function Vn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function Wn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=0.0;i=i;return}function Xn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function Yn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=.3;i=i;return}function Zn(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5232>>3]=0.0;i=i;return}function _n(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=0.0;i=i;return}function $n(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function ao(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=0.0;i=i;return}function bo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function co(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function eo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=0.0;i=i;return}function fo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5176>>3]=0.0;i=i;return}function go(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=0.0;i=i;return}function ho(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function io(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function jo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function ko(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function lo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=128.0;i=i;return}function mo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=255.0;i=i;return}function no(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function oo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=128.0;i=i;return}function po(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5136>>3]=255.0;i=i;return}function qo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=0.0;i=i;return}function ro(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=1.0;i=i;return}function so(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function to(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5088>>3]=0.0;i=i;return}function uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5080>>3]=0.0;i=i;return}function vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=1.0;i=i;return}function wo(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5064>>3]=+h[b+48>>3]+ +h[b+1288>>3]*-.5;i=i;return}function xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5056>>3]=0.0;i=i;return}function yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=1.0;i=i;return}function zo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5040>>3]=0.0;i=i;return}function Ao(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=0.0;i=i;return}function Bo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function Co(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5016>>3]=0.0;i=i;return}function Do(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function Eo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function Fo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function Go(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4992>>3]=155.0;i=i;return}function Ho(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=155.0;i=i;return}function Io(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5008>>3]=155.0;i=i;return}function Jo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4984>>3]=0.0;i=i;return}function Ko(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=1.0;i=i;return}function Lo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4968>>3]=0.0;i=i;return}function Mo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=100;i=i;return}function No(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=100;i=i;return}function Oo(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=100;i=i;return}function Po(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4944>>3]=100.0;i=i;return}function Qo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=100.0;i=i;return}function Ro(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4960>>3]=100.0;i=i;return}function So(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4936>>3]=0.0;i=i;return}function To(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=1.0;i=i;return}function Uo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4920>>3]=0.0;i=i;return}function Vo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4912>>3]=0.0;i=i;return}function Wo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=0.0;i=i;return}function Xo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4896>>3]=0.0;i=i;return}function Yo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4888>>3]=0.0;i=i;return}function Zo(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function _o(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=0.0;i=i;return}function $o(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4864>>3]=0.0;i=i;return}function ap(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=0.0;i=i;return}function bp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4848>>3]=0.0;i=i;return}function cp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4840>>3]=0.0;i=i;return}function dp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4832>>3]=0.0;i=i;return}function ep(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4824>>3]=0.0;i=i;return}function fp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=255;i=i;return}function gp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=0;i=i;return}function hp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function ip(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4800>>3]=0.0;i=i;return}function jp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=0.0;i=i;return}function kp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=255.0;i=i;return}function lp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=0.0;i=i;return}function mp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=0.0;i=i;return}function np(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=0.0;i=i;return}function op(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=255;i=i;return}function pp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=128;i=i;return}function qp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=0;i=i;return}function rp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=0.0;i=i;return}function sp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=0.0;i=i;return}function tp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=0.0;i=i;return}function up(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=0.0;i=i;return}function vp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=0.0;i=i;return}function wp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4728>>3]=0.0;i=i;return}function xp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4720>>3]=0.0;i=i;return}function yp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=0.0;i=i;return}function zp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=0.0;i=i;return}function Ap(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=255;i=i;return}function Bp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=0;i=i;return}function Cp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=0;i=i;return}function Dp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4680>>3]=0.0;i=i;return}function Ep(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4688>>3]=0.0;i=i;return}function Fp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=255.0;i=i;return}function Gp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=0.0;i=i;return}function Hp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4664>>3]=0.0;i=i;return}function Ip(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4656>>3]=0.0;i=i;return}function Jp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=255;i=i;return}function Kp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=128;i=i;return}function Lp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=0;i=i;return}function Mp(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=0;i=i;return}function Np(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=230;i=i;return}function Op(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=0;i=i;return}function Pp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4632>>3]=0.0;i=i;return}function Qp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4640>>3]=230.0;i=i;return}function Rp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=0.0;i=i;return}function Sp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4608>>3]=0.0;i=i;return}function Tp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=230.0;i=i;return}function Up(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4624>>3]=0.0;i=i;return}function Vp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=0.0;i=i;return}function Wp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4592>>3]=1.0;i=i;return}function Xp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=0.0;i=i;return}function Yp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4576>>3]=0.0;i=i;return}function Zp(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4568>>3]=-1.0;i=i;return}function _p(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function $p(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=0.0;i=i;return}function aq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=0.0;i=i;return}function bq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=0.0;i=i;return}function cq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=0.0;i=i;return}function dq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=1.0;i=i;return}function eq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function fq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4496>>3]=0.0;i=i;return}function gq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4488>>3]=-1.0;i=i;return}function hq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4480>>3]=0.0;i=i;return}function iq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=0.0;i=i;return}function jq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4464>>3]=0.0;i=i;return}function kq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4456>>3]=0.0;i=i;return}function lq(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=0;i=i;return}function mq(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=0;i=i;return}function nq(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function oq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4432>>3]=0.0;i=i;return}function pq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4440>>3]=0.0;i=i;return}function qq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function rq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=0.0;i=i;return}function sq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4416>>3]=0.0;i=i;return}function tq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=0.0;i=i;return}function uq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4384>>3]=0.0;i=i;return}function vq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4392>>3]=0.0;i=i;return}function wq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=0.0;i=i;return}function xq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4360>>3]=0.0;i=i;return}function yq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4368>>3]=0.0;i=i;return}function zq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=0.0;i=i;return}function Aq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4336>>3]=0.0;i=i;return}function Bq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4344>>3]=0.0;i=i;return}function Cq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function Dq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4312>>3]=0.0;i=i;return}function Eq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4320>>3]=0.0;i=i;return}function Fq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=0.0;i=i;return}function Gq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4288>>3]=0.0;i=i;return}function Hq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4296>>3]=0.0;i=i;return}function Iq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3]=0.0;i=i;return}function Jq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4264>>3]=0.0;i=i;return}function Kq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4272>>3]=0.0;i=i;return}function Lq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4280>>3]=0.0;i=i;return}function Mq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4240>>3]=0.0;i=i;return}function Nq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4248>>3]=0.0;i=i;return}function Oq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4256>>3]=0.0;i=i;return}function Pq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4216>>3]=0.0;i=i;return}function Qq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4224>>3]=0.0;i=i;return}function Rq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4232>>3]=0.0;i=i;return}function Sq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4192>>3]=0.0;i=i;return}function Tq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4200>>3]=0.0;i=i;return}function Uq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4208>>3]=0.0;i=i;return}function Vq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3]=0.0;i=i;return}function Wq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4176>>3]=0.0;i=i;return}function Xq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4184>>3]=0.0;i=i;return}function Yq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4144>>3]=0.0;i=i;return}function Zq(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4152>>3]=0.0;i=i;return}function _q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4160>>3]=0.0;i=i;return}function $q(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4136>>3]=0.0;i=i;return}function ar(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4128>>3]=1.0;i=i;return}function br(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4120>>3]=0.0;i=i;return}function cr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4112>>3]=1.0;i=i;return}function dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4104>>3]=0.0;i=i;return}function er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4096>>3]=0.0;i=i;return}function fr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4088>>3]=0.0;i=i;return}function gr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4080>>3]=0.0;i=i;return}function hr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4072>>3]=0.0;i=i;return}function ir(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4064>>3]=0.0;i=i;return}function jr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4056>>3]=0.0;i=i;return}function kr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4048>>3]=0.0;i=i;return}function lr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4040>>3]=1.0;i=i;return}function mr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=0.0;i=i;return}function nr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3]=1.0;i=i;return}function or(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4016>>3]=0.0;i=i;return}function pr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function qr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=0.0;i=i;return}function rr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=0.0;i=i;return}function sr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function tr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=0.0;i=i;return}function ur(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function vr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=0.0;i=i;return}function wr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=0.0;i=i;return}function xr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=0.0;i=i;return}function yr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=1.0;i=i;return}function zr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=0.0;i=i;return}function Ar(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3920>>3]=1.0;i=i;return}function Br(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=0.0;i=i;return}function Cr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=0.0;i=i;return}function Dr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=0.0;i=i;return}function Er(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=0.0;i=i;return}function Fr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=0.0;i=i;return}function Gr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=0.0;i=i;return}function Hr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3864>>3]=0.0;i=i;return}function Ir(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3856>>3]=0.0;i=i;return}function Jr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3848>>3]=1.0;i=i;return}function Kr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3840>>3]=0.0;i=i;return}function Lr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3832>>3]=1.0;i=i;return}function Mr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3824>>3]=0.0;i=i;return}function Nr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3816>>3]=0.0;i=i;return}function Or(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=0.0;i=i;return}function Pr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3800>>3]=0.0;i=i;return}function Qr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3792>>3]=0.0;i=i;return}function Rr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3784>>3]=0.0;i=i;return}function Sr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3776>>3]=0.0;i=i;return}function Tr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3768>>3]=0.0;i=i;return}function Ur(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3760>>3]=1.0;i=i;return}function Vr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3752>>3]=0.0;i=i;return}function Wr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3744>>3]=0.0;i=i;return}function Xr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3736>>3]=0.0;i=i;return}function Yr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3728>>3]=1.0;i=i;return}function Zr(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3720>>3]=0.0;i=i;return}function _r(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3712>>3]=0.0;i=i;return}function $r(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3704>>3]=0.0;i=i;return}function as(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3696>>3]=0.0;i=i;return}function bs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3688>>3]=0.0;i=i;return}function cs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3680>>3]=0.0;i=i;return}function ds(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3672>>3]=1.0;i=i;return}function es(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3664>>3]=0.0;i=i;return}function fs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3656>>3]=0.0;i=i;return}function gs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3648>>3]=0.0;i=i;return}function hs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3640>>3]=1.0;i=i;return}function is(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3632>>3]=0.0;i=i;return}function js(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3624>>3]=0.0;i=i;return}function ks(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3616>>3]=0.0;i=i;return}function ls(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3608>>3]=0.0;i=i;return}function ms(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3600>>3]=0.0;i=i;return}function ns(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=0.0;i=i;return}function os(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=0.0;i=i;return}function ps(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=1.0;i=i;return}function qs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=0.0;i=i;return}function rs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=0.0;i=i;return}function ss(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=0.0;i=i;return}function ts(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=0.0;i=i;return}function us(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=0.0;i=i;return}function vs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=0.0;i=i;return}function ws(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=0.0;i=i;return}function xs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=0.0;i=i;return}function ys(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=1.0;i=i;return}function zs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function As(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=1.0;i=i;return}function Bs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function Cs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function Ds(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=0.0;i=i;return}function Es(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=0.0;i=i;return}function Fs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function Gs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function Hs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=0.0;i=i;return}function Is(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=1.0;i=i;return}function Js(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=0.0;i=i;return}function Ks(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function Ls(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function Ms(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=1.0;i=i;return}function Ns(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=0.0;i=i;return}function Os(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=0.0;i=i;return}function Ps(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=0.0;i=i;return}function Qs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=1.0;i=i;return}function Rs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=0.0;i=i;return}function Ss(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=0.0;i=i;return}function Ts(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=l;i=b;return}function Us(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=l;i=b;return}function Vs(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=l;i=b;return}function Ws(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=0.0;i=i;return}function Xs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function Ys(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=0.0;i=i;return}function Zs(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=0.0;i=i;return}function _s(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=1.0;i=i;return}function $s(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=0.0;i=i;return}function at(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=0.0;i=i;return}function bt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function dt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function et(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=1.0;i=i;return}function ft(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=0.0;i=i;return}function gt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function ht(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=0.0;i=i;return}function it(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=0.0;i=i;return}function jt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function kt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=1.0;i=i;return}function lt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function mt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function nt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function ot(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function pt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function qt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2912>>3]=0.0;i=i;return}function rt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=-1.0;i=i;return}function st(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=0.0;i=i;return}function tt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=1.0;i=i;return}function ut(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function vt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function wt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function xt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function yt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function zt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function At(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=1.0;i=i;return}function Bt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=0.0;i=i;return}function Ct(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=0.0;i=i;return}function Dt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=0.0;i=i;return}function Et(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=1.0;i=i;return}function Ft(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=0.0;i=i;return}function Gt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=0.0;i=i;return}function Ht(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=0.0;i=i;return}function It(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=1.0;i=i;return}function Jt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=0.0;i=i;return}function Kt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=0.0;i=i;return}function Lt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=l;i=b;return}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=l;i=b;return}function Nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4792;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=l;i=b;return}function Ot(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=0.0;i=i;return}function Pt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=0.0;i=i;return}function Qt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=0.0;i=i;return}function Rt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=0.0;i=i;return}function St(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=1.0;i=i;return}function Tt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=0.0;i=i;return}function Ut(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=0.0;i=i;return}function Vt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=0.0;i=i;return}function Wt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function Xt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function Yt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=1.0;i=i;return}function Zt(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=0.0;i=i;return}function _t(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=0.0;i=i;return}function $t(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=0.0;i=i;return}function au(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=0.0;i=i;return}function bu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=0.0;i=i;return}function cu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=0.0;i=i;return}function du(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=1.0;i=i;return}function eu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=0.0;i=i;return}function fu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=0.0;i=i;return}function gu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=0.0;i=i;return}function hu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=1.0;i=i;return}function iu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=0.0;i=i;return}function ju(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=0.0;i=i;return}function ku(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2392>>3]=0.0;i=i;return}function lu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2384>>3]=0.0;i=i;return}function mu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2376>>3]=0.0;i=i;return}function nu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2368>>3]=1.0;i=i;return}function ou(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2360>>3]=0.0;i=i;return}function pu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2352>>3]=0.0;i=i;return}function qu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2344>>3]=0.0;i=i;return}function ru(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2336>>3]=1.0;i=i;return}function su(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2328>>3]=0.0;i=i;return}function tu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2320>>3]=0.0;i=i;return}function uu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2312>>3]=0.0;i=i;return}function vu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2304>>3]=1.0;i=i;return}function wu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2280>>3]=0.0;i=i;return}function xu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2272>>3]=0.0;i=i;return}function yu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2264>>3]=l;i=b;return}function zu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2256>>3]=l;i=b;return}function Au(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4776;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2248>>3]=l;i=b;return}function Bu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2120>>3]=0.0;i=i;return}function Cu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2112>>3]=0.0;i=i;return}function Du(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2104>>3]=0.0;i=i;return}function Eu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2096>>3]=0.0;i=i;return}function Fu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2088>>3]=1.0;i=i;return}function Gu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2080>>3]=0.0;i=i;return}function Hu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2072>>3]=0.0;i=i;return}function Iu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2064>>3]=0.0;i=i;return}function Ju(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=0.0;i=i;return}function Ku(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function Lu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=230;i=i;return}function Mu(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=0;i=i;return}function Nu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6552>>3]=0.0;i=i;return}function Ou(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function Pu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6528>>3]=.1;i=i;return}function Qu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6520>>3]=.01;i=i;return}function Ru(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6512>>3]=.07200000000000001;i=i;return}function Su(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6504>>3]=.02;i=i;return}function Tu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function Uu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2040>>3]=0.0;i=i;return}function Vu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=0.0;i=i;return}function Wu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=1.0;i=i;return}function Xu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=0.0;i=i;return}function Yu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=0.0;i=i;return}function Zu(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=0.0;i=i;return}function _u(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=1.0;i=i;return}function $u(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1984>>3]=0.0;i=i;return}function av(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1976>>3]=0.0;i=i;return}function bv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1968>>3]=0.0;i=i;return}function cv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=1.0;i=i;return}function dv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6496>>3]=.1;i=i;return}function ev(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6488>>3]=.01;i=i;return}function fv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=.07200000000000001;i=i;return}function gv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=.02;i=i;return}function hv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1952>>3]=0.0;i=i;return}function iv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=0.0;i=i;return}function jv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1936>>3]=0.0;i=i;return}function kv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1928>>3]=1.0;i=i;return}function lv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1920>>3]=0.0;i=i;return}function mv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1912>>3]=0.0;i=i;return}function nv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1904>>3]=0.0;i=i;return}function ov(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1896>>3]=1.0;i=i;return}function pv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1888>>3]=0.0;i=i;return}function qv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1880>>3]=0.0;i=i;return}function rv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=0.0;i=i;return}function sv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=1.0;i=i;return}function tv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function uv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6456>>3]=0.0;i=i;return}function vv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6448>>3]=0.0;i=i;return}function wv(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;b=i;d=a+416|0;e=c[d>>2]|0;f=+h[e+584>>3];g=+h[e+592>>3];j=+h[e+600>>3];k=+V(+(f*f+g*g+j*j));if((DZ(k,+h[e+1424>>3]*.5)|0)<<24>>24==0){l=0.0;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6440|0;x=w;h[x>>3]=l;i=b;return}e=c[d>>2]|0;y=DZ(+h[e+1432>>3],+h[e+1424>>3]*1.1)|0;e=c[d>>2]|0;k=+h[e+584>>3];j=+h[e+592>>3];g=+h[e+600>>3];f=+V(+(k*k+j*j+g*g));if(y<<24>>24==0){z=0.0}else{z=+h[e+1424>>3]*.5}l=f-z;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6440|0;x=w;h[x>>3]=l;i=b;return}function xv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function yv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=0.0;i=i;return}function zv(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;b=i;d=a+416|0;e=c[d>>2]|0;f=+h[e+48>>3];g=+h[e+56>>3];j=+h[e+64>>3];k=+V(+(f*f+g*g+j*j));if((DZ(k,+h[e+1288>>3]*.5)|0)<<24>>24==0){l=0.0;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6416|0;x=w;h[x>>3]=l;i=b;return}e=c[d>>2]|0;y=DZ(+h[e+1296>>3],+h[e+1288>>3]*1.1)|0;e=c[d>>2]|0;k=+h[e+48>>3];j=+h[e+56>>3];g=+h[e+64>>3];f=+V(+(k*k+j*j+g*g));if(y<<24>>24==0){z=0.0}else{z=+h[e+1288>>3]*.5}l=f-z;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6416|0;x=w;h[x>>3]=l;i=b;return}function Av(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6408>>3]=0.0;i=i;return}function Bv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function Cv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=0.0;i=i;return}function Dv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=0.0;i=i;return}function Ev(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=0.0;i=i;return}function Fv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1832>>3]=1.0;i=i;return}function Gv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1824>>3]=0.0;i=i;return}function Hv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1816>>3]=0.0;i=i;return}function Iv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1808>>3]=0.0;i=i;return}function Jv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=1.0;i=i;return}function Kv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1792>>3]=0.0;i=i;return}function Lv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1784>>3]=0.0;i=i;return}function Mv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1776>>3]=0.0;i=i;return}function Nv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1768>>3]=1.0;i=i;return}function Ov(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6392>>3]=0.0;i=i;return}function Pv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6384>>3]=0.0;i=i;return}function Qv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=0.0;i=i;return}function Rv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1752>>3]=0.0;i=i;return}function Sv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=0.0;i=i;return}function Tv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1736>>3]=1.0;i=i;return}function Uv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1728>>3]=0.0;i=i;return}function Vv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1720>>3]=0.0;i=i;return}function Wv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1712>>3]=0.0;i=i;return}function Xv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1704>>3]=1.0;i=i;return}function Yv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1696>>3]=0.0;i=i;return}function Zv(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1688>>3]=0.0;i=i;return}function _v(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1680>>3]=0.0;i=i;return}function $v(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1672>>3]=1.0;i=i;return}function aw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6376>>3]=0.0;i=i;return}function bw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6368>>3]=0.0;i=i;return}function cw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1664>>3]=0.0;i=i;return}function dw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1656>>3]=0.0;i=i;return}function ew(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=0.0;i=i;return}function fw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1640>>3]=1.0;i=i;return}function gw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1632>>3]=0.0;i=i;return}function hw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=0.0;i=i;return}function iw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=0.0;i=i;return}function jw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=1.0;i=i;return}function kw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1600>>3]=0.0;i=i;return}function lw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1592>>3]=0.0;i=i;return}function mw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=0.0;i=i;return}function nw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1576>>3]=1.0;i=i;return}function ow(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6360>>3]=0.0;i=i;return}function pw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=0.0;i=i;return}



function $Y(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+td(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+td(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}PY(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function aZ(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function bZ(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;fe[c[(c[a+540>>2]|0)+112>>2]&255](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function cZ(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function dZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=EW(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{xe[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;CW(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=EW(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function eZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((dZ(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}fZ(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(EW(d)|0)>0;h=b?2:0;i=e;return h|0}function fZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=Soa(q)|0;s=r;t=Soa(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[16630]=AW(4)|0;if((r|0)==0){cb(66528,66544,308,66576)}if((t|0)==0){cb(66592,66544,309,66576)}v=HW(b)|0;if((v|0)!=0){w=v;do{v=JW(w)|0;c[l>>2]=c[v>>2];tW(27,0,66608,l);w=IW(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;wpa(t|0,c[a+384>>2]|0,v|0)|0;wpa(r|0,l|0,v|0)|0}h[d>>3]=+iZ(a,n,o,q,s,c[16630]|0,b);do{if((EW(c[16630]|0)|0)==0){s=FW(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=HW(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=JW(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=IW(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];tW(27,0,66656,j);v=HW(b)|0;if((v|0)==0){break}else{B=v}do{v=JW(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[16630]|0;DW(v,JW(B)|0);v=JW(B)|0;c[g>>2]=c[v>>2];tW(27,0,66680,g)}B=IW(B)|0;}while((B|0)!=0)}}while(0);BW(b);if((c[35852>>2]|0)!=0){EW(c[16630]|0)|0}if((EW(c[16630]|0)|0)>0){B=m;do{g=FW(c[16630]|0)|0;c[m>>2]=c[g>>2];GW(c[16630]|0);c[f>>2]=c[m>>2];tW(7,0,66704,f);CW(b,B);}while((EW(c[16630]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){wpa(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ze(a);lZ(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){Toa(t);Toa(r);i=e;return}wpa(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;Toa(t);Toa(r);i=e;return}function gZ(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){pZ(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tW(7,0,66248,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((EW(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[35852>>2]|0)!=0){e=HW(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=JW(s)|0;x=c[e>>2]|0;e=xe[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;sW(7,0,w,66272,l);s=IW(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=JW(HW(d)|0)|0;x=xe[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;sW(1,0,e,66288,j);c[s>>2]=1}}while(0);BW(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;kZ(b);hZ(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function hZ(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;tW(27,0,66896,b);d=a+344|0;le[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function iZ(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=Soa(p<<3)|0;if((q|0)==0){cb(66712,66544,409,66728)}if((p|0)>0){wpa(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tW(27,0,66744,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(27,0,66792,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){Toa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}J_(a)|0;ie[c[(c[p>>2]|0)+40>>2]&127](a)|0;ie[c[(c[p>>2]|0)+28>>2]&127](a)|0;ie[c[(c[p>>2]|0)+32>>2]&127](a)|0;le[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(jZ(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}wpa(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}Toa(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function jZ(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;BW(b);tW(27,0,66816,g);g=HW(d)|0;if((g|0)==0){j=EW(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=JW(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=JW(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=JW(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=JW(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=JW(a)|0;o=c[g>>2]|0;g=JW(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?66232:66240;g=JW(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?66232:66240;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;tW(27,0,66856,f);CW(b,JW(a)|0)}a=IW(a)|0;}while((a|0)!=0);j=EW(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function kZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;xe[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;lZ(b);mZ(b);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;nZ(b,8);h=oZ(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{mZ(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}pZ(b);lZ(b);nZ(b,8);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=oZ(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){xW(c[b+536>>2]|0,66936,e)}else if((o|0)==7){mZ(b);i=d;return}}function lZ(a){a=a|0;var b=0;b=i;wpa(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function mZ(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function nZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[35824+(d<<2)>>2]|0)==0){i=e;return}tW(d,1,67360,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;tW(d,0,67384,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}fe[c[9094]&255](d);i=e;return}function oZ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function pZ(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;wpa(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;wpa(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;wpa(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;wpa(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function qZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}le[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function rZ(a){a=a|0;var b=0;b=i;sZ(a);tZ(a);pZ(a);uZ(a);i=b;return}function sZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function tZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function uZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((AX(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];wpa(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;wpa(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;wpa(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;wpa(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(AX(c[d>>2]|0)|0));i=b;return}function vZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[35824+(d<<2)>>2]|0)==0){i=e;return}tW(d,1,67032,q);q=b+136|0;if((c[q>>2]|0)>0){tW(d,1,67056,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?67016:67024;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];tW(d,0,67072,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}fe[c[9094]&255](d)}s=b+140|0;if((c[s>>2]|0)>0){tW(d,1,67128,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?67016:67024;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;tW(d,0,67152,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}fe[c[9094]&255](d)}o=b+144|0;if((c[o>>2]|0)>0){tW(d,1,67208,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?67016:67024;v=(a[n+(m*48|0)+40|0]|0)!=0?67016:67024;n=(a[(c[s>>2]|0)+m|0]|0)!=0?67016:67024;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;tW(d,0,67232,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}fe[c[9094]&255](d)}m=b+148|0;if((c[m>>2]|0)>0){tW(d,1,67288,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;tW(d,0,67312,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}fe[c[9094]&255](d)}fe[c[9094]&255](d);i=e;return}function wZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((AX(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];wpa(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;wpa(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;wpa(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;wpa(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(AX(c[d>>2]|0)|0));i=b;return}function xZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function yZ(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];wpa(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;wpa(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;wpa(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;wpa(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function zZ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=vX(3,32)|0;c[o>>2]=p;if((p|0)==0){xW(c[b+536>>2]|0,67416,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=Uoa(c[p>>2]|0,8)|0;c[q>>2]=z;wW(c[r>>2]|0,(z|0)!=0|0,67472,l);z=Uoa(c[s>>2]|0,4)|0;c[t>>2]=z;wW(c[r>>2]|0,(z|0)!=0|0,67472,k);z=Uoa(c[u>>2]|0,1)|0;c[v>>2]=z;wW(c[r>>2]|0,(z|0)!=0|0,67472,j);z=Uoa(c[w>>2]|0,4)|0;c[x>>2]=z;wW(c[r>>2]|0,(z|0)!=0|0,67472,g);zX(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=Uoa(3,4)|0;c[b+4>>2]=n;BX(c[o>>2]|0,0,n);c[b+8>>2]=Uoa(c[p>>2]|0,112)|0;c[b+12>>2]=Uoa(c[s>>2]|0,60)|0;c[b+16>>2]=Uoa(c[u>>2]|0,48)|0;c[b+20>>2]=Uoa(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=Uoa(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=Uoa(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=Uoa(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=Uoa(g,52)|0;c[b+40>>2]=Uoa(c[b+216>>2]|0,52)|0;c[b+44>>2]=Uoa(c[b+220>>2]|0,52)|0;c[b+48>>2]=Uoa(c[b+224>>2]|0,52)|0;c[b+52>>2]=Uoa(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=Uoa(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=Uoa(x,8)|0;c[b+340>>2]=Uoa(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=Uoa(x,8)|0;c[b+348>>2]=Uoa(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=Uoa(j,1)|0;c[b+356>>2]=Uoa(j,1)|0;c[b+360>>2]=Uoa(j,1)|0;j=Soa(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=Soa(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=Uoa(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=Uoa(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=Uoa(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=Uoa(u,4)|0;c[b+400>>2]=Uoa(x,8)|0;c[b+404>>2]=Uoa(p,4)|0;c[b+408>>2]=Uoa(s,1)|0;c[b+412>>2]=Uoa(u,4)|0;c[b+416>>2]=Uoa(c[n>>2]|0,8)|0;c[b+420>>2]=Uoa(o,4)|0;c[b+424>>2]=Uoa(y,1)|0;c[b+428>>2]=Uoa(g,4)|0;c[b+432>>2]=Uoa(c[b+152>>2]|0,8)|0;c[b+436>>2]=Uoa(c[b+156>>2]|0,8)|0;g=Soa((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;fe[c[(c[y>>2]|0)+20>>2]&255](g);g=Soa((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;fe[c[(c[y>>2]|0)+16>>2]&255](g);g=Soa((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;fe[c[(c[y>>2]|0)+12>>2]&255](g);g=Soa((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ge[c[(c[y>>2]|0)+24>>2]&127](g,b);c[b+464>>2]=Soa((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=Uoa(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;wW(c[r>>2]|0,(g|0)!=0|0,67488,f);c[b+512>>2]=100;c[b+516>>2]=Uoa(100,4)|0;c[b+520>>2]=Uoa(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=Soa(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;wW(c[r>>2]|0,(g|0)!=0|0,67472,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=vX(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}function AZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;Toa(c[g+8>>2]|0);Toa(c[g+12>>2]|0);Toa(c[g+16>>2]|0);Toa(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);Toa(e);wX(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){TX(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}Toa(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){TX(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}Toa(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){TX(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}Toa(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){TX(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}Toa(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){TX(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}Toa(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){TX(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}Toa(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){TX(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}Toa(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){TX(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}Toa(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){TX(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}Toa(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){TX(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}Toa(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){TX(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}Toa(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){TX(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}Toa(v);Toa(c[a+108>>2]|0);Toa(c[a+336>>2]|0);Toa(c[a+340>>2]|0);Toa(c[a+344>>2]|0);Toa(c[a+348>>2]|0);Toa(c[a+352>>2]|0);Toa(c[a+356>>2]|0);Toa(c[a+360>>2]|0);Toa(c[a+368>>2]|0);Toa(c[a+384>>2]|0);Toa(c[a+388>>2]|0);Toa(c[a+392>>2]|0);Toa(c[a+396>>2]|0);Toa(c[a+400>>2]|0);Toa(c[a+404>>2]|0);Toa(c[a+408>>2]|0);Toa(c[a+412>>2]|0);Toa(c[a+416>>2]|0);Toa(c[a+420>>2]|0);Toa(c[a+424>>2]|0);Toa(c[a+428>>2]|0);Toa(c[a+488>>2]|0);Toa(c[a+484>>2]|0);Toa(c[a+476>>2]|0);Toa(c[a+468>>2]|0);Toa(c[a+464>>2]|0);Toa(c[a+432>>2]|0);Toa(c[a+436>>2]|0);Toa(c[a+320>>2]|0);Toa(c[a+516>>2]|0);Toa(c[a+520>>2]|0);kca(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;Toa(x);i=b;return}else{y=a;z=0}while(1){wX(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;Toa(x);i=b;return}function BZ(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[8441]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];tW(8,0,67536,d);i=b;return}function CZ(a,b){a=+a;b=+b;i=i;return a<=b|0}function DZ(a,b){a=+a;b=+b;i=i;return a>b|0}function EZ(a,b){a=+a;b=+b;i=i;return a>=b|0}function FZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=Soa(k)|0;c[e+(h*40|0)+24>>2]=Soa(k)|0;if((c[g>>2]|0)!=1){l=5;break}IZ(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){xW(c[a+536>>2]|0,67592,d)}else if((l|0)==6){i=b;return 0}return 0}function GZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){Toa(c[e+(h*40|0)+20>>2]|0);Toa(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;JZ(k)|0;Toa(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){xW(c[a+536>>2]|0,67592,d)}else if((j|0)==6){i=b;return 0}return 0}function HZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[35892>>2]|c[8954]|0)==0){z=w;A=1;break}ica(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];vW(17,1,67624,g);ica(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;ica(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;vW(17,0,67656,f);ica(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[9094]&255](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function IZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Soa(20)|0;c[b>>2]=f;wW(0,(f|0)!=0|0,67664,e);e=Soa(a)|0;c[f>>2]=e;e=Soa(a)|0;c[f+4>>2]=e;e=Soa(a)|0;c[f+8>>2]=e;e=Soa(a)|0;c[f+16>>2]=e;wW(0,(c[b>>2]|0)!=0|0,67696,d);i=d;return 0}function JZ(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Toa(c[d>>2]|0);Toa(c[d+4>>2]|0);Toa(c[d+8>>2]|0);Toa(c[d+16>>2]|0);i=b;return 0}function KZ(a,b){a=a|0;b=b|0;b=i;i=i+8|0;xW(c[a+536>>2]|0,67744,b);return 0}function LZ(a){a=a|0;a=i;i=i+8|0;xW(0,67744,a);return 0}function MZ(a,b){a=a|0;b=b|0;b=i;i=i+8|0;xW(c[a+536>>2]|0,67744,b);return 0}function NZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=Soa(l)|0;c[e+(h<<6)+36>>2]=Soa(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=Soa(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;TZ(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;WZ(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){xW(c[a+536>>2]|0,67784,d)}else if((n|0)==8){i=b;return 0}return 0}function OZ(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function PZ(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function QZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){Toa(c[e+(h<<6)+28>>2]|0);Toa(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){XZ(e+(h<<6)+24|0)|0}else if((j|0)==1){UZ(e+(h<<6)+24|0)|0;Toa(c[e+(h<<6)+32>>2]|0)}else{k=6;break}Toa(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){xW(c[a+536>>2]|0,67784,d)}else if((k|0)==8){i=b;return 0}return 0}function RZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==1){j=VZ(b,d)|0}else if((h|0)==2){j=YZ(b,d)|0}else{xW(c[b+536>>2]|0,67784,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function SZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[35884>>2]|c[8954]|0)==0){z=w;A=1;break}ica(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];vW(15,1,67816,g);ica(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;ica(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;vW(15,0,67848,f);ica(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[9094]&255](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function TZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=Soa(12)|0;f=Soa(a<<2)|0;c[e>>2]=f;wW(0,(f|0)!=0|0,67856,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function UZ(a){a=a|0;var b=0;b=i;Toa(c[c[a>>2]>>2]|0);i=b;return 0}function VZ(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;ypa(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ge[c[x>>2]&127](C,D);ge[c[w+(d<<6)+4>>2]&127](C,D);if((c[35888>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;tW(16,1,67912,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,67936,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;tW(16,0,67952,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;tW(16,1,67960,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,67936,o|0)|0;c[n>>2]=D;tW(16,0,67952,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;tW(16,1,67960,s)}}while(0);fe[c[9094]&255](16)}s=w+(d<<6)+36|0;A=y+8|0;gR(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;vW(1,0,67976,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;wpa(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;wpa(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;vW(1,0,68064,l);if((c[35884>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;wpa(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hc(l|0,68168,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hc(l|0,68168,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;wpa(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];hc(l|0,68168,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;wpa(M|0,O|0,Q|0)|0;i=e;return F|0}function WZ(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=Soa(32)|0;wW(0,(g|0)!=0|0,68176,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Yd(0,d|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;Yd(0,g+4|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Lb(68224,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function XZ(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;zd(c[d+12>>2]|0)|0;Kb(c[d+8>>2]|0)|0;Kb(c[d+4>>2]|0)|0;i=b;return 0}function YZ(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;ld(c[g>>2]|0)|0;Ud(0,g|0)|0;j=g+24|0;Pb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ge[c[f>>2]&127](k,a);Vc(c[g>>2]|0,1)|0;Ua(c[g>>2]|0)|0;ge[c[e+(b<<6)+4>>2]&127](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){gd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(mc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Jb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;ld(c[g>>2]|0)|0;i=d;return l|0}function ZZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;wW(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,68392,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){wW(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,68432,e);if((ie[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=Soa(p)|0;c[g+(m*80|0)+52>>2]=Soa(p)|0;c[g+(m*80|0)+48>>2]=Soa(p)|0;c[g+(m*80|0)+16>>2]=Soa(p)|0;c[g+(m*80|0)+8>>2]=Soa(p)|0;c[g+(m*80|0)+12>>2]=Soa(p)|0;ge[c[g+(m*80|0)+36>>2]&127](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){k_(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==1){c_(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==3){k_(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==2){KZ(a,n)|0;break}else{q=12;break a}}}while(0);n=m+1|0;if((n|0)<(c[h>>2]|0)){m=n}else{q=14;break}}if((q|0)==12){xW(c[j>>2]|0,68472,d)}else if((q|0)==14){i=b;return 0}return 0}function _Z(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;Toa(c[e+(h*80|0)+44>>2]|0);Toa(c[e+(h*80|0)+52>>2]|0);Toa(c[e+(h*80|0)+48>>2]|0);Toa(c[e+(h*80|0)+16>>2]|0);Toa(c[e+(h*80|0)+8>>2]|0);Toa(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;l_(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;l_(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==1){k=e+(h*80|0)+40|0;d_(k)|0;l=k;break}else{n=9;break a}}}while(0);Toa(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){LZ(j)|0}else if((n|0)==9){xW(c[a+536>>2]|0,68472,d)}else if((n|0)==11){i=b;return 0}return 0}function $Z(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(n_(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=e_(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(n_(b,d)|0)&255;break}else if((k|0)==2){j=(MZ(b,d)|0)&255;break}else{xW(c[b+536>>2]|0,68472,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function a_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;ica(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];uW(17,1,u,68504,m);do{if((a[b+312|0]|0)==0){ica(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;ica(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;vW(17,0,68704,f);ica(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{vW(17,1,68544,l);ica(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;ica(q,d,c[v>>2]|0);if((qpa(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];vW(17,0,68624,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;ica(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;vW(17,0,68664,g);G=E}ica(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[35892>>2]|c[8954]|0)==0){break}fe[c[9094]&255](17)}}while(0);if((c[35892>>2]|c[8954]|0)==0){x=1;i=e;return x|0}fe[c[9094]&255](17);x=1;i=e;return x|0}function b_(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function c_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Soa(144)|0;c[b>>2]=f;wW(0,(f|0)!=0|0,68720,e);c[f>>2]=0;e=a<<3;g=Soa(e)|0;c[f+4>>2]=g;g=Soa(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=Soa(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=Soa(e)|0;c[f+24>>2]=g;g=Uoa(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=Soa(e)|0;c[f+64>>2]=g;g=Soa(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=Uoa(g,8)|0;c[f+104>>2]=j;j=Uoa(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=Soa(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=Soa(e)|0;c[f+124>>2]=j;j=Soa(e)|0;c[f+128>>2]=j;j=Soa(e)|0;c[f+132>>2]=j;j=Soa(e)|0;c[f+136>>2]=j;j=Soa(e)|0;c[f+140>>2]=j;wW(0,(c[b>>2]|0)!=0|0,68752,d);i=d;return 0}function d_(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Toa(c[d+4>>2]|0);Toa(c[d+16>>2]|0);Toa(c[d+12>>2]|0);Toa(c[d+24>>2]|0);Toa(c[d+28>>2]|0);Toa(c[d+64>>2]|0);Toa(c[d+68>>2]|0);Toa(c[d+104>>2]|0);Toa(c[d+108>>2]|0);Toa(c[d+116>>2]|0);Toa(c[d+124>>2]|0);Toa(c[d+128>>2]|0);Toa(c[d+132>>2]|0);Toa(c[d+136>>2]|0);Toa(c[d+140>>2]|0);i=b;return 0}function e_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=Soa(c[Y>>2]|0)|0;if((c[35892>>2]|0)!=0){ica(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];tW(17,1,68792,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];tW(17,1,68848,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];tW(17,0,68864,F);fe[c[9094]&255](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}fe[c[9094]&255](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){wpa(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{wpa(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+td(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;f_($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+td(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[35896>>2]|0)!=0){g_(c[Q>>2]|0,$,18,68904);g_(c[ca>>2]|0,$,18,68936)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[35896>>2]|0)!=0){g_(c[ca>>2]|0,$,18,68968)}a[da]=R;xY(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){ica(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];SX(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;f_($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;f_($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}lZ(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[35896>>2]|0)!=0){tW(18,1,69008,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];tW(18,1,69048,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];tW(18,0,69080,C);fe[c[9094]&255](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[9094]&255](18)}if((c[35900>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;tW(19,1,69112,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];hc(Ja|0,69136,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;tW(19,0,69144,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[9094]&255](19)}h[K>>3]=+wY($,c[Ia>>2]|0);h[J>>3]=+wY($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}wpa(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];tW(17,0,69192,w);h_(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}tW(17,0,69264,v);h_(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+td(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}tW(17,0,69328,u);h_(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+td(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}tW(17,0,69400,t);h_(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}wpa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;wpa(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}tW(17,0,69464,s);h_(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){wpa(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}tW(17,0,69536,r);h_(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tW(17,0,69608,q);h_(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tW(17,0,69680,p);h_(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){wpa(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tW(17,0,69744,o);h_(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}tW(17,0,69816,n);h_(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];tW(17,0,69952,l);h_(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){wpa(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{wpa(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}tW(17,0,69880,m);h_(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[35892>>2]|0)!=0){tW(17,1,69152,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;tW(17,0,69168,x);fe[c[9094]&255](17);h_(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}wpa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;f_($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;Toa(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;Toa(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;Toa(Z);i=e;return kb|0}if((a[Ha]|0)==0){ica(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];SX(0,f,hb);}if((c[35892>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;tW(17,0,70024,j);h_(S,L,J,K,17)}wpa(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;Toa(Z);i=e;return kb|0}return 0}function f_(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0.0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==1){B=y+8|0;do{if((c[B>>2]|0)!=0){C=c[b>>2]|0;if((C|0)<=0){break}D=c[y+12>>2]|0;E=0;do{F=d+(E<<3)|0;h[F>>3]=+h[F>>3]*+h[D+(E<<3)>>3];E=E+1|0;}while((E|0)<(C|0))}}while(0);if((c[35904>>2]|0)!=0){c[u>>2]=c[y+96>>2];tW(20,0,70272,u);g_(d,b,20,70304)}Ie[c[x+(m*80|0)+32>>2]&31](l,d,e,j);if((c[35904>>2]|0)!=0){g_(e,b,20,70320);c[t>>2]=c[y+96>>2];tW(20,0,70336,t)}if((c[B>>2]|0)==0){i=g;return 0}B=c[b>>2]|0;if((B|0)<=0){i=g;return 0}t=c[y+12>>2]|0;j=0;do{u=d+(j<<3)|0;h[u>>3]=1.0/+h[t+(j<<3)>>3]*+h[u>>3];j=j+1|0;}while((j|0)<(B|0));i=g;return 0}else if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[35904>>2]|0)!=0){tW(20,0,70376,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){j_(w,f,d,e,m)}else{i_(w,f,m)}do{if((c[35904>>2]|0)!=0){tW(20,0,70416,r);if((c[35900>>2]|0)==0){break}m=v;w=c[b>>2]|0;c[q>>2]=w;c[q+4>>2]=w;tW(19,1,69112,q);w=c[b>>2]|0;if((w|0)>0){e=y+20|0;d=w;w=0;do{a[m]=0;if((d|0)>0){x=0;do{G=+h[f+((fa(c[e>>2]|0,w)|0)+x<<3)>>3];c[p>>2]=m;s=p+4|0;h[k>>3]=G;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];hc(m|0,70448,p|0)|0;x=x+1|0;}while((x|0)<(c[b>>2]|0))}c[o>>2]=m;tW(19,0,69144,o);w=w+1|0;d=c[b>>2]|0;}while((w|0)<(d|0))}fe[c[9094]&255](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;xW(g,70464,n)}return 0}function g_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[35824+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;tW(d,1,69144,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];tW(d,0,70256,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}fe[c[9094]&255](d);i=f;return}function h_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[35824+(f<<2)>>2]|0)==0){i=g;return}tW(f,1,70064,q);tW(f,1,70080,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];tW(f,0,70096,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}fe[c[9094]&255](f);tW(f,1,70136,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];tW(f,0,70152,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}fe[c[9094]&255](f);tW(f,1,70192,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];tW(f,0,70208,j);fe[c[9094]&255](f);fe[c[9094]&255](f);i=g;return}function i_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;ypa(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;ypa(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function j_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+td(+(n*+td(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;f_(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function k_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Soa(80)|0;c[b>>2]=f;wW(0,(f|0)!=0|0,70544,e);c[f>>2]=0;e=a<<3;g=Soa(e)|0;c[f+4>>2]=g;g=Soa(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=Soa(e)|0;c[f+16>>2]=g;g=Uoa(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=Soa(fa(e,a)|0)|0;c[f+64>>2]=g;g=Soa(e)|0;c[f+68>>2]=g;g=Soa(a<<2)|0;c[f+72>>2]=g;wW(0,(c[b>>2]|0)!=0|0,70576,d);i=d;return 0}function l_(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;Toa(c[d+4>>2]|0);Toa(c[d+8>>2]|0);Toa(c[d+16>>2]|0);Toa(c[d+20>>2]|0);Toa(c[d+64>>2]|0);Toa(c[d+68>>2]|0);Toa(c[d+72>>2]|0);i=b;return 0}function m_(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;ypa(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function n_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;wpa(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[35892>>2]|0)==0){J=b+4|0}else{ica(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tW(17,1,70616,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];tW(17,1,70688,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];tW(17,0,70704,t);fe[c[9094]&255](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}fe[c[9094]&255](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];o_(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){ica(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];SX(3,g,P);}$=+wY(H,c[b>>2]|0);aa=+wY(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){wpa(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;tW(17,0,70880,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;tW(17,0,70936,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;tW(17,0,71e3,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[35892>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;tW(17,0,70752,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];tW(17,0,70792,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];tW(17,0,70848,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){ica(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];SX(0,f,L);if((c[35892>>2]|0)==0){da=0;break}c[m>>2]=V;tW(17,0,71080,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(17,0,70792,l);if((c[35892>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(17,0,70848,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[35892>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;wpa(ma|0,oa|0,qa|0)|0;i=e;return da|0}fe[c[9094]&255](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;wpa(ma|0,oa|0,qa|0)|0;i=e;return da|0}function o_(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[35896>>2]|0)!=0){c[z>>2]=j;tW(18,0,71120,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];tW(18,0,71168,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){p_(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){q_(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{m_(E,m,r)|0}if((c[35900>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;tW(19,1,71184,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hc(F|0,71208,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;tW(19,0,71216,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}fe[c[9094]&255](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+wY(b,_);if(!(!(J<=H)&!(+wY(b,e)<=H))){$=31;break}gR(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;vW(17,0,71224,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;vW(17,0,71256,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+wY(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function p_(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Ie[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&31](e,a,b,d);i=g;return 0}function q_(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+td(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;p_(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function r_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+24>>2]|0;if((e|0)==1){f=c[a+4>>2]|0;g=c[f+4>>2]|0;t_(c[f>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);j=0;i=d;return j|0}else if((e|0)==4){te[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];j=0;i=d;return j|0}else if((e|0)==3){j=OY(a,b)|0;i=d;return j|0}else if((e|0)==2){s_(a,b);j=0;i=d;return j|0}else{j=1;i=d;return j|0}return 0}function s_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[71288+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[71288+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ie[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function t_(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function u_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+8|0;f=e;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=AW(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;g=c[d+24>>2]|0;a:do{if((g|0)==2){j=Soa(8)|0;c[j+4>>2]=4;k=Soa(20)|0;c[j>>2]=k;l=c[b+112>>2]|0;m=k;k=0;while(1){c[m+(k<<2)>>2]=Uoa(l,8)|0;if((k|0)>=4){break}m=c[j>>2]|0;k=k+1|0}c[d+48>>2]=j;n=0}else if((g|0)==3){k=Soa(88)|0;tW(23,0,71320,f);m=MY(b,d,k)|0;c[d+48>>2]=k;n=m}else if((g|0)==4){m=c[596]|0;k=Soa(m<<2)|0;c[17836]=k;if((m|0)<=0){n=0;break}l=c[b+116>>2]|0;o=k;k=0;while(1){c[o+(k<<2)>>2]=Uoa(l,8)|0;p=k+1|0;if((p|0)>=(m|0)){n=0;break a}o=c[17836]|0;k=p}}else{n=0}}while(0);H_(b)|0;if((c[2]|0)==0){i=e;return n|0}PX(6);MX(1);i=e;return n|0}function v_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[596]|0;g=c[17836]|0;if((f|0)>0){h=g;j=0;while(1){Toa(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[17836]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}Toa(m)}else if((e|0)==3){NY(c[b+48>>2]|0)|0}else if((e|0)==2){e=b+48|0;b=c[e>>2]|0;m=c[b>>2]|0;if((c[b+4>>2]|0)>-1){b=m;g=0;while(1){Toa(c[b+(g<<2)>>2]|0);h=c[e>>2]|0;j=c[h>>2]|0;if((g|0)<(c[h+4>>2]|0)){g=g+1|0;b=j}else{n=j;break}}}else{n=m}Toa(n);Toa(c[e>>2]|0)}I_(a)|0;C_(a);i=d;return 0}function w_(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(170,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=Hpa(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=Hpa(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=Hpa(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=Hpa(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=Hpa(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(171,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=Hpa(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=Hpa(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;tpa(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Hpa(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=Hpa(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,71352,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=Hpa(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Hpa(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,71448,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=Hpa(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[77568>>2]|0,77544,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=Hpa(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,71504,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=Hpa(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(172,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=Hpa(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function x_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];tW(8,0,71600,G);I=b+313|0;a[I]=1;kZ(b);if((c[92876>>2]|0)==0){ge[c[77564>>2]&127](77544,b)}a[I]=0}}while(0);if((e|0)!=0){y_(Ad(e|0)|0,b)}if((c[35924>>2]|0)==0){i=f;return 0}PX(0);tW(25,0,71648,F);tW(25,1,71672,E);H=+HX(6);J=+HX(6);K=J/+HX(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];tW(25,0,71680,D);K=+HX(1);H=+HX(1);J=H/+HX(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];tW(25,0,71720,C);J=+HX(2);K=+HX(2);H=K/+HX(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tW(25,0,71752,B);H=+HX(3);J=+HX(3);K=J/+HX(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];tW(25,0,71776,A);K=+HX(4);H=+HX(4);J=H/+HX(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tW(25,0,71816,z);J=+HX(7);K=+HX(7);H=K/+HX(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(25,0,71848,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+HX(0);J=H- +HX(7);H=J- +HX(4);J=H- +HX(3);H=J- +HX(2);J=H- +HX(1);H=J- +HX(6);J=+HX(0);K=J- +HX(7);J=K- +HX(4);K=J- +HX(3);J=K- +HX(2);K=J- +HX(1);J=K- +HX(6);K=J/+HX(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(25,0,71912,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tW(25,0,71880,x)}K=+HX(0);H=+HX(0);J=H/+HX(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];tW(25,0,71944,v);fe[c[9094]&255](25);tW(25,1,71968,u);c[t>>2]=c[d+40>>2];tW(25,0,71976,t);c[s>>2]=c[d+44>>2];tW(25,0,72e3,s);fe[c[9094]&255](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);tW(25,1,72024,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];tW(25,0,72040,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];tW(25,0,72056,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];tW(25,0,72088,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];tW(25,0,72120,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];tW(25,0,72144,m);fe[c[9094]&255](25)}else if((s|0)!=5){tW(25,1,72176,l);tW(25,0,72184,j);fe[c[9094]&255](25)}tW(25,0,72248,g);MX(0);i=f;return 0}



function $na(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;goa(m,c[p>>2]|0)|0;goa(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=goa(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 0:{if((c[v>>2]&1|0)!=0){Q=goa(m,7)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}}U=M;V=N;W=goa(m,3)|0;break};case 8:{Q=L+ -2|0;c[n>>2]=Q;X=c[P+(Q<<2)>>2]|0;Q=c[w>>2]|0;Y=qoa(Q,0,0,1,32)|0;if((Y|0)==0){Z=12;T=294;break b}_=qoa(Q,0,0,1,8)|0;Q=Y+4|0;c[Q>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Y>>2]=3;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[_>>2]=X;c[(c[Q>>2]|0)+4>>2]=N;c[Y+16>>2]=(c[N+16>>2]|0)+(c[X+16>>2]|0);U=M;V=Y;W=0;break};case 1:{Y=c[q>>2]|0;d:do{switch(a[Y]|0){case 40:{if((c[v>>2]&1|0)!=0){$=Y;T=74}break};case 92:{X=Y+1|0;Q=a[X]|0;do{if((c[v>>2]&1|0)==0){if(Q<<24>>24==40){c[q>>2]=X;$=X;T=74;break d}else{_=a[Y+1|0]|0;if(_<<24>>24==41){T=265;break d}else{aa=_;break}}}else{aa=Q}}while(0);Q=Y+1|0;X=aa<<24>>24==0;if(X){Z=5;T=294;break b}else{ba=124964|0;ca=0}while(1){_=ca+1|0;if((a[124960+(ca<<3)|0]|0)==aa<<24>>24){da=ba;break}ea=124964+(_<<3)|0;if((_|0)==12){da=ea;break}else{ba=ea;ca=_}}_=c[da>>2]|0;if((_|0)!=0){ea=F+0|0;fa=G+0|0;ga=ea+40|0;do{c[ea>>2]=c[fa>>2];ea=ea+4|0;fa=fa+4|0}while((ea|0)<(ga|0));c[H>>2]=_;c[I>>2]=1;fa=$na(j)|0;if((fa|0)!=0){Z=fa;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(X){Z=5;T=294;break b}c[q>>2]=Q;fa=a[Q]|0;e:do{switch(fa|0){case 98:{ea=c[w>>2]|0;ga=qoa(ea,0,0,1,32)|0;ha=ga;do{if((ga|0)==0){ia=0}else{ja=qoa(ea,0,0,1,20)|0;c[ga+4>>2]=ja;if((ja|0)==0){ia=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[ja>>2]=-2;c[ja+4>>2]=64;c[ja+8>>2]=-1;ia=ha}}while(0);c[q>>2]=(c[q>>2]|0)+1;ka=ia;break};case 66:{ha=c[w>>2]|0;ga=qoa(ha,0,0,1,32)|0;ea=ga;do{if((ga|0)==0){la=0}else{ja=qoa(ha,0,0,1,20)|0;c[ga+4>>2]=ja;if((ja|0)==0){la=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[ja>>2]=-2;c[ja+4>>2]=128;c[ja+8>>2]=-1;la=ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;ka=la;break};case 60:{ea=c[w>>2]|0;ga=qoa(ea,0,0,1,32)|0;ha=ga;do{if((ga|0)==0){ma=0}else{ja=qoa(ea,0,0,1,20)|0;c[ga+4>>2]=ja;if((ja|0)==0){ma=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[ja>>2]=-2;c[ja+4>>2]=16;c[ja+8>>2]=-1;ma=ha}}while(0);c[q>>2]=(c[q>>2]|0)+1;ka=ma;break};case 62:{ha=c[w>>2]|0;ga=qoa(ha,0,0,1,32)|0;ea=ga;do{if((ga|0)==0){na=0}else{ja=qoa(ha,0,0,1,20)|0;c[ga+4>>2]=ja;if((ja|0)==0){na=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[ja>>2]=-2;c[ja+4>>2]=32;c[ja+8>>2]=-1;na=ea}}while(0);c[q>>2]=(c[q>>2]|0)+1;ka=na;break};case 120:{ea=Y+2|0;c[q>>2]=ea;ga=a[ea]|0;if(ga<<24>>24==123){ea=Y+3|0;c[q>>2]=ea;ha=ea;ea=0;while(1){ja=a[ha]|0;if(ja<<24>>24==0|ja<<24>>24==125){oa=ea;pa=ha;break}if((Ona(ja<<24>>24)|0)==0){Z=9;T=294;break b}ja=c[q>>2]|0;a[l+ea|0]=a[ja]|0;qa=ea+1|0;ra=ja+1|0;c[q>>2]=ra;if(qa>>>0>31){oa=qa;pa=ra;break}else{ha=ra;ea=qa}}c[q>>2]=pa+1;a[l+oa|0]=0;ea=Vb(C|0,0,16)|0;ha=c[w>>2]|0;qa=c[x>>2]|0;ra=qoa(ha,0,0,1,32)|0;ja=ra;do{if((ra|0)==0){sa=0}else{ta=qoa(ha,0,0,1,20)|0;c[ra+4>>2]=ta;if((ta|0)==0){sa=0;break}c[ra>>2]=0;c[ra+8>>2]=-1;c[ra+12>>2]=-1;c[ta>>2]=ea;c[ta+4>>2]=ea;c[ta+8>>2]=qa;sa=ja}}while(0);c[x>>2]=(c[x>>2]|0)+1;ka=sa;break e}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;ja=(Ona(ga<<24>>24)|0)==0;qa=c[q>>2]|0;if(ja){ua=qa}else{a[D]=a[qa]|0;ja=qa+1|0;c[q>>2]=ja;ua=ja}if((Ona(a[ua]|0)|0)!=0){ja=c[q>>2]|0;a[E]=a[ja]|0;c[q>>2]=ja+1}ja=Vb(D|0,0,16)|0;qa=c[w>>2]|0;ea=c[x>>2]|0;ra=qoa(qa,0,0,1,32)|0;ha=ra;do{if((ra|0)==0){va=0}else{ta=qoa(qa,0,0,1,20)|0;c[ra+4>>2]=ta;if((ta|0)==0){va=0;break}c[ra>>2]=0;c[ra+8>>2]=-1;c[ra+12>>2]=-1;c[ta>>2]=ja;c[ta+4>>2]=ja;c[ta+8>>2]=ea;va=ha}}while(0);c[x>>2]=(c[x>>2]|0)+1;ka=va;break e}break};default:{if((Hna(fa)|0)!=0){ha=(a[c[q>>2]|0]|0)+ -48|0;ea=c[w>>2]|0;ja=c[x>>2]|0;ra=qoa(ea,0,0,1,32)|0;if((ra|0)==0){Z=12;T=294;break b}qa=qoa(ea,0,0,1,20)|0;c[ra+4>>2]=qa;if((qa|0)==0){Z=12;T=294;break b}c[ra>>2]=0;c[ra+8>>2]=-1;c[ra+12>>2]=-1;c[qa>>2]=-4;c[qa+4>>2]=ha;c[qa+8>>2]=ja;c[x>>2]=(c[x>>2]|0)+1;ja=c[B>>2]|0;c[B>>2]=(ha|0)<(ja|0)?ja:ha;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ra;W=0;break c}ra=c[w>>2]|0;ha=a[c[q>>2]|0]|0;ja=c[x>>2]|0;qa=qoa(ra,0,0,1,32)|0;ea=qa;do{if((qa|0)==0){wa=0}else{ga=qoa(ra,0,0,1,20)|0;c[qa+4>>2]=ga;if((ga|0)==0){wa=0;break}c[qa>>2]=0;c[qa+8>>2]=-1;c[qa+12>>2]=-1;c[ga>>2]=ha;c[ga+4>>2]=ha;c[ga+8>>2]=ja;wa=ea}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;ka=wa}}}while(0);if((ka|0)==0){Z=12;T=294;break b}else{U=M;V=ka;W=0;break c}break};case 91:{fa=Y+1|0;c[q>>2]=fa;Q=Soa(128)|0;if((Q|0)==0){Z=12;T=294;break b}if((a[fa]|0)==94){X=Y+2|0;c[q>>2]=X;xa=X;ya=1}else{xa=fa;ya=0}fa=(ya|0)==0;X=Q;Q=0;_=0;ea=32;ja=xa;f:while(1){ha=a[ja]|0;if(ha<<24>>24==0){za=X;Aa=ja;Ba=7;T=140;break}else if(ha<<24>>24==93){if(ja>>>0>(c[q>>2]|0)>>>0){T=85;break}}ha=Wna(e,ja,-1)|0;if((ha|0)<0){c[e>>2]=-1;Ca=1}else{Ca=ha}ha=ja+Ca|0;do{if((a[ha]|0)==45){qa=Ca+1|0;ra=ja+qa|0;if((a[ra]|0)==93){T=94;break}ga=c[e>>2]|0;ta=Wna(e,ra,-1)|0;if((ta|0)<0){c[e>>2]=-1;Da=-1;Ea=1}else{Da=c[e>>2]|0;Ea=ta}Fa=0;Ga=Da;Ha=ga;Ia=ja+(Ea+qa)|0;Ja=ga>>>0>Da>>>0?11:0}else{T=94}}while(0);g:do{if((T|0)==94){T=0;ga=a[ja]|0;do{if(ga<<24>>24==45){if((a[ja+1|0]|0)==93){Ka=0;break}Ka=(c[q>>2]|0)==(ja|0)?0:11}else if(ga<<24>>24==91){qa=a[ja+1|0]|0;if(qa<<24>>24==61|qa<<24>>24==46){za=X;Aa=ja;Ba=3;T=140;break f}else if(!(qa<<24>>24==58)){Ka=0;break}qa=ja+2|0;ta=qa;while(1){ra=a[ta]|0;La=ra<<24>>24==0;if(ra<<24>>24!=58&(La^1)){ta=ta+1|0}else{break}}if(La){za=X;Aa=ja;Ba=4;T=140;break f}ra=ta-ja+ -2|0;Ma=(ra|0)>63?63:ra;Fpa(A|0,qa|0,Ma|0)|0;a[f+Ma|0]=0;Ma=Gna(A)|0;Fa=Ma;Ga=1114111;Ha=0;Ia=ta+2|0;Ja=(Ma|0)==0?4:0;break g}else{Ka=0}}while(0);ga=c[e>>2]|0;Fa=0;Ga=ga;Ha=ga;Ia=ha;Ja=Ka}}while(0);if((Ja|0)!=0){za=X;Aa=Ia;Ba=Ja;T=140;break}ha=(Fa|0)!=0;do{if(fa|ha^1){ga=c[w>>2]|0;if((_|0)<(ea|0)){Na=X;Oa=ea}else{if((ea|0)>1024){za=X;Aa=Ia;Ba=12;T=140;break f}Ma=Voa(X,ea<<3)|0;if((Ma|0)==0){za=X;Aa=Ia;Ba=12;T=140;break f}else{Na=Ma;Oa=ea<<1}}Ma=qoa(ga,0,0,1,32)|0;if((Ma|0)==0){T=112;break f}ra=qoa(ga,0,0,1,20)|0;ga=Ma+4|0;c[ga>>2]=ra;if((ra|0)==0){T=112;break f}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[ra>>2]=Ha;c[ra+4>>2]=Ga;c[ra+8>>2]=-1;c[Na+(_<<2)>>2]=Ma;c[(c[ga>>2]|0)+12>>2]=Fa;Pa=Na;Qa=Q;Ra=_+1|0;Sa=Oa;Ta=0}else{if((Q|0)>63){Pa=X;Qa=Q;Ra=_;Sa=ea;Ta=12;break}c[g+(Q<<2)>>2]=Fa;Pa=X;Qa=Q+1|0;Ra=_;Sa=ea;Ta=0}}while(0);ga=(Ta|0)==0;if(ga&(((c[v>>2]&2|0)==0|ha)^1)){Ua=Pa;Va=Ra;Wa=Sa;Xa=Ha}else{if(ga){X=Pa;Q=Qa;_=Ra;ea=Sa;ja=Ia;continue}else{za=Pa;Aa=Ia;Ba=Ta;T=140;break}}while(1){ga=Xa;while(1){if(ga>>>0>Ga>>>0){X=Ua;Q=Qa;_=Va;ea=Wa;ja=Ia;continue f}if((Jna(ga)|0)!=0){T=118;break}Ya=ga+1|0;if((Nna(ga)|0)==0){ga=Ya}else{T=129;break}}if((T|0)==118){T=0;Ma=Pna(ga)|0;ra=ga+1|0;h:do{if((Jna(ra)|0)==0){Za=Ma;_a=ra}else{$a=Ma;ab=ra;while(1){if((Pna(ab)|0)!=($a+1|0)|ab>>>0>Ga>>>0){Za=$a;_a=ab;break h}bb=Pna(ab)|0;cb=ab+1|0;if((Jna(cb)|0)==0){Za=bb;_a=cb;break}else{$a=bb;ab=cb}}}}while(0);ra=c[w>>2]|0;if((Va|0)<(Wa|0)){db=Ua;eb=Wa}else{if((Wa|0)>1024){za=Ua;Aa=Ia;Ba=12;T=140;break f}ab=Voa(Ua,Wa<<3)|0;if((ab|0)==0){za=Ua;Aa=Ia;Ba=12;T=140;break f}else{db=ab;eb=Wa<<1}}ab=qoa(ra,0,0,1,32)|0;$a=ab;do{if((ab|0)==0){fb=0}else{ta=qoa(ra,0,0,1,20)|0;c[ab+4>>2]=ta;if((ta|0)==0){fb=0;break}c[ab>>2]=0;c[ab+8>>2]=-1;c[ab+12>>2]=-1;c[ta>>2]=Ma;c[ta+4>>2]=Za;c[ta+8>>2]=-1;fb=$a}}while(0);c[db+(Va<<2)>>2]=fb;gb=fb;hb=db;ib=eb;jb=_a}else if((T|0)==129){T=0;$a=Rna(ga)|0;i:do{if((Nna(Ya)|0)==0){kb=$a;lb=Ya}else{Ma=$a;ab=Ya;while(1){if((Rna(ab)|0)!=(Ma+1|0)|ab>>>0>Ga>>>0){kb=Ma;lb=ab;break i}ra=ab+1|0;ta=Rna(ab)|0;if((Nna(ra)|0)==0){kb=ta;lb=ra;break}else{Ma=ta;ab=ra}}}}while(0);ga=c[w>>2]|0;if((Va|0)<(Wa|0)){mb=Ua;nb=Wa}else{if((Wa|0)>1024){za=Ua;Aa=Ia;Ba=12;T=140;break f}ab=Voa(Ua,Wa<<3)|0;if((ab|0)==0){za=Ua;Aa=Ia;Ba=12;T=140;break f}else{mb=ab;nb=Wa<<1}}ab=qoa(ga,0,0,1,32)|0;Ma=ab;do{if((ab|0)==0){ob=0}else{ra=qoa(ga,0,0,1,20)|0;c[ab+4>>2]=ra;if((ra|0)==0){ob=0;break}c[ab>>2]=0;c[ab+8>>2]=-1;c[ab+12>>2]=-1;c[ra>>2]=$a;c[ra+4>>2]=kb;c[ra+8>>2]=-1;ob=Ma}}while(0);c[mb+(Va<<2)>>2]=ob;gb=ob;hb=mb;ib=nb;jb=lb}if((gb|0)==0){T=141;break f}else{Ua=hb;Va=Va+1|0;Wa=ib;Xa=jb}}}j:do{if((T|0)==85){T=0;c[q>>2]=ja+1;ea=(ya|0)!=0;if(ea){cc(X|0,_|0,4,62)}k:do{if((_|0)>0){fa=(Q|0)>0;ha=Q<<2;Ma=ha+4|0;if(ea){pb=0;qb=0;rb=0;sb=0}else{$a=0;ab=0;while(1){ga=X+($a<<2)|0;ra=c[(c[ga>>2]|0)+4>>2]|0;do{if((ra|0)==0){tb=ab;ub=0}else{c[ra+8>>2]=c[x>>2];if(fa){ta=qoa(c[w>>2]|0,0,0,0,Ma)|0;qa=ra+16|0;c[qa>>2]=ta;if((ta|0)==0){vb=X;wb=ab;xb=12;break j}wpa(ta|0,z|0,ha|0)|0;c[(c[qa>>2]|0)+(Q<<2)>>2]=0}else{c[ra+16>>2]=0}if((ab|0)==0){tb=c[ga>>2]|0;ub=0;break}qa=c[w>>2]|0;ta=c[ga>>2]|0;cb=qoa(qa,0,0,1,32)|0;bb=cb;do{if((cb|0)==0){yb=0}else{zb=qoa(qa,0,0,1,8)|0;Ab=cb+4|0;c[Ab>>2]=zb;if((zb|0)==0){yb=0;break}c[cb>>2]=3;c[cb+8>>2]=-1;c[cb+12>>2]=-1;c[zb>>2]=ab;c[(c[Ab>>2]|0)+4>>2]=ta;c[cb+16>>2]=(c[ta+16>>2]|0)+(c[ab+16>>2]|0);yb=bb}}while(0);tb=yb;ub=(yb|0)==0?12:0}}while(0);ga=$a+1|0;if((ga|0)<(_|0)&(ub|0)==0){$a=ga;ab=tb}else{Bb=0;Cb=tb;Db=ub;break k}}}while(1){ab=X+(rb<<2)|0;$a=c[(c[ab>>2]|0)+4>>2]|0;ga=c[$a>>2]|0;ra=$a+4|0;bb=c[ra>>2]|0;do{if((ga|0)<(pb|0)){ta=bb+1|0;Eb=(ta|0)<(pb|0)?pb:ta;Fb=qb;Gb=sb;Hb=0}else{if((ga|0)<=(qb|0)){ta=bb+1|0;Eb=ta;Fb=ta;Gb=sb;Hb=0;break}c[$a>>2]=qb;c[ra>>2]=ga+ -1;ta=bb+1|0;if(($a|0)==0){Eb=ta;Fb=ta;Gb=sb;Hb=0;break}c[$a+8>>2]=c[x>>2];if(fa){cb=qoa(c[w>>2]|0,0,0,0,Ma)|0;qa=$a+16|0;c[qa>>2]=cb;if((cb|0)==0){vb=X;wb=sb;xb=12;break j}wpa(cb|0,z|0,ha|0)|0;c[(c[qa>>2]|0)+(Q<<2)>>2]=0}else{c[$a+16>>2]=0}if((sb|0)==0){Eb=ta;Fb=ta;Gb=c[ab>>2]|0;Hb=0;break}qa=c[w>>2]|0;cb=c[ab>>2]|0;Ab=qoa(qa,0,0,1,32)|0;zb=Ab;do{if((Ab|0)==0){Ib=0}else{Jb=qoa(qa,0,0,1,8)|0;Kb=Ab+4|0;c[Kb>>2]=Jb;if((Jb|0)==0){Ib=0;break}c[Ab>>2]=3;c[Ab+8>>2]=-1;c[Ab+12>>2]=-1;c[Jb>>2]=sb;c[(c[Kb>>2]|0)+4>>2]=cb;c[Ab+16>>2]=(c[cb+16>>2]|0)+(c[sb+16>>2]|0);Ib=zb}}while(0);Eb=ta;Fb=ta;Gb=Ib;Hb=(Ib|0)==0?12:0}}while(0);ab=rb+1|0;if((ab|0)<(_|0)&(Hb|0)==0){pb=Eb;qb=Fb;rb=ab;sb=Gb}else{Bb=Fb;Cb=Gb;Db=Hb;break}}}else{Bb=0;Cb=0;Db=0}}while(0);if((Db|0)!=0|ea^1){vb=X;wb=Cb;xb=Db;break}ha=c[w>>2]|0;Ma=c[x>>2]|0;fa=qoa(ha,0,0,1,32)|0;ab=fa;if((fa|0)==0){vb=X;wb=Cb;xb=12;break}$a=qoa(ha,0,0,1,20)|0;c[fa+4>>2]=$a;if(($a|0)==0){vb=X;wb=Cb;xb=12;break}c[fa>>2]=0;c[fa+8>>2]=-1;c[fa+12>>2]=-1;c[$a>>2]=Bb;c[$a+4>>2]=1114111;c[$a+8>>2]=Ma;if((Q|0)>0){Ma=Q<<2;ha=qoa(c[w>>2]|0,0,0,0,Ma+4|0)|0;bb=$a+16|0;c[bb>>2]=ha;if((ha|0)==0){vb=X;wb=Cb;xb=12;break}wpa(ha|0,z|0,Ma|0)|0;c[(c[bb>>2]|0)+(Q<<2)>>2]=0}else{c[$a+16>>2]=0}if((Cb|0)==0){vb=X;wb=ab;xb=0;break}$a=c[w>>2]|0;bb=qoa($a,0,0,1,32)|0;Ma=bb;do{if((bb|0)==0){Lb=0}else{ha=qoa($a,0,0,1,8)|0;ga=bb+4|0;c[ga>>2]=ha;if((ha|0)==0){Lb=0;break}c[bb>>2]=3;c[bb+8>>2]=-1;c[bb+12>>2]=-1;c[ha>>2]=Cb;c[(c[ga>>2]|0)+4>>2]=ab;c[bb+16>>2]=(c[fa+16>>2]|0)+(c[Cb+16>>2]|0);Lb=Ma}}while(0);vb=X;wb=Lb;xb=(Lb|0)==0?12:0}else if((T|0)==112){T=0;c[Na+(_<<2)>>2]=0;za=Na;Aa=Ia;Ba=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Ia;vb=hb;wb=0;xb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Aa;vb=za;wb=0;xb=Ba}Toa(vb);c[x>>2]=(c[x>>2]|0)+1;if((xb|0)==0){U=M;V=wb;W=0;break c}else{Z=xb;T=294;break b}break};case 94:{if((c[v>>2]&1|0)==0){if((Y|0)!=(c[r>>2]|0)){break d}_=goa(m,5)|0;if((_|0)!=0){R=M;S=_;T=6;break b}}_=c[w>>2]|0;X=qoa(_,0,0,1,32)|0;if((X|0)==0){Z=12;T=294;break b}Q=qoa(_,0,0,1,20)|0;c[X+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=1;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=X;W=0;break c;break};case 36:{if((c[v>>2]&1|0)==0){if((a[Y+1|0]|0)!=0){break d}}X=c[w>>2]|0;Q=qoa(X,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}_=qoa(X,0,0,1,20)|0;c[Q+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[_>>2]=-2;c[_+4>>2]=2;c[_+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Q;W=0;break c;break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 0:{T=265;break};case 41:{if((M|0)!=0){T=264}break};case 46:{Q=(c[v>>2]&4|0)==0;_=c[w>>2]|0;X=c[x>>2]|0;ja=qoa(_,0,0,1,32)|0;Ma=ja;fa=(ja|0)==0;if(Q){if(fa){Z=12;T=294;break b}Q=qoa(_,0,0,1,20)|0;c[ja+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[ja>>2]=0;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[Q>>2]=0;c[Q+4>>2]=1114111;c[Q+8>>2]=X;Mb=Ma;Nb=(c[x>>2]|0)+1|0}else{if(fa){Z=12;T=294;break b}fa=qoa(_,0,0,1,20)|0;c[ja+4>>2]=fa;if((fa|0)==0){Z=12;T=294;break b}c[ja>>2]=0;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[fa>>2]=0;c[fa+4>>2]=9;c[fa+8>>2]=X;X=c[w>>2]|0;fa=(c[x>>2]|0)+1|0;_=qoa(X,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}Q=qoa(X,0,0,1,20)|0;c[_+4>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Q>>2]=11;c[Q+4>>2]=1114111;c[Q+8>>2]=fa;fa=c[w>>2]|0;Q=qoa(fa,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}X=qoa(fa,0,0,1,8)|0;fa=Q+4|0;c[fa>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[X>>2]=Ma;c[(c[fa>>2]|0)+4>>2]=_;c[Q+16>>2]=(c[_+16>>2]|0)+(c[ja+16>>2]|0);Mb=Q;Nb=(c[x>>2]|0)+2|0}c[x>>2]=Nb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Mb;W=0;break c;break};default:{}}}while(0);if((T|0)==74){T=0;Q=M+1|0;c[q>>2]=$+1;ja=goa(m,c[y>>2]|0)|0;if((ja|0)!=0){R=Q;S=ja;T=6;break b}ja=goa(m,2)|0;if((ja|0)!=0){R=Q;S=ja;T=6;break b}ja=goa(m,0)|0;if((ja|0)!=0){R=Q;S=ja;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=Q;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;Q=c[w>>2]|0;ja=qoa(Q,0,0,1,32)|0;if((ja|0)==0){Z=12;T=294;break b}_=qoa(Q,0,0,1,20)|0;c[ja+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[ja>>2]=0;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[_>>2]=-1;c[_+4>>2]=-1;c[_+8>>2]=-1;U=M;V=ja;W=0;break c}ja=Wna(h,Y,-1)|0;if((ja|0)<0){c[h>>2]=-1;Ob=1}else{Ob=ja}do{if((c[v>>2]&2|0)==0){T=280}else{if((Nna(c[h>>2]|0)|0)==0){if((Jna(c[h>>2]|0)|0)==0){T=280;break}}ja=c[w>>2]|0;_=Pna(c[h>>2]|0)|0;Q=Pna(c[h>>2]|0)|0;fa=c[x>>2]|0;Ma=qoa(ja,0,0,1,32)|0;if((Ma|0)==0){Z=12;T=294;break b}X=qoa(ja,0,0,1,20)|0;c[Ma+4>>2]=X;if((X|0)==0){Z=12;T=294;break b}c[Ma>>2]=0;c[Ma+8>>2]=-1;c[Ma+12>>2]=-1;c[X>>2]=_;c[X+4>>2]=Q;c[X+8>>2]=fa;fa=c[w>>2]|0;X=Rna(c[h>>2]|0)|0;Q=Rna(c[h>>2]|0)|0;_=c[x>>2]|0;ja=qoa(fa,0,0,1,32)|0;if((ja|0)==0){Z=12;T=294;break b}bb=qoa(fa,0,0,1,20)|0;c[ja+4>>2]=bb;if((bb|0)==0){Z=12;T=294;break b}c[ja>>2]=0;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[bb>>2]=X;c[bb+4>>2]=Q;c[bb+8>>2]=_;_=c[w>>2]|0;bb=qoa(_,0,0,1,32)|0;if((bb|0)==0){Z=12;T=294;break b}Q=qoa(_,0,0,1,8)|0;_=bb+4|0;c[_>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[bb>>2]=3;c[bb+8>>2]=-1;c[bb+12>>2]=-1;c[Q>>2]=Ma;c[(c[_>>2]|0)+4>>2]=ja;c[bb+16>>2]=(c[ja+16>>2]|0)+(c[Ma+16>>2]|0);Pb=bb}}while(0);if((T|0)==280){T=0;Y=c[w>>2]|0;bb=c[h>>2]|0;Ma=c[x>>2]|0;ja=qoa(Y,0,0,1,32)|0;if((ja|0)==0){Z=12;T=294;break b}_=qoa(Y,0,0,1,20)|0;c[ja+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[ja>>2]=0;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[_>>2]=bb;c[_+4>>2]=bb;c[_+8>>2]=Ma;Pb=ja}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+Ob;U=M;V=Pb;W=0;break};case 2:{ja=L+ -2|0;c[n>>2]=ja;Ma=c[P+(ja<<2)>>2]|0;if((c[N+12>>2]|0)>-1){ja=c[w>>2]|0;_=qoa(ja,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}bb=qoa(ja,0,0,1,20)|0;c[_+4>>2]=bb;if((bb|0)==0){Z=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[bb>>2]=-1;c[bb+4>>2]=-1;c[bb+8>>2]=-1;bb=c[w>>2]|0;ja=qoa(bb,0,0,1,32)|0;if((ja|0)==0){Z=12;T=294;break b}Y=qoa(bb,0,0,1,8)|0;bb=ja+4|0;c[bb>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[ja>>2]=1;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[Y>>2]=_;c[(c[bb>>2]|0)+4>>2]=N;bb=N+16|0;Y=ja+16|0;c[Y>>2]=(c[bb>>2]|0)+(c[_+16>>2]|0);c[Y>>2]=c[bb>>2];Qb=ja}else{Qb=N}c[Qb+12>>2]=Ma;Ma=Qb+16|0;c[Ma>>2]=(c[Ma>>2]|0)+1;U=M;V=Qb;W=0;break};case 5:{Ma=c[q>>2]|0;ja=a[Ma]|0;if(ja<<24>>24==0){U=M;V=N;W=0;break c}bb=c[v>>2]&1;Y=(bb|0)!=0;if(Y&ja<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Y&ja<<24>>24==41&(M|0)>0)){if((bb|0)==0&ja<<24>>24==92){if((a[Ma+1|0]|0)==41){break}}_=goa(m,5)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=goa(m,N)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=goa(m,6)|0;if((_|0)!=0){R=M;S=_;T=6;break b}U=M;V=N;W=goa(m,4)|0;break c}}while(0);ja=(bb|M|0)==0?8:0;Y=M+ -1|0;if((bb|0)!=0){U=Y;V=N;W=ja;break c}c[q>>2]=Ma+2;U=Y;V=N;W=ja;break};case 7:{ja=c[q>>2]|0;Y=a[ja]|0;if((Y|0)==41){c[q>>2]=ja+1;U=M;V=N;W=0;break c}else if((Y|0)!=124){U=M;V=N;W=0;break c}Y=goa(m,7)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=goa(m,N)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=goa(m,8)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}Y=goa(m,3)|0;if((Y|0)!=0){R=M;S=Y;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 6:{Y=L+ -2|0;c[n>>2]=Y;ja=c[P+(Y<<2)>>2]|0;Y=c[w>>2]|0;_=qoa(Y,0,0,1,32)|0;if((_|0)==0){Z=12;T=294;break b}Q=qoa(Y,0,0,1,8)|0;Y=_+4|0;c[Y>>2]=Q;if((Q|0)==0){Z=12;T=294;break b}c[_>>2]=1;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Q>>2]=ja;c[(c[Y>>2]|0)+4>>2]=N;c[_+16>>2]=(c[N+16>>2]|0)+(c[ja+16>>2]|0);U=M;V=_;W=0;break};case 4:{_=goa(m,9)|0;if((_|0)!=0){R=M;S=_;T=6;break b}U=M;V=N;W=goa(m,1)|0;break};case 9:{_=c[q>>2]|0;ja=a[_]|0;switch(ja<<24>>24|0){case 92:{Y=c[v>>2]|0;if((Y&1|0)!=0){U=M;V=N;W=0;break c}Q=_+1|0;if((a[Q]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=Q;Rb=Y;Sb=Q;break};case 42:{T=41;break};case 123:{Q=c[v>>2]|0;if((Q&1|0)==0){U=M;V=N;W=0;break c}else{Rb=Q;Sb=_}break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=_+1;_=c[w>>2]|0;Q=qoa(_,0,0,1,32)|0;if((Q|0)==0){Z=12;T=294;break b}Y=qoa(_,0,0,1,16)|0;c[Q+4>>2]=Y;if((Y|0)==0){Z=12;T=294;break b}c[Q>>2]=2;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[Y>>2]=N;c[Y+4>>2]=ja<<24>>24==43;c[Y+8>>2]=ja<<24>>24==63?1:-1;ja=Y+12|0;a[ja]=a[ja]&-2;c[Q+16>>2]=c[N+16>>2];U=M;V=Q;W=goa(m,9)|0;break c}Q=Sb+1|0;c[q>>2]=Q;ja=a[Q]|0;if((ja+ -48<<24>>24&255)<10){Y=ja<<24>>24;if((Y+ -48|0)>>>0<10){Tb=Y;Ub=-1;Wb=Q}else{Z=10;T=294;break b}while(1){Y=((Ub|0)<0?-48:(Ub*10|0)+ -48|0)+Tb|0;_=Wb+1|0;X=a[_]|0;fa=X<<24>>24;if((fa+ -48|0)>>>0<10){Wb=_;Ub=Y;Tb=fa}else{Xb=X;Yb=Y;Zb=_;break}}}else{Xb=ja;Yb=-1;Zb=Q}do{if(Xb<<24>>24==44){Ma=Zb+1|0;bb=a[Ma]|0;_=bb<<24>>24;if((_+ -48|0)>>>0<10){_b=_;$b=-1;ac=Ma}else{bc=bb;dc=-1;ec=Ma;break}while(1){Ma=(($b|0)<0?-48:($b*10|0)+ -48|0)+_b|0;bb=ac+1|0;_=a[bb]|0;Y=_<<24>>24;if((Y+ -48|0)>>>0<10){ac=bb;$b=Ma;_b=Y}else{fc=_;gc=Ma;hc=bb;T=54;break}}}else{fc=Xb;gc=Yb;hc=Zb;T=54}}while(0);do{if((T|0)==54){T=0;if(!((gc|0)>-1)){bc=fc;dc=gc;ec=hc;break}if((Yb|0)>(gc|0)|(gc|0)>255){Z=10;T=294;break b}else{bc=fc;dc=gc;ec=hc}}}while(0);if(bc<<24>>24==0){Z=9;T=294;break b}if((ec|0)==(Q|0)){Z=10;T=294;break b}if((Rb&1|0)==0){if(!(bc<<24>>24==92)){Z=10;T=294;break b}if((a[ec+1|0]|0)!=125){Z=10;T=294;break b}ic=ec+2|0}else{if(!(bc<<24>>24==125)){Z=10;T=294;break b}ic=ec+1|0}if((dc|Yb|0)==0){ja=c[w>>2]|0;bb=qoa(ja,0,0,1,32)|0;if((bb|0)==0){Z=12;T=294;break b}Ma=qoa(ja,0,0,1,20)|0;c[bb+4>>2]=Ma;if((Ma|0)==0){Z=12;T=294;break b}c[bb>>2]=0;c[bb+8>>2]=-1;c[bb+12>>2]=-1;c[Ma>>2]=-1;c[Ma+4>>2]=-1;c[Ma+8>>2]=-1;jc=bb}else{bb=(dc&Yb|0)<0;Ma=c[w>>2]|0;ja=qoa(Ma,0,0,1,32)|0;if((ja|0)==0){Z=12;T=294;break b}_=qoa(Ma,0,0,1,16)|0;c[ja+4>>2]=_;if((_|0)==0){Z=12;T=294;break b}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[_>>2]=N;c[_+4>>2]=bb?1:Yb;c[_+8>>2]=bb?1:dc;bb=_+12|0;a[bb]=a[bb]&-2;c[ja+16>>2]=c[N+16>>2];jc=ja}c[q>>2]=ic;U=M;V=jc;W=goa(m,9)|0;break};case 10:{ja=L+ -2|0;c[n>>2]=ja;c[v>>2]=c[P+(ja<<2)>>2];U=M;V=N;W=0;break};case 3:{ja=goa(m,5)|0;if((ja|0)!=0){R=M;S=ja;T=6;break b}U=M;V=N;W=goa(m,4)|0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{kc=O;lc=U;mc=V;nc=W;break a}}if((T|0)==6){kc=(S|0)==0;lc=R;mc=N;nc=S;break}else if((T|0)==294){i=d;return Z|0}}else{kc=t;lc=0;mc=0;nc=p}}while(0);p=(lc|0)>0;if(p|kc^1){Z=p?8:nc;i=d;return Z|0}c[b+8>>2]=mc;Z=0;i=d;return Z|0}function aoa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=Soa((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=Soa((l<<2)+4|0)|0;if((p|0)==0){Toa(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}goa(d,e)|0;e=goa(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 5:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;if(!k){G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break b}E=c[F+4>>2]|0;c[F+20>>2]=(c[(c[E+4>>2]|0)+20>>2]|0)+(c[(c[E>>2]|0)+20>>2]|0);G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 6:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=0;do{O=A+(E<<2)|0;E=E+1|0}while((c[O>>2]|0)>-1);c[O>>2]=F<<1|1;c[A+(E<<2)>>2]=-1;P=0;while(1){if((c[p+(P<<2)>>2]|0)>-1){P=P+1|0}else{break}}c[p+(P+ -1<<2)>>2]=-1;G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B;break};case 4:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=u+ -3|0;c[h>>2]=E;G=v;H=w;I=c[D+(E<<2)>>2]|0;J=y;K=z;L=A;M=0;N=(F|0)>-1?F:B;break};case 3:{F=c[D+(u+ -2<<2)>>2]|0;E=c[D+(u+ -3<<2)>>2]|0;Q=c[D+(u+ -4<<2)>>2]|0;R=u+ -5|0;c[h>>2]=R;if(k){S=c[Q+4>>2]|0;T=Q+16|0;c[Q+20>>2]=(c[(c[S>>2]|0)+20>>2]|0)+(c[D+(R<<2)>>2]|0)+(c[(c[S+4>>2]|0)+20>>2]|0)+((c[T>>2]|0)>0?2:0);U=T;V=c[h>>2]|0}else{U=Q+16|0;V=R}R=c[D+(V+ -1<<2)>>2]|0;Q=V+ -2|0;c[h>>2]=Q;T=c[D+(Q<<2)>>2]|0;Q=V+ -3|0;c[h>>2]=Q;S=c[D+(Q<<2)>>2]|0;if((c[U>>2]|0)<=0){G=1;H=w;I=x;J=y;K=z;L=R;M=0;N=B;break b}if(k){W=0}else{joa(b,F,T)|0;c[(c[r>>2]|0)+(T<<2)>>2]=1;T=joa(b,E,S)|0;c[(c[r>>2]|0)+(S<<2)>>2]=1;W=T}G=1;H=w;I=x;J=y;K=z+2|0;L=R;M=W;N=B;break};case 0:{R=u+ -2|0;c[h>>2]=R;T=c[D+(R<<2)>>2]|0;R=T;S=T+12|0;E=c[S>>2]|0;if((E|0)>-1){F=0;do{X=A+(F<<2)|0;F=F+1|0}while((c[X>>2]|0)>-1);c[X>>2]=E<<1;c[A+(F<<2)>>2]=-1;do{if(!k){P=0;while(1){if((c[p+(P<<2)>>2]|0)>-1){P=P+1|0}else{break}}c[(c[s>>2]|0)+(E*12|0)+8>>2]=0;if((P|0)<=0){break}Q=Soa((P<<2)+4|0)|0;Y=Q;if((Q|0)==0){Z=w;_=y;$=z;aa=A;ba=12;ca=B;break a}c[(c[s>>2]|0)+(E*12|0)+8>>2]=Y;da=c[p>>2]|0;if((da|0)>-1){ea=Y;fa=da;da=0;while(1){c[ea>>2]=fa;ga=da+1|0;ha=c[p+(ga<<2)>>2]|0;ia=Q+(ga<<2)|0;if((ha|0)>-1){da=ga;fa=ha;ea=ia}else{ja=ia;break}}}else{ja=Y}c[ja>>2]=-1}}while(0);E=goa(d,c[S>>2]|0)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}E=goa(d,6)|0;if((E|0)!=0){Z=w;_=y;$=z;aa=A;ba=E;ca=B;break a}}E=c[T>>2]|0;do{if((E|0)==3){F=c[T+4>>2]|0;ea=c[F>>2]|0;fa=c[F+4>>2]|0;F=(c[A>>2]|0)>-1;da=x+1|0;Q=goa(d,F?da:x)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=goa(d,F?x:B)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=goa(d,A)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=goa(d,(c[A>>2]|0)>>>31^1)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=goa(d,T)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}Q=fa;fa=goa(d,Q)|0;if((fa|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=fa;qa=B;break}fa=ea;ea=goa(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=goa(d,3)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=goa(d,Q)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=goa(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=goa(d,2)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=goa(d,fa)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}ea=goa(d,0)|0;if((ea|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=ea;qa=B;break}if((c[A>>2]|0)>-1){if(k){ra=w;sa=y;ta=0}else{ea=ioa(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){fa=c[t>>2]|0;Q=0;while(1){ua=fa+(Q<<2)|0;va=Q+1|0;if((c[ua>>2]|0)>-1){Q=va}else{break}}c[ua>>2]=B;c[fa+(va<<2)>>2]=w;c[fa+(Q+2<<2)>>2]=-1;wa=-1;xa=y+1|0}else{wa=w;xa=y}Y=c[A>>2]|0;if((Y|0)>-1){F=c[s>>2]|0;P=Y;Y=0;do{ia=(P|0)/2|0;if((P&1|0)==0){c[F+(ia*12|0)>>2]=B}else{c[F+(ia*12|0)+4>>2]=B}Y=Y+1|0;P=c[A+(Y<<2)>>2]|0;}while((P|0)>-1)}c[A>>2]=-1;ra=wa;sa=xa;ta=ea}c[A>>2]=-1;ya=ra;za=da;Aa=sa;Ba=z+1|0;Ca=ta;Da=x}else{ya=w;za=x;Aa=y;Ba=z;Ca=0;Da=B}if((c[T+16>>2]|0)<=0){ka=v;la=ya;ma=za;na=Aa;oa=Ba;pa=Ca;qa=Da;break}ka=v;la=ya;ma=za+2|0;na=Aa;oa=Ba;pa=Ca;qa=za+1|0}else if((E|0)==1){P=c[T+4>>2]|0;Y=c[P>>2]|0;F=c[P+4>>2]|0;P=goa(d,T)|0;if((P|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=P;qa=B;break}P=goa(d,5)|0;if((P|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=P;qa=B;break}P=goa(d,F)|0;if((P|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=P;qa=B;break}P=goa(d,0)|0;if((P|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=P;qa=B;break}P=Y+20|0;Q=goa(d,(c[P>>2]|0)+x|0)|0;if((Q|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Q;qa=B;break}if((c[P>>2]|0)>0){P=(c[F+20>>2]|0)>0;Ea=(P&1)+x|0;Fa=P?x:-1}else{Ea=x;Fa=-1}P=goa(d,Fa)|0;if((P|0)!=0){ka=v;la=w;ma=Ea;na=y;oa=z;pa=P;qa=B;break}P=goa(d,4)|0;if((P|0)!=0){ka=v;la=w;ma=Ea;na=y;oa=z;pa=P;qa=B;break}P=goa(d,Y)|0;if((P|0)!=0){ka=v;la=w;ma=Ea;na=y;oa=z;pa=P;qa=B;break}ka=v;la=w;ma=Ea;na=y;oa=z;pa=goa(d,0)|0;qa=B}else if((E|0)==2){P=c[T+4>>2]|0;if(k){if((c[A>>2]|0)>-1){Ga=1}else{Ga=a[P+12|0]&1}Y=goa(d,Ga)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}else{Y=goa(d,B)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=goa(d,a[P+12|0]&1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}}Y=goa(d,T)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=goa(d,1)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=goa(d,c[P>>2]|0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}Y=goa(d,0)|0;if((Y|0)!=0){ka=v;la=w;ma=x;na=y;oa=z;pa=Y;qa=B;break}if(!((c[A>>2]|0)>-1)){if((a[P+12|0]&1)==0){ka=0;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}}if(k){Ha=w;Ia=y;Ja=0}else{Y=ioa(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[P+12|0]&1)==0?v:1;if((w|0)>-1){P=c[t>>2]|0;F=0;while(1){Ka=P+(F<<2)|0;La=F+1|0;if((c[Ka>>2]|0)>-1){F=La}else{break}}c[Ka>>2]=B;c[P+(La<<2)>>2]=w;c[P+(F+2<<2)>>2]=-1;Ma=-1;Na=y+1|0}else{Ma=w;Na=y}da=c[A>>2]|0;if((da|0)>-1){ea=c[s>>2]|0;Q=da;da=0;do{fa=(Q|0)/2|0;if((Q&1|0)==0){c[ea+(fa*12|0)>>2]=B}else{c[ea+(fa*12|0)+4>>2]=B}da=da+1|0;Q=c[A+(da<<2)>>2]|0;}while((Q|0)>-1)}c[A>>2]=-1;Ha=Ma;Ia=Na;Ja=Y}c[A>>2]=-1;ka=0;la=Ha;ma=x+1|0;na=Ia;oa=z+1|0;pa=Ja;qa=x}else if((E|0)==0){Q=c[c[T+4>>2]>>2]|0;if(!((Q|0)>-1|(Q|0)==-4)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(!((c[A>>2]|0)>-1)){ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B;break}if(k){c[T+20>>2]=1;Oa=w;Pa=y;Qa=0}else{Q=ioa(b,R,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){da=c[t>>2]|0;ea=0;while(1){Ra=da+(ea<<2)|0;Sa=ea+1|0;if((c[Ra>>2]|0)>-1){ea=Sa}else{break}}c[Ra>>2]=B;c[da+(Sa<<2)>>2]=w;c[da+(ea+2<<2)>>2]=-1;Ta=-1;Ua=y+1|0}else{Ta=w;Ua=y}Y=c[A>>2]|0;if((Y|0)>-1){F=c[s>>2]|0;P=Y;Y=0;do{fa=(P|0)/2|0;if((P&1|0)==0){c[F+(fa*12|0)>>2]=B}else{c[F+(fa*12|0)+4>>2]=B}Y=Y+1|0;P=c[A+(Y<<2)>>2]|0;}while((P|0)>-1)}c[A>>2]=-1;Oa=Ta;Pa=Ua;Qa=Q}c[A>>2]=-1;ka=v;la=Oa;ma=x+1|0;na=Pa;oa=z+1|0;pa=Qa;qa=x}else{ka=v;la=w;ma=x;na=y;oa=z;pa=0;qa=B}}while(0);R=c[S>>2]|0;if((R|0)>-1){Va=0}else{G=ka;H=la;I=ma;J=na;K=oa;L=A;M=pa;N=qa;break b}do{Wa=p+(Va<<2)|0;Va=Va+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=R;c[p+(Va<<2)>>2]=-1;G=ka;H=la;I=ma;J=na;K=oa;L=A;M=pa;N=qa;break};case 2:{S=A;while(1){if((c[S>>2]|0)>-1){S=S+4|0}else{G=v;H=w;I=x;J=y;K=z;L=S;M=0;N=B;break}}break};case 1:{S=u+ -2|0;c[h>>2]=S;R=c[D+(S<<2)>>2]|0;if(k){S=c[(c[c[R+4>>2]>>2]|0)+20>>2]|0;T=u+ -3|0;c[h>>2]=T;c[R+20>>2]=(c[D+(T<<2)>>2]|0)+S;G=v;H=-1;I=x;J=y;K=z;L=A;M=0;N=B;break b}else{S=u+ -3|0;c[h>>2]=S;T=c[D+(S<<2)>>2]|0;S=u+ -4|0;c[h>>2]=S;R=(T|0)==0;G=R&1;H=R?w:c[D+(S<<2)>>2]|0;I=x;J=y;K=z;L=A;M=0;N=B;break b}break};default:{G=v;H=w;I=x;J=y;K=z;L=A;M=0;N=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(M|0)==0){u=D;v=G;w=H;x=I;y=J;z=K;A=L;B=N}else{Z=H;_=J;$=K;aa=L;ba=M;ca=N;break a}}}else{Z=-1;_=0;$=0;aa=n;ba=e;ca=0}}while(0);do{if(k){Xa=_}else{e=c[aa>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;N=e;e=0;do{M=(N|0)/2|0;if((N&1|0)==0){c[n+(M*12|0)>>2]=ca}else{c[n+(M*12|0)+4>>2]=ca}e=e+1|0;N=c[aa+(e<<2)>>2]|0;}while((N|0)>-1)}c[aa>>2]=-1;if(!((Z|0)>-1)){Xa=_;break}N=c[f+36>>2]|0;e=0;while(1){Ya=N+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=ca;c[N+(Za<<2)>>2]=Z;c[N+(e+2<<2)>>2]=-1;Xa=_+1|0}}while(0);c[f+48>>2]=$;c[f+40>>2]=$;c[f+44>>2]=Xa;Toa(m);Toa(p);o=ba;i=g;return o|0}function boa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;k=doa(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((k|0)!=0){l=k;m=10;break a}k=boa(c[h>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else if((a|0)==3){k=c[g+4>>2]|0;j=boa(c[k>>2]|0,b,d,e)|0;if((j|0)!=0){l=j;m=10;break a}n=k+4|0}else if((a|0)==2){k=c[g+4>>2]|0;j=k;if(!((c[k+8>>2]|0)==-1)){n=j;break}h=c[k>>2]|0;k=doa(c[h+28>>2]|0,c[h+24>>2]|0,b,d,e)|0;if((k|0)==0){n=j}else{l=k;m=10;break a}}else{l=0;m=10;break a}}while(0);g=c[n>>2]|0}if((m|0)==10){i=f;return l|0}return 0}function coa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{Toa(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}Toa(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){Toa(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){Toa(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}Toa(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{Toa(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}Toa(m)}m=c[d+32>>2]|0;if((m|0)!=0){Toa(m)}m=c[d+20>>2]|0;if((m|0)!=0){Toa(m)}m=c[d+36>>2]|0;if((m|0)!=0){Toa(m)}Toa(d);i=b;return}function doa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=Soa(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){Toa(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=Soa((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function eoa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=qoa(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=qoa(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=qoa(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function foa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=goa(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==1){r=c[o+4>>2]|0;s=goa(a,c[r>>2]|0)|0;if((s|0)!=0){m=s;p=28;break a}t=goa(a,c[r+4>>2]|0)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=goa(a,r)|0}else if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){u=r;v=d;w=0;while(1){x=w+1|0;if((u|0)==(s|0)){break}y=d+(x<<2)|0;z=c[y>>2]|0;if((z|0)>-1){u=z;v=y;w=x}else{A=y;B=x;break c}}if((s|0)<0){A=v;B=w}else{break b}}else{A=d;B=0}}while(0);c[A>>2]=s;c[d+(B+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){t=goa(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}t=goa(a,r)|0}else{continue a}}while(0);if((t|0)!=0){m=t;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function goa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=Voa(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;goa(a,b)|0;i=d;return 0}return 0}function hoa(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;goa(d,e)|0;e=goa(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==2){y=c[u+4>>2]|0;x=goa(d,c[y>>2]|0)|0;if((x|0)!=0){v=s;w=x;break a}x=goa(d,0)|0;if((x|0)!=0){v=s;w=x;break a}x=c[y>>2]|0;D=c[y+4>>2]|0;E=c[y+8>>2]|0;F=a[y+12|0]|0;y=qoa(b,0,0,1,32)|0;if((y|0)==0){G=40;break b}H=qoa(b,0,0,1,16)|0;I=y+4|0;c[I>>2]=H;if((H|0)==0){G=40;break b}c[y>>2]=2;c[y+8>>2]=-1;c[y+12>>2]=-1;c[H>>2]=x;c[H+4>>2]=D;c[H+8>>2]=E;E=H+12|0;a[E]=a[E]&-2|F&1;c[y+16>>2]=c[x+16>>2];c[t>>2]=y;A=s;B=r;t=c[I>>2]|0;s=A;r=B;continue b}else if((z|0)==0){I=c[u+4>>2]|0;y=c[I+8>>2]|0;x=c[I>>2]|0;F=c[I+4>>2]|0;do{if((x|0)>-1|(x|0)==-4){J=r;K=F;L=x;M=s+1|0;N=(c[g>>2]|0)+y|0}else{if(!((x|0)==-3)){J=r;K=F;L=x;M=s;N=y;break}if(!p){J=r;K=-1;L=-1;M=s;N=-1;break}if(q|(r|0)==0){J=r;K=F;L=-3;M=s;N=y;break}c[h+(F<<2)>>2]=1;J=0;K=F;L=-3;M=s;N=y}}while(0);y=qoa(b,0,0,1,32)|0;F=y;do{if((y|0)==0){O=0}else{x=qoa(b,0,0,1,20)|0;c[y+4>>2]=x;if((x|0)==0){O=0;break}c[y>>2]=0;c[y+8>>2]=-1;c[y+12>>2]=-1;c[x>>2]=L;c[x+4>>2]=K;c[x+8>>2]=N;O=F}}while(0);c[t>>2]=O;F=(O|0)==0?12:0;if((N|0)<=(c[k>>2]|0)){P=J;Q=M;R=t;S=F;break}c[k>>2]=N;P=J;Q=M;R=t;S=F}else if((z|0)==3){F=c[u+4>>2]|0;y=c[F>>2]|0;x=F+4|0;I=c[x>>2]|0;E=qoa(b,0,0,1,32)|0;if((E|0)==0){G=20;break b}H=qoa(b,0,0,1,8)|0;D=E+4|0;c[D>>2]=H;if((H|0)==0){G=20;break b}c[E>>2]=3;c[E+8>>2]=-1;c[E+12>>2]=-1;c[H>>2]=y;c[(c[D>>2]|0)+4>>2]=I;c[E+16>>2]=(c[I+16>>2]|0)+(c[y+16>>2]|0);c[t>>2]=E;E=c[D>>2]|0;D=goa(d,c[x>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,E+4|0)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,c[F>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}P=r;Q=s;R=E;S=goa(d,0)|0}else if((z|0)==1){E=c[u+4>>2]|0;D=c[E>>2]|0;F=E+4|0;x=c[F>>2]|0;y=qoa(b,0,0,1,32)|0;if((y|0)==0){G=29;break b}I=qoa(b,0,0,1,8)|0;H=y+4|0;c[H>>2]=I;if((I|0)==0){G=29;break b}c[y>>2]=1;c[y+8>>2]=-1;c[y+12>>2]=-1;c[I>>2]=D;c[(c[H>>2]|0)+4>>2]=x;c[y+16>>2]=(c[x+16>>2]|0)+(c[D+16>>2]|0);c[t>>2]=y;y=c[H>>2]|0;c[y>>2]=0;H=y+4|0;c[H>>2]=0;D=goa(d,c[F>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,0)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,H)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,1)|0;if((D|0)!=0){v=s;w=D;break a}D=goa(d,c[E>>2]|0)|0;if((D|0)!=0){v=s;w=D;break a}P=r;Q=s;R=y;S=goa(d,0)|0}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((S|0)==0){r=P;s=Q;t=R}else{v=Q;w=S;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function ioa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=qoa(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=qoa(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=qoa(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=qoa(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function joa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=qoa(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=qoa(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=qoa(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=qoa(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function koa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function loa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=125208}else{j=b;k=125208;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((upa(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,125496,g|0)|0)+1|0;i=d;return h|0}function moa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=Soa(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=Soa(y)|0;if((z|0)==0){A=12;break}ypa(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=Wna(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((Bna(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((Bna(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((Bna(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((Bna(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(Bna(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(Bna(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(Bna(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(Bna(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){ypa(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=Wna(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((Bna(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((Bna(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((Bna(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((Bna(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(Bna(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(Bna(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(Bna(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(Bna(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((Fna(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=Rna(X)|0;qb=_a+24|0;if((Fna(fb,c[qb>>2]|0)|0)!=0){break}fb=Pna(X)|0;if((Fna(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((Fna(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=Pna(X)|0;if((Fna(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=Rna(X)|0;if((Fna(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}Toa(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=ooa(0,0)|0;if((S|0)==0){A=12;break}R=qoa(S,0,0,0,32)|0;Q=R;if((R|0)==0){poa(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=Soa(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=Soa(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=Soa(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){ypa(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){ypa(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=Wna(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((Bna(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((Bna(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((Bna(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((Bna(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(Bna(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(Bna(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(Bna(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(Bna(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=qoa(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=qoa(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;noa(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((rpa(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=Wna(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=Wna(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((Bna(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((Bna(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((Bna(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((Bna(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(Bna(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(Bna(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(Bna(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(Bna(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((Fna(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=Rna(tc)|0;aa=Ca+24|0;if((Fna(qa,c[aa>>2]|0)|0)!=0){break}qa=Pna(tc)|0;if((Fna(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((Fna(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=Pna(tc)|0;if((Fna(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=Rna(tc)|0;if((Fna(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=qoa(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=qoa(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){poa(S);if((Eb|0)!=0){Toa(O)}if((Kb|0)!=0){Toa(Kb)}if((Lb|0)==0){A=12;break a}Toa(N);A=12;break a}else if((sa|0)==67){poa(S);if((Eb|0)!=0){Toa(O)}if((Kb|0)!=0){Toa(Kb)}if((Lb|0)==0){A=12;break a}Toa(N);A=12;break a}else if((sa|0)==169){poa(S);if((Eb|0)!=0){Toa(O)}if((Kb|0)!=0){Toa(Kb)}if((Lb|0)==0){A=12;break a}Toa(N);A=12;break a}else if((sa|0)==176){poa(S);if((Eb|0)!=0){Toa(O)}if((Kb|0)!=0){Toa(Kb)}if((Lb|0)==0){A=12;break a}Toa(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);poa(S);if((Jb|0)!=0){Toa(Jb)}if((Gb|0)!=0){Toa(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}Toa(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}noa(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}Toa(m);p=A;i=g;return p|0}function noa(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function ooa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=Uoa(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function poa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;Toa(e);i=b;return}else{f=d}while(1){Toa(c[f>>2]|0);d=c[f+4>>2]|0;Toa(f);if((d|0)==0){break}else{f=d}}e=a;Toa(e);i=b;return}function qoa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=Soa(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=Soa(p)|0;c[o>>2]=r;if((r|0)==0){Toa(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}ypa(m|0,0,h|0)|0;j=m;i=g;return j|0}function roa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((soa(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function soa(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function toa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function uoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function voa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function woa(a){a=a|0;i=i;return}function xoa(a){a=a|0;c[a>>2]=125512;i=i;return}function yoa(a){a=a|0;var b=0;b=i;zb(a|0);_oa(a);i=b;return}function zoa(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function Aoa(a){a=a|0;i=i;return 125528}function Boa(a){a=a|0;i=i;return}function Coa(a){a=a|0;i=i;return}function Doa(a){a=a|0;i=i;return}function Eoa(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Foa(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Goa(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Hoa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=Loa(b,125640,125696,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ie[c[(c[h>>2]|0)+28>>2]&31](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function Ioa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Joa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ie[c[(c[h>>2]|0)+28>>2]&31](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function Koa(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ie[c[(c[l>>2]|0)+28>>2]&31](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ie[c[(c[m>>2]|0)+28>>2]&31](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function Loa(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;re[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ce[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function Moa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;re[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ce[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ce[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function Noa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ce[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;re[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function Ooa(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function Poa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;re[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;re[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Qoa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;re[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function Roa(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}



function x$(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=Uoa(c[f>>2]<<2,4)|0;c[e>>2]=g;wW(c[d+536>>2]|0,(g|0)!=0|0,77944,k);g=s+240|0;f=z$(g)|0;h=s+264|0;t=z$(h)|0;u=s+288|0;v=z$(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=z$(g)|0;D=z$(h)|0;E=z$(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){E$(l,b,A+(v*52|0)+4|0);G$(n,b);if(!(F$(l,n)|0)){F=w;break}G=(c[(H$(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){E$(l,g,A+(v*52|0)+4|0);G$(m,g);if(!(F$(l,m)|0)){F=w;break}G=(c[(H$(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==1){E$(l,v,G+(t*52|0)+4|0);G$(p,v);J=(F$(l,p)|0)&1}else if(f<<24>>24==0){E$(l,h,G+(t*52|0)+4|0);G$(o,h);f=F$(l,o)|0;J=f?2:0}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(H$(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==1){E$(l,d,y+(t*52|0)+4|0);G$(r,d);M=(F$(l,r)|0)&1}else if(x<<24>>24==0){E$(l,u,y+(t*52|0)+4|0);G$(q,u);x=F$(l,q)|0;M=x?2:0}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(H$(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function y$(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(upa(d|0)|0)+1;e=m;bha(e,l,20)|0;if(yfa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];xW(l,77920,k)}bha(e,d,c[f>>2]|0)|0;if(yfa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];xW(m,77920,j)}else{i=h;return}}function z$(a){a=a|0;var b=0,d=0;b=i;d=c[(l0(a)|0)>>2]|0;i=b;return d|0}function A$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;MX(3);do{if(xfa(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];dha(k,e)|0;k=z$(h+240|0)|0;m=z$(h+264|0)|0;l=z$(h+288|0)|0;y$(a,b,77824,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);o$(h)}else{if((h|0)!=0){break}c[g>>2]=0;PX(3);i=d;return}}while(0);B$(j);_oa(h);c[g>>2]=0;PX(3);i=d;return}function B$(a){a=a|0;var b=0;b=i;J0(a);i=b;return}function C$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;MX(3);PX(0);h[j>>3]=+HX(0);MX(0);l=k;m=d+4|0;bha(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){bha(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){bha(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);bha(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);bha(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);bha(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(yfa(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];xW(t,77864,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;PX(3);i=e;return}}function D$(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((rpa(b,78080,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((rpa(b,78080,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function E$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;Z$(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];P$(a,f);i=e;return}function F$(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=N$(a,b)|0;i=c;return d|0}function G$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Q$(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];P$(a,e);i=d;return}function H$(a){a=a|0;var b=0,c=0;b=i;c=I$(J$(a)|0)|0;i=b;return c|0}function I$(a){a=a|0;var b=0,c=0;b=i;c=M$(a)|0;i=b;return c|0}function J$(a){a=a|0;var b=0,d=0;b=i;d=K$((c[a>>2]|0)+16|0)|0;i=b;return d|0}function K$(a){a=a|0;var b=0,c=0;b=i;c=L$(a)|0;i=b;return c|0}function L$(a){a=a|0;i=i;return a|0}function M$(a){a=a|0;i=i;return a|0}function N$(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(O$(a,b)|0)^1;i=c;return d|0}function O$(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function P$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Y$(a,e);i=d;return}function Q$(a,b){a=a|0;b=b|0;var c=0;c=i;R$(a,S$(b)|0);i=c;return}function R$(a,b){a=a|0;b=b|0;var c=0;c=i;X$(a,b);i=c;return}function S$(a){a=a|0;var b=0,c=0;b=i;c=T$(U$(a+4|0)|0)|0;i=b;return c|0}function T$(a){a=a|0;var b=0,c=0;b=i;c=W$(a)|0;i=b;return c|0}function U$(a){a=a|0;var b=0,c=0;b=i;c=V$(a)|0;i=b;return c|0}function V$(a){a=a|0;i=i;return a|0}function W$(a){a=a|0;i=i;return a|0}function X$(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Y$(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Z$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=$$(b)|0;_$(f,b,d,h,S$(b)|0);Q$(g,b);do{if(N$(f,g)|0){h=a0(b)|0;if(b0(h,d,c0(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Q$(a,b);i=e;return}function _$(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;g0(h);a:do{if((e|0)==0){j=f}else{k=a0(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(h0(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;g0(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;g0(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);R$(a,j);i=g;return}function $$(a){a=a|0;var b=0,d=0;b=i;d=c[(S$(a)|0)>>2]|0;i=b;return d|0}function a0(a){a=a|0;var b=0,c=0;b=i;c=e0(a+8|0)|0;i=b;return c|0}function b0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=d0(0,b,c)|0;i=a;return d|0}function c0(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function d0(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function e0(a){a=a|0;var b=0,c=0;b=i;c=f0(a)|0;i=b;return c|0}function f0(a){a=a|0;i=i;return a|0}function g0(a){a=a|0;var b=0;b=i;i0(a,-1);i=b;return}function h0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=d0(0,b,c)|0;i=a;return d|0}function i0(a,b){a=a|0;b=b|0;b=i;j0(a,0);i=b;return}function j0(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function k0(a){a=a|0;i=i;return c[a+4>>2]|0}function l0(a){a=a|0;var b=0,c=0;b=i;c=m0(a+8|0)|0;i=b;return c|0}function m0(a){a=a|0;var b=0,c=0;b=i;c=n0(a)|0;i=b;return c|0}function n0(a){a=a|0;i=i;return a|0}function o0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 1:case 17:{h=77992;break};case 28:{h=78056;break};case 52:case 20:{h=78032;break};case 13:case 29:{h=78072;break};case 5:case 21:{h=78040;break};case 60:{h=78064;break};case 48:case 16:{h=77984;break};case 12:{h=78048;break};case 9:case 25:{h=78024;break};case 8:{h=78e3;break};case 24:{h=78008;break};case 56:{h=78016;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ic(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Wc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Yc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function p0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function q0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}r0(d,f,104);f=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Yc(s0(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}t0(d);g=h;i=b;return g|0}function r0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;A0(a,b,c);i=d;return}function s0(a){a=a|0;var b=0,d=0;b=i;d=w0(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function t0(a){a=a|0;var b=0;b=i;u0(a);i=b;return}function u0(a){a=a|0;var b=0;b=i;v0(a,0);i=b;return}function v0(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=w0(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ie[c[(x0(e)|0)>>2]&127](f)|0;i=d;return}function w0(a){a=a|0;var b=0,c=0;b=i;c=z0(a)|0;i=b;return c|0}function x0(a){a=a|0;var b=0,c=0;b=i;c=y0(a)|0;i=b;return c|0}function y0(a){a=a|0;i=i;return a+4|0}function z0(a){a=a|0;i=i;return a|0}function A0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(C0(f)|0)>>2]|0;B0(a,d,c[(D0(g)|0)>>2]|0);i=e;return}function B0(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;E0(a,b,c);i=d;return}function C0(a){a=a|0;i=i;return a|0}function D0(a){a=a|0;i=i;return a|0}function E0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(G0(f)|0)>>2]|0;F0(a,d,c[(H0(g)|0)>>2]|0);i=e;return}function F0(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(G0(f)|0)>>2];c[a+4>>2]=c[(H0(g)|0)>>2];i=e;return}function G0(a){a=a|0;i=i;return a|0}function H0(a){a=a|0;i=i;return a|0}function I0(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function J0(a){a=a|0;var b=0;b=i;K0(a+300|0);K0(a+288|0);K0(a+276|0);K0(a+264|0);K0(a+252|0);K0(a+240|0);L0(a);i=b;return}function K0(a){a=a|0;var b=0;b=i;v1(a);i=b;return}function L0(a){a=a|0;var b=0;b=i;M0(a,78128);Ffa(a+104|0);i=b;return}function M0(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Q0(a+4|0);i=d;return}function N0(a){a=a|0;var b=0;b=i;L0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function O0(a){a=a|0;var b=0;b=i;L0(a);_oa(a);i=b;return}function P0(a){a=a|0;var b=0;b=i;O0(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function Q0(a){a=a|0;var b=0;b=i;R0(a);i=b;return}function R0(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=78256;q0(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}$oa(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}$oa(e)}}while(0);Ofa(b);i=d;return}function S0(a){a=a|0;var b=0;b=i;Q0(a);_oa(a);i=b;return}function T0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=t1(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=u1(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;Yfa(h,0,0,0);bga(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}$oa(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=Zoa(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=Zoa(h)|0;a[b+97|0]=1;i=e;return}function U0(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;Yfa(e,0,0,0);bga(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}$oa(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}$oa(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=Zoa(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(q1(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=Zoa(o)|0;a[k]=1;i=f;return e|0}return 0}function V0(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;xoa(n);Td(n|0,125584,127)}n=m1(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){u$(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=Npa(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Wc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;u$(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];p1(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{u$(a,-1,-1);i=g;return}}}while(0);u$(a,-1,-1);i=g;return}function W0(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=I0(d)|0;if((Wc(j|0,k|0,0)|0)==0){o1(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{u$(a,-1,-1);i=e;return}}}while(0);u$(a,-1,-1);i=e;return}function X0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;xoa(m);Td(m|0,125584,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=m1(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=Wfa(s)|0;u=(fa(t-(Vfa(s)|0)|0,p)|0)+r|0;v=0;break}p=Vfa(s)|0;if((p|0)==(Wfa(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=n1(t,g,x,o,p-(Ufa(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=Wfa(w)|0;u=q-(Vfa(w)|0)|0;v=0}}while(0);if((Wc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;Yfa(b,0,0,0);c[m>>2]=0}else{q=b;y=_fa(q)|0;do{if((y|0)!=(Zfa(q)|0)){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=l1(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((ud(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function Y0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=g1(b)|0;o=b;if((Vfa(o)|0)==0){p=e+1|0;Yfa(o,e,p,p)}if(n){q=0}else{n=Wfa(o)|0;c[f>>2]=(n-(Ufa(o)|0)|0)/2|0;c[g>>2]=4;q=c[(h1(f,g)|0)>>2]|0}g=Vfa(o)|0;do{if((g|0)==(Wfa(o)|0)){xpa(Ufa(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=Wfa(o)|0;n=Ufa(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=Ufa(o)|0;Yfa(o,n,n+q|0,n+(p+q)|0);r=e1(a[Vfa(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;xpa(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(h1(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;xoa(t);Td(t|0,125584,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=Ufa(o)|0;if((i1(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;Yfa(o,f,f,c[s>>2]|0);r=e1(a[Vfa(o)|0]|0)|0;break}s=c[k>>2]|0;f=Ufa(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}Yfa(o,f,p,s);r=e1(a[Vfa(o)|0]|0)|0}else{r=e1(a[g]|0)|0}}while(0);if((Ufa(o)|0)!=(e|0)){m=r;i=d;return m|0}Yfa(o,0,0,0);m=r;i=d;return m|0}function Z0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=Ufa(g)|0;j=Vfa(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(a1(d,-1)|0){Xfa(g,-1);f=d1(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=b1(d)|0;do{if(h){if(f1(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);Xfa(g,-1);a[Vfa(g)|0]=b;f=d;i=e;return f|0}function _0(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}$0(b);l=b;m=Zfa(l)|0;n=$fa(l)|0;if(!(a1(d,-1)|0)){if((_fa(l)|0)==0){bga(l,f,f+1|0)}f=b1(d)|0;a[_fa(l)|0]=f;aga(l,1)}f=_fa(l)|0;o=Zfa(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;xoa(u);v=125584;w=127;Td(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=Zfa(l)|0;A=_fa(l)|0;B=c1(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=Zfa(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;bga(l,B,_fa(l)|0);B=$fa(l)|0;aga(l,B-(Zfa(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;xoa(u);v=125584;w=127;Td(t|0,v|0,w|0)}else if((D|0)==14){q=(_fa(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);bga(l,m,n)}k=d1(d)|0;i=e;return k|0}function $0(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;Yfa(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;bga(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;bga(f,h,h+(g+ -1)|0);break}}else{bga(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function a1(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function b1(a){a=a|0;i=i;return a&255|0}function c1(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function d1(a){a=a|0;var b=0,c=0;b=i;c=a1(a,-1)|0;i=b;return(c?0:a)|0}function e1(a){a=a|0;i=i;return a&255|0}function f1(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function g1(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;bga(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;Yfa(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;Yfa(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function h1(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=j1(b,c,e)|0;i=d;return g|0}function i1(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function j1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=k1(0,b,a)|0;i=c;return(d?b:a)|0}function k1(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function l1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function m1(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function n1(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function o1(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function p1(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function q1(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=r1(b,c,e)|0;i=d;return g|0}function r1(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=s1(0,a,b)|0;i=c;return(d?b:a)|0}function s1(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function t1(a){a=a|0;var b=0,c=0;b=i;c=xla(a,110088)|0;i=b;return c|0}function u1(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function v1(a){a=a|0;var b=0;b=i;w1(a);i=b;return}function w1(a){a=a|0;var b=0;b=i;x1(a);i=b;return}function x1(a){a=a|0;var b=0;b=i;y1(a,$$(a)|0);i=b;return}function y1(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;g0(d);if((b|0)==0){i=d;return}y1(a,c[b>>2]|0);y1(a,c[b+4>>2]|0);A1(z1(a)|0,b,1);i=d;return}function z1(a){a=a|0;var b=0,c=0;b=i;c=C1(a+4|0)|0;i=b;return c|0}function A1(a,b,c){a=a|0;b=b|0;c=c|0;c=i;B1(0,b,0);i=c;return}function B1(a,b,c){a=a|0;b=b|0;c=c|0;c=i;_oa(b);i=c;return}function C1(a){a=a|0;var b=0,c=0;b=i;c=D1(a)|0;i=b;return c|0}function D1(a){a=a|0;i=i;return a|0}function E1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=F1(a,f,b)|0;l=c[k>>2]|0;g0(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}H1(j,a,b);I1(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];G1(g,e);J1(j);j=c[f>>2]|0;K1(a,j,k,L1(g)|0);k=M1(g)|0;J1(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function F1(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=$$(h)|0;g0(e);if((a|0)==0){j=S$(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(d0(0,d,a)|0){m=l;j=c[m>>2]|0;g0(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(d0(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g0(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function G1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];y2(a,e);i=d;return}function H1(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=z1(d)|0;d=h2(n,1)|0;i2(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];g2(j,d,h);j2(0,c2((k2(j)|0)+16|0)|0,e);e=l2(j)|0;a[e+4|0]=1;m2(0,b2((k2(j)|0)+20|0)|0);a[e+5|0]=1;n2(m,j);I1(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];G1(b,g);J1(m);J1(j);i=f;return}function I1(a,b){a=a|0;b=b|0;var c=0;c=i;e2(a,b);i=c;return}function J1(a){a=a|0;var b=0;b=i;Z1(a);i=b;return}function K1(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g0(f);c[e>>2]=0;g0(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=R1(a)|0;b=c[c[e>>2]>>2]|0;g0(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(S$(a)|0)>>2]|0;S1(e,c[d>>2]|0);d=T1(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function L1(a){a=a|0;var b=0,d=0;b=i;d=c[(P1(a)|0)>>2]|0;i=b;return d|0}function M1(a){a=a|0;var b=0,d=0;b=i;d=N1(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function N1(a){a=a|0;var b=0,c=0;b=i;c=O1(a)|0;i=b;return c|0}function O1(a){a=a|0;i=i;return a|0}function P1(a){a=a|0;var b=0,c=0;b=i;c=Q1(a)|0;i=b;return c|0}function Q1(a){a=a|0;i=i;return a|0}function R1(a){a=a|0;i=i;return a|0}function S1(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=W1(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;g0(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;g0(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(W1(j)|0){p=j}else{o=c[k>>2]|0;X1(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;Y1(p);i=e;return}else if((l|0)==14){if(W1(j)|0){p=c[k>>2]|0;Y1(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;X1(q);i=e;return}else if((l|0)==17){i=e;return}}function T1(a){a=a|0;var b=0,c=0;b=i;c=U1(a+8|0)|0;i=b;return c|0}function U1(a){a=a|0;var b=0,c=0;b=i;c=V1(a)|0;i=b;return c|0}function V1(a){a=a|0;i=i;return a|0}function W1(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function X1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;g0(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=W1(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Y1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;g0(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=W1(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function Z1(a){a=a|0;var b=0;b=i;_1(a,0);i=b;return}function _1(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=N1(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}a2($1(e)|0,f);i=d;return}function $1(a){a=a|0;var b=0,c=0;b=i;c=d2(a)|0;i=b;return c|0}function a2(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}A1(c[a>>2]|0,b,1);i=d;return}function b2(a){a=a|0;i=i;return a|0}function c2(a){a=a|0;i=i;return a|0}function d2(a){a=a|0;i=i;return a+4|0}function e2(a,b){a=a|0;b=b|0;var c=0;c=i;f2(a,b);i=c;return}function f2(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function g2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];q2(a,b,f);i=e;return}function h2(a,b){a=a|0;b=b|0;var c=0;a=i;c=p2(0,b,0)|0;i=a;return c|0}function i2(a,b){a=a|0;b=b|0;var c=0;c=i;o2(a,b);i=c;return}function j2(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function k2(a){a=a|0;var b=0,d=0;b=i;d=c[(P1(a)|0)>>2]|0;i=b;return d|0}function l2(a){a=a|0;var b=0,c=0;b=i;c=$1(a)|0;i=b;return c|0}function m2(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function n2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;e2(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];G1(h,f);I1(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];G1(a,e);J1(h);i=d;return}function o2(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function p2(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Yoa(b*24|0)|0;i=c;return a|0}function q2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(s2(g)|0)>>2]|0;g=t2(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];r2(b,a,f);i=e;return}function r2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];u2(a,b,f);i=e;return}function s2(a){a=a|0;i=i;return a|0}function t2(a){a=a|0;i=i;return a|0}function u2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(w2(g)|0)>>2]|0;g=x2(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];v2(b,a,f);i=e;return}function v2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(w2(f)|0)>>2];f=x2(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function w2(a){a=a|0;i=i;return a|0}function x2(a){a=a|0;i=i;return a|0}function y2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=M1(z2(b)|0)|0;h=x2(l2(z2(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];r2(g,a,e);i=d;return}function z2(a){a=a|0;i=i;return c[a>>2]|0}function A2(a){a=a|0;var b=0;b=i;i=i+48|0;B2(a);u$(a+184|0,0,0);u$(a+200|0,0,0);C2(a+240|0,b);C2(a+252|0,b+8|0);C2(a+264|0,b+16|0);C2(a+276|0,b+24|0);C2(a+288|0,b+32|0);C2(a+300|0,b+40|0);i=b;return}function B2(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;Kfa(d);e=a;c[e>>2]=78100;f=d;c[f>>2]=78120;d=a+4|0;Rga(a,78132|0,d);c[e>>2]=78100;c[f>>2]=78120;P2(d);i=b;return}function C2(a,b){a=a|0;b=b|0;b=i;D2(a,0);i=b;return}function D2(a,b){a=a|0;b=b|0;b=i;i=i+8|0;E2(a,b);i=b;return}function E2(a,b){a=a|0;b=b|0;b=i;F2(a,0);i=b;return}function F2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;G2(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;H2(f,0,e);e=S$(b)|0;c[(R1(b)|0)>>2]=e;i=d;return}function G2(a){a=a|0;var b=0;b=i;L2(a);i=b;return}function H2(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;I2(b,c,f);i=e;return}function I2(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K2(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;J2(d,b,f);i=e;return}function J2(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K2(e)|0)>>2];i=d;return}function K2(a){a=a|0;i=i;return a|0}function L2(a){a=a|0;var b=0;b=i;M2(a);i=b;return}function M2(a){a=a|0;var b=0;b=i;N2(a);i=b;return}function N2(a){a=a|0;var b=0;b=i;O2(a);i=b;return}function O2(a){a=a|0;c[a>>2]=0;i=i;return}function P2(a){a=a|0;var b=0;b=i;Q2(a);i=b;return}function Q2(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;Tfa(j);c[d>>2]=78256;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;g0(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;Pfa(g,j);l=R2(g)|0;vla(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}Pfa(h,j);c[k>>2]=t1(h)|0;vla(h);a[f]=(u1(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}function R2(a){a=a|0;var b=0,c=0;b=i;c=wla(a,110088)|0;i=b;return c|0}function S2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;MX(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){T2(a,b,c[f>>2]|0,h);PX(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=Voa(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;xW(k,78528,e)}T2(a,b,l,h);PX(3);i=d;return}function T2(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;PX(0);k=+HX(0);MX(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function U2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=Soa(24)|0;MX(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;wW(c[m>>2]|0,l>>>31^1,78584,f);f=b+8|0;b=c[a+8>>2]|0;l=V2(b,f)|0;c[g+20>>2]=l;l=V2(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=Soa(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;xW(k,78664,e)}else{c[h>>2]=0;c[a+12>>2]=g;PX(3);i=d;return}}function V2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function W2(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;MX(3);u=b;v=ic(c[u>>2]|0,78728)|0;if((v|0)==0){X2(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;xW(w,78736,q)}rc(78792,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];wd(v|0,78840,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];wd(v|0,78864,o|0)|0;rc(78888,40,1,v|0)|0;rc(78936,11,1,v|0)|0;rc(78952,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];Y2(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(78968,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;Y2(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Sd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];wd(v|0,78992,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;Y2(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Sd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];wd(v|0,78992,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;Y2(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Sd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];wd(v|0,78992,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;Y2(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];wd(v|0,78992,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;Y2(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Sd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];wd(v|0,78992,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;Y2(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Sd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];wd(v|0,78992,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;Y2(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Sd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}X2(t);if((Yc(v|0)|0)==0){Toa(c[r>>2]|0);c[r>>2]=0;PX(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];xW(e,79008,f)}}function X2(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}Toa(a);c[d>>2]=0;i=b;return}function Y2(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];wd(a|0,79056,f|0)|0;i=e;return}function Z2(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=Yoa(192)|0;ypa(m|0,0,192)|0;_2(m);c[a+12>>2]=m;n=m;o=a;v$(n,c[o>>2]|0,36);if(yfa(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];xW(a,79096,g)}else{g=m;bha(g,79072,14)|0;cha(h,g);a=I0(h)|0;h=m+184|0;c[h>>2]=a;bha(g,79088,4)|0;$2(n,b+8|0);cha(j,g);b=I0(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;u$(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];dha(g,f)|0;a3(n,-4-m+b|0);b=c[j>>2]|0;u$(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];dha(g,e)|0;PX(3);i=d;return}}function _2(a){a=a|0;var b=0;b=i;t3(a);i=b;return}function $2(a,b){a=a|0;b=b|0;var c=0;c=i;c3(a,3);d3(a,79272);c3(a,0);d3(a,79280);c3(a,2);o3(a,b);p3(a,b);d3(a,79288);c3(a,0);i=c;return}function a3(a,b){a=a|0;b=b|0;var d=0;d=i;c[19816]=Hd(b|0)|0;bha(a,79264,4)|0;i=d;return}function b3(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;cha(l,q);r=I0(l)|0;a3(b,0);cha(m,q);l=I0(m)|0;c3(b,1);d3(b,79160);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;e3(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);f3(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{f3(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{g3(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{h3(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{d3(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}cha(n,q);u=I0(n)|0;n=vpa(0,r|0,32)|0;u$(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];dha(q,k)|0;a3(b,u-l|0);u$(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];dha(q,j)|0;i=g;return}function c3(b,d){b=b|0;d=d|0;var e=0;e=i;a[79248]=-33;c[19814]=Hd(d|0)|0;d=b;bha(d,79248,1)|0;bha(d,79256,4)|0;i=e;return}function d3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Hd(upa(d|0)|0)|0;a[79240]=-37;g=b;bha(g,79240,1)|0;bha(g,f,4)|0;bha(g,d,upa(d|0)|0)|0;i=e;return}function e3(b,d){b=b|0;d=d|0;var e=0;e=i;a[79224]=-35;c[19808]=Hd(d|0)|0;d=b;bha(d,79224,1)|0;bha(d,79232,4)|0;i=e;return}function f3(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[79208]=-53;n3(c);e=b;bha(e,79208,1)|0;bha(e,79216,8)|0;i=d;return}function g3(b,d){b=b|0;d=d|0;var e=0;e=i;a[79192]=-46;c[19800]=Hd(d|0)|0;d=b;bha(d,79192,1)|0;bha(d,79200,4)|0;i=e;return}function h3(b,c){b=b|0;c=c|0;var d=0;d=i;a[79184]=c?-61:-62;bha(b,79184,1)|0;i=d;return}function i3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;b3(e,+h[f>>3],a,f);b3(e,+h[b+248>>3],a,f);i=d;return}function j3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;cha(j,p);o=I0(j)|0;a3(b,0);cha(k,p);j=I0(k)|0;c3(b,1);d3(b,79168);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;e3(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;f3(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{f3(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{g3(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{h3(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{d3(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}cha(l,p);s=I0(l)|0;l=vpa(0,o|0,32)|0;u$(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];dha(p,g)|0;a3(b,s-j|0);u$(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];dha(p,f)|0;i=e;return}function k3(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;o$(a);MX(3);if((a|0)!=0){l3(a);_oa(a)}c[d>>2]=0;PX(3);i=b;return}function l3(a){a=a|0;var b=0;b=i;m3(a);i=b;return}function m3(a){a=a|0;var b=0;b=i;L0(a);i=b;return}function n3(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Hd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=79216;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[79216+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function o3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;d3(a,79160);c3(a,4);d3(a,79296);c3(a,0);d3(a,79304);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;e3(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);d3(a,79312);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{d3(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{d3(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{d3(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{d3(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=79400;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];q3(a,b,e);d3(a,79336);c3(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);r3(a,79312,79344);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;r3(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;r3(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;r3(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;r3(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function p3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;d3(a,79168);c3(a,4);d3(a,79296);c3(a,0);d3(a,79304);o=g+1+j+l+n|0;e3(a,o);d3(a,79312);if((c[f>>2]|0)>0){n=b;l=0;do{d3(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{d3(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{d3(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{d3(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=79320;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];q3(a,b,e);d3(a,79336);c3(a,o);r3(a,79312,79344);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;r3(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;r3(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;r3(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;r3(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function q3(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;d3(b,79368);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}c3(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?79312:h;if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}s3(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;j=a[g+(u*52|0)+8|0]|0;if((c[e+(j<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{m=j<<24>>24==2?79312:w;if(j<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(j<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=m}s3(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?79312:l;if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}s3(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?79312:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}s3(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function r3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;d3(a,b);c3(a,1);d3(a,79352);d3(a,c);i=d;return}function s3(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;d3(a,b);c3(a,d?2:1);d3(a,79376);d3(a,c);if(!d){i=e;return}d3(a,79384);d3(a,79392);i=e;return}function t3(a){a=a|0;var b=0;b=i;B2(a);i=b;return}function u3(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;Hea(e,79416);Dea(d,w3(a,e)|0);v3(d,b+4|0);Nea(d);Nea(e);Hea(g,79424);Dea(f,w3(a,g)|0);x3(f,b);Nea(f);Nea(g);Hea(j,79440);Dea(h,w3(a,j)|0);v3(h,b+8|0);Nea(h);Nea(j);Hea(l,79456);Dea(k,w3(a,l)|0);v3(k,b+12|0);Nea(k);Nea(l);Hea(n,79472);Dea(m,w3(a,n)|0);y3(m,b+16|0,0);Nea(m);Nea(n);Hea(p,79488);Dea(o,w3(a,p)|0);y3(o,b+20|0,0);Nea(o);Nea(p);Hea(r,79504);Dea(q,w3(a,r)|0);y3(q,b+24|0,0);Nea(q);Nea(r);Hea(t,79512);Dea(s,w3(a,t)|0);y3(s,b+28|0,0);Nea(s);Nea(t);Hea(v,79528);Dea(u,w3(a,v)|0);y3(u,b+32|0,0);Nea(u);Nea(v);i=c;return}function v3(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){vW(22,0,82736,d);i=d;return}else{c[b>>2]=Ad(ifa(a)|0)|0;i=d;return}}function w3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=F7(a,f,b)|0;l=c[k>>2]|0;g0(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}H7(j,a,b);I7(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];G7(g,e);J7(j);j=c[f>>2]|0;K7(a,j,k,L7(g)|0);k=M7(g)|0;J7(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function x3(a,b){a=a|0;b=b|0;var d=0;d=i;if((lfa(a,79704)|0)==0){c[b>>2]=1;i=d;return}if((lfa(a,79712)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(ifa(a)|0)|0;i=d;return}}function y3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((lfa(a,79680)|0)==0){c[b>>2]=d}if((lfa(a,79704)|0)==0){c[b>>2]=1;i=e;return}if((lfa(a,79712)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(ifa(a)|0)|0;i=e;return}}function z3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;Hea(j,79544);Dea(g,w3(b,j)|0);y=d+48|0;A3(g,y);Nea(g);Nea(j);Hea(m,79560);Dea(l,w3(b,m)|0);j=d+56|0;B3(l,j,0.0);Nea(l);Nea(m);Hea(o,79568);Dea(n,w3(b,o)|0);m=d+32|0;A3(n,m);Nea(n);Nea(o);Hea(q,79576);Dea(p,w3(b,q)|0);o=d+33|0;A3(p,o);Nea(p);Nea(q);Hea(s,79592);Dea(r,w3(b,s)|0);q=d+40|0;B3(r,q,1.0);Nea(r);Nea(s);Hea(u,79600);Dea(t,w3(b,u)|0);s=d+16|0;B3(t,s,-1.7976931348623157e+308);Nea(t);Nea(u);Hea(w,79608);Dea(v,w3(b,w)|0);u=d+24|0;B3(v,u,1.7976931348623157e+308);Nea(v);Nea(w);Hea(x,79416);w=ifa(w3(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?79704:79712;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?79680:79688;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?79680:79696;c[f+20>>2]=j;c[f+24>>2]=m?79680:79688;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?79680:79696;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];tW(4,0,79616,f);Nea(x);i=e;return}function A3(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(lfa(b,79704)|0)==0|0;i=d;return}function B3(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((lfa(a,79680)|0)==0){h[b>>3]=c;i=d;return}if((lfa(a,79704)|0)==0){h[b>>3]=1.0;i=d;return}if((lfa(a,79712)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+mpa(ifa(a)|0);i=d;return}}function C3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;Hea(h,79544);Dea(g,w3(b,h)|0);s=d+13|0;A3(g,s);Nea(g);Nea(h);Hea(k,79560);Dea(j,w3(b,k)|0);h=d+16|0;y3(j,h,0);Nea(j);Nea(k);Hea(m,79568);Dea(l,w3(b,m)|0);k=d+12|0;A3(l,k);Nea(l);Nea(m);Hea(o,79600);Dea(n,w3(b,o)|0);m=d+4|0;y3(n,m,-2147483648);Nea(n);Nea(o);Hea(q,79608);Dea(p,w3(b,q)|0);o=d+8|0;y3(p,o,2147483647);Nea(p);Nea(q);Hea(r,79416);q=ifa(w3(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?79704:79712;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?79680:79688;c[f+8>>2]=s;c[f+12>>2]=b?79680:79696;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;tW(4,0,79720,f);Nea(r);i=e;return}function D3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;Hea(h,79544);Dea(g,w3(b,h)|0);o=d+5|0;A3(g,o);Nea(g);Nea(h);Hea(k,79560);Dea(j,w3(b,k)|0);h=d+6|0;A3(j,h);Nea(j);Nea(k);Hea(m,79568);Dea(l,w3(b,m)|0);k=d+4|0;A3(l,k);Nea(l);Nea(m);Hea(n,79416);m=ifa(w3(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?79704:79712;h=(a[k]|0)!=0?79704:79712;c[f>>2]=m;c[f+4>>2]=b?79680:79688;c[f+8>>2]=o;c[f+12>>2]=b?79680:79696;c[f+16>>2]=h;tW(4,0,79776,f);Nea(n);i=e;return}function E3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;Hea(h,79544);Dea(g,w3(b,h)|0);m=d+4|0;A3(g,m);Nea(g);Nea(h);Hea(k,79560);Dea(j,w3(b,k)|0);h=d+8|0;v3(j,h);Nea(j);Nea(k);Hea(l,79416);k=ifa(w3(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?79680:79688;c[f+8>>2]=m;c[f+12>>2]=b?79680:79696;tW(4,0,79816,f);Nea(l);i=e;return}function F3(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;G3(qa);Bea(ra);H3(sa,ta);H3(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[92800>>2]|0)==0){Hea(za,c[b+80>>2]|0);I3(ya,za,79840);Oea(ra,ya)|0;Nea(ya);Nea(za)}else{Pea(ra,c[92928>>2]|0)|0}ta=ic(ifa(ra)|0,79856)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=ifa(ra)|0;xW(0,79864,pa)}else{Wc=0}}while(0);pa=oR(0)|0;if((pa|0)==0){Yc(Wc|0)|0;xW(0,79968,oa)}zR(pa,Vc);AR(pa,8,54);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;ypa(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((BR(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){Yc(Wc|0)|0;oa=ifa(ra)|0;ya=JR(GR(pa)|0)|0;za=HR(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;vW(1,0,80048,na);vR(pa);xW(0,80136,ma)}else if((Xc|0)==14){Yc(Wc|0)|0;break}}else{if((BR(pa,Vc,upa(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=JR(GR(pa)|0)|0;ta=HR(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;wd(za|0,80160,la|0)|0;za=c[va>>2]|0;ta=JR(GR(pa)|0)|0;oa=HR(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;vW(1,0,80176,ka);vR(pa);xW(0,80136,ja)}}while(0);ja=qa;Hea(Ca,80264);M3(Ba,ja,Ca);N3(Da,ja);ka=L3(Ba,Da)|0;Nea(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=ifa(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;vW(1,0,80272,ia)}else{Hea(Ea,80264);Ba=qpa(Da,ifa(w3(ja,Ea)|0)|0)|0;Nea(Ea);if((Ba|0)==0){break}vR(pa);Hea(Fa,80264);Ba=ifa(w3(ja,Fa)|0)|0;va=ifa(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;vW(1,0,80320,ha);Nea(Fa);xW(0,80136,ga)}}while(0);O3(qa,b,c[93012>>2]|0,c[93016>>2]|0);tW(23,1,80416,fa);fa=qa+12|0;Hea(Ha,80456);Dea(Ga,w3(fa,Ha)|0);ga=d;B3(Ga,ga,0.0);Nea(Ga);Nea(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];tW(23,0,80472,ea);Hea(Ja,80488);Dea(Ia,w3(fa,Ja)|0);ea=d+8|0;B3(Ia,ea,1.0);Nea(Ia);Nea(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];tW(23,0,80504,da);Hea(La,80520);Dea(Ka,w3(fa,La)|0);da=d+24|0;B3(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);Nea(Ka);Nea(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];tW(23,0,80536,ca);Hea(Na,80552);Dea(Ma,w3(fa,Na)|0);ca=d+32|0;B3(Ma,ca,1.0e-5);Nea(Ma);Nea(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];tW(23,0,80568,ba);Hea(Pa,80584);Dea(Oa,w3(fa,Pa)|0);ba=d+40|0;v3(Oa,ba);Nea(Oa);Nea(Pa);c[aa>>2]=c[ba>>2];tW(23,0,80592,aa);Hea(Ra,80616);Dea(Qa,w3(fa,Ra)|0);aa=d+44|0;v3(Qa,aa);Nea(Qa);Nea(Ra);c[$>>2]=c[aa>>2];tW(23,0,80632,$);Hea(Ta,80656);Dea(Sa,w3(fa,Ta)|0);fa=d+48|0;v3(Sa,fa);Nea(Sa);Nea(Ta);c[_>>2]=c[fa>>2];tW(23,0,80672,_);Hea(Va,80696);Dea(Ua,w3(ja,Va)|0);_=d+268|0;v3(Ua,_);Nea(Ua);Nea(Va);c[Z>>2]=c[_>>2];tW(23,0,80720,Z);if((c[35916>>2]|0)!=0){fe[c[9094]&255](23)}Hea(eb,80744);Dea(db,w3(ja,eb)|0);y3(db,Wa,0);Nea(db);Nea(eb);Hea(gb,80776);Dea(fb,w3(ja,gb)|0);y3(fb,Xa,0);Nea(fb);Nea(gb);Hea(ib,80808);Dea(hb,w3(ja,ib)|0);y3(hb,Ya,0);Nea(hb);Nea(ib);Hea(kb,80832);Dea(jb,w3(ja,kb)|0);y3(jb,_a,0);Nea(jb);Nea(kb);Hea(mb,80864);Dea(lb,w3(ja,mb)|0);y3(lb,Za,0);Nea(lb);Nea(mb);Hea(ob,80904);Dea(nb,w3(ja,ob)|0);y3(nb,ab,0);Nea(nb);Nea(ob);Hea(qb,80936);Dea(pb,w3(ja,qb)|0);y3(pb,$a,0);Nea(pb);Nea(qb);Hea(tb,80976);Dea(rb,w3(ja,tb)|0);y3(rb,cb,0);Nea(rb);Nea(tb);Hea(vb,81008);Dea(ub,w3(ja,vb)|0);y3(ub,bb,0);Nea(ub);Nea(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=81552;tW(4,1,81528,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=P3(lb,wb)|0;u3(ib,jb+(kb*112|0)|0);z3(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(xb,81568);jb=(lfa(w3(ib,xb)|0,79704)|0)==0;Nea(xb);if(!jb){break}c[N>>2]=c[hb>>2];tW(4,0,81584,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);Hea(yb,c[hb>>2]|0);c[(Q3(sa,yb)|0)>>2]=kb;Nea(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[M>>2]=81616;tW(4,1,81528,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=P3(lb,zb)|0;u3(fb,gb+(jb*112|0)|0);z3(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Ab,81568);gb=(lfa(w3(fb,Ab)|0,79704)|0)==0;Nea(Ab);if(!gb){break}c[L>>2]=c[eb>>2];tW(4,0,81584,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);Hea(Bb,c[eb>>2]|0);c[(Q3(sa,Bb)|0)>>2]=jb;Nea(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[K>>2]=81640;tW(4,1,81528,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=P3(mb,Cb)|0;u3(gb,hb+(fb*112|0)|0);z3(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Db,81568);hb=(lfa(w3(gb,Db)|0,79704)|0)==0;Nea(Db);if(!hb){break}c[J>>2]=c[db>>2];tW(4,0,81584,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);Hea(Eb,c[db>>2]|0);c[(Q3(sa,Eb)|0)>>2]=fb;Nea(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[I>>2]=81656;tW(4,1,81528,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=P3(ub,Fb)|0;u3(mb,kb+(ib*60|0)|0);C3(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Gb,81568);kb=(lfa(w3(mb,Gb)|0,79704)|0)==0;Nea(Gb);if(!kb){break}c[H>>2]=c[gb>>2];tW(4,0,81584,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);Hea(Hb,c[gb>>2]|0);c[(Q3(sa,Hb)|0)>>2]=ib;Nea(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[G>>2]=81680;tW(4,1,81528,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=P3(ib,Ib)|0;u3(mb,ub+(lb*48|0)|0);D3(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Jb,81568);ub=(lfa(w3(mb,Jb)|0,79704)|0)==0;Nea(Jb);if(!ub){break}c[F>>2]=c[fb>>2];tW(4,0,81584,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);Hea(Kb,c[fb>>2]|0);c[(Q3(sa,Kb)|0)>>2]=lb;Nea(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[E>>2]=81704;tW(4,1,81528,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=P3(lb,Lb)|0;u3(mb,ib+(rb*52|0)|0);E3(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Mb,81568);ib=(lfa(w3(mb,Mb)|0,79704)|0)==0;Nea(Mb);if(!ib){break}c[D>>2]=c[gb>>2];tW(4,0,81584,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);Hea(Nb,c[gb>>2]|0);c[(Q3(sa,Nb)|0)>>2]=rb;Nea(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[C>>2]=81728;tW(4,1,81528,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=P3(rb,Ob)|0;u3(mb,lb+(pb*112|0)|0);z3(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Pb,81568);lb=(lfa(w3(mb,Pb)|0,79704)|0)==0;Nea(Pb);if(!lb){break}c[B>>2]=c[fb>>2];tW(4,0,81584,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);Hea(Qb,c[fb>>2]|0);c[(Q3(ua,Qb)|0)>>2]=pb;Nea(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[A>>2]=81744;tW(4,1,81528,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=P3(pb,Rb)|0;u3(mb,rb+(nb*60|0)|0);C3(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Sb,81568);rb=(lfa(w3(mb,Sb)|0,79704)|0)==0;Nea(Sb);if(!rb){break}c[z>>2]=c[gb>>2];tW(4,0,81584,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);Hea(Tb,c[gb>>2]|0);c[(Q3(ua,Tb)|0)>>2]=nb;Nea(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[y>>2]=81768;tW(4,1,81528,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=P3(nb,Ub)|0;u3(mb,pb+(ja*48|0)|0);D3(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Vb,81568);pb=(lfa(w3(mb,Vb)|0,79704)|0)==0;Nea(Vb);if(!pb){break}c[x>>2]=c[fb>>2];tW(4,0,81584,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);Hea(Wb,c[fb>>2]|0);c[(Q3(ua,Wb)|0)>>2]=ja;Nea(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}c[w>>2]=81792;tW(4,1,81528,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=P3(ja,Xb)|0;u3(mb,nb+(tb*52|0)|0);E3(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[92796>>2]|0)!=0){break}Hea(Yb,81568);nb=(lfa(w3(mb,Yb)|0,79704)|0)==0;Nea(Yb);if(!nb){break}c[v>>2]=c[gb>>2];tW(4,0,81584,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);Hea(Zb,c[gb>>2]|0);c[(Q3(ua,Zb)|0)>>2]=tb;Nea(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}tW(4,1,81816,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=P3(tb,_b)|0;u3(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);Bea($b);c[bc>>2]=ja;mb=P3(tb,bc)|0;Hea(cc,81856);Dea(ac,w3(mb,cc)|0);R3(ac,$b);Nea(ac);Nea(cc);mb=(lfa($b,81864)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;tW(4,0,81880,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=P3(tb,ec)|0;Hea(fc,81920);Dea(dc,w3(nb,fc)|0);R3(dc,$b);Nea(dc);Nea(fc);S3(wa,sa,$b);S3(xa,ua,$b);U3(gc,sa);do{if(T3(wa,gc)|0){nb=c[(V3(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{U3(hc,ua);if(T3(xa,hc)|0){fb=c[(V3(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((lfa($b,81936)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);Nea($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}wfa(kc,81944,$b);I3(jc,kc,81968);Nea(kc);c[s>>2]=ifa(jc)|0;xW(0,81984,s)}}while(0);if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}tW(4,1,81992,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=P3(ja,lc)|0;u3(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);Bea(mc);c[oc>>2]=tb;gb=P3(ja,oc)|0;Hea(pc,81856);Dea(nc,w3(gb,pc)|0);R3(nc,mc);Nea(nc);Nea(pc);gb=(lfa(mc,81864)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;tW(4,0,81880,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=P3(ja,rc)|0;Hea(sc,81920);Dea(qc,w3(fb,sc)|0);R3(qc,mc);Nea(qc);Nea(sc);S3(wa,sa,mc);S3(xa,ua,mc);U3(tc,sa);if(T3(wa,tc)|0){fb=c[(V3(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{U3(uc,ua);if(!(T3(xa,uc)|0)){break}nb=c[(V3(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Nea(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}wfa(wc,82032,mc);I3(vc,wc,81968);Nea(wc);c[o>>2]=ifa(vc)|0;xW(0,81984,o)}}while(0);if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}tW(4,1,82056,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=P3(tb,xc)|0;u3(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);Bea(yc);c[Ac>>2]=ja;fb=P3(tb,Ac)|0;Hea(Bc,81856);Dea(zc,w3(fb,Bc)|0);R3(zc,yc);Nea(zc);Nea(Bc);fb=(lfa(yc,81864)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;tW(4,0,81880,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=P3(tb,Dc)|0;Hea(Ec,81920);Dea(Cc,w3(gb,Ec)|0);R3(Cc,yc);Nea(Cc);Nea(Ec);S3(wa,sa,yc);S3(xa,ua,yc);U3(Fc,sa);if(T3(wa,Fc)|0){gb=c[(V3(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{U3(Gc,ua);if(!(T3(xa,Gc)|0)){break}nb=c[(V3(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}Nea(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}wfa(Ic,82096,yc);I3(Hc,Ic,81968);Nea(Ic);c[l>>2]=ifa(Hc)|0;xW(0,81984,l)}}while(0);if((c[35840>>2]|0)!=0){fe[c[9094]&255](4)}tW(4,1,82120,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=P3(ja,Jc)|0;u3(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);Bea(Kc);c[Mc>>2]=tb;gb=P3(ja,Mc)|0;Hea(Nc,81856);Dea(Lc,w3(gb,Nc)|0);R3(Lc,Kc);Nea(Lc);Nea(Nc);gb=(lfa(Kc,81864)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;tW(4,0,81880,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=P3(ja,Pc)|0;Hea(Qc,81920);Dea(Oc,w3(fb,Qc)|0);R3(Oc,Kc);Nea(Oc);Nea(Qc);S3(wa,sa,Kc);S3(xa,ua,Kc);U3(Rc,sa);if(T3(wa,Rc)|0){fb=c[(V3(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{U3(Sc,ua);if(!(T3(xa,Sc)|0)){break}nb=c[(V3(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}Nea(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}wfa(Uc,82160,Kc);I3(Tc,Uc,81968);Nea(Uc);c[f>>2]=ifa(Tc)|0;xW(0,81984,f)}}while(0);if((c[35840>>2]|0)==0){vR(pa);W3(ua);W3(sa);Nea(ra);X3(qa);i=e;return}fe[c[9094]&255](4);vR(pa);W3(ua);W3(sa);Nea(ra);X3(qa);i=e;return}}while(0);if((c[35912>>2]|c[8954]|0)==0){vR(pa);Zc=ud(0)|0;Cd(-1)}vW(22,1,81048,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;vW(22,0,81096,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;vW(22,0,81144,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;vW(22,0,81192,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;vW(22,0,81240,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;vW(22,0,81288,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;vW(22,0,81336,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;vW(22,0,81384,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;vW(22,0,81432,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;vW(22,0,81480,P);fe[c[9094]&255](22);vR(pa);Zc=ud(0)|0;Cd(-1)}function G3(a){a=a|0;var b=0;b=i;Gaa(a);i=b;return}function H3(a,b){a=a|0;b=b|0;b=i;l6(a,0);i=b;return}function I3(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;Cea(a,d);e=Lea(b)|0;f=v4(c)|0;mfa(a,Mea(b)|0,e,f+e|0);efa(a,c,f)|0;i=d;return}



function y_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,72720)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(b|0,72728,y|0)|0;if((z|0)==0){C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,72744,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;wd(b|0,72760,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;wd(b|0,72768,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;wd(b|0,72776,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((qpa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,72744,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,72744,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((qpa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;wd(b|0,72760,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;wd(b|0,72760,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((qpa(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;wd(b|0,72768,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;wd(b|0,72768,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((qpa(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;wd(b|0,72776,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];wd(b|0,72744,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;wd(b|0,72760,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;wd(b|0,72768,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((qpa(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;wd(b|0,72776,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,72720)|0;}while((d|0)!=0);C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}function z_(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 11:case 10:case 9:case 6:case 7:case 8:{vW(1,0,72272,r);v=1;i=m;return v|0};case 18:{w=c[594]|0;do{if((w|0)!=0){if((qpa(w,72528)|0)!=0){break}c[u>>2]=4;break a}}while(0);tW(23,0,72552,o);v=1;i=m;return v|0};case 4:{w=c[594]|0;if((w|0)!=0){if((qpa(w,72384)|0)==0){break a}}tW(23,0,72400,p);v=1;i=m;return v|0};case 5:{vW(1,0,72344,q);v=1;i=m;return v|0};default:{}}}while(0);q=u_(a,s)|0;Ce[c[36724>>2]&7]()|0;do{if((q|0)==0){p=w_(a,b,d,e,f,g)|0;Ce[c[36724>>2]&7]()|0;if((p|0)!=0){x=p;break}if((c[u>>2]|0)!=5){ge[c[77564>>2]&127](77544,a);uZ(a)}y=+h[a+248>>3];p=n;h[k>>3]=+h[a+240>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=y;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tW(23,0,72680,n);p=xe[c[c[a+540>>2]>>2]&63](a,t)|0;Ce[c[36724>>2]&7]()|0;x_(a,s,l)|0;Ce[c[36724>>2]&7]()|0;x=p}else{Ce[c[36724>>2]&7]()|0;x=q}}while(0);v_(a,s)|0;v=x;i=m;return v|0}function A_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){B_(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ie[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){xW(c[a+536>>2]|0,72792,d)}else if((k|0)==6){B_(a);i=b;return}}function B_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;ypa(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function C_(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;Toa(c[f+(a*48|0)+28>>2]|0);Toa(c[f+(a*48|0)+32>>2]|0);Toa(c[f+(a*48|0)+16>>2]|0);Toa(c[f+(a*48|0)+20>>2]|0);Toa(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function D_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=Soa(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=Soa(c[y>>2]<<2)|0;E_(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;wpa(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;wpa(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((LY(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=F_(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){wpa(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;wpa(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;Toa(x);Toa(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;vW(5,1,72848,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(q|0,72880,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;vW(5,0,72888,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=36376;K=c[9094]|0;fe[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=72896;aa=$;xW(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];vW(5,0,72888,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=36376;K=c[9094]|0;fe[K&255](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=72896;aa=$;xW(O,aa,g);return 0}function E_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;ypa(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function F_(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=Uoa(d,4)|0;r=Uoa(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;Toa(q);Toa(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;Toa(q);Toa(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){Toa(q);Toa(r);i=o;return v|0}if((n|0)==0){v=-1;Toa(q);Toa(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(5,1,73e3,p);G_(s,d,f,c[g>>2]|0,j,l,m);if((c[35844>>2]|0)==0){v=-1;Toa(q);Toa(r);i=o;return v|0}fe[c[9094]&255](5);v=-1;Toa(q);Toa(r);i=o;return v|0}function G_(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;ypa(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];tW(5,0,73032,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function H_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ic(73048,73072)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=dd(n|0)|0;if((o|0)==-1){break a}else if((o|0)==10){break}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((dd(n|0)|0)!=10);q=c[b+152>>2]|0;r=Uoa(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=Uoa(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=Uoa(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Od(n|0,73080,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Od(n|0,73080,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=Uoa(s,8)|0;x=v}}while(0);gc(73088,j|0)|0;gc(73144,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(73104,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];gc(73128,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(73144)|0;Yc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function I_(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}Toa(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){Toa(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}Toa(l);i=d;return 0}function J_(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function K_(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+L_(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[35860>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];tW(9,1,73208,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(9,0,73320,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}fe[c[9094]&255](9);g=1;i=b;return g|0}function L_(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;__(b);g=f+540|0;ie[c[(c[g>>2]|0)+84>>2]&127](f)|0;ie[c[(c[g>>2]|0)+36>>2]&127](f)|0;ie[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;xe[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function M_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+L_(b,1.0);if((c[35860>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}tW(9,1,73344,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(9,0,73408,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(9,0,73368,s)}tW(9,1,73432,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;tW(9,0,73504,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];tW(9,0,73456,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;tW(9,0,73592,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(9,0,73528,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;tW(9,0,73680,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tW(9,0,73624,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}fe[c[9094]&255](9);tW(9,1,73712,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ie[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;tW(9,0,73504,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];tW(9,0,73456,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}fe[c[9094]&255](9);fe[c[9094]&255](9);i=d;return}function N_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[35860>>2]|0)!=0){vZ(b,9)}if((c[35920>>2]|0)==0){i=d;return}tW(24,1,73736,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){tW(24,1,73776,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tW(24,0,73800,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}fe[c[9094]&255](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}tW(24,1,73856,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tW(24,0,73880,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}fe[c[9094]&255](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){tW(24,1,73912,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(24,0,73800,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}fe[c[9094]&255](24)}p=b+124|0;if((c[p>>2]|0)>0){tW(24,1,73936,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;tW(24,0,73960,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}fe[c[9094]&255](24)}H=b+128|0;if((c[H>>2]|0)>0){tW(24,1,74008,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?74080:74088;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?74080:74088;t=(a[(c[l>>2]|0)+n|0]|0)!=0?74080:74088;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;tW(24,0,74032,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}fe[c[9094]&255](24)}n=b+132|0;if((c[n>>2]|0)>0){tW(24,1,74096,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;tW(24,0,74120,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}fe[c[9094]&255](24)}fe[c[9094]&255](24);i=d;return}function O_(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;tW(9,0,74168,z);if((f|0)==0){sZ(b);tZ(b);C=6}else{if((a[f]|0)!=0){P_(b,f,g)}sZ(b);tZ(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ie[c[(c[A>>2]|0)+84>>2]&127](b)|0;ie[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(qpa(d,75656)|0)==0|0;f=(qpa(d,75664)|0)==0;z=(qpa(d,75672)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;vW(1,0,74216,y);vW(1,0,74248,x);c[w>>2]=75656;c[w+4>>2]=75464;vW(1,0,74272,w);c[v>>2]=75664;c[v+4>>2]=75544;vW(1,0,74272,v);c[u>>2]=75672;c[u+4>>2]=75592;vW(1,0,74272,u);xW(c[b+536>>2]|0,74304,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(qpa(e,c[74328+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;vW(1,0,74360,s);vW(1,0,74248,r);t=1;do{u=c[74392+(t<<2)>>2]|0;c[q>>2]=c[74328+(t<<2)>>2];c[q+4>>2]=u;vW(1,0,74272,q);t=t+1|0;}while((t|0)<7);xW(c[b+536>>2]|0,74304,p)}}while(0);p=c[74288+(D<<2)>>2]|0;c[o>>2]=c[74200+(D<<2)>>2];c[o+4>>2]=p;tW(9,0,74424,o);o=(D|0)==2;if(o){p=c[74392+(F<<2)>>2]|0;c[n>>2]=c[74328+(F<<2)>>2];c[n+4>>2]=p;tW(9,0,74464,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=Q_(b,F,j)|0;break}if((D|0)==3){R_(b,j);I=0;break}else{xW(c[b+536>>2]|0,74504,m)}}}while(0);if((a_(b,1)|0)!=0){J=-2;N_(b);K=15;L=K;M=74528;N=M;tW(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];bZ(b,R,V);W=167;pZ(b);X=173;uZ(b);Y=168;kZ(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=176;qZ(b);i=k;return J|0}if((SZ(b,1)|0)!=0){J=-3;N_(b);K=15;L=K;M=74528;N=M;tW(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];bZ(b,R,V);W=167;pZ(b);X=173;uZ(b);Y=168;kZ(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=176;qZ(b);i=k;return J|0}m=(HZ(b,1)|0)==0;J=m?I:-4;N_(b);K=15;L=K;M=74528;N=M;tW(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];bZ(b,R,V);W=167;pZ(b);X=173;uZ(b);Y=168;kZ(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=176;qZ(b);i=k;return J|0}function P_(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tW(9,0,75688,z);z=aX(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;xW(C,75728,y)}tW(9,0,75768,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=bX(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=U_(c[d+(C*112|0)+4>>2]|0)|0;E=bX(A,D)|0;Toa(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((rpa(E,75808,6)|0)==0){if((c[35860>>2]|0)==0){break}}else{D=rpa(E,75816,6)|0;if((c[35860>>2]|D|0)==0){break}}c[v>>2]=E;vW(9,0,75824,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;hX(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];tW(9,0,75792,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}tW(9,0,75880,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=bX(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=U_(c[G+(w*112|0)+4>>2]|0)|0;v=bX(A,F)|0;Toa(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];vW(9,0,75904,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;hX(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];tW(9,0,75792,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}tW(9,0,75960,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=bX(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=U_(c[t+(x*112|0)+4>>2]|0)|0;K=bX(A,C)|0;Toa(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];vW(9,0,75904,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;hX(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tW(9,0,75792,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}tW(9,0,75984,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=bX(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=U_(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=bX(A,u)|0;Toa(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];vW(9,0,76032,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;hX(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;tW(9,0,76016,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}tW(9,0,76088,l);l=b+144|0;if((c[l>>2]|0)<=0){_W(A);i=f;return}o=b+32|0;b=0;do{x=bX(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=U_(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=bX(A,n)|0;Toa(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];vW(9,0,76136,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;hX(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?74080:74088;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;tW(9,0,76120,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));_W(A);i=f;return}function Q_(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;aZ(a,+h[a+240>>3]);pZ(a);uZ(a);kZ(a);wZ(a);B_(a);lZ(a);pZ(a);e=S_(a,b,c)|0;uZ(a);kZ(a);qZ(a);uZ(a);i=d;return e|0}function R_(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;aZ(b,+h[b+240>>3]);pZ(b);uZ(b);D_(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=Uoa(c[y>>2]|0,8)|0;A=b+124|0;B=Uoa(c[A>>2]|0,4)|0;C=b+128|0;D=Uoa(c[C>>2]|0,1)|0;E=b+132|0;F=Uoa(c[E>>2]|0,4)|0;G=b+536|0;wW(c[G>>2]|0,(z|0)!=0|0,74560,t);wW(c[G>>2]|0,(B|0)!=0|0,74560,s);wW(c[G>>2]|0,(D|0)!=0|0,74560,r);wW(c[G>>2]|0,(F|0)!=0|0,74560,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[35860>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];hc(x|0,74576,p|0)|0;p=ic(x|0,74592)|0;c[o>>2]=74608;wd(p|0,74600,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];wd(p|0,74600,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Sd(10,p|0)|0;H=p}tW(9,1,74616,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(9,0,74640,l);if((c[35860>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(H|0,74664,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];wd(H|0,74664,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Sd(10,H|0)|0}if((a_(b,0)|0)!=0){break a}if((SZ(b,0)|0)!=0){break a}if((HZ(b,0)|0)!=0){break a}xZ(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);fe[c[9094]&255](9);if((c[35860>>2]|0)!=0){Yc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}Toa(z);Toa(B);Toa(D);Toa(F)}else{h[b+304>>3]=1.0;ie[c[w+80>>2]&127](b)|0}mZ(b);if((D_(b,1,1)|0)!=1){i=e;return}ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;mZ(b);if((D_(b,1,1)|0)!=1){i=e;return}vW(1,0,74672,f);i=e;return}function S_(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=V_(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){tW(9,0,74776,u);if((c[b+184>>2]|0)==0){xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}Toa(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){tW(9,0,74808,t);xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;Toa(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){tW(9,1,74880,s);t=Soa(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+L_(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+L_(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}tW(9,1,74904,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];tW(9,0,74928,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];tW(9,0,74928,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];tW(9,0,74928,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[35860>>2]|0)!=0){fe[c[9094]&255](9);fe[c[9094]&255](9)}Toa(t);W_(v);H=V_(b)|0;if((c[H>>2]|0)!=0){$=H;break}tW(9,0,74952,n);Toa(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}tW(9,0,74984,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){tW(9,0,75e3,l);T_($,d,1,e);M_(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+L_($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){Toa(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){Toa(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){Toa(v);c[l>>2]=0}T_($,d,0,e);M_(b,$);+L_($,1.0)}else{tW(9,0,75024,j)}tW(9,1,75048,g);M_(b,$);b=K_($)|0;if((c[35860>>2]|0)!=0){fe[c[9094]&255](9)}W_($);y=b;i=f;return y|0}function T_(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=Soa(c[p>>2]<<3)|0;r=q;s=+L_(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;Y_(a,r);Toa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=75176;F=E;tW(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;tW(9,0,75088,m);if(!t){X_(a)}switch(b|0){case 4:{G=12;break a;break};case 5:{G=13;break a;break};case 1:{H=d$(a)|0;break};case 3:{H=f$(a,n,e)|0;break};case 6:{G=14;break a;break};case 2:{H=b$(a)|0;break};default:{G=15;break a}}uZ(o);kZ(o);qZ(o);uZ(o);s=+L_(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}tW(9,0,75136,k);M_(o,a);K=s}else{tW(9,0,75152,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){a$(a)|0}else if((G|0)==13){a$(a)|0}else if((G|0)==14){$_(o,a,0)|0}else if((G|0)==15){xW(c[o+536>>2]|0,75112,l)}else if((G|0)==23){Y_(a,r);Toa(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=75176;F=E;tW(9,0,F,g);i=f;return}}function U_(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=upa(b|0)|0;do{if((d|0)==0){e=Soa(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==91){l=h+1|0}else if(k<<24>>24==93){l=h+ -1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=Soa(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((ppa(e,76192,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;wpa(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((ppa(e,76192,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function V_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=Soa(64)|0;z=y;wW(0,(y|0)!=0|0,76200,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=Uoa(Z,8)|0;c[E>>2]=y;wW(0,(y|0)!=0|0,76200,w);w=Uoa(Z,8)|0;c[F>>2]=w;wW(0,(w|0)!=0|0,76200,v);v=Uoa(Z,8)|0;c[G>>2]=v;wW(0,(v|0)!=0|0,76200,u);u=Uoa(Z,8)|0;c[H>>2]=u;wW(0,(u|0)!=0|0,76200,t);t=Uoa(Z,8)|0;c[I>>2]=t;wW(0,(t|0)!=0|0,76200,s);s=Uoa(Z,4)|0;t=s;c[J>>2]=t;wW(0,(s|0)!=0|0,76200,r);tW(9,0,76216,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;tW(9,0,76240,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];tW(9,0,76328,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];tW(9,0,76376,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];tW(9,0,76432,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;tW(9,0,76488,l);c[j>>2]=ya;tW(9,0,76560,j);j=Uoa(sa,8)|0;c[K>>2]=j;wW(0,(j|0)!=0|0,76200,g);g=Soa(sa<<3)|0;c[L>>2]=g;wW(0,(g|0)!=0|0,76200,f);f=Soa(ya<<3)|0;c[M>>2]=f;wW(0,(f|0)!=0|0,76200,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function W_(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+28>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+32>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+36>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+40>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+44>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+48>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+52>>2]|0;if((d|0)!=0){Toa(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;Toa(e);i=b;return}Toa(d);e=a;Toa(e);i=b;return}function X_(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=Uoa(o,8)|0;q=Uoa(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=Uoa(s,8)|0;u=Uoa(s,8)|0;v=Uoa(o,8)|0;w=Uoa(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+L_(b,1.0);s=c[n>>2]|0;if((s|0)>0){wpa(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+L_(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){wpa(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;tW(9,0,76600,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}Toa(p);Toa(q);Toa(t);Toa(u);Toa(v);Toa(w);i=d;return}function Y_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function Z_(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function __(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function $_(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;xW(c[a+536>>2]|0,76672,d);return 0}function a$(a){a=a|0;a=i;i=i+8|0;xW(0,76704,a);return 0}function b$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[35860>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=Uoa((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;wW(0,(n|0)!=0|0,76744,b);c[19190]=c[a+60>>2];c[19192]=c[a+48>>2];CY(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;Toa(n);c[19190]=0;c[19192]=0;n=K_(a)|0;i=b;return n|0}function c$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[19192];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[19190];h[d>>3]=+L_(f,1.0);i=e;return}function d$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=Soa(x)|0;z=y;A=Soa(x)|0;x=A;wW(0,(y|0)!=0|0,76776,n);wW(0,(A|0)!=0|0,76776,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[35860>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+L_(a,1.0);h[o>>3]=D;if(D!=0.0){c[19198]=c[a+60>>2];c[19200]=c[a+48>>2];zY(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[19198]=0;c[19200]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];tW(9,0,76808,l)}D=+L_(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];tW(9,0,76912,j);j=c[u>>2]|0;do{if((j|0)==2){vW(9,0,77008,f);F=-2;i=b;return F|0}else if((j|0)==3){vW(9,0,77072,e);F=-3;i=b;return F|0}else if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];vW(9,0,76928,g);F=-1;i=b;return F|0}else if((j|0)==4){vW(9,0,77144,d);F=-4;i=b;return F|0}}while(0);F=K_(a)|0;i=b;return F|0}function e$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[19200];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[19198];h[d>>3]=+L_(f,1.0);i=e;return}function f$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;tW(9,1,77200,g);if((c[35860>>2]|0)==0){l=0}else{l=(k|0)/10|0}g$(a,d,k,l,b,j);c[f>>2]=c[j>>2];tW(9,0,77224,f);fe[c[9094]&255](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=K_(a)|0;if((b|0)==0){m=0;i=e;return m|0}vW(9,0,77240,e);m=b;i=e;return m|0}function g$(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=Soa(fa(N,M)|0)|0;P=Soa(M<<3)|0;Q=Soa(N)|0;R=Q;S=Soa(N)|0;T=S;V=Soa(N)|0;W=V;X=Soa(N)|0;Y=+h[f>>3];if((c[35860>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];hc(N|0,77288,I|0)|0;I=ic(N|0,77304)|0;c[H>>2]=77320;wd(I|0,77312,H|0)|0;c[G>>2]=77336;wd(I|0,77312,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];wd(I|0,77312,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Sd(10,I|0)|0;c[E>>2]=0;wd(I|0,77344,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(I|0,77352,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];wd(I|0,77352,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Sd(10,I|0)|0;Z=I}else{Z=0}wW(0,(O|0)!=0|0,77360,B);wW(0,(P|0)!=0|0,77360,A);wW(0,(Q|0)!=0|0,77360,z);wW(0,(S|0)!=0|0,77360,y);wW(0,(V|0)!=0|0,77360,x);wW(0,(X|0)!=0|0,77360,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{Z_(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+L_(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;Z_(a,la);+L_(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];tW(9,0,77376,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){ypa(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);Z_(a,R);za=+L_(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}wpa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}Z_(a,T);if(+L_(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}wpa(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}wpa(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}Z_(a,W);Ba=+L_(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}Z_(a,W);Ba=+L_(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}wpa(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];tW(9,0,77416,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;wd(Z|0,77344,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];wd(Z|0,77352,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(Z|0,77352,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];vW(9,0,77464,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];vW(9,0,77480,p);xW(0,77496,o)}Z_(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){Toa(S);Toa(Q);Toa(V);Toa(X);Toa(P);Toa(O);i=j;return}c[n>>2]=ia;wd(Z|0,77344,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,77352,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,77352,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;Yc(Z|0)|0;Toa(S);Toa(Q);Toa(V);Toa(X);Toa(P);Toa(O);i=j;return}function h$(a,b){a=a|0;b=b|0;i=i;return}function i$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;MX(3);PX(0);w=+HX(0);MX(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(v|0,77576,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];wd(v|0,77576,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(v|0,77576,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];wd(v|0,77584,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;wd(v|0,77584,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];wd(v|0,77592,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,77576,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,77576,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;wd(v|0,77584,l|0)|0;break}else{c[m>>2]=0-E;wd(v|0,77584,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;wd(v|0,77584,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;wd(v|0,77584,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Sd(10,v|0)|0;PX(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];wd(v|0,77592,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Sd(10,v|0)|0;PX(3);i=e;return}function j$(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ic(c[r>>2]|0,77600)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;wW(t,(s|0)!=0|0,77608,q);c[p>>2]=77664;wd(s|0,77592,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=77672;wd(s|0,77592,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];wd(s|0,77592,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];wd(s|0,77592,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];wd(s|0,77592,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];wd(s|0,77592,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];wd(s|0,77592,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];wd(s|0,77592,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];wd(s|0,77592,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];wd(s|0,77592,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function k$(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;MX(3);Yc(d|0)|0;PX(3);i=b;return}function l$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;cha(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];dha(p,f)|0;m$(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;n$(a,b,77688,c[j>>2]|0,c[g>>2]|0,o,8);Toa(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];dha(p,e)|0;i=d;return}function m$(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=Uoa(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;wW(c[b+536>>2]|0,(p|0)!=0|0,77968,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function n$(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;y$(a,b,d,e,f,h);bha(l,g,fa(fa(f,e)|0,h)|0)|0;if(yfa(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];xW(l,77920,k)}else{i=j;return}}function o$(a){a=a|0;var b=0;b=i;if((q0(a+4|0)|0)!=0){i=b;return}Bfa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function p$(a){a=a|0;Rc(a|0)|0;Ya()}function q$(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=Yoa(320)|0;ypa(q|0,0,320)|0;r$(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;MX(3);t=a+8|0;u=s$(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=t$(a,b,u+s|0)|0;u=q+184|0;u$(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;u$(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;v$(q,c[x>>2]|0,36);if(yfa(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];xW(y,77744,e)}else{n$(a,b,77776,4,11,77696,1);w$((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;n$(a,b,77784,c[g>>2]|0,c[j>>2]|0,e,1);Toa(e);c[f>>2]=0;w$((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;n$(a,b,77792,c[g>>2]|0,c[j>>2]|0,e,1);Toa(e);c[f>>2]=0;x$(a,b,k,g,j,c[r>>2]|0,s);n$(a,b,77808,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;cha(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];m$(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;n$(a,b,77688,c[j>>2]|0,c[g>>2]|0,n,8);cha(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=z$(q+240|0)|0;w=z$(q+264|0)|0;p=z$(q+288|0)|0;y$(a,b,77824,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);Toa(n);Toa(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;Jga(s)|0;Toa(v);PX(3);i=d;return}}function r$(a){a=a|0;var b=0;b=i;A2(a);i=b;return}function s$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(E1(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(E1(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(E1(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function t$(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=Soa(e<<2)|0;e=l;c[l>>2]=78376;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=78416;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(E1(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(E1(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(E1(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function u$(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;p0(a,b,c);i=d;return}function v$(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(o0(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){Bfa(d,4);i=e;return}else{zfa(d,0);i=e;return}}function w$(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=upa(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=Uoa((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;wW(0,(o|0)!=0|0,77896,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;Fpa(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;D$(q,upa(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=Uoa(1,1)|0;c[d>>2]=q;wW(0,(q|0)!=0|0,77896,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}



function XH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=0.0;i=i;return}function YH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=0.0;i=i;return}function ZH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4720>>3]=0.0;i=i;return}function _H(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4728>>3]=0.0;i=i;return}function $H(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=0.0;i=i;return}function aI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4744>>3]=0.0;i=i;return}function bI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4752>>3]=0.0;i=i;return}function cI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=0.0;i=i;return}function dI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4768>>3]=0.0;i=i;return}function eI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=0;i=i;return}function fI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=128;i=i;return}function gI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=255;i=i;return}function hI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4776>>3]=0.0;i=i;return}function iI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=0.0;i=i;return}function jI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4792>>3]=0.0;i=i;return}function kI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4816>>3]=255.0;i=i;return}function lI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=0.0;i=i;return}function mI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4800>>3]=0.0;i=i;return}function nI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function oI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=0;i=i;return}function pI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=255;i=i;return}function qI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4824>>3]=0.0;i=i;return}function rI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4832>>3]=0.0;i=i;return}function sI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4840>>3]=0.0;i=i;return}function tI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4848>>3]=0.0;i=i;return}function uI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=0.0;i=i;return}function vI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4864>>3]=0.0;i=i;return}function wI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4872>>3]=0.0;i=i;return}function xI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function yI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4888>>3]=0.0;i=i;return}function zI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4896>>3]=0.0;i=i;return}function AI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=0.0;i=i;return}function BI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4912>>3]=0.0;i=i;return}function CI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4920>>3]=0.0;i=i;return}function DI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=1.0;i=i;return}function EI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4936>>3]=0.0;i=i;return}function FI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4960>>3]=100.0;i=i;return}function GI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=100.0;i=i;return}function HI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4944>>3]=100.0;i=i;return}function II(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=100;i=i;return}function JI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=100;i=i;return}function KI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=100;i=i;return}function LI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4968>>3]=0.0;i=i;return}function MI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=1.0;i=i;return}function NI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4984>>3]=0.0;i=i;return}function OI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5008>>3]=155.0;i=i;return}function PI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=155.0;i=i;return}function QI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4992>>3]=155.0;i=i;return}function RI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function SI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function TI(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function UI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5016>>3]=0.0;i=i;return}function VI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function WI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5032>>3]=0.0;i=i;return}function XI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5040>>3]=0.0;i=i;return}function YI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=1.0;i=i;return}function ZI(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5056>>3]=0.0;i=i;return}function _I(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5064>>3]=+h[b+48>>3]+ +h[b+1288>>3]*-.5;i=i;return}function $I(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=1.0;i=i;return}function aJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5080>>3]=0.0;i=i;return}function bJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5088>>3]=0.0;i=i;return}function cJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function dJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5104>>3]=1.0;i=i;return}function eJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5112>>3]=0.0;i=i;return}function fJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5136>>3]=255.0;i=i;return}function gJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5128>>3]=128.0;i=i;return}function hJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function iJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5160>>3]=255.0;i=i;return}function jJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5152>>3]=128.0;i=i;return}function kJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function lJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function mJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function nJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function oJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=0.0;i=i;return}function pJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5176>>3]=0.0;i=i;return}function qJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5184>>3]=0.0;i=i;return}function rJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function sJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5200>>3]=0.0;i=i;return}function tJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5208>>3]=0.0;i=i;return}function uJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function vJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5224>>3]=0.0;i=i;return}function wJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5232>>3]=0.0;i=i;return}function xJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=.3;i=i;return}function yJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5248>>3]=0.0;i=i;return}function zJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5256>>3]=0.0;i=i;return}function AJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function BJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5272>>3]=1.0;i=i;return}function CJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5280>>3]=0.0;i=i;return}function DJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5304>>3]=155.0;i=i;return}function EJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5296>>3]=155.0;i=i;return}function FJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=155.0;i=i;return}function GJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=155;i=i;return}function HJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=155;i=i;return}function IJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=155;i=i;return}function JJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=.6;i=i;return}function KJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5320>>3]=0.0;i=i;return}function LJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5328>>3]=0.0;i=i;return}function MJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function NJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5344>>3]=1.0;i=i;return}function OJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5352>>3]=0.0;i=i;return}function PJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5376>>3]=155.0;i=i;return}function QJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5368>>3]=155.0;i=i;return}function RJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=155.0;i=i;return}function SJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=155;i=i;return}function TJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=155;i=i;return}function UJ(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=155;i=i;return}function VJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function WJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5392>>3]=0.0;i=i;return}function XJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5400>>3]=0.0;i=i;return}function YJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=0.0;i=i;return}function ZJ(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5416>>3]=1.0;i=i;return}function _J(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5424>>3]=0.0;i=i;return}function $J(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=+h[b+584>>3]+ +h[b+1424>>3]*-.5;i=i;return}function aK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5440>>3]=1.0;i=i;return}function bK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5448>>3]=0.0;i=i;return}function cK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function dK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5464>>3]=0.0;i=i;return}function eK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5472>>3]=1.0;i=i;return}function fK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function gK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=255.0;i=i;return}function hK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5496>>3]=128.0;i=i;return}function iK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5488>>3]=0.0;i=i;return}function jK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=255.0;i=i;return}function kK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5520>>3]=128.0;i=i;return}function lK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5512>>3]=0.0;i=i;return}function mK(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function nK(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function oK(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function pK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5536>>3]=0.0;i=i;return}function qK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5544>>3]=0.0;i=i;return}function rK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function sK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=1.0;i=i;return}function tK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function uK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5576>>3]=0.0;i=i;return}function vK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5584>>3]=0.0;i=i;return}function wK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=0.0;i=i;return}function xK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5600>>3]=0.0;i=i;return}function yK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5608>>3]=0.0;i=i;return}function zK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function AK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5624>>3]=0.0;i=i;return}function BK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5632>>3]=0.0;i=i;return}function CK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5640>>3]=0.0;i=i;return}function DK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5648>>3]=0.0;i=i;return}function EK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function FK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5664>>3]=0.0;i=i;return}function GK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5672>>3]=-1.0;i=i;return}function HK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=0.0;i=i;return}function IK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function JK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=1.0;i=i;return}function KK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5704>>3]=0.0;i=i;return}function LK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function MK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function NK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5712>>3]=255.0;i=i;return}function OK(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=255;i=i;return}function PK(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=0;i=i;return}function QK(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=0;i=i;return}function RK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function SK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5776>>3]=0.0;i=i;return}function TK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=0.0;i=i;return}function UK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5760>>3]=0.0;i=i;return}function VK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5800>>3]=0.0;i=i;return}function WK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function XK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5784>>3]=0.0;i=i;return}function YK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5808>>3]=+h[(c[a+416>>2]|0)+392>>3];i=i;return}function ZK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5736>>3]=+h[b+5808>>3]+ +h[(c[a+416>>2]|0)+488>>3];i=i;return}function _K(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[(c[a+416>>2]|0)+400>>3];i=i;return}function $K(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5744>>3]=+h[b+5816>>3]+ +h[(c[a+416>>2]|0)+496>>3];i=i;return}function aL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[(c[a+416>>2]|0)+408>>3];i=i;return}function bL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5752>>3]=+h[b+5824>>3]+ +h[(c[a+416>>2]|0)+504>>3];i=i;return}function cL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5832>>3]=0.0;i=i;return}function dL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5840>>3]=1.0;i=i;return}function eL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function fL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5856>>3]=0.0;i=i;return}function gL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5864>>3]=1.0;i=i;return}function hL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5872>>3]=0.0;i=i;return}function iL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function jL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5888>>3]=0.0;i=i;return}function kL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5896>>3]=0.0;i=i;return}function lL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function mL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5912>>3]=0.0;i=i;return}function nL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5920>>3]=0.0;i=i;return}function oL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function pL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function qL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function rL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5952>>3]=0.0;i=i;return}function sL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5960>>3]=0.0;i=i;return}function tL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function uL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function vL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function wL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function xL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6e3>>3]=0.0;i=i;return}function yL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6568>>3]=0.0;i=i;return}function zL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6008>>3]=0.0;i=i;return}function AL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function BL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6024>>3]=0.0;i=i;return}function CL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6032>>3]=0.0;i=i;return}function DL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function EL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6048>>3]=0.0;i=i;return}function FL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6576>>3]=0.0;i=i;return}function GL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function HL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6056>>3]=0.0;i=i;return}function IL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6064>>3]=0.0;i=i;return}function JL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6072>>3]=0.0;i=i;return}function KL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6080>>3]=1.0;i=i;return}function LL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function ML(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function NL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6088>>3]=0.0;i=i;return}function OL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6112>>3]=1.0;i=i;return}function PL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6136>>3]=0.0;i=i;return}function QL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6096>>3]=0.0;i=i;return}function RL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6120>>3]=0.0;i=i;return}function SL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6144>>3]=1.0;i=i;return}function TL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function UL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6160>>3]=0.0;i=i;return}function VL(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6168>>3]=0.0;i=i;return}function WL(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+1|0]|0)==0){e=0}else{e=(a[d+2|0]|0)!=0|0}c[(c[b+420>>2]|0)+52>>2]=e;i=i;return}function XL(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e+1|0]|0)==0){f=0}else{if((a[e+2|0]|0)==0){f=0;break}f=(a[e+5|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+56>>2]=f;i=d;return}function YL(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+1|0]|0)==0){e=0}else{e=(a[d+3|0]|0)!=0|0}c[(c[b+420>>2]|0)+60>>2]=e;i=i;return}function ZL(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1072>>3]=+h[b+1024>>3]*.5;i=i;return}function _L(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1080>>3]=+h[b+1024>>3]*.2;i=i;return}function $L(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1088>>3]=+h[b+1024>>3]*.1;i=i;return}function aM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1096>>3]=+h[b+1024>>3]*.05;i=i;return}function bM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1104>>3]=+h[b+1024>>3]*.1;i=i;return}function cM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1112>>3]=+h[b+1024>>3]*.05;i=i;return}function dM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6544>>3]=+h[(c[a+416>>2]|0)+1112>>3]*.6;i=i;return}function eM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+1024>>3]/9.0;i=i;return}function fM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1128>>3]=+h[b+1024>>3]*.025;i=i;return}function gM(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1040>>3];j=+h[f+1072>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,5280,5272,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1136>>3]=l;i=d;return}function hM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1144>>3]=+h[b+1072>>3]*.5;i=i;return}function iM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+1072>>3]*1.05;i=i;return}function jM(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1160>>3]=+sd(+(+h[d+1072>>3]),+(+h[d+1136>>3]*5.0));i=b;return}function kM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1168>>3]=+h[b+1136>>3]*3.0;i=i;return}function lM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1176>>3]=+h[b+1136>>3];i=i;return}function mM(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1184>>3]=+h[b+1136>>3]*3.0;i=i;return}function nM(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+1184>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3352>>3]=d;i=i;return}function oM(a){a=a|0;var b=0.0,d=0.0;b=+h[(c[a+416>>2]|0)+1184>>3];d=+V(+(b*b));h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3344>>3]=d;i=i;return}function pM(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+1184>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3336|0;w=v;h[w>>3]=j;i=b;return}x=c[21290]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=5448;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,5328,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+3336|0;w=v;h[w>>3]=j;i=b;return}function qM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3240>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+3264>>3]- +h[b+3288>>3]);i=i;return}function rM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3232>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+3256>>3]- +h[b+3280>>3]);i=i;return}function sM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3224>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+3248>>3]- +h[b+3272>>3]);i=i;return}function tM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3216>>3]=+h[b+1152>>3]+ +h[d+3288>>3]*+h[b+1184>>3];i=i;return}function uM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3208>>3]=+h[b+3280>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function vM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3200>>3]=+h[b+3272>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function wM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3192>>3]=+h[b+3264>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function xM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3184>>3]=+h[b+3256>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function yM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3176>>3]=+h[b+3248>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function zM(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3168>>3]=+h[b+1152>>3]+ +h[d+3288>>3]*+h[b+1184>>3];i=i;return}function AM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3160>>3]=+h[b+3280>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function BM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3152>>3]=+h[b+3272>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function CM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3144>>3]=+h[b+3264>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function DM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3136>>3]=+h[b+3256>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function EM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3128>>3]=+h[b+3248>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function FM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2976>>3]=+h[(c[a+416>>2]|0)+1184>>3]*.75;i=i;return}function GM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2968>>3]=+h[(c[a+416>>2]|0)+1184>>3]*.5;i=i;return}function HM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2960>>3]=+h[(c[a+416>>2]|0)+1184>>3]*1.5;i=i;return}function IM(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+2968>>3];e=+h[b+2976>>3]- +h[b+2960>>3];h[b+2752>>3]=+V(+(d*d+e*e));i=i;return}function JM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2680>>3]*+h[b+2968>>3]+ +h[b+2704>>3]*(+h[b+2976>>3]- +h[b+2960>>3]);i=i;return}function KM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2672>>3]*+h[b+2968>>3]+ +h[b+2696>>3]*(+h[b+2976>>3]- +h[b+2960>>3]);i=i;return}function LM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2640>>3]=+h[b+2664>>3]*+h[b+2968>>3]+ +h[b+2688>>3]*(+h[b+2976>>3]- +h[b+2960>>3]);i=i;return}function MM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2632>>3]=+h[b+2704>>3]*+h[b+2960>>3];i=i;return}function NM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2624>>3]=+h[(c[a+416>>2]|0)+1152>>3]+ +h[b+2696>>3]*+h[b+2960>>3];i=i;return}function OM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+2688>>3]*+h[b+2960>>3];i=i;return}function PM(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2944>>3]=+h[(c[a+416>>2]|0)+1184>>3]*1.5;i=i;return}function QM(a){a=a|0;var b=0.0,d=0,e=0.0;b=+h[(c[a+416>>2]|0)+1184>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=+h[d+2944>>3];h[d+2760>>3]=+V(+(b*b+e*e));i=i;return}function RM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+2680>>3]*+h[(c[a+416>>2]|0)+1184>>3]+ +h[b+2704>>3]*+h[b+2944>>3];i=i;return}function SM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2600>>3]=+h[b+2672>>3]*+h[(c[a+416>>2]|0)+1184>>3]+ +h[b+2696>>3]*+h[b+2944>>3];i=i;return}function TM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=+h[b+2664>>3]*+h[(c[a+416>>2]|0)+1184>>3]+ +h[b+2688>>3]*+h[b+2944>>3];i=i;return}function UM(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+1184>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2296|0;w=v;h[w>>3]=j;i=b;return}x=c[21290]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=5448;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,5328,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2296|0;w=v;h[w>>3]=j;i=b;return}function VM(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;b=i;i=i+32|0;d=b;e=b+24|0;f=+h[(c[a+416>>2]|0)+1184>>3];g=f*(f+f);if(g>=0.0){j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2288|0;w=v;h[w>>3]=j;i=b;return}x=c[21290]|0;y=c[a+536>>2]|0;z=e;h[k>>3]=g;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=x;x=d;A=5448;c[x+0>>2]=c[A+0>>2];c[x+4>>2]=c[A+4>>2];c[x+8>>2]=c[A+8>>2];c[x+12>>2]=c[A+12>>2];c[x+16>>2]=c[A+16>>2];c[x+20>>2]=c[A+20>>2];Ie[z&31](y,d,5328,e);j=+V(+g);l=a;m=l+4|0;n=m;o=c[n>>2]|0;p=c[o>>2]|0;q=p;r=q+8|0;s=r;t=c[s>>2]|0;u=t;v=u+2288|0;w=v;h[w>>3]=j;i=b;return}function WM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2192>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2216>>3]- +h[b+2240>>3]);i=i;return}function XM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2208>>3]- +h[b+2232>>3]);i=i;return}function YM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2200>>3]- +h[b+2224>>3]);i=i;return}function ZM(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2168>>3]=+h[b+2240>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function _M(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2160>>3]=+h[b+2232>>3]*+h[(c[a+416>>2]|0)+1184>>3];i=i;return}function $M(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2152>>3]=+h[b+1152>>3]+ +h[d+2224>>3]*+h[b+1184>>3];i=i;return}function aN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2144>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2216>>3]+ +h[b+2240>>3]);i=i;return}function bN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2208>>3]+ +h[b+2232>>3]);i=i;return}function cN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=+h[(c[a+416>>2]|0)+1184>>3]*(+h[b+2200>>3]+ +h[b+2224>>3]);i=i;return}function dN(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1032>>3];j=+h[f+1144>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,5480,5472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1192>>3]=l;i=d;return}function eN(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1200>>3]=+td(0.0,+(+h[d+1072>>3]- +h[d+1160>>3]));i=b;return}function fN(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1208>>3]=+sd(+(+h[d+1144>>3]),+(+h[d+1192>>3]*4.0));i=b;return}function gN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+1192>>3]*3.0;i=i;return}function hN(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+1224>>3]=+td(0.0,+(+h[d+1144>>3]- +h[d+1208>>3]));i=b;return}function iN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4552>>3]=+h[b+32>>3]- +h[b+1224>>3];i=i;return}function jN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+6|0]=a[d]|0;i=i;return}function kN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+144>>3]=+h[b+72>>3];i=i;return}function lN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+152>>3]=+h[b+80>>3];i=i;return}function mN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+160>>3]=+h[b+88>>3];i=i;return}function nN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,0);h[(c[a+416>>2]|0)+360>>3]=l;i=b;return}function oN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,1);h[(c[a+416>>2]|0)+368>>3]=l;i=b;return}function pN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,2);h[(c[a+416>>2]|0)+376>>3]=l;i=b;return}function qN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,3);h[(c[a+416>>2]|0)+384>>3]=l;i=b;return}function rN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+12|0]=a[d]|0;i=i;return}function sN(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+392>>3]- +h[b+416>>3];e=+h[b+400>>3]- +h[b+424>>3];f=+h[b+408>>3]- +h[b+432>>3];h[b+1312>>3]=+V(+(d*d+e*e+f*f));i=i;return}function tN(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1032>>3];j=+h[f+1312>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,5480,5544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1320>>3]=l;i=d;return}function uN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1328>>3]=+h[b+1320>>3];i=i;return}function vN(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+80>>2]=c[b+76>>2];i=i;return}function wN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+13|0]=a[d]|0;i=i;return}function xN(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+488>>3]- +h[b+512>>3];e=+h[b+496>>3]- +h[b+520>>3];f=+h[b+504>>3]- +h[b+528>>3];h[b+1344>>3]=+V(+(d*d+e*e+f*f));i=i;return}function yN(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+1032>>3];j=+h[f+1344>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+zW(c[b+536>>2]|0,g,5480,5552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+1352>>3]=l;i=d;return}function zN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1360>>3]=+h[b+1352>>3];i=i;return}function AN(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+88>>2]=c[b+84>>2];i=i;return}function BN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+14|0]=a[d]|0;i=i;return}function CN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+680>>3]=+h[b+608>>3];i=i;return}function DN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+688>>3]=+h[b+616>>3];i=i;return}function EN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+696>>3]=+h[b+624>>3];i=i;return}function FN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,0);h[(c[a+416>>2]|0)+896>>3]=l;i=b;return}function GN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,1);h[(c[a+416>>2]|0)+904>>3]=l;i=b;return}function HN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,2);h[(c[a+416>>2]|0)+912>>3]=l;i=b;return}function IN(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5512;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5528;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,3);h[(c[a+416>>2]|0)+920>>3]=l;i=b;return}function JN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+21|0]=a[d]|0;i=i;return}function KN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1456>>3]=+h[b+1448>>3];i=i;return}function LN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+1464>>3];i=i;return}function MN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+1472>>3];i=i;return}function NN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+26|0]=a[d+22|0]|0;i=i;return}function ON(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+27|0]=a[d+23|0]|0;i=i;return}function PN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1520>>3]=+h[b+1488>>3];i=i;return}function QN(a){a=a|0;h[(c[a+416>>2]|0)+1528>>3]=+(c[(c[a+420>>2]|0)+80>>2]|0);i=i;return}function RN(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+108>>2]=c[b+104>>2];i=i;return}function SN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1576>>3]=+h[b+1544>>3];i=i;return}function TN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1584>>3]=+h[b+1552>>3];i=i;return}function UN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+34|0]=a[d+30|0]|0;i=i;return}function VN(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+35|0]=a[d+31|0]|0;i=i;return}function WN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1600>>3]=+h[b+1568>>3];i=i;return}function XN(a){a=a|0;h[(c[a+416>>2]|0)+1608>>3]=+(c[(c[a+420>>2]|0)+84>>2]|0);i=i;return}function YN(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+116>>2]=c[b+112>>2];i=i;return}function ZN(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1104>>3];i=i;return}function _N(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5560]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(5576,TW(+h[(c[g>>2]|0)+1648>>3],5568)|0)|0;g=c[21292]|0;j=e;k=5760;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[5560]=1;i=d;return}function $N(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5784]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(5792,TW(+h[(c[g>>2]|0)+1640>>3],5568)|0)|0;g=c[21292]|0;j=e;k=5872;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[5784]=1;i=d;return}function aO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5896]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(5904,TW(+h[(c[g>>2]|0)+1632>>3],5568)|0)|0;g=c[21292]|0;j=e;k=6064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[5896]=1;i=d;return}function bO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6088]&1){i=d;return}g=b+416|0;b=EZ(+h[(c[g>>2]|0)+1600>>3],0.0)|0;if(!(b<<24>>24==0|(CZ(+h[(c[g>>2]|0)+1600>>3],1.0)|0)<<24>>24==0)){i=d;return}b=XW(6096,TW(+h[(c[g>>2]|0)+1600>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6088]=1;i=d;return}function cO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6264]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(6272,TW(+h[(c[g>>2]|0)+1592>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6264]=1;i=d;return}function dO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6368]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(6376,TW(+h[(c[g>>2]|0)+1584>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6368]=1;i=d;return}function eO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6560]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(6568,TW(+h[(c[g>>2]|0)+1576>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6560]=1;i=d;return}function fO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6664]&1){i=d;return}g=b+416|0;b=EZ(+h[(c[g>>2]|0)+1568>>3],0.0)|0;if(!(b<<24>>24==0|(CZ(+h[(c[g>>2]|0)+1568>>3],1.0)|0)<<24>>24==0)){i=d;return}b=XW(6672,TW(+h[(c[g>>2]|0)+1568>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6664]=1;i=d;return}function gO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6808]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(6816,TW(+h[(c[g>>2]|0)+1560>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6808]=1;i=d;return}function hO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6896]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(6904,TW(+h[(c[g>>2]|0)+1544>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6896]=1;i=d;return}function iO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[6984]&1){i=d;return}g=b+416|0;b=EZ(+h[(c[g>>2]|0)+1520>>3],0.0)|0;if(!(b<<24>>24==0|(CZ(+h[(c[g>>2]|0)+1520>>3],1.0)|0)<<24>>24==0)){i=d;return}b=XW(6992,TW(+h[(c[g>>2]|0)+1520>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7160;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[6984]=1;i=d;return}function jO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7184]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(7192,TW(+h[(c[g>>2]|0)+1512>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7288;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7184]=1;i=d;return}function kO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7312]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(7320,TW(+h[(c[g>>2]|0)+1504>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7424;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7312]=1;i=d;return}function lO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7448]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(7456,TW(+h[(c[g>>2]|0)+1496>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7448]=1;i=d;return}function mO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7576]&1){i=d;return}g=b+416|0;b=EZ(+h[(c[g>>2]|0)+1488>>3],0.0)|0;if(!(b<<24>>24==0|(CZ(+h[(c[g>>2]|0)+1488>>3],1.0)|0)<<24>>24==0)){i=d;return}b=XW(7584,TW(+h[(c[g>>2]|0)+1488>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7576]=1;i=d;return}function nO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7744]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(7752,TW(+h[(c[g>>2]|0)+1480>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7744]=1;i=d;return}function oO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7856]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(7864,TW(+h[(c[g>>2]|0)+1464>>3],5568)|0)|0;g=c[21292]|0;j=e;k=7944;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7856]=1;i=d;return}function pO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7968]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(7976,TW(+h[(c[g>>2]|0)+1456>>3],5568)|0)|0;g=c[21292]|0;j=e;k=8152;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7968]=1;i=d;return}function qO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8176]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(8184,TW(+h[(c[g>>2]|0)+1448>>3],5568)|0)|0;g=c[21292]|0;j=e;k=8264;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8176]=1;i=d;return}function rO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8288]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+76>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=XW(8304,VW(c[(c[g>>2]|0)+76>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=8448;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[8288]=1;i=d;return}function sO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8472]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(8480,TW(+h[(c[g>>2]|0)+1432>>3],5568)|0)|0;g=c[21292]|0;j=e;k=10912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8472]=1;i=d;return}function tO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8672]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(8680,TW(+h[(c[g>>2]|0)+1424>>3],5568)|0)|0;g=c[21292]|0;j=e;k=11048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8672]=1;i=d;return}function uO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8784]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+44>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(8792,VW(c[(c[g>>2]|0)+44>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=11576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[8784]=1;i=d;return}function vO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8952]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(8960,VW(c[(c[g>>2]|0)+40>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=11576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[8952]=1;i=d;return}function wO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9120]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+36>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(9128,VW(c[(c[g>>2]|0)+36>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=11576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9120]=1;i=d;return}function xO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9288]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+32>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(9296,VW(c[(c[g>>2]|0)+32>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=12032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9288]=1;i=d;return}function yO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9432]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(9440,VW(c[(c[g>>2]|0)+28>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=12032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9432]=1;i=d;return}function zO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9576]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+24>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(9584,VW(c[(c[g>>2]|0)+24>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=12032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9576]=1;i=d;return}function AO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9720]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1416>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=XW(9728,TW(+h[(c[g>>2]|0)+1416>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9720]=1;i=d;return}function BO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9832]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1408>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=XW(9840,TW(+h[(c[g>>2]|0)+1408>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9832]=1;i=d;return}function CO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9944]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1400>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=XW(9952,TW(+h[(c[g>>2]|0)+1400>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9944]=1;i=d;return}function DO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10056]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10064,TW(+h[(c[g>>2]|0)+1392>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10056]=1;i=d;return}function EO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10144]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10152,TW(+h[(c[g>>2]|0)+1384>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10144]=1;i=d;return}function FO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10232]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10240,TW(+h[(c[g>>2]|0)+1376>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10232]=1;i=d;return}function GO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10320]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10328,TW(+h[(c[g>>2]|0)+1368>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10320]=1;i=d;return}function HO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10400]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10408,TW(+h[(c[g>>2]|0)+1360>>3],5568)|0)|0;g=c[21292]|0;j=e;k=10664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10400]=1;i=d;return}function IO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10488]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10496,TW(+h[(c[g>>2]|0)+1352>>3],5568)|0)|0;g=c[21292]|0;j=e;k=10776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10488]=1;i=d;return}function JO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10576]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10584,TW(+h[(c[g>>2]|0)+1328>>3],5568)|0)|0;g=c[21292]|0;j=e;k=10664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10576]=1;i=d;return}function KO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10688]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10696,TW(+h[(c[g>>2]|0)+1320>>3],5568)|0)|0;g=c[21292]|0;j=e;k=10776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10688]=1;i=d;return}function LO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10800]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10808,TW(+h[(c[g>>2]|0)+1296>>3],5568)|0)|0;g=c[21292]|0;j=e;k=10912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10800]=1;i=d;return}function MO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10936]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(10944,TW(+h[(c[g>>2]|0)+1288>>3],5568)|0)|0;g=c[21292]|0;j=e;k=11048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10936]=1;i=d;return}function NO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11072]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+20>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(11080,VW(c[(c[g>>2]|0)+20>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=11576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11072]=1;i=d;return}function OO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11240]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(11248,VW(c[(c[g>>2]|0)+16>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=11576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11240]=1;i=d;return}function PO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11408]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+12>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(11416,VW(c[(c[g>>2]|0)+12>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=11576;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11408]=1;i=d;return}function QO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11600]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+8>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(11608,VW(c[(c[g>>2]|0)+8>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=12032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11600]=1;i=d;return}function RO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11744]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(11752,VW(c[(c[g>>2]|0)+4>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=12032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11744]=1;i=d;return}function SO(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11888]&1){i=d;return}g=b+420|0;b=EZ(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[c[g>>2]>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(11896,VW(c[c[g>>2]>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=12032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11888]=1;i=d;return}function TO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12056]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1280>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=XW(12064,TW(+h[(c[g>>2]|0)+1280>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12056]=1;i=d;return}function UO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12192]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1272>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=XW(12200,TW(+h[(c[g>>2]|0)+1272>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12304;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12192]=1;i=d;return}function VO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12328]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=XW(12336,TW(+h[(c[g>>2]|0)+1264>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12440;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12328]=1;i=d;return}function WO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12464]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(12472,TW(+h[(c[g>>2]|0)+1256>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12552;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12464]=1;i=d;return}function XO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12576]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(12584,TW(+h[(c[g>>2]|0)+1248>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12664;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12576]=1;i=d;return}function YO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12688]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(12696,TW(+h[(c[g>>2]|0)+1240>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12688]=1;i=d;return}function ZO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12800]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(12808,TW(+h[(c[g>>2]|0)+1232>>3],5568)|0)|0;g=c[21292]|0;j=e;k=12880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12800]=1;i=d;return}function _O(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12904]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(12912,TW(+h[(c[g>>2]|0)+1192>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12904]=1;i=d;return}function $O(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13136]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13144,TW(+h[(c[g>>2]|0)+1136>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13240;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13136]=1;i=d;return}function aP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13264]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13272,TW(+h[(c[g>>2]|0)+1072>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13264]=1;i=d;return}function bP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13392]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13400,TW(+h[(c[g>>2]|0)+1064>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13504;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13392]=1;i=d;return}function cP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13528]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13536,TW(+h[(c[g>>2]|0)+1056>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13632;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13528]=1;i=d;return}function dP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13656]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13664,TW(+h[(c[g>>2]|0)+1048>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13792;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13656]=1;i=d;return}function eP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13816]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13824,TW(+h[(c[g>>2]|0)+1016>>3],5568)|0)|0;g=c[21292]|0;j=e;k=13936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13816]=1;i=d;return}function fP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13960]&1){i=d;return}g=b+416|0;if(!((EZ(+h[(c[g>>2]|0)+1008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(13968,TW(+h[(c[g>>2]|0)+1008>>3],5568)|0)|0;g=c[21292]|0;j=e;k=14048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[13960]=1;i=d;return}function gP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14072]&1){i=d;return}g=b+420|0;b=EZ(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[g>>2]|0)+48>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=XW(14080,VW(c[(c[g>>2]|0)+48>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=14312;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14072]=1;i=d;return}function hP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14336]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(14344,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=14696;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14336]=1;i=d;return}function iP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14456]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(14464,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=14696;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14456]=1;i=d;return}function jP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14576]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(14584,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=14696;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14576]=1;i=d;return}function kP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14720]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(14728,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14720]=1;i=d;return}function lP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14856]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(14864,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14856]=1;i=d;return}function mP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14992]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15e3,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[14992]=1;i=d;return}function nP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15128]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15136,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=15848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15128]=1;i=d;return}function oP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15248]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15256,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=15848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15248]=1;i=d;return}function pP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15368]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15376,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=15848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15368]=1;i=d;return}function qP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15488]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15496,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=15848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15488]=1;i=d;return}function rP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15608]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15616,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=15848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15608]=1;i=d;return}function sP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15728]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15736,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=15848;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15728]=1;i=d;return}function tP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15872]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(15880,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15872]=1;i=d;return}function uP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16008]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16016,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16008]=1;i=d;return}function vP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16144]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16152,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16144]=1;i=d;return}function wP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16304]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16312,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16304]=1;i=d;return}function xP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16440]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16448,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16440]=1;i=d;return}function yP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16576]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16584,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=16712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16576]=1;i=d;return}function zP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16736]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16744,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=17144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16736]=1;i=d;return}function AP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16872]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(16880,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=17144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16872]=1;i=d;return}function BP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17008]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17016,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=17144;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17008]=1;i=d;return}function CP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17168]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17176,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17168]=1;i=d;return}



function Je(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ke(){return i|0}function Le(a){a=a|0;i=a}function Me(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ne(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Oe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Pe(a){a=a|0;J=a}function Qe(a){a=a|0;K=a}function Re(a){a=a|0;L=a}function Se(a){a=a|0;M=a}function Te(a){a=a|0;N=a}function Ue(a){a=a|0;O=a}function Ve(a){a=a|0;P=a}function We(a){a=a|0;Q=a}function Xe(a){a=a|0;R=a}function Ye(a){a=a|0;S=a}function Ze(a){a=a|0;var b=0,d=0;b=i;J_(a)|0;d=a+540|0;ie[c[(c[d>>2]|0)+40>>2]&127](a)|0;ie[c[(c[d>>2]|0)+28>>2]&127](a)|0;ie[c[(c[d>>2]|0)+32>>2]&127](a)|0;ie[c[(c[d>>2]|0)+48>>2]&127](a)|0;ie[c[(c[d>>2]|0)+52>>2]&127](a)|0;pZ(a);i=b;return}function _e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=upa(B|0)|0;D=Soa(C+11|0)|0;Fpa(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ic(D|0,32)|0;if((C|0)==0){B=Wd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;vW(23,0,40,u);Yc(0)|0;F=0}else{F=C}Toa(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Ce[c[36724>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{NX(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}NX(2);MX(2)}BX(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tW(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];cZ(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tW(23,1,144,r);Z=r_(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ze(b);qZ(b);if((c[35916>>2]|0)!=0){fe[c[9094]&255](23)}if((c[2]|0)!=0){MX(4)}A=eZ(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];tW(7,1,200,q);if((c[92876>>2]|0)==0){ge[c[77564>>2]&127](77544,b)}gZ(b,c[J>>2]|0,z,d);if((c[35852>>2]|0)!=0){fe[c[9094]&255](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;uZ(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){PX(4)}if((D_(b,1,1)|0)!=0){c[B>>2]=1;uZ(b)}ie[c[(c[K>>2]|0)+88>>2]&127](b)|0;pZ(b);yZ(b);qZ(b);do{if((T|0)==0){_=0}else{MX(7);PX(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+HX(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+HX(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=CX(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+HX(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}PX(7);if((la|0)!=0){_=T;break}c[p>>2]=Wd(c[(Nc()|0)>>2]|0)|0;vW(23,0,240,p);Yc(T|0)|0;_=0}}while(0);if((c[92876>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ge[c[77564>>2]&127](77544,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[20786]|0)!=0){ca=f;ba=83152;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];lW(M,f);Sd(10,M|0)|0;ba=c[20794]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;tW(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((a_(b,0)|0)!=0){ma=58;break}if((SZ(b,0)|0)!=0){ma=58;break}if((HZ(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tW(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((a_(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tW(1,0,448,m);U=_;V=-2;break}if((SZ(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tW(1,0,536,l);U=_;V=-3;break}T=(HZ(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tW(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];tW(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Yc(U|0)|0;i=e;return V|0}function $e(a){a=a|0;i=i;return 0}function af(a){a=a|0;i=i;return 0}function bf(a){a=a|0;i=i;return 0}function cf(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(DZ(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+104>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+6248|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+104>>3];g=e;j=g+6248|0;k=j;h[k>>3]=f;i=b;return}function df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+48>>3]- +h[b+5808>>3];i=i;return}function ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b+56>>3]- +h[b+5816>>3];i=i;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+64>>3]- +h[b+5824>>3];i=i;return}function gf(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+368>>3];e=+h[b+376>>3];f=+h[b+384>>3];h[b+6224>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[b+416>>2]|0)+1616>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+376>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,872,864,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}function jf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[b+416>>2]|0)+1616>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+368>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+344|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+344|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,872,984,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+344|0;q=p;h[q>>3]=n;i=d;return}function kf(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6216>>3]=+h[b+1576>>3]*(+h[d+6224>>3]- +h[b+1584>>3]);i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=-(+h[b+344>>3]*+h[b+6216>>3]);i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=-(+h[b+352>>3]*+h[b+6216>>3]);i=i;return}function nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[b+416>>2]|0)+1616>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+384>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,872,992,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=-(+h[b+360>>3]*+h[b+6216>>3]);i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+24>>3];i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+32>>3];i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=+h[b+40>>3];i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+96>>3];i=i;return}function tf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+496>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+496|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+b_(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+496>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+504>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+504|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+b_(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+504>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+512>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+512|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+b_(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+512>>3]);g=c[f>>2]|0;h[(c[g+132>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+124>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+488>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+488|0;h[(c[g+128>>2]|0)+24>>3]=+h[j>>3];k=+b_(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+488>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+24>>3]=k;$Z(a,1)|0;e=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+496>>3]=+h[e>>3];h[f+504>>3]=+h[e+8>>3];h[f+512>>3]=+h[e+16>>3];h[f+488>>3]=+h[e+24>>3];Xg(a);i=b;return}function uf(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+488>>3];e=+h[b+512>>3];h[b+568>>3]=(d*d+e*e)*2.0+-1.0;i=i;return}function vf(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+504>>3];e=+h[b+512>>3];h[b+632>>3]=(d*d+e*e)*2.0+-1.0;i=i;return}function wf(a){a=a|0;var b=0,d=0,e=0;b=i;RZ(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+688>>3]=+h[d>>3];h[e+696>>3]=+h[d+8>>3];h[e+704>>3]=+h[d+16>>3];h[e+712>>3]=+h[d+24>>3];i=b;return}function xf(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[c[f>>2]>>2]|0;g=c[a+12>>2]|0;j=c[a+8>>2]|0;l=+h[j+712>>3];m=+h[j+704>>3];n=+h[j+696>>3];o=+h[j+688>>3];p=+(c[g>>2]|0)*l+ +(c[g+12>>2]|0)*m+ +(c[g+24>>2]|0)*n+ +(c[g+36>>2]|0)*o;q=l*+(c[g+8>>2]|0)+m*+(c[g+20>>2]|0)+n*+(c[g+32>>2]|0)+o*+(c[g+44>>2]|0);j=d;h[k>>3]=l*+(c[g+4>>2]|0)+m*+(c[g+16>>2]|0)+n*+(c[g+28>>2]|0)+o*+(c[g+40>>2]|0);c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];rX(e,3,p,d);oX(e,(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+184|0);i=b;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=(+h[b+504>>3]*+h[b+496>>3]- +h[b+488>>3]*+h[b+512>>3])*2.0;i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=(+h[b+504>>3]*+h[b+488>>3]+ +h[b+496>>3]*+h[b+512>>3])*2.0;i=i;return}function Af(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6216>>3];h[b+408>>3]=+h[b+616>>3]*+h[b+344>>3]*d+(+h[b+624>>3]*d*+h[b+352>>3]+ +h[b+632>>3]*d*+h[b+360>>3]);i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=(+h[b+496>>3]*+h[b+504>>3]+ +h[b+488>>3]*+h[b+512>>3])*2.0;i=i;return}function Cf(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+496>>3];e=+h[b+512>>3];h[b+600>>3]=(d*d+e*e)*2.0+-1.0;i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=(+h[b+496>>3]*+h[b+488>>3]- +h[b+504>>3]*+h[b+512>>3])*2.0;i=i;return}function Ef(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6216>>3];h[b+400>>3]=+h[b+592>>3]*+h[b+344>>3]*d+(+h[b+600>>3]*d*+h[b+352>>3]+ +h[b+608>>3]*d*+h[b+360>>3]);i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=(+h[b+488>>3]*+h[b+504>>3]- +h[b+496>>3]*+h[b+512>>3])*2.0;i=i;return}function Gf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=(+h[b+488>>3]*+h[b+496>>3]+ +h[b+504>>3]*+h[b+512>>3])*2.0;i=i;return}function Hf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6216>>3];h[b+392>>3]=+h[b+568>>3]*+h[b+344>>3]*d+(+h[b+576>>3]*d*+h[b+352>>3]+ +h[b+584>>3]*d*+h[b+360>>3]);i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+48>>3]- +h[b+5808>>3];i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+56>>3]- +h[b+5816>>3];i=i;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+64>>3]- +h[b+5824>>3];i=i;return}function Lf(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=+h[d+248>>3];f=+h[d+256>>3];g=+h[d+264>>3];j=+V(+(e*e+f*f+g*g));h[d+6200>>3]=+td(+j,+(+h[(c[a+416>>2]|0)+1624>>3]));i=b;return}function Mf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6200>>3];k=+h[g+256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+280|0;p=o;h[p>>3]=m;i=d;return}q=k/+zW(c[b+536>>2]|0,j,1008,1e3,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+280|0;p=o;h[p>>3]=m;i=d;return}function Nf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6200>>3];k=+h[g+248>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}q=k/+zW(c[b+536>>2]|0,j,1008,1024,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}function Of(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6176>>3]=+td(+(+h[d+6200>>3]- +h[(c[a+416>>2]|0)+1648>>3]),0.0);i=b;return}function Pf(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6184>>3]=+sd(+(+h[(c[a+416>>2]|0)+1648>>3]),+(+h[d+6200>>3]));i=b;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+272>>3]*+h[b+6184>>3];i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+280>>3]*+h[b+6184>>3];i=i;return}function Sf(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6200>>3];k=+h[g+264>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}q=k/+zW(c[b+536>>2]|0,j,1008,1032,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+288>>3]*+h[b+6184>>3];i=i;return}function Uf(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;d=i;e=b+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=+h[f+248>>3];j=+h[f+256>>3];k=+h[f+264>>3];l=+V(+(g*g+j*j+k*k));do{if((DZ(l,+h[(c[b+416>>2]|0)+1624>>3])|0)<<24>>24==0){m=0.0}else{f=c[c[e>>2]>>2]|0;n=c[f+8>>2]|0;k=+h[n+248>>3];j=+h[n+256>>3];g=+h[n+264>>3];o=+V(+(k*k+j*j+g*g))*2.0;p=+h[n+24>>3];q=+h[n+32>>3];r=+h[n+40>>3];s=k*(p+p)+j*(q+q)+g*(r+r);if(o!=0.0){m=s/o;break}if(s==0.0){m=s;break}m=s/+zW(c[b+536>>2]|0,o,1048,1040,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6256>>3]=m;i=d;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6208>>3]=+h[(c[a+416>>2]|0)+1640>>3]*+h[b+6256>>3];i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=-(+h[b+272>>3]*+h[b+6208>>3]);i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=-+h[b+416>>3]- +h[b+320>>3];i=i;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=-(+h[b+280>>3]*+h[b+6208>>3]);i=i;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=-(+h[b+288>>3]*+h[b+6208>>3]);i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=-(+h[b+584>>3]*+h[b+336>>3])- +h[b+576>>3]*+h[b+328>>3]- +h[b+568>>3]*+h[b+320>>3];i=i;return}function $f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=-+h[b+392>>3]- +h[b+296>>3];i=i;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+304>>3]=-(+h[b+608>>3]*+h[b+336>>3])- +h[b+600>>3]*+h[b+328>>3]- +h[b+592>>3]*+h[b+320>>3];i=i;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=-+h[b+400>>3]- +h[b+304>>3];i=i;return}function cg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b>>3]*+h[b+8>>3];e=c[a+416>>2]|0;h[b+480>>3]=d- +h[e+56>>3]*+h[b+544>>3]/-.1- -(+h[e+48>>3]*+h[b+552>>3])/-.1-d;i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+480>>3];i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+312>>3]=-(+h[b+632>>3]*+h[b+336>>3])- +h[b+624>>3]*+h[b+328>>3]- +h[b+616>>3]*+h[b+320>>3];i=i;return}function fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+560>>3]=-+h[b+408>>3]- +h[b+312>>3];i=i;return}function gg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+8>>3]*+h[b+16>>3];e=c[a+416>>2]|0;h[b+464>>3]=d- +h[e+64>>3]*+h[b+552>>3]/-.1- -(+h[e+56>>3]*+h[b+560>>3])/-.1-d;i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+112>>3]=+h[b+464>>3];i=i;return}function ig(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3]*+h[b>>3];e=c[a+416>>2]|0;h[b+472>>3]=d- +h[e+48>>3]*+h[b+560>>3]/-.1- -(+h[e+64>>3]*+h[b+544>>3])/-.1-d;i=i;return}function jg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+472>>3];i=i;return}function kg(a){a=a|0;var b=0,d=0,e=0;b=i;RZ(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+536>>3]=+h[d>>3];h[e+520>>3]=+h[d+8>>3];h[e+528>>3]=+h[d+16>>3];i=b;return}function lg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+152>>3]=+h[b+536>>3];i=i;return}function mg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+136>>3]=+h[b+520>>3];i=i;return}function ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+144>>3]=+h[b+528>>3];i=i;return}function og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=-+h[b+432>>3]- +h[b+336>>3];i=i;return}function pg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+648>>3]=+h[b+408>>3]*+h[d+664>>3]- +h[b+392>>3]*+h[d+680>>3];i=i;return}function qg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6192>>3]=+h[b+6208>>3]*+h[b+6256>>3];i=i;return}function rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+5744>>3]- +h[b+104>>3];i=i;return}function sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+456>>3]- +h[b+5744>>3];i=i;return}function tg(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+856>>3];h[b+6240>>3]=+V(+(d*d));i=i;return}function ug(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6232>>3]=+h[b+1496>>3]*(+h[d+6240>>3]- +h[b+1504>>3]);i=i;return}function vg(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6240>>3],+h[(c[b+416>>2]|0)+1536>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+856>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+832|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+832|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,1192,1184,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+832|0;q=p;h[q>>3]=n;i=d;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=-(+h[b+832>>3]*+h[b+6232>>3]);i=i;return}function xg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=-+h[b+328>>3]- +h[b+808>>3]- +h[b+424>>3];i=i;return}function yg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=+h[b+832>>3]*+h[b+6232>>3];i=i;return}function zg(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=-+h[e+1e3>>3];g=+h[e+1368>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+784>>3];if(g!=0.0){m=k;n=l/g;o=f-n;p=m;q=p+936|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f-n;p=m;q=p+936|0;r=q;h[r>>3]=o;i=d;return}s=l/+zW(c[b+536>>2]|0,g,1312,1304,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f-n;p=m;q=p+936|0;r=q;h[r>>3]=o;i=d;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=-+h[b+936>>3];i=i;return}function Bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[(c[a+416>>2]|0)+600>>3]*+h[b+784>>3];i=i;return}function Cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=+h[(c[a+416>>2]|0)+504>>3]*+h[b+808>>3]- +h[b+448>>3];i=i;return}function Dg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+640>>3]=+h[b+400>>3]*+h[d+680>>3]+(+h[d+720>>3]- +h[b+408>>3]*+h[d+672>>3]);i=i;return}function Eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=-(+h[(c[a+416>>2]|0)+584>>3]*+h[b+784>>3]);i=i;return}function Fg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=-(+h[(c[a+416>>2]|0)+488>>3]*+h[b+808>>3])- +h[b+440>>3];i=i;return}function Gg(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+656>>3]=+h[b+392>>3]*+h[d+672>>3]+(+h[d+736>>3]- +h[b+400>>3]*+h[d+664>>3]);i=i;return}function Hg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((DZ(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3],+h[(c[a+416>>2]|0)+1536>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[21290]|0;g=d;j=2352;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,1408,e);i=b;return}function Ig(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((DZ(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[a+416>>2]|0)+1616>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[21290]|0;g=d;j=2352;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&31](f,d,1408,e);i=b;return}function Jg(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);i=c;return 0}function Kg(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Lg(b);i=c;return 0}function Lg(a){a=a|0;var b=0;b=i;df(a);ef(a);ff(a);gf(a);hf(a);jf(a);kf(a);nf(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Sf(a);Uf(a);Vf(a);Wf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);rg(a);sg(a);tg(a);ug(a);vg(a);yg(a);zg(a);Ag(a);i=b;return}function Mg(a,b){a=a|0;b=+b;i=i;return 0}function Ng(a){a=a|0;var b=0;b=i;i=i+8|0;wW(c[a+536>>2]|0,(a|0)!=0|0,2584,b);c[a+540>>2]=2392;c[a+84>>2]=2616;c[a+88>>2]=2616;c[a+92>>2]=2688;c[a+96>>2]=2784;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=14;c[a+116>>2]=827;c[a+120>>2]=0;c[a+124>>2]=54;c[a+128>>2]=0;c[a+132>>2]=0;c[a+136>>2]=207;c[a+140>>2]=22;c[a+144>>2]=42;c[a+148>>2]=32;c[a+152>>2]=0;c[a+156>>2]=0;c[a+232>>2]=6;c[a+216>>2]=776;c[a+220>>2]=33;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=0;c[a+104>>2]=0;c[a+164>>2]=0;c[a+168>>2]=0;c[a+176>>2]=3;c[a+180>>2]=0;c[a+184>>2]=3;c[a+188>>2]=0;c[a+56>>2]=2824;c[a+64>>2]=5;c[a+72>>2]=0;c[a+68>>2]=1982;c[a+192>>2]=0;c[a+196>>2]=4;c[a+200>>2]=2;c[a+204>>2]=1;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function Og(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=Hpa(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=36704;F=36728;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[9176]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=Hpa(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[8434]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=Hpa(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(48,c[8434]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=Hpa(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;tpa(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Hpa(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;tpa(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=Hpa(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(48,c[8434]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=Hpa(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Hpa(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=Hpa(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,2904,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=Hpa(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=Hpa(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=Hpa(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(138,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=Hpa(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=Hpa(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=Hpa(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(48,c[8434]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=Hpa(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=Hpa(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=Hpa(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(139,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=Hpa(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function Pg(){var a=0;a=i;ud(0)|0;rc(3064,18,1,c[r>>2]|0)|0;ud(0)|0;i=a;return}function Qg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0;f=i;i=i+120|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+24|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=ta;c[sa>>2]=4;lX(Aa,1,sa);c[ra>>2]=4;lX(ua,1,ra);c[qa>>2]=1;c[qa+4>>2]=1;Ba=+h[(sX(d,2,qa)|0)>>3];c[pa>>2]=2;c[pa+4>>2]=2;Ca=-+h[(sX(d,2,pa)|0)>>3];c[oa>>2]=3;c[oa+4>>2]=3;Da=Ba+(Ca- +h[(sX(d,2,oa)|0)>>3])+1.0;c[na>>2]=2;c[na+4>>2]=2;Ca=+h[(sX(d,2,na)|0)>>3];c[ma>>2]=1;c[ma+4>>2]=1;Ba=-+h[(sX(d,2,ma)|0)>>3];c[la>>2]=3;c[la+4>>2]=3;Ea=Ca+(Ba- +h[(sX(d,2,la)|0)>>3])+1.0;c[ka>>2]=3;c[ka+4>>2]=3;Ba=+h[(sX(d,2,ka)|0)>>3];c[ja>>2]=1;c[ja+4>>2]=1;Ca=-+h[(sX(d,2,ja)|0)>>3];c[ia>>2]=2;c[ia+4>>2]=2;Fa=Ba+(Ca- +h[(sX(d,2,ia)|0)>>3])+1.0;c[ha>>2]=1;c[ha+4>>2]=1;Ca=+h[(sX(d,2,ha)|0)>>3];c[ga>>2]=2;c[ga+4>>2]=2;Ba=+h[(sX(d,2,ga)|0)>>3];c[fa>>2]=3;c[fa+4>>2]=3;Ga=Ca+(Ba+ +h[(sX(d,2,fa)|0)>>3])+1.0;do{if(Ga>.04000000000000001){Ha=3}else{if(Ga>Da&Ga>Ea&Ga>Fa){Ha=3;break}if(Da>Ea&Da>Fa&Da>Ga){if(!(Da>=0.0)){fa=c[21290]|0;ga=Y;h[k>>3]=Da;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa;fa=l;ha=3264;c[fa+0>>2]=c[ha+0>>2];c[fa+4>>2]=c[ha+4>>2];c[fa+8>>2]=c[ha+8>>2];c[fa+12>>2]=c[ha+12>>2];c[fa+16>>2]=c[ha+16>>2];c[fa+20>>2]=c[ha+20>>2];Ie[ga&31](b,l,3152,Y);}Ba=+V(+Da)*.5;Ca=Ba*4.0;c[X>>2]=1;c[X+4>>2]=2;Ia=+h[(sX(d,2,X)|0)>>3];c[W>>2]=2;c[W+4>>2]=1;Ja=(Ia+ +h[(sX(d,2,W)|0)>>3])/Ca;c[U>>2]=1;c[U+4>>2]=3;Ia=+h[(sX(d,2,U)|0)>>3];c[T>>2]=3;c[T+4>>2]=1;Ka=(Ia+ +h[(sX(d,2,T)|0)>>3])/Ca;c[S>>2]=2;c[S+4>>2]=3;Ia=+h[(sX(d,2,S)|0)>>3];c[R>>2]=3;c[R+4>>2]=2;La=(Ia- +h[(sX(d,2,R)|0)>>3])/Ca;ga=Q;h[k>>3]=Ja;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+8|0;h[k>>3]=Ka;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+16|0;h[k>>3]=La;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];rX(wa,4,Ba,Q);mX(wa,ua);break}if(Ea>Da&Ea>Fa&Ea>Ga){if(!(Ea>=0.0)){ga=c[21290]|0;ha=P;h[k>>3]=Ea;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=ga;ga=j;fa=3264;c[ga+0>>2]=c[fa+0>>2];c[ga+4>>2]=c[fa+4>>2];c[ga+8>>2]=c[fa+8>>2];c[ga+12>>2]=c[fa+12>>2];c[ga+16>>2]=c[fa+16>>2];c[ga+20>>2]=c[fa+20>>2];Ie[ha&31](b,j,3208,P);}Ba=+V(+Ea)*.5;La=Ba*4.0;c[O>>2]=1;c[O+4>>2]=2;Ka=+h[(sX(d,2,O)|0)>>3];c[N>>2]=2;c[N+4>>2]=1;Ja=(Ka+ +h[(sX(d,2,N)|0)>>3])/La;c[M>>2]=2;c[M+4>>2]=3;Ka=+h[(sX(d,2,M)|0)>>3];c[L>>2]=3;c[L+4>>2]=2;Ca=(Ka+ +h[(sX(d,2,L)|0)>>3])/La;c[K>>2]=3;c[K+4>>2]=1;Ka=+h[(sX(d,2,K)|0)>>3];c[J>>2]=1;c[J+4>>2]=3;Ia=(Ka- +h[(sX(d,2,J)|0)>>3])/La;ha=I;h[k>>3]=Ba;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+8|0;h[k>>3]=Ca;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+16|0;h[k>>3]=Ia;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];rX(xa,4,Ja,I);mX(xa,ua);break}else{if(!(Fa>=0.0)){ha=c[21290]|0;fa=H;h[k>>3]=Fa;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=ha;ha=g;ga=3264;c[ha+0>>2]=c[ga+0>>2];c[ha+4>>2]=c[ga+4>>2];c[ha+8>>2]=c[ga+8>>2];c[ha+12>>2]=c[ga+12>>2];c[ha+16>>2]=c[ga+16>>2];c[ha+20>>2]=c[ga+20>>2];Ie[fa&31](b,g,3288,H);}Ja=+V(+Fa)*.5;Ia=Ja*4.0;c[G>>2]=1;c[G+4>>2]=3;Ca=+h[(sX(d,2,G)|0)>>3];c[F>>2]=3;c[F+4>>2]=1;Ba=(Ca+ +h[(sX(d,2,F)|0)>>3])/Ia;c[E>>2]=2;c[E+4>>2]=3;Ca=+h[(sX(d,2,E)|0)>>3];c[D>>2]=3;c[D+4>>2]=2;La=(Ca+ +h[(sX(d,2,D)|0)>>3])/Ia;c[C>>2]=1;c[C+4>>2]=2;Ca=+h[(sX(d,2,C)|0)>>3];c[B>>2]=2;c[B+4>>2]=1;Ka=(Ca- +h[(sX(d,2,B)|0)>>3])/Ia;fa=A;h[k>>3]=La;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+8|0;h[k>>3]=Ja;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+16|0;h[k>>3]=Ka;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];rX(ya,4,Ba,A);mX(ya,ua);break}}}while(0);if((Ha|0)==3){if(!(Ga>=0.0)){Ha=c[21290]|0;ya=ea;h[k>>3]=Ga;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=Ha;Ha=m;A=3264;c[Ha+0>>2]=c[A+0>>2];c[Ha+4>>2]=c[A+4>>2];c[Ha+8>>2]=c[A+8>>2];c[Ha+12>>2]=c[A+12>>2];c[Ha+16>>2]=c[A+16>>2];c[Ha+20>>2]=c[A+20>>2];Ie[ya&31](b,m,3096,ea);}Fa=+V(+Ga)*.5;Ga=Fa*4.0;c[da>>2]=2;c[da+4>>2]=3;Ea=+h[(sX(d,2,da)|0)>>3];c[ca>>2]=3;c[ca+4>>2]=2;Da=(Ea- +h[(sX(d,2,ca)|0)>>3])/Ga;c[ba>>2]=3;c[ba+4>>2]=1;Ea=+h[(sX(d,2,ba)|0)>>3];c[aa>>2]=1;c[aa+4>>2]=3;Ba=(Ea- +h[(sX(d,2,aa)|0)>>3])/Ga;c[$>>2]=1;c[$+4>>2]=2;Ea=+h[(sX(d,2,$)|0)>>3];c[_>>2]=2;c[_+4>>2]=1;Ka=(Ea- +h[(sX(d,2,_)|0)>>3])/Ga;_=Z;h[k>>3]=Ba;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+8|0;h[k>>3]=Ka;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+16|0;h[k>>3]=Fa;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];rX(va,4,Da,Z);mX(va,ua)}c[z>>2]=1;Da=+h[(sX(ua,1,z)|0)>>3];c[y>>2]=1;Fa=Da*+h[(sX(e,1,y)|0)>>3];c[x>>2]=2;Da=+h[(sX(ua,1,x)|0)>>3];c[w>>2]=2;Ka=Da*+h[(sX(e,1,w)|0)>>3];c[v>>2]=3;Da=+h[(sX(ua,1,v)|0)>>3];c[u>>2]=3;Ba=Da*+h[(sX(e,1,u)|0)>>3];c[t>>2]=4;Da=+h[(sX(ua,1,t)|0)>>3];c[s>>2]=4;if(!(Fa+(Ka+(Ba+Da*+h[(sX(e,1,s)|0)>>3]))<0.0)){mX(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}c[r>>2]=1;Da=-+h[(sX(ua,1,r)|0)>>3];c[q>>2]=2;Ba=-+h[(sX(ua,1,q)|0)>>3];c[p>>2]=3;Ka=-+h[(sX(ua,1,p)|0)>>3];c[o>>2]=4;Fa=-+h[(sX(ua,1,o)|0)>>3];o=n;h[k>>3]=Ba;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=Ka;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=Fa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];rX(za,4,Da,n);mX(za,ua);mX(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}function Rg(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;h[a>>3]=c>d?c:d;i=i;return}function Sg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0.0,bc=0.0,cc=0.0,dc=0.0,ec=0.0,fc=0.0,gc=0.0,hc=0.0,ic=0.0,jc=0.0;b=i;i=i+8|0;f=b;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+16|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+16|0;S=i;i=i+8|0;T=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+8|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+8|0;za=i;i=i+8|0;Aa=i;i=i+8|0;Ba=i;i=i+8|0;Ca=i;i=i+8|0;Da=i;i=i+8|0;Ea=i;i=i+8|0;Fa=i;i=i+8|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+8|0;Ka=i;i=i+8|0;La=i;i=i+8|0;Ma=i;i=i+8|0;Na=i;i=i+8|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+8|0;Sa=i;i=i+8|0;Ta=i;i=i+8|0;Ua=i;i=i+8|0;Va=i;i=i+8|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+16|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+8|0;eb=i;i=i+8|0;fb=i;i=i+8|0;gb=i;i=i+8|0;hb=i;i=i+8|0;ib=i;i=i+8|0;jb=i;i=i+8|0;kb=i;i=i+8|0;lb=i;i=i+8|0;mb=i;i=i+8|0;nb=i;i=i+8|0;ob=i;i=i+16|0;pb=i;i=i+8|0;qb=i;i=i+8|0;rb=i;i=i+8|0;sb=i;i=i+8|0;tb=i;i=i+8|0;ub=i;i=i+8|0;vb=i;i=i+8|0;wb=i;i=i+8|0;xb=i;i=i+8|0;yb=i;i=i+16|0;zb=i;i=i+16|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+16|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+16|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+16|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+16|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+16|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+16|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+16|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+16|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+16|0;$b=yb;c[xb>>2]=3;c[xb+4>>2]=3;lX($b,2,xb);c[wb>>2]=3;c[wb+4>>2]=3;lX(zb,2,wb);c[vb>>2]=1;ac=+h[(sX(d,1,vb)|0)>>3];c[ub>>2]=2;bc=+h[(sX(d,1,ub)|0)>>3];c[tb>>2]=3;cc=+h[(sX(d,1,tb)|0)>>3];dc=+V(+(ac*ac+(bc*bc+cc*cc)));c[sb>>2]=3;lX(Ab,1,sb);if(dc<1.0e-10){sb=Bb;tb=3344;c[sb+0>>2]=c[tb+0>>2];c[sb+4>>2]=c[tb+4>>2];c[sb+8>>2]=c[tb+8>>2]}else{c[rb>>2]=1;cc=+h[(sX(d,1,rb)|0)>>3]/dc;c[qb>>2]=2;bc=+h[(sX(d,1,qb)|0)>>3]/dc;c[pb>>2]=3;ac=+h[(sX(d,1,pb)|0)>>3]/dc;pb=ob;h[k>>3]=bc;c[pb>>2]=c[k>>2];c[pb+4>>2]=c[k+4>>2];pb=ob+8|0;h[k>>3]=ac;c[pb>>2]=c[k>>2];c[pb+4>>2]=c[k+4>>2];rX(Bb,3,cc,ob)}ob=Ab;pb=Bb;c[ob+0>>2]=c[pb+0>>2];c[ob+4>>2]=c[pb+4>>2];c[ob+8>>2]=c[pb+8>>2];c[nb>>2]=3;lX(Cb,1,nb);c[mb>>2]=2;cc=+h[(sX(Ab,1,mb)|0)>>3];c[lb>>2]=3;ac=cc*+h[(sX(e,1,lb)|0)>>3];c[kb>>2]=3;cc=+h[(sX(Ab,1,kb)|0)>>3];c[jb>>2]=2;bc=ac-cc*+h[(sX(e,1,jb)|0)>>3];c[ib>>2]=3;cc=+h[(sX(Ab,1,ib)|0)>>3];c[hb>>2]=1;ac=cc*+h[(sX(e,1,hb)|0)>>3];c[gb>>2]=1;cc=+h[(sX(Ab,1,gb)|0)>>3];c[fb>>2]=3;dc=ac-cc*+h[(sX(e,1,fb)|0)>>3];c[eb>>2]=1;cc=+h[(sX(Ab,1,eb)|0)>>3];c[db>>2]=2;ac=cc*+h[(sX(e,1,db)|0)>>3];c[cb>>2]=2;cc=+h[(sX(Ab,1,cb)|0)>>3];c[bb>>2]=1;ec=ac-cc*+h[(sX(e,1,bb)|0)>>3];bb=ab;h[k>>3]=dc;c[bb>>2]=c[k>>2];c[bb+4>>2]=c[k+4>>2];bb=ab+8|0;h[k>>3]=ec;c[bb>>2]=c[k>>2];c[bb+4>>2]=c[k+4>>2];rX(Db,3,bc,ab);mX(Db,Cb);c[$a>>2]=2;bc=+h[(sX(Ab,1,$a)|0)>>3];c[_a>>2]=3;ec=bc*+h[(sX(e,1,_a)|0)>>3];c[Za>>2]=3;bc=+h[(sX(Ab,1,Za)|0)>>3];c[Ya>>2]=2;dc=ec-bc*+h[(sX(e,1,Ya)|0)>>3];c[Xa>>2]=3;bc=+h[(sX(Ab,1,Xa)|0)>>3];c[Wa>>2]=1;ec=bc*+h[(sX(e,1,Wa)|0)>>3];c[Va>>2]=1;bc=+h[(sX(Ab,1,Va)|0)>>3];c[Ua>>2]=3;cc=ec-bc*+h[(sX(e,1,Ua)|0)>>3];c[Ta>>2]=1;bc=+h[(sX(Ab,1,Ta)|0)>>3];c[Sa>>2]=2;ec=bc*+h[(sX(e,1,Sa)|0)>>3];c[Ra>>2]=2;bc=+h[(sX(Ab,1,Ra)|0)>>3];c[Qa>>2]=1;ac=ec-bc*+h[(sX(e,1,Qa)|0)>>3];Qa=Pa;h[k>>3]=cc;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];Qa=Pa+8|0;h[k>>3]=ac;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];rX(Eb,3,dc,Pa);Pa=Cb;Qa=Eb;c[Pa+0>>2]=c[Qa+0>>2];c[Pa+4>>2]=c[Qa+4>>2];c[Pa+8>>2]=c[Qa+8>>2];c[Oa>>2]=3;lX(Fb,1,Oa);c[Na>>2]=1;dc=+h[(sX(Cb,1,Na)|0)>>3];c[Ma>>2]=2;ac=+h[(sX(Cb,1,Ma)|0)>>3];c[La>>2]=3;cc=+h[(sX(Cb,1,La)|0)>>3];if(dc*dc+(ac*ac+cc*cc)>1.0e-6){c[Ka>>2]=1;cc=+h[(sX(e,1,Ka)|0)>>3];c[Ja>>2]=2;ac=+h[(sX(e,1,Ja)|0)>>3];c[Ia>>2]=3;dc=+h[(sX(e,1,Ia)|0)>>3];Ia=Ha;h[k>>3]=ac;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];Ia=Ha+8|0;h[k>>3]=dc;c[Ia>>2]=c[k>>2];c[Ia+4>>2]=c[k+4>>2];rX(Hb,3,cc,Ha)}else{c[Ga>>2]=1;Ha=Gb;if(+U(+(+h[(sX(Ab,1,Ga)|0)>>3]))>1.0e-6){Ga=3360;c[Ha+0>>2]=c[Ga+0>>2];c[Ha+4>>2]=c[Ga+4>>2];c[Ha+8>>2]=c[Ga+8>>2]}else{Ga=3344;c[Ha+0>>2]=c[Ga+0>>2];c[Ha+4>>2]=c[Ga+4>>2];c[Ha+8>>2]=c[Ga+8>>2]}Ga=Hb;c[Ga+0>>2]=c[Ha+0>>2];c[Ga+4>>2]=c[Ha+4>>2];c[Ga+8>>2]=c[Ha+8>>2]}Ha=Fb;Ga=Hb;c[Ha+0>>2]=c[Ga+0>>2];c[Ha+4>>2]=c[Ga+4>>2];c[Ha+8>>2]=c[Ga+8>>2];c[Fa>>2]=3;lX(Ib,1,Fa);c[Ea>>2]=2;cc=+h[(sX(Ab,1,Ea)|0)>>3];c[Da>>2]=3;dc=cc*+h[(sX(Fb,1,Da)|0)>>3];c[Ca>>2]=3;cc=+h[(sX(Ab,1,Ca)|0)>>3];c[Ba>>2]=2;ac=dc-cc*+h[(sX(Fb,1,Ba)|0)>>3];c[Aa>>2]=3;cc=+h[(sX(Ab,1,Aa)|0)>>3];c[za>>2]=1;dc=cc*+h[(sX(Fb,1,za)|0)>>3];c[ya>>2]=1;cc=+h[(sX(Ab,1,ya)|0)>>3];c[xa>>2]=3;bc=dc-cc*+h[(sX(Fb,1,xa)|0)>>3];c[wa>>2]=1;cc=+h[(sX(Ab,1,wa)|0)>>3];c[va>>2]=2;dc=cc*+h[(sX(Fb,1,va)|0)>>3];c[ua>>2]=2;cc=+h[(sX(Ab,1,ua)|0)>>3];c[ta>>2]=1;ec=dc-cc*+h[(sX(Fb,1,ta)|0)>>3];ta=sa;h[k>>3]=bc;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];ta=sa+8|0;h[k>>3]=ec;c[ta>>2]=c[k>>2];c[ta+4>>2]=c[k+4>>2];rX(Jb,3,ac,sa);mX(Jb,Ib);c[ra>>2]=2;ac=+h[(sX(Ab,1,ra)|0)>>3];c[qa>>2]=3;ec=ac*+h[(sX(Fb,1,qa)|0)>>3];c[pa>>2]=3;ac=+h[(sX(Ab,1,pa)|0)>>3];c[oa>>2]=2;bc=ec-ac*+h[(sX(Fb,1,oa)|0)>>3];c[na>>2]=3;ac=+h[(sX(Ab,1,na)|0)>>3];c[ma>>2]=1;ec=ac*+h[(sX(Fb,1,ma)|0)>>3];c[la>>2]=1;ac=+h[(sX(Ab,1,la)|0)>>3];c[ka>>2]=3;cc=ec-ac*+h[(sX(Fb,1,ka)|0)>>3];c[ja>>2]=1;ac=+h[(sX(Ab,1,ja)|0)>>3];c[ia>>2]=2;ec=ac*+h[(sX(Fb,1,ia)|0)>>3];c[ha>>2]=2;ac=+h[(sX(Ab,1,ha)|0)>>3];c[ga>>2]=1;dc=ec-ac*+h[(sX(Fb,1,ga)|0)>>3];ga=fa;h[k>>3]=cc;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa+8|0;h[k>>3]=dc;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];rX(Kb,3,bc,fa);fa=Ib;ga=Kb;c[fa+0>>2]=c[ga+0>>2];c[fa+4>>2]=c[ga+4>>2];c[fa+8>>2]=c[ga+8>>2];c[ea>>2]=3;lX(Lb,1,ea);c[da>>2]=1;bc=+h[(sX(Ib,1,da)|0)>>3];c[ca>>2]=2;dc=+h[(sX(Ib,1,ca)|0)>>3];c[ba>>2]=3;cc=+h[(sX(Ib,1,ba)|0)>>3];c[aa>>2]=1;ac=+h[(sX(Ib,1,aa)|0)>>3];c[$>>2]=2;ec=+h[(sX(Ib,1,$)|0)>>3];c[_>>2]=3;fc=+h[(sX(Ib,1,_)|0)>>3];c[Z>>2]=1;gc=+h[(sX(Ib,1,Z)|0)>>3];c[Y>>2]=2;hc=+h[(sX(Ib,1,Y)|0)>>3];c[X>>2]=3;ic=+h[(sX(Ib,1,X)|0)>>3];c[W>>2]=1;jc=+h[(sX(Ib,1,W)|0)>>3]/+V(+(bc*bc+(dc*dc+cc*cc)));c[T>>2]=2;cc=+h[(sX(Ib,1,T)|0)>>3]/+V(+(ac*ac+(ec*ec+fc*fc)));c[S>>2]=3;fc=+h[(sX(Ib,1,S)|0)>>3]/+V(+(gc*gc+(hc*hc+ic*ic)));S=R;h[k>>3]=cc;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];S=R+8|0;h[k>>3]=fc;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];rX(Mb,3,jc,R);mX(Mb,Lb);c[Q>>2]=1;jc=+h[(sX(Ib,1,Q)|0)>>3];c[P>>2]=2;fc=+h[(sX(Ib,1,P)|0)>>3];c[O>>2]=3;cc=+h[(sX(Ib,1,O)|0)>>3];c[N>>2]=1;ic=+h[(sX(Ib,1,N)|0)>>3];c[M>>2]=2;hc=+h[(sX(Ib,1,M)|0)>>3];c[L>>2]=3;gc=+h[(sX(Ib,1,L)|0)>>3];c[K>>2]=1;ec=+h[(sX(Ib,1,K)|0)>>3];c[J>>2]=2;ac=+h[(sX(Ib,1,J)|0)>>3];c[I>>2]=3;dc=+h[(sX(Ib,1,I)|0)>>3];c[H>>2]=1;bc=+h[(sX(Ib,1,H)|0)>>3]/+V(+(jc*jc+(fc*fc+cc*cc)));c[G>>2]=2;cc=+h[(sX(Ib,1,G)|0)>>3]/+V(+(ic*ic+(hc*hc+gc*gc)));c[F>>2]=3;gc=+h[(sX(Ib,1,F)|0)>>3]/+V(+(ec*ec+(ac*ac+dc*dc)));F=E;h[k>>3]=cc;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];F=E+8|0;h[k>>3]=gc;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];rX(Nb,3,bc,E);E=Lb;F=Nb;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[D>>2]=1;uX(+h[(sX(Ab,1,D)|0)>>3],2,Pb);c[C>>2]=2;uX(+h[(sX(Ab,1,C)|0)>>3],2,Qb);c[B>>2]=3;uX(+h[(sX(Ab,1,B)|0)>>3],2,Rb);c[A>>2]=2;bc=+h[(sX(Lb,1,A)|0)>>3];c[z>>2]=3;gc=bc*+h[(sX(Ab,1,z)|0)>>3];c[y>>2]=3;bc=+h[(sX(Lb,1,y)|0)>>3];c[x>>2]=2;uX(gc-bc*+h[(sX(Ab,1,x)|0)>>3],2,Tb);c[w>>2]=3;bc=+h[(sX(Lb,1,w)|0)>>3];c[v>>2]=1;gc=bc*+h[(sX(Ab,1,v)|0)>>3];c[u>>2]=1;bc=+h[(sX(Lb,1,u)|0)>>3];c[t>>2]=3;uX(gc-bc*+h[(sX(Ab,1,t)|0)>>3],2,Ub);c[s>>2]=1;bc=+h[(sX(Lb,1,s)|0)>>3];c[r>>2]=2;gc=bc*+h[(sX(Ab,1,r)|0)>>3];c[q>>2]=2;bc=+h[(sX(Lb,1,q)|0)>>3];c[p>>2]=1;uX(gc-bc*+h[(sX(Ab,1,p)|0)>>3],2,Vb);c[o>>2]=1;uX(+h[(sX(Lb,1,o)|0)>>3],2,Xb);c[n>>2]=2;uX(+h[(sX(Lb,1,n)|0)>>3],2,Yb);c[m>>2]=3;uX(+h[(sX(Lb,1,m)|0)>>3],2,Zb);c[l>>2]=Qb;c[l+4>>2]=Rb;tX(2,Ob,3,Pb,l);c[j>>2]=Ub;c[j+4>>2]=Vb;tX(2,Sb,3,Tb,j);c[g>>2]=Yb;c[g+4>>2]=Zb;tX(2,Wb,3,Xb,g);c[f>>2]=Sb;c[f+4>>2]=Wb;tX(1,_b,3,Ob,f);mX(_b,zb);mX(zb,$b);$b=a;a=yb;c[$b+0>>2]=c[a+0>>2];c[$b+4>>2]=c[a+4>>2];c[$b+8>>2]=c[a+8>>2];i=b;return}function Tg(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;tW(4,0,3440,b);tW(4,0,3480,a);i=a;return}function Ug(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}Toa(a);c[d>>2]=0;i=b;return}function Vg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7024>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7e3>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7008>>3];h[a+8>>3]=+h[d+6912>>3];h[e+8>>3]=+h[d+6888>>3];h[f+8>>3]=+h[d+6896>>3];h[a+16>>3]=+h[d+7248>>3];h[e+16>>3]=+h[d+7224>>3];h[f+16>>3]=+h[d+7232>>3];h[a+24>>3]=+h[d+7136>>3];h[e+24>>3]=+h[d+7112>>3];h[f+24>>3]=+h[d+7120>>3];i=i;return}function Wg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0.0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;f=+h[b>>3];e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;g=e+496|0;h[g>>3]=f;j=+h[b+8>>3];k=e+488|0;h[k>>3]=j;l=+h[b+16>>3];m=e+512|0;h[m>>3]=l;n=+h[b+24>>3];b=e+504|0;h[b>>3]=n;e=c[a+416>>2]|0;a=e+360|0;o=e+368|0;p=e+376|0;q=e+384|0;h[d>>3]=f*+h[a>>3]+(l*+h[p>>3]-n*+h[q>>3]-j*+h[o>>3]);j=+h[k>>3];n=+h[g>>3];l=+h[b>>3];f=+h[m>>3];h[d+8>>3]=j*j+(n*n+(l*l+f*f))+-1.0;h[d+16>>3]=+h[m>>3]*+h[a>>3]+(+h[b>>3]*+h[o>>3]+(-(+h[k>>3]*+h[q>>3])- +h[g>>3]*+h[p>>3]));h[d+24>>3]=+h[m>>3]*+h[o>>3]+(+h[k>>3]*+h[p>>3]- +h[g>>3]*+h[q>>3])- +h[b>>3]*+h[a>>3];i=i;return}function Xg(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=a+4|0;a=c[c[f>>2]>>2]|0;g=c[a+8>>2]|0;j=c[a+12>>2]|0;l=+h[g+512>>3];m=+h[g+504>>3];n=+h[g+496>>3];o=+h[g+488>>3];p=+h[g+72>>3]+(-(+(c[j+12>>2]|0)*m)- +(c[j>>2]|0)*l- +(c[j+24>>2]|0)*n- +(c[j+36>>2]|0)*o);q=+h[g+88>>3]+(-(m*+(c[j+20>>2]|0))-l*+(c[j+8>>2]|0)-n*+(c[j+32>>2]|0)-o*+(c[j+44>>2]|0));a=d;h[k>>3]=+h[g+80>>3]+(-(m*+(c[j+16>>2]|0))-l*+(c[j+4>>2]|0)-n*+(c[j+28>>2]|0)-o*+(c[j+40>>2]|0));c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=q;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];rX(e,3,p,d);oX(e,(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+6592|0);i=b;return}function Yg(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7024>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7e3>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7008>>3];h[a+8>>3]=+h[d+7136>>3];h[e+8>>3]=+h[d+7112>>3];h[f+8>>3]=+h[d+7120>>3];h[a+16>>3]=+h[d+7248>>3];h[e+16>>3]=+h[d+7224>>3];h[f+16>>3]=+h[d+7232>>3];h[a+24>>3]=+h[d+6912>>3];h[e+24>>3]=+h[d+6888>>3];h[f+24>>3]=+h[d+6896>>3];i=i;return}function Zg(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0.0,k=0.0,l=0.0,m=0.0;e=i;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[g+496>>3]=+h[b>>3];h[g+504>>3]=+h[b+8>>3];h[g+512>>3]=+h[b+16>>3];h[g+488>>3]=+h[b+24>>3];Xg(a);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=+h[a+488>>3];k=+h[a+496>>3];l=+h[a+504>>3];m=+h[a+512>>3];h[d>>3]=j*j+(k*k+(l*l+m*m))+-1.0;h[d+8>>3]=+h[a+6592>>3];h[d+16>>3]=+h[a+6600>>3];h[d+24>>3]=+h[a+6608>>3];i=e;return}function _g(a){a=a|0;c[a+4>>2]=83;c[a>>2]=4;c[a+56>>2]=0;c[a+32>>2]=18;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=949;c[a+80>>2]=4;c[a+136>>2]=0;c[a+112>>2]=19;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;i=i;return}function $g(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=a+4|0;g=a+416|0;se[c[e>>2]&3](0,0,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+624>>3]*+h[(c[g>>2]|0)+1232>>3]),0,b);se[c[e>>2]&3](0,1,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+632>>3]*+h[(c[g>>2]|0)+1232>>3]),1,b);se[c[e>>2]&3](0,2,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+616>>3]*+h[(c[g>>2]|0)+1232>>3]),2,b);se[c[e>>2]&3](1,0,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3]*+h[(c[g>>2]|0)+1232>>3]),3,b);se[c[e>>2]&3](1,1,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+608>>3]*+h[(c[g>>2]|0)+1232>>3]),4,b);se[c[e>>2]&3](1,2,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+592>>3]*+h[(c[g>>2]|0)+1232>>3]),5,b);se[c[e>>2]&3](2,0,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+576>>3]*+h[(c[g>>2]|0)+1232>>3]),6,b);se[c[e>>2]&3](2,1,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3]*+h[(c[g>>2]|0)+1232>>3]),7,b);se[c[e>>2]&3](2,2,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3]*+h[(c[g>>2]|0)+1232>>3]),8,b);i=d;return}function ah(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=e+1e3|0;f=d+464|0;g=e+56|0;j=+h[g>>3];k=+h[d>>3];l=d+16|0;m=+h[l>>3];n=e+48|0;o=+h[n>>3];p=e+64|0;q=+h[p>>3];r=d+8|0;s=+h[r>>3];t=d+472|0;u=e+1232|0;e=c[b+36>>2]|0;h[e>>3]=+h[u>>3]*(+h[d+624>>3]*+h[a>>3]+(+h[f>>3]*j+(k*(m*o-k*q)+(-(s*(q*s-j*m))-o*+h[t>>3]))))- +h[d+560>>3];b=d+480|0;o=+h[n>>3];m=+h[l>>3];j=+h[r>>3];s=+h[p>>3];q=+h[g>>3];k=+h[d>>3];h[e+8>>3]=+h[u>>3]*(+h[d+600>>3]*+h[a>>3]+(+h[b>>3]*o+(m*(j*s-m*q)+(-(k*(q*k-o*j))-s*+h[f>>3]))))- +h[d+552>>3];s=+h[p>>3];j=+h[r>>3];o=+h[d>>3];k=+h[g>>3];q=+h[n>>3];m=+h[l>>3];h[e+16>>3]=+h[u>>3]*(+h[d+576>>3]*+h[a>>3]+(+h[t>>3]*s+(j*(o*k-j*q)+(-(m*(q*m-s*o))-k*+h[b>>3]))))- +h[d+544>>3];i=i;return}function bh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*2.0,0,b);se[c[e>>2]&3](0,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,1,b);se[c[e>>2]&3](0,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*2.0,2,b);se[c[e>>2]&3](0,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*-2.0,3,b);se[c[e>>2]&3](1,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,4,b);se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*-2.0,5,b);se[c[e>>2]&3](1,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*-2.0,6,b);se[c[e>>2]&3](1,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*-2.0,7,b);se[c[e>>2]&3](2,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*2.0,8,b);se[c[e>>2]&3](2,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*-2.0,9,b);se[c[e>>2]&3](2,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,10,b);se[c[e>>2]&3](2,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*2.0,11,b);se[c[e>>2]&3](3,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*2.0,12,b);se[c[e>>2]&3](3,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*2.0,13,b);se[c[e>>2]&3](3,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*-2.0,14,b);se[c[e>>2]&3](3,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,15,b);i=d;return}function ch(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[d>>3];h[a+8>>3]=0.0;h[a+16>>3]=-+h[d+16>>3];h[a+24>>3]=-+h[d+8>>3];i=i;return}function dh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*2.0,0,b);se[c[e>>2]&3](0,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,1,b);se[c[e>>2]&3](0,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*-2.0,2,b);se[c[e>>2]&3](0,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*2.0,3,b);se[c[e>>2]&3](1,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*-2.0,4,b);se[c[e>>2]&3](1,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*2.0,5,b);se[c[e>>2]&3](1,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,6,b);se[c[e>>2]&3](1,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*2.0,7,b);se[c[e>>2]&3](2,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*-2.0,8,b);se[c[e>>2]&3](2,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*-2.0,9,b);se[c[e>>2]&3](2,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*-2.0,10,b);se[c[e>>2]&3](2,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,11,b);se[c[e>>2]&3](3,0,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+512>>3]*-2.0,12,b);se[c[e>>2]&3](3,1,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+504>>3]*-2.0,13,b);se[c[e>>2]&3](3,2,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+496>>3]*2.0,14,b);se[c[e>>2]&3](3,3,+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+488>>3]*2.0,15,b);i=d;return}function eh(a,b){a=a|0;b=b|0;var d=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=-+h[d+8>>3];h[a+8>>3]=-+h[d+16>>3];h[a+16>>3]=0.0;h[a+24>>3]=-+h[d>>3];i=i;return}function fh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=a+4|0;g=a+416|0;se[c[e>>2]&3](0,0,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+632>>3]*+h[(c[g>>2]|0)+1232>>3]),0,b);se[c[e>>2]&3](0,1,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+616>>3]*+h[(c[g>>2]|0)+1232>>3]),1,b);se[c[e>>2]&3](0,2,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+624>>3]*+h[(c[g>>2]|0)+1232>>3]),2,b);se[c[e>>2]&3](1,0,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+584>>3]*+h[(c[g>>2]|0)+1232>>3]),3,b);se[c[e>>2]&3](1,1,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+568>>3]*+h[(c[g>>2]|0)+1232>>3]),4,b);se[c[e>>2]&3](1,2,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+576>>3]*+h[(c[g>>2]|0)+1232>>3]),5,b);se[c[e>>2]&3](2,0,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+608>>3]*+h[(c[g>>2]|0)+1232>>3]),6,b);se[c[e>>2]&3](2,1,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+592>>3]*+h[(c[g>>2]|0)+1232>>3]),7,b);se[c[e>>2]&3](2,2,-(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+600>>3]*+h[(c[g>>2]|0)+1232>>3]),8,b);i=d;return}function gh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=c[a+416>>2]|0;a=e+1e3|0;f=d+464|0;g=e+56|0;j=+h[g>>3];k=+h[d>>3];l=d+16|0;m=+h[l>>3];n=e+48|0;o=+h[n>>3];p=e+64|0;q=+h[p>>3];r=d+8|0;s=+h[r>>3];t=d+472|0;u=e+1232|0;e=c[b+36>>2]|0;h[e>>3]=+h[u>>3]*(+h[d+624>>3]*+h[a>>3]+(+h[f>>3]*j+(k*(m*o-k*q)+(-(s*(q*s-j*m))-o*+h[t>>3]))))- +h[d+560>>3];o=+h[p>>3];m=+h[r>>3];j=+h[d>>3];s=+h[g>>3];q=+h[n>>3];k=+h[l>>3];b=d+480|0;h[e+8>>3]=+h[u>>3]*(+h[d+576>>3]*+h[a>>3]+(+h[t>>3]*o+(m*(j*s-m*q)+(-(k*(q*k-o*j))-s*+h[b>>3]))))- +h[d+544>>3];s=+h[n>>3];j=+h[l>>3];o=+h[r>>3];k=+h[p>>3];q=+h[g>>3];m=+h[d>>3];h[e+16>>3]=+h[u>>3]*(+h[d+600>>3]*+h[a>>3]+(+h[b>>3]*s+(j*(o*k-j*q)+(-(m*(q*m-s*o))-k*+h[f>>3]))))- +h[d+552>>3];i=i;return}function hh(a){a=a|0;c[a+20>>2]=107;c[a+16>>2]=3;c[a+12>>2]=9;c[a>>2]=45;c[a+4>>2]=46;c[a+84>>2]=112;c[a+80>>2]=4;c[a+76>>2]=16;c[a+64>>2]=47;c[a+68>>2]=48;c[a+148>>2]=952;c[a+144>>2]=4;c[a+140>>2]=16;c[a+128>>2]=49;c[a+132>>2]=50;c[a+212>>2]=994;c[a+208>>2]=3;c[a+204>>2]=9;c[a+192>>2]=51;c[a+196>>2]=52;i=i;return}function ih(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=4;c[a+4>>2]=3;c[a+8>>2]=1;e=Uoa(3,36)|0;c[a+28>>2]=e;f=b+8|0;g=c[f>>2]|0;c[e>>2]=g+1008;c[e+4>>2]=g+1120;c[e+8>>2]=g+1232;g=Uoa(4,36)|0;c[a+32>>2]=g;e=c[f>>2]|0;c[g>>2]=e+7168;c[g+4>>2]=e+7056;c[g+8>>2]=e+6944;c[g+12>>2]=e+6832;c[a+12>>2]=c[b+12>>2];c[a+16>>2]=Uoa(1,4)|0;c[a+20>>2]=Uoa(4,4)|0;c[a+24>>2]=Uoa(4,8)|0;c[a+36>>2]=100;c[a+40>>2]=101;c[a+44>>2]=0;i=d;return}function jh(a){a=a|0;i=i;return}function kh(a,b){a=a|0;b=b|0;c[b>>2]=0;i=i;return 3528}function lh(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return 0}function mh(a){a=a|0;i=i;return 3528}function nh(a,b){a=a|0;b=b|0;i=i;return 0}function oh(a){a=a|0;a=i;i=i+8|0;tW(8,1,3536,a);if((c[35856>>2]|0)==0){i=a;return 0}fe[c[9094]&255](8);i=a;return 0}function ph(a){a=a|0;i=i;return c[3976+(a<<2)>>2]|0}function qh(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+8|0;tW(21,1,3992,j);j=a+4|0;l=c[(c[c[j>>2]>>2]|0)+8>>2]|0;m=a+416|0;a=c[m>>2]|0;n=+h[l+496>>3]*+h[a+360>>3]+(+h[l+512>>3]*+h[a+376>>3]- +h[l+504>>3]*+h[a+384>>3]- +h[l+488>>3]*+h[a+368>>3]);h[b>>3]=n;a=ph(0)|0;c[g>>2]=1;c[g+4>>2]=a;a=g+8|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];tW(21,0,4024,g);g=c[(c[c[j>>2]>>2]|0)+8>>2]|0;a=c[m>>2]|0;n=+h[g+512>>3]*+h[a+368>>3]+(+h[g+488>>3]*+h[a+376>>3]- +h[g+496>>3]*+h[a+384>>3])- +h[g+504>>3]*+h[a+360>>3];h[b+8>>3]=n;a=ph(1)|0;c[f>>2]=2;c[f+4>>2]=a;a=f+8|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];tW(21,0,4024,f);f=c[(c[c[j>>2]>>2]|0)+8>>2]|0;j=c[m>>2]|0;n=+h[f+512>>3]*+h[j+360>>3]+(+h[f+504>>3]*+h[j+368>>3]+(-(+h[f+488>>3]*+h[j+384>>3])- +h[f+496>>3]*+h[j+376>>3]));h[b+16>>3]=n;b=ph(2)|0;c[e>>2]=3;c[e+4>>2]=b;b=e+8|0;h[k>>3]=n;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];tW(21,0,4024,e);if((c[35908>>2]|0)==0){i=d;return 0}fe[c[9094]&255](21);i=d;return 0}function rh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1584>>3]=+h[b+1552>>3];i=i;return}function sh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1576>>3]=+h[b+1544>>3];i=i;return}function th(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+1472>>3];i=i;return}function uh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+1464>>3];i=i;return}function vh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,3);h[(c[a+416>>2]|0)+384>>3]=l;i=b;return}function wh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,2);h[(c[a+416>>2]|0)+376>>3]=l;i=b;return}function xh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,1);h[(c[a+416>>2]|0)+368>>3]=l;i=b;return}function yh(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=4040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=4056;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Qg(f,g,e,d);l=+iX(f,0);h[(c[a+416>>2]|0)+360>>3]=l;i=b;return}function zh(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1104>>3]=+h[b+1024>>3]*.1;i=i;return}function Ah(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1104>>3];i=i;return}function Bh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5824>>3]=+h[(c[a+416>>2]|0)+408>>3];i=i;return}function Ch(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=+h[(c[a+416>>2]|0)+400>>3];i=i;return}function Dh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5808>>3]=+h[(c[a+416>>2]|0)+392>>3];i=i;return}function Eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5752>>3]=+h[b+5824>>3]+ +h[(c[a+416>>2]|0)+504>>3];i=i;return}function Fh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5744>>3]=+h[b+5816>>3]+ +h[(c[a+416>>2]|0)+496>>3];i=i;return}function Gh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5736>>3]=+h[b+5808>>3]+ +h[(c[a+416>>2]|0)+488>>3];i=i;return}function Hh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+48>>3]=.3;i=i;return}function Ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+48>>3]- +h[b+5808>>3];i=i;return}function Jh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+248>>3]=+h[b+48>>3]- +h[b+5808>>3];i=i;return}function Kh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+56>>3]=-.2;i=i;return}function Lh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+376>>3]=+h[b+56>>3]- +h[b+5816>>3];i=i;return}function Mh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+256>>3]=+h[b+56>>3]- +h[b+5816>>3];i=i;return}function Nh(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+64>>3]=0.0;i=i;return}function Oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+384>>3]=+h[b+64>>3]- +h[b+5824>>3];i=i;return}function Ph(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+368>>3];e=+h[b+376>>3];f=+h[b+384>>3];h[b+6224>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Qh(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6216>>3]=+h[b+1576>>3]*(+h[d+6224>>3]- +h[b+1584>>3]);i=i;return}function Rh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[b+416>>2]|0)+1616>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+368>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+344|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+344|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,4080,4072,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+344|0;q=p;h[q>>3]=n;i=d;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=-(+h[b+344>>3]*+h[b+6216>>3]);i=i;return}function Th(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[b+416>>2]|0)+1616>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+384>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,4080,4192,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+360|0;q=p;h[q>>3]=n;i=d;return}function Uh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+432>>3]=-(+h[b+360>>3]*+h[b+6216>>3]);i=i;return}function Vh(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],+h[(c[b+416>>2]|0)+1616>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+376>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,4080,4200,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+352|0;q=p;h[q>>3]=n;i=d;return}function Wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+424>>3]=-(+h[b+352>>3]*+h[b+6216>>3]);i=i;return}function Xh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+264>>3]=+h[b+64>>3]- +h[b+5824>>3];i=i;return}function Yh(a){a=a|0;var b=0,d=0,e=0.0,f=0.0,g=0.0,j=0.0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;e=+h[d+248>>3];f=+h[d+256>>3];g=+h[d+264>>3];j=+V(+(e*e+f*f+g*g));h[d+6200>>3]=+td(+j,+(+h[(c[a+416>>2]|0)+1624>>3]));i=b;return}function Zh(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6184>>3]=+sd(+(+h[(c[a+416>>2]|0)+1648>>3]),+(+h[d+6200>>3]));i=b;return}function _h(a){a=a|0;var b=0,d=0;b=i;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6176>>3]=+td(+(+h[d+6200>>3]- +h[(c[a+416>>2]|0)+1648>>3]),0.0);i=b;return}function $h(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6200>>3];k=+h[g+248>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}q=k/+zW(c[b+536>>2]|0,j,4216,4208,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+272|0;p=o;h[p>>3]=m;i=d;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+224>>3]=+h[b+272>>3]*+h[b+6184>>3];i=i;return}function bi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6200>>3];k=+h[g+256>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+280|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+280|0;p=o;h[p>>3]=m;i=d;return}q=k/+zW(c[b+536>>2]|0,j,4216,4232,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+280|0;p=o;h[p>>3]=m;i=d;return}function ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+280>>3]*+h[b+6184>>3];i=i;return}function di(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+6200>>3];k=+h[g+264>>3];if(j!=0.0){l=g;m=k/j;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=g;m=k;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}q=k/+zW(c[b+536>>2]|0,j,4216,4240,+h[f>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+288|0;p=o;h[p>>3]=m;i=d;return}function ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+288>>3]*+h[b+6184>>3];i=i;return}function fi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=0.0;i=i;return}function gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+24>>3];i=i;return}function hi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=0.0;i=i;return}function ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+32>>3];i=i;return}function ji(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=0.0;i=i;return}function ki(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0;d=i;e=b+4|0;f=c[(c[c[e>>2]>>2]|0)+8>>2]|0;g=+h[f+248>>3];j=+h[f+256>>3];k=+h[f+264>>3];l=+V(+(g*g+j*j+k*k));do{if((DZ(l,+h[(c[b+416>>2]|0)+1624>>3])|0)<<24>>24==0){m=0.0}else{f=c[c[e>>2]>>2]|0;n=c[f+8>>2]|0;k=+h[n+248>>3];j=+h[n+256>>3];g=+h[n+264>>3];o=+V(+(k*k+j*j+g*g))*2.0;p=+h[n+24>>3];q=+h[n+32>>3];r=+h[n+40>>3];s=k*(p+p)+j*(q+q)+g*(r+r);if(o!=0.0){m=s/o;break}if(s==0.0){m=s;break}m=s/+zW(c[b+536>>2]|0,o,4256,4248,+h[f>>3],(a[b+319|0]|0)!=0|0)}}while(0);h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+6256>>3]=m;i=d;return}function li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6208>>3]=+h[(c[a+416>>2]|0)+1640>>3]*+h[b+6256>>3];i=i;return}function mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=-(+h[b+288>>3]*+h[b+6208>>3]);i=i;return}function ni(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=-+h[b+432>>3]- +h[b+336>>3];i=i;return}function oi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+328>>3]=-(+h[b+280>>3]*+h[b+6208>>3]);i=i;return}function pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+320>>3]=-(+h[b+272>>3]*+h[b+6208>>3]);i=i;return}function qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+664>>3]=-+h[b+416>>3]- +h[b+320>>3];i=i;return}function ri(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+648>>3]=+h[b+408>>3]*+h[d+664>>3]- +h[b+392>>3]*+h[d+680>>3];i=i;return}function si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6192>>3]=+h[b+6208>>3]*+h[b+6256>>3];i=i;return}function ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+176>>3]=+h[b+40>>3];i=i;return}function ui(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+96>>3];i=i;return}function vi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+104>>3];i=i;return}function wi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+112>>3];i=i;return}function xi(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+104>>3]=.1;i=i;return}function yi(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(DZ(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+104>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+6248|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+104>>3];g=e;j=g+6248|0;k=j;h[k>>3]=f;i=b;return}function zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+456>>3]=+h[b+5744>>3]- +h[b+104>>3];i=i;return}function Ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+856>>3]=+h[b+456>>3]- +h[b+5744>>3];i=i;return}function Bi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+856>>3];h[b+6240>>3]=+V(+(d*d));i=i;return}function Ci(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+6232>>3]=+h[b+1496>>3]*(+h[d+6240>>3]- +h[b+1504>>3]);i=i;return}function Di(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0.0;d=i;i=i+8|0;e=d;f=b+536|0;g=b+4|0;Rg(e,c[f>>2]|0,+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6240>>3],+h[(c[b+416>>2]|0)+1536>>3]);j=+h[e>>3];e=c[c[g>>2]>>2]|0;k=c[e+8>>2]|0;l=+h[k+856>>3];if(j!=0.0){m=k;n=l/j;o=m;p=o+832|0;q=p;h[q>>3]=n;i=d;return}if(l==0.0){m=k;n=l;o=m;p=o+832|0;q=p;h[q>>3]=n;i=d;return}r=l/+zW(c[f>>2]|0,j,4400,4392,+h[e>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[g>>2]>>2]|0)+8>>2]|0;n=r;o=m;p=o+832|0;q=p;h[q>>3]=n;i=d;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+784>>3]=+h[b+832>>3]*+h[b+6232>>3];i=i;return}function Fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=-(+h[(c[a+416>>2]|0)+584>>3]*+h[b+784>>3]);i=i;return}function Gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+448>>3]=+h[(c[a+416>>2]|0)+600>>3]*+h[b+784>>3];i=i;return}function Hi(b){b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0,k=0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=c[b+416>>2]|0;f=-+h[e+1e3>>3];g=+h[e+1368>>3];e=b+4|0;j=c[c[e>>2]>>2]|0;k=c[j+8>>2]|0;l=+h[k+784>>3];if(g!=0.0){m=k;n=l/g;o=f-n;p=m;q=p+936|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=k;n=l;o=f-n;p=m;q=p+936|0;r=q;h[r>>3]=o;i=d;return}s=l/+zW(c[b+536>>2]|0,g,4520,4512,+h[j>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=f-n;p=m;q=p+936|0;r=q;h[r>>3]=o;i=d;return}function Ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=-+h[b+936>>3];i=i;return}function Ji(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+808>>3]=-(+h[b+832>>3]*+h[b+6232>>3]);i=i;return}function Ki(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+720>>3]=+h[(c[a+416>>2]|0)+504>>3]*+h[b+808>>3]- +h[b+448>>3];i=i;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=-(+h[(c[a+416>>2]|0)+488>>3]*+h[b+808>>3])- +h[b+440>>3];i=i;return}function Mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+672>>3]=-+h[b+328>>3]- +h[b+808>>3]- +h[b+424>>3];i=i;return}function Ni(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+640>>3]=+h[b+400>>3]*+h[d+680>>3]+(+h[d+720>>3]- +h[b+408>>3]*+h[d+672>>3]);i=i;return}function Oi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+656>>3]=+h[b+392>>3]*+h[d+672>>3]+(+h[d+736>>3]- +h[b+400>>3]*+h[d+664>>3]);i=i;return}function Pi(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+496>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+496|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+b_(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+496>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+488>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+488|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+b_(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+488>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+512>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+512|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+b_(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+512>>3]);g=c[f>>2]|0;h[(c[g+52>>2]|0)+16>>3]=k;e=c[d>>2]|0;h[(c[g+44>>2]|0)+24>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+504>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+504|0;h[(c[g+48>>2]|0)+24>>3]=+h[j>>3];k=+b_(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+504>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+24>>3]=k;$Z(a,0)|0;a=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+496>>3]=+h[a>>3];h[f+488>>3]=+h[a+8>>3];h[f+512>>3]=+h[a+16>>3];h[f+504>>3]=+h[a+24>>3];i=b;return}function Qi(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+496>>3];e=+h[b+512>>3];h[b+600>>3]=(d*d+e*e)*2.0+-1.0;i=i;return}function Ri(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+504>>3];e=+h[b+512>>3];h[b+632>>3]=(d*d+e*e)*2.0+-1.0;i=i;return}function Si(a){a=a|0;var b=0,d=0.0,e=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+488>>3];e=+h[b+512>>3];h[b+568>>3]=(d*d+e*e)*2.0+-1.0;i=i;return}function Ti(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+576>>3]=(+h[b+488>>3]*+h[b+496>>3]+ +h[b+504>>3]*+h[b+512>>3])*2.0;i=i;return}function Ui(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+584>>3]=(+h[b+488>>3]*+h[b+504>>3]- +h[b+496>>3]*+h[b+512>>3])*2.0;i=i;return}function Vi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+6216>>3];h[b+392>>3]=+h[b+568>>3]*+h[b+344>>3]*d+(+h[b+576>>3]*d*+h[b+352>>3]+ +h[b+584>>3]*d*+h[b+360>>3]);i=i;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+296>>3]=-(+h[b+584>>3]*+h[b+336>>3])- +h[b+576>>3]*+h[b+328>>3]- +h[b+568>>3]*+h[b+320>>3];i=i;return}function Xi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=-+h[b+392>>3]- +h[b+296>>3];i=i;return}function Yi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=(+h[b+496>>3]*+h[b+488>>3]- +h[b+504>>3]*+h[b+512>>3])*2.0;i=i;return}function Zi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+608>>3]=(+h[b+496>>3]*+h[b+504>>3]+ +h[b+488>>3]*+h[b+512>>3])*2.0;i=i;return}



function $U(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};case 60:case 0:{break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==15360){if((a[b+73|0]|0)==4){p=16}else{if((a[b+73|0]|0)==3){p=16}}if((p|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==61371){if((e|0)==1){o=a[b+73|0]|0;if((o|0)==0|(o|0)==4|(o|0)==5|(o|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function aV(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((cV(bV(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((cV(bV(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=bV(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((cV(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=bV(k,a,b)|0;n=h;}while((cV(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=bV(k,a,b)|0;while(1){if((cV(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=bV(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=bV(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function bV(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function cV(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function dV(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function eV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 12:{c[h>>2]=14;j=1;break};case 14:{j=0;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,33728)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 29:{c[h>>2]=16;j=2;break};case 11:{c[h>>2]=14;j=55;break};case 15:{c[h>>2]=14;j=0;break};case 13:{c[h>>2]=14;j=56;break};default:{k=10}}}while(0);if((k|0)==10){j=iV(h,a)|0}i=g;return j|0}function fV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 26:{j=9;break};case 33:{c[h>>2]=17;k=0;break};case-4:{if((c[h+12>>2]|0)!=0){j=9;break a}k=0;break};case 34:{if((c[h+12>>2]|0)==0){j=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;k=0;break};case 15:{k=0;break};default:{k=hV(h,a,d,e,f)|0}}}while(0);if((j|0)==9){k=iV(h,a)|0}i=g;return k|0}function gV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=0;l=k;i=g;return l|0}do{if((j|0)==3){if((He[c[e+28>>2]&63](e,b,d,33712)|0)!=0){c[h>>2]=18;k=0;l=k;i=g;return l|0}if((He[c[e+28>>2]&63](e,b,d,33720)|0)==0){break}c[h>>2]=19;k=0;l=k;i=g;return l|0}}while(0);k=iV(h,a)|0;l=k;i=g;return l|0}function hV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 13:{j=56;k=j;i=g;return k|0};case 15:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 16:{if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33488)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33496)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33504)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,33512)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};default:{}}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function iV(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function jV(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function kV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=26;g=9}else{g=iV(e,a)|0}i=f;return g|0}function lV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=iV(e,a)|0}i=f;return g|0}function mV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=iV(e,a)|0}i=f;return g|0}function nV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=iV(e,a)|0}i=f;return g|0}function oV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==17){c[e>>2]=30;g=8}else{g=iV(e,a)|0}i=f;return g|0}function pV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==29){c[e>>2]=16;g=2}else if((b|0)==11){g=55}else if((b|0)==13){g=56}else{g=iV(e,a)|0}i=f;return g|0}function qV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=17;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((He[c[e+28>>2]&63](e,b,d,33528)|0)!=0){c[h>>2]=31;j=17;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,33536)|0)==0){break}c[h>>2]=32;j=17;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function rV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=iV(e,a)|0}i=f;return g|0}function sV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=iV(e,a)|0}i=f;return g|0}function tV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else{g=iV(e,a)|0}i=f;return g|0}function uV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=iV(e,a)|0;h=g;i=f;return h|0}return 0}function vV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,33544)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,33552)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function wV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 32:{c[h>>2]=40;j=54;break};case 31:{c[h>>2]=40;j=52;break};case 15:{j=39;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 20:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,33560)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};case 30:{c[h>>2]=40;j=53;break};default:{k=10}}}while(0);if((k|0)==10){j=iV(h,a)|0}i=g;return j|0}function xV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=iV(e,a)|0}i=f;return g|0}function yV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 31:{c[e>>2]=40;g=52;break};case 15:{g=39;break};case 30:{c[e>>2]=40;g=53;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 32:{c[e>>2]=40;g=54;break};default:{g=iV(e,a)|0}}i=f;return g|0}function zV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 15:{g=39;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};default:{g=iV(e,a)|0;h=g;i=f;return h|0}}return 0}function AV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else if((b|0)==15){g=39}else{g=iV(e,a)|0}i=f;return g|0}function BV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else if((b|0)==21){c[e>>2]=41;g=39}else{g=iV(e,a)|0}i=f;return g|0}function CV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else{g=iV(e,a)|0}i=f;return g|0}function DV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==23){c[h>>2]=46;j=33;k=j;i=g;return k|0}else if((f|0)==18){l=0;while(1){m=c[e+28>>2]|0;n=e;o=b;p=d;if((l|0)>=8){break}if((He[m&63](n,o,p,c[33568+(l<<2)>>2]|0)|0)!=0){q=6;break}l=l+1|0}if((q|0)==6){c[h>>2]=44;j=23+l|0;k=j;i=g;return k|0}if((He[m&63](n,o,p,33512)|0)==0){break}c[h>>2]=45;j=33;k=j;i=g;return k|0}else if((f|0)==15){j=33;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function EV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,33672)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,33680)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,33696)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function FV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==23){c[e>>2]=48;g=33}else if((b|0)==15){g=33}else{g=iV(e,a)|0}i=f;return g|0}function GV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=iV(e,a)|0}i=f;return g|0}function HV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=46;g=33}else{g=iV(e,a)|0}i=f;return g|0}function IV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==18){c[e>>2]=50;g=32}else{g=iV(e,a)|0}i=f;return g|0}function JV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=48;g=33}else{g=iV(e,a)|0}i=f;return g|0}function KV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==27){c[e>>2]=27;g=38}else{g=iV(e,a)|0}i=f;return g|0}function LV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=iV(e,a)|0}i=f;return g|0}function MV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,33528)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,33536)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function NV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=54;g=13}else if((b|0)==15){g=11}else{g=iV(e,a)|0}i=f;return g|0}function OV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=52;g=14}else if((b|0)==15){g=11}else{g=iV(e,a)|0}i=f;return g|0}function PV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,33704)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function QV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else{g=iV(e,a)|0}i=f;return g|0}function RV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,33528)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,33536)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function SV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=iV(e,a)|0}i=f;return g|0}function TV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=iV(e,a)|0}i=f;return g|0}function UV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=iV(e,a)|0;h=g;i=f;return h|0}return 0}function VV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;d=e+12|0;c[d>>2]=(c[d>>2]|0)+1;g=0;h=g;i=f;return h|0}else if((b|0)==15){g=0;h=g;i=f;return h|0}else{g=iV(e,a)|0;h=g;i=f;return h|0}return 0}function WV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==25){c[e>>2]=36;g=58}else{g=iV(e,a)|0}i=f;return g|0}function XV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 11:{j=55;break};case 13:{j=56;break};case 14:{j=0;break};case 15:{j=0;break};case 29:{c[h>>2]=16;j=2;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,33728)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};default:{k=9}}}while(0);if((k|0)==9){j=iV(h,a)|0}i=g;return j|0}function YV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=iV(e,a)|0}i=f;return g|0}function ZV(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,33528)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,33536)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}}while(0);j=iV(h,a)|0;k=j;i=g;return k|0}function _V(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=3}else if((b|0)==27){c[e>>2]=62;g=5}else{g=iV(e,a)|0}i=f;return g|0}function $V(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=iV(e,a)|0}i=f;return g|0}function aW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=iV(e,a)|0}i=f;return g|0}function bW(){i=i;return}function cW(){i=i;return}function dW(){var a=0;a=i;Wa(33736,0)|0;i=a;return}function eW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(33744,29,1,e|0)|0;ud(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(33776,54,1,g|0)|0;ud(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(33832,47,1,a|0)|0;ud(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;wd(k|0,33880,d|0)|0;ud(k|0)|0;f=0;i=b;return f|0}function fW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;wd(j|0,33944,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;wd(n|0,33976,e|0)|0;k=0;i=d;return k|0}function gW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function hW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=OW(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function iW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=OW(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function jW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[21290]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=34032;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ie[p&31](0,f,34056,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function kW(){var a=0,b=0,d=0;a=i;b=35824|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=35936|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=36048|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[35828>>2]=1;c[35832>>2]=1;i=a;return}function lW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?36184:36200;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;wd(a|0,36160,e|0)|0;i=d;return}function mW(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=36048+(d<<2)|0;o=35936+(d<<2)|0;p=36248+(b<<2)|0;q=34528+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=36232;gc(36216,l|0)|0;s=36232}else{if((c[8952]|0)==(d|0)){if((c[o>>2]|0)>0){t=36232}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;gc(36216,m|0)|0;do{if((c[8952]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=36232;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;gc(36240,k|0)|0;c[n>>2]=b;c[8952]=d;if((c[o>>2]|0)>0){g=0;while(1){gc(36272,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==0){break a}else if(g<<24>>24==10){break}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;ud(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function nW(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[36248+(a<<2)>>2]|0;c[j>>2]=c[34528+(b<<2)>>2];c[j+4>>2]=k;gc(36280,j|0)|0;oW(e);if((g|0)==0){Kd(((d|0)!=0?36320:36368)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}tb(36448)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];gc(36328,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}rc(36352,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}function oW(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==60){rc(36400,4,1,e|0)|0}else if(b<<24>>24==0){break}else if(b<<24>>24==62){rc(36408,4,1,e|0)|0}else if(b<<24>>24==38){rc(36392,5,1,e|0)|0}else{Sd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function pW(a){a=a|0;var b=0;b=35936+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function qW(a){a=a|0;var b=0;b=(a|0)==0;c[9096]=b?1:19;c[9094]=b?7:164;i=i;return}function rW(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(36352,11,1,b|0)|0;ud(b|0)|0;i=a;return}function sW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[35824+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Zc(j|0,2048,e|0,h|0)|0;re[c[9096]&31](1,a,b,j,0,d);i=g;return}function tW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[35824+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[9096]&31](1,a,b,h,0,0);i=f;return}function uW(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[8954]|0)==0){if((c[35824+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Zc(k|0,2048,e|0,j|0)|0;re[c[9096]&31](2,a,b,k,0,d);i=g;return}function vW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[8954]|0)==0){if((c[35824+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Zc(j|0,2048,d|0,h|0)|0;re[c[9096]&31](2,a,b,j,0,0);i=f;return}function wW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Zc(b|0,2048,d|0,g|0)|0;re[c[9096]&31](4,2,0,b,0,0);if((a|0)==0){h=md(c[8434]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function xW(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Zc(g|0,2048,b|0,f|0)|0;re[c[9096]&31](5,2,0,g,0,0);if((a|0)==0){h=md(c[8434]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function yW(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[9096]&31](5,2,0,h,0,b);if((a|0)==0){j=md(c[8434]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function zW(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;yW(a,e,36520,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;uW(26,0,e,36456,m);i=j;return+b}return 0.0}function AW(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=Soa(16)|0;wW(0,(d|0)!=0|0,36568,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function BW(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;Toa(c[f>>2]|0);Toa(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function CW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;wW(0,(a|0)!=0|0,36584,f);f=Soa(8)|0;g=f;wW(0,(f|0)!=0|0,36568,e);e=a+8|0;h=Soa(c[e>>2]|0)|0;c[f>>2]=h;wW(0,(h|0)!=0|0,36568,d);wpa(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function DW(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;wW(0,(a|0)!=0|0,36584,f);f=Soa(8)|0;g=f;wW(0,(f|0)!=0|0,36568,e);e=a+8|0;h=Soa(c[e>>2]|0)|0;c[f>>2]=h;wW(0,(h|0)!=0|0,36568,d);wpa(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function EW(a){a=a|0;var b=0;b=i;i=i+8|0;wW(0,(a|0)!=0|0,36584,b);i=b;return c[a+12>>2]|0}function FW(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;wW(0,(a|0)!=0|0,36584,d);d=a;wW(0,(c[d>>2]|0)!=0|0,36608,b);i=b;return c[c[d>>2]>>2]|0}function GW(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;Toa(c[e>>2]|0);Toa(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function HW(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;wW(0,(a|0)!=0|0,36584,d);d=a;wW(0,(c[d>>2]|0)!=0|0,36624,b);i=b;return c[d>>2]|0}function IW(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;wW(0,d&1,36656,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function JW(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;wW(0,(a|0)!=0|0,36656,d);d=a;wW(0,(c[d>>2]|0)!=0|0,36680,b);i=b;return c[d>>2]|0}function KW(){var a=0,b=0,d=0;a=i;b=Soa(16)|0;c[9188]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=Soa(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function LW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=PW(a)|0;tc(36760)|0;QW(d);a=c[9188]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;fc(36760)|0;ypa(g|0,0,d|0)|0;i=b;return g|0}function MW(){var a=0,b=0,d=0,e=0;a=i;b=c[9188]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;Toa(c[b>>2]|0);Toa(b);if((d|0)==0){break}else{b=d}}e=c[9188]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function NW(a){a=a|0;var b=0,d=0;b=i;d=ie[c[36712>>2]&127](a<<3)|0;i=b;return d|0}function OW(a){a=a|0;var b=0,d=0;b=i;d=ie[c[36712>>2]&127](a<<2)|0;i=b;return d|0}function PW(a){a=a|0;i=i;return a+7&-8|0}function QW(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[9188]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=Soa(16)|0;c[f+12>>2]=d;c[9188]=f;c[f+4>>2]=0;d=RW((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=Soa(d)|0;c[f>>2]=a;i=b;return}function RW(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function SW(a){a=a|0;var b=0,c=0;b=i;c=upa(a|0)|0;i=b;return c|0}function TW(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;Apa(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(m|0,l|0,f|0)|0;f=UW(m)|0;i=e;return f|0}function UW(a){a=a|0;var b=0,c=0,d=0;b=i;c=upa(a|0)|0;d=WW(c)|0;wpa(d|0,a|0,c|0)|0;i=b;return d|0}function VW(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;Apa(g+1|0,d|0)|0;c[f>>2]=b;hc(k|0,j|0,f|0)|0;f=UW(k)|0;i=e;return f|0}function WW(b){b=b|0;var d=0,e=0;d=i;e=ie[c[36716>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function XW(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=SW(a)|0;e=SW(b)|0;f=WW(e+d|0)|0;wpa(f|0,a|0,d|0)|0;wpa(f+d|0,b|0,e|0)|0;i=c;return f|0}function YW(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=qpa(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function ZW(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 0:{f=8;break a;break};case 1:{f=4;break a;break};case 4:{f=2;break a;break};case 5:{f=1;break a;break};case 3:{f=2;break a;break};case 2:{f=4;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function _W(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Yc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){Toa(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{Toa(c[(c[f>>2]|0)+(g<<4)>>2]|0);Toa(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;Toa(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){Toa(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{Toa(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}Toa(d);c[g>>2]=0;i=b;return}function $W(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(upa(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function aX(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ic(b|0,36944)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Wd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Ad(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=36952;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[36920+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=36976;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=37e3;E=131;break}G=ZW(D)|0;if((G|0)==-1){n=37032;E=131;break}D=c[q>>2]|0;H=Soa(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=37080;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=37104;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((qpa(H,c[36896+(C<<2)>>2]|0)|0)!=0){n=37128;E=131;break}Toa(H);H=37704;b:do{switch(C|0){case 0:{if((D|0)!=4){n=37152;E=131;break a}if((I|0)!=11){n=37192;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){K=0}else{n=37232;E=131;break a}while(1){F=0;do{a[k+F|0]=a[j+((F<<2)+K)|0]|0;F=F+1|0;}while(F>>>0<11);a[k+11|0]=0;if((K|0)==3){break}F=K+1|0;if(F>>>0<4){K=F}else{L=d;E=130;break b}}if((rpa(t,c[9200]|0,8)|0)==0){L=1;E=130;break b}if((rpa(t,c[9206]|0,9)|0)==0){L=0;E=130}else{n=37264;E=131;break a}break};case 1:{F=d<<24>>24==0;c[u>>2]=F?D:I;G=Soa((F?D:I)<<4)|0;c[v>>2]=G;c:do{if(d<<24>>24==1){if((I|0)==0){M=0;break}N=D+1|0;O=G;P=0;while(1){c[O+(P<<4)>>2]=Soa(N)|0;if((sb(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=37328;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;Q=c[v>>2]|0;c[Q+(P<<4)+8>>2]=-1;c[Q+(P<<4)+12>>2]=-1;$W(c[Q+(P<<4)>>2]|0);Q=P+1|0;if(!(Q>>>0<I>>>0)){M=I;break c}O=c[v>>2]|0;P=Q}}else{M=I}}while(0);if(!F){L=d;E=130;break b}G=fa(D,M)|0;R=Soa(G+1|0)|0;if((sb(R|0,G|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){G=M+1|0;P=(M|0)==0;O=0;do{N=Soa(G)|0;c[(c[v>>2]|0)+(O<<4)>>2]=N;if(!P){N=0;do{Q=a[R+((fa(D,N)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+N|0]=Q;N=N+1|0;}while(N>>>0<M>>>0)}a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+M|0]=0;N=c[v>>2]|0;c[N+(O<<4)+8>>2]=-1;c[N+(O<<4)+12>>2]=-1;$W(c[N+(O<<4)>>2]|0);O=O+1|0;}while(O>>>0<D>>>0)}Toa(R);L=0;E=130;break};case 3:{O=fa(I<<2,D)|0;S=Soa(O)|0;if((sb(S|0,O|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}O=c[v>>2]|0;P=0;do{G=fa(D,P)|0;c[O+(P<<4)+8>>2]=(c[S+(G<<2)>>2]|0)==1;c[O+(P<<4)+12>>2]=c[S+(G+1<<2)>>2];P=P+1|0;}while(P>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}P=c[v>>2]|0;O=0;do{c[P+(O<<4)+8>>2]=(c[S+(O<<2)>>2]|0)==1;c[P+(O<<4)+12>>2]=c[S+(D+O<<2)>>2];O=O+1|0;}while(O>>>0<D>>>0)}}while(0);Toa(S);cc(c[v>>2]|0,c[u>>2]|0,16,54);L=d;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=37640;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=Uoa(c[z>>2]<<1,4)|0;if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=37672;E=131;break a}else{L=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=37640;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=Uoa(c[z>>2]<<1,4)|0;O=fa(I,D)|0;if((a[l]|0)==1){P=Soa(O<<3)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=37672;E=131;break a}if((I|0)!=0){G=D<<3;F=(D|0)==0;N=D<<3;Q=0;do{T=Soa(G)|0;c[(c[B>>2]|0)+(Q<<2)>>2]=T;if(!F){T=P+(fa(N,Q)|0)|0;wpa(c[(c[B>>2]|0)+(Q<<2)>>2]|0,T|0,N|0)|0}Q=Q+1|0;}while(Q>>>0<I>>>0)}Q=c[z>>2]|0;N=Q<<1;if(Q>>>0<N>>>0){F=D<<3;G=(D|0)==0;T=Q;do{U=Soa(F)|0;c[(c[B>>2]|0)+(T<<2)>>2]=U;if(!G){U=c[B>>2]|0;V=c[U+(T-Q<<2)>>2]|0;W=c[U+(T<<2)>>2]|0;U=0;do{h[W+(U<<3)>>3]=-+h[V+(U<<3)>>3];U=U+1|0;}while(U>>>0<D>>>0)}T=T+1|0;}while(T>>>0<N>>>0)}Toa(P)}else{N=Soa(O<<2)|0;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=37672;E=131;break a}if((I|0)!=0){T=D<<3;Q=(D|0)==0;G=0;do{F=Soa(T)|0;c[(c[B>>2]|0)+(G<<2)>>2]=F;if(!Q){F=c[(c[B>>2]|0)+(G<<2)>>2]|0;U=0;do{h[F+(U<<3)>>3]=+g[N+((fa(D,G)|0)+U<<2)>>2];U=U+1|0;}while(U>>>0<D>>>0)}G=G+1|0;}while(G>>>0<I>>>0)}G=c[z>>2]|0;Q=G<<1;if(G>>>0<Q>>>0){T=D<<3;O=(D|0)==0;P=G;do{U=Soa(T)|0;c[(c[B>>2]|0)+(P<<2)>>2]=U;if(!O){U=c[B>>2]|0;F=c[U+(P-G<<2)>>2]|0;V=c[U+(P<<2)>>2]|0;U=0;do{h[V+(U<<3)>>3]=-+h[F+(U<<3)>>3];U=U+1|0;}while(U>>>0<D>>>0)}P=P+1|0;}while(P>>>0<Q>>>0)}Toa(N)}if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=37672;E=131;break a}else{L=d;E=130}break};case 2:{if(d<<24>>24==1){if((I|0)==0){X=1;E=129;break b}Q=D+1|0;P=0;while(1){G=Soa(Q)|0;c[(c[v>>2]|0)+(P<<4)+4>>2]=G;if((sb(c[(c[v>>2]|0)+(P<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=37328;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)+4>>2]|0)+D|0]=0;G=P+1|0;if(G>>>0<I>>>0){P=G}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){X=d;E=129;break b}P=fa(D,I)|0;Y=Soa(P+1|0)|0;if((sb(Y|0,P|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){P=I+1|0;Q=(I|0)==0;N=0;do{G=Soa(P)|0;c[(c[v>>2]|0)+(N<<4)+4>>2]=G;if(!Q){G=0;do{O=a[Y+((fa(D,G)|0)+N)|0]|0;a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+G|0]=O;G=G+1|0;}while(G>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(N<<4)+4>>2]|0)+I|0]=0;N=N+1|0;}while(N>>>0<D>>>0)}Toa(Y);L=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=37392;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=37448;E=131;break a}c[w>>2]=D;N=fa(I,D)|0;if((a[l]|0)==1){Q=Soa(N<<3)|0;c[x>>2]=Q;if((sb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=37488;E=131;break a}}else{Q=Soa(N<<2)|0;c[x>>2]=Soa(fa(D<<3,I)|0)|0;if((sb(Q|0,J|0,1,c[m>>2]|0)|0)!=1){n=37488;E=131;break a}if((N|0)!=0){P=c[x>>2]|0;G=0;do{h[P+(G<<3)>>3]=+g[Q+(G<<2)>>2];G=G+1|0;}while(G>>>0<N>>>0)}Toa(Q)}N=c[w>>2]|0;if(!(N>>>0>1)){L=1;E=130;break b}G=(I|0)==2;P=1;while(1){if(G){O=c[x>>2]|0;if(+h[O+(P<<3)>>3]!=+h[O+(N+P<<3)>>3]){n=37520;E=131;break a}}O=P+1|0;if(O>>>0<N>>>0){P=O}else{L=1;E=130;break b}}}else if(!(d<<24>>24==0)){X=d;E=129;break b}if((I|0)==0){n=37392;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=37600;E=131;break a}c[w>>2]=I;P=fa(I,D)|0;if((a[l]|0)==1){N=Soa(P<<3)|0;c[x>>2]=Soa(fa(D<<3,I)|0)|0;if((sb(N|0,J|0,1,c[m>>2]|0)|0)!=1){n=37488;E=131;break a}if((D|0)!=0){G=0;do{Q=c[x>>2]|0;O=0;do{h[Q+((fa(I,G)|0)+O<<3)>>3]=+h[N+((fa(D,O)|0)+G<<3)>>3];O=O+1|0;}while(O>>>0<I>>>0);G=G+1|0;}while(G>>>0<D>>>0)}Toa(N)}else{G=Soa(P<<2)|0;c[x>>2]=Soa(fa(D<<3,I)|0)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=37488;E=131;break a}if((D|0)!=0){O=0;do{Q=c[x>>2]|0;T=0;do{h[Q+((fa(I,O)|0)+T<<3)>>3]=+g[G+((fa(D,T)|0)+O<<2)>>2];T=T+1|0;}while(T>>>0<I>>>0);O=O+1|0;}while(O>>>0<D>>>0)}Toa(G)}O=c[w>>2]|0;if(!(O>>>0>1)){L=d;E=130;break b}P=(D|0)==2;N=1;while(1){if(P){T=c[x>>2]|0;if(+h[T+(N<<3)>>3]!=+h[T+(O+N<<3)>>3]){n=37520;E=131;break a}}T=N+1|0;if(T>>>0<O>>>0){N=T}else{L=d;E=130;break}}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=X;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=L;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){Toa(R);n=37328;i=e;return n|0}else if((E|0)==46){Toa(Y);n=37328;i=e;return n|0}else if((E|0)==52){Toa(S);n=37360;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function bX(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Ed(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function cX(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=37744;o=n;p=37792;q=p;r=37816;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=37744;o=n;p=37792;q=p;r=37816;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=Soa(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}Toa(r);t=0;i=e;return t|0}else{k=Soa(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}Toa(k);Toa(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);Toa(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function dX(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=37744;r=q;s=37792;t=s;u=37840;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=37744;r=q;s=37792;t=s;u=37840;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Wc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Wc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function eX(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function fX(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function gX(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function hX(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+gX(b)<e){q=1;i=f;return q|0}if(+fX(b)>e){q=1;i=f;return q|0}if((cX(b,1)|0)==0){q=1;i=f;return q|0}eX(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+dX(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+dX(a,b,d,o);i=f;return q|0}if(+dX(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+dX(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function iX(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function jX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0;e=i;f=+iX(a,(fa(c[(c[a+4>>2]|0)+4>>2]|0,b)|0)+d|0);i=e;return+f}function kX(a,b){a=a|0;b=b|0;var c=0;c=i;hW(a,b,NW(b)|0);i=c;return}function lX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=NW(iW(a,b,f)|0)|0;i=e;return}function mX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((eW(a)|0)==0){cb(37872,37896,127,37920)}if((eW(b)|0)==0){cb(37944,37896,128,37920)}if((fW(a,b)|0)==0){cb(37968,37896,129,37920)}e=gW(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+iX(a,b);nX(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function nX(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function oX(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((eW(a)|0)==0){cb(37872,37896,142,38008)}d=gW(a)|0;if((d|0)==0){i=c;return}else{e=0}do{h[b+(e<<3)>>3]=+iX(a,e);e=e+1|0;}while(e>>>0<d>>>0);i=c;return}function pX(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function qX(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;nX(c[d+8>>2]|0,b,a);i=e;return}function rX(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;kX(a,b);j=g;c[g>>2]=e;qX(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;qX(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function sX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=jW(a,b,f)|0;f=pX(c[a+8>>2]|0,d)|0;i=e;return f|0}function tX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0;g=i;i=i+16|0;h=g;j=Soa(d<<2)|0;if((j|0)==0){cb(38040,37896,784,38072)}k=h;c[h>>2]=f;c[j>>2]=e;f=(d|0)>1;if(f){h=1;do{l=c[k>>2]|0;m=c[l>>2]|0;c[k>>2]=l+4;c[j+(h<<2)>>2]=m;h=h+1|0;}while((h|0)<(d|0));n=c[j>>2]|0}else{n=e}e=c[n>>2]|0;if((e|0)<(a|0)){cb(38048,37896,795,38072)}h=a+ -1|0;k=c[n+4>>2]|0;m=c[k+(h<<2)>>2]|0;a:do{if(f){l=(h|0)>0;o=n;p=1;q=m;b:while(1){r=c[j+(p<<2)>>2]|0;if((e|0)!=(c[r>>2]|0)){s=14;break}t=c[r+4>>2]|0;if(l){r=0;while(1){u=r+1|0;if((c[k+(r<<2)>>2]|0)!=(c[t+(r<<2)>>2]|0)){s=17;break b}if((u|0)<(h|0)){r=u}else{v=n;break}}}else{v=o}r=(c[t+(h<<2)>>2]|0)+q|0;u=c[v>>2]|0;if((u|0)>(a|0)){w=c[v+4>>2]|0;x=a;while(1){y=x+1|0;if((c[w+(x<<2)>>2]|0)!=(c[t+(x<<2)>>2]|0)){s=22;break b}if((y|0)<(u|0)){x=y}else{break}}}x=p+1|0;if((x|0)<(d|0)){o=v;p=x;q=r}else{z=u;A=v;B=r;break a}}if((s|0)==14){cb(38096,37896,798,38072)}else if((s|0)==17){cb(38136,37896,800,38072)}else if((s|0)==22){cb(38136,37896,804,38072)}}else{z=e;A=n;B=m}}while(0);if((h|0)>0){m=c[A+4>>2]|0;n=0;e=1;while(1){s=fa(c[m+(n<<2)>>2]|0,e)|0;v=n+1|0;if((v|0)<(h|0)){e=s;n=v}else{C=s;break}}}else{C=1}n=A;if((z|0)>(a|0)){e=c[A+4>>2]|0;m=a;a=1;while(1){s=fa(c[e+(m<<2)>>2]|0,a)|0;v=m+1|0;if((v|0)<(z|0)){a=s;m=v}else{D=s;break}}}else{D=1}m=b+8|0;c[m>>2]=NW(fa(fa(C,B)|0,D)|0)|0;a=c[n>>2]|0;n=b;c[n>>2]=a;z=OW(a)|0;c[b+4>>2]=z;b=c[n>>2]|0;if((b|0)>0){n=c[A+4>>2]|0;A=0;do{c[z+(A<<2)>>2]=c[n+(A<<2)>>2];A=A+1|0;}while((A|0)<(b|0))}c[z+(h<<2)>>2]=B;if((C|0)<=0){Toa(j);i=g;return}B=(d|0)>0;z=0;b=0;while(1){if(B){A=0;n=b;while(1){a=c[j+(A<<2)>>2]|0;e=fa(c[(c[a+4>>2]|0)+(h<<2)>>2]|0,D)|0;if((e|0)>0){s=fa(e,z)|0;v=n;k=0;while(1){E=+iX(a,k+s|0);nX(c[m>>2]|0,v,E);f=k+1|0;if((f|0)<(e|0)){k=f;v=v+1|0}else{break}}F=n+e|0}else{F=n}v=A+1|0;if((v|0)<(d|0)){A=v;n=F}else{G=F;break}}}else{G=b}n=z+1|0;if((n|0)<(C|0)){z=n;b=G}else{break}}Toa(j);i=g;return}function uX(a,b,d){a=+a;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=d+4|0;c[f>>2]=OW(b)|0;g=NW(1)|0;c[d+8>>2]=g;c[d>>2]=b;nX(g,0,a);if((b|0)<=0){i=e;return}g=c[f>>2]|0;f=0;do{c[g+(f<<2)>>2]=1;f=f+1|0;}while((f|0)<(b|0));i=e;return}function vX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=Soa(20)|0;wW(0,(f|0)!=0|0,38184,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=Uoa(e,b)|0;c[f>>2]=a;wW(0,(a|0)!=0|0,38184,d);i=d;return f|0}function wX(a){a=a|0;var b=0;b=i;Toa(c[a>>2]|0);Toa(a);i=b;return}function xX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;wW(0,(c[h>>2]|0)>0|0,38200,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;wW(0,(g|0)>(b|0)|0,38224,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;wW(0,(0-f|0)<(b|0)|0,38224,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function yX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=Uoa(c[d>>2]<<1,c[e>>2]|0)|0;wW(0,(f|0)!=0|0,38184,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=xX(a,j)|0;h=c[e>>2]|0;wpa(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;Toa(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function zX(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){yX(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;wpa((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function AX(a){a=a|0;i=i;return c[a+12>>2]|0}function BX(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;wW(0,(c[j>>2]|0)>0|0,38200,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;wW(0,(h|0)>(b|0)|0,38224,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;wW(0,b>>>31^1,38224,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=xX(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function CX(a){a=a|0;i=i;return c[(c[9564]|0)+(a<<2)>>2]|0}function DX(a){a=a|0;i=i;return c[(c[9566]|0)+(a<<2)>>2]|0}function EX(a){a=a|0;i=i;return c[(c[9568]|0)+(a<<2)>>2]|0}function FX(a){a=a|0;i=i;return c[(c[9570]|0)+(a<<2)>>2]|0}function GX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[9566]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[9568]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[9564]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function HX(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9572]|0;e=+IX(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function IX(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function JX(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9574]|0;e=+IX(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function KX(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[9576]|0;e=+IX(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function LX(a){a=a|0;i=i;return 0}function MX(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[9578]|0)+(a<<3)|0)|0;d=(c[9564]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function NX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[9572]|0;f=e+(a<<3)|0;g=c[9576]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[9570]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[9564]|0)+(a<<2)>>2]|0);e=c[9574]|0;g=e+(a<<3)|0;OX(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;GX(a);d=c[9572]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[9564]|0)+(a<<2)>>2]=0;i=b;return}function OX(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(RX(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function PX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[9578]|0;f=c[9572]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function QX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=Uoa(a,8)|0;c[9572]=d;e=Uoa(a,8)|0;c[9574]=e;f=Uoa(a,8)|0;c[9576]=f;g=Uoa(a,8)|0;c[9578]=g;h=Uoa(a,4)|0;c[9564]=h;j=Uoa(a,4)|0;c[9570]=j;k=a<<2;l=Soa(k)|0;c[9566]=l;m=Uoa(a,4)|0;c[9568]=m;ypa(l|0,-1,k|0)|0;if((d|0)==0){cb(38320,38336,393,38352)}if((e|0)==0){cb(38360,38336,394,38352)}if((f|0)==0){cb(38376,38336,395,38352)}if((g|0)==0){cb(38392,38336,396,38352)}if((h|0)==0){cb(38408,38336,397,38352)}if((l|0)==0){cb(38432,38336,398,38352)}if((m|0)==0){cb(38456,38336,399,38352)}if((j|0)==0){cb(38480,38336,400,38352)}else{i=b;return}}function RX(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function SX(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==0){c[m>>2]=c[b+8>>2];n=m+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];uW(17,0,o,40112,m);i=e;return}else if((a|0)==2){c[j>>2]=c[b+8>>2];m=j+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];uW(17,0,o,40264,j);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];j=l+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];uW(17,0,o,40160,l);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];l=g+4|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];uW(17,0,o,40360,g);i=e;return}else{g=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=g;g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];uW(17,0,o,40424,f);i=e;return}}function TX(a){a=a|0;var b=0;b=i;Toa(c[a+12>>2]|0);Toa(c[a+4>>2]|0);Toa(c[a+8>>2]|0);i=b;return}function UX(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[5656]=.5;h[5642]=1.0;h[5679]=.25;h[5654]=2.0;h[5681]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[11320]=A;B=c[d>>2]|0;c[11250]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[11250]=D;if((C|0)<(B|0)){C=D}else{break}}}c[11248]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[5657]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[5657]=F;G=F}else{G=E}D=c[d>>2]|0;c[11250]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[11250]=I;if((H|0)>=(D|0)){break a}E=+h[5657];H=I}}}while(0);D=C+1|0;c[11248]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[5661]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[5626]=0.0;h[5628]=0.0;h[5632]=0.0;h[5689]=0.0;c[11246]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[5626]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[5628]+ +h[B>>3]*F;h[5628]=E;F=+h[I>>3];M=+h[5632]+F*F;h[5632]=M;F=+h[H>>3];h[5689]=+h[5689]+F*F;H=A+1|0;c[11246]=H;F=+h[5626];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[11316]=A;E=G/J;h[5678]=E;C=c[d>>2]|0;c[11250]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[5686]=0.0;h[5688]=0.0;I=c[b>>2]|0;c[11246]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[5655]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[5686]=ba;ca=E+aa*aa;h[5688]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[11246]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[11316]=A;h[5678]=E;h[5628]=Z;h[5632]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[11250]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[11246]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[11246]=A+1;da=+h[5628];ea=+h[5632];ga=+h[5626]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[5677]=K;c[11344]=0;h[5685]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[11344]=C;K=+h[5642]/+V(+ga);h[5657]=K;h[5680]=0.0;h[5682]=0.0;B=c[b>>2]|0;c[11246]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[5680]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[5680]=oa;pa=+h[5682]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[5682]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[5628];L=+h[5626];N=+h[5657];D=D+1|0;la=ma}c[11246]=B+1;ia=+h[5626];ja=pa;ka=oa}N=+h[5656];L=ka*N*ka;h[5673]=L;J=ja*N*ja;h[5674]=J;h[5633]=J+(L+ia*(+h[5689]+ia*N));N=+h[5654];h[45072>>3]=N*ka*ia;h[45080>>3]=N*ja*ia;h[45088>>3]=L-J;h[45096>>3]=ka*ja;la=45104|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[11246]=10;la=c[d>>2]|0;c[11250]=1;if((la|0)>=1){D=1;while(1){h[5673]=0.0;h[5674]=0.0;h[5675]=0.0;A=c[b>>2]|0;c[11246]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[5673]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[5674]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[5675]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[11246]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[5679]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[5673]*+h[5675];h[t+(U+D<<3)>>3]=+h[5674]*+h[5675];J=+h[5673];L=+h[5674];h[t+(P+D<<3)>>3]=+h[5679]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[5656]*+h[5673]*+h[5674];na=D+1|0;c[11250]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[11246]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[11258]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[11246]=B;if((la|0)<(D|0)){la=B}else{break}}}c[11254]=1;la=1;do{D=c[d>>2]|0;c[11262]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[11262]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[11250]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[11250]=D+1}na=c[11320]|0;c[11248]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[5653]=0.0;ma=c[d>>2]|0;c[11250]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[5653]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[11250]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[5653]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[11250]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[5653];Ca=Ca+1|0}c[11250]=ta+1}Ca=B+1|0;c[11248]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[11250]=1;if((A|0)<1){break}else{Ea=1}while(1){h[5653]=0.0;B=c[b>>2]|0;c[11248]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[5653]=N;Ca=na+1|0;c[11248]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[11250]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[11248]=1;if((A|0)>=1){ta=1;while(1){h[5653]=0.0;c[11246]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[5653]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[11246]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[11248]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[11254]=la;}while((la|0)<6);la=c[l>>2]|0;c[11250]=1;h[5653]=0.0;c[11246]=1;L=+h[5656];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[45144+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[45144+(A+ -1<<3)>>3]+L;h[5653]=L;A=A+1|0;}while((A|0)<6);h[5633]=+h[5633]- +h[5643]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[5673]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[5674]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[5675]=O;h[45072>>3]=+h[45072>>3]-J-N*(O+K);h[45104>>3]=+h[45104>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[5673]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[5674]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[5675]=J;h[45080>>3]=+h[45080>>3]-O-N*(K-J);h[45112>>3]=+h[45112>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[5673]=J;h[45088>>3]=+h[45160>>3]+(+h[45088>>3]-J- +h[45152>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[5673]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[5674]=K;Oa=+h[5656];h[45096>>3]=+h[45096>>3]-J-K*Oa;h[45120>>3]=+h[45120>>3]- +h[45168>>3]+ +h[45176>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[5673]=K;h[45128>>3]=+h[45128>>3]-Oa*K;h[5653]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[11250]=la+1;c[11246]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[45144+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[45144+(ta+ -1<<3)>>3]+N;h[5653]=N;ta=ta+1|0;c[11246]=ta;}while((ta|0)<6);K=+h[5661];h[5663]=K*+h[5633]+ +h[5643]+N;J=+h[5654];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[5673]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[5674]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[5675]=R;T=R+(K*+h[45072>>3]+O+S);h[45312>>3]=T;O=K*+h[45104>>3]+S-R;h[45344>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[5673]=R;S=+h[I>>3]*+h[ma>>3];h[5674]=S;Z=+h[Ma>>3]*+h[Na>>3];h[5675]=Z;h[45320>>3]=K*+h[45080>>3]+R+S-Z;h[45352>>3]=K*+h[45112>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[5673]=Z;R=+h[45152>>3]+(Z+K*+h[45088>>3])- +h[45160>>3];h[45328>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[5673]=Z;h[45336>>3]=Z+K*+h[45096>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[45120>>3]+ +h[45168>>3]- +h[45176>>3];h[45360>>3]=J;h[45368>>3]=+h[5661]*+h[45128>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[5663]+T+R+O+J;h[5653]=K;h[5683]=K;h[5684]=K;c[11352]=0;J=+h[5681]/50.0;h[5657]=J;h[5643]=+h[5642];c[11246]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[45152>>3]=Z;W=+Y(+Pa);h[45160>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[45144+(Ma+ -1<<3)>>3]=Z;Q=+h[45152>>3]*G+ +h[45160>>3]*W;h[45144+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[45160>>3];ca=+h[45152>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[45304+(Ma<<3)>>3]*+h[45144+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[5684]=Ra;c[11352]=Na;h[5673]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[5674]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[11248]=10;h[5653]=Ra;h[5662]=Pa;h[5687]=O;c[11246]=50;if((Xa|0)==49){h[5674]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[5673]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[5659]=0.0;if(Ya!=Za){S=Ya-Ua;h[5673]=S;T=Za-Ua;h[5674]=T;R=+h[5656]*(S-T)/(S+T);h[5659]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[5662]=R;T=+X(+R);h[45152>>3]=T;S=+Y(+R);h[45160>>3]=S;c[11248]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[45144+(Na+ -1<<3)>>3]=T;W=+h[45152>>3]*G+ +h[45160>>3]*S;h[45144+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[45160>>3];N=+h[45152>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[5684]=0.0;c[11248]=1;Na=1;do{ma=Na+ -1|0;Ma=45144+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[45064+(ma<<3)>>3]*+h[Ma>>3];h[5684]=+h[5684]+ +h[45304+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[11248]=10;Na=c[l>>2]|0;c[11250]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[45144+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[11248]=6;c[11250]=Na+1}h[5652]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[5626]=0.0;h[5673]=0.0;h[5674]=0.0;Ma=c[b>>2]|0;c[11246]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[45152>>3]*+h[la>>3]+ +h[45160>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[5626]=+h[5626]+G*G;bb=+h[5673]+ +h[la>>3]*+h[ta>>3];h[5673]=bb;G=+h[ta>>3];cb=+h[5674]+G*G;h[5674]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[11246]=Ma+1;$a=cb;ab=bb}ma=c[11344]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[5685];S=+h[5683];h[5685]=G>=S?G:S}S=+h[5684];if(!(S>=0.0)){db=-S}else{db=S}G=+h[5685];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[5685]=S;c[11246]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[5657]=N;R=+h[5652]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[5661];la=ta+1|0;c[11246]=la;if((ta|0)>=(Na|0)){break b}S=+h[5674];G=+h[5673];ta=la}}}while(0);Na=c[d>>2]|0;c[11250]=1;if((Na|0)>=1){Ma=1;while(1){h[5653]=0.0;ta=c[b>>2]|0;c[11248]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[5653]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[11248]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[5652]*+h[p+(la+ -1+Ma<<3)>>3]- +h[5661]*+h[q+(Ma+ -1<<3)>>3]);h[5657]=G;c[11246]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[5657];I=I+1|0}c[11246]=la+1}I=Ma+1|0;c[11250]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[5632]=0.0;h[5628]=0.0;Ma=c[b>>2]|0;c[11246]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[5632]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[5628]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[11246]=Ma+1;hb=kb;ib=jb}S=+h[5626];G=S*ib-hb*hb;h[5677]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[45040]=1;C=c[l>>2]|0;c[11250]=1;if((C|0)<1){lb=45136;mb=+h[5642];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[45144+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[11248]=6;c[11250]=C+1;lb=45136;mb=+h[5642];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function VX(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[5709]=.5;h[5705]=1.0;h[5721]=6.283185307179586;z=+h[n>>3];h[5718]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[11424]=A;c[11432]=0;B=c[d>>2]|0;c[11384]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[11384]=B+1}c[11382]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[5710]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[5710]=F;G=F}else{G=z}H=c[d>>2]|0;c[11384]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[5710];I=I+1|0}c[11384]=H+1}I=B+1|0;c[11382]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[5693]=0.0;D=c[b>>2]|0;c[11380]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[5693]=+h[5693]+G*G;A=p+1|0;c[11380]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[11384]=1;if((p|0)>=1){D=1;while(1){h[5710]=0.0;h[5708]=0.0;y=c[b>>2]|0;c[11382]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[5710]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[5708]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[11382]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[5710]=G;h[5708]=+h[g>>3]*L;g=c[b>>2]|0;c[11380]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[5708]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[5710];H=H+1|0}c[11380]=g+1}H=D+1|0;c[11384]=H;if((D|0)<(p|0)){D=H}else{break}}}h[5694]=0.0;h[5696]=0.0;h[5703]=0.0;D=c[b>>2]|0;c[11380]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[5694]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[5696]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[5703]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[11380]=D+1;O=R;P=T;Q=S}S=+h[5693];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[5714]=U;h[5710]=0.0;if(Q*Q>S*.99*O){h[5710]=+h[5705]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[5709]*U*Z);h[5706]=P;if(O*+h[5718]<P*P*.01){h[5710]=+h[5705]}n=c[b>>2]|0;c[11380]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[5714]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[5710]*U;if((D|0)>=(n|0)){break}e=D;P=+h[5714];D=D+1|0;p=e}c[11380]=n+1;_=0}while(1){n=_+1|0;c[11432]=n;h[5693]=0.0;h[5696]=0.0;h[5697]=0.0;p=c[b>>2]|0;c[11380]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[5693]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[5696]=da;Z=+h[H>>3];ea=P+Z*Z;h[5697]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[11380]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[5710]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[5715]=U;D=c[b>>2]|0;c[11380]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[5715];U=+h[5696];O=+h[5693];g=g+1|0;H=e}c[11380]=D+1}H=c[d>>2]|0;c[11384]=1;if((H|0)>=1){g=1;while(1){h[5708]=0.0;p=c[b>>2]|0;c[11382]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[5708]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[11382]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[5708]=O;e=c[b>>2]|0;c[11380]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[5708];l=l+1|0}c[11380]=e+1}l=g+1|0;c[11384]=l;if((g|0)<(H|0)){g=l}else{break}}}h[5698]=0.0;h[5699]=0.0;h[5700]=0.0;h[5701]=0.0;h[5702]=0.0;g=c[b>>2]|0;c[11380]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[5698]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[5699]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[5700]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[5701]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[5702]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[11380]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[5709];O=U*na;h[5698]=O;P=U*ma-O;h[5701]=P;Z=O+la+P;h[5722]=Z;h[5724]=Z;h[5723]=Z;c[11434]=0;a[45560]=1;W=+h[5721]/50.0;h[5710]=W;c[11380]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[5724]=wa;c[11434]=p;h[5719]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[5720]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[5713]=ta;h[5704]=ua;h[5707]=va;h[5706]=wa;c[11380]=50;h[5723]=wa;if((za|0)==49){h[5720]=Z;Ba=Z}else if((za|0)==0){h[5719]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[5720]}h[5711]=0.0;S=+h[5719];if(S!=Ba){Q=S-Aa;h[5719]=Q;S=Ba-Aa;h[5720]=S;T=U*(Q-S)/(Q+S);h[5711]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[5713]=T;S=+X(+T);h[5704]=S;Q=+Y(+T);h[5707]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[5706]=T;p=c[b>>2]|0;c[11380]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[5704]*+h[y>>3]+ +h[5707]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[5707];Q=+h[5704];H=H+1|0;g=e}c[11380]=p+1;Da=+h[5706]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[5722];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function WX(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[46016]=1;a[46008]=1;c[46028>>2]=6;vda(46024)|0;e=c[d>>2]|0;c[11500]=1;if((e|0)>=1){d=1;do{Mca(46144,b+(d+ -1)|0,1)|0;o=c[11500]|0;d=o+1|0;c[11500]=d;}while((o|0)<(e|0))}dda()|0;e=c[g>>2]|0;if((e|0)==1){c[46052>>2]=a[46008]&1?6:0;vda(46048)|0;Mca(46144,h,4)|0;dda()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[46076>>2]=a[46008]&1?6:0;vda(46072)|0;Mca(46144,h,4)|0;Mca(46144,j,4)|0;dda()|0}j=c[k>>2]|0;if((j|0)==1){c[46100>>2]=a[46008]&1?6:0;vda(46096)|0;Mca(46144,l,8)|0;dda()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[46124>>2]=a[46008]&1?6:0;vda(46120)|0;Mca(46144,l,8)|0;Mca(46144,m,8)|0;dda()|0}if((c[f>>2]|0)==2){uca(46152,0)|0}else{i=n;return 0}return 0}



function DP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17296]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17304,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17296]=1;i=d;return}function EP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17424]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17432,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17424]=1;i=d;return}function FP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17552]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17560,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17552]=1;i=d;return}function GP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17688]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17696,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17688]=1;i=d;return}function HP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17824]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17832,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17824]=1;i=d;return}function IP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17960]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(17968,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17960]=1;i=d;return}function JP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18088]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18096,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18088]=1;i=d;return}function KP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18216]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18224,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18344;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18216]=1;i=d;return}function LP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18368]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18376,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18368]=1;i=d;return}function MP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18504]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18512,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18504]=1;i=d;return}function NP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18640]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18648,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=18776;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18640]=1;i=d;return}function OP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18800]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18808,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=19280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18800]=1;i=d;return}function PP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18960]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(18968,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=19280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18960]=1;i=d;return}function QP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19120]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(19128,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=19280;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19120]=1;i=d;return}function RP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19304]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(19312,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=19712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19304]=1;i=d;return}function SP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19440]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(19448,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=19712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19440]=1;i=d;return}function TP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19576]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(19584,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=19712;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19576]=1;i=d;return}function UP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19736]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(19744,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=20216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19736]=1;i=d;return}function VP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19896]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(19904,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=20216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[19896]=1;i=d;return}function WP(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20056]&1){i=d;return}g=b+4|0;b=EZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(CZ(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=XW(20064,VW(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,8296)|0)|0;g=c[21292]|0;h=e;j=20216;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[20056]=1;i=d;return}function XP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20240]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20248,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6544>>3],5568)|0)|0;g=c[21292]|0;j=e;k=20344;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20240]=1;i=d;return}function YP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20368]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20376,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6528>>3],5568)|0)|0;g=c[21292]|0;j=e;k=20776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20368]=1;i=d;return}function ZP(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20464]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20472,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6520>>3],5568)|0)|0;g=c[21292]|0;j=e;k=20904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20464]=1;i=d;return}function _P(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20568]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20576,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6512>>3],5568)|0)|0;g=c[21292]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20568]=1;i=d;return}function $P(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20680]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20688,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6496>>3],5568)|0)|0;g=c[21292]|0;j=e;k=20776;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20680]=1;i=d;return}function aQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20800]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20808,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6488>>3],5568)|0)|0;g=c[21292]|0;j=e;k=20904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20800]=1;i=d;return}function bQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20928]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(20936,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6480>>3],5568)|0)|0;g=c[21292]|0;j=e;k=21040;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20928]=1;i=d;return}function cQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21064]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(21072,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6408>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21064]=1;i=d;return}function dQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21296]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(21304,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6392>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21296]=1;i=d;return}function eQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21448]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(21456,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6376>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21448]=1;i=d;return}function fQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21592]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(21600,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6360>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21592]=1;i=d;return}function gQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21736]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(21744,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6344>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21736]=1;i=d;return}function hQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21880]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(21888,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6328>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21880]=1;i=d;return}function iQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22024]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(22032,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6312>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22024]=1;i=d;return}function jQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22168]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(22176,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6296>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22168]=1;i=d;return}function kQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22336]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(22344,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6280>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22336]=1;i=d;return}function lQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22560]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(22568,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6272>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22560]=1;i=d;return}function mQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22696]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(22704,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6264>>3],5568)|0)|0;g=c[21292]|0;j=e;k=22832;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[22696]=1;i=d;return}function nQ(a){a=a|0;var b=0;b=i;My(a);Ny(a);Oy(a);Py(a);Qy(a);Ry(a);Sy(a);Ty(a);Uy(a);Vy(a);Wy(a);Xy(a);Yy(a);Zy(a);_y(a);$y(a);az(a);bz(a);cz(a);dz(a);ez(a);fz(a);gz(a);hz(a);iz(a);jz(a);kz(a);lz(a);mz(a);nz(a);oz(a);pz(a);qz(a);rz(a);sz(a);tz(a);uz(a);vz(a);wz(a);xz(a);yz(a);zz(a);Az(a);Bz(a);Cz(a);Dz(a);Ez(a);Fz(a);Gz(a);Hz(a);Iz(a);Jz(a);Kz(a);Lz(a);Mz(a);Nz(a);Oz(a);Pz(a);Qz(a);Rz(a);Sz(a);Tz(a);Uz(a);Vz(a);Wz(a);Xz(a);Yz(a);Zz(a);_z(a);$z(a);aA(a);bA(a);cA(a);dA(a);eA(a);fA(a);gA(a);hA(a);iA(a);jA(a);kA(a);lA(a);mA(a);nA(a);oA(a);pA(a);qA(a);rA(a);sA(a);tA(a);uA(a);vA(a);wA(a);xA(a);yA(a);zA(a);AA(a);BA(a);CA(a);DA(a);EA(a);FA(a);GA(a);HA(a);IA(a);JA(a);KA(a);LA(a);MA(a);NA(a);OA(a);PA(a);QA(a);RA(a);SA(a);TA(a);UA(a);VA(a);WA(a);XA(a);YA(a);ZA(a);_A(a);$A(a);aB(a);bB(a);cB(a);dB(a);eB(a);fB(a);gB(a);hB(a);iB(a);jB(a);kB(a);lB(a);mB(a);nB(a);oB(a);pB(a);qB(a);rB(a);sB(a);tB(a);uB(a);vB(a);wB(a);xB(a);yB(a);zB(a);AB(a);BB(a);CB(a);DB(a);EB(a);FB(a);GB(a);HB(a);IB(a);JB(a);KB(a);LB(a);MB(a);NB(a);OB(a);PB(a);QB(a);RB(a);SB(a);TB(a);UB(a);VB(a);WB(a);XB(a);YB(a);ZB(a);_B(a);$B(a);aC(a);bC(a);cC(a);dC(a);eC(a);fC(a);gC(a);hC(a);iC(a);jC(a);kC(a);lC(a);mC(a);nC(a);oC(a);pC(a);qC(a);rC(a);sC(a);tC(a);uC(a);vC(a);wC(a);xC(a);yC(a);zC(a);AC(a);BC(a);CC(a);DC(a);EC(a);FC(a);GC(a);HC(a);IC(a);JC(a);KC(a);LC(a);MC(a);NC(a);OC(a);PC(a);QC(a);RC(a);SC(a);TC(a);UC(a);VC(a);WC(a);XC(a);YC(a);ZC(a);_C(a);$C(a);aD(a);bD(a);cD(a);dD(a);eD(a);fD(a);gD(a);hD(a);iD(a);jD(a);kD(a);lD(a);mD(a);nD(a);oD(a);pD(a);qD(a);rD(a);sD(a);tD(a);uD(a);vD(a);wD(a);xD(a);yD(a);zD(a);AD(a);BD(a);CD(a);DD(a);ED(a);FD(a);GD(a);HD(a);ID(a);JD(a);KD(a);LD(a);MD(a);ND(a);OD(a);PD(a);QD(a);RD(a);SD(a);TD(a);UD(a);VD(a);WD(a);XD(a);YD(a);ZD(a);_D(a);$D(a);aE(a);bE(a);cE(a);dE(a);eE(a);fE(a);gE(a);hE(a);iE(a);jE(a);kE(a);lE(a);mE(a);nE(a);oE(a);pE(a);qE(a);rE(a);sE(a);tE(a);uE(a);vE(a);wE(a);xE(a);yE(a);zE(a);AE(a);BE(a);CE(a);DE(a);EE(a);FE(a);GE(a);HE(a);IE(a);JE(a);KE(a);LE(a);ME(a);NE(a);OE(a);PE(a);QE(a);RE(a);SE(a);TE(a);UE(a);VE(a);WE(a);XE(a);YE(a);ZE(a);_E(a);$E(a);aF(a);bF(a);cF(a);dF(a);eF(a);fF(a);gF(a);hF(a);iF(a);jF(a);kF(a);lF(a);mF(a);nF(a);oF(a);pF(a);qF(a);rF(a);sF(a);tF(a);uF(a);vF(a);wF(a);xF(a);yF(a);zF(a);AF(a);BF(a);CF(a);DF(a);EF(a);FF(a);GF(a);HF(a);IF(a);JF(a);KF(a);LF(a);MF(a);NF(a);OF(a);PF(a);QF(a);RF(a);SF(a);TF(a);UF(a);VF(a);WF(a);XF(a);YF(a);ZF(a);_F(a);$F(a);aG(a);bG(a);cG(a);dG(a);eG(a);fG(a);gG(a);hG(a);iG(a);jG(a);kG(a);lG(a);mG(a);nG(a);oG(a);pG(a);qG(a);rG(a);sG(a);tG(a);uG(a);vG(a);wG(a);xG(a);yG(a);zG(a);AG(a);BG(a);CG(a);DG(a);EG(a);FG(a);GG(a);HG(a);IG(a);JG(a);KG(a);LG(a);MG(a);NG(a);OG(a);PG(a);QG(a);RG(a);SG(a);TG(a);UG(a);VG(a);WG(a);XG(a);YG(a);ZG(a);_G(a);$G(a);aH(a);bH(a);cH(a);dH(a);eH(a);fH(a);gH(a);hH(a);iH(a);jH(a);kH(a);lH(a);mH(a);nH(a);oH(a);pH(a);qH(a);rH(a);sH(a);tH(a);uH(a);vH(a);wH(a);xH(a);yH(a);zH(a);AH(a);BH(a);CH(a);DH(a);EH(a);FH(a);GH(a);HH(a);IH(a);JH(a);KH(a);LH(a);MH(a);NH(a);OH(a);PH(a);QH(a);RH(a);SH(a);TH(a);UH(a);VH(a);WH(a);XH(a);YH(a);ZH(a);_H(a);$H(a);aI(a);bI(a);cI(a);dI(a);eI(a);fI(a);gI(a);hI(a);iI(a);jI(a);kI(a);lI(a);mI(a);nI(a);oI(a);pI(a);qI(a);rI(a);sI(a);tI(a);uI(a);vI(a);wI(a);xI(a);yI(a);zI(a);AI(a);BI(a);CI(a);DI(a);EI(a);FI(a);GI(a);HI(a);II(a);JI(a);KI(a);LI(a);MI(a);NI(a);OI(a);PI(a);QI(a);RI(a);SI(a);TI(a);UI(a);VI(a);WI(a);XI(a);YI(a);ZI(a);_I(a);$I(a);aJ(a);bJ(a);cJ(a);dJ(a);eJ(a);fJ(a);gJ(a);hJ(a);iJ(a);jJ(a);kJ(a);lJ(a);mJ(a);nJ(a);oJ(a);pJ(a);qJ(a);rJ(a);sJ(a);tJ(a);uJ(a);vJ(a);wJ(a);xJ(a);yJ(a);zJ(a);AJ(a);BJ(a);CJ(a);DJ(a);EJ(a);FJ(a);GJ(a);HJ(a);IJ(a);JJ(a);KJ(a);LJ(a);MJ(a);NJ(a);OJ(a);PJ(a);QJ(a);RJ(a);SJ(a);TJ(a);UJ(a);VJ(a);WJ(a);XJ(a);YJ(a);ZJ(a);_J(a);$J(a);aK(a);bK(a);cK(a);dK(a);eK(a);fK(a);gK(a);hK(a);iK(a);jK(a);kK(a);lK(a);mK(a);nK(a);oK(a);pK(a);qK(a);rK(a);sK(a);tK(a);uK(a);vK(a);wK(a);xK(a);yK(a);zK(a);AK(a);BK(a);CK(a);DK(a);EK(a);FK(a);GK(a);HK(a);IK(a);JK(a);KK(a);LK(a);MK(a);NK(a);OK(a);PK(a);QK(a);RK(a);SK(a);TK(a);UK(a);VK(a);WK(a);XK(a);YK(a);ZK(a);_K(a);$K(a);aL(a);bL(a);cL(a);dL(a);eL(a);fL(a);gL(a);hL(a);iL(a);jL(a);kL(a);lL(a);mL(a);nL(a);oL(a);pL(a);qL(a);rL(a);sL(a);tL(a);uL(a);vL(a);wL(a);xL(a);yL(a);zL(a);AL(a);BL(a);CL(a);DL(a);EL(a);FL(a);GL(a);HL(a);IL(a);JL(a);KL(a);LL(a);ML(a);NL(a);OL(a);PL(a);QL(a);RL(a);SL(a);TL(a);UL(a);VL(a);WL(a);XL(a);YL(a);ZL(a);_L(a);$L(a);aM(a);bM(a);cM(a);dM(a);eM(a);fM(a);gM(a);hM(a);iM(a);jM(a);kM(a);lM(a);mM(a);nM(a);oM(a);pM(a);qM(a);rM(a);sM(a);tM(a);uM(a);vM(a);wM(a);xM(a);yM(a);zM(a);AM(a);BM(a);CM(a);DM(a);EM(a);FM(a);GM(a);HM(a);IM(a);JM(a);KM(a);LM(a);MM(a);NM(a);OM(a);PM(a);QM(a);RM(a);SM(a);TM(a);UM(a);VM(a);WM(a);XM(a);YM(a);ZM(a);_M(a);$M(a);aN(a);bN(a);cN(a);dN(a);eN(a);fN(a);gN(a);hN(a);iN(a);jN(a);kN(a);lN(a);mN(a);nN(a);oN(a);pN(a);qN(a);rN(a);sN(a);tN(a);uN(a);vN(a);wN(a);xN(a);yN(a);zN(a);AN(a);BN(a);CN(a);DN(a);EN(a);FN(a);GN(a);HN(a);IN(a);JN(a);KN(a);LN(a);MN(a);NN(a);ON(a);PN(a);QN(a);RN(a);SN(a);TN(a);UN(a);VN(a);WN(a);XN(a);YN(a);ZN(a);_N(a);$N(a);aO(a);bO(a);cO(a);dO(a);eO(a);fO(a);gO(a);hO(a);iO(a);jO(a);kO(a);lO(a);mO(a);nO(a);oO(a);pO(a);qO(a);rO(a);sO(a);tO(a);uO(a);vO(a);wO(a);xO(a);yO(a);zO(a);AO(a);BO(a);CO(a);DO(a);EO(a);FO(a);GO(a);HO(a);IO(a);JO(a);KO(a);LO(a);MO(a);NO(a);OO(a);PO(a);QO(a);RO(a);SO(a);TO(a);UO(a);VO(a);WO(a);XO(a);YO(a);ZO(a);_O(a);$O(a);aP(a);bP(a);cP(a);dP(a);eP(a);fP(a);gP(a);hP(a);iP(a);jP(a);kP(a);lP(a);mP(a);nP(a);oP(a);pP(a);qP(a);rP(a);sP(a);tP(a);uP(a);vP(a);wP(a);xP(a);yP(a);zP(a);AP(a);BP(a);CP(a);DP(a);EP(a);FP(a);GP(a);HP(a);IP(a);JP(a);KP(a);LP(a);MP(a);NP(a);OP(a);PP(a);QP(a);RP(a);SP(a);TP(a);UP(a);VP(a);WP(a);XP(a);YP(a);ZP(a);_P(a);$P(a);aQ(a);bQ(a);cQ(a);dQ(a);eQ(a);fQ(a);gQ(a);hQ(a);iQ(a);jQ(a);kQ(a);lQ(a);mQ(a);i=b;return 0}function oQ(b){b=b|0;var c=0;c=i;a[b+314|0]=0;pQ(b);i=c;return 0}function pQ(a){a=a|0;var b=0;b=i;cf(a);lf(a);mf(a);of(a);Of(a);Pf(a);Qf(a);Rf(a);Tf(a);Xf(a);og(a);pg(a);qg(a);wg(a);xg(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);i=b;return}function qQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23104]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(23120,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6240>>3],23112)|0)|0;g=c[21292]|0;j=e;k=23416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23104]=1;i=d;return}function rQ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23304]&1){i=d;return}g=b+4|0;if(!((EZ(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=XW(23312,TW(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+6224>>3],23112)|0)|0;g=c[21292]|0;j=e;k=23416;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23304]=1;i=d;return}function sQ(a){a=a|0;var b=0;b=i;qQ(a);rQ(a);i=b;return 0}function tQ(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a>>2]=4;c[a+4>>2]=1;c[a+28>>2]=Uoa(4,8)|0;a=Uoa(1,8)|0;c[(c[d>>2]|0)+36>>2]=a;a=Uoa(1,8)|0;c[(c[d>>2]|0)+32>>2]=a;a=Soa(16)|0;c[(c[d>>2]|0)+8>>2]=a;a=Soa(16)|0;c[(c[d>>2]|0)+12>>2]=a;a=Soa(16)|0;c[(c[d>>2]|0)+20>>2]=a;a=c[d>>2]|0;c[a+24>>2]=4;c[a+40>>2]=0;a=c[d>>2]|0;e=c[a+8>>2]|0;c[e>>2]=1;c[e+4>>2]=2;c[e+8>>2]=3;c[e+12>>2]=4;uQ(1,c[a+12>>2]|0);a=c[d>>2]|0;vQ(c[(c[a+8>>2]|0)+4>>2]|0,c[a+12>>2]|0);a=c[d>>2]|0;wQ(c[(c[a+8>>2]|0)+8>>2]|0,c[a+12>>2]|0);a=c[d>>2]|0;xQ(c[(c[a+8>>2]|0)+12>>2]|0,c[a+12>>2]|0);a=c[(c[d>>2]|0)+20>>2]|0;c[a>>2]=1;c[a+4>>2]=2;c[a+8>>2]=3;c[a+12>>2]=4;i=b;return 0}function uQ(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=0;i=i;return}function vQ(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=0;i=i;return}function wQ(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=0;i=i;return}function xQ(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=0;i=i;return}function yQ(a){a=a|0;i=i;return 1}function zQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+88>>2]=14;c[a+92>>2]=14;c[a+116>>2]=Uoa(14,8)|0;a=Uoa(14,8)|0;c[(c[d>>2]|0)+124>>2]=a;a=Uoa(0,8)|0;c[(c[d>>2]|0)+120>>2]=a;a=Soa(56)|0;c[(c[d>>2]|0)+96>>2]=a;a=Soa(368)|0;c[(c[d>>2]|0)+100>>2]=a;a=Soa(56)|0;c[(c[d>>2]|0)+108>>2]=a;a=c[d>>2]|0;c[a+112>>2]=12;c[a+128>>2]=0;a=c[d>>2]|0;e=c[a+96>>2]|0;c[e+44>>2]=9;c[e+40>>2]=9;c[e+36>>2]=9;c[e+24>>2]=6;c[e+28>>2]=6;c[e+32>>2]=6;c[e+12>>2]=7;c[e+16>>2]=7;c[e+20>>2]=7;c[e>>2]=8;c[e+4>>2]=8;c[e+8>>2]=8;c[e+52>>2]=1;c[e+48>>2]=1;f=8;g=8;h=1;while(1){j=f+g|0;c[e+(h<<2)>>2]=j;k=h+1|0;if((k|0)>=14){break}f=c[e+(k<<2)>>2]|0;h=k;g=j}AQ(e,c[a+100>>2]|0);a=c[d>>2]|0;BQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;CQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;DQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;EQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;FQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;GQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;HQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;IQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;JQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;KQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;LQ(c[a+96>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;MQ(c[(c[a+96>>2]|0)+52>>2]|0,c[a+100>>2]|0);a=c[d>>2]|0;NQ(c[(c[a+96>>2]|0)+48>>2]|0,c[a+100>>2]|0);a=c[(c[d>>2]|0)+108>>2]|0;c[a+44>>2]=1;c[a+52>>2]=1;c[a+48>>2]=1;c[a+40>>2]=2;c[a+36>>2]=3;c[a+24>>2]=4;c[a+28>>2]=5;c[a+32>>2]=6;c[a+12>>2]=7;c[a+16>>2]=8;c[a+20>>2]=9;c[a>>2]=10;c[a+4>>2]=11;c[a+8>>2]=12;i=b;return 0}function AQ(a,b){a=a|0;b=b|0;var d=0;d=a+44|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=2;c[b+((c[d>>2]|0)+ -8<<2)>>2]=1;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function BQ(a,b){a=a|0;b=b|0;var d=0;d=a+40|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=2;c[b+((c[d>>2]|0)+ -8<<2)>>2]=1;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function CQ(a,b){a=a|0;b=b|0;var d=0;d=a+36|0;c[b+((c[d>>2]|0)+ -9<<2)>>2]=2;c[b+((c[d>>2]|0)+ -8<<2)>>2]=1;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function DQ(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=4;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function EQ(a,b){a=a|0;b=b|0;var d=0;d=a+28|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=4;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function FQ(a,b){a=a|0;b=b|0;var d=0;d=a+32|0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=2;c[b+((c[d>>2]|0)+ -5<<2)>>2]=1;c[b+((c[d>>2]|0)+ -4<<2)>>2]=0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=5;c[b+((c[d>>2]|0)+ -2<<2)>>2]=4;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function GQ(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=2;c[b+((c[d>>2]|0)+ -6<<2)>>2]=1;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=6;i=i;return}function HQ(a,b){a=a|0;b=b|0;var d=0;d=a+16|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=2;c[b+((c[d>>2]|0)+ -6<<2)>>2]=1;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=7;i=i;return}function IQ(a,b){a=a|0;b=b|0;var d=0;d=a+20|0;c[b+((c[d>>2]|0)+ -7<<2)>>2]=2;c[b+((c[d>>2]|0)+ -6<<2)>>2]=1;c[b+((c[d>>2]|0)+ -5<<2)>>2]=0;c[b+((c[d>>2]|0)+ -4<<2)>>2]=5;c[b+((c[d>>2]|0)+ -3<<2)>>2]=4;c[b+((c[d>>2]|0)+ -2<<2)>>2]=3;c[b+((c[d>>2]|0)+ -1<<2)>>2]=8;i=i;return}function JQ(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -8<<2)>>2]=2;c[b+((c[a>>2]|0)+ -7<<2)>>2]=1;c[b+((c[a>>2]|0)+ -6<<2)>>2]=5;c[b+((c[a>>2]|0)+ -5<<2)>>2]=4;c[b+((c[a>>2]|0)+ -4<<2)>>2]=3;c[b+((c[a>>2]|0)+ -3<<2)>>2]=9;c[b+((c[a>>2]|0)+ -2<<2)>>2]=10;c[b+((c[a>>2]|0)+ -1<<2)>>2]=11;i=i;return}function KQ(a,b){a=a|0;b=b|0;var d=0;d=a+4|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=2;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function LQ(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -8<<2)>>2]=1;c[b+((c[d>>2]|0)+ -7<<2)>>2]=0;c[b+((c[d>>2]|0)+ -6<<2)>>2]=5;c[b+((c[d>>2]|0)+ -5<<2)>>2]=4;c[b+((c[d>>2]|0)+ -4<<2)>>2]=3;c[b+((c[d>>2]|0)+ -3<<2)>>2]=9;c[b+((c[d>>2]|0)+ -2<<2)>>2]=10;c[b+((c[d>>2]|0)+ -1<<2)>>2]=11;i=i;return}function MQ(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=12;i=i;return}function NQ(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=13;i=i;return}function OQ(a){a=a|0;i=i;return 1}function PQ(a){a=a|0;i=i;return 1}function QQ(a){a=a|0;i=i;return 1}function RQ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+464>>2]|0;a=c[d+28>>2]|0;h[c[d+36>>2]>>3]=(+h[b+488>>3]*+h[a+24>>3]+(+h[b+496>>3]*+h[a+16>>3]+(+h[b+504>>3]*+h[a+8>>3]+ +h[b+512>>3]*+h[a>>3])))*-2.0;i=i;return}function SQ(a){a=a|0;var b=0;b=i;RQ(a);i=b;return 0}function TQ(a){a=a|0;i=i;return 0}function UQ(a){a=a|0;i=i;return 0}function VQ(a){a=a|0;i=i;return 0}function WQ(a){a=a|0;i=i;return 0}function XQ(a){a=a|0;i=i;return 0}function YQ(a,b){a=a|0;b=b|0;i=i;return-1}function ZQ(a,b){a=a|0;b=b|0;i=i;return-1}function _Q(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function $Q(){i=i;return 23440}function aR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function bR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function cR(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function dR(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(24568,n|0)|0;i=m;return 0}function eR(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=yY(a,24576)|0;z=yY(b,24576)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((yY(a,24584)|0)!=0){C=5;break}if((yY(a,24592)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((yY(b,24584)|0)!=0){break}if((yY(b,24592)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){ypa(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}ypa(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}ypa(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(24600,r|0)|0;i=q;return 0}function fR(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(yY(a,24608)|0)!=0;v=c[(u?f:g)>>2]|0;w=yY(e,24616)|0;x=yY(b,24624)|0;c[p>>2]=0;do{if(u){y=4}else{if((yY(a,24632)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((yY(b,24608)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((yY(d,24616)|0)==0){if((yY(d,24640)|0)!=0){break}if((yY(d,24648)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((yY(e,24624)|0)==0){if((yY(e,24616)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){ypa(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(yY(d,24616)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(24656,p|0)|0;i=o;return 0}function gR(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}iR(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}jR(24672,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(24664,l|0)|0;i=k;return 0}function hR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+fY(24696);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(aR(l,z,24704)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){cR(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;bR(l,n,d+(x-o+v<<3)|0,24704)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;dR(l,m,24712,d+(B+y<<3)|0,24704,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(24688,k|0)|0;i=j;return 0}function iR(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=24744;u=lR(24728,24720,24736,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;hR(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;kR(k,d,e,m,l,f,24728)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;kR(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,24728)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;fR(24752,24760,24768,24784,n,k,24792,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=24768;eR(H,H,k,l,n,24800,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,24792,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);hR(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(24720,j|0)|0;i=h;return 0}function jR(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(yY(a,24808)|0)!=0;do{if(n){o=5}else{if((yY(a,24816)|0)!=0){o=5;break}if((yY(a,24824)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=24840;kR(d,h,j,q,b,g,q)|0;fR(24848,24856,24864,24880,b,d,24888,e,f,h,j)|0;fR(24848,24896,24864,24904,b,d,24888,e,f,h,j)|0;i=l;return 0}else{fR(24848,24896,24920,24904,b,d,24888,e,f,h,j)|0;fR(24848,24856,24920,24880,b,d,24888,e,f,h,j)|0;kR(d,h,j,24840,b,g,24936)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(24832,m|0)|0;i=l;return 0}function kR(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function lR(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=upa(d|0)|0;switch(c[b>>2]|0){case 4:{q=6;i=k;return q|0};case 5:{q=2;i=k;return q|0};case 3:case 2:case 1:{r=o;Bca(r,d,1,p);p=a[r]|0;do{if((p+ -97<<24>>24&255)<26){s=p+ -32<<24>>24;a[r]=s;t=o+1|0;u=a[t]|0;if((u+ -97<<24>>24&255)<26){a[t]=u+ -32<<24>>24}u=o+2|0;t=a[u]|0;if((t+ -97<<24>>24&255)<26){a[u]=t+ -32<<24>>24}t=o+3|0;u=a[t]|0;if((u+ -97<<24>>24&255)<26){a[t]=u+ -32<<24>>24}u=o+4|0;t=a[u]|0;if((t+ -97<<24>>24&255)<26){a[u]=t+ -32<<24>>24}t=o+5|0;u=a[t]|0;if(!((u+ -97<<24>>24&255)<26)){v=s;break}a[t]=u+ -32<<24>>24;v=s}else{v=p}}while(0);p=v<<24>>24==83;r=v<<24>>24==68;s=p|r;if(!(v<<24>>24==67|v<<24>>24==68|v<<24>>24==83|v<<24>>24==90)){q=1;i=k;return q|0}u=l;Bca(u,o+1|0,1,2);l=m;Bca(l,o+3|0,1,3);o=n;Bca(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((Aca(u,24944,1,2)|0)==0){if((Aca(l,24960,1,3)|0)==0){q=2;i=k;return q|0}if((Aca(l,24968,1,3)|0)==0){q=2;i=k;return q|0}if((Aca(l,24976,1,3)|0)==0){q=2;i=k;return q|0}if((Aca(l,24984,1,3)|0)==0){q=2;i=k;return q|0}if((Aca(l,24992,1,3)|0)==0){q=2;i=k;return q|0}if((Aca(l,25e3,1,3)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}if((Aca(u,25024,1,2)|0)==0){n=(Aca(l,24952,1,3)|0)==0;if(n|(p|r)^1){q=n?8:2;i=k;return q|0}q=2;i=k;return q|0}if(v<<24>>24==68|v<<24>>24==83){w=94}else if(v<<24>>24==67|v<<24>>24==90){w=91}else{q=2;i=k;return q|0}do{if((w|0)==91){if((Aca(u,25048,1,2)|0)==0){q=2;i=k;return q|0}else{if(v<<24>>24==68|v<<24>>24==83){w=94;break}else if(v<<24>>24==67|v<<24>>24==90){break}else{q=2}i=k;return q|0}}}while(0);do{if((w|0)==94){if((Aca(u,25056,1,2)|0)!=0){if(v<<24>>24==67|v<<24>>24==90){break}else{q=2}i=k;return q|0}n=a[l]|0;if(n<<24>>24==77){if((Aca(o,25064,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25072,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25080,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25088,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25096,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25104,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(n<<24>>24==71){if((Aca(o,25064,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25072,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25080,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25088,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25096,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25104,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}}while(0);if((Aca(u,25120,1,2)|0)!=0){q=2;i=k;return q|0}n=a[l]|0;if(n<<24>>24==77){if((Aca(o,25064,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25072,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25080,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25088,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25096,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25104,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else if(n<<24>>24==71){if((Aca(o,25064,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25072,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25080,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25088,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25096,1,2)|0)==0){q=2;i=k;return q|0}if((Aca(o,25104,1,2)|0)==0){q=2;i=k;return q|0}q=2;i=k;return q|0}else{q=2;i=k;return q|0}}else if((m|0)==3){if((Aca(u,24944,1,2)|0)==0){if((Aca(l,24960,1,3)|0)==0){q=128;i=k;return q|0}if((Aca(l,24968,1,3)|0)==0){q=128;i=k;return q|0}if((Aca(l,24976,1,3)|0)==0){q=128;i=k;return q|0}if((Aca(l,24984,1,3)|0)==0){q=128;i=k;return q|0}if((Aca(l,24992,1,3)|0)==0){q=128;i=k;return q|0}m=(Aca(l,25e3,1,3)|0)==0;q=m?128:0;i=k;return q|0}if((Aca(u,25024,1,2)|0)==0){if(!(v<<24>>24==68|v<<24>>24==83)){q=0;i=k;return q|0}m=(Aca(l,25032,1,3)|0)==0;q=m?32:0;i=k;return q|0}if(v<<24>>24==68|v<<24>>24==83){w=141}else if(v<<24>>24==67|v<<24>>24==90){w=138}else{q=0;i=k;return q|0}do{if((w|0)==138){if((Aca(u,25048,1,2)|0)==0){m=(Aca(l,25032,1,3)|0)==0;q=m?32:0;i=k;return q|0}else{if(v<<24>>24==68|v<<24>>24==83){w=141;break}else if(v<<24>>24==67|v<<24>>24==90){break}else{q=0}i=k;return q|0}}}while(0);do{if((w|0)==141){if((Aca(u,25056,1,2)|0)!=0){if(v<<24>>24==67|v<<24>>24==90){break}else{q=0}i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((Aca(o,25064,1,2)|0)!=0){if((Aca(o,25072,1,2)|0)==0){break}if((Aca(o,25080,1,2)|0)==0){break}if((Aca(o,25088,1,2)|0)==0){break}if((Aca(o,25096,1,2)|0)==0){break}if((Aca(o,25104,1,2)|0)==0){break}if((Aca(o,25112,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}}while(0);if((Aca(u,25120,1,2)|0)!=0){q=0;i=k;return q|0}if((a[l]|0)!=71){q=0;i=k;return q|0}do{if((Aca(o,25064,1,2)|0)!=0){if((Aca(o,25072,1,2)|0)==0){break}if((Aca(o,25080,1,2)|0)==0){break}if((Aca(o,25088,1,2)|0)==0){break}if((Aca(o,25096,1,2)|0)==0){break}if((Aca(o,25104,1,2)|0)==0){break}if((Aca(o,25112,1,2)|0)==0){break}else{q=0}i=k;return q|0}}while(0);q=128;i=k;return q|0}else{if((Aca(u,24944,1,2)|0)==0){if((Aca(l,24952,1,3)|0)==0){q=64;i=k;return q|0}if((Aca(l,24960,1,3)|0)==0){q=32;i=k;return q|0}if((Aca(l,24968,1,3)|0)==0){q=32;i=k;return q|0}if((Aca(l,24976,1,3)|0)==0){q=32;i=k;return q|0}if((Aca(l,24984,1,3)|0)==0){q=32;i=k;return q|0}if((Aca(l,24992,1,3)|0)==0){q=32;i=k;return q|0}if((Aca(l,25e3,1,3)|0)==0){q=32;i=k;return q|0}m=(Aca(l,25008,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((Aca(u,25016,1,2)|0)==0){m=(Aca(l,24952,1,3)|0)==0;q=m?64:1;i=k;return q|0}if((Aca(u,25024,1,2)|0)==0){m=(Aca(l,24952,1,3)|0)==0;if(m|s^1){q=m?64:1;i=k;return q|0}m=(Aca(l,25032,1,3)|0)==0;if(m){q=m?32:1;i=k;return q|0}m=(Aca(l,25040,1,3)|0)==0;q=m?64:1;i=k;return q|0}do{if(v<<24>>24==68|v<<24>>24==83){w=29}else if(v<<24>>24==67|v<<24>>24==90){if((Aca(u,25048,1,2)|0)!=0){if(v<<24>>24==68|v<<24>>24==83){w=29;break}else if(v<<24>>24==67|v<<24>>24==90){w=48;break}else{break}}if((Aca(l,24952,1,3)|0)==0){q=64;i=k;return q|0}if((Aca(l,25032,1,3)|0)==0){q=32;i=k;return q|0}m=(Aca(l,25040,1,3)|0)==0;q=m?64:1;i=k;return q|0}}while(0);do{if((w|0)==29){if((Aca(u,25056,1,2)|0)!=0){if(v<<24>>24==67|v<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((Aca(o,25064,1,2)|0)!=0){if((Aca(o,25072,1,2)|0)==0){break}if((Aca(o,25080,1,2)|0)==0){break}if((Aca(o,25088,1,2)|0)==0){break}if((Aca(o,25096,1,2)|0)==0){break}if((Aca(o,25104,1,2)|0)==0){break}if((Aca(o,25112,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==77){do{if((Aca(o,25064,1,2)|0)!=0){if((Aca(o,25072,1,2)|0)==0){break}if((Aca(o,25080,1,2)|0)==0){break}if((Aca(o,25088,1,2)|0)==0){break}if((Aca(o,25096,1,2)|0)==0){break}if((Aca(o,25104,1,2)|0)==0){break}if((Aca(o,25112,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);do{if((w|0)==48){if((Aca(u,25120,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==77){do{if((Aca(o,25064,1,2)|0)!=0){if((Aca(o,25072,1,2)|0)==0){break}if((Aca(o,25080,1,2)|0)==0){break}if((Aca(o,25088,1,2)|0)==0){break}if((Aca(o,25096,1,2)|0)==0){break}if((Aca(o,25104,1,2)|0)==0){break}if((Aca(o,25112,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else if(m<<24>>24==71){do{if((Aca(o,25064,1,2)|0)!=0){if((Aca(o,25072,1,2)|0)==0){break}if((Aca(o,25080,1,2)|0)==0){break}if((Aca(o,25088,1,2)|0)==0){break}if((Aca(o,25096,1,2)|0)==0){break}if((Aca(o,25104,1,2)|0)==0){break}if((Aca(o,25112,1,2)|0)==0){break}else{q=1}i=k;return q|0}}while(0);q=32;i=k;return q|0}else{q=1;i=k;return q|0}}}while(0);if((Aca(u,25128,1,2)|0)==0){if((Aca(l,24952,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[j>>2]|0)<65?1:32;i=k;return q|0}if((Aca(u,25136,1,2)|0)==0){if((Aca(l,24952,1,3)|0)!=0){q=1;i=k;return q|0}q=(c[g>>2]|0)<65?1:32;i=k;return q|0}if((Aca(u,25104,1,2)|0)==0){o=(Aca(l,25008,1,3)|0)==0;q=o?64:1;i=k;return q|0}if((Aca(u,25144,1,2)|0)==0){o=(Aca(l,25152,1,3)|0)==0;q=o?64:1;i=k;return q|0}if(!(v<<24>>24==68|v<<24>>24==83)){q=1;i=k;return q|0}if((Aca(u,25160,1,2)|0)==0){i=k;return 1}else{q=1;i=k;return q|0}}break};case 6:{u=c[f>>2]|0;v=c[g>>2]|0;q=~~(+(((u|0)>(v|0)?v:u)|0)*1.600000023841858);i=k;return q|0};case 7:{q=1;i=k;return q|0};case 8:{q=50;i=k;return q|0};case 9:{q=25;i=k;return q|0};case 10:{q=mR(25176,25184,25192)|0;i=k;return q|0};case 11:{q=mR(25200,25184,25192)|0;i=k;return q|0};case 16:case 15:case 14:case 13:case 12:{q=nR(b,d,e,f,g,h,j)|0;i=k;return q|0};default:{q=-1;i=k;return q|0}}return 0}function mR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function nR(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(zca(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 15:{p=o;i=j;return p|0};case 12:{p=75;i=j;return p|0};case 14:{p=14;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};default:{p=-1;i=j;return p|0}}return 0}function oR(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=pR(a,0,0)|0;i=b;return c|0}function pR(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=qR(a,b,c,0)|0;i=d;return e|0}function qR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ie[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=Soa(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=163}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ie[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){fe[c[b+8>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ie[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){fe[c[b+20>>2]&255](c[j+392>>2]|0);fe[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=BS(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}fe[c[j+20>>2]&255](c[j+44>>2]|0);fe[c[j+20>>2]&255](c[j+392>>2]|0);fe[c[j+20>>2]&255](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;CS(j+416|0,j+12|0);CS(j+440|0,j+12|0);sR(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}vR(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=WS()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=NS()|0}k=j;l=k;i=g;return l|0}function rR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function sR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;dV(f+256|0);if((b|0)!=0){g=tR(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;OS(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function tR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((KR(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function uR(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=NR(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=tR(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((KR(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((KR(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((RR(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=NR(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function vR(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;fe[c[e+20>>2]&255](c[g+36>>2]|0);wR(c[g+44>>2]|0,e);fe[c[e+20>>2]&255](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;fe[c[e+20>>2]&255](f)}wR(c[h+376>>2]|0,e);wR(c[e+372>>2]|0,e);xR(e+416|0);xR(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}yR(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);fe[c[e+20>>2]&255](c[e+392>>2]|0);fe[c[e+20>>2]&255](c[e+464>>2]|0);fe[c[e+20>>2]&255](c[e+8>>2]|0);fe[c[e+20>>2]&255](c[e+44>>2]|0);fe[c[e+20>>2]&255](c[e+396>>2]|0);fe[c[e+20>>2]&255](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){fe[c[e+252>>2]&255](c[e+244>>2]|0)}fe[c[e+20>>2]&255](e);i=d;return}function wR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;fe[c[a+20>>2]&255](c[b+16>>2]|0);fe[c[a+20>>2]&255](b)}i=d;return}



function ola(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=109944;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);Fea(b+144|0,109928,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[114836>>2]=0;c[28708]=108424;if(!((c[27112]|0)==-1)){c[G>>2]=108448;c[G+4>>2]=186;c[G+8>>2]=0;yea(108448,G,187)}pla(b,114832,(c[108452>>2]|0)+ -1|0);c[114828>>2]=0;c[28706]=108464;if(!((c[27122]|0)==-1)){c[F>>2]=108488;c[F+4>>2]=186;c[F+8>>2]=0;yea(108488,F,187)}pla(b,114824,(c[108492>>2]|0)+ -1|0);c[114812>>2]=0;c[28702]=110040;c[114816>>2]=0;a[114820|0]=0;F=c[(yc()|0)>>2]|0;c[114816>>2]=F;if(!((c[27506]|0)==-1)){c[E>>2]=110024;c[E+4>>2]=186;c[E+8>>2]=0;yea(110024,E,187)}pla(b,114808,(c[110028>>2]|0)+ -1|0);c[114804>>2]=0;c[28700]=111e3;if(!((c[27504]|0)==-1)){c[D>>2]=110016;c[D+4>>2]=186;c[D+8>>2]=0;yea(110016,D,187)}pla(b,114800,(c[110020>>2]|0)+ -1|0);c[114796>>2]=0;c[28698]=111216;if(!((c[27522]|0)==-1)){c[C>>2]=110088;c[C+4>>2]=186;c[C+8>>2]=0;yea(110088,C,187)}pla(b,114792,(c[110092>>2]|0)+ -1|0);c[114780>>2]=0;c[28694]=110112;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);c[114784>>2]=c[27478];if(!((c[27524]|0)==-1)){c[B>>2]=110096;c[B+4>>2]=186;c[B+8>>2]=0;yea(110096,B,187)}pla(b,114776,(c[110100>>2]|0)+ -1|0);c[114772>>2]=0;c[28692]=111440;if(!((c[27538]|0)==-1)){c[A>>2]=110152;c[A+4>>2]=186;c[A+8>>2]=0;yea(110152,A,187)}pla(b,114768,(c[110156>>2]|0)+ -1|0);c[114764>>2]=0;c[28690]=111560;if(!((c[27540]|0)==-1)){c[z>>2]=110160;c[z+4>>2]=186;c[z+8>>2]=0;yea(110160,z,187)}pla(b,114760,(c[110164>>2]|0)+ -1|0);c[114740>>2]=0;c[28684]=110192;a[114744|0]=46;a[114745|0]=44;z=114748|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[27542]|0)==-1)){c[y>>2]=110168;c[y+4>>2]=186;c[y+8>>2]=0;yea(110168,y,187)}pla(b,114736,(c[110172>>2]|0)+ -1|0);c[114708>>2]=0;c[28676]=110232;c[114712>>2]=46;c[114716>>2]=44;y=114720|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[27544]|0)==-1)){c[x>>2]=110176;c[x+4>>2]=186;c[x+8>>2]=0;yea(110176,x,187)}pla(b,114704,(c[110180>>2]|0)+ -1|0);c[114700>>2]=0;c[28674]=108504;if(!((c[27140]|0)==-1)){c[w>>2]=108560;c[w+4>>2]=186;c[w+8>>2]=0;yea(108560,w,187)}pla(b,114696,(c[108564>>2]|0)+ -1|0);c[114692>>2]=0;c[28672]=108624;if(!((c[27170]|0)==-1)){c[v>>2]=108680;c[v+4>>2]=186;c[v+8>>2]=0;yea(108680,v,187)}pla(b,114688,(c[108684>>2]|0)+ -1|0);c[114684>>2]=0;c[28670]=108696;if(!((c[27186]|0)==-1)){c[u>>2]=108744;c[u+4>>2]=186;c[u+8>>2]=0;yea(108744,u,187)}pla(b,114680,(c[108748>>2]|0)+ -1|0);c[114676>>2]=0;c[28668]=108760;if(!((c[27202]|0)==-1)){c[t>>2]=108808;c[t+4>>2]=186;c[t+8>>2]=0;yea(108808,t,187)}pla(b,114672,(c[108812>>2]|0)+ -1|0);c[114668>>2]=0;c[28666]=109352;if(!((c[27350]|0)==-1)){c[s>>2]=109400;c[s+4>>2]=186;c[s+8>>2]=0;yea(109400,s,187)}pla(b,114664,(c[109404>>2]|0)+ -1|0);c[114660>>2]=0;c[28664]=109416;if(!((c[27366]|0)==-1)){c[r>>2]=109464;c[r+4>>2]=186;c[r+8>>2]=0;yea(109464,r,187)}pla(b,114656,(c[109468>>2]|0)+ -1|0);c[114652>>2]=0;c[28662]=109480;if(!((c[27382]|0)==-1)){c[q>>2]=109528;c[q+4>>2]=186;c[q+8>>2]=0;yea(109528,q,187)}pla(b,114648,(c[109532>>2]|0)+ -1|0);c[114644>>2]=0;c[28660]=109544;if(!((c[27398]|0)==-1)){c[p>>2]=109592;c[p+4>>2]=186;c[p+8>>2]=0;yea(109592,p,187)}pla(b,114640,(c[109596>>2]|0)+ -1|0);c[114636>>2]=0;c[28658]=109608;if(!((c[27408]|0)==-1)){c[o>>2]=109632;c[o+4>>2]=186;c[o+8>>2]=0;yea(109632,o,187)}pla(b,114632,(c[109636>>2]|0)+ -1|0);c[114628>>2]=0;c[28656]=109688;if(!((c[27428]|0)==-1)){c[n>>2]=109712;c[n+4>>2]=186;c[n+8>>2]=0;yea(109712,n,187)}pla(b,114624,(c[109716>>2]|0)+ -1|0);c[114620>>2]=0;c[28654]=109744;if(!((c[27442]|0)==-1)){c[m>>2]=109768;c[m+4>>2]=186;c[m+8>>2]=0;yea(109768,m,187)}pla(b,114616,(c[109772>>2]|0)+ -1|0);c[114612>>2]=0;c[28652]=109792;if(!((c[27454]|0)==-1)){c[l>>2]=109816;c[l+4>>2]=186;c[l+8>>2]=0;yea(109816,l,187)}pla(b,114608,(c[109820>>2]|0)+ -1|0);c[114596>>2]=0;c[28648]=108840;c[114600>>2]=108888;if(!((c[27230]|0)==-1)){c[k>>2]=108920;c[k+4>>2]=186;c[k+8>>2]=0;yea(108920,k,187)}pla(b,114592,(c[108924>>2]|0)+ -1|0);c[114580>>2]=0;c[28644]=108992;c[114584>>2]=109040;if(!((c[27268]|0)==-1)){c[j>>2]=109072;c[j+4>>2]=186;c[j+8>>2]=0;yea(109072,j,187)}pla(b,114576,(c[109076>>2]|0)+ -1|0);c[114564>>2]=0;c[28640]=110936;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);c[114568>>2]=c[27478];c[28640]=109288;if(!((c[27326]|0)==-1)){c[h>>2]=109304;c[h+4>>2]=186;c[h+8>>2]=0;yea(109304,h,187)}pla(b,114560,(c[109308>>2]|0)+ -1|0);c[114548>>2]=0;c[28636]=110936;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);c[114552>>2]=c[27478];c[28636]=109320;if(!((c[27334]|0)==-1)){c[g>>2]=109336;c[g+4>>2]=186;c[g+8>>2]=0;yea(109336,g,187)}pla(b,114544,(c[109340>>2]|0)+ -1|0);c[114540>>2]=0;c[28634]=109832;if(!((c[27464]|0)==-1)){c[f>>2]=109856;c[f+4>>2]=186;c[f+8>>2]=0;yea(109856,f,187)}pla(b,114536,(c[109860>>2]|0)+ -1|0);c[114532>>2]=0;c[28632]=109872;if((c[27474]|0)==-1){N=109896;O=109896;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=114528;pla(b,T,S);i=e;return}c[H>>2]=109896;c[H+4>>2]=186;c[H+8>>2]=0;yea(109896,H,187);N=109896;O=109896;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=114528;pla(b,T,S);i=e;return}function pla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;cea(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){una(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}dea(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function qla(a){a=a|0;var b=0;b=i;rla(a);_oa(a);i=b;return}function rla(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=109944;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{dea(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}Nea(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{_oa(h);i=d;return}}function sla(){var b=0,d=0,e=0,f=0;b=i;if((a[11e4]|0)!=0){d=109992;e=c[27498]|0;i=b;return e|0}if((Za(11e4)|0)==0){d=109992;e=c[27498]|0;i=b;return e|0}do{if((a[109976]|0)==0){if((Za(109976)|0)==0){break}ola(114368,1);c[27490]=114368;c[27492]=109960;Tb(109976)}}while(0);f=c[c[27492]>>2]|0;c[27496]=f;cea(f);c[27498]=109984;Tb(11e4);d=109992;e=c[27498]|0;i=b;return e|0}function tla(a){a=a|0;var b=0,d=0;b=i;d=c[(sla()|0)>>2]|0;c[a>>2]=d;cea(d);i=b;return}function ula(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;cea(e);i=d;return}function vla(a){a=a|0;var b=0;b=i;dea(c[a>>2]|0)|0;i=b;return}function wla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=186;c[e+8>>2]=0;yea(a,e,187)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function xla(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=186;c[e+8>>2]=0;yea(a,e,187)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;xoa(h);j=125584;k=127;Td(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;xoa(h);j=125584;k=127;Td(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function yla(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function zla(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}fe[c[(c[a>>2]|0)+4>>2]&255](a);i=b;return}function Ala(a){a=a|0;var b=0;b=c[27502]|0;c[27502]=1+b;c[a+4>>2]=b+1;i=i;return}function Bla(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Cla(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function Dla(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function Ela(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function Fla(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function Gla(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Hla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Ila(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Jla(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Kla(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function Lla(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function Mla(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function Nla(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function Ola(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=110040;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}$oa(e)}}while(0);_oa(b);i=d;return}function Pla(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=110040;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}$oa(e);i=d;return}function Qla(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function Rla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Sla(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function Tla(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Id()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function Ula(a,b){a=a|0;b=b|0;i=i;return b|0}function Vla(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function Wla(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function Xla(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function Yla(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Zla(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function _la(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function $la(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function ama(a){a=a|0;i=i;return 1}function bma(a){a=a|0;i=i;return 1}function cma(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function dma(a){a=a|0;i=i;return 1}function ema(a){a=a|0;var b=0;b=i;mla(a);_oa(a);i=b;return}function fma(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=Yna(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==0){B=1;C=33;break}else if((A|0)==-1){C=10;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){C=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=Xna(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=2;C=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){B=1;C=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((C|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=Xna(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;B=2;i=l;return B|0}else if((C|0)==31){q=c[g>>2]|0;break}else if((C|0)==33){i=l;return B|0}}}while(0);B=(q|0)!=(f|0)|0;i=l;return B|0}function gma(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=Una(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==0){A=2;B=32;break}else if((y|0)==-1){B=10;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){B=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=Tna(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){A=2;B=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((B|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=Tna(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==-1){B=15;break}else if((y|0)==-2){B=16;break}else if((y|0)==0){I=v+1|0}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((B|0)==15){c[g>>2]=v;A=2;i=l;return A|0}else if((B|0)==16){c[g>>2]=v;A=1;i=l;return A|0}}}while(0);c[g>>2]=H;A=(H|0)!=(f|0)|0;i=l;return A|0}else if((B|0)==30){p=c[g>>2]|0;break}else if((B|0)==32){i=l;return A|0}}}while(0);A=(p|0)!=(f|0)|0;i=l;return A|0}function hma(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=Xna(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function ima(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=Wna(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function jma(a){a=a|0;i=i;return 0}function kma(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=Sna(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==-2|(n|0)==-1){h=d;o=9;break}else if((n|0)==0){p=a+1|0;q=1}else{p=a+n|0;q=n}n=q+d|0;m=l+1|0;if(m>>>0>=f>>>0|(p|0)==(e|0)){h=n;o=9;break}else{a=p;d=n;l=m}}if((o|0)==9){i=g;return h|0}return 0}function lma(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function mma(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function nma(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=oma(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function oma(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function pma(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=qma(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function qma(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function rma(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function sma(a){a=a|0;i=i;return 0}function tma(a){a=a|0;i=i;return 0}function uma(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=vma(c,d,e,1114111,0)|0;i=b;return a|0}function vma(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function wma(a){a=a|0;i=i;return 4}function xma(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function yma(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=zma(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function zma(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function Ama(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Bma(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function Bma(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function Cma(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function Dma(a){a=a|0;i=i;return 0}function Ema(a){a=a|0;i=i;return 0}function Fma(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=Gma(c,d,e,1114111,0)|0;i=b;return a|0}function Gma(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function Hma(a){a=a|0;i=i;return 4}function Ima(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Jma(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function Kma(a){a=a|0;var b=0;b=i;c[a>>2]=110192;Nea(a+12|0);_oa(a);i=b;return}function Lma(a){a=a|0;var b=0;b=i;c[a>>2]=110192;Nea(a+12|0);i=b;return}function Mma(a){a=a|0;var b=0;b=i;c[a>>2]=110232;Nea(a+16|0);_oa(a);i=b;return}function Nma(a){a=a|0;var b=0;b=i;c[a>>2]=110232;Nea(a+16|0);i=b;return}function Oma(b){b=b|0;i=i;return a[b+8|0]|0}function Pma(a){a=a|0;i=i;return c[a+8>>2]|0}function Qma(b){b=b|0;i=i;return a[b+9|0]|0}function Rma(a){a=a|0;i=i;return c[a+12>>2]|0}function Sma(a,b){a=a|0;b=b|0;var c=0;c=i;Dea(a,b+12|0);i=c;return}function Tma(a,b){a=a|0;b=b|0;var c=0;c=i;Dea(a,b+16|0);i=c;return}function Uma(a,b){a=a|0;b=b|0;b=i;Fea(a,110264,4);i=b;return}function Vma(a,b){a=a|0;b=b|0;b=i;nfa(a,110272,soa(110272)|0);i=b;return}function Wma(a,b){a=a|0;b=b|0;b=i;Fea(a,110296,5);i=b;return}function Xma(a,b){a=a|0;b=b|0;b=i;nfa(a,110304,soa(110304)|0);i=b;return}function Yma(b){b=b|0;var d=0,e=0;b=i;if((a[110336]|0)!=0){d=110328;e=c[27582]|0;i=b;return e|0}if((Za(110336)|0)==0){d=110328;e=c[27582]|0;i=b;return e|0}do{if((a[117536]|0)==0){if((Za(117536)|0)==0){break}ypa(117368,0,168)|0;Zd(189,0,q|0)|0;Tb(117536)}}while(0);Qea(117368,117544)|0;Qea(117380|0,117552)|0;Qea(117392|0,117560)|0;Qea(117404|0,117568)|0;Qea(117416|0,117584)|0;Qea(117428|0,117600)|0;Qea(117440|0,117608)|0;Qea(117452|0,117624)|0;Qea(117464|0,117632)|0;Qea(117476|0,117640)|0;Qea(117488|0,117648)|0;Qea(117500|0,117656)|0;Qea(117512|0,117664)|0;Qea(117524|0,117672)|0;c[27582]=117368;Tb(110336);d=110328;e=c[27582]|0;i=b;return e|0}function Zma(b){b=b|0;var d=0,e=0;b=i;if((a[110352]|0)!=0){d=110344;e=c[27586]|0;i=b;return e|0}if((Za(110352)|0)==0){d=110344;e=c[27586]|0;i=b;return e|0}do{if((a[117e3]|0)==0){if((Za(117e3)|0)==0){break}ypa(116832,0,168)|0;Zd(190,0,q|0)|0;Tb(117e3)}}while(0);qfa(116832,117008)|0;qfa(116844|0,117040)|0;qfa(116856|0,117072)|0;qfa(116868|0,117104)|0;qfa(116880|0,117144)|0;qfa(116892|0,117184)|0;qfa(116904|0,117216)|0;qfa(116916|0,117256)|0;qfa(116928|0,117272)|0;qfa(116940|0,117288)|0;qfa(116952|0,117304)|0;qfa(116964|0,117320)|0;qfa(116976|0,117336)|0;qfa(116988|0,117352)|0;c[27586]=116832;Tb(110352);d=110344;e=c[27586]|0;i=b;return e|0}function _ma(b){b=b|0;var d=0,e=0;b=i;if((a[110368]|0)!=0){d=110360;e=c[27590]|0;i=b;return e|0}if((Za(110368)|0)==0){d=110360;e=c[27590]|0;i=b;return e|0}do{if((a[116608]|0)==0){if((Za(116608)|0)==0){break}ypa(116320,0,288)|0;Zd(191,0,q|0)|0;Tb(116608)}}while(0);Qea(116320,116616)|0;Qea(116332|0,116624)|0;Qea(116344|0,116640)|0;Qea(116356|0,116648)|0;Qea(116368|0,116656)|0;Qea(116380|0,116664)|0;Qea(116392|0,116672)|0;Qea(116404|0,116680)|0;Qea(116416|0,116688)|0;Qea(116428|0,116704)|0;Qea(116440|0,116712)|0;Qea(116452|0,116728)|0;Qea(116464|0,116744)|0;Qea(116476|0,116752)|0;Qea(116488|0,116760)|0;Qea(116500|0,116768)|0;Qea(116512|0,116656)|0;Qea(116524|0,116776)|0;Qea(116536|0,116784)|0;Qea(116548|0,116792)|0;Qea(116560|0,116800)|0;Qea(116572|0,116808)|0;Qea(116584|0,116816)|0;Qea(116596|0,116824)|0;c[27590]=116320;Tb(110368);d=110360;e=c[27590]|0;i=b;return e|0}function $ma(b){b=b|0;var d=0,e=0;b=i;if((a[110384]|0)!=0){d=110376;e=c[27594]|0;i=b;return e|0}if((Za(110384)|0)==0){d=110376;e=c[27594]|0;i=b;return e|0}do{if((a[115768]|0)==0){if((Za(115768)|0)==0){break}ypa(115480,0,288)|0;Zd(192,0,q|0)|0;Tb(115768)}}while(0);qfa(115480,115776)|0;qfa(115492|0,115808)|0;qfa(115504|0,115848)|0;qfa(115516|0,115872)|0;qfa(115528|0,116192)|0;qfa(115540|0,115896)|0;qfa(115552|0,115920)|0;qfa(115564|0,115944)|0;qfa(115576|0,115976)|0;qfa(115588|0,116016)|0;qfa(115600|0,116048)|0;qfa(115612|0,116088)|0;qfa(115624|0,116128)|0;qfa(115636|0,116144)|0;qfa(115648|0,116160)|0;qfa(115660|0,116176)|0;qfa(115672|0,116192)|0;qfa(115684|0,116208)|0;qfa(115696|0,116224)|0;qfa(115708|0,116240)|0;qfa(115720|0,116256)|0;qfa(115732|0,116272)|0;qfa(115744|0,116288)|0;qfa(115756|0,116304)|0;c[27594]=115480;Tb(110384);d=110376;e=c[27594]|0;i=b;return e|0}function ana(b){b=b|0;var d=0,e=0;b=i;if((a[110400]|0)!=0){d=110392;e=c[27598]|0;i=b;return e|0}if((Za(110400)|0)==0){d=110392;e=c[27598]|0;i=b;return e|0}do{if((a[115456]|0)==0){if((Za(115456)|0)==0){break}ypa(115168,0,288)|0;Zd(193,0,q|0)|0;Tb(115456)}}while(0);Qea(115168,115464)|0;Qea(115180|0,115472)|0;c[27598]=115168;Tb(110400);d=110392;e=c[27598]|0;i=b;return e|0}function bna(b){b=b|0;var d=0,e=0;b=i;if((a[110416]|0)!=0){d=110408;e=c[27602]|0;i=b;return e|0}if((Za(110416)|0)==0){d=110408;e=c[27602]|0;i=b;return e|0}do{if((a[115128]|0)==0){if((Za(115128)|0)==0){break}ypa(114840,0,288)|0;Zd(194,0,q|0)|0;Tb(115128)}}while(0);qfa(114840,115136)|0;qfa(114852|0,115152)|0;c[27602]=114840;Tb(110416);d=110408;e=c[27602]|0;i=b;return e|0}function cna(b){b=b|0;var c=0;b=i;if((a[110440]|0)!=0){c=110424;i=b;return c|0}if((Za(110440)|0)==0){c=110424;i=b;return c|0}Fea(110424,110448,8);Zd(195,110424,q|0)|0;Tb(110440);c=110424;i=b;return c|0}function dna(b){b=b|0;var c=0;b=i;if((a[110480]|0)!=0){c=110464;i=b;return c|0}if((Za(110480)|0)==0){c=110464;i=b;return c|0}nfa(110464,110488,soa(110488)|0);Zd(196,110464,q|0)|0;Tb(110480);c=110464;i=b;return c|0}function ena(b){b=b|0;var c=0;b=i;if((a[110544]|0)!=0){c=110528;i=b;return c|0}if((Za(110544)|0)==0){c=110528;i=b;return c|0}Fea(110528,110552,8);Zd(195,110528,q|0)|0;Tb(110544);c=110528;i=b;return c|0}function fna(b){b=b|0;var c=0;b=i;if((a[110584]|0)!=0){c=110568;i=b;return c|0}if((Za(110584)|0)==0){c=110568;i=b;return c|0}nfa(110568,110592,soa(110592)|0);Zd(196,110568,q|0)|0;Tb(110584);c=110568;i=b;return c|0}function gna(b){b=b|0;var c=0;b=i;if((a[110648]|0)!=0){c=110632;i=b;return c|0}if((Za(110648)|0)==0){c=110632;i=b;return c|0}Fea(110632,110656,20);Zd(195,110632,q|0)|0;Tb(110648);c=110632;i=b;return c|0}function hna(b){b=b|0;var c=0;b=i;if((a[110696]|0)!=0){c=110680;i=b;return c|0}if((Za(110696)|0)==0){c=110680;i=b;return c|0}nfa(110680,110704,soa(110704)|0);Zd(196,110680,q|0)|0;Tb(110696);c=110680;i=b;return c|0}function ina(b){b=b|0;var c=0;b=i;if((a[110808]|0)!=0){c=110792;i=b;return c|0}if((Za(110808)|0)==0){c=110792;i=b;return c|0}Fea(110792,110816,11);Zd(195,110792,q|0)|0;Tb(110808);c=110792;i=b;return c|0}function jna(b){b=b|0;var c=0;b=i;if((a[110848]|0)!=0){c=110832;i=b;return c|0}if((Za(110848)|0)==0){c=110832;i=b;return c|0}nfa(110832,110856,soa(110856)|0);Zd(196,110832,q|0)|0;Tb(110848);c=110832;i=b;return c|0}function kna(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);l=+opa(b,g,c[27478]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function lna(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);l=+opa(b,g,c[27478]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function mna(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);l=+opa(b,g,c[27478]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function nna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);n=lb(b|0,h|0,f|0,c[27478]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function ona(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);m=lb(b|0,h|0,f|0,c[27478]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function pna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);m=lb(b|0,h|0,f|0,c[27478]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function qna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);m=lb(b|0,h|0,f|0,c[27478]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function rna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);n=Gc(b|0,h|0,f|0,c[27478]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function sna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[109920]|0)==0){if((Za(109920)|0)==0){break}c[27478]=Zb(2147483647,109928,0)|0;Tb(109920)}}while(0);m=Gc(b|0,h|0,f|0,c[27478]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function tna(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;fe[h&255](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;fe[h&255](a);i=b;return}}function una(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){nla(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=Yoa(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;wpa(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{_oa(h);i=e;return}}function vna(a){a=a|0;a=i;pfa(115116|0);pfa(115104|0);pfa(115092|0);pfa(115080|0);pfa(115068|0);pfa(115056|0);pfa(115044|0);pfa(115032|0);pfa(115020|0);pfa(115008|0);pfa(114996|0);pfa(114984|0);pfa(114972|0);pfa(114960|0);pfa(114948|0);pfa(114936|0);pfa(114924|0);pfa(114912|0);pfa(114900|0);pfa(114888|0);pfa(114876|0);pfa(114864|0);pfa(114852|0);pfa(114840);i=a;return}function wna(a){a=a|0;a=i;Nea(115444|0);Nea(115432|0);Nea(115420|0);Nea(115408|0);Nea(115396|0);Nea(115384|0);Nea(115372|0);Nea(115360|0);Nea(115348|0);Nea(115336|0);Nea(115324|0);Nea(115312|0);Nea(115300|0);Nea(115288|0);Nea(115276|0);Nea(115264|0);Nea(115252|0);Nea(115240|0);Nea(115228|0);Nea(115216|0);Nea(115204|0);Nea(115192|0);Nea(115180|0);Nea(115168);i=a;return}function xna(a){a=a|0;a=i;pfa(115756|0);pfa(115744|0);pfa(115732|0);pfa(115720|0);pfa(115708|0);pfa(115696|0);pfa(115684|0);pfa(115672|0);pfa(115660|0);pfa(115648|0);pfa(115636|0);pfa(115624|0);pfa(115612|0);pfa(115600|0);pfa(115588|0);pfa(115576|0);pfa(115564|0);pfa(115552|0);pfa(115540|0);pfa(115528|0);pfa(115516|0);pfa(115504|0);pfa(115492|0);pfa(115480);i=a;return}function yna(a){a=a|0;a=i;Nea(116596|0);Nea(116584|0);Nea(116572|0);Nea(116560|0);Nea(116548|0);Nea(116536|0);Nea(116524|0);Nea(116512|0);Nea(116500|0);Nea(116488|0);Nea(116476|0);Nea(116464|0);Nea(116452|0);Nea(116440|0);Nea(116428|0);Nea(116416|0);Nea(116404|0);Nea(116392|0);Nea(116380|0);Nea(116368|0);Nea(116356|0);Nea(116344|0);Nea(116332|0);Nea(116320);i=a;return}function zna(a){a=a|0;a=i;pfa(116988|0);pfa(116976|0);pfa(116964|0);pfa(116952|0);pfa(116940|0);pfa(116928|0);pfa(116916|0);pfa(116904|0);pfa(116892|0);pfa(116880|0);pfa(116868|0);pfa(116856|0);pfa(116844|0);pfa(116832);i=a;return}function Ana(a){a=a|0;a=i;Nea(117524|0);Nea(117512|0);Nea(117500|0);Nea(117488|0);Nea(117476|0);Nea(117464|0);Nea(117452|0);Nea(117440|0);Nea(117428|0);Nea(117416|0);Nea(117404|0);Nea(117392|0);Nea(117380|0);Nea(117368);i=a;return}function Bna(a){a=a|0;var b=0,c=0;b=i;if((Hna(a)|0)==0){c=(Cna(a)|0)!=0|0}else{c=1}i=b;return c|0}function Cna(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[117680+((d[117680+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function Dna(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function Ena(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function Fna(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 8:{d=Kna(a)|0;break};case 9:{d=Lna(a)|0;break};case 4:{d=Ena(a)|0;break};case 12:{d=Ona(a)|0;break};case 5:{d=Hna(a)|0;break};case 2:{d=Cna(a)|0;break};case 10:{d=Mna(a)|0;break};case 6:{d=Ina(a)|0;break};case 7:{d=Jna(a)|0;break};case 3:{d=Dna(a)|0;break};case 1:{d=Bna(a)|0;break};case 11:{d=Nna(a)|0;break};default:{d=0}}i=c;return d|0}function Gna(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=120656;while(1){if(d<<24>>24==e<<24>>24){if((qpa(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function Hna(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function Ina(a){a=a|0;var b=0,c=0;b=i;if((Mna(a)|0)==0){c=(Kna(a)|0)!=0|0}else{c=0}i=b;return c|0}function Jna(a){a=a|0;var b=0,c=0;b=i;if((Pna(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function Kna(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function Lna(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[120736+((d[120736+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function Mna(a){a=a|0;var b=0,c=0;b=i;c=(roa(123904,a)|0)!=0|0;i=b;return c|0}function Nna(a){a=a|0;var b=0,c=0;b=i;c=(Rna(a)|0)!=(a|0)|0;i=b;return c|0}function Ona(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function Pna(a){a=a|0;var b=0,c=0;b=i;c=Qna(a,0)|0;i=b;return c|0}function Qna(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((Cna(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[123994+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[123992+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[123995+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[124240+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[124240+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[124240+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function Rna(a){a=a|0;var b=0,c=0;b=i;c=Qna(a,1)|0;i=b;return c|0}function Sna(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=Tna(0,a,b,(c|0)!=0?c:124944)|0;i=d;return e|0}function Tna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?124952:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[124736+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function Una(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=Vna(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=Tna(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==-1){C=-1;break}else if((I|0)==0){c[h>>2]=0;C=G;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function Vna(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[124736+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[124736+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function Wna(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[124736+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function Xna(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function Yna(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=Zna(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=Xna(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function Zna(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=Xna(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=Xna(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=Xna(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}Xna(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function _na(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=Soa(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=Soa(2048)|0;c[p+16>>2]=s;if((s|0)==0){Toa(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=ooa(0,0)|0;if((s|0)==0){Toa(c[p+16>>2]|0);Toa(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=$na(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=Uoa(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=aoa(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=Soa(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;ypa(y|0,-1,v|0)|0;I=H}else{I=0}H=Uoa(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=Uoa(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=aoa(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=goa(q,x)|0;b:do{if((v|0)==0){y=goa(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==0){P=c[S>>2]|0;if((P|0)==1){T=c[S+4>>2]|0;U=goa(q,c[T+4>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}U=goa(q,0)|0;if((U|0)!=0){V=N;W=U;break c}U=goa(q,c[T>>2]|0)|0;if((U|0)!=0){V=N;W=U;break c}X=goa(q,0)|0}else if((P|0)==3){U=c[S+4>>2]|0;T=goa(q,c[U+4>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=goa(q,0)|0;if((T|0)!=0){V=N;W=T;break c}T=goa(q,c[U>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}X=goa(q,0)|0}else if((P|0)==0){T=c[S+4>>2]|0;U=c[T>>2]|0;if(!((U|0)>-1|(U|0)==-4)){Y=L;Z=M;_=N;break}U=T+8|0;T=(c[U>>2]|0)+L|0;c[U>>2]=T;if((T|0)<=(c[k>>2]|0)){Y=L;Z=M;_=N;break}c[k>>2]=T;Y=L;Z=M;_=N;break}else if((P|0)==2){P=c[S+4>>2]|0;T=goa(q,L)|0;if((T|0)!=0){V=N;W=T;break c}T=goa(q,S)|0;if((T|0)!=0){V=N;W=T;break c}T=goa(q,1)|0;if((T|0)!=0){V=N;W=T;break c}T=goa(q,c[P>>2]|0)|0;if((T|0)!=0){V=N;W=T;break c}T=goa(q,0)|0;if((T|0)!=0){V=N;W=T;break c}if((c[P+4>>2]|0)>1){F=45}else{if((c[P+8>>2]|0)>1){F=45}else{$=L}}if((F|0)==45){F=0;c[j>>2]=0;$=0}Y=$;Z=M+1|0;_=N;break}else{Y=L;Z=M;_=N;break}if((X|0)==0){Y=L;Z=M;_=N}else{V=N;W=X;break c}}else if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;aa=c[Q+(U<<2)>>2]|0;c[j>>2]=aa;U=T+4|0;ba=c[U>>2]|0;do{if((ba|0)>1){c[l>>2]=0;ca=T;F=51}else{if((c[T+8>>2]|0)<=1){da=aa;break}c[l>>2]=0;ea=T;if((ba|0)>0){ca=ea;F=51}else{fa=ba;ga=ea;ha=aa;ia=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;ea=aa;ja=ba;ka=1;la=0;while(1){ma=hoa(s,q,c[ca>>2]|0,(ka|0)<(ja|0)?1:2,j,G,m,k)|0;if((ma|0)!=0){J=ma;break b}ma=c[m>>2]|0;if((la|0)==0){na=ma}else{oa=qoa(s,0,0,1,32)|0;if((oa|0)==0){J=12;break b}pa=qoa(s,0,0,1,8)|0;qa=oa+4|0;c[qa>>2]=pa;if((pa|0)==0){J=12;break b}c[oa>>2]=1;c[oa+8>>2]=-1;c[oa+12>>2]=-1;c[pa>>2]=la;c[(c[qa>>2]|0)+4>>2]=ma;c[oa+16>>2]=(c[ma+16>>2]|0)+(c[la+16>>2]|0);na=oa}if((na|0)==0){J=12;break b}oa=c[U>>2]|0;if((ka|0)>=(oa|0)){fa=oa;ga=ca;ha=ea;ia=na;F=60;break e}ea=c[j>>2]|0;ja=oa;ka=ka+1|0;la=na}}}while(0);if((F|0)==60){F=0;U=T+8|0;ba=c[U>>2]|0;do{if((ba|0)==-1){la=c[j>>2]|0;ka=hoa(s,q,c[ga>>2]|0,0,j,0,l,k)|0;if((ka|0)!=0){J=ka;break b}ka=c[l>>2]|0;ja=qoa(s,0,0,1,32)|0;ea=ja;if((ja|0)==0){F=65;break d}oa=qoa(s,0,0,1,16)|0;c[ja+4>>2]=oa;if((oa|0)==0){F=65;break d}c[ja>>2]=2;c[ja+8>>2]=-1;c[ja+12>>2]=-1;c[oa>>2]=ka;c[oa+4>>2]=0;c[oa+8>>2]=-1;ma=oa+12|0;a[ma]=a[ma]&-2;c[ja+16>>2]=c[ka+16>>2];c[l>>2]=ea;ra=ea;sa=la}else{if((fa|0)<(ba|0)){ta=0;ua=fa}else{ra=0;sa=ha;break}while(1){la=c[j>>2]|0;ea=hoa(s,q,c[ga>>2]|0,0,j,0,n,k)|0;if((ea|0)!=0){J=ea;break b}ea=c[n>>2]|0;if((ta|0)==0){va=ea}else{ka=qoa(s,0,0,1,32)|0;if((ka|0)==0){F=73;break d}ja=qoa(s,0,0,1,8)|0;ma=ka+4|0;c[ma>>2]=ja;if((ja|0)==0){F=73;break d}c[ka>>2]=1;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ja>>2]=ea;c[(c[ma>>2]|0)+4>>2]=ta;c[ka+16>>2]=(c[ta+16>>2]|0)+(c[ea+16>>2]|0);va=ka}c[l>>2]=va;if((va|0)==0){J=12;break b}ka=qoa(s,0,0,1,32)|0;if((ka|0)==0){J=12;break b}ea=qoa(s,0,0,1,20)|0;c[ka+4>>2]=ea;if((ea|0)==0){J=12;break b}c[ka>>2]=0;c[ka+8>>2]=-1;c[ka+12>>2]=-1;c[ea>>2]=-1;c[ea+4>>2]=-1;c[ea+8>>2]=-1;ea=qoa(s,0,0,1,32)|0;ma=ea;if((ea|0)==0){F=79;break d}ja=qoa(s,0,0,1,8)|0;oa=ea+4|0;c[oa>>2]=ja;if((ja|0)==0){F=79;break d}c[ea>>2]=3;c[ea+8>>2]=-1;c[ea+12>>2]=-1;c[ja>>2]=ka;c[(c[oa>>2]|0)+4>>2]=va;c[ea+16>>2]=(c[va+16>>2]|0)+(c[ka+16>>2]|0);c[l>>2]=ma;ka=ua+1|0;if((ka|0)<(c[U>>2]|0)){ta=ma;ua=ka}else{ra=ma;sa=la;break}}}}while(0);c[j>>2]=sa;do{if((ia|0)==0){wa=ra;F=85}else{if((ra|0)==0){xa=ia;break}U=qoa(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}ba=qoa(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=ba;if((ba|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[ba>>2]=ia;c[(c[T>>2]|0)+4>>2]=ra;c[U+16>>2]=(c[ra+16>>2]|0)+(c[ia+16>>2]|0);wa=U;F=85}}while(0);if((F|0)==85){F=0;if((wa|0)==0){J=12;break b}else{xa=wa}}c[P>>2]=c[xa+4>>2];c[S>>2]=c[xa>>2];da=sa}U=M+ -1|0;T=da-aa+N|0;if((U|0)!=0){Y=da;Z=U;_=T;break}c[j>>2]=T;Y=T;Z=0;_=T}else{Y=L;Z=M;_=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=Y;M=Z;N=_;O=S}else{V=_;W=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{V=0;W=0}}while(0);y=(c[H>>2]|0)+V|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=W}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=qoa(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=qoa(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=qoa(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=qoa(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=goa(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=goa(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==1){M=c[ya+4>>2]|0;L=c[M>>2]|0;Q=M+4|0;R=c[Q>>2]|0;if((c[L+8>>2]|0)==0){za=(c[R+8>>2]|0)!=0|0}else{za=1}c[ya+8>>2]=za;T=eoa(s,c[L+24>>2]|0,c[R+24>>2]|0,0,0)|0;c[ya+24>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}T=eoa(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Q>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==3){T=c[ya+4>>2]|0;Q=c[T>>2]|0;do{if((c[T+4>>2]|0)==0){F=141}else{if((c[Q+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[Q+24>>2];c[ya+28>>2]=c[(c[T>>2]|0)+28>>2]}else if((S|0)==2){M=c[ya+4>>2]|0;R=c[M>>2]|0;L=R+8|0;if((c[L>>2]|0)==0){Aa=0}else{Aa=(c[(c[M+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=Aa;if((c[L>>2]|0)==0){c[ya+24>>2]=c[R+24>>2];Ba=M+4|0}else{L=foa(q,R,0,0,g)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}Ca=Soa((c[g>>2]<<2)+4|0)|0;L=Ca;if((Ca|0)==0){z=0;A=12;B=0;C=D;break a}c[Ca>>2]=-1;c[h>>2]=0;Da=foa(q,c[M>>2]|0,L,h,0)|0;if((Da|0)!=0){F=150;break g}R=M+4|0;U=eoa(s,c[(c[R>>2]|0)+24>>2]|0,c[(c[M>>2]|0)+24>>2]|0,L,c[h>>2]|0)|0;L=ya+24|0;c[L>>2]=U;Toa(Ca);if((c[L>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Ba=R}}R=c[Ba>>2]|0;if((c[R+8>>2]|0)==0){c[ya+28>>2]=c[R+28>>2];break}L=foa(q,R,0,0,g)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}Ea=Soa((c[g>>2]<<2)+4|0)|0;L=Ea;if((Ea|0)==0){z=0;A=12;B=0;C=D;break a}c[Ea>>2]=-1;c[h>>2]=0;Fa=foa(q,c[Ba>>2]|0,L,h,0)|0;if((Fa|0)!=0){F=157;break g}R=eoa(s,c[(c[M>>2]|0)+28>>2]|0,c[(c[Ba>>2]|0)+28>>2]|0,L,c[h>>2]|0)|0;L=ya+28|0;c[L>>2]=R;Toa(Ea);if((c[L>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==0){L=c[ya>>2]|0;if((L|0)==2){R=goa(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,3)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,c[c[ya+4>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((L|0)==0){R=c[ya+4>>2]|0;M=c[R>>2]|0;if((M|0)==-4){c[ya+8>>2]=0;U=R+8|0;ba=c[U>>2]|0;la=qoa(s,0,0,1,64)|0;if((la|0)==0){F=104;break g}ma=la;c[la>>2]=ba;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;ba=la+28|0;la=ya+24|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[la>>2]=ma;ma=c[U>>2]|0;U=c[R+4>>2]|0;la=qoa(s,0,0,1,64)|0;if((la|0)==0){F=106;break g}c[la>>2]=ma;c[la+4>>2]=0;c[la+8>>2]=1114111;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=U;c[la+32>>2]=-1;c[la+36>>2]=-1;c[la+40>>2]=-1;c[ya+28>>2]=la;break}la=ya+8|0;if((M|0)<0){c[la>>2]=1;U=qoa(s,0,0,1,32)|0;if((U|0)==0){F=110;break g}c[U>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[ya+24>>2]=U;U=qoa(s,0,0,1,32)|0;if((U|0)==0){F=112;break g}c[U>>2]=-1;c[U+4>>2]=-1;c[U+8>>2]=-1;c[ya+28>>2]=U;break}else{c[la>>2]=0;la=R+8|0;U=c[la>>2]|0;ma=R+4|0;ba=c[ma>>2]|0;ka=qoa(s,0,0,1,64)|0;if((ka|0)==0){F=115;break g}ea=ka;c[ka>>2]=U;c[ka+4>>2]=M;c[ka+8>>2]=ba;c[ka+20>>2]=0;c[ka+24>>2]=0;ba=ka+28|0;ka=ya+24|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[ka>>2]=ea;ea=c[la>>2]|0;la=c[R>>2]|0;ka=c[ma>>2]|0;ma=c[R+12>>2]|0;ba=c[R+16>>2]|0;R=qoa(s,0,0,1,64)|0;if((R|0)==0){F=117;break g}M=R;c[R>>2]=ea;c[R+4>>2]=la;c[R+8>>2]=ka;c[R+20>>2]=ma;c[R+24>>2]=ba;ba=R+28|0;R=ya+28|0;c[ba+0>>2]=-1;c[ba+4>>2]=-1;c[ba+8>>2]=-1;c[ba+12>>2]=-1;c[R>>2]=M;break}}else if((L|0)==1){M=goa(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=goa(q,2)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=ya+4|0;R=goa(q,c[(c[M>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,c[c[M>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((L|0)==3){L=goa(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=goa(q,1)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=goa(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=goa(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else{break}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){Toa(Ca);z=0;A=Da;B=0;C=D;break a}else if((F|0)==157){Toa(Ea);z=0;A=Fa;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=Soa(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=Soa(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){ypa(O|0,0,((E|0)>1?E<<2:4)|0)|0}boa(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;R=O+(S<<2)|0;L=K+1+(c[R>>2]|0)|0;c[R>>2]=0;R=S+1|0;if((R|0)<(E|0)){S=R;K=L}else{Ga=L;break}}}else{Ga=0}K=Uoa(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;L=boa(y,S,x,u)|0;if((L|0)!=0){z=x;A=L;B=u;C=D;break}c[w+20>>2]=0;L=v+24|0;S=c[L>>2]|0;if((c[S>>2]|0)>-1){R=1;M=S;while(1){S=M+32|0;ba=R+1|0;if((c[S>>2]|0)>-1){M=S;R=ba}else{Ha=ba;break}}}else{Ha=1}R=Uoa(Ha,32)|0;if((R|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=R;M=c[L>>2]|0;y=c[M>>2]|0;if((y|0)>-1){ba=y;y=M;M=0;while(1){c[R+(M<<5)+8>>2]=K+(c[N+(ba<<2)>>2]<<5);c[R+(M<<5)+12>>2]=ba;S=R+(M<<5)+16|0;c[S>>2]=0;ma=y+12|0;ka=c[ma>>2]|0;if((ka|0)!=0){la=0;while(1){Ia=la+1|0;if((c[ka+(la<<2)>>2]|0)>-1){la=Ia}else{break}}la=Ia<<2;ka=Soa(la)|0;c[S>>2]=ka;if((ka|0)==0){z=x;A=12;B=u;C=D;break a}wpa(ka|0,c[ma>>2]|0,la|0)|0}c[R+(M<<5)+20>>2]=c[y+16>>2];la=M+1|0;ka=y+32|0;ea=c[ka>>2]|0;if((ea|0)>-1){ba=ea;y=ka;M=la}else{Ja=la;break}}}else{Ja=0}c[R+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;poa(s);Toa(c[p+16>>2]|0);Toa(p);Toa(O);Toa(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);poa(s);Toa(c[p+16>>2]|0);Toa(p);if((z|0)!=0){Toa(z)}if((B|0)!=0){Toa(B)}c[b+4>>2]=C;coa(b);r=A;i=f;return r|0}



function qw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1568>>3]=0.0;i=i;return}function rw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1560>>3]=0.0;i=i;return}function sw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1552>>3]=0.0;i=i;return}function tw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1544>>3]=1.0;i=i;return}function uw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1536>>3]=0.0;i=i;return}function vw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1528>>3]=0.0;i=i;return}function ww(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1520>>3]=0.0;i=i;return}function xw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1512>>3]=1.0;i=i;return}function yw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1504>>3]=0.0;i=i;return}function zw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1496>>3]=0.0;i=i;return}function Aw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1488>>3]=0.0;i=i;return}function Bw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1480>>3]=1.0;i=i;return}function Cw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6344>>3]=0.0;i=i;return}function Dw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6336>>3]=0.0;i=i;return}function Ew(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1472>>3]=0.0;i=i;return}function Fw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1464>>3]=0.0;i=i;return}function Gw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1456>>3]=0.0;i=i;return}function Hw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1448>>3]=1.0;i=i;return}function Iw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1440>>3]=0.0;i=i;return}function Jw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1432>>3]=0.0;i=i;return}function Kw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1424>>3]=0.0;i=i;return}function Lw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1416>>3]=1.0;i=i;return}function Mw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1408>>3]=0.0;i=i;return}function Nw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1400>>3]=0.0;i=i;return}function Ow(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1392>>3]=0.0;i=i;return}function Pw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1384>>3]=1.0;i=i;return}function Qw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6328>>3]=0.0;i=i;return}function Rw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6320>>3]=0.0;i=i;return}function Sw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1376>>3]=0.0;i=i;return}function Tw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1368>>3]=0.0;i=i;return}function Uw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1360>>3]=0.0;i=i;return}function Vw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1352>>3]=1.0;i=i;return}function Ww(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1344>>3]=0.0;i=i;return}function Xw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1336>>3]=0.0;i=i;return}function Yw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1328>>3]=0.0;i=i;return}function Zw(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1320>>3]=1.0;i=i;return}function _w(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1312>>3]=0.0;i=i;return}function $w(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1304>>3]=0.0;i=i;return}function ax(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1296>>3]=0.0;i=i;return}function bx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1288>>3]=1.0;i=i;return}function cx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function dx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=0.0;i=i;return}function ex(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1280>>3]=0.0;i=i;return}function fx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1272>>3]=0.0;i=i;return}function gx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1264>>3]=0.0;i=i;return}function hx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1256>>3]=1.0;i=i;return}function ix(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1248>>3]=0.0;i=i;return}function jx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1240>>3]=0.0;i=i;return}function kx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1232>>3]=0.0;i=i;return}function lx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1224>>3]=1.0;i=i;return}function mx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=0.0;i=i;return}function nx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=0.0;i=i;return}function ox(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=0.0;i=i;return}function px(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=1.0;i=i;return}function qx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6296>>3]=0.0;i=i;return}function rx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function sx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=0.0;i=i;return}function tx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=0.0;i=i;return}function ux(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=0.0;i=i;return}function vx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1160>>3]=1.0;i=i;return}function wx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1152>>3]=0.0;i=i;return}function xx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=0.0;i=i;return}function yx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=0.0;i=i;return}function zx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=1.0;i=i;return}function Ax(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=0.0;i=i;return}function Bx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=0.0;i=i;return}function Cx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=0.0;i=i;return}function Dx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1096>>3]=1.0;i=i;return}function Ex(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6280>>3]=0.0;i=i;return}function Fx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1088>>3]=0.0;i=i;return}function Gx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1080>>3]=0.0;i=i;return}function Hx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1072>>3]=0.0;i=i;return}function Ix(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1064>>3]=0.0;i=i;return}function Jx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=0.0;i=i;return}function Kx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=0.0;i=i;return}function Lx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6272>>3]=0.0;i=i;return}function Mx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=0.0;i=i;return}function Nx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=0.0;i=i;return}function Ox(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=0.0;i=i;return}function Px(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1016>>3]=0.0;i=i;return}function Qx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1008>>3]=0.0;i=i;return}function Rx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function Sx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e3>>3]=0.0;i=i;return}function Tx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=0.0;i=i;return}function Ux(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+984>>3]=0.0;i=i;return}function Vx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+976>>3]=0.0;i=i;return}function Wx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+968>>3]=0.0;i=i;return}function Xx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+960>>3]=0.0;i=i;return}function Yx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=0.0;i=i;return}function Zx(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+944>>3]=0.0;i=i;return}function _x(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+928>>3]=0.0;i=i;return}function $x(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+920>>3]=0.0;i=i;return}function ay(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+912>>3]=0.0;i=i;return}function by(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+904>>3]=0.0;i=i;return}function cy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+896>>3]=0.0;i=i;return}function dy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+888>>3]=0.0;i=i;return}function ey(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+880>>3]=0.0;i=i;return}function fy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+872>>3]=0.0;i=i;return}function gy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+864>>3]=0.0;i=i;return}function hy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+848>>3]=0.0;i=i;return}function iy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+840>>3]=0.0;i=i;return}function jy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+824>>3]=0.0;i=i;return}function ky(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+800>>3]=0.0;i=i;return}function ly(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+816>>3]=0.0;i=i;return}function my(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=0.0;i=i;return}function ny(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+768>>3]=0.0;i=i;return}function oy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=0.0;i=i;return}function py(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=0.0;i=i;return}function qy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=0.0;i=i;return}function ry(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=0.0;i=i;return}function sy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=0.0;i=i;return}function ty(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+96>>3]=0.0;i=i;return}function uy(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=+h[b+96>>3];i=i;return}function vy(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);mu(b);nu(b);ou(b);pu(b);qu(b);ru(b);su(b);tu(b);uu(b);vu(b);wu(b);xu(b);yu(b);zu(b);Au(b);Bu(b);Cu(b);Du(b);Eu(b);Fu(b);Gu(b);Hu(b);Iu(b);Ju(b);Ku(b);Lu(b);Mu(b);Nu(b);Ou(b);Pu(b);Qu(b);Ru(b);Su(b);Tu(b);Uu(b);Vu(b);Wu(b);Xu(b);Yu(b);Zu(b);_u(b);$u(b);av(b);bv(b);cv(b);dv(b);ev(b);fv(b);gv(b);hv(b);iv(b);jv(b);kv(b);lv(b);mv(b);nv(b);ov(b);pv(b);qv(b);rv(b);sv(b);tv(b);uv(b);vv(b);wv(b);xv(b);yv(b);zv(b);Av(b);Bv(b);Cv(b);Dv(b);Ev(b);Fv(b);Gv(b);Hv(b);Iv(b);Jv(b);Kv(b);Lv(b);Mv(b);Nv(b);Ov(b);Pv(b);Qv(b);Rv(b);Sv(b);Tv(b);Uv(b);Vv(b);Wv(b);Xv(b);Yv(b);Zv(b);_v(b);$v(b);aw(b);bw(b);cw(b);dw(b);ew(b);fw(b);gw(b);hw(b);iw(b);jw(b);kw(b);lw(b);mw(b);nw(b);ow(b);pw(b);qw(b);rw(b);sw(b);tw(b);uw(b);vw(b);ww(b);xw(b);yw(b);zw(b);Aw(b);Bw(b);Cw(b);Dw(b);Ew(b);Fw(b);Gw(b);Hw(b);Iw(b);Jw(b);Kw(b);Lw(b);Mw(b);Nw(b);Ow(b);Pw(b);Qw(b);Rw(b);Sw(b);Tw(b);Uw(b);Vw(b);Ww(b);Xw(b);Yw(b);Zw(b);_w(b);$w(b);ax(b);bx(b);cx(b);dx(b);ex(b);fx(b);gx(b);hx(b);ix(b);jx(b);kx(b);lx(b);mx(b);nx(b);ox(b);px(b);qx(b);rx(b);sx(b);tx(b);ux(b);vx(b);wx(b);xx(b);yx(b);zx(b);Ax(b);Bx(b);Cx(b);Dx(b);Ex(b);Fx(b);Gx(b);Hx(b);Ix(b);Jx(b);Kx(b);Lx(b);Mx(b);Nx(b);Ox(b);Px(b);Qx(b);Rx(b);Sx(b);Tx(b);Ux(b);Vx(b);Wx(b);Xx(b);Yx(b);Zx(b);_x(b);$x(b);ay(b);by(b);cy(b);dy(b);ey(b);fy(b);gy(b);hy(b);iy(b);jy(b);ky(b);ly(b);my(b);ny(b);oy(b);py(b);qy(b);ry(b);sy(b);ty(b);uy(b);a[d]=0;i=c;return 0}function wy(a){a=a|0;i=i;return}function xy(a){a=a|0;i=i;return 0}function yy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+480>>3]=+h[(c[a+416>>2]|0)+136>>3];i=i;return}function zy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+472>>3]=+h[(c[a+416>>2]|0)+128>>3];i=i;return}function Ay(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+464>>3]=+h[(c[a+416>>2]|0)+120>>3];i=i;return}function By(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+512>>3]=+h[(c[a+416>>2]|0)+384>>3];i=i;return}function Cy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+504>>3]=+h[(c[a+416>>2]|0)+376>>3];i=i;return}function Dy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+496>>3]=+h[(c[a+416>>2]|0)+368>>3];i=i;return}function Ey(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+488>>3]=+h[(c[a+416>>2]|0)+360>>3];i=i;return}function Fy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=+h[(c[a+416>>2]|0)+112>>3];i=i;return}function Gy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+104>>3];i=i;return}function Hy(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+96>>3];i=i;return}function Iy(a){a=a|0;var b=0,d=0,e=0;b=c[c[a+4>>2]>>2]|0;d=c[b+12>>2]|0;e=c[a+8>>2]|0;h[(c[b+8>>2]|0)+72>>3]=+(c[d>>2]|0)*+h[e+7264>>3]+(+(c[d+12>>2]|0)*+h[e+7152>>3]+(+(c[d+24>>2]|0)*+h[e+7040>>3]+ +(c[d+36>>2]|0)*+h[e+6928>>3]));i=i;return}function Jy(a){a=a|0;var b=0,d=0,e=0;b=c[c[a+4>>2]>>2]|0;d=c[b+12>>2]|0;e=c[a+8>>2]|0;h[(c[b+8>>2]|0)+80>>3]=+(c[d+4>>2]|0)*+h[e+7264>>3]+(+(c[d+16>>2]|0)*+h[e+7152>>3]+(+(c[d+28>>2]|0)*+h[e+7040>>3]+ +(c[d+40>>2]|0)*+h[e+6928>>3]));i=i;return}function Ky(a){a=a|0;var b=0,d=0,e=0;b=c[c[a+4>>2]>>2]|0;d=c[b+12>>2]|0;e=c[a+8>>2]|0;h[(c[b+8>>2]|0)+88>>3]=+(c[d+8>>2]|0)*+h[e+7264>>3]+(+(c[d+20>>2]|0)*+h[e+7152>>3]+(+(c[d+32>>2]|0)*+h[e+7040>>3]+ +(c[d+44>>2]|0)*+h[e+6928>>3]));i=i;return}function Ly(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;tW(9,1,5096,w);if((c[35860>>2]|0)!=0){fe[c[9094]&255](9)}tW(9,1,5120,v);if((c[35860>>2]|0)!=0){fe[c[9094]&255](9)}tW(9,1,5144,u);if((c[35860>>2]|0)!=0){fe[c[9094]&255](9)}yy(a);zy(a);Ay(a);By(a);Cy(a);Dy(a);Ey(a);Fy(a);Gy(a);Hy(a);Iy(a);Jy(a);Ky(a);tW(9,1,5168,t);t=a+4|0;x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+480>>3];u=a+8|0;a=c[u>>2]|0;h[a+6816>>3]=x;c[s>>2]=c[a+6724>>2];a=s+4|0;h[k>>3]=x;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];tW(9,0,5192,s);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+472>>3];s=c[u>>2]|0;h[s+6704>>3]=x;c[r>>2]=c[s+6612>>2];s=r+4|0;h[k>>3]=x;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];tW(9,0,5192,r);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+464>>3];r=c[u>>2]|0;h[r+6592>>3]=x;c[q>>2]=c[r+6500>>2];r=q+4|0;h[k>>3]=x;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];tW(9,0,5192,q);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+512>>3];q=c[u>>2]|0;h[q+7264>>3]=x;c[p>>2]=c[q+7172>>2];q=p+4|0;h[k>>3]=x;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];tW(9,0,5192,p);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+504>>3];p=c[u>>2]|0;h[p+7152>>3]=x;c[o>>2]=c[p+7060>>2];p=o+4|0;h[k>>3]=x;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];tW(9,0,5192,o);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+496>>3];o=c[u>>2]|0;h[o+7040>>3]=x;c[n>>2]=c[o+6948>>2];o=n+4|0;h[k>>3]=x;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];tW(9,0,5192,n);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+488>>3];n=c[u>>2]|0;h[n+6928>>3]=x;c[m>>2]=c[n+6836>>2];n=m+4|0;h[k>>3]=x;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];tW(9,0,5192,m);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+16>>3];m=c[u>>2]|0;h[m+320>>3]=x;c[l>>2]=c[m+228>>2];m=l+4|0;h[k>>3]=x;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];tW(9,0,5192,l);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+8>>3];l=c[u>>2]|0;h[l+208>>3]=x;c[j>>2]=c[l+116>>2];l=j+4|0;h[k>>3]=x;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];tW(9,0,5192,j);x=+h[c[(c[c[t>>2]>>2]|0)+8>>2]>>3];j=c[u>>2]|0;h[j+96>>3]=x;c[g>>2]=c[j+4>>2];j=g+4|0;h[k>>3]=x;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];tW(9,0,5192,g);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+72>>3];g=c[u>>2]|0;h[g+1104>>3]=x;c[f>>2]=c[g+1012>>2];g=f+4|0;h[k>>3]=x;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];tW(9,0,5192,f);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+80>>3];f=c[u>>2]|0;h[f+1216>>3]=x;c[e>>2]=c[f+1124>>2];f=e+4|0;h[k>>3]=x;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];tW(9,0,5192,e);x=+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+88>>3];t=c[u>>2]|0;h[t+1328>>3]=x;c[d>>2]=c[t+1236>>2];t=d+4|0;h[k>>3]=x;c[t>>2]=c[k>>2];c[t+4>>2]=c[k+4>>2];tW(9,0,5192,d);if((c[35860>>2]|0)==0){i=b;return 0}fe[c[9094]&255](9);i=b;return 0}function My(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+728>>3]=0.0;i=i;return}function Ny(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+744>>3]=0.0;i=i;return}function Oy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+760>>3]=0.0;i=i;return}function Py(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+792>>3]=0.0;i=i;return}function Qy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+752>>3]=0.0;i=i;return}function Ry(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+768>>3]=0.0;i=i;return}function Sy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+776>>3]=0.0;i=i;return}function Ty(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+816>>3]=0.0;i=i;return}function Uy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+800>>3]=0.0;i=i;return}function Vy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+824>>3]=0.0;i=i;return}function Wy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+840>>3]=0.0;i=i;return}function Xy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+848>>3]=0.0;i=i;return}function Yy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+864>>3]=0.0;i=i;return}function Zy(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+872>>3]=0.0;i=i;return}function _y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+880>>3]=0.0;i=i;return}function $y(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+888>>3]=0.0;i=i;return}function az(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+896>>3]=0.0;i=i;return}function bz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+904>>3]=0.0;i=i;return}function cz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+912>>3]=0.0;i=i;return}function dz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+920>>3]=0.0;i=i;return}function ez(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+928>>3]=0.0;i=i;return}function fz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+944>>3]=0.0;i=i;return}function gz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+952>>3]=0.0;i=i;return}function hz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+960>>3]=0.0;i=i;return}function iz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+968>>3]=0.0;i=i;return}function jz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+976>>3]=0.0;i=i;return}function kz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+984>>3]=0.0;i=i;return}function lz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+992>>3]=0.0;i=i;return}function mz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e3>>3]=0.0;i=i;return}function nz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function oz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1008>>3]=0.0;i=i;return}function pz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1016>>3]=0.0;i=i;return}function qz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1024>>3]=0.0;i=i;return}function rz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1032>>3]=0.0;i=i;return}function sz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1040>>3]=0.0;i=i;return}function tz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6272>>3]=0.0;i=i;return}function uz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1048>>3]=0.0;i=i;return}function vz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1056>>3]=0.0;i=i;return}function wz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1064>>3]=0.0;i=i;return}function xz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1072>>3]=0.0;i=i;return}function yz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1080>>3]=0.0;i=i;return}function zz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1088>>3]=0.0;i=i;return}function Az(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6280>>3]=0.0;i=i;return}function Bz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1096>>3]=1.0;i=i;return}function Cz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1104>>3]=0.0;i=i;return}function Dz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1112>>3]=0.0;i=i;return}function Ez(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1120>>3]=0.0;i=i;return}function Fz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1128>>3]=1.0;i=i;return}function Gz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1136>>3]=0.0;i=i;return}function Hz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1144>>3]=0.0;i=i;return}function Iz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1152>>3]=0.0;i=i;return}function Jz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1160>>3]=1.0;i=i;return}function Kz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1168>>3]=0.0;i=i;return}function Lz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1176>>3]=0.0;i=i;return}function Mz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1184>>3]=0.0;i=i;return}function Nz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function Oz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6296>>3]=0.0;i=i;return}function Pz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1192>>3]=1.0;i=i;return}function Qz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1200>>3]=0.0;i=i;return}function Rz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1208>>3]=0.0;i=i;return}function Sz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1216>>3]=0.0;i=i;return}function Tz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1224>>3]=1.0;i=i;return}function Uz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1232>>3]=0.0;i=i;return}function Vz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1240>>3]=0.0;i=i;return}function Wz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1248>>3]=0.0;i=i;return}function Xz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1256>>3]=1.0;i=i;return}function Yz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1264>>3]=0.0;i=i;return}function Zz(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1272>>3]=0.0;i=i;return}function _z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1280>>3]=0.0;i=i;return}function $z(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6304>>3]=0.0;i=i;return}function aA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function bA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1288>>3]=1.0;i=i;return}function cA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1296>>3]=0.0;i=i;return}function dA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1304>>3]=0.0;i=i;return}function eA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1312>>3]=0.0;i=i;return}function fA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1320>>3]=1.0;i=i;return}function gA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1328>>3]=0.0;i=i;return}function hA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1336>>3]=0.0;i=i;return}function iA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1344>>3]=0.0;i=i;return}function jA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1352>>3]=1.0;i=i;return}function kA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1360>>3]=0.0;i=i;return}function lA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1368>>3]=0.0;i=i;return}function mA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1376>>3]=0.0;i=i;return}function nA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6320>>3]=0.0;i=i;return}function oA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6328>>3]=0.0;i=i;return}function pA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1384>>3]=1.0;i=i;return}function qA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1392>>3]=0.0;i=i;return}function rA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1400>>3]=0.0;i=i;return}function sA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1408>>3]=0.0;i=i;return}function tA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1416>>3]=1.0;i=i;return}function uA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1424>>3]=0.0;i=i;return}function vA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1432>>3]=0.0;i=i;return}function wA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1440>>3]=0.0;i=i;return}function xA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1448>>3]=1.0;i=i;return}function yA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1456>>3]=0.0;i=i;return}function zA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1464>>3]=0.0;i=i;return}function AA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1472>>3]=0.0;i=i;return}function BA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6336>>3]=0.0;i=i;return}function CA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6344>>3]=0.0;i=i;return}function DA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1480>>3]=1.0;i=i;return}function EA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1488>>3]=0.0;i=i;return}function FA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1496>>3]=0.0;i=i;return}function GA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1504>>3]=0.0;i=i;return}function HA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1512>>3]=1.0;i=i;return}function IA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1520>>3]=0.0;i=i;return}function JA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1528>>3]=0.0;i=i;return}function KA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1536>>3]=0.0;i=i;return}function LA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1544>>3]=1.0;i=i;return}function MA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1552>>3]=0.0;i=i;return}function NA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1560>>3]=0.0;i=i;return}function OA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1568>>3]=0.0;i=i;return}function PA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=0.0;i=i;return}function QA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6360>>3]=0.0;i=i;return}function RA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1576>>3]=1.0;i=i;return}function SA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1584>>3]=0.0;i=i;return}function TA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1592>>3]=0.0;i=i;return}function UA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1600>>3]=0.0;i=i;return}function VA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1608>>3]=1.0;i=i;return}function WA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1616>>3]=0.0;i=i;return}function XA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1624>>3]=0.0;i=i;return}function YA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1632>>3]=0.0;i=i;return}function ZA(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1640>>3]=1.0;i=i;return}function _A(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1648>>3]=0.0;i=i;return}function $A(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1656>>3]=0.0;i=i;return}function aB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1664>>3]=0.0;i=i;return}function bB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6368>>3]=0.0;i=i;return}function cB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6376>>3]=0.0;i=i;return}function dB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1672>>3]=1.0;i=i;return}function eB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1680>>3]=0.0;i=i;return}function fB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1688>>3]=0.0;i=i;return}function gB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1696>>3]=0.0;i=i;return}function hB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1704>>3]=1.0;i=i;return}function iB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1712>>3]=0.0;i=i;return}function jB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1720>>3]=0.0;i=i;return}function kB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1728>>3]=0.0;i=i;return}function lB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1736>>3]=1.0;i=i;return}function mB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1744>>3]=0.0;i=i;return}function nB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1752>>3]=0.0;i=i;return}function oB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1760>>3]=0.0;i=i;return}function pB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6384>>3]=0.0;i=i;return}function qB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6392>>3]=0.0;i=i;return}function rB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1768>>3]=1.0;i=i;return}function sB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1776>>3]=0.0;i=i;return}function tB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1784>>3]=0.0;i=i;return}function uB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1792>>3]=0.0;i=i;return}function vB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1800>>3]=1.0;i=i;return}function wB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1808>>3]=0.0;i=i;return}function xB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1816>>3]=0.0;i=i;return}function yB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1824>>3]=0.0;i=i;return}function zB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1832>>3]=1.0;i=i;return}function AB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1840>>3]=0.0;i=i;return}function BB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1848>>3]=0.0;i=i;return}function CB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1856>>3]=0.0;i=i;return}function DB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function EB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6408>>3]=0.0;i=i;return}function FB(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;b=i;d=a+416|0;e=c[d>>2]|0;f=+h[e+48>>3];g=+h[e+56>>3];j=+h[e+64>>3];k=+V(+(f*f+g*g+j*j));if((DZ(k,+h[e+1288>>3]*.5)|0)<<24>>24==0){l=0.0;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6416|0;x=w;h[x>>3]=l;i=b;return}e=c[d>>2]|0;y=DZ(+h[e+1296>>3],+h[e+1288>>3]*1.1)|0;e=c[d>>2]|0;k=+h[e+48>>3];j=+h[e+56>>3];g=+h[e+64>>3];f=+V(+(k*k+j*j+g*g));if(y<<24>>24==0){z=0.0}else{z=+h[e+1288>>3]*.5}l=f-z;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6416|0;x=w;h[x>>3]=l;i=b;return}function GB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=0.0;i=i;return}function HB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function IB(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0;b=i;d=a+416|0;e=c[d>>2]|0;f=+h[e+584>>3];g=+h[e+592>>3];j=+h[e+600>>3];k=+V(+(f*f+g*g+j*j));if((DZ(k,+h[e+1424>>3]*.5)|0)<<24>>24==0){l=0.0;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6440|0;x=w;h[x>>3]=l;i=b;return}e=c[d>>2]|0;y=DZ(+h[e+1432>>3],+h[e+1424>>3]*1.1)|0;e=c[d>>2]|0;k=+h[e+584>>3];j=+h[e+592>>3];g=+h[e+600>>3];f=+V(+(k*k+j*j+g*g));if(y<<24>>24==0){z=0.0}else{z=+h[e+1424>>3]*.5}l=f-z;m=a;n=m+4|0;o=n;p=c[o>>2]|0;q=c[p>>2]|0;r=q;s=r+8|0;t=s;u=c[t>>2]|0;v=u;w=v+6440|0;x=w;h[x>>3]=l;i=b;return}function JB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6448>>3]=0.0;i=i;return}function KB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6456>>3]=0.0;i=i;return}function LB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function MB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1864>>3]=1.0;i=i;return}function NB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1872>>3]=0.0;i=i;return}function OB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1880>>3]=0.0;i=i;return}function PB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1888>>3]=0.0;i=i;return}function QB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1896>>3]=1.0;i=i;return}function RB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1904>>3]=0.0;i=i;return}function SB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1912>>3]=0.0;i=i;return}function TB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1920>>3]=0.0;i=i;return}function UB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1928>>3]=1.0;i=i;return}function VB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1936>>3]=0.0;i=i;return}function WB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1944>>3]=0.0;i=i;return}function XB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1952>>3]=0.0;i=i;return}function YB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=.02;i=i;return}function ZB(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=.07200000000000001;i=i;return}function _B(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6488>>3]=.01;i=i;return}function $B(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6496>>3]=.1;i=i;return}function aC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1960>>3]=1.0;i=i;return}function bC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1968>>3]=0.0;i=i;return}function cC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1976>>3]=0.0;i=i;return}function dC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1984>>3]=0.0;i=i;return}function eC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1992>>3]=1.0;i=i;return}function fC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e3>>3]=0.0;i=i;return}function gC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2008>>3]=0.0;i=i;return}function hC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2016>>3]=0.0;i=i;return}function iC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2024>>3]=1.0;i=i;return}function jC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2032>>3]=0.0;i=i;return}function kC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2040>>3]=0.0;i=i;return}function lC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2048>>3]=0.0;i=i;return}function mC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6504>>3]=.02;i=i;return}function nC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6512>>3]=.07200000000000001;i=i;return}function oC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6520>>3]=.01;i=i;return}function pC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6528>>3]=.1;i=i;return}function qC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function rC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6552>>3]=0.0;i=i;return}function sC(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=0;i=i;return}function tC(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=230;i=i;return}function uC(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function vC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2056>>3]=0.0;i=i;return}function wC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2064>>3]=0.0;i=i;return}function xC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2072>>3]=0.0;i=i;return}function yC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2080>>3]=0.0;i=i;return}function zC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2088>>3]=1.0;i=i;return}function AC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2096>>3]=0.0;i=i;return}function BC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2104>>3]=0.0;i=i;return}function CC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2112>>3]=0.0;i=i;return}function DC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2120>>3]=0.0;i=i;return}function EC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2200>>3]=l;i=b;return}function FC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2224>>3]=l;i=b;return}function GC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2248>>3]=l;i=b;return}function HC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2208>>3]=l;i=b;return}function IC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2232>>3]=l;i=b;return}function JC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2256>>3]=l;i=b;return}function KC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2216>>3]=l;i=b;return}function LC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2240>>3]=l;i=b;return}function MC(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2264>>3]=l;i=b;return}function NC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2272>>3]=0.0;i=i;return}function OC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2280>>3]=0.0;i=i;return}function PC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2304>>3]=1.0;i=i;return}function QC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2312>>3]=0.0;i=i;return}function RC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2320>>3]=0.0;i=i;return}function SC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2328>>3]=0.0;i=i;return}function TC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2336>>3]=1.0;i=i;return}function UC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2344>>3]=0.0;i=i;return}function VC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2352>>3]=0.0;i=i;return}function WC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2360>>3]=0.0;i=i;return}function XC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2368>>3]=1.0;i=i;return}function YC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2376>>3]=0.0;i=i;return}function ZC(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2384>>3]=0.0;i=i;return}function _C(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2392>>3]=0.0;i=i;return}function $C(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2400>>3]=0.0;i=i;return}function aD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2408>>3]=0.0;i=i;return}function bD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2416>>3]=1.0;i=i;return}function cD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2424>>3]=0.0;i=i;return}function dD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2432>>3]=0.0;i=i;return}function eD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2440>>3]=0.0;i=i;return}function fD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2448>>3]=1.0;i=i;return}function gD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2456>>3]=0.0;i=i;return}function hD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2464>>3]=0.0;i=i;return}function iD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2472>>3]=0.0;i=i;return}function jD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2480>>3]=0.0;i=i;return}function kD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2488>>3]=0.0;i=i;return}function lD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2496>>3]=0.0;i=i;return}function mD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2504>>3]=1.0;i=i;return}function nD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2512>>3]=0.0;i=i;return}function oD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2520>>3]=0.0;i=i;return}function pD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2528>>3]=0.0;i=i;return}function qD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2536>>3]=0.0;i=i;return}function rD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2544>>3]=0.0;i=i;return}function sD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2552>>3]=1.0;i=i;return}function tD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2560>>3]=0.0;i=i;return}function uD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2568>>3]=0.0;i=i;return}function vD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2576>>3]=0.0;i=i;return}function wD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2584>>3]=0.0;i=i;return}function xD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2664>>3]=l;i=b;return}function yD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2688>>3]=l;i=b;return}function zD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2712>>3]=l;i=b;return}function AD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2672>>3]=l;i=b;return}function BD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2696>>3]=l;i=b;return}function CD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2720>>3]=l;i=b;return}function DD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2680>>3]=l;i=b;return}function ED(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2704>>3]=l;i=b;return}function FD(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5224;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5240;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2728>>3]=l;i=b;return}function GD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2736>>3]=0.0;i=i;return}function HD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2744>>3]=0.0;i=i;return}function ID(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2768>>3]=1.0;i=i;return}function JD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2776>>3]=0.0;i=i;return}function KD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2784>>3]=0.0;i=i;return}function LD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2792>>3]=0.0;i=i;return}function MD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2800>>3]=1.0;i=i;return}function ND(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2808>>3]=0.0;i=i;return}function OD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2816>>3]=0.0;i=i;return}function PD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2824>>3]=0.0;i=i;return}function QD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2832>>3]=1.0;i=i;return}function RD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2840>>3]=0.0;i=i;return}function SD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2848>>3]=0.0;i=i;return}function TD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2856>>3]=0.0;i=i;return}function UD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2864>>3]=0.0;i=i;return}function VD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2872>>3]=0.0;i=i;return}function WD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2880>>3]=0.0;i=i;return}function XD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2888>>3]=1.0;i=i;return}function YD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2896>>3]=0.0;i=i;return}function ZD(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2904>>3]=-1.0;i=i;return}function _D(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2912>>3]=0.0;i=i;return}function $D(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2920>>3]=0.0;i=i;return}function aE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2928>>3]=0.0;i=i;return}function bE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2936>>3]=0.0;i=i;return}function cE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2952>>3]=0.0;i=i;return}function dE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2984>>3]=0.0;i=i;return}function eE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2992>>3]=1.0;i=i;return}function fE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3e3>>3]=0.0;i=i;return}function gE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3008>>3]=0.0;i=i;return}function hE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3016>>3]=0.0;i=i;return}function iE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3024>>3]=0.0;i=i;return}function jE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3032>>3]=0.0;i=i;return}function kE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3040>>3]=1.0;i=i;return}function lE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3048>>3]=0.0;i=i;return}function mE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3056>>3]=0.0;i=i;return}function nE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3064>>3]=0.0;i=i;return}function oE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3072>>3]=0.0;i=i;return}function pE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3080>>3]=0.0;i=i;return}function qE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3088>>3]=1.0;i=i;return}function rE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3096>>3]=0.0;i=i;return}function sE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3104>>3]=0.0;i=i;return}function tE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3112>>3]=0.0;i=i;return}function uE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3120>>3]=0.0;i=i;return}function vE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3248>>3]=l;i=b;return}function wE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3272>>3]=l;i=b;return}function xE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,0);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3296>>3]=l;i=b;return}function yE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3256>>3]=l;i=b;return}function zE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3280>>3]=l;i=b;return}function AE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,1);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3304>>3]=l;i=b;return}function BE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,0,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3264>>3]=l;i=b;return}function CE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,1,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3288>>3]=l;i=b;return}function DE(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5224;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];Sg(f,g,e,d);l=+jX(f,2,2);h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3312>>3]=l;i=b;return}function EE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3320>>3]=0.0;i=i;return}function FE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3328>>3]=0.0;i=i;return}function GE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3360>>3]=1.0;i=i;return}function HE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3368>>3]=0.0;i=i;return}function IE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3376>>3]=0.0;i=i;return}function JE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3384>>3]=0.0;i=i;return}function KE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3392>>3]=1.0;i=i;return}function LE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3400>>3]=0.0;i=i;return}function ME(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3408>>3]=0.0;i=i;return}function NE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3416>>3]=0.0;i=i;return}function OE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3424>>3]=1.0;i=i;return}function PE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3432>>3]=0.0;i=i;return}function QE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3440>>3]=0.0;i=i;return}function RE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3448>>3]=0.0;i=i;return}function SE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3456>>3]=0.0;i=i;return}function TE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3464>>3]=0.0;i=i;return}function UE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3472>>3]=0.0;i=i;return}function VE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3480>>3]=0.0;i=i;return}function WE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3488>>3]=1.0;i=i;return}function XE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3496>>3]=0.0;i=i;return}function YE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3504>>3]=1.0;i=i;return}function ZE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3512>>3]=0.0;i=i;return}function _E(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3520>>3]=0.0;i=i;return}function $E(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3528>>3]=0.0;i=i;return}function aF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3536>>3]=0.0;i=i;return}function bF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3544>>3]=0.0;i=i;return}function cF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3552>>3]=0.0;i=i;return}function dF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3560>>3]=0.0;i=i;return}function eF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3568>>3]=0.0;i=i;return}function fF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3576>>3]=1.0;i=i;return}function gF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3584>>3]=0.0;i=i;return}function hF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3592>>3]=0.0;i=i;return}function iF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3600>>3]=0.0;i=i;return}function jF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3608>>3]=0.0;i=i;return}function kF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3616>>3]=0.0;i=i;return}function lF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3624>>3]=0.0;i=i;return}function mF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3632>>3]=0.0;i=i;return}function nF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3640>>3]=1.0;i=i;return}function oF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3648>>3]=0.0;i=i;return}function pF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3656>>3]=0.0;i=i;return}function qF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3664>>3]=0.0;i=i;return}function rF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3672>>3]=1.0;i=i;return}function sF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3680>>3]=0.0;i=i;return}function tF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3688>>3]=0.0;i=i;return}function uF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3696>>3]=0.0;i=i;return}function vF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3704>>3]=0.0;i=i;return}function wF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3712>>3]=0.0;i=i;return}function xF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3720>>3]=0.0;i=i;return}function yF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3728>>3]=1.0;i=i;return}function zF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3736>>3]=0.0;i=i;return}function AF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3744>>3]=0.0;i=i;return}function BF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3752>>3]=0.0;i=i;return}function CF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3760>>3]=1.0;i=i;return}function DF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3768>>3]=0.0;i=i;return}function EF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3776>>3]=0.0;i=i;return}function FF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3784>>3]=0.0;i=i;return}function GF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3792>>3]=0.0;i=i;return}function HF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3800>>3]=0.0;i=i;return}function IF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3808>>3]=0.0;i=i;return}function JF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3816>>3]=0.0;i=i;return}function KF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3824>>3]=0.0;i=i;return}function LF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3832>>3]=1.0;i=i;return}function MF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3840>>3]=0.0;i=i;return}function NF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3848>>3]=1.0;i=i;return}function OF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3856>>3]=0.0;i=i;return}function PF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3864>>3]=0.0;i=i;return}function QF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3872>>3]=0.0;i=i;return}function RF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3880>>3]=0.0;i=i;return}function SF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3888>>3]=0.0;i=i;return}function TF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3896>>3]=0.0;i=i;return}function UF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3904>>3]=0.0;i=i;return}function VF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3912>>3]=0.0;i=i;return}function WF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3920>>3]=1.0;i=i;return}function XF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3928>>3]=0.0;i=i;return}function YF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3936>>3]=1.0;i=i;return}function ZF(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3944>>3]=0.0;i=i;return}function _F(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3952>>3]=0.0;i=i;return}function $F(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3960>>3]=0.0;i=i;return}function aG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3968>>3]=0.0;i=i;return}function bG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3976>>3]=0.0;i=i;return}function cG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3984>>3]=0.0;i=i;return}function dG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+3992>>3]=0.0;i=i;return}function eG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4e3>>3]=0.0;i=i;return}function fG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4008>>3]=0.0;i=i;return}function gG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4016>>3]=0.0;i=i;return}function hG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4024>>3]=1.0;i=i;return}function iG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4032>>3]=0.0;i=i;return}function jG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4040>>3]=1.0;i=i;return}function kG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4048>>3]=0.0;i=i;return}function lG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4056>>3]=0.0;i=i;return}function mG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4064>>3]=0.0;i=i;return}function nG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4072>>3]=0.0;i=i;return}function oG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4080>>3]=0.0;i=i;return}function pG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4088>>3]=0.0;i=i;return}function qG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4096>>3]=0.0;i=i;return}function rG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4104>>3]=0.0;i=i;return}function sG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4112>>3]=1.0;i=i;return}function tG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4120>>3]=0.0;i=i;return}function uG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4128>>3]=1.0;i=i;return}function vG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4136>>3]=0.0;i=i;return}function wG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4160>>3]=0.0;i=i;return}function xG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4152>>3]=0.0;i=i;return}function yG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4144>>3]=0.0;i=i;return}function zG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4184>>3]=0.0;i=i;return}function AG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4176>>3]=0.0;i=i;return}function BG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4168>>3]=0.0;i=i;return}function CG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4208>>3]=0.0;i=i;return}function DG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4200>>3]=0.0;i=i;return}function EG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4192>>3]=0.0;i=i;return}function FG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4232>>3]=0.0;i=i;return}function GG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4224>>3]=0.0;i=i;return}function HG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4216>>3]=0.0;i=i;return}function IG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4256>>3]=0.0;i=i;return}function JG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4248>>3]=0.0;i=i;return}function KG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4240>>3]=0.0;i=i;return}function LG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4280>>3]=0.0;i=i;return}function MG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4272>>3]=0.0;i=i;return}function NG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4264>>3]=0.0;i=i;return}function OG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4304>>3]=0.0;i=i;return}function PG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4296>>3]=0.0;i=i;return}function QG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4288>>3]=0.0;i=i;return}function RG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=0.0;i=i;return}function SG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4320>>3]=0.0;i=i;return}function TG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4312>>3]=0.0;i=i;return}function UG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function VG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4344>>3]=0.0;i=i;return}function WG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4336>>3]=0.0;i=i;return}function XG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=0.0;i=i;return}function YG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4368>>3]=0.0;i=i;return}function ZG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4360>>3]=0.0;i=i;return}function _G(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=0.0;i=i;return}function $G(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4392>>3]=0.0;i=i;return}function aH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4384>>3]=0.0;i=i;return}function bH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=0.0;i=i;return}function cH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4416>>3]=0.0;i=i;return}function dH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4408>>3]=0.0;i=i;return}function eH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function fH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4440>>3]=0.0;i=i;return}function gH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4432>>3]=0.0;i=i;return}function hH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=0;i=i;return}function iH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=0;i=i;return}function jH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=0;i=i;return}function kH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4456>>3]=0.0;i=i;return}function lH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4464>>3]=0.0;i=i;return}function mH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=0.0;i=i;return}function nH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4480>>3]=0.0;i=i;return}function oH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4488>>3]=-1.0;i=i;return}function pH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4496>>3]=0.0;i=i;return}function qH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function rH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=1.0;i=i;return}function sH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4520>>3]=0.0;i=i;return}function tH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4528>>3]=0.0;i=i;return}function uH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=0.0;i=i;return}function vH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4544>>3]=0.0;i=i;return}function wH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function xH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4568>>3]=-1.0;i=i;return}function yH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4576>>3]=0.0;i=i;return}function zH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=0.0;i=i;return}function AH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4592>>3]=1.0;i=i;return}function BH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4600>>3]=0.0;i=i;return}function CH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4624>>3]=0.0;i=i;return}function DH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=230.0;i=i;return}function EH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4608>>3]=0.0;i=i;return}function FH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=0.0;i=i;return}function GH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4640>>3]=230.0;i=i;return}function HH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4632>>3]=0.0;i=i;return}function IH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=0;i=i;return}function JH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=230;i=i;return}function KH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=0;i=i;return}function LH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=0;i=i;return}function MH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=128;i=i;return}function NH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=255;i=i;return}function OH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4656>>3]=0.0;i=i;return}function PH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4664>>3]=0.0;i=i;return}function QH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=0.0;i=i;return}function RH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=255.0;i=i;return}function SH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4688>>3]=0.0;i=i;return}function TH(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4680>>3]=0.0;i=i;return}function UH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=0;i=i;return}function VH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=0;i=i;return}function WH(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=255;i=i;return}



function J3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((qpa(b,82792)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{Hea(g,v);w=w3(u,g)|0;Pea(w,c[d+((t|1)<<2)>>2]|0)|0;Nea(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((qpa(b,82816)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{Hea(h,g);u=w3(t,h)|0;Pea(u,c[d+((v|1)<<2)>>2]|0)|0;Nea(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((qpa(b,82840)|0)!=0){do{if((qpa(b,83096)|0)!=0){if((qpa(b,83104)|0)==0){break}if((qpa(b,83112)|0)==0){break}if((qpa(b,83120)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=P3(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){Hea(r,c[t>>2]|0);w=w3(g,r)|0;Pea(w,c[d+((u|1)<<2)>>2]|0)|0;Nea(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=P3(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}Hea(s,83128);Pea(w3(x,s)|0,b)|0;Nea(s);i=e;return}Y3(j,k);Bea(l);Bea(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{Hea(n,g);t=w3(j,n)|0;Pea(t,c[d+((x|1)<<2)>>2]|0)|0;Nea(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}Hea(o,82856);Oea(l,w3(j,o)|0)|0;Nea(o);Hea(p,82872);Oea(m,w3(j,p)|0)|0;Nea(p);c[k>>2]=Fc(ifa(l)|0)|0;if((lfa(m,82888)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((lfa(m,82896)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((lfa(m,82904)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((lfa(m,82912)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((lfa(m,82920)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((lfa(m,82928)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((lfa(m,82936)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((lfa(m,82944)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((lfa(m,82952)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((lfa(m,82960)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((lfa(m,82968)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((lfa(m,82976)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((lfa(m,82984)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((lfa(m,82992)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=ifa(m)|0;Hea(q,79416);N=ifa(w3(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;wW(0,(O|0)!=0|0,83e3,f);Nea(q);j9(P3(c[b>>2]|0,s)|0,j)|0;Nea(m);Nea(l);e4(j);i=e;return}function K3(a,b){a=a|0;b=b|0;i=i;return}function L3(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=W5(a,b)|0;i=c;return d|0}function M3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;d6(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];X5(a,f);i=e;return}function N3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;Y5(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];X5(a,e);i=d;return}function O3(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;Y3(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){xW(0,82184,n)}if(p){ec=Ad(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;tW(23,0,82328,m);Z3(q);_3(q,e,8);if(!($3(q)|0)){c[l>>2]=e;xW(0,82368,l)}Bea(r);l=q;a4(l,r)|0;Dea(s,r);while(1){e=a4(l,r)|0;if(!(xfa(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}wfa(t,82448,r);cfa(s,t)|0;Nea(t)}t=Ad(ifa(s)|0)|0;b4(q);Nea(s);Nea(r);c4(q);fc=t}if((fc|0)==0){tW(23,0,82536,g);e4(o);i=f;return}Bea(u);Bea(v);c[k>>2]=fc;tW(23,0,82456,k);k=Xb(fc|0,82448)|0;if((k|0)!=0){g=k;do{k=Yoa(12)|0;Hea(k,g);t=jfa(k,82488,0)|0;hfa(w,k,0,t);Oea(u,w)|0;Nea(w);hfa(x,k,t+1|0,(Uea(k)|0)+~t|0);Oea(v,x)|0;Nea(x);Oea(w3(o,u)|0,v)|0;t=ifa(u)|0;k=ifa(v)|0;c[j>>2]=t;c[j+4>>2]=k;tW(23,0,82496,j);g=Xb(0,82448)|0;}while((g|0)!=0)}Toa(fc);fc=a+12|0;Hea(y,80584);g=w3(fc,y)|0;Hea(z,80584);if((d4(o,z)|0)==0){Hea(B,80584);gc=1;hc=0;ic=w3(fc,B)|0}else{Hea(A,80584);gc=0;hc=1;ic=w3(o,A)|0}Oea(g,ic)|0;if(gc){Nea(B)}if(hc){Nea(A)}Nea(z);Nea(y);Hea(C,80456);y=w3(fc,C)|0;Hea(D,80456);if((d4(o,D)|0)==0){Hea(F,80456);jc=1;kc=0;lc=w3(fc,F)|0}else{Hea(E,80456);jc=0;kc=1;lc=w3(o,E)|0}Oea(y,lc)|0;if(jc){Nea(F)}if(kc){Nea(E)}Nea(D);Nea(C);Hea(G,80488);C=w3(fc,G)|0;Hea(H,80488);if((d4(o,H)|0)==0){Hea(J,80488);mc=1;nc=0;oc=w3(fc,J)|0}else{Hea(I,80488);mc=0;nc=1;oc=w3(o,I)|0}Oea(C,oc)|0;if(mc){Nea(J)}if(nc){Nea(I)}Nea(H);Nea(G);Hea(K,80520);G=w3(fc,K)|0;Hea(L,80520);if((d4(o,L)|0)==0){Hea(N,80520);pc=0;qc=1;rc=w3(fc,N)|0}else{Hea(M,80520);pc=1;qc=0;rc=w3(o,M)|0}Oea(G,rc)|0;if(qc){Nea(N)}if(pc){Nea(M)}Nea(L);Nea(K);Hea(O,80552);K=w3(fc,O)|0;Hea(P,80552);if((d4(o,P)|0)==0){Hea(R,80552);sc=1;tc=0;uc=w3(fc,R)|0}else{Hea(Q,80552);sc=0;tc=1;uc=w3(o,Q)|0}Oea(K,uc)|0;if(sc){Nea(R)}if(tc){Nea(Q)}Nea(P);Nea(O);Hea(S,80616);O=w3(fc,S)|0;Hea(T,80616);if((d4(o,T)|0)==0){Hea(V,80616);vc=1;wc=0;xc=w3(fc,V)|0}else{Hea(U,80616);vc=0;wc=1;xc=w3(o,U)|0}Oea(O,xc)|0;if(vc){Nea(V)}if(wc){Nea(U)}Nea(T);Nea(S);Hea(W,80656);S=w3(fc,W)|0;Hea(X,80656);if((d4(o,X)|0)==0){Hea(Z,80656);yc=1;zc=0;Ac=w3(fc,Z)|0}else{Hea(Y,80656);yc=0;zc=1;Ac=w3(o,Y)|0}Oea(S,Ac)|0;if(yc){Nea(Z)}if(zc){Nea(Y)}Nea(X);Nea(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=P3(Y,_)|0;Hea($,79560);Ac=w3(yc,$)|0;c[aa>>2]=Z;yc=P3(Y,aa)|0;Hea(ba,79416);if((d4(o,w3(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=P3(Y,ea)|0;Hea(fa,79560);Bc=1;Cc=0;Dc=w3(yc,fa)|0}else{c[ca>>2]=Z;yc=P3(Y,ca)|0;Hea(da,79416);Bc=0;Cc=1;Dc=w3(o,w3(yc,da)|0)|0}Oea(Ac,Dc)|0;if(Bc){Nea(fa)}if(Cc){Nea(da)}Nea(ba);Nea($);c[ga>>2]=Z;Ac=P3(zc,ga)|0;Hea(ha,79560);yc=w3(Ac,ha)|0;c[ia>>2]=Z;Ac=P3(zc,ia)|0;Hea(ja,79416);if((d4(o,w3(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=P3(zc,ma)|0;Hea(na,79560);Ec=1;Fc=0;Gc=w3(Ac,na)|0}else{c[ka>>2]=Z;Ac=P3(zc,ka)|0;Hea(la,79416);Ec=0;Fc=1;Gc=w3(o,w3(Ac,la)|0)|0}Oea(yc,Gc)|0;if(Ec){Nea(na)}if(Fc){Nea(la)}Nea(ja);Nea(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=P3(Hc,oa)|0;Hea(pa,79560);ja=w3(ha,pa)|0;c[qa>>2]=Z;ha=P3(Hc,qa)|0;Hea(ra,79416);if((d4(o,w3(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=P3(Hc,ua)|0;Hea(va,79560);Ic=1;Jc=0;Kc=w3(ha,va)|0}else{c[sa>>2]=Z;ha=P3(Hc,sa)|0;Hea(ta,79416);Ic=0;Jc=1;Kc=w3(o,w3(ha,ta)|0)|0}Oea(ja,Kc)|0;if(Ic){Nea(va)}if(Jc){Nea(ta)}Nea(ra);Nea(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=P3(X,wa)|0;Hea(xa,79560);ra=w3(pa,xa)|0;c[ya>>2]=Z;pa=P3(X,ya)|0;Hea(za,79416);if((d4(o,w3(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=P3(X,Ca)|0;Hea(Da,79560);Lc=1;Mc=0;Nc=w3(pa,Da)|0}else{c[Aa>>2]=Z;pa=P3(X,Aa)|0;Hea(Ba,79416);Lc=0;Mc=1;Nc=w3(o,w3(pa,Ba)|0)|0}Oea(ra,Nc)|0;if(Lc){Nea(Da)}if(Mc){Nea(Ba)}Nea(za);Nea(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=P3(Z,Ea)|0;Hea(Fa,79560);Ba=w3(za,Fa)|0;c[Ga>>2]=xa;za=P3(Z,Ga)|0;Hea(Ha,79416);if((d4(o,w3(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=P3(Z,Ka)|0;Hea(La,79560);Oc=1;Pc=0;Qc=w3(za,La)|0}else{c[Ia>>2]=xa;za=P3(Z,Ia)|0;Hea(Ja,79416);Oc=0;Pc=1;Qc=w3(o,w3(za,Ja)|0)|0}Oea(Ba,Qc)|0;if(Oc){Nea(La)}if(Pc){Nea(Ja)}Nea(Ha);Nea(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=P3(xa,Ma)|0;Hea(Na,79560);Ja=w3(Ha,Na)|0;c[Oa>>2]=Fa;Ha=P3(xa,Oa)|0;Hea(Pa,79416);if((d4(o,w3(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=P3(xa,Sa)|0;Hea(Ta,79560);Rc=1;Sc=0;Tc=w3(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=P3(xa,Qa)|0;Hea(Ra,79416);Rc=0;Sc=1;Tc=w3(o,w3(Ha,Ra)|0)|0}Oea(Ja,Tc)|0;if(Rc){Nea(Ta)}if(Sc){Nea(Ra)}Nea(Pa);Nea(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=P3(Fa,Ua)|0;Hea(Va,79560);Ra=w3(Pa,Va)|0;c[Wa>>2]=Na;Pa=P3(Fa,Wa)|0;Hea(Xa,79416);if((d4(o,w3(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=P3(Fa,_a)|0;Hea($a,79560);Uc=1;Vc=0;Wc=w3(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=P3(Fa,Ya)|0;Hea(Za,79416);Uc=0;Vc=1;Wc=w3(o,w3(Pa,Za)|0)|0}Oea(Ra,Wc)|0;if(Uc){Nea($a)}if(Vc){Nea(Za)}Nea(Xa);Nea(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=P3(Na,ab)|0;Hea(bb,79560);Za=w3(Xa,bb)|0;c[cb>>2]=Va;Xa=P3(Na,cb)|0;Hea(db,79416);if((d4(o,w3(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=P3(Na,gb)|0;Hea(hb,79560);Xc=1;Yc=0;Zc=w3(Xa,hb)|0}else{c[eb>>2]=Va;Xa=P3(Na,eb)|0;Hea(fb,79416);Xc=0;Yc=1;Zc=w3(o,w3(Xa,fb)|0)|0}Oea(Za,Zc)|0;if(Xc){Nea(hb)}if(Yc){Nea(fb)}Nea(db);Nea(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=P3(Va,ib)|0;Hea(jb,79560);fb=w3(db,jb)|0;c[kb>>2]=bb;db=P3(Va,kb)|0;Hea(lb,79416);if((d4(o,w3(db,lb)|0)|0)==0){c[ob>>2]=bb;db=P3(Va,ob)|0;Hea(pb,79560);_c=1;$c=0;ad=w3(db,pb)|0}else{c[mb>>2]=bb;db=P3(Va,mb)|0;Hea(nb,79416);_c=0;$c=1;ad=w3(o,w3(db,nb)|0)|0}Oea(fb,ad)|0;if(_c){Nea(pb)}if($c){Nea(nb)}Nea(lb);Nea(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=P3(bb,qb)|0;Hea(rb,79560);nb=w3(lb,rb)|0;c[sb>>2]=jb;lb=P3(bb,sb)|0;Hea(tb,79416);if((d4(o,w3(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=P3(bb,wb)|0;Hea(xb,79560);bd=1;cd=0;dd=w3(lb,xb)|0}else{c[ub>>2]=jb;lb=P3(bb,ub)|0;Hea(vb,79416);bd=0;cd=1;dd=w3(o,w3(lb,vb)|0)|0}Oea(nb,dd)|0;if(bd){Nea(xb)}if(cd){Nea(vb)}Nea(tb);Nea(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=P3(jb,yb)|0;Hea(zb,79560);vb=w3(tb,zb)|0;c[Ab>>2]=rb;tb=P3(jb,Ab)|0;Hea(Bb,79416);if((d4(o,w3(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=P3(jb,Eb)|0;Hea(Fb,79560);ed=1;fd=0;gd=w3(tb,Fb)|0}else{c[Cb>>2]=rb;tb=P3(jb,Cb)|0;Hea(Db,79416);ed=0;fd=1;gd=w3(o,w3(tb,Db)|0)|0}Oea(vb,gd)|0;if(ed){Nea(Fb)}if(fd){Nea(Db)}Nea(Bb);Nea(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=P3(rb,Gb)|0;Hea(Hb,79560);Db=w3(Bb,Hb)|0;c[Ib>>2]=zb;Bb=P3(rb,Ib)|0;Hea(Jb,79416);if((d4(o,w3(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=P3(rb,Mb)|0;Hea(Nb,79560);hd=0;id=1;jd=w3(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=P3(rb,Kb)|0;Hea(Lb,79416);hd=1;id=0;jd=w3(o,w3(Bb,Lb)|0)|0}Oea(Db,jd)|0;if(id){Nea(Nb)}if(hd){Nea(Lb)}Nea(Jb);Nea(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=P3(zb,Ob)|0;Hea(Pb,79560);Lb=w3(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=P3(zb,Qb)|0;Hea(Rb,79416);if((d4(o,w3(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=P3(zb,Ub)|0;Hea(Vb,79560);kd=1;ld=0;md=w3(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=P3(zb,Sb)|0;Hea(Tb,79416);kd=0;ld=1;md=w3(o,w3(Jb,Tb)|0)|0}Oea(Lb,md)|0;if(kd){Nea(Vb)}if(ld){Nea(Tb)}Nea(Rb);Nea(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=P3(b,Wb)|0;Hea(Yb,79560);Pb=w3(Hb,Yb)|0;c[Zb>>2]=a;Hb=P3(b,Zb)|0;Hea(_b,79416);if((d4(o,w3(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=P3(b,bc)|0;Hea(cc,79560);nd=1;od=0;pd=w3(Hb,cc)|0}else{c[$b>>2]=a;Hb=P3(b,$b)|0;Hea(ac,79416);nd=0;od=1;pd=w3(o,w3(Hb,ac)|0)|0}Oea(Pb,pd)|0;if(nd){Nea(cc)}if(od){Nea(ac)}Nea(_b);Nea(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}tW(23,0,82520,h);Nea(v);Nea(u);e4(o);i=f;return}function P3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=u6(a,f,b)|0;l=c[k>>2]|0;g0(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}w6(j,a,b);x6(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];v6(g,e);y6(j);j=c[f>>2]|0;z6(a,j,k,A6(g)|0);k=B6(g)|0;y6(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function Q3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=Y4(a,f,b)|0;l=c[k>>2]|0;g0(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}_4(j,a,b);$4(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];Z4(g,e);a5(j);j=c[f>>2]|0;b5(a,j,k,c5(g)|0);k=d5(g)|0;a5(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function R3(a,b){a=a|0;b=b|0;var c=0;c=i;Oea(b,a)|0;i=c;return}function S3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;P4(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];H4(a,f);i=e;return}function T3(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=F4(a,b)|0;i=c;return d|0}function U3(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;I4(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];H4(a,e);i=d;return}function V3(a){a=a|0;var b=0,c=0;b=i;c=C4(a)|0;i=b;return c|0}function W3(a){a=a|0;var b=0;b=i;$8(a);i=b;return}function X3(a){a=a|0;var b=0;b=i;O8(a);i=b;return}function Y3(a,b){a=a|0;b=b|0;b=i;v7(a,0);i=b;return}function Z3(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;Kfa(d);e=a;c[e>>2]=82588;f=d;c[f>>2]=82608;d=a+8|0;Cga(a,82620|0,d);c[e>>2]=82588;c[f>>2]=82608;P2(d);i=b;return}function _3(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(o0(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){Bfa(d,4);i=e;return}else{zfa(d,0);i=e;return}}function $3(a){a=a|0;var b=0,c=0;b=i;c=x4(a+8|0)|0;i=b;return c|0}function a4(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=w4(a,b,Ifa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function b4(a){a=a|0;var b=0;b=i;if((q0(a+8|0)|0)!=0){i=b;return}Bfa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function c4(a){a=a|0;var b=0;b=i;B4(a,82616);Ffa(a+108|0);i=b;return}function d4(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=f4(a,b)|0;i=c;return d|0}function e4(a){a=a|0;var b=0;b=i;D8(a);i=b;return}function f4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=h4(a)|0;g0(e);if((f|0)==0){g=0;i=d;return g|0}h=i4(a)|0;a=f;while(1){f=a+16|0;if(j4(h,b,f)|0){j=a}else{if(!(k4(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;g0(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function g4(a){a=a|0;var b=0,c=0;b=i;c=T$(q4(a+4|0)|0)|0;i=b;return c|0}function h4(a){a=a|0;var b=0,d=0;b=i;d=c[(g4(a)|0)>>2]|0;i=b;return d|0}function i4(a){a=a|0;var b=0,c=0;b=i;c=o4(a+8|0)|0;i=b;return c|0}function j4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l4(0,b,c)|0;i=a;return d|0}function k4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l4(0,b,c)|0;i=a;return d|0}function l4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=m4(b,c)|0;i=a;return d|0}function m4(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(kfa(a,b)|0)<0;i=c;return d|0}function n4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=ppa(a,b,c)|0;i=d;return e|0}function o4(a){a=a|0;var b=0,c=0;b=i;c=p4(a)|0;i=b;return c|0}function p4(a){a=a|0;i=i;return a|0}function q4(a){a=a|0;var b=0,c=0;b=i;c=r4(a)|0;i=b;return c|0}function r4(a){a=a|0;i=i;return a|0}function s4(a,b){a=a|0;b=b|0;var c=0;a=i;c=u4(0,b,0)|0;i=a;return c|0}function t4(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function u4(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Yoa(b)|0;i=c;return a|0}function v4(a){a=a|0;var b=0,c=0;b=i;c=upa(a|0)|0;i=b;return c|0}function w4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;Hga(f,a,1);if(!(Kga(f)|0)){i=e;return a|0}bfa(b);f=0;while(1){g=Qfa(Gfa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(a1(g,-1)|0){h=2;j=f;break}k=f+1|0;l=b1(g)|0;if(f1(l,d)|0){h=0;j=k;break}dfa(b,l);if((Lea(b)|0)==-17){h=4;j=k;break}else{f=k}}Bfa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function x4(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function y4(a){a=a|0;var b=0;b=i;c4(a);_oa(a);i=b;return}function z4(a){a=a|0;var b=0;b=i;c4(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function A4(a){a=a|0;var b=0;b=i;y4(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function B4(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];Q0(a+8|0);i=d;return}function C4(a){a=a|0;var b=0,d=0;b=i;d=D4((c[a>>2]|0)+16|0)|0;i=b;return d|0}function D4(a){a=a|0;var b=0,c=0;b=i;c=E4(a)|0;i=b;return c|0}function E4(a){a=a|0;i=i;return a|0}function F4(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(G4(a,b)|0)^1;i=c;return d|0}function G4(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function H4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];O4(a,e);i=d;return}function I4(a,b){a=a|0;b=b|0;var c=0;c=i;J4(a,K4(b)|0);i=c;return}function J4(a,b){a=a|0;b=b|0;var c=0;c=i;N4(a,b);i=c;return}function K4(a){a=a|0;var b=0,c=0;b=i;c=T$(L4(a+4|0)|0)|0;i=b;return c|0}function L4(a){a=a|0;var b=0,c=0;b=i;c=M4(a)|0;i=b;return c|0}function M4(a){a=a|0;i=i;return a|0}function N4(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function O4(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function P4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=R4(b)|0;Q4(f,b,d,h,K4(b)|0);I4(g,b);do{if(F4(f,g)|0){h=S4(b)|0;if(T4(h,d,U4(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);I4(a,b);i=e;return}function Q4(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;g0(h);a:do{if((e|0)==0){j=f}else{k=S4(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(X4(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;g0(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;g0(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);J4(a,j);i=g;return}function R4(a){a=a|0;var b=0,d=0;b=i;d=c[(K4(a)|0)>>2]|0;i=b;return d|0}function S4(a){a=a|0;var b=0,c=0;b=i;c=V4(a+8|0)|0;i=b;return c|0}function T4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l4(0,b,c)|0;i=a;return d|0}function U4(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function V4(a){a=a|0;var b=0,c=0;b=i;c=W4(a)|0;i=b;return c|0}function W4(a){a=a|0;i=i;return a|0}function X4(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l4(0,b,c)|0;i=a;return d|0}function Y4(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=R4(h)|0;g0(e);if((a|0)==0){j=K4(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(l4(0,d,a)|0){m=l;j=c[m>>2]|0;g0(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(l4(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g0(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function Z4(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];U5(a,e);i=d;return}function _4(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=z5(d)|0;d=B5(n,1)|0;C5(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];A5(j,d,h);D5(0,s5((E5(j)|0)+16|0)|0,e);e=F5(j)|0;a[e+4|0]=1;G5(0,q5((E5(j)|0)+28|0)|0);a[e+5|0]=1;H5(m,j);$4(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];Z4(b,g);a5(m);a5(j);i=f;return}function $4(a,b){a=a|0;b=b|0;var c=0;c=i;x5(a,b);i=c;return}function a5(a){a=a|0;var b=0;b=i;m5(a);i=b;return}function b5(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g0(f);c[e>>2]=0;g0(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=i5(a)|0;b=c[c[e>>2]>>2]|0;g0(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(K4(a)|0)>>2]|0;S1(e,c[d>>2]|0);d=j5(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function c5(a){a=a|0;var b=0,d=0;b=i;d=c[(g5(a)|0)>>2]|0;i=b;return d|0}function d5(a){a=a|0;var b=0,d=0;b=i;d=e5(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function e5(a){a=a|0;var b=0,c=0;b=i;c=f5(a)|0;i=b;return c|0}function f5(a){a=a|0;i=i;return a|0}function g5(a){a=a|0;var b=0,c=0;b=i;c=h5(a)|0;i=b;return c|0}function h5(a){a=a|0;i=i;return a|0}function i5(a){a=a|0;i=i;return a|0}function j5(a){a=a|0;var b=0,c=0;b=i;c=k5(a+8|0)|0;i=b;return c|0}function k5(a){a=a|0;var b=0,c=0;b=i;c=l5(a)|0;i=b;return c|0}function l5(a){a=a|0;i=i;return a|0}function m5(a){a=a|0;var b=0;b=i;n5(a,0);i=b;return}function n5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=e5(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}p5(o5(e)|0,f);i=d;return}function o5(a){a=a|0;var b=0,c=0;b=i;c=w5(a)|0;i=b;return c|0}function p5(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;r5(f,s5(d+16|0)|0)}if((d|0)==0){i=e;return}t5(c[b>>2]|0,d,1);i=e;return}function q5(a){a=a|0;i=i;return a|0}function r5(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;v5(d,0,c);i=b;return}function s5(a){a=a|0;i=i;return a|0}function t5(a,b,c){a=a|0;b=b|0;c=c|0;c=i;u5(0,b,0);i=c;return}function u5(a,b,c){a=a|0;b=b|0;c=c|0;c=i;_oa(b);i=c;return}function v5(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Nea(c);i=b;return}function w5(a){a=a|0;i=i;return a+4|0}function x5(a,b){a=a|0;b=b|0;var c=0;c=i;y5(a,b);i=c;return}function y5(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function z5(a){a=a|0;var b=0,c=0;b=i;c=S5(a+4|0)|0;i=b;return c|0}function A5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];K5(a,b,f);i=e;return}function B5(a,b){a=a|0;b=b|0;var c=0;a=i;c=J5(0,b,0)|0;i=a;return c|0}function C5(a,b){a=a|0;b=b|0;var c=0;c=i;I5(a,b);i=c;return}function D5(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}Dea(b,c);i=a;return}function E5(a){a=a|0;var b=0,d=0;b=i;d=c[(g5(a)|0)>>2]|0;i=b;return d|0}function F5(a){a=a|0;var b=0,c=0;b=i;c=o5(a)|0;i=b;return c|0}function G5(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function H5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;x5(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];Z4(h,f);$4(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];Z4(a,e);a5(h);i=d;return}function I5(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function J5(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Yoa(b<<5)|0;i=c;return a|0}function K5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(M5(g)|0)>>2]|0;g=N5(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];L5(b,a,f);i=e;return}function L5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];O5(a,b,f);i=e;return}function M5(a){a=a|0;i=i;return a|0}function N5(a){a=a|0;i=i;return a|0}function O5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(Q5(g)|0)>>2]|0;g=R5(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];P5(b,a,f);i=e;return}function P5(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(Q5(f)|0)>>2];f=R5(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function Q5(a){a=a|0;i=i;return a|0}function R5(a){a=a|0;i=i;return a|0}function S5(a){a=a|0;var b=0,c=0;b=i;c=T5(a)|0;i=b;return c|0}function T5(a){a=a|0;i=i;return a|0}function U5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=d5(V5(b)|0)|0;h=R5(F5(V5(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];L5(g,a,e);i=d;return}function V5(a){a=a|0;i=i;return c[a>>2]|0}function W5(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function X5(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];c6(a,e);i=d;return}function Y5(a,b){a=a|0;b=b|0;var c=0;c=i;Z5(a,_5(b)|0);i=c;return}function Z5(a,b){a=a|0;b=b|0;var c=0;c=i;b6(a,b);i=c;return}function _5(a){a=a|0;var b=0,c=0;b=i;c=T$($5(a+4|0)|0)|0;i=b;return c|0}function $5(a){a=a|0;var b=0,c=0;b=i;c=a6(a)|0;i=b;return c|0}function a6(a){a=a|0;i=i;return a|0}function b6(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function c6(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function d6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=f6(b)|0;e6(f,b,d,h,_5(b)|0);Y5(g,b);do{if(g6(f,g)|0){h=h6(b)|0;if(j4(h,d,i6(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);Y5(a,b);i=e;return}function e6(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;g0(h);a:do{if((e|0)==0){j=f}else{k=h6(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(k4(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;g0(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;g0(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);Z5(a,j);i=g;return}function f6(a){a=a|0;var b=0,d=0;b=i;d=c[(_5(a)|0)>>2]|0;i=b;return d|0}function g6(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(W5(a,b)|0)^1;i=c;return d|0}function h6(a){a=a|0;var b=0,c=0;b=i;c=j6(a+8|0)|0;i=b;return c|0}function i6(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function j6(a){a=a|0;var b=0,c=0;b=i;c=k6(a)|0;i=b;return c|0}function k6(a){a=a|0;i=i;return a|0}function l6(a,b){a=a|0;b=b|0;b=i;i=i+8|0;m6(a,b);i=b;return}function m6(a,b){a=a|0;b=b|0;b=i;n6(a,0);i=b;return}function n6(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;o6(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;p6(f,0,e);e=K4(b)|0;c[(i5(b)|0)>>2]=e;i=d;return}function o6(a){a=a|0;var b=0;b=i;s6(a);i=b;return}function p6(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;q6(b,c,f);i=e;return}function q6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K2(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;r6(d,b,f);i=e;return}function r6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K2(e)|0)>>2];i=d;return}function s6(a){a=a|0;var b=0;b=i;t6(a);i=b;return}function t6(a){a=a|0;var b=0;b=i;N2(a);i=b;return}function u6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=u7(h)|0;g0(e);if((a|0)==0){j=H6(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(d0(0,d,a)|0){m=l;j=c[m>>2]|0;g0(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(d0(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g0(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function v6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];s7(a,e);i=d;return}function w6(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=Z6(d)|0;d=$6(n,1)|0;a7(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];_6(j,d,h);b7(0,c2((c7(j)|0)+16|0)|0,e);e=d7(j)|0;a[e+4|0]=1;e7(0,S6((c7(j)|0)+20|0)|0);a[e+5|0]=1;f7(m,j);x6(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];v6(b,g);y6(m);y6(j);i=f;return}function x6(a,b){a=a|0;b=b|0;var c=0;c=i;X6(a,b);i=c;return}function y6(a){a=a|0;var b=0;b=i;N6(a);i=b;return}function z6(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g0(f);c[e>>2]=0;g0(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=G6(a)|0;b=c[c[e>>2]>>2]|0;g0(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(H6(a)|0)>>2]|0;S1(e,c[d>>2]|0);d=I6(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function A6(a){a=a|0;var b=0,d=0;b=i;d=c[(E6(a)|0)>>2]|0;i=b;return d|0}function B6(a){a=a|0;var b=0,d=0;b=i;d=C6(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function C6(a){a=a|0;var b=0,c=0;b=i;c=D6(a)|0;i=b;return c|0}function D6(a){a=a|0;i=i;return a|0}function E6(a){a=a|0;var b=0,c=0;b=i;c=F6(a)|0;i=b;return c|0}function F6(a){a=a|0;i=i;return a|0}function G6(a){a=a|0;i=i;return a|0}function H6(a){a=a|0;var b=0,c=0;b=i;c=T$(L6(a+4|0)|0)|0;i=b;return c|0}function I6(a){a=a|0;var b=0,c=0;b=i;c=J6(a+8|0)|0;i=b;return c|0}function J6(a){a=a|0;var b=0,c=0;b=i;c=K6(a)|0;i=b;return c|0}function K6(a){a=a|0;i=i;return a|0}function L6(a){a=a|0;var b=0,c=0;b=i;c=M6(a)|0;i=b;return c|0}function M6(a){a=a|0;i=i;return a|0}function N6(a){a=a|0;var b=0;b=i;O6(a,0);i=b;return}function O6(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=C6(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Q6(P6(e)|0,f);i=d;return}function P6(a){a=a|0;var b=0,c=0;b=i;c=W6(a)|0;i=b;return c|0}function Q6(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;R6(f,S6(d+20|0)|0)}if((d|0)==0){i=e;return}T6(c[b>>2]|0,d,1);i=e;return}function R6(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;V6(d,0,c);i=b;return}function S6(a){a=a|0;i=i;return a|0}function T6(a,b,c){a=a|0;b=b|0;c=c|0;c=i;U6(0,b,0);i=c;return}function U6(a,b,c){a=a|0;b=b|0;c=c|0;c=i;_oa(b);i=c;return}function V6(a,b,c){a=a|0;b=b|0;c=c|0;b=i;e4(c);i=b;return}function W6(a){a=a|0;i=i;return a+4|0}function X6(a,b){a=a|0;b=b|0;var c=0;c=i;Y6(a,b);i=c;return}function Y6(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function Z6(a){a=a|0;var b=0,c=0;b=i;c=q7(a+4|0)|0;i=b;return c|0}function _6(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];i7(a,b,f);i=e;return}function $6(a,b){a=a|0;b=b|0;var c=0;a=i;c=h7(0,b,0)|0;i=a;return c|0}function a7(a,b){a=a|0;b=b|0;var c=0;c=i;g7(a,b);i=c;return}function b7(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function c7(a){a=a|0;var b=0,d=0;b=i;d=c[(E6(a)|0)>>2]|0;i=b;return d|0}function d7(a){a=a|0;var b=0,c=0;b=i;c=P6(a)|0;i=b;return c|0}function e7(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}Y3(b,a);i=a;return}function f7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;X6(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];v6(h,f);x6(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];v6(a,e);y6(h);i=d;return}function g7(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function h7(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Yoa(b<<5)|0;i=c;return a|0}function i7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(k7(g)|0)>>2]|0;g=l7(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];j7(b,a,f);i=e;return}function j7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];m7(a,b,f);i=e;return}function k7(a){a=a|0;i=i;return a|0}function l7(a){a=a|0;i=i;return a|0}function m7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(o7(g)|0)>>2]|0;g=p7(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];n7(b,a,f);i=e;return}function n7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(o7(f)|0)>>2];f=p7(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function o7(a){a=a|0;i=i;return a|0}function p7(a){a=a|0;i=i;return a|0}function q7(a){a=a|0;var b=0,c=0;b=i;c=r7(a)|0;i=b;return c|0}function r7(a){a=a|0;i=i;return a|0}function s7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=B6(t7(b)|0)|0;h=p7(d7(t7(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];j7(g,a,e);i=d;return}function t7(a){a=a|0;i=i;return c[a>>2]|0}function u7(a){a=a|0;var b=0,d=0;b=i;d=c[(H6(a)|0)>>2]|0;i=b;return d|0}function v7(a,b){a=a|0;b=b|0;b=i;i=i+8|0;w7(a,b);i=b;return}function w7(a,b){a=a|0;b=b|0;b=i;x7(a,0);i=b;return}function x7(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;y7(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;z7(f,0,e);e=_5(b)|0;c[(A7(b)|0)>>2]=e;i=d;return}function y7(a){a=a|0;var b=0;b=i;D7(a);i=b;return}function z7(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;B7(b,c,f);i=e;return}function A7(a){a=a|0;i=i;return a|0}function B7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K2(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;C7(d,b,f);i=e;return}function C7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K2(e)|0)>>2];i=d;return}function D7(a){a=a|0;var b=0;b=i;E7(a);i=b;return}function E7(a){a=a|0;var b=0;b=i;N2(a);i=b;return}function F7(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=f6(h)|0;g0(e);if((a|0)==0){j=_5(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(l4(0,d,a)|0){m=l;j=c[m>>2]|0;g0(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(l4(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;g0(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function G7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];B8(a,e);i=d;return}function H7(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=g8(d)|0;d=i8(n,1)|0;j8(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];h8(j,d,h);k8(0,s5((l8(j)|0)+16|0)|0,e);e=m8(j)|0;a[e+4|0]=1;n8(0,Z7((l8(j)|0)+28|0)|0);a[e+5|0]=1;o8(m,j);I7(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];G7(b,g);J7(m);J7(j);i=f;return}function I7(a,b){a=a|0;b=b|0;var c=0;c=i;e8(a,b);i=c;return}function J7(a){a=a|0;var b=0;b=i;U7(a);i=b;return}function K7(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;g0(f);c[e>>2]=0;g0(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=A7(a)|0;b=c[c[e>>2]>>2]|0;g0(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(_5(a)|0)>>2]|0;S1(e,c[d>>2]|0);d=R7(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function L7(a){a=a|0;var b=0,d=0;b=i;d=c[(P7(a)|0)>>2]|0;i=b;return d|0}function M7(a){a=a|0;var b=0,d=0;b=i;d=N7(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function N7(a){a=a|0;var b=0,c=0;b=i;c=O7(a)|0;i=b;return c|0}function O7(a){a=a|0;i=i;return a|0}function P7(a){a=a|0;var b=0,c=0;b=i;c=Q7(a)|0;i=b;return c|0}function Q7(a){a=a|0;i=i;return a|0}function R7(a){a=a|0;var b=0,c=0;b=i;c=S7(a+8|0)|0;i=b;return c|0}function S7(a){a=a|0;var b=0,c=0;b=i;c=T7(a)|0;i=b;return c|0}function T7(a){a=a|0;i=i;return a|0}function U7(a){a=a|0;var b=0;b=i;V7(a,0);i=b;return}function V7(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=N7(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}X7(W7(e)|0,f);i=d;return}function W7(a){a=a|0;var b=0,c=0;b=i;c=d8(a)|0;i=b;return c|0}function X7(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;Y7(f,Z7(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;_7(f,s5(d+16|0)|0)}if((d|0)==0){i=e;return}$7(c[b>>2]|0,d,1);i=e;return}function Y7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;c8(d,0,c);i=b;return}function Z7(a){a=a|0;i=i;return a|0}function _7(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;b8(d,0,c);i=b;return}function $7(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a8(0,b,0);i=c;return}function a8(a,b,c){a=a|0;b=b|0;c=c|0;c=i;_oa(b);i=c;return}function b8(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Nea(c);i=b;return}function c8(a,b,c){a=a|0;b=b|0;c=c|0;b=i;Nea(c);i=b;return}function d8(a){a=a|0;i=i;return a+4|0}function e8(a,b){a=a|0;b=b|0;var c=0;c=i;f8(a,b);i=c;return}function f8(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function g8(a){a=a|0;var b=0,c=0;b=i;c=z8(a+4|0)|0;i=b;return c|0}function h8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];r8(a,b,f);i=e;return}function i8(a,b){a=a|0;b=b|0;var c=0;a=i;c=q8(0,b,0)|0;i=a;return c|0}function j8(a,b){a=a|0;b=b|0;var c=0;c=i;p8(a,b);i=c;return}function k8(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}Dea(b,c);i=a;return}function l8(a){a=a|0;var b=0,d=0;b=i;d=c[(P7(a)|0)>>2]|0;i=b;return d|0}function m8(a){a=a|0;var b=0,c=0;b=i;c=W7(a)|0;i=b;return c|0}function n8(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}Bea(b);i=a;return}function o8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;e8(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];G7(h,f);I7(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];G7(a,e);J7(h);i=d;return}function p8(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function q8(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=Yoa(b*40|0)|0;i=c;return a|0}function r8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(t8(g)|0)>>2]|0;g=u8(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];s8(b,a,f);i=e;return}function s8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];v8(a,b,f);i=e;return}function t8(a){a=a|0;i=i;return a|0}function u8(a){a=a|0;i=i;return a|0}function v8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(x8(g)|0)>>2]|0;g=y8(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];w8(b,a,f);i=e;return}function w8(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(x8(f)|0)>>2];f=y8(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function x8(a){a=a|0;i=i;return a|0}function y8(a){a=a|0;i=i;return a|0}function z8(a){a=a|0;var b=0,c=0;b=i;c=A8(a)|0;i=b;return c|0}function A8(a){a=a|0;i=i;return a|0}function B8(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=M7(C8(b)|0)|0;h=y8(m8(C8(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];s8(g,a,e);i=d;return}function C8(a){a=a|0;i=i;return c[a>>2]|0}function D8(a){a=a|0;var b=0;b=i;E8(a);i=b;return}function E8(a){a=a|0;var b=0;b=i;F8(a);i=b;return}function F8(a){a=a|0;var b=0;b=i;G8(a,f6(a)|0);i=b;return}function G8(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;g0(d);if((b|0)==0){i=d;return}G8(a,c[b>>2]|0);G8(a,c[b+4>>2]|0);e=g8(a)|0;H8(e,I8(b+16|0)|0);$7(e,b,1);i=d;return}function H8(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;J8(d,0,c);i=b;return}function I8(a){a=a|0;i=i;return a|0}function J8(a,b,c){a=a|0;b=b|0;c=c|0;b=i;K8(c);i=b;return}function K8(a){a=a|0;var b=0;b=i;L8(a);i=b;return}function L8(a){a=a|0;var b=0;b=i;M8(a);i=b;return}function M8(a){a=a|0;var b=0;b=i;N8(a);i=b;return}function N8(a){a=a|0;var b=0;b=i;Nea(a+12|0);Nea(a);i=b;return}function O8(a){a=a|0;var b=0;b=i;P8(a+180|0);P8(a+168|0);P8(a+156|0);P8(a+144|0);P8(a+132|0);P8(a+120|0);P8(a+108|0);P8(a+96|0);P8(a+84|0);P8(a+72|0);P8(a+60|0);P8(a+48|0);P8(a+36|0);P8(a+24|0);e4(a+12|0);e4(a);i=b;return}function P8(a){a=a|0;var b=0;b=i;Q8(a);i=b;return}function Q8(a){a=a|0;var b=0;b=i;R8(a);i=b;return}function R8(a){a=a|0;var b=0;b=i;S8(a);i=b;return}function S8(a){a=a|0;var b=0;b=i;T8(a,u7(a)|0);i=b;return}function T8(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;g0(d);if((b|0)==0){i=d;return}T8(a,c[b>>2]|0);T8(a,c[b+4>>2]|0);e=Z6(a)|0;U8(e,V8(b+16|0)|0);T6(e,b,1);i=d;return}function U8(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;W8(d,0,c);i=b;return}function V8(a){a=a|0;i=i;return a|0}function W8(a,b,c){a=a|0;b=b|0;c=c|0;b=i;X8(c);i=b;return}function X8(a){a=a|0;var b=0;b=i;Y8(a);i=b;return}function Y8(a){a=a|0;var b=0;b=i;Z8(a);i=b;return}function Z8(a){a=a|0;var b=0;b=i;_8(a);i=b;return}function _8(a){a=a|0;var b=0;b=i;e4(a+4|0);i=b;return}function $8(a){a=a|0;var b=0;b=i;a9(a);i=b;return}function a9(a){a=a|0;var b=0;b=i;b9(a);i=b;return}function b9(a){a=a|0;var b=0;b=i;c9(a,R4(a)|0);i=b;return}function c9(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;g0(d);if((b|0)==0){i=d;return}c9(a,c[b>>2]|0);c9(a,c[b+4>>2]|0);e=z5(a)|0;d9(e,E4(b+16|0)|0);t5(e,b,1);i=d;return}function d9(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;e9(d,0,c);i=b;return}function e9(a,b,c){a=a|0;b=b|0;c=c|0;b=i;f9(c);i=b;return}function f9(a){a=a|0;var b=0;b=i;g9(a);i=b;return}function g9(a){a=a|0;var b=0;b=i;h9(a);i=b;return}function h9(a){a=a|0;var b=0;b=i;i9(a);i=b;return}function i9(a){a=a|0;var b=0;b=i;Nea(a);i=b;return}function j9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;k9(a);m9(g,b);n9(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];l9(a,f,e);i=d;return a|0}function k9(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;G8(a,f6(a)|0);c[(R7(a)|0)>>2]=0;d=_5(a)|0;c[(A7(a)|0)>>2]=d;g0(b);c[d>>2]=0;i=b;return}function l9(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;v9(h,a);if(!(w9(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];o9(j,g);o=y9(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];x9(l,a,f,o);z9(b)|0;}while(w9(b,d)|0);i=e;return}function m9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;t9(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];o9(a,e);i=d;return}function n9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;p9(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];o9(a,e);i=d;return}function o9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];s9(a,e);i=d;return}function p9(a,b){a=a|0;b=b|0;var c=0;c=i;q9(a,g4(b)|0);i=c;return}function q9(a,b){a=a|0;b=b|0;var c=0;c=i;r9(a,b);i=c;return}function r9(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function s9(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function t9(a,b){a=a|0;b=b|0;var d=0;d=i;q9(a,c[(u9(b)|0)>>2]|0);i=d;return}function u9(a){a=a|0;i=i;return a|0}function v9(a,b){a=a|0;b=b|0;var c=0;c=i;n9(a,b);i=c;return}function w9(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=Faa(a,b)|0;i=c;return d|0}function x9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];H9(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];G9(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];X5(a,g);K8(l);i=f;return}function y9(a){a=a|0;var b=0,c=0;b=i;c=D9(a)|0;i=b;return c|0}function z9(a){a=a|0;var b=0;b=i;A9(a)|0;i=b;return a|0}function A9(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=B9(c[d>>2]|0)|0;i=b;return a|0}function B9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;g0(b);if((e|0)==0){e=a;while(1){a=W1(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=C9(c[d>>2]|0)|0;i=b;return g|0}return 0}function C9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;g0(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;g0(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function D9(a){a=a|0;var b=0,d=0;b=i;d=E9((c[a>>2]|0)+16|0)|0;i=b;return d|0}function E9(a){a=a|0;var b=0,c=0;b=i;c=F9(a)|0;i=b;return c|0}function F9(a){a=a|0;i=i;return a|0}function G9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=L9(b,h,j,e)|0;h=c[p>>2]|0;g0(l);if((h|0)!=0){q=h;Z5(a,q);i=f;return}N9(o,b,e);O9(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];M9(m,g);P9(o);o=c[j>>2]|0;K7(b,o,p,Q9(m)|0);p=R9(m)|0;P9(m);q=p;Z5(a,q);i=f;return}function H9(a,b){a=a|0;b=b|0;var c=0;c=i;I9(a,b);i=c;return}function I9(a,b){a=a|0;b=b|0;var c=0;c=i;J9(a,b);i=c;return}function J9(a,b){a=a|0;b=b|0;var c=0;c=i;K9(a,b);i=c;return}function K9(a,b){a=a|0;b=b|0;var c=0;c=i;Dea(a,b);Dea(a+12|0,b+12|0);i=c;return}function L9(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;Y5(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];taa(l,k);do{if(!(saa(b,l)|0)){k=h6(a)|0;x=vaa(b)|0;if(uaa(k,e,x)|0){break}w=uaa(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];zaa(r,h,1,0);Y5(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];taa(t,g);do{if(!(saa(r,t)|0)){if(uaa(k,e,vaa(r)|0)|0){break}y=yaa(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;g0(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;waa(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];taa(o,j);do{if(!(saa(n,o)|0)){j=h6(a)|0;if(uaa(j,vaa(xaa(n)|0)|0,e)|0){break}y=yaa(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;g0(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function M9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];qaa(a,e);i=d;return}function N9(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=g8(d)|0;d=i8(n,1)|0;caa(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];baa(j,d,h);daa(0,I8((eaa(j)|0)+16|0)|0,e);a[(faa(j)|0)+4|0]=1;gaa(m,j);O9(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];M9(b,g);P9(m);P9(j);i=f;return}function O9(a,b){a=a|0;b=b|0;var c=0;c=i;$9(a,b);i=c;return}function P9(a){a=a|0;var b=0;b=i;W9(a);i=b;return}function Q9(a){a=a|0;var b=0,d=0;b=i;d=c[(U9(a)|0)>>2]|0;i=b;return d|0}function R9(a){a=a|0;var b=0,d=0;b=i;d=S9(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function S9(a){a=a|0;var b=0,c=0;b=i;c=T9(a)|0;i=b;return c|0}function T9(a){a=a|0;i=i;return a|0}function U9(a){a=a|0;var b=0,c=0;b=i;c=V9(a)|0;i=b;return c|0}function V9(a){a=a|0;i=i;return a|0}function W9(a){a=a|0;var b=0;b=i;X9(a,0);i=b;return}function X9(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=S9(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}Z9(Y9(e)|0,f);i=d;return}function Y9(a){a=a|0;var b=0,c=0;b=i;c=_9(a)|0;i=b;return c|0}function Z9(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;H8(f,I8(d+16|0)|0)}if((d|0)==0){i=e;return}$7(c[b>>2]|0,d,1);i=e;return}function _9(a){a=a|0;i=i;return a+4|0}function $9(a,b){a=a|0;b=b|0;var c=0;c=i;aaa(a,b);i=c;return}function aaa(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function baa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];kaa(a,b,f);i=e;return}function caa(a,b){a=a|0;b=b|0;var c=0;c=i;jaa(a,b);i=c;return}function daa(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}haa(b,c);i=a;return}function eaa(a){a=a|0;var b=0,d=0;b=i;d=c[(U9(a)|0)>>2]|0;i=b;return d|0}function faa(a){a=a|0;var b=0,c=0;b=i;c=Y9(a)|0;i=b;return c|0}function gaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;$9(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];M9(h,f);O9(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];M9(a,e);P9(h);i=d;return}function haa(a,b){a=a|0;b=b|0;var c=0;c=i;iaa(a,b);i=c;return}function iaa(a,b){a=a|0;b=b|0;var c=0;c=i;J9(a,b);i=c;return}function jaa(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function kaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(t8(g)|0)>>2]|0;g=maa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];laa(b,a,f);i=e;return}function laa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];naa(a,b,f);i=e;return}function maa(a){a=a|0;i=i;return a|0}function naa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(x8(g)|0)>>2]|0;g=paa(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];oaa(b,a,f);i=e;return}function oaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(x8(f)|0)>>2];f=paa(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function paa(a){a=a|0;i=i;return a|0}function qaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=R9(raa(b)|0)|0;h=paa(faa(raa(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];laa(g,a,e);i=d;return}function raa(a){a=a|0;i=i;return c[a>>2]|0}function saa(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function taa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];Eaa(a,e);i=d;return}function uaa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=l4(0,b,c)|0;i=a;return d|0}function vaa(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function waa(a,b){a=a|0;b=b|0;var d=0;d=i;Z5(a,c[(A7(b)|0)>>2]|0);i=d;return}function xaa(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=Caa(c[d>>2]|0)|0;i=b;return a|0}function yaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=f6(a)|0;g0(e);if((h|0)==0){j=_5(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=h6(a)|0;a=h;while(1){h=a+16|0;if(uaa(j,d,h)|0){l=a;m=c[l>>2]|0;g0(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(uaa(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;g0(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function zaa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;Aaa(b,d);c[a>>2]=c[b>>2];i=e;return}function Aaa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;Baa(b,c,e);i=d;return}function Baa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{xaa(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{A9(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function Caa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;g0(b);if((e|0)==0){e=a;while(1){a=W1(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=Daa(c[d>>2]|0)|0;i=b;return g|0}return 0}function Daa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;g0(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;g0(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function Eaa(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function Faa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(saa(a,b)|0)^1;i=c;return d|0}function Gaa(a){a=a|0;var b=0;b=i;i=i+128|0;Y3(a,b);Y3(a+12|0,b+8|0);Haa(a+24|0,b+16|0);Haa(a+36|0,b+24|0);Haa(a+48|0,b+32|0);Haa(a+60|0,b+40|0);Haa(a+72|0,b+48|0);Haa(a+84|0,b+56|0);Haa(a+96|0,b+64|0);Haa(a+108|0,b+72|0);Haa(a+120|0,b+80|0);Haa(a+132|0,b+88|0);Haa(a+144|0,b+96|0);Haa(a+156|0,b+104|0);Haa(a+168|0,b+112|0);Haa(a+180|0,b+120|0);i=b;return}function Haa(a,b){a=a|0;b=b|0;b=i;Iaa(a,0);i=b;return}function Iaa(a,b){a=a|0;b=b|0;b=i;i=i+8|0;Jaa(a,b);i=b;return}function Jaa(a,b){a=a|0;b=b|0;b=i;Kaa(a,0);i=b;return}function Kaa(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;Laa(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;Maa(f,0,e);e=H6(b)|0;c[(G6(b)|0)>>2]=e;i=d;return}function Laa(a){a=a|0;var b=0;b=i;Paa(a);i=b;return}function Maa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;Naa(b,c,f);i=e;return}function Naa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[(K2(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;Oaa(d,b,f);i=e;return}function Oaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[(K2(e)|0)>>2];i=d;return}function Paa(a){a=a|0;var b=0;b=i;Qaa(a);i=b;return}function Qaa(a){a=a|0;var b=0;b=i;N2(a);i=b;return}function Raa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[92988>>2]|0;if((m|0)==0){n=0}else{o=Yoa(12)|0;Hea(o,m);n=o}if((c[92904>>2]|0)!=0){c[8954]=1}if((n|0)==0){c[35828>>2]=1;c[35832>>2]=1;i=b;return}do{if((jfa(n,83192,0)|0)==-1){Dea(g,n);Bea(h);o=c[8528]|0;m=(o|0)<28;while(1){p=jfa(g,83200,0)|0;q=(p|0)!=-1;if(q){hfa(j,g,0,p);Oea(h,j)|0;Nea(j);hfa(k,g,p+1|0,-1);Oea(g,k)|0;Nea(k)}else{Oea(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){Hea(l,c[34528+(s<<2)>>2]|0);p=Saa(h,l)|0;Nea(l);if(p){c[35824+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){vW(1,1,83208,f);if(m){v=o}else{w=36376;x=c[9094]|0;fe[x&255](1);y=ifa(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=83248;E=D;xW(0,E,a)}do{p=c[35696+(v<<2)>>2]|0;c[e>>2]=c[34528+(v<<2)>>2];c[e+4>>2]=p;vW(1,0,83232,e);v=v+1|0;}while((v|0)<28);w=36376;x=c[9094]|0;fe[x&255](1);y=ifa(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=83248;E=D;xW(0,E,a)}else if((t|0)==20){vW(1,1,83208,d);w=36376;x=c[9094]|0;fe[x&255](1);y=ifa(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=83248;E=D;xW(0,E,a)}else if((t|0)==23){Nea(h);Nea(g);break}}else{o=1;do{c[35824+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[35828>>2]=1;c[35832>>2]=1;if((c[35860>>2]|0)!=0){c[35920>>2]=1}if((c[35916>>2]|0)==1){c[35924>>2]=1}if((c[35896>>2]|0)!=0){c[35892>>2]=1}if((c[35904>>2]|0)!=0){c[35892>>2]=1}if((c[35856>>2]|0)!=0){c[35852>>2]=1}if((c[35900>>2]|0)!=0){c[35892>>2]=1}if((c[35848>>2]|0)!=0){c[35844>>2]=1}Nea(n);_oa(n);i=b;return}function Saa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=Lea(b)|0;if((e|0)!=(Lea(c)|0)){f=0;i=d;return f|0}g=Mea(b)|0;h=Mea(c)|0;if(Eea(b)|0){f=(n4(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function Taa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[92996>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Yoa(12)|0;l=k;Hea(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(Uaa(l,c[68288+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=ifa(l)|0;vW(1,1,83280,g);g=c[68372>>2]|0;c[f>>2]=c[68292>>2];c[f+4>>2]=g;vW(1,0,83232,f);f=c[68376>>2]|0;c[e>>2]=c[68296>>2];c[e+4>>2]=f;vW(1,0,83232,e);e=c[68380>>2]|0;c[d>>2]=c[68300>>2];c[d+4>>2]=e;vW(1,0,83232,d);fe[c[9094]&255](1);xW(0,83336,a)}else if((n|0)==6){i=b;return j|0}return 0}function Uaa(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(lfa(a,b)|0)==0;i=c;return d|0}function Vaa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[92980>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=Yoa(12)|0;l=k;Hea(l,h);if((k|0)==0){j=1;i=b;return j|0}Hea(f,83360);k=Saa(l,f)|0;Nea(f);if(k){j=1;i=b;return j|0}Hea(g,83368);k=Saa(l,g)|0;Nea(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=ifa(l)|0;vW(1,1,83376,e);c[d>>2]=83360;c[d+4>>2]=83432;vW(1,0,83232,d);c[a>>2]=83368;c[a+4>>2]=83448;vW(1,0,83232,a);fe[c[9094]&255](1);xW(0,83336,b)}return 0}function Waa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;Wga(f,a);if(!(Zga(f)|0)){Xga(f);i=d;return a|0}j=v4(b)|0;hba(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((k0(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=Hfa(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];kba(h,e,b,m,k,l,n);if(!(iba(h)|0)){Xga(f);i=d;return a|0}Bfa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);Xga(f);i=d;return a|0}function Xaa(a){a=a|0;var b=0;b=i;aha(a,Ifa(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;Jga(a)|0;i=b;return a|0}function Yaa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;Hea(h,d);wfa(k,83456,h);I3(j,k,83464);Nea(k);k=ifa(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((qpa(c[n+4>>2]|0,83472)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((qpa(k,83480)|0)==0){Nea(j);Nea(h);i=f;return}d=_na(g,k,1)|0;if((d|0)!=0){m=l;ypa(m|0,0,2048)|0;loa(d,g,m,2048)|0;_ga(Waa(Waa(Waa(Waa(Waa(105384,83488)|0,k)|0,83528)|0,m)|0,83544)|0,105)|0;Nea(j);Nea(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(moa(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(moa(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(moa(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(moa(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==1){q=(moa(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==0){n=(moa(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){m=b+8|0;s=l;l=0;while(1){d=c[m>>2]|0;if((a[d+(l*48|0)+44|0]|0)==0){k=(moa(g,c[d+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[m>>2]|0)+(l*48|0)+44|0]=k;t=c[o>>2]|0}else{t=s}k=l+1|0;if((k|0)<(t|0)){s=t;l=k}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;s=b+8|0;o=(e|0)==0;m=b+24|0;k=0;do{d=c[t>>2]|0;do{if((a[d+(k*52|0)+48|0]|0)==0){p=a[d+(k*52|0)+8|0]|0;if(p<<24>>24==1){n=(moa(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(k*52|0)+48|0]|0)!=0|o){break}a[(c[m>>2]|0)+((c[n+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==0){p=(moa(g,c[d+(k*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(k*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(k*52|0)+48|0]|0)!=0){break}a[(c[s>>2]|0)+((c[p+(k*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);k=k+1|0;}while((k|0)<(c[l>>2]|0))}l=b+124|0;k=c[l>>2]|0;if((k|0)>0){s=b+12|0;t=k;k=0;while(1){m=c[s>>2]|0;if((a[m+(k*52|0)+48|0]|0)==0){o=(moa(g,c[m+(k*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(k*52|0)+48|0]=o;u=c[l>>2]|0}else{u=t}o=k+1|0;if((o|0)<(u|0)){t=u;k=o}else{break}}}k=b+220|0;if((c[k>>2]|0)>0){u=b+44|0;t=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{s=c[u>>2]|0;do{if((a[s+(b*52|0)+48|0]|0)==0){o=a[s+(b*52|0)+8|0]|0;if(o<<24>>24==0){m=(moa(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=m;m=c[u>>2]|0;if((a[m+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[m+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==1){o=(moa(g,c[s+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[k>>2]|0))}coa(g);Nea(j);Nea(h);i=f;return}function Zaa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[92844>>2]|0;H=c[92972>>2]|0;I=c[2]|0;if((c[35924>>2]|0)==0){if(!((c[92792>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;tW(23,0,83592,l);l=c[92916>>2]|0;do{if((l|0)==0){M=0}else{if((qpa(l,83616)|0)==0){M=1;break}if((qpa(l,83624)|0)==0){M=0;break}if((qpa(l,83632)|0)==0){M=2;break}c[j>>2]=l;vW(1,0,83640,j);M=0}}while(0);if((LX(M)|0)!=0){c[g>>2]=l;vW(1,0,83712,g)}if((c[2]|0)!=0){fca(d+56|0);QX((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);MX(0);MX(6);NX(3);NX(4);NX(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+mpa(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];tW(1,0,83800,f)}do{if((c[92900>>2]|0)!=0){f=Yoa(12)|0;J=f;Hea(J,c[93028>>2]|0);if((f|0)==0){break}f=ifa(J)|0;c[d+280>>2]=f;c[e>>2]=f;tW(23,0,83856,e)}}while(0);e=c[93024>>2]|0;Bea(m);if((e|0)==0){Hea(p,c[d+88>>2]|0);Hea(q,83904);_aa(o,p,q);I3(n,o,c[d+284>>2]|0);Oea(m,n)|0;Nea(n);Nea(o);Nea(q);Nea(p)}else{Pea(m,e)|0}Hea(r,83912);Hea(s,83912);Hea(t,83912);Hea(u,83912);Hea(v,83912);Hea(w,83912);e=c[92792>>2]|0;if((c[92812>>2]|0)!=0){Pea(r,c[92940>>2]|0)|0}if((c[92828>>2]|0)!=0){Pea(s,c[92956>>2]|0)|0}if((c[92808>>2]|0)!=0){Pea(t,c[92936>>2]|0)|0}if((c[92816>>2]|0)==0){O=0.0}else{Pea(u,c[92944>>2]|0)|0;O=+mpa(ifa(u)|0)}if((c[92820>>2]|0)==0){P=1}else{Pea(v,c[92948>>2]|0)|0;P=Fc(ifa(v)|0)|0}if((c[92880>>2]|0)!=0){Pea(w,c[93008>>2]|0)|0}Dea(x,m);Dea(y,r);Dea(z,s);Dea(A,t);Dea(B,w);p=$aa(d,x,y,z,A,O,P,B,e)|0;Nea(B);Nea(A);Nea(z);Nea(y);Nea(x);if((p|0)!=0|g^1){Q=p}else{MX(5);p=wba(d)|0;PX(5);tW(1,0,83920,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;Nea(w);Nea(v);Nea(u);Nea(t);Nea(s);Nea(r);Nea(m);i=b;return R|0}Q=d+88|0;Hea(D,c[Q>>2]|0);I3(C,D,83952);Nea(D);Hea(F,c[Q>>2]|0);I3(E,F,83968);Nea(F);PX(0);F=c[92992>>2]|0;Q=ifa(C)|0;D=ifa(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;Vba(d,Q,D,(F|0)!=0?F:83984,I,p,ifa(m)|0)|0;Nea(E);Nea(C);R=0;Nea(w);Nea(v);Nea(u);Nea(t);Nea(s);Nea(r);Nea(m);i=b;return R|0}function _aa(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;Cea(a,d);e=Lea(b)|0;f=Lea(c)|0;mfa(a,Mea(b)|0,e,f+e|0);efa(a,Mea(c)|0,f)|0;i=d;return}function $aa(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((Lea(j)|0)==0){u=0}else{u=ifa(j)|0}Dea(r,b);b=(aba(a,r,k)|0)==0;Nea(r);if(!b){v=-1;i=l;return v|0}Hea(s,83912);b=a+280|0;r=Uaa(s,c[b>>2]|0)|0;Nea(s);do{if(r){w=3}else{s=1;k=0;do{Hea(t,c[84128+(s<<2)>>2]|0);j=Uaa(t,c[b>>2]|0)|0;Nea(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];vW(1,0,84208,q);vW(1,0,83208,p);s=1;do{j=c[84240+(s<<2)>>2]|0;c[o>>2]=c[84128+(s<<2)>>2];c[o+4>>2]=j;vW(1,0,83232,o);s=s+1|0;}while((s|0)<20);xW(c[a+536>>2]|0,83336,n)}}while(0);c[m>>2]=c[84128+(w<<2)>>2];tW(23,0,84320,m);m=ifa(d)|0;d=ifa(e)|0;e=z_(a,m,d,ifa(f)|0,g,h,w,u)|0;ge[c[77572>>2]&127](77544,a);v=e;i=l;return v|0}function aba(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[19386]=Ad(ifa(b)|0)|0;c[77548>>2]=g;c[77552>>2]=d;d=a+284|0;do{if((c[20796]|0)==0){g=c[d>>2]|0;if((qpa(83992,g)|0)==0){h=0;break}if((qpa(84e3,g)|0)==0){c[77560>>2]=55;c[77564>>2]=56;c[77572>>2]=57;h=0;break}if((qpa(84008,g)|0)==0){c[77560>>2]=58;c[77564>>2]=59;c[77568>>2]=60;c[77572>>2]=61;h=1;break}if((qpa(84016,g)|0)==0){c[77560>>2]=62;c[77564>>2]=63;c[77568>>2]=64;c[77572>>2]=65;h=1;break}if((qpa(84024,g)|0)==0){c[77560>>2]=66;c[77564>>2]=67;c[77572>>2]=68;h=0;break}g=Waa(105384,84032)|0;_ga(Waa(g,c[d>>2]|0)|0,105)|0;j=1;i=e;return j|0}else{h=0}}while(0);Yaa(a+8|0,c[a+288>>2]|0,h);ge[c[77560>>2]&127](77544,a);a=c[19386]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;tW(23,0,84056,f);j=0;i=e;return j|0}



function Soa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[31486]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=125984+(j<<2)|0;l=125984+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[31486]=f&~(1<<h)}else{if(n>>>0<(c[125960>>2]|0)>>>0){hd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{hd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[125952>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=125984+(r<<2)|0;o=125984+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[31486]=f&~(1<<t)}else{if(n>>>0<(c[125960>>2]|0)>>>0){hd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{hd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[125952>>2]|0;if((n|0)!=0){f=c[125964>>2]|0;e=n>>>3;n=e<<1;g=125984+(n<<2)|0;m=c[31486]|0;j=1<<e;do{if((m&j|0)==0){c[31486]=m|j;u=125984+(n+2<<2)|0;v=g}else{e=125984+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[125960>>2]|0)>>>0)){u=e;v=h;break}hd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[125952>>2]=o;c[125964>>2]=s;p=k;i=b;return p|0}n=c[125948>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[126248+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[125960>>2]|0;if(h>>>0<k>>>0){hd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){hd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){hd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){hd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){hd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{hd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=126248+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<h);break a}else{if(s>>>0<(c[125960>>2]|0)>>>0){hd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[125960>>2]|0)>>>0){hd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[125952>>2]|0;if((h|0)!=0){s=c[125964>>2]|0;k=h>>>3;h=k<<1;f=125984+(h<<2)|0;m=c[31486]|0;g=1<<k;do{if((m&g|0)==0){c[31486]=m|g;A=125984+(h+2<<2)|0;B=f}else{k=125984+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[125960>>2]|0)>>>0)){A=k;B=e;break}hd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[125952>>2]=t;c[125964>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[125948>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[126248+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[126248+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[125952>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[125960>>2]|0;if(t>>>0<f>>>0){hd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){hd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){hd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){hd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){hd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{hd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=126248+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<e);break c}else{if(t>>>0<(c[125960>>2]|0)>>>0){hd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[125960>>2]|0)>>>0){hd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=125984+(t<<2)|0;s=c[31486]|0;r=1<<e;do{if((s&r|0)==0){c[31486]=s|r;S=125984+(t+2<<2)|0;T=f}else{e=125984+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[125960>>2]|0)>>>0)){S=e;T=k;break}hd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=126248+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[125948>>2]|0;l=1<<U;if((f&l|0)==0){c[125948>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[125960>>2]|0;if(W>>>0<k>>>0){hd()}if(r>>>0<k>>>0){hd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[125952>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[125964>>2]|0;if(W>>>0>15){c[125964>>2]=X+q;c[125952>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[125952>>2]=0;c[125964>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[125956>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[125956>>2]=W;X=c[125968>>2]|0;c[125968>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[31604]|0)==0){X=ed(30)|0;if((X+ -1&X|0)==0){c[126424>>2]=X;c[126420>>2]=X;c[126428>>2]=-1;c[126432>>2]=-1;c[126436>>2]=0;c[126388>>2]=0;c[31604]=(sc(0)|0)&-16^1431655768;break}else{hd()}}}while(0);X=q+48|0;W=c[126424>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[126384>>2]|0;do{if((U|0)!=0){T=c[126376>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[126388>>2]&4|0)==0){U=c[125968>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=126392|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[125956>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[126420>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[126376>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[126384>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[126424>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[126388>>2]=c[126388>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[126376>>2]|0)+ga|0;c[126376>>2]=ia;if(ia>>>0>(c[126380>>2]|0)>>>0){c[126380>>2]=ia}ia=c[125968>>2]|0;W=126392|0;i:do{if((ia|0)==0){aa=c[125960>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[125960>>2]=fa}c[126392>>2]=fa;c[126396>>2]=ga;c[126404>>2]=0;c[125980>>2]=c[31604];c[125976>>2]=-1;aa=0;do{ha=aa<<1;$=125984+(ha<<2)|0;c[125984+(ha+3<<2)>>2]=$;c[125984+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[125968>>2]=fa+ja;c[125956>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[125972>>2]=c[126432>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[125956>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[125968>>2]=ia+na;c[125956>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[125972>>2]=c[126432>>2];break i}}while(0);if(fa>>>0<(c[125960>>2]|0)>>>0){c[125960>>2]=fa}aa=fa+ga|0;$=126392|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[125968>>2]|0)){ca=(c[125956>>2]|0)+X|0;c[125956>>2]=ca;c[125968>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[125964>>2]|0)){ca=(c[125952>>2]|0)+X|0;c[125952>>2]=ca;c[125964>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=125984+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[125960>>2]|0)>>>0){hd()}if((c[V+12>>2]|0)==(ha|0)){break}hd()}}while(0);if((L|0)==(V|0)){c[31486]=c[31486]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[125960>>2]|0)>>>0){hd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}hd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[125960>>2]|0)>>>0){hd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){hd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{hd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=126248+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<t);break k}else{if(T>>>0<(c[125960>>2]|0)>>>0){hd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[125960>>2]|0)>>>0){hd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=125984+(Z<<2)|0;t=c[31486]|0;T=1<<ca;do{if((t&T|0)==0){c[31486]=t|T;xa=125984+(Z+2<<2)|0;ya=ea}else{ca=125984+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[125960>>2]|0)>>>0)){xa=ca;ya=V;break}hd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=126248+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[125948>>2]|0;L=1<<za;if((ea&L|0)==0){c[125948>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[125960>>2]|0;if(Ba>>>0<S>>>0){hd()}if(T>>>0<S>>>0){hd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=126392|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[125968>>2]=fa+Ha;c[125956>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[125972>>2]=c[126432>>2];c[ba+4>>2]=27;X=126392|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[126392>>2]=fa;c[126396>>2]=ga;c[126404>>2]=0;c[126400>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=125984+(da<<2)|0;aa=c[31486]|0;f=1<<M;do{if((aa&f|0)==0){c[31486]=aa|f;Ia=125984+(da+2<<2)|0;Ja=ha}else{M=125984+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[125960>>2]|0)>>>0)){Ia=M;Ja=T;break}hd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=126248+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[125948>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[125948>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[125960>>2]|0;if(Ma>>>0<f>>>0){hd()}if(M>>>0<f>>>0){hd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[125956>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[125956>>2]=W;ia=c[125968>>2]|0;c[125968>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}function Toa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[125960>>2]|0;if(d>>>0<f>>>0){hd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){hd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){hd()}if((p|0)==(c[125964>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[125952>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=125984+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){hd()}if((c[m+12>>2]|0)==(p|0)){break}hd()}}while(0);if((u|0)==(m|0)){c[31486]=c[31486]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){hd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}hd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){hd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){hd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){hd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{hd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=126248+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[125960>>2]|0)>>>0){hd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[125960>>2]|0)>>>0){hd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){hd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){hd()}do{if((C&2|0)==0){if((l|0)==(c[125968>>2]|0)){f=(c[125956>>2]|0)+t|0;c[125956>>2]=f;c[125968>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[125964>>2]|0)){i=b;return}c[125964>>2]=0;c[125952>>2]=0;i=b;return}if((l|0)==(c[125964>>2]|0)){f=(c[125952>>2]|0)+t|0;c[125952>>2]=f;c[125964>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=125984+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[125960>>2]|0)>>>0){hd()}if((c[E+12>>2]|0)==(l|0)){break}hd()}}while(0);if((w|0)==(E|0)){c[31486]=c[31486]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[125960>>2]|0)>>>0){hd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}hd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[125960>>2]|0)>>>0){hd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){hd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{hd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=126248+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<g);break b}else{if(d>>>0<(c[125960>>2]|0)>>>0){hd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[125960>>2]|0)>>>0){hd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[125964>>2]|0)){J=f;break}c[125952>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=125984+(C<<2)|0;G=c[31486]|0;j=1<<t;do{if((G&j|0)==0){c[31486]=G|j;K=125984+(C+2<<2)|0;L=e}else{t=125984+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[125960>>2]|0)>>>0)){K=t;L=a;break}hd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=126248+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[125948>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[125948>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[125960>>2]|0;if(O>>>0<K>>>0){hd()}if(f>>>0<K>>>0){hd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[125976>>2]|0)+ -1|0;c[125976>>2]=s;if((s|0)==0){Q=126400|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[125976>>2]=-1;i=b;return}function Uoa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=Soa(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}ypa(b|0,0,e|0)|0;i=d;return b|0}function Voa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=Soa(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=Woa(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=Soa(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;wpa(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;Toa(a);e=g;i=d;return e|0}function Woa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[125960>>2]|0;if(h>>>0<l>>>0){hd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){hd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){hd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[126424>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;Xoa(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[125968>>2]|0)){m=(c[125956>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[125968>>2]=a+b;c[125956>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[125964>>2]|0)){h=(c[125952>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[125952>>2]=r;c[125964>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=125984+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){hd()}if((c[h+12>>2]|0)==(k|0)){break}hd()}}while(0);if((m|0)==(h|0)){c[31486]=c[31486]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){hd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}hd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){hd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){hd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{hd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=126248+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<u);break a}else{if(t>>>0<(c[125960>>2]|0)>>>0){hd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[125960>>2]|0)>>>0){hd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;Xoa(a+b|0,r);o=a;i=d;return o|0}return 0}function Xoa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[125960>>2]|0;if(j>>>0<m>>>0){hd()}if((k|0)==(c[125964>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[125952>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=125984+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){hd()}if((c[q+12>>2]|0)==(k|0)){break}hd()}}while(0);if((r|0)==(q|0)){c[31486]=c[31486]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){hd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}hd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){hd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){hd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{hd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=126248+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[125960>>2]|0)>>>0){hd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[125960>>2]|0)>>>0){hd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[125960>>2]|0;if(e>>>0<z>>>0){hd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[125968>>2]|0)){t=(c[125956>>2]|0)+p|0;c[125956>>2]=t;c[125968>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[125964>>2]|0)){i=d;return}c[125964>>2]=0;c[125952>>2]=0;i=d;return}if((f|0)==(c[125964>>2]|0)){t=(c[125952>>2]|0)+p|0;c[125952>>2]=t;c[125964>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=125984+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){hd()}if((c[u+12>>2]|0)==(f|0)){break}hd()}}while(0);if((h|0)==(u|0)){c[31486]=c[31486]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){hd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}hd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){hd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){hd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){hd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{hd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=126248+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[125948>>2]=c[125948>>2]&~(1<<j);break b}else{if(m>>>0<(c[125960>>2]|0)>>>0){hd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[125960>>2]|0)>>>0){hd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[125960>>2]|0)>>>0){hd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[125964>>2]|0)){G=t;break}c[125952>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=125984+(B<<2)|0;D=c[31486]|0;b=1<<p;do{if((D&b|0)==0){c[31486]=D|b;H=125984+(B+2<<2)|0;I=A}else{p=125984+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[125960>>2]|0)>>>0)){H=p;I=a;break}hd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=126248+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[125948>>2]|0;B=1<<J;if((a&B|0)==0){c[125948>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[125960>>2]|0)>>>0){hd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[125960>>2]|0;if(L>>>0<B>>>0){hd()}if(G>>>0<B>>>0){hd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function Yoa(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=Soa(d)|0;if((e|0)!=0){f=6;break}a=c[31610]|0;c[31610]=0+a;if((a|0)==0){f=5;break}Fe[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=126456;Td(d|0,126504,135)}else if((f|0)==6){i=b;return e|0}return 0}function Zoa(a){a=a|0;var b=0,c=0;b=i;c=Yoa(a)|0;i=b;return c|0}function _oa(a){a=a|0;var b=0;b=i;if((a|0)!=0){Toa(a)}i=b;return}function $oa(a){a=a|0;var b=0;b=i;_oa(a);i=b;return}function apa(a){a=a|0;var b=0;b=i;zb(a|0);_oa(a);i=b;return}function bpa(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function cpa(a){a=a|0;i=i;return 126472}function dpa(){var a=0;a=Ec(4)|0;c[a>>2]=126456;Td(a|0,126504,135)}function epa(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==2){j=53;k=-1074}else if((e|0)==1){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=hpa(b)|0}}while((jd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=hpa(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[126520+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=hpa(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[126536+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=hpa(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=hpa(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=hpa(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=hpa(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=hpa(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=hpa(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=Epa(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=Epa(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=hpa(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){gpa(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=Epa(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=fpa(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){gpa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=zpa(q|0,n|0,2)|0;o=Epa(p|0,J|0,-32,-1)|0;p=Epa(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=Epa(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=Dpa(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=Epa(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Rd(+(+ipa(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Nc()|0)>>2]=34}l=+jpa(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=hpa(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=hpa(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=hpa(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=Epa(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=Epa(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=hpa(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=fpa(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){gpa(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=Epa(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Nc()|0)>>2]=22;gpa(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[126552+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[126552+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[126552+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=zpa(c[Ra>>2]|0,0,29)|0;Qa=Epa(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=Opa(Qa|0,Ta|0,1e9,0)|0;pa=Ppa(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=zpa(c[Ua>>2]|0,0,29)|0;Ra=Epa(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=Opa(Ra|0,Sa|0,1e9,0)|0;Pa=Ppa(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[126544+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Rd(+(+ipa(1.0,105-tc|0)),+sc);vc=+zc(+sc,+(+ipa(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+zc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=yc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Nc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+jpa(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=hpa(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=hpa(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;gpa(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;gpa(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function fpa(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=hpa(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=hpa(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=hpa(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=Npa(q|0,m|0,10,0)|0;b=J;g=Epa(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=Epa(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=hpa(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=hpa(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=Dpa(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function gpa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function hpa(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=lpa(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function ipa(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=zpa(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function jpa(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+ipa(a,b);i=c;return+d}function kpa(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){le[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function lpa(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((kpa(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((le[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function mpa(a){a=a|0;var b=0,c=0.0;b=i;c=+npa(a,0);i=b;return+c}function npa(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;gpa(e,0);h=+epa(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function opa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;gpa(e,0);h=+epa(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function ppa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function qpa(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function rpa(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function spa(){c[26714]=p;c[26756]=p;c[31398]=p;c[31628]=p}function tpa(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}dc(116);dc(111);dc(111);dc(32);dc(109);dc(97);dc(110);dc(121);dc(32);dc(115);dc(101);dc(116);dc(106);dc(109);dc(112);dc(115);dc(32);dc(105);dc(110);dc(32);dc(97);dc(32);dc(102);dc(117);dc(110);dc(99);dc(116);dc(105);dc(111);dc(110);dc(32);dc(99);dc(97);dc(108);dc(108);dc(44);dc(32);dc(98);dc(117);dc(105);dc(108);dc(100);dc(32);dc(119);dc(105);dc(116);dc(104);dc(32);dc(97);dc(32);dc(104);dc(105);dc(103);dc(104);dc(101);dc(114);dc(32);dc(118);dc(97);dc(108);dc(117);dc(101);dc(32);dc(102);dc(111);dc(114);dc(32);dc(77);dc(65);dc(88);dc(95);dc(83);dc(69);dc(84);dc(74);dc(77);dc(80);dc(83);dc(10);ga(0);return 0}function upa(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function vpa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function wpa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function xpa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{wpa(b,c,d)|0}return b|0}function ypa(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function zpa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function Apa(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function Bpa(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function Cpa(){return Bpa(o)|0}function Dpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function Epa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function Fpa(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function Gpa(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Hpa(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Ipa(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function Jpa(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function Kpa(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function Lpa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=Dpa(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=Dpa((Qpa(i,b,Dpa(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function Mpa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=Dpa(h^a,j^b,h,j)|0;b=J;Qpa(m,b,Dpa(k^d,l^e,k,l)|0,J,g)|0;l=Dpa(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function Npa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=Kpa(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function Opa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=Qpa(a,b,c,d,0)|0;return(J=J,e)|0}function Ppa(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;Qpa(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function Qpa(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((Jpa(l|0)|0)>>>0);return(J=n,o)|0}p=(Ipa(l|0)|0)-(Ipa(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Ipa(l|0)|0)-(Ipa(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Ipa(j|0)|0)+33-(Ipa(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=Jpa(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=Epa(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;Dpa(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=Dpa(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function Rpa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return be[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function Spa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ce[a&31](b|0,c|0,d|0,e|0,f|0)}function Tpa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return de[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function Upa(a,b){a=a|0;b=+b;ee[a&1](+b)}function Vpa(a,b){a=a|0;b=b|0;fe[a&255](b|0)}function Wpa(a,b,c){a=a|0;b=b|0;c=c|0;ge[a&127](b|0,c|0)}function Xpa(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function Ypa(a,b){a=a|0;b=b|0;return ie[a&127](b|0)|0}function Zpa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;je[a&1](b|0,c|0,+d,e|0)}function _pa(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function $pa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return le[a&63](b|0,c|0,d|0)|0}function aqa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return me[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function bqa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ne[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function cqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;oe[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function dqa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function eqa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function fqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;re[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function gqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;se[a&3](b|0,c|0,+d,e|0,f|0)}function hqa(a,b,c){a=a|0;b=b|0;c=+c;return te[a&1](b|0,+c)|0}function iqa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ue[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function jqa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ve[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function kqa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;we[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function lqa(a,b,c){a=a|0;b=b|0;c=c|0;return xe[a&63](b|0,c|0)|0}function mqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ye[a&63](b|0,c|0,d|0,e|0,f|0)|0}function nqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ze[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function oqa(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Ae[a&1](b|0,+c,+d)}function pqa(a,b,c){a=a|0;b=b|0;c=c|0;return+Be[a&1](b|0,c|0)}function qqa(a){a=a|0;return Ce[a&7]()|0}function rqa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return De[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function sqa(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ee[a&15](b|0,c|0,d|0)}function tqa(a){a=a|0;Fe[a&7]()}function uqa(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ge[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function vqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return He[a&63](b|0,c|0,d|0,e|0)|0}function wqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ie[a&31](b|0,c|0,d|0,e|0)}function xqa(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function yqa(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function zqa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function Aqa(a){a=+a;ga(3)}function Bqa(a){a=a|0;ga(4)}function Cqa(a){a=a|0;Cd(a|0)}function Dqa(a,b){a=a|0;b=b|0;ga(5)}function Eqa(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function Fqa(a){a=a|0;ga(7);return 0}function Gqa(a){a=a|0;return Oc(a|0)|0}function Hqa(a){a=a|0;return Ld(a|0)|0}function Iqa(a){a=a|0;return wc(a|0)|0}function Jqa(a){a=a|0;return Ad(a|0)|0}function Kqa(a){a=a|0;return md(a|0)|0}function Lqa(a){a=a|0;return ud(a|0)|0}function Mqa(a){a=a|0;return Yc(a|0)|0}function Nqa(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function Oqa(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function Pqa(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function Qqa(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function Rqa(a,b,c){a=a|0;b=b|0;c=c|0;return hc(a|0,b|0,c|0)|0}function Sqa(a,b,c){a=a|0;b=b|0;c=c|0;return Od(a|0,b|0,c|0)|0}function Tqa(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function Uqa(a,b,c){a=a|0;b=b|0;c=c|0;return xd(a|0,b|0,c|0)|0}function Vqa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function Wqa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function Xqa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function Yqa(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function Zqa(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function _qa(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function $qa(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function ara(a,b){a=a|0;b=+b;ga(18);return 0}function bra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function cra(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function dra(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function era(a,b){a=a|0;b=b|0;ga(22);return 0}function fra(a,b){a=a|0;b=b|0;return Qd(a|0,b|0)|0}function gra(a,b){a=a|0;b=b|0;return gc(a|0,b|0)|0}function hra(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function ira(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function jra(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function kra(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function lra(a,b){a=a|0;b=b|0;ga(26);return 0.0}function mra(){ga(27);return 0}function nra(){return jb()|0}function ora(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function pra(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function qra(){ga(30)}function rra(){Uc()}function sra(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function tra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function ura(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function vra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function wra(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function xR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&255](a);a=e}i=b;return}function yR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;LR(f,g+20|0);while(1){d=MR(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}fe[c[b+8>>2]&255](c[d+20>>2]|0)}QR(g);QR(g+132|0);QR(g+20|0);QR(g+40|0);QR(g+60|0);xR(g+80|0);xR(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&255](o);i=e;return}fe[c[b+8>>2]&255](c[g+184>>2]|0);fe[c[b+8>>2]&255](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&255](o);i=e;return}function zR(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function AR(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function BR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((CR(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=ER(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{wpa(f|0,b|0,d|0)|0;j=FR(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=He[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Ie[c[(c[h+144>>2]|0)+52>>2]&31](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function CR(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=zS()|0}if((a[e+236|0]|0)!=0){f=uR(e,26984)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function DR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function ER(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;xpa(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ie[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;wpa(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;fe[c[e+20>>2]&255](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function FR(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((CR(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}else if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=He[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==3){e=2}else if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}}while(0);Ie[c[(c[g+144>>2]|0)+52>>2]&31](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function GR(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function HR(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ie[c[(c[d+144>>2]|0)+52>>2]&31](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function IR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ce[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function JR(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[25208+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function KR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;wpa((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=xe[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ie[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){wpa(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function LR(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function MR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function NR(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ie[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){ypa(c[m>>2]|0,0,g|0)|0;g=OR(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=OR(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((PR(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ie[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}ypa(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=OR(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}fe[c[(c[b+16>>2]|0)+8>>2]&255](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ie[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){ypa(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function OR(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function PR(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function QR(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}fe[e&255](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}fe[e&255](c[d>>2]|0);i=b;return}function RR(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[26792+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[26832+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=xe[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ie[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ie[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}fe[c[j+20>>2]&255](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;wpa(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ee[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function SR(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((le[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=yS(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function TR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=UR(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function UR(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ye[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=VR(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=NR(o,l+132|0,26864,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=WR(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}XR(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=WR(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;rR(o+416|0);h=0;break};case 57:{v=VR(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=_R(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);rR(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=NR(o,l+132|0,26864,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}fe[c[o+88>>2]&255](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=ZR(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=26968}else{x=(s|0)==32?26952:26976}if(($R(o+416|0,x)|0)==0){r=111;break a}if((aS(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=26872;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=26880;r=102;break};case 25:{c[o+332>>2]=26888;r=102;break};case 26:{c[o+332>>2]=26896;r=102;break};case 27:{c[o+332>>2]=26904;r=102;break};case 28:{c[o+332>>2]=26912;r=102;break};case 29:{c[o+332>>2]=26928;r=102;break};case 30:{c[o+332>>2]=26936;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((bS(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((KR(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((KR(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);rR(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=WR(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=26864}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=NR(o,l+132|0,26864,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=cS(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((bS(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((KR(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((KR(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);rR(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=dS(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=WR(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;re[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((le[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=WR(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=NR(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=WR(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=NR(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=WR(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){IR(o,b,e,c[n>>2]|0)}h=0;D=eS(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=WR(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}XR(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=WR(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);rR(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);rR(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ie[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=xe[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=xe[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=gS(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=WR(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=NR(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ee[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=hS(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=ZR(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=ie[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((kS(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((jS(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=WR(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=gS(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=ZR(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=iS(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=WR(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}XR(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}IR(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=He[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((ye[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=NR(o,l+132|0,26864,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=YR(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function VR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((he[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=WR(n+440|0,p,b,s+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=WR(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ie[c[n+140>>2]&31](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}IR(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=WR(n+440|0,e,d,m+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=yS(n,f)|0;rR(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){rR(n+440|0)}q=0;r=q;i=g;return r|0}function WR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((aS(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((KR(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function XR(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function YR(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=nS(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((vS(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function ZR(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=WR(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=NR(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((wS(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function _R(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((KR(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=WR(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=NR(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=NR(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((KR(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((KR(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=NR(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function $R(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((KR(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function aS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((KR(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ce[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((KR(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function bS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ie[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=xe[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function cS(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=xS(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((KR(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function dS(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((KR(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(He[c[b+20>>2]&63](b,e,f,j)|0){case-4:{r=24;break a;break};case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=WR(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=NR(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=dS(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(ye[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 6:case 9:{if((aS(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 0:{r=49;break a;break};case 7:{r=28;break};case-1:{r=46;break a;break};case 10:{s=xe[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=ES(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((KR(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((KR(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function eS(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=He[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case 42:{if((c[k+80>>2]|0)!=0){IR(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function fS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=eS(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=TR(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function gS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ie[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=xe[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ie[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function hS(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ie[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=He[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=UR(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=nS(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function iS(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ie[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;mS(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function jS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){IR(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(xe[c[a+32>>2]&63](a,b)|0)|0;k=WR(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=xe[c[a+36>>2]&63](a,e)|0;e=WR(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){lS(e);Ee[c[g+64>>2]&15](c[g+4>>2]|0,k,e);rR(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function kS(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){IR(g,a,b,d)}h=1;j=h;i=f;return j|0}k=WR(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){lS(k);ge[c[g+68>>2]&127](c[g+4>>2]|0,k);rR(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function lS(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function mS(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}mS(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function nS(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=He[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case-3:{B=6;break a;break};case 5:{if((c[y+312>>2]|0)==(b|0)){B=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;D=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;E=xe[c[e+32>>2]&63](e,D)|0;if((E|0)!=(c[C+8>>2]|0)){B=112;break a}if((ppa(c[C+4>>2]|0,D,E)|0)!=0){B=112;break a}E=y+312|0;c[E>>2]=(c[E>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){E=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((E|0)==0){break}F=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[E]|0)==0){break}G=E;E=G+1|0;H=F;F=H+1|0;a[H]=a[G]|0}G=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((G|0)==0){break}H=F;F=H+1|0;a[H]=a[y+472|0]|0;while(1){if((a[G]|0)==0){break c}H=G;G=H+1|0;I=F;F=I+1|0;a[I]=a[H]|0}}}while(0);a[F]=0}}while(0);ge[c[y+56>>2]&127](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}IR(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}E=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=133;break a}break};case 12:{B=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break};case 9:{a[p]=le[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){C=y;if((c[y+60>>2]|0)!=0){Ee[c[C+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[C+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break b}C=WR(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((C|0)==0){B=37;break a}E=NR(y,k,C,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){B=40;break}if((E|0)!=0){break}G=y;if((c[y+120>>2]|0)!=0){Ee[c[G+120>>2]&15](c[y+4>>2]|0,C,0);break b}if((c[G+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{B=40}}while(0);if((B|0)==40){B=0;if((E|0)==0){B=41;break a}if((a[E+34|0]|0)==0){B=43;break a}}if((a[E+32|0]|0)!=0){B=50;break a}if((c[E+28>>2]|0)!=0){B=52;break a}C=y;if((c[E+4>>2]|0)!=0){G=y;if((a[C+308|0]|0)!=0){J=hS(G,E,0)|0;if((J|0)!=0){B=60;break a}else{break b}}H=y;if((c[G+120>>2]|0)!=0){Ee[c[H+120>>2]&15](c[y+4>>2]|0,c[E>>2]|0,0);break b}if((c[H+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[C+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[E+32|0]=1;C=pS(y)|0;a[E+32|0]=0;if((C|0)==0){B=63;break a}if((ye[c[y+112>>2]&63](c[y+116>>2]|0,C,c[E+20>>2]|0,c[E+16>>2]|0,c[E+24>>2]|0)|0)==0){B=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 0:{B=24;break a;break};case 1:case 2:{C=y;if((c[y+368>>2]|0)!=0){K=c[C+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{K=ie[c[C+12>>2]&127](48)|0;if((K|0)==0){B=72;break a}c[K+36>>2]=ie[c[y+12>>2]&127](32)|0;if((c[K+36>>2]|0)==0){B=74;break a}c[K+40>>2]=(c[K+36>>2]|0)+32}c[K+44>>2]=0;c[K>>2]=c[y+364>>2];c[y+364>>2]=K;c[K+16>>2]=0;c[K+20>>2]=0;c[K+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[K+8>>2]=xe[c[e+32>>2]&63](e,c[K+4>>2]|0)|0;C=y+312|0;c[C>>2]=(c[C>>2]|0)+1;C=(c[K+4>>2]|0)+(c[K+8>>2]|0)|0;c[r>>2]=c[K+4>>2];c[q>>2]=c[K+36>>2];while(1){ce[c[e+60>>2]&31](e,r,C,q,(c[K+40>>2]|0)+ -1|0);L=(c[q>>2]|0)-(c[K+36>>2]|0)|0;if((c[r>>2]|0)==(C|0)){break}H=(c[K+40>>2]|0)-(c[K+36>>2]|0)<<1;G=xe[c[y+16>>2]&63](c[K+36>>2]|0,H)|0;if((G|0)==0){B=80;break a}c[K+36>>2]=G;c[K+40>>2]=G+H;c[q>>2]=G+L}c[K+24>>2]=L;c[K+12>>2]=c[K+36>>2];a[c[q>>2]|0]=0;M=qS(y,e,c[m>>2]|0,K+12|0,K+44|0)|0;if((M|0)!=0){B=82;break a}C=y;do{if((c[y+52>>2]|0)!=0){Ee[c[C+52>>2]&15](c[y+4>>2]|0,c[K+12>>2]|0,c[y+392>>2]|0)}else{if((c[C+80>>2]|0)==0){break}IR(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);rR(y+416|0);break};case 3:case 4:{C=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;E=1;c[t>>2]=WR(y+416|0,e,C,C+(xe[c[e+32>>2]&63](e,C)|0)|0)|0;if((c[t>>2]|0)==0){B=89;break a}c[y+432>>2]=c[y+428>>2];N=qS(y,e,c[m>>2]|0,t,s)|0;if((N|0)!=0){B=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ee[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);E=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ge[c[y+56>>2]&127](c[y+4>>2]|0,c[t>>2]|0);E=0}do{if((E&255|0)!=0){if((c[y+80>>2]|0)==0){break}IR(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);rR(y+416|0);while(1){if((c[s>>2]|0)==0){break}E=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&127](c[y+4>>2]|0,c[c[E>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[E+4>>2]=c[y+376>>2];c[y+376>>2]=E;c[(c[E>>2]|0)+4>>2]=c[E+8>>2]}if((c[y+312>>2]|0)==0){B=107;break a}break};case-1:{B=25;break a;break};case 10:{E=xe[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((E|0)<0){B=135;break a}C=y;if((c[y+60>>2]|0)!=0){G=c[C+60>>2]|0;H=c[y+4>>2]|0;I=ES(E,u)|0;Ee[G&15](H,u,I);break b}if((c[C+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{C=y;do{if((c[y+72>>2]|0)!=0){fe[c[C+72>>2]&255](c[y+4>>2]|0)}else{if((c[C+80>>2]|0)==0){break}IR(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);O=sS(y,e,n,g,h,j)|0;if((O|0)!=0){B=150;break a}if((c[n>>2]|0)==0){B=152;break a}break};case-5:{B=153;break a;break};case 6:{C=c[y+60>>2]|0;if((C|0)==0){if((c[y+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ee[C&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ce[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ee[C&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case 11:{if((jS(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=174;break a}break};case 13:{if((kS(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){B=176;break a}break};case-2:{B=28;break a;break};case-4:{B=17;break a;break};default:{if((c[y+80>>2]|0)==0){break b}IR(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){B=180;break}else if((f|0)==2){B=181;break}}if((B|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}IR(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((B|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((B|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((B|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((B|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((B|0)==37){P=1;Q=P;i=l;return Q|0}else if((B|0)==41){P=11;Q=P;i=l;return Q|0}else if((B|0)==43){P=24;Q=P;i=l;return Q|0}else if((B|0)==50){P=12;Q=P;i=l;return Q|0}else if((B|0)==52){P=15;Q=P;i=l;return Q|0}else if((B|0)==60){P=J;Q=P;i=l;return Q|0}else if((B|0)==63){P=1;Q=P;i=l;return Q|0}else if((B|0)==65){P=21;Q=P;i=l;return Q|0}else if((B|0)==72){P=1;Q=P;i=l;return Q|0}else if((B|0)==74){fe[c[y+20>>2]&255](K);P=1;Q=P;i=l;return Q|0}else if((B|0)==80){P=1;Q=P;i=l;return Q|0}else if((B|0)==82){P=M;Q=P;i=l;return Q|0}else if((B|0)==89){P=1;Q=P;i=l;return Q|0}else if((B|0)==91){P=N;Q=P;i=l;return Q|0}else if((B|0)==107){P=rS(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==109){P=13;Q=P;i=l;return Q|0}else if((B|0)==112){c[z>>2]=D;P=7;Q=P;i=l;return Q|0}else if((B|0)==133){P=rS(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((B|0)==135){P=14;Q=P;i=l;return Q|0}else if((B|0)==140){P=17;Q=P;i=l;return Q|0}else if((B|0)==150){P=O;Q=P;i=l;return Q|0}else if((B|0)==152){c[y+280>>2]=42;P=O;Q=P;i=l;return Q|0}else if((B|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ee[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ce[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ee[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}IR(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((B|0)==174){P=1;Q=P;i=l;return Q|0}else if((B|0)==176){P=1;Q=P;i=l;return Q|0}else if((B|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((B|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function oS(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=He[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=UR(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=nS(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=UR(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=nS(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function pS(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((KR(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);LR(e,b+60|0);a:while(1){k=MR(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((KR(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((KR(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){LR(e,b);b:while(1){b=MR(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((KR(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((KR(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}




// EMSCRIPTEN_END_FUNCS
var be=[xqa,PY,RY,WY,Vba,xqa,xqa,xqa];var ce=[yqa,rT,sT,XT,YT,AU,BU,YU,ZU,_U,Ooa,Noa,Moa,tX,LS,MS,uW,sW,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa,yqa];var de=[zqa,z_];var ee=[Aqa,BZ];var fe=[Bqa,Tg,Ug,_g,hh,wy,jh,pW,L0,O0,N0,P0,Tga,Sga,Vga,Uga,Q0,S0,c4,y4,z4,A4,Ega,Dga,Gga,Fga,rba,Eba,Fba,Gba,Iba,Kba,Ada,Bda,Hda,Ida,Oda,Pda,Vda,Wda,gea,fea,lea,kea,nea,oea,xea,wea,Efa,Dfa,Nfa,Mfa,pga,oga,Nga,Mga,Pga,Oga,fha,eha,hha,gha,nha,mha,Cfa,oha,lha,pha,rha,qha,zla,xha,wha,Cha,Bha,$ha,_ha,Dia,Cia,Ria,Qia,dja,cja,rja,qja,Eja,Dja,Hja,Gja,Lja,Kja,Wja,Vja,fka,eka,qka,pka,Bka,Aka,Lka,Kka,Tka,Ska,Zka,Yka,dla,cla,ila,hla,rla,qla,Pla,Ola,mla,ema,Lma,Kma,Nma,Mma,sha,yla,Bla,Yla,mma,xma,Ima,Jma,zoa,yoa,Boa,Eoa,Coa,Doa,Foa,Goa,bpa,apa,Xg,Ng,Cqa,cf,lf,mf,of,Of,Pf,Qf,Rf,Tf,Xf,og,pg,qg,wg,xg,Bg,Cg,Dg,Eg,Fg,Gg,Hg,Ig,Toa,rW,Ze,lZ,pZ,kZ,C_,rZ,A_,PX,uZ,sZ,tZ,qZ,wZ,B_,xZ,mZ,zZ,cba,AZ,_ca,zda,Ala,tna,Dka,Ana,zna,yna,xna,wna,vna,Nea,pfa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa,Bqa];var ge=[Dqa,ih,h$,T0,cga,Cda,Jda,Qda,Xda,qga,Oja,Pja,Qja,Rja,Tja,Uja,Zja,_ja,$ja,aka,cka,dka,ika,jka,kka,lka,nka,oka,tka,uka,vka,wka,yka,zka,gla,lla,Sma,Uma,Wma,Tma,Vma,Xma,cZ,Vg,Yg,$g,ah,bh,ch,dh,eh,fh,gh,vZ,K3,j$,i$,k$,q$,C$,l$,A$,Z2,j3,i3,k3,U2,S2,W2,hca,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa,Dqa];var he=[Eqa,_S,TS,QY,SY,TY,UY,VY];var ie=[Fqa,Kg,oQ,Jg,$e,af,bf,xy,Ly,ph,vy,nQ,sQ,oh,mh,yQ,zQ,OQ,PQ,QQ,TQ,UQ,VQ,WQ,XQ,Gqa,Hqa,Iqa,LW,Soa,Jqa,X0,hga,Y0,kga,gga,Nba,Dda,vga,xga,yga,uga,Kda,Lda,Rda,jga,Yda,Zda,hea,mea,jha,eja,Yma,_ma,ana,gna,ina,cna,ena,sja,Zma,$ma,bna,hna,jna,dna,fna,Mja,Nja,Sja,Xja,Yja,bka,gka,hka,mka,rka,ska,xka,ima,jma,lma,Oma,Qma,Pma,Rma,ama,bma,dma,sma,tma,wma,Dma,Ema,Hma,Aoa,cpa,J_,Kqa,Lqa,SQ,tQ,H_,I_,Mqa,Xaa,wba,FZ,NZ,ZZ,GZ,QZ,_Z,rda,lpa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa,Fqa];var je=[Nqa,rX];var ke=[Oqa,zY];var le=[Pqa,lh,iT,oT,OT,UT,rU,xU,U0,iga,mga,dga,rga,wga,Eda,Aga,Sda,rea,sea,vha,Aha,ela,jla,Rla,Tla,Wla,Cla,Hla,Jla,Mla,Hoa,eba,sX,XS,OS,VS,$S,Qqa,Rqa,Sqa,D_,bba,Zaa,Tqa,jda,Uqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa,Pqa];var me=[Vqa,DY];var ne=[Wqa,XX];var oe=[Xqa,Lia,Oia,Zia,$ia,Xqa,Xqa,Xqa];var pe=[Yqa,Fja,Ija,Cka,Gka,Mka,Oka,Yqa];var qe=[Zqa,xY];var re=[_qa,mW,V0,Lba,sga,ega,Eia,Fia,Jia,Pia,Sia,Tia,Xia,aja,fla,kla,Roa,Qoa,Poa,nW,_qa,_qa,_qa,_qa,_qa,_qa,_qa,_qa,_qa,_qa,_qa,_qa];var se=[$qa,OZ,PZ,$qa];var te=[ara,Mg];var ue=[bra,Dha,Fha,Hha,Jha,Lha,Nha,Pha,Rha,Tha,Vha,Xha,aia,cia,eia,gia,iia,kia,mia,oia,qia,sia,uia,Iia,Kia,Wia,Yia,fja,gja,hja,ija,jja,tja,uja,vja,wja,xja,Xka,bla,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra,bra];var ve=[cra,Uka,_ka,cra];var we=[dra,kja,yja,dra];var xe=[era,_e,qh,nh,kh,YQ,ZQ,kT,lT,nT,QT,RT,TT,tU,uU,wU,CU,DU,EU,FU,GU,HU,IU,JU,Z0,_0,Oba,Pba,zga,Fda,Mda,Bga,lga,Tda,_da,nga,Qla,Sla,Ula,Gla,Ila,Kla,r_,a_,SZ,HZ,$Z,RZ,fra,Voa,IS,JS,KS,gra,YW,VZ,YZ,KZ,n_,e_,MZ,hra,koa,era];var ye=[ira,tha,yha,Xla,hma,kma,Nla,$la,cma,rma,uma,Cma,Fma,eV,XV,YV,jV,gV,VV,WV,kV,lV,mV,nV,oV,LV,MV,CV,vV,qV,pV,rV,sV,uV,tV,hV,fV,wV,xV,yV,zV,AV,BV,DV,EV,FV,GV,KV,IV,HV,JV,RV,NV,OV,PV,QV,SV,TV,UV,ZV,_V,$V,aW,Gia];var ze=[jra,O_];var Ae=[kra,b_];var Be=[lra,fY];var Ce=[mra,$Q,nra,MW,wda,xda,uda,mra];var De=[ora,CY];var Ee=[pra,gba,qea,kha,lX,xW,c$,e$,J3,gca,pra,pra,pra,pra,pra,pra];var Fe=[qra,rra,KW,dW,Pg,qra,qra,qra];var Ge=[sra,_Q,fma,gma,Zla,_la,nma,pma,yma,Ama,f_,sra,sra,sra,sra,sra];var He=[tra,cT,dT,eT,fT,gT,hT,jT,mT,qT,IT,JT,KT,LT,MT,NT,PT,ST,WT,lU,mU,nU,oU,pU,qU,sU,vU,zU,Vla,Dla,Ela,Fla,Lla,eZ,ura,yY,AS,DR,YR,fS,TR,oS,tS,rS,uS,aT,GS,QS,RS,YS,ZS,Zha,Mia,vra,tra,tra,tra,tra,tra,tra,tra,tra,tra,tra];var Ie=[wra,pT,VT,yU,W0,fba,Mba,tga,fga,uha,zha,Ioa,Joa,Koa,vW,tW,gZ,wW,Wg,Zg,Bca,SS,yW,wra,wra,wra,wra,wra,wra,wra,wra,wra];return{_testSetjmp:Hpa,_saveSetjmp:tpa,_free:Toa,_main:Og,_rand_r:Bpa,_realloc:Voa,_i64Add:Epa,_memmove:xpa,_bitshift64Ashr:vpa,_memset:ypa,_malloc:Soa,_strncpy:Fpa,_memcpy:wpa,_strlen:upa,_bitshift64Lshr:Gpa,_bitshift64Shl:zpa,_i64Subtract:Dpa,_strcpy:Apa,_calloc:Uoa,_rand:Cpa,__GLOBAL__I_a:aea,runPostSets:spa,stackAlloc:Je,stackSave:Ke,stackRestore:Le,setThrew:Me,setTempRet0:Pe,setTempRet1:Qe,setTempRet2:Re,setTempRet3:Se,setTempRet4:Te,setTempRet5:Ue,setTempRet6:Ve,setTempRet7:We,setTempRet8:Xe,setTempRet9:Ye,dynCall_iiiiiiii:Rpa,dynCall_viiiii:Spa,dynCall_iiiiidiii:Tpa,dynCall_vd:Upa,dynCall_vi:Vpa,dynCall_vii:Wpa,dynCall_iiiiiiiiiii:Xpa,dynCall_ii:Ypa,dynCall_viidi:Zpa,dynCall_iiiiiiiiiiiiii:_pa,dynCall_iiii:$pa,dynCall_iiiiiiiiiiiiiiiiiiiiiii:aqa,dynCall_iiiiiiiiiiiiiiiiiiiii:bqa,dynCall_viiiiid:cqa,dynCall_viiiiiiii:dqa,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:eqa,dynCall_viiiiii:fqa,dynCall_viidii:gqa,dynCall_iid:hqa,dynCall_viiiiiii:iqa,dynCall_viiiiiid:jqa,dynCall_viiiiiiiii:kqa,dynCall_iii:lqa,dynCall_iiiiii:mqa,dynCall_iiiiidi:nqa,dynCall_didd:oqa,dynCall_dii:pqa,dynCall_i:qqa,dynCall_iiiiiiiiii:rqa,dynCall_viii:sqa,dynCall_v:tqa,dynCall_iiiiiiiii:uqa,dynCall_iiiii:vqa,dynCall_viiii:wqa}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






