var Module = {};
var preloadComplete = false;

Module['noInitialRun'] = true;
Module['OpenModelica_readFile'] = function(fname) {
  return intArrayToString(FS.findObject(fname).contents);
};
Module['OpenModelica_readFileBuffer'] = function(fname) {
  return FS.findObject(fname).contents;
};

try { // Try to add an event listener like a webworker thread
  self.addEventListener('message', function(e) {
    var data = e.data;
    if (!data) return;
    if (data.preload) {
      var error = function() {console.log('error...'); /* self.postError({message: "Preload failed"}); */ };
      if (!preloadComplete) {
        FS.createPreloadedFile('/', data.basename + "_init.xml", data.basename + "_init.xml", true, false, function() {
        FS.createLazyFile('/', data.basename + "_info.xml", data.basename + "_info.xml", true, false);
        preloadComplete = true;
        self.postMessage({preloaded:true});
      }, error);
      } else {
        self.postMessage({preloaded:true});
      }
      return;
    }
    var result = {};
    result.status = "Simulation failed"
    try {
      shouldRunNow = true;
      var args = ['-override','outputFormat=csv,stopTime=' +  data.stopTime +',tolerance=' + data.tolerance + ',stepSize=' + data.stepSize];
      Module.callMain(args);
      result.csv = intArrayToString(FS.findObject(data.basename + "_res.csv").contents);
      result.status = "Simulation finished";

  } catch(e) {
  }
  self.postMessage(result);
  }, false);
} catch (e) {
}

// The Module object: Our interface to the outside world. We import
// and export values on it, and do the work to get that through
// closure compiler if necessary. There are various ways Module can be used:
// 1. Not defined. We create it here
// 2. A function parameter, function(Module) { ..generated code.. }
// 3. pre-run appended it, var Module = {}; ..generated code..
// 4. External script tag defines var Module.
// We need to do an eval in order to handle the closure compiler
// case, where this code here is minified but Module was defined
// elsewhere (e.g. case 4 above). We also need to check if Module
// already exists (e.g. case 3 above).
// Note that if you want to run closure, and also to use Module
// after the generated code, you will need to define   var Module = {};
// before the code. Then that object will be used in the code, and you
// can continue to use Module afterwards as well.
var Module;
if (!Module) Module = eval('(function() { try { return Module || {} } catch(e) { return {} } })()');

// Sometimes an existing Module object exists with properties
// meant to overwrite the default module functionality. Here
// we collect those properties and reapply _after_ we configure
// the current environment's defaults to avoid having to be so
// defensive during initialization.
var moduleOverrides = {};
for (var key in Module) {
  if (Module.hasOwnProperty(key)) {
    moduleOverrides[key] = Module[key];
  }
}

// The environment setup code below is customized to use Module.
// *** Environment setup code ***
var ENVIRONMENT_IS_NODE = typeof process === 'object' && typeof require === 'function';
var ENVIRONMENT_IS_WEB = typeof window === 'object';
var ENVIRONMENT_IS_WORKER = typeof importScripts === 'function';
var ENVIRONMENT_IS_SHELL = !ENVIRONMENT_IS_WEB && !ENVIRONMENT_IS_NODE && !ENVIRONMENT_IS_WORKER;

if (ENVIRONMENT_IS_NODE) {
  // Expose functionality in the same simple way that the shells work
  // Note that we pollute the global namespace here, otherwise we break in node
  if (!Module['print']) Module['print'] = function print(x) {
    process['stdout'].write(x + '\n');
  };
  if (!Module['printErr']) Module['printErr'] = function printErr(x) {
    process['stderr'].write(x + '\n');
  };

  var nodeFS = require('fs');
  var nodePath = require('path');

  Module['read'] = function read(filename, binary) {
    filename = nodePath['normalize'](filename);
    var ret = nodeFS['readFileSync'](filename);
    // The path is absolute if the normalized version is the same as the resolved.
    if (!ret && filename != nodePath['resolve'](filename)) {
      filename = path.join(__dirname, '..', 'src', filename);
      ret = nodeFS['readFileSync'](filename);
    }
    if (ret && !binary) ret = ret.toString();
    return ret;
  };

  Module['readBinary'] = function readBinary(filename) { return Module['read'](filename, true) };

  Module['load'] = function load(f) {
    globalEval(read(f));
  };

  Module['arguments'] = process['argv'].slice(2);

  module['exports'] = Module;
}
else if (ENVIRONMENT_IS_SHELL) {
  if (!Module['print']) Module['print'] = print;
  if (typeof printErr != 'undefined') Module['printErr'] = printErr; // not present in v8 or older sm

  if (typeof read != 'undefined') {
    Module['read'] = read;
  } else {
    Module['read'] = function read() { throw 'no read() available (jsc?)' };
  }

  Module['readBinary'] = function readBinary(f) {
    return read(f, 'binary');
  };

  if (typeof scriptArgs != 'undefined') {
    Module['arguments'] = scriptArgs;
  } else if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  this['Module'] = Module;

  eval("if (typeof gc === 'function' && gc.toString().indexOf('[native code]') > 0) var gc = undefined"); // wipe out the SpiderMonkey shell 'gc' function, which can confuse closure (uses it as a minified name, and it is then initted to a non-falsey value unexpectedly)
}
else if (ENVIRONMENT_IS_WEB || ENVIRONMENT_IS_WORKER) {
  Module['read'] = function read(url) {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', url, false);
    xhr.send(null);
    return xhr.responseText;
  };

  if (typeof arguments != 'undefined') {
    Module['arguments'] = arguments;
  }

  if (typeof console !== 'undefined') {
    if (!Module['print']) Module['print'] = function print(x) {
      console.log(x);
    };
    if (!Module['printErr']) Module['printErr'] = function printErr(x) {
      console.log(x);
    };
  } else {
    // Probably a worker, and without console.log. We can do very little here...
    var TRY_USE_DUMP = false;
    if (!Module['print']) Module['print'] = (TRY_USE_DUMP && (typeof(dump) !== "undefined") ? (function(x) {
      dump(x);
    }) : (function(x) {
      // self.postMessage(x); // enable this if you want stdout to be sent as messages
    }));
  }

  if (ENVIRONMENT_IS_WEB) {
    this['Module'] = Module;
  } else {
    Module['load'] = importScripts;
  }
}
else {
  // Unreachable because SHELL is dependant on the others
  throw 'Unknown runtime environment. Where are we?';
}

function globalEval(x) {
  eval.call(null, x);
}
if (!Module['load'] == 'undefined' && Module['read']) {
  Module['load'] = function load(f) {
    globalEval(Module['read'](f));
  };
}
if (!Module['print']) {
  Module['print'] = function(){};
}
if (!Module['printErr']) {
  Module['printErr'] = Module['print'];
}
if (!Module['arguments']) {
  Module['arguments'] = [];
}
// *** Environment setup code ***

// Closure helpers
Module.print = Module['print'];
Module.printErr = Module['printErr'];

// Callbacks
Module['preRun'] = [];
Module['postRun'] = [];

// Merge back in the overrides
for (var key in moduleOverrides) {
  if (moduleOverrides.hasOwnProperty(key)) {
    Module[key] = moduleOverrides[key];
  }
}



// === Auto-generated preamble library stuff ===

//========================================
// Runtime code shared with compiler
//========================================

var Runtime = {
  stackSave: function () {
    return STACKTOP;
  },
  stackRestore: function (stackTop) {
    STACKTOP = stackTop;
  },
  forceAlign: function (target, quantum) {
    quantum = quantum || 4;
    if (quantum == 1) return target;
    if (isNumber(target) && isNumber(quantum)) {
      return Math.ceil(target/quantum)*quantum;
    } else if (isNumber(quantum) && isPowerOfTwo(quantum)) {
      return '(((' +target + ')+' + (quantum-1) + ')&' + -quantum + ')';
    }
    return 'Math.ceil((' + target + ')/' + quantum + ')*' + quantum;
  },
  isNumberType: function (type) {
    return type in Runtime.INT_TYPES || type in Runtime.FLOAT_TYPES;
  },
  isPointerType: function isPointerType(type) {
  return type[type.length-1] == '*';
},
  isStructType: function isStructType(type) {
  if (isPointerType(type)) return false;
  if (isArrayType(type)) return true;
  if (/<?\{ ?[^}]* ?\}>?/.test(type)) return true; // { i32, i8 } etc. - anonymous struct types
  // See comment in isStructPointerType()
  return type[0] == '%';
},
  INT_TYPES: {"i1":0,"i8":0,"i16":0,"i32":0,"i64":0},
  FLOAT_TYPES: {"float":0,"double":0},
  or64: function (x, y) {
    var l = (x | 0) | (y | 0);
    var h = (Math.round(x / 4294967296) | Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  and64: function (x, y) {
    var l = (x | 0) & (y | 0);
    var h = (Math.round(x / 4294967296) & Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  xor64: function (x, y) {
    var l = (x | 0) ^ (y | 0);
    var h = (Math.round(x / 4294967296) ^ Math.round(y / 4294967296)) * 4294967296;
    return l + h;
  },
  getNativeTypeSize: function (type) {
    switch (type) {
      case 'i1': case 'i8': return 1;
      case 'i16': return 2;
      case 'i32': return 4;
      case 'i64': return 8;
      case 'float': return 4;
      case 'double': return 8;
      default: {
        if (type[type.length-1] === '*') {
          return Runtime.QUANTUM_SIZE; // A pointer
        } else if (type[0] === 'i') {
          var bits = parseInt(type.substr(1));
          assert(bits % 8 === 0);
          return bits/8;
        } else {
          return 0;
        }
      }
    }
  },
  getNativeFieldSize: function (type) {
    return Math.max(Runtime.getNativeTypeSize(type), Runtime.QUANTUM_SIZE);
  },
  dedup: function dedup(items, ident) {
  var seen = {};
  if (ident) {
    return items.filter(function(item) {
      if (seen[item[ident]]) return false;
      seen[item[ident]] = true;
      return true;
    });
  } else {
    return items.filter(function(item) {
      if (seen[item]) return false;
      seen[item] = true;
      return true;
    });
  }
},
  set: function set() {
  var args = typeof arguments[0] === 'object' ? arguments[0] : arguments;
  var ret = {};
  for (var i = 0; i < args.length; i++) {
    ret[args[i]] = 0;
  }
  return ret;
},
  STACK_ALIGN: 8,
  getAlignSize: function (type, size, vararg) {
    // we align i64s and doubles on 64-bit boundaries, unlike x86
    if (!vararg && (type == 'i64' || type == 'double')) return 8;
    if (!type) return Math.min(size, 8); // align structures internally to 64 bits
    return Math.min(size || (type ? Runtime.getNativeFieldSize(type) : 0), Runtime.QUANTUM_SIZE);
  },
  calculateStructAlignment: function calculateStructAlignment(type) {
    type.flatSize = 0;
    type.alignSize = 0;
    var diffs = [];
    var prev = -1;
    var index = 0;
    type.flatIndexes = type.fields.map(function(field) {
      index++;
      var size, alignSize;
      if (Runtime.isNumberType(field) || Runtime.isPointerType(field)) {
        size = Runtime.getNativeTypeSize(field); // pack char; char; in structs, also char[X]s.
        alignSize = Runtime.getAlignSize(field, size);
      } else if (Runtime.isStructType(field)) {
        if (field[1] === '0') {
          // this is [0 x something]. When inside another structure like here, it must be at the end,
          // and it adds no size
          // XXX this happens in java-nbody for example... assert(index === type.fields.length, 'zero-length in the middle!');
          size = 0;
          if (Types.types[field]) {
            alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
          } else {
            alignSize = type.alignSize || QUANTUM_SIZE;
          }
        } else {
          size = Types.types[field].flatSize;
          alignSize = Runtime.getAlignSize(null, Types.types[field].alignSize);
        }
      } else if (field[0] == 'b') {
        // bN, large number field, like a [N x i8]
        size = field.substr(1)|0;
        alignSize = 1;
      } else if (field[0] === '<') {
        // vector type
        size = alignSize = Types.types[field].flatSize; // fully aligned
      } else if (field[0] === 'i') {
        // illegal integer field, that could not be legalized because it is an internal structure field
        // it is ok to have such fields, if we just use them as markers of field size and nothing more complex
        size = alignSize = parseInt(field.substr(1))/8;
        assert(size % 1 === 0, 'cannot handle non-byte-size field ' + field);
      } else {
        assert(false, 'invalid type for calculateStructAlignment');
      }
      if (type.packed) alignSize = 1;
      type.alignSize = Math.max(type.alignSize, alignSize);
      var curr = Runtime.alignMemory(type.flatSize, alignSize); // if necessary, place this on aligned memory
      type.flatSize = curr + size;
      if (prev >= 0) {
        diffs.push(curr-prev);
      }
      prev = curr;
      return curr;
    });
    if (type.name_ && type.name_[0] === '[') {
      // arrays have 2 elements, so we get the proper difference. then we scale here. that way we avoid
      // allocating a potentially huge array for [999999 x i8] etc.
      type.flatSize = parseInt(type.name_.substr(1))*type.flatSize/2;
    }
    type.flatSize = Runtime.alignMemory(type.flatSize, type.alignSize);
    if (diffs.length == 0) {
      type.flatFactor = type.flatSize;
    } else if (Runtime.dedup(diffs).length == 1) {
      type.flatFactor = diffs[0];
    }
    type.needsFlattening = (type.flatFactor != 1);
    return type.flatIndexes;
  },
  generateStructInfo: function (struct, typeName, offset) {
    var type, alignment;
    if (typeName) {
      offset = offset || 0;
      type = (typeof Types === 'undefined' ? Runtime.typeInfo : Types.types)[typeName];
      if (!type) return null;
      if (type.fields.length != struct.length) {
        printErr('Number of named fields must match the type for ' + typeName + ': possibly duplicate struct names. Cannot return structInfo');
        return null;
      }
      alignment = type.flatIndexes;
    } else {
      var type = { fields: struct.map(function(item) { return item[0] }) };
      alignment = Runtime.calculateStructAlignment(type);
    }
    var ret = {
      __size__: type.flatSize
    };
    if (typeName) {
      struct.forEach(function(item, i) {
        if (typeof item === 'string') {
          ret[item] = alignment[i] + offset;
        } else {
          // embedded struct
          var key;
          for (var k in item) key = k;
          ret[key] = Runtime.generateStructInfo(item[key], type.fields[i], alignment[i]);
        }
      });
    } else {
      struct.forEach(function(item, i) {
        ret[item[1]] = alignment[i];
      });
    }
    return ret;
  },
  dynCall: function (sig, ptr, args) {
    if (args && args.length) {
      if (!args.splice) args = Array.prototype.slice.call(args);
      args.splice(0, 0, ptr);
      return Module['dynCall_' + sig].apply(null, args);
    } else {
      return Module['dynCall_' + sig].call(null, ptr);
    }
  },
  functionPointers: [],
  addFunction: function (func) {
    for (var i = 0; i < Runtime.functionPointers.length; i++) {
      if (!Runtime.functionPointers[i]) {
        Runtime.functionPointers[i] = func;
        return 2*(1 + i);
      }
    }
    throw 'Finished up all reserved function pointers. Use a higher value for RESERVED_FUNCTION_POINTERS.';
  },
  removeFunction: function (index) {
    Runtime.functionPointers[(index-2)/2] = null;
  },
  getAsmConst: function (code, numArgs) {
    // code is a constant string on the heap, so we can cache these
    if (!Runtime.asmConstCache) Runtime.asmConstCache = {};
    var func = Runtime.asmConstCache[code];
    if (func) return func;
    var args = [];
    for (var i = 0; i < numArgs; i++) {
      args.push(String.fromCharCode(36) + i); // $0, $1 etc
    }
    code = Pointer_stringify(code);
    if (code[0] === '"') {
      // tolerate EM_ASM("..code..") even though EM_ASM(..code..) is correct
      if (code.indexOf('"', 1) === code.length-1) {
        code = code.substr(1, code.length-2);
      } else {
        // something invalid happened, e.g. EM_ASM("..code($0)..", input)
        abort('invalid EM_ASM input |' + code + '|. Please use EM_ASM(..code..) (no quotes) or EM_ASM({ ..code($0).. }, input) (to input values)');
      }
    }
    return Runtime.asmConstCache[code] = eval('(function(' + args.join(',') + '){ ' + code + ' })'); // new Function does not allow upvars in node
  },
  warnOnce: function (text) {
    if (!Runtime.warnOnce.shown) Runtime.warnOnce.shown = {};
    if (!Runtime.warnOnce.shown[text]) {
      Runtime.warnOnce.shown[text] = 1;
      Module.printErr(text);
    }
  },
  funcWrappers: {},
  getFuncWrapper: function (func, sig) {
    assert(sig);
    if (!Runtime.funcWrappers[func]) {
      Runtime.funcWrappers[func] = function dynCall_wrapper() {
        return Runtime.dynCall(sig, func, arguments);
      };
    }
    return Runtime.funcWrappers[func];
  },
  UTF8Processor: function () {
    var buffer = [];
    var needed = 0;
    this.processCChar = function (code) {
      code = code & 0xFF;

      if (buffer.length == 0) {
        if ((code & 0x80) == 0x00) {        // 0xxxxxxx
          return String.fromCharCode(code);
        }
        buffer.push(code);
        if ((code & 0xE0) == 0xC0) {        // 110xxxxx
          needed = 1;
        } else if ((code & 0xF0) == 0xE0) { // 1110xxxx
          needed = 2;
        } else {                            // 11110xxx
          needed = 3;
        }
        return '';
      }

      if (needed) {
        buffer.push(code);
        needed--;
        if (needed > 0) return '';
      }

      var c1 = buffer[0];
      var c2 = buffer[1];
      var c3 = buffer[2];
      var c4 = buffer[3];
      var ret;
      if (buffer.length == 2) {
        ret = String.fromCharCode(((c1 & 0x1F) << 6)  | (c2 & 0x3F));
      } else if (buffer.length == 3) {
        ret = String.fromCharCode(((c1 & 0x0F) << 12) | ((c2 & 0x3F) << 6)  | (c3 & 0x3F));
      } else {
        // http://mathiasbynens.be/notes/javascript-encoding#surrogate-formulae
        var codePoint = ((c1 & 0x07) << 18) | ((c2 & 0x3F) << 12) |
                        ((c3 & 0x3F) << 6)  | (c4 & 0x3F);
        ret = String.fromCharCode(
          Math.floor((codePoint - 0x10000) / 0x400) + 0xD800,
          (codePoint - 0x10000) % 0x400 + 0xDC00);
      }
      buffer.length = 0;
      return ret;
    }
    this.processJSString = function processJSString(string) {
      string = unescape(encodeURIComponent(string));
      var ret = [];
      for (var i = 0; i < string.length; i++) {
        ret.push(string.charCodeAt(i));
      }
      return ret;
    }
  },
  getCompilerSetting: function (name) {
    throw 'You must build with -s RETAIN_COMPILER_SETTINGS=1 for Runtime.getCompilerSetting or emscripten_get_compiler_setting to work';
  },
  stackAlloc: function (size) { var ret = STACKTOP;STACKTOP = (STACKTOP + size)|0;STACKTOP = (((STACKTOP)+7)&-8); return ret; },
  staticAlloc: function (size) { var ret = STATICTOP;STATICTOP = (STATICTOP + size)|0;STATICTOP = (((STATICTOP)+7)&-8); return ret; },
  dynamicAlloc: function (size) { var ret = DYNAMICTOP;DYNAMICTOP = (DYNAMICTOP + size)|0;DYNAMICTOP = (((DYNAMICTOP)+7)&-8); if (DYNAMICTOP >= TOTAL_MEMORY) enlargeMemory();; return ret; },
  alignMemory: function (size,quantum) { var ret = size = Math.ceil((size)/(quantum ? quantum : 8))*(quantum ? quantum : 8); return ret; },
  makeBigInt: function (low,high,unsigned) { var ret = (unsigned ? ((+((low>>>0)))+((+((high>>>0)))*(+4294967296))) : ((+((low>>>0)))+((+((high|0)))*(+4294967296)))); return ret; },
  GLOBAL_BASE: 8,
  QUANTUM_SIZE: 4,
  __dummy__: 0
}


Module['Runtime'] = Runtime;









//========================================
// Runtime essentials
//========================================

var __THREW__ = 0; // Used in checking for thrown exceptions.

var ABORT = false; // whether we are quitting the application. no code should run after this. set in exit() and abort()
var EXITSTATUS = 0;

var undef = 0;
// tempInt is used for 32-bit signed values or smaller. tempBigInt is used
// for 32-bit unsigned values or more than 32 bits. TODO: audit all uses of tempInt
var tempValue, tempInt, tempBigInt, tempInt2, tempBigInt2, tempPair, tempBigIntI, tempBigIntR, tempBigIntS, tempBigIntP, tempBigIntD, tempDouble, tempFloat;
var tempI64, tempI64b;
var tempRet0, tempRet1, tempRet2, tempRet3, tempRet4, tempRet5, tempRet6, tempRet7, tempRet8, tempRet9;

function assert(condition, text) {
  if (!condition) {
    abort('Assertion failed: ' + text);
  }
}

var globalScope = this;

// C calling interface. A convenient way to call C functions (in C files, or
// defined with extern "C").
//
// Note: LLVM optimizations can inline and remove functions, after which you will not be
//       able to call them. Closure can also do so. To avoid that, add your function to
//       the exports using something like
//
//         -s EXPORTED_FUNCTIONS='["_main", "_myfunc"]'
//
// @param ident      The name of the C function (note that C++ functions will be name-mangled - use extern "C")
// @param returnType The return type of the function, one of the JS types 'number', 'string' or 'array' (use 'number' for any C pointer, and
//                   'array' for JavaScript arrays and typed arrays; note that arrays are 8-bit).
// @param argTypes   An array of the types of arguments for the function (if there are no arguments, this can be ommitted). Types are as in returnType,
//                   except that 'array' is not possible (there is no way for us to know the length of the array)
// @param args       An array of the arguments to the function, as native JS values (as in returnType)
//                   Note that string arguments will be stored on the stack (the JS string will become a C string on the stack).
// @return           The return value, as a native JS value (as in returnType)
function ccall(ident, returnType, argTypes, args) {
  return ccallFunc(getCFunc(ident), returnType, argTypes, args);
}
Module["ccall"] = ccall;

// Returns the C function with a specified identifier (for C++, you need to do manual name mangling)
function getCFunc(ident) {
  try {
    var func = Module['_' + ident]; // closure exported function
    if (!func) func = eval('_' + ident); // explicit lookup
  } catch(e) {
  }
  assert(func, 'Cannot call unknown function ' + ident + ' (perhaps LLVM optimizations or closure removed it?)');
  return func;
}

// Internal function that does a C call using a function, not an identifier
function ccallFunc(func, returnType, argTypes, args) {
  var stack = 0;
  function toC(value, type) {
    if (type == 'string') {
      if (value === null || value === undefined || value === 0) return 0; // null string
      value = intArrayFromString(value);
      type = 'array';
    }
    if (type == 'array') {
      if (!stack) stack = Runtime.stackSave();
      var ret = Runtime.stackAlloc(value.length);
      writeArrayToMemory(value, ret);
      return ret;
    }
    return value;
  }
  function fromC(value, type) {
    if (type == 'string') {
      return Pointer_stringify(value);
    }
    assert(type != 'array');
    return value;
  }
  var i = 0;
  var cArgs = args ? args.map(function(arg) {
    return toC(arg, argTypes[i++]);
  }) : [];
  var ret = fromC(func.apply(null, cArgs), returnType);
  if (stack) Runtime.stackRestore(stack);
  return ret;
}

// Returns a native JS wrapper for a C function. This is similar to ccall, but
// returns a function you can call repeatedly in a normal way. For example:
//
//   var my_function = cwrap('my_c_function', 'number', ['number', 'number']);
//   alert(my_function(5, 22));
//   alert(my_function(99, 12));
//
function cwrap(ident, returnType, argTypes) {
  var func = getCFunc(ident);
  return function() {
    return ccallFunc(func, returnType, argTypes, Array.prototype.slice.call(arguments));
  }
}
Module["cwrap"] = cwrap;

// Sets a value in memory in a dynamic way at run-time. Uses the
// type data. This is the same as makeSetValue, except that
// makeSetValue is done at compile-time and generates the needed
// code then, whereas this function picks the right code at
// run-time.
// Note that setValue and getValue only do *aligned* writes and reads!
// Note that ccall uses JS types as for defining types, while setValue and
// getValue need LLVM types ('i8', 'i32') - this is a lower-level operation
function setValue(ptr, value, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': HEAP8[(ptr)]=value; break;
      case 'i8': HEAP8[(ptr)]=value; break;
      case 'i16': HEAP16[((ptr)>>1)]=value; break;
      case 'i32': HEAP32[((ptr)>>2)]=value; break;
      case 'i64': (tempI64 = [value>>>0,(tempDouble=value,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((ptr)>>2)]=tempI64[0],HEAP32[(((ptr)+(4))>>2)]=tempI64[1]); break;
      case 'float': HEAPF32[((ptr)>>2)]=value; break;
      case 'double': HEAPF64[((ptr)>>3)]=value; break;
      default: abort('invalid type for setValue: ' + type);
    }
}
Module['setValue'] = setValue;

// Parallel to setValue.
function getValue(ptr, type, noSafe) {
  type = type || 'i8';
  if (type.charAt(type.length-1) === '*') type = 'i32'; // pointers are 32-bit
    switch(type) {
      case 'i1': return HEAP8[(ptr)];
      case 'i8': return HEAP8[(ptr)];
      case 'i16': return HEAP16[((ptr)>>1)];
      case 'i32': return HEAP32[((ptr)>>2)];
      case 'i64': return HEAP32[((ptr)>>2)];
      case 'float': return HEAPF32[((ptr)>>2)];
      case 'double': return HEAPF64[((ptr)>>3)];
      default: abort('invalid type for setValue: ' + type);
    }
  return null;
}
Module['getValue'] = getValue;

var ALLOC_NORMAL = 0; // Tries to use _malloc()
var ALLOC_STACK = 1; // Lives for the duration of the current function call
var ALLOC_STATIC = 2; // Cannot be freed
var ALLOC_DYNAMIC = 3; // Cannot be freed except through sbrk
var ALLOC_NONE = 4; // Do not allocate
Module['ALLOC_NORMAL'] = ALLOC_NORMAL;
Module['ALLOC_STACK'] = ALLOC_STACK;
Module['ALLOC_STATIC'] = ALLOC_STATIC;
Module['ALLOC_DYNAMIC'] = ALLOC_DYNAMIC;
Module['ALLOC_NONE'] = ALLOC_NONE;

// allocate(): This is for internal use. You can use it yourself as well, but the interface
//             is a little tricky (see docs right below). The reason is that it is optimized
//             for multiple syntaxes to save space in generated code. So you should
//             normally not use allocate(), and instead allocate memory using _malloc(),
//             initialize it with setValue(), and so forth.
// @slab: An array of data, or a number. If a number, then the size of the block to allocate,
//        in *bytes* (note that this is sometimes confusing: the next parameter does not
//        affect this!)
// @types: Either an array of types, one for each byte (or 0 if no type at that position),
//         or a single type which is used for the entire block. This only matters if there
//         is initial data - if @slab is a number, then this does not matter at all and is
//         ignored.
// @allocator: How to allocate memory, see ALLOC_*
function allocate(slab, types, allocator, ptr) {
  var zeroinit, size;
  if (typeof slab === 'number') {
    zeroinit = true;
    size = slab;
  } else {
    zeroinit = false;
    size = slab.length;
  }

  var singleType = typeof types === 'string' ? types : null;

  var ret;
  if (allocator == ALLOC_NONE) {
    ret = ptr;
  } else {
    ret = [_malloc, Runtime.stackAlloc, Runtime.staticAlloc, Runtime.dynamicAlloc][allocator === undefined ? ALLOC_STATIC : allocator](Math.max(size, singleType ? 1 : types.length));
  }

  if (zeroinit) {
    var ptr = ret, stop;
    assert((ret & 3) == 0);
    stop = ret + (size & ~3);
    for (; ptr < stop; ptr += 4) {
      HEAP32[((ptr)>>2)]=0;
    }
    stop = ret + size;
    while (ptr < stop) {
      HEAP8[((ptr++)|0)]=0;
    }
    return ret;
  }

  if (singleType === 'i8') {
    if (slab.subarray || slab.slice) {
      HEAPU8.set(slab, ret);
    } else {
      HEAPU8.set(new Uint8Array(slab), ret);
    }
    return ret;
  }

  var i = 0, type, typeSize, previousType;
  while (i < size) {
    var curr = slab[i];

    if (typeof curr === 'function') {
      curr = Runtime.getFunctionIndex(curr);
    }

    type = singleType || types[i];
    if (type === 0) {
      i++;
      continue;
    }

    if (type == 'i64') type = 'i32'; // special case: we have one i32 here, and one i32 later

    setValue(ret+i, curr, type);

    // no need to look up size unless type changes, so cache it
    if (previousType !== type) {
      typeSize = Runtime.getNativeTypeSize(type);
      previousType = type;
    }
    i += typeSize;
  }

  return ret;
}
Module['allocate'] = allocate;

function Pointer_stringify(ptr, /* optional */ length) {
  // TODO: use TextDecoder
  // Find the length, and check for UTF while doing so
  var hasUtf = false;
  var t;
  var i = 0;
  while (1) {
    t = HEAPU8[(((ptr)+(i))|0)];
    if (t >= 128) hasUtf = true;
    else if (t == 0 && !length) break;
    i++;
    if (length && i == length) break;
  }
  if (!length) length = i;

  var ret = '';

  if (!hasUtf) {
    var MAX_CHUNK = 1024; // split up into chunks, because .apply on a huge string can overflow the stack
    var curr;
    while (length > 0) {
      curr = String.fromCharCode.apply(String, HEAPU8.subarray(ptr, ptr + Math.min(length, MAX_CHUNK)));
      ret = ret ? ret + curr : curr;
      ptr += MAX_CHUNK;
      length -= MAX_CHUNK;
    }
    return ret;
  }

  var utf8 = new Runtime.UTF8Processor();
  for (i = 0; i < length; i++) {
    t = HEAPU8[(((ptr)+(i))|0)];
    ret += utf8.processCChar(t);
  }
  return ret;
}
Module['Pointer_stringify'] = Pointer_stringify;

// Given a pointer 'ptr' to a null-terminated UTF16LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF16ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var codeUnit = HEAP16[(((ptr)+(i*2))>>1)];
    if (codeUnit == 0)
      return str;
    ++i;
    // fromCharCode constructs a character from a UTF-16 code unit, so we can pass the UTF16 string right through.
    str += String.fromCharCode(codeUnit);
  }
}
Module['UTF16ToString'] = UTF16ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF16LE form. The copy will require at most (str.length*2+1)*2 bytes of space in the HEAP.
function stringToUTF16(str, outPtr) {
  for(var i = 0; i < str.length; ++i) {
    // charCodeAt returns a UTF-16 encoded code unit, so it can be directly written to the HEAP.
    var codeUnit = str.charCodeAt(i); // possibly a lead surrogate
    HEAP16[(((outPtr)+(i*2))>>1)]=codeUnit;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP16[(((outPtr)+(str.length*2))>>1)]=0;
}
Module['stringToUTF16'] = stringToUTF16;

// Given a pointer 'ptr' to a null-terminated UTF32LE-encoded string in the emscripten HEAP, returns
// a copy of that string as a Javascript String object.
function UTF32ToString(ptr) {
  var i = 0;

  var str = '';
  while (1) {
    var utf32 = HEAP32[(((ptr)+(i*4))>>2)];
    if (utf32 == 0)
      return str;
    ++i;
    // Gotcha: fromCharCode constructs a character from a UTF-16 encoded code (pair), not from a Unicode code point! So encode the code point to UTF-16 for constructing.
    if (utf32 >= 0x10000) {
      var ch = utf32 - 0x10000;
      str += String.fromCharCode(0xD800 | (ch >> 10), 0xDC00 | (ch & 0x3FF));
    } else {
      str += String.fromCharCode(utf32);
    }
  }
}
Module['UTF32ToString'] = UTF32ToString;

// Copies the given Javascript String object 'str' to the emscripten HEAP at address 'outPtr',
// null-terminated and encoded in UTF32LE form. The copy will require at most (str.length+1)*4 bytes of space in the HEAP,
// but can use less, since str.length does not return the number of characters in the string, but the number of UTF-16 code units in the string.
function stringToUTF32(str, outPtr) {
  var iChar = 0;
  for(var iCodeUnit = 0; iCodeUnit < str.length; ++iCodeUnit) {
    // Gotcha: charCodeAt returns a 16-bit word that is a UTF-16 encoded code unit, not a Unicode code point of the character! We must decode the string to UTF-32 to the heap.
    var codeUnit = str.charCodeAt(iCodeUnit); // possibly a lead surrogate
    if (codeUnit >= 0xD800 && codeUnit <= 0xDFFF) {
      var trailSurrogate = str.charCodeAt(++iCodeUnit);
      codeUnit = 0x10000 + ((codeUnit & 0x3FF) << 10) | (trailSurrogate & 0x3FF);
    }
    HEAP32[(((outPtr)+(iChar*4))>>2)]=codeUnit;
    ++iChar;
  }
  // Null-terminate the pointer to the HEAP.
  HEAP32[(((outPtr)+(iChar*4))>>2)]=0;
}
Module['stringToUTF32'] = stringToUTF32;

function demangle(func) {
  var i = 3;
  // params, etc.
  var basicTypes = {
    'v': 'void',
    'b': 'bool',
    'c': 'char',
    's': 'short',
    'i': 'int',
    'l': 'long',
    'f': 'float',
    'd': 'double',
    'w': 'wchar_t',
    'a': 'signed char',
    'h': 'unsigned char',
    't': 'unsigned short',
    'j': 'unsigned int',
    'm': 'unsigned long',
    'x': 'long long',
    'y': 'unsigned long long',
    'z': '...'
  };
  var subs = [];
  var first = true;
  function dump(x) {
    //return;
    if (x) Module.print(x);
    Module.print(func);
    var pre = '';
    for (var a = 0; a < i; a++) pre += ' ';
    Module.print (pre + '^');
  }
  function parseNested() {
    i++;
    if (func[i] === 'K') i++; // ignore const
    var parts = [];
    while (func[i] !== 'E') {
      if (func[i] === 'S') { // substitution
        i++;
        var next = func.indexOf('_', i);
        var num = func.substring(i, next) || 0;
        parts.push(subs[num] || '?');
        i = next+1;
        continue;
      }
      if (func[i] === 'C') { // constructor
        parts.push(parts[parts.length-1]);
        i += 2;
        continue;
      }
      var size = parseInt(func.substr(i));
      var pre = size.toString().length;
      if (!size || !pre) { i--; break; } // counter i++ below us
      var curr = func.substr(i + pre, size);
      parts.push(curr);
      subs.push(curr);
      i += pre + size;
    }
    i++; // skip E
    return parts;
  }
  function parse(rawList, limit, allowVoid) { // main parser
    limit = limit || Infinity;
    var ret = '', list = [];
    function flushList() {
      return '(' + list.join(', ') + ')';
    }
    var name;
    if (func[i] === 'N') {
      // namespaced N-E
      name = parseNested().join('::');
      limit--;
      if (limit === 0) return rawList ? [name] : name;
    } else {
      // not namespaced
      if (func[i] === 'K' || (first && func[i] === 'L')) i++; // ignore const and first 'L'
      var size = parseInt(func.substr(i));
      if (size) {
        var pre = size.toString().length;
        name = func.substr(i + pre, size);
        i += pre + size;
      }
    }
    first = false;
    if (func[i] === 'I') {
      i++;
      var iList = parse(true);
      var iRet = parse(true, 1, true);
      ret += iRet[0] + ' ' + name + '<' + iList.join(', ') + '>';
    } else {
      ret = name;
    }
    paramLoop: while (i < func.length && limit-- > 0) {
      //dump('paramLoop');
      var c = func[i++];
      if (c in basicTypes) {
        list.push(basicTypes[c]);
      } else {
        switch (c) {
          case 'P': list.push(parse(true, 1, true)[0] + '*'); break; // pointer
          case 'R': list.push(parse(true, 1, true)[0] + '&'); break; // reference
          case 'L': { // literal
            i++; // skip basic type
            var end = func.indexOf('E', i);
            var size = end - i;
            list.push(func.substr(i, size));
            i += size + 2; // size + 'EE'
            break;
          }
          case 'A': { // array
            var size = parseInt(func.substr(i));
            i += size.toString().length;
            if (func[i] !== '_') throw '?';
            i++; // skip _
            list.push(parse(true, 1, true)[0] + ' [' + size + ']');
            break;
          }
          case 'E': break paramLoop;
          default: ret += '?' + c; break paramLoop;
        }
      }
    }
    if (!allowVoid && list.length === 1 && list[0] === 'void') list = []; // avoid (void)
    return rawList ? list : ret + flushList();
  }
  try {
    // Special-case the entry point, since its name differs from other name mangling.
    if (func == 'Object._main' || func == '_main') {
      return 'main()';
    }
    if (typeof func === 'number') func = Pointer_stringify(func);
    if (func[0] !== '_') return func;
    if (func[1] !== '_') return func; // C function
    if (func[2] !== 'Z') return func;
    switch (func[3]) {
      case 'n': return 'operator new()';
      case 'd': return 'operator delete()';
    }
    return parse();
  } catch(e) {
    return func;
  }
}

function demangleAll(text) {
  return text.replace(/__Z[\w\d_]+/g, function(x) { var y = demangle(x); return x === y ? x : (x + ' [' + y + ']') });
}

function stackTrace() {
  var stack = new Error().stack;
  return stack ? demangleAll(stack) : '(no stack trace available)'; // Stack trace is not available at least on IE10 and Safari 6.
}

// Memory management

var PAGE_SIZE = 4096;
function alignMemoryPage(x) {
  return (x+4095)&-4096;
}

var HEAP;
var HEAP8, HEAPU8, HEAP16, HEAPU16, HEAP32, HEAPU32, HEAPF32, HEAPF64;

var STATIC_BASE = 0, STATICTOP = 0, staticSealed = false; // static area
var STACK_BASE = 0, STACKTOP = 0, STACK_MAX = 0; // stack area
var DYNAMIC_BASE = 0, DYNAMICTOP = 0; // dynamic area handled by sbrk

function enlargeMemory() {
  abort('Cannot enlarge memory arrays. Either (1) compile with -s TOTAL_MEMORY=X with X higher than the current value ' + TOTAL_MEMORY + ', (2) compile with ALLOW_MEMORY_GROWTH which adjusts the size at runtime but prevents some optimizations, or (3) set Module.TOTAL_MEMORY before the program runs.');
}

var TOTAL_STACK = Module['TOTAL_STACK'] || 5242880;
var TOTAL_MEMORY = Module['TOTAL_MEMORY'] || 536870912;
var FAST_MEMORY = Module['FAST_MEMORY'] || 2097152;

var totalMemory = 4096;
while (totalMemory < TOTAL_MEMORY || totalMemory < 2*TOTAL_STACK) {
  if (totalMemory < 16*1024*1024) {
    totalMemory *= 2;
  } else {
    totalMemory += 16*1024*1024
  }
}
if (totalMemory !== TOTAL_MEMORY) {
  Module.printErr('increasing TOTAL_MEMORY to ' + totalMemory + ' to be more reasonable');
  TOTAL_MEMORY = totalMemory;
}

// Initialize the runtime's memory
// check for full engine support (use string 'subarray' to avoid closure compiler confusion)
assert(typeof Int32Array !== 'undefined' && typeof Float64Array !== 'undefined' && !!(new Int32Array(1)['subarray']) && !!(new Int32Array(1)['set']),
       'JS engine does not provide full typed array support');

var buffer = new ArrayBuffer(TOTAL_MEMORY);
HEAP8 = new Int8Array(buffer);
HEAP16 = new Int16Array(buffer);
HEAP32 = new Int32Array(buffer);
HEAPU8 = new Uint8Array(buffer);
HEAPU16 = new Uint16Array(buffer);
HEAPU32 = new Uint32Array(buffer);
HEAPF32 = new Float32Array(buffer);
HEAPF64 = new Float64Array(buffer);

// Endianness check (note: assumes compiler arch was little-endian)
HEAP32[0] = 255;
assert(HEAPU8[0] === 255 && HEAPU8[3] === 0, 'Typed arrays 2 must be run on a little-endian system');

Module['HEAP'] = HEAP;
Module['HEAP8'] = HEAP8;
Module['HEAP16'] = HEAP16;
Module['HEAP32'] = HEAP32;
Module['HEAPU8'] = HEAPU8;
Module['HEAPU16'] = HEAPU16;
Module['HEAPU32'] = HEAPU32;
Module['HEAPF32'] = HEAPF32;
Module['HEAPF64'] = HEAPF64;

function callRuntimeCallbacks(callbacks) {
  while(callbacks.length > 0) {
    var callback = callbacks.shift();
    if (typeof callback == 'function') {
      callback();
      continue;
    }
    var func = callback.func;
    if (typeof func === 'number') {
      if (callback.arg === undefined) {
        Runtime.dynCall('v', func);
      } else {
        Runtime.dynCall('vi', func, [callback.arg]);
      }
    } else {
      func(callback.arg === undefined ? null : callback.arg);
    }
  }
}

var __ATPRERUN__  = []; // functions called before the runtime is initialized
var __ATINIT__    = []; // functions called during startup
var __ATMAIN__    = []; // functions called when main() is to be run
var __ATEXIT__    = []; // functions called during shutdown
var __ATPOSTRUN__ = []; // functions called after the runtime has exited

var runtimeInitialized = false;

function preRun() {
  // compatibility - merge in anything from Module['preRun'] at this time
  if (Module['preRun']) {
    if (typeof Module['preRun'] == 'function') Module['preRun'] = [Module['preRun']];
    while (Module['preRun'].length) {
      addOnPreRun(Module['preRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPRERUN__);
}

function ensureInitRuntime() {
  if (runtimeInitialized) return;
  runtimeInitialized = true;
  callRuntimeCallbacks(__ATINIT__);
}

function preMain() {
  callRuntimeCallbacks(__ATMAIN__);
}

function exitRuntime() {
  callRuntimeCallbacks(__ATEXIT__);
}

function postRun() {
  // compatibility - merge in anything from Module['postRun'] at this time
  if (Module['postRun']) {
    if (typeof Module['postRun'] == 'function') Module['postRun'] = [Module['postRun']];
    while (Module['postRun'].length) {
      addOnPostRun(Module['postRun'].shift());
    }
  }
  callRuntimeCallbacks(__ATPOSTRUN__);
}

function addOnPreRun(cb) {
  __ATPRERUN__.unshift(cb);
}
Module['addOnPreRun'] = Module.addOnPreRun = addOnPreRun;

function addOnInit(cb) {
  __ATINIT__.unshift(cb);
}
Module['addOnInit'] = Module.addOnInit = addOnInit;

function addOnPreMain(cb) {
  __ATMAIN__.unshift(cb);
}
Module['addOnPreMain'] = Module.addOnPreMain = addOnPreMain;

function addOnExit(cb) {
  __ATEXIT__.unshift(cb);
}
Module['addOnExit'] = Module.addOnExit = addOnExit;

function addOnPostRun(cb) {
  __ATPOSTRUN__.unshift(cb);
}
Module['addOnPostRun'] = Module.addOnPostRun = addOnPostRun;

// Tools

// This processes a JS string into a C-line array of numbers, 0-terminated.
// For LLVM-originating strings, see parser.js:parseLLVMString function
function intArrayFromString(stringy, dontAddNull, length /* optional */) {
  var ret = (new Runtime.UTF8Processor()).processJSString(stringy);
  if (length) {
    ret.length = length;
  }
  if (!dontAddNull) {
    ret.push(0);
  }
  return ret;
}
Module['intArrayFromString'] = intArrayFromString;

function intArrayToString(array) {
  var ret = [];
  for (var i = 0; i < array.length; i++) {
    var chr = array[i];
    if (chr > 0xFF) {
      chr &= 0xFF;
    }
    ret.push(String.fromCharCode(chr));
  }
  return ret.join('');
}
Module['intArrayToString'] = intArrayToString;

// Write a Javascript array to somewhere in the heap
function writeStringToMemory(string, buffer, dontAddNull) {
  var array = intArrayFromString(string, dontAddNull);
  var i = 0;
  while (i < array.length) {
    var chr = array[i];
    HEAP8[(((buffer)+(i))|0)]=chr;
    i = i + 1;
  }
}
Module['writeStringToMemory'] = writeStringToMemory;

function writeArrayToMemory(array, buffer) {
  for (var i = 0; i < array.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=array[i];
  }
}
Module['writeArrayToMemory'] = writeArrayToMemory;

function writeAsciiToMemory(str, buffer, dontAddNull) {
  for (var i = 0; i < str.length; i++) {
    HEAP8[(((buffer)+(i))|0)]=str.charCodeAt(i);
  }
  if (!dontAddNull) HEAP8[(((buffer)+(str.length))|0)]=0;
}
Module['writeAsciiToMemory'] = writeAsciiToMemory;

function unSign(value, bits, ignore) {
  if (value >= 0) {
    return value;
  }
  return bits <= 32 ? 2*Math.abs(1 << (bits-1)) + value // Need some trickery, since if bits == 32, we are right at the limit of the bits JS uses in bitshifts
                    : Math.pow(2, bits)         + value;
}
function reSign(value, bits, ignore) {
  if (value <= 0) {
    return value;
  }
  var half = bits <= 32 ? Math.abs(1 << (bits-1)) // abs is needed if bits == 32
                        : Math.pow(2, bits-1);
  if (value >= half && (bits <= 32 || value > half)) { // for huge values, we can hit the precision limit and always get true here. so don't do that
                                                       // but, in general there is no perfect solution here. With 64-bit ints, we get rounding and errors
                                                       // TODO: In i64 mode 1, resign the two parts separately and safely
    value = -2*half + value; // Cannot bitshift half, as it may be at the limit of the bits JS uses in bitshifts
  }
  return value;
}

// check for imul support, and also for correctness ( https://bugs.webkit.org/show_bug.cgi?id=126345 )
if (!Math['imul'] || Math['imul'](0xffffffff, 5) !== -5) Math['imul'] = function imul(a, b) {
  var ah  = a >>> 16;
  var al = a & 0xffff;
  var bh  = b >>> 16;
  var bl = b & 0xffff;
  return (al*bl + ((ah*bl + al*bh) << 16))|0;
};
Math.imul = Math['imul'];


var Math_abs = Math.abs;
var Math_cos = Math.cos;
var Math_sin = Math.sin;
var Math_tan = Math.tan;
var Math_acos = Math.acos;
var Math_asin = Math.asin;
var Math_atan = Math.atan;
var Math_atan2 = Math.atan2;
var Math_exp = Math.exp;
var Math_log = Math.log;
var Math_sqrt = Math.sqrt;
var Math_ceil = Math.ceil;
var Math_floor = Math.floor;
var Math_pow = Math.pow;
var Math_imul = Math.imul;
var Math_fround = Math.fround;
var Math_min = Math.min;

// A counter of dependencies for calling run(). If we need to
// do asynchronous work before running, increment this and
// decrement it. Incrementing must happen in a place like
// PRE_RUN_ADDITIONS (used by emcc to add file preloading).
// Note that you can add dependencies in preRun, even though
// it happens right before run - run will be postponed until
// the dependencies are met.
var runDependencies = 0;
var runDependencyWatcher = null;
var dependenciesFulfilled = null; // overridden to take different actions when all run dependencies are fulfilled

function addRunDependency(id) {
  runDependencies++;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
}
Module['addRunDependency'] = addRunDependency;
function removeRunDependency(id) {
  runDependencies--;
  if (Module['monitorRunDependencies']) {
    Module['monitorRunDependencies'](runDependencies);
  }
  if (runDependencies == 0) {
    if (runDependencyWatcher !== null) {
      clearInterval(runDependencyWatcher);
      runDependencyWatcher = null;
    }
    if (dependenciesFulfilled) {
      var callback = dependenciesFulfilled;
      dependenciesFulfilled = null;
      callback(); // can add another dependenciesFulfilled
    }
  }
}
Module['removeRunDependency'] = removeRunDependency;

Module["preloadedImages"] = {}; // maps url to image data
Module["preloadedAudios"] = {}; // maps url to audio data


var memoryInitializer = null;

// === Body ===
var __ZTVN10__cxxabiv117__class_type_infoE = 382048;
var __ZTVN10__cxxabiv120__si_class_type_infoE = 382088;




STATIC_BASE = 8;

STATICTOP = STATIC_BASE + Runtime.alignMemory(382915);
/* global initializers */ __ATINIT__.push({ func: function() { __GLOBAL__I_a() } });


/* memory initializer */ allocate([0,0,0,0,0,0,0,0,95,112,114,111,102,46,100,97,116,97,0,0,0,0,0,0,119,98,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,32,99,111,117,108,100,32,110,111,116,32,98,101,32,111,112,101,110,101,100,58,32,37,115,0,0,0,0,0,0,0,0,111,102,102,115,101,116,32,118,97,108,117,101,32,102,111,114,32,116,104,101,32,110,101,120,116,32,115,116,101,112,58,32,37,46,49,48,102,0,0,0,99,97,108,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,32,40,115,116,101,112,83,105,122,101,58,32,37,103,41,0,0,0,0,0,0,0,0,82,117,110,110,105,110,103,0,37,115,32,101,118,101,110,116,32,97,116,32,116,105,109,101,32,37,46,49,50,103,0,0,116,105,109,101,0,0,0,0,115,116,97,116,101,0,0,0,68,105,115,97,98,108,101,100,32,116,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,98,101,99,97,117,115,101,32,116,104,101,32,111,117,116,112,117,116,32,102,105,108,101,32,99,111,117,108,100,32,110,111,116,32,98,101,32,103,101,110,101,114,97,116,101,100,58,32,37,115,0,0,0,83,105,109,117,108,97,116,105,111,110,32,99,97,108,108,32,116,101,114,109,105,110,97,116,101,40,41,32,97,116,32,116,105,109,101,32,37,102,10,77,101,115,115,97,103,101,32,58,32,37,115,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,73,110,116,101,103,114,97,116,111,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,109,105,120,101,100,32,115,121,115,116,101,109,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,0,109,111,100,101,108,32,116,101,114,109,105,110,97,116,101,32,124,32,112,114,111,98,97,98,108,121,32,97,32,115,116,114,111,110,103,32,99,111,109,112,111,110,101,110,116,32,115,111,108,118,101,114,32,102,97,105,108,101,100,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,102,108,97,103,115,32,45,108,118,32,76,79,71,95,78,76,83,44,32,76,79,71,95,76,83,46,32,124,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,1,0,0,0,91,18,0,0,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,0,1,0,0,0,30,19,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,32,19,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,33,19,0,0,1,0,0,0,54,19,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,97,19,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,99,19,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,100,19,0,0,1,0,0,0,116,19,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,158,19,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,160,19,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,161,19,0,0,1,0,0,0,169,19,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,218,19,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,220,19,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,221,19,0,0,1,0,0,0,231,19,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,27,20,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,29,20,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,30,20,0,0,1,0,0,0,46,20,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,85,20,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,87,20,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,88,20,0,0,1,0,0,0,96,20,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,10,84,104,101,32,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,82,101,118,111,108,117,116,101,80,108,97,110,97,114,76,111,111,112,67,111,110,115,116,114,97,105,110,116,32,106,111,105,110,116,32,105,115,32,117,115,101,100,32,97,115,32,99,117,116,45,106,111,105,110,116,32,111,102,32,97,10,112,108,97,110,97,114,32,108,111,111,112,46,32,72,111,119,101,118,101,114,44,32,116,104,101,32,114,101,118,111,108,117,116,101,32,106,111,105,110,116,32,105,115,32,110,111,116,32,112,97,114,116,32,111,102,32,97,32,112,108,97,110,97,114,32,108,111,111,112,32,119,104,101,114,101,32,116,104,101,10,97,120,105,115,32,111,102,32,116,104,101,32,114,101,118,111,108,117,116,101,32,106,111,105,110,116,32,40,112,97,114,97,109,101,116,101,114,32,110,41,32,105,115,32,111,114,116,104,111,103,111,110,97,108,32,116,111,32,116,104,101,32,112,111,115,115,105,98,108,101,32,109,111,118,101,109,101,110,116,115,46,10,69,105,116,104,101,114,32,117,115,101,32,105,110,115,116,101,97,100,32,106,111,105,110,116,32,77,117,108,116,105,66,111,100,121,46,74,111,105,110,116,115,46,82,101,118,111,108,117,116,101,32,111,114,32,99,111,114,114,101,99,116,32,116,104,101,10,100,101,102,105,110,105,116,105,111,110,32,111,102,32,116,104,101,32,97,120,101,115,32,118,101,99,116,111,114,115,32,110,32,105,110,32,116,104,101,32,114,101,118,111,108,117,116,101,32,106,111,105,110,116,115,32,111,102,32,116,104,101,32,112,108,97,110,97,114,32,108,111,111,112,46,10,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,112,97,114,97,109,101,116,101,114,32,105,110,110,101,114,68,105,97,109,101,116,101,114,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,112,97,114,97,109,101,116,101,114,32,100,105,97,109,101,116,101,114,0,0,0,0,0,0,112,97,114,97,109,101,116,101,114,32,105,110,110,101,114,87,105,100,116,104,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,112,97,114,97,109,101,116,101,114,32,119,105,100,116,104,0,0,0,0,112,97,114,97,109,101,116,101,114,32,105,110,110,101,114,72,101,105,103,104,116,32,105,115,32,103,114,101,97,116,101,114,32,116,104,97,110,32,112,97,114,97,109,101,116,101,114,32,104,101,105,103,104,116,0,0,232,5,0,0,86,2,0,0,5,0,0,0,93,2,0,0,3,0,0,0,0,0,0,0,200,7,0,0,233,5,0,0,5,0,0,0,234,5,0,0,62,0,0,0,0,0,0,0,200,7,0,0,235,5,0,0,5,0,0,0,236,5,0,0,64,0,0,0,0,0,0,0,200,7,0,0,213,6,0,0,5,0,0,0,214,6,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,1,0,0,0,8,0,0,0,9,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,1,0,0,0,3,0,0,0,13,0,0,0,4,0,0,0,14,0,0,0,6,0,0,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,1,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,69,114,114,111,114,32,119,104,105,108,101,32,105,110,105,116,105,97,108,105,122,101,32,68,97,116,97,0,0,0,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,76,111,111,112,115,46,69,110,103,105,110,101,86,54,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,76,111,111,112,115,0,123,56,99,52,101,56,49,48,102,45,51,100,102,51,45,52,97,48,48,45,56,50,55,54,45,49,55,54,102,97,51,99,57,102,57,101,48,125,0,0,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,69,120,97,109,112,108,101,115,46,76,111,111,112,115,46,69,110,103,105,110,101,86,54,95,105,110,102,111,46,120,109,108,0,0,0,83,116,97,99,107,32,111,118,101,114,102,108,111,119,32,100,101,116,101,99,116,101,100,32,97,110,100,32,119,97,115,32,110,111,116,32,99,97,117,103,104,116,46,10,83,101,110,100,32,117,115,32,97,32,98,117,103,32,114,101,112,111,114,116,32,97,116,32,104,116,116,112,115,58,47,47,116,114,97,99,46,111,112,101,110,109,111,100,101,108,105,99,97,46,111,114,103,47,79,112,101,110,77,111,100,101,108,105,99,97,47,110,101,119,116,105,99,107,101,116,10,32,32,32,32,73,110,99,108,117,100,101,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,116,114,97,99,101,58,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,102,97,105,108,101,100,33,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,52,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,49,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,50,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,208,11,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,77,111,100,101,108,32,101,114,114,111,114,58,32,65,114,103,117,109,101,110,116,32,111,102,32,115,113,114,116,40,99,51,41,32,119,97,115,32,37,103,32,115,104,111,117,108,100,32,98,101,32,62,61,32,48,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,0,0,0,0,0,0,0,99,97,108,108,32,101,120,116,101,114,110,97,108,32,79,98,106,101,99,116,32,67,111,110,115,116,114,117,99,116,111,114,115,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,118,95,114,101,108,32,60,32,48,46,48,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,120,32,60,32,48,46,57,56,55,0,0,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,120,32,62,32,48,46,57,51,0,0,0,0,0,1,0,0,0,93,20,0,0,1,0,0,0,93,20,0,0,1,0,0,0,93,20,0,0,1,0,0,0,43,20,0,0,1,0,0,0,43,20,0,0,1,0,0,0,43,20,0,0,1,0,0,0,228,19,0,0,1,0,0,0,228,19,0,0,1,0,0,0,228,19,0,0,1,0,0,0,166,19,0,0,1,0,0,0,166,19,0,0,1,0,0,0,166,19,0,0,1,0,0,0,113,19,0,0,1,0,0,0,113,19,0,0,1,0,0,0,113,19,0,0,1,0,0,0,51,19,0,0,1,0,0,0,51,19,0,0,1,0,0,0,51,19,0,0,104,15,0,0,112,15,0,0,120,15,0,0,128,15,0,0,136,15,0,0,144,15,0,0,152,15,0,0,160,15,0,0,168,15,0,0,176,15,0,0,184,15,0,0,192,15,0,0,200,15,0,0,208,15,0,0,216,15,0,0,224,15,0,0,232,15,0,0,240,15,0,0,40,13,0,0,72,13,0,0,104,13,0,0,136,13,0,0,168,13,0,0,200,13,0,0,232,13,0,0,8,14,0,0,40,14,0,0,72,14,0,0,104,14,0,0,136,14,0,0,168,14,0,0,200,14,0,0,232,14,0,0,8,15,0,0,40,15,0,0,72,15,0,0,99,104,101,99,107,32,102,111,114,32,100,105,115,99,114,101,116,101,32,99,104,97,110,103,101,115,0,0,0,0,0,0,36,68,69,82,46,102,105,108,116,101,114,46,120,91,49,93,0,0,0,0,0,0,0,0,36,68,69,82,46,102,105,108,116,101,114,46,120,91,50,93,0,0,0,0,0,0,0,0,168,16,0,0,192,16,0,0,117,112,100,97,116,105,110,103,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,91,37,100,93,58,32,37,115,32,61,32,37,103,0,0,0,1,0,0,0,2,0,0,0,102,105,108,116,101,114,46,97,108,112,104,97,0,0,0,0,1,0,0,0,5,0,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,35,0,0,0,1,0,0,0,51,0,0,0,1,0,0,0,55,0,0,0,1,0,0,0,59,0,0,0,1,0,0,0,85,0,0,0,1,0,0,0,101,0,0,0,1,0,0,0,105,0,0,0,1,0,0,0,109,0,0,0,1,0,0,0,135,0,0,0,1,0,0,0,151,0,0,0,1,0,0,0,155,0,0,0,1,0,0,0,159,0,0,0,1,0,0,0,185,0,0,0,1,0,0,0,201,0,0,0,1,0,0,0,205,0,0,0,1,0,0,0,209,0,0,0,1,0,0,0,235,0,0,0,1,0,0,0,251,0,0,0,1,0,0,0,255,0,0,0,1,0,0,0,3,1,0,0,1,0,0,0,29,1,0,0,1,0,0,0,45,1,0,0,1,0,0,0,9,2,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,10,2,0,0,1,0,0,0,12,2,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,44,2,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,45,2,0,0,1,0,0,0,47,2,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,78,2,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,79,2,0,0,1,0,0,0,81,2,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,116,2,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,117,2,0,0,1,0,0,0,119,2,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,154,2,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,155,2,0,0,1,0,0,0,157,2,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,196,2,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,76,0,0,0,0,1,0,0,0,197,2,0,0,1,0,0,0,199,2,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,86,0,0,0,0,1,0,0,0,209,2,0,0,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,0,1,0,0,0,89,3,0,0,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,96,3,0,0,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,121,3,0,0,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,128,3,0,0,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,153,3,0,0,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,160,3,0,0,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,107,0,0,0,0,1,0,0,0,225,4,0,0,102,105,108,116,101,114,46,119,0,0,0,0,0,0,0,0,1,0,0,0,226,4,0,0,1,0,0,0,229,4,0,0,1,0,0,0,232,4,0,0,1,0,0,0,238,4,0,0,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,2,0,0,0,96,24,0,0,104,24,0,0,0,0,0,0,1,0,0,0,56,24,0,0,64,24,0,0,0,0,0,0,1,0,0,0,94,5,0,0,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,186,5,0,0,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,208,5,0,0,1,0,0,0,211,5,0,0,1,0,0,0,217,5,0,0,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,0,6,0,0,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,92,6,0,0,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,114,6,0,0,1,0,0,0,117,6,0,0,1,0,0,0,123,6,0,0,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,162,6,0,0,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,254,6,0,0,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,20,7,0,0,1,0,0,0,23,7,0,0,1,0,0,0,29,7,0,0,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,68,7,0,0,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,160,7,0,0,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,182,7,0,0,1,0,0,0,185,7,0,0,1,0,0,0,191,7,0,0,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,230,7,0,0,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,66,8,0,0,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,88,8,0,0,1,0,0,0,91,8,0,0,1,0,0,0,97,8,0,0,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,136,8,0,0,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,228,8,0,0,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,250,8,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,255,8,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,117,112,100,97,116,105,110,103,32,109,105,110,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,109,97,120,45,118,97,108,117,101,115,0,0,0,0,0,117,112,100,97,116,105,110,103,32,110,111,109,105,110,97,108,45,118,97,108,117,101,115,0,117,112,100,97,116,105,110,103,32,115,116,97,114,116,45,118,97,108,117,101,115,0,0,0,37,115,40,115,116,97,114,116,61,37,103,41,0,0,0,0,1,0,0,0,86,31,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,70,114,97,109,101,68,105,97,109,101,116,101,114,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,93,31,0,0,119,111,114,108,100,46,100,101,102,97,117,108,116,87,105,100,116,104,70,114,97,99,116,105,111,110,0,0,0,0,0,0,1,0,0,0,106,31,0,0,2,0,0,0,24,64,4,0,32,64,4,0,0,0,0,0,1,0,0,0,240,63,4,0,248,63,4,0,0,0,0,0,1,0,0,0,136,31,0,0,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,176,31,0,0,1,0,0,0,16,32,0,0,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,54,32,0,0,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,62,32,0,0,1,0,0,0,68,32,0,0,1,0,0,0,71,32,0,0,1,0,0,0,74,32,0,0,1,0,0,0,85,32,0,0,1,0,0,0,115,32,0,0,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,156,32,0,0,1,0,0,0,252,32,0,0,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,34,33,0,0,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,42,33,0,0,1,0,0,0,48,33,0,0,1,0,0,0,51,33,0,0,1,0,0,0,54,33,0,0,1,0,0,0,65,33,0,0,1,0,0,0,95,33,0,0,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,136,33,0,0,1,0,0,0,232,33,0,0,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,14,34,0,0,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,22,34,0,0,1,0,0,0,28,34,0,0,1,0,0,0,31,34,0,0,1,0,0,0,34,34,0,0,1,0,0,0,45,34,0,0,1,0,0,0,75,34,0,0,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,116,34,0,0,1,0,0,0,212,34,0,0,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,250,34,0,0,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,2,35,0,0,1,0,0,0,8,35,0,0,1,0,0,0,11,35,0,0,1,0,0,0,14,35,0,0,1,0,0,0,25,35,0,0,1,0,0,0,55,35,0,0,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,96,35,0,0,1,0,0,0,192,35,0,0,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,230,35,0,0,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,238,35,0,0,1,0,0,0,244,35,0,0,1,0,0,0,247,35,0,0,1,0,0,0,250,35,0,0,1,0,0,0,5,36,0,0,1,0,0,0,35,36,0,0,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,76,36,0,0,1,0,0,0,172,36,0,0,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,209,36,0,0,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,0,0,0,0,0,0,0,1,0,0,0,217,36,0,0,1,0,0,0,223,36,0,0,1,0,0,0,226,36,0,0,1,0,0,0,229,36,0,0,1,0,0,0,233,36,0,0,102,105,108,116,101,114,46,97,108,112,104,97,0,0,0,0,0,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,102,105,108,116,101,114,46,105,110,105,116,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,102,105,108,116,101,114,46,105,110,105,116,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,78,111,73,110,105,116,32,97,110,100,32,102,105,108,116,101,114,46,105,110,105,116,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,66,108,111,99,107,115,46,84,121,112,101,115,46,73,110,105,116,46,73,110,105,116,105,97,108,79,117,116,112,117,116,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,66,108,111,99,107,115,47,67,111,110,116,105,110,117,111,117,115,46,109,111,0,0,0,0,0,0,0,104,30,0,0,127,6,0,0,5,0,0,0,130,6,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,50,46,119,95,110,111,109,105,110,97,108,32,62,61,32,49,101,45,49,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,82,111,116,97,116,105,111,110,97,108,46,109,111,0,0,0,0,64,31,0,0,159,24,0,0,7,0,0,0,160,24,0,0,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,108,111,97,100,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,64,31,0,0,253,8,0,0,7,0,0,0,255,8,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,108,111,97,100,46,74,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,108,111,97,100,46,74,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,64,31,0,0,252,8,0,0,7,0,0,0,252,8,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,76,111,111,112,115,47,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,80,97,114,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE);
/* memory initializer */ allocate([101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+10240);
/* memory initializer */ allocate([99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+20480);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+30720);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,74,111,105,110,116,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+40960);
/* memory initializer */ allocate([108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+51200);
/* memory initializer */ allocate([101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+61440);
/* memory initializer */ allocate([51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+71680);
/* memory initializer */ allocate([111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,104,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+81920);
/* memory initializer */ allocate([105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+92160);
/* memory initializer */ allocate([32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+102400);
/* memory initializer */ allocate([100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+112640);
/* memory initializer */ allocate([121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+122880);
/* memory initializer */ allocate([110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+133120);
/* memory initializer */ allocate([107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+143360);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+153600);
/* memory initializer */ allocate([114,50,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+163840);
/* memory initializer */ allocate([83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,56,33,0,0,18,1,0,0,5,0,0,0,18,1,0,0,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,166,1,0,0,5,0,0,0,169,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,161,1,0,0,5,0,0,0,165,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,115,101,113,117,101,110,99,101,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,32,34,0,0,123,1,0,0,5,0,0,0,127,1,0,0,102,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,82,111,116,97,116,105,111,110,65,120,105,115,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,114,111,116,97,116,105,111,110,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,82,111,116,97,116,105,111,110,84,121,112,101,115,46,80,108,97,110,97,114,82,111,116,97,116,105,111,110,83,101,113,117,101,110,99,101,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,102,1,0,0,5,0,0,0,104,1,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+174080);
/* memory initializer */ allocate([97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+184320);
/* memory initializer */ allocate([49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,179,5,0,0,5,0,0,0,179,5,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,175,5,0,0,5,0,0,0,176,5,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,106,5,0,0,5,0,0,0,106,5,0,0,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,177,5,0,0,5,0,0,0,178,5,0,0,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,104,5,0,0,5,0,0,0,105,5,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,105,110,110,101,114,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,34,0,0,109,5,0,0,5,0,0,0,110,5,0,0,65,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,34,0,0,170,5,0,0,5,0,0,0,173,5,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,34,0,0,140,5,0,0,5,0,0,0,142,5,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,34,0,0,111,5,0,0,5,0,0,0,112,5,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,105,110,110,101,114,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,107,5,0,0,5,0,0,0,108,5,0,0,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+194560);
/* memory initializer */ allocate([32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,102,114,97,109,101,84,114,97,110,115,108,97,116,105,111,110,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,225,2,0,0,5,0,0,0,229,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,214,2,0,0,5,0,0,0,218,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,34,0,0,248,2,0,0,5,0,0,0,251,2,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,34,0,0,190,2,0,0,5,0,0,0,192,2,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,50,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,34,0,0,165,2,0,0,5,0,0,0,167,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,34,0,0,162,2,0,0,5,0,0,0,164,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,49,32,62,61,32,45,57,46,57,57,57,57,57,57,57,57,57,57,57,57,57,57,57,101,43,53,57,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,32,34,0,0,159,2,0,0,5,0,0,0,161,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,51,51,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,156,2,0,0,5,0,0,0,158,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,50,50,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,153,2,0,0,5,0,0,0,155,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,73,95,49,49,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,150,2,0,0,5,0,0,0,152,2,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,149,2,0,0,5,0,0,0,149,2,0,0,61,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,160,6,0,0,5,0,0,0,160,6,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,111,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,111,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,153,6,0,0,5,0,0,0,154,6,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,114,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,150,6,0,0,5,0,0,0,150,6,0,0,71,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,105,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,109,105,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,155,6,0,0,5,0,0,0,156,6,0,0,45,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,100,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,32,34,0,0,80,6,0,0,5,0,0,0,81,6,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,105,110,110,101,114,82,97,100,105,117,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,151,6,0,0,5,0,0,0,152,6,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,97,110,103,108,101,83,116,97,116,101,115,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,144,6,0,0,5,0,0,0,147,6,0,0,29,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,51,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,50,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,62,61,32,49,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,115,101,113,117,101,110,99,101,95,115,116,97,114,116,91,49,93,32,60,61,32,51,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,114,6,0,0,5,0,0,0,116,6,0,0,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,100,101,110,115,105,116,121,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,84,6,0,0,5,0,0,0,85,6,0,0,75,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,105,110,110,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,82,6,0,0,5,0,0,0,83,6,0,0,68,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,104,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,32,34,0,0,195,0,0,0,5,0,0,0,198,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,119,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,190,0,0,0,5,0,0,0,194,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,160,0,0,15,2,0,0,5,0,0,0,17,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,248,160,0,0,12,2,0,0,5,0,0,0,14,2,0,0,73,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,50,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,72,101,105,103,104,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,248,160,0,0,33,0,0,0,5,0,0,0,34,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,87,105,100,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,248,160,0,0,30,0,0,0,5,0,0,0,32,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,248,160,0,0,41,0,0,0,5,0,0,0,42,0,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,112,97,99,107,97,103,101,46,109,111,0,0,0,0,0,112,58,3,0,189,4,0,0,3,0,0,0,193,4,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,112,58,3,0,167,4,0,0,3,0,0,0,169,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,58,3,0,164,4,0,0,3,0,0,0,166,4,0,0,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,109,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,58,3,0,243,4,0,0,3,0,0,0,245,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,78,95,116,111,95,109,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,58,3,0,240,4,0,0,3,0,0,0,242,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,100,101,102,97,117,108,116,83,112,101,99,117,108,97,114,67,111,101,102,102,105,99,105,101,110,116,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,58,3,0,237,4,0,0,3,0,0,0,239,4,0,0,40,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,112,58,3,0,198,4,0,0,3,0,0,0,202,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,109,117,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,109,117,101,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,112,58,3,0,156,4,0,0,3,0,0,0,160,4,0,0,108,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,62,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,78,111,71,114,97,118,105,116,121,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,84,121,112,101,32,60,61,32,77,111,100,101,108,105,99,97,46,77,101,99,104,97,110,105,99,115,46,77,117,108,116,105,66,111,100,121,46,84,121,112,101,115,46,71,114,97,118,105,116,121,84,121,112,101,115,46,80,111,105,110,116,71,114,97,118,105,116,121,32,104,97,115,32,118,97,108,117,101,58,32,0,112,58,3,0,148,4,0,0,3,0,0,0,149,4,0,0,155,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,68,105,97,109,101,116,101,114,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,248,160,0,0,247,0,0,0,5,0,0,0,249,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,76,101,110,103,116,104,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,160,0,0,244,0,0,0,5,0,0,0,246,0,0,0,90,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,101,97,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,101,97,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,62,61,32,83,116,97,116,101,83,101,108,101,99,116,46,110,101,118,101,114,32,97,110,100,32,98,101,97,114,105,110,103,46,115,116,97,116,101,83,101,108,101,99,116,32,60,61,32,83,116,97,116,101,83,101,108,101,99,116,46,97,108,119,97,121,115,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,160,0,0,1,1,0,0,5,0,0,0,2,1,0,0,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,77,105], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+204800);
/* memory initializer */ allocate([100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,54,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+215040);
/* memory initializer */ allocate([100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,53,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+225280);
/* memory initializer */ allocate([108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,52,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+235520);
/* memory initializer */ allocate([111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,51,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+245760);
/* memory initializer */ allocate([51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,50,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+256000);
/* memory initializer */ allocate([86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,65,110,103,108,101,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,73,110,99,108,105,110,97,116,105,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,182,1,0,0,5,0,0,0,187,1,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,77,105,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,49,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,51,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,50,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,114,97,110,107,52,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,77,111,117,110,116,105,110,103,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,82,111,100,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,113,5,0,0,5,0,0,0,114,5,0,0,79,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,32,34,0,0,86,6,0,0,5,0,0,0,88,6,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,80,105,115,116,111,110,46,98,111,100,121,46,115,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,32,34,0,0,219,2,0,0,5,0,0,0,224,2,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,84,111,112,46,99,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,32,34,0,0,205,0,0,0,5,0,0,0,210,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,49,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,248,160,0,0,18,2,0,0,5,0,0,0,20,2,0,0,93,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,66,50,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+266248);
/* memory initializer */ allocate([111,120,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,99,121,108,105,110,100,101,114,49,46,67,121,108,105,110,100,101,114,46,98,111,120,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,248,160,0,0,35,0,0,0,5,0,0,0,37,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,98,101,97,114,105,110,103,46,99,121,108,105,110,100,101,114,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,248,160,0,0,250,0,0,0,5,0,0,0,252,0,0,0,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,97,120,105,115,67,111,108,111,114,95,120,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,112,58,3,0,172,4,0,0,3,0,0,0,174,4,0,0,133,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,83,112,104,101,114,101,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,112,58,3,0,203,4,0,0,3,0,0,0,206,4,0,0,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,51,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,50,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,62,61,32,48,32,97,110,100,32,119,111,114,108,100,46,103,114,97,118,105,116,121,65,114,114,111,119,67,111,108,111,114,91,49,93,32,60,61,32,50,53,53,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,112,58,3,0,194,4,0,0,3,0,0,0,197,4,0,0,101,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,3,0,0,0,3,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,103,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,47,104,111,109,101,47,109,97,114,115,106,47,116,114,117,110,107,47,98,117,105,108,100,47,108,105,98,47,111,109,108,105,98,114,97,114,121,47,77,111,100,101,108,105,99,97,32,51,46,50,46,49,47,77,101,99,104,97,110,105,99,115,47,77,117,108,116,105,66,111,100,121,47,69,120,97,109,112,108,101,115,47,76,111,111,112,115,47,85,116,105,108,105,116,105,101,115,46,109,111,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,49,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,50,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,51,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,52,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,53,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,100,101,110,115,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,224,64,4,0,29,1,0,0,5,0,0,0,29,1,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,86,97,114,105,97,98,108,101,32,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,84,32,111,117,116,32,111,102,32,91,109,105,110,44,32,109,97,120,93,32,105,110,116,101,114,118,97,108,58,32,99,121,108,105,110,100,101,114,54,46,103,97,115,70,111,114,99,101,46,84,32,62,61,32,48,46,48,32,104,97,115,32,118,97,108,117,101,58,32,0,0,0,0,0,0,0,224,64,4,0,33,1,0,0,5,0,0,0,33,1,0,0,21,0,0,0,0,0,0,0,109,111,100,101,108,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,76,111,111,112,115,95,69,110,103,105,110,101,86,54,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,110,32,61,32,52,59,32,47,47,32,115,116,97,116,101,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,107,32,61,32,48,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,105,110,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,108,32,61,32,51,59,32,47,47,32,116,111,112,45,108,101,118,101,108,32,111,117,116,112,117,116,115,32,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,120,48,91,52,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,117,48,91,48,93,32,61,32,123,37,115,125,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,65,91,52,44,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,66,91,52,44,48,93,32,61,32,122,101,114,111,115,40,52,44,48,41,59,37,115,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,67,91,51,44,52,93,32,61,32,91,37,115,93,59,10,32,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,68,91,51,44,48,93,32,61,32,122,101,114,111,115,40,51,44,48,41,59,37,115,10,32,32,82,101,97,108,32,120,91,52,93,40,115,116,97,114,116,61,120,48,41,59,10,32,32,105,110,112,117,116,32,82,101,97,108,32,117,91,48,93,59,10,32,32,111,117,116,112,117,116,32,82,101,97,108,32,121,91,51,93,59,10,10,32,32,82,101,97,108,32,120,95,80,102,105,108,116,101,114,80,120,108,66,49,114,66,32,61,32,120,91,49,93,59,10,32,32,82,101,97,108,32,120,95,80,102,105,108,116,101,114,80,120,108,66,50,114,66,32,61,32,120,91,50,93,59,10,32,32,82,101,97,108,32,120,95,80,108,111,97,100,80,119,32,61,32,120,91,51,93,59,10,32,32,82,101,97,108,32,120,95,80,108,111,97,100,80,112,104,105,32,61,32,120,91,52,93,59,10,32,32,32,32,32,32,82,101,97,108,32,121,95,80,102,105,108,116,101,114,101,100,69,110,103,105,110,101,84,111,114,113,117,101,32,61,32,121,91,49,93,59,10,32,32,82,101,97,108,32,121,95,80,101,110,103,105,110,101,84,111,114,113,117,101,32,61,32,121,91,50,93,59,10,32,32,82,101,97,108,32,121,95,80,101,110,103,105,110,101,83,112,101,101,100,95,114,112,109,32,61,32,121,91,51,93,59,10,32,32,10,101,113,117,97,116,105,111,110,10,32,32,100,101,114,40,120,41,32,61,32,65,32,42,32,120,32,43,32,66,32,42,32,117,59,10,32,32,121,32,61,32,67,32,42,32,120,32,43,32,68,32,42,32,117,59,10,101,110,100,32,108,105,110,101,97,114,95,77,111,100,101,108,105,99,97,95,77,101,99,104,97,110,105,99,115,95,77,117,108,116,105,66,111,100,121,95,69,120,97,109,112,108,101,115,95,76,111,111,112,115,95,69,110,103,105,110,101,86,54,59,10,0,0,0,0,0,0,68,71,69,82,32,32,0,0,78,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,68,71,69,77,77,32,0,0,76,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,84,82,83,77,32,0,0,68,71,69,83,86,32,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,68,71,69,84,70,50,0,0,83,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,240,191,68,71,69,84,82,70,0,0,1,0,0,0,0,0,0,0,32,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,240,191,78,0,0,0,0,0,0,0,84,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,68,71,69,84,82,83,0,0,1,0,0,0,0,0,0,0,76,101,102,116,0,0,0,0,76,111,119,101,114,0,0,0,78,111,32,116,114,97,110,115,112,111,115,101,0,0,0,0,85,110,105,116,0,0,0,0,0,0,0,0,0,0,240,63,85,112,112,101,114,0,0,0,78,111,110,45,117,110,105,116,0,0,0,0,0,0,0,0,84,114,97,110,115,112,111,115,101,0,0,0,0,0,0,0,255,255,255,255,0,0,0,0,71,69,0,0,0,0,0,0,84,82,70,0,0,0,0,0,81,82,70,0,0,0,0,0,82,81,70,0,0,0,0,0,76,81,70,0,0,0,0,0,81,76,70,0,0,0,0,0,72,82,68,0,0,0,0,0,66,82,68,0,0,0,0,0,84,82,73,0,0,0,0,0,80,79,0,0,0,0,0,0,83,89,0,0,0,0,0,0,84,82,68,0,0,0,0,0,71,83,84,0,0,0,0,0,72,69,0,0,0,0,0,0,79,82,0,0,0,0,0,0,81,82,0,0,0,0,0,0,82,81,0,0,0,0,0,0,76,81,0,0,0,0,0,0,81,76,0,0,0,0,0,0,72,82,0,0,0,0,0,0,84,82,0,0,0,0,0,0,66,82,0,0,0,0,0,0,85,78,0,0,0,0,0,0,71,66,0,0,0,0,0,0,80,66,0,0,0,0,0,0,76,65,0,0,0,0,0,0,85,85,77,0,0,0,0,0,83,84,0,0,0,0,0,0,69,66,90,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,76,4,0,184,76,4,0,200,76,4,0,224,76,4,0,0,77,4,0,16,77,4,0,40,77,4,0,56,77,4,0,80,77,4,0,112,77,4,0,152,77,4,0,176,77,4,0,208,77,4,0,232,77,4,0,16,78,4,0,48,78,4,0,96,78,4,0,144,78,4,0,168,78,4,0,224,78,4,0,248,78,4,0,40,79,4,0,72,79,4,0,128,79,4,0,168,79,4,0,224,79,4,0,16,80,4,0,32,80,4,0,64,80,4,0,104,80,4,0,136,80,4,0,176,80,4,0,216,80,4,0,240,80,4,0,8,81,4,0,24,81,4,0,48,81,4,0,96,81,4,0,176,81,4,0,240,81,4,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,115,121,110,116,97,120,32,101,114,114,111,114,0,0,0,0,110,111,32,101,108,101,109,101,110,116,32,102,111,117,110,100,0,0,0,0,0,0,0,0,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,32,40,105,110,118,97,108,105,100,32,116,111,107,101,110,41,0,117,110,99,108,111,115,101,100,32,116,111,107,101,110,0,0,112,97,114,116,105,97,108,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,109,105,115,109,97,116,99,104,101,100,32,116,97,103,0,0,100,117,112,108,105,99,97,116,101,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,106,117,110,107,32,97,102,116,101,114,32,100,111,99,117,109,101,110,116,32,101,108,101,109,101,110,116,0,0,0,0,0,105,108,108,101,103,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,110,116,105,116,121,0,0,0,0,0,0,0,0,114,101,99,117,114,115,105,118,101,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,0,0,0,97,115,121,110,99,104,114,111,110,111,117,115,32,101,110,116,105,116,121,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,105,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,110,117,109,98,101,114,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,98,105,110,97,114,121,32,101,110,116,105,116,121,0,0,0,0,0,0,114,101,102,101,114,101,110,99,101,32,116,111,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,105,110,32,97,116,116,114,105,98,117,116,101,0,0,0,0,0,0,0,88,77,76,32,111,114,32,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,97,116,32,115,116,97,114,116,32,111,102,32,101,110,116,105,116,121,0,0,117,110,107,110,111,119,110,32,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,101,110,99,111,100,105,110,103,32,115,112,101,99,105,102,105,101,100,32,105,110,32,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,105,115,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,117,110,99,108,111,115,101,100,32,67,68,65,84,65,32,115,101,99,116,105,111,110,0,0,101,114,114,111,114,32,105,110,32,112,114,111,99,101,115,115,105,110,103,32,101,120,116,101,114,110,97,108,32,101,110,116,105,116,121,32,114,101,102,101,114,101,110,99,101,0,0,0,100,111,99,117,109,101,110,116,32,105,115,32,110,111,116,32,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,117,110,101,120,112,101,99,116,101,100,32,112,97,114,115,101,114,32,115,116,97,116,101,32,45,32,112,108,101,97,115,101,32,115,101,110,100,32,97,32,98,117,103,32,114,101,112,111,114,116,0,0,0,0,0,0,101,110,116,105,116,121,32,100,101,99,108,97,114,101,100,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,113,117,101,115,116,101,100,32,102,101,97,116,117,114,101,32,114,101,113,117,105,114,101,115,32,88,77,76,95,68,84,68,32,115,117,112,112,111,114,116,32,105,110,32,69,120,112,97,116,0,0,0,0,0,99,97,110,110,111,116,32,99,104,97,110,103,101,32,115,101,116,116,105,110,103,32,111,110,99,101,32,112,97,114,115,105,110,103,32,104,97,115,32,98,101,103,117,110,0,0,0,0,117,110,98,111,117,110,100,32,112,114,101,102,105,120,0,0,109,117,115,116,32,110,111,116,32,117,110,100,101,99,108,97,114,101,32,112,114,101,102,105,120,0,0,0,0,0,0,0,105,110,99,111,109,112,108,101,116,101,32,109,97,114,107,117,112,32,105,110,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,88,77,76,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,116,101,120,116,32,100,101,99,108,97,114,97,116,105,111,110,32,110,111,116,32,119,101,108,108,45,102,111,114,109,101,100,0,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,99,104,97,114,97,99,116,101,114,40,115,41,32,105,110,32,112,117,98,108,105,99,32,105,100,0,0,0,0,0,0,0,112,97,114,115,101,114,32,115,117,115,112,101,110,100,101,100,0,0,0,0,0,0,0,0,112,97,114,115,101,114,32,110,111,116,32,115,117,115,112,101,110,100,101,100,0,0,0,0,112,97,114,115,105,110,103,32,97,98,111,114,116,101,100,0,112,97,114,115,105,110,103,32,102,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,99,97,110,110,111,116,32,115,117,115,112,101,110,100,32,105,110,32,101,120,116,101,114,110,97,108,32,112,97,114,97,109,101,116,101,114,32,101,110,116,105,116,121,0,0,0,0,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,41,32,109,117,115,116,32,110,111,116,32,98,101,32,117,110,100,101,99,108,97,114,101,100,32,111,114,32,98,111,117,110,100,32,116,111,32,97,110,111,116,104,101,114,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,0,114,101,115,101,114,118,101,100,32,112,114,101,102,105,120,32,40,120,109,108,110,115,41,32,109,117,115,116,32,110,111,116,32,98,101,32,100,101,99,108,97,114,101,100,32,111,114,32,117,110,100,101,99,108,97,114,101,100,0,0,0,0,0,0,112,114,101,102,105,120,32,109,117,115,116,32,110,111,116,32,98,101,32,98,111,117,110,100,32,116,111,32,111,110,101,32,111,102,32,116,104,101,32,114,101,115,101,114,118,101,100,32,110,97,109,101,115,112,97,99,101,32,110,97,109,101,115,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,50,48,48,48,47,120,109,108,110,115,47,0,0,0,35,0,0,0,0,0,0,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,89,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,78,79,84,65,84,73,79,78,40,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,120,109,108,61,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,103,47,88,77,76,47,49,57,57,56,47,110,97,109,101,115,112,97,99,101,0,0,0,0,0,0,0,0,2,3,4,5,6,7,8,0,0,9,10,11,12,13,14,15,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,4,254,255,255,135,254,255,255,7,0,0,0,0,0,0,0,0,255,255,127,255,255,255,127,255,255,255,255,255,255,255,243,127,254,253,255,255,255,255,255,127,255,255,255,255,255,255,255,255,15,224,255,255,255,255,49,252,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,3,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,0,0,0,0,0,0,0,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,254,7,0,0,0,0,254,255,255,255,255,255,255,255,255,124,255,127,47,0,96,0,0,0,224,255,255,255,255,255,255,35,0,0,0,255,3,0,0,0,224,159,249,255,255,253,197,3,0,0,0,176,3,0,3,0,224,135,249,255,255,253,109,3,0,0,0,94,0,0,28,0,224,175,251,255,255,253,237,35,0,0,0,0,1,0,0,0,224,159,249,255,255,253,205,35,0,0,0,176,3,0,0,0,224,199,61,214,24,199,191,3,0,0,0,0,0,0,0,0,224,223,253,255,255,253,239,3,0,0,0,0,3,0,0,0,224,223,253,255,255,253,239,3,0,0,0,64,3,0,0,0,224,223,253,255,255,253,255,3,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,13,0,63,0,0,0,0,0,0,0,150,37,240,254,174,108,13,32,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,254,255,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,63,0,255,255,255,255,127,0,237,218,7,0,0,0,0,80,1,80,49,130,171,98,44,0,0,0,0,64,0,201,128,245,7,0,0,0,0,8,1,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,3,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,64,76,0,0,0,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,254,3,0,0,254,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,7,224,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,255,7,254,255,255,135,254,255,255,7,0,0,0,0,0,0,128,0,255,255,127,255,255,255,127,255,255,255,255,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,1,0,248,3,0,3,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,3,0,0,0,192,215,255,255,251,255,255,255,255,127,127,84,253,255,15,0,254,223,255,255,255,255,255,255,255,255,254,223,255,255,255,255,123,0,255,255,255,255,255,255,159,25,255,255,255,207,63,3,0,0,0,0,0,0,254,255,255,255,127,2,254,255,255,255,127,0,254,255,251,255,255,187,22,0,255,255,255,7,7,0,0,0,0,0,254,255,255,7,255,255,7,0,255,3,255,255,255,255,255,255,255,255,255,124,255,127,239,255,255,61,255,3,238,255,255,255,255,255,255,243,255,63,30,255,207,255,0,0,238,159,249,255,255,253,197,211,159,57,128,176,207,255,3,0,228,135,249,255,255,253,109,211,135,57,0,94,192,255,31,0,238,175,251,255,255,253,237,243,191,59,0,0,193,255,0,0,238,159,249,255,255,253,205,243,143,57,192,176,195,255,0,0,236,199,61,214,24,199,191,195,199,61,128,0,128,255,0,0,238,223,253,255,255,253,239,195,223,61,96,0,195,255,0,0,236,223,253,255,255,253,239,195,223,61,96,64,195,255,0,0,236,223,253,255,255,253,255,195,207,61,128,0,195,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,255,255,255,255,127,255,7,255,127,255,3,0,0,0,0,150,37,240,254,174,108,255,59,95,63,255,3,0,0,0,0,0,0,0,3,255,3,160,194,255,254,255,255,255,3,254,255,223,15,191,254,255,63,254,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,31,2,0,0,0,160,0,0,0,254,255,62,0,254,255,255,255,255,255,255,255,255,255,31,102,254,255,255,255,255,255,255,255,255,255,255,119,25,3,26,27,28,29,30,0,0,31,32,33,34,35,36,37,16,17,0,0,0,0,0,0,0,0,0,0,0,0,18,19,38,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,39,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,23,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,85,84,70,45,49,54,0,0,32,96,4,0,176,94,4,0,56,93,4,0,192,91,4,0,192,91,4,0,72,90,4,0,56,93,4,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,67,68,65,84,65,91,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+276488);
/* memory initializer */ allocate([19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,23,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,232,106,4,0,112,103,4,0,0,102,4,0,144,100,4,0,144,100,4,0,32,99,4,0,0,102,4,0,0,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,2,0,0,0,7,0,0,0,7,0,0,0,8,0,0,0,8,0,0,0,9,0,0,0,3,0,0,0,1,0,0,0,9,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,4,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,17,0,0,0,12,0,0,0,5,0,0,0,2,0,0,0,18,0,0,0,3,0,0,0,4,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,7,0,0,0,8,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,118,101,114,115,105,111,110,0,101,110,99,111,100,105,110,103,0,0,0,0,0,0,0,0,115,116,97,110,100,97,108,111,110,101,0,0,0,0,0,0,121,101,115,0,0,0,0,0,110,111,0,0,0,0,0,0,48,105,4,0,64,105,4,0,80,105,4,0,32,90,4,0,88,105,4,0,104,105,4,0,73,83,79,45,56,56,53,57,45,49,0,0,0,0,0,0,85,83,45,65,83,67,73,73,0,0,0,0,0,0,0,0,85,84,70,45,56,0,0,0,85,84,70,45,49,54,66,69,0,0,0,0,0,0,0,0,85,84,70,45,49,54,76,69,0,0,0,0,0,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,5,0,0,0,6,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,7,7,7,7,7,0,0,0,0,0,0,0,0,0,1,1,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,18,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,6,0,0,0,25,0,0,0,13,0,0,0,14,0,0,0,26,0,0,0,15,0,0,0,7,0,0,0,3,0,0,0,27,0,0,0,9,0,0,0,8,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,10,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,21,16,12,19,28,30,3,13,31,32,33,34,35,27,26,17,25,25,25,25,25,25,25,25,25,25,22,18,2,14,11,15,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,20,28,4,28,22,28,24,24,24,24,24,24,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,36,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,22,28,28,28,28,28,28,28,28,28,28,22,28,26,28,28,22,28,28,28,28,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,22,28,22,22,22,22,22,22,22,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,78,84,73,84,89,0,0,65,84,84,76,73,83,84,0,69,76,69,77,69,78,84,0,78,79,84,65,84,73,79,78,0,0,0,0,0,0,0,0,83,89,83,84,69,77,0,0,80,85,66,76,73,67,0,0,69,77,80,84,89,0,0,0,65,78,89,0,0,0,0,0,80,67,68,65,84,65,0,0,200,108,4,0,208,108,4,0,216,108,4,0,224,108,4,0,88,108,4,0,232,108,4,0,248,108,4,0,0,109,4,0,67,68,65,84,65,0,0,0,73,68,0,0,0,0,0,0,73,68,82,69,70,0,0,0,73,68,82,69,70,83,0,0,69,78,84,73,84,73,69,83,0,0,0,0,0,0,0,0,78,77,84,79,75,69,78,0,78,77,84,79,75,69,78,83,0,0,0,0,0,0,0,0,73,77,80,76,73,69,68,0,82,69,81,85,73,82,69,68,0,0,0,0,0,0,0,0,70,73,88,69,68,0,0,0,78,68,65,84,65,0,0,0,73,78,67,76,85,68,69,0,73,71,78,79,82,69,0,0,68,79,67,84,89,80,69,0,0,0,0,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,105,115,32,78,85,76,76,33,10,0,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,97,114,101,32,60,32,48,33,10,0,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,115,32,115,105,122,101,115,32,97,114,101,32,78,85,76,76,33,10,0,98,97,115,101,95,97,114,114,97,121,46,99,58,32,97,114,114,97,121,32,100,105,109,101,110,115,105,111,110,32,115,105,122,101,32,102,111,114,32,100,105,109,101,110,115,105,111,110,32,37,100,32,105,115,32,37,100,32,60,32,48,33,10,0,117,116,105,108,47,98,97,115,101,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,97,45,62,110,100,105,109,115,32,33,61,32,98,45,62,110,100,105,109,115,44,32,37,100,32,33,61,32,37,100,10,0,97,45,62,100,105,109,95,115,105,122,101,91,37,100,93,32,33,61,32,98,45,62,100,105,109,95,115,105,122,101,91,37,100,93,44,32,37,100,32,33,61,32,37,100,10,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,99,108,111,110,101,95,98,97,115,101,95,97,114,114,97,121,95,115,112,101,99,0,0,0,100,101,115,116,45,62,100,105,109,95,115,105,122,101,0,0,0,0,0,0,0,0,0,0,200,110,4,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,68,105,109,101,110,115,105,111,110,32,37,100,32,104,97,115,32,98,111,117,110,100,115,32,49,46,46,37,100,44,32,103,111,116,32,97,114,114,97,121,32,115,117,98,115,99,114,105,112,116,32,37,100,0,0,0,3,0,0,0,0,0,0,0,76,79,71,95,85,78,75,78,79,87,78,0,0,0,0,0,115,116,100,111,117,116,0,0,97,115,115,101,114,116,0,0,76,79,71,95,68,68,65,83,82,84,0,0,0,0,0,0,76,79,71,95,68,69,66,85,71,0,0,0,0,0,0,0,76,79,71,95,68,83,83,0,76,79,71,95,68,83,83,95,74,65,67,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,0,0,0,0,0,0,76,79,71,95,69,86,69,78,84,83,95,86,0,0,0,0,76,79,71,95,73,78,73,84,0,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,0,0,0,0,0,0,0,76,79,71,95,73,80,79,80,84,95,70,85,76,76,0,0,76,79,71,95,73,80,79,80,84,95,74,65,67,0,0,0,76,79,71,95,73,80,79,80,84,95,72,69,83,83,69,0,76,79,71,95,74,65,67,0,76,79,71,95,76,83,0,0,76,79,71,95,76,83,95,86,0,0,0,0,0,0,0,0,76,79,71,95,78,76,83,0,76,79,71,95,78,76,83,95,86,0,0,0,0,0,0,0,76,79,71,95,78,76,83,95,74,65,67,0,0,0,0,0,76,79,71,95,78,76,83,95,82,69,83,0,0,0,0,0,76,79,71,95,82,69,83,95,73,78,73,84,0,0,0,0,76,79,71,95,83,73,77,85,76,65,84,73,79,78,0,0,76,79,71,95,83,79,76,86,69,82,0,0,0,0,0,0,76,79,71,95,83,79,84,73,0,0,0,0,0,0,0,0,76,79,71,95,83,84,65,84,83,0,0,0,0,0,0,0,76,79,71,95,85,84,73,76,0,0,0,0,0,0,0,0,76,79,71,95,90,69,82,79,67,82,79,83,83,73,78,71,83,0,0,0,0,0,0,0,40,111,4,0,56,111,4,0,64,111,4,0,72,111,4,0,88,111,4,0,104,111,4,0,112,111,4,0,128,111,4,0,144,111,4,0,160,111,4,0,176,111,4,0,192,111,4,0,208,111,4,0,224,111,4,0,240,111,4,0,248,111,4,0,0,112,4,0,16,112,4,0,24,112,4,0,40,112,4,0,56,112,4,0,72,112,4,0,88,112,4,0,104,112,4,0,120,112,4,0,136,112,4,0,152,112,4,0,168,112,4,0,117,110,107,110,111,119,110,0,116,104,105,115,32,115,116,114,101,97,109,32,105,115,32,97,108,119,97,121,115,32,97,99,116,105,118,101,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,97,115,115,108,32,115,111,108,118,101,114,0,0,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,100,101,98,117,103,32,105,110,102,111,114,109,97,116,105,111,110,0,0,0,0,111,117,116,112,117,116,115,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,106,97,99,111,98,105,97,110,32,111,102,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,101,118,101,110,116,32,115,121,115,116,101,109,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,100,117,114,105,110,103,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,102,114,111,109,32,73,112,111,112,116,0,0,0,0,0,99,104,101,99,107,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,0,0,0,0,0,0,0,99,104,101,99,107,32,104,101,115,115,105,97,110,32,109,97,116,114,105,120,32,119,105,116,104,32,73,112,111,112,116,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,117,115,101,100,32,98,121,32,100,97,115,115,108,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,108,111,103,103,105,110,103,32,102,111,114,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,118,101,114,98,111,115,101,32,108,111,103,103,105,110,103,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,111,117,116,112,117,116,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,111,102,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,115,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,101,118,101,114,121,32,101,118,97,108,117,97,116,105,111,110,32,111,102,32,116,104,101,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,111,117,116,112,117,116,115,32,114,101,115,105,100,117,97,108,115,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,105,109,117,108,97,116,105,111,110,32,112,114,111,99,101,115,115,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,115,111,108,118,101,114,32,112,114,111,99,101,115,115,0,0,0,0,0,102,105,110,97,108,32,115,111,108,117,116,105,111,110,32,111,102,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,115,116,97,116,105,115,116,105,99,115,32,97,98,111,117,116,32,116,105,109,101,114,47,101,118,101,110,116,115,47,115,111,108,118,101,114,0,63,63,63,0,0,0,0,0,97,100,100,105,116,105,111,110,97,108,32,105,110,102,111,114,109,97,116,105,111,110,32,97,98,111,117,116,32,116,104,101,32,122,101,114,111,99,114,111,115,115,105,110,103,115,0,0,48,113,4,0,56,113,4,0,56,113,4,0,88,113,4,0,136,113,4,0,168,113,4,0,224,113,4,0,16,114,4,0,64,114,4,0,96,114,4,0,144,114,4,0,168,114,4,0,200,114,4,0,240,114,4,0,16,115,4,0,64,115,4,0,96,115,4,0,136,115,4,0,168,115,4,0,208,115,4,0,0,116,4,0,56,116,4,0,96,116,4,0,144,116,4,0,192,116,4,0,232,116,4,0,24,117,4,0,32,117,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,91,37,115,58,37,100,58,37,100,45,37,100,58,37,100,58,37,115,93,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,37,45,49,55,115,32,124,32,0,0,0,0,0,0,0,0,124,0,0,0,0,0,0,0,37,45,55,115,32,124,32,0,48,113,4,0,32,120,4,0,40,120,4,0,48,120,4,0,64,111,4,0,56,120,4,0,124,32,0,0,0,0,0,0,60,109,101,115,115,97,103,101,32,115,116,114,101,97,109,61,34,37,115,34,32,116,121,112,101,61,34,37,115,34,32,116,101,120,116,61,34,0,0,0,34,62,10,0,0,0,0,0,60,117,115,101,100,32,105,110,100,101,120,61,34,37,100,34,32,47,62,10,0,0,0,0,60,47,109,101,115,115,97,103,101,62,10,0,0,0,0,0,34,32,47,62,10,0,0,0,7,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,38,97,109,112,59,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,105,110,102,111,0,0,0,0,119,97,114,110,105,110,103,0,101,114,114,111,114,0,0,0,100,101,98,117,103,0,0,0,34,62,0,0,0,0,0,0,115,111,108,118,101,114,32,119,105,108,108,32,116,114,121,32,116,111,32,104,97,110,100,108,101,32,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,58,32,37,115,0,0,0,0,100,105,118,105,115,105,111,110,32,98,121,32,122,101,114,111,32,97,116,32,116,105,109,101,32,37,46,49,54,103,44,32,100,105,118,105,115,111,114,58,32,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,101,109,112,116,121,32,108,105,115,116,0,0,0,0,0,0,105,110,118,97,108,105,100,32,102,105,115,116,32,108,105,115,116,45,112,111,105,110,116,101,114,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,108,105,115,116,45,110,111,100,101,0,0,0,0,0,0,0,105,110,118,97,108,105,100,32,100,97,116,97,32,110,111,100,101,0,0,0,0,0,0,0,1,0,0,0,25,0,0,0,26,0,0,0,26,0,0,0,27,0,0,0,2,0,0,0,2,0,0,0,28,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,105,110,84,114,97,110,115,0,0,0,0,0,0,0,0,144,121,4,0,0,0,0,0,98,105,110,78,111,114,109,97,108,0,0,0,0,0,0,0,168,121,4,0,0,0,0,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,100,97,116,97,95,50,0,0,192,121,4,0,200,121,4,0,208,121,4,0,224,121,4,0,240,121,4,0,248,121,4,0,51,0,0,0,51,0,0,0,51,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,49,41,0,0,0,0,0,0,77,97,116,114,105,120,32,116,121,112,101,32,109,105,115,109,97,116,99,104,0,0,0,0,77,97,116,114,105,120,32,117,115,101,115,32,105,109,97,103,105,110,97,114,121,32,110,117,109,98,101,114,115,0,0,0,67,111,117,108,100,32,110,111,116,32,100,101,116,101,114,109,105,110,101,32,115,105,122,101,32,111,102,32,109,97,116,114,105,120,32,101,108,101,109,101,110,116,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,50,41,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,32,40,51,41,0,0,0,0,0,0,77,97,116,114,105,120,32,110,97,109,101,32,109,105,115,109,97,116,99,104,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,52,32,114,111,119,115,0,0,0,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,49,32,99,111,108,115,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,65,99,108,97,115,115,32,109,97,116,114,105,120,0,0,0,65,99,108,97,115,115,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,98,105,110,84,114,97,110,115,32,111,114,32,98,105,110,78,111,114,109,97,108,32,102,111,114,109,97,116,0,0,0,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,110,97,109,101,115,32,109,97,116,114,105,120,0,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,73,110,102,111,32,109,97,116,114,105,120,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,99,111,110,116,97,105,110,32,97,116,32,108,101,97,115,116,32,49,32,118,97,114,105,97,98,108,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,99,111,108,115,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,49,32,109,97,116,114,105,120,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,99,111,110,116,97,105,110,101,100,32,112,97,114,97,109,101,116,101,114,32,116,104,97,116,32,99,104,97,110,103,101,100,32,98,101,116,119,101,101,110,32,115,116,97,114,116,32,97,110,100,32,115,116,111,112,45,116,105,109,101,0,0,0,0,0,0,100,97,116,97,95,49,32,109,97,116,114,105,120,32,100,111,101,115,32,110,111,116,32,104,97,118,101,32,49,32,111,114,32,50,32,114,111,119,115,0,84,111,111,32,102,101,119,32,114,111,119,115,32,105,110,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,67,111,114,114,117,112,116,32,104,101,97,100,101,114,58,32,100,97,116,97,95,50,32,109,97,116,114,105,120,0,0,0,73,109,112,108,101,109,101,110,116,97,116,105,111,110,32,101,114,114,111,114,58,32,85,110,107,110,111,119,110,32,99,97,115,101,0,0,0,0,0,0,97,98,115,86,97,114,73,110,100,101,120,32,62,32,48,32,38,38,32,97,98,115,86,97,114,73,110,100,101,120,32,60,61,32,114,101,97,100,101,114,45,62,110,118,97,114,0,0,117,116,105,108,47,114,101,97,100,95,109,97,116,108,97,98,52,46,99,0,0,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,118,97,108,115,0,0,0,111,109,99,95,109,97,116,108,97,98,52,95,114,101,97,100,95,115,105,110,103,108,101,95,118,97,108,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,115,111,117,114,99,101,41,0,0,0,117,116,105,108,47,114,101,97,108,95,97,114,114,97,121,46,99,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,111,107,40,100,101,115,116,41,0,0,0,0,0,98,97,115,101,95,97,114,114,97,121,95,115,104,97,112,101,95,101,113,40,115,111,117,114,99,101,44,32,100,101,115,116,41,0,0,0,0,0,0,0,99,111,112,121,95,114,101,97,108,95,97,114,114,97,121,95,100,97,116,97,95,109,101,109,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,109,112,116,121,32,82,105,110,103,66,117,102,102,101,114,0,0,0,0,0,0,0,0,105,110,100,101,120,32,91,37,100,93,32,111,117,116,32,111,102,32,114,97,110,103,101,32,91,37,100,58,37,100,93,0,120,133,4,0,0,0,0,0,240,132,4,0,0,0,0,0,104,132,4,0,0,0,0,0,224,131,4,0,0,0,0,0,216,130,4,0,0,0,0,0,208,129,4,0,0,0,0,0,200,128,4,0,0,0,0,0,192,127,4,0,0,0,0,0,97,99,99,95,116,112,32,33,61,32,48,0,0,0,0,0,117,116,105,108,47,114,116,99,108,111,99,107,46,99,0,0,114,116,95,105,110,105,116,0,109,97,120,95,116,112,32,33,61,32,48,0,0,0,0,0,116,111,116,97,108,95,116,112,32,33,61,32,48,0,0,0,116,105,99,107,95,116,112,32,33,61,32,48,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,32,33,61,32,48,0,0,0,0,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,105,110,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,109,97,120,32,33,61,32,48,0,114,116,95,99,108,111,99,107,95,110,99,97,108,108,95,116,111,116,97,108,32,33,61,32,48], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+286744);
/* memory initializer */ allocate([69,114,114,111,114,32,115,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,119,105,116,104,32,100,105,102,102,101,114,101,110,116,32,115,116,97,114,116,105,110,103,32,112,111,105,110,116,115,32,40,43,37,103,41,0,83,111,108,118,105,110,103,32,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,37,115,58,32,105,116,101,114,97,116,105,111,110,32,110,111,116,32,109,97,107,105,110,103,32,112,114,111,103,114,101,115,115,44,32,116,114,121,105,110,103,32,116,111,32,100,101,99,114,101,97,115,101,32,102,97,99,116,111,114,32,116,111,32,37,103,0,0,0,0,0,105,109,112,114,111,112,101,114,32,105,110,112,117,116,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,110,111,110,108,105,110,101,97,114,32,101,113,46,32,115,121,115,116,58,32,37,115,32,97,116,32,116,105,109,101,32,37,103,0,0,85,110,107,110,111,119,110,32,101,113,117,97,116,105,111,110,32,115,121,115,116,101,109,32,101,114,114,111,114,58,32,37,100,32,37,115,32,37,103,0,70,76,65,71,95,85,78,75,78,79,87,78,0,0,0,0,99,108,111,99,107,0,0,0,99,112,117,0,0,0,0,0,101,109,105,116,95,112,114,111,116,101,99,116,101,100,0,0,102,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,105,105,102,0,0,0,0,0,105,105,109,0,0,0,0,0,105,105,116,0,0,0,0,0,105,108,115,0,0,0,0,0,105,110,116,101,114,97,99,116,105,118,101,0,0,0,0,0,105,111,109,0,0,0,0,0,105,112,111,112,116,95,104,101,115,115,101,0,0,0,0,0,105,112,111,112,116,95,106,97,99,0,0,0,0,0,0,0,105,112,111,112,116,95,105,110,105,116,0,0,0,0,0,0,108,0,0,0,0,0,0,0,108,111,103,70,111,114,109,97,116,0,0,0,0,0,0,0,108,115,0,0,0,0,0,0,108,115,95,105,112,111,112,116,0,0,0,0,0,0,0,0,108,118,0,0,0,0,0,0,109,101,97,115,117,114,101,84,105,109,101,80,108,111,116,70,111,114,109,97,116,0,0,0,110,108,115,0,0,0,0,0,110,111,101,109,105,116,0,0,110,111,69,118,101,110,116,69,109,105,116,0,0,0,0,0,111,117,116,112,117,116,0,0,111,118,101,114,114,105,100,101,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,70,105,108,101,0,0,0,0,112,111,114,116,0,0,0,0,114,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,96,135,4,0,112,135,4,0,120,135,4,0,128,135,4,0,144,135,4,0,152,135,4,0,160,135,4,0,168,135,4,0,176,135,4,0,184,135,4,0,192,135,4,0,208,135,4,0,216,135,4,0,232,135,4,0,248,135,4,0,8,136,4,0,16,136,4,0,32,136,4,0,40,136,4,0,56,136,4,0,64,136,4,0,88,136,4,0,96,136,4,0,104,136,4,0,120,136,4,0,128,136,4,0,144,136,4,0,160,136,4,0,168,136,4,0,176,136,4,0,184,136,4,0,192,136,4,0,117,110,107,110,111,119,110,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,0,0,0,0,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,115,45,102,105,108,101,0,0,0,0,0,0,0,0,101,109,105,116,115,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,115,101,116,117,112,32,88,77,76,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,110,32,101,120,116,101,114,110,97,108,32,102,105,108,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,0,0,0,0,0,91,100,111,117,98,108,101,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,91,105,110,116,93,32,100,101,102,97,117,108,116,58,32,49,0,0,0,0,0,0,0,0,115,112,101,99,105,102,121,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,119,104,101,114,101,32,116,104,101,32,108,105,110,101,97,114,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,32,115,104,111,117,108,100,32,98,101,32,112,101,114,102,111,114,109,101,100,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,46,32,45,108,111,103,70,111,114,109,97,116,61,116,101,120,116,32,40,100,101,102,97,117,108,116,41,32,111,114,32,45,108,111,103,70,111,114,109,97,116,61,120,109,108,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,105,112,111,112,116,0,0,0,0,0,0,91,115,116,114,105,110,103,32,108,105,115,116,93,32,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,97,110,121,32,114,101,115,117,108,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,0,100,111,32,110,111,116,32,101,109,105,116,32,101,118,101,110,116,32,112,111,105,110,116,115,32,116,111,32,116,104,101,32,114,101,115,117,108,116,32,102,105,108,101,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,105,110,116,101,114,97,99,116,105,118,101,32,115,105,109,117,108,97,116,105,111,110,32,112,111,114,116,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,110,101,119,32,114,101,115,117,108,116,32,102,105,108,101,32,116,104,97,110,32,116,104,101,32,100,101,102,97,117,108,116,32,77,111,100,101,108,95,114,101,115,46,109,97,116,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,115,111,108,118,101,114,0,0,0,0,0,0,115,104,111,119,115,32,97,108,108,32,119,97,114,110,105,110,103,115,32,101,118,101,110,32,105,102,32,97,32,114,101,108,97,116,101,100,32,108,111,103,45,115,116,114,101,97,109,32,105,115,32,105,110,97,99,116,105,118,101,0,0,0,0,0,80,137,4,0,88,137,4,0,160,137,4,0,208,137,4,0,0,138,4,0,72,138,4,0,136,138,4,0,208,138,4,0,0,139,4,0,72,139,4,0,96,139,4,0,128,139,4,0,184,139,4,0,224,139,4,0,8,140,4,0,64,140,4,0,144,140,4,0,240,140,4,0,32,141,4,0,88,141,4,0,136,141,4,0,208,141,4,0,248,141,4,0,40,142,4,0,88,142,4,0,176,142,4,0,248,142,4,0,104,143,4,0,152,143,4,0,224,143,4,0,0,144,4,0,192,136,4,0,115,101,108,101,99,116,115,32,116,104,101,32,116,121,112,101,32,111,102,32,99,108,111,99,107,32,116,111,32,117,115,101,32,45,99,108,111,99,107,61,82,84,44,32,45,99,108,111,99,107,61,67,89,67,32,111,114,32,45,99,108,111,99,107,61,67,80,85,10,32,32,82,84,61,109,111,110,111,116,111,110,105,99,32,114,101,97,108,45,116,105,109,101,32,99,108,111,99,107,44,32,67,80,85,61,112,114,111,99,101,115,115,45,98,97,115,101,100,32,67,80,85,45,116,105,109,101,44,32,67,89,67,61,99,112,117,32,99,121,99,108,101,115,32,109,101,97,115,117,114,101,100,32,119,105,116,104,32,82,68,84,83,67,0,0,0,0,0,32,32,45,32,100,117,109,112,115,32,116,104,101,32,99,112,117,45,116,105,109,101,32,105,110,116,111,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,10,32,32,45,32,36,99,112,117,84,105,109,101,32,105,115,32,116,104,101,32,118,97,114,105,97,98,108,101,32,110,97,109,101,32,105,110,115,105,100,101,32,116,104,101,32,114,101,115,117,108,116,45,102,105,108,101,0,0,0,0,103,101,116,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,116,104,97,116,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,10,32,32,101,46,103,46,32,45,104,101,108,112,61,102,32,112,114,105,110,116,115,32,100,101,116,97,105,108,101,100,32,105,110,102,111,114,109,97,116,105,111,110,32,102,111,114,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,32,102,0,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,97,32,116,105,109,101,32,102,111,114,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,111,102,32,116,104,101,32,109,111,100,101,108,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,102,111,114,32,104,111,109,111,116,111,112,121,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,115,121,109,98,111,108,105,99,41,32,111,114,10,39,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,39,32,109,101,116,104,111,100,32,40,114,101,113,117,105,114,101,100,58,32,45,105,105,109,61,110,117,109,101,114,105,99,32,45,105,111,109,61,110,101,108,100,101,114,95,109,101,97,100,95,101,120,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,104,101,115,115,101,109,97,116,114,105,120,32,102,111,114,32,73,112,111,112,116,40,79,77,67,44,32,66,70,71,83,44,32,99,111,110,115,116,41,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,106,97,99,111,98,105,97,110,32,102,111,114,32,73,112,111,112,116,40,83,89,77,44,32,78,85,77,44,32,78,85,77,68,69,78,83,69,41,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,111,114,32,111,112,116,105,109,105,122,97,116,105,111,110,32,40,115,105,109,44,32,99,111,110,115,116,41,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,10,32,32,108,97,112,97,99,107,44,32,108,105,115,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,102,111,114,32,73,112,111,112,116,44,32,100,101,102,97,117,108,116,32,109,117,109,112,115,46,10,32,78,111,116,101,58,32,85,115,101,32,105,102,32,121,111,117,32,98,117,105,108,100,32,105,112,111,112,116,32,119,105,116,104,32,111,116,104,101,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,105,107,101,32,109,97,50,55,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,108,111,103,103,105,110,103,32,108,101,118,101,108,0,0,0,0,0,0,0,118,97,108,117,101,32,115,112,101,99,105,102,105,101,115,32,116,104,101,32,111,117,116,112,117,116,32,102,111,114,109,97,116,32,111,102,32,116,104,101,32,109,101,97,115,117,114,101,32,116,105,109,101,32,102,117,110,99,116,105,111,110,97,108,105,116,121,10,32,32,115,118,103,10,32,32,106,112,103,10,32,32,112,115,10,32,32,103,105,102,10,32,32,46,46,46,0,0,0,0,0,0,0,0,111,117,116,112,117,116,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,97,44,32,98,32,97,110,100,32,99,32,97,116,32,116,104,101,32,101,110,100,32,111,102,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,116,111,32,116,104,101,32,115,116,97,110,100,97,114,100,32,111,117,116,112,117,116,10,32,32,116,105,109,101,32,61,32,118,97,108,117,101,44,32,97,32,61,32,118,97,108,117,101,44,32,98,32,61,32,118,97,108,117,101,44,32,99,32,61,32,118,97,108,117,101,0,0,0,0,0,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,10,32,32,101,46,103,46,32,118,97,114,49,61,115,116,97,114,116,49,44,118,97,114,50,61,115,116,97,114,116,50,44,112,97,114,51,61,115,116,97,114,116,51,44,115,116,97,114,116,84,105,109,101,61,118,97,108,49,44,115,116,111,112,84,105,109,101,61,118,97,108,50,44,115,116,101,112,83,105,122,101,61,118,97,108,51,44,10,32,32,32,32,32,32,32,116,111,108,101,114,97,110,99,101,61,118,97,108,52,44,115,111,108,118,101,114,61,34,115,101,101,32,45,115,34,44,111,117,116,112,117,116,70,111,114,109,97,116,61,34,109,97,116,124,112,108,116,124,99,115,118,124,101,109,112,116,121,34,44,118,97,114,105,97,98,108,101,70,105,108,116,101,114,61,34,102,105,108,116,101,114,34,0,0,0,119,105,108,108,32,111,118,101,114,114,105,100,101,32,116,104,101,32,118,97,114,105,97,98,108,101,115,32,111,114,32,116,104,101,32,115,105,109,117,108,97,116,105,111,110,32,115,101,116,116,105,110,103,115,32,105,110,32,116,104,101,32,88,77,76,32,115,101,116,117,112,32,102,105,108,101,32,119,105,116,104,32,116,104,101,32,118,97,108,117,101,115,32,102,114,111,109,32,116,104,101,32,102,105,108,101,10,32,32,110,111,116,101,32,116,104,97,116,58,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,67,65,78,78,79,84,32,98,101,32,117,115,101,100,32,119,105,116,104,32,45,111,118,101,114,114,105,100,101,10,32,32,117,115,101,32,119,104,101,110,32,118,97,114,105,97,98,108,101,115,32,102,111,114,32,45,111,118,101,114,114,105,100,101,32,97,114,101,32,116,111,111,32,109,97,110,121,32,97,110,100,32,100,111,32,110,111,116,32,102,105,116,32,105,110,32,99,111,109,109,97,110,100,32,108,105,110,101,32,115,105,122,101,10,32,32,111,118,101,114,114,105,100,101,70,105,108,101,78,97,109,101,32,99,111,110,116,97,105,110,115,32,108,105,110,101,115,32,111,102,32,116,104,101,32,102,111,114,109,58,32,118,97,114,49,61,115,116,97,114,116,49,0,0,0,0,0,0,80,137,4,0,192,144,4,0,104,145,4,0,208,137,4,0,0,138,4,0,208,145,4,0,136,138,4,0,208,138,4,0,88,146,4,0,152,146,4,0,96,139,4,0,128,139,4,0,56,147,4,0,120,147,4,0,184,147,4,0,64,140,4,0,144,140,4,0,248,147,4,0,48,148,4,0,184,148,4,0,224,148,4,0,208,141,4,0,248,141,4,0,40,142,4,0,72,149,4,0,208,149,4,0,208,150,4,0,104,143,4,0,152,143,4,0,224,143,4,0,0,144,4,0,192,136,4,0,0,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,1,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,49,120,44,56,48,97,49,41,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,41,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,73,49,32,61,2,44,105,49,48,44,51,120,44,2,73,50,32,61,2,44,105,49,48,41,0,0,0,0,0,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,32,109,101,115,115,97,103,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,41,0,0,0,40,54,120,44,2,73,110,32,97,98,111,118,101,44,32,32,82,49,32,61,2,44,101,50,49,46,49,51,44,51,120,44,2,82,50,32,61,2,44,101,50,49,46,49,51,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,156,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,72,156,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,156,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,156,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,156,4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,72,69,32,76,65,83,84,32,83,84,69,80,32,84,69,82,77,73,78,65,84,69,68,32,87,73,84,72,32,65,32,78,69,71,65,84,73,86,69,0,0,0,0,0,0,0,49,0,0,0,0,0,0,0,201,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,86,65,76,85,69,32,40,61,73,49,41,32,79,70,32,73,68,73,68,32,65,78,68,32,78,79,32,65,80,80,82,79,80,82,73,65,84,69,0,47,0,0,0,0,0,0,0,202,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,67,84,73,79,78,32,87,65,83,32,84,65,75,69,78,46,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,0,0,0,0,0,0,0,41,0,0,0,0,0,0,0,203,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,2,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,67,85,82,82,69,78,84,32,84,32,40,61,82,49,41,32,32,53,48,48,32,83,84,69,80,83,0,0,38,0,0,0,0,0,0,0,98,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,65,75,69,78,32,79,78,32,84,72,73,83,32,67,65,76,76,32,66,69,70,79,82,69,32,82,69,65,67,72,73,78,71,32,84,79,85,84,0,0,0,0,0,0,0,0,48,0,0,0,0,0,0,0,99,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,84,79,79,32,77,85,67,72,32,65,67,67,85,82,65,67,89,32,82,69,81,85,69,83,84,69,68,0,108,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,70,79,82,32,80,82,69,67,73,83,73,79,78,32,79,70,32,77,65,67,72,73,78,69,46,32,82,84,79,76,32,65,78,68,32,65,84,79,76,0,0,0,0,0,0,0,0,109,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,87,69,82,69,32,73,78,67,82,69,65,83,69,68,32,84,79,32,65,80,80,82,79,80,82,73,65,84,69,32,86,65,76,85,69,83,0,0,0,45,0,0,0,0,0,0,0,110,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,0,0,118,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,65,83,32,66,69,67,79,77,69,32,46,76,69,46,32,48,46,48,0,0,0,0,28,0,0,0,0,0,0,0,119,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,32,84,72,69,0,0,0,0,44,0,0,0,0,0,0,0,128,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,0,0,0,57,0,0,0,0,0,0,0,129,2,0,0,0,0,0,0,138,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,70,65,73,76,69,68,32,84,79,32,67,79,78,86,69,82,71,69,32,82,69,80,69,65,84,69,68,76,89,0,0,0,0,0,0,0,0,139,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,82,32,87,73,84,72,32,65,66,83,40,72,41,61,72,77,73,78,0,0,0,0,140,2,0,0,0,0,0,0,148,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,84,69,82,65,84,73,79,78,32,77,65,84,82,73,88,32,73,83,32,83,73,78,71,85,76,65,82,0,0,0,37,0,0,0,0,0,0,0,149,2,0,0,0,0,0,0,158,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,46,32,32,65,76,83,79,44,32,84,72,69,0,0,0,0,0,0,0,159,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,69,82,82,79,82,32,84,69,83,84,32,70,65,73,76,69,68,32,82,69,80,69,65,84,69,68,76,89,46,0,0,160,2,0,0,0,0,0,0,163,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,67,79,82,82,69,67,84,79,82,32,67,79,85,76,68,32,78,79,84,32,67,79,78,86,69,82,71,69,32,66,69,67,65,85,83,69,0,0,0,164,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,79,78,69,0,0,0,0,36,0,0,0,0,0,0,0,165,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,84,32,84,32,40,61,82,49,41,32,65,78,68,32,83,84,69,80,83,73,90,69,32,72,32,40,61,82,50,41,0,0,0,0,0,0,0,0,40,0,0,0,0,0,0,0,168,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,82,69,83,32,87,65,83,32,69,81,85,65,76,32,84,79,32,77,73,78,85,83,32,84,87,79,0,0,0,0,169,2,0,0,0,0,0,0,173,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,73,84,73,65,76,32,89,80,82,73,77,69,32,67,79,85,76,68,32,78,79,84,32,66,69,32,67,79,77,80,85,84,69,68,0,0,0,174,2,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,73,78,70,79,32,86,69,67,84,79,82,32,73,83,32,78,79,84,32,90,69,82,79,32,79,82,32,79,78,69,0,55,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,69,81,32,40,61,73,49,41,32,46,76,69,46,32,48,0,0,0,0,0,0,0,25,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,65,88,79,82,68,32,40,61,73,49,41,32,78,79,84,32,73,78,32,82,65,78,71,69,0,0,0,0,0,0,34,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,82,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,82,87,32,40,61,73,50,41,0,0,0,0,60,0,0,0,0,0,0,0,4,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,87,79,82,75,32,76,69,78,71,84,72,32,78,69,69,68,69,68,44,32,76,69,78,73,87,32,40,61,73,49,41,44,32,69,88,67,69,69,68,83,32,76,73,87,32,40,61,73,50,41,0,0,0,0,5,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,82,84,79,76,32,73,83,32,46,76,84,46,32,48,0,39,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,65,84,79,76,32,73,83,32,46,76,84,46,32,48,0,7,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,65,76,76,32,69,76,69,77,69,78,84,83,32,79,70,32,82,84,79,76,32,65,78,68,32,65,84,79,76,32,65,82,69,32,90,69,82,79,0,8,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,32,61,32,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,79,85,84,32,40,61,82,50,41,0,0,54,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,72,77,65,88,32,40,61,82,49,41,32,46,76,84,46,32,48,46,48,0,0,0,0,10,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,11,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,56,41,61,49,32,65,78,68,32,72,48,61,48,46,48,0,0,0,29,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,83,79,77,69,32,69,76,69,77,69,78,84,32,79,70,32,87,84,32,73,83,32,46,76,69,46,32,48,46,48,0,13,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,84,79,85,84,32,40,61,82,49,41,32,84,79,79,32,67,76,79,83,69,32,84,79,32,84,32,40,61,82,50,41,32,84,79,32,83,84,65,82,84,32,73,78,84,69,71,82,65,84,73,79,78,0,0,0,0,14,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,73,78,70,79,40,52,41,61,49,32,65,78,68,32,84,83,84,79,80,32,40,61,82,49,41,32,66,69,72,73,78,68,32,84,32,40,61,82,50,41,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,76,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,52,0,0,0,0,0,0,0,17,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,77,85,32,40,61,73,49,41,32,73,76,76,69,71,65,76,46,32,69,73,84,72,69,82,32,46,76,84,46,32,48,32,79,82,32,46,71,84,46,32,78,69,81,0,0,0,0,18,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,84,79,85,84,32,40,61,82,49,41,32,73,83,32,69,81,85,65,76,32,84,79,32,84,32,40,61,82,50,41,0,19,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,78,71,32,40,61,73,49,41,32,46,76,84,46,32,48,0,0,0,0,0,0,0,0,24,0,0,0,0,0,0,0,30,0,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,79,78,69,32,79,82,32,77,79,82,69,32,67,79,77,80,79,78,69,78,84,83,32,79,70,32,71,32,72,65,83,32,65,32,82,79,79,84,0,32,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,84,79,79,32,78,69,65,82,32,84,79,32,84,72,69,32,73,78,73,84,73,65,76,32,80,79,73,78,84,0,0,68,65,83,83,76,45,45,32,32,82,69,80,69,65,84,69,68,32,79,67,67,85,82,82,69,78,67,69,83,32,79,70,32,73,76,76,69,71,65,76,32,73,78,80,85,84,0,0,46,0,0,0,0,0,0,0,33,3,0,0,0,0,0,0,68,65,83,83,76,45,45,32,32,82,85,78,32,84,69,82,77,73,78,65,84,69,68,46,32,65,80,80,65,82,69,78,84,32,73,78,70,73,78,73,84,69,32,76,79,79,80,0,34,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,97,116,32,112,111,105,110,116,32,105,110,32,116,105,109,101,58,32,37,103,0,0,0,0,99,106,58,32,37,103,0,0,115,116,97,116,101,115,0,0,91,37,108,100,93,32,37,103,0,0,0,0,0,0,0,0,97,110,97,108,121,116,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,37,115,37,103,32,0,0,0,37,115,0,0,0,0,0,0,110,117,109,101,114,105,99,97,108,32,74,97,99,111,98,105,97,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,0,0,0,0,0,0,0,83,0,0,0,0,0,0,0,66,0,0,0,0,0,0,0,80,0,0,0,0,0,0,0,78,0,0,0,0,0,0,0,82,0,0,0,0,0,0,0,77,0,0,0,0,0,0,0,85,0,0,0,0,0,0,0,76,0,0,0,0,0,0,0,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+296440);
/* memory initializer */ allocate([40,47,47,2,32,87,65,82,78,73,78,71,46,32,84,104,101,32,118,97,108,117,101,32,69,77,73,78,32,109,97,121,32,98,101,32,105,110,99,111,114,114,101,99,116,58,45,2,44,2,32,32,69,77,73,78,32,61,32,2,44,105,56,44,47,2,32,73,102,44,32,97,102,116,101,114,32,105,110,115,112,101,99,116,105,111,110,44,32,116,104,101,32,118,97,108,117,101,32,69,77,73,78,32,108,111,111,107,115,2,44,2,32,97,99,99,101,112,116,97,98,108,101,32,112,108,101,97,115,101,32,99,111,109,109,101,110,116,32,111,117,116,32,2,44,47,2,32,116,104,101,32,73,70,32,98,108,111,99,107,32,97,115,32,109,97,114,107,101,100,32,119,105,116,104,105,110,32,116,104,101,32,99,111,100,101,32,111,102,32,114,111,117,116,105,110,101,2,44,2,32,68,76,65,77,67,50,44,2,44,47,2,32,111,116,104,101,114,119,105,115,101,32,115,117,112,112,108,121,32,69,77,73,78,32,101,120,112,108,105,99,105,116,108,121,46,2,44,47,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,104,174,4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,191,76,0,0,0,0,176,60,49,101,0,0,0,0,16,0,244,14,255,255,255,255,239,127,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,2,32,80,114,111,103,114,101,115,115,32,82,101,112,111,114,116,32,101,118,101,114,121,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,47,44,2,32,69,86,65,76,46,32,32,32,70,85,78,67,46,86,65,76,85,69,46,2,44,49,48,120,44,2,80,65,82,65,77,69,84,69,82,32,86,65,76,85,69,83,2,41,0,0,0,0,40,47,49,120,44,105,52,44,50,120,44,103,49,50,46,53,44,50,120,44,53,103,49,49,46,52,44,51,40,47,50,49,120,44,53,103,49,49,46,52,41,41,0,0,0,0,0,0,40,2,32,78,111,46,32,111,102,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,62,32,2,44,105,53,41,0,0,40,2,32,82,77,83,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,103,49,52,46,54,41,0,0,0,0,0,40,2,32,67,101,110,116,114,111,105,100,32,111,102,32,108,97,115,116,32,115,105,109,112,108,101,120,32,61,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,99,101,110,116,114,111,105,100,32,61,2,44,103,49,52,46,54,41,0,40,47,2,32,69,86,73,68,69,78,67,69,32,79,70,32,67,79,78,86,69,82,71,69,78,67,69,2,41,0,0,0,40,47,47,2,32,77,105,110,105,109,117,109,32,102,111,117,110,100,32,97,102,116,101,114,2,44,105,53,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,2,41,0,0,0,40,2,32,77,105,110,105,109,117,109,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,54,41,41,0,0,0,40,2,32,70,117,110,99,116,105,111,110,32,118,97,108,117,101,32,97,116,32,109,105,110,105,109,117,109,32,61,2,44,103,49,52,46,54,41,0,0,40,47,2,32,70,105,116,116,105,110,103,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,97,98,111,117,116,32,115,117,112,112,111,115,101,100,32,109,105,110,105,109,117,109,2,47,41,0,40,47,2,32,77,65,84,82,73,88,32,79,70,32,69,83,84,73,77,65,84,69,68,32,83,69,67,79,78,68,32,68,69,82,73,86,65,84,73,86,69,83,32,78,79,84,32,43,86,69,32,68,69,70,78,46,2,47,2,32,77,73,78,73,77,85,77,32,80,82,79,66,65,66,76,89,32,78,79,84,32,70,79,85,78,68,2,47,41,0,0,0,0,0,0,0,40,47,49,48,120,44,2,83,101,97,114,99,104,32,114,101,115,116,97,114,116,105,110,103,2,47,41,0,0,0,0,0,40,2,32,77,105,110,105,109,117,109,32,111,102,32,113,117,97,100,114,97,116,105,99,32,115,117,114,102,97,99,101,32,61,2,44,103,49,52,46,54,44,2,32,97,116,2,44,52,40,47,49,120,44,54,103,49,51,46,53,41,41,0,0,0,40,2,32,73,70,32,84,72,73,83,32,68,73,70,70,69,82,83,32,66,89,32,77,85,67,72,32,70,82,79,77,32,84,72,69,32,77,73,78,73,77,85,77,32,69,83,84,73,77,65,84,69,68,2,44,49,120,44,2,70,82,79,77,32,84,72,69,32,77,73,78,73,77,73,90,65,84,73,79,78,44,2,47,2,32,84,72,69,32,77,73,78,73,77,85,77,32,77,65,89,32,66,69,32,70,65,76,83,69,32,38,47,79,82,32,84,72,69,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,32,77,65,89,32,66,69,2,44,49,120,44,2,73,78,65,67,67,85,82,65,84,69,2,47,41,0,0,0,0,0,40,2,32,82,97,110,107,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,32,61,2,44,105,51,47,2,32,73,110,118,101,114,115,101,32,111,102,32,105,110,102,111,114,109,97,116,105,111,110,32,109,97,116,114,105,120,58,45,2,41,0,40,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,109,105,110,105,109,105,122,101,100,32,119,97,115,32,45,76,79,71,40,76,73,75,69,76,73,72,79,79,68,41,44,2,47,2,32,116,104,105,115,32,105,115,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,32,111,102,32,116,104,101,32,112,97,114,97,109,101,116,101,114,115,46,2,47,2,32,73,102,32,116,104,101,32,102,117,110,99,116,105,111,110,32,119,97,115,32,97,32,115,117,109,32,111,102,32,115,113,117,97,114,101,115,32,111,102,32,114,101,115,105,100,117,97,108,115,44,2,47,2,32,116,104,105,115,32,109,97,116,114,105,120,32,109,117,115,116,32,98,101,32,109,117,108,116,105,112,108,105,101,100,32,98,121,32,116,119,105,99,101,32,116,104,101,32,101,115,116,105,109,97,116,101,100,2,44,49,120,44,2,114,101,115,105,100,117,97,108,32,118,97,114,105,97,110,99,101,2,47,2,32,116,111,32,111,98,116,97,105,110,32,116,104,101,32,99,111,118,97,114,105,97,110,99,101,32,109,97,116,114,105,120,46,2,47,41,0,0,0,0,40,2,32,73,78,70,79,82,77,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,47,41,0,0,0,0,0,0,40,47,47,2,32,67,79,82,82,69,76,65,84,73,79,78,32,77,65,84,82,73,88,58,45,2,41,0,0,0,0,0,40,47,2,32,65,32,102,117,114,116,104,101,114,2,44,105,52,44,2,32,102,117,110,99,116,105,111,110,32,101,118,97,108,117,97,116,105,111,110,115,32,104,97,118,101,32,98,101,101,110,32,117,115,101,100,2,47,41,0,0,0,0,0,0,40,49,120,44,54,103,49,51,46,53,41,0,0,0,0,0,40,47,41], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+306784);
/* memory initializer */ allocate([232,178,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,168,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,180,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,80,179,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,181,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,181,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,144,181,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,208,181,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,182,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,182,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,216,183,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,183,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,184,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,184,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,88,184,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,104,184,4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,78,80,84,32,105,115,32,110,111,116,32,105,110,2,44,2,32,116,104,101,32,114,101,113,117,105,114,101,100,32,105,110,116,101,114,118,97,108,2,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,184,219,4,0,0,0,0,0,0,0,0,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,67,65,76,70,85,78,32,104,97,115,32,98,101,101,110,2,44,2,32,99,97,108,108,101,100,32,77,65,88,70,85,78,32,116,105,109,101,115,46,2,41,0,0,0,0,0,0,40,47,52,120,44,2,70,117,110,99,116,105,111,110,32,110,117,109,98,101,114,2,44,105,54,44,2,32,32,32,32,70,32,61,2,44,49,112,100,49,56,46,49,48,44,2,32,32,32,32,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,40,47,52,120,44,2,82,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,32,98,101,99,97,117,115,101,32,97,32,116,114,117,115,116,2,44,2,32,114,101,103,105,111,110,32,115,116,101,112,32,104,97,115,32,102,97,105,108,101,100,32,116,111,32,114,101,100,117,99,101,32,81,46,2,41,0,0,0,0,0,0,0,40,53,120,41,0,0,0,0,40,47,52,120,44,2,78,101,119,32,82,72,79,32,61,2,44,49,112,100,49,49,46,52,44,53,120,44,2,78,117,109,98,101,114,32,111,102,2,44,2,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,40,52,120,44,2,76,101,97,115,116,32,118,97,108,117,101,32,111,102,32,70,32,61,2,44,49,112,100,50,51,46,49,53,44,57,120,44,2,84,104,101,32,99,111,114,114,101,115,112,111,110,100,105,110,103,32,88,32,105,115,58,2,47,40,50,120,44,53,100,49,53,46,54,41,41,0,0,0,0,0,40,47,52,120,44,2,65,116,32,116,104,101,32,114,101,116,117,114,110,32,102,114,111,109,32,78,69,87,85,79,65,2,44,53,120,44,2,78,117,109,98,101,114,32,111,102,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,115,32,61,2,44,105,54,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,220,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,232,220,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,64,221,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,152,221,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,160,221,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,232,221,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,56,222,4,0,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,232,221,4,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,105,118,111,116,32,33,61,32,48,0,0,0,0,0,0,109,97,116,104,45,115,117,112,112,111,114,116,47,112,105,118,111,116,46,99,0,0,0,0,112,105,118,111,116,0,0,0,112,234,4,0,144,235,4,0,152,235,4,0,168,235,4,0,184,235,4,0,200,235,4,0,224,235,4,0,248,235,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,112,234,4,0,120,234,4,0,192,234,4,0,232,234,4,0,8,235,4,0,40,235,4,0,80,235,4,0,120,235,4,0,117,110,114,101,99,111,103,110,105,122,101,100,32,100,97,115,115,108,32,115,111,108,118,101,114,32,109,101,116,104,111,100,32,37,115,0,0,0,0,0,124,32,115,111,108,118,101,114,32,124,32,85,115,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,9,37,115,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,78,111,32,83,112,97,114,115,101,80,97,116,116,101,114,110,44,32,115,105,110,99,101,32,116,104,101,114,101,32,97,114,101,32,110,111,32,115,116,97,116,101,115,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,74,97,99,111,98,105,97,110,32,111,114,32,83,112,97,114,115,101,80,97,116,116,101,114,110,32,105,115,32,110,111,116,32,103,101,110,101,114,97,116,101,100,32,111,114,32,102,97,105,108,101,100,32,116,111,32,105,110,105,116,105,97,108,105,122,101,33,32,83,119,105,116,99,104,32,98,97,99,107,32,116,111,32,110,111,114,109,97,108,46,0,0,0,0,0,0,99,111,117,108,100,32,110,111,116,32,112,97,115,115,101,100,32,116,111,32,68,68,65,83,82,84,0,0,0,0,0,0,68,101,115,105,114,101,100,32,115,116,101,112,32,116,111,32,115,109,97,108,108,32,116,114,121,32,110,101,120,116,32,111,110,101,0,0,0,0,0,0,73,110,116,101,114,112,111,108,97,116,101,32,108,105,110,101,97,114,0,0,0,0,0,0,67,97,108,108,105,110,103,32,68,68,65,83,82,84,32,102,114,111,109,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,83,116,97,114,116,32,115,116,101,112,32,37,46,49,53,103,32,116,111,32,37,46,49,53,103,0,0,0,0,0,0,0,65,32,108,97,114,103,101,32,97,109,111,117,110,116,32,111,102,32,119,111,114,107,32,104,97,115,32,98,101,101,110,32,101,120,112,101,110,100,101,100,46,40,65,98,111,117,116,32,53,48,48,32,115,116,101,112,115,41,46,32,84,114,121,105,110,103,32,116,111,32,99,111,110,116,105,110,117,101,32,46,46,46,0,0,0,0,0,0,68,65,83,83,76,32,119,105,108,108,32,116,114,121,32,97,103,97,105,110,46,46,46,0,99,97,110,39,116,32,99,111,110,116,105,110,117,101,46,32,116,105,109,101,32,61,32,37,102,0,0,0,0,0,0,0,100,97,115,115,108,32,99,97,108,108,32,115,116,97,105,115,116,105,99,115,58,32,0,0,118,97,108,117,101,32,111,102,32,105,100,105,100,58,32,37,100,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,105,110,116,101,103,114,97,116,105,111,110,32,116,105,109,101,32,118,97,108,117,101,58,32,37,48,46,52,103,0,0,0,115,116,101,112,32,115,105,122,101,32,72,32,116,111,32,98,101,32,97,116,116,101,109,112,116,101,100,32,111,110,32,110,101,120,116,32,115,116,101,112,58,32,37,48,46,52,103,0,115,116,101,112,32,115,105,122,101,32,117,115,101,100,32,111,110,32,108,97,115,116,32,115,117,99,99,101,115,115,102,117,108,32,115,116,101,112,58,32,37,48,46,52,103,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,101,112,115,32,116,97,107,101,110,32,115,111,32,102,97,114,58,32,37,100,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,40,41,32,58,32,37,100,0,0,0,110,117,109,98,101,114,32,111,102,32,99,97,108,99,117,108,97,116,105,111,110,32,111,102,32,106,97,99,111,98,105,97,110,32,58,32,37,100,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,0,0,116,111,116,97,108,32,110,117,109,98,101,114,32,111,102,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,58,32,37,100,0,49,48,32,43,32,117,105,32,60,32,100,97,115,115,108,68,97,116,97,45,62,108,105,119,0,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,100,97,115,115,108,46,99,0,0,0,0,0,0,0,100,97,115,114,116,95,115,116,101,112,0,0,0,0,0,0,70,105,110,105,115,104,101,100,32,68,68,65,83,82,84,32,115,116,101,112,46,0,0,0,84,104,101,32,101,114,114,111,114,32,116,111,108,101,114,97,110,99,101,115,32,97,114,101,32,116,111,111,32,115,116,114,105,110,103,101,110,116,0,0,68,68,65,83,83,76,32,104,97,100,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,111,110,32,116,104,101,32,108,97,115,116,32,97,116,116,101,109,112,116,101,100,32,115,116,101,112,46,0,0,0,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,0,0,0,0,0,0,0,84,104,101,32,109,97,116,114,105,120,32,111,102,32,112,97,114,116,105,97,108,32,100,101,114,105,118,97,116,105,118,101,115,32,105,115,32,115,105,110,103,117,108,97,114,46,0,0,84,104,101,32,99,111,114,114,101,99,116,111,114,32,99,111,117,108,100,32,110,111,116,32,99,111,110,118,101,114,103,101,46,32,84,104,101,114,101,32,119,101,114,101,32,114,101,112,101,97,116,101,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,32,105,110,32,116,104,105,115,32,115,116,101,112,46,0,65,32,77,111,100,101,108,105,99,97,32,97,115,115,101,114,116,32,112,114,101,118,101,110,116,115,32,116,104,101,32,105,110,116,101,103,114,97,116,111,114,32,116,111,32,99,111,110,116,105,110,117,101,46,32,70,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,32,117,115,101,32,45,108,118,32,76,79,71,95,68,68,65,83,82,84,0,0,73,82,69,83,32,101,113,117,97,108,32,116,111,32,45,50,32,119,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,97,110,100,32,99,111,110,116,114,111,108,32,105,115,32,98,101,105,110,103,32,114,101,116,117,114,110,101,100,32,116,111,32,116,104,101,32,99,97,108,108,105,110,103,32,112,114,111,103,114,97,109,46,0,0,68,68,65,83,83,76,32,102,97,105,108,101,100,32,116,111,32,99,111,109,112,117,116,101,32,116,104,101,32,105,110,105,116,105,97,108,32,89,80,82,73,77,69,46,0,0,0,0,84,104,101,32,99,111,100,101,32,104,97,115,32,101,110,99,111,117,110,116,101,114,101,100,32,116,114,111,117,98,108,101,32,102,114,111,109,32,119,104,105,99,104,32,105,116,32,99,97,110,110,111,116,32,114,101,99,111,118,101,114,46,0,0,117,110,107,110,111,119,110,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,84,82,85,69,0,0,0,0,70,65,76,83,69,0,0,0,91,37,108,100,93,32,115,97,109,112,108,101,40,37,103,44,32,37,103,41,0,0,0,0,91,37,108,100,93,32,37,115,0,0,0,0,0,0,0,0,67,104,97,116,116,101,114,105,110,103,32,100,101,116,101,99,116,101,100,32,97,114,111,117,110,100,32,116,105,109,101,32,37,46,49,50,103,46,46,37,46,49,50,103,32,40,37,100,32,115,116,97,116,101,32,101,118,101,110,116,115,32,105,110,32,97,32,114,111,119,32,119,105,116,104,32,97,32,116,111,116,97,108,32,116,105,109,101,32,100,101,108,116,97,32,108,101,115,115,32,116,104,97,110,32,116,104,101,32,115,116,101,112,32,115,105,122,101,32,37,46,49,50,103,41,46,32,84,104,105,115,32,99,97,110,32,98,101,32,97,32,112,101,114,102,111,114,109,97,110,99,101,32,98,111,116,116,108,101,110,101,99,107,46,32,85,115,101,32,45,108,118,32,76,79,71,95,69,86,69,78,84,83,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,32,84,104,101,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,119,97,115,58,32,37,115,0,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,114,105,103,104,116,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,111,108,118,101,114,47,101,118,101,110,116,115,46,99,0,0,0,0,0,0,102,105,110,100,82,111,111,116,0,0,0,0,0,0,0,0,115,116,97,116,101,115,95,108,101,102,116,0,0,0,0,0,115,101,97,114,99,104,32,102,111,114,32,99,117,114,114,101,110,116,32,101,118,101,110,116,46,32,69,118,101,110,116,115,32,105,110,32,108,105,115,116,58,32,37,108,100,0,0,0,77,105,110,105,109,117,109,32,118,97,108,117,101,58,32,37,101,0,0,0,0,0,0,0,97,100,100,101,100,32,116,109,112,32,101,118,101,110,116,32,58,32,37,108,100,0,0,0,37,108,100,32,0,0,0,0,98,97,99,107,117,112,95,103,111,117,116,0,0,0,0,0,98,105,115,101,99,116,105,111,110,0,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,109,101,116,104,111,100,32,115,116,97,114,116,115,32,105,110,32,105,110,116,101,114,118,97,108,32,91,37,101,44,32,37,101,93,0,0,0,0,84,84,79,76,32,105,115,32,115,101,116,32,116,111,58,32,37,101,0,0,0,0,0,0,98,105,115,101,99,116,105,111,110,32,99,104,101,99,107,115,32,102,111,114,32,99,111,110,100,105,116,105,111,110,32,99,104,97,110,103,101,115,0,0,37,108,100,32,99,104,97,110,103,101,100,32,102,114,111,109,32,37,115,32,116,111,32,99,117,114,114,101,110,116,32,37,115,0,0,0,0,0,0,0,115,97,118,101,32,97,108,108,32,122,101,114,111,99,114,111,115,115,105,110,103,115,32,97,102,116,101,114,32,97,110,32,101,118,101,110,116,0,0,0,69,82,82,79,82,58,32,84,111,111,32,109,97,110,121,32,101,118,101,110,116,32,105,116,101,114,97,116,105,111,110,115,46,32,83,121,115,116,101,109,32,105,115,32,105,110,99,111,110,115,105,115,116,101,110,116,46,32,83,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,46,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,112,97,114,97,109,101,116,101,114,32,118,97,108,117,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,103,0,0,0,0,0,0,0,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,108,100,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,44,32,102,105,120,101,100,61,37,115,41,32,61,32,37,115,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,0,0,0,0,115,116,97,116,117,115,32,111,102,32,114,101,108,97,116,105,111,110,115,0,0,0,0,0,91,37,108,100,93,32,37,115,32,61,32,37,99,32,124,32,112,114,101,40,37,115,41,32,61,32,37,99,0,0,0,0,89,111,117,114,32,109,101,109,111,114,121,32,105,115,32,110,111,116,32,115,116,114,111,110,103,32,101,110,111,117,103,104,32,102,111,114,32,111,117,114,32,82,105,110,103,98,117,102,102,101,114,33,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,101,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,101,120,116,101,114,110,97,108,32,111,98,106,101,99,116,115,0,0,0,0,0,0,0,187,189,215,217,223,124,219,61,83,101,116,32,116,111,108,101,114,97,110,99,101,32,102,111,114,32,122,101,114,111,45,99,114,111,115,115,105,110,103,32,104,121,115,116,101,114,101,115,105,115,32,116,111,58,32,37,101,0,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,109,105,120,101,100,32,115,111,108,118,101,114,0,0,0,0,0,0,0,109,105,120,101,100,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,91,37,100,93,32,37,115,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,101,77,105,120,101,100,83,101,97,114,99,104,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,0,0,0,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,91,37,100,93,32,37,115,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,108,97,112,97,99,107,46,0,0,0,0,0,0,0,65,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,0,0,0,0,0,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,37,115,0,0,0,0,0,0,98,32,118,101,99,116,111,114,32,91,37,100,93,0,0,0,69,114,114,111,114,32,115,111,108,118,105,110,103,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,46,32,65,114,103,117,109,101,110,116,32,37,100,32,105,108,108,101,103,97,108,46,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,115,111,108,118,101,32,108,105,110,101,97,114,32,115,121,115,116,101,109,32,111,102,32,101,113,117,97,116,105,111,110,115,32,40,110,111,46,32,37,100,41,32,97,116,32,116,105,109,101,32,37,102,44,32,115,121,115,116,101,109,32,105,115,32,115,105,110,103,117,108,97,114,32,102,111,114,32,85,91,37,100,44,32,37,100,93,46,0,0,0,0,0,0,0,37,115,37,49,48,103,32,0,67,111,117,108,100,32,110,111,116,32,97,108,108,111,99,97,116,101,32,100,97,116,97,32,102,111,114,32,108,105,110,101,97,114,32,115,111,108,118,101,114,32,76,105,115,46,0,0,45,105,32,102,103,109,114,101,115,32,0,0,0,0,0,0,78,76,83,95,85,78,75,78,79,87,78,0,0,0,0,0,104,121,98,114,105,100,0,0,107,105,110,115,111,108,0,0,110,101,119,116,111,110,0,0,78,76,83,95,77,65,88,0,224,243,4,0,240,243,4,0,248,243,4,0,0,244,4,0,8,244,4,0,0,0,0,0,117,110,107,110,111,119,110,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,78,101,119,116,111,110,32,82,97,112,104,115,111,110,0,0,40,244,4,0,48,244,4,0,64,244,4,0,80,244,4,0,8,244,4,0,0,0,0,0,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,106,97,99,111,98,105,97,110,32,102,117,110,99,116,105,111,110,32,112,111,105,110,116,101,114,32,105,115,32,105,110,118,97,108,105,100,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,110,111,110,108,105,110,101,97,114,32,115,111,108,118,101,114,0,0,0,110,111,110,108,105,110,101,97,114,32,115,121,115,116,101,109,32,102,97,105,108,115,58,32,37,115,32,97,116,32,116,61,37,103,0,0,0,0,0,0,112,114,111,112,101,114,32,115,116,97,114,116,45,118,97,108,117,101,115,32,102,111,114,32,115,111,109,101,32,111,102,32,116,104,101,32,102,111,108,108,111,119,105,110,103,32,105,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,115,32,109,105,103,104,116,32,104,101,108,112,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,63,44,32,110,111,109,105,110,97,108,61,63,41,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,0,97,108,108,111,99,97,116,105,111,110,72,121,98,114,100,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,0,115,116,97,114,116,32,115,111,108,118,105,110,103,32,110,111,110,45,108,105,110,101,97,114,32,115,121,115,116,101,109,32,62,62,37,115,60,60,32,97,116,32,116,105,109,101,32,37,103,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,102,0,0,0,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,10,111,108,100,32,61,32,37,102,10,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,102,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,0,0,0,0,0,0,0,73,116,101,114,97,116,105,111,110,32,118,97,114,105,97,98,108,101,32,118,97,108,117,101,115,32,40,115,99,97,108,101,100,41,0,0,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,32,102,111,114,32,114,101,115,105,100,117,97,108,32,118,101,99,116,111,114,0,0,0,0,0,115,99,97,108,101,100,32,114,101,115,105,100,117,97,108,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,91,37,100,93,32,58,32,37,46,50,48,101,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,115,121,115,116,101,109,32,115,111,108,118,101,100,0,0,0,37,100,32,114,101,116,114,105,101,115,10,37,100,32,114,101,115,116,97,114,116,115,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,101,99,114,101,97,115,105,110,103,32,105,110,105,116,105,97,108,32,115,116,101,112,32,98,111,117,110,100,32,116,111,32,37,102,46,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,32,97,115,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,0,0,0,0,0,0,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,111,117,116,32,115,99,97,108,105,110,103,32,97,116,32,97,108,108,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,116,111,32,115,111,108,118,101,32,97,32,100,105,115,99,111,110,116,105,110,117,111,117,115,32,115,121,115,116,101,109,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,117,115,101,32,111,108,100,32,118,97,108,117,101,115,32,105,110,115,116,101,97,100,32,101,120,116,114,97,112,111,108,97,116,101,100,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,97,100,100,105,110,103,32,49,37,37,46,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,105,110,105,116,105,97,108,32,112,111,105,110,116,32,98,121,32,45,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,97,115,32,105,110,105,116,105,97,108,32,112,111,105,110,116,46,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,119,105,116,104,32,111,119,110,32,115,99,97,108,105,110,103,32,102,97,99,116,111,114,115,46,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,100,105,115,97,98,108,101,32,115,111,108,118,101,114,32,105,110,116,101,114,110,97,108,32,115,99,97,108,105,110,103,46,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,114,101,100,117,99,101,32,116,104,101,32,116,111,108,101,114,97,110,99,101,32,115,108,105,103,104,116,108,121,32,116,111,32,37,101,46,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,110,108,115,32,115,116,97,116,117,115,0,0,0,0,0,0,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,0,0,102,117,110,99,116,105,111,110,115,0,0,0,0,0,0,0,114,101,115,91,37,100,93,32,61,32,37,46,50,48,101,32,91,115,99,97,108,105,110,103,32,102,97,99,116,111,114,32,61,32,37,49,54,101,93,0,115,116,97,116,105,115,116,105,99,115,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,10,101,114,114,111,114,32,61,32,37,46,50,48,101,10,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,50,48,101,0,0,0,91,37,50,100,93,32,37,50,48,46,49,50,103,0,0,0,45,45,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,120,32,118,101,99,116,111,114,0,0,0,0,0,0,0,0,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,45,45,32,101,110,100,32,111,102,32,114,101,115,105,100,117,97,108,32,102,117,110,99,116,105,111,110,32,99,97,108,108,32,37,100,32,45,45,0,0,45,45,32,98,101,103,105,110,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,0,0,0,0,0,0,45,45,32,101,110,100,32,99,97,108,99,117,108,97,116,105,110,103,32,106,97,99,111,98,105,97,110,32,45,45,0,0,37,115,37,50,48,46,49,50,103,32,0,0,0,0,0,0,87,101,108,108,44,32,116,104,105,115,32,105,115,32,101,109,98,97,114,114,97,115,105,110,103,46,32,84,104,101,32,110,111,110,45,108,105,110,101,97,114,32,115,111,108,118,101,114,32,115,104,111,117,108,100,32,110,101,118,101,114,32,99,97,108,108,32,116,104,105,115,32,99,97,115,101,46,37,100,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,102,97,105,108,101,100,33,0,0,97,108,108,111,99,97,116,105,111,110,78,101,119,116,111,110,68,97,116,97,40,41,32,118,111,105,100,100,97,116,97,32,102,97,105,108,101,100,33,0,83,116,97,114,116,32,115,111,108,118,105,110,103,32,78,111,110,45,76,105,110,101,97,114,32,83,121,115,116,101,109,32,37,115,32,97,116,32,116,105,109,101,32,37,103,32,119,105,116,104,32,78,101,119,116,111,110,32,83,111,108,118,101,114,0,0,0,0,0,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,0,0,0,115,99,97,108,105,110,103,32,61,32,37,102,32,43,43,43,32,111,108,100,32,61,32,37,101,32,43,43,43,32,101,120,116,114,97,112,111,108,97,116,101,100,32,61,32,37,101,0,42,42,42,32,83,121,115,116,101,109,32,115,111,108,118,101,100,32,42,42,42,10,37,100,32,114,101,115,116,97,114,116,115,0,0,0,0,0,0,0,110,102,117,110,99,32,61,32,37,100,32,43,43,43,32,101,114,114,111,114,32,61,32,37,46,49,53,101,32,43,43,43,32,101,114,114,111,114,95,115,99,97,108,101,100,32,61,32,37,46,49,53,101,0,0,0,120,91,37,100,93,32,61,32,37,46,49,53,101,10,9,114,101,115,105,100,117,97,108,32,61,32,37,101,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,111,108,100,32,118,97,108,117,101,115,46,0,0,0,0,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,118,97,114,121,32,115,111,108,117,116,105,111,110,32,112,111,105,110,116,32,98,121,32,49,37,37,46,0,0,0,32,45,32,105,116,101,114,97,116,105,111,110,32,109,97,107,105,110,103,32,110,111,32,112,114,111,103,114,101,115,115,58,9,32,116,114,121,32,110,111,109,105,110,97,108,32,118,97,108,117,101,115,32,97,115,32,105,110,105,116,105,97,108,32,115,111,108,117,116,105,111,110,46,0,0,0,0,0,0,0,35,35,35,32,78,111,32,83,111,108,117,116,105,111,110,33,32,35,35,35,10,32,97,102,116,101,114,32,37,100,32,114,101,115,116,97,114,116,115,0,35,35,35,35,35,35,35,35,35,32,83,116,97,114,116,32,78,101,119,116,111,110,32,109,97,120,102,101,118,58,32,37,100,32,35,35,35,35,35,35,35,35,35,0,0,0,0,0,120,91,37,100,93,58,32,37,101,32,0,0,0,0,0,0,106,97,99,111,98,105,97,110,32,109,97,116,114,105,120,32,91,37,100,120,37,100,93,0,37,115,37,49,48,103,32,0,37,115,0,0,0,0,0,0,74,97,99,111,98,105,97,110,32,77,97,116,114,105,120,32,115,105,110,103,117,108,97,114,33,0,0,0,0,0,0,0,105,108,108,101,103,97,108,32,32,105,110,112,117,116,32,105,110,32,97,114,103,117,109,101,110,116,32,37,100,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,63,0,0,0,0,0,0,224,63,0,0,0,0,0,0,240,63,73,110,105,116,105,97,108,105,122,105,110,103,32,68,65,83,83,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,116,111], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+317468);
/* memory initializer */ allocate([114,105,110,103,32,114,101,115,117,108,116,115,32,97,110,100,32,101,120,105,116,105,110,103,46,10,85,115,101,32,45,108,118,61,76,79,71,95,73,78,73,84,32,45,119,32,102,111,114,32,109,111,114,101,32,105,110,102,111,114,109,97,116,105,111,110,46,0,115,105,109,117,108,97,116,105,111,110,32,116,101,114,109,105,110,97,116,101,100,32,98,121,32,97,110,32,97,115,115,101,114,116,105,111,110,32,97,116,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,87,114,111,116,101,32,112,97,114,97,109,101,116,101,114,115,32,116,111,32,116,104,101,32,102,105,108,101,32,97,102,116,101,114,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,40,102,111,114,32,111,117,116,112,117,116,32,102,111,114,109,97,116,115,32,116,104,97,116,32,115,117,112,112,111,114,116,32,116,104,105,115,41,0,0,0,0,0,0,0,0,116,101,114,109,105,110,97,108,32,101,118,101,110,116,32,97,116,32,115,116,111,112,32,116,105,109,101,32,37,103,0,0,70,105,110,105,115,104,101,100,0,0,0,0,0,0,0,0,35,35,35,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,0,0,0,0,116,105,109,101,114,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,112,114,101,45,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,116,101,112,115,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,99,114,101,97,116,105,110,103,32,111,117,116,112,117,116,45,102,105,108,101,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,101,118,101,110,116,45,104,97,110,100,108,105,110,103,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,118,101,114,104,101,97,100,0,0,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,115,105,109,117,108,97,116,105,111,110,0,0,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,37,49,50,103,115,32,91,37,53,46,49,102,37,37,93,32,116,111,116,97,108,0,0,0,101,118,101,110,116,115,0,0,37,53,108,100,32,115,116,97,116,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,37,53,108,100,32,116,105,109,101,32,101,118,101,110,116,115,0,0,0,0,0,0,0,0,115,111,108,118,101,114,58,32,68,65,83,83,76,0,0,0,37,53,100,32,115,116,101,112,115,32,116,97,107,101,110,0,37,53,100,32,99,97,108,108,115,32,111,102,32,102,117,110,99,116,105,111,110,79,68,69,0,0,0,0,0,0,0,0,37,53,100,32,101,118,97,108,117,97,116,105,111,110,115,32,111,102,32,106,97,99,111,98,105,97,110,0,0,0,0,0,37,53,100,32,101,114,114,111,114,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,37,53,100,32,99,111,110,118,101,114,103,101,110,99,101,32,116,101,115,116,32,102,97,105,108,117,114,101,115,0,0,0,115,111,108,118,101,114,0,0,115,111,114,114,121,32,45,32,110,111,32,115,111,108,118,101,114,32,115,116,97,116,105,115,116,105,99,115,32,97,118,97,105,108,97,98,108,101,46,32,91,110,111,116,32,121,101,116,32,105,109,112,108,101,109,101,110,116,101,100,93,0,0,0,35,35,35,32,69,78,68,32,83,84,65,84,73,83,84,73,67,83,32,35,35,35,0,0,83,117,110,100,105,97,108,47,107,105,110,115,111,108,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,32,80,108,101,97,115,101,32,99,104,111,111,115,101,32,111,116,104,101,114,32,115,111,108,118,101,114,46,0,73,112,111,112,116,32,105,115,32,110,101,101,100,101,100,32,98,117,116,32,110,111,116,32,97,118,97,105,108,97,98,108,101,46,0,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,101,117,108,101,114,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,69,85,76,69,82,46,0,0,0,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,82,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,44,32,98,117,116,32,116,104,101,32,101,120,101,99,117,116,97,98,108,101,32,119,97,115,32,110,111,116,32,99,111,109,112,105,108,101,100,32,119,105,116,104,32,115,117,112,112,111,114,116,32,102,111,114,32,105,116,46,32,67,111,109,112,105,108,101,32,119,105,116,104,32,45,68,95,79,77,67,95,73,78,76,73,78,69,95,82,75,46,0,0,0,83,116,97,114,116,32,110,117,109,101,114,105,99,97,108,32,115,111,108,118,101,114,32,102,114,111,109,32,37,103,32,116,111,32,37,103,0,0,0,0,44,0,0,0,0,0,0,0,116,105,109,101,61,37,46,50,48,103,0,0,0,0,0,0,44,37,115,61,37,46,50,48,103,0,0,0,0,0,0,0,44,37,115,61,37,108,105,0,44,37,115,61,37,105,0,0,44,37,115,61,34,37,115,34,0,0,0,0,0,0,0,0,99,97,110,32,110,111,116,32,105,110,105,116,105,97,108,122,101,32,74,97,99,111,98,105,97,110,115,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,0,106,97,99,111,98,105,97,110,32,37,100,120,37,100,32,91,105,100,58,32,37,108,100,93,0,0,0,0,0,0,0,0,37,115,37,46,53,101,32,0,37,115,0,0,0,0,0,0,69,114,114,111,114,44,32,115,105,110,103,117,108,97,114,32,74,97,99,111,98,105,97,110,32,102,111,114,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,32,97,116,32,116,105,109,101,32,37,102,10,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,95,74,65,67,32,116,111,32,103,101,116,32,116,104,101,32,74,97,99,111,98,105,97,110,0,115,101,108,101,99,116,32,110,101,119,32,115,116,97,116,101,115,32,97,116,32,116,105,109,101,32,37,102,0,0,0,0,115,101,108,101,99,116,32,37,115,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,73,110,112,117,116,46,99,115,118,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,37,108,102,0,0,0,0,0,10,69,120,116,101,114,110,97,108,32,73,110,112,117,116,0,10,73,110,112,117,116,58,32,116,61,37,102,32,32,32,9,0,0,0,0,0,0,0,0,117,37,100,40,116,41,61,32,37,102,32,9,0,0,0,0,10,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,61,0,0,0,0,0,0,0,101,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,121,115,116,101,109,32,111,102,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,97,114,101,32,110,111,116,32,99,111,110,115,105,115,116,101,110,116,10,40,108,101,97,115,116,32,115,113,117,97,114,101,32,102,117,110,99,116,105,111,110,32,118,97,108,117,101,32,105,115,32,37,103,41,0,0,0,0,0,114,101,115,105,100,117,97,108,91,37,108,100,93,32,61,32,37,103,0,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,115,116,97,116,117,115,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,32,91,115,99,97,108,101,100,58,32,37,103,93,0,0,0,0,0,108,101,97,115,116,32,115,113,117,97,114,101,32,118,97,108,117,101,58,32,37,103,0,0,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,0,0,0,0,0,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,112,97,114,97,109,101,116,101,114,41,0,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,32,91,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,58,32,37,103,93,0,91,37,108,100,93,32,91,37,49,53,103,93,32,58,61,32,37,115,32,40,100,105,115,99,114,101,116,101,41,0,0,0,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,0,0,0,0,0,0,0,35,35,35,32,83,79,76,85,84,73,79,78,32,79,70,32,84,72,69,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,115,116,97,116,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,0,0,100,101,114,105,118,97,116,105,118,101,115,32,118,97,114,105,97,98,108,101,115,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,32,61,32,37,103,32,40,112,114,101,58,32,37,103,41,0,0,0,0,111,116,104,101,114,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,73,110,116,101,103,101,114,32,37,115,40,115,116,97,114,116,61,37,108,100,41,32,61,32,37,108,100,32,40,112,114,101,58,32,37,108,100,41,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,91,37,108,100,93,32,66,111,111,108,101,97,110,32,37,115,40,115,116,97,114,116,61,37,115,41,32,61,32,37,115,32,40,112,114,101,58,32,37,115,41,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,91,37,108,100,93,32,83,116,114,105,110,103,32,37,115,40,115,116,97,114,116,61,34,37,115,34,41,32,61,32,34,37,115,34,32,40,112,114,101,58,32,34,37,115,34,41,0,0,35,35,35,32,83,84,65,82,84,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,16,15,5,0,216,16,5,0,224,16,5,0,232,16,5,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,105,109,32,37,115,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,124,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,16,15,5,0,24,16,5,0,104,16,5,0,152,16,5,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,16,15,5,0,216,15,5,0,224,15,5,0,232,15,5,0,248,15,5,0,0,16,5,0,16,16,5,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,105,111,109,32,37,115,0,0,0,0,0,16,15,5,0,24,15,5,0,48,15,5,0,64,15,5,0,136,15,5,0,152,15,5,0,184,15,5,0,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,32,109,101,116,104,111,100,58,32,32,32,37,45,49,53,115,32,91,37,115,93,0,0,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,105,109,0,35,35,35,32,69,78,68,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,35,35,35,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,37,115,95,104,111,109,111,116,111,112,121,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,108,97,109,98,100,97,0,0,104,111,109,111,116,111,112,121,32,112,114,111,99,101,115,115,0,0,0,0,0,0,0,0,108,97,109,98,100,97,32,61,32,37,103,32,100,111,110,101,0,0,0,0,0,0,0,0,37,46,49,54,103,44,0,0,67,97,110,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,117,110,105,113,117,101,32,116,104,101,32,100,121,110,97,109,105,99,32,115,116,97,116,101,32,115,101,108,101,99,116,105,111,110,46,32,85,115,101,32,45,108,118,32,76,79,71,95,68,83,83,32,116,111,32,115,101,101,32,116,104,101,32,115,119,105,116,99,104,105,110,103,32,115,116,97,116,101,32,115,101,116,46,0,0,0,110,111,32,118,97,114,105,97,98,108,101,115,32,116,111,32,105,110,105,116,105,97,108,105,122,101,0,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,32,40,110,101,105,116,104,101,114,32,105,110,105,116,105,97,108,32,101,113,117,97,116,105,111,110,115,32,110,111,114,32,105,110,105,116,105,97,108,32,97,108,103,111,114,105,116,104,109,115,41,0,117,110,100,101,114,45,100,101,116,101,114,109,105,110,101,100,0,0,0,0,0,0,0,0,115,101,116,116,105,110,103,32,102,105,120,101,100,61,116,114,117,101,32,102,111,114,58,0,37,115,40,102,105,120,101,100,61,116,114,117,101,41,32,61,32,37,103,0,0,0,0,0,110,111,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,0,0,111,118,101,114,45,100,101,116,101,114,109,105,110,101,100,0,115,116,97,114,116,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,0,0,115,107,105,112,32,119,47,111,32,115,99,97,108,105,110,103,0,0,0,0,0,0,0,0,35,35,35,32,70,73,78,65,76,32,73,78,73,84,73,65,76,73,90,65,84,73,79,78,32,82,69,83,85,76,84,83,32,35,35,35,0,0,0,0,105,110,105,116,105,97,108,105,122,97,116,105,111,110,45,110,114,46,32,37,108,100,0,0,117,110,115,117,112,112,111,114,116,101,100,32,111,112,116,105,111,110,32,45,105,111,109,0,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,110,111,116,32,117,112,100,97,116,105,110,103,32,98,101,115,116,90,0,0,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,45,99,97,108,108,115,58,32,37,108,100,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,105,109,112,111,114,116,32,115,116,97,114,116,32,118,97,108,117,101,115,10,102,105,108,101,58,32,37,115,10,116,105,109,101,58,32,37,103,0,0,0,117,110,97,98,108,101,32,116,111,32,114,101,97,100,32,105,110,112,117,116,45,102,105,108,101,32,60,37,115,62,32,91,37,115,93,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,115,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,103,41,0,0,36,90,69,82,79,46,0,0,36,112,68,69,82,46,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,118,97,114,105,97,98,108,101,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,114,101,97,108,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,0,0,0,105,109,112,111,114,116,32,114,101,97,108,32,100,105,115,99,114,101,116,101,0,0,0,0,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,108,100,41,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,124,32,37,115,40,115,116,97,114,116,61,37,115,41,0,0,117,110,97,98,108,101,32,116,111,32,105,109,112,111,114,116,32,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,32,37,115,32,102,114,111,109,32,103,105,118,101,110,32,102,105,108,101,0,0,0,100,101,114,40,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,105,110,105,116,105,97,108,32,112,114,111,98,108,101,109,58,0,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,117,110,102,105,120,101,100,32,118,97,114,105,97,98,108,101,115,58,32,32,37,108,100,32,40,37,108,100,32,115,116,97,116,101,115,32,43,32,37,108,100,32,112,97,114,97,109,101,116,101,114,115,32,43,32,37,108,100,32,100,105,115,99,114,101,116,101,32,114,101,97,108,115,41,0,0,0,0,91,37,108,100,93,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,0,91,37,108,100,93,32,112,97,114,97,109,101,116,101,114,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,91,37,108,100,93,32,100,105,115,99,114,101,116,101,32,82,101,97,108,32,37,115,40,115,116,97,114,116,61,37,103,44,32,110,111,109,105,110,97,108,61,37,103,41,32,61,32,37,103,0,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,114,101,115,105,100,117,97,108,115,58,32,32,37,108,100,32,40,37,108,100,32,101,113,117,97,116,105,111,110,115,32,43,32,37,108,100,32,97,108,103,111,114,105,116,104,109,115,41,0,0,0,0,0,0,110,117,109,98,101,114,32,111,102,32,115,116,97,114,116,32,118,97,108,117,101,32,114,101,115,105,100,117,97,108,115,58,32,37,108,100,0,0,0,0,91,37,108,100,93,32,114,101,115,105,100,117,97,108,32,105,115,32,105,110,101,102,102,101,99,116,105,118,101,32,40,115,99,97,108,105,110,103,32,99,111,101,102,102,105,99,105,101,110,116,32,105,115,32,115,101,116,32,116,111,32,49,46,48,41,0,0,0,0,0,0,0,110,111,32,105,112,111,112,116,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,0,0,110,111,32,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,115,117,112,112,111,114,116,32,97,99,116,105,118,97,116,101,100,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,95,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,124,32,82,101,115,117,108,116,32,111,102,32,108,101,97,115,116,83,113,117,97,114,101,32,109,101,116,104,111,100,32,61,32,37,103,46,32,84,104,101,32,105,110,105,116,105,97,108,32,103,117,101,115,115,32,102,105,116,115,32,116,111,32,116,104,101,32,115,121,115,116,101,109,0,0,0,0,0,0,0,0,108,101,97,115,116,83,113,117,97,114,101,61,37,103,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,83,111,108,118,101,114,32,105,116,101,114,97,116,101,100,32,37,100,32,116,105,109,101,115,32,119,105,116,104,111,117,116,32,102,105,110,100,105,110,103,32,97,32,115,111,108,117,116,105,111,110,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,99,111,110,115,105,115,116,101,110,116,32,105,110,105,116,105,97,108,32,99,111,110,100,105,116,105,111,110,115,46,0,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,78,117,109,98,101,114,32,111,102,32,105,110,105,116,105,97,108,32,118,97,108,117,101,115,32,116,111,32,99,97,108,99,117,108,97,116,101,32,60,32,49,0,0,0,0,0,0,69,114,114,111,114,32,105,110,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,46,32,73,110,116,101,114,110,97,108,32,101,114,114,111,114,44,32,78,76,79,79,80,32,60,32,49,46,0,0,0,0,0,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,105,116,101,114,97,116,105,111,110,115,58,32,37,108,100,0,116,114,121,32,45,105,108,115,32,116,111,32,97,99,116,105,118,97,116,101,32,115,116,97,114,116,32,118,97,108,117,101,32,104,111,109,111,116,111,112,121,0,0,0,0,0,0,0,37,115,95,105,110,105,116,80,97,116,104,46,99,115,118,0,119,116,0,0,0,0,0,0,37,115,44,0,0,0,0,0,105,116,101,114,97,116,105,111,110,0,0,0,0,0,0,0,108,97,109,98,100,97,0,0,37,108,100,44,0,0,0,0,37,46,49,54,103,44,0,0,111,117,116,32,111,102,32,109,101,109,111,114,121,0,0,0,108,97,109,98,100,97,32,105,115,32,37,45,51,103,32,105,110,32,115,116,101,112,61,37,54,100,32,97,116,32,102,61,37,103,32,91,37,103,93,0,105,110,99,114,101,97,115,105,110,103,32,108,97,109,98,100,97,32,116,111,32,37,45,51,103,32,105,110,32,115,116,101,112,32,37,54,100,32,97,116,32,102,61,37,103,0,0,0,102,120,114,32,61,32,37,103,0,0,0,0,0,0,0,0,102,120,107,32,61,32,37,103,0,0,0,0,0,0,0,0,117,110,100,101,102,105,110,101,100,32,101,114,114,111,114,32,105,110,32,78,101,108,100,101,114,77,101,97,100,79,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,2,0,0,0,37,46,49,54,103,44,0,0,37,105,44,0,0,0,0,0,34,37,115,34,44,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,116,105,109,101,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,100,97,116,97,95,49,0,0,65,49,32,98,116,46,32,105,114,49,32,110,97,32,32,84,106,32,32,114,101,32,32,97,99,32,32,110,116,32,32,115,111,32,32,32,114,32,32,32,121,32,32,32,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,65,99,108,97,115,115,0,0,110,97,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,100,97,116,97,73,110,102,111,0,0,0,0,0,0,0,0,100,97,116,97,95,50,0,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,102,105,108,101,32,37,115,0,0,0,0,0,67,97,110,110,111,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,0,0,67,97,110,110,111,116,32,119,114,105,116,101,32,116,111,32,102,105,108,101,32,37,115,0,67,97,110,110,111,116,32,97,108,108,111,99,32,109,101,109,111,114,121,0,0,0,0,0,77,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,119,0,0,0,0,0,0,0,97,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,114,43,0,0,0,0,0,0,119,43,0,0,0,0,0,0,97,43,0,0,0,0,0,0,119,98,0,0,0,0,0,0,97,98,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,43,98,0,0,0,0,0,119,43,98,0,0,0,0,0,97,43,98,0,0,0,0,0,100,101,114,40,0,0,0,0,104,0,0,0,0,0,0,0,192,26,5,0,8,0,0,0,9,0,0,0,152,255,255,255,152,255,255,255,192,26,5,0,10,0,0,0,11,0,0,0,100,26,5,0,220,26,5,0,240,26,5,0,120,26,5,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,111,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,144,212,5,0,144,26,5,0,24,144,5,0,0,0,0,0,104,0,0,0,0,0,0,0,24,144,5,0,12,0,0,0,13,0,0,0,152,255,255,255,152,255,255,255,24,144,5,0,14,0,0,0,15,0,0,0,0,0,0,0,104,27,5,0,16,0,0,0,17,0,0,0,3,0,0,0,8,0,0,0,2,0,0,0,4,0,0,0,31,0,0,0,32,0,0,0,9,0,0,0,33,0,0,0,34,0,0,0,24,0,0,0,10,0,0,0,25,0,0,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,102,105,108,101,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,144,212,5,0,56,27,5,0,16,143,5,0,0,0,0,0,0,0,0,0,240,27,5,0,248,27,5,0,232,27,5,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,200,27,5,0,216,27,5,0,232,27,5,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,36,99,112,117,84,105,109,101,0,0,0,0,0,0,0,0,99,112,117,32,116,105,109,101,32,91,115,93,0,0,0,0,0,0,0,0,0,0,0,0,116,105,109,101,0,0,0,0,83,105,109,117,108,97,116,105,111,110,32,116,105,109,101,32,91,115,93,0,0,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,0,0,0,0,0,65,117,116,111,109,97,116,105,99,32,111,117,116,112,117,116,32,115,116,101,112,115,32,110,111,116,32,115,117,112,112,111,114,116,101,100,32,105,110,32,79,112,101,110,77,111,100,101,108,105,99,97,32,121,101,116,46,32,83,101,116,32,110,117,109,112,111,105,110,116,115,32,62,61,32,48,46,0,0,0,69,114,114,111,114,32,97,108,108,111,99,97,116,105,110,103,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,111,102,32,115,105,122,101,32,37,108,100,32,102,97,105,108,101,100,0,0,0,0,0,0,119,0,0,0,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,99,114,101,97,116,101,32,111,117,116,112,117,116,32,102,105,108,101,58,32,91,37,115,93,32,98,101,99,97,117,115,101,32,111,102,32,37,115,0,0,35,80,116,111,108,101,109,121,32,80,108,111,116,32,102,105,108,101,44,32,103,101,110,101,114,97,116,101,100,32,98,121,32,79,112,101,110,77,111,100,101,108,105,99,97,10,0,0,35,78,117,109,98,101,114,111,102,86,97,114,105,97,98,108,101,115,61,37,100,10,0,0,35,73,110,116,101,114,118,97,108,83,105,122,101,61,37,108,100,10,0,0,0,0,0,0,84,105,116,108,101,84,101,120,116,58,32,79,112,101,110,77,111,100,101,108,105,99,97,32,115,105,109,117,108,97,116,105,111,110,32,112,108,111,116,10,0,0,0,0,0,0,0,0,88,76,97,98,101,108,58,32,116,10,10,0,0,0,0,0,68,97,116,97,83,101,116,58,32,116,105,109,101,10,0,0,68,97,116,97,83,101,116,58,32,36,99,112,117,84,105,109,101,10,0,0,0,0,0,0,68,97,116,97,83,101,116,58,32,37,115,10,0,0,0,0,69,114,114,111,114,44,32,99,111,117,108,100,110,39,116,32,119,114,105,116,101,32,116,111,32,111,117,116,112,117,116,32,102,105,108,101,32,37,115,10,0,0,0,0,0,0,0,0,37,46,49,54,103,44,32,37,46,49,54,103,10,0,0,0,114,101,99,111,110,58,119,97,108,108,58,118,48,49,0,0,0,0,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,32,102,111,114,32,119,114,105,116,105,110,103,0,69,114,114,111,114,32,119,104,105,108,101,32,119,114,105,116,105,110,103,32,109,97,116,32,102,105,108,101,32,37,115,0,112,97,114,97,109,115,0,0,99,111,110,116,105,110,117,111,117,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,101,116,97,0,0,0,116,97,98,115,0,0,0,0,111,98,106,115,0,0,0,0,116,109,101,116,97,0,0,0,115,105,103,115,0,0,0,0,116,105,109,101,0,0,0,0,1,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,118,109,101,116,97,0,0,0,84,105,109,101,0,0,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,97,108,115,0,0,0,0,0,115,0,0,0,0,0,0,0,116,0,0,0,0,0,0,0,105,110,118,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,110,97,109,101,0,0,0,0,118,97,108,117,101,82,101,102,101,114,101,110,99,101,0,0,100,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,102,105,108,101,78,97,109,101,0,0,0,0,0,0,0,0,115,116,97,114,116,76,105,110,101,0,0,0,0,0,0,0,115,116,97,114,116,67,111,108,117,109,110,0,0,0,0,0,101,110,100,76,105,110,101,0,101,110,100,67,111,108,117,109,110,0,0,0,0,0,0,0,102,105,108,101,87,114,105,116,97,98,108,101,0,0,0,0,117,115,101,83,116,97,114,116,0,0,0,0,0,0,0,0,115,116,97,114,116,0,0,0,102,105,120,101,100,0,0,0,117,115,101,78,111,109,105,110,97,108,0,0,0,0,0,0,110,111,109,105,110,97,108,0,109,105,110,0,0,0,0,0,109,97,120,0,0,0,0,0,82,101,97,108,32,37,115,40,37,115,115,116,97,114,116,61,37,103,37,115,44,32,102,105,120,101,100,61,37,115,44,32,37,115,110,111,109,105,110,97,108,61,37,103,37,115,44,32,109,105,110,61,37,103,44,32,109,97,120,61,37,103,41,0,0,0,0,0,0,0,0,0,123,0,0,0,0,0,0,0,125,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,102,97,108,115,101,0,0,0,73,110,116,101,103,101,114,32,37,115,40,37,115,115,116,97,114,116,61,37,108,100,37,115,44,32,102,105,120,101,100,61,37,115,44,32,109,105,110,61,37,108,100,44,32,109,97,120,61,37,108,100,41,0,0,0,66,111,111,108,101,97,110,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,44,32,102,105,120,101,100,61,37,115,41,0,0,0,0,0,0,83,116,114,105,110,103,32,37,115,40,37,115,115,116,97,114,116,61,37,115,37,115,41,0,95,105,110,105,116,46,120,109,108,0,0,0,0,0,0,0,114,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,97,110,32,110,111,116,32,114,101,97,100,32,102,105,108,101,32,37,115,32,97,115,32,115,101,116,117,112,32,102,105,108,101,32,116,111,32,116,104,101,32,103,101,110,101,114,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,99,111,100,101,46,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,99,111,117,108,100,110,39,116,32,97,108,108,111,99,97,116,101,32,109,101,109,111,114,121,32,102,111,114,32,116,104,101,32,88,77,76,32,112,97,114,115,101,114,33,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,37,115,44,32,37,115,32,37,108,117,10,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,10,0,0,0,0,0,0,0,0,103,117,105,100,0,0,0,0,84,104,101,32,77,111,100,101,108,32,71,85,73,68,58,32,37,115,32,105,115,32,110,111,116,32,115,101,116,32,105,110,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,0,69,114,114,111,114,44,32,116,104,101,32,71,85,73,68,58,32,37,115,32,102,114,111,109,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,58,32,37,115,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,116,104,101,32,71,85,73,68,32,99,111,109,112,105,108,101,100,32,105,110,32,116,104,101,32,109,111,100,101,108,58,32,37,115,0,0,114,101,97,100,32,97,108,108,32,116,104,101,32,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,32,118,97,108,117,101,115,58,0,0,115,116,97,114,116,84,105,109,101,0,0,0,0,0,0,0,115,116,97,114,116,84,105,109,101,32,61,32,37,103,0,0,115,116,111,112,84,105,109,101,0,0,0,0,0,0,0,0,115,116,111,112,84,105,109,101,32,61,32,37,103,0,0,0,115,116,101,112,83,105,122,101,0,0,0,0,0,0,0,0,115,116,101,112,83,105,122,101,32,61,32,37,103,0,0,0,116,111,108,101,114,97,110,99,101,0,0,0,0,0,0,0,116,111,108,101,114,97,110,99,101,32,61,32,37,103,0,0,115,111,108,118,101,114,0,0,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,0,0,0,0,0,0,0,111,117,116,112,117,116,70,111,114,109,97,116,0,0,0,0,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,37,115,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,70,105,108,116,101,114,0,0,118,97,114,105,97,98,108,101,32,102,105,108,116,101,114,58,32,37,115,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,0,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,58,32,37,115,0,0,0,0,110,117,109,98,101,114,79,102,67,111,110,116,105,110,117,111,117,115,83,116,97,116,101,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,82,101,97,108,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,110,117,109,98,101,114,79,102,82,101,97,108,80,97,114,97,109,101,116,101,114,115,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,103,101,114,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,66,111,111,108,101,97,110,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,80,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,83,116,114,105,110,103,65,108,103,101,98,114,97,105,99,86,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,69,114,114,111,114,44,32,105,110,112,117,116,32,100,97,116,97,32,102,105,108,101,32,100,111,101,115,32,110,111,116,32,109,97,116,99,104,32,109,111,100,101,108,46,0,0,0,0,110,120,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,100,0,0,0,0,0,0,0,110,121,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,0,0,0,110,112,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,105,110,116,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,112,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,121,98,111,111,108,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,110,112,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,110,121,115,116,114,32,105,110,32,115,101,116,117,112,32,102,105,108,101,58,32,37,108,100,32,102,114,111,109,32,109,111,100,101,108,32,99,111,100,101,58,32,37,108,100,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,37,115,0,0,0,0,114,101,97,108,32,115,116,97,116,101,115,0,0,0,0,0,105,115,80,114,111,116,101,99,116,101,100,0,0,0,0,0,102,105,108,116,101,114,105,110,103,32,112,114,111,116,101,99,116,101,100,32,118,97,114,105,97,98,108,101,32,37,115,0,114,101,97,108], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+327708);
/* memory initializer */ allocate([32,115,116,97,116,101,32,100,101,114,105,118,97,116,105,118,101,115,0,0,114,101,97,108,32,97,108,103,101,98,114,97,105,99,115,0,105,110,116,101,103,101,114,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,98,111,111,108,101,97,110,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,115,116,114,105,110,103,32,118,97,114,105,97,98,108,101,115,0,0,0,0,0,0,0,0,114,101,97,108,32,112,97,114,97,109,101,116,101,114,115,0,105,110,116,101,103,101,114,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,98,111,111,108,101,97,110,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,115,116,114,105,110,103,32,112,97,114,97,109,101,116,101,114,115,0,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,114,101,97,108,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,0,0,97,108,105,97,115,0,0,0,110,101,103,97,116,101,100,65,108,105,97,115,0,0,0,0,114,101,97,100,32,102,111,114,32,37,115,32,110,101,103,97,116,101,100,32,37,100,32,102,114,111,109,32,115,101,116,117,112,32,102,105,108,101,0,0,97,108,105,97,115,86,97,114,105,97,98,108,101,0,0,0,116,105,109,101,0,0,0,0,82,101,97,108,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,0,0,32,110,111,116,32,102,111,117,110,100,46,0,0,0,0,0,37,115,0,0,0,0,0,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,105,110,116,101,103,101,114,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,73,110,116,101,103,101,114,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,98,111,111,108,101,97,110,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,66,111,111,108,101,97,110,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,114,101,97,100,32,120,109,108,32,102,105,108,101,32,102,111,114,32,115,116,114,105,110,103,32,97,108,105,97,115,32,118,97,114,115,0,0,0,0,0,83,116,114,105,110,103,32,65,108,105,97,115,32,118,97,114,105,97,98,108,101,32,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,117,115,97,103,101,32,101,114,114,111,114,32,121,111,117,32,99,97,110,110,111,116,32,104,97,118,101,32,98,111,116,104,32,45,111,118,101,114,114,105,100,101,32,97,110,100,32,45,111,118,101,114,114,105,100,101,70,105,108,101,32,97,99,116,105,118,101,32,97,116,32,116,104,101,32,115,97,109,101,32,116,105,109,101,46,32,115,101,101,32,77,111,100,101,108,32,45,63,32,102,111,114,32,109,111,114,101,32,105,110,102,111,33,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,32,102,114,111,109,32,102,105,108,101,58,32,37,115,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,99,111,117,108,100,32,110,111,116,32,111,112,101,110,32,116,104,101,32,102,105,108,101,32,103,105,118,101,110,32,116,111,32,45,111,118,101,114,114,105,100,101,70,105,108,101,61,37,115,0,0,0,0,0,44,0,0,0,0,0,0,0,114,101,97,100,32,111,118,101,114,114,105,100,101,32,118,97,108,117,101,115,58,32,37,115,0,0,0,0,0,0,0,0,61,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,37,115,32,61,32,37,115,0,0,0,0,0,0,0,0,111,118,101,114,114,105,100,101,32,100,111,110,101,33,0,0,78,79,32,111,118,101,114,114,105,100,101,32,103,105,118,101,110,32,111,110,32,116,104,101,32,99,111,109,109,97,110,100,32,108,105,110,101,46,0,0,108,0,0,0,0,0,0,0,72,44,5,0,18,0,0,0,19,0,0,0,148,255,255,255,148,255,255,255,72,44,5,0,20,0,0,0,21,0,0,0,236,43,5,0,100,44,5,0,120,44,5,0,0,44,5,0,78,83,116,51,95,95,49,49,52,98,97,115,105,99,95,105,102,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,144,212,5,0,24,44,5,0,136,143,5,0,0,0,0,0,108,0,0,0,0,0,0,0,136,143,5,0,22,0,0,0,23,0,0,0,148,255,255,255,148,255,255,255,136,143,5,0,24,0,0,0,25,0,0,0,101,114,114,111,114,32,114,101,97,100,95,118,97,108,117,101,44,32,110,111,32,100,97,116,97,32,97,108,108,111,99,97,116,101,100,32,102,111,114,32,115,116,111,114,105,110,103,32,115,116,114,105,110,103,0,0,102,109,105,77,111,100,101,108,68,101,115,99,114,105,112,116,105,111,110,0,0,0,0,0,68,101,102,97,117,108,116,69,120,112,101,114,105,109,101,110,116,0,0,0,0,0,0,0,83,99,97,108,97,114,86,97,114,105,97,98,108,101,0,0,99,108,97,115,115,73,110,100,101,120,0,0,0,0,0,0,99,108,97,115,115,84,121,112,101,0,0,0,0,0,0,0,114,83,116,97,0,0,0,0,114,68,101,114,0,0,0,0,114,65,108,103,0,0,0,0,114,80,97,114,0,0,0,0,114,65,108,105,0,0,0,0,105,65,108,103,0,0,0,0,105,80,97,114,0,0,0,0,105,65,108,105,0,0,0,0,98,65,108,103,0,0,0,0,98,80,97,114,0,0,0,0,98,65,108,105,0,0,0,0,115,65,108,103,0,0,0,0,115,80,97,114,0,0,0,0,115,65,108,105,0,0,0,0,115,105,109,117,108,97,116,105,111,110,95,105,110,112,117,116,95,120,109,108,46,99,112,112,58,32,101,114,114,111,114,32,114,101,97,100,105,110,103,32,116,104,101,32,120,109,108,32,102,105,108,101,44,32,102,111,117,110,100,32,117,110,107,110,111,119,110,32,99,108,97,115,115,58,32,37,115,32,32,102,111,114,32,118,97,114,105,97,98,108,101,58,32,37,115,0,82,101,97,108,0,0,0,0,73,110,116,101,103,101,114,0,66,111,111,108,101,97,110,0,83,116,114,105,110,103,0,0,118,97,114,105,97,98,108,101,84,121,112,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,76,79,71,95,65,76,76,0,44,0,0,0,0,0,0,0,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,37,45,49,56,115,32,91,37,115,93,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,118,32,37,115,0,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,110,108,115,61,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,115,101,101,32,108,97,115,116,32,119,97,114,110,105,110,103,0,0,0,0,0,0,0,0,108,97,112,97,99,107,0,0,108,105,115,0,0,0,0,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,108,115,32,37,115,44,32,99,117,114,114,101,110,116,32,111,112,116,105,111,110,115,32,97,114,101,58,0,0,0,0,0,0,0,0,100,101,102,97,117,108,116,32,109,101,116,104,111,100,0,0,76,105,115,0,0,0,0,0,94,40,0,0,0,0,0,0,41,36,0,0,0,0,0,0,36,100,117,109,109,121,0,0,46,42,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,111,109,112,105,108,101,32,114,101,103,117,108,97,114,32,101,120,112,114,101,115,115,105,111,110,58,32,0,0,32,119,105,116,104,32,101,114,114,111,114,58,32,0,0,0,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,111,117,116,112,117,116,116,105,110,103,32,97,108,108,32,118,97,114,105,97,98,108,101,115,46,0,0,0,0,0,0,0,110,117,109,98,101,114,79,102,73,110,116,101,114,118,97,108,115,32,61,32,37,108,100,0,67,80,85,0,0,0,0,0,82,84,0,0,0,0,0,0,67,89,67,0,0,0,0,0,91,117,110,107,110,111,119,110,32,99,108,111,99,107,45,116,121,112,101,93,32,103,111,116,32,37,115,44,32,101,120,112,101,99,116,101,100,32,67,80,85,124,82,84,124,67,89,67,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,82,84,46,0,0,0,0,0,67,104,111,115,101,110,32,99,108,111,99,107,45,116,121,112,101,58,32,37,115,32,110,111,116,32,97,118,97,105,108,97,98,108,101,32,102,111,114,32,116,104,101,32,99,117,114,114,101,110,116,32,112,108,97,116,102,111,114,109,46,32,68,101,102,97,117,108,116,105,110,103,32,116,111,32,114,101,97,108,45,116,105,109,101,46,0,0,76,105,110,101,97,114,105,122,97,116,105,111,110,32,119,105,108,108,32,112,101,114,102,111,114,109,101,100,32,97,116,32,112,111,105,110,116,32,111,102,32,116,105,109,101,58,32,37,102,0,0,0,0,0,0,0,111,118,101,114,119,114,105,116,101,32,115,111,108,118,101,114,32,109,101,116,104,111,100,58,32,37,115,32,91,102,114,111,109,32,99,111,109,109,97,110,100,32,108,105,110,101,93,0,95,114,101,115,46,0,0,0,0,0,0,0,0,0,0,0,76,105,110,101,97,114,32,109,111,100,101,108,32,105,115,32,99,114,101,97,116,101,100,33,0,0,0,0,0,0,0,0,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,95,112,114,111,102,46,112,108,116,0,0,0,0,0,0,0,115,118,103,0,0,0,0,0,101,109,112,116,121,0,0,0,99,115,118,0,0,0,0,0,109,97,116,0,0,0,0,0,119,97,108,108,0,0,0,0,112,108,116,0,0,0,0,0,85,110,107,110,111,119,110,32,111,117,116,112,117,116,32,102,111,114,109,97,116,58,32,0,65,108,108,111,99,97,116,101,100,32,115,105,109,117,108,97,116,105,111,110,32,114,101,115,117,108,116,32,100,97,116,97,32,115,116,111,114,97,103,101,32,102,111,114,32,109,101,116,104,111,100,32,39,37,115,39,32,97,110,100,32,102,105,108,101,61,39,37,115,39,0,0,64,54,5,0,40,56,5,0,48,56,5,0,120,58,5,0,144,56,5,0,160,56,5,0,128,58,5,0,136,58,5,0,144,58,5,0,152,58,5,0,168,58,5,0,184,58,5,0,200,58,5,0,216,58,5,0,232,58,5,0,248,58,5,0,8,59,5,0,32,59,5,0,88,58,5,0,112,58,5,0,117,110,114,101,99,111,103,110,105,122,101,100,32,111,112,116,105,111,110,32,45,115,32,37,115,0,0,0,0,0,0,0,64,54,5,0,40,56,5,0,48,56,5,0,64,56,5,0,144,56,5,0,160,56,5,0,176,56,5,0,208,56,5,0,240,56,5,0,16,57,5,0,56,57,5,0,96,57,5,0,136,57,5,0,176,57,5,0,200,57,5,0,232,57,5,0,8,58,5,0,48,58,5,0,88,58,5,0,112,58,5,0,114,101,99,111,103,110,105,122,101,100,32,115,111,108,118,101,114,58,32,37,115,0,0,0,117,115,97,103,101,58,32,37,115,0,0,0,0,0,0,0,60,45,37,115,62,10,32,32,37,115,0,0,0,0,0,0,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,32,32,37,115,0,91,117,110,107,110,111,119,110,32,102,108,97,103,45,116,121,112,101,93,32,60,45,37,115,62,0,0,0,0,0,0,0,120,109,108,0,0,0,0,0,116,101,120,116,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,108,111,103,70,111,114,109,97,116,61,37,115,44,32,101,120,112,101,99,116,101,100,32,116,101,120,116,32,111,114,32,120,109,108,0,0,0,0,0,0,0,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,62,10,37,115,0,100,101,116,97,105,108,101,100,32,102,108,97,103,45,100,101,115,99,114,105,112,116,105,111,110,32,102,111,114,58,32,60,45,37,115,61,118,97,108,117,101,62,32,111,114,32,60,45,37,115,32,118,97,108,117,101,62,10,37,115,0,0,0,0,64,54,5,0,8,56,5,0,16,56,5,0,24,56,5,0,64,54,5,0,72,55,5,0,152,55,5,0,200,55,5,0,64,54,5,0,8,55,5,0,16,55,5,0,24,55,5,0,40,55,5,0,48,55,5,0,64,55,5,0,0,0,0,0,64,54,5,0,72,54,5,0,96,54,5,0,112,54,5,0,184,54,5,0,200,54,5,0,232,54,5,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,45,104,101,108,112,61,37,115,0,0,0,117,115,101,32,37,115,32,45,104,101,108,112,32,102,111,114,32,97,32,108,105,115,116,32,111,102,32,97,108,108,32,99,111,109,109,97,110,100,45,108,105,110,101,32,102,108,97,103,115,0,0,0,0,0,0,0,69,114,114,111,114,58,32,67,111,117,108,100,32,110,111,116,32,105,110,105,116,105,97,108,105,122,101,32,116,104,101,32,103,108,111,98,97,108,32,100,97,116,97,32,115,116,114,117,99,116,117,114,101,32,102,105,108,101,0,0,0,0,0,0,78,111,32,118,97,114,105,97,98,108,101,115,32,105,110,32,116,104,101,32,109,111,100,101,108,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,109,111,100,101,108,62,37,115,60,47,109,111,100,101,108,62,10,0,0,0,0,0,0,60,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,37,103,60,47,99,117,114,114,101,110,116,83,116,101,112,83,105,122,101,62,10,0,0,60,111,108,100,84,105,109,101,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,62,10,0,0,0,0,0,0,0,60,111,108,100,84,105,109,101,50,62,37,46,49,50,103,60,47,111,108,100,84,105,109,101,50,62,10,0,0,0,0,0,60,100,105,102,102,79,108,100,84,105,109,101,62,37,103,60,47,100,105,102,102,79,108,100,84,105,109,101,62,10,0,0,60,99,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,99,117,114,114,101,110,116,84,105,109,101,62,10,0,0,60,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,37,103,60,47,100,105,102,102,67,117,114,114,101,110,116,84,105,109,101,62,10,0,0,5,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,87,97,114,110,105,110,103,58,32,0,0,0,0,0,0,0,69,114,114,111,114,58,32,0,85,110,104,97,110,100,108,101,100,32,65,115,115,101,114,116,105,111,110,45,69,114,114,111,114,0,0,0,0,0,0,0,117,110,107,110,111,119,110,0,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,0,0,0,0,0,0,66,114,101,110,116,39,115,32,109,101,116,104,111,100,0,0,69,120,116,101,110,100,101,100,32,78,101,108,100,101,114,45,77,101,97,100,32,109,101,116,104,111,100,32,40,115,101,101,32,45,105,108,115,32,102,111,114,32,103,108,111,98,97,108,32,104,111,109,111,116,111,112,121,41,32,45,32,100,101,102,97,117,108,116,0,0,0,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,0,115,117,110,100,105,97,108,115,47,107,105,110,115,111,108,32,119,105,116,104,32,115,99,97,108,105,110,103,0,0,0,0,73,110,116,101,114,105,111,114,32,80,111,105,110,116,32,79,80,84,105,109,105,122,101,114,0,0,0,0,0,0,0,0,115,105,109,112,108,101,120,0,110,101,119,117,111,97,0,0,110,101,108,100,101,114,95,109,101,97,100,95,101,120,0,0,107,105,110,115,111,108,0,0,107,105,110,115,111,108,95,115,99,97,108,101,100,0,0,0,105,112,111,112,116,0,0,0,115,101,116,115,32,97,108,108,32,118,97,114,105,97,98,108,101,115,32,116,111,32,116,104,101,105,114,32,115,116,97,114,116,32,118,97,108,117,101,115,32,97,110,100,32,115,107,105,112,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,99,101,115,115,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,110,117,109,101,114,105,99,97,108,108,121,0,0,0,115,111,108,118,101,115,32,116,104,101,32,105,110,105,116,105,97,108,105,122,97,116,105,111,110,32,112,114,111,98,108,101,109,32,115,121,109,98,111,108,105,99,97,108,108,121,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,0,0,0,110,111,110,101,0,0,0,0,110,117,109,101,114,105,99,0,115,121,109,98,111,108,105,99,0,0,0,0,0,0,0,0,101,117,108,101,114,0,0,0,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,44,32,119,105,116,104,32,105,110,116,101,114,118,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,32,45,32,100,101,102,97,117,108,116,0,0,0,0,0,105,110,108,105,110,101,45,101,117,108,101,114,0,0,0,0,111,112,116,105,109,105,122,97,116,105,111,110,0,0,0,0,114,97,100,97,117,53,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,51,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,114,97,100,97,117,49,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,108,111,98,97,116,116,111,50,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,32,91,115,117,110,100,105,97,108,47,107,105,110,115,111,108,32,110,101,101,100,101,100,93,0,0,0,0,0,0,0,0,100,97,115,115,108,32,119,105,116,104,111,117,116,32,105,110,116,101,114,110,97,108,32,114,111,111,116,32,102,105,110,100,105,110,103,0,0,0,0,0,100,97,115,115,108,32,102,111,114,32,100,101,98,117,103,32,112,114,111,112,111,115,101,0,100,97,115,115,108,32,119,105,116,104,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,0,100,97,115,115,108,32,119,105,116,104,32,99,111,108,111,114,101,100,32,115,121,109,98,111,108,105,99,32,106,97,99,111,98,105,97,110,0,0,0,0,100,97,115,115,108,32,119,105,116,104,32,105,110,116,101,114,110,97,108,32,110,117,109,101,114,105,99,97,108,32,106,97,99,111,98,105,97,110,0,0,105,110,108,105,110,101,45,114,117,110,103,101,107,117,116,116,97,0,0,0,0,0,0,0,113,115,115,0,0,0,0,0,100,97,115,115,108,0,0,0,114,97,100,97,117,53,0,0,114,97,100,97,117,51,0,0,114,97,100,97,117,49,0,0,108,111,98,97,116,116,111,50,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,52,0,0,0,0,0,0,0,0,108,111,98,97,116,116,111,54,0,0,0,0,0,0,0,0,100,97,115,115,108,119,111,114,116,0,0,0,0,0,0,0,100,97,115,115,108,116,101,115,116,0,0,0,0,0,0,0,100,97,115,115,108,83,121,109,74,97,99,0,0,0,0,0,100,97,115,115,108,78,117,109,74,97,99,0,0,0,0,0,100,97,115,115,108,67,111,108,111,114,83,121,109,74,97,99,0,0,0,0,0,0,0,0,100,97,115,115,108,73,110,116,101,114,110,97,108,78,117,109,74,97,99,0,0,0,0,0,60,115,116,97,116,117,115,62,0,0,0,0,0,0,0,0,60,112,104,97,115,101,62,85,78,75,78,79,87,78,60,47,112,104,97,115,101,62,0,0,60,47,115,116,97,116,117,115,62,0,0,0,0,0,0,0,44,0,0,0,0,0,0,0,59,0,0,0,0,0,0,0,115,101,101,100,58,32,100,97,116,97,45,62,115,105,109,117,108,97,116,105,111,110,73,110,102,111,46,97,110,97,108,121,116,105,99,74,97,99,111,98,105,97,110,115,91,105,110,100,101,120,93,46,115,101,101,100,86,97,114,115,91,37,100,93,61,32,37,102,0,0,0,0,119,114,105,116,101,32,105,110,32,106,97,99,91,37,100,93,45,91,37,100,44,37,100,93,61,37,103,32,102,114,111,109,32,114,111,119,91,37,100,93,61,37,103,0,0,0,0,0,80,114,105,110,116,32,106,97,99,58,0,0,0,0,0,0,37,32,46,53,101,32,0,0,99,97,108,108,111,99,32,102,97,105,108,101,100,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,65,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,66,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,67,32,0,0,0,0,69,114,114,111,114,44,32,99,97,110,32,110,111,116,32,103,101,116,32,77,97,116,114,105,120,32,68,32,0,0,0,0,105,32,102,111,114,32,105,32,105,110,32,49,58,48,0,0,108,105,110,101,97,114,95,0,46,109,111,0,0,0,0,0,119,98,0,0,0,0,0,0,67,97,110,110,111,116,32,111,112,101,110,32,70,105,108,101,32,37,115,0,0,0,0,0,56,0,0,0,0,0,0,0,96,61,5,0,26,0,0,0,27,0,0,0,200,255,255,255,200,255,255,255,96,61,5,0,28,0,0,0,29,0,0,0,236,60,5,0,124,61,5,0,144,61,5,0,0,61,5,0,78,83,116,51,95,95,49,49,57,98,97,115,105,99,95,111,115,116,114,105,110,103,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,144,212,5,0,24,61,5,0,24,144,5,0,0,0,0,0,56,0,0,0,0,0,0,0,24,144,5,0,12,0,0,0,13,0,0,0,200,255,255,255,200,255,255,255,24,144,5,0,14,0,0,0,15,0,0,0,0,0,0,0,32,62,5,0,30,0,0,0,31,0,0,0,4,0,0,0,11,0,0,0,3,0,0,0,6,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,36,0,0,0,34,0,0,0,26,0,0,0,10,0,0,0,27,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,105,110,103,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,78,83,95,57,97,108,108,111,99,97,116,111,114,73,99,69,69,69,69,0,0,0,0,0,0,0,144,212,5,0,216,61,5,0,16,143,5,0,0,0,0,0,67,97,108,117,99,117,108,97,116,101,32,111,110,101,32,99,111,108,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,119,0,0,0,0,0,0,0,103,110,117,112,108,111,116,0,80,108,111,116,115,32,111,102,32,112,114,111,102,105,108,105,110,103,32,100,97,116,97,32,119,101,114,101,32,100,105,115,97,98,108,101,100,58,32,37,115,10,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,37,115,58,32,37,115,10,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,115,118,103,10,0,0,0,0,0,0,0,115,101,116,32,110,111,107,101,121,10,0,0,0,0,0,0,115,101,116,32,102,111,114,109,97,116,32,121,32,34,37,103,34,10,0,0,0,0,0,0,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,111,102,32,103,108,111,98,97,108,32,115,116,101,112,115,0,0,0,0,0,0,0,0,0,0,60,33,68,79,67,84,89,80,69,32,100,111,99,32,91,32,32,60,33,69,76,69,77,69,78,84,32,115,105,109,117,108,97,116,105,111,110,32,40,109,111,100,101,108,105,110,102,111,44,32,118,97,114,105,97,98,108,101,115,44,32,102,117,110,99,116,105,111,110,115,44,32,101,113,117,97,116,105,111,110,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,118,97,114,105,97,98,108,101,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,101,113,117,97,116,105,111,110,32,40,114,101,102,115,41,62,32,32,60,33,65,84,84,76,73,83,84,32,101,113,117,97,116,105,111,110,32,105,100,32,73,68,32,35,82,69,81,85,73,82,69,68,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,115,32,40,112,114,111,102,105,108,101,98,108,111,99,107,42,41,62,32,32,60,33,69,76,69,77,69,78,84,32,112,114,111,102,105,108,101,98,108,111,99,107,32,40,114,101,102,115,44,32,110,99,97,108,108,44,32,116,105,109,101,44,32,109,97,120,84,105,109,101,41,62,32,32,60,33,69,76,69,77,69,78,84,32,114,101,102,115,32,40,114,101,102,42,41,62,32,32,60,33,65,84,84,76,73,83,84,32,114,101,102,32,114,101,102,105,100,32,73,68,82,69,70,32,35,82,69,81,85,73,82,69,68,62,32,32,93,62,10,0,0,0,0,116,105,109,101,40,41,32,102,97,105,108,101,100,58,32,37,115,0,0,0,0,0,0,0,37,89,45,37,109,45,37,100,32,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,115,116,114,102,116,105,109,101,40,41,32,102,97,105,108,101,100,0,0,0,0,0,0,0,60,115,105,109,117,108,97,116,105,111,110,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,62,10,0,0,0,0,60,110,97,109,101,62,0,0,60,47,110,97,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,102,105,120,62,0,0,0,0,0,0,0,0,60,47,112,114,101,102,105,120,62,10,0,0,0,0,0,0,60,100,97,116,101,62,0,0,60,47,100,97,116,101,62,10,0,0,0,0,0,0,0,0,60,109,101,116,104,111,100,62,0,0,0,0,0,0,0,0,60,47,109,101,116,104,111,100,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,111,114,109,97,116,62,0,0,60,47,111,117,116,112,117,116,70,111,114,109,97,116,62,10,0,0,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,0,0,0,0,0,0,0,0,60,47,111,117,116,112,117,116,70,105,108,101,110,97,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,37,108,100,60,47,111,117,116,112,117,116,70,105,108,101,115,105,122,101,62,10,0,0,0,60,111,118,101,114,104,101,97,100,84,105,109,101,62,37,102,60,47,111,118,101,114,104,101,97,100,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,112,114,101,105,110,105,116,84,105,109,101,62,37,102,60,47,112,114,101,105,110,105,116,84,105,109,101,62,10,0,0,60,105,110,105,116,84,105,109,101,62,37,102,60,47,105,110,105,116,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,101,118,101,110,116,84,105,109,101,62,37,102,60,47,101,118,101,110,116,84,105,109,101,62,10,0,0,0,0,0,0,60,111,117,116,112,117,116,84,105,109,101,62,37,102,60,47,111,117,116,112,117,116,84,105,109,101,62,10,0,0,0,0,60,108,105,110,101,97,114,105,122,101,84,105,109,101,62,37,102,60,47,108,105,110,101,97,114,105,122,101,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,84,105,109,101,62,37,102,60,47,116,111,116,97,108,84,105,109,101,62,10,0,0,0,0,0,0,60,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,37,102,60,47,116,111,116,97,108,83,116,101,112,115,84,105,109,101,62,10,0,0,0,0,60,110,117,109,83,116,101,112,62,37,100,60,47,110,117,109,83,116,101,112,62,10,0,0,60,109,97,120,84,105,109,101,62,37,46,57,102,60,47,109,97,120,84,105,109,101,62,10,0,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,62,10,0,0,0,60,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,0,60,111,100,101,84,105,109,101,62,37,102,60,47,111,100,101,84,105,109,101,62,10,0,0,60,111,100,101,84,105,109,101,84,105,99,107,115,62,37,108,117,60,47,111,100,101,84,105,109,101,84,105,99,107,115,62,10,0,0,0,0,0,0,0,60,47,109,111,100,101,108,105,110,102,111,95,101,120,116,62,10,0,0,0,0,0,0,0,60,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,0,60,47,112,114,111,102,105,108,105,110,103,100,97,116,97,104,101,97,100,101,114,62,10,0,60,118,97,114,105,97,98,108,101,115,62,10,0,0,0,0,60,47,118,97,114,105,97,98,108,101,115,62,10,0,0,0,60,102,117,110,99,116,105,111,110,115,62,10,0,0,0,0,60,47,102,117,110,99,116,105,111,110,115,62,10,0,0,0,60,101,113,117,97,116,105,111,110,115,62,10,0,0,0,0,60,47,101,113,117,97,116,105,111,110,115,62,10,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,115,62,10,0,0,0,0,0,0,0,60,47,115,105,109,117,108,97,116,105,111,110,62,10,0,0,98,117,102,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,109,111,100,101,108,105,110,102,111,46,99,0,0,112,114,105,110,116,77,111,100,101,108,73,110,102,111,0,0,87,97,114,110,105,110,103,58,32,80,108,111,116,32,99,111,109,109,97,110,100,32,102,97,105,108,101,100,10,0,0,0,120,115,108,116,112,114,111,99,0,0,0,0,0,0,0,0,37,115,32,45,111,32,37,115,95,112,114,111,102,46,104,116,109,108,32,37,115,47,115,104,97,114,101,47,111,109,99,47,115,99,114,105,112,116,115,47,100,101,102,97,117,108,116,95,112,114,111,102,105,108,105,110,103,46,120,115,108,32,37,115,95,112,114,111,102,46,120,109,108,0,0,0,0,0,0,0,79,80,69,78,77,79,68,69,76,73,67,65,72,79,77,69,32,109,105,115,115,105,110,103,0,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,103,101,110,101,114,97,116,101,32,104,116,109,108,32,118,101,114,115,105,111,110,32,111,102,32,112,114,111,102,105,108,105,110,103,32,114,101,115,117,108,116,115,58,32,37,115,10,0,0,0,0,0,0,0,84,105,109,101,32,109,101,97,115,117,114,101,109,101,110,116,115,32,97,114,101,32,115,116,111,114,101,100,32,105,110,32,37,115,95,112,114,111,102,46,104,116,109,108,32,40,104,117,109,97,110,45,114,101,97,100,97,98,108,101,41,32,97,110,100,32,37,115,95,112,114,111,102,46,120,109,108,32,40,102,111,114,32,88,83,76,32,116,114,97,110,115,102,111,114,109,115,32,111,114,32,109,111,114,101,32,100,101,116,97,105,108,115,41,0,0,0,0,0,0,101,113,0,0,0,0,0,0,60,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,101,113,37,100,34,47,62,10,0,0,0,0,60,110,99,97,108,108,62,37,100,60,47,110,99,97,108,108,62,10,0,0,0,0,0,0,60,116,105,109,101,62,37,46,57,102,60,47,116,105,109,101,62,10,0,0,0,0,0,0,60,47,112,114,111,102,105,108,101,98,108,111,99,107,62,10,0,0,0,0,0,0,0,0,60,101,113,117,97,116,105,111,110,32,105,100,61,34,101,113,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,0,34,62,10,0,0,0,0,0,60,114,101,102,115,62,10,0,60,114,101,102,32,114,101,102,105,100,61,34,118,97,114,37,100,34,32,47,62,10,0,0,60,47,114,101,102,115,62,10,0,0,0,0,0,0,0,0,60,99,97,108,99,105,110,102,111,32,116,105,109,101,61,34,37,102,34,32,99,111,117,110,116,61,34,37,108,117,34,47,62,10,0,0,0,0,0,0,60,47,101,113,117,97,116,105,111,110,62,10,0,0,0,0,102,117,110,0,0,0,0,0,60,102,117,110,99,116,105,111,110,32,105,100,61,34,102,117,110,37,100,34,62,10,0,0,60,47,102,117,110,99,116,105,111,110,62,10,0,0,0,0,60,105,110,102,111,32,102,105,108,101,110,97,109,101,61,34,0,0,0,0,0,0,0,0,34,32,115,116,97,114,116,108,105,110,101,61,34,37,100,34,32,115,116,97,114,116,99,111,108,61,34,37,100,34,32,101,110,100,108,105,110,101,61,34,37,100,34,32,101,110,100,99,111,108,61,34,37,100,34,32,114,101,97,100,111,110,108,121,61,34,37,115,34,32,47,62,10,0,0,0,0,0,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,119,114,105,116,97,98,108,101,0,0,0,0,0,0,0,0,60,118,97,114,105,97,98,108,101,32,105,100,61,34,118,97,114,37,100,34,32,110,97,109,101,61,34,0,0,0,0,0,34,32,99,111,109,109,101,110,116,61,34,0,0,0,0,0,60,47,118,97,114,105,97,98,108,101,62,10,0,0,0,0,37,115,95,112,114,111,102,46,100,97,116,97,0,0,0,0,60,102,105,108,101,110,97,109,101,62,0,0,0,0,0,0,60,47,102,105,108,101,110,97,109,101,62,10,0,0,0,0,60,102,105,108,101,115,105,122,101,62,37,108,100,60,47,102,105,108,101,115,105,122,101,62,10,0,0,0,0,0,0,0,60,102,111,114,109,97,116,62,10,0,0,0,0,0,0,0,60,117,105,110,116,51,50,62,115,116,101,112,60,47,117,105,110,116,51,50,62,10,0,0,60,100,111,117,98,108,101,62,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,60,100,111,117,98,108,101,62,99,112,117,32,116,105,109,101,60,47,100,111,117,98,108,101,62,10,0,0,0,0,0,0,60,117,105,110,116,51,50,62,0,0,0,0,0,0,0,0,32,40,99,97,108,108,115,41,60,47,117,105,110,116,51,50,62,10,0,0,0,0,0,0,60,100,111,117,98,108,101,62,0,0,0,0,0,0,0,0,32,40,99,112,117,32,116,105,109,101,41,60,47,100,111,117,98,108,101,62,10,0,0,0,60,47,102,111,114,109,97,116,62,10,0,0,0,0,0,0,114,98,0,0,0,0,0,0,38,108,116,59,0,0,0,0,38,103,116,59,0,0,0,0,38,97,112,111,115,59,0,0,38,113,117,111,116,59,0,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,50,100,111,117,98,108,101,37,37,42,37,100,117,105,110,116,51,50,37,37,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,49,58,40,36,37,100,62,49,101,45,57,32,63,32,36,37,100,32,58,32,49,101,45,51,48,41,32,119,32,108,32,108,119,32,37,100,10,0,112,108,111,116,32,34,37,115,95,112,114,111,102,46,100,97,116,97,34,32,98,105,110,97,114,121,32,102,111,114,109,97,116,61,34,37,37,42,117,105,110,116,51,50,37,37,42,50,100,111,117,98,108,101,37,37,37,100,117,105,110,116,51,50,37,37,42,37,100,100,111,117,98,108,101,34,32,117,115,105,110,103,32,37,100,32,119,32,108,32,108,119,32,37,100,10,0,0,0,0,0,0,0,0,117,110,115,101,116,32,120,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,121,116,105,99,115,10,0,0,0,0,117,110,115,101,116,32,98,111,114,100,101,114,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,115,101,116,32,116,105,116,108,101,10,0,0,0,0,0,0,115,101,116,32,120,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,10,0,0,0,0,0,115,101,116,32,108,111,103,32,121,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,37,103,93,10,0,0,0,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,42,58,42,93,10,0,0,0,0,0,0,0,115,101,116,32,110,111,108,111,103,32,120,121,10,0,0,0,115,101,116,32,121,114,97,110,103,101,32,91,37,103,58,37,103,93,10,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,116,104,117,109,98,46,115,118,103,34,10,0,0,0,0,0,0,115,101,116,32,121,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,120,116,105,99,115,10,0,0,0,0,0,0,115,101,116,32,98,111,114,100,101,114,10,0,0,0,0,0,115,101,116,32,116,101,114,109,105,110,97,108,32,37,115,10,0,0,0,0,0,0,0,0,115,101,116,32,116,105,116,108,101,32,34,37,115,34,10,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,97,116,32,116,105,109,101,34,10,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,116,105,109,101,32,91,115,93,34,10,0,0,0,0,0,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,46,37,115,34,10,0,0,0,115,101,116,32,120,108,97,98,101,108,32,34,71,108,111,98,97,108,32,115,116,101,112,32,110,117,109,98,101,114,34,10,0,0,0,0,0,0,0,0,115,101,116,32,121,108,97,98,101,108,32,34,69,120,101,99,117,116,105,111,110,32,99,111,117,110,116,34,10,0,0,0,115,101,116,32,111,117,116,112,117,116,32,34,37,115,95,112,114,111,102,46,37,115,37,100,95,99,111,117,110,116,46,37,115,34,10,0,0,0,0,0,114,0,0,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,111,112,101,110,32,102,105,108,101,32,37,115,58,32,37,115,10,0,0,0,0,0,70,97,105,108,101,100,32,116,111,32,99,114,101,97,116,101,32,101,120,112,97,116,32,111,98,106,101,99,116,0,0,0,68,117,109,109,121,32,101,113,117,97,116,105,111,110,32,115,111,32,119,101,32,99,97,110,32,105,110,100,101,120,32,102,114,111,109,32,49,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,102,105,108,101,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,115,105,109,117,108,97,116,105,111,110,47,115,105,109,117,108,97,116,105,111,110,95,105,110,102,111,95,120,109,108,46,99,0,0,0,0,0,0,0,0,37,115,58,32,69,114,114,111,114,58,32,102,97,105,108,101,100,32,116,111,32,114,101,97,100,32,116,104,101,32,88,77,76,32,100,97,116,97,32,37,115,58,32,37,115,32,97,116,32,108,105,110,101,32,37,108,117,0,0,0,0,0,0,0,120,109,108,45,62,110,69,113,117,97,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,49,93,0,0,0,109,111,100,101,108,73,110,102,111,88,109,108,73,110,105,116,0,0,0,0,0,0,0,0,120,109,108,45,62,110,70,117,110,99,116,105,111,110,115,32,61,61,32,40,108,111,110,103,41,32,117,115,101,114,68,97,116,97,91,51,93,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,119,101,32,111,110,108,121,32,104,97,118,101,32,37,108,100,32,115,117,99,104,32,98,108,111,99,107,115,0,0,0,0,82,101,113,117,101,115,116,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,112,114,111,102,105,108,101,114,32,105,110,100,101,120,32,37,108,100,44,32,98,117,116,32,99,111,117,108,100,32,110,111,116,32,102,105,110,100,32,105,116,33,0,0,0,0,0,0,118,97,114,105,97,98,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,113,117,97,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,97,114,0,0,76,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,105,110,100,101,120,32,37,108,100,44,32,115,105,122,101,32,37,100,41,0,0,0,0,110,111,110,108,105,110,101,97,114,0,0,0,0,0,0,0,78,111,110,108,105,110,101,97,114,32,102,117,110,99,116,105,111,110,32,40,114,101,115,105,100,117,97,108,70,117,110,99,37,108,100,44], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+337948);
/* memory initializer */ allocate([32,115,105,122,101,32,37,100,41,0,0,0,102,117,110,99,116,105,111,110,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,100,101,102,105,110,101,115,0,110,97,109,101,0,0,0,0,60,100,101,102,105,110,101,115,62,32,110,101,101,100,115,32,116,111,32,104,97,118,101,32,101,120,97,99,116,108,121,32,111,110,101,32,97,116,116,114,105,98,117,116,101,58,32,110,97,109,101,0,0,0,0,0,0,0,0,0,0,0,0,0,105,110,102,111,0,0,0,0,102,105,108,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,108,105,110,101,83,116,97,114,116,0,0,0,0,0,0,0,108,105,110,101,69,110,100,0,99,111,108,83,116,97,114,116,0,0,0,0,0,0,0,0,99,111,108,69,110,100,0,0,114,101,97,100,111,110,108,121,0,0,0,0,0,0,0,0,116,114,117,101,0,0,0,0,37,115,58,32,85,110,107,110,111,119,110,32,97,116,116,114,105,98,117,116,101,32,105,110,32,60,105,110,102,111,62,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,109,111,114,101,32,101,113,117,97,116,105,111,110,115,32,116,104,97,110,32,101,120,112,101,99,116,101,100,32,40,37,108,100,41,0,0,0,0,105,110,100,101,120,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,99,111,110,116,97,105,110,101,100,32,101,113,117,97,116,105,111,110,32,119,105,116,104,111,117,116,32,105,110,100,101,120,0,0,0,0,0,0,0,0,37,115,58,32,73,110,102,111,32,88,77,76,32,37,115,32,103,111,116,32,101,113,117,97,116,105,111,110,32,119,105,116,104,32,105,110,100,101,120,32,37,108,100,44,32,101,120,112,101,99,116,101,100,32,37,108,100,0,0,0,0,0,0,0,83,79,77,69,32,78,73,67,69,32,69,81,85,65,84,73,79,78,32,78,65,77,69,32,40,116,111,32,98,101,32,115,101,116,32,97,32,108,105,116,116,108,101,32,108,97,116,101,114,41,0,0,0,0,0,0,99,111,109,109,101,110,116,0,60,118,97,114,62,45,116,97,103,32,100,105,100,32,110,111,116,32,115,101,116,32,110,97,109,101,32,97,110,100,32,99,111,109,109,101,110,116,0,0,35,70,73,88,77,69,35,0,84,79,68,79,58,32,83,101,116,32,109,101,32,117,112,33,33,33,0,0,0,0,0,0,100,117,109,109,121,86,97,114,83,116,97,116,101,83,101,116,74,97,99,0,0,0,0,0,255,255,255,255,176,82,5,0,176,82,5,0,176,82,5,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,82,101,102,101,114,101,110,99,101,100,32,39,37,115,39,32,116,104,97,116,32,119,97,115,32,110,111,116,32,100,101,99,108,97,114,101,100,32,97,115,32,60,118,97,114,105,97,98,108,101,62,0,0,0,0,0,63,0,0,0,0,0,0,0,104,101,108,112,0,0,0,0,70,76,65,71,95,77,65,88,0,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,78,65,77,69,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,83,67,0,0,0,0,0,0,0,117,110,98,97,108,97,110,99,101,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,102,108,97,103,32,115,116,114,117,99,116,117,114,101,58,32,70,76,65,71,95,68,69,84,65,73,76,69,68,95,68,69,83,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,97,99,104,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,32,99,97,110,32,111,110,108,121,32,98,101,32,117,115,101,100,32,111,110,99,101,58,32,37,115,0,0,0,0,0,0,105,110,118,97,108,105,100,32,99,111,109,109,97,110,100,32,108,105,110,101,32,111,112,116,105,111,110,58,32,37,115,0,83,84,79,80,32,0,0,0,32,115,116,97,116,101,109,101,110,116,32,101,120,101,99,117,116,101,100,10,0,0,0,0,37,115,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,101,110,100,102,105,108,101,0,101,114,114,111,114,32,105,110,32,102,111,114,109,97,116,0,105,108,108,101,103,97,108,32,117,110,105,116,32,110,117,109,98,101,114,0,0,0,0,0,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,100,105,114,101,99,116,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,115,101,113,117,101,110,116,105,97,108,32,105,111,32,110,111,116,32,97,108,108,111,119,101,100,0,0,0,0,0,0,0,99,97,110,39,116,32,98,97,99,107,115,112,97,99,101,32,102,105,108,101,0,0,0,0,110,117,108,108,32,102,105,108,101,32,110,97,109,101,0,0,99,97,110,39,116,32,115,116,97,116,32,102,105,108,101,0,117,110,105,116,32,110,111,116,32,99,111,110,110,101,99,116,101,100,0,0,0,0,0,0,111,102,102,32,101,110,100,32,111,102,32,114,101,99,111,114,100,0,0,0,0,0,0,0,116,114,117,110,99,97,116,105,111,110,32,102,97,105,108,101,100,32,105,110,32,101,110,100,102,105,108,101,0,0,0,0,105,110,99,111,109,112,114,101,104,101,110,115,105,98,108,101,32,108,105,115,116,32,105,110,112,117,116,0,0,0,0,0,111,117,116,32,111,102,32,102,114,101,101,32,115,112,97,99,101,0,0,0,0,0,0,0,114,101,97,100,32,117,110,101,120,112,101,99,116,101,100,32,99,104,97,114,97,99,116,101,114,0,0,0,0,0,0,0,98,97,100,32,108,111,103,105,99,97,108,32,105,110,112,117,116,32,102,105,101,108,100,0,98,97,100,32,118,97,114,105,97,98,108,101,32,116,121,112,101,0,0,0,0,0,0,0,98,97,100,32,110,97,109,101,108,105,115,116,32,110,97,109,101,0,0,0,0,0,0,0,118,97,114,105,97,98,108,101,32,110,111,116,32,105,110,32,110,97,109,101,108,105,115,116,0,0,0,0,0,0,0,0,110,111,32,101,110,100,32,114,101,99,111,114,100,0,0,0,118,97,114,105,97,98,108,101,32,99,111,117,110,116,32,105,110,99,111,114,114,101,99,116,0,0,0,0,0,0,0,0,115,117,98,115,99,114,105,112,116,32,102,111,114,32,115,99,97,108,97,114,32,118,97,114,105,97,98,108,101,0,0,0,105,110,118,97,108,105,100,32,97,114,114,97,121,32,115,101,99,116,105,111,110,0,0,0,115,117,98,115,116,114,105,110,103,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,115,117,98,115,99,114,105,112,116,32,111,117,116,32,111,102,32,98,111,117,110,100,115,0,99,97,110,39,116,32,114,101,97,100,32,102,105,108,101,0,99,97,110,39,116,32,119,114,105,116,101,32,102,105,108,101,0,0,0,0,0,0,0,0,39,110,101,119,39,32,102,105,108,101,32,101,120,105,115,116,115,0,0,0,0,0,0,0,99,97,110,39,116,32,97,112,112,101,110,100,32,116,111,32,102,105,108,101,0,0,0,0,110,111,110,45,112,111,115,105,116,105,118,101,32,114,101,99,111,114,100,32,110,117,109,98,101,114,0,0,0,0,0,0,110,109,76,98,117,102,32,111,118,101,114,102,108,111,119,0,88,85,5,0,104,85,5,0,128,85,5,0,160,85,5,0,192,85,5,0,216,85,5,0,248,85,5,0,16,86,5,0,32,86,5,0,48,86,5,0,72,86,5,0,96,86,5,0,128,86,5,0,160,86,5,0,48,86,5,0,184,86,5,0,216,86,5,0,240,86,5,0,8,87,5,0,32,87,5,0,64,87,5,0,80,87,5,0,112,87,5,0,144,87,5,0,168,87,5,0,192,87,5,0,216,87,5,0,232,87,5,0,0,88,5,0,24,88,5,0,48,88,5,0,80,88,5,0,37,115,58,32,105,108,108,101,103,97,108,32,101,114,114,111,114,32,110,117,109,98,101,114,32,37,100,10,0,0,0,0,37,115,58,32,101,110,100,32,111,102,32,102,105,108,101,10,0,0,0,0,0,0,0,0,37,115,58,32,37,115,10,0,0,0,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,117,110,105,116,32,37,100,32], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+348188);
/* memory initializer */ allocate([110,97,109,101,100,32,37,115,10,0,0,0,0,0,0,0,40,117,110,110,97,109,101,100,41,10,0,0,0,0,0,0,97,112,112,97,114,101,110,116,32,115,116,97,116,101,58,32,105,110,116,101,114,110,97,108,32,73,47,79,10,0,0,0,0,0,0,0,0,0,0,0,108,97,115,116,32,102,111,114,109,97,116,58,32,37,115,10,0,0,0,0,0,0,0,0,108,97,116,101,108,121,32,37,115,32,37,115,32,37,115,32,37,115,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,101,97,100,105,110,103,0,119,114,105,116,105,110,103,0,0,0,0,0,0,0,0,0,115,101,113,117,101,110,116,105,97,108,0,0,0,0,0,0,100,105,114,101,99,116,0,0,0,0,0,0,0,0,0,0,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,117,110,102,111,114,109,97,116,116,101,100,0,0,0,0,0,0,0,0,0,0,0,0,0,101,120,116,101,114,110,97,108,0,0,0,0,0,0,0,0,105,110,116,101,114,110,97,108,0,0,0,0,0,0,0,0,32,73,79], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+355328);
/* memory initializer */ allocate([117,110,107,110,111,119,110,32,99,111,100,101,32,105,110,32,100,111,95,102,105,111,58,32,37,100,10,37,115,10,0,0,100,111,95,102,105,111,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,102,109,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,100,32,115,116,114,105,110,103,0,0,0,0,0,0,102,111,114,109,97,116,32,116,111,111,32,99,111,109,112,108,105,99,97,116,101,100,58,10,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,114,98,0,0,0,0,0,0,114,0,0,0,0,0,0,0,88,129,5,0,96,129,5,0,119,98,0,0,0,0,0,0,119,0,0,0,0,0,0,0,114,43,98,0,0,0,0,0,114,43,0,0,0,0,0,0,112,129,5,0,120,129,5,0,128,129,5,0,136,129,5,0,144,1,0,0,0,0,0,0,248,129,5,0,0,0,0,0,111,112,101,110,0,0,0,0,102,111,114,116,46,37,108,100,0,0,0,0,0,0,0,0,110,111,32,115,112,97,99,101,0,0,0,0,0,0,0,0,115,0,0,0,0,0,0,0,100,0,0,0,0,0,0,0,102,0,0,0,0,0,0,0,117,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,109,97,108,108,111,99,32,102,97,105,108,117,114,101,0,0,115,116,97,114,116,105,111,0,115,102,101,0,0,0,0,0,37,35,46,42,69,0,0,0,37,43,46,50,100,0,0,0,37,35,46,42,102,0,0,0,119,95,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,0,119,95,110,101,100,44,32,117,110,101,120,112,101,99,116,101,100,32,99,111,100,101,58,32,37,100,10,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,65,66,67,68,69,70,0,0,0,0,0,0,0,0,108,101,102,116,32,111,102,102,0,0,0,0,0,0,0,0,114,101,99,101,110,100,0,0,115,116,97,114,116,105,111,0,119,114,105,116,101,32,115,116,97,114,116], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+360552);
/* memory initializer */ allocate([208,136,5,0,32,0,0,0,33,0,0,0,5,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,37,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,14,0,0,0,29,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,119,69,69,0,0,0,0,0,0,0,0,144,212,5,0,176,136,5,0,80,143,5,0,0,0,0,0,0,0,0,0,56,137,5,0,34,0,0,0,35,0,0,0,6,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,42,0,0,0,43,0,0,0,30,0,0,0,15,0,0,0,31,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,119,69,69,0,144,212,5,0,32,137,5,0,80,143,5,0,0,0,0,0,117,110,115,117,112,112,111,114,116,101,100,32,108,111,99,97,108,101,32,102,111,114,32,115,116,97,110,100,97,114,100,32,105,110,112,117,116,0,0,0,0,0,0,0,208,137,5,0,36,0,0,0,37,0,0,0,7,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,44,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,16,0,0,0,33,0,0,0,78,83,116,51,95,95,49,49,49,95,95,115,116,100,111,117,116,98,117,102,73,99,69,69,0,0,0,0,0,0,0,0,144,212,5,0,176,137,5,0,16,143,5,0,0,0,0,0,0,0,0,0,56,138,5,0,38,0,0,0,39,0,0,0,8,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,46,0,0,0,47,0,0,0,34,0,0,0,10,0,0,0,35,0,0,0,78,83,116,51,95,95,49,49,48,95,95,115,116,100,105,110,98,117,102,73,99,69,69,0,144,212,5,0,32,138,5,0,16,143,5,0,0,0,0,0,78,83,116,51,95,95,49,49,52,95,95,115,104,97,114,101,100,95,99,111,117,110,116,69,0,0,0,0,0,0,0,0,104,212,5,0,72,138,5,0,0,0,0,0,176,138,5,0,40,0,0,0,41,0,0,0,48,0,0,0,0,0,0,0,0,0,0,0,88,139,5,0,42,0,0,0,43,0,0,0,49,0,0,0,0,0,0,0,83,116,49,49,108,111,103,105,99,95,101,114,114,111,114,0,144,212,5,0,160,138,5,0,0,0,0,0,0,0,0,0,0,0,0,0,240,138,5,0,40,0,0,0,44,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,108,101,110,103,116,104,95,101,114,114,111,114,0,0,0,0,0,0,0,0,144,212,5,0,216,138,5,0,176,138,5,0,0,0,0,0,0,0,0,0,48,139,5,0,40,0,0,0,45,0,0,0,48,0,0,0,0,0,0,0,83,116,49,50,111,117,116,95,111,102,95,114,97,110,103,101,0,0,0,0,0,0,0,0,144,212,5,0,24,139,5,0,176,138,5,0,0,0,0,0,83,116,49,51,114,117,110,116,105,109,101,95,101,114,114,111,114,0,0,0,0,0,0,0,144,212,5,0,64,139,5,0,0,0,0,0,0,0,0,0,58,32,0,0,0,0,0,0,0,0,0,0,160,139,5,0,46,0,0,0,47,0,0,0,49,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,115,121,115,116,101,109,95,101,114,114,111,114,69,0,0,144,212,5,0,136,139,5,0,88,139,5,0,0,0,0,0,78,83,116,51,95,95,49,49,52,101,114,114,111,114,95,99,97,116,101,103,111,114,121,69,0,0,0,0,0,0,0,0,104,212,5,0,176,139,5,0,78,83,116,51,95,95,49,49,50,95,95,100,111,95,109,101,115,115,97,103,101,69,0,0,144,212,5,0,216,139,5,0,208,139,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,98,97,115,105,99,95,115,116,114,105,110,103,0,0,0,0,0,0,0,0,136,142,5,0,48,0,0,0,49,0,0,0,0,0,0,0,16,143,5,0,50,0,0,0,51,0,0,0,4,0,0,0,11,0,0,0,5,0,0,0,8,0,0,0,35,0,0,0,32,0,0,0,9,0,0,0,45,0,0,0,34,0,0,0,32,0,0,0,10,0,0,0,35,0,0,0,0,0,0,0,80,143,5,0,52,0,0,0,53,0,0,0,9,0,0,0,12,0,0,0,4,0,0,0,7,0,0,0,41,0,0,0,38,0,0,0,13,0,0,0,39,0,0,0,40,0,0,0,28,0,0,0,15,0,0,0,31,0,0,0,8,0,0,0,0,0,0,0,136,143,5,0,22,0,0,0,23,0,0,0,248,255,255,255,248,255,255,255,136,143,5,0,24,0,0,0,25,0,0,0,8,0,0,0,0,0,0,0,208,143,5,0,54,0,0,0,55,0,0,0,248,255,255,255,248,255,255,255,208,143,5,0,56,0,0,0,57,0,0,0,4,0,0,0,0,0,0,0,24,144,5,0,12,0,0,0,13,0,0,0,252,255,255,255,252,255,255,255,24,144,5,0,14,0,0,0,15,0,0,0,4,0,0,0,0,0,0,0,96,144,5,0,58,0,0,0,59,0,0,0,252,255,255,255,252,255,255,255,96,144,5,0,60,0,0,0,61,0,0,0,105,111,115,116,114,101,97,109,0,0,0,0,0,0,0,0,117,110,115,112,101,99,105,102,105,101,100,32,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,32,101,114,114,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,40,142,5,0,62,0,0,0,63,0,0,0,49,0,0,0,0,0,0,0,0,0,0,0,80,142,5,0,64,0,0,0,65,0,0,0,105,111,115,95,98,97,115,101,58,58,99,108,101,97,114,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,55,102,97,105,108,117,114,101,69,0,0,0,0,0,0,0,144,212,5,0,8,142,5,0,160,139,5,0,0,0,0,0,78,83,116,51,95,95,49,56,105,111,115,95,98,97,115,101,69,0,0,0,0,0,0,0,104,212,5,0,56,142,5,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,144,212,5,0,88,142,5,0,80,142,5,0,0,0,0,0,78,83,116,51,95,95,49,57,98,97,115,105,99,95,105,111,115,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,144,212,5,0,152,142,5,0,80,142,5,0,0,0,0,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,0,0,0,0,0,0,104,212,5,0,216,142,5,0,78,83,116,51,95,95,49,49,53,98,97,115,105,99,95,115,116,114,101,97,109,98,117,102,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,0,0,0,0,0,0,104,212,5,0,24,143,5,0,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,240,212,5,0,88,143,5,0,0,0,0,0,1,0,0,0,136,142,5,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,105,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,240,212,5,0,160,143,5,0,0,0,0,0,1,0,0,0,200,142,5,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,0,0,240,212,5,0,232,143,5,0,0,0,0,0,1,0,0,0,136,142,5,0,3,244,255,255,78,83,116,51,95,95,49,49,51,98,97,115,105,99,95,111,115,116,114,101,97,109,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,0,0,240,212,5,0,48,144,5,0,0,0,0,0,1,0,0,0,200,142,5,0,3,244,255,255,0,0,0,0,192,144,5,0,66,0,0,0,67,0,0,0,50,0,0,0,2,0,0,0,17,0,0,0,18,0,0,0,3,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,57,95,95,105,111,115,116,114,101,97,109,95,99,97,116,101,103,111,114,121,69,0,0,0,144,212,5,0,160,144,5,0,240,139,5,0,0,0,0,0,0,0,0,0,232,158,5,0,68,0,0,0,69,0,0,0,70,0,0,0,1,0,0,0,9,0,0,0,19,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,159,5,0,71,0,0,0,72,0,0,0,70,0,0,0,2,0,0,0,10,0,0,0,20,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,163,5,0,73,0,0,0,74,0,0,0,70,0,0,0,1,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,5,0,0,0,6,0,0,0,7,0,0,0,8,0,0,0,9,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,97,98,99,100,101,102,65,66,67,68,69,70,120,88,43,45,112,80,105,73,110,78,0,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,88,164,5,0,75,0,0,0,76,0,0,0,70,0,0,0,12,0,0,0,13,0,0,0,14,0,0,0,15,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,20,0,0,0,21,0,0,0,22,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,24,165,5,0,77,0,0,0,78,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,23,0,0,0,8,0,0,0,24,0,0,0,1,0,0,0,2,0,0,0,9,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,176,165,5,0,79,0,0,0,80,0,0,0,70,0,0,0,10,0,0,0,11,0,0,0,25,0,0,0,12,0,0,0,26,0,0,0,3,0,0,0,4,0,0,0,13,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,0,0,0,0,37,112,0,0,0,0,0,0,0,0,0,0,216,160,5,0,81,0,0,0,82,0,0,0,70,0,0,0,51,0,0,0,27,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,1,0,0,0,248,255,255,255,216,160,5,0,52,0,0,0,53,0,0,0,54,0,0,0,55,0,0,0,56,0,0,0,57,0,0,0,58,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,37,109,47,37,100,47,37,121,37,89,45,37,109,45,37,100,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,37,72,58,37,77,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,120,161,5,0,83,0,0,0,84,0,0,0,70,0,0,0,59,0,0,0,32,0,0,0,33,0,0,0,34,0,0,0,35,0,0,0,36,0,0,0,2,0,0,0,248,255,255,255,120,161,5,0,60,0,0,0,61,0,0,0,62,0,0,0,63,0,0,0,64,0,0,0,65,0,0,0,66,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,37,0,0,0,89,0,0,0,45,0,0,0,37,0,0,0,109,0,0,0,45,0,0,0,37,0,0,0,100,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,8,162,5,0,85,0,0,0,86,0,0,0,70,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,162,5,0,87,0,0,0,88,0,0,0,70,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,159,5,0,89,0,0,0,90,0,0,0,70,0,0,0,67,0,0,0,68,0,0,0,10,0,0,0,11,0,0,0,12,0,0,0,13,0,0,0,69,0,0,0,14,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,159,5,0,91,0,0,0,92,0,0,0,70,0,0,0,70,0,0,0,71,0,0,0,16,0,0,0,17,0,0,0,18,0,0,0,19,0,0,0,72,0,0,0,20,0,0,0,21,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,159,5,0,93,0,0,0,94,0,0,0,70,0,0,0,73,0,0,0,74,0,0,0,22,0,0,0,23,0,0,0,24,0,0,0,25,0,0,0,75,0,0,0,26,0,0,0,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,160,5,0,95,0,0,0,96,0,0,0,70,0,0,0,76,0,0,0,77,0,0,0,28,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,78,0,0,0,32,0,0,0,33,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,64,166,5,0,97,0,0,0,98,0,0,0,70,0,0,0,3,0,0,0,4,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,37,76,102,0,0,0,0,0,109,111,110,101,121,95,103,101,116,32,101,114,114,111,114,0,0,0,0,0,208,166,5,0,99,0,0,0,100,0,0,0,70,0,0,0,5,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,49,50,51,52,53,54,55,56,57,0,0,0,0,0,0,0,0,0,0,96,167,5,0,101,0,0,0,102,0,0,0,70,0,0,0,1,0,0,0,37,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,46,48,76,102,0,0,0,0,0,0,0,240,167,5,0,103,0,0,0,104,0,0,0,70,0,0,0,2,0,0,0,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,200,162,5,0,105,0,0,0,106,0,0,0,70,0,0,0,21,0,0,0,14,0,0,0,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,163,5,0,107,0,0,0,108,0,0,0,70,0,0,0,22,0,0,0,15,0,0,0,35,0,0,0,0,0,0,0,0,0,0,0,118,101,99,116,111,114,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,67,0,0,0,0,0,0,0,0,0,0,0,192,158,5,0,109,0,0,0,110,0,0,0,70,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,152,155,5,0,111,0,0,0,112,0,0,0,70,0,0,0,36,0,0,0,23,0,0,0,37,0,0,0,24,0,0,0,38,0,0,0,28,0,0,0,25,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,156,5,0,113,0,0,0,114,0,0,0,70,0,0,0,2,0,0,0,3,0,0,0,4,0,0,0,79,0,0,0,80,0,0,0,5,0,0,0,81,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,112,158,5,0,115,0,0,0,116,0,0,0,70,0,0,0,82,0,0,0,83,0,0,0,36,0,0,0,37,0,0,0,38,0,0,0,0,0,0,0,152,158,5,0,117,0,0,0,118,0,0,0,70,0,0,0,84,0,0,0,85,0,0,0,39,0,0,0,40,0,0,0,41,0,0,0,116,114,117,101,0,0,0,0,116,0,0,0,114,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,102,97,108,115,101,0,0,0,102,0,0,0,97,0,0,0,108,0,0,0,115,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,109,47,37,100,47,37,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,109,0,0,0,47,0,0,0,37,0,0,0,100,0,0,0,47,0,0,0,37,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,72,58,37,77,58,37,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,97,32,37,98,32,37,100,32,37,72,58,37,77,58,37,83,32,37,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,97,0,0,0,32,0,0,0,37,0,0,0,98,0,0,0,32,0,0,0,37,0,0,0,100,0,0,0,32,0,0,0,37,0,0,0,72,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,89,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,73,58,37,77,58,37,83,32,37,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,37,0,0,0,73,0,0,0,58,0,0,0,37,0,0,0,77,0,0,0,58,0,0,0,37,0,0,0,83,0,0,0,32,0,0,0,37,0,0,0,112,0,0,0,0,0,0,0,108,111,99,97,108,101,32,110,111,116,32,115,117,112,112,111,114,116,101,100,0,0,0,0,0,0,0,0,208,154,5,0,119,0,0,0,120,0,0,0,70,0,0,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,102,97,99,101,116,69,0,0,0,144,212,5,0,184,154,5,0,104,138,5,0,0,0,0,0,0,0,0,0,96,155,5,0,119,0,0,0,121,0,0,0,70,0,0,0,26,0,0,0,29,0,0,0,30,0,0,0,31,0,0,0,39,0,0,0,27,0,0,0,40,0,0,0,28,0,0,0,41,0,0,0,32,0,0,0,29,0,0,0,6,0,0,0,0,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,119,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,48,99,116,121,112,101,95,98,97,115,101,69,0,0,0,0,104,212,5,0,64,155,5,0,240,212,5,0,40,155,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,155,5,0,2,0,0,0,78,83,116,51,95,95,49,53,99,116,121,112,101,73,99,69,69,0,0,0,0,0,0,0,240,212,5,0,128,155,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,155,5,0,2,0,0,0,0,0,0,0,48,156,5,0,119,0,0,0,122,0,0,0,70,0,0,0,4,0,0,0,5,0,0,0,7,0,0,0,86,0,0,0,87,0,0,0,8,0,0,0,88,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,99,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,78,83,116,51,95,95,49,49,50,99,111,100,101,99,118,116,95,98,97,115,101,69,0,0,104,212,5,0,16,156,5,0,240,212,5,0,232,155,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,40,156,5,0,2,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,119,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,0,240,212,5,0,80,156,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,40,156,5,0,2,0,0,0,0,0,0,0,240,156,5,0,119,0,0,0,123,0,0,0,70,0,0,0,6,0,0,0,7,0,0,0,9,0,0,0,89,0,0,0,90,0,0,0,10,0,0,0,91,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,115,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,240,212,5,0,200,156,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,40,156,5,0,2,0,0,0,0,0,0,0,104,157,5,0,119,0,0,0,124,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,55,99,111,100,101,99,118,116,73,68,105,99,49,49,95,95,109,98,115,116,97,116,101,95,116,69,69,0,0,0,0,0,0,240,212,5,0,64,157,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,40,156,5,0,2,0,0,0,0,0,0,0,224,157,5,0,119,0,0,0,125,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,54,95,95,110,97,114,114,111,119,95,116,111,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,0,144,212,5,0,184,157,5,0,104,157,5,0,0,0,0,0,0,0,0,0,72,158,5,0,119,0,0,0,126,0,0,0,70,0,0,0,8,0,0,0,9,0,0,0,11,0,0,0,92,0,0,0,93,0,0,0,12,0,0,0,94,0,0,0,78,83,116,51,95,95,49,49,55,95,95,119,105,100,101,110,95,102,114,111,109,95,117,116,102,56,73,76,106,51,50,69,69,69,0,0,0,0,0,0,144,212,5,0,32,158,5,0,104,157,5,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,99,69,69,0,0,0,0,144,212,5,0,88,158,5,0,208,154,5,0,0,0,0,0,78,83,116,51,95,95,49,56,110,117,109,112,117,110,99,116,73,119,69,69,0,0,0,0,144,212,5,0,128,158,5,0,208,154,5,0,0,0,0,0,78,83,116,51,95,95,49,54,108,111,99,97,108,101,53,95,95,105,109,112,69,0,0,0,144,212,5,0,168,158,5,0,208,154,5,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,99,69,69,0,0,0,0,0,144,212,5,0,208,158,5,0,208,154,5,0,0,0,0,0,78,83,116,51,95,95,49,55,99,111,108,108,97,116,101,73,119,69,69,0,0,0,0,0,144,212,5,0,248,158,5,0,208,154,5,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,48,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,95,98,97,115,101,69,0,0,0,0,104,212,5,0,64,159,5,0,240,212,5,0,32,159,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,159,5,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,99,76,98,49,69,69,69,0,0,0,0,0,240,212,5,0,128,159,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,159,5,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,48,69,69,69,0,0,0,0,0,240,212,5,0,192,159,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,159,5,0,2,0,0,0,78,83,116,51,95,95,49,49,48,109,111,110,101,121,112,117,110,99,116,73,119,76,98,49,69,69,69,0,0,0,0,0,240,212,5,0,0,160,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,159,5,0,2,0,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,57,116,105,109,101,95,98,97,115,101,69,0,0,0,0,0,0,104,212,5,0,136,160,5,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,99,69,69,0,0,0,0,0,0,0,104,212,5,0,168,160,5,0,240,212,5,0,64,160,5,0,0,0,0,0,3,0,0,0,208,154,5,0,2,0,0,0,160,160,5,0,2,0,0,0,208,160,5,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,50,48,95,95,116,105,109,101,95,103,101,116,95,99,95,115,116,111,114,97,103,101,73,119,69,69,0,0,0,0,0,0,0,104,212,5,0,72,161,5,0,240,212,5,0,0,161,5,0,0,0,0,0,3,0,0,0,208,154,5,0,2,0,0,0,160,160,5,0,2,0,0,0,112,161,5,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,78,83,116,51,95,95,49,49,48,95,95,116,105,109,101,95,112,117,116,69,0,0,0,0,104,212,5,0,232,161,5,0,240,212,5,0,160,161,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,0,162,5,0,0,8,0,0,78,83,116,51,95,95,49,56,116,105,109,101,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,240,212,5,0,40,162,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,0,162,5,0,0,8,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,99,69,69,0,0,0,0,78,83,116,51,95,95,49,49,51,109,101,115,115,97,103,101,115,95,98,97,115,101,69,0,104,212,5,0,168,162,5,0,240,212,5,0,144,162,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,192,162,5,0,2,0,0,0,78,83,116,51,95,95,49,56,109,101,115,115,97,103,101,115,73,119,69,69,0,0,0,0,240,212,5,0,232,162,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,192,162,5,0,2,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,103,101,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,104,212,5,0,128,163,5,0,240,212,5,0,104,163,5,0,0,0,0,0,1,0,0,0,160,163,5,0,0,0,0,0,240,212,5,0,32,163,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,168,163,5,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,103,101,116,73,119,69,69,0,0,0,240,212,5,0,40,164,5,0,0,0,0,0,1,0,0,0,160,163,5,0,0,0,0,0,240,212,5,0,224,163,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,64,164,5,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,99,69,69,0,0,0,78,83,116,51,95,95,49,49,52,95,95,110,117,109,95,112,117,116,95,98,97,115,101,69,0,0,0,0,0,0,0,0,104,212,5,0,216,164,5,0,240,212,5,0,192,164,5,0,0,0,0,0,1,0,0,0,248,164,5,0,0,0,0,0,240,212,5,0,120,164,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,0,165,5,0,0,0,0,0,78,83,116,51,95,95,49,55,110,117,109,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,0,0,78,83,116,51,95,95,49,57,95,95,110,117,109,95,112,117,116,73,119,69,69,0,0,0,240,212,5,0,128,165,5,0,0,0,0,0,1,0,0,0,248,164,5,0,0,0,0,0,240,212,5,0,56,165,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,152,165,5,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,99,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,99,69,69,0,0,0,0,0,0,0,0,104,212,5,0,24,166,5,0,240,212,5,0,208,165,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,56,166,5,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,103,101,116,73,119,78,83,95,49,57,105,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,103,101,116,73,119,69,69,0,0,0,0,0,0,0,0,104,212,5,0,168,166,5,0,240,212,5,0,96,166,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,200,166,5,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,99,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,99,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,99,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,99,69,69,0,0,0,0,0,0,0,0,104,212,5,0,56,167,5,0,240,212,5,0,240,166,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,88,167,5,0,0,0,0,0,78,83,116,51,95,95,49,57,109,111,110,101,121,95,112,117,116,73,119,78,83,95,49,57,111,115,116,114,101,97,109,98,117,102,95,105,116,101,114,97,116,111,114,73,119,78,83,95,49,49,99,104,97,114,95,116,114,97,105,116,115,73,119,69,69,69,69,69,69,0,0,0,78,83,116,51,95,95,49,49,49,95,95,109,111,110,101,121,95,112,117,116,73,119,69,69,0,0,0,0,0,0,0,0,104,212,5,0,200,167,5,0,240,212,5,0,128,167,5,0,0,0,0,0,2,0,0,0,208,154,5,0,2,0,0,0,232,167,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,80,0,0,0,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,65,77,0,0,0,0,0,0,80,77,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,114,0,0,0,117,0,0,0,97,0,0,0,114,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,99,0,0,0,104,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,105,0,0,0,108,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,101,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,117,0,0,0,115,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,116,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,111,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99,0,0,0,101,0,0,0,109,0,0,0,98,0,0,0,101,0,0,0,114,0,0,0,0,0,0,0,0,0,0,0,74,0,0,0,97,0,0,0,110,0,0,0,0,0,0,0,70,0,0,0,101,0,0,0,98,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,114,0,0,0,0,0,0,0,65,0,0,0,112,0,0,0,114,0,0,0,0,0,0,0,77,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,74,0,0,0,117,0,0,0,108,0,0,0,0,0,0,0,65,0,0,0,117,0,0,0,103,0,0,0,0,0,0,0,83,0,0,0,101,0,0,0,112,0,0,0,0,0,0,0,79,0,0,0,99,0,0,0,116,0,0,0,0,0,0,0,78,0,0,0,111,0,0,0,118,0,0,0,0,0,0,0,68,0,0,0,101,0,0,0,99], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+362604);
/* memory initializer */ allocate([74,97,110,117,97,114,121,0,70,101,98,114,117,97,114,121,0,0,0,0,0,0,0,0,77,97,114,99,104,0,0,0,65,112,114,105,108,0,0,0,77,97,121,0,0,0,0,0,74,117,110,101,0,0,0,0,74,117,108,121,0,0,0,0,65,117,103,117,115,116,0,0,83,101,112,116,101,109,98,101,114,0,0,0,0,0,0,0,79,99,116,111,98,101,114,0,78,111,118,101,109,98,101,114,0,0,0,0,0,0,0,0,68,101,99,101,109,98,101,114,0,0,0,0,0,0,0,0,74,97,110,0,0,0,0,0,70,101,98,0,0,0,0,0,77,97,114,0,0,0,0,0,65,112,114,0,0,0,0,0,74,117,110,0,0,0,0,0,74,117,108,0,0,0,0,0,65,117,103,0,0,0,0,0,83,101,112,0,0,0,0,0,79,99,116,0,0,0,0,0,78,111,118,0,0,0,0,0,68,101,99,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,110,0,0,0,101,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,114,0,0,0,115,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,117,0,0,0,114,0,0,0,100,0,0,0,97,0,0,0,121,0,0,0,0,0,0,0,0,0,0,0,83,0,0,0,117,0,0,0,110,0,0,0,0,0,0,0,77,0,0,0,111,0,0,0,110,0,0,0,0,0,0,0,84,0,0,0,117,0,0,0,101,0,0,0,0,0,0,0,87,0,0,0,101,0,0,0,100,0,0,0,0,0,0,0,84,0,0,0,104,0,0,0,117,0,0,0,0,0,0,0,70,0,0,0,114,0,0,0,105,0,0,0,0,0,0,0,83,0,0,0,97,0,0,0,116,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,83,117,110,100,97,121,0,0,77,111,110,100,97,121,0,0,84,117,101,115,100,97,121,0,87,101,100,110,101,115,100,97,121,0,0,0,0,0,0,0,84,104,117,114,115,100,97,121,0,0,0,0,0,0,0,0,70,114,105,100,97,121,0,0,83,97,116,117,114,100,97,121,0,0,0,0,0,0,0,0,83,117,110,0,0,0,0,0,77,111,110,0,0,0,0,0,84,117,101,0,0,0,0,0,87,101,100,0,0,0,0,0,84,104,117,0,0,0,0,0,70,114,105,0,0,0,0,0,83,97,116,0,0,0,0,0,18,17,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,17,34,35,36,17,37,38,39,40,41,42,43,44,17,45,46,47,16,16,48,16,16,16,16,16,16,16,49,50,51,16,52,53,16,16,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,54,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,55,17,17,17,17,56,17,57,58,59,60,61,62,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,17,63,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,64,65,17,66,67,68,69,70,71,72,73,16,16,16,74,75,76,77,78,16,16,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,17,17,17,82,83,16,16,16,16,16,16,16,16,16,16,16,17,17,17,17,84,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,17,17,85,16,16,16,16,86,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,87,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,88,89,90,91,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,92,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,254,255,255,7,254,255,255,7,0,0,0,0,0,4,32,4,255,255,127,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,195,255,3,0,31,80,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,223,60,64,215,255,255,251,255,255,255,255,255,255,255,255,255,191,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,3,252,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,254,255,255,255,127,2,254,255,255,255,255,0,0,0,0,0,255,191,182,0,255,255,255,7,7,0,0,0,255,7,255,255,255,255,255,255,255,254,255,195,255,255,255,255,255,255,255,255,255,255,255,255,239,31,254,225,255,159,0,0,255,255,255,255,255,255,0,224,255,255,255,255,255,255,255,255,255,255,255,255,3,0,255,255,255,255,255,7,48,4,255,255,255,252,255,31,0,0,255,255,255,1,0,0,0,0,0,0,0,0,253,31,0,0,0,0,0,0,240,3,255,127,255,255,255,255,255,255,255,239,255,223,225,255,207,255,254,254,238,159,249,255,255,253,197,227,159,89,128,176,207,255,3,0,238,135,249,255,255,253,109,195,135,25,2,94,192,255,63,0,238,191,251,255,255,253,237,227,191,27,1,0,207,255,0,0,238,159,249,255,255,253,237,227,159,25,192,176,207,255,2,0,236,199,61,214,24,199,255,195,199,29,129,0,192,255,0,0,238,223,253,255,255,253,239,227,223,29,96,3,207,255,0,0,236,223,253,255,255,253,239,227,223,29,96,64,207,255,6,0,236,223,253,255,255,255,255,231,223,93,128,0,207,255,0,252,236,255,127,252,255,255,251,47,127,128,95,255,0,0,12,0,254,255,255,255,255,127,255,7,63,32,255,3,0,0,0,0,150,37,240,254,174,236,255,59,95,32,255,243,0,0,0,0,1,0,0,0,255,3,0,0,255,254,255,255,255,31,254,255,3,255,255,254,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,249,255,3,255,255,231,193,255,255,127,64,255,51,255,255,255,255,191,32,255,255,255,255,255,247,255,255,255,255,255,255,255,255,255,61,127,61,255,255,255,255,255,61,255,255,255,255,61,127,61,255,127,255,255,255,255,255,255,255,61,255,255,255,255,255,255,255,255,135,0,0,0,0,255,255,0,0,255,255,255,255,255,255,255,255,255,255,31,0,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,159,255,255,254,255,255,7,255,255,255,255,255,255,255,255,255,199,1,0,255,223,15,0,255,255,15,0,255,255,15,0,255,223,13,0,255,255,255,255,255,255,207,255,255,1,128,16,255,3,0,0,0,0,255,3,255,255,255,255,255,255,255,255,255,255,255,0,255,255,255,255,255,7,255,255,255,255,255,255,255,255,63,0,255,255,255,31,255,15,255,1,192,255,255,255,255,63,31,0,255,255,255,255,255,15,255,255,255,3,255,3,0,0,0,0,255,255,255,15,255,255,255,255,255,255,255,127,254,255,31,0,255,3,255,3,128,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,239,255,239,15,255,3,0,0,0,0,255,255,255,255,255,243,255,255,255,255,255,255,191,255,3,0,255,255,255,255,255,255,63,0,255,227,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,222,111,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,255,255,63,63,255,255,255,255,63,63,255,170,255,255,255,63,255,255,255,255,255,255,223,95,220,31,207,15,255,31,220,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,128,0,0,255,31,0,0,0,0,0,0,0,0,0,0,0,0,132,252,47,62,80,189,255,243,224,67,0,0,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,255,255,255,255,255,255,3,0,0,255,255,255,255,255,127,255,255,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,120,12,0,255,255,255,255,191,32,255,255,255,255,255,255,255,128,0,0,255,255,127,0,127,127,127,127,127,127,127,127,255,255,255,255,0,0,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,0,0,0,254,3,62,31,254,255,255,255,255,255,255,255,255,255,127,224,254,255,255,255,255,255,255,255,255,255,255,247,224,255,255,255,255,63,254,255,255,255,255,255,255,255,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,255,255,255,255,255,63,255,31,255,255,255,15,0,0,255,255,255,255,255,127,240,143,255,255,255,128,255,255,255,255,255,255,255,255,255,255,0,0,0,0,128,255,252,255,255,255,255,255,255,255,255,255,255,255,255,121,15,0,255,7,0,0,0,0,0,0,0,0,0,255,187,247,255,255,255,0,0,0,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,15,0,255,3,0,0,252,8,255,255,255,255,255,7,255,255,255,255,7,0,255,255,255,31,255,255,255,255,255,255,247,255,0,128,255,3,0,0,0,0,255,255,255,255,255,255,127,0,255,63,255,3,255,255,127,4,255,255,255,255,255,255,255,127,5,0,0,56,255,255,60,0,126,126,126,0,127,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,7,255,3,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,127,248,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,0,127,0,248,224,255,253,127,95,219,255,255,255,255,255,255,255,255,255,255,255,255,255,3,0,0,0,248,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,255,255,255,255,255,255,255,255,252,255,255,255,255,255,255,0,0,0,0,0,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,223,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,0,0,255,3,254,255,255,7,254,255,255,7,192,255,255,255,255,255,255,255,255,255,255,127,252,252,252,28,0,0,0,0,255,239,255,255,127,255,255,183,255,63,255,63,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,255,255,255,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,31,255,255,255,255,255,255,1,0,0,0,0,0,255,255,255,127,0,0,255,255,255,7,0,0,0,0,0,0,255,255,255,63,255,255,255,255,15,255,62,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,3,0,0,0,0,0,0,0,0,0,0,63,253,255,255,255,255,191,145,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,63,0,255,255,255,3,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,192,0,0,0,0,0,0,0,0,111,240,239,254,255,255,15,0,0,0,0,0,255,255,255,31,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,255,63,0,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,192,255,0,0,252,255,255,255,255,255,255,1,0,0,255,255,255,1,255,3,255,255,255,255,255,255,199,255,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,30,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,63,0,255,3,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,31,0,255,255,255,255,255,127,0,0,248,255,0,0,0,0,0,0,0,0,0,0,0,0,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,255,255,255,223,100,222,255,235,239,255,255,255,255,255,255,255,191,231,223,223,255,255,255,123,95,252,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,255,255,255,253,255,255,247,255,255,255,247,255,255,223,255,255,255,223,255,255,127,255,255,255,127,255,255,255,253,255,255,255,253,255,255,247,207,255,255,255,255,255,255,239,255,255,255,150,254,247,10,132,234,150,170,150,247,247,94,255,251,255,15,238,251,255,15,0,0,0,0,0,0,0,0,97,108,110,117,109,0,97,108,112,104,97,0,98,108,97,110,107,0,99,110,116,114,108,0,100,105,103,105,116,0,103,114,97,112,104,0,108,111,119,101,114,0,112,114,105,110,116,0,112,117,110,99,116,0,115,112,97,99,101,0,117,112,112,101,114,0,120,100,105,103,105,116,0,0,0,0,0,0,0,0,18,16,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,16,16,34,35,16,36,37,38,39,40,41,42,43,16,44,45,46,17,47,48,17,17,49,17,17,17,50,51,52,53,54,55,56,57,17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,58,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,59,16,60,61,62,63,64,65,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,66,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,67,16,16,68,16,69,70,71,16,72,16,73,16,16,16,16,74,75,76,77,16,16,78,16,79,80,16,16,16,16,81,16,16,16,16,16,16,16,16,16,16,16,16,16,82,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,83,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,84,85,86,87,16,16,88,89,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,90,16,91,92,93,94,95,96,97,98,16,16,16,16,16,16,16,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,0,0,0,0,254,255,0,252,1,0,0,248,1,0,0,120,0,0,0,0,255,251,223,251,0,0,128,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,60,0,252,255,224,175,255,255,255,255,255,255,255,255,255,255,223,255,255,255,255,255,32,64,176,0,0,0,0,0,0,0,0,0,0,0,0,0,64,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,134,254,255,255,255,0,64,73,0,0,0,0,0,24,0,223,255,0,200,0,0,0,0,0,0,0,1,0,60,0,0,0,0,0,0,0,0,0,0,0,0,16,224,1,30,0,96,255,191,0,0,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,207,3,0,0,0,3,0,32,255,127,0,0,0,78,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,0,0,0,16,0,32,30,0,48,0,1,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,252,15,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,3,0,0,0,0,0,0,0,0,16,0,32,0,0,0,0,253,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,255,7,0,0,0,0,0,0,0,0,0,32,0,0,0,0,0,255,0,0,0,0,0,0,0,16,0,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,0,63,2,0,0,0,0,0,0,0,0,0,4,0,0,0,0,16,0,0,0,0,0,0,128,0,128,192,223,0,12,0,0,0,0,0,0,0,0,0,0,0,0,0,31,0,0,0,0,0,0,254,255,255,255,0,252,255,255,0,0,0,0,0,0,0,0,252,0,0,0,0,0,0,192,255,223,255,7,0,0,0,0,0,0,0,0,0,0,128,6,0,252,0,0,24,62,0,0,128,191,0,204,0,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,96,255,255,255,31,0,0,255,3,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,96,0,0,1,0,0,24,0,0,0,0,0,0,0,0,0,56,0,0,0,0,16,0,0,0,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,0,0,254,127,47,0,0,255,3,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,14,49,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,196,255,255,255,255,0,0,0,192,0,0,0,0,0,0,0,0,1,0,224,159,0,0,0,0,127,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,16,0,16,0,0,252,255,255,255,31,0,0,0,0,0,12,0,0,0,0,0,0,64,0,12,240,0,0,0,0,0,0,192,248,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,255,0,255,255,255,33,16,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,127,0,0,240,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,160,3,224,0,224,0,224,0,96,128,248,255,255,255,252,255,255,255,255,255,127,31,252,241,127,255,127,0,0,255,255,255,3,0,0,255,255,255,255,1,0,123,3,208,193,175,66,0,12,31,188,255,255,0,0,0,0,0,2,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,127,0,0,0,255,7,0,0,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,252,255,255,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,31,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,224,135,3,254,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,127,255,15,0,0,0,0,0,0,0,0,255,255,255,251,255,255,255,255,255,255,255,255,255,255,15,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,255,15,30,255,255,255,1,252,193,224,0,0,0,0,0,0,0,0,0,0,0,30,1,0,0,0,0,0,0,0,0,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,0,0,0,0,255,255,255,255,15,0,0,0,255,255,255,127,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,127,0,0,0,0,0,0,192,0,224,0,0,0,0,0,0,0,0,0,0,0,128,15,112,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,0,255,255,127,0,3,0,0,0,0,0,0,0,0,0,0,0,0,6,0,0,0,0,0,0,0,0,0,0,0,0,0,0,68,8,0,0,0,15,255,3,0,0,0,0,0,0,240,0,0,0,0,0,0,0,0,0,16,192,0,0,255,255,3,7,0,0,0,0,0,248,0,0,0,0,8,128,0,0,0,0,0,0,0,0,0,0,8,0,255,63,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,240,0,0,128,11,0,0,0,0,0,0,0,128,2,0,0,192,0,0,67,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,56,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,252,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,48,255,255,255,3,127,0,255,255,255,255,247,255,127,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,254,255,0,252,1,0,0,248,1,0,0,248,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,127,127,0,48,135,255,255,255,255,255,143,255,0,0,0,0,0,0,224,255,255,7,255,15,0,0,0,0,0,0,255,255,255,255,255,63,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,143,0,0,0,128,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,135,255,0,255,1,0,0,0,224,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,254,0,0,0,255,0,0,0,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,127,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,63,252,255,63,0,0,0,3,0,0,0,0,0,0,254,3,0,0,0,0,0,0,0,0,0,0,0,0,0,24,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,225,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,192,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,128,7,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,255,255,255,255,127,254,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,63,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,127,0,255,255,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,8,0,0,0,8,0,0,32,0,0,0,32,0,0,128,0,0,0,128,0,0,0,2,0,0,0,2,0,0,8,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,3,0,255,255,255,255,255,15,255,255,255,255,255,255,255,255,255,255,255,255,15,0,255,127,254,127,254,255,254,255,0,0,0,0,255,7,255,255,255,127,255,255,255,255,255,255,255,15,255,255,255,255,255,7,0,0,0,0,0,0,0,0,192,255,255,255,7,0,255,255,255,255,255,7,255,1,3,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,255,255,255,255,1,0,191,255,255,255,255,255,255,255,255,31,255,255,15,0,255,255,255,255,223,7,0,0,255,255,1,0,255,255,255,255,255,255,255,127,253,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,30,255,255,255,255,255,255,255,63,15,0,255,255,255,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,248,255,255,255,255,255,255,255,255,225,255,0,0,0,0,0,0,255,255,255,255,255,255,255,255,63,0,0,0,0,0,0,0,255,255,255,255,255,255,255,255,255,255,255,255,255,255,15,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,0,0,0,9,0,0,0,10,0,0,0,13,0,0,0,11,0,0,0,12,0,0,0,133,0,0,0,0,32,0,0,1,32,0,0,2,32,0,0,3,32,0,0,4,32,0,0,5,32,0,0,6,32,0,0,8,32,0,0,9,32,0,0,10,32,0,0,40,32,0,0,41,32,0,0,95,32,0,0,0,48,0,0,0,0,0,0,65,0,32,26,192,0,32,31,0,1,1,47,50,1,1,5,57,1,1,15,74,1,1,45,121,1,1,5,112,3,1,3,145,3,32,17,163,3,32,9,0,4,80,16,16,4,32,32,96,4,1,33,138,4,1,53,193,4,1,13,208,4,1,63,20,5,1,19,49,5,48,38,160,1,1,5,179,1,1,3,205,1,1,15,222,1,1,17,248,1,1,39,34,2,1,17,216,3,1,23,0,30,1,149,160,30,1,95,8,31,248,8,24,31,248,6,40,31,248,8,56,31,248,8,72,31,248,6,104,31,248,8,136,31,248,8,152,31,248,8,168,31,248,8,184,31,248,2,186,31,182,2,200,31,170,4,216,31,248,2,218,31,156,2,232,31,248,2,234,31,144,2,248,31,128,2,250,31,130,2,70,2,1,9,16,5,1,3,96,33,16,16,0,44,48,47,103,44,1,5,128,44,1,99,235,44,1,3,64,166,1,45,128,166,1,23,34,167,1,13,50,167,1,61,121,167,1,3,126,167,1,9,144,167,1,3,160,167,1,9,33,255,32,26,0,0,0,0,73,0,49,1,83,0,127,1,48,1,105,0,120,1,255,0,129,1,83,2,130,1,131,1,132,1,133,1,134,1,84,2,135,1,136,1,137,1,86,2,138,1,87,2,139,1,140,1,142,1,221,1,143,1,89,2,144,1,91,2,145,1,146,1,147,1,96,2,148,1,99,2,150,1,105,2,151,1,104,2,152,1,153,1,156,1,111,2,157,1,114,2,159,1,117,2,166,1,128,2,167,1,168,1,169,1,131,2,172,1,173,1,174,1,136,2,175,1,176,1,177,1,138,2,178,1,139,2,183,1,146,2,184,1,185,1,188,1,189,1,196,1,198,1,196,1,197,1,197,1,198,1,199,1,201,1,199,1,200,1,200,1,201,1,202,1,204,1,202,1,203,1,203,1,204,1,241,1,243,1,241,1,242,1,242,1,243,1,244,1,245,1,246,1,149,1,247,1,191,1,32,2,158,1,134,3,172,3,136,3,173,3,137,3,174,3,138,3,175,3,140,3,204,3,142,3,205,3,143,3,206,3,153,3,69,3,153,3,190,31,163,3,194,3,247,3,248,3,250,3,251,3,96,30,155,30,223,0,223,0,158,30,223,0,89,31,81,31,91,31,83,31,93,31,85,31,95,31,87,31,188,31,179,31,204,31,195,31,236,31,229,31,252,31,243,31,58,2,101,44,59,2,60,2,61,2,154,1,62,2,102,44,65,2,66,2,67,2,128,1,68,2,137,2,69,2,140,2,244,3,184,3,249,3,242,3,253,3,123,3,254,3,124,3,255,3,125,3,192,4,207,4,38,33,201,3,42,33,107,0,43,33,229,0,50,33,78,33,131,33,132,33,96,44,97,44,98,44,107,2,99,44,125,29,100,44,125,2,109,44,81,2,110,44,113,2,111,44,80,2,112,44,82,2,114,44,115,44,117,44,118,44,126,44,63,2,127,44,64,2,242,44,243,44,125,167,121,29,139,167,140,167,141,167,101,2,170,167,102,2,199,16,39,45,205,16,45,45,118,3,119,3,156,3,181,0,146,3,208,3,152,3,209,3,166,3,213,3,160,3,214,3,154,3,240,3,161,3,241,3,149,3,245,3,207,3,215,3,0,0,0,0,0,0,0,0,2,0,0,192,3,0,0,192,4,0,0,192,5,0,0,192,6,0,0,192,7,0,0,192,8,0,0,192,9,0,0,192,10,0,0,192,11,0,0,192,12,0,0,192,13,0,0,192,14,0,0,192,15,0,0,192,16,0,0,192,17,0,0,192,18,0,0,192,19,0,0,192,20,0,0,192,21,0,0,192,22,0,0,192,23,0,0,192,24,0,0,192,25,0,0,192,26,0,0,192,27,0,0,192,28,0,0,192,29,0,0,192,30,0,0,192,31,0,0,192,0,0,0,179,1,0,0,195,2,0,0,195,3,0,0,195,4,0,0,195,5,0,0,195,6,0,0,195,7,0,0,195,8,0,0,195,9,0,0,195,10,0,0,195,11,0,0,195,12,0,0,195,13,0,0,211,14,0,0,195,15,0,0,195,0,0,12,187,1,0,12,195,2,0,12,195,3,0,12,195,4,0,12,211,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,116,0,0,0,216,209,5,0,110,0,0,0,224,209,5,0,114,0,0,0,232,209,5,0,102,0,0,0,240,209,5,0,97,0,0,0,248,209,5,0,101,0,0,0,0,210,5,0,119,0,0,0,8,210,5,0,87,0,0,0,24,210,5,0,115,0,0,0,40,210,5,0,83,0,0,0,56,210,5,0,100,0,0,0,72,210,5,0,68,0,0,0,88,210,5,0,0,0,0,0,0,0,0,0,9,0,0,0,0,0,0,0,10,0,0,0,0,0,0,0,13,0,0,0,0,0,0,0,12,0,0,0,0,0,0,0,7,0,0,0,0,0,0,0,27,0,0,0,0,0,0,0,91,91,58,97,108,110,117,109,58,93,95,93,0,0,0,0,91,94,91,58,97,108,110,117,109,58,93,95,93,0,0,0,91,91,58,115,112,97,99,101,58,93,93,0,0,0,0,0,91,94,91,58,115,112,97,99,101,58,93,93,0,0,0,0,91,91,58,100,105,103,105,116,58,93,93,0,0,0,0,0,91,94,91,58,100,105,103,105,116,58,93,93,0,0,0,0,78,111,32,101,114,114,111,114,0,78,111,32,109,97,116,99,104,0,73,110,118,97,108,105,100,32,114,101,103,101,120,112,0,85,110,107,110,111,119,110,32,99,111,108,108,97,116,105,110,103,32,101,108,101,109,101,110,116,0,85,110,107,110,111,119,110,32,99,104,97,114,97,99,116,101,114,32,99,108,97,115,115,32,110,97,109,101,0,84,114,97,105,108,105,110,103,32,98,97,99,107,115,108,97,115,104,0,73,110,118,97,108,105,100,32,98,97,99,107,32,114,101,102,101,114,101,110,99,101,0,77,105,115,115,105,110,103,32,39,93,39,0,77,105,115,115,105,110,103,32,39,41,39,0,77,105,115,115,105,110,103,32,39,125,39,0,73,110,118,97,108,105,100,32,99,111,110,116,101,110,116,115,32,111,102,32,123,125,0,73,110,118,97,108,105,100,32,99,104,97,114,97,99,116,101,114,32,114,97,110,103,101,0,79,117,116,32,111,102,32,109,101,109,111,114,121,0,82,101,112,101,116,105,116,105,111,110,32,110,111,116,32,112,114,101,99,101,100,101,100,32,98,121,32,118,97,108,105,100,32,101,120,112,114,101,115,115,105,111,110,0,0,85,110,107,110,111,119,110,32,101,114,114,111,114,0,0,0,37,115,0,0,0,0,0,0,0,0,0,0,224,211,5,0,127,0,0,0,128,0,0,0,95,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,99,97,115,116,0,0,0,83,116,57,116,121,112,101,95,105,110,102,111,0,0,0,0,104,212,5,0,184,211,5,0,83,116,56,98,97,100,95,99,97,115,116,0,0,0,0,0,144,212,5,0,208,211,5,0,0,0,0,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,54,95,95,115,104,105,109,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,0,144,212,5,0,240,211,5,0,200,211,5,0,0,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,49,55,95,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,0,0,0,144,212,5,0,40,212,5,0,24,212,5,0,0,0,0,0,0,0,0,0,80,212,5,0,129,0,0,0,130,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,16,0,0,0,10,0,0,0,11,0,0,0,0,0,0,0,216,212,5,0,129,0,0,0,133,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,17,0,0,0,11,0,0,0,12,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,48,95,95,115,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,0,144,212,5,0,176,212,5,0,80,212,5,0,0,0,0,0,0,0,0,0,56,213,5,0,129,0,0,0,134,0,0,0,131,0,0,0,132,0,0,0,30,0,0,0,18,0,0,0,12,0,0,0,13,0,0,0,78,49,48,95,95,99,120,120,97,98,105,118,49,50,49,95,95,118,109,105,95,99,108,97,115,115,95,116,121,112,101,95,105,110,102,111,69,0,0,0,144,212,5,0,16,213,5,0,80,212,5,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,120,215,5,0,135,0,0,0,136,0,0,0,96,0,0,0,0,0,0,0,115,116,100,58,58,98,97,100,95,97,108,108,111,99,0,0,83,116,57,98,97,100,95,97,108,108,111,99,0,0,0,0,144,212,5,0,104,215,5,0,0,0,0,0,0,0,0,0,105,110,102,105,110,105,116,121,0,0,0,0,0,0,0,0,110,97,110,0,0,0,0,0,95,112,137,0,255,9,47,15,10,0,0,0,100,0,0,0,232,3,0,0,16,39,0,0,160,134,1,0,64,66,15,0,128,150,152,0,0,225,245,5], "i8", ALLOC_NONE, Runtime.GLOBAL_BASE+372944);




var tempDoublePtr = Runtime.alignMemory(allocate(12, "i8", ALLOC_STATIC), 8);

assert(tempDoublePtr % 8 == 0);

function copyTempFloat(ptr) { // functions, because inlining this code increases code size too much

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

}

function copyTempDouble(ptr) {

  HEAP8[tempDoublePtr] = HEAP8[ptr];

  HEAP8[tempDoublePtr+1] = HEAP8[ptr+1];

  HEAP8[tempDoublePtr+2] = HEAP8[ptr+2];

  HEAP8[tempDoublePtr+3] = HEAP8[ptr+3];

  HEAP8[tempDoublePtr+4] = HEAP8[ptr+4];

  HEAP8[tempDoublePtr+5] = HEAP8[ptr+5];

  HEAP8[tempDoublePtr+6] = HEAP8[ptr+6];

  HEAP8[tempDoublePtr+7] = HEAP8[ptr+7];

}


  function _llvm_lifetime_end() {}

  
  
  var ERRNO_CODES={EPERM:1,ENOENT:2,ESRCH:3,EINTR:4,EIO:5,ENXIO:6,E2BIG:7,ENOEXEC:8,EBADF:9,ECHILD:10,EAGAIN:11,EWOULDBLOCK:11,ENOMEM:12,EACCES:13,EFAULT:14,ENOTBLK:15,EBUSY:16,EEXIST:17,EXDEV:18,ENODEV:19,ENOTDIR:20,EISDIR:21,EINVAL:22,ENFILE:23,EMFILE:24,ENOTTY:25,ETXTBSY:26,EFBIG:27,ENOSPC:28,ESPIPE:29,EROFS:30,EMLINK:31,EPIPE:32,EDOM:33,ERANGE:34,ENOMSG:42,EIDRM:43,ECHRNG:44,EL2NSYNC:45,EL3HLT:46,EL3RST:47,ELNRNG:48,EUNATCH:49,ENOCSI:50,EL2HLT:51,EDEADLK:35,ENOLCK:37,EBADE:52,EBADR:53,EXFULL:54,ENOANO:55,EBADRQC:56,EBADSLT:57,EDEADLOCK:35,EBFONT:59,ENOSTR:60,ENODATA:61,ETIME:62,ENOSR:63,ENONET:64,ENOPKG:65,EREMOTE:66,ENOLINK:67,EADV:68,ESRMNT:69,ECOMM:70,EPROTO:71,EMULTIHOP:72,EDOTDOT:73,EBADMSG:74,ENOTUNIQ:76,EBADFD:77,EREMCHG:78,ELIBACC:79,ELIBBAD:80,ELIBSCN:81,ELIBMAX:82,ELIBEXEC:83,ENOSYS:38,ENOTEMPTY:39,ENAMETOOLONG:36,ELOOP:40,EOPNOTSUPP:95,EPFNOSUPPORT:96,ECONNRESET:104,ENOBUFS:105,EAFNOSUPPORT:97,EPROTOTYPE:91,ENOTSOCK:88,ENOPROTOOPT:92,ESHUTDOWN:108,ECONNREFUSED:111,EADDRINUSE:98,ECONNABORTED:103,ENETUNREACH:101,ENETDOWN:100,ETIMEDOUT:110,EHOSTDOWN:112,EHOSTUNREACH:113,EINPROGRESS:115,EALREADY:114,EDESTADDRREQ:89,EMSGSIZE:90,EPROTONOSUPPORT:93,ESOCKTNOSUPPORT:94,EADDRNOTAVAIL:99,ENETRESET:102,EISCONN:106,ENOTCONN:107,ETOOMANYREFS:109,EUSERS:87,EDQUOT:122,ESTALE:116,ENOTSUP:95,ENOMEDIUM:123,EILSEQ:84,EOVERFLOW:75,ECANCELED:125,ENOTRECOVERABLE:131,EOWNERDEAD:130,ESTRPIPE:86};
  
  var ERRNO_MESSAGES={0:"Success",1:"Not super-user",2:"No such file or directory",3:"No such process",4:"Interrupted system call",5:"I/O error",6:"No such device or address",7:"Arg list too long",8:"Exec format error",9:"Bad file number",10:"No children",11:"No more processes",12:"Not enough core",13:"Permission denied",14:"Bad address",15:"Block device required",16:"Mount device busy",17:"File exists",18:"Cross-device link",19:"No such device",20:"Not a directory",21:"Is a directory",22:"Invalid argument",23:"Too many open files in system",24:"Too many open files",25:"Not a typewriter",26:"Text file busy",27:"File too large",28:"No space left on device",29:"Illegal seek",30:"Read only file system",31:"Too many links",32:"Broken pipe",33:"Math arg out of domain of func",34:"Math result not representable",35:"File locking deadlock error",36:"File or path name too long",37:"No record locks available",38:"Function not implemented",39:"Directory not empty",40:"Too many symbolic links",42:"No message of desired type",43:"Identifier removed",44:"Channel number out of range",45:"Level 2 not synchronized",46:"Level 3 halted",47:"Level 3 reset",48:"Link number out of range",49:"Protocol driver not attached",50:"No CSI structure available",51:"Level 2 halted",52:"Invalid exchange",53:"Invalid request descriptor",54:"Exchange full",55:"No anode",56:"Invalid request code",57:"Invalid slot",59:"Bad font file fmt",60:"Device not a stream",61:"No data (for no delay io)",62:"Timer expired",63:"Out of streams resources",64:"Machine is not on the network",65:"Package not installed",66:"The object is remote",67:"The link has been severed",68:"Advertise error",69:"Srmount error",70:"Communication error on send",71:"Protocol error",72:"Multihop attempted",73:"Cross mount point (not really error)",74:"Trying to read unreadable message",75:"Value too large for defined data type",76:"Given log. name not unique",77:"f.d. invalid for this operation",78:"Remote address changed",79:"Can   access a needed shared lib",80:"Accessing a corrupted shared lib",81:".lib section in a.out corrupted",82:"Attempting to link in too many libs",83:"Attempting to exec a shared library",84:"Illegal byte sequence",86:"Streams pipe error",87:"Too many users",88:"Socket operation on non-socket",89:"Destination address required",90:"Message too long",91:"Protocol wrong type for socket",92:"Protocol not available",93:"Unknown protocol",94:"Socket type not supported",95:"Not supported",96:"Protocol family not supported",97:"Address family not supported by protocol family",98:"Address already in use",99:"Address not available",100:"Network interface is not configured",101:"Network is unreachable",102:"Connection reset by network",103:"Connection aborted",104:"Connection reset by peer",105:"No buffer space available",106:"Socket is already connected",107:"Socket is not connected",108:"Can't send after socket shutdown",109:"Too many references",110:"Connection timed out",111:"Connection refused",112:"Host is down",113:"Host is unreachable",114:"Socket already connected",115:"Connection already in progress",116:"Stale file handle",122:"Quota exceeded",123:"No medium (in tape drive)",125:"Operation canceled",130:"Previous owner died",131:"State not recoverable"};
  
  
  var ___errno_state=0;function ___setErrNo(value) {
      // For convenient setting and returning of errno.
      HEAP32[((___errno_state)>>2)]=value;
      return value;
    }
  
  var PATH={splitPath:function (filename) {
        var splitPathRe = /^(\/?|)([\s\S]*?)((?:\.{1,2}|[^\/]+?|)(\.[^.\/]*|))(?:[\/]*)$/;
        return splitPathRe.exec(filename).slice(1);
      },normalizeArray:function (parts, allowAboveRoot) {
        // if the path tries to go above the root, `up` ends up > 0
        var up = 0;
        for (var i = parts.length - 1; i >= 0; i--) {
          var last = parts[i];
          if (last === '.') {
            parts.splice(i, 1);
          } else if (last === '..') {
            parts.splice(i, 1);
            up++;
          } else if (up) {
            parts.splice(i, 1);
            up--;
          }
        }
        // if the path is allowed to go above the root, restore leading ..s
        if (allowAboveRoot) {
          for (; up--; up) {
            parts.unshift('..');
          }
        }
        return parts;
      },normalize:function (path) {
        var isAbsolute = path.charAt(0) === '/',
            trailingSlash = path.substr(-1) === '/';
        // Normalize the path
        path = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), !isAbsolute).join('/');
        if (!path && !isAbsolute) {
          path = '.';
        }
        if (path && trailingSlash) {
          path += '/';
        }
        return (isAbsolute ? '/' : '') + path;
      },dirname:function (path) {
        var result = PATH.splitPath(path),
            root = result[0],
            dir = result[1];
        if (!root && !dir) {
          // No dirname whatsoever
          return '.';
        }
        if (dir) {
          // It has a dirname, strip trailing slash
          dir = dir.substr(0, dir.length - 1);
        }
        return root + dir;
      },basename:function (path) {
        // EMSCRIPTEN return '/'' for '/', not an empty string
        if (path === '/') return '/';
        var lastSlash = path.lastIndexOf('/');
        if (lastSlash === -1) return path;
        return path.substr(lastSlash+1);
      },extname:function (path) {
        return PATH.splitPath(path)[3];
      },join:function () {
        var paths = Array.prototype.slice.call(arguments, 0);
        return PATH.normalize(paths.join('/'));
      },join2:function (l, r) {
        return PATH.normalize(l + '/' + r);
      },resolve:function () {
        var resolvedPath = '',
          resolvedAbsolute = false;
        for (var i = arguments.length - 1; i >= -1 && !resolvedAbsolute; i--) {
          var path = (i >= 0) ? arguments[i] : FS.cwd();
          // Skip empty and invalid entries
          if (typeof path !== 'string') {
            throw new TypeError('Arguments to path.resolve must be strings');
          } else if (!path) {
            continue;
          }
          resolvedPath = path + '/' + resolvedPath;
          resolvedAbsolute = path.charAt(0) === '/';
        }
        // At this point the path should be resolved to a full absolute path, but
        // handle relative paths to be safe (might happen when process.cwd() fails)
        resolvedPath = PATH.normalizeArray(resolvedPath.split('/').filter(function(p) {
          return !!p;
        }), !resolvedAbsolute).join('/');
        return ((resolvedAbsolute ? '/' : '') + resolvedPath) || '.';
      },relative:function (from, to) {
        from = PATH.resolve(from).substr(1);
        to = PATH.resolve(to).substr(1);
        function trim(arr) {
          var start = 0;
          for (; start < arr.length; start++) {
            if (arr[start] !== '') break;
          }
          var end = arr.length - 1;
          for (; end >= 0; end--) {
            if (arr[end] !== '') break;
          }
          if (start > end) return [];
          return arr.slice(start, end - start + 1);
        }
        var fromParts = trim(from.split('/'));
        var toParts = trim(to.split('/'));
        var length = Math.min(fromParts.length, toParts.length);
        var samePartsLength = length;
        for (var i = 0; i < length; i++) {
          if (fromParts[i] !== toParts[i]) {
            samePartsLength = i;
            break;
          }
        }
        var outputParts = [];
        for (var i = samePartsLength; i < fromParts.length; i++) {
          outputParts.push('..');
        }
        outputParts = outputParts.concat(toParts.slice(samePartsLength));
        return outputParts.join('/');
      }};
  
  var TTY={ttys:[],init:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // currently, FS.init does not distinguish if process.stdin is a file or TTY
        //   // device, it always assumes it's a TTY device. because of this, we're forcing
        //   // process.stdin to UTF8 encoding to at least make stdin reading compatible
        //   // with text files until FS.init can be refactored.
        //   process['stdin']['setEncoding']('utf8');
        // }
      },shutdown:function () {
        // https://github.com/kripken/emscripten/pull/1555
        // if (ENVIRONMENT_IS_NODE) {
        //   // inolen: any idea as to why node -e 'process.stdin.read()' wouldn't exit immediately (with process.stdin being a tty)?
        //   // isaacs: because now it's reading from the stream, you've expressed interest in it, so that read() kicks off a _read() which creates a ReadReq operation
        //   // inolen: I thought read() in that case was a synchronous operation that just grabbed some amount of buffered data if it exists?
        //   // isaacs: it is. but it also triggers a _read() call, which calls readStart() on the handle
        //   // isaacs: do process.stdin.pause() and i'd think it'd probably close the pending call
        //   process['stdin']['pause']();
        // }
      },register:function (dev, ops) {
        TTY.ttys[dev] = { input: [], output: [], ops: ops };
        FS.registerDevice(dev, TTY.stream_ops);
      },stream_ops:{open:function (stream) {
          var tty = TTY.ttys[stream.node.rdev];
          if (!tty) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          stream.tty = tty;
          stream.seekable = false;
        },close:function (stream) {
          // flush any pending line data
          if (stream.tty.output.length) {
            stream.tty.ops.put_char(stream.tty, 10);
          }
        },read:function (stream, buffer, offset, length, pos /* ignored */) {
          if (!stream.tty || !stream.tty.ops.get_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          var bytesRead = 0;
          for (var i = 0; i < length; i++) {
            var result;
            try {
              result = stream.tty.ops.get_char(stream.tty);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            if (result === undefined && bytesRead === 0) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
            if (result === null || result === undefined) break;
            bytesRead++;
            buffer[offset+i] = result;
          }
          if (bytesRead) {
            stream.node.timestamp = Date.now();
          }
          return bytesRead;
        },write:function (stream, buffer, offset, length, pos) {
          if (!stream.tty || !stream.tty.ops.put_char) {
            throw new FS.ErrnoError(ERRNO_CODES.ENXIO);
          }
          for (var i = 0; i < length; i++) {
            try {
              stream.tty.ops.put_char(stream.tty, buffer[offset+i]);
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
          }
          if (length) {
            stream.node.timestamp = Date.now();
          }
          return i;
        }},default_tty_ops:{get_char:function (tty) {
          if (!tty.input.length) {
            var result = null;
            if (ENVIRONMENT_IS_NODE) {
              result = process['stdin']['read']();
              if (!result) {
                if (process['stdin']['_readableState'] && process['stdin']['_readableState']['ended']) {
                  return null;  // EOF
                }
                return undefined;  // no data available
              }
            } else if (typeof window != 'undefined' &&
              typeof window.prompt == 'function') {
              // Browser.
              result = window.prompt('Input: ');  // returns null on cancel
              if (result !== null) {
                result += '\n';
              }
            } else if (typeof readline == 'function') {
              // Command line.
              result = readline();
              if (result !== null) {
                result += '\n';
              }
            }
            if (!result) {
              return null;
            }
            tty.input = intArrayFromString(result, true);
          }
          return tty.input.shift();
        },put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['print'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }},default_tty1_ops:{put_char:function (tty, val) {
          if (val === null || val === 10) {
            Module['printErr'](tty.output.join(''));
            tty.output = [];
          } else {
            tty.output.push(TTY.utf8.processCChar(val));
          }
        }}};
  
  var MEMFS={ops_table:null,CONTENT_OWNING:1,CONTENT_FLEXIBLE:2,CONTENT_FIXED:3,mount:function (mount) {
        return MEMFS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createNode:function (parent, name, mode, dev) {
        if (FS.isBlkdev(mode) || FS.isFIFO(mode)) {
          // no supported
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (!MEMFS.ops_table) {
          MEMFS.ops_table = {
            dir: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                lookup: MEMFS.node_ops.lookup,
                mknod: MEMFS.node_ops.mknod,
                rename: MEMFS.node_ops.rename,
                unlink: MEMFS.node_ops.unlink,
                rmdir: MEMFS.node_ops.rmdir,
                readdir: MEMFS.node_ops.readdir,
                symlink: MEMFS.node_ops.symlink
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek
              }
            },
            file: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: {
                llseek: MEMFS.stream_ops.llseek,
                read: MEMFS.stream_ops.read,
                write: MEMFS.stream_ops.write,
                allocate: MEMFS.stream_ops.allocate,
                mmap: MEMFS.stream_ops.mmap
              }
            },
            link: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr,
                readlink: MEMFS.node_ops.readlink
              },
              stream: {}
            },
            chrdev: {
              node: {
                getattr: MEMFS.node_ops.getattr,
                setattr: MEMFS.node_ops.setattr
              },
              stream: FS.chrdev_stream_ops
            },
          };
        }
        var node = FS.createNode(parent, name, mode, dev);
        if (FS.isDir(node.mode)) {
          node.node_ops = MEMFS.ops_table.dir.node;
          node.stream_ops = MEMFS.ops_table.dir.stream;
          node.contents = {};
        } else if (FS.isFile(node.mode)) {
          node.node_ops = MEMFS.ops_table.file.node;
          node.stream_ops = MEMFS.ops_table.file.stream;
          node.contents = [];
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        } else if (FS.isLink(node.mode)) {
          node.node_ops = MEMFS.ops_table.link.node;
          node.stream_ops = MEMFS.ops_table.link.stream;
        } else if (FS.isChrdev(node.mode)) {
          node.node_ops = MEMFS.ops_table.chrdev.node;
          node.stream_ops = MEMFS.ops_table.chrdev.stream;
        }
        node.timestamp = Date.now();
        // add the new node to the parent
        if (parent) {
          parent.contents[name] = node;
        }
        return node;
      },ensureFlexible:function (node) {
        if (node.contentMode !== MEMFS.CONTENT_FLEXIBLE) {
          var contents = node.contents;
          node.contents = Array.prototype.slice.call(contents);
          node.contentMode = MEMFS.CONTENT_FLEXIBLE;
        }
      },node_ops:{getattr:function (node) {
          var attr = {};
          // device numbers reuse inode numbers.
          attr.dev = FS.isChrdev(node.mode) ? node.id : 1;
          attr.ino = node.id;
          attr.mode = node.mode;
          attr.nlink = 1;
          attr.uid = 0;
          attr.gid = 0;
          attr.rdev = node.rdev;
          if (FS.isDir(node.mode)) {
            attr.size = 4096;
          } else if (FS.isFile(node.mode)) {
            attr.size = node.contents.length;
          } else if (FS.isLink(node.mode)) {
            attr.size = node.link.length;
          } else {
            attr.size = 0;
          }
          attr.atime = new Date(node.timestamp);
          attr.mtime = new Date(node.timestamp);
          attr.ctime = new Date(node.timestamp);
          // NOTE: In our implementation, st_blocks = Math.ceil(st_size/st_blksize),
          //       but this is not required by the standard.
          attr.blksize = 4096;
          attr.blocks = Math.ceil(attr.size / attr.blksize);
          return attr;
        },setattr:function (node, attr) {
          if (attr.mode !== undefined) {
            node.mode = attr.mode;
          }
          if (attr.timestamp !== undefined) {
            node.timestamp = attr.timestamp;
          }
          if (attr.size !== undefined) {
            MEMFS.ensureFlexible(node);
            var contents = node.contents;
            if (attr.size < contents.length) contents.length = attr.size;
            else while (attr.size > contents.length) contents.push(0);
          }
        },lookup:function (parent, name) {
          throw FS.genericErrors[ERRNO_CODES.ENOENT];
        },mknod:function (parent, name, mode, dev) {
          return MEMFS.createNode(parent, name, mode, dev);
        },rename:function (old_node, new_dir, new_name) {
          // if we're overwriting a directory at new_name, make sure it's empty.
          if (FS.isDir(old_node.mode)) {
            var new_node;
            try {
              new_node = FS.lookupNode(new_dir, new_name);
            } catch (e) {
            }
            if (new_node) {
              for (var i in new_node.contents) {
                throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
              }
            }
          }
          // do the internal rewiring
          delete old_node.parent.contents[old_node.name];
          old_node.name = new_name;
          new_dir.contents[new_name] = old_node;
          old_node.parent = new_dir;
        },unlink:function (parent, name) {
          delete parent.contents[name];
        },rmdir:function (parent, name) {
          var node = FS.lookupNode(parent, name);
          for (var i in node.contents) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
          }
          delete parent.contents[name];
        },readdir:function (node) {
          var entries = ['.', '..']
          for (var key in node.contents) {
            if (!node.contents.hasOwnProperty(key)) {
              continue;
            }
            entries.push(key);
          }
          return entries;
        },symlink:function (parent, newname, oldpath) {
          var node = MEMFS.createNode(parent, newname, 511 /* 0777 */ | 40960, 0);
          node.link = oldpath;
          return node;
        },readlink:function (node) {
          if (!FS.isLink(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          return node.link;
        }},stream_ops:{read:function (stream, buffer, offset, length, position) {
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (size > 8 && contents.subarray) { // non-trivial, and typed array
            buffer.set(contents.subarray(position, position + size), offset);
          } else
          {
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          }
          return size;
        },write:function (stream, buffer, offset, length, position, canOwn) {
          var node = stream.node;
          node.timestamp = Date.now();
          var contents = node.contents;
          if (length && contents.length === 0 && position === 0 && buffer.subarray) {
            // just replace it with the new data
            if (canOwn && offset === 0) {
              node.contents = buffer; // this could be a subarray of Emscripten HEAP, or allocated from some other source.
              node.contentMode = (buffer.buffer === HEAP8.buffer) ? MEMFS.CONTENT_OWNING : MEMFS.CONTENT_FIXED;
            } else {
              node.contents = new Uint8Array(buffer.subarray(offset, offset+length));
              node.contentMode = MEMFS.CONTENT_FIXED;
            }
            return length;
          }
          MEMFS.ensureFlexible(node);
          var contents = node.contents;
          while (contents.length < position) contents.push(0);
          for (var i = 0; i < length; i++) {
            contents[position + i] = buffer[offset + i];
          }
          return length;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              position += stream.node.contents.length;
            }
          }
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          stream.ungotten = [];
          stream.position = position;
          return position;
        },allocate:function (stream, offset, length) {
          MEMFS.ensureFlexible(stream.node);
          var contents = stream.node.contents;
          var limit = offset + length;
          while (limit > contents.length) contents.push(0);
        },mmap:function (stream, buffer, offset, length, position, prot, flags) {
          if (!FS.isFile(stream.node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
          }
          var ptr;
          var allocated;
          var contents = stream.node.contents;
          // Only make a new copy when MAP_PRIVATE is specified.
          if ( !(flags & 2) &&
                (contents.buffer === buffer || contents.buffer === buffer.buffer) ) {
            // We can't emulate MAP_SHARED when the file is not backed by the buffer
            // we're mapping to (e.g. the HEAP buffer).
            allocated = false;
            ptr = contents.byteOffset;
          } else {
            // Try to avoid unnecessary slices.
            if (position > 0 || position + length < contents.length) {
              if (contents.subarray) {
                contents = contents.subarray(position, position + length);
              } else {
                contents = Array.prototype.slice.call(contents, position, position + length);
              }
            }
            allocated = true;
            ptr = _malloc(length);
            if (!ptr) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOMEM);
            }
            buffer.set(contents, ptr);
          }
          return { ptr: ptr, allocated: allocated };
        }}};
  
  var IDBFS={dbs:{},indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_VERSION:21,DB_STORE_NAME:"FILE_DATA",mount:function (mount) {
        // reuse all of the core MEMFS functionality
        return MEMFS.mount.apply(null, arguments);
      },syncfs:function (mount, populate, callback) {
        IDBFS.getLocalSet(mount, function(err, local) {
          if (err) return callback(err);
  
          IDBFS.getRemoteSet(mount, function(err, remote) {
            if (err) return callback(err);
  
            var src = populate ? remote : local;
            var dst = populate ? local : remote;
  
            IDBFS.reconcile(src, dst, callback);
          });
        });
      },getDB:function (name, callback) {
        // check the cache first
        var db = IDBFS.dbs[name];
        if (db) {
          return callback(null, db);
        }
  
        var req;
        try {
          req = IDBFS.indexedDB().open(name, IDBFS.DB_VERSION);
        } catch (e) {
          return callback(e);
        }
        req.onupgradeneeded = function(e) {
          var db = e.target.result;
          var transaction = e.target.transaction;
  
          var fileStore;
  
          if (db.objectStoreNames.contains(IDBFS.DB_STORE_NAME)) {
            fileStore = transaction.objectStore(IDBFS.DB_STORE_NAME);
          } else {
            fileStore = db.createObjectStore(IDBFS.DB_STORE_NAME);
          }
  
          fileStore.createIndex('timestamp', 'timestamp', { unique: false });
        };
        req.onsuccess = function() {
          db = req.result;
  
          // add to the cache
          IDBFS.dbs[name] = db;
          callback(null, db);
        };
        req.onerror = function() {
          callback(this.error);
        };
      },getLocalSet:function (mount, callback) {
        var entries = {};
  
        function isRealDir(p) {
          return p !== '.' && p !== '..';
        };
        function toAbsolute(root) {
          return function(p) {
            return PATH.join2(root, p);
          }
        };
  
        var check = FS.readdir(mount.mountpoint).filter(isRealDir).map(toAbsolute(mount.mountpoint));
  
        while (check.length) {
          var path = check.pop();
          var stat;
  
          try {
            stat = FS.stat(path);
          } catch (e) {
            return callback(e);
          }
  
          if (FS.isDir(stat.mode)) {
            check.push.apply(check, FS.readdir(path).filter(isRealDir).map(toAbsolute(path)));
          }
  
          entries[path] = { timestamp: stat.mtime };
        }
  
        return callback(null, { type: 'local', entries: entries });
      },getRemoteSet:function (mount, callback) {
        var entries = {};
  
        IDBFS.getDB(mount.mountpoint, function(err, db) {
          if (err) return callback(err);
  
          var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readonly');
          transaction.onerror = function() { callback(this.error); };
  
          var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
          var index = store.index('timestamp');
  
          index.openKeyCursor().onsuccess = function(event) {
            var cursor = event.target.result;
  
            if (!cursor) {
              return callback(null, { type: 'remote', db: db, entries: entries });
            }
  
            entries[cursor.primaryKey] = { timestamp: cursor.key };
  
            cursor.continue();
          };
        });
      },loadLocalEntry:function (path, callback) {
        var stat, node;
  
        try {
          var lookup = FS.lookupPath(path);
          node = lookup.node;
          stat = FS.stat(path);
        } catch (e) {
          return callback(e);
        }
  
        if (FS.isDir(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode });
        } else if (FS.isFile(stat.mode)) {
          return callback(null, { timestamp: stat.mtime, mode: stat.mode, contents: node.contents });
        } else {
          return callback(new Error('node type not supported'));
        }
      },storeLocalEntry:function (path, entry, callback) {
        try {
          if (FS.isDir(entry.mode)) {
            FS.mkdir(path, entry.mode);
          } else if (FS.isFile(entry.mode)) {
            FS.writeFile(path, entry.contents, { encoding: 'binary', canOwn: true });
          } else {
            return callback(new Error('node type not supported'));
          }
  
          FS.utime(path, entry.timestamp, entry.timestamp);
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },removeLocalEntry:function (path, callback) {
        try {
          var lookup = FS.lookupPath(path);
          var stat = FS.stat(path);
  
          if (FS.isDir(stat.mode)) {
            FS.rmdir(path);
          } else if (FS.isFile(stat.mode)) {
            FS.unlink(path);
          }
        } catch (e) {
          return callback(e);
        }
  
        callback(null);
      },loadRemoteEntry:function (store, path, callback) {
        var req = store.get(path);
        req.onsuccess = function(event) { callback(null, event.target.result); };
        req.onerror = function() { callback(this.error); };
      },storeRemoteEntry:function (store, path, entry, callback) {
        var req = store.put(entry, path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },removeRemoteEntry:function (store, path, callback) {
        var req = store.delete(path);
        req.onsuccess = function() { callback(null); };
        req.onerror = function() { callback(this.error); };
      },reconcile:function (src, dst, callback) {
        var total = 0;
  
        var create = [];
        Object.keys(src.entries).forEach(function (key) {
          var e = src.entries[key];
          var e2 = dst.entries[key];
          if (!e2 || e.timestamp > e2.timestamp) {
            create.push(key);
            total++;
          }
        });
  
        var remove = [];
        Object.keys(dst.entries).forEach(function (key) {
          var e = dst.entries[key];
          var e2 = src.entries[key];
          if (!e2) {
            remove.push(key);
            total++;
          }
        });
  
        if (!total) {
          return callback(null);
        }
  
        var errored = false;
        var completed = 0;
        var db = src.type === 'remote' ? src.db : dst.db;
        var transaction = db.transaction([IDBFS.DB_STORE_NAME], 'readwrite');
        var store = transaction.objectStore(IDBFS.DB_STORE_NAME);
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= total) {
            return callback(null);
          }
        };
  
        transaction.onerror = function() { done(this.error); };
  
        // sort paths in ascending order so directory entries are created
        // before the files inside them
        create.sort().forEach(function (path) {
          if (dst.type === 'local') {
            IDBFS.loadRemoteEntry(store, path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeLocalEntry(path, entry, done);
            });
          } else {
            IDBFS.loadLocalEntry(path, function (err, entry) {
              if (err) return done(err);
              IDBFS.storeRemoteEntry(store, path, entry, done);
            });
          }
        });
  
        // sort paths in descending order so files are deleted before their
        // parent directories
        remove.sort().reverse().forEach(function(path) {
          if (dst.type === 'local') {
            IDBFS.removeLocalEntry(path, done);
          } else {
            IDBFS.removeRemoteEntry(store, path, done);
          }
        });
      }};
  
  var NODEFS={isWindows:false,staticInit:function () {
        NODEFS.isWindows = !!process.platform.match(/^win/);
      },mount:function (mount) {
        assert(ENVIRONMENT_IS_NODE);
        return NODEFS.createNode(null, '/', NODEFS.getMode(mount.opts.root), 0);
      },createNode:function (parent, name, mode, dev) {
        if (!FS.isDir(mode) && !FS.isFile(mode) && !FS.isLink(mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node = FS.createNode(parent, name, mode);
        node.node_ops = NODEFS.node_ops;
        node.stream_ops = NODEFS.stream_ops;
        return node;
      },getMode:function (path) {
        var stat;
        try {
          stat = fs.lstatSync(path);
          if (NODEFS.isWindows) {
            // On Windows, directories return permission bits 'rw-rw-rw-', even though they have 'rwxrwxrwx', so 
            // propagate write bits to execute bits.
            stat.mode = stat.mode | ((stat.mode & 146) >> 1);
          }
        } catch (e) {
          if (!e.code) throw e;
          throw new FS.ErrnoError(ERRNO_CODES[e.code]);
        }
        return stat.mode;
      },realPath:function (node) {
        var parts = [];
        while (node.parent !== node) {
          parts.push(node.name);
          node = node.parent;
        }
        parts.push(node.mount.opts.root);
        parts.reverse();
        return PATH.join.apply(null, parts);
      },flagsToPermissionStringMap:{0:"r",1:"r+",2:"r+",64:"r",65:"r+",66:"r+",129:"rx+",193:"rx+",514:"w+",577:"w",578:"w+",705:"wx",706:"wx+",1024:"a",1025:"a",1026:"a+",1089:"a",1090:"a+",1153:"ax",1154:"ax+",1217:"ax",1218:"ax+",4096:"rs",4098:"rs+"},flagsToPermissionString:function (flags) {
        if (flags in NODEFS.flagsToPermissionStringMap) {
          return NODEFS.flagsToPermissionStringMap[flags];
        } else {
          return flags;
        }
      },node_ops:{getattr:function (node) {
          var path = NODEFS.realPath(node);
          var stat;
          try {
            stat = fs.lstatSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          // node.js v0.10.20 doesn't report blksize and blocks on Windows. Fake them with default blksize of 4096.
          // See http://support.microsoft.com/kb/140365
          if (NODEFS.isWindows && !stat.blksize) {
            stat.blksize = 4096;
          }
          if (NODEFS.isWindows && !stat.blocks) {
            stat.blocks = (stat.size+stat.blksize-1)/stat.blksize|0;
          }
          return {
            dev: stat.dev,
            ino: stat.ino,
            mode: stat.mode,
            nlink: stat.nlink,
            uid: stat.uid,
            gid: stat.gid,
            rdev: stat.rdev,
            size: stat.size,
            atime: stat.atime,
            mtime: stat.mtime,
            ctime: stat.ctime,
            blksize: stat.blksize,
            blocks: stat.blocks
          };
        },setattr:function (node, attr) {
          var path = NODEFS.realPath(node);
          try {
            if (attr.mode !== undefined) {
              fs.chmodSync(path, attr.mode);
              // update the common node structure mode as well
              node.mode = attr.mode;
            }
            if (attr.timestamp !== undefined) {
              var date = new Date(attr.timestamp);
              fs.utimesSync(path, date, date);
            }
            if (attr.size !== undefined) {
              fs.truncateSync(path, attr.size);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },lookup:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          var mode = NODEFS.getMode(path);
          return NODEFS.createNode(parent, name, mode);
        },mknod:function (parent, name, mode, dev) {
          var node = NODEFS.createNode(parent, name, mode, dev);
          // create the backing node for this in the fs root as well
          var path = NODEFS.realPath(node);
          try {
            if (FS.isDir(node.mode)) {
              fs.mkdirSync(path, node.mode);
            } else {
              fs.writeFileSync(path, '', { mode: node.mode });
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return node;
        },rename:function (oldNode, newDir, newName) {
          var oldPath = NODEFS.realPath(oldNode);
          var newPath = PATH.join2(NODEFS.realPath(newDir), newName);
          try {
            fs.renameSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },unlink:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.unlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },rmdir:function (parent, name) {
          var path = PATH.join2(NODEFS.realPath(parent), name);
          try {
            fs.rmdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readdir:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readdirSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },symlink:function (parent, newName, oldPath) {
          var newPath = PATH.join2(NODEFS.realPath(parent), newName);
          try {
            fs.symlinkSync(oldPath, newPath);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },readlink:function (node) {
          var path = NODEFS.realPath(node);
          try {
            return fs.readlinkSync(path);
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        }},stream_ops:{open:function (stream) {
          var path = NODEFS.realPath(stream.node);
          try {
            if (FS.isFile(stream.node.mode)) {
              stream.nfd = fs.openSync(path, NODEFS.flagsToPermissionString(stream.flags));
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },close:function (stream) {
          try {
            if (FS.isFile(stream.node.mode) && stream.nfd) {
              fs.closeSync(stream.nfd);
            }
          } catch (e) {
            if (!e.code) throw e;
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
        },read:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(length);
          var res;
          try {
            res = fs.readSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          if (res > 0) {
            for (var i = 0; i < res; i++) {
              buffer[offset + i] = nbuffer[i];
            }
          }
          return res;
        },write:function (stream, buffer, offset, length, position) {
          // FIXME this is terrible.
          var nbuffer = new Buffer(buffer.subarray(offset, offset + length));
          var res;
          try {
            res = fs.writeSync(stream.nfd, nbuffer, 0, length, position);
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES[e.code]);
          }
          return res;
        },llseek:function (stream, offset, whence) {
          var position = offset;
          if (whence === 1) {  // SEEK_CUR.
            position += stream.position;
          } else if (whence === 2) {  // SEEK_END.
            if (FS.isFile(stream.node.mode)) {
              try {
                var stat = fs.fstatSync(stream.nfd);
                position += stat.size;
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES[e.code]);
              }
            }
          }
  
          if (position < 0) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
  
          stream.position = position;
          return position;
        }}};
  
  var _stdin=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stdout=allocate(1, "i32*", ALLOC_STATIC);
  
  var _stderr=allocate(1, "i32*", ALLOC_STATIC);
  
  function _fflush(stream) {
      // int fflush(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fflush.html
      // we don't currently perform any user-space buffering of data
    }var FS={root:null,mounts:[],devices:[null],streams:[],nextInode:1,nameTable:null,currentPath:"/",initialized:false,ignorePermissions:true,ErrnoError:null,genericErrors:{},handleFSError:function (e) {
        if (!(e instanceof FS.ErrnoError)) throw e + ' : ' + stackTrace();
        return ___setErrNo(e.errno);
      },lookupPath:function (path, opts) {
        path = PATH.resolve(FS.cwd(), path);
        opts = opts || {};
  
        var defaults = {
          follow_mount: true,
          recurse_count: 0
        };
        for (var key in defaults) {
          if (opts[key] === undefined) {
            opts[key] = defaults[key];
          }
        }
  
        if (opts.recurse_count > 8) {  // max recursive lookup of 8
          throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
        }
  
        // split the path
        var parts = PATH.normalizeArray(path.split('/').filter(function(p) {
          return !!p;
        }), false);
  
        // start at the root
        var current = FS.root;
        var current_path = '/';
  
        for (var i = 0; i < parts.length; i++) {
          var islast = (i === parts.length-1);
          if (islast && opts.parent) {
            // stop resolving
            break;
          }
  
          current = FS.lookupNode(current, parts[i]);
          current_path = PATH.join2(current_path, parts[i]);
  
          // jump to the mount's root node if this is a mountpoint
          if (FS.isMountpoint(current)) {
            if (!islast || (islast && opts.follow_mount)) {
              current = current.mounted.root;
            }
          }
  
          // by default, lookupPath will not follow a symlink if it is the final path component.
          // setting opts.follow = true will override this behavior.
          if (!islast || opts.follow) {
            var count = 0;
            while (FS.isLink(current.mode)) {
              var link = FS.readlink(current_path);
              current_path = PATH.resolve(PATH.dirname(current_path), link);
              
              var lookup = FS.lookupPath(current_path, { recurse_count: opts.recurse_count });
              current = lookup.node;
  
              if (count++ > 40) {  // limit max consecutive symlinks to 40 (SYMLOOP_MAX).
                throw new FS.ErrnoError(ERRNO_CODES.ELOOP);
              }
            }
          }
        }
  
        return { path: current_path, node: current };
      },getPath:function (node) {
        var path;
        while (true) {
          if (FS.isRoot(node)) {
            var mount = node.mount.mountpoint;
            if (!path) return mount;
            return mount[mount.length-1] !== '/' ? mount + '/' + path : mount + path;
          }
          path = path ? node.name + '/' + path : node.name;
          node = node.parent;
        }
      },hashName:function (parentid, name) {
        var hash = 0;
  
  
        for (var i = 0; i < name.length; i++) {
          hash = ((hash << 5) - hash + name.charCodeAt(i)) | 0;
        }
        return ((parentid + hash) >>> 0) % FS.nameTable.length;
      },hashAddNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        node.name_next = FS.nameTable[hash];
        FS.nameTable[hash] = node;
      },hashRemoveNode:function (node) {
        var hash = FS.hashName(node.parent.id, node.name);
        if (FS.nameTable[hash] === node) {
          FS.nameTable[hash] = node.name_next;
        } else {
          var current = FS.nameTable[hash];
          while (current) {
            if (current.name_next === node) {
              current.name_next = node.name_next;
              break;
            }
            current = current.name_next;
          }
        }
      },lookupNode:function (parent, name) {
        var err = FS.mayLookup(parent);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        var hash = FS.hashName(parent.id, name);
        for (var node = FS.nameTable[hash]; node; node = node.name_next) {
          var nodeName = node.name;
          if (node.parent.id === parent.id && nodeName === name) {
            return node;
          }
        }
        // if we failed to find it in the cache, call into the VFS
        return FS.lookup(parent, name);
      },createNode:function (parent, name, mode, rdev) {
        if (!FS.FSNode) {
          FS.FSNode = function(parent, name, mode, rdev) {
            if (!parent) {
              parent = this;  // root node sets parent to itself
            }
            this.parent = parent;
            this.mount = parent.mount;
            this.mounted = null;
            this.id = FS.nextInode++;
            this.name = name;
            this.mode = mode;
            this.node_ops = {};
            this.stream_ops = {};
            this.rdev = rdev;
          };
  
          FS.FSNode.prototype = {};
  
          // compatibility
          var readMode = 292 | 73;
          var writeMode = 146;
  
          // NOTE we must use Object.defineProperties instead of individual calls to
          // Object.defineProperty in order to make closure compiler happy
          Object.defineProperties(FS.FSNode.prototype, {
            read: {
              get: function() { return (this.mode & readMode) === readMode; },
              set: function(val) { val ? this.mode |= readMode : this.mode &= ~readMode; }
            },
            write: {
              get: function() { return (this.mode & writeMode) === writeMode; },
              set: function(val) { val ? this.mode |= writeMode : this.mode &= ~writeMode; }
            },
            isFolder: {
              get: function() { return FS.isDir(this.mode); },
            },
            isDevice: {
              get: function() { return FS.isChrdev(this.mode); },
            },
          });
        }
  
        var node = new FS.FSNode(parent, name, mode, rdev);
  
        FS.hashAddNode(node);
  
        return node;
      },destroyNode:function (node) {
        FS.hashRemoveNode(node);
      },isRoot:function (node) {
        return node === node.parent;
      },isMountpoint:function (node) {
        return !!node.mounted;
      },isFile:function (mode) {
        return (mode & 61440) === 32768;
      },isDir:function (mode) {
        return (mode & 61440) === 16384;
      },isLink:function (mode) {
        return (mode & 61440) === 40960;
      },isChrdev:function (mode) {
        return (mode & 61440) === 8192;
      },isBlkdev:function (mode) {
        return (mode & 61440) === 24576;
      },isFIFO:function (mode) {
        return (mode & 61440) === 4096;
      },isSocket:function (mode) {
        return (mode & 49152) === 49152;
      },flagModes:{"r":0,"rs":1052672,"r+":2,"w":577,"wx":705,"xw":705,"w+":578,"wx+":706,"xw+":706,"a":1089,"ax":1217,"xa":1217,"a+":1090,"ax+":1218,"xa+":1218},modeStringToFlags:function (str) {
        var flags = FS.flagModes[str];
        if (typeof flags === 'undefined') {
          throw new Error('Unknown file open mode: ' + str);
        }
        return flags;
      },flagsToPermissionString:function (flag) {
        var accmode = flag & 2097155;
        var perms = ['r', 'w', 'rw'][accmode];
        if ((flag & 512)) {
          perms += 'w';
        }
        return perms;
      },nodePermissions:function (node, perms) {
        if (FS.ignorePermissions) {
          return 0;
        }
        // return 0 if any user, group or owner bits are set.
        if (perms.indexOf('r') !== -1 && !(node.mode & 292)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('w') !== -1 && !(node.mode & 146)) {
          return ERRNO_CODES.EACCES;
        } else if (perms.indexOf('x') !== -1 && !(node.mode & 73)) {
          return ERRNO_CODES.EACCES;
        }
        return 0;
      },mayLookup:function (dir) {
        return FS.nodePermissions(dir, 'x');
      },mayCreate:function (dir, name) {
        try {
          var node = FS.lookupNode(dir, name);
          return ERRNO_CODES.EEXIST;
        } catch (e) {
        }
        return FS.nodePermissions(dir, 'wx');
      },mayDelete:function (dir, name, isdir) {
        var node;
        try {
          node = FS.lookupNode(dir, name);
        } catch (e) {
          return e.errno;
        }
        var err = FS.nodePermissions(dir, 'wx');
        if (err) {
          return err;
        }
        if (isdir) {
          if (!FS.isDir(node.mode)) {
            return ERRNO_CODES.ENOTDIR;
          }
          if (FS.isRoot(node) || FS.getPath(node) === FS.cwd()) {
            return ERRNO_CODES.EBUSY;
          }
        } else {
          if (FS.isDir(node.mode)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return 0;
      },mayOpen:function (node, flags) {
        if (!node) {
          return ERRNO_CODES.ENOENT;
        }
        if (FS.isLink(node.mode)) {
          return ERRNO_CODES.ELOOP;
        } else if (FS.isDir(node.mode)) {
          if ((flags & 2097155) !== 0 ||  // opening for write
              (flags & 512)) {
            return ERRNO_CODES.EISDIR;
          }
        }
        return FS.nodePermissions(node, FS.flagsToPermissionString(flags));
      },MAX_OPEN_FDS:4096,nextfd:function (fd_start, fd_end) {
        fd_start = fd_start || 0;
        fd_end = fd_end || FS.MAX_OPEN_FDS;
        for (var fd = fd_start; fd <= fd_end; fd++) {
          if (!FS.streams[fd]) {
            return fd;
          }
        }
        throw new FS.ErrnoError(ERRNO_CODES.EMFILE);
      },getStream:function (fd) {
        return FS.streams[fd];
      },createStream:function (stream, fd_start, fd_end) {
        if (!FS.FSStream) {
          FS.FSStream = function(){};
          FS.FSStream.prototype = {};
          // compatibility
          Object.defineProperties(FS.FSStream.prototype, {
            object: {
              get: function() { return this.node; },
              set: function(val) { this.node = val; }
            },
            isRead: {
              get: function() { return (this.flags & 2097155) !== 1; }
            },
            isWrite: {
              get: function() { return (this.flags & 2097155) !== 0; }
            },
            isAppend: {
              get: function() { return (this.flags & 1024); }
            }
          });
        }
        if (stream.__proto__) {
          // reuse the object
          stream.__proto__ = FS.FSStream.prototype;
        } else {
          var newStream = new FS.FSStream();
          for (var p in stream) {
            newStream[p] = stream[p];
          }
          stream = newStream;
        }
        var fd = FS.nextfd(fd_start, fd_end);
        stream.fd = fd;
        FS.streams[fd] = stream;
        return stream;
      },closeStream:function (fd) {
        FS.streams[fd] = null;
      },getStreamFromPtr:function (ptr) {
        return FS.streams[ptr - 1];
      },getPtrForStream:function (stream) {
        return stream ? stream.fd + 1 : 0;
      },chrdev_stream_ops:{open:function (stream) {
          var device = FS.getDevice(stream.node.rdev);
          // override node's stream ops with the device's
          stream.stream_ops = device.stream_ops;
          // forward the open call
          if (stream.stream_ops.open) {
            stream.stream_ops.open(stream);
          }
        },llseek:function () {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }},major:function (dev) {
        return ((dev) >> 8);
      },minor:function (dev) {
        return ((dev) & 0xff);
      },makedev:function (ma, mi) {
        return ((ma) << 8 | (mi));
      },registerDevice:function (dev, ops) {
        FS.devices[dev] = { stream_ops: ops };
      },getDevice:function (dev) {
        return FS.devices[dev];
      },getMounts:function (mount) {
        var mounts = [];
        var check = [mount];
  
        while (check.length) {
          var m = check.pop();
  
          mounts.push(m);
  
          check.push.apply(check, m.mounts);
        }
  
        return mounts;
      },syncfs:function (populate, callback) {
        if (typeof(populate) === 'function') {
          callback = populate;
          populate = false;
        }
  
        var mounts = FS.getMounts(FS.root.mount);
        var completed = 0;
  
        function done(err) {
          if (err) {
            if (!done.errored) {
              done.errored = true;
              return callback(err);
            }
            return;
          }
          if (++completed >= mounts.length) {
            callback(null);
          }
        };
  
        // sync all mounts
        mounts.forEach(function (mount) {
          if (!mount.type.syncfs) {
            return done(null);
          }
          mount.type.syncfs(mount, populate, done);
        });
      },mount:function (type, opts, mountpoint) {
        var root = mountpoint === '/';
        var pseudo = !mountpoint;
        var node;
  
        if (root && FS.root) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        } else if (!root && !pseudo) {
          var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
          mountpoint = lookup.path;  // use the absolute path
          node = lookup.node;
  
          if (FS.isMountpoint(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
          }
  
          if (!FS.isDir(node.mode)) {
            throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
          }
        }
  
        var mount = {
          type: type,
          opts: opts,
          mountpoint: mountpoint,
          mounts: []
        };
  
        // create a root node for the fs
        var mountRoot = type.mount(mount);
        mountRoot.mount = mount;
        mount.root = mountRoot;
  
        if (root) {
          FS.root = mountRoot;
        } else if (node) {
          // set as a mountpoint
          node.mounted = mount;
  
          // add the new mount to the current mount's children
          if (node.mount) {
            node.mount.mounts.push(mount);
          }
        }
  
        return mountRoot;
      },unmount:function (mountpoint) {
        var lookup = FS.lookupPath(mountpoint, { follow_mount: false });
  
        if (!FS.isMountpoint(lookup.node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
  
        // destroy the nodes for this mount, and all its child mounts
        var node = lookup.node;
        var mount = node.mounted;
        var mounts = FS.getMounts(mount);
  
        Object.keys(FS.nameTable).forEach(function (hash) {
          var current = FS.nameTable[hash];
  
          while (current) {
            var next = current.name_next;
  
            if (mounts.indexOf(current.mount) !== -1) {
              FS.destroyNode(current);
            }
  
            current = next;
          }
        });
  
        // no longer a mountpoint
        node.mounted = null;
  
        // remove this mount from the child mounts
        var idx = node.mount.mounts.indexOf(mount);
        assert(idx !== -1);
        node.mount.mounts.splice(idx, 1);
      },lookup:function (parent, name) {
        return parent.node_ops.lookup(parent, name);
      },mknod:function (path, mode, dev) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var err = FS.mayCreate(parent, name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.mknod) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.mknod(parent, name, mode, dev);
      },create:function (path, mode) {
        mode = mode !== undefined ? mode : 438 /* 0666 */;
        mode &= 4095;
        mode |= 32768;
        return FS.mknod(path, mode, 0);
      },mkdir:function (path, mode) {
        mode = mode !== undefined ? mode : 511 /* 0777 */;
        mode &= 511 | 512;
        mode |= 16384;
        return FS.mknod(path, mode, 0);
      },mkdev:function (path, mode, dev) {
        if (typeof(dev) === 'undefined') {
          dev = mode;
          mode = 438 /* 0666 */;
        }
        mode |= 8192;
        return FS.mknod(path, mode, dev);
      },symlink:function (oldpath, newpath) {
        var lookup = FS.lookupPath(newpath, { parent: true });
        var parent = lookup.node;
        var newname = PATH.basename(newpath);
        var err = FS.mayCreate(parent, newname);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.symlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return parent.node_ops.symlink(parent, newname, oldpath);
      },rename:function (old_path, new_path) {
        var old_dirname = PATH.dirname(old_path);
        var new_dirname = PATH.dirname(new_path);
        var old_name = PATH.basename(old_path);
        var new_name = PATH.basename(new_path);
        // parents must exist
        var lookup, old_dir, new_dir;
        try {
          lookup = FS.lookupPath(old_path, { parent: true });
          old_dir = lookup.node;
          lookup = FS.lookupPath(new_path, { parent: true });
          new_dir = lookup.node;
        } catch (e) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // need to be part of the same mount
        if (old_dir.mount !== new_dir.mount) {
          throw new FS.ErrnoError(ERRNO_CODES.EXDEV);
        }
        // source must exist
        var old_node = FS.lookupNode(old_dir, old_name);
        // old path should not be an ancestor of the new path
        var relative = PATH.relative(old_path, new_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        // new path should not be an ancestor of the old path
        relative = PATH.relative(new_path, old_dirname);
        if (relative.charAt(0) !== '.') {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTEMPTY);
        }
        // see if the new path already exists
        var new_node;
        try {
          new_node = FS.lookupNode(new_dir, new_name);
        } catch (e) {
          // not fatal
        }
        // early out if nothing needs to change
        if (old_node === new_node) {
          return;
        }
        // we'll need to delete the old entry
        var isdir = FS.isDir(old_node.mode);
        var err = FS.mayDelete(old_dir, old_name, isdir);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // need delete permissions if we'll be overwriting.
        // need create permissions if new doesn't already exist.
        err = new_node ?
          FS.mayDelete(new_dir, new_name, isdir) :
          FS.mayCreate(new_dir, new_name);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!old_dir.node_ops.rename) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(old_node) || (new_node && FS.isMountpoint(new_node))) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        // if we are going to change the parent, check write permissions
        if (new_dir !== old_dir) {
          err = FS.nodePermissions(old_dir, 'w');
          if (err) {
            throw new FS.ErrnoError(err);
          }
        }
        // remove the node from the lookup hash
        FS.hashRemoveNode(old_node);
        // do the underlying fs rename
        try {
          old_dir.node_ops.rename(old_node, new_dir, new_name);
        } catch (e) {
          throw e;
        } finally {
          // add the node back to the hash (in case node_ops.rename
          // changed its name)
          FS.hashAddNode(old_node);
        }
      },rmdir:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, true);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.rmdir) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.rmdir(parent, name);
        FS.destroyNode(node);
      },readdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        if (!node.node_ops.readdir) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        return node.node_ops.readdir(node);
      },unlink:function (path) {
        var lookup = FS.lookupPath(path, { parent: true });
        var parent = lookup.node;
        var name = PATH.basename(path);
        var node = FS.lookupNode(parent, name);
        var err = FS.mayDelete(parent, name, false);
        if (err) {
          // POSIX says unlink should set EPERM, not EISDIR
          if (err === ERRNO_CODES.EISDIR) err = ERRNO_CODES.EPERM;
          throw new FS.ErrnoError(err);
        }
        if (!parent.node_ops.unlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isMountpoint(node)) {
          throw new FS.ErrnoError(ERRNO_CODES.EBUSY);
        }
        parent.node_ops.unlink(parent, name);
        FS.destroyNode(node);
      },readlink:function (path) {
        var lookup = FS.lookupPath(path);
        var link = lookup.node;
        if (!link.node_ops.readlink) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        return link.node_ops.readlink(link);
      },stat:function (path, dontFollow) {
        var lookup = FS.lookupPath(path, { follow: !dontFollow });
        var node = lookup.node;
        if (!node.node_ops.getattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        return node.node_ops.getattr(node);
      },lstat:function (path) {
        return FS.stat(path, true);
      },chmod:function (path, mode, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          mode: (mode & 4095) | (node.mode & ~4095),
          timestamp: Date.now()
        });
      },lchmod:function (path, mode) {
        FS.chmod(path, mode, true);
      },fchmod:function (fd, mode) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chmod(stream.node, mode);
      },chown:function (path, uid, gid, dontFollow) {
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: !dontFollow });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        node.node_ops.setattr(node, {
          timestamp: Date.now()
          // we ignore the uid / gid for now
        });
      },lchown:function (path, uid, gid) {
        FS.chown(path, uid, gid, true);
      },fchown:function (fd, uid, gid) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        FS.chown(stream.node, uid, gid);
      },truncate:function (path, len) {
        if (len < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var node;
        if (typeof path === 'string') {
          var lookup = FS.lookupPath(path, { follow: true });
          node = lookup.node;
        } else {
          node = path;
        }
        if (!node.node_ops.setattr) {
          throw new FS.ErrnoError(ERRNO_CODES.EPERM);
        }
        if (FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!FS.isFile(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var err = FS.nodePermissions(node, 'w');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        node.node_ops.setattr(node, {
          size: len,
          timestamp: Date.now()
        });
      },ftruncate:function (fd, len) {
        var stream = FS.getStream(fd);
        if (!stream) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        FS.truncate(stream.node, len);
      },utime:function (path, atime, mtime) {
        var lookup = FS.lookupPath(path, { follow: true });
        var node = lookup.node;
        node.node_ops.setattr(node, {
          timestamp: Math.max(atime, mtime)
        });
      },open:function (path, flags, mode, fd_start, fd_end) {
        flags = typeof flags === 'string' ? FS.modeStringToFlags(flags) : flags;
        mode = typeof mode === 'undefined' ? 438 /* 0666 */ : mode;
        if ((flags & 64)) {
          mode = (mode & 4095) | 32768;
        } else {
          mode = 0;
        }
        var node;
        if (typeof path === 'object') {
          node = path;
        } else {
          path = PATH.normalize(path);
          try {
            var lookup = FS.lookupPath(path, {
              follow: !(flags & 131072)
            });
            node = lookup.node;
          } catch (e) {
            // ignore
          }
        }
        // perhaps we need to create the node
        if ((flags & 64)) {
          if (node) {
            // if O_CREAT and O_EXCL are set, error out if the node already exists
            if ((flags & 128)) {
              throw new FS.ErrnoError(ERRNO_CODES.EEXIST);
            }
          } else {
            // node doesn't exist, try to create it
            node = FS.mknod(path, mode, 0);
          }
        }
        if (!node) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOENT);
        }
        // can't truncate a device
        if (FS.isChrdev(node.mode)) {
          flags &= ~512;
        }
        // check permissions
        var err = FS.mayOpen(node, flags);
        if (err) {
          throw new FS.ErrnoError(err);
        }
        // do truncation if necessary
        if ((flags & 512)) {
          FS.truncate(node, 0);
        }
        // we've already handled these, don't pass down to the underlying vfs
        flags &= ~(128 | 512);
  
        // register the stream with the filesystem
        var stream = FS.createStream({
          node: node,
          path: FS.getPath(node),  // we want the absolute path to the node
          flags: flags,
          seekable: true,
          position: 0,
          stream_ops: node.stream_ops,
          // used by the file family libc calls (fopen, fwrite, ferror, etc.)
          ungotten: [],
          error: false
        }, fd_start, fd_end);
        // call the new stream's open function
        if (stream.stream_ops.open) {
          stream.stream_ops.open(stream);
        }
        if (Module['logReadFiles'] && !(flags & 1)) {
          if (!FS.readFiles) FS.readFiles = {};
          if (!(path in FS.readFiles)) {
            FS.readFiles[path] = 1;
            Module['printErr']('read file: ' + path);
          }
        }
        return stream;
      },close:function (stream) {
        try {
          if (stream.stream_ops.close) {
            stream.stream_ops.close(stream);
          }
        } catch (e) {
          throw e;
        } finally {
          FS.closeStream(stream.fd);
        }
      },llseek:function (stream, offset, whence) {
        if (!stream.seekable || !stream.stream_ops.llseek) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        return stream.stream_ops.llseek(stream, offset, whence);
      },read:function (stream, buffer, offset, length, position) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.read) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        var bytesRead = stream.stream_ops.read(stream, buffer, offset, length, position);
        if (!seeking) stream.position += bytesRead;
        return bytesRead;
      },write:function (stream, buffer, offset, length, position, canOwn) {
        if (length < 0 || position < 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (FS.isDir(stream.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.EISDIR);
        }
        if (!stream.stream_ops.write) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        var seeking = true;
        if (typeof position === 'undefined') {
          position = stream.position;
          seeking = false;
        } else if (!stream.seekable) {
          throw new FS.ErrnoError(ERRNO_CODES.ESPIPE);
        }
        if (stream.flags & 1024) {
          // seek to the end before writing in append mode
          FS.llseek(stream, 0, 2);
        }
        var bytesWritten = stream.stream_ops.write(stream, buffer, offset, length, position, canOwn);
        if (!seeking) stream.position += bytesWritten;
        return bytesWritten;
      },allocate:function (stream, offset, length) {
        if (offset < 0 || length <= 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
        }
        if ((stream.flags & 2097155) === 0) {
          throw new FS.ErrnoError(ERRNO_CODES.EBADF);
        }
        if (!FS.isFile(stream.node.mode) && !FS.isDir(node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        if (!stream.stream_ops.allocate) {
          throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
        }
        stream.stream_ops.allocate(stream, offset, length);
      },mmap:function (stream, buffer, offset, length, position, prot, flags) {
        // TODO if PROT is PROT_WRITE, make sure we have write access
        if ((stream.flags & 2097155) === 1) {
          throw new FS.ErrnoError(ERRNO_CODES.EACCES);
        }
        if (!stream.stream_ops.mmap) {
          throw new FS.ErrnoError(ERRNO_CODES.ENODEV);
        }
        return stream.stream_ops.mmap(stream, buffer, offset, length, position, prot, flags);
      },ioctl:function (stream, cmd, arg) {
        if (!stream.stream_ops.ioctl) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTTY);
        }
        return stream.stream_ops.ioctl(stream, cmd, arg);
      },readFile:function (path, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'r';
        opts.encoding = opts.encoding || 'binary';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var ret;
        var stream = FS.open(path, opts.flags);
        var stat = FS.stat(path);
        var length = stat.size;
        var buf = new Uint8Array(length);
        FS.read(stream, buf, 0, length, 0);
        if (opts.encoding === 'utf8') {
          ret = '';
          var utf8 = new Runtime.UTF8Processor();
          for (var i = 0; i < length; i++) {
            ret += utf8.processCChar(buf[i]);
          }
        } else if (opts.encoding === 'binary') {
          ret = buf;
        }
        FS.close(stream);
        return ret;
      },writeFile:function (path, data, opts) {
        opts = opts || {};
        opts.flags = opts.flags || 'w';
        opts.encoding = opts.encoding || 'utf8';
        if (opts.encoding !== 'utf8' && opts.encoding !== 'binary') {
          throw new Error('Invalid encoding type "' + opts.encoding + '"');
        }
        var stream = FS.open(path, opts.flags, opts.mode);
        if (opts.encoding === 'utf8') {
          var utf8 = new Runtime.UTF8Processor();
          var buf = new Uint8Array(utf8.processJSString(data));
          FS.write(stream, buf, 0, buf.length, 0, opts.canOwn);
        } else if (opts.encoding === 'binary') {
          FS.write(stream, data, 0, data.length, 0, opts.canOwn);
        }
        FS.close(stream);
      },cwd:function () {
        return FS.currentPath;
      },chdir:function (path) {
        var lookup = FS.lookupPath(path, { follow: true });
        if (!FS.isDir(lookup.node.mode)) {
          throw new FS.ErrnoError(ERRNO_CODES.ENOTDIR);
        }
        var err = FS.nodePermissions(lookup.node, 'x');
        if (err) {
          throw new FS.ErrnoError(err);
        }
        FS.currentPath = lookup.path;
      },createDefaultDirectories:function () {
        FS.mkdir('/tmp');
      },createDefaultDevices:function () {
        // create /dev
        FS.mkdir('/dev');
        // setup /dev/null
        FS.registerDevice(FS.makedev(1, 3), {
          read: function() { return 0; },
          write: function() { return 0; }
        });
        FS.mkdev('/dev/null', FS.makedev(1, 3));
        // setup /dev/tty and /dev/tty1
        // stderr needs to print output using Module['printErr']
        // so we register a second tty just for it.
        TTY.register(FS.makedev(5, 0), TTY.default_tty_ops);
        TTY.register(FS.makedev(6, 0), TTY.default_tty1_ops);
        FS.mkdev('/dev/tty', FS.makedev(5, 0));
        FS.mkdev('/dev/tty1', FS.makedev(6, 0));
        // we're not going to emulate the actual shm device,
        // just create the tmp dirs that reside in it commonly
        FS.mkdir('/dev/shm');
        FS.mkdir('/dev/shm/tmp');
      },createStandardStreams:function () {
        // TODO deprecate the old functionality of a single
        // input / output callback and that utilizes FS.createDevice
        // and instead require a unique set of stream ops
  
        // by default, we symlink the standard streams to the
        // default tty devices. however, if the standard streams
        // have been overwritten we create a unique device for
        // them instead.
        if (Module['stdin']) {
          FS.createDevice('/dev', 'stdin', Module['stdin']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdin');
        }
        if (Module['stdout']) {
          FS.createDevice('/dev', 'stdout', null, Module['stdout']);
        } else {
          FS.symlink('/dev/tty', '/dev/stdout');
        }
        if (Module['stderr']) {
          FS.createDevice('/dev', 'stderr', null, Module['stderr']);
        } else {
          FS.symlink('/dev/tty1', '/dev/stderr');
        }
  
        // open default streams for the stdin, stdout and stderr devices
        var stdin = FS.open('/dev/stdin', 'r');
        HEAP32[((_stdin)>>2)]=FS.getPtrForStream(stdin);
        assert(stdin.fd === 0, 'invalid handle for stdin (' + stdin.fd + ')');
  
        var stdout = FS.open('/dev/stdout', 'w');
        HEAP32[((_stdout)>>2)]=FS.getPtrForStream(stdout);
        assert(stdout.fd === 1, 'invalid handle for stdout (' + stdout.fd + ')');
  
        var stderr = FS.open('/dev/stderr', 'w');
        HEAP32[((_stderr)>>2)]=FS.getPtrForStream(stderr);
        assert(stderr.fd === 2, 'invalid handle for stderr (' + stderr.fd + ')');
      },ensureErrnoError:function () {
        if (FS.ErrnoError) return;
        FS.ErrnoError = function ErrnoError(errno) {
          this.errno = errno;
          for (var key in ERRNO_CODES) {
            if (ERRNO_CODES[key] === errno) {
              this.code = key;
              break;
            }
          }
          this.message = ERRNO_MESSAGES[errno];
        };
        FS.ErrnoError.prototype = new Error();
        FS.ErrnoError.prototype.constructor = FS.ErrnoError;
        // Some errors may happen quite a bit, to avoid overhead we reuse them (and suffer a lack of stack info)
        [ERRNO_CODES.ENOENT].forEach(function(code) {
          FS.genericErrors[code] = new FS.ErrnoError(code);
          FS.genericErrors[code].stack = '<generic error, no stack>';
        });
      },staticInit:function () {
        FS.ensureErrnoError();
  
        FS.nameTable = new Array(4096);
  
        FS.mount(MEMFS, {}, '/');
  
        FS.createDefaultDirectories();
        FS.createDefaultDevices();
      },init:function (input, output, error) {
        assert(!FS.init.initialized, 'FS.init was previously called. If you want to initialize later with custom parameters, remove any earlier calls (note that one is automatically added to the generated code)');
        FS.init.initialized = true;
  
        FS.ensureErrnoError();
  
        // Allow Module.stdin etc. to provide defaults, if none explicitly passed to us here
        Module['stdin'] = input || Module['stdin'];
        Module['stdout'] = output || Module['stdout'];
        Module['stderr'] = error || Module['stderr'];
  
        FS.createStandardStreams();
      },quit:function () {
        FS.init.initialized = false;
        for (var i = 0; i < FS.streams.length; i++) {
          var stream = FS.streams[i];
          if (!stream) {
            continue;
          }
          FS.close(stream);
        }
      },getMode:function (canRead, canWrite) {
        var mode = 0;
        if (canRead) mode |= 292 | 73;
        if (canWrite) mode |= 146;
        return mode;
      },joinPath:function (parts, forceRelative) {
        var path = PATH.join.apply(null, parts);
        if (forceRelative && path[0] == '/') path = path.substr(1);
        return path;
      },absolutePath:function (relative, base) {
        return PATH.resolve(base, relative);
      },standardizePath:function (path) {
        return PATH.normalize(path);
      },findObject:function (path, dontResolveLastLink) {
        var ret = FS.analyzePath(path, dontResolveLastLink);
        if (ret.exists) {
          return ret.object;
        } else {
          ___setErrNo(ret.error);
          return null;
        }
      },analyzePath:function (path, dontResolveLastLink) {
        // operate from within the context of the symlink's target
        try {
          var lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          path = lookup.path;
        } catch (e) {
        }
        var ret = {
          isRoot: false, exists: false, error: 0, name: null, path: null, object: null,
          parentExists: false, parentPath: null, parentObject: null
        };
        try {
          var lookup = FS.lookupPath(path, { parent: true });
          ret.parentExists = true;
          ret.parentPath = lookup.path;
          ret.parentObject = lookup.node;
          ret.name = PATH.basename(path);
          lookup = FS.lookupPath(path, { follow: !dontResolveLastLink });
          ret.exists = true;
          ret.path = lookup.path;
          ret.object = lookup.node;
          ret.name = lookup.node.name;
          ret.isRoot = lookup.path === '/';
        } catch (e) {
          ret.error = e.errno;
        };
        return ret;
      },createFolder:function (parent, name, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.mkdir(path, mode);
      },createPath:function (parent, path, canRead, canWrite) {
        parent = typeof parent === 'string' ? parent : FS.getPath(parent);
        var parts = path.split('/').reverse();
        while (parts.length) {
          var part = parts.pop();
          if (!part) continue;
          var current = PATH.join2(parent, part);
          try {
            FS.mkdir(current);
          } catch (e) {
            // ignore EEXIST
          }
          parent = current;
        }
        return current;
      },createFile:function (parent, name, properties, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(canRead, canWrite);
        return FS.create(path, mode);
      },createDataFile:function (parent, name, data, canRead, canWrite, canOwn) {
        var path = name ? PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name) : parent;
        var mode = FS.getMode(canRead, canWrite);
        var node = FS.create(path, mode);
        if (data) {
          if (typeof data === 'string') {
            var arr = new Array(data.length);
            for (var i = 0, len = data.length; i < len; ++i) arr[i] = data.charCodeAt(i);
            data = arr;
          }
          // make sure we can write to the file
          FS.chmod(node, mode | 146);
          var stream = FS.open(node, 'w');
          FS.write(stream, data, 0, data.length, 0, canOwn);
          FS.close(stream);
          FS.chmod(node, mode);
        }
        return node;
      },createDevice:function (parent, name, input, output) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        var mode = FS.getMode(!!input, !!output);
        if (!FS.createDevice.major) FS.createDevice.major = 64;
        var dev = FS.makedev(FS.createDevice.major++, 0);
        // Create a fake device that a set of stream ops to emulate
        // the old behavior.
        FS.registerDevice(dev, {
          open: function(stream) {
            stream.seekable = false;
          },
          close: function(stream) {
            // flush any pending line data
            if (output && output.buffer && output.buffer.length) {
              output(10);
            }
          },
          read: function(stream, buffer, offset, length, pos /* ignored */) {
            var bytesRead = 0;
            for (var i = 0; i < length; i++) {
              var result;
              try {
                result = input();
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
              if (result === undefined && bytesRead === 0) {
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
              if (result === null || result === undefined) break;
              bytesRead++;
              buffer[offset+i] = result;
            }
            if (bytesRead) {
              stream.node.timestamp = Date.now();
            }
            return bytesRead;
          },
          write: function(stream, buffer, offset, length, pos) {
            for (var i = 0; i < length; i++) {
              try {
                output(buffer[offset+i]);
              } catch (e) {
                throw new FS.ErrnoError(ERRNO_CODES.EIO);
              }
            }
            if (length) {
              stream.node.timestamp = Date.now();
            }
            return i;
          }
        });
        return FS.mkdev(path, mode, dev);
      },createLink:function (parent, name, target, canRead, canWrite) {
        var path = PATH.join2(typeof parent === 'string' ? parent : FS.getPath(parent), name);
        return FS.symlink(target, path);
      },forceLoadFile:function (obj) {
        if (obj.isDevice || obj.isFolder || obj.link || obj.contents) return true;
        var success = true;
        if (typeof XMLHttpRequest !== 'undefined') {
          throw new Error("Lazy loading should have been performed (contents set) in createLazyFile, but it was not. Lazy loading only works in web workers. Use --embed-file or --preload-file in emcc on the main thread.");
        } else if (Module['read']) {
          // Command-line.
          try {
            // WARNING: Can't read binary files in V8's d8 or tracemonkey's js, as
            //          read() will try to parse UTF8.
            obj.contents = intArrayFromString(Module['read'](obj.url), true);
          } catch (e) {
            success = false;
          }
        } else {
          throw new Error('Cannot load without read() or XMLHttpRequest.');
        }
        if (!success) ___setErrNo(ERRNO_CODES.EIO);
        return success;
      },createLazyFile:function (parent, name, url, canRead, canWrite) {
        if (typeof XMLHttpRequest !== 'undefined') {
          if (!ENVIRONMENT_IS_WORKER) throw 'Cannot do synchronous binary XHRs outside webworkers in modern browsers. Use --embed-file or --preload-file in emcc';
          // Lazy chunked Uint8Array (implements get and length from Uint8Array). Actual getting is abstracted away for eventual reuse.
          function LazyUint8Array() {
            this.lengthKnown = false;
            this.chunks = []; // Loaded chunks. Index is the chunk number
          }
          LazyUint8Array.prototype.get = function LazyUint8Array_get(idx) {
            if (idx > this.length-1 || idx < 0) {
              return undefined;
            }
            var chunkOffset = idx % this.chunkSize;
            var chunkNum = Math.floor(idx / this.chunkSize);
            return this.getter(chunkNum)[chunkOffset];
          }
          LazyUint8Array.prototype.setDataGetter = function LazyUint8Array_setDataGetter(getter) {
            this.getter = getter;
          }
          LazyUint8Array.prototype.cacheLength = function LazyUint8Array_cacheLength() {
              // Find length
              var xhr = new XMLHttpRequest();
              xhr.open('HEAD', url, false);
              xhr.send(null);
              if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
              var datalength = Number(xhr.getResponseHeader("Content-length"));
              var header;
              var hasByteServing = (header = xhr.getResponseHeader("Accept-Ranges")) && header === "bytes";
              var chunkSize = 1024*1024; // Chunk size in bytes
  
              if (!hasByteServing) chunkSize = datalength;
  
              // Function to get a range from the remote URL.
              var doXHR = (function(from, to) {
                if (from > to) throw new Error("invalid range (" + from + ", " + to + ") or no bytes requested!");
                if (to > datalength-1) throw new Error("only " + datalength + " bytes available! programmer error!");
  
                // TODO: Use mozResponseArrayBuffer, responseStream, etc. if available.
                var xhr = new XMLHttpRequest();
                xhr.open('GET', url, false);
                if (datalength !== chunkSize) xhr.setRequestHeader("Range", "bytes=" + from + "-" + to);
  
                // Some hints to the browser that we want binary data.
                if (typeof Uint8Array != 'undefined') xhr.responseType = 'arraybuffer';
                if (xhr.overrideMimeType) {
                  xhr.overrideMimeType('text/plain; charset=x-user-defined');
                }
  
                xhr.send(null);
                if (!(xhr.status >= 200 && xhr.status < 300 || xhr.status === 304)) throw new Error("Couldn't load " + url + ". Status: " + xhr.status);
                if (xhr.response !== undefined) {
                  return new Uint8Array(xhr.response || []);
                } else {
                  return intArrayFromString(xhr.responseText || '', true);
                }
              });
              var lazyArray = this;
              lazyArray.setDataGetter(function(chunkNum) {
                var start = chunkNum * chunkSize;
                var end = (chunkNum+1) * chunkSize - 1; // including this byte
                end = Math.min(end, datalength-1); // if datalength-1 is selected, this is the last block
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") {
                  lazyArray.chunks[chunkNum] = doXHR(start, end);
                }
                if (typeof(lazyArray.chunks[chunkNum]) === "undefined") throw new Error("doXHR failed!");
                return lazyArray.chunks[chunkNum];
              });
  
              this._length = datalength;
              this._chunkSize = chunkSize;
              this.lengthKnown = true;
          }
  
          var lazyArray = new LazyUint8Array();
          Object.defineProperty(lazyArray, "length", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._length;
              }
          });
          Object.defineProperty(lazyArray, "chunkSize", {
              get: function() {
                  if(!this.lengthKnown) {
                      this.cacheLength();
                  }
                  return this._chunkSize;
              }
          });
  
          var properties = { isDevice: false, contents: lazyArray };
        } else {
          var properties = { isDevice: false, url: url };
        }
  
        var node = FS.createFile(parent, name, properties, canRead, canWrite);
        // This is a total hack, but I want to get this lazy file code out of the
        // core of MEMFS. If we want to keep this lazy file concept I feel it should
        // be its own thin LAZYFS proxying calls to MEMFS.
        if (properties.contents) {
          node.contents = properties.contents;
        } else if (properties.url) {
          node.contents = null;
          node.url = properties.url;
        }
        // override each stream op with one that tries to force load the lazy file first
        var stream_ops = {};
        var keys = Object.keys(node.stream_ops);
        keys.forEach(function(key) {
          var fn = node.stream_ops[key];
          stream_ops[key] = function forceLoadLazyFile() {
            if (!FS.forceLoadFile(node)) {
              throw new FS.ErrnoError(ERRNO_CODES.EIO);
            }
            return fn.apply(null, arguments);
          };
        });
        // use a custom read function
        stream_ops.read = function stream_ops_read(stream, buffer, offset, length, position) {
          if (!FS.forceLoadFile(node)) {
            throw new FS.ErrnoError(ERRNO_CODES.EIO);
          }
          var contents = stream.node.contents;
          if (position >= contents.length)
            return 0;
          var size = Math.min(contents.length - position, length);
          assert(size >= 0);
          if (contents.slice) { // normal array
            for (var i = 0; i < size; i++) {
              buffer[offset + i] = contents[position + i];
            }
          } else {
            for (var i = 0; i < size; i++) { // LazyUint8Array from sync binary XHR
              buffer[offset + i] = contents.get(position + i);
            }
          }
          return size;
        };
        node.stream_ops = stream_ops;
        return node;
      },createPreloadedFile:function (parent, name, url, canRead, canWrite, onload, onerror, dontCreateFile, canOwn) {
        Browser.init();
        // TODO we should allow people to just pass in a complete filename instead
        // of parent and name being that we just join them anyways
        var fullname = name ? PATH.resolve(PATH.join2(parent, name)) : parent;
        function processData(byteArray) {
          function finish(byteArray) {
            if (!dontCreateFile) {
              FS.createDataFile(parent, name, byteArray, canRead, canWrite, canOwn);
            }
            if (onload) onload();
            removeRunDependency('cp ' + fullname);
          }
          var handled = false;
          Module['preloadPlugins'].forEach(function(plugin) {
            if (handled) return;
            if (plugin['canHandle'](fullname)) {
              plugin['handle'](byteArray, fullname, finish, function() {
                if (onerror) onerror();
                removeRunDependency('cp ' + fullname);
              });
              handled = true;
            }
          });
          if (!handled) finish(byteArray);
        }
        addRunDependency('cp ' + fullname);
        if (typeof url == 'string') {
          Browser.asyncLoad(url, function(byteArray) {
            processData(byteArray);
          }, onerror);
        } else {
          processData(url);
        }
      },indexedDB:function () {
        return window.indexedDB || window.mozIndexedDB || window.webkitIndexedDB || window.msIndexedDB;
      },DB_NAME:function () {
        return 'EM_FS_' + window.location.pathname;
      },DB_VERSION:20,DB_STORE_NAME:"FILE_DATA",saveFilesToDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = function openRequest_onupgradeneeded() {
          console.log('creating db');
          var db = openRequest.result;
          db.createObjectStore(FS.DB_STORE_NAME);
        };
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          var transaction = db.transaction([FS.DB_STORE_NAME], 'readwrite');
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var putRequest = files.put(FS.analyzePath(path).object.contents, path);
            putRequest.onsuccess = function putRequest_onsuccess() { ok++; if (ok + fail == total) finish() };
            putRequest.onerror = function putRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      },loadFilesFromDB:function (paths, onload, onerror) {
        onload = onload || function(){};
        onerror = onerror || function(){};
        var indexedDB = FS.indexedDB();
        try {
          var openRequest = indexedDB.open(FS.DB_NAME(), FS.DB_VERSION);
        } catch (e) {
          return onerror(e);
        }
        openRequest.onupgradeneeded = onerror; // no database to load from
        openRequest.onsuccess = function openRequest_onsuccess() {
          var db = openRequest.result;
          try {
            var transaction = db.transaction([FS.DB_STORE_NAME], 'readonly');
          } catch(e) {
            onerror(e);
            return;
          }
          var files = transaction.objectStore(FS.DB_STORE_NAME);
          var ok = 0, fail = 0, total = paths.length;
          function finish() {
            if (fail == 0) onload(); else onerror();
          }
          paths.forEach(function(path) {
            var getRequest = files.get(path);
            getRequest.onsuccess = function getRequest_onsuccess() {
              if (FS.analyzePath(path).exists) {
                FS.unlink(path);
              }
              FS.createDataFile(PATH.dirname(path), PATH.basename(path), getRequest.result, true, true, true);
              ok++;
              if (ok + fail == total) finish();
            };
            getRequest.onerror = function getRequest_onerror() { fail++; if (ok + fail == total) finish() };
          });
          transaction.onerror = onerror;
        };
        openRequest.onerror = onerror;
      }};
  
  function _lseek(fildes, offset, whence) {
      // off_t lseek(int fildes, off_t offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/lseek.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        return FS.llseek(stream, offset, whence);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fileno(stream) {
      // int fileno(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fileno.html
      return FS.getStreamFromPtr(stream).fd;
    }function _fseek(stream, offset, whence) {
      // int fseek(FILE *stream, long offset, int whence);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fseek.html
      var fd = _fileno(stream);
      var ret = _lseek(fd, offset, whence);
      if (ret == -1) {
        return -1;
      }
      stream = FS.getStreamFromPtr(stream);
      stream.eof = false;
      return 0;
    }

  
  function _close(fildes) {
      // int close(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/close.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        FS.close(stream);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }
  
  function _fsync(fildes) {
      // int fsync(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fsync.html
      var stream = FS.getStream(fildes);
      if (stream) {
        // We write directly to the file system, so there's nothing to do here.
        return 0;
      } else {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
    }function _fclose(stream) {
      // int fclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fclose.html
      var fd = _fileno(stream);
      _fsync(fd);
      return _close(fd);
    }

  function _pthread_mutex_lock() {}

  
  
  function _isspace(chr) {
      return (chr == 32) || (chr >= 9 && chr <= 13);
    }
  function __parseInt64(str, endptr, base, min, max, unsign) {
      var isNegative = false;
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      if (HEAP8[(str)] == 45) {
        str++;
        isNegative = true;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var ok = false;
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            ok = true; // we saw an initial zero, perhaps the entire thing is just "0"
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
      var start = str;
  
      // Get digits.
      var chr;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          str++;
          ok = true;
        }
      }
  
      if (!ok) {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return ((asm["setTempRet0"](0),0)|0);
      }
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      try {
        var numberString = isNegative ? '-'+Pointer_stringify(start, str - start) : Pointer_stringify(start, str - start);
        i64Math.fromString(numberString, finalBase, min, max, unsign);
      } catch(e) {
        ___setErrNo(ERRNO_CODES.ERANGE); // not quite correct
      }
  
      return ((asm["setTempRet0"](((HEAP32[(((tempDoublePtr)+(4))>>2)])|0)),((HEAP32[((tempDoublePtr)>>2)])|0))|0);
    }function _strtoull(str, endptr, base) {
      return __parseInt64(str, endptr, base, 0, '18446744073709551615', true);  // ULONG_MAX.
    }


  function _lis_solver_create() {
  Module['printErr']('missing function: lis_solver_create'); abort(-1);
  }

  var _emscripten_check_longjmp=true;

  
  function __parseInt(str, endptr, base, min, max, bits, unsign) {
      // Skip space.
      while (_isspace(HEAP8[(str)])) str++;
  
      // Check for a plus/minus sign.
      var multiplier = 1;
      if (HEAP8[(str)] == 45) {
        multiplier = -1;
        str++;
      } else if (HEAP8[(str)] == 43) {
        str++;
      }
  
      // Find base.
      var finalBase = base;
      if (!finalBase) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            finalBase = 16;
            str += 2;
          } else {
            finalBase = 8;
            str++;
          }
        }
      } else if (finalBase==16) {
        if (HEAP8[(str)] == 48) {
          if (HEAP8[((str+1)|0)] == 120 ||
              HEAP8[((str+1)|0)] == 88) {
            str += 2;
          }
        }
      }
      if (!finalBase) finalBase = 10;
  
      // Get digits.
      var chr;
      var ret = 0;
      while ((chr = HEAP8[(str)]) != 0) {
        var digit = parseInt(String.fromCharCode(chr), finalBase);
        if (isNaN(digit)) {
          break;
        } else {
          ret = ret * finalBase + digit;
          str++;
        }
      }
  
      // Apply sign.
      ret *= multiplier;
  
      // Set end pointer.
      if (endptr) {
        HEAP32[((endptr)>>2)]=str;
      }
  
      // Unsign if needed.
      if (unsign) {
        if (Math.abs(ret) > max) {
          ret = max;
          ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          ret = unSign(ret, bits);
        }
      }
  
      // Validate range.
      if (ret > max || ret < min) {
        ret = ret > max ? max : min;
        ___setErrNo(ERRNO_CODES.ERANGE);
      }
  
      if (bits == 64) {
        return ((asm["setTempRet0"]((tempDouble=ret,(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)),ret>>>0)|0);
      }
  
      return ret;
    }function _strtol(str, endptr, base) {
      return __parseInt(str, endptr, base, -2147483648, 2147483647, 32);  // LONG_MIN, LONG_MAX.
    }

  
  
  
  
  function _mkport() { throw 'TODO' }var SOCKFS={mount:function (mount) {
        return FS.createNode(null, '/', 16384 | 511 /* 0777 */, 0);
      },createSocket:function (family, type, protocol) {
        var streaming = type == 1;
        if (protocol) {
          assert(streaming == (protocol == 6)); // if SOCK_STREAM, must be tcp
        }
  
        // create our internal socket structure
        var sock = {
          family: family,
          type: type,
          protocol: protocol,
          server: null,
          peers: {},
          pending: [],
          recv_queue: [],
          sock_ops: SOCKFS.websocket_sock_ops
        };
  
        // create the filesystem node to store the socket structure
        var name = SOCKFS.nextname();
        var node = FS.createNode(SOCKFS.root, name, 49152, 0);
        node.sock = sock;
  
        // and the wrapping stream that enables library functions such
        // as read and write to indirectly interact with the socket
        var stream = FS.createStream({
          path: name,
          node: node,
          flags: FS.modeStringToFlags('r+'),
          seekable: false,
          stream_ops: SOCKFS.stream_ops
        });
  
        // map the new stream to the socket structure (sockets have a 1:1
        // relationship with a stream)
        sock.stream = stream;
  
        return sock;
      },getSocket:function (fd) {
        var stream = FS.getStream(fd);
        if (!stream || !FS.isSocket(stream.node.mode)) {
          return null;
        }
        return stream.node.sock;
      },stream_ops:{poll:function (stream) {
          var sock = stream.node.sock;
          return sock.sock_ops.poll(sock);
        },ioctl:function (stream, request, varargs) {
          var sock = stream.node.sock;
          return sock.sock_ops.ioctl(sock, request, varargs);
        },read:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          var msg = sock.sock_ops.recvmsg(sock, length);
          if (!msg) {
            // socket is closed
            return 0;
          }
          buffer.set(msg.buffer, offset);
          return msg.buffer.length;
        },write:function (stream, buffer, offset, length, position /* ignored */) {
          var sock = stream.node.sock;
          return sock.sock_ops.sendmsg(sock, buffer, offset, length);
        },close:function (stream) {
          var sock = stream.node.sock;
          sock.sock_ops.close(sock);
        }},nextname:function () {
        if (!SOCKFS.nextname.current) {
          SOCKFS.nextname.current = 0;
        }
        return 'socket[' + (SOCKFS.nextname.current++) + ']';
      },websocket_sock_ops:{createPeer:function (sock, addr, port) {
          var ws;
  
          if (typeof addr === 'object') {
            ws = addr;
            addr = null;
            port = null;
          }
  
          if (ws) {
            // for sockets that've already connected (e.g. we're the server)
            // we can inspect the _socket property for the address
            if (ws._socket) {
              addr = ws._socket.remoteAddress;
              port = ws._socket.remotePort;
            }
            // if we're just now initializing a connection to the remote,
            // inspect the url property
            else {
              var result = /ws[s]?:\/\/([^:]+):(\d+)/.exec(ws.url);
              if (!result) {
                throw new Error('WebSocket URL must be in the format ws(s)://address:port');
              }
              addr = result[1];
              port = parseInt(result[2], 10);
            }
          } else {
            // create the actual websocket object and connect
            try {
              var url = 'ws://' + addr + ':' + port;
              // the node ws library API is slightly different than the browser's
              var opts = ENVIRONMENT_IS_NODE ? {headers: {'websocket-protocol': ['binary']}} : ['binary'];
              // If node we use the ws library.
              var WebSocket = ENVIRONMENT_IS_NODE ? require('ws') : window['WebSocket'];
              ws = new WebSocket(url, opts);
              ws.binaryType = 'arraybuffer';
            } catch (e) {
              throw new FS.ErrnoError(ERRNO_CODES.EHOSTUNREACH);
            }
          }
  
  
          var peer = {
            addr: addr,
            port: port,
            socket: ws,
            dgram_send_queue: []
          };
  
          SOCKFS.websocket_sock_ops.addPeer(sock, peer);
          SOCKFS.websocket_sock_ops.handlePeerEvents(sock, peer);
  
          // if this is a bound dgram socket, send the port number first to allow
          // us to override the ephemeral port reported to us by remotePort on the
          // remote end.
          if (sock.type === 2 && typeof sock.sport !== 'undefined') {
            peer.dgram_send_queue.push(new Uint8Array([
                255, 255, 255, 255,
                'p'.charCodeAt(0), 'o'.charCodeAt(0), 'r'.charCodeAt(0), 't'.charCodeAt(0),
                ((sock.sport & 0xff00) >> 8) , (sock.sport & 0xff)
            ]));
          }
  
          return peer;
        },getPeer:function (sock, addr, port) {
          return sock.peers[addr + ':' + port];
        },addPeer:function (sock, peer) {
          sock.peers[peer.addr + ':' + peer.port] = peer;
        },removePeer:function (sock, peer) {
          delete sock.peers[peer.addr + ':' + peer.port];
        },handlePeerEvents:function (sock, peer) {
          var first = true;
  
          var handleOpen = function () {
            try {
              var queued = peer.dgram_send_queue.shift();
              while (queued) {
                peer.socket.send(queued);
                queued = peer.dgram_send_queue.shift();
              }
            } catch (e) {
              // not much we can do here in the way of proper error handling as we've already
              // lied and said this data was sent. shut it down.
              peer.socket.close();
            }
          };
  
          function handleMessage(data) {
            assert(typeof data !== 'string' && data.byteLength !== undefined);  // must receive an ArrayBuffer
            data = new Uint8Array(data);  // make a typed array view on the array buffer
  
  
            // if this is the port message, override the peer's port with it
            var wasfirst = first;
            first = false;
            if (wasfirst &&
                data.length === 10 &&
                data[0] === 255 && data[1] === 255 && data[2] === 255 && data[3] === 255 &&
                data[4] === 'p'.charCodeAt(0) && data[5] === 'o'.charCodeAt(0) && data[6] === 'r'.charCodeAt(0) && data[7] === 't'.charCodeAt(0)) {
              // update the peer's port and it's key in the peer map
              var newport = ((data[8] << 8) | data[9]);
              SOCKFS.websocket_sock_ops.removePeer(sock, peer);
              peer.port = newport;
              SOCKFS.websocket_sock_ops.addPeer(sock, peer);
              return;
            }
  
            sock.recv_queue.push({ addr: peer.addr, port: peer.port, data: data });
          };
  
          if (ENVIRONMENT_IS_NODE) {
            peer.socket.on('open', handleOpen);
            peer.socket.on('message', function(data, flags) {
              if (!flags.binary) {
                return;
              }
              handleMessage((new Uint8Array(data)).buffer);  // copy from node Buffer -> ArrayBuffer
            });
            peer.socket.on('error', function() {
              // don't throw
            });
          } else {
            peer.socket.onopen = handleOpen;
            peer.socket.onmessage = function peer_socket_onmessage(event) {
              handleMessage(event.data);
            };
          }
        },poll:function (sock) {
          if (sock.type === 1 && sock.server) {
            // listen sockets should only say they're available for reading
            // if there are pending clients.
            return sock.pending.length ? (64 | 1) : 0;
          }
  
          var mask = 0;
          var dest = sock.type === 1 ?  // we only care about the socket state for connection-based sockets
            SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport) :
            null;
  
          if (sock.recv_queue.length ||
              !dest ||  // connection-less sockets are always ready to read
              (dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {  // let recv return 0 once closed
            mask |= (64 | 1);
          }
  
          if (!dest ||  // connection-less sockets are always ready to write
              (dest && dest.socket.readyState === dest.socket.OPEN)) {
            mask |= 4;
          }
  
          if ((dest && dest.socket.readyState === dest.socket.CLOSING) ||
              (dest && dest.socket.readyState === dest.socket.CLOSED)) {
            mask |= 16;
          }
  
          return mask;
        },ioctl:function (sock, request, arg) {
          switch (request) {
            case 21531:
              var bytes = 0;
              if (sock.recv_queue.length) {
                bytes = sock.recv_queue[0].data.length;
              }
              HEAP32[((arg)>>2)]=bytes;
              return 0;
            default:
              return ERRNO_CODES.EINVAL;
          }
        },close:function (sock) {
          // if we've spawned a listen server, close it
          if (sock.server) {
            try {
              sock.server.close();
            } catch (e) {
            }
            sock.server = null;
          }
          // close any peer connections
          var peers = Object.keys(sock.peers);
          for (var i = 0; i < peers.length; i++) {
            var peer = sock.peers[peers[i]];
            try {
              peer.socket.close();
            } catch (e) {
            }
            SOCKFS.websocket_sock_ops.removePeer(sock, peer);
          }
          return 0;
        },bind:function (sock, addr, port) {
          if (typeof sock.saddr !== 'undefined' || typeof sock.sport !== 'undefined') {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already bound
          }
          sock.saddr = addr;
          sock.sport = port || _mkport();
          // in order to emulate dgram sockets, we need to launch a listen server when
          // binding on a connection-less socket
          // note: this is only required on the server side
          if (sock.type === 2) {
            // close the existing server if it exists
            if (sock.server) {
              sock.server.close();
              sock.server = null;
            }
            // swallow error operation not supported error that occurs when binding in the
            // browser where this isn't supported
            try {
              sock.sock_ops.listen(sock, 0);
            } catch (e) {
              if (!(e instanceof FS.ErrnoError)) throw e;
              if (e.errno !== ERRNO_CODES.EOPNOTSUPP) throw e;
            }
          }
        },connect:function (sock, addr, port) {
          if (sock.server) {
            throw new FS.ErrnoError(ERRNO_CODS.EOPNOTSUPP);
          }
  
          // TODO autobind
          // if (!sock.addr && sock.type == 2) {
          // }
  
          // early out if we're already connected / in the middle of connecting
          if (typeof sock.daddr !== 'undefined' && typeof sock.dport !== 'undefined') {
            var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
            if (dest) {
              if (dest.socket.readyState === dest.socket.CONNECTING) {
                throw new FS.ErrnoError(ERRNO_CODES.EALREADY);
              } else {
                throw new FS.ErrnoError(ERRNO_CODES.EISCONN);
              }
            }
          }
  
          // add the socket to our peer list and set our
          // destination address / port to match
          var peer = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
          sock.daddr = peer.addr;
          sock.dport = peer.port;
  
          // always "fail" in non-blocking mode
          throw new FS.ErrnoError(ERRNO_CODES.EINPROGRESS);
        },listen:function (sock, backlog) {
          if (!ENVIRONMENT_IS_NODE) {
            throw new FS.ErrnoError(ERRNO_CODES.EOPNOTSUPP);
          }
          if (sock.server) {
             throw new FS.ErrnoError(ERRNO_CODES.EINVAL);  // already listening
          }
          var WebSocketServer = require('ws').Server;
          var host = sock.saddr;
          sock.server = new WebSocketServer({
            host: host,
            port: sock.sport
            // TODO support backlog
          });
  
          sock.server.on('connection', function(ws) {
            if (sock.type === 1) {
              var newsock = SOCKFS.createSocket(sock.family, sock.type, sock.protocol);
  
              // create a peer on the new socket
              var peer = SOCKFS.websocket_sock_ops.createPeer(newsock, ws);
              newsock.daddr = peer.addr;
              newsock.dport = peer.port;
  
              // push to queue for accept to pick up
              sock.pending.push(newsock);
            } else {
              // create a peer on the listen socket so calling sendto
              // with the listen socket and an address will resolve
              // to the correct client
              SOCKFS.websocket_sock_ops.createPeer(sock, ws);
            }
          });
          sock.server.on('closed', function() {
            sock.server = null;
          });
          sock.server.on('error', function() {
            // don't throw
          });
        },accept:function (listensock) {
          if (!listensock.server) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
          var newsock = listensock.pending.shift();
          newsock.stream.flags = listensock.stream.flags;
          return newsock;
        },getname:function (sock, peer) {
          var addr, port;
          if (peer) {
            if (sock.daddr === undefined || sock.dport === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            }
            addr = sock.daddr;
            port = sock.dport;
          } else {
            // TODO saddr and sport will be set for bind()'d UDP sockets, but what
            // should we be returning for TCP sockets that've been connect()'d?
            addr = sock.saddr || 0;
            port = sock.sport || 0;
          }
          return { addr: addr, port: port };
        },sendmsg:function (sock, buffer, offset, length, addr, port) {
          if (sock.type === 2) {
            // connection-less sockets will honor the message address,
            // and otherwise fall back to the bound destination address
            if (addr === undefined || port === undefined) {
              addr = sock.daddr;
              port = sock.dport;
            }
            // if there was no address to fall back to, error out
            if (addr === undefined || port === undefined) {
              throw new FS.ErrnoError(ERRNO_CODES.EDESTADDRREQ);
            }
          } else {
            // connection-based sockets will only use the bound
            addr = sock.daddr;
            port = sock.dport;
          }
  
          // find the peer for the destination address
          var dest = SOCKFS.websocket_sock_ops.getPeer(sock, addr, port);
  
          // early out if not connected with a connection-based socket
          if (sock.type === 1) {
            if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
              throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
            } else if (dest.socket.readyState === dest.socket.CONNECTING) {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // create a copy of the incoming data to send, as the WebSocket API
          // doesn't work entirely with an ArrayBufferView, it'll just send
          // the entire underlying buffer
          var data;
          if (buffer instanceof Array || buffer instanceof ArrayBuffer) {
            data = buffer.slice(offset, offset + length);
          } else {  // ArrayBufferView
            data = buffer.buffer.slice(buffer.byteOffset + offset, buffer.byteOffset + offset + length);
          }
  
          // if we're emulating a connection-less dgram socket and don't have
          // a cached connection, queue the buffer to send upon connect and
          // lie, saying the data was sent now.
          if (sock.type === 2) {
            if (!dest || dest.socket.readyState !== dest.socket.OPEN) {
              // if we're not connected, open a new connection
              if (!dest || dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                dest = SOCKFS.websocket_sock_ops.createPeer(sock, addr, port);
              }
              dest.dgram_send_queue.push(data);
              return length;
            }
          }
  
          try {
            // send the actual data
            dest.socket.send(data);
            return length;
          } catch (e) {
            throw new FS.ErrnoError(ERRNO_CODES.EINVAL);
          }
        },recvmsg:function (sock, length) {
          // http://pubs.opengroup.org/onlinepubs/7908799/xns/recvmsg.html
          if (sock.type === 1 && sock.server) {
            // tcp servers should not be recv()'ing on the listen socket
            throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
          }
  
          var queued = sock.recv_queue.shift();
          if (!queued) {
            if (sock.type === 1) {
              var dest = SOCKFS.websocket_sock_ops.getPeer(sock, sock.daddr, sock.dport);
  
              if (!dest) {
                // if we have a destination address but are not connected, error out
                throw new FS.ErrnoError(ERRNO_CODES.ENOTCONN);
              }
              else if (dest.socket.readyState === dest.socket.CLOSING || dest.socket.readyState === dest.socket.CLOSED) {
                // return null if the socket has closed
                return null;
              }
              else {
                // else, our socket is in a valid state but truly has nothing available
                throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
              }
            } else {
              throw new FS.ErrnoError(ERRNO_CODES.EAGAIN);
            }
          }
  
          // queued.data will be an ArrayBuffer if it's unadulterated, but if it's
          // requeued TCP data it'll be an ArrayBufferView
          var queuedLength = queued.data.byteLength || queued.data.length;
          var queuedOffset = queued.data.byteOffset || 0;
          var queuedBuffer = queued.data.buffer || queued.data;
          var bytesRead = Math.min(length, queuedLength);
          var res = {
            buffer: new Uint8Array(queuedBuffer, queuedOffset, bytesRead),
            addr: queued.addr,
            port: queued.port
          };
  
  
          // push back any unread data for TCP connections
          if (sock.type === 1 && bytesRead < queuedLength) {
            var bytesRemaining = queuedLength - bytesRead;
            queued.data = new Uint8Array(queuedBuffer, queuedOffset + bytesRead, bytesRemaining);
            sock.recv_queue.unshift(queued);
          }
  
          return res;
        }}};function _send(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _write(fd, buf, len);
    }
  
  function _pwrite(fildes, buf, nbyte, offset) {
      // ssize_t pwrite(int fildes, const void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _write(fildes, buf, nbyte) {
      // ssize_t write(int fildes, const void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/write.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.write(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fputc(c, stream) {
      // int fputc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputc.html
      var chr = unSign(c & 0xFF);
      HEAP8[((_fputc.ret)|0)]=chr;
      var fd = _fileno(stream);
      var ret = _write(fd, _fputc.ret, 1);
      if (ret == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return -1;
      } else {
        return chr;
      }
    }

  
  var ___strtok_state=0;
  
  function _strtok_r(s, delim, lasts) {
      var skip_leading_delim = 1;
      var spanp;
      var c, sc;
      var tok;
  
  
      if (s == 0 && (s = getValue(lasts, 'i8*')) == 0) {
        return 0;
      }
  
      cont: while (1) {
        c = getValue(s++, 'i8');
        for (spanp = delim; (sc = getValue(spanp++, 'i8')) != 0;) {
          if (c == sc) {
            if (skip_leading_delim) {
              continue cont;
            } else {
              setValue(lasts, s, 'i8*');
              setValue(s - 1, 0, 'i8');
              return s - 1;
            }
          }
        }
        break;
      }
  
      if (c == 0) {
        setValue(lasts, 0, 'i8*');
        return 0;
      }
      tok = s - 1;
  
      for (;;) {
        c = getValue(s++, 'i8');
        spanp = delim;
        do {
          if ((sc = getValue(spanp++, 'i8')) == c) {
            if (c == 0) {
              s = 0;
            } else {
              setValue(s - 1, 0, 'i8');
            }
            setValue(lasts, s, 'i8*');
            return tok;
          }
        } while (sc != 0);
      }
      abort('strtok_r error!');
    }function _strtok(s, delim) {
      return _strtok_r(s, delim, ___strtok_state);
    }

  function _fwrite(ptr, size, nitems, stream) {
      // size_t fwrite(const void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fwrite.html
      var bytesToWrite = nitems * size;
      if (bytesToWrite == 0) return 0;
      var fd = _fileno(stream);
      var bytesWritten = _write(fd, ptr, bytesToWrite);
      if (bytesWritten == -1) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (streamObj) streamObj.error = true;
        return 0;
      } else {
        return Math.floor(bytesWritten / size);
      }
    }

  
  function _putchar(c) {
      // int putchar(int c);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/putchar.html
      return _fputc(c, HEAP32[((_stdout)>>2)]);
    } 
  Module["_saveSetjmp"] = _saveSetjmp;

  
   
  Module["_strlen"] = _strlen;function _fputs(s, stream) {
      // int fputs(const char *restrict s, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fputs.html
      var fd = _fileno(stream);
      return _write(fd, s, _strlen(s));
    }

  var Browser={mainLoop:{scheduler:null,method:"",shouldPause:false,paused:false,queue:[],pause:function () {
          Browser.mainLoop.shouldPause = true;
        },resume:function () {
          if (Browser.mainLoop.paused) {
            Browser.mainLoop.paused = false;
            Browser.mainLoop.scheduler();
          }
          Browser.mainLoop.shouldPause = false;
        },updateStatus:function () {
          if (Module['setStatus']) {
            var message = Module['statusMessage'] || 'Please wait...';
            var remaining = Browser.mainLoop.remainingBlockers;
            var expected = Browser.mainLoop.expectedBlockers;
            if (remaining) {
              if (remaining < expected) {
                Module['setStatus'](message + ' (' + (expected - remaining) + '/' + expected + ')');
              } else {
                Module['setStatus'](message);
              }
            } else {
              Module['setStatus']('');
            }
          }
        }},isFullScreen:false,pointerLock:false,moduleContextCreatedCallbacks:[],workers:[],init:function () {
        if (!Module["preloadPlugins"]) Module["preloadPlugins"] = []; // needs to exist even in workers
  
        if (Browser.initted || ENVIRONMENT_IS_WORKER) return;
        Browser.initted = true;
  
        try {
          new Blob();
          Browser.hasBlobConstructor = true;
        } catch(e) {
          Browser.hasBlobConstructor = false;
          console.log("warning: no blob constructor, cannot create blobs with mimetypes");
        }
        Browser.BlobBuilder = typeof MozBlobBuilder != "undefined" ? MozBlobBuilder : (typeof WebKitBlobBuilder != "undefined" ? WebKitBlobBuilder : (!Browser.hasBlobConstructor ? console.log("warning: no BlobBuilder") : null));
        Browser.URLObject = typeof window != "undefined" ? (window.URL ? window.URL : window.webkitURL) : undefined;
        if (!Module.noImageDecoding && typeof Browser.URLObject === 'undefined') {
          console.log("warning: Browser does not support creating object URLs. Built-in browser image decoding will not be available.");
          Module.noImageDecoding = true;
        }
  
        // Support for plugins that can process preloaded files. You can add more of these to
        // your app by creating and appending to Module.preloadPlugins.
        //
        // Each plugin is asked if it can handle a file based on the file's name. If it can,
        // it is given the file's raw data. When it is done, it calls a callback with the file's
        // (possibly modified) data. For example, a plugin might decompress a file, or it
        // might create some side data structure for use later (like an Image element, etc.).
  
        var imagePlugin = {};
        imagePlugin['canHandle'] = function imagePlugin_canHandle(name) {
          return !Module.noImageDecoding && /\.(jpg|jpeg|png|bmp)$/i.test(name);
        };
        imagePlugin['handle'] = function imagePlugin_handle(byteArray, name, onload, onerror) {
          var b = null;
          if (Browser.hasBlobConstructor) {
            try {
              b = new Blob([byteArray], { type: Browser.getMimetype(name) });
              if (b.size !== byteArray.length) { // Safari bug #118630
                // Safari's Blob can only take an ArrayBuffer
                b = new Blob([(new Uint8Array(byteArray)).buffer], { type: Browser.getMimetype(name) });
              }
            } catch(e) {
              Runtime.warnOnce('Blob constructor present but fails: ' + e + '; falling back to blob builder');
            }
          }
          if (!b) {
            var bb = new Browser.BlobBuilder();
            bb.append((new Uint8Array(byteArray)).buffer); // we need to pass a buffer, and must copy the array to get the right data range
            b = bb.getBlob();
          }
          var url = Browser.URLObject.createObjectURL(b);
          var img = new Image();
          img.onload = function img_onload() {
            assert(img.complete, 'Image ' + name + ' could not be decoded');
            var canvas = document.createElement('canvas');
            canvas.width = img.width;
            canvas.height = img.height;
            var ctx = canvas.getContext('2d');
            ctx.drawImage(img, 0, 0);
            Module["preloadedImages"][name] = canvas;
            Browser.URLObject.revokeObjectURL(url);
            if (onload) onload(byteArray);
          };
          img.onerror = function img_onerror(event) {
            console.log('Image ' + url + ' could not be decoded');
            if (onerror) onerror();
          };
          img.src = url;
        };
        Module['preloadPlugins'].push(imagePlugin);
  
        var audioPlugin = {};
        audioPlugin['canHandle'] = function audioPlugin_canHandle(name) {
          return !Module.noAudioDecoding && name.substr(-4) in { '.ogg': 1, '.wav': 1, '.mp3': 1 };
        };
        audioPlugin['handle'] = function audioPlugin_handle(byteArray, name, onload, onerror) {
          var done = false;
          function finish(audio) {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = audio;
            if (onload) onload(byteArray);
          }
          function fail() {
            if (done) return;
            done = true;
            Module["preloadedAudios"][name] = new Audio(); // empty shim
            if (onerror) onerror();
          }
          if (Browser.hasBlobConstructor) {
            try {
              var b = new Blob([byteArray], { type: Browser.getMimetype(name) });
            } catch(e) {
              return fail();
            }
            var url = Browser.URLObject.createObjectURL(b); // XXX we never revoke this!
            var audio = new Audio();
            audio.addEventListener('canplaythrough', function() { finish(audio) }, false); // use addEventListener due to chromium bug 124926
            audio.onerror = function audio_onerror(event) {
              if (done) return;
              console.log('warning: browser could not fully decode audio ' + name + ', trying slower base64 approach');
              function encode64(data) {
                var BASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
                var PAD = '=';
                var ret = '';
                var leftchar = 0;
                var leftbits = 0;
                for (var i = 0; i < data.length; i++) {
                  leftchar = (leftchar << 8) | data[i];
                  leftbits += 8;
                  while (leftbits >= 6) {
                    var curr = (leftchar >> (leftbits-6)) & 0x3f;
                    leftbits -= 6;
                    ret += BASE[curr];
                  }
                }
                if (leftbits == 2) {
                  ret += BASE[(leftchar&3) << 4];
                  ret += PAD + PAD;
                } else if (leftbits == 4) {
                  ret += BASE[(leftchar&0xf) << 2];
                  ret += PAD;
                }
                return ret;
              }
              audio.src = 'data:audio/x-' + name.substr(-3) + ';base64,' + encode64(byteArray);
              finish(audio); // we don't wait for confirmation this worked - but it's worth trying
            };
            audio.src = url;
            // workaround for chrome bug 124926 - we do not always get oncanplaythrough or onerror
            Browser.safeSetTimeout(function() {
              finish(audio); // try to use it even though it is not necessarily ready to play
            }, 10000);
          } else {
            return fail();
          }
        };
        Module['preloadPlugins'].push(audioPlugin);
  
        // Canvas event setup
  
        var canvas = Module['canvas'];
        canvas.requestPointerLock = canvas['requestPointerLock'] ||
                                    canvas['mozRequestPointerLock'] ||
                                    canvas['webkitRequestPointerLock'];
        canvas.exitPointerLock = document['exitPointerLock'] ||
                                 document['mozExitPointerLock'] ||
                                 document['webkitExitPointerLock'] ||
                                 function(){}; // no-op if function does not exist
        canvas.exitPointerLock = canvas.exitPointerLock.bind(document);
  
        function pointerLockChange() {
          Browser.pointerLock = document['pointerLockElement'] === canvas ||
                                document['mozPointerLockElement'] === canvas ||
                                document['webkitPointerLockElement'] === canvas;
        }
  
        document.addEventListener('pointerlockchange', pointerLockChange, false);
        document.addEventListener('mozpointerlockchange', pointerLockChange, false);
        document.addEventListener('webkitpointerlockchange', pointerLockChange, false);
  
        if (Module['elementPointerLock']) {
          canvas.addEventListener("click", function(ev) {
            if (!Browser.pointerLock && canvas.requestPointerLock) {
              canvas.requestPointerLock();
              ev.preventDefault();
            }
          }, false);
        }
      },createContext:function (canvas, useWebGL, setInModule, webGLContextAttributes) {
        var ctx;
        var errorInfo = '?';
        function onContextCreationError(event) {
          errorInfo = event.statusMessage || errorInfo;
        }
        try {
          if (useWebGL) {
            var contextAttributes = {
              antialias: false,
              alpha: false
            };
  
            if (webGLContextAttributes) {
              for (var attribute in webGLContextAttributes) {
                contextAttributes[attribute] = webGLContextAttributes[attribute];
              }
            }
  
  
            canvas.addEventListener('webglcontextcreationerror', onContextCreationError, false);
            try {
              ['experimental-webgl', 'webgl'].some(function(webglId) {
                return ctx = canvas.getContext(webglId, contextAttributes);
              });
            } finally {
              canvas.removeEventListener('webglcontextcreationerror', onContextCreationError, false);
            }
          } else {
            ctx = canvas.getContext('2d');
          }
          if (!ctx) throw ':(';
        } catch (e) {
          Module.print('Could not create canvas: ' + [errorInfo, e]);
          return null;
        }
        if (useWebGL) {
          // Set the background of the WebGL canvas to black
          canvas.style.backgroundColor = "black";
  
          // Warn on context loss
          canvas.addEventListener('webglcontextlost', function(event) {
            alert('WebGL context lost. You will need to reload the page.');
          }, false);
        }
        if (setInModule) {
          GLctx = Module.ctx = ctx;
          Module.useWebGL = useWebGL;
          Browser.moduleContextCreatedCallbacks.forEach(function(callback) { callback() });
          Browser.init();
        }
        return ctx;
      },destroyContext:function (canvas, useWebGL, setInModule) {},fullScreenHandlersInstalled:false,lockPointer:undefined,resizeCanvas:undefined,requestFullScreen:function (lockPointer, resizeCanvas) {
        Browser.lockPointer = lockPointer;
        Browser.resizeCanvas = resizeCanvas;
        if (typeof Browser.lockPointer === 'undefined') Browser.lockPointer = true;
        if (typeof Browser.resizeCanvas === 'undefined') Browser.resizeCanvas = false;
  
        var canvas = Module['canvas'];
        function fullScreenChange() {
          Browser.isFullScreen = false;
          if ((document['webkitFullScreenElement'] || document['webkitFullscreenElement'] ||
               document['mozFullScreenElement'] || document['mozFullscreenElement'] ||
               document['fullScreenElement'] || document['fullscreenElement']) === canvas) {
            canvas.cancelFullScreen = document['cancelFullScreen'] ||
                                      document['mozCancelFullScreen'] ||
                                      document['webkitCancelFullScreen'];
            canvas.cancelFullScreen = canvas.cancelFullScreen.bind(document);
            if (Browser.lockPointer) canvas.requestPointerLock();
            Browser.isFullScreen = true;
            if (Browser.resizeCanvas) Browser.setFullScreenCanvasSize();
          } else if (Browser.resizeCanvas){
            Browser.setWindowedCanvasSize();
          }
          if (Module['onFullScreen']) Module['onFullScreen'](Browser.isFullScreen);
        }
  
        if (!Browser.fullScreenHandlersInstalled) {
          Browser.fullScreenHandlersInstalled = true;
          document.addEventListener('fullscreenchange', fullScreenChange, false);
          document.addEventListener('mozfullscreenchange', fullScreenChange, false);
          document.addEventListener('webkitfullscreenchange', fullScreenChange, false);
        }
  
        canvas.requestFullScreen = canvas['requestFullScreen'] ||
                                   canvas['mozRequestFullScreen'] ||
                                   (canvas['webkitRequestFullScreen'] ? function() { canvas['webkitRequestFullScreen'](Element['ALLOW_KEYBOARD_INPUT']) } : null);
        canvas.requestFullScreen();
      },requestAnimationFrame:function requestAnimationFrame(func) {
        if (typeof window === 'undefined') { // Provide fallback to setTimeout if window is undefined (e.g. in Node.js)
          setTimeout(func, 1000/60);
        } else {
          if (!window.requestAnimationFrame) {
            window.requestAnimationFrame = window['requestAnimationFrame'] ||
                                           window['mozRequestAnimationFrame'] ||
                                           window['webkitRequestAnimationFrame'] ||
                                           window['msRequestAnimationFrame'] ||
                                           window['oRequestAnimationFrame'] ||
                                           window['setTimeout'];
          }
          window.requestAnimationFrame(func);
        }
      },safeCallback:function (func) {
        return function() {
          if (!ABORT) return func.apply(null, arguments);
        };
      },safeRequestAnimationFrame:function (func) {
        return Browser.requestAnimationFrame(function() {
          if (!ABORT) func();
        });
      },safeSetTimeout:function (func, timeout) {
        return setTimeout(function() {
          if (!ABORT) func();
        }, timeout);
      },safeSetInterval:function (func, timeout) {
        return setInterval(function() {
          if (!ABORT) func();
        }, timeout);
      },getMimetype:function (name) {
        return {
          'jpg': 'image/jpeg',
          'jpeg': 'image/jpeg',
          'png': 'image/png',
          'bmp': 'image/bmp',
          'ogg': 'audio/ogg',
          'wav': 'audio/wav',
          'mp3': 'audio/mpeg'
        }[name.substr(name.lastIndexOf('.')+1)];
      },getUserMedia:function (func) {
        if(!window.getUserMedia) {
          window.getUserMedia = navigator['getUserMedia'] ||
                                navigator['mozGetUserMedia'];
        }
        window.getUserMedia(func);
      },getMovementX:function (event) {
        return event['movementX'] ||
               event['mozMovementX'] ||
               event['webkitMovementX'] ||
               0;
      },getMovementY:function (event) {
        return event['movementY'] ||
               event['mozMovementY'] ||
               event['webkitMovementY'] ||
               0;
      },getMouseWheelDelta:function (event) {
        return Math.max(-1, Math.min(1, event.type === 'DOMMouseScroll' ? event.detail : -event.wheelDelta));
      },mouseX:0,mouseY:0,mouseMovementX:0,mouseMovementY:0,calculateMouseEvent:function (event) { // event should be mousemove, mousedown or mouseup
        if (Browser.pointerLock) {
          // When the pointer is locked, calculate the coordinates
          // based on the movement of the mouse.
          // Workaround for Firefox bug 764498
          if (event.type != 'mousemove' &&
              ('mozMovementX' in event)) {
            Browser.mouseMovementX = Browser.mouseMovementY = 0;
          } else {
            Browser.mouseMovementX = Browser.getMovementX(event);
            Browser.mouseMovementY = Browser.getMovementY(event);
          }
          
          // check if SDL is available
          if (typeof SDL != "undefined") {
          	Browser.mouseX = SDL.mouseX + Browser.mouseMovementX;
          	Browser.mouseY = SDL.mouseY + Browser.mouseMovementY;
          } else {
          	// just add the mouse delta to the current absolut mouse position
          	// FIXME: ideally this should be clamped against the canvas size and zero
          	Browser.mouseX += Browser.mouseMovementX;
          	Browser.mouseY += Browser.mouseMovementY;
          }        
        } else {
          // Otherwise, calculate the movement based on the changes
          // in the coordinates.
          var rect = Module["canvas"].getBoundingClientRect();
          var x, y;
          
          // Neither .scrollX or .pageXOffset are defined in a spec, but
          // we prefer .scrollX because it is currently in a spec draft.
          // (see: http://www.w3.org/TR/2013/WD-cssom-view-20131217/)
          var scrollX = ((typeof window.scrollX !== 'undefined') ? window.scrollX : window.pageXOffset);
          var scrollY = ((typeof window.scrollY !== 'undefined') ? window.scrollY : window.pageYOffset);
          if (event.type == 'touchstart' ||
              event.type == 'touchend' ||
              event.type == 'touchmove') {
            var t = event.touches.item(0);
            if (t) {
              x = t.pageX - (scrollX + rect.left);
              y = t.pageY - (scrollY + rect.top);
            } else {
              return;
            }
          } else {
            x = event.pageX - (scrollX + rect.left);
            y = event.pageY - (scrollY + rect.top);
          }
  
          // the canvas might be CSS-scaled compared to its backbuffer;
          // SDL-using content will want mouse coordinates in terms
          // of backbuffer units.
          var cw = Module["canvas"].width;
          var ch = Module["canvas"].height;
          x = x * (cw / rect.width);
          y = y * (ch / rect.height);
  
          Browser.mouseMovementX = x - Browser.mouseX;
          Browser.mouseMovementY = y - Browser.mouseY;
          Browser.mouseX = x;
          Browser.mouseY = y;
        }
      },xhrLoad:function (url, onload, onerror) {
        var xhr = new XMLHttpRequest();
        xhr.open('GET', url, true);
        xhr.responseType = 'arraybuffer';
        xhr.onload = function xhr_onload() {
          if (xhr.status == 200 || (xhr.status == 0 && xhr.response)) { // file URLs can return 0
            onload(xhr.response);
          } else {
            onerror();
          }
        };
        xhr.onerror = onerror;
        xhr.send(null);
      },asyncLoad:function (url, onload, onerror, noRunDep) {
        Browser.xhrLoad(url, function(arrayBuffer) {
          assert(arrayBuffer, 'Loading data file "' + url + '" failed (no arrayBuffer).');
          onload(new Uint8Array(arrayBuffer));
          if (!noRunDep) removeRunDependency('al ' + url);
        }, function(event) {
          if (onerror) {
            onerror();
          } else {
            throw 'Loading data file "' + url + '" failed.';
          }
        });
        if (!noRunDep) addRunDependency('al ' + url);
      },resizeListeners:[],updateResizeListeners:function () {
        var canvas = Module['canvas'];
        Browser.resizeListeners.forEach(function(listener) {
          listener(canvas.width, canvas.height);
        });
      },setCanvasSize:function (width, height, noUpdates) {
        var canvas = Module['canvas'];
        canvas.width = width;
        canvas.height = height;
        if (!noUpdates) Browser.updateResizeListeners();
      },windowedWidth:0,windowedHeight:0,setFullScreenCanvasSize:function () {
        var canvas = Module['canvas'];
        this.windowedWidth = canvas.width;
        this.windowedHeight = canvas.height;
        canvas.width = screen.width;
        canvas.height = screen.height;
        // check if SDL is available   
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags | 0x00800000; // set SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      },setWindowedCanvasSize:function () {
        var canvas = Module['canvas'];
        canvas.width = this.windowedWidth;
        canvas.height = this.windowedHeight;
        // check if SDL is available       
        if (typeof SDL != "undefined") {
        	var flags = HEAPU32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)];
        	flags = flags & ~0x00800000; // clear SDL_FULLSCREEN flag
        	HEAP32[((SDL.screen+Runtime.QUANTUM_SIZE*0)>>2)]=flags
        }
        Browser.updateResizeListeners();
      }};


  
  function _malloc(bytes) {
      /* Over-allocate to make sure it is byte-aligned by 8.
       * This will leak memory, but this is only the dummy
       * implementation (replaced by dlmalloc normally) so
       * not an issue.
       */
      var ptr = Runtime.dynamicAlloc(bytes + 8);
      return (ptr+8) & 0xFFFFFFF8;
    }
  Module["_malloc"] = _malloc;
  
  var ___tm_current=allocate(44, "i8", ALLOC_STATIC);
  
  
  var ___tm_timezone=allocate(intArrayFromString("GMT"), "i8", ALLOC_STATIC);
  
  
  var _tzname=allocate(8, "i32*", ALLOC_STATIC);
  
  var _daylight=allocate(1, "i32*", ALLOC_STATIC);
  
  var _timezone=allocate(1, "i32*", ALLOC_STATIC);function _tzset() {
      // TODO: Use (malleable) environment variables instead of system settings.
      if (_tzset.called) return;
      _tzset.called = true;
  
      HEAP32[((_timezone)>>2)]=-(new Date()).getTimezoneOffset() * 60;
  
      var winter = new Date(2000, 0, 1);
      var summer = new Date(2000, 6, 1);
      HEAP32[((_daylight)>>2)]=Number(winter.getTimezoneOffset() != summer.getTimezoneOffset());
  
      var winterName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | winter.toString().match(/\(([A-Z]+)\)/)[1];
      var summerName = 'GMT'; // XXX do not rely on browser timezone info, it is very unpredictable | summer.toString().match(/\(([A-Z]+)\)/)[1];
      var winterNamePtr = allocate(intArrayFromString(winterName), 'i8', ALLOC_NORMAL);
      var summerNamePtr = allocate(intArrayFromString(summerName), 'i8', ALLOC_NORMAL);
      HEAP32[((_tzname)>>2)]=winterNamePtr;
      HEAP32[(((_tzname)+(4))>>2)]=summerNamePtr;
    }function _localtime_r(time, tmPtr) {
      _tzset();
      var date = new Date(HEAP32[((time)>>2)]*1000);
      HEAP32[((tmPtr)>>2)]=date.getSeconds();
      HEAP32[(((tmPtr)+(4))>>2)]=date.getMinutes();
      HEAP32[(((tmPtr)+(8))>>2)]=date.getHours();
      HEAP32[(((tmPtr)+(12))>>2)]=date.getDate();
      HEAP32[(((tmPtr)+(16))>>2)]=date.getMonth();
      HEAP32[(((tmPtr)+(20))>>2)]=date.getFullYear()-1900;
      HEAP32[(((tmPtr)+(24))>>2)]=date.getDay();
  
      var start = new Date(date.getFullYear(), 0, 1);
      var yday = Math.floor((date.getTime() - start.getTime()) / (1000 * 60 * 60 * 24));
      HEAP32[(((tmPtr)+(28))>>2)]=yday;
      HEAP32[(((tmPtr)+(36))>>2)]=start.getTimezoneOffset() * 60;
  
      var dst = Number(start.getTimezoneOffset() != date.getTimezoneOffset());
      HEAP32[(((tmPtr)+(32))>>2)]=dst;
  
      HEAP32[(((tmPtr)+(40))>>2)]=___tm_timezone;
  
      return tmPtr;
    }function _localtime(time) {
      return _localtime_r(time, ___tm_current);
    }

   
  Module["_bitshift64Ashr"] = _bitshift64Ashr;

  
  var PTHREAD_SPECIFIC={};function _pthread_setspecific(key, value) {
      if (!(key in PTHREAD_SPECIFIC)) {
        return ERRNO_CODES.EINVAL;
      }
      PTHREAD_SPECIFIC[key] = value;
      return 0;
    }

  function _GC_init() {
  Module['printErr']('missing function: GC_init'); abort(-1);
  }

  var _ceil=Math_ceil;

  function _GC_strdup() {
  Module['printErr']('missing function: GC_strdup'); abort(-1);
  }

  function _GC_malloc_atomic() {
  Module['printErr']('missing function: GC_malloc_atomic'); abort(-1);
  }

  
  function _isxdigit(chr) {
      return (chr >= 48 && chr <= 57) ||
             (chr >= 97 && chr <= 102) ||
             (chr >= 65 && chr <= 70);
    }function _isxdigit_l(chr) {
      return _isxdigit(chr); // no locale support yet
    }

  
  function _puts(s) {
      // int puts(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/puts.html
      // NOTE: puts() always writes an extra newline.
      var stdout = HEAP32[((_stdout)>>2)];
      var ret = _fputs(s, stdout);
      if (ret < 0) {
        return ret;
      } else {
        var newlineRet = _fputc(10, stdout);
        return (newlineRet < 0) ? -1 : ret + 1;
      }
    }
  
  
  function _strerror_r(errnum, strerrbuf, buflen) {
      if (errnum in ERRNO_MESSAGES) {
        if (ERRNO_MESSAGES[errnum].length > buflen - 1) {
          return ___setErrNo(ERRNO_CODES.ERANGE);
        } else {
          var msg = ERRNO_MESSAGES[errnum];
          writeAsciiToMemory(msg, strerrbuf);
          return 0;
        }
      } else {
        return ___setErrNo(ERRNO_CODES.EINVAL);
      }
    }function _strerror(errnum) {
      if (!_strerror.buffer) _strerror.buffer = _malloc(256);
      _strerror_r(errnum, _strerror.buffer, 256);
      return _strerror.buffer;
    }
  
  function ___errno_location() {
      return ___errno_state;
    }function _perror(s) {
      // void perror(const char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/perror.html
      var stdout = HEAP32[((_stdout)>>2)];
      if (s) {
        _fputs(s, stdout);
        _fputc(58, stdout);
        _fputc(32, stdout);
      }
      var errnum = HEAP32[((___errno_location())>>2)];
      _puts(_strerror(errnum));
    }

  
  function _emscripten_memcpy_big(dest, src, num) {
      HEAPU8.set(HEAPU8.subarray(src, src+num), dest);
      return dest;
    } 
  Module["_memcpy"] = _memcpy;


  function _strstr(ptr1, ptr2) {
      var check = 0, start;
      do {
        if (!check) {
          start = ptr1;
          check = ptr2;
        }
        var curr1 = HEAP8[((ptr1++)|0)];
        var curr2 = HEAP8[((check++)|0)];
        if (curr2 == 0) return start;
        if (curr2 != curr1) {
          // rewind to one character after start, to find ez in eeez
          ptr1 = start + 1;
          check = 0;
        }
      } while (curr1);
      return 0;
    }

   
  Module["_memmove"] = _memmove;

  function _newlocale(mask, locale, base) {
      return _malloc(4);
    }

  function _signal(sig, func) {
      // TODO
      return 0;
    }

  
  
  function __getFloat(text) {
      return /^[+-]?[0-9]*\.?[0-9]+([eE][+-]?[0-9]+)?/.exec(text);
    }function __scanString(format, get, unget, varargs) {
      if (!__scanString.whiteSpace) {
        __scanString.whiteSpace = {};
        __scanString.whiteSpace[32] = 1;
        __scanString.whiteSpace[9] = 1;
        __scanString.whiteSpace[10] = 1;
        __scanString.whiteSpace[11] = 1;
        __scanString.whiteSpace[12] = 1;
        __scanString.whiteSpace[13] = 1;
      }
      // Supports %x, %4x, %d.%d, %lld, %s, %f, %lf.
      // TODO: Support all format specifiers.
      format = Pointer_stringify(format);
      var soFar = 0;
      if (format.indexOf('%n') >= 0) {
        // need to track soFar
        var _get = get;
        get = function get() {
          soFar++;
          return _get();
        }
        var _unget = unget;
        unget = function unget() {
          soFar--;
          return _unget();
        }
      }
      var formatIndex = 0;
      var argsi = 0;
      var fields = 0;
      var argIndex = 0;
      var next;
  
      mainLoop:
      for (var formatIndex = 0; formatIndex < format.length;) {
        if (format[formatIndex] === '%' && format[formatIndex+1] == 'n') {
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          HEAP32[((argPtr)>>2)]=soFar;
          formatIndex += 2;
          continue;
        }
  
        if (format[formatIndex] === '%') {
          var nextC = format.indexOf('c', formatIndex+1);
          if (nextC > 0) {
            var maxx = 1;
            if (nextC > formatIndex+1) {
              var sub = format.substring(formatIndex+1, nextC);
              maxx = parseInt(sub);
              if (maxx != sub) maxx = 0;
            }
            if (maxx) {
              var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
              argIndex += Runtime.getAlignSize('void*', null, true);
              fields++;
              for (var i = 0; i < maxx; i++) {
                next = get();
                HEAP8[((argPtr++)|0)]=next;
                if (next === 0) return i > 0 ? fields : fields-1; // we failed to read the full length of this field
              }
              formatIndex += nextC - formatIndex + 1;
              continue;
            }
          }
        }
  
        // handle %[...]
        if (format[formatIndex] === '%' && format.indexOf('[', formatIndex+1) > 0) {
          var match = /\%([0-9]*)\[(\^)?(\]?[^\]]*)\]/.exec(format.substring(formatIndex));
          if (match) {
            var maxNumCharacters = parseInt(match[1]) || Infinity;
            var negateScanList = (match[2] === '^');
            var scanList = match[3];
  
            // expand "middle" dashs into character sets
            var middleDashMatch;
            while ((middleDashMatch = /([^\-])\-([^\-])/.exec(scanList))) {
              var rangeStartCharCode = middleDashMatch[1].charCodeAt(0);
              var rangeEndCharCode = middleDashMatch[2].charCodeAt(0);
              for (var expanded = ''; rangeStartCharCode <= rangeEndCharCode; expanded += String.fromCharCode(rangeStartCharCode++));
              scanList = scanList.replace(middleDashMatch[1] + '-' + middleDashMatch[2], expanded);
            }
  
            var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
            argIndex += Runtime.getAlignSize('void*', null, true);
            fields++;
  
            for (var i = 0; i < maxNumCharacters; i++) {
              next = get();
              if (negateScanList) {
                if (scanList.indexOf(String.fromCharCode(next)) < 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              } else {
                if (scanList.indexOf(String.fromCharCode(next)) >= 0) {
                  HEAP8[((argPtr++)|0)]=next;
                } else {
                  unget();
                  break;
                }
              }
            }
  
            // write out null-terminating character
            HEAP8[((argPtr++)|0)]=0;
            formatIndex += match[0].length;
            
            continue;
          }
        }      
        // remove whitespace
        while (1) {
          next = get();
          if (next == 0) return fields;
          if (!(next in __scanString.whiteSpace)) break;
        }
        unget();
  
        if (format[formatIndex] === '%') {
          formatIndex++;
          var suppressAssignment = false;
          if (format[formatIndex] == '*') {
            suppressAssignment = true;
            formatIndex++;
          }
          var maxSpecifierStart = formatIndex;
          while (format[formatIndex].charCodeAt(0) >= 48 &&
                 format[formatIndex].charCodeAt(0) <= 57) {
            formatIndex++;
          }
          var max_;
          if (formatIndex != maxSpecifierStart) {
            max_ = parseInt(format.slice(maxSpecifierStart, formatIndex), 10);
          }
          var long_ = false;
          var half = false;
          var longLong = false;
          if (format[formatIndex] == 'l') {
            long_ = true;
            formatIndex++;
            if (format[formatIndex] == 'l') {
              longLong = true;
              formatIndex++;
            }
          } else if (format[formatIndex] == 'h') {
            half = true;
            formatIndex++;
          }
          var type = format[formatIndex];
          formatIndex++;
          var curr = 0;
          var buffer = [];
          // Read characters according to the format. floats are trickier, they may be in an unfloat state in the middle, then be a valid float later
          if (type == 'f' || type == 'e' || type == 'g' ||
              type == 'F' || type == 'E' || type == 'G') {
            next = get();
            while (next > 0 && (!(next in __scanString.whiteSpace)))  {
              buffer.push(String.fromCharCode(next));
              next = get();
            }
            var m = __getFloat(buffer.join(''));
            var last = m ? m[0].length : 0;
            for (var i = 0; i < buffer.length - last + 1; i++) {
              unget();
            }
            buffer.length = last;
          } else {
            next = get();
            var first = true;
            
            // Strip the optional 0x prefix for %x.
            if ((type == 'x' || type == 'X') && (next == 48)) {
              var peek = get();
              if (peek == 120 || peek == 88) {
                next = get();
              } else {
                unget();
              }
            }
            
            while ((curr < max_ || isNaN(max_)) && next > 0) {
              if (!(next in __scanString.whiteSpace) && // stop on whitespace
                  (type == 's' ||
                   ((type === 'd' || type == 'u' || type == 'i') && ((next >= 48 && next <= 57) ||
                                                                     (first && next == 45))) ||
                   ((type === 'x' || type === 'X') && (next >= 48 && next <= 57 ||
                                     next >= 97 && next <= 102 ||
                                     next >= 65 && next <= 70))) &&
                  (formatIndex >= format.length || next !== format[formatIndex].charCodeAt(0))) { // Stop when we read something that is coming up
                buffer.push(String.fromCharCode(next));
                next = get();
                curr++;
                first = false;
              } else {
                break;
              }
            }
            unget();
          }
          if (buffer.length === 0) return 0;  // Failure.
          if (suppressAssignment) continue;
  
          var text = buffer.join('');
          var argPtr = HEAP32[(((varargs)+(argIndex))>>2)];
          argIndex += Runtime.getAlignSize('void*', null, true);
          switch (type) {
            case 'd': case 'u': case 'i':
              if (half) {
                HEAP16[((argPtr)>>1)]=parseInt(text, 10);
              } else if (longLong) {
                (tempI64 = [parseInt(text, 10)>>>0,(tempDouble=parseInt(text, 10),(+(Math_abs(tempDouble))) >= (+1) ? (tempDouble > (+0) ? ((Math_min((+(Math_floor((tempDouble)/(+4294967296)))), (+4294967295)))|0)>>>0 : (~~((+(Math_ceil((tempDouble - +(((~~(tempDouble)))>>>0))/(+4294967296))))))>>>0) : 0)],HEAP32[((argPtr)>>2)]=tempI64[0],HEAP32[(((argPtr)+(4))>>2)]=tempI64[1]);
              } else {
                HEAP32[((argPtr)>>2)]=parseInt(text, 10);
              }
              break;
            case 'X':
            case 'x':
              HEAP32[((argPtr)>>2)]=parseInt(text, 16);
              break;
            case 'F':
            case 'f':
            case 'E':
            case 'e':
            case 'G':
            case 'g':
            case 'E':
              // fallthrough intended
              if (long_) {
                HEAPF64[((argPtr)>>3)]=parseFloat(text);
              } else {
                HEAPF32[((argPtr)>>2)]=parseFloat(text);
              }
              break;
            case 's':
              var array = intArrayFromString(text);
              for (var j = 0; j < array.length; j++) {
                HEAP8[(((argPtr)+(j))|0)]=array[j];
              }
              break;
          }
          fields++;
        } else if (format[formatIndex].charCodeAt(0) in __scanString.whiteSpace) {
          next = get();
          while (next in __scanString.whiteSpace) {
            if (next <= 0) break mainLoop;  // End of input.
            next = get();
          }
          unget(next);
          formatIndex++;
        } else {
          // Not a specifier.
          next = get();
          if (format[formatIndex].charCodeAt(0) !== next) {
            unget(next);
            break mainLoop;
          }
          formatIndex++;
        }
      }
      return fields;
    }
  
  
  
  
  function _recv(fd, buf, len, flags) {
      var sock = SOCKFS.getSocket(fd);
      if (!sock) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      // TODO honor flags
      return _read(fd, buf, len);
    }
  
  function _pread(fildes, buf, nbyte, offset) {
      // ssize_t pread(int fildes, void *buf, size_t nbyte, off_t offset);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte, offset);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _read(fildes, buf, nbyte) {
      // ssize_t read(int fildes, void *buf, size_t nbyte);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/read.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
  
  
      try {
        var slab = HEAP8;
        return FS.read(stream, slab, buf, nbyte);
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fread(ptr, size, nitems, stream) {
      // size_t fread(void *restrict ptr, size_t size, size_t nitems, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fread.html
      var bytesToRead = nitems * size;
      if (bytesToRead == 0) {
        return 0;
      }
      var bytesRead = 0;
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      while (streamObj.ungotten.length && bytesToRead > 0) {
        HEAP8[((ptr++)|0)]=streamObj.ungotten.pop();
        bytesToRead--;
        bytesRead++;
      }
      var err = _read(streamObj.fd, ptr, bytesToRead);
      if (err == -1) {
        if (streamObj) streamObj.error = true;
        return 0;
      }
      bytesRead += err;
      if (bytesRead < bytesToRead) streamObj.eof = true;
      return Math.floor(bytesRead / size);
    }function _fgetc(stream) {
      // int fgetc(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fgetc.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) return -1;
      if (streamObj.eof || streamObj.error) return -1;
      var ret = _fread(_fgetc.ret, 1, 1, stream);
      if (ret == 0) {
        return -1;
      } else if (ret == -1) {
        streamObj.error = true;
        return -1;
      } else {
        return HEAPU8[((_fgetc.ret)|0)];
      }
    }
  
  function _ungetc(c, stream) {
      // int ungetc(int c, FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ungetc.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        return -1;
      }
      if (c === -1) {
        // do nothing for EOF character
        return c;
      }
      c = unSign(c & 0xFF);
      stream.ungotten.push(c);
      stream.eof = false;
      return c;
    }function _fscanf(stream, format, varargs) {
      // int fscanf(FILE *restrict stream, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var streamObj = FS.getStreamFromPtr(stream);
      if (!streamObj) {
        return -1;
      }
      var buffer = [];
      function get() {
        var c = _fgetc(stream);
        buffer.push(c);
        return c;
      };
      function unget() {
        _ungetc(buffer.pop(), stream);
      };
      return __scanString(format, get, unget, varargs);
    }

  var _emscripten_preinvoke=true;

  function _pthread_cond_wait() {
      return 0;
    }

  
  
  
  var ___cxa_exception_header_size=8;
  
  function _free() {
  }
  Module["_free"] = _free;function ___cxa_free_exception(ptr) {
      try {
        return _free(ptr - ___cxa_exception_header_size);
      } catch(e) { // XXX FIXME
      }
    }
  
  var ___cxa_last_thrown_exception=0;
  
  var ___cxa_caught_exceptions=[];function ___cxa_end_catch() {
      if (___cxa_end_catch.rethrown) {
        ___cxa_end_catch.rethrown = false;
        return;
      }
      // Clear state flag.
      asm['setThrew'](0);
      // Call destructor if one is registered then clear it.
      var ptr = ___cxa_caught_exceptions.pop();
      if (ptr) {
        header = ptr - ___cxa_exception_header_size;
        var destructor = HEAP32[(((header)+(4))>>2)];
        if (destructor) {
          Runtime.dynCall('vi', destructor, [ptr]);
          HEAP32[(((header)+(4))>>2)]=0;
        }
        ___cxa_free_exception(ptr);
        ___cxa_last_thrown_exception = 0;
      }
    }function ___cxa_rethrow() {
      ___cxa_end_catch.rethrown = true;
      var ptr = ___cxa_caught_exceptions.pop();
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  
  
  function _open(path, oflag, varargs) {
      // int open(const char *path, int oflag, ...);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/open.html
      var mode = HEAP32[((varargs)>>2)];
      path = Pointer_stringify(path);
      try {
        var stream = FS.open(path, oflag, mode);
        return stream.fd;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fopen(filename, mode) {
      // FILE *fopen(const char *restrict filename, const char *restrict mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/fopen.html
      var flags;
      mode = Pointer_stringify(mode);
      if (mode[0] == 'r') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 0;
        }
      } else if (mode[0] == 'w') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 512;
      } else if (mode[0] == 'a') {
        if (mode.indexOf('+') != -1) {
          flags = 2;
        } else {
          flags = 1;
        }
        flags |= 64;
        flags |= 1024;
      } else {
        ___setErrNo(ERRNO_CODES.EINVAL);
        return 0;
      }
      var fd = _open(filename, flags, allocate([0x1FF, 0, 0, 0], 'i32', ALLOC_STACK));  // All creation permissions.
      return fd === -1 ? 0 : FS.getPtrForStream(FS.getStream(fd));
    }function _freopen(filename, mode, stream) {
      // FILE *freopen(const char *restrict filename, const char *restrict mode, FILE *restrict stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/freopen.html
      if (!filename) {
        var streamObj = FS.getStreamFromPtr(stream);
        if (!streamObj) {
          ___setErrNo(ERRNO_CODES.EBADF);
          return 0;
        }
        if (_freopen.buffer) _free(_freopen.buffer);
        filename = intArrayFromString(streamObj.path);
        filename = allocate(filename, 'i8', ALLOC_NORMAL);
      }
      _fclose(stream);
      return _fopen(filename, mode);
    }

  function _round(x) {
      return (x < 0) ? -Math.round(-x) : Math.round(x);
    }

  
  function _emscripten_get_now() {
      if (!_emscripten_get_now.actual) {
        if (ENVIRONMENT_IS_NODE) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() {
            var t = process['hrtime']();
            return t[0] * 1e3 + t[1] / 1e6;
          }
        } else if (typeof dateNow !== 'undefined') {
          _emscripten_get_now.actual = dateNow;
        } else if (ENVIRONMENT_IS_WEB && window['performance'] && window['performance']['now']) {
          _emscripten_get_now.actual = function _emscripten_get_now_actual() { return window['performance']['now'](); };
        } else {
          _emscripten_get_now.actual = Date.now;
        }
      }
      return _emscripten_get_now.actual();
    }function _clock_gettime(clk_id, tp) {
      // int clock_gettime(clockid_t clk_id, struct timespec *tp);
      var now;
      if (clk_id === 0) {
        now = Date.now();
      } else {
        now = _emscripten_get_now();
      }
      HEAP32[((tp)>>2)]=Math.floor(now/1000); // seconds
      HEAP32[(((tp)+(4))>>2)]=Math.floor((now % 1000)*1000*1000); // nanoseconds
      return 0;
    }

  
  function _tmpnam(s, dir, prefix) {
      // char *tmpnam(char *s);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpnam.html
      // NOTE: The dir and prefix arguments are for internal use only.
      var folder = FS.findObject(dir || '/tmp');
      if (!folder || !folder.isFolder) {
        dir = '/tmp';
        folder = FS.findObject(dir);
        if (!folder || !folder.isFolder) return 0;
      }
      var name = prefix || 'file';
      do {
        name += String.fromCharCode(65 + Math.floor(Math.random() * 25));
      } while (name in folder.contents);
      var result = dir + '/' + name;
      if (!_tmpnam.buffer) _tmpnam.buffer = _malloc(256);
      if (!s) s = _tmpnam.buffer;
      writeAsciiToMemory(result, s);
      return s;
    }function _tmpfile() {
      // FILE *tmpfile(void);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/tmpfile.html
      // TODO: Delete the created file on closing.
      if (_tmpfile.mode) {
        _tmpfile.mode = allocate(intArrayFromString('w+'), 'i8', ALLOC_NORMAL);
      }
      return _fopen(_tmpnam(0), _tmpfile.mode);
    }

  
  function _sscanf(s, format, varargs) {
      // int sscanf(const char *restrict s, const char *restrict format, ... );
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/scanf.html
      var index = 0;
      function get() { return HEAP8[(((s)+(index++))|0)]; };
      function unget() { index--; };
      return __scanString(format, get, unget, varargs);
    }function _vsscanf(s, format, va_arg) {
      return _sscanf(s, format, HEAP32[((va_arg)>>2)]);
    }

  
  
  function __reallyNegative(x) {
      return x < 0 || (x === 0 && (1/x) === -Infinity);
    }function __formatString(format, varargs) {
      var textIndex = format;
      var argIndex = 0;
      function getNextArg(type) {
        // NOTE: Explicitly ignoring type safety. Otherwise this fails:
        //       int x = 4; printf("%c\n", (char)x);
        var ret;
        if (type === 'double') {
          ret = (HEAP32[((tempDoublePtr)>>2)]=HEAP32[(((varargs)+(argIndex))>>2)],HEAP32[(((tempDoublePtr)+(4))>>2)]=HEAP32[(((varargs)+((argIndex)+(4)))>>2)],(+(HEAPF64[(tempDoublePtr)>>3])));
        } else if (type == 'i64') {
          ret = [HEAP32[(((varargs)+(argIndex))>>2)],
                 HEAP32[(((varargs)+(argIndex+4))>>2)]];
  
        } else {
          type = 'i32'; // varargs are always i32, i64, or double
          ret = HEAP32[(((varargs)+(argIndex))>>2)];
        }
        argIndex += Runtime.getNativeFieldSize(type);
        return ret;
      }
  
      var ret = [];
      var curr, next, currArg;
      while(1) {
        var startTextIndex = textIndex;
        curr = HEAP8[(textIndex)];
        if (curr === 0) break;
        next = HEAP8[((textIndex+1)|0)];
        if (curr == 37) {
          // Handle flags.
          var flagAlwaysSigned = false;
          var flagLeftAlign = false;
          var flagAlternative = false;
          var flagZeroPad = false;
          var flagPadSign = false;
          flagsLoop: while (1) {
            switch (next) {
              case 43:
                flagAlwaysSigned = true;
                break;
              case 45:
                flagLeftAlign = true;
                break;
              case 35:
                flagAlternative = true;
                break;
              case 48:
                if (flagZeroPad) {
                  break flagsLoop;
                } else {
                  flagZeroPad = true;
                  break;
                }
              case 32:
                flagPadSign = true;
                break;
              default:
                break flagsLoop;
            }
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          }
  
          // Handle width.
          var width = 0;
          if (next == 42) {
            width = getNextArg('i32');
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
          } else {
            while (next >= 48 && next <= 57) {
              width = width * 10 + (next - 48);
              textIndex++;
              next = HEAP8[((textIndex+1)|0)];
            }
          }
  
          // Handle precision.
          var precisionSet = false, precision = -1;
          if (next == 46) {
            precision = 0;
            precisionSet = true;
            textIndex++;
            next = HEAP8[((textIndex+1)|0)];
            if (next == 42) {
              precision = getNextArg('i32');
              textIndex++;
            } else {
              while(1) {
                var precisionChr = HEAP8[((textIndex+1)|0)];
                if (precisionChr < 48 ||
                    precisionChr > 57) break;
                precision = precision * 10 + (precisionChr - 48);
                textIndex++;
              }
            }
            next = HEAP8[((textIndex+1)|0)];
          }
          if (precision < 0) {
            precision = 6; // Standard default.
            precisionSet = false;
          }
  
          // Handle integer sizes. WARNING: These assume a 32-bit architecture!
          var argSize;
          switch (String.fromCharCode(next)) {
            case 'h':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 104) {
                textIndex++;
                argSize = 1; // char (actually i32 in varargs)
              } else {
                argSize = 2; // short (actually i32 in varargs)
              }
              break;
            case 'l':
              var nextNext = HEAP8[((textIndex+2)|0)];
              if (nextNext == 108) {
                textIndex++;
                argSize = 8; // long long
              } else {
                argSize = 4; // long
              }
              break;
            case 'L': // long long
            case 'q': // int64_t
            case 'j': // intmax_t
              argSize = 8;
              break;
            case 'z': // size_t
            case 't': // ptrdiff_t
            case 'I': // signed ptrdiff_t or unsigned size_t
              argSize = 4;
              break;
            default:
              argSize = null;
          }
          if (argSize) textIndex++;
          next = HEAP8[((textIndex+1)|0)];
  
          // Handle type specifier.
          switch (String.fromCharCode(next)) {
            case 'd': case 'i': case 'u': case 'o': case 'x': case 'X': case 'p': {
              // Integer.
              var signed = next == 100 || next == 105;
              argSize = argSize || 4;
              var currArg = getNextArg('i' + (argSize * 8));
              var origArg = currArg;
              var argText;
              // Flatten i64-1 [low, high] into a (slightly rounded) double
              if (argSize == 8) {
                currArg = Runtime.makeBigInt(currArg[0], currArg[1], next == 117);
              }
              // Truncate to requested size.
              if (argSize <= 4) {
                var limit = Math.pow(256, argSize) - 1;
                currArg = (signed ? reSign : unSign)(currArg & limit, argSize * 8);
              }
              // Format the number.
              var currAbsArg = Math.abs(currArg);
              var prefix = '';
              if (next == 100 || next == 105) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], null); else
                argText = reSign(currArg, 8 * argSize, 1).toString(10);
              } else if (next == 117) {
                if (argSize == 8 && i64Math) argText = i64Math.stringify(origArg[0], origArg[1], true); else
                argText = unSign(currArg, 8 * argSize, 1).toString(10);
                currArg = Math.abs(currArg);
              } else if (next == 111) {
                argText = (flagAlternative ? '0' : '') + currAbsArg.toString(8);
              } else if (next == 120 || next == 88) {
                prefix = (flagAlternative && currArg != 0) ? '0x' : '';
                if (argSize == 8 && i64Math) {
                  if (origArg[1]) {
                    argText = (origArg[1]>>>0).toString(16);
                    var lower = (origArg[0]>>>0).toString(16);
                    while (lower.length < 8) lower = '0' + lower;
                    argText += lower;
                  } else {
                    argText = (origArg[0]>>>0).toString(16);
                  }
                } else
                if (currArg < 0) {
                  // Represent negative numbers in hex as 2's complement.
                  currArg = -currArg;
                  argText = (currAbsArg - 1).toString(16);
                  var buffer = [];
                  for (var i = 0; i < argText.length; i++) {
                    buffer.push((0xF - parseInt(argText[i], 16)).toString(16));
                  }
                  argText = buffer.join('');
                  while (argText.length < argSize * 2) argText = 'f' + argText;
                } else {
                  argText = currAbsArg.toString(16);
                }
                if (next == 88) {
                  prefix = prefix.toUpperCase();
                  argText = argText.toUpperCase();
                }
              } else if (next == 112) {
                if (currAbsArg === 0) {
                  argText = '(nil)';
                } else {
                  prefix = '0x';
                  argText = currAbsArg.toString(16);
                }
              }
              if (precisionSet) {
                while (argText.length < precision) {
                  argText = '0' + argText;
                }
              }
  
              // Add sign if needed
              if (currArg >= 0) {
                if (flagAlwaysSigned) {
                  prefix = '+' + prefix;
                } else if (flagPadSign) {
                  prefix = ' ' + prefix;
                }
              }
  
              // Move sign to prefix so we zero-pad after the sign
              if (argText.charAt(0) == '-') {
                prefix = '-' + prefix;
                argText = argText.substr(1);
              }
  
              // Add padding.
              while (prefix.length + argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad) {
                    argText = '0' + argText;
                  } else {
                    prefix = ' ' + prefix;
                  }
                }
              }
  
              // Insert the result into the buffer.
              argText = prefix + argText;
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 'f': case 'F': case 'e': case 'E': case 'g': case 'G': {
              // Float.
              var currArg = getNextArg('double');
              var argText;
              if (isNaN(currArg)) {
                argText = 'nan';
                flagZeroPad = false;
              } else if (!isFinite(currArg)) {
                argText = (currArg < 0 ? '-' : '') + 'inf';
                flagZeroPad = false;
              } else {
                var isGeneral = false;
                var effectivePrecision = Math.min(precision, 20);
  
                // Convert g/G to f/F or e/E, as per:
                // http://pubs.opengroup.org/onlinepubs/9699919799/functions/printf.html
                if (next == 103 || next == 71) {
                  isGeneral = true;
                  precision = precision || 1;
                  var exponent = parseInt(currArg.toExponential(effectivePrecision).split('e')[1], 10);
                  if (precision > exponent && exponent >= -4) {
                    next = ((next == 103) ? 'f' : 'F').charCodeAt(0);
                    precision -= exponent + 1;
                  } else {
                    next = ((next == 103) ? 'e' : 'E').charCodeAt(0);
                    precision--;
                  }
                  effectivePrecision = Math.min(precision, 20);
                }
  
                if (next == 101 || next == 69) {
                  argText = currArg.toExponential(effectivePrecision);
                  // Make sure the exponent has at least 2 digits.
                  if (/[eE][-+]\d$/.test(argText)) {
                    argText = argText.slice(0, -1) + '0' + argText.slice(-1);
                  }
                } else if (next == 102 || next == 70) {
                  argText = currArg.toFixed(effectivePrecision);
                  if (currArg === 0 && __reallyNegative(currArg)) {
                    argText = '-' + argText;
                  }
                }
  
                var parts = argText.split('e');
                if (isGeneral && !flagAlternative) {
                  // Discard trailing zeros and periods.
                  while (parts[0].length > 1 && parts[0].indexOf('.') != -1 &&
                         (parts[0].slice(-1) == '0' || parts[0].slice(-1) == '.')) {
                    parts[0] = parts[0].slice(0, -1);
                  }
                } else {
                  // Make sure we have a period in alternative mode.
                  if (flagAlternative && argText.indexOf('.') == -1) parts[0] += '.';
                  // Zero pad until required precision.
                  while (precision > effectivePrecision++) parts[0] += '0';
                }
                argText = parts[0] + (parts.length > 1 ? 'e' + parts[1] : '');
  
                // Capitalize 'E' if needed.
                if (next == 69) argText = argText.toUpperCase();
  
                // Add sign.
                if (currArg >= 0) {
                  if (flagAlwaysSigned) {
                    argText = '+' + argText;
                  } else if (flagPadSign) {
                    argText = ' ' + argText;
                  }
                }
              }
  
              // Add padding.
              while (argText.length < width) {
                if (flagLeftAlign) {
                  argText += ' ';
                } else {
                  if (flagZeroPad && (argText[0] == '-' || argText[0] == '+')) {
                    argText = argText[0] + '0' + argText.slice(1);
                  } else {
                    argText = (flagZeroPad ? '0' : ' ') + argText;
                  }
                }
              }
  
              // Adjust case.
              if (next < 97) argText = argText.toUpperCase();
  
              // Insert the result into the buffer.
              argText.split('').forEach(function(chr) {
                ret.push(chr.charCodeAt(0));
              });
              break;
            }
            case 's': {
              // String.
              var arg = getNextArg('i8*');
              var argLength = arg ? _strlen(arg) : '(null)'.length;
              if (precisionSet) argLength = Math.min(argLength, precision);
              if (!flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              if (arg) {
                for (var i = 0; i < argLength; i++) {
                  ret.push(HEAPU8[((arg++)|0)]);
                }
              } else {
                ret = ret.concat(intArrayFromString('(null)'.substr(0, argLength), true));
              }
              if (flagLeftAlign) {
                while (argLength < width--) {
                  ret.push(32);
                }
              }
              break;
            }
            case 'c': {
              // Character.
              if (flagLeftAlign) ret.push(getNextArg('i8'));
              while (--width > 0) {
                ret.push(32);
              }
              if (!flagLeftAlign) ret.push(getNextArg('i8'));
              break;
            }
            case 'n': {
              // Write the length written so far to the next parameter.
              var ptr = getNextArg('i32*');
              HEAP32[((ptr)>>2)]=ret.length;
              break;
            }
            case '%': {
              // Literal percent sign.
              ret.push(curr);
              break;
            }
            default: {
              // Unknown specifiers remain untouched.
              for (var i = startTextIndex; i < textIndex + 2; i++) {
                ret.push(HEAP8[(i)]);
              }
            }
          }
          textIndex += 2;
          // TODO: Support a/A (hex float) and m (last error) specifiers.
          // TODO: Support %1${specifier} for arg selection.
        } else {
          ret.push(curr);
          textIndex += 1;
        }
      }
      return ret;
    }function _snprintf(s, n, format, varargs) {
      // int snprintf(char *restrict s, size_t n, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var limit = (n === undefined) ? result.length
                                    : Math.min(result.length, Math.max(n - 1, 0));
      if (s < 0) {
        s = -s;
        var buf = _malloc(limit+1);
        HEAP32[((s)>>2)]=buf;
        s = buf;
      }
      for (var i = 0; i < limit; i++) {
        HEAP8[(((s)+(i))|0)]=result[i];
      }
      if (limit < n || (n === undefined)) HEAP8[(((s)+(i))|0)]=0;
      return result.length;
    }


  function _pclose(stream) {
      // int pclose(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/pclose.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.ECHILD);
      return -1;
    }

   
  Module["_memset"] = _memset;

  var _BDtoILow=true;


   
  Module["_bitshift64Shl"] = _bitshift64Shl;

  var _llvm_memcpy_p0i8_p0i8_i32=_memcpy;

  function ___assert_fail(condition, filename, line, func) {
      ABORT = true;
      throw 'Assertion failed: ' + Pointer_stringify(condition) + ', at: ' + [filename ? Pointer_stringify(filename) : 'unknown filename', line, func ? Pointer_stringify(func) : 'unknown function'] + ' at ' + stackTrace();
    }

  function _lis_matrix_assemble() {
  Module['printErr']('missing function: lis_matrix_assemble'); abort(-1);
  }

  
  function _isdigit(chr) {
      return chr >= 48 && chr <= 57;
    }function _isdigit_l(chr) {
      return _isdigit(chr); // no locale support yet
    }

  var _emscripten_prep_setjmp=true;


  function _access(path, amode) {
      // int access(const char *path, int amode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/access.html
      path = Pointer_stringify(path);
      if (amode & ~7) {
        // need a valid mode
        ___setErrNo(ERRNO_CODES.EINVAL);
        return -1;
      }
      var node;
      try {
        var lookup = FS.lookupPath(path, { follow: true });
        node = lookup.node;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
      var perms = '';
      if (amode & 4) perms += 'r';
      if (amode & 2) perms += 'w';
      if (amode & 1) perms += 'x';
      if (perms /* otherwise, they've just passed F_OK */ && FS.nodePermissions(node, perms)) {
        ___setErrNo(ERRNO_CODES.EACCES);
        return -1;
      }
      return 0;
    }

  function _ftell(stream) {
      // long ftell(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftell.html
      stream = FS.getStreamFromPtr(stream);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      if (FS.isChrdev(stream.node.mode)) {
        ___setErrNo(ERRNO_CODES.ESPIPE);
        return -1;
      } else {
        return stream.position;
      }
    }

  
  function __exit(status) {
      // void _exit(int status);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/exit.html
      Module['exit'](status);
    }function _exit(status) {
      __exit(status);
    }

  function _sprintf(s, format, varargs) {
      // int sprintf(char *restrict s, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      return _snprintf(s, undefined, format, varargs);
    }

  var _emscripten_get_longjmp_result=true;

  function ___ctype_b_loc() {
      // http://refspecs.freestandards.org/LSB_3.0.0/LSB-Core-generic/LSB-Core-generic/baselib---ctype-b-loc.html
      var me = ___ctype_b_loc;
      if (!me.ret) {
        var values = [
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,2,2,2,2,2,2,2,2,2,8195,8194,8194,8194,8194,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,24577,49156,49156,49156,
          49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,49156,55304,55304,55304,55304,55304,55304,55304,55304,
          55304,55304,49156,49156,49156,49156,49156,49156,49156,54536,54536,54536,54536,54536,54536,50440,50440,50440,50440,50440,
          50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,50440,49156,49156,49156,49156,49156,
          49156,54792,54792,54792,54792,54792,54792,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,50696,
          50696,50696,50696,50696,50696,50696,50696,49156,49156,49156,49156,2,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
          0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
        ];
        var i16size = 2;
        var arr = _malloc(values.length * i16size);
        for (var i = 0; i < values.length; i++) {
          HEAP16[(((arr)+(i * i16size))>>1)]=values[i];
        }
        me.ret = allocate([arr + 128 * i16size], 'i16*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _strrchr(ptr, chr) {
      var ptr2 = ptr + _strlen(ptr);
      do {
        if (HEAP8[(ptr2)] == chr) return ptr2;
        ptr2--;
      } while (ptr2 >= ptr);
      return 0;
    }

  function _freelocale(locale) {
      _free(locale);
    }

  function _catgets(catd, set_id, msg_id, s) {
      // char *catgets (nl_catd catd, int set_id, int msg_id, const char *s)
      return s;
    }

  function _fmod(x, y) {
      return x % y;
    }

  function _fmax(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.max(x, y);
    }

  function _asprintf(s, format, varargs) {
      return _sprintf(-s, format, varargs);
    }

  function _GC_malloc() {
  Module['printErr']('missing function: GC_malloc'); abort(-1);
  }

  function ___cxa_guard_acquire(variable) {
      if (!HEAP8[(variable)]) { // ignore SAFE_HEAP stuff because llvm mixes i64 and i8 here
        HEAP8[(variable)]=1;
        return 1;
      }
      return 0;
    }

  function _lis_vector_destroy() {
  Module['printErr']('missing function: lis_vector_destroy'); abort(-1);
  }

  
  function __ZSt18uncaught_exceptionv() { // std::uncaught_exception()
      return !!__ZSt18uncaught_exceptionv.uncaught_exception;
    }function ___cxa_begin_catch(ptr) {
      __ZSt18uncaught_exceptionv.uncaught_exception--;
      ___cxa_caught_exceptions.push(___cxa_last_thrown_exception);
      return ptr;
    }

  function _lis_vector_create() {
  Module['printErr']('missing function: lis_vector_create'); abort(-1);
  }

  function _lis_matrix_set_type() {
  Module['printErr']('missing function: lis_matrix_set_type'); abort(-1);
  }


  var _cos=Math_cos;

  function _lis_matrix_set_value() {
  Module['printErr']('missing function: lis_matrix_set_value'); abort(-1);
  }



  function __ZNSt9exceptionD2Ev() {}

  function _lis_solver_destroy() {
  Module['printErr']('missing function: lis_solver_destroy'); abort(-1);
  }

  function _popen(command, mode) {
      // FILE *popen(const char *command, const char *mode);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/popen.html
      // We allow only one process, so no pipes.
      ___setErrNo(ERRNO_CODES.EMFILE);
      return 0;
    }

  function _isblank(chr) {
      return chr == 32 || chr == 9;
    }

   
  Module["_strcpy"] = _strcpy;

  function _copysign(a, b) {
      return __reallyNegative(a) === __reallyNegative(b) ? a : -a;
    }

  function _bsearch(key, base, num, size, compar) {
      function cmp(x, y) {
        return Module['dynCall_iii'](compar, x, y);
      };
      var left = 0;
      var right = num;
      var mid, test, addr;
  
      while (left < right) {
        mid = (left + right) >>> 1;
        addr = base + (mid * size);
        test = cmp(key, addr);
        if (test < 0) {
          right = mid;
        } else if (test > 0) {
          left = mid + 1;
        } else {
          return addr;
        }
      }
  
      return 0;
    }

  function _fmin(x, y) {
      return isNaN(x) ? y : isNaN(y) ? x : Math.min(x, y);
    }

  
  var PTHREAD_SPECIFIC_NEXT_KEY=1;function _pthread_key_create(key, destructor) {
      if (key == 0) {
        return ERRNO_CODES.EINVAL;
      }
      HEAP32[((key)>>2)]=PTHREAD_SPECIFIC_NEXT_KEY;
      // values start at 0
      PTHREAD_SPECIFIC[PTHREAD_SPECIFIC_NEXT_KEY] = 0;
      PTHREAD_SPECIFIC_NEXT_KEY++;
      return 0;
    }

  function _lis_vector_get_values() {
  Module['printErr']('missing function: lis_vector_get_values'); abort(-1);
  }


  
  function __isLeapYear(year) {
        return year%4 === 0 && (year%100 !== 0 || year%400 === 0);
    }
  
  function __arraySum(array, index) {
      var sum = 0;
      for (var i = 0; i <= index; sum += array[i++]);
      return sum;
    }
  
  
  var __MONTH_DAYS_LEAP=[31,29,31,30,31,30,31,31,30,31,30,31];
  
  var __MONTH_DAYS_REGULAR=[31,28,31,30,31,30,31,31,30,31,30,31];function __addDays(date, days) {
      var newDate = new Date(date.getTime());
      while(days > 0) {
        var leap = __isLeapYear(newDate.getFullYear());
        var currentMonth = newDate.getMonth();
        var daysInCurrentMonth = (leap ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR)[currentMonth];
  
        if (days > daysInCurrentMonth-newDate.getDate()) {
          // we spill over to next month
          days -= (daysInCurrentMonth-newDate.getDate()+1);
          newDate.setDate(1);
          if (currentMonth < 11) {
            newDate.setMonth(currentMonth+1)
          } else {
            newDate.setMonth(0);
            newDate.setFullYear(newDate.getFullYear()+1);
          }
        } else {
          // we stay in current month 
          newDate.setDate(newDate.getDate()+days);
          return newDate;
        }
      }
  
      return newDate;
    }function _strftime(s, maxsize, format, tm) {
      // size_t strftime(char *restrict s, size_t maxsize, const char *restrict format, const struct tm *restrict timeptr);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/strftime.html
      
      var date = {
        tm_sec: HEAP32[((tm)>>2)],
        tm_min: HEAP32[(((tm)+(4))>>2)],
        tm_hour: HEAP32[(((tm)+(8))>>2)],
        tm_mday: HEAP32[(((tm)+(12))>>2)],
        tm_mon: HEAP32[(((tm)+(16))>>2)],
        tm_year: HEAP32[(((tm)+(20))>>2)],
        tm_wday: HEAP32[(((tm)+(24))>>2)],
        tm_yday: HEAP32[(((tm)+(28))>>2)],
        tm_isdst: HEAP32[(((tm)+(32))>>2)]
      };
  
      var pattern = Pointer_stringify(format);
  
      // expand format
      var EXPANSION_RULES_1 = {
        '%c': '%a %b %d %H:%M:%S %Y',     // Replaced by the locale's appropriate date and time representation - e.g., Mon Aug  3 14:02:01 2013
        '%D': '%m/%d/%y',                 // Equivalent to %m / %d / %y
        '%F': '%Y-%m-%d',                 // Equivalent to %Y - %m - %d
        '%h': '%b',                       // Equivalent to %b
        '%r': '%I:%M:%S %p',              // Replaced by the time in a.m. and p.m. notation
        '%R': '%H:%M',                    // Replaced by the time in 24-hour notation
        '%T': '%H:%M:%S',                 // Replaced by the time
        '%x': '%m/%d/%y',                 // Replaced by the locale's appropriate date representation
        '%X': '%H:%M:%S',                 // Replaced by the locale's appropriate date representation
      };
      for (var rule in EXPANSION_RULES_1) {
        pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_1[rule]);
      }
  
      var WEEKDAYS = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
      var MONTHS = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];
  
      function leadingSomething(value, digits, character) {
        var str = typeof value === 'number' ? value.toString() : (value || '');
        while (str.length < digits) {
          str = character[0]+str;
        }
        return str;
      };
  
      function leadingNulls(value, digits) {
        return leadingSomething(value, digits, '0');
      };
  
      function compareByDay(date1, date2) {
        function sgn(value) {
          return value < 0 ? -1 : (value > 0 ? 1 : 0);
        };
  
        var compare;
        if ((compare = sgn(date1.getFullYear()-date2.getFullYear())) === 0) {
          if ((compare = sgn(date1.getMonth()-date2.getMonth())) === 0) {
            compare = sgn(date1.getDate()-date2.getDate());
          }
        }
        return compare;
      };
  
      function getFirstWeekStartDate(janFourth) {
          switch (janFourth.getDay()) {
            case 0: // Sunday
              return new Date(janFourth.getFullYear()-1, 11, 29);
            case 1: // Monday
              return janFourth;
            case 2: // Tuesday
              return new Date(janFourth.getFullYear(), 0, 3);
            case 3: // Wednesday
              return new Date(janFourth.getFullYear(), 0, 2);
            case 4: // Thursday
              return new Date(janFourth.getFullYear(), 0, 1);
            case 5: // Friday
              return new Date(janFourth.getFullYear()-1, 11, 31);
            case 6: // Saturday
              return new Date(janFourth.getFullYear()-1, 11, 30);
          }
      };
  
      function getWeekBasedYear(date) {
          var thisDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          var janFourthThisYear = new Date(thisDate.getFullYear(), 0, 4);
          var janFourthNextYear = new Date(thisDate.getFullYear()+1, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          if (compareByDay(firstWeekStartThisYear, thisDate) <= 0) {
            // this date is after the start of the first week of this year
            if (compareByDay(firstWeekStartNextYear, thisDate) <= 0) {
              return thisDate.getFullYear()+1;
            } else {
              return thisDate.getFullYear();
            }
          } else { 
            return thisDate.getFullYear()-1;
          }
      };
  
      var EXPANSION_RULES_2 = {
        '%a': function(date) {
          return WEEKDAYS[date.tm_wday].substring(0,3);
        },
        '%A': function(date) {
          return WEEKDAYS[date.tm_wday];
        },
        '%b': function(date) {
          return MONTHS[date.tm_mon].substring(0,3);
        },
        '%B': function(date) {
          return MONTHS[date.tm_mon];
        },
        '%C': function(date) {
          var year = date.tm_year+1900;
          return leadingNulls(Math.floor(year/100),2);
        },
        '%d': function(date) {
          return leadingNulls(date.tm_mday, 2);
        },
        '%e': function(date) {
          return leadingSomething(date.tm_mday, 2, ' ');
        },
        '%g': function(date) {
          // %g, %G, and %V give values according to the ISO 8601:2000 standard week-based year. 
          // In this system, weeks begin on a Monday and week 1 of the year is the week that includes 
          // January 4th, which is also the week that includes the first Thursday of the year, and 
          // is also the first week that contains at least four days in the year. 
          // If the first Monday of January is the 2nd, 3rd, or 4th, the preceding days are part of 
          // the last week of the preceding year; thus, for Saturday 2nd January 1999, 
          // %G is replaced by 1998 and %V is replaced by 53. If December 29th, 30th, 
          // or 31st is a Monday, it and any following days are part of week 1 of the following year. 
          // Thus, for Tuesday 30th December 1997, %G is replaced by 1998 and %V is replaced by 01.
          
          return getWeekBasedYear(date).toString().substring(2);
        },
        '%G': function(date) {
          return getWeekBasedYear(date);
        },
        '%H': function(date) {
          return leadingNulls(date.tm_hour, 2);
        },
        '%I': function(date) {
          return leadingNulls(date.tm_hour < 13 ? date.tm_hour : date.tm_hour-12, 2);
        },
        '%j': function(date) {
          // Day of the year (001-366)
          return leadingNulls(date.tm_mday+__arraySum(__isLeapYear(date.tm_year+1900) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, date.tm_mon-1), 3);
        },
        '%m': function(date) {
          return leadingNulls(date.tm_mon+1, 2);
        },
        '%M': function(date) {
          return leadingNulls(date.tm_min, 2);
        },
        '%n': function() {
          return '\n';
        },
        '%p': function(date) {
          if (date.tm_hour > 0 && date.tm_hour < 13) {
            return 'AM';
          } else {
            return 'PM';
          }
        },
        '%S': function(date) {
          return leadingNulls(date.tm_sec, 2);
        },
        '%t': function() {
          return '\t';
        },
        '%u': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay() || 7;
        },
        '%U': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Sunday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year+1900, 0, 1);
          var firstSunday = janFirst.getDay() === 0 ? janFirst : __addDays(janFirst, 7-janFirst.getDay());
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
          
          // is target date after the first Sunday?
          if (compareByDay(firstSunday, endDate) < 0) {
            // calculate difference in days between first Sunday and endDate
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstSundayUntilEndJanuary = 31-firstSunday.getDate();
            var days = firstSundayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
  
          return compareByDay(firstSunday, janFirst) === 0 ? '01': '00';
        },
        '%V': function(date) {
          // Replaced by the week number of the year (Monday as the first day of the week) 
          // as a decimal number [01,53]. If the week containing 1 January has four 
          // or more days in the new year, then it is considered week 1. 
          // Otherwise, it is the last week of the previous year, and the next week is week 1. 
          // Both January 4th and the first Thursday of January are always in week 1. [ tm_year, tm_wday, tm_yday]
          var janFourthThisYear = new Date(date.tm_year+1900, 0, 4);
          var janFourthNextYear = new Date(date.tm_year+1901, 0, 4);
  
          var firstWeekStartThisYear = getFirstWeekStartDate(janFourthThisYear);
          var firstWeekStartNextYear = getFirstWeekStartDate(janFourthNextYear);
  
          var endDate = __addDays(new Date(date.tm_year+1900, 0, 1), date.tm_yday);
  
          if (compareByDay(endDate, firstWeekStartThisYear) < 0) {
            // if given date is before this years first week, then it belongs to the 53rd week of last year
            return '53';
          } 
  
          if (compareByDay(firstWeekStartNextYear, endDate) <= 0) {
            // if given date is after next years first week, then it belongs to the 01th week of next year
            return '01';
          }
  
          // given date is in between CW 01..53 of this calendar year
          var daysDifference;
          if (firstWeekStartThisYear.getFullYear() < date.tm_year+1900) {
            // first CW of this year starts last year
            daysDifference = date.tm_yday+32-firstWeekStartThisYear.getDate()
          } else {
            // first CW of this year starts this year
            daysDifference = date.tm_yday+1-firstWeekStartThisYear.getDate();
          }
          return leadingNulls(Math.ceil(daysDifference/7), 2);
        },
        '%w': function(date) {
          var day = new Date(date.tm_year+1900, date.tm_mon+1, date.tm_mday, 0, 0, 0, 0);
          return day.getDay();
        },
        '%W': function(date) {
          // Replaced by the week number of the year as a decimal number [00,53]. 
          // The first Monday of January is the first day of week 1; 
          // days in the new year before this are in week 0. [ tm_year, tm_wday, tm_yday]
          var janFirst = new Date(date.tm_year, 0, 1);
          var firstMonday = janFirst.getDay() === 1 ? janFirst : __addDays(janFirst, janFirst.getDay() === 0 ? 1 : 7-janFirst.getDay()+1);
          var endDate = new Date(date.tm_year+1900, date.tm_mon, date.tm_mday);
  
          // is target date after the first Monday?
          if (compareByDay(firstMonday, endDate) < 0) {
            var februaryFirstUntilEndMonth = __arraySum(__isLeapYear(endDate.getFullYear()) ? __MONTH_DAYS_LEAP : __MONTH_DAYS_REGULAR, endDate.getMonth()-1)-31;
            var firstMondayUntilEndJanuary = 31-firstMonday.getDate();
            var days = firstMondayUntilEndJanuary+februaryFirstUntilEndMonth+endDate.getDate();
            return leadingNulls(Math.ceil(days/7), 2);
          }
          return compareByDay(firstMonday, janFirst) === 0 ? '01': '00';
        },
        '%y': function(date) {
          // Replaced by the last two digits of the year as a decimal number [00,99]. [ tm_year]
          return (date.tm_year+1900).toString().substring(2);
        },
        '%Y': function(date) {
          // Replaced by the year as a decimal number (for example, 1997). [ tm_year]
          return date.tm_year+1900;
        },
        '%z': function(date) {
          // Replaced by the offset from UTC in the ISO 8601:2000 standard format ( +hhmm or -hhmm ),
          // or by no characters if no timezone is determinable. 
          // For example, "-0430" means 4 hours 30 minutes behind UTC (west of Greenwich). 
          // If tm_isdst is zero, the standard time offset is used. 
          // If tm_isdst is greater than zero, the daylight savings time offset is used. 
          // If tm_isdst is negative, no characters are returned. 
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%Z': function(date) {
          // Replaced by the timezone name or abbreviation, or by no bytes if no timezone information exists. [ tm_isdst]
          // FIXME: we cannot determine time zone (or can we?)
          return '';
        },
        '%%': function() {
          return '%';
        }
      };
      for (var rule in EXPANSION_RULES_2) {
        if (pattern.indexOf(rule) >= 0) {
          pattern = pattern.replace(new RegExp(rule, 'g'), EXPANSION_RULES_2[rule](date));
        }
      }
  
      var bytes = intArrayFromString(pattern, false);
      if (bytes.length > maxsize) {
        return 0;
      } 
  
      writeArrayToMemory(bytes, s);
      return bytes.length-1;
    }

  
  function _atexit(func, arg) {
      __ATEXIT__.unshift({ func: func, arg: arg });
    }var ___cxa_atexit=_atexit;

  
   
  Module["_rand_r"] = _rand_r;
  
  var ___rand_seed=allocate([0x0273459b, 0, 0, 0], "i32", ALLOC_STATIC); 
  Module["_rand"] = _rand;

  var _llvm_memset_p0i8_i32=_memset;

   
  Module["_i64Subtract"] = _i64Subtract;

   
  Module["_i64Add"] = _i64Add;

  var _pow=Math_pow;

  
  
  
  function ___cxa_is_number_type(type) {
      var isNumber = false;
      try { if (type == __ZTIi) isNumber = true } catch(e){}
      try { if (type == __ZTIj) isNumber = true } catch(e){}
      try { if (type == __ZTIl) isNumber = true } catch(e){}
      try { if (type == __ZTIm) isNumber = true } catch(e){}
      try { if (type == __ZTIx) isNumber = true } catch(e){}
      try { if (type == __ZTIy) isNumber = true } catch(e){}
      try { if (type == __ZTIf) isNumber = true } catch(e){}
      try { if (type == __ZTId) isNumber = true } catch(e){}
      try { if (type == __ZTIe) isNumber = true } catch(e){}
      try { if (type == __ZTIc) isNumber = true } catch(e){}
      try { if (type == __ZTIa) isNumber = true } catch(e){}
      try { if (type == __ZTIh) isNumber = true } catch(e){}
      try { if (type == __ZTIs) isNumber = true } catch(e){}
      try { if (type == __ZTIt) isNumber = true } catch(e){}
      return isNumber;
    }function ___cxa_does_inherit(definiteType, possibilityType, possibility) {
      if (possibility == 0) return false;
      if (possibilityType == 0 || possibilityType == definiteType)
        return true;
      var possibility_type_info;
      if (___cxa_is_number_type(possibilityType)) {
        possibility_type_info = possibilityType;
      } else {
        var possibility_type_infoAddr = HEAP32[((possibilityType)>>2)] - 8;
        possibility_type_info = HEAP32[((possibility_type_infoAddr)>>2)];
      }
      switch (possibility_type_info) {
      case 0: // possibility is a pointer
        // See if definite type is a pointer
        var definite_type_infoAddr = HEAP32[((definiteType)>>2)] - 8;
        var definite_type_info = HEAP32[((definite_type_infoAddr)>>2)];
        if (definite_type_info == 0) {
          // Also a pointer; compare base types of pointers
          var defPointerBaseAddr = definiteType+8;
          var defPointerBaseType = HEAP32[((defPointerBaseAddr)>>2)];
          var possPointerBaseAddr = possibilityType+8;
          var possPointerBaseType = HEAP32[((possPointerBaseAddr)>>2)];
          return ___cxa_does_inherit(defPointerBaseType, possPointerBaseType, possibility);
        } else
          return false; // one pointer and one non-pointer
      case 1: // class with no base class
        return false;
      case 2: // class with base class
        var parentTypeAddr = possibilityType + 8;
        var parentType = HEAP32[((parentTypeAddr)>>2)];
        return ___cxa_does_inherit(definiteType, parentType, possibility);
      default:
        return false; // some unencountered type
      }
    }
  
  function ___resumeException(ptr) {
      if (!___cxa_last_thrown_exception) { ___cxa_last_thrown_exception = ptr; }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }function ___cxa_find_matching_catch(thrown, throwntype) {
      if (thrown == -1) thrown = ___cxa_last_thrown_exception;
      header = thrown - ___cxa_exception_header_size;
      if (throwntype == -1) throwntype = HEAP32[((header)>>2)];
      var typeArray = Array.prototype.slice.call(arguments, 2);
  
      // If throwntype is a pointer, this means a pointer has been
      // thrown. When a pointer is thrown, actually what's thrown
      // is a pointer to the pointer. We'll dereference it.
      if (throwntype != 0 && !___cxa_is_number_type(throwntype)) {
        var throwntypeInfoAddr= HEAP32[((throwntype)>>2)] - 8;
        var throwntypeInfo= HEAP32[((throwntypeInfoAddr)>>2)];
        if (throwntypeInfo == 0)
          thrown = HEAP32[((thrown)>>2)];
      }
      // The different catch blocks are denoted by different types.
      // Due to inheritance, those types may not precisely match the
      // type of the thrown object. Find one which matches, and
      // return the type of the catch block which should be called.
      for (var i = 0; i < typeArray.length; i++) {
        if (___cxa_does_inherit(typeArray[i], throwntype, thrown))
          return ((asm["setTempRet0"](typeArray[i]),thrown)|0);
      }
      // Shouldn't happen unless we have bogus data in typeArray
      // or encounter a type for which emscripten doesn't have suitable
      // typeinfo defined. Best-efforts match just in case.
      return ((asm["setTempRet0"](throwntype),thrown)|0);
    }function ___cxa_throw(ptr, type, destructor) {
      if (!___cxa_throw.initialized) {
        try {
          HEAP32[((__ZTVN10__cxxabiv119__pointer_type_infoE)>>2)]=0; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv117__class_type_infoE)>>2)]=1; // Workaround for libcxxabi integration bug
        } catch(e){}
        try {
          HEAP32[((__ZTVN10__cxxabiv120__si_class_type_infoE)>>2)]=2; // Workaround for libcxxabi integration bug
        } catch(e){}
        ___cxa_throw.initialized = true;
      }
      var header = ptr - ___cxa_exception_header_size;
      HEAP32[((header)>>2)]=type;
      HEAP32[(((header)+(4))>>2)]=destructor;
      ___cxa_last_thrown_exception = ptr;
      if (!("uncaught_exception" in __ZSt18uncaught_exceptionv)) {
        __ZSt18uncaught_exceptionv.uncaught_exception = 1;
      } else {
        __ZSt18uncaught_exceptionv.uncaught_exception++;
      }
      throw ptr + " - Exception catching is disabled, this exception cannot be caught. Compile with -s DISABLE_EXCEPTION_CATCHING=0 or DISABLE_EXCEPTION_CATCHING=2 to catch.";
    }

  function _lis_vector_set_value() {
  Module['printErr']('missing function: lis_vector_set_value'); abort(-1);
  }


  
  function _fprintf(stream, format, varargs) {
      // int fprintf(FILE *restrict stream, const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var result = __formatString(format, varargs);
      var stack = Runtime.stackSave();
      var ret = _fwrite(allocate(result, 'i8', ALLOC_STACK), 1, result.length, stream);
      Runtime.stackRestore(stack);
      return ret;
    }function _printf(format, varargs) {
      // int printf(const char *restrict format, ...);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/printf.html
      var stdout = HEAP32[((_stdout)>>2)];
      return _fprintf(stdout, format, varargs);
    }

  function _htonl(value) {
      return ((value & 0xff) << 24) + ((value & 0xff00) << 8) +
             ((value & 0xff0000) >>> 8) + ((value & 0xff000000) >>> 24);
    }


  function _lis_solve() {
  Module['printErr']('missing function: lis_solve'); abort(-1);
  }

   
  Module["_strncpy"] = _strncpy;

  function _strtoull_l(str, endptr, base) {
      return _strtoull(str, endptr, base); // no locale support yet
    }

  var _log=Math_log;

  var _emscripten_postinvoke=true;

  function _xerbla_() {
  Module['printErr']('missing function: xerbla_'); abort(-1);
  }

  var _copysignl=_copysign;

  
  function _strtoll(str, endptr, base) {
      return __parseInt64(str, endptr, base, '-9223372036854775808', '9223372036854775807');  // LLONG_MIN, LLONG_MAX.
    }function _strtoll_l(str, endptr, base) {
      return _strtoll(str, endptr, base); // no locale support yet
    }

  function _qsort(base, num, size, cmp) {
      if (num == 0 || size == 0) return;
      // forward calls to the JavaScript sort method
      // first, sort the items logically
      var keys = [];
      for (var i = 0; i < num; i++) keys.push(i);
      keys.sort(function(a, b) {
        return Module['dynCall_iii'](cmp, base+a*size, base+b*size);
      });
      // apply the sort
      var temp = _malloc(num*size);
      _memcpy(temp, base, num*size);
      for (var i = 0; i < num; i++) {
        if (keys[i] == i) continue; // already in place
        _memcpy(base+i*size, temp+keys[i]*size, size);
      }
      _free(temp);
    }

  function _system(command) {
      // int system(const char *command);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/system.html
      // Can't call external programs.
      ___setErrNo(ERRNO_CODES.EAGAIN);
      return -1;
    }

  function _lis_matrix_create() {
  Module['printErr']('missing function: lis_matrix_create'); abort(-1);
  }

  function _strdup(ptr) {
      var len = _strlen(ptr);
      var newStr = _malloc(len + 1);
      (_memcpy(newStr, ptr, len)|0);
      HEAP8[(((newStr)+(len))|0)]=0;
      return newStr;
    }

   
  Module["_bitshift64Lshr"] = _bitshift64Lshr;

  function _srand(seed) {
      HEAP32[((___rand_seed)>>2)]=seed
    }

  function _isatty(fildes) {
      // int isatty(int fildes);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/isatty.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return 0;
      }
      // HACK - implement tcgetattr
      if (!stream.tty) {
        ___setErrNo(ERRNO_CODES.ENOTTY);
        return 0;
      }
      return 1;
    }

  var _putc=_fputc;

  var _BDtoIHigh=true;

  function _pthread_cond_broadcast() {
      return 0;
    }

  
  
   
  Module["_testSetjmp"] = _testSetjmp;function _longjmp(env, value) {
      asm['setThrew'](env, value || 1);
      throw 'longjmp';
    }function _emscripten_longjmp(env, value) {
      _longjmp(env, value);
    }

  function __ZSt9terminatev() {
      _exit(-1234);
    }

  var _fseeko=_fseek;

  function _lis_matrix_set_size() {
  Module['printErr']('missing function: lis_matrix_set_size'); abort(-1);
  }

  function _vfprintf(s, f, va_arg) {
      return _fprintf(s, f, HEAP32[((va_arg)>>2)]);
    }

  
  function _atoi(ptr) {
      return _strtol(ptr, null, 10);
    }var _atol=_atoi;

  function _pthread_mutex_unlock() {}

  function _sbrk(bytes) {
      // Implement a Linux-like 'memory area' for our 'process'.
      // Changes the size of the memory area by |bytes|; returns the
      // address of the previous top ('break') of the memory area
      // We control the "dynamic" memory - DYNAMIC_BASE to DYNAMICTOP
      var self = _sbrk;
      if (!self.called) {
        DYNAMICTOP = alignMemoryPage(DYNAMICTOP); // make sure we start out aligned
        self.called = true;
        assert(Runtime.dynamicAlloc);
        self.alloc = Runtime.dynamicAlloc;
        Runtime.dynamicAlloc = function() { abort('cannot dynamically allocate, sbrk now has control') };
      }
      var ret = DYNAMICTOP;
      if (bytes != 0) self.alloc(bytes);
      return ret;  // Previous break location.
    }



  var _BItoD=true;

  
  function _stat(path, buf, dontResolveLastLink) {
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/stat.html
      // int stat(const char *path, struct stat *buf);
      // NOTE: dontResolveLastLink is a shortcut for lstat(). It should never be
      //       used in client code.
      path = typeof path !== 'string' ? Pointer_stringify(path) : path;
      try {
        var stat = dontResolveLastLink ? FS.lstat(path) : FS.stat(path);
        HEAP32[((buf)>>2)]=stat.dev;
        HEAP32[(((buf)+(4))>>2)]=0;
        HEAP32[(((buf)+(8))>>2)]=stat.ino;
        HEAP32[(((buf)+(12))>>2)]=stat.mode;
        HEAP32[(((buf)+(16))>>2)]=stat.nlink;
        HEAP32[(((buf)+(20))>>2)]=stat.uid;
        HEAP32[(((buf)+(24))>>2)]=stat.gid;
        HEAP32[(((buf)+(28))>>2)]=stat.rdev;
        HEAP32[(((buf)+(32))>>2)]=0;
        HEAP32[(((buf)+(36))>>2)]=stat.size;
        HEAP32[(((buf)+(40))>>2)]=4096;
        HEAP32[(((buf)+(44))>>2)]=stat.blocks;
        HEAP32[(((buf)+(48))>>2)]=Math.floor(stat.atime.getTime() / 1000);
        HEAP32[(((buf)+(52))>>2)]=0;
        HEAP32[(((buf)+(56))>>2)]=Math.floor(stat.mtime.getTime() / 1000);
        HEAP32[(((buf)+(60))>>2)]=0;
        HEAP32[(((buf)+(64))>>2)]=Math.floor(stat.ctime.getTime() / 1000);
        HEAP32[(((buf)+(68))>>2)]=0;
        HEAP32[(((buf)+(72))>>2)]=stat.ino;
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _fstat(fildes, buf) {
      // int fstat(int fildes, struct stat *buf);
      // http://pubs.opengroup.org/onlinepubs/7908799/xsh/fstat.html
      var stream = FS.getStream(fildes);
      if (!stream) {
        ___setErrNo(ERRNO_CODES.EBADF);
        return -1;
      }
      return _stat(stream.path, buf);
    }

  function _catclose(catd) {
      // int catclose (nl_catd catd)
      return 0;
    }

  function _llvm_lifetime_start() {}

  function ___cxa_guard_release() {}


  
  function _truncate(path, length) {
      // int truncate(const char *path, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/truncate.html
      // NOTE: The path argument may be a string, to simplify ftruncate().
      if (typeof path !== 'string') path = Pointer_stringify(path);
      try {
        FS.truncate(path, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }function _ftruncate(fildes, length) {
      // int ftruncate(int fildes, off_t length);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/ftruncate.html
      try {
        FS.ftruncate(fildes, length);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  function _uselocale(locale) {
      return 0;
    }

  function _vsnprintf(s, n, format, va_arg) {
      return _snprintf(s, n, format, HEAP32[((va_arg)>>2)]);
    }


  function _sysconf(name) {
      // long sysconf(int name);
      // http://pubs.opengroup.org/onlinepubs/009695399/functions/sysconf.html
      switch(name) {
        case 30: return PAGE_SIZE;
        case 132:
        case 133:
        case 12:
        case 137:
        case 138:
        case 15:
        case 235:
        case 16:
        case 17:
        case 18:
        case 19:
        case 20:
        case 149:
        case 13:
        case 10:
        case 236:
        case 153:
        case 9:
        case 21:
        case 22:
        case 159:
        case 154:
        case 14:
        case 77:
        case 78:
        case 139:
        case 80:
        case 81:
        case 79:
        case 82:
        case 68:
        case 67:
        case 164:
        case 11:
        case 29:
        case 47:
        case 48:
        case 95:
        case 52:
        case 51:
        case 46:
          return 200809;
        case 27:
        case 246:
        case 127:
        case 128:
        case 23:
        case 24:
        case 160:
        case 161:
        case 181:
        case 182:
        case 242:
        case 183:
        case 184:
        case 243:
        case 244:
        case 245:
        case 165:
        case 178:
        case 179:
        case 49:
        case 50:
        case 168:
        case 169:
        case 175:
        case 170:
        case 171:
        case 172:
        case 97:
        case 76:
        case 32:
        case 173:
        case 35:
          return -1;
        case 176:
        case 177:
        case 7:
        case 155:
        case 8:
        case 157:
        case 125:
        case 126:
        case 92:
        case 93:
        case 129:
        case 130:
        case 131:
        case 94:
        case 91:
          return 1;
        case 74:
        case 60:
        case 69:
        case 70:
        case 4:
          return 1024;
        case 31:
        case 42:
        case 72:
          return 32;
        case 87:
        case 26:
        case 33:
          return 2147483647;
        case 34:
        case 1:
          return 47839;
        case 38:
        case 36:
          return 99;
        case 43:
        case 37:
          return 2048;
        case 0: return 2097152;
        case 3: return 65536;
        case 28: return 32768;
        case 44: return 32767;
        case 75: return 16384;
        case 39: return 1000;
        case 89: return 700;
        case 71: return 256;
        case 40: return 255;
        case 2: return 100;
        case 180: return 64;
        case 25: return 20;
        case 5: return 16;
        case 6: return 6;
        case 73: return 4;
        case 84: return 1;
      }
      ___setErrNo(ERRNO_CODES.EINVAL);
      return -1;
    }

  var _llvm_memmove_p0i8_p0i8_i32=_memmove;

  var _ftello=_ftell;

  function _strftime_l(s, maxsize, format, tm) {
      return _strftime(s, maxsize, format, tm); // no locale support yet
    }

  function _abort() {
      Module['abort']();
    }





  function _pthread_getspecific(key) {
      return PTHREAD_SPECIFIC[key] || 0;
    }

  var _fabs=Math_abs;

  var _floor=Math_floor;

  var _getc=_fgetc;

  var _sqrt=Math_sqrt;

  function _rewind(stream) {
      // void rewind(FILE *stream);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/rewind.html
      _fseek(stream, 0, 0);  // SEEK_SET.
      var streamObj = FS.getStreamFromPtr(stream);
      if (streamObj) streamObj.error = false;
    }

  function ___cxa_allocate_exception(size) {
      var ptr = _malloc(size + ___cxa_exception_header_size);
      return ptr + ___cxa_exception_header_size;
    }

  var _sin=Math_sin;

  var _fmodl=_fmod;



  function _vasprintf(s, format, va_arg) {
      return _asprintf(s, format, HEAP32[((va_arg)>>2)]);
    }

  function _catopen(name, oflag) {
      // nl_catd catopen (const char *name, int oflag)
      return -1;
    }

  function ___ctype_toupper_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-toupper-loc.html
      var me = ___ctype_toupper_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,
          73,74,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
          81,82,83,84,85,86,87,88,89,90,123,124,125,126,127,128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,
          145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,
          175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,
          205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,
          235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_matrix_destroy() {
  Module['printErr']('missing function: lis_matrix_destroy'); abort(-1);
  }

  function ___ctype_tolower_loc() {
      // http://refspecs.freestandards.org/LSB_3.1.1/LSB-Core-generic/LSB-Core-generic/libutil---ctype-tolower-loc.html
      var me = ___ctype_tolower_loc;
      if (!me.ret) {
        var values = [
          128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,
          158,159,160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,
          188,189,190,191,192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,
          218,219,220,221,222,223,224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,
          248,249,250,251,252,253,254,-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,
          33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,91,92,93,94,95,96,97,98,99,100,101,102,103,
          104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,131,132,133,
          134,135,136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,160,161,162,163,
          164,165,166,167,168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,192,193,
          194,195,196,197,198,199,200,201,202,203,204,205,206,207,208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
          224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,240,241,242,243,244,245,246,247,248,249,250,251,252,253,
          254,255
        ];
        var i32size = 4;
        var arr = _malloc(values.length * i32size);
        for (var i = 0; i < values.length; i++) {
          HEAP32[(((arr)+(i * i32size))>>2)]=values[i];
        }
        me.ret = allocate([arr + 128 * i32size], 'i32*', ALLOC_NORMAL);
      }
      return me.ret;
    }

  function _lis_vector_set_size() {
  Module['printErr']('missing function: lis_vector_set_size'); abort(-1);
  }

  function _unlink(path) {
      // int unlink(const char *path);
      // http://pubs.opengroup.org/onlinepubs/000095399/functions/unlink.html
      path = Pointer_stringify(path);
      try {
        FS.unlink(path);
        return 0;
      } catch (e) {
        FS.handleFSError(e);
        return -1;
      }
    }

  var _emscripten_setjmp=true;

  function _GC_collect_a_little() {
  Module['printErr']('missing function: GC_collect_a_little'); abort(-1);
  }


  function _lis_solver_set_option() {
  Module['printErr']('missing function: lis_solver_set_option'); abort(-1);
  }

  function _time(ptr) {
      var ret = Math.floor(Date.now()/1000);
      if (ptr) {
        HEAP32[((ptr)>>2)]=ret;
      }
      return ret;
    }

  var __ZTISt9exception=allocate([allocate([1,0,0,0,0,0,0], "i8", ALLOC_STATIC)+8, 0], "i32", ALLOC_STATIC);

  var ___dso_handle=allocate(1, "i32*", ALLOC_STATIC);



FS.staticInit();__ATINIT__.unshift({ func: function() { if (!Module["noFSInit"] && !FS.init.initialized) FS.init() } });__ATMAIN__.push({ func: function() { FS.ignorePermissions = false } });__ATEXIT__.push({ func: function() { FS.quit() } });Module["FS_createFolder"] = FS.createFolder;Module["FS_createPath"] = FS.createPath;Module["FS_createDataFile"] = FS.createDataFile;Module["FS_createPreloadedFile"] = FS.createPreloadedFile;Module["FS_createLazyFile"] = FS.createLazyFile;Module["FS_createLink"] = FS.createLink;Module["FS_createDevice"] = FS.createDevice;
___errno_state = Runtime.staticAlloc(4); HEAP32[((___errno_state)>>2)]=0;
__ATINIT__.unshift({ func: function() { TTY.init() } });__ATEXIT__.push({ func: function() { TTY.shutdown() } });TTY.utf8 = new Runtime.UTF8Processor();
if (ENVIRONMENT_IS_NODE) { var fs = require("fs"); NODEFS.staticInit(); }
_fputc.ret = allocate([0], "i8", ALLOC_STATIC);
__ATINIT__.push({ func: function() { SOCKFS.root = FS.mount(SOCKFS, {}, null); } });
___strtok_state = Runtime.staticAlloc(4);
Module["requestFullScreen"] = function Module_requestFullScreen(lockPointer, resizeCanvas) { Browser.requestFullScreen(lockPointer, resizeCanvas) };
  Module["requestAnimationFrame"] = function Module_requestAnimationFrame(func) { Browser.requestAnimationFrame(func) };
  Module["setCanvasSize"] = function Module_setCanvasSize(width, height, noUpdates) { Browser.setCanvasSize(width, height, noUpdates) };
  Module["pauseMainLoop"] = function Module_pauseMainLoop() { Browser.mainLoop.pause() };
  Module["resumeMainLoop"] = function Module_resumeMainLoop() { Browser.mainLoop.resume() };
  Module["getUserMedia"] = function Module_getUserMedia() { Browser.getUserMedia() }
_fgetc.ret = allocate([0], "i8", ALLOC_STATIC);
STACK_BASE = STACKTOP = Runtime.alignMemory(STATICTOP);

staticSealed = true; // seal the static portion of memory

STACK_MAX = STACK_BASE + 5242880;

DYNAMIC_BASE = DYNAMICTOP = Runtime.alignMemory(STACK_MAX);

assert(DYNAMIC_BASE < TOTAL_MEMORY, "TOTAL_MEMORY not big enough for stack");

 var ctlz_i8 = allocate([8,7,6,6,5,5,5,5,4,4,4,4,4,4,4,4,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0], "i8", ALLOC_DYNAMIC);
 var cttz_i8 = allocate([8,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,7,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,6,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,5,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0,4,0,1,0,2,0,1,0,3,0,1,0,2,0,1,0], "i8", ALLOC_DYNAMIC);

var Math_min = Math.min;
function invoke_iiiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    return Module["dynCall_iiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiidiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vd(index,a1) {
  try {
    Module["dynCall_vd"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vi(index,a1) {
  try {
    Module["dynCall_vi"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_vii(index,a1,a2) {
  try {
    Module["dynCall_vii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10) {
  try {
    return Module["dynCall_iiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_ii(index,a1) {
  try {
    return Module["dynCall_ii"](index,a1);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidi(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viidi"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13) {
  try {
    return Module["dynCall_iiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiii(index,a1,a2,a3) {
  try {
    return Module["dynCall_iiii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiid(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiid"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    Module["dynCall_viiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiiiiiiiiiiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24) {
  try {
    return Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20,a21,a22,a23,a24);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiii(index,a1,a2,a3,a4,a5,a6) {
  try {
    Module["dynCall_viiiiii"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viidii(index,a1,a2,a3,a4,a5) {
  try {
    Module["dynCall_viidii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iid(index,a1,a2) {
  try {
    return Module["dynCall_iid"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiii(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiii"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiid(index,a1,a2,a3,a4,a5,a6,a7) {
  try {
    Module["dynCall_viiiiiid"](index,a1,a2,a3,a4,a5,a6,a7);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    Module["dynCall_viiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iii(index,a1,a2) {
  try {
    return Module["dynCall_iii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiii(index,a1,a2,a3,a4,a5) {
  try {
    return Module["dynCall_iiiiii"](index,a1,a2,a3,a4,a5);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiidi(index,a1,a2,a3,a4,a5,a6) {
  try {
    return Module["dynCall_iiiiidi"](index,a1,a2,a3,a4,a5,a6);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_didd(index,a1,a2,a3) {
  try {
    return Module["dynCall_didd"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_dii(index,a1,a2) {
  try {
    return Module["dynCall_dii"](index,a1,a2);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_i(index) {
  try {
    return Module["dynCall_i"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8,a9) {
  try {
    return Module["dynCall_iiiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8,a9);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viii(index,a1,a2,a3) {
  try {
    Module["dynCall_viii"](index,a1,a2,a3);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_v(index) {
  try {
    Module["dynCall_v"](index);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiiiiiii(index,a1,a2,a3,a4,a5,a6,a7,a8) {
  try {
    return Module["dynCall_iiiiiiiii"](index,a1,a2,a3,a4,a5,a6,a7,a8);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_iiiii(index,a1,a2,a3,a4) {
  try {
    return Module["dynCall_iiiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function invoke_viiii(index,a1,a2,a3,a4) {
  try {
    Module["dynCall_viiii"](index,a1,a2,a3,a4);
  } catch(e) {
    if (typeof e !== 'number' && e !== 'longjmp') throw e;
    asm["setThrew"](1, 0);
  }
}

function asmPrintInt(x, y) {
  Module.print('int ' + x + ',' + y);// + ' ' + new Error().stack);
}
function asmPrintFloat(x, y) {
  Module.print('float ' + x + ',' + y);// + ' ' + new Error().stack);
}
// EMSCRIPTEN_START_ASM
var asm=(function(global,env,buffer){"use asm";var a=new global.Int8Array(buffer);var b=new global.Int16Array(buffer);var c=new global.Int32Array(buffer);var d=new global.Uint8Array(buffer);var e=new global.Uint16Array(buffer);var f=new global.Uint32Array(buffer);var g=new global.Float32Array(buffer);var h=new global.Float64Array(buffer);var i=env.STACKTOP|0;var j=env.STACK_MAX|0;var k=env.tempDoublePtr|0;var l=env.ABORT|0;var m=env.cttz_i8|0;var n=env.ctlz_i8|0;var o=env.___rand_seed|0;var p=env.__ZTISt9exception|0;var q=env.___dso_handle|0;var r=env._stderr|0;var s=env._stdin|0;var t=env._stdout|0;var u=0;var v=0;var w=0;var x=0;var y=+env.NaN,z=+env.Infinity;var A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0.0;var J=0;var K=0;var L=0;var M=0;var N=0;var O=0;var P=0;var Q=0;var R=0;var S=0;var T=global.Math.floor;var U=global.Math.abs;var V=global.Math.sqrt;var W=global.Math.pow;var X=global.Math.cos;var Y=global.Math.sin;var Z=global.Math.tan;var _=global.Math.acos;var $=global.Math.asin;var aa=global.Math.atan;var ba=global.Math.atan2;var ca=global.Math.exp;var da=global.Math.log;var ea=global.Math.ceil;var fa=global.Math.imul;var ga=env.abort;var ha=env.assert;var ia=env.asmPrintInt;var ja=env.asmPrintFloat;var ka=env.min;var la=env.invoke_iiiiiiii;var ma=env.invoke_viiiii;var na=env.invoke_iiiiidiii;var oa=env.invoke_vd;var pa=env.invoke_vi;var qa=env.invoke_vii;var ra=env.invoke_iiiiiiiiiii;var sa=env.invoke_ii;var ta=env.invoke_viidi;var ua=env.invoke_iiiiiiiiiiiiii;var va=env.invoke_iiii;var wa=env.invoke_iiiiiiiiiiiiiiiiiiiiiii;var xa=env.invoke_iiiiiiiiiiiiiiiiiiiii;var ya=env.invoke_viiiiid;var za=env.invoke_viiiiiiii;var Aa=env.invoke_iiiiiiiiiiiiiiiiiiiiiiiii;var Ba=env.invoke_viiiiii;var Ca=env.invoke_viidii;var Da=env.invoke_iid;var Ea=env.invoke_viiiiiii;var Fa=env.invoke_viiiiiid;var Ga=env.invoke_viiiiiiiii;var Ha=env.invoke_iii;var Ia=env.invoke_iiiiii;var Ja=env.invoke_iiiiidi;var Ka=env.invoke_didd;var La=env.invoke_dii;var Ma=env.invoke_i;var Na=env.invoke_iiiiiiiiii;var Oa=env.invoke_viii;var Pa=env.invoke_v;var Qa=env.invoke_iiiiiiiii;var Ra=env.invoke_iiiii;var Sa=env.invoke_viiii;var Ta=env._fabs;var Ua=env._lis_matrix_assemble;var Va=env._strrchr;var Wa=env._pthread_key_create;var Xa=env._vsscanf;var Ya=env.__ZSt9terminatev;var Za=env.___cxa_guard_acquire;var _a=env.__reallyNegative;var $a=env._fstat;var ab=env._pclose;var bb=env._lis_solver_create;var cb=env.___assert_fail;var db=env.__ZSt18uncaught_exceptionv;var eb=env._longjmp;var fb=env.__isLeapYear;var gb=env._clock_gettime;var hb=env._fsync;var ib=env._signal;var jb=env._GC_collect_a_little;var kb=env._sbrk;var lb=env._strtoull;var mb=env._emscripten_memcpy_big;var nb=env.__parseInt64;var ob=env._close;var pb=env._rewind;var qb=env._cos;var rb=env._fileno;var sb=env._fread;var tb=env._puts;var ub=env._isatty;var vb=env._lis_matrix_set_value;var wb=env._write;var xb=env._isblank;var yb=env._ftell;var zb=env.__ZNSt9exceptionD2Ev;var Ab=env._xerbla_;var Bb=env._round;var Cb=env.___cxa_does_inherit;var Db=env._strtoll_l;var Eb=env._strstr;var Fb=env.___cxa_rethrow;var Gb=env._llvm_lifetime_end;var Hb=env._catclose;var Ib=env._tmpnam;var Jb=env._lis_vector_get_values;var Kb=env._lis_vector_destroy;var Lb=env._lis_solver_set_option;var Mb=env._tmpfile;var Nb=env._send;var Ob=env._pow;var Pb=env._lis_matrix_set_size;var Qb=env.___cxa_free_exception;var Rb=env.___cxa_find_matching_catch;var Sb=env._isxdigit_l;var Tb=env.___cxa_guard_release;var Ub=env._truncate;var Vb=env._strtol;var Wb=env._sin;var Xb=env._strtok;var Yb=env.___setErrNo;var Zb=env._newlocale;var _b=env._isdigit_l;var $b=env.___resumeException;var ac=env._freelocale;var bc=env._srand;var cc=env._qsort;var dc=env._putchar;var ec=env._floor;var fc=env._pthread_mutex_unlock;var gc=env._printf;var hc=env._sprintf;var ic=env._fopen;var jc=env._vasprintf;var kc=env._emscripten_get_now;var lc=env._stat;var mc=env._lis_solve;var nc=env._strtoull_l;var oc=env._mkport;var pc=env._read;var qc=env.__addDays;var rc=env._fwrite;var sc=env._time;var tc=env._pthread_mutex_lock;var uc=env._catopen;var vc=env._exit;var wc=env._GC_strdup;var xc=env._freopen;var yc=env.___ctype_b_loc;var zc=env._fmod;var Ac=env._strtok_r;var Bc=env._lseek;var Cc=env._access;var Dc=env._vfprintf;var Ec=env.___cxa_allocate_exception;var Fc=env._atoi;var Gc=env._strtoll;var Hc=env._pwrite;var Ic=env._localtime_r;var Jc=env._tzset;var Kc=env._open;var Lc=env._uselocale;var Mc=env._snprintf;var Nc=env.___errno_location;var Oc=env._GC_malloc;var Pc=env.___cxa_end_catch;var Qc=env._perror;var Rc=env.___cxa_begin_catch;var Sc=env._strftime;var Tc=env._ftruncate;var Uc=env._GC_init;var Vc=env._lis_matrix_set_type;var Wc=env._fseek;var Xc=env._isxdigit;var Yc=env._fclose;var Zc=env._vsnprintf;var _c=env.__parseInt;var $c=env._log;var ad=env._pthread_cond_broadcast;var bd=env._popen;var cd=env._recv;var dd=env._fgetc;var ed=env._sysconf;var fd=env.__getFloat;var gd=env._lis_vector_set_value;var hd=env._abort;var id=env._ceil;var jd=env._isspace;var kd=env._localtime;var ld=env._lis_matrix_destroy;var md=env._pthread_getspecific;var nd=env._pthread_cond_wait;var od=env._llvm_lifetime_start;var pd=env.___cxa_is_number_type;var qd=env._ungetc;var rd=env._system;var sd=env._fmin;var td=env._fmax;var ud=env._fflush;var vd=env._strftime_l;var wd=env._fprintf;var xd=env._sscanf;var yd=env._catgets;var zd=env._lis_solver_destroy;var Ad=env._strdup;var Bd=env._asprintf;var Cd=env.__exit;var Dd=env.___ctype_toupper_loc;var Ed=env._bsearch;var Fd=env.__arraySum;var Gd=env.__formatString;var Hd=env._htonl;var Id=env.___ctype_tolower_loc;var Jd=env._unlink;var Kd=env._fputs;var Ld=env._GC_malloc_atomic;var Md=env._pread;var Nd=env._lis_vector_set_size;var Od=env._fscanf;var Pd=env.__scanString;var Qd=env._pthread_setspecific;var Rd=env._copysign;var Sd=env._fputc;var Td=env.___cxa_throw;var Ud=env._lis_matrix_create;var Vd=env._isdigit;var Wd=env._strerror;var Xd=env._emscripten_longjmp;var Yd=env._lis_vector_create;var Zd=env._atexit;var _d=env._sqrt;var $d=env._strerror_r;var ae=0.0;
// EMSCRIPTEN_START_FUNCS
function hz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](0,270,+h[e+23904>>3]*+h[f+5752>>3]- +h[e+23888>>3]*+h[f+5744>>3],0,b);se[c[(b+8|0)>>2]&3](0,403,1.0,1,b);se[c[(b+8|0)>>2]&3](1,47,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-1.814269757448105,2,b);se[c[(b+8|0)>>2]&3](1,402,1.0,3,b);se[c[(b+8|0)>>2]&3](1,403,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-1.814269757448105,4,b);se[c[(b+8|0)>>2]&3](2,397,-1.0,5,b);se[c[(b+8|0)>>2]&3](2,401,-1.0,6,b);se[c[(b+8|0)>>2]&3](2,402,1.0,7,b);se[c[(b+8|0)>>2]&3](3,378,+h[(c[(a+416|0)>>2]|0)+5176>>3],8,b);se[c[(b+8|0)>>2]&3](3,393,-1.0,9,b);se[c[(b+8|0)>>2]&3](3,400,-1.0,10,b);se[c[(b+8|0)>>2]&3](3,401,-+h[(c[(a+416|0)>>2]|0)+5168>>3],11,b);se[c[(b+8|0)>>2]&3](4,9,1.0,12,b);se[c[(b+8|0)>>2]&3](4,399,-1.0,13,b);se[c[(b+8|0)>>2]&3](4,400,1.0,14,b);se[c[(b+8|0)>>2]&3](5,269,1.0,15,b);se[c[(b+8|0)>>2]&3](5,396,+h[(c[(a+416|0)>>2]|0)+5744>>3],16,b);se[c[(b+8|0)>>2]&3](5,398,-+h[(c[(a+416|0)>>2]|0)+5752>>3],17,b);se[c[(b+8|0)>>2]&3](5,399,1.0,18,b);se[c[(b+8|0)>>2]&3](6,377,.8660254037844387,19,b);se[c[(b+8|0)>>2]&3](6,397,.4999999999999999,20,b);se[c[(b+8|0)>>2]&3](6,398,-1.0,21,b);se[c[(b+8|0)>>2]&3](7,377,-.4999999999999999,22,b);se[c[(b+8|0)>>2]&3](7,396,-1.0,23,b);se[c[(b+8|0)>>2]&3](7,397,.8660254037844387,24,b);se[c[(b+8|0)>>2]&3](8,45,1.0,25,b);se[c[(b+8|0)>>2]&3](8,395,-1.0,26,b);se[c[(b+8|0)>>2]&3](8,401,1.0,27,b);se[c[(b+8|0)>>2]&3](9,379,+h[(c[(a+416|0)>>2]|0)+3208>>3],28,b);se[c[(b+8|0)>>2]&3](9,388,-1.0,29,b);se[c[(b+8|0)>>2]&3](9,394,-1.0,30,b);se[c[(b+8|0)>>2]&3](9,395,-+h[(c[(a+416|0)>>2]|0)+3200>>3],31,b);se[c[(b+8|0)>>2]&3](10,44,1.0,32,b);se[c[(b+8|0)>>2]&3](10,393,1.0,33,b);se[c[(b+8|0)>>2]&3](10,394,1.0,34,b);se[c[(b+8|0)>>2]&3](11,35,1.0,35,b);se[c[(b+8|0)>>2]&3](11,392,1.0,36,b);se[c[(b+8|0)>>2]&3](11,395,1.0,37,b);se[c[(b+8|0)>>2]&3](12,17,1.0,38,b);se[c[(b+8|0)>>2]&3](12,391,-1.0,39,b);se[c[(b+8|0)>>2]&3](12,392,-1.0,40,b);se[c[(b+8|0)>>2]&3](13,381,+h[(c[(a+416|0)>>2]|0)+4400>>3],41,b);se[c[(b+8|0)>>2]&3](13,384,-1.0,42,b);se[c[(b+8|0)>>2]&3](13,390,-1.0,43,b);se[c[(b+8|0)>>2]&3](13,391,-+h[(c[(a+416|0)>>2]|0)+4392>>3],44,b);se[c[(b+8|0)>>2]&3](14,8,1.0,45,b);se[c[(b+8|0)>>2]&3](14,389,-1.0,46,b);se[c[(b+8|0)>>2]&3](14,390,1.0,47,b);se[c[(b+8|0)>>2]&3](15,36,1.0,48,b);se[c[(b+8|0)>>2]&3](15,388,1.0,49,b);se[c[(b+8|0)>>2]&3](15,389,1.0,50,b);se[c[(b+8|0)>>2]&3](16,21,1.0,51,b);se[c[(b+8|0)>>2]&3](16,387,-1.0,52,b);se[c[(b+8|0)>>2]&3](16,391,1.0,53,b);se[c[(b+8|0)>>2]&3](17,376,1.0,54,b);se[c[(b+8|0)>>2]&3](17,382,+h[(c[(a+416|0)>>2]|0)+6136>>3],55,b);se[c[(b+8|0)>>2]&3](17,386,1.0,56,b);se[c[(b+8|0)>>2]&3](17,387,-+h[(c[(a+416|0)>>2]|0)+6128>>3],57,b);se[c[(b+8|0)>>2]&3](18,382,+h[(c[(a+416|0)>>2]|0)+2408>>3],58,b);se[c[(b+8|0)>>2]&3](18,385,-1.0,59,b);se[c[(b+8|0)>>2]&3](18,386,-1.0,60,b);se[c[(b+8|0)>>2]&3](18,387,-+h[(c[(a+416|0)>>2]|0)+2400>>3],61,b);se[c[(b+8|0)>>2]&3](19,20,1.0,62,b);se[c[(b+8|0)>>2]&3](19,384,1.0,63,b);se[c[(b+8|0)>>2]&3](19,385,1.0,64,b);se[c[(b+8|0)>>2]&3](20,352,.8660254037844387,65,b);se[c[(b+8|0)>>2]&3](20,383,.4999999999999999,66,b);se[c[(b+8|0)>>2]&3](20,387,1.0,67,b);se[c[(b+8|0)>>2]&3](21,352,-.4999999999999999,68,b);se[c[(b+8|0)>>2]&3](21,382,1.0,69,b);se[c[(b+8|0)>>2]&3](21,383,.8660254037844387,70,b);se[c[(b+8|0)>>2]&3](22,19,1.0,71,b);se[c[(b+8|0)>>2]&3](22,381,1.0,72,b);se[c[(b+8|0)>>2]&3](22,382,-1.0,73,b);se[c[(b+8|0)>>2]&3](23,16,1.0,74,b);se[c[(b+8|0)>>2]&3](23,380,-1.0,75,b);se[c[(b+8|0)>>2]&3](23,381,-1.0,76,b);se[c[(b+8|0)>>2]&3](24,37,1.0,77,b);se[c[(b+8|0)>>2]&3](24,379,1.0,78,b);se[c[(b+8|0)>>2]&3](24,380,1.0,79,b);se[c[(b+8|0)>>2]&3](25,43,1.0,80,b);se[c[(b+8|0)>>2]&3](25,378,1.0,81,b);se[c[(b+8|0)>>2]&3](25,379,-1.0,82,b);se[c[(b+8|0)>>2]&3](26,15,1.0,83,b);se[c[(b+8|0)>>2]&3](26,377,-1.0,84,b);se[c[(b+8|0)>>2]&3](26,378,-1.0,85,b);se[c[(b+8|0)>>2]&3](27,352,+h[(c[(a+416|0)>>2]|0)+12152>>3],86,b);se[c[(b+8|0)>>2]&3](27,372,1.0,87,b);se[c[(b+8|0)>>2]&3](27,376,-1.0,88,b);se[c[(b+8|0)>>2]&3](27,383,-+h[(c[(a+416|0)>>2]|0)+12160>>3],89,b);se[c[(b+8|0)>>2]&3](28,353,6.123233995736766e-17,90,b);se[c[(b+8|0)>>2]&3](28,375,-1.0,91,b);se[c[(b+8|0)>>2]&3](28,383,-1.0,92,b);se[c[(b+8|0)>>2]&3](29,57,1.0,93,b);se[c[(b+8|0)>>2]&3](29,374,-1.0,94,b);se[c[(b+8|0)>>2]&3](29,375,-1.0,95,b);se[c[(b+8|0)>>2]&3](30,354,+h[(c[(a+416|0)>>2]|0)+11584>>3],96,b);se[c[(b+8|0)>>2]&3](30,369,-1.0,97,b);se[c[(b+8|0)>>2]&3](30,373,-1.0,98,b);se[c[(b+8|0)>>2]&3](30,374,-+h[(c[(a+416|0)>>2]|0)+11576>>3],99,b);se[c[(b+8|0)>>2]&3](31,7,1.0,100,b);se[c[(b+8|0)>>2]&3](31,372,-1.0,101,b);se[c[(b+8|0)>>2]&3](31,373,1.0,102,b);se[c[(b+8|0)>>2]&3](32,87,1.0,103,b);se[c[(b+8|0)>>2]&3](32,371,-1.0,104,b);se[c[(b+8|0)>>2]&3](32,374,1.0,105,b);se[c[(b+8|0)>>2]&3](33,355,+h[(c[(a+416|0)>>2]|0)+9616>>3],106,b);se[c[(b+8|0)>>2]&3](33,364,-1.0,107,b);se[c[(b+8|0)>>2]&3](33,370,-1.0,108,b);se[c[(b+8|0)>>2]&3](33,371,-+h[(c[(a+416|0)>>2]|0)+9608>>3],109,b);se[c[(b+8|0)>>2]&3](34,86,1.0,110,b);se[c[(b+8|0)>>2]&3](34,369,1.0,111,b);se[c[(b+8|0)>>2]&3](34,370,1.0,112,b);se[c[(b+8|0)>>2]&3](35,79,1.0,113,b);se[c[(b+8|0)>>2]&3](35,368,1.0,114,b);se[c[(b+8|0)>>2]&3](35,371,1.0,115,b);se[c[(b+8|0)>>2]&3](36,59,1.0,116,b);se[c[(b+8|0)>>2]&3](36,367,-1.0,117,b);se[c[(b+8|0)>>2]&3](36,368,-1.0,118,b);se[c[(b+8|0)>>2]&3](37,357,+h[(c[(a+416|0)>>2]|0)+10808>>3],119,b);se[c[(b+8|0)>>2]&3](37,360,-1.0,120,b);se[c[(b+8|0)>>2]&3](37,366,-1.0,121,b);se[c[(b+8|0)>>2]&3](37,367,-+h[(c[(a+416|0)>>2]|0)+10800>>3],122,b);se[c[(b+8|0)>>2]&3](38,6,1.0,123,b);se[c[(b+8|0)>>2]&3](38,365,-1.0,124,b);se[c[(b+8|0)>>2]&3](38,366,1.0,125,b);se[c[(b+8|0)>>2]&3](39,78,1.0,126,b);se[c[(b+8|0)>>2]&3](39,364,1.0,127,b);se[c[(b+8|0)>>2]&3](39,365,1.0,128,b);se[c[(b+8|0)>>2]&3](40,63,1.0,129,b);se[c[(b+8|0)>>2]&3](40,363,-1.0,130,b);se[c[(b+8|0)>>2]&3](40,367,1.0,131,b);se[c[(b+8|0)>>2]&3](41,351,1.0,132,b);se[c[(b+8|0)>>2]&3](41,358,+h[(c[(a+416|0)>>2]|0)+12544>>3],133,b);se[c[(b+8|0)>>2]&3](41,362,1.0,134,b);se[c[(b+8|0)>>2]&3](41,363,-+h[(c[(a+416|0)>>2]|0)+12536>>3],135,b);se[c[(b+8|0)>>2]&3](42,358,+h[(c[(a+416|0)>>2]|0)+8816>>3],136,b);se[c[(b+8|0)>>2]&3](42,361,-1.0,137,b);se[c[(b+8|0)>>2]&3](42,362,-1.0,138,b);se[c[(b+8|0)>>2]&3](42,363,-+h[(c[(a+416|0)>>2]|0)+8808>>3],139,b);se[c[(b+8|0)>>2]&3](43,62,1.0,140,b);se[c[(b+8|0)>>2]&3](43,360,1.0,141,b);se[c[(b+8|0)>>2]&3](43,361,1.0,142,b);se[c[(b+8|0)>>2]&3](44,349,-1.0,143,b);se[c[(b+8|0)>>2]&3](44,359,6.123233995736766e-17,144,b);se[c[(b+8|0)>>2]&3](44,363,1.0,145,b);se[c[(b+8|0)>>2]&3](45,349,6.123233995736766e-17,146,b);se[c[(b+8|0)>>2]&3](45,358,1.0,147,b);se[c[(b+8|0)>>2]&3](45,359,1.0,148,b);se[c[(b+8|0)>>2]&3](46,61,1.0,149,b);se[c[(b+8|0)>>2]&3](46,357,1.0,150,b);se[c[(b+8|0)>>2]&3](46,358,-1.0,151,b);se[c[(b+8|0)>>2]&3](47,58,1.0,152,b);se[c[(b+8|0)>>2]&3](47,356,-1.0,153,b);se[c[(b+8|0)>>2]&3](47,357,-1.0,154,b);se[c[(b+8|0)>>2]&3](48,77,1.0,155,b);se[c[(b+8|0)>>2]&3](48,355,1.0,156,b);se[c[(b+8|0)>>2]&3](48,356,1.0,157,b);se[c[(b+8|0)>>2]&3](49,85,1.0,158,b);se[c[(b+8|0)>>2]&3](49,354,1.0,159,b);se[c[(b+8|0)>>2]&3](49,355,-1.0,160,b);se[c[(b+8|0)>>2]&3](50,56,1.0,161,b);se[c[(b+8|0)>>2]&3](50,353,-1.0,162,b);se[c[(b+8|0)>>2]&3](50,354,-1.0,163,b);se[c[(b+8|0)>>2]&3](51,352,-1.0,164,b);se[c[(b+8|0)>>2]&3](51,353,1.0,165,b);se[c[(b+8|0)>>2]&3](51,375,6.123233995736766e-17,166,b);se[c[(b+8|0)>>2]&3](52,334,1.0,167,b);se[c[(b+8|0)>>2]&3](52,349,-+h[(c[(a+416|0)>>2]|0)+18568>>3],168,b);se[c[(b+8|0)>>2]&3](52,351,-1.0,169,b);se[c[(b+8|0)>>2]&3](52,359,+h[(c[(a+416|0)>>2]|0)+18560>>3],170,b);se[c[(b+8|0)>>2]&3](53,324,-.8660254037844386,171,b);se[c[(b+8|0)>>2]&3](53,350,-.5000000000000001,172,b);se[c[(b+8|0)>>2]&3](53,359,-1.0,173,b);se[c[(b+8|0)>>2]&3](54,324,.5000000000000001,174,b);se[c[(b+8|0)>>2]&3](54,349,-1.0,175,b);se[c[(b+8|0)>>2]&3](54,350,-.8660254037844386,176,b);se[c[(b+8|0)>>2]&3](55,98,1.0,177,b);se[c[(b+8|0)>>2]&3](55,348,-1.0,178,b);se[c[(b+8|0)>>2]&3](55,350,-1.0,179,b);se[c[(b+8|0)>>2]&3](56,127,1.0,180,b);se[c[(b+8|0)>>2]&3](56,347,-1.0,181,b);se[c[(b+8|0)>>2]&3](56,348,1.0,182,b);se[c[(b+8|0)>>2]&3](57,119,1.0,183,b);se[c[(b+8|0)>>2]&3](57,346,1.0,184,b);se[c[(b+8|0)>>2]&3](57,347,1.0,185,b);se[c[(b+8|0)>>2]&3](58,100,1.0,186,b);se[c[(b+8|0)>>2]&3](58,345,-1.0,187,b);se[c[(b+8|0)>>2]&3](58,346,-1.0,188,b);se[c[(b+8|0)>>2]&3](59,103,1.0,189,b);se[c[(b+8|0)>>2]&3](59,344,-1.0,190,b);se[c[(b+8|0)>>2]&3](59,345,1.0,191,b);se[c[(b+8|0)>>2]&3](60,329,-+h[(c[(a+416|0)>>2]|0)+18944>>3],192,b);se[c[(b+8|0)>>2]&3](60,332,1.0,193,b);se[c[(b+8|0)>>2]&3](60,343,1.0,194,b);se[c[(b+8|0)>>2]&3](60,344,+h[(c[(a+416|0)>>2]|0)+18952>>3],195,b);se[c[(b+8|0)>>2]&3](61,329,-+h[(c[(a+416|0)>>2]|0)+15216>>3],196,b);se[c[(b+8|0)>>2]&3](61,342,-1.0,197,b);se[c[(b+8|0)>>2]&3](61,343,-1.0,198,b);se[c[(b+8|0)>>2]&3](61,344,+h[(c[(a+416|0)>>2]|0)+15224>>3],199,b);se[c[(b+8|0)>>2]&3](62,104,1.0,200,b);se[c[(b+8|0)>>2]&3](62,341,1.0,201,b);se[c[(b+8|0)>>2]&3](62,342,1.0,202,b);se[c[(b+8|0)>>2]&3](63,328,-+h[(c[(a+416|0)>>2]|0)+17208>>3],203,b);se[c[(b+8|0)>>2]&3](63,340,-1.0,204,b);se[c[(b+8|0)>>2]&3](63,341,-1.0,205,b);se[c[(b+8|0)>>2]&3](63,345,+h[(c[(a+416|0)>>2]|0)+17216>>3],206,b);se[c[(b+8|0)>>2]&3](64,4,1.0,207,b);se[c[(b+8|0)>>2]&3](64,339,-1.0,208,b);se[c[(b+8|0)>>2]&3](64,340,1.0,209,b);se[c[(b+8|0)>>2]&3](65,120,1.0,210,b);se[c[(b+8|0)>>2]&3](65,338,1.0,211,b);se[c[(b+8|0)>>2]&3](65,339,1.0,212,b);se[c[(b+8|0)>>2]&3](66,326,-+h[(c[(a+416|0)>>2]|0)+16016>>3],213,b);se[c[(b+8|0)>>2]&3](66,337,-1.0,214,b);se[c[(b+8|0)>>2]&3](66,338,-1.0,215,b);se[c[(b+8|0)>>2]&3](66,347,+h[(c[(a+416|0)>>2]|0)+16024>>3],216,b);se[c[(b+8|0)>>2]&3](67,128,1.0,217,b);se[c[(b+8|0)>>2]&3](67,336,1.0,218,b);se[c[(b+8|0)>>2]&3](67,337,1.0,219,b);se[c[(b+8|0)>>2]&3](68,325,-+h[(c[(a+416|0)>>2]|0)+17984>>3],220,b);se[c[(b+8|0)>>2]&3](68,335,-1.0,221,b);se[c[(b+8|0)>>2]&3](68,336,-1.0,222,b);se[c[(b+8|0)>>2]&3](68,348,+h[(c[(a+416|0)>>2]|0)+17992>>3],223,b);se[c[(b+8|0)>>2]&3](69,5,1.0,224,b);se[c[(b+8|0)>>2]&3](69,334,-1.0,225,b);se[c[(b+8|0)>>2]&3](69,335,1.0,226,b);se[c[(b+8|0)>>2]&3](70,330,-.8660254037844386,227,b);se[c[(b+8|0)>>2]&3](70,333,-.5000000000000001,228,b);se[c[(b+8|0)>>2]&3](70,344,1.0,229,b);se[c[(b+8|0)>>2]&3](71,309,1.0,230,b);se[c[(b+8|0)>>2]&3](71,330,-+h[(c[(a+416|0)>>2]|0)+24976>>3],231,b);se[c[(b+8|0)>>2]&3](71,332,-1.0,232,b);se[c[(b+8|0)>>2]&3](71,333,+h[(c[(a+416|0)>>2]|0)+24968>>3],233,b);se[c[(b+8|0)>>2]&3](72,286,-.8660254037844386,234,b);se[c[(b+8|0)>>2]&3](72,331,-.5000000000000001,235,b);se[c[(b+8|0)>>2]&3](72,333,-1.0,236,b);se[c[(b+8|0)>>2]&3](73,286,.5000000000000001,237,b);se[c[(b+8|0)>>2]&3](73,330,-1.0,238,b);se[c[(b+8|0)>>2]&3](73,331,-.8660254037844386,239,b);se[c[(b+8|0)>>2]&3](74,329,1.0,240,b);se[c[(b+8|0)>>2]&3](74,330,.5000000000000001,241,b);se[c[(b+8|0)>>2]&3](74,333,-.8660254037844386,242,b);se[c[(b+8|0)>>2]&3](75,105,1.0,243,b);se[c[(b+8|0)>>2]&3](75,328,1.0,244,b);se[c[(b+8|0)>>2]&3](75,329,-1.0,245,b);se[c[(b+8|0)>>2]&3](76,101,1.0,246,b);se[c[(b+8|0)>>2]&3](76,327,-1.0,247,b);se[c[(b+8|0)>>2]&3](76,328,-1.0,248,b);se[c[(b+8|0)>>2]&3](77,121,1.0,249,b);se[c[(b+8|0)>>2]&3](77,326,1.0,250,b);se[c[(b+8|0)>>2]&3](77,327,1.0,251,b);se[c[(b+8|0)>>2]&3](78,129,1.0,252,b);se[c[(b+8|0)>>2]&3](78,325,1.0,253,b);se[c[(b+8|0)>>2]&3](78,326,-1.0,254,b);se[c[(b+8|0)>>2]&3](79,99,1.0,255,b);se[c[(b+8|0)>>2]&3](79,324,-1.0,256,b);se[c[(b+8|0)>>2]&3](79,325,-1.0,257,b);se[c[(b+8|0)>>2]&3](80,140,1.0,258,b);se[c[(b+8|0)>>2]&3](80,323,-1.0,259,b);se[c[(b+8|0)>>2]&3](80,331,-1.0,260,b);se[c[(b+8|0)>>2]&3](81,169,1.0,261,b);se[c[(b+8|0)>>2]&3](81,322,-1.0,262,b);se[c[(b+8|0)>>2]&3](81,323,1.0,263,b);se[c[(b+8|0)>>2]&3](82,163,1.0,264,b);se[c[(b+8|0)>>2]&3](82,321,1.0,265,b);se[c[(b+8|0)>>2]&3](82,322,1.0,266,b);se[c[(b+8|0)>>2]&3](83,142,1.0,267,b);se[c[(b+8|0)>>2]&3](83,320,-1.0,268,b);se[c[(b+8|0)>>2]&3](83,321,-1.0,269,b);se[c[(b+8|0)>>2]&3](84,145,1.0,270,b);se[c[(b+8|0)>>2]&3](84,319,-1.0,271,b);se[c[(b+8|0)>>2]&3](84,320,1.0,272,b);se[c[(b+8|0)>>2]&3](85,291,-+h[(c[(a+416|0)>>2]|0)+25352>>3],273,b);se[c[(b+8|0)>>2]&3](85,307,1.0,274,b);se[c[(b+8|0)>>2]&3](85,318,1.0,275,b);se[c[(b+8|0)>>2]&3](85,319,+h[(c[(a+416|0)>>2]|0)+25360>>3],276,b);se[c[(b+8|0)>>2]&3](86,291,-+h[(c[(a+416|0)>>2]|0)+21624>>3],277,b);se[c[(b+8|0)>>2]&3](86,317,-1.0,278,b);se[c[(b+8|0)>>2]&3](86,318,-1.0,279,b);se[c[(b+8|0)>>2]&3](86,319,+h[(c[(a+416|0)>>2]|0)+21632>>3],280,b);se[c[(b+8|0)>>2]&3](87,146,1.0,281,b);se[c[(b+8|0)>>2]&3](87,316,1.0,282,b);se[c[(b+8|0)>>2]&3](87,317,1.0,283,b);se[c[(b+8|0)>>2]&3](88,290,-+h[(c[(a+416|0)>>2]|0)+23616>>3],284,b);se[c[(b+8|0)>>2]&3](88,315,-1.0,285,b);se[c[(b+8|0)>>2]&3](88,316,-1.0,286,b);se[c[(b+8|0)>>2]&3](88,320,+h[(c[(a+416|0)>>2]|0)+23624>>3],287,b);se[c[(b+8|0)>>2]&3](89,2,1.0,288,b);se[c[(b+8|0)>>2]&3](89,314,-1.0,289,b);se[c[(b+8|0)>>2]&3](89,315,1.0,290,b);se[c[(b+8|0)>>2]&3](90,162,1.0,291,b);se[c[(b+8|0)>>2]&3](90,313,1.0,292,b);se[c[(b+8|0)>>2]&3](90,314,1.0,293,b);se[c[(b+8|0)>>2]&3](91,288,-+h[(c[(a+416|0)>>2]|0)+22424>>3],294,b);se[c[(b+8|0)>>2]&3](91,312,-1.0,295,b);se[c[(b+8|0)>>2]&3](91,313,-1.0,296,b);se[c[(b+8|0)>>2]&3](91,322,+h[(c[(a+416|0)>>2]|0)+22432>>3],297,b);se[c[(b+8|0)>>2]&3](92,170,1.0,298,b);se[c[(b+8|0)>>2]&3](92,311,1.0,299,b);se[c[(b+8|0)>>2]&3](92,312,1.0,300,b);se[c[(b+8|0)>>2]&3](93,287,-+h[(c[(a+416|0)>>2]|0)+24392>>3],301,b);se[c[(b+8|0)>>2]&3](93,310,-1.0,302,b);se[c[(b+8|0)>>2]&3](93,311,-1.0,303,b);se[c[(b+8|0)>>2]&3](93,323,+h[(c[(a+416|0)>>2]|0)+24400>>3],304,b);se[c[(b+8|0)>>2]&3](94,3,1.0,305,b);se[c[(b+8|0)>>2]&3](94,309,-1.0,306,b);se[c[(b+8|0)>>2]&3](94,310,1.0,307,b);se[c[(b+8|0)>>2]&3](95,292,-.8660254037844386,308,b);se[c[(b+8|0)>>2]&3](95,308,-.5000000000000001,309,b);se[c[(b+8|0)>>2]&3](95,319,1.0,310,b);se[c[(b+8|0)>>2]&3](96,292,-+h[(c[(a+416|0)>>2]|0)+31384>>3],311,b);se[c[(b+8|0)>>2]&3](96,303,1.0,312,b);se[c[(b+8|0)>>2]&3](96,307,-1.0,313,b);se[c[(b+8|0)>>2]&3](96,308,+h[(c[(a+416|0)>>2]|0)+31376>>3],314,b);se[c[(b+8|0)>>2]&3](97,293,6.123233995736766e-17,315,b);se[c[(b+8|0)>>2]&3](97,306,1.0,316,b);se[c[(b+8|0)>>2]&3](97,308,-1.0,317,b);se[c[(b+8|0)>>2]&3](98,182,1.0,318,b);se[c[(b+8|0)>>2]&3](98,305,-1.0,319,b);se[c[(b+8|0)>>2]&3](98,306,-1.0,320,b);se[c[(b+8|0)>>2]&3](99,294,-+h[(c[(a+416|0)>>2]|0)+30800>>3],321,b);se[c[(b+8|0)>>2]&3](99,300,-1.0,322,b);se[c[(b+8|0)>>2]&3](99,304,-1.0,323,b);se[c[(b+8|0)>>2]&3](99,305,+h[(c[(a+416|0)>>2]|0)+30808>>3],324,b);se[c[(b+8|0)>>2]&3](100,1,1.0,325,b);se[c[(b+8|0)>>2]&3](100,303,-1.0,326,b);se[c[(b+8|0)>>2]&3](100,304,1.0,327,b);se[c[(b+8|0)>>2]&3](101,193,1.0,328,b);se[c[(b+8|0)>>2]&3](101,302,-1.0,329,b);se[c[(b+8|0)>>2]&3](101,305,1.0,330,b);se[c[(b+8|0)>>2]&3](102,295,-+h[(c[(a+416|0)>>2]|0)+28832>>3],331,b);se[c[(b+8|0)>>2]&3](102,297,-1.0,332,b);se[c[(b+8|0)>>2]&3](102,301,-1.0,333,b);se[c[(b+8|0)>>2]&3](102,302,+h[(c[(a+416|0)>>2]|0)+28840>>3],334,b);se[c[(b+8|0)>>2]&3](103,194,1.0,335,b);se[c[(b+8|0)>>2]&3](103,300,1.0,336,b);se[c[(b+8|0)>>2]&3](103,301,1.0,337,b);se[c[(b+8|0)>>2]&3](104,241,1.0,338,b);se[c[(b+8|0)>>2]&3](104,299,1.0,339,b);se[c[(b+8|0)>>2]&3](104,302,1.0,340,b);se[c[(b+8|0)>>2]&3](105,296,+h[(c[(a+416|0)>>2]|0)+30896>>3],341,b);se[c[(b+8|0)>>2]&3](105,298,-1.0,342,b);se[c[(b+8|0)>>2]&3](105,299,-+h[(c[(a+416|0)>>2]|0)+30904>>3],343,b);se[c[(b+8|0)>>2]&3](106,252,1.0,344,b);se[c[(b+8|0)>>2]&3](106,297,1.0,345,b);se[c[(b+8|0)>>2]&3](106,298,1.0,346,b);se[c[(b+8|0)>>2]&3](107,281,1.0,347,b);se[c[(b+8|0)>>2]&3](107,296,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10328>>3],348,b);se[c[(b+8|0)>>2]&3](107,299,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10304>>3],349,b);se[c[(b+8|0)>>2]&3](108,244,1.0,350,b);se[c[(b+8|0)>>2]&3](108,295,1.0,351,b);se[c[(b+8|0)>>2]&3](108,296,1.0,352,b);se[c[(b+8|0)>>2]&3](109,195,1.0,353,b);se[c[(b+8|0)>>2]&3](109,294,1.0,354,b);se[c[(b+8|0)>>2]&3](109,295,-1.0,355,b);se[c[(b+8|0)>>2]&3](110,183,1.0,356,b);se[c[(b+8|0)>>2]&3](110,293,-1.0,357,b);se[c[(b+8|0)>>2]&3](110,294,-1.0,358,b);se[c[(b+8|0)>>2]&3](111,292,-1.0,359,b);se[c[(b+8|0)>>2]&3](111,293,-1.0,360,b);se[c[(b+8|0)>>2]&3](111,306,6.123233995736766e-17,361,b);se[c[(b+8|0)>>2]&3](112,291,1.0,362,b);se[c[(b+8|0)>>2]&3](112,292,.5000000000000001,363,b);se[c[(b+8|0)>>2]&3](112,308,-.8660254037844386,364,b);se[c[(b+8|0)>>2]&3](113,147,1.0,365,b);se[c[(b+8|0)>>2]&3](113,290,1.0,366,b);se[c[(b+8|0)>>2]&3](113,291,-1.0,367,b);se[c[(b+8|0)>>2]&3](114,143,1.0,368,b);se[c[(b+8|0)>>2]&3](114,289,-1.0,369,b);se[c[(b+8|0)>>2]&3](114,290,-1.0,370,b);se[c[(b+8|0)>>2]&3](115,161,1.0,371,b);se[c[(b+8|0)>>2]&3](115,288,1.0,372,b);se[c[(b+8|0)>>2]&3](115,289,1.0,373,b);se[c[(b+8|0)>>2]&3](116,171,1.0,374,b);se[c[(b+8|0)>>2]&3](116,287,1.0,375,b);se[c[(b+8|0)>>2]&3](116,288,-1.0,376,b);se[c[(b+8|0)>>2]&3](117,141,1.0,377,b);se[c[(b+8|0)>>2]&3](117,286,-1.0,378,b);se[c[(b+8|0)>>2]&3](117,287,-1.0,379,b);se[c[(b+8|0)>>2]&3](118,285,1.0,380,b);se[c[(b+8|0)>>2]&3](118,296,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10320>>3],381,b);se[c[(b+8|0)>>2]&3](118,299,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10296>>3],382,b);se[c[(b+8|0)>>2]&3](119,279,1.0,383,b);se[c[(b+8|0)>>2]&3](119,284,-1.0,384,b);se[c[(b+8|0)>>2]&3](119,285,1.0,385,b);se[c[(b+8|0)>>2]&3](120,272,-+h[(c[(a+416|0)>>2]|0)+27136>>3],386,b);se[c[(b+8|0)>>2]&3](120,283,-1.0,387,b);se[c[(b+8|0)>>2]&3](120,284,+h[(c[(a+416|0)>>2]|0)+27144>>3],388,b);se[c[(b+8|0)>>2]&3](121,275,-.008808799999999999,389,b);se[c[(b+8|0)>>2]&3](121,282,-.09,390,b);se[c[(b+8|0)>>2]&3](121,283,-1.0,391,b);se[c[(b+8|0)>>2]&3](122,272,-1.0,392,b);se[c[(b+8|0)>>2]&3](122,281,1.0,393,b);se[c[(b+8|0)>>2]&3](122,282,1.0,394,b);se[c[(b+8|0)>>2]&3](123,271,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23360>>3]*-2.0328,395,b);se[c[(b+8|0)>>2]&3](123,275,-.182952,396,b);se[c[(b+8|0)>>2]&3](123,280,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23368>>3]*-2.0328,397,b);se[c[(b+8|0)>>2]&3](123,282,1.0,398,b);se[c[(b+8|0)>>2]&3](124,271,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23336>>3]*-2.0328,399,b);se[c[(b+8|0)>>2]&3](124,279,1.0,400,b);se[c[(b+8|0)>>2]&3](124,280,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23344>>3]*-2.0328,401,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](125,275,+h[f+23344>>3]*+h[e+27144>>3]- +h[f+23368>>3]*+h[e+27136>>3],402,b);se[c[(b+8|0)>>2]&3](125,278,1.0,403,b);se[c[(b+8|0)>>2]&3](125,280,-1.0,404,b);se[c[(b+8|0)>>2]&3](126,277,-.4999999999999999,405,b);se[c[(b+8|0)>>2]&3](126,278,1.0,406,b);se[c[(b+8|0)>>2]&3](127,276,1.0,407,b);se[c[(b+8|0)>>2]&3](127,277,.8660254037844387,408,b);se[c[(b+8|0)>>2]&3](128,271,-1.0,409,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](128,275,+h[e+23336>>3]*+h[f+27144>>3]- +h[e+23360>>3]*+h[f+27136>>3],410,b);se[c[(b+8|0)>>2]&3](128,276,1.0,411,b);se[c[(b+8|0)>>2]&3](129,274,1.0,412,b);se[c[(b+8|0)>>2]&3](129,276,-5.237345664226305,413,b);se[c[(b+8|0)>>2]&3](129,278,3.023782929080176,414,b);se[c[(b+8|0)>>2]&3](130,273,1.0,415,b);se[c[(b+8|0)>>2]&3](130,274,1.0,416,b);se[c[(b+8|0)>>2]&3](131,272,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+24960>>3],417,b);se[c[(b+8|0)>>2]&3](131,273,1.0,418,b);se[c[(b+8|0)>>2]&3](131,284,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+24936>>3],419,b);se[c[(b+8|0)>>2]&3](132,178,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3],420,b);se[c[(b+8|0)>>2]&3](132,191,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3],421,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(b+8|0)>>2]&3](132,270,+h[f+11800>>3]*(+h[f+976>>3]- +h[f+11544>>3])+ +h[f+11792>>3]*(+h[f+984>>3]- +h[f+11552>>3]),422,b);se[c[(b+8|0)>>2]&3](132,271,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3],423,b);se[c[(b+8|0)>>2]&3](132,280,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3],424,b);se[c[(b+8|0)>>2]&3](133,178,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3],425,b);se[c[(b+8|0)>>2]&3](133,191,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3],426,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(b+8|0)>>2]&3](133,270,-(+h[f+11776>>3]*(+h[f+984>>3]- +h[f+11552>>3]))- +h[f+11784>>3]*(+h[f+976>>3]- +h[f+11544>>3]),427,b);se[c[(b+8|0)>>2]&3](133,271,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3],428,b);se[c[(b+8|0)>>2]&3](133,280,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3],429,b);se[c[(b+8|0)>>2]&3](134,269,-1.0,430,b);se[c[(b+8|0)>>2]&3](134,270,+h[(c[(a+416|0)>>2]|0)+47696>>3],431,b);se[c[(b+8|0)>>2]&3](135,219,-1.0,432,b);se[c[(b+8|0)>>2]&3](135,268,1.0,433,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](135,270,+h[f+11216>>3]*+h[e+37312>>3]- +h[f+11200>>3]*+h[e+37304>>3],434,b);se[c[(b+8|0)>>2]&3](136,224,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3],435,b);se[c[(b+8|0)>>2]&3](136,225,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3],436,b);se[c[(b+8|0)>>2]&3](136,267,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3],437,b);se[c[(b+8|0)>>2]&3](136,268,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3],438,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(b+8|0)>>2]&3](136,270,+h[e+11224>>3]*(+h[e+376>>3]- +h[e+11016>>3])+ +h[e+11216>>3]*(+h[e+384>>3]- +h[e+11024>>3]),439,b);se[c[(b+8|0)>>2]&3](137,225,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23240>>3]*-2.0328,440,b);se[c[(b+8|0)>>2]&3](137,228,-.182952,441,b);se[c[(b+8|0)>>2]&3](137,266,1.0,442,b);se[c[(b+8|0)>>2]&3](137,267,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23248>>3]*-2.0328,443,b);se[c[(b+8|0)>>2]&3](138,234,-1.0,444,b);se[c[(b+8|0)>>2]&3](138,265,1.0,445,b);se[c[(b+8|0)>>2]&3](138,266,1.0,446,b);se[c[(b+8|0)>>2]&3](139,251,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10560>>3],447,b);se[c[(b+8|0)>>2]&3](139,264,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10584>>3],448,b);se[c[(b+8|0)>>2]&3](139,265,1.0,449,b);se[c[(b+8|0)>>2]&3](140,251,-+h[(c[(a+416|0)>>2]|0)+37312>>3],450,b);se[c[(b+8|0)>>2]&3](140,263,-1.0,451,b);se[c[(b+8|0)>>2]&3](140,264,+h[(c[(a+416|0)>>2]|0)+37304>>3],452,b);se[c[(b+8|0)>>2]&3](141,214,1.0,453,b);se[c[(b+8|0)>>2]&3](141,262,1.0,454,b);se[c[(b+8|0)>>2]&3](141,263,1.0,455,b);se[c[(b+8|0)>>2]&3](142,239,-+h[(c[(a+416|0)>>2]|0)+35240>>3],456,b);se[c[(b+8|0)>>2]&3](142,250,+h[(c[(a+416|0)>>2]|0)+35248>>3],457,b);se[c[(b+8|0)>>2]&3](142,261,-1.0,458,b);se[c[(b+8|0)>>2]&3](142,262,-1.0,459,b);se[c[(b+8|0)>>2]&3](143,221,1.0,460,b);se[c[(b+8|0)>>2]&3](143,260,1.0,461,b);se[c[(b+8|0)>>2]&3](143,261,1.0,462,b);se[c[(b+8|0)>>2]&3](144,238,-+h[(c[(a+416|0)>>2]|0)+37208>>3],463,b);se[c[(b+8|0)>>2]&3](144,249,+h[(c[(a+416|0)>>2]|0)+37216>>3],464,b);se[c[(b+8|0)>>2]&3](144,259,-1.0,465,b);se[c[(b+8|0)>>2]&3](144,260,-1.0,466,b);se[c[(b+8|0)>>2]&3](145,205,1.0,467,b);se[c[(b+8|0)>>2]&3](145,258,-1.0,468,b);se[c[(b+8|0)>>2]&3](145,259,1.0,469,b);se[c[(b+8|0)>>2]&3](146,240,-+h[(c[(a+416|0)>>2]|0)+37792>>3],470,b);se[c[(b+8|0)>>2]&3](146,247,+h[(c[(a+416|0)>>2]|0)+37784>>3],471,b);se[c[(b+8|0)>>2]&3](146,257,-1.0,472,b);se[c[(b+8|0)>>2]&3](146,258,1.0,473,b);se[c[(b+8|0)>>2]&3](147,243,+h[(c[(a+416|0)>>2]|0)+31768>>3],474,b);se[c[(b+8|0)>>2]&3](147,246,-+h[(c[(a+416|0)>>2]|0)+31760>>3],475,b);se[c[(b+8|0)>>2]&3](147,256,1.0,476,b);se[c[(b+8|0)>>2]&3](147,257,1.0,477,b);se[c[(b+8|0)>>2]&3](148,243,+h[(c[(a+416|0)>>2]|0)+28040>>3],478,b);se[c[(b+8|0)>>2]&3](148,246,-+h[(c[(a+416|0)>>2]|0)+28032>>3],479,b);se[c[(b+8|0)>>2]&3](148,255,-1.0,480,b);se[c[(b+8|0)>>2]&3](148,256,-1.0,481,b);se[c[(b+8|0)>>2]&3](149,188,1.0,482,b);se[c[(b+8|0)>>2]&3](149,254,1.0,483,b);se[c[(b+8|0)>>2]&3](149,255,1.0,484,b);se[c[(b+8|0)>>2]&3](150,242,+h[(c[(a+416|0)>>2]|0)+30032>>3],485,b);se[c[(b+8|0)>>2]&3](150,245,-+h[(c[(a+416|0)>>2]|0)+30024>>3],486,b);se[c[(b+8|0)>>2]&3](150,253,-1.0,487,b);se[c[(b+8|0)>>2]&3](150,254,-1.0,488,b);se[c[(b+8|0)>>2]&3](151,0,1.0,489,b);se[c[(b+8|0)>>2]&3](151,252,-1.0,490,b);se[c[(b+8|0)>>2]&3](151,253,1.0,491,b);se[c[(b+8|0)>>2]&3](152,233,1.0,492,b);se[c[(b+8|0)>>2]&3](152,251,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10552>>3],493,b);se[c[(b+8|0)>>2]&3](152,264,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+10576>>3],494,b);se[c[(b+8|0)>>2]&3](153,211,1.0,495,b);se[c[(b+8|0)>>2]&3](153,250,1.0,496,b);se[c[(b+8|0)>>2]&3](153,251,1.0,497,b);se[c[(b+8|0)>>2]&3](154,220,1.0,498,b);se[c[(b+8|0)>>2]&3](154,249,1.0,499,b);se[c[(b+8|0)>>2]&3](154,250,-1.0,500,b);se[c[(b+8|0)>>2]&3](155,201,1.0,501,b);se[c[(b+8|0)>>2]&3](155,248,-1.0,502,b);se[c[(b+8|0)>>2]&3](155,249,-1.0,503,b);se[c[(b+8|0)>>2]&3](156,237,.8660254037844387,504,b);se[c[(b+8|0)>>2]&3](156,247,-1.0,505,b);se[c[(b+8|0)>>2]&3](156,248,-.4999999999999999,506,b);se[c[(b+8|0)>>2]&3](157,240,-1.0,507,b);se[c[(b+8|0)>>2]&3](157,246,1.0,508,b);se[c[(b+8|0)>>2]&3](157,247,6.123233995736766e-17,509,b);se[c[(b+8|0)>>2]&3](158,189,1.0,510,b);se[c[(b+8|0)>>2]&3](158,245,1.0,511,b);se[c[(b+8|0)>>2]&3](158,246,-1.0,512,b);se[c[(b+8|0)>>2]&3](159,185,1.0,513,b);se[c[(b+8|0)>>2]&3](159,244,-1.0,514,b);se[c[(b+8|0)>>2]&3](159,245,-1.0,515,b);se[c[(b+8|0)>>2]&3](160,240,6.123233995736766e-17,516,b);se[c[(b+8|0)>>2]&3](160,243,1.0,517,b);se[c[(b+8|0)>>2]&3](160,247,1.0,518,b);se[c[(b+8|0)>>2]&3](161,187,1.0,519,b);se[c[(b+8|0)>>2]&3](161,242,1.0,520,b);se[c[(b+8|0)>>2]&3](161,243,-1.0,521,b);se[c[(b+8|0)>>2]&3](162,184,1.0,522,b);se[c[(b+8|0)>>2]&3](162,241,-1.0,523,b);se[c[(b+8|0)>>2]&3](162,242,-1.0,524,b);se[c[(b+8|0)>>2]&3](163,237,.4999999999999999,525,b);se[c[(b+8|0)>>2]&3](163,240,-1.0,526,b);se[c[(b+8|0)>>2]&3](163,248,.8660254037844387,527,b);se[c[(b+8|0)>>2]&3](164,216,1.0,528,b);se[c[(b+8|0)>>2]&3](164,239,1.0,529,b);se[c[(b+8|0)>>2]&3](164,264,1.0,530,b);se[c[(b+8|0)>>2]&3](165,222,1.0,531,b);se[c[(b+8|0)>>2]&3](165,238,1.0,532,b);se[c[(b+8|0)>>2]&3](165,239,-1.0,533,b);se[c[(b+8|0)>>2]&3](166,202,1.0,534,b);se[c[(b+8|0)>>2]&3](166,237,-1.0,535,b);se[c[(b+8|0)>>2]&3](166,238,-1.0,536,b);se[c[(b+8|0)>>2]&3](167,228,-.008808799999999999,537,b);se[c[(b+8|0)>>2]&3](167,236,-1.0,538,b);se[c[(b+8|0)>>2]&3](167,266,-.09,539,b);se[c[(b+8|0)>>2]&3](168,234,-+h[(c[(a+416|0)>>2]|0)+33544>>3],540,b);se[c[(b+8|0)>>2]&3](168,235,+h[(c[(a+416|0)>>2]|0)+33552>>3],541,b);se[c[(b+8|0)>>2]&3](168,236,-1.0,542,b);se[c[(b+8|0)>>2]&3](169,226,1.0,543,b);se[c[(b+8|0)>>2]&3](169,234,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+25168>>3],544,b);se[c[(b+8|0)>>2]&3](169,235,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+25144>>3],545,b);se[c[(b+8|0)>>2]&3](170,232,1.0,546,b);se[c[(b+8|0)>>2]&3](170,233,1.0,547,b);se[c[(b+8|0)>>2]&3](170,235,-1.0,548,b);se[c[(b+8|0)>>2]&3](171,225,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23216>>3]*-2.0328,549,b);se[c[(b+8|0)>>2]&3](171,232,1.0,550,b);se[c[(b+8|0)>>2]&3](171,267,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23224>>3]*-2.0328,551,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](172,228,+h[e+23224>>3]*+h[f+33552>>3]- +h[e+23248>>3]*+h[f+33544>>3],552,b);se[c[(b+8|0)>>2]&3](172,231,1.0,553,b);se[c[(b+8|0)>>2]&3](172,267,-1.0,554,b);se[c[(b+8|0)>>2]&3](173,230,.4999999999999999,555,b);se[c[(b+8|0)>>2]&3](173,231,1.0,556,b);se[c[(b+8|0)>>2]&3](174,229,1.0,557,b);se[c[(b+8|0)>>2]&3](174,230,.8660254037844387,558,b);se[c[(b+8|0)>>2]&3](175,225,-1.0,559,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](175,228,+h[f+23216>>3]*+h[e+33552>>3]- +h[f+23240>>3]*+h[e+33544>>3],560,b);se[c[(b+8|0)>>2]&3](175,229,1.0,561,b);se[c[(b+8|0)>>2]&3](176,227,1.0,562,b);se[c[(b+8|0)>>2]&3](176,229,-5.237345664226305,563,b);se[c[(b+8|0)>>2]&3](176,231,-3.023782929080176,564,b);se[c[(b+8|0)>>2]&3](177,226,1.0,565,b);se[c[(b+8|0)>>2]&3](177,227,1.0,566,b);c[d+8>>2]=a;c[d+16>>2]=b;c[d+1608>>2]=0;c[d+1612>>2]=0;_setLinearMatrixA5242$1(d);c[d+8>>2]=a;c[d+16>>2]=b;c[d+1600>>2]=0;c[d+1604>>2]=0;_setLinearMatrixA5242$0(d);H=c[d+1600>>2]|0;A=c[d+1604>>2]|0;I=+g[d+1604>>2];c[d+1600>>2]=0;c[d+1604>>2]=0;if((H|0)==5){return}}function iz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,j=0,k=0,l=0.0,m=0.0,n=0,o=0;d=i;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[e+16>>3];j=c[(a+416|0)>>2]|0;k=c[(b+36|0)>>2]|0;h[k>>3]=+h[e+23904>>3]*f*+h[j+5744>>3]*-f+ +h[e+23888>>3]*f*+h[j+5752>>3]*-f;h[k+8>>3]=+h[e+23032>>3]*+h[j+38584>>3]*1.814269757448105;P4c(k+16|0,0,360)|0;P4c((c[(b+36|0)>>2]|0)+376|0,0,400)|0;k=c[(b+36|0)>>2]|0;P4c(k+776|0,0,184)|0;j=c[(a+416|0)>>2]|0;h[k+960>>3]=+h[j+44832>>3];c[(k+968|0)+0>>2]=0;c[(k+968|0)+4>>2]=0;c[(k+968|0)+8>>2]=0;c[(k+968|0)+12>>2]=0;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;h[k+984>>3]=+h[(e+23360|0)>>3]*+h[(j+38584|0)>>3]*2.0328;f=+h[(e+11488|0)>>3];h[k+992>>3]=(f*f*-.09+ +h[(e+23336|0)>>3]*+h[(j+38584|0)>>3])*2.0328;f=+h[(e+11488|0)>>3];h[k+1e3>>3]=+h[e+23344>>3]*f*+h[(j+27136|0)>>3]*-f+ +h[e+23368>>3]*f*+h[(j+27144|0)>>3]*-f;h[k+1008>>3]=0.0;k=c[(b+36|0)>>2]|0;h[k+1016>>3]=0.0;f=+h[(e+11488|0)>>3];h[k+1024>>3]=+h[(e+23336|0)>>3]*f*+h[(j+27136|0)>>3]*-f+ +h[(e+23360|0)>>3]*f*+h[(j+27144|0)>>3]*-f;h[k+1032>>3]=+h[(j+38584|0)>>3]*5.237345664226305;h[k+1040>>3]=-+h[e+26168>>3];h[k+1048>>3]=0.0;f=+h[e+16>>3];l=+h[e+11800>>3]*(+h[e+11440>>3]- +h[e+11712>>3]);m=+h[e+11792>>3]*(+h[e+11448>>3]- +h[e+11720>>3]);h[k+1056>>3]=-(f*(l+(m+f*(+h[e+11784>>3]*(+h[e+976>>3]- +h[e+11544>>3])+ +h[e+11776>>3]*(+h[e+984>>3]- +h[e+11552>>3])))))-f*(l+m);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;m=+h[(e+16|0)>>3];l=+h[e+11784>>3]*(+h[e+11440>>3]- +h[e+11712>>3]);f=+h[e+11776>>3]*(+h[e+11448>>3]- +h[e+11720>>3]);k=c[(b+36|0)>>2]|0;h[k+1064>>3]=m*(l+f)+m*(l+(f-m*(+h[e+11800>>3]*(+h[e+976>>3]- +h[e+11544>>3])+ +h[e+11792>>3]*(+h[e+984>>3]- +h[e+11552>>3]))));h[k+1072>>3]=+h[e+25952>>3];m=+h[(e+16|0)>>3];j=c[(a+416|0)>>2]|0;h[k+1080>>3]=+h[(e+11216|0)>>3]*m*+h[j+37304>>3]*-m+ +h[(e+11200|0)>>3]*m*+h[j+37312>>3]*-m;m=+h[(e+16|0)>>3];f=+h[e+11224>>3]*(+h[e+10936>>3]- +h[e+11136>>3]);l=+h[(e+11216|0)>>3]*(+h[e+10944>>3]- +h[e+11144>>3]);h[k+1088>>3]=-(m*(f+(l+m*(+h[e+11208>>3]*(+h[e+376>>3]- +h[e+11016>>3])+ +h[(e+11200|0)>>3]*(+h[e+384>>3]- +h[e+11024>>3])))))-m*(f+l);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;h[k+1096>>3]=+h[e+23240>>3]*+h[j+38584>>3]*2.0328;j=k+1104|0;k=j+80|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));n=c[(b+36|0)>>2]|0;P4c(n+1184|0,0,160)|0;o=c[(a+416|0)>>2]|0;h[n+1344>>3]=+h[o+46312>>3];c[(n+1352|0)+0>>2]=0;c[(n+1352|0)+4>>2]=0;c[(n+1352|0)+8>>2]=0;c[(n+1352|0)+12>>2]=0;l=+h[(e+10952|0)>>3];h[n+1368>>3]=(l*l*-.09+ +h[e+23216>>3]*+h[(o+38584|0)>>3])*2.0328;l=+h[(e+10952|0)>>3];h[n+1376>>3]=+h[e+23224>>3]*l*+h[(o+33544|0)>>3]*-l+ +h[e+23248>>3]*l*+h[(o+33552|0)>>3]*-l;c[(n+1384|0)+0>>2]=0;c[(n+1384|0)+4>>2]=0;c[(n+1384|0)+8>>2]=0;c[(n+1384|0)+12>>2]=0;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[n+10952>>3];e=c[(b+36|0)>>2]|0;h[e+1400>>3]=+h[n+23216>>3]*l*+h[(o+33544|0)>>3]*-l+ +h[n+23240>>3]*l*+h[(o+33552|0)>>3]*-l;h[e+1408>>3]=+h[(o+38584|0)>>3]*5.237345664226305;h[e+1416>>3]=-+h[n+26056>>3];l=+h[(n+16|0)>>3];f=+h[(n+11208|0)>>3]*(+h[n+10936>>3]- +h[n+11136>>3]);m=+h[(n+11200|0)>>3]*(+h[n+10944>>3]- +h[n+11144>>3]);h[e+1424>>3]=l*(f+m)+l*(f+(m-l*(+h[(n+11224|0)>>3]*(+h[n+376>>3]- +h[n+11016>>3])+ +h[(n+11216|0)>>3]*(+h[n+384>>3]- +h[n+11024>>3]))));l=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+1432>>3]=+h[(n+11224|0)>>3]*l*+h[o+37304>>3]*-l+ +h[(n+11208|0)>>3]*l*+h[o+37312>>3]*-l;l=+h[(n+16|0)>>3];h[e+1440>>3]=+h[(n+11216|0)>>3]*l*+h[o+37208>>3]*-l+ +h[(n+11200|0)>>3]*l*+h[o+37216>>3]*-l;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+36|0)>>2]|0;h[e+1448>>3]=+h[(n+11208|0)>>3]*+h[(o+38584|0)>>3]*.77;h[e+1456>>3]=0.0;l=+h[(n+16|0)>>3];h[e+1464>>3]=(l*l*-.05+ +h[(n+11224|0)>>3]*+h[(o+38584|0)>>3])*.77;l=+h[(n+16|0)>>3];h[e+1472>>3]=+h[(n+11216|0)>>3]*l*+h[o+35240>>3]*-l+ +h[(n+11200|0)>>3]*l*+h[o+35248>>3]*-l;l=+h[(n+16|0)>>3];h[e+1480>>3]=+h[(n+11216|0)>>3]*l*+h[o+36432>>3]*-l+ +h[(n+11200|0)>>3]*l*+h[o+36440>>3]*-l;h[e+1488>>3]=+h[(n+11208|0)>>3]*+h[(o+38584|0)>>3]*.77;c[(e+1496|0)+0>>2]=0;c[(e+1496|0)+4>>2]=0;c[(e+1496|0)+8>>2]=0;c[(e+1496|0)+12>>2]=0;c[(e+1496|0)+16>>2]=0;c[(e+1496|0)+20>>2]=0;c[(e+1496|0)+24>>2]=0;c[(e+1496|0)+28>>2]=0;l=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+1528>>3]=(l*l*.05+ +h[(n+11224|0)>>3]*+h[(o+38584|0)>>3])*.77;h[e+1536>>3]=0.0;h[e+1544>>3]=+h[(n+11208|0)>>3]*+h[(o+38584|0)>>3]*.653137112681318;h[e+1552>>3]=+h[(n+11224|0)>>3]*+h[(o+38584|0)>>3]*.653137112681318;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1560>>3]=+h[(n+11224|0)>>3]*l*+h[o+37208>>3]*-l+ +h[(n+11208|0)>>3]*l*+h[o+37216>>3]*-l;l=+h[(n+16|0)>>3];h[e+1568>>3]=+h[(n+11224|0)>>3]*l*+h[o+35240>>3]*-l+ +h[(n+11208|0)>>3]*l*+h[o+35248>>3]*-l;l=+h[(n+16|0)>>3];h[e+1576>>3]=+h[(n+11224|0)>>3]*l*+h[o+36432>>3]*-l+ +h[(n+11208|0)>>3]*l*+h[o+36440>>3]*-l;c[(e+1584|0)+0>>2]=0;c[(e+1584|0)+4>>2]=0;c[(e+1584|0)+8>>2]=0;c[(e+1584|0)+12>>2]=0;l=+h[(n+16|0)>>3];h[e+1600>>3]=+h[(n+23968|0)>>3]*l*+h[o+37784>>3]*-l+ +h[n+23992>>3]*l*+h[o+37792>>3]*-l;o=c[(a+416|0)>>2]|0;h[e+1608>>3]=+h[(n+11208|0)>>3]*+h[(o+38584|0)>>3]*1.814269757448105;h[e+1616>>3]=+h[(n+11224|0)>>3]*+h[(o+38584|0)>>3]*1.814269757448105;l=+h[(n+16|0)>>3];h[e+1624>>3]=+h[n+23960>>3]*l*+h[o+37784>>3]*-l+ +h[n+23984>>3]*l*+h[o+37792>>3]*-l;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1632>>3]=+h[(n+11792|0)>>3]*l*+h[(o+31760|0)>>3]*-l+ +h[(n+11776|0)>>3]*l*+h[(o+31768|0)>>3]*-l;l=+h[(n+16|0)>>3];h[e+1640>>3]=+h[(n+11800|0)>>3]*l*+h[(o+31760|0)>>3]*-l+ +h[(n+11784|0)>>3]*l*+h[(o+31768|0)>>3]*-l;l=+h[(n+16|0)>>3];h[e+1648>>3]=+h[n+12e3>>3]*l*+h[o+31376>>3]*-l+ +h[n+11984>>3]*l*+h[o+31384>>3]*-l;l=+h[(n+16|0)>>3];h[e+1656>>3]=+h[(n+11792|0)>>3]*l*+h[o+30800>>3]*-l+ +h[(n+11776|0)>>3]*l*+h[o+30808>>3]*-l;o=c[(a+416|0)>>2]|0;h[e+1664>>3]=+h[(n+11784|0)>>3]*+h[(o+38584|0)>>3]*.77;h[e+1672>>3]=0.0;l=+h[(n+16|0)>>3];h[e+1680>>3]=(l*l*-.05+ +h[(n+11800|0)>>3]*+h[(o+38584|0)>>3])*.77;l=+h[(n+16|0)>>3];h[e+1688>>3]=+h[(n+11792|0)>>3]*l*+h[o+28832>>3]*-l+ +h[(n+11776|0)>>3]*l*+h[o+28840>>3]*-l;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1696>>3]=+h[(n+11792|0)>>3]*l*+h[o+30896>>3]*-l+ +h[(n+11776|0)>>3]*l*+h[o+30904>>3]*-l;l=+h[(n+16|0)>>3];h[e+1704>>3]=+h[(n+11792|0)>>3]*l*+h[o+30024>>3]*-l+ +h[(n+11776|0)>>3]*l*+h[o+30032>>3]*-l;h[e+1712>>3]=+h[(n+11784|0)>>3]*+h[(o+38584|0)>>3]*.77;h[e+1720>>3]=0.0;l=+h[(n+16|0)>>3];h[e+1728>>3]=(l*l*.05+ +h[(n+11800|0)>>3]*+h[(o+38584|0)>>3])*.77;l=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+1736>>3]=+h[(n+11792|0)>>3]*l*+h[o+28032>>3]*-l+ +h[(n+11776|0)>>3]*l*+h[o+28040>>3]*-l;h[e+1744>>3]=+h[(n+11784|0)>>3]*+h[(o+38584|0)>>3]*.653137112681318;h[e+1752>>3]=+h[(n+11800|0)>>3]*+h[(o+38584|0)>>3]*.653137112681318;h[e+1760>>3]=+h[(n+11784|0)>>3]*+h[(o+38584|0)>>3]*1.814269757448105;h[e+1768>>3]=+h[(n+11800|0)>>3]*+h[(o+38584|0)>>3]*1.814269757448105;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1776>>3]=+h[n+12008>>3]*l*+h[o+31376>>3]*-l+ +h[n+11992>>3]*l*+h[o+31384>>3]*-l;l=+h[(n+16|0)>>3];h[e+1784>>3]=+h[(n+11800|0)>>3]*l*+h[o+30800>>3]*-l+ +h[(n+11784|0)>>3]*l*+h[o+30808>>3]*-l;l=+h[(n+16|0)>>3];h[e+1792>>3]=+h[(n+11800|0)>>3]*l*+h[o+28832>>3]*-l+ +h[(n+11784|0)>>3]*l*+h[o+28840>>3]*-l;l=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+1800>>3]=+h[(n+11800|0)>>3]*l*+h[o+30896>>3]*-l+ +h[(n+11784|0)>>3]*l*+h[o+30904>>3]*-l;l=+h[(n+16|0)>>3];h[e+1808>>3]=+h[(n+11800|0)>>3]*l*+h[o+30024>>3]*-l+ +h[(n+11784|0)>>3]*l*+h[o+30032>>3]*-l;l=+h[(n+16|0)>>3];h[e+1816>>3]=+h[(n+11800|0)>>3]*l*+h[o+28032>>3]*-l+ +h[(n+11784|0)>>3]*l*+h[o+28040>>3]*-l;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1824>>3]=+h[(n+12440|0)>>3]*l*+h[(o+25352|0)>>3]*-l+ +h[(n+12424|0)>>3]*l*+h[(o+25360|0)>>3]*-l;l=+h[(n+16|0)>>3];h[e+1832>>3]=+h[(n+12448|0)>>3]*l*+h[(o+25352|0)>>3]*-l+ +h[(n+12432|0)>>3]*l*+h[(o+25360|0)>>3]*-l;l=+h[(n+16|0)>>3];h[e+1840>>3]=+h[n+12648>>3]*l*+h[o+24968>>3]*-l+ +h[n+12632>>3]*l*+h[o+24976>>3]*-l;l=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+1848>>3]=+h[(n+12440|0)>>3]*l*+h[o+24392>>3]*-l+ +h[(n+12424|0)>>3]*l*+h[o+24400>>3]*-l;h[e+1856>>3]=+h[(n+12432|0)>>3]*+h[(o+38584|0)>>3]*.77;h[e+1864>>3]=0.0;l=+h[(n+16|0)>>3];h[e+1872>>3]=(l*l*-.05+ +h[(n+12448|0)>>3]*+h[(o+38584|0)>>3])*.77;l=+h[(n+16|0)>>3];h[e+1880>>3]=+h[(n+12440|0)>>3]*l*+h[o+22424>>3]*-l+ +h[(n+12424|0)>>3]*l*+h[o+22432>>3]*-l;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1888>>3]=+h[(n+12440|0)>>3]*l*+h[o+24488>>3]*-l+ +h[(n+12424|0)>>3]*l*+h[o+24496>>3]*-l;l=+h[(n+16|0)>>3];m=+h[n+12448>>3]*(+h[n+12088>>3]- +h[n+12360>>3]);f=+h[(n+12440|0)>>3]*(+h[n+12096>>3]- +h[n+12368>>3]);h[e+1896>>3]=-(l*(m+(f+l*(+h[n+12432>>3]*(+h[n+1600>>3]- +h[n+12192>>3])+ +h[(n+12424|0)>>3]*(+h[n+1608>>3]- +h[n+12200>>3])))))-l*(m+f);o=c[(a+416|0)>>2]|0;h[e+1904>>3]=+h[n+23480>>3]*+h[(o+38584|0)>>3]*2.0328;j=e+1912|0;k=j+40|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));h[e+1952>>3]=+h[(o+43352|0)>>3];c[(e+1960|0)+0>>2]=0;c[(e+1960|0)+4>>2]=0;c[(e+1960|0)+8>>2]=0;c[(e+1960|0)+12>>2]=0;f=+h[(n+12104|0)>>3];h[e+1976>>3]=(f*f*-.09+ +h[n+23456>>3]*+h[(o+38584|0)>>3])*2.0328;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(n+12104|0)>>3];e=c[(b+36|0)>>2]|0;h[e+1984>>3]=+h[n+23464>>3]*f*+h[(o+20728|0)>>3]*-f+ +h[n+23488>>3]*f*+h[(o+20736|0)>>3]*-f;c[(e+1992|0)+0>>2]=0;c[(e+1992|0)+4>>2]=0;c[(e+1992|0)+8>>2]=0;c[(e+1992|0)+12>>2]=0;f=+h[(n+12104|0)>>3];h[e+2008>>3]=+h[(n+23456|0)>>3]*f*+h[(o+20728|0)>>3]*-f+ +h[n+23480>>3]*f*+h[(o+20736|0)>>3]*-f;h[e+2016>>3]=+h[(o+38584|0)>>3]*5.237345664226305;h[e+2024>>3]=-+h[n+26280>>3];f=+h[(n+16|0)>>3];m=+h[n+12432>>3]*(+h[n+12088>>3]- +h[n+12360>>3]);l=+h[(n+12424|0)>>3]*(+h[n+12096>>3]- +h[n+12368>>3]);h[e+2032>>3]=f*(m+l)+f*(m+(l-f*(+h[n+12448>>3]*(+h[n+1600>>3]- +h[n+12192>>3])+ +h[(n+12440|0)>>3]*(+h[n+1608>>3]- +h[n+12200>>3]))));f=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+2040>>3]=+h[(n+12440|0)>>3]*f*+h[o+23616>>3]*-f+ +h[(n+12424|0)>>3]*f*+h[o+23624>>3]*-f;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+36|0)>>2]|0;h[e+2048>>3]=+h[(n+12432|0)>>3]*+h[(o+38584|0)>>3]*.77;h[e+2056>>3]=0.0;f=+h[(n+16|0)>>3];h[e+2064>>3]=(f*f*.05+ +h[(n+12448|0)>>3]*+h[(o+38584|0)>>3])*.77;f=+h[(n+16|0)>>3];h[e+2072>>3]=+h[n+12440>>3]*f*+h[o+21624>>3]*-f+ +h[n+12424>>3]*f*+h[o+21632>>3]*-f;h[e+2080>>3]=+h[(n+12432|0)>>3]*+h[(o+38584|0)>>3]*.653137112681318;h[e+2088>>3]=+h[(n+12448|0)>>3]*+h[(o+38584|0)>>3]*.653137112681318;h[e+2096>>3]=+h[(n+12432|0)>>3]*+h[(o+38584|0)>>3]*1.814269757448105;h[e+2104>>3]=+h[(n+12448|0)>>3]*+h[(o+38584|0)>>3]*1.814269757448105;f=+h[(n+16|0)>>3];h[e+2112>>3]=+h[n+12656>>3]*f*+h[o+24968>>3]*-f+ +h[n+12640>>3]*f*+h[o+24976>>3]*-f;f=+h[(n+16|0)>>3];o=c[(a+416|0)>>2]|0;h[e+2120>>3]=+h[(n+12448|0)>>3]*f*+h[o+24392>>3]*-f+ +h[(n+12432|0)>>3]*f*+h[o+24400>>3]*-f;n=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(n+16|0)>>3];e=c[(b+36|0)>>2]|0;h[e+2128>>3]=+h[(n+12448|0)>>3]*f*+h[o+22424>>3]*-f+ +h[(n+12432|0)>>3]*f*+h[o+22432>>3]*-f;f=+h[(n+16|0)>>3];c[d+8>>2]=a;c[d+16>>2]=b;c[d+248>>2]=o;c[d+264>>2]=n;c[d+280>>2]=e;g[d+288>>2]=f;c[d+1888>>2]=j;c[d+1904>>2]=k;c[d+1912>>2]=0;c[d+1916>>2]=0;_setLinearVectorb5242$0(d);j=c[d+1888>>2]|0;k=c[d+1904>>2]|0;H=c[d+1912>>2]|0;A=c[d+1916>>2]|0;I=+g[d+1916>>2];c[d+1912>>2]=0;c[d+1916>>2]=0;if((H|0)==5){return}}function jz(a){a=a|0;c[a+20>>2]=494;c[a+16>>2]=2;c[a+12>>2]=4;c[a>>2]=55;c[a+4>>2]=56;c[a+84>>2]=532;c[a+80>>2]=2;c[a+76>>2]=4;c[a+64>>2]=57;c[a+68>>2]=58;c[a+148>>2]=570;c[a+144>>2]=2;c[a+140>>2]=4;c[a+128>>2]=59;c[a+132>>2]=60;c[a+212>>2]=608;c[a+208>>2]=2;c[a+204>>2]=4;c[a+192>>2]=61;c[a+196>>2]=62;c[a+276>>2]=646;c[a+272>>2]=2;c[a+268>>2]=4;c[a+256>>2]=63;c[a+260>>2]=64;c[a+340>>2]=684;c[a+336>>2]=2;c[a+332>>2]=4;c[a+320>>2]=65;c[a+324>>2]=66;c[a+404>>2]=845;c[a+400>>2]=2;c[a+396>>2]=4;c[a+384>>2]=67;c[a+388>>2]=68;c[a+468>>2]=846;c[a+464>>2]=4;c[a+460>>2]=8;c[a+448>>2]=69;c[a+452>>2]=70;c[a+532>>2]=861;c[a+528>>2]=2;c[a+524>>2]=4;c[a+512>>2]=71;c[a+516>>2]=72;c[a+596>>2]=862;c[a+592>>2]=4;c[a+588>>2]=8;c[a+576>>2]=73;c[a+580>>2]=74;c[a+660>>2]=877;c[a+656>>2]=2;c[a+652>>2]=4;c[a+640>>2]=75;c[a+644>>2]=76;c[a+724>>2]=878;c[a+720>>2]=4;c[a+716>>2]=8;c[a+704>>2]=77;c[a+708>>2]=78;c[a+788>>2]=893;c[a+784>>2]=2;c[a+780>>2]=4;c[a+768>>2]=79;c[a+772>>2]=80;c[a+852>>2]=894;c[a+848>>2]=4;c[a+844>>2]=8;c[a+832>>2]=81;c[a+836>>2]=82;c[a+916>>2]=909;c[a+912>>2]=2;c[a+908>>2]=4;c[a+896>>2]=83;c[a+900>>2]=84;c[a+980>>2]=910;c[a+976>>2]=4;c[a+972>>2]=8;c[a+960>>2]=85;c[a+964>>2]=86;c[a+1044>>2]=925;c[a+1040>>2]=2;c[a+1036>>2]=4;c[a+1024>>2]=87;c[a+1028>>2]=88;c[a+1108>>2]=926;c[a+1104>>2]=4;c[a+1100>>2]=8;c[a+1088>>2]=89;c[a+1092>>2]=90;c[a+1172>>2]=931;c[a+1168>>2]=404;c[a+1164>>2]=1255;c[a+1152>>2]=91;c[a+1156>>2]=92;c[a+1236>>2]=4875;c[a+1232>>2]=2;c[a+1228>>2]=4;c[a+1216>>2]=93;c[a+1220>>2]=94;c[a+1300>>2]=4904;c[a+1296>>2]=2;c[a+1292>>2]=4;c[a+1280>>2]=95;c[a+1284>>2]=96;c[a+1364>>2]=4905;c[a+1360>>2]=4;c[a+1356>>2]=8;c[a+1344>>2]=97;c[a+1348>>2]=98;c[a+1428>>2]=4937;c[a+1424>>2]=2;c[a+1420>>2]=4;c[a+1408>>2]=99;c[a+1412>>2]=100;c[a+1492>>2]=4966;c[a+1488>>2]=2;c[a+1484>>2]=4;c[a+1472>>2]=101;c[a+1476>>2]=102;c[a+1556>>2]=4967;c[a+1552>>2]=4;c[a+1548>>2]=8;c[a+1536>>2]=103;c[a+1540>>2]=104;c[a+1620>>2]=4999;c[a+1616>>2]=2;c[a+1612>>2]=4;c[a+1600>>2]=105;c[a+1604>>2]=106;c[a+1684>>2]=5028;c[a+1680>>2]=2;c[a+1676>>2]=4;c[a+1664>>2]=107;c[a+1668>>2]=108;c[a+1748>>2]=5029;c[a+1744>>2]=4;c[a+1740>>2]=8;c[a+1728>>2]=109;c[a+1732>>2]=110;c[a+1812>>2]=5061;c[a+1808>>2]=2;c[a+1804>>2]=4;c[a+1792>>2]=111;c[a+1796>>2]=112;c[a+1876>>2]=5090;c[a+1872>>2]=2;c[a+1868>>2]=4;c[a+1856>>2]=113;c[a+1860>>2]=114;c[a+1940>>2]=5091;c[a+1936>>2]=4;c[a+1932>>2]=8;c[a+1920>>2]=115;c[a+1924>>2]=116;c[a+2004>>2]=5123;c[a+2e3>>2]=2;c[a+1996>>2]=4;c[a+1984>>2]=117;c[a+1988>>2]=118;c[a+2068>>2]=5152;c[a+2064>>2]=2;c[a+2060>>2]=4;c[a+2048>>2]=119;c[a+2052>>2]=120;c[a+2132>>2]=5153;c[a+2128>>2]=4;c[a+2124>>2]=8;c[a+2112>>2]=121;c[a+2116>>2]=122;c[a+2196>>2]=5182;c[a+2192>>2]=2;c[a+2188>>2]=4;c[a+2176>>2]=123;c[a+2180>>2]=124;c[a+2260>>2]=5211;c[a+2256>>2]=2;c[a+2252>>2]=4;c[a+2240>>2]=125;c[a+2244>>2]=126;c[a+2324>>2]=5212;c[a+2320>>2]=4;c[a+2316>>2]=8;c[a+2304>>2]=127;c[a+2308>>2]=128;c[a+2388>>2]=5242;c[a+2384>>2]=404;c[a+2380>>2]=1255;c[a+2368>>2]=129;c[a+2372>>2]=130;i=i;return}function kz(a,b){a=a|0;b=b|0;i=i;return}function lz(a){a=a|0;i=i;return}function mz(a,b){a=a|0;b=b|0;c[b>>2]=c[4088+(a<<2)>>2];i=i;return c[4160+(a<<2)>>2]|0}function nz(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=b+4|0;g=b+360|0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0,a[c[g>>2]|0]|0)|0)<<24>>24!=0;h[d>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3],.987,a[(c[g>>2]|0)+1|0]|0)|0)<<24>>24!=0;h[d+8>>3]=b?1.0:-1.0;b=(REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3],.93,a[(c[g>>2]|0)+2|0]|0)|0)<<24>>24!=0;h[d+16>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0,a[(c[g>>2]|0)+3|0]|0)|0)<<24>>24!=0;h[d+24>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3],.987,a[(c[g>>2]|0)+4|0]|0)|0)<<24>>24!=0;h[d+32>>3]=b?1.0:-1.0;b=(REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3],.93,a[(c[g>>2]|0)+5|0]|0)|0)<<24>>24!=0;h[d+40>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0,a[(c[g>>2]|0)+6|0]|0)|0)<<24>>24!=0;h[d+48>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3],.987,a[(c[g>>2]|0)+7|0]|0)|0)<<24>>24!=0;h[d+56>>3]=b?1.0:-1.0;b=(REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3],.93,a[(c[g>>2]|0)+8|0]|0)|0)<<24>>24!=0;h[d+64>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0,a[(c[g>>2]|0)+9|0]|0)|0)<<24>>24!=0;h[d+72>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3],.987,a[(c[g>>2]|0)+10|0]|0)|0)<<24>>24!=0;h[d+80>>3]=b?1.0:-1.0;b=(REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3],.93,a[(c[g>>2]|0)+11|0]|0)|0)<<24>>24!=0;h[d+88>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0,a[(c[g>>2]|0)+12|0]|0)|0)<<24>>24!=0;h[d+96>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3],.987,a[(c[g>>2]|0)+13|0]|0)|0)<<24>>24!=0;h[d+104>>3]=b?1.0:-1.0;b=(REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3],.93,a[(c[g>>2]|0)+14|0]|0)|0)<<24>>24!=0;h[d+112>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0,a[(c[g>>2]|0)+15|0]|0)|0)<<24>>24!=0;h[d+120>>3]=b?1.0:-1.0;b=(QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3],.987,a[(c[g>>2]|0)+16|0]|0)|0)<<24>>24!=0;h[d+128>>3]=b?1.0:-1.0;b=(REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3],.93,a[(c[g>>2]|0)+17|0]|0)|0)<<24>>24!=0;h[d+136>>3]=b?1.0:-1.0;i=e;return 0}function oz(a){a=a|0;i=i;return c[4160+(a<<2)>>2]|0}function pz(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0,k=0;e=i;f=b+4|0;g=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+25968>>3];if((d|0)==0){d=b+352|0;a[c[d>>2]|0]=g<0.0|0;a[(c[d>>2]|0)+1|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3]<.987|0;a[(c[d>>2]|0)+2|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3]>.93|0;a[(c[d>>2]|0)+3|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26080>>3]<0.0|0;a[(c[d>>2]|0)+4|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3]<.987|0;a[(c[d>>2]|0)+5|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3]>.93|0;a[(c[d>>2]|0)+6|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26192>>3]<0.0|0;a[(c[d>>2]|0)+7|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3]<.987|0;a[(c[d>>2]|0)+8|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3]>.93|0;a[(c[d>>2]|0)+9|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26304>>3]<0.0|0;a[(c[d>>2]|0)+10|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3]<.987|0;a[(c[d>>2]|0)+11|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3]>.93|0;a[(c[d>>2]|0)+12|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26416>>3]<0.0|0;a[(c[d>>2]|0)+13|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3]<.987|0;a[(c[d>>2]|0)+14|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3]>.93|0;a[(c[d>>2]|0)+15|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26528>>3]<0.0|0;a[(c[d>>2]|0)+16|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3]<.987|0;a[(c[d>>2]|0)+17|0]=+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3]>.93|0;i=e;return 0}else{d=b+360|0;j=QEc(g,0.0,a[c[d>>2]|0]|0)|0;k=b+352|0;a[c[k>>2]|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3],.987,a[(c[d>>2]|0)+1|0]|0)|0;a[(c[k>>2]|0)+1|0]=j;j=REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3],.93,a[(c[d>>2]|0)+2|0]|0)|0;a[(c[k>>2]|0)+2|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0,a[(c[d>>2]|0)+3|0]|0)|0;a[(c[k>>2]|0)+3|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3],.987,a[(c[d>>2]|0)+4|0]|0)|0;a[(c[k>>2]|0)+4|0]=j;j=REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3],.93,a[(c[d>>2]|0)+5|0]|0)|0;a[(c[k>>2]|0)+5|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0,a[(c[d>>2]|0)+6|0]|0)|0;a[(c[k>>2]|0)+6|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3],.987,a[(c[d>>2]|0)+7|0]|0)|0;a[(c[k>>2]|0)+7|0]=j;j=REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3],.93,a[(c[d>>2]|0)+8|0]|0)|0;a[(c[k>>2]|0)+8|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0,a[(c[d>>2]|0)+9|0]|0)|0;a[(c[k>>2]|0)+9|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3],.987,a[(c[d>>2]|0)+10|0]|0)|0;a[(c[k>>2]|0)+10|0]=j;j=REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3],.93,a[(c[d>>2]|0)+11|0]|0)|0;a[(c[k>>2]|0)+11|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0,a[(c[d>>2]|0)+12|0]|0)|0;a[(c[k>>2]|0)+12|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3],.987,a[(c[d>>2]|0)+13|0]|0)|0;a[(c[k>>2]|0)+13|0]=j;j=REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3],.93,a[(c[d>>2]|0)+14|0]|0)|0;a[(c[k>>2]|0)+14|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0,a[(c[d>>2]|0)+15|0]|0)|0;a[(c[k>>2]|0)+15|0]=j;j=QEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3],.987,a[(c[d>>2]|0)+16|0]|0)|0;a[(c[k>>2]|0)+16|0]=j;j=REc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3],.93,a[(c[d>>2]|0)+17|0]|0)|0;a[(c[k>>2]|0)+17|0]=j;i=e;return 0}return 0}function qz(a){a=a|0;a=i;i=i+8|0;EBc(8,1,4232,a);if((c[292336>>2]|0)==0){i=a;return 0}fe[c[73214]&1023](8);i=a;return 0}function rz(a){a=a|0;i=i;return c[4312+(a<<2)>>2]|0}function sz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0.0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;EBc(21,1,4320,g);g=a+4|0;j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+32>>3];h[b>>3]=j;a=rz(0)|0;c[f>>2]=1;c[f+4>>2]=a;a=f+8|0;h[k>>3]=j;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];EBc(21,0,4352,f);j=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+40>>3];h[b+8>>3]=j;b=rz(1)|0;c[e>>2]=2;c[e+4>>2]=b;b=e+8|0;h[k>>3]=j;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];EBc(21,0,4352,e);if((c[292388>>2]|0)==0){i=d;return 0}fe[c[73214]&1023](21);i=d;return 0}function tz(b){b=b|0;h[(c[b+416>>2]|0)+47736>>3]=(a[(c[b+424>>2]|0)+556|0]|0)!=0?.6435942529055827:1.0;i=i;return}function uz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47736>>3];j=+h[f+47720>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4376,4368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47744>>3]=l*6.283185307179586;i=d;return}function vz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37392>>3]=+h[b+46240>>3]+ +h[b+46256>>3]*-.5;i=i;return}function wz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+37392>>3]- +h[b+37512>>3];e=+h[b+37400>>3]- +h[b+37520>>3];f=+h[b+37408>>3]- +h[b+37528>>3];h[b+47552>>3]=+V(+(d*d+e*e+f*f));i=i;return}function xz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47552>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47560>>3]=l;i=d;return}function yz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47568>>3]=+h[b+47560>>3];i=i;return}function zz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37296>>3]=+h[b+46256>>3]*.5;i=i;return}function Az(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+37296>>3]- +h[b+37320>>3];e=+h[b+37304>>3]- +h[b+37328>>3];f=+h[b+37312>>3]- +h[b+37336>>3];h[b+47512>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Bz(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47512>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47520>>3]=l;i=d;return}function Cz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47528>>3]=+h[b+47520>>3];i=i;return}function Dz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37216>>3]=+h[b+36536>>3];i=i;return}function Ez(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37208>>3]=+h[b+36528>>3];i=i;return}function Fz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36520>>3]=+h[b+46240>>3]- +h[b+46256>>3];i=i;return}function Gz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37200>>3]=+h[b+36520>>3];i=i;return}function Hz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36440>>3]=+h[b+35760>>3];i=i;return}function Iz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36432>>3]=+h[b+35752>>3];i=i;return}function Jz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35744>>3]=+h[b+46256>>3];i=i;return}function Kz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36424>>3]=+h[b+35744>>3];i=i;return}function Lz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35248>>3]=+h[b+34960>>3];i=i;return}function Mz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35232>>3]=+h[b+34944>>3];i=i;return}function Nz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34952>>3]=+h[b+46248>>3];i=i;return}function Oz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+34944>>3]- +h[b+34968>>3];e=+h[b+34952>>3]- +h[b+34976>>3];f=+h[b+34960>>3]- +h[b+34984>>3];h[b+46976>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Pz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47032>>3]=+h[b+46976>>3];i=i;return}function Qz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35240>>3]=+h[b+34952>>3];i=i;return}function Rz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34448>>3]=+h[b+34160>>3];i=i;return}function Sz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34432>>3]=+h[b+34144>>3];i=i;return}function Tz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34152>>3]=-+h[b+46248>>3];i=i;return}function Uz(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+34144>>3]- +h[b+34168>>3];e=+h[b+34152>>3]- +h[b+34176>>3];f=+h[b+34160>>3]- +h[b+34184>>3];h[b+46800>>3]=+V(+(d*d+e*e+f*f));i=i;return}function Vz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46856>>3]=+h[b+46800>>3];i=i;return}function Wz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34440>>3]=+h[b+34152>>3];i=i;return}function Xz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46776>>3]=+h[b+46216>>3]+(+h[b+46248>>3]+(-+h[b+46232>>3]- +h[b+46224>>3]));i=i;return}function Yz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47656>>3]=+h[b+46776>>3];i=i;return}function Zz(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34048>>3]=+h[b+46240>>3];i=i;return}function _z(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+34048>>3]- +h[b+34072>>3];e=+h[b+34056>>3]- +h[b+34080>>3];f=+h[b+34064>>3]- +h[b+34088>>3];h[b+46752>>3]=+V(+(d*d+e*e+f*f));i=i;return}function $z(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46752>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46760>>3]=l;i=d;return}function aA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46768>>3]=+h[b+46760>>3];i=i;return}function bA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33552>>3]=+h[b+33264>>3];i=i;return}function cA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33536>>3]=+h[b+33248>>3];i=i;return}function dA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33256>>3]=+h[b+46232>>3];i=i;return}function eA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+33248>>3]- +h[b+33272>>3];e=+h[b+33256>>3]- +h[b+33280>>3];f=+h[b+33264>>3]- +h[b+33288>>3];h[b+46584>>3]=+V(+(d*d+e*e+f*f));i=i;return}function fA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46640>>3]=+h[b+46584>>3];i=i;return}function gA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33544>>3]=+h[b+33256>>3];i=i;return}function hA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33168>>3]=+h[b+32488>>3];i=i;return}function iA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33152>>3]=+h[b+32472>>3];i=i;return}function jA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32480>>3]=+h[b+46224>>3];i=i;return}function kA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+32472>>3]- +h[b+32496>>3];e=+h[b+32480>>3]- +h[b+32504>>3];f=+h[b+32488>>3]- +h[b+32512>>3];h[b+46400>>3]=+V(+(d*d+e*e+f*f));i=i;return}function lA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46544>>3]=+h[b+46400>>3];i=i;return}function mA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33160>>3]=+h[b+32480>>3];i=i;return}function nA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32384>>3]=+h[b+46216>>3];i=i;return}function oA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+32376>>3]- +h[b+32400>>3];e=+h[b+32384>>3]- +h[b+32408>>3];f=+h[b+32392>>3]- +h[b+32416>>3];h[b+46360>>3]=+V(+(d*d+e*e+f*f));i=i;return}function pA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46360>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46368>>3]=l;i=d;return}function qA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46376>>3]=+h[b+46368>>3];i=i;return}function rA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30984>>3]=+h[b+44760>>3]+ +h[b+44776>>3]*-.5;i=i;return}function sA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+30984>>3]- +h[b+31104>>3];e=+h[b+30992>>3]- +h[b+31112>>3];f=+h[b+31e3>>3]- +h[b+31120>>3];h[b+46072>>3]=+V(+(d*d+e*e+f*f));i=i;return}function tA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46072>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4456,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46080>>3]=l;i=d;return}function uA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46088>>3]=+h[b+46080>>3];i=i;return}function vA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30888>>3]=+h[b+44776>>3]*.5;i=i;return}function wA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+30888>>3]- +h[b+30912>>3];e=+h[b+30896>>3]- +h[b+30920>>3];f=+h[b+30904>>3]- +h[b+30928>>3];h[b+46032>>3]=+V(+(d*d+e*e+f*f));i=i;return}function xA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46032>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4464,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46040>>3]=l;i=d;return}function yA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46048>>3]=+h[b+46040>>3];i=i;return}function zA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30808>>3]=+h[b+30128>>3];i=i;return}function AA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30800>>3]=+h[b+30120>>3];i=i;return}function BA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30112>>3]=+h[b+44760>>3]- +h[b+44776>>3];i=i;return}function CA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30792>>3]=+h[b+30112>>3];i=i;return}function DA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30032>>3]=+h[b+29352>>3];i=i;return}function EA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30024>>3]=+h[b+29344>>3];i=i;return}function FA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29336>>3]=+h[b+44776>>3];i=i;return}function GA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30016>>3]=+h[b+29336>>3];i=i;return}function HA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28840>>3]=+h[b+28552>>3];i=i;return}function IA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28824>>3]=+h[b+28536>>3];i=i;return}function JA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28544>>3]=+h[b+44768>>3];i=i;return}function KA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+28536>>3]- +h[b+28560>>3];e=+h[b+28544>>3]- +h[b+28568>>3];f=+h[b+28552>>3]- +h[b+28576>>3];h[b+45496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function LA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45552>>3]=+h[b+45496>>3];i=i;return}function MA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28832>>3]=+h[b+28544>>3];i=i;return}function NA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28040>>3]=+h[b+27752>>3];i=i;return}function OA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28024>>3]=+h[b+27736>>3];i=i;return}function PA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27744>>3]=-+h[b+44768>>3];i=i;return}function QA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+27736>>3]- +h[b+27760>>3];e=+h[b+27744>>3]- +h[b+27768>>3];f=+h[b+27752>>3]- +h[b+27776>>3];h[b+45320>>3]=+V(+(d*d+e*e+f*f));i=i;return}function RA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45376>>3]=+h[b+45320>>3];i=i;return}function SA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28032>>3]=+h[b+27744>>3];i=i;return}function TA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45296>>3]=+h[b+44736>>3]+(+h[b+44768>>3]+(-+h[b+44752>>3]- +h[b+44744>>3]));i=i;return}function UA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46176>>3]=+h[b+45296>>3];i=i;return}function VA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27640>>3]=+h[b+44760>>3];i=i;return}function _setLinearMatrixA5242$0(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+8>>2]|0;d=c[a+16>>2]|0;a:do{se[c[(d+8|0)>>2]&3](286,118,-1.0,906,d);se[c[(d+8|0)>>2]&3](287,108,1.0,907,d);se[c[(d+8|0)>>2]&3](287,116,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24520>>3],908,d);se[c[(d+8|0)>>2]&3](287,117,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24544>>3],909,d);se[c[(d+8|0)>>2]&3](288,114,1.0,910,d);se[c[(d+8|0)>>2]&3](288,115,1.0,911,d);se[c[(d+8|0)>>2]&3](288,116,-1.0,912,d);se[c[(d+8|0)>>2]&3](289,107,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23584>>3]*-2.0328,913,d);se[c[(d+8|0)>>2]&3](289,114,1.0,914,d);se[c[(d+8|0)>>2]&3](289,124,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23576>>3]*-2.0328,915,d);se[c[(d+8|0)>>2]&3](290,110,1.0,916,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](290,113,+h[e+23576>>3]*+h[f+14328>>3]- +h[e+23600>>3]*+h[f+14320>>3],917,d);se[c[(d+8|0)>>2]&3](290,124,-1.0,918,d);se[c[(d+8|0)>>2]&3](291,107,-1.0,919,d);se[c[(d+8|0)>>2]&3](291,112,1.0,920,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](291,113,+h[f+23584>>3]*+h[e+14328>>3]- +h[f+23608>>3]*+h[e+14320>>3],921,d);se[c[(d+8|0)>>2]&3](292,111,-.4999999999999999,922,d);se[c[(d+8|0)>>2]&3](292,112,1.0,923,d);se[c[(d+8|0)>>2]&3](293,110,1.0,924,d);se[c[(d+8|0)>>2]&3](293,111,.8660254037844387,925,d);se[c[(d+8|0)>>2]&3](294,109,1.0,926,d);se[c[(d+8|0)>>2]&3](294,110,-5.237345664226305,927,d);se[c[(d+8|0)>>2]&3](294,112,3.023782929080176,928,d);se[c[(d+8|0)>>2]&3](295,108,1.0,929,d);se[c[(d+8|0)>>2]&3](295,109,1.0,930,d);se[c[(d+8|0)>>2]&3](296,94,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3],931,d);se[c[(d+8|0)>>2]&3](296,107,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3],932,d);se[c[(d+8|0)>>2]&3](296,124,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3],933,d);se[c[(d+8|0)>>2]&3](296,125,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3],934,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](296,270,-(+h[e+13072>>3]*(+h[e+2232>>3]- +h[e+12848>>3]))- +h[e+13080>>3]*(+h[e+2224>>3]- +h[e+12840>>3]),935,d);se[c[(d+8|0)>>2]&3](297,106,1.0,936,d);se[c[(d+8|0)>>2]&3](297,126,-1.0,937,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](297,270,+h[e+13088>>3]*+h[f+17216>>3]- +h[e+13072>>3]*+h[f+17208>>3],938,d);se[c[(d+8|0)>>2]&3](298,93,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-.77,939,d);se[c[(d+8|0)>>2]&3](298,105,1.0,940,d);se[c[(d+8|0)>>2]&3](298,106,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-.77,941,d);se[c[(d+8|0)>>2]&3](298,270,.03850000000000001,942,d);se[c[(d+8|0)>>2]&3](299,104,1.0,943,d);se[c[(d+8|0)>>2]&3](299,105,.05,944,d);se[c[(d+8|0)>>2]&3](299,270,-.0008020833333333335,945,d);se[c[(d+8|0)>>2]&3](300,93,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-.77,946,d);se[c[(d+8|0)>>2]&3](300,103,1.0,947,d);se[c[(d+8|0)>>2]&3](300,106,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-.77,948,d);se[c[(d+8|0)>>2]&3](301,102,1.0,949,d);se[c[(d+8|0)>>2]&3](301,106,-1.0,950,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](301,270,+h[f+13088>>3]*+h[e+15224>>3]- +h[f+13072>>3]*+h[e+15216>>3],951,d);se[c[(d+8|0)>>2]&3](302,95,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-.653137112681318,952,d);se[c[(d+8|0)>>2]&3](302,101,1.0,953,d);se[c[(d+8|0)>>2]&3](302,126,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-.653137112681318,954,d);se[c[(d+8|0)>>2]&3](303,95,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-.653137112681318,955,d);se[c[(d+8|0)>>2]&3](303,100,1.0,956,d);se[c[(d+8|0)>>2]&3](303,126,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-.653137112681318,957,d);se[c[(d+8|0)>>2]&3](304,97,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-1.814269757448105,958,d);se[c[(d+8|0)>>2]&3](304,99,1.0,959,d);se[c[(d+8|0)>>2]&3](304,131,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-1.814269757448105,960,d);se[c[(d+8|0)>>2]&3](305,97,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-1.814269757448105,961,d);se[c[(d+8|0)>>2]&3](305,98,1.0,962,d);se[c[(d+8|0)>>2]&3](305,131,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-1.814269757448105,963,d);se[c[(d+8|0)>>2]&3](306,90,-1.0,964,d);se[c[(d+8|0)>>2]&3](306,97,1.0,965,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](306,270,+h[e+13304>>3]*+h[f+18568>>3]- +h[e+13288>>3]*+h[f+18560>>3],966,d);se[c[(d+8|0)>>2]&3](307,96,1.0,967,d);se[c[(d+8|0)>>2]&3](307,97,-1.0,968,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](307,270,+h[f+13096>>3]*+h[e+17992>>3]- +h[f+13080>>3]*+h[e+17984>>3],969,d);se[c[(d+8|0)>>2]&3](308,95,1.0,970,d);se[c[(d+8|0)>>2]&3](308,96,-1.0,971,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](308,270,+h[e+13096>>3]*+h[f+16024>>3]- +h[e+13080>>3]*+h[f+16016>>3],972,d);se[c[(d+8|0)>>2]&3](309,94,1.0,973,d);se[c[(d+8|0)>>2]&3](309,95,-1.0,974,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](309,270,+h[f+13096>>3]*+h[e+18088>>3]- +h[f+13080>>3]*+h[e+18080>>3],975,d);se[c[(d+8|0)>>2]&3](310,93,1.0,976,d);se[c[(d+8|0)>>2]&3](310,95,-1.0,977,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](310,270,+h[e+13096>>3]*+h[f+17216>>3]- +h[e+13080>>3]*+h[f+17208>>3],978,d);se[c[(d+8|0)>>2]&3](311,92,1.0,979,d);se[c[(d+8|0)>>2]&3](311,93,-1.0,980,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](311,270,+h[f+13096>>3]*+h[e+15224>>3]- +h[f+13080>>3]*+h[e+15216>>3],981,d);se[c[(d+8|0)>>2]&3](312,60,-1.0,982,d);se[c[(d+8|0)>>2]&3](312,91,1.0,983,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](312,270,+h[e+13736>>3]*+h[f+12544>>3]- +h[e+13720>>3]*+h[f+12536>>3],984,d);se[c[(d+8|0)>>2]&3](313,50,-1.0,985,d);se[c[(d+8|0)>>2]&3](313,90,1.0,986,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](313,270,+h[f+13744>>3]*+h[e+12544>>3]- +h[f+13728>>3]*+h[e+12536>>3],987,d);se[c[(d+8|0)>>2]&3](314,49,-1.0,988,d);se[c[(d+8|0)>>2]&3](314,89,1.0,989,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](314,270,+h[e+13944>>3]*+h[f+12160>>3]- +h[e+13928>>3]*+h[f+12152>>3],990,d);se[c[(d+8|0)>>2]&3](315,88,1.0,991,d);se[c[(d+8|0)>>2]&3](315,89,-1.0,992,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](315,270,+h[f+13736>>3]*+h[e+11584>>3]- +h[f+13720>>3]*+h[e+11576>>3],993,d);se[c[(d+8|0)>>2]&3](316,54,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-.77,994,d);se[c[(d+8|0)>>2]&3](316,87,1.0,995,d);se[c[(d+8|0)>>2]&3](316,88,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-.77,996,d);se[c[(d+8|0)>>2]&3](316,270,-.03850000000000001,997,d);se[c[(d+8|0)>>2]&3](317,86,1.0,998,d);se[c[(d+8|0)>>2]&3](317,87,-.05,999,d);se[c[(d+8|0)>>2]&3](317,270,-.0008020833333333335,1e3,d);se[c[(d+8|0)>>2]&3](318,54,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-.77,1001,d);se[c[(d+8|0)>>2]&3](318,85,1.0,1002,d);se[c[(d+8|0)>>2]&3](318,88,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-.77,1003,d);se[c[(d+8|0)>>2]&3](319,84,1.0,1004,d);se[c[(d+8|0)>>2]&3](319,88,-1.0,1005,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](319,270,+h[e+13736>>3]*+h[f+9616>>3]- +h[e+13720>>3]*+h[f+9608>>3],1006,d);se[c[(d+8|0)>>2]&3](320,83,1.0,1007,d);se[c[(d+8|0)>>2]&3](320,84,-1.0,1008,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](320,270,+h[f+13736>>3]*+h[e+11680>>3]- +h[f+13720>>3]*+h[e+11672>>3],1009,d);se[c[(d+8|0)>>2]&3](321,52,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3],1010,d);se[c[(d+8|0)>>2]&3](321,65,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3],1011,d);se[c[(d+8|0)>>2]&3](321,82,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3],1012,d);se[c[(d+8|0)>>2]&3](321,83,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3],1013,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](321,270,+h[e+13744>>3]*(+h[e+2832>>3]- +h[e+13488>>3])+ +h[e+13736>>3]*(+h[e+2840>>3]- +h[e+13496>>3]),1014,d);se[c[(d+8|0)>>2]&3](322,65,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23728>>3]*-2.0328,1015,d);se[c[(d+8|0)>>2]&3](322,71,-.182952,1016,d);se[c[(d+8|0)>>2]&3](322,81,1.0,1017,d);se[c[(d+8|0)>>2]&3](322,82,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23720>>3]*-2.0328,1018,d);se[c[(d+8|0)>>2]&3](323,73,-1.0,1019,d);se[c[(d+8|0)>>2]&3](323,80,1.0,1020,d);se[c[(d+8|0)>>2]&3](323,81,1.0,1021,d);se[c[(d+8|0)>>2]&3](324,77,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9536>>3],1022,d);se[c[(d+8|0)>>2]&3](324,79,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9560>>3],1023,d);se[c[(d+8|0)>>2]&3](324,80,1.0,1024,d);se[c[(d+8|0)>>2]&3](325,77,-+h[(c[(b+416|0)>>2]|0)+11680>>3],1025,d);se[c[(d+8|0)>>2]&3](325,78,-1.0,1026,d);se[c[(d+8|0)>>2]&3](325,79,+h[(c[(b+416|0)>>2]|0)+11672>>3],1027,d);se[c[(d+8|0)>>2]&3](326,74,1.0,1028,d);se[c[(d+8|0)>>2]&3](326,77,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9528>>3],1029,d);se[c[(d+8|0)>>2]&3](326,79,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9552>>3],1030,d);se[c[(d+8|0)>>2]&3](327,71,-.0088088,1031,d);se[c[(d+8|0)>>2]&3](327,76,-1.0,1032,d);se[c[(d+8|0)>>2]&3](327,81,-.09,1033,d);se[c[(d+8|0)>>2]&3](328,73,-+h[(c[(b+416|0)>>2]|0)+7912>>3],1034,d);se[c[(d+8|0)>>2]&3](328,75,+h[(c[(b+416|0)>>2]|0)+7920>>3],1035,d);se[c[(d+8|0)>>2]&3](328,76,-1.0,1036,d);se[c[(d+8|0)>>2]&3](329,72,1.0,1037,d);se[c[(d+8|0)>>2]&3](329,74,1.0,1038,d);se[c[(d+8|0)>>2]&3](329,75,-1.0,1039,d);se[c[(d+8|0)>>2]&3](330,66,1.0,1040,d);se[c[(d+8|0)>>2]&3](330,73,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24336>>3],1041,d);se[c[(d+8|0)>>2]&3](330,75,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24312>>3],1042,d);se[c[(d+8|0)>>2]&3](331,65,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23704>>3]*-2.0328,1043,d);se[c[(d+8|0)>>2]&3](331,72,1.0,1044,d);se[c[(d+8|0)>>2]&3](331,82,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23696>>3]*-2.0328,1045,d);se[c[(d+8|0)>>2]&3](332,68,1.0,1046,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](332,71,+h[e+23696>>3]*+h[f+7920>>3]- +h[e+23720>>3]*+h[f+7912>>3],1047,d);se[c[(d+8|0)>>2]&3](332,82,-1.0,1048,d);se[c[(d+8|0)>>2]&3](333,65,-1.0,1049,d);se[c[(d+8|0)>>2]&3](333,70,1.0,1050,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](333,71,+h[f+23704>>3]*+h[e+7920>>3]- +h[f+23728>>3]*+h[e+7912>>3],1051,d);se[c[(d+8|0)>>2]&3](334,69,.4999999999999999,1052,d);se[c[(d+8|0)>>2]&3](334,70,1.0,1053,d);se[c[(d+8|0)>>2]&3](335,68,1.0,1054,d);se[c[(d+8|0)>>2]&3](335,69,.8660254037844387,1055,d);se[c[(d+8|0)>>2]&3](336,67,1.0,1056,d);se[c[(d+8|0)>>2]&3](336,68,-5.237345664226305,1057,d);se[c[(d+8|0)>>2]&3](336,70,-3.023782929080176,1058,d);se[c[(d+8|0)>>2]&3](337,66,1.0,1059,d);se[c[(d+8|0)>>2]&3](337,67,1.0,1060,d);se[c[(d+8|0)>>2]&3](338,52,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3],1061,d);se[c[(d+8|0)>>2]&3](338,65,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3],1062,d);se[c[(d+8|0)>>2]&3](338,82,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3],1063,d);se[c[(d+8|0)>>2]&3](338,83,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3],1064,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](338,270,-(+h[e+13720>>3]*(+h[e+2840>>3]- +h[e+13496>>3]))- +h[e+13728>>3]*(+h[e+2832>>3]- +h[e+13488>>3]),1065,d);se[c[(d+8|0)>>2]&3](339,64,1.0,1066,d);se[c[(d+8|0)>>2]&3](339,84,-1.0,1067,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](339,270,+h[e+13736>>3]*+h[f+10808>>3]- +h[e+13720>>3]*+h[f+10800>>3],1068,d);se[c[(d+8|0)>>2]&3](340,51,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-.77,1069,d);se[c[(d+8|0)>>2]&3](340,63,1.0,1070,d);se[c[(d+8|0)>>2]&3](340,64,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-.77,1071,d);se[c[(d+8|0)>>2]&3](340,270,.03850000000000001,1072,d);se[c[(d+8|0)>>2]&3](341,62,1.0,1073,d);se[c[(d+8|0)>>2]&3](341,63,.05,1074,d);se[c[(d+8|0)>>2]&3](341,270,-.0008020833333333335,1075,d);se[c[(d+8|0)>>2]&3](342,51,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-.77,1076,d);se[c[(d+8|0)>>2]&3](342,61,1.0,1077,d);se[c[(d+8|0)>>2]&3](342,64,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-.77,1078,d);se[c[(d+8|0)>>2]&3](343,60,1.0,1079,d);se[c[(d+8|0)>>2]&3](343,64,-1.0,1080,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](343,270,+h[f+13736>>3]*+h[e+8816>>3]- +h[f+13720>>3]*+h[e+8808>>3],1081,d);se[c[(d+8|0)>>2]&3](344,53,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-.653137112681318,1082,d);se[c[(d+8|0)>>2]&3](344,59,1.0,1083,d);se[c[(d+8|0)>>2]&3](344,84,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-.653137112681318,1084,d);se[c[(d+8|0)>>2]&3](345,53,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-.653137112681318,1085,d);se[c[(d+8|0)>>2]&3](345,58,1.0,1086,d);se[c[(d+8|0)>>2]&3](345,84,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-.653137112681318,1087,d);se[c[(d+8|0)>>2]&3](346,55,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-1.814269757448105,1088,d);se[c[(d+8|0)>>2]&3](346,57,1.0,1089,d);se[c[(d+8|0)>>2]&3](346,89,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-1.814269757448105,1090,d);se[c[(d+8|0)>>2]&3](347,55,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-1.814269757448105,1091,d);se[c[(d+8|0)>>2]&3](347,56,1.0,1092,d);se[c[(d+8|0)>>2]&3](347,89,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-1.814269757448105,1093,d);se[c[(d+8|0)>>2]&3](348,48,-1.0,1094,d);se[c[(d+8|0)>>2]&3](348,55,1.0,1095,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](348,270,+h[e+13952>>3]*+h[f+12160>>3]- +h[e+13936>>3]*+h[f+12152>>3],1096,d);se[c[(d+8|0)>>2]&3](349,54,1.0,1097,d);se[c[(d+8|0)>>2]&3](349,55,-1.0,1098,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](349,270,+h[f+13744>>3]*+h[e+11584>>3]- +h[f+13728>>3]*+h[e+11576>>3],1099,d);se[c[(d+8|0)>>2]&3](350,53,1.0,1100,d);se[c[(d+8|0)>>2]&3](350,54,-1.0,1101,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](350,270,+h[e+13744>>3]*+h[f+9616>>3]- +h[e+13728>>3]*+h[f+9608>>3],1102,d);se[c[(d+8|0)>>2]&3](351,52,1.0,1103,d);se[c[(d+8|0)>>2]&3](351,53,-1.0,1104,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](351,270,+h[f+13744>>3]*+h[e+11680>>3]- +h[f+13728>>3]*+h[e+11672>>3],1105,d);se[c[(d+8|0)>>2]&3](352,51,1.0,1106,d);se[c[(d+8|0)>>2]&3](352,53,-1.0,1107,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](352,270,+h[e+13744>>3]*+h[f+10808>>3]- +h[e+13728>>3]*+h[f+10800>>3],1108,d);se[c[(d+8|0)>>2]&3](353,50,1.0,1109,d);se[c[(d+8|0)>>2]&3](353,51,-1.0,1110,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](353,270,+h[f+13744>>3]*+h[e+8816>>3]- +h[f+13728>>3]*+h[e+8808>>3],1111,d);se[c[(d+8|0)>>2]&3](354,18,-1.0,1112,d);se[c[(d+8|0)>>2]&3](354,49,1.0,1113,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](354,270,+h[e+23040>>3]*+h[f+6136>>3]- +h[e+23024>>3]*+h[f+6128>>3],1114,d);se[c[(d+8|0)>>2]&3](355,10,-1.0,1115,d);se[c[(d+8|0)>>2]&3](355,48,1.0,1116,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](355,270,+h[f+23048>>3]*+h[e+6136>>3]- +h[f+23032>>3]*+h[e+6128>>3],1117,d);se[c[(d+8|0)>>2]&3](356,47,1.0,1118,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](356,270,+h[e+23896>>3]*+h[f+5752>>3]- +h[e+23880>>3]*+h[f+5744>>3],1119,d);se[c[(d+8|0)>>2]&3](357,46,1.0,1120,d);se[c[(d+8|0)>>2]&3](357,47,-1.0,1121,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](357,270,+h[f+23040>>3]*+h[e+5176>>3]- +h[f+23024>>3]*+h[e+5168>>3],1122,d);se[c[(d+8|0)>>2]&3](358,14,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-.77,1123,d);se[c[(d+8|0)>>2]&3](358,45,1.0,1124,d);se[c[(d+8|0)>>2]&3](358,46,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-.77,1125,d);se[c[(d+8|0)>>2]&3](358,270,-.03850000000000001,1126,d);se[c[(d+8|0)>>2]&3](359,44,1.0,1127,d);se[c[(d+8|0)>>2]&3](359,45,-.05,1128,d);se[c[(d+8|0)>>2]&3](359,270,-.0008020833333333335,1129,d);se[c[(d+8|0)>>2]&3](360,14,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-.77,1130,d);se[c[(d+8|0)>>2]&3](360,43,1.0,1131,d);se[c[(d+8|0)>>2]&3](360,46,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-.77,1132,d);se[c[(d+8|0)>>2]&3](361,42,1.0,1133,d);se[c[(d+8|0)>>2]&3](361,46,-1.0,1134,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](361,270,+h[e+23040>>3]*+h[f+3208>>3]- +h[e+23024>>3]*+h[f+3200>>3],1135,d);se[c[(d+8|0)>>2]&3](362,41,1.0,1136,d);se[c[(d+8|0)>>2]&3](362,42,-1.0,1137,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](362,270,+h[f+23040>>3]*+h[e+5272>>3]- +h[f+23024>>3]*+h[e+5264>>3],1138,d);se[c[(d+8|0)>>2]&3](363,12,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3],1139,d);se[c[(d+8|0)>>2]&3](363,23,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3],1140,d);se[c[(d+8|0)>>2]&3](363,40,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3],1141,d);se[c[(d+8|0)>>2]&3](363,41,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3],1142,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](363,270,+h[e+23048>>3]*(+h[e+3408>>3]- +h[e+14768>>3])+ +h[e+23040>>3]*(+h[e+3416>>3]- +h[e+14776>>3]),1143,d);se[c[(d+8|0)>>2]&3](364,23,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23872>>3]*-2.0328,1144,d);se[c[(d+8|0)>>2]&3](364,29,-.182952,1145,d);se[c[(d+8|0)>>2]&3](364,39,1.0,1146,d);se[c[(d+8|0)>>2]&3](364,40,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23864>>3]*-2.0328,1147,d);se[c[(d+8|0)>>2]&3](365,33,-1.0,1148,d);se[c[(d+8|0)>>2]&3](365,38,1.0,1149,d);se[c[(d+8|0)>>2]&3](365,39,1.0,1150,d);se[c[(d+8|0)>>2]&3](366,35,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7840>>3],1151,d);se[c[(d+8|0)>>2]&3](366,37,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7816>>3],1152,d);se[c[(d+8|0)>>2]&3](366,38,1.0,1153,d);se[c[(d+8|0)>>2]&3](367,35,+h[(c[(b+416|0)>>2]|0)+5264>>3],1154,d);se[c[(d+8|0)>>2]&3](367,36,-1.0,1155,d);se[c[(d+8|0)>>2]&3](367,37,-+h[(c[(b+416|0)>>2]|0)+5272>>3],1156,d);se[c[(d+8|0)>>2]&3](368,31,1.0,1157,d);se[c[(d+8|0)>>2]&3](368,35,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7832>>3],1158,d);se[c[(d+8|0)>>2]&3](368,37,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7808>>3],1159,d);se[c[(d+8|0)>>2]&3](369,29,-.0088088,1160,d);se[c[(d+8|0)>>2]&3](369,34,-1.0,1161,d);se[c[(d+8|0)>>2]&3](369,39,-.09,1162,d);se[c[(d+8|0)>>2]&3](370,32,+h[(c[(b+416|0)>>2]|0)+1512>>3],1163,d);se[c[(d+8|0)>>2]&3](370,33,-+h[(c[(b+416|0)>>2]|0)+1504>>3],1164,d);se[c[(d+8|0)>>2]&3](370,34,-1.0,1165,d);se[c[(d+8|0)>>2]&3](371,24,1.0,1166,d);se[c[(d+8|0)>>2]&3](371,32,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24104>>3],1167,d);se[c[(d+8|0)>>2]&3](371,33,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24128>>3],1168,d);se[c[(d+8|0)>>2]&3](372,30,1.0,1169,d);se[c[(d+8|0)>>2]&3](372,31,1.0,1170,d);se[c[(d+8|0)>>2]&3](372,32,-1.0,1171,d);se[c[(d+8|0)>>2]&3](373,23,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23848>>3]*-2.0328,1172,d);se[c[(d+8|0)>>2]&3](373,30,1.0,1173,d);se[c[(d+8|0)>>2]&3](373,40,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23840>>3]*-2.0328,1174,d);se[c[(d+8|0)>>2]&3](374,26,1.0,1175,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](374,29,+h[e+23840>>3]*+h[f+1512>>3]- +h[e+23864>>3]*+h[f+1504>>3],1176,d);se[c[(d+8|0)>>2]&3](374,40,-1.0,1177,d);se[c[(d+8|0)>>2]&3](375,23,-1.0,1178,d);se[c[(d+8|0)>>2]&3](375,28,1.0,1179,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](375,29,+h[f+23848>>3]*+h[e+1512>>3]- +h[f+23872>>3]*+h[e+1504>>3],1180,d);se[c[(d+8|0)>>2]&3](376,27,-.4999999999999999,1181,d);se[c[(d+8|0)>>2]&3](376,28,1.0,1182,d);se[c[(d+8|0)>>2]&3](377,26,1.0,1183,d);se[c[(d+8|0)>>2]&3](377,27,.8660254037844387,1184,d);se[c[(d+8|0)>>2]&3](378,25,1.0,1185,d);se[c[(d+8|0)>>2]&3](378,26,-5.237345664226305,1186,d);se[c[(d+8|0)>>2]&3](378,28,3.023782929080176,1187,d);se[c[(d+8|0)>>2]&3](379,24,1.0,1188,d);se[c[(d+8|0)>>2]&3](379,25,1.0,1189,d);se[c[(d+8|0)>>2]&3](380,12,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3],1190,d);se[c[(d+8|0)>>2]&3](380,23,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3],1191,d);se[c[(d+8|0)>>2]&3](380,40,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3],1192,d);se[c[(d+8|0)>>2]&3](380,41,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3],1193,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](380,270,-(+h[e+23024>>3]*(+h[e+3416>>3]- +h[e+14776>>3]))- +h[e+23032>>3]*(+h[e+3408>>3]- +h[e+14768>>3]),1194,d);se[c[(d+8|0)>>2]&3](381,22,1.0,1195,d);se[c[(d+8|0)>>2]&3](381,42,-1.0,1196,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](381,270,+h[e+23040>>3]*+h[f+4400>>3]- +h[e+23024>>3]*+h[f+4392>>3],1197,d);se[c[(d+8|0)>>2]&3](382,11,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-.77,1198,d);se[c[(d+8|0)>>2]&3](382,21,1.0,1199,d);se[c[(d+8|0)>>2]&3](382,22,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-.77,1200,d);se[c[(d+8|0)>>2]&3](382,270,.03850000000000001,1201,d);se[c[(d+8|0)>>2]&3](383,20,1.0,1202,d);se[c[(d+8|0)>>2]&3](383,21,.05,1203,d);se[c[(d+8|0)>>2]&3](383,270,-.0008020833333333335,1204,d);se[c[(d+8|0)>>2]&3](384,11,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-.77,1205,d);se[c[(d+8|0)>>2]&3](384,19,1.0,1206,d);se[c[(d+8|0)>>2]&3](384,22,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-.77,1207,d);se[c[(d+8|0)>>2]&3](385,18,1.0,1208,d);se[c[(d+8|0)>>2]&3](385,22,-1.0,1209,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](385,270,+h[f+23040>>3]*+h[e+2408>>3]- +h[f+23024>>3]*+h[e+2400>>3],1210,d);se[c[(d+8|0)>>2]&3](386,13,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-.653137112681318,1211,d);se[c[(d+8|0)>>2]&3](386,17,1.0,1212,d);se[c[(d+8|0)>>2]&3](386,42,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-.653137112681318,1213,d);se[c[(d+8|0)>>2]&3](387,13,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-.653137112681318,1214,d);se[c[(d+8|0)>>2]&3](387,16,1.0,1215,d);se[c[(d+8|0)>>2]&3](387,42,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-.653137112681318,1216,d);se[c[(d+8|0)>>2]&3](388,15,1.0,1217,d);se[c[(d+8|0)>>2]&3](388,47,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-1.814269757448105,1218,d);se[c[(d+8|0)>>2]&3](388,403,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-1.814269757448105,1219,d);se[c[(d+8|0)>>2]&3](389,14,1.0,1220,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](389,270,+h[e+23048>>3]*+h[f+5176>>3]- +h[e+23032>>3]*+h[f+5168>>3],1221,d);se[c[(d+8|0)>>2]&3](389,403,-1.0,1222,d);se[c[(d+8|0)>>2]&3](390,13,1.0,1223,d);se[c[(d+8|0)>>2]&3](390,14,-1.0,1224,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](390,270,+h[f+23048>>3]*+h[e+3208>>3]- +h[f+23032>>3]*+h[e+3200>>3],1225,d);se[c[(d+8|0)>>2]&3](391,12,1.0,1226,d);se[c[(d+8|0)>>2]&3](391,13,-1.0,1227,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](391,270,+h[e+23048>>3]*+h[f+5272>>3]- +h[e+23032>>3]*+h[f+5264>>3],1228,d);se[c[(d+8|0)>>2]&3](392,11,1.0,1229,d);se[c[(d+8|0)>>2]&3](392,13,-1.0,1230,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](392,270,+h[f+23048>>3]*+h[e+4400>>3]- +h[f+23032>>3]*+h[e+4392>>3],1231,d);se[c[(d+8|0)>>2]&3](393,10,1.0,1232,d);se[c[(d+8|0)>>2]&3](393,11,-1.0,1233,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](393,270,+h[e+23048>>3]*+h[f+2408>>3]- +h[e+23032>>3]*+h[f+2400>>3],1234,d);se[c[(d+8|0)>>2]&3](394,9,1.0,1235,d);se[c[(d+8|0)>>2]&3](394,270,-.0005669592992025331,1236,d);se[c[(d+8|0)>>2]&3](395,8,1.0,1237,d);se[c[(d+8|0)>>2]&3](395,270,-7347792517664828.0e-20,1238,d);se[c[(d+8|0)>>2]&3](396,7,1.0,1239,d);se[c[(d+8|0)>>2]&3](396,270,-.0005669592992025331,1240,d);se[c[(d+8|0)>>2]&3](397,6,1.0,1241,d);se[c[(d+8|0)>>2]&3](397,270,-7347792517664828.0e-20,1242,d);se[c[(d+8|0)>>2]&3](398,5,1.0,1243,d);se[c[(d+8|0)>>2]&3](398,270,-.0005669592992025331,1244,d);se[c[(d+8|0)>>2]&3](399,4,1.0,1245,d);se[c[(d+8|0)>>2]&3](399,270,-7347792517664828.0e-20,1246,d);se[c[(d+8|0)>>2]&3](400,3,1.0,1247,d);se[c[(d+8|0)>>2]&3](400,270,-.0005669592992025331,1248,d);se[c[(d+8|0)>>2]&3](401,2,1.0,1249,d);se[c[(d+8|0)>>2]&3](401,270,-7347792517664828.0e-20,1250,d);se[c[(d+8|0)>>2]&3](402,1,1.0,1251,d);se[c[(d+8|0)>>2]&3](402,270,-.0005669592992025331,1252,d);se[c[(d+8|0)>>2]&3](403,0,1.0,1253,d);se[c[(d+8|0)>>2]&3](403,270,-7347792517664828.0e-20,1254,d);i=a;c[a+1600>>2]=5;break a}while(0)}function _setLinearMatrixA5242$1(a){a=a|0;var b=0,d=0,e=0;b=c[a+8>>2]|0;d=c[a+16>>2]|0;se[c[(d+8|0)>>2]&3](178,224,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3],567,d);se[c[(d+8|0)>>2]&3](178,225,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3],568,d);se[c[(d+8|0)>>2]&3](178,267,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3],569,d);se[c[(d+8|0)>>2]&3](178,268,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3],570,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](178,270,-(+h[a+11200>>3]*(+h[a+384>>3]- +h[a+11024>>3]))- +h[a+11208>>3]*(+h[a+376>>3]- +h[a+11016>>3]),571,d);se[c[(d+8|0)>>2]&3](179,207,-1.0,572,d);se[c[(d+8|0)>>2]&3](179,224,1.0,573,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](179,270,+h[a+11224>>3]*+h[e+37312>>3]- +h[a+11208>>3]*+h[e+37304>>3],574,d);se[c[(d+8|0)>>2]&3](180,203,-1.0,575,d);se[c[(d+8|0)>>2]&3](180,223,1.0,576,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](180,270,+h[e+11216>>3]*+h[a+37216>>3]- +h[e+11200>>3]*+h[a+37208>>3],577,d);se[c[(d+8|0)>>2]&3](181,208,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-.77,578,d);se[c[(d+8|0)>>2]&3](181,222,1.0,579,d);se[c[(d+8|0)>>2]&3](181,223,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-.77,580,d);se[c[(d+8|0)>>2]&3](181,270,-.03850000000000001,581,d);se[c[(d+8|0)>>2]&3](182,221,1.0,582,d);se[c[(d+8|0)>>2]&3](182,222,-.05,583,d);se[c[(d+8|0)>>2]&3](182,270,-.0008020833333333335,584,d);se[c[(d+8|0)>>2]&3](183,208,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-.77,585,d);se[c[(d+8|0)>>2]&3](183,220,1.0,586,d);se[c[(d+8|0)>>2]&3](183,223,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-.77,587,d);se[c[(d+8|0)>>2]&3](184,219,1.0,588,d);se[c[(d+8|0)>>2]&3](184,223,-1.0,589,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](184,270,+h[a+11216>>3]*+h[e+35248>>3]- +h[a+11200>>3]*+h[e+35240>>3],590,d);se[c[(d+8|0)>>2]&3](185,218,1.0,591,d);se[c[(d+8|0)>>2]&3](185,219,-1.0,592,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](185,270,+h[e+11216>>3]*+h[a+36440>>3]- +h[e+11200>>3]*+h[a+36432>>3],593,d);se[c[(d+8|0)>>2]&3](186,206,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-.77,594,d);se[c[(d+8|0)>>2]&3](186,217,-1.0,595,d);se[c[(d+8|0)>>2]&3](186,218,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-.77,596,d);se[c[(d+8|0)>>2]&3](186,270,.03850000000000001,597,d);se[c[(d+8|0)>>2]&3](187,210,1.0,598,d);se[c[(d+8|0)>>2]&3](187,216,-1.0,599,d);se[c[(d+8|0)>>2]&3](187,217,-1.0,600,d);se[c[(d+8|0)>>2]&3](188,212,+h[(c[(b+416|0)>>2]|0)+36440>>3],601,d);se[c[(d+8|0)>>2]&3](188,213,-1.0,602,d);se[c[(d+8|0)>>2]&3](188,215,-1.0,603,d);se[c[(d+8|0)>>2]&3](188,217,-+h[(c[(b+416|0)>>2]|0)+36432>>3],604,d);se[c[(d+8|0)>>2]&3](189,204,1.0,605,d);se[c[(d+8|0)>>2]&3](189,214,-1.0,606,d);se[c[(d+8|0)>>2]&3](189,215,1.0,607,d);se[c[(d+8|0)>>2]&3](190,213,-1.0,608,d);se[c[(d+8|0)>>2]&3](190,217,-.05,609,d);se[c[(d+8|0)>>2]&3](190,270,-.0008020833333333335,610,d);se[c[(d+8|0)>>2]&3](191,206,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-.77,611,d);se[c[(d+8|0)>>2]&3](191,212,-1.0,612,d);se[c[(d+8|0)>>2]&3](191,218,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-.77,613,d);se[c[(d+8|0)>>2]&3](192,209,1.0,614,d);se[c[(d+8|0)>>2]&3](192,211,-1.0,615,d);se[c[(d+8|0)>>2]&3](192,212,-1.0,616,d);se[c[(d+8|0)>>2]&3](193,207,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-.653137112681318,617,d);se[c[(d+8|0)>>2]&3](193,210,1.0,618,d);se[c[(d+8|0)>>2]&3](193,219,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-.653137112681318,619,d);se[c[(d+8|0)>>2]&3](194,207,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-.653137112681318,620,d);se[c[(d+8|0)>>2]&3](194,209,1.0,621,d);se[c[(d+8|0)>>2]&3](194,219,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-.653137112681318,622,d);se[c[(d+8|0)>>2]&3](195,200,-1.0,623,d);se[c[(d+8|0)>>2]&3](195,208,1.0,624,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](195,270,+h[a+11224>>3]*+h[e+37216>>3]- +h[a+11208>>3]*+h[e+37208>>3],625,d);se[c[(d+8|0)>>2]&3](196,207,1.0,626,d);se[c[(d+8|0)>>2]&3](196,208,-1.0,627,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](196,270,+h[e+11224>>3]*+h[a+35248>>3]- +h[e+11208>>3]*+h[a+35240>>3],628,d);se[c[(d+8|0)>>2]&3](197,206,1.0,629,d);se[c[(d+8|0)>>2]&3](197,207,-1.0,630,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](197,270,+h[a+11224>>3]*+h[e+36440>>3]- +h[a+11208>>3]*+h[e+36432>>3],631,d);se[c[(d+8|0)>>2]&3](198,205,1.0,632,d);se[c[(d+8|0)>>2]&3](198,270,-.0005669592992025331,633,d);se[c[(d+8|0)>>2]&3](199,204,1.0,634,d);se[c[(d+8|0)>>2]&3](199,270,-7347792517664828.0e-20,635,d);se[c[(d+8|0)>>2]&3](200,199,-1.0,636,d);se[c[(d+8|0)>>2]&3](200,203,1.0,637,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](200,270,+h[e+23968>>3]*+h[a+37792>>3]- +h[e+23992>>3]*+h[a+37784>>3],638,d);se[c[(d+8|0)>>2]&3](201,200,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-1.814269757448105,639,d);se[c[(d+8|0)>>2]&3](201,202,1.0,640,d);se[c[(d+8|0)>>2]&3](201,203,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-1.814269757448105,641,d);se[c[(d+8|0)>>2]&3](202,200,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-1.814269757448105,642,d);se[c[(d+8|0)>>2]&3](202,201,1.0,643,d);se[c[(d+8|0)>>2]&3](202,203,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-1.814269757448105,644,d);se[c[(d+8|0)>>2]&3](203,198,-1.0,645,d);se[c[(d+8|0)>>2]&3](203,200,1.0,646,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](203,270,+h[a+23960>>3]*+h[e+37792>>3]- +h[a+23984>>3]*+h[e+37784>>3],647,d);se[c[(d+8|0)>>2]&3](204,186,-1.0,648,d);se[c[(d+8|0)>>2]&3](204,199,1.0,649,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](204,270,+h[e+11792>>3]*+h[a+31768>>3]- +h[e+11776>>3]*+h[a+31760>>3],650,d);se[c[(d+8|0)>>2]&3](205,176,-1.0,651,d);se[c[(d+8|0)>>2]&3](205,198,1.0,652,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](205,270,+h[a+11800>>3]*+h[e+31768>>3]- +h[a+11784>>3]*+h[e+31760>>3],653,d);se[c[(d+8|0)>>2]&3](206,175,-1.0,654,d);se[c[(d+8|0)>>2]&3](206,197,1.0,655,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](206,270,+h[e+12e3>>3]*+h[a+31384>>3]- +h[e+11984>>3]*+h[a+31376>>3],656,d);se[c[(d+8|0)>>2]&3](207,196,1.0,657,d);se[c[(d+8|0)>>2]&3](207,197,-1.0,658,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](207,270,+h[a+11792>>3]*+h[e+30808>>3]- +h[a+11776>>3]*+h[e+30800>>3],659,d);se[c[(d+8|0)>>2]&3](208,180,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-.77,660,d);se[c[(d+8|0)>>2]&3](208,195,1.0,661,d);se[c[(d+8|0)>>2]&3](208,196,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-.77,662,d);se[c[(d+8|0)>>2]&3](208,270,-.03850000000000001,663,d);se[c[(d+8|0)>>2]&3](209,194,1.0,664,d);se[c[(d+8|0)>>2]&3](209,195,-.05,665,d);se[c[(d+8|0)>>2]&3](209,270,-.0008020833333333335,666,d);se[c[(d+8|0)>>2]&3](210,180,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-.77,667,d);se[c[(d+8|0)>>2]&3](210,193,1.0,668,d);se[c[(d+8|0)>>2]&3](210,196,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-.77,669,d);se[c[(d+8|0)>>2]&3](211,192,1.0,670,d);se[c[(d+8|0)>>2]&3](211,196,-1.0,671,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](211,270,+h[e+11792>>3]*+h[a+28840>>3]- +h[e+11776>>3]*+h[a+28832>>3],672,d);se[c[(d+8|0)>>2]&3](212,191,1.0,673,d);se[c[(d+8|0)>>2]&3](212,192,-1.0,674,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](212,270,+h[a+11792>>3]*+h[e+30904>>3]- +h[a+11776>>3]*+h[e+30896>>3],675,d);se[c[(d+8|0)>>2]&3](213,190,1.0,676,d);se[c[(d+8|0)>>2]&3](213,192,-1.0,677,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](213,270,+h[e+11792>>3]*+h[a+30032>>3]- +h[e+11776>>3]*+h[a+30024>>3],678,d);se[c[(d+8|0)>>2]&3](214,177,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-.77,679,d);se[c[(d+8|0)>>2]&3](214,189,1.0,680,d);se[c[(d+8|0)>>2]&3](214,190,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-.77,681,d);se[c[(d+8|0)>>2]&3](214,270,.03850000000000001,682,d);se[c[(d+8|0)>>2]&3](215,188,1.0,683,d);se[c[(d+8|0)>>2]&3](215,189,.05,684,d);se[c[(d+8|0)>>2]&3](215,270,-.0008020833333333335,685,d);se[c[(d+8|0)>>2]&3](216,177,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-.77,686,d);se[c[(d+8|0)>>2]&3](216,187,1.0,687,d);se[c[(d+8|0)>>2]&3](216,190,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-.77,688,d);se[c[(d+8|0)>>2]&3](217,186,1.0,689,d);se[c[(d+8|0)>>2]&3](217,190,-1.0,690,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](217,270,+h[a+11792>>3]*+h[e+28040>>3]- +h[a+11776>>3]*+h[e+28032>>3],691,d);se[c[(d+8|0)>>2]&3](218,179,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-.653137112681318,692,d);se[c[(d+8|0)>>2]&3](218,185,1.0,693,d);se[c[(d+8|0)>>2]&3](218,192,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-.653137112681318,694,d);se[c[(d+8|0)>>2]&3](219,179,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-.653137112681318,695,d);se[c[(d+8|0)>>2]&3](219,184,1.0,696,d);se[c[(d+8|0)>>2]&3](219,192,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-.653137112681318,697,d);se[c[(d+8|0)>>2]&3](220,181,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-1.814269757448105,698,d);se[c[(d+8|0)>>2]&3](220,183,1.0,699,d);se[c[(d+8|0)>>2]&3](220,197,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-1.814269757448105,700,d);se[c[(d+8|0)>>2]&3](221,181,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-1.814269757448105,701,d);se[c[(d+8|0)>>2]&3](221,182,1.0,702,d);se[c[(d+8|0)>>2]&3](221,197,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-1.814269757448105,703,d);se[c[(d+8|0)>>2]&3](222,174,-1.0,704,d);se[c[(d+8|0)>>2]&3](222,181,1.0,705,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](222,270,+h[e+12008>>3]*+h[a+31384>>3]- +h[e+11992>>3]*+h[a+31376>>3],706,d);se[c[(d+8|0)>>2]&3](223,180,1.0,707,d);se[c[(d+8|0)>>2]&3](223,181,-1.0,708,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](223,270,+h[a+11800>>3]*+h[e+30808>>3]- +h[a+11784>>3]*+h[e+30800>>3],709,d);se[c[(d+8|0)>>2]&3](224,179,1.0,710,d);se[c[(d+8|0)>>2]&3](224,180,-1.0,711,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](224,270,+h[e+11800>>3]*+h[a+28840>>3]- +h[e+11784>>3]*+h[a+28832>>3],712,d);se[c[(d+8|0)>>2]&3](225,178,1.0,713,d);se[c[(d+8|0)>>2]&3](225,179,-1.0,714,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](225,270,+h[a+11800>>3]*+h[e+30904>>3]- +h[a+11784>>3]*+h[e+30896>>3],715,d);se[c[(d+8|0)>>2]&3](226,177,1.0,716,d);se[c[(d+8|0)>>2]&3](226,179,-1.0,717,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](226,270,+h[e+11800>>3]*+h[a+30032>>3]- +h[e+11784>>3]*+h[a+30024>>3],718,d);se[c[(d+8|0)>>2]&3](227,176,1.0,719,d);se[c[(d+8|0)>>2]&3](227,177,-1.0,720,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](227,270,+h[a+11800>>3]*+h[e+28040>>3]- +h[a+11784>>3]*+h[e+28032>>3],721,d);se[c[(d+8|0)>>2]&3](228,144,-1.0,722,d);se[c[(d+8|0)>>2]&3](228,175,1.0,723,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](228,270,+h[e+12440>>3]*+h[a+25360>>3]- +h[e+12424>>3]*+h[a+25352>>3],724,d);se[c[(d+8|0)>>2]&3](229,134,-1.0,725,d);se[c[(d+8|0)>>2]&3](229,174,1.0,726,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](229,270,+h[a+12448>>3]*+h[e+25360>>3]- +h[a+12432>>3]*+h[e+25352>>3],727,d);se[c[(d+8|0)>>2]&3](230,133,-1.0,728,d);se[c[(d+8|0)>>2]&3](230,173,1.0,729,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](230,270,+h[e+12648>>3]*+h[a+24976>>3]- +h[e+12632>>3]*+h[a+24968>>3],730,d);se[c[(d+8|0)>>2]&3](231,172,1.0,731,d);se[c[(d+8|0)>>2]&3](231,173,-1.0,732,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](231,270,+h[a+12440>>3]*+h[e+24400>>3]- +h[a+12424>>3]*+h[e+24392>>3],733,d);se[c[(d+8|0)>>2]&3](232,138,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-.77,734,d);se[c[(d+8|0)>>2]&3](232,171,1.0,735,d);se[c[(d+8|0)>>2]&3](232,172,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-.77,736,d);se[c[(d+8|0)>>2]&3](232,270,-.03850000000000001,737,d);se[c[(d+8|0)>>2]&3](233,170,1.0,738,d);se[c[(d+8|0)>>2]&3](233,171,-.05,739,d);se[c[(d+8|0)>>2]&3](233,270,-.0008020833333333335,740,d);se[c[(d+8|0)>>2]&3](234,138,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-.77,741,d);se[c[(d+8|0)>>2]&3](234,169,1.0,742,d);se[c[(d+8|0)>>2]&3](234,172,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-.77,743,d);se[c[(d+8|0)>>2]&3](235,168,1.0,744,d);se[c[(d+8|0)>>2]&3](235,172,-1.0,745,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](235,270,+h[e+12440>>3]*+h[a+22432>>3]- +h[e+12424>>3]*+h[a+22424>>3],746,d);se[c[(d+8|0)>>2]&3](236,167,1.0,747,d);se[c[(d+8|0)>>2]&3](236,168,-1.0,748,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](236,270,+h[a+12440>>3]*+h[e+24496>>3]- +h[a+12424>>3]*+h[e+24488>>3],749,d);se[c[(d+8|0)>>2]&3](237,136,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3],750,d);se[c[(d+8|0)>>2]&3](237,149,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3],751,d);se[c[(d+8|0)>>2]&3](237,166,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3],752,d);se[c[(d+8|0)>>2]&3](237,167,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3],753,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](237,270,+h[e+12448>>3]*(+h[e+1600>>3]- +h[e+12192>>3])+ +h[e+12440>>3]*(+h[e+1608>>3]- +h[e+12200>>3]),754,d);se[c[(d+8|0)>>2]&3](238,149,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23480>>3]*-2.0328,755,d);se[c[(d+8|0)>>2]&3](238,152,-.182952,756,d);se[c[(d+8|0)>>2]&3](238,165,1.0,757,d);se[c[(d+8|0)>>2]&3](238,166,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23488>>3]*-2.0328,758,d);se[c[(d+8|0)>>2]&3](239,159,-1.0,759,d);se[c[(d+8|0)>>2]&3](239,164,1.0,760,d);se[c[(d+8|0)>>2]&3](239,165,1.0,761,d);se[c[(d+8|0)>>2]&3](240,161,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10072>>3],762,d);se[c[(d+8|0)>>2]&3](240,163,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10048>>3],763,d);se[c[(d+8|0)>>2]&3](240,164,1.0,764,d);se[c[(d+8|0)>>2]&3](241,161,+h[(c[(b+416|0)>>2]|0)+24488>>3],765,d);se[c[(d+8|0)>>2]&3](241,162,-1.0,766,d);se[c[(d+8|0)>>2]&3](241,163,-+h[(c[(b+416|0)>>2]|0)+24496>>3],767,d);se[c[(d+8|0)>>2]&3](242,157,1.0,768,d);se[c[(d+8|0)>>2]&3](242,161,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10064>>3],769,d);se[c[(d+8|0)>>2]&3](242,163,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10040>>3],770,d);se[c[(d+8|0)>>2]&3](243,152,-.008808799999999999,771,d);se[c[(d+8|0)>>2]&3](243,160,-1.0,772,d);se[c[(d+8|0)>>2]&3](243,165,-.09,773,d);se[c[(d+8|0)>>2]&3](244,158,+h[(c[(b+416|0)>>2]|0)+20736>>3],774,d);se[c[(d+8|0)>>2]&3](244,159,-+h[(c[(b+416|0)>>2]|0)+20728>>3],775,d);se[c[(d+8|0)>>2]&3](244,160,-1.0,776,d);se[c[(d+8|0)>>2]&3](245,150,1.0,777,d);se[c[(d+8|0)>>2]&3](245,158,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24728>>3],778,d);se[c[(d+8|0)>>2]&3](245,159,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24752>>3],779,d);se[c[(d+8|0)>>2]&3](246,156,1.0,780,d);se[c[(d+8|0)>>2]&3](246,157,1.0,781,d);se[c[(d+8|0)>>2]&3](246,158,-1.0,782,d);se[c[(d+8|0)>>2]&3](247,149,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23456>>3]*-2.0328,783,d);se[c[(d+8|0)>>2]&3](247,156,1.0,784,d);se[c[(d+8|0)>>2]&3](247,166,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23464>>3]*-2.0328,785,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](248,152,+h[e+23464>>3]*+h[a+20736>>3]- +h[e+23488>>3]*+h[a+20728>>3],786,d);se[c[(d+8|0)>>2]&3](248,155,1.0,787,d);se[c[(d+8|0)>>2]&3](248,166,-1.0,788,d);se[c[(d+8|0)>>2]&3](249,154,.4999999999999999,789,d);se[c[(d+8|0)>>2]&3](249,155,1.0,790,d);se[c[(d+8|0)>>2]&3](250,153,1.0,791,d);se[c[(d+8|0)>>2]&3](250,154,.8660254037844387,792,d);se[c[(d+8|0)>>2]&3](251,149,-1.0,793,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](251,152,+h[a+23456>>3]*+h[e+20736>>3]- +h[a+23480>>3]*+h[e+20728>>3],794,d);se[c[(d+8|0)>>2]&3](251,153,1.0,795,d);se[c[(d+8|0)>>2]&3](252,151,1.0,796,d);se[c[(d+8|0)>>2]&3](252,153,-5.237345664226305,797,d);se[c[(d+8|0)>>2]&3](252,155,-3.023782929080176,798,d);se[c[(d+8|0)>>2]&3](253,150,1.0,799,d);se[c[(d+8|0)>>2]&3](253,151,1.0,800,d);se[c[(d+8|0)>>2]&3](254,136,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3],801,d);se[c[(d+8|0)>>2]&3](254,149,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3],802,d);se[c[(d+8|0)>>2]&3](254,166,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3],803,d);se[c[(d+8|0)>>2]&3](254,167,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3],804,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](254,270,-(+h[e+12424>>3]*(+h[e+1608>>3]- +h[e+12200>>3]))- +h[e+12432>>3]*(+h[e+1600>>3]- +h[e+12192>>3]),805,d);se[c[(d+8|0)>>2]&3](255,148,1.0,806,d);se[c[(d+8|0)>>2]&3](255,168,-1.0,807,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](255,270,+h[e+12440>>3]*+h[a+23624>>3]- +h[e+12424>>3]*+h[a+23616>>3],808,d);se[c[(d+8|0)>>2]&3](256,135,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-.77,809,d);se[c[(d+8|0)>>2]&3](256,147,1.0,810,d);se[c[(d+8|0)>>2]&3](256,148,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-.77,811,d);se[c[(d+8|0)>>2]&3](256,270,.03850000000000001,812,d);se[c[(d+8|0)>>2]&3](257,146,1.0,813,d);se[c[(d+8|0)>>2]&3](257,147,.05,814,d);se[c[(d+8|0)>>2]&3](257,270,-.0008020833333333335,815,d);se[c[(d+8|0)>>2]&3](258,135,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-.77,816,d);se[c[(d+8|0)>>2]&3](258,145,1.0,817,d);se[c[(d+8|0)>>2]&3](258,148,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-.77,818,d);se[c[(d+8|0)>>2]&3](259,144,1.0,819,d);se[c[(d+8|0)>>2]&3](259,148,-1.0,820,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](259,270,+h[a+12440>>3]*+h[e+21632>>3]- +h[a+12424>>3]*+h[e+21624>>3],821,d);se[c[(d+8|0)>>2]&3](260,137,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-.653137112681318,822,d);se[c[(d+8|0)>>2]&3](260,143,1.0,823,d);se[c[(d+8|0)>>2]&3](260,168,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-.653137112681318,824,d);se[c[(d+8|0)>>2]&3](261,137,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-.653137112681318,825,d);se[c[(d+8|0)>>2]&3](261,142,1.0,826,d);se[c[(d+8|0)>>2]&3](261,168,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-.653137112681318,827,d);se[c[(d+8|0)>>2]&3](262,139,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-1.814269757448105,828,d);se[c[(d+8|0)>>2]&3](262,141,1.0,829,d);se[c[(d+8|0)>>2]&3](262,173,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-1.814269757448105,830,d);se[c[(d+8|0)>>2]&3](263,139,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-1.814269757448105,831,d);se[c[(d+8|0)>>2]&3](263,140,1.0,832,d);se[c[(d+8|0)>>2]&3](263,173,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-1.814269757448105,833,d);se[c[(d+8|0)>>2]&3](264,132,-1.0,834,d);se[c[(d+8|0)>>2]&3](264,139,1.0,835,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](264,270,+h[e+12656>>3]*+h[a+24976>>3]- +h[e+12640>>3]*+h[a+24968>>3],836,d);se[c[(d+8|0)>>2]&3](265,138,1.0,837,d);se[c[(d+8|0)>>2]&3](265,139,-1.0,838,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](265,270,+h[a+12448>>3]*+h[e+24400>>3]- +h[a+12432>>3]*+h[e+24392>>3],839,d);se[c[(d+8|0)>>2]&3](266,137,1.0,840,d);se[c[(d+8|0)>>2]&3](266,138,-1.0,841,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](266,270,+h[e+12448>>3]*+h[a+22432>>3]- +h[e+12432>>3]*+h[a+22424>>3],842,d);se[c[(d+8|0)>>2]&3](267,136,1.0,843,d);se[c[(d+8|0)>>2]&3](267,137,-1.0,844,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](267,270,+h[a+12448>>3]*+h[e+24496>>3]- +h[a+12432>>3]*+h[e+24488>>3],845,d);se[c[(d+8|0)>>2]&3](268,135,1.0,846,d);se[c[(d+8|0)>>2]&3](268,137,-1.0,847,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](268,270,+h[e+12448>>3]*+h[a+23624>>3]- +h[e+12432>>3]*+h[a+23616>>3],848,d);se[c[(d+8|0)>>2]&3](269,134,1.0,849,d);se[c[(d+8|0)>>2]&3](269,135,-1.0,850,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](269,270,+h[a+12448>>3]*+h[e+21632>>3]- +h[a+12432>>3]*+h[e+21624>>3],851,d);se[c[(d+8|0)>>2]&3](270,102,-1.0,852,d);se[c[(d+8|0)>>2]&3](270,133,1.0,853,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](270,270,+h[e+13088>>3]*+h[a+18952>>3]- +h[e+13072>>3]*+h[a+18944>>3],854,d);se[c[(d+8|0)>>2]&3](271,92,-1.0,855,d);se[c[(d+8|0)>>2]&3](271,132,1.0,856,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](271,270,+h[a+13096>>3]*+h[e+18952>>3]- +h[a+13080>>3]*+h[e+18944>>3],857,d);se[c[(d+8|0)>>2]&3](272,91,-1.0,858,d);se[c[(d+8|0)>>2]&3](272,131,1.0,859,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](272,270,+h[e+13296>>3]*+h[a+18568>>3]- +h[e+13280>>3]*+h[a+18560>>3],860,d);se[c[(d+8|0)>>2]&3](273,130,1.0,861,d);se[c[(d+8|0)>>2]&3](273,131,-1.0,862,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](273,270,+h[a+13088>>3]*+h[e+17992>>3]- +h[a+13072>>3]*+h[e+17984>>3],863,d);se[c[(d+8|0)>>2]&3](274,96,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-.77,864,d);se[c[(d+8|0)>>2]&3](274,129,1.0,865,d);se[c[(d+8|0)>>2]&3](274,130,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-.77,866,d);se[c[(d+8|0)>>2]&3](274,270,-.03850000000000001,867,d);se[c[(d+8|0)>>2]&3](275,128,1.0,868,d);se[c[(d+8|0)>>2]&3](275,129,-.05,869,d);se[c[(d+8|0)>>2]&3](275,270,-.0008020833333333335,870,d);se[c[(d+8|0)>>2]&3](276,96,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-.77,871,d);se[c[(d+8|0)>>2]&3](276,127,1.0,872,d);se[c[(d+8|0)>>2]&3](276,130,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-.77,873,d);se[c[(d+8|0)>>2]&3](277,126,1.0,874,d);se[c[(d+8|0)>>2]&3](277,130,-1.0,875,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;a=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](277,270,+h[e+13088>>3]*+h[a+16024>>3]- +h[e+13072>>3]*+h[a+16016>>3],876,d);se[c[(d+8|0)>>2]&3](278,125,1.0,877,d);se[c[(d+8|0)>>2]&3](278,126,-1.0,878,d);a=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](278,270,+h[a+13088>>3]*+h[e+18088>>3]- +h[a+13072>>3]*+h[e+18080>>3],879,d);se[c[(d+8|0)>>2]&3](279,94,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3],880,d);se[c[(d+8|0)>>2]&3](279,107,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3],881,d);se[c[(d+8|0)>>2]&3](279,124,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3],882,d);se[c[(d+8|0)>>2]&3](279,125,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3],883,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](279,270,+h[e+13096>>3]*(+h[e+2224>>3]- +h[e+12840>>3])+ +h[e+13088>>3]*(+h[e+2232>>3]- +h[e+12848>>3]),884,d);se[c[(d+8|0)>>2]&3](280,107,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23608>>3]*-2.0328,885,d);se[c[(d+8|0)>>2]&3](280,113,-.182952,886,d);se[c[(d+8|0)>>2]&3](280,123,1.0,887,d);se[c[(d+8|0)>>2]&3](280,124,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23600>>3]*-2.0328,888,d);se[c[(d+8|0)>>2]&3](281,117,-1.0,889,d);se[c[(d+8|0)>>2]&3](281,122,1.0,890,d);se[c[(d+8|0)>>2]&3](281,123,1.0,891,d);se[c[(d+8|0)>>2]&3](282,119,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9792>>3],892,d);se[c[(d+8|0)>>2]&3](282,121,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9816>>3],893,d);se[c[(d+8|0)>>2]&3](282,122,1.0,894,d);se[c[(d+8|0)>>2]&3](283,119,-+h[(c[(b+416|0)>>2]|0)+18088>>3],895,d);se[c[(d+8|0)>>2]&3](283,120,-1.0,896,d);se[c[(d+8|0)>>2]&3](283,121,+h[(c[(b+416|0)>>2]|0)+18080>>3],897,d);se[c[(d+8|0)>>2]&3](284,115,1.0,898,d);se[c[(d+8|0)>>2]&3](284,119,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9784>>3],899,d);se[c[(d+8|0)>>2]&3](284,121,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9808>>3],900,d);se[c[(d+8|0)>>2]&3](285,113,-.008808799999999999,901,d);se[c[(d+8|0)>>2]&3](285,118,-1.0,902,d);se[c[(d+8|0)>>2]&3](285,123,-.09,903,d);se[c[(d+8|0)>>2]&3](286,116,+h[(c[(b+416|0)>>2]|0)+14328>>3],904,d);se[c[(d+8|0)>>2]&3](286,117,-+h[(c[(b+416|0)>>2]|0)+14320>>3],905,d);}function _setLinearVectorb5242$0(a){a=a|0;var b=0,d=0,e=0,f=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0.0,s=0.0,t=0,u=0,v=0;b=c[a+8>>2]|0;d=c[a+16>>2]|0;e=c[a+248>>2]|0;f=c[a+264>>2]|0;j=c[a+280>>2]|0;k=+g[a+288>>2];l=c[a+1888>>2]|0;m=c[a+1904>>2]|0;a:do{h[j+2136>>3]=+h[(f+12448|0)>>3]*k*+h[e+24488>>3]*-k+ +h[(f+12432|0)>>3]*k*+h[e+24496>>3]*-k;n=+h[(f+16|0)>>3];h[j+2144>>3]=+h[(f+12448|0)>>3]*n*+h[e+23616>>3]*-n+ +h[(f+12432|0)>>3]*n*+h[e+23624>>3]*-n;n=+h[(f+16|0)>>3];h[j+2152>>3]=+h[(f+12448|0)>>3]*n*+h[e+21624>>3]*-n+ +h[(f+12432|0)>>3]*n*+h[e+21632>>3]*-n;n=+h[(f+16|0)>>3];h[j+2160>>3]=+h[f+13088>>3]*n*+h[e+18944>>3]*-n+ +h[f+13072>>3]*n*+h[e+18952>>3]*-n;n=+h[(f+16|0)>>3];o=c[(b+416|0)>>2]|0;h[j+2168>>3]=+h[f+13096>>3]*n*+h[o+18944>>3]*-n+ +h[f+13080>>3]*n*+h[o+18952>>3]*-n;p=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=+h[(p+16|0)>>3];q=c[(d+36|0)>>2]|0;h[q+2176>>3]=+h[p+13296>>3]*n*+h[o+18560>>3]*-n+ +h[p+13280>>3]*n*+h[o+18568>>3]*-n;n=+h[(p+16|0)>>3];h[q+2184>>3]=+h[(p+13088|0)>>3]*n*+h[o+17984>>3]*-n+ +h[(p+13072|0)>>3]*n*+h[o+17992>>3]*-n;h[q+2192>>3]=+h[p+13080>>3]*+h[(o+38584|0)>>3]*.77;h[q+2200>>3]=0.0;n=+h[(p+16|0)>>3];h[q+2208>>3]=(n*n*-.05+ +h[p+13096>>3]*+h[(o+38584|0)>>3])*.77;n=+h[(p+16|0)>>3];h[q+2216>>3]=+h[(p+13088|0)>>3]*n*+h[o+16016>>3]*-n+ +h[(p+13072|0)>>3]*n*+h[o+16024>>3]*-n;n=+h[(p+16|0)>>3];o=c[(b+416|0)>>2]|0;h[q+2224>>3]=+h[(p+13088|0)>>3]*n*+h[o+18080>>3]*-n+ +h[(p+13072|0)>>3]*n*+h[o+18088>>3]*-n;p=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=+h[p+16>>3];r=+h[p+13096>>3]*(+h[p+12736>>3]- +h[p+13008>>3]);s=+h[p+13088>>3]*(+h[p+12744>>3]- +h[p+13016>>3]);q=c[(d+36|0)>>2]|0;h[q+2232>>3]=-(n*(r+(s+n*(+h[p+13080>>3]*(+h[p+2224>>3]- +h[p+12840>>3])+ +h[p+13072>>3]*(+h[p+2232>>3]- +h[p+12848>>3])))))-n*(r+s);h[q+2240>>3]=+h[(p+23600|0)>>3]*+h[(o+38584|0)>>3]*2.0328;l=q+2248|0;m=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));h[q+2288>>3]=+h[(o+41872|0)>>3];c[(q+2296|0)+0>>2]=0;c[(q+2296|0)+4>>2]=0;c[(q+2296|0)+8>>2]=0;c[(q+2296|0)+12>>2]=0;s=+h[(p+12752|0)>>3];h[q+2312>>3]=(s*s*-.09+ +h[(p+23576|0)>>3]*+h[(o+38584|0)>>3])*2.0328;s=+h[(p+12752|0)>>3];t=c[(b+416|0)>>2]|0;h[q+2320>>3]=+h[(p+23576|0)>>3]*s*+h[(t+14320|0)>>3]*-s+ +h[(p+23600|0)>>3]*s*+h[(t+14328|0)>>3]*-s;u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[u+12752>>3];h[q+2328>>3]=+h[u+23584>>3]*s*+h[(t+14320|0)>>3]*-s+ +h[u+23608>>3]*s*+h[(t+14328|0)>>3]*-s;c[(q+2336|0)+0>>2]=0;c[(q+2336|0)+4>>2]=0;c[(q+2336|0)+8>>2]=0;c[(q+2336|0)+12>>2]=0;h[q+2352>>3]=+h[(t+38584|0)>>3]*5.237345664226305;h[q+2360>>3]=-+h[u+26392>>3];s=+h[(u+16|0)>>3];r=+h[(u+13080|0)>>3]*(+h[u+12736>>3]- +h[u+13008>>3]);n=+h[(u+13072|0)>>3]*(+h[u+12744>>3]- +h[u+13016>>3]);v=c[(d+36|0)>>2]|0;h[v+2368>>3]=s*(r+n)+s*(r+(n-s*(+h[u+13096>>3]*(+h[u+2224>>3]- +h[u+12840>>3])+ +h[(u+13088|0)>>3]*(+h[u+2232>>3]- +h[u+12848>>3]))));s=+h[(u+16|0)>>3];h[v+2376>>3]=+h[(u+13088|0)>>3]*s*+h[t+17208>>3]*-s+ +h[(u+13072|0)>>3]*s*+h[t+17216>>3]*-s;t=c[(b+416|0)>>2]|0;h[v+2384>>3]=+h[(u+13080|0)>>3]*+h[(t+38584|0)>>3]*.77;h[v+2392>>3]=0.0;u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[(u+16|0)>>3];h[v+2400>>3]=(s*s*.05+ +h[(u+13096|0)>>3]*+h[(t+38584|0)>>3])*.77;s=+h[(u+16|0)>>3];h[v+2408>>3]=+h[u+13088>>3]*s*+h[t+15216>>3]*-s+ +h[u+13072>>3]*s*+h[t+15224>>3]*-s;h[v+2416>>3]=+h[(u+13080|0)>>3]*+h[(t+38584|0)>>3]*.653137112681318;h[v+2424>>3]=+h[(u+13096|0)>>3]*+h[(t+38584|0)>>3]*.653137112681318;h[v+2432>>3]=+h[(u+13080|0)>>3]*+h[(t+38584|0)>>3]*1.814269757448105;h[v+2440>>3]=+h[(u+13096|0)>>3]*+h[(t+38584|0)>>3]*1.814269757448105;s=+h[(u+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2448>>3]=+h[u+13304>>3]*s*+h[t+18560>>3]*-s+ +h[u+13288>>3]*s*+h[t+18568>>3]*-s;s=+h[(u+16|0)>>3];h[v+2456>>3]=+h[(u+13096|0)>>3]*s*+h[t+17984>>3]*-s+ +h[(u+13080|0)>>3]*s*+h[t+17992>>3]*-s;s=+h[(u+16|0)>>3];t=c[(b+416|0)>>2]|0;h[v+2464>>3]=+h[(u+13096|0)>>3]*s*+h[t+16016>>3]*-s+ +h[(u+13080|0)>>3]*s*+h[t+16024>>3]*-s;u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[(u+16|0)>>3];h[v+2472>>3]=+h[(u+13096|0)>>3]*s*+h[t+18080>>3]*-s+ +h[(u+13080|0)>>3]*s*+h[t+18088>>3]*-s;s=+h[(u+16|0)>>3];h[v+2480>>3]=+h[(u+13096|0)>>3]*s*+h[t+17208>>3]*-s+ +h[(u+13080|0)>>3]*s*+h[t+17216>>3]*-s;s=+h[(u+16|0)>>3];h[v+2488>>3]=+h[(u+13096|0)>>3]*s*+h[t+15216>>3]*-s+ +h[(u+13080|0)>>3]*s*+h[t+15224>>3]*-s;s=+h[(u+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2496>>3]=+h[u+13736>>3]*s*+h[(t+12536|0)>>3]*-s+ +h[u+13720>>3]*s*+h[(t+12544|0)>>3]*-s;s=+h[(u+16|0)>>3];h[v+2504>>3]=+h[u+13744>>3]*s*+h[(t+12536|0)>>3]*-s+ +h[u+13728>>3]*s*+h[(t+12544|0)>>3]*-s;s=+h[(u+16|0)>>3];t=c[(b+416|0)>>2]|0;h[v+2512>>3]=+h[u+13944>>3]*s*+h[t+12152>>3]*-s+ +h[u+13928>>3]*s*+h[t+12160>>3]*-s;u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[(u+16|0)>>3];h[v+2520>>3]=+h[(u+13736|0)>>3]*s*+h[t+11576>>3]*-s+ +h[(u+13720|0)>>3]*s*+h[t+11584>>3]*-s;h[v+2528>>3]=+h[(u+13728|0)>>3]*+h[(t+38584|0)>>3]*.77;h[v+2536>>3]=0.0;s=+h[(u+16|0)>>3];h[v+2544>>3]=(s*s*-.05+ +h[(u+13744|0)>>3]*+h[(t+38584|0)>>3])*.77;s=+h[(u+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2552>>3]=+h[(u+13736|0)>>3]*s*+h[t+9608>>3]*-s+ +h[(u+13720|0)>>3]*s*+h[t+9616>>3]*-s;s=+h[(u+16|0)>>3];h[v+2560>>3]=+h[(u+13736|0)>>3]*s*+h[t+11672>>3]*-s+ +h[(u+13720|0)>>3]*s*+h[t+11680>>3]*-s;s=+h[(u+16|0)>>3];n=+h[(u+13744|0)>>3]*(+h[u+13384>>3]- +h[u+13656>>3]);r=+h[(u+13736|0)>>3]*(+h[u+13392>>3]- +h[u+13664>>3]);h[v+2568>>3]=-(s*(n+(r+s*(+h[(u+13728|0)>>3]*(+h[u+2832>>3]- +h[u+13488>>3])+ +h[(u+13720|0)>>3]*(+h[u+2840>>3]- +h[u+13496>>3])))))-s*(n+r);u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;t=c[(b+416|0)>>2]|0;h[v+2576>>3]=+h[(u+23720|0)>>3]*+h[(t+38584|0)>>3]*2.0328;l=v+2584|0;m=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));h[v+2624>>3]=+h[(t+40392|0)>>3];c[(v+2632|0)+0>>2]=0;c[(v+2632|0)+4>>2]=0;c[(v+2632|0)+8>>2]=0;c[(v+2632|0)+12>>2]=0;r=+h[(u+13432|0)>>3];q=c[(d+36|0)>>2]|0;h[q+2648>>3]=(r*r*-.09+ +h[(u+23696|0)>>3]*+h[(t+38584|0)>>3])*2.0328;r=+h[(u+13432|0)>>3];h[q+2656>>3]=+h[(u+23696|0)>>3]*r*+h[(t+7912|0)>>3]*-r+ +h[(u+23720|0)>>3]*r*+h[(t+7920|0)>>3]*-r;r=+h[(u+13432|0)>>3];h[q+2664>>3]=+h[u+23704>>3]*r*+h[(t+7912|0)>>3]*-r+ +h[u+23728>>3]*r*+h[(t+7920|0)>>3]*-r;c[(q+2672|0)+0>>2]=0;c[(q+2672|0)+4>>2]=0;c[(q+2672|0)+8>>2]=0;c[(q+2672|0)+12>>2]=0;h[q+2688>>3]=+h[(t+38584|0)>>3]*5.237345664226305;h[q+2696>>3]=-+h[u+26504>>3];r=+h[u+16>>3];n=+h[u+13728>>3]*(+h[u+13384>>3]- +h[u+13656>>3]);s=+h[u+13720>>3]*(+h[u+13392>>3]- +h[u+13664>>3]);h[q+2704>>3]=r*(n+s)+r*(n+(s-r*(+h[u+13744>>3]*(+h[u+2832>>3]- +h[u+13488>>3])+ +h[u+13736>>3]*(+h[u+2840>>3]- +h[u+13496>>3]))));q=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(q+16|0)>>3];p=c[(b+416|0)>>2]|0;o=c[(d+36|0)>>2]|0;h[o+2712>>3]=+h[(q+13736|0)>>3]*r*+h[p+10800>>3]*-r+ +h[(q+13720|0)>>3]*r*+h[p+10808>>3]*-r;h[o+2720>>3]=+h[(q+13728|0)>>3]*+h[(p+38584|0)>>3]*.77;h[o+2728>>3]=0.0;r=+h[(q+16|0)>>3];h[o+2736>>3]=(r*r*.05+ +h[(q+13744|0)>>3]*+h[(p+38584|0)>>3])*.77;r=+h[(q+16|0)>>3];h[o+2744>>3]=+h[(q+13736|0)>>3]*r*+h[p+8808>>3]*-r+ +h[(q+13720|0)>>3]*r*+h[p+8816>>3]*-r;h[o+2752>>3]=+h[(q+13728|0)>>3]*+h[(p+38584|0)>>3]*.653137112681318;h[o+2760>>3]=+h[(q+13744|0)>>3]*+h[(p+38584|0)>>3]*.653137112681318;h[o+2768>>3]=+h[(q+13728|0)>>3]*+h[(p+38584|0)>>3]*1.814269757448105;h[o+2776>>3]=+h[(q+13744|0)>>3]*+h[(p+38584|0)>>3]*1.814269757448105;r=+h[(q+16|0)>>3];h[o+2784>>3]=+h[q+13952>>3]*r*+h[p+12152>>3]*-r+ +h[q+13936>>3]*r*+h[p+12160>>3]*-r;p=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(p+16|0)>>3];q=c[(b+416|0)>>2]|0;o=c[(d+36|0)>>2]|0;h[o+2792>>3]=+h[(p+13744|0)>>3]*r*+h[q+11576>>3]*-r+ +h[(p+13728|0)>>3]*r*+h[q+11584>>3]*-r;r=+h[(p+16|0)>>3];h[o+2800>>3]=+h[(p+13744|0)>>3]*r*+h[q+9608>>3]*-r+ +h[(p+13728|0)>>3]*r*+h[q+9616>>3]*-r;r=+h[(p+16|0)>>3];h[o+2808>>3]=+h[(p+13744|0)>>3]*r*+h[q+11672>>3]*-r+ +h[(p+13728|0)>>3]*r*+h[q+11680>>3]*-r;r=+h[(p+16|0)>>3];h[o+2816>>3]=+h[(p+13744|0)>>3]*r*+h[q+10800>>3]*-r+ +h[(p+13728|0)>>3]*r*+h[q+10808>>3]*-r;r=+h[(p+16|0)>>3];h[o+2824>>3]=+h[(p+13744|0)>>3]*r*+h[q+8808>>3]*-r+ +h[(p+13728|0)>>3]*r*+h[q+8816>>3]*-r;r=+h[(p+16|0)>>3];h[o+2832>>3]=+h[p+23040>>3]*r*+h[q+6128>>3]*-r+ +h[p+23024>>3]*r*+h[q+6136>>3]*-r;q=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(q+16|0)>>3];p=c[(b+416|0)>>2]|0;o=c[(d+36|0)>>2]|0;h[o+2840>>3]=+h[(q+23048|0)>>3]*r*+h[p+6128>>3]*-r+ +h[(q+23032|0)>>3]*r*+h[p+6136>>3]*-r;r=+h[(q+16|0)>>3];h[o+2848>>3]=+h[q+23896>>3]*r*+h[p+5744>>3]*-r+ +h[q+23880>>3]*r*+h[p+5752>>3]*-r;r=+h[(q+16|0)>>3];h[o+2856>>3]=+h[(q+23040|0)>>3]*r*+h[p+5168>>3]*-r+ +h[(q+23024|0)>>3]*r*+h[p+5176>>3]*-r;h[o+2864>>3]=+h[(q+23032|0)>>3]*+h[(p+38584|0)>>3]*.77;h[o+2872>>3]=0.0;r=+h[(q+16|0)>>3];h[o+2880>>3]=(r*r*-.05+ +h[(q+23048|0)>>3]*+h[(p+38584|0)>>3])*.77;r=+h[(q+16|0)>>3];h[o+2888>>3]=+h[(q+23040|0)>>3]*r*+h[p+3200>>3]*-r+ +h[(q+23024|0)>>3]*r*+h[p+3208>>3]*-r;p=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(p+16|0)>>3];q=c[(b+416|0)>>2]|0;o=c[(d+36|0)>>2]|0;h[o+2896>>3]=+h[(p+23040|0)>>3]*r*+h[q+5264>>3]*-r+ +h[(p+23024|0)>>3]*r*+h[q+5272>>3]*-r;r=+h[(p+16|0)>>3];s=+h[p+23048>>3]*(+h[p+14032>>3]- +h[p+14160>>3]);n=+h[(p+23040|0)>>3]*(+h[p+14040>>3]- +h[p+14168>>3]);h[o+2904>>3]=-(r*(s+(n+r*(+h[p+23032>>3]*(+h[p+3408>>3]- +h[p+14768>>3])+ +h[(p+23024|0)>>3]*(+h[p+3416>>3]- +h[p+14776>>3])))))-r*(s+n);h[o+2912>>3]=+h[p+23864>>3]*+h[(q+38584|0)>>3]*2.0328;l=o+2920|0;m=l+40|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));h[o+2960>>3]=+h[(q+38912|0)>>3];c[(o+2968|0)+0>>2]=0;c[(o+2968|0)+4>>2]=0;c[(o+2968|0)+8>>2]=0;c[(o+2968|0)+12>>2]=0;n=+h[(p+14048|0)>>3];h[o+2984>>3]=(n*n*-.09+ +h[p+23840>>3]*+h[(q+38584|0)>>3])*2.0328;u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=+h[(u+14048|0)>>3];t=c[(b+416|0)>>2]|0;v=c[(d+36|0)>>2]|0;h[v+2992>>3]=+h[u+23840>>3]*n*+h[(t+1504|0)>>3]*-n+ +h[u+23864>>3]*n*+h[(t+1512|0)>>3]*-n;n=+h[(u+14048|0)>>3];h[v+3e3>>3]=+h[u+23848>>3]*n*+h[(t+1504|0)>>3]*-n+ +h[u+23872>>3]*n*+h[(t+1512|0)>>3]*-n;c[(v+3008|0)+0>>2]=0;c[(v+3008|0)+4>>2]=0;c[(v+3008|0)+8>>2]=0;c[(v+3008|0)+12>>2]=0;h[v+3024>>3]=+h[(t+38584|0)>>3]*5.237345664226305;h[v+3032>>3]=-+h[u+26616>>3];n=+h[u+16>>3];s=+h[u+23032>>3]*(+h[u+14032>>3]- +h[u+14160>>3]);r=+h[u+23024>>3]*(+h[u+14040>>3]- +h[u+14168>>3]);h[v+3040>>3]=n*(s+r)+n*(s+(r-n*(+h[u+23048>>3]*(+h[u+3408>>3]- +h[u+14768>>3])+ +h[u+23040>>3]*(+h[u+3416>>3]- +h[u+14776>>3]))));u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=+h[(u+16|0)>>3];v=c[(b+416|0)>>2]|0;t=c[(d+36|0)>>2]|0;h[t+3048>>3]=+h[(u+23040|0)>>3]*n*+h[v+4392>>3]*-n+ +h[(u+23024|0)>>3]*n*+h[v+4400>>3]*-n;h[t+3056>>3]=+h[(u+23032|0)>>3]*+h[(v+38584|0)>>3]*.77;h[t+3064>>3]=0.0;n=+h[(u+16|0)>>3];h[t+3072>>3]=(n*n*.05+ +h[(u+23048|0)>>3]*+h[(v+38584|0)>>3])*.77;n=+h[(u+16|0)>>3];h[t+3080>>3]=+h[(u+23040|0)>>3]*n*+h[v+2400>>3]*-n+ +h[(u+23024|0)>>3]*n*+h[v+2408>>3]*-n;h[t+3088>>3]=+h[(u+23032|0)>>3]*+h[(v+38584|0)>>3]*.653137112681318;h[t+3096>>3]=+h[(u+23048|0)>>3]*+h[(v+38584|0)>>3]*.653137112681318;h[t+3104>>3]=+h[(u+23048|0)>>3]*+h[(v+38584|0)>>3]*1.814269757448105;n=+h[(u+16|0)>>3];h[t+3112>>3]=+h[(u+23048|0)>>3]*n*+h[v+5168>>3]*-n+ +h[(u+23032|0)>>3]*n*+h[v+5176>>3]*-n;n=+h[(u+16|0)>>3];h[t+3120>>3]=+h[(u+23048|0)>>3]*n*+h[v+3200>>3]*-n+ +h[(u+23032|0)>>3]*n*+h[v+3208>>3]*-n;v=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;n=+h[(v+16|0)>>3];u=c[(b+416|0)>>2]|0;t=c[(d+36|0)>>2]|0;h[t+3128>>3]=+h[(v+23048|0)>>3]*n*+h[u+5264>>3]*-n+ +h[(v+23032|0)>>3]*n*+h[u+5272>>3]*-n;n=+h[(v+16|0)>>3];h[t+3136>>3]=+h[(v+23048|0)>>3]*n*+h[u+4392>>3]*-n+ +h[(v+23032|0)>>3]*n*+h[u+4400>>3]*-n;n=+h[(v+16|0)>>3];h[t+3144>>3]=+h[(v+23048|0)>>3]*n*+h[u+2400>>3]*-n+ +h[(v+23032|0)>>3]*n*+h[u+2408>>3]*-n;l=t+3152|0;m=l+80|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));i=a;c[a+1912>>2]=5;break a}while(0);c[a+1888>>2]=l;c[a+1904>>2]=m}



function KWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=1;j=(f&255)>>>1}if((j|0)==(h|0)){MWc(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+4|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}c[l+(j<<2)>>2]=d;c[l+(m<<2)>>2]=0;i=e;return}function LWc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((1073741806-d|0)>>>0<e>>>0){QVc(0)}if((a[b]&1)==0){m=b+4|0}else{m=c[b+8>>2]|0}do{if(d>>>0<536870887){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<2){q=2;break}q=p+4&-4}else{q=1073741807}}while(0);e=n4c(q<<2)|0;p=e;if((g|0)!=0){K3c(p,m,g)|0}if((j|0)!=0){K3c(e+(g<<2)|0,k,j)|0}k=f-h|0;if((k|0)!=(g|0)){K3c(e+(j+g<<2)|0,m+(h+g<<2)|0,k-g|0)|0}if((d|0)!=1){p4c(m)}c[b+8>>2]=p;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;c[e+(q<<2)>>2]=0;i=l;return}function MWc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((1073741807-d|0)>>>0<e>>>0){QVc(0)}if((a[b]&1)==0){l=b+4|0}else{l=c[b+8>>2]|0}do{if(d>>>0<536870887){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<2){p=2;break}p=o+4&-4}else{p=1073741807}}while(0);e=n4c(p<<2)|0;o=e;if((g|0)!=0){K3c(o,l,g)|0}m=f-h|0;if((m|0)!=(g|0)){K3c(e+(j+g<<2)|0,l+(h+g<<2)|0,m-g|0)|0}if((d|0)==1){q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}p4c(l);q=b;r=q+8|0;s=r;c[s>>2]=o;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function NWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=b;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;g=L4c(d|0)|0;h=a[e]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[e+4>>2]|0}h=j+g|0;if(h>>>0>4294967279){QVc(0)}if(h>>>0<11){a[b]=g<<1;k=b+1|0}else{l=h+16&-16;h=n4c(l)|0;c[b+8>>2]=h;c[b>>2]=l|1;c[b+4>>2]=g;k=h}N4c(k|0,d|0,g|0)|0;a[k+g|0]=0;if((a[e]&1)==0){m=e+1|0;n=vWc(b,m,j)|0;i=f;return}else{m=c[e+8>>2]|0;n=vWc(b,m,j)|0;i=f;return}}function OWc(a){a=a|0;i=i;return(c[a+16>>2]&5|0)==0|0}function PWc(a){a=a|0;i=i;return(c[a+16>>2]&5|0)!=0|0}function QWc(a,b){a=a|0;b=b|0;var c=0;c=i;RWc(a,b);i=c;return}function RWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(c[b+24>>2]|0)==0;if(h){c[b+16>>2]=d|1}else{c[b+16>>2]=d}if(((h&1|d)&c[b+20>>2]|0)==0){i=e;return}e=Ec(16)|0;do{if((a[363976]|0)==0){if((Za(363976)|0)==0){break}c[90992]=364672;Zd(66,363968,q|0)|0;Tb(363976)}}while(0);b=e;d=g;c[d>>2]=1;c[d+4>>2]=363968;d=f;h=g;c[d+0>>2]=c[h+0>>2];c[d+4>>2]=c[h+4>>2];MVc(b,f,364024);c[e>>2]=363992;Td(e|0,364072,62)}function SWc(a,b){a=a|0;b=b|0;var d=0;d=i;RWc(a,c[a+16>>2]|b);i=d;return}function TWc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;c[a>>2]=364016;d=c[a+40>>2]|0;e=a+32|0;f=a+36|0;if((d|0)!=0){g=d;do{g=g+ -1|0;Ee[c[(c[e>>2]|0)+(g<<2)>>2]&15](0,a,c[(c[f>>2]|0)+(g<<2)>>2]|0);}while((g|0)!=0)}M0c(a+28|0);i4c(c[e>>2]|0);i4c(c[f>>2]|0);i4c(c[a+48>>2]|0);i4c(c[a+60>>2]|0);i=b;return}function UWc(a){a=a|0;var b=0;b=i;TWc(a);p4c(a);i=b;return}function VWc(a){a=a|0;var b=0;b=i;TWc(a);i=b;return}function WWc(a){a=a|0;var b=0;b=i;TWc(a);i=b;return}function XWc(a){a=a|0;i=i;return c[a+24>>2]|0}function YWc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=b;e=a+76|0;f=c[e>>2]|0;if(!((f|0)==-1)){g=f&255;i=b;return g|0}L0c(d,a+28|0);a=O0c(d,366360)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,32)|0;M0c(d);c[e>>2]=f<<24>>24;g=f;i=b;return g|0}function ZWc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=d;L0c(e,a+28|0);a=O0c(e,366360)|0;f=xe[c[(c[a>>2]|0)+28>>2]&63](a,b)|0;M0c(e);i=d;return f|0}function _Wc(a,b){a=a|0;b=b|0;var c=0;c=i;L0c(a,b+28|0);i=c;return}function $Wc(a){a=a|0;c[a>>2]=363616;i=i;return}function aXc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;c[a+24>>2]=b;c[a+16>>2]=(b|0)==0;c[a+20>>2]=0;c[a+4>>2]=4098;c[a+12>>2]=0;c[a+8>>2]=6;b=a+28|0;e=a+32|0;a=e+40|0;do{c[e>>2]=0;e=e+4|0}while((e|0)<(a|0));K0c(b);i=d;return}function bXc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);p4c(a);i=b;return}function cXc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);i=b;return}function dXc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);i=b;return}function eXc(a,b){a=a|0;b=b|0;var c=0;c=i;L0c(a,b+4|0);i=c;return}function fXc(a){a=a|0;var b=0,e=0,f=0,g=0;b=i;e=a+12|0;f=c[e>>2]|0;if((f|0)==(c[a+16>>2]|0)){g=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;i=b;return g|0}else{c[e>>2]=f+1;g=d[f]|0;i=b;return g|0}return 0}function gXc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==(c[b+28>>2]|0)){h=xe[c[(c[b>>2]|0)+52>>2]&63](b,d&255)|0;i=e;return h|0}else{c[f>>2]=g+1;a[g]=d;h=d&255;i=e;return h|0}return 0}function hXc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=le[c[(c[a>>2]|0)+48>>2]&63](a,b,d)|0;i=e;return f|0}function iXc(a){a=a|0;var b=0,d=0;b=i;c[a>>2]=363632;K0c(a+4|0);d=a+8|0;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;c[d+12>>2]=0;c[d+16>>2]=0;c[d+20>>2]=0;i=b;return}function jXc(a){a=a|0;i=i;return c[a+8>>2]|0}function kXc(a){a=a|0;i=i;return c[a+12>>2]|0}function lXc(a){a=a|0;i=i;return c[a+16>>2]|0}function mXc(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function nXc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;c[a+8>>2]=b;c[a+12>>2]=d;c[a+16>>2]=e;i=i;return}function oXc(a){a=a|0;i=i;return c[a+20>>2]|0}function pXc(a){a=a|0;i=i;return c[a+24>>2]|0}function qXc(a){a=a|0;i=i;return c[a+28>>2]|0}function rXc(a,b){a=a|0;b=b|0;var d=0;d=a+24|0;c[d>>2]=(c[d>>2]|0)+b;i=i;return}function sXc(a,b,d){a=a|0;b=b|0;d=d|0;c[a+24>>2]=b;c[a+20>>2]=b;c[a+28>>2]=d;i=i;return}function tXc(a,b){a=a|0;b=b|0;i=i;return}function uXc(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function vXc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function wXc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function xXc(a){a=a|0;i=i;return 0}function yXc(a){a=a|0;i=i;return 0}function zXc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;if((e|0)<=0){g=0;i=f;return g|0}h=b+12|0;j=b+16|0;k=d;d=0;while(1){l=c[h>>2]|0;if(l>>>0<(c[j>>2]|0)>>>0){c[h>>2]=l+1;m=a[l]|0}else{l=ie[c[(c[b>>2]|0)+40>>2]&127](b)|0;if((l|0)==-1){g=d;n=8;break}m=l&255}a[k]=m;l=d+1|0;if((l|0)<(e|0)){k=k+1|0;d=l}else{g=l;n=8;break}}if((n|0)==8){i=f;return g|0}return 0}function AXc(a){a=a|0;i=i;return-1}function BXc(a){a=a|0;var b=0,e=0,f=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){e=-1;i=b;return e|0}f=a+12|0;a=c[f>>2]|0;c[f>>2]=a+1;e=d[a]|0;i=b;return e|0}function CXc(a,b){a=a|0;b=b|0;i=i;return-1}function DXc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((f|0)<=0){h=0;i=g;return h|0}j=b+24|0;k=b+28|0;l=e;e=0;while(1){m=c[j>>2]|0;if(m>>>0<(c[k>>2]|0)>>>0){n=a[l]|0;c[j>>2]=m+1;a[m]=n}else{if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[l]|0)|0)==-1){h=e;o=7;break}}n=e+1|0;if((n|0)<(f|0)){l=l+1|0;e=n}else{h=n;o=7;break}}if((o|0)==7){i=g;return h|0}return 0}function EXc(a,b){a=a|0;b=b|0;i=i;return-1}function FXc(a){a=a|0;var b=0;b=i;c[a>>2]=363696;M0c(a+4|0);p4c(a);i=b;return}function GXc(a){a=a|0;var b=0;b=i;c[a>>2]=363696;M0c(a+4|0);i=b;return}function HXc(a,b){a=a|0;b=b|0;i=i;return}function IXc(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return a|0}function JXc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;g=a;c[g>>2]=0;c[g+4>>2]=0;g=a+8|0;c[g>>2]=-1;c[g+4>>2]=-1;i=i;return}function KXc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=-1;c[e+4>>2]=-1;i=i;return}function LXc(a){a=a|0;i=i;return 0}function MXc(a){a=a|0;i=i;return 0}function NXc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+12|0;h=a+16|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[g>>2]=k+4;l=c[k>>2]|0}else{k=ie[c[(c[a>>2]|0)+40>>2]&127](a)|0;if((k|0)==-1){f=b;m=8;break}else{l=k}}c[j>>2]=l;k=b+1|0;if((k|0)>=(d|0)){f=k;m=8;break}j=j+4|0;b=k}if((m|0)==8){i=e;return f|0}return 0}function OXc(a){a=a|0;i=i;return-1}function PXc(a){a=a|0;var b=0,d=0,e=0;b=i;if((ie[c[(c[a>>2]|0)+36>>2]&127](a)|0)==-1){d=-1;i=b;return d|0}e=a+12|0;a=c[e>>2]|0;c[e>>2]=a+4;d=c[a>>2]|0;i=b;return d|0}function QXc(a,b){a=a|0;b=b|0;i=i;return-1}function RXc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)<=0){f=0;i=e;return f|0}g=a+24|0;h=a+28|0;j=b;b=0;while(1){k=c[g>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){l=c[j>>2]|0;c[g>>2]=k+4;c[k>>2]=l}else{if((xe[c[(c[a>>2]|0)+52>>2]&63](a,c[j>>2]|0)|0)==-1){f=b;m=8;break}}l=b+1|0;if((l|0)>=(d|0)){f=l;m=8;break}j=j+4|0;b=l}if((m|0)==8){i=e;return f|0}return 0}function SXc(a,b){a=a|0;b=b|0;i=i;return-1}function TXc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];c[a+4>>2]=0;b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));K0c(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function UXc(a){a=a|0;var b=0;b=i;TWc(a+8|0);p4c(a);i=b;return}function VXc(a){a=a|0;var b=0;b=i;TWc(a+8|0);i=b;return}function WXc(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;TWc(a+(d+8)|0);p4c(a+d|0);i=b;return}function XXc(a){a=a|0;var b=0;b=i;TWc(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function YXc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;ZXc(a,b,c);i=d;return}function ZXc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+8|0;h=g;j=d;a[j]=0;d=c[(c[e>>2]|0)+ -12>>2]|0;k=c[e+(d+16)>>2]|0;if((k|0)!=0){RWc(e+d|0,k|4);i=g;return}k=c[e+(d+72)>>2]|0;if((k|0)!=0){_Xc(k)|0}a:do{if(!f){k=c[(c[e>>2]|0)+ -12>>2]|0;if((c[e+(k+4)>>2]&4096|0)==0){break}L0c(h,e+(k+28)|0);k=O0c(h,366360)|0;M0c(h);d=k+8|0;k=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;while(1){if((k|0)==0){break}if((c[k+12>>2]|0)==(c[k+16>>2]|0)){l=(ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1;m=l?0:k;if((m|0)==0){break}else{n=m}}else{n=k}m=n+12|0;l=c[m>>2]|0;o=n+16|0;if((l|0)==(c[o>>2]|0)){p=(ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)&255}else{p=a[l]|0}if(!(p<<24>>24>-1)){q=18;break}if((b[(c[d>>2]|0)+(p<<24>>24<<1)>>1]&8192)==0){q=18;break}l=c[m>>2]|0;if((l|0)==(c[o>>2]|0)){ie[c[(c[n>>2]|0)+40>>2]&127](n)|0;k=n;continue}else{c[m>>2]=l+1;k=n;continue}}do{if((q|0)==18){if((n|0)==0){break}if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){break a}if(!((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1|(n|0)==0)){break a}}}while(0);k=c[(c[e>>2]|0)+ -12>>2]|0;RWc(e+k|0,c[e+(k+16)>>2]|6)}}while(0);a[j]=(c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+16)>>2]|0)==0|0;i=g;return}function _Xc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{_Xc(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;RWc(b+h|0,c[b+(h+16)>>2]|1)}}while(0);nYc(e);i=d;return b|0}function $Xc(b){b=b|0;i=i;return(a[b]|0)!=0|0}function aYc(a){a=a|0;var b=0;b=a+16|0;c[b>>2]=c[b>>2]|1;if((c[a+20>>2]&1|0)==0){i=i;return}else{Fb()}}function bYc(a){a=a|0;var b=0;b=i;TWc(a+8|0);p4c(a);i=b;return}function cYc(a){a=a|0;var b=0;b=i;TWc(a+8|0);i=b;return}function dYc(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;TWc(a+(d+8)|0);p4c(a+d|0);i=b;return}function eYc(a){a=a|0;var b=0;b=i;TWc(a+((c[(c[a>>2]|0)+ -12>>2]|0)+8)|0);i=b;return}function fYc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+8|0;e=d;f=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(f+24)>>2]|0)==0){i=d;return b|0}g=e;a[g]=0;c[e+4>>2]=b;do{if((c[b+(f+16)>>2]|0)==0){h=c[b+(f+72)>>2]|0;if((h|0)==0){j=f}else{fYc(h)|0;j=c[(c[b>>2]|0)+ -12>>2]|0}a[g]=1;h=c[b+(j+24)>>2]|0;if(!((ie[c[(c[h>>2]|0)+24>>2]&127](h)|0)==-1)){break}h=c[(c[b>>2]|0)+ -12>>2]|0;RWc(b+h|0,c[b+(h+16)>>2]|1)}}while(0);zYc(e);i=d;return b|0}function gYc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[b>>2]|0;c[a>>2]=f;c[a+(c[f+ -12>>2]|0)>>2]=c[b+4>>2];b=c[(c[a>>2]|0)+ -12>>2]|0;c[a+(b+24)>>2]=d;c[a+(b+16)>>2]=(d|0)==0;c[a+(b+20)>>2]=0;c[a+(b+4)>>2]=4098;c[a+(b+12)>>2]=0;c[a+(b+8)>>2]=6;d=a+(b+28)|0;f=a+(b+32)+0|0;g=f+40|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));K0c(d);c[a+(b+72)>>2]=0;c[a+(b+76)>>2]=-1;i=e;return}function hYc(a){a=a|0;var b=0;b=i;TWc(a+4|0);p4c(a);i=b;return}function iYc(a){a=a|0;var b=0;b=i;TWc(a+4|0);i=b;return}function jYc(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;TWc(a+(d+4)|0);p4c(a+d|0);i=b;return}function kYc(a){a=a|0;var b=0;b=i;TWc(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function lYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=b;a[f]=0;c[b+4>>2]=d;b=c[(c[d>>2]|0)+ -12>>2]|0;if((c[d+(b+16)>>2]|0)!=0){i=e;return}g=c[d+(b+72)>>2]|0;if((g|0)!=0){_Xc(g)|0}a[f]=1;i=e;return}function mYc(a){a=a|0;var b=0;b=i;nYc(a);i=b;return}function nYc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;RWc(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function oYc(b){b=b|0;i=i;return(a[b]|0)!=0|0}function pYc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=ie[b&127](a)|0;i=c;return d|0}function qYc(b,d){b=b|0;d=+d;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;m=j;a[m]=0;c[j+4>>2]=b;n=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(n+16)>>2]|0)!=0){nYc(j);i=e;return b|0}o=c[b+(n+72)>>2]|0;if((o|0)==0){p=n}else{_Xc(o)|0;p=c[(c[b>>2]|0)+ -12>>2]|0}a[m]=1;L0c(k,b+(p+28)|0);p=O0c(k,365080)|0;m=p;M0c(k);k=c[(c[b>>2]|0)+ -12>>2]|0;o=c[b+(k+24)>>2]|0;n=b+(k+76)|0;q=c[n>>2]|0;if((q|0)==-1){L0c(h,b+(k+28)|0);r=O0c(h,366360)|0;s=xe[c[(c[r>>2]|0)+28>>2]&63](r,32)|0;M0c(h);c[n>>2]=s<<24>>24;t=s}else{t=q&255}q=b+k|0;k=c[(c[p>>2]|0)+32>>2]|0;c[g>>2]=o;o=f;p=g;c[o+0>>2]=c[p+0>>2];oe[k&7](l,m,f,q,t,d);if((c[l>>2]|0)!=0){nYc(j);i=e;return b|0}l=c[(c[b>>2]|0)+ -12>>2]|0;RWc(b+l|0,c[b+(l+16)>>2]|5);nYc(j);i=e;return b|0}function rYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=f;a[g]=0;c[f+4>>2]=b;h=c[b>>2]|0;j=c[h+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){nYc(f);i=e;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)==0){l=h;m=j}else{_Xc(k)|0;k=c[b>>2]|0;l=k;m=c[k+ -12>>2]|0}a[g]=1;g=c[b+(m+24)>>2]|0;m=g;do{if((g|0)==0){n=l}else{k=g+24|0;j=c[k>>2]|0;if((j|0)!=(c[g+28>>2]|0)){c[k>>2]=j+1;a[j]=d;nYc(f);i=e;return b|0}if((xe[c[(c[g>>2]|0)+52>>2]&63](m,d&255)|0)==-1){n=c[b>>2]|0;break}else{nYc(f);i=e;return b|0}}}while(0);d=c[n+ -12>>2]|0;RWc(b+d|0,c[b+(d+16)>>2]|1);nYc(f);i=e;return b|0}function sYc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=g;a[h]=0;c[g+4>>2]=b;j=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(j+16)>>2]|0)!=0){nYc(g);i=f;return b|0}k=c[b+(j+72)>>2]|0;if((k|0)!=0){_Xc(k)|0}a[h]=1;if((e|0)==0){nYc(g);i=f;return b|0}h=c[b+((c[(c[b>>2]|0)+ -12>>2]|0)+24)>>2]|0;if((le[c[(c[h>>2]|0)+48>>2]&63](h,d,e)|0)==(e|0)){nYc(g);i=f;return b|0}e=c[(c[b>>2]|0)+ -12>>2]|0;RWc(b+e|0,c[b+(e+16)>>2]|1);nYc(g);i=f;return b|0}function tYc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(e+16)>>2]&5|0)==0){f=c[b+(e+24)>>2]|0;re[c[(c[f>>2]|0)+16>>2]&31](a,f,0,0,1,16);i=d;return}else{f=a;c[f>>2]=0;c[f+4>>2]=0;f=a+8|0;c[f>>2]=-1;c[f+4>>2]=-1;i=d;return}}function uYc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+56|0;f=e;g=e+16|0;h=e+32|0;j=e+40|0;k=h;a[k]=0;c[h+4>>2]=b;l=c[(c[b>>2]|0)+ -12>>2]|0;if((c[b+(l+16)>>2]|0)!=0){nYc(h);i=e;return b|0}m=c[b+(l+72)>>2]|0;if((m|0)==0){n=l}else{_Xc(m)|0;n=c[(c[b>>2]|0)+ -12>>2]|0}a[k]=1;k=c[b+(n+24)>>2]|0;n=k;m=d;d=g;l=c[(c[k>>2]|0)+20>>2]|0;c[d+0>>2]=c[m+0>>2];c[d+4>>2]=c[m+4>>2];c[d+8>>2]=c[m+8>>2];c[d+12>>2]=c[m+12>>2];m=f;d=g;c[m+0>>2]=c[d+0>>2];c[m+4>>2]=c[d+4>>2];c[m+8>>2]=c[d+8>>2];c[m+12>>2]=c[d+12>>2];Ie[l&63](j,n,f,16);f=j+8|0;if(!((c[f>>2]|0)==-1&(c[f+4>>2]|0)==-1)){nYc(h);i=e;return b|0}f=c[(c[b>>2]|0)+ -12>>2]|0;RWc(b+f|0,c[b+(f+16)>>2]|4);nYc(h);i=e;return b|0}function vYc(a){a=a|0;var b=0;b=i;TWc(a+4|0);p4c(a);i=b;return}function wYc(a){a=a|0;var b=0;b=i;TWc(a+4|0);i=b;return}function xYc(a){a=a|0;var b=0,d=0;b=i;d=c[(c[a>>2]|0)+ -12>>2]|0;TWc(a+(d+4)|0);p4c(a+d|0);i=b;return}function yYc(a){a=a|0;var b=0;b=i;TWc(a+((c[(c[a>>2]|0)+ -12>>2]|0)+4)|0);i=b;return}function zYc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+4|0;a=c[d>>2]|0;e=c[(c[a>>2]|0)+ -12>>2]|0;if((c[a+(e+24)>>2]|0)==0){i=b;return}if((c[a+(e+16)>>2]|0)!=0){i=b;return}if((c[a+(e+4)>>2]&8192|0)==0){i=b;return}if(db()|0){i=b;return}e=c[d>>2]|0;a=c[e+((c[(c[e>>2]|0)+ -12>>2]|0)+24)>>2]|0;if(!((ie[c[(c[a>>2]|0)+24>>2]&127](a)|0)==-1)){i=b;return}a=c[d>>2]|0;d=c[(c[a>>2]|0)+ -12>>2]|0;RWc(a+d|0,c[a+(d+16)>>2]|1);i=b;return}function AYc(a){a=a|0;i=i;return 363912}function BYc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;if((c|0)==1){WVc(a,363928,35);i=d;return}else{KVc(a,b,c);i=d;return}}function CYc(a){a=a|0;i=i;return}function DYc(a){a=a|0;var b=0;b=i;OVc(a);p4c(a);i=b;return}function EYc(a){a=a|0;var b=0;b=i;OVc(a);i=b;return}function FYc(a){a=a|0;var b=0;b=i;TWc(a);p4c(a);i=b;return}function GYc(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function HYc(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function IYc(a){a=a|0;i=i;return}function JYc(a){a=a|0;i=i;return}function KYc(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;a:do{if((e|0)==(f|0)){g=c;h=6}else{j=e;k=c;while(1){if((k|0)==(d|0)){l=-1;break a}m=a[k]|0;n=a[j]|0;if(m<<24>>24<n<<24>>24){l=-1;break a}if(n<<24>>24<m<<24>>24){l=1;break a}m=k+1|0;n=j+1|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=b;return l|0}function LYc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;g=e;h=f-g|0;if(h>>>0>4294967279){QVc(b)}if(h>>>0<11){a[b]=h<<1;j=b+1|0}else{k=h+16&-16;l=n4c(k)|0;c[b+8>>2]=l;c[b>>2]=k|1;c[b+4>>2]=h;j=l}if((e|0)==(f|0)){m=j;a[m]=0;i=d;return}else{n=e;o=j}while(1){a[o]=a[n]|0;e=n+1|0;if((e|0)==(f|0)){break}else{o=o+1|0;n=e}}m=j+(f+(0-g))|0;a[m]=0;i=d;return}function MYc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;if((c|0)==(d|0)){e=0;i=b;return e|0}else{f=0;g=c}while(1){c=(a[g]|0)+(f<<4)|0;h=c&-268435456;j=(h>>>24|h)^c;c=g+1|0;if((c|0)==(d|0)){e=j;break}else{g=c;f=j}}i=b;return e|0}function NYc(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function OYc(a){a=a|0;i=i;return}function PYc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;a=i;a:do{if((e|0)==(f|0)){g=b;h=6}else{j=e;k=b;while(1){if((k|0)==(d|0)){l=-1;break a}m=c[k>>2]|0;n=c[j>>2]|0;if((m|0)<(n|0)){l=-1;break a}if((n|0)<(m|0)){l=1;break a}m=k+4|0;n=j+4|0;if((n|0)==(f|0)){g=m;h=6;break}else{j=n;k=m}}}}while(0);if((h|0)==6){l=(g|0)!=(d|0)|0}i=a;return l|0}function QYc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;g=e;h=f-g|0;j=h>>2;if(j>>>0>1073741807){QVc(b)}if(j>>>0<2){a[b]=h>>>1;k=b+4|0}else{h=j+4&-4;l=n4c(h<<2)|0;c[b+8>>2]=l;c[b>>2]=h|1;c[b+4>>2]=j;k=l}if((e|0)==(f|0)){m=k;c[m>>2]=0;i=d;return}l=f+ -4+(0-g)|0;g=e;e=k;while(1){c[e>>2]=c[g>>2];j=g+4|0;if((j|0)==(f|0)){break}else{e=e+4|0;g=j}}m=k+((l>>>2)+1<<2)|0;c[m>>2]=0;i=d;return}function RYc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;a=i;if((b|0)==(d|0)){e=0;i=a;return e|0}else{f=0;g=b}while(1){b=(c[g>>2]|0)+(f<<4)|0;h=b&-268435456;j=(h>>>24|h)^b;b=g+4|0;if((b|0)==(d|0)){e=j;break}else{g=b;f=j}}i=a;return e|0}function SYc(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function TYc(a){a=a|0;i=i;return}function UYc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}_Wc(u,g);m=u;u=c[m>>2]|0;if(!((c[91590]|0)==-1)){c[p>>2]=366360;c[p+4>>2]=769;c[p+8>>2]=0;PVc(366360,p,770)}p=(c[366364>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}F=u;uVc(c[m>>2]|0)|0;_Wc(v,g);g=v;v=c[g>>2]|0;if(!((c[91626]|0)==-1)){c[o>>2]=366504;c[o+4>>2]=769;c[o+8>>2]=0;PVc(366504,o,770)}o=(c[366508>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}J=v;uVc(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&255](g,J);ge[c[(c[v>>2]|0)+28>>2]&255](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=VYc(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];cWc(w+12|0);cWc(w);i=k;return}function VYc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=h4c(l)|0;if((n|0)!=0){o=n;p=n;break}u4c()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=0}else{if((c[r+12>>2]|0)!=(c[r+16>>2]|0)){y=r;break}if((ie[c[(c[r>>2]|0)+36>>2]&127](r)|0)==-1){c[l>>2]=0;y=0;break}else{y=c[l>>2]|0;break}}}while(0);r=(y|0)==0;t=c[b>>2]|0;do{if((t|0)==0){z=0}else{if((c[t+12>>2]|0)!=(c[t+16>>2]|0)){z=t;break}if(!((ie[c[(c[t>>2]|0)+36>>2]&127](t)|0)==-1)){z=t;break}c[b>>2]=0;z=0}}while(0);A=(z|0)==0;B=c[l>>2]|0;if(!((r^A)&(q|0)!=0)){break}t=c[B+12>>2]|0;if((t|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[t]|0}if(j){D=C}else{D=xe[c[(c[g>>2]|0)+12>>2]&63](g,C)|0}t=d+1|0;if(m){d=t;q=q;x=x;continue}b:do{if(j){w=0;s=e;n=x;v=q;u=p;while(1){do{if((a[u]|0)==1){E=a[s]|0;F=(E&1)==0;if(F){G=s+1|0}else{G=c[s+8>>2]|0}if(!(D<<24>>24==(a[G+d|0]|0))){a[u]=0;H=w;I=n;J=v+ -1|0;break}if(F){K=(E&255)>>>1}else{K=c[s+4>>2]|0}if((K|0)!=(t|0)){H=1;I=n;J=v;break}a[u]=2;H=1;I=n+1|0;J=v+ -1|0}else{H=w;I=n;J=v}}while(0);E=s+12|0;if((E|0)==(f|0)){L=H;M=I;N=J;break b}w=H;s=E;n=I;v=J;u=u+1|0}}else{u=0;v=e;n=x;s=q;w=p;while(1){do{if((a[w]|0)==1){if((a[v]&1)==0){O=v+1|0}else{O=c[v+8>>2]|0}if(!(D<<24>>24==(xe[c[(c[g>>2]|0)+12>>2]&63](g,a[O+d|0]|0)|0)<<24>>24)){a[w]=0;P=u;Q=n;R=s+ -1|0;break}E=a[v]|0;if((E&1)==0){S=(E&255)>>>1}else{S=c[v+4>>2]|0}if((S|0)!=(t|0)){P=1;Q=n;R=s;break}a[w]=2;P=1;Q=n+1|0;R=s+ -1|0}else{P=u;Q=n;R=s}}while(0);E=v+12|0;if((E|0)==(f|0)){L=P;M=Q;N=R;break b}u=P;v=E;n=Q;s=R;w=w+1|0}}}while(0);if(!L){d=t;x=M;q=N;continue}r=c[l>>2]|0;w=r+12|0;s=c[w>>2]|0;if((s|0)==(c[r+16>>2]|0)){ie[c[(c[r>>2]|0)+40>>2]&127](r)|0}else{c[w>>2]=s+1}if((N+M|0)>>>0<2){d=t;x=M;q=N;continue}else{T=e;U=M;V=p}while(1){do{if((a[V]|0)==2){s=a[T]|0;if((s&1)==0){W=(s&255)>>>1}else{W=c[T+4>>2]|0}if((W|0)==(t|0)){X=U;break}a[V]=0;X=U+ -1|0}else{X=U}}while(0);s=T+12|0;if((s|0)==(f|0)){d=t;x=X;q=N;continue a}else{T=s;U=X;V=V+1|0}}}do{if((B|0)==0){Y=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){Y=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[l>>2]=0;Y=0;break}else{Y=c[l>>2]|0;break}}}while(0);l=(Y|0)==0;do{if(A){Z=78}else{if((c[z+12>>2]|0)!=(c[z+16>>2]|0)){if(l){break}else{Z=80;break}}if((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1){c[b>>2]=0;Z=78;break}else{if(l){break}else{Z=80;break}}}}while(0);if((Z|0)==78){if(l){Z=80}}if((Z|0)==80){c[h>>2]=c[h>>2]|2}c:do{if(m){Z=85}else{if((a[p]|0)==2){_=e;break}else{$=e;aa=p}while(1){l=$+12|0;b=aa+1|0;if((l|0)==(f|0)){Z=85;break c}if((a[b]|0)==2){_=l;break}else{aa=b;$=l}}}}while(0);if((Z|0)==85){c[h>>2]=c[h>>2]|4;_=f}if((o|0)==0){i=k;return _|0}i4c(o);i=k;return _|0}function WYc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];XYc(a,0,k,j,f,g,h);i=b;return}function XYc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;NZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}lWc(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}lWc(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((nZc(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=J2c(F,c[o>>2]|0,h,t)|0;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}function YYc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];ZYc(a,0,k,j,f,g,h);i=b;return}function ZYc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;NZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}lWc(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}lWc(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((nZc(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=I2c(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}function _Yc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];$Yc(a,0,k,j,f,g,h);i=b;return}function $Yc(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+256|0;l=e;m=e+32|0;n=e+40|0;o=e+56|0;p=e+72|0;q=e+80|0;r=e+240|0;s=e+248|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==8){u=16}else if((t|0)==0){u=0}else{u=10}t=l;NZc(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=a[m]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){B=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){B=m;break}c[l>>2]=0;B=0}}while(0);x=(B|0)==0;C=c[f>>2]|0;do{if((C|0)==0){D=18}else{if((c[C+12>>2]|0)!=(c[C+16>>2]|0)){if(x){E=C;break}else{F=C;G=A;break a}}if((ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)==-1){c[f>>2]=0;D=18;break}else{if(x){E=C;break}else{F=C;G=A;break a}}}}while(0);if((D|0)==18){D=0;if(x){F=0;G=A;break}else{E=0}}C=a[o]|0;H=(C&1)==0;if(H){I=(C&255)>>>1}else{I=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(I|0)){if(H){J=(C&255)>>>1;K=(C&255)>>>1}else{C=c[y>>2]|0;J=C;K=C}lWc(o,K<<1,0);if((a[o]&1)==0){L=10}else{L=(c[g>>2]&-2)+ -1|0}lWc(o,L,0);if((a[o]&1)==0){M=v}else{M=c[w>>2]|0}c[p>>2]=M+J;N=M}else{N=A}C=B+12|0;H=c[C>>2]|0;O=B+16|0;if((H|0)==(c[O>>2]|0)){P=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{P=a[H]|0}if((nZc(P,u,N,p,s,z,n,h,r,t)|0)!=0){F=E;G=N;break}H=c[C>>2]|0;if((H|0)==(c[O>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=N;continue}else{c[C>>2]=H+1;m=B;A=N;continue}}N=a[n]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[n+4>>2]|0}do{if((Q|0)!=0){N=c[r>>2]|0;if((N-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=N+4;c[N>>2]=A}}while(0);b[k>>1]=H2c(G,c[p>>2]|0,j,u)|0;_$c(n,h,c[r>>2]|0,j);do{if((B|0)==0){R=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){R=B;break}if(!((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1)){R=B;break}c[l>>2]=0;R=0}}while(0);l=(R|0)==0;do{if((F|0)==0){D=54}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){if(!l){break}S=d;T=S;c[T>>2]=R;cWc(o);cWc(n);i=e;return}if((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1){c[f>>2]=0;D=54;break}if(!(l^(F|0)==0)){break}S=d;T=S;c[T>>2]=R;cWc(o);cWc(n);i=e;return}}while(0);do{if((D|0)==54){if(l){break}S=d;T=S;c[T>>2]=R;cWc(o);cWc(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;S=d;T=S;c[T>>2]=R;cWc(o);cWc(n);i=e;return}function aZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];bZc(a,0,k,j,f,g,h);i=b;return}function bZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==0){t=0}else if((s|0)==8){t=16}else{t=10}s=k;NZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}lWc(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}lWc(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((nZc(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=G2c(F,c[o>>2]|0,h,t)|0;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}function cZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];dZc(a,0,k,j,f,g,h);i=b;return}function dZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;NZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;J=(B&255)>>>1}else{B=c[x>>2]|0;I=B;J=B}lWc(n,J<<1,0);if((a[n]&1)==0){K=10}else{K=(c[f>>2]&-2)+ -1|0}lWc(n,K,0);if((a[n]&1)==0){L=u}else{L=c[v>>2]|0}c[o>>2]=L+I;M=L}else{M=z}B=A+12|0;G=c[B>>2]|0;N=A+16|0;if((G|0)==(c[N>>2]|0)){O=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{O=a[G]|0}if((nZc(O,t,M,o,r,y,m,g,q,s)|0)!=0){E=D;F=M;break}G=c[B>>2]|0;if((G|0)==(c[N>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=M;continue}else{c[B>>2]=G+1;l=A;z=M;continue}}M=a[m]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[m+4>>2]|0}do{if((P|0)!=0){M=c[q>>2]|0;if((M-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=M+4;c[M>>2]=z}}while(0);c[j>>2]=F2c(F,c[o>>2]|0,h,t)|0;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){Q=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){Q=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){Q=A;break}c[k>>2]=0;Q=0}}while(0);k=(Q|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;R=b;S=R;c[S>>2]=Q;cWc(n);cWc(m);i=d;return}function eZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];fZc(a,0,k,j,f,g,h);i=b;return}function fZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;d=i;i=i+256|0;k=d;l=d+32|0;m=d+40|0;n=d+56|0;o=d+72|0;p=d+80|0;q=d+240|0;r=d+248|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;NZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=a[l]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){A=l;break}if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){A=l;break}c[k>>2]=0;A=0}}while(0);w=(A|0)==0;B=c[e>>2]|0;do{if((B|0)==0){C=18}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){if(w){D=B;break}else{E=B;F=z;break a}}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[e>>2]=0;C=18;break}else{if(w){D=B;break}else{E=B;F=z;break a}}}}while(0);if((C|0)==18){C=0;if(w){E=0;F=z;break}else{D=0}}B=a[n]|0;G=(B&1)==0;if(G){H=(B&255)>>>1}else{H=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(H|0)){if(G){I=(B&255)>>>1;K=(B&255)>>>1}else{B=c[x>>2]|0;I=B;K=B}lWc(n,K<<1,0);if((a[n]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}lWc(n,L,0);if((a[n]&1)==0){M=u}else{M=c[v>>2]|0}c[o>>2]=M+I;N=M}else{N=z}B=A+12|0;G=c[B>>2]|0;O=A+16|0;if((G|0)==(c[O>>2]|0)){P=(ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)&255}else{P=a[G]|0}if((nZc(P,t,N,o,r,y,m,g,q,s)|0)!=0){E=D;F=N;break}G=c[B>>2]|0;if((G|0)==(c[O>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=N;continue}else{c[B>>2]=G+1;l=A;z=N;continue}}N=a[m]|0;if((N&1)==0){Q=(N&255)>>>1}else{Q=c[m+4>>2]|0}do{if((Q|0)!=0){N=c[q>>2]|0;if((N-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=N+4;c[N>>2]=z}}while(0);r=E2c(F,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){R=0}else{if((c[A+12>>2]|0)!=(c[A+16>>2]|0)){R=A;break}if(!((ie[c[(c[A>>2]|0)+36>>2]&127](A)|0)==-1)){R=A;break}c[k>>2]=0;R=0}}while(0);k=(R|0)==0;do{if((E|0)==0){C=54}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(!k){break}S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;C=54;break}if(!(k^(E|0)==0)){break}S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}}while(0);do{if((C|0)==54){if(k){break}S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;S=b;T=S;c[T>>2]=R;cWc(n);cWc(m);i=d;return}function gZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];hZc(a,0,k,j,f,g,h);i=b;return}function hZc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;OZc(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}lWc(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}lWc(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((PZc(R,t,u,P,p,B,l,n,h,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);g[k>>2]=+D2c(I,c[p>>2]|0,j);_$c(n,h,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}function iZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];jZc(a,0,k,j,f,g,h);i=b;return}function jZc(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;OZc(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}lWc(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}lWc(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((PZc(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+C2c(I,c[p>>2]|0,j);_$c(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}function kZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];lZc(a,0,k,j,f,g,h);i=b;return}function lZc(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0;d=i;i=i+280|0;l=d+32|0;m=d+40|0;n=d+48|0;o=d+64|0;p=d+80|0;q=d+88|0;r=d+248|0;s=d+256|0;t=d+264|0;u=d+272|0;v=d;OZc(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=a[l]|0;l=a[m]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){D=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){D=m;break}c[z>>2]=0;D=0}}while(0);y=(D|0)==0;E=c[e>>2]|0;do{if((E|0)==0){F=14}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(y){G=E;break}else{H=E;I=C;break a}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[e>>2]=0;F=14;break}else{if(y){G=E;break}else{H=E;I=C;break a}}}}while(0);if((F|0)==14){F=0;if(y){H=0;I=C;break}else{G=0}}E=a[o]|0;J=(E&1)==0;if(J){K=(E&255)>>>1}else{K=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(K|0)){if(J){L=(E&255)>>>1;M=(E&255)>>>1}else{E=c[A>>2]|0;L=E;M=E}lWc(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}lWc(o,N,0);if((a[o]&1)==0){O=w}else{O=c[x>>2]|0}c[p>>2]=O+L;P=O}else{P=C}E=D+12|0;J=c[E>>2]|0;Q=D+16|0;if((J|0)==(c[Q>>2]|0)){R=(ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)&255}else{R=a[J]|0}if((PZc(R,t,u,P,p,B,l,n,g,r,s,v)|0)!=0){H=G;I=P;break}J=c[E>>2]|0;if((J|0)==(c[Q>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=P;continue}else{c[E>>2]=J+1;m=D;C=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){if((a[t]|0)==0){break}P=c[r>>2]|0;if((P-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=C}}while(0);h[k>>3]=+B2c(I,c[p>>2]|0,j);_$c(n,g,c[r>>2]|0,j);do{if((D|0)==0){T=0}else{if((c[D+12>>2]|0)!=(c[D+16>>2]|0)){T=D;break}if(!((ie[c[(c[D>>2]|0)+36>>2]&127](D)|0)==-1)){T=D;break}c[z>>2]=0;T=0}}while(0);z=(T|0)==0;do{if((H|0)==0){F=51}else{if((c[H+12>>2]|0)!=(c[H+16>>2]|0)){if(!z){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}if((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1){c[e>>2]=0;F=51;break}if(!(z^(H|0)==0)){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}}while(0);do{if((F|0)==51){if(z){break}U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;U=b;V=U;c[V>>2]=T;cWc(o);cWc(n);i=d;return}function mZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;_Wc(o,g);g=o;o=c[g>>2]|0;if(!((c[91590]|0)==-1)){c[l>>2]=366360;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366360,l,770)}l=(c[366364>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+32>>2]&63](o,364904,364930|0,y)|0;uVc(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0}else{if((c[m+12>>2]|0)!=(c[m+16>>2]|0)){C=m;break}if(!((ie[c[(c[m>>2]|0)+36>>2]&127](m)|0)==-1)){C=m;break}c[r>>2]=0;C=0}}while(0);B=(C|0)==0;v=c[e>>2]|0;do{if((v|0)==0){D=19}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){if(B){break}else{E=x;break a}}if((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1){c[e>>2]=0;D=19;break}else{if(B){break}else{E=x;break a}}}}while(0);if((D|0)==19){D=0;if(B){E=x;break}}v=a[p]|0;w=(v&1)==0;if(w){F=(v&255)>>>1}else{F=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(F|0)){if(w){G=(v&255)>>>1;H=(v&255)>>>1}else{v=c[o>>2]|0;G=v;H=v}lWc(p,H<<1,0);if((a[p]&1)==0){I=10}else{I=(c[f>>2]&-2)+ -1|0}lWc(p,I,0);if((a[p]&1)==0){J=z}else{J=c[A>>2]|0}c[q>>2]=J+G;K=J}else{K=x}v=C+12|0;w=c[v>>2]|0;l=C+16|0;if((w|0)==(c[l>>2]|0)){L=(ie[c[(c[C>>2]|0)+36>>2]&127](C)|0)&255}else{L=a[w]|0}if((nZc(L,16,K,q,t,0,n,g,s,y)|0)!=0){E=K;break}w=c[v>>2]|0;if((w|0)==(c[l>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=K;continue}else{c[v>>2]=w+1;m=C;x=K;continue}}a[E+3|0]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);K=c[91562]|0;c[k>>2]=j;if((oZc(E,K,364944,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){M=0}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){M=k;break}if(!((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1)){M=k;break}c[r>>2]=0;M=0}}while(0);r=(M|0)==0;k=c[e>>2]|0;do{if((k|0)==0){D=54}else{if((c[k+12>>2]|0)!=(c[k+16>>2]|0)){if(!r){break}N=b;O=N;c[O>>2]=M;cWc(p);cWc(n);i=d;return}if((ie[c[(c[k>>2]|0)+36>>2]&127](k)|0)==-1){c[e>>2]=0;D=54;break}if(!(r^(k|0)==0)){break}N=b;O=N;c[O>>2]=M;cWc(p);cWc(n);i=d;return}}while(0);do{if((D|0)==54){if(r){break}N=b;O=N;c[O>>2]=M;cWc(p);cWc(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;N=b;O=N;c[O>>2]=M;cWc(p);cWc(n);i=d;return}function nZc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(a[m+24|0]|0)==b<<24>>24;if(!q){if(!((a[m+25|0]|0)==b<<24>>24)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&b<<24>>24==h<<24>>24){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+26|0;h=m;while(1){l=h+1|0;if((a[h]|0)==b<<24>>24){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;if((h|0)>23){r=-1;i=n;return r|0}do{if((d|0)==10|(d|0)==8){if((h|0)<(d|0)){break}else{r=-1}i=n;return r|0}else if((d|0)==16){if((h|0)<22){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;m=a[364904+h|0]|0;c[f>>2]=o+1;a[o]=m;r=0;i=n;return r|0}}while(0);e=a[364904+h|0]|0;c[f>>2]=o+1;a[o]=e;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function oZc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=Xa(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function pZc(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function qZc(a){a=a|0;i=i;return}function rZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;k=i;i=i+136|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=k+40|0;q=k+56|0;r=k+64|0;s=k+72|0;t=k+80|0;u=k+88|0;v=k+96|0;w=k+104|0;x=k+128|0;if((c[g+4>>2]&1|0)==0){c[q>>2]=-1;y=c[(c[d>>2]|0)+16>>2]|0;z=e;c[s>>2]=c[z>>2];c[t>>2]=c[f>>2];A=n;B=s;c[A+0>>2]=c[B+0>>2];B=m;A=t;c[B+0>>2]=c[A+0>>2];ue[y&63](r,d,n,m,g,h,q);m=c[r>>2]|0;c[z>>2]=m;z=c[q>>2]|0;if((z|0)==0){a[j]=0}else if((z|0)==1){a[j]=1}else{a[j]=1;c[h>>2]=4}c[b>>2]=m;i=k;return}_Wc(u,g);m=u;u=c[m>>2]|0;if(!((c[91588]|0)==-1)){c[p>>2]=366352;c[p+4>>2]=769;c[p+8>>2]=0;PVc(366352,p,770)}p=(c[366356>>2]|0)+ -1|0;z=c[u+8>>2]|0;if(!((c[u+12>>2]|0)-z>>2>>>0>p>>>0)){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}u=c[z+(p<<2)>>2]|0;if((u|0)==0){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}F=u;uVc(c[m>>2]|0)|0;_Wc(v,g);g=v;v=c[g>>2]|0;if(!((c[91628]|0)==-1)){c[o>>2]=366512;c[o+4>>2]=769;c[o+8>>2]=0;PVc(366512,o,770)}o=(c[366516>>2]|0)+ -1|0;m=c[v+8>>2]|0;if(!((c[v+12>>2]|0)-m>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}v=c[m+(o<<2)>>2]|0;if((v|0)==0){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}J=v;uVc(c[g>>2]|0)|0;g=w;ge[c[(c[v>>2]|0)+24>>2]&255](g,J);ge[c[(c[v>>2]|0)+28>>2]&255](w+12|0,J);c[x>>2]=c[f>>2];f=w+24|0;J=l;v=x;c[J+0>>2]=c[v+0>>2];v=sZc(e,l,g,f,F,h,1)|0;a[j]=(v|0)==(g|0)|0;c[b>>2]=c[e>>2];GWc(w+12|0);GWc(w);i=k;return}function sZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;k=i;i=i+104|0;l=(f-e|0)/12|0;m=k;do{if(l>>>0>100){n=h4c(l)|0;if((n|0)!=0){o=n;p=n;break}u4c()}else{o=0;p=m}}while(0);m=(e|0)==(f|0);if(m){q=0;r=l}else{n=e;s=0;t=l;l=p;while(1){u=a[n]|0;if((u&1)==0){v=(u&255)>>>1}else{v=c[n+4>>2]|0}if((v|0)==0){a[l]=2;w=s+1|0;x=t+ -1|0}else{a[l]=1;w=s;x=t}u=n+12|0;if((u|0)==(f|0)){q=w;r=x;break}else{n=u;s=w;t=x;l=l+1|0}}}l=b;b=d;d=0;x=q;q=r;a:while(1){r=c[l>>2]|0;do{if((r|0)==0){y=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){z=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{z=c[t>>2]|0}if((z|0)==-1){c[l>>2]=0;y=1;break}else{y=(c[l>>2]|0)==0;break}}}while(0);r=c[b>>2]|0;do{if((r|0)==0){A=0;B=1}else{t=c[r+12>>2]|0;if((t|0)==(c[r+16>>2]|0)){C=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{C=c[t>>2]|0}if(!((C|0)==-1)){A=r;B=0;break}c[b>>2]=0;A=0;B=1}}while(0);D=c[l>>2]|0;if(!((y^B)&(q|0)!=0)){break}r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){E=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{E=c[r>>2]|0}if(j){F=E}else{F=xe[c[(c[g>>2]|0)+28>>2]&63](g,E)|0}r=d+1|0;if(m){d=r;q=q;x=x;continue}b:do{if(j){t=0;w=e;s=x;n=q;v=p;while(1){do{if((a[v]|0)==1){u=a[w]|0;G=(u&1)==0;if(G){H=w+4|0}else{H=c[w+8>>2]|0}if((F|0)!=(c[H+(d<<2)>>2]|0)){a[v]=0;I=t;J=s;K=n+ -1|0;break}if(G){L=(u&255)>>>1}else{L=c[w+4>>2]|0}if((L|0)!=(r|0)){I=1;J=s;K=n;break}a[v]=2;I=1;J=s+1|0;K=n+ -1|0}else{I=t;J=s;K=n}}while(0);u=w+12|0;if((u|0)==(f|0)){M=I;N=J;O=K;break b}t=I;w=u;s=J;n=K;v=v+1|0}}else{v=0;n=e;s=x;w=q;t=p;while(1){do{if((a[t]|0)==1){if((a[n]&1)==0){P=n+4|0}else{P=c[n+8>>2]|0}if((F|0)!=(xe[c[(c[g>>2]|0)+28>>2]&63](g,c[P+(d<<2)>>2]|0)|0)){a[t]=0;Q=v;R=s;S=w+ -1|0;break}u=a[n]|0;if((u&1)==0){T=(u&255)>>>1}else{T=c[n+4>>2]|0}if((T|0)!=(r|0)){Q=1;R=s;S=w;break}a[t]=2;Q=1;R=s+1|0;S=w+ -1|0}else{Q=v;R=s;S=w}}while(0);u=n+12|0;if((u|0)==(f|0)){M=Q;N=R;O=S;break b}v=Q;n=u;s=R;w=S;t=t+1|0}}}while(0);if(!M){d=r;x=N;q=O;continue}t=c[l>>2]|0;w=t+12|0;s=c[w>>2]|0;if((s|0)==(c[t+16>>2]|0)){ie[c[(c[t>>2]|0)+40>>2]&127](t)|0}else{c[w>>2]=s+4}if((O+N|0)>>>0<2){d=r;x=N;q=O;continue}else{U=e;V=N;W=p}while(1){do{if((a[W]|0)==2){s=a[U]|0;if((s&1)==0){X=(s&255)>>>1}else{X=c[U+4>>2]|0}if((X|0)==(r|0)){Y=V;break}a[W]=0;Y=V+ -1|0}else{Y=V}}while(0);s=U+12|0;if((s|0)==(f|0)){d=r;x=Y;q=O;continue a}else{U=s;V=Y;W=W+1|0}}}do{if((D|0)==0){Z=1}else{W=c[D+12>>2]|0;if((W|0)==(c[D+16>>2]|0)){_=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{_=c[W>>2]|0}if((_|0)==-1){c[l>>2]=0;Z=1;break}else{Z=(c[l>>2]|0)==0;break}}}while(0);do{if((A|0)==0){$=85}else{l=c[A+12>>2]|0;if((l|0)==(c[A+16>>2]|0)){aa=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{aa=c[l>>2]|0}if((aa|0)==-1){c[b>>2]=0;$=85;break}else{if(Z){break}else{$=87;break}}}}while(0);if(($|0)==85){if(Z){$=87}}if(($|0)==87){c[h>>2]=c[h>>2]|2}c:do{if(m){$=92}else{if((a[p]|0)==2){ba=e;break}else{ca=e;da=p}while(1){Z=ca+12|0;b=da+1|0;if((Z|0)==(f|0)){$=92;break c}if((a[b]|0)==2){ba=Z;break}else{da=b;ca=Z}}}}while(0);if(($|0)==92){c[h>>2]=c[h>>2]|4;ba=f}if((o|0)==0){i=k;return ba|0}i4c(o);i=k;return ba|0}function tZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];uZc(a,0,k,j,f,g,h);i=b;return}function uZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==0){t=0}else if((s|0)==64){t=8}else{t=10}s=k;QZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}lWc(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}lWc(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((MZc(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=J2c(I,c[o>>2]|0,h,t)|0;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}function vZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];wZc(a,0,k,j,f,g,h);i=b;return}function wZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==64){t=8}else if((s|0)==8){t=16}else if((s|0)==0){t=0}else{t=10}s=k;QZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}lWc(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}lWc(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((MZc(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=I2c(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;cWc(n);cWc(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;cWc(n);cWc(m);i=d;return}function xZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];yZc(a,0,k,j,f,g,h);i=b;return}function yZc(d,e,f,g,h,j,k){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+328|0;l=e;m=e+104|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+152|0;r=e+312|0;s=e+320|0;t=c[h+4>>2]&74;if((t|0)==64){u=8}else if((t|0)==0){u=0}else if((t|0)==8){u=16}else{u=10}t=l;QZc(n,h,t,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){h=o+1|0;v=h;w=o+8|0;x=h}else{h=o+8|0;v=o+1|0;w=h;x=c[h>>2]|0}c[p>>2]=x;h=q;c[r>>2]=h;c[s>>2]=0;l=f;f=g;g=o;y=o+4|0;z=c[m>>2]|0;m=c[l>>2]|0;A=x;a:while(1){do{if((m|0)==0){B=0;C=1}else{x=c[m+12>>2]|0;if((x|0)==(c[m+16>>2]|0)){D=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{D=c[x>>2]|0}if(!((D|0)==-1)){B=m;C=0;break}c[l>>2]=0;B=0;C=1}}while(0);x=c[f>>2]|0;do{if((x|0)==0){E=21}else{F=c[x+12>>2]|0;if((F|0)==(c[x+16>>2]|0)){G=ie[c[(c[x>>2]|0)+36>>2]&127](x)|0}else{G=c[F>>2]|0}if((G|0)==-1){c[f>>2]=0;E=21;break}else{if(C){H=x;break}else{I=x;J=A;break a}}}}while(0);if((E|0)==21){E=0;if(C){I=0;J=A;break}else{H=0}}x=a[o]|0;F=(x&1)==0;if(F){K=(x&255)>>>1}else{K=c[y>>2]|0}if(((c[p>>2]|0)-A|0)==(K|0)){if(F){L=(x&255)>>>1;M=(x&255)>>>1}else{x=c[y>>2]|0;L=x;M=x}lWc(o,M<<1,0);if((a[o]&1)==0){N=10}else{N=(c[g>>2]&-2)+ -1|0}lWc(o,N,0);if((a[o]&1)==0){O=v}else{O=c[w>>2]|0}c[p>>2]=O+L;P=O}else{P=A}x=B+12|0;F=c[x>>2]|0;Q=B+16|0;if((F|0)==(c[Q>>2]|0)){R=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{R=c[F>>2]|0}if((MZc(R,u,P,p,s,z,n,h,r,t)|0)!=0){I=H;J=P;break}F=c[x>>2]|0;if((F|0)==(c[Q>>2]|0)){ie[c[(c[B>>2]|0)+40>>2]&127](B)|0;m=B;A=P;continue}else{c[x>>2]=F+4;m=B;A=P;continue}}P=a[n]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[n+4>>2]|0}do{if((S|0)!=0){P=c[r>>2]|0;if((P-q|0)>=160){break}A=c[s>>2]|0;c[r>>2]=P+4;c[P>>2]=A}}while(0);b[k>>1]=H2c(J,c[p>>2]|0,j,u)|0;_$c(n,h,c[r>>2]|0,j);do{if((B|0)==0){T=0;U=1}else{r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){V=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{V=c[r>>2]|0}if(!((V|0)==-1)){T=B;U=0;break}c[l>>2]=0;T=0;U=1}}while(0);do{if((I|0)==0){E=60}else{l=c[I+12>>2]|0;if((l|0)==(c[I+16>>2]|0)){W=ie[c[(c[I>>2]|0)+36>>2]&127](I)|0}else{W=c[l>>2]|0}if((W|0)==-1){c[f>>2]=0;E=60;break}if(!U){break}X=d;Y=X;c[Y>>2]=T;cWc(o);cWc(n);i=e;return}}while(0);do{if((E|0)==60){if(U){break}X=d;Y=X;c[Y>>2]=T;cWc(o);cWc(n);i=e;return}}while(0);c[j>>2]=c[j>>2]|2;X=d;Y=X;c[Y>>2]=T;cWc(o);cWc(n);i=e;return}function zZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];AZc(a,0,k,j,f,g,h);i=b;return}function AZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==64){t=8}else if((s|0)==8){t=16}else{t=10}s=k;QZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}lWc(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}lWc(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((MZc(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=G2c(I,c[o>>2]|0,h,t)|0;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}function BZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];CZc(a,0,k,j,f,g,h);i=b;return}function CZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==0){t=0}else if((s|0)==8){t=16}else if((s|0)==64){t=8}else{t=10}s=k;QZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){J=(w&255)>>>1}else{J=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(J|0)){if(E){K=(w&255)>>>1;L=(w&255)>>>1}else{w=c[x>>2]|0;K=w;L=w}lWc(n,L<<1,0);if((a[n]&1)==0){M=10}else{M=(c[f>>2]&-2)+ -1|0}lWc(n,M,0);if((a[n]&1)==0){N=u}else{N=c[v>>2]|0}c[o>>2]=N+K;O=N}else{O=z}w=A+12|0;E=c[w>>2]|0;P=A+16|0;if((E|0)==(c[P>>2]|0)){Q=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{Q=c[E>>2]|0}if((MZc(Q,t,O,o,r,y,m,g,q,s)|0)!=0){H=G;I=O;break}E=c[w>>2]|0;if((E|0)==(c[P>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=O;continue}else{c[w>>2]=E+4;l=A;z=O;continue}}O=a[m]|0;if((O&1)==0){R=(O&255)>>>1}else{R=c[m+4>>2]|0}do{if((R|0)!=0){O=c[q>>2]|0;if((O-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=O+4;c[O>>2]=z}}while(0);c[j>>2]=F2c(I,c[o>>2]|0,h,t)|0;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){S=0;T=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){U=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{U=c[q>>2]|0}if(!((U|0)==-1)){S=A;T=0;break}c[k>>2]=0;S=0;T=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){V=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{V=c[k>>2]|0}if((V|0)==-1){c[e>>2]=0;D=60;break}if(!T){break}W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}}while(0);do{if((D|0)==60){if(T){break}W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;W=b;X=W;c[X>>2]=S;cWc(n);cWc(m);i=d;return}function DZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];EZc(a,0,k,j,f,g,h);i=b;return}function EZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+328|0;k=d;l=d+104|0;m=d+112|0;n=d+128|0;o=d+144|0;p=d+152|0;q=d+312|0;r=d+320|0;s=c[g+4>>2]&74;if((s|0)==8){t=16}else if((s|0)==64){t=8}else if((s|0)==0){t=0}else{t=10}s=k;QZc(m,g,s,l);g=n;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(n,10,0);if((a[n]&1)==0){g=n+1|0;u=g;v=n+8|0;w=g}else{g=n+8|0;u=n+1|0;v=g;w=c[g>>2]|0}c[o>>2]=w;g=p;c[q>>2]=g;c[r>>2]=0;k=e;e=f;f=n;x=n+4|0;y=c[l>>2]|0;l=c[k>>2]|0;z=w;a:while(1){do{if((l|0)==0){A=0;B=1}else{w=c[l+12>>2]|0;if((w|0)==(c[l+16>>2]|0)){C=ie[c[(c[l>>2]|0)+36>>2]&127](l)|0}else{C=c[w>>2]|0}if(!((C|0)==-1)){A=l;B=0;break}c[k>>2]=0;A=0;B=1}}while(0);w=c[e>>2]|0;do{if((w|0)==0){D=21}else{E=c[w+12>>2]|0;if((E|0)==(c[w+16>>2]|0)){F=ie[c[(c[w>>2]|0)+36>>2]&127](w)|0}else{F=c[E>>2]|0}if((F|0)==-1){c[e>>2]=0;D=21;break}else{if(B){G=w;break}else{H=w;I=z;break a}}}}while(0);if((D|0)==21){D=0;if(B){H=0;I=z;break}else{G=0}}w=a[n]|0;E=(w&1)==0;if(E){K=(w&255)>>>1}else{K=c[x>>2]|0}if(((c[o>>2]|0)-z|0)==(K|0)){if(E){L=(w&255)>>>1;M=(w&255)>>>1}else{w=c[x>>2]|0;L=w;M=w}lWc(n,M<<1,0);if((a[n]&1)==0){N=10}else{N=(c[f>>2]&-2)+ -1|0}lWc(n,N,0);if((a[n]&1)==0){O=u}else{O=c[v>>2]|0}c[o>>2]=O+L;P=O}else{P=z}w=A+12|0;E=c[w>>2]|0;Q=A+16|0;if((E|0)==(c[Q>>2]|0)){R=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{R=c[E>>2]|0}if((MZc(R,t,P,o,r,y,m,g,q,s)|0)!=0){H=G;I=P;break}E=c[w>>2]|0;if((E|0)==(c[Q>>2]|0)){ie[c[(c[A>>2]|0)+40>>2]&127](A)|0;l=A;z=P;continue}else{c[w>>2]=E+4;l=A;z=P;continue}}P=a[m]|0;if((P&1)==0){S=(P&255)>>>1}else{S=c[m+4>>2]|0}do{if((S|0)!=0){P=c[q>>2]|0;if((P-p|0)>=160){break}z=c[r>>2]|0;c[q>>2]=P+4;c[P>>2]=z}}while(0);r=E2c(I,c[o>>2]|0,h,t)|0;t=j;c[t>>2]=r;c[t+4>>2]=J;_$c(m,g,c[q>>2]|0,h);do{if((A|0)==0){T=0;U=1}else{q=c[A+12>>2]|0;if((q|0)==(c[A+16>>2]|0)){V=ie[c[(c[A>>2]|0)+36>>2]&127](A)|0}else{V=c[q>>2]|0}if(!((V|0)==-1)){T=A;U=0;break}c[k>>2]=0;T=0;U=1}}while(0);do{if((H|0)==0){D=60}else{k=c[H+12>>2]|0;if((k|0)==(c[H+16>>2]|0)){W=ie[c[(c[H>>2]|0)+36>>2]&127](H)|0}else{W=c[k>>2]|0}if((W|0)==-1){c[e>>2]=0;D=60;break}if(!U){break}X=b;Y=X;c[Y>>2]=T;cWc(n);cWc(m);i=d;return}}while(0);do{if((D|0)==60){if(U){break}X=b;Y=X;c[Y>>2]=T;cWc(n);cWc(m);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;X=b;Y=X;c[Y>>2]=T;cWc(n);cWc(m);i=d;return}function FZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];GZc(a,0,k,j,f,g,h);i=b;return}function GZc(b,d,e,f,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;RZc(n,h,v,l,m);h=o;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){h=o+1|0;w=h;x=o+8|0;y=h}else{h=o+8|0;w=o+1|0;x=h;y=c[h>>2]|0}c[p>>2]=y;h=q;c[r>>2]=h;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}lWc(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}lWc(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((SZc(T,t,u,R,p,B,l,n,h,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);g[k>>2]=+D2c(L,c[p>>2]|0,j);_$c(n,h,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}function HZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];IZc(a,0,k,j,f,g,h);i=b;return}function IZc(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;RZc(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}lWc(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}lWc(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((SZc(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+C2c(L,c[p>>2]|0,j);_$c(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}function JZc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;b=i;i=i+32|0;j=b;k=b+8|0;l=b+16|0;m=b+24|0;c[l>>2]=c[d>>2];c[m>>2]=c[e>>2];e=k;d=l;c[e+0>>2]=c[d+0>>2];d=j;e=m;c[d+0>>2]=c[e+0>>2];KZc(a,0,k,j,f,g,h);i=b;return}function KZc(b,d,e,f,g,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;d=i;i=i+376|0;l=d+128|0;m=d+136|0;n=d+144|0;o=d+160|0;p=d+176|0;q=d+184|0;r=d+344|0;s=d+352|0;t=d+360|0;u=d+368|0;v=d;RZc(n,g,v,l,m);g=o;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(o,10,0);if((a[o]&1)==0){g=o+1|0;w=g;x=o+8|0;y=g}else{g=o+8|0;w=o+1|0;x=g;y=c[g>>2]|0}c[p>>2]=y;g=q;c[r>>2]=g;c[s>>2]=0;a[t]=1;a[u]=69;z=e;e=f;f=o;A=o+4|0;B=c[l>>2]|0;l=c[m>>2]|0;m=c[z>>2]|0;C=y;a:while(1){do{if((m|0)==0){D=0;E=1}else{y=c[m+12>>2]|0;if((y|0)==(c[m+16>>2]|0)){F=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{F=c[y>>2]|0}if(!((F|0)==-1)){D=m;E=0;break}c[z>>2]=0;D=0;E=1}}while(0);y=c[e>>2]|0;do{if((y|0)==0){G=17}else{H=c[y+12>>2]|0;if((H|0)==(c[y+16>>2]|0)){I=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{I=c[H>>2]|0}if((I|0)==-1){c[e>>2]=0;G=17;break}else{if(E){J=y;break}else{K=y;L=C;break a}}}}while(0);if((G|0)==17){G=0;if(E){K=0;L=C;break}else{J=0}}y=a[o]|0;H=(y&1)==0;if(H){M=(y&255)>>>1}else{M=c[A>>2]|0}if(((c[p>>2]|0)-C|0)==(M|0)){if(H){N=(y&255)>>>1;O=(y&255)>>>1}else{y=c[A>>2]|0;N=y;O=y}lWc(o,O<<1,0);if((a[o]&1)==0){P=10}else{P=(c[f>>2]&-2)+ -1|0}lWc(o,P,0);if((a[o]&1)==0){Q=w}else{Q=c[x>>2]|0}c[p>>2]=Q+N;R=Q}else{R=C}y=D+12|0;H=c[y>>2]|0;S=D+16|0;if((H|0)==(c[S>>2]|0)){T=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{T=c[H>>2]|0}if((SZc(T,t,u,R,p,B,l,n,g,r,s,v)|0)!=0){K=J;L=R;break}H=c[y>>2]|0;if((H|0)==(c[S>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0;m=D;C=R;continue}else{c[y>>2]=H+4;m=D;C=R;continue}}R=a[n]|0;if((R&1)==0){U=(R&255)>>>1}else{U=c[n+4>>2]|0}do{if((U|0)!=0){if((a[t]|0)==0){break}R=c[r>>2]|0;if((R-q|0)>=160){break}C=c[s>>2]|0;c[r>>2]=R+4;c[R>>2]=C}}while(0);h[k>>3]=+B2c(L,c[p>>2]|0,j);_$c(n,g,c[r>>2]|0,j);do{if((D|0)==0){V=0;W=1}else{r=c[D+12>>2]|0;if((r|0)==(c[D+16>>2]|0)){X=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{X=c[r>>2]|0}if(!((X|0)==-1)){V=D;W=0;break}c[z>>2]=0;V=0;W=1}}while(0);do{if((K|0)==0){G=57}else{z=c[K+12>>2]|0;if((z|0)==(c[K+16>>2]|0)){Y=ie[c[(c[K>>2]|0)+36>>2]&127](K)|0}else{Y=c[z>>2]|0}if((Y|0)==-1){c[e>>2]=0;G=57;break}if(!W){break}Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}}while(0);do{if((G|0)==57){if(W){break}Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}}while(0);c[j>>2]=c[j>>2]|2;Z=b;_=Z;c[_>>2]=V;cWc(o);cWc(n);i=d;return}function LZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;d=i;i=i+8|0;k=d;l=i;i=i+16|0;m=i;i=i+104|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+160|0;s=i;i=i+8|0;t=i;i=i+8|0;u=n;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;_Wc(o,g);g=o;o=c[g>>2]|0;if(!((c[91588]|0)==-1)){c[l>>2]=366352;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366352,l,770)}l=(c[366356>>2]|0)+ -1|0;u=c[o+8>>2]|0;if(!((c[o+12>>2]|0)-u>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}o=c[u+(l<<2)>>2]|0;if((o|0)==0){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}y=m;He[c[(c[o>>2]|0)+48>>2]&63](o,364904,364930|0,y)|0;uVc(c[g>>2]|0)|0;g=p;c[g+0>>2]=0;c[g+4>>2]=0;c[g+8>>2]=0;lWc(p,10,0);if((a[p]&1)==0){g=p+1|0;z=g;A=p+8|0;B=g}else{g=p+8|0;z=p+1|0;A=g;B=c[g>>2]|0}c[q>>2]=B;g=r;c[s>>2]=g;c[t>>2]=0;r=e;e=f;f=p;o=p+4|0;m=c[r>>2]|0;x=B;a:while(1){do{if((m|0)==0){C=0;D=1}else{B=c[m+12>>2]|0;if((B|0)==(c[m+16>>2]|0)){E=ie[c[(c[m>>2]|0)+36>>2]&127](m)|0}else{E=c[B>>2]|0}if(!((E|0)==-1)){C=m;D=0;break}c[r>>2]=0;C=0;D=1}}while(0);B=c[e>>2]|0;do{if((B|0)==0){F=22}else{v=c[B+12>>2]|0;if((v|0)==(c[B+16>>2]|0)){G=ie[c[(c[B>>2]|0)+36>>2]&127](B)|0}else{G=c[v>>2]|0}if((G|0)==-1){c[e>>2]=0;F=22;break}else{if(D){break}else{H=x;break a}}}}while(0);if((F|0)==22){F=0;if(D){H=x;break}}B=a[p]|0;v=(B&1)==0;if(v){I=(B&255)>>>1}else{I=c[o>>2]|0}if(((c[q>>2]|0)-x|0)==(I|0)){if(v){J=(B&255)>>>1;K=(B&255)>>>1}else{B=c[o>>2]|0;J=B;K=B}lWc(p,K<<1,0);if((a[p]&1)==0){L=10}else{L=(c[f>>2]&-2)+ -1|0}lWc(p,L,0);if((a[p]&1)==0){M=z}else{M=c[A>>2]|0}c[q>>2]=M+J;N=M}else{N=x}B=C+12|0;v=c[B>>2]|0;w=C+16|0;if((v|0)==(c[w>>2]|0)){O=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{O=c[v>>2]|0}if((MZc(O,16,N,q,t,0,n,g,s,y)|0)!=0){H=N;break}v=c[B>>2]|0;if((v|0)==(c[w>>2]|0)){ie[c[(c[C>>2]|0)+40>>2]&127](C)|0;m=C;x=N;continue}else{c[B>>2]=v+4;m=C;x=N;continue}}a[H+3|0]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);N=c[91562]|0;c[k>>2]=j;if((oZc(H,N,364944,k)|0)!=1){c[h>>2]=4}k=c[r>>2]|0;do{if((k|0)==0){P=0;Q=1}else{N=c[k+12>>2]|0;if((N|0)==(c[k+16>>2]|0)){R=ie[c[(c[k>>2]|0)+36>>2]&127](k)|0}else{R=c[N>>2]|0}if(!((R|0)==-1)){P=k;Q=0;break}c[r>>2]=0;P=0;Q=1}}while(0);r=c[e>>2]|0;do{if((r|0)==0){F=60}else{k=c[r+12>>2]|0;if((k|0)==(c[r+16>>2]|0)){S=ie[c[(c[r>>2]|0)+36>>2]&127](r)|0}else{S=c[k>>2]|0}if((S|0)==-1){c[e>>2]=0;F=60;break}if(!Q){break}T=b;U=T;c[U>>2]=P;cWc(p);cWc(n);i=d;return}}while(0);do{if((F|0)==60){if(Q){break}T=b;U=T;c[U>>2]=P;cWc(p);cWc(n);i=d;return}}while(0);c[h>>2]=c[h>>2]|2;T=b;U=T;c[U>>2]=P;cWc(p);cWc(n);i=d;return}function MZc(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;o=c[f>>2]|0;p=(o|0)==(e|0);do{if(p){q=(c[m+96>>2]|0)==(b|0);if(!q){if((c[m+100>>2]|0)!=(b|0)){break}}c[f>>2]=e+1;a[e]=q?43:45;c[g>>2]=0;r=0;i=n;return r|0}}while(0);q=a[j]|0;if((q&1)==0){s=(q&255)>>>1}else{s=c[j+4>>2]|0}if((s|0)!=0&(b|0)==(h|0)){h=c[l>>2]|0;if((h-k|0)>=160){r=0;i=n;return r|0}k=c[g>>2]|0;c[l>>2]=h+4;c[h>>2]=k;c[g>>2]=0;r=0;i=n;return r|0}k=m+104|0;h=m;while(1){l=h+4|0;if((c[h>>2]|0)==(b|0)){t=h;break}if((l|0)==(k|0)){t=k;break}else{h=l}}h=t-m|0;m=h>>2;if((h|0)>92){r=-1;i=n;return r|0}do{if((d|0)==16){if((h|0)<88){break}if(p){r=-1;i=n;return r|0}if((o-e|0)>=3){r=-1;i=n;return r|0}if((a[o+ -1|0]|0)!=48){r=-1;i=n;return r|0}c[g>>2]=0;t=a[364904+m|0]|0;c[f>>2]=o+1;a[o]=t;r=0;i=n;return r|0}else if((d|0)==10|(d|0)==8){if((m|0)<(d|0)){break}else{r=-1}i=n;return r|0}}while(0);d=a[364904+m|0]|0;c[f>>2]=o+1;a[o]=d;c[g>>2]=(c[g>>2]|0)+1;r=0;i=n;return r|0}function NZc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;_Wc(k,d);d=k;k=c[d>>2]|0;if(!((c[91590]|0)==-1)){c[j>>2]=366360;c[j+4>>2]=769;c[j+8>>2]=0;PVc(366360,j,770)}j=(c[366364>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;O3c(n);o=381920;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;O3c(n);o=381920;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+32>>2]&63](k,364904,364930|0,e)|0;e=c[d>>2]|0;if(!((c[91626]|0)==-1)){c[h>>2]=366504;c[h+4>>2]=769;c[h+8>>2]=0;PVc(366504,h,770)}h=(c[366508>>2]|0)+ -1|0;k=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}e=c[k+(h<<2)>>2]|0;if((e|0)==0){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}else{t=e;a[f]=ie[c[(c[e>>2]|0)+16>>2]&127](t)|0;ge[c[(c[e>>2]|0)+20>>2]&255](b,t);uVc(c[d>>2]|0)|0;i=g;return}}function OZc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+40|0;j=h;k=h+16|0;l=h+32|0;_Wc(l,d);d=l;l=c[d>>2]|0;if(!((c[91590]|0)==-1)){c[k>>2]=366360;c[k+4>>2]=769;c[k+8>>2]=0;PVc(366360,k,770)}k=(c[366364>>2]|0)+ -1|0;m=c[l+8>>2]|0;if(!((c[l+12>>2]|0)-m>>2>>>0>k>>>0)){n=Ec(4)|0;o=n;O3c(o);p=381920;q=127;Td(n|0,p|0,q|0)}l=c[m+(k<<2)>>2]|0;if((l|0)==0){n=Ec(4)|0;o=n;O3c(o);p=381920;q=127;Td(n|0,p|0,q|0)}He[c[(c[l>>2]|0)+32>>2]&63](l,364904,364936|0,e)|0;e=c[d>>2]|0;if(!((c[91626]|0)==-1)){c[j>>2]=366504;c[j+4>>2]=769;c[j+8>>2]=0;PVc(366504,j,770)}j=(c[366508>>2]|0)+ -1|0;l=c[e+8>>2]|0;if(!((c[e+12>>2]|0)-l>>2>>>0>j>>>0)){r=Ec(4)|0;s=r;O3c(s);t=381920;u=127;Td(r|0,t|0,u|0)}e=c[l+(j<<2)>>2]|0;if((e|0)==0){r=Ec(4)|0;s=r;O3c(s);t=381920;u=127;Td(r|0,t|0,u|0)}else{u=e;a[f]=ie[c[(c[e>>2]|0)+12>>2]&127](u)|0;a[g]=ie[c[(c[e>>2]|0)+16>>2]&127](u)|0;ge[c[(c[e>>2]|0)+20>>2]&255](b,u);uVc(c[d>>2]|0)|0;i=h;return}}function PZc(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if(b<<24>>24==h<<24>>24){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if(b<<24>>24==j<<24>>24){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+32|0;j=o;while(1){r=j+1|0;if((a[j]|0)==b<<24>>24){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;if((j|0)>31){q=-1;i=p;return q|0}o=a[364904+j|0]|0;if((j|0)==23|(j|0)==22){a[e]=80;t=c[g>>2]|0;c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else if((j|0)==24|(j|0)==25){t=c[g>>2]|0;do{if((t|0)!=(f|0)){if((a[t+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=t+1;a[t]=o;q=0;i=p;return q|0}else{t=a[e]|0;do{if((o&95|0)==(t<<24>>24|0)){a[e]=t|-128;if((a[d]|0)==0){break}a[d]=0;f=a[k]|0;if((f&1)==0){u=(f&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}f=c[m>>2]|0;if((f-l|0)>=160){break}s=c[n>>2]|0;c[m>>2]=f+4;c[f>>2]=s}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=o;if((j|0)>21){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}return 0}function QZc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+40|0;g=f;h=f+16|0;j=f+32|0;_Wc(j,b);b=j;j=c[b>>2]|0;if(!((c[91588]|0)==-1)){c[h>>2]=366352;c[h+4>>2]=769;c[h+8>>2]=0;PVc(366352,h,770)}h=(c[366356>>2]|0)+ -1|0;k=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-k>>2>>>0>h>>>0)){l=Ec(4)|0;m=l;O3c(m);n=381920;o=127;Td(l|0,n|0,o|0)}j=c[k+(h<<2)>>2]|0;if((j|0)==0){l=Ec(4)|0;m=l;O3c(m);n=381920;o=127;Td(l|0,n|0,o|0)}He[c[(c[j>>2]|0)+48>>2]&63](j,364904,364930|0,d)|0;d=c[b>>2]|0;if(!((c[91628]|0)==-1)){c[g>>2]=366512;c[g+4>>2]=769;c[g+8>>2]=0;PVc(366512,g,770)}g=(c[366516>>2]|0)+ -1|0;j=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-j>>2>>>0>g>>>0)){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}d=c[j+(g<<2)>>2]|0;if((d|0)==0){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}else{s=d;c[e>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](s)|0;ge[c[(c[d>>2]|0)+20>>2]&255](a,s);uVc(c[b>>2]|0)|0;i=f;return}}function RZc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+40|0;h=g;j=g+16|0;k=g+32|0;_Wc(k,b);b=k;k=c[b>>2]|0;if(!((c[91588]|0)==-1)){c[j>>2]=366352;c[j+4>>2]=769;c[j+8>>2]=0;PVc(366352,j,770)}j=(c[366356>>2]|0)+ -1|0;l=c[k+8>>2]|0;if(!((c[k+12>>2]|0)-l>>2>>>0>j>>>0)){m=Ec(4)|0;n=m;O3c(n);o=381920;p=127;Td(m|0,o|0,p|0)}k=c[l+(j<<2)>>2]|0;if((k|0)==0){m=Ec(4)|0;n=m;O3c(n);o=381920;p=127;Td(m|0,o|0,p|0)}He[c[(c[k>>2]|0)+48>>2]&63](k,364904,364936|0,d)|0;d=c[b>>2]|0;if(!((c[91628]|0)==-1)){c[h>>2]=366512;c[h+4>>2]=769;c[h+8>>2]=0;PVc(366512,h,770)}h=(c[366516>>2]|0)+ -1|0;k=c[d+8>>2]|0;if(!((c[d+12>>2]|0)-k>>2>>>0>h>>>0)){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}d=c[k+(h<<2)>>2]|0;if((d|0)==0){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}else{t=d;c[e>>2]=ie[c[(c[d>>2]|0)+12>>2]&127](t)|0;c[f>>2]=ie[c[(c[d>>2]|0)+16>>2]&127](t)|0;ge[c[(c[d>>2]|0)+20>>2]&255](a,t);uVc(c[b>>2]|0)|0;i=g;return}}function SZc(b,d,e,f,g,h,j,k,l,m,n,o){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0;p=i;if((b|0)==(h|0)){if((a[d]|0)==0){q=-1;i=p;return q|0}a[d]=0;h=c[g>>2]|0;c[g>>2]=h+1;a[h]=46;h=a[k]|0;if((h&1)==0){r=(h&255)>>>1}else{r=c[k+4>>2]|0}if((r|0)==0){q=0;i=p;return q|0}r=c[m>>2]|0;if((r-l|0)>=160){q=0;i=p;return q|0}h=c[n>>2]|0;c[m>>2]=r+4;c[r>>2]=h;q=0;i=p;return q|0}do{if((b|0)==(j|0)){h=a[k]|0;if((h&1)==0){s=(h&255)>>>1}else{s=c[k+4>>2]|0}if((s|0)==0){break}if((a[d]|0)==0){q=-1;i=p;return q|0}h=c[m>>2]|0;if((h-l|0)>=160){q=0;i=p;return q|0}r=c[n>>2]|0;c[m>>2]=h+4;c[h>>2]=r;c[n>>2]=0;q=0;i=p;return q|0}}while(0);s=o+128|0;j=o;while(1){r=j+4|0;if((c[j>>2]|0)==(b|0)){t=j;break}if((r|0)==(s|0)){t=s;break}else{j=r}}j=t-o|0;o=j>>2;if((j|0)>124){q=-1;i=p;return q|0}t=a[364904+o|0]|0;do{if((o|0)==24|(o|0)==25){s=c[g>>2]|0;do{if((s|0)!=(f|0)){if((a[s+ -1|0]&95|0)==(a[e]&127|0)){break}else{q=-1}i=p;return q|0}}while(0);c[g>>2]=s+1;a[s]=t;q=0;i=p;return q|0}else if((o|0)==23|(o|0)==22){a[e]=80}else{b=a[e]|0;if((t&95|0)!=(b<<24>>24|0)){break}a[e]=b|-128;if((a[d]|0)==0){break}a[d]=0;b=a[k]|0;if((b&1)==0){u=(b&255)>>>1}else{u=c[k+4>>2]|0}if((u|0)==0){break}b=c[m>>2]|0;if((b-l|0)>=160){break}r=c[n>>2]|0;c[m>>2]=b+4;c[b>>2]=r}}while(0);m=c[g>>2]|0;c[g>>2]=m+1;a[m]=t;if((j|0)>84){q=0;i=p;return q|0}c[n>>2]=(c[n>>2]|0)+1;q=0;i=p;return q|0}function TZc(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function UZc(a){a=a|0;i=i;return}function VZc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}_Wc(n,f);f=n;n=c[f>>2]|0;if(!((c[91626]|0)==-1)){c[l>>2]=366504;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366504,l,770)}l=(c[366508>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;O3c(u);v=381920;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;O3c(u);v=381920;w=127;Td(t|0,v|0,w|0)}w=n;uVc(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&255](o,w)}else{ge[c[f+28>>2]&255](o,w)}w=a[o]|0;if((w&1)==0){f=o+1|0;x=f;y=f;z=o+8|0}else{f=o+8|0;x=c[f>>2]|0;y=o+1|0;z=f}f=e;e=o+4|0;h=w;w=x;while(1){if((h&1)==0){A=y;B=(h&255)>>>1}else{A=c[z>>2]|0;B=c[e>>2]|0}if((w|0)==(A+B|0)){break}x=a[w]|0;n=c[f>>2]|0;do{if((n|0)!=0){v=n+24|0;t=c[v>>2]|0;if((t|0)!=(c[n+28>>2]|0)){c[v>>2]=t+1;a[t]=x;break}if(!((xe[c[(c[n>>2]|0)+52>>2]&63](n,x&255)|0)==-1)){break}c[f>>2]=0}}while(0);h=a[o]|0;w=w+1|0}c[b>>2]=c[f>>2];cWc(o);i=j;return}function WZc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=365152;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==64){a[w]=111}else if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else{a[w]=100}}while(0);w=m;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);v=c[91562]|0;c[k>>2]=h;h=XZc(w,12,v,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;_Wc(q,f);YZc(w,y,k,z,o,p,q);uVc(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];BSc(b,j,z,e,o,f,g);i=d;return}function XZc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+16|0;h=g;c[h>>2]=f;f=Lc(d|0)|0;d=Zc(a|0,b|0,e|0,h|0)|0;if((f|0)==0){i=g;return d|0}Lc(f|0)|0;i=g;return d|0}function YZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[91590]|0)==-1)){c[m>>2]=366360;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366360,m,770)}m=(c[366364>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[91626]|0)==-1)){c[l>>2]=366504;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366504,l,770)}l=(c[366508>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&255](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,b,e,f)|0;c[h>>2]=f+(e-b)}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;z=b+1|0}else{z=b}do{if((e-z|0)>1){if((a[z]|0)!=48){A=z;break}u=z+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){A=z;break}w=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+1;a[v]=w;w=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+1;a[u]=w;A=z+2|0}else{A=z}}while(0);do{if((A|0)!=(e|0)){w=e+ -1|0;if(w>>>0>A>>>0){B=A;C=w}else{break}do{w=a[B]|0;a[B]=a[C]|0;a[C]=w;B=B+1|0;C=C+ -1|0;}while(B>>>0<C>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(A>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=A;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){D=o;E=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){D=o;E=q;break}p=c[h>>2]|0;c[h>>2]=p+1;a[p]=w;p=a[n]|0;if((p&1)==0){F=(p&255)>>>1}else{F=c[v>>2]|0}D=0;E=(q>>>0<(F+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=m;m=r+1|0;if(m>>>0<e>>>0){o=D+1|0;q=E;r=m}else{break}}}r=f+(A-b)|0;q=c[h>>2]|0;if((r|0)==(q|0)){break}o=q+ -1|0;if(o>>>0>r>>>0){G=r;H=o}else{break}do{o=a[G]|0;a[G]=a[H]|0;a[H]=o;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);if((d|0)==(e|0)){I=c[h>>2]|0;c[g>>2]=I;cWc(n);i=k;return}else{I=f+(d-b)|0;c[g>>2]=I;cWc(n);i=k;return}}function ZZc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=100}}while(0);x=n;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);w=c[91562]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=XZc(x,22,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;_Wc(r,f);YZc(x,z,l,A,p,q,r);uVc(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];BSc(b,k,A,e,p,f,g);i=d;return}function _Zc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=365152;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);x=c[91562]|0;c[k>>2]=h;h=XZc(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;_Wc(q,f);YZc(w,y,k,z,o,p,q);uVc(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];BSc(b,j,z,e,o,f,g);i=d;return}function $Zc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+48|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==64){a[x]=111}else if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else{a[x]=117}}while(0);x=n;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);w=c[91562]|0;y=l;c[y>>2]=h;c[y+4>>2]=j;j=XZc(x,23,w,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==32){z=l}else if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else{A=20}}while(0);if((A|0)==20){z=x}A=o;_Wc(r,f);YZc(x,z,l,A,p,q,r);uVc(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];BSc(b,k,A,e,p,f,g);i=d;return}function a_c(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[366256]|0)==0;if(F){do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=b_c(s,r,z,n)|0}else{do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);o=c[91562]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=b_c(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}u4c()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=h4c(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}u4c()}}while(0);_Wc(w,f);c_c(N,L,G,P,u,v,w);uVc(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];BSc(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){i4c(O)}if((J|0)==0){i=d;return}i4c(J);i=d;return}function b_c(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;e=Lc(b|0)|0;b=jc(a|0,d|0,g|0)|0;if((e|0)==0){i=f;return b|0}Lc(e|0)|0;i=f;return b|0}function c_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[91590]|0)==-1)){c[m>>2]=366360;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366360,m,770)}m=(c[366364>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[91626]|0)==-1)){c[l>>2]=366504;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366504,l,770)}l=(c[366508>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&255](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+28>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+28>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+1;a[l]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+1;a[w]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[91562]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[91562]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+32>>2]&63](t,B,C,c[h>>2]|0)|0;c[h>>2]=(c[h>>2]|0)+(C-B)}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){F=B;G=y}else{break}do{y=a[F]|0;a[F]=a[G]|0;a[G]=y;F=F+1|0;G=G+ -1|0;}while(F>>>0<G>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){H=l;I=v;break}q=c[h>>2]|0;c[h>>2]=q+1;a[q]=A;q=a[n]|0;if((q&1)==0){J=(q&255)>>>1}else{J=c[D>>2]|0}H=0;I=(v>>>0<(J+ -1|0)>>>0)+v|0}else{H=l;I=v}}while(0);o=xe[c[(c[j>>2]|0)+28>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;c[h>>2]=q+1;a[q]=o;o=w+1|0;if(o>>>0<C>>>0){l=H+1|0;v=I;w=o}else{break}}}w=f+(B-b)|0;v=c[h>>2]|0;if((w|0)==(v|0)){break}l=v+ -1|0;if(l>>>0>w>>>0){K=w;L=l}else{break}do{l=a[K]|0;a[K]=a[L]|0;a[L]=l;K=K+1|0;L=L+ -1|0;}while(K>>>0<L>>>0)}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){K=a[L]|0;if(K<<24>>24==46){break}B=xe[c[(c[j>>2]|0)+28>>2]&63](t,K)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;B=L+1|0;if(B>>>0<e>>>0){L=B}else{M=B;break c}}B=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;K=c[h>>2]|0;c[h>>2]=K+1;a[K]=B;M=L+1|0}else{M=C}}while(0);He[c[(c[j>>2]|0)+32>>2]&63](t,M,e,c[h>>2]|0)|0;t=(c[h>>2]|0)+(u-M)|0;c[h>>2]=t;if((d|0)==(e|0)){N=t;c[g>>2]=N;cWc(n);i=k;return}N=f+(d-b)|0;c[g>>2]=N;cWc(n);i=k;return}function d_c(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+64|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[366256]|0)==0;if(F){do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=b_c(s,r,z,n)|0}else{do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);o=c[91562]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=b_c(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}u4c()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=h4c(K<<1)|0;if((M|0)!=0){N=I;O=M;P=M;break}u4c()}}while(0);_Wc(w,f);c_c(N,L,G,P,u,v,w);uVc(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];BSc(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){i4c(O)}if((J|0)==0){i=d;return}i4c(J);i=d;return}function e_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+40|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=365160;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);s=c[91562]|0;c[k>>2]=h;h=XZc(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}u=o;_Wc(p,f);r=p;p=c[r>>2]|0;if(!((c[91590]|0)==-1)){c[l>>2]=366360;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366360,l,770)}l=(c[366364>>2]|0)+ -1|0;s=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-s>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}p=c[s+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}uVc(c[r>>2]|0)|0;He[c[(c[p>>2]|0)+32>>2]&63](p,m,k,u)|0;m=o+h|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];BSc(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];BSc(b,j,u,z,m,f,g);I=j;i=d;return}function f_c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function g_c(a){a=a|0;i=i;return}function h_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;j=i;i=i+56|0;k=j;l=j+8|0;m=j+24|0;n=j+32|0;o=j+40|0;if((c[f+4>>2]&1|0)==0){p=c[(c[d>>2]|0)+24>>2]|0;c[m>>2]=c[e>>2];q=h&1;r=k;s=m;c[r+0>>2]=c[s+0>>2];re[p&31](b,d,k,f,g,q);i=j;return}_Wc(n,f);f=n;n=c[f>>2]|0;if(!((c[91628]|0)==-1)){c[l>>2]=366512;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366512,l,770)}l=(c[366516>>2]|0)+ -1|0;q=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-q>>2>>>0>l>>>0)){t=Ec(4)|0;u=t;O3c(u);v=381920;w=127;Td(t|0,v|0,w|0)}n=c[q+(l<<2)>>2]|0;if((n|0)==0){t=Ec(4)|0;u=t;O3c(u);v=381920;w=127;Td(t|0,v|0,w|0)}w=n;uVc(c[f>>2]|0)|0;f=c[n>>2]|0;if(h){ge[c[f+24>>2]&255](o,w)}else{ge[c[f+28>>2]&255](o,w)}w=a[o]|0;if((w&1)==0){f=o+4|0;x=f;y=o+8|0;z=f}else{f=o+8|0;x=c[f>>2]|0;y=f;z=o+4|0}f=e;e=w;w=x;while(1){if((e&1)==0){A=z;B=(e&255)>>>1}else{A=c[y>>2]|0;B=c[z>>2]|0}if((w|0)==(A+(B<<2)|0)){break}x=c[w>>2]|0;h=c[f>>2]|0;do{if((h|0)!=0){n=h+24|0;v=c[n>>2]|0;if((v|0)==(c[h+28>>2]|0)){C=xe[c[(c[h>>2]|0)+52>>2]&63](h,x)|0}else{c[n>>2]=v+4;c[v>>2]=x;C=x}if(!((C|0)==-1)){break}c[f>>2]=0}}while(0);e=a[o]|0;w=w+4|0}c[b>>2]=c[f>>2];GWc(o);i=j;return}function i_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=365152;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=100}}while(0);w=m;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);x=c[91562]|0;c[k>>2]=h;h=XZc(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==32){y=k}else if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else{z=20}}while(0);if((z|0)==20){y=w}z=n;_Wc(q,f);j_c(w,y,k,z,o,p,q);uVc(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];k_c(b,j,z,e,o,f,g);i=d;return}function j_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[91588]|0)==-1)){c[m>>2]=366352;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366352,m,770)}m=(c[366356>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[91628]|0)==-1)){c[l>>2]=366512;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366512,l,770)}l=(c[366516>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&255](n,x);w=a[n]|0;if((w&1)==0){y=(w&255)>>>1}else{y=c[n+4>>2]|0}do{if((y|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,b,e,f)|0;w=f+(e-b<<2)|0;c[h>>2]=w;z=w}else{c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;A=b+1|0}else{A=b}do{if((e-A|0)>1){if((a[A]|0)!=48){B=A;break}u=A+1|0;w=a[u]|0;if(!(w<<24>>24==88|w<<24>>24==120)){B=A;break}w=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;v=c[h>>2]|0;c[h>>2]=v+4;c[v>>2]=w;w=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[u]|0)|0;u=c[h>>2]|0;c[h>>2]=u+4;c[u>>2]=w;B=A+2|0}else{B=A}}while(0);do{if((B|0)!=(e|0)){w=e+ -1|0;if(w>>>0>B>>>0){C=B;D=w}else{break}do{w=a[C]|0;a[C]=a[D]|0;a[D]=w;C=C+1|0;D=D+ -1|0;}while(C>>>0<D>>>0)}}while(0);w=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<e>>>0){u=n+1|0;v=n+4|0;l=n+8|0;o=0;q=0;r=B;while(1){m=(a[n]&1)==0;do{if((a[(m?u:c[l>>2]|0)+q|0]|0)==0){E=o;F=q}else{if((o|0)!=(a[(m?u:c[l>>2]|0)+q|0]|0)){E=o;F=q;break}p=c[h>>2]|0;c[h>>2]=p+4;c[p>>2]=w;p=a[n]|0;if((p&1)==0){G=(p&255)>>>1}else{G=c[v>>2]|0}E=0;F=(q>>>0<(G+ -1|0)>>>0)+q|0}}while(0);m=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[r]|0)|0;p=c[h>>2]|0;H=p+4|0;c[h>>2]=H;c[p>>2]=m;m=r+1|0;if(m>>>0<e>>>0){o=E+1|0;q=F;r=m}else{I=H;break}}}else{I=c[h>>2]|0}r=f+(B-b<<2)|0;if((r|0)==(I|0)){z=I;break}q=I+ -4|0;if(q>>>0>r>>>0){J=r;K=q}else{z=I;break}while(1){q=c[J>>2]|0;c[J>>2]=c[K>>2];c[K>>2]=q;q=J+4|0;r=K+ -4|0;if(q>>>0<r>>>0){K=r;J=q}else{z=I;break}}}}while(0);if((d|0)==(e|0)){L=z;c[g>>2]=L;cWc(n);i=k;return}L=f+(d-b<<2)|0;c[g>>2]=L;cWc(n);i=k;return}function k_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;k=i;i=i+16|0;l=k;m=d;d=c[m>>2]|0;if((d|0)==0){c[b>>2]=0;i=k;return}n=g;g=e;o=n-g>>2;p=h+12|0;h=c[p>>2]|0;q=(h|0)>(o|0)?h-o|0:0;o=f;h=o-g|0;g=h>>2;do{if((h|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,e,g)|0)==(g|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);do{if((q|0)>0){FWc(l,q,j);if((a[l]&1)==0){r=l+4|0}else{r=c[l+8>>2]|0}if((le[c[(c[d>>2]|0)+48>>2]&63](d,r,q)|0)==(q|0)){GWc(l);break}c[m>>2]=0;c[b>>2]=0;GWc(l);i=k;return}}while(0);l=n-o|0;o=l>>2;do{if((l|0)>0){if((le[c[(c[d>>2]|0)+48>>2]&63](d,f,o)|0)==(o|0)){break}c[m>>2]=0;c[b>>2]=0;i=k;return}}while(0);c[p>>2]=0;c[b>>2]=d;i=k;return}function l_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+168|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=100}}while(0);x=n;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);y=c[91562]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=XZc(x,22,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;_Wc(r,f);j_c(x,z,l,A,p,q,r);uVc(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];k_c(b,k,A,e,p,f,g);i=d;return}function m_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+88|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=l;t=365152;a[s+0|0]=a[t+0|0]|0;a[s+1|0]=a[t+1|0]|0;a[s+2|0]=a[t+2|0]|0;a[s+3|0]=a[t+3|0]|0;a[s+4|0]=a[t+4|0]|0;a[s+5|0]=a[t+5|0]|0;t=l+1|0;u=f+4|0;v=c[u>>2]|0;if((v&2048|0)==0){w=t}else{a[t]=43;w=l+2|0}if((v&512|0)==0){x=w}else{a[w]=35;x=w+1|0}a[x]=108;w=x+1|0;x=v&74;do{if((x|0)==8){if((v&16384|0)==0){a[w]=120;break}else{a[w]=88;break}}else if((x|0)==64){a[w]=111}else{a[w]=117}}while(0);w=m;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);x=c[91562]|0;c[k>>2]=h;h=XZc(w,12,x,s,k)|0;k=m+h|0;s=c[u>>2]&176;do{if((s|0)==16){u=a[w]|0;if(u<<24>>24==43|u<<24>>24==45){y=m+1|0;break}if(!((h|0)>1&u<<24>>24==48)){z=20;break}u=a[m+1|0]|0;if(!(u<<24>>24==88|u<<24>>24==120)){z=20;break}y=m+2|0}else if((s|0)==32){y=k}else{z=20}}while(0);if((z|0)==20){y=w}z=n;_Wc(q,f);j_c(w,y,k,z,o,p,q);uVc(c[q>>2]|0)|0;c[r>>2]=c[e>>2];e=c[o>>2]|0;o=c[p>>2]|0;p=j;q=r;c[p+0>>2]=c[q+0>>2];k_c(b,j,z,e,o,f,g);i=d;return}



function n_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+16|0;k=d;l=d+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+176|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=m;c[t>>2]=37;c[t+4>>2]=0;t=m;u=m+1|0;v=f+4|0;w=c[v>>2]|0;if((w&2048|0)==0){x=u}else{a[u]=43;x=m+2|0}if((w&512|0)==0){y=x}else{a[x]=35;y=x+1|0}a[y]=108;a[y+1|0]=108;x=y+2|0;y=w&74;do{if((y|0)==8){if((w&16384|0)==0){a[x]=120;break}else{a[x]=88;break}}else if((y|0)==64){a[x]=111}else{a[x]=117}}while(0);x=n;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);y=c[91562]|0;w=l;c[w>>2]=h;c[w+4>>2]=j;j=XZc(x,23,y,t,l)|0;l=n+j|0;t=c[v>>2]&176;do{if((t|0)==16){v=a[x]|0;if(v<<24>>24==43|v<<24>>24==45){z=n+1|0;break}if(!((j|0)>1&v<<24>>24==48)){A=20;break}v=a[n+1|0]|0;if(!(v<<24>>24==88|v<<24>>24==120)){A=20;break}z=n+2|0}else if((t|0)==32){z=l}else{A=20}}while(0);if((A|0)==20){z=x}A=o;_Wc(r,f);j_c(x,z,l,A,p,q,r);uVc(c[r>>2]|0)|0;c[s>>2]=c[e>>2];e=c[p>>2]|0;p=c[q>>2]|0;q=k;r=s;c[q+0>>2]=c[r+0>>2];k_c(b,k,A,e,p,f,g);i=d;return}function o_c(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+24|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){if((q&1|0)==0){a[E]=97;F=0;break}else{a[E]=65;F=0;break}}else{a[E]=46;C=E+2|0;a[E+1|0]=42;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[366256]|0)==0;if(F){do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=b_c(s,r,z,n)|0}else{do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);o=c[91562]|0;c[m>>2]=c[f+8>>2];r=m+4|0;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=b_c(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}u4c()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else if((s|0)==32){L=G}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=h4c(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}u4c()}}while(0);_Wc(w,f);p_c(N,L,G,P,u,v,w);uVc(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];k_c(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){i4c(O)}if((J|0)==0){i=d;return}i4c(J);i=d;return}function p_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;k=i;i=i+48|0;l=k;m=k+16|0;n=k+32|0;o=j;j=c[o>>2]|0;if(!((c[91588]|0)==-1)){c[m>>2]=366352;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366352,m,770)}m=(c[366356>>2]|0)+ -1|0;p=c[j+8>>2]|0;if(!((c[j+12>>2]|0)-p>>2>>>0>m>>>0)){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}j=c[p+(m<<2)>>2]|0;if((j|0)==0){q=Ec(4)|0;r=q;O3c(r);s=381920;t=127;Td(q|0,s|0,t|0)}t=j;s=c[o>>2]|0;if(!((c[91628]|0)==-1)){c[l>>2]=366512;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366512,l,770)}l=(c[366516>>2]|0)+ -1|0;o=c[s+8>>2]|0;if(!((c[s+12>>2]|0)-o>>2>>>0>l>>>0)){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}s=c[o+(l<<2)>>2]|0;if((s|0)==0){u=Ec(4)|0;v=u;O3c(v);w=381920;x=127;Td(u|0,w|0,x|0)}x=s;ge[c[(c[s>>2]|0)+20>>2]&255](n,x);c[h>>2]=f;w=a[b]|0;if(w<<24>>24==43|w<<24>>24==45){u=xe[c[(c[j>>2]|0)+44>>2]&63](t,w)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=u;y=b+1|0}else{y=b}u=e;a:do{if((u-y|0)>1){if((a[y]|0)!=48){z=14;break}w=y+1|0;v=a[w]|0;if(!(v<<24>>24==88|v<<24>>24==120)){z=14;break}v=xe[c[(c[j>>2]|0)+44>>2]&63](t,48)|0;l=c[h>>2]|0;c[h>>2]=l+4;c[l>>2]=v;v=y+2|0;l=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;w=c[h>>2]|0;c[h>>2]=w+4;c[w>>2]=l;if(v>>>0<e>>>0){A=v}else{B=v;C=v;break}while(1){l=a[A]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);w=A+1|0;if((Xc(l<<24>>24|0,c[91562]|0)|0)==0){B=v;C=A;break a}if(w>>>0<e>>>0){A=w}else{B=v;C=w;break}}}else{z=14}}while(0);b:do{if((z|0)==14){if(y>>>0<e>>>0){D=y}else{B=y;C=y;break}while(1){A=a[D]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);l=D+1|0;if((Vd(A<<24>>24|0,c[91562]|0)|0)==0){B=y;C=D;break b}if(l>>>0<e>>>0){D=l}else{B=y;C=l;break}}}}while(0);y=a[n]|0;if((y&1)==0){E=(y&255)>>>1}else{E=c[n+4>>2]|0}do{if((E|0)==0){He[c[(c[j>>2]|0)+48>>2]&63](t,B,C,c[h>>2]|0)|0;y=(c[h>>2]|0)+(C-B<<2)|0;c[h>>2]=y;F=y}else{do{if((B|0)!=(C|0)){y=C+ -1|0;if(y>>>0>B>>>0){G=B;H=y}else{break}do{y=a[G]|0;a[G]=a[H]|0;a[H]=y;G=G+1|0;H=H+ -1|0;}while(G>>>0<H>>>0)}}while(0);A=ie[c[(c[s>>2]|0)+16>>2]&127](x)|0;if(B>>>0<C>>>0){y=n+1|0;D=n+4|0;z=n+8|0;l=0;v=0;w=B;while(1){o=(a[n]&1)==0;do{if((a[(o?y:c[z>>2]|0)+v|0]|0)>0){if((l|0)!=(a[(o?y:c[z>>2]|0)+v|0]|0)){I=l;J=v;break}q=c[h>>2]|0;c[h>>2]=q+4;c[q>>2]=A;q=a[n]|0;if((q&1)==0){K=(q&255)>>>1}else{K=c[D>>2]|0}I=0;J=(v>>>0<(K+ -1|0)>>>0)+v|0}else{I=l;J=v}}while(0);o=xe[c[(c[j>>2]|0)+44>>2]&63](t,a[w]|0)|0;q=c[h>>2]|0;r=q+4|0;c[h>>2]=r;c[q>>2]=o;o=w+1|0;if(o>>>0<C>>>0){l=I+1|0;v=J;w=o}else{L=r;break}}}else{L=c[h>>2]|0}w=f+(B-b<<2)|0;if((w|0)==(L|0)){F=L;break}v=L+ -4|0;if(v>>>0>w>>>0){M=w;N=v}else{F=L;break}while(1){v=c[M>>2]|0;c[M>>2]=c[N>>2];c[N>>2]=v;v=M+4|0;w=N+ -4|0;if(v>>>0<w>>>0){N=w;M=v}else{F=L;break}}}}while(0);c:do{if(C>>>0<e>>>0){L=C;while(1){M=a[L]|0;if(M<<24>>24==46){break}N=xe[c[(c[j>>2]|0)+44>>2]&63](t,M)|0;M=c[h>>2]|0;B=M+4|0;c[h>>2]=B;c[M>>2]=N;N=L+1|0;if(N>>>0<e>>>0){L=N}else{O=B;P=N;break c}}N=ie[c[(c[s>>2]|0)+12>>2]&127](x)|0;B=c[h>>2]|0;M=B+4|0;c[h>>2]=M;c[B>>2]=N;O=M;P=L+1|0}else{O=F;P=C}}while(0);He[c[(c[j>>2]|0)+48>>2]&63](t,P,e,O)|0;O=(c[h>>2]|0)+(u-P<<2)|0;c[h>>2]=O;if((d|0)==(e|0)){Q=O;c[g>>2]=Q;cWc(n);i=k;return}Q=f+(d-b<<2)|0;c[g>>2]=Q;cWc(n);i=k;return}function q_c(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=+j;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+32|0;s=i;i=i+8|0;t=i;i=i+232|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=q;c[z>>2]=37;c[z+4>>2]=0;z=q;A=q+1|0;B=f+4|0;C=c[B>>2]|0;if((C&2048|0)==0){D=A}else{a[A]=43;D=q+2|0}if((C&1024|0)==0){E=D}else{a[D]=35;E=D+1|0}D=C&260;q=C>>>14;do{if((D|0)==260){a[E]=76;C=E+1|0;if((q&1|0)==0){a[C]=97;F=0;break}else{a[C]=65;F=0;break}}else{a[E]=46;a[E+1|0]=42;a[E+2|0]=76;C=E+3|0;if((D|0)==256){if((q&1|0)==0){a[C]=101;F=1;break}else{a[C]=69;F=1;break}}else if((D|0)==4){if((q&1|0)==0){a[C]=102;F=1;break}else{a[C]=70;F=1;break}}else{if((q&1|0)==0){a[C]=103;F=1;break}else{a[C]=71;F=1;break}}}}while(0);q=r;c[s>>2]=q;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;if(F){c[p>>2]=c[f+8>>2];D=p+4|0;h[k>>3]=j;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,p)|0}else{p=o;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];G=XZc(q,30,r,z,o)|0}do{if((G|0)>29){o=(a[366256]|0)==0;if(F){do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);r=c[91562]|0;c[n>>2]=c[f+8>>2];p=n+4|0;h[k>>3]=j;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];H=b_c(s,r,z,n)|0}else{do{if(o){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);o=c[91562]|0;r=m;h[k>>3]=j;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];H=b_c(s,o,z,m)|0}o=c[s>>2]|0;if((o|0)!=0){I=o;J=o;K=H;break}u4c()}else{I=c[s>>2]|0;J=0;K=G}}while(0);G=I+K|0;s=c[B>>2]&176;do{if((s|0)==32){L=G}else if((s|0)==16){B=a[I]|0;if(B<<24>>24==43|B<<24>>24==45){L=I+1|0;break}if(!((K|0)>1&B<<24>>24==48)){M=44;break}B=a[I+1|0]|0;if(!(B<<24>>24==88|B<<24>>24==120)){M=44;break}L=I+2|0}else{M=44}}while(0);if((M|0)==44){L=I}do{if((I|0)==(q|0)){N=q;O=0;P=t}else{M=h4c(K<<3)|0;s=M;if((M|0)!=0){N=I;O=s;P=s;break}u4c()}}while(0);_Wc(w,f);p_c(N,L,G,P,u,v,w);uVc(c[w>>2]|0)|0;w=e;c[y>>2]=c[w>>2];e=c[u>>2]|0;u=c[v>>2]|0;v=l;G=y;c[v+0>>2]=c[G+0>>2];k_c(x,l,P,e,u,f,g);g=c[x>>2]|0;c[w>>2]=g;c[b>>2]=g;if((O|0)!=0){i4c(O)}if((J|0)==0){i=d;return}i4c(J);i=d;return}function r_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;d=i;i=i+16|0;j=d;k=d+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+24|0;o=i;i=i+152|0;p=i;i=i+8|0;q=i;i=i+8|0;r=m;m=365160;a[r+0|0]=a[m+0|0]|0;a[r+1|0]=a[m+1|0]|0;a[r+2|0]=a[m+2|0]|0;a[r+3|0]=a[m+3|0]|0;a[r+4|0]=a[m+4|0]|0;a[r+5|0]=a[m+5|0]|0;m=n;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);s=c[91562]|0;c[k>>2]=h;h=XZc(m,20,s,r,k)|0;k=n+h|0;r=c[f+4>>2]&176;do{if((r|0)==32){t=k}else if((r|0)==16){s=a[m]|0;if(s<<24>>24==43|s<<24>>24==45){t=n+1|0;break}if(!((h|0)>1&s<<24>>24==48)){u=10;break}s=a[n+1|0]|0;if(!(s<<24>>24==88|s<<24>>24==120)){u=10;break}t=n+2|0}else{u=10}}while(0);if((u|0)==10){t=m}_Wc(p,f);u=p;p=c[u>>2]|0;if(!((c[91588]|0)==-1)){c[l>>2]=366352;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366352,l,770)}l=(c[366356>>2]|0)+ -1|0;r=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-r>>2>>>0>l>>>0)){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}p=c[r+(l<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}uVc(c[u>>2]|0)|0;u=o;He[c[(c[p>>2]|0)+48>>2]&63](p,m,k,u)|0;m=o+(h<<2)|0;if((t|0)==(k|0)){z=m;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];k_c(b,j,u,z,m,f,g);I=j;i=d;return}z=o+(t-n<<2)|0;A=e;B=A;C=c[B>>2]|0;D=q;E=D;c[E>>2]=C;F=j;G=j;H=q;c[G+0>>2]=c[H+0>>2];k_c(b,j,u,z,m,f,g);I=j;i=d;return}function s_c(d,e,f,g,h,j,k,l,m){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0;n=i;i=i+64|0;o=n;p=n+8|0;q=n+16|0;r=n+32|0;s=n+40|0;t=n+48|0;u=n+56|0;_Wc(r,h);v=r;r=c[v>>2]|0;if(!((c[91590]|0)==-1)){c[q>>2]=366360;c[q+4>>2]=769;c[q+8>>2]=0;PVc(366360,q,770)}q=(c[366364>>2]|0)+ -1|0;w=c[r+8>>2]|0;if(!((c[r+12>>2]|0)-w>>2>>>0>q>>>0)){x=Ec(4)|0;y=x;O3c(y);z=381920;A=127;Td(x|0,z|0,A|0)}r=c[w+(q<<2)>>2]|0;if((r|0)==0){x=Ec(4)|0;y=x;O3c(y);z=381920;A=127;Td(x|0,z|0,A|0)}A=r;uVc(c[v>>2]|0)|0;c[j>>2]=0;v=f;a:do{if((l|0)==(m|0)){B=65}else{z=g;x=r+8|0;y=t;q=u;w=s;C=l;D=0;b:while(1){E=D;while(1){if((E|0)!=0){B=65;break a}F=c[v>>2]|0;do{if((F|0)==0){G=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){G=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){G=F;break}c[v>>2]=0;G=0}}while(0);F=(G|0)==0;H=c[z>>2]|0;c:do{if((H|0)==0){B=19}else{do{if((c[H+12>>2]|0)==(c[H+16>>2]|0)){if(!((ie[c[(c[H>>2]|0)+36>>2]&127](H)|0)==-1)){break}c[z>>2]=0;B=19;break c}}while(0);if(F){I=H}else{B=20;break b}}}while(0);if((B|0)==19){B=0;if(F){B=20;break b}else{I=0}}if((le[c[(c[r>>2]|0)+36>>2]&63](A,a[C]|0,0)|0)<<24>>24==37){B=22;break}H=a[C]|0;if(H<<24>>24>-1){J=c[x>>2]|0;if(!((b[J+(H<<24>>24<<1)>>1]&8192)==0)){K=C;B=33;break}}L=G+12|0;H=c[L>>2]|0;M=G+16|0;if((H|0)==(c[M>>2]|0)){N=(ie[c[(c[G>>2]|0)+36>>2]&127](G)|0)&255}else{N=a[H]|0}H=xe[c[(c[r>>2]|0)+12>>2]&63](A,N)|0;if(H<<24>>24==(xe[c[(c[r>>2]|0)+12>>2]&63](A,a[C]|0)|0)<<24>>24){B=60;break}c[j>>2]=4;E=4}d:do{if((B|0)==22){B=0;E=C+1|0;if((E|0)==(m|0)){B=23;break b}H=le[c[(c[r>>2]|0)+36>>2]&63](A,a[E]|0,0)|0;if(H<<24>>24==48|H<<24>>24==69){O=C+2|0;if((O|0)==(m|0)){B=26;break b}P=O;Q=le[c[(c[r>>2]|0)+36>>2]&63](A,a[O]|0,0)|0;R=H}else{P=E;Q=H;R=0}H=c[(c[e>>2]|0)+36>>2]|0;c[y>>2]=G;c[q>>2]=I;E=p;O=t;c[E+0>>2]=c[O+0>>2];O=o;E=u;c[O+0>>2]=c[E+0>>2];we[H&3](s,e,p,o,h,j,k,Q,R);c[v>>2]=c[w>>2];S=P+1|0}else if((B|0)==33){while(1){B=0;H=K+1|0;if((H|0)==(m|0)){T=m;break}E=a[H]|0;if(!(E<<24>>24>-1)){T=H;break}if((b[J+(E<<24>>24<<1)>>1]&8192)==0){T=H;break}else{K=H;B=33}}F=G;H=I;E=I;while(1){do{if((F|0)==0){U=0}else{if((c[F+12>>2]|0)!=(c[F+16>>2]|0)){U=F;break}if(!((ie[c[(c[F>>2]|0)+36>>2]&127](F)|0)==-1)){U=F;break}c[v>>2]=0;U=0}}while(0);O=(U|0)==0;do{if((E|0)==0){V=H;B=46}else{if((c[E+12>>2]|0)!=(c[E+16>>2]|0)){if(O){W=H;X=E;break}else{S=T;break d}}if((ie[c[(c[E>>2]|0)+36>>2]&127](E)|0)==-1){c[z>>2]=0;V=0;B=46;break}else{if(O^(H|0)==0){W=H;X=H;break}else{S=T;break d}}}}while(0);if((B|0)==46){B=0;if(O){S=T;break d}else{W=V;X=0}}Y=U+12|0;Z=c[Y>>2]|0;_=U+16|0;if((Z|0)==(c[_>>2]|0)){$=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{$=a[Z]|0}if(!($<<24>>24>-1)){S=T;break d}if((b[(c[x>>2]|0)+($<<24>>24<<1)>>1]&8192)==0){S=T;break d}Z=c[Y>>2]|0;if((Z|0)==(c[_>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;F=U;H=W;E=X;continue}else{c[Y>>2]=Z+1;F=U;H=W;E=X;continue}}}else if((B|0)==60){B=0;E=c[L>>2]|0;if((E|0)==(c[M>>2]|0)){ie[c[(c[G>>2]|0)+40>>2]&127](G)|0}else{c[L>>2]=E+1}S=C+1|0}}while(0);if((S|0)==(m|0)){B=65;break a}C=S;D=c[j>>2]|0}if((B|0)==20){c[j>>2]=4;aa=G;break}else if((B|0)==23){c[j>>2]=4;aa=G;break}else if((B|0)==26){c[j>>2]=4;aa=G;break}}}while(0);if((B|0)==65){aa=c[v>>2]|0}v=f;do{if((aa|0)==0){ba=0}else{if((c[aa+12>>2]|0)!=(c[aa+16>>2]|0)){ba=aa;break}if(!((ie[c[(c[aa>>2]|0)+36>>2]&127](aa)|0)==-1)){ba=aa;break}c[v>>2]=0;ba=0}}while(0);v=(ba|0)==0;aa=g;g=c[aa>>2]|0;e:do{if((g|0)==0){B=75}else{do{if((c[g+12>>2]|0)==(c[g+16>>2]|0)){if(!((ie[c[(c[g>>2]|0)+36>>2]&127](g)|0)==-1)){break}c[aa>>2]=0;B=75;break e}}while(0);if(!v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);do{if((B|0)==75){if(v){break}ca=d;da=ca;c[da>>2]=ba;i=n;return}}while(0);c[j>>2]=c[j>>2]|2;ca=d;da=ca;c[da>>2]=ba;i=n;return}function t_c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function u_c(a){a=a|0;i=i;return}function v_c(a){a=a|0;i=i;return 2}function w_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];s_c(a,b,l,k,f,g,h,365264,365272|0);i=j;return}function x_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+1|0;s=q+1|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+t|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];s_c(b,d,m,l,g,h,j,s,q);i=k;return}function y_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;_Wc(n,f);f=n;n=c[f>>2]|0;if(!((c[91590]|0)==-1)){c[m>>2]=366360;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366360,m,770)}m=(c[366364>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}s=n;uVc(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=VYc(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function z_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;_Wc(n,f);f=n;n=c[f>>2]|0;if(!((c[91590]|0)==-1)){c[m>>2]=366360;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366360,m,770)}m=(c[366364>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}s=n;uVc(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=VYc(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function A_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;_Wc(m,f);f=m;m=c[f>>2]|0;if(!((c[91590]|0)==-1)){c[l>>2]=366360;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366360,l,770)}l=(c[366364>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;O3c(p);q=381920;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;O3c(p);q=381920;r=127;Td(o|0,q|0,r|0)}r=m;uVc(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=F_c(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function B_c(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;_Wc(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[91590]|0)==-1)){c[ba>>2]=366360;c[ba+4>>2]=769;c[ba+8>>2]=0;PVc(366360,ba,770)}ba=(c[366364>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;O3c(Ga);Ha=381920;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;O3c(Ga);Ha=381920;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;uVc(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=F_c(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=F_c(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=F_c(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];s_c(ra,d,y,x,g,h,j,365304,365309|0);c[ca>>2]=c[ra>>2];break};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=ie[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(VYc(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=F_c(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];ca=F_c(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((ca|0)<69){Ja=ca+2e3|0}else{Ja=(ca+ -69|0)>>>0<31?ca+1900|0:ca}c[j+20>>2]=Ja+ -1900;break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];D_c(d,j+8|0,e,B,h,Ia);break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=F_c(e,t,h,Ia,1)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Ha|4;break a}break};case 84:{Ha=e;c[va>>2]=c[Ha>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];s_c(ua,d,v,u,g,h,j,365312,365320|0);c[Ha>>2]=c[ua>>2];break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Ha=F_c(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<60){c[j+4>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 68:{ca=e;c[ha>>2]=c[ca>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];s_c(ga,d,L,K,g,h,j,365272,365280|0);c[ca>>2]=c[ga>>2];break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];E_c(0,e,m,h,Ia);break};case 88:{ca=d+8|0;Ha=ie[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Ka=Ha+1|0;La=Ha+1|0;Ma=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Ka=Da;La=Da;Ma=c[Ha+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];s_c(za,d,q,p,g,h,j,La,Ka+Ma|0);c[ca>>2]=c[za>>2];break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];s_c(ja,d,J,I,g,h,j,365280,365288|0);c[ca>>2]=c[ja>>2];break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[ca&63](b,d,s,r,g,h,j);i=l;return};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];ca=F_c(e,E,h,Ia,2)|0;Ha=c[h>>2]|0;if((Ha&4|0)==0&(ca|0)<13){c[j+16>>2]=ca+ -1;break a}else{c[h>>2]=Ha|4;break a}break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];C_c(0,e,C,h,Ia);break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];Ha=F_c(e,w,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Ha|0)<61){c[j>>2]=Ha;break a}else{c[h>>2]=ca|4;break a}break};case 99:{ca=d+8|0;Ha=ie[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Na=Ha+1|0;Oa=Ha+1|0;Pa=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Na=Da;Oa=Da;Pa=c[Ha+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];s_c(da,d,O,N,g,h,j,Oa,Na+Pa|0);c[ca>>2]=c[da>>2];break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];s_c(oa,d,A,z,g,h,j,365288,365299|0);c[ca>>2]=c[oa>>2];break};case 65:case 97:{ca=c[f>>2]|0;Ha=d+8|0;Da=ie[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(VYc(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=F_c(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function C_c(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;j=e;e=f;f=h+8|0;a:while(1){h=c[j>>2]|0;do{if((h|0)==0){k=0}else{if((c[h+12>>2]|0)!=(c[h+16>>2]|0)){k=h;break}if((ie[c[(c[h>>2]|0)+36>>2]&127](h)|0)==-1){c[j>>2]=0;k=0;break}else{k=c[j>>2]|0;break}}}while(0);h=(k|0)==0;l=c[e>>2]|0;do{if((l|0)==0){m=12}else{if((c[l+12>>2]|0)!=(c[l+16>>2]|0)){if(h){n=l;break}else{o=l;break a}}if((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1){c[e>>2]=0;m=12;break}else{if(h){n=l;break}else{o=l;break a}}}}while(0);if((m|0)==12){m=0;if(h){o=0;break}else{n=0}}l=c[j>>2]|0;p=c[l+12>>2]|0;if((p|0)==(c[l+16>>2]|0)){q=(ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)&255}else{q=a[p]|0}if(!(q<<24>>24>-1)){o=n;break}if((b[(c[f>>2]|0)+(q<<24>>24<<1)>>1]&8192)==0){o=n;break}p=c[j>>2]|0;l=p+12|0;r=c[l>>2]|0;if((r|0)==(c[p+16>>2]|0)){ie[c[(c[p>>2]|0)+40>>2]&127](p)|0;continue}else{c[l>>2]=r+1;continue}}n=c[j>>2]|0;do{if((n|0)==0){s=0}else{if((c[n+12>>2]|0)!=(c[n+16>>2]|0)){s=n;break}if((ie[c[(c[n>>2]|0)+36>>2]&127](n)|0)==-1){c[j>>2]=0;s=0;break}else{s=c[j>>2]|0;break}}}while(0);j=(s|0)==0;b:do{if((o|0)==0){m=32}else{do{if((c[o+12>>2]|0)==(c[o+16>>2]|0)){if(!((ie[c[(c[o>>2]|0)+36>>2]&127](o)|0)==-1)){break}c[e>>2]=0;m=32;break b}}while(0);if(!j){break}i=d;return}}while(0);do{if((m|0)==32){if(j){break}i=d;return}}while(0);c[g>>2]=c[g>>2]|2;i=d;return}function D_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=VYc(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function E_c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;b=i;h=d;d=c[h>>2]|0;do{if((d|0)==0){j=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){j=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[h>>2]=0;j=0;break}else{j=c[h>>2]|0;break}}}while(0);d=(j|0)==0;j=e;e=c[j>>2]|0;a:do{if((e|0)==0){k=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[j>>2]=0;k=11;break a}}while(0);if(d){l=e}else{k=12}}}while(0);if((k|0)==11){if(d){k=12}else{l=0}}if((k|0)==12){c[f>>2]=c[f>>2]|6;i=b;return}d=c[h>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){m=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{m=a[e]|0}if(!((le[c[(c[g>>2]|0)+36>>2]&63](g,m,0)|0)<<24>>24==37)){c[f>>2]=c[f>>2]|4;i=b;return}m=c[h>>2]|0;g=m+12|0;e=c[g>>2]|0;if((e|0)==(c[m+16>>2]|0)){ie[c[(c[m>>2]|0)+40>>2]&127](m)|0}else{c[g>>2]=e+1}e=c[h>>2]|0;do{if((e|0)==0){n=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){n=e;break}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[h>>2]=0;n=0;break}else{n=c[h>>2]|0;break}}}while(0);h=(n|0)==0;b:do{if((l|0)==0){k=31}else{do{if((c[l+12>>2]|0)==(c[l+16>>2]|0)){if(!((ie[c[(c[l>>2]|0)+36>>2]&127](l)|0)==-1)){break}c[j>>2]=0;k=31;break b}}while(0);if(!h){break}i=b;return}}while(0);do{if((k|0)==31){if(h){break}i=b;return}}while(0);c[f>>2]=c[f>>2]|2;i=b;return}function F_c(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;j=i;k=d;d=c[k>>2]|0;do{if((d|0)==0){l=0}else{if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){l=d;break}if((ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)==-1){c[k>>2]=0;l=0;break}else{l=c[k>>2]|0;break}}}while(0);d=(l|0)==0;l=e;e=c[l>>2]|0;a:do{if((e|0)==0){m=11}else{do{if((c[e+12>>2]|0)==(c[e+16>>2]|0)){if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){break}c[l>>2]=0;m=11;break a}}while(0);if(d){n=e}else{m=12}}}while(0);if((m|0)==11){if(d){m=12}else{n=0}}if((m|0)==12){c[f>>2]=c[f>>2]|6;o=0;i=j;return o|0}d=c[k>>2]|0;e=c[d+12>>2]|0;if((e|0)==(c[d+16>>2]|0)){p=(ie[c[(c[d>>2]|0)+36>>2]&127](d)|0)&255}else{p=a[e]|0}do{if(p<<24>>24>-1){e=g+8|0;if((b[(c[e>>2]|0)+(p<<24>>24<<1)>>1]&2048)==0){break}d=(le[c[(c[g>>2]|0)+36>>2]&63](g,p,0)|0)<<24>>24;q=c[k>>2]|0;r=q+12|0;s=c[r>>2]|0;if((s|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;t=h;u=n;v=n;w=d}else{c[r>>2]=s+1;t=h;u=n;v=n;w=d}while(1){x=w+ -48|0;d=t+ -1|0;s=c[k>>2]|0;do{if((s|0)==0){y=0}else{if((c[s+12>>2]|0)!=(c[s+16>>2]|0)){y=s;break}if((ie[c[(c[s>>2]|0)+36>>2]&127](s)|0)==-1){c[k>>2]=0;y=0;break}else{y=c[k>>2]|0;break}}}while(0);s=(y|0)==0;do{if((v|0)==0){z=u;A=0}else{if((c[v+12>>2]|0)!=(c[v+16>>2]|0)){z=u;A=v;break}if(!((ie[c[(c[v>>2]|0)+36>>2]&127](v)|0)==-1)){z=u;A=u;break}c[l>>2]=0;z=0;A=0}}while(0);B=c[k>>2]|0;if(!((s^(A|0)==0)&(d|0)>0)){m=40;break}r=c[B+12>>2]|0;if((r|0)==(c[B+16>>2]|0)){C=(ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)&255}else{C=a[r]|0}if(!(C<<24>>24>-1)){o=x;m=52;break}if((b[(c[e>>2]|0)+(C<<24>>24<<1)>>1]&2048)==0){o=x;m=52;break}r=((le[c[(c[g>>2]|0)+36>>2]&63](g,C,0)|0)<<24>>24)+(x*10|0)|0;q=c[k>>2]|0;D=q+12|0;E=c[D>>2]|0;if((E|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;F=d;u=z;v=A;w=r;t=F;continue}else{c[D>>2]=E+1;F=d;u=z;v=A;w=r;t=F;continue}}if((m|0)==40){do{if((B|0)==0){G=0}else{if((c[B+12>>2]|0)!=(c[B+16>>2]|0)){G=B;break}if((ie[c[(c[B>>2]|0)+36>>2]&127](B)|0)==-1){c[k>>2]=0;G=0;break}else{G=c[k>>2]|0;break}}}while(0);e=(G|0)==0;b:do{if((z|0)==0){m=50}else{do{if((c[z+12>>2]|0)==(c[z+16>>2]|0)){if(!((ie[c[(c[z>>2]|0)+36>>2]&127](z)|0)==-1)){break}c[l>>2]=0;m=50;break b}}while(0);if(e){o=x}else{break}i=j;return o|0}}while(0);do{if((m|0)==50){if(e){break}else{o=x}i=j;return o|0}}while(0);c[f>>2]=c[f>>2]|2;o=x;i=j;return o|0}else if((m|0)==52){i=j;return o|0}}}while(0);c[f>>2]=c[f>>2]|4;o=0;i=j;return o|0}function G_c(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0;l=i;i=i+64|0;m=l;n=l+8|0;o=l+16|0;p=l+32|0;q=l+40|0;r=l+48|0;s=l+56|0;_Wc(p,f);t=p;p=c[t>>2]|0;if(!((c[91588]|0)==-1)){c[o>>2]=366352;c[o+4>>2]=769;c[o+8>>2]=0;PVc(366352,o,770)}o=(c[366356>>2]|0)+ -1|0;u=c[p+8>>2]|0;if(!((c[p+12>>2]|0)-u>>2>>>0>o>>>0)){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}p=c[u+(o<<2)>>2]|0;if((p|0)==0){v=Ec(4)|0;w=v;O3c(w);x=381920;y=127;Td(v|0,x|0,y|0)}y=p;uVc(c[t>>2]|0)|0;c[g>>2]=0;t=d;a:do{if((j|0)==(k|0)){z=69}else{x=e;v=r;w=s;o=q;u=j;A=0;b:while(1){B=A;while(1){if((B|0)!=0){z=69;break a}C=c[t>>2]|0;do{if((C|0)==0){D=0;E=1}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[F>>2]|0}if(!((G|0)==-1)){D=C;E=0;break}c[t>>2]=0;D=0;E=1}}while(0);C=c[x>>2]|0;do{if((C|0)==0){z=22}else{F=c[C+12>>2]|0;if((F|0)==(c[C+16>>2]|0)){H=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{H=c[F>>2]|0}if((H|0)==-1){c[x>>2]=0;z=22;break}else{if(E){I=C;break}else{z=24;break b}}}}while(0);if((z|0)==22){z=0;if(E){z=24;break b}else{I=0}}if((le[c[(c[p>>2]|0)+52>>2]&63](y,c[u>>2]|0,0)|0)<<24>>24==37){z=26;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[u>>2]|0)|0){J=u;z=36;break}K=D+12|0;C=c[K>>2]|0;L=D+16|0;if((C|0)==(c[L>>2]|0)){M=ie[c[(c[D>>2]|0)+36>>2]&127](D)|0}else{M=c[C>>2]|0}C=xe[c[(c[p>>2]|0)+28>>2]&63](y,M)|0;if((C|0)==(xe[c[(c[p>>2]|0)+28>>2]&63](y,c[u>>2]|0)|0)){z=64;break}c[g>>2]=4;B=4}c:do{if((z|0)==26){z=0;B=u+4|0;if((B|0)==(k|0)){z=27;break b}C=le[c[(c[p>>2]|0)+52>>2]&63](y,c[B>>2]|0,0)|0;if(C<<24>>24==48|C<<24>>24==69){F=u+8|0;if((F|0)==(k|0)){z=30;break b}N=F;O=le[c[(c[p>>2]|0)+52>>2]&63](y,c[F>>2]|0,0)|0;P=C}else{N=B;O=C;P=0}C=c[(c[b>>2]|0)+36>>2]|0;c[v>>2]=D;c[w>>2]=I;B=n;F=r;c[B+0>>2]=c[F+0>>2];F=m;B=s;c[F+0>>2]=c[B+0>>2];we[C&3](q,b,n,m,f,g,h,O,P);c[t>>2]=c[o>>2];Q=N+4|0}else if((z|0)==36){while(1){z=0;C=J+4|0;if((C|0)==(k|0)){R=k;break}if(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,c[C>>2]|0)|0){J=C;z=36}else{R=C;break}}C=D;B=I;F=I;while(1){do{if((C|0)==0){S=0;T=1}else{U=c[C+12>>2]|0;if((U|0)==(c[C+16>>2]|0)){V=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{V=c[U>>2]|0}if(!((V|0)==-1)){S=C;T=0;break}c[t>>2]=0;S=0;T=1}}while(0);do{if((F|0)==0){W=B;z=51}else{U=c[F+12>>2]|0;if((U|0)==(c[F+16>>2]|0)){X=ie[c[(c[F>>2]|0)+36>>2]&127](F)|0}else{X=c[U>>2]|0}if((X|0)==-1){c[x>>2]=0;W=0;z=51;break}else{if(T^(B|0)==0){Y=B;Z=B;break}else{Q=R;break c}}}}while(0);if((z|0)==51){z=0;if(T){Q=R;break c}else{Y=W;Z=0}}U=S+12|0;_=c[U>>2]|0;$=S+16|0;if((_|0)==(c[$>>2]|0)){aa=ie[c[(c[S>>2]|0)+36>>2]&127](S)|0}else{aa=c[_>>2]|0}if(!(le[c[(c[p>>2]|0)+12>>2]&63](y,8192,aa)|0)){Q=R;break c}_=c[U>>2]|0;if((_|0)==(c[$>>2]|0)){ie[c[(c[S>>2]|0)+40>>2]&127](S)|0;C=S;B=Y;F=Z;continue}else{c[U>>2]=_+4;C=S;B=Y;F=Z;continue}}}else if((z|0)==64){z=0;F=c[K>>2]|0;if((F|0)==(c[L>>2]|0)){ie[c[(c[D>>2]|0)+40>>2]&127](D)|0}else{c[K>>2]=F+4}Q=u+4|0}}while(0);if((Q|0)==(k|0)){z=69;break a}u=Q;A=c[g>>2]|0}if((z|0)==24){c[g>>2]=4;ba=D;break}else if((z|0)==27){c[g>>2]=4;ba=D;break}else if((z|0)==30){c[g>>2]=4;ba=D;break}}}while(0);if((z|0)==69){ba=c[t>>2]|0}t=d;do{if((ba|0)==0){ca=0;da=1}else{d=c[ba+12>>2]|0;if((d|0)==(c[ba+16>>2]|0)){ea=ie[c[(c[ba>>2]|0)+36>>2]&127](ba)|0}else{ea=c[d>>2]|0}if(!((ea|0)==-1)){ca=ba;da=0;break}c[t>>2]=0;ca=0;da=1}}while(0);t=e;e=c[t>>2]|0;do{if((e|0)==0){z=82}else{ba=c[e+12>>2]|0;if((ba|0)==(c[e+16>>2]|0)){fa=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{fa=c[ba>>2]|0}if((fa|0)==-1){c[t>>2]=0;z=82;break}if(!da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);do{if((z|0)==82){if(da){break}ga=a;ha=ga;c[ha>>2]=ca;i=l;return}}while(0);c[g>>2]=c[g>>2]|2;ga=a;ha=ga;c[ha>>2]=ca;i=l;return}function H_c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function I_c(a){a=a|0;i=i;return}function J_c(a){a=a|0;i=i;return 2}function K_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;c[m>>2]=c[d>>2];c[n>>2]=c[e>>2];e=l;d=m;c[e+0>>2]=c[d+0>>2];d=k;e=n;c[d+0>>2]=c[e+0>>2];G_c(a,b,l,k,f,g,h,365416,365448|0);i=j;return}function L_c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=d+8|0;q=ie[c[(c[p>>2]|0)+20>>2]&127](p)|0;c[n>>2]=c[e>>2];c[o>>2]=c[f>>2];f=a[q]|0;if((f&1)==0){r=q+4|0;s=q+4|0;t=(f&255)>>>1}else{f=c[q+8>>2]|0;r=f;s=f;t=c[q+4>>2]|0}q=r+(t<<2)|0;t=m;r=n;c[t+0>>2]=c[r+0>>2];r=l;t=o;c[r+0>>2]=c[t+0>>2];G_c(b,d,m,l,g,h,j,s,q);i=k;return}function M_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;_Wc(n,f);f=n;n=c[f>>2]|0;if(!((c[91588]|0)==-1)){c[m>>2]=366352;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366352,m,770)}m=(c[366356>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}s=n;uVc(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[c[e>>2]>>2]&127](e)|0;c[l>>2]=f;f=b+168|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=sZc(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=168){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+24>>2]=((g|0)/12|0|0)%7|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function N_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;i=i+40|0;k=j;l=j+8|0;m=j+16|0;n=j+32|0;_Wc(n,f);f=n;n=c[f>>2]|0;if(!((c[91588]|0)==-1)){c[m>>2]=366352;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366352,m,770)}m=(c[366356>>2]|0)+ -1|0;o=c[n+8>>2]|0;if(!((c[n+12>>2]|0)-o>>2>>>0>m>>>0)){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}n=c[o+(m<<2)>>2]|0;if((n|0)==0){p=Ec(4)|0;q=p;O3c(q);r=381920;s=127;Td(p|0,r|0,s|0)}s=n;uVc(c[f>>2]|0)|0;f=c[e>>2]|0;e=b+8|0;b=ie[c[(c[e>>2]|0)+4>>2]&127](e)|0;c[l>>2]=f;f=b+288|0;e=k;n=l;c[e+0>>2]=c[n+0>>2];n=sZc(d,k,b,f,s,g,0)|0;g=n-b|0;if((g|0)>=288){t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}c[h+16>>2]=((g|0)/12|0|0)%12|0;t=d;u=t;v=c[u>>2]|0;w=a;x=w;c[x>>2]=v;i=j;return}function O_c(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;b=i;i=i+40|0;j=b;k=b+8|0;l=b+16|0;m=b+32|0;_Wc(m,f);f=m;m=c[f>>2]|0;if(!((c[91588]|0)==-1)){c[l>>2]=366352;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366352,l,770)}l=(c[366356>>2]|0)+ -1|0;n=c[m+8>>2]|0;if(!((c[m+12>>2]|0)-n>>2>>>0>l>>>0)){o=Ec(4)|0;p=o;O3c(p);q=381920;r=127;Td(o|0,q|0,r|0)}m=c[n+(l<<2)>>2]|0;if((m|0)==0){o=Ec(4)|0;p=o;O3c(p);q=381920;r=127;Td(o|0,q|0,r|0)}r=m;uVc(c[f>>2]|0)|0;f=h+20|0;c[k>>2]=c[e>>2];e=j;h=k;c[e+0>>2]=c[h+0>>2];h=T_c(d,j,g,r,4)|0;if((c[g>>2]&4|0)!=0){s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}if((h|0)<69){x=h+2e3|0}else{x=(h+ -69|0)>>>0<31?h+1900|0:h}c[f>>2]=x+ -1900;s=d;t=s;u=c[t>>2]|0;v=a;w=v;c[w>>2]=u;i=b;return}function P_c(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0;l=i;i=i+576|0;m=l;n=l+8|0;o=l+16|0;p=l+24|0;q=l+32|0;r=l+40|0;s=l+48|0;t=l+56|0;u=l+64|0;v=l+72|0;w=l+80|0;x=l+88|0;y=l+96|0;z=l+104|0;A=l+112|0;B=l+120|0;C=l+128|0;D=l+136|0;E=l+144|0;F=l+152|0;G=l+160|0;H=l+168|0;I=l+176|0;J=l+184|0;K=l+192|0;L=l+200|0;M=l+208|0;N=l+216|0;O=l+224|0;P=l+232|0;Q=l+240|0;R=l+248|0;S=l+256|0;T=l+264|0;U=l+272|0;V=l+280|0;W=l+288|0;X=l+296|0;Y=l+304|0;Z=l+312|0;_=l+320|0;$=l+328|0;aa=l+336|0;ba=l+344|0;ca=l+360|0;da=l+368|0;ea=l+376|0;fa=l+384|0;ga=l+392|0;ha=l+400|0;ia=l+408|0;ja=l+416|0;ka=l+424|0;la=l+432|0;ma=l+440|0;na=l+448|0;oa=l+456|0;pa=l+464|0;qa=l+472|0;ra=l+480|0;sa=l+488|0;ta=l+496|0;ua=l+504|0;va=l+512|0;wa=l+520|0;xa=l+528|0;ya=l+536|0;za=l+544|0;Aa=l+552|0;Ba=l+560|0;Ca=l+568|0;c[h>>2]=0;_Wc(ca,g);Da=ca;ca=c[Da>>2]|0;if(!((c[91588]|0)==-1)){c[ba>>2]=366352;c[ba+4>>2]=769;c[ba+8>>2]=0;PVc(366352,ba,770)}ba=(c[366356>>2]|0)+ -1|0;Ea=c[ca+8>>2]|0;if(!((c[ca+12>>2]|0)-Ea>>2>>>0>ba>>>0)){Fa=Ec(4)|0;Ga=Fa;O3c(Ga);Ha=381920;Ia=127;Td(Fa|0,Ha|0,Ia|0)}ca=c[Ea+(ba<<2)>>2]|0;if((ca|0)==0){Fa=Ec(4)|0;Ga=Fa;O3c(Ga);Ha=381920;Ia=127;Td(Fa|0,Ha|0,Ia|0)}Ia=ca;uVc(c[Da>>2]|0)|0;a:do{switch(k<<24>>24|0){case 68:{Da=e;c[ha>>2]=c[Da>>2];c[ia>>2]=c[f>>2];c[L+0>>2]=c[ha+0>>2];c[K+0>>2]=c[ia+0>>2];G_c(ga,d,L,K,g,h,j,365448,365480|0);c[Da>>2]=c[ga>>2];break};case 101:case 100:{Da=j+12|0;c[_>>2]=c[f>>2];c[M+0>>2]=c[_+0>>2];ca=T_c(e,M,h,Ia,2)|0;Ha=c[h>>2]|0;do{if((Ha&4|0)==0){if(!((ca+ -1|0)>>>0<31)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Ha|4;break};case 99:{ca=d+8|0;Da=ie[c[(c[ca>>2]|0)+12>>2]&127](ca)|0;ca=e;c[ea>>2]=c[ca>>2];c[fa>>2]=c[f>>2];Fa=a[Da]|0;if((Fa&1)==0){Ja=Da+4|0;Ka=Da+4|0;La=(Fa&255)>>>1}else{Fa=c[Da+8>>2]|0;Ja=Fa;Ka=Fa;La=c[Da+4>>2]|0}c[O+0>>2]=c[ea+0>>2];c[N+0>>2]=c[fa+0>>2];G_c(da,d,O,N,g,h,j,Ka,Ja+(La<<2)|0);c[ca>>2]=c[da>>2];break};case 72:{c[Z>>2]=c[f>>2];c[H+0>>2]=c[Z+0>>2];ca=T_c(e,H,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<24){c[j+8>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 73:{Da=j+8|0;c[Y>>2]=c[f>>2];c[G+0>>2]=c[Y+0>>2];ca=T_c(e,G,h,Ia,2)|0;Fa=c[h>>2]|0;do{if((Fa&4|0)==0){if(!((ca+ -1|0)>>>0<12)){break}c[Da>>2]=ca;break a}}while(0);c[h>>2]=Fa|4;break};case 83:{c[U>>2]=c[f>>2];c[w+0>>2]=c[U+0>>2];ca=T_c(e,w,h,Ia,2)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<61){c[j>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 112:{c[na>>2]=c[f>>2];c[B+0>>2]=c[na+0>>2];R_c(d,j+8|0,e,B,h,Ia);break};case 109:{c[W>>2]=c[f>>2];c[E+0>>2]=c[W+0>>2];Da=T_c(e,E,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<13){c[j+16>>2]=Da+ -1;break a}else{c[h>>2]=ca|4;break a}break};case 82:{ca=e;c[sa>>2]=c[ca>>2];c[ta>>2]=c[f>>2];c[y+0>>2]=c[sa+0>>2];c[x+0>>2]=c[ta+0>>2];G_c(ra,d,y,x,g,h,j,365560,365580|0);c[ca>>2]=c[ra>>2];break};case 114:{ca=e;c[pa>>2]=c[ca>>2];c[qa>>2]=c[f>>2];c[A+0>>2]=c[pa+0>>2];c[z+0>>2]=c[qa+0>>2];G_c(oa,d,A,z,g,h,j,365512,365556|0);c[ca>>2]=c[oa>>2];break};case 120:{ca=c[(c[d>>2]|0)+20>>2]|0;c[xa>>2]=c[e>>2];c[ya>>2]=c[f>>2];c[s+0>>2]=c[xa+0>>2];c[r+0>>2]=c[ya+0>>2];ue[ca&63](b,d,s,r,g,h,j);i=l;return};case 104:case 66:case 98:{ca=c[f>>2]|0;Da=d+8|0;Ha=ie[c[(c[Da>>2]|0)+4>>2]&127](Da)|0;c[$>>2]=ca;c[P+0>>2]=c[$+0>>2];ca=(sZc(e,P,Ha,Ha+288|0,Ia,h,0)|0)-Ha|0;if((ca|0)>=288){break a}c[j+16>>2]=((ca|0)/12|0|0)%12|0;break};case 88:{ca=d+8|0;Ha=ie[c[(c[ca>>2]|0)+24>>2]&127](ca)|0;ca=e;c[Aa>>2]=c[ca>>2];c[Ba>>2]=c[f>>2];Da=a[Ha]|0;if((Da&1)==0){Ma=Ha+4|0;Na=Ha+4|0;Oa=(Da&255)>>>1}else{Da=c[Ha+8>>2]|0;Ma=Da;Na=Da;Oa=c[Ha+4>>2]|0}c[q+0>>2]=c[Aa+0>>2];c[p+0>>2]=c[Ba+0>>2];G_c(za,d,q,p,g,h,j,Na,Ma+(Oa<<2)|0);c[ca>>2]=c[za>>2];break};case 65:case 97:{ca=c[f>>2]|0;Ha=d+8|0;Da=ie[c[c[Ha>>2]>>2]&127](Ha)|0;c[aa>>2]=ca;c[Q+0>>2]=c[aa+0>>2];ca=(sZc(e,Q,Da,Da+168|0,Ia,h,0)|0)-Da|0;if((ca|0)>=168){break a}c[j+24>>2]=((ca|0)/12|0|0)%7|0;break};case 119:{c[T>>2]=c[f>>2];c[t+0>>2]=c[T+0>>2];ca=T_c(e,t,h,Ia,1)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<7){c[j+24>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 121:{c[S>>2]=c[f>>2];c[o+0>>2]=c[S+0>>2];Da=T_c(e,o,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}if((Da|0)<69){Pa=Da+2e3|0}else{Pa=(Da+ -69|0)>>>0<31?Da+1900|0:Da}c[j+20>>2]=Pa+ -1900;break};case 77:{c[V>>2]=c[f>>2];c[D+0>>2]=c[V+0>>2];Da=T_c(e,D,h,Ia,2)|0;ca=c[h>>2]|0;if((ca&4|0)==0&(Da|0)<60){c[j+4>>2]=Da;break a}else{c[h>>2]=ca|4;break a}break};case 70:{ca=e;c[ka>>2]=c[ca>>2];c[la>>2]=c[f>>2];c[J+0>>2]=c[ka+0>>2];c[I+0>>2]=c[la+0>>2];G_c(ja,d,J,I,g,h,j,365480,365512|0);c[ca>>2]=c[ja>>2];break};case 116:case 110:{c[ma>>2]=c[f>>2];c[C+0>>2]=c[ma+0>>2];Q_c(0,e,C,h,Ia);break};case 89:{c[R>>2]=c[f>>2];c[n+0>>2]=c[R+0>>2];ca=T_c(e,n,h,Ia,4)|0;if((c[h>>2]&4|0)!=0){break a}c[j+20>>2]=ca+ -1900;break};case 37:{c[Ca>>2]=c[f>>2];c[m+0>>2]=c[Ca+0>>2];S_c(0,e,m,h,Ia);break};case 106:{c[X>>2]=c[f>>2];c[F+0>>2]=c[X+0>>2];ca=T_c(e,F,h,Ia,3)|0;Da=c[h>>2]|0;if((Da&4|0)==0&(ca|0)<366){c[j+28>>2]=ca;break a}else{c[h>>2]=Da|4;break a}break};case 84:{Da=e;c[va>>2]=c[Da>>2];c[wa>>2]=c[f>>2];c[v+0>>2]=c[va+0>>2];c[u+0>>2]=c[wa+0>>2];G_c(ua,d,v,u,g,h,j,365584,365616|0);c[Da>>2]=c[ua>>2];break};default:{c[h>>2]=c[h>>2]|4}}}while(0);c[b>>2]=c[e>>2];i=l;return}function Q_c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;a=i;g=b;b=d;a:while(1){d=c[g>>2]|0;do{if((d|0)==0){h=1}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){k=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);d=c[b>>2]|0;do{if((d|0)==0){l=15}else{j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[j>>2]|0}if((m|0)==-1){c[b>>2]=0;l=15;break}else{if(h){n=d;break}else{o=d;break a}}}}while(0);if((l|0)==15){l=0;if(h){o=0;break}else{n=0}}d=c[g>>2]|0;j=c[d+12>>2]|0;if((j|0)==(c[d+16>>2]|0)){p=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{p=c[j>>2]|0}if(!(le[c[(c[f>>2]|0)+12>>2]&63](f,8192,p)|0)){o=n;break}j=c[g>>2]|0;d=j+12|0;q=c[d>>2]|0;if((q|0)==(c[j+16>>2]|0)){ie[c[(c[j>>2]|0)+40>>2]&127](j)|0;continue}else{c[d>>2]=q+4;continue}}n=c[g>>2]|0;do{if((n|0)==0){r=1}else{p=c[n+12>>2]|0;if((p|0)==(c[n+16>>2]|0)){s=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{s=c[p>>2]|0}if((s|0)==-1){c[g>>2]=0;r=1;break}else{r=(c[g>>2]|0)==0;break}}}while(0);do{if((o|0)==0){l=37}else{g=c[o+12>>2]|0;if((g|0)==(c[o+16>>2]|0)){t=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{t=c[g>>2]|0}if((t|0)==-1){c[b>>2]=0;l=37;break}if(!r){break}i=a;return}}while(0);do{if((l|0)==37){if(r){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function R_c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+16|0;k=j;l=j+8|0;m=b+8|0;b=ie[c[(c[m>>2]|0)+8>>2]&127](m)|0;m=a[b]|0;if((m&1)==0){n=(m&255)>>>1}else{n=c[b+4>>2]|0}m=a[b+12|0]|0;if((m&1)==0){o=(m&255)>>>1}else{o=c[b+16>>2]|0}if((n|0)==(0-o|0)){c[g>>2]=c[g>>2]|4;i=j;return}c[l>>2]=c[f>>2];f=b+24|0;o=k;n=l;c[o+0>>2]=c[n+0>>2];n=sZc(e,k,b,f,h,g,0)|0;g=n-b|0;do{if((n|0)==(b|0)){if((c[d>>2]|0)!=12){break}c[d>>2]=0;i=j;return}}while(0);if((g|0)!=12){i=j;return}g=c[d>>2]|0;if((g|0)>=12){i=j;return}c[d>>2]=g+12;i=j;return}function S_c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;a=i;g=b;b=c[g>>2]|0;do{if((b|0)==0){h=1}else{j=c[b+12>>2]|0;if((j|0)==(c[b+16>>2]|0)){k=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{k=c[j>>2]|0}if((k|0)==-1){c[g>>2]=0;h=1;break}else{h=(c[g>>2]|0)==0;break}}}while(0);k=d;d=c[k>>2]|0;do{if((d|0)==0){l=14}else{b=c[d+12>>2]|0;if((b|0)==(c[d+16>>2]|0)){m=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{m=c[b>>2]|0}if((m|0)==-1){c[k>>2]=0;l=14;break}else{if(h){n=d;break}else{l=16;break}}}}while(0);if((l|0)==14){if(h){l=16}else{n=0}}if((l|0)==16){c[e>>2]=c[e>>2]|6;i=a;return}h=c[g>>2]|0;d=c[h+12>>2]|0;if((d|0)==(c[h+16>>2]|0)){o=ie[c[(c[h>>2]|0)+36>>2]&127](h)|0}else{o=c[d>>2]|0}if(!((le[c[(c[f>>2]|0)+52>>2]&63](f,o,0)|0)<<24>>24==37)){c[e>>2]=c[e>>2]|4;i=a;return}o=c[g>>2]|0;f=o+12|0;d=c[f>>2]|0;if((d|0)==(c[o+16>>2]|0)){ie[c[(c[o>>2]|0)+40>>2]&127](o)|0}else{c[f>>2]=d+4}d=c[g>>2]|0;do{if((d|0)==0){p=1}else{f=c[d+12>>2]|0;if((f|0)==(c[d+16>>2]|0)){q=ie[c[(c[d>>2]|0)+36>>2]&127](d)|0}else{q=c[f>>2]|0}if((q|0)==-1){c[g>>2]=0;p=1;break}else{p=(c[g>>2]|0)==0;break}}}while(0);do{if((n|0)==0){l=38}else{g=c[n+12>>2]|0;if((g|0)==(c[n+16>>2]|0)){r=ie[c[(c[n>>2]|0)+36>>2]&127](n)|0}else{r=c[g>>2]|0}if((r|0)==-1){c[k>>2]=0;l=38;break}if(!p){break}i=a;return}}while(0);do{if((l|0)==38){if(p){break}i=a;return}}while(0);c[e>>2]=c[e>>2]|2;i=a;return}function T_c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;g=i;h=a;a=c[h>>2]|0;do{if((a|0)==0){j=1}else{k=c[a+12>>2]|0;if((k|0)==(c[a+16>>2]|0)){l=ie[c[(c[a>>2]|0)+36>>2]&127](a)|0}else{l=c[k>>2]|0}if((l|0)==-1){c[h>>2]=0;j=1;break}else{j=(c[h>>2]|0)==0;break}}}while(0);l=b;b=c[l>>2]|0;do{if((b|0)==0){m=14}else{a=c[b+12>>2]|0;if((a|0)==(c[b+16>>2]|0)){n=ie[c[(c[b>>2]|0)+36>>2]&127](b)|0}else{n=c[a>>2]|0}if((n|0)==-1){c[l>>2]=0;m=14;break}else{if(j){o=b;break}else{m=16;break}}}}while(0);if((m|0)==14){if(j){m=16}else{o=0}}if((m|0)==16){c[d>>2]=c[d>>2]|6;p=0;i=g;return p|0}j=c[h>>2]|0;b=c[j+12>>2]|0;if((b|0)==(c[j+16>>2]|0)){q=ie[c[(c[j>>2]|0)+36>>2]&127](j)|0}else{q=c[b>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,q)|0)){c[d>>2]=c[d>>2]|4;p=0;i=g;return p|0}b=(le[c[(c[e>>2]|0)+52>>2]&63](e,q,0)|0)<<24>>24;q=c[h>>2]|0;j=q+12|0;n=c[j>>2]|0;if((n|0)==(c[q+16>>2]|0)){ie[c[(c[q>>2]|0)+40>>2]&127](q)|0;r=f;s=o;t=o;u=b}else{c[j>>2]=n+4;r=f;s=o;t=o;u=b}while(1){v=u+ -48|0;b=r+ -1|0;o=c[h>>2]|0;do{if((o|0)==0){w=1}else{f=c[o+12>>2]|0;if((f|0)==(c[o+16>>2]|0)){x=ie[c[(c[o>>2]|0)+36>>2]&127](o)|0}else{x=c[f>>2]|0}if((x|0)==-1){c[h>>2]=0;w=1;break}else{w=(c[h>>2]|0)==0;break}}}while(0);do{if((t|0)==0){y=s;z=0;A=1}else{o=c[t+12>>2]|0;if((o|0)==(c[t+16>>2]|0)){B=ie[c[(c[t>>2]|0)+36>>2]&127](t)|0}else{B=c[o>>2]|0}if((B|0)==-1){c[l>>2]=0;y=0;z=0;A=1;break}else{y=s;z=s;A=(s|0)==0;break}}}while(0);C=c[h>>2]|0;if(!((w^A)&(b|0)>0)){break}o=c[C+12>>2]|0;if((o|0)==(c[C+16>>2]|0)){D=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{D=c[o>>2]|0}if(!(le[c[(c[e>>2]|0)+12>>2]&63](e,2048,D)|0)){p=v;m=63;break}o=((le[c[(c[e>>2]|0)+52>>2]&63](e,D,0)|0)<<24>>24)+(v*10|0)|0;f=c[h>>2]|0;n=f+12|0;j=c[n>>2]|0;if((j|0)==(c[f+16>>2]|0)){ie[c[(c[f>>2]|0)+40>>2]&127](f)|0;E=b;s=y;t=z;u=o;r=E;continue}else{c[n>>2]=j+4;E=b;s=y;t=z;u=o;r=E;continue}}if((m|0)==63){i=g;return p|0}do{if((C|0)==0){F=1}else{E=c[C+12>>2]|0;if((E|0)==(c[C+16>>2]|0)){G=ie[c[(c[C>>2]|0)+36>>2]&127](C)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[h>>2]=0;F=1;break}else{F=(c[h>>2]|0)==0;break}}}while(0);do{if((y|0)==0){m=60}else{h=c[y+12>>2]|0;if((h|0)==(c[y+16>>2]|0)){H=ie[c[(c[y>>2]|0)+36>>2]&127](y)|0}else{H=c[h>>2]|0}if((H|0)==-1){c[l>>2]=0;m=60;break}if(F){p=v}else{break}i=g;return p|0}}while(0);do{if((m|0)==60){if(F){break}else{p=v}i=g;return p|0}}while(0);c[d>>2]=c[d>>2]|2;p=v;i=g;return p|0}function U_c(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);if((f|0)==(c[91562]|0)){g=b;p4c(g);i=d;return}ac(c[e>>2]|0);g=b;p4c(g);i=d;return}function V_c(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);if((b|0)==(c[91562]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function W_c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;g=i;i=i+112|0;f=g;l=g+8|0;m=l;n=f;a[n]=37;o=f+1|0;a[o]=j;p=f+2|0;a[p]=k;a[f+3|0]=0;if(!(k<<24>>24==0)){a[o]=k;a[p]=j}j=Sc(m|0,100,n|0,h|0,c[d+8>>2]|0)|0;d=l+j|0;l=c[e>>2]|0;if((j|0)==0){q=l;r=b;s=r;c[s>>2]=q;i=g;return}else{t=m;u=l;v=l}while(1){l=a[t]|0;do{if((v|0)==0){w=u;x=0}else{m=v+24|0;j=c[m>>2]|0;if((j|0)==(c[v+28>>2]|0)){e=(xe[c[(c[v>>2]|0)+52>>2]&63](v,l&255)|0)==-1;w=e?0:u;x=e?0:v;break}else{c[m>>2]=j+1;a[j]=l;w=u;x=v;break}}}while(0);l=t+1|0;if((l|0)==(d|0)){q=w;break}else{t=l;u=w;v=x}}r=b;s=r;c[s>>2]=q;i=g;return}function X_c(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+8|0;f=c[e>>2]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);if((f|0)==(c[91562]|0)){g=b;p4c(g);i=d;return}ac(c[e>>2]|0);g=b;p4c(g);i=d;return}function Y_c(b){b=b|0;var d=0,e=0;d=i;e=b+8|0;b=c[e>>2]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);if((b|0)==(c[91562]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function Z_c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+408|0;e=f;k=f+400|0;l=e;c[k>>2]=e+400;__c(b+8|0,l,k,g,h,j);j=c[k>>2]|0;k=c[d>>2]|0;if((l|0)==(j|0)){m=k;n=a;o=n;c[o>>2]=m;i=f;return}else{p=l;q=k;r=k}while(1){k=c[p>>2]|0;if((q|0)==0){s=r;t=0}else{l=q+24|0;d=c[l>>2]|0;if((d|0)==(c[q+28>>2]|0)){u=xe[c[(c[q>>2]|0)+52>>2]&63](q,k)|0}else{c[l>>2]=d+4;c[d>>2]=k;u=k}k=(u|0)==-1;s=k?0:r;t=k?0:q}k=p+4|0;if((k|0)==(j|0)){m=s;break}else{p=k;q=t;r=s}}n=a;o=n;c[o>>2]=m;i=f;return}function __c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+120|0;k=j;l=j+112|0;m=i;i=i+8|0;n=j+8|0;o=k;a[o]=37;p=k+1|0;a[p]=g;q=k+2|0;a[q]=h;a[k+3|0]=0;if(!(h<<24>>24==0)){a[p]=h;a[q]=g}g=b;Sc(n|0,100,o|0,f|0,c[g>>2]|0)|0;f=l;c[f>>2]=0;c[f+4>>2]=0;c[m>>2]=n;n=(c[e>>2]|0)-d>>2;f=Lc(c[g>>2]|0)|0;g=k3c(d,m,n,l)|0;if((f|0)!=0){Lc(f|0)|0}if((g|0)==-1){W$c(367240)}else{c[e>>2]=d+(g<<2);i=j;return}}function $_c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function a$c(a){a=a|0;i=i;return}function b$c(a){a=a|0;i=i;return 127}function c$c(a){a=a|0;i=i;return 127}function d$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function e$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function f$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function g$c(a,b){a=a|0;b=b|0;b=i;_Vc(a,1,45);i=b;return}function h$c(a){a=a|0;i=i;return 0}function i$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function j$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function k$c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function l$c(a){a=a|0;i=i;return}function m$c(a){a=a|0;i=i;return 127}function n$c(a){a=a|0;i=i;return 127}function o$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function p$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function q$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function r$c(a,b){a=a|0;b=b|0;b=i;_Vc(a,1,45);i=b;return}function s$c(a){a=a|0;i=i;return 0}function t$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function u$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function v$c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function w$c(a){a=a|0;i=i;return}function x$c(a){a=a|0;i=i;return 2147483647}function y$c(a){a=a|0;i=i;return 2147483647}function z$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function A$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function B$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function C$c(a,b){a=a|0;b=b|0;b=i;FWc(a,1,45);i=b;return}function D$c(a){a=a|0;i=i;return 0}function E$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function F$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function G$c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function H$c(a){a=a|0;i=i;return}function I$c(a){a=a|0;i=i;return 2147483647}function J$c(a){a=a|0;i=i;return 2147483647}function K$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function L$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function M$c(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function N$c(a,b){a=a|0;b=b|0;b=i;FWc(a,1,45);i=b;return}function O$c(a){a=a|0;i=i;return 0}function P$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function Q$c(b,c){b=b|0;c=c|0;c=b;a[c]=67109634;a[c+1|0]=262147;a[c+2|0]=1024;a[c+3|0]=4;i=i;return}function R$c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function S$c(a){a=a|0;i=i;return}function T$c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+104|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=771;y=o+100|0;_Wc(r,h);o=r;z=c[o>>2]|0;if(!((c[91590]|0)==-1)){c[n>>2]=366360;c[n+4>>2]=769;c[n+8>>2]=0;PVc(366360,n,770)}n=(c[366364>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=V$c(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+32>>2]&63](E,365976,365986|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>98){l=h4c(g+2|0)|0;if((l|0)!=0){F=l;G=l;break}u4c()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+10|0;l=u;h=H;t=r;while(1){C=a[t]|0;n=y;while(1){A=n+1|0;if((a[n]|0)==C<<24>>24){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[365976+(I-l)|0]|0;n=t+1|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,365992,m|0)|0)!=1){t=Ec(8)|0;AVc(t,366e3);Td(t|0,363352,42)}if((F|0)==0){break}i4c(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){K=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){K=e;break}c[F>>2]=0;K=0}}while(0);F=(K|0)==0;e=c[D>>2]|0;do{if((e|0)==0){L=31}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){if(F){break}else{L=33;break}}if((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1){c[D>>2]=0;L=31;break}else{if(F){break}else{L=33;break}}}}while(0);if((L|0)==31){if(F){L=33}}if((L|0)==33){c[j>>2]=c[j>>2]|2}c[b>>2]=K;uVc(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&1023](o);i=d;return}function U$c(a){a=a|0;i=i;return}function V$c(e,f,g,h,j,k,l,m,n,o,p){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0;q=i;i=i+408|0;r=q;s=q+400|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;D=r;c[s>>2]=0;E=w;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=x;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=y;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=z;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;E=A;c[E+0>>2]=0;c[E+4>>2]=0;c[E+8>>2]=0;Z$c(g,h,t,u,v,w,x,y,z,B);t=n;c[o>>2]=c[t>>2];h=e;e=f;f=m+8|0;m=z+1|0;g=z+4|0;E=z+8|0;F=y+1|0;G=y+4|0;H=y+8|0;I=(j&512|0)!=0;j=x+1|0;J=x+8|0;K=x+4|0;L=A+1|0;M=A+8|0;N=A+4|0;O=s+3|0;P=n+4|0;n=w+4|0;Q=r+400|0;r=D;R=D;D=p;p=0;S=0;T=771;a:while(1){U=c[h>>2]|0;do{if((U|0)==0){V=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){V=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;V=0;break}else{V=c[h>>2]|0;break}}}while(0);U=(V|0)==0;W=c[e>>2]|0;do{if((W|0)==0){X=12}else{if((c[W+12>>2]|0)!=(c[W+16>>2]|0)){if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}if((ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)==-1){c[e>>2]=0;X=12;break}else{if(U){Y=W;break}else{Z=R;_=r;$=S;aa=T;X=269;break a}}}}while(0);if((X|0)==12){X=0;if(U){Z=R;_=r;$=S;aa=T;X=269;break}else{Y=0}}b:do{switch(a[s+p|0]|0){case 4:{W=D;ba=R;ca=r;da=Q;ea=0;fa=T;c:while(1){ga=c[h>>2]|0;do{if((ga|0)==0){ha=0}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){ha=ga;break}if((ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[h>>2]=0;ha=0;break}else{ha=c[h>>2]|0;break}}}while(0);ga=(ha|0)==0;ia=c[e>>2]|0;do{if((ia|0)==0){X=173}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){if(ga){break}else{break c}}if((ie[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[e>>2]=0;X=173;break}else{if(ga){break}else{break c}}}}while(0);if((X|0)==173){X=0;if(ga){break}}ia=c[h>>2]|0;ja=c[ia+12>>2]|0;if((ja|0)==(c[ia+16>>2]|0)){ka=(ie[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255}else{ka=a[ja]|0}do{if(ka<<24>>24>-1){if((b[(c[f>>2]|0)+(ka<<24>>24<<1)>>1]&2048)==0){X=189;break}ja=c[o>>2]|0;if((ja|0)==(W|0)){ia=(c[P>>2]|0)!=771;la=c[t>>2]|0;ma=W-la|0;na=ma>>>0<2147483647?ma<<1:-1;oa=k4c(ia?la:0,na)|0;if((oa|0)==0){X=182;break a}do{if(ia){c[t>>2]=oa;pa=oa}else{la=c[t>>2]|0;c[t>>2]=oa;if((la|0)==0){pa=oa;break}fe[c[P>>2]&1023](la);pa=c[t>>2]|0}}while(0);c[P>>2]=746;oa=pa+ma|0;c[o>>2]=oa;qa=oa;ra=(c[t>>2]|0)+na|0}else{qa=ja;ra=W}c[o>>2]=qa+1;a[qa]=ka;sa=ra;ta=ba;ua=ca;va=da;wa=ea+1|0;xa=fa}else{X=189}}while(0);if((X|0)==189){X=0;ga=a[w]|0;if((ga&1)==0){ya=(ga&255)>>>1}else{ya=c[n>>2]|0}if((ya|0)==0|(ea|0)==0){break}if(!(ka<<24>>24==(a[v]|0))){break}if((ca|0)==(da|0)){ga=ca-ba|0;oa=ga>>>0<2147483647?ga<<1:-1;if((fa|0)==771){za=0}else{za=ba}ia=k4c(za,oa)|0;if((ia|0)==0){X=198;break a}Aa=ia;Ba=ia+(ga>>2<<2)|0;Ca=ia+(oa>>>2<<2)|0;Da=746}else{Aa=ba;Ba=ca;Ca=da;Da=fa}c[Ba>>2]=ea;sa=W;ta=Aa;ua=Ba+4|0;va=Ca;wa=0;xa=Da}oa=c[h>>2]|0;ia=oa+12|0;ga=c[ia>>2]|0;if((ga|0)==(c[oa+16>>2]|0)){ie[c[(c[oa>>2]|0)+40>>2]&127](oa)|0;W=sa;ba=ta;ca=ua;da=va;ea=wa;fa=xa;continue}else{c[ia>>2]=ga+1;W=sa;ba=ta;ca=ua;da=va;ea=wa;fa=xa;continue}}if((ba|0)==(ca|0)|(ea|0)==0){Ea=ba;Fa=ca;Ga=da;Ha=fa}else{if((ca|0)==(da|0)){ga=ca-ba|0;ia=ga>>>0<2147483647?ga<<1:-1;if((fa|0)==771){Ia=0}else{Ia=ba}oa=k4c(Ia,ia)|0;if((oa|0)==0){X=209;break a}Ja=oa;Ka=oa+(ga>>2<<2)|0;La=oa+(ia>>>2<<2)|0;Ma=746}else{Ja=ba;Ka=ca;La=da;Ma=fa}c[Ka>>2]=ea;Ea=Ja;Fa=Ka+4|0;Ga=La;Ha=Ma}if((c[B>>2]|0)>0){ia=c[h>>2]|0;do{if((ia|0)==0){Na=0}else{if((c[ia+12>>2]|0)!=(c[ia+16>>2]|0)){Na=ia;break}if((ie[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)==-1){c[h>>2]=0;Na=0;break}else{Na=c[h>>2]|0;break}}}while(0);ia=(Na|0)==0;ea=c[e>>2]|0;do{if((ea|0)==0){X=223}else{if((c[ea+12>>2]|0)!=(c[ea+16>>2]|0)){if(ia){Oa=ea;break}else{X=229;break a}}if((ie[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)==-1){c[e>>2]=0;X=223;break}else{if(ia){Oa=ea;break}else{X=229;break a}}}}while(0);if((X|0)==223){X=0;if(ia){X=229;break a}else{Oa=0}}ea=c[h>>2]|0;fa=c[ea+12>>2]|0;if((fa|0)==(c[ea+16>>2]|0)){Pa=(ie[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Pa=a[fa]|0}if(!(Pa<<24>>24==(a[u]|0))){X=229;break a}fa=c[h>>2]|0;ea=fa+12|0;da=c[ea>>2]|0;if((da|0)==(c[fa+16>>2]|0)){ie[c[(c[fa>>2]|0)+40>>2]&127](fa)|0;Qa=Oa;Ra=Oa;Sa=W}else{c[ea>>2]=da+1;Qa=Oa;Ra=Oa;Sa=W}while(1){da=c[h>>2]|0;do{if((da|0)==0){Ta=0}else{if((c[da+12>>2]|0)!=(c[da+16>>2]|0)){Ta=da;break}if((ie[c[(c[da>>2]|0)+36>>2]&127](da)|0)==-1){c[h>>2]=0;Ta=0;break}else{Ta=c[h>>2]|0;break}}}while(0);da=(Ta|0)==0;do{if((Ra|0)==0){Ua=Qa;X=243}else{if((c[Ra+12>>2]|0)!=(c[Ra+16>>2]|0)){if(da){Va=Qa;Wa=Ra;break}else{X=250;break a}}if((ie[c[(c[Ra>>2]|0)+36>>2]&127](Ra)|0)==-1){c[e>>2]=0;Ua=0;X=243;break}else{if(da^(Qa|0)==0){Va=Qa;Wa=Qa;break}else{X=250;break a}}}}while(0);if((X|0)==243){X=0;if(da){X=250;break a}else{Va=Ua;Wa=0}}ea=c[h>>2]|0;fa=c[ea+12>>2]|0;if((fa|0)==(c[ea+16>>2]|0)){Xa=(ie[c[(c[ea>>2]|0)+36>>2]&127](ea)|0)&255}else{Xa=a[fa]|0}if(!(Xa<<24>>24>-1)){X=250;break a}if((b[(c[f>>2]|0)+(Xa<<24>>24<<1)>>1]&2048)==0){X=250;break a}fa=c[o>>2]|0;if((fa|0)==(Sa|0)){ea=(c[P>>2]|0)!=771;ca=c[t>>2]|0;ba=Sa-ca|0;oa=ba>>>0<2147483647?ba<<1:-1;ga=k4c(ea?ca:0,oa)|0;if((ga|0)==0){X=253;break a}do{if(ea){c[t>>2]=ga;Ya=ga}else{ca=c[t>>2]|0;c[t>>2]=ga;if((ca|0)==0){Ya=ga;break}fe[c[P>>2]&1023](ca);Ya=c[t>>2]|0}}while(0);c[P>>2]=746;ga=Ya+ba|0;c[o>>2]=ga;Za=ga;_a=(c[t>>2]|0)+oa|0}else{Za=fa;_a=Sa}ga=c[h>>2]|0;ea=c[ga+12>>2]|0;if((ea|0)==(c[ga+16>>2]|0)){da=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;$a=da;ab=c[o>>2]|0}else{$a=a[ea]|0;ab=Za}c[o>>2]=ab+1;a[ab]=$a;ea=(c[B>>2]|0)+ -1|0;c[B>>2]=ea;da=c[h>>2]|0;ga=da+12|0;ca=c[ga>>2]|0;if((ca|0)==(c[da+16>>2]|0)){ie[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[ga>>2]=ca+1}if((ea|0)>0){Qa=Va;Ra=Wa;Sa=_a}else{bb=_a;break}}}else{bb=W}if((c[o>>2]|0)==(c[t>>2]|0)){X=267;break a}else{cb=bb;db=Ea;eb=Fa;fb=Ga;gb=S;hb=Ha}break};case 3:{ia=a[y]|0;ea=(ia&1)==0;if(ea){ib=(ia&255)>>>1}else{ib=c[G>>2]|0}ca=a[z]|0;ga=(ca&1)==0;if(ga){jb=(ca&255)>>>1}else{jb=c[g>>2]|0}if((ib|0)==(0-jb|0)){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break b}if(ea){kb=(ia&255)>>>1}else{kb=c[G>>2]|0}do{if((kb|0)!=0){if(ga){lb=(ca&255)>>>1}else{lb=c[g>>2]|0}if((lb|0)==0){break}da=c[h>>2]|0;la=c[da+12>>2]|0;mb=c[da+16>>2]|0;if((la|0)==(mb|0)){nb=(ie[c[(c[da>>2]|0)+36>>2]&127](da)|0)&255;ob=c[h>>2]|0;pb=nb;qb=c[ob+16>>2]|0;rb=c[ob+12>>2]|0;sb=ob;tb=a[y]|0}else{pb=a[la]|0;qb=mb;rb=la;sb=da;tb=ia}da=sb+12|0;la=(rb|0)==(qb|0);if(pb<<24>>24==(a[(tb&1)==0?F:c[H>>2]|0]|0)){if(la){ie[c[(c[sb>>2]|0)+40>>2]&127](sb)|0}else{c[da>>2]=rb+1}da=a[y]|0;if((da&1)==0){ub=(da&255)>>>1}else{ub=c[G>>2]|0}cb=D;db=R;eb=r;fb=Q;gb=ub>>>0>1?y:S;hb=T;break b}if(la){vb=(ie[c[(c[sb>>2]|0)+36>>2]&127](sb)|0)&255}else{vb=a[rb]|0}if(!(vb<<24>>24==(a[(a[z]&1)==0?m:c[E>>2]|0]|0))){X=112;break a}la=c[h>>2]|0;da=la+12|0;mb=c[da>>2]|0;if((mb|0)==(c[la+16>>2]|0)){ie[c[(c[la>>2]|0)+40>>2]&127](la)|0}else{c[da>>2]=mb+1}a[l]=1;mb=a[z]|0;if((mb&1)==0){wb=(mb&255)>>>1}else{wb=c[g>>2]|0}cb=D;db=R;eb=r;fb=Q;gb=wb>>>0>1?z:S;hb=T;break b}}while(0);if(ea){xb=(ia&255)>>>1}else{xb=c[G>>2]|0}ga=c[h>>2]|0;W=c[ga+12>>2]|0;mb=(W|0)==(c[ga+16>>2]|0);if((xb|0)==0){if(mb){da=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;yb=da;zb=a[z]|0}else{yb=a[W]|0;zb=ca}if(!(yb<<24>>24==(a[(zb&1)==0?m:c[E>>2]|0]|0))){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break b}da=c[h>>2]|0;la=da+12|0;ob=c[la>>2]|0;if((ob|0)==(c[da+16>>2]|0)){ie[c[(c[da>>2]|0)+40>>2]&127](da)|0}else{c[la>>2]=ob+1}a[l]=1;ob=a[z]|0;if((ob&1)==0){Ab=(ob&255)>>>1}else{Ab=c[g>>2]|0}cb=D;db=R;eb=r;fb=Q;gb=Ab>>>0>1?z:S;hb=T;break b}if(mb){mb=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255;Bb=mb;Cb=a[y]|0}else{Bb=a[W]|0;Cb=ia}if(!(Bb<<24>>24==(a[(Cb&1)==0?F:c[H>>2]|0]|0))){a[l]=1;cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break b}W=c[h>>2]|0;mb=W+12|0;ga=c[mb>>2]|0;if((ga|0)==(c[W+16>>2]|0)){ie[c[(c[W>>2]|0)+40>>2]&127](W)|0}else{c[mb>>2]=ga+1}ga=a[y]|0;if((ga&1)==0){Db=(ga&255)>>>1}else{Db=c[G>>2]|0}cb=D;db=R;eb=r;fb=Q;gb=Db>>>0>1?y:S;hb=T;break};case 2:{if(!((S|0)!=0|p>>>0<2)){if((p|0)==2){Eb=(a[O]|0)!=0}else{Eb=0}if(!(I|Eb)){cb=D;db=R;eb=r;fb=Q;gb=0;hb=T;break b}}ga=a[x]|0;mb=(ga&1)==0;W=mb?j:c[J>>2]|0;d:do{if((p|0)==0){Fb=Y;Gb=Y;Hb=ga;Ib=W}else{if((d[s+(p+ -1)|0]|0)>=2){Fb=Y;Gb=Y;Hb=ga;Ib=W;break}ob=W+(mb?(ga&255)>>>1:c[K>>2]|0)|0;la=W;while(1){if((la|0)==(ob|0)){Jb=ob;break}da=a[la]|0;if(!(da<<24>>24>-1)){Jb=la;break}if((b[(c[f>>2]|0)+(da<<24>>24<<1)>>1]&8192)==0){Jb=la;break}else{la=la+1|0}}la=Jb-W|0;ob=a[A]|0;fa=(ob&1)==0;if(fa){Kb=(ob&255)>>>1}else{Kb=c[N>>2]|0}if(la>>>0>Kb>>>0){Fb=Y;Gb=Y;Hb=ga;Ib=W;break}if(fa){fa=(ob&255)>>>1;Lb=A+1+(fa-la)|0;Mb=L;Nb=fa}else{fa=c[M>>2]|0;ob=c[N>>2]|0;Lb=fa+(ob-la)|0;Mb=fa;Nb=ob}ob=Mb+Nb|0;if((Lb|0)==(ob|0)){Fb=Y;Gb=Y;Hb=ga;Ib=Jb;break}else{Ob=W;Pb=Lb}while(1){if((a[Pb]|0)!=(a[Ob]|0)){Fb=Y;Gb=Y;Hb=ga;Ib=W;break d}fa=Pb+1|0;if((fa|0)==(ob|0)){Fb=Y;Gb=Y;Hb=ga;Ib=Jb;break}else{Ob=Ob+1|0;Pb=fa}}}}while(0);e:while(1){if((Hb&1)==0){Qb=j;Rb=(Hb&255)>>>1}else{Qb=c[J>>2]|0;Rb=c[K>>2]|0}if((Ib|0)==(Qb+Rb|0)){break}ga=c[h>>2]|0;do{if((ga|0)==0){Sb=0}else{if((c[ga+12>>2]|0)!=(c[ga+16>>2]|0)){Sb=ga;break}if((ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)==-1){c[h>>2]=0;Sb=0;break}else{Sb=c[h>>2]|0;break}}}while(0);ga=(Sb|0)==0;do{if((Gb|0)==0){Tb=Fb;X=147}else{if((c[Gb+12>>2]|0)!=(c[Gb+16>>2]|0)){if(ga){Ub=Fb;Vb=Gb;break}else{break e}}if((ie[c[(c[Gb>>2]|0)+36>>2]&127](Gb)|0)==-1){c[e>>2]=0;Tb=0;X=147;break}else{if(ga^(Fb|0)==0){Ub=Fb;Vb=Fb;break}else{break e}}}}while(0);if((X|0)==147){X=0;if(ga){break}else{Ub=Tb;Vb=0}}W=c[h>>2]|0;mb=c[W+12>>2]|0;if((mb|0)==(c[W+16>>2]|0)){Wb=(ie[c[(c[W>>2]|0)+36>>2]&127](W)|0)&255}else{Wb=a[mb]|0}if(!(Wb<<24>>24==(a[Ib]|0))){break}mb=c[h>>2]|0;W=mb+12|0;ia=c[W>>2]|0;if((ia|0)==(c[mb+16>>2]|0)){ie[c[(c[mb>>2]|0)+40>>2]&127](mb)|0}else{c[W>>2]=ia+1}Fb=Ub;Gb=Vb;Hb=a[x]|0;Ib=Ib+1|0}if(!I){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break b}ia=a[x]|0;if((ia&1)==0){Xb=j;Yb=(ia&255)>>>1}else{Xb=c[J>>2]|0;Yb=c[K>>2]|0}if((Ib|0)==(Xb+Yb|0)){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T}else{X=162;break a}break};case 1:{if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}ia=c[h>>2]|0;W=c[ia+12>>2]|0;if((W|0)==(c[ia+16>>2]|0)){Zb=(ie[c[(c[ia>>2]|0)+36>>2]&127](ia)|0)&255}else{Zb=a[W]|0}if(!(Zb<<24>>24>-1)){X=25;break a}if((b[(c[f>>2]|0)+(Zb<<24>>24<<1)>>1]&8192)==0){X=25;break a}W=c[h>>2]|0;ia=W+12|0;mb=c[ia>>2]|0;if((mb|0)==(c[W+16>>2]|0)){_b=(ie[c[(c[W>>2]|0)+40>>2]&127](W)|0)&255}else{c[ia>>2]=mb+1;_b=a[mb]|0}uWc(A,_b);X=26;break};case 0:{X=26;break};default:{cb=D;db=R;eb=r;fb=Q;gb=S;hb=T}}}while(0);f:do{if((X|0)==26){X=0;if((p|0)==3){Z=R;_=r;$=S;aa=T;X=269;break a}else{$b=Y;ac=Y}while(1){U=c[h>>2]|0;do{if((U|0)==0){bc=0}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){bc=U;break}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[h>>2]=0;bc=0;break}else{bc=c[h>>2]|0;break}}}while(0);U=(bc|0)==0;do{if((ac|0)==0){cc=$b;X=37}else{if((c[ac+12>>2]|0)!=(c[ac+16>>2]|0)){if(U){dc=$b;ec=ac;break}else{cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break f}}if((ie[c[(c[ac>>2]|0)+36>>2]&127](ac)|0)==-1){c[e>>2]=0;cc=0;X=37;break}else{if(U^($b|0)==0){dc=$b;ec=$b;break}else{cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break f}}}}while(0);if((X|0)==37){X=0;if(U){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break f}else{dc=cc;ec=0}}ga=c[h>>2]|0;mb=c[ga+12>>2]|0;if((mb|0)==(c[ga+16>>2]|0)){fc=(ie[c[(c[ga>>2]|0)+36>>2]&127](ga)|0)&255}else{fc=a[mb]|0}if(!(fc<<24>>24>-1)){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break f}if((b[(c[f>>2]|0)+(fc<<24>>24<<1)>>1]&8192)==0){cb=D;db=R;eb=r;fb=Q;gb=S;hb=T;break f}mb=c[h>>2]|0;ga=mb+12|0;ia=c[ga>>2]|0;if((ia|0)==(c[mb+16>>2]|0)){gc=(ie[c[(c[mb>>2]|0)+40>>2]&127](mb)|0)&255}else{c[ga>>2]=ia+1;gc=a[ia]|0}uWc(A,gc);$b=dc;ac=ec}}}while(0);ia=p+1|0;if(ia>>>0<4){Q=fb;r=eb;R=db;D=cb;p=ia;S=gb;T=hb}else{Z=db;_=eb;$=gb;aa=hb;X=269;break}}g:do{if((X|0)==25){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==112){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==162){c[k>>2]=c[k>>2]|4;hc=0;ic=R;jc=T}else if((X|0)==182){u4c()}else if((X|0)==198){u4c()}else if((X|0)==209){u4c()}else if((X|0)==229){c[k>>2]=c[k>>2]|4;hc=0;ic=Ea;jc=Ha}else if((X|0)==250){c[k>>2]=c[k>>2]|4;hc=0;ic=Ea;jc=Ha}else if((X|0)==253){u4c()}else if((X|0)==267){c[k>>2]=c[k>>2]|4;hc=0;ic=Ea;jc=Ha}else if((X|0)==269){h:do{if(($|0)!=0){hb=$+1|0;gb=$+8|0;eb=$+4|0;db=1;i:while(1){S=a[$]|0;if((S&1)==0){kc=(S&255)>>>1}else{kc=c[eb>>2]|0}if(!(db>>>0<kc>>>0)){break h}S=c[h>>2]|0;do{if((S|0)==0){lc=0}else{if((c[S+12>>2]|0)!=(c[S+16>>2]|0)){lc=S;break}if((ie[c[(c[S>>2]|0)+36>>2]&127](S)|0)==-1){c[h>>2]=0;lc=0;break}else{lc=c[h>>2]|0;break}}}while(0);S=(lc|0)==0;U=c[e>>2]|0;do{if((U|0)==0){X=285}else{if((c[U+12>>2]|0)!=(c[U+16>>2]|0)){if(S){break}else{break i}}if((ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)==-1){c[e>>2]=0;X=285;break}else{if(S){break}else{break i}}}}while(0);if((X|0)==285){X=0;if(S){break}}U=c[h>>2]|0;p=c[U+12>>2]|0;if((p|0)==(c[U+16>>2]|0)){mc=(ie[c[(c[U>>2]|0)+36>>2]&127](U)|0)&255}else{mc=a[p]|0}if((a[$]&1)==0){nc=hb}else{nc=c[gb>>2]|0}if(!(mc<<24>>24==(a[nc+db|0]|0))){break}p=db+1|0;U=c[h>>2]|0;cb=U+12|0;D=c[cb>>2]|0;if((D|0)==(c[U+16>>2]|0)){ie[c[(c[U>>2]|0)+40>>2]&127](U)|0;db=p;continue}else{c[cb>>2]=D+1;db=p;continue}}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa;break g}}while(0);if((Z|0)==(_|0)){hc=1;ic=_;jc=aa;break}c[C>>2]=0;_$c(w,Z,_,C);if((c[C>>2]|0)==0){hc=1;ic=Z;jc=aa;break}c[k>>2]=c[k>>2]|4;hc=0;ic=Z;jc=aa}}while(0);cWc(A);cWc(z);cWc(y);cWc(x);cWc(w);if((ic|0)==0){i=q;return hc|0}fe[jc&1023](ic);i=q;return hc|0}function W$c(a){a=a|0;var b=0;b=Ec(8)|0;AVc(b,a);Td(b|0,363352,42)}function X$c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;d=i;i=i+168|0;l=d;m=d+8|0;n=d+24|0;o=d+128|0;p=d+136|0;q=d+144|0;r=d+152|0;s=d+160|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=771;v=n+100|0;_Wc(q,h);n=q;w=c[n>>2]|0;if(!((c[91590]|0)==-1)){c[m>>2]=366360;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366360,m,770)}m=(c[366364>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;O3c(z);A=381920;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;O3c(z);A=381920;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=V$c(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}if((a[r]|0)!=0){uWc(k,xe[c[(c[w>>2]|0)+28>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+28>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -1|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+1|0;if(!((a[z]|0)==r<<24>>24)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);Y$c(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=0}else{if((c[e+12>>2]|0)!=(c[e+16>>2]|0)){D=e;break}if(!((ie[c[(c[e>>2]|0)+36>>2]&127](e)|0)==-1)){D=e;break}c[w>>2]=0;D=0}}while(0);w=(D|0)==0;do{if((f|0)==0){E=25}else{if((c[f+12>>2]|0)!=(c[f+16>>2]|0)){if(w){break}else{E=27;break}}if((ie[c[(c[f>>2]|0)+36>>2]&127](f)|0)==-1){c[A>>2]=0;E=25;break}else{if(w^(f|0)==0){break}else{E=27;break}}}}while(0);if((E|0)==25){if(w){E=27}}if((E|0)==27){c[j>>2]=c[j>>2]|2}c[b>>2]=D;uVc(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&1023](n);i=d;return}function Y$c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=10}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g|0;if((e|0)==(d|0)){i=f;return b|0}if((l-j|0)>>>0<h>>>0){xWc(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+1|0}else{n=c[b+8>>2]|0}m=e+(j-g)|0;g=d;d=n+j|0;while(1){a[d]=a[g]|0;k=g+1|0;if((k|0)==(e|0)){break}else{d=d+1|0;g=k}}a[n+m|0]=0;m=j+h|0;if((a[b]&1)==0){a[b]=m<<1;i=f;return b|0}else{c[b+4>>2]=m;i=f;return b|0}return 0}function Z$c(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[91450]|0)==-1)){c[p>>2]=365800;c[p+4>>2]=769;c[p+8>>2]=0;PVc(365800,p,770)}p=(c[365804>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&255](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&255](r,E);B=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}oWc(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;cWc(r);ge[c[(c[b>>2]|0)+28>>2]&255](s,E);r=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}oWc(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;cWc(s);a[f]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;a[g]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&255](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}oWc(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;cWc(t);ge[c[(c[b>>2]|0)+24>>2]&255](u,E);t=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}oWc(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;cWc(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[91434]|0)==-1)){c[o>>2]=365736;c[o+4>>2]=769;c[o+8>>2]=0;PVc(365736,o,770)}o=(c[365740>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&255](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&255](w,J);e=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}oWc(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;cWc(w);ge[c[(c[E>>2]|0)+28>>2]&255](x,J);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}oWc(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;cWc(x);a[f]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;a[g]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&255](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}oWc(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cWc(y);ge[c[(c[E>>2]|0)+24>>2]&255](z,J);y=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}oWc(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;cWc(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function _$c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1}else{j=c[b+4>>2]|0}if((j|0)==0){i=g;return}do{if((d|0)==(e|0)){k=h}else{j=e+ -4|0;if(j>>>0>d>>>0){l=d;m=j}else{k=h;break}do{j=c[l>>2]|0;c[l>>2]=c[m>>2];c[m>>2]=j;l=l+4|0;m=m+ -4|0;}while(l>>>0<m>>>0);k=a[b]|0}}while(0);if((k&1)==0){n=b+1|0;o=(k&255)>>>1}else{n=c[b+8>>2]|0;o=c[b+4>>2]|0}b=e+ -4|0;e=a[n]|0;k=e<<24>>24<1|e<<24>>24==127;a:do{if(b>>>0>d>>>0){m=n+o|0;l=e;h=n;j=d;p=k;while(1){if(!p){if((l<<24>>24|0)!=(c[j>>2]|0)){break}}q=(m-h|0)>1?h+1|0:h;r=j+4|0;s=a[q]|0;t=s<<24>>24<1|s<<24>>24==127;if(r>>>0<b>>>0){l=s;h=q;j=r;p=t}else{u=s;v=t;break a}}c[f>>2]=4;i=g;return}else{u=e;v=k}}while(0);if(v){i=g;return}v=c[b>>2]|0;if(!(u<<24>>24>>>0<v>>>0|(v|0)==0)){i=g;return}c[f>>2]=4;i=g;return}function $$c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function a0c(a){a=a|0;i=i;return}function b0c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0;d=i;i=i+16|0;l=d;m=d+8|0;n=i;i=i+16|0;o=i;i=i+400|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+40|0;v=i;i=i+104|0;w=p;c[w>>2]=o;x=p+4|0;c[x>>2]=771;y=o+400|0;_Wc(r,h);o=r;z=c[o>>2]|0;if(!((c[91588]|0)==-1)){c[n>>2]=366352;c[n+4>>2]=769;c[n+8>>2]=0;PVc(366352,n,770)}n=(c[366356>>2]|0)+ -1|0;A=c[z+8>>2]|0;if(!((c[z+12>>2]|0)-A>>2>>>0>n>>>0)){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}z=c[A+(n<<2)>>2]|0;if((z|0)==0){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}E=z;a[s]=0;D=f;c[t>>2]=c[D>>2];f=c[h+4>>2]|0;h=l;B=t;c[h+0>>2]=c[B+0>>2];B=c0c(e,l,g,r,f,j,s,E,p,q,y)|0;do{if(B){y=u;He[c[(c[z>>2]|0)+48>>2]&63](E,366056,366066|0,y)|0;p=v;f=c[q>>2]|0;r=c[w>>2]|0;g=f-r|0;do{if((g|0)>392){l=h4c((g>>2)+2|0)|0;if((l|0)!=0){F=l;G=l;break}u4c()}else{F=0;G=p}}while(0);if((a[s]|0)==0){H=G}else{a[G]=45;H=G+1|0}if(r>>>0<f>>>0){g=u+40|0;l=u;h=H;t=r;while(1){C=c[t>>2]|0;n=y;while(1){A=n+4|0;if((c[n>>2]|0)==(C|0)){I=n;break}if((A|0)==(g|0)){I=g;break}else{n=A}}a[h]=a[366056+(I-l>>2)|0]|0;n=t+4|0;C=h+1|0;if(n>>>0<(c[q>>2]|0)>>>0){h=C;t=n}else{J=C;break}}}else{J=H}a[J]=0;c[m>>2]=k;if((xd(p|0,365992,m|0)|0)!=1){t=Ec(8)|0;AVc(t,366e3);Td(t|0,363352,42)}if((F|0)==0){break}i4c(F)}}while(0);F=e;e=c[F>>2]|0;do{if((e|0)==0){K=1}else{m=c[e+12>>2]|0;if((m|0)==(c[e+16>>2]|0)){L=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{L=c[m>>2]|0}if((L|0)==-1){c[F>>2]=0;K=1;break}else{K=(c[F>>2]|0)==0;break}}}while(0);L=c[D>>2]|0;do{if((L|0)==0){M=35}else{e=c[L+12>>2]|0;if((e|0)==(c[L+16>>2]|0)){N=ie[c[(c[L>>2]|0)+36>>2]&127](L)|0}else{N=c[e>>2]|0}if((N|0)==-1){c[D>>2]=0;M=35;break}else{if(K){break}else{M=37;break}}}}while(0);if((M|0)==35){if(K){M=37}}if((M|0)==37){c[j>>2]=c[j>>2]|2}c[b>>2]=c[F>>2];uVc(c[o>>2]|0)|0;o=c[w>>2]|0;c[w>>2]=0;if((o|0)==0){i=d;return}fe[c[x>>2]&1023](o);i=d;return}function c0c(b,e,f,g,h,j,k,l,m,n,o){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;var p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0;p=i;i=i+416|0;q=p;r=p+8|0;s=p+408|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+8|0;c[q>>2]=o;o=r;c[s>>2]=0;D=w;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=x;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=y;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=z;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;D=A;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;f0c(f,g,t,u,v,w,x,y,z,B);t=m;c[n>>2]=c[t>>2];g=b;b=e;e=z+4|0;f=z+8|0;D=y+4|0;E=y+8|0;F=(h&512|0)!=0;h=x+4|0;G=x+8|0;H=A+4|0;I=A+8|0;J=s+3|0;K=w+4|0;L=r+400|0;r=o;M=o;o=0;N=0;O=771;a:while(1){P=c[g>>2]|0;do{if((P|0)==0){Q=1}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){S=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{S=c[R>>2]|0}if((S|0)==-1){c[g>>2]=0;Q=1;break}else{Q=(c[g>>2]|0)==0;break}}}while(0);P=c[b>>2]|0;do{if((P|0)==0){T=15}else{R=c[P+12>>2]|0;if((R|0)==(c[P+16>>2]|0)){U=ie[c[(c[P>>2]|0)+36>>2]&127](P)|0}else{U=c[R>>2]|0}if((U|0)==-1){c[b>>2]=0;T=15;break}else{if(Q){V=P;break}else{W=M;X=r;Y=N;Z=O;T=276;break a}}}}while(0);if((T|0)==15){T=0;if(Q){W=M;X=r;Y=N;Z=O;T=276;break}else{V=0}}b:do{switch(a[s+o|0]|0){case 2:{if(!((N|0)!=0|o>>>0<2)){if((o|0)==2){_=(a[J]|0)!=0}else{_=0}if(!(F|_)){$=M;aa=r;ba=L;ca=0;da=O;break b}}P=a[x]|0;R=(P&1)==0?h:c[G>>2]|0;c:do{if((o|0)==0){ea=V;fa=V;ga=P;ha=R}else{if((d[s+(o+ -1)|0]|0)<2){ia=P;ja=R}else{ea=V;fa=V;ga=P;ha=R;break}while(1){if((ia&1)==0){ka=h;la=(ia&255)>>>1}else{ka=c[G>>2]|0;la=c[h>>2]|0}if((ja|0)==(ka+(la<<2)|0)){ma=ia;break}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,c[ja>>2]|0)|0)){T=129;break}ia=a[x]|0;ja=ja+4|0}if((T|0)==129){T=0;ma=a[x]|0}na=(ma&1)==0;oa=ja-(na?h:c[G>>2]|0)>>2;pa=a[A]|0;qa=(pa&1)==0;if(qa){ra=(pa&255)>>>1}else{ra=c[H>>2]|0}d:do{if(!(oa>>>0>ra>>>0)){if(qa){sa=H+(((pa&255)>>>1)-oa<<2)|0;ta=H;ua=(pa&255)>>>1}else{va=c[I>>2]|0;wa=c[H>>2]|0;sa=va+(wa-oa<<2)|0;ta=va;ua=wa}wa=ta+(ua<<2)|0;if((sa|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}else{xa=na?h:c[G>>2]|0;ya=sa}while(1){if((c[ya>>2]|0)!=(c[xa>>2]|0)){break d}va=ya+4|0;if((va|0)==(wa|0)){ea=V;fa=V;ga=ma;ha=ja;break c}xa=xa+4|0;ya=va}}}while(0);ea=V;fa=V;ga=ma;ha=na?h:c[G>>2]|0}}while(0);e:while(1){if((ga&1)==0){za=h;Aa=(ga&255)>>>1}else{za=c[G>>2]|0;Aa=c[h>>2]|0}if((ha|0)==(za+(Aa<<2)|0)){break}R=c[g>>2]|0;do{if((R|0)==0){Ba=1}else{P=c[R+12>>2]|0;if((P|0)==(c[R+16>>2]|0)){Ca=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ca=c[P>>2]|0}if((Ca|0)==-1){c[g>>2]=0;Ba=1;break}else{Ba=(c[g>>2]|0)==0;break}}}while(0);do{if((fa|0)==0){Da=ea;T=159}else{R=c[fa+12>>2]|0;if((R|0)==(c[fa+16>>2]|0)){Ea=ie[c[(c[fa>>2]|0)+36>>2]&127](fa)|0}else{Ea=c[R>>2]|0}if((Ea|0)==-1){c[b>>2]=0;Da=0;T=159;break}else{if(Ba^(ea|0)==0){Fa=ea;Ga=ea;break}else{break e}}}}while(0);if((T|0)==159){T=0;if(Ba){break}else{Fa=Da;Ga=0}}R=c[g>>2]|0;na=c[R+12>>2]|0;if((na|0)==(c[R+16>>2]|0)){Ha=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Ha=c[na>>2]|0}if((Ha|0)!=(c[ha>>2]|0)){break}na=c[g>>2]|0;R=na+12|0;P=c[R>>2]|0;if((P|0)==(c[na+16>>2]|0)){ie[c[(c[na>>2]|0)+40>>2]&127](na)|0}else{c[R>>2]=P+4}ea=Fa;fa=Ga;ga=a[x]|0;ha=ha+4|0}if(!F){$=M;aa=r;ba=L;ca=N;da=O;break b}P=a[x]|0;if((P&1)==0){Ia=h;Ja=(P&255)>>>1}else{Ia=c[G>>2]|0;Ja=c[h>>2]|0}if((ha|0)==(Ia+(Ja<<2)|0)){$=M;aa=r;ba=L;ca=N;da=O}else{T=174;break a}break};case 4:{P=M;R=r;na=L;oa=0;pa=O;f:while(1){qa=c[g>>2]|0;do{if((qa|0)==0){Ka=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){La=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{La=c[wa>>2]|0}if((La|0)==-1){c[g>>2]=0;Ka=1;break}else{Ka=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=188}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Ma=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Ma=c[wa>>2]|0}if((Ma|0)==-1){c[b>>2]=0;T=188;break}else{if(Ka){break}else{break f}}}}while(0);if((T|0)==188){T=0;if(Ka){break}}qa=c[g>>2]|0;wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){Na=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{Na=c[wa>>2]|0}if(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,Na)|0){wa=c[n>>2]|0;if((wa|0)==(c[q>>2]|0)){g0c(m,n,q);Oa=c[n>>2]|0}else{Oa=wa}c[n>>2]=Oa+4;c[Oa>>2]=Na;Pa=P;Qa=R;Ra=na;Sa=oa+1|0;Ta=pa}else{wa=a[w]|0;if((wa&1)==0){Ua=(wa&255)>>>1}else{Ua=c[K>>2]|0}if((Ua|0)==0|(oa|0)==0){break}if((Na|0)!=(c[v>>2]|0)){break}if((R|0)==(na|0)){wa=R-P|0;qa=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=771){Va=P}else{Va=0}va=k4c(Va,qa)|0;if((va|0)==0){T=206;break a}Wa=va;Xa=va+(wa>>2<<2)|0;Ya=va+(qa>>>2<<2)|0;Za=746}else{Wa=P;Xa=R;Ya=na;Za=pa}c[Xa>>2]=oa;Pa=Wa;Qa=Xa+4|0;Ra=Ya;Sa=0;Ta=Za}qa=c[g>>2]|0;va=qa+12|0;wa=c[va>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){ie[c[(c[qa>>2]|0)+40>>2]&127](qa)|0;P=Pa;R=Qa;na=Ra;oa=Sa;pa=Ta;continue}else{c[va>>2]=wa+4;P=Pa;R=Qa;na=Ra;oa=Sa;pa=Ta;continue}}if((P|0)==(R|0)|(oa|0)==0){_a=P;$a=R;ab=na;bb=pa}else{if((R|0)==(na|0)){wa=R-P|0;va=wa>>>0<2147483647?wa<<1:-1;if((pa|0)!=771){cb=P}else{cb=0}qa=k4c(cb,va)|0;if((qa|0)==0){T=217;break a}db=qa;eb=qa+(wa>>2<<2)|0;fb=qa+(va>>>2<<2)|0;gb=746}else{db=P;eb=R;fb=na;gb=pa}c[eb>>2]=oa;_a=db;$a=eb+4|0;ab=fb;bb=gb}va=c[B>>2]|0;if((va|0)>0){qa=c[g>>2]|0;do{if((qa|0)==0){hb=1}else{wa=c[qa+12>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){ib=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{ib=c[wa>>2]|0}if((ib|0)==-1){c[g>>2]=0;hb=1;break}else{hb=(c[g>>2]|0)==0;break}}}while(0);qa=c[b>>2]|0;do{if((qa|0)==0){T=234}else{oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){jb=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{jb=c[oa>>2]|0}if((jb|0)==-1){c[b>>2]=0;T=234;break}else{if(hb){kb=qa;break}else{T=240;break a}}}}while(0);if((T|0)==234){T=0;if(hb){T=240;break a}else{kb=0}}qa=c[g>>2]|0;oa=c[qa+12>>2]|0;if((oa|0)==(c[qa+16>>2]|0)){lb=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{lb=c[oa>>2]|0}if((lb|0)!=(c[u>>2]|0)){T=240;break a}oa=c[g>>2]|0;qa=oa+12|0;pa=c[qa>>2]|0;if((pa|0)==(c[oa+16>>2]|0)){ie[c[(c[oa>>2]|0)+40>>2]&127](oa)|0;mb=kb;nb=va;ob=kb}else{c[qa>>2]=pa+4;mb=kb;nb=va;ob=kb}while(1){pa=c[g>>2]|0;do{if((pa|0)==0){pb=1}else{qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){qb=ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{qb=c[qa>>2]|0}if((qb|0)==-1){c[g>>2]=0;pb=1;break}else{pb=(c[g>>2]|0)==0;break}}}while(0);do{if((ob|0)==0){rb=mb;T=257}else{pa=c[ob+12>>2]|0;if((pa|0)==(c[ob+16>>2]|0)){sb=ie[c[(c[ob>>2]|0)+36>>2]&127](ob)|0}else{sb=c[pa>>2]|0}if((sb|0)==-1){c[b>>2]=0;rb=0;T=257;break}else{if(pb^(mb|0)==0){tb=mb;ub=mb;break}else{T=263;break a}}}}while(0);if((T|0)==257){T=0;if(pb){T=263;break a}else{tb=rb;ub=0}}pa=c[g>>2]|0;qa=c[pa+12>>2]|0;if((qa|0)==(c[pa+16>>2]|0)){vb=ie[c[(c[pa>>2]|0)+36>>2]&127](pa)|0}else{vb=c[qa>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,2048,vb)|0)){T=263;break a}if((c[n>>2]|0)==(c[q>>2]|0)){g0c(m,n,q)}qa=c[g>>2]|0;pa=c[qa+12>>2]|0;if((pa|0)==(c[qa+16>>2]|0)){wb=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0}else{wb=c[pa>>2]|0}pa=c[n>>2]|0;c[n>>2]=pa+4;c[pa>>2]=wb;pa=nb+ -1|0;c[B>>2]=pa;qa=c[g>>2]|0;oa=qa+12|0;na=c[oa>>2]|0;if((na|0)==(c[qa+16>>2]|0)){ie[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[oa>>2]=na+4}if((pa|0)>0){mb=tb;nb=pa;ob=ub}else{break}}}if((c[n>>2]|0)==(c[t>>2]|0)){T=274;break a}else{$=_a;aa=$a;ba=ab;ca=N;da=bb}break};case 0:{T=28;break};case 1:{if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}va=c[g>>2]|0;pa=c[va+12>>2]|0;if((pa|0)==(c[va+16>>2]|0)){xb=ie[c[(c[va>>2]|0)+36>>2]&127](va)|0}else{xb=c[pa>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,xb)|0)){T=27;break a}pa=c[g>>2]|0;va=pa+12|0;na=c[va>>2]|0;if((na|0)==(c[pa+16>>2]|0)){yb=ie[c[(c[pa>>2]|0)+40>>2]&127](pa)|0}else{c[va>>2]=na+4;yb=c[na>>2]|0}KWc(A,yb);T=28;break};case 3:{na=a[y]|0;va=(na&1)==0;if(va){zb=(na&255)>>>1}else{zb=c[D>>2]|0}pa=a[z]|0;oa=(pa&1)==0;if(oa){Ab=(pa&255)>>>1}else{Ab=c[e>>2]|0}if((zb|0)==(0-Ab|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}if(va){Bb=(na&255)>>>1}else{Bb=c[D>>2]|0}do{if((Bb|0)!=0){if(oa){Cb=(pa&255)>>>1}else{Cb=c[e>>2]|0}if((Cb|0)==0){break}qa=c[g>>2]|0;R=c[qa+12>>2]|0;if((R|0)==(c[qa+16>>2]|0)){P=ie[c[(c[qa>>2]|0)+36>>2]&127](qa)|0;Db=P;Eb=a[y]|0}else{Db=c[R>>2]|0;Eb=na}R=c[g>>2]|0;P=R+12|0;qa=c[P>>2]|0;wa=(qa|0)==(c[R+16>>2]|0);if((Db|0)==(c[((Eb&1)==0?D:c[E>>2]|0)>>2]|0)){if(wa){ie[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[P>>2]=qa+4}P=a[y]|0;if((P&1)==0){Fb=(P&255)>>>1}else{Fb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Fb>>>0>1?y:N;da=O;break b}if(wa){Gb=ie[c[(c[R>>2]|0)+36>>2]&127](R)|0}else{Gb=c[qa>>2]|0}if((Gb|0)!=(c[((a[z]&1)==0?e:c[f>>2]|0)>>2]|0)){T=116;break a}qa=c[g>>2]|0;R=qa+12|0;wa=c[R>>2]|0;if((wa|0)==(c[qa+16>>2]|0)){ie[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[R>>2]=wa+4}a[k]=1;wa=a[z]|0;if((wa&1)==0){Hb=(wa&255)>>>1}else{Hb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Hb>>>0>1?z:N;da=O;break b}}while(0);if(va){Ib=(na&255)>>>1}else{Ib=c[D>>2]|0}oa=c[g>>2]|0;wa=c[oa+12>>2]|0;R=(wa|0)==(c[oa+16>>2]|0);if((Ib|0)==0){if(R){qa=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Jb=qa;Kb=a[z]|0}else{Jb=c[wa>>2]|0;Kb=pa}if((Jb|0)!=(c[((Kb&1)==0?e:c[f>>2]|0)>>2]|0)){$=M;aa=r;ba=L;ca=N;da=O;break b}qa=c[g>>2]|0;P=qa+12|0;Lb=c[P>>2]|0;if((Lb|0)==(c[qa+16>>2]|0)){ie[c[(c[qa>>2]|0)+40>>2]&127](qa)|0}else{c[P>>2]=Lb+4}a[k]=1;Lb=a[z]|0;if((Lb&1)==0){Mb=(Lb&255)>>>1}else{Mb=c[e>>2]|0}$=M;aa=r;ba=L;ca=Mb>>>0>1?z:N;da=O;break b}if(R){R=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0;Nb=R;Ob=a[y]|0}else{Nb=c[wa>>2]|0;Ob=na}if((Nb|0)!=(c[((Ob&1)==0?D:c[E>>2]|0)>>2]|0)){a[k]=1;$=M;aa=r;ba=L;ca=N;da=O;break b}wa=c[g>>2]|0;R=wa+12|0;oa=c[R>>2]|0;if((oa|0)==(c[wa+16>>2]|0)){ie[c[(c[wa>>2]|0)+40>>2]&127](wa)|0}else{c[R>>2]=oa+4}oa=a[y]|0;if((oa&1)==0){Pb=(oa&255)>>>1}else{Pb=c[D>>2]|0}$=M;aa=r;ba=L;ca=Pb>>>0>1?y:N;da=O;break};default:{$=M;aa=r;ba=L;ca=N;da=O}}}while(0);g:do{if((T|0)==28){T=0;if((o|0)==3){W=M;X=r;Y=N;Z=O;T=276;break a}else{Qb=V;Rb=V}while(1){oa=c[g>>2]|0;do{if((oa|0)==0){Sb=1}else{R=c[oa+12>>2]|0;if((R|0)==(c[oa+16>>2]|0)){Tb=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Tb=c[R>>2]|0}if((Tb|0)==-1){c[g>>2]=0;Sb=1;break}else{Sb=(c[g>>2]|0)==0;break}}}while(0);do{if((Rb|0)==0){Ub=Qb;T=42}else{oa=c[Rb+12>>2]|0;if((oa|0)==(c[Rb+16>>2]|0)){Vb=ie[c[(c[Rb>>2]|0)+36>>2]&127](Rb)|0}else{Vb=c[oa>>2]|0}if((Vb|0)==-1){c[b>>2]=0;Ub=0;T=42;break}else{if(Sb^(Qb|0)==0){Wb=Qb;Xb=Qb;break}else{$=M;aa=r;ba=L;ca=N;da=O;break g}}}}while(0);if((T|0)==42){T=0;if(Sb){$=M;aa=r;ba=L;ca=N;da=O;break g}else{Wb=Ub;Xb=0}}oa=c[g>>2]|0;R=c[oa+12>>2]|0;if((R|0)==(c[oa+16>>2]|0)){Yb=ie[c[(c[oa>>2]|0)+36>>2]&127](oa)|0}else{Yb=c[R>>2]|0}if(!(le[c[(c[l>>2]|0)+12>>2]&63](l,8192,Yb)|0)){$=M;aa=r;ba=L;ca=N;da=O;break g}R=c[g>>2]|0;oa=R+12|0;wa=c[oa>>2]|0;if((wa|0)==(c[R+16>>2]|0)){Zb=ie[c[(c[R>>2]|0)+40>>2]&127](R)|0}else{c[oa>>2]=wa+4;Zb=c[wa>>2]|0}KWc(A,Zb);Qb=Wb;Rb=Xb}}}while(0);na=o+1|0;if(na>>>0<4){L=ba;r=aa;M=$;o=na;N=ca;O=da}else{W=$;X=aa;Y=ca;Z=da;T=276;break}}h:do{if((T|0)==27){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==116){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==174){c[j>>2]=c[j>>2]|4;_b=0;$b=M;ac=O}else if((T|0)==206){u4c()}else if((T|0)==217){u4c()}else if((T|0)==240){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==263){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==274){c[j>>2]=c[j>>2]|4;_b=0;$b=_a;ac=bb}else if((T|0)==276){i:do{if((Y|0)!=0){da=Y+4|0;ca=Y+8|0;aa=1;j:while(1){$=a[Y]|0;if(($&1)==0){bc=($&255)>>>1}else{bc=c[da>>2]|0}if(!(aa>>>0<bc>>>0)){break i}$=c[g>>2]|0;do{if(($|0)==0){cc=1}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){dc=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{dc=c[N>>2]|0}if((dc|0)==-1){c[g>>2]=0;cc=1;break}else{cc=(c[g>>2]|0)==0;break}}}while(0);$=c[b>>2]|0;do{if(($|0)==0){T=295}else{N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){ec=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{ec=c[N>>2]|0}if((ec|0)==-1){c[b>>2]=0;T=295;break}else{if(cc){break}else{break j}}}}while(0);if((T|0)==295){T=0;if(cc){break}}$=c[g>>2]|0;N=c[$+12>>2]|0;if((N|0)==(c[$+16>>2]|0)){fc=ie[c[(c[$>>2]|0)+36>>2]&127]($)|0}else{fc=c[N>>2]|0}if((a[Y]&1)==0){gc=da}else{gc=c[ca>>2]|0}if((fc|0)!=(c[gc+(aa<<2)>>2]|0)){break}N=aa+1|0;$=c[g>>2]|0;o=$+12|0;r=c[o>>2]|0;if((r|0)==(c[$+16>>2]|0)){ie[c[(c[$>>2]|0)+40>>2]&127]($)|0;aa=N;continue}else{c[o>>2]=r+4;aa=N;continue}}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z;break h}}while(0);if((W|0)==(X|0)){_b=1;$b=X;ac=Z;break}c[C>>2]=0;_$c(w,W,X,C);if((c[C>>2]|0)==0){_b=1;$b=W;ac=Z;break}c[j>>2]=c[j>>2]|4;_b=0;$b=W;ac=Z}}while(0);GWc(A);GWc(z);GWc(y);GWc(x);cWc(w);if(($b|0)==0){i=p;return _b|0}fe[ac&1023]($b);i=p;return _b|0}function d0c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;d=i;i=i+464|0;l=d;m=d+8|0;n=d+24|0;o=d+424|0;p=d+432|0;q=d+440|0;r=d+448|0;s=d+456|0;t=o;c[t>>2]=n;u=o+4|0;c[u>>2]=771;v=n+400|0;_Wc(q,h);n=q;w=c[n>>2]|0;if(!((c[91588]|0)==-1)){c[m>>2]=366352;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366352,m,770)}m=(c[366356>>2]|0)+ -1|0;x=c[w+8>>2]|0;if(!((c[w+12>>2]|0)-x>>2>>>0>m>>>0)){y=Ec(4)|0;z=y;O3c(z);A=381920;B=127;Td(y|0,A|0,B|0)}w=c[x+(m<<2)>>2]|0;if((w|0)==0){y=Ec(4)|0;z=y;O3c(z);A=381920;B=127;Td(y|0,A|0,B|0)}B=w;a[r]=0;A=f;f=c[A>>2]|0;c[s>>2]=f;y=c[h+4>>2]|0;h=l;z=s;c[h+0>>2]=c[z+0>>2];z=c0c(e,l,g,q,y,j,r,B,o,p,v)|0;if(z){if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}if((a[r]|0)!=0){KWc(k,xe[c[(c[w>>2]|0)+44>>2]&63](B,45)|0)}r=xe[c[(c[w>>2]|0)+44>>2]&63](B,48)|0;B=c[t>>2]|0;w=c[p>>2]|0;p=w+ -4|0;a:do{if(B>>>0<p>>>0){z=B;while(1){v=z+4|0;if((c[z>>2]|0)!=(r|0)){C=z;break a}if(v>>>0<p>>>0){z=v}else{C=v;break}}}else{C=B}}while(0);e0c(k,C,w)|0}w=e;e=c[w>>2]|0;do{if((e|0)==0){D=1}else{C=c[e+12>>2]|0;if((C|0)==(c[e+16>>2]|0)){E=ie[c[(c[e>>2]|0)+36>>2]&127](e)|0}else{E=c[C>>2]|0}if((E|0)==-1){c[w>>2]=0;D=1;break}else{D=(c[w>>2]|0)==0;break}}}while(0);do{if((f|0)==0){F=29}else{E=c[f+12>>2]|0;if((E|0)==(c[f+16>>2]|0)){G=ie[c[(c[f>>2]|0)+36>>2]&127](f)|0}else{G=c[E>>2]|0}if((G|0)==-1){c[A>>2]=0;F=29;break}else{if(D){break}else{F=31;break}}}}while(0);if((F|0)==29){if(D){F=31}}if((F|0)==31){c[j>>2]=c[j>>2]|2}c[b>>2]=c[w>>2];uVc(c[n>>2]|0)|0;n=c[t>>2]|0;c[t>>2]=0;if((n|0)==0){i=d;return}fe[c[u>>2]&1023](n);i=d;return}function e0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=d;h=a[b]|0;if((h&1)==0){j=(h&255)>>>1;k=h;l=1}else{h=c[b>>2]|0;j=c[b+4>>2]|0;k=h&255;l=(h&-2)+ -1|0}h=e-g>>2;if((h|0)==0){i=f;return b|0}if((l-j|0)>>>0<h>>>0){MWc(b,l,j+h-l|0,j,j,0,0);m=a[b]|0}else{m=k}if((m&1)==0){n=b+4|0}else{n=c[b+8>>2]|0}m=n+(j<<2)|0;if((d|0)==(e|0)){o=m}else{k=j+((e+ -4+(0-g)|0)>>>2)+1|0;g=d;d=m;while(1){c[d>>2]=c[g>>2];m=g+4|0;if((m|0)==(e|0)){break}else{d=d+4|0;g=m}}o=n+(k<<2)|0}c[o>>2]=0;o=j+h|0;if((a[b]&1)==0){a[b]=o<<1;i=f;return b|0}else{c[b+4>>2]=o;i=f;return b|0}return 0}function f0c(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;n=i;i=i+176|0;o=n;p=n+16|0;q=n+32|0;r=n+40|0;s=n+56|0;t=n+72|0;u=n+88|0;v=n+104|0;w=n+112|0;x=n+128|0;y=n+144|0;z=n+160|0;if(b){b=c[d>>2]|0;if(!((c[91482]|0)==-1)){c[p>>2]=365928;c[p+4>>2]=769;c[p+8>>2]=0;PVc(365928,p,770)}p=(c[365932>>2]|0)+ -1|0;A=c[b+8>>2]|0;if(!((c[b+12>>2]|0)-A>>2>>>0>p>>>0)){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}b=c[A+(p<<2)>>2]|0;if((b|0)==0){B=Ec(4)|0;C=B;O3c(C);D=381920;E=127;Td(B|0,D|0,E|0)}E=b;ge[c[(c[b>>2]|0)+44>>2]&255](q,E);D=e;B=c[q>>2]|0;a[D]=B;a[D+1|0]=B>>8;a[D+2|0]=B>>16;a[D+3|0]=B>>24;ge[c[(c[b>>2]|0)+32>>2]&255](r,E);B=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}JWc(l,0);D=r;c[B+0>>2]=c[D+0>>2];c[B+4>>2]=c[D+4>>2];c[B+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;GWc(r);ge[c[(c[b>>2]|0)+28>>2]&255](s,E);r=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}JWc(k,0);D=s;c[r+0>>2]=c[D+0>>2];c[r+4>>2]=c[D+4>>2];c[r+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;GWc(s);c[f>>2]=ie[c[(c[b>>2]|0)+12>>2]&127](E)|0;c[g>>2]=ie[c[(c[b>>2]|0)+16>>2]&127](E)|0;ge[c[(c[b>>2]|0)+20>>2]&255](t,E);s=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}oWc(h,0);D=t;c[s+0>>2]=c[D+0>>2];c[s+4>>2]=c[D+4>>2];c[s+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;cWc(t);ge[c[(c[b>>2]|0)+24>>2]&255](u,E);t=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}JWc(j,0);D=u;c[t+0>>2]=c[D+0>>2];c[t+4>>2]=c[D+4>>2];c[t+8>>2]=c[D+8>>2];c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;GWc(u);F=ie[c[(c[b>>2]|0)+36>>2]&127](E)|0;c[m>>2]=F;i=n;return}else{E=c[d>>2]|0;if(!((c[91466]|0)==-1)){c[o>>2]=365864;c[o+4>>2]=769;c[o+8>>2]=0;PVc(365864,o,770)}o=(c[365868>>2]|0)+ -1|0;d=c[E+8>>2]|0;if(!((c[E+12>>2]|0)-d>>2>>>0>o>>>0)){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}E=c[d+(o<<2)>>2]|0;if((E|0)==0){G=Ec(4)|0;H=G;O3c(H);I=381920;J=127;Td(G|0,I|0,J|0)}J=E;ge[c[(c[E>>2]|0)+44>>2]&255](v,J);I=e;e=c[v>>2]|0;a[I]=e;a[I+1|0]=e>>8;a[I+2|0]=e>>16;a[I+3|0]=e>>24;ge[c[(c[E>>2]|0)+32>>2]&255](w,J);e=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}JWc(l,0);l=w;c[e+0>>2]=c[l+0>>2];c[e+4>>2]=c[l+4>>2];c[e+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;GWc(w);ge[c[(c[E>>2]|0)+28>>2]&255](x,J);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}JWc(k,0);k=x;c[w+0>>2]=c[k+0>>2];c[w+4>>2]=c[k+4>>2];c[w+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;GWc(x);c[f>>2]=ie[c[(c[E>>2]|0)+12>>2]&127](J)|0;c[g>>2]=ie[c[(c[E>>2]|0)+16>>2]&127](J)|0;ge[c[(c[E>>2]|0)+20>>2]&255](y,J);g=h;if((a[h]&1)==0){a[h+1|0]=0;a[h]=0}else{a[c[h+8>>2]|0]=0;c[h+4>>2]=0}oWc(h,0);h=y;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];c[g+8>>2]=c[h+8>>2];c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;cWc(y);ge[c[(c[E>>2]|0)+24>>2]&255](z,J);y=j;if((a[j]&1)==0){c[j+4>>2]=0;a[j]=0}else{c[c[j+8>>2]>>2]=0;c[j+4>>2]=0}JWc(j,0);j=z;c[y+0>>2]=c[j+0>>2];c[y+4>>2]=c[j+4>>2];c[y+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;GWc(z);F=ie[c[(c[E>>2]|0)+36>>2]&127](J)|0;c[m>>2]=F;i=n;return}}function g0c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=a+4|0;g=(c[f>>2]|0)!=771;h=a;a=c[h>>2]|0;j=a;k=(c[d>>2]|0)-j|0;l=k>>>0<2147483647?k<<1:-1;k=(c[b>>2]|0)-j>>2;if(g){m=a}else{m=0}a=k4c(m,l)|0;m=a;if((a|0)==0){u4c()}do{if(g){c[h>>2]=m;n=m}else{a=c[h>>2]|0;c[h>>2]=m;if((a|0)==0){n=m;break}fe[c[f>>2]&1023](a);n=c[h>>2]|0}}while(0);c[f>>2]=746;c[b>>2]=n+(k<<2);c[d>>2]=(c[h>>2]|0)+(l>>>2<<2);i=e;return}function h0c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function i0c(a){a=a|0;i=i;return}function j0c(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+104|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+104|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,366112,o|0)|0;do{if(s>>>0>99){do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);o=c[91562]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=b_c(r,o,366112,n)|0;o=c[r>>2]|0;if((o|0)==0){u4c()}H=h4c(G)|0;if((H|0)!=0){I=o;J=H;K=H;L=G;break}u4c()}else{I=0;J=0;K=q;L=s}}while(0);_Wc(t,g);s=t;q=c[s>>2]|0;if(!((c[91590]|0)==-1)){c[p>>2]=366360;c[p+4>>2]=769;c[p+8>>2]=0;PVc(366360,p,770)}p=(c[366364>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){M=Ec(4)|0;N=M;O3c(N);O=381920;P=127;Td(M|0,O|0,P|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){M=Ec(4)|0;N=M;O3c(N);O=381920;P=127;Td(M|0,O|0,P|0)}P=q;O=c[r>>2]|0;He[c[(c[q>>2]|0)+32>>2]&63](P,O,O+L|0,K)|0;if((L|0)==0){Q=0}else{Q=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;k0c(f,Q,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((L|0)>(C|0)){B=a[A]|0;if((B&1)==0){R=(B&255)>>>1}else{R=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[z+4>>2]|0}T=R+(L-C<<1|1)+S|0}else{S=a[A]|0;if((S&1)==0){U=(S&255)>>>1}else{U=c[A+4>>2]|0}S=a[z]|0;if((S&1)==0){V=(S&255)>>>1}else{V=c[z+4>>2]|0}T=U+2+V|0}V=T+C|0;do{if(V>>>0>100){T=h4c(V)|0;if((T|0)!=0){W=T;X=T;break}u4c()}else{W=0;X=t}}while(0);l0c(X,D,E,c[g+4>>2]|0,K,K+L|0,P,Q,v,a[w]|0,a[x]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];BSc(b,m,X,e,D,g,j);if((W|0)!=0){i4c(W)}cWc(A);cWc(z);cWc(y);uVc(c[s>>2]|0)|0;if((J|0)!=0){i4c(J)}if((I|0)==0){i=d;return}i4c(I);i=d;return}function k0c(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[91450]|0)==-1)){c[p>>2]=365800;c[p+4>>2]=769;c[p+8>>2]=0;PVc(365800,p,770)}p=(c[365804>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;O3c(I);J=381920;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;O3c(I);J=381920;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&255](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&255](s,K);H=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}oWc(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;cWc(s)}else{ge[c[J+40>>2]&255](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&255](v,K);J=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}oWc(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cWc(v)}a[g]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;a[h]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&255](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}oWc(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cWc(w);ge[c[(c[e>>2]|0)+24>>2]&255](x,K);w=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}oWc(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cWc(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[91434]|0)==-1)){c[o>>2]=365736;c[o+4>>2]=769;c[o+8>>2]=0;PVc(365736,o,770)}o=(c[365740>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;O3c(N);O=381920;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;O3c(N);O=381920;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&255](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&255](A,P);d=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}oWc(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;cWc(A)}else{ge[c[O+40>>2]&255](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&255](D,P);f=l;if((a[l]&1)==0){a[l+1|0]=0;a[l]=0}else{a[c[l+8>>2]|0]=0;c[l+4>>2]=0}oWc(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;cWc(D)}a[g]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;a[h]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&255](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}oWc(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;cWc(E);ge[c[(c[G>>2]|0)+24>>2]&255](F,P);E=k;if((a[k]&1)==0){a[k+1|0]=0;a[k]=0}else{a[c[k+8>>2]|0]=0;c[k+4>>2]=0}oWc(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;cWc(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function l0c(d,e,f,g,h,j,k,l,m,n,o,p,q,r,s){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;var t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;t=i;c[f>>2]=d;u=r+1|0;v=r+8|0;w=r+4|0;x=(g&512|0)==0;y=q+1|0;z=q+8|0;A=q+4|0;B=(s|0)>0;C=p+1|0;D=p+8|0;E=p+4|0;F=k+8|0;G=0-s|0;H=h;h=0;while(1){a:do{switch(a[m+h|0]|0){case 1:{c[e>>2]=c[f>>2];I=xe[c[(c[k>>2]|0)+28>>2]&63](k,32)|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;K=H;break};case 0:{c[e>>2]=c[f>>2];K=H;break};case 4:{I=c[f>>2]|0;J=l?H+1|0:H;b:do{if(J>>>0<j>>>0){L=J;while(1){M=a[L]|0;if(!(M<<24>>24>-1)){N=L;break b}O=L+1|0;if((b[(c[F>>2]|0)+(M<<24>>24<<1)>>1]&2048)==0){N=L;break b}if(O>>>0<j>>>0){L=O}else{N=O;break}}}else{N=J}}while(0);L=N;if(B){if(N>>>0>J>>>0){O=J+(0-L)|0;L=O>>>0<G>>>0?G:O;O=L+s|0;M=I;P=N;Q=s;while(1){R=P+ -1|0;S=a[R]|0;c[f>>2]=M+1;a[M]=S;S=Q+ -1|0;T=(S|0)>0;if(!(R>>>0>J>>>0&T)){break}M=c[f>>2]|0;Q=S;P=R}P=N+L|0;if(T){U=P;V=O;W=32}else{X=0;Y=P;Z=O}}else{U=N;V=s;W=32}if((W|0)==32){W=0;X=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;Y=U;Z=V}P=c[f>>2]|0;c[f>>2]=P+1;if((Z|0)>0){Q=P;M=Z;while(1){a[Q]=X;R=M+ -1|0;S=c[f>>2]|0;c[f>>2]=S+1;if((R|0)>0){M=R;Q=S}else{_=S;break}}}else{_=P}a[_]=n;$=Y}else{$=N}if(($|0)==(J|0)){Q=xe[c[(c[k>>2]|0)+28>>2]&63](k,48)|0;M=c[f>>2]|0;c[f>>2]=M+1;a[M]=Q}else{Q=a[p]|0;M=(Q&1)==0;if(M){aa=(Q&255)>>>1}else{aa=c[E>>2]|0}if((aa|0)==0){ba=$;ca=-1;da=0;ea=0}else{if(M){fa=C}else{fa=c[D>>2]|0}ba=$;ca=a[fa]|0;da=0;ea=0}while(1){do{if((ea|0)==(ca|0)){M=c[f>>2]|0;c[f>>2]=M+1;a[M]=o;M=da+1|0;Q=a[p]|0;O=(Q&1)==0;if(O){ga=(Q&255)>>>1}else{ga=c[E>>2]|0}if(!(M>>>0<ga>>>0)){ha=ca;ia=M;ja=0;break}if(O){ka=C}else{ka=c[D>>2]|0}if((a[ka+M|0]|0)==127){ha=-1;ia=M;ja=0;break}if(O){la=C}else{la=c[D>>2]|0}ha=a[la+M|0]|0;ia=M;ja=0}else{ha=ca;ia=da;ja=ea}}while(0);M=ba+ -1|0;O=a[M]|0;Q=c[f>>2]|0;c[f>>2]=Q+1;a[Q]=O;if((M|0)==(J|0)){break}else{ba=M;ca=ha;da=ia;ea=ja+1|0}}}P=c[f>>2]|0;if((I|0)==(P|0)){K=J;break a}M=P+ -1|0;if(M>>>0>I>>>0){ma=I;na=M}else{K=J;break a}while(1){M=a[ma]|0;a[ma]=a[na]|0;a[na]=M;M=ma+1|0;P=na+ -1|0;if(M>>>0<P>>>0){na=P;ma=M}else{K=J;break}}break};case 3:{J=a[r]|0;I=(J&1)==0;if(I){oa=(J&255)>>>1}else{oa=c[w>>2]|0}if((oa|0)==0){K=H;break a}if(I){pa=u}else{pa=c[v>>2]|0}I=a[pa]|0;J=c[f>>2]|0;c[f>>2]=J+1;a[J]=I;K=H;break};case 2:{I=a[q]|0;J=(I&1)==0;if(J){qa=(I&255)>>>1}else{qa=c[A>>2]|0}if((qa|0)==0|x){K=H;break a}if(J){ra=y;sa=(I&255)>>>1}else{ra=c[z>>2]|0;sa=c[A>>2]|0}I=ra+sa|0;J=c[f>>2]|0;if((ra|0)==(I|0)){ta=J}else{M=J;J=ra;while(1){a[M]=a[J]|0;P=J+1|0;O=M+1|0;if((P|0)==(I|0)){ta=O;break}else{J=P;M=O}}}c[f>>2]=ta;K=H;break};default:{K=H}}}while(0);M=h+1|0;if(M>>>0<4){H=K;h=M}else{break}}h=a[r]|0;r=(h&1)==0;if(r){ua=(h&255)>>>1}else{ua=c[w>>2]|0}if(ua>>>0>1){if(r){va=u;wa=(h&255)>>>1}else{va=c[v>>2]|0;wa=c[w>>2]|0}w=va+1|0;v=va+wa|0;wa=c[f>>2]|0;if((w|0)==(v|0)){xa=wa}else{va=wa;wa=w;while(1){a[va]=a[wa]|0;w=wa+1|0;h=va+1|0;if((w|0)==(v|0)){xa=h;break}else{wa=w;va=h}}}c[f>>2]=xa}xa=g&176;if((xa|0)==16){i=t;return}else if((xa|0)==32){c[e>>2]=c[f>>2];i=t;return}else{c[e>>2]=d;i=t;return}}function m0c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+104|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;_Wc(m,g);z=m;A=c[z>>2]|0;if(!((c[91590]|0)==-1)){c[l>>2]=366360;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366360,l,770)}l=(c[366364>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+1|0}else{I=c[j+8>>2]|0}C=a[I]|0;H=C<<24>>24==(xe[c[(c[A>>2]|0)+28>>2]&63](F,45)|0)<<24>>24}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;k0c(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=h4c(P)|0;if((N|0)!=0){Q=N;R=N;break}u4c()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+1|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}l0c(R,w,x,c[g+4>>2]|0,S,S+T|0,F,H,o,a[p]|0,a[q]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];BSc(b,k,R,e,w,g,h);if((Q|0)==0){cWc(t);cWc(s);cWc(r);U=c[z>>2]|0;V=U;W=V;X=uVc(W)|0;i=d;return}i4c(Q);cWc(t);cWc(s);cWc(r);U=c[z>>2]|0;V=U;W=V;X=uVc(W)|0;i=d;return}function n0c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function o0c(a){a=a|0;i=i;return}function p0c(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=+l;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;d=i;i=i+16|0;m=d;n=d+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+104|0;r=i;i=i+8|0;s=i;i=i+400|0;t=i;i=i+8|0;u=i;i=i+8|0;v=u;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+400|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=q;c[r>>2]=G;q=s;s=o;h[k>>3]=l;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];s=Mc(G|0,100,366112,o|0)|0;do{if(s>>>0>99){do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);o=c[91562]|0;G=n;h[k>>3]=l;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];G=b_c(r,o,366112,n)|0;o=c[r>>2]|0;if((o|0)==0){u4c()}H=h4c(G<<2)|0;I=H;if((H|0)!=0){J=o;K=I;L=I;M=G;break}u4c()}else{J=0;K=0;L=q;M=s}}while(0);_Wc(t,g);s=t;q=c[s>>2]|0;if(!((c[91588]|0)==-1)){c[p>>2]=366352;c[p+4>>2]=769;c[p+8>>2]=0;PVc(366352,p,770)}p=(c[366356>>2]|0)+ -1|0;n=c[q+8>>2]|0;if(!((c[q+12>>2]|0)-n>>2>>>0>p>>>0)){N=Ec(4)|0;O=N;O3c(O);P=381920;Q=127;Td(N|0,P|0,Q|0)}q=c[n+(p<<2)>>2]|0;if((q|0)==0){N=Ec(4)|0;O=N;O3c(O);P=381920;Q=127;Td(N|0,P|0,Q|0)}Q=q;P=c[r>>2]|0;He[c[(c[q>>2]|0)+48>>2]&63](Q,P,P+M|0,L)|0;if((M|0)==0){R=0}else{R=(a[c[r>>2]|0]|0)==45}c[u>>2]=0;u=y;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=z;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;u=A;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;q0c(f,R,t,v,w,x,y,z,A,B);t=C;C=c[B>>2]|0;if((M|0)>(C|0)){B=a[A]|0;if((B&1)==0){S=(B&255)>>>1}else{S=c[A+4>>2]|0}B=a[z]|0;if((B&1)==0){T=(B&255)>>>1}else{T=c[z+4>>2]|0}U=S+(M-C<<1|1)+T|0}else{T=a[A]|0;if((T&1)==0){V=(T&255)>>>1}else{V=c[A+4>>2]|0}T=a[z]|0;if((T&1)==0){W=(T&255)>>>1}else{W=c[z+4>>2]|0}U=V+2+W|0}W=U+C|0;do{if(W>>>0>100){U=h4c(W<<2)|0;V=U;if((U|0)!=0){X=V;Y=V;break}u4c()}else{X=0;Y=t}}while(0);r0c(Y,D,E,c[g+4>>2]|0,L,L+(M<<2)|0,Q,R,v,c[w>>2]|0,c[x>>2]|0,y,z,A,C);c[F>>2]=c[e>>2];e=c[D>>2]|0;D=c[E>>2]|0;E=m;C=F;c[E+0>>2]=c[C+0>>2];k_c(b,m,Y,e,D,g,j);if((X|0)!=0){i4c(X)}GWc(A);GWc(z);cWc(y);uVc(c[s>>2]|0)|0;if((K|0)!=0){i4c(K)}if((J|0)==0){i=d;return}i4c(J);i=d;return}function q0c(b,d,e,f,g,h,j,k,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0;n=i;i=i+40|0;o=n;p=n+16|0;q=n+32|0;r=q;s=i;i=i+16|0;t=i;i=i+8|0;u=t;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=B;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[e>>2]|0;if(b){if(!((c[91482]|0)==-1)){c[p>>2]=365928;c[p+4>>2]=769;c[p+8>>2]=0;PVc(365928,p,770)}p=(c[365932>>2]|0)+ -1|0;b=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-b>>2>>>0>p>>>0)){H=Ec(4)|0;I=H;O3c(I);J=381920;K=127;Td(H|0,J|0,K|0)}e=c[b+(p<<2)>>2]|0;if((e|0)==0){H=Ec(4)|0;I=H;O3c(I);J=381920;K=127;Td(H|0,J|0,K|0)}K=e;J=c[e>>2]|0;if(d){ge[c[J+44>>2]&255](r,K);r=f;H=c[q>>2]|0;a[r]=H;a[r+1|0]=H>>8;a[r+2|0]=H>>16;a[r+3|0]=H>>24;ge[c[(c[e>>2]|0)+32>>2]&255](s,K);H=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}JWc(l,0);r=s;c[H+0>>2]=c[r+0>>2];c[H+4>>2]=c[r+4>>2];c[H+8>>2]=c[r+8>>2];c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;GWc(s)}else{ge[c[J+40>>2]&255](u,K);u=f;J=c[t>>2]|0;a[u]=J;a[u+1|0]=J>>8;a[u+2|0]=J>>16;a[u+3|0]=J>>24;ge[c[(c[e>>2]|0)+28>>2]&255](v,K);J=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}JWc(l,0);u=v;c[J+0>>2]=c[u+0>>2];c[J+4>>2]=c[u+4>>2];c[J+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;GWc(v)}c[g>>2]=ie[c[(c[e>>2]|0)+12>>2]&127](K)|0;c[h>>2]=ie[c[(c[e>>2]|0)+16>>2]&127](K)|0;ge[c[(c[e>>2]|0)+20>>2]&255](w,K);v=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}oWc(j,0);u=w;c[v+0>>2]=c[u+0>>2];c[v+4>>2]=c[u+4>>2];c[v+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;cWc(w);ge[c[(c[e>>2]|0)+24>>2]&255](x,K);w=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}JWc(k,0);u=x;c[w+0>>2]=c[u+0>>2];c[w+4>>2]=c[u+4>>2];c[w+8>>2]=c[u+8>>2];c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;GWc(x);L=ie[c[(c[e>>2]|0)+36>>2]&127](K)|0;c[m>>2]=L;i=n;return}else{if(!((c[91466]|0)==-1)){c[o>>2]=365864;c[o+4>>2]=769;c[o+8>>2]=0;PVc(365864,o,770)}o=(c[365868>>2]|0)+ -1|0;K=c[G+8>>2]|0;if(!((c[G+12>>2]|0)-K>>2>>>0>o>>>0)){M=Ec(4)|0;N=M;O3c(N);O=381920;P=127;Td(M|0,O|0,P|0)}G=c[K+(o<<2)>>2]|0;if((G|0)==0){M=Ec(4)|0;N=M;O3c(N);O=381920;P=127;Td(M|0,O|0,P|0)}P=G;O=c[G>>2]|0;if(d){ge[c[O+44>>2]&255](z,P);z=f;d=c[y>>2]|0;a[z]=d;a[z+1|0]=d>>8;a[z+2|0]=d>>16;a[z+3|0]=d>>24;ge[c[(c[G>>2]|0)+32>>2]&255](A,P);d=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}JWc(l,0);z=A;c[d+0>>2]=c[z+0>>2];c[d+4>>2]=c[z+4>>2];c[d+8>>2]=c[z+8>>2];c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;GWc(A)}else{ge[c[O+40>>2]&255](C,P);C=f;f=c[B>>2]|0;a[C]=f;a[C+1|0]=f>>8;a[C+2|0]=f>>16;a[C+3|0]=f>>24;ge[c[(c[G>>2]|0)+28>>2]&255](D,P);f=l;if((a[l]&1)==0){c[l+4>>2]=0;a[l]=0}else{c[c[l+8>>2]>>2]=0;c[l+4>>2]=0}JWc(l,0);l=D;c[f+0>>2]=c[l+0>>2];c[f+4>>2]=c[l+4>>2];c[f+8>>2]=c[l+8>>2];c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;GWc(D)}c[g>>2]=ie[c[(c[G>>2]|0)+12>>2]&127](P)|0;c[h>>2]=ie[c[(c[G>>2]|0)+16>>2]&127](P)|0;ge[c[(c[G>>2]|0)+20>>2]&255](E,P);h=j;if((a[j]&1)==0){a[j+1|0]=0;a[j]=0}else{a[c[j+8>>2]|0]=0;c[j+4>>2]=0}oWc(j,0);j=E;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[j+0>>2]=0;c[j+4>>2]=0;c[j+8>>2]=0;cWc(E);ge[c[(c[G>>2]|0)+24>>2]&255](F,P);E=k;if((a[k]&1)==0){c[k+4>>2]=0;a[k]=0}else{c[c[k+8>>2]>>2]=0;c[k+4>>2]=0}JWc(k,0);k=F;c[E+0>>2]=c[k+0>>2];c[E+4>>2]=c[k+4>>2];c[E+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;GWc(F);L=ie[c[(c[G>>2]|0)+36>>2]&127](P)|0;c[m>>2]=L;i=n;return}}function r0c(b,d,e,f,g,h,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0;s=i;c[e>>2]=b;t=q+4|0;u=q+8|0;v=(f&512|0)==0;w=p+4|0;x=p+8|0;y=(r|0)>0;z=o+1|0;A=o+8|0;B=o+4|0;C=g;g=0;while(1){a:do{switch(a[l+g|0]|0){case 1:{c[d>>2]=c[e>>2];D=xe[c[(c[j>>2]|0)+44>>2]&63](j,32)|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 4:{D=c[e>>2]|0;E=k?C+4|0:C;b:do{if(E>>>0<h>>>0){G=E;while(1){H=G+4|0;if(!(le[c[(c[j>>2]|0)+12>>2]&63](j,2048,c[G>>2]|0)|0)){I=G;break b}if(H>>>0<h>>>0){G=H}else{I=H;break}}}else{I=E}}while(0);if(y){do{if(I>>>0>E>>>0){G=c[e>>2]|0;H=I;J=r;while(1){K=H+ -4|0;L=G+4|0;c[G>>2]=c[K>>2];M=J+ -1|0;N=(M|0)>0;if(K>>>0>E>>>0&N){J=M;H=K;G=L}else{break}}c[e>>2]=L;if(N){O=K;P=M;Q=34;break}G=c[e>>2]|0;c[e>>2]=G+4;R=G;S=K}else{O=I;P=r;Q=34}}while(0);do{if((Q|0)==34){Q=0;G=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;H=c[e>>2]|0;J=H+4|0;c[e>>2]=J;if((P|0)>0){T=J;U=H;V=P}else{R=H;S=O;break}while(1){c[U>>2]=G;J=V+ -1|0;if((J|0)>0){V=J;U=T;T=T+4|0}else{break}}c[e>>2]=H+(P+1<<2);R=H+(P<<2)|0;S=O}}while(0);c[R>>2]=m;W=S}else{W=I}if((W|0)==(E|0)){G=xe[c[(c[j>>2]|0)+44>>2]&63](j,48)|0;J=c[e>>2]|0;X=J+4|0;c[e>>2]=X;c[J>>2]=G;Y=X}else{X=a[o]|0;G=(X&1)==0;if(G){Z=(X&255)>>>1}else{Z=c[B>>2]|0}if((Z|0)==0){_=W;$=-1;aa=0;ba=0}else{if(G){ca=z}else{ca=c[A>>2]|0}_=W;$=a[ca]|0;aa=0;ba=0}while(1){G=c[e>>2]|0;do{if((ba|0)==($|0)){X=G+4|0;c[e>>2]=X;c[G>>2]=n;J=aa+1|0;da=a[o]|0;ea=(da&1)==0;if(ea){fa=(da&255)>>>1}else{fa=c[B>>2]|0}if(!(J>>>0<fa>>>0)){ga=X;ha=$;ia=J;ja=0;break}if(ea){ka=z}else{ka=c[A>>2]|0}if((a[ka+J|0]|0)==127){ga=X;ha=-1;ia=J;ja=0;break}if(ea){la=z}else{la=c[A>>2]|0}ga=X;ha=a[la+J|0]|0;ia=J;ja=0}else{ga=G;ha=$;ia=aa;ja=ba}}while(0);G=_+ -4|0;H=c[G>>2]|0;J=ga+4|0;c[e>>2]=J;c[ga>>2]=H;if((G|0)==(E|0)){Y=J;break}else{_=G;$=ha;aa=ia;ba=ja+1|0}}}if((D|0)==(Y|0)){F=E;break a}G=Y+ -4|0;if(G>>>0>D>>>0){ma=D;na=G}else{F=E;break a}while(1){G=c[ma>>2]|0;c[ma>>2]=c[na>>2];c[na>>2]=G;G=ma+4|0;J=na+ -4|0;if(G>>>0<J>>>0){na=J;ma=G}else{F=E;break}}break};case 3:{E=a[q]|0;D=(E&1)==0;if(D){oa=(E&255)>>>1}else{oa=c[t>>2]|0}if((oa|0)==0){F=C;break a}if(D){pa=t}else{pa=c[u>>2]|0}D=c[pa>>2]|0;E=c[e>>2]|0;c[e>>2]=E+4;c[E>>2]=D;F=C;break};case 0:{c[d>>2]=c[e>>2];F=C;break};case 2:{D=a[p]|0;E=(D&1)==0;if(E){qa=(D&255)>>>1}else{qa=c[w>>2]|0}if((qa|0)==0|v){F=C;break a}if(E){ra=w;sa=(D&255)>>>1}else{ra=c[x>>2]|0;sa=c[w>>2]|0}D=ra+(sa<<2)|0;E=c[e>>2]|0;if((ra|0)==(D|0)){ta=E}else{G=(ra+(sa+ -1<<2)+(0-ra)|0)>>>2;J=E;H=ra;while(1){c[J>>2]=c[H>>2];X=H+4|0;if((X|0)==(D|0)){break}J=J+4|0;H=X}ta=E+(G+1<<2)|0}c[e>>2]=ta;F=C;break};default:{F=C}}}while(0);H=g+1|0;if(H>>>0<4){C=F;g=H}else{break}}g=a[q]|0;q=(g&1)==0;if(q){ua=(g&255)>>>1}else{ua=c[t>>2]|0}if(ua>>>0>1){if(q){va=t;wa=(g&255)>>>1}else{va=c[u>>2]|0;wa=c[t>>2]|0}t=va+4|0;u=va+(wa<<2)|0;g=c[e>>2]|0;if((t|0)==(u|0)){xa=g}else{q=(va+(wa+ -1<<2)+(0-t)|0)>>>2;wa=g;va=t;while(1){c[wa>>2]=c[va>>2];t=va+4|0;if((t|0)==(u|0)){break}else{va=t;wa=wa+4|0}}xa=g+(q+1<<2)|0}c[e>>2]=xa}xa=f&176;if((xa|0)==32){c[d>>2]=c[e>>2];i=s;return}else if((xa|0)==16){i=s;return}else{c[d>>2]=b;i=s;return}}



function rSc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[a+256>>2]<<2;c[83470]=Ad(zWc(b)|0)|0;c[333884>>2]=g;c[333888>>2]=d;d=a+284|0;do{if((c[84880]|0)==0){g=c[d>>2]|0;if((H4c(340328,g)|0)==0){h=0;break}if((H4c(340336,g)|0)==0){c[333896>>2]=133;c[333900>>2]=134;c[333908>>2]=135;h=0;break}if((H4c(340344,g)|0)==0){c[333896>>2]=136;c[333900>>2]=137;c[333904>>2]=138;c[333908>>2]=139;h=1;break}if((H4c(340352,g)|0)==0){c[333896>>2]=140;c[333900>>2]=141;c[333904>>2]=142;c[333908>>2]=143;h=1;break}if((H4c(340360,g)|0)==0){c[333896>>2]=144;c[333900>>2]=145;c[333908>>2]=146;h=0;break}g=lSc(361720,340368)|0;pYc(lSc(g,c[d>>2]|0)|0,103)|0;j=1;i=e;return j|0}else{h=0}}while(0);nSc(a+8|0,c[a+288>>2]|0,h);ge[c[333896>>2]&255](333880,a);a=c[83470]|0;c[f>>2]=c[d>>2];c[f+4>>2]=a;EBc(23,0,340392,f);j=0;i=e;return j|0}function sSc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16|0;v=i;i=i+16|0;vBc();do{if((ETc(a,b)|0)==0){if((GTc(a,b)|0)!=0){break}do{if((c[349184>>2]|0)!=0){w=c[349312>>2]|0;if((H4c(w,340776)|0)==0){BBc(1);break}if((H4c(w,340784)|0)==0){BBc(0);break}else{c[p>>2]=w;GBc(1,0,340792,p);ud(0)|0;Cd(0)}}}while(0);if((c[349140>>2]|0)==0){gSc(0,0);NEc(d);if((d|0)==0){pYc(lSc(361720,341160)|0,103)|0}c[d+300>>2]=iSc(0,0)|0;c[d+292>>2]=kSc(0,0)|0;WKc(d+8|0,d+240|0);WEc(d)|0;cFc(d)|0;oFc(d)|0;do{if((c[d+116>>2]|0)==0){if((c[d+124>>2]|0)==0){break}if((c[d+128>>2]|0)==0){break}pYc(lSc(361720,341224)|0,103)|0;x=1;i=e;return x|0}}while(0);c[84880]=c[349208>>2];x=0;i=e;return x|0}YVc(u,c[349268>>2]|0);w=1;while(1){y=297168+(w<<2)|0;YVc(v,c[y>>2]|0);z=hSc(u,v)|0;cWc(v);A=w+1|0;if(z){break}if((A|0)<31){w=A}else{B=33;break}}if((B|0)==33){c[g>>2]=zWc(u)|0;GBc(1,0,341064,g);c[f>>2]=c[b>>2];GBc(1,0,341104,f);ud(0)|0;Cd(0)}A=c[301192+(w<<2)>>2]|0;do{if((A|0)==1){z=c[301064+(w<<2)>>2]|0;c[o>>2]=c[y>>2];c[o+4>>2]=z;EBc(1,1,340864,o)}else{z=c[y>>2]|0;if((A|0)==2){C=c[301064+(w<<2)>>2]|0;c[n>>2]=z;c[n+4>>2]=z;c[n+8>>2]=C;EBc(1,1,340904,n);break}else{c[m>>2]=z;GBc(1,1,340744,m);break}}}while(0);if((w|0)==19){A=c[72648]|0;if((A|0)<28){D=A}else{E=292856;F=c[73214]|0;fe[F&1023](1);G=ud(0)|0;Cd(0)}do{A=c[292176+(D<<2)>>2]|0;c[l>>2]=c[291008+(D<<2)>>2];c[l+4>>2]=A;EBc(1,0,339568,l);D=D+1|0;}while((D|0)<28);E=292856;F=c[73214]|0;fe[F&1023](1);G=ud(0)|0;Cd(0)}else if((w|0)==11){A=1;do{z=c[341032+(A<<2)>>2]|0;c[j>>2]=c[341e3+(A<<2)>>2];c[j+4>>2]=z;EBc(1,0,339568,j);A=A+1|0;}while((A|0)<7);E=292856;F=c[73214]|0;fe[F&1023](1);G=ud(0)|0;Cd(0)}else if((w|0)==7){A=1;do{z=c[340984+(A<<2)>>2]|0;c[k>>2]=c[340968+(A<<2)>>2];c[k+4>>2]=z;EBc(1,0,339568,k);A=A+1|0;}while((A|0)<4);E=292856;F=c[73214]|0;fe[F&1023](1);G=ud(0)|0;Cd(0)}else if((w|0)==29){A=1;do{z=c[340576+(A<<2)>>2]|0;c[h>>2]=c[340464+(A<<2)>>2];c[h+4>>2]=z;EBc(1,0,339568,h);A=A+1|0;}while((A|0)<20);E=292856;F=c[73214]|0;fe[F&1023](1);G=ud(0)|0;Cd(0)}else{E=292856;F=c[73214]|0;fe[F&1023](1);G=ud(0)|0;Cd(0)}}}while(0);c[t>>2]=c[b>>2];EBc(1,1,340680,t);t=1;do{b=c[301192+(t<<2)>>2]|0;do{if((b|0)==1){G=c[299072+(t<<2)>>2]|0;c[s>>2]=c[297168+(t<<2)>>2];c[s+4>>2]=G;EBc(1,0,340696,s)}else{G=c[297168+(t<<2)>>2]|0;if((b|0)==2){F=c[299072+(t<<2)>>2]|0;c[r>>2]=G;c[r+4>>2]=G;c[r+8>>2]=F;EBc(1,0,340712,r);break}else{c[q>>2]=G;GBc(1,0,340744,q);break}}}while(0);t=t+1|0;}while((t|0)<31);fe[c[73214]&1023](1);ud(0)|0;Cd(0);return 0}function tSc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0;a=i;i=i+8|0;b=a;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=c[85314]|0;tb(342840)|0;c[l>>2]=c[m+88>>2];gc(341264,l|0)|0;tb(342856)|0;l=j;h[k>>3]=+h[m+264>>3];c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];gc(341288,j|0)|0;j=m+4|0;m=g;h[k>>3]=+h[c[(c[j>>2]|0)+4>>2]>>3];c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];gc(341328,g|0)|0;g=f;h[k>>3]=+h[c[(c[j>>2]|0)+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(341360,f|0)|0;f=c[j>>2]|0;g=e;h[k>>3]=+h[c[f+4>>2]>>3]- +h[c[f+8>>2]>>3];c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];gc(341392,e|0)|0;e=d;h[k>>3]=+h[c[c[j>>2]>>2]>>3];c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];gc(341424,d|0)|0;d=c[j>>2]|0;j=b;h[k>>3]=+h[c[d>>2]>>3]- +h[c[d+4>>2]>>3];c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];gc(341456,b|0)|0;tb(342880)|0;i=a;return}function uSc(a,b){a=a|0;b=+b;i=i;return}function vSc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0;e=i;f=i;i=i+168|0;c[f>>2]=0;g=i;i=i+160|0;h=(c[d+536>>2]|0)+76|0;j=c[h>>2]|0;c[h>>2]=g;K4c(g,1,f|0)|0;u=0;g=u;u=0;if((g|0)!=0&(v|0)!=0){k=Y4c(c[g>>2]|0,f)|0;if((k|0)==0){eb(g|0,v|0)}J=v}else{k=-1}if((k|0)==1){l=J}else{l=0}while(1){if((l|0)==0){u=0;k=va(41,a|0,b|0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){m=Y4c(c[g>>2]|0,f)|0;if((m|0)==0){eb(g|0,v|0)}J=v}else{m=-1}if((m|0)==1){l=J;continue}if((k|0)!=0){n=1;o=17;break}c[85314]=d;u=0;Ha(61,10,765)|0;k=u;u=0;if((k|0)!=0&(v|0)!=0){p=Y4c(c[k>>2]|0,f)|0;if((p|0)==0){eb(k|0,v|0)}J=v}else{p=-1}if((p|0)==1){l=J;continue}u=0;k=va(42,0,0,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){q=Y4c(c[g>>2]|0,f)|0;if((q|0)==0){eb(g|0,v|0)}J=v}else{q=-1}if((q|0)==1){l=J;continue}u=0;sa(108,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){r=Y4c(c[g>>2]|0,f)|0;if((r|0)==0){eb(g|0,v|0)}J=v}else{r=-1}if((r|0)==1){l=J;continue}u=0;sa(109,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){s=Y4c(c[g>>2]|0,f)|0;if((s|0)==0){eb(g|0,v|0)}J=v}else{s=-1}if((s|0)==1){l=J;continue}u=0;sa(110,d|0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){t=Y4c(c[g>>2]|0,f)|0;if((t|0)==0){eb(g|0,v|0)}J=v}else{t=-1}if((t|0)==1){l=J;continue}u=0;pa(c[(c[d+540>>2]|0)+8>>2]|0,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){w=Y4c(c[g>>2]|0,f)|0;if((w|0)==0){eb(g|0,v|0)}J=v}else{w=-1}if((w|0)==1){l=J;continue}u=0;pa(766,d|0);g=u;u=0;if((g|0)!=0&(v|0)!=0){x=Y4c(c[g>>2]|0,f)|0;if((x|0)==0){eb(g|0,v|0)}J=v}else{x=-1}if((x|0)==1){l=J;continue}u=0;sa(99,0)|0;g=u;u=0;if((g|0)!=0&(v|0)!=0){y=Y4c(c[g>>2]|0,f)|0;if((y|0)==0){eb(g|0,v|0)}J=v}else{y=-1}if((y|0)==1){l=J;continue}z=k}else{z=-1}c[h>>2]=j;u=0;k=u;u=0;if((k|0)!=0&(v|0)!=0){A=Y4c(c[k>>2]|0,f)|0;if((A|0)==0){eb(k|0,v|0)}J=v}else{A=-1}if((A|0)==1){l=J}else{break}}if((o|0)==17){i=e;return n|0}n=z;i=e;return n|0}function wSc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;f=i;i=i+16|0;if((a|0)==0){g=md(c[72532]|0)|0}else{g=a}switch(c[g+84>>2]|0){case 3:{if((c[292372>>2]|0)==0){i=b;return}c[f>>2]=e;a=c[r>>2]|0;rc(341528,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Sd(10,a|0)|0;ud(0)|0;i=b;return};case 2:{if((c[292316>>2]|0)==0){h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1)}c[f>>2]=e;a=c[r>>2]|0;rc(341528,7,1,a|0)|0;Dc(a|0,d|0,f|0)|0;Sd(10,a|0)|0;ud(0)|0;h=g;j=h+80|0;k=j;l=c[k>>2]|0;m=l;n=m;eb(n|0,1);break};case 1:{c[f>>2]=e;e=c[r>>2]|0;rc(341528,7,1,e|0)|0;Dc(e|0,d|0,f|0)|0;Sd(10,e|0)|0;ud(0)|0;eb(c[g+80>>2]|0,1);break};case 5:case 4:{i=b;return};default:{IBc(g,341536,b)}}}function xSc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;a=i;i=i+16|0;e=a;c[e>>2]=d;d=c[r>>2]|0;rc(341512,9,1,d|0)|0;Dc(d|0,b|0,e|0)|0;Sd(10,d|0)|0;ud(0)|0;i=a;return}function ySc(a,b){a=a|0;b=b|0;var c=0;c=i;ASc(a,b);i=c;return}function zSc(a){a=a|0;i=i;return(c[a>>2]|0)==0|0}function ASc(a,b){a=a|0;b=b|0;var d=0;d=i;c[a>>2]=XWc(b+(c[(c[b>>2]|0)+ -12>>2]|0)|0)|0;i=d;return}function BSc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;j=i;i=i+48|0;k=j+8|0;l=j+16|0;m=j+32|0;n=j+40|0;o=b;b=c[o>>2]|0;xHc(j);if((b|0)==0){c[a>>2]=0;i=j;return}p=f;f=d;q=p-f|0;r=CSc(g)|0;s=(r|0)>(q|0)?r-q|0:0;q=e;r=q-f|0;do{if((r|0)>0){if((hXc(b,d,r)|0)==(r|0)){break}xHc(k);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);do{if((s|0)>0){ZVc(l,s,h);if((hXc(b,bWc(l)|0,s)|0)==(s|0)){cWc(l);break}xHc(m);c[o>>2]=0;c[a>>2]=0;cWc(l);i=j;return}}while(0);l=p-q|0;do{if((l|0)>0){if((hXc(b,e,l)|0)==(l|0)){break}xHc(n);c[o>>2]=0;c[a>>2]=0;i=j;return}}while(0);DSc(g,0)|0;c[a>>2]=b;i=j;return}function CSc(a){a=a|0;i=i;return c[a+12>>2]|0}function DSc(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function ESc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;i=i+136|0;g=f;FSc(g,16);GSc(g+(c[(c[g>>2]|0)+ -12>>2]|0)|0,16)|0;if((d|0)<=0){HSc(a,g);ISc(g);i=f;return}j=e+ -1|0;k=(j|0)>0;l=(e|0)>0;m=g;n=(e|0)==0;e=0;do{if(k){o=0;p=e;while(1){lSc(qYc(m,+h[b+(p<<3)>>3])|0,342896)|0;q=p+d|0;r=o+1|0;if((r|0)<(j|0)){p=q;o=r}else{s=q;break}}}else{s=e}if(l){qYc(m,+h[b+(s<<3)>>3])|0}e=e+1|0;if(!((e|0)==(d|0)|n)){lSc(m,342904)|0}}while((e|0)<(d|0));HSc(a,g);ISc(g);i=f;return}function FSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=a+56|0;$Wc(e);f=a;c[f>>2]=343276;g=e;c[g>>2]=343296;e=a+4|0;gYc(a,343308|0,e);c[f>>2]=343276;c[g>>2]=343296;USc(e,b|16);i=d;return}function GSc(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;a=c[d>>2]|0;c[d>>2]=b;i=i;return a|0}function HSc(a,b){a=a|0;b=b|0;var c=0;c=i;OSc(a,b+4|0);i=c;return}function ISc(a){a=a|0;var b=0;b=i;YSc(a,343304);WWc(a+56|0);i=b;return}function JSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+120>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[292360>>2]|0)!=0){tb(343600)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(14,0,342912,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+160>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(14,0,342984,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[292360>>2]|0)==0){i=d;return 0}EBc(14,0,343032,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(343048,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function KSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+124>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[292360>>2]|0)!=0){tb(343600)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(14,0,342912,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+164>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(14,0,342984,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[292360>>2]|0)==0){i=d;return 0}EBc(14,0,343032,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(343048,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function LSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+128>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[292360>>2]|0)!=0){tb(343600)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(14,0,342912,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+168>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(14,0,342984,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[292360>>2]|0)==0){i=d;return 0}EBc(14,0,343032,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(343048,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function MSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;j=i;i=i+16|0;l=a+540|0;m=c[(c[l>>2]|0)+132>>2]|0;n=a+464|0;o=c[n>>2]|0;if((c[o+(m*44|0)>>2]|0)!=0){p=a;a=o;o=0;q=0;while(1){h[(c[a+(m*44|0)+28>>2]|0)+(o<<3)>>3]=1.0;do{if((c[292360>>2]|0)!=0){tb(343600)|0;r=c[n>>2]|0;if((c[r+(m*44|0)>>2]|0)==0){break}else{s=r;t=0}do{u=+h[(c[s+(m*44|0)+28>>2]|0)+(t<<3)>>3];c[j>>2]=t;r=j+4|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(14,0,342912,j);t=t+1|0;s=c[n>>2]|0;}while(t>>>0<(c[s+(m*44|0)>>2]|0)>>>0)}}while(0);ie[c[(c[l>>2]|0)+172>>2]&127](p)|0;r=c[n>>2]|0;if((c[r+(m*44|0)+4>>2]|0)==0){v=r;w=q}else{x=r;r=0;y=q;while(1){z=(c[x+(m*44|0)+36>>2]|0)+(r<<3)|0;u=+h[z>>3];A=y+1|0;h[b+(y<<3)>>3]=u;B=+h[z>>3];c[g>>2]=y;c[g+4>>2]=o;c[g+8>>2]=r;z=g+12|0;h[k>>3]=u;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];c[g+20>>2]=o;z=g+24|0;h[k>>3]=B;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(14,0,342984,g);z=r+1|0;C=c[n>>2]|0;if(z>>>0<(c[C+(m*44|0)+4>>2]|0)>>>0){y=A;r=z;x=C}else{v=C;w=A;break}}}h[(c[v+(m*44|0)+28>>2]|0)+(o<<3)>>3]=0.0;x=o+1|0;if(x>>>0<(c[v+(m*44|0)>>2]|0)>>>0){a=v;o=x;q=w}else{break}}}if((c[292360>>2]|0)==0){i=d;return 0}EBc(14,0,343032,f);f=c[n>>2]|0;if((c[f+(m*44|0)+4>>2]|0)==0){i=d;return 0}else{D=f;E=0}do{f=c[D+(m*44|0)>>2]|0;if((f|0)!=0){w=f;f=0;do{B=+h[b+((fa(w,f)|0)+E<<3)>>3];q=e;h[k>>3]=B;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];gc(343048,e|0)|0;f=f+1|0;w=c[(c[n>>2]|0)+(m*44|0)>>2]|0;}while(f>>>0<w>>>0)}dc(10)|0;E=E+1|0;D=c[n>>2]|0;}while(E>>>0<(c[D+(m*44|0)+4>>2]|0)>>>0);i=d;return 0}function NSc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;b=i;i=i+24|0;d=b;e=i;i=i+24|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=c[a+112>>2]|0;G=c[a+152>>2]|0;H=c[a+156>>2]|0;I=j4c(fa(F,F)|0,8)|0;J=I;K=j4c(fa(G,F)|0,8)|0;L=K;M=j4c(fa(H,F)|0,8)|0;N=M;O=j4c(fa(H,G)|0,8)|0;P=O;SVc(p);SVc(q);SVc(r);SVc(s);SVc(t);SVc(u);SVc(v);Q=a+536|0;HBc(c[Q>>2]|0,(I|0)!=0|0,343056,o);HBc(c[Q>>2]|0,(K|0)!=0|0,343056,n);HBc(c[Q>>2]|0,(M|0)!=0|0,343056,m);HBc(c[Q>>2]|0,(O|0)!=0|0,343056,l);l=a+540|0;m=a;if((ie[c[(c[l>>2]|0)+140>>2]&127](m)|0)==0){n=c[Q>>2]|0;JSc(a,J)|0;HBc(n,1,343072,k)}ESc(w,J,F,F);dWc(p,w)|0;cWc(w);if((ie[c[(c[l>>2]|0)+144>>2]&127](m)|0)==0){w=c[Q>>2]|0;KSc(a,L)|0;HBc(w,1,343104,j)}ESc(x,L,F,G);dWc(q,x)|0;cWc(x);if((ie[c[(c[l>>2]|0)+148>>2]&127](m)|0)==0){x=c[Q>>2]|0;LSc(a,N)|0;HBc(x,1,343136,h)}ESc(y,N,H,F);dWc(r,y)|0;cWc(y);if((ie[c[(c[l>>2]|0)+152>>2]&127](m)|0)==0){m=c[Q>>2]|0;MSc(a,P)|0;HBc(m,1,343168,g)}ESc(z,P,H,G);dWc(s,z)|0;cWc(z);if((F|0)==0){eWc(t,343200)|0}else{ESc(A,c[(c[c[a+4>>2]>>2]|0)+8>>2]|0,1,F);dWc(t,A)|0;cWc(A)}if((G|0)==0){eWc(u,343200)|0}else{ESc(B,c[a+432>>2]|0,1,G);dWc(u,B)|0;cWc(B)}i4c(I);i4c(K);i4c(M);i4c(O);YVc(E,c[a+84>>2]|0);NWc(D,343216,E);ZKc(C,D,343224);dWc(v,C)|0;cWc(C);cWc(D);cWc(E);E=ic(zWc(v)|0,343232)|0;D=c[Q>>2]|0;c[f>>2]=zWc(v)|0;HBc(D,(E|0)!=0|0,343240,f);f=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;D=zWc(t)|0;Q=zWc(u)|0;C=zWc(p)|0;a=zWc(q)|0;O=zWc(r)|0;M=zWc(s)|0;c[e>>2]=D;c[e+4>>2]=Q;c[e+8>>2]=C;c[e+12>>2]=a;c[e+16>>2]=O;c[e+20>>2]=M;wd(E|0,f|0,e|0)|0;if((c[292404>>2]|0)==0){R=ud(E|0)|0;S=Yc(E|0)|0;cWc(v);cWc(u);cWc(t);cWc(s);cWc(r);cWc(q);cWc(p);i=b;return 0}e=Ce[c[(c[l>>2]|0)+176>>2]&7]()|0;l=zWc(t)|0;f=zWc(u)|0;M=zWc(p)|0;O=zWc(q)|0;a=zWc(r)|0;C=zWc(s)|0;c[d>>2]=l;c[d+4>>2]=f;c[d+8>>2]=M;c[d+12>>2]=O;c[d+16>>2]=a;c[d+20>>2]=C;EBc(25,0,e,d);R=ud(E|0)|0;S=Yc(E|0)|0;cWc(v);cWc(u);cWc(t);cWc(s);cWc(r);cWc(q);cWc(p);i=b;return 0}function OSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+24|0;e=d;f=d+8|0;g=d+16|0;h=c[b+48>>2]|0;if((h&16|0)!=0){j=b+44|0;k=c[j>>2]|0;l=b;m=pXc(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}PSc(a,oXc(l)|0,n,e);i=d;return}if((h&8|0)==0){TVc(a,g);i=d;return}else{g=b;b=jXc(g)|0;PSc(a,b,lXc(g)|0,f);i=d;return}}function PSc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;QSc(a,b,c,0);i=d;return}function QSc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;d=i;RSc(a,b,c);i=d;return}function RSc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=SSc(c,d)|0;if(g>>>0>4294967279){QVc(0)}if(g>>>0<11){iWc(b,g);h=hWc(b)|0}else{j=pWc(g)|0;k=j+1|0;j=JLc(XVc(b)|0,k)|0;rWc(b,j);qWc(b,k);gWc(b,g);h=j}if((c|0)==(d|0)){l=h;a[f]=0;KLc(l,f);i=e;return}j=d+(0-c)|0;g=c;c=h;while(1){KLc(c,g);b=g+1|0;if((b|0)==(d|0)){break}else{c=c+1|0;g=b}}l=h+j|0;a[f]=0;KLc(l,f);i=e;return}function SSc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=TSc(b,c,e)|0;i=d;return g|0}function TSc(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return b-a|0}function USc(a,b){a=a|0;b=b|0;var c=0;c=i;iTc(a,b);i=c;return}function VSc(a){a=a|0;var b=0;b=i;ISc(a);p4c(a);i=b;return}function WSc(a){a=a|0;var b=0;b=i;ISc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function XSc(a){a=a|0;var b=0;b=i;VSc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function YSc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];ZSc(a+4|0);i=d;return}function ZSc(a){a=a|0;var b=0;b=i;_Sc(a);i=b;return}function _Sc(a){a=a|0;var b=0;b=i;c[a>>2]=343456;cWc(a+32|0);dXc(a);i=b;return}function $Sc(a){a=a|0;var b=0;b=i;ZSc(a);p4c(a);i=b;return}function aTc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;j=b+44|0;k=c[j>>2]|0;l=b;m=pXc(l)|0;if(k>>>0<m>>>0){c[j>>2]=m;n=m}else{n=k}k=g&24;do{if((k|0)==0){LGc(a,-1,-1);i=h;return}else if((k|0)==24){if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}LGc(a,-1,-1);i=h;return}else{if((f|0)==0){o=0;p=0;break}else if((f|0)==2){q=11;break}else if((f|0)!=1){q=12;break}if((g&8|0)==0){m=pXc(l)|0;j=m-(oXc(l)|0)|0;o=j;p=((j|0)<0)<<31>>31;break}else{j=kXc(l)|0;m=j-(jXc(l)|0)|0;o=m;p=((m|0)<0)<<31>>31;break}}}while(0);if((q|0)==11){f=n-(bWc(b+32|0)|0)|0;o=f;p=((f|0)<0)<<31>>31}else if((q|0)==12){LGc(a,-1,-1);i=h;return}q=V4c(o|0,p|0,d|0,e|0)|0;e=J;do{if(!((e|0)<0|(e|0)==0&q>>>0<0)){d=n-(bWc(b+32|0)|0)|0;p=((d|0)<0)<<31>>31;if((p|0)<(e|0)|(p|0)==(e|0)&d>>>0<q>>>0){break}d=g&8;do{if(!((q|0)==0&(e|0)==0)){do{if((d|0)!=0){if((kXc(l)|0)!=0){break}LGc(a,-1,-1);i=h;return}}while(0);if((g&16|0)==0){break}if((pXc(l)|0)!=0){break}LGc(a,-1,-1);i=h;return}}while(0);if((d|0)!=0){p=jXc(l)|0;nXc(l,p,p+q|0,n)}if((g&16|0)!=0){p=oXc(l)|0;sXc(l,p,qXc(l)|0);rXc(l,q)}LGc(a,q,e);i=h;return}}while(0);LGc(a,-1,-1);i=h;return}function bTc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[(c[b>>2]|0)+16>>2]|0;h=ZHc(d)|0;re[g&31](a,b,h,J,0,e);i=f;return}function cTc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=b+44|0;f=c[e>>2]|0;g=b;h=pXc(g)|0;if(f>>>0<h>>>0){c[e>>2]=h;j=h}else{j=f}if((c[b+48>>2]&8|0)==0){k=-1;i=d;return k|0}if((lXc(g)|0)>>>0<j>>>0){b=jXc(g)|0;nXc(g,b,kXc(g)|0,j)}j=kXc(g)|0;if(!(j>>>0<(lXc(g)|0)>>>0)){k=-1;i=d;return k|0}k=vIc(a[j]|0)|0;i=d;return k|0}function dTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=b+44|0;g=c[f>>2]|0;h=b;j=pXc(h)|0;if(g>>>0<j>>>0){c[f>>2]=j;k=j}else{k=g}g=jXc(h)|0;j=kXc(h)|0;if(!(g>>>0<j>>>0)){l=-1;i=e;return l|0}if(rIc(d,-1)|0){nXc(h,g,j+ -1|0,k);l=uIc(d)|0;i=e;return l|0}g=(c[b+48>>2]&16|0)==0;b=sIc(d)|0;do{if(g){if(wIc(b,a[j+ -1|0]|0)|0){break}else{l=-1}i=e;return l|0}}while(0);j=jXc(h)|0;nXc(h,j,(kXc(h)|0)+ -1|0,k);a[kXc(h)|0]=b;l=d;i=e;return l|0}function eTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+8|0;e=d;if(rIc(b,-1)|0){f=uIc(b)|0;i=d;return f|0}g=a;h=kXc(g)|0;j=h-(jXc(g)|0)|0;h=pXc(g)|0;do{if((h|0)==(qXc(g)|0)){k=a+48|0;if((c[k>>2]&16|0)==0){f=-1;i=d;return f|0}else{l=oXc(g)|0;m=a+44|0;n=(c[m>>2]|0)-l|0;o=a+32|0;uWc(o,0);nWc(o,kWc(o)|0);p=bWc(o)|0;sXc(g,p,p+(aWc(o)|0)|0);rXc(g,h-l|0);c[m>>2]=(oXc(g)|0)+n;q=k;r=m;break}}else{q=a+48|0;r=a+44|0}}while(0);c[e>>2]=(pXc(g)|0)+1;h=c[(fTc(e,r)|0)>>2]|0;c[r>>2]=h;if((c[q>>2]&8|0)!=0){q=bWc(a+32|0)|0;nXc(g,q,q+j|0,h)}f=gXc(g,b&255)|0;i=d;return f|0}function fTc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=gTc(b,c,e)|0;i=d;return g|0}function gTc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=hTc(0,a,b)|0;i=c;return(d?b:a)|0}function hTc(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function iTc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;iXc(a);c[a>>2]=343456;SVc(a+32|0);c[a+44>>2]=0;c[a+48>>2]=b;SVc(e);jTc(a,e);cWc(e);i=d;return}function jTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+32|0;dWc(e,b)|0;b=a+44|0;c[b>>2]=0;f=a+48|0;g=c[f>>2]|0;if((g&8|0)==0){h=g}else{g=bWc(e)|0;j=g+(aWc(e)|0)|0;c[b>>2]=j;g=bWc(e)|0;nXc(a,g,g,j);h=c[f>>2]|0}if((h&16|0)==0){i=d;return}h=aWc(e)|0;c[b>>2]=(bWc(e)|0)+h;nWc(e,kWc(e)|0);b=a;a=bWc(e)|0;sXc(b,a,a+(aWc(e)|0)|0);if((c[f>>2]&3|0)==0){i=d;return}rXc(b,h);i=d;return}function kTc(b,d,e,f,g,j,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0,R=0;j=i;i=i+8|0;g=j;m=i;i=i+8|0;n=i;i=i+16|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=ic(d|0,343880)|0;J=bd(343888,343880)|0;K=(J|0)!=0;L=Nc()|0;if(K){M=c[b+536>>2]|0;N=Wd(c[L>>2]|0)|0;c[E>>2]=d;c[E+4>>2]=N;HBc(M,(I|0)!=0|0,343944,E);rc(343968,17,1,J|0)|0;rc(343992,10,1,J|0)|0;rc(344008,18,1,J|0)|0;lTc(J,f,344032,c[b+88>>2]|0,(c[b+72>>2]|0)+(c[b+64>>2]|0)|0,-1,999,344064)}else{c[G>>2]=Wd(c[L>>2]|0)|0;GBc(26,0,343896,G);G=c[b+536>>2]|0;E=Wd(c[L>>2]|0)|0;c[F>>2]=d;c[F+4>>2]=E;HBc(G,(I|0)!=0|0,343944,F)}rc(344072,348,1,I|0)|0;if((sc(H|0)|0)<0){c[D>>2]=Wd(c[L>>2]|0)|0;GBc(26,0,344424,D);Yc(I|0)|0;ab(J|0)|0;O=1;i=j;return O|0}if((Sc(343624,250,344448,kd(H|0)|0)|0)==0){GBc(26,0,344472,C);Yc(I|0)|0;O=1;i=j;return O|0}rc(344496,13,1,I|0)|0;rc(344512,12,1,I|0)|0;mTc(I,2);rc(344528,6,1,I|0)|0;nTc(I,c[b+84>>2]|0);rc(344536,8,1,I|0)|0;mTc(I,2);rc(344552,8,1,I|0)|0;C=b+88|0;nTc(I,c[C>>2]|0);rc(344568,10,1,I|0)|0;mTc(I,2);rc(344584,6,1,I|0)|0;nTc(I,343624);rc(344592,8,1,I|0)|0;mTc(I,2);rc(344608,8,1,I|0)|0;nTc(I,c[b+280>>2]|0);rc(344624,10,1,I|0)|0;mTc(I,2);rc(344640,14,1,I|0)|0;nTc(I,c[b+284>>2]|0);rc(344656,16,1,I|0)|0;mTc(I,2);rc(344680,16,1,I|0)|0;nTc(I,l);rc(344704,18,1,I|0)|0;mTc(I,2);c[B>>2]=oTc(l)|0;wd(I|0,344728,B|0)|0;mTc(I,2);P=+VCc(7);B=A;h[k>>3]=P;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(I|0,344768,A|0)|0;mTc(I,2);P=+VCc(6);A=z;h[k>>3]=P;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];wd(I|0,344808,z|0)|0;mTc(I,2);P=+VCc(1);z=y;h[k>>3]=P;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(I|0,344840,y|0)|0;mTc(I,2);P=+VCc(4);y=x;h[k>>3]=P;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(I|0,344872,x|0)|0;mTc(I,2);P=+VCc(3);x=w;h[k>>3]=P;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(I|0,344904,w|0)|0;mTc(I,2);P=+VCc(5);w=v;h[k>>3]=P;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(I|0,344936,v|0)|0;mTc(I,2);P=+VCc(0);v=u;h[k>>3]=P;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(I|0,344976,u|0)|0;mTc(I,2);P=+YCc(2);u=t;h[k>>3]=P;c[u>>2]=c[k>>2];c[u+4>>2]=c[k+4>>2];wd(I|0,345008,t|0)|0;mTc(I,2);c[s>>2]=TCc(2)|0;wd(I|0,345048,s|0)|0;mTc(I,2);P=+XCc(2);s=r;h[k>>3]=P;c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];wd(I|0,345072,r|0)|0;rc(345104,13,1,I|0)|0;rc(345120,16,1,I|0)|0;mTc(I,2);P=+VCc(8);r=q;h[k>>3]=P;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];wd(I|0,345144,q|0)|0;mTc(I,2);c[p>>2]=QCc(8)|0;wd(I|0,345168,p|0)|0;rc(345208,17,1,I|0)|0;rc(345232,22,1,I|0)|0;pTc(I,b);rc(345256,23,1,I|0)|0;rc(345280,12,1,I|0)|0;p=b+116|0;if((c[p>>2]|0)>0){q=b+8|0;r=0;do{qTc(I,(c[q>>2]|0)+(r*112|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+136|0;if((c[p>>2]|0)>0){r=b+24|0;q=0;do{qTc(I,(c[r>>2]|0)+(q*112|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+124|0;if((c[p>>2]|0)>0){q=b+12|0;r=0;do{qTc(I,(c[q>>2]|0)+(r*60|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+140|0;if((c[p>>2]|0)>0){r=b+28|0;q=0;do{qTc(I,(c[r>>2]|0)+(q*60|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+128|0;if((c[p>>2]|0)>0){q=b+16|0;r=0;do{qTc(I,(c[q>>2]|0)+(r*48|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+144|0;if((c[p>>2]|0)>0){r=b+32|0;q=0;do{qTc(I,(c[r>>2]|0)+(q*48|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+132|0;if((c[p>>2]|0)>0){q=b+20|0;r=0;do{qTc(I,(c[q>>2]|0)+(r*52|0)|0);r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+148|0;if((c[p>>2]|0)>0){r=b+36|0;q=0;do{qTc(I,(c[r>>2]|0)+(q*52|0)|0);q=q+1|0;}while((q|0)<(c[p>>2]|0))}rc(345296,13,1,I|0)|0;rc(345312,12,1,I|0)|0;rTc(I,J,f,c[C>>2]|0,b);rc(345328,13,1,I|0)|0;rc(345344,12,1,I|0)|0;sTc(I,c[b+68>>2]|0,b+56|0);rc(345360,13,1,I|0)|0;rc(345376,16,1,I|0)|0;tTc(I,J,f,b);rc(345400,17,1,I|0)|0;rc(345424,14,1,I|0)|0;Yc(I|0)|0;if(!K){O=0;i=j;return O|0}K=c[b+508>>2]|0;b=((L4c(e|0)|0)<<1)+230|0;e=(K|0)!=0;if(e){Q=(L4c(K|0)|0)<<1}else{Q=0}I=h4c(b+Q|0)|0;if((I|0)==0){cb(345440,345448,404,345472)}if((ab(J|0)|0)!=0){GBc(26,0,345488,o)}if(e){e=c[C>>2]|0;c[n>>2]=345520;c[n+4>>2]=e;c[n+8>>2]=K;c[n+12>>2]=e;hc(I|0,345536,n|0)|0;if((rd(I|0)|0)!=0){R=42}}else{n=I+0|0;e=345616|0;K=n+25|0;do{a[n]=a[e]|0;n=n+1|0;e=e+1|0}while((n|0)<(K|0));R=42}if((R|0)==42){c[m>>2]=I;GBc(1,0,345648,m)}m=c[C>>2]|0;c[g>>2]=m;c[g+4>>2]=m;EBc(1,0,345712,g);i4c(I);O=0;i=j;return O|0}function lTc(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0,K=0,L=0,M=0.0,N=0.0,O=0.0;m=i;i=i+24|0;n=m;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+24|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+24|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+24|0;C=i;i=i+8|0;D=i;i=i+16|0;if((a|0)==0){i=m;return}E=(g|0)>-1;if(E){F=g+9|0;G=RCc(F)|0;H=SCc(F)|0;if((G|0)==0){I=-.01}else{I=+(G>>>0)*.95}if((H|0)==0){J=.01}else{J=+(H>>>0)*1.05}K=H;L=G;M=+XCc(F)*1.01+1.0e-30;N=J;O=I}else{K=0;L=0;M=0.0;N=0.0;O=0.0}rc(343968,17,1,a|0)|0;rc(346880,12,1,a|0)|0;rc(346896,12,1,a|0)|0;rc(346912,13,1,a|0)|0;c[D>>2]=e;c[D+4>>2]=l;c[D+8>>2]=j;wd(a|0,346928,D|0)|0;rc(346968,10,1,a|0)|0;rc(346984,11,1,a|0)|0;rc(347e3,11,1,a|0)|0;rc(347016,10,1,a|0)|0;if(E){D=C;h[k>>3]=M;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];wd(a|0,347032,C|0)|0}else{rc(347056,17,1,a|0)|0}C=g+3|0;c[B>>2]=e;c[B+4>>2]=f;c[B+8>>2]=f;c[B+12>>2]=C;c[B+16>>2]=C;c[B+20>>2]=4;wd(a|0,346656,B|0)|0;rc(347080,13,1,a|0)|0;if(E){rc(346896,12,1,a|0)|0;if((L|0)==(K|0)){B=A;h[k>>3]=O;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=N;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(a|0,347096,A|0)|0}else{rc(347056,17,1,a|0)|0}c[z>>2]=e;c[z+4>>2]=l;c[z+8>>2]=j;wd(a|0,347120,z|0)|0;c[y>>2]=e;c[y+4>>2]=f;c[y+8>>2]=f;c[y+12>>2]=g+1;c[y+16>>2]=4;wd(a|0,346776,y|0)|0;rc(347168,10,1,a|0)|0;rc(347184,10,1,a|0)|0;rc(347168,10,1,a|0)|0;rc(347200,11,1,a|0)|0;c[x>>2]=b;wd(a|0,347216,x|0)|0;c[w>>2]=d;wd(a|0,347240,w|0)|0;rc(347256,33,1,a|0)|0;rc(347296,32,1,a|0)|0;c[v>>2]=e;c[v+4>>2]=l;c[v+8>>2]=j;c[v+12>>2]=b;wd(a|0,347336,v|0)|0;rc(347016,10,1,a|0)|0;v=u;h[k>>3]=M;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];wd(a|0,347032,u|0)|0}else{rc(347184,10,1,a|0)|0;rc(347168,10,1,a|0)|0;rc(347200,11,1,a|0)|0;c[t>>2]=b;wd(a|0,347216,t|0)|0;c[s>>2]=d;wd(a|0,347240,s|0)|0;rc(347256,33,1,a|0)|0;rc(347296,32,1,a|0)|0;c[r>>2]=e;c[r+4>>2]=l;c[r+8>>2]=j;c[r+12>>2]=b;wd(a|0,347336,r|0)|0;rc(347016,10,1,a|0)|0;rc(347056,17,1,a|0)|0}c[q>>2]=e;c[q+4>>2]=f;c[q+8>>2]=f;c[q+12>>2]=C;c[q+16>>2]=C;c[q+20>>2]=2;wd(a|0,346656,q|0)|0;rc(347080,13,1,a|0)|0;if(!E){i=m;return}if((L|0)==(K|0)){K=p;h[k>>3]=O;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];K=p+8|0;h[k>>3]=N;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];wd(a|0,347096,p|0)|0}else{rc(347056,17,1,a|0)|0}rc(347368,32,1,a|0)|0;rc(347408,29,1,a|0)|0;c[o>>2]=e;c[o+4>>2]=l;c[o+8>>2]=j;c[o+12>>2]=b;wd(a|0,347440,o|0)|0;c[n>>2]=e;c[n+4>>2]=f;c[n+8>>2]=f;c[n+12>>2]=g+1;c[n+16>>2]=2;wd(a|0,346776,n|0)|0;i=m;return}function mTc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((b|0)==0){i=c;return}else{d=b}do{d=d+ -1|0;Sd(32,a|0)|0;}while((d|0)!=0);i=c;return}function nTc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;e=a[c]|0;if(e<<24>>24==0){i=d;return}else{f=c;g=e}do{e=g<<24>>24;if((e|0)==60){rc(346624,4,1,b|0)|0}else if((e|0)==39){rc(346640,6,1,b|0)|0}else if((e|0)==62){rc(346632,4,1,b|0)|0}else if((e|0)==34){rc(346648,6,1,b|0)|0}else{Sd(e|0,b|0)|0}f=f+1|0;g=a[f]|0;}while(!(g<<24>>24==0));i=d;return}function oTc(a){a=a|0;var b=0,c=0,d=0;b=i;c=ic(a|0,346616)|0;if((c|0)==0){d=-1;i=b;return d|0}Wc(c|0,0,2)|0;a=yb(c|0)|0;Yc(c|0)|0;d=a;i=b;return d|0}function pTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+32|0;h=i;i=i+24|0;j=i;i=i+32|0;k=i;i=i+24|0;l=c[b+88>>2]|0;m=h4c((L4c(l|0)|0)+15|0)|0;c[f>>2]=l;hc(m|0,346344,f|0)|0;mTc(a,2);rc(346360,10,1,a|0)|0;nTc(a,m);rc(346376,12,1,a|0)|0;mTc(a,2);c[e>>2]=oTc(m)|0;wd(a|0,346392,e|0)|0;i4c(m);mTc(a,2);rc(346424,9,1,a|0)|0;mTc(a,4);rc(346440,22,1,a|0)|0;mTc(a,4);rc(346464,22,1,a|0)|0;mTc(a,4);rc(346488,26,1,a|0)|0;m=b+56|0;e=b+64|0;f=c[e>>2]|0;if((f|0)>0){l=g+4|0;n=0;while(1){vTc(g,m,n);o=c[l>>2]|0;mTc(a,4);rc(346520,8,1,a|0)|0;nTc(a,o);rc(346536,18,1,a|0)|0;o=n+1|0;p=c[e>>2]|0;if((o|0)<(p|0)){n=o}else{q=p;break}}}else{q=f}f=b+72|0;b=c[f>>2]|0;if((b|0)>0){n=h+8|0;l=0;do{ATc(h,m,l);g=c[n>>2]|0;mTc(a,4);rc(346520,8,1,a|0)|0;nTc(a,g);rc(346536,18,1,a|0)|0;l=l+1|0;r=c[f>>2]|0;}while((l|0)<(r|0));s=r;t=c[e>>2]|0}else{s=b;t=q}if((t|0)>0){t=j+4|0;q=0;do{vTc(j,m,q);b=c[t>>2]|0;mTc(a,4);rc(346560,8,1,a|0)|0;nTc(a,b);rc(346576,21,1,a|0)|0;q=q+1|0;}while((q|0)<(c[e>>2]|0));u=c[f>>2]|0}else{u=s}if((u|0)<=0){mTc(a,2);v=346600;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}u=k+8|0;s=0;do{ATc(k,m,s);e=c[u>>2]|0;mTc(a,4);rc(346560,8,1,a|0)|0;nTc(a,e);rc(346576,21,1,a|0)|0;s=s+1|0;}while((s|0)<(c[f>>2]|0));mTc(a,2);v=346600;w=v;x=rc(w|0,10,1,a|0)|0;i=d;return}function qTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=d;f=d+24|0;mTc(a,2);c[f>>2]=c[b>>2];wd(a|0,346280,f|0)|0;nTc(a,c[b+4>>2]|0);rc(346312,11,1,a|0)|0;nTc(a,c[b+8>>2]|0);rc(345984,3,1,a|0)|0;f=e;g=b+12|0;c[f+0>>2]=c[g+0>>2];c[f+4>>2]=c[g+4>>2];c[f+8>>2]=c[g+8>>2];c[f+12>>2]=c[g+12>>2];c[f+16>>2]=c[g+16>>2];c[f+20>>2]=c[g+20>>2];uTc(a,4,e);mTc(a,2);rc(346328,12,1,a|0)|0;i=d;return}function rTc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0;g=i;i=i+32|0;j=g;l=g+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+32|0;q=f+64|0;if((c[q>>2]|0)<=0){i=g;return}r=f+56|0;s=p+4|0;t=f+72|0;f=p;u=p+8|0;v=0;do{vTc(p,r,v);lTc(b,d,c[s>>2]|0,e,(c[t>>2]|0)+(c[q>>2]|0)|0,v,c[f>>2]|0,346096);w=v+9|0;$Cc(w);mTc(a,2);c[o>>2]=c[f>>2];wd(a|0,346104,o|0)|0;mTc(a,4);rc(344528,6,1,a|0)|0;nTc(a,c[s>>2]|0);rc(344536,8,1,a|0)|0;mTc(a,4);c[n>>2]=TCc(w)|0;wd(a|0,345880,n|0)|0;mTc(a,4);x=+YCc(w);y=m;h[k>>3]=x;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(a|0,345904,m|0)|0;mTc(a,4);x=+XCc(w);w=l;h[k>>3]=x;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];wd(a|0,345072,l|0)|0;w=j;y=u;c[w+0>>2]=c[y+0>>2];c[w+4>>2]=c[y+4>>2];c[w+8>>2]=c[y+8>>2];c[w+12>>2]=c[y+12>>2];c[w+16>>2]=c[y+16>>2];c[w+20>>2]=c[y+20>>2];uTc(a,6,j);mTc(a,2);rc(346128,12,1,a|0)|0;v=v+1|0;}while((v|0)<(c[q>>2]|0));i=g;return}function sTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+24|0;n=i;i=i+24|0;o=i;i=i+24|0;p=i;i=i+24|0;if((b|0)<=0){i=e;return}q=l;r=m+8|0;s=n+12|0;t=d+8|0;u=d+16|0;v=o;w=p;x=0;do{mTc(a,2);zTc(l,d,x);c[j>>2]=c[q>>2];wd(a|0,345952,j|0)|0;zTc(m,d,x);nTc(a,c[r>>2]|0);rc(345984,3,1,a|0)|0;mTc(a,4);rc(345992,7,1,a|0)|0;zTc(n,d,x);if((c[s>>2]|0)>0){y=0;do{mTc(a,6);c[g>>2]=0;wd(a|0,346e3,g|0)|0;y=y+1|0;zTc(n,d,x);}while((y|0)<(c[s>>2]|0))}mTc(a,4);rc(346024,8,1,a|0)|0;mTc(a,4);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;zTc(o,d,x);z=+VCc(y+(c[v>>2]|0)|0);y=(c[t>>2]|0)+9+(c[u>>2]|0)|0;zTc(p,d,x);A=QCc(y+(c[w>>2]|0)|0)|0;y=f;h[k>>3]=z;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[f+8>>2]=A;wd(a|0,346040,f|0)|0;mTc(a,2);rc(346080,12,1,a|0)|0;x=x+1|0;}while((x|0)<(b|0));i=e;return}function tTc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+24|0;o=e+56|0;p=e+64|0;q=c[p>>2]|0;r=e+72|0;if((c[r>>2]|0)<=0){i=f;return}s=n+8|0;t=e+88|0;e=n;u=q;v=q;do{ATc(n,o,v-u|0);lTc(b,d,c[s>>2]|0,c[t>>2]|0,(c[r>>2]|0)+(c[p>>2]|0)|0,v,c[e>>2]|0,345832);q=v+9|0;$Cc(q);mTc(a,2);rc(345840,15,1,a|0)|0;mTc(a,4);c[m>>2]=c[e>>2];wd(a|0,345856,m|0)|0;mTc(a,4);c[l>>2]=TCc(q)|0;wd(a|0,345880,l|0)|0;mTc(a,4);w=+YCc(q);x=j;h[k>>3]=w;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];wd(a|0,345904,j|0)|0;mTc(a,4);w=+XCc(q);q=g;h[k>>3]=w;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];wd(a|0,345072,g|0)|0;mTc(a,2);rc(345928,16,1,a|0)|0;v=v+1|0;u=c[p>>2]|0;}while((v|0)<((c[r>>2]|0)+u|0));i=f;return}function uTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;mTc(a,b);rc(346144,16,1,a|0)|0;nTc(a,c[d>>2]|0);b=c[d+8>>2]|0;g=c[d+12>>2]|0;h=c[d+16>>2]|0;j=(c[d+20>>2]|0)!=0?346248:346264;c[f>>2]=c[d+4>>2];c[f+4>>2]=b;c[f+8>>2]=g;c[f+12>>2]=h;c[f+16>>2]=j;wd(a|0,346168,f|0)|0;i=e;return}function vTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+24>>2]|0)==0){wTc(b)}f=a;a=(c[b+20>>2]|0)+(d<<5)|0;c[f+0>>2]=c[a+0>>2];c[f+4>>2]=c[a+4>>2];c[f+8>>2]=c[a+8>>2];c[f+12>>2]=c[a+12>>2];c[f+16>>2]=c[a+16>>2];c[f+20>>2]=c[a+20>>2];c[f+24>>2]=c[a+24>>2];c[f+28>>2]=c[a+28>>2];i=e;return}function wTc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+16|0;j=i;i=i+1024|0;c[h>>2]=a;k=h+4|0;c[k>>2]=1;l=h+8|0;c[l>>2]=0;m=h+12|0;c[m>>2]=0;n=a+4|0;do{if((c[n>>2]|0)==0){o=a;p=ic(c[o>>2]|0,347480)|0;if((p|0)!=0){q=p;break}p=Wd(c[(Nc()|0)>>2]|0)|0;c[g>>2]=c[o>>2];c[g+4>>2]=p;IBc(0,347488,g)}else{q=0}}while(0);g=xwc(0)|0;if((g|0)==0){IBc(0,347520,f)}f=a+8|0;c[a+20>>2]=j4c(c[f>>2]|0,32)|0;p=a+12|0;o=j4c((c[p>>2]|0)+1|0,20)|0;c[a+24>>2]=o;c[o>>2]=0;c[o+4>>2]=-1;c[o+8>>2]=347552;c[o+12>>2]=0;c[o+16>>2]=0;Iwc(g,h);Jwc(g,9,147);h=c[n>>2]|0;do{if((h|0)==0){o=j;P4c(o|0,0,1024)|0;while(1){r=sb(o|0,1,1024,q|0)|0;s=r>>>0<1024;if((Kwc(g,o,r,s&1)|0)==0){t=9;break}if(s){t=11;break}}if((t|0)==9){o=Swc(Pwc(g)|0)|0;s=Qwc(g)|0;Yc(q|0)|0;Ewc(g);r=c[a>>2]|0;c[e>>2]=347656;c[e+4>>2]=r;c[e+8>>2]=o;c[e+12>>2]=s;IBc(0,347592,e)}else if((t|0)==11){Yc(q|0)|0;break}}else{if((Kwc(g,h,L4c(h|0)|0,1)|0)!=0){break}s=Swc(Pwc(g)|0)|0;o=Qwc(g)|0;Ewc(g);r=c[n>>2]|0;c[d>>2]=347656;c[d+4>>2]=r;c[d+8>>2]=s;c[d+12>>2]=o;IBc(0,347696,d)}}while(0);if((c[p>>2]|0)!=(c[k>>2]|0)){cb(347760,347656,295,347800)}c[a+16>>2]=c[l>>2];if((c[f>>2]|0)==(c[m>>2]|0)){i=b;return}else{cb(347824,347656,297,347800)}}function xTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+8|0;m=c[a>>2]|0;n=c[a+4>>2]|0;o=c[a+12>>2]|0;if((H4c(348232,b)|0)==0){if((H4c(c[d>>2]|0,348240)|0)==0){p=(c[d+8>>2]|0)==0|0}else{p=0}HBc(0,p,348248,l);l=c[87022]|0;p=c[87076]|0;do{if((l|0)==0|(p|0)==0){c[87076]=32;a=h4c(1152)|0;c[87022]=a;q=m+24|0;r=a}else{a=m+24|0;s=a;if(((c[(c[a>>2]|0)+(n*20|0)+12>>2]|0)+2|0)<(p|0)){q=s;r=l;break}c[87076]=p<<1;a=k4c(l,p*72|0)|0;c[87022]=a;q=s;r=a}}while(0);p=(c[q>>2]|0)+(n*20|0)+12|0;q=c[p>>2]|0;c[p>>2]=q+1;p=r+(q*36|0)+0|0;q=(DTc(c[d+4>>2]|0)|0)+0|0;r=p+36|0;do{c[p>>2]=c[q>>2];p=p+4|0;q=q+4|0}while((p|0)<(r|0));i=e;return}if((H4c(348312,b)|0)==0){q=c[d>>2]|0;if((q|0)==0){i=e;return}else{t=d;u=q}a:while(1){do{if((H4c(348320,u)|0)==0){c[87082]=Ad(c[t+4>>2]|0)|0}else{if((H4c(348352,u)|0)==0){c[348332>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((H4c(348368,u)|0)==0){c[348340>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((H4c(348376,u)|0)==0){c[348336>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((H4c(348392,u)|0)==0){c[348344>>2]=Vb(c[t+4>>2]|0,0,10)|0;break}if((H4c(348400,u)|0)!=0){v=23;break a}c[348348>>2]=(H4c(c[t+4>>2]|0,348416)|0)==0}}while(0);q=t+8|0;p=c[q>>2]|0;if((p|0)==0){v=45;break}else{t=q;u=p}}if((v|0)==23){c[k>>2]=c[m>>2];IBc(0,348424,k)}else if((v|0)==45){i=e;return}}if((H4c(348072,b)|0)==0){v=c[m+12>>2]|0;if((n|0)>(v|0)){k=c[m>>2]|0;c[j>>2]=347656;c[j+4>>2]=k;c[j+8>>2]=v;IBc(0,348456,j)}if((H4c(348520,c[d>>2]|0)|0)!=0){j=c[m>>2]|0;c[h>>2]=347656;c[h+4>>2]=j;IBc(0,348528,h)}h=Vb(c[d+4>>2]|0,0,10)|0;if((n|0)!=(h|0)){j=c[m>>2]|0;c[g>>2]=347656;c[g+4>>2]=j;c[g+8>>2]=h;c[g+12>>2]=n;IBc(0,348584,g)}g=m+24|0;h=c[g>>2]|0;c[h+(n*20|0)>>2]=n;c[h+(n*20|0)+4>>2]=-1;c[h+(n*20|0)+8>>2]=348648;h=c[g>>2]|0;c[h+(n*20|0)+12>>2]=0;c[h+(n*20|0)+16>>2]=0;i=e;return}if((H4c(348016,b)|0)!=0){if((H4c(348208,b)|0)!=0){i=e;return}b=m+20|0;m=c[b>>2]|0;c[m+(o<<5)>>2]=o;c[m+(o<<5)+4>>2]=348752;m=Ad(c[d+4>>2]|0)|0;c[(c[b>>2]|0)+(o<<5)+4>>2]=m;c[(c[b>>2]|0)+(o<<5)+8>>2]=348760;i=e;return}c[348036>>2]=0;c[348040>>2]=0;o=c[d>>2]|0;do{if((o|0)==0){w=0}else{b=d;m=o;do{do{if((H4c(m,348240)|0)==0){c[348036>>2]=Ad(c[b+4>>2]|0)|0}else{if((H4c(m,348704)|0)!=0){break}c[348040>>2]=Ad(c[b+4>>2]|0)|0}}while(0);b=b+8|0;m=c[b>>2]|0;}while((m|0)!=0);if((c[348036>>2]|0)==0){w=0;break}w=(c[348040>>2]|0)!=0|0}}while(0);HBc(0,w,348712,f);c[87008]=-1;f=348044|0;w=348328;c[f+0>>2]=c[w+0>>2];c[f+4>>2]=c[w+4>>2];c[f+8>>2]=c[w+8>>2];c[f+12>>2]=c[w+12>>2];c[f+16>>2]=c[w+16>>2];c[f+20>>2]=c[w+20>>2];i=e;return}function yTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+48|0;e=d;f=d+40|0;g=i;i=i+8|0;h=c[a>>2]|0;j=a+4|0;k=c[j>>2]|0;l=a+8|0;m=c[l>>2]|0;n=a+12|0;a=c[n>>2]|0;if((H4c(348016,b)|0)==0){o=e+0|0;p=348032|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));CTc(e);i=d;return}if((H4c(348072,b)|0)==0){e=h+24|0;r=h4c((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)*36|0)|0;c[(c[e>>2]|0)+(k*20|0)+16>>2]=r;if((c[(c[e>>2]|0)+(k*20|0)+12>>2]|0)>0){r=0;do{s=h4c(36)|0;t=s;o=s+0|0;p=(c[87022]|0)+(r*36|0)+0|0;q=o+36|0;do{c[o>>2]=c[p>>2];o=o+4|0;p=p+4|0}while((o|0)<(q|0));c[(c[(c[e>>2]|0)+(k*20|0)+16>>2]|0)+(r<<2)>>2]=t;r=r+1|0;}while((r|0)<(c[(c[e>>2]|0)+(k*20|0)+12>>2]|0))}c[j>>2]=k+1;i=d;return}if((H4c(348096,b)|0)==0){j=h+24|0;e=c[j>>2]|0;r=c[e+(k*20|0)+12>>2]|0;c[g>>2]=k;c[g+4>>2]=r;Bd(e+(k*20|0)+8|0,348104,g|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((H4c(348144,b)|0)==0){j=h+24|0;h=c[j>>2]|0;g=c[h+(k*20|0)+12>>2]|0;c[f>>2]=k;c[f+4>>2]=g;Bd(h+(k*20|0)+8|0,348160,f|0)|0;c[(c[j>>2]|0)+(k*20|0)+4>>2]=m;c[l>>2]=m+1;i=d;return}if((H4c(348208,b)|0)!=0){i=d;return}c[n>>2]=a+1;i=d;return}function zTc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=b+24|0;g=c[f>>2]|0;if((g|0)==0){wTc(b);h=c[f>>2]|0}else{h=g}g=a;a=h+(d*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}function ATc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=b+24|0;if((c[h>>2]|0)==0){wTc(b)}j=c[b+16>>2]|0;if(j>>>0<d>>>0){c[g>>2]=d;c[g+4>>2]=j;IBc(0,347864,g)}g=c[b+12>>2]|0;if((g|0)<=0){k=f;l=k;c[l>>2]=d;m=5;n=m;o=347944;p=o;IBc(0,p,f)}b=c[h>>2]|0;h=0;while(1){j=h+1|0;if((c[b+(h*20|0)+4>>2]|0)==(d|0)){q=9;break}if((j|0)<(g|0)){h=j}else{q=10;break}}if((q|0)==9){g=a;a=b+(h*20|0)|0;c[g+0>>2]=c[a+0>>2];c[g+4>>2]=c[a+4>>2];c[g+8>>2]=c[a+8>>2];c[g+12>>2]=c[a+12>>2];c[g+16>>2]=c[a+16>>2];i=e;return}else if((q|0)==10){k=f;l=k;c[l>>2]=d;m=5;n=m;o=347944;p=o;IBc(0,p,f)}}function BTc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){i4c(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=a+12|0;if((c[f>>2]|0)>0){a=e;g=0;while(1){i4c(c[a+(g*20|0)+16>>2]|0);c[(c[d>>2]|0)+(g*20|0)+16>>2]=0;h=g+1|0;j=c[d>>2]|0;if((h|0)<(c[f>>2]|0)){g=h;a=j}else{k=j;break}}}else{k=e}i4c(k);c[d>>2]=0;i=b;return}function CTc(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;b=i;e=h4c(72)|0;f=c[a+4>>2]|0;c[e>>2]=f;g=e+4|0;h=a+0|0;a=g+36|0;do{c[g>>2]=c[h>>2];g=g+4|0;h=h+4|0}while((g|0)<(a|0));h=e+40|0;j=h;c[e+48>>2]=0;c[e+60>>2]=f;k=L4c(f|0)|0;c[e+64>>2]=k;k=c[87056]|0;do{if((k|0)==0){c[87056]=e;c[e+44>>2]=0;l=h4c(44)|0;m=l;c[e+40>>2]=m;if((l|0)==0){vc(-1)}g=l+0|0;a=g+44|0;do{c[g>>2]=0;g=g+4|0}while((g|0)<(a|0));c[l+16>>2]=e+40;c[l+4>>2]=32;c[l+8>>2]=5;c[l+20>>2]=40;n=h4c(384)|0;c[l>>2]=n;if((n|0)==0){vc(-1)}else{P4c(n|0,0,384)|0;c[l+40>>2]=-1609490463;o=f;p=m;break}}else{c[(c[(c[k+40>>2]|0)+16>>2]|0)+8>>2]=e;n=(c[87056]|0)+40|0;q=c[n>>2]|0;c[e+44>>2]=(c[q+16>>2]|0)+(0-(c[q+20>>2]|0));c[(c[n>>2]|0)+16>>2]=j;o=c[e>>2]|0;p=c[(c[87056]|0)+40>>2]|0}}while(0);k=p+12|0;c[k>>2]=(c[k>>2]|0)+1;c[h>>2]=p;p=e+68|0;c[p>>2]=-17973521;k=L4c(o|0)|0;if(k>>>0>11){f=-17973521;g=-1640531527;a=-1640531527;n=k;q=o;do{r=((d[q+5|0]|0)<<8|(d[q+4|0]|0)|(d[q+6|0]|0)<<16|(d[q+7|0]|0)<<24)+a|0;s=((d[q+9|0]|0)<<8|(d[q+8|0]|0)|(d[q+10|0]|0)<<16|(d[q+11|0]|0)<<24)+f|0;t=((d[q+1|0]|0)<<8|(d[q]|0)|(d[q+2|0]|0)<<16|(d[q+3|0]|0)<<24)+g-r-s^s>>>13;u=r-s-t^t<<8;r=s-t-u^u>>>13;s=t-u-r^r>>>12;t=u-r-s^s<<16;u=r-s-t^t>>>5;g=s-t-u^u>>>3;a=t-u-g^g<<10;f=u-g-a^a>>>15;c[p>>2]=f;q=q+12|0;n=n+ -12|0;}while(n>>>0>11);v=f;w=c[e>>2]|0;x=g;y=a;z=n;A=q}else{v=-17973521;w=o;x=-1640531527;y=-1640531527;z=k;A=o}o=v+(L4c(w|0)|0)|0;c[p>>2]=o;switch(z|0){case 2:{B=o;C=x;D=y;E=21;break};case 5:{F=o;G=y;E=18;break};case 4:{H=o;I=y;E=19;break};case 7:{J=o;K=y;E=16;break};case 9:{L=o;E=14;break};case 8:{M=o;E=15;break};case 10:{N=o;E=13;break};case 6:{O=o;P=y;E=17;break};case 3:{Q=o;R=x;S=y;E=20;break};case 11:{z=((d[A+10|0]|0)<<24)+o|0;c[p>>2]=z;N=z;E=13;break};case 1:{T=o;U=x;V=y;E=22;break};default:{W=o;X=x;Y=y}}if((E|0)==13){o=((d[A+9|0]|0)<<16)+N|0;c[p>>2]=o;L=o;E=14}if((E|0)==14){o=((d[A+8|0]|0)<<8)+L|0;c[p>>2]=o;M=o;E=15}if((E|0)==15){J=M;K=((d[A+7|0]|0)<<24)+y|0;E=16}if((E|0)==16){O=J;P=((d[A+6|0]|0)<<16)+K|0;E=17}if((E|0)==17){F=O;G=((d[A+5|0]|0)<<8)+P|0;E=18}if((E|0)==18){H=F;I=(d[A+4|0]|0)+G|0;E=19}if((E|0)==19){Q=H;R=((d[A+3|0]|0)<<24)+x|0;S=I;E=20}if((E|0)==20){B=Q;C=((d[A+2|0]|0)<<16)+R|0;D=S;E=21}if((E|0)==21){T=B;U=((d[A+1|0]|0)<<8)+C|0;V=D;E=22}if((E|0)==22){W=T;X=(d[A]|0)+U|0;Y=V}V=X-Y-W^W>>>13;X=Y-W-V^V<<8;Y=W-V-X^X>>>13;W=V-X-Y^Y>>>12;V=X-Y-W^W<<16;X=Y-W-V^V>>>5;Y=W-V-X^X>>>3;W=V-X-Y^Y<<10;V=X-Y-W^W>>>15;c[p>>2]=V;p=(c[87056]|0)+40|0;W=c[p>>2]|0;Y=V&(c[W+4>>2]|0)+ -1;V=c[W>>2]|0;W=V+(Y*12|0)+4|0;c[W>>2]=(c[W>>2]|0)+1;c[e+56>>2]=c[V+(Y*12|0)>>2];c[e+52>>2]=0;e=c[c[p>>2]>>2]|0;p=c[e+(Y*12|0)>>2]|0;if((p|0)==0){Z=e}else{c[p+12>>2]=j;Z=c[c[(c[87056]|0)+40>>2]>>2]|0}c[Z+(Y*12|0)>>2]=j;j=c[c[(c[87056]|0)+40>>2]>>2]|0;if((c[j+(Y*12|0)+4>>2]|0)>>>0<(((c[j+(Y*12|0)+8>>2]|0)*10|0)+10|0)>>>0){i=b;return}Y=c[h>>2]|0;if((c[Y+36>>2]|0)==1){i=b;return}j=Y+4|0;Z=h4c((c[j>>2]|0)*24|0)|0;p=Z;if((Z|0)==0){vc(-1)}P4c(Z|0,0,(c[j>>2]|0)*24|0)|0;e=c[Y+12>>2]|0;V=c[j>>2]|0;c[Y+24>>2]=(((V<<1)+ -1&e|0)!=0)+(e>>>((c[Y+8>>2]|0)+1|0));c[Y+28>>2]=0;e=c[Y>>2]|0;if((V|0)==0){_=e}else{V=Y;Y=e;e=0;while(1){j=c[Y+(e*12|0)>>2]|0;if((j|0)==0){$=V}else{W=V;X=j;while(1){j=X+16|0;U=c[j>>2]|0;A=(c[W+4>>2]<<1)+ -1&c[X+28>>2];T=Z+(A*12|0)+4|0;E=(c[T>>2]|0)+1|0;c[T>>2]=E;D=c[W+24>>2]|0;if(E>>>0>D>>>0){E=W+28|0;c[E>>2]=(c[E>>2]|0)+1;c[Z+(A*12|0)+8>>2]=((c[T>>2]|0)>>>0)/(D>>>0)|0}c[X+12>>2]=0;D=Z+(A*12|0)|0;c[j>>2]=c[D>>2];j=c[D>>2]|0;if((j|0)!=0){c[j+12>>2]=X}c[D>>2]=X;D=c[h>>2]|0;if((U|0)==0){$=D;break}else{W=D;X=U}}}X=e+1|0;W=c[$>>2]|0;if(X>>>0<(c[$+4>>2]|0)>>>0){V=$;Y=W;e=X}else{_=W;break}}}i4c(_);_=c[h>>2]|0;e=_+4|0;c[e>>2]=c[e>>2]<<1;e=_+8|0;c[e>>2]=(c[e>>2]|0)+1;c[_>>2]=p;p=c[h>>2]|0;h=p+32|0;if(!((c[p+28>>2]|0)>>>0>(c[p+12>>2]|0)>>>1>>>0)){c[h>>2]=0;i=b;return}_=(c[h>>2]|0)+1|0;c[h>>2]=_;if(!(_>>>0>1)){i=b;return}c[p+36>>2]=1;i=b;return}function DTc(a){a=a|0;var b=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;b=i;i=i+8|0;e=b;a:do{if((c[87056]|0)==0){f=24}else{g=L4c(a|0)|0;if(g>>>0>11){h=-17973521;j=-1640531527;k=-1640531527;l=g;m=a;while(1){n=((d[m+5|0]|0)<<8|(d[m+4|0]|0)|(d[m+6|0]|0)<<16|(d[m+7|0]|0)<<24)+k|0;o=((d[m+9|0]|0)<<8|(d[m+8|0]|0)|(d[m+10|0]|0)<<16|(d[m+11|0]|0)<<24)+h|0;p=((d[m+1|0]|0)<<8|(d[m]|0)|(d[m+2|0]|0)<<16|(d[m+3|0]|0)<<24)+j-n-o^o>>>13;q=n-o-p^p<<8;n=o-p-q^q>>>13;o=p-q-n^n>>>12;p=q-n-o^o<<16;q=n-o-p^p>>>5;n=o-p-q^q>>>3;o=p-q-n^n<<10;p=q-n-o^o>>>15;q=m+12|0;r=l+ -12|0;if(r>>>0>11){m=q;l=r;k=o;j=n;h=p}else{s=p;t=n;u=o;v=r;w=q;break}}}else{s=-17973521;t=-1640531527;u=-1640531527;v=g;w=a}h=(L4c(a|0)|0)+s|0;switch(v|0){case 6:{x=h;y=u;f=10;break};case 3:{z=h;A=t;B=u;f=13;break};case 1:{C=h;D=t;E=u;f=15;break};case 10:{F=h;f=6;break};case 5:{G=h;H=u;f=11;break};case 7:{I=h;J=u;f=9;break};case 8:{K=h;f=8;break};case 11:{F=((d[w+10|0]|0)<<24)+h|0;f=6;break};case 9:{L=h;f=7;break};case 2:{M=h;N=t;O=u;f=14;break};case 4:{P=h;Q=u;f=12;break};default:{R=h;S=t;T=u}}if((f|0)==6){L=((d[w+9|0]|0)<<16)+F|0;f=7}if((f|0)==7){K=((d[w+8|0]|0)<<8)+L|0;f=8}if((f|0)==8){I=K;J=((d[w+7|0]|0)<<24)+u|0;f=9}if((f|0)==9){x=I;y=((d[w+6|0]|0)<<16)+J|0;f=10}if((f|0)==10){G=x;H=((d[w+5|0]|0)<<8)+y|0;f=11}if((f|0)==11){P=G;Q=(d[w+4|0]|0)+H|0;f=12}if((f|0)==12){z=P;A=((d[w+3|0]|0)<<24)+t|0;B=Q;f=13}if((f|0)==13){M=z;N=((d[w+2|0]|0)<<16)+A|0;O=B;f=14}if((f|0)==14){C=M;D=((d[w+1|0]|0)<<8)+N|0;E=O;f=15}if((f|0)==15){R=C;S=(d[w]|0)+D|0;T=E}h=S-R-T^R>>>13;j=T-R-h^h<<8;k=R-h-j^j>>>13;l=h-j-k^k>>>12;h=j-k-l^l<<16;j=k-l-h^h>>>5;k=l-h-j^j>>>3;l=h-j-k^k<<10;h=c[(c[87056]|0)+40>>2]|0;m=c[(c[h>>2]|0)+(((j-k-l^l>>>15)&(c[h+4>>2]|0)+ -1)*12|0)>>2]|0;if((m|0)==0){f=24;break}l=m+(0-(c[h+20>>2]|0))|0;if((l|0)==0){f=24;break}m=L4c(a|0)|0;k=l;while(1){U=k;if((c[k+64>>2]|0)==(m|0)){if((G4c(c[k+60>>2]|0,a,m)|0)==0){break}}l=c[k+56>>2]|0;if((l|0)==0){f=24;break a}j=l+(0-(c[h+20>>2]|0))|0;if((j|0)==0){f=24;break a}else{k=j}}if((k|0)==0){f=24}else{V=U}}}while(0);do{if((f|0)==24){if((Eb(a|0,348784)|0)==0){V=0;break}else{W=348808}i=b;return W|0}}while(0);c[e>>2]=a;HBc(0,(V|0)!=0|0,348856,e);W=V+4|0;i=b;return W|0}function ETc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;if((FTc(348912,a,b)|0)!=0){d=1;i=c;return d|0}d=(FTc(348920,a,b)|0)!=0|0;i=c;return d|0}function FTc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((d|0)>0){g=0}else{h=0;i=f;return h|0}while(1){j=c[e+(g<<2)>>2]|0;if((a[j]|0)==45){if((H4c(b,j+1|0)|0)==0){h=1;k=5;break}}j=g+1|0;if((j|0)<(d|0)){g=j}else{h=0;k=5;break}}if((k|0)==5){i=f;return h|0}return 0}function GTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=(H4c(c[297292>>2]|0,348928)|0)==0|0;HBc(0,m,348944,l);l=(H4c(c[299196>>2]|0,348928)|0)==0|0;HBc(0,l,349e3,k);k=(H4c(c[301188>>2]|0,348928)|0)==0|0;HBc(0,k,349056,j);j=349120|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));j=349248|0;k=j+124|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));if((a|0)>1){n=1}else{o=0;i=d;return o|0}a:while(1){p=b+(n<<2)|0;j=n+1|0;k=1;while(1){l=c[301192+(k<<2)>>2]|0;if((l|0)==2){q=c[297168+(k<<2)>>2]|0;if(!((FTc(q,1,p)|0)==0|(j|0)>=(a|0))){r=9;break}s=c[297168+(k<<2)>>2]|0;if((ITc(s,p)|0)!=0){r=13;break}}else if((l|0)==1){if((FTc(c[297168+(k<<2)>>2]|0,1,p)|0)!=0){r=5;break}}l=k+1|0;if((l|0)<31){k=l}else{r=17;break a}}if((r|0)==5){r=0;l=349120+(k<<2)|0;if((c[l>>2]|0)!=0){r=6;break}c[l>>2]=1;t=n}else if((r|0)==9){r=0;l=349120+(k<<2)|0;if((c[l>>2]|0)!=0){r=10;break}c[l>>2]=1;c[349248+(k<<2)>>2]=HTc(q,p)|0;t=j}else if((r|0)==13){r=0;l=349120+(k<<2)|0;if((c[l>>2]|0)!=0){r=14;break}c[l>>2]=1;c[349248+(k<<2)>>2]=JTc(s,p)|0;t=n}l=t+1|0;if((l|0)<(a|0)){n=l}else{o=0;r=19;break}}if((r|0)==6){c[h>>2]=c[p>>2];GBc(1,0,349376,h);o=1;i=d;return o|0}else if((r|0)==10){c[g>>2]=c[p>>2];GBc(1,0,349376,g);o=1;i=d;return o|0}else if((r|0)==14){c[f>>2]=c[p>>2];GBc(1,0,349376,f);o=1;i=d;return o|0}else if((r|0)==17){c[e>>2]=c[p>>2];GBc(1,0,349432,e);o=1;i=d;return o|0}else if((r|0)==19){i=d;return o|0}return 0}function HTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;f=c[d>>2]|0;do{if((a[f]|0)==45){if((H4c(b,f+1|0)|0)!=0){g=0;break}g=c[d+4>>2]|0}else{g=0}}while(0);i=e;return g|0}function ITc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(JTc(a,b)|0)!=0|0;i=c;return d|0}function JTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=L4c(b|0)|0;g=c[d>>2]|0;if((a[g]|0)!=45){h=0;i=e;return h|0}if((I4c(b,g+1|0,f)|0)!=0){h=0;i=e;return h|0}if((a[g+(f+1)|0]|0)!=61){h=0;i=e;return h|0}h=g+(f+2)|0;i=e;return h|0}function KTc(){i=i;return}function LTc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;if((d|0)<=0){vc(0)}e=c[r>>2]|0;rc(349464,5,1,e|0)|0;f=b;b=0;while(1){Sd(a[f]|0,e|0)|0;g=b+1|0;if((g|0)<(d|0)){b=g;f=f+1|0}else{break}}rc(349472,20,1,e|0)|0;vc(0);return 0}function MTc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;e=d;d=c[r>>2]|0;c[e>>2]=a;wd(d|0,349496,e|0)|0;if((b|0)==0){vc(1)}else{ud(d|0)|0;UTc();ud(d|0)|0;ib(6,0)|0;hd()}}function NTc(a,b){a=a|0;b=b|0;var c=0.0;c=+W(+(+h[a>>3]),+(+h[b>>3]));i=i;return+c}function OTc(a,b){a=a|0;b=b|0;var d=0,e=0.0,f=0.0,g=0.0,j=0,k=0.0,l=0.0;d=i;e=+h[a>>3];a=c[b>>2]|0;if((a|0)==0){f=1.0;i=d;return+f}if((a|0)<0){g=1.0;j=0-a|0;k=1.0/e}else{g=1.0;j=a;k=e}while(1){if((j&1|0)==0){l=g}else{l=g*k}a=j>>>1;if((a|0)==0){f=l;break}g=l;j=a;k=k*k}i=d;return+f}function PTc(a,b){a=a|0;b=b|0;var c=0,d=0.0,e=0.0,f=0.0;c=i;d=+h[a>>3];if(!(d>=0.0)){e=-d}else{e=d}if(+h[b>>3]>=0.0){f=e;i=c;return+f}f=-e;i=c;return+f}function QTc(a){a=a|0;var b=0.0,c=0.0,d=0.0;b=+g[a>>2];c=b;if(!(b>=0.0)){d=-+T(+(.5-c))}else{d=+T(+(c+.5))}i=i;return~~d|0}function RTc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;g=b+d|0;h=c+e|0;if((d|0)>(e|0)){a:do{if((e|0)>0){j=b;k=c;while(1){l=a[j]|0;m=a[k]|0;if(!(l<<24>>24==m<<24>>24)){break}n=j+1|0;o=k+1|0;if(o>>>0<h>>>0){j=n;k=o}else{p=n;break a}}q=(l&255)-(m&255)|0;i=f;return q|0}else{p=b}}while(0);if(p>>>0<g>>>0){r=p}else{q=0;i=f;return q|0}while(1){s=a[r]|0;p=r+1|0;if(!(s<<24>>24==32)){break}if(p>>>0<g>>>0){r=p}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=(s&255)+ -32|0;i=f;return q|0}else{b:do{if((d|0)>0){s=b;r=c;while(1){u=a[s]|0;v=a[r]|0;if(!(u<<24>>24==v<<24>>24)){break}p=s+1|0;m=r+1|0;if(p>>>0<g>>>0){s=p;r=m}else{w=m;break b}}q=(u&255)-(v&255)|0;i=f;return q|0}else{w=c}}while(0);if(w>>>0<h>>>0){x=w}else{q=0;i=f;return q|0}while(1){y=a[x]|0;w=x+1|0;if(!(y<<24>>24==32)){break}if(w>>>0<h>>>0){x=w}else{q=0;t=18;break}}if((t|0)==18){i=f;return q|0}q=32-(y&255)|0;i=f;return q|0}return 0}function STc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;f=i;g=c;h=b+d|0;if((d|0)<=(e|0)){do{if(b>>>0>c>>>0){j=c+d|0;if(!(j>>>0>b>>>0)){break}if((d|0)>0){k=j;l=h}else{i=f;return}do{k=k+ -1|0;l=l+ -1|0;a[l]=a[k]|0;}while(l>>>0>b>>>0);i=f;return}}while(0);if((d|0)>0){m=c;n=b}else{i=f;return}while(1){l=n+1|0;a[n]=a[m]|0;if(l>>>0<h>>>0){n=l;m=m+1|0}else{break}}i=f;return}m=c+e|0;do{if(b>>>0>c>>>0&m>>>0>b>>>0){n=b+e|0;if((e|0)>0){l=0-g-e|0;k=~g;j=~(c+(l>>>0>k>>>0?l:k));k=n;l=m;do{l=l+ -1|0;k=k+ -1|0;a[k]=a[l]|0;}while(l>>>0>c>>>0);o=b+j|0}else{o=n}p=o+e|0}else{if((e|0)<=0){p=b;break}l=c+1|0;k=(m>>>0>l>>>0?m:l)+(0-g)|0;l=b;q=c;while(1){r=q+1|0;a[l]=a[q]|0;if(r>>>0<m>>>0){q=r;l=l+1|0}else{break}}p=b+k|0}}while(0);if(!(p>>>0<h>>>0)){i=f;return}P4c(p|0,32,b+(d-p)|0)|0;i=f;return}function TTc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+4>>2]|0;if((e|0)>99){i=d;return 0}f=350536+(e*48|0)|0;g=c[f>>2]|0;if((g|0)!=0){do{if((c[350580+(e*48|0)>>2]|0)==1){h=10}else{j=c[b+8>>2]|0;if((j|0)!=0){k=a[j]|0;if((k|0)==100|(k|0)==68){h=10;break}}if((c[350576+(e*48|0)>>2]|0)==1){VTc(b)|0}k=350540+(e*48|0)|0;if((c[k>>2]|0)==0){break}Yc(c[f>>2]|0)|0;i4c(c[k>>2]|0)}}while(0);do{if((h|0)==10){Yc(g|0)|0;b=350540+(e*48|0)|0;k=c[b>>2]|0;if((k|0)==0){break}Jd(k|0)|0;i4c(c[b>>2]|0)}}while(0);c[f>>2]=0}c[350572+(e*48|0)>>2]=0;c[350540+(e*48|0)>>2]=0;i=d;return 0}function UTc(){var a=0,b=0;a=i;if((c[87376]|0)!=0){i=a;return}c[87376]=1;c[349512>>2]=0;b=0;do{c[349508>>2]=b;TTc(349504)|0;b=b+1|0;}while((b|0)<100);i=a;return}function VTc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=c[a+4>>2]|0;if((c[350552+(d*48|0)>>2]|0)!=0){e=0;i=b;return e|0}f=350536+(d*48|0)|0;g=c[f>>2]|0;h=yb(g|0)|0;Wc(g|0,0,2)|0;if((h|0)>=(yb(g|0)|0)){e=0;i=b;return e|0}if((c[350556+(d*48|0)>>2]|0)==0){e=0;i=b;return e|0}if((c[350564+(d*48|0)>>2]&2|0)!=0){ud(c[f>>2]|0)|0}d=Tc(rb(c[f>>2]|0)|0,h|0)|0;Wc(c[f>>2]|0,0,2)|0;if((d|0)==0){e=0;i=b;return e|0}if((c[a>>2]|0)==0){XTc(111,349520);e=111;i=b;return e|0}else{c[(Nc()|0)>>2]=111;e=111;i=b;return e|0}return 0}function WTc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+80|0;d=b;do{if(($a(rb(a|0)|0,d|0)|0)<0){e=0}else{f=c[d+12>>2]&61440;if((f|0)==8192){e=(ub(rb(a|0)|0)|0)==0|0;break}else if((f|0)==24576){e=1;break}else if((f|0)==32768|(f|0)==16384){e=(c[d+16>>2]|0)!=0|0;break}else{e=0;break}}}while(0);i=b;return e|0}function XTc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;d=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;do{if(a>>>0<100){Qc(b|0);l=c[r>>2]|0}else{if((a+1|0)>>>0>132){m=c[r>>2]|0;c[k>>2]=b;c[k+4>>2]=a;wd(m|0,350432,k|0)|0;l=m;break}m=c[r>>2]|0;if((a|0)==-1){c[j>>2]=b;wd(m|0,350464,j|0)|0;l=m;break}else{n=c[350304+(a+ -100<<2)>>2]|0;c[h>>2]=b;c[h+4>>2]=n;wd(m|0,350488,h|0)|0;l=m;break}}}while(0);h=c[87624]|0;do{if((h|0)==0){rc(355368,29,1,l|0)|0}else{c[g>>2]=(h-350536|0)/48|0;wd(l|0,350504,g|0)|0;b=c[(c[87624]|0)+4>>2]|0;if((b|0)==0){rc(355352,10,1,l|0)|0;break}else{c[f>>2]=b;wd(l|0,355336,f|0)|0;break}}}while(0);f=c[88850]|0;if((f|0)!=0){c[d>>2]=f;wd(l|0,355408,d|0)|0}d=(c[88870]|0)!=0?355488:355504;f=(c[88878]|0)!=0?355520:355536;g=(c[88888]|0)!=0?355560:355576;c[e>>2]=(c[88864]|0)!=0?355464:355472;c[e+4>>2]=d;c[e+8>>2]=f;c[e+12>>2]=g;wd(l|0,355432,e|0)|0;MTc(355592,1)}function YTc(){var a=0,b=0;a=i;c[88900]=1;b=c[r>>2]|0;c[87634]=b;c[350556>>2]=WTc(b)|0;c[350560>>2]=1;c[350576>>2]=1;b=c[s>>2]|0;c[350776>>2]=b;c[350796>>2]=WTc(b)|0;c[350800>>2]=1;c[350816>>2]=0;b=c[t>>2]|0;c[350824>>2]=b;c[350844>>2]=WTc(b)|0;c[350848>>2]=1;c[350864>>2]=1;i=a;return}function ZTc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;d=a+28|0;e=c[d>>2]|0;a:do{if((e&2|0)==0){f=a+4|0;g=c[f>>2]|0;do{if((g|0)!=0){if((c[a+16>>2]|0)==0){h=c[a+24>>2]|0}else{h=0}if((c[a+40>>2]|0)==3){j=a;k=xc(g|0,c[360848+(h<<2)>>2]|0,c[j>>2]|0)|0;c[j>>2]=k;c[88902]=k;if((k|0)==0){break}c[d>>2]=2;break a}k=a;j=yb(c[k>>2]|0)|0;l=xc(c[f>>2]|0,c[360848+((h|2)<<2)>>2]|0,c[k>>2]|0)|0;c[k>>2]=l;c[88902]=l;if((l|0)==0){c[k>>2]=0;break}else{c[d>>2]=3;Wc(c[k>>2]|0,j|0,0)|0;break a}}}while(0);c[(Nc()|0)>>2]=127;m=1;i=b;return m|0}else{if((e&1|0)==0){break}Wc(c[a>>2]|0,0,1)|0}}while(0);c[a+40>>2]=1;m=0;i=b;return m|0}function _Tc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((a|0)==0){XTc(b,d)}d=c[88904]|0;if((d|0)!=0){Ce[d&7]()|0}c[(Nc()|0)>>2]=b;i=e;return b|0}function $Tc(a){a=a|0;var b=0,d=0;b=i;c[88934]=0;c[88936]=0;c[88938]=0;d=((aUc(a,0)|0)==0)<<31>>31;i=b;return d|0}function aUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b;while(1){b=a[f]|0;g=f+1|0;if(b<<24>>24==40){break}else if(b<<24>>24==32){f=g}else{h=0;j=8;break}}if((j|0)==8){i=e;return h|0}j=c[88938]|0;c[88938]=j+1;if((j|0)==1){c[88936]=d}if((fUc(1,d,0,0)|0)<0){h=0;i=e;return h|0}d=gUc(g)|0;if((d|0)==0){h=0;i=e;return h|0}else{k=d}while(1){if((a[k]|0)==32){k=k+1|0}else{h=k;break}}i=e;return h|0}function bUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0;e=i;i=i+8|0;f=e;if((c[a>>2]|0)>0){g=b;h=0}else{j=0;i=e;return j|0}a:while(1){b=(g|0)==0;b:while(1){k=c[88934]|0;l=355760+(k<<4)|0;m=c[l>>2]|0;switch(cUc(m)|0){case 33:{c[90178]=1;c[88934]=k+1;continue b;break};case 19:case 17:{c[88910]=0;c[88934]=k+1;continue b;break};case 20:{c[88930]=c[355764+(k<<4)>>2];c[88934]=k+1;continue b;break};case 1:{n=c[355764+(k<<4)>>2]|0;o=(c[90166]|0)+1|0;c[90166]=o;c[360672+(o<<2)>>2]=n;c[88934]=k+1;continue b;break};case 21:{c[88912]=0;c[88934]=k+1;continue b;break};case 9:{n=(ie[c[88918]&127](l)|0)==0;c[88934]=(c[88934]|0)+1;if(n){break b}else{continue b}break};case 18:{c[88910]=1;c[88934]=k+1;continue b;break};case 8:{n=c[90150]|0;p=360608+(n<<2)|0;q=c[p>>2]|0;if((q|0)>=1){s=10;break b}c[90150]=n+ -1;c[88934]=k+1;continue b;break};case 2:{c[90150]=0;c[90166]=0;c[88934]=c[355764+(k<<4)>>2];if(b){s=24;break a}if((c[90162]|0)==0){j=0;s=37;break a}n=Ce[c[88920]&7]()|0;if((n|0)==0){continue b}else{j=n;s=37;break a}break};case 16:{if(b){s=28;break a}c[88934]=k+1;continue b;break};case 3:{n=c[90150]|0;o=360608+(n<<2)|0;t=c[o>>2]|0;c[o>>2]=t+ -1;if((t|0)<2){c[90150]=n+ -1;c[90166]=(c[90166]|0)+ -1;c[88934]=k+1;continue b}else{n=c[90166]|0;c[90166]=n+ -1;c[88934]=(c[360672+(n<<2)>>2]|0)+1;continue b}break};case 6:{n=c[355764+(k<<4)>>2]|0;t=(c[90150]|0)+1|0;c[90150]=t;c[360608+(t<<2)>>2]=n;c[88934]=k+1;continue b;break};case 22:{c[88912]=1;c[88934]=k+1;continue b;break};default:{s=4;break a}}}if((s|0)==10){s=0;if(b){s=11;break}c[p>>2]=q+ -1;c[90162]=1;k=le[c[88916]&63](l,g,d)|0;if((k|0)>0){s=13;break}if((k|0)<0){s=15;break}}k=h+1|0;if((k|0)<(c[a>>2]|0)){g=g+d|0;h=k}else{j=0;s=37;break}}if((s|0)==4){h=c[r>>2]|0;d=c[88850]|0;c[f>>2]=m;c[f+4>>2]=d;wd(h|0,360560,f|0)|0;if((c[c[88906]>>2]|0)==0){XTc(100,360592);j=100;i=e;return j|0}else{c[(Nc()|0)>>2]=100;j=100;i=e;return j|0}}else if((s|0)==11){j=Ce[c[88904]&7]()|0;i=e;return j|0}else if((s|0)==13){f=c[c[88906]>>2]|0;j=_Tc(f,c[(Nc()|0)>>2]|0,360656)|0;i=e;return j|0}else if((s|0)==15){if((c[(c[88906]|0)+8>>2]|0)==0){XTc(-1,360656);j=-1;i=e;return j|0}else{c[(Nc()|0)>>2]=-1;j=-1;i=e;return j|0}}else if((s|0)==24){j=Ce[c[88904]&7]()|0;i=e;return j|0}else if((s|0)==28){j=Ce[c[88904]&7]()|0;i=e;return j|0}else if((s|0)==37){i=e;return j|0}return 0}function cUc(a){a=a|0;var b=0;switch(a|0){case 26:case 25:case 24:case 29:case 34:case 32:case 31:case 30:case 10:case 7:case 23:case 27:case 28:case 35:case 36:{b=8;break};case 14:case 13:case 15:case 12:case 11:case 5:case 4:{b=9;break};default:{b=a}}i=i;return b|0}function dUc(){var a=0,b=0,d=0;a=i;i=i+8|0;b=a;c[b>>2]=1;d=bUc(b,0,0)|0;i=a;return d|0}function eUc(){c[88926]=0;c[88934]=0;c[90166]=0;c[90150]=0;c[90162]=0;c[90168]=0;c[90152]=0;i=i;return}function fUc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;g=c[88934]|0;if((g|0)>299){rc(360736,24,1,c[r>>2]|0)|0;MTc(c[88850]|0,1)}else{c[355760+(g<<4)>>2]=a;c[355764+(g<<4)>>2]=b;c[355768+(g<<4)>>2]=d;c[355772+(g<<4)>>2]=e;c[88934]=g+1;i=f;return g|0}return 0}function gUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;e=a[b]|0;if(e<<24>>24==0){f=0;i=d;return f|0}else{g=b;h=e}a:while(1){e=g+1|0;if(h<<24>>24==32){h=a[e]|0;g=e;continue}e=hUc(g)|0;if((e|0)==0){f=0;j=12;break}else{k=e}while(1){e=a[k]|0;if(e<<24>>24==41){j=9;break a}else if(e<<24>>24==44){j=7;break}else if(!(e<<24>>24==32)){l=k;break}k=k+1|0}if((j|0)==7){j=0;l=k+1|0}e=a[l]|0;if(e<<24>>24==0){f=0;j=12;break}else{g=l;h=e}}if((j|0)==9){h=(c[88938]|0)+ -1|0;c[88938]=h;if((h|0)==0){fUc(2,c[88936]|0,0,0)|0;f=k+1|0;i=d;return f|0}else{fUc(3,0,0,0)|0;f=k+1|0;i=d;return f|0}}else if((j|0)==12){i=d;return f|0}return 0}function hUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;do{if((a[b]|0)==41){g=b}else{if((iUc(b,e)|0)!=0){g=c[e>>2]|0;break}if((jUc(b,e)|0)!=0){g=c[e>>2]|0;break}h=kUc(b,f,1)|0;j=fUc(6,c[f>>2]|0,0,0)|0;if((j|0)<0){g=0;break}g=aUc(h,j)|0}}while(0);i=d;return g|0}function iUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+8|0;f=e;a:do{switch(a[b]|0){case 115:case 83:{g=b+1|0;h=a[g]|0;if(h<<24>>24==83|h<<24>>24==115){j=g;k=19}else if(h<<24>>24==80|h<<24>>24==112){j=g;k=18}else{j=b;k=17}fUc(k,0,0,0)|0;l=j;m=30;break};case 47:{fUc(5,0,0,0)|0;l=b;m=30;break};case 120:case 88:{fUc(4,1,0,0)|0;l=b;m=30;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{n=b;o=0;m=14;break};case 58:{fUc(16,0,0,0)|0;l=b;m=30;break};case 45:{p=1;m=13;break};case 116:case 84:{g=b+1|0;h=a[g]|0;if(h<<24>>24==82|h<<24>>24==114){q=g;r=14}else if(h<<24>>24==76|h<<24>>24==108){q=g;r=13}else{q=b;r=15}g=kUc(q+1|0,f,0)|0;if((g|0)==0){m=15;break a}fUc(r,c[f>>2]|0,0,0)|0;l=g+ -1|0;m=30;break};case 112:case 80:{fUc(20,1,0,0)|0;l=b;m=30;break};case 43:{p=0;m=13;break};case 98:case 66:{g=b+1|0;h=a[g]|0;if(h<<24>>24==90|h<<24>>24==122){fUc(22,0,0,0)|0;l=g;m=30;break a}else{fUc(21,0,0,0)|0;l=g;m=30;break a}break};case 39:case 34:case 2:{c[355768+((fUc(11,0,0,0)|0)<<4)>>2]=b;g=lUc(b)|0;c[d>>2]=g;s=(g|0)!=0|0;i=e;return s|0};case 36:{fUc(33,0,0,0)|0;l=b;m=30;break};default:{s=0;i=e;return s|0}}}while(0);if((m|0)==13){n=b+1|0;o=p;m=14}b:do{if((m|0)==14){p=kUc(n,f,0)|0;if((p|0)==0){m=15;break}switch(a[p]|0){case 120:case 88:{fUc(4,c[f>>2]|0,0,0)|0;l=p;m=30;break b;break};case 104:case 72:{b=c[f>>2]|0;c[355768+((fUc(12,b,0,0)|0)<<4)>>2]=p+1;l=p+b|0;m=30;break b;break};case 112:case 80:{b=c[f>>2]|0;if((o|0)==0){t=b}else{r=0-b|0;c[f>>2]=r;t=r}fUc(20,t,0,0)|0;l=p;m=30;break b;break};default:{s=0;i=e;return s|0}}}}while(0);if((m|0)==15){c[d>>2]=0;s=1;i=e;return s|0}else if((m|0)==30){c[d>>2]=l+1;s=1;i=e;return s|0}return 0}function jUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=kUc(b,f,1)|0;fUc(6,c[f>>2]|0,0,0)|0;f=k+1|0;a:do{switch(a[k]|0){case 122:case 90:{l=35;m=36;n=38;break};case 108:case 76:{o=kUc(f,g,0)|0;if((o|0)==0){n=4;break a}p=c[g>>2]|0;if((p|0)==0){q=o;n=45;break a}fUc(29,p,0,0)|0;q=o;n=45;break};case 111:case 79:{l=32;m=34;n=38;break};case 97:case 65:{o=f;while(1){r=a[o]|0;if(r<<24>>24==32){o=o+1|0}else{break}}if(!((r+ -48<<24>>24&255)<10)){fUc(30,0,0,0)|0;q=o;n=45;break a}p=kUc(o,g,1)|0;s=c[g>>2]|0;if((s|0)==0){q=p;n=45;break a}fUc(31,s,0,0)|0;q=p;n=45;break};case 101:case 69:{t=1;n=3;break};case 105:case 73:{l=7;m=10;n=38;break};case 100:case 68:{p=kUc(f,g,0)|0;if((p|0)==0){n=4;break a}s=c[g>>2]|0;if((s|0)==0){q=p;n=45;break a}if((a[p]|0)==46){u=kUc(p+1|0,h,0)|0;if((u|0)==0){n=4;break a}v=u;w=c[h>>2]|0}else{c[h>>2]=0;v=p;w=0}fUc(26,s,w,0)|0;q=v;n=45;break};case 102:case 70:{s=kUc(f,g,0)|0;if((s|0)==0){n=4;break a}p=c[g>>2]|0;if((p|0)==0){q=s;n=45;break a}if((a[s]|0)==46){u=kUc(s+1|0,h,0)|0;if((u|0)==0){n=4;break a}x=u;y=c[h>>2]|0}else{c[h>>2]=0;x=s;y=0}fUc(23,p,y,0)|0;q=x;n=45;break};case 103:case 71:{t=0;n=3;break};default:{c[88934]=(c[88934]|0)+ -1;c[d>>2]=b;z=0;i=e;return z|0}}}while(0);do{if((n|0)==3){b=kUc(f,g,0)|0;if((b|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=b;n=45;break}y=a[b]|0;if(y<<24>>24==46){v=kUc(b+1|0,h,0)|0;if((v|0)==0){n=4;break}A=v;B=a[v]|0}else{c[h>>2]=0;A=b;B=y}if(!(B<<24>>24==101|B<<24>>24==69)){fUc((t|0)==1?24:27,x,c[h>>2]|0,0)|0;q=A;n=45;break}y=kUc(A+1|0,j,0)|0;if((y|0)==0){n=4;break}fUc((t|0)==1?25:28,x,c[h>>2]|0,c[j>>2]|0)|0;q=y;n=45}else if((n|0)==38){y=kUc(f,g,0)|0;if((y|0)==0){n=4;break}x=c[g>>2]|0;if((x|0)==0){q=y;n=45;break}if((a[y]|0)!=46){fUc(l,x,0,0)|0;q=y;n=45;break}b=kUc(y+1|0,h,0)|0;if((b|0)==0){n=4;break}fUc(m,x,c[h>>2]|0,0)|0;q=b;n=45}}while(0);if((n|0)==4){c[d>>2]=0;z=1;i=e;return z|0}else if((n|0)==45){c[d>>2]=q;z=1;i=e;return z|0}return 0}function kUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=b;b=0;h=0;while(1){j=a[g]|0;k=j<<24>>24;if(j<<24>>24==32){l=b;m=h}else{if((j+ -48<<24>>24&255)>9){break}l=b+1|0;m=(h*10|0)+ -48+k|0}g=g+1|0;b=l;h=m}if((b|0)!=0){n=g;o=h;c[d>>2]=o;i=f;return n|0}n=(e|0)==0?0:g;o=e;c[d>>2]=o;i=f;return n|0}function lUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;e=a[b]|0;f=b+1|0;g=a[f]|0;a:do{if(!(g<<24>>24==0)){h=f;j=g;k=b;while(1){if(j<<24>>24==e<<24>>24){l=k+2|0;if((a[l]|0)==e<<24>>24){m=l}else{n=l;break}}else{m=h}l=m+1|0;o=a[l]|0;if(o<<24>>24==0){break a}else{h=l;j=o;k=m}}i=d;return n|0}}while(0);if((c[c[88906]>>2]|0)==0){XTc(100,360720);n=0;i=d;return n|0}else{c[(Nc()|0)>>2]=100;n=0;i=d;return n|0}return 0}function mUc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;do{if((b|0)>0){h=0;j=b}else{if((b|0)<0){h=1;j=0-b|0;break}c[e>>2]=0;c[d>>2]=1;a[360790|0]=48;k=360790|0;i=g;return k|0}}while(0);c[e>>2]=h;h=23;e=j;while(1){j=h+ -1|0;l=360768+j|0;a[l]=((e>>>0)%(f>>>0)|0)+48;b=(e>>>0)/(f>>>0)|0;if((b|0)==0){break}else{e=b;h=j}}c[d>>2]=24-h;k=l;i=g;return k|0}function nUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=c[88928]|0;f=c[88924]|0;if((e|0)>(f|0)){c[88924]=e;g=e}else{g=f}f=g+1|0;if((f|0)<(c[90216]|0)){h=g}else{oUc(f,g);h=c[88924]|0}g=c[90218]|0;f=g+h|0;if((b|0)==0){j=f}else{a[f]=b;j=g+(h+1)|0}a[j]=0;Kd(g|0,c[88902]|0)|0;h=L4c(g|0)|0;b=g+h|0;if(b>>>0<j>>>0){k=b;l=h;m=g}else{i=d;return 0}while(1){g=l+1|0;h=m+g|0;Sd(a[k]|0,c[88902]|0)|0;Kd(h|0,c[88902]|0)|0;b=L4c(h|0)|0;f=m+(g+b)|0;if(f>>>0<j>>>0){m=h;l=b;k=f}else{break}}i=d;return 0}function oUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=c[90218]|0;if((f|0)==360952){c[90216]=1024;g=1024}else{g=c[90216]|0}if((g|0)>(b|0)){h=g}else{j=g;do{j=j<<1;}while((j|0)<=(b|0));c[90216]=j;h=j}j=h4c(h)|0;if((j|0)==0){XTc(113,361352);k=c[90218]|0}else{k=f}f=k+d|0;if((d|0)>0){d=j;h=k;while(1){b=h+1|0;a[d]=a[h]|0;if(b>>>0<f>>>0){h=b;d=d+1|0}else{break}}l=c[90218]|0}else{l=k}if((l|0)==360952){m=360872;c[90218]=j;i=e;return}i4c(l);m=360872;c[90218]=j;i=e;return}function pUc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[88924]|0;f=c[90216]|0;if((e|0)<(f|0)){g=e}else{oUc(e,f);g=c[88924]|0}c[88924]=g+1;a[(c[90218]|0)+g|0]=b;i=d;return}function qUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;i=i+8|0;e=d;f=i;i=i+256|0;g=i;i=i+16|0;h=i;i=i+8|0;j=f;c[88888]=1;f=b+4|0;k=c[f>>2]|0;if(k>>>0>99){if((c[b>>2]|0)==0){XTc(101,360880);l=101;i=d;return l|0}else{c[(Nc()|0)>>2]=101;l=101;i=d;return l|0}}if((c[88900]|0)==0){YTc();m=c[f>>2]|0}else{m=k}k=350536+(m*48|0)|0;c[87624]=k;n=k;a:do{if((c[n>>2]|0)!=0){k=c[b+8>>2]|0;do{if((k|0)!=0){vUc(k,c[b+12>>2]|0,j);o=wUc(j,h)|0;if((o|0)==(c[350544+(m*48|0)>>2]|0)){if((c[h>>2]|0)==(c[350548+(m*48|0)>>2]|0)){break}}c[g+4>>2]=c[f>>2];c[g+8>>2]=0;c[g>>2]=c[b>>2];o=TTc(g)|0;if((o|0)==0){break a}else{l=o}i=d;return l|0}}while(0);k=c[b+32>>2]|0;if((k|0)==0){l=0;i=d;return l|0}o=a[k]|0;if(o<<24>>24==122){p=1}else{p=o<<24>>24==90|0}c[350568+(m*48|0)>>2]=p;l=0;i=d;return l|0}}while(0);p=b+28|0;g=c[p>>2]|0;h=350552+(m*48|0)|0;c[h>>2]=g;o=c[b+32>>2]|0;do{if((o|0)==0){q=0}else{k=a[o]|0;if(k<<24>>24==122){q=1;break}q=k<<24>>24==90|0}}while(0);c[350568+(m*48|0)>>2]=q;q=c[b+24>>2]|0;do{if((q|0)==0){o=350560+(m*48|0)|0;if((g|0)>0){c[o>>2]=0;r=0;break}else{c[o>>2]=1;r=1;break}}else{o=a[q]|0;if(o<<24>>24==70|o<<24>>24==102){c[350560+(m*48|0)>>2]=1;r=1;break}else{c[350560+(m*48|0)>>2]=0;r=0;break}}}while(0);q=c[b+8>>2]|0;do{if((q|0)==0){c[e>>2]=c[f>>2];hc(j|0,360888,e|0)|0}else{vUc(q,c[b+12>>2]|0,j);if((a[j]|0)!=0){break}if((c[b>>2]|0)==0){rUc(107,360880,b);l=107;i=d;return l|0}else{c[(Nc()|0)>>2]=107;l=107;i=d;return l|0}}}while(0);q=350580+(m*48|0)|0;c[q>>2]=0;c[350572+(m*48|0)>>2]=0;e=350576+(m*48|0)|0;c[e>>2]=0;c[n>>2]=0;f=350564+(m*48|0)|0;c[f>>2]=3;g=c[b+16>>2]|0;b:do{if((g|0)!=0){c:do{switch(a[g]|0){case 79:case 111:{if((Cc(j|0,0)|0)==0){break b}o=(c[b>>2]|0)==0;k=Nc()|0;s=c[k>>2]|0;if(o){rUc(s,360880,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=s;l=s;i=d;return l|0}break};case 83:case 115:{c[q>>2]=1;s=Mb()|0;c[n>>2]=s;if((s|0)!=0){c[350540+(m*48|0)>>2]=0;c[350548+(m*48|0)>>2]=-1;c[350544+(m*48|0)>>2]=-1;c[350556+(m*48|0)>>2]=1;l=0;i=d;return l|0}s=(c[b>>2]|0)==0;k=Nc()|0;o=c[k>>2]|0;if(s){rUc(o,360880,b);l=c[k>>2]|0;i=d;return l|0}else{c[k>>2]=o;l=o;i=d;return l|0}break};case 82:case 114:{break};case 78:case 110:{if((Cc(j|0,0)|0)!=0){break c}if((c[b>>2]|0)==0){rUc(128,360880,b);l=128;i=d;return l|0}else{c[(Nc()|0)>>2]=128;l=128;i=d;return l|0}break};default:{break b}}}while(0);o=ic(j|0,c[90212]|0)|0;if((o|0)==0){break}Yc(o|0)|0}}while(0);q=h4c((L4c(j|0)|0)+1|0)|0;c[350540+(m*48|0)>>2]=q;if((q|0)==0){if((c[b>>2]|0)==0){rUc(113,360904,b);l=113;i=d;return l|0}else{c[(Nc()|0)>>2]=113;l=113;i=d;return l|0}}R4c(q|0,j|0)|0;q=b+20|0;if((c[q>>2]|0)==0){t=r}else{t=(c[h>>2]|0)==0?r:0}r=ic(j|0,c[360848+((t|2)<<2)>>2]|0)|0;do{if((r|0)==0){h=ic(j|0,c[360808+(t<<2)>>2]|0)|0;if((h|0)!=0){c[f>>2]=1;u=h;break}h=ic(j|0,c[360848+(t<<2)>>2]|0)|0;if((h|0)!=0){c[e>>2]=1;c[f>>2]=2;u=h;break}h=(c[b>>2]|0)==0;g=Nc()|0;o=c[g>>2]|0;if(h){XTc(o,360880);l=c[g>>2]|0;i=d;return l|0}else{c[g>>2]=o;l=o;i=d;return l|0}}else{u=r}}while(0);c[n>>2]=u;r=350556+(m*48|0)|0;c[r>>2]=WTc(u)|0;u=wUc(j,350548+(m*48|0)|0)|0;c[350544+(m*48|0)>>2]=u;if((u|0)==-1){if((c[b>>2]|0)==0){rUc(108,360880,b);l=108;i=d;return l|0}else{c[(Nc()|0)>>2]=108;l=108;i=d;return l|0}}if((c[r>>2]|0)==0){l=0;i=d;return l|0}if((c[p>>2]|0)!=0){pb(c[n>>2]|0);l=0;i=d;return l|0}p=c[q>>2]|0;if((p|0)==0){l=0;i=d;return l|0}q=a[p]|0;if(!(q<<24>>24==65|q<<24>>24==97)){l=0;i=d;return l|0}if((Wc(c[n>>2]|0,0,2)|0)==0){l=0;i=d;return l|0}if((c[b>>2]|0)==0){rUc(129,360880,b);l=129;i=d;return l|0}else{c[(Nc()|0)>>2]=129;l=129;i=d;return l|0}return 0}function rUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=d+8|0;g=c[f>>2]|0;if((g|0)==0){XTc(a,b);i=e;return}h=d+12|0;d=c[h>>2]|0;if((d|0)<(c[90216]|0)){j=d;k=g}else{oUc(d,0);j=c[h>>2]|0;k=c[f>>2]|0}f=c[90218]|0;c[(c[87624]|0)+4>>2]=f;vUc(k,j,f);XTc(a,b);i=e;return}function sUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+40|0;j=g;c[f>>2]=d;hc(j|0,360888,f|0)|0;c[h>>2]=1;c[h+4>>2]=d;c[h+8>>2]=j;c[h+12>>2]=L4c(j|0)|0;c[h+16>>2]=0;c[h+20>>2]=(a|0)==3?360920:360928;c[h+24>>2]=(b|0)==5?360936:360944;c[h+28>>2]=(a|0)==4;c[h+32>>2]=0;a=qUc(h)|0;i=e;return a|0}function tUc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a+4>>2]|0;e=350536+(d*48|0)|0;c[87624]=e;if(d>>>0>99){if((c[a>>2]|0)==0){XTc(101,361368);f=101;i=b;return f|0}else{c[(Nc()|0)>>2]=101;f=101;i=b;return f|0}}do{if((c[e>>2]|0)==0){if((sUc(3,5,d)|0)==0){break}if((c[a>>2]|0)==0){XTc(114,361376);f=114;i=b;return f|0}else{c[(Nc()|0)>>2]=114;f=114;i=b;return f|0}}}while(0);if((c[350560+(d*48|0)>>2]|0)!=0){f=0;i=b;return f|0}if((c[a>>2]|0)==0){XTc(102,361376);f=102;i=b;return f|0}else{c[(Nc()|0)>>2]=102;f=102;i=b;return f|0}return 0}function uUc(){var a=0,b=0;a=i;b=dUc()|0;c[88850]=0;i=a;return b|0}function vUc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=b+c|0;g=d+c|0;while(1){if(!(f>>>0>b>>>0)){h=3;break}j=f+ -1|0;k=g+ -1|0;if((a[j]|0)==32){f=j;g=k}else{break}}if((h|0)==3){a[d]=0;i=e;return}a[g]=0;g=j;j=k;while(1){a[j]=a[g]|0;if(g>>>0>b>>>0){j=j+ -1|0;g=g+ -1|0}else{break}}i=e;return}function wUc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+80|0;e=d;if((lc(a|0,e|0)|0)<0){f=-1;i=d;return f|0}c[b>>2]=c[e>>2];f=c[e+72>>2]|0;i=d;return f|0}function xUc(b,d,e,f,j){b=b|0;d=d|0;e=e|0;f=f|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=i;i=i+56|0;p=o;q=(f|0)<1?2:f;r=c[88930]|0;if((r|0)==0){s=3}else{if((r|0)<(e+2|0)&(r|0)>(0-e|0)){s=3}}a:do{if((s|0)==3){t=(((r|0)<1)<<31>>31)+e|0;if((j|0)==4){u=+g[b>>2]}else{u=+h[b>>3]}do{if(u<0.0){v=-u;w=1;x=1}else{y=c[88910]|0;if(u!=0.0){v=u;w=0;x=y;break}v=0.0;w=0;x=y}}while(0);y=d+ -4-q-t-x|0;if((y|0)<0){break}z=((r|0)<0?r:0)+t|0;A=(z|0)>40;B=A?40:z;C=A?z+ -40|0:0;c[n>>2]=B;z=n+4|0;h[k>>3]=v;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];hc(p|0,361384,n|0)|0;z=a[p]|0;if(!((z+ -48|0)>>>0<10)){if((z|0)==78|(z|0)==110){D=0}else{D=x}z=d-(L4c(p|0)|0)-D|0;if((z|0)<0){break}if((z|0)>0){A=z;do{A=A+ -1|0;fe[c[88914]&1023](32);}while((A|0)>0)}if((D|0)!=0){fe[c[88914]&1023]((w|0)!=0?45:43)}A=a[p]|0;if(A<<24>>24==0){i=l;return 0}else{E=A;F=p}do{fe[c[88914]&1023](E<<24>>24);F=F+1|0;E=a[F]|0;}while(!(E<<24>>24==0));i=l;return 0}A=o+(B+3)|0;if(v!=0.0){t=(Fc(A|0)|0)+1|0;c[m>>2]=t-(c[88930]|0);hc(A|0,361392,m|0)|0}else{t=A;a[t]=3158059;a[t+1|0]=12336;a[t+2|0]=48;a[t+3|0]=0}t=o+(B+4)|0;A=(q|0)<2;if(A){if((a[t]|0)!=48){break}}z=o+(B+6)|0;G=(a[z]|0)==0;b:do{if(G){H=2}else{if((f|0)==0){I=o+(B+2)|0;while(1){J=I+1|0;K=a[J]|0;a[I]=K;if(K<<24>>24==0){H=2;break b}else{I=J}}}I=(f|0)<0;if(I|G){H=I?q:2;break}else{L=2;M=z}while(1){if((L|0)>=(q|0)){break a}I=L+1|0;J=M+1|0;if((a[J]|0)==0){H=I;break}else{L=I;M=J}}}}while(0);if((y|0)>0){z=y;do{z=z+ -1|0;fe[c[88914]&1023](32);}while((z|0)>0)}if((x|0)!=0){fe[c[88914]&1023]((w|0)!=0?45:43)}z=c[88930]|0;do{if((z|0)<1){fe[c[88914]&1023](46);y=c[88914]|0;if((z|0)<0){G=y;J=z;while(1){fe[G&1023](48);I=J+1|0;K=c[88914]|0;if((I|0)<0){J=I;G=K}else{N=K;break}}}else{N=y}fe[N&1023](a[p]|0);O=o+2|0}else{if((z|0)<=1){O=p;break}fe[c[88914]&1023](a[p]|0);G=o+2|0;J=z+ -1|0;K=c[88914]|0;if((J|0)>0){I=z+1|0;P=K;Q=J;J=G;while(1){fe[P&1023](a[J]|0);R=Q+ -1|0;S=c[88914]|0;if((R|0)>0){J=J+1|0;Q=R;P=S}else{break}}T=S;U=o+I|0}else{T=K;U=G}fe[T&1023](46);O=U}}while(0);if((C|0)==0){V=O}else{z=o+(B+2)|0;if(O>>>0<z>>>0){P=O;while(1){Q=P+1|0;fe[c[88914]&1023](a[P]|0);if(Q>>>0<z>>>0){P=Q}else{W=Q;break}}}else{W=O}P=C;while(1){fe[c[88914]&1023](48);z=P+ -1|0;if((z|0)>0){P=z}else{V=W;break}}}if(V>>>0<t>>>0){P=V;while(1){C=P+1|0;fe[c[88914]&1023](a[P]|0);if(C>>>0<t>>>0){P=C}else{X=C;break}}}else{X=V}if(A){fe[c[88914]&1023](a[X+1|0]|0);i=l;return 0}if((H|0)<(q|0)){P=H;do{P=P+1|0;fe[c[88914]&1023](48);}while((P|0)<(q|0))}P=a[X]|0;if(P<<24>>24==0){i=l;return 0}else{Y=P;Z=X}do{Z=Z+1|0;fe[c[88914]&1023](Y<<24>>24);Y=a[Z]|0;}while(!(Y<<24>>24==0));i=l;return 0}}while(0);if((d|0)>0){_=d}else{i=l;return 0}do{_=_+ -1|0;fe[c[88914]&1023](42);}while((_|0)>0);i=l;return 0}function yUc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;j=i;i=i+16|0;l=j;m=i;i=i+656|0;n=m;if((f|0)==4){o=+g[b>>2]}else{o=+h[b>>3]}b=(e|0)<344;f=b?e:344;p=b?0:e+ -344|0;do{if(o<0.0){q=1;r=-o}else{if(o!=0.0){q=0;r=o;break}q=0;r=0.0}}while(0);e=c[88930]|0;if((e|0)==0){s=r}else{if((e|0)>0){b=e;o=r;while(1){t=o*10.0;u=b+ -1|0;if((u|0)>0){o=t;b=u}else{s=t;break}}}else{b=e;o=r;while(1){r=o*.1;e=b+1|0;if((e|0)<0){o=r;b=e}else{s=r;break}}}}c[l>>2]=f;b=l+4|0;h[k>>3]=s;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=(hc(n|0,361400,l|0)|0)+p|0;if((a[n]|0)!=48|(f|0)==0){v=n;w=b}else{v=m+1|0;w=b+ -1|0}a:do{if((q|0)==1){b=v;while(1){m=a[b]|0;if(!(m<<24>>24==48)){n=m<<24>>24;if((n|0)==0){x=0;break a}else if((n|0)!=46){break}}b=b+1|0}x=1}else{x=q}}while(0);q=(x|0)==0;b=((c[88910]|x|0)!=0)+w|0;if((b|0)>(d|0)){if((d|0)>0){y=d}else{i=j;return 0}do{y=y+ -1|0;fe[c[88914]&1023](42);}while((y|0)>0);i=j;return 0}y=d-b|0;if((y|0)>0){b=y;do{b=b+ -1|0;fe[c[88914]&1023](32);}while((b|0)>0)}do{if(q){if((c[88910]|0)==0){break}fe[c[88914]&1023](43)}else{fe[c[88914]&1023](45)}}while(0);q=a[v]|0;if(!(q<<24>>24==0)){b=q;q=v;do{q=q+1|0;fe[c[88914]&1023](b<<24>>24);b=a[q]|0;}while(!(b<<24>>24==0))}if((p|0)>0){z=p}else{i=j;return 0}do{z=z+ -1|0;fe[c[88914]&1023](48);}while((z|0)>0);i=j;return 0}function zUc(d,e,f){d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((f|0)==4){h=c[d>>2]|0}else if((f|0)==1){h=a[d]|0}else{h=b[d>>1]|0}d=e+ -1|0;if((d|0)>0){e=0;do{fe[c[88914]&1023](32);e=e+1|0;}while((e|0)<(d|0))}d=c[88914]|0;if((h|0)==0){fe[d&1023](70);i=g;return 0}else{fe[d&1023](84);i=g;return 0}return 0}function AUc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;do{if((c[88926]|0)!=0){g=BUc()|0;if((g|0)==0){break}else{h=g}i=e;return h|0}}while(0);g=c[a>>2]|0;switch(g|0){case 36:{HUc(b,c[a+4>>2]|0,c[a+8>>2]|0,d);h=0;i=e;return h|0};case 7:{CUc(b,c[a+4>>2]|0,d,10);h=0;i=e;return h|0};case 23:{h=yUc(b,c[a+4>>2]|0,c[a+8>>2]|0,d)|0;i=e;return h|0};case 29:{zUc(b,c[a+4>>2]|0,d)|0;h=0;i=e;return h|0};case 34:{DUc(b,c[a+4>>2]|0,c[a+8>>2]|0,d,8);h=0;i=e;return h|0};case 31:{FUc(b,c[a+4>>2]|0,d);h=0;i=e;return h|0};case 35:{HUc(b,c[a+4>>2]|0,0,d);h=0;i=e;return h|0};case 30:{EUc(b,d);h=0;i=e;return h|0};case 28:case 27:{h=GUc(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 10:{DUc(b,c[a+4>>2]|0,c[a+8>>2]|0,d,10);h=0;i=e;return h|0};case 25:case 24:case 26:{h=xUc(b,c[a+4>>2]|0,c[a+8>>2]|0,c[a+12>>2]|0,d)|0;i=e;return h|0};case 32:{CUc(b,c[a+4>>2]|0,d,8);h=0;i=e;return h|0};default:{h=c[r>>2]|0;c[f>>2]=g;wd(h|0,361408,f|0)|0;MTc(c[88850]|0,1)}}return 0}function BUc(){var a=0,b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;a=i;b=c[88926]|0;c[88926]=0;if((c[88888]|0)!=0){if((b|0)>0){d=c[88928]|0;e=c[88924]|0;if((d|0)<=(e|0)){f=b;while(1){fe[c[88914]&1023](32);g=f+ -1|0;if((g|0)>0){f=g}else{h=0;break}}i=a;return h|0}f=e+b|0;if((d|0)>(f|0)){c[88924]=f;h=0;i=a;return h|0}f=b-d+e|0;c[88924]=d;if((f|0)>0){j=f}else{h=0;i=a;return h|0}while(1){fe[c[88914]&1023](32);f=j+ -1|0;if((f|0)>0){j=f}else{h=0;break}}i=a;return h|0}if((b|0)>=0){h=0;i=a;return h|0}j=c[88924]|0;f=j+b|0;if((f|0)>=0){if((c[88928]|0)<(j|0)){c[88928]=j}c[88924]=f;h=0;i=a;return h|0}if((c[c[88906]>>2]|0)==0){XTc(110,361496);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<0){f=c[88924]|0;if((c[88928]|0)<(f|0)){c[88928]=f}j=f+b|0;c[88924]=j;c[88932]=(c[88932]|0)+b;if((j|0)>=0){h=0;i=a;return h|0}if((c[c[88906]>>2]|0)==0){XTc(110,361496);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}if((b|0)<=0){h=0;i=a;return h|0}j=c[88924]|0;f=j+b|0;if((f|0)>=(c[(c[88908]|0)+16>>2]|0)){if((c[c[88906]>>2]|0)==0){XTc(110,361512);h=110;i=a;return h|0}else{c[(Nc()|0)>>2]=110;h=110;i=a;return h|0}}d=c[88928]|0;if((d|0)<=(j|0)){e=b;while(1){fe[c[88914]&1023](32);g=e+ -1|0;if((g|0)>0){e=g}else{h=0;break}}i=a;return h|0}if((d|0)>(f|0)){c[88932]=(c[88932]|0)+b;c[88924]=f;h=0;i=a;return h|0}f=d-j|0;j=b-f|0;c[88932]=(c[88932]|0)+f;c[88924]=d;if((j|0)>0){k=j}else{h=0;i=a;return h|0}while(1){fe[c[88914]&1023](32);j=k+ -1|0;if((j|0)>0){k=j}else{h=0;break}}i=a;return h|0}function CUc(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+16|0;j=h;k=h+8|0;if((f|0)==1){l=a[d]|0}else if((f|0)==4){l=c[d>>2]|0}else{l=b[d>>1]|0}d=mUc(l,j,k,g)|0;g=c[k>>2]|0;l=(((c[88910]|g|0)!=0)<<31>>31)+(e-(c[j>>2]|0))|0;if((l|0)<0){if((e|0)>0){m=0}else{i=h;return}do{fe[c[88914]&1023](42);m=m+1|0;}while((m|0)<(e|0));i=h;return}if((l|0)>0){e=0;do{fe[c[88914]&1023](32);e=e+1|0;}while((e|0)<(l|0));n=c[k>>2]|0}else{n=g}do{if((n|0)==0){if((c[88910]|0)==0){break}fe[c[88914]&1023](43)}else{fe[c[88914]&1023](45)}}while(0);if((c[j>>2]|0)>0){o=d;p=0}else{i=h;return}while(1){fe[c[88914]&1023](a[o]|0);d=p+1|0;if((d|0)<(c[j>>2]|0)){p=d;o=o+1|0}else{break}}i=h;return}function DUc(d,e,f,g,h){d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;j=i;i=i+16|0;k=j;l=j+8|0;if((g|0)==4){m=c[d>>2]|0}else if((g|0)==1){m=a[d]|0}else{m=b[d>>1]|0}d=mUc(m,k,l,h)|0;h=c[l>>2]|0;g=(c[88910]|h|0)!=0;n=g&1;o=c[k>>2]|0;do{if((n+o|0)<=(e|0)){if((n+f|0)>(e|0)){break}if((m|f|0)==0){if((e|0)>0){p=0}else{i=j;return}do{fe[c[88914]&1023](32);p=p+1|0;}while((p|0)<(e|0));i=j;return}q=e-((o|0)<(f|0)?f:o)+(g<<31>>31)|0;if((q|0)>0){r=0;do{fe[c[88914]&1023](32);r=r+1|0;}while((r|0)<(q|0));s=c[l>>2]|0}else{s=h}do{if((s|0)==0){if((c[88910]|0)==0){break}fe[c[88914]&1023](43)}else{fe[c[88914]&1023](45)}}while(0);q=c[k>>2]|0;if((f-q|0)>0){r=0;while(1){fe[c[88914]&1023](48);t=r+1|0;u=c[k>>2]|0;if((t|0)<(f-u|0)){r=t}else{v=u;break}}}else{v=q}if((v|0)>0){w=d;x=0}else{i=j;return}while(1){fe[c[88914]&1023](a[w]|0);r=x+1|0;if((r|0)<(c[k>>2]|0)){x=r;w=w+1|0}else{break}}i=j;return}}while(0);if((e|0)>0){y=0}else{i=j;return}do{fe[c[88914]&1023](42);y=y+1|0;}while((y|0)<(e|0));i=j;return}function EUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)>0){f=b;g=d}else{i=e;return}while(1){d=g+ -1|0;fe[c[88914]&1023](a[f]|0);if((d|0)>0){g=d;f=f+1|0}else{break}}i=e;return}function FUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;if((d|0)>(e|0)){g=d;while(1){h=g+ -1|0;fe[c[88914]&1023](32);if((h|0)>(e|0)){g=h}else{j=e;break}}}else{j=d}if((j|0)>0){k=b;l=j}else{i=f;return}while(1){j=l+ -1|0;fe[c[88914]&1023](a[k]|0);if((j|0)>0){l=j;k=k+1|0}else{break}}i=f;return}function GUc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0.0,l=0.0,m=0,n=0,o=0,p=0;j=i;if((f|0)==4){k=+g[a>>2]}else{k=+h[a>>3]}if(k<0.0){l=-k}else{l=k}a:do{if(l<.1){if(!(l!=0.0)){m=1;break}n=xUc(a,b,d,e,f)|0;i=j;return n|0}else{if((d|0)>=0){o=0;k=1.0;while(1){if(!(l>=k)){m=o;break a}if((o|0)<(d|0)){o=o+1|0;k=k*10.0}else{break}}}n=xUc(a,b,d,e,f)|0;i=j;return n|0}}while(0);o=c[88930]|0;c[88930]=0;p=(e|0)==0?4:e+2|0;e=yUc(a,b-p|0,d-m|0,f)|0;if((p|0)>0){f=0;do{fe[c[88914]&1023](32);f=f+1|0;}while((f|0)<(p|0))}c[88930]=o;n=e;i=j;return n|0}function HUc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;k=b+(g+ -1)|0;a:do{if((k|0)==(j|0)){l=1;m=j}else{g=k;while(1){n=g+ -1|0;if((a[g]|0)!=0){l=0;m=g;break a}if((n|0)==(j|0)){l=1;m=j;break}else{g=n}}}}while(0);k=((d[m]|0)>15)+(m-b<<1|1)|0;if((k|0)>(e|0)){if((e|0)>0){o=0}else{i=h;return}do{fe[c[88914]&1023](42);o=o+1|0;}while((o|0)<(e|0));i=h;return}o=f-k|0;b=(o|0)>0;g=b?f:k;if((g|0)<(e|0)){k=e;do{k=k+ -1|0;fe[c[88914]&1023](32);}while((k|0)>(g|0))}if(b){b=o;do{b=b+ -1|0;fe[c[88914]&1023](48);}while((b|0)>0)}b=a[m]|0;do{if((b&240|0)==0){fe[c[88914]&1023](a[361472+(b&15)|0]|0);if(l){i=h;return}else{p=m+ -1|0;break}}else{p=m}}while(0);while(1){fe[c[88914]&1023](a[361472+((d[p]|0)>>>4)|0]|0);fe[c[88914]&1023](a[361472+(a[p]&15)|0]|0);if((p|0)==(j|0)){break}p=p+ -1|0}i=h;return}function IUc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[a>>2]|0;switch(e|0){case 5:{f=Ce[c[88922]&7]()|0;i=b;return f|0};case 13:{g=(c[88926]|0)-(c[a+4>>2]|0)|0;h=0-(c[88924]|0)|0;c[88926]=(g|0)<(h|0)?h:g;f=1;i=b;return f|0};case 11:{f=JUc(c[a+8>>2]|0)|0;i=b;return f|0};case 4:case 14:{c[88926]=(c[88926]|0)+(c[a+4>>2]|0);f=1;i=b;return f|0};case 15:{c[88926]=(c[a+4>>2]|0)+ -1-(c[88924]|0);f=1;i=b;return f|0};case 12:{f=KUc(c[a+4>>2]|0,c[a+8>>2]|0)|0;i=b;return f|0};default:{f=c[r>>2]|0;c[d>>2]=e;wd(f|0,361440,d|0)|0;MTc(c[88850]|0,1)}}return 0}function JUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;do{if((c[88926]|0)!=0){e=BUc()|0;if((e|0)==0){break}else{f=e}i=d;return f|0}}while(0);e=a[b]|0;g=b+1|0;h=a[g]|0;if(h<<24>>24==0){f=1;i=d;return f|0}else{j=g;k=h;l=b}while(1){if(k<<24>>24==e<<24>>24){b=l+2|0;if(!((a[b]|0)==e<<24>>24)){f=1;m=9;break}fe[c[88914]&1023](e<<24>>24);n=b}else{fe[c[88914]&1023](k<<24>>24);n=j}b=n+1|0;h=a[b]|0;if(h<<24>>24==0){f=1;m=9;break}else{j=b;k=h;l=n}}if((m|0)==9){i=d;return f|0}return 0}function KUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;do{if((c[88926]|0)!=0){f=BUc()|0;if((f|0)==0){break}else{g=f}i=e;return g|0}}while(0);if((b|0)==0){g=1;i=e;return g|0}else{h=d;j=b}while(1){b=j+ -1|0;fe[c[88914]&1023](a[h]|0);if((b|0)==0){g=1;break}else{j=b;h=h+1|0}}i=e;return g|0}function LUc(){var a=0,b=0;a=i;b=nUc(10)|0;c[88926]=0;c[88924]=0;c[88928]=0;i=a;return(b|0)==0|0}function MUc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((c[88900]|0)==0){YTc()}c[88864]=0;c[88870]=1;c[88878]=1;c[88888]=1;d=tUc(a)|0;if((d|0)!=0){e=d;i=b;return e|0}c[88906]=a;c[88924]=0;c[88926]=0;c[88928]=0;c[90178]=0;c[88930]=0;d=c[a+12>>2]|0;c[88850]=d;c[88902]=c[c[87624]>>2];if(($Tc(d)|0)<0){if((c[a>>2]|0)==0){XTc(100,361520);e=100;i=b;return e|0}else{c[(Nc()|0)>>2]=100;e=100;i=b;return e|0}}c[88914]=767;c[88916]=44;c[88918]=111;c[88904]=4;c[88920]=5;c[88922]=6;eUc();c[88910]=0;d=c[87624]|0;c[88912]=c[d+32>>2];if((c[d+40>>2]|0)==1){e=0;i=b;return e|0}if((ZTc(d)|0)==0){e=0;i=b;return e|0}d=(c[a>>2]|0)==0;a=Nc()|0;f=c[a>>2]|0;if(d){XTc(f,361528);e=c[a>>2]|0;i=b;return e|0}else{c[a>>2]=f;e=f;i=b;return e|0}return 0}function NUc(){var a=0,b=0;a=i;if((c[90178]|0)==0){b=nUc(10)|0}else{nUc(0)|0;ud(c[88902]|0)|0;b=0}c[88926]=0;c[88924]=0;c[88928]=0;i=a;return b|0}function OUc(){var a=0,b=0,d=0;a=i;if((c[90162]|0)==0){b=0}else{d=nUc(10)|0;c[90162]=0;b=d}c[88926]=0;c[88924]=0;c[88928]=0;i=a;return b|0}function PUc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+32|0;d=b;e=b+8|0;f=b+16|0;g=b+24|0;h=c[s>>2]|0;jVc(362256,h,362312);c[90386]=363764;c[361552>>2]=363784;c[361548>>2]=0;aXc(361552|0,362256);c[361624>>2]=0;c[361628>>2]=-1;j=c[t>>2]|0;c[90590]=363632;K0c(362364|0);k=362368|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[90590]=362872;c[362392>>2]=j;L0c(g,362364|0);k=O0c(g,366424)|0;l=k;M0c(g);c[362396>>2]=l;c[362400>>2]=362320;a[362404|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](l)|0)&1;c[90408]=363844;c[361636>>2]=363864;aXc(361636|0,362360);c[361708>>2]=0;c[361712>>2]=-1;l=c[r>>2]|0;c[90602]=363632;K0c(362412|0);k=362416|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[90602]=362872;c[362440>>2]=l;L0c(f,362412|0);k=O0c(f,366424)|0;g=k;M0c(f);c[362444>>2]=g;c[362448>>2]=362328;a[362452|0]=(ie[c[(c[k>>2]|0)+28>>2]&127](g)|0)&1;c[90430]=363844;c[361724>>2]=363864;aXc(361724|0,362408);c[361796>>2]=0;c[361800>>2]=-1;g=c[(c[(c[90430]|0)+ -12>>2]|0)+361744>>2]|0;c[90452]=363844;c[361812>>2]=363864;aXc(361812|0,g);c[361884>>2]=0;c[361888>>2]=-1;c[(c[(c[90386]|0)+ -12>>2]|0)+361616>>2]=361632;g=(c[(c[90430]|0)+ -12>>2]|0)+361724|0;c[g>>2]=c[g>>2]|8192;c[(c[(c[90430]|0)+ -12>>2]|0)+361792>>2]=361632;XUc(362456,h,362336|0);c[90474]=363804;c[361904>>2]=363824;c[361900>>2]=0;aXc(361904|0,362456);c[361976>>2]=0;c[361980>>2]=-1;c[90628]=363696;K0c(362516|0);h=362520|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[90628]=362616;c[362544>>2]=j;L0c(e,362516|0);j=O0c(e,366432)|0;h=j;M0c(e);c[362548>>2]=h;c[362552>>2]=362344;a[362556|0]=(ie[c[(c[j>>2]|0)+28>>2]&127](h)|0)&1;c[90496]=363884;c[361988>>2]=363904;aXc(361988|0,362512);c[362060>>2]=0;c[362064>>2]=-1;c[90640]=363696;K0c(362564|0);h=362568|0;c[h+0>>2]=0;c[h+4>>2]=0;c[h+8>>2]=0;c[h+12>>2]=0;c[h+16>>2]=0;c[h+20>>2]=0;c[90640]=362616;c[362592>>2]=l;L0c(d,362564|0);l=O0c(d,366432)|0;h=l;M0c(d);c[362596>>2]=h;c[362600>>2]=362352;a[362604|0]=(ie[c[(c[l>>2]|0)+28>>2]&127](h)|0)&1;c[90518]=363884;c[362076>>2]=363904;aXc(362076|0,362560);c[362148>>2]=0;c[362152>>2]=-1;h=c[(c[(c[90518]|0)+ -12>>2]|0)+362096>>2]|0;c[90540]=363884;c[362164>>2]=363904;aXc(362164|0,h);c[362236>>2]=0;c[362240>>2]=-1;c[(c[(c[90474]|0)+ -12>>2]|0)+361968>>2]=361984;h=(c[(c[90518]|0)+ -12>>2]|0)+362076|0;c[h>>2]=c[h>>2]|8192;c[(c[(c[90518]|0)+ -12>>2]|0)+362144>>2]=361984;i=b;return}function QUc(a){a=a|0;a=i;_Xc(361632)|0;_Xc(361808)|0;fYc(361984)|0;fYc(362160)|0;i=a;return}function RUc(a){a=a|0;var b=0;b=i;c[a>>2]=363696;M0c(a+4|0);i=b;return}function SUc(a){a=a|0;var b=0;b=i;c[a>>2]=363696;M0c(a+4|0);p4c(a);i=b;return}function TUc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=O0c(d,366432)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function UUc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function VUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;if((a[b+44|0]|0)!=0){g=rc(d|0,4,e|0,c[b+32>>2]|0)|0;i=f;return g|0}if((e|0)>0){h=d;j=0}else{g=0;i=f;return g|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,c[h>>2]|0)|0)==-1){g=j;k=6;break}d=j+1|0;if((d|0)<(e|0)){h=h+4|0;j=d}else{g=d;k=6;break}}if((k|0)==6){i=f;return g|0}return 0}function WUc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){c[g>>2]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,4,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+4|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function XUc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=363696;j=b+4|0;K0c(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=362728;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;L0c(g,j);j=O0c(g,366432)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){W$c(362824)}else{M0c(g);i=f;return}}function YUc(a){a=a|0;var b=0;b=i;c[a>>2]=363696;M0c(a+4|0);i=b;return}function ZUc(a){a=a|0;var b=0;b=i;c[a>>2]=363696;M0c(a+4|0);p4c(a);i=b;return}function _Uc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=O0c(d,366432)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){W$c(362824)}else{i=e;return}}function $Uc(a){a=a|0;var b=0,c=0;b=i;c=cVc(a,0)|0;i=b;return c|0}function aVc(a){a=a|0;var b=0,c=0;b=i;c=cVc(a,1)|0;i=b;return c|0}function bVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){c[h>>2]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+4|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function cVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;if((a[k]|0)!=0){l=b+48|0;m=c[l>>2]|0;if(!d){n=m;i=e;return n|0}c[l>>2]=-1;a[k]=0;n=m;i=e;return n|0}m=c[b+44>>2]|0;k=(m|0)>1?m:1;a:do{if((k|0)>0){m=b+32|0;l=0;while(1){o=dd(c[m>>2]|0)|0;if((o|0)==-1){n=-1;break}a[f+l|0]=o;l=l+1|0;if((l|0)>=(k|0)){break a}}i=e;return n|0}}while(0);b:do{if((a[b+53|0]|0)==0){l=b+40|0;m=b+36|0;o=f;p=g+4|0;q=b+32|0;r=k;while(1){s=c[l>>2]|0;t=s;u=c[t>>2]|0;v=c[t+4>>2]|0;t=c[m>>2]|0;w=f+r|0;x=Ge[c[(c[t>>2]|0)+16>>2]&15](t,s,o,w,h,g,p,j)|0;if((x|0)==3){y=14;break}else if((x|0)==2){n=-1;y=22;break}else if((x|0)!=1){z=r;break b}x=c[l>>2]|0;c[x>>2]=u;c[x+4>>2]=v;if((r|0)==8){n=-1;y=22;break}v=dd(c[q>>2]|0)|0;if((v|0)==-1){n=-1;y=22;break}a[w]=v;r=r+1|0}if((y|0)==14){c[g>>2]=a[o]|0;z=r;break}else if((y|0)==22){i=e;return n|0}}else{c[g>>2]=a[f]|0;z=k}}while(0);if(d){d=c[g>>2]|0;c[b+48>>2]=d;n=d;i=e;return n|0}d=b+32|0;b=z;while(1){if((b|0)<=0){break}z=b+ -1|0;if((qd(a[f+z|0]|0,c[d>>2]|0)|0)==-1){n=-1;y=22;break}else{b=z}}if((y|0)==22){i=e;return n|0}n=c[g>>2]|0;i=e;return n|0}function dVc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);i=b;return}function eVc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);p4c(a);i=b;return}function fVc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=O0c(d,366424)|0;d=f;c[b+36>>2]=d;a[b+44|0]=(ie[c[(c[f>>2]|0)+28>>2]&127](d)|0)&1;i=e;return}function gVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+16|0;d=b;e=b+8|0;f=a+36|0;g=a+40|0;h=d;j=d+8|0;k=d;d=a+32|0;while(1){a=c[f>>2]|0;l=ye[c[(c[a>>2]|0)+20>>2]&63](a,c[g>>2]|0,h,j,e)|0;a=(c[e>>2]|0)-k|0;if((rc(h|0,1,a|0,c[d>>2]|0)|0)!=(a|0)){m=-1;n=5;break}if((l|0)==2){m=-1;n=5;break}else if((l|0)!=1){n=4;break}}if((n|0)==4){m=((ud(c[d>>2]|0)|0)!=0)<<31>>31;i=b;return m|0}else if((n|0)==5){i=b;return m|0}return 0}function hVc(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;if((a[b+44|0]|0)!=0){h=rc(e|0,1,f|0,c[b+32>>2]|0)|0;i=g;return h|0}if((f|0)>0){j=e;k=0}else{h=0;i=g;return h|0}while(1){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,d[j]|0)|0)==-1){h=k;l=6;break}e=k+1|0;if((e|0)<(f|0)){j=j+1|0;k=e}else{h=e;l=6;break}}if((l|0)==6){i=g;return h|0}return 0}function iVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=(d|0)==-1;a:do{if(!k){a[g]=d;if((a[b+44|0]|0)!=0){if((rc(g|0,1,1,c[b+32>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}m=f;c[h>>2]=m;n=g+1|0;o=b+36|0;p=b+40|0;q=f+8|0;r=f;s=b+32|0;t=g;while(1){u=c[o>>2]|0;v=Ge[c[(c[u>>2]|0)+12>>2]&15](u,c[p>>2]|0,t,n,j,m,q,h)|0;if((c[j>>2]|0)==(t|0)){l=-1;w=12;break}if((v|0)==3){w=7;break}u=(v|0)==1;if(!(v>>>0<2)){l=-1;w=12;break}v=(c[h>>2]|0)-r|0;if((rc(m|0,1,v|0,c[s>>2]|0)|0)!=(v|0)){l=-1;w=12;break}if(u){t=u?c[j>>2]|0:t}else{break a}}if((w|0)==7){if((rc(t|0,1,1,c[s>>2]|0)|0)==1){break}else{l=-1}i=e;return l|0}else if((w|0)==12){i=e;return l|0}}}while(0);l=k?0:d;i=e;return l|0}function jVc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+8|0;g=f;h=b;c[h>>2]=363632;j=b+4|0;K0c(j);k=b+8|0;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;c[k+12>>2]=0;c[k+16>>2]=0;c[k+20>>2]=0;c[h>>2]=362984;c[b+32>>2]=d;c[b+40>>2]=e;c[b+48>>2]=-1;a[b+52|0]=0;L0c(g,j);j=O0c(g,366424)|0;e=j;d=b+36|0;c[d>>2]=e;h=b+44|0;c[h>>2]=ie[c[(c[j>>2]|0)+24>>2]&127](e)|0;e=c[d>>2]|0;a[b+53|0]=(ie[c[(c[e>>2]|0)+28>>2]&127](e)|0)&1;if((c[h>>2]|0)>8){W$c(362824)}else{M0c(g);i=f;return}}function kVc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);i=b;return}function lVc(a){a=a|0;var b=0;b=i;c[a>>2]=363632;M0c(a+4|0);p4c(a);i=b;return}function mVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=O0c(d,366424)|0;d=f;g=b+36|0;c[g>>2]=d;h=b+44|0;c[h>>2]=ie[c[(c[f>>2]|0)+24>>2]&127](d)|0;d=c[g>>2]|0;a[b+53|0]=(ie[c[(c[d>>2]|0)+28>>2]&127](d)|0)&1;if((c[h>>2]|0)>8){W$c(362824)}else{i=e;return}}function nVc(a){a=a|0;var b=0,c=0;b=i;c=qVc(a,0)|0;i=b;return c|0}function oVc(a){a=a|0;var b=0,c=0;b=i;c=qVc(a,1)|0;i=b;return c|0}function pVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;i=i+32|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=b+52|0;l=(a[k]|0)!=0;if((d|0)==-1){if(l){m=-1;i=e;return m|0}n=c[b+48>>2]|0;a[k]=(n|0)!=-1|0;m=n;i=e;return m|0}n=b+48|0;a:do{if(l){a[h]=c[n>>2];o=c[b+36>>2]|0;p=f;q=Ge[c[(c[o>>2]|0)+12>>2]&15](o,c[b+40>>2]|0,h,h+1|0,j,p,f+8|0,g)|0;if((q|0)==3){a[p]=c[n>>2];c[g>>2]=f+1}else if((q|0)==1|(q|0)==2){m=-1;i=e;return m|0}q=b+32|0;while(1){o=c[g>>2]|0;if(!(o>>>0>p>>>0)){break a}r=o+ -1|0;c[g>>2]=r;if((qd(a[r]|0,c[q>>2]|0)|0)==-1){m=-1;break}}i=e;return m|0}}while(0);c[n>>2]=d;a[k]=1;m=d;i=e;return m|0}function qVc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;f=i;i=i+32|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=b+52|0;if((a[l]|0)!=0){m=b+48|0;n=c[m>>2]|0;if(!e){o=n;i=f;return o|0}c[m>>2]=-1;a[l]=0;o=n;i=f;return o|0}n=c[b+44>>2]|0;l=(n|0)>1?n:1;a:do{if((l|0)>0){n=b+32|0;m=0;while(1){p=dd(c[n>>2]|0)|0;if((p|0)==-1){o=-1;break}a[g+m|0]=p;m=m+1|0;if((m|0)>=(l|0)){break a}}i=f;return o|0}}while(0);b:do{if((a[b+53|0]|0)==0){m=b+40|0;n=b+36|0;p=g;q=h+1|0;r=b+32|0;s=l;while(1){t=c[m>>2]|0;u=t;v=c[u>>2]|0;w=c[u+4>>2]|0;u=c[n>>2]|0;x=g+s|0;y=Ge[c[(c[u>>2]|0)+16>>2]&15](u,t,p,x,j,h,q,k)|0;if((y|0)==3){z=14;break}else if((y|0)==2){o=-1;z=23;break}else if((y|0)!=1){A=s;break b}y=c[m>>2]|0;c[y>>2]=v;c[y+4>>2]=w;if((s|0)==8){o=-1;z=23;break}w=dd(c[r>>2]|0)|0;if((w|0)==-1){o=-1;z=23;break}a[x]=w;s=s+1|0}if((z|0)==14){a[h]=a[p]|0;A=s;break}else if((z|0)==23){i=f;return o|0}}else{a[h]=a[g]|0;A=l}}while(0);do{if(e){l=a[h]|0;c[b+48>>2]=l&255;B=l}else{l=b+32|0;k=A;while(1){if((k|0)<=0){z=21;break}j=k+ -1|0;if((qd(d[g+j|0]|0,c[l>>2]|0)|0)==-1){o=-1;z=23;break}else{k=j}}if((z|0)==21){B=a[h]|0;break}else if((z|0)==23){i=f;return o|0}}}while(0);o=B&255;i=f;return o|0}function rVc(){var a=0;a=i;PUc(0);Zd(768,362248,q|0)|0;i=a;return}function sVc(a){a=a|0;i=i;return}function tVc(a){a=a|0;var b=0;b=a+4|0;c[b>>2]=1+(c[b>>2]|0);i=i;return}function uVc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+4|0;e=c[d>>2]|0;c[d>>2]=-1+e;if((e|0)!=0){f=0;i=b;return f|0}fe[c[(c[a>>2]|0)+8>>2]&1023](a);f=1;i=b;return f|0}function vVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=363128;e=L4c(b|0)|0;f=o4c(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;N4c(g|0,b|0,e+1|0)|0;i=d;return}function wVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=363128;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}q4c((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}function xVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=363128;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}q4c((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function yVc(a){a=a|0;i=i;return c[a+4>>2]|0}function zVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;c[b>>2]=363152;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=L4c(f|0)|0;g=o4c(d+13|0)|0;c[g+4>>2]=d;c[g>>2]=d;h=g+12|0;c[b+4>>2]=h;c[g+8>>2]=0;N4c(h|0,f|0,d+1|0)|0;i=e;return}function AVc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a>>2]=363152;e=L4c(b|0)|0;f=o4c(e+13|0)|0;c[f+4>>2]=e;c[f>>2]=e;g=f+12|0;c[a+4>>2]=g;c[f+8>>2]=0;N4c(g|0,b|0,e+1|0)|0;i=d;return}function BVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=363152;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}q4c((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}function CVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;c[a>>2]=363152;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);i=b;return}q4c((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);i=b;return}function DVc(a){a=a|0;i=i;return c[a+4>>2]|0}function EVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=363128;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}q4c((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}function FVc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;c[a>>2]=363128;d=a+4|0;e=(c[d>>2]|0)+ -4|0;f=c[e>>2]|0;c[e>>2]=-1+f;if((f+ -1|0)>=0){g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}q4c((c[d>>2]|0)+ -12|0);g=a;h=g;zb(h|0);j=a;p4c(j);i=b;return}function GVc(a){a=a|0;i=i;return}function HVc(a,b,d){a=a|0;b=b|0;d=d|0;c[a>>2]=d;c[a+4>>2]=b;i=i;return}function IVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;Ee[c[(c[a>>2]|0)+12>>2]&15](f,a,b);if((c[f+4>>2]|0)!=(c[d+4>>2]|0)){g=0;i=e;return g|0}g=(c[f>>2]|0)==(c[d>>2]|0);i=e;return g|0}function JVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;if((c[b+4>>2]|0)!=(a|0)){f=0;i=e;return f|0}f=(c[b>>2]|0)==(d|0);i=e;return f|0}function KVc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;f=Wd(e|0)|0;e=L4c(f|0)|0;if(e>>>0>4294967279){QVc(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0;N4c(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}else{l=e+16&-16;m=n4c(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=e;g=m;N4c(g|0,f|0,e|0)|0;h=g;j=h+e|0;k=j;a[k]=0;i=d;return}}function LVc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;f=i;i=i+16|0;g=f;h=d;j=c[h>>2]|0;k=e;do{if((j|0)!=0){l=a[e]|0;if((l&1)==0){m=(l&255)>>>1}else{m=c[e+4>>2]|0}if((m|0)==0){n=j}else{vWc(e,363368,2)|0;n=c[h>>2]|0}l=c[d+4>>2]|0;Ee[c[(c[l>>2]|0)+24>>2]&15](g,l,n);l=a[g]|0;if((l&1)==0){o=g+1|0;p=(l&255)>>>1}else{o=c[g+8>>2]|0;p=c[g+4>>2]|0}vWc(e,o,p)|0;if((a[g]&1)==0){break}p4c(c[g+8>>2]|0)}}while(0);g=b;c[g+0>>2]=c[k+0>>2];c[g+4>>2]=c[k+4>>2];c[g+8>>2]=c[k+8>>2];c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;i=f;return}function MVc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+32|0;g=f;h=f+16|0;j=L4c(e|0)|0;if(j>>>0>4294967279){QVc(0)}if(j>>>0<11){a[h]=j<<1;k=h+1|0}else{l=j+16&-16;m=n4c(l)|0;c[h+8>>2]=m;c[h>>2]=l|1;c[h+4>>2]=j;k=m}N4c(k|0,e|0,j|0)|0;a[k+j|0]=0;LVc(g,d,h);zVc(b,g);if(!((a[g]&1)==0)){p4c(c[g+8>>2]|0)}if(!((a[h]&1)==0)){p4c(c[h+8>>2]|0)}c[b>>2]=363384;h=d;d=c[h+4>>2]|0;g=b+8|0;c[g>>2]=c[h>>2];c[g+4>>2]=d;i=f;return}function NVc(a){a=a|0;var b=0;b=i;CVc(a);p4c(a);i=b;return}function OVc(a){a=a|0;var b=0;b=i;CVc(a);i=b;return}function PVc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;tc(363520)|0;if((c[a>>2]|0)==1){do{nd(363544,363520)|0;}while((c[a>>2]|0)==1)}if((c[a>>2]|0)==0){c[a>>2]=1;fc(363520)|0;fe[d&1023](b);tc(363520)|0;c[a>>2]=-1;fc(363520)|0;ad(363544)|0;i=e;return}else{fc(363520)|0;i=e;return}}function QVc(a){a=a|0;a=Ec(8)|0;vVc(a,363592);c[a>>2]=363208;Td(a|0,363248,40)}function RVc(a){a=a|0;a=Ec(8)|0;vVc(a,363592);c[a>>2]=363272;Td(a|0,363312,40)}function SVc(a){a=a|0;var b=0,d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function TVc(a,b){a=a|0;b=b|0;var d=0;b=i;d=a;c[d+0>>2]=0;c[d+4>>2]=0;c[d+8>>2]=0;i=b;return}function UVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=d;if((a[d]&1)==0){g=b;c[g+0>>2]=c[f+0>>2];c[g+4>>2]=c[f+4>>2];c[g+8>>2]=c[f+8>>2];i=e;return}f=c[d+8>>2]|0;g=c[d+4>>2]|0;if(g>>>0>4294967279){QVc(0)}if(g>>>0<11){a[b]=g<<1;h=b+1|0}else{d=g+16&-16;j=n4c(d)|0;c[b+8>>2]=j;c[b>>2]=d|1;c[b+4>>2]=g;h=j}N4c(h|0,f|0,g|0)|0;a[h+g|0]=0;i=e;return}function VVc(b){b=b|0;i=i;return(a[b]&1)!=0|0}function WVc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>4294967279){QVc(0)}if(e>>>0<11){a[b]=e<<1;g=b+1|0}else{h=e+16&-16;j=n4c(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}N4c(g|0,d|0,e|0)|0;a[g+e|0]=0;i=f;return}function XVc(a){a=a|0;i=i;return a|0}function YVc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=L4c(d|0)|0;if(f>>>0>4294967279){QVc(0)}if(f>>>0<11){a[b]=f<<1;g=b+1|0;N4c(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}else{l=f+16&-16;m=n4c(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=f;g=m;N4c(g|0,d|0,f|0)|0;h=g;j=h+f|0;k=j;a[k]=0;i=e;return}}function ZVc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>4294967279){QVc(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0}else{h=d+16&-16;j=n4c(h)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}P4c(g|0,e|0,d|0)|0;a[g+d|0]=0;i=f;return}function _Vc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if(d>>>0>4294967279){QVc(0)}if(d>>>0<11){a[b]=d<<1;g=b+1|0;P4c(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}else{l=d+16&-16;m=n4c(l)|0;c[b+8>>2]=m;c[b>>2]=l|1;c[b+4>>2]=d;g=m;P4c(g|0,e|0,d|0)|0;h=g;j=h+d|0;k=j;a[k]=0;i=f;return}}function $Vc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;g=i;h=a[d]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[d+4>>2]|0}if(k>>>0<e>>>0){RVc(0)}if(j){l=d+1|0}else{l=c[d+8>>2]|0}d=l+e|0;l=k-e|0;e=l>>>0<f>>>0?l:f;if(e>>>0>4294967279){QVc(0)}if(e>>>0<11){a[b]=e<<1;m=b+1|0;N4c(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}else{f=e+16&-16;l=n4c(f)|0;c[b+8>>2]=l;c[b>>2]=f|1;c[b+4>>2]=e;m=l;N4c(m|0,d|0,e|0)|0;n=m;o=n+e|0;p=o;a[p]=0;i=g;return}}function aWc(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function bWc(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function cWc(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}p4c(c[b+8>>2]|0);i=d;return}function dWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((b|0)==(d|0)){i=e;return b|0}f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=a[b]|0;if((d&1)==0){j=d;k=10}else{d=c[b>>2]|0;j=d&255;k=(d&-2)+ -1|0}d=(j&1)==0;if(k>>>0<h>>>0){if(d){l=(j&255)>>>1}else{l=c[b+4>>2]|0}wWc(b,k,h-k|0,l,0,l,h,g);i=e;return b|0}if(d){m=b+1|0}else{m=c[b+8>>2]|0}O4c(m|0,g|0,h|0)|0;a[m+h|0]=0;if((a[b]&1)==0){a[b]=h<<1;i=e;return b|0}else{c[b+4>>2]=h;i=e;return b|0}return 0}function eWc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=fWc(a,b)|0;i=c;return d|0}function fWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;f=L4c(d|0)|0;g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}g=(h&1)==0;if(j>>>0<f>>>0){if(g){k=(h&255)>>>1}else{k=c[b+4>>2]|0}wWc(b,j,f-j|0,k,0,k,f,d);i=e;return b|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}O4c(l|0,d|0,f|0)|0;a[l+f|0]=0;if((a[b]&1)==0){a[b]=f<<1;i=e;return b|0}else{c[b+4>>2]=f;i=e;return b|0}return 0}function gWc(a,b){a=a|0;b=b|0;c[a+4>>2]=b;i=i;return}function hWc(a){a=a|0;i=i;return a+1|0}function iWc(b,c){b=b|0;c=c|0;a[b]=c<<1;i=i;return}function jWc(b){b=b|0;var d=0,e=0,f=0;d=i;e=a[b]|0;if((e&1)==0){f=(e&255)>>>1;i=d;return f|0}else{f=c[b+4>>2]|0;i=d;return f|0}return 0}function kWc(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=10;i=d;return e|0}e=(c[b>>2]&-2)+ -1|0;i=d;return e|0}function lWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if(j>>>0<d>>>0){mWc(b,d-j|0,e)|0;i=f;return}if(h){a[b+1+d|0]=0;a[b]=d<<1;i=f;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=f;return}}function mWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;if((d|0)==0){i=f;return b|0}g=a[b]|0;if((g&1)==0){h=g;j=10}else{g=c[b>>2]|0;h=g&255;j=(g&-2)+ -1|0}if((h&1)==0){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if((j-k|0)>>>0<d>>>0){xWc(b,j,d-j+k|0,k,k,0,0);l=a[b]|0}else{l=h}if((l&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}P4c(m+k|0,e|0,d|0)|0;e=k+d|0;if((a[b]&1)==0){a[b]=e<<1}else{c[b+4>>2]=e}a[m+e|0]=0;i=f;return b|0}function nWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}if(h>>>0<d>>>0){mWc(b,d-h|0,0)|0;i=e;return}if(g){a[b+1+d|0]=0;a[b]=d<<1;i=e;return}else{a[(c[b+8>>2]|0)+d|0]=0;c[b+4>>2]=d;i=e;return}}function oWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>4294967279){QVc(0)}f=a[b]|0;if((f&1)==0){g=f;h=10}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<11){k=10}else{k=(f+16&-16)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==10){l=b+1|0;m=0;n=c[b+8>>2]|0;o=1}else{f=k+1|0;if(k>>>0>h>>>0){p=n4c(f)|0}else{p=n4c(f)|0}if((g&1)==0){l=p;m=1;n=b+1|0;o=0;break}else{l=p;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}N4c(l|0,n|0,q+1|0)|0;if(o){p4c(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}function pWc(a){a=a|0;var b=0;if(a>>>0<11){b=10}else{b=(a+16&-16)+ -1|0}i=i;return b|0}function qWc(a,b){a=a|0;b=b|0;c[a>>2]=b|1;i=i;return}function rWc(a,b){a=a|0;b=b|0;c[a+8>>2]=b;i=i;return}function sWc(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){a[b+1|0]=0;a[b]=0;i=d;return}else{a[c[b+8>>2]|0]=0;c[b+4>>2]=0;i=d;return}}function tWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;f=a[d]|0;if((f&1)==0){g=d+1|0;h=(f&255)>>>1}else{g=c[d+8>>2]|0;h=c[d+4>>2]|0}d=vWc(b,g,h)|0;i=e;return d|0}function uWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)!=0;if(g){h=(c[b>>2]&-2)+ -1|0;j=c[b+4>>2]|0}else{h=10;j=(f&255)>>>1}if((j|0)==(h|0)){xWc(b,h,1,h,h,0,0);if((a[b]&1)==0){k=7}else{k=8}}else{if(g){k=8}else{k=7}}if((k|0)==7){a[b]=(j<<1)+2;l=b+1|0;m=j+1|0}else if((k|0)==8){k=c[b+8>>2]|0;g=j+1|0;c[b+4>>2]=g;l=k;m=g}a[l+j|0]=d;a[l+m|0]=0;i=e;return}function vWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=10;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}if((j&1)==0){k=(j&255)>>>1}else{k=c[b+4>>2]|0}if((h-k|0)>>>0<e>>>0){wWc(b,h,e-h+k|0,k,k,0,e,d);i=f;return b|0}if((e|0)==0){i=f;return b|0}if((j&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}N4c(l+k|0,d|0,e|0)|0;d=k+e|0;if((a[b]&1)==0){a[b]=d<<1}else{c[b+4>>2]=d}a[l+d|0]=0;i=f;return b|0}function wWc(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0;l=i;if((-18-d|0)>>>0<e>>>0){QVc(0)}if((a[b]&1)==0){m=b+1|0}else{m=c[b+8>>2]|0}do{if(d>>>0<2147483623){n=e+d|0;o=d<<1;p=n>>>0<o>>>0?o:n;if(p>>>0<11){q=11;break}q=p+16&-16}else{q=-17}}while(0);e=n4c(q)|0;if((g|0)!=0){N4c(e|0,m|0,g|0)|0}if((j|0)!=0){N4c(e+g|0,k|0,j|0)|0}k=f-h|0;if((k|0)!=(g|0)){N4c(e+(j+g)|0,m+(h+g)|0,k-g|0)|0}if((d|0)!=10){p4c(m)}c[b+8>>2]=e;c[b>>2]=q|1;q=k+j|0;c[b+4>>2]=q;a[e+q|0]=0;i=l;return}function xWc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;k=i;if((-17-d|0)>>>0<e>>>0){QVc(0)}if((a[b]&1)==0){l=b+1|0}else{l=c[b+8>>2]|0}do{if(d>>>0<2147483623){m=e+d|0;n=d<<1;o=m>>>0<n>>>0?n:m;if(o>>>0<11){p=11;break}p=o+16&-16}else{p=-17}}while(0);e=n4c(p)|0;if((g|0)!=0){N4c(e|0,l|0,g|0)|0}o=f-h|0;if((o|0)!=(g|0)){N4c(e+(j+g)|0,l+(h+g)|0,o-g|0)|0}if((d|0)==10){q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}p4c(l);q=b;r=q+8|0;s=r;c[s>>2]=e;t=p|1;u=b;v=u;c[v>>2]=t;i=k;return}function yWc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;$Vc(a,b,c,d,0);i=e;return}function zWc(b){b=b|0;var d=0,e=0;d=i;if((a[b]&1)==0){e=b+1|0;i=d;return e|0}else{e=c[b+8>>2]|0;i=d;return e|0}return 0}function AWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=L4c(d|0)|0;h=a[b]|0;j=(h&1)==0;if(j){k=(h&255)>>>1}else{k=c[b+4>>2]|0}if(k>>>0<e>>>0|(k-e|0)>>>0<g>>>0){l=-1;i=f;return l|0}if((g|0)==0){l=e;i=f;return l|0}if(j){m=b+1|0}else{m=c[b+8>>2]|0}b=m+e|0;j=m+k|0;h=d+g|0;if((j-b|0)<(g|0)){l=-1;i=f;return l|0}n=k+(1-g)|0;g=m+n|0;if((n|0)==(e|0)){l=-1;i=f;return l|0}e=a[d]|0;n=b;a:while(1){if((a[n]|0)==e<<24>>24){b=n;k=d;do{k=k+1|0;if((k|0)==(h|0)){break a}b=b+1|0;}while((a[b]|0)==(a[k]|0))}k=n+1|0;if((k|0)==(g|0)){l=-1;o=18;break}else{n=k}}if((o|0)==18){i=f;return l|0}if((n|0)==(j|0)){l=-1;i=f;return l|0}l=n-m|0;i=f;return l|0}function BWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=a[b]|0;g=(f&1)==0;if(g){h=(f&255)>>>1}else{h=c[b+4>>2]|0}f=a[d]|0;j=(f&1)==0;if(j){k=(f&255)>>>1}else{k=c[d+4>>2]|0}if(g){l=b+1|0}else{l=c[b+8>>2]|0}if(j){m=d+1|0}else{m=c[d+8>>2]|0}d=k>>>0<h>>>0;j=G4c(l,m,d?k:h)|0;if((j|0)==0){i=e;return(h>>>0<k>>>0?-1:d&1)|0}else{i=e;return j|0}return 0}function CWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=L4c(d|0)|0;g=a[b]|0;h=(g&1)==0;if(h){j=(g&255)>>>1}else{j=c[b+4>>2]|0}if((f|0)==-1){RVc(0)}if(h){k=b+1|0}else{k=c[b+8>>2]|0}b=j>>>0>f>>>0;h=G4c(k,d,b?f:j)|0;if((h|0)==0){i=e;return(j>>>0<f>>>0?-1:b&1)|0}else{i=e;return h|0}return 0}function DWc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;if(f>>>0>4294967279){QVc(0)}if(f>>>0<11){a[b]=e<<1;h=b+1|0;N4c(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}else{m=f+16&-16;f=n4c(m)|0;c[b+8>>2]=f;c[b>>2]=m|1;c[b+4>>2]=e;h=f;N4c(h|0,d|0,e|0)|0;j=h;k=j+e|0;l=k;a[l]=0;i=g;return}}function EWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(e>>>0>1073741807){QVc(0)}if(e>>>0<2){a[b]=e<<1;g=b+4|0}else{h=e+4&-4;j=n4c(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=e;g=j}K3c(g,d,e)|0;c[g+(e<<2)>>2]=0;i=f;return}function FWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;if(d>>>0>1073741807){QVc(0)}if(d>>>0<2){a[b]=d<<1;g=b+4|0}else{h=d+4&-4;j=n4c(h<<2)|0;c[b+8>>2]=j;c[b>>2]=h|1;c[b+4>>2]=d;g=j}M3c(g,e,d)|0;c[g+(d<<2)>>2]=0;i=f;return}function GWc(b){b=b|0;var d=0;d=i;if((a[b]&1)==0){i=d;return}p4c(c[b+8>>2]|0);i=d;return}function HWc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=IWc(a,b,J3c(b)|0)|0;i=c;return d|0}function IWc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;g=a[b]|0;if((g&1)==0){h=1;j=g}else{g=c[b>>2]|0;h=(g&-2)+ -1|0;j=g&255}g=(j&1)==0;if(h>>>0<e>>>0){if(g){k=(j&255)>>>1}else{k=c[b+4>>2]|0}LWc(b,h,e-h|0,k,0,k,e,d);i=f;return b|0}if(g){l=b+4|0}else{l=c[b+8>>2]|0}L3c(l,d,e)|0;c[l+(e<<2)>>2]=0;if((a[b]&1)==0){a[b]=e<<1;i=f;return b|0}else{c[b+4>>2]=e;i=f;return b|0}return 0}function JWc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;if(d>>>0>1073741807){QVc(0)}f=a[b]|0;if((f&1)==0){g=f;h=1}else{f=c[b>>2]|0;g=f&255;h=(f&-2)+ -1|0}if((g&1)==0){j=(g&255)>>>1}else{j=c[b+4>>2]|0}f=j>>>0>d>>>0?j:d;if(f>>>0<2){k=1}else{k=(f+4&-4)+ -1|0}if((k|0)==(h|0)){i=e;return}do{if((k|0)==1){l=b+4|0;m=0;n=c[b+8>>2]|0;o=1}else{f=(k<<2)+4|0;if(k>>>0>h>>>0){p=n4c(f)|0}else{p=n4c(f)|0}f=p;if((g&1)==0){l=f;m=1;n=b+4|0;o=0;break}else{l=f;m=1;n=c[b+8>>2]|0;o=1;break}}}while(0);if((g&1)==0){q=(g&255)>>>1}else{q=c[b+4>>2]|0}K3c(l,n,q+1|0)|0;if(o){p4c(n)}if(m){c[b>>2]=k+1|1;c[b+4>>2]=j;c[b+8>>2]=l;i=e;return}else{a[b]=j<<1;i=e;return}}



function xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;se[c[(b+8|0)>>2]&3](0,90,-1.0,0,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](0,100,+h[e+23848>>3]*+h[f+1512>>3]- +h[e+23872>>3]*+h[f+1504>>3],1,b);se[c[(b+8|0)>>2]&3](0,403,1.0,2,b);se[c[(b+8|0)>>2]&3](1,0,-5.237345664226305,3,b);se[c[(b+8|0)>>2]&3](1,402,1.0,4,b);se[c[(b+8|0)>>2]&3](1,403,3.023782929080176,5,b);se[c[(b+8|0)>>2]&3](2,401,1.0,6,b);se[c[(b+8|0)>>2]&3](2,402,1.0,7,b);se[c[(b+8|0)>>2]&3](3,98,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+24128>>3],8,b);se[c[(b+8|0)>>2]&3](3,400,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+24104>>3],9,b);se[c[(b+8|0)>>2]&3](3,401,1.0,10,b);se[c[(b+8|0)>>2]&3](4,91,1.0,11,b);se[c[(b+8|0)>>2]&3](4,399,1.0,12,b);se[c[(b+8|0)>>2]&3](4,400,-1.0,13,b);se[c[(b+8|0)>>2]&3](5,96,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7808>>3],14,b);se[c[(b+8|0)>>2]&3](5,398,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+7832>>3],15,b);se[c[(b+8|0)>>2]&3](5,399,1.0,16,b);se[c[(b+8|0)>>2]&3](6,96,-+h[(c[(a+416|0)>>2]|0)+5272>>3],17,b);se[c[(b+8|0)>>2]&3](6,397,-1.0,18,b);se[c[(b+8|0)>>2]&3](6,398,+h[(c[(a+416|0)>>2]|0)+5264>>3],19,b);se[c[(b+8|0)>>2]&3](7,380,1.0,20,b);se[c[(b+8|0)>>2]&3](7,396,1.0,21,b);se[c[(b+8|0)>>2]&3](7,397,1.0,22,b);se[c[(b+8|0)>>2]&3](8,78,1.0,23,b);se[c[(b+8|0)>>2]&3](8,395,1.0,24,b);se[c[(b+8|0)>>2]&3](8,396,-1.0,25,b);se[c[(b+8|0)>>2]&3](9,377,-1.0,26,b);se[c[(b+8|0)>>2]&3](9,390,-+h[(c[(a+416|0)>>2]|0)+4392>>3],27,b);se[c[(b+8|0)>>2]&3](9,394,+h[(c[(a+416|0)>>2]|0)+4400>>3],28,b);se[c[(b+8|0)>>2]&3](9,395,-1.0,29,b);se[c[(b+8|0)>>2]&3](10,17,1.0,30,b);se[c[(b+8|0)>>2]&3](10,393,-1.0,31,b);se[c[(b+8|0)>>2]&3](10,394,1.0,32,b);se[c[(b+8|0)>>2]&3](11,374,-.4999999999999999,33,b);se[c[(b+8|0)>>2]&3](11,392,.8660254037844387,34,b);se[c[(b+8|0)>>2]&3](11,393,1.0,35,b);se[c[(b+8|0)>>2]&3](12,374,.8660254037844387,36,b);se[c[(b+8|0)>>2]&3](12,391,1.0,37,b);se[c[(b+8|0)>>2]&3](12,392,.4999999999999999,38,b);se[c[(b+8|0)>>2]&3](13,19,1.0,39,b);se[c[(b+8|0)>>2]&3](13,390,1.0,40,b);se[c[(b+8|0)>>2]&3](13,391,-1.0,41,b);se[c[(b+8|0)>>2]&3](14,12,1.0,42,b);se[c[(b+8|0)>>2]&3](14,389,-1.0,43,b);se[c[(b+8|0)>>2]&3](14,390,-1.0,44,b);se[c[(b+8|0)>>2]&3](15,388,1.0,45,b);se[c[(b+8|0)>>2]&3](15,389,1.0,46,b);se[c[(b+8|0)>>2]&3](15,398,1.0,47,b);se[c[(b+8|0)>>2]&3](16,10,1.0,48,b);se[c[(b+8|0)>>2]&3](16,387,1.0,49,b);se[c[(b+8|0)>>2]&3](16,388,-1.0,50,b);se[c[(b+8|0)>>2]&3](17,5,1.0,51,b);se[c[(b+8|0)>>2]&3](17,386,-1.0,52,b);se[c[(b+8|0)>>2]&3](17,387,-1.0,53,b);se[c[(b+8|0)>>2]&3](18,93,.8660254037844387,54,b);se[c[(b+8|0)>>2]&3](18,385,-1.0,55,b);se[c[(b+8|0)>>2]&3](18,386,.4999999999999999,56,b);se[c[(b+8|0)>>2]&3](19,2,1.0,57,b);se[c[(b+8|0)>>2]&3](19,379,+h[(c[(a+416|0)>>2]|0)+5744>>3],58,b);se[c[(b+8|0)>>2]&3](19,384,1.0,59,b);se[c[(b+8|0)>>2]&3](19,385,-+h[(c[(a+416|0)>>2]|0)+5752>>3],60,b);se[c[(b+8|0)>>2]&3](20,77,1.0,61,b);se[c[(b+8|0)>>2]&3](20,383,1.0,62,b);se[c[(b+8|0)>>2]&3](20,384,-1.0,63,b);se[c[(b+8|0)>>2]&3](21,94,+h[(c[(a+416|0)>>2]|0)+5176>>3],64,b);se[c[(b+8|0)>>2]&3](21,382,-1.0,65,b);se[c[(b+8|0)>>2]&3](21,383,-1.0,66,b);se[c[(b+8|0)>>2]&3](21,387,-+h[(c[(a+416|0)>>2]|0)+5168>>3],67,b);se[c[(b+8|0)>>2]&3](22,11,1.0,68,b);se[c[(b+8|0)>>2]&3](22,381,1.0,69,b);se[c[(b+8|0)>>2]&3](22,382,1.0,70,b);se[c[(b+8|0)>>2]&3](23,95,+h[(c[(a+416|0)>>2]|0)+3208>>3],71,b);se[c[(b+8|0)>>2]&3](23,380,-1.0,72,b);se[c[(b+8|0)>>2]&3](23,381,-1.0,73,b);se[c[(b+8|0)>>2]&3](23,388,-+h[(c[(a+416|0)>>2]|0)+3200>>3],74,b);se[c[(b+8|0)>>2]&3](24,93,-.4999999999999999,75,b);se[c[(b+8|0)>>2]&3](24,379,-1.0,76,b);se[c[(b+8|0)>>2]&3](24,386,.8660254037844387,77,b);se[c[(b+8|0)>>2]&3](25,376,-1.0,78,b);se[c[(b+8|0)>>2]&3](25,378,-1.0,79,b);se[c[(b+8|0)>>2]&3](25,391,-+h[(c[(a+416|0)>>2]|0)+2400>>3],80,b);se[c[(b+8|0)>>2]&3](25,393,+h[(c[(a+416|0)>>2]|0)+2408>>3],81,b);se[c[(b+8|0)>>2]&3](26,20,1.0,82,b);se[c[(b+8|0)>>2]&3](26,377,1.0,83,b);se[c[(b+8|0)>>2]&3](26,378,1.0,84,b);se[c[(b+8|0)>>2]&3](27,373,1.0,85,b);se[c[(b+8|0)>>2]&3](27,376,1.0,86,b);se[c[(b+8|0)>>2]&3](27,391,-+h[(c[(a+416|0)>>2]|0)+6128>>3],87,b);se[c[(b+8|0)>>2]&3](27,393,+h[(c[(a+416|0)>>2]|0)+6136>>3],88,b);se[c[(b+8|0)>>2]&3](28,299,6.123233995736766e-17,89,b);se[c[(b+8|0)>>2]&3](28,375,-1.0,90,b);se[c[(b+8|0)>>2]&3](28,392,-1.0,91,b);se[c[(b+8|0)>>2]&3](29,299,1.0,92,b);se[c[(b+8|0)>>2]&3](29,374,-1.0,93,b);se[c[(b+8|0)>>2]&3](29,375,6.123233995736766e-17,94,b);se[c[(b+8|0)>>2]&3](30,309,1.0,95,b);se[c[(b+8|0)>>2]&3](30,373,-1.0,96,b);se[c[(b+8|0)>>2]&3](30,374,+h[(c[(a+416|0)>>2]|0)+12152>>3],97,b);se[c[(b+8|0)>>2]&3](30,392,-+h[(c[(a+416|0)>>2]|0)+12160>>3],98,b);se[c[(b+8|0)>>2]&3](31,72,1.0,99,b);se[c[(b+8|0)>>2]&3](31,372,-1.0,100,b);se[c[(b+8|0)>>2]&3](31,375,-1.0,101,b);se[c[(b+8|0)>>2]&3](32,22,1.0,102,b);se[c[(b+8|0)>>2]&3](32,371,-1.0,103,b);se[c[(b+8|0)>>2]&3](32,372,1.0,104,b);se[c[(b+8|0)>>2]&3](33,316,1.0,105,b);se[c[(b+8|0)>>2]&3](33,370,1.0,106,b);se[c[(b+8|0)>>2]&3](33,371,1.0,107,b);se[c[(b+8|0)>>2]&3](34,29,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+9528>>3],108,b);se[c[(b+8|0)>>2]&3](34,369,1.0,109,b);se[c[(b+8|0)>>2]&3](34,370,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+9552>>3],110,b);se[c[(b+8|0)>>2]&3](35,31,-1.0,111,b);se[c[(b+8|0)>>2]&3](35,368,1.0,112,b);se[c[(b+8|0)>>2]&3](35,369,1.0,113,b);se[c[(b+8|0)>>2]&3](36,37,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23704>>3]*-2.0328,114,b);se[c[(b+8|0)>>2]&3](36,367,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+23696>>3]*-2.0328,115,b);se[c[(b+8|0)>>2]&3](36,368,1.0,116,b);se[c[(b+8|0)>>2]&3](37,37,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3],117,b);se[c[(b+8|0)>>2]&3](37,38,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3],118,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(b+8|0)>>2]&3](37,87,-(+h[f+13720>>3]*(+h[f+2840>>3]- +h[f+13496>>3]))- +h[f+13728>>3]*(+h[f+2832>>3]- +h[f+13488>>3]),119,b);se[c[(b+8|0)>>2]&3](37,366,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3],120,b);se[c[(b+8|0)>>2]&3](37,367,-+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3],121,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](38,87,+h[f+13744>>3]*+h[e+11680>>3]- +h[f+13728>>3]*+h[e+11672>>3],122,b);se[c[(b+8|0)>>2]&3](38,365,-1.0,123,b);se[c[(b+8|0)>>2]&3](38,366,1.0,124,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](39,87,+h[e+13744>>3]*+h[f+10808>>3]- +h[e+13728>>3]*+h[f+10800>>3],125,b);se[c[(b+8|0)>>2]&3](39,364,1.0,126,b);se[c[(b+8|0)>>2]&3](39,365,-1.0,127,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](40,87,+h[f+13744>>3]*+h[e+8816>>3]- +h[f+13728>>3]*+h[e+8808>>3],128,b);se[c[(b+8|0)>>2]&3](40,363,1.0,129,b);se[c[(b+8|0)>>2]&3](40,364,-1.0,130,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](41,87,+h[e+13744>>3]*+h[f+12544>>3]- +h[e+13728>>3]*+h[f+12536>>3],131,b);se[c[(b+8|0)>>2]&3](41,362,1.0,132,b);se[c[(b+8|0)>>2]&3](41,363,-1.0,133,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](42,87,+h[f+13304>>3]*+h[e+18568>>3]- +h[f+13288>>3]*+h[e+18560>>3],134,b);se[c[(b+8|0)>>2]&3](42,361,1.0,135,b);se[c[(b+8|0)>>2]&3](42,362,-1.0,136,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](43,87,+h[e+13096>>3]*+h[f+17992>>3]- +h[e+13080>>3]*+h[f+17984>>3],137,b);se[c[(b+8|0)>>2]&3](43,360,1.0,138,b);se[c[(b+8|0)>>2]&3](43,361,-1.0,139,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](44,87,+h[f+13096>>3]*+h[e+16024>>3]- +h[f+13080>>3]*+h[e+16016>>3],140,b);se[c[(b+8|0)>>2]&3](44,359,1.0,141,b);se[c[(b+8|0)>>2]&3](44,360,-1.0,142,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](45,87,+h[e+13096>>3]*+h[f+17216>>3]- +h[e+13080>>3]*+h[f+17208>>3],143,b);se[c[(b+8|0)>>2]&3](45,358,1.0,144,b);se[c[(b+8|0)>>2]&3](45,359,-1.0,145,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](46,87,+h[f+13096>>3]*+h[e+15224>>3]- +h[f+13080>>3]*+h[e+15216>>3],146,b);se[c[(b+8|0)>>2]&3](46,357,1.0,147,b);se[c[(b+8|0)>>2]&3](46,358,-1.0,148,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](47,87,+h[e+13096>>3]*+h[f+18952>>3]- +h[e+13080>>3]*+h[f+18944>>3],149,b);se[c[(b+8|0)>>2]&3](47,356,1.0,150,b);se[c[(b+8|0)>>2]&3](47,357,-1.0,151,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](48,87,+h[f+12656>>3]*+h[e+24976>>3]- +h[f+12640>>3]*+h[e+24968>>3],152,b);se[c[(b+8|0)>>2]&3](48,355,1.0,153,b);se[c[(b+8|0)>>2]&3](48,356,-1.0,154,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](49,87,+h[e+12448>>3]*+h[f+24400>>3]- +h[e+12432>>3]*+h[f+24392>>3],155,b);se[c[(b+8|0)>>2]&3](49,354,1.0,156,b);se[c[(b+8|0)>>2]&3](49,355,-1.0,157,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](50,87,+h[f+12448>>3]*+h[e+22432>>3]- +h[f+12432>>3]*+h[e+22424>>3],158,b);se[c[(b+8|0)>>2]&3](50,353,1.0,159,b);se[c[(b+8|0)>>2]&3](50,354,-1.0,160,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](51,87,+h[e+12448>>3]*+h[f+23624>>3]- +h[e+12432>>3]*+h[f+23616>>3],161,b);se[c[(b+8|0)>>2]&3](51,352,1.0,162,b);se[c[(b+8|0)>>2]&3](51,353,-1.0,163,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](52,87,+h[f+12448>>3]*+h[e+21632>>3]- +h[f+12432>>3]*+h[e+21624>>3],164,b);se[c[(b+8|0)>>2]&3](52,351,1.0,165,b);se[c[(b+8|0)>>2]&3](52,352,-1.0,166,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](53,87,+h[e+12448>>3]*+h[f+25360>>3]- +h[e+12432>>3]*+h[f+25352>>3],167,b);se[c[(b+8|0)>>2]&3](53,350,1.0,168,b);se[c[(b+8|0)>>2]&3](53,351,-1.0,169,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](54,87,+h[f+12008>>3]*+h[e+31384>>3]- +h[f+11992>>3]*+h[e+31376>>3],170,b);se[c[(b+8|0)>>2]&3](54,349,1.0,171,b);se[c[(b+8|0)>>2]&3](54,350,-1.0,172,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](55,87,+h[e+11800>>3]*+h[f+30808>>3]- +h[e+11784>>3]*+h[f+30800>>3],173,b);se[c[(b+8|0)>>2]&3](55,348,1.0,174,b);se[c[(b+8|0)>>2]&3](55,349,-1.0,175,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](56,87,+h[f+11800>>3]*+h[e+28840>>3]- +h[f+11784>>3]*+h[e+28832>>3],176,b);se[c[(b+8|0)>>2]&3](56,347,1.0,177,b);se[c[(b+8|0)>>2]&3](56,348,-1.0,178,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](57,87,+h[e+11800>>3]*+h[f+30032>>3]- +h[e+11784>>3]*+h[f+30024>>3],179,b);se[c[(b+8|0)>>2]&3](57,346,1.0,180,b);se[c[(b+8|0)>>2]&3](57,347,-1.0,181,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](58,87,+h[f+11800>>3]*+h[e+28040>>3]- +h[f+11784>>3]*+h[e+28032>>3],182,b);se[c[(b+8|0)>>2]&3](58,345,1.0,183,b);se[c[(b+8|0)>>2]&3](58,346,-1.0,184,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](59,87,+h[e+11800>>3]*+h[f+31768>>3]- +h[e+11784>>3]*+h[f+31760>>3],185,b);se[c[(b+8|0)>>2]&3](59,344,1.0,186,b);se[c[(b+8|0)>>2]&3](59,345,-1.0,187,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](60,87,+h[f+23960>>3]*+h[e+37792>>3]- +h[f+23984>>3]*+h[e+37784>>3],188,b);se[c[(b+8|0)>>2]&3](60,343,1.0,189,b);se[c[(b+8|0)>>2]&3](60,344,-1.0,190,b);se[c[(b+8|0)>>2]&3](61,46,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-1.814269757448105,191,b);se[c[(b+8|0)>>2]&3](61,342,1.0,192,b);se[c[(b+8|0)>>2]&3](61,343,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-1.814269757448105,193,b);se[c[(b+8|0)>>2]&3](62,231,-1.0,194,b);se[c[(b+8|0)>>2]&3](62,341,-1.0,195,b);se[c[(b+8|0)>>2]&3](62,342,1.0,196,b);se[c[(b+8|0)>>2]&3](63,242,.4999999999999999,197,b);se[c[(b+8|0)>>2]&3](63,340,-1.0,198,b);se[c[(b+8|0)>>2]&3](63,341,.8660254037844387,199,b);se[c[(b+8|0)>>2]&3](64,244,1.0,200,b);se[c[(b+8|0)>>2]&3](64,339,1.0,201,b);se[c[(b+8|0)>>2]&3](64,340,6.123233995736766e-17,202,b);se[c[(b+8|0)>>2]&3](65,198,1.0,203,b);se[c[(b+8|0)>>2]&3](65,338,1.0,204,b);se[c[(b+8|0)>>2]&3](65,339,-1.0,205,b);se[c[(b+8|0)>>2]&3](66,176,1.0,206,b);se[c[(b+8|0)>>2]&3](66,337,-1.0,207,b);se[c[(b+8|0)>>2]&3](66,338,-1.0,208,b);se[c[(b+8|0)>>2]&3](67,186,1.0,209,b);se[c[(b+8|0)>>2]&3](67,336,1.0,210,b);se[c[(b+8|0)>>2]&3](67,337,1.0,211,b);se[c[(b+8|0)>>2]&3](68,174,1.0,212,b);se[c[(b+8|0)>>2]&3](68,335,1.0,213,b);se[c[(b+8|0)>>2]&3](68,336,-1.0,214,b);se[c[(b+8|0)>>2]&3](69,171,1.0,215,b);se[c[(b+8|0)>>2]&3](69,334,-1.0,216,b);se[c[(b+8|0)>>2]&3](69,335,-1.0,217,b);se[c[(b+8|0)>>2]&3](70,246,-1.0,218,b);se[c[(b+8|0)>>2]&3](70,333,-1.0,219,b);se[c[(b+8|0)>>2]&3](70,334,6.123233995736766e-17,220,b);se[c[(b+8|0)>>2]&3](71,262,-.8660254037844386,221,b);se[c[(b+8|0)>>2]&3](71,332,1.0,222,b);se[c[(b+8|0)>>2]&3](71,333,.5000000000000001,223,b);se[c[(b+8|0)>>2]&3](72,168,1.0,224,b);se[c[(b+8|0)>>2]&3](72,331,1.0,225,b);se[c[(b+8|0)>>2]&3](72,332,-1.0,226,b);se[c[(b+8|0)>>2]&3](73,146,1.0,227,b);se[c[(b+8|0)>>2]&3](73,330,-1.0,228,b);se[c[(b+8|0)>>2]&3](73,331,-1.0,229,b);se[c[(b+8|0)>>2]&3](74,156,1.0,230,b);se[c[(b+8|0)>>2]&3](74,329,1.0,231,b);se[c[(b+8|0)>>2]&3](74,330,1.0,232,b);se[c[(b+8|0)>>2]&3](75,144,1.0,233,b);se[c[(b+8|0)>>2]&3](75,328,1.0,234,b);se[c[(b+8|0)>>2]&3](75,329,-1.0,235,b);se[c[(b+8|0)>>2]&3](76,141,1.0,236,b);se[c[(b+8|0)>>2]&3](76,327,-1.0,237,b);se[c[(b+8|0)>>2]&3](76,328,-1.0,238,b);se[c[(b+8|0)>>2]&3](77,263,-.5000000000000001,239,b);se[c[(b+8|0)>>2]&3](77,326,-1.0,240,b);se[c[(b+8|0)>>2]&3](77,327,-.8660254037844386,241,b);se[c[(b+8|0)>>2]&3](78,280,.5000000000000001,242,b);se[c[(b+8|0)>>2]&3](78,325,1.0,243,b);se[c[(b+8|0)>>2]&3](78,326,-.8660254037844386,244,b);se[c[(b+8|0)>>2]&3](79,139,1.0,245,b);se[c[(b+8|0)>>2]&3](79,324,1.0,246,b);se[c[(b+8|0)>>2]&3](79,325,-1.0,247,b);se[c[(b+8|0)>>2]&3](80,117,1.0,248,b);se[c[(b+8|0)>>2]&3](80,323,-1.0,249,b);se[c[(b+8|0)>>2]&3](80,324,-1.0,250,b);se[c[(b+8|0)>>2]&3](81,129,1.0,251,b);se[c[(b+8|0)>>2]&3](81,322,1.0,252,b);se[c[(b+8|0)>>2]&3](81,323,1.0,253,b);se[c[(b+8|0)>>2]&3](82,115,1.0,254,b);se[c[(b+8|0)>>2]&3](82,321,1.0,255,b);se[c[(b+8|0)>>2]&3](82,322,-1.0,256,b);se[c[(b+8|0)>>2]&3](83,112,1.0,257,b);se[c[(b+8|0)>>2]&3](83,320,-1.0,258,b);se[c[(b+8|0)>>2]&3](83,321,-1.0,259,b);se[c[(b+8|0)>>2]&3](84,281,-.5000000000000001,260,b);se[c[(b+8|0)>>2]&3](84,319,-1.0,261,b);se[c[(b+8|0)>>2]&3](84,320,-.8660254037844386,262,b);se[c[(b+8|0)>>2]&3](85,298,-1.0,263,b);se[c[(b+8|0)>>2]&3](85,318,1.0,264,b);se[c[(b+8|0)>>2]&3](85,319,6.123233995736766e-17,265,b);se[c[(b+8|0)>>2]&3](86,110,1.0,266,b);se[c[(b+8|0)>>2]&3](86,317,1.0,267,b);se[c[(b+8|0)>>2]&3](86,318,-1.0,268,b);se[c[(b+8|0)>>2]&3](87,68,1.0,269,b);se[c[(b+8|0)>>2]&3](87,316,-1.0,270,b);se[c[(b+8|0)>>2]&3](87,317,-1.0,271,b);se[c[(b+8|0)>>2]&3](88,303,+h[(c[(a+416|0)>>2]|0)+10808>>3],272,b);se[c[(b+8|0)>>2]&3](88,307,-1.0,273,b);se[c[(b+8|0)>>2]&3](88,315,-1.0,274,b);se[c[(b+8|0)>>2]&3](88,317,-+h[(c[(a+416|0)>>2]|0)+10800>>3],275,b);se[c[(b+8|0)>>2]&3](89,80,1.0,276,b);se[c[(b+8|0)>>2]&3](89,314,-1.0,277,b);se[c[(b+8|0)>>2]&3](89,315,1.0,278,b);se[c[(b+8|0)>>2]&3](90,28,1.0,279,b);se[c[(b+8|0)>>2]&3](90,313,1.0,280,b);se[c[(b+8|0)>>2]&3](90,314,1.0,281,b);se[c[(b+8|0)>>2]&3](91,301,+h[(c[(a+416|0)>>2]|0)+9616>>3],282,b);se[c[(b+8|0)>>2]&3](91,312,-1.0,283,b);se[c[(b+8|0)>>2]&3](91,313,-1.0,284,b);se[c[(b+8|0)>>2]&3](91,371,-+h[(c[(a+416|0)>>2]|0)+9608>>3],285,b);se[c[(b+8|0)>>2]&3](92,21,1.0,286,b);se[c[(b+8|0)>>2]&3](92,311,1.0,287,b);se[c[(b+8|0)>>2]&3](92,312,1.0,288,b);se[c[(b+8|0)>>2]&3](93,300,+h[(c[(a+416|0)>>2]|0)+11584>>3],289,b);se[c[(b+8|0)>>2]&3](93,310,-1.0,290,b);se[c[(b+8|0)>>2]&3](93,311,-1.0,291,b);se[c[(b+8|0)>>2]&3](93,372,-+h[(c[(a+416|0)>>2]|0)+11576>>3],292,b);se[c[(b+8|0)>>2]&3](94,79,1.0,293,b);se[c[(b+8|0)>>2]&3](94,309,-1.0,294,b);se[c[(b+8|0)>>2]&3](94,310,1.0,295,b);se[c[(b+8|0)>>2]&3](95,304,+h[(c[(a+416|0)>>2]|0)+8816>>3],296,b);se[c[(b+8|0)>>2]&3](95,306,-1.0,297,b);se[c[(b+8|0)>>2]&3](95,308,-1.0,298,b);se[c[(b+8|0)>>2]&3](95,318,-+h[(c[(a+416|0)>>2]|0)+8808>>3],299,b);se[c[(b+8|0)>>2]&3](96,109,1.0,300,b);se[c[(b+8|0)>>2]&3](96,307,1.0,301,b);se[c[(b+8|0)>>2]&3](96,308,1.0,302,b);se[c[(b+8|0)>>2]&3](97,304,+h[(c[(a+416|0)>>2]|0)+12544>>3],303,b);se[c[(b+8|0)>>2]&3](97,305,1.0,304,b);se[c[(b+8|0)>>2]&3](97,306,1.0,305,b);se[c[(b+8|0)>>2]&3](97,318,-+h[(c[(a+416|0)>>2]|0)+12536>>3],306,b);se[c[(b+8|0)>>2]&3](98,296,1.0,307,b);se[c[(b+8|0)>>2]&3](98,298,-+h[(c[(a+416|0)>>2]|0)+18568>>3],308,b);se[c[(b+8|0)>>2]&3](98,305,-1.0,309,b);se[c[(b+8|0)>>2]&3](98,319,+h[(c[(a+416|0)>>2]|0)+18560>>3],310,b);se[c[(b+8|0)>>2]&3](99,298,6.123233995736766e-17,311,b);se[c[(b+8|0)>>2]&3](99,304,1.0,312,b);se[c[(b+8|0)>>2]&3](99,319,1.0,313,b);se[c[(b+8|0)>>2]&3](100,111,1.0,314,b);se[c[(b+8|0)>>2]&3](100,303,1.0,315,b);se[c[(b+8|0)>>2]&3](100,304,-1.0,316,b);se[c[(b+8|0)>>2]&3](101,69,1.0,317,b);se[c[(b+8|0)>>2]&3](101,302,-1.0,318,b);se[c[(b+8|0)>>2]&3](101,303,-1.0,319,b);se[c[(b+8|0)>>2]&3](102,29,1.0,320,b);se[c[(b+8|0)>>2]&3](102,301,1.0,321,b);se[c[(b+8|0)>>2]&3](102,302,1.0,322,b);se[c[(b+8|0)>>2]&3](103,23,1.0,323,b);se[c[(b+8|0)>>2]&3](103,300,1.0,324,b);se[c[(b+8|0)>>2]&3](103,301,-1.0,325,b);se[c[(b+8|0)>>2]&3](104,73,1.0,326,b);se[c[(b+8|0)>>2]&3](104,299,-1.0,327,b);se[c[(b+8|0)>>2]&3](104,300,-1.0,328,b);se[c[(b+8|0)>>2]&3](105,281,-.8660254037844386,329,b);se[c[(b+8|0)>>2]&3](105,298,-1.0,330,b);se[c[(b+8|0)>>2]&3](105,320,.5000000000000001,331,b);se[c[(b+8|0)>>2]&3](106,282,+h[(c[(a+416|0)>>2]|0)+17992>>3],332,b);se[c[(b+8|0)>>2]&3](106,294,-1.0,333,b);se[c[(b+8|0)>>2]&3](106,297,-1.0,334,b);se[c[(b+8|0)>>2]&3](106,321,-+h[(c[(a+416|0)>>2]|0)+17984>>3],335,b);se[c[(b+8|0)>>2]&3](107,81,1.0,336,b);se[c[(b+8|0)>>2]&3](107,296,-1.0,337,b);se[c[(b+8|0)>>2]&3](107,297,1.0,338,b);se[c[(b+8|0)>>2]&3](108,283,+h[(c[(a+416|0)>>2]|0)+16024>>3],339,b);se[c[(b+8|0)>>2]&3](108,291,-1.0,340,b);se[c[(b+8|0)>>2]&3](108,295,-1.0,341,b);se[c[(b+8|0)>>2]&3](108,322,-+h[(c[(a+416|0)>>2]|0)+16016>>3],342,b);se[c[(b+8|0)>>2]&3](109,114,1.0,343,b);se[c[(b+8|0)>>2]&3](109,294,1.0,344,b);se[c[(b+8|0)>>2]&3](109,295,1.0,345,b);se[c[(b+8|0)>>2]&3](110,285,+h[(c[(a+416|0)>>2]|0)+17216>>3],346,b);se[c[(b+8|0)>>2]&3](110,289,-1.0,347,b);se[c[(b+8|0)>>2]&3](110,293,-1.0,348,b);se[c[(b+8|0)>>2]&3](110,324,-+h[(c[(a+416|0)>>2]|0)+17208>>3],349,b);se[c[(b+8|0)>>2]&3](111,82,1.0,350,b);se[c[(b+8|0)>>2]&3](111,292,-1.0,351,b);se[c[(b+8|0)>>2]&3](111,293,1.0,352,b);se[c[(b+8|0)>>2]&3](112,128,1.0,353,b);se[c[(b+8|0)>>2]&3](112,291,1.0,354,b);se[c[(b+8|0)>>2]&3](112,292,1.0,355,b);se[c[(b+8|0)>>2]&3](113,286,+h[(c[(a+416|0)>>2]|0)+15224>>3],356,b);se[c[(b+8|0)>>2]&3](113,288,-1.0,357,b);se[c[(b+8|0)>>2]&3](113,290,-1.0,358,b);se[c[(b+8|0)>>2]&3](113,325,-+h[(c[(a+416|0)>>2]|0)+15216>>3],359,b);se[c[(b+8|0)>>2]&3](114,138,1.0,360,b);se[c[(b+8|0)>>2]&3](114,289,1.0,361,b);se[c[(b+8|0)>>2]&3](114,290,1.0,362,b);se[c[(b+8|0)>>2]&3](115,286,+h[(c[(a+416|0)>>2]|0)+18952>>3],363,b);se[c[(b+8|0)>>2]&3](115,287,1.0,364,b);se[c[(b+8|0)>>2]&3](115,288,1.0,365,b);se[c[(b+8|0)>>2]&3](115,325,-+h[(c[(a+416|0)>>2]|0)+18944>>3],366,b);se[c[(b+8|0)>>2]&3](116,278,1.0,367,b);se[c[(b+8|0)>>2]&3](116,280,-+h[(c[(a+416|0)>>2]|0)+24976>>3],368,b);se[c[(b+8|0)>>2]&3](116,287,-1.0,369,b);se[c[(b+8|0)>>2]&3](116,326,+h[(c[(a+416|0)>>2]|0)+24968>>3],370,b);se[c[(b+8|0)>>2]&3](117,280,-.8660254037844386,371,b);se[c[(b+8|0)>>2]&3](117,286,1.0,372,b);se[c[(b+8|0)>>2]&3](117,326,-.5000000000000001,373,b);se[c[(b+8|0)>>2]&3](118,140,1.0,374,b);se[c[(b+8|0)>>2]&3](118,285,1.0,375,b);se[c[(b+8|0)>>2]&3](118,286,-1.0,376,b);se[c[(b+8|0)>>2]&3](119,118,1.0,377,b);se[c[(b+8|0)>>2]&3](119,284,-1.0,378,b);se[c[(b+8|0)>>2]&3](119,285,-1.0,379,b);se[c[(b+8|0)>>2]&3](120,127,1.0,380,b);se[c[(b+8|0)>>2]&3](120,283,1.0,381,b);se[c[(b+8|0)>>2]&3](120,284,1.0,382,b);se[c[(b+8|0)>>2]&3](121,116,1.0,383,b);se[c[(b+8|0)>>2]&3](121,282,1.0,384,b);se[c[(b+8|0)>>2]&3](121,283,-1.0,385,b);se[c[(b+8|0)>>2]&3](122,113,1.0,386,b);se[c[(b+8|0)>>2]&3](122,281,-1.0,387,b);se[c[(b+8|0)>>2]&3](122,282,-1.0,388,b);se[c[(b+8|0)>>2]&3](123,263,-.8660254037844386,389,b);se[c[(b+8|0)>>2]&3](123,280,-1.0,390,b);se[c[(b+8|0)>>2]&3](123,327,.5000000000000001,391,b);se[c[(b+8|0)>>2]&3](124,264,+h[(c[(a+416|0)>>2]|0)+24400>>3],392,b);se[c[(b+8|0)>>2]&3](124,276,-1.0,393,b);se[c[(b+8|0)>>2]&3](124,279,-1.0,394,b);se[c[(b+8|0)>>2]&3](124,328,-+h[(c[(a+416|0)>>2]|0)+24392>>3],395,b);se[c[(b+8|0)>>2]&3](125,83,1.0,396,b);se[c[(b+8|0)>>2]&3](125,278,-1.0,397,b);se[c[(b+8|0)>>2]&3](125,279,1.0,398,b);se[c[(b+8|0)>>2]&3](126,265,+h[(c[(a+416|0)>>2]|0)+22432>>3],399,b);se[c[(b+8|0)>>2]&3](126,273,-1.0,400,b);se[c[(b+8|0)>>2]&3](126,277,-1.0,401,b);se[c[(b+8|0)>>2]&3](126,329,-+h[(c[(a+416|0)>>2]|0)+22424>>3],402,b);se[c[(b+8|0)>>2]&3](127,143,1.0,403,b);se[c[(b+8|0)>>2]&3](127,276,1.0,404,b);se[c[(b+8|0)>>2]&3](127,277,1.0,405,b);se[c[(b+8|0)>>2]&3](128,267,+h[(c[(a+416|0)>>2]|0)+23624>>3],406,b);se[c[(b+8|0)>>2]&3](128,271,-1.0,407,b);se[c[(b+8|0)>>2]&3](128,275,-1.0,408,b);se[c[(b+8|0)>>2]&3](128,331,-+h[(c[(a+416|0)>>2]|0)+23616>>3],409,b);se[c[(b+8|0)>>2]&3](129,84,1.0,410,b);se[c[(b+8|0)>>2]&3](129,274,-1.0,411,b);se[c[(b+8|0)>>2]&3](129,275,1.0,412,b);se[c[(b+8|0)>>2]&3](130,157,1.0,413,b);se[c[(b+8|0)>>2]&3](130,273,1.0,414,b);se[c[(b+8|0)>>2]&3](130,274,1.0,415,b);se[c[(b+8|0)>>2]&3](131,268,+h[(c[(a+416|0)>>2]|0)+21632>>3],416,b);se[c[(b+8|0)>>2]&3](131,270,-1.0,417,b);se[c[(b+8|0)>>2]&3](131,272,-1.0,418,b);se[c[(b+8|0)>>2]&3](131,332,-+h[(c[(a+416|0)>>2]|0)+21624>>3],419,b);se[c[(b+8|0)>>2]&3](132,167,1.0,420,b);se[c[(b+8|0)>>2]&3](132,271,1.0,421,b);se[c[(b+8|0)>>2]&3](132,272,1.0,422,b);se[c[(b+8|0)>>2]&3](133,268,+h[(c[(a+416|0)>>2]|0)+25360>>3],423,b);se[c[(b+8|0)>>2]&3](133,269,1.0,424,b);se[c[(b+8|0)>>2]&3](133,270,1.0,425,b);se[c[(b+8|0)>>2]&3](133,332,-+h[(c[(a+416|0)>>2]|0)+25352>>3],426,b);se[c[(b+8|0)>>2]&3](134,260,1.0,427,b);se[c[(b+8|0)>>2]&3](134,262,+h[(c[(a+416|0)>>2]|0)+31376>>3],428,b);se[c[(b+8|0)>>2]&3](134,269,-1.0,429,b);se[c[(b+8|0)>>2]&3](134,333,-+h[(c[(a+416|0)>>2]|0)+31384>>3],430,b);se[c[(b+8|0)>>2]&3](135,262,-.5000000000000001,431,b);se[c[(b+8|0)>>2]&3](135,268,1.0,432,b);se[c[(b+8|0)>>2]&3](135,333,-.8660254037844386,433,b);se[c[(b+8|0)>>2]&3](136,169,1.0,434,b);se[c[(b+8|0)>>2]&3](136,267,1.0,435,b);se[c[(b+8|0)>>2]&3](136,268,-1.0,436,b);se[c[(b+8|0)>>2]&3](137,147,1.0,437,b);se[c[(b+8|0)>>2]&3](137,266,-1.0,438,b);se[c[(b+8|0)>>2]&3](137,267,-1.0,439,b);se[c[(b+8|0)>>2]&3](138,158,1.0,440,b);se[c[(b+8|0)>>2]&3](138,265,1.0,441,b);se[c[(b+8|0)>>2]&3](138,266,1.0,442,b);se[c[(b+8|0)>>2]&3](139,145,1.0,443,b);se[c[(b+8|0)>>2]&3](139,264,1.0,444,b);se[c[(b+8|0)>>2]&3](139,265,-1.0,445,b);se[c[(b+8|0)>>2]&3](140,142,1.0,446,b);se[c[(b+8|0)>>2]&3](140,263,-1.0,447,b);se[c[(b+8|0)>>2]&3](140,264,-1.0,448,b);se[c[(b+8|0)>>2]&3](141,246,6.123233995736766e-17,449,b);se[c[(b+8|0)>>2]&3](141,262,-1.0,450,b);se[c[(b+8|0)>>2]&3](141,334,1.0,451,b);se[c[(b+8|0)>>2]&3](142,247,-+h[(c[(a+416|0)>>2]|0)+30800>>3],452,b);se[c[(b+8|0)>>2]&3](142,258,-1.0,453,b);se[c[(b+8|0)>>2]&3](142,261,-1.0,454,b);se[c[(b+8|0)>>2]&3](142,335,+h[(c[(a+416|0)>>2]|0)+30808>>3],455,b);se[c[(b+8|0)>>2]&3](143,85,1.0,456,b);se[c[(b+8|0)>>2]&3](143,260,-1.0,457,b);se[c[(b+8|0)>>2]&3](143,261,1.0,458,b);se[c[(b+8|0)>>2]&3](144,248,-+h[(c[(a+416|0)>>2]|0)+28832>>3],459,b);se[c[(b+8|0)>>2]&3](144,255,-1.0,460,b);se[c[(b+8|0)>>2]&3](144,259,-1.0,461,b);se[c[(b+8|0)>>2]&3](144,336,+h[(c[(a+416|0)>>2]|0)+28840>>3],462,b);se[c[(b+8|0)>>2]&3](145,172,1.0,463,b);se[c[(b+8|0)>>2]&3](145,258,1.0,464,b);se[c[(b+8|0)>>2]&3](145,259,1.0,465,b);se[c[(b+8|0)>>2]&3](146,250,-+h[(c[(a+416|0)>>2]|0)+30024>>3],466,b);se[c[(b+8|0)>>2]&3](146,253,-1.0,467,b);se[c[(b+8|0)>>2]&3](146,257,-1.0,468,b);se[c[(b+8|0)>>2]&3](146,338,+h[(c[(a+416|0)>>2]|0)+30032>>3],469,b);se[c[(b+8|0)>>2]&3](147,86,1.0,470,b);se[c[(b+8|0)>>2]&3](147,256,-1.0,471,b);se[c[(b+8|0)>>2]&3](147,257,1.0,472,b);se[c[(b+8|0)>>2]&3](148,184,1.0,473,b);se[c[(b+8|0)>>2]&3](148,255,1.0,474,b);se[c[(b+8|0)>>2]&3](148,256,1.0,475,b);se[c[(b+8|0)>>2]&3](149,251,-+h[(c[(a+416|0)>>2]|0)+28032>>3],476,b);se[c[(b+8|0)>>2]&3](149,252,-1.0,477,b);se[c[(b+8|0)>>2]&3](149,254,-1.0,478,b);se[c[(b+8|0)>>2]&3](149,339,+h[(c[(a+416|0)>>2]|0)+28040>>3],479,b);se[c[(b+8|0)>>2]&3](150,196,1.0,480,b);se[c[(b+8|0)>>2]&3](150,253,1.0,481,b);se[c[(b+8|0)>>2]&3](150,254,1.0,482,b);se[c[(b+8|0)>>2]&3](151,245,1.0,483,b);se[c[(b+8|0)>>2]&3](151,251,-+h[(c[(a+416|0)>>2]|0)+31760>>3],484,b);se[c[(b+8|0)>>2]&3](151,252,1.0,485,b);se[c[(b+8|0)>>2]&3](151,339,+h[(c[(a+416|0)>>2]|0)+31768>>3],486,b);se[c[(b+8|0)>>2]&3](152,244,6.123233995736766e-17,487,b);se[c[(b+8|0)>>2]&3](152,251,1.0,488,b);se[c[(b+8|0)>>2]&3](152,340,-1.0,489,b);se[c[(b+8|0)>>2]&3](153,197,1.0,490,b);se[c[(b+8|0)>>2]&3](153,250,1.0,491,b);se[c[(b+8|0)>>2]&3](153,251,-1.0,492,b);se[c[(b+8|0)>>2]&3](154,175,1.0,493,b);se[c[(b+8|0)>>2]&3](154,249,-1.0,494,b);se[c[(b+8|0)>>2]&3](154,250,-1.0,495,b);se[c[(b+8|0)>>2]&3](155,185,1.0,496,b);se[c[(b+8|0)>>2]&3](155,248,1.0,497,b);se[c[(b+8|0)>>2]&3](155,249,1.0,498,b);se[c[(b+8|0)>>2]&3](156,173,1.0,499,b);se[c[(b+8|0)>>2]&3](156,247,1.0,500,b);se[c[(b+8|0)>>2]&3](156,248,-1.0,501,b);se[c[(b+8|0)>>2]&3](157,170,1.0,502,b);se[c[(b+8|0)>>2]&3](157,246,-1.0,503,b);se[c[(b+8|0)>>2]&3](157,247,-1.0,504,b);se[c[(b+8|0)>>2]&3](158,232,1.0,505,b);se[c[(b+8|0)>>2]&3](158,244,+h[(c[(a+416|0)>>2]|0)+37784>>3],506,b);se[c[(b+8|0)>>2]&3](158,245,-1.0,507,b);se[c[(b+8|0)>>2]&3](158,340,-+h[(c[(a+416|0)>>2]|0)+37792>>3],508,b);se[c[(b+8|0)>>2]&3](159,242,.8660254037844387,509,b);se[c[(b+8|0)>>2]&3](159,244,-1.0,510,b);se[c[(b+8|0)>>2]&3](159,341,-.4999999999999999,511,b);se[c[(b+8|0)>>2]&3](160,46,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-1.814269757448105,512,b);se[c[(b+8|0)>>2]&3](160,243,1.0,513,b);se[c[(b+8|0)>>2]&3](160,343,+h[(c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-1.814269757448105,514,b);se[c[(b+8|0)>>2]&3](161,223,-1.0,515,b);se[c[(b+8|0)>>2]&3](161,242,-1.0,516,b);se[c[(b+8|0)>>2]&3](161,243,1.0,517,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](162,87,+h[e+11224>>3]*+h[f+37216>>3]- +h[e+11208>>3]*+h[f+37208>>3],518,b);se[c[(b+8|0)>>2]&3](162,241,1.0,519,b);se[c[(b+8|0)>>2]&3](162,343,-1.0,520,b);f=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(a+416|0)>>2]|0;se[c[(b+8|0)>>2]&3](163,87,+h[f+11224>>3]*+h[e+35248>>3]- +h[f+11208>>3]*+h[e+35240>>3],521,b);se[c[(b+8|0)>>2]&3](163,240,1.0,522,b);se[c[(b+8|0)>>2]&3](163,241,-1.0,523,b);e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(a+416|0)>>2]|0;c[d+8>>2]=a;c[d+16>>2]=b;c[d+64>>2]=e;c[d+72>>2]=f;c[d+1608>>2]=0;c[d+1612>>2]=0;_setLinearMatrixA931$1(d);c[d+8>>2]=a;c[d+16>>2]=b;c[d+1600>>2]=0;c[d+1604>>2]=0;_setLinearMatrixA931$0(d);H=c[d+1600>>2]|0;A=c[d+1604>>2]|0;I=+g[d+1604>>2];c[d+1600>>2]=0;c[d+1604>>2]=0;if((H|0)==5){return}}function yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,j=0,k=0,l=0.0,m=0.0,n=0,o=0;d=i;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[e+14048>>3];j=c[(a+416|0)>>2]|0;k=c[(b+36|0)>>2]|0;h[k>>3]=+h[e+23848>>3]*f*+h[j+1504>>3]*-f+ +h[e+23872>>3]*f*+h[j+1512>>3]*-f;h[k+8>>3]=+h[j+38584>>3]*5.237345664226305;h[k+16>>3]=-+h[e+26616>>3];P4c(k+24|0,0,264)|0;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[e+13432>>3];j=c[(a+416|0)>>2]|0;h[k+288>>3]=(f*f*-.09+ +h[e+23696>>3]*+h[j+38584>>3])*2.0328;f=+h[(e+16|0)>>3];l=+h[(e+13728|0)>>3]*(+h[e+13384>>3]- +h[e+13656>>3]);m=+h[e+13720>>3]*(+h[e+13392>>3]- +h[e+13664>>3]);k=c[(b+36|0)>>2]|0;h[k+296>>3]=f*(l+m)+f*(l+(m-f*(+h[(e+13744|0)>>3]*(+h[e+2832>>3]- +h[e+13488>>3])+ +h[e+13736>>3]*(+h[e+2840>>3]- +h[e+13496>>3]))));f=+h[(e+16|0)>>3];h[k+304>>3]=+h[(e+13744|0)>>3]*f*+h[j+11672>>3]*-f+ +h[(e+13728|0)>>3]*f*+h[j+11680>>3]*-f;f=+h[(e+16|0)>>3];h[k+312>>3]=+h[(e+13744|0)>>3]*f*+h[j+10800>>3]*-f+ +h[(e+13728|0)>>3]*f*+h[j+10808>>3]*-f;f=+h[(e+16|0)>>3];h[k+320>>3]=+h[(e+13744|0)>>3]*f*+h[j+8808>>3]*-f+ +h[(e+13728|0)>>3]*f*+h[j+8816>>3]*-f;j=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(j+16|0)>>3];e=c[(a+416|0)>>2]|0;h[k+328>>3]=+h[j+13744>>3]*f*+h[e+12536>>3]*-f+ +h[j+13728>>3]*f*+h[e+12544>>3]*-f;f=+h[(j+16|0)>>3];h[k+336>>3]=+h[j+13304>>3]*f*+h[e+18560>>3]*-f+ +h[j+13288>>3]*f*+h[e+18568>>3]*-f;f=+h[(j+16|0)>>3];k=c[(b+36|0)>>2]|0;h[k+344>>3]=+h[(j+13096|0)>>3]*f*+h[e+17984>>3]*-f+ +h[(j+13080|0)>>3]*f*+h[e+17992>>3]*-f;f=+h[(j+16|0)>>3];h[k+352>>3]=+h[(j+13096|0)>>3]*f*+h[e+16016>>3]*-f+ +h[(j+13080|0)>>3]*f*+h[e+16024>>3]*-f;f=+h[(j+16|0)>>3];h[k+360>>3]=+h[(j+13096|0)>>3]*f*+h[e+17208>>3]*-f+ +h[(j+13080|0)>>3]*f*+h[e+17216>>3]*-f;f=+h[(j+16|0)>>3];h[k+368>>3]=+h[(j+13096|0)>>3]*f*+h[e+15216>>3]*-f+ +h[(j+13080|0)>>3]*f*+h[e+15224>>3]*-f;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(e+16|0)>>3];j=c[(a+416|0)>>2]|0;h[k+376>>3]=+h[e+13096>>3]*f*+h[j+18944>>3]*-f+ +h[e+13080>>3]*f*+h[j+18952>>3]*-f;f=+h[(e+16|0)>>3];h[k+384>>3]=+h[e+12656>>3]*f*+h[j+24968>>3]*-f+ +h[e+12640>>3]*f*+h[j+24976>>3]*-f;f=+h[(e+16|0)>>3];k=c[(b+36|0)>>2]|0;h[k+392>>3]=+h[(e+12448|0)>>3]*f*+h[j+24392>>3]*-f+ +h[(e+12432|0)>>3]*f*+h[j+24400>>3]*-f;f=+h[(e+16|0)>>3];h[k+400>>3]=+h[(e+12448|0)>>3]*f*+h[j+22424>>3]*-f+ +h[(e+12432|0)>>3]*f*+h[j+22432>>3]*-f;f=+h[(e+16|0)>>3];h[k+408>>3]=+h[(e+12448|0)>>3]*f*+h[j+23616>>3]*-f+ +h[(e+12432|0)>>3]*f*+h[j+23624>>3]*-f;f=+h[(e+16|0)>>3];h[k+416>>3]=+h[(e+12448|0)>>3]*f*+h[j+21624>>3]*-f+ +h[(e+12432|0)>>3]*f*+h[j+21632>>3]*-f;j=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(j+16|0)>>3];e=c[(a+416|0)>>2]|0;h[k+424>>3]=+h[j+12448>>3]*f*+h[e+25352>>3]*-f+ +h[j+12432>>3]*f*+h[e+25360>>3]*-f;f=+h[(j+16|0)>>3];h[k+432>>3]=+h[j+12008>>3]*f*+h[e+31376>>3]*-f+ +h[j+11992>>3]*f*+h[e+31384>>3]*-f;f=+h[(j+16|0)>>3];k=c[(b+36|0)>>2]|0;h[k+440>>3]=+h[(j+11800|0)>>3]*f*+h[e+30800>>3]*-f+ +h[(j+11784|0)>>3]*f*+h[e+30808>>3]*-f;f=+h[(j+16|0)>>3];h[k+448>>3]=+h[(j+11800|0)>>3]*f*+h[e+28832>>3]*-f+ +h[(j+11784|0)>>3]*f*+h[e+28840>>3]*-f;f=+h[(j+16|0)>>3];h[k+456>>3]=+h[(j+11800|0)>>3]*f*+h[e+30024>>3]*-f+ +h[(j+11784|0)>>3]*f*+h[e+30032>>3]*-f;f=+h[(j+16|0)>>3];h[k+464>>3]=+h[(j+11800|0)>>3]*f*+h[e+28032>>3]*-f+ +h[(j+11784|0)>>3]*f*+h[e+28040>>3]*-f;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(e+16|0)>>3];j=c[(a+416|0)>>2]|0;h[k+472>>3]=+h[e+11800>>3]*f*+h[j+31760>>3]*-f+ +h[e+11784>>3]*f*+h[j+31768>>3]*-f;f=+h[(e+16|0)>>3];h[k+480>>3]=+h[e+23960>>3]*f*+h[j+37784>>3]*-f+ +h[e+23984>>3]*f*+h[j+37792>>3]*-f;k=c[(b+36|0)>>2]|0;h[k+488>>3]=+h[e+11224>>3]*+h[j+38584>>3]*1.814269757448105;P4c(k+496|0,0,392)|0;P4c((c[(b+36|0)>>2]|0)+888|0,0,392)|0;k=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;j=c[(a+416|0)>>2]|0;e=c[(b+36|0)>>2]|0;h[e+1280>>3]=+h[(k+11208|0)>>3]*+h[(j+38584|0)>>3]*1.814269757448105;h[e+1288>>3]=0.0;f=+h[(k+16|0)>>3];h[e+1296>>3]=+h[(k+11224|0)>>3]*f*+h[j+37208>>3]*-f+ +h[(k+11208|0)>>3]*f*+h[j+37216>>3]*-f;f=+h[(k+16|0)>>3];h[e+1304>>3]=+h[(k+11224|0)>>3]*f*+h[j+35240>>3]*-f+ +h[(k+11208|0)>>3]*f*+h[j+35248>>3]*-f;f=+h[(k+16|0)>>3];h[e+1312>>3]=+h[(k+11224|0)>>3]*f*+h[j+36432>>3]*-f+ +h[(k+11208|0)>>3]*f*+h[j+36440>>3]*-f;f=+h[(k+16|0)>>3];h[e+1320>>3]=(f*f*.05+ +h[(k+11224|0)>>3]*+h[(j+38584|0)>>3])*.77;n=e+1328|0;o=n+80|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));h[e+1408>>3]=+h[(k+11208|0)>>3]*+h[(j+38584|0)>>3]*.77;c[(e+1416|0)+0>>2]=0;c[(e+1416|0)+4>>2]=0;c[(e+1416|0)+8>>2]=0;c[(e+1416|0)+12>>2]=0;c[(e+1416|0)+16>>2]=0;c[(e+1416|0)+20>>2]=0;e=c[(b+36|0)>>2]|0;h[e+1440>>3]=0.0;j=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;k=c[(a+416|0)>>2]|0;h[e+1448>>3]=+h[(j+11224|0)>>3]*+h[(k+38584|0)>>3]*.653137112681318;h[e+1456>>3]=+h[(j+11208|0)>>3]*+h[(k+38584|0)>>3]*.653137112681318;f=+h[(j+16|0)>>3];h[e+1464>>3]=+h[(j+11224|0)>>3]*f*+h[k+37304>>3]*-f+ +h[(j+11208|0)>>3]*f*+h[k+37312>>3]*-f;f=+h[(j+16|0)>>3];m=+h[(j+11208|0)>>3]*(+h[j+10936>>3]- +h[j+11136>>3]);l=+h[j+11200>>3]*(+h[j+10944>>3]- +h[j+11144>>3]);h[e+1472>>3]=f*(m+l)+f*(m+(l-f*(+h[(j+11224|0)>>3]*(+h[j+376>>3]- +h[j+11016>>3])+ +h[j+11216>>3]*(+h[j+384>>3]- +h[j+11024>>3]))));f=+h[j+10952>>3];e=c[(b+36|0)>>2]|0;h[e+1480>>3]=+h[j+23224>>3]*f*+h[k+33544>>3]*-f+ +h[j+23248>>3]*f*+h[k+33552>>3]*-f;h[e+1488>>3]=+h[(k+38584|0)>>3]*5.237345664226305;k=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;h[e+1496>>3]=-+h[k+26056>>3];h[e+1504>>3]=0.0;j=c[(a+416|0)>>2]|0;h[e+1512>>3]=+h[j+46312>>3];n=e+1520|0;o=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));f=+h[(k+10952|0)>>3];h[e+1576>>3]=+h[(k+23216|0)>>3]*f*+h[j+33544>>3]*-f+ +h[(k+23240|0)>>3]*f*+h[j+33552>>3]*-f;h[e+1584>>3]=0.0;h[e+1592>>3]=+h[(k+23240|0)>>3]*+h[(j+38584|0)>>3]*2.0328;f=+h[(k+10952|0)>>3];h[e+1600>>3]=(f*f*-.09+ +h[(k+23216|0)>>3]*+h[(j+38584|0)>>3])*2.0328;f=+h[k+16>>3];l=+h[k+11224>>3]*(+h[k+10936>>3]- +h[k+11136>>3]);m=+h[k+11216>>3]*(+h[k+10944>>3]- +h[k+11144>>3]);j=c[(b+36|0)>>2]|0;h[j+1608>>3]=-(f*(l+(m+f*(+h[k+11208>>3]*(+h[k+376>>3]- +h[k+11016>>3])+ +h[k+11200>>3]*(+h[k+384>>3]- +h[k+11024>>3])))))-f*(l+m);k=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;m=+h[(k+16|0)>>3];e=c[(a+416|0)>>2]|0;h[j+1616>>3]=(m*m*-.05+ +h[k+11224>>3]*+h[(e+38584|0)>>3])*.77;h[j+1624>>3]=+h[k+11208>>3]*+h[(e+38584|0)>>3]*.77;h[j+1632>>3]=0.0;m=+h[(k+16|0)>>3];h[j+1640>>3]=(m*m*.05+ +h[(k+11800|0)>>3]*+h[(e+38584|0)>>3])*.77;h[j+1648>>3]=+h[(k+11784|0)>>3]*+h[(e+38584|0)>>3]*.77;h[j+1656>>3]=0.0;m=+h[(k+16|0)>>3];h[j+1664>>3]=+h[(k+11800|0)>>3]*m*+h[e+30896>>3]*-m+ +h[(k+11784|0)>>3]*m*+h[e+30904>>3]*-m;m=+h[(k+16|0)>>3];l=+h[(k+11784|0)>>3]*(+h[k+11440>>3]- +h[k+11712>>3]);f=+h[k+11776>>3]*(+h[k+11448>>3]- +h[k+11720>>3]);e=c[(b+36|0)>>2]|0;h[e+1672>>3]=m*(l+f)+m*(l+(f-m*(+h[(k+11800|0)>>3]*(+h[k+976>>3]- +h[k+11544>>3])+ +h[k+11792>>3]*(+h[k+984>>3]- +h[k+11552>>3]))));k=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;m=+h[k+16>>3];f=+h[k+11800>>3]*(+h[k+11440>>3]- +h[k+11712>>3]);l=+h[k+11792>>3]*(+h[k+11448>>3]- +h[k+11720>>3]);h[e+1680>>3]=-(m*(f+(l+m*(+h[k+11784>>3]*(+h[k+976>>3]- +h[k+11544>>3])+ +h[k+11776>>3]*(+h[k+984>>3]- +h[k+11552>>3])))))-m*(f+l);l=+h[k+11488>>3];j=c[(a+416|0)>>2]|0;h[e+1688>>3]=+h[k+23344>>3]*l*+h[(j+27136|0)>>3]*-l+ +h[k+23368>>3]*l*+h[(j+27144|0)>>3]*-l;h[e+1696>>3]=+h[(j+38584|0)>>3]*5.237345664226305;h[e+1704>>3]=-+h[k+26168>>3];h[e+1712>>3]=0.0;h[e+1720>>3]=+h[j+44832>>3];n=e+1728|0;o=n+48|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));e=c[(b+36|0)>>2]|0;h[e+1776>>3]=0.0;k=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(k+11488|0)>>3];h[e+1784>>3]=+h[(k+23336|0)>>3]*l*+h[(j+27136|0)>>3]*-l+ +h[(k+23360|0)>>3]*l*+h[(j+27144|0)>>3]*-l;h[e+1792>>3]=+h[(k+23360|0)>>3]*+h[(j+38584|0)>>3]*2.0328;h[e+1800>>3]=0.0;l=+h[(k+11488|0)>>3];h[e+1808>>3]=(l*l*-.09+ +h[(k+23336|0)>>3]*+h[(j+38584|0)>>3])*2.0328;h[e+1816>>3]=+h[(k+11800|0)>>3]*+h[(j+38584|0)>>3]*.653137112681318;h[e+1824>>3]=+h[(k+11784|0)>>3]*+h[(j+38584|0)>>3]*.653137112681318;l=+h[(k+16|0)>>3];j=c[(a+416|0)>>2]|0;h[e+1832>>3]=(l*l*-.05+ +h[(k+11800|0)>>3]*+h[(j+38584|0)>>3])*.77;h[e+1840>>3]=+h[(k+11784|0)>>3]*+h[(j+38584|0)>>3]*.77;h[e+1848>>3]=0.0;h[e+1856>>3]=+h[(k+11800|0)>>3]*+h[(j+38584|0)>>3]*1.814269757448105;h[e+1864>>3]=+h[(k+11784|0)>>3]*+h[(j+38584|0)>>3]*1.814269757448105;l=+h[(k+16|0)>>3];h[e+1872>>3]=(l*l*.05+ +h[k+12448>>3]*+h[(j+38584|0)>>3])*.77;e=c[(b+36|0)>>2]|0;h[e+1880>>3]=+h[k+12432>>3]*+h[(j+38584|0)>>3]*.77;h[e+1888>>3]=0.0;k=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(k+16|0)>>3];h[e+1896>>3]=+h[(k+12448|0)>>3]*l*+h[j+24488>>3]*-l+ +h[(k+12432|0)>>3]*l*+h[j+24496>>3]*-l;l=+h[(k+16|0)>>3];f=+h[(k+12432|0)>>3]*(+h[k+12088>>3]- +h[k+12360>>3]);m=+h[k+12424>>3]*(+h[k+12096>>3]- +h[k+12368>>3]);h[e+1904>>3]=l*(f+m)+l*(f+(m-l*(+h[(k+12448|0)>>3]*(+h[k+1600>>3]- +h[k+12192>>3])+ +h[k+12440>>3]*(+h[k+1608>>3]- +h[k+12200>>3]))));l=+h[k+12104>>3];j=c[(a+416|0)>>2]|0;h[e+1912>>3]=+h[k+23464>>3]*l*+h[(j+20728|0)>>3]*-l+ +h[k+23488>>3]*l*+h[(j+20736|0)>>3]*-l;h[e+1920>>3]=+h[(j+38584|0)>>3]*5.237345664226305;h[e+1928>>3]=-+h[k+26280>>3];k=c[(b+36|0)>>2]|0;h[k+1936>>3]=0.0;h[k+1944>>3]=+h[j+43352>>3];n=k+1952|0;o=n+56|0;do{c[n>>2]=0;n=n+4|0}while((n|0)<(o|0));e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;l=+h[(e+12104|0)>>3];h[k+2008>>3]=+h[(e+23456|0)>>3]*l*+h[(j+20728|0)>>3]*-l+ +h[(e+23480|0)>>3]*l*+h[(j+20736|0)>>3]*-l;h[k+2016>>3]=0.0;h[k+2024>>3]=+h[(e+23480|0)>>3]*+h[(j+38584|0)>>3]*2.0328;l=+h[(e+12104|0)>>3];h[k+2032>>3]=(l*l*-.09+ +h[(e+23456|0)>>3]*+h[(j+38584|0)>>3])*2.0328;l=+h[e+16>>3];m=+h[(e+12448|0)>>3]*(+h[e+12088>>3]- +h[e+12360>>3]);f=+h[e+12440>>3]*(+h[e+12096>>3]- +h[e+12368>>3]);j=c[(b+36|0)>>2]|0;h[j+2040>>3]=-(l*(m+(f+l*(+h[(e+12432|0)>>3]*(+h[e+1600>>3]- +h[e+12192>>3])+ +h[e+12424>>3]*(+h[e+1608>>3]- +h[e+12200>>3])))))-l*(m+f);k=c[(a+416|0)>>2]|0;h[j+2048>>3]=+h[(e+12448|0)>>3]*+h[(k+38584|0)>>3]*.653137112681318;h[j+2056>>3]=+h[(e+12432|0)>>3]*+h[(k+38584|0)>>3]*.653137112681318;e=c[(c[c[(a+4|0)>>2]>>2]|0)+8>>2]|0;f=+h[(e+16|0)>>3];h[j+2064>>3]=(f*f*-.05+ +h[(e+12448|0)>>3]*+h[(k+38584|0)>>3])*.77;h[j+2072>>3]=+h[(e+12432|0)>>3]*+h[(k+38584|0)>>3]*.77;h[j+2080>>3]=0.0;h[j+2088>>3]=+h[(e+12448|0)>>3]*+h[(k+38584|0)>>3]*1.814269757448105;h[j+2096>>3]=+h[(e+12432|0)>>3]*+h[(k+38584|0)>>3]*1.814269757448105;f=+h[(e+16|0)>>3];h[j+2104>>3]=(f*f*.05+ +h[(e+13096|0)>>3]*+h[(k+38584|0)>>3])*.77;h[j+2112>>3]=+h[(e+13080|0)>>3]*+h[(k+38584|0)>>3]*.77;h[j+2120>>3]=0.0;f=+h[(e+16|0)>>3];h[j+2128>>3]=+h[(e+13096|0)>>3]*f*+h[k+18080>>3]*-f+ +h[(e+13080|0)>>3]*f*+h[k+18088>>3]*-f;f=+h[(e+16|0)>>3];m=+h[(e+13080|0)>>3]*(+h[e+12736>>3]- +h[e+13008>>3]);l=+h[e+13072>>3]*(+h[e+12744>>3]- +h[e+13016>>3]);k=c[(b+36|0)>>2]|0;c[d+8>>2]=a;c[d+16>>2]=b;c[d+224>>2]=e;g[d+256>>2]=f;g[d+264>>2]=m;g[d+280>>2]=l;c[d+288>>2]=k;c[d+1896>>2]=n;c[d+1912>>2]=o;c[d+1920>>2]=0;c[d+1924>>2]=0;_setLinearVectorb931$0(d);n=c[d+1896>>2]|0;o=c[d+1912>>2]|0;H=c[d+1920>>2]|0;A=c[d+1924>>2]|0;I=+g[d+1924>>2];c[d+1920>>2]=0;c[d+1924>>2]=0;if((H|0)==5){return}}function zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23024>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23032>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23040>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23048>>3],3,b);i=d;return}function Ay(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+14768|0;e=d+14776|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+23024>>3]*+h[e>>3])- +h[d+23032>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+23040>>3]*+h[e>>3])- +h[d+23048>>3]*+h[a>>3];i=i;return}function By(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23048>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23040>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23032>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23024>>3],3,b);i=d;return}function Cy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+23048|0;e=d+14160|0;f=d+23040|0;g=d+14168|0;j=d+16|0;k=d+23032|0;l=d+3408|0;m=d+14768|0;n=d+23024|0;o=d+3416|0;p=d+14776|0;d=c[b+36>>2]|0;h[d>>3]=+h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[f>>3]*+h[g>>3]- +h[a>>3]*+h[e>>3];h[d+8>>3]=-(+h[n>>3]*+h[g>>3])- +h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[k>>3]*+h[e>>3];i=i;return}function Dy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,0,+h[g+23848>>3]*+h[a+1512>>3]- +h[g+23872>>3]*+h[a+1504>>3],0,b);se[c[e>>2]&3](0,3,1.0,1,b);se[c[e>>2]&3](1,2,.4999999999999999,2,b);se[c[e>>2]&3](1,3,1.0,3,b);se[c[e>>2]&3](2,1,1.0,4,b);se[c[e>>2]&3](2,2,-.8660254037844387,5,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](3,0,+h[a+23840>>3]*+h[f+1512>>3]- +h[a+23864>>3]*+h[f+1504>>3],6,b);se[c[e>>2]&3](3,1,1.0,7,b);i=d;return}function Ey(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+14040>>3];b=e+14032|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;h[a+24>>3]=+h[b>>3];i=d;return}function Fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13728>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13720>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13744>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13736>>3],3,b);i=d;return}function Gy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+13488|0;e=d+13496|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+13720>>3]*+h[e>>3])- +h[d+13728>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+13736>>3]*+h[e>>3])- +h[d+13744>>3]*+h[a>>3];i=i;return}function Hy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13744>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13736>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13728>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13720>>3],3,b);i=d;return}function Iy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+13744|0;e=d+13656|0;f=d+13736|0;g=d+13664|0;j=d+16|0;k=d+13728|0;l=d+2832|0;m=d+13488|0;n=d+13720|0;o=d+2840|0;p=d+13496|0;d=c[b+36>>2]|0;h[d>>3]=+h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[f>>3]*+h[g>>3]- +h[a>>3]*+h[e>>3];h[d+8>>3]=-(+h[n>>3]*+h[g>>3])- +h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[k>>3]*+h[e>>3];i=i;return}function Jy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,0,+h[g+23704>>3]*+h[a+7920>>3]- +h[g+23728>>3]*+h[a+7912>>3],0,b);se[c[e>>2]&3](0,3,1.0,1,b);se[c[e>>2]&3](1,2,-.4999999999999999,2,b);se[c[e>>2]&3](1,3,1.0,3,b);se[c[e>>2]&3](2,1,1.0,4,b);se[c[e>>2]&3](2,2,-.8660254037844387,5,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](3,0,+h[a+23696>>3]*+h[f+7920>>3]- +h[a+23720>>3]*+h[f+7912>>3],6,b);se[c[e>>2]&3](3,1,1.0,7,b);i=d;return}function Ky(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+13392>>3];b=e+13384|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;h[a+24>>3]=+h[b>>3];i=d;return}function Ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13072>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13080>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13088>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13096>>3],3,b);i=d;return}function My(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+12840|0;e=d+12848|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+13072>>3]*+h[e>>3])- +h[d+13080>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+13088>>3]*+h[e>>3])- +h[d+13096>>3]*+h[a>>3];i=i;return}function Ny(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13096>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13088>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13080>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13072>>3],3,b);i=d;return}function Oy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+13096|0;e=d+13008|0;f=d+13088|0;g=d+13016|0;j=d+16|0;k=d+13080|0;l=d+2224|0;m=d+12840|0;n=d+13072|0;o=d+2232|0;p=d+12848|0;d=c[b+36>>2]|0;h[d>>3]=+h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[f>>3]*+h[g>>3]- +h[a>>3]*+h[e>>3];h[d+8>>3]=-(+h[n>>3]*+h[g>>3])- +h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[k>>3]*+h[e>>3];i=i;return}function Py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,3,+h[g+23584>>3]*+h[a+14328>>3]- +h[g+23608>>3]*+h[a+14320>>3],1,b);se[c[e>>2]&3](1,2,1.0,2,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](1,3,+h[a+23576>>3]*+h[f+14328>>3]- +h[a+23600>>3]*+h[f+14320>>3],3,b);se[c[e>>2]&3](2,1,-.8660254037844387,4,b);se[c[e>>2]&3](2,2,1.0,5,b);se[c[e>>2]&3](3,0,1.0,6,b);se[c[e>>2]&3](3,1,.4999999999999999,7,b);i=d;return}function Qy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+12744>>3];h[a+8>>3]=+h[e+12736>>3];e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function Ry(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12432>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12424>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12448>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12440>>3],3,b);i=d;return}function Sy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+12192|0;e=d+12200|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+12424>>3]*+h[e>>3])- +h[d+12432>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+12440>>3]*+h[e>>3])- +h[d+12448>>3]*+h[a>>3];i=i;return}function Ty(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12448>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12440>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12432>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12424>>3],3,b);i=d;return}function Uy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+12448|0;e=d+12360|0;f=d+12440|0;g=d+12368|0;j=d+16|0;k=d+12432|0;l=d+1600|0;m=d+12192|0;n=d+12424|0;o=d+1608|0;p=d+12200|0;d=c[b+36>>2]|0;h[d>>3]=+h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[f>>3]*+h[g>>3]- +h[a>>3]*+h[e>>3];h[d+8>>3]=-(+h[n>>3]*+h[g>>3])- +h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[k>>3]*+h[e>>3];i=i;return}function Vy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,3,+h[g+23464>>3]*+h[a+20736>>3]- +h[g+23488>>3]*+h[a+20728>>3],1,b);se[c[e>>2]&3](1,2,1.0,2,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](1,3,+h[a+23456>>3]*+h[f+20736>>3]- +h[a+23480>>3]*+h[f+20728>>3],3,b);se[c[e>>2]&3](2,1,-.8660254037844387,4,b);se[c[e>>2]&3](2,2,1.0,5,b);se[c[e>>2]&3](3,0,1.0,6,b);se[c[e>>2]&3](3,1,-.4999999999999999,7,b);i=d;return}function Wy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+12096>>3];h[a+8>>3]=+h[e+12088>>3];e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function Xy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11784>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11776>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11800>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11792>>3],3,b);i=d;return}function Yy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11544|0;e=d+11552|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+11776>>3]*+h[e>>3])- +h[d+11784>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+11792>>3]*+h[e>>3])- +h[d+11800>>3]*+h[a>>3];i=i;return}function Zy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11800>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11792>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11784>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11776>>3],3,b);i=d;return}function _y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11800|0;e=d+11712|0;f=d+11792|0;g=d+11720|0;j=d+16|0;k=d+11784|0;l=d+976|0;m=d+11544|0;n=d+11776|0;o=d+984|0;p=d+11552|0;d=c[b+36>>2]|0;h[d>>3]=+h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[f>>3]*+h[g>>3]- +h[a>>3]*+h[e>>3];h[d+8>>3]=-(+h[n>>3]*+h[g>>3])- +h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[k>>3]*+h[e>>3];i=i;return}function $y(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,0,+h[g+23344>>3]*+h[a+27144>>3]- +h[g+23368>>3]*+h[a+27136>>3],0,b);se[c[e>>2]&3](0,3,1.0,1,b);se[c[e>>2]&3](1,2,.4999999999999999,2,b);se[c[e>>2]&3](1,3,1.0,3,b);se[c[e>>2]&3](2,1,1.0,4,b);se[c[e>>2]&3](2,2,-.8660254037844387,5,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](3,0,+h[a+23336>>3]*+h[f+27144>>3]- +h[a+23360>>3]*+h[f+27136>>3],6,b);se[c[e>>2]&3](3,1,1.0,7,b);i=d;return}function az(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+11448>>3];b=e+11440|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;h[a+24>>3]=+h[b>>3];i=d;return}function bz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11200>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11208>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11216>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11224>>3],3,b);i=d;return}function cz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11016|0;e=d+11024|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+11200>>3]*+h[e>>3])- +h[d+11208>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+11216>>3]*+h[e>>3])- +h[d+11224>>3]*+h[a>>3];i=i;return}function dz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11224>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11216>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11208>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11200>>3],3,b);i=d;return}function ez(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11224|0;e=d+11136|0;f=d+11216|0;g=d+11144|0;j=d+16|0;k=d+11208|0;l=d+376|0;m=d+11016|0;n=d+11200|0;o=d+384|0;p=d+11024|0;d=c[b+36>>2]|0;h[d>>3]=+h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[f>>3]*+h[g>>3]- +h[a>>3]*+h[e>>3];h[d+8>>3]=-(+h[n>>3]*+h[g>>3])- +h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[k>>3]*+h[e>>3];i=i;return}function fz(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,3,+h[g+23224>>3]*+h[a+33552>>3]- +h[g+23248>>3]*+h[a+33544>>3],1,b);se[c[e>>2]&3](1,2,1.0,2,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](1,3,+h[a+23216>>3]*+h[f+33552>>3]- +h[a+23240>>3]*+h[f+33544>>3],3,b);se[c[e>>2]&3](2,1,-.8660254037844387,4,b);se[c[e>>2]&3](2,2,1.0,5,b);se[c[e>>2]&3](3,0,1.0,6,b);se[c[e>>2]&3](3,1,-.4999999999999999,7,b);i=d;return}function gz(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+10944>>3];h[a+8>>3]=+h[e+10936>>3];e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function _setLinearMatrixA931$0(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+8>>2]|0;d=c[a+16>>2]|0;a:do{se[c[(d+8|0)>>2]&3](286,117,1.0,909,d);se[c[(d+8|0)>>2]&3](286,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-.653137112681318,910,d);se[c[(d+8|0)>>2]&3](287,63,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-.77,911,d);se[c[(d+8|0)>>2]&3](287,116,1.0,912,d);se[c[(d+8|0)>>2]&3](287,360,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-.77,913,d);se[c[(d+8|0)>>2]&3](288,63,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-.77,914,d);se[c[(d+8|0)>>2]&3](288,87,-.03850000000000001,915,d);se[c[(d+8|0)>>2]&3](288,115,1.0,916,d);se[c[(d+8|0)>>2]&3](288,360,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-.77,917,d);se[c[(d+8|0)>>2]&3](289,87,-.0008020833333333335,918,d);se[c[(d+8|0)>>2]&3](289,114,1.0,919,d);se[c[(d+8|0)>>2]&3](289,115,-.05,920,d);se[c[(d+8|0)>>2]&3](290,64,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-1.814269757448105,921,d);se[c[(d+8|0)>>2]&3](290,113,1.0,922,d);se[c[(d+8|0)>>2]&3](290,361,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-1.814269757448105,923,d);se[c[(d+8|0)>>2]&3](291,64,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-1.814269757448105,924,d);se[c[(d+8|0)>>2]&3](291,112,1.0,925,d);se[c[(d+8|0)>>2]&3](291,361,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-1.814269757448105,926,d);se[c[(d+8|0)>>2]&3](292,67,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-.77,927,d);se[c[(d+8|0)>>2]&3](292,111,1.0,928,d);se[c[(d+8|0)>>2]&3](292,364,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-.77,929,d);se[c[(d+8|0)>>2]&3](293,67,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-.77,930,d);se[c[(d+8|0)>>2]&3](293,87,.03850000000000001,931,d);se[c[(d+8|0)>>2]&3](293,110,1.0,932,d);se[c[(d+8|0)>>2]&3](293,364,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-.77,933,d);se[c[(d+8|0)>>2]&3](294,87,-.0008020833333333335,934,d);se[c[(d+8|0)>>2]&3](294,109,1.0,935,d);se[c[(d+8|0)>>2]&3](294,110,.05,936,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](295,87,+h[e+13744>>3]*+h[f+9616>>3]- +h[e+13728>>3]*+h[f+9608>>3],937,d);se[c[(d+8|0)>>2]&3](295,108,-1.0,938,d);se[c[(d+8|0)>>2]&3](295,365,1.0,939,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](296,87,+h[f+13744>>3]*+h[e+11584>>3]- +h[f+13728>>3]*+h[e+11576>>3],940,d);se[c[(d+8|0)>>2]&3](296,107,-1.0,941,d);se[c[(d+8|0)>>2]&3](296,108,1.0,942,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](297,87,+h[e+13952>>3]*+h[f+12160>>3]- +h[e+13936>>3]*+h[f+12152>>3],943,d);se[c[(d+8|0)>>2]&3](297,106,-1.0,944,d);se[c[(d+8|0)>>2]&3](297,107,1.0,945,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](298,87,+h[f+23048>>3]*+h[e+6136>>3]- +h[f+23032>>3]*+h[e+6128>>3],946,d);se[c[(d+8|0)>>2]&3](298,105,-1.0,947,d);se[c[(d+8|0)>>2]&3](298,106,1.0,948,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](299,87,+h[e+23048>>3]*+h[f+2408>>3]- +h[e+23032>>3]*+h[f+2400>>3],949,d);se[c[(d+8|0)>>2]&3](299,104,-1.0,950,d);se[c[(d+8|0)>>2]&3](299,105,1.0,951,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](300,87,+h[f+23048>>3]*+h[e+4400>>3]- +h[f+23032>>3]*+h[e+4392>>3],952,d);se[c[(d+8|0)>>2]&3](300,103,-1.0,953,d);se[c[(d+8|0)>>2]&3](300,104,1.0,954,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](301,87,+h[e+23048>>3]*+h[f+5272>>3]- +h[e+23032>>3]*+h[f+5264>>3],955,d);se[c[(d+8|0)>>2]&3](301,102,1.0,956,d);se[c[(d+8|0)>>2]&3](301,103,-1.0,957,d);se[c[(d+8|0)>>2]&3](302,16,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3],958,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](302,87,-(+h[f+23024>>3]*(+h[f+3416>>3]- +h[f+14776>>3]))- +h[f+23032>>3]*(+h[f+3408>>3]- +h[f+14768>>3]),959,d);se[c[(d+8|0)>>2]&3](302,90,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3],960,d);se[c[(d+8|0)>>2]&3](302,101,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3],961,d);se[c[(d+8|0)>>2]&3](302,102,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3],962,d);se[c[(d+8|0)>>2]&3](303,0,1.0,963,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](303,100,+h[f+23840>>3]*+h[e+1512>>3]- +h[f+23864>>3]*+h[e+1504>>3],964,d);se[c[(d+8|0)>>2]&3](303,101,-1.0,965,d);se[c[(d+8|0)>>2]&3](304,92,-.09,966,d);se[c[(d+8|0)>>2]&3](304,99,-1.0,967,d);se[c[(d+8|0)>>2]&3](304,100,-.0088088,968,d);se[c[(d+8|0)>>2]&3](305,98,-+h[(c[(b+416|0)>>2]|0)+1504>>3],969,d);se[c[(d+8|0)>>2]&3](305,99,-1.0,970,d);se[c[(d+8|0)>>2]&3](305,400,+h[(c[(b+416|0)>>2]|0)+1512>>3],971,d);se[c[(d+8|0)>>2]&3](306,92,1.0,972,d);se[c[(d+8|0)>>2]&3](306,97,1.0,973,d);se[c[(d+8|0)>>2]&3](306,98,-1.0,974,d);se[c[(d+8|0)>>2]&3](307,96,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7816>>3],975,d);se[c[(d+8|0)>>2]&3](307,97,1.0,976,d);se[c[(d+8|0)>>2]&3](307,398,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+7840>>3],977,d);se[c[(d+8|0)>>2]&3](308,13,1.0,978,d);se[c[(d+8|0)>>2]&3](308,95,1.0,979,d);se[c[(d+8|0)>>2]&3](308,96,1.0,980,d);se[c[(d+8|0)>>2]&3](309,8,1.0,981,d);se[c[(d+8|0)>>2]&3](309,94,1.0,982,d);se[c[(d+8|0)>>2]&3](309,95,-1.0,983,d);se[c[(d+8|0)>>2]&3](310,6,1.0,984,d);se[c[(d+8|0)>>2]&3](310,93,-1.0,985,d);se[c[(d+8|0)>>2]&3](310,94,-1.0,986,d);se[c[(d+8|0)>>2]&3](311,90,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23872>>3]*-2.0328,987,d);se[c[(d+8|0)>>2]&3](311,92,1.0,988,d);se[c[(d+8|0)>>2]&3](311,100,-.182952,989,d);se[c[(d+8|0)>>2]&3](311,101,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23864>>3]*-2.0328,990,d);se[c[(d+8|0)>>2]&3](312,90,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23848>>3]*-2.0328,991,d);se[c[(d+8|0)>>2]&3](312,91,1.0,992,d);se[c[(d+8|0)>>2]&3](312,101,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23840>>3]*-2.0328,993,d);se[c[(d+8|0)>>2]&3](313,16,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3],994,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](313,87,+h[e+23048>>3]*(+h[e+3408>>3]- +h[e+14768>>3])+ +h[e+23040>>3]*(+h[e+3416>>3]- +h[e+14776>>3]),995,d);se[c[(d+8|0)>>2]&3](313,90,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3],996,d);se[c[(d+8|0)>>2]&3](313,101,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3],997,d);se[c[(d+8|0)>>2]&3](313,102,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3],998,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](314,87,+h[e+23048>>3]*+h[f+3208>>3]- +h[e+23032>>3]*+h[f+3200>>3],999,d);se[c[(d+8|0)>>2]&3](314,89,-1.0,1e3,d);se[c[(d+8|0)>>2]&3](314,103,1.0,1001,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](315,87,+h[f+23048>>3]*+h[e+5176>>3]- +h[f+23032>>3]*+h[e+5168>>3],1002,d);se[c[(d+8|0)>>2]&3](315,88,-1.0,1003,d);se[c[(d+8|0)>>2]&3](315,89,1.0,1004,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](316,87,+h[e+23904>>3]*+h[f+5752>>3]- +h[e+23888>>3]*+h[f+5744>>3],1005,d);se[c[(d+8|0)>>2]&3](316,88,1.0,1006,d);se[c[(d+8|0)>>2]&3](317,86,1.0,1007,d);se[c[(d+8|0)>>2]&3](317,87,-7347792517664828.0e-20,1008,d);se[c[(d+8|0)>>2]&3](318,85,1.0,1009,d);se[c[(d+8|0)>>2]&3](318,87,-.0005669592992025331,1010,d);se[c[(d+8|0)>>2]&3](319,84,1.0,1011,d);se[c[(d+8|0)>>2]&3](319,87,-7347792517664828.0e-20,1012,d);se[c[(d+8|0)>>2]&3](320,83,1.0,1013,d);se[c[(d+8|0)>>2]&3](320,87,-.0005669592992025331,1014,d);se[c[(d+8|0)>>2]&3](321,82,1.0,1015,d);se[c[(d+8|0)>>2]&3](321,87,-7347792517664828.0e-20,1016,d);se[c[(d+8|0)>>2]&3](322,81,1.0,1017,d);se[c[(d+8|0)>>2]&3](322,87,-.0005669592992025331,1018,d);se[c[(d+8|0)>>2]&3](323,80,1.0,1019,d);se[c[(d+8|0)>>2]&3](323,87,-7347792517664828.0e-20,1020,d);se[c[(d+8|0)>>2]&3](324,79,1.0,1021,d);se[c[(d+8|0)>>2]&3](324,87,-.0005669592992025331,1022,d);se[c[(d+8|0)>>2]&3](325,78,1.0,1023,d);se[c[(d+8|0)>>2]&3](325,87,-7347792517664828.0e-20,1024,d);se[c[(d+8|0)>>2]&3](326,77,1.0,1025,d);se[c[(d+8|0)>>2]&3](326,87,-.0005669592992025331,1026,d);se[c[(d+8|0)>>2]&3](327,18,-1.0,1027,d);se[c[(d+8|0)>>2]&3](327,76,1.0,1028,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](327,87,+h[f+23040>>3]*+h[e+2408>>3]- +h[f+23024>>3]*+h[e+2400>>3],1029,d);se[c[(d+8|0)>>2]&3](328,75,1.0,1030,d);se[c[(d+8|0)>>2]&3](328,76,-1.0,1031,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](328,87,+h[e+23040>>3]*+h[f+6136>>3]- +h[e+23024>>3]*+h[f+6128>>3],1032,d);se[c[(d+8|0)>>2]&3](329,74,1.0,1033,d);se[c[(d+8|0)>>2]&3](329,75,-1.0,1034,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](329,87,+h[f+13944>>3]*+h[e+12160>>3]- +h[f+13928>>3]*+h[e+12152>>3],1035,d);se[c[(d+8|0)>>2]&3](330,73,1.0,1036,d);se[c[(d+8|0)>>2]&3](330,74,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-1.814269757448105,1037,d);se[c[(d+8|0)>>2]&3](330,107,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-1.814269757448105,1038,d);se[c[(d+8|0)>>2]&3](331,72,1.0,1039,d);se[c[(d+8|0)>>2]&3](331,74,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-1.814269757448105,1040,d);se[c[(d+8|0)>>2]&3](331,107,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-1.814269757448105,1041,d);se[c[(d+8|0)>>2]&3](332,71,1.0,1042,d);se[c[(d+8|0)>>2]&3](332,74,-1.0,1043,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](332,87,+h[e+13736>>3]*+h[f+11584>>3]- +h[e+13720>>3]*+h[f+11576>>3],1044,d);se[c[(d+8|0)>>2]&3](333,70,1.0,1045,d);se[c[(d+8|0)>>2]&3](333,71,-1.0,1046,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](333,87,+h[f+13736>>3]*+h[e+9616>>3]- +h[f+13720>>3]*+h[e+9608>>3],1047,d);se[c[(d+8|0)>>2]&3](334,69,1.0,1048,d);se[c[(d+8|0)>>2]&3](334,70,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-.653137112681318,1049,d);se[c[(d+8|0)>>2]&3](334,365,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-.653137112681318,1050,d);se[c[(d+8|0)>>2]&3](335,68,1.0,1051,d);se[c[(d+8|0)>>2]&3](335,70,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-.653137112681318,1052,d);se[c[(d+8|0)>>2]&3](335,365,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-.653137112681318,1053,d);se[c[(d+8|0)>>2]&3](336,67,1.0,1054,d);se[c[(d+8|0)>>2]&3](336,70,-1.0,1055,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](336,87,+h[e+13736>>3]*+h[f+10808>>3]- +h[e+13720>>3]*+h[f+10800>>3],1056,d);se[c[(d+8|0)>>2]&3](337,66,1.0,1057,d);se[c[(d+8|0)>>2]&3](337,67,-1.0,1058,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](337,87,+h[f+13736>>3]*+h[e+8816>>3]- +h[f+13720>>3]*+h[e+8808>>3],1059,d);se[c[(d+8|0)>>2]&3](338,65,1.0,1060,d);se[c[(d+8|0)>>2]&3](338,66,-1.0,1061,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](338,87,+h[e+13736>>3]*+h[f+12544>>3]- +h[e+13720>>3]*+h[f+12536>>3],1062,d);se[c[(d+8|0)>>2]&3](339,64,1.0,1063,d);se[c[(d+8|0)>>2]&3](339,65,-1.0,1064,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](339,87,+h[f+13296>>3]*+h[e+18568>>3]- +h[f+13280>>3]*+h[e+18560>>3],1065,d);se[c[(d+8|0)>>2]&3](340,63,1.0,1066,d);se[c[(d+8|0)>>2]&3](340,64,-1.0,1067,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](340,87,+h[e+13088>>3]*+h[f+17992>>3]- +h[e+13072>>3]*+h[f+17984>>3],1068,d);se[c[(d+8|0)>>2]&3](341,62,1.0,1069,d);se[c[(d+8|0)>>2]&3](341,63,-1.0,1070,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](341,87,+h[f+13088>>3]*+h[e+16024>>3]- +h[f+13072>>3]*+h[e+16016>>3],1071,d);se[c[(d+8|0)>>2]&3](342,61,1.0,1072,d);se[c[(d+8|0)>>2]&3](342,62,-1.0,1073,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](342,87,+h[e+13088>>3]*+h[f+17216>>3]- +h[e+13072>>3]*+h[f+17208>>3],1074,d);se[c[(d+8|0)>>2]&3](343,60,1.0,1075,d);se[c[(d+8|0)>>2]&3](343,61,-1.0,1076,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](343,87,+h[f+13088>>3]*+h[e+15224>>3]- +h[f+13072>>3]*+h[e+15216>>3],1077,d);se[c[(d+8|0)>>2]&3](344,59,1.0,1078,d);se[c[(d+8|0)>>2]&3](344,60,-1.0,1079,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](344,87,+h[e+13088>>3]*+h[f+18952>>3]- +h[e+13072>>3]*+h[f+18944>>3],1080,d);se[c[(d+8|0)>>2]&3](345,58,1.0,1081,d);se[c[(d+8|0)>>2]&3](345,59,-1.0,1082,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](345,87,+h[f+12648>>3]*+h[e+24976>>3]- +h[f+12632>>3]*+h[e+24968>>3],1083,d);se[c[(d+8|0)>>2]&3](346,57,1.0,1084,d);se[c[(d+8|0)>>2]&3](346,58,-1.0,1085,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](346,87,+h[e+12440>>3]*+h[f+24400>>3]- +h[e+12424>>3]*+h[f+24392>>3],1086,d);se[c[(d+8|0)>>2]&3](347,56,1.0,1087,d);se[c[(d+8|0)>>2]&3](347,57,-1.0,1088,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](347,87,+h[f+12440>>3]*+h[e+22432>>3]- +h[f+12424>>3]*+h[e+22424>>3],1089,d);se[c[(d+8|0)>>2]&3](348,55,1.0,1090,d);se[c[(d+8|0)>>2]&3](348,56,-1.0,1091,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](348,87,+h[e+12440>>3]*+h[f+23624>>3]- +h[e+12424>>3]*+h[f+23616>>3],1092,d);se[c[(d+8|0)>>2]&3](349,54,1.0,1093,d);se[c[(d+8|0)>>2]&3](349,55,-1.0,1094,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](349,87,+h[f+12440>>3]*+h[e+21632>>3]- +h[f+12424>>3]*+h[e+21624>>3],1095,d);se[c[(d+8|0)>>2]&3](350,53,1.0,1096,d);se[c[(d+8|0)>>2]&3](350,54,-1.0,1097,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](350,87,+h[e+12440>>3]*+h[f+25360>>3]- +h[e+12424>>3]*+h[f+25352>>3],1098,d);se[c[(d+8|0)>>2]&3](351,52,1.0,1099,d);se[c[(d+8|0)>>2]&3](351,53,-1.0,1100,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](351,87,+h[f+12e3>>3]*+h[e+31384>>3]- +h[f+11984>>3]*+h[e+31376>>3],1101,d);se[c[(d+8|0)>>2]&3](352,51,1.0,1102,d);se[c[(d+8|0)>>2]&3](352,52,-1.0,1103,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](352,87,+h[e+11792>>3]*+h[f+30808>>3]- +h[e+11776>>3]*+h[f+30800>>3],1104,d);se[c[(d+8|0)>>2]&3](353,50,1.0,1105,d);se[c[(d+8|0)>>2]&3](353,51,-1.0,1106,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](353,87,+h[f+11792>>3]*+h[e+28840>>3]- +h[f+11776>>3]*+h[e+28832>>3],1107,d);se[c[(d+8|0)>>2]&3](354,49,1.0,1108,d);se[c[(d+8|0)>>2]&3](354,50,-1.0,1109,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](354,87,+h[e+11792>>3]*+h[f+30032>>3]- +h[e+11776>>3]*+h[f+30024>>3],1110,d);se[c[(d+8|0)>>2]&3](355,48,1.0,1111,d);se[c[(d+8|0)>>2]&3](355,49,-1.0,1112,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](355,87,+h[f+11792>>3]*+h[e+28040>>3]- +h[f+11776>>3]*+h[e+28032>>3],1113,d);se[c[(d+8|0)>>2]&3](356,47,1.0,1114,d);se[c[(d+8|0)>>2]&3](356,48,-1.0,1115,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](356,87,+h[e+11792>>3]*+h[f+31768>>3]- +h[e+11776>>3]*+h[f+31760>>3],1116,d);se[c[(d+8|0)>>2]&3](357,46,1.0,1117,d);se[c[(d+8|0)>>2]&3](357,47,-1.0,1118,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](357,87,+h[f+23968>>3]*+h[e+37792>>3]- +h[f+23992>>3]*+h[e+37784>>3],1119,d);se[c[(d+8|0)>>2]&3](358,45,1.0,1120,d);se[c[(d+8|0)>>2]&3](358,46,-1.0,1121,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](358,87,+h[e+11216>>3]*+h[f+37216>>3]- +h[e+11200>>3]*+h[f+37208>>3],1122,d);se[c[(d+8|0)>>2]&3](359,44,1.0,1123,d);se[c[(d+8|0)>>2]&3](359,45,-1.0,1124,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](359,87,+h[f+11216>>3]*+h[e+35248>>3]- +h[f+11200>>3]*+h[e+35240>>3],1125,d);se[c[(d+8|0)>>2]&3](360,43,1.0,1126,d);se[c[(d+8|0)>>2]&3](360,44,-1.0,1127,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](360,87,+h[e+11216>>3]*+h[f+36440>>3]- +h[e+11200>>3]*+h[f+36432>>3],1128,d);se[c[(d+8|0)>>2]&3](361,42,1.0,1129,d);se[c[(d+8|0)>>2]&3](361,44,-1.0,1130,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](361,87,+h[f+11216>>3]*+h[e+37312>>3]- +h[f+11200>>3]*+h[e+37304>>3],1131,d);se[c[(d+8|0)>>2]&3](362,41,1.0,1132,d);se[c[(d+8|0)>>2]&3](362,50,-1.0,1133,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](362,87,+h[e+11792>>3]*+h[f+30904>>3]- +h[e+11776>>3]*+h[f+30896>>3],1134,d);se[c[(d+8|0)>>2]&3](363,40,1.0,1135,d);se[c[(d+8|0)>>2]&3](363,56,-1.0,1136,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](363,87,+h[f+12440>>3]*+h[e+24496>>3]- +h[f+12424>>3]*+h[e+24488>>3],1137,d);se[c[(d+8|0)>>2]&3](364,39,1.0,1138,d);se[c[(d+8|0)>>2]&3](364,62,-1.0,1139,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](364,87,+h[e+13088>>3]*+h[f+18088>>3]- +h[e+13072>>3]*+h[f+18080>>3],1140,d);se[c[(d+8|0)>>2]&3](365,38,1.0,1141,d);se[c[(d+8|0)>>2]&3](365,70,-1.0,1142,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](365,87,+h[f+13736>>3]*+h[e+11680>>3]- +h[f+13720>>3]*+h[e+11672>>3],1143,d);se[c[(d+8|0)>>2]&3](366,37,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3],1144,d);se[c[(d+8|0)>>2]&3](366,38,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3],1145,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](366,87,+h[e+13744>>3]*(+h[e+2832>>3]- +h[e+13488>>3])+ +h[e+13736>>3]*(+h[e+2840>>3]- +h[e+13496>>3]),1146,d);se[c[(d+8|0)>>2]&3](366,366,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3],1147,d);se[c[(d+8|0)>>2]&3](366,367,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3],1148,d);se[c[(d+8|0)>>2]&3](367,26,1.0,1149,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](367,36,+h[e+23704>>3]*+h[f+7920>>3]- +h[e+23728>>3]*+h[f+7912>>3],1150,d);se[c[(d+8|0)>>2]&3](367,37,-1.0,1151,d);se[c[(d+8|0)>>2]&3](368,35,1.0,1152,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](368,36,+h[f+23696>>3]*+h[e+7920>>3]- +h[f+23720>>3]*+h[e+7912>>3],1153,d);se[c[(d+8|0)>>2]&3](368,367,-1.0,1154,d);se[c[(d+8|0)>>2]&3](369,26,-3.023782929080176,1155,d);se[c[(d+8|0)>>2]&3](369,34,1.0,1156,d);se[c[(d+8|0)>>2]&3](369,35,-5.237345664226305,1157,d);se[c[(d+8|0)>>2]&3](370,33,1.0,1158,d);se[c[(d+8|0)>>2]&3](370,34,1.0,1159,d);se[c[(d+8|0)>>2]&3](371,31,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24312>>3],1160,d);se[c[(d+8|0)>>2]&3](371,32,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24336>>3],1161,d);se[c[(d+8|0)>>2]&3](371,33,1.0,1162,d);se[c[(d+8|0)>>2]&3](372,25,-1.0,1163,d);se[c[(d+8|0)>>2]&3](372,31,+h[(c[(b+416|0)>>2]|0)+7920>>3],1164,d);se[c[(d+8|0)>>2]&3](372,32,-+h[(c[(b+416|0)>>2]|0)+7912>>3],1165,d);se[c[(d+8|0)>>2]&3](373,24,1.0,1166,d);se[c[(d+8|0)>>2]&3](373,30,1.0,1167,d);se[c[(d+8|0)>>2]&3](373,32,-1.0,1168,d);se[c[(d+8|0)>>2]&3](374,29,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9536>>3],1169,d);se[c[(d+8|0)>>2]&3](374,30,1.0,1170,d);se[c[(d+8|0)>>2]&3](374,370,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9560>>3],1171,d);se[c[(d+8|0)>>2]&3](375,28,-1.0,1172,d);se[c[(d+8|0)>>2]&3](375,29,-+h[(c[(b+416|0)>>2]|0)+11680>>3],1173,d);se[c[(d+8|0)>>2]&3](375,370,+h[(c[(b+416|0)>>2]|0)+11672>>3],1174,d);se[c[(d+8|0)>>2]&3](376,27,.8660254037844387,1175,d);se[c[(d+8|0)>>2]&3](376,35,1.0,1176,d);se[c[(d+8|0)>>2]&3](377,26,1.0,1177,d);se[c[(d+8|0)>>2]&3](377,27,.4999999999999999,1178,d);se[c[(d+8|0)>>2]&3](378,24,-.09,1179,d);se[c[(d+8|0)>>2]&3](378,25,-1.0,1180,d);se[c[(d+8|0)>>2]&3](378,36,-.0088088,1181,d);se[c[(d+8|0)>>2]&3](379,24,1.0,1182,d);se[c[(d+8|0)>>2]&3](379,36,-.182952,1183,d);se[c[(d+8|0)>>2]&3](379,37,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23728>>3]*-2.0328,1184,d);se[c[(d+8|0)>>2]&3](379,367,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23720>>3]*-2.0328,1185,d);se[c[(d+8|0)>>2]&3](380,23,1.0,1186,d);se[c[(d+8|0)>>2]&3](380,71,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13736>>3]*-.77,1187,d);se[c[(d+8|0)>>2]&3](380,108,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13744>>3]*-.77,1188,d);se[c[(d+8|0)>>2]&3](381,22,1.0,1189,d);se[c[(d+8|0)>>2]&3](381,71,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13720>>3]*-.77,1190,d);se[c[(d+8|0)>>2]&3](381,87,-.03850000000000001,1191,d);se[c[(d+8|0)>>2]&3](381,108,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13728>>3]*-.77,1192,d);se[c[(d+8|0)>>2]&3](382,21,1.0,1193,d);se[c[(d+8|0)>>2]&3](382,22,-.05,1194,d);se[c[(d+8|0)>>2]&3](382,87,-.0008020833333333335,1195,d);se[c[(d+8|0)>>2]&3](383,19,.05,1196,d);se[c[(d+8|0)>>2]&3](383,20,1.0,1197,d);se[c[(d+8|0)>>2]&3](383,87,-.0008020833333333335,1198,d);se[c[(d+8|0)>>2]&3](384,18,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-.77,1199,d);se[c[(d+8|0)>>2]&3](384,19,1.0,1200,d);se[c[(d+8|0)>>2]&3](384,87,.03850000000000001,1201,d);se[c[(d+8|0)>>2]&3](384,104,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-.77,1202,d);se[c[(d+8|0)>>2]&3](385,15,-1.0,1203,d);se[c[(d+8|0)>>2]&3](385,18,1.0,1204,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](385,87,+h[e+23040>>3]*+h[f+4400>>3]- +h[e+23024>>3]*+h[f+4392>>3],1205,d);se[c[(d+8|0)>>2]&3](386,17,1.0,1206,d);se[c[(d+8|0)>>2]&3](386,18,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-.77,1207,d);se[c[(d+8|0)>>2]&3](386,104,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-.77,1208,d);se[c[(d+8|0)>>2]&3](387,15,-1.0,1209,d);se[c[(d+8|0)>>2]&3](387,16,1.0,1210,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](387,87,+h[f+23040>>3]*+h[e+5272>>3]- +h[f+23024>>3]*+h[e+5264>>3],1211,d);se[c[(d+8|0)>>2]&3](388,9,-1.0,1212,d);se[c[(d+8|0)>>2]&3](388,15,1.0,1213,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](388,87,+h[e+23040>>3]*+h[f+3208>>3]- +h[e+23024>>3]*+h[f+3200>>3],1214,d);se[c[(d+8|0)>>2]&3](389,14,1.0,1215,d);se[c[(d+8|0)>>2]&3](389,15,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-.653137112681318,1216,d);se[c[(d+8|0)>>2]&3](389,103,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-.653137112681318,1217,d);se[c[(d+8|0)>>2]&3](390,13,-1.0,1218,d);se[c[(d+8|0)>>2]&3](390,14,1.0,1219,d);se[c[(d+8|0)>>2]&3](390,394,-1.0,1220,d);se[c[(d+8|0)>>2]&3](391,12,1.0,1221,d);se[c[(d+8|0)>>2]&3](391,15,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-.653137112681318,1222,d);se[c[(d+8|0)>>2]&3](391,103,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-.653137112681318,1223,d);se[c[(d+8|0)>>2]&3](392,10,-.05,1224,d);se[c[(d+8|0)>>2]&3](392,11,1.0,1225,d);se[c[(d+8|0)>>2]&3](392,87,-.0008020833333333335,1226,d);se[c[(d+8|0)>>2]&3](393,9,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-.77,1227,d);se[c[(d+8|0)>>2]&3](393,10,1.0,1228,d);se[c[(d+8|0)>>2]&3](393,87,-.03850000000000001,1229,d);se[c[(d+8|0)>>2]&3](393,89,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-.77,1230,d);se[c[(d+8|0)>>2]&3](394,7,-1.0,1231,d);se[c[(d+8|0)>>2]&3](394,9,1.0,1232,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](394,87,+h[f+23040>>3]*+h[e+5176>>3]- +h[f+23024>>3]*+h[e+5168>>3],1233,d);se[c[(d+8|0)>>2]&3](395,8,1.0,1234,d);se[c[(d+8|0)>>2]&3](395,9,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-.77,1235,d);se[c[(d+8|0)>>2]&3](395,89,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-.77,1236,d);se[c[(d+8|0)>>2]&3](396,7,1.0,1237,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](396,87,+h[e+23896>>3]*+h[f+5752>>3]- +h[e+23880>>3]*+h[f+5744>>3],1238,d);se[c[(d+8|0)>>2]&3](397,6,1.0,1239,d);se[c[(d+8|0)>>2]&3](397,7,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23040>>3]*-1.814269757448105,1240,d);se[c[(d+8|0)>>2]&3](397,88,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23048>>3]*-1.814269757448105,1241,d);se[c[(d+8|0)>>2]&3](398,5,1.0,1242,d);se[c[(d+8|0)>>2]&3](398,7,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23024>>3]*-1.814269757448105,1243,d);se[c[(d+8|0)>>2]&3](398,88,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23032>>3]*-1.814269757448105,1244,d);se[c[(d+8|0)>>2]&3](399,4,1.0,1245,d);se[c[(d+8|0)>>2]&3](399,87,-7347792517664828.0e-20,1246,d);se[c[(d+8|0)>>2]&3](400,3,1.0,1247,d);se[c[(d+8|0)>>2]&3](400,87,-.0005669592992025331,1248,d);se[c[(d+8|0)>>2]&3](401,2,-1.0,1249,d);se[c[(d+8|0)>>2]&3](401,87,+h[(c[(b+416|0)>>2]|0)+47696>>3],1250,d);se[c[(d+8|0)>>2]&3](402,1,-.4999999999999999,1251,d);se[c[(d+8|0)>>2]&3](402,403,1.0,1252,d);se[c[(d+8|0)>>2]&3](403,0,1.0,1253,d);se[c[(d+8|0)>>2]&3](403,1,.8660254037844387,1254,d);i=a;c[a+1600>>2]=5;break a}while(0)}function _setLinearMatrixA931$1(a){a=a|0;var b=0,d=0,e=0,f=0;b=c[a+8>>2]|0;d=c[a+16>>2]|0;e=c[a+64>>2]|0;f=c[a+72>>2]|0;se[c[(d+8|0)>>2]&3](164,87,+h[e+11224>>3]*+h[f+36440>>3]- +h[e+11208>>3]*+h[f+36432>>3],524,d);se[c[(d+8|0)>>2]&3](164,239,1.0,525,d);se[c[(d+8|0)>>2]&3](164,240,-1.0,526,d);se[c[(d+8|0)>>2]&3](165,43,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-.77,527,d);se[c[(d+8|0)>>2]&3](165,238,-1.0,528,d);se[c[(d+8|0)>>2]&3](165,239,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-.77,529,d);se[c[(d+8|0)>>2]&3](166,222,1.0,530,d);se[c[(d+8|0)>>2]&3](166,237,-1.0,531,d);se[c[(d+8|0)>>2]&3](166,238,-1.0,532,d);se[c[(d+8|0)>>2]&3](167,210,1.0,533,d);se[c[(d+8|0)>>2]&3](167,236,1.0,534,d);se[c[(d+8|0)>>2]&3](167,237,1.0,535,d);se[c[(d+8|0)>>2]&3](168,224,-+h[(c[(b+416|0)>>2]|0)+35240>>3],536,d);se[c[(d+8|0)>>2]&3](168,228,-1.0,537,d);se[c[(d+8|0)>>2]&3](168,235,-1.0,538,d);se[c[(d+8|0)>>2]&3](168,236,+h[(c[(b+416|0)>>2]|0)+35248>>3],539,d);se[c[(d+8|0)>>2]&3](169,199,1.0,540,d);se[c[(d+8|0)>>2]&3](169,234,1.0,541,d);se[c[(d+8|0)>>2]&3](169,235,1.0,542,d);se[c[(d+8|0)>>2]&3](170,223,-+h[(c[(b+416|0)>>2]|0)+37208>>3],543,d);se[c[(d+8|0)>>2]&3](170,231,+h[(c[(b+416|0)>>2]|0)+37216>>3],544,d);se[c[(d+8|0)>>2]&3](170,233,-1.0,545,d);se[c[(d+8|0)>>2]&3](170,234,-1.0,546,d);se[c[(d+8|0)>>2]&3](171,3,1.0,547,d);se[c[(d+8|0)>>2]&3](171,232,-1.0,548,d);se[c[(d+8|0)>>2]&3](171,233,1.0,549,d);se[c[(d+8|0)>>2]&3](172,201,1.0,550,d);se[c[(d+8|0)>>2]&3](172,231,1.0,551,d);se[c[(d+8|0)>>2]&3](172,236,-1.0,552,d);se[c[(d+8|0)>>2]&3](173,226,-1.0,553,d);se[c[(d+8|0)>>2]&3](173,227,-+h[(c[(b+416|0)>>2]|0)+36432>>3],554,d);se[c[(d+8|0)>>2]&3](173,230,-1.0,555,d);se[c[(d+8|0)>>2]&3](173,238,+h[(c[(b+416|0)>>2]|0)+36440>>3],556,d);se[c[(d+8|0)>>2]&3](174,4,1.0,557,d);se[c[(d+8|0)>>2]&3](174,229,-1.0,558,d);se[c[(d+8|0)>>2]&3](174,230,1.0,559,d);se[c[(d+8|0)>>2]&3](175,211,1.0,560,d);se[c[(d+8|0)>>2]&3](175,228,1.0,561,d);se[c[(d+8|0)>>2]&3](175,229,1.0,562,d);se[c[(d+8|0)>>2]&3](176,43,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-.77,563,d);se[c[(d+8|0)>>2]&3](176,87,.03850000000000001,564,d);se[c[(d+8|0)>>2]&3](176,227,-1.0,565,d);se[c[(d+8|0)>>2]&3](176,239,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-.77,566,d);se[c[(d+8|0)>>2]&3](177,87,-.0008020833333333335,567,d);se[c[(d+8|0)>>2]&3](177,226,-1.0,568,d);se[c[(d+8|0)>>2]&3](177,227,-.05,569,d);se[c[(d+8|0)>>2]&3](178,221,1.0,570,d);se[c[(d+8|0)>>2]&3](178,225,-1.0,571,d);se[c[(d+8|0)>>2]&3](178,227,-1.0,572,d);se[c[(d+8|0)>>2]&3](179,212,1.0,573,d);se[c[(d+8|0)>>2]&3](179,224,1.0,574,d);se[c[(d+8|0)>>2]&3](179,225,1.0,575,d);se[c[(d+8|0)>>2]&3](180,200,1.0,576,d);se[c[(d+8|0)>>2]&3](180,223,1.0,577,d);se[c[(d+8|0)>>2]&3](180,224,-1.0,578,d);se[c[(d+8|0)>>2]&3](181,44,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-.653137112681318,579,d);se[c[(d+8|0)>>2]&3](181,222,1.0,580,d);se[c[(d+8|0)>>2]&3](181,240,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-.653137112681318,581,d);se[c[(d+8|0)>>2]&3](182,44,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-.653137112681318,582,d);se[c[(d+8|0)>>2]&3](182,221,1.0,583,d);se[c[(d+8|0)>>2]&3](182,240,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-.653137112681318,584,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](183,87,+h[f+11224>>3]*+h[e+37312>>3]- +h[f+11208>>3]*+h[e+37304>>3],585,d);se[c[(d+8|0)>>2]&3](183,220,1.0,586,d);se[c[(d+8|0)>>2]&3](183,240,-1.0,587,d);se[c[(d+8|0)>>2]&3](184,42,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3],588,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](184,87,-(+h[e+11200>>3]*(+h[e+384>>3]- +h[e+11024>>3]))- +h[e+11208>>3]*(+h[e+376>>3]- +h[e+11016>>3]),589,d);se[c[(d+8|0)>>2]&3](184,202,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3],590,d);se[c[(d+8|0)>>2]&3](184,219,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3],591,d);se[c[(d+8|0)>>2]&3](184,220,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3],592,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](185,206,+h[e+23224>>3]*+h[f+33552>>3]- +h[e+23248>>3]*+h[f+33544>>3],593,d);se[c[(d+8|0)>>2]&3](185,218,1.0,594,d);se[c[(d+8|0)>>2]&3](185,219,-1.0,595,d);se[c[(d+8|0)>>2]&3](186,207,-5.237345664226305,596,d);se[c[(d+8|0)>>2]&3](186,217,1.0,597,d);se[c[(d+8|0)>>2]&3](186,218,-3.023782929080176,598,d);se[c[(d+8|0)>>2]&3](187,216,1.0,599,d);se[c[(d+8|0)>>2]&3](187,217,1.0,600,d);se[c[(d+8|0)>>2]&3](188,214,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+25144>>3],601,d);se[c[(d+8|0)>>2]&3](188,215,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+25168>>3],602,d);se[c[(d+8|0)>>2]&3](188,216,1.0,603,d);se[c[(d+8|0)>>2]&3](189,205,-1.0,604,d);se[c[(d+8|0)>>2]&3](189,214,+h[(c[(b+416|0)>>2]|0)+33552>>3],605,d);se[c[(d+8|0)>>2]&3](189,215,-+h[(c[(b+416|0)>>2]|0)+33544>>3],606,d);se[c[(d+8|0)>>2]&3](190,203,1.0,607,d);se[c[(d+8|0)>>2]&3](190,213,1.0,608,d);se[c[(d+8|0)>>2]&3](190,214,-1.0,609,d);se[c[(d+8|0)>>2]&3](191,210,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10552>>3],610,d);se[c[(d+8|0)>>2]&3](191,212,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10576>>3],611,d);se[c[(d+8|0)>>2]&3](191,213,1.0,612,d);se[c[(d+8|0)>>2]&3](192,210,-+h[(c[(b+416|0)>>2]|0)+37312>>3],613,d);se[c[(d+8|0)>>2]&3](192,211,-1.0,614,d);se[c[(d+8|0)>>2]&3](192,212,+h[(c[(b+416|0)>>2]|0)+37304>>3],615,d);se[c[(d+8|0)>>2]&3](193,209,1.0,616,d);se[c[(d+8|0)>>2]&3](193,210,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10560>>3],617,d);se[c[(d+8|0)>>2]&3](193,212,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10584>>3],618,d);se[c[(d+8|0)>>2]&3](194,204,1.0,619,d);se[c[(d+8|0)>>2]&3](194,209,1.0,620,d);se[c[(d+8|0)>>2]&3](194,215,-1.0,621,d);se[c[(d+8|0)>>2]&3](195,208,.4999999999999999,622,d);se[c[(d+8|0)>>2]&3](195,218,1.0,623,d);se[c[(d+8|0)>>2]&3](196,207,1.0,624,d);se[c[(d+8|0)>>2]&3](196,208,.8660254037844387,625,d);se[c[(d+8|0)>>2]&3](197,202,-1.0,626,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](197,206,+h[f+23216>>3]*+h[e+33552>>3]- +h[f+23240>>3]*+h[e+33544>>3],627,d);se[c[(d+8|0)>>2]&3](197,207,1.0,628,d);se[c[(d+8|0)>>2]&3](198,204,-.09,629,d);se[c[(d+8|0)>>2]&3](198,205,-1.0,630,d);se[c[(d+8|0)>>2]&3](198,206,-.008808799999999999,631,d);se[c[(d+8|0)>>2]&3](199,202,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23240>>3]*-2.0328,632,d);se[c[(d+8|0)>>2]&3](199,204,1.0,633,d);se[c[(d+8|0)>>2]&3](199,206,-.182952,634,d);se[c[(d+8|0)>>2]&3](199,219,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23248>>3]*-2.0328,635,d);se[c[(d+8|0)>>2]&3](200,202,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23216>>3]*-2.0328,636,d);se[c[(d+8|0)>>2]&3](200,203,1.0,637,d);se[c[(d+8|0)>>2]&3](200,219,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23224>>3]*-2.0328,638,d);se[c[(d+8|0)>>2]&3](201,42,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3],639,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](201,87,+h[e+11224>>3]*(+h[e+376>>3]- +h[e+11016>>3])+ +h[e+11216>>3]*(+h[e+384>>3]- +h[e+11024>>3]),640,d);se[c[(d+8|0)>>2]&3](201,202,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3],641,d);se[c[(d+8|0)>>2]&3](201,219,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3],642,d);se[c[(d+8|0)>>2]&3](201,220,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3],643,d);se[c[(d+8|0)>>2]&3](202,45,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11216>>3]*-.77,644,d);se[c[(d+8|0)>>2]&3](202,201,1.0,645,d);se[c[(d+8|0)>>2]&3](202,241,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11224>>3]*-.77,646,d);se[c[(d+8|0)>>2]&3](203,45,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11200>>3]*-.77,647,d);se[c[(d+8|0)>>2]&3](203,87,-.03850000000000001,648,d);se[c[(d+8|0)>>2]&3](203,200,1.0,649,d);se[c[(d+8|0)>>2]&3](203,241,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11208>>3]*-.77,650,d);se[c[(d+8|0)>>2]&3](204,87,-.0008020833333333335,651,d);se[c[(d+8|0)>>2]&3](204,199,1.0,652,d);se[c[(d+8|0)>>2]&3](204,200,-.05,653,d);se[c[(d+8|0)>>2]&3](205,49,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-.77,654,d);se[c[(d+8|0)>>2]&3](205,198,1.0,655,d);se[c[(d+8|0)>>2]&3](205,346,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-.77,656,d);se[c[(d+8|0)>>2]&3](206,49,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-.77,657,d);se[c[(d+8|0)>>2]&3](206,87,.03850000000000001,658,d);se[c[(d+8|0)>>2]&3](206,197,1.0,659,d);se[c[(d+8|0)>>2]&3](206,346,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-.77,660,d);se[c[(d+8|0)>>2]&3](207,87,-.0008020833333333335,661,d);se[c[(d+8|0)>>2]&3](207,196,1.0,662,d);se[c[(d+8|0)>>2]&3](207,197,.05,663,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](208,87,+h[e+11800>>3]*+h[f+30904>>3]- +h[e+11784>>3]*+h[f+30896>>3],664,d);se[c[(d+8|0)>>2]&3](208,195,1.0,665,d);se[c[(d+8|0)>>2]&3](208,347,-1.0,666,d);se[c[(d+8|0)>>2]&3](209,41,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3],667,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](209,87,-(+h[f+11776>>3]*(+h[f+984>>3]- +h[f+11552>>3]))- +h[f+11784>>3]*(+h[f+976>>3]- +h[f+11544>>3]),668,d);se[c[(d+8|0)>>2]&3](209,193,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3],669,d);se[c[(d+8|0)>>2]&3](209,194,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3],670,d);se[c[(d+8|0)>>2]&3](209,195,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3],671,d);se[c[(d+8|0)>>2]&3](210,41,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3],672,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](210,87,+h[f+11800>>3]*(+h[f+976>>3]- +h[f+11544>>3])+ +h[f+11792>>3]*(+h[f+984>>3]- +h[f+11552>>3]),673,d);se[c[(d+8|0)>>2]&3](210,193,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3],674,d);se[c[(d+8|0)>>2]&3](210,194,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3],675,d);se[c[(d+8|0)>>2]&3](210,195,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3],676,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](211,180,+h[f+23344>>3]*+h[e+27144>>3]- +h[f+23368>>3]*+h[e+27136>>3],677,d);se[c[(d+8|0)>>2]&3](211,192,1.0,678,d);se[c[(d+8|0)>>2]&3](211,193,-1.0,679,d);se[c[(d+8|0)>>2]&3](212,181,-5.237345664226305,680,d);se[c[(d+8|0)>>2]&3](212,191,1.0,681,d);se[c[(d+8|0)>>2]&3](212,192,3.023782929080176,682,d);se[c[(d+8|0)>>2]&3](213,190,1.0,683,d);se[c[(d+8|0)>>2]&3](213,191,1.0,684,d);se[c[(d+8|0)>>2]&3](214,188,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24936>>3],685,d);se[c[(d+8|0)>>2]&3](214,189,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24960>>3],686,d);se[c[(d+8|0)>>2]&3](214,190,1.0,687,d);se[c[(d+8|0)>>2]&3](215,178,-1.0,688,d);se[c[(d+8|0)>>2]&3](215,188,+h[(c[(b+416|0)>>2]|0)+27144>>3],689,d);se[c[(d+8|0)>>2]&3](215,189,-+h[(c[(b+416|0)>>2]|0)+27136>>3],690,d);se[c[(d+8|0)>>2]&3](216,177,1.0,691,d);se[c[(d+8|0)>>2]&3](216,187,1.0,692,d);se[c[(d+8|0)>>2]&3](216,188,-1.0,693,d);se[c[(d+8|0)>>2]&3](217,185,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10320>>3],694,d);se[c[(d+8|0)>>2]&3](217,186,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10296>>3],695,d);se[c[(d+8|0)>>2]&3](217,187,1.0,696,d);se[c[(d+8|0)>>2]&3](218,183,1.0,697,d);se[c[(d+8|0)>>2]&3](218,185,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10328>>3],698,d);se[c[(d+8|0)>>2]&3](218,186,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10304>>3],699,d);se[c[(d+8|0)>>2]&3](219,184,-1.0,700,d);se[c[(d+8|0)>>2]&3](219,185,+h[(c[(b+416|0)>>2]|0)+30896>>3],701,d);se[c[(d+8|0)>>2]&3](219,186,-+h[(c[(b+416|0)>>2]|0)+30904>>3],702,d);se[c[(d+8|0)>>2]&3](220,179,1.0,703,d);se[c[(d+8|0)>>2]&3](220,183,1.0,704,d);se[c[(d+8|0)>>2]&3](220,189,-1.0,705,d);se[c[(d+8|0)>>2]&3](221,182,-.4999999999999999,706,d);se[c[(d+8|0)>>2]&3](221,192,1.0,707,d);se[c[(d+8|0)>>2]&3](222,181,1.0,708,d);se[c[(d+8|0)>>2]&3](222,182,.8660254037844387,709,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](223,180,+h[e+23336>>3]*+h[f+27144>>3]- +h[e+23360>>3]*+h[f+27136>>3],710,d);se[c[(d+8|0)>>2]&3](223,181,1.0,711,d);se[c[(d+8|0)>>2]&3](223,194,-1.0,712,d);se[c[(d+8|0)>>2]&3](224,179,1.0,713,d);se[c[(d+8|0)>>2]&3](224,180,-.182952,714,d);se[c[(d+8|0)>>2]&3](224,193,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23368>>3]*-2.0328,715,d);se[c[(d+8|0)>>2]&3](224,194,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23360>>3]*-2.0328,716,d);se[c[(d+8|0)>>2]&3](225,178,-1.0,717,d);se[c[(d+8|0)>>2]&3](225,179,-.09,718,d);se[c[(d+8|0)>>2]&3](225,180,-.008808799999999999,719,d);se[c[(d+8|0)>>2]&3](226,177,1.0,720,d);se[c[(d+8|0)>>2]&3](226,193,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23344>>3]*-2.0328,721,d);se[c[(d+8|0)>>2]&3](226,194,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23336>>3]*-2.0328,722,d);se[c[(d+8|0)>>2]&3](227,50,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-.653137112681318,723,d);se[c[(d+8|0)>>2]&3](227,176,1.0,724,d);se[c[(d+8|0)>>2]&3](227,347,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-.653137112681318,725,d);se[c[(d+8|0)>>2]&3](228,50,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-.653137112681318,726,d);se[c[(d+8|0)>>2]&3](228,175,1.0,727,d);se[c[(d+8|0)>>2]&3](228,347,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-.653137112681318,728,d);se[c[(d+8|0)>>2]&3](229,51,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-.77,729,d);se[c[(d+8|0)>>2]&3](229,174,1.0,730,d);se[c[(d+8|0)>>2]&3](229,348,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-.77,731,d);se[c[(d+8|0)>>2]&3](230,51,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-.77,732,d);se[c[(d+8|0)>>2]&3](230,87,-.03850000000000001,733,d);se[c[(d+8|0)>>2]&3](230,173,1.0,734,d);se[c[(d+8|0)>>2]&3](230,348,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-.77,735,d);se[c[(d+8|0)>>2]&3](231,87,-.0008020833333333335,736,d);se[c[(d+8|0)>>2]&3](231,172,1.0,737,d);se[c[(d+8|0)>>2]&3](231,173,-.05,738,d);se[c[(d+8|0)>>2]&3](232,52,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11792>>3]*-1.814269757448105,739,d);se[c[(d+8|0)>>2]&3](232,171,1.0,740,d);se[c[(d+8|0)>>2]&3](232,349,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11800>>3]*-1.814269757448105,741,d);se[c[(d+8|0)>>2]&3](233,52,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11776>>3]*-1.814269757448105,742,d);se[c[(d+8|0)>>2]&3](233,170,1.0,743,d);se[c[(d+8|0)>>2]&3](233,349,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+11784>>3]*-1.814269757448105,744,d);se[c[(d+8|0)>>2]&3](234,55,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-.77,745,d);se[c[(d+8|0)>>2]&3](234,169,1.0,746,d);se[c[(d+8|0)>>2]&3](234,352,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-.77,747,d);se[c[(d+8|0)>>2]&3](235,55,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-.77,748,d);se[c[(d+8|0)>>2]&3](235,87,.03850000000000001,749,d);se[c[(d+8|0)>>2]&3](235,168,1.0,750,d);se[c[(d+8|0)>>2]&3](235,352,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-.77,751,d);se[c[(d+8|0)>>2]&3](236,87,-.0008020833333333335,752,d);se[c[(d+8|0)>>2]&3](236,167,1.0,753,d);se[c[(d+8|0)>>2]&3](236,168,.05,754,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](237,87,+h[f+12448>>3]*+h[e+24496>>3]- +h[f+12432>>3]*+h[e+24488>>3],755,d);se[c[(d+8|0)>>2]&3](237,166,1.0,756,d);se[c[(d+8|0)>>2]&3](237,353,-1.0,757,d);se[c[(d+8|0)>>2]&3](238,40,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3],758,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](238,87,-(+h[e+12424>>3]*(+h[e+1608>>3]- +h[e+12200>>3]))- +h[e+12432>>3]*(+h[e+1600>>3]- +h[e+12192>>3]),759,d);se[c[(d+8|0)>>2]&3](238,148,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3],760,d);se[c[(d+8|0)>>2]&3](238,165,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3],761,d);se[c[(d+8|0)>>2]&3](238,166,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3],762,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](239,152,+h[e+23464>>3]*+h[f+20736>>3]- +h[e+23488>>3]*+h[f+20728>>3],763,d);se[c[(d+8|0)>>2]&3](239,164,1.0,764,d);se[c[(d+8|0)>>2]&3](239,165,-1.0,765,d);se[c[(d+8|0)>>2]&3](240,153,-5.237345664226305,766,d);se[c[(d+8|0)>>2]&3](240,163,1.0,767,d);se[c[(d+8|0)>>2]&3](240,164,-3.023782929080176,768,d);se[c[(d+8|0)>>2]&3](241,162,1.0,769,d);se[c[(d+8|0)>>2]&3](241,163,1.0,770,d);se[c[(d+8|0)>>2]&3](242,160,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24728>>3],771,d);se[c[(d+8|0)>>2]&3](242,161,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24752>>3],772,d);se[c[(d+8|0)>>2]&3](242,162,1.0,773,d);se[c[(d+8|0)>>2]&3](243,151,-1.0,774,d);se[c[(d+8|0)>>2]&3](243,160,+h[(c[(b+416|0)>>2]|0)+20736>>3],775,d);se[c[(d+8|0)>>2]&3](243,161,-+h[(c[(b+416|0)>>2]|0)+20728>>3],776,d);se[c[(d+8|0)>>2]&3](244,149,1.0,777,d);se[c[(d+8|0)>>2]&3](244,159,1.0,778,d);se[c[(d+8|0)>>2]&3](244,160,-1.0,779,d);se[c[(d+8|0)>>2]&3](245,156,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10064>>3],780,d);se[c[(d+8|0)>>2]&3](245,158,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10040>>3],781,d);se[c[(d+8|0)>>2]&3](245,159,1.0,782,d);se[c[(d+8|0)>>2]&3](246,156,+h[(c[(b+416|0)>>2]|0)+24488>>3],783,d);se[c[(d+8|0)>>2]&3](246,157,-1.0,784,d);se[c[(d+8|0)>>2]&3](246,158,-+h[(c[(b+416|0)>>2]|0)+24496>>3],785,d);se[c[(d+8|0)>>2]&3](247,155,1.0,786,d);se[c[(d+8|0)>>2]&3](247,156,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10072>>3],787,d);se[c[(d+8|0)>>2]&3](247,158,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+10048>>3],788,d);se[c[(d+8|0)>>2]&3](248,150,1.0,789,d);se[c[(d+8|0)>>2]&3](248,155,1.0,790,d);se[c[(d+8|0)>>2]&3](248,161,-1.0,791,d);se[c[(d+8|0)>>2]&3](249,154,.4999999999999999,792,d);se[c[(d+8|0)>>2]&3](249,164,1.0,793,d);se[c[(d+8|0)>>2]&3](250,153,1.0,794,d);se[c[(d+8|0)>>2]&3](250,154,.8660254037844387,795,d);se[c[(d+8|0)>>2]&3](251,148,-1.0,796,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](251,152,+h[f+23456>>3]*+h[e+20736>>3]- +h[f+23480>>3]*+h[e+20728>>3],797,d);se[c[(d+8|0)>>2]&3](251,153,1.0,798,d);se[c[(d+8|0)>>2]&3](252,150,-.09,799,d);se[c[(d+8|0)>>2]&3](252,151,-1.0,800,d);se[c[(d+8|0)>>2]&3](252,152,-.008808799999999999,801,d);se[c[(d+8|0)>>2]&3](253,148,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23480>>3]*-2.0328,802,d);se[c[(d+8|0)>>2]&3](253,150,1.0,803,d);se[c[(d+8|0)>>2]&3](253,152,-.182952,804,d);se[c[(d+8|0)>>2]&3](253,165,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23488>>3]*-2.0328,805,d);se[c[(d+8|0)>>2]&3](254,148,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23456>>3]*-2.0328,806,d);se[c[(d+8|0)>>2]&3](254,149,1.0,807,d);se[c[(d+8|0)>>2]&3](254,165,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23464>>3]*-2.0328,808,d);se[c[(d+8|0)>>2]&3](255,40,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3],809,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](255,87,+h[e+12448>>3]*(+h[e+1600>>3]- +h[e+12192>>3])+ +h[e+12440>>3]*(+h[e+1608>>3]- +h[e+12200>>3]),810,d);se[c[(d+8|0)>>2]&3](255,148,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3],811,d);se[c[(d+8|0)>>2]&3](255,165,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3],812,d);se[c[(d+8|0)>>2]&3](255,166,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3],813,d);se[c[(d+8|0)>>2]&3](256,56,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-.653137112681318,814,d);se[c[(d+8|0)>>2]&3](256,147,1.0,815,d);se[c[(d+8|0)>>2]&3](256,353,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-.653137112681318,816,d);se[c[(d+8|0)>>2]&3](257,56,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-.653137112681318,817,d);se[c[(d+8|0)>>2]&3](257,146,1.0,818,d);se[c[(d+8|0)>>2]&3](257,353,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-.653137112681318,819,d);se[c[(d+8|0)>>2]&3](258,57,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-.77,820,d);se[c[(d+8|0)>>2]&3](258,145,1.0,821,d);se[c[(d+8|0)>>2]&3](258,354,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-.77,822,d);se[c[(d+8|0)>>2]&3](259,57,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-.77,823,d);se[c[(d+8|0)>>2]&3](259,87,-.03850000000000001,824,d);se[c[(d+8|0)>>2]&3](259,144,1.0,825,d);se[c[(d+8|0)>>2]&3](259,354,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-.77,826,d);se[c[(d+8|0)>>2]&3](260,87,-.0008020833333333335,827,d);se[c[(d+8|0)>>2]&3](260,143,1.0,828,d);se[c[(d+8|0)>>2]&3](260,144,-.05,829,d);se[c[(d+8|0)>>2]&3](261,58,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12440>>3]*-1.814269757448105,830,d);se[c[(d+8|0)>>2]&3](261,142,1.0,831,d);se[c[(d+8|0)>>2]&3](261,355,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12448>>3]*-1.814269757448105,832,d);se[c[(d+8|0)>>2]&3](262,58,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12424>>3]*-1.814269757448105,833,d);se[c[(d+8|0)>>2]&3](262,141,1.0,834,d);se[c[(d+8|0)>>2]&3](262,355,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+12432>>3]*-1.814269757448105,835,d);se[c[(d+8|0)>>2]&3](263,61,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-.77,836,d);se[c[(d+8|0)>>2]&3](263,140,1.0,837,d);se[c[(d+8|0)>>2]&3](263,358,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-.77,838,d);se[c[(d+8|0)>>2]&3](264,61,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-.77,839,d);se[c[(d+8|0)>>2]&3](264,87,.03850000000000001,840,d);se[c[(d+8|0)>>2]&3](264,139,1.0,841,d);se[c[(d+8|0)>>2]&3](264,358,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3]*-.77,842,d);se[c[(d+8|0)>>2]&3](265,87,-.0008020833333333335,843,d);se[c[(d+8|0)>>2]&3](265,138,1.0,844,d);se[c[(d+8|0)>>2]&3](265,139,.05,845,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](266,87,+h[e+13096>>3]*+h[f+18088>>3]- +h[e+13080>>3]*+h[f+18080>>3],846,d);se[c[(d+8|0)>>2]&3](266,137,1.0,847,d);se[c[(d+8|0)>>2]&3](266,359,-1.0,848,d);se[c[(d+8|0)>>2]&3](267,39,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3],849,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](267,87,-(+h[f+13072>>3]*(+h[f+2232>>3]- +h[f+12848>>3]))- +h[f+13080>>3]*(+h[f+2224>>3]- +h[f+12840>>3]),850,d);se[c[(d+8|0)>>2]&3](267,119,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3],851,d);se[c[(d+8|0)>>2]&3](267,136,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3],852,d);se[c[(d+8|0)>>2]&3](267,137,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3],853,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;e=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](268,123,+h[f+23576>>3]*+h[e+14328>>3]- +h[f+23600>>3]*+h[e+14320>>3],854,d);se[c[(d+8|0)>>2]&3](268,135,1.0,855,d);se[c[(d+8|0)>>2]&3](268,136,-1.0,856,d);se[c[(d+8|0)>>2]&3](269,124,3.023782929080176,857,d);se[c[(d+8|0)>>2]&3](269,134,1.0,858,d);se[c[(d+8|0)>>2]&3](269,135,-5.237345664226305,859,d);se[c[(d+8|0)>>2]&3](270,133,1.0,860,d);se[c[(d+8|0)>>2]&3](270,134,1.0,861,d);se[c[(d+8|0)>>2]&3](271,131,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24520>>3],862,d);se[c[(d+8|0)>>2]&3](271,132,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+24544>>3],863,d);se[c[(d+8|0)>>2]&3](271,133,1.0,864,d);se[c[(d+8|0)>>2]&3](272,122,-1.0,865,d);se[c[(d+8|0)>>2]&3](272,131,+h[(c[(b+416|0)>>2]|0)+14328>>3],866,d);se[c[(d+8|0)>>2]&3](272,132,-+h[(c[(b+416|0)>>2]|0)+14320>>3],867,d);se[c[(d+8|0)>>2]&3](273,120,1.0,868,d);se[c[(d+8|0)>>2]&3](273,130,1.0,869,d);se[c[(d+8|0)>>2]&3](273,131,-1.0,870,d);se[c[(d+8|0)>>2]&3](274,127,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9784>>3],871,d);se[c[(d+8|0)>>2]&3](274,129,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9808>>3],872,d);se[c[(d+8|0)>>2]&3](274,130,1.0,873,d);se[c[(d+8|0)>>2]&3](275,127,-+h[(c[(b+416|0)>>2]|0)+18088>>3],874,d);se[c[(d+8|0)>>2]&3](275,128,-1.0,875,d);se[c[(d+8|0)>>2]&3](275,129,+h[(c[(b+416|0)>>2]|0)+18080>>3],876,d);se[c[(d+8|0)>>2]&3](276,126,1.0,877,d);se[c[(d+8|0)>>2]&3](276,127,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9792>>3],878,d);se[c[(d+8|0)>>2]&3](276,129,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+9816>>3],879,d);se[c[(d+8|0)>>2]&3](277,121,1.0,880,d);se[c[(d+8|0)>>2]&3](277,126,1.0,881,d);se[c[(d+8|0)>>2]&3](277,132,-1.0,882,d);se[c[(d+8|0)>>2]&3](278,125,.8660254037844387,883,d);se[c[(d+8|0)>>2]&3](278,135,1.0,884,d);se[c[(d+8|0)>>2]&3](279,124,1.0,885,d);se[c[(d+8|0)>>2]&3](279,125,-.4999999999999999,886,d);se[c[(d+8|0)>>2]&3](280,119,-1.0,887,d);e=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;f=c[(b+416|0)>>2]|0;se[c[(d+8|0)>>2]&3](280,123,+h[e+23584>>3]*+h[f+14328>>3]- +h[e+23608>>3]*+h[f+14320>>3],888,d);se[c[(d+8|0)>>2]&3](280,124,1.0,889,d);se[c[(d+8|0)>>2]&3](281,121,-.09,890,d);se[c[(d+8|0)>>2]&3](281,122,-1.0,891,d);se[c[(d+8|0)>>2]&3](281,123,-.008808799999999999,892,d);se[c[(d+8|0)>>2]&3](282,119,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23608>>3]*-2.0328,893,d);se[c[(d+8|0)>>2]&3](282,121,1.0,894,d);se[c[(d+8|0)>>2]&3](282,123,-.182952,895,d);se[c[(d+8|0)>>2]&3](282,136,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23600>>3]*-2.0328,896,d);se[c[(d+8|0)>>2]&3](283,119,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23584>>3]*-2.0328,897,d);se[c[(d+8|0)>>2]&3](283,120,1.0,898,d);se[c[(d+8|0)>>2]&3](283,136,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+23576>>3]*-2.0328,899,d);se[c[(d+8|0)>>2]&3](284,39,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3],900,d);f=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;se[c[(d+8|0)>>2]&3](284,87,+h[f+13096>>3]*(+h[f+2224>>3]- +h[f+12840>>3])+ +h[f+13088>>3]*(+h[f+2232>>3]- +h[f+12848>>3]),901,d);se[c[(d+8|0)>>2]&3](284,119,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3],902,d);se[c[(d+8|0)>>2]&3](284,136,-+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3],903,d);se[c[(d+8|0)>>2]&3](284,137,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13080>>3],904,d);se[c[(d+8|0)>>2]&3](285,62,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13088>>3]*-.653137112681318,905,d);se[c[(d+8|0)>>2]&3](285,118,1.0,906,d);se[c[(d+8|0)>>2]&3](285,359,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13096>>3]*-.653137112681318,907,d);se[c[(d+8|0)>>2]&3](286,62,+h[(c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0)+13072>>3]*-.653137112681318,908,d);}function _setLinearVectorb931$0(a){a=a|0;var b=0,d=0,e=0,f=0.0,j=0.0,k=0.0,l=0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0;b=c[a+8>>2]|0;d=c[a+16>>2]|0;e=c[a+224>>2]|0;f=+g[a+256>>2];j=+g[a+264>>2];k=+g[a+280>>2];l=c[a+288>>2]|0;m=c[a+1896>>2]|0;n=c[a+1912>>2]|0;a:do{h[l+2136>>3]=f*(j+k)+f*(j+(k-f*(+h[(e+13096|0)>>3]*(+h[e+2224>>3]- +h[e+12840>>3])+ +h[e+13088>>3]*(+h[e+2232>>3]- +h[e+12848>>3]))));o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;p=+h[(o+12752|0)>>3];q=c[(b+416|0)>>2]|0;h[l+2144>>3]=+h[(o+23576|0)>>3]*p*+h[(q+14320|0)>>3]*-p+ +h[(o+23600|0)>>3]*p*+h[(q+14328|0)>>3]*-p;h[l+2152>>3]=+h[(q+38584|0)>>3]*5.237345664226305;h[l+2160>>3]=-+h[o+26392>>3];h[l+2168>>3]=0.0;h[l+2176>>3]=+h[q+41872>>3];m=l+2184|0;n=m+56|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));p=+h[(o+12752|0)>>3];h[l+2240>>3]=+h[(o+23584|0)>>3]*p*+h[(q+14320|0)>>3]*-p+ +h[o+23608>>3]*p*+h[(q+14328|0)>>3]*-p;h[l+2248>>3]=0.0;h[l+2256>>3]=+h[(o+23600|0)>>3]*+h[(q+38584|0)>>3]*2.0328;p=+h[(o+12752|0)>>3];h[l+2264>>3]=(p*p*-.09+ +h[(o+23576|0)>>3]*+h[(q+38584|0)>>3])*2.0328;p=+h[o+16>>3];r=+h[o+13096>>3]*(+h[o+12736>>3]- +h[o+13008>>3]);s=+h[o+13088>>3]*(+h[o+12744>>3]- +h[o+13016>>3]);t=c[(d+36|0)>>2]|0;h[t+2272>>3]=-(p*(r+(s+p*(+h[o+13080>>3]*(+h[o+2224>>3]- +h[o+12840>>3])+ +h[o+13072>>3]*(+h[o+2232>>3]- +h[o+12848>>3])))))-p*(r+s);u=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;v=c[(b+416|0)>>2]|0;h[t+2280>>3]=+h[(u+13096|0)>>3]*+h[(v+38584|0)>>3]*.653137112681318;h[t+2288>>3]=+h[(u+13080|0)>>3]*+h[(v+38584|0)>>3]*.653137112681318;s=+h[(u+16|0)>>3];h[t+2296>>3]=(s*s*-.05+ +h[(u+13096|0)>>3]*+h[(v+38584|0)>>3])*.77;h[t+2304>>3]=+h[(u+13080|0)>>3]*+h[(v+38584|0)>>3]*.77;h[t+2312>>3]=0.0;h[t+2320>>3]=+h[(u+13096|0)>>3]*+h[(v+38584|0)>>3]*1.814269757448105;h[t+2328>>3]=+h[(u+13080|0)>>3]*+h[(v+38584|0)>>3]*1.814269757448105;s=+h[(u+16|0)>>3];h[t+2336>>3]=(s*s*.05+ +h[(u+13744|0)>>3]*+h[(v+38584|0)>>3])*.77;h[t+2344>>3]=+h[(u+13728|0)>>3]*+h[(v+38584|0)>>3]*.77;h[t+2352>>3]=0.0;s=+h[(u+16|0)>>3];h[t+2360>>3]=+h[(u+13744|0)>>3]*s*+h[v+9608>>3]*-s+ +h[(u+13728|0)>>3]*s*+h[v+9616>>3]*-s;s=+h[(u+16|0)>>3];t=c[(d+36|0)>>2]|0;h[t+2368>>3]=+h[(u+13744|0)>>3]*s*+h[v+11576>>3]*-s+ +h[(u+13728|0)>>3]*s*+h[v+11584>>3]*-s;v=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[(v+16|0)>>3];u=c[(b+416|0)>>2]|0;h[t+2376>>3]=+h[v+13952>>3]*s*+h[u+12152>>3]*-s+ +h[v+13936>>3]*s*+h[u+12160>>3]*-s;s=+h[(v+16|0)>>3];h[t+2384>>3]=+h[(v+23048|0)>>3]*s*+h[u+6128>>3]*-s+ +h[(v+23032|0)>>3]*s*+h[u+6136>>3]*-s;s=+h[(v+16|0)>>3];h[t+2392>>3]=+h[(v+23048|0)>>3]*s*+h[u+2400>>3]*-s+ +h[(v+23032|0)>>3]*s*+h[u+2408>>3]*-s;s=+h[(v+16|0)>>3];h[t+2400>>3]=+h[(v+23048|0)>>3]*s*+h[u+4392>>3]*-s+ +h[(v+23032|0)>>3]*s*+h[u+4400>>3]*-s;s=+h[(v+16|0)>>3];h[t+2408>>3]=+h[(v+23048|0)>>3]*s*+h[u+5264>>3]*-s+ +h[(v+23032|0)>>3]*s*+h[u+5272>>3]*-s;s=+h[(v+16|0)>>3];r=+h[(v+23032|0)>>3]*(+h[v+14032>>3]- +h[v+14160>>3]);p=+h[v+23024>>3]*(+h[v+14040>>3]- +h[v+14168>>3]);u=c[(d+36|0)>>2]|0;h[u+2416>>3]=s*(r+p)+s*(r+(p-s*(+h[(v+23048|0)>>3]*(+h[v+3408>>3]- +h[v+14768>>3])+ +h[v+23040>>3]*(+h[v+3416>>3]- +h[v+14776>>3]))));v=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[(v+14048|0)>>3];t=c[(b+416|0)>>2]|0;h[u+2424>>3]=+h[(v+23840|0)>>3]*s*+h[t+1504>>3]*-s+ +h[(v+23864|0)>>3]*s*+h[t+1512>>3]*-s;h[u+2432>>3]=0.0;h[u+2440>>3]=+h[t+38912>>3];m=u+2448|0;n=m+40|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));h[u+2488>>3]=+h[(v+23864|0)>>3]*+h[(t+38584|0)>>3]*2.0328;s=+h[(v+14048|0)>>3];h[u+2496>>3]=(s*s*-.09+ +h[(v+23840|0)>>3]*+h[(t+38584|0)>>3])*2.0328;s=+h[v+16>>3];p=+h[v+23048>>3]*(+h[v+14032>>3]- +h[v+14160>>3]);r=+h[v+23040>>3]*(+h[v+14040>>3]- +h[v+14168>>3]);o=c[(d+36|0)>>2]|0;h[o+2504>>3]=-(s*(p+(r+s*(+h[v+23032>>3]*(+h[v+3408>>3]- +h[v+14768>>3])+ +h[v+23024>>3]*(+h[v+3416>>3]- +h[v+14776>>3])))))-s*(p+r);q=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(q+16|0)>>3];w=c[(b+416|0)>>2]|0;h[o+2512>>3]=+h[(q+23048|0)>>3]*r*+h[w+3200>>3]*-r+ +h[(q+23032|0)>>3]*r*+h[w+3208>>3]*-r;r=+h[(q+16|0)>>3];h[o+2520>>3]=+h[(q+23048|0)>>3]*r*+h[w+5168>>3]*-r+ +h[(q+23032|0)>>3]*r*+h[w+5176>>3]*-r;r=+h[(q+16|0)>>3];h[o+2528>>3]=+h[q+23904>>3]*r*+h[w+5744>>3]*-r+ +h[q+23888>>3]*r*+h[w+5752>>3]*-r;m=o+2536|0;n=m+80|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));r=+h[(q+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2616>>3]=+h[(q+23040|0)>>3]*r*+h[w+2400>>3]*-r+ +h[q+23024>>3]*r*+h[w+2408>>3]*-r;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(t+16|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2624>>3]=+h[t+23040>>3]*r*+h[u+6128>>3]*-r+ +h[t+23024>>3]*r*+h[u+6136>>3]*-r;r=+h[(t+16|0)>>3];h[v+2632>>3]=+h[t+13944>>3]*r*+h[u+12152>>3]*-r+ +h[t+13928>>3]*r*+h[u+12160>>3]*-r;h[v+2640>>3]=+h[(t+13744|0)>>3]*+h[(u+38584|0)>>3]*1.814269757448105;h[v+2648>>3]=+h[t+13728>>3]*+h[(u+38584|0)>>3]*1.814269757448105;r=+h[(t+16|0)>>3];h[v+2656>>3]=+h[(t+13736|0)>>3]*r*+h[u+11576>>3]*-r+ +h[(t+13720|0)>>3]*r*+h[u+11584>>3]*-r;r=+h[(t+16|0)>>3];h[v+2664>>3]=+h[(t+13736|0)>>3]*r*+h[u+9608>>3]*-r+ +h[(t+13720|0)>>3]*r*+h[u+9616>>3]*-r;v=c[(d+36|0)>>2]|0;h[v+2672>>3]=+h[(t+13744|0)>>3]*+h[(u+38584|0)>>3]*.653137112681318;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[v+2680>>3]=+h[t+13728>>3]*+h[(u+38584|0)>>3]*.653137112681318;r=+h[(t+16|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2688>>3]=+h[(t+13736|0)>>3]*r*+h[u+10800>>3]*-r+ +h[(t+13720|0)>>3]*r*+h[u+10808>>3]*-r;r=+h[(t+16|0)>>3];h[v+2696>>3]=+h[(t+13736|0)>>3]*r*+h[u+8808>>3]*-r+ +h[(t+13720|0)>>3]*r*+h[u+8816>>3]*-r;r=+h[(t+16|0)>>3];h[v+2704>>3]=+h[(t+13736|0)>>3]*r*+h[u+12536>>3]*-r+ +h[(t+13720|0)>>3]*r*+h[u+12544>>3]*-r;r=+h[(t+16|0)>>3];h[v+2712>>3]=+h[t+13296>>3]*r*+h[u+18560>>3]*-r+ +h[t+13280>>3]*r*+h[u+18568>>3]*-r;r=+h[(t+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2720>>3]=+h[t+13088>>3]*r*+h[u+17984>>3]*-r+ +h[t+13072>>3]*r*+h[u+17992>>3]*-r;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(t+16|0)>>3];h[v+2728>>3]=+h[(t+13088|0)>>3]*r*+h[u+16016>>3]*-r+ +h[(t+13072|0)>>3]*r*+h[u+16024>>3]*-r;r=+h[(t+16|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2736>>3]=+h[(t+13088|0)>>3]*r*+h[u+17208>>3]*-r+ +h[(t+13072|0)>>3]*r*+h[u+17216>>3]*-r;r=+h[(t+16|0)>>3];h[v+2744>>3]=+h[(t+13088|0)>>3]*r*+h[u+15216>>3]*-r+ +h[(t+13072|0)>>3]*r*+h[u+15224>>3]*-r;r=+h[(t+16|0)>>3];h[v+2752>>3]=+h[(t+13088|0)>>3]*r*+h[u+18944>>3]*-r+ +h[(t+13072|0)>>3]*r*+h[u+18952>>3]*-r;r=+h[(t+16|0)>>3];h[v+2760>>3]=+h[t+12648>>3]*r*+h[u+24968>>3]*-r+ +h[t+12632>>3]*r*+h[u+24976>>3]*-r;r=+h[(t+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2768>>3]=+h[t+12440>>3]*r*+h[u+24392>>3]*-r+ +h[t+12424>>3]*r*+h[u+24400>>3]*-r;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(t+16|0)>>3];h[v+2776>>3]=+h[(t+12440|0)>>3]*r*+h[u+22424>>3]*-r+ +h[(t+12424|0)>>3]*r*+h[u+22432>>3]*-r;r=+h[(t+16|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2784>>3]=+h[(t+12440|0)>>3]*r*+h[u+23616>>3]*-r+ +h[(t+12424|0)>>3]*r*+h[u+23624>>3]*-r;r=+h[(t+16|0)>>3];h[v+2792>>3]=+h[(t+12440|0)>>3]*r*+h[u+21624>>3]*-r+ +h[(t+12424|0)>>3]*r*+h[u+21632>>3]*-r;r=+h[(t+16|0)>>3];h[v+2800>>3]=+h[(t+12440|0)>>3]*r*+h[u+25352>>3]*-r+ +h[(t+12424|0)>>3]*r*+h[u+25360>>3]*-r;r=+h[(t+16|0)>>3];h[v+2808>>3]=+h[t+12e3>>3]*r*+h[u+31376>>3]*-r+ +h[t+11984>>3]*r*+h[u+31384>>3]*-r;r=+h[(t+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2816>>3]=+h[t+11792>>3]*r*+h[u+30800>>3]*-r+ +h[t+11776>>3]*r*+h[u+30808>>3]*-r;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(t+16|0)>>3];h[v+2824>>3]=+h[(t+11792|0)>>3]*r*+h[u+28832>>3]*-r+ +h[(t+11776|0)>>3]*r*+h[u+28840>>3]*-r;r=+h[(t+16|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2832>>3]=+h[(t+11792|0)>>3]*r*+h[u+30024>>3]*-r+ +h[(t+11776|0)>>3]*r*+h[u+30032>>3]*-r;r=+h[(t+16|0)>>3];h[v+2840>>3]=+h[(t+11792|0)>>3]*r*+h[u+28032>>3]*-r+ +h[(t+11776|0)>>3]*r*+h[u+28040>>3]*-r;r=+h[(t+16|0)>>3];h[v+2848>>3]=+h[(t+11792|0)>>3]*r*+h[u+31760>>3]*-r+ +h[(t+11776|0)>>3]*r*+h[u+31768>>3]*-r;r=+h[(t+16|0)>>3];h[v+2856>>3]=+h[t+23968>>3]*r*+h[u+37784>>3]*-r+ +h[t+23992>>3]*r*+h[u+37792>>3]*-r;r=+h[(t+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2864>>3]=+h[t+11216>>3]*r*+h[u+37208>>3]*-r+ +h[t+11200>>3]*r*+h[u+37216>>3]*-r;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(t+16|0)>>3];h[v+2872>>3]=+h[(t+11216|0)>>3]*r*+h[u+35240>>3]*-r+ +h[(t+11200|0)>>3]*r*+h[u+35248>>3]*-r;r=+h[(t+16|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2880>>3]=+h[(t+11216|0)>>3]*r*+h[u+36432>>3]*-r+ +h[(t+11200|0)>>3]*r*+h[u+36440>>3]*-r;r=+h[(t+16|0)>>3];h[v+2888>>3]=+h[(t+11216|0)>>3]*r*+h[u+37304>>3]*-r+ +h[(t+11200|0)>>3]*r*+h[u+37312>>3]*-r;r=+h[(t+16|0)>>3];h[v+2896>>3]=+h[t+11792>>3]*r*+h[u+30896>>3]*-r+ +h[t+11776>>3]*r*+h[u+30904>>3]*-r;r=+h[(t+16|0)>>3];h[v+2904>>3]=+h[t+12440>>3]*r*+h[u+24488>>3]*-r+ +h[t+12424>>3]*r*+h[u+24496>>3]*-r;r=+h[(t+16|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2912>>3]=+h[t+13088>>3]*r*+h[u+18080>>3]*-r+ +h[t+13072>>3]*r*+h[u+18088>>3]*-r;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;r=+h[(t+16|0)>>3];h[v+2920>>3]=+h[(t+13736|0)>>3]*r*+h[u+11672>>3]*-r+ +h[(t+13720|0)>>3]*r*+h[u+11680>>3]*-r;r=+h[(t+16|0)>>3];p=+h[t+13744>>3]*(+h[t+13384>>3]- +h[t+13656>>3]);s=+h[(t+13736|0)>>3]*(+h[t+13392>>3]- +h[t+13664>>3]);h[v+2928>>3]=-(r*(p+(s+r*(+h[t+13728>>3]*(+h[t+2832>>3]- +h[t+13488>>3])+ +h[(t+13720|0)>>3]*(+h[t+2840>>3]- +h[t+13496>>3])))))-r*(p+s);s=+h[(t+13432|0)>>3];u=c[(b+416|0)>>2]|0;h[v+2936>>3]=+h[t+23704>>3]*s*+h[(u+7912|0)>>3]*-s+ +h[t+23728>>3]*s*+h[(u+7920|0)>>3]*-s;s=+h[(t+13432|0)>>3];v=c[(d+36|0)>>2]|0;h[v+2944>>3]=+h[t+23696>>3]*s*+h[(u+7912|0)>>3]*-s+ +h[t+23720>>3]*s*+h[(u+7920|0)>>3]*-s;h[v+2952>>3]=+h[(u+38584|0)>>3]*5.237345664226305;t=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[v+2960>>3]=-+h[t+26504>>3];h[v+2968>>3]=0.0;h[v+2976>>3]=+h[u+40392>>3];m=v+2984|0;n=m+48|0;do{c[m>>2]=0;m=m+4|0}while((m|0)<(n|0));h[v+3032>>3]=+h[(t+23720|0)>>3]*+h[(u+38584|0)>>3]*2.0328;s=+h[(t+16|0)>>3];h[v+3040>>3]=(s*s*-.05+ +h[t+13744>>3]*+h[(u+38584|0)>>3])*.77;h[v+3048>>3]=+h[t+13728>>3]*+h[(u+38584|0)>>3]*.77;c[(v+3056|0)+0>>2]=0;c[(v+3056|0)+4>>2]=0;c[(v+3056|0)+8>>2]=0;c[(v+3056|0)+12>>2]=0;h[v+3072>>3]=+h[(t+23032|0)>>3]*+h[(u+38584|0)>>3]*.77;s=+h[(t+16|0)>>3];w=c[(b+416|0)>>2]|0;h[v+3080>>3]=+h[(t+23040|0)>>3]*s*+h[w+4392>>3]*-s+ +h[(t+23024|0)>>3]*s*+h[w+4400>>3]*-s;s=+h[(t+16|0)>>3];q=c[(d+36|0)>>2]|0;h[q+3088>>3]=(s*s*.05+ +h[t+23048>>3]*+h[(w+38584|0)>>3])*.77;s=+h[(t+16|0)>>3];h[q+3096>>3]=+h[(t+23040|0)>>3]*s*+h[w+5264>>3]*-s+ +h[(t+23024|0)>>3]*s*+h[w+5272>>3]*-s;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;s=+h[(o+16|0)>>3];h[q+3104>>3]=+h[(o+23040|0)>>3]*s*+h[w+3200>>3]*-s+ +h[(o+23024|0)>>3]*s*+h[w+3208>>3]*-s;h[q+3112>>3]=+h[(o+23048|0)>>3]*+h[(w+38584|0)>>3]*.653137112681318;h[q+3120>>3]=0.0;h[q+3128>>3]=+h[(o+23032|0)>>3]*+h[(w+38584|0)>>3]*.653137112681318;h[q+3136>>3]=0.0;h[q+3144>>3]=+h[(o+23032|0)>>3]*+h[(w+38584|0)>>3]*.77;s=+h[(o+16|0)>>3];h[q+3152>>3]=+h[(o+23040|0)>>3]*s*+h[w+5168>>3]*-s+ +h[(o+23024|0)>>3]*s*+h[w+5176>>3]*-s;s=+h[(o+16|0)>>3];w=c[(b+416|0)>>2]|0;h[q+3160>>3]=(s*s*-.05+ +h[(o+23048|0)>>3]*+h[(w+38584|0)>>3])*.77;s=+h[(o+16|0)>>3];q=c[(d+36|0)>>2]|0;h[q+3168>>3]=+h[o+23896>>3]*s*+h[w+5744>>3]*-s+ +h[o+23880>>3]*s*+h[w+5752>>3]*-s;h[q+3176>>3]=+h[(o+23048|0)>>3]*+h[(w+38584|0)>>3]*1.814269757448105;o=c[(c[c[(b+4|0)>>2]>>2]|0)+8>>2]|0;h[q+3184>>3]=+h[o+23032>>3]*+h[(w+38584|0)>>3]*1.814269757448105;c[(q+3192|0)+0>>2]=0;c[(q+3192|0)+4>>2]=0;c[(q+3192|0)+8>>2]=0;c[(q+3192|0)+12>>2]=0;h[q+3208>>3]=+h[(o+25952|0)>>3];c[(q+3216|0)+0>>2]=0;c[(q+3216|0)+4>>2]=0;c[(q+3216|0)+8>>2]=0;c[(q+3216|0)+12>>2]=0;i=a;c[a+1920>>2]=5;break a}while(0);c[a+1896>>2]=m;c[a+1912>>2]=n}



function pzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){m=d[k+76+(d[b+1|0]|0)|0]|0}else{m=Cyc(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b:do{switch(m|0){case 7:{l=16;break a;break};case 14:{break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){n=d[k+76+(d[b+1|0]|0)|0]|0}else{n=Cyc(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(n|0){case 24:case 22:{break};case 7:{l=36;break a;break};case 6:{l=33;break a;break};case 29:{if((c[283680+((d[283424+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=28;break a}break};case 5:{l=30;break a;break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 27:case 26:case 25:case 24:case 22:{l=9;break};case 6:{l=13;break a;break};case 29:{if((c[283680+((d[284960+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){o=d[k+76+(d[b+1|0]|0)|0]|0}else{o=Cyc(a[b]|0,a[(c[j>>2]|0)+1|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 5:{l=10;break a;break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){q=d[k+76+(d[p+1|0]|0)|0]|0}else{q=Cyc(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){s=d[k+76+(d[p+1|0]|0)|0]|0}else{s=Cyc(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 3:{t=gzc(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){u=d[k+76+(d[p+1|0]|0)|0]|0}else{u=Cyc(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(u|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[c[j>>2]|0]|0)==0){v=d[k+76+(d[p+1|0]|0)|0]|0}else{v=Cyc(a[p]|0,a[(c[j>>2]|0)+1|0]|0)|0}switch(v|0){case 7:{l=103;break a;break};case 10:case 9:case 21:{break};case 29:{l=94;break d;break};case 24:case 22:{break d;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};case 6:{l=100;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[283680+((d[283424+(d[c[j>>2]|0]|0)|0]<<3)+(d[(c[j>>2]|0)+1|0]>>5)<<2)>>2]&1<<(a[(c[j>>2]|0)+1|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[c[j>>2]|0]|0)==0){if((a[(c[j>>2]|0)+1|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function qzc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g]|0)==0){k=a[g+1|0]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){l=a[g+1|0]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g]|0)==0){m=a[g+1|0]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function rzc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e]|0)==0){m=d[b+76+(d[h+1|0]|0)|0]|0}else{m=Cyc(a[h]|0,a[e+1|0]|0)|0}h=m;switch(h|0){case 8:case 1:case 0:{l=16;break a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e]|0)==0){p=d[b+76+(d[g+1|0]|0)|0]|0}else{p=Cyc(a[g]|0,a[e+1|0]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function szc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Cyc(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 10:case 9:case 21:{break a;break};case 30:{n=16;break a;break};case 24:case 22:{break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+2|0]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Cyc(a[o]|0,a[b+3|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=lzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function tzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Cyc(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function uzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 2:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 16:{k=dAc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 15:{k=_zc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -1;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=b+2|0;m=18;break a}g=b;if((xe[c[j+332>>2]&63](j,b)|0)!=0){b=g+2|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 30:{k=Uzc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=b+3|0;m=18;break a}g=b;if((xe[c[j+336>>2]&63](j,b)|0)!=0){b=g+3|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==93){if((b+1|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 11:{c[f>>2]=b+1;k=17;l=k;i=h;return l|0};case 32:{b=b+1|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}switch(d[j+76+(d[b]|0)|0]|0){case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+1;k=37;l=k;i=h;return l|0};case 15:{c[f>>2]=b+1;k=35;l=k;i=h;return l|0};case 33:{c[f>>2]=b+1;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 24:case 22:{m=18;b=b+1|0;break};case 36:{c[f>>2]=b+1;k=21;l=k;i=h;return l|0};case 19:{k=eAc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 9:{if((b+1|0)!=(e|0)){n=15;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+1;k=38;l=k;i=h;return l|0};case 13:{k=cAc(13,j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 23:case 27:case 26:case 25:{m=19;b=b+1|0;break};case 31:{c[f>>2]=b+1;k=23;l=k;i=h;return l|0};case 10:case 21:{n=15;break};case 20:{c[f>>2]=b+1;k=25;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=b+4|0;m=18;break a}g=b;if((xe[c[j+340>>2]&63](j,b)|0)!=0){b=g+4|0;m=19;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 12:{k=cAc(12,j,b+1|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);if((n|0)==15){while(1){n=0;b=b+1|0;o=b;if((b|0)==(e|0)){n=19;break}g=d[j+76+(d[o]|0)|0]|0;if((g|0)==10|(g|0)==21){n=15;continue}else if((g|0)!=9){n=18;break}if((b+1|0)!=(e|0)){n=15}else{n=18;break}}if((n|0)==18){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==19){c[f>>2]=o;k=15;l=k;i=h;return l|0}}b:while(1){if((b|0)==(e|0)){n=120;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{n=69;break b;break};case 5:{if((e-b|0)<2){n=72;break b}p=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){n=74;break b}b=p+2|0;continue b;break};case 33:{n=113;break b;break};case 34:{n=110;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 23:{b=b+1|0;o=m;if((o|0)==41){m=19;continue b}else if((o|0)!=18){continue b}if((b|0)==(e|0)){n=89;break b}m=41;switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){n=104;break b}q=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){n=106;break b}b=q+4|0;continue b;break};case 29:{n=91;break b;break};case 6:{if((e-b|0)<3){n=99;break b}r=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){n=101;break b}b=r+3|0;continue b;break};case 5:{if((e-b|0)<2){n=94;break b}s=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){n=96;break b}b=s+2|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};default:{m=19;continue b}}break};case 6:{if((e-b|0)<3){n=77;break b}t=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){n=79;break b}b=t+3|0;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=86;break b;break};case 7:{if((e-b|0)<4){n=82;break b}u=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){n=84;break b}b=u+4|0;continue b;break};case 15:{n=116;break b;break};default:{n=119;break b}}}if((n|0)==69){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==72){k=-2;l=k;i=h;return l|0}else if((n|0)==74){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((n|0)==77){k=-2;l=k;i=h;return l|0}else if((n|0)==79){c[f>>2]=t;k=0;l=k;i=h;return l|0}else if((n|0)==82){k=-2;l=k;i=h;return l|0}else if((n|0)==84){c[f>>2]=u;k=0;l=k;i=h;return l|0}else if((n|0)==86){c[f>>2]=b;k=m;l=k;i=h;return l|0}else if((n|0)==89){k=-1;l=k;i=h;return l|0}else if((n|0)==91){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==94){k=-2;l=k;i=h;return l|0}else if((n|0)==96){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((n|0)==99){k=-2;l=k;i=h;return l|0}else if((n|0)==101){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((n|0)==104){k=-2;l=k;i=h;return l|0}else if((n|0)==106){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((n|0)==110){q=b;if((m|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=32;l=k;i=h;return l|0}}else if((n|0)==113){q=b;if((m|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=31;l=k;i=h;return l|0}}else if((n|0)==116){q=b;if((m|0)==19){c[f>>2]=q;k=0;l=k;i=h;return l|0}else{c[f>>2]=q+1;k=30;l=k;i=h;return l|0}}else if((n|0)==119){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==120){k=0-m|0;l=k;i=h;return l|0}return 0}function vzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 9:{b=b+1|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 3:{k=Tzc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 2:{k=Xzc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=60;break}switch(d[j+76+(d[m]|0)|0]|0){case 7:{if((e-b|0)<4){n=49;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=49;break b}b=b+4|0;continue b;break};case 5:{if((e-b|0)<2){n=41;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=41;break b}b=b+2|0;continue b;break};case 4:{if((b+1|0)==(e|0)){n=58;break b}g=b;if((a[b+1|0]|0)!=93){b=g+1|0;continue b}if((g+2|0)==(e|0)){n=58;break b}o=b;if((a[b+2|0]|0)==62){n=57;break b}b=o+1|0;continue b;break};case 6:{if((e-b|0)<3){n=45;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=45;break b}b=b+3|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{n=58;break b;break};default:{b=b+1|0;continue b}}}if((n|0)==41){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==45){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==57){c[f>>2]=o+2;k=0;l=k;i=h;return l|0}else if((n|0)==58){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==60){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function wzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+356>>2]&63](j,b)|0)==0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=93){break a}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)!=62){b=g+ -1|0;break a}c[f>>2]=g+1;k=40;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+360>>2]&63](j,b)|0)==0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 10:{c[f>>2]=b+1;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+364>>2]&63](j,b)|0)==0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 9:{b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((d[j+76+(d[b]|0)|0]|0)==10){b=b+1|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};default:{b=b+1|0}}}while(0);b:while(1){m=b;if((b|0)==(e|0)){n=51;break}switch(d[j+76+(d[m]|0)|0]|0){case 4:case 10:case 9:case 8:case 1:case 0:{n=49;break b;break};case 6:{if((e-b|0)<3){n=43;break b}if((xe[c[j+360>>2]&63](j,b)|0)!=0){n=43;break b}b=b+3|0;continue b;break};case 5:{if((e-b|0)<2){n=39;break b}if((xe[c[j+356>>2]&63](j,b)|0)!=0){n=39;break b}b=b+2|0;continue b;break};case 7:{if((e-b|0)<4){n=47;break b}if((xe[c[j+364>>2]&63](j,b)|0)!=0){n=47;break b}b=b+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((n|0)==39){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==43){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==47){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((n|0)==51){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function xzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;g=0;a:while(1){if((b|0)==(e|0)){k=37;break}switch(d[j+76+(d[b]|0)|0]|0){case 2:{l=b+1|0;b=l;if((l|0)==(e|0)){k=21;break a}if((a[b]|0)!=33){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=24;break a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+1|0;continue a;break};case 4:{l=b+1|0;b=l;if((l|0)==(e|0)){k=28;break a}if((a[b]|0)!=93){continue a}l=b+1|0;b=l;if((l|0)==(e|0)){k=31;break a}if((a[b]|0)!=62){continue a}b=b+1|0;if((g|0)==0){k=34;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{k=19;break a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};case 5:{if((e-b|0)<2){k=5;break a}o=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){k=7;break a}b=o+2|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){p=-2;q=p;i=h;return q|0}else if((k|0)==7){c[f>>2]=o;p=0;q=p;i=h;return q|0}else if((k|0)==10){p=-2;q=p;i=h;return q|0}else if((k|0)==12){c[f>>2]=m;p=0;q=p;i=h;return q|0}else if((k|0)==15){p=-2;q=p;i=h;return q|0}else if((k|0)==17){c[f>>2]=n;p=0;q=p;i=h;return q|0}else if((k|0)==19){c[f>>2]=b;p=0;q=p;i=h;return q|0}else if((k|0)==21){p=-1;q=p;i=h;return q|0}else if((k|0)==24){p=-1;q=p;i=h;return q|0}else if((k|0)==28){p=-1;q=p;i=h;return q|0}else if((k|0)==31){p=-1;q=p;i=h;return q|0}else if((k|0)==34){c[f>>2]=b;p=42;q=p;i=h;return q|0}else if((k|0)==37){p=-1;q=p;i=h;return q|0}return 0}function yzc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+48|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=27;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 2:{m=12;break a;break};case 6:{a=a+3|0;continue a;break};case 10:{m=13;break a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=16;break a;break};case 3:{m=9;break a;break};case 21:{m=23;break a;break};case 7:{a=a+4|0;continue a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Tzc(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((m|0)==13){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==16){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==23){h=a;if((a|0)==(f|0)){c[e>>2]=h+1;j=39;k=j;i=g;return k|0}else{c[e>>2]=h;j=6;k=j;i=g;return k|0}}else if((m|0)==27){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function zzc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+56|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-4;k=j;i=g;return k|0}f=a;a:while(1){l=a;if((a|0)==(b|0)){m=26;break}switch(d[h+76+(d[l]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 3:{m=9;break a;break};case 10:{m=15;break a;break};case 7:{a=a+4|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 9:{m=18;break a;break};case 30:{m=12;break a;break};default:{a=a+1|0;continue a}}}if((m|0)==9){if((a|0)==(f|0)){j=Tzc(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==12){if((a|0)==(f|0)){n=Uzc(h,a+1|0,b,e)|0;j=(n|0)==22?0:n;k=j;i=g;return k|0}else{c[e>>2]=a;j=6;k=j;i=g;return k|0}}else if((m|0)==15){n=a;if((a|0)==(f|0)){c[e>>2]=n+1;j=7;k=j;i=g;return k|0}else{c[e>>2]=n;j=6;k=j;i=g;return k|0}}else if((m|0)==18){n=a;if((a|0)!=(f|0)){c[e>>2]=n;j=6;k=j;i=g;return k|0}a=n+1|0;if((a|0)==(b|0)){j=-3;k=j;i=g;return k|0}if((d[h+76+(d[a]|0)|0]|0|0)==10){a=a+1|0}c[e>>2]=a;j=7;k=j;i=g;return k|0}else if((m|0)==26){c[e>>2]=l;j=6;k=j;i=g;return k|0}return 0}function Azc(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){switch(d[g+76+(d[b]|0)|0]|0){case 6:{h=5;break};case 5:{break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=4;break a}else{h=5}break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){h=12;break a}else{continue a}break};default:{h=13;break a}}if((h|0)==5){h=0;e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=6;break}}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){h=8;break}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){h=10;break}}if((h|0)==4){k=0;l=k;i=f;return l|0}else if((h|0)==6){k=0;l=k;i=f;return l|0}else if((h|0)==8){k=0;l=k;i=f;return l|0}else if((h|0)==10){k=0;l=k;i=f;return l|0}else if((h|0)==12){k=0;l=k;i=f;return l|0}else if((h|0)==13){if((a[b]|0)==(a[c]|0)){k=1;l=k;i=f;return l|0}switch(d[g+76+(d[c]|0)|0]|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{k=0;l=k;i=f;return l|0};default:{k=1;l=k;i=f;return l|0}}}return 0}function Bzc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=8;break}if(g){h=4;break}if((a[f]|0)!=(a[d]|0)){h=6;break}f=f+1|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==6){j=0;k=j;i=b;return k|0}else if((h|0)==8){j=g&1;k=j;i=b;return k|0}return 0}function Czc(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+24|0;e=a;a=b;b=a;a:while(1){switch(d[e+76+(d[a]|0)|0]|0|0){case 6:{a=a+3|0;continue a;break};case 5:{a=a+2|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{a=a+1|0;continue a;break};case 7:{a=a+4|0;continue a;break};default:{break a}}}i=c;return a-b|0}function Dzc(a,b){a=a|0;b=b|0;var c=0,e=0;c=i;i=i+16|0;e=a;a=b;while(1){b=d[e+76+(d[a]|0)|0]|0;if(!((b|0)==21|(b|0)==9|(b|0)==10)){break}a=a+1|0}i=c;return a|0}function Ezc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+1|0;a:while(1){b:do{switch(d[j+76+(d[b]|0)|0]|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+3|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)!=32){break}if((a[b+1|0]|0)==32){break}if((d[j+76+(d[b+1|0]|0)|0]|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+1}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+1|0}i=h;return k|0}function Fzc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;b=i;i=i+48|0;d=c;c=0;d=d+2|0;a:do{if((a[d]|0)==120){d=d+1|0;while(1){if(!((a[d]|0)==59^1)){break a}e=a[d]|0;switch(e|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(e-97))|0;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(e-65))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|e-48;break};default:{}}if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}else{while(1){if(!((a[d]|0)==59^1)){break a}c=c*10|0;c=c+((a[d]|0)-48)|0;if((c|0)>=1114112){break}d=d+1|0}f=-1;g=f;i=b;return g|0}}while(0);f=Qxc(c)|0;g=f;i=b;return g|0}function Gzc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0;b=i;i=i+32|0;e=c;c=(d-e|0)/1|0;do{if((c|0)==2){if((a[e+1|0]|0)!=116){break}d=a[e]|0;if((d|0)==108){f=60;g=f;i=b;return g|0}else if((d|0)==103){f=62;g=f;i=b;return g|0}else{break}}else if((c|0)==4){d=a[e]|0;if((d|0)==97){e=e+1|0;if((a[e]|0)!=112){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=115){break}f=39;g=f;i=b;return g|0}else if((d|0)==113){e=e+1|0;if((a[e]|0)!=117){break}e=e+1|0;if((a[e]|0)!=111){break}e=e+1|0;if((a[e]|0)!=116){break}f=34;g=f;i=b;return g|0}else{break}}else if((c|0)==3){if((a[e]|0)!=97){break}e=e+1|0;if((a[e]|0)!=109){break}e=e+1|0;if((a[e]|0)!=112){break}f=38;g=f;i=b;return g|0}}while(0);f=0;g=f;i=b;return g|0}function Hzc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0;g=i;i=i+32|0;h=a;a=b;b=e;e=f;while(1){if(!(a>>>0<b>>>0)){break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{a=a+2|0;break};case 7:{a=a+4|0;break};case 6:{a=a+3|0;break};case 9:{f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;do{if((a|0)!=(b|0)){if((d[h+76+(d[a]|0)|0]|0|0)!=10){break}a=a+1|0}}while(0);c[e+4>>2]=-1;break};case 10:{c[e+4>>2]=-1;f=e;c[f>>2]=(c[f>>2]|0)+1;a=a+1|0;break};default:{a=a+1|0}}f=e+4|0;c[f>>2]=(c[f>>2]|0)+1}i=g;return}function Izc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+1|0;e=e+ -1|0;a:while(1){if((b|0)==(e|0)){k=10;break}switch(d[j+76+(d[b]|0)|0]|0){case 22:case 26:{if((a[b]&-128|0)!=0){k=7}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)==9){k=5;break a}break};default:{k=7}}if((k|0)==7){k=0;g=a[b]|0;if(!((g|0)==64|(g|0)==36)){k=8;break}}b=b+1|0}if((k|0)==5){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==8){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((k|0)==10){l=1;m=l;i=h;return m|0}return 0}function Jzc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0;b=i;i=i+56|0;h=d;d=e;e=f;f=g;a:do{if((d-(c[h>>2]|0)|0)>(f-(c[e>>2]|0)|0)){d=(c[h>>2]|0)+(f-(c[e>>2]|0))|0;while(1){if(!(d>>>0>(c[h>>2]|0)>>>0)){break a}if((a[d+ -1|0]&192|0)!=128){break a}d=d+ -1|0}}}while(0);f=c[e>>2]|0;g=c[h>>2]|0;while(1){j=g;if((g|0)==(d|0)){break}a[f]=a[j]|0;g=g+1|0;f=f+1|0}c[h>>2]=j;c[e>>2]=f;i=b;return}function Kzc(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+64|0;l=e;e=f;f=g;g=h;h=j;j=c[g>>2]|0;m=c[e>>2]|0;while(1){if((m|0)==(f|0)){n=10;break}if((j|0)==(h|0)){n=10;break}o=d[l+76+(d[m]|0)|0]|0;if((o|0)==6){p=j;j=p+2|0;b[p>>1]=(a[m]&15)<<12|(a[m+1|0]&63)<<6|a[m+2|0]&63;m=m+3|0;continue}else if((o|0)==7){if((j+2|0)==(h|0)){n=10;break}p=(a[m]&7)<<18|(a[m+1|0]&63)<<12|(a[m+2|0]&63)<<6|a[m+3|0]&63;p=p-65536|0;b[j>>1]=p>>>10|55296;b[j+2>>1]=p&1023|56320;j=j+4|0;m=m+4|0;continue}else if((o|0)==5){o=j;j=o+2|0;b[o>>1]=(a[m]&31)<<6|a[m+1|0]&63;m=m+2|0;continue}else{o=m;m=o+1|0;p=j;j=p+2|0;b[p>>1]=a[o]|0;continue}}if((n|0)==10){c[e>>2]=m;c[g>>2]=j;i=k;return}}function Lzc(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[283680+(((d[284960+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Mzc(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[283680+(((d[284960+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Nzc(a,b){a=a|0;b=b|0;b=i;i=i+16|0;i=b;return 0}function Ozc(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[283680+(((d[283424+((d[f]|0)>>2&7)|0]|0)<<3)+((a[f]&3)<<1)+((d[f+1|0]|0)>>5&1)<<2)>>2]&1<<(a[f+1|0]&31)|0}function Pzc(b,e){b=b|0;e=e|0;var f=0;b=i;i=i+16|0;f=e;i=b;return c[283680+(((d[283424+(((a[f]&15)<<4)+((d[f+1|0]|0)>>2&15))|0]|0)<<3)+((a[f+1|0]&3)<<1)+((d[f+2|0]|0)>>5&1)<<2)>>2]&1<<(a[f+2|0]&31)|0}function Qzc(b,c){b=b|0;c=c|0;var e=0,f=0;b=i;i=i+16|0;e=c;do{if((d[e]|0|0)<194){f=1}else{if((a[e+1|0]&128|0)==0){f=1;break}f=(a[e+1|0]&192|0)==192}}while(0);i=b;return f&1|0}function Rzc(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}do{if((d[e]|0|0)==239){if((d[e+1|0]|0|0)!=191){h=5;break}if((d[e+2|0]|0|0)>189){f=1}else{break}g=f&1;i=b;return g|0}else{h=5}}while(0);do{if((h|0)==5){if((a[e+2|0]&192|0)==192){f=1}else{break}g=f&1;i=b;return g|0}}while(0);h=d[e+1|0]|0;do{if((d[e]|0|0)==224){if((h|0)<160){j=1;break}j=(a[e+1|0]&192|0)==192}else{if((h&128|0)==0){j=1;break}c=d[e+1|0]|0;if((d[e]|0|0)==237){k=(c|0)>159}else{k=(c&192|0)==192}j=(k&1|0)!=0}}while(0);f=(j&1|0)!=0;g=f&1;i=b;return g|0}function Szc(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+16|0;e=c;if((a[e+3|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+3|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&128|0)==0){f=1;g=f&1;i=b;return g|0}if((a[e+2|0]&192|0)==192){f=1;g=f&1;i=b;return g|0}c=d[e+1|0]|0;do{if((d[e]|0|0)==240){if((c|0)<144){h=1;break}h=(a[e+1|0]&192|0)==192}else{if((c&128|0)==0){h=1;break}j=d[e+1|0]|0;if((d[e]|0|0)==244){k=(j|0)>143}else{k=(j&192|0)==192}h=(k&1|0)!=0}}while(0);f=(h&1|0)!=0;g=f&1;i=b;return g|0}function Tzc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 19:{j=Vzc(h,a+1|0,b,e)|0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){l=28;break b}m=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=m+2|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=n+4|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 18:{l=42;break b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};case 29:{l=25;break b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=9;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Uzc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 30:case 9:case 10:case 21:{c[e>>2]=a;j=22;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=44;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 7:{if((b-a|0)<4){l=38;break b}m=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=40;break b}a=m+4|0;continue b;break};case 18:{l=42;break b;break};case 29:{l=25;break b;break};case 5:{if((b-a|0)<2){l=28;break b}n=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=30;break b}a=n+2|0;continue b;break};case 6:{if((b-a|0)<3){l=33;break b}o=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=35;break b}a=o+3|0;continue b;break};default:{l=43;break b}}}if((l|0)==25){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==28){j=-2;k=j;i=g;return k|0}else if((l|0)==30){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==33){j=-2;k=j;i=g;return k|0}else if((l|0)==35){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==38){j=-2;k=j;i=g;return k|0}else if((l|0)==40){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a+1;j=28;k=j;i=g;return k|0}else if((l|0)==43){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==44){j=-1;k=j;i=g;return k|0}return 0}function Vzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){if((a[b]|0)==120){k=Wzc(j,b+1|0,e,f)|0;l=k;i=h;return l|0}g=b;if((d[j+76+(d[b]|0)|0]|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;while(1){if((b|0)==(e|0)){break a}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==18){m=9;break}else if((g|0)!=25){m=10;break}b=b+1|0}if((m|0)==9){c[f>>2]=b+1;k=10;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Wzc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;a:do{if((a|0)!=(b|0)){f=a;if(!(((d[h+76+(d[a]|0)|0]|0)+ -24|0)>>>0<2)){c[e>>2]=f;j=0;k=j;i=g;return k|0}a=f+1|0;while(1){if((a|0)==(b|0)){break a}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==18){l=7;break}else if(!((f|0)==24|(f|0)==25)){l=8;break}a=a+1|0}if((l|0)==7){c[e>>2]=a+1;j=10;k=j;i=g;return k|0}else if((l|0)==8){c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);j=-1;k=j;i=g;return k|0}function Xzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}a:do{switch(d[j+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 15:{k=_zc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 17:{k=$zc(j,b+1|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break a}c[f>>2]=g;k=0;l=k;i=h;return l|0};case 24:case 22:{b=b+1|0;break};case 16:{g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=d[j+76+(d[b]|0)|0]|0;if((g|0)==20){k=Zzc(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else if((g|0)==27){k=Yzc(j,b+1|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);g=0;b:while(1){if((b|0)==(e|0)){m=104;break}switch(d[j+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){m=46;break b}n=b;if((xe[c[j+340>>2]&63](j,b)|0)==0){m=48;break b}b=n+4|0;continue b;break};case 5:{if((e-b|0)<2){m=36;break b}o=b;if((xe[c[j+332>>2]&63](j,b)|0)==0){m=38;break b}b=o+2|0;continue b;break};case 10:case 9:case 21:{m=73;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{m=33;break b;break};case 6:{if((e-b|0)<3){m=41;break b}p=b;if((xe[c[j+336>>2]&63](j,b)|0)==0){m=43;break b}b=p+3|0;continue b;break};case 11:{m=97;break b;break};case 17:{break b;break};case 23:{if((g|0)!=0){m=51;break b}g=1;b=b+1|0;if((b|0)==(e|0)){m=53;break b}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=63;break b}q=b;if((xe[c[j+348>>2]&63](j,b)|0)==0){m=65;break b}b=q+3|0;continue b;break};case 29:{m=55;break b;break};case 24:case 22:{b=b+1|0;continue b;break};case 5:{if((e-b|0)<2){m=58;break b}r=b;if((xe[c[j+344>>2]&63](j,b)|0)==0){m=60;break b}b=r+2|0;continue b;break};case 7:{if((e-b|0)<4){m=68;break b}s=b;if((xe[c[j+352>>2]&63](j,b)|0)==0){m=70;break b}b=s+4|0;continue b;break};default:{m=72;break b}}break};default:{m=103;break b}}}c:do{if((m|0)==33){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==36){k=-2;l=k;i=h;return l|0}else if((m|0)==38){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==41){k=-2;l=k;i=h;return l|0}else if((m|0)==43){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==46){k=-2;l=k;i=h;return l|0}else if((m|0)==48){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==51){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==53){k=-1;l=k;i=h;return l|0}else if((m|0)==55){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==58){k=-2;l=k;i=h;return l|0}else if((m|0)==60){c[f>>2]=r;k=0;l=k;i=h;return l|0}else if((m|0)==63){k=-2;l=k;i=h;return l|0}else if((m|0)==65){c[f>>2]=q;k=0;l=k;i=h;return l|0}else if((m|0)==68){k=-2;l=k;i=h;return l|0}else if((m|0)==70){c[f>>2]=s;k=0;l=k;i=h;return l|0}else if((m|0)==72){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==73){b=b+1|0;d:while(1){if((b|0)==(e|0)){m=96;break}switch(d[j+76+(d[b]|0)|0]|0){case 29:{m=76;break d;break};case 6:{m=83;break d;break};case 5:{m=78;break d;break};case 24:case 22:{m=77;break d;break};case 7:{m=88;break d;break};case 11:{m=97;break c;break};case 10:case 9:case 21:{break};case 17:{break c;break};default:{m=94;break d}}b=b+1|0}do{if((m|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==77){b=b+1|0}else if((m|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+344>>2]&63](j,b)|0)!=0){b=g+2|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==83){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+348>>2]&63](j,b)|0)!=0){b=g+3|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==88){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}g=b;if((xe[c[j+352>>2]&63](j,b)|0)!=0){b=g+4|0;break}c[f>>2]=g;k=0;l=k;i=h;return l|0}else if((m|0)==94){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==96){k=-1;l=k;i=h;return l|0}}while(0);k=aAc(j,b,e,f)|0;l=k;i=h;return l|0}else if((m|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==104){k=-1;l=k;i=h;return l|0}}while(0);if((m|0)==97){c[f>>2]=b+1;k=2;l=k;i=h;return l|0}b=b+1|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}e=b;if((a[b]|0)==62){c[f>>2]=e+1;k=4;l=k;i=h;return l|0}else{c[f>>2]=e;k=0;l=k;i=h;return l|0}return 0}function Yzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)!=45){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+1|0;b:while(1){if((b|0)==(e|0)){break a}switch(d[j+76+(d[b]|0)|0]|0){case 6:{if((e-b|0)<3){m=13;break b}n=b;if((xe[c[j+360>>2]&63](j,b)|0)!=0){m=15;break b}b=n+3|0;continue b;break};case 27:{g=b+1|0;b=g;if((g|0)==(e|0)){m=24;break b}if((a[b]|0)==45){m=26;break b}else{continue b}break};case 5:{if((e-b|0)<2){m=8;break b}o=b;if((xe[c[j+356>>2]&63](j,b)|0)!=0){m=10;break b}b=o+2|0;continue b;break};case 8:case 1:case 0:{m=22;break b;break};case 7:{if((e-b|0)<4){m=18;break b}p=b;if((xe[c[j+364>>2]&63](j,b)|0)!=0){m=20;break b}b=p+4|0;continue b;break};default:{b=b+1|0;continue b}}}if((m|0)==8){k=-2;l=k;i=h;return l|0}else if((m|0)==10){c[f>>2]=o;k=0;l=k;i=h;return l|0}else if((m|0)==13){k=-2;l=k;i=h;return l|0}else if((m|0)==15){c[f>>2]=n;k=0;l=k;i=h;return l|0}else if((m|0)==18){k=-2;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=p;k=0;l=k;i=h;return l|0}else if((m|0)==22){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((m|0)==24){k=-1;l=k;i=h;return l|0}else if((m|0)==26){g=b+1|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==62){c[f>>2]=g+1;k=13;l=k;i=h;return l|0}else{c[f>>2]=g;k=0;l=k;i=h;return l|0}}}}while(0);k=-1;l=k;i=h;return l|0}function Zzc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<6){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=8;break}if((a[k]|0)!=(a[286376+e|0]|0)){l=6;break}e=e+1|0;g=g+1|0}if((l|0)==6){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==8){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function _zc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}a:do{switch(d[k+76+(d[b]|0)|0]|0){case 29:{c[f>>2]=b;l=0;m=l;i=h;return m|0};case 24:case 22:{b=b+1|0;break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+348>>2]&63](k,b)|0)!=0){b=n+3|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+352>>2]&63](k,b)|0)!=0){b=n+4|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}n=b;if((xe[c[k+344>>2]&63](k,b)|0)!=0){b=n+2|0;break a}c[f>>2]=n;l=0;m=l;i=h;return m|0};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b:while(1){if((b|0)==(e|0)){o=75;break}switch(d[k+76+(d[b]|0)|0]|0){case 7:{if((e-b|0)<4){o=37;break b}p=b;if((xe[c[k+340>>2]&63](k,b)|0)==0){o=39;break b}b=p+4|0;continue b;break};case 6:{if((e-b|0)<3){o=32;break b}q=b;if((xe[c[k+336>>2]&63](k,b)|0)==0){o=34;break b}b=q+3|0;continue b;break};case 15:{o=68;break b;break};case 10:case 9:case 21:{o=41;break b;break};case 27:case 26:case 25:case 24:case 22:{b=b+1|0;continue b;break};case 29:{o=24;break b;break};case 5:{if((e-b|0)<2){o=27;break b}r=b;if((xe[c[k+332>>2]&63](k,b)|0)==0){o=29;break b}b=r+2|0;continue b;break};default:{break b}}}do{if((o|0)==24){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==27){l=-2;m=l;i=h;return m|0}else if((o|0)==29){c[f>>2]=r;l=0;m=l;i=h;return m|0}else if((o|0)==32){l=-2;m=l;i=h;return m|0}else if((o|0)==34){c[f>>2]=q;l=0;m=l;i=h;return m|0}else if((o|0)==37){l=-2;m=l;i=h;return m|0}else if((o|0)==39){c[f>>2]=p;l=0;m=l;i=h;return m|0}else if((o|0)==41){n=b;if((bAc(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;c:while(1){if((b|0)==(e|0)){o=67;break}switch(d[k+76+(d[b]|0)|0]|0){case 15:{b=b+1|0;if((b|0)==(e|0)){o=63;break c}if((a[b]|0)==62){o=65;break c}else{continue c}break};case 5:{if((e-b|0)<2){o=47;break c}s=b;if((xe[c[k+356>>2]&63](k,b)|0)!=0){o=49;break c}b=s+2|0;continue c;break};case 7:{if((e-b|0)<4){o=57;break c}t=b;if((xe[c[k+364>>2]&63](k,b)|0)!=0){o=59;break c}b=t+4|0;continue c;break};case 6:{if((e-b|0)<3){o=52;break c}u=b;if((xe[c[k+360>>2]&63](k,b)|0)!=0){o=54;break c}b=u+3|0;continue c;break};case 8:case 1:case 0:{o=61;break c;break};default:{b=b+1|0;continue c}}}if((o|0)==47){l=-2;m=l;i=h;return m|0}else if((o|0)==49){c[f>>2]=s;l=0;m=l;i=h;return m|0}else if((o|0)==52){l=-2;m=l;i=h;return m|0}else if((o|0)==54){c[f>>2]=u;l=0;m=l;i=h;return m|0}else if((o|0)==57){l=-2;m=l;i=h;return m|0}else if((o|0)==59){c[f>>2]=t;l=0;m=l;i=h;return m|0}else if((o|0)==61){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((o|0)==63){l=-1;m=l;i=h;return m|0}else if((o|0)==65){c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==67){l=-1;m=l;i=h;return m|0}}else if((o|0)==68){n=b;if((bAc(k,g,b,j)|0)==0){c[f>>2]=n;l=0;m=l;i=h;return m|0}b=n+1|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=62){break}c[f>>2]=b+1;l=c[j>>2]|0;m=l;i=h;return m|0}else if((o|0)==75){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function $zc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 24:case 22:{a=a+1|0;break};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=51;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 7:{if((b-a|0)<4){l=37;break b}m=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=m+4|0;continue b;break};case 6:{if((b-a|0)<3){l=32;break b}n=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=n+3|0;continue b;break};case 11:{l=49;break b;break};case 10:case 9:case 21:{l=41;break b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 23:{a=a+1|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=50;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==41){a=a+1|0;while(1){if((a|0)==(b|0)){l=47;break}m=d[h+76+(d[a]|0)|0]|0;if((m|0)==11){l=44;break}else if(!((m|0)==10|(m|0)==9|(m|0)==21)){l=45;break}a=a+1|0}if((l|0)==44){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==45){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==47){j=-1;k=j;i=g;return k|0}}else if((l|0)==49){c[e>>2]=a+1;j=5;k=j;i=g;return k|0}else if((l|0)==50){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==51){j=-1;k=j;i=g;return k|0}return 0}function aAc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=114;break}b:do{switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 6:{if((e-(c[j>>2]|0)|0)<3){l=12;break a}b=(xe[c[k+336>>2]&63](k,c[j>>2]|0)|0)!=0;m=c[j>>2]|0;if(!b){l=14;break a}c[j>>2]=m+3;continue a;break};case 29:{l=4;break a;break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=7;break a}b=(xe[c[k+332>>2]&63](k,c[j>>2]|0)|0)!=0;n=c[j>>2]|0;if(!b){l=9;break a}c[j>>2]=n+2;continue a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=45;break a}b=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((b|0)==14){break b}o=b;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=48;break a}}break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=17;break a}o=(xe[c[k+340>>2]&63](k,c[j>>2]|0)|0)!=0;p=c[j>>2]|0;if(!o){l=19;break a}c[j>>2]=p+4;continue a;break};case 23:{if((g|0)!=0){l=22;break a}g=1;c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=24;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 5:{if((e-(c[j>>2]|0)|0)<2){l=29;break a}o=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;q=c[j>>2]|0;if(!o){l=31;break a}c[j>>2]=q+2;continue a;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=34;break a}o=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;r=c[j>>2]|0;if(!o){l=36;break a}c[j>>2]=r+3;continue a;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=39;break a}o=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;s=c[j>>2]|0;if(!o){l=41;break a}c[j>>2]=s+4;continue a;break};case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 29:{l=26;break a;break};default:{l=43;break a}}break};case 27:case 26:case 25:case 24:case 22:{c[j>>2]=(c[j>>2]|0)+1;continue a;break};case 14:{break};default:{l=113;break a}}}while(0);g=0;while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=51;break a}t=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((t|0)==12|(t|0)==13){break}o=t;if(!((o|0)==9|(o|0)==10|(o|0)==21)){l=54;break a}}c[j>>2]=(c[j>>2]|0)+1;c:while(1){if((c[j>>2]|0)==(e|0)){l=57;break a}o=d[k+76+(d[c[j>>2]|0]|0)|0]|0;if((o|0)==(t|0)){break}switch(o|0){case 8:case 1:case 0:{l=75;break a;break};case 2:{l=80;break a;break};case 3:{u=Tzc(k,(c[j>>2]|0)+1|0,e,j)|0;if((u|0)<=0){l=77;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=61;break a}o=(xe[c[k+356>>2]&63](k,c[j>>2]|0)|0)!=0;v=c[j>>2]|0;if(o){l=63;break a}c[j>>2]=v+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=66;break a}o=(xe[c[k+360>>2]&63](k,c[j>>2]|0)|0)!=0;w=c[j>>2]|0;if(o){l=68;break a}c[j>>2]=w+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=71;break a}o=(xe[c[k+364>>2]&63](k,c[j>>2]|0)|0)!=0;x=c[j>>2]|0;if(o){l=73;break a}c[j>>2]=x+4;continue c;break};default:{c[j>>2]=(c[j>>2]|0)+1;continue c}}}c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=83;break}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 17:{l=107;break a;break};case 11:{l=106;break a;break};default:{l=85;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){l=87;break a}switch(d[k+76+(d[c[j>>2]|0]|0)|0]|0){case 10:case 9:case 21:{break};case 5:{l=91;break d;break};case 29:{l=89;break a;break};case 24:case 22:{l=90;break d;break};case 17:{l=107;break a;break};case 7:{l=101;break d;break};case 11:{l=106;break a;break};case 6:{l=96;break d;break};default:{l=112;break a}}}if((l|0)==90){l=0;c[j>>2]=(c[j>>2]|0)+1;continue}else if((l|0)==91){l=0;if((e-(c[j>>2]|0)|0)<2){l=92;break}o=(xe[c[k+344>>2]&63](k,c[j>>2]|0)|0)!=0;y=c[j>>2]|0;if(!o){l=94;break}c[j>>2]=y+2;continue}else if((l|0)==96){l=0;if((e-(c[j>>2]|0)|0)<3){l=97;break}o=(xe[c[k+348>>2]&63](k,c[j>>2]|0)|0)!=0;z=c[j>>2]|0;if(!o){l=99;break}c[j>>2]=z+3;continue}else if((l|0)==101){l=0;if((e-(c[j>>2]|0)|0)<4){l=102;break}o=(xe[c[k+352>>2]&63](k,c[j>>2]|0)|0)!=0;A=c[j>>2]|0;if(!o){l=104;break}c[j>>2]=A+4;continue}}if((l|0)==4){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==7){B=-2;C=B;i=h;return C|0}else if((l|0)==9){c[f>>2]=n;B=0;C=B;i=h;return C|0}else if((l|0)==12){B=-2;C=B;i=h;return C|0}else if((l|0)==14){c[f>>2]=m;B=0;C=B;i=h;return C|0}else if((l|0)==17){B=-2;C=B;i=h;return C|0}else if((l|0)==19){c[f>>2]=p;B=0;C=B;i=h;return C|0}else if((l|0)==22){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==24){B=-1;C=B;i=h;return C|0}else if((l|0)==26){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==29){B=-2;C=B;i=h;return C|0}else if((l|0)==31){c[f>>2]=q;B=0;C=B;i=h;return C|0}else if((l|0)==34){B=-2;C=B;i=h;return C|0}else if((l|0)==36){c[f>>2]=r;B=0;C=B;i=h;return C|0}else if((l|0)==39){B=-2;C=B;i=h;return C|0}else if((l|0)==41){c[f>>2]=s;B=0;C=B;i=h;return C|0}else if((l|0)==43){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==45){B=-1;C=B;i=h;return C|0}else if((l|0)==48){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==51){B=-1;C=B;i=h;return C|0}else if((l|0)==54){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==57){B=-1;C=B;i=h;return C|0}else if((l|0)==61){B=-2;C=B;i=h;return C|0}else if((l|0)==63){c[f>>2]=v;B=0;C=B;i=h;return C|0}else if((l|0)==66){B=-2;C=B;i=h;return C|0}else if((l|0)==68){c[f>>2]=w;B=0;C=B;i=h;return C|0}else if((l|0)==71){B=-2;C=B;i=h;return C|0}else if((l|0)==73){c[f>>2]=x;B=0;C=B;i=h;return C|0}else if((l|0)==75){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==77){if((u|0)==0){c[f>>2]=c[j>>2]}B=u;C=B;i=h;return C|0}else if((l|0)==80){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==83){B=-1;C=B;i=h;return C|0}else if((l|0)==85){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==87){B=-1;C=B;i=h;return C|0}else if((l|0)==89){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==92){B=-2;C=B;i=h;return C|0}else if((l|0)==94){c[f>>2]=y;B=0;C=B;i=h;return C|0}else if((l|0)==97){B=-2;C=B;i=h;return C|0}else if((l|0)==99){c[f>>2]=z;B=0;C=B;i=h;return C|0}else if((l|0)==102){B=-2;C=B;i=h;return C|0}else if((l|0)==104){c[f>>2]=A;B=0;C=B;i=h;return C|0}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+1;B=1;C=B;i=h;return C|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+1;if((c[j>>2]|0)==(e|0)){B=-1;C=B;i=h;return C|0}e=c[j>>2]|0;if((a[c[j>>2]|0]|0)==62){c[f>>2]=e+1;B=3;C=B;i=h;return C|0}else{c[f>>2]=e;B=0;C=B;i=h;return C|0}}else if((l|0)==112){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==113){c[f>>2]=c[j>>2];B=0;C=B;i=h;return C|0}else if((l|0)==114){B=-1;C=B;i=h;return C|0}return 0}function bAc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;do{if((e-g|0)!=3){h=1}else{j=a[g]|0;if((j|0)==88){f=1}else if((j|0)!=120){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==77){f=1}else if((j|0)!=109){h=1;break}g=g+1|0;j=a[g]|0;if((j|0)==76){f=1}else if((j|0)!=108){h=1;break}if((f|0)!=0){h=0;break}else{c[d>>2]=12;h=1;break}}}while(0);i=b;return h|0}function cAc(a,b,e,f,g){a=a|0;b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+56|0;j=a;a=b;b=e;e=f;f=g;a:while(1){if((b|0)==(e|0)){k=27;break}g=d[a+76+(d[b]|0)|0]|0;switch(g|0){case 13:case 12:{b=b+1|0;if((g|0)!=(j|0)){continue a}else{k=21;break a}break};case 8:case 1:case 0:{k=19;break a;break};case 5:{if((e-b|0)<2){k=5;break a}l=b;if((xe[c[a+356>>2]&63](a,b)|0)!=0){k=7;break a}b=l+2|0;continue a;break};case 6:{if((e-b|0)<3){k=10;break a}m=b;if((xe[c[a+360>>2]&63](a,b)|0)!=0){k=12;break a}b=m+3|0;continue a;break};case 7:{if((e-b|0)<4){k=15;break a}n=b;if((xe[c[a+364>>2]&63](a,b)|0)!=0){k=17;break a}b=n+4|0;continue a;break};default:{b=b+1|0;continue a}}}if((k|0)==5){o=-2;p=o;i=h;return p|0}else if((k|0)==7){c[f>>2]=l;o=0;p=o;i=h;return p|0}else if((k|0)==10){o=-2;p=o;i=h;return p|0}else if((k|0)==12){c[f>>2]=m;o=0;p=o;i=h;return p|0}else if((k|0)==15){o=-2;p=o;i=h;return p|0}else if((k|0)==17){c[f>>2]=n;o=0;p=o;i=h;return p|0}else if((k|0)==19){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==21){if((b|0)==(e|0)){o=-27;p=o;i=h;return p|0}c[f>>2]=b;switch(d[a+76+(d[b]|0)|0]|0|0){case 20:case 30:case 11:case 10:case 9:case 21:{o=27;p=o;i=h;return p|0};default:{o=0;p=o;i=h;return p|0}}}else if((k|0)==27){o=-1;p=o;i=h;return p|0}return 0}function dAc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}f=d[h+76+(d[a]|0)|0]|0;if((f|0)==20){c[e>>2]=a+1;j=33;k=j;i=g;return k|0}else if((f|0)==24|(f|0)==22){a=a+1|0;a:while(1){if((a|0)==(b|0)){l=17;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{break};case 30:{l=10;break a;break};case 10:case 9:case 21:{break a;break};default:{l=16;break a}}a=a+1|0}do{if((l|0)==10){if((a+1|0)==(b|0)){j=-1;k=j;i=g;return k|0}m=d[h+76+(d[a+1|0]|0)|0]|0;if(!((m|0)==30|(m|0)==10|(m|0)==9|(m|0)==21)){break}c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==16){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==17){j=-1;k=j;i=g;return k|0}}while(0);c[e>>2]=a;j=16;k=j;i=g;return k|0}else if((f|0)==27){j=Yzc(h,a+1|0,b,e)|0;k=j;i=g;return k|0}else{c[e>>2]=a;j=0;k=j;i=g;return k|0}return 0}function eAc(a,b,e,f){a=a|0;b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+40|0;h=a;a=b;b=e;e=f;if((a|0)==(b|0)){j=-1;k=j;i=g;return k|0}a:do{switch(d[h+76+(d[a]|0)|0]|0|0){case 24:case 22:{a=a+1|0;break};case 29:{c[e>>2]=a;j=0;k=j;i=g;return k|0};case 7:{if((b-a|0)<4){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+352>>2]&63](h,a)|0)!=0){a=f+4|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 5:{if((b-a|0)<2){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+344>>2]&63](h,a)|0)!=0){a=f+2|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};case 6:{if((b-a|0)<3){j=-2;k=j;i=g;return k|0}f=a;if((xe[c[h+348>>2]&63](h,a)|0)!=0){a=f+3|0;break a}c[e>>2]=f;j=0;k=j;i=g;return k|0};default:{c[e>>2]=a;j=0;k=j;i=g;return k|0}}}while(0);b:while(1){if((a|0)==(b|0)){l=43;break}switch(d[h+76+(d[a]|0)|0]|0|0){case 6:{if((b-a|0)<3){l=32;break b}m=a;if((xe[c[h+336>>2]&63](h,a)|0)==0){l=34;break b}a=m+3|0;continue b;break};case 27:case 26:case 25:case 24:case 22:{a=a+1|0;continue b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{l=41;break b;break};case 7:{if((b-a|0)<4){l=37;break b}n=a;if((xe[c[h+340>>2]&63](h,a)|0)==0){l=39;break b}a=n+4|0;continue b;break};case 29:{l=24;break b;break};case 5:{if((b-a|0)<2){l=27;break b}o=a;if((xe[c[h+332>>2]&63](h,a)|0)==0){l=29;break b}a=o+2|0;continue b;break};default:{l=42;break b}}}if((l|0)==24){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==27){j=-2;k=j;i=g;return k|0}else if((l|0)==29){c[e>>2]=o;j=0;k=j;i=g;return k|0}else if((l|0)==32){j=-2;k=j;i=g;return k|0}else if((l|0)==34){c[e>>2]=m;j=0;k=j;i=g;return k|0}else if((l|0)==37){j=-2;k=j;i=g;return k|0}else if((l|0)==39){c[e>>2]=n;j=0;k=j;i=g;return k|0}else if((l|0)==41){c[e>>2]=a;j=20;k=j;i=g;return k|0}else if((l|0)==42){c[e>>2]=a;j=0;k=j;i=g;return k|0}else if((l|0)==43){j=-20;k=j;i=g;return k|0}return 0}function fAc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+40|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=5;break}if((c[e>>2]|0)==(f|0)){j=5;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g}if((j|0)==5){i=b;return}}function gAc(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;a=i;i=i+40|0;j=e;e=f;f=g;g=h;while(1){if((c[j>>2]|0)==(e|0)){k=5;break}if((c[f>>2]|0)==(g|0)){k=5;break}h=j;l=c[h>>2]|0;c[h>>2]=l+1;h=d[l]|0;l=f;m=c[l>>2]|0;c[l>>2]=m+2;b[m>>1]=h}if((k|0)==5){i=a;return}}function hAc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;i=i+48|0;h=d;d=e;e=f;f=g;while(1){if((c[h>>2]|0)==(d|0)){j=8;break}g=a[c[h>>2]|0]|0;if((g&128|0)!=0){if((f-(c[e>>2]|0)|0)<2){j=8;break}k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=(g&255)>>6|192;l=e;k=c[l>>2]|0;c[l>>2]=k+1;a[k]=g&63|128;g=h;c[g>>2]=(c[g>>2]|0)+1;continue}else{if((c[e>>2]|0)==(f|0)){j=8;break}g=h;k=c[g>>2]|0;c[g>>2]=k+1;g=a[k]|0;k=e;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=g;continue}}if((j|0)==8){i=b;return}}function iAc(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0;k=i;i=i+72|0;l=b;b=e;e=f;f=g;g=h;h=j;if((f|0)==(g|0)){m=-4;n=m;i=k;return n|0}j=c[b+76>>2]|0;a:do{if((f+1|0)==(g|0)){if(((a[b+73|0]|0)+ -3|0)>>>0<3){m=-1;n=m;i=k;return n|0}b:do{switch(d[f]|0){case 60:case 0:{break};case 239:case 255:case 254:{if((a[b+73|0]|0)!=0){break b}if((e|0)==1){break a}break};default:{break a}}}while(0);m=-1;n=m;i=k;return n|0}else{o=d[f]<<8|d[f+1|0];if((o|0)==61371){if((e|0)==1){p=a[b+73|0]|0;if((p|0)==0|(p|0)==4|(p|0)==5|(p|0)==3){break}}if((f+2|0)==(g|0)){m=-1;n=m;i=k;return n|0}if((d[f+2|0]|0)!=191){break}c[h>>2]=f+3;c[j>>2]=c[l+8>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65279){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+16>>2];m=14;n=m;i=k;return n|0}else if((o|0)==65534){if((a[b+73|0]|0)==0){if((e|0)==1){break}}c[h>>2]=f+2;c[j>>2]=c[l+20>>2];m=14;n=m;i=k;return n|0}else if((o|0)==15360){if((a[b+73|0]|0)==4){q=16}else{if((a[b+73|0]|0)==3){q=16}}if((q|0)==16){if((e|0)==1){break}}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f]|0)==0){if((e|0)==1){if((a[b+73|0]|0)==5){break}}c[j>>2]=c[l+16>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}else{if((a[f+1|0]|0)!=0){break}if((e|0)==1){break}c[j>>2]=c[l+20>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}}}}while(0);c[j>>2]=c[l+(a[b+73|0]<<2)>>2];m=He[c[(c[j>>2]|0)+(e<<2)>>2]&63](c[j>>2]|0,f,g,h)|0;n=m;i=k;return n|0}function jAc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+80|0;k=a;a=b;b=d;d=e;e=f;f=g;g=h;if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}if((lAc(kAc(k,a,b)|0)|0)==0){c[g>>2]=a;l=0;m=l;i=j;return m|0}do{a=a+(c[k+68>>2]|0)|0;}while((lAc(kAc(k,a,b)|0)|0)!=0);if((a|0)==(b|0)){c[d>>2]=0;l=1;m=l;i=j;return m|0}c[d>>2]=a;while(1){n=kAc(k,a,b)|0;if((n|0)==-1){o=10;break}if((n|0)==61){o=12;break}if((lAc(n)|0)!=0){o=14;break}a=a+(c[k+68>>2]|0)|0}do{if((o|0)==10){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==12){c[e>>2]=a}else if((o|0)==14){c[e>>2]=a;do{a=a+(c[k+68>>2]|0)|0;h=kAc(k,a,b)|0;n=h;}while((lAc(h)|0)!=0);if((n|0)==61){break}c[g>>2]=a;l=0;m=l;i=j;return m|0}}while(0);if((a|0)==(c[d>>2]|0)){c[g>>2]=a;l=0;m=l;i=j;return m|0}a=a+(c[k+68>>2]|0)|0;n=kAc(k,a,b)|0;while(1){if((lAc(n)|0)==0){break}a=a+(c[k+68>>2]|0)|0;n=kAc(k,a,b)|0}if((n|0)!=34&(n|0)!=39){c[g>>2]=a;l=0;m=l;i=j;return m|0}d=n&255;a=a+(c[k+68>>2]|0)|0;c[f>>2]=a;a:while(1){n=kAc(k,a,b)|0;if((n|0)==(d<<24>>24|0)){o=33;break}do{if(!(97<=(n|0)&(n|0)<=122)){if(65<=(n|0)&(n|0)<=90){break}if((48<=(n|0)&(n|0)<=57^1)&(n|0)!=46&(n|0)!=45&(n|0)!=95){o=31;break a}}}while(0);a=a+(c[k+68>>2]|0)|0}if((o|0)==31){c[g>>2]=a;l=0;m=l;i=j;return m|0}else if((o|0)==33){c[g>>2]=a+(c[k+68>>2]|0);l=1;m=l;i=j;return m|0}return 0}function kAc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+48|0;g=f+16|0;h=f+32|0;j=f+40|0;k=b;c[g>>2]=d;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,e,j,(c[j>>2]|0)+1|0);if((c[j>>2]|0)==(h|0)){l=-1;m=l;i=f;return m|0}else{l=a[h]|0;m=l;i=f;return m|0}return 0}function lAc(a){a=a|0;var b=0,c=0,d=0;b=i;i=i+16|0;c=a;if((c|0)==9|(c|0)==10|(c|0)==13|(c|0)==32){d=1}else{d=0}i=b;return d|0}function mAc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;c[d>>2]=13;c[d+16>>2]=1;c[d+12>>2]=0;c[d+20>>2]=0;i=b;return}function nAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{c[h>>2]=14;j=0;break};case 29:{c[h>>2]=16;j=2;break};case 14:{j=0;break};case 12:{c[h>>2]=14;j=1;break};case 13:{c[h>>2]=14;j=56;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,290120)|0)==0){k=10;break a}c[h>>2]=15;j=3;break};case 11:{c[h>>2]=14;j=55;break};default:{k=10}}}while(0);if((k|0)==10){j=rAc(h,a)|0}i=g;return j|0}function oAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;a:do{switch(a|0){case 33:{c[h>>2]=17;j=0;break};case 26:{k=9;break};case 15:{j=0;break};case 34:{if((c[h+12>>2]|0)==0){k=9;break a}b=h+12|0;c[b>>2]=(c[b>>2]|0)-1;j=0;break};case-4:{if((c[h+12>>2]|0)!=0){k=9;break a}j=0;break};default:{j=qAc(h,a,d,e,f)|0}}}while(0);if((k|0)==9){j=rAc(h,a)|0}i=g;return j|0}function pAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==15){j=0;k=j;i=g;return k|0}else if((f|0)==18){l=3}do{if((l|0)==3){if((He[c[e+28>>2]&63](e,b,d,290104)|0)!=0){c[h>>2]=18;j=0;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,290112)|0)==0){break}c[h>>2]=19;j=0;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function qAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;a:do{switch(a|0){case 15:{j=0;k=j;i=g;return k|0};case 26:{c[h>>2]=24;j=3;k=j;i=g;return k|0};case 16:{if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,289880)|0)!=0){c[h>>2]=20;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,289888)|0)!=0){c[h>>2]=21;j=33;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,289896)|0)!=0){c[h>>2]=22;j=39;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]<<1)|0,d,289904)|0)==0){break a}c[h>>2]=23;j=17;k=j;i=g;return k|0};case 13:{j=56;k=j;i=g;return k|0};case 11:{j=55;k=j;i=g;return k|0};case-4:{j=0;k=j;i=g;return k|0};case 28:{j=60;k=j;i=g;return k|0};default:{}}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function rAc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=a;do{if((c[e+16>>2]|0)==0){if((b|0)!=28){break}f=59;g=f;i=d;return g|0}}while(0);c[e>>2]=16;f=-1;g=f;i=d;return g|0}function sAc(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;e=i;i=i+40|0;i=e;return 0}function tAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=26;g=9}else if((b|0)==22){c[e>>2]=25;g=11}else if((b|0)==15){g=11}else{g=rAc(e,a)|0}i=f;return g|0}function uAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=27;g=34}else if((b|0)==15){g=33}else{g=rAc(e,a)|0}i=f;return g|0}function vAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=28;g=40}else{g=rAc(e,a)|0}i=f;return g|0}function wAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==18){c[e>>2]=29;g=18}else{g=rAc(e,a)|0}i=f;return g|0}function xAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==15){g=3}else{g=rAc(e,a)|0}i=f;return g|0}function yAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0}else if((b|0)==13){g=56}else if((b|0)==11){g=55}else if((b|0)==29){c[e>>2]=16;g=2}else{g=rAc(e,a)|0}i=f;return g|0}function zAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;if((f|0)==18){j=3}else if((f|0)==15){k=17;l=k;i=g;return l|0}do{if((j|0)==3){if((He[c[e+28>>2]&63](e,b,d,289920)|0)!=0){c[h>>2]=31;k=17;l=k;i=g;return l|0}if((He[c[e+28>>2]&63](e,b,d,289928)|0)==0){break}c[h>>2]=32;k=17;l=k;i=g;return l|0}}while(0);k=rAc(h,a)|0;l=k;i=g;return l|0}function AAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==15){g=17}else{g=rAc(e,a)|0}i=f;return g|0}function BAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=34;g=21}else{g=rAc(e,a)|0}i=f;return g|0}function CAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=17}else if((b|0)==27){c[e>>2]=33;c[e+8>>2]=17;g=19}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=20}else{g=rAc(e,a)|0}i=f;return g|0}function DAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=c[e+8>>2]|0;h=g;i=f;return h|0}else if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=c[e+8>>2]|0;h=g;i=f;return h|0}else{g=rAc(e,a)|0;h=g;i=f;return h|0}return 0}function EAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=39;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,289936)|0)!=0){c[h>>2]=33;c[h+8>>2]=39;j=42;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,289944)|0)==0){break}c[h>>2]=33;c[h+8>>2]=39;j=41;k=j;i=g;return k|0}else if((f|0)==23){c[h>>2]=37;c[h+4>>2]=1;j=44;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function FAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 30:{c[h>>2]=40;j=53;break};case 31:{c[h>>2]=40;j=52;break};case 41:case 18:{c[h>>2]=40;j=51;break};case 15:{j=39;break};case 20:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]|0)|0,e,289952)|0)==0){k=10;break a}c[h>>2]=38;j=43;break};case 32:{c[h>>2]=40;j=54;break};case 23:{c[h+4>>2]=2;c[h>>2]=39;j=44;break};default:{k=10}}}while(0);if((k|0)==10){j=rAc(h,a)|0}i=g;return j|0}function GAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=33;c[e+8>>2]=39;g=45}else if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else if((b|0)==15){g=39}else{g=rAc(e,a)|0}i=f;return g|0}function HAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 32:{c[e>>2]=40;g=54;break};case 31:{c[e>>2]=40;g=52;break};case 15:{g=39;break};case 30:{c[e>>2]=40;g=53;break};case 41:case 18:{c[e>>2]=40;g=51;break};case 23:{b=e+4|0;c[b>>2]=(c[b>>2]|0)+1;g=44;break};default:{g=rAc(e,a)|0}}i=f;return g|0}function IAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;switch(a|0){case 35:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=47;h=g;i=f;return h|0};case 37:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=48;h=g;i=f;return h|0};case 21:{c[e>>2]=39;g=49;h=g;i=f;return h|0};case 36:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=46;h=g;i=f;return h|0};case 24:{b=e+4|0;c[b>>2]=(c[b>>2]|0)-1;if((c[e+4>>2]|0)==0){c[e>>2]=33;c[e+8>>2]=39}g=45;h=g;i=f;return h|0};case 15:{g=39;h=g;i=f;return h|0};case 38:{c[e>>2]=39;g=50;h=g;i=f;return h|0};default:{g=rAc(e,a)|0;h=g;i=f;return h|0}}return 0}function JAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=39}else if((b|0)==41|(b|0)==18){c[e>>2]=42;g=51}else{g=rAc(e,a)|0}i=f;return g|0}function KAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==21){c[e>>2]=41;g=39}else if((b|0)==15){g=39}else if((b|0)==36){c[e>>2]=33;c[e+8>>2]=39;g=46}else{g=rAc(e,a)|0}i=f;return g|0}function LAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=33}else if((b|0)==41|(b|0)==18){c[e>>2]=43;g=22}else if((b|0)==15){g=33}else{g=rAc(e,a)|0}i=f;return g|0}function MAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;i=i+56|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){j=0;while(1){k=c[e+28>>2]|0;l=e;m=b;n=d;if((j|0)>=8){break}if((He[k&63](l,m,n,c[289960+(j<<2)>>2]|0)|0)!=0){o=6;break}j=j+1|0}if((o|0)==6){c[h>>2]=44;p=23+j|0;q=p;i=g;return q|0}if((He[k&63](l,m,n,289904)|0)==0){break}c[h>>2]=45;p=33;q=p;i=g;return q|0}else if((f|0)==23){c[h>>2]=46;p=33;q=p;i=g;return q|0}else if((f|0)==15){p=33;q=p;i=g;return q|0}}while(0);p=rAc(h,a)|0;q=p;i=g;return q|0}function NAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=33;k=j;i=g;return k|0}else if((f|0)==20){if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,290064)|0)!=0){c[h>>2]=27;j=35;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,290072)|0)!=0){c[h>>2]=27;j=36;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b+(c[e+68>>2]|0)|0,d,290088)|0)==0){break}c[h>>2]=47;j=33;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=27;j=37;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function OAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==23){c[e>>2]=48;g=33}else{g=rAc(e,a)|0}i=f;return g|0}function PAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==41|(b|0)==18|(b|0)==19){c[e>>2]=49;g=31}else{g=rAc(e,a)|0}i=f;return g|0}function QAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==24){c[e>>2]=44;g=33}else if((b|0)==21){c[e>>2]=46;g=33}else if((b|0)==15){g=33}else{g=rAc(e,a)|0}i=f;return g|0}function RAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=50;g=32}else if((b|0)==15){g=33}else{g=rAc(e,a)|0}i=f;return g|0}function SAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=33}else if((b|0)==21){c[e>>2]=48;g=33}else if((b|0)==24){c[e>>2]=44;g=33}else{g=rAc(e,a)|0}i=f;return g|0}function TAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=27;g=38}else if((b|0)==15){g=33}else{g=rAc(e,a)|0}i=f;return g|0}function UAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==18){c[e>>2]=51;g=10}else{g=rAc(e,a)|0}i=f;return g|0}function VAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,289920)|0)!=0){c[h>>2]=52;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,289928)|0)==0){break}c[h>>2]=53;j=11;k=j;i=g;return k|0}else if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function WAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=54;g=13}else{g=rAc(e,a)|0}i=f;return g|0}function XAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=52;g=14}else{g=rAc(e,a)|0}i=f;return g|0}function YAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,290096)|0)==0){break}c[h>>2]=55;j=11;k=j;i=g;return k|0}else if((f|0)==17){c[h>>2]=(c[h+16>>2]|0)!=0?35:36;j=15;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function ZAc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==18){c[e>>2]=33;c[e+8>>2]=11;g=16}else if((b|0)==15){g=11}else{g=rAc(e,a)|0}i=f;return g|0}function _Ac(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==15){j=11;k=j;i=g;return k|0}else if((f|0)==27){c[h>>2]=33;c[h+8>>2]=11;j=12;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,289920)|0)!=0){c[h>>2]=56;j=11;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,289928)|0)==0){break}c[h>>2]=57;j=11;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function $Ac(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=58;g=13}else if((b|0)==15){g=11}else{g=rAc(e,a)|0}i=f;return g|0}function aBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=11}else if((b|0)==27){c[e>>2]=56;g=14}else{g=rAc(e,a)|0}i=f;return g|0}function bBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=(c[e+16>>2]|0)!=0?35:36;g=15;h=g;i=f;return h|0}else if((b|0)==15){g=11;h=g;i=f;return h|0}else{g=rAc(e,a)|0;h=g;i=f;return h|0}return 0}function cBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==15){g=0;h=g;i=f;return h|0}else if((b|0)==25){c[e>>2]=36;b=e+12|0;c[b>>2]=(c[b>>2]|0)+1;g=0;h=g;i=f;return h|0}else{g=rAc(e,a)|0;h=g;i=f;return h|0}return 0}function dBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==25){c[e>>2]=36;g=58}else if((b|0)==15){g=0}else{g=rAc(e,a)|0}i=f;return g|0}function eBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=f;a:do{switch(a|0){case 15:{j=0;break};case 13:{j=56;break};case 14:{j=0;break};case 16:{if((He[c[b+28>>2]&63](b,d+(c[b+68>>2]<<1)|0,e,290120)|0)==0){k=9;break a}c[h>>2]=15;j=3;break};case 11:{j=55;break};case 29:{c[h>>2]=16;j=2;break};default:{k=9}}}while(0);if((k|0)==9){j=rAc(h,a)|0}i=g;return j|0}function fBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==41|(b|0)==18){c[e>>2]=59;g=4}else if((b|0)==15){g=3}else{g=rAc(e,a)|0}i=f;return g|0}function gBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=a;a=b;b=d;d=e;e=f;f=a;do{if((f|0)==17){c[h>>2]=30;j=8;k=j;i=g;return k|0}else if((f|0)==15){j=3;k=j;i=g;return k|0}else if((f|0)==18){if((He[c[e+28>>2]&63](e,b,d,289920)|0)!=0){c[h>>2]=60;j=3;k=j;i=g;return k|0}if((He[c[e+28>>2]&63](e,b,d,289928)|0)==0){break}c[h>>2]=61;j=3;k=j;i=g;return k|0}else if((f|0)==25){c[h>>2]=35;j=7;k=j;i=g;return k|0}}while(0);j=rAc(h,a)|0;k=j;i=g;return k|0}function hBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=62;g=5}else if((b|0)==15){g=3}else{g=rAc(e,a)|0}i=f;return g|0}function iBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==27){c[e>>2]=60;g=6}else if((b|0)==15){g=3}else{g=rAc(e,a)|0}i=f;return g|0}function jBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;f=i;i=i+48|0;e=a;a=b;b=a;if((b|0)==17){c[e>>2]=30;g=8}else if((b|0)==25){c[e>>2]=35;g=7}else if((b|0)==15){g=3}else{g=rAc(e,a)|0}i=f;return g|0}function kBc(){i=i;return}function lBc(){i=i;return}function mBc(){var a=0;a=i;Wa(290128,0)|0;i=a;return}function nBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;c[a+8>>2]=b;c[a>>2]=d;b=a+4|0;c[b>>2]=ZBc(d)|0;if((d|0)>0){g=0}else{i=f;return}do{a=c[e>>2]|0;h=c[a>>2]|0;c[e>>2]=a+4;c[(c[b>>2]|0)+(g<<2)>>2]=h;g=g+1|0;}while((g|0)<(d|0));i=f;return}function oBc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;if((a|0)==0){e=c[r>>2]|0;rc(290136,29,1,e|0)|0;ud(e|0)|0;f=0;i=b;return f|0}e=c[a>>2]|0;if((e|0)<0){g=c[r>>2]|0;rc(290168,54,1,g|0)|0;ud(g|0)|0;f=0;i=b;return f|0}g=c[a+4>>2]|0;if((g|0)==0){a=c[r>>2]|0;rc(290224,47,1,a|0)|0;ud(a|0)|0;f=0;i=b;return f|0}if((e|0)>0){h=0}else{f=1;i=b;return f|0}while(1){j=c[g+(h<<2)>>2]|0;a=h+1|0;if((j|0)<0){break}if((a|0)<(e|0)){h=a}else{f=1;k=11;break}}if((k|0)==11){i=b;return f|0}k=c[r>>2]|0;c[d>>2]=h;c[d+4>>2]=j;wd(k|0,290272,d|0)|0;ud(k|0)|0;f=0;i=b;return f|0}function pBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=c[a>>2]|0;h=c[b>>2]|0;if((g|0)!=(h|0)){j=c[r>>2]|0;c[f>>2]=g;c[f+4>>2]=h;wd(j|0,290360,f|0)|0;k=0;i=d;return k|0}if((g|0)<=0){k=1;i=d;return k|0}f=c[a+4>>2]|0;a=c[b+4>>2]|0;b=0;while(1){l=c[f+(b<<2)>>2]|0;m=c[a+(b<<2)>>2]|0;j=b+1|0;if((l|0)!=(m|0)){break}if((j|0)<(g|0)){b=j}else{k=1;n=8;break}}if((n|0)==8){i=d;return k|0}n=c[r>>2]|0;c[e>>2]=b;c[e+4>>2]=b;c[e+8>>2]=l;c[e+12>>2]=m;wd(n|0,290392,e|0)|0;k=0;i=d;return k|0}function qBc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;d=c[a>>2]|0;if((d|0)<=0){e=1;i=b;return e|0}f=c[a+4>>2]|0;a=0;g=1;while(1){h=fa(c[f+(a<<2)>>2]|0,g)|0;j=a+1|0;if((j|0)<(d|0)){g=h;a=j}else{e=h;break}}i=b;return e|0}function rBc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;c[a>>2]=1;f=ZBc(1)|0;c[a+4>>2]=f;c[f>>2]=b;c[a+8>>2]=d;i=e;return}function sBc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;c[a>>2]=b;f=a+4|0;c[f>>2]=ZBc(b)|0;if((b|0)>0){g=0;h=1}else{j=1;i=e;return j|0}while(1){a=c[d>>2]|0;k=c[a>>2]|0;c[d>>2]=a+4;c[(c[f>>2]|0)+(g<<2)>>2]=k;a=fa(k,h)|0;k=g+1|0;if((k|0)<(b|0)){h=a;g=k}else{j=a;break}}i=e;return j|0}function tBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((oBc(a)|0)==0){cb(290440,290336,262,290464)}e=c[a>>2]|0;f=b;c[f>>2]=e;g=ZBc(e)|0;c[b+4>>2]=g;if((g|0)==0){cb(290488,290336,266,290464)}b=c[f>>2]|0;if((b|0)<=0){i=d;return}f=c[a+4>>2]|0;a=0;do{c[g+(a<<2)>>2]=c[f+(a<<2)>>2];a=a+1|0;}while((a|0)<(b|0));i=d;return}function uBc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+40|0;f=e;g=e+24|0;if((b|0)<=0){h=0;i=e;return h|0}j=a+4|0;a=0;k=0;while(1){l=c[d>>2]|0;m=c[l>>2]|0;c[d>>2]=l+4;l=c[(c[j>>2]|0)+(a<<2)>>2]|0;if((m|0)<1|(m|0)>(l|0)){n=c[85374]|0;o=a+1|0;c[g>>2]=o;c[g+4>>2]=l;c[g+8>>2]=m;p=n;n=f;q=290512;c[n+0>>2]=c[q+0>>2];c[n+4>>2]=c[q+4>>2];c[n+8>>2]=c[q+8>>2];c[n+12>>2]=c[q+12>>2];c[n+16>>2]=c[q+16>>2];c[n+20>>2]=c[q+20>>2];Ie[p&63](0,f,290536,g);r=o;s=c[(c[j>>2]|0)+(a<<2)>>2]|0}else{r=a+1|0;s=l}l=m+ -1+(fa(s,k)|0)|0;if((r|0)<(b|0)){a=r;k=l}else{h=l;break}}i=e;return h|0}function vBc(){var a=0,b=0,d=0;a=i;b=292304|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=292416|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));b=292528|0;d=b+112|0;do{c[b>>2]=0;b=b+4|0}while((b|0)<(d|0));c[292308>>2]=1;c[292312>>2]=1;i=a;return}function wBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+24|0;e=d;f=c[b+4>>2]|0;g=c[b+8>>2]|0;h=c[b+12>>2]|0;j=c[b+16>>2]|0;k=(c[b+20>>2]|0)!=0?292664:292680;c[e>>2]=c[b>>2];c[e+4>>2]=f;c[e+8>>2]=g;c[e+12>>2]=h;c[e+16>>2]=j;c[e+20>>2]=k;wd(a|0,292640,e|0)|0;i=d;return}function xBc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=292528+(d<<2)|0;o=292416+(d<<2)|0;p=292728+(b<<2)|0;q=291008+(d<<2)|0;r=e;e=f;f=(g|0)!=0;a:while(1){b:do{if(f){c[l>>2]=292712;gc(292696,l|0)|0;s=292712}else{if((c[73072]|0)==(d|0)){if((c[o>>2]|0)>0){t=292712}else{u=5}}else{u=5}if((u|0)==5){u=0;t=c[q>>2]|0}c[m>>2]=t;gc(292696,m|0)|0;do{if((c[73072]|0)==(d|0)){if((c[n>>2]|0)!=(b|0)){break}if((c[o>>2]|0)>0){s=292712;break b}}}while(0);s=c[p>>2]|0}}while(0);c[k>>2]=s;gc(292720,k|0)|0;c[n>>2]=b;c[73072]=d;if((c[o>>2]|0)>0){g=0;while(1){gc(292752,j|0)|0;v=g+1|0;if((v|0)<(c[o>>2]|0)){g=v}else{w=0;break}}}else{w=0}while(1){x=e+w|0;g=a[x]|0;if(g<<24>>24==10){break}else if(g<<24>>24==0){break a}w=w+1|0}a[x]=0;tb(e|0)|0;r=0;e=e+(w+1)|0;f=1}tb(e|0)|0;ud(0)|0;if((r|0)==0){i=h;return}c[o>>2]=(c[o>>2]|0)+1;i=h;return}function yBc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+8|0;h=f;j=i;i=i+8|0;k=c[292728+(a<<2)>>2]|0;c[j>>2]=c[291008+(b<<2)>>2];c[j+4>>2]=k;gc(292760,j|0)|0;zBc(e);if((g|0)==0){Kd(((d|0)!=0?292800:292848)|0,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}tb(292928)|0;if((c[g>>2]|0)>=1){e=1;while(1){c[h>>2]=c[g+(e<<2)>>2];gc(292808,h|0)|0;if((e|0)<(c[g>>2]|0)){e=e+1|0}else{break}}}if((d|0)!=0){l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}rc(292832,11,1,c[t>>2]|0)|0;l=t;m=c[t>>2]|0;n=ud(m|0)|0;i=f;return}function zBc(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[t>>2]|0;f=b;while(1){b=a[f]|0;if(b<<24>>24==0){break}else if(b<<24>>24==62){rc(292888,4,1,e|0)|0}else if(b<<24>>24==60){rc(292880,4,1,e|0)|0}else if(b<<24>>24==38){rc(292872,5,1,e|0)|0}else{Sd(b<<24>>24|0,e|0)|0}f=f+1|0}i=d;return}function ABc(a){a=a|0;var b=0;b=292416+(a<<2)|0;c[b>>2]=(c[b>>2]|0)+ -1;i=i;return}function BBc(a){a=a|0;var b=0;b=(a|0)==0;c[73216]=b?1:19;c[73214]=b?7:747;i=i;return}function CBc(a){a=a|0;var b=0;a=i;b=c[t>>2]|0;rc(292832,11,1,b|0)|0;ud(b|0)|0;i=a;return}function DBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;g=i;i=i+2064|0;h=g+2048|0;if((c[292304+(a<<2)>>2]|0)==0){i=g;return}j=g;c[h>>2]=f;Zc(j|0,2048,e|0,h|0)|0;re[c[73216]&31](1,a,b,j,0,d);i=g;return}function EBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((c[292304+(a<<2)>>2]|0)==0){i=f;return}h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[73216]&31](1,a,b,h,0,0);i=f;return}function FBc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+2064|0;h=g;j=g+2048|0;do{if((c[73074]|0)==0){if((c[292304+(a<<2)>>2]|0)!=0){break}i=g;return}}while(0);k=h;c[j>>2]=f;Zc(k|0,2048,e|0,j|0)|0;re[c[73216]&31](2,a,b,k,0,d);i=g;return}function GBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f;h=f+2048|0;do{if((c[73074]|0)==0){if((c[292304+(a<<2)>>2]|0)!=0){break}i=f;return}}while(0);j=g;c[h>>2]=e;Zc(j|0,2048,d|0,h|0)|0;re[c[73216]&31](2,a,b,j,0,0);i=f;return}function HBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+2064|0;g=f+2048|0;if((b|0)!=0){i=f;return}b=f;c[g>>2]=e;Zc(b|0,2048,d|0,g|0)|0;re[c[73216]&31](4,2,0,b,0,0);if((a|0)==0){h=md(c[72532]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function IBc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+2064|0;f=e+2048|0;g=e;c[f>>2]=d;Zc(g|0,2048,b|0,f|0)|0;re[c[73216]&31](5,2,0,g,0,0);if((a|0)==0){h=md(c[72532]|0)|0}else{h=a}eb(c[h+76>>2]|0,1)}function JBc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+2064|0;g=f+2048|0;h=f;c[g>>2]=e;Zc(h|0,2048,d|0,g|0)|0;re[c[73216]&31](5,2,0,h,0,b);if((a|0)==0){j=md(c[72532]|0)|0}else{j=a}eb(c[j+76>>2]|0,1)}function KBc(a,b,d,e,f,g){a=a|0;b=+b;d=d|0;e=e|0;f=+f;g=g|0;var j=0,l=0,m=0;j=i;i=i+16|0;l=j;m=i;i=i+16|0;if(g<<24>>24==0){g=l;h[k>>3]=f;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];c[l+8>>2]=d;JBc(a,e,293e3,l)}else{l=m;h[k>>3]=f;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];c[m+8>>2]=d;FBc(26,0,e,292936,m);i=j;return+b}return 0.0}function LBc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=h4c(16)|0;HBc(0,(d|0)!=0|0,293048,b);c[d>>2]=0;c[d+4>>2]=0;c[d+8>>2]=a;c[d+12>>2]=0;i=b;return d|0}function MBc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)!=0){f=e;while(1){e=c[f+4>>2]|0;i4c(c[f>>2]|0);i4c(f);if((e|0)==0){break}else{f=e}}}c[a+12>>2]=0;c[d>>2]=0;c[a+4>>2]=0;i=b;return}function NBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;HBc(0,(a|0)!=0|0,293064,f);f=h4c(8)|0;g=f;HBc(0,(f|0)!=0|0,293048,e);e=a+8|0;h=h4c(c[e>>2]|0)|0;c[f>>2]=h;HBc(0,(h|0)!=0|0,293048,d);N4c(c[f>>2]|0,b|0,c[e>>2]|0)|0;e=a;c[f+4>>2]=c[e>>2];f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;c[e>>2]=g;e=a+4|0;if((c[e>>2]|0)!=0){i=d;return}c[e>>2]=g;i=d;return}function OBc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;HBc(0,(a|0)!=0|0,293064,f);f=h4c(8)|0;g=f;HBc(0,(f|0)!=0|0,293048,e);e=a+8|0;h=h4c(c[e>>2]|0)|0;c[f>>2]=h;HBc(0,(h|0)!=0|0,293048,d);N4c(c[f>>2]|0,b|0,c[e>>2]|0)|0;c[f+4>>2]=0;f=a+12|0;c[f>>2]=(c[f>>2]|0)+1;f=a+4|0;e=c[f>>2]|0;if((e|0)!=0){c[e+4>>2]=g}c[f>>2]=g;f=a;if((c[f>>2]|0)!=0){i=d;return}c[f>>2]=g;i=d;return}function PBc(a){a=a|0;var b=0;b=i;i=i+8|0;HBc(0,(a|0)!=0|0,293064,b);i=b;return c[a+12>>2]|0}function QBc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;HBc(0,(a|0)!=0|0,293064,d);d=a;HBc(0,(c[d>>2]|0)!=0|0,293088,b);i=b;return c[c[d>>2]>>2]|0}function RBc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;if((a|0)==0){i=b;return}d=a;e=c[d>>2]|0;if((e|0)==0){i=b;return}f=c[e+4>>2]|0;i4c(c[e>>2]|0);i4c(c[d>>2]|0);c[d>>2]=f;d=a+12|0;c[d>>2]=(c[d>>2]|0)+ -1;if((f|0)!=0){i=b;return}c[a+4>>2]=0;i=b;return}function SBc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;HBc(0,(a|0)!=0|0,293064,d);d=a;HBc(0,(c[d>>2]|0)!=0|0,293104,b);i=b;return c[d>>2]|0}function TBc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+8|0;d=(a|0)!=0;HBc(0,d&1,293136,b);if(!d){e=0;i=b;return e|0}e=c[a+4>>2]|0;i=b;return e|0}function UBc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=i;i=i+8|0;HBc(0,(a|0)!=0|0,293136,d);d=a;HBc(0,(c[d>>2]|0)!=0|0,293160,b);i=b;return c[d>>2]|0}function VBc(){var a=0,b=0,d=0;a=i;b=h4c(16)|0;c[73308]=b;c[b+4>>2]=0;c[b+8>>2]=2097152;d=h4c(2097152)|0;c[b>>2]=d;c[b+12>>2]=0;i=a;return}function WBc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=_Bc(a)|0;tc(293240)|0;$Bc(d);a=c[73308]|0;e=a+4|0;f=c[e>>2]|0;g=(c[a>>2]|0)+f|0;c[e>>2]=f+d;fc(293240)|0;P4c(g|0,0,d|0)|0;i=b;return g|0}function XBc(){var a=0,b=0,d=0,e=0;a=i;b=c[73308]|0;d=c[b+12>>2]|0;if((d|0)==0){e=b}else{b=d;while(1){d=c[b+12>>2]|0;i4c(c[b>>2]|0);i4c(b);if((d|0)==0){break}else{b=d}}e=c[73308]|0}c[e+4>>2]=0;c[e+12>>2]=0;i=a;return 0}function YBc(a){a=a|0;var b=0,d=0;b=i;d=ie[c[293192>>2]&127](a<<3)|0;i=b;return d|0}function ZBc(a){a=a|0;var b=0,d=0;b=i;d=ie[c[293192>>2]&127](a<<2)|0;i=b;return d|0}function _Bc(a){a=a|0;i=i;return a+7&-8|0}function $Bc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[73308]|0;e=d+8|0;if(!(((c[e>>2]|0)-(c[d+4>>2]|0)|0)>>>0<a>>>0)){i=b;return}f=h4c(16)|0;c[f+12>>2]=d;c[73308]=f;c[f+4>>2]=0;d=aCc((((c[e>>2]|0)*3|0)>>>1)+a|0)|0;c[f+8>>2]=d;a=h4c(d)|0;c[f>>2]=a;i=b;return}function aCc(a){a=a|0;var b=0;b=a+ -1|0;a=b>>>1|b;b=a>>>2|a;a=b>>>4|b;b=a>>>8|a;i=i;return(b>>>16|b)+1|0}function bCc(a){a=a|0;var b=0,c=0;b=i;c=L4c(a|0)|0;i=b;return c|0}function cCc(b,d){b=+b;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;j=i;i=i+400|0;l=g;m=j;a[l]=37;R4c(g+1|0,d|0)|0;d=f;h[k>>3]=b;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(m|0,l|0,f|0)|0;f=dCc(m)|0;i=e;return f|0}function dCc(a){a=a|0;var b=0,c=0,d=0;b=i;c=L4c(a|0)|0;d=fCc(c)|0;N4c(d|0,a|0,c|0)|0;i=b;return d|0}function eCc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+8|0;f=e;g=i;i=i+40|0;h=i;i=i+400|0;j=g;k=h;a[j]=37;R4c(g+1|0,d|0)|0;c[f>>2]=b;hc(k|0,j|0,f|0)|0;f=dCc(k)|0;i=e;return f|0}function fCc(b){b=b|0;var d=0,e=0;d=i;e=ie[c[293196>>2]&127](b+1|0)|0;if((e|0)==0){i=d;return e|0}a[e+b|0]=0;i=d;return e|0}function gCc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=i;d=bCc(a)|0;e=bCc(b)|0;f=fCc(e+d|0)|0;N4c(f|0,a|0,d|0)|0;N4c(f+d|0,b|0,e|0)|0;i=c;return f|0}function hCc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=H4c(c[a>>2]|0,c[b>>2]|0)|0;i=d;return e|0}function iCc(a){a=a|0;var b=0,c=0,d=0,e=0,f=0;b=i;c=(a|0)%100|0;d=(c|0)/10|0;e=(a|0)%10|0;a:do{if((a+999|0)>>>0>1998){f=-1}else{if((((a|0)%1e3|0)+99|0)>>>0>198){f=-1;break}if((e|0)==2){f=-1;break}else if((e|0)==1){if((c+ -50|0)>>>0>9){f=-1;break}}switch(d|0){case 3:{f=2;break a;break};case 5:{f=1;break a;break};case 0:{f=8;break a;break};case 1:{f=4;break a;break};case 2:{f=4;break a;break};case 4:{f=2;break a;break};default:{f=-1;break a}}}}while(0);i=b;return f|0}function jCc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=a;e=c[d>>2]|0;if((e|0)!=0){Yc(e|0)|0;c[d>>2]=0}e=a+4|0;f=c[e>>2]|0;if((f|0)!=0){i4c(f);c[e>>2]=0}e=a+8|0;if((c[e>>2]|0)!=0){f=a+12|0;g=0;do{i4c(c[(c[f>>2]|0)+(g<<4)>>2]|0);i4c(c[(c[f>>2]|0)+(g<<4)+4>>2]|0);g=g+1|0;}while(g>>>0<(c[e>>2]|0)>>>0)}c[e>>2]=0;if((c[d>>2]|0)!=0){d=a+12|0;i4c(c[d>>2]|0);c[d>>2]=0}d=a+20|0;e=c[d>>2]|0;if((e|0)!=0){i4c(e);c[d>>2]=0}d=a+24|0;e=c[d>>2]|0;g=a+40|0;if((e&2147483647|0)!=0){a=e;e=0;while(1){f=c[(c[g>>2]|0)+(e<<2)>>2]|0;if((f|0)==0){h=a}else{i4c(f);h=c[d>>2]|0}f=e+1|0;if(f>>>0<h<<1>>>0){a=h;e=f}else{break}}}c[d>>2]=0;d=c[g>>2]|0;if((d|0)==0){i=b;return}i4c(d);c[g>>2]=0;i=b;return}function kCc(b){b=b|0;var c=0,d=0,e=0,f=0,g=0;c=i;d=0;e=0;while(1){f=a[b+d|0]|0;if(f<<24>>24==32){g=e}else{a[b+e|0]=f;g=e+1|0}f=d+1|0;if(f>>>0>(L4c(b|0)|0)>>>0){break}else{d=f;e=g}}i=c;return}function lCc(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0;e=i;i=i+88|0;f=e;j=e+24|0;k=e+72|0;l=d+0|0;m=l+48|0;do{c[l>>2]=0;l=l+4|0}while((l|0)<(m|0));l=ic(b|0,293424)|0;m=d;c[m>>2]=l;if((l|0)==0){n=Wd(c[(Nc()|0)>>2]|0)|0;i=e;return n|0}c[d+4>>2]=Ad(b|0)|0;c[d+36>>2]=0;b=f;l=d+44|0;o=f;p=f+12|0;q=f+16|0;r=f+4|0;s=f+8|0;f=j;t=k;u=d+8|0;v=d+12|0;w=d+16|0;x=d+20|0;y=d+28|0;z=d+24|0;A=d+32|0;B=d+40|0;d=1;C=0;a:while(1){D=sb(b|0,20,1,c[m>>2]|0)|0;a[l]=1;if((D|0)!=1){n=293432;E=131;break}D=c[o>>2]|0;if((D|0)!=(c[293400+(C<<2)>>2]|0)){if(!((C|0)>3&(D|0)==10)){n=293456;E=131;break}a[l]=0}F=c[p>>2]|0;if(F>>>0>1){n=293480;E=131;break}G=iCc(D)|0;if((G|0)==-1){n=293512;E=131;break}D=c[q>>2]|0;H=h4c(D)|0;if((sb(H|0,D|0,1,c[m>>2]|0)|0)!=1){n=293560;E=131;break}if((a[H+(D+ -1)|0]|0)!=0){n=293584;E=131;break}D=c[r>>2]|0;I=c[s>>2]|0;J=fa(fa(fa(D,G)|0,I)|0,F+1|0)|0;if((H4c(H,c[293376+(C<<2)>>2]|0)|0)!=0){n=293608;E=131;break}i4c(H);H=294184;b:do{switch(C|0){case 2:{if(d<<24>>24==1){if((I|0)==0){K=1;E=129;break b}F=D+1|0;G=0;while(1){L=h4c(F)|0;c[(c[v>>2]|0)+(G<<4)+4>>2]=L;if((sb(c[(c[v>>2]|0)+(G<<4)+4>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=293808;E=131;break a}a[(c[(c[v>>2]|0)+(G<<4)+4>>2]|0)+D|0]=0;L=G+1|0;if(L>>>0<I>>>0){G=L}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}G=fa(D,I)|0;N=h4c(G+1|0)|0;if((sb(N|0,G|0,1,c[m>>2]|0)|0)!=1){E=46;break a}if((D|0)!=0){G=I+1|0;F=(I|0)==0;L=0;do{O=h4c(G)|0;c[(c[v>>2]|0)+(L<<4)+4>>2]=O;if(!F){O=0;do{P=a[N+((fa(D,O)|0)+L)|0]|0;a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+O|0]=P;O=O+1|0;}while(O>>>0<I>>>0)}a[(c[(c[v>>2]|0)+(L<<4)+4>>2]|0)+I|0]=0;L=L+1|0;}while(L>>>0<D>>>0)}i4c(N);M=0;E=130;break};case 1:{L=d<<24>>24==0;c[u>>2]=L?D:I;F=h4c((L?D:I)<<4)|0;c[v>>2]=F;c:do{if(d<<24>>24==1){if((I|0)==0){Q=0;break}G=D+1|0;O=F;P=0;while(1){c[O+(P<<4)>>2]=h4c(G)|0;if((sb(c[(c[v>>2]|0)+(P<<4)>>2]|0,D|0,1,c[m>>2]|0)|0)!=1){n=293808;E=131;break a}a[(c[(c[v>>2]|0)+(P<<4)>>2]|0)+D|0]=0;R=c[v>>2]|0;c[R+(P<<4)+8>>2]=-1;c[R+(P<<4)+12>>2]=-1;kCc(c[R+(P<<4)>>2]|0);R=P+1|0;if(!(R>>>0<I>>>0)){Q=I;break c}O=c[v>>2]|0;P=R}}else{Q=I}}while(0);if(!L){M=d;E=130;break b}F=fa(D,Q)|0;S=h4c(F+1|0)|0;if((sb(S|0,F|0,1,c[m>>2]|0)|0)!=1){E=33;break a}if((D|0)!=0){F=Q+1|0;P=(Q|0)==0;O=0;do{G=h4c(F)|0;c[(c[v>>2]|0)+(O<<4)>>2]=G;if(!P){G=0;do{R=a[S+((fa(D,G)|0)+O)|0]|0;a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+G|0]=R;G=G+1|0;}while(G>>>0<Q>>>0)}a[(c[(c[v>>2]|0)+(O<<4)>>2]|0)+Q|0]=0;G=c[v>>2]|0;c[G+(O<<4)+8>>2]=-1;c[G+(O<<4)+12>>2]=-1;kCc(c[G+(O<<4)>>2]|0);O=O+1|0;}while(O>>>0<D>>>0)}i4c(S);M=0;E=130;break};case 4:{if(d<<24>>24==1){if((D|0)==0){n=293872;E=131;break a}if(!((I+ -1|0)>>>0<2)){n=293928;E=131;break a}c[w>>2]=D;O=fa(I,D)|0;if((a[l]|0)==1){P=h4c(O<<3)|0;c[x>>2]=P;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=293968;E=131;break a}}else{P=h4c(O<<2)|0;c[x>>2]=h4c(fa(D<<3,I)|0)|0;if((sb(P|0,J|0,1,c[m>>2]|0)|0)!=1){n=293968;E=131;break a}if((O|0)!=0){F=c[x>>2]|0;L=0;do{h[F+(L<<3)>>3]=+g[P+(L<<2)>>2];L=L+1|0;}while(L>>>0<O>>>0)}i4c(P)}O=c[w>>2]|0;if(!(O>>>0>1)){M=1;E=130;break b}L=(I|0)==2;F=1;while(1){if(L){G=c[x>>2]|0;if(+h[G+(F<<3)>>3]!=+h[G+(O+F<<3)>>3]){n=294e3;E=131;break a}}G=F+1|0;if(G>>>0<O>>>0){F=G}else{M=1;E=130;break b}}}else if(!(d<<24>>24==0)){K=d;E=129;break b}if((I|0)==0){n=293872;E=131;break a}if(!((D+ -1|0)>>>0<2)){n=294080;E=131;break a}c[w>>2]=I;F=fa(I,D)|0;if((a[l]|0)==1){O=h4c(F<<3)|0;c[x>>2]=h4c(fa(D<<3,I)|0)|0;if((sb(O|0,J|0,1,c[m>>2]|0)|0)!=1){n=293968;E=131;break a}if((D|0)!=0){L=0;do{P=c[x>>2]|0;G=0;do{h[P+((fa(I,L)|0)+G<<3)>>3]=+h[O+((fa(D,G)|0)+L<<3)>>3];G=G+1|0;}while(G>>>0<I>>>0);L=L+1|0;}while(L>>>0<D>>>0)}i4c(O)}else{L=h4c(F<<2)|0;c[x>>2]=h4c(fa(D<<3,I)|0)|0;if((sb(L|0,J|0,1,c[m>>2]|0)|0)!=1){n=293968;E=131;break a}if((D|0)!=0){G=0;do{P=c[x>>2]|0;R=0;do{h[P+((fa(I,G)|0)+R<<3)>>3]=+g[L+((fa(D,R)|0)+G<<2)>>2];R=R+1|0;}while(R>>>0<I>>>0);G=G+1|0;}while(G>>>0<D>>>0)}i4c(L)}G=c[w>>2]|0;if(!(G>>>0>1)){M=d;E=130;break b}F=(D|0)==2;O=1;while(1){if(F){R=c[x>>2]|0;if(+h[R+(O<<3)>>3]!=+h[R+(G+O<<3)>>3]){n=294e3;E=131;break a}}R=O+1|0;if(R>>>0<G>>>0){O=R}else{M=d;E=130;break}}break};case 0:{if((D|0)!=4){n=293632;E=131;break a}if((I|0)!=11){n=293672;E=131;break a}if((sb(f|0,44,1,c[m>>2]|0)|0)==1){T=0}else{n=293712;E=131;break a}while(1){O=0;do{a[k+O|0]=a[j+((O<<2)+T)|0]|0;O=O+1|0;}while(O>>>0<11);a[k+11|0]=0;if((T|0)==3){break}O=T+1|0;if(O>>>0<4){T=O}else{M=d;E=130;break b}}if((I4c(t,c[73320]|0,8)|0)==0){M=1;E=130;break b}if((I4c(t,c[73326]|0,9)|0)==0){M=0;E=130}else{n=293744;E=131;break a}break};case 3:{O=fa(I<<2,D)|0;U=h4c(O)|0;if((sb(U|0,O|0,1,c[m>>2]|0)|0)!=1){E=52;break a}do{if(d<<24>>24==1){if((I|0)==0){break}O=c[v>>2]|0;G=0;do{F=fa(D,G)|0;c[O+(G<<4)+8>>2]=(c[U+(F<<2)>>2]|0)==1;c[O+(G<<4)+12>>2]=c[U+(F+1<<2)>>2];G=G+1|0;}while(G>>>0<I>>>0)}else if(d<<24>>24==0){if((D|0)==0){break}G=c[v>>2]|0;O=0;do{c[G+(O<<4)+8>>2]=(c[U+(O<<2)>>2]|0)==1;c[G+(O<<4)+12>>2]=c[U+(D+O<<2)>>2];O=O+1|0;}while(O>>>0<D>>>0)}}while(0);i4c(U);cc(c[v>>2]|0,c[u>>2]|0,16,54);M=d;E=130;break};case 5:{if(d<<24>>24==1){c[y>>2]=I;if(I>>>0<2){n=294120;E=131;break a}c[z>>2]=D;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=j4c(c[z>>2]<<1,4)|0;if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=294152;E=131;break a}else{M=1;E=130;break b}}else if(!(d<<24>>24==0)){n=0;E=131;break a}c[y>>2]=D;if(D>>>0<2){n=294120;E=131;break a}c[z>>2]=I;c[A>>2]=yb(c[m>>2]|0)|0;c[B>>2]=j4c(c[z>>2]<<1,4)|0;O=fa(I,D)|0;if((a[l]|0)==1){G=h4c(O<<3)|0;if((sb(G|0,J|0,1,c[m>>2]|0)|0)!=1){n=294152;E=131;break a}if((I|0)!=0){F=D<<3;L=(D|0)==0;R=D<<3;P=0;do{V=h4c(F)|0;c[(c[B>>2]|0)+(P<<2)>>2]=V;if(!L){V=G+(fa(R,P)|0)|0;N4c(c[(c[B>>2]|0)+(P<<2)>>2]|0,V|0,R|0)|0}P=P+1|0;}while(P>>>0<I>>>0)}P=c[z>>2]|0;R=P<<1;if(P>>>0<R>>>0){L=D<<3;F=(D|0)==0;V=P;do{W=h4c(L)|0;c[(c[B>>2]|0)+(V<<2)>>2]=W;if(!F){W=c[B>>2]|0;X=c[W+(V-P<<2)>>2]|0;Y=c[W+(V<<2)>>2]|0;W=0;do{h[Y+(W<<3)>>3]=-+h[X+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}V=V+1|0;}while(V>>>0<R>>>0)}i4c(G)}else{R=h4c(O<<2)|0;if((sb(R|0,J|0,1,c[m>>2]|0)|0)!=1){n=294152;E=131;break a}if((I|0)!=0){V=D<<3;P=(D|0)==0;F=0;do{L=h4c(V)|0;c[(c[B>>2]|0)+(F<<2)>>2]=L;if(!P){L=c[(c[B>>2]|0)+(F<<2)>>2]|0;W=0;do{h[L+(W<<3)>>3]=+g[R+((fa(D,F)|0)+W<<2)>>2];W=W+1|0;}while(W>>>0<D>>>0)}F=F+1|0;}while(F>>>0<I>>>0)}F=c[z>>2]|0;P=F<<1;if(F>>>0<P>>>0){V=D<<3;O=(D|0)==0;G=F;do{W=h4c(V)|0;c[(c[B>>2]|0)+(G<<2)>>2]=W;if(!O){W=c[B>>2]|0;L=c[W+(G-F<<2)>>2]|0;X=c[W+(G<<2)>>2]|0;W=0;do{h[X+(W<<3)>>3]=-+h[L+(W<<3)>>3];W=W+1|0;}while(W>>>0<D>>>0)}G=G+1|0;}while(G>>>0<P>>>0)}i4c(R)}if((Wc(c[m>>2]|0,J|0,1)|0)==-1){n=294152;E=131;break a}else{M=d;E=130}break};default:{n=H;E=131;break a}}}while(0);if((E|0)==129){E=0;d=K;C=C+1|0;continue}else if((E|0)==130){E=0;H=C+1|0;if((H|0)<6){d=M;C=H;continue}else{n=0;E=131;break}}}if((E|0)==33){i4c(S);n=293808;i=e;return n|0}else if((E|0)==46){i4c(N);n=293808;i=e;return n|0}else if((E|0)==52){i4c(U);n=293840;i=e;return n|0}else if((E|0)==131){i=e;return n|0}return 0}function mCc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=d;c[e>>2]=b;b=Ed(e|0,c[a+12>>2]|0,c[a+8>>2]|0,16,54)|0;i=d;return b|0}function nCc(b,d){b=b|0;d=d|0;var e=0,f=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;e=i;f=(d|0)>-1?d:0-d|0;j=(d|0)<0;do{if(j){k=c[b+24>>2]|0;l=k+f|0;m=k}else{if((d|0)==0){n=294224;o=n;p=294272;q=p;r=294296;s=r;cb(o|0,q|0,399,s|0)}else{l=f;m=c[b+24>>2]|0;break}}}while(0);d=l+ -1|0;l=b+24|0;if(f>>>0>m>>>0){n=294224;o=n;p=294272;q=p;r=294296;s=r;cb(o|0,q|0,399,s|0)}s=b+40|0;q=c[(c[s>>2]|0)+(d<<2)>>2]|0;if((q|0)!=0){t=q;i=e;return t|0}q=b+28|0;o=c[q>>2]|0;r=h4c(o<<3)|0;p=r;a:do{if((a[b+44|0]|0)==1){if((o|0)==0){break}n=b;m=b+32|0;k=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -8+((fa(c[l>>2]|0,k)|0)+f<<3)|0,0)|0;u=r+(k<<3)|0;if((sb(u|0,8,1,c[n>>2]|0)|0)!=1){break}if(j){h[u>>3]=-+h[u>>3]}k=k+1|0;if(!(k>>>0<(c[q>>2]|0)>>>0)){break a}}i4c(r);t=0;i=e;return t|0}else{k=h4c(o<<2)|0;b:do{if((o|0)==0){v=0}else{n=b;m=b+32|0;u=0;while(1){Wc(c[n>>2]|0,(c[m>>2]|0)+ -4+((fa(c[l>>2]|0,u)|0)+f<<2)|0,0)|0;w=u+1|0;if((sb(k+(u<<2)|0,4,1,c[n>>2]|0)|0)!=1){break}x=c[q>>2]|0;if(w>>>0<x>>>0){u=w}else{v=x;break b}}i4c(k);i4c(r);t=0;i=e;return t|0}}while(0);u=(v|0)==0;do{if(j){if(u){break}else{y=0}do{h[r+(y<<3)>>3]=-+g[k+(y<<2)>>2];y=y+1|0;}while(y>>>0<v>>>0)}else{if(u){break}else{z=0}do{h[r+(z<<3)>>3]=+g[k+(z<<2)>>2];z=z+1|0;}while(z>>>0<v>>>0)}}while(0);i4c(k)}}while(0);c[(c[s>>2]|0)+(d<<2)>>2]=p;t=c[(c[s>>2]|0)+(d<<2)>>2]|0;i=e;return t|0}function oCc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0;j=i;i=i+8|0;k=j;l=(e|0)>-1?e:0-e|0;m=(e|0)<0;do{if(m){n=c[d+24>>2]|0;o=n+l|0;p=n}else{if((e|0)==0){q=294224;r=q;s=294272;t=s;u=294320;v=u;cb(r|0,t|0,519,v|0)}else{o=l;p=c[d+24>>2]|0;break}}}while(0);if(l>>>0>p>>>0){q=294224;r=q;s=294272;t=s;u=294320;v=u;cb(r|0,t|0,519,v|0)}v=c[(c[d+40>>2]|0)+(o+ -1<<2)>>2]|0;if((v|0)!=0){h[b>>3]=+h[v+(f<<3)>>3];w=0.0;i=j;return+w}v=d;o=c[v>>2]|0;t=c[d+32>>2]|0;r=l+ -1+(fa(p,f)|0)|0;do{if((a[d+44|0]|0)==1){Wc(o|0,t+(r<<3)|0,0)|0;f=(sb(b|0,8,1,c[v>>2]|0)|0)!=1;if(f|m^1){w=f?1.0:0.0;i=j;return+w}else{x=+h[b>>3];break}}else{Wc(o|0,t+(r<<2)|0,0)|0;if((sb(k|0,4,1,c[v>>2]|0)|0)!=1){w=1.0;i=j;return+w}y=+g[k>>2];h[b>>3]=y;if(m){x=y;break}else{w=0.0}i=j;return+w}}while(0);h[b>>3]=-x;w=0.0;i=j;return+w}function pCc(a,b,d,e,f,g,j){a=+a;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0;k=i;l=d+ -1|0;d=0;while(1){m=((l-d|0)/2|0)+d|0;n=+h[b+(m<<3)>>3];if(n==a){o=n;p=m;q=3;break}r=n<a;s=r?m+1|0:d;t=r?l:m+ -1|0;if((t|0)>(s|0)){l=t;d=s}else{break}}if((q|0)==3){while(1){q=0;if((p|0)>=(l|0)){break}d=p+1|0;n=+h[b+(d<<3)>>3];if(o==n){o=n;p=d;q=3}else{break}}c[e>>2]=p;h[f>>3]=1.0;c[g>>2]=-1;u=0.0;h[j>>3]=u;i=k;return}do{if((t|0)==(s|0)){if(+h[b+(s<<3)>>3]<a){v=s+1|0;w=s;break}else{v=s;w=s+ -1|0;break}}else{v=t;w=s}}while(0);c[e>>2]=v;c[g>>2]=w;o=+h[b+(w<<3)>>3];n=(a-o)/(+h[b+(v<<3)>>3]-o);h[f>>3]=n;u=1.0-n;h[j>>3]=u;i=k;return}function qCc(a){a=a|0;i=i;return+(+h[c[a+20>>2]>>3])}function rCc(a){a=a|0;i=i;return+(+h[(c[a+20>>2]|0)+(c[a+16>>2]<<3)>>3])}function sCc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;f=i;i=i+48|0;g=f;j=f+8|0;k=f+16|0;l=f+24|0;m=f+32|0;n=f+40|0;if((c[d+8>>2]|0)!=0){o=c[d+12>>2]|0;if((o|0)<0){p=-+h[(c[b+20>>2]|0)+(~o<<3)>>3]}else{p=+h[(c[b+20>>2]|0)+(o+ -1<<3)>>3]}h[a>>3]=p;q=0;i=f;return q|0}if(+rCc(b)<e){q=1;i=f;return q|0}if(+qCc(b)>e){q=1;i=f;return q|0}if((nCc(b,1)|0)==0){q=1;i=f;return q|0}pCc(e,c[c[b+40>>2]>>2]|0,c[b+28>>2]|0,m,g,n,j);o=c[n>>2]|0;if((o|0)==-1){q=~~+oCc(a,b,c[d+12>>2]|0,c[m>>2]|0);i=f;return q|0}n=c[m>>2]|0;m=d+12|0;d=c[m>>2]|0;if((n|0)==-1){q=~~+oCc(a,b,d,o);i=f;return q|0}if(+oCc(k,b,d,n)!=0.0){q=1;i=f;return q|0}if(+oCc(l,b,c[m>>2]|0,o)!=0.0){q=1;i=f;return q|0}h[a>>3]=+h[g>>3]*+h[k>>3]+ +h[j>>3]*+h[l>>3];q=0;i=f;return q|0}function tCc(a,b){a=a|0;b=b|0;i=i;return+(+h[(c[a+8>>2]|0)+(b<<3)>>3])}function uCc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+16|0;g=f;c[g>>2]=e;nBc(a,b,d,g);i=f;return}function vCc(a,b){a=a|0;b=b|0;var c=0;c=i;rBc(a,b,YBc(b)|0);i=c;return}function wCc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;c[a+8>>2]=YBc(sBc(a,b,f)|0)|0;i=e;return}function xCc(a){a=a|0;var b=0;b=i;c[a+8>>2]=YBc(qBc(a)|0)|0;i=b;return}function yCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;if((oBc(a)|0)==0){cb(294352,294376,127,294400)}if((oBc(b)|0)==0){cb(294424,294376,128,294400)}if((pBc(a,b)|0)==0){cb(294448,294376,129,294400)}e=qBc(a)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=+tCc(a,b);zCc(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function zCc(a,b,c){a=a|0;b=b|0;c=+c;h[a+(b<<3)>>3]=c;i=i;return}function ACc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;if((oBc(a)|0)==0){cb(294352,294376,142,294488)}d=qBc(a)|0;if((d|0)==0){i=c;return}else{e=0}do{h[b+(e<<3)>>3]=+tCc(a,e);e=e+1|0;}while(e>>>0<d>>>0);i=c;return}function BCc(a,b){a=a|0;b=b|0;i=i;return a+(b<<3)|0}function CCc(a,b,d){a=+a;b=b|0;d=d|0;var e=0;e=i;zCc(c[d+8>>2]|0,b,a);i=e;return}function DCc(a,b,d,e){a=a|0;b=b|0;d=+d;e=e|0;var f=0,g=0,j=0,k=0;f=i;i=i+16|0;g=f;vCc(a,b);j=g;c[g>>2]=e;CCc(d,0,a);if((b|0)>1){k=1}else{i=f;return}do{e=c[j>>2]|0;d=+h[e>>3];c[j>>2]=e+8;CCc(d,k,a);k=k+1|0;}while((k|0)<(b|0));i=f;return}function ECc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=e;c[f>>2]=d;d=uBc(a,b,f)|0;f=BCc(c[a+8>>2]|0,d)|0;i=e;return f|0}function FCc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0.0;e=i;f=qBc(a)|0;if((f|0)==0){i=e;return}g=d+8|0;d=0;do{h=+tCc(a,d);j=h+ +tCc(b,d);zCc(c[g>>2]|0,d,j);d=d+1|0;}while(d>>>0<f>>>0);i=e;return}function GCc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;HCc(a,c);xCc(c);FCc(a,b,c);i=d;return}function HCc(a,b){a=a|0;b=b|0;var c=0;c=i;tBc(a,b);i=c;return}function ICc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0.0;d=i;HCc(a,b);xCc(b);e=qBc(b)|0;if((e|0)==0){i=d;return}f=b+8|0;b=0;do{g=-+tCc(a,b);zCc(c[f>>2]|0,b,g);b=b+1|0;}while(b>>>0<e>>>0);i=d;return}function JCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=h4c(20)|0;HBc(0,(f|0)!=0|0,294520,e);c[f+8>>2]=0;c[f+12>>2]=0;e=(a|0)<1?1:a;c[f+16>>2]=e;c[f+4>>2]=b;a=j4c(e,b)|0;c[f>>2]=a;HBc(0,(a|0)!=0|0,294520,d);i=d;return f|0}function KCc(a){a=a|0;var b=0;b=i;i4c(c[a>>2]|0);i4c(a);i=b;return}function LCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;f=i;i=i+16|0;g=i;i=i+8|0;h=a+12|0;HBc(0,(c[h>>2]|0)>0|0,294536,g);g=c[h>>2]|0;c[f>>2]=b;c[f+4>>2]=1-g;c[f+8>>2]=g+ -1;HBc(0,(g|0)>(b|0)|0,294560,f);f=c[h>>2]|0;c[e>>2]=b;c[e+4>>2]=1-f;c[e+8>>2]=f+ -1;HBc(0,(0-f|0)<(b|0)|0,294560,e);e=(c[a>>2]|0)+(fa(c[a+4>>2]|0,((c[a+8>>2]|0)+b|0)%(c[a+16>>2]|0)|0)|0)|0;i=d;return e|0}function MCc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=a+16|0;e=a+4|0;f=j4c(c[d>>2]<<1,c[e>>2]|0)|0;HBc(0,(f|0)!=0|0,294520,b);g=a+12|0;if((c[g>>2]|0)>0){h=c[e>>2]|0;j=0;do{k=f+(fa(h,j)|0)|0;l=LCc(a,j)|0;h=c[e>>2]|0;N4c(k|0,l|0,h|0)|0;j=j+1|0;}while((j|0)<(c[g>>2]|0))}g=a;i4c(c[g>>2]|0);c[g>>2]=f;c[d>>2]=c[d>>2]<<1;c[a+8>>2]=0;i=b;return}function NCc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=a+16|0;f=c[e>>2]|0;g=a+12|0;h=c[g>>2]|0;if((f|0)<(h+1|0)){MCc(a);j=c[e>>2]|0;k=c[g>>2]|0}else{j=f;k=h}h=c[a+4>>2]|0;N4c((c[a>>2]|0)+(fa(h,(k+(c[a+8>>2]|0)|0)%(j|0)|0)|0)|0,b|0,h|0)|0;c[g>>2]=(c[g>>2]|0)+1;i=d;return}function OCc(a){a=a|0;i=i;return c[a+12>>2]|0}function PCc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+8|0;j=a+12|0;HBc(0,(c[j>>2]|0)>0|0,294536,h);h=c[j>>2]|0;c[g>>2]=b;c[g+4>>2]=0;c[g+8>>2]=h+ -1;HBc(0,(h|0)>(b|0)|0,294560,g);g=(c[j>>2]|0)+ -1|0;c[f>>2]=b;c[f+4>>2]=0;c[f+8>>2]=g;HBc(0,b>>>31^1,294560,f);f=a+8|0;g=c[a+16>>2]|0;c[f>>2]=((fa(g+ -1|0,b)|0)+(c[f>>2]|0)|0)%(g|0)|0;if((d|0)==0){i=e;return}if((c[j>>2]|0)>0){k=0}else{i=e;return}do{c[d+(k<<2)>>2]=LCc(a,k)|0;k=k+1|0;}while((k|0)<(c[j>>2]|0));i=e;return}function QCc(a){a=a|0;i=i;return c[(c[73648]|0)+(a<<2)>>2]|0}function RCc(a){a=a|0;i=i;return c[(c[73650]|0)+(a<<2)>>2]|0}function SCc(a){a=a|0;i=i;return c[(c[73652]|0)+(a<<2)>>2]|0}function TCc(a){a=a|0;i=i;return c[(c[73654]|0)+(a<<2)>>2]|0}function UCc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;d=(c[73650]|0)+(a<<2)|0;e=c[d>>2]|0;f=(c[73652]|0)+(a<<2)|0;g=c[f>>2]|0;h=c[(c[73648]|0)+(a<<2)>>2]|0;if((h|0)==0){i=b;return}c[d>>2]=(e|0)!=0&e>>>0<h>>>0?e:h;c[f>>2]=g>>>0>h>>>0?g:h;i=b;return}function VCc(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[73656]|0;e=+WCc(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function WCc(a,b){a=a|0;b=b|0;i=i;return+(+(a|0)+ +(b|0)*1.0e-9)}function XCc(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[73658]|0;e=+WCc(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function YCc(a){a=a|0;var b=0,d=0,e=0.0;b=i;d=c[73660]|0;e=+WCc(c[d+(a<<3)>>2]|0,c[d+(a<<3)+4>>2]|0);i=b;return+e}function ZCc(a){a=a|0;i=i;return 0}function _Cc(a){a=a|0;var b=0,d=0;b=i;gb(4,(c[73662]|0)+(a<<3)|0)|0;d=(c[73648]|0)+(a<<2)|0;c[d>>2]=(c[d>>2]|0)+1;i=b;return}function $Cc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=c[73656]|0;f=e+(a<<3)|0;g=c[73660]|0;h=g+(a<<3)|0;c[h>>2]=(c[h>>2]|0)+(c[f>>2]|0);h=e+(a<<3)+4|0;e=g+(a<<3)+4|0;c[e>>2]=(c[e>>2]|0)+(c[h>>2]|0);e=(c[73654]|0)+(a<<2)|0;c[e>>2]=(c[e>>2]|0)+(c[(c[73648]|0)+(a<<2)>>2]|0);e=c[73658]|0;g=e+(a<<3)|0;aDc(d,c[g>>2]|0,c[e+(a<<3)+4>>2]|0,c[f>>2]|0,c[h>>2]|0);h=d;d=c[h+4>>2]|0;f=g;c[f>>2]=c[h>>2];c[f+4>>2]=d;UCc(a);d=c[73656]|0;c[d+(a<<3)>>2]=0;c[d+(a<<3)+4>>2]=0;c[(c[73648]|0)+(a<<2)>>2]=0;i=b;return}function aDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;h=(dDc(b,d,e,f)|0)<0;if(h){j=e;k=f}else{j=b;k=d}d=a;c[d>>2]=j;c[d+4>>2]=k;i=g;return}function bDc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+8|0;d=b;e=d;c[e>>2]=0;c[e+4>>2]=0;gb(4,d|0)|0;e=c[73662]|0;f=c[73656]|0;g=f+(a<<3)|0;h=(c[d>>2]|0)-(c[e+(a<<3)>>2]|0)+(c[g>>2]|0)|0;c[g>>2]=h;j=f+(a<<3)+4|0;f=(c[d+4>>2]|0)-(c[e+(a<<3)+4>>2]|0)+(c[j>>2]|0)|0;c[j>>2]=f;if((f|0)<=999999999){i=b;return}c[g>>2]=h+1;c[j>>2]=~~(+(f|0)+-1.0e9);i=b;return}function cDc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;if((a|0)<33){i=b;return}d=j4c(a,8)|0;c[73656]=d;e=j4c(a,8)|0;c[73658]=e;f=j4c(a,8)|0;c[73660]=f;g=j4c(a,8)|0;c[73662]=g;h=j4c(a,4)|0;c[73648]=h;j=j4c(a,4)|0;c[73654]=j;k=a<<2;l=h4c(k)|0;c[73650]=l;m=j4c(a,4)|0;c[73652]=m;P4c(l|0,-1,k|0)|0;if((d|0)==0){cb(294656,294672,393,294688)}if((e|0)==0){cb(294696,294672,394,294688)}if((f|0)==0){cb(294712,294672,395,294688)}if((g|0)==0){cb(294728,294672,396,294688)}if((h|0)==0){cb(294744,294672,397,294688)}if((l|0)==0){cb(294768,294672,398,294688)}if((m|0)==0){cb(294792,294672,399,294688)}if((j|0)==0){cb(294816,294672,400,294688)}else{i=b;return}}function dDc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;i=i;return((a|0)==(c|0)?b-d|0:a-c|0)|0}function eDc(a,b,d){a=a|0;b=b|0;d=+d;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+8|0;o=n;c[o>>2]=1;c[n+4>>2]=c[b>>2];if((a|0)==2){c[j>>2]=c[b+8>>2];n=j+4|0;h[k>>3]=d;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];FBc(17,0,o,296600,j);i=e;return}else if((a|0)==3){c[g>>2]=c[b+8>>2];j=g+4|0;h[k>>3]=d;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];FBc(17,0,o,296696,g);i=e;return}else if((a|0)==0){c[m>>2]=c[b+8>>2];g=m+4|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];FBc(17,0,o,296448,m);i=e;return}else if((a|0)==1){c[l>>2]=c[b+8>>2];m=l+4|0;h[k>>3]=d;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];FBc(17,0,o,296496,l);i=e;return}else{l=c[b+8>>2]|0;c[f>>2]=a;c[f+4>>2]=l;l=f+8|0;h[k>>3]=d;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];FBc(17,0,o,296760,f);i=e;return}}function fDc(a){a=a|0;var b=0;b=i;i4c(c[a+12>>2]|0);i4c(c[a+4>>2]|0);i4c(c[a+8>>2]|0);i=b;return}



function Ezb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25216>>3]=0.0;i=i;return}function Fzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25224>>3]=0.0;i=i;return}function Gzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25232>>3]=0.0;i=i;return}function Hzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25240>>3]=0.0;i=i;return}function Izb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25248>>3]=0.0;i=i;return}function Jzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25256>>3]=0.0;i=i;return}function Kzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25264>>3]=0.0;i=i;return}function Lzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25272>>3]=0.0;i=i;return}function Mzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25280>>3]=0.0;i=i;return}function Nzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25288>>3]=0.0;i=i;return}function Ozb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25296>>3]=0.0;i=i;return}function Pzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25304>>3]=0.0;i=i;return}function Qzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25312>>3]=0.0;i=i;return}function Rzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25320>>3]=0.0;i=i;return}function Szb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25328>>3]=0.0;i=i;return}function Tzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25352>>3]=0.0;i=i;return}function Uzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25360>>3]=0.0;i=i;return}function Vzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25368>>3]=0.0;i=i;return}function Wzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25376>>3]=0.0;i=i;return}function Xzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25384>>3]=0.0;i=i;return}function Yzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25392>>3]=0.0;i=i;return}function Zzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25400>>3]=0.0;i=i;return}function _zb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25424>>3]=0.0;i=i;return}function $zb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25432>>3]=0.0;i=i;return}function aAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25440>>3]=0.0;i=i;return}function bAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25448>>3]=0.0;i=i;return}function cAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25456>>3]=0.0;i=i;return}function dAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25464>>3]=0.0;i=i;return}function eAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25472>>3]=0.0;i=i;return}function fAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25496>>3]=0.0;i=i;return}function gAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25504>>3]=0.0;i=i;return}function hAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25512>>3]=0.0;i=i;return}function iAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25520>>3]=0.0;i=i;return}function jAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25528>>3]=0.0;i=i;return}function kAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25536>>3]=0.0;i=i;return}function lAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25544>>3]=0.0;i=i;return}function mAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25568>>3]=0.0;i=i;return}function nAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25576>>3]=0.0;i=i;return}function oAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25584>>3]=0.0;i=i;return}function pAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25592>>3]=0.0;i=i;return}function qAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25600>>3]=0.0;i=i;return}function rAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25608>>3]=0.0;i=i;return}function sAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25616>>3]=0.0;i=i;return}function tAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25640>>3]=0.0;i=i;return}function uAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25648>>3]=0.0;i=i;return}function vAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25656>>3]=0.0;i=i;return}function wAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25664>>3]=0.0;i=i;return}function xAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25672>>3]=0.0;i=i;return}function yAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25680>>3]=0.0;i=i;return}function zAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25688>>3]=0.0;i=i;return}function AAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25712>>3]=0.0;i=i;return}function BAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25720>>3]=0.0;i=i;return}function CAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25728>>3]=0.0;i=i;return}function DAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25736>>3]=0.0;i=i;return}function EAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25744>>3]=0.0;i=i;return}function FAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25752>>3]=0.0;i=i;return}function GAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25760>>3]=0.0;i=i;return}function HAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25768>>3]=0.0;i=i;return}function IAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25776>>3]=0.0;i=i;return}function JAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25784>>3]=0.0;i=i;return}function KAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25792>>3]=0.0;i=i;return}function LAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25800>>3]=0.0;i=i;return}function MAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25808>>3]=0.0;i=i;return}function NAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25816>>3]=0.0;i=i;return}function OAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25824>>3]=0.0;i=i;return}function PAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25832>>3]=1.0;i=i;return}function QAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25856>>3]=0.0;i=i;return}function RAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25880>>3]=0.0;i=i;return}function SAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25840>>3]=0.0;i=i;return}function TAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25864>>3]=1.0;i=i;return}function UAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25888>>3]=0.0;i=i;return}function VAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25848>>3]=0.0;i=i;return}function WAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25872>>3]=0.0;i=i;return}function XAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25896>>3]=1.0;i=i;return}function YAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25904>>3]=0.0;i=i;return}function ZAb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25912>>3]=0.0;i=i;return}function _Ab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25920>>3]=0.0;i=i;return}function $Ab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25928>>3]=0.0;i=i;return}function aBb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25936>>3]=0.0;i=i;return}function bBb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25944>>3]=0.0;i=i;return}function cBb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+2|0]=a[d]|0;i=i;return}function dBb(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+3|0]|0)==0){e=0}else{e=(a[d+4|0]|0)!=0|0}c[(c[b+420>>2]|0)+1952>>2]=e;i=i;return}function eBb(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e+3|0]|0)==0){f=0}else{if((a[e+4|0]|0)==0){f=0;break}f=(a[e+7|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+1956>>2]=f;i=d;return}function fBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38656>>3]=+h[b+38608>>3]*.5;i=i;return}function gBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38664>>3]=+h[b+38608>>3]*.2;i=i;return}function hBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38672>>3]=+h[b+38608>>3]*.1;i=i;return}function iBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38680>>3]=+h[b+38608>>3]*.05;i=i;return}function jBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38688>>3]=+h[b+38608>>3]*.1;i=i;return}function kBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38696>>3]=+h[b+38608>>3]*.05;i=i;return}function lBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38704>>3]=+h[b+38608>>3]/9.0;i=i;return}function mBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38712>>3]=+h[b+38608>>3]*.025;i=i;return}function nBb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38624>>3];j=+h[f+38656>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6440,6432,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+38720>>3]=l;i=d;return}function oBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38728>>3]=+h[b+38656>>3]*.5;i=i;return}function pBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38736>>3]=+h[b+38656>>3]*1.05;i=i;return}function qBb(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38744>>3]=+sd(+(+h[d+38656>>3]),+(+h[d+38720>>3]*5.0));i=b;return}function rBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38752>>3]=+h[b+38720>>3]*3.0;i=i;return}function sBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38760>>3]=+h[b+38720>>3];i=i;return}function tBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38768>>3]=+h[b+38720>>3]*3.0;i=i;return}function uBb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+38728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+38776>>3]=l;i=d;return}function vBb(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38784>>3]=+td(0.0,+(+h[d+38656>>3]- +h[d+38744>>3]));i=b;return}function wBb(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38792>>3]=+sd(+(+h[d+38728>>3]),+(+h[d+38776>>3]*4.0));i=b;return}function xBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38800>>3]=+h[b+38776>>3]*3.0;i=i;return}function yBb(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38808>>3]=+td(0.0,+(+h[d+38728>>3]- +h[d+38792>>3]));i=b;return}function zBb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+8|0]=a[d]|0;i=i;return}function ABb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38896>>3]=+h[b+38888>>3];i=i;return}function BBb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+12|0]=a[d+8|0]|0;i=i;return}function CBb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+14|0]=a[d+8|0]|0;i=i;return}function DBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+38816>>3];i=i;return}function EBb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14368>>3]=+h[b+23800>>3]+(+h[d+344>>3]*-.4999999999999999+ +h[d+352>>3]*.8660254037844387);i=i;return}function FBb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14360>>3]=+h[b+23792>>3]+(+h[d+344>>3]*.8660254037844387+ +h[d+352>>3]*.4999999999999999);i=i;return}function GBb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+336>>3]- +h[b+360>>3];e=+h[b+344>>3]- +h[b+368>>3];f=+h[b+352>>3]- +h[b+376>>3];h[b+38960>>3]=+V(+(d*d+e*e+f*f));i=i;return}function HBb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+38960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+38968>>3]=l;i=d;return}function IBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38976>>3]=+h[b+38968>>3];i=i;return}function JBb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+16|0]=a[d+8|0]|0;i=i;return}function KBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+38824>>3];i=i;return}function LBb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+432>>3]- +h[b+456>>3];e=+h[b+440>>3]- +h[b+464>>3];f=+h[b+448>>3]- +h[b+472>>3];h[b+39e3>>3]=+V(+(d*d+e*e+f*f));i=i;return}function MBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+480>>3];i=i;return}function NBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+488>>3];i=i;return}function OBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+496>>3];i=i;return}function PBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+504>>3];i=i;return}function QBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+512>>3];i=i;return}function RBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+520>>3];i=i;return}function SBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+528>>3];i=i;return}function TBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+536>>3];i=i;return}function UBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+544>>3];i=i;return}function VBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+792>>3];i=i;return}function WBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+800>>3];i=i;return}function XBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+808>>3];i=i;return}function YBb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39120>>3]=+h[b+38704>>3];i=i;return}function ZBb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+1080>>3]=l;i=b;return}function _Bb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+1088>>3]=l;i=b;return}function $Bb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+1096>>3]=l;i=b;return}function aCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+1104>>3]=l;i=b;return}function bCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39128>>3]=+h[b+39120>>3]/3.0;i=i;return}function cCb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+28|0]=a[d+16|0]|0;i=i;return}function dCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1112>>3]=+h[b+432>>3];i=i;return}function eCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+440>>3];i=i;return}function fCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1128>>3]=+h[b+448>>3];i=i;return}function gCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1136>>3]=+h[b+456>>3];i=i;return}function hCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1144>>3]=+h[b+464>>3];i=i;return}function iCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+472>>3];i=i;return}function jCb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+39016>>3];j=+h[f+38984>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6568,6560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+39136>>3]=l;i=d;return}function kCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39144>>3]=+h[b+39e3>>3];i=i;return}function lCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39152>>3]=+h[b+39016>>3];i=i;return}function mCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39160>>3]=+h[b+39016>>3];i=i;return}function nCb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+32>>2]=c[b+28>>2];i=i;return}function oCb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+29|0]=a[d+8|0]|0;i=i;return}function pCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+38832>>3];i=i;return}function qCb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1208>>3]- +h[b+1232>>3];e=+h[b+1216>>3]- +h[b+1240>>3];f=+h[b+1224>>3]- +h[b+1248>>3];h[b+39184>>3]=+V(+(d*d+e*e+f*f));i=i;return}function rCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39192>>3]=+h[b+39168>>3];i=i;return}function sCb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+35|0]=a[d+29|0]|0;i=i;return}function tCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+1208>>3];i=i;return}function uCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+1216>>3];i=i;return}function vCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+1224>>3];i=i;return}function wCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1520>>3]=+h[b+1232>>3];i=i;return}function xCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1528>>3]=+h[b+1240>>3];i=i;return}function yCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1536>>3]=+h[b+1248>>3];i=i;return}function zCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39240>>3]=+h[b+39184>>3];i=i;return}function ACb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39248>>3]=+h[b+39200>>3];i=i;return}function BCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39256>>3]=+h[b+39216>>3];i=i;return}function CCb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+40>>2]=c[b+36>>2];i=i;return}function DCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1688>>3]=+h[b+1280>>3];i=i;return}function ECb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1696>>3]=+h[b+1288>>3];i=i;return}function FCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1704>>3]=+h[b+1296>>3];i=i;return}function GCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1712>>3]=+h[b+1304>>3];i=i;return}function HCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1720>>3]=+h[b+1312>>3];i=i;return}function ICb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1728>>3]=+h[b+1320>>3];i=i;return}function JCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+1328>>3];i=i;return}function KCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1744>>3]=+h[b+1336>>3];i=i;return}function LCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1752>>3]=+h[b+1344>>3];i=i;return}function MCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1760>>3]=+h[b+1688>>3];i=i;return}function NCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+1696>>3];i=i;return}function OCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+1704>>3];i=i;return}function PCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39328>>3]=+h[b+38704>>3];i=i;return}function QCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+1976>>3]=l;i=b;return}function RCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+1984>>3]=l;i=b;return}function SCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+1992>>3]=l;i=b;return}function TCb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+2e3>>3]=l;i=b;return}function UCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39336>>3]=+h[b+39328>>3]/3.0;i=i;return}function VCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2008>>3]=+h[b+38840>>3];i=i;return}function WCb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2008>>3]- +h[b+2032>>3];e=+h[b+2016>>3]- +h[b+2040>>3];f=+h[b+2024>>3]- +h[b+2048>>3];h[b+39352>>3]=+V(+(d*d+e*e+f*f));i=i;return}function XCb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+39352>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+39360>>3]=l;i=d;return}function YCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39368>>3]=+h[b+39360>>3];i=i;return}function ZCb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39376>>3]=+h[b+38816>>3]+(+h[b+38848>>3]+(-+h[b+38832>>3]- +h[b+38824>>3]));i=i;return}function _Cb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+43|0]=a[d+8|0]|0;i=i;return}function $Cb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2112>>3]=-+h[b+38848>>3];i=i;return}function aDb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2104>>3]- +h[b+2128>>3];e=+h[b+2112>>3]- +h[b+2136>>3];f=+h[b+2120>>3]- +h[b+2144>>3];h[b+39400>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39408>>3]=+h[b+39384>>3];i=i;return}function cDb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+49|0]=a[d+43|0]|0;i=i;return}function dDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2392>>3]=+h[b+2104>>3];i=i;return}function eDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2400>>3]=+h[b+2112>>3];i=i;return}function fDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2408>>3]=+h[b+2120>>3];i=i;return}function gDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2416>>3]=+h[b+2128>>3];i=i;return}function hDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2424>>3]=+h[b+2136>>3];i=i;return}function iDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2432>>3]=+h[b+2144>>3];i=i;return}function jDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39456>>3]=+h[b+39400>>3];i=i;return}function kDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39464>>3]=+h[b+39416>>3];i=i;return}function lDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39472>>3]=+h[b+39432>>3];i=i;return}function mDb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+52>>2]=c[b+48>>2];i=i;return}function nDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2584>>3]=+h[b+2176>>3];i=i;return}function oDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2592>>3]=+h[b+2184>>3];i=i;return}function pDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2600>>3]=+h[b+2192>>3];i=i;return}function qDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2608>>3]=+h[b+2200>>3];i=i;return}function rDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2616>>3]=+h[b+2208>>3];i=i;return}function sDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2624>>3]=+h[b+2216>>3];i=i;return}function tDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2632>>3]=+h[b+2224>>3];i=i;return}function uDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2640>>3]=+h[b+2232>>3];i=i;return}function vDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2648>>3]=+h[b+2240>>3];i=i;return}function wDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2656>>3]=+h[b+2584>>3];i=i;return}function xDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2664>>3]=+h[b+2592>>3];i=i;return}function yDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2672>>3]=+h[b+2600>>3];i=i;return}function zDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39544>>3]=+h[b+38704>>3];i=i;return}function ADb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+2872>>3]=l;i=b;return}function BDb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+2880>>3]=l;i=b;return}function CDb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+2888>>3]=l;i=b;return}function DDb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+2896>>3]=l;i=b;return}function EDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39552>>3]=+h[b+39544>>3]/3.0;i=i;return}function FDb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+56|0]=a[d+8|0]|0;i=i;return}function GDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2912>>3]=+h[b+38848>>3];i=i;return}function HDb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2904>>3]- +h[b+2928>>3];e=+h[b+2912>>3]- +h[b+2936>>3];f=+h[b+2920>>3]- +h[b+2944>>3];h[b+39576>>3]=+V(+(d*d+e*e+f*f));i=i;return}function IDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39584>>3]=+h[b+39560>>3];i=i;return}function JDb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+62|0]=a[d+56|0]|0;i=i;return}function KDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+2904>>3];i=i;return}function LDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3200>>3]=+h[b+2912>>3];i=i;return}function MDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3208>>3]=+h[b+2920>>3];i=i;return}function NDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3216>>3]=+h[b+2928>>3];i=i;return}function ODb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3224>>3]=+h[b+2936>>3];i=i;return}function PDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3232>>3]=+h[b+2944>>3];i=i;return}function QDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39632>>3]=+h[b+39576>>3];i=i;return}function RDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39640>>3]=+h[b+39592>>3];i=i;return}function SDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39648>>3]=+h[b+39608>>3];i=i;return}function TDb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+60>>2]=c[b+56>>2];i=i;return}function UDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3384>>3]=+h[b+2976>>3];i=i;return}function VDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3392>>3]=+h[b+2984>>3];i=i;return}function WDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+2992>>3];i=i;return}function XDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3e3>>3];i=i;return}function YDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3416>>3]=+h[b+3008>>3];i=i;return}function ZDb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3016>>3];i=i;return}function _Db(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3024>>3];i=i;return}function $Db(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3440>>3]=+h[b+3032>>3];i=i;return}function aEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3040>>3];i=i;return}function bEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3384>>3];i=i;return}function cEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3464>>3]=+h[b+3392>>3];i=i;return}function dEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3472>>3]=+h[b+3400>>3];i=i;return}function eEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39720>>3]=+h[b+38704>>3];i=i;return}function fEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+3672>>3]=l;i=b;return}function gEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+3680>>3]=l;i=b;return}function hEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+3688>>3]=l;i=b;return}function iEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+3696>>3]=l;i=b;return}function jEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39728>>3]=+h[b+39720>>3]/3.0;i=i;return}function kEb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+69|0]=a[d+8|0]|0;i=i;return}function lEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3704>>3]=+h[b+38856>>3];i=i;return}function mEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4064>>3]=+h[b+3752>>3];i=i;return}function nEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4072>>3]=+h[b+3760>>3];i=i;return}function oEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4080>>3]=+h[b+3768>>3];i=i;return}function pEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4088>>3]=+h[b+3776>>3];i=i;return}function qEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4096>>3]=+h[b+3784>>3];i=i;return}function rEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4104>>3]=+h[b+3792>>3];i=i;return}function sEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4112>>3]=+h[b+3800>>3];i=i;return}function tEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4120>>3]=+h[b+3808>>3];i=i;return}function uEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4128>>3]=+h[b+3816>>3];i=i;return}function vEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4136>>3]=+h[b+4064>>3];i=i;return}function wEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4144>>3]=+h[b+4072>>3];i=i;return}function xEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4152>>3]=+h[b+4080>>3];i=i;return}function yEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39872>>3]=+h[b+38704>>3];i=i;return}function zEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+4352>>3]=l;i=b;return}function AEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+4360>>3]=l;i=b;return}function BEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+4368>>3]=l;i=b;return}function CEb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+4376>>3]=l;i=b;return}function DEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39880>>3]=+h[b+39872>>3]/3.0;i=i;return}function EEb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+81|0]=a[d+69|0]|0;i=i;return}function FEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4384>>3]=+h[b+3704>>3];i=i;return}function GEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4392>>3]=+h[b+3712>>3];i=i;return}function HEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4400>>3]=+h[b+3720>>3];i=i;return}function IEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4408>>3]=+h[b+3728>>3];i=i;return}function JEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4416>>3]=+h[b+3736>>3];i=i;return}function KEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4424>>3]=+h[b+3744>>3];i=i;return}function LEb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+39768>>3];j=+h[f+39736>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6616,6608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+39888>>3]=l;i=d;return}function MEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39896>>3]=+h[b+39752>>3];i=i;return}function NEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39904>>3]=+h[b+39768>>3];i=i;return}function OEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39912>>3]=+h[b+39768>>3];i=i;return}function PEb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+68>>2]=c[b+64>>2];i=i;return}function QEb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+82|0]=a[d+8|0]|0;i=i;return}function REb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4480>>3]=+h[b+38840>>3]- +h[b+38856>>3];i=i;return}function SEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4840>>3]=+h[b+4528>>3];i=i;return}function TEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4848>>3]=+h[b+4536>>3];i=i;return}function UEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4856>>3]=+h[b+4544>>3];i=i;return}function VEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4864>>3]=+h[b+4552>>3];i=i;return}function WEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4872>>3]=+h[b+4560>>3];i=i;return}function XEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4880>>3]=+h[b+4568>>3];i=i;return}function YEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4888>>3]=+h[b+4576>>3];i=i;return}function ZEb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4896>>3]=+h[b+4584>>3];i=i;return}function _Eb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4904>>3]=+h[b+4592>>3];i=i;return}function $Eb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4912>>3]=+h[b+4840>>3];i=i;return}function aFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4920>>3]=+h[b+4848>>3];i=i;return}function bFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4928>>3]=+h[b+4856>>3];i=i;return}function cFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40056>>3]=+h[b+38704>>3];i=i;return}function dFb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+5128>>3]=l;i=b;return}function eFb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+5136>>3]=l;i=b;return}function fFb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+5144>>3]=l;i=b;return}function gFb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+5152>>3]=l;i=b;return}function hFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40064>>3]=+h[b+40056>>3]/3.0;i=i;return}function iFb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+94|0]=a[d+82|0]|0;i=i;return}function jFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5160>>3]=+h[b+4480>>3];i=i;return}function kFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14832>>3]=+h[b+5736>>3]+ +h[b+5160>>3];i=i;return}function lFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14808>>3]=+h[b+14832>>3]+ +h[(c[a+416>>2]|0)+3192>>3];i=i;return}function mFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14784>>3]=+h[b+14808>>3]+ +h[(c[a+416>>2]|0)+4384>>3];i=i;return}function nFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14736>>3]=+h[b+14784>>3]+ +h[(c[a+416>>2]|0)+2392>>3];i=i;return}function oFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14712>>3]=+h[b+14736>>3]+ +h[(c[a+416>>2]|0)+6120>>3];i=i;return}function pFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13904>>3]=+h[b+14712>>3]+ +h[(c[a+416>>2]|0)+12144>>3];i=i;return}function qFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5168>>3]=+h[b+4488>>3];i=i;return}function rFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5176>>3]=+h[b+4496>>3];i=i;return}function sFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5184>>3]=+h[b+4504>>3];i=i;return}function tFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5192>>3]=+h[b+4512>>3];i=i;return}function uFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5200>>3]=+h[b+4520>>3];i=i;return}function vFb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+39952>>3];j=+h[f+39920>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6656,6648,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40072>>3]=l;i=d;return}function wFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40080>>3]=+h[b+39936>>3];i=i;return}function xFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40088>>3]=+h[b+39952>>3];i=i;return}function yFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40096>>3]=+h[b+39952>>3];i=i;return}function zFb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+72>>2];i=i;return}function AFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5256>>3]=+h[b+38856>>3]*.5;i=i;return}function BFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14760>>3]=+h[b+14808>>3]+ +h[(c[a+416>>2]|0)+5256>>3];i=i;return}function CFb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5256>>3]- +h[b+5280>>3];e=+h[b+5264>>3]- +h[b+5288>>3];f=+h[b+5272>>3]- +h[b+5296>>3];h[b+40112>>3]=+V(+(d*d+e*e+f*f));i=i;return}function DFb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6688,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40120>>3]=l;i=d;return}function EFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40128>>3]=+h[b+40120>>3];i=i;return}function FFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5352>>3]=+h[b+38840>>3]+ +h[b+38856>>3]*-.5;i=i;return}function GFb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23784>>3]=+h[(c[a+416>>2]|0)+5352>>3];i=i;return}function HFb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14352>>3]=+h[b+23784>>3]+ +h[(c[a+416>>2]|0)+336>>3];i=i;return}function IFb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5352>>3]- +h[b+5472>>3];e=+h[b+5360>>3]- +h[b+5480>>3];f=+h[b+5368>>3]- +h[b+5488>>3];h[b+40152>>3]=+V(+(d*d+e*e+f*f));i=i;return}function JFb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40152>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6696,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40160>>3]=l;i=d;return}function KFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40168>>3]=+h[b+40160>>3];i=i;return}function LFb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5736>>3]- +h[b+5856>>3];e=+h[b+5744>>3]- +h[b+5864>>3];f=+h[b+5752>>3]- +h[b+5872>>3];h[b+40192>>3]=+V(+(d*d+e*e+f*f));i=i;return}function MFb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40192>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6704,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40200>>3]=l;i=d;return}function NFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40208>>3]=+h[b+40200>>3];i=i;return}function OFb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6120>>3]- +h[b+6240>>3];e=+h[b+6128>>3]- +h[b+6248>>3];f=+h[b+6136>>3]- +h[b+6256>>3];h[b+40232>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PFb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40232>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6712,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40240>>3]=l;i=d;return}function QFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40248>>3]=+h[b+40240>>3];i=i;return}function RFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40256>>3]=+h[b+39376>>3];i=i;return}function SFb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+99|0]=a[d]|0;i=i;return}function TFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40376>>3]=+h[b+40368>>3];i=i;return}function UFb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+103|0]=a[d+99|0]|0;i=i;return}function VFb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+105|0]=a[d+99|0]|0;i=i;return}function WFb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6752>>3]=+h[b+40296>>3];i=i;return}function XFb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14392>>3]=+h[b+14416>>3]+(+h[d+6752>>3]*.4999999999999999+ +h[d+6760>>3]*.8660254037844387);i=i;return}function YFb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14384>>3]=+h[b+14408>>3]+(+h[d+6752>>3]*.8660254037844387+ +h[d+6760>>3]*-.4999999999999999);i=i;return}function ZFb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6744>>3]- +h[b+6768>>3];e=+h[b+6752>>3]- +h[b+6776>>3];f=+h[b+6760>>3]- +h[b+6784>>3];h[b+40440>>3]=+V(+(d*d+e*e+f*f));i=i;return}function _Fb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40440>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6720,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40448>>3]=l;i=d;return}function $Fb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40456>>3]=+h[b+40448>>3];i=i;return}function aGb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+107|0]=a[d+99|0]|0;i=i;return}function bGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6848>>3]=+h[b+40304>>3];i=i;return}function cGb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6840>>3]- +h[b+6864>>3];e=+h[b+6848>>3]- +h[b+6872>>3];f=+h[b+6856>>3]- +h[b+6880>>3];h[b+40480>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7200>>3]=+h[b+6888>>3];i=i;return}function eGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7208>>3]=+h[b+6896>>3];i=i;return}function fGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7216>>3]=+h[b+6904>>3];i=i;return}function gGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7224>>3]=+h[b+6912>>3];i=i;return}function hGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7232>>3]=+h[b+6920>>3];i=i;return}function iGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7240>>3]=+h[b+6928>>3];i=i;return}function jGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7248>>3]=+h[b+6936>>3];i=i;return}function kGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7256>>3]=+h[b+6944>>3];i=i;return}function lGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7264>>3]=+h[b+6952>>3];i=i;return}function mGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7272>>3]=+h[b+7200>>3];i=i;return}function nGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7280>>3]=+h[b+7208>>3];i=i;return}function oGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7288>>3]=+h[b+7216>>3];i=i;return}function pGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40600>>3]=+h[b+38704>>3];i=i;return}function qGb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+7488>>3]=l;i=b;return}function rGb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+7496>>3]=l;i=b;return}function sGb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+7504>>3]=l;i=b;return}function tGb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+7512>>3]=l;i=b;return}function uGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40608>>3]=+h[b+40600>>3]/3.0;i=i;return}function vGb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+119|0]=a[d+107|0]|0;i=i;return}function wGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7520>>3]=+h[b+6840>>3];i=i;return}function xGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7528>>3]=+h[b+6848>>3];i=i;return}function yGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7536>>3]=+h[b+6856>>3];i=i;return}function zGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7544>>3]=+h[b+6864>>3];i=i;return}function AGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7552>>3]=+h[b+6872>>3];i=i;return}function BGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7560>>3]=+h[b+6880>>3];i=i;return}function CGb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+40496>>3];j=+h[f+40464>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6736,6728,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40616>>3]=l;i=d;return}function DGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40624>>3]=+h[b+40480>>3];i=i;return}function EGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40632>>3]=+h[b+40496>>3];i=i;return}function FGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40640>>3]=+h[b+40496>>3];i=i;return}function GGb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+116>>2]=c[b+112>>2];i=i;return}function HGb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+120|0]=a[d+99|0]|0;i=i;return}function IGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7624>>3]=+h[b+40312>>3];i=i;return}function JGb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+7616>>3]- +h[b+7640>>3];e=+h[b+7624>>3]- +h[b+7648>>3];f=+h[b+7632>>3]- +h[b+7656>>3];h[b+40664>>3]=+V(+(d*d+e*e+f*f));i=i;return}function KGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40672>>3]=+h[b+40648>>3];i=i;return}function LGb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+126|0]=a[d+120|0]|0;i=i;return}function MGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7904>>3]=+h[b+7616>>3];i=i;return}function NGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7912>>3]=+h[b+7624>>3];i=i;return}function OGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7920>>3]=+h[b+7632>>3];i=i;return}function PGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7928>>3]=+h[b+7640>>3];i=i;return}function QGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7936>>3]=+h[b+7648>>3];i=i;return}function RGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7944>>3]=+h[b+7656>>3];i=i;return}function SGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40720>>3]=+h[b+40664>>3];i=i;return}function TGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40728>>3]=+h[b+40680>>3];i=i;return}function UGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40736>>3]=+h[b+40696>>3];i=i;return}function VGb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+124>>2]=c[b+120>>2];i=i;return}function WGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8096>>3]=+h[b+7688>>3];i=i;return}function XGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8104>>3]=+h[b+7696>>3];i=i;return}function YGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8112>>3]=+h[b+7704>>3];i=i;return}function ZGb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8120>>3]=+h[b+7712>>3];i=i;return}function _Gb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8128>>3]=+h[b+7720>>3];i=i;return}function $Gb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8136>>3]=+h[b+7728>>3];i=i;return}function aHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8144>>3]=+h[b+7736>>3];i=i;return}function bHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8152>>3]=+h[b+7744>>3];i=i;return}function cHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8160>>3]=+h[b+7752>>3];i=i;return}function dHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8168>>3]=+h[b+8096>>3];i=i;return}function eHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8176>>3]=+h[b+8104>>3];i=i;return}function fHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8184>>3]=+h[b+8112>>3];i=i;return}function gHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40808>>3]=+h[b+38704>>3];i=i;return}function hHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+8384>>3]=l;i=b;return}function iHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+8392>>3]=l;i=b;return}function jHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+8400>>3]=l;i=b;return}function kHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+8408>>3]=l;i=b;return}function lHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40816>>3]=+h[b+40808>>3]/3.0;i=i;return}function mHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8416>>3]=+h[b+40320>>3];i=i;return}function nHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14688>>3]=+h[b+2008>>3]+ +h[b+8416>>3];i=i;return}function oHb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8416>>3]- +h[b+8440>>3];e=+h[b+8424>>3]- +h[b+8448>>3];f=+h[b+8432>>3]- +h[b+8456>>3];h[b+40832>>3]=+V(+(d*d+e*e+f*f));i=i;return}function pHb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40832>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6768,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40840>>3]=l;i=d;return}function qHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40848>>3]=+h[b+40840>>3];i=i;return}function rHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40856>>3]=+h[b+40296>>3]+(+h[b+40328>>3]+(-+h[b+40312>>3]- +h[b+40304>>3]));i=i;return}function sHb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+134|0]=a[d+99|0]|0;i=i;return}function tHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8520>>3]=-+h[b+40328>>3];i=i;return}function uHb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8512>>3]- +h[b+8536>>3];e=+h[b+8520>>3]- +h[b+8544>>3];f=+h[b+8528>>3]- +h[b+8552>>3];h[b+40880>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40888>>3]=+h[b+40864>>3];i=i;return}function wHb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+140|0]=a[d+134|0]|0;i=i;return}function xHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8800>>3]=+h[b+8512>>3];i=i;return}function yHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8808>>3]=+h[b+8520>>3];i=i;return}function zHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8816>>3]=+h[b+8528>>3];i=i;return}function AHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8824>>3]=+h[b+8536>>3];i=i;return}function BHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8832>>3]=+h[b+8544>>3];i=i;return}function CHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8840>>3]=+h[b+8552>>3];i=i;return}function DHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40936>>3]=+h[b+40880>>3];i=i;return}function EHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40944>>3]=+h[b+40896>>3];i=i;return}function FHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40952>>3]=+h[b+40912>>3];i=i;return}function GHb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+136>>2]=c[b+132>>2];i=i;return}function HHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8992>>3]=+h[b+8584>>3];i=i;return}function IHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9e3>>3]=+h[b+8592>>3];i=i;return}function JHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9008>>3]=+h[b+8600>>3];i=i;return}function KHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9016>>3]=+h[b+8608>>3];i=i;return}function LHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9024>>3]=+h[b+8616>>3];i=i;return}function MHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9032>>3]=+h[b+8624>>3];i=i;return}function NHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9040>>3]=+h[b+8632>>3];i=i;return}function OHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9048>>3]=+h[b+8640>>3];i=i;return}function PHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9056>>3]=+h[b+8648>>3];i=i;return}function QHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9064>>3]=+h[b+8992>>3];i=i;return}function RHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9072>>3]=+h[b+9e3>>3];i=i;return}function SHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9080>>3]=+h[b+9008>>3];i=i;return}function THb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41024>>3]=+h[b+38704>>3];i=i;return}function UHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+9280>>3]=l;i=b;return}function VHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+9288>>3]=l;i=b;return}function WHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+9296>>3]=l;i=b;return}function XHb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+9304>>3]=l;i=b;return}function YHb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41032>>3]=+h[b+41024>>3]/3.0;i=i;return}function ZHb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+147|0]=a[d+99|0]|0;i=i;return}function _Hb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9320>>3]=+h[b+40328>>3];i=i;return}function $Hb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9312>>3]- +h[b+9336>>3];e=+h[b+9320>>3]- +h[b+9344>>3];f=+h[b+9328>>3]- +h[b+9352>>3];h[b+41056>>3]=+V(+(d*d+e*e+f*f));i=i;return}function aIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41064>>3]=+h[b+41040>>3];i=i;return}function bIb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+153|0]=a[d+147|0]|0;i=i;return}function cIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9600>>3]=+h[b+9312>>3];i=i;return}function dIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9608>>3]=+h[b+9320>>3];i=i;return}function eIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9616>>3]=+h[b+9328>>3];i=i;return}function fIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9624>>3]=+h[b+9336>>3];i=i;return}function gIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9632>>3]=+h[b+9344>>3];i=i;return}function hIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9640>>3]=+h[b+9352>>3];i=i;return}function iIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41112>>3]=+h[b+41056>>3];i=i;return}function jIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41120>>3]=+h[b+41072>>3];i=i;return}function kIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41128>>3]=+h[b+41088>>3];i=i;return}function lIb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+144>>2]=c[b+140>>2];i=i;return}function mIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9792>>3]=+h[b+9384>>3];i=i;return}function nIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9800>>3]=+h[b+9392>>3];i=i;return}function oIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9808>>3]=+h[b+9400>>3];i=i;return}function pIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9816>>3]=+h[b+9408>>3];i=i;return}function qIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9824>>3]=+h[b+9416>>3];i=i;return}function rIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9832>>3]=+h[b+9424>>3];i=i;return}function sIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9840>>3]=+h[b+9432>>3];i=i;return}function tIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9848>>3]=+h[b+9440>>3];i=i;return}function uIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9856>>3]=+h[b+9448>>3];i=i;return}function vIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9864>>3]=+h[b+9792>>3];i=i;return}function wIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9872>>3]=+h[b+9800>>3];i=i;return}function xIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9880>>3]=+h[b+9808>>3];i=i;return}function yIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41200>>3]=+h[b+38704>>3];i=i;return}function zIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+10080>>3]=l;i=b;return}function AIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+10088>>3]=l;i=b;return}function BIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+10096>>3]=l;i=b;return}function CIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+10104>>3]=l;i=b;return}function DIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41208>>3]=+h[b+41200>>3]/3.0;i=i;return}function EIb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+160|0]=a[d+99|0]|0;i=i;return}function FIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10112>>3]=+h[b+40336>>3];i=i;return}function GIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10472>>3]=+h[b+10160>>3];i=i;return}function HIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10480>>3]=+h[b+10168>>3];i=i;return}function IIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10488>>3]=+h[b+10176>>3];i=i;return}function JIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10496>>3]=+h[b+10184>>3];i=i;return}function KIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10504>>3]=+h[b+10192>>3];i=i;return}function LIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10512>>3]=+h[b+10200>>3];i=i;return}function MIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10520>>3]=+h[b+10208>>3];i=i;return}function NIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10528>>3]=+h[b+10216>>3];i=i;return}function OIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10536>>3]=+h[b+10224>>3];i=i;return}function PIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10544>>3]=+h[b+10472>>3];i=i;return}function QIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10552>>3]=+h[b+10480>>3];i=i;return}function RIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10560>>3]=+h[b+10488>>3];i=i;return}function SIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41352>>3]=+h[b+38704>>3];i=i;return}function TIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+10760>>3]=l;i=b;return}function UIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+10768>>3]=l;i=b;return}function VIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+10776>>3]=l;i=b;return}function WIb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+10784>>3]=l;i=b;return}function XIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41360>>3]=+h[b+41352>>3]/3.0;i=i;return}function YIb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+172|0]=a[d+160|0]|0;i=i;return}function ZIb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10792>>3]=+h[b+10112>>3];i=i;return}function _Ib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10800>>3]=+h[b+10120>>3];i=i;return}function $Ib(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10808>>3]=+h[b+10128>>3];i=i;return}function aJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10816>>3]=+h[b+10136>>3];i=i;return}function bJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10824>>3]=+h[b+10144>>3];i=i;return}function cJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10832>>3]=+h[b+10152>>3];i=i;return}function dJb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+41248>>3];j=+h[f+41216>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6784,6776,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41368>>3]=l;i=d;return}function eJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41376>>3]=+h[b+41232>>3];i=i;return}function fJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41384>>3]=+h[b+41248>>3];i=i;return}function gJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41392>>3]=+h[b+41248>>3];i=i;return}function hJb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+152>>2]=c[b+148>>2];i=i;return}function iJb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+173|0]=a[d+99|0]|0;i=i;return}function jJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10888>>3]=+h[b+40320>>3]- +h[b+40336>>3];i=i;return}function kJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11248>>3]=+h[b+10936>>3];i=i;return}function lJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11256>>3]=+h[b+10944>>3];i=i;return}function mJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11264>>3]=+h[b+10952>>3];i=i;return}function nJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11272>>3]=+h[b+10960>>3];i=i;return}function oJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11280>>3]=+h[b+10968>>3];i=i;return}function pJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11288>>3]=+h[b+10976>>3];i=i;return}function qJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11296>>3]=+h[b+10984>>3];i=i;return}function rJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11304>>3]=+h[b+10992>>3];i=i;return}function sJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11312>>3]=+h[b+11e3>>3];i=i;return}function tJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11320>>3]=+h[b+11248>>3];i=i;return}function uJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11328>>3]=+h[b+11256>>3];i=i;return}function vJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11336>>3]=+h[b+11264>>3];i=i;return}function wJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41536>>3]=+h[b+38704>>3];i=i;return}function xJb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+11536>>3]=l;i=b;return}function yJb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+11544>>3]=l;i=b;return}function zJb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+11552>>3]=l;i=b;return}function AJb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+11560>>3]=l;i=b;return}function BJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41544>>3]=+h[b+41536>>3]/3.0;i=i;return}function CJb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+185|0]=a[d+173|0]|0;i=i;return}function DJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11568>>3]=+h[b+10888>>3];i=i;return}function EJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13576>>3]=+h[b+13904>>3]+ +h[(c[a+416>>2]|0)+11568>>3];i=i;return}function FJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13552>>3]=+h[b+13576>>3]+ +h[(c[a+416>>2]|0)+9600>>3];i=i;return}function GJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13528>>3]=+h[b+13552>>3]+ +h[(c[a+416>>2]|0)+10792>>3];i=i;return}function HJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13504>>3]=+h[b+13528>>3]+ +h[(c[a+416>>2]|0)+8800>>3];i=i;return}function IJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13456>>3]=+h[b+13504>>3]+ +h[(c[a+416>>2]|0)+12528>>3];i=i;return}function JJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13256>>3]=+h[b+13456>>3]+ +h[(c[a+416>>2]|0)+18552>>3];i=i;return}function KJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11576>>3]=+h[b+10896>>3];i=i;return}function LJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11584>>3]=+h[b+10904>>3];i=i;return}function MJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11592>>3]=+h[b+10912>>3];i=i;return}function NJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11600>>3]=+h[b+10920>>3];i=i;return}function OJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11608>>3]=+h[b+10928>>3];i=i;return}function PJb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+41432>>3];j=+h[f+41400>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6824,6816,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41552>>3]=l;i=d;return}function QJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41560>>3]=+h[b+41416>>3];i=i;return}function RJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41568>>3]=+h[b+41432>>3];i=i;return}function SJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41576>>3]=+h[b+41432>>3];i=i;return}function TJb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+160>>2]=c[b+156>>2];i=i;return}function UJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11664>>3]=+h[b+40336>>3]*.5;i=i;return}function VJb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13480>>3]=+h[b+13552>>3]+ +h[(c[a+416>>2]|0)+11664>>3];i=i;return}function WJb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11664>>3]- +h[b+11688>>3];e=+h[b+11672>>3]- +h[b+11696>>3];f=+h[b+11680>>3]- +h[b+11704>>3];h[b+41592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function XJb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6856,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41600>>3]=l;i=d;return}function YJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41608>>3]=+h[b+41600>>3];i=i;return}function ZJb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11760>>3]=+h[b+40320>>3]+ +h[b+40336>>3]*-.5;i=i;return}function _Jb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14400>>3]=+h[b+2008>>3]+ +h[b+11760>>3];i=i;return}function $Jb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14376>>3]=+h[b+14400>>3]+ +h[(c[a+416>>2]|0)+6744>>3];i=i;return}function aKb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11760>>3]- +h[b+11880>>3];e=+h[b+11768>>3]- +h[b+11888>>3];f=+h[b+11776>>3]- +h[b+11896>>3];h[b+41632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bKb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6864,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41640>>3]=l;i=d;return}function cKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41648>>3]=+h[b+41640>>3];i=i;return}function dKb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12144>>3]- +h[b+12264>>3];e=+h[b+12152>>3]- +h[b+12272>>3];f=+h[b+12160>>3]- +h[b+12280>>3];h[b+41672>>3]=+V(+(d*d+e*e+f*f));i=i;return}function eKb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41672>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6872,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41680>>3]=l;i=d;return}function fKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41688>>3]=+h[b+41680>>3];i=i;return}function gKb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12528>>3]- +h[b+12648>>3];e=+h[b+12536>>3]- +h[b+12656>>3];f=+h[b+12544>>3]- +h[b+12664>>3];h[b+41712>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hKb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41712>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6880,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41720>>3]=l;i=d;return}function iKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41728>>3]=+h[b+41720>>3];i=i;return}function jKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41736>>3]=+h[b+40856>>3];i=i;return}function kKb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+190|0]=a[d]|0;i=i;return}function lKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41856>>3]=+h[b+41848>>3];i=i;return}function mKb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+194|0]=a[d+190|0]|0;i=i;return}function nKb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+196|0]=a[d+190|0]|0;i=i;return}function oKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13160>>3]=+h[b+41776>>3];i=i;return}function pKb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14440>>3]=+h[b+14464>>3]+(+h[d+13160>>3]*-.4999999999999999+ +h[d+13168>>3]*.8660254037844387);i=i;return}function qKb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14432>>3]=+h[b+14456>>3]+(+h[d+13160>>3]*.8660254037844387+ +h[d+13168>>3]*.4999999999999999);i=i;return}function rKb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13152>>3]- +h[b+13176>>3];e=+h[b+13160>>3]- +h[b+13184>>3];f=+h[b+13168>>3]- +h[b+13192>>3];h[b+41920>>3]=+V(+(d*d+e*e+f*f));i=i;return}function sKb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41920>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41928>>3]=l;i=d;return}function tKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41936>>3]=+h[b+41928>>3];i=i;return}function uKb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+198|0]=a[d+190|0]|0;i=i;return}function vKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13256>>3]=+h[b+41784>>3];i=i;return}function wKb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13248>>3]- +h[b+13272>>3];e=+h[b+13256>>3]- +h[b+13280>>3];f=+h[b+13264>>3]- +h[b+13288>>3];h[b+41960>>3]=+V(+(d*d+e*e+f*f));i=i;return}function xKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13608>>3]=+h[b+13296>>3];i=i;return}function yKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13616>>3]=+h[b+13304>>3];i=i;return}function zKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13624>>3]=+h[b+13312>>3];i=i;return}function AKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13632>>3]=+h[b+13320>>3];i=i;return}function BKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13640>>3]=+h[b+13328>>3];i=i;return}function CKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13648>>3]=+h[b+13336>>3];i=i;return}function DKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13656>>3]=+h[b+13344>>3];i=i;return}function EKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13664>>3]=+h[b+13352>>3];i=i;return}function FKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13672>>3]=+h[b+13360>>3];i=i;return}function GKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13680>>3]=+h[b+13608>>3];i=i;return}function HKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13688>>3]=+h[b+13616>>3];i=i;return}function IKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13696>>3]=+h[b+13624>>3];i=i;return}function JKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42080>>3]=+h[b+38704>>3];i=i;return}function KKb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+13896>>3]=l;i=b;return}function LKb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+13904>>3]=l;i=b;return}function MKb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+13912>>3]=l;i=b;return}function NKb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+13920>>3]=l;i=b;return}function OKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42088>>3]=+h[b+42080>>3]/3.0;i=i;return}function PKb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+210|0]=a[d+198|0]|0;i=i;return}function QKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13928>>3]=+h[b+13248>>3];i=i;return}function RKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13936>>3]=+h[b+13256>>3];i=i;return}function SKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13944>>3]=+h[b+13264>>3];i=i;return}function TKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13952>>3]=+h[b+13272>>3];i=i;return}function UKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13960>>3]=+h[b+13280>>3];i=i;return}function VKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13968>>3]=+h[b+13288>>3];i=i;return}function WKb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+41976>>3];j=+h[f+41944>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6904,6896,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+42096>>3]=l;i=d;return}function XKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42104>>3]=+h[b+41960>>3];i=i;return}function YKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42112>>3]=+h[b+41976>>3];i=i;return}function ZKb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42120>>3]=+h[b+41976>>3];i=i;return}function _Kb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+200>>2]=c[b+196>>2];i=i;return}function $Kb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+211|0]=a[d+190|0]|0;i=i;return}function aLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14032>>3]=+h[b+41792>>3];i=i;return}function bLb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14024>>3]- +h[b+14048>>3];e=+h[b+14032>>3]- +h[b+14056>>3];f=+h[b+14040>>3]- +h[b+14064>>3];h[b+42144>>3]=+V(+(d*d+e*e+f*f));i=i;return}function cLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42152>>3]=+h[b+42128>>3];i=i;return}function dLb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+217|0]=a[d+211|0]|0;i=i;return}function eLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14312>>3]=+h[b+14024>>3];i=i;return}function fLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14320>>3]=+h[b+14032>>3];i=i;return}function gLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14328>>3]=+h[b+14040>>3];i=i;return}function hLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14336>>3]=+h[b+14048>>3];i=i;return}function iLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14344>>3]=+h[b+14056>>3];i=i;return}function jLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14352>>3]=+h[b+14064>>3];i=i;return}function kLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42200>>3]=+h[b+42144>>3];i=i;return}function lLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42208>>3]=+h[b+42160>>3];i=i;return}function mLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42216>>3]=+h[b+42176>>3];i=i;return}function nLb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+208>>2]=c[b+204>>2];i=i;return}function oLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14504>>3]=+h[b+14096>>3];i=i;return}function pLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14512>>3]=+h[b+14104>>3];i=i;return}function qLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14520>>3]=+h[b+14112>>3];i=i;return}function rLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14528>>3]=+h[b+14120>>3];i=i;return}function sLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14536>>3]=+h[b+14128>>3];i=i;return}function tLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14544>>3]=+h[b+14136>>3];i=i;return}function uLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14552>>3]=+h[b+14144>>3];i=i;return}function vLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14560>>3]=+h[b+14152>>3];i=i;return}function wLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14568>>3]=+h[b+14160>>3];i=i;return}function xLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14576>>3]=+h[b+14504>>3];i=i;return}function yLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14584>>3]=+h[b+14512>>3];i=i;return}function zLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14592>>3]=+h[b+14520>>3];i=i;return}function ALb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42288>>3]=+h[b+38704>>3];i=i;return}function BLb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+14792>>3]=l;i=b;return}function CLb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+14800>>3]=l;i=b;return}function DLb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+14808>>3]=l;i=b;return}function ELb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+14816>>3]=l;i=b;return}function FLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42296>>3]=+h[b+42288>>3]/3.0;i=i;return}function GLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14824>>3]=+h[b+41800>>3];i=i;return}function HLb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14664>>3]=+h[b+14688>>3]+ +h[(c[a+416>>2]|0)+14824>>3];i=i;return}function ILb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14824>>3]- +h[b+14848>>3];e=+h[b+14832>>3]- +h[b+14856>>3];f=+h[b+14840>>3]- +h[b+14864>>3];h[b+42312>>3]=+V(+(d*d+e*e+f*f));i=i;return}function JLb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+42312>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,6936,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+42320>>3]=l;i=d;return}function KLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42328>>3]=+h[b+42320>>3];i=i;return}function LLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42336>>3]=+h[b+41776>>3]+(+h[b+41808>>3]+(-+h[b+41792>>3]- +h[b+41784>>3]));i=i;return}function MLb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+225|0]=a[d+190|0]|0;i=i;return}function NLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14928>>3]=-+h[b+41808>>3];i=i;return}function OLb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14920>>3]- +h[b+14944>>3];e=+h[b+14928>>3]- +h[b+14952>>3];f=+h[b+14936>>3]- +h[b+14960>>3];h[b+42360>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42368>>3]=+h[b+42344>>3];i=i;return}function QLb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+231|0]=a[d+225|0]|0;i=i;return}function RLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15208>>3]=+h[b+14920>>3];i=i;return}function SLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15216>>3]=+h[b+14928>>3];i=i;return}function TLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15224>>3]=+h[b+14936>>3];i=i;return}function ULb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15232>>3]=+h[b+14944>>3];i=i;return}function VLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15240>>3]=+h[b+14952>>3];i=i;return}function WLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15248>>3]=+h[b+14960>>3];i=i;return}function XLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42416>>3]=+h[b+42360>>3];i=i;return}function YLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42424>>3]=+h[b+42376>>3];i=i;return}function ZLb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42432>>3]=+h[b+42392>>3];i=i;return}function _Lb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+220>>2]=c[b+216>>2];i=i;return}function $Lb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15400>>3]=+h[b+14992>>3];i=i;return}function aMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15408>>3]=+h[b+15e3>>3];i=i;return}function bMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15416>>3]=+h[b+15008>>3];i=i;return}function cMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15424>>3]=+h[b+15016>>3];i=i;return}function dMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15432>>3]=+h[b+15024>>3];i=i;return}function eMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15440>>3]=+h[b+15032>>3];i=i;return}function fMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15448>>3]=+h[b+15040>>3];i=i;return}function gMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15456>>3]=+h[b+15048>>3];i=i;return}function hMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15464>>3]=+h[b+15056>>3];i=i;return}function iMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15472>>3]=+h[b+15400>>3];i=i;return}function jMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15480>>3]=+h[b+15408>>3];i=i;return}function kMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15488>>3]=+h[b+15416>>3];i=i;return}function lMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42504>>3]=+h[b+38704>>3];i=i;return}function mMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+15688>>3]=l;i=b;return}function nMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+15696>>3]=l;i=b;return}function oMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+15704>>3]=l;i=b;return}function pMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+15712>>3]=l;i=b;return}function qMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42512>>3]=+h[b+42504>>3]/3.0;i=i;return}function rMb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+238|0]=a[d+190|0]|0;i=i;return}function sMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15728>>3]=+h[b+41808>>3];i=i;return}function tMb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15720>>3]- +h[b+15744>>3];e=+h[b+15728>>3]- +h[b+15752>>3];f=+h[b+15736>>3]- +h[b+15760>>3];h[b+42536>>3]=+V(+(d*d+e*e+f*f));i=i;return}function uMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42544>>3]=+h[b+42520>>3];i=i;return}function vMb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+244|0]=a[d+238|0]|0;i=i;return}function wMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16008>>3]=+h[b+15720>>3];i=i;return}function xMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16016>>3]=+h[b+15728>>3];i=i;return}function yMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16024>>3]=+h[b+15736>>3];i=i;return}function zMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16032>>3]=+h[b+15744>>3];i=i;return}function AMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16040>>3]=+h[b+15752>>3];i=i;return}function BMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16048>>3]=+h[b+15760>>3];i=i;return}function CMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42592>>3]=+h[b+42536>>3];i=i;return}function DMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42600>>3]=+h[b+42552>>3];i=i;return}function EMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42608>>3]=+h[b+42568>>3];i=i;return}function FMb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+228>>2]=c[b+224>>2];i=i;return}function GMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16200>>3]=+h[b+15792>>3];i=i;return}function HMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16208>>3]=+h[b+15800>>3];i=i;return}function IMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16216>>3]=+h[b+15808>>3];i=i;return}function JMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16224>>3]=+h[b+15816>>3];i=i;return}function KMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16232>>3]=+h[b+15824>>3];i=i;return}function LMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16240>>3]=+h[b+15832>>3];i=i;return}function MMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16248>>3]=+h[b+15840>>3];i=i;return}function NMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16256>>3]=+h[b+15848>>3];i=i;return}function OMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16264>>3]=+h[b+15856>>3];i=i;return}function PMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16272>>3]=+h[b+16200>>3];i=i;return}function QMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16280>>3]=+h[b+16208>>3];i=i;return}function RMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16288>>3]=+h[b+16216>>3];i=i;return}function SMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42680>>3]=+h[b+38704>>3];i=i;return}function TMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+16488>>3]=l;i=b;return}function UMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+16496>>3]=l;i=b;return}function VMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+16504>>3]=l;i=b;return}function WMb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+16512>>3]=l;i=b;return}function XMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42688>>3]=+h[b+42680>>3]/3.0;i=i;return}function YMb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+251|0]=a[d+190|0]|0;i=i;return}function ZMb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16520>>3]=+h[b+41816>>3];i=i;return}function _Mb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16880>>3]=+h[b+16568>>3];i=i;return}function $Mb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16888>>3]=+h[b+16576>>3];i=i;return}function aNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16896>>3]=+h[b+16584>>3];i=i;return}function bNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16904>>3]=+h[b+16592>>3];i=i;return}function cNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16912>>3]=+h[b+16600>>3];i=i;return}function dNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16920>>3]=+h[b+16608>>3];i=i;return}function eNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16928>>3]=+h[b+16616>>3];i=i;return}function fNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16936>>3]=+h[b+16624>>3];i=i;return}function gNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16944>>3]=+h[b+16632>>3];i=i;return}function hNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16952>>3]=+h[b+16880>>3];i=i;return}function iNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16960>>3]=+h[b+16888>>3];i=i;return}function jNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16968>>3]=+h[b+16896>>3];i=i;return}function kNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42832>>3]=+h[b+38704>>3];i=i;return}function lNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+17168>>3]=l;i=b;return}function mNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+17176>>3]=l;i=b;return}function nNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+17184>>3]=l;i=b;return}function oNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+17192>>3]=l;i=b;return}function pNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42840>>3]=+h[b+42832>>3]/3.0;i=i;return}function qNb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+263|0]=a[d+251|0]|0;i=i;return}function rNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17200>>3]=+h[b+16520>>3];i=i;return}function sNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17208>>3]=+h[b+16528>>3];i=i;return}function tNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17216>>3]=+h[b+16536>>3];i=i;return}function uNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17224>>3]=+h[b+16544>>3];i=i;return}function vNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17232>>3]=+h[b+16552>>3];i=i;return}function wNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17240>>3]=+h[b+16560>>3];i=i;return}function xNb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+42728>>3];j=+h[f+42696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6952,6944,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+42848>>3]=l;i=d;return}function yNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42856>>3]=+h[b+42712>>3];i=i;return}function zNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42864>>3]=+h[b+42728>>3];i=i;return}function ANb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42872>>3]=+h[b+42728>>3];i=i;return}function BNb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+236>>2]=c[b+232>>2];i=i;return}function CNb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+264|0]=a[d+190|0]|0;i=i;return}function DNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17296>>3]=+h[b+41800>>3]- +h[b+41816>>3];i=i;return}function ENb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17656>>3]=+h[b+17344>>3];i=i;return}function FNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17664>>3]=+h[b+17352>>3];i=i;return}function GNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17672>>3]=+h[b+17360>>3];i=i;return}function HNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17680>>3]=+h[b+17368>>3];i=i;return}function INb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17688>>3]=+h[b+17376>>3];i=i;return}function JNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17696>>3]=+h[b+17384>>3];i=i;return}function KNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17704>>3]=+h[b+17392>>3];i=i;return}function LNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17712>>3]=+h[b+17400>>3];i=i;return}function MNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17720>>3]=+h[b+17408>>3];i=i;return}function NNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17728>>3]=+h[b+17656>>3];i=i;return}function ONb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17736>>3]=+h[b+17664>>3];i=i;return}function PNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17744>>3]=+h[b+17672>>3];i=i;return}function QNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43016>>3]=+h[b+38704>>3];i=i;return}function RNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+17944>>3]=l;i=b;return}function SNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+17952>>3]=l;i=b;return}function TNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+17960>>3]=l;i=b;return}function UNb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+17968>>3]=l;i=b;return}function VNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43024>>3]=+h[b+43016>>3]/3.0;i=i;return}function WNb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+276|0]=a[d+264|0]|0;i=i;return}function XNb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17976>>3]=+h[b+17296>>3];i=i;return}function YNb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12928>>3]=+h[b+13256>>3]+ +h[(c[a+416>>2]|0)+17976>>3];i=i;return}function ZNb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12904>>3]=+h[b+12928>>3]+ +h[(c[a+416>>2]|0)+16008>>3];i=i;return}function _Nb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12880>>3]=+h[b+12904>>3]+ +h[(c[a+416>>2]|0)+17200>>3];i=i;return}function $Nb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12856>>3]=+h[b+12880>>3]+ +h[(c[a+416>>2]|0)+15208>>3];i=i;return}function aOb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12808>>3]=+h[b+12856>>3]+ +h[(c[a+416>>2]|0)+18936>>3];i=i;return}function bOb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12608>>3]=+h[b+12808>>3]+ +h[(c[a+416>>2]|0)+24960>>3];i=i;return}function cOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17984>>3]=+h[b+17304>>3];i=i;return}function dOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17992>>3]=+h[b+17312>>3];i=i;return}function eOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18e3>>3]=+h[b+17320>>3];i=i;return}function fOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18008>>3]=+h[b+17328>>3];i=i;return}function gOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18016>>3]=+h[b+17336>>3];i=i;return}function hOb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+42912>>3];j=+h[f+42880>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6992,6984,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43032>>3]=l;i=d;return}function iOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43040>>3]=+h[b+42896>>3];i=i;return}function jOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43048>>3]=+h[b+42912>>3];i=i;return}function kOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43056>>3]=+h[b+42912>>3];i=i;return}function lOb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+244>>2]=c[b+240>>2];i=i;return}function mOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18072>>3]=+h[b+41816>>3]*.5;i=i;return}function nOb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12832>>3]=+h[b+12904>>3]+ +h[(c[a+416>>2]|0)+18072>>3];i=i;return}function oOb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18072>>3]- +h[b+18096>>3];e=+h[b+18080>>3]- +h[b+18104>>3];f=+h[b+18088>>3]- +h[b+18112>>3];h[b+43072>>3]=+V(+(d*d+e*e+f*f));i=i;return}function pOb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43072>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7024,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43080>>3]=l;i=d;return}function qOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43088>>3]=+h[b+43080>>3];i=i;return}function rOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18168>>3]=+h[b+41800>>3]+ +h[b+41816>>3]*-.5;i=i;return}function sOb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14448>>3]=+h[b+14688>>3]+ +h[(c[a+416>>2]|0)+18168>>3];i=i;return}function tOb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14424>>3]=+h[b+14448>>3]+ +h[(c[a+416>>2]|0)+13152>>3];i=i;return}function uOb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18168>>3]- +h[b+18288>>3];e=+h[b+18176>>3]- +h[b+18296>>3];f=+h[b+18184>>3]- +h[b+18304>>3];h[b+43112>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vOb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7032,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43120>>3]=l;i=d;return}function wOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43128>>3]=+h[b+43120>>3];i=i;return}function xOb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18552>>3]- +h[b+18672>>3];e=+h[b+18560>>3]- +h[b+18680>>3];f=+h[b+18568>>3]- +h[b+18688>>3];h[b+43152>>3]=+V(+(d*d+e*e+f*f));i=i;return}function yOb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43152>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7040,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43160>>3]=l;i=d;return}function zOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43168>>3]=+h[b+43160>>3];i=i;return}function AOb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18936>>3]- +h[b+19056>>3];e=+h[b+18944>>3]- +h[b+19064>>3];f=+h[b+18952>>3]- +h[b+19072>>3];h[b+43192>>3]=+V(+(d*d+e*e+f*f));i=i;return}function BOb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43192>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7048,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43200>>3]=l;i=d;return}function COb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43208>>3]=+h[b+43200>>3];i=i;return}function DOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43216>>3]=+h[b+42336>>3];i=i;return}function EOb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+281|0]=a[d]|0;i=i;return}function FOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43336>>3]=+h[b+43328>>3];i=i;return}function GOb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+285|0]=a[d+281|0]|0;i=i;return}function HOb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+287|0]=a[d+281|0]|0;i=i;return}function IOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19568>>3]=+h[b+43256>>3];i=i;return}function JOb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14488>>3]=+h[b+14512>>3]+(+h[d+19568>>3]*.4999999999999999+ +h[d+19576>>3]*.8660254037844387);i=i;return}function KOb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14480>>3]=+h[b+14504>>3]+(+h[d+19568>>3]*.8660254037844387+ +h[d+19576>>3]*-.4999999999999999);i=i;return}function LOb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+19560>>3]- +h[b+19584>>3];e=+h[b+19568>>3]- +h[b+19592>>3];f=+h[b+19576>>3]- +h[b+19600>>3];h[b+43400>>3]=+V(+(d*d+e*e+f*f));i=i;return}function MOb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43400>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7056,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43408>>3]=l;i=d;return}function NOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43416>>3]=+h[b+43408>>3];i=i;return}function OOb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+289|0]=a[d+281|0]|0;i=i;return}function POb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19664>>3]=+h[b+43264>>3];i=i;return}function QOb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+19656>>3]- +h[b+19680>>3];e=+h[b+19664>>3]- +h[b+19688>>3];f=+h[b+19672>>3]- +h[b+19696>>3];h[b+43440>>3]=+V(+(d*d+e*e+f*f));i=i;return}function ROb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20016>>3]=+h[b+19704>>3];i=i;return}function SOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20024>>3]=+h[b+19712>>3];i=i;return}function TOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20032>>3]=+h[b+19720>>3];i=i;return}function UOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20040>>3]=+h[b+19728>>3];i=i;return}function VOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20048>>3]=+h[b+19736>>3];i=i;return}function WOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20056>>3]=+h[b+19744>>3];i=i;return}function XOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20064>>3]=+h[b+19752>>3];i=i;return}function YOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20072>>3]=+h[b+19760>>3];i=i;return}function ZOb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20080>>3]=+h[b+19768>>3];i=i;return}function _Ob(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20088>>3]=+h[b+20016>>3];i=i;return}function $Ob(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20096>>3]=+h[b+20024>>3];i=i;return}function aPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20104>>3]=+h[b+20032>>3];i=i;return}function bPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43560>>3]=+h[b+38704>>3];i=i;return}function cPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+20304>>3]=l;i=b;return}function dPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+20312>>3]=l;i=b;return}function ePb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+20320>>3]=l;i=b;return}function fPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+20328>>3]=l;i=b;return}function gPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43568>>3]=+h[b+43560>>3]/3.0;i=i;return}function hPb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+301|0]=a[d+289|0]|0;i=i;return}function iPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20336>>3]=+h[b+19656>>3];i=i;return}function jPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20344>>3]=+h[b+19664>>3];i=i;return}function kPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20352>>3]=+h[b+19672>>3];i=i;return}function lPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20360>>3]=+h[b+19680>>3];i=i;return}function mPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20368>>3]=+h[b+19688>>3];i=i;return}function nPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20376>>3]=+h[b+19696>>3];i=i;return}function oPb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+43456>>3];j=+h[f+43424>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7072,7064,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43576>>3]=l;i=d;return}function pPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43584>>3]=+h[b+43440>>3];i=i;return}function qPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43592>>3]=+h[b+43456>>3];i=i;return}function rPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43600>>3]=+h[b+43456>>3];i=i;return}function sPb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+284>>2]=c[b+280>>2];i=i;return}function tPb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+302|0]=a[d+281|0]|0;i=i;return}function uPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20440>>3]=+h[b+43272>>3];i=i;return}function vPb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+20432>>3]- +h[b+20456>>3];e=+h[b+20440>>3]- +h[b+20464>>3];f=+h[b+20448>>3]- +h[b+20472>>3];h[b+43624>>3]=+V(+(d*d+e*e+f*f));i=i;return}function wPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43632>>3]=+h[b+43608>>3];i=i;return}function xPb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+308|0]=a[d+302|0]|0;i=i;return}function yPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20720>>3]=+h[b+20432>>3];i=i;return}function zPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20728>>3]=+h[b+20440>>3];i=i;return}function APb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20736>>3]=+h[b+20448>>3];i=i;return}function BPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20744>>3]=+h[b+20456>>3];i=i;return}function CPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20752>>3]=+h[b+20464>>3];i=i;return}function DPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20760>>3]=+h[b+20472>>3];i=i;return}function EPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43680>>3]=+h[b+43624>>3];i=i;return}function FPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43688>>3]=+h[b+43640>>3];i=i;return}function GPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43696>>3]=+h[b+43656>>3];i=i;return}function HPb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+292>>2]=c[b+288>>2];i=i;return}function IPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20912>>3]=+h[b+20504>>3];i=i;return}function JPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20920>>3]=+h[b+20512>>3];i=i;return}function KPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20928>>3]=+h[b+20520>>3];i=i;return}function LPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20936>>3]=+h[b+20528>>3];i=i;return}function MPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20944>>3]=+h[b+20536>>3];i=i;return}function NPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20952>>3]=+h[b+20544>>3];i=i;return}function OPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20960>>3]=+h[b+20552>>3];i=i;return}function PPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20968>>3]=+h[b+20560>>3];i=i;return}function QPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20976>>3]=+h[b+20568>>3];i=i;return}function RPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20984>>3]=+h[b+20912>>3];i=i;return}function SPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20992>>3]=+h[b+20920>>3];i=i;return}function TPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21e3>>3]=+h[b+20928>>3];i=i;return}function UPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43768>>3]=+h[b+38704>>3];i=i;return}function VPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+21200>>3]=l;i=b;return}function WPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+21208>>3]=l;i=b;return}function XPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+21216>>3]=l;i=b;return}function YPb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+21224>>3]=l;i=b;return}function ZPb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43776>>3]=+h[b+43768>>3]/3.0;i=i;return}function _Pb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21232>>3]=+h[b+43280>>3];i=i;return}function $Pb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14640>>3]=+h[b+14664>>3]+ +h[(c[a+416>>2]|0)+21232>>3];i=i;return}function aQb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+21232>>3]- +h[b+21256>>3];e=+h[b+21240>>3]- +h[b+21264>>3];f=+h[b+21248>>3]- +h[b+21272>>3];h[b+43792>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bQb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43792>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43800>>3]=l;i=d;return}function cQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43808>>3]=+h[b+43800>>3];i=i;return}function dQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43816>>3]=+h[b+43256>>3]+(+h[b+43288>>3]+(-+h[b+43272>>3]- +h[b+43264>>3]));i=i;return}function eQb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+316|0]=a[d+281|0]|0;i=i;return}function fQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21336>>3]=-+h[b+43288>>3];i=i;return}function gQb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+21328>>3]- +h[b+21352>>3];e=+h[b+21336>>3]- +h[b+21360>>3];f=+h[b+21344>>3]- +h[b+21368>>3];h[b+43840>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43848>>3]=+h[b+43824>>3];i=i;return}function iQb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+322|0]=a[d+316|0]|0;i=i;return}



function ZR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=-+h[b+2992>>3]- +h[(c[a+416>>2]|0)+8416>>3]*+h[b+4408>>3];i=i;return}function _R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=-+h[b+2816>>3]- +h[b+2448>>3];i=i;return}function $R(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=-+h[b+3560>>3]- +h[(c[a+416>>2]|0)+2008>>3]*+h[b+4384>>3];i=i;return}function aS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3584>>3]=+h[b+3392>>3]+ +h[b+3056>>3];i=i;return}function bS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+448>>3]=-(+h[b+33160>>3]*+h[d+4608>>3])- +h[d+408>>3]- +h[b+33168>>3]*+h[d+26056>>3];i=i;return}function cS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+448>>3]- +h[b+4608>>3]*+h[b+26048>>3];i=i;return}function dS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+456>>3]=+h[b+32384>>3]*+h[d+4608>>3]+(+h[b+32392>>3]*+h[d+26056>>3]+ +h[d+552>>3]);i=i;return}function eS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1120>>3]=+h[b+37400>>3]*+h[d+4600>>3]- +h[b+37408>>3]*+h[d+4592>>3]- +h[d+456>>3];i=i;return}function fS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+944>>3]=+h[b+27656>>3]*+h[d+4592>>3]+(-(+h[b+27648>>3]*+h[d+4600>>3])- +h[d+1120>>3]);i=i;return}function gS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=-+h[b+944>>3]- +h[b+560>>3];i=i;return}function hS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1568>>3]=+h[b+21248>>3]*+h[d+4456>>3]+(-(+h[b+21240>>3]*+h[d+4464>>3])- +h[d+1744>>3]);i=i;return}function iS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=-+h[b+1568>>3]- +h[b+1184>>3];i=i;return}function jS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2192>>3]=+h[b+14840>>3]*+h[d+4432>>3]+(-(+h[b+14832>>3]*+h[d+4440>>3])- +h[d+2368>>3]);i=i;return}function kS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2976>>3]=-+h[b+2192>>3]- +h[b+1808>>3];i=i;return}function lS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2800>>3]=+h[b+8432>>3]*+h[d+4408>>3]+(-(+h[b+8424>>3]*+h[d+4416>>3])- +h[d+2976>>3]);i=i;return}function mS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3544>>3]=-+h[b+2800>>3]- +h[b+2432>>3];i=i;return}function nS(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3376>>3]=+h[b+2024>>3]*+h[d+4384>>3]+(-(+h[b+2016>>3]*+h[d+4392>>3])- +h[d+3544>>3]);i=i;return}function oS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[b+3376>>3]+ +h[b+3040>>3];i=i;return}function pS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3632>>3]=+h[b+26648>>3]- +h[b+3568>>3];i=i;return}function qS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=-(+h[(c[a+416>>2]|0)+37296>>3]*+h[b+25704>>3]);i=i;return}function rS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[(c[a+416>>2]|0)+37296>>3]*+h[b+25696>>3];i=i;return}function sS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+5640>>3]*-.05;i=i;return}function tS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+5632>>3]*.05;i=i;return}function uS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[(c[a+416>>2]|0)+36424>>3]*+h[b+5608>>3];i=i;return}function vS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+232>>3]+ +h[b+208>>3];i=i;return}function wS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=-+h[b+272>>3]- +h[b+72>>3];i=i;return}function xS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+336>>3]- +h[(c[a+416>>2]|0)+35232>>3]*+h[b+5584>>3];i=i;return}function yS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[(c[a+416>>2]|0)+37200>>3]*+h[b+5520>>3]- +h[b+160>>3];i=i;return}function zS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=-(+h[(c[a+416>>2]|0)+36424>>3]*+h[b+5600>>3]);i=i;return}function AS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+240>>3]+ +h[b+216>>3];i=i;return}function BS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=-+h[b+280>>3]- +h[b+80>>3];i=i;return}function CS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+344>>3]+ +h[(c[a+416>>2]|0)+35232>>3]*+h[b+5576>>3];i=i;return}function DS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=-+h[b+168>>3]- +h[(c[a+416>>2]|0)+37200>>3]*+h[b+5512>>3];i=i;return}function ES(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+5672>>3]*-.05;i=i;return}function FS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+120>>3]+ +h[b+96>>3];i=i;return}function GS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+5664>>3]*.05;i=i;return}function HS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+128>>3]+ +h[b+104>>3];i=i;return}function IS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+184>>3]*.8660254037844387+(+h[b+192>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+37776>>3]*+h[b+5472>>3]);i=i;return}function JS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+184>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+37776>>3]*+h[b+5464>>3]+ +h[b+192>>3]*.8660254037844387);i=i;return}function KS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+504>>3]*-6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+31752>>3]*+h[b+5448>>3])- +h[b+512>>3]);i=i;return}function LS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=+h[b+928>>3]- +h[(c[a+416>>2]|0)+28024>>3]*+h[b+5448>>3];i=i;return}function MS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+728>>3]=+h[(c[a+416>>2]|0)+30016>>3]*+h[b+5424>>3]- +h[b+792>>3];i=i;return}function NS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+816>>3]=+h[b+752>>3]+ +h[b+728>>3];i=i;return}function OS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+880>>3]=-+h[b+816>>3]- +h[b+592>>3];i=i;return}function PS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=+h[b+880>>3]- +h[(c[a+416>>2]|0)+28824>>3]*+h[b+5400>>3];i=i;return}function QS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[(c[a+416>>2]|0)+30792>>3]*+h[b+5376>>3]- +h[b+680>>3];i=i;return}function RS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+640>>3]+ +h[b+616>>3];i=i;return}function SS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+512>>3]*-6.123233995736766e-17+(+h[b+504>>3]+ +h[(c[a+416>>2]|0)+31752>>3]*+h[b+5440>>3]);i=i;return}function TS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=+h[b+936>>3]+ +h[(c[a+416>>2]|0)+28024>>3]*+h[b+5440>>3];i=i;return}function US(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=-+h[b+800>>3]- +h[(c[a+416>>2]|0)+30016>>3]*+h[b+5416>>3];i=i;return}function VS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+760>>3]+ +h[b+736>>3];i=i;return}function WS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+888>>3]=-+h[b+824>>3]- +h[b+600>>3];i=i;return}function XS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+688>>3]=+h[b+888>>3]+ +h[(c[a+416>>2]|0)+28824>>3]*+h[b+5392>>3];i=i;return}function YS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=-+h[b+688>>3]- +h[(c[a+416>>2]|0)+30792>>3]*+h[b+5368>>3];i=i;return}function ZS(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+648>>3]+ +h[b+624>>3];i=i;return}function _S(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+704>>3]*6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+31368>>3]*+h[b+5328>>3])- +h[b+712>>3]);i=i;return}function $S(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=+h[b+712>>3]*6.123233995736766e-17+(+h[b+704>>3]+ +h[(c[a+416>>2]|0)+31368>>3]*+h[b+5320>>3]);i=i;return}function aT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+1104>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+25344>>3]*+h[b+5296>>3]+ +h[b+1112>>3]*.8660254037844386);i=i;return}function bT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1424>>3]=+h[b+1560>>3]+ +h[(c[a+416>>2]|0)+21616>>3]*+h[b+5296>>3];i=i;return}function cT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=-+h[b+1424>>3]- +h[(c[a+416>>2]|0)+23608>>3]*+h[b+5272>>3];i=i;return}function dT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1448>>3]=+h[b+1384>>3]+ +h[b+1360>>3];i=i;return}function eT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=-+h[b+1448>>3]- +h[b+1224>>3];i=i;return}function fT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1512>>3]+ +h[(c[a+416>>2]|0)+22416>>3]*+h[b+5248>>3];i=i;return}function gT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=-+h[b+1312>>3]- +h[(c[a+416>>2]|0)+24384>>3]*+h[b+5224>>3];i=i;return}function hT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=+h[b+1272>>3]+ +h[b+1248>>3];i=i;return}function iT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+1104>>3]*.8660254037844386+(+h[b+1112>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+25344>>3]*+h[b+5304>>3]);i=i;return}function jT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+1552>>3]- +h[(c[a+416>>2]|0)+21616>>3]*+h[b+5304>>3];i=i;return}function kT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[(c[a+416>>2]|0)+23608>>3]*+h[b+5280>>3]- +h[b+1416>>3];i=i;return}function lT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+1376>>3]+ +h[b+1352>>3];i=i;return}function mT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=-+h[b+1440>>3]- +h[b+1216>>3];i=i;return}function nT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1304>>3]=+h[b+1504>>3]- +h[(c[a+416>>2]|0)+22416>>3]*+h[b+5256>>3];i=i;return}function oT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[(c[a+416>>2]|0)+24384>>3]*+h[b+5232>>3]- +h[b+1304>>3];i=i;return}function pT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+1264>>3]+ +h[b+1240>>3];i=i;return}function qT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1736>>3]=+h[b+1328>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+24960>>3]*+h[b+5176>>3]+ +h[b+1336>>3]*-.8660254037844386);i=i;return}function rT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1728>>3]=+h[b+1328>>3]*-.8660254037844386+(+h[b+1336>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+24960>>3]*+h[b+5184>>3]);i=i;return}function sT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+1728>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+18936>>3]*+h[b+5152>>3]+ +h[b+1736>>3]*.8660254037844386);i=i;return}function tT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+2184>>3]+ +h[(c[a+416>>2]|0)+15208>>3]*+h[b+5152>>3];i=i;return}function uT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=-+h[b+2048>>3]- +h[(c[a+416>>2]|0)+17200>>3]*+h[b+5128>>3];i=i;return}function vT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+2008>>3]+ +h[b+1984>>3];i=i;return}function wT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=-+h[b+2072>>3]- +h[b+1848>>3];i=i;return}function xT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+2136>>3]+ +h[(c[a+416>>2]|0)+16008>>3]*+h[b+5104>>3];i=i;return}function yT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1872>>3]=-+h[b+1936>>3]- +h[(c[a+416>>2]|0)+17976>>3]*+h[b+5080>>3];i=i;return}function zT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1896>>3]+ +h[b+1872>>3];i=i;return}function AT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[b+1728>>3]*.8660254037844386+(+h[b+1736>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+18936>>3]*+h[b+5160>>3]);i=i;return}function BT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+2176>>3]- +h[(c[a+416>>2]|0)+15208>>3]*+h[b+5160>>3];i=i;return}function CT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[(c[a+416>>2]|0)+17200>>3]*+h[b+5136>>3]- +h[b+2040>>3];i=i;return}function DT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2064>>3]=+h[b+2e3>>3]+ +h[b+1976>>3];i=i;return}function ET(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=-+h[b+2064>>3]- +h[b+1840>>3];i=i;return}function FT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+2128>>3]- +h[(c[a+416>>2]|0)+16008>>3]*+h[b+5112>>3];i=i;return}function GT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[(c[a+416>>2]|0)+17976>>3]*+h[b+5088>>3]- +h[b+1928>>3];i=i;return}function HT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+1888>>3]+ +h[b+1864>>3];i=i;return}function IT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2360>>3]=+h[b+1952>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+18552>>3]*+h[b+5032>>3]+ +h[b+1960>>3]*-.8660254037844386);i=i;return}function JT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2352>>3]=+h[b+1952>>3]*-.8660254037844386+(+h[b+1960>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+18552>>3]*+h[b+5040>>3]);i=i;return}function KT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+2360>>3]*-6.123233995736766e-17+(+h[b+2352>>3]+ +h[(c[a+416>>2]|0)+12528>>3]*+h[b+5008>>3]);i=i;return}function LT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2792>>3]+ +h[(c[a+416>>2]|0)+8800>>3]*+h[b+5008>>3];i=i;return}function MT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=-+h[b+2656>>3]- +h[(c[a+416>>2]|0)+10792>>3]*+h[b+4984>>3];i=i;return}function NT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+2616>>3]+ +h[b+2592>>3];i=i;return}function OT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=-+h[b+2680>>3]- +h[b+2472>>3];i=i;return}function PT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=+h[b+2744>>3]+ +h[(c[a+416>>2]|0)+9600>>3]*+h[b+4960>>3];i=i;return}function QT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2496>>3]=-+h[b+2544>>3]- +h[(c[a+416>>2]|0)+11568>>3]*+h[b+4936>>3];i=i;return}function RT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=+h[b+2520>>3]+ +h[b+2496>>3];i=i;return}function ST(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2784>>3]=+h[b+2352>>3]*-6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+12528>>3]*+h[b+5016>>3])- +h[b+2360>>3]);i=i;return}function TT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2784>>3]- +h[(c[a+416>>2]|0)+8800>>3]*+h[b+5016>>3];i=i;return}function UT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=+h[(c[a+416>>2]|0)+10792>>3]*+h[b+4992>>3]- +h[b+2648>>3];i=i;return}function VT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+2608>>3]+ +h[b+2584>>3];i=i;return}function WT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=-+h[b+2672>>3]- +h[b+2464>>3];i=i;return}function XT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+2736>>3]- +h[(c[a+416>>2]|0)+9600>>3]*+h[b+4968>>3];i=i;return}function YT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2488>>3]=+h[(c[a+416>>2]|0)+11568>>3]*+h[b+4944>>3]- +h[b+2536>>3];i=i;return}function ZT(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=+h[b+2512>>3]+ +h[b+2488>>3];i=i;return}function _T(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2968>>3]=+h[b+2568>>3]*6.123233995736766e-17+(+h[b+2560>>3]+ +h[(c[a+416>>2]|0)+12144>>3]*+h[b+4888>>3]);i=i;return}function $T(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2960>>3]=+h[b+2560>>3]*6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+12144>>3]*+h[b+4896>>3])- +h[b+2568>>3]);i=i;return}function aU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3368>>3]=+h[b+2960>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+6120>>3]*+h[b+4864>>3]+ +h[b+2968>>3]*-.8660254037844387);i=i;return}function bU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3264>>3]=+h[b+3368>>3]+ +h[(c[a+416>>2]|0)+2392>>3]*+h[b+4864>>3];i=i;return}function cU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3216>>3]=-+h[b+3264>>3]- +h[(c[a+416>>2]|0)+4384>>3]*+h[b+4840>>3];i=i;return}function dU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3288>>3]=+h[b+3240>>3]+ +h[b+3216>>3];i=i;return}function eU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=-+h[b+3288>>3]- +h[b+3080>>3];i=i;return}function fU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3168>>3]=+h[b+3336>>3]+ +h[(c[a+416>>2]|0)+3192>>3]*+h[b+4816>>3];i=i;return}function gU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=-+h[b+3168>>3]- +h[(c[a+416>>2]|0)+5160>>3]*+h[b+4792>>3];i=i;return}function hU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3192>>3]=+h[b+3128>>3]+ +h[b+3104>>3];i=i;return}function iU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3360>>3]=+h[b+2960>>3]*-.8660254037844387+(+h[b+2968>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+6120>>3]*+h[b+4872>>3]);i=i;return}function jU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3256>>3]=+h[b+3360>>3]- +h[(c[a+416>>2]|0)+2392>>3]*+h[b+4872>>3];i=i;return}function kU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3208>>3]=+h[(c[a+416>>2]|0)+4384>>3]*+h[b+4848>>3]- +h[b+3256>>3];i=i;return}function lU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3280>>3]=+h[b+3232>>3]+ +h[b+3208>>3];i=i;return}function mU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3328>>3]=-+h[b+3280>>3]- +h[b+3072>>3];i=i;return}function nU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3160>>3]=+h[b+3328>>3]- +h[(c[a+416>>2]|0)+3192>>3]*+h[b+4824>>3];i=i;return}function oU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[(c[a+416>>2]|0)+5160>>3]*+h[b+4800>>3]- +h[b+3160>>3];i=i;return}function pU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3184>>3]=+h[b+3120>>3]+ +h[b+3096>>3];i=i;return}function qU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3536>>3]=+h[b+3184>>3]*.8660254037844387+(+h[b+3192>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+5736>>3]*+h[b+4752>>3]);i=i;return}function rU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3528>>3]=+h[b+3184>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+5736>>3]*+h[b+4744>>3]+ +h[b+3192>>3]*.8660254037844387);i=i;return}function sU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+23896>>3]*+h[b+3536>>3]+ +h[b+23880>>3]*+h[b+3528>>3];i=i;return}function tU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3648>>3]=-+h[b+3656>>3]- +h[b+3584>>3];i=i;return}function uU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3664>>3]=+h[b+23904>>3]*+h[b+3536>>3]+ +h[b+23888>>3]*+h[b+3528>>3];i=i;return}function vU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3640>>3]=-+h[b+3664>>3]- +h[b+3576>>3];i=i;return}function wU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[b+23896>>3]*+h[b+4744>>3]+ +h[b+23880>>3]*+h[b+4752>>3];i=i;return}function xU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=-+h[b+4728>>3]- +h[b+4368>>3];i=i;return}function yU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4720>>3]=+h[b+23904>>3]*+h[b+4744>>3]+ +h[b+23888>>3]*+h[b+4752>>3];i=i;return}function zU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=-+h[b+4720>>3]- +h[b+4360>>3];i=i;return}function AU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26592>>3]));h[b+4136>>3]=-(d*+h[b+14048>>3]);i=i;return}function BU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26592>>3]));h[b+4144>>3]=d*+h[b+14048>>3];i=i;return}function CU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3888>>3]=+h[b+4136>>3]*-.4999999999999999+ +h[b+4144>>3]*.8660254037844387;i=i;return}function DU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3880>>3]=+h[b+4136>>3]*.8660254037844387+ +h[b+4144>>3]*.4999999999999999;i=i;return}function EU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26592>>3]));h[b+4152>>3]=-(d*+h[b+14048>>3]);i=i;return}function FU(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26592>>3]));h[b+4160>>3]=-(d*+h[b+14048>>3]);i=i;return}function GU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3904>>3]=+h[b+4152>>3]*-.4999999999999999+ +h[b+4160>>3]*.8660254037844387;i=i;return}function HU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3896>>3]=+h[b+4152>>3]*.8660254037844387+ +h[b+4160>>3]*.4999999999999999;i=i;return}function IU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=+h[b+14048>>3]- +h[b+16>>3];i=i;return}function JU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+40>>3]=0.0;i=i;return}function KU(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+32>>3]=0.0;i=i;return}function LU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26648>>3];k=+h[(c[b+416>>2]|0)+47744>>3];l=+h[g+32>>3];if(k!=0.0){m=g;n=l/k;o=j-n;h[m>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;h[m>>3]=o;i=d;return}p=l/+KBc(c[b+536>>2]|0,k,5272,5264,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=p;o=j-n;h[m>>3]=o;i=d;return}function MU(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0.0,o=0.0,p=0,q=0,r=0,s=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g>>3];k=+h[(c[b+416>>2]|0)+47744>>3];l=+h[g+40>>3];if(k!=0.0){m=g;n=l/k;o=j-n;p=m;q=p+8|0;r=q;h[r>>3]=o;i=d;return}if(l==0.0){m=g;n=l;o=j-n;p=m;q=p+8|0;r=q;h[r>>3]=o;i=d;return}s=l/+KBc(c[b+536>>2]|0,k,5272,5288,+h[f>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[e>>2]>>2]|0)+8>>2]|0;n=s;o=j-n;p=m;q=p+8|0;r=q;h[r>>3]=o;i=d;return}function NU(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26640>>3]=+h[b+8>>3];i=i;return}function OU(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+38160>>3]- +h[b+38280>>3];e=+h[b+38168>>3]- +h[b+38288>>3];f=+h[b+38176>>3]- +h[b+38296>>3];h[b+47632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5296,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47640>>3]=l;i=d;return}function QU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47648>>3]=+h[b+47640>>3];i=i;return}function RU(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+37776>>3]- +h[b+37896>>3];e=+h[b+37784>>3]- +h[b+37904>>3];f=+h[b+37792>>3]- +h[b+37912>>3];h[b+47592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function SU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5304,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47600>>3]=l;i=d;return}function TU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47608>>3]=+h[b+47600>>3];i=i;return}function UU(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+496>>2]=c[b+492>>2];i=i;return}function VU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47496>>3]=+h[b+47352>>3];i=i;return}function WU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47488>>3]=+h[b+47352>>3];i=i;return}function XU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47480>>3]=+h[b+47336>>3];i=i;return}function YU(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47352>>3];j=+h[f+47320>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5320,5312,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47472>>3]=l;i=d;return}function ZU(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37240>>3]=+h[b+36560>>3];i=i;return}function _U(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37232>>3]=+h[b+36552>>3];i=i;return}function $U(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37224>>3]=+h[b+36544>>3];i=i;return}function aV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+463|0]=a[d]|0;i=i;return}function bV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+467|0]=a[d+463|0]|0;i=i;return}function cV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+469|0]=a[d+463|0]|0;i=i;return}function dV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+471|0]=a[d+463|0]|0;i=i;return}function eV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+483|0]=a[d+471|0]|0;i=i;return}function fV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+484|0]=a[d+463|0]|0;i=i;return}function gV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+490|0]=a[d+484|0]|0;i=i;return}function hV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+498|0]=a[d+463|0]|0;i=i;return}function iV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+504|0]=a[d+498|0]|0;i=i;return}function jV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+511|0]=a[d+463|0]|0;i=i;return}function kV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+517|0]=a[d+511|0]|0;i=i;return}function lV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+524|0]=a[d+463|0]|0;i=i;return}function mV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+536|0]=a[d+524|0]|0;i=i;return}function nV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+537|0]=a[d+463|0]|0;i=i;return}function oV(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+549|0]=a[d+537|0]|0;i=i;return}function pV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38704>>3]=+h[b+38608>>3]/9.0;i=i;return}function qV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39120>>3]=+h[b+38704>>3];i=i;return}function rV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39128>>3]=+h[b+39120>>3]/3.0;i=i;return}function sV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39328>>3]=+h[b+38704>>3];i=i;return}function tV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39336>>3]=+h[b+39328>>3]/3.0;i=i;return}function uV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39544>>3]=+h[b+38704>>3];i=i;return}function vV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39552>>3]=+h[b+39544>>3]/3.0;i=i;return}function wV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39720>>3]=+h[b+38704>>3];i=i;return}function xV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39728>>3]=+h[b+39720>>3]/3.0;i=i;return}function yV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39872>>3]=+h[b+38704>>3];i=i;return}function zV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39880>>3]=+h[b+39872>>3]/3.0;i=i;return}function AV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40056>>3]=+h[b+38704>>3];i=i;return}function BV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40064>>3]=+h[b+40056>>3]/3.0;i=i;return}function CV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40600>>3]=+h[b+38704>>3];i=i;return}function DV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40608>>3]=+h[b+40600>>3]/3.0;i=i;return}function EV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40808>>3]=+h[b+38704>>3];i=i;return}function FV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40816>>3]=+h[b+40808>>3]/3.0;i=i;return}function GV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41024>>3]=+h[b+38704>>3];i=i;return}function HV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41032>>3]=+h[b+41024>>3]/3.0;i=i;return}function IV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41200>>3]=+h[b+38704>>3];i=i;return}function JV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41208>>3]=+h[b+41200>>3]/3.0;i=i;return}function KV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41352>>3]=+h[b+38704>>3];i=i;return}function LV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41360>>3]=+h[b+41352>>3]/3.0;i=i;return}function MV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41536>>3]=+h[b+38704>>3];i=i;return}function NV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41544>>3]=+h[b+41536>>3]/3.0;i=i;return}function OV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42080>>3]=+h[b+38704>>3];i=i;return}function PV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42088>>3]=+h[b+42080>>3]/3.0;i=i;return}function QV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42288>>3]=+h[b+38704>>3];i=i;return}function RV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42296>>3]=+h[b+42288>>3]/3.0;i=i;return}function SV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42504>>3]=+h[b+38704>>3];i=i;return}function TV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42512>>3]=+h[b+42504>>3]/3.0;i=i;return}function UV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42680>>3]=+h[b+38704>>3];i=i;return}function VV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42688>>3]=+h[b+42680>>3]/3.0;i=i;return}function WV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42832>>3]=+h[b+38704>>3];i=i;return}function XV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42840>>3]=+h[b+42832>>3]/3.0;i=i;return}function YV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43016>>3]=+h[b+38704>>3];i=i;return}function ZV(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43024>>3]=+h[b+43016>>3]/3.0;i=i;return}function _V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43560>>3]=+h[b+38704>>3];i=i;return}function $V(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43568>>3]=+h[b+43560>>3]/3.0;i=i;return}function aW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43768>>3]=+h[b+38704>>3];i=i;return}function bW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43776>>3]=+h[b+43768>>3]/3.0;i=i;return}function cW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43984>>3]=+h[b+38704>>3];i=i;return}function dW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43992>>3]=+h[b+43984>>3]/3.0;i=i;return}function eW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44160>>3]=+h[b+38704>>3];i=i;return}function fW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44168>>3]=+h[b+44160>>3]/3.0;i=i;return}function gW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44312>>3]=+h[b+38704>>3];i=i;return}function hW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44320>>3]=+h[b+44312>>3]/3.0;i=i;return}function iW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44496>>3]=+h[b+38704>>3];i=i;return}function jW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44504>>3]=+h[b+44496>>3]/3.0;i=i;return}function kW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45040>>3]=+h[b+38704>>3];i=i;return}function lW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45048>>3]=+h[b+45040>>3]/3.0;i=i;return}function mW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45248>>3]=+h[b+38704>>3];i=i;return}function nW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45256>>3]=+h[b+45248>>3]/3.0;i=i;return}function oW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45464>>3]=+h[b+38704>>3];i=i;return}function pW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45472>>3]=+h[b+45464>>3]/3.0;i=i;return}function qW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45640>>3]=+h[b+38704>>3];i=i;return}function rW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45648>>3]=+h[b+45640>>3]/3.0;i=i;return}function sW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45792>>3]=+h[b+38704>>3];i=i;return}function tW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45800>>3]=+h[b+45792>>3]/3.0;i=i;return}function uW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45976>>3]=+h[b+38704>>3];i=i;return}function vW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45984>>3]=+h[b+45976>>3]/3.0;i=i;return}function wW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46520>>3]=+h[b+38704>>3];i=i;return}function xW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46528>>3]=+h[b+46520>>3]/3.0;i=i;return}function yW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46728>>3]=+h[b+38704>>3];i=i;return}function zW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46736>>3]=+h[b+46728>>3]/3.0;i=i;return}function AW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46944>>3]=+h[b+38704>>3];i=i;return}function BW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46952>>3]=+h[b+46944>>3]/3.0;i=i;return}function CW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47120>>3]=+h[b+38704>>3];i=i;return}function DW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47128>>3]=+h[b+47120>>3]/3.0;i=i;return}function EW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47272>>3]=+h[b+38704>>3];i=i;return}function FW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47280>>3]=+h[b+47272>>3]/3.0;i=i;return}function GW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47456>>3]=+h[b+38704>>3];i=i;return}function HW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47464>>3]=+h[b+47456>>3]/3.0;i=i;return}function IW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+37192>>3]=l;i=b;return}function JW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+37184>>3]=l;i=b;return}function KW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+37176>>3]=l;i=b;return}function LW(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+37168>>3]=l;i=b;return}function MW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36896>>3]=+h[b+36584>>3];i=i;return}function NW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36968>>3]=+h[b+36896>>3];i=i;return}function OW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36888>>3]=+h[b+36576>>3];i=i;return}function PW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36960>>3]=+h[b+36888>>3];i=i;return}function QW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36880>>3]=+h[b+36568>>3];i=i;return}function RW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36952>>3]=+h[b+36880>>3];i=i;return}function SW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36944>>3]=+h[b+36632>>3];i=i;return}function TW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36936>>3]=+h[b+36624>>3];i=i;return}function UW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36928>>3]=+h[b+36616>>3];i=i;return}function VW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36920>>3]=+h[b+36608>>3];i=i;return}function WW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36912>>3]=+h[b+36600>>3];i=i;return}function XW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36904>>3]=+h[b+36592>>3];i=i;return}function YW(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+488>>2]=c[b+484>>2];i=i;return}function ZW(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47312>>3]=+h[b+47168>>3];i=i;return}function _W(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47304>>3]=+h[b+47168>>3];i=i;return}function $W(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47296>>3]=+h[b+47152>>3];i=i;return}function aX(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47168>>3];j=+h[f+47136>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5392,5384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47288>>3]=l;i=d;return}function bX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36464>>3]=+h[b+35784>>3];i=i;return}function cX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36456>>3]=+h[b+35776>>3];i=i;return}function dX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36448>>3]=+h[b+35768>>3];i=i;return}function eX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+36416>>3]=l;i=b;return}function fX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+36408>>3]=l;i=b;return}function gX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+36400>>3]=l;i=b;return}function hX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+36392>>3]=l;i=b;return}function iX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36120>>3]=+h[b+35808>>3];i=i;return}function jX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36192>>3]=+h[b+36120>>3];i=i;return}function kX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36112>>3]=+h[b+35800>>3];i=i;return}function lX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36184>>3]=+h[b+36112>>3];i=i;return}function mX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36104>>3]=+h[b+35792>>3];i=i;return}function nX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36176>>3]=+h[b+36104>>3];i=i;return}function oX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36168>>3]=+h[b+35856>>3];i=i;return}function pX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36160>>3]=+h[b+35848>>3];i=i;return}function qX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36152>>3]=+h[b+35840>>3];i=i;return}function rX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36144>>3]=+h[b+35832>>3];i=i;return}function sX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36136>>3]=+h[b+35824>>3];i=i;return}function tX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36128>>3]=+h[b+35816>>3];i=i;return}function uX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+35736>>3]=l;i=b;return}function vX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+35728>>3]=l;i=b;return}function wX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+35720>>3]=l;i=b;return}function xX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+35712>>3]=l;i=b;return}function yX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35440>>3]=+h[b+35032>>3];i=i;return}function zX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35512>>3]=+h[b+35440>>3];i=i;return}function AX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35432>>3]=+h[b+35024>>3];i=i;return}function BX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35504>>3]=+h[b+35432>>3];i=i;return}function CX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35424>>3]=+h[b+35016>>3];i=i;return}function DX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35496>>3]=+h[b+35424>>3];i=i;return}function EX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35488>>3]=+h[b+35080>>3];i=i;return}function FX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35480>>3]=+h[b+35072>>3];i=i;return}function GX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35472>>3]=+h[b+35064>>3];i=i;return}function HX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35464>>3]=+h[b+35056>>3];i=i;return}function IX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35456>>3]=+h[b+35048>>3];i=i;return}function JX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35448>>3]=+h[b+35040>>3];i=i;return}function KX(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+480>>2]=c[b+476>>2];i=i;return}function LX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47048>>3]=+h[b+47008>>3];i=i;return}function MX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47040>>3]=+h[b+46992>>3];i=i;return}function NX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35272>>3]=+h[b+34984>>3];i=i;return}function OX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35264>>3]=+h[b+34976>>3];i=i;return}function PX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35256>>3]=+h[b+34968>>3];i=i;return}function QX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46984>>3]=+h[b+46960>>3];i=i;return}function RX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+34936>>3]=l;i=b;return}function SX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+34928>>3]=l;i=b;return}function TX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+34920>>3]=l;i=b;return}function UX(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+34912>>3]=l;i=b;return}function VX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34640>>3]=+h[b+34232>>3];i=i;return}function WX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34712>>3]=+h[b+34640>>3];i=i;return}function XX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34632>>3]=+h[b+34224>>3];i=i;return}function YX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34704>>3]=+h[b+34632>>3];i=i;return}function ZX(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34624>>3]=+h[b+34216>>3];i=i;return}function _X(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34696>>3]=+h[b+34624>>3];i=i;return}function $X(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34688>>3]=+h[b+34280>>3];i=i;return}function aY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34680>>3]=+h[b+34272>>3];i=i;return}function bY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34672>>3]=+h[b+34264>>3];i=i;return}function cY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34664>>3]=+h[b+34256>>3];i=i;return}function dY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34656>>3]=+h[b+34248>>3];i=i;return}function eY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34648>>3]=+h[b+34240>>3];i=i;return}function fY(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+472>>2]=c[b+468>>2];i=i;return}function gY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46872>>3]=+h[b+46832>>3];i=i;return}function hY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46864>>3]=+h[b+46816>>3];i=i;return}function iY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34472>>3]=+h[b+34184>>3];i=i;return}function jY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34464>>3]=+h[b+34176>>3];i=i;return}function kY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34456>>3]=+h[b+34168>>3];i=i;return}function lY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46808>>3]=+h[b+46784>>3];i=i;return}function mY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+34040>>3]=l;i=b;return}function nY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+34032>>3]=l;i=b;return}function oY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+34024>>3]=l;i=b;return}function pY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+34016>>3]=l;i=b;return}function qY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33744>>3]=+h[b+33336>>3];i=i;return}function rY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33816>>3]=+h[b+33744>>3];i=i;return}function sY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33736>>3]=+h[b+33328>>3];i=i;return}function tY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33808>>3]=+h[b+33736>>3];i=i;return}function uY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33728>>3]=+h[b+33320>>3];i=i;return}function vY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33800>>3]=+h[b+33728>>3];i=i;return}function wY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33792>>3]=+h[b+33384>>3];i=i;return}function xY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33784>>3]=+h[b+33376>>3];i=i;return}function yY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33776>>3]=+h[b+33368>>3];i=i;return}function zY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33768>>3]=+h[b+33360>>3];i=i;return}function AY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33760>>3]=+h[b+33352>>3];i=i;return}function BY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33752>>3]=+h[b+33344>>3];i=i;return}function CY(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+460>>2]=c[b+456>>2];i=i;return}function DY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46656>>3]=+h[b+46616>>3];i=i;return}function EY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46648>>3]=+h[b+46600>>3];i=i;return}function FY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33576>>3]=+h[b+33288>>3];i=i;return}function GY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33568>>3]=+h[b+33280>>3];i=i;return}function HY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33560>>3]=+h[b+33272>>3];i=i;return}function IY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46592>>3]=+h[b+46568>>3];i=i;return}function JY(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+452>>2]=c[b+448>>2];i=i;return}function KY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46560>>3]=+h[b+46416>>3];i=i;return}function LY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46552>>3]=+h[b+46416>>3];i=i;return}function MY(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+46416>>3];j=+h[f+46384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5432,5424,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46536>>3]=l;i=d;return}function NY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33192>>3]=+h[b+32512>>3];i=i;return}function OY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33184>>3]=+h[b+32504>>3];i=i;return}function PY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33176>>3]=+h[b+32496>>3];i=i;return}function QY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+33144>>3]=l;i=b;return}function RY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+33136>>3]=l;i=b;return}function SY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+33128>>3]=l;i=b;return}function TY(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+33120>>3]=l;i=b;return}function UY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32848>>3]=+h[b+32536>>3];i=i;return}function VY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32920>>3]=+h[b+32848>>3];i=i;return}function WY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32840>>3]=+h[b+32528>>3];i=i;return}function XY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32912>>3]=+h[b+32840>>3];i=i;return}function YY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32832>>3]=+h[b+32520>>3];i=i;return}function ZY(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32904>>3]=+h[b+32832>>3];i=i;return}function _Y(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32896>>3]=+h[b+32584>>3];i=i;return}function $Y(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32888>>3]=+h[b+32576>>3];i=i;return}function aZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32880>>3]=+h[b+32568>>3];i=i;return}function bZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32872>>3]=+h[b+32560>>3];i=i;return}function cZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32864>>3]=+h[b+32552>>3];i=i;return}function dZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32856>>3]=+h[b+32544>>3];i=i;return}function eZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46296>>3]=+h[b+46288>>3];i=i;return}function fZ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+31752>>3]- +h[b+31872>>3];e=+h[b+31760>>3]- +h[b+31880>>3];f=+h[b+31768>>3]- +h[b+31888>>3];h[b+46152>>3]=+V(+(d*d+e*e+f*f));i=i;return}function gZ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46152>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5464,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46160>>3]=l;i=d;return}function hZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46168>>3]=+h[b+46160>>3];i=i;return}function iZ(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+31368>>3]- +h[b+31488>>3];e=+h[b+31376>>3]- +h[b+31496>>3];f=+h[b+31384>>3]- +h[b+31504>>3];h[b+46112>>3]=+V(+(d*d+e*e+f*f));i=i;return}function jZ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46120>>3]=l;i=d;return}function kZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46128>>3]=+h[b+46120>>3];i=i;return}function lZ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+412>>2]=c[b+408>>2];i=i;return}function mZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46016>>3]=+h[b+45872>>3];i=i;return}function nZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46008>>3]=+h[b+45872>>3];i=i;return}function oZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46e3>>3]=+h[b+45856>>3];i=i;return}function pZ(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+45872>>3];j=+h[f+45840>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5488,5480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45992>>3]=l;i=d;return}function qZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30832>>3]=+h[b+30152>>3];i=i;return}function rZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30824>>3]=+h[b+30144>>3];i=i;return}function sZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30816>>3]=+h[b+30136>>3];i=i;return}function tZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+372|0]=a[d]|0;i=i;return}function uZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+376|0]=a[d+372|0]|0;i=i;return}function vZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+378|0]=a[d+372|0]|0;i=i;return}function wZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+380|0]=a[d+372|0]|0;i=i;return}function xZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+392|0]=a[d+380|0]|0;i=i;return}function yZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+393|0]=a[d+372|0]|0;i=i;return}function zZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+399|0]=a[d+393|0]|0;i=i;return}function AZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+407|0]=a[d+372|0]|0;i=i;return}function BZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+413|0]=a[d+407|0]|0;i=i;return}function CZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+420|0]=a[d+372|0]|0;i=i;return}function DZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+426|0]=a[d+420|0]|0;i=i;return}function EZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+433|0]=a[d+372|0]|0;i=i;return}function FZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+445|0]=a[d+433|0]|0;i=i;return}function GZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+446|0]=a[d+372|0]|0;i=i;return}function HZ(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+458|0]=a[d+446|0]|0;i=i;return}function IZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+30784>>3]=l;i=b;return}function JZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+30776>>3]=l;i=b;return}function KZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+30768>>3]=l;i=b;return}function LZ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+30760>>3]=l;i=b;return}function MZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30488>>3]=+h[b+30176>>3];i=i;return}function NZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30560>>3]=+h[b+30488>>3];i=i;return}function OZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30480>>3]=+h[b+30168>>3];i=i;return}function PZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30552>>3]=+h[b+30480>>3];i=i;return}function QZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30472>>3]=+h[b+30160>>3];i=i;return}function RZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30544>>3]=+h[b+30472>>3];i=i;return}function SZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30536>>3]=+h[b+30224>>3];i=i;return}function TZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30528>>3]=+h[b+30216>>3];i=i;return}function UZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30520>>3]=+h[b+30208>>3];i=i;return}function VZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30512>>3]=+h[b+30200>>3];i=i;return}function WZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30504>>3]=+h[b+30192>>3];i=i;return}function XZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30496>>3]=+h[b+30184>>3];i=i;return}function YZ(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+404>>2]=c[b+400>>2];i=i;return}function ZZ(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45832>>3]=+h[b+45688>>3];i=i;return}function _Z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45824>>3]=+h[b+45688>>3];i=i;return}function $Z(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45816>>3]=+h[b+45672>>3];i=i;return}function a_(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+45688>>3];j=+h[f+45656>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5528,5520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45808>>3]=l;i=d;return}function b_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30056>>3]=+h[b+29376>>3];i=i;return}function c_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30048>>3]=+h[b+29368>>3];i=i;return}function d_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30040>>3]=+h[b+29360>>3];i=i;return}function e_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+30008>>3]=l;i=b;return}function f_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+3e4>>3]=l;i=b;return}function g_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+29992>>3]=l;i=b;return}function h_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+29984>>3]=l;i=b;return}function i_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29712>>3]=+h[b+29400>>3];i=i;return}function j_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29784>>3]=+h[b+29712>>3];i=i;return}function k_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29704>>3]=+h[b+29392>>3];i=i;return}function l_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29776>>3]=+h[b+29704>>3];i=i;return}function m_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29696>>3]=+h[b+29384>>3];i=i;return}function n_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29768>>3]=+h[b+29696>>3];i=i;return}function o_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29760>>3]=+h[b+29448>>3];i=i;return}function p_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29752>>3]=+h[b+29440>>3];i=i;return}function q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29744>>3]=+h[b+29432>>3];i=i;return}function r_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29736>>3]=+h[b+29424>>3];i=i;return}function s_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29728>>3]=+h[b+29416>>3];i=i;return}function t_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29720>>3]=+h[b+29408>>3];i=i;return}function u_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+29328>>3]=l;i=b;return}function v_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+29320>>3]=l;i=b;return}function w_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+29312>>3]=l;i=b;return}function x_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+29304>>3]=l;i=b;return}function y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29032>>3]=+h[b+28624>>3];i=i;return}function z_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29104>>3]=+h[b+29032>>3];i=i;return}function A_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29024>>3]=+h[b+28616>>3];i=i;return}function B_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29096>>3]=+h[b+29024>>3];i=i;return}function C_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29016>>3]=+h[b+28608>>3];i=i;return}function D_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29088>>3]=+h[b+29016>>3];i=i;return}function E_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29080>>3]=+h[b+28672>>3];i=i;return}function F_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29072>>3]=+h[b+28664>>3];i=i;return}function G_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29064>>3]=+h[b+28656>>3];i=i;return}function H_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29056>>3]=+h[b+28648>>3];i=i;return}function I_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29048>>3]=+h[b+28640>>3];i=i;return}function J_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29040>>3]=+h[b+28632>>3];i=i;return}function K_(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+396>>2]=c[b+392>>2];i=i;return}function L_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45568>>3]=+h[b+45528>>3];i=i;return}function M_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45560>>3]=+h[b+45512>>3];i=i;return}function N_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28864>>3]=+h[b+28576>>3];i=i;return}function O_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28856>>3]=+h[b+28568>>3];i=i;return}function P_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28848>>3]=+h[b+28560>>3];i=i;return}function Q_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45504>>3]=+h[b+45480>>3];i=i;return}function R_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+28528>>3]=l;i=b;return}function S_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+28520>>3]=l;i=b;return}function T_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+28512>>3]=l;i=b;return}function U_(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+28504>>3]=l;i=b;return}function V_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28232>>3]=+h[b+27824>>3];i=i;return}function W_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28304>>3]=+h[b+28232>>3];i=i;return}function X_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28224>>3]=+h[b+27816>>3];i=i;return}function Y_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28296>>3]=+h[b+28224>>3];i=i;return}function Z_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28216>>3]=+h[b+27808>>3];i=i;return}function __(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28288>>3]=+h[b+28216>>3];i=i;return}function $_(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28280>>3]=+h[b+27872>>3];i=i;return}function a$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28272>>3]=+h[b+27864>>3];i=i;return}function b$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28264>>3]=+h[b+27856>>3];i=i;return}function c$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28256>>3]=+h[b+27848>>3];i=i;return}function d$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28248>>3]=+h[b+27840>>3];i=i;return}function e$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28240>>3]=+h[b+27832>>3];i=i;return}function f$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+388>>2]=c[b+384>>2];i=i;return}function g$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45392>>3]=+h[b+45352>>3];i=i;return}function h$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45384>>3]=+h[b+45336>>3];i=i;return}function i$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28064>>3]=+h[b+27776>>3];i=i;return}function j$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28056>>3]=+h[b+27768>>3];i=i;return}function k$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28048>>3]=+h[b+27760>>3];i=i;return}function l$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45328>>3]=+h[b+45304>>3];i=i;return}function m$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+27632>>3]=l;i=b;return}function n$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+27624>>3]=l;i=b;return}function o$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+27616>>3]=l;i=b;return}function p$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+27608>>3]=l;i=b;return}function q$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27336>>3]=+h[b+26928>>3];i=i;return}function r$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27408>>3]=+h[b+27336>>3];i=i;return}function s$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27328>>3]=+h[b+26920>>3];i=i;return}function t$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27400>>3]=+h[b+27328>>3];i=i;return}function u$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27320>>3]=+h[b+26912>>3];i=i;return}function v$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27392>>3]=+h[b+27320>>3];i=i;return}function w$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27384>>3]=+h[b+26976>>3];i=i;return}function x$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27376>>3]=+h[b+26968>>3];i=i;return}function y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27368>>3]=+h[b+26960>>3];i=i;return}function z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27360>>3]=+h[b+26952>>3];i=i;return}function A$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27352>>3]=+h[b+26944>>3];i=i;return}function B$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27344>>3]=+h[b+26936>>3];i=i;return}function C$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+376>>2]=c[b+372>>2];i=i;return}function D$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45176>>3]=+h[b+45136>>3];i=i;return}function E$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45168>>3]=+h[b+45120>>3];i=i;return}function F$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27168>>3]=+h[b+26880>>3];i=i;return}function G$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27160>>3]=+h[b+26872>>3];i=i;return}function H$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27152>>3]=+h[b+26864>>3];i=i;return}function I$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45112>>3]=+h[b+45088>>3];i=i;return}function J$(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+368>>2]=c[b+364>>2];i=i;return}function K$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45080>>3]=+h[b+44936>>3];i=i;return}function L$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45072>>3]=+h[b+44936>>3];i=i;return}function M$(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+44936>>3];j=+h[f+44904>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5568,5560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45056>>3]=l;i=d;return}function N$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26784>>3]=+h[b+26104>>3];i=i;return}function O$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26776>>3]=+h[b+26096>>3];i=i;return}function P$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26768>>3]=+h[b+26088>>3];i=i;return}function Q$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+26736>>3]=l;i=b;return}function R$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+26728>>3]=l;i=b;return}function S$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+26720>>3]=l;i=b;return}function T$(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+26712>>3]=l;i=b;return}function U$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26440>>3]=+h[b+26128>>3];i=i;return}function V$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26512>>3]=+h[b+26440>>3];i=i;return}function W$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26432>>3]=+h[b+26120>>3];i=i;return}function X$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26504>>3]=+h[b+26432>>3];i=i;return}function Y$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26424>>3]=+h[b+26112>>3];i=i;return}function Z$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26496>>3]=+h[b+26424>>3];i=i;return}function _$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26488>>3]=+h[b+26176>>3];i=i;return}function $$(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26480>>3]=+h[b+26168>>3];i=i;return}function a0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26472>>3]=+h[b+26160>>3];i=i;return}function b0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26464>>3]=+h[b+26152>>3];i=i;return}function c0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26456>>3]=+h[b+26144>>3];i=i;return}function d0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26448>>3]=+h[b+26136>>3];i=i;return}function e0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44816>>3]=+h[b+44808>>3];i=i;return}function f0(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+25344>>3]- +h[b+25464>>3];e=+h[b+25352>>3]- +h[b+25472>>3];f=+h[b+25360>>3]- +h[b+25480>>3];h[b+44672>>3]=+V(+(d*d+e*e+f*f));i=i;return}function g0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44672>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44680>>3]=l;i=d;return}function h0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44688>>3]=+h[b+44680>>3];i=i;return}function i0(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+24960>>3]- +h[b+25080>>3];e=+h[b+24968>>3]- +h[b+25088>>3];f=+h[b+24976>>3]- +h[b+25096>>3];h[b+44632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function j0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44640>>3]=l;i=d;return}function k0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44648>>3]=+h[b+44640>>3];i=i;return}function l0(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+328>>2]=c[b+324>>2];i=i;return}function m0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44536>>3]=+h[b+44392>>3];i=i;return}function n0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44528>>3]=+h[b+44392>>3];i=i;return}function o0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44520>>3]=+h[b+44376>>3];i=i;return}function p0(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+44392>>3];j=+h[f+44360>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5624,5616,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44512>>3]=l;i=d;return}function q0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24424>>3]=+h[b+23744>>3];i=i;return}function r0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24416>>3]=+h[b+23736>>3];i=i;return}function s0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24408>>3]=+h[b+23728>>3];i=i;return}function t0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+281|0]=a[d]|0;i=i;return}function u0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+285|0]=a[d+281|0]|0;i=i;return}function v0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+287|0]=a[d+281|0]|0;i=i;return}function w0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+289|0]=a[d+281|0]|0;i=i;return}function x0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+301|0]=a[d+289|0]|0;i=i;return}function y0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+302|0]=a[d+281|0]|0;i=i;return}function z0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+308|0]=a[d+302|0]|0;i=i;return}function A0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+316|0]=a[d+281|0]|0;i=i;return}function B0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+322|0]=a[d+316|0]|0;i=i;return}function C0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+329|0]=a[d+281|0]|0;i=i;return}function D0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+335|0]=a[d+329|0]|0;i=i;return}function E0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+342|0]=a[d+281|0]|0;i=i;return}function F0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+354|0]=a[d+342|0]|0;i=i;return}function G0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+355|0]=a[d+281|0]|0;i=i;return}function H0(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+367|0]=a[d+355|0]|0;i=i;return}function I0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+24376>>3]=l;i=b;return}function J0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+24368>>3]=l;i=b;return}function K0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+24360>>3]=l;i=b;return}function L0(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+24352>>3]=l;i=b;return}function M0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24080>>3]=+h[b+23768>>3];i=i;return}function N0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24152>>3]=+h[b+24080>>3];i=i;return}function O0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24072>>3]=+h[b+23760>>3];i=i;return}function P0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24144>>3]=+h[b+24072>>3];i=i;return}function Q0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24064>>3]=+h[b+23752>>3];i=i;return}function R0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24136>>3]=+h[b+24064>>3];i=i;return}function S0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24128>>3]=+h[b+23816>>3];i=i;return}function T0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24120>>3]=+h[b+23808>>3];i=i;return}function U0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24112>>3]=+h[b+23800>>3];i=i;return}function V0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24104>>3]=+h[b+23792>>3];i=i;return}function W0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24096>>3]=+h[b+23784>>3];i=i;return}function X0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24088>>3]=+h[b+23776>>3];i=i;return}function Y0(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+320>>2]=c[b+316>>2];i=i;return}function Z0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44352>>3]=+h[b+44208>>3];i=i;return}function _0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44344>>3]=+h[b+44208>>3];i=i;return}function $0(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44336>>3]=+h[b+44192>>3];i=i;return}function a1(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+44208>>3];j=+h[f+44176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5664,5656,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44328>>3]=l;i=d;return}function b1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23648>>3]=+h[b+22968>>3];i=i;return}function c1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23640>>3]=+h[b+22960>>3];i=i;return}function d1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23632>>3]=+h[b+22952>>3];i=i;return}function e1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+23600>>3]=l;i=b;return}function f1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+23592>>3]=l;i=b;return}function g1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+23584>>3]=l;i=b;return}function h1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+23576>>3]=l;i=b;return}function i1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23304>>3]=+h[b+22992>>3];i=i;return}function j1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23376>>3]=+h[b+23304>>3];i=i;return}function k1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23296>>3]=+h[b+22984>>3];i=i;return}function l1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23368>>3]=+h[b+23296>>3];i=i;return}function m1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23288>>3]=+h[b+22976>>3];i=i;return}function n1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23360>>3]=+h[b+23288>>3];i=i;return}function o1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23352>>3]=+h[b+23040>>3];i=i;return}function p1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23344>>3]=+h[b+23032>>3];i=i;return}function q1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23336>>3]=+h[b+23024>>3];i=i;return}function r1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23328>>3]=+h[b+23016>>3];i=i;return}function s1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23320>>3]=+h[b+23008>>3];i=i;return}function t1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23312>>3]=+h[b+23e3>>3];i=i;return}function u1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+22920>>3]=l;i=b;return}function v1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+22912>>3]=l;i=b;return}function w1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+22904>>3]=l;i=b;return}function x1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+22896>>3]=l;i=b;return}function y1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22624>>3]=+h[b+22216>>3];i=i;return}function z1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22696>>3]=+h[b+22624>>3];i=i;return}function A1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22616>>3]=+h[b+22208>>3];i=i;return}function B1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22688>>3]=+h[b+22616>>3];i=i;return}function C1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22608>>3]=+h[b+22200>>3];i=i;return}function D1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22680>>3]=+h[b+22608>>3];i=i;return}function E1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22672>>3]=+h[b+22264>>3];i=i;return}function F1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22664>>3]=+h[b+22256>>3];i=i;return}function G1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22656>>3]=+h[b+22248>>3];i=i;return}function H1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22648>>3]=+h[b+22240>>3];i=i;return}function I1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22640>>3]=+h[b+22232>>3];i=i;return}function J1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22632>>3]=+h[b+22224>>3];i=i;return}function K1(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+312>>2]=c[b+308>>2];i=i;return}function L1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44088>>3]=+h[b+44048>>3];i=i;return}function M1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44080>>3]=+h[b+44032>>3];i=i;return}function N1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22456>>3]=+h[b+22168>>3];i=i;return}function O1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22448>>3]=+h[b+22160>>3];i=i;return}function P1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22440>>3]=+h[b+22152>>3];i=i;return}function Q1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44024>>3]=+h[b+44e3>>3];i=i;return}function R1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+22120>>3]=l;i=b;return}function S1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+22112>>3]=l;i=b;return}function T1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+22104>>3]=l;i=b;return}function U1(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+22096>>3]=l;i=b;return}function V1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21824>>3]=+h[b+21416>>3];i=i;return}function W1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21896>>3]=+h[b+21824>>3];i=i;return}function X1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21816>>3]=+h[b+21408>>3];i=i;return}function Y1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21888>>3]=+h[b+21816>>3];i=i;return}function Z1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21808>>3]=+h[b+21400>>3];i=i;return}function _1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21880>>3]=+h[b+21808>>3];i=i;return}function $1(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21872>>3]=+h[b+21464>>3];i=i;return}function a2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21864>>3]=+h[b+21456>>3];i=i;return}function b2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21856>>3]=+h[b+21448>>3];i=i;return}function c2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21848>>3]=+h[b+21440>>3];i=i;return}function d2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21840>>3]=+h[b+21432>>3];i=i;return}function e2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21832>>3]=+h[b+21424>>3];i=i;return}function f2(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+304>>2]=c[b+300>>2];i=i;return}function g2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43912>>3]=+h[b+43872>>3];i=i;return}function h2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43904>>3]=+h[b+43856>>3];i=i;return}function i2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21656>>3]=+h[b+21368>>3];i=i;return}function j2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21648>>3]=+h[b+21360>>3];i=i;return}function k2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21640>>3]=+h[b+21352>>3];i=i;return}function l2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43848>>3]=+h[b+43824>>3];i=i;return}function m2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+21224>>3]=l;i=b;return}function n2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+21216>>3]=l;i=b;return}function o2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+21208>>3]=l;i=b;return}function p2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+21200>>3]=l;i=b;return}function q2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20928>>3]=+h[b+20520>>3];i=i;return}function r2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21e3>>3]=+h[b+20928>>3];i=i;return}function s2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20920>>3]=+h[b+20512>>3];i=i;return}function t2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20992>>3]=+h[b+20920>>3];i=i;return}function u2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20912>>3]=+h[b+20504>>3];i=i;return}function v2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20984>>3]=+h[b+20912>>3];i=i;return}function w2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20976>>3]=+h[b+20568>>3];i=i;return}function x2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20968>>3]=+h[b+20560>>3];i=i;return}function y2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20960>>3]=+h[b+20552>>3];i=i;return}function z2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20952>>3]=+h[b+20544>>3];i=i;return}function A2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20944>>3]=+h[b+20536>>3];i=i;return}function B2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20936>>3]=+h[b+20528>>3];i=i;return}function C2(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+292>>2]=c[b+288>>2];i=i;return}function D2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43696>>3]=+h[b+43656>>3];i=i;return}function E2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43688>>3]=+h[b+43640>>3];i=i;return}function F2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20760>>3]=+h[b+20472>>3];i=i;return}function G2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20752>>3]=+h[b+20464>>3];i=i;return}function H2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20744>>3]=+h[b+20456>>3];i=i;return}function I2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43632>>3]=+h[b+43608>>3];i=i;return}function J2(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+284>>2]=c[b+280>>2];i=i;return}function K2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43600>>3]=+h[b+43456>>3];i=i;return}function L2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43592>>3]=+h[b+43456>>3];i=i;return}function M2(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+43456>>3];j=+h[f+43424>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5704,5696,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43576>>3]=l;i=d;return}function N2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20376>>3]=+h[b+19696>>3];i=i;return}function O2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20368>>3]=+h[b+19688>>3];i=i;return}function P2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20360>>3]=+h[b+19680>>3];i=i;return}function Q2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+20328>>3]=l;i=b;return}function R2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+20320>>3]=l;i=b;return}function S2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+20312>>3]=l;i=b;return}function T2(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+20304>>3]=l;i=b;return}function U2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20032>>3]=+h[b+19720>>3];i=i;return}function V2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20104>>3]=+h[b+20032>>3];i=i;return}function W2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20024>>3]=+h[b+19712>>3];i=i;return}function X2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20096>>3]=+h[b+20024>>3];i=i;return}function Y2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20016>>3]=+h[b+19704>>3];i=i;return}function Z2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20088>>3]=+h[b+20016>>3];i=i;return}function _2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20080>>3]=+h[b+19768>>3];i=i;return}function $2(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20072>>3]=+h[b+19760>>3];i=i;return}function a3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20064>>3]=+h[b+19752>>3];i=i;return}function b3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20056>>3]=+h[b+19744>>3];i=i;return}function c3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20048>>3]=+h[b+19736>>3];i=i;return}function d3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20040>>3]=+h[b+19728>>3];i=i;return}function e3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43336>>3]=+h[b+43328>>3];i=i;return}function f3(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18936>>3]- +h[b+19056>>3];e=+h[b+18944>>3]- +h[b+19064>>3];f=+h[b+18952>>3]- +h[b+19072>>3];h[b+43192>>3]=+V(+(d*d+e*e+f*f));i=i;return}function g3(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43192>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5736,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43200>>3]=l;i=d;return}function h3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43208>>3]=+h[b+43200>>3];i=i;return}function i3(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18552>>3]- +h[b+18672>>3];e=+h[b+18560>>3]- +h[b+18680>>3];f=+h[b+18568>>3]- +h[b+18688>>3];h[b+43152>>3]=+V(+(d*d+e*e+f*f));i=i;return}function j3(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43152>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5744,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43160>>3]=l;i=d;return}function k3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43168>>3]=+h[b+43160>>3];i=i;return}function l3(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+244>>2]=c[b+240>>2];i=i;return}function m3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43056>>3]=+h[b+42912>>3];i=i;return}function n3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43048>>3]=+h[b+42912>>3];i=i;return}function o3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43040>>3]=+h[b+42896>>3];i=i;return}function p3(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+42912>>3];j=+h[f+42880>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5760,5752,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43032>>3]=l;i=d;return}function q3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18016>>3]=+h[b+17336>>3];i=i;return}function r3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18008>>3]=+h[b+17328>>3];i=i;return}function s3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18e3>>3]=+h[b+17320>>3];i=i;return}function t3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+190|0]=a[d]|0;i=i;return}function u3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+194|0]=a[d+190|0]|0;i=i;return}function v3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+196|0]=a[d+190|0]|0;i=i;return}function w3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+198|0]=a[d+190|0]|0;i=i;return}function x3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+210|0]=a[d+198|0]|0;i=i;return}function y3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+211|0]=a[d+190|0]|0;i=i;return}function z3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+217|0]=a[d+211|0]|0;i=i;return}function A3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+225|0]=a[d+190|0]|0;i=i;return}function B3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+231|0]=a[d+225|0]|0;i=i;return}function C3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+238|0]=a[d+190|0]|0;i=i;return}function D3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+244|0]=a[d+238|0]|0;i=i;return}function E3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+251|0]=a[d+190|0]|0;i=i;return}function F3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+263|0]=a[d+251|0]|0;i=i;return}function G3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+264|0]=a[d+190|0]|0;i=i;return}function H3(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+276|0]=a[d+264|0]|0;i=i;return}function I3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+17968>>3]=l;i=b;return}function J3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+17960>>3]=l;i=b;return}function K3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+17952>>3]=l;i=b;return}function L3(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+17944>>3]=l;i=b;return}function M3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17672>>3]=+h[b+17360>>3];i=i;return}function N3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17744>>3]=+h[b+17672>>3];i=i;return}function O3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17664>>3]=+h[b+17352>>3];i=i;return}function P3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17736>>3]=+h[b+17664>>3];i=i;return}function Q3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17656>>3]=+h[b+17344>>3];i=i;return}function R3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17728>>3]=+h[b+17656>>3];i=i;return}function S3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17720>>3]=+h[b+17408>>3];i=i;return}function T3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17712>>3]=+h[b+17400>>3];i=i;return}function U3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17704>>3]=+h[b+17392>>3];i=i;return}function V3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17696>>3]=+h[b+17384>>3];i=i;return}function W3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17688>>3]=+h[b+17376>>3];i=i;return}function X3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17680>>3]=+h[b+17368>>3];i=i;return}function Y3(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+236>>2]=c[b+232>>2];i=i;return}function Z3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42872>>3]=+h[b+42728>>3];i=i;return}function _3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42864>>3]=+h[b+42728>>3];i=i;return}function $3(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42856>>3]=+h[b+42712>>3];i=i;return}function a4(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+42728>>3];j=+h[f+42696>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5800,5792,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+42848>>3]=l;i=d;return}function b4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17240>>3]=+h[b+16560>>3];i=i;return}function c4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17232>>3]=+h[b+16552>>3];i=i;return}function d4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17224>>3]=+h[b+16544>>3];i=i;return}function e4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+17192>>3]=l;i=b;return}function f4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+17184>>3]=l;i=b;return}function g4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+17176>>3]=l;i=b;return}function h4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+17168>>3]=l;i=b;return}function i4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16896>>3]=+h[b+16584>>3];i=i;return}function j4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16968>>3]=+h[b+16896>>3];i=i;return}function k4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16888>>3]=+h[b+16576>>3];i=i;return}function l4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16960>>3]=+h[b+16888>>3];i=i;return}function m4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16880>>3]=+h[b+16568>>3];i=i;return}function n4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16952>>3]=+h[b+16880>>3];i=i;return}function o4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16944>>3]=+h[b+16632>>3];i=i;return}function p4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16936>>3]=+h[b+16624>>3];i=i;return}function q4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16928>>3]=+h[b+16616>>3];i=i;return}function r4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16920>>3]=+h[b+16608>>3];i=i;return}function s4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16912>>3]=+h[b+16600>>3];i=i;return}function t4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16904>>3]=+h[b+16592>>3];i=i;return}function u4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+16512>>3]=l;i=b;return}function v4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+16504>>3]=l;i=b;return}function w4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+16496>>3]=l;i=b;return}function x4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+16488>>3]=l;i=b;return}function y4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16216>>3]=+h[b+15808>>3];i=i;return}function z4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16288>>3]=+h[b+16216>>3];i=i;return}function A4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16208>>3]=+h[b+15800>>3];i=i;return}function B4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16280>>3]=+h[b+16208>>3];i=i;return}function C4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16200>>3]=+h[b+15792>>3];i=i;return}function D4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16272>>3]=+h[b+16200>>3];i=i;return}function E4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16264>>3]=+h[b+15856>>3];i=i;return}function F4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16256>>3]=+h[b+15848>>3];i=i;return}function G4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16248>>3]=+h[b+15840>>3];i=i;return}function H4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16240>>3]=+h[b+15832>>3];i=i;return}function I4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16232>>3]=+h[b+15824>>3];i=i;return}function J4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16224>>3]=+h[b+15816>>3];i=i;return}function K4(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+228>>2]=c[b+224>>2];i=i;return}function L4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42608>>3]=+h[b+42568>>3];i=i;return}function M4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42600>>3]=+h[b+42552>>3];i=i;return}function N4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16048>>3]=+h[b+15760>>3];i=i;return}function O4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16040>>3]=+h[b+15752>>3];i=i;return}function P4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16032>>3]=+h[b+15744>>3];i=i;return}function Q4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42544>>3]=+h[b+42520>>3];i=i;return}function R4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+15712>>3]=l;i=b;return}function S4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+15704>>3]=l;i=b;return}function T4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+15696>>3]=l;i=b;return}function U4(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+15688>>3]=l;i=b;return}function V4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15416>>3]=+h[b+15008>>3];i=i;return}function W4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15488>>3]=+h[b+15416>>3];i=i;return}function X4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15408>>3]=+h[b+15e3>>3];i=i;return}function Y4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15480>>3]=+h[b+15408>>3];i=i;return}function Z4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15400>>3]=+h[b+14992>>3];i=i;return}function _4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15472>>3]=+h[b+15400>>3];i=i;return}function $4(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15464>>3]=+h[b+15056>>3];i=i;return}function a5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15456>>3]=+h[b+15048>>3];i=i;return}function b5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15448>>3]=+h[b+15040>>3];i=i;return}function c5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15440>>3]=+h[b+15032>>3];i=i;return}function d5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15432>>3]=+h[b+15024>>3];i=i;return}function e5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15424>>3]=+h[b+15016>>3];i=i;return}function f5(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+220>>2]=c[b+216>>2];i=i;return}function g5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42432>>3]=+h[b+42392>>3];i=i;return}function h5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42424>>3]=+h[b+42376>>3];i=i;return}function i5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15248>>3]=+h[b+14960>>3];i=i;return}function j5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15240>>3]=+h[b+14952>>3];i=i;return}function k5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15232>>3]=+h[b+14944>>3];i=i;return}function l5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42368>>3]=+h[b+42344>>3];i=i;return}function m5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+14816>>3]=l;i=b;return}function n5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+14808>>3]=l;i=b;return}function o5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+14800>>3]=l;i=b;return}function p5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+14792>>3]=l;i=b;return}function q5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14520>>3]=+h[b+14112>>3];i=i;return}function r5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14592>>3]=+h[b+14520>>3];i=i;return}function s5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14512>>3]=+h[b+14104>>3];i=i;return}function t5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14584>>3]=+h[b+14512>>3];i=i;return}function u5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14504>>3]=+h[b+14096>>3];i=i;return}function v5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14576>>3]=+h[b+14504>>3];i=i;return}function w5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14568>>3]=+h[b+14160>>3];i=i;return}function x5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14560>>3]=+h[b+14152>>3];i=i;return}function y5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14552>>3]=+h[b+14144>>3];i=i;return}function z5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14544>>3]=+h[b+14136>>3];i=i;return}function A5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14536>>3]=+h[b+14128>>3];i=i;return}function B5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14528>>3]=+h[b+14120>>3];i=i;return}function C5(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+208>>2]=c[b+204>>2];i=i;return}function D5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42216>>3]=+h[b+42176>>3];i=i;return}function E5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42208>>3]=+h[b+42160>>3];i=i;return}function F5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14352>>3]=+h[b+14064>>3];i=i;return}function G5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14344>>3]=+h[b+14056>>3];i=i;return}function H5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14336>>3]=+h[b+14048>>3];i=i;return}function I5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42152>>3]=+h[b+42128>>3];i=i;return}function J5(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+200>>2]=c[b+196>>2];i=i;return}function K5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42120>>3]=+h[b+41976>>3];i=i;return}function L5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42112>>3]=+h[b+41976>>3];i=i;return}



function jQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21616>>3]=+h[b+21328>>3];i=i;return}function kQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21624>>3]=+h[b+21336>>3];i=i;return}function lQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21632>>3]=+h[b+21344>>3];i=i;return}function mQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21640>>3]=+h[b+21352>>3];i=i;return}function nQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21648>>3]=+h[b+21360>>3];i=i;return}function oQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21656>>3]=+h[b+21368>>3];i=i;return}function pQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43896>>3]=+h[b+43840>>3];i=i;return}function qQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43904>>3]=+h[b+43856>>3];i=i;return}function rQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43912>>3]=+h[b+43872>>3];i=i;return}function sQb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+304>>2]=c[b+300>>2];i=i;return}function tQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21808>>3]=+h[b+21400>>3];i=i;return}function uQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21816>>3]=+h[b+21408>>3];i=i;return}function vQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21824>>3]=+h[b+21416>>3];i=i;return}function wQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21832>>3]=+h[b+21424>>3];i=i;return}function xQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21840>>3]=+h[b+21432>>3];i=i;return}function yQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21848>>3]=+h[b+21440>>3];i=i;return}function zQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21856>>3]=+h[b+21448>>3];i=i;return}function AQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21864>>3]=+h[b+21456>>3];i=i;return}function BQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21872>>3]=+h[b+21464>>3];i=i;return}function CQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21880>>3]=+h[b+21808>>3];i=i;return}function DQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21888>>3]=+h[b+21816>>3];i=i;return}function EQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21896>>3]=+h[b+21824>>3];i=i;return}function FQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43984>>3]=+h[b+38704>>3];i=i;return}function GQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+22096>>3]=l;i=b;return}function HQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+22104>>3]=l;i=b;return}function IQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+22112>>3]=l;i=b;return}function JQb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+22120>>3]=l;i=b;return}function KQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43992>>3]=+h[b+43984>>3]/3.0;i=i;return}function LQb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+329|0]=a[d+281|0]|0;i=i;return}function MQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22136>>3]=+h[b+43288>>3];i=i;return}function NQb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+22128>>3]- +h[b+22152>>3];e=+h[b+22136>>3]- +h[b+22160>>3];f=+h[b+22144>>3]- +h[b+22168>>3];h[b+44016>>3]=+V(+(d*d+e*e+f*f));i=i;return}function OQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44024>>3]=+h[b+44e3>>3];i=i;return}function PQb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+335|0]=a[d+329|0]|0;i=i;return}function QQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22416>>3]=+h[b+22128>>3];i=i;return}function RQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22424>>3]=+h[b+22136>>3];i=i;return}function SQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22432>>3]=+h[b+22144>>3];i=i;return}function TQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22440>>3]=+h[b+22152>>3];i=i;return}function UQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22448>>3]=+h[b+22160>>3];i=i;return}function VQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22456>>3]=+h[b+22168>>3];i=i;return}function WQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44072>>3]=+h[b+44016>>3];i=i;return}function XQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44080>>3]=+h[b+44032>>3];i=i;return}function YQb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44088>>3]=+h[b+44048>>3];i=i;return}function ZQb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+312>>2]=c[b+308>>2];i=i;return}function _Qb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22608>>3]=+h[b+22200>>3];i=i;return}function $Qb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22616>>3]=+h[b+22208>>3];i=i;return}function aRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22624>>3]=+h[b+22216>>3];i=i;return}function bRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22632>>3]=+h[b+22224>>3];i=i;return}function cRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22640>>3]=+h[b+22232>>3];i=i;return}function dRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22648>>3]=+h[b+22240>>3];i=i;return}function eRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22656>>3]=+h[b+22248>>3];i=i;return}function fRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22664>>3]=+h[b+22256>>3];i=i;return}function gRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22672>>3]=+h[b+22264>>3];i=i;return}function hRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22680>>3]=+h[b+22608>>3];i=i;return}function iRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22688>>3]=+h[b+22616>>3];i=i;return}function jRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22696>>3]=+h[b+22624>>3];i=i;return}function kRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44160>>3]=+h[b+38704>>3];i=i;return}function lRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+22896>>3]=l;i=b;return}function mRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+22904>>3]=l;i=b;return}function nRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+22912>>3]=l;i=b;return}function oRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+22920>>3]=l;i=b;return}function pRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44168>>3]=+h[b+44160>>3]/3.0;i=i;return}function qRb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+342|0]=a[d+281|0]|0;i=i;return}function rRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22928>>3]=+h[b+43296>>3];i=i;return}function sRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23288>>3]=+h[b+22976>>3];i=i;return}function tRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23296>>3]=+h[b+22984>>3];i=i;return}function uRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23304>>3]=+h[b+22992>>3];i=i;return}function vRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23312>>3]=+h[b+23e3>>3];i=i;return}function wRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23320>>3]=+h[b+23008>>3];i=i;return}function xRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23328>>3]=+h[b+23016>>3];i=i;return}function yRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23336>>3]=+h[b+23024>>3];i=i;return}function zRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23344>>3]=+h[b+23032>>3];i=i;return}function ARb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23352>>3]=+h[b+23040>>3];i=i;return}function BRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23360>>3]=+h[b+23288>>3];i=i;return}function CRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23368>>3]=+h[b+23296>>3];i=i;return}function DRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23376>>3]=+h[b+23304>>3];i=i;return}function ERb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44312>>3]=+h[b+38704>>3];i=i;return}function FRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+23576>>3]=l;i=b;return}function GRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+23584>>3]=l;i=b;return}function HRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+23592>>3]=l;i=b;return}function IRb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+23600>>3]=l;i=b;return}function JRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44320>>3]=+h[b+44312>>3]/3.0;i=i;return}function KRb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+354|0]=a[d+342|0]|0;i=i;return}function LRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23608>>3]=+h[b+22928>>3];i=i;return}function MRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23616>>3]=+h[b+22936>>3];i=i;return}function NRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23624>>3]=+h[b+22944>>3];i=i;return}function ORb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23632>>3]=+h[b+22952>>3];i=i;return}function PRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23640>>3]=+h[b+22960>>3];i=i;return}function QRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23648>>3]=+h[b+22968>>3];i=i;return}function RRb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+44208>>3];j=+h[f+44176>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7120,7112,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44328>>3]=l;i=d;return}function SRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44336>>3]=+h[b+44192>>3];i=i;return}function TRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44344>>3]=+h[b+44208>>3];i=i;return}function URb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44352>>3]=+h[b+44208>>3];i=i;return}function VRb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+320>>2]=c[b+316>>2];i=i;return}function WRb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+355|0]=a[d+281|0]|0;i=i;return}function XRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23704>>3]=+h[b+43280>>3]- +h[b+43296>>3];i=i;return}function YRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24064>>3]=+h[b+23752>>3];i=i;return}function ZRb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24072>>3]=+h[b+23760>>3];i=i;return}function _Rb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24080>>3]=+h[b+23768>>3];i=i;return}function $Rb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24088>>3]=+h[b+23776>>3];i=i;return}function aSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24096>>3]=+h[b+23784>>3];i=i;return}function bSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24104>>3]=+h[b+23792>>3];i=i;return}function cSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24112>>3]=+h[b+23800>>3];i=i;return}function dSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24120>>3]=+h[b+23808>>3];i=i;return}function eSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24128>>3]=+h[b+23816>>3];i=i;return}function fSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24136>>3]=+h[b+24064>>3];i=i;return}function gSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24144>>3]=+h[b+24072>>3];i=i;return}function hSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24152>>3]=+h[b+24080>>3];i=i;return}function iSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44496>>3]=+h[b+38704>>3];i=i;return}function jSb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+24352>>3]=l;i=b;return}function kSb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+24360>>3]=l;i=b;return}function lSb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+24368>>3]=l;i=b;return}function mSb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+24376>>3]=l;i=b;return}function nSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44504>>3]=+h[b+44496>>3]/3.0;i=i;return}function oSb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+367|0]=a[d+355|0]|0;i=i;return}function pSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24384>>3]=+h[b+23704>>3];i=i;return}function qSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12280>>3]=+h[b+12608>>3]+ +h[(c[a+416>>2]|0)+24384>>3];i=i;return}function rSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12256>>3]=+h[b+12280>>3]+ +h[(c[a+416>>2]|0)+22416>>3];i=i;return}function sSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12232>>3]=+h[b+12256>>3]+ +h[(c[a+416>>2]|0)+23608>>3];i=i;return}function tSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12208>>3]=+h[b+12232>>3]+ +h[(c[a+416>>2]|0)+21616>>3];i=i;return}function uSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12160>>3]=+h[b+12208>>3]+ +h[(c[a+416>>2]|0)+25344>>3];i=i;return}function vSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11960>>3]=+h[b+12160>>3]+ +h[(c[a+416>>2]|0)+31368>>3];i=i;return}function wSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24392>>3]=+h[b+23712>>3];i=i;return}function xSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24400>>3]=+h[b+23720>>3];i=i;return}function ySb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24408>>3]=+h[b+23728>>3];i=i;return}function zSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24416>>3]=+h[b+23736>>3];i=i;return}function ASb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24424>>3]=+h[b+23744>>3];i=i;return}function BSb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+44392>>3];j=+h[f+44360>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7160,7152,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44512>>3]=l;i=d;return}function CSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44520>>3]=+h[b+44376>>3];i=i;return}function DSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44528>>3]=+h[b+44392>>3];i=i;return}function ESb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44536>>3]=+h[b+44392>>3];i=i;return}function FSb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+328>>2]=c[b+324>>2];i=i;return}function GSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24480>>3]=+h[b+43296>>3]*.5;i=i;return}function HSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12184>>3]=+h[b+12256>>3]+ +h[(c[a+416>>2]|0)+24480>>3];i=i;return}function ISb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+24480>>3]- +h[b+24504>>3];e=+h[b+24488>>3]- +h[b+24512>>3];f=+h[b+24496>>3]- +h[b+24520>>3];h[b+44552>>3]=+V(+(d*d+e*e+f*f));i=i;return}function JSb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44552>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7192,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44560>>3]=l;i=d;return}function KSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44568>>3]=+h[b+44560>>3];i=i;return}function LSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24576>>3]=+h[b+43280>>3]+ +h[b+43296>>3]*-.5;i=i;return}function MSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14496>>3]=+h[b+14664>>3]+ +h[(c[a+416>>2]|0)+24576>>3];i=i;return}function NSb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14472>>3]=+h[b+14496>>3]+ +h[(c[a+416>>2]|0)+19560>>3];i=i;return}function OSb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+24576>>3]- +h[b+24696>>3];e=+h[b+24584>>3]- +h[b+24704>>3];f=+h[b+24592>>3]- +h[b+24712>>3];h[b+44592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PSb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7200,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44600>>3]=l;i=d;return}function QSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44608>>3]=+h[b+44600>>3];i=i;return}function RSb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+24960>>3]- +h[b+25080>>3];e=+h[b+24968>>3]- +h[b+25088>>3];f=+h[b+24976>>3]- +h[b+25096>>3];h[b+44632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function SSb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7208,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44640>>3]=l;i=d;return}function TSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44648>>3]=+h[b+44640>>3];i=i;return}function USb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+25344>>3]- +h[b+25464>>3];e=+h[b+25352>>3]- +h[b+25472>>3];f=+h[b+25360>>3]- +h[b+25480>>3];h[b+44672>>3]=+V(+(d*d+e*e+f*f));i=i;return}function VSb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44672>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7216,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44680>>3]=l;i=d;return}function WSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44688>>3]=+h[b+44680>>3];i=i;return}function XSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44696>>3]=+h[b+43816>>3];i=i;return}function YSb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+372|0]=a[d]|0;i=i;return}function ZSb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44816>>3]=+h[b+44808>>3];i=i;return}function _Sb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+376|0]=a[d+372|0]|0;i=i;return}function $Sb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+378|0]=a[d+372|0]|0;i=i;return}function aTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25976>>3]=+h[b+44736>>3];i=i;return}function bTb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14536>>3]=+h[b+14560>>3]+(+h[d+25976>>3]*-.4999999999999999+ +h[d+25984>>3]*.8660254037844387);i=i;return}function cTb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14528>>3]=+h[b+14552>>3]+(+h[d+25976>>3]*.8660254037844387+ +h[d+25984>>3]*.4999999999999999);i=i;return}function dTb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+25968>>3]- +h[b+25992>>3];e=+h[b+25976>>3]- +h[b+26e3>>3];f=+h[b+25984>>3]- +h[b+26008>>3];h[b+44880>>3]=+V(+(d*d+e*e+f*f));i=i;return}function eTb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44880>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7224,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44888>>3]=l;i=d;return}function fTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44896>>3]=+h[b+44888>>3];i=i;return}function gTb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+380|0]=a[d+372|0]|0;i=i;return}function hTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26072>>3]=+h[b+44744>>3];i=i;return}function iTb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+26064>>3]- +h[b+26088>>3];e=+h[b+26072>>3]- +h[b+26096>>3];f=+h[b+26080>>3]- +h[b+26104>>3];h[b+44920>>3]=+V(+(d*d+e*e+f*f));i=i;return}function jTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26424>>3]=+h[b+26112>>3];i=i;return}function kTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26432>>3]=+h[b+26120>>3];i=i;return}function lTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26440>>3]=+h[b+26128>>3];i=i;return}function mTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26448>>3]=+h[b+26136>>3];i=i;return}function nTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26456>>3]=+h[b+26144>>3];i=i;return}function oTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26464>>3]=+h[b+26152>>3];i=i;return}function pTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26472>>3]=+h[b+26160>>3];i=i;return}function qTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26480>>3]=+h[b+26168>>3];i=i;return}function rTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26488>>3]=+h[b+26176>>3];i=i;return}function sTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26496>>3]=+h[b+26424>>3];i=i;return}function tTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26504>>3]=+h[b+26432>>3];i=i;return}function uTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26512>>3]=+h[b+26440>>3];i=i;return}function vTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45040>>3]=+h[b+38704>>3];i=i;return}function wTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+26712>>3]=l;i=b;return}function xTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+26720>>3]=l;i=b;return}function yTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+26728>>3]=l;i=b;return}function zTb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+26736>>3]=l;i=b;return}function ATb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45048>>3]=+h[b+45040>>3]/3.0;i=i;return}function BTb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+392|0]=a[d+380|0]|0;i=i;return}function CTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26744>>3]=+h[b+26064>>3];i=i;return}function DTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26752>>3]=+h[b+26072>>3];i=i;return}function ETb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26760>>3]=+h[b+26080>>3];i=i;return}function FTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26768>>3]=+h[b+26088>>3];i=i;return}function GTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26776>>3]=+h[b+26096>>3];i=i;return}function HTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26784>>3]=+h[b+26104>>3];i=i;return}function ITb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+44936>>3];j=+h[f+44904>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7240,7232,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45056>>3]=l;i=d;return}function JTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45064>>3]=+h[b+44920>>3];i=i;return}function KTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45072>>3]=+h[b+44936>>3];i=i;return}function LTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45080>>3]=+h[b+44936>>3];i=i;return}function MTb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+368>>2]=c[b+364>>2];i=i;return}function NTb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+393|0]=a[d+372|0]|0;i=i;return}function OTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26848>>3]=+h[b+44752>>3];i=i;return}function PTb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+26840>>3]- +h[b+26864>>3];e=+h[b+26848>>3]- +h[b+26872>>3];f=+h[b+26856>>3]- +h[b+26880>>3];h[b+45104>>3]=+V(+(d*d+e*e+f*f));i=i;return}function QTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45112>>3]=+h[b+45088>>3];i=i;return}function RTb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+399|0]=a[d+393|0]|0;i=i;return}function STb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27128>>3]=+h[b+26840>>3];i=i;return}function TTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27136>>3]=+h[b+26848>>3];i=i;return}function UTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27144>>3]=+h[b+26856>>3];i=i;return}function VTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27152>>3]=+h[b+26864>>3];i=i;return}function WTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27160>>3]=+h[b+26872>>3];i=i;return}function XTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27168>>3]=+h[b+26880>>3];i=i;return}function YTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45160>>3]=+h[b+45104>>3];i=i;return}function ZTb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45168>>3]=+h[b+45120>>3];i=i;return}function _Tb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45176>>3]=+h[b+45136>>3];i=i;return}function $Tb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+376>>2]=c[b+372>>2];i=i;return}function aUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27320>>3]=+h[b+26912>>3];i=i;return}function bUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27328>>3]=+h[b+26920>>3];i=i;return}function cUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27336>>3]=+h[b+26928>>3];i=i;return}function dUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27344>>3]=+h[b+26936>>3];i=i;return}function eUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27352>>3]=+h[b+26944>>3];i=i;return}function fUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27360>>3]=+h[b+26952>>3];i=i;return}function gUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27368>>3]=+h[b+26960>>3];i=i;return}function hUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27376>>3]=+h[b+26968>>3];i=i;return}function iUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27384>>3]=+h[b+26976>>3];i=i;return}function jUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27392>>3]=+h[b+27320>>3];i=i;return}function kUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27400>>3]=+h[b+27328>>3];i=i;return}function lUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27408>>3]=+h[b+27336>>3];i=i;return}function mUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45248>>3]=+h[b+38704>>3];i=i;return}function nUb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+27608>>3]=l;i=b;return}function oUb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+27616>>3]=l;i=b;return}function pUb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+27624>>3]=l;i=b;return}function qUb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+27632>>3]=l;i=b;return}function rUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45256>>3]=+h[b+45248>>3]/3.0;i=i;return}function sUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27640>>3]=+h[b+44760>>3];i=i;return}function tUb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14616>>3]=+h[b+14640>>3]+ +h[(c[a+416>>2]|0)+27640>>3];i=i;return}function uUb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+27640>>3]- +h[b+27664>>3];e=+h[b+27648>>3]- +h[b+27672>>3];f=+h[b+27656>>3]- +h[b+27680>>3];h[b+45272>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vUb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+45272>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7272,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45280>>3]=l;i=d;return}function wUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45288>>3]=+h[b+45280>>3];i=i;return}function xUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45296>>3]=+h[b+44736>>3]+(+h[b+44768>>3]+(-+h[b+44752>>3]- +h[b+44744>>3]));i=i;return}function yUb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+407|0]=a[d+372|0]|0;i=i;return}function zUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27744>>3]=-+h[b+44768>>3];i=i;return}function AUb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+27736>>3]- +h[b+27760>>3];e=+h[b+27744>>3]- +h[b+27768>>3];f=+h[b+27752>>3]- +h[b+27776>>3];h[b+45320>>3]=+V(+(d*d+e*e+f*f));i=i;return}function BUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45328>>3]=+h[b+45304>>3];i=i;return}function CUb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+413|0]=a[d+407|0]|0;i=i;return}function DUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28024>>3]=+h[b+27736>>3];i=i;return}function EUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28032>>3]=+h[b+27744>>3];i=i;return}function FUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28040>>3]=+h[b+27752>>3];i=i;return}function GUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28048>>3]=+h[b+27760>>3];i=i;return}function HUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28056>>3]=+h[b+27768>>3];i=i;return}function IUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28064>>3]=+h[b+27776>>3];i=i;return}function JUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45376>>3]=+h[b+45320>>3];i=i;return}function KUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45384>>3]=+h[b+45336>>3];i=i;return}function LUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45392>>3]=+h[b+45352>>3];i=i;return}function MUb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+388>>2]=c[b+384>>2];i=i;return}function NUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28216>>3]=+h[b+27808>>3];i=i;return}function OUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28224>>3]=+h[b+27816>>3];i=i;return}function PUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28232>>3]=+h[b+27824>>3];i=i;return}function QUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28240>>3]=+h[b+27832>>3];i=i;return}function RUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28248>>3]=+h[b+27840>>3];i=i;return}function SUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28256>>3]=+h[b+27848>>3];i=i;return}function TUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28264>>3]=+h[b+27856>>3];i=i;return}function UUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28272>>3]=+h[b+27864>>3];i=i;return}function VUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28280>>3]=+h[b+27872>>3];i=i;return}function WUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28288>>3]=+h[b+28216>>3];i=i;return}function XUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28296>>3]=+h[b+28224>>3];i=i;return}function YUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28304>>3]=+h[b+28232>>3];i=i;return}function ZUb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45464>>3]=+h[b+38704>>3];i=i;return}function _Ub(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+28504>>3]=l;i=b;return}function $Ub(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+28512>>3]=l;i=b;return}function aVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+28520>>3]=l;i=b;return}function bVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+28528>>3]=l;i=b;return}function cVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45472>>3]=+h[b+45464>>3]/3.0;i=i;return}function dVb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+420|0]=a[d+372|0]|0;i=i;return}function eVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28544>>3]=+h[b+44768>>3];i=i;return}function fVb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+28536>>3]- +h[b+28560>>3];e=+h[b+28544>>3]- +h[b+28568>>3];f=+h[b+28552>>3]- +h[b+28576>>3];h[b+45496>>3]=+V(+(d*d+e*e+f*f));i=i;return}function gVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45504>>3]=+h[b+45480>>3];i=i;return}function hVb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+426|0]=a[d+420|0]|0;i=i;return}function iVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28824>>3]=+h[b+28536>>3];i=i;return}function jVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28832>>3]=+h[b+28544>>3];i=i;return}function kVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28840>>3]=+h[b+28552>>3];i=i;return}function lVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28848>>3]=+h[b+28560>>3];i=i;return}function mVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28856>>3]=+h[b+28568>>3];i=i;return}function nVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+28864>>3]=+h[b+28576>>3];i=i;return}function oVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45552>>3]=+h[b+45496>>3];i=i;return}function pVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45560>>3]=+h[b+45512>>3];i=i;return}function qVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45568>>3]=+h[b+45528>>3];i=i;return}function rVb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+396>>2]=c[b+392>>2];i=i;return}function sVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29016>>3]=+h[b+28608>>3];i=i;return}function tVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29024>>3]=+h[b+28616>>3];i=i;return}function uVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29032>>3]=+h[b+28624>>3];i=i;return}function vVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29040>>3]=+h[b+28632>>3];i=i;return}function wVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29048>>3]=+h[b+28640>>3];i=i;return}function xVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29056>>3]=+h[b+28648>>3];i=i;return}function yVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29064>>3]=+h[b+28656>>3];i=i;return}function zVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29072>>3]=+h[b+28664>>3];i=i;return}function AVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29080>>3]=+h[b+28672>>3];i=i;return}function BVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29088>>3]=+h[b+29016>>3];i=i;return}function CVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29096>>3]=+h[b+29024>>3];i=i;return}function DVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29104>>3]=+h[b+29032>>3];i=i;return}function EVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45640>>3]=+h[b+38704>>3];i=i;return}function FVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+29304>>3]=l;i=b;return}function GVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+29312>>3]=l;i=b;return}function HVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+29320>>3]=l;i=b;return}function IVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+29328>>3]=l;i=b;return}function JVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45648>>3]=+h[b+45640>>3]/3.0;i=i;return}function KVb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+433|0]=a[d+372|0]|0;i=i;return}function LVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29336>>3]=+h[b+44776>>3];i=i;return}function MVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29696>>3]=+h[b+29384>>3];i=i;return}function NVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29704>>3]=+h[b+29392>>3];i=i;return}function OVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29712>>3]=+h[b+29400>>3];i=i;return}function PVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29720>>3]=+h[b+29408>>3];i=i;return}function QVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29728>>3]=+h[b+29416>>3];i=i;return}function RVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29736>>3]=+h[b+29424>>3];i=i;return}function SVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29744>>3]=+h[b+29432>>3];i=i;return}function TVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29752>>3]=+h[b+29440>>3];i=i;return}function UVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29760>>3]=+h[b+29448>>3];i=i;return}function VVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29768>>3]=+h[b+29696>>3];i=i;return}function WVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29776>>3]=+h[b+29704>>3];i=i;return}function XVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+29784>>3]=+h[b+29712>>3];i=i;return}function YVb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45792>>3]=+h[b+38704>>3];i=i;return}function ZVb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+29984>>3]=l;i=b;return}function _Vb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+29992>>3]=l;i=b;return}function $Vb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+3e4>>3]=l;i=b;return}function aWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+30008>>3]=l;i=b;return}function bWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45800>>3]=+h[b+45792>>3]/3.0;i=i;return}function cWb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+445|0]=a[d+433|0]|0;i=i;return}function dWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30016>>3]=+h[b+29336>>3];i=i;return}function eWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30024>>3]=+h[b+29344>>3];i=i;return}function fWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30032>>3]=+h[b+29352>>3];i=i;return}function gWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30040>>3]=+h[b+29360>>3];i=i;return}function hWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30048>>3]=+h[b+29368>>3];i=i;return}function iWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30056>>3]=+h[b+29376>>3];i=i;return}function jWb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+45688>>3];j=+h[f+45656>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7288,7280,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45808>>3]=l;i=d;return}function kWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45816>>3]=+h[b+45672>>3];i=i;return}function lWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45824>>3]=+h[b+45688>>3];i=i;return}function mWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45832>>3]=+h[b+45688>>3];i=i;return}function nWb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+404>>2]=c[b+400>>2];i=i;return}function oWb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+446|0]=a[d+372|0]|0;i=i;return}function pWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30112>>3]=+h[b+44760>>3]- +h[b+44776>>3];i=i;return}function qWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30472>>3]=+h[b+30160>>3];i=i;return}function rWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30480>>3]=+h[b+30168>>3];i=i;return}function sWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30488>>3]=+h[b+30176>>3];i=i;return}function tWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30496>>3]=+h[b+30184>>3];i=i;return}function uWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30504>>3]=+h[b+30192>>3];i=i;return}function vWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30512>>3]=+h[b+30200>>3];i=i;return}function wWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30520>>3]=+h[b+30208>>3];i=i;return}function xWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30528>>3]=+h[b+30216>>3];i=i;return}function yWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30536>>3]=+h[b+30224>>3];i=i;return}function zWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30544>>3]=+h[b+30472>>3];i=i;return}function AWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30552>>3]=+h[b+30480>>3];i=i;return}function BWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30560>>3]=+h[b+30488>>3];i=i;return}function CWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45976>>3]=+h[b+38704>>3];i=i;return}function DWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+30760>>3]=l;i=b;return}function EWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+30768>>3]=l;i=b;return}function FWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+30776>>3]=l;i=b;return}function GWb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+30784>>3]=l;i=b;return}function HWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45984>>3]=+h[b+45976>>3]/3.0;i=i;return}function IWb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+458|0]=a[d+446|0]|0;i=i;return}function JWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30792>>3]=+h[b+30112>>3];i=i;return}function KWb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11632>>3]=+h[b+11960>>3]+ +h[(c[a+416>>2]|0)+30792>>3];i=i;return}function LWb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11608>>3]=+h[b+11632>>3]+ +h[(c[a+416>>2]|0)+28824>>3];i=i;return}function MWb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11584>>3]=+h[b+11608>>3]+ +h[(c[a+416>>2]|0)+30016>>3];i=i;return}function NWb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11560>>3]=+h[b+11584>>3]+ +h[(c[a+416>>2]|0)+28024>>3];i=i;return}function OWb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11512>>3]=+h[b+11560>>3]+ +h[(c[a+416>>2]|0)+31752>>3];i=i;return}function PWb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11360>>3]=+h[b+11512>>3]+ +h[(c[a+416>>2]|0)+37776>>3];i=i;return}function QWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30800>>3]=+h[b+30120>>3];i=i;return}function RWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30808>>3]=+h[b+30128>>3];i=i;return}function SWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30816>>3]=+h[b+30136>>3];i=i;return}function TWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30824>>3]=+h[b+30144>>3];i=i;return}function UWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30832>>3]=+h[b+30152>>3];i=i;return}function VWb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+45872>>3];j=+h[f+45840>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7328,7320,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45992>>3]=l;i=d;return}function WWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46e3>>3]=+h[b+45856>>3];i=i;return}function XWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46008>>3]=+h[b+45872>>3];i=i;return}function YWb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46016>>3]=+h[b+45872>>3];i=i;return}function ZWb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+412>>2]=c[b+408>>2];i=i;return}function _Wb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30888>>3]=+h[b+44776>>3]*.5;i=i;return}function $Wb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11536>>3]=+h[b+11608>>3]+ +h[(c[a+416>>2]|0)+30888>>3];i=i;return}function aXb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+30888>>3]- +h[b+30912>>3];e=+h[b+30896>>3]- +h[b+30920>>3];f=+h[b+30904>>3]- +h[b+30928>>3];h[b+46032>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bXb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46032>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7360,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46040>>3]=l;i=d;return}function cXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46048>>3]=+h[b+46040>>3];i=i;return}function dXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+30984>>3]=+h[b+44760>>3]+ +h[b+44776>>3]*-.5;i=i;return}function eXb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14544>>3]=+h[b+14640>>3]+ +h[(c[a+416>>2]|0)+30984>>3];i=i;return}function fXb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14520>>3]=+h[b+14544>>3]+ +h[(c[a+416>>2]|0)+25968>>3];i=i;return}function gXb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+30984>>3]- +h[b+31104>>3];e=+h[b+30992>>3]- +h[b+31112>>3];f=+h[b+31e3>>3]- +h[b+31120>>3];h[b+46072>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hXb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46072>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7368,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46080>>3]=l;i=d;return}function iXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46088>>3]=+h[b+46080>>3];i=i;return}function jXb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+31368>>3]- +h[b+31488>>3];e=+h[b+31376>>3]- +h[b+31496>>3];f=+h[b+31384>>3]- +h[b+31504>>3];h[b+46112>>3]=+V(+(d*d+e*e+f*f));i=i;return}function kXb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7376,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46120>>3]=l;i=d;return}function lXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46128>>3]=+h[b+46120>>3];i=i;return}function mXb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+31752>>3]- +h[b+31872>>3];e=+h[b+31760>>3]- +h[b+31880>>3];f=+h[b+31768>>3]- +h[b+31888>>3];h[b+46152>>3]=+V(+(d*d+e*e+f*f));i=i;return}function nXb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46152>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7384,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46160>>3]=l;i=d;return}function oXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46168>>3]=+h[b+46160>>3];i=i;return}function pXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46176>>3]=+h[b+45296>>3];i=i;return}function qXb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+463|0]=a[d]|0;i=i;return}function rXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46296>>3]=+h[b+46288>>3];i=i;return}function sXb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+467|0]=a[d+463|0]|0;i=i;return}function tXb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+469|0]=a[d+463|0]|0;i=i;return}function uXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32384>>3]=+h[b+46216>>3];i=i;return}function vXb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14584>>3]=+h[b+14608>>3]+(+h[d+32384>>3]*.4999999999999999+ +h[d+32392>>3]*.8660254037844387);i=i;return}function wXb(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14576>>3]=+h[b+14600>>3]+(+h[d+32384>>3]*.8660254037844387+ +h[d+32392>>3]*-.4999999999999999);i=i;return}function xXb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+32376>>3]- +h[b+32400>>3];e=+h[b+32384>>3]- +h[b+32408>>3];f=+h[b+32392>>3]- +h[b+32416>>3];h[b+46360>>3]=+V(+(d*d+e*e+f*f));i=i;return}function yXb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46360>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7392,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46368>>3]=l;i=d;return}function zXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46376>>3]=+h[b+46368>>3];i=i;return}function AXb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+471|0]=a[d+463|0]|0;i=i;return}function BXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32480>>3]=+h[b+46224>>3];i=i;return}function CXb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+32472>>3]- +h[b+32496>>3];e=+h[b+32480>>3]- +h[b+32504>>3];f=+h[b+32488>>3]- +h[b+32512>>3];h[b+46400>>3]=+V(+(d*d+e*e+f*f));i=i;return}function DXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32832>>3]=+h[b+32520>>3];i=i;return}function EXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32840>>3]=+h[b+32528>>3];i=i;return}function FXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32848>>3]=+h[b+32536>>3];i=i;return}function GXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32856>>3]=+h[b+32544>>3];i=i;return}function HXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32864>>3]=+h[b+32552>>3];i=i;return}function IXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32872>>3]=+h[b+32560>>3];i=i;return}function JXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32880>>3]=+h[b+32568>>3];i=i;return}function KXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32888>>3]=+h[b+32576>>3];i=i;return}function LXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32896>>3]=+h[b+32584>>3];i=i;return}function MXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32904>>3]=+h[b+32832>>3];i=i;return}function NXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32912>>3]=+h[b+32840>>3];i=i;return}function OXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+32920>>3]=+h[b+32848>>3];i=i;return}function PXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46520>>3]=+h[b+38704>>3];i=i;return}function QXb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+33120>>3]=l;i=b;return}function RXb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+33128>>3]=l;i=b;return}function SXb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+33136>>3]=l;i=b;return}function TXb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+33144>>3]=l;i=b;return}function UXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46528>>3]=+h[b+46520>>3]/3.0;i=i;return}function VXb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+483|0]=a[d+471|0]|0;i=i;return}function WXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33152>>3]=+h[b+32472>>3];i=i;return}function XXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33160>>3]=+h[b+32480>>3];i=i;return}function YXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33168>>3]=+h[b+32488>>3];i=i;return}function ZXb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33176>>3]=+h[b+32496>>3];i=i;return}function _Xb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33184>>3]=+h[b+32504>>3];i=i;return}function $Xb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33192>>3]=+h[b+32512>>3];i=i;return}function aYb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+46416>>3];j=+h[f+46384>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7408,7400,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46536>>3]=l;i=d;return}function bYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46544>>3]=+h[b+46400>>3];i=i;return}function cYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46552>>3]=+h[b+46416>>3];i=i;return}function dYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46560>>3]=+h[b+46416>>3];i=i;return}function eYb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+452>>2]=c[b+448>>2];i=i;return}function fYb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+484|0]=a[d+463|0]|0;i=i;return}function gYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33256>>3]=+h[b+46232>>3];i=i;return}function hYb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+33248>>3]- +h[b+33272>>3];e=+h[b+33256>>3]- +h[b+33280>>3];f=+h[b+33264>>3]- +h[b+33288>>3];h[b+46584>>3]=+V(+(d*d+e*e+f*f));i=i;return}function iYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46592>>3]=+h[b+46568>>3];i=i;return}function jYb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+490|0]=a[d+484|0]|0;i=i;return}function kYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33536>>3]=+h[b+33248>>3];i=i;return}function lYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33544>>3]=+h[b+33256>>3];i=i;return}function mYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33552>>3]=+h[b+33264>>3];i=i;return}function nYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33560>>3]=+h[b+33272>>3];i=i;return}function oYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33568>>3]=+h[b+33280>>3];i=i;return}function pYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33576>>3]=+h[b+33288>>3];i=i;return}function qYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46640>>3]=+h[b+46584>>3];i=i;return}function rYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46648>>3]=+h[b+46600>>3];i=i;return}function sYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46656>>3]=+h[b+46616>>3];i=i;return}function tYb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+460>>2]=c[b+456>>2];i=i;return}function uYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33728>>3]=+h[b+33320>>3];i=i;return}function vYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33736>>3]=+h[b+33328>>3];i=i;return}function wYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33744>>3]=+h[b+33336>>3];i=i;return}function xYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33752>>3]=+h[b+33344>>3];i=i;return}function yYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33760>>3]=+h[b+33352>>3];i=i;return}function zYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33768>>3]=+h[b+33360>>3];i=i;return}function AYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33776>>3]=+h[b+33368>>3];i=i;return}function BYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33784>>3]=+h[b+33376>>3];i=i;return}function CYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33792>>3]=+h[b+33384>>3];i=i;return}function DYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33800>>3]=+h[b+33728>>3];i=i;return}function EYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33808>>3]=+h[b+33736>>3];i=i;return}function FYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+33816>>3]=+h[b+33744>>3];i=i;return}function GYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46728>>3]=+h[b+38704>>3];i=i;return}function HYb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+34016>>3]=l;i=b;return}function IYb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+34024>>3]=l;i=b;return}function JYb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+34032>>3]=l;i=b;return}function KYb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+34040>>3]=l;i=b;return}function LYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46736>>3]=+h[b+46728>>3]/3.0;i=i;return}function MYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34048>>3]=+h[b+46240>>3];i=i;return}function NYb(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10656>>3]=+h[b+14616>>3]+ +h[(c[a+416>>2]|0)+34048>>3];i=i;return}function OYb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+34048>>3]- +h[b+34072>>3];e=+h[b+34056>>3]- +h[b+34080>>3];f=+h[b+34064>>3]- +h[b+34088>>3];h[b+46752>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PYb(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+46752>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7440,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+46760>>3]=l;i=d;return}function QYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46768>>3]=+h[b+46760>>3];i=i;return}function RYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46776>>3]=+h[b+46216>>3]+(+h[b+46248>>3]+(-+h[b+46232>>3]- +h[b+46224>>3]));i=i;return}function SYb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+498|0]=a[d+463|0]|0;i=i;return}function TYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34152>>3]=-+h[b+46248>>3];i=i;return}function UYb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+34144>>3]- +h[b+34168>>3];e=+h[b+34152>>3]- +h[b+34176>>3];f=+h[b+34160>>3]- +h[b+34184>>3];h[b+46800>>3]=+V(+(d*d+e*e+f*f));i=i;return}function VYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46808>>3]=+h[b+46784>>3];i=i;return}function WYb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+504|0]=a[d+498|0]|0;i=i;return}function XYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34432>>3]=+h[b+34144>>3];i=i;return}function YYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34440>>3]=+h[b+34152>>3];i=i;return}function ZYb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34448>>3]=+h[b+34160>>3];i=i;return}function _Yb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34456>>3]=+h[b+34168>>3];i=i;return}function $Yb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34464>>3]=+h[b+34176>>3];i=i;return}function aZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34472>>3]=+h[b+34184>>3];i=i;return}function bZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46856>>3]=+h[b+46800>>3];i=i;return}function cZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46864>>3]=+h[b+46816>>3];i=i;return}function dZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46872>>3]=+h[b+46832>>3];i=i;return}function eZb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+472>>2]=c[b+468>>2];i=i;return}function fZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34624>>3]=+h[b+34216>>3];i=i;return}function gZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34632>>3]=+h[b+34224>>3];i=i;return}function hZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34640>>3]=+h[b+34232>>3];i=i;return}function iZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34648>>3]=+h[b+34240>>3];i=i;return}function jZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34656>>3]=+h[b+34248>>3];i=i;return}function kZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34664>>3]=+h[b+34256>>3];i=i;return}function lZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34672>>3]=+h[b+34264>>3];i=i;return}function mZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34680>>3]=+h[b+34272>>3];i=i;return}function nZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34688>>3]=+h[b+34280>>3];i=i;return}function oZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34696>>3]=+h[b+34624>>3];i=i;return}function pZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34704>>3]=+h[b+34632>>3];i=i;return}function qZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34712>>3]=+h[b+34640>>3];i=i;return}function rZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46944>>3]=+h[b+38704>>3];i=i;return}function sZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+34912>>3]=l;i=b;return}function tZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+34920>>3]=l;i=b;return}function uZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+34928>>3]=l;i=b;return}function vZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+34936>>3]=l;i=b;return}function wZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46952>>3]=+h[b+46944>>3]/3.0;i=i;return}function xZb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+511|0]=a[d+463|0]|0;i=i;return}function yZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+34952>>3]=+h[b+46248>>3];i=i;return}function zZb(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+34944>>3]- +h[b+34968>>3];e=+h[b+34952>>3]- +h[b+34976>>3];f=+h[b+34960>>3]- +h[b+34984>>3];h[b+46976>>3]=+V(+(d*d+e*e+f*f));i=i;return}function AZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+46984>>3]=+h[b+46960>>3];i=i;return}function BZb(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+517|0]=a[d+511|0]|0;i=i;return}function CZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35232>>3]=+h[b+34944>>3];i=i;return}function DZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35240>>3]=+h[b+34952>>3];i=i;return}function EZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35248>>3]=+h[b+34960>>3];i=i;return}function FZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35256>>3]=+h[b+34968>>3];i=i;return}function GZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35264>>3]=+h[b+34976>>3];i=i;return}function HZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35272>>3]=+h[b+34984>>3];i=i;return}function IZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47032>>3]=+h[b+46976>>3];i=i;return}function JZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47040>>3]=+h[b+46992>>3];i=i;return}function KZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47048>>3]=+h[b+47008>>3];i=i;return}function LZb(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+480>>2]=c[b+476>>2];i=i;return}function MZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35424>>3]=+h[b+35016>>3];i=i;return}function NZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35432>>3]=+h[b+35024>>3];i=i;return}function OZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35440>>3]=+h[b+35032>>3];i=i;return}function PZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35448>>3]=+h[b+35040>>3];i=i;return}function QZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35456>>3]=+h[b+35048>>3];i=i;return}function RZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35464>>3]=+h[b+35056>>3];i=i;return}function SZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35472>>3]=+h[b+35064>>3];i=i;return}function TZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35480>>3]=+h[b+35072>>3];i=i;return}function UZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35488>>3]=+h[b+35080>>3];i=i;return}function VZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35496>>3]=+h[b+35424>>3];i=i;return}function WZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35504>>3]=+h[b+35432>>3];i=i;return}function XZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35512>>3]=+h[b+35440>>3];i=i;return}function YZb(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47120>>3]=+h[b+38704>>3];i=i;return}function ZZb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+35712>>3]=l;i=b;return}function _Zb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+35720>>3]=l;i=b;return}function $Zb(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+35728>>3]=l;i=b;return}function a_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+35736>>3]=l;i=b;return}function b_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47128>>3]=+h[b+47120>>3]/3.0;i=i;return}function c_b(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+524|0]=a[d+463|0]|0;i=i;return}function d_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+35744>>3]=+h[b+46256>>3];i=i;return}function e_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36104>>3]=+h[b+35792>>3];i=i;return}function f_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36112>>3]=+h[b+35800>>3];i=i;return}function g_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36120>>3]=+h[b+35808>>3];i=i;return}function h_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36128>>3]=+h[b+35816>>3];i=i;return}function i_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36136>>3]=+h[b+35824>>3];i=i;return}function j_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36144>>3]=+h[b+35832>>3];i=i;return}function k_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36152>>3]=+h[b+35840>>3];i=i;return}function l_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36160>>3]=+h[b+35848>>3];i=i;return}function m_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36168>>3]=+h[b+35856>>3];i=i;return}function n_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36176>>3]=+h[b+36104>>3];i=i;return}function o_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36184>>3]=+h[b+36112>>3];i=i;return}function p_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36192>>3]=+h[b+36120>>3];i=i;return}function q_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47272>>3]=+h[b+38704>>3];i=i;return}function r_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+36392>>3]=l;i=b;return}function s_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+36400>>3]=l;i=b;return}function t_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+36408>>3]=l;i=b;return}function u_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+36416>>3]=l;i=b;return}function v_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47280>>3]=+h[b+47272>>3]/3.0;i=i;return}function w_b(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+536|0]=a[d+524|0]|0;i=i;return}function x_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36424>>3]=+h[b+35744>>3];i=i;return}function y_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36432>>3]=+h[b+35752>>3];i=i;return}function z_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36440>>3]=+h[b+35760>>3];i=i;return}function A_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36448>>3]=+h[b+35768>>3];i=i;return}function B_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36456>>3]=+h[b+35776>>3];i=i;return}function C_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36464>>3]=+h[b+35784>>3];i=i;return}function D_b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47168>>3];j=+h[f+47136>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7456,7448,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47288>>3]=l;i=d;return}function E_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47296>>3]=+h[b+47152>>3];i=i;return}function F_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47304>>3]=+h[b+47168>>3];i=i;return}function G_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47312>>3]=+h[b+47168>>3];i=i;return}function H_b(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+488>>2]=c[b+484>>2];i=i;return}function I_b(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+537|0]=a[d+463|0]|0;i=i;return}function J_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36520>>3]=+h[b+46240>>3]- +h[b+46256>>3];i=i;return}function K_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36880>>3]=+h[b+36568>>3];i=i;return}function L_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36888>>3]=+h[b+36576>>3];i=i;return}function M_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36896>>3]=+h[b+36584>>3];i=i;return}function N_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36904>>3]=+h[b+36592>>3];i=i;return}function O_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36912>>3]=+h[b+36600>>3];i=i;return}function P_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36920>>3]=+h[b+36608>>3];i=i;return}function Q_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36928>>3]=+h[b+36616>>3];i=i;return}function R_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36936>>3]=+h[b+36624>>3];i=i;return}function S_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36944>>3]=+h[b+36632>>3];i=i;return}function T_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36952>>3]=+h[b+36880>>3];i=i;return}function U_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36960>>3]=+h[b+36888>>3];i=i;return}function V_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+36968>>3]=+h[b+36896>>3];i=i;return}function W_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47456>>3]=+h[b+38704>>3];i=i;return}function X_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+37168>>3]=l;i=b;return}function Y_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+37176>>3]=l;i=b;return}function Z_b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+37184>>3]=l;i=b;return}function __b(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=6528;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=6544;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+37192>>3]=l;i=b;return}function $_b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47464>>3]=+h[b+47456>>3]/3.0;i=i;return}function a$b(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+549|0]=a[d+537|0]|0;i=i;return}function b$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37200>>3]=+h[b+36520>>3];i=i;return}function c$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11080>>3]=+h[b+11360>>3]+ +h[(c[a+416>>2]|0)+37200>>3];i=i;return}function d$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11056>>3]=+h[b+11080>>3]+ +h[(c[a+416>>2]|0)+35232>>3];i=i;return}function e$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11032>>3]=+h[b+11056>>3]+ +h[(c[a+416>>2]|0)+36424>>3];i=i;return}function f$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10704>>3]=+h[b+11032>>3]+ +h[(c[a+416>>2]|0)+34432>>3];i=i;return}function g$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10680>>3]=+h[b+10704>>3]+ +h[(c[a+416>>2]|0)+38160>>3];i=i;return}function h$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37208>>3]=+h[b+36528>>3];i=i;return}function i$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37216>>3]=+h[b+36536>>3];i=i;return}function j$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37224>>3]=+h[b+36544>>3];i=i;return}function k$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37232>>3]=+h[b+36552>>3];i=i;return}function l$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37240>>3]=+h[b+36560>>3];i=i;return}function m$b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47352>>3];j=+h[f+47320>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7496,7488,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47472>>3]=l;i=d;return}function n$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47480>>3]=+h[b+47336>>3];i=i;return}function o$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47488>>3]=+h[b+47352>>3];i=i;return}function p$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47496>>3]=+h[b+47352>>3];i=i;return}function q$b(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+496>>2]=c[b+492>>2];i=i;return}function r$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37296>>3]=+h[b+46256>>3]*.5;i=i;return}function s$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11008>>3]=+h[b+11056>>3]+ +h[(c[a+416>>2]|0)+37296>>3];i=i;return}function t$b(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+37296>>3]- +h[b+37320>>3];e=+h[b+37304>>3]- +h[b+37328>>3];f=+h[b+37312>>3]- +h[b+37336>>3];h[b+47512>>3]=+V(+(d*d+e*e+f*f));i=i;return}function u$b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47512>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47520>>3]=l;i=d;return}function v$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47528>>3]=+h[b+47520>>3];i=i;return}function w$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+37392>>3]=+h[b+46240>>3]+ +h[b+46256>>3]*-.5;i=i;return}function x$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14592>>3]=+h[b+14616>>3]+ +h[(c[a+416>>2]|0)+37392>>3];i=i;return}function y$b(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14568>>3]=+h[b+14592>>3]+ +h[(c[a+416>>2]|0)+32376>>3];i=i;return}function z$b(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+37392>>3]- +h[b+37512>>3];e=+h[b+37400>>3]- +h[b+37520>>3];f=+h[b+37408>>3]- +h[b+37528>>3];h[b+47552>>3]=+V(+(d*d+e*e+f*f));i=i;return}function A$b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47552>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7536,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47560>>3]=l;i=d;return}function B$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47568>>3]=+h[b+47560>>3];i=i;return}function C$b(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+37776>>3]- +h[b+37896>>3];e=+h[b+37784>>3]- +h[b+37904>>3];f=+h[b+37792>>3]- +h[b+37912>>3];h[b+47592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function D$b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47600>>3]=l;i=d;return}function E$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47608>>3]=+h[b+47600>>3];i=i;return}function F$b(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+38160>>3]- +h[b+38280>>3];e=+h[b+38168>>3]- +h[b+38288>>3];f=+h[b+38176>>3]- +h[b+38296>>3];h[b+47632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function G$b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+47632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6488,7552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47640>>3]=l;i=d;return}function H$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47648>>3]=+h[b+47640>>3];i=i;return}function I$b(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+47656>>3]=+h[b+46776>>3];i=i;return}function J$b(b){b=b|0;h[(c[b+416>>2]|0)+47736>>3]=(a[(c[b+424>>2]|0)+556|0]|0)!=0?.6435942529055827:1.0;i=i;return}function K$b(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47736>>3];j=+h[f+47720>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,7568,7560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+47744>>3]=l*6.283185307179586;i=d;return}function L$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7584]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2092>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2092>>2]|0),4.0)|0)<<24>>24==0)){i=d;return}b=gCc(7600,eCc(c[(c[g>>2]|0)+2092>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=7864;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[7584]=1;i=d;return}function M$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[7888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47712>>3],1.0e-15)|0)<<24>>24==0)){i=d;return}b=gCc(7904,cCc(+h[(c[g>>2]|0)+47712>>3],7896)|0)|0;g=c[85376]|0;j=e;k=8080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[7888]=1;i=d;return}function N$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8104]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2084>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2084>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(8112,eCc(c[(c[g>>2]|0)+2084>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=8264;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[8104]=1;i=d;return}function O$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(8296,cCc(+h[(c[g>>2]|0)+47696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=8368;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8288]=1;i=d;return}function P$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8392]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(8400,cCc(+h[(c[g>>2]|0)+47664>>3],7896)|0)|0;g=c[85376]|0;j=e;k=176904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8392]=1;i=d;return}function Q$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8608]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(8616,cCc(+h[(c[g>>2]|0)+47648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8608]=1;i=d;return}function R$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(8832,cCc(+h[(c[g>>2]|0)+47640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[8824]=1;i=d;return}function S$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[8944]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1940>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1940>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(8952,eCc(c[(c[g>>2]|0)+1940>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[8944]=1;i=d;return}function T$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9120]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1936>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1936>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(9128,eCc(c[(c[g>>2]|0)+1936>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9120]=1;i=d;return}function U$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9296]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1932>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1932>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(9304,eCc(c[(c[g>>2]|0)+1932>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9296]=1;i=d;return}function V$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2080>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2080>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(9480,eCc(c[(c[g>>2]|0)+2080>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[9472]=1;i=d;return}function W$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(9792,cCc(+h[(c[g>>2]|0)+47608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9784]=1;i=d;return}function X$b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[9912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(9920,cCc(+h[(c[g>>2]|0)+47600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[9912]=1;i=d;return}function Y$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10032]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1928>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1928>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(10040,eCc(c[(c[g>>2]|0)+1928>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10032]=1;i=d;return}function Z$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10208]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1924>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1924>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(10216,eCc(c[(c[g>>2]|0)+1924>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10208]=1;i=d;return}function _$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10384]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1920>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1920>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(10392,eCc(c[(c[g>>2]|0)+1920>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10384]=1;i=d;return}function $$b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10560]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2076>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2076>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(10568,eCc(c[(c[g>>2]|0)+2076>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[10560]=1;i=d;return}function a0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[10872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(10880,cCc(+h[(c[g>>2]|0)+47568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[10872]=1;i=d;return}function b0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(11024,cCc(+h[(c[g>>2]|0)+47560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[11016]=1;i=d;return}function c0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11152]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1916>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1916>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(11160,eCc(c[(c[g>>2]|0)+1916>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11152]=1;i=d;return}function d0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11352]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1912>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1912>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(11360,eCc(c[(c[g>>2]|0)+1912>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11352]=1;i=d;return}function e0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11552]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1908>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1908>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(11560,eCc(c[(c[g>>2]|0)+1908>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11552]=1;i=d;return}function f0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[11752]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2072>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2072>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(11760,eCc(c[(c[g>>2]|0)+2072>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[11752]=1;i=d;return}function g0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12088]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(12096,cCc(+h[(c[g>>2]|0)+47528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12088]=1;i=d;return}function h0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(12208,cCc(+h[(c[g>>2]|0)+47520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12200]=1;i=d;return}function i0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12304]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(12312,cCc(+h[(c[g>>2]|0)+47496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12304]=1;i=d;return}function j0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(12464,cCc(+h[(c[g>>2]|0)+47488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12456]=1;i=d;return}function k0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(12608,cCc(+h[(c[g>>2]|0)+47464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12600]=1;i=d;return}function l0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(12752,cCc(+h[(c[g>>2]|0)+47456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[12744]=1;i=d;return}function m0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[12888]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1904>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1904>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(12896,eCc(c[(c[g>>2]|0)+1904>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[12888]=1;i=d;return}function n0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13104]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1900>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1900>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(13112,eCc(c[(c[g>>2]|0)+1900>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13104]=1;i=d;return}function o0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13320]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1896>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1896>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(13328,eCc(c[(c[g>>2]|0)+1896>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13320]=1;i=d;return}function p0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13536]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1892>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1892>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(13544,eCc(c[(c[g>>2]|0)+1892>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13536]=1;i=d;return}function q0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13728]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1888>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1888>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(13736,eCc(c[(c[g>>2]|0)+1888>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13728]=1;i=d;return}function r0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[13920]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1884>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1884>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(13928,eCc(c[(c[g>>2]|0)+1884>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[13920]=1;i=d;return}function s0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14112]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47448>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(14120,cCc(+h[(c[g>>2]|0)+47448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14112]=1;i=d;return}function t0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14256]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47440>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(14264,cCc(+h[(c[g>>2]|0)+47440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14256]=1;i=d;return}function u0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47432>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(14408,cCc(+h[(c[g>>2]|0)+47432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14400]=1;i=d;return}function v0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(14552,cCc(+h[(c[g>>2]|0)+47424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14544]=1;i=d;return}function w0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(14672,cCc(+h[(c[g>>2]|0)+47416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14664]=1;i=d;return}function x0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(14792,cCc(+h[(c[g>>2]|0)+47408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14784]=1;i=d;return}function y0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[14904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(14912,cCc(+h[(c[g>>2]|0)+47400>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[14904]=1;i=d;return}function z0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(15024,cCc(+h[(c[g>>2]|0)+47392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15016]=1;i=d;return}function A0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15120]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(15128,cCc(+h[(c[g>>2]|0)+47376>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15120]=1;i=d;return}function B0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(15232,cCc(+h[(c[g>>2]|0)+47368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15224]=1;i=d;return}function C0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15336]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(15344,cCc(+h[(c[g>>2]|0)+47360>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15336]=1;i=d;return}function D0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15440]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(15448,cCc(+h[(c[g>>2]|0)+47352>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15440]=1;i=d;return}function E0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(15568,cCc(+h[(c[g>>2]|0)+47344>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[15560]=1;i=d;return}function F0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15688]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1880>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1880>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(15696,eCc(c[(c[g>>2]|0)+1880>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15688]=1;i=d;return}function G0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[15888]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1876>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1876>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(15896,eCc(c[(c[g>>2]|0)+1876>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[15888]=1;i=d;return}function H0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16088]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1872>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1872>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(16096,eCc(c[(c[g>>2]|0)+1872>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16088]=1;i=d;return}function I0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16288]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1868>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1868>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(16296,eCc(c[(c[g>>2]|0)+1868>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16288]=1;i=d;return}function J0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16464]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1864>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1864>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(16472,eCc(c[(c[g>>2]|0)+1864>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16464]=1;i=d;return}function K0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16640]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1860>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1860>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(16648,eCc(c[(c[g>>2]|0)+1860>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[16640]=1;i=d;return}function L0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16816]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(16824,cCc(+h[(c[g>>2]|0)+47328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16816]=1;i=d;return}function M0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[16936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(16944,cCc(+h[(c[g>>2]|0)+47320>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[16936]=1;i=d;return}function N0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17064]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(17072,cCc(+h[(c[g>>2]|0)+47312>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17064]=1;i=d;return}function O0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(17224,cCc(+h[(c[g>>2]|0)+47304>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17216]=1;i=d;return}function P0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17360]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(17368,cCc(+h[(c[g>>2]|0)+47280>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17360]=1;i=d;return}function Q0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17504]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(17512,cCc(+h[(c[g>>2]|0)+47272>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[17504]=1;i=d;return}function R0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17648]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1856>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1856>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(17656,eCc(c[(c[g>>2]|0)+1856>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17648]=1;i=d;return}function S0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[17864]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1852>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1852>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(17872,eCc(c[(c[g>>2]|0)+1852>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[17864]=1;i=d;return}function T0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18080]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1848>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1848>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(18088,eCc(c[(c[g>>2]|0)+1848>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18080]=1;i=d;return}function U0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18296]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1844>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1844>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(18304,eCc(c[(c[g>>2]|0)+1844>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18296]=1;i=d;return}



function u3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0;g=i;h=a;a=c[h>>2]|0;j=(a|0)>-1;if((d|0)==0){if(!j){k=0;i=g;return k|0}l=b;m=a;a=h;while(1){a:do{if((c[l>>2]|0)>-1){n=b;o=m;while(1){p=e+(o<<2)|0;c[p>>2]=(c[p>>2]|0)+1;p=n+32|0;if(!((c[p>>2]|0)>-1)){break a}o=c[a>>2]|0;n=p}}}while(0);n=a+32|0;o=c[n>>2]|0;if((o|0)>-1){m=o;a=n}else{k=0;break}}i=g;return k|0}if(!j){k=0;i=g;return k|0}j=b;a=h;b:while(1){h=c[j>>2]|0;c:do{if((h|0)>-1){m=a+4|0;e=a+8|0;l=a+16|0;n=a+20|0;o=a+24|0;p=a+28|0;q=a+12|0;r=b;s=h;t=j;u=-1;while(1){v=r;w=s;x=t;while(1){y=v+32|0;if((w|0)!=(u|0)){break}z=y;A=c[z>>2]|0;if((A|0)>-1){w=A;x=z;v=y}else{break c}}z=d+(c[f+(c[a>>2]<<2)>>2]<<5)|0;while(1){B=z+8|0;if((c[B>>2]|0)==0){break}else{z=z+32|0}}c[z+40>>2]=0;c[z>>2]=c[m>>2];c[z+4>>2]=c[e>>2];A=c[x>>2]|0;c[B>>2]=d+(c[f+(A<<2)>>2]<<5);c[z+12>>2]=A;A=c[n>>2]|0;C=c[o>>2]|0;D=c[v+16>>2]|c[l>>2]|((A|0)!=0?4:0)|((C|0)!=0?8:0);E=z+20|0;c[E>>2]=D;F=c[p>>2]|0;G=z+24|0;if((F|0)>-1){c[G>>2]=F;c[E>>2]=D|256}else{c[G>>2]=A}if((C|0)==0){c[z+28>>2]=0}else{A=0;while(1){H=A+1|0;if((c[C+(A<<2)>>2]|0)==0){break}else{A=H}}A=h4c(H<<2)|0;C=A;c[z+28>>2]=C;if((A|0)==0){k=12;I=49;break b}x=c[o>>2]|0;G=c[x>>2]|0;if((G|0)==0){J=C}else{D=C;C=G;G=0;while(1){c[D>>2]=C;E=G+1|0;F=c[x+(E<<2)>>2]|0;K=A+(E<<2)|0;if((F|0)==0){J=K;break}else{G=E;C=F;D=K}}}c[J>>2]=0}D=c[q>>2]|0;if((D|0)==0){L=0}else{C=0;while(1){if((c[D+(C<<2)>>2]|0)>-1){C=C+1|0}else{L=C;break}}}C=v+12|0;D=c[C>>2]|0;if((D|0)==0){M=0}else{G=0;while(1){if((c[D+(G<<2)>>2]|0)>-1){G=G+1|0}else{M=G;break}}}G=z+16|0;D=c[G>>2]|0;if((D|0)!=0){i4c(D)}c[G>>2]=0;D=M+L|0;if((D|0)>0){v=h4c((D<<2)+4|0)|0;c[G>>2]=v;if((v|0)==0){k=12;I=49;break b}G=c[q>>2]|0;do{if((G|0)==0){N=0}else{D=c[G>>2]|0;if((D|0)>-1){O=D;P=0}else{N=0;break}while(1){c[v+(P<<2)>>2]=O;D=P+1|0;A=c[G+(D<<2)>>2]|0;if((A|0)>-1){P=D;O=A}else{N=D;break}}}}while(0);G=c[C>>2]|0;do{if((G|0)==0){Q=N}else{z=c[G>>2]|0;if(!((z|0)>-1)){Q=N;break}D=(N|0)>0;A=z;z=0;x=N;while(1){d:do{if(D){K=0;while(1){F=K+1|0;if((c[v+(K<<2)>>2]|0)==(A|0)){R=x;break d}if((F|0)<(N|0)){K=F}else{I=40;break}}}else{I=40}}while(0);if((I|0)==40){I=0;c[v+(x<<2)>>2]=A;R=x+1|0}K=z+1|0;F=c[G+(K<<2)>>2]|0;if((F|0)>-1){A=F;z=K;x=R}else{Q=R;break}}}}while(0);c[v+(Q<<2)>>2]=-1}G=y;C=c[G>>2]|0;if((C|0)>-1){r=y;s=C;t=G;u=w}else{break}}}}while(0);h=a+32|0;if((c[h>>2]|0)>-1){a=h}else{k=0;I=49;break}}if((I|0)==49){i=g;return k|0}return 0}function v3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0;g=i;h=(e|0)==0;a:do{if(h){j=0}else{k=0;while(1){if(!((c[e+(k<<2)>>2]|0)>-1)){j=k;break a}k=k+1|0}}}while(0);k=0;while(1){if((c[b+(k<<5)>>2]|0)>-1){k=k+1|0}else{l=0;break}}while(1){if((c[d+(l<<5)>>2]|0)>-1){l=l+1|0}else{break}}m=H3c(a,0,0,1,(l+k<<5)+32|0)|0;k=m;if((m|0)==0){n=0;i=g;return n|0}l=c[b>>2]|0;b:do{if((l|0)>-1){o=(j|0)>0;p=l;q=0;while(1){c[m+(q<<5)>>2]=p;c[m+(q<<5)+4>>2]=c[b+(q<<5)+4>>2];c[m+(q<<5)+8>>2]=c[b+(q<<5)+8>>2];c[m+(q<<5)+16>>2]=c[b+(q<<5)+16>>2]|f;c[m+(q<<5)+20>>2]=c[b+(q<<5)+20>>2];c[m+(q<<5)+24>>2]=c[b+(q<<5)+24>>2];c[m+(q<<5)+28>>2]=c[b+(q<<5)+28>>2];r=b+(q<<5)+12|0;s=c[r>>2]|0;t=(s|0)==0;if(t&h){c[m+(q<<5)+12>>2]=0}else{c:do{if(t){u=0}else{v=0;while(1){if(!((c[s+(v<<2)>>2]|0)>-1)){u=v;break c}v=v+1|0}}}while(0);s=H3c(a,0,0,0,(u+j<<2)+4|0)|0;t=s;if((s|0)==0){n=0;break}if((u|0)>0){v=c[r>>2]|0;w=0;while(1){c[s+(w<<2)>>2]=c[v+(w<<2)>>2];x=w+1|0;if((x|0)<(u|0)){w=x}else{y=u;break}}}else{y=0}if(o){w=0;while(1){c[s+(w+y<<2)>>2]=c[e+(w<<2)>>2];v=w+1|0;if((v|0)<(j|0)){w=v}else{z=j;break}}}else{z=0}c[s+(z+y<<2)>>2]=-1;c[m+(q<<5)+12>>2]=t}w=q+1|0;v=c[b+(w<<5)>>2]|0;if((v|0)>-1){p=v;q=w}else{A=w;break b}}i=g;return n|0}else{A=0}}while(0);b=c[d>>2]|0;y=m+(A<<5)|0;d:do{if((b|0)>-1){z=y;j=A;e=b;u=0;while(1){c[z>>2]=e;c[m+(j<<5)+4>>2]=c[d+(u<<5)+4>>2];c[m+(j<<5)+8>>2]=c[d+(u<<5)+8>>2];c[m+(j<<5)+16>>2]=c[d+(u<<5)+16>>2];c[m+(j<<5)+20>>2]=c[d+(u<<5)+20>>2];c[m+(j<<5)+24>>2]=c[d+(u<<5)+24>>2];c[m+(j<<5)+28>>2]=c[d+(u<<5)+28>>2];h=d+(u<<5)+12|0;f=c[h>>2]|0;if((f|0)==0){c[m+(j<<5)+12>>2]=0}else{l=0;while(1){if((c[f+(l<<2)>>2]|0)>-1){l=l+1|0}else{break}}f=H3c(a,0,0,0,(l<<2)+4|0)|0;t=f;if((f|0)==0){n=0;break}if((l|0)>0){s=c[h>>2]|0;q=0;while(1){c[f+(q<<2)>>2]=c[s+(q<<2)>>2];p=q+1|0;if((p|0)<(l|0)){q=p}else{B=l;break}}}else{B=0}c[f+(B<<2)>>2]=-1;c[m+(j<<5)+12>>2]=t}l=u+1|0;q=c[d+(l<<5)>>2]|0;s=l+A|0;h=m+(s<<5)|0;if((q|0)>-1){z=h;j=s;e=q;u=l}else{C=h;break d}}i=g;return n|0}else{C=y}}while(0);c[C>>2]=-1;n=k;i=g;return n|0}function w3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;g=i;h=a+12|0;j=c[h>>2]|0;k=(f|0)!=0;if(k){c[f>>2]=0}l=x3c(a,b)|0;if((l|0)!=0){m=l;i=g;return m|0}l=a+16|0;b=(d|0)==0;n=(e|0)==0;a:while(1){o=c[h>>2]|0;if((o|0)<=(j|0)){m=0;p=28;break}q=o+ -1|0;c[h>>2]=q;o=c[(c[l>>2]|0)+(q<<2)>>2]|0;q=c[o>>2]|0;do{if((q|0)==0){r=c[o+4>>2]|0;s=c[r>>2]|0;if((s|0)==-2){if(n){continue a}c[e>>2]=c[e>>2]|c[r+4>>2];continue a}else if(!((s|0)==-3)){continue a}s=c[r+4>>2]|0;if(!((s|0)>-1)){continue a}b:do{if(!b){r=c[d>>2]|0;c:do{if((r|0)>-1){t=r;u=d;v=0;while(1){w=v+1|0;if((t|0)==(s|0)){break}x=d+(w<<2)|0;y=c[x>>2]|0;if((y|0)>-1){t=y;u=x;v=w}else{z=x;A=w;break c}}if((s|0)<0){z=u;A=v}else{break b}}else{z=d;A=0}}while(0);c[z>>2]=s;c[d+(A+1<<2)>>2]=-1}}while(0);if(!k){continue a}c[f>>2]=(c[f>>2]|0)+1;continue a}else if((q|0)==1){s=c[o+4>>2]|0;r=x3c(a,c[s>>2]|0)|0;if((r|0)!=0){m=r;p=28;break a}B=x3c(a,c[s+4>>2]|0)|0}else if((q|0)==3){s=c[o+4>>2]|0;r=c[s>>2]|0;if((c[r+8>>2]|0)!=0){B=x3c(a,r)|0;break}r=c[s+4>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=x3c(a,r)|0}else if((q|0)==2){r=c[c[o+4>>2]>>2]|0;if((c[r+8>>2]|0)==0){continue a}B=x3c(a,r)|0}else{continue a}}while(0);if((B|0)!=0){m=B;p=28;break}}if((p|0)==28){i=g;return m|0}return 0}function x3c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=a+12|0;f=c[e>>2]|0;g=a;h=c[g>>2]|0;if((f|0)<(h|0)){c[(c[a+16>>2]|0)+(f<<2)>>2]=b;c[e>>2]=(c[e>>2]|0)+1;j=0;i=d;return j|0}e=c[a+4>>2]|0;if((h|0)>=(e|0)){j=12;i=d;return j|0}f=(c[a+8>>2]|0)+h|0;h=(f|0)>(e|0)?e:f;f=a+16|0;e=k4c(c[f>>2]|0,h<<2)|0;if((e|0)==0){j=12;i=d;return j|0}else{c[g>>2]=h;c[f>>2]=e;x3c(a,b)|0;i=d;return 0}return 0}function y3c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;l=i;m=d+12|0;n=c[m>>2]|0;x3c(d,e)|0;e=x3c(d,0)|0;a:do{if((e|0)==0){o=d+16|0;p=(f&1|0)==0;q=(f&2|0)==0;r=1;s=0;t=j;b:while(1){u=c[m>>2]|0;if((u|0)<=(n|0)){v=s;w=0;break a}x=u+ -1|0;c[m>>2]=x;y=c[o>>2]|0;z=c[y+(x<<2)>>2]|0;if((z|0)==1){x=u+ -2|0;c[m>>2]=x;A=s;B=r;t=c[y+(x<<2)>>2]|0;s=A;r=B;continue}else if((z|0)!=0){C=t;A=s;B=r;t=C;s=A;r=B;continue}z=u+ -2|0;c[m>>2]=z;u=c[y+(z<<2)>>2]|0;z=c[u>>2]|0;do{if((z|0)==3){y=c[u+4>>2]|0;x=c[y>>2]|0;D=y+4|0;E=c[D>>2]|0;F=H3c(b,0,0,1,32)|0;if((F|0)==0){G=20;break b}H=H3c(b,0,0,1,8)|0;I=F+4|0;c[I>>2]=H;if((H|0)==0){G=20;break b}c[F>>2]=3;c[F+8>>2]=-1;c[F+12>>2]=-1;c[H>>2]=x;c[(c[I>>2]|0)+4>>2]=E;c[F+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);c[t>>2]=F;F=c[I>>2]|0;I=x3c(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,F+4|0)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=F;M=x3c(d,0)|0}else if((z|0)==0){F=c[u+4>>2]|0;I=c[F+8>>2]|0;y=c[F>>2]|0;D=c[F+4>>2]|0;do{if((y|0)>-1|(y|0)==-4){N=r;O=D;P=y;Q=s+1|0;R=(c[g>>2]|0)+I|0}else{if(!((y|0)==-3)){N=r;O=D;P=y;Q=s;R=I;break}if(!p){N=r;O=-1;P=-1;Q=s;R=-1;break}if(q|(r|0)==0){N=r;O=D;P=-3;Q=s;R=I;break}c[h+(D<<2)>>2]=1;N=0;O=D;P=-3;Q=s;R=I}}while(0);I=H3c(b,0,0,1,32)|0;D=I;do{if((I|0)==0){S=0}else{y=H3c(b,0,0,1,20)|0;c[I+4>>2]=y;if((y|0)==0){S=0;break}c[I>>2]=0;c[I+8>>2]=-1;c[I+12>>2]=-1;c[y>>2]=P;c[y+4>>2]=O;c[y+8>>2]=R;S=D}}while(0);c[t>>2]=S;D=(S|0)==0?12:0;if((R|0)<=(c[k>>2]|0)){J=N;K=Q;L=t;M=D;break}c[k>>2]=R;J=N;K=Q;L=t;M=D}else if((z|0)==1){D=c[u+4>>2]|0;I=c[D>>2]|0;y=D+4|0;F=c[y>>2]|0;x=H3c(b,0,0,1,32)|0;if((x|0)==0){G=29;break b}E=H3c(b,0,0,1,8)|0;H=x+4|0;c[H>>2]=E;if((E|0)==0){G=29;break b}c[x>>2]=1;c[x+8>>2]=-1;c[x+12>>2]=-1;c[E>>2]=I;c[(c[H>>2]|0)+4>>2]=F;c[x+16>>2]=(c[F+16>>2]|0)+(c[I+16>>2]|0);c[t>>2]=x;x=c[H>>2]|0;c[x>>2]=0;H=x+4|0;c[H>>2]=0;I=x3c(d,c[y>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,H)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,1)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,c[D>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}J=r;K=s;L=x;M=x3c(d,0)|0}else if((z|0)==2){x=c[u+4>>2]|0;I=x3c(d,c[x>>2]|0)|0;if((I|0)!=0){v=s;w=I;break a}I=x3c(d,0)|0;if((I|0)!=0){v=s;w=I;break a}I=c[x>>2]|0;D=c[x+4>>2]|0;H=c[x+8>>2]|0;y=a[x+12|0]|0;x=H3c(b,0,0,1,32)|0;if((x|0)==0){G=40;break b}F=H3c(b,0,0,1,16)|0;E=x+4|0;c[E>>2]=F;if((F|0)==0){G=40;break b}c[x>>2]=2;c[x+8>>2]=-1;c[x+12>>2]=-1;c[F>>2]=I;c[F+4>>2]=D;c[F+8>>2]=H;H=F+12|0;a[H]=a[H]&-2|y&1;c[x+16>>2]=c[I+16>>2];c[t>>2]=x;A=s;B=r;t=c[E>>2]|0;s=A;r=B;continue b}else{C=t;A=s;B=r;t=C;s=A;r=B;continue b}}while(0);if((M|0)==0){r=J;s=K;t=L}else{v=K;w=M;break a}}if((G|0)==20){c[t>>2]=0;v=s;w=12;break}else if((G|0)==29){c[t>>2]=0;v=s;w=12;break}else if((G|0)==40){c[t>>2]=0;v=s;w=12;break}}else{v=0;w=e}}while(0);c[g>>2]=(c[g>>2]|0)+v;i=l;return w|0}function z3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=H3c(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=H3c(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=H3c(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f>>2]=j;k=H3c(a,0,0,0,32)|0;l=f+4|0;c[l>>2]=k;if((k|0)==0){g=12;i=e;return g|0}m=b+4|0;c[k+4>>2]=c[m>>2];k=b;c[c[l>>2]>>2]=c[k>>2];n=c[l>>2]|0;c[n+8>>2]=-1;c[n+12>>2]=-1;c[n+24>>2]=0;c[(c[l>>2]|0)+28>>2]=0;c[(c[l>>2]|0)+20>>2]=0;c[m>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f>>2]=0;g=12;i=e;return g|0}function A3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;f=H3c(a,0,0,0,8)|0;if((f|0)==0){g=12;i=e;return g|0}h=H3c(a,0,0,1,32)|0;j=h;do{if((h|0)!=0){k=H3c(a,0,0,1,20)|0;c[h+4>>2]=k;if((k|0)==0){break}c[h>>2]=0;c[h+8>>2]=-1;c[h+12>>2]=-1;c[k>>2]=-3;c[k+4>>2]=d;c[k+8>>2]=-1;c[f+4>>2]=j;k=H3c(a,0,0,0,32)|0;c[f>>2]=k;if((k|0)==0){g=12;i=e;return g|0}l=b+4|0;c[k+4>>2]=c[l>>2];k=b;c[c[f>>2]>>2]=c[k>>2];m=c[f>>2]|0;c[m+8>>2]=-1;c[m+12>>2]=-1;c[m+24>>2]=0;c[(c[f>>2]|0)+28>>2]=0;c[(c[f>>2]|0)+20>>2]=0;c[l>>2]=f;c[k>>2]=1;g=0;i=e;return g|0}}while(0);c[f+4>>2]=0;g=12;i=e;return g|0}function B3c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[c[(c[a>>2]|0)+4>>2]>>2]|0;a=c[c[(c[b>>2]|0)+4>>2]>>2]|0;if((e|0)<(a|0)){f=-1;i=d;return f|0}f=(e|0)>(a|0)|0;i=d;return f|0}function C3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;g=d;a:do{if((b|0)==0){h=381544}else{j=b;k=381544;while(1){if((a[k]|0)==0){h=k;break a}l=j+ -1|0;m=k+((L4c(k|0)|0)+1)|0;if((l|0)==0){h=m;break}else{j=l;k=m}}}}while(0);c[g>>2]=(a[h]|0)==0?h+1|0:h;h=(Mc(e|0,f|0,381832,g|0)|0)+1|0;i=d;return h|0}function D3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0;g=i;i=i+16|0;h=g;j=g+8|0;k=c[a+4>>2]|0;a=k;l=k+40|0;m=c[l>>2]|0;do{if((m|0)<1|(d|0)==0){n=0}else{o=h4c(m<<2)|0;if((o|0)==0){p=12}else{n=o;break}i=g;return p|0}}while(0);m=n;a:do{if((c[k+60>>2]|0)==0){c[h>>2]=0;o=f&1;q=f&2;r=k+56|0;s=c[r>>2]&4;if((n|0)==0){t=0}else{t=c[l>>2]|0}u=t<<2;v=c[k+52>>2]|0;w=v<<3;x=w+8|0;y=u+12+w+(x+(fa(u,v)|0)<<1)|0;z=h4c(y)|0;if((z|0)==0){A=12;break}P4c(z|0,0,y|0)|0;y=z;B=z+u&3;C=((B|0)==0?0:4-B|0)+u|0;B=z+C|0;D=B;E=C+x|0;C=z+E&3;F=((C|0)==0?0:4-C|0)+E|0;E=z+F|0;C=E;G=F+x|0;x=z+G&3;F=((x|0)==0?0:4-x|0)+G|0;G=z+F|0;x=F+w|0;w=z+x&3;if((v|0)>0){F=t<<3;H=0;I=z+(((w|0)==0?0:4-w|0)+x)|0;while(1){c[E+(H<<3)+4>>2]=I;c[B+(H<<3)+4>>2]=I+u;x=H+1|0;if((x|0)<(v|0)){I=I+F|0;H=x}else{J=0;break}}do{c[G+(J<<3)>>2]=-1;J=J+1|0;}while((J|0)<(v|0))}v=l3c(h,b,4)|0;if((v|0)<1){if((v|0)<0){A=1;break}K=v+1|0}else{K=v}v=k+8|0;H=(s|0)==0;F=(o|0)==0;I=(t|0)>0;B=k+12|0;E=k+44|0;x=k+32|0;w=k+36|0;L=(t|0)==0;M=I^1;N=-1;O=0;P=0;Q=K;R=0;S=C;T=D;U=D;V=b+K|0;W=y;while(1){if((N|0)<0){X=c[v>>2]|0;Y=X+8|0;b:do{if((c[Y>>2]|0)==0){Z=N;_=O;$=U}else{aa=(P|0)==0;ba=(R|0)==95;ca=(P|0)<1&F;da=((R|0)!=10|H)^1;ea=Y;ga=N;ha=O;ia=U;ja=X;while(1){ka=ea;la=ja;c:while(1){ma=la+12|0;if((c[G+(c[ma>>2]<<3)>>2]|0)>=(P|0)){na=ga;oa=ha;pa=ia;break}qa=la+20|0;ra=c[qa>>2]|0;if((ra|0)==0){sa=260;break}d:do{if((ra&1|0)==0|ca|da){if((ra&2|0)!=0){ta=c[h>>2]|0;if((ta|q|0)!=0&((ta|0)!=10|H)){break}}do{if((ra&16|0)!=0){if(ba){break d}if((S2c(R)|0)!=0){break d}ta=c[h>>2]|0;if((ta|0)==95){break}if((S2c(ta)|0)==0){break d}}}while(0);ta=c[qa>>2]|0;if((ta&32|0)==0){ua=ta}else{if(!ba){if((S2c(R)|0)==0){break}}ta=c[h>>2]|0;if((ta|0)==95){break}if((S2c(ta)|0)!=0){break}ua=c[qa>>2]|0}do{if((ua&64|0)==0|aa){va=ua}else{ta=c[h>>2]|0;if((ta|0)==0){va=ua;break}if(ba){wa=ta;xa=1}else{ta=(S2c(R)|0)!=0|0;wa=c[h>>2]|0;xa=ta}if((wa|0)==95){ya=1}else{ya=(S2c(wa)|0)!=0|0}if((xa|0)==(ya|0)){break d}va=c[qa>>2]|0}}while(0);if((va&128|0)==0){sa=260;break c}if(aa){break}ta=c[h>>2]|0;if((ta|0)==0){break}if(ba){za=ta;Aa=1}else{ta=(S2c(R)|0)!=0|0;za=c[h>>2]|0;Aa=ta}if((za|0)==95){Ba=1}else{Ba=(S2c(za)|0)!=0|0}if((Aa|0)==(Ba|0)){sa=260;break c}}}while(0);qa=la+40|0;if((c[qa>>2]|0)==0){Z=ga;_=ha;$=ia;break b}else{ka=qa;la=la+32|0}}if((sa|0)==260){sa=0;qa=ia;c[qa>>2]=c[ka>>2];if(I){P4c(c[ia+4>>2]|0,-1,u|0)|0}ra=c[la+16>>2]|0;do{if((ra|0)!=0){ta=c[ra>>2]|0;if(!((ta|0)>-1)){break}Ca=ia+4|0;Da=ta;ta=ra;do{if((Da|0)<(t|0)){c[(c[Ca>>2]|0)+(Da<<2)>>2]=P}ta=ta+4|0;Da=c[ta>>2]|0;}while((Da|0)>-1)}}while(0);ra=(c[qa>>2]|0)!=(c[B>>2]|0);if(ra|M){Ea=ia+4|0;Fa=ra?ga:P;Ga=ra?ha:1}else{ra=ia+4|0;ka=c[ra>>2]|0;Da=0;while(1){c[n+(Da<<2)>>2]=c[ka+(Da<<2)>>2];ta=Da+1|0;if((ta|0)<(t|0)){Da=ta}else{Ea=ra;Fa=P;Ga=1;break}}}c[G+(c[ma>>2]<<3)>>2]=P;c[G+(c[ma>>2]<<3)+4>>2]=Ea;na=Fa;oa=Ga;pa=ia+8|0}ra=la+40|0;if((c[ra>>2]|0)==0){Z=na;_=oa;$=pa;break}else{ea=ra;ga=na;ha=oa;ia=pa;ja=la+32|0}}}}while(0);c[$>>2]=0;Ha=Z;Ia=_}else{if(L|(U|0)==(T|0)){Ja=N;break}else{Ha=N;Ia=O}}X=c[h>>2]|0;if((X|0)==0){Ja=Ha;break}Y=P+Q|0;ja=l3c(h,V,4)|0;if((ja|0)<1){if((ja|0)<0){A=1;break a}Ka=ja+1|0}else{Ka=ja}ja=V+Ka|0;if((c[E>>2]|0)==0|(Ia|0)==0){La=Ia;Ma=T;Na=S}else{ia=T;ha=c[ia>>2]|0;if((ha|0)==0){Oa=S}else{ga=ha;ha=ia;ia=S;while(1){ea=c[w>>2]|0;ba=c[ea>>2]|0;aa=ha+4|0;e:do{if((ba|0)>-1){da=ba;ca=0;while(1){ra=c[ea+((ca|1)<<2)>>2]|0;if((da|0)>=(t|0)){Pa=ia;break e}Da=c[aa>>2]|0;if((c[Da+(ra<<2)>>2]|0)==(c[n+(ra<<2)>>2]|0)){if((c[Da+(da<<2)>>2]|0)<(c[n+(da<<2)>>2]|0)){Pa=ia;break e}}Da=ca+2|0;ra=c[ea+(Da<<2)>>2]|0;if((ra|0)>-1){da=ra;ca=Da}else{sa=287;break}}}else{sa=287}}while(0);if((sa|0)==287){sa=0;c[ia>>2]=ga;ea=ia+4|0;ba=c[ea>>2]|0;c[ea>>2]=c[aa>>2];c[aa>>2]=ba;Pa=ia+8|0}ba=ha+8|0;ea=c[ba>>2]|0;if((ea|0)==0){Oa=Pa;break}else{ga=ea;ha=ba;ia=Pa}}}c[Oa>>2]=0;La=0;Ma=S;Na=T}ia=c[Ma>>2]|0;if((ia|0)==0){Qa=Ha;Ra=La;Sa=Na;Ta=W}else{ha=(Y|0)==0;ga=(X|0)==95;ba=(Y|0)<1&F;ea=((X|0)!=10|H)^1;ca=ia;ia=Ha;da=La;la=Ma;Da=Na;ra=W;while(1){ka=ca+8|0;if((c[ka>>2]|0)==0){Ua=ia;Va=da;Wa=Da;Xa=ra}else{qa=la+4|0;ta=ka;ka=ia;Ca=da;Ya=Da;Za=ra;_a=ca;while(1){f:do{if((c[_a>>2]|0)>>>0>X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za}else{if((c[_a+4>>2]|0)>>>0<X>>>0){$a=ka;ab=Ca;bb=Ya;cb=Za;break}db=_a+20|0;eb=c[db>>2]|0;g:do{if((eb|0)!=0){if(!((eb&1|0)==0|ba|ea)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((eb&2|0)!=0){fb=c[h>>2]|0;if((fb|q|0)!=0&((fb|0)!=10|H)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}do{if((eb&16|0)!=0){if(ga){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((S2c(X)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==95){break}if((S2c(fb)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);fb=c[db>>2]|0;if((fb&32|0)==0){gb=fb}else{if(!ga){if((S2c(X)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}fb=c[h>>2]|0;if((fb|0)==95){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if((S2c(fb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}gb=c[db>>2]|0}do{if((gb&64|0)==0|ha){hb=gb}else{fb=c[h>>2]|0;if((fb|0)==0){hb=gb;break}if(ga){ib=fb;jb=1}else{fb=(S2c(X)|0)!=0|0;ib=c[h>>2]|0;jb=fb}if((ib|0)==95){kb=1}else{kb=(S2c(ib)|0)!=0|0}if((jb|0)==(kb|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}hb=c[db>>2]|0}}while(0);if((hb&128|0)==0){lb=hb}else{if(ha){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}fb=c[h>>2]|0;if((fb|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}if(ga){mb=fb;nb=1}else{fb=(S2c(X)|0)!=0|0;mb=c[h>>2]|0;nb=fb}if((mb|0)==95){ob=1}else{ob=(S2c(mb)|0)!=0|0}if((nb|0)!=(ob|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}lb=c[db>>2]|0}do{if((lb&4|0)==0){pb=lb}else{if((c[r>>2]&2|0)!=0){pb=lb;break}if((W2c(X,c[_a+24>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}pb=c[db>>2]|0}}while(0);do{if((pb&4|0)!=0){if((c[r>>2]&2|0)==0){break}fb=g3c(X)|0;qb=_a+24|0;if((W2c(fb,c[qb>>2]|0)|0)!=0){break}fb=e3c(X)|0;if((W2c(fb,c[qb>>2]|0)|0)==0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}}while(0);if((c[db>>2]&8|0)==0){break}qb=c[_a+28>>2]|0;fb=c[qb>>2]|0;if((fb|0)==0){break}if((c[r>>2]&2|0)==0){rb=qb;sb=fb;while(1){if((W2c(X,sb)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}rb=rb+4|0;sb=c[rb>>2]|0;if((sb|0)==0){break g}}}else{tb=qb}do{sb=e3c(X)|0;if((W2c(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}sb=g3c(X)|0;if((W2c(sb,c[tb>>2]|0)|0)!=0){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}tb=tb+4|0;}while((c[tb>>2]|0)!=0)}}while(0);if(I){db=c[qa>>2]|0;eb=0;do{c[Za+(eb<<2)>>2]=c[db+(eb<<2)>>2];eb=eb+1|0;}while((eb|0)<(t|0))}eb=c[_a+16>>2]|0;do{if((eb|0)!=0){db=c[eb>>2]|0;if((db|0)>-1){ub=db;vb=eb}else{break}do{if((ub|0)<(t|0)){c[Za+(ub<<2)>>2]=Y}vb=vb+4|0;ub=c[vb>>2]|0;}while((ub|0)>-1)}}while(0);eb=_a+12|0;db=c[eb>>2]|0;qb=G+(db<<3)|0;if((c[qb>>2]|0)<(Y|0)){sb=Ya;c[sb>>2]=c[ta>>2];rb=Ya+4|0;fb=c[rb>>2]|0;c[rb>>2]=Za;c[qb>>2]=Y;c[G+(c[eb>>2]<<3)+4>>2]=rb;do{if((c[sb>>2]|0)==(c[B>>2]|0)){if((ka|0)==-1){if(!I){wb=Y;xb=1;break}yb=c[rb>>2]|0}else{if(!I){wb=ka;xb=Ca;break}eb=c[rb>>2]|0;if((c[eb>>2]|0)>(c[n>>2]|0)){wb=ka;xb=Ca;break}else{yb=eb}}eb=0;while(1){c[n+(eb<<2)>>2]=c[yb+(eb<<2)>>2];qb=eb+1|0;if((qb|0)<(t|0)){eb=qb}else{wb=Y;xb=1;break}}}else{wb=ka;xb=Ca}}while(0);$a=wb;ab=xb;bb=Ya+8|0;cb=fb;break}else{rb=c[x>>2]|0;sb=c[G+(db<<3)+4>>2]|0;eb=c[sb>>2]|0;if(I){zb=0}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break}while(1){qb=c[Za+(zb<<2)>>2]|0;Ab=c[eb+(zb<<2)>>2]|0;if((c[rb+(zb<<2)>>2]|0)==0){if((qb|0)<(Ab|0)){break}if((qb|0)>(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}else{if((qb|0)>(Ab|0)){break}if((qb|0)<(Ab|0)){$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}Ab=zb+1|0;if((Ab|0)<(t|0)){zb=Ab}else{$a=ka;ab=Ca;bb=Ya;cb=Za;break f}}c[sb>>2]=Za;if((c[ta>>2]|0)==(c[B>>2]|0)){Bb=0}else{$a=ka;ab=Ca;bb=Ya;cb=eb;break}while(1){c[n+(Bb<<2)>>2]=c[Za+(Bb<<2)>>2];rb=Bb+1|0;if((rb|0)<(t|0)){Bb=rb}else{$a=Y;ab=1;bb=Ya;cb=eb;break}}}}}while(0);eb=_a+40|0;if((c[eb>>2]|0)==0){Ua=$a;Va=ab;Wa=bb;Xa=cb;break}else{ta=eb;ka=$a;Ca=ab;Ya=bb;Za=cb;_a=_a+32|0}}}_a=la+8|0;Za=c[_a>>2]|0;if((Za|0)==0){Qa=Ua;Ra=Va;Sa=Wa;Ta=Xa;break}else{ca=Za;ia=Ua;da=Va;la=_a;Da=Wa;ra=Xa}}}c[Sa>>2]=0;N=Qa;O=Ra;P=Y;Q=Ka;R=X;S=Ma;T=Na;U=Sa;V=ja;W=Ta}i4c(z);Cb=Ja;Db=Ja>>>31;sa=375}else{c[j>>2]=0;W=f&1;V=f&2;U=k+56|0;T=c[U>>2]&4;S=F3c(0,0)|0;if((S|0)==0){A=12;break}R=H3c(S,0,0,0,32)|0;Q=R;if((R|0)==0){G3c(S);A=12;break}c[R+24>>2]=0;c[R+28>>2]=0;R=c[l>>2]|0;if((R|0)==0){Eb=0;sa=9}else{P=h4c(R<<2)|0;O=P;if((P|0)==0){Fb=0;Gb=0;Hb=12;Ib=0;Jb=O}else{Eb=O;sa=9}}do{if((sa|0)==9){O=Eb;P=c[k+28>>2]|0;if((P|0)==0){Kb=0}else{N=h4c(P<<3)|0;P=N;if((N|0)==0){Fb=0;Gb=P;Hb=12;Ib=0;Jb=Eb;break}else{Kb=P}}P=k+52|0;N=c[P>>2]|0;if((N|0)==0){Lb=0}else{B=h4c(N<<2)|0;N=B;if((B|0)==0){Fb=0;Gb=Kb;Hb=12;Ib=N;Jb=Eb;break}else{Lb=N}}N=Lb;B=(n|0)==0;I=k+8|0;G=k+12|0;x=k+32|0;r=(T|0)==0;H=(W|0)==0;q=R;F=-1;w=1;E=-1;L=Q;M=b;h:while(1){do{if((q|0)>0){if(B){P4c(O|0,-1,q<<2|0)|0;break}else{u=0;do{c[Eb+(u<<2)>>2]=-1;c[n+(u<<2)>>2]=-1;u=u+1|0;}while((u|0)<(c[l>>2]|0))}}}while(0);u=c[P>>2]|0;if((u|0)>0){P4c(N|0,0,u<<2|0)|0}u=c[j>>2]|0;v=w+E|0;y=l3c(j,M,4)|0;if((y|0)<1){if((y|0)<0){A=1;break a}Mb=y+1|0}else{Mb=y}y=M+Mb|0;D=c[j>>2]|0;C=c[I>>2]|0;o=C+8|0;if((c[o>>2]|0)==0){Nb=F;Ob=0;Pb=Mb;Qb=L;sa=196}else{s=(v|0)==0;ra=(u|0)==95;Da=(v|0)<1&H;la=((u|0)!=10|r)^1;da=o;o=0;ia=L;ca=0;ga=C;while(1){C=ga+20|0;ha=c[C>>2]|0;i:do{if((ha|0)==0){sa=56}else{if(!((ha&1|0)==0|Da|la)){Rb=o;Sb=ia;Tb=ca;break}if((ha&2|0)!=0){ea=c[j>>2]|0;if((ea|V|0)!=0&((ea|0)!=10|r)){Rb=o;Sb=ia;Tb=ca;break}}do{if((ha&16|0)!=0){if(ra){Rb=o;Sb=ia;Tb=ca;break i}if((S2c(u)|0)!=0){Rb=o;Sb=ia;Tb=ca;break i}ea=c[j>>2]|0;if((ea|0)==95){break}if((S2c(ea)|0)==0){Rb=o;Sb=ia;Tb=ca;break i}}}while(0);ea=c[C>>2]|0;if((ea&32|0)==0){Ub=ea}else{if(!ra){if((S2c(u)|0)==0){Rb=o;Sb=ia;Tb=ca;break}}ea=c[j>>2]|0;if((ea|0)==95){Rb=o;Sb=ia;Tb=ca;break}if((S2c(ea)|0)!=0){Rb=o;Sb=ia;Tb=ca;break}Ub=c[C>>2]|0}do{if((Ub&64|0)==0|s){Vb=Ub}else{ea=c[j>>2]|0;if((ea|0)==0){Vb=Ub;break}if(ra){Wb=ea;Xb=1}else{ea=(S2c(u)|0)!=0|0;Wb=c[j>>2]|0;Xb=ea}if((Wb|0)==95){Yb=1}else{Yb=(S2c(Wb)|0)!=0|0}if((Xb|0)==(Yb|0)){Rb=o;Sb=ia;Tb=ca;break i}Vb=c[C>>2]|0}}while(0);if((Vb&128|0)==0){sa=56;break}if(s){Rb=o;Sb=ia;Tb=ca;break}ea=c[j>>2]|0;if((ea|0)==0){Rb=o;Sb=ia;Tb=ca;break}if(ra){Zb=ea;_b=1}else{ea=(S2c(u)|0)!=0|0;Zb=c[j>>2]|0;_b=ea}if((Zb|0)==95){$b=1}else{$b=(S2c(Zb)|0)!=0|0}if((_b|0)==($b|0)){sa=56}else{Rb=o;Sb=ia;Tb=ca}}}while(0);do{if((sa|0)==56){sa=0;if((ca|0)==0){Rb=c[ga+16>>2]|0;Sb=ia;Tb=c[da>>2]|0;break}C=ia+28|0;ha=c[C>>2]|0;if((ha|0)==0){ea=H3c(S,0,0,0,32)|0;ba=ea;if((ea|0)==0){sa=60;break h}c[ea+24>>2]=ia;c[ea+28>>2]=0;_a=H3c(S,0,0,0,c[l>>2]<<2)|0;c[ea+20>>2]=_a;if((_a|0)==0){sa=67;break h}c[C>>2]=ba;ac=ba}else{ac=ha}c[ac>>2]=v;c[ac+4>>2]=y;c[ac+8>>2]=c[da>>2];c[ac+12>>2]=c[ga+12>>2];c[ac+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ha=c[ac+20>>2]|0;ba=0;do{c[ha+(ba<<2)>>2]=c[Eb+(ba<<2)>>2];ba=ba+1|0;}while((ba|0)<(c[l>>2]|0))}ba=c[ga+16>>2]|0;if((ba|0)==0){Rb=o;Sb=ac;Tb=ca;break}ha=c[ba>>2]|0;if(!((ha|0)>-1)){Rb=o;Sb=ac;Tb=ca;break}C=c[ac+20>>2]|0;_a=ha;ha=ba;while(1){ba=ha+4|0;c[C+(_a<<2)>>2]=v;ea=c[ba>>2]|0;if((ea|0)>-1){ha=ba;_a=ea}else{Rb=o;Sb=ac;Tb=ca;break}}}}while(0);_a=ga+40|0;if((c[_a>>2]|0)==0){break}else{da=_a;o=Rb;ia=Sb;ca=Tb;ga=ga+32|0}}do{if((Rb|0)==0){bc=0}else{ga=c[Rb>>2]|0;if((ga|0)>-1){cc=ga;dc=Rb}else{bc=Rb;break}while(1){c[Eb+(cc<<2)>>2]=v;ga=dc+4|0;ca=c[ga>>2]|0;if((ca|0)>-1){dc=ga;cc=ca}else{bc=ga;break}}}}while(0);if((Tb|0)==0){Nb=F;Ob=bc;Pb=Mb;Qb=Sb;sa=196}else{ec=F;fc=bc;gc=v;hc=Mb;ic=Sb;jc=Tb;kc=y}}j:while(1){if((sa|0)==196){sa=0;ga=c[Qb+24>>2]|0;if((ga|0)==0){break}ca=c[Qb+8>>2]|0;if((c[ca+20>>2]&256|0)!=0){c[Lb+(c[Qb+12>>2]<<2)>>2]=0}ia=c[Qb>>2]|0;o=c[Qb+4>>2]|0;c[j>>2]=c[Qb+16>>2];da=c[l>>2]|0;if((da|0)<=0){ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue}u=c[Qb+20>>2]|0;ra=0;while(1){c[Eb+(ra<<2)>>2]=c[u+(ra<<2)>>2];s=ra+1|0;if((s|0)<(da|0)){ra=s}else{ec=Nb;fc=Ob;gc=ia;hc=Pb;ic=ga;jc=ca;kc=o;continue j}}}if((jc|0)==(c[G>>2]|0)){lc=fc;mc=gc;nc=hc;oc=ic}else{o=fc;ca=gc;ga=hc;ia=ic;ra=jc;da=kc;while(1){u=ra+8|0;do{if((c[u>>2]|0)==0){sa=109}else{if((c[ra+20>>2]&256|0)==0){sa=109;break}s=c[ra+24>>2]|0;E3c(s+1|0,Kb,c[U>>2]&-9,a,Eb,ca);la=c[Kb+(s<<3)>>2]|0;Da=c[Kb+(s<<3)+4>>2]|0;s=Da-la|0;if((I4c(b+la|0,da+ -1|0,s)|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}_a=(Da|0)==(la|0);la=_a&1;Da=Lb+(c[ra+12>>2]<<2)|0;if(_a){if((c[Da>>2]|0)!=0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}}c[Da>>2]=la;la=s+ -1|0;s=la+ca|0;Da=c[j>>2]|0;_a=l3c(j,da+la|0,4)|0;if((_a|0)<1){if((_a|0)<0){A=1;break a}pc=_a+1|0}else{pc=_a}qc=s;rc=pc+la|0;sc=pc;tc=Da}}while(0);do{if((sa|0)==109){sa=0;Da=c[j>>2]|0;if((Da|0)==0){Nb=ec;Ob=o;Pb=ga;Qb=ia;sa=196;continue j}la=l3c(j,da,4)|0;if((la|0)>=1){qc=ca;rc=la;sc=la;tc=Da;break}if((la|0)<0){A=1;break a}s=la+1|0;qc=ca;rc=s;sc=s;tc=Da}}while(0);Da=da+rc|0;s=qc+ga|0;if((c[u>>2]|0)==0){Nb=ec;Ob=o;Pb=sc;Qb=ia;sa=196;continue j}la=(s|0)==0;_a=(tc|0)==95;ha=(s|0)<1&H;C=((tc|0)!=10|r)^1;ea=u;ba=0;Za=o;Ya=ia;Ca=ra;while(1){k:do{if((c[Ca>>2]|0)>>>0>tc>>>0){uc=ba;vc=Za;wc=Ya}else{if((c[Ca+4>>2]|0)>>>0<tc>>>0){uc=ba;vc=Za;wc=Ya;break}ka=Ca+20|0;ta=c[ka>>2]|0;l:do{if((ta|0)!=0){if(!((ta&1|0)==0|ha|C)){uc=ba;vc=Za;wc=Ya;break k}if((ta&2|0)!=0){qa=c[j>>2]|0;if((qa|V|0)!=0&((qa|0)!=10|r)){uc=ba;vc=Za;wc=Ya;break k}}do{if((ta&16|0)!=0){if(_a){uc=ba;vc=Za;wc=Ya;break k}if((S2c(tc)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==95){break}if((S2c(qa)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);qa=c[ka>>2]|0;if((qa&32|0)==0){xc=qa}else{if(!_a){if((S2c(tc)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}qa=c[j>>2]|0;if((qa|0)==95){uc=ba;vc=Za;wc=Ya;break k}if((S2c(qa)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}xc=c[ka>>2]|0}do{if((xc&64|0)==0|la){yc=xc}else{qa=c[j>>2]|0;if((qa|0)==0){yc=xc;break}if(_a){zc=qa;Ac=1}else{qa=(S2c(tc)|0)!=0|0;zc=c[j>>2]|0;Ac=qa}if((zc|0)==95){Bc=1}else{Bc=(S2c(zc)|0)!=0|0}if((Ac|0)==(Bc|0)){uc=ba;vc=Za;wc=Ya;break k}yc=c[ka>>2]|0}}while(0);if((yc&128|0)==0){Cc=yc}else{if(la){uc=ba;vc=Za;wc=Ya;break k}qa=c[j>>2]|0;if((qa|0)==0){uc=ba;vc=Za;wc=Ya;break k}if(_a){Dc=qa;Ec=1}else{qa=(S2c(tc)|0)!=0|0;Dc=c[j>>2]|0;Ec=qa}if((Dc|0)==95){Fc=1}else{Fc=(S2c(Dc)|0)!=0|0}if((Ec|0)!=(Fc|0)){uc=ba;vc=Za;wc=Ya;break k}Cc=c[ka>>2]|0}do{if((Cc&4|0)==0){Gc=Cc}else{if((c[U>>2]&2|0)!=0){Gc=Cc;break}if((W2c(tc,c[Ca+24>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}Gc=c[ka>>2]|0}}while(0);do{if((Gc&4|0)!=0){if((c[U>>2]&2|0)==0){break}qa=g3c(tc)|0;aa=Ca+24|0;if((W2c(qa,c[aa>>2]|0)|0)!=0){break}qa=e3c(tc)|0;if((W2c(qa,c[aa>>2]|0)|0)==0){uc=ba;vc=Za;wc=Ya;break k}}}while(0);if((c[ka>>2]&8|0)==0){break}aa=c[Ca+28>>2]|0;qa=c[aa>>2]|0;if((qa|0)==0){break}if((c[U>>2]&2|0)==0){eb=aa;sb=qa;while(1){if((W2c(tc,sb)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}eb=eb+4|0;sb=c[eb>>2]|0;if((sb|0)==0){break l}}}else{Hc=aa}do{sb=e3c(tc)|0;if((W2c(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}sb=g3c(tc)|0;if((W2c(sb,c[Hc>>2]|0)|0)!=0){uc=ba;vc=Za;wc=Ya;break k}Hc=Hc+4|0;}while((c[Hc>>2]|0)!=0)}}while(0);if((ba|0)==0){uc=c[ea>>2]|0;vc=c[Ca+16>>2]|0;wc=Ya;break}ka=Ya+28|0;ta=c[ka>>2]|0;if((ta|0)==0){aa=H3c(S,0,0,0,32)|0;sb=aa;if((aa|0)==0){sa=169;break h}c[aa+24>>2]=Ya;c[aa+28>>2]=0;eb=H3c(S,0,0,0,c[l>>2]<<2)|0;c[aa+20>>2]=eb;if((eb|0)==0){sa=176;break h}c[ka>>2]=sb;Ic=sb}else{Ic=ta}c[Ic>>2]=s;c[Ic+4>>2]=Da;c[Ic+8>>2]=c[ea>>2];c[Ic+12>>2]=c[Ca+12>>2];c[Ic+16>>2]=c[j>>2];if((c[l>>2]|0)>0){ta=c[Ic+20>>2]|0;sb=0;do{c[ta+(sb<<2)>>2]=c[Eb+(sb<<2)>>2];sb=sb+1|0;}while((sb|0)<(c[l>>2]|0))}sb=c[Ca+16>>2]|0;if((sb|0)==0){uc=ba;vc=Za;wc=Ic;break}ta=c[sb>>2]|0;if(!((ta|0)>-1)){uc=ba;vc=Za;wc=Ic;break}ka=c[Ic+20>>2]|0;eb=ta;ta=sb;while(1){c[ka+(eb<<2)>>2]=s;sb=ta+4|0;aa=c[sb>>2]|0;if((aa|0)>-1){ta=sb;eb=aa}else{uc=ba;vc=Za;wc=Ic;break}}}}while(0);eb=Ca+40|0;if((c[eb>>2]|0)==0){break}else{ea=eb;ba=uc;Za=vc;Ya=wc;Ca=Ca+32|0}}if((uc|0)==0){Nb=ec;Ob=vc;Pb=sc;Qb=wc;sa=196;continue j}do{if((vc|0)==0){Jc=0}else{Ca=c[vc>>2]|0;if((Ca|0)>-1){Kc=Ca;Lc=vc}else{Jc=vc;break}while(1){Ca=Lc+4|0;c[Eb+(Kc<<2)>>2]=s;Ya=c[Ca>>2]|0;if((Ya|0)>-1){Lc=Ca;Kc=Ya}else{Jc=Ca;break}}}}while(0);if((uc|0)==(c[G>>2]|0)){lc=Jc;mc=s;nc=sc;oc=wc;break}else{o=Jc;ca=s;ga=sc;ia=wc;ra=uc;da=Da}}}m:do{if((ec|0)<(mc|0)){sa=96}else{if((ec|0)!=(mc|0)|B){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}da=c[l>>2]|0;ra=c[x>>2]|0;if((da|0)>0){Mc=0}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}while(1){ia=c[Eb+(Mc<<2)>>2]|0;ga=c[n+(Mc<<2)>>2]|0;if((c[ra+(Mc<<2)>>2]|0)==0){if((ia|0)<(ga|0)){sa=96;break m}if((ia|0)>(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}else{if((ia|0)>(ga|0)){Nc=da;break m}if((ia|0)<(ga|0)){Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}ga=Mc+1|0;if((ga|0)<(da|0)){Mc=ga}else{Nb=ec;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}}while(0);if((sa|0)==96){sa=0;if(B){Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}Nc=c[l>>2]|0}if((Nc|0)>0){Oc=0}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue}while(1){c[n+(Oc<<2)>>2]=c[Eb+(Oc<<2)>>2];da=Oc+1|0;if((da|0)<(c[l>>2]|0)){Oc=da}else{Nb=mc;Ob=lc;Pb=nc;Qb=oc;sa=196;continue j}}}if((Nb|0)>=0){sa=205;break}if((c[j>>2]|0)==0){sa=205;break}c[j>>2]=D;q=c[l>>2]|0;F=Nb;w=Pb;E=v;L=Qb;M=y}if((sa|0)==60){G3c(S);if((Eb|0)!=0){i4c(O)}if((Kb|0)!=0){i4c(Kb)}if((Lb|0)==0){A=12;break a}i4c(N);A=12;break a}else if((sa|0)==67){G3c(S);if((Eb|0)!=0){i4c(O)}if((Kb|0)!=0){i4c(Kb)}if((Lb|0)==0){A=12;break a}i4c(N);A=12;break a}else if((sa|0)==169){G3c(S);if((Eb|0)!=0){i4c(O)}if((Kb|0)!=0){i4c(Kb)}if((Lb|0)==0){A=12;break a}i4c(N);A=12;break a}else if((sa|0)==176){G3c(S);if((Eb|0)!=0){i4c(O)}if((Kb|0)!=0){i4c(Kb)}if((Lb|0)==0){A=12;break a}i4c(N);A=12;break a}else if((sa|0)==205){Fb=Nb;Gb=Kb;Hb=Nb>>>31;Ib=Lb;Jb=Eb;break}}}while(0);G3c(S);if((Jb|0)!=0){i4c(Jb)}if((Gb|0)!=0){i4c(Gb)}if((Ib|0)==0){Cb=Fb;Db=Hb;sa=375;break}i4c(Ib);Cb=Fb;Db=Hb;sa=375}}while(0);do{if((sa|0)==375){if((Db|0)!=0){A=Db;break}E3c(d,e,c[k+56>>2]|0,a,n,Cb);A=0}}while(0);if((n|0)==0){p=A;i=g;return p|0}i4c(m);p=A;i=g;return p|0}function E3c(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;h=i;do{if((g|0)>-1){if((d&8|0)!=0){j=0;break}k=c[e+16>>2]|0;l=e+28|0;m=c[l>>2]|0;n=(a|0)!=0;if((m|0)!=0&n){o=e+48|0;p=0;while(1){q=c[k+(p*12|0)>>2]|0;if((q|0)==(c[o>>2]|0)){c[b+(p<<3)>>2]=g;r=g}else{s=c[f+(q<<2)>>2]|0;c[b+(p<<3)>>2]=s;r=s}s=c[k+(p*12|0)+4>>2]|0;if((s|0)==(c[o>>2]|0)){c[b+(p<<3)+4>>2]=g;t=g}else{q=c[f+(s<<2)>>2]|0;c[b+(p<<3)+4>>2]=q;t=q}if((r|0)==-1|(t|0)==-1){c[b+(p<<3)+4>>2]=-1;c[b+(p<<3)>>2]=-1}q=p+1|0;s=c[l>>2]|0;if(q>>>0<s>>>0&q>>>0<a>>>0){p=q}else{u=s;break}}}else{u=m}if((u|0)!=0&n){v=u;w=0}else{j=0;break}while(1){p=b+(w<<3)+4|0;o=c[k+(w*12|0)+8>>2]|0;do{if((o|0)==0){x=v}else{s=c[o>>2]|0;if(!((s|0)>-1)){x=v;break}q=b+(w<<3)|0;y=c[q>>2]|0;z=s;s=0;while(1){if((y|0)<(c[b+(z<<3)>>2]|0)){A=21}else{if((c[p>>2]|0)>(c[b+(z<<3)+4>>2]|0)){A=21}else{B=y}}if((A|0)==21){A=0;c[p>>2]=-1;c[q>>2]=-1;B=-1}C=s+1|0;D=c[o+(C<<2)>>2]|0;if((D|0)>-1){y=B;z=D;s=C}else{break}}x=c[l>>2]|0}}while(0);o=w+1|0;if(o>>>0<x>>>0&o>>>0<a>>>0){v=x;w=o}else{j=o;break}}}else{j=0}}while(0);if(j>>>0<a>>>0){E=j}else{i=h;return}do{c[b+(E<<3)>>2]=-1;c[b+(E<<3)+4>>2]=-1;E=E+1|0;}while(E>>>0<a>>>0);i=h;return}function F3c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;if((a|0)==0){e=j4c(1,24)|0}else{c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[b+20>>2]=0;e=b}if((e|0)==0){f=0;i=d;return f|0}f=e;i=d;return f|0}function G3c(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=c[a>>2]|0;if((d|0)==0){e=a;i4c(e);i=b;return}else{f=d}while(1){i4c(c[f>>2]|0);d=c[f+4>>2]|0;i4c(f);if((d|0)==0){break}else{f=d}}e=a;i4c(e);i=b;return}function H3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;g=i;h=a+16|0;if((c[h>>2]|0)!=0){j=0;i=g;return j|0}k=a+12|0;l=c[k>>2]|0;do{if(l>>>0<f>>>0){if((b|0)!=0){if((d|0)!=0){c[a+8>>2]=d;c[k>>2]=1024;m=d;n=1024;break}c[h>>2]=1;j=0;i=g;return j|0}o=f<<3;p=o>>>0>1024?o:1024;o=h4c(8)|0;q=o;if((o|0)==0){c[h>>2]=1;j=0;i=g;return j|0}r=h4c(p)|0;c[o>>2]=r;if((r|0)==0){i4c(o);c[h>>2]=1;j=0;i=g;return j|0}c[o+4>>2]=0;r=a+4|0;s=c[r>>2]|0;if((s|0)!=0){c[s+4>>2]=q}s=a;if((c[s>>2]|0)==0){c[s>>2]=q}c[r>>2]=q;q=c[o>>2]|0;c[a+8>>2]=q;c[k>>2]=p;m=q;n=p}else{m=c[a+8>>2]|0;n=l}}while(0);l=m+f&3;h=((l|0)==0?0:4-l|0)+f|0;c[a+8>>2]=m+h;c[k>>2]=n-h;if((e|0)==0){j=m;i=g;return j|0}P4c(m|0,0,h|0)|0;j=m;i=g;return j|0}function I3c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;if((b|0)==0){e=a+((J3c(a)|0)<<2)|0;i=d;return e|0}else{f=a}while(1){g=c[f>>2]|0;if((g|0)==0|(g|0)==(b|0)){break}else{f=f+4|0}}e=(g|0)!=0?f:0;i=d;return e|0}function J3c(a){a=a|0;var b=0,d=0;b=i;d=a;while(1){if((c[d>>2]|0)==0){break}else{d=d+4|0}}i=b;return d-a>>2|0}function K3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=b;h=a}while(1){b=f+ -1|0;c[h>>2]=c[g>>2];if((b|0)==0){break}else{h=h+4|0;g=g+4|0;f=b}}i=e;return a|0}function L3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;f=(d|0)==0;if(a-b>>2>>>0<d>>>0){if(f){i=e;return a|0}else{g=d}do{g=g+ -1|0;c[a+(g<<2)>>2]=c[b+(g<<2)>>2];}while((g|0)!=0);i=e;return a|0}else{if(f){i=e;return a|0}else{h=b;j=a;k=d}while(1){d=k+ -1|0;c[j>>2]=c[h>>2];if((d|0)==0){break}else{k=d;j=j+4|0;h=h+4|0}}i=e;return a|0}return 0}function M3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;if((d|0)==0){i=e;return a|0}else{f=d;g=a}while(1){d=f+ -1|0;c[g>>2]=b;if((d|0)==0){break}else{g=g+4|0;f=d}}i=e;return a|0}function N3c(a){a=a|0;i=i;return}function O3c(a){a=a|0;c[a>>2]=381848;i=i;return}function P3c(a){a=a|0;var b=0;b=i;zb(a|0);p4c(a);i=b;return}function Q3c(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function R3c(a){a=a|0;i=i;return 381864}function S3c(a){a=a|0;i=i;return}function T3c(a){a=a|0;i=i;return}function U3c(a){a=a|0;i=i;return}function V3c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function W3c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function X3c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function Y3c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+56|0;f=e;if((a|0)==(b|0)){g=1;i=e;return g|0}if((b|0)==0){g=0;i=e;return g|0}h=a4c(b,381976,382032,0)|0;b=h;if((h|0)==0){g=0;i=e;return g|0}j=f+0|0;k=j+56|0;do{c[j>>2]=0;j=j+4|0}while((j|0)<(k|0));c[f>>2]=b;c[f+8>>2]=a;c[f+12>>2]=-1;c[f+48>>2]=1;Ie[c[(c[h>>2]|0)+28>>2]&63](b,f,c[d>>2]|0,1);if((c[f+24>>2]|0)!=1){g=0;i=e;return g|0}c[d>>2]=c[f+16>>2];g=1;i=e;return g|0}function Z3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((c[d+8>>2]|0)!=(b|0)){i=g;return}b=d+16|0;h=c[b>>2]|0;if((h|0)==0){c[b>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function _3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;if((b|0)!=(c[d+8>>2]|0)){h=c[b+8>>2]|0;Ie[c[(c[h>>2]|0)+28>>2]&63](h,d,e,f);i=g;return}h=d+16|0;b=c[h>>2]|0;if((b|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}e=d+24|0;if((c[e>>2]|0)!=2){i=g;return}c[e>>2]=f;i=g;return}function $3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;if((b|0)==(c[d+8>>2]|0)){h=d+16|0;j=c[h>>2]|0;if((j|0)==0){c[h>>2]=e;c[d+24>>2]=f;c[d+36>>2]=1;i=g;return}if((j|0)!=(e|0)){j=d+36|0;c[j>>2]=(c[j>>2]|0)+1;c[d+24>>2]=2;a[d+54|0]=1;i=g;return}j=d+24|0;if((c[j>>2]|0)!=2){i=g;return}c[j>>2]=f;i=g;return}j=c[b+12>>2]|0;h=b+16+(j<<3)|0;k=c[b+20>>2]|0;l=k>>8;if((k&1|0)==0){m=l}else{m=c[(c[e>>2]|0)+l>>2]|0}l=c[b+16>>2]|0;Ie[c[(c[l>>2]|0)+28>>2]&63](l,d,e+m|0,(k&2|0)!=0?f:2);if((j|0)<=1){i=g;return}j=d+54|0;k=b+24|0;while(1){b=c[k+4>>2]|0;m=b>>8;if((b&1|0)==0){n=m}else{n=c[(c[e>>2]|0)+m>>2]|0}m=c[k>>2]|0;Ie[c[(c[m>>2]|0)+28>>2]&63](m,d,e+n|0,(b&2|0)!=0?f:2);if((a[j]|0)!=0){o=16;break}b=k+8|0;if(b>>>0<h>>>0){k=b}else{o=16;break}}if((o|0)==16){i=g;return}}function a4c(d,e,f,g){d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+56|0;j=h;k=c[d>>2]|0;l=d+(c[k+ -8>>2]|0)|0;m=c[k+ -4>>2]|0;k=m;c[j>>2]=f;c[j+4>>2]=d;c[j+8>>2]=e;c[j+12>>2]=g;g=j+16|0;e=j+20|0;d=j+24|0;n=j+28|0;o=j+32|0;p=j+40|0;q=(m|0)==(f|0);f=g;r=f+0|0;s=r+36|0;do{c[r>>2]=0;r=r+4|0}while((r|0)<(s|0));b[f+36>>1]=0;a[f+38|0]=0;if(q){c[j+48>>2]=1;re[c[(c[m>>2]|0)+20>>2]&31](k,j,l,l,1,0);t=(c[d>>2]|0)==1?l:0;i=h;return t|0}ce[c[(c[m>>2]|0)+24>>2]&31](k,j,l,1,0);l=c[j+36>>2]|0;if((l|0)==0){if((c[p>>2]|0)!=1){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}t=(c[o>>2]|0)==1?c[e>>2]|0:0;i=h;return t|0}else if((l|0)==1){do{if((c[d>>2]|0)!=1){if((c[p>>2]|0)!=0){t=0;i=h;return t|0}if((c[n>>2]|0)!=1){t=0;i=h;return t|0}if((c[o>>2]|0)==1){break}else{t=0}i=h;return t|0}}while(0);t=c[g>>2]|0;i=h;return t|0}else{t=0;i=h;return t|0}return 0}function b4c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)==(c[d>>2]|0)){do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=c[b+12>>2]|0;m=b+16+(l<<3)|0;a:do{if((l|0)>0){n=d+52|0;o=d+53|0;p=d+54|0;q=b+8|0;r=d+24|0;s=0;t=0;u=b+16|0;b:while(1){a[n]=0;a[o]=0;v=c[u+4>>2]|0;w=v>>8;if((v&1|0)==0){x=w}else{x=c[(c[e>>2]|0)+w>>2]|0}w=c[u>>2]|0;re[c[(c[w>>2]|0)+20>>2]&31](w,d,e,e+x|0,2-(v>>>1&1)|0,g);if((a[p]|0)!=0){y=s;z=t;break}do{if((a[o]|0)==0){A=s;B=t}else{if((a[n]|0)==0){if((c[q>>2]&1|0)==0){y=s;z=1;break b}else{A=s;B=1;break}}if((c[r>>2]|0)==1){C=27;break a}if((c[q>>2]&2|0)==0){C=27;break a}else{A=1;B=1}}}while(0);v=u+8|0;if(v>>>0<m>>>0){s=A;t=B;u=v}else{y=A;z=B;break}}if(y){D=z;C=26}else{E=z;C=23}}else{E=0;C=23}}while(0);do{if((C|0)==23){c[j>>2]=e;m=d+40|0;c[m>>2]=(c[m>>2]|0)+1;if((c[d+36>>2]|0)!=1){D=E;C=26;break}if((c[d+24>>2]|0)!=2){D=E;C=26;break}a[d+54|0]=1;if(E){C=27}else{C=28}}}while(0);if((C|0)==26){if(D){C=27}else{C=28}}if((C|0)==27){c[k>>2]=3;i=h;return}else if((C|0)==28){c[k>>2]=4;i=h;return}}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}D=c[b+12>>2]|0;E=b+16+(D<<3)|0;z=c[b+20>>2]|0;y=z>>8;if((z&1|0)==0){F=y}else{F=c[(c[e>>2]|0)+y>>2]|0}y=c[b+16>>2]|0;ce[c[(c[y>>2]|0)+24>>2]&31](y,d,e+F|0,(z&2|0)!=0?f:2,g);z=b+24|0;if((D|0)<=1){i=h;return}D=c[b+8>>2]|0;do{if((D&2|0)==0){b=d+36|0;if((c[b>>2]|0)==1){break}if((D&1|0)==0){F=d+54|0;y=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){C=53;break}B=c[y+4>>2]|0;A=B>>8;if((B&1|0)==0){G=A}else{G=c[(c[e>>2]|0)+A>>2]|0}A=c[y>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+G|0,(B&2|0)!=0?f:2,g);B=y+8|0;if(B>>>0<E>>>0){y=B}else{C=53;break}}if((C|0)==53){i=h;return}}y=d+24|0;F=d+54|0;k=z;while(1){if((a[F]|0)!=0){C=53;break}if((c[b>>2]|0)==1){if((c[y>>2]|0)==1){C=53;break}}B=c[k+4>>2]|0;A=B>>8;if((B&1|0)==0){H=A}else{H=c[(c[e>>2]|0)+A>>2]|0}A=c[k>>2]|0;ce[c[(c[A>>2]|0)+24>>2]&31](A,d,e+H|0,(B&2|0)!=0?f:2,g);B=k+8|0;if(B>>>0<E>>>0){k=B}else{C=53;break}}if((C|0)==53){i=h;return}}}while(0);H=d+54|0;G=z;while(1){if((a[H]|0)!=0){C=53;break}z=c[G+4>>2]|0;D=z>>8;if((z&1|0)==0){I=D}else{I=c[(c[e>>2]|0)+D>>2]|0}D=c[G>>2]|0;ce[c[(c[D>>2]|0)+24>>2]&31](D,d,e+I|0,(z&2|0)!=0?f:2,g);z=G+8|0;if(z>>>0<E>>>0){G=z}else{C=53;break}}if((C|0)==53){i=h;return}}function c4c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;j=b;if((j|0)==(c[d+8>>2]|0)){if((c[d+4>>2]|0)!=(e|0)){i=h;return}k=d+28|0;if((c[k>>2]|0)==1){i=h;return}c[k>>2]=f;i=h;return}if((j|0)!=(c[d>>2]|0)){j=c[b+8>>2]|0;ce[c[(c[j>>2]|0)+24>>2]&31](j,d,e,f,g);i=h;return}do{if((c[d+16>>2]|0)!=(e|0)){j=d+20|0;if((c[j>>2]|0)==(e|0)){break}c[d+32>>2]=f;k=d+44|0;if((c[k>>2]|0)==4){i=h;return}l=d+52|0;a[l]=0;m=d+53|0;a[m]=0;n=c[b+8>>2]|0;re[c[(c[n>>2]|0)+20>>2]&31](n,d,e,e,1,g);if((a[m]|0)==0){o=0;p=13}else{if((a[l]|0)==0){o=1;p=13}}a:do{if((p|0)==13){c[j>>2]=e;l=d+40|0;c[l>>2]=(c[l>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){p=16;break}a[d+54|0]=1;if(o){break a}}else{p=16}}while(0);if((p|0)==16){if(o){break}}c[k>>2]=4;i=h;return}}while(0);c[k>>2]=3;i=h;return}}while(0);if((f|0)!=1){i=h;return}c[d+32>>2]=1;i=h;return}function d4c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0;g=i;if((c[d+8>>2]|0)==(b|0)){if((c[d+4>>2]|0)!=(e|0)){i=g;return}h=d+28|0;if((c[h>>2]|0)==1){i=g;return}c[h>>2]=f;i=g;return}if((c[d>>2]|0)!=(b|0)){i=g;return}do{if((c[d+16>>2]|0)!=(e|0)){b=d+20|0;if((c[b>>2]|0)==(e|0)){break}c[d+32>>2]=f;c[b>>2]=e;b=d+40|0;c[b>>2]=(c[b>>2]|0)+1;do{if((c[d+36>>2]|0)==1){if((c[d+24>>2]|0)!=2){break}a[d+54|0]=1}}while(0);c[d+44>>2]=4;i=g;return}}while(0);if((f|0)!=1){i=g;return}c[d+32>>2]=1;i=g;return}function e4c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=d+52|0;l=a[k]|0;m=d+53|0;n=a[m]|0;o=c[b+12>>2]|0;p=b+16+(o<<3)|0;a[k]=0;a[m]=0;q=c[b+20>>2]|0;r=q>>8;if((q&1|0)==0){s=r}else{s=c[(c[f>>2]|0)+r>>2]|0}r=c[b+16>>2]|0;re[c[(c[r>>2]|0)+20>>2]&31](r,d,e,f+s|0,(q&2|0)!=0?g:2,h);a:do{if((o|0)>1){q=d+24|0;s=b+8|0;r=d+54|0;t=b+24|0;do{if((a[r]|0)!=0){break a}do{if((a[k]|0)==0){if((a[m]|0)==0){break}if((c[s>>2]&1|0)==0){break a}}else{if((c[q>>2]|0)==1){break a}if((c[s>>2]&2|0)==0){break a}}}while(0);a[k]=0;a[m]=0;u=c[t+4>>2]|0;v=u>>8;if((u&1|0)==0){w=v}else{w=c[(c[f>>2]|0)+v>>2]|0}v=c[t>>2]|0;re[c[(c[v>>2]|0)+20>>2]&31](v,d,e,f+w|0,(u&2|0)!=0?g:2,h);t=t+8|0;}while(t>>>0<p>>>0)}}while(0);a[k]=l;a[m]=n;i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;n=c[f>>2]|0;if((n|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((n|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;n=c[e>>2]|0;if((n|0)==2){c[e>>2]=g;x=g}else{x=n}if(!((c[d+48>>2]|0)==1&(x|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function f4c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;if((b|0)!=(c[d+8>>2]|0)){k=c[b+8>>2]|0;re[c[(c[k>>2]|0)+20>>2]&31](k,d,e,f,g,h);i=j;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=j;return}a[d+52|0]=1;f=d+16|0;h=c[f>>2]|0;if((h|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}if((h|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=j;return}e=d+24|0;h=c[e>>2]|0;if((h|0)==2){c[e>>2]=g;l=g}else{l=h}if(!((c[d+48>>2]|0)==1&(l|0)==1)){i=j;return}a[d+54|0]=1;i=j;return}function g4c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0;h=i;if((c[d+8>>2]|0)!=(b|0)){i=h;return}a[d+53|0]=1;if((c[d+4>>2]|0)!=(f|0)){i=h;return}a[d+52|0]=1;f=d+16|0;b=c[f>>2]|0;if((b|0)==0){c[f>>2]=e;c[d+24>>2]=g;c[d+36>>2]=1;if(!((c[d+48>>2]|0)==1&(g|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}if((b|0)!=(e|0)){e=d+36|0;c[e>>2]=(c[e>>2]|0)+1;a[d+54|0]=1;i=h;return}e=d+24|0;b=c[e>>2]|0;if((b|0)==2){c[e>>2]=g;j=g}else{j=b}if(!((c[d+48>>2]|0)==1&(j|0)==1)){i=h;return}a[d+54|0]=1;i=h;return}function h4c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0;b=i;do{if(a>>>0<245){if(a>>>0<11){d=16}else{d=a+11&-8}e=d>>>3;f=c[95570]|0;g=f>>>e;if((g&3|0)!=0){h=(g&1^1)+e|0;j=h<<1;k=382320+(j<<2)|0;l=382320+(j+2<<2)|0;j=c[l>>2]|0;m=j+8|0;n=c[m>>2]|0;do{if((k|0)==(n|0)){c[95570]=f&~(1<<h)}else{if(n>>>0<(c[382296>>2]|0)>>>0){hd()}o=n+12|0;if((c[o>>2]|0)==(j|0)){c[o>>2]=k;c[l>>2]=n;break}else{hd()}}}while(0);n=h<<3;c[j+4>>2]=n|3;l=j+(n|4)|0;c[l>>2]=c[l>>2]|1;p=m;i=b;return p|0}if(!(d>>>0>(c[382288>>2]|0)>>>0)){q=d;break}if((g|0)!=0){l=2<<e;n=g<<e&(l|0-l);l=(n&0-n)+ -1|0;n=l>>>12&16;k=l>>>n;l=k>>>5&8;o=k>>>l;k=o>>>2&4;r=o>>>k;o=r>>>1&2;s=r>>>o;r=s>>>1&1;t=(l|n|k|o|r)+(s>>>r)|0;r=t<<1;s=382320+(r<<2)|0;o=382320+(r+2<<2)|0;r=c[o>>2]|0;k=r+8|0;n=c[k>>2]|0;do{if((s|0)==(n|0)){c[95570]=f&~(1<<t)}else{if(n>>>0<(c[382296>>2]|0)>>>0){hd()}l=n+12|0;if((c[l>>2]|0)==(r|0)){c[l>>2]=s;c[o>>2]=n;break}else{hd()}}}while(0);n=t<<3;o=n-d|0;c[r+4>>2]=d|3;s=r+d|0;c[r+(d|4)>>2]=o|1;c[r+n>>2]=o;n=c[382288>>2]|0;if((n|0)!=0){f=c[382300>>2]|0;e=n>>>3;n=e<<1;g=382320+(n<<2)|0;m=c[95570]|0;j=1<<e;do{if((m&j|0)==0){c[95570]=m|j;u=382320+(n+2<<2)|0;v=g}else{e=382320+(n+2<<2)|0;h=c[e>>2]|0;if(!(h>>>0<(c[382296>>2]|0)>>>0)){u=e;v=h;break}hd()}}while(0);c[u>>2]=f;c[v+12>>2]=f;c[f+8>>2]=v;c[f+12>>2]=g}c[382288>>2]=o;c[382300>>2]=s;p=k;i=b;return p|0}n=c[382284>>2]|0;if((n|0)==0){q=d;break}j=(n&0-n)+ -1|0;n=j>>>12&16;m=j>>>n;j=m>>>5&8;r=m>>>j;m=r>>>2&4;t=r>>>m;r=t>>>1&2;h=t>>>r;t=h>>>1&1;e=c[382584+((j|n|m|r|t)+(h>>>t)<<2)>>2]|0;t=(c[e+4>>2]&-8)-d|0;h=e;r=e;while(1){e=c[h+16>>2]|0;if((e|0)==0){m=c[h+20>>2]|0;if((m|0)==0){break}else{w=m}}else{w=e}e=(c[w+4>>2]&-8)-d|0;m=e>>>0<t>>>0;t=m?e:t;h=w;r=m?w:r}h=r;k=c[382296>>2]|0;if(h>>>0<k>>>0){hd()}s=r+d|0;o=s;if(!(h>>>0<s>>>0)){hd()}s=c[r+24>>2]|0;h=c[r+12>>2]|0;do{if((h|0)==(r|0)){g=r+20|0;f=c[g>>2]|0;if((f|0)==0){m=r+16|0;e=c[m>>2]|0;if((e|0)==0){x=0;break}else{y=e;z=m}}else{y=f;z=g}while(1){g=y+20|0;f=c[g>>2]|0;if((f|0)!=0){z=g;y=f;continue}f=y+16|0;g=c[f>>2]|0;if((g|0)==0){break}else{y=g;z=f}}if(z>>>0<k>>>0){hd()}else{c[z>>2]=0;x=y;break}}else{f=c[r+8>>2]|0;if(f>>>0<k>>>0){hd()}g=f+12|0;if((c[g>>2]|0)!=(r|0)){hd()}m=h+8|0;if((c[m>>2]|0)==(r|0)){c[g>>2]=h;c[m>>2]=f;x=h;break}else{hd()}}}while(0);a:do{if((s|0)!=0){h=c[r+28>>2]|0;k=382584+(h<<2)|0;do{if((r|0)==(c[k>>2]|0)){c[k>>2]=x;if((x|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<h);break a}else{if(s>>>0<(c[382296>>2]|0)>>>0){hd()}f=s+16|0;if((c[f>>2]|0)==(r|0)){c[f>>2]=x}else{c[s+20>>2]=x}if((x|0)==0){break a}}}while(0);if(x>>>0<(c[382296>>2]|0)>>>0){hd()}c[x+24>>2]=s;h=c[r+16>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[x+16>>2]=h;c[h+24>>2]=x;break}}}while(0);h=c[r+20>>2]|0;if((h|0)==0){break}if(h>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[x+20>>2]=h;c[h+24>>2]=x;break}}}while(0);if(t>>>0<16){s=t+d|0;c[r+4>>2]=s|3;h=r+(s+4)|0;c[h>>2]=c[h>>2]|1}else{c[r+4>>2]=d|3;c[r+(d|4)>>2]=t|1;c[r+(t+d)>>2]=t;h=c[382288>>2]|0;if((h|0)!=0){s=c[382300>>2]|0;k=h>>>3;h=k<<1;f=382320+(h<<2)|0;m=c[95570]|0;g=1<<k;do{if((m&g|0)==0){c[95570]=m|g;A=382320+(h+2<<2)|0;B=f}else{k=382320+(h+2<<2)|0;e=c[k>>2]|0;if(!(e>>>0<(c[382296>>2]|0)>>>0)){A=k;B=e;break}hd()}}while(0);c[A>>2]=s;c[B+12>>2]=s;c[s+8>>2]=B;c[s+12>>2]=f}c[382288>>2]=t;c[382300>>2]=o}p=r+8|0;i=b;return p|0}else{if(a>>>0>4294967231){q=-1;break}h=a+11|0;g=h&-8;m=c[382284>>2]|0;if((m|0)==0){q=g;break}e=0-g|0;k=h>>>8;do{if((k|0)==0){C=0}else{if(g>>>0>16777215){C=31;break}h=(k+1048320|0)>>>16&8;n=k<<h;j=(n+520192|0)>>>16&4;l=n<<j;n=(l+245760|0)>>>16&2;D=14-(j|h|n)+(l<<n>>>15)|0;C=g>>>(D+7|0)&1|D<<1}}while(0);k=c[382584+(C<<2)>>2]|0;b:do{if((k|0)==0){E=e;F=0;G=0}else{if((C|0)==31){H=0}else{H=25-(C>>>1)|0}r=e;o=0;t=g<<H;f=k;s=0;while(1){D=c[f+4>>2]&-8;n=D-g|0;if(n>>>0<r>>>0){if((D|0)==(g|0)){E=n;F=f;G=f;break b}else{I=n;J=f}}else{I=r;J=s}n=c[f+20>>2]|0;D=c[f+16+(t>>>31<<2)>>2]|0;l=(n|0)==0|(n|0)==(D|0)?o:n;if((D|0)==0){E=I;F=l;G=J;break}else{r=I;o=l;t=t<<1;f=D;s=J}}}}while(0);if((F|0)==0&(G|0)==0){k=2<<C;e=m&(k|0-k);if((e|0)==0){q=g;break}k=(e&0-e)+ -1|0;e=k>>>12&16;s=k>>>e;k=s>>>5&8;f=s>>>k;s=f>>>2&4;t=f>>>s;f=t>>>1&2;o=t>>>f;t=o>>>1&1;K=c[382584+((k|e|s|f|t)+(o>>>t)<<2)>>2]|0}else{K=F}if((K|0)==0){L=E;M=G}else{t=E;o=K;f=G;while(1){s=(c[o+4>>2]&-8)-g|0;e=s>>>0<t>>>0;k=e?s:t;s=e?o:f;e=c[o+16>>2]|0;if((e|0)!=0){N=s;O=k;f=N;o=e;t=O;continue}e=c[o+20>>2]|0;if((e|0)==0){L=k;M=s;break}else{N=s;O=k;o=e;f=N;t=O}}}if((M|0)==0){q=g;break}if(!(L>>>0<((c[382288>>2]|0)-g|0)>>>0)){q=g;break}t=M;f=c[382296>>2]|0;if(t>>>0<f>>>0){hd()}o=M+g|0;m=o;if(!(t>>>0<o>>>0)){hd()}t=c[M+24>>2]|0;e=c[M+12>>2]|0;do{if((e|0)==(M|0)){k=M+20|0;s=c[k>>2]|0;if((s|0)==0){r=M+16|0;D=c[r>>2]|0;if((D|0)==0){P=0;break}else{Q=D;R=r}}else{Q=s;R=k}while(1){k=Q+20|0;s=c[k>>2]|0;if((s|0)!=0){R=k;Q=s;continue}s=Q+16|0;k=c[s>>2]|0;if((k|0)==0){break}else{Q=k;R=s}}if(R>>>0<f>>>0){hd()}else{c[R>>2]=0;P=Q;break}}else{s=c[M+8>>2]|0;if(s>>>0<f>>>0){hd()}k=s+12|0;if((c[k>>2]|0)!=(M|0)){hd()}r=e+8|0;if((c[r>>2]|0)==(M|0)){c[k>>2]=e;c[r>>2]=s;P=e;break}else{hd()}}}while(0);c:do{if((t|0)!=0){e=c[M+28>>2]|0;f=382584+(e<<2)|0;do{if((M|0)==(c[f>>2]|0)){c[f>>2]=P;if((P|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<e);break c}else{if(t>>>0<(c[382296>>2]|0)>>>0){hd()}s=t+16|0;if((c[s>>2]|0)==(M|0)){c[s>>2]=P}else{c[t+20>>2]=P}if((P|0)==0){break c}}}while(0);if(P>>>0<(c[382296>>2]|0)>>>0){hd()}c[P+24>>2]=t;e=c[M+16>>2]|0;do{if((e|0)!=0){if(e>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[P+16>>2]=e;c[e+24>>2]=P;break}}}while(0);e=c[M+20>>2]|0;if((e|0)==0){break}if(e>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[P+20>>2]=e;c[e+24>>2]=P;break}}}while(0);d:do{if(L>>>0<16){t=L+g|0;c[M+4>>2]=t|3;e=M+(t+4)|0;c[e>>2]=c[e>>2]|1}else{c[M+4>>2]=g|3;c[M+(g|4)>>2]=L|1;c[M+(L+g)>>2]=L;e=L>>>3;if(L>>>0<256){t=e<<1;f=382320+(t<<2)|0;s=c[95570]|0;r=1<<e;do{if((s&r|0)==0){c[95570]=s|r;S=382320+(t+2<<2)|0;T=f}else{e=382320+(t+2<<2)|0;k=c[e>>2]|0;if(!(k>>>0<(c[382296>>2]|0)>>>0)){S=e;T=k;break}hd()}}while(0);c[S>>2]=m;c[T+12>>2]=m;c[M+(g+8)>>2]=T;c[M+(g+12)>>2]=f;break}t=o;r=L>>>8;do{if((r|0)==0){U=0}else{if(L>>>0>16777215){U=31;break}s=(r+1048320|0)>>>16&8;k=r<<s;e=(k+520192|0)>>>16&4;D=k<<e;k=(D+245760|0)>>>16&2;l=14-(e|s|k)+(D<<k>>>15)|0;U=L>>>(l+7|0)&1|l<<1}}while(0);r=382584+(U<<2)|0;c[M+(g+28)>>2]=U;c[M+(g+20)>>2]=0;c[M+(g+16)>>2]=0;f=c[382284>>2]|0;l=1<<U;if((f&l|0)==0){c[382284>>2]=f|l;c[r>>2]=t;c[M+(g+24)>>2]=r;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break}l=c[r>>2]|0;if((U|0)==31){V=0}else{V=25-(U>>>1)|0}e:do{if((c[l+4>>2]&-8|0)==(L|0)){W=l}else{r=L<<V;f=l;while(1){X=f+16+(r>>>31<<2)|0;k=c[X>>2]|0;if((k|0)==0){break}if((c[k+4>>2]&-8|0)==(L|0)){W=k;break e}else{r=r<<1;f=k}}if(X>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[X>>2]=t;c[M+(g+24)>>2]=f;c[M+(g+12)>>2]=t;c[M+(g+8)>>2]=t;break d}}}while(0);l=W+8|0;r=c[l>>2]|0;k=c[382296>>2]|0;if(W>>>0<k>>>0){hd()}if(r>>>0<k>>>0){hd()}else{c[r+12>>2]=t;c[l>>2]=t;c[M+(g+8)>>2]=r;c[M+(g+12)>>2]=W;c[M+(g+24)>>2]=0;break}}}while(0);p=M+8|0;i=b;return p|0}}while(0);M=c[382288>>2]|0;if(!(q>>>0>M>>>0)){W=M-q|0;X=c[382300>>2]|0;if(W>>>0>15){c[382300>>2]=X+q;c[382288>>2]=W;c[X+(q+4)>>2]=W|1;c[X+M>>2]=W;c[X+4>>2]=q|3}else{c[382288>>2]=0;c[382300>>2]=0;c[X+4>>2]=M|3;W=X+(M+4)|0;c[W>>2]=c[W>>2]|1}p=X+8|0;i=b;return p|0}X=c[382292>>2]|0;if(q>>>0<X>>>0){W=X-q|0;c[382292>>2]=W;X=c[382304>>2]|0;c[382304>>2]=X+q;c[X+(q+4)>>2]=W|1;c[X+4>>2]=q|3;p=X+8|0;i=b;return p|0}do{if((c[95688]|0)==0){X=ed(30)|0;if((X+ -1&X|0)==0){c[382760>>2]=X;c[382756>>2]=X;c[382764>>2]=-1;c[382768>>2]=-1;c[382772>>2]=0;c[382724>>2]=0;c[95688]=(sc(0)|0)&-16^1431655768;break}else{hd()}}}while(0);X=q+48|0;W=c[382760>>2]|0;M=q+47|0;L=W+M|0;V=0-W|0;W=L&V;if(!(W>>>0>q>>>0)){p=0;i=b;return p|0}U=c[382720>>2]|0;do{if((U|0)!=0){T=c[382712>>2]|0;S=T+W|0;if(S>>>0<=T>>>0|S>>>0>U>>>0){p=0}else{break}i=b;return p|0}}while(0);f:do{if((c[382724>>2]&4|0)==0){U=c[382304>>2]|0;g:do{if((U|0)==0){Y=182}else{S=U;T=382728|0;while(1){Z=T;P=c[Z>>2]|0;if(!(P>>>0>S>>>0)){_=T+4|0;if((P+(c[_>>2]|0)|0)>>>0>S>>>0){break}}P=c[T+8>>2]|0;if((P|0)==0){Y=182;break g}else{T=P}}if((T|0)==0){Y=182;break}S=L-(c[382292>>2]|0)&V;if(!(S>>>0<2147483647)){$=0;break}t=kb(S|0)|0;P=(t|0)==((c[Z>>2]|0)+(c[_>>2]|0)|0);aa=t;ba=S;ca=P?t:-1;da=P?S:0;Y=191}}while(0);do{if((Y|0)==182){U=kb(0)|0;if((U|0)==(-1|0)){$=0;break}S=U;P=c[382756>>2]|0;t=P+ -1|0;if((t&S|0)==0){ea=W}else{ea=W-S+(t+S&0-P)|0}P=c[382712>>2]|0;S=P+ea|0;if(!(ea>>>0>q>>>0&ea>>>0<2147483647)){$=0;break}t=c[382720>>2]|0;if((t|0)!=0){if(S>>>0<=P>>>0|S>>>0>t>>>0){$=0;break}}t=kb(ea|0)|0;S=(t|0)==(U|0);aa=t;ba=ea;ca=S?U:-1;da=S?ea:0;Y=191}}while(0);h:do{if((Y|0)==191){S=0-ba|0;if((ca|0)!=(-1|0)){fa=ca;ga=da;Y=202;break f}do{if((aa|0)!=(-1|0)&ba>>>0<2147483647&ba>>>0<X>>>0){U=c[382760>>2]|0;t=M-ba+U&0-U;if(!(t>>>0<2147483647)){ha=ba;break}if((kb(t|0)|0)==(-1|0)){kb(S|0)|0;$=da;break h}else{ha=t+ba|0;break}}else{ha=ba}}while(0);if((aa|0)==(-1|0)){$=da}else{fa=aa;ga=ha;Y=202;break f}}}while(0);c[382724>>2]=c[382724>>2]|4;ia=$;Y=199}else{ia=0;Y=199}}while(0);do{if((Y|0)==199){if(!(W>>>0<2147483647)){break}$=kb(W|0)|0;ha=kb(0)|0;if(!((ha|0)!=(-1|0)&($|0)!=(-1|0)&$>>>0<ha>>>0)){break}aa=ha-$|0;ha=aa>>>0>(q+40|0)>>>0;if(ha){fa=$;ga=ha?aa:ia;Y=202}}}while(0);do{if((Y|0)==202){ia=(c[382712>>2]|0)+ga|0;c[382712>>2]=ia;if(ia>>>0>(c[382716>>2]|0)>>>0){c[382716>>2]=ia}ia=c[382304>>2]|0;W=382728|0;i:do{if((ia|0)==0){aa=c[382296>>2]|0;if((aa|0)==0|fa>>>0<aa>>>0){c[382296>>2]=fa}c[382728>>2]=fa;c[382732>>2]=ga;c[382740>>2]=0;c[382316>>2]=c[95688];c[382312>>2]=-1;aa=0;do{ha=aa<<1;$=382320+(ha<<2)|0;c[382320+(ha+3<<2)>>2]=$;c[382320+(ha+2<<2)>>2]=$;aa=aa+1|0;}while(aa>>>0<32);aa=fa+8|0;if((aa&7|0)==0){ja=0}else{ja=0-aa&7}aa=ga+ -40-ja|0;c[382304>>2]=fa+ja;c[382292>>2]=aa;c[fa+(ja+4)>>2]=aa|1;c[fa+(ga+ -36)>>2]=40;c[382308>>2]=c[382768>>2]}else{aa=W;while(1){ka=c[aa>>2]|0;la=aa+4|0;ma=c[la>>2]|0;if((fa|0)==(ka+ma|0)){Y=214;break}$=c[aa+8>>2]|0;if(($|0)==0){break}else{aa=$}}do{if((Y|0)==214){if((c[aa+12>>2]&8|0)!=0){break}$=ia;if(!($>>>0>=ka>>>0&$>>>0<fa>>>0)){break}c[la>>2]=ma+ga;$=(c[382292>>2]|0)+ga|0;ha=ia+8|0;if((ha&7|0)==0){na=0}else{na=0-ha&7}ha=$-na|0;c[382304>>2]=ia+na;c[382292>>2]=ha;c[ia+(na+4)>>2]=ha|1;c[ia+($+4)>>2]=40;c[382308>>2]=c[382768>>2];break i}}while(0);if(fa>>>0<(c[382296>>2]|0)>>>0){c[382296>>2]=fa}aa=fa+ga|0;$=382728|0;while(1){oa=$;if((c[oa>>2]|0)==(aa|0)){Y=224;break}ha=c[$+8>>2]|0;if((ha|0)==0){break}else{$=ha}}do{if((Y|0)==224){if((c[$+12>>2]&8|0)!=0){break}c[oa>>2]=fa;aa=$+4|0;c[aa>>2]=(c[aa>>2]|0)+ga;aa=fa+8|0;if((aa&7|0)==0){pa=0}else{pa=0-aa&7}aa=fa+(ga+8)|0;if((aa&7|0)==0){qa=0}else{qa=0-aa&7}aa=fa+(qa+ga)|0;ha=aa;da=pa+q|0;ba=fa+da|0;M=ba;X=aa-(fa+pa)-q|0;c[fa+(pa+4)>>2]=q|3;j:do{if((ha|0)==(c[382304>>2]|0)){ca=(c[382292>>2]|0)+X|0;c[382292>>2]=ca;c[382304>>2]=M;c[fa+(da+4)>>2]=ca|1}else{if((ha|0)==(c[382300>>2]|0)){ca=(c[382288>>2]|0)+X|0;c[382288>>2]=ca;c[382300>>2]=M;c[fa+(da+4)>>2]=ca|1;c[fa+(ca+da)>>2]=ca;break}ca=ga+4|0;ea=c[fa+(ca+qa)>>2]|0;if((ea&3|0)==1){_=ea&-8;Z=ea>>>3;k:do{if(ea>>>0<256){V=c[fa+((qa|8)+ga)>>2]|0;L=c[fa+(ga+12+qa)>>2]|0;S=382320+(Z<<1<<2)|0;do{if((V|0)!=(S|0)){if(V>>>0<(c[382296>>2]|0)>>>0){hd()}if((c[V+12>>2]|0)==(ha|0)){break}hd()}}while(0);if((L|0)==(V|0)){c[95570]=c[95570]&~(1<<Z);break}do{if((L|0)==(S|0)){ra=L+8|0}else{if(L>>>0<(c[382296>>2]|0)>>>0){hd()}T=L+8|0;if((c[T>>2]|0)==(ha|0)){ra=T;break}hd()}}while(0);c[V+12>>2]=L;c[ra>>2]=V}else{S=aa;T=c[fa+((qa|24)+ga)>>2]|0;t=c[fa+(ga+12+qa)>>2]|0;do{if((t|0)==(S|0)){U=qa|16;P=fa+(ca+U)|0;Q=P;R=c[P>>2]|0;if((R|0)==0){P=fa+(U+ga)|0;U=c[P>>2]|0;if((U|0)==0){sa=0;break}else{ta=U;ua=P}}else{ta=R;ua=Q}while(1){Q=ta+20|0;R=c[Q>>2]|0;if((R|0)!=0){ua=Q;ta=R;continue}R=ta+16|0;Q=c[R>>2]|0;if((Q|0)==0){break}else{ta=Q;ua=R}}if(ua>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[ua>>2]=0;sa=ta;break}}else{R=c[fa+((qa|8)+ga)>>2]|0;if(R>>>0<(c[382296>>2]|0)>>>0){hd()}Q=R+12|0;if((c[Q>>2]|0)!=(S|0)){hd()}P=t+8|0;if((c[P>>2]|0)==(S|0)){c[Q>>2]=t;c[P>>2]=R;sa=t;break}else{hd()}}}while(0);if((T|0)==0){break}t=c[fa+(ga+28+qa)>>2]|0;V=382584+(t<<2)|0;do{if((S|0)==(c[V>>2]|0)){c[V>>2]=sa;if((sa|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<t);break k}else{if(T>>>0<(c[382296>>2]|0)>>>0){hd()}L=T+16|0;if((c[L>>2]|0)==(S|0)){c[L>>2]=sa}else{c[T+20>>2]=sa}if((sa|0)==0){break k}}}while(0);if(sa>>>0<(c[382296>>2]|0)>>>0){hd()}c[sa+24>>2]=T;S=qa|16;t=c[fa+(S+ga)>>2]|0;do{if((t|0)!=0){if(t>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[sa+16>>2]=t;c[t+24>>2]=sa;break}}}while(0);t=c[fa+(ca+S)>>2]|0;if((t|0)==0){break}if(t>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[sa+20>>2]=t;c[t+24>>2]=sa;break}}}while(0);va=fa+((_|qa)+ga)|0;wa=_+X|0}else{va=ha;wa=X}ca=va+4|0;c[ca>>2]=c[ca>>2]&-2;c[fa+(da+4)>>2]=wa|1;c[fa+(wa+da)>>2]=wa;ca=wa>>>3;if(wa>>>0<256){Z=ca<<1;ea=382320+(Z<<2)|0;t=c[95570]|0;T=1<<ca;do{if((t&T|0)==0){c[95570]=t|T;xa=382320+(Z+2<<2)|0;ya=ea}else{ca=382320+(Z+2<<2)|0;V=c[ca>>2]|0;if(!(V>>>0<(c[382296>>2]|0)>>>0)){xa=ca;ya=V;break}hd()}}while(0);c[xa>>2]=M;c[ya+12>>2]=M;c[fa+(da+8)>>2]=ya;c[fa+(da+12)>>2]=ea;break}Z=ba;T=wa>>>8;do{if((T|0)==0){za=0}else{if(wa>>>0>16777215){za=31;break}t=(T+1048320|0)>>>16&8;_=T<<t;V=(_+520192|0)>>>16&4;ca=_<<V;_=(ca+245760|0)>>>16&2;L=14-(V|t|_)+(ca<<_>>>15)|0;za=wa>>>(L+7|0)&1|L<<1}}while(0);T=382584+(za<<2)|0;c[fa+(da+28)>>2]=za;c[fa+(da+20)>>2]=0;c[fa+(da+16)>>2]=0;ea=c[382284>>2]|0;L=1<<za;if((ea&L|0)==0){c[382284>>2]=ea|L;c[T>>2]=Z;c[fa+(da+24)>>2]=T;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break}L=c[T>>2]|0;if((za|0)==31){Aa=0}else{Aa=25-(za>>>1)|0}l:do{if((c[L+4>>2]&-8|0)==(wa|0)){Ba=L}else{T=wa<<Aa;ea=L;while(1){Ca=ea+16+(T>>>31<<2)|0;_=c[Ca>>2]|0;if((_|0)==0){break}if((c[_+4>>2]&-8|0)==(wa|0)){Ba=_;break l}else{T=T<<1;ea=_}}if(Ca>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[Ca>>2]=Z;c[fa+(da+24)>>2]=ea;c[fa+(da+12)>>2]=Z;c[fa+(da+8)>>2]=Z;break j}}}while(0);L=Ba+8|0;T=c[L>>2]|0;S=c[382296>>2]|0;if(Ba>>>0<S>>>0){hd()}if(T>>>0<S>>>0){hd()}else{c[T+12>>2]=Z;c[L>>2]=Z;c[fa+(da+8)>>2]=T;c[fa+(da+12)>>2]=Ba;c[fa+(da+24)>>2]=0;break}}}while(0);p=fa+(pa|8)|0;i=b;return p|0}}while(0);$=ia;da=382728|0;while(1){Da=c[da>>2]|0;if(!(Da>>>0>$>>>0)){Ea=c[da+4>>2]|0;Fa=Da+Ea|0;if(Fa>>>0>$>>>0){break}}da=c[da+8>>2]|0}da=Da+(Ea+ -39)|0;if((da&7|0)==0){Ga=0}else{Ga=0-da&7}da=Da+(Ea+ -47+Ga)|0;ba=da>>>0<(ia+16|0)>>>0?$:da;da=ba+8|0;M=da;X=fa+8|0;if((X&7|0)==0){Ha=0}else{Ha=0-X&7}X=ga+ -40-Ha|0;c[382304>>2]=fa+Ha;c[382292>>2]=X;c[fa+(Ha+4)>>2]=X|1;c[fa+(ga+ -36)>>2]=40;c[382308>>2]=c[382768>>2];c[ba+4>>2]=27;X=382728|0;c[da+0>>2]=c[X+0>>2];c[da+4>>2]=c[X+4>>2];c[da+8>>2]=c[X+8>>2];c[da+12>>2]=c[X+12>>2];c[382728>>2]=fa;c[382732>>2]=ga;c[382740>>2]=0;c[382736>>2]=M;M=ba+28|0;c[M>>2]=7;if((ba+32|0)>>>0<Fa>>>0){X=M;while(1){M=X+4|0;c[M>>2]=7;if((X+8|0)>>>0<Fa>>>0){X=M}else{break}}}if((ba|0)==($|0)){break}X=ba-ia|0;M=ia+(X+4)|0;c[M>>2]=c[M>>2]&-2;c[ia+4>>2]=X|1;c[ia+X>>2]=X;M=X>>>3;if(X>>>0<256){da=M<<1;ha=382320+(da<<2)|0;aa=c[95570]|0;f=1<<M;do{if((aa&f|0)==0){c[95570]=aa|f;Ia=382320+(da+2<<2)|0;Ja=ha}else{M=382320+(da+2<<2)|0;T=c[M>>2]|0;if(!(T>>>0<(c[382296>>2]|0)>>>0)){Ia=M;Ja=T;break}hd()}}while(0);c[Ia>>2]=ia;c[Ja+12>>2]=ia;c[ia+8>>2]=Ja;c[ia+12>>2]=ha;break}da=ia;f=X>>>8;do{if((f|0)==0){Ka=0}else{if(X>>>0>16777215){Ka=31;break}aa=(f+1048320|0)>>>16&8;ba=f<<aa;$=(ba+520192|0)>>>16&4;T=ba<<$;ba=(T+245760|0)>>>16&2;M=14-($|aa|ba)+(T<<ba>>>15)|0;Ka=X>>>(M+7|0)&1|M<<1}}while(0);f=382584+(Ka<<2)|0;c[ia+28>>2]=Ka;c[ia+20>>2]=0;c[ia+16>>2]=0;ha=c[382284>>2]|0;M=1<<Ka;if((ha&M|0)==0){c[382284>>2]=ha|M;c[f>>2]=da;c[ia+24>>2]=f;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break}M=c[f>>2]|0;if((Ka|0)==31){La=0}else{La=25-(Ka>>>1)|0}m:do{if((c[M+4>>2]&-8|0)==(X|0)){Ma=M}else{f=X<<La;ha=M;while(1){Na=ha+16+(f>>>31<<2)|0;ba=c[Na>>2]|0;if((ba|0)==0){break}if((c[ba+4>>2]&-8|0)==(X|0)){Ma=ba;break m}else{f=f<<1;ha=ba}}if(Na>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[Na>>2]=da;c[ia+24>>2]=ha;c[ia+12>>2]=ia;c[ia+8>>2]=ia;break i}}}while(0);X=Ma+8|0;M=c[X>>2]|0;f=c[382296>>2]|0;if(Ma>>>0<f>>>0){hd()}if(M>>>0<f>>>0){hd()}else{c[M+12>>2]=da;c[X>>2]=da;c[ia+8>>2]=M;c[ia+12>>2]=Ma;c[ia+24>>2]=0;break}}}while(0);ia=c[382292>>2]|0;if(!(ia>>>0>q>>>0)){break}W=ia-q|0;c[382292>>2]=W;ia=c[382304>>2]|0;c[382304>>2]=ia+q;c[ia+(q+4)>>2]=W|1;c[ia+4>>2]=q|3;p=ia+8|0;i=b;return p|0}}while(0);c[(Nc()|0)>>2]=12;p=0;i=b;return p|0}function i4c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;b=i;if((a|0)==0){i=b;return}d=a+ -8|0;e=d;f=c[382296>>2]|0;if(d>>>0<f>>>0){hd()}g=c[a+ -4>>2]|0;h=g&3;if((h|0)==1){hd()}j=g&-8;k=a+(j+ -8)|0;l=k;a:do{if((g&1|0)==0){m=c[d>>2]|0;if((h|0)==0){i=b;return}n=-8-m|0;o=a+n|0;p=o;q=m+j|0;if(o>>>0<f>>>0){hd()}if((p|0)==(c[382300>>2]|0)){r=a+(j+ -4)|0;if((c[r>>2]&3|0)!=3){s=p;t=q;break}c[382288>>2]=q;c[r>>2]=c[r>>2]&-2;c[a+(n+4)>>2]=q|1;c[k>>2]=q;i=b;return}r=m>>>3;if(m>>>0<256){m=c[a+(n+8)>>2]|0;u=c[a+(n+12)>>2]|0;v=382320+(r<<1<<2)|0;do{if((m|0)!=(v|0)){if(m>>>0<f>>>0){hd()}if((c[m+12>>2]|0)==(p|0)){break}hd()}}while(0);if((u|0)==(m|0)){c[95570]=c[95570]&~(1<<r);s=p;t=q;break}do{if((u|0)==(v|0)){w=u+8|0}else{if(u>>>0<f>>>0){hd()}x=u+8|0;if((c[x>>2]|0)==(p|0)){w=x;break}hd()}}while(0);c[m+12>>2]=u;c[w>>2]=m;s=p;t=q;break}v=o;r=c[a+(n+24)>>2]|0;x=c[a+(n+12)>>2]|0;do{if((x|0)==(v|0)){y=a+(n+20)|0;z=y;A=c[y>>2]|0;if((A|0)==0){y=a+(n+16)|0;B=c[y>>2]|0;if((B|0)==0){C=0;break}else{D=B;E=y}}else{D=A;E=z}while(1){z=D+20|0;A=c[z>>2]|0;if((A|0)!=0){E=z;D=A;continue}A=D+16|0;z=c[A>>2]|0;if((z|0)==0){break}else{D=z;E=A}}if(E>>>0<f>>>0){hd()}else{c[E>>2]=0;C=D;break}}else{A=c[a+(n+8)>>2]|0;if(A>>>0<f>>>0){hd()}z=A+12|0;if((c[z>>2]|0)!=(v|0)){hd()}y=x+8|0;if((c[y>>2]|0)==(v|0)){c[z>>2]=x;c[y>>2]=A;C=x;break}else{hd()}}}while(0);if((r|0)==0){s=p;t=q;break}x=c[a+(n+28)>>2]|0;o=382584+(x<<2)|0;do{if((v|0)==(c[o>>2]|0)){c[o>>2]=C;if((C|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<x);s=p;t=q;break a}else{if(r>>>0<(c[382296>>2]|0)>>>0){hd()}m=r+16|0;if((c[m>>2]|0)==(v|0)){c[m>>2]=C}else{c[r+20>>2]=C}if((C|0)==0){s=p;t=q;break a}}}while(0);if(C>>>0<(c[382296>>2]|0)>>>0){hd()}c[C+24>>2]=r;v=c[a+(n+16)>>2]|0;do{if((v|0)!=0){if(v>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[C+16>>2]=v;c[v+24>>2]=C;break}}}while(0);v=c[a+(n+20)>>2]|0;if((v|0)==0){s=p;t=q;break}if(v>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[C+20>>2]=v;c[v+24>>2]=C;s=p;t=q;break}}else{s=e;t=j}}while(0);if(!(s>>>0<k>>>0)){hd()}e=a+(j+ -4)|0;C=c[e>>2]|0;if((C&1|0)==0){hd()}do{if((C&2|0)==0){if((l|0)==(c[382304>>2]|0)){f=(c[382292>>2]|0)+t|0;c[382292>>2]=f;c[382304>>2]=s;c[s+4>>2]=f|1;if((s|0)!=(c[382300>>2]|0)){i=b;return}c[382300>>2]=0;c[382288>>2]=0;i=b;return}if((l|0)==(c[382300>>2]|0)){f=(c[382288>>2]|0)+t|0;c[382288>>2]=f;c[382300>>2]=s;c[s+4>>2]=f|1;c[s+f>>2]=f;i=b;return}f=(C&-8)+t|0;D=C>>>3;b:do{if(C>>>0<256){E=c[a+j>>2]|0;w=c[a+(j|4)>>2]|0;h=382320+(D<<1<<2)|0;do{if((E|0)!=(h|0)){if(E>>>0<(c[382296>>2]|0)>>>0){hd()}if((c[E+12>>2]|0)==(l|0)){break}hd()}}while(0);if((w|0)==(E|0)){c[95570]=c[95570]&~(1<<D);break}do{if((w|0)==(h|0)){F=w+8|0}else{if(w>>>0<(c[382296>>2]|0)>>>0){hd()}d=w+8|0;if((c[d>>2]|0)==(l|0)){F=d;break}hd()}}while(0);c[E+12>>2]=w;c[F>>2]=E}else{h=k;d=c[a+(j+16)>>2]|0;g=c[a+(j|4)>>2]|0;do{if((g|0)==(h|0)){v=a+(j+12)|0;r=v;x=c[v>>2]|0;if((x|0)==0){v=a+(j+8)|0;o=c[v>>2]|0;if((o|0)==0){G=0;break}else{H=o;I=v}}else{H=x;I=r}while(1){r=H+20|0;x=c[r>>2]|0;if((x|0)!=0){I=r;H=x;continue}x=H+16|0;r=c[x>>2]|0;if((r|0)==0){break}else{H=r;I=x}}if(I>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[I>>2]=0;G=H;break}}else{x=c[a+j>>2]|0;if(x>>>0<(c[382296>>2]|0)>>>0){hd()}r=x+12|0;if((c[r>>2]|0)!=(h|0)){hd()}v=g+8|0;if((c[v>>2]|0)==(h|0)){c[r>>2]=g;c[v>>2]=x;G=g;break}else{hd()}}}while(0);if((d|0)==0){break}g=c[a+(j+20)>>2]|0;E=382584+(g<<2)|0;do{if((h|0)==(c[E>>2]|0)){c[E>>2]=G;if((G|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<g);break b}else{if(d>>>0<(c[382296>>2]|0)>>>0){hd()}w=d+16|0;if((c[w>>2]|0)==(h|0)){c[w>>2]=G}else{c[d+20>>2]=G}if((G|0)==0){break b}}}while(0);if(G>>>0<(c[382296>>2]|0)>>>0){hd()}c[G+24>>2]=d;h=c[a+(j+8)>>2]|0;do{if((h|0)!=0){if(h>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[G+16>>2]=h;c[h+24>>2]=G;break}}}while(0);h=c[a+(j+12)>>2]|0;if((h|0)==0){break}if(h>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[G+20>>2]=h;c[h+24>>2]=G;break}}}while(0);c[s+4>>2]=f|1;c[s+f>>2]=f;if((s|0)!=(c[382300>>2]|0)){J=f;break}c[382288>>2]=f;i=b;return}else{c[e>>2]=C&-2;c[s+4>>2]=t|1;c[s+t>>2]=t;J=t}}while(0);t=J>>>3;if(J>>>0<256){C=t<<1;e=382320+(C<<2)|0;G=c[95570]|0;j=1<<t;do{if((G&j|0)==0){c[95570]=G|j;K=382320+(C+2<<2)|0;L=e}else{t=382320+(C+2<<2)|0;a=c[t>>2]|0;if(!(a>>>0<(c[382296>>2]|0)>>>0)){K=t;L=a;break}hd()}}while(0);c[K>>2]=s;c[L+12>>2]=s;c[s+8>>2]=L;c[s+12>>2]=e;i=b;return}e=s;L=J>>>8;do{if((L|0)==0){M=0}else{if(J>>>0>16777215){M=31;break}K=(L+1048320|0)>>>16&8;C=L<<K;j=(C+520192|0)>>>16&4;G=C<<j;C=(G+245760|0)>>>16&2;a=14-(j|K|C)+(G<<C>>>15)|0;M=J>>>(a+7|0)&1|a<<1}}while(0);L=382584+(M<<2)|0;c[s+28>>2]=M;c[s+20>>2]=0;c[s+16>>2]=0;a=c[382284>>2]|0;C=1<<M;c:do{if((a&C|0)==0){c[382284>>2]=a|C;c[L>>2]=e;c[s+24>>2]=L;c[s+12>>2]=s;c[s+8>>2]=s}else{G=c[L>>2]|0;if((M|0)==31){N=0}else{N=25-(M>>>1)|0}d:do{if((c[G+4>>2]&-8|0)==(J|0)){O=G}else{K=J<<N;j=G;while(1){P=j+16+(K>>>31<<2)|0;t=c[P>>2]|0;if((t|0)==0){break}if((c[t+4>>2]&-8|0)==(J|0)){O=t;break d}else{K=K<<1;j=t}}if(P>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[P>>2]=e;c[s+24>>2]=j;c[s+12>>2]=s;c[s+8>>2]=s;break c}}}while(0);G=O+8|0;f=c[G>>2]|0;K=c[382296>>2]|0;if(O>>>0<K>>>0){hd()}if(f>>>0<K>>>0){hd()}else{c[f+12>>2]=e;c[G>>2]=e;c[s+8>>2]=f;c[s+12>>2]=O;c[s+24>>2]=0;break}}}while(0);s=(c[382312>>2]|0)+ -1|0;c[382312>>2]=s;if((s|0)==0){Q=382736|0}else{i=b;return}while(1){s=c[Q>>2]|0;if((s|0)==0){break}else{Q=s+8|0}}c[382312>>2]=-1;i=b;return}function j4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;do{if((a|0)==0){e=0}else{f=fa(b,a)|0;if(!((b|a)>>>0>65535)){e=f;break}e=((f>>>0)/(a>>>0)|0|0)==(b|0)?f:-1}}while(0);b=h4c(e)|0;if((b|0)==0){i=d;return b|0}if((c[b+ -4>>2]&3|0)==0){i=d;return b|0}P4c(b|0,0,e|0)|0;i=d;return b|0}function k4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;if((a|0)==0){e=h4c(b)|0;i=d;return e|0}if(b>>>0>4294967231){c[(Nc()|0)>>2]=12;e=0;i=d;return e|0}if(b>>>0<11){f=16}else{f=b+11&-8}g=l4c(a+ -8|0,f)|0;if((g|0)!=0){e=g+8|0;i=d;return e|0}g=h4c(b)|0;if((g|0)==0){e=0;i=d;return e|0}f=c[a+ -4>>2]|0;h=(f&-8)-((f&3|0)==0?8:4)|0;N4c(g|0,a|0,(h>>>0<b>>>0?h:b)|0)|0;i4c(a);e=g;i=d;return e|0}function l4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0;d=i;e=a+4|0;f=c[e>>2]|0;g=f&-8;h=a;j=a+g|0;k=j;l=c[382296>>2]|0;if(h>>>0<l>>>0){hd()}m=f&3;if(!((m|0)!=1&h>>>0<j>>>0)){hd()}h=a+(g|4)|0;n=c[h>>2]|0;if((n&1|0)==0){hd()}if((m|0)==0){if(b>>>0<256){o=0;i=d;return o|0}do{if(!(g>>>0<(b+4|0)>>>0)){if((g-b|0)>>>0>c[382760>>2]<<1>>>0){break}else{o=a}i=d;return o|0}}while(0);o=0;i=d;return o|0}if(!(g>>>0<b>>>0)){m=g-b|0;if(!(m>>>0>15)){o=a;i=d;return o|0}c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|3;c[h>>2]=c[h>>2]|1;m4c(a+b|0,m);o=a;i=d;return o|0}if((k|0)==(c[382304>>2]|0)){m=(c[382292>>2]|0)+g|0;if(!(m>>>0>b>>>0)){o=0;i=d;return o|0}h=m-b|0;c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=h|1;c[382304>>2]=a+b;c[382292>>2]=h;o=a;i=d;return o|0}if((k|0)==(c[382300>>2]|0)){h=(c[382288>>2]|0)+g|0;if(h>>>0<b>>>0){o=0;i=d;return o|0}m=h-b|0;if(m>>>0>15){c[e>>2]=f&1|b|2;c[a+(b+4)>>2]=m|1;c[a+h>>2]=m;p=a+(h+4)|0;c[p>>2]=c[p>>2]&-2;q=a+b|0;r=m}else{c[e>>2]=f&1|h|2;f=a+(h+4)|0;c[f>>2]=c[f>>2]|1;q=0;r=0}c[382288>>2]=r;c[382300>>2]=q;o=a;i=d;return o|0}if((n&2|0)!=0){o=0;i=d;return o|0}q=(n&-8)+g|0;if(q>>>0<b>>>0){o=0;i=d;return o|0}r=q-b|0;f=n>>>3;a:do{if(n>>>0<256){h=c[a+(g+8)>>2]|0;m=c[a+(g+12)>>2]|0;p=382320+(f<<1<<2)|0;do{if((h|0)!=(p|0)){if(h>>>0<l>>>0){hd()}if((c[h+12>>2]|0)==(k|0)){break}hd()}}while(0);if((m|0)==(h|0)){c[95570]=c[95570]&~(1<<f);break}do{if((m|0)==(p|0)){s=m+8|0}else{if(m>>>0<l>>>0){hd()}t=m+8|0;if((c[t>>2]|0)==(k|0)){s=t;break}hd()}}while(0);c[h+12>>2]=m;c[s>>2]=h}else{p=j;t=c[a+(g+24)>>2]|0;u=c[a+(g+12)>>2]|0;do{if((u|0)==(p|0)){v=a+(g+20)|0;w=v;x=c[v>>2]|0;if((x|0)==0){v=a+(g+16)|0;y=c[v>>2]|0;if((y|0)==0){z=0;break}else{A=y;B=v}}else{A=x;B=w}while(1){w=A+20|0;x=c[w>>2]|0;if((x|0)!=0){B=w;A=x;continue}x=A+16|0;w=c[x>>2]|0;if((w|0)==0){break}else{A=w;B=x}}if(B>>>0<l>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{x=c[a+(g+8)>>2]|0;if(x>>>0<l>>>0){hd()}w=x+12|0;if((c[w>>2]|0)!=(p|0)){hd()}v=u+8|0;if((c[v>>2]|0)==(p|0)){c[w>>2]=u;c[v>>2]=x;z=u;break}else{hd()}}}while(0);if((t|0)==0){break}u=c[a+(g+28)>>2]|0;h=382584+(u<<2)|0;do{if((p|0)==(c[h>>2]|0)){c[h>>2]=z;if((z|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<u);break a}else{if(t>>>0<(c[382296>>2]|0)>>>0){hd()}m=t+16|0;if((c[m>>2]|0)==(p|0)){c[m>>2]=z}else{c[t+20>>2]=z}if((z|0)==0){break a}}}while(0);if(z>>>0<(c[382296>>2]|0)>>>0){hd()}c[z+24>>2]=t;p=c[a+(g+16)>>2]|0;do{if((p|0)!=0){if(p>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[z+16>>2]=p;c[p+24>>2]=z;break}}}while(0);p=c[a+(g+20)>>2]|0;if((p|0)==0){break}if(p>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[z+20>>2]=p;c[p+24>>2]=z;break}}}while(0);if(r>>>0<16){c[e>>2]=q|c[e>>2]&1|2;z=a+(q|4)|0;c[z>>2]=c[z>>2]|1;o=a;i=d;return o|0}else{c[e>>2]=c[e>>2]&1|b|2;c[a+(b+4)>>2]=r|3;e=a+(q|4)|0;c[e>>2]=c[e>>2]|1;m4c(a+b|0,r);o=a;i=d;return o|0}return 0}function m4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;d=i;e=a+b|0;f=e;g=c[a+4>>2]|0;a:do{if((g&1|0)==0){h=c[a>>2]|0;if((g&3|0)==0){i=d;return}j=a+(0-h)|0;k=j;l=h+b|0;m=c[382296>>2]|0;if(j>>>0<m>>>0){hd()}if((k|0)==(c[382300>>2]|0)){n=a+(b+4)|0;if((c[n>>2]&3|0)!=3){o=k;p=l;break}c[382288>>2]=l;c[n>>2]=c[n>>2]&-2;c[a+(4-h)>>2]=l|1;c[e>>2]=l;i=d;return}n=h>>>3;if(h>>>0<256){q=c[a+(8-h)>>2]|0;r=c[a+(12-h)>>2]|0;s=382320+(n<<1<<2)|0;do{if((q|0)!=(s|0)){if(q>>>0<m>>>0){hd()}if((c[q+12>>2]|0)==(k|0)){break}hd()}}while(0);if((r|0)==(q|0)){c[95570]=c[95570]&~(1<<n);o=k;p=l;break}do{if((r|0)==(s|0)){t=r+8|0}else{if(r>>>0<m>>>0){hd()}u=r+8|0;if((c[u>>2]|0)==(k|0)){t=u;break}hd()}}while(0);c[q+12>>2]=r;c[t>>2]=q;o=k;p=l;break}s=j;n=c[a+(24-h)>>2]|0;u=c[a+(12-h)>>2]|0;do{if((u|0)==(s|0)){v=16-h|0;w=a+(v+4)|0;x=w;y=c[w>>2]|0;if((y|0)==0){w=a+v|0;v=c[w>>2]|0;if((v|0)==0){z=0;break}else{A=v;B=w}}else{A=y;B=x}while(1){x=A+20|0;y=c[x>>2]|0;if((y|0)!=0){B=x;A=y;continue}y=A+16|0;x=c[y>>2]|0;if((x|0)==0){break}else{A=x;B=y}}if(B>>>0<m>>>0){hd()}else{c[B>>2]=0;z=A;break}}else{y=c[a+(8-h)>>2]|0;if(y>>>0<m>>>0){hd()}x=y+12|0;if((c[x>>2]|0)!=(s|0)){hd()}w=u+8|0;if((c[w>>2]|0)==(s|0)){c[x>>2]=u;c[w>>2]=y;z=u;break}else{hd()}}}while(0);if((n|0)==0){o=k;p=l;break}u=c[a+(28-h)>>2]|0;m=382584+(u<<2)|0;do{if((s|0)==(c[m>>2]|0)){c[m>>2]=z;if((z|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<u);o=k;p=l;break a}else{if(n>>>0<(c[382296>>2]|0)>>>0){hd()}j=n+16|0;if((c[j>>2]|0)==(s|0)){c[j>>2]=z}else{c[n+20>>2]=z}if((z|0)==0){o=k;p=l;break a}}}while(0);if(z>>>0<(c[382296>>2]|0)>>>0){hd()}c[z+24>>2]=n;s=16-h|0;u=c[a+s>>2]|0;do{if((u|0)!=0){if(u>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[z+16>>2]=u;c[u+24>>2]=z;break}}}while(0);u=c[a+(s+4)>>2]|0;if((u|0)==0){o=k;p=l;break}if(u>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[z+20>>2]=u;c[u+24>>2]=z;o=k;p=l;break}}else{o=a;p=b}}while(0);z=c[382296>>2]|0;if(e>>>0<z>>>0){hd()}A=a+(b+4)|0;B=c[A>>2]|0;do{if((B&2|0)==0){if((f|0)==(c[382304>>2]|0)){t=(c[382292>>2]|0)+p|0;c[382292>>2]=t;c[382304>>2]=o;c[o+4>>2]=t|1;if((o|0)!=(c[382300>>2]|0)){i=d;return}c[382300>>2]=0;c[382288>>2]=0;i=d;return}if((f|0)==(c[382300>>2]|0)){t=(c[382288>>2]|0)+p|0;c[382288>>2]=t;c[382300>>2]=o;c[o+4>>2]=t|1;c[o+t>>2]=t;i=d;return}t=(B&-8)+p|0;g=B>>>3;b:do{if(B>>>0<256){u=c[a+(b+8)>>2]|0;h=c[a+(b+12)>>2]|0;n=382320+(g<<1<<2)|0;do{if((u|0)!=(n|0)){if(u>>>0<z>>>0){hd()}if((c[u+12>>2]|0)==(f|0)){break}hd()}}while(0);if((h|0)==(u|0)){c[95570]=c[95570]&~(1<<g);break}do{if((h|0)==(n|0)){C=h+8|0}else{if(h>>>0<z>>>0){hd()}m=h+8|0;if((c[m>>2]|0)==(f|0)){C=m;break}hd()}}while(0);c[u+12>>2]=h;c[C>>2]=u}else{n=e;m=c[a+(b+24)>>2]|0;j=c[a+(b+12)>>2]|0;do{if((j|0)==(n|0)){q=a+(b+20)|0;r=q;y=c[q>>2]|0;if((y|0)==0){q=a+(b+16)|0;w=c[q>>2]|0;if((w|0)==0){D=0;break}else{E=w;F=q}}else{E=y;F=r}while(1){r=E+20|0;y=c[r>>2]|0;if((y|0)!=0){F=r;E=y;continue}y=E+16|0;r=c[y>>2]|0;if((r|0)==0){break}else{E=r;F=y}}if(F>>>0<z>>>0){hd()}else{c[F>>2]=0;D=E;break}}else{y=c[a+(b+8)>>2]|0;if(y>>>0<z>>>0){hd()}r=y+12|0;if((c[r>>2]|0)!=(n|0)){hd()}q=j+8|0;if((c[q>>2]|0)==(n|0)){c[r>>2]=j;c[q>>2]=y;D=j;break}else{hd()}}}while(0);if((m|0)==0){break}j=c[a+(b+28)>>2]|0;u=382584+(j<<2)|0;do{if((n|0)==(c[u>>2]|0)){c[u>>2]=D;if((D|0)!=0){break}c[382284>>2]=c[382284>>2]&~(1<<j);break b}else{if(m>>>0<(c[382296>>2]|0)>>>0){hd()}h=m+16|0;if((c[h>>2]|0)==(n|0)){c[h>>2]=D}else{c[m+20>>2]=D}if((D|0)==0){break b}}}while(0);if(D>>>0<(c[382296>>2]|0)>>>0){hd()}c[D+24>>2]=m;n=c[a+(b+16)>>2]|0;do{if((n|0)!=0){if(n>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[D+16>>2]=n;c[n+24>>2]=D;break}}}while(0);n=c[a+(b+20)>>2]|0;if((n|0)==0){break}if(n>>>0<(c[382296>>2]|0)>>>0){hd()}else{c[D+20>>2]=n;c[n+24>>2]=D;break}}}while(0);c[o+4>>2]=t|1;c[o+t>>2]=t;if((o|0)!=(c[382300>>2]|0)){G=t;break}c[382288>>2]=t;i=d;return}else{c[A>>2]=B&-2;c[o+4>>2]=p|1;c[o+p>>2]=p;G=p}}while(0);p=G>>>3;if(G>>>0<256){B=p<<1;A=382320+(B<<2)|0;D=c[95570]|0;b=1<<p;do{if((D&b|0)==0){c[95570]=D|b;H=382320+(B+2<<2)|0;I=A}else{p=382320+(B+2<<2)|0;a=c[p>>2]|0;if(!(a>>>0<(c[382296>>2]|0)>>>0)){H=p;I=a;break}hd()}}while(0);c[H>>2]=o;c[I+12>>2]=o;c[o+8>>2]=I;c[o+12>>2]=A;i=d;return}A=o;I=G>>>8;do{if((I|0)==0){J=0}else{if(G>>>0>16777215){J=31;break}H=(I+1048320|0)>>>16&8;B=I<<H;b=(B+520192|0)>>>16&4;D=B<<b;B=(D+245760|0)>>>16&2;a=14-(b|H|B)+(D<<B>>>15)|0;J=G>>>(a+7|0)&1|a<<1}}while(0);I=382584+(J<<2)|0;c[o+28>>2]=J;c[o+20>>2]=0;c[o+16>>2]=0;a=c[382284>>2]|0;B=1<<J;if((a&B|0)==0){c[382284>>2]=a|B;c[I>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}B=c[I>>2]|0;if((J|0)==31){K=0}else{K=25-(J>>>1)|0}c:do{if((c[B+4>>2]&-8|0)==(G|0)){L=B}else{J=G<<K;I=B;while(1){M=I+16+(J>>>31<<2)|0;a=c[M>>2]|0;if((a|0)==0){break}if((c[a+4>>2]&-8|0)==(G|0)){L=a;break c}else{J=J<<1;I=a}}if(M>>>0<(c[382296>>2]|0)>>>0){hd()}c[M>>2]=A;c[o+24>>2]=I;c[o+12>>2]=o;c[o+8>>2]=o;i=d;return}}while(0);M=L+8|0;G=c[M>>2]|0;B=c[382296>>2]|0;if(L>>>0<B>>>0){hd()}if(G>>>0<B>>>0){hd()}c[G+12>>2]=A;c[M>>2]=A;c[o+8>>2]=G;c[o+12>>2]=L;c[o+24>>2]=0;i=d;return}function n4c(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=(a|0)==0?1:a;while(1){e=h4c(d)|0;if((e|0)!=0){f=6;break}a=c[95694]|0;c[95694]=0+a;if((a|0)==0){f=5;break}Fe[a&7]()}if((f|0)==5){d=Ec(4)|0;c[d>>2]=382792;Td(d|0,382840,135)}else if((f|0)==6){i=b;return e|0}return 0}function o4c(a){a=a|0;var b=0,c=0;b=i;c=n4c(a)|0;i=b;return c|0}function p4c(a){a=a|0;var b=0;b=i;if((a|0)!=0){i4c(a)}i=b;return}function q4c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function r4c(a){a=a|0;var b=0;b=i;zb(a|0);p4c(a);i=b;return}function s4c(a){a=a|0;var b=0;b=i;zb(a|0);i=b;return}function t4c(a){a=a|0;i=i;return 382808}function u4c(){var a=0;a=Ec(4)|0;c[a>>2]=382792;Td(a|0,382840,135)}function v4c(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,ga=0.0,ha=0,ia=0.0,ja=0,ka=0.0,la=0.0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0,xa=0,ya=0,za=0,Aa=0.0,Ba=0,Ca=0.0,Da=0.0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0.0,tc=0,uc=0,vc=0.0,wc=0.0,xc=0.0,yc=0.0,Ac=0.0,Bc=0.0,Cc=0,Dc=0,Ec=0.0,Fc=0,Gc=0.0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0;g=i;i=i+512|0;h=g;if((e|0)==1){j=53;k=-1074}else if((e|0)==2){j=53;k=-1074}else if((e|0)==0){j=24;k=-149}else{l=0.0;i=g;return+l}e=b+4|0;m=b+100|0;do{n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;o=d[n]|0}else{o=y4c(b)|0}}while((jd(o|0)|0)!=0);do{if((o|0)==43|(o|0)==45){n=1-(((o|0)==45)<<1)|0;p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;q=d[p]|0;r=n;break}else{q=y4c(b)|0;r=n;break}}else{q=o;r=1}}while(0);o=q;q=0;while(1){if((o|32|0)!=(a[382856+q|0]|0)){s=o;t=q;break}do{if(q>>>0<7){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;u=d[n]|0;break}else{u=y4c(b)|0;break}}else{u=o}}while(0);n=q+1|0;if(n>>>0<8){o=u;q=n}else{s=u;t=n;break}}do{if((t|0)==3){v=23}else if((t|0)!=8){u=(f|0)==0;if(!(t>>>0<4|u)){if((t|0)==8){break}else{v=23;break}}a:do{if((t|0)==0){q=s;o=0;while(1){if((q|32|0)!=(a[382872+o|0]|0)){w=q;x=o;break a}do{if(o>>>0<2){n=c[e>>2]|0;if(n>>>0<(c[m>>2]|0)>>>0){c[e>>2]=n+1;A=d[n]|0;break}else{A=y4c(b)|0;break}}else{A=q}}while(0);n=o+1|0;if(n>>>0<3){q=A;o=n}else{w=A;x=n;break}}}else{w=s;x=t}}while(0);if((x|0)==0){do{if((w|0)==48){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;B=d[o]|0}else{B=y4c(b)|0}if((B|32|0)!=120){if((c[m>>2]|0)==0){C=48;break}c[e>>2]=(c[e>>2]|0)+ -1;C=48;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=0}else{D=y4c(b)|0;E=0}while(1){if((D|0)==46){v=70;break}else if((D|0)!=48){F=0;G=0;H=0;I=0;K=D;L=E;M=0;N=0;O=1.0;P=0;Q=0.0;break}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;D=d[o]|0;E=1;continue}else{D=y4c(b)|0;E=1;continue}}b:do{if((v|0)==70){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;R=d[o]|0}else{R=y4c(b)|0}if((R|0)==48){S=-1;T=-1}else{F=0;G=0;H=0;I=0;K=R;L=E;M=1;N=0;O=1.0;P=0;Q=0.0;break}while(1){o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;V=d[o]|0}else{V=y4c(b)|0}if((V|0)!=48){F=S;G=T;H=0;I=0;K=V;L=1;M=1;N=0;O=1.0;P=0;Q=0.0;break b}o=V4c(S|0,T|0,-1,-1)|0;S=o;T=J}}}while(0);c:while(1){o=K+ -48|0;do{if(o>>>0<10){W=o;v=84}else{q=K|32;n=(K|0)==46;if(!((q+ -97|0)>>>0<6|n)){X=K;break c}if(n){if((M|0)==0){Y=H;Z=I;_=H;$=I;aa=L;ba=1;ca=N;da=O;ea=P;ga=Q;break}else{X=46;break c}}else{W=(K|0)>57?q+ -87|0:o;v=84;break}}}while(0);if((v|0)==84){v=0;do{if((I|0)<0|(I|0)==0&H>>>0<8){ha=N;ia=O;ja=W+(P<<4)|0;ka=Q}else{if((I|0)<0|(I|0)==0&H>>>0<14){la=O*.0625;ha=N;ia=la;ja=P;ka=Q+la*+(W|0);break}if(!((W|0)!=0&(N|0)==0)){ha=N;ia=O;ja=P;ka=Q;break}ha=1;ia=O;ja=P;ka=Q+O*.5}}while(0);o=V4c(H|0,I|0,1,0)|0;Y=F;Z=G;_=o;$=J;aa=1;ba=M;ca=ha;da=ia;ea=ja;ga=ka}o=c[e>>2]|0;if(o>>>0<(c[m>>2]|0)>>>0){c[e>>2]=o+1;F=Y;G=Z;H=_;I=$;K=d[o]|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}else{F=Y;G=Z;H=_;I=$;K=y4c(b)|0;L=aa;M=ba;N=ca;O=da;P=ea;Q=ga;continue}}if((L|0)==0){o=(c[m>>2]|0)==0;if(!o){c[e>>2]=(c[e>>2]|0)+ -1}do{if(u){x4c(b,0)}else{if(o){break}q=c[e>>2]|0;c[e>>2]=q+ -1;if((M|0)==0){break}c[e>>2]=q+ -2}}while(0);l=+(r|0)*0.0;i=g;return+l}o=(M|0)==0;q=o?H:F;n=o?I:G;if((I|0)<0|(I|0)==0&H>>>0<8){o=H;p=I;ma=P;while(1){na=ma<<4;oa=V4c(o|0,p|0,1,0)|0;pa=J;if((pa|0)<0|(pa|0)==0&oa>>>0<8){ma=na;p=pa;o=oa}else{qa=na;break}}}else{qa=P}do{if((X|32|0)==112){o=w4c(b,f)|0;p=J;if(!((o|0)==0&(p|0)==-2147483648)){ra=o;sa=p;break}if(u){x4c(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0;break}}else{if((c[m>>2]|0)==0){ra=0;sa=0;break}c[e>>2]=(c[e>>2]|0)+ -1;ra=0;sa=0}}while(0);p=Q4c(q|0,n|0,2)|0;o=V4c(p|0,J|0,-32,-1)|0;p=V4c(o|0,J|0,ra|0,sa|0)|0;o=J;if((qa|0)==0){l=+(r|0)*0.0;i=g;return+l}if((o|0)>0|(o|0)==0&p>>>0>(0-k|0)>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}ma=k+ -106|0;na=((ma|0)<0)<<31>>31;if((o|0)<(na|0)|(o|0)==(na|0)&p>>>0<ma>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((qa|0)>-1){ma=p;na=o;oa=qa;la=Q;while(1){pa=oa<<1;if(!(la>=.5)){ta=la;ua=pa}else{ta=la+-1.0;ua=pa|1}va=la+ta;pa=V4c(ma|0,na|0,-1,-1)|0;wa=J;if((ua|0)>-1){ma=pa;na=wa;oa=ua;la=va}else{xa=pa;ya=wa;za=ua;Aa=va;break}}}else{xa=p;ya=o;za=qa;Aa=Q}oa=U4c(32,0,k|0,((k|0)<0)<<31>>31|0)|0;na=V4c(xa|0,ya|0,oa|0,J|0)|0;oa=J;if(0>(oa|0)|0==(oa|0)&j>>>0>na>>>0){Ba=(na|0)<0?0:na}else{Ba=j}do{if((Ba|0)<53){la=+(r|0);va=+Rd(+(+z4c(1.0,84-Ba|0)),+la);if(!((Ba|0)<32&Aa!=0.0)){Ca=la;Da=va;Ea=za;Fa=Aa;break}na=za&1;Ca=la;Da=va;Ea=(na^1)+za|0;Fa=(na|0)==0?0.0:Aa}else{Ca=+(r|0);Da=0.0;Ea=za;Fa=Aa}}while(0);va=Ca*Fa+(Da+Ca*+(Ea>>>0))-Da;if(!(va!=0.0)){c[(Nc()|0)>>2]=34}l=+A4c(va,xa);i=g;return+l}else{C=w}}while(0);o=k+j|0;p=0-o|0;na=C;oa=0;while(1){if((na|0)==46){v=139;break}else if((na|0)!=48){Ga=na;Ha=0;Ia=0;Ja=oa;Ka=0;break}ma=c[e>>2]|0;if(ma>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ma+1;na=d[ma]|0;oa=1;continue}else{na=y4c(b)|0;oa=1;continue}}d:do{if((v|0)==139){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;La=d[na]|0}else{La=y4c(b)|0}if((La|0)==48){Ma=-1;Na=-1}else{Ga=La;Ha=0;Ia=0;Ja=oa;Ka=1;break}while(1){na=c[e>>2]|0;if(na>>>0<(c[m>>2]|0)>>>0){c[e>>2]=na+1;Oa=d[na]|0}else{Oa=y4c(b)|0}if((Oa|0)!=48){Ga=Oa;Ha=Ma;Ia=Na;Ja=1;Ka=1;break d}na=V4c(Ma|0,Na|0,-1,-1)|0;Ma=na;Na=J}}}while(0);oa=h;c[oa>>2]=0;na=Ga+ -48|0;ma=(Ga|0)==46;e:do{if(na>>>0<10|ma){n=h+496|0;q=Ga;wa=ma;pa=na;Pa=0;Qa=0;Ra=Ha;Sa=Ia;Ta=Ja;Ua=Ka;Va=0;Wa=0;Xa=0;while(1){do{if(wa){if((Ua|0)==0){Ya=Pa;Za=Qa;_a=Pa;$a=Qa;ab=Ta;bb=1;cb=Va;db=Wa;eb=Xa}else{fb=q;gb=Pa;hb=Qa;ib=Ra;jb=Sa;kb=Ta;lb=Va;mb=Wa;nb=Xa;break e}}else{ob=V4c(Pa|0,Qa|0,1,0)|0;pb=J;qb=(q|0)!=48;if((Wa|0)>=125){if(!qb){Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}c[n>>2]=c[n>>2]|1;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=Ta;bb=Ua;cb=Va;db=Wa;eb=Xa;break}rb=h+(Wa<<2)|0;if((Va|0)==0){sb=pa}else{sb=q+ -48+((c[rb>>2]|0)*10|0)|0}c[rb>>2]=sb;rb=Va+1|0;tb=(rb|0)==9;Ya=Ra;Za=Sa;_a=ob;$a=pb;ab=1;bb=Ua;cb=tb?0:rb;db=(tb&1)+Wa|0;eb=qb?ob:Xa}}while(0);ob=c[e>>2]|0;if(ob>>>0<(c[m>>2]|0)>>>0){c[e>>2]=ob+1;ub=d[ob]|0}else{ub=y4c(b)|0}ob=ub+ -48|0;qb=(ub|0)==46;if(ob>>>0<10|qb){q=ub;wa=qb;pa=ob;Pa=_a;Qa=$a;Ra=Ya;Sa=Za;Ta=ab;Ua=bb;Va=cb;Wa=db;Xa=eb}else{vb=ub;wb=_a;xb=$a;yb=Ya;zb=Za;Ab=ab;Bb=bb;Cb=cb;Db=db;Eb=eb;v=162;break}}}else{vb=Ga;wb=0;xb=0;yb=Ha;zb=Ia;Ab=Ja;Bb=Ka;Cb=0;Db=0;Eb=0;v=162}}while(0);if((v|0)==162){na=(Bb|0)==0;fb=vb;gb=wb;hb=xb;ib=na?wb:yb;jb=na?xb:zb;kb=Ab;lb=Cb;mb=Db;nb=Eb}na=(kb|0)!=0;do{if(na){if((fb|32|0)!=101){v=171;break}ma=w4c(b,f)|0;Xa=J;do{if((ma|0)==0&(Xa|0)==-2147483648){if(u){x4c(b,0);l=0.0;i=g;return+l}else{if((c[m>>2]|0)==0){Fb=0;Gb=0;break}c[e>>2]=(c[e>>2]|0)+ -1;Fb=0;Gb=0;break}}else{Fb=ma;Gb=Xa}}while(0);Xa=V4c(Fb|0,Gb|0,ib|0,jb|0)|0;Hb=Xa;Ib=J}else{v=171}}while(0);do{if((v|0)==171){if(!((fb|0)>-1)){Hb=ib;Ib=jb;break}if((c[m>>2]|0)==0){Hb=ib;Ib=jb;break}c[e>>2]=(c[e>>2]|0)+ -1;Hb=ib;Ib=jb}}while(0);if(!na){c[(Nc()|0)>>2]=22;x4c(b,0);l=0.0;i=g;return+l}Xa=c[oa>>2]|0;if((Xa|0)==0){l=+(r|0)*0.0;i=g;return+l}do{if((Hb|0)==(gb|0)&(Ib|0)==(hb|0)&((hb|0)<0|(hb|0)==0&gb>>>0<10)){if(!(j>>>0>30)){if((Xa>>>j|0)!=0){break}}l=+(r|0)*+(Xa>>>0);i=g;return+l}}while(0);Xa=(k|0)/-2|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)>(na|0)|(Ib|0)==(na|0)&Hb>>>0>Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.7976931348623157e+308*1.7976931348623157e+308;i=g;return+l}Xa=k+ -106|0;na=((Xa|0)<0)<<31>>31;if((Ib|0)<(na|0)|(Ib|0)==(na|0)&Hb>>>0<Xa>>>0){c[(Nc()|0)>>2]=34;l=+(r|0)*1.2882297539194267e-231*1.2882297539194267e-231;i=g;return+l}if((lb|0)==0){Jb=mb}else{if((lb|0)<9){Xa=h+(mb<<2)|0;na=c[Xa>>2]|0;ma=lb;do{na=na*10|0;ma=ma+1|0;}while((ma|0)<9);c[Xa>>2]=na}Jb=mb+1|0}do{if((nb|0)<9){if(!((nb|0)<=(Hb|0)&(Hb|0)<18)){break}if((Hb|0)==9){l=+(r|0)*+((c[oa>>2]|0)>>>0);i=g;return+l}if((Hb|0)<9){l=+(r|0)*+((c[oa>>2]|0)>>>0)/+(c[382888+(8-Hb<<2)>>2]|0);i=g;return+l}ma=j+27+(fa(Hb,-3)|0)|0;Wa=c[oa>>2]|0;if((ma|0)<=30){if((Wa>>>ma|0)!=0){break}}l=+(r|0)*+(Wa>>>0)*+(c[382888+(Hb+ -10<<2)>>2]|0);i=g;return+l}}while(0);oa=(Hb|0)%9|0;if((oa|0)==0){Kb=0;Lb=0;Mb=Hb;Nb=Jb}else{na=(Hb|0)>-1?oa:oa+9|0;oa=c[382888+(8-na<<2)>>2]|0;do{if((Jb|0)==0){Ob=0;Pb=Hb;Qb=0}else{Xa=1e9/(oa|0)|0;Wa=0;ma=0;Va=0;Ua=Hb;while(1){Ta=h+(Va<<2)|0;Sa=c[Ta>>2]|0;Ra=((Sa>>>0)/(oa>>>0)|0)+ma|0;c[Ta>>2]=Ra;Rb=fa((Sa>>>0)%(oa>>>0)|0,Xa)|0;Sa=Va+1|0;if((Va|0)==(Wa|0)&(Ra|0)==0){Sb=Sa&127;Tb=Ua+ -9|0}else{Sb=Wa;Tb=Ua}if((Sa|0)==(Jb|0)){break}else{Wa=Sb;Ua=Tb;Va=Sa;ma=Rb}}if((Rb|0)==0){Ob=Sb;Pb=Tb;Qb=Jb;break}c[h+(Jb<<2)>>2]=Rb;Ob=Sb;Pb=Tb;Qb=Jb+1|0}}while(0);Kb=Ob;Lb=0;Mb=9-na+Pb|0;Nb=Qb}f:while(1){oa=h+(Kb<<2)|0;if((Mb|0)<18){ma=Lb;Va=Nb;while(1){Ua=0;Wa=Va+127|0;Xa=Va;while(1){Sa=Wa&127;Ra=h+(Sa<<2)|0;Ta=Q4c(c[Ra>>2]|0,0,29)|0;Qa=V4c(Ta|0,J|0,Ua|0,0)|0;Ta=J;if(Ta>>>0>0|(Ta|0)==0&Qa>>>0>1e9){Pa=d5c(Qa|0,Ta|0,1e9,0)|0;pa=e5c(Qa|0,Ta|0,1e9,0)|0;Ub=pa;Vb=Pa}else{Ub=Qa;Vb=0}c[Ra>>2]=Ub;Ra=(Sa|0)==(Kb|0);if((Sa|0)!=(Xa+127&127|0)|Ra){Wb=Xa}else{Wb=(Ub|0)==0?Sa:Xa}if(Ra){break}else{Ua=Vb;Wa=Sa+ -1|0;Xa=Wb}}Xa=ma+ -29|0;if((Vb|0)==0){ma=Xa;Va=Wb}else{Xb=Xa;Yb=Vb;Zb=Wb;break}}}else{if((Mb|0)==18){_b=Lb;$b=Nb}else{ac=Kb;bc=Lb;cc=Mb;dc=Nb;break}while(1){if(!((c[oa>>2]|0)>>>0<9007199)){ac=Kb;bc=_b;cc=18;dc=$b;break f}Va=0;ma=$b+127|0;Xa=$b;while(1){Wa=ma&127;Ua=h+(Wa<<2)|0;Sa=Q4c(c[Ua>>2]|0,0,29)|0;Ra=V4c(Sa|0,J|0,Va|0,0)|0;Sa=J;if(Sa>>>0>0|(Sa|0)==0&Ra>>>0>1e9){Qa=d5c(Ra|0,Sa|0,1e9,0)|0;Pa=e5c(Ra|0,Sa|0,1e9,0)|0;ec=Pa;fc=Qa}else{ec=Ra;fc=0}c[Ua>>2]=ec;Ua=(Wa|0)==(Kb|0);if((Wa|0)!=(Xa+127&127|0)|Ua){gc=Xa}else{gc=(ec|0)==0?Wa:Xa}if(Ua){break}else{Va=fc;ma=Wa+ -1|0;Xa=gc}}Xa=_b+ -29|0;if((fc|0)==0){_b=Xa;$b=gc}else{Xb=Xa;Yb=fc;Zb=gc;break}}}oa=Kb+127&127;if((oa|0)==(Zb|0)){Xa=Zb+127&127;ma=h+((Zb+126&127)<<2)|0;c[ma>>2]=c[ma>>2]|c[h+(Xa<<2)>>2];hc=Xa}else{hc=Zb}c[h+(oa<<2)>>2]=Yb;Kb=oa;Lb=Xb;Mb=Mb+9|0;Nb=hc}g:while(1){ic=dc+1&127;na=h+((dc+127&127)<<2)|0;oa=ac;Xa=bc;ma=cc;while(1){Va=(ma|0)==18;Wa=(ma|0)>27?9:1;jc=oa;kc=Xa;while(1){Ua=0;while(1){Ra=Ua+jc&127;if((Ra|0)==(dc|0)){lc=2;break}Qa=c[h+(Ra<<2)>>2]|0;Ra=c[382880+(Ua<<2)>>2]|0;if(Qa>>>0<Ra>>>0){lc=2;break}Pa=Ua+1|0;if(Qa>>>0>Ra>>>0){lc=Ua;break}if((Pa|0)<2){Ua=Pa}else{lc=Pa;break}}if((lc|0)==2&Va){break g}mc=Wa+kc|0;if((jc|0)==(dc|0)){jc=dc;kc=mc}else{break}}Va=(1<<Wa)+ -1|0;Ua=1e9>>>Wa;nc=jc;oc=0;Pa=jc;pc=ma;do{Ra=h+(Pa<<2)|0;Qa=c[Ra>>2]|0;Sa=(Qa>>>Wa)+oc|0;c[Ra>>2]=Sa;oc=fa(Qa&Va,Ua)|0;Qa=(Pa|0)==(nc|0)&(Sa|0)==0;Pa=Pa+1&127;pc=Qa?pc+ -9|0:pc;nc=Qa?Pa:nc;}while((Pa|0)!=(dc|0));if((oc|0)==0){oa=nc;Xa=mc;ma=pc;continue}if((ic|0)!=(nc|0)){break}c[na>>2]=c[na>>2]|1;oa=nc;Xa=mc;ma=pc}c[h+(dc<<2)>>2]=oc;ac=nc;bc=mc;cc=pc;dc=ic}ma=jc&127;if((ma|0)==(dc|0)){c[h+(ic+ -1<<2)>>2]=0;qc=ic}else{qc=dc}va=+((c[h+(ma<<2)>>2]|0)>>>0);ma=jc+1&127;if((ma|0)==(qc|0)){Xa=qc+1&127;c[h+(Xa+ -1<<2)>>2]=0;rc=Xa}else{rc=qc}la=+(r|0);sc=la*(va*1.0e9+ +((c[h+(ma<<2)>>2]|0)>>>0));ma=kc+53|0;Xa=ma-k|0;if((Xa|0)<(j|0)){tc=(Xa|0)<0?0:Xa;uc=1}else{tc=j;uc=0}if((tc|0)<53){va=+Rd(+(+z4c(1.0,105-tc|0)),+sc);vc=+zc(+sc,+(+z4c(1.0,53-tc|0)));wc=va;xc=vc;yc=va+(sc-vc)}else{wc=0.0;xc=0.0;yc=sc}oa=jc+2&127;do{if((oa|0)==(rc|0)){Ac=xc}else{na=c[h+(oa<<2)>>2]|0;do{if(na>>>0<5e8){if((na|0)==0){if((jc+3&127|0)==(rc|0)){Bc=xc;break}}Bc=la*.25+xc}else{if(na>>>0>5e8){Bc=la*.75+xc;break}if((jc+3&127|0)==(rc|0)){Bc=la*.5+xc;break}else{Bc=la*.75+xc;break}}}while(0);if((53-tc|0)<=1){Ac=Bc;break}if(+zc(+Bc,1.0)!=0.0){Ac=Bc;break}Ac=Bc+1.0}}while(0);la=yc+Ac-wc;do{if((ma&2147483647|0)>(-2-o|0)){if(!(+U(+la)>=9007199254740992.0)){Cc=uc;Dc=kc;Ec=la}else{Cc=(uc|0)!=0&(tc|0)==(Xa|0)?0:uc;Dc=kc+1|0;Ec=la*.5}if((Dc+50|0)<=(p|0)){if(!((Cc|0)!=0&Ac!=0.0)){Fc=Dc;Gc=Ec;break}}c[(Nc()|0)>>2]=34;Fc=Dc;Gc=Ec}else{Fc=kc;Gc=la}}while(0);l=+A4c(Gc,Fc);i=g;return+l}else if((x|0)==3){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Hc=d[p]|0}else{Hc=y4c(b)|0}if((Hc|0)==40){Ic=1}else{if((c[m>>2]|0)==0){l=+y;i=g;return+l}c[e>>2]=(c[e>>2]|0)+ -1;l=+y;i=g;return+l}while(1){p=c[e>>2]|0;if(p>>>0<(c[m>>2]|0)>>>0){c[e>>2]=p+1;Jc=d[p]|0}else{Jc=y4c(b)|0}if(!((Jc+ -48|0)>>>0<10|(Jc+ -65|0)>>>0<26)){if(!((Jc+ -97|0)>>>0<26|(Jc|0)==95)){break}}Ic=Ic+1|0}if((Jc|0)==41){l=+y;i=g;return+l}p=(c[m>>2]|0)==0;if(!p){c[e>>2]=(c[e>>2]|0)+ -1}if(u){c[(Nc()|0)>>2]=22;x4c(b,0);l=0.0;i=g;return+l}if((Ic|0)==0|p){l=+y;i=g;return+l}else{Kc=Ic}while(1){p=Kc+ -1|0;c[e>>2]=(c[e>>2]|0)+ -1;if((p|0)==0){l=+y;break}else{Kc=p}}i=g;return+l}else{if((c[m>>2]|0)!=0){c[e>>2]=(c[e>>2]|0)+ -1}c[(Nc()|0)>>2]=22;x4c(b,0);l=0.0;i=g;return+l}}}while(0);do{if((v|0)==23){b=(c[m>>2]|0)==0;if(!b){c[e>>2]=(c[e>>2]|0)+ -1}if(t>>>0<4|(f|0)==0|b){break}else{Lc=t}do{c[e>>2]=(c[e>>2]|0)+ -1;Lc=Lc+ -1|0;}while(Lc>>>0>3)}}while(0);l=+(r|0)*+z;i=g;return+l}function w4c(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=a+4|0;g=c[f>>2]|0;h=a+100|0;if(g>>>0<(c[h>>2]|0)>>>0){c[f>>2]=g+1;j=d[g]|0}else{j=y4c(a)|0}do{if((j|0)==43|(j|0)==45){g=(j|0)==45|0;k=c[f>>2]|0;if(k>>>0<(c[h>>2]|0)>>>0){c[f>>2]=k+1;l=d[k]|0}else{l=y4c(a)|0}if((l+ -48|0)>>>0<10|(b|0)==0){m=l;n=g;break}if((c[h>>2]|0)==0){m=l;n=g;break}c[f>>2]=(c[f>>2]|0)+ -1;m=l;n=g}else{m=j;n=0}}while(0);if((m+ -48|0)>>>0>9){if((c[h>>2]|0)==0){o=0;p=-2147483648;J=p;i=e;return o|0}c[f>>2]=(c[f>>2]|0)+ -1;o=0;p=-2147483648;J=p;i=e;return o|0}else{q=m;r=0}while(1){s=q+ -48+r|0;m=c[f>>2]|0;if(m>>>0<(c[h>>2]|0)>>>0){c[f>>2]=m+1;t=d[m]|0}else{t=y4c(a)|0}if(!((t+ -48|0)>>>0<10&(s|0)<214748364)){break}q=t;r=s*10|0}r=((s|0)<0)<<31>>31;if((t+ -48|0)>>>0<10){q=s;m=r;j=t;while(1){l=c5c(q|0,m|0,10,0)|0;b=J;g=V4c(j|0,((j|0)<0)<<31>>31|0,-48,-1)|0;k=V4c(g|0,J|0,l|0,b|0)|0;b=J;l=c[f>>2]|0;if(l>>>0<(c[h>>2]|0)>>>0){c[f>>2]=l+1;u=d[l]|0}else{u=y4c(a)|0}if((u+ -48|0)>>>0<10&((b|0)<21474836|(b|0)==21474836&k>>>0<2061584302)){j=u;m=b;q=k}else{v=k;w=b;x=u;break}}}else{v=s;w=r;x=t}if((x+ -48|0)>>>0<10){do{x=c[f>>2]|0;if(x>>>0<(c[h>>2]|0)>>>0){c[f>>2]=x+1;y=d[x]|0}else{y=y4c(a)|0}}while((y+ -48|0)>>>0<10)}if((c[h>>2]|0)!=0){c[f>>2]=(c[f>>2]|0)+ -1}f=(n|0)!=0;n=U4c(0,0,v|0,w|0)|0;o=f?n:v;p=f?J:w;J=p;i=e;return o|0}function x4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;c[a+104>>2]=b;e=c[a+8>>2]|0;f=c[a+4>>2]|0;g=e-f|0;c[a+108>>2]=g;if((b|0)!=0&(g|0)>(b|0)){c[a+100>>2]=f+b;i=d;return}else{c[a+100>>2]=e;i=d;return}}function y4c(b){b=b|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;f=b+104|0;g=c[f>>2]|0;if((g|0)==0){h=3}else{if((c[b+108>>2]|0)<(g|0)){h=3}}do{if((h|0)==3){g=C4c(b)|0;if((g|0)<0){break}j=c[f>>2]|0;k=c[b+8>>2]|0;do{if((j|0)==0){h=8}else{l=c[b+4>>2]|0;m=j-(c[b+108>>2]|0)+ -1|0;if((k-l|0)<=(m|0)){h=8;break}c[b+100>>2]=l+m}}while(0);if((h|0)==8){c[b+100>>2]=k}j=c[b+4>>2]|0;if((k|0)!=0){m=b+108|0;c[m>>2]=k+1-j+(c[m>>2]|0)}m=j+ -1|0;if((d[m]|0|0)==(g|0)){n=g;i=e;return n|0}a[m]=g;n=g;i=e;return n|0}}while(0);c[b+100>>2]=0;n=-1;i=e;return n|0}function z4c(a,b){a=+a;b=b|0;var d=0,e=0.0,f=0,g=0,j=0.0;d=i;do{if((b|0)>1023){e=a*8.98846567431158e+307;f=b+ -1023|0;if((f|0)<=1023){g=f;j=e;break}f=b+ -2046|0;g=(f|0)>1023?1023:f;j=e*8.98846567431158e+307}else{if(!((b|0)<-1022)){g=b;j=a;break}e=a*1.2882297539194267e-231;f=b+1022|0;if(!((f|0)<-1022)){g=f;j=e;break}f=b+2044|0;g=(f|0)<-1022?-1022:f;j=e*1.2882297539194267e-231}}while(0);b=Q4c(g+1023|0,0,52)|0;g=J;c[k>>2]=b;c[k+4>>2]=g;a=j*+h[k>>3];i=d;return+a}function A4c(a,b){a=+a;b=b|0;var c=0,d=0.0;c=i;d=+z4c(a,b);i=c;return+d}function B4c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+74|0;f=a[e]|0;a[e]=f+ -1<<24>>24|f;f=b+20|0;e=b+44|0;if((c[f>>2]|0)>>>0>(c[e>>2]|0)>>>0){le[c[b+36>>2]&63](b,0,0)|0}c[b+16>>2]=0;c[b+28>>2]=0;c[f>>2]=0;f=b;g=c[f>>2]|0;if((g&20|0)==0){h=c[e>>2]|0;c[b+8>>2]=h;c[b+4>>2]=h;j=0;i=d;return j|0}if((g&4|0)==0){j=-1;i=d;return j|0}c[f>>2]=g|32;j=-1;i=d;return j|0}function C4c(a){a=a|0;var b=0,e=0,f=0;b=i;i=i+8|0;e=b;do{if((c[a+8>>2]|0)==0){if((B4c(a)|0)==0){break}else{f=-1}i=b;return f|0}}while(0);if((le[c[a+32>>2]&63](a,e,1)|0)!=1){f=-1;i=b;return f|0}f=d[e]|0;i=b;return f|0}function D4c(a){a=a|0;var b=0,c=0.0;b=i;c=+E4c(a,0);i=b;return+c}function E4c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;x4c(e,0);h=+v4c(e,1,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function F4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0.0,j=0,k=0;d=i;i=i+112|0;e=d;f=e+0|0;g=f+112|0;do{c[f>>2]=0;f=f+4|0}while((f|0)<(g|0));f=e+4|0;c[f>>2]=a;g=e+8|0;c[g>>2]=-1;c[e+44>>2]=a;c[e+76>>2]=-1;x4c(e,0);h=+v4c(e,2,1);j=(c[f>>2]|0)-(c[g>>2]|0)+(c[e+108>>2]|0)|0;if((b|0)==0){i=d;return+h}if((j|0)==0){k=a}else{k=a+j|0}c[b>>2]=k;i=d;return+h}function G4c(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;if((d|0)==0){f=0;i=e;return f|0}else{g=d;h=b;j=c}while(1){k=a[h]|0;l=a[j]|0;if(!(k<<24>>24==l<<24>>24)){break}c=g+ -1|0;if((c|0)==0){f=0;m=5;break}else{g=c;h=h+1|0;j=j+1|0}}if((m|0)==5){i=e;return f|0}f=(k&255)-(l&255)|0;i=e;return f|0}function H4c(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=a[b]|0;f=a[c]|0;if(e<<24>>24!=f<<24>>24|e<<24>>24==0|f<<24>>24==0){g=e;h=f;j=g&255;k=h&255;l=j-k|0;i=d;return l|0}else{m=b;n=c}while(1){c=m+1|0;b=n+1|0;f=a[c]|0;e=a[b]|0;if(f<<24>>24!=e<<24>>24|f<<24>>24==0|e<<24>>24==0){g=f;h=e;break}else{n=b;m=c}}j=g&255;k=h&255;l=j-k|0;i=d;return l|0}function I4c(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;f=i;if((e|0)==0){g=0;i=f;return g|0}h=a[b]|0;a:do{if(h<<24>>24==0){j=0;k=c}else{l=e;m=h;n=b;o=c;while(1){p=l+ -1|0;q=a[o]|0;if(!((p|0)!=0&q<<24>>24!=0&m<<24>>24==q<<24>>24)){j=m;k=o;break a}q=n+1|0;r=o+1|0;s=a[q]|0;if(s<<24>>24==0){j=0;k=r;break}else{m=s;n=q;o=r;l=p}}}}while(0);g=(j&255)-(d[k]|0)|0;i=f;return g|0}function J4c(){c[90798]=p;c[90840]=p;c[95482]=p;c[95712]=p}function K4c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;w=w+1|0;c[a>>2]=w;while((e|0)<40){if((c[d+(e<<2)>>2]|0)==0){c[d+(e<<2)>>2]=w;c[d+((e<<2)+4)>>2]=b;c[d+((e<<2)+8)>>2]=0;return 0}e=e+2|0}dc(116);dc(111);dc(111);dc(32);dc(109);dc(97);dc(110);dc(121);dc(32);dc(115);dc(101);dc(116);dc(106);dc(109);dc(112);dc(115);dc(32);dc(105);dc(110);dc(32);dc(97);dc(32);dc(102);dc(117);dc(110);dc(99);dc(116);dc(105);dc(111);dc(110);dc(32);dc(99);dc(97);dc(108);dc(108);dc(44);dc(32);dc(98);dc(117);dc(105);dc(108);dc(100);dc(32);dc(119);dc(105);dc(116);dc(104);dc(32);dc(97);dc(32);dc(104);dc(105);dc(103);dc(104);dc(101);dc(114);dc(32);dc(118);dc(97);dc(108);dc(117);dc(101);dc(32);dc(102);dc(111);dc(114);dc(32);dc(77);dc(65);dc(88);dc(95);dc(83);dc(69);dc(84);dc(74);dc(77);dc(80);dc(83);dc(10);ga(0);return 0}function L4c(b){b=b|0;var c=0;c=b;while(a[c]|0){c=c+1|0}return c-b|0}function M4c(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=(b|0)<0?-1:0;return b>>c-32|0}function N4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;if((e|0)>=4096)return mb(b|0,d|0,e|0)|0;f=b|0;if((b&3)==(d&3)){while(b&3){if((e|0)==0)return f|0;a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}while((e|0)>=4){c[b>>2]=c[d>>2];b=b+4|0;d=d+4|0;e=e-4|0}}while((e|0)>0){a[b]=a[d]|0;b=b+1|0;d=d+1|0;e=e-1|0}return f|0}function O4c(b,c,d){b=b|0;c=c|0;d=d|0;var e=0;if((c|0)<(b|0)&(b|0)<(c+d|0)){e=b;c=c+d|0;b=b+d|0;while((d|0)>0){b=b-1|0;c=c-1|0;d=d-1|0;a[b]=a[c]|0}b=e}else{N4c(b,c,d)|0}return b|0}function P4c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,i=0;f=b+e|0;if((e|0)>=20){d=d&255;g=b&3;h=d|d<<8|d<<16|d<<24;i=f&~3;if(g){g=b+4-g|0;while((b|0)<(g|0)){a[b]=d;b=b+1|0}}while((b|0)<(i|0)){c[b>>2]=h;b=b+4|0}}while((b|0)<(f|0)){a[b]=d;b=b+1|0}return b-e|0}function Q4c(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b<<c|(a&(1<<c)-1<<32-c)>>>32-c;return a<<c}J=a<<c-32;return 0}function R4c(b,c){b=b|0;c=c|0;var d=0;do{a[b+d|0]=a[c+d|0];d=d+1|0}while(a[c+(d-1)|0]|0);return b|0}function S4c(a){a=a|0;var b=0;b=(fa(c[a>>2]|0,31010991)|0)+1735287159&2147483647;c[a>>2]=b;return b|0}function T4c(){return S4c(o)|0}function U4c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=b-d>>>0;e=b-d-(c>>>0>a>>>0|0)>>>0;return(J=e,a-c>>>0|0)|0}function V4c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=a+c>>>0;return(J=b+d+(e>>>0<a>>>0|0)>>>0,e|0)|0}function W4c(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0;while((e|0)<(d|0)){a[b+e|0]=f?0:a[c+e|0]|0;f=f?1:(a[c+e|0]|0)==0;e=e+1|0}return b|0}function X4c(a,b,c){a=a|0;b=b|0;c=c|0;if((c|0)<32){J=b>>>c;return a>>>c|(b&(1<<c)-1)<<32-c}J=0;return b>>>c-32|0}function Y4c(a,b){a=a|0;b=b|0;var d=0,e=0;while((d|0)<20){e=c[b+(d<<2)>>2]|0;if((e|0)==0)break;if((e|0)==(a|0)){return c[b+((d<<2)+4)>>2]|0}d=d+2|0}return 0}function Z4c(b){b=b|0;var c=0;c=a[n+(b>>>24)|0]|0;if((c|0)<8)return c|0;c=a[n+(b>>16&255)|0]|0;if((c|0)<8)return c+8|0;c=a[n+(b>>8&255)|0]|0;if((c|0)<8)return c+16|0;return(a[n+(b&255)|0]|0)+24|0}function _4c(b){b=b|0;var c=0;c=a[m+(b&255)|0]|0;if((c|0)<8)return c|0;c=a[m+(b>>8&255)|0]|0;if((c|0)<8)return c+8|0;c=a[m+(b>>16&255)|0]|0;if((c|0)<8)return c+16|0;return(a[m+(b>>>24)|0]|0)+24|0}function $4c(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0;c=a&65535;d=b&65535;e=fa(d,c)|0;f=a>>>16;a=(e>>>16)+(fa(d,f)|0)|0;d=b>>>16;b=fa(d,c)|0;return(J=(a>>>16)+(fa(d,f)|0)+(((a&65535)+b|0)>>>16)|0,a+b<<16|e&65535|0)|0}function a5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,i=0;e=b>>31|((b|0)<0?-1:0)<<1;f=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;g=d>>31|((d|0)<0?-1:0)<<1;h=((d|0)<0?-1:0)>>31|((d|0)<0?-1:0)<<1;i=U4c(e^a,f^b,e,f)|0;b=J;a=g^e;e=h^f;f=U4c((f5c(i,b,U4c(g^c,h^d,g,h)|0,J,0)|0)^a,J^e,a,e)|0;return(J=J,f)|0}function b5c(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+8|0;g=f|0;h=b>>31|((b|0)<0?-1:0)<<1;j=((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1;k=e>>31|((e|0)<0?-1:0)<<1;l=((e|0)<0?-1:0)>>31|((e|0)<0?-1:0)<<1;m=U4c(h^a,j^b,h,j)|0;b=J;f5c(m,b,U4c(k^d,l^e,k,l)|0,J,g)|0;l=U4c(c[g>>2]^h,c[g+4>>2]^j,h,j)|0;j=J;i=f;return(J=j,l)|0}function c5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=a;a=c;c=$4c(e,a)|0;f=J;return(J=(fa(b,a)|0)+(fa(d,e)|0)+f|f&0,c|0|0)|0}function d5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=f5c(a,b,c,d,0)|0;return(J=J,e)|0}function e5c(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=f|0;f5c(a,b,d,e,g)|0;i=f;return(J=c[g+4>>2]|0,c[g>>2]|0)|0}function f5c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,i=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0;g=a;h=b;i=h;j=d;k=e;l=k;if((i|0)==0){m=(f|0)!=0;if((l|0)==0){if(m){c[f>>2]=(g>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(g>>>0)/(j>>>0)>>>0;return(J=n,o)|0}else{if(!m){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=b&0;n=0;o=0;return(J=n,o)|0}}m=(l|0)==0;do{if((j|0)==0){if(m){if((f|0)!=0){c[f>>2]=(i>>>0)%(j>>>0);c[f+4>>2]=0}n=0;o=(i>>>0)/(j>>>0)>>>0;return(J=n,o)|0}if((g|0)==0){if((f|0)!=0){c[f>>2]=0;c[f+4>>2]=(i>>>0)%(l>>>0)}n=0;o=(i>>>0)/(l>>>0)>>>0;return(J=n,o)|0}p=l-1|0;if((p&l|0)==0){if((f|0)!=0){c[f>>2]=a|0;c[f+4>>2]=p&i|b&0}n=0;o=i>>>((_4c(l|0)|0)>>>0);return(J=n,o)|0}p=(Z4c(l|0)|0)-(Z4c(i|0)|0)|0;if(p>>>0<=30){q=p+1|0;r=31-p|0;s=q;t=i<<r|g>>>(q>>>0);u=i>>>(q>>>0);v=0;w=g<<r;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}else{if(!m){r=(Z4c(l|0)|0)-(Z4c(i|0)|0)|0;if(r>>>0<=31){q=r+1|0;p=31-r|0;x=r-31>>31;s=q;t=g>>>(q>>>0)&x|i<<p;u=i>>>(q>>>0)&x;v=0;w=g<<p;break}if((f|0)==0){n=0;o=0;return(J=n,o)|0}c[f>>2]=a|0;c[f+4>>2]=h|b&0;n=0;o=0;return(J=n,o)|0}p=j-1|0;if((p&j|0)!=0){x=(Z4c(j|0)|0)+33-(Z4c(i|0)|0)|0;q=64-x|0;r=32-x|0;y=r>>31;z=x-32|0;A=z>>31;s=x;t=r-1>>31&i>>>(z>>>0)|(i<<r|g>>>(x>>>0))&A;u=A&i>>>(x>>>0);v=g<<q&y;w=(i<<q|g>>>(z>>>0))&y|g<<r&x-33>>31;break}if((f|0)!=0){c[f>>2]=p&g;c[f+4>>2]=0}if((j|0)==1){n=h|b&0;o=a|0|0;return(J=n,o)|0}else{p=_4c(j|0)|0;n=i>>>(p>>>0)|0;o=i<<32-p|g>>>(p>>>0)|0;return(J=n,o)|0}}}while(0);if((s|0)==0){B=w;C=v;D=u;E=t;F=0;G=0}else{g=d|0|0;d=k|e&0;e=V4c(g,d,-1,-1)|0;k=J;i=w;w=v;v=u;u=t;t=s;s=0;while(1){H=w>>>31|i<<1;I=s|w<<1;j=u<<1|i>>>31|0;a=u>>>31|v<<1|0;U4c(e,k,j,a)|0;b=J;h=b>>31|((b|0)<0?-1:0)<<1;K=h&1;L=U4c(j,a,h&g,(((b|0)<0?-1:0)>>31|((b|0)<0?-1:0)<<1)&d)|0;M=J;b=t-1|0;if((b|0)==0){break}else{i=H;w=I;v=M;u=L;t=b;s=K}}B=H;C=I;D=M;E=L;F=0;G=K}K=C;C=0;if((f|0)!=0){c[f>>2]=E;c[f+4>>2]=D}n=(K|0)>>>31|(B|C)<<1|(C<<1|K>>>31)&0|F;o=(K<<1|0>>>31)&-2|G;return(J=n,o)|0}function g5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;return be[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0)|0}function h5c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ce[a&31](b|0,c|0,d|0,e|0,f|0)}function i5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;h=h|0;i=i|0;return de[a&1](b|0,c|0,d|0,e|0,+f,g|0,h|0,i|0)|0}function j5c(a,b){a=a|0;b=+b;ee[a&1](+b)}function k5c(a,b){a=a|0;b=b|0;fe[a&1023](b|0)}function l5c(a,b,c){a=a|0;b=b|0;c=c|0;ge[a&255](b|0,c|0)}function m5c(a,b,c,d,e,f,g,h,i,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;return he[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0)|0}function n5c(a,b){a=a|0;b=b|0;return ie[a&127](b|0)|0}function o5c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;je[a&1](b|0,c|0,+d,e|0)}function p5c(a,b,c,d,e,f,g,h,i,j,k,l,m,n){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;return ke[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0)|0}function q5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return le[a&63](b|0,c|0,d|0)|0}function r5c(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;return me[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0)|0}function s5c(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;return ne[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0)|0}function t5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;oe[a&7](b|0,c|0,d|0,e|0,f|0,+g)}function u5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;pe[a&7](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)}function v5c(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;return qe[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0,k|0,l|0,m|0,n|0,o|0,p|0,q|0,r|0,s|0,t|0,u|0,v|0,w|0,x|0,y|0)|0}function w5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;re[a&31](b|0,c|0,d|0,e|0,f|0,g|0)}function x5c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=+d;e=e|0;f=f|0;se[a&3](b|0,c|0,+d,e|0,f|0)}function y5c(a,b,c){a=a|0;b=b|0;c=+c;return te[a&1](b|0,+c)|0}function z5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ue[a&63](b|0,c|0,d|0,e|0,f|0,g|0,h|0)}function A5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=+h;ve[a&3](b|0,c|0,d|0,e|0,f|0,g|0,+h)}function B5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;we[a&3](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)}function C5c(a,b,c){a=a|0;b=b|0;c=c|0;return xe[a&63](b|0,c|0)|0}function D5c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;return ye[a&63](b|0,c|0,d|0,e|0,f|0)|0}function E5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;g=g|0;return ze[a&1](b|0,c|0,d|0,e|0,+f,g|0)|0}function F5c(a,b,c,d){a=a|0;b=b|0;c=+c;d=+d;return+Ae[a&1](b|0,+c,+d)}function G5c(a,b,c){a=a|0;b=b|0;c=c|0;return+Be[a&1](b|0,c|0)}function H5c(a){a=a|0;return Ce[a&7]()|0}function I5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;return De[a&1](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0,j|0)|0}function J5c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;Ee[a&15](b|0,c|0,d|0)}function K5c(a){a=a|0;Fe[a&7]()}function L5c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;return Ge[a&15](b|0,c|0,d|0,e|0,f|0,g|0,h|0,i|0)|0}function M5c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;return He[a&63](b|0,c|0,d|0,e|0)|0}function N5c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;Ie[a&63](b|0,c|0,d|0,e|0)}function O5c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(0);return 0}function P5c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(1)}function Q5c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;g=g|0;h=h|0;ga(2);return 0}function R5c(a){a=+a;ga(3)}function S5c(a){a=a|0;ga(4)}function T5c(a){a=a|0;Cd(a|0)}function U5c(a,b){a=a|0;b=b|0;ga(5)}function V5c(a,b,c,d,e,f,g,h,i,j){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;ga(6);return 0}function W5c(a){a=a|0;ga(7);return 0}function X5c(a){a=a|0;return Oc(a|0)|0}function Y5c(a){a=a|0;return Ld(a|0)|0}function Z5c(a){a=a|0;return wc(a|0)|0}function _5c(a){a=a|0;return Ad(a|0)|0}function $5c(a){a=a|0;return md(a|0)|0}function a6c(a){a=a|0;return ud(a|0)|0}function b6c(a){a=a|0;return Yc(a|0)|0}function c6c(a,b,c,d){a=a|0;b=b|0;c=+c;d=d|0;ga(8)}function d6c(a,b,c,d,e,f,g,h,i,j,k,l,m){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;ga(9);return 0}function e6c(a,b,c){a=a|0;b=b|0;c=c|0;ga(10);return 0}function f6c(a,b,c){a=a|0;b=b|0;c=c|0;return wd(a|0,b|0,c|0)|0}function g6c(a,b,c){a=a|0;b=b|0;c=c|0;return hc(a|0,b|0,c|0)|0}function h6c(a,b,c){a=a|0;b=b|0;c=c|0;return Od(a|0,b|0,c|0)|0}function i6c(a,b,c){a=a|0;b=b|0;c=c|0;return Bd(a|0,b|0,c|0)|0}function j6c(a,b,c){a=a|0;b=b|0;c=c|0;return xd(a|0,b|0,c|0)|0}function k6c(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;ga(11);return 0}function l6c(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;ga(12);return 0}function m6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=+f;ga(13)}function n6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(14)}function o6c(a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;ga(15);return 0}function p6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;ga(16)}function q6c(a,b,c,d,e){a=a|0;b=b|0;c=+c;d=d|0;e=e|0;ga(17)}function r6c(a,b){a=a|0;b=+b;ga(18);return 0}function s6c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;ga(19)}function t6c(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=+g;ga(20)}function u6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(21)}function v6c(a,b){a=a|0;b=b|0;ga(22);return 0}function w6c(a,b){a=a|0;b=b|0;return Qd(a|0,b|0)|0}function x6c(a,b){a=a|0;b=b|0;return gc(a|0,b|0)|0}function y6c(a,b){a=a|0;b=b|0;return ib(a|0,b|0)|0}function z6c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;ga(23);return 0}function A6c(a,b,c,d,e,f){a=a|0;b=b|0;c=c|0;d=d|0;e=+e;f=f|0;ga(24);return 0}function B6c(a,b,c){a=a|0;b=+b;c=+c;ga(25);return 0.0}function C6c(a,b){a=a|0;b=b|0;ga(26);return 0.0}function D6c(){ga(27);return 0}function E6c(){return jb()|0}function F6c(a,b,c,d,e,f,g,h,i){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i|0;ga(28);return 0}function G6c(a,b,c){a=a|0;b=b|0;c=c|0;ga(29)}function H6c(){ga(30)}function I6c(){Uc()}function J6c(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;ga(31);return 0}function K6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(32);return 0}function L6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return rc(a|0,b|0,c|0,d|0)|0}function M6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;return Mc(a|0,b|0,c|0,d|0)|0}function N6c(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;ga(33)}



function Bxc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;i=i+120|0;k=j+56|0;l=j+80|0;m=j+96|0;n=j+112|0;o=b;b=d;d=e;e=f;f=g;g=h;c[k>>2]=c[d>>2];h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;c[p>>2]=c[k>>2];q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}c[p>>2]=c[k>>2];c[d>>2]=0;a:while(1){h=He[c[b+8>>2]&63](b,c[k>>2]|0,e,l)|0;c[q>>2]=c[l>>2];b:do{switch(h|0){case 0:{r=24;break a;break};case 6:{s=c[o+60>>2]|0;if((s|0)==0){if((c[o+80>>2]|0)==0){break b}Rwc(o,b,c[k>>2]|0,c[l>>2]|0);break b}if((a[b+72|0]|0)!=0){Ee[s&15](c[o+4>>2]|0,c[k>>2]|0,(c[l>>2]|0)-(c[k>>2]|0)|0);break b}while(1){c[n>>2]=c[o+44>>2];ce[c[b+60>>2]&31](b,k,c[l>>2]|0,n,c[o+48>>2]|0);c[q>>2]=c[l>>2];Ee[s&15](c[o+4>>2]|0,c[o+44>>2]|0,(c[n>>2]|0)-(c[o+44>>2]|0)|0);if((c[k>>2]|0)==(c[l>>2]|0)){break b}c[p>>2]=c[k>>2]}break};case-4:case-1:{r=28;break a;break};case 40:{r=6;break a;break};case-2:{r=25;break a;break};case 7:{if((c[o+60>>2]|0)!=0){a[m]=10;Ee[c[o+60>>2]&15](c[o+4>>2]|0,m,1);break b}if((c[o+80>>2]|0)==0){break b}Rwc(o,b,c[k>>2]|0,c[l>>2]|0);break};default:{r=31;break a}}}while(0);h=c[l>>2]|0;c[k>>2]=h;c[p>>2]=h;h=c[o+480>>2]|0;if((h|0)==2){r=34;break}else if((h|0)==3){r=33;break}}if((r|0)==6){m=o;do{if((c[o+76>>2]|0)!=0){fe[c[m+76>>2]&1023](c[o+4>>2]|0)}else{if((c[m+80>>2]|0)==0){break}Rwc(o,b,c[k>>2]|0,c[l>>2]|0)}}while(0);c[d>>2]=c[l>>2];c[f>>2]=c[l>>2];if((c[o+480>>2]|0)==2){t=35;u=t;i=j;return u|0}else{t=0;u=t;i=j;return u|0}}else if((r|0)==24){c[p>>2]=c[l>>2];t=4;u=t;i=j;return u|0}else if((r|0)==25){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=6;u=t;i=j;return u|0}}else if((r|0)==28){if(g<<24>>24!=0){c[f>>2]=c[k>>2];t=0;u=t;i=j;return u|0}else{t=20;u=t;i=j;return u|0}}else if((r|0)==31){c[p>>2]=c[l>>2];t=23;u=t;i=j;return u|0}else if((r|0)==33){c[f>>2]=c[l>>2];t=0;u=t;i=j;return u|0}else if((r|0)==34){t=35;u=t;i=j;return u|0}return 0}function Cxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=Bxc(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)==0){k=f;l=k;i=g;return l|0}f=j+280|0;if((c[j+476>>2]|0)!=0){c[f>>2]=44;k=Dxc(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=fxc(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}return 0}function Dxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=wxc(h,1,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Exc(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function Exc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+56|0;d=a;a=c[d+364>>2]|0;while(1){if((a|0)==0){e=13;break}f=(c[a+24>>2]|0)+1|0;g=(c[a+36>>2]|0)+f|0;if((c[a+4>>2]|0)==(g|0)){e=13;break}h=f+((c[a+8>>2]|0)+0)|0;if((h|0)>((c[a+40>>2]|0)-(c[a+36>>2]|0)|0)){j=xe[c[d+16>>2]&63](c[a+36>>2]|0,h)|0;if((j|0)==0){e=6;break}if((c[a+12>>2]|0)==(c[a+36>>2]|0)){c[a+12>>2]=j}if((c[a+16>>2]|0)!=0){c[a+16>>2]=j+((c[a+16>>2]|0)-(c[a+36>>2]|0))}c[a+36>>2]=j;c[a+40>>2]=j+h;g=j+f|0}N4c(g|0,c[a+4>>2]|0,c[a+8>>2]|0)|0;c[a+4>>2]=g;a=c[a>>2]|0}if((e|0)==6){k=0;l=k;i=b;return l|0}else if((e|0)==13){k=1;l=k;i=b;return l|0}return 0}function Fxc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=c[b>>2]|0;a:while(1){if((a[g]|0)==0){h=20;break}if((a[g]|0)==58){j=c[b>>2]|0;while(1){k=(c[d+92>>2]|0)==(c[d+88>>2]|0);if((j|0)==(g|0)){break}if(k){if(!((Twc(d+80|0)|0)<<24>>24!=0)){h=9;break a}}l=a[j]|0;m=d+92|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;j=j+1|0}if(k){if(!((Twc(d+80|0)|0)<<24>>24!=0)){h=13;break}}j=d+92|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;l=Wwc(f,d+60|0,c[d+96>>2]|0,8)|0;if((l|0)==0){h=14;break}j=d+80|0;if((c[l>>2]|0)==(c[d+96>>2]|0)){c[d+96>>2]=c[j+12>>2]}else{c[d+92>>2]=c[j+16>>2]}c[b+4>>2]=l}g=g+1|0}if((h|0)==9){o=0;p=o;i=e;return p|0}else if((h|0)==13){o=0;p=o;i=e;return p|0}else if((h|0)==14){o=0;p=o;i=e;return p|0}else if((h|0)==20){o=1;p=o;i=e;return p|0}return 0}function Gxc(b,e,f,g,h,j){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;k=i;i=i+152|0;l=k+64|0;m=k+80|0;n=b;b=e;e=f;f=g;g=h;h=j;j=c[n+356>>2]|0;a:while(1){b:do{switch(He[c[b+16>>2]&63](b,f,g,l)|0){case 10:{o=xe[c[b+44>>2]&63](b,f)|0;if((o|0)<0){p=11;break a}do{if(!(e<<24>>24!=0)){if((o|0)!=32){break}if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break b}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break b}}}while(0);o=Nxc(o,m)|0;if((o|0)==0){p=19;break a}q=0;while(1){if((q|0)>=(o|0)){break b}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Twc(h)|0)<<24>>24!=0)){p=27;break a}}r=a[m+q|0]|0;s=h+12|0;t=c[s>>2]|0;c[s>>2]=t+1;a[t]=r;q=q+1|0}break};case-3:{c[l>>2]=f+(c[b+68>>2]|0);p=31;break};case 0:{p=4;break a;break};case 9:{q=(le[c[b+48>>2]&63](b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0)&255;if(q<<24>>24!=0){if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Twc(h)|0)<<24>>24!=0)){p=42;break a}}o=h+12|0;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;break b}q=dxc(n+440|0,b,f+(c[b+68>>2]|0)|0,(c[l>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((q|0)==0){p=44;break a}r=Wwc(n,j,q,0)|0;c[n+452>>2]=c[n+456>>2];if((h|0)==(j+80|0)){if((c[n+272>>2]|0)!=0){if((d[j+130|0]|0)!=0){u=(c[n+300>>2]|0)!=0}else{u=(a[j+129|0]|0)!=0}v=((u^1)&1|0)!=0}else{v=0}w=v&1}else{if((a[j+129|0]|0)!=0){x=(d[j+130|0]|0)!=0}else{x=1}w=x&1}q=(r|0)!=0;if(w<<24>>24!=0){if(!q){p=57;break a}if((a[r+34|0]|0)==0){p=59;break a}}else{if(!q){break b}}if((a[r+32|0]|0)!=0){p=62;break a}if((c[r+28>>2]|0)!=0){p=66;break a}if((c[r+4>>2]|0)==0){p=70;break a}q=(c[r+4>>2]|0)+(c[r+8>>2]|0)|0;a[r+32|0]=1;y=Gxc(n,c[n+228>>2]|0,e,c[r+4>>2]|0,q,h)|0;a[r+32|0]=0;if((y|0)!=0){p=74;break a}break};case 6:{if((jxc(h,b,f,c[l>>2]|0)|0)==0){p=29;break a}break};case-1:{p=7;break a;break};case 7:case 39:{p=31;break};case-4:{p=3;break a;break};default:{p=75;break a}}}while(0);do{if((p|0)==31){p=0;if(!(e<<24>>24!=0)){if(((c[h+12>>2]|0)-(c[h+16>>2]|0)|0)==0){break}if((a[(c[h+12>>2]|0)+ -1|0]|0)==32){break}}if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if(!((Twc(h)|0)<<24>>24!=0)){p=37;break a}}r=h+12|0;q=c[r>>2]|0;c[r>>2]=q+1;a[q]=32}}while(0);f=c[l>>2]|0}if((p|0)==3){z=0;A=z;i=k;return A|0}else if((p|0)==4){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=c[l>>2]}z=4;A=z;i=k;return A|0}else if((p|0)==7){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=4;A=z;i=k;return A|0}else if((p|0)==11){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==19){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=14;A=z;i=k;return A|0}else if((p|0)==27){z=1;A=z;i=k;return A|0}else if((p|0)==29){z=1;A=z;i=k;return A|0}else if((p|0)==37){z=1;A=z;i=k;return A|0}else if((p|0)==42){z=1;A=z;i=k;return A|0}else if((p|0)==44){z=1;A=z;i=k;return A|0}else if((p|0)==57){z=11;A=z;i=k;return A|0}else if((p|0)==59){z=24;A=z;i=k;return A|0}else if((p|0)==62){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=12;A=z;i=k;return A|0}else if((p|0)==66){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=15;A=z;i=k;return A|0}else if((p|0)==70){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=16;A=z;i=k;return A|0}else if((p|0)==74){z=y;A=z;i=k;return A|0}else if((p|0)==75){if((b|0)==(c[n+144>>2]|0)){c[n+288>>2]=f}z=23;A=z;i=k;return A|0}return 0}function Hxc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;i=i+1080|0;f=e+24|0;g=b;b=d;do{if((c[g+124>>2]|0)!=0){d=0;while(1){if((d|0)>=256){break}c[f+(d<<2)>>2]=-1;d=d+1|0}c[f+1028>>2]=0;c[f+1024>>2]=0;c[f+1032>>2]=0;do{if((le[c[g+124>>2]&63](c[g+248>>2]|0,b,f)|0)!=0){d=c[g+12>>2]|0;h=Oxc()|0;c[g+240>>2]=ie[d&127](h)|0;if((c[g+240>>2]|0)!=0){h=He[((a[g+236|0]&255|0)!=0?45:46)&63](c[g+240>>2]|0,f,c[f+1028>>2]|0,c[f+1024>>2]|0)|0;if((h|0)==0){break}c[g+244>>2]=c[f+1024>>2];c[g+252>>2]=c[f+1032>>2];c[g+144>>2]=h;j=0;k=j;i=e;return k|0}if((c[f+1032>>2]|0)!=0){fe[c[f+1032>>2]&1023](c[f+1024>>2]|0)}j=1;k=j;i=e;return k|0}}while(0);if((c[f+1032>>2]|0)==0){break}fe[c[f+1032>>2]&1023](c[f+1024>>2]|0)}}while(0);j=18;k=j;i=e;return k|0}function Ixc(){var a=0,b=0;a=i;i=i+8|0;bc(((sc(0)|0)>>>0)%4294967295|0|0);b=T4c()|0;i=a;return b|0}function Jxc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+48|0;g=a;a=$wc(g)|0;if((a|0)!=0){h=a;j=h;i=f;return j|0}else{c[g+280>>2]=40;h=axc(g,b,d,e)|0;j=h;i=f;return j|0}return 0}function Kxc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=ie[c[e>>2]&127](188)|0;f=b;if((b|0)==0){g=f;h=g;i=d;return h|0}else{Lxc(f+80|0,e);Lxc(b+104|0,e);Mxc(b,e);Mxc(b+20|0,e);Mxc(b+40|0,e);Mxc(b+60|0,e);a[b+131|0]=0;Mxc(b+132|0,e);c[b+152>>2]=0;c[b+156>>2]=0;a[b+160|0]=0;c[b+184>>2]=0;c[b+164>>2]=0;c[b+180>>2]=0;c[b+172>>2]=0;c[b+176>>2]=0;c[b+168>>2]=0;a[b+128|0]=1;a[b+129|0]=0;a[b+130|0]=0;g=b;h=g;i=d;return h|0}return 0}function Lxc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;c[e>>2]=0;c[e+4>>2]=0;c[e+16>>2]=0;c[e+12>>2]=0;c[e+8>>2]=0;c[e+20>>2]=b;i=d;return}function Mxc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;i=i+16|0;f=b;a[f+4|0]=0;c[f+8>>2]=0;c[f+12>>2]=0;c[f>>2]=0;c[f+16>>2]=d;i=e;return}function Nxc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;if((e|0)<0){f=0;g=f;i=d;return g|0}c=e;if((e|0)<128){a[b]=c;f=1;g=f;i=d;return g|0}h=e;if((c|0)<2048){a[b]=h>>6|192;a[b+1|0]=e&63|128;f=2;g=f;i=d;return g|0}c=e;if((h|0)<65536){a[b]=c>>12|224;a[b+1|0]=e>>6&63|128;a[b+2|0]=e&63|128;f=3;g=f;i=d;return g|0}if((c|0)<1114112){a[b]=e>>18|240;a[b+1|0]=e>>12&63|128;a[b+2|0]=e>>6&63|128;a[b+3|0]=e&63|128;f=4;g=f;i=d;return g|0}else{f=0;g=f;i=d;return g|0}return 0}function Oxc(){i=i;return 1912}function Pxc(e,f,g,h){e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;j=i;i=i+64|0;k=e;e=f;f=g;g=h;h=k;l=0;while(1){if((l|0)>=368){break}a[k+l|0]=a[289512+l|0]|0;l=l+1|0}l=0;a:while(1){if((l|0)>=128){break}do{if((d[289588+l|0]|0|0)!=28){if((d[289588+l|0]|0|0)==0){break}if((c[e+(l<<2)>>2]|0)!=(l|0)){m=9;break a}}}while(0);l=l+1|0}if((m|0)==9){n=0;o=n;i=j;return o|0}l=0;b:while(1){if((l|0)>=256){m=36;break}k=c[e+(l<<2)>>2]|0;do{if((k|0)==-1){a[h+76+l|0]=1;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0}else{p=k;if((k|0)<0){if((p|0)<-4){m=17;break b}a[h+76+l|0]=5-(k+2);a[h+888+(l<<2)|0]=0;b[h+376+(l<<1)>>1]=0;break}q=k;if((p|0)<128){do{if((d[289588+q|0]|0|0)!=28){if((d[289588+k|0]|0|0)==0){break}if((k|0)!=(l|0)){m=23;break b}}}while(0);a[h+76+l|0]=a[289588+k|0]|0;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=k;b[h+376+(l<<1)>>1]=(k|0)==0?65535:k;break}if((Qxc(q)|0)<0){a[h+76+l|0]=0;b[h+376+(l<<1)>>1]=-1;a[h+888+(l<<2)|0]=1;a[h+888+(l<<2)+1|0]=0;break}if((k|0)>65535){m=28;break b}do{if((c[283680+(((d[283424+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[h+76+l|0]=22}else{p=h+76+l|0;if((c[283680+(((d[284960+(k>>8)|0]|0)<<3)+((k&255)>>5)<<2)>>2]&1<<(k&31)|0)!=0){a[p]=26;break}else{a[p]=28;break}}}while(0);a[h+888+(l<<2)|0]=Nxc(k,h+888+(l<<2)+1|0)|0;b[h+376+(l<<1)>>1]=k}}while(0);l=l+1|0}if((m|0)==17){n=0;o=n;i=j;return o|0}else if((m|0)==23){n=0;o=n;i=j;return o|0}else if((m|0)==28){n=0;o=n;i=j;return o|0}else if((m|0)==36){c[h+372>>2]=g;c[h+368>>2]=f;if((f|0)!=0){c[h+332>>2]=50;c[h+336>>2]=50;c[h+340>>2]=50;c[h+344>>2]=51;c[h+348>>2]=51;c[h+352>>2]=51;c[h+356>>2]=52;c[h+360>>2]=52;c[h+364>>2]=52}c[h+60>>2]=13;c[h+64>>2]=14;n=h;o=n;i=j;return o|0}return 0}function Qxc(a){a=a|0;var b=0,c=0,e=0,f=0;b=i;i=i+16|0;c=a;a:do{switch(c>>8|0){case 223:case 222:case 221:case 220:case 219:case 218:case 217:case 216:{e=-1;break};case 255:{if(!((c|0)==65534|(c|0)==65535)){f=7;break a}e=-1;break};case 0:{if((d[289588+c|0]|0|0)!=0){f=7;break a}e=-1;break};default:{f=7}}}while(0);if((f|0)==7){e=c}i=b;return e|0}function Rxc(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[283680+(((d[284960+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Sxc(a,b){a=a|0;b=b|0;var e=0,f=0,g=0,h=0;e=i;i=i+40|0;f=a;a=xe[c[f+368>>2]&63](c[f+372>>2]|0,b)|0;if((a&-65536|0)!=0){g=0;h=g;i=e;return h|0}else{g=c[283680+(((d[283424+(a>>8)|0]|0)<<3)+((a&255)>>5)<<2)>>2]&1<<(a&31);h=g;i=e;return h|0}return 0}function Txc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+32|0;e=a;a=xe[c[e+368>>2]&63](c[e+372>>2]|0,b)|0;if((a&-65536|0)!=0){f=1;g=f&1;i=d;return g|0}f=(Qxc(a)|0)<0;g=f&1;i=d;return g|0}function Uxc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;j=i;i=i+80|0;k=j+48|0;l=b;b=e;e=f;f=g;g=h;h=l;a:while(1){if((c[b>>2]|0)==(e|0)){m=9;break}n=h+888+(d[c[b>>2]|0]<<2)|0;o=n;n=o+1|0;p=a[o]|0;if((p|0)==0){p=Nxc(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[b>>2]|0)|0,k)|0;if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}n=k;o=b;c[o>>2]=(c[o>>2]|0)+((d[l+76+(d[c[b>>2]|0]|0)|0]|0)-3)}else{if((p|0)>(g-(c[f>>2]|0)|0)){m=9;break}o=b;c[o>>2]=(c[o>>2]|0)+1}while(1){o=n;n=o+1|0;q=a[o]|0;o=f;r=c[o>>2]|0;c[o>>2]=r+1;a[r]=q;q=p+ -1|0;p=q;if((q|0)==0){continue a}}}if((m|0)==9){i=j;return}}function Vxc(a,e,f,g,h){a=a|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0;j=i;i=i+56|0;k=a;a=e;e=f;f=g;g=h;h=k;while(1){if((c[a>>2]|0)==(e|0)){l=8;break}if((c[f>>2]|0)==(g|0)){l=8;break}m=b[h+376+((d[c[a>>2]|0]|0)<<1)>>1]|0;if((m&65535|0)==0){m=(xe[c[h+368>>2]&63](c[h+372>>2]|0,c[a>>2]|0)|0)&65535;n=a;c[n>>2]=(c[n>>2]|0)+((d[k+76+(d[c[a>>2]|0]|0)|0]|0)-3)}else{n=a;c[n>>2]=(c[n>>2]|0)+1}n=f;o=c[n>>2]|0;c[n>>2]=o+2;b[o>>1]=m}if((l|0)==8){i=j;return}}function Wxc(){i=i;return 289144}function Xxc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Yxc(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=47;c[g+4>>2]=48;c[g+52>>2]=32;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function Yxc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+24|0;d=a;if((d|0)==0){e=6;f=e;i=b;return f|0}a=0;while(1){if((a|0)>=6){g=8;break}h=a;if((kyc(d,c[289048+(a<<2)>>2]|0)|0)!=0){g=6;break}a=h+1|0}if((g|0)==6){e=h;f=e;i=b;return f|0}else if((g|0)==8){e=-1;f=e;i=b;return f|0}return 0}function Zxc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=iAc(287488,a,0,b,c,d)|0;i=e;return f|0}function _xc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=iAc(287488,a,1,b,c,d)|0;i=e;return f|0}function $xc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;a=i;i=i+32|0;Hzc(288256,b,c,d);i=a;return}function ayc(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=byc(35,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function byc(a,b,d,e,f,g,h,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;n=i;i=i+128|0;o=n+32|0;p=n+96|0;q=n+104|0;r=n+112|0;s=a;a=b;b=d;c[o>>2]=e;e=f;f=g;g=h;h=j;j=k;k=l;l=m;c[p>>2]=0;c[q>>2]=0;c[r>>2]=0;c[o>>2]=(c[o>>2]|0)+((c[b+68>>2]|0)*5|0);e=e+(0-(c[b+68>>2]<<1))|0;m=(jAc(b,c[o>>2]|0,e,q,r,p,o)|0)!=0;if(!(m&(c[q>>2]|0)!=0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,288992)|0)!=0){if((g|0)!=0){c[g>>2]=c[p>>2]}if((h|0)!=0){c[h>>2]=c[o>>2]}if((jAc(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}if((a|0)!=0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}else{if((a|0)!=0){break}c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,289e3)|0)!=0){h=kAc(b,c[p>>2]|0,e)|0;do{if(!(97<=(h|0)&(h|0)<=122)){if(65<=(h|0)&(h|0)<=90){break}c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}while(0);if((j|0)!=0){c[j>>2]=c[p>>2]}if((k|0)!=0){c[k>>2]=le[s&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0)|0}if((jAc(b,c[o>>2]|0,e,q,r,p,o)|0)==0){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}if((c[q>>2]|0)!=0){break}t=1;u=t;i=n;return u|0}}while(0);do{if((He[c[b+28>>2]&63](b,c[q>>2]|0,c[r>>2]|0,289016)|0)!=0){if((a|0)!=0){break}do{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,289032)|0)!=0){if((l|0)==0){break}c[l>>2]=1}else{if((He[c[b+28>>2]&63](b,c[p>>2]|0,(c[o>>2]|0)+(0-(c[b+68>>2]|0))|0,289040)|0)!=0){if((l|0)==0){break}c[l>>2]=0;break}else{c[f>>2]=c[p>>2];t=0;u=t;i=n;return u|0}}}while(0);while(1){if((lAc(kAc(b,c[o>>2]|0,e)|0)|0)==0){break}c[o>>2]=(c[o>>2]|0)+(c[b+68>>2]|0)}if((c[o>>2]|0)!=(e|0)){c[f>>2]=c[o>>2];t=0;u=t;i=n;return u|0}else{t=1;u=t;i=n;return u|0}}}while(0);c[f>>2]=c[q>>2];t=0;u=t;i=n;return u|0}function cyc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((kyc(h,285216)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Yxc(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[287488+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function dyc(){i=i;return 287120}function eyc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0;f=i;i=i+40|0;g=b;b=d;d=Yxc(e)|0;if((d|0)==-1){h=0;j=h;i=f;return j|0}else{a[g+73|0]=d;c[g>>2]=49;c[g+4>>2]=50;c[g+52>>2]=32;c[g+76>>2]=b;c[b>>2]=g;h=1;j=h;i=f;return j|0}return 0}function fyc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=iAc(285224,a,0,b,c,d)|0;i=e;return f|0}function gyc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0,f=0;e=i;i=i+32|0;f=iAc(285224,a,1,b,c,d)|0;i=e;return f|0}function hyc(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0;l=i;i=i+80|0;m=byc(36,a,b,c,d,e,f,g,h,j,k)|0;i=l;return m|0}function iyc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+176|0;g=f+16|0;h=f+32|0;j=f+160|0;k=b;c[g>>2]=d;d=e;c[j>>2]=h;ce[c[k+60>>2]&31](k,g,d,j,(c[j>>2]|0)+128+ -1|0);if((c[g>>2]|0)!=(d|0)){l=0;m=l;i=f;return m|0}a[c[j>>2]|0]=0;do{if((kyc(h,285216)|0)!=0){if((c[k+68>>2]|0)!=2){break}l=k;m=l;i=f;return m|0}}while(0);k=Yxc(h)|0;if((k|0)==-1){l=0;m=l;i=f;return m|0}else{l=c[285224+(k<<2)>>2]|0;m=l;i=f;return m|0}return 0}function jyc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+40|0;g=Pxc(b,c,d,e)|0;if((g|0)==0){h=g;i=f;return h|0}a[g+134|0]=23;h=g;i=f;return h|0}function kyc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+40|0;e=b;b=c;while(1){c=e;e=c+1|0;f=a[c]|0;c=b;b=c+1|0;g=a[c]|0;do{if(97<=(f<<24>>24|0)){if((f<<24>>24|0)>122){break}f=(f<<24>>24)+ -32&255}}while(0);do{if(97<=(g<<24>>24|0)){if((g<<24>>24|0)>122){break}g=(g<<24>>24)+ -32&255}}while(0);if((f<<24>>24|0)!=(g<<24>>24|0)){h=9;break}if(!(f<<24>>24!=0)){h=11;break}}if((h|0)==9){j=0;k=j;i=d;return k|0}else if((h|0)==11){j=1;k=j;i=d;return k|0}return 0}function lyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=Qyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 30:{k=Eyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 13:{k=Oyc(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Cyc(a[g+1|0]|0,a[b]|0)|0}switch(n|0){case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+3|0]|0)!=0){break}if((a[b+2|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 10:case 21:{o=25;break};case 9:{if((b+2|0)!=(e|0)){o=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 12:{k=Oyc(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[g]|0)|0]|0}else{p=Cyc(a[g+1|0]|0,a[b]|0)|0}switch(p|0){case 15:{k=Kyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 16:{k=Pyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{q=18;b=b+2|0;o=77;break};case 29:{g=b;if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){b=g+2|0;q=18;o=77;break a}if((c[283680+((d[284960+(d[g+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=76;break a}b=b+2|0;q=19;o=77;break};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;o=77;break};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};default:{o=76}}}while(0);if((o|0)==25){while(1){o=0;b=b+2|0;r=b;if((b|0)==(e|0)){o=32;break}p=b;if((a[r+1|0]|0)==0){s=d[j+76+(d[p]|0)|0]|0}else{s=Cyc(a[p+1|0]|0,a[b]|0)|0}if((s|0)==10|(s|0)==21){o=25;continue}else if((s|0)!=9){o=31;break}if((b+2|0)!=(e|0)){o=25}else{o=31;break}}if((o|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((o|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((o|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==77){b:while(1){o=0;if((b|0)==(e|0)){o=126;break}r=b;if((a[b+1|0]|0)==0){t=d[j+76+(d[r]|0)|0]|0}else{t=Cyc(a[r+1|0]|0,a[b]|0)|0}switch(t|0){case 34:{o=116;break b;break};case 15:{o=122;break b;break};case 33:{o=119;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=85;break b;break};case 6:{o=88;break b;break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;o=77;continue b}else if((r|0)!=18){o=77;continue b}if((b|0)==(e|0)){o=97;break b}q=41;r=b;if((a[b+1|0]|0)==0){u=d[j+76+(d[r]|0)|0]|0}else{u=Cyc(a[r+1|0]|0,a[b]|0)|0}switch(u|0){case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=103;break b}break};case 6:{o=108;break b;break};case 5:{o=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{o=111;break b;break};default:{q=19;o=77;continue b}}b=b+2|0;o=77;continue b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{o=94;break b;break};case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=83;break b}break};case 7:{o=91;break b;break};default:{o=125;break b}}b=b+2|0;o=77}if((o|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((o|0)==97){k=-1;l=k;i=h;return l|0}else if((o|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((o|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((o|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((o|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function myc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 3:{k=Dyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 2:{k=Hyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Cyc(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Cyc(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+3|0]|0)==0){if((a[b+2|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+5|0]|0)==0){if((a[b+4|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function nyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+1|0]|0)!=0){break a}if((a[b]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Cyc(a[g+1|0]|0,a[b]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o+1|0]|0)==0){q=d[j+76+(d[n]|0)|0]|0}else{q=Cyc(a[n+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function oyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[k]|0)|0]|0}else{m=Cyc(a[k+1|0]|0,a[b]|0)|0}switch(m|0){case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b+1|0]|0)!=0){continue a}if((a[b]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function pyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Cyc(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 2:{n=15;break a;break};case 6:{b=b+3|0;continue a;break};case 9:{n=19;break a;break};case 10:{n=16;break a;break};case 5:{b=b+2|0;continue a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Dyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Cyc(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function qyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Cyc(a[o+1|0]|0,a[b]|0)|0}switch(p|0){case 10:{n=18;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=21;break a;break};case 5:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};case 30:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=Dyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=Eyc(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[e]|0)|0]|0}else{q=Cyc(a[e+1|0]|0,a[b]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function ryc(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b+1|0]|0)==0){h=d[g+76+(d[e]|0)|0]|0}else{h=Cyc(a[e+1|0]|0,a[b]|0)|0}switch(h|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:{e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=15;break a}j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=17;break a}else{continue a}break};case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 5:{break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c+1|0]|0)==0){n=d[g+76+(d[k]|0)|0]|0}else{n=Cyc(a[k+1|0]|0,a[c]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function syc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f+1|0]|0)!=0){h=7;break}if((a[f]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function tyc(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b+1|0]|0)==0){h=d[f+76+(d[g]|0)|0]|0}else{h=Cyc(a[g+1|0]|0,a[b]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function uyc(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b+1|0]|0)==0){g=d[f+76+(d[c]|0)|0]|0}else{g=Cyc(a[c+1|0]|0,a[b]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function vyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[m]|0)|0]|0}else{n=Cyc(a[m+1|0]|0,a[b]|0)|0}b:do{switch(n|0){case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 17:case 11:{if((g|0)!=2){break a}break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b+1|0]|0)==0){o=a[b]|0}else{o=-1}if((o|0)!=32){break}if((a[b+3|0]|0)==0){p=a[b+2|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+3|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Cyc(a[m+1|0]|0,a[b+2|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function wyc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d+1|0]|0)==0){if((a[d]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d+1|0]|0)==0){f=(a[d]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d+1|0]|0)==0){g=a[d]|0}else{g=-1}h=g;switch(h|0){case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d+1|0]|0)==0){l=(a[d]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d+1|0]|0)==0){m=a[d]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Qxc(c)|0;k=j;i=b;return k|0}function xyc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==4){if((a[e+1|0]|0)==0){f=a[e]|0}else{f=-1}if((f|0)==113){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=117){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=116){break}g=34;h=g;i=b;return h|0}else if((f|0)==97){e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=111){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=115){break}g=39;h=g;i=b;return h|0}else{break}}else if((c|0)==3){if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=97){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=109){break}e=e+2|0;if((a[e+1|0]|0)!=0){break}if((a[e]|0)!=112){break}g=38;h=g;i=b;return h|0}else if((c|0)==2){if((a[e+3|0]|0)!=0){break}if((a[e+2|0]|0)!=116){break}if((a[e+1|0]|0)==0){j=a[e]|0}else{j=-1}if((j|0)==108){g=60;h=g;i=b;return h|0}else if((j|0)==103){g=62;h=g;i=b;return h|0}else{break}}}while(0);g=0;h=g;i=b;return h|0}function yyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Cyc(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 5:{b=b+2|0;break};case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Cyc(a[g+1|0]|0,a[b]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};case 7:{b=b+4|0;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function zyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b+1|0]|0)==0){l=d[j+76+(d[g]|0)|0]|0}else{l=Cyc(a[g+1|0]|0,a[b]|0)|0}b:do{switch(l|0){case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b+1|0]|0)!=0){break b}if((a[b]|0)==9){k=9;break a}break};case 22:case 26:{if((a[b+1|0]|0)==0){m=a[b]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b+1|0]|0)==0){n=a[b]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function Ayc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j]|0;m=a[g+1|0]|0;b:do{switch(m&255|0){case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}n=((m&3)<<2|(l&255)>>6&3)+1|0;o=e;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n>>2|240;p=e;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=(l&255)>>2&15|(n&3)<<4|128;g=g+2|0;n=a[g]|0;o=((l&3)<<4|(a[g+1|0]&3)<<2|(n&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=o;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=n&63|128;break};case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=(m&255)>>4|224;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(m&15)<<2|(l&255)>>6|128;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=(l&255)>>6|(m&255)<<2|192;q=e;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function Byc(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2+1|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[(c[k>>2]|0)+1|0]|0)<<8|(d[c[k>>2]|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function Cyc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0;c=i;i=i+24|0;a:do{switch(a&255|0){case 223:case 222:case 221:case 220:{d=8;break};case 255:{if(!(((b&255)+ -254|0)>>>0<2)){e=6;break a}d=0;break};case 219:case 218:case 217:case 216:{d=7;break};default:{e=6}}}while(0);if((e|0)==6){d=29}i=c;return d|0}function Dyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 19:{k=Fyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Cyc(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 7:{n=35;break b;break};case 6:{n=32;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Eyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Cyc(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=27;break b}break};case 18:{n=38;break b;break};case 6:{n=32;break b;break};case 5:{n=29;break b;break};case 7:{n=35;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function Fyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=120){break}k=Gyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Cyc(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function Gyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Cyc(a[g+1|0]|0,a[b]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Cyc(a[g+1|0]|0,a[b]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function Hyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 24:case 22:{break};case 15:{k=Kyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 17:{k=Lyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){n=d[j+76+(d[g]|0)|0]|0}else{n=Cyc(a[g+1|0]|0,a[b]|0)|0}if((n|0)==27){k=Iyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==20){k=Jyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[m]|0)|0]|0}else{p=Cyc(a[m+1|0]|0,a[b]|0)|0}switch(p|0){case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b+1|0]|0)==0){q=d[j+76+(d[m]|0)|0]|0}else{q=Cyc(a[m+1|0]|0,a[b]|0)|0}switch(q|0){case 5:{o=59;break b;break};case 24:case 22:{break};case 7:{o=65;break b;break};case 6:{o=62;break b;break};case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=57;break b}break};default:{o=68;break b}}b=b+2|0;continue b;break};case 6:{o=42;break b;break};case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){o=37;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{o=39;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 7:{o=45;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b+1|0]|0)==0){r=d[j+76+(d[q]|0)|0]|0}else{r=Cyc(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 7:{o=84;break d;break};case 6:{o=81;break d;break};case 17:{break c;break};case 29:{o=75;break d;break};case 5:{o=78;break d;break};case 24:case 22:{break d;break};case 11:{o=90;break c;break};case 10:case 9:case 21:{break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=Myc(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function Iyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b+1|0]|0)==0){if((a[b]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b+1|0]|0)==0){k=d[j+76+(d[g]|0)|0]|0}else{k=Cyc(a[g+1|0]|0,a[b]|0)|0}switch(k|0){case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b+1|0]|0)!=0){continue b}if((a[b]|0)==45){l=25;break b}else{continue b}break};case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b+1|0]|0)==0){if((a[b]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function Jyc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k+1|0]|0)!=0){l=7;break}if((a[g]|0)!=(a[285624+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function Kyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b+1|0]|0)==0){o=d[k+76+(d[n]|0)|0]|0}else{o=Cyc(a[n+1|0]|0,a[b]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b+1|0]|0)==0){q=d[k+76+(d[o]|0)|0]|0}else{q=Cyc(a[o+1|0]|0,a[b]|0)|0}switch(q|0){case 6:{p=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 7:{p=34;break b;break};case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){p=26;break b}break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};case 15:{p=62;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((Nyc(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b+1|0]|0)==0){r=d[k+76+(d[q]|0)|0]|0}else{r=Cyc(a[q+1|0]|0,a[b]|0)|0}switch(r|0){case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b+1|0]|0)!=0){continue c}if((a[b]|0)==62){p=59;break c}else{continue c}break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((Nyc(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b+1|0]|0)!=0){break}if((a[b]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function Lyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Cyc(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 7:{n=34;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{n=31;break b;break};case 5:{n=28;break b;break};case 11:{n=48;break b;break};case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 23:{b=b+2|0;continue b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b+1|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Cyc(a[o+1|0]|0,a[b]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}function Myc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;i=i+80|0;j=h+16|0;k=b;c[j>>2]=e;e=f;f=g;g=0;a:while(1){if((c[j>>2]|0)==(e|0)){l=115;break}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){m=d[k+76+(d[b]|0)|0]|0}else{m=Cyc(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b:do{switch(m|0){case 27:case 26:case 25:case 24:case 22:{l=9;break};case 7:{l=16;break a;break};case 23:{if((g|0)!=0){l=20;break a}g=1;c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=22;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){n=d[k+76+(d[b]|0)|0]|0}else{n=Cyc(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}switch(n|0){case 6:{l=33;break a;break};case 24:case 22:{break};case 5:{l=30;break a;break};case 7:{l=36;break a;break};case 29:{if((c[283680+((d[283424+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=28;break a}break};default:{l=39;break a}}c[j>>2]=(c[j>>2]|0)+2;continue a;break};case 29:{if((c[283680+((d[284960+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)!=0){l=9}else{l=8;break a}break};case 5:{l=10;break a;break};case 10:case 9:case 21:{while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=41;break a}b=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){o=d[k+76+(d[b]|0)|0]|0}else{o=Cyc(a[b+1|0]|0,a[c[j>>2]|0]|0)|0}b=o;if((b|0)==14){break b}p=b;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=47;break a}}break};case 6:{l=13;break a;break};case 14:{break};default:{l=114;break a}}}while(0);if((l|0)==9){l=0;c[j>>2]=(c[j>>2]|0)+2;continue}g=0;while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=50;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){q=d[k+76+(d[p]|0)|0]|0}else{q=Cyc(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}r=q;if((r|0)==12|(r|0)==13){break}p=r;if(!((p|0)==9|(p|0)==10|(p|0)==21)){l=56;break a}}c[j>>2]=(c[j>>2]|0)+2;c:while(1){if((c[j>>2]|0)==(e|0)){l=59;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){s=d[k+76+(d[p]|0)|0]|0}else{s=Cyc(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}p=s;if((p|0)==(r|0)){break}switch(p|0){case 3:{t=Dyc(k,(c[j>>2]|0)+2|0,e,j)|0;if((t|0)<=0){l=76;break a}else{continue c}break};case 5:{if((e-(c[j>>2]|0)|0)<2){l=66;break a}c[j>>2]=(c[j>>2]|0)+2;continue c;break};case 6:{if((e-(c[j>>2]|0)|0)<3){l=69;break a}c[j>>2]=(c[j>>2]|0)+3;continue c;break};case 7:{if((e-(c[j>>2]|0)|0)<4){l=72;break a}c[j>>2]=(c[j>>2]|0)+4;continue c;break};case 8:case 1:case 0:{l=74;break a;break};case 2:{l=79;break a;break};default:{c[j>>2]=(c[j>>2]|0)+2;continue c}}}c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=82;break}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){u=d[k+76+(d[p]|0)|0]|0}else{u=Cyc(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(u|0){case 11:{l=106;break a;break};case 10:case 9:case 21:{break};case 17:{l=107;break a;break};default:{l=87;break a}}d:while(1){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){l=89;break a}p=c[j>>2]|0;if((a[(c[j>>2]|0)+1|0]|0)==0){v=d[k+76+(d[p]|0)|0]|0}else{v=Cyc(a[p+1|0]|0,a[c[j>>2]|0]|0)|0}switch(v|0){case 6:{l=100;break a;break};case 11:{l=106;break a;break};case 24:case 22:{break d;break};case 10:case 9:case 21:{break};case 29:{l=94;break d;break};case 5:{l=97;break a;break};case 17:{l=107;break a;break};case 7:{l=103;break a;break};default:{l=113;break a}}}if((l|0)==94){l=0;if((c[283680+((d[283424+(d[(c[j>>2]|0)+1|0]|0)|0]<<3)+(d[c[j>>2]|0]>>5)<<2)>>2]&1<<(a[c[j>>2]|0]&31)|0)==0){l=95;break}}c[j>>2]=(c[j>>2]|0)+2}if((l|0)==8){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==10){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==13){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==16){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==20){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==22){w=-1;x=w;i=h;return x|0}else if((l|0)==28){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==30){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==33){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==36){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==39){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==41){w=-1;x=w;i=h;return x|0}else if((l|0)==47){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==50){w=-1;x=w;i=h;return x|0}else if((l|0)==56){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==59){w=-1;x=w;i=h;return x|0}else if((l|0)==66){w=-2;x=w;i=h;return x|0}else if((l|0)==69){w=-2;x=w;i=h;return x|0}else if((l|0)==72){w=-2;x=w;i=h;return x|0}else if((l|0)==74){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==76){if((t|0)==0){c[f>>2]=c[j>>2]}w=t;x=w;i=h;return x|0}else if((l|0)==79){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==82){w=-1;x=w;i=h;return x|0}else if((l|0)==87){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==89){w=-1;x=w;i=h;return x|0}else if((l|0)==95){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==97){if((e-(c[j>>2]|0)|0)<2){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==100){if((e-(c[j>>2]|0)|0)<3){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==103){if((e-(c[j>>2]|0)|0)<4){w=-2;x=w;i=h;return x|0}else{c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}}else if((l|0)==106){c[f>>2]=(c[j>>2]|0)+2;w=1;x=w;i=h;return x|0}else if((l|0)==107){c[j>>2]=(c[j>>2]|0)+2;if((c[j>>2]|0)==(e|0)){w=-1;x=w;i=h;return x|0}do{if((a[(c[j>>2]|0)+1|0]|0)==0){if((a[c[j>>2]|0]|0)!=62){break}c[f>>2]=(c[j>>2]|0)+2;w=3;x=w;i=h;return x|0}}while(0);c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==113){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==114){c[f>>2]=c[j>>2];w=0;x=w;i=h;return x|0}else if((l|0)==115){w=-1;x=w;i=h;return x|0}return 0}function Nyc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;g=d;d=f;f=0;c[d>>2]=11;if((e-g|0)!=6){h=1;j=h;i=b;return j|0}if((a[g+1|0]|0)==0){k=a[g]|0}else{k=-1}if((k|0)==88){f=1}else if((k|0)!=120){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){l=a[g]|0}else{l=-1}if((l|0)==77){f=1}else if((l|0)!=109){h=1;j=h;i=b;return j|0}g=g+2|0;if((a[g+1|0]|0)==0){m=a[g]|0}else{m=-1}if((m|0)==76){f=1}else if((m|0)!=108){h=1;j=h;i=b;return j|0}if((f|0)!=0){h=0;j=h;i=b;return j|0}else{c[d>>2]=12;h=1;j=h;i=b;return j|0}return 0}function Oyc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+56|0;k=b;b=e;e=f;f=g;g=h;a:while(1){if((e|0)==(f|0)){l=27;break}h=e;if((a[e+1|0]|0)==0){m=d[b+76+(d[h]|0)|0]|0}else{m=Cyc(a[h+1|0]|0,a[e]|0)|0}h=m;switch(h|0){case 5:{if((f-e|0)<2){l=8;break a}e=e+2|0;continue a;break};case 13:case 12:{e=e+2|0;if((h|0)!=(k|0)){continue a}else{l=18;break a}break};case 7:{if((f-e|0)<4){l=14;break a}e=e+4|0;continue a;break};case 8:case 1:case 0:{l=16;break a;break};case 6:{if((f-e|0)<3){l=11;break a}e=e+3|0;continue a;break};default:{e=e+2|0;continue a}}}if((l|0)==8){n=-2;o=n;i=j;return o|0}else if((l|0)==11){n=-2;o=n;i=j;return o|0}else if((l|0)==14){n=-2;o=n;i=j;return o|0}else if((l|0)==16){c[g>>2]=e;n=0;o=n;i=j;return o|0}else if((l|0)==18){if((e|0)==(f|0)){n=-27;o=n;i=j;return o|0}c[g>>2]=e;g=e;if((a[e+1|0]|0)==0){p=d[b+76+(d[g]|0)|0]|0}else{p=Cyc(a[g+1|0]|0,a[e]|0)|0}switch(p|0){case 20:case 30:case 11:case 10:case 9:case 21:{n=27;o=n;i=j;return o|0};default:{n=0;o=n;i=j;return o|0}}}else if((l|0)==27){n=-1;o=n;i=j;return o|0}return 0}function Pyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}if((m|0)==24|(m|0)==22){b=b+2|0;a:while(1){if((b|0)==(e|0)){n=26;break}g=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[g]|0)|0]|0}else{o=Cyc(a[g+1|0]|0,a[b]|0)|0}switch(o|0){case 30:{n=16;break a;break};case 24:case 22:{break};case 10:case 9:case 21:{break a;break};default:{n=25;break a}}b=b+2|0}do{if((n|0)==16){if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}o=b+2|0;if((a[b+3|0]|0)==0){p=d[j+76+(d[o]|0)|0]|0}else{p=Cyc(a[o+1|0]|0,a[b+2|0]|0)|0}if(!((p|0)==30|(p|0)==10|(p|0)==9|(p|0)==21)){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==25){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==26){k=-1;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=16;l=k;i=h;return l|0}else if((m|0)==20){c[f>>2]=b+2;k=33;l=k;i=h;return l|0}else if((m|0)==27){k=Iyc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}return 0}function Qyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b+1|0]|0)==0){m=d[j+76+(d[g]|0)|0]|0}else{m=Cyc(a[g+1|0]|0,a[b]|0)|0}a:do{switch(m|0){case 29:{if((c[283680+((d[283424+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=39;break}m=b;if((a[b+1|0]|0)==0){o=d[j+76+(d[m]|0)|0]|0}else{o=Cyc(a[m+1|0]|0,a[b]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 29:{if((c[283680+((d[284960+(d[b+1|0]|0)|0]<<3)+(d[b]>>5)<<2)>>2]&1<<(a[b]&31)|0)==0){n=26;break b}break};case 7:{n=34;break b;break};case 5:{n=28;break b;break};case 36:case 30:case 11:case 32:case 21:case 10:case 9:{n=37;break b;break};case 6:{n=31;break b;break};default:{n=38;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){c[f>>2]=b;k=20;l=k;i=h;return l|0}else if((n|0)==38){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==39){k=-20;l=k;i=h;return l|0}return 0}function Ryc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:case 21:{n=25;break};case 9:{if((b+2|0)!=(e|0)){n=25;break a}c[f>>2]=e;k=-15;l=k;i=h;return l|0};case 31:{c[f>>2]=b+2;k=23;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-26;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=93){break}if((b+2|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b+2|0]|0)!=0){break}if((a[b+3|0]|0)!=62){break}c[f>>2]=b+4;k=34;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=26;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=tzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 12:{k=rzc(12,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 32:{b=b+2|0;if((b|0)==(e|0)){k=-24;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){o=d[j+76+(d[g+1|0]|0)|0]|0}else{o=Cyc(a[g]|0,a[b+1|0]|0)|0}switch(o|0){case 34:{c[f>>2]=b+2;k=37;l=k;i=h;return l|0};case 33:{c[f>>2]=b+2;k=36;l=k;i=h;return l|0};case 32:case 36:case 35:case 11:case 21:case 10:case 9:{c[f>>2]=b;k=24;l=k;i=h;return l|0};case 15:{c[f>>2]=b+2;k=35;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 13:{k=rzc(13,j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 2:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){p=d[j+76+(d[g+1|0]|0)|0]|0}else{p=Cyc(a[g]|0,a[b+1|0]|0)|0}switch(p|0){case 16:{k=szc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 7:case 6:case 5:case 29:case 24:case 22:{c[f>>2]=b+ -2;k=29;l=k;i=h;return l|0};case 15:{k=nzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}break};case 20:{c[f>>2]=b+2;k=25;l=k;i=h;return l|0};case 35:{c[f>>2]=b+2;k=38;l=k;i=h;return l|0};case 11:{c[f>>2]=b+2;k=17;l=k;i=h;return l|0};case 36:{c[f>>2]=b+2;k=21;l=k;i=h;return l|0};case 30:{k=hzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 29:{g=b;if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){b=g+2|0;q=18;n=77;break a}if((c[283680+((d[284960+(d[g]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=76;break a}b=b+2|0;q=19;n=77;break};case 23:case 27:case 26:case 25:{q=19;b=b+2|0;n=77;break};case 24:case 22:{q=18;b=b+2|0;n=77;break};default:{n=76}}}while(0);if((n|0)==25){while(1){n=0;b=b+2|0;r=b;if((b|0)==(e|0)){n=32;break}p=b;if((a[r]|0)==0){s=d[j+76+(d[p+1|0]|0)|0]|0}else{s=Cyc(a[p]|0,a[b+1|0]|0)|0}if((s|0)==10|(s|0)==21){n=25;continue}else if((s|0)!=9){n=31;break}if((b+2|0)!=(e|0)){n=25}else{n=31;break}}if((n|0)==31){c[f>>2]=b;k=15;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=r;k=15;l=k;i=h;return l|0}}else if((n|0)==76){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==77){b:while(1){n=0;if((b|0)==(e|0)){n=126;break}r=b;if((a[b]|0)==0){t=d[j+76+(d[r+1|0]|0)|0]|0}else{t=Cyc(a[r]|0,a[b+1|0]|0)|0}switch(t|0){case 5:{n=85;break b;break};case 33:{n=119;break b;break};case 34:{n=116;break b;break};case 6:{n=88;break b;break};case 15:{n=122;break b;break};case 10:case 9:case 21:case 30:case 20:case 36:case 35:case 32:case 11:{n=94;break b;break};case 7:{n=91;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 23:{b=b+2|0;r=q;if((r|0)==41){q=19;n=77;continue b}else if((r|0)!=18){n=77;continue b}if((b|0)==(e|0)){n=97;break b}q=41;r=b;if((a[b]|0)==0){u=d[j+76+(d[r+1|0]|0)|0]|0}else{u=Cyc(a[r]|0,a[b+1|0]|0)|0}switch(u|0){case 6:{n=108;break b;break};case 7:{n=111;break b;break};case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=103;break b}break};case 5:{n=105;break b;break};case 27:case 26:case 25:case 24:case 22:{break};default:{q=19;n=77;continue b}}b=b+2|0;n=77;continue b;break};case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=83;break b}break};default:{n=125;break b}}b=b+2|0;n=77}if((n|0)==83){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==85){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==88){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==91){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==94){c[f>>2]=b;k=q;l=k;i=h;return l|0}else if((n|0)==97){k=-1;l=k;i=h;return l|0}else if((n|0)==103){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==105){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==108){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==111){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==116){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=32;l=k;i=h;return l|0}}else if((n|0)==119){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=31;l=k;i=h;return l|0}}else if((n|0)==122){e=b;if((q|0)==19){c[f>>2]=e;k=0;l=k;i=h;return l|0}else{c[f>>2]=e+2;k=30;l=k;i=h;return l|0}}else if((n|0)==125){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==126){k=0-q|0;l=k;i=h;return l|0}}return 0}function Syc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 2:{k=kzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 3:{k=gzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Cyc(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-5;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=68;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Cyc(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:{if((b+2|0)==(e|0)){p=66;break b}do{if((a[b+2|0]|0)==0){if((a[b+3|0]|0)!=93){break}if((b+4|0)==(e|0)){p=66;break b}if((a[b+4|0]|0)==0){if((a[b+5|0]|0)==62){p=65;break b}}b=b+2|0;continue b}}while(0);b=b+2|0;continue b;break};case 10:case 9:case 8:case 1:case 0:case 2:case 3:{p=66;break b;break};case 5:{r=b;if((e-b|0)<2){p=49;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=55;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=52;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==49){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==52){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==65){c[f>>2]=b+4;k=0;l=k;i=h;return l|0}else if((p|0)==66){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==68){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Tyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=e-b|0;do{if((g&1|0)!=0){g=g&-2;if((g|0)!=0){e=b+g|0;break}k=-1;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 10:{c[f>>2]=b+2;k=7;l=k;i=h;return l|0};case 7:{if((e-b|0)>=4){b=b+4|0;break a}k=-2;l=k;i=h;return l|0};case 8:case 1:case 0:{c[f>>2]=b;k=0;l=k;i=h;return l|0};case 4:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}if((a[b]|0)!=0){break a}if((a[b+1|0]|0)!=93){break a}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=40;l=k;i=h;return l|0}}while(0);b=b+ -2|0;break};case 9:{b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Cyc(a[g]|0,a[b+1|0]|0)|0}if((n|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0};case 5:{if((e-b|0)>=2){b=b+2|0;break a}k=-2;l=k;i=h;return l|0};case 6:{if((e-b|0)>=3){b=b+3|0;break a}k=-2;l=k;i=h;return l|0};default:{b=b+2|0}}}while(0);b:while(1){o=b;if((b|0)==(e|0)){p=57;break}n=b;if((a[o]|0)==0){q=d[j+76+(d[n+1|0]|0)|0]|0}else{q=Cyc(a[n]|0,a[b+1|0]|0)|0}switch(q|0){case 4:case 10:case 9:case 8:case 1:case 0:{p=55;break b;break};case 5:{r=b;if((e-b|0)<2){p=47;break b}b=r+2|0;continue b;break};case 7:{s=b;if((e-b|0)<4){p=53;break b}b=s+4|0;continue b;break};case 6:{t=b;if((e-b|0)<3){p=50;break b}b=t+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((p|0)==47){c[f>>2]=r;k=6;l=k;i=h;return l|0}else if((p|0)==50){c[f>>2]=t;k=6;l=k;i=h;return l|0}else if((p|0)==53){c[f>>2]=s;k=6;l=k;i=h;return l|0}else if((p|0)==55){c[f>>2]=b;k=6;l=k;i=h;return l|0}else if((p|0)==57){c[f>>2]=o;k=6;l=k;i=h;return l|0}return 0}function Uyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=0;k=e-b|0;if((k&1|0)!=0){k=k&-2;e=b+k|0}a:while(1){if((b|0)==(e|0)){l=39;break}k=b;if((a[b]|0)==0){m=d[j+76+(d[k+1|0]|0)|0]|0}else{m=Cyc(a[k]|0,a[b+1|0]|0)|0}switch(m|0){case 7:{if((e-b|0)<4){l=15;break a}b=b+4|0;continue a;break};case 6:{if((e-b|0)<3){l=12;break a}b=b+3|0;continue a;break};case 4:{k=b+2|0;b=k;if((k|0)==(e|0)){l=28;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=93){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=32;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=62){continue a}b=b+2|0;if((g|0)==0){l=36;break a}g=g+ -1|0;continue a;break};case 5:{if((e-b|0)<2){l=9;break a}b=b+2|0;continue a;break};case 8:case 1:case 0:{l=17;break a;break};case 2:{k=b+2|0;b=k;if((k|0)==(e|0)){l=19;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=33){continue a}k=b+2|0;b=k;if((k|0)==(e|0)){l=23;break a}if((a[b]|0)!=0){continue a}if((a[b+1|0]|0)!=91){continue a}g=g+1|0;b=b+2|0;continue a;break};default:{b=b+2|0;continue a}}}if((l|0)==9){n=-2;o=n;i=h;return o|0}else if((l|0)==12){n=-2;o=n;i=h;return o|0}else if((l|0)==15){n=-2;o=n;i=h;return o|0}else if((l|0)==17){c[f>>2]=b;n=0;o=n;i=h;return o|0}else if((l|0)==19){n=-1;o=n;i=h;return o|0}else if((l|0)==23){n=-1;o=n;i=h;return o|0}else if((l|0)==28){n=-1;o=n;i=h;return o|0}else if((l|0)==32){n=-1;o=n;i=h;return o|0}else if((l|0)==36){c[f>>2]=b;n=42;o=n;i=h;return o|0}else if((l|0)==39){n=-1;o=n;i=h;return o|0}return 0}function Vyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=33;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Cyc(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 6:{b=b+3|0;continue a;break};case 21:{n=29;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 9:{n=19;break a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=16;break a;break};case 2:{n=15;break a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=gzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==16){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==19){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Cyc(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==29){q=b;if((b|0)==(g|0)){c[f>>2]=q+2;k=39;l=k;i=h;return l|0}else{c[f>>2]=q;k=6;l=k;i=h;return l|0}}else if((n|0)==33){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Wyc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-4;l=k;i=h;return l|0}g=b;a:while(1){m=b;if((b|0)==(e|0)){n=32;break}o=b;if((a[m]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Cyc(a[o]|0,a[b+1|0]|0)|0}switch(p|0){case 30:{n=15;break a;break};case 5:{b=b+2|0;continue a;break};case 10:{n=18;break a;break};case 9:{n=21;break a;break};case 7:{b=b+4|0;continue a;break};case 3:{n=12;break a;break};case 6:{b=b+3|0;continue a;break};default:{b=b+2|0;continue a}}}if((n|0)==12){if((b|0)==(g|0)){k=gzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==15){if((b|0)==(g|0)){p=hzc(j,b+2|0,e,f)|0;k=(p|0)==22?0:p;l=k;i=h;return l|0}else{c[f>>2]=b;k=6;l=k;i=h;return l|0}}else if((n|0)==18){p=b;if((b|0)==(g|0)){c[f>>2]=p+2;k=7;l=k;i=h;return l|0}else{c[f>>2]=p;k=6;l=k;i=h;return l|0}}else if((n|0)==21){p=b;if((b|0)!=(g|0)){c[f>>2]=p;k=6;l=k;i=h;return l|0}b=p+2|0;if((b|0)==(e|0)){k=-3;l=k;i=h;return l|0}e=b;if((a[b]|0)==0){q=d[j+76+(d[e+1|0]|0)|0]|0}else{q=Cyc(a[e]|0,a[b+1|0]|0)|0}if((q|0)==10){b=b+2|0}c[f>>2]=b;k=7;l=k;i=h;return l|0}else if((n|0)==32){c[f>>2]=m;k=6;l=k;i=h;return l|0}return 0}function Xyc(b,c,e){b=b|0;c=c|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;i=i+32|0;g=b;b=c;c=e;a:while(1){e=b;if((a[b]|0)==0){h=d[g+76+(d[e+1|0]|0)|0]|0}else{h=Cyc(a[e]|0,a[b+1|0]|0)|0}switch(h|0){case 7:{e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=7;break a}else{k=8}break};case 6:{k=8;break};case 5:{break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{j=c;c=j+1|0;e=b;b=e+1|0;if((a[j]|0)!=(a[e]|0)){k=15;break a}e=c;c=e+1|0;j=b;b=j+1|0;if((a[e]|0)!=(a[j]|0)){k=17;break a}else{continue a}break};default:{k=18;break a}}if((k|0)==8){k=0;j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=9;break}}e=b;b=e+1|0;j=c;c=j+1|0;if((a[e]|0)!=(a[j]|0)){k=11;break}j=b;b=j+1|0;e=c;c=e+1|0;if((a[j]|0)!=(a[e]|0)){k=13;break}}if((k|0)==7){l=0;m=l;i=f;return m|0}else if((k|0)==9){l=0;m=l;i=f;return m|0}else if((k|0)==11){l=0;m=l;i=f;return m|0}else if((k|0)==13){l=0;m=l;i=f;return m|0}else if((k|0)==15){l=0;m=l;i=f;return m|0}else if((k|0)==17){l=0;m=l;i=f;return m|0}else if((k|0)==18){k=c;if((a[c]|0)==0){n=d[g+76+(d[k+1|0]|0)|0]|0}else{n=Cyc(a[k]|0,a[c+1|0]|0)|0}switch(n|0){case 27:case 26:case 25:case 24:case 23:case 22:case 29:case 7:case 6:case 5:{l=0;m=l;i=f;return m|0};default:{l=1;m=l;i=f;return m|0}}}return 0}function Yyc(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;b=i;i=i+40|0;f=c;c=d;d=e;while(1){g=(f|0)==(c|0);if((a[d]|0)==0){h=9;break}if(g){h=4;break}if((a[f]|0)!=0){h=7;break}if((a[f+1|0]|0)!=(a[d]|0)){h=7;break}f=f+2|0;d=d+1|0}if((h|0)==4){j=0;k=j;i=b;return k|0}else if((h|0)==7){j=0;k=j;i=b;return k|0}else if((h|0)==9){j=g&1;k=j;i=b;return k|0}return 0}function Zyc(b,c){b=b|0;c=c|0;var e=0,f=0,g=0,h=0;e=i;i=i+24|0;f=b;b=c;c=b;a:while(1){g=b;if((a[b]|0)==0){h=d[f+76+(d[g+1|0]|0)|0]|0}else{h=Cyc(a[g]|0,a[b+1|0]|0)|0}switch(h|0){case 5:{b=b+2|0;continue a;break};case 7:{b=b+4|0;continue a;break};case 27:case 26:case 25:case 24:case 23:case 22:case 29:{b=b+2|0;continue a;break};case 6:{b=b+3|0;continue a;break};default:{break a}}}i=e;return b-c|0}function _yc(b,c){b=b|0;c=c|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=c;while(1){c=b;if((a[b]|0)==0){g=d[f+76+(d[c+1|0]|0)|0]|0}else{g=Cyc(a[c]|0,a[b+1|0]|0)|0}if(!((g|0)==21|(g|0)==9|(g|0)==10)){break}b=b+2|0}i=e;return b|0}function $yc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;h=i;i=i+56|0;j=b;b=e;e=f;f=g;g=1;k=0;l=0;b=b+2|0;a:while(1){m=b;if((a[b]|0)==0){n=d[j+76+(d[m+1|0]|0)|0]|0}else{n=Cyc(a[m]|0,a[b+1|0]|0)|0}b:do{switch(n|0){case 10:case 9:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 6:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+1|0;break};case 21:{if((g|0)==1){g=0;break b}if((g|0)!=2){break b}if((k|0)>=(e|0)){break b}if((a[f+(k<<4)+12|0]|0)==0){break b}do{if((b|0)!=(c[f+(k<<4)+4>>2]|0)){if((a[b]|0)==0){o=a[b+1|0]|0}else{o=-1}if((o|0)!=32){break}if((a[b+2|0]|0)==0){p=a[b+3|0]|0}else{p=-1}if((p|0)==32){break}m=b+2|0;if((a[b+2|0]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Cyc(a[m]|0,a[b+3|0]|0)|0}if((q|0)!=(l|0)){break b}}}while(0);a[f+(k<<4)+12|0]=0;break};case 13:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=13;break b}if((l|0)!=13){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 17:case 11:{if((g|0)!=2){break a}break};case 24:case 22:case 29:{if((g|0)!=0){break b}if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1;break};case 12:{if((g|0)!=2){if((k|0)<(e|0)){c[f+(k<<4)+4>>2]=b+2}g=2;l=12;break b}if((l|0)!=12){break b}g=0;if((k|0)<(e|0)){c[f+(k<<4)+8>>2]=b}k=k+1|0;break};case 5:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b;break};case 3:{if((k|0)>=(e|0)){break b}a[f+(k<<4)+12|0]=0;break};case 7:{if((g|0)==0){if((k|0)<(e|0)){c[f+(k<<4)>>2]=b;a[f+(k<<4)+12|0]=1}g=1}b=b+2|0;break};default:{}}}while(0);b=b+2|0}i=h;return k|0}function azc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+48|0;d=c;c=0;d=d+4|0;a:do{if((a[d]|0)==0){if((a[d+1|0]|0)!=120){e=16;break}d=d+2|0;while(1){if((a[d]|0)==0){f=(a[d+1|0]|0)==59}else{f=0}if(!(f^1)){break a}if((a[d]|0)==0){g=a[d+1|0]|0}else{g=-1}h=g;switch(h|0){case 70:case 69:case 68:case 67:case 66:case 65:{c=c<<4;c=c+(10+(h-65))|0;break};case 102:case 101:case 100:case 99:case 98:case 97:{c=c<<4;c=c+(10+(h-97))|0;break};case 57:case 56:case 55:case 54:case 53:case 52:case 51:case 50:case 49:case 48:{c=c<<4;c=c|h-48;break};default:{}}if((c|0)>=1114112){break}d=d+2|0}j=-1;k=j;i=b;return k|0}else{e=16}}while(0);b:do{if((e|0)==16){while(1){e=0;if((a[d]|0)==0){l=(a[d+1|0]|0)==59}else{l=0}if(!(l^1)){break b}if((a[d]|0)==0){m=a[d+1|0]|0}else{m=-1}c=c*10|0;c=c+(m-48)|0;if((c|0)>=1114112){break}d=d+2|0;e=16}j=-1;k=j;i=b;return k|0}}while(0);j=Qxc(c)|0;k=j;i=b;return k|0}function bzc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;b=i;i=i+32|0;e=c;c=(d-e|0)/2|0;do{if((c|0)==3){if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=97){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=109){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}f=38;g=f;i=b;return g|0}else if((c|0)==4){if((a[e]|0)==0){h=a[e+1|0]|0}else{h=-1}if((h|0)==113){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=117){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=116){break}f=34;g=f;i=b;return g|0}else if((h|0)==97){e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=112){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=111){break}e=e+2|0;if((a[e]|0)!=0){break}if((a[e+1|0]|0)!=115){break}f=39;g=f;i=b;return g|0}else{break}}else if((c|0)==2){if((a[e+2|0]|0)!=0){break}if((a[e+3|0]|0)!=116){break}if((a[e]|0)==0){j=a[e+1|0]|0}else{j=-1}if((j|0)==108){f=60;g=f;i=b;return g|0}else if((j|0)==103){f=62;g=f;i=b;return g|0}else{break}}}while(0);f=0;g=f;i=b;return g|0}function czc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;h=i;i=i+32|0;j=b;b=e;e=f;f=g;while(1){if(!(b>>>0<e>>>0)){break}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Cyc(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 10:{c[f+4>>2]=-1;g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;break};case 6:{b=b+3|0;break};case 5:{b=b+2|0;break};case 7:{b=b+4|0;break};case 9:{g=f;c[g>>2]=(c[g>>2]|0)+1;b=b+2|0;do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Cyc(a[g]|0,a[b+1|0]|0)|0}if((l|0)!=10){break}b=b+2|0}}while(0);c[f+4>>2]=-1;break};default:{b=b+2|0}}g=f+4|0;c[g>>2]=(c[g>>2]|0)+1}i=h;return}function dzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;b=b+2|0;e=e+ -2|0;a:while(1){if((b|0)==(e|0)){k=18;break}g=b;if((a[b]|0)==0){l=d[j+76+(d[g+1|0]|0)|0]|0}else{l=Cyc(a[g]|0,a[b+1|0]|0)|0}b:do{switch(l|0){case 22:case 26:{if((a[b]|0)==0){m=a[b+1|0]|0}else{m=-1}if((m&-128|0)!=0){k=13}break};case 23:case 19:case 30:case 33:case 16:case 18:case 10:case 9:case 15:case 14:case 17:case 35:case 34:case 32:case 31:case 13:case 27:case 24:case 25:{break};case 21:{if((a[b]|0)!=0){break b}if((a[b+1|0]|0)==9){k=9;break a}break};default:{k=13}}}while(0);if((k|0)==13){k=0;if((a[b]|0)==0){n=a[b+1|0]|0}else{n=-1}if(!((n|0)==64|(n|0)==36)){k=16;break}}b=b+2|0}if((k|0)==9){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==16){c[f>>2]=b;o=0;p=o;i=h;return p|0}else if((k|0)==18){o=1;p=o;i=h;return p|0}return 0}function ezc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+80|0;h=d;d=e;e=f;f=g;g=c[h>>2]|0;a:while(1){j=g;if((g|0)==(d|0)){k=18;break}l=a[j+1|0]|0;m=a[g]|0;b:do{switch(m&255|0){case 0:{if((l&255|0)>=128){k=8;break b}if((c[e>>2]|0)==(f|0)){k=6;break a}n=e;o=c[n>>2]|0;c[n>>2]=o+1;a[o]=l;break};case 7:case 6:case 5:case 4:case 3:case 2:case 1:{k=8;break};case 219:case 218:case 217:case 216:{if((f-(c[e>>2]|0)|0)<4){k=15;break a}o=((m&3)<<2|(l&255)>>6&3)+1|0;n=e;p=c[n>>2]|0;c[n>>2]=p+1;a[p]=o>>2|240;p=e;n=c[p>>2]|0;c[p>>2]=n+1;a[n]=(l&255)>>2&15|(o&3)<<4|128;g=g+2|0;o=a[g+1|0]|0;n=((l&3)<<4|(a[g]&3)<<2|(o&255)>>6|128)&255;p=e;q=c[p>>2]|0;c[p>>2]=q+1;a[q]=n;n=e;q=c[n>>2]|0;c[n>>2]=q+1;a[q]=o&63|128;break};default:{if((f-(c[e>>2]|0)|0)<3){k=12;break a}o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=(m&255)>>4|224;q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(m&15)<<2|(l&255)>>6|128;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}}}while(0);if((k|0)==8){k=0;if((f-(c[e>>2]|0)|0)<2){k=9;break}q=e;o=c[q>>2]|0;c[q>>2]=o+1;a[o]=(l&255)>>6|(m&255)<<2|192;o=e;q=c[o>>2]|0;c[o>>2]=q+1;a[q]=l&63|128}g=g+2|0}if((k|0)==6){c[h>>2]=g;i=b;return}else if((k|0)==9){c[h>>2]=g;i=b;return}else if((k|0)==12){c[h>>2]=g;i=b;return}else if((k|0)==15){c[h>>2]=g;i=b;return}else if((k|0)==18){c[h>>2]=j;i=b;return}}function fzc(e,f,g,h,j){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0;e=i;i=i+40|0;k=f;f=g;g=h;h=j;do{if((f-(c[k>>2]|0)|0)>(((h-(c[g>>2]|0)|0)/2|0)<<1|0)){if((a[f+ -2|0]&248|0)!=216){break}f=f+ -2|0}}while(0);while(1){if((c[k>>2]|0)==(f|0)){l=7;break}if((c[g>>2]|0)==(h|0)){l=7;break}j=((d[c[k>>2]|0]|0)<<8|(d[(c[k>>2]|0)+1|0]|0))&65535;m=g;n=c[m>>2]|0;c[m>>2]=n+2;b[n>>1]=j;j=k;c[j>>2]=(c[j>>2]|0)+2}if((l|0)==7){i=e;return}}function gzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 19:{k=izc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Cyc(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=29;break b;break};case 6:{n=32;break b;break};case 18:{n=38;break b;break};case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 7:{n=35;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=9;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function hzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 30:case 9:case 10:case 21:{c[f>>2]=b;k=22;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=40;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Cyc(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 6:{n=32;break b;break};case 7:{n=35;break b;break};case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=27;break b}break};case 27:case 26:case 25:case 24:case 22:{break};case 18:{n=38;break b;break};case 5:{n=29;break b;break};default:{n=39;break b}}b=b+2|0}if((n|0)==27){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==29){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==32){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==35){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==38){c[f>>2]=b+2;k=28;l=k;i=h;return l|0}else if((n|0)==39){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==40){k=-1;l=k;i=h;return l|0}return 0}function izc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=120){break}k=jzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}}while(0);g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}g=b;if((m|0)!=25){c[f>>2]=g;k=0;l=k;i=h;return l|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Cyc(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=16;break}else if((n|0)!=25){o=17;break}b=b+2|0}if((o|0)==16){c[f>>2]=b+2;k=10;l=k;i=h;return l|0}else if((o|0)==17){c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);k=-1;l=k;i=h;return l|0}function jzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Cyc(a[g]|0,a[b+1|0]|0)|0}g=b;if(!((k+ -24|0)>>>0<2)){c[f>>2]=g;l=0;m=l;i=h;return m|0}b=g+2|0;while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Cyc(a[g]|0,a[b+1|0]|0)|0}if((n|0)==18){o=13;break}else if(!((n|0)==24|(n|0)==25)){o=14;break}b=b+2|0}if((o|0)==13){c[f>>2]=b+2;l=10;m=l;i=h;return m|0}else if((o|0)==14){c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);l=-1;m=l;i=h;return m|0}function kzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+48|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 16:{g=b+2|0;b=g;if((g|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){n=d[j+76+(d[g+1|0]|0)|0]|0}else{n=Cyc(a[g]|0,a[b+1|0]|0)|0}if((n|0)==20){k=mzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else if((n|0)==27){k=lzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 24:case 22:{break};case 17:{k=ozc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 15:{k=nzc(j,b+2|0,e,f)|0;l=k;i=h;return l|0};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;n=0;b:while(1){if((b|0)==(e|0)){o=98;break}m=b;if((a[b]|0)==0){p=d[j+76+(d[m+1|0]|0)|0]|0}else{p=Cyc(a[m]|0,a[b+1|0]|0)|0}switch(p|0){case 7:{o=45;break b;break};case 10:case 9:case 21:{o=69;break b;break};case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=37;break b}break};case 23:{if((n|0)!=0){o=49;break b}n=1;b=b+2|0;if((b|0)==(e|0)){o=51;break b}m=b;if((a[b]|0)==0){q=d[j+76+(d[m+1|0]|0)|0]|0}else{q=Cyc(a[m]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){o=57;break b}break};case 5:{o=59;break b;break};case 6:{o=62;break b;break};case 7:{o=65;break b;break};case 24:case 22:{break};default:{o=68;break b}}b=b+2|0;continue b;break};case 5:{o=39;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{o=42;break b;break};case 17:{break b;break};case 11:{o=90;break b;break};default:{o=97;break b}}b=b+2|0}c:do{if((o|0)==37){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==39){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==42){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==45){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==51){k=-1;l=k;i=h;return l|0}else if((o|0)==57){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==59){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==62){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==65){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==68){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==69){b=b+2|0;d:while(1){if((b|0)==(e|0)){o=89;break}q=b;if((a[b]|0)==0){r=d[j+76+(d[q+1|0]|0)|0]|0}else{r=Cyc(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{o=78;break d;break};case 17:{break c;break};case 10:case 9:case 21:{break};case 7:{o=84;break d;break};case 11:{o=90;break c;break};case 6:{o=81;break d;break};case 24:case 22:{break d;break};case 29:{o=75;break d;break};default:{o=88;break d}}b=b+2|0}do{if((o|0)==75){if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break}c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==78){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==81){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==84){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((o|0)==88){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==89){k=-1;l=k;i=h;return l|0}}while(0);b=b+2|0;k=pzc(j,b,e,f)|0;l=k;i=h;return l|0}else if((o|0)==97){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((o|0)==98){k=-1;l=k;i=h;return l|0}}while(0);if((o|0)==90){c[f>>2]=b+2;k=2;l=k;i=h;return l|0}b=b+2|0;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;k=4;l=k;i=h;return l|0}}while(0);c[f>>2]=b;k=0;l=k;i=h;return l|0}function lzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;a:do{if((b|0)!=(e|0)){do{if((a[b]|0)==0){if((a[b+1|0]|0)!=45){break}b=b+2|0;b:while(1){if((b|0)==(e|0)){break a}g=b;if((a[b]|0)==0){k=d[j+76+(d[g+1|0]|0)|0]|0}else{k=Cyc(a[g]|0,a[b+1|0]|0)|0}switch(k|0){case 5:{if((e-b|0)<2){l=12;break b}b=b+2|0;continue b;break};case 27:{g=b+2|0;b=g;if((g|0)==(e|0)){l=22;break b}if((a[b]|0)!=0){continue b}if((a[b+1|0]|0)==45){l=25;break b}else{continue b}break};case 7:{if((e-b|0)<4){l=18;break b}b=b+4|0;continue b;break};case 8:case 1:case 0:{l=20;break b;break};case 6:{if((e-b|0)<3){l=15;break b}b=b+3|0;continue b;break};default:{b=b+2|0;continue b}}}if((l|0)==12){m=-2;n=m;i=h;return n|0}else if((l|0)==15){m=-2;n=m;i=h;return n|0}else if((l|0)==18){m=-2;n=m;i=h;return n|0}else if((l|0)==20){c[f>>2]=b;m=0;n=m;i=h;return n|0}else if((l|0)==22){m=-1;n=m;i=h;return n|0}else if((l|0)==25){g=b+2|0;b=g;if((g|0)==(e|0)){m=-1;n=m;i=h;return n|0}do{if((a[b]|0)==0){if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;m=13;n=m;i=h;return n|0}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}}while(0);c[f>>2]=b;m=0;n=m;i=h;return n|0}}while(0);m=-1;n=m;i=h;return n|0}function mzc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;b=i;i=i+48|0;g=d;d=f;if((e-g|0)<12){h=-1;j=h;i=b;return j|0}e=0;while(1){k=g;if((e|0)>=6){l=9;break}if((a[k]|0)!=0){l=7;break}if((a[g+1|0]|0)!=(a[286e3+e|0]|0)){l=7;break}e=e+1|0;g=g+2|0}if((l|0)==7){c[d>>2]=g;h=0;j=h;i=b;return j|0}else if((l|0)==9){c[d>>2]=k;h=8;j=h;i=b;return j|0}return 0}function nzc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;h=i;i=i+56|0;j=h+40|0;k=b;b=e;e=f;f=g;g=b;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}n=b;if((a[b]|0)==0){o=d[k+76+(d[n+1|0]|0)|0]|0}else{o=Cyc(a[n]|0,a[b+1|0]|0)|0}a:do{switch(o|0){case 24:case 22:{break};case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;l=0;m=l;i=h;return m|0};case 5:{if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 7:{if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};case 6:{if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}break};default:{c[f>>2]=b;l=0;m=l;i=h;return m|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){p=70;break}o=b;if((a[b]|0)==0){q=d[k+76+(d[o+1|0]|0)|0]|0}else{q=Cyc(a[o]|0,a[b+1|0]|0)|0}switch(q|0){case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){p=26;break b}break};case 15:{p=62;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 6:{p=31;break b;break};case 7:{p=34;break b;break};case 10:case 9:case 21:{p=37;break b;break};case 5:{p=28;break b;break};default:{break b}}b=b+2|0}do{if((p|0)==26){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==28){if((e-b|0)<2){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==31){if((e-b|0)<3){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==34){if((e-b|0)<4){l=-2;m=l;i=h;return m|0}else{c[f>>2]=b;l=0;m=l;i=h;return m|0}}else if((p|0)==37){q=b;if((qzc(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;c:while(1){if((b|0)==(e|0)){p=61;break}q=b;if((a[b]|0)==0){r=d[k+76+(d[q+1|0]|0)|0]|0}else{r=Cyc(a[q]|0,a[b+1|0]|0)|0}switch(r|0){case 5:{if((e-b|0)<2){p=46;break c}b=b+2|0;continue c;break};case 8:case 1:case 0:{p=54;break c;break};case 7:{if((e-b|0)<4){p=52;break c}b=b+4|0;continue c;break};case 15:{b=b+2|0;if((b|0)==(e|0)){p=56;break c}if((a[b]|0)!=0){continue c}if((a[b+1|0]|0)==62){p=59;break c}else{continue c}break};case 6:{if((e-b|0)<3){p=49;break c}b=b+3|0;continue c;break};default:{b=b+2|0;continue c}}}if((p|0)==46){l=-2;m=l;i=h;return m|0}else if((p|0)==49){l=-2;m=l;i=h;return m|0}else if((p|0)==52){l=-2;m=l;i=h;return m|0}else if((p|0)==54){c[f>>2]=b;l=0;m=l;i=h;return m|0}else if((p|0)==56){l=-1;m=l;i=h;return m|0}else if((p|0)==59){c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==61){l=-1;m=l;i=h;return m|0}}else if((p|0)==62){q=b;if((qzc(k,g,b,j)|0)==0){c[f>>2]=q;l=0;m=l;i=h;return m|0}b=q+2|0;if((b|0)==(e|0)){l=-1;m=l;i=h;return m|0}if((a[b]|0)!=0){break}if((a[b+1|0]|0)!=62){break}c[f>>2]=b+2;l=c[j>>2]|0;m=l;i=h;return m|0}else if((p|0)==70){l=-1;m=l;i=h;return m|0}}while(0);c[f>>2]=b;l=0;m=l;i=h;return m|0}function ozc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+40|0;j=b;b=e;e=f;f=g;if((b|0)==(e|0)){k=-1;l=k;i=h;return l|0}g=b;if((a[b]|0)==0){m=d[j+76+(d[g+1|0]|0)|0]|0}else{m=Cyc(a[g]|0,a[b+1|0]|0)|0}a:do{switch(m|0){case 24:case 22:{break};case 29:{if((c[283680+((d[283424+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)!=0){break a}c[f>>2]=b;k=0;l=k;i=h;return l|0};case 5:{if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 7:{if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};case 6:{if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}break};default:{c[f>>2]=b;k=0;l=k;i=h;return l|0}}}while(0);b=b+2|0;b:while(1){if((b|0)==(e|0)){n=50;break}m=b;if((a[b]|0)==0){o=d[j+76+(d[m+1|0]|0)|0]|0}else{o=Cyc(a[m]|0,a[b+1|0]|0)|0}switch(o|0){case 29:{if((c[283680+((d[284960+(d[b]|0)|0]<<3)+(d[b+1|0]>>5)<<2)>>2]&1<<(a[b+1|0]&31)|0)==0){n=26;break b}break};case 23:{b=b+2|0;continue b;break};case 11:{n=48;break b;break};case 10:case 9:case 21:{n=37;break b;break};case 6:{n=31;break b;break};case 27:case 26:case 25:case 24:case 22:{break};case 5:{n=28;break b;break};case 7:{n=34;break b;break};default:{n=49;break b}}b=b+2|0}if((n|0)==26){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==28){if((e-b|0)<2){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==31){if((e-b|0)<3){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==34){if((e-b|0)<4){k=-2;l=k;i=h;return l|0}else{c[f>>2]=b;k=0;l=k;i=h;return l|0}}else if((n|0)==37){b=b+2|0;while(1){if((b|0)==(e|0)){n=46;break}o=b;if((a[b]|0)==0){p=d[j+76+(d[o+1|0]|0)|0]|0}else{p=Cyc(a[o]|0,a[b+1|0]|0)|0}if((p|0)==11){n=43;break}else if(!((p|0)==10|(p|0)==9|(p|0)==21)){n=44;break}b=b+2|0}if((n|0)==43){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==44){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==46){k=-1;l=k;i=h;return l|0}}else if((n|0)==48){c[f>>2]=b+2;k=5;l=k;i=h;return l|0}else if((n|0)==49){c[f>>2]=b;k=0;l=k;i=h;return l|0}else if((n|0)==50){k=-1;l=k;i=h;return l|0}return 0}



function M5(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+41976>>3];j=+h[f+41944>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5840,5832,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+42096>>3]=l;i=d;return}function N5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13968>>3]=+h[b+13288>>3];i=i;return}function O5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13960>>3]=+h[b+13280>>3];i=i;return}function P5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13952>>3]=+h[b+13272>>3];i=i;return}function Q5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+13920>>3]=l;i=b;return}function R5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+13912>>3]=l;i=b;return}function S5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+13904>>3]=l;i=b;return}function T5(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+13896>>3]=l;i=b;return}function U5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13624>>3]=+h[b+13312>>3];i=i;return}function V5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13696>>3]=+h[b+13624>>3];i=i;return}function W5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13616>>3]=+h[b+13304>>3];i=i;return}function X5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13688>>3]=+h[b+13616>>3];i=i;return}function Y5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13608>>3]=+h[b+13296>>3];i=i;return}function Z5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13680>>3]=+h[b+13608>>3];i=i;return}function _5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13672>>3]=+h[b+13360>>3];i=i;return}function $5(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13664>>3]=+h[b+13352>>3];i=i;return}function a6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13656>>3]=+h[b+13344>>3];i=i;return}function b6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13648>>3]=+h[b+13336>>3];i=i;return}function c6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13640>>3]=+h[b+13328>>3];i=i;return}function d6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13632>>3]=+h[b+13320>>3];i=i;return}function e6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41856>>3]=+h[b+41848>>3];i=i;return}function f6(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12528>>3]- +h[b+12648>>3];e=+h[b+12536>>3]- +h[b+12656>>3];f=+h[b+12544>>3]- +h[b+12664>>3];h[b+41712>>3]=+V(+(d*d+e*e+f*f));i=i;return}function g6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41712>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5872,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41720>>3]=l;i=d;return}function h6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41728>>3]=+h[b+41720>>3];i=i;return}function i6(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+12144>>3]- +h[b+12264>>3];e=+h[b+12152>>3]- +h[b+12272>>3];f=+h[b+12160>>3]- +h[b+12280>>3];h[b+41672>>3]=+V(+(d*d+e*e+f*f));i=i;return}function j6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41672>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,5880,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41680>>3]=l;i=d;return}function k6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41688>>3]=+h[b+41680>>3];i=i;return}function l6(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+160>>2]=c[b+156>>2];i=i;return}function m6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41576>>3]=+h[b+41432>>3];i=i;return}function n6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41568>>3]=+h[b+41432>>3];i=i;return}function o6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41560>>3]=+h[b+41416>>3];i=i;return}function p6(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+41432>>3];j=+h[f+41400>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5896,5888,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41552>>3]=l;i=d;return}function q6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11608>>3]=+h[b+10928>>3];i=i;return}function r6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11600>>3]=+h[b+10920>>3];i=i;return}function s6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11592>>3]=+h[b+10912>>3];i=i;return}function t6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+99|0]=a[d]|0;i=i;return}function u6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+103|0]=a[d+99|0]|0;i=i;return}function v6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+105|0]=a[d+99|0]|0;i=i;return}function w6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+107|0]=a[d+99|0]|0;i=i;return}function x6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+119|0]=a[d+107|0]|0;i=i;return}function y6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+120|0]=a[d+99|0]|0;i=i;return}function z6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+126|0]=a[d+120|0]|0;i=i;return}function A6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+134|0]=a[d+99|0]|0;i=i;return}function B6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+140|0]=a[d+134|0]|0;i=i;return}function C6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+147|0]=a[d+99|0]|0;i=i;return}function D6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+153|0]=a[d+147|0]|0;i=i;return}function E6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+160|0]=a[d+99|0]|0;i=i;return}function F6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+172|0]=a[d+160|0]|0;i=i;return}function G6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+173|0]=a[d+99|0]|0;i=i;return}function H6(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+185|0]=a[d+173|0]|0;i=i;return}function I6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+11560>>3]=l;i=b;return}function J6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+11552>>3]=l;i=b;return}function K6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+11544>>3]=l;i=b;return}function L6(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+11536>>3]=l;i=b;return}function M6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11264>>3]=+h[b+10952>>3];i=i;return}function N6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11336>>3]=+h[b+11264>>3];i=i;return}function O6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11256>>3]=+h[b+10944>>3];i=i;return}function P6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11328>>3]=+h[b+11256>>3];i=i;return}function Q6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11248>>3]=+h[b+10936>>3];i=i;return}function R6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11320>>3]=+h[b+11248>>3];i=i;return}function S6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11312>>3]=+h[b+11e3>>3];i=i;return}function T6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11304>>3]=+h[b+10992>>3];i=i;return}function U6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11296>>3]=+h[b+10984>>3];i=i;return}function V6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11288>>3]=+h[b+10976>>3];i=i;return}function W6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11280>>3]=+h[b+10968>>3];i=i;return}function X6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11272>>3]=+h[b+10960>>3];i=i;return}function Y6(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+152>>2]=c[b+148>>2];i=i;return}function Z6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41392>>3]=+h[b+41248>>3];i=i;return}function _6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41384>>3]=+h[b+41248>>3];i=i;return}function $6(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41376>>3]=+h[b+41232>>3];i=i;return}function a7(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+41248>>3];j=+h[f+41216>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5936,5928,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41368>>3]=l;i=d;return}function b7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10832>>3]=+h[b+10152>>3];i=i;return}function c7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10824>>3]=+h[b+10144>>3];i=i;return}function d7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10816>>3]=+h[b+10136>>3];i=i;return}function e7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+10784>>3]=l;i=b;return}function f7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+10776>>3]=l;i=b;return}function g7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+10768>>3]=l;i=b;return}function h7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+10760>>3]=l;i=b;return}function i7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10488>>3]=+h[b+10176>>3];i=i;return}function j7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10560>>3]=+h[b+10488>>3];i=i;return}function k7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10480>>3]=+h[b+10168>>3];i=i;return}function l7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10552>>3]=+h[b+10480>>3];i=i;return}function m7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10472>>3]=+h[b+10160>>3];i=i;return}function n7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10544>>3]=+h[b+10472>>3];i=i;return}function o7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10536>>3]=+h[b+10224>>3];i=i;return}function p7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10528>>3]=+h[b+10216>>3];i=i;return}function q7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10520>>3]=+h[b+10208>>3];i=i;return}function r7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10512>>3]=+h[b+10200>>3];i=i;return}function s7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10504>>3]=+h[b+10192>>3];i=i;return}function t7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10496>>3]=+h[b+10184>>3];i=i;return}function u7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+10104>>3]=l;i=b;return}function v7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+10096>>3]=l;i=b;return}function w7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+10088>>3]=l;i=b;return}function x7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+10080>>3]=l;i=b;return}function y7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9808>>3]=+h[b+9400>>3];i=i;return}function z7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9880>>3]=+h[b+9808>>3];i=i;return}function A7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9800>>3]=+h[b+9392>>3];i=i;return}function B7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9872>>3]=+h[b+9800>>3];i=i;return}function C7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9792>>3]=+h[b+9384>>3];i=i;return}function D7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9864>>3]=+h[b+9792>>3];i=i;return}function E7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9856>>3]=+h[b+9448>>3];i=i;return}function F7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9848>>3]=+h[b+9440>>3];i=i;return}function G7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9840>>3]=+h[b+9432>>3];i=i;return}function H7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9832>>3]=+h[b+9424>>3];i=i;return}function I7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9824>>3]=+h[b+9416>>3];i=i;return}function J7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9816>>3]=+h[b+9408>>3];i=i;return}function K7(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+144>>2]=c[b+140>>2];i=i;return}function L7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41128>>3]=+h[b+41088>>3];i=i;return}function M7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41120>>3]=+h[b+41072>>3];i=i;return}function N7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9640>>3]=+h[b+9352>>3];i=i;return}function O7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9632>>3]=+h[b+9344>>3];i=i;return}function P7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9624>>3]=+h[b+9336>>3];i=i;return}function Q7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41064>>3]=+h[b+41040>>3];i=i;return}function R7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+9304>>3]=l;i=b;return}function S7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+9296>>3]=l;i=b;return}function T7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+9288>>3]=l;i=b;return}function U7(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+9280>>3]=l;i=b;return}function V7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9008>>3]=+h[b+8600>>3];i=i;return}function W7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9080>>3]=+h[b+9008>>3];i=i;return}function X7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9e3>>3]=+h[b+8592>>3];i=i;return}function Y7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9072>>3]=+h[b+9e3>>3];i=i;return}function Z7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8992>>3]=+h[b+8584>>3];i=i;return}function _7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9064>>3]=+h[b+8992>>3];i=i;return}function $7(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9056>>3]=+h[b+8648>>3];i=i;return}function a8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9048>>3]=+h[b+8640>>3];i=i;return}function b8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9040>>3]=+h[b+8632>>3];i=i;return}function c8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9032>>3]=+h[b+8624>>3];i=i;return}function d8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9024>>3]=+h[b+8616>>3];i=i;return}function e8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9016>>3]=+h[b+8608>>3];i=i;return}function f8(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+136>>2]=c[b+132>>2];i=i;return}function g8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40952>>3]=+h[b+40912>>3];i=i;return}function h8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40944>>3]=+h[b+40896>>3];i=i;return}function i8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8840>>3]=+h[b+8552>>3];i=i;return}function j8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8832>>3]=+h[b+8544>>3];i=i;return}function k8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8824>>3]=+h[b+8536>>3];i=i;return}function l8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40888>>3]=+h[b+40864>>3];i=i;return}function m8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+8408>>3]=l;i=b;return}function n8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+8400>>3]=l;i=b;return}function o8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+8392>>3]=l;i=b;return}function p8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+8384>>3]=l;i=b;return}function q8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8112>>3]=+h[b+7704>>3];i=i;return}function r8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8184>>3]=+h[b+8112>>3];i=i;return}function s8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8104>>3]=+h[b+7696>>3];i=i;return}function t8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8176>>3]=+h[b+8104>>3];i=i;return}function u8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8096>>3]=+h[b+7688>>3];i=i;return}function v8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8168>>3]=+h[b+8096>>3];i=i;return}function w8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8160>>3]=+h[b+7752>>3];i=i;return}function x8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8152>>3]=+h[b+7744>>3];i=i;return}function y8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8144>>3]=+h[b+7736>>3];i=i;return}function z8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8136>>3]=+h[b+7728>>3];i=i;return}function A8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8128>>3]=+h[b+7720>>3];i=i;return}function B8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8120>>3]=+h[b+7712>>3];i=i;return}function C8(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+124>>2]=c[b+120>>2];i=i;return}function D8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40736>>3]=+h[b+40696>>3];i=i;return}function E8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40728>>3]=+h[b+40680>>3];i=i;return}function F8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7944>>3]=+h[b+7656>>3];i=i;return}function G8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7936>>3]=+h[b+7648>>3];i=i;return}function H8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7928>>3]=+h[b+7640>>3];i=i;return}function I8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40672>>3]=+h[b+40648>>3];i=i;return}function J8(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+116>>2]=c[b+112>>2];i=i;return}function K8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40640>>3]=+h[b+40496>>3];i=i;return}function L8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40632>>3]=+h[b+40496>>3];i=i;return}function M8(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+40496>>3];j=+h[f+40464>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,5976,5968,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40616>>3]=l;i=d;return}function N8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7560>>3]=+h[b+6880>>3];i=i;return}function O8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7552>>3]=+h[b+6872>>3];i=i;return}function P8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7544>>3]=+h[b+6864>>3];i=i;return}function Q8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+7512>>3]=l;i=b;return}function R8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+7504>>3]=l;i=b;return}function S8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+7496>>3]=l;i=b;return}function T8(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+7488>>3]=l;i=b;return}function U8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7216>>3]=+h[b+6904>>3];i=i;return}function V8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7288>>3]=+h[b+7216>>3];i=i;return}function W8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7208>>3]=+h[b+6896>>3];i=i;return}function X8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7280>>3]=+h[b+7208>>3];i=i;return}function Y8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7200>>3]=+h[b+6888>>3];i=i;return}function Z8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7272>>3]=+h[b+7200>>3];i=i;return}function _8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7264>>3]=+h[b+6952>>3];i=i;return}function $8(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7256>>3]=+h[b+6944>>3];i=i;return}function a9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7248>>3]=+h[b+6936>>3];i=i;return}function b9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7240>>3]=+h[b+6928>>3];i=i;return}function c9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7232>>3]=+h[b+6920>>3];i=i;return}function d9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7224>>3]=+h[b+6912>>3];i=i;return}function e9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40376>>3]=+h[b+40368>>3];i=i;return}function f9(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6120>>3]- +h[b+6240>>3];e=+h[b+6128>>3]- +h[b+6248>>3];f=+h[b+6136>>3]- +h[b+6256>>3];h[b+40232>>3]=+V(+(d*d+e*e+f*f));i=i;return}function g9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40232>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,6008,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40240>>3]=l;i=d;return}function h9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40248>>3]=+h[b+40240>>3];i=i;return}function i9(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5736>>3]- +h[b+5856>>3];e=+h[b+5744>>3]- +h[b+5864>>3];f=+h[b+5752>>3]- +h[b+5872>>3];h[b+40192>>3]=+V(+(d*d+e*e+f*f));i=i;return}function j9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40192>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,6016,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40200>>3]=l;i=d;return}function k9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40208>>3]=+h[b+40200>>3];i=i;return}function l9(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+76>>2]=c[b+72>>2];i=i;return}function m9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40096>>3]=+h[b+39952>>3];i=i;return}function n9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40088>>3]=+h[b+39952>>3];i=i;return}function o9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40080>>3]=+h[b+39936>>3];i=i;return}function p9(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+39952>>3];j=+h[f+39920>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6032,6024,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40072>>3]=l;i=d;return}function q9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5200>>3]=+h[b+4520>>3];i=i;return}function r9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5192>>3]=+h[b+4512>>3];i=i;return}function s9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5184>>3]=+h[b+4504>>3];i=i;return}function t9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+8|0]=a[d]|0;i=i;return}function u9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+12|0]=a[d+8|0]|0;i=i;return}function v9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+14|0]=a[d+8|0]|0;i=i;return}function w9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+16|0]=a[d+8|0]|0;i=i;return}function x9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+28|0]=a[d+16|0]|0;i=i;return}function y9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+29|0]=a[d+8|0]|0;i=i;return}function z9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+35|0]=a[d+29|0]|0;i=i;return}function A9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+43|0]=a[d+8|0]|0;i=i;return}function B9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+49|0]=a[d+43|0]|0;i=i;return}function C9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+56|0]=a[d+8|0]|0;i=i;return}function D9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+62|0]=a[d+56|0]|0;i=i;return}function E9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+69|0]=a[d+8|0]|0;i=i;return}function F9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+81|0]=a[d+69|0]|0;i=i;return}function G9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+82|0]=a[d+8|0]|0;i=i;return}function H9(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+94|0]=a[d+82|0]|0;i=i;return}function I9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+5152>>3]=l;i=b;return}function J9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+5144>>3]=l;i=b;return}function K9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+5136>>3]=l;i=b;return}function L9(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+5128>>3]=l;i=b;return}function M9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4856>>3]=+h[b+4544>>3];i=i;return}function N9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4928>>3]=+h[b+4856>>3];i=i;return}function O9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4848>>3]=+h[b+4536>>3];i=i;return}function P9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4920>>3]=+h[b+4848>>3];i=i;return}function Q9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4840>>3]=+h[b+4528>>3];i=i;return}function R9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4912>>3]=+h[b+4840>>3];i=i;return}function S9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4904>>3]=+h[b+4592>>3];i=i;return}function T9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4896>>3]=+h[b+4584>>3];i=i;return}function U9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4888>>3]=+h[b+4576>>3];i=i;return}function V9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4880>>3]=+h[b+4568>>3];i=i;return}function W9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4872>>3]=+h[b+4560>>3];i=i;return}function X9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4864>>3]=+h[b+4552>>3];i=i;return}function Y9(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+68>>2]=c[b+64>>2];i=i;return}function Z9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39912>>3]=+h[b+39768>>3];i=i;return}function _9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39904>>3]=+h[b+39768>>3];i=i;return}function $9(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39896>>3]=+h[b+39752>>3];i=i;return}function aaa(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+39768>>3];j=+h[f+39736>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6072,6064,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+39888>>3]=l;i=d;return}function baa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4424>>3]=+h[b+3744>>3];i=i;return}function caa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4416>>3]=+h[b+3736>>3];i=i;return}function daa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4408>>3]=+h[b+3728>>3];i=i;return}function eaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+4376>>3]=l;i=b;return}function faa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+4368>>3]=l;i=b;return}function gaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+4360>>3]=l;i=b;return}function haa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+4352>>3]=l;i=b;return}function iaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4080>>3]=+h[b+3768>>3];i=i;return}function jaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4152>>3]=+h[b+4080>>3];i=i;return}function kaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4072>>3]=+h[b+3760>>3];i=i;return}function laa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4144>>3]=+h[b+4072>>3];i=i;return}function maa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4064>>3]=+h[b+3752>>3];i=i;return}function naa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4136>>3]=+h[b+4064>>3];i=i;return}function oaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4128>>3]=+h[b+3816>>3];i=i;return}function paa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4120>>3]=+h[b+3808>>3];i=i;return}function qaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4112>>3]=+h[b+3800>>3];i=i;return}function raa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4104>>3]=+h[b+3792>>3];i=i;return}function saa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4096>>3]=+h[b+3784>>3];i=i;return}function taa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4088>>3]=+h[b+3776>>3];i=i;return}function uaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+3696>>3]=l;i=b;return}function vaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+3688>>3]=l;i=b;return}function waa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+3680>>3]=l;i=b;return}function xaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+3672>>3]=l;i=b;return}function yaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3400>>3]=+h[b+2992>>3];i=i;return}function zaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3472>>3]=+h[b+3400>>3];i=i;return}function Aaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3392>>3]=+h[b+2984>>3];i=i;return}function Baa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3464>>3]=+h[b+3392>>3];i=i;return}function Caa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3384>>3]=+h[b+2976>>3];i=i;return}function Daa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3384>>3];i=i;return}function Eaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3448>>3]=+h[b+3040>>3];i=i;return}function Faa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3440>>3]=+h[b+3032>>3];i=i;return}function Gaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3432>>3]=+h[b+3024>>3];i=i;return}function Haa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3424>>3]=+h[b+3016>>3];i=i;return}function Iaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3416>>3]=+h[b+3008>>3];i=i;return}function Jaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3408>>3]=+h[b+3e3>>3];i=i;return}function Kaa(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+60>>2]=c[b+56>>2];i=i;return}function Laa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39648>>3]=+h[b+39608>>3];i=i;return}function Maa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39640>>3]=+h[b+39592>>3];i=i;return}function Naa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3232>>3]=+h[b+2944>>3];i=i;return}function Oaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3224>>3]=+h[b+2936>>3];i=i;return}function Paa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3216>>3]=+h[b+2928>>3];i=i;return}function Qaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39584>>3]=+h[b+39560>>3];i=i;return}function Raa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+2896>>3]=l;i=b;return}function Saa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+2888>>3]=l;i=b;return}function Taa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+2880>>3]=l;i=b;return}function Uaa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+2872>>3]=l;i=b;return}function Vaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2600>>3]=+h[b+2192>>3];i=i;return}function Waa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2672>>3]=+h[b+2600>>3];i=i;return}function Xaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2592>>3]=+h[b+2184>>3];i=i;return}function Yaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2664>>3]=+h[b+2592>>3];i=i;return}function Zaa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2584>>3]=+h[b+2176>>3];i=i;return}function _aa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2656>>3]=+h[b+2584>>3];i=i;return}function $aa(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2648>>3]=+h[b+2240>>3];i=i;return}function aba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2640>>3]=+h[b+2232>>3];i=i;return}function bba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2632>>3]=+h[b+2224>>3];i=i;return}function cba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2624>>3]=+h[b+2216>>3];i=i;return}function dba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2616>>3]=+h[b+2208>>3];i=i;return}function eba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2608>>3]=+h[b+2200>>3];i=i;return}function fba(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+52>>2]=c[b+48>>2];i=i;return}function gba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39472>>3]=+h[b+39432>>3];i=i;return}function hba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39464>>3]=+h[b+39416>>3];i=i;return}function iba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2432>>3]=+h[b+2144>>3];i=i;return}function jba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2424>>3]=+h[b+2136>>3];i=i;return}function kba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2416>>3]=+h[b+2128>>3];i=i;return}function lba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39408>>3]=+h[b+39384>>3];i=i;return}function mba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+2e3>>3]=l;i=b;return}function nba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+1992>>3]=l;i=b;return}function oba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+1984>>3]=l;i=b;return}function pba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+1976>>3]=l;i=b;return}function qba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1704>>3]=+h[b+1296>>3];i=i;return}function rba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1776>>3]=+h[b+1704>>3];i=i;return}function sba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1696>>3]=+h[b+1288>>3];i=i;return}function tba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1768>>3]=+h[b+1696>>3];i=i;return}function uba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1688>>3]=+h[b+1280>>3];i=i;return}function vba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1760>>3]=+h[b+1688>>3];i=i;return}function wba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1752>>3]=+h[b+1344>>3];i=i;return}function xba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1744>>3]=+h[b+1336>>3];i=i;return}function yba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1736>>3]=+h[b+1328>>3];i=i;return}function zba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1728>>3]=+h[b+1320>>3];i=i;return}function Aba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1720>>3]=+h[b+1312>>3];i=i;return}function Bba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1712>>3]=+h[b+1304>>3];i=i;return}function Cba(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+40>>2]=c[b+36>>2];i=i;return}function Dba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39256>>3]=+h[b+39216>>3];i=i;return}function Eba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39248>>3]=+h[b+39200>>3];i=i;return}function Fba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1536>>3]=+h[b+1248>>3];i=i;return}function Gba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1528>>3]=+h[b+1240>>3];i=i;return}function Hba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1520>>3]=+h[b+1232>>3];i=i;return}function Iba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39192>>3]=+h[b+39168>>3];i=i;return}function Jba(a){a=a|0;var b=0;b=c[a+428>>2]|0;c[b+32>>2]=c[b+28>>2];i=i;return}function Kba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39160>>3]=+h[b+39016>>3];i=i;return}function Lba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39152>>3]=+h[b+39016>>3];i=i;return}function Mba(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+39016>>3];j=+h[f+38984>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6112,6104,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+39136>>3]=l;i=d;return}function Nba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1152>>3]=+h[b+472>>3];i=i;return}function Oba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1144>>3]=+h[b+464>>3];i=i;return}function Pba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1136>>3]=+h[b+456>>3];i=i;return}function Qba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,3);h[(c[a+416>>2]|0)+1104>>3]=l;i=b;return}function Rba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,2);h[(c[a+416>>2]|0)+1096>>3]=l;i=b;return}function Sba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,1);h[(c[a+416>>2]|0)+1088>>3]=l;i=b;return}function Tba(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0.0;b=i;i=i+48|0;d=b;e=b+16|0;f=b+32|0;g=c[a+536>>2]|0;j=e;k=5352;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];k=d;j=5368;c[k+0>>2]=c[j+0>>2];c[k+4>>2]=c[j+4>>2];c[k+8>>2]=c[j+8>>2];tu(f,g,e,d);l=+tCc(f,0);h[(c[a+416>>2]|0)+1080>>3]=l;i=b;return}function Uba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+808>>3]=+h[b+496>>3];i=i;return}function Vba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+880>>3]=+h[b+808>>3];i=i;return}function Wba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+800>>3]=+h[b+488>>3];i=i;return}function Xba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+872>>3]=+h[b+800>>3];i=i;return}function Yba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+792>>3]=+h[b+480>>3];i=i;return}function Zba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+864>>3]=+h[b+792>>3];i=i;return}function _ba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+856>>3]=+h[b+544>>3];i=i;return}function $ba(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+848>>3]=+h[b+536>>3];i=i;return}function aca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+840>>3]=+h[b+528>>3];i=i;return}function bca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+832>>3]=+h[b+520>>3];i=i;return}function cca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+824>>3]=+h[b+512>>3];i=i;return}function dca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+816>>3]=+h[b+504>>3];i=i;return}function eca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38896>>3]=+h[b+38888>>3];i=i;return}function fca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38656>>3]=+h[b+38608>>3]*.5;i=i;return}function gca(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38624>>3];j=+h[f+38656>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,6152,6144,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+38720>>3]=l;i=d;return}function hca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38752>>3]=+h[b+38720>>3]*3.0;i=i;return}function ica(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38760>>3]=+h[b+38720>>3];i=i;return}function jca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38768>>3]=+h[b+38720>>3]*3.0;i=i;return}function kca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38728>>3]=+h[b+38656>>3]*.5;i=i;return}function lca(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+38728>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,6192,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+38776>>3]=l;i=d;return}function mca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38800>>3]=+h[b+38776>>3]*3.0;i=i;return}function nca(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38792>>3]=+sd(+(+h[d+38728>>3]),+(+h[d+38776>>3]*4.0));i=b;return}function oca(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38808>>3]=+td(0.0,+(+h[d+38728>>3]- +h[d+38792>>3]));i=b;return}function pca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38736>>3]=+h[b+38656>>3]*1.05;i=i;return}function qca(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38744>>3]=+sd(+(+h[d+38656>>3]),+(+h[d+38720>>3]*5.0));i=b;return}function rca(a){a=a|0;var b=0,d=0;b=i;d=c[a+416>>2]|0;h[d+38784>>3]=+td(0.0,+(+h[d+38656>>3]- +h[d+38744>>3]));i=b;return}function sca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38712>>3]=+h[b+38608>>3]*.025;i=i;return}function tca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38696>>3]=+h[b+38608>>3]*.05;i=i;return}function uca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38688>>3]=+h[b+38608>>3]*.1;i=i;return}function vca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38680>>3]=+h[b+38608>>3]*.05;i=i;return}function wca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38672>>3]=+h[b+38608>>3]*.1;i=i;return}function xca(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38664>>3]=+h[b+38608>>3]*.2;i=i;return}function yca(b){b=b|0;var d=0,e=0,f=0;d=i;e=c[b+424>>2]|0;do{if((a[e+3|0]|0)==0){f=0}else{if((a[e+4|0]|0)==0){f=0;break}f=(a[e+7|0]|0)!=0|0}}while(0);c[(c[b+420>>2]|0)+1956>>2]=f;i=d;return}function zca(b){b=b|0;var d=0,e=0;d=c[b+424>>2]|0;if((a[d+3|0]|0)==0){e=0}else{e=(a[d+4|0]|0)!=0|0}c[(c[b+420>>2]|0)+1952>>2]=e;i=i;return}function Aca(b){b=b|0;var d=0;d=c[b+424>>2]|0;a[d+2|0]=a[d]|0;i=i;return}function Bca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25944>>3]=0.0;i=i;return}function Cca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25936>>3]=0.0;i=i;return}function Dca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25928>>3]=0.0;i=i;return}function Eca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25920>>3]=0.0;i=i;return}function Fca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25912>>3]=0.0;i=i;return}function Gca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25904>>3]=0.0;i=i;return}function Hca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25896>>3]=1.0;i=i;return}function Ica(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25872>>3]=0.0;i=i;return}function Jca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25848>>3]=0.0;i=i;return}function Kca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25888>>3]=0.0;i=i;return}function Lca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25864>>3]=1.0;i=i;return}function Mca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25840>>3]=0.0;i=i;return}function Nca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25880>>3]=0.0;i=i;return}function Oca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25856>>3]=0.0;i=i;return}function Pca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25832>>3]=1.0;i=i;return}function Qca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25824>>3]=0.0;i=i;return}function Rca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25816>>3]=0.0;i=i;return}function Sca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25808>>3]=0.0;i=i;return}function Tca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25800>>3]=0.0;i=i;return}function Uca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25792>>3]=0.0;i=i;return}function Vca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25784>>3]=0.0;i=i;return}function Wca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25776>>3]=0.0;i=i;return}function Xca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25768>>3]=0.0;i=i;return}function Yca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25760>>3]=0.0;i=i;return}function Zca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25752>>3]=0.0;i=i;return}function _ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25744>>3]=0.0;i=i;return}function $ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25736>>3]=0.0;i=i;return}function ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25728>>3]=0.0;i=i;return}function bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25720>>3]=0.0;i=i;return}function cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25712>>3]=0.0;i=i;return}function dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25688>>3]=0.0;i=i;return}function eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25680>>3]=0.0;i=i;return}function fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25672>>3]=0.0;i=i;return}function gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25664>>3]=0.0;i=i;return}function hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25656>>3]=0.0;i=i;return}function ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25648>>3]=0.0;i=i;return}function jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25640>>3]=0.0;i=i;return}function kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25616>>3]=0.0;i=i;return}function lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25608>>3]=0.0;i=i;return}function mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25600>>3]=0.0;i=i;return}function nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25592>>3]=0.0;i=i;return}function oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25584>>3]=0.0;i=i;return}function pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25576>>3]=0.0;i=i;return}function qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25568>>3]=0.0;i=i;return}function rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25544>>3]=0.0;i=i;return}function sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25536>>3]=0.0;i=i;return}function tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25528>>3]=0.0;i=i;return}function uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25520>>3]=0.0;i=i;return}function vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25512>>3]=0.0;i=i;return}function wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25504>>3]=0.0;i=i;return}function xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25496>>3]=0.0;i=i;return}function yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25472>>3]=0.0;i=i;return}function zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25464>>3]=0.0;i=i;return}function Ada(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25456>>3]=0.0;i=i;return}function Bda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25448>>3]=0.0;i=i;return}function Cda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25440>>3]=0.0;i=i;return}function Dda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25432>>3]=0.0;i=i;return}function Eda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25424>>3]=0.0;i=i;return}function Fda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25400>>3]=0.0;i=i;return}function Gda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25392>>3]=0.0;i=i;return}function Hda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25384>>3]=0.0;i=i;return}function Ida(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25376>>3]=0.0;i=i;return}function Jda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25368>>3]=0.0;i=i;return}function Kda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25360>>3]=0.0;i=i;return}function Lda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25352>>3]=0.0;i=i;return}function Mda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25328>>3]=0.0;i=i;return}function Nda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25320>>3]=0.0;i=i;return}function Oda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25312>>3]=0.0;i=i;return}function Pda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25304>>3]=0.0;i=i;return}function Qda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25296>>3]=0.0;i=i;return}function Rda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25288>>3]=0.0;i=i;return}function Sda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25280>>3]=0.0;i=i;return}function Tda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25272>>3]=0.0;i=i;return}function Uda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25264>>3]=0.0;i=i;return}function Vda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25256>>3]=0.0;i=i;return}function Wda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25248>>3]=0.0;i=i;return}function Xda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25240>>3]=0.0;i=i;return}function Yda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25232>>3]=0.0;i=i;return}function Zda(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25224>>3]=0.0;i=i;return}function _da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25216>>3]=0.0;i=i;return}function $da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25208>>3]=0.0;i=i;return}function aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25200>>3]=0.0;i=i;return}function bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25192>>3]=0.0;i=i;return}function cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25160>>3]=0.0;i=i;return}function dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25136>>3]=0.0;i=i;return}function eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25128>>3]=0.0;i=i;return}function fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25120>>3]=0.0;i=i;return}function gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25112>>3]=1.0;i=i;return}function hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25104>>3]=0.0;i=i;return}function iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25096>>3]=0.0;i=i;return}function jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26920>>3]=0.0;i=i;return}function kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25088>>3]=0.0;i=i;return}function lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25080>>3]=0.0;i=i;return}function mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25072>>3]=0.0;i=i;return}function nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25064>>3]=0.0;i=i;return}function oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25056>>3]=0.0;i=i;return}function pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25048>>3]=0.0;i=i;return}function qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25040>>3]=0.0;i=i;return}function rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25032>>3]=0.0;i=i;return}function sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25024>>3]=0.0;i=i;return}function tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25016>>3]=0.0;i=i;return}function uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25008>>3]=0.0;i=i;return}function vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25e3>>3]=0.0;i=i;return}function wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24992>>3]=0.0;i=i;return}function xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24984>>3]=0.0;i=i;return}function yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24952>>3]=0.0;i=i;return}function zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24928>>3]=0.0;i=i;return}function Aea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24920>>3]=0.0;i=i;return}function Bea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24912>>3]=0.0;i=i;return}function Cea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24904>>3]=1.0;i=i;return}function Dea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24896>>3]=0.0;i=i;return}function Eea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24888>>3]=0.0;i=i;return}function Fea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26912>>3]=0.0;i=i;return}function Gea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24880>>3]=0.0;i=i;return}function Hea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24872>>3]=0.0;i=i;return}function Iea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24864>>3]=0.0;i=i;return}function Jea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24856>>3]=0.0;i=i;return}function Kea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24848>>3]=0.0;i=i;return}function Lea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24840>>3]=0.0;i=i;return}function Mea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24832>>3]=0.0;i=i;return}function Nea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24824>>3]=0.0;i=i;return}function Oea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24816>>3]=0.0;i=i;return}function Pea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24808>>3]=0.0;i=i;return}function Qea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24800>>3]=0.0;i=i;return}function Rea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24792>>3]=0.0;i=i;return}function Sea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24784>>3]=0.0;i=i;return}function Tea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24776>>3]=0.0;i=i;return}function Uea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24744>>3]=0.0;i=i;return}function Vea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24720>>3]=0.0;i=i;return}function Wea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24712>>3]=0.0;i=i;return}function Xea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24704>>3]=0.0;i=i;return}function Yea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24696>>3]=1.0;i=i;return}function Zea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24688>>3]=0.0;i=i;return}function _ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24680>>3]=0.0;i=i;return}function $ea(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26904>>3]=0.0;i=i;return}function afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24672>>3]=0.0;i=i;return}function bfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24664>>3]=0.0;i=i;return}function cfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24656>>3]=0.0;i=i;return}function dfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24648>>3]=0.0;i=i;return}function efa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24640>>3]=0.0;i=i;return}function ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24632>>3]=0.0;i=i;return}function gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24624>>3]=0.0;i=i;return}function hfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24616>>3]=0.0;i=i;return}function ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24608>>3]=0.0;i=i;return}function jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24600>>3]=0.0;i=i;return}function kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24592>>3]=0.0;i=i;return}function lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24584>>3]=0.0;i=i;return}function mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24576>>3]=0.0;i=i;return}function nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24568>>3]=0.0;i=i;return}function ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24536>>3]=0.0;i=i;return}function pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24512>>3]=0.0;i=i;return}function qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24504>>3]=0.0;i=i;return}function rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24496>>3]=0.0;i=i;return}function sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24488>>3]=1.0;i=i;return}function tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24480>>3]=0.0;i=i;return}function ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24472>>3]=0.0;i=i;return}function vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26896>>3]=0.0;i=i;return}function wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24464>>3]=0.0;i=i;return}function xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24456>>3]=0.0;i=i;return}function yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24448>>3]=0.0;i=i;return}function zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24440>>3]=0.0;i=i;return}function Afa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24432>>3]=0.0;i=i;return}function Bfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24424>>3]=0.0;i=i;return}function Cfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24416>>3]=0.0;i=i;return}function Dfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24408>>3]=0.0;i=i;return}function Efa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24400>>3]=0.0;i=i;return}function Ffa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24392>>3]=0.0;i=i;return}function Gfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24384>>3]=0.0;i=i;return}function Hfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24376>>3]=0.0;i=i;return}function Ifa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24368>>3]=0.0;i=i;return}function Jfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24360>>3]=0.0;i=i;return}function Kfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24328>>3]=0.0;i=i;return}function Lfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24304>>3]=0.0;i=i;return}function Mfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24296>>3]=0.0;i=i;return}function Nfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24288>>3]=0.0;i=i;return}function Ofa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24280>>3]=1.0;i=i;return}function Pfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24272>>3]=0.0;i=i;return}function Qfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24264>>3]=0.0;i=i;return}function Rfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26888>>3]=0.0;i=i;return}function Sfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24256>>3]=0.0;i=i;return}function Tfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24248>>3]=0.0;i=i;return}function Ufa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24240>>3]=0.0;i=i;return}function Vfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24232>>3]=0.0;i=i;return}function Wfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24224>>3]=0.0;i=i;return}function Xfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24216>>3]=0.0;i=i;return}function Yfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24208>>3]=0.0;i=i;return}function Zfa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24200>>3]=0.0;i=i;return}function _fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24192>>3]=0.0;i=i;return}function $fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24184>>3]=0.0;i=i;return}function aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24176>>3]=0.0;i=i;return}function bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24168>>3]=0.0;i=i;return}function cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24160>>3]=0.0;i=i;return}function dga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24152>>3]=0.0;i=i;return}function ega(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24120>>3]=0.0;i=i;return}function fga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24096>>3]=0.0;i=i;return}function gga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24088>>3]=0.0;i=i;return}function hga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24080>>3]=0.0;i=i;return}function iga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24072>>3]=1.0;i=i;return}function jga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24064>>3]=0.0;i=i;return}function kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24056>>3]=0.0;i=i;return}function lga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26880>>3]=0.0;i=i;return}function mga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24048>>3]=0.0;i=i;return}function nga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24040>>3]=0.0;i=i;return}function oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24032>>3]=0.0;i=i;return}function pga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24024>>3]=0.0;i=i;return}function qga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24016>>3]=1.0;i=i;return}function rga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24008>>3]=0.0;i=i;return}function sga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24e3>>3]=0.0;i=i;return}function tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26872>>3]=0.0;i=i;return}function uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23928>>3]=1.0;i=i;return}function vga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23936>>3]=0.0;i=i;return}function wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23944>>3]=0.0;i=i;return}function xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23920>>3]=0.0;i=i;return}function yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23912>>3]=0.0;i=i;return}function zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23808>>3]=1.0;i=i;return}function Aga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23816>>3]=0.0;i=i;return}function Bga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23824>>3]=0.0;i=i;return}function Cga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23776>>3]=0.0;i=i;return}function Dga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23768>>3]=.8660254037844387;i=i;return}function Ega(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23760>>3]=-.4999999999999999;i=i;return}function Fga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23752>>3]=0.0;i=i;return}function Gga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23744>>3]=.4999999999999999;i=i;return}function Hga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23736>>3]=.8660254037844387;i=i;return}function Iga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23664>>3]=1.0;i=i;return}function Jga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23672>>3]=0.0;i=i;return}function Kga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23680>>3]=0.0;i=i;return}function Lga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23656>>3]=0.0;i=i;return}function Mga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23648>>3]=.8660254037844387;i=i;return}function Nga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23640>>3]=.4999999999999999;i=i;return}function Oga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23632>>3]=0.0;i=i;return}function Pga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23624>>3]=-.4999999999999999;i=i;return}function Qga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23616>>3]=.8660254037844387;i=i;return}function Rga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23544>>3]=1.0;i=i;return}function Sga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23552>>3]=0.0;i=i;return}function Tga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23560>>3]=0.0;i=i;return}function Uga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23536>>3]=0.0;i=i;return}function Vga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23528>>3]=.8660254037844387;i=i;return}function Wga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23520>>3]=-.4999999999999999;i=i;return}function Xga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23512>>3]=0.0;i=i;return}function Yga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23504>>3]=.4999999999999999;i=i;return}function Zga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23496>>3]=.8660254037844387;i=i;return}function _ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23424>>3]=1.0;i=i;return}function $ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23432>>3]=0.0;i=i;return}function aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23440>>3]=0.0;i=i;return}function bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23416>>3]=0.0;i=i;return}function cha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23408>>3]=.8660254037844387;i=i;return}function dha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23400>>3]=.4999999999999999;i=i;return}function eha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23392>>3]=0.0;i=i;return}function fha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23384>>3]=-.4999999999999999;i=i;return}function gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23376>>3]=.8660254037844387;i=i;return}function hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23304>>3]=1.0;i=i;return}function iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23312>>3]=0.0;i=i;return}function jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23320>>3]=0.0;i=i;return}function kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23296>>3]=0.0;i=i;return}function lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23288>>3]=.8660254037844387;i=i;return}function mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23280>>3]=-.4999999999999999;i=i;return}function nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23272>>3]=0.0;i=i;return}function oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23264>>3]=.4999999999999999;i=i;return}function pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23256>>3]=.8660254037844387;i=i;return}function qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23184>>3]=1.0;i=i;return}function rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23192>>3]=0.0;i=i;return}function sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23200>>3]=0.0;i=i;return}function tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23160>>3]=0.0;i=i;return}function uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23168>>3]=0.0;i=i;return}function vha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23176>>3]=0.0;i=i;return}function wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23152>>3]=0.0;i=i;return}function xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23144>>3]=.8660254037844387;i=i;return}function yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23136>>3]=.4999999999999999;i=i;return}function zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23128>>3]=0.0;i=i;return}function Aha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23120>>3]=-.4999999999999999;i=i;return}function Bha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23112>>3]=.8660254037844387;i=i;return}function Cha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23232>>3]=0.0;i=i;return}function Dha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23208>>3]=0.0;i=i;return}function Eha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23104>>3]=1.0;i=i;return}function Fha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23352>>3]=0.0;i=i;return}function Gha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23328>>3]=0.0;i=i;return}function Hha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23096>>3]=1.0;i=i;return}function Iha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23472>>3]=0.0;i=i;return}function Jha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23448>>3]=0.0;i=i;return}function Kha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23088>>3]=1.0;i=i;return}function Lha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23592>>3]=0.0;i=i;return}function Mha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23568>>3]=0.0;i=i;return}function Nha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23080>>3]=1.0;i=i;return}function Oha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23712>>3]=0.0;i=i;return}function Pha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23688>>3]=0.0;i=i;return}function Qha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23072>>3]=1.0;i=i;return}function Rha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23064>>3]=0.0;i=i;return}function Sha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23056>>3]=0.0;i=i;return}function Tha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23856>>3]=0.0;i=i;return}function Uha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23832>>3]=0.0;i=i;return}function Vha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23016>>3]=1.0;i=i;return}function Wha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26864>>3]=0.0;i=i;return}function Xha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26856>>3]=0.0;i=i;return}function Yha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26848>>3]=0.0;i=i;return}function Zha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26840>>3]=0.0;i=i;return}function _ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26832>>3]=0.0;i=i;return}function $ha(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26824>>3]=0.0;i=i;return}function aia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26816>>3]=0.0;i=i;return}function bia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1556>>2]=155;i=i;return}function cia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1552>>2]=155;i=i;return}function dia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1548>>2]=155;i=i;return}function eia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1544>>2]=155;i=i;return}function fia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1540>>2]=155;i=i;return}function gia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1536>>2]=155;i=i;return}function hia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1532>>2]=155;i=i;return}function iia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1528>>2]=155;i=i;return}function jia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1524>>2]=155;i=i;return}function kia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1520>>2]=155;i=i;return}function lia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1516>>2]=155;i=i;return}function mia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1512>>2]=155;i=i;return}function nia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1508>>2]=180;i=i;return}function oia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1504>>2]=180;i=i;return}function pia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1500>>2]=180;i=i;return}function qia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22992>>3]=180.0;i=i;return}function ria(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23e3>>3]=180.0;i=i;return}function sia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23008>>3]=180.0;i=i;return}function tia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22984>>3]=0.0;i=i;return}function uia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22976>>3]=1.0;i=i;return}function via(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22968>>3]=0.0;i=i;return}function wia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22960>>3]=0.0;i=i;return}function xia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22952>>3]=0.0;i=i;return}function yia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22944>>3]=.11;i=i;return}function zia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22936>>3]=0.0;i=i;return}function Aia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22928>>3]=0.0;i=i;return}function Bia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22920>>3]=0.0;i=i;return}function Cia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22912>>3]=0.0;i=i;return}function Dia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22904>>3]=0.0;i=i;return}function Eia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22896>>3]=0.0;i=i;return}function Fia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22888>>3]=0.0;i=i;return}function Gia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22880>>3]=0.0;i=i;return}function Hia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22872>>3]=0.0;i=i;return}function Iia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22864>>3]=1.0;i=i;return}function Jia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22856>>3]=0.0;i=i;return}function Kia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22848>>3]=0.0;i=i;return}function Lia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22840>>3]=0.0;i=i;return}function Mia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1496>>2]=255;i=i;return}function Nia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1492>>2]=128;i=i;return}function Oia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1488>>2]=0;i=i;return}function Pia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1484>>2]=180;i=i;return}function Qia(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1480>>2]=180;i=i;return}function Ria(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1476>>2]=180;i=i;return}function Sia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22816>>3]=180.0;i=i;return}function Tia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22824>>3]=180.0;i=i;return}function Uia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22832>>3]=180.0;i=i;return}function Via(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22808>>3]=0.0;i=i;return}function Wia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22800>>3]=1.0;i=i;return}function Xia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22792>>3]=0.0;i=i;return}function Yia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22784>>3]=0.0;i=i;return}function Zia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22776>>3]=0.0;i=i;return}function _ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22768>>3]=.11;i=i;return}function $ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22760>>3]=0.0;i=i;return}function aja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22752>>3]=0.0;i=i;return}function bja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22744>>3]=0.0;i=i;return}function cja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22736>>3]=0.0;i=i;return}function dja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22728>>3]=0.0;i=i;return}function eja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22720>>3]=0.0;i=i;return}function fja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22712>>3]=0.0;i=i;return}function gja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22704>>3]=0.0;i=i;return}function hja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22696>>3]=0.0;i=i;return}function ija(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22688>>3]=1.0;i=i;return}function jja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22680>>3]=0.0;i=i;return}function kja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22672>>3]=0.0;i=i;return}function lja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22664>>3]=0.0;i=i;return}function mja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1472>>2]=255;i=i;return}function nja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1468>>2]=128;i=i;return}function oja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1464>>2]=0;i=i;return}function pja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22656>>3]=0.0;i=i;return}function qja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22648>>3]=0.0;i=i;return}function rja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22640>>3]=0.0;i=i;return}function sja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22632>>3]=0.0;i=i;return}function tja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22624>>3]=0.0;i=i;return}function uja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22616>>3]=0.0;i=i;return}function vja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22608>>3]=0.0;i=i;return}function wja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22600>>3]=0.0;i=i;return}function xja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22592>>3]=0.0;i=i;return}function yja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22584>>3]=1.0;i=i;return}function zja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22576>>3]=0.0;i=i;return}function Aja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22568>>3]=0.0;i=i;return}function Bja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22560>>3]=0.0;i=i;return}function Cja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1460>>2]=255;i=i;return}function Dja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1456>>2]=128;i=i;return}function Eja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1452>>2]=0;i=i;return}function Fja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1448>>2]=255;i=i;return}function Gja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1444>>2]=128;i=i;return}function Hja(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1440>>2]=0;i=i;return}function Ija(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22536>>3]=0.0;i=i;return}function Jja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22544>>3]=128.0;i=i;return}function Kja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22552>>3]=255.0;i=i;return}function Lja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22528>>3]=0.0;i=i;return}function Mja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22520>>3]=0.0;i=i;return}function Nja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22512>>3]=1.0;i=i;return}function Oja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22504>>3]=0.0;i=i;return}function Pja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22496>>3]=.1;i=i;return}function Qja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22488>>3]=0.0;i=i;return}function Rja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22480>>3]=0.0;i=i;return}function Sja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22472>>3]=0.0;i=i;return}function Tja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22464>>3]=0.0;i=i;return}function Uja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22456>>3]=0.0;i=i;return}function Vja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22448>>3]=0.0;i=i;return}function Wja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22440>>3]=0.0;i=i;return}function Xja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22432>>3]=0.0;i=i;return}function Yja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22424>>3]=0.0;i=i;return}function Zja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22416>>3]=0.0;i=i;return}function _ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22408>>3]=1.0;i=i;return}function $ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22400>>3]=0.0;i=i;return}function aka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22392>>3]=0.0;i=i;return}function bka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22384>>3]=0.0;i=i;return}function cka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1436>>2]=255;i=i;return}function dka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1432>>2]=128;i=i;return}function eka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1428>>2]=0;i=i;return}function fka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1424>>2]=255;i=i;return}function gka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1420>>2]=128;i=i;return}function hka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1416>>2]=0;i=i;return}function ika(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22360>>3]=0.0;i=i;return}function jka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22368>>3]=128.0;i=i;return}function kka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22376>>3]=255.0;i=i;return}function lka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22352>>3]=0.0;i=i;return}function mka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22344>>3]=0.0;i=i;return}function nka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22336>>3]=1.0;i=i;return}function oka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22328>>3]=0.0;i=i;return}function pka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22320>>3]=-.1;i=i;return}function qka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22312>>3]=0.0;i=i;return}function rka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1412>>2]=155;i=i;return}function ska(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1408>>2]=155;i=i;return}function tka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1404>>2]=155;i=i;return}function uka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22304>>3]=0.0;i=i;return}function vka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22296>>3]=0.0;i=i;return}function wka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22288>>3]=0.0;i=i;return}function xka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22280>>3]=0.0;i=i;return}function yka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22272>>3]=0.0;i=i;return}function zka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22264>>3]=0.0;i=i;return}function Aka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22256>>3]=0.0;i=i;return}function Bka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22248>>3]=0.0;i=i;return}function Cka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22240>>3]=0.0;i=i;return}function Dka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22232>>3]=1.0;i=i;return}function Eka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22224>>3]=0.0;i=i;return}function Fka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22216>>3]=0.0;i=i;return}function Gka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22208>>3]=0.0;i=i;return}function Hka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1400>>2]=255;i=i;return}function Ika(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1396>>2]=128;i=i;return}function Jka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1392>>2]=0;i=i;return}function Kka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1388>>2]=200;i=i;return}function Lka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1384>>2]=0;i=i;return}function Mka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1380>>2]=0;i=i;return}function Nka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22184>>3]=0.0;i=i;return}function Oka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22192>>3]=0.0;i=i;return}function Pka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22200>>3]=200.0;i=i;return}function Qka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22176>>3]=0.0;i=i;return}function Rka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22168>>3]=0.0;i=i;return}function Ska(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22160>>3]=1.0;i=i;return}function Tka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22152>>3]=0.0;i=i;return}function Uka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22144>>3]=.22;i=i;return}function Vka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22136>>3]=0.0;i=i;return}function Wka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1376>>2]=180;i=i;return}function Xka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1372>>2]=180;i=i;return}function Yka(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1368>>2]=180;i=i;return}function Zka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22112>>3]=180.0;i=i;return}function _ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22120>>3]=180.0;i=i;return}function $ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22128>>3]=180.0;i=i;return}function ala(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22104>>3]=0.0;i=i;return}function bla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22096>>3]=1.0;i=i;return}function cla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22088>>3]=0.0;i=i;return}function dla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22080>>3]=0.0;i=i;return}function ela(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22072>>3]=.1;i=i;return}function fla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22064>>3]=0.0;i=i;return}function gla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22056>>3]=0.0;i=i;return}function hla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22048>>3]=0.0;i=i;return}function ila(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22040>>3]=0.0;i=i;return}function jla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22032>>3]=0.0;i=i;return}function kla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22024>>3]=0.0;i=i;return}function lla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22016>>3]=0.0;i=i;return}function mla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22008>>3]=0.0;i=i;return}function nla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22e3>>3]=0.0;i=i;return}function ola(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21992>>3]=0.0;i=i;return}function pla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21984>>3]=1.0;i=i;return}function qla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21976>>3]=0.0;i=i;return}function rla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21968>>3]=0.0;i=i;return}function sla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21960>>3]=0.0;i=i;return}function tla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1364>>2]=255;i=i;return}function ula(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1360>>2]=128;i=i;return}function vla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1356>>2]=0;i=i;return}function wla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1352>>2]=155;i=i;return}function xla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1348>>2]=155;i=i;return}function yla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1344>>2]=155;i=i;return}function zla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1340>>2]=0;i=i;return}function Ala(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1336>>2]=0;i=i;return}function Bla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1332>>2]=255;i=i;return}function Cla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21936>>3]=255.0;i=i;return}function Dla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21944>>3]=0.0;i=i;return}function Ela(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21952>>3]=0.0;i=i;return}function Fla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21928>>3]=0.0;i=i;return}function Gla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21920>>3]=1.0;i=i;return}function Hla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21912>>3]=0.0;i=i;return}function Ila(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21904>>3]=0.0;i=i;return}function Jla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21896>>3]=0.0;i=i;return}function Kla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21888>>3]=1.0;i=i;return}function Lla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21880>>3]=0.0;i=i;return}function Mla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21872>>3]=0.0;i=i;return}function Nla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21864>>3]=+h[(c[a+416>>2]|0)+46336>>3]*-.5;i=i;return}function Ola(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1328>>2]=0;i=i;return}function Pla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1324>>2]=0;i=i;return}function Qla(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1320>>2]=255;i=i;return}function Rla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21840>>3]=255.0;i=i;return}function Sla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21848>>3]=0.0;i=i;return}function Tla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21856>>3]=0.0;i=i;return}function Ula(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21832>>3]=0.0;i=i;return}function Vla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21824>>3]=1.0;i=i;return}function Wla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21816>>3]=0.0;i=i;return}function Xla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21808>>3]=0.0;i=i;return}function Yla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21800>>3]=0.0;i=i;return}function Zla(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21792>>3]=1.0;i=i;return}function _la(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21784>>3]=0.0;i=i;return}function $la(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21776>>3]=0.0;i=i;return}function ama(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21768>>3]=+h[(c[a+416>>2]|0)+46320>>3]*-.5;i=i;return}function bma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1316>>2]=0;i=i;return}function cma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1312>>2]=0;i=i;return}function dma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1308>>2]=255;i=i;return}function ema(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21744>>3]=255.0;i=i;return}function fma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21752>>3]=0.0;i=i;return}function gma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21760>>3]=0.0;i=i;return}function hma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21736>>3]=0.0;i=i;return}function ima(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21728>>3]=1.0;i=i;return}function jma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21720>>3]=0.0;i=i;return}function kma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21712>>3]=0.0;i=i;return}function lma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21704>>3]=-1.0;i=i;return}function mma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21696>>3]=0.0;i=i;return}function nma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21688>>3]=0.0;i=i;return}function oma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21680>>3]=0.0;i=i;return}function pma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21672>>3]=0.0;i=i;return}function qma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1304>>2]=155;i=i;return}function rma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1300>>2]=155;i=i;return}function sma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1296>>2]=155;i=i;return}function tma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1292>>2]=155;i=i;return}function uma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1288>>2]=155;i=i;return}function vma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1284>>2]=155;i=i;return}function wma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1280>>2]=155;i=i;return}function xma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1276>>2]=155;i=i;return}function yma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1272>>2]=155;i=i;return}function zma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1268>>2]=155;i=i;return}function Ama(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1264>>2]=155;i=i;return}function Bma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1260>>2]=155;i=i;return}function Cma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1256>>2]=180;i=i;return}function Dma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1252>>2]=180;i=i;return}function Ema(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1248>>2]=180;i=i;return}function Fma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21648>>3]=180.0;i=i;return}function Gma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21656>>3]=180.0;i=i;return}function Hma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21664>>3]=180.0;i=i;return}function Ima(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21640>>3]=0.0;i=i;return}function Jma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21632>>3]=1.0;i=i;return}function Kma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21624>>3]=0.0;i=i;return}function Lma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21616>>3]=0.0;i=i;return}function Mma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21608>>3]=0.0;i=i;return}function Nma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21600>>3]=.11;i=i;return}function Oma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21592>>3]=0.0;i=i;return}function Pma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21584>>3]=0.0;i=i;return}function Qma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21576>>3]=0.0;i=i;return}function Rma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21568>>3]=0.0;i=i;return}function Sma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21560>>3]=0.0;i=i;return}function Tma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21552>>3]=0.0;i=i;return}function Uma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21544>>3]=0.0;i=i;return}function Vma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21536>>3]=0.0;i=i;return}function Wma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21528>>3]=0.0;i=i;return}function Xma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21520>>3]=1.0;i=i;return}function Yma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21512>>3]=0.0;i=i;return}function Zma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21504>>3]=0.0;i=i;return}function _ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21496>>3]=0.0;i=i;return}function $ma(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1244>>2]=255;i=i;return}function ana(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1240>>2]=128;i=i;return}function bna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1236>>2]=0;i=i;return}function cna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1232>>2]=180;i=i;return}function dna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1228>>2]=180;i=i;return}function ena(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1224>>2]=180;i=i;return}function fna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21472>>3]=180.0;i=i;return}function gna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21480>>3]=180.0;i=i;return}function hna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21488>>3]=180.0;i=i;return}function ina(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21464>>3]=0.0;i=i;return}function jna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21456>>3]=1.0;i=i;return}function kna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21448>>3]=0.0;i=i;return}function lna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21440>>3]=0.0;i=i;return}function mna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21432>>3]=0.0;i=i;return}function nna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21424>>3]=.11;i=i;return}function ona(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21416>>3]=0.0;i=i;return}function pna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21408>>3]=0.0;i=i;return}function qna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21400>>3]=0.0;i=i;return}function rna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21392>>3]=0.0;i=i;return}function sna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21384>>3]=0.0;i=i;return}function tna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21376>>3]=0.0;i=i;return}function una(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21368>>3]=0.0;i=i;return}function vna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21360>>3]=0.0;i=i;return}function wna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21352>>3]=0.0;i=i;return}function xna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21344>>3]=1.0;i=i;return}function yna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21336>>3]=0.0;i=i;return}function zna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21328>>3]=0.0;i=i;return}function Ana(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21320>>3]=0.0;i=i;return}function Bna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1220>>2]=255;i=i;return}function Cna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1216>>2]=128;i=i;return}function Dna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1212>>2]=0;i=i;return}function Ena(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21312>>3]=0.0;i=i;return}function Fna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21304>>3]=0.0;i=i;return}function Gna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21296>>3]=0.0;i=i;return}function Hna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21288>>3]=0.0;i=i;return}function Ina(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21280>>3]=0.0;i=i;return}function Jna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21272>>3]=0.0;i=i;return}function Kna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21264>>3]=0.0;i=i;return}function Lna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21256>>3]=0.0;i=i;return}function Mna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21248>>3]=0.0;i=i;return}function Nna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21240>>3]=1.0;i=i;return}function Ona(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21232>>3]=0.0;i=i;return}function Pna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21224>>3]=0.0;i=i;return}function Qna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21216>>3]=0.0;i=i;return}function Rna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1208>>2]=255;i=i;return}function Sna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1204>>2]=128;i=i;return}function Tna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1200>>2]=0;i=i;return}function Una(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1196>>2]=255;i=i;return}function Vna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1192>>2]=128;i=i;return}function Wna(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1188>>2]=0;i=i;return}function Xna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21192>>3]=0.0;i=i;return}function Yna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21200>>3]=128.0;i=i;return}function Zna(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21208>>3]=255.0;i=i;return}function _na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21184>>3]=0.0;i=i;return}function $na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21176>>3]=0.0;i=i;return}function aoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21168>>3]=1.0;i=i;return}function boa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21160>>3]=0.0;i=i;return}function coa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21152>>3]=.1;i=i;return}function doa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21144>>3]=0.0;i=i;return}function eoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21136>>3]=0.0;i=i;return}function foa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21128>>3]=0.0;i=i;return}function goa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21120>>3]=0.0;i=i;return}function hoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21112>>3]=0.0;i=i;return}function ioa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21104>>3]=0.0;i=i;return}function joa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21096>>3]=0.0;i=i;return}function koa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21088>>3]=0.0;i=i;return}function loa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21080>>3]=0.0;i=i;return}function moa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21072>>3]=0.0;i=i;return}function noa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21064>>3]=1.0;i=i;return}function ooa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21056>>3]=0.0;i=i;return}function poa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21048>>3]=0.0;i=i;return}function qoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21040>>3]=0.0;i=i;return}function roa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1184>>2]=255;i=i;return}function soa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1180>>2]=128;i=i;return}function toa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1176>>2]=0;i=i;return}function uoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1172>>2]=255;i=i;return}function voa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1168>>2]=128;i=i;return}function woa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1164>>2]=0;i=i;return}function xoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21016>>3]=0.0;i=i;return}function yoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21024>>3]=128.0;i=i;return}function zoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21032>>3]=255.0;i=i;return}function Aoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21008>>3]=0.0;i=i;return}function Boa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21e3>>3]=0.0;i=i;return}function Coa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20992>>3]=1.0;i=i;return}function Doa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20984>>3]=0.0;i=i;return}function Eoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20976>>3]=-.1;i=i;return}function Foa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20968>>3]=0.0;i=i;return}function Goa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1160>>2]=155;i=i;return}function Hoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1156>>2]=155;i=i;return}function Ioa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1152>>2]=155;i=i;return}function Joa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20960>>3]=0.0;i=i;return}function Koa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20952>>3]=0.0;i=i;return}function Loa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20944>>3]=0.0;i=i;return}function Moa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20936>>3]=0.0;i=i;return}function Noa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20928>>3]=0.0;i=i;return}function Ooa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20920>>3]=0.0;i=i;return}function Poa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20912>>3]=0.0;i=i;return}function Qoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20904>>3]=0.0;i=i;return}function Roa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20896>>3]=0.0;i=i;return}function Soa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20888>>3]=1.0;i=i;return}function Toa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20880>>3]=0.0;i=i;return}function Uoa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20872>>3]=0.0;i=i;return}function Voa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20864>>3]=0.0;i=i;return}function Woa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1148>>2]=255;i=i;return}function Xoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1144>>2]=128;i=i;return}function Yoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1140>>2]=0;i=i;return}function Zoa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1136>>2]=200;i=i;return}function _oa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1132>>2]=0;i=i;return}function $oa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1128>>2]=0;i=i;return}function apa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20840>>3]=0.0;i=i;return}function bpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20848>>3]=0.0;i=i;return}function cpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20856>>3]=200.0;i=i;return}function dpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20832>>3]=0.0;i=i;return}function epa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20824>>3]=0.0;i=i;return}function fpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20816>>3]=1.0;i=i;return}function gpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20808>>3]=0.0;i=i;return}function hpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20800>>3]=.22;i=i;return}function ipa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20792>>3]=0.0;i=i;return}function jpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1124>>2]=180;i=i;return}function kpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1120>>2]=180;i=i;return}function lpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1116>>2]=180;i=i;return}function mpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20768>>3]=180.0;i=i;return}function npa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20776>>3]=180.0;i=i;return}function opa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20784>>3]=180.0;i=i;return}function ppa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20760>>3]=0.0;i=i;return}function qpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20752>>3]=1.0;i=i;return}



function s0c(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;d=i;i=i+40|0;k=d;l=d+8|0;m=d+24|0;n=d+32|0;o=n;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+400|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;_Wc(m,g);z=m;A=c[z>>2]|0;if(!((c[91588]|0)==-1)){c[l>>2]=366352;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366352,l,770)}l=(c[366356>>2]|0)+ -1|0;B=c[A+8>>2]|0;if(!((c[A+12>>2]|0)-B>>2>>>0>l>>>0)){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}A=c[B+(l<<2)>>2]|0;if((A|0)==0){C=Ec(4)|0;D=C;O3c(D);E=381920;F=127;Td(C|0,E|0,F|0)}F=A;E=a[j]|0;C=(E&1)==0;if(C){G=(E&255)>>>1}else{G=c[j+4>>2]|0}if((G|0)==0){H=0}else{if(C){I=j+4|0}else{I=c[j+8>>2]|0}C=c[I>>2]|0;H=(C|0)==(xe[c[(c[A>>2]|0)+44>>2]&63](F,45)|0)}c[n>>2]=0;n=r;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=s;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;n=t;c[n+0>>2]=0;c[n+4>>2]=0;c[n+8>>2]=0;q0c(f,H,m,o,p,q,r,s,t,u);m=v;v=a[j]|0;f=(v&1)==0;if(f){J=(v&255)>>>1}else{J=c[j+4>>2]|0}n=c[u>>2]|0;if((J|0)>(n|0)){if(f){K=(v&255)>>>1}else{K=c[j+4>>2]|0}f=a[t]|0;if((f&1)==0){L=(f&255)>>>1}else{L=c[t+4>>2]|0}f=a[s]|0;if((f&1)==0){M=(f&255)>>>1}else{M=c[s+4>>2]|0}N=L+(K-n<<1|1)+M|0}else{M=a[t]|0;if((M&1)==0){O=(M&255)>>>1}else{O=c[t+4>>2]|0}M=a[s]|0;if((M&1)==0){P=(M&255)>>>1}else{P=c[s+4>>2]|0}N=O+2+P|0}P=N+n|0;do{if(P>>>0>100){N=h4c(P<<2)|0;O=N;if((N|0)!=0){Q=O;R=O;break}u4c()}else{Q=0;R=m}}while(0);if((v&1)==0){S=j+4|0;T=(v&255)>>>1}else{S=c[j+8>>2]|0;T=c[j+4>>2]|0}r0c(R,w,x,c[g+4>>2]|0,S,S+(T<<2)|0,F,H,o,c[p>>2]|0,c[q>>2]|0,r,s,t,n);c[y>>2]=c[e>>2];e=c[w>>2]|0;w=c[x>>2]|0;x=k;n=y;c[x+0>>2]=c[n+0>>2];k_c(b,k,R,e,w,g,h);if((Q|0)==0){GWc(t);GWc(s);cWc(r);U=c[z>>2]|0;V=U;W=V;X=uVc(W)|0;i=d;return}i4c(Q);GWc(t);GWc(s);cWc(r);U=c[z>>2]|0;V=U;W=V;X=uVc(W)|0;i=d;return}function t0c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function u0c(a){a=a|0;i=i;return}function v0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function w0c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;d=i;i=i+16|0;j=d;k=j;c[k+0>>2]=0;c[k+4>>2]=0;c[k+8>>2]=0;k=a[h]|0;if((k&1)==0){l=h+1|0;m=h+1|0;n=(k&255)>>>1}else{k=c[h+8>>2]|0;l=k;m=k;n=c[h+4>>2]|0}h=l+n|0;do{if(m>>>0<h>>>0){n=m;do{uWc(j,a[n]|0);n=n+1|0;}while(n>>>0<h>>>0);n=(e|0)==-1?-1:e<<1;if((a[j]&1)==0){o=n;p=9;break}q=n;r=c[j+8>>2]|0}else{o=(e|0)==-1?-1:e<<1;p=9}}while(0);if((p|0)==9){q=o;r=j+1|0}o=yd(q|0,f|0,g|0,r|0)|0;r=b;c[r+0>>2]=0;c[r+4>>2]=0;c[r+8>>2]=0;r=L4c(o|0)|0;g=o+r|0;if((r|0)>0){s=o}else{cWc(j);i=d;return}do{uWc(b,a[s]|0);s=s+1|0;}while(s>>>0<g>>>0);cWc(j);i=d;return}function x0c(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function y0c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function z0c(a){a=a|0;i=i;return}function A0c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((a[d]&1)==0){f=d+1|0}else{f=c[d+8>>2]|0}d=uc(f|0,1)|0;i=e;return d>>>((d|0)!=(-1|0)|0)|0}function B0c(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;d=i;i=i+240|0;j=d;k=d+8|0;l=d+40|0;m=d+48|0;n=d+56|0;o=d+64|0;p=d+192|0;q=d+200|0;r=d+208|0;s=d+224|0;t=d+232|0;u=r;c[u+0>>2]=0;c[u+4>>2]=0;c[u+8>>2]=0;c[s+4>>2]=0;c[s>>2]=368016;u=a[h]|0;if((u&1)==0){v=h+4|0;w=h+4|0;x=(u&255)>>>1}else{u=c[h+8>>2]|0;v=u;w=u;x=c[h+4>>2]|0}h=v+(x<<2)|0;x=k;v=j;u=j;c[u>>2]=0;c[u+4>>2]=0;a:do{if(w>>>0<h>>>0){u=s;j=k+32|0;y=w;z=368016|0;while(1){c[m>>2]=y;A=(Ge[c[z+12>>2]&15](u,v,y,h,m,x,j,l)|0)==2;B=c[m>>2]|0;if(A|(B|0)==(y|0)){break}if(x>>>0<(c[l>>2]|0)>>>0){A=x;do{uWc(r,a[A]|0);A=A+1|0;}while(A>>>0<(c[l>>2]|0)>>>0);C=c[m>>2]|0}else{C=B}if(!(C>>>0<h>>>0)){break a}y=C;z=c[s>>2]|0}W$c(367240)}}while(0);if((a[r]&1)==0){D=r+1|0}else{D=c[r+8>>2]|0}s=yd(((e|0)==-1?-1:e<<1)|0,f|0,g|0,D|0)|0;D=b;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[t+4>>2]=0;c[t>>2]=368120;D=L4c(s|0)|0;g=s+D|0;f=n;e=n;c[e>>2]=0;c[e+4>>2]=0;if((D|0)<=0){cWc(r);i=d;return}D=t;e=g;n=o;C=o+128|0;o=s;s=368120|0;while(1){c[q>>2]=o;h=(Ge[c[s+16>>2]&15](D,f,o,(e-o|0)>32?o+32|0:g,q,n,C,p)|0)==2;m=c[q>>2]|0;if(h|(m|0)==(o|0)){E=20;break}if(n>>>0<(c[p>>2]|0)>>>0){h=n;do{KWc(b,c[h>>2]|0);h=h+4|0;}while(h>>>0<(c[p>>2]|0)>>>0);F=c[q>>2]|0}else{F=m}if(!(F>>>0<g>>>0)){E=25;break}o=F;s=c[t>>2]|0}if((E|0)==20){W$c(367240)}else if((E|0)==25){cWc(r);i=d;return}}function C0c(a,b){a=a|0;b=b|0;a=i;Hb(((b|0)==-1?-1:b<<1)|0)|0;i=a;return}function D0c(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=366448;e=b+8|0;b=c[e>>2]|0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);if((b|0)==(c[91562]|0)){i=d;return}ac(c[e>>2]|0);i=d;return}function E0c(a){a=a|0;a=Ec(8)|0;vVc(a,366240);c[a>>2]=363208;Td(a|0,363248,40)}function F0c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0;e=i;i=i+448|0;f=e;g=e+16|0;h=e+32|0;j=e+48|0;k=e+64|0;l=e+80|0;m=e+96|0;n=e+112|0;o=e+128|0;p=e+144|0;q=e+160|0;r=e+176|0;s=e+192|0;t=e+208|0;u=e+224|0;v=e+240|0;w=e+256|0;x=e+272|0;y=e+288|0;z=e+304|0;A=e+320|0;B=e+336|0;C=e+352|0;D=e+368|0;E=e+384|0;F=e+400|0;G=e+416|0;H=e+432|0;c[b+4>>2]=d+ -1;c[b>>2]=366280;d=b+8|0;I=b+12|0;J=b+136|0;a[J]=1;K=b+24|0;c[I>>2]=K;c[d>>2]=K;c[b+16>>2]=J;J=28;L=K;do{if((L|0)==0){M=0}else{c[L>>2]=0;M=c[I>>2]|0}L=M+4|0;c[I>>2]=L;J=J+ -1|0;}while((J|0)!=0);WVc(b+144|0,366264,1);J=c[d>>2]|0;d=c[I>>2]|0;if((d|0)!=(J|0)){c[I>>2]=d+(~((d+ -4+(0-J)|0)>>>2)<<2)}c[371172>>2]=0;c[92792]=364760;if(!((c[91196]|0)==-1)){c[G>>2]=364784;c[G+4>>2]=769;c[G+8>>2]=0;PVc(364784,G,770)}G0c(b,371168,(c[364788>>2]|0)+ -1|0);c[371164>>2]=0;c[92790]=364800;if(!((c[91206]|0)==-1)){c[F>>2]=364824;c[F+4>>2]=769;c[F+8>>2]=0;PVc(364824,F,770)}G0c(b,371160,(c[364828>>2]|0)+ -1|0);c[371148>>2]=0;c[92786]=366376;c[371152>>2]=0;a[371156|0]=0;F=c[(yc()|0)>>2]|0;c[371152>>2]=F;if(!((c[91590]|0)==-1)){c[E>>2]=366360;c[E+4>>2]=769;c[E+8>>2]=0;PVc(366360,E,770)}G0c(b,371144,(c[366364>>2]|0)+ -1|0);c[371140>>2]=0;c[92784]=367336;if(!((c[91588]|0)==-1)){c[D>>2]=366352;c[D+4>>2]=769;c[D+8>>2]=0;PVc(366352,D,770)}G0c(b,371136,(c[366356>>2]|0)+ -1|0);c[371132>>2]=0;c[92782]=367552;if(!((c[91606]|0)==-1)){c[C>>2]=366424;c[C+4>>2]=769;c[C+8>>2]=0;PVc(366424,C,770)}G0c(b,371128,(c[366428>>2]|0)+ -1|0);c[371116>>2]=0;c[92778]=366448;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);c[371120>>2]=c[91562];if(!((c[91608]|0)==-1)){c[B>>2]=366432;c[B+4>>2]=769;c[B+8>>2]=0;PVc(366432,B,770)}G0c(b,371112,(c[366436>>2]|0)+ -1|0);c[371108>>2]=0;c[92776]=367776;if(!((c[91622]|0)==-1)){c[A>>2]=366488;c[A+4>>2]=769;c[A+8>>2]=0;PVc(366488,A,770)}G0c(b,371104,(c[366492>>2]|0)+ -1|0);c[371100>>2]=0;c[92774]=367896;if(!((c[91624]|0)==-1)){c[z>>2]=366496;c[z+4>>2]=769;c[z+8>>2]=0;PVc(366496,z,770)}G0c(b,371096,(c[366500>>2]|0)+ -1|0);c[371076>>2]=0;c[92768]=366528;a[371080|0]=46;a[371081|0]=44;z=371084|0;c[z+0>>2]=0;c[z+4>>2]=0;c[z+8>>2]=0;if(!((c[91626]|0)==-1)){c[y>>2]=366504;c[y+4>>2]=769;c[y+8>>2]=0;PVc(366504,y,770)}G0c(b,371072,(c[366508>>2]|0)+ -1|0);c[371044>>2]=0;c[92760]=366568;c[371048>>2]=46;c[371052>>2]=44;y=371056|0;c[y+0>>2]=0;c[y+4>>2]=0;c[y+8>>2]=0;if(!((c[91628]|0)==-1)){c[x>>2]=366512;c[x+4>>2]=769;c[x+8>>2]=0;PVc(366512,x,770)}G0c(b,371040,(c[366516>>2]|0)+ -1|0);c[371036>>2]=0;c[92758]=364840;if(!((c[91224]|0)==-1)){c[w>>2]=364896;c[w+4>>2]=769;c[w+8>>2]=0;PVc(364896,w,770)}G0c(b,371032,(c[364900>>2]|0)+ -1|0);c[371028>>2]=0;c[92756]=364960;if(!((c[91254]|0)==-1)){c[v>>2]=365016;c[v+4>>2]=769;c[v+8>>2]=0;PVc(365016,v,770)}G0c(b,371024,(c[365020>>2]|0)+ -1|0);c[371020>>2]=0;c[92754]=365032;if(!((c[91270]|0)==-1)){c[u>>2]=365080;c[u+4>>2]=769;c[u+8>>2]=0;PVc(365080,u,770)}G0c(b,371016,(c[365084>>2]|0)+ -1|0);c[371012>>2]=0;c[92752]=365096;if(!((c[91286]|0)==-1)){c[t>>2]=365144;c[t+4>>2]=769;c[t+8>>2]=0;PVc(365144,t,770)}G0c(b,371008,(c[365148>>2]|0)+ -1|0);c[371004>>2]=0;c[92750]=365688;if(!((c[91434]|0)==-1)){c[s>>2]=365736;c[s+4>>2]=769;c[s+8>>2]=0;PVc(365736,s,770)}G0c(b,371e3,(c[365740>>2]|0)+ -1|0);c[370996>>2]=0;c[92748]=365752;if(!((c[91450]|0)==-1)){c[r>>2]=365800;c[r+4>>2]=769;c[r+8>>2]=0;PVc(365800,r,770)}G0c(b,370992,(c[365804>>2]|0)+ -1|0);c[370988>>2]=0;c[92746]=365816;if(!((c[91466]|0)==-1)){c[q>>2]=365864;c[q+4>>2]=769;c[q+8>>2]=0;PVc(365864,q,770)}G0c(b,370984,(c[365868>>2]|0)+ -1|0);c[370980>>2]=0;c[92744]=365880;if(!((c[91482]|0)==-1)){c[p>>2]=365928;c[p+4>>2]=769;c[p+8>>2]=0;PVc(365928,p,770)}G0c(b,370976,(c[365932>>2]|0)+ -1|0);c[370972>>2]=0;c[92742]=365944;if(!((c[91492]|0)==-1)){c[o>>2]=365968;c[o+4>>2]=769;c[o+8>>2]=0;PVc(365968,o,770)}G0c(b,370968,(c[365972>>2]|0)+ -1|0);c[370964>>2]=0;c[92740]=366024;if(!((c[91512]|0)==-1)){c[n>>2]=366048;c[n+4>>2]=769;c[n+8>>2]=0;PVc(366048,n,770)}G0c(b,370960,(c[366052>>2]|0)+ -1|0);c[370956>>2]=0;c[92738]=366080;if(!((c[91526]|0)==-1)){c[m>>2]=366104;c[m+4>>2]=769;c[m+8>>2]=0;PVc(366104,m,770)}G0c(b,370952,(c[366108>>2]|0)+ -1|0);c[370948>>2]=0;c[92736]=366128;if(!((c[91538]|0)==-1)){c[l>>2]=366152;c[l+4>>2]=769;c[l+8>>2]=0;PVc(366152,l,770)}G0c(b,370944,(c[366156>>2]|0)+ -1|0);c[370932>>2]=0;c[92732]=365176;c[370936>>2]=365224;if(!((c[91314]|0)==-1)){c[k>>2]=365256;c[k+4>>2]=769;c[k+8>>2]=0;PVc(365256,k,770)}G0c(b,370928,(c[365260>>2]|0)+ -1|0);c[370916>>2]=0;c[92728]=365328;c[370920>>2]=365376;if(!((c[91352]|0)==-1)){c[j>>2]=365408;c[j+4>>2]=769;c[j+8>>2]=0;PVc(365408,j,770)}G0c(b,370912,(c[365412>>2]|0)+ -1|0);c[370900>>2]=0;c[92724]=367272;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);c[370904>>2]=c[91562];c[92724]=365624;if(!((c[91410]|0)==-1)){c[h>>2]=365640;c[h+4>>2]=769;c[h+8>>2]=0;PVc(365640,h,770)}G0c(b,370896,(c[365644>>2]|0)+ -1|0);c[370884>>2]=0;c[92720]=367272;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);c[370888>>2]=c[91562];c[92720]=365656;if(!((c[91418]|0)==-1)){c[g>>2]=365672;c[g+4>>2]=769;c[g+8>>2]=0;PVc(365672,g,770)}G0c(b,370880,(c[365676>>2]|0)+ -1|0);c[370876>>2]=0;c[92718]=366168;if(!((c[91548]|0)==-1)){c[f>>2]=366192;c[f+4>>2]=769;c[f+8>>2]=0;PVc(366192,f,770)}G0c(b,370872,(c[366196>>2]|0)+ -1|0);c[370868>>2]=0;c[92716]=366208;if((c[91558]|0)==-1){N=366232;O=366232;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=370864;G0c(b,T,S);i=e;return}c[H>>2]=366232;c[H+4>>2]=769;c[H+8>>2]=0;PVc(366232,H,770);N=366232;O=366232;P=O+4|0;Q=P;R=c[Q>>2]|0;S=R+ -1|0;T=370864;G0c(b,T,S);i=e;return}function G0c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;tVc(b);f=a+8|0;g=a+12|0;a=c[g>>2]|0;h=f;j=c[h>>2]|0;k=a-j>>2;do{if(k>>>0>d>>>0){l=j}else{m=d+1|0;if(k>>>0<m>>>0){L2c(f,m-k|0);l=c[h>>2]|0;break}if(!(k>>>0>m>>>0)){l=j;break}n=j+(m<<2)|0;if((a|0)==(n|0)){l=j;break}c[g>>2]=a+(~((a+ -4+(0-n)|0)>>>2)<<2);l=j}}while(0);j=c[l+(d<<2)>>2]|0;if((j|0)==0){o=l;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}uVc(j)|0;o=c[h>>2]|0;p=o;q=d<<2;r=p+q|0;s=r;c[s>>2]=b;i=e;return}function H0c(a){a=a|0;var b=0;b=i;I0c(a);p4c(a);i=b;return}function I0c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;c[b>>2]=366280;e=b+12|0;f=c[e>>2]|0;g=b+8|0;h=c[g>>2]|0;if((f|0)!=(h|0)){j=f;f=h;h=0;while(1){k=c[f+(h<<2)>>2]|0;if((k|0)==0){l=f;m=j}else{uVc(k)|0;l=c[g>>2]|0;m=c[e>>2]|0}k=h+1|0;if(k>>>0<m-l>>2>>>0){j=m;f=l;h=k}else{break}}}cWc(b+144|0);h=c[g>>2]|0;if((h|0)==0){i=d;return}g=c[e>>2]|0;if((g|0)!=(h|0)){c[e>>2]=g+(~((g+ -4+(0-h)|0)>>>2)<<2)}if((b+24|0)==(h|0)){a[b+136|0]=0;i=d;return}else{p4c(h);i=d;return}}function J0c(){var b=0,d=0,e=0,f=0;b=i;if((a[366336]|0)!=0){d=366328;e=c[91582]|0;i=b;return e|0}if((Za(366336)|0)==0){d=366328;e=c[91582]|0;i=b;return e|0}do{if((a[366312]|0)==0){if((Za(366312)|0)==0){break}F0c(370704,1);c[91574]=370704;c[91576]=366296;Tb(366312)}}while(0);f=c[c[91576]>>2]|0;c[91580]=f;tVc(f);c[91582]=366320;Tb(366336);d=366328;e=c[91582]|0;i=b;return e|0}function K0c(a){a=a|0;var b=0,d=0;b=i;d=c[(J0c()|0)>>2]|0;c[a>>2]=d;tVc(d);i=b;return}function L0c(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;tVc(e);i=d;return}function M0c(a){a=a|0;var b=0;b=i;uVc(c[a>>2]|0)|0;i=b;return}function N0c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=769;c[e+8>>2]=0;PVc(a,e,770)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=0;i=d;return g|0}g=(c[b+(e<<2)>>2]|0)!=0;i=d;return g|0}function O0c(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+16|0;e=d;f=c[a>>2]|0;a=b;if(!((c[a>>2]|0)==-1)){c[e>>2]=b;c[e+4>>2]=769;c[e+8>>2]=0;PVc(a,e,770)}e=(c[b+4>>2]|0)+ -1|0;b=c[f+8>>2]|0;if(!((c[f+12>>2]|0)-b>>2>>>0>e>>>0)){g=Ec(4)|0;h=g;O3c(h);j=381920;k=127;Td(g|0,j|0,k|0)}f=c[b+(e<<2)>>2]|0;if((f|0)==0){g=Ec(4)|0;h=g;O3c(h);j=381920;k=127;Td(g|0,j|0,k|0)}else{i=d;return f|0}return 0}function P0c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function Q0c(a){a=a|0;var b=0;b=i;if((a|0)==0){i=b;return}fe[c[(c[a>>2]|0)+4>>2]&1023](a);i=b;return}function R0c(a){a=a|0;var b=0;b=c[91586]|0;c[91586]=1+b;c[a+4>>2]=b+1;i=i;return}function S0c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function T0c(a,d,e){a=a|0;d=d|0;e=e|0;var f=0;a=i;if(!(e>>>0<128)){f=0;i=a;return f|0}f=(b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16!=0;i=a;return f|0}function U0c(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;if((d|0)==(e|0)){g=d;i=a;return g|0}else{h=d;j=f}while(1){f=c[h>>2]|0;if(f>>>0<128){k=b[(c[(yc()|0)>>2]|0)+(f<<1)>>1]|0}else{k=0}b[j>>1]=k;f=h+4|0;if((f|0)==(e|0)){g=e;break}else{h=f;j=j+2|0}}i=a;return g|0}function V0c(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;a=i;if((e|0)==(f|0)){g=e;i=a;return g|0}else{h=e}while(1){e=c[h>>2]|0;if(e>>>0<128){if(!((b[(c[(yc()|0)>>2]|0)+(e<<1)>>1]&d)<<16>>16==0)){g=h;j=5;break}}e=h+4|0;if((e|0)==(f|0)){g=f;j=5;break}else{h=e}}if((j|0)==5){i=a;return g|0}return 0}function W0c(a,d,e,f){a=a|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;a=i;a:do{if((e|0)==(f|0)){g=e}else{h=e;while(1){j=c[h>>2]|0;if(!(j>>>0<128)){g=h;break a}k=h+4|0;if((b[(c[(yc()|0)>>2]|0)+(j<<1)>>1]&d)<<16>>16==0){g=h;break a}if((k|0)==(f|0)){g=f;break}else{h=k}}}}while(0);i=a;return g|0}function X0c(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function Y0c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Dd()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function Z0c(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b>>>0<128)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0;i=a;return d|0}function _0c(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;a=i;if((b|0)==(d|0)){e=b;i=a;return e|0}else{f=b}while(1){b=c[f>>2]|0;if(b>>>0<128){g=c[(c[(Id()|0)>>2]|0)+(b<<2)>>2]|0}else{g=b}c[f>>2]=g;b=f+4|0;if((b|0)==(d|0)){e=d;break}else{f=b}}i=a;return e|0}function $0c(a,b){a=a|0;b=b|0;i=i;return b<<24>>24|0}function a1c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((d|0)==(e|0)){g=d;i=b;return g|0}else{h=d;j=f}while(1){c[j>>2]=a[h]|0;f=h+1|0;if((f|0)==(e|0)){g=e;break}else{j=j+4|0;h=f}}i=b;return g|0}function b1c(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b>>>0<128?b&255:c)|0}function c1c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0;b=i;if((d|0)==(e|0)){h=d;i=b;return h|0}j=((e+ -4+(0-d)|0)>>>2)+1|0;k=d;l=g;while(1){g=c[k>>2]|0;a[l]=g>>>0<128?g&255:f;g=k+4|0;if((g|0)==(e|0)){break}else{l=l+1|0;k=g}}h=d+(j<<2)|0;i=b;return h|0}function d1c(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=366376;e=c[b+8>>2]|0;do{if((e|0)!=0){if((a[b+12|0]|0)==0){break}q4c(e)}}while(0);p4c(b);i=d;return}function e1c(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=366376;e=c[b+8>>2]|0;if((e|0)==0){i=d;return}if((a[b+12|0]|0)==0){i=d;return}q4c(e);i=d;return}function f1c(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Dd()|0)>>2]|0)+((b&255)<<2)>>2]&255;i=a;return d|0}function g1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Dd()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function h1c(a,b){a=a|0;b=b|0;var d=0;a=i;if(!(b<<24>>24>-1)){d=b;i=a;return d|0}d=c[(c[(Id()|0)>>2]|0)+(b<<24>>24<<2)>>2]&255;i=a;return d|0}function i1c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((d|0)==(e|0)){f=d;i=b;return f|0}else{g=d}while(1){d=a[g]|0;if(d<<24>>24>-1){h=c[(c[(Id()|0)>>2]|0)+(d<<24>>24<<2)>>2]&255}else{h=d}a[g]=h;d=g+1|0;if((d|0)==(e|0)){f=e;break}else{g=d}}i=b;return f|0}function j1c(a,b){a=a|0;b=b|0;i=i;return b|0}function k1c(b,c,d,e){b=b|0;c=c|0;d=d|0;e=e|0;var f=0,g=0,h=0;b=i;if((c|0)==(d|0)){f=c;i=b;return f|0}else{g=c;h=e}while(1){a[h]=a[g]|0;e=g+1|0;if((e|0)==(d|0)){f=d;break}else{h=h+1|0;g=e}}i=b;return f|0}function l1c(a,b,c){a=a|0;b=b|0;c=c|0;i=i;return(b<<24>>24>-1?b:c)|0}function m1c(b,c,d,e,f){b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0;b=i;if((c|0)==(d|0)){g=c;i=b;return g|0}else{h=c;j=f}while(1){f=a[h]|0;a[j]=f<<24>>24>-1?f:e;f=h+1|0;if((f|0)==(d|0)){g=d;break}else{j=j+1|0;h=f}}i=b;return g|0}function n1c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function o1c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function p1c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;c[f>>2]=d;c[j>>2]=g;i=i;return 3}function q1c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function r1c(a){a=a|0;i=i;return 1}function s1c(a){a=a|0;i=i;return 1}function t1c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=d-c|0;i=i;return(b>>>0<e>>>0?b:e)|0}function u1c(a){a=a|0;i=i;return 1}function v1c(a){a=a|0;var b=0;b=i;D0c(a);p4c(a);i=b;return}function w1c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;l=i;i=i+8|0;m=l;n=m;o=i;i=i+8|0;p=(e|0)==(f|0);a:do{if(p){c[k>>2]=h;c[g>>2]=e;q=e}else{r=e;while(1){s=r+4|0;if((c[r>>2]|0)==0){t=r;break}if((s|0)==(f|0)){t=f;break}else{r=s}}c[k>>2]=h;c[g>>2]=e;if(p|(h|0)==(j|0)){q=e;break}r=j;s=b+8|0;u=o;v=e;w=h;x=t;while(1){y=d;z=c[y+4>>2]|0;A=m;c[A>>2]=c[y>>2];c[A+4>>2]=z;z=Lc(c[s>>2]|0)|0;A=n3c(w,g,x-v>>2,r-w|0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){B=10;break}else if((A|0)==0){C=1;B=33;break}z=(c[k>>2]|0)+A|0;c[k>>2]=z;if((z|0)==(j|0)){B=31;break}if((x|0)==(f|0)){D=c[g>>2]|0;E=z;F=f}else{z=Lc(c[s>>2]|0)|0;A=m3c(u,0,d)|0;if((z|0)!=0){Lc(z|0)|0}if((A|0)==-1){C=2;B=33;break}z=c[k>>2]|0;if(A>>>0>(r-z|0)>>>0){C=1;B=33;break}b:do{if((A|0)!=0){y=z;G=A;H=u;while(1){I=a[H]|0;c[k>>2]=y+1;a[y]=I;I=G+ -1|0;if((I|0)==0){break b}y=c[k>>2]|0;H=H+1|0;G=I}}}while(0);A=(c[g>>2]|0)+4|0;c[g>>2]=A;c:do{if((A|0)==(f|0)){J=f}else{z=A;while(1){G=z+4|0;if((c[z>>2]|0)==0){J=z;break c}if((G|0)==(f|0)){J=f;break}else{z=G}}}}while(0);D=A;E=c[k>>2]|0;F=J}if((D|0)==(f|0)|(E|0)==(j|0)){q=D;break a}else{v=D;w=E;x=F}}if((B|0)==10){c[k>>2]=w;d:do{if((v|0)==(c[g>>2]|0)){K=v}else{x=v;u=w;while(1){r=c[x>>2]|0;z=Lc(c[s>>2]|0)|0;G=m3c(u,r,n)|0;if((z|0)!=0){Lc(z|0)|0}if((G|0)==-1){K=x;break d}z=(c[k>>2]|0)+G|0;c[k>>2]=z;G=x+4|0;if((G|0)==(c[g>>2]|0)){K=G;break}else{x=G;u=z}}}}while(0);c[g>>2]=K;C=2;i=l;return C|0}else if((B|0)==31){q=c[g>>2]|0;break}else if((B|0)==33){i=l;return C|0}}}while(0);C=(q|0)!=(f|0)|0;i=l;return C|0}function x1c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;l=i;i=i+8|0;m=l;n=m;o=(e|0)==(f|0);a:do{if(o){c[k>>2]=h;c[g>>2]=e;p=e}else{q=e;while(1){r=q+1|0;if((a[q]|0)==0){s=q;break}if((r|0)==(f|0)){s=f;break}else{q=r}}c[k>>2]=h;c[g>>2]=e;if(o|(h|0)==(j|0)){p=e;break}q=j;r=b+8|0;t=e;u=h;v=s;while(1){w=d;x=c[w+4>>2]|0;y=m;c[y>>2]=c[w>>2];c[y+4>>2]=x;z=v;x=Lc(c[r>>2]|0)|0;y=j3c(u,g,z-t|0,q-u>>2,d)|0;if((x|0)!=0){Lc(x|0)|0}if((y|0)==-1){A=10;break}else if((y|0)==0){B=2;A=32;break}x=(c[k>>2]|0)+(y<<2)|0;c[k>>2]=x;if((x|0)==(j|0)){A=30;break}y=c[g>>2]|0;if((v|0)==(f|0)){C=y;D=x;E=f}else{w=Lc(c[r>>2]|0)|0;F=i3c(x,y,1,d)|0;if((w|0)!=0){Lc(w|0)|0}if((F|0)!=0){B=2;A=32;break}c[k>>2]=(c[k>>2]|0)+4;F=(c[g>>2]|0)+1|0;c[g>>2]=F;b:do{if((F|0)==(f|0)){G=f}else{w=F;while(1){y=w+1|0;if((a[w]|0)==0){G=w;break b}if((y|0)==(f|0)){G=f;break}else{w=y}}}}while(0);C=F;D=c[k>>2]|0;E=G}if((C|0)==(f|0)|(D|0)==(j|0)){p=C;break a}else{t=C;u=D;v=E}}if((A|0)==10){c[k>>2]=u;c:do{if((t|0)==(c[g>>2]|0)){H=t}else{v=t;q=u;while(1){w=Lc(c[r>>2]|0)|0;y=i3c(q,v,z-v|0,n)|0;if((w|0)!=0){Lc(w|0)|0}if((y|0)==-1){A=15;break}else if((y|0)==-2){A=16;break}else if((y|0)==0){I=v+1|0}else{I=v+y|0}y=(c[k>>2]|0)+4|0;c[k>>2]=y;if((I|0)==(c[g>>2]|0)){H=I;break c}else{v=I;q=y}}if((A|0)==15){c[g>>2]=v;B=2;i=l;return B|0}else if((A|0)==16){c[g>>2]=v;B=1;i=l;return B|0}}}while(0);c[g>>2]=H;B=(H|0)!=(f|0)|0;i=l;return B|0}else if((A|0)==30){p=c[g>>2]|0;break}else if((A|0)==32){i=l;return B|0}}}while(0);B=(p|0)!=(f|0)|0;i=l;return B|0}function y1c(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+8|0;c[g>>2]=e;e=h;j=Lc(c[b+8>>2]|0)|0;b=m3c(e,0,d)|0;if((j|0)!=0){Lc(j|0)|0}if((b|0)==0|(b|0)==-1){k=2;i=h;return k|0}j=b+ -1|0;b=c[g>>2]|0;if(j>>>0>(f-b|0)>>>0){k=1;i=h;return k|0}if((j|0)==0){k=0;i=h;return k|0}else{l=b;m=j;n=e}while(1){e=a[n]|0;c[g>>2]=l+1;a[l]=e;e=m+ -1|0;if((e|0)==0){k=0;break}l=c[g>>2]|0;n=n+1|0;m=e}i=h;return k|0}function z1c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=a+8|0;a=Lc(c[d>>2]|0)|0;e=l3c(0,0,4)|0;if((a|0)!=0){Lc(a|0)|0}do{if((e|0)==0){a=c[d>>2]|0;if((a|0)==0){f=1;break}g=Lc(a|0)|0;if((g|0)==0){f=0;break}Lc(g|0)|0;f=0}else{f=-1}}while(0);i=b;return f|0}function A1c(a){a=a|0;i=i;return 0}function B1c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;if((f|0)==0|(d|0)==(e|0)){h=0;i=g;return h|0}j=e;k=a+8|0;a=d;d=0;l=0;while(1){m=Lc(c[k>>2]|0)|0;n=h3c(a,j-a|0,b)|0;if((m|0)!=0){Lc(m|0)|0}if((n|0)==0){o=a+1|0;p=1}else if((n|0)==-2|(n|0)==-1){h=d;q=9;break}else{o=a+n|0;p=n}n=p+d|0;m=l+1|0;if(m>>>0>=f>>>0|(o|0)==(e|0)){h=n;q=9;break}else{a=o;d=n;l=m}}if((q|0)==9){i=g;return h|0}return 0}function C1c(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+8>>2]|0;do{if((d|0)==0){e=1}else{a=Lc(d|0)|0;if((a|0)==0){e=4;break}Lc(a|0)|0;e=4}}while(0);i=b;return e|0}function D1c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function E1c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=F1c(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>1<<1);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function F1c(d,f,g,h,j,k,l,m){d=d|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0;n=i;c[g>>2]=d;c[k>>2]=h;do{if((m&2|0)!=0){if((j-h|0)<3){o=1;i=n;return o|0}else{c[k>>2]=h+1;a[h]=-17;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-69;d=c[k>>2]|0;c[k>>2]=d+1;a[d]=-65;break}}}while(0);h=f;m=c[g>>2]|0;if(!(m>>>0<f>>>0)){o=0;i=n;return o|0}d=j;j=m;a:while(1){m=b[j>>1]|0;p=m&65535;if(p>>>0>l>>>0){o=2;q=26;break}do{if((m&65535)<128){r=c[k>>2]|0;if((d-r|0)<1){o=1;q=26;break a}c[k>>2]=r+1;a[r]=m}else{if((m&65535)<2048){r=c[k>>2]|0;if((d-r|0)<2){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>6|192;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((m&65535)<55296){r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if(!((m&65535)<56320)){if((m&65535)<57344){o=2;q=26;break a}r=c[k>>2]|0;if((d-r|0)<3){o=1;q=26;break a}c[k>>2]=r+1;a[r]=p>>>12|224;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p>>>6&63|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p&63|128;break}if((h-j|0)<4){o=1;q=26;break a}r=j+2|0;s=e[r>>1]|0;if((s&64512|0)!=56320){o=2;q=26;break a}if((d-(c[k>>2]|0)|0)<4){o=1;q=26;break a}t=p&960;if(((t<<10)+65536|p<<10&64512|s&1023)>>>0>l>>>0){o=2;q=26;break a}c[g>>2]=r;r=(t>>>6)+1|0;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=r>>>2|240;t=c[k>>2]|0;c[k>>2]=t+1;a[t]=p>>>2&15|r<<4&48|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=p<<4&48|s>>>6&15|128;r=c[k>>2]|0;c[k>>2]=r+1;a[r]=s&63|128}}while(0);p=(c[g>>2]|0)+2|0;c[g>>2]=p;if(p>>>0<f>>>0){j=p}else{o=0;q=26;break}}if((q|0)==26){i=n;return o|0}return 0}function G1c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=H1c(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>1<<1);i=b;return l|0}function H1c(e,f,g,h,j,k,l,m){e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;n=i;c[g>>2]=e;c[k>>2]=h;h=c[g>>2]|0;do{if((m&4|0)==0){o=h}else{if((f-h|0)<=2){o=h;break}if(!((a[h]|0)==-17)){o=h;break}if(!((a[h+1|0]|0)==-69)){o=h;break}if(!((a[h+2|0]|0)==-65)){o=h;break}e=h+3|0;c[g>>2]=e;o=e}}while(0);a:do{if(o>>>0<f>>>0){h=f;m=j;e=o;p=c[k>>2]|0;b:while(1){if(!(p>>>0<j>>>0)){q=e;break a}r=a[e]|0;s=r&255;if(s>>>0>l>>>0){t=2;u=41;break}do{if(r<<24>>24>-1){b[p>>1]=r&255;c[g>>2]=e+1}else{if((r&255)<194){t=2;u=41;break b}if((r&255)<224){if((h-e|0)<2){t=1;u=41;break b}v=d[e+1|0]|0;if((v&192|0)!=128){t=2;u=41;break b}w=v&63|s<<6&1984;if(w>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=w;c[g>>2]=e+2;break}if((r&255)<240){if((h-e|0)<3){t=1;u=41;break b}w=a[e+1|0]|0;v=a[e+2|0]|0;if((s|0)==224){if(!((w&-32)<<24>>24==-96)){t=2;u=41;break b}}else if((s|0)==237){if(!((w&-32)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((w&-64)<<24>>24==-128)){t=2;u=41;break b}}x=v&255;if((x&192|0)!=128){t=2;u=41;break b}v=(w&255)<<6&4032|s<<12|x&63;if((v&65535)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=v;c[g>>2]=e+3;break}if(!((r&255)<245)){t=2;u=41;break b}if((h-e|0)<4){t=1;u=41;break b}v=a[e+1|0]|0;x=a[e+2|0]|0;w=a[e+3|0]|0;if((s|0)==240){if(!((v+112<<24>>24&255)<48)){t=2;u=41;break b}}else if((s|0)==244){if(!((v&-16)<<24>>24==-128)){t=2;u=41;break b}}else{if(!((v&-64)<<24>>24==-128)){t=2;u=41;break b}}y=x&255;if((y&192|0)!=128){t=2;u=41;break b}x=w&255;if((x&192|0)!=128){t=2;u=41;break b}if((m-p|0)<4){t=1;u=41;break b}w=s&7;z=v&255;v=y<<6;A=x&63;if((z<<12&258048|w<<18|v&4032|A)>>>0>l>>>0){t=2;u=41;break b}b[p>>1]=z<<2&60|y>>>4&3|((z>>>4&3|w<<2)<<6)+16320|55296;w=p+2|0;c[k>>2]=w;b[w>>1]=A|v&960|56320;c[g>>2]=(c[g>>2]|0)+4}}while(0);s=(c[k>>2]|0)+2|0;c[k>>2]=s;r=c[g>>2]|0;if(r>>>0<f>>>0){e=r;p=s}else{q=r;break a}}if((u|0)==41){i=n;return t|0}}else{q=o}}while(0);t=q>>>0<f>>>0|0;i=n;return t|0}function I1c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function J1c(a){a=a|0;i=i;return 0}function K1c(a){a=a|0;i=i;return 0}function L1c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=M1c(c,d,e,1114111,0)|0;i=b;return a|0}function M1c(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=0;b:while(1){m=a[k]|0;n=m&255;if(n>>>0>f>>>0){o=k;break a}do{if(m<<24>>24>-1){p=k+1|0;q=l}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}r=d[k+1|0]|0;if((r&192|0)!=128){o=k;break a}if((r&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;q=l;break}if((m&255)<240){s=k;if((g-s|0)<3){o=k;break a}r=a[k+1|0]|0;t=a[k+2|0]|0;if((n|0)==224){if(!((r&-32)<<24>>24==-96)){u=21;break b}}else if((n|0)==237){if(!((r&-32)<<24>>24==-128)){u=23;break b}}else{if(!((r&-64)<<24>>24==-128)){u=25;break b}}v=t&255;if((v&192|0)!=128){o=k;break a}if(((r&255)<<6&4032|n<<12&61440|v&63)>>>0>f>>>0){o=k;break a}p=k+3|0;q=l;break}if(!((m&255)<245)){o=k;break a}w=k;if((g-w|0)<4){o=k;break a}if((e-l|0)>>>0<2){o=k;break a}v=a[k+1|0]|0;r=a[k+2|0]|0;t=a[k+3|0]|0;if((n|0)==244){if(!((v&-16)<<24>>24==-128)){u=36;break b}}else if((n|0)==240){if(!((v+112<<24>>24&255)<48)){u=34;break b}}else{if(!((v&-64)<<24>>24==-128)){u=38;break b}}x=r&255;if((x&192|0)!=128){o=k;break a}r=t&255;if((r&192|0)!=128){o=k;break a}if(((v&255)<<12&258048|n<<18&1835008|x<<6&4032|r&63)>>>0>f>>>0){o=k;break a}p=k+4|0;q=l+1|0}}while(0);n=q+1|0;if(p>>>0<c>>>0&n>>>0<e>>>0){k=p;l=n}else{o=p;break a}}if((u|0)==21){y=s-b|0;i=h;return y|0}else if((u|0)==23){y=s-b|0;i=h;return y|0}else if((u|0)==25){y=s-b|0;i=h;return y|0}else if((u|0)==34){y=w-b|0;i=h;return y|0}else if((u|0)==36){y=w-b|0;i=h;return y|0}else if((u|0)==38){y=w-b|0;i=h;return y|0}}else{o=j}}while(0);y=o-b|0;i=h;return y|0}function N1c(a){a=a|0;i=i;return 4}function O1c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function P1c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=Q1c(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d>>2<<2);c[j>>2]=g+((c[k>>2]|0)-g);i=b;return l|0}function Q1c(b,d,e,f,g,h,j,k){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0;l=i;c[e>>2]=b;c[h>>2]=f;do{if((k&2|0)!=0){if((g-f|0)<3){m=1;i=l;return m|0}else{c[h>>2]=f+1;a[f]=-17;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-69;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=-65;break}}}while(0);f=c[e>>2]|0;if(!(f>>>0<d>>>0)){m=0;i=l;return m|0}k=g;g=f;a:while(1){f=c[g>>2]|0;if((f&-2048|0)==55296|f>>>0>j>>>0){m=2;n=19;break}do{if(f>>>0<128){b=c[h>>2]|0;if((k-b|0)<1){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f}else{if(f>>>0<2048){b=c[h>>2]|0;if((k-b|0)<2){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>6|192;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}b=c[h>>2]|0;o=k-b|0;if(f>>>0<65536){if((o|0)<3){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>12|224;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f>>>6&63|128;p=c[h>>2]|0;c[h>>2]=p+1;a[p]=f&63|128;break}else{if((o|0)<4){m=1;n=19;break a}c[h>>2]=b+1;a[b]=f>>>18|240;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>12&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f>>>6&63|128;b=c[h>>2]|0;c[h>>2]=b+1;a[b]=f&63|128;break}}}while(0);f=(c[e>>2]|0)+4|0;c[e>>2]=f;if(f>>>0<d>>>0){g=f}else{m=0;n=19;break}}if((n|0)==19){i=l;return m|0}return 0}function R1c(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;b=i;i=i+16|0;a=b;k=b+8|0;c[a>>2]=d;c[k>>2]=g;l=S1c(d,e,a,g,h,k,1114111,0)|0;c[f>>2]=d+((c[a>>2]|0)-d);c[j>>2]=g+((c[k>>2]|0)-g>>2<<2);i=b;return l|0}function S1c(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;m=i;c[f>>2]=b;c[j>>2]=g;g=c[f>>2]|0;do{if((l&4|0)==0){n=g}else{if((e-g|0)<=2){n=g;break}if(!((a[g]|0)==-17)){n=g;break}if(!((a[g+1|0]|0)==-69)){n=g;break}if(!((a[g+2|0]|0)==-65)){n=g;break}b=g+3|0;c[f>>2]=b;n=b}}while(0);a:do{if(n>>>0<e>>>0){g=e;l=n;b=c[j>>2]|0;b:while(1){if(!(b>>>0<h>>>0)){o=l;break a}p=a[l]|0;q=p&255;do{if(p<<24>>24>-1){if(q>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=q;c[f>>2]=l+1}else{if((p&255)<194){r=2;s=40;break b}if((p&255)<224){if((g-l|0)<2){r=1;s=40;break b}t=d[l+1|0]|0;if((t&192|0)!=128){r=2;s=40;break b}u=t&63|q<<6&1984;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+2;break}if((p&255)<240){if((g-l|0)<3){r=1;s=40;break b}u=a[l+1|0]|0;t=a[l+2|0]|0;if((q|0)==237){if(!((u&-32)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==224){if(!((u&-32)<<24>>24==-96)){r=2;s=40;break b}}else{if(!((u&-64)<<24>>24==-128)){r=2;s=40;break b}}v=t&255;if((v&192|0)!=128){r=2;s=40;break b}t=(u&255)<<6&4032|q<<12&61440|v&63;if(t>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=t;c[f>>2]=l+3;break}if(!((p&255)<245)){r=2;s=40;break b}if((g-l|0)<4){r=1;s=40;break b}t=a[l+1|0]|0;v=a[l+2|0]|0;u=a[l+3|0]|0;if((q|0)==244){if(!((t&-16)<<24>>24==-128)){r=2;s=40;break b}}else if((q|0)==240){if(!((t+112<<24>>24&255)<48)){r=2;s=40;break b}}else{if(!((t&-64)<<24>>24==-128)){r=2;s=40;break b}}w=v&255;if((w&192|0)!=128){r=2;s=40;break b}v=u&255;if((v&192|0)!=128){r=2;s=40;break b}u=(t&255)<<12&258048|q<<18&1835008|w<<6&4032|v&63;if(u>>>0>k>>>0){r=2;s=40;break b}c[b>>2]=u;c[f>>2]=l+4}}while(0);q=(c[j>>2]|0)+4|0;c[j>>2]=q;p=c[f>>2]|0;if(p>>>0<e>>>0){l=p;b=q}else{o=p;break a}}if((s|0)==40){i=m;return r|0}}else{o=n}}while(0);r=o>>>0<e>>>0|0;i=m;return r|0}function T1c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;c[f>>2]=d;i=i;return 3}function U1c(a){a=a|0;i=i;return 0}function V1c(a){a=a|0;i=i;return 0}function W1c(a,b,c,d,e){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;b=i;a=X1c(c,d,e,1114111,0)|0;i=b;return a|0}function X1c(b,c,e,f,g){b=b|0;c=c|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;h=i;do{if((g&4|0)==0){j=b}else{if((c-b|0)<=2){j=b;break}if(!((a[b]|0)==-17)){j=b;break}if(!((a[b+1|0]|0)==-69)){j=b;break}j=(a[b+2|0]|0)==-65?b+3|0:b}}while(0);a:do{if(j>>>0<c>>>0&(e|0)!=0){g=c;k=j;l=1;b:while(1){m=a[k]|0;n=m&255;do{if(m<<24>>24>-1){if(n>>>0>f>>>0){o=k;break a}p=k+1|0}else{if((m&255)<194){o=k;break a}if((m&255)<224){if((g-k|0)<2){o=k;break a}q=d[k+1|0]|0;if((q&192|0)!=128){o=k;break a}if((q&63|n<<6&1984)>>>0>f>>>0){o=k;break a}p=k+2|0;break}if((m&255)<240){r=k;if((g-r|0)<3){o=k;break a}q=a[k+1|0]|0;s=a[k+2|0]|0;if((n|0)==224){if(!((q&-32)<<24>>24==-96)){t=21;break b}}else if((n|0)==237){if(!((q&-32)<<24>>24==-128)){t=23;break b}}else{if(!((q&-64)<<24>>24==-128)){t=25;break b}}u=s&255;if((u&192|0)!=128){o=k;break a}if(((q&255)<<6&4032|n<<12&61440|u&63)>>>0>f>>>0){o=k;break a}p=k+3|0;break}if(!((m&255)<245)){o=k;break a}v=k;if((g-v|0)<4){o=k;break a}u=a[k+1|0]|0;q=a[k+2|0]|0;s=a[k+3|0]|0;if((n|0)==244){if(!((u&-16)<<24>>24==-128)){t=35;break b}}else if((n|0)==240){if(!((u+112<<24>>24&255)<48)){t=33;break b}}else{if(!((u&-64)<<24>>24==-128)){t=37;break b}}w=q&255;if((w&192|0)!=128){o=k;break a}q=s&255;if((q&192|0)!=128){o=k;break a}if(((u&255)<<12&258048|n<<18&1835008|w<<6&4032|q&63)>>>0>f>>>0){o=k;break a}p=k+4|0}}while(0);if(!(p>>>0<c>>>0&l>>>0<e>>>0)){o=p;break a}k=p;l=l+1|0}if((t|0)==21){x=r-b|0;i=h;return x|0}else if((t|0)==23){x=r-b|0;i=h;return x|0}else if((t|0)==25){x=r-b|0;i=h;return x|0}else if((t|0)==33){x=v-b|0;i=h;return x|0}else if((t|0)==35){x=v-b|0;i=h;return x|0}else if((t|0)==37){x=v-b|0;i=h;return x|0}}else{o=j}}while(0);x=o-b|0;i=h;return x|0}function Y1c(a){a=a|0;i=i;return 4}function Z1c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function _1c(a){a=a|0;var b=0;b=i;p4c(a);i=b;return}function $1c(a){a=a|0;var b=0;b=i;c[a>>2]=366528;cWc(a+12|0);p4c(a);i=b;return}function a2c(a){a=a|0;var b=0;b=i;c[a>>2]=366528;cWc(a+12|0);i=b;return}function b2c(a){a=a|0;var b=0;b=i;c[a>>2]=366568;cWc(a+16|0);p4c(a);i=b;return}function c2c(a){a=a|0;var b=0;b=i;c[a>>2]=366568;cWc(a+16|0);i=b;return}function d2c(b){b=b|0;i=i;return a[b+8|0]|0}function e2c(a){a=a|0;i=i;return c[a+8>>2]|0}function f2c(b){b=b|0;i=i;return a[b+9|0]|0}function g2c(a){a=a|0;i=i;return c[a+12>>2]|0}function h2c(a,b){a=a|0;b=b|0;var c=0;c=i;UVc(a,b+12|0);i=c;return}function i2c(a,b){a=a|0;b=b|0;var c=0;c=i;UVc(a,b+16|0);i=c;return}function j2c(a,b){a=a|0;b=b|0;b=i;WVc(a,366600,4);i=b;return}function k2c(a,b){a=a|0;b=b|0;b=i;EWc(a,366608,J3c(366608)|0);i=b;return}function l2c(a,b){a=a|0;b=b|0;b=i;WVc(a,366632,5);i=b;return}function m2c(a,b){a=a|0;b=b|0;b=i;EWc(a,366640,J3c(366640)|0);i=b;return}function n2c(b){b=b|0;var d=0,e=0;b=i;if((a[366672]|0)!=0){d=366664;e=c[91666]|0;i=b;return e|0}if((Za(366672)|0)==0){d=366664;e=c[91666]|0;i=b;return e|0}do{if((a[373872]|0)==0){if((Za(373872)|0)==0){break}P4c(373704,0,168)|0;Zd(772,0,q|0)|0;Tb(373872)}}while(0);fWc(373704,373880)|0;fWc(373716|0,373888)|0;fWc(373728|0,373896)|0;fWc(373740|0,373904)|0;fWc(373752|0,373920)|0;fWc(373764|0,373936)|0;fWc(373776|0,373944)|0;fWc(373788|0,373960)|0;fWc(373800|0,373968)|0;fWc(373812|0,373976)|0;fWc(373824|0,373984)|0;fWc(373836|0,373992)|0;fWc(373848|0,374e3)|0;fWc(373860|0,374008)|0;c[91666]=373704;Tb(366672);d=366664;e=c[91666]|0;i=b;return e|0}function o2c(b){b=b|0;var d=0,e=0;b=i;if((a[366688]|0)!=0){d=366680;e=c[91670]|0;i=b;return e|0}if((Za(366688)|0)==0){d=366680;e=c[91670]|0;i=b;return e|0}do{if((a[373336]|0)==0){if((Za(373336)|0)==0){break}P4c(373168,0,168)|0;Zd(773,0,q|0)|0;Tb(373336)}}while(0);HWc(373168,373344)|0;HWc(373180|0,373376)|0;HWc(373192|0,373408)|0;HWc(373204|0,373440)|0;HWc(373216|0,373480)|0;HWc(373228|0,373520)|0;HWc(373240|0,373552)|0;HWc(373252|0,373592)|0;HWc(373264|0,373608)|0;HWc(373276|0,373624)|0;HWc(373288|0,373640)|0;HWc(373300|0,373656)|0;HWc(373312|0,373672)|0;HWc(373324|0,373688)|0;c[91670]=373168;Tb(366688);d=366680;e=c[91670]|0;i=b;return e|0}function p2c(b){b=b|0;var d=0,e=0;b=i;if((a[366704]|0)!=0){d=366696;e=c[91674]|0;i=b;return e|0}if((Za(366704)|0)==0){d=366696;e=c[91674]|0;i=b;return e|0}do{if((a[372944]|0)==0){if((Za(372944)|0)==0){break}P4c(372656,0,288)|0;Zd(774,0,q|0)|0;Tb(372944)}}while(0);fWc(372656,372952)|0;fWc(372668|0,372960)|0;fWc(372680|0,372976)|0;fWc(372692|0,372984)|0;fWc(372704|0,372992)|0;fWc(372716|0,373e3)|0;fWc(372728|0,373008)|0;fWc(372740|0,373016)|0;fWc(372752|0,373024)|0;fWc(372764|0,373040)|0;fWc(372776|0,373048)|0;fWc(372788|0,373064)|0;fWc(372800|0,373080)|0;fWc(372812|0,373088)|0;fWc(372824|0,373096)|0;fWc(372836|0,373104)|0;fWc(372848|0,372992)|0;fWc(372860|0,373112)|0;fWc(372872|0,373120)|0;fWc(372884|0,373128)|0;fWc(372896|0,373136)|0;fWc(372908|0,373144)|0;fWc(372920|0,373152)|0;fWc(372932|0,373160)|0;c[91674]=372656;Tb(366704);d=366696;e=c[91674]|0;i=b;return e|0}function q2c(b){b=b|0;var d=0,e=0;b=i;if((a[366720]|0)!=0){d=366712;e=c[91678]|0;i=b;return e|0}if((Za(366720)|0)==0){d=366712;e=c[91678]|0;i=b;return e|0}do{if((a[372104]|0)==0){if((Za(372104)|0)==0){break}P4c(371816,0,288)|0;Zd(775,0,q|0)|0;Tb(372104)}}while(0);HWc(371816,372112)|0;HWc(371828|0,372144)|0;HWc(371840|0,372184)|0;HWc(371852|0,372208)|0;HWc(371864|0,372528)|0;HWc(371876|0,372232)|0;HWc(371888|0,372256)|0;HWc(371900|0,372280)|0;HWc(371912|0,372312)|0;HWc(371924|0,372352)|0;HWc(371936|0,372384)|0;HWc(371948|0,372424)|0;HWc(371960|0,372464)|0;HWc(371972|0,372480)|0;HWc(371984|0,372496)|0;HWc(371996|0,372512)|0;HWc(372008|0,372528)|0;HWc(372020|0,372544)|0;HWc(372032|0,372560)|0;HWc(372044|0,372576)|0;HWc(372056|0,372592)|0;HWc(372068|0,372608)|0;HWc(372080|0,372624)|0;HWc(372092|0,372640)|0;c[91678]=371816;Tb(366720);d=366712;e=c[91678]|0;i=b;return e|0}function r2c(b){b=b|0;var d=0,e=0;b=i;if((a[366736]|0)!=0){d=366728;e=c[91682]|0;i=b;return e|0}if((Za(366736)|0)==0){d=366728;e=c[91682]|0;i=b;return e|0}do{if((a[371792]|0)==0){if((Za(371792)|0)==0){break}P4c(371504,0,288)|0;Zd(776,0,q|0)|0;Tb(371792)}}while(0);fWc(371504,371800)|0;fWc(371516|0,371808)|0;c[91682]=371504;Tb(366736);d=366728;e=c[91682]|0;i=b;return e|0}function s2c(b){b=b|0;var d=0,e=0;b=i;if((a[366752]|0)!=0){d=366744;e=c[91686]|0;i=b;return e|0}if((Za(366752)|0)==0){d=366744;e=c[91686]|0;i=b;return e|0}do{if((a[371464]|0)==0){if((Za(371464)|0)==0){break}P4c(371176,0,288)|0;Zd(777,0,q|0)|0;Tb(371464)}}while(0);HWc(371176,371472)|0;HWc(371188|0,371488)|0;c[91686]=371176;Tb(366752);d=366744;e=c[91686]|0;i=b;return e|0}function t2c(b){b=b|0;var c=0;b=i;if((a[366776]|0)!=0){c=366760;i=b;return c|0}if((Za(366776)|0)==0){c=366760;i=b;return c|0}WVc(366760,366784,8);Zd(778,366760,q|0)|0;Tb(366776);c=366760;i=b;return c|0}function u2c(b){b=b|0;var c=0;b=i;if((a[366816]|0)!=0){c=366800;i=b;return c|0}if((Za(366816)|0)==0){c=366800;i=b;return c|0}EWc(366800,366824,J3c(366824)|0);Zd(779,366800,q|0)|0;Tb(366816);c=366800;i=b;return c|0}function v2c(b){b=b|0;var c=0;b=i;if((a[366880]|0)!=0){c=366864;i=b;return c|0}if((Za(366880)|0)==0){c=366864;i=b;return c|0}WVc(366864,366888,8);Zd(778,366864,q|0)|0;Tb(366880);c=366864;i=b;return c|0}function w2c(b){b=b|0;var c=0;b=i;if((a[366920]|0)!=0){c=366904;i=b;return c|0}if((Za(366920)|0)==0){c=366904;i=b;return c|0}EWc(366904,366928,J3c(366928)|0);Zd(779,366904,q|0)|0;Tb(366920);c=366904;i=b;return c|0}function x2c(b){b=b|0;var c=0;b=i;if((a[366984]|0)!=0){c=366968;i=b;return c|0}if((Za(366984)|0)==0){c=366968;i=b;return c|0}WVc(366968,366992,20);Zd(778,366968,q|0)|0;Tb(366984);c=366968;i=b;return c|0}function y2c(b){b=b|0;var c=0;b=i;if((a[367032]|0)!=0){c=367016;i=b;return c|0}if((Za(367032)|0)==0){c=367016;i=b;return c|0}EWc(367016,367040,J3c(367040)|0);Zd(779,367016,q|0)|0;Tb(367032);c=367016;i=b;return c|0}function z2c(b){b=b|0;var c=0;b=i;if((a[367144]|0)!=0){c=367128;i=b;return c|0}if((Za(367144)|0)==0){c=367128;i=b;return c|0}WVc(367128,367152,11);Zd(778,367128,q|0)|0;Tb(367144);c=367128;i=b;return c|0}function A2c(b){b=b|0;var c=0;b=i;if((a[367184]|0)!=0){c=367168;i=b;return c|0}if((Za(367184)|0)==0){c=367168;i=b;return c|0}EWc(367168,367192,J3c(367192)|0);Zd(779,367168,q|0)|0;Tb(367184);c=367168;i=b;return c|0}function B2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);l=+F4c(b,g,c[91562]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function C2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);l=+F4c(b,g,c[91562]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)!=34){h=l;i=f;return+h}c[e>>2]=4;h=l;i=f;return+h}function D2c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0.0,j=0,k=0,l=0.0;f=i;i=i+8|0;g=f;if((b|0)==(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}j=Nc()|0;k=c[j>>2]|0;c[j>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);l=+F4c(b,g,c[91562]|0);b=c[j>>2]|0;if((b|0)==0){c[j>>2]=k}if((c[g>>2]|0)!=(d|0)){c[e>>2]=4;h=0.0;i=f;return+h}if((b|0)==34){c[e>>2]=4}h=l;i=f;return+h}function E2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);n=lb(b|0,h|0,f|0,c[91562]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)!=34){j=n;k=f;J=k;i=g;return j|0}c[e>>2]=4;j=-1;k=-1;J=k;i=g;return j|0}function F2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);m=lb(b|0,h|0,f|0,c[91562]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function G2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);m=lb(b|0,h|0,f|0,c[91562]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>4294967295)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m;i=g;return j|0}return 0}function H2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((a[b]|0)==45){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);m=lb(b|0,h|0,f|0,c[91562]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}if((b|0)==34|(f>>>0>0|(f|0)==0&m>>>0>65535)){c[e>>2]=4;j=-1;i=g;return j|0}else{j=m&65535;i=g;return j|0}return 0}function I2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}l=Nc()|0;m=c[l>>2]|0;c[l>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);n=Gc(b|0,h|0,f|0,c[91562]|0)|0;f=J;b=c[l>>2]|0;if((b|0)==0){c[l>>2]=m}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;k=0;J=k;i=g;return j|0}if((b|0)==34){c[e>>2]=4;e=(f|0)>0|(f|0)==0&n>>>0>0;J=e?2147483647:-2147483648;i=g;return(e?-1:0)|0}else{j=n;k=f;J=k;i=g;return j|0}return 0}function J2c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+8|0;h=g;if((b|0)==(d|0)){c[e>>2]=4;j=0;i=g;return j|0}k=Nc()|0;l=c[k>>2]|0;c[k>>2]=0;do{if((a[366256]|0)==0){if((Za(366256)|0)==0){break}c[91562]=Zb(2147483647,366264,0)|0;Tb(366256)}}while(0);m=Gc(b|0,h|0,f|0,c[91562]|0)|0;f=J;b=c[k>>2]|0;if((b|0)==0){c[k>>2]=l}if((c[h>>2]|0)!=(d|0)){c[e>>2]=4;j=0;i=g;return j|0}do{if((b|0)==34){c[e>>2]=4;if((f|0)>0|(f|0)==0&m>>>0>0){j=2147483647}else{break}i=g;return j|0}else{if((f|0)<-1|(f|0)==-1&m>>>0<2147483648){c[e>>2]=4;break}if((f|0)>0|(f|0)==0&m>>>0>2147483647){c[e>>2]=4;j=2147483647;i=g;return j|0}else{j=m;i=g;return j|0}}}while(0);j=-2147483648;i=g;return j|0}function K2c(a){a=a|0;var b=0,e=0,f=0,g=0,h=0;b=i;e=a+4|0;f=e;g=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=e+4|0;e=d[f]|d[f+1|0]<<8|d[f+2|0]<<16|d[f+3|0]<<24;f=(c[a>>2]|0)+(e>>1)|0;a=f;if((e&1|0)==0){h=g;fe[h&1023](a);i=b;return}else{h=c[(c[f>>2]|0)+g>>2]|0;fe[h&1023](a);i=b;return}}function L2c(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;f=b+8|0;g=b+4|0;h=c[g>>2]|0;j=c[f>>2]|0;k=h;if(!(j-k>>2>>>0<d>>>0)){l=d;m=h;do{if((m|0)==0){n=0}else{c[m>>2]=0;n=c[g>>2]|0}m=n+4|0;c[g>>2]=m;l=l+ -1|0;}while((l|0)!=0);i=e;return}l=b+16|0;m=b;n=c[m>>2]|0;h=k-n>>2;k=h+d|0;if(k>>>0>1073741823){E0c(0)}o=j-n|0;do{if(o>>2>>>0<536870911){n=o>>1;j=n>>>0<k>>>0?k:n;if((j|0)==0){p=0;q=0;break}n=b+128|0;if(!((a[n]|0)==0&j>>>0<29)){r=j;s=11;break}a[n]=1;p=j;q=l}else{r=1073741823;s=11}}while(0);if((s|0)==11){p=r;q=n4c(r<<2)|0}r=d;d=q+(h<<2)|0;do{if((d|0)==0){t=0}else{c[d>>2]=0;t=d}d=t+4|0;r=r+ -1|0;}while((r|0)!=0);r=c[m>>2]|0;t=(c[g>>2]|0)-r|0;s=q+(h-(t>>2)<<2)|0;h=r;N4c(s|0,h|0,t|0)|0;c[m>>2]=s;c[g>>2]=d;c[f>>2]=q+(p<<2);if((r|0)==0){i=e;return}if((l|0)==(r|0)){a[b+128|0]=0;i=e;return}else{p4c(h);i=e;return}}function M2c(a){a=a|0;a=i;GWc(371452|0);GWc(371440|0);GWc(371428|0);GWc(371416|0);GWc(371404|0);GWc(371392|0);GWc(371380|0);GWc(371368|0);GWc(371356|0);GWc(371344|0);GWc(371332|0);GWc(371320|0);GWc(371308|0);GWc(371296|0);GWc(371284|0);GWc(371272|0);GWc(371260|0);GWc(371248|0);GWc(371236|0);GWc(371224|0);GWc(371212|0);GWc(371200|0);GWc(371188|0);GWc(371176);i=a;return}function N2c(a){a=a|0;a=i;cWc(371780|0);cWc(371768|0);cWc(371756|0);cWc(371744|0);cWc(371732|0);cWc(371720|0);cWc(371708|0);cWc(371696|0);cWc(371684|0);cWc(371672|0);cWc(371660|0);cWc(371648|0);cWc(371636|0);cWc(371624|0);cWc(371612|0);cWc(371600|0);cWc(371588|0);cWc(371576|0);cWc(371564|0);cWc(371552|0);cWc(371540|0);cWc(371528|0);cWc(371516|0);cWc(371504);i=a;return}function O2c(a){a=a|0;a=i;GWc(372092|0);GWc(372080|0);GWc(372068|0);GWc(372056|0);GWc(372044|0);GWc(372032|0);GWc(372020|0);GWc(372008|0);GWc(371996|0);GWc(371984|0);GWc(371972|0);GWc(371960|0);GWc(371948|0);GWc(371936|0);GWc(371924|0);GWc(371912|0);GWc(371900|0);GWc(371888|0);GWc(371876|0);GWc(371864|0);GWc(371852|0);GWc(371840|0);GWc(371828|0);GWc(371816);i=a;return}function P2c(a){a=a|0;a=i;cWc(372932|0);cWc(372920|0);cWc(372908|0);cWc(372896|0);cWc(372884|0);cWc(372872|0);cWc(372860|0);cWc(372848|0);cWc(372836|0);cWc(372824|0);cWc(372812|0);cWc(372800|0);cWc(372788|0);cWc(372776|0);cWc(372764|0);cWc(372752|0);cWc(372740|0);cWc(372728|0);cWc(372716|0);cWc(372704|0);cWc(372692|0);cWc(372680|0);cWc(372668|0);cWc(372656);i=a;return}function Q2c(a){a=a|0;a=i;GWc(373324|0);GWc(373312|0);GWc(373300|0);GWc(373288|0);GWc(373276|0);GWc(373264|0);GWc(373252|0);GWc(373240|0);GWc(373228|0);GWc(373216|0);GWc(373204|0);GWc(373192|0);GWc(373180|0);GWc(373168);i=a;return}function R2c(a){a=a|0;a=i;cWc(373860|0);cWc(373848|0);cWc(373836|0);cWc(373824|0);cWc(373812|0);cWc(373800|0);cWc(373788|0);cWc(373776|0);cWc(373764|0);cWc(373752|0);cWc(373740|0);cWc(373728|0);cWc(373716|0);cWc(373704);i=a;return}function S2c(a){a=a|0;var b=0,c=0;b=i;if((Y2c(a)|0)==0){c=(T2c(a)|0)!=0|0}else{c=1}i=b;return c|0}function T2c(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<131072){c=(d[374016+((d[374016+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}else{c=a>>>0<196606|0;i=b;return c|0}return 0}function U2c(a){a=a|0;var b=0,c=0;b=i;c=xb(a|0)|0;i=b;return c|0}function V2c(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<32|(a+ -127|0)>>>0<33|(a+ -8232|0)>>>0<2){c=1;i=b;return c|0}c=(a+ -65529|0)>>>0<3|0;i=b;return c|0}function W2c(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;switch(b|0){case 8:{d=$2c(a)|0;break};case 7:{d=_2c(a)|0;break};case 6:{d=Z2c(a)|0;break};case 4:{d=V2c(a)|0;break};case 1:{d=S2c(a)|0;break};case 3:{d=U2c(a)|0;break};case 11:{d=c3c(a)|0;break};case 9:{d=a3c(a)|0;break};case 2:{d=T2c(a)|0;break};case 12:{d=d3c(a)|0;break};case 5:{d=Y2c(a)|0;break};case 10:{d=b3c(a)|0;break};default:{d=0}}i=c;return d|0}function X2c(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;c=i;d=a[b]|0;e=97;f=1;g=376992;while(1){if(d<<24>>24==e<<24>>24){if((H4c(b,g)|0)==0){h=f;j=5;break}}k=g+6|0;l=a[k]|0;if(l<<24>>24==0){h=0;j=5;break}else{e=l;f=f+1|0;g=k}}if((j|0)==5){i=c;return h|0}return 0}function Y2c(a){a=a|0;i=i;return(a+ -48|0)>>>0<10|0}function Z2c(a){a=a|0;var b=0,c=0;b=i;if((b3c(a)|0)==0){c=($2c(a)|0)!=0|0}else{c=0}i=b;return c|0}function _2c(a){a=a|0;var b=0,c=0;b=i;if((e3c(a)|0)==(a|0)){c=(a|0)==223|0}else{c=1}i=b;return c|0}function $2c(a){a=a|0;var b=0,c=0;b=i;if(a>>>0<255){c=(a+1&127)>>>0>32|0;i=b;return c|0}if(a>>>0<8232|(a+ -8234|0)>>>0<47062|(a+ -57344|0)>>>0<8185){c=1;i=b;return c|0}else{i=b;return((a+ -65532|0)>>>0>1048579|(a&65534|0)==65534)&1^1|0}return 0}function a3c(a){a=a|0;var b=0,c=0;b=i;if(!(a>>>0<131072)){c=0;i=b;return c|0}c=(d[377072+((d[377072+(a>>>8)|0]|0)<<5|a>>>3&31)|0]|0)>>>(a&7)&1;i=b;return c|0}function b3c(a){a=a|0;var b=0,c=0;b=i;c=(I3c(380240,a)|0)!=0|0;i=b;return c|0}function c3c(a){a=a|0;var b=0,c=0;b=i;c=(g3c(a)|0)!=(a|0)|0;i=b;return c|0}function d3c(a){a=a|0;var b=0,c=0;b=i;if((a+ -48|0)>>>0<10){c=1;i=b;return c|0}c=((a|32)+ -97|0)>>>0<6|0;i=b;return c|0}function e3c(a){a=a|0;var b=0,c=0;b=i;c=f3c(a,0)|0;i=b;return c|0}function f3c(c,f){c=c|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;g=i;h=(f<<1)+ -1|0;j=f+ -1|0;if((T2c(c)|0)==0|(c+ -1536|0)>>>0<2560|(c+ -11776|0)>>>0<30784|(c+ -43008|0)>>>0<22272){k=c;i=g;return k|0}do{if((f|0)==0){if(!((c+ -11520|0)>>>0<38)){l=0;break}k=c+ -7264|0;i=g;return k|0}else{if(!((c+ -4256|0)>>>0<46)){l=0;break}do{if((c|0)>4293){if((c|0)==4295|(c|0)==4301){break}else{k=c}i=g;return k|0}}while(0);k=c+7264|0;i=g;return k|0}}while(0);while(1){m=a[380330+(l<<2)|0]|0;n=m<<24>>24;o=c-(e[380328+(l<<2)>>1]|0)|0;p=l+1|0;if((o-(n&j)|0)>>>0<(d[380331+(l<<2)|0]|0)>>>0){q=12;break}if((p|0)==61){break}else{l=p}}if((q|0)==12){if(m<<24>>24==1){k=f+c-(o&1)|0;i=g;return k|0}else{k=(fa(n,h)|0)+c|0;i=g;return k|0}}h=1-f|0;n=b[380576+(h<<1)>>1]|0;a:do{if(!(n<<16>>16==0)){o=n;m=0;while(1){q=m+1|0;if((o&65535|0)==(c|0)){break}l=b[380576+(q<<2)+(h<<1)>>1]|0;if(l<<16>>16==0){break a}else{o=l;m=q}}k=e[380576+(m<<2)+(f<<1)>>1]|0;i=g;return k|0}}while(0);if(!((c+ -66600+(f*40|0)|0)>>>0<40)){k=c;i=g;return k|0}k=c+ -40+(f*80|0)|0;i=g;return k|0}function g3c(a){a=a|0;var b=0,c=0;b=i;c=f3c(a,1)|0;i=b;return c|0}function h3c(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=i3c(0,a,b,(c|0)!=0?c:381280)|0;i=d;return e|0}function i3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+8|0;h=g;c[h>>2]=b;j=(f|0)==0?381288:f;f=c[j>>2]|0;a:do{if((d|0)==0){if((f|0)==0){k=0}else{break}i=g;return k|0}else{if((b|0)==0){l=h;c[h>>2]=l;m=l}else{m=b}if((e|0)==0){k=-2;i=g;return k|0}do{if((f|0)==0){l=a[d]|0;n=l&255;if(l<<24>>24>-1){c[m>>2]=n;k=l<<24>>24!=0|0;i=g;return k|0}else{l=n+ -194|0;if(l>>>0>50){break a}o=e+ -1|0;p=c[381072+(l<<2)>>2]|0;q=d+1|0;break}}else{o=e;p=f;q=d}}while(0);b:do{if((o|0)==0){r=p}else{l=a[q]|0;n=(l&255)>>>3;if((n+ -16|n+(p>>26))>>>0>7){break a}else{s=o;t=l;u=p;v=q}while(1){v=v+1|0;u=(t&255)+ -128|u<<6;s=s+ -1|0;if((u|0)>=0){break}if((s|0)==0){r=u;break b}t=a[v]|0;if(((t&255)+ -128|0)>>>0>63){break a}}c[j>>2]=0;c[m>>2]=u;k=e-s|0;i=g;return k|0}}while(0);c[j>>2]=r;k=-2;i=g;return k|0}}while(0);c[j>>2]=0;c[(Nc()|0)>>2]=84;k=-1;i=g;return k|0}function j3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;g=i;i=i+1032|0;h=g+1024|0;j=c[b>>2]|0;c[h>>2]=j;k=(a|0)!=0;l=g;m=k?e:256;e=k?a:l;a:do{if((j|0)==0|(m|0)==0){n=d;o=m;p=j;q=0;r=e}else{a=d;s=m;t=j;u=0;v=e;while(1){w=a>>>2;x=w>>>0>=s>>>0;if(!(x|a>>>0>131)){n=a;o=s;p=t;q=u;r=v;break a}y=x?s:w;z=a-y|0;w=k3c(v,h,y,f)|0;if((w|0)==-1){break}if((v|0)==(l|0)){A=s;B=l}else{A=s-w|0;B=v+(w<<2)|0}y=w+u|0;w=c[h>>2]|0;if((w|0)==0|(A|0)==0){n=z;o=A;p=w;q=y;r=B;break a}else{a=z;s=A;t=w;u=y;v=B}}n=z;o=0;p=c[h>>2]|0;q=-1;r=v}}while(0);b:do{if((p|0)==0){C=q}else{if((o|0)==0|(n|0)==0){C=q;break}else{D=n;E=o;F=p;G=q;H=r}while(1){I=i3c(H,F,D,f)|0;if((I+2|0)>>>0<3){break}z=(c[h>>2]|0)+I|0;c[h>>2]=z;B=E+ -1|0;A=G+1|0;if((B|0)==0|(D|0)==(I|0)){C=A;break b}else{D=D-I|0;E=B;F=z;G=A;H=H+4|0}}if((I|0)==0){c[h>>2]=0;C=G;break}else if((I|0)==-1){C=-1;break}else{c[f>>2]=0;C=G;break}}}while(0);if(!k){i=g;return C|0}c[b>>2]=c[h>>2];i=g;return C|0}function k3c(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0;h=i;j=c[e>>2]|0;do{if((g|0)==0){k=5}else{l=g;m=c[l>>2]|0;if((m|0)==0){k=5;break}if((b|0)==0){n=f;o=m;p=j;k=16;break}c[l>>2]=0;q=b;r=f;s=m;t=j;k=36}}while(0);if((k|0)==5){if((b|0)==0){u=f;v=j;k=7}else{w=b;x=f;y=j;k=6}}a:while(1){if((k|0)==6){k=0;if((x|0)==0){z=f;k=53;break}else{A=w;B=x;C=y}while(1){j=a[C]|0;do{if(((j&255)+ -1|0)>>>0<127){if((C&3|0)==0&B>>>0>3){D=A;E=B;F=C}else{G=A;H=B;I=j;J=C;break}while(1){K=c[F>>2]|0;if(((K+ -16843009|K)&-2139062144|0)!=0){k=30;break}c[D>>2]=K&255;c[D+4>>2]=d[F+1|0]|0;c[D+8>>2]=d[F+2|0]|0;L=F+4|0;M=D+16|0;c[D+12>>2]=d[F+3|0]|0;N=E+ -4|0;if(N>>>0>3){D=M;E=N;F=L}else{k=31;break}}if((k|0)==30){k=0;G=D;H=E;I=K&255;J=F;break}else if((k|0)==31){k=0;G=M;H=N;I=a[L]|0;J=L;break}}else{G=A;H=B;I=j;J=C}}while(0);O=I&255;if(!((O+ -1|0)>>>0<127)){break}c[G>>2]=O;j=H+ -1|0;if((j|0)==0){z=f;k=53;break a}else{A=G+4|0;B=j;C=J+1|0}}j=O+ -194|0;if(j>>>0>50){P=G;Q=H;R=J;k=47;break}q=G;r=H;s=c[381072+(j<<2)>>2]|0;t=J+1|0;k=36;continue}else if((k|0)==7){k=0;j=a[v]|0;do{if(((j&255)+ -1|0)>>>0<127){if((v&3|0)!=0){S=u;T=j;U=v;break}g=c[v>>2]|0;if(((g+ -16843009|g)&-2139062144|0)==0){V=u;W=v}else{S=u;T=g&255;U=v;break}do{W=W+4|0;V=V+ -4|0;X=c[W>>2]|0;}while(((X+ -16843009|X)&-2139062144|0)==0);S=V;T=X&255;U=W}else{S=u;T=j;U=v}}while(0);j=T&255;if((j+ -1|0)>>>0<127){u=S+ -1|0;v=U+1|0;k=7;continue}g=j+ -194|0;if(g>>>0>50){P=b;Q=S;R=U;k=47;break}n=S;o=c[381072+(g<<2)>>2]|0;p=U+1|0;k=16;continue}else if((k|0)==16){k=0;g=(d[p]|0)>>>3;if((g+ -16|g+(o>>26))>>>0>7){k=17;break}g=p+1|0;do{if((o&33554432|0)==0){Y=g}else{if(((d[g]|0)+ -128|0)>>>0>63){k=20;break a}j=p+2|0;if((o&524288|0)==0){Y=j;break}if(((d[j]|0)+ -128|0)>>>0>63){k=23;break a}Y=p+3|0}}while(0);u=n+ -1|0;v=Y;k=7;continue}else if((k|0)==36){k=0;g=d[t]|0;j=g>>>3;if((j+ -16|j+(s>>26))>>>0>7){k=37;break}j=t+1|0;Z=g+ -128|s<<6;do{if((Z|0)<0){g=(d[j]|0)+ -128|0;if(g>>>0>63){k=40;break a}m=t+2|0;_=g|Z<<6;if((_|0)>=0){$=_;aa=m;break}g=(d[m]|0)+ -128|0;if(g>>>0>63){k=43;break a}$=g|_<<6;aa=t+3|0}else{$=Z;aa=j}}while(0);c[q>>2]=$;w=q+4|0;x=r+ -1|0;y=aa;k=6;continue}}if((k|0)==17){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==20){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==23){ba=b;ca=n;da=o;ea=p+ -1|0;k=46}else if((k|0)==37){ba=q;ca=r;da=s;ea=t+ -1|0;k=46}else if((k|0)==40){ba=q;ca=r;da=Z;ea=t+ -1|0;k=46}else if((k|0)==43){ba=q;ca=r;da=_;ea=t+ -1|0;k=46}else if((k|0)==53){i=h;return z|0}if((k|0)==46){if((da|0)==0){P=ba;Q=ca;R=ea;k=47}else{fa=ba;ga=ea}}do{if((k|0)==47){if((a[R]|0)!=0){fa=P;ga=R;break}if((P|0)!=0){c[P>>2]=0;c[e>>2]=0}z=f-Q|0;i=h;return z|0}}while(0);c[(Nc()|0)>>2]=84;if((fa|0)==0){z=-1;i=h;return z|0}c[e>>2]=ga;z=-1;i=h;return z|0}function l3c(b,e,f){b=b|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0;g=i;i=i+8|0;h=g;c[h>>2]=b;if((e|0)==0){j=0;i=g;return j|0}do{if((f|0)!=0){if((b|0)==0){k=h;c[h>>2]=k;l=k}else{l=b}k=a[e]|0;m=k&255;if(k<<24>>24>-1){c[l>>2]=m;j=k<<24>>24!=0|0;i=g;return j|0}k=m+ -194|0;if(k>>>0>50){break}m=e+1|0;n=c[381072+(k<<2)>>2]|0;if(f>>>0<4){if((n&-2147483648>>>((f*6|0)+ -6|0)|0)!=0){break}}k=d[m]|0;m=k>>>3;if((m+ -16|m+(n>>26))>>>0>7){break}m=k+ -128|n<<6;if((m|0)>=0){c[l>>2]=m;j=2;i=g;return j|0}n=(d[e+2|0]|0)+ -128|0;if(n>>>0>63){break}k=n|m<<6;if((k|0)>=0){c[l>>2]=k;j=3;i=g;return j|0}m=(d[e+3|0]|0)+ -128|0;if(m>>>0>63){break}c[l>>2]=m|k<<6;j=4;i=g;return j|0}}while(0);c[(Nc()|0)>>2]=84;j=-1;i=g;return j|0}function m3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0;e=i;if((b|0)==0){f=1;i=e;return f|0}if(d>>>0<128){a[b]=d;f=1;i=e;return f|0}if(d>>>0<2048){a[b]=d>>>6|192;a[b+1|0]=d&63|128;f=2;i=e;return f|0}if(d>>>0<55296|(d+ -57344|0)>>>0<8192){a[b]=d>>>12|224;a[b+1|0]=d>>>6&63|128;a[b+2|0]=d&63|128;f=3;i=e;return f|0}if((d+ -65536|0)>>>0<1048576){a[b]=d>>>18|240;a[b+1|0]=d>>>12&63|128;a[b+2|0]=d>>>6&63|128;a[b+3|0]=d&63|128;f=4;i=e;return f|0}else{c[(Nc()|0)>>2]=84;f=-1;i=e;return f|0}return 0}function n3c(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+264|0;g=f+256|0;h=f;j=c[b>>2]|0;c[g>>2]=j;k=(a|0)!=0;l=k?e:256;e=k?a:h;a:do{if((j|0)==0|(l|0)==0){m=d;n=l;o=j;p=0;q=e}else{a=d;r=l;s=j;t=0;u=e;while(1){v=a>>>0>=r>>>0;if(!(v|a>>>0>32)){m=a;n=r;o=s;p=t;q=u;break a}w=v?r:a;x=a-w|0;v=o3c(u,g,w,0)|0;if((v|0)==-1){break}if((u|0)==(h|0)){y=r;z=h}else{y=r-v|0;z=u+v|0}w=v+t|0;v=c[g>>2]|0;if((v|0)==0|(y|0)==0){m=x;n=y;o=v;p=w;q=z;break a}else{a=x;r=y;s=v;t=w;u=z}}m=x;n=0;o=c[g>>2]|0;p=-1;q=u}}while(0);b:do{if((o|0)==0){A=p}else{if((n|0)==0|(m|0)==0){A=p;break}else{B=m;C=n;D=o;E=p;F=q}while(1){G=m3c(F,c[D>>2]|0,0)|0;if((G+1|0)>>>0<2){break}x=(c[g>>2]|0)+4|0;c[g>>2]=x;z=B+ -1|0;y=E+1|0;if((C|0)==(G|0)|(z|0)==0){A=y;break b}else{B=z;C=C-G|0;D=x;E=y;F=F+G|0}}if((G|0)!=0){A=-1;break}c[g>>2]=0;A=E}}while(0);if(!k){i=f;return A|0}c[b>>2]=c[g>>2];i=f;return A|0}function o3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;f=i;i=i+8|0;g=f;if((b|0)==0){h=c[d>>2]|0;j=g;k=c[h>>2]|0;if((k|0)==0){l=0;i=f;return l|0}else{m=0;n=k;o=h}while(1){if(n>>>0>127){h=m3c(j,n,0)|0;if((h|0)==-1){l=-1;p=26;break}else{q=h}}else{q=1}h=q+m|0;k=o+4|0;r=c[k>>2]|0;if((r|0)==0){l=h;p=26;break}else{m=h;n=r;o=k}}if((p|0)==26){i=f;return l|0}}a:do{if(e>>>0>3){o=b;n=e;m=c[d>>2]|0;while(1){q=c[m>>2]|0;if((q|0)==0){s=o;t=n;break a}if(q>>>0>127){j=m3c(o,q,0)|0;if((j|0)==-1){l=-1;break}u=o+j|0;v=n-j|0;w=m}else{a[o]=q;u=o+1|0;v=n+ -1|0;w=c[d>>2]|0}q=w+4|0;c[d>>2]=q;if(v>>>0>3){o=u;n=v;m=q}else{s=u;t=v;break a}}i=f;return l|0}else{s=b;t=e}}while(0);b:do{if((t|0)==0){x=0}else{b=g;v=s;u=t;w=c[d>>2]|0;while(1){m=c[w>>2]|0;if((m|0)==0){p=24;break}if(m>>>0>127){n=m3c(b,m,0)|0;if((n|0)==-1){l=-1;p=26;break}if(n>>>0>u>>>0){p=20;break}m3c(v,c[w>>2]|0,0)|0;y=v+n|0;z=u-n|0;A=w}else{a[v]=m;y=v+1|0;z=u+ -1|0;A=c[d>>2]|0}m=A+4|0;c[d>>2]=m;if((z|0)==0){x=0;break b}else{v=y;u=z;w=m}}if((p|0)==20){l=e-u|0;i=f;return l|0}else if((p|0)==24){a[v]=0;x=u;break}else if((p|0)==26){i=f;return l|0}}}while(0);c[d>>2]=0;l=e-x|0;i=f;return l|0}function p3c(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0;f=i;i=i+104|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=h4c(20)|0;q=p;if((p|0)==0){r=12;i=f;return r|0}s=h4c(2048)|0;c[p+16>>2]=s;if((s|0)==0){i4c(p);r=12;i=f;return r|0}c[p>>2]=512;c[p+4>>2]=10240;c[p+8>>2]=128;c[p+12>>2]=0;s=F3c(0,0)|0;if((s|0)==0){i4c(c[p+16>>2]|0);i4c(p);r=12;i=f;return r|0}t=o+0|0;u=t+44|0;do{c[t>>2]=0;t=t+4|0}while((t|0)<(u|0));c[o>>2]=s;c[o+4>>2]=q;c[o+12>>2]=d;c[o+36>>2]=e;d=o+28|0;c[d>>2]=-1;t=q3c(o)|0;a:do{if((t|0)==0){u=o+20|0;v=c[u>>2]|0;w=v+ -1|0;c[b>>2]=w;x=c[o+8>>2]|0;y=c[d>>2]|0;if((y|0)>-1){if((c[o+32>>2]|0)!=0){z=0;A=2;B=0;C=0;break}}if((y|0)>(w|0)){z=0;A=6;B=0;C=0;break}w=j4c(1,68)|0;D=w;if((w|0)==0){z=0;A=12;B=0;C=D;break}E=y>>>31;c[w+60>>2]=E^1;c[w+64>>2]=c[o+32>>2];c[w+28>>2]=v;if((E|0)==1){if((e&8|0)==0){F=13}else{G=0}}else{F=13}if((F|0)==13){E=r3c(0,q,x,D)|0;if((E|0)!=0){z=0;A=E;B=0;C=D;break}E=c[w+40>>2]|0;if((E|0)>0){v=(E<<2)+4|0;y=h4c(v)|0;H=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[w+32>>2]=H;P4c(y|0,-1,v|0)|0;I=H}else{I=0}H=j4c(E<<1|1,4)|0;c[w+36>>2]=H;if((H|0)==0){z=0;A=12;B=0;C=D;break}H=j4c(c[u>>2]|0,12)|0;if((H|0)==0){z=0;A=12;B=0;C=D;break}c[w+16>>2]=H;H=r3c(s,q,x,D)|0;if((H|0)==0){G=I}else{z=0;A=H;B=0;C=D;break}}H=o+24|0;u=p+12|0;E=c[u>>2]|0;c[j>>2]=0;c[k>>2]=0;v=x3c(q,x)|0;b:do{if((v|0)==0){y=x3c(q,0)|0;if((y|0)!=0){J=y;break}y=p+16|0;K=c[u>>2]|0;c:do{if((K|0)>(E|0)){L=0;M=0;N=0;O=K;d:while(1){P=O+ -1|0;c[u>>2]=P;Q=c[y>>2]|0;R=c[Q+(P<<2)>>2]|0;P=O+ -2|0;c[u>>2]=P;S=c[Q+(P<<2)>>2]|0;do{if((R|0)==1){P=S+4|0;T=c[P>>2]|0;U=O+ -3|0;c[u>>2]=U;V=c[Q+(U<<2)>>2]|0;c[j>>2]=V;U=T+4|0;W=c[U>>2]|0;do{if((W|0)>1){c[l>>2]=0;X=T;F=51}else{if((c[T+8>>2]|0)<=1){Y=V;break}c[l>>2]=0;Z=T;if((W|0)>0){X=Z;F=51}else{_=W;$=Z;aa=V;ba=0;F=60}}}while(0);e:do{if((F|0)==51){F=0;Z=V;ca=W;da=1;ea=0;while(1){fa=y3c(s,q,c[X>>2]|0,(da|0)<(ca|0)?1:2,j,G,m,k)|0;if((fa|0)!=0){J=fa;break b}fa=c[m>>2]|0;if((ea|0)==0){ga=fa}else{ha=H3c(s,0,0,1,32)|0;if((ha|0)==0){J=12;break b}ia=H3c(s,0,0,1,8)|0;ja=ha+4|0;c[ja>>2]=ia;if((ia|0)==0){J=12;break b}c[ha>>2]=1;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[ia>>2]=ea;c[(c[ja>>2]|0)+4>>2]=fa;c[ha+16>>2]=(c[fa+16>>2]|0)+(c[ea+16>>2]|0);ga=ha}if((ga|0)==0){J=12;break b}ha=c[U>>2]|0;if((da|0)>=(ha|0)){_=ha;$=X;aa=Z;ba=ga;F=60;break e}Z=c[j>>2]|0;ca=ha;da=da+1|0;ea=ga}}}while(0);if((F|0)==60){F=0;U=T+8|0;W=c[U>>2]|0;do{if((W|0)==-1){ea=c[j>>2]|0;da=y3c(s,q,c[$>>2]|0,0,j,0,l,k)|0;if((da|0)!=0){J=da;break b}da=c[l>>2]|0;ca=H3c(s,0,0,1,32)|0;Z=ca;if((ca|0)==0){F=65;break d}ha=H3c(s,0,0,1,16)|0;c[ca+4>>2]=ha;if((ha|0)==0){F=65;break d}c[ca>>2]=2;c[ca+8>>2]=-1;c[ca+12>>2]=-1;c[ha>>2]=da;c[ha+4>>2]=0;c[ha+8>>2]=-1;fa=ha+12|0;a[fa]=a[fa]&-2;c[ca+16>>2]=c[da+16>>2];c[l>>2]=Z;ka=Z;la=ea}else{if((_|0)<(W|0)){ma=0;na=_}else{ka=0;la=aa;break}while(1){ea=c[j>>2]|0;Z=y3c(s,q,c[$>>2]|0,0,j,0,n,k)|0;if((Z|0)!=0){J=Z;break b}Z=c[n>>2]|0;if((ma|0)==0){oa=Z}else{da=H3c(s,0,0,1,32)|0;if((da|0)==0){F=73;break d}ca=H3c(s,0,0,1,8)|0;fa=da+4|0;c[fa>>2]=ca;if((ca|0)==0){F=73;break d}c[da>>2]=1;c[da+8>>2]=-1;c[da+12>>2]=-1;c[ca>>2]=Z;c[(c[fa>>2]|0)+4>>2]=ma;c[da+16>>2]=(c[ma+16>>2]|0)+(c[Z+16>>2]|0);oa=da}c[l>>2]=oa;if((oa|0)==0){J=12;break b}da=H3c(s,0,0,1,32)|0;if((da|0)==0){J=12;break b}Z=H3c(s,0,0,1,20)|0;c[da+4>>2]=Z;if((Z|0)==0){J=12;break b}c[da>>2]=0;c[da+8>>2]=-1;c[da+12>>2]=-1;c[Z>>2]=-1;c[Z+4>>2]=-1;c[Z+8>>2]=-1;Z=H3c(s,0,0,1,32)|0;fa=Z;if((Z|0)==0){F=79;break d}ca=H3c(s,0,0,1,8)|0;ha=Z+4|0;c[ha>>2]=ca;if((ca|0)==0){F=79;break d}c[Z>>2]=3;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[ca>>2]=da;c[(c[ha>>2]|0)+4>>2]=oa;c[Z+16>>2]=(c[oa+16>>2]|0)+(c[da+16>>2]|0);c[l>>2]=fa;da=na+1|0;if((da|0)<(c[U>>2]|0)){ma=fa;na=da}else{ka=fa;la=ea;break}}}}while(0);c[j>>2]=la;do{if((ba|0)==0){pa=ka;F=85}else{if((ka|0)==0){qa=ba;break}U=H3c(s,0,0,1,32)|0;if((U|0)==0){J=12;break b}W=H3c(s,0,0,1,8)|0;T=U+4|0;c[T>>2]=W;if((W|0)==0){J=12;break b}c[U>>2]=1;c[U+8>>2]=-1;c[U+12>>2]=-1;c[W>>2]=ba;c[(c[T>>2]|0)+4>>2]=ka;c[U+16>>2]=(c[ka+16>>2]|0)+(c[ba+16>>2]|0);pa=U;F=85}}while(0);if((F|0)==85){F=0;if((pa|0)==0){J=12;break b}else{qa=pa}}c[P>>2]=c[qa+4>>2];c[S>>2]=c[qa>>2];Y=la}U=M+ -1|0;T=Y-V+N|0;if((U|0)!=0){ra=Y;sa=U;ta=T;break}c[j>>2]=T;ra=T;sa=0;ta=T}else if((R|0)==0){T=c[S>>2]|0;if((T|0)==1){U=c[S+4>>2]|0;W=x3c(q,c[U+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=x3c(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=x3c(q,c[U>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=x3c(q,0)|0}else if((T|0)==2){W=c[S+4>>2]|0;U=x3c(q,L)|0;if((U|0)!=0){ua=N;va=U;break c}U=x3c(q,S)|0;if((U|0)!=0){ua=N;va=U;break c}U=x3c(q,1)|0;if((U|0)!=0){ua=N;va=U;break c}U=x3c(q,c[W>>2]|0)|0;if((U|0)!=0){ua=N;va=U;break c}U=x3c(q,0)|0;if((U|0)!=0){ua=N;va=U;break c}if((c[W+4>>2]|0)>1){F=45}else{if((c[W+8>>2]|0)>1){F=45}else{xa=L}}if((F|0)==45){F=0;c[j>>2]=0;xa=0}ra=xa;sa=M+1|0;ta=N;break}else if((T|0)==0){W=c[S+4>>2]|0;U=c[W>>2]|0;if(!((U|0)>-1|(U|0)==-4)){ra=L;sa=M;ta=N;break}U=W+8|0;W=(c[U>>2]|0)+L|0;c[U>>2]=W;if((W|0)<=(c[k>>2]|0)){ra=L;sa=M;ta=N;break}c[k>>2]=W;ra=L;sa=M;ta=N;break}else if((T|0)==3){T=c[S+4>>2]|0;W=x3c(q,c[T+4>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}W=x3c(q,0)|0;if((W|0)!=0){ua=N;va=W;break c}W=x3c(q,c[T>>2]|0)|0;if((W|0)!=0){ua=N;va=W;break c}wa=x3c(q,0)|0}else{ra=L;sa=M;ta=N;break}if((wa|0)==0){ra=L;sa=M;ta=N}else{ua=N;va=wa;break c}}else{ra=L;sa=M;ta=N}}while(0);S=c[u>>2]|0;if((S|0)>(E|0)){L=ra;M=sa;N=ta;O=S}else{ua=ta;va=0;break c}}if((F|0)==65){c[l>>2]=0;J=12;break b}else if((F|0)==73){c[l>>2]=0;J=12;break b}else if((F|0)==79){c[l>>2]=0;J=12;break b}}else{ua=0;va=0}}while(0);y=(c[H>>2]|0)+ua|0;K=c[k>>2]|0;c[H>>2]=(K|0)>(y|0)?K:y;J=va}else{J=v}}while(0);if((J|0)!=0){z=0;A=J;B=0;C=D;break}v=c[H>>2]|0;c[H>>2]=v+1;E=H3c(s,0,0,1,32)|0;if((E|0)==0){z=0;A=12;B=0;C=D;break}y=H3c(s,0,0,1,20)|0;c[E+4>>2]=y;if((y|0)==0){z=0;A=12;B=0;C=D;break}c[E>>2]=0;c[E+8>>2]=-1;c[E+12>>2]=-1;c[y>>2]=0;c[y+4>>2]=0;c[y+8>>2]=v;v=H3c(s,0,0,1,32)|0;y=v;if((v|0)==0){z=0;A=12;B=0;C=D;break}K=H3c(s,0,0,1,8)|0;O=v+4|0;c[O>>2]=K;if((K|0)==0){z=0;A=12;B=0;C=D;break}c[v>>2]=1;c[v+8>>2]=-1;c[v+12>>2]=-1;c[K>>2]=x;c[(c[O>>2]|0)+4>>2]=E;c[v+16>>2]=(c[E+16>>2]|0)+(c[x+16>>2]|0);E=c[u>>2]|0;O=x3c(q,v)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=x3c(q,0)|0;if((O|0)!=0){z=0;A=O;B=0;C=D;break}O=c[u>>2]|0;f:do{if((O|0)>(E|0)){K=p+16|0;N=O;g:while(1){M=N+ -1|0;c[u>>2]=M;L=c[K>>2]|0;S=c[L+(M<<2)>>2]|0;M=N+ -2|0;c[u>>2]=M;ya=c[L+(M<<2)>>2]|0;do{if((S|0)==0){M=c[ya>>2]|0;if((M|0)==1){L=x3c(q,ya)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=x3c(q,2)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=ya+4|0;R=x3c(q,c[(c[L>>2]|0)+4>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=x3c(q,0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=x3c(q,c[c[L>>2]>>2]|0)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=x3c(q,0)|0;if((R|0)==0){break}else{z=0;A=R;B=0;C=D;break a}}else if((M|0)==3){R=x3c(q,ya)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=x3c(q,1)|0;if((R|0)!=0){z=0;A=R;B=0;C=D;break a}R=ya+4|0;L=x3c(q,c[(c[R>>2]|0)+4>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=x3c(q,0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=x3c(q,c[c[R>>2]>>2]|0)|0;if((L|0)!=0){z=0;A=L;B=0;C=D;break a}L=x3c(q,0)|0;if((L|0)==0){break}else{z=0;A=L;B=0;C=D;break a}}else if((M|0)==0){L=c[ya+4>>2]|0;R=c[L>>2]|0;if((R|0)==-4){c[ya+8>>2]=0;Q=L+8|0;W=c[Q>>2]|0;T=H3c(s,0,0,1,64)|0;if((T|0)==0){F=104;break g}U=T;c[T>>2]=W;c[T+4>>2]=0;c[T+8>>2]=1114111;c[T+20>>2]=0;c[T+24>>2]=0;W=T+28|0;T=ya+24|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[T>>2]=U;U=c[Q>>2]|0;Q=c[L+4>>2]|0;T=H3c(s,0,0,1,64)|0;if((T|0)==0){F=106;break g}c[T>>2]=U;c[T+4>>2]=0;c[T+8>>2]=1114111;c[T+20>>2]=0;c[T+24>>2]=0;c[T+28>>2]=Q;c[T+32>>2]=-1;c[T+36>>2]=-1;c[T+40>>2]=-1;c[ya+28>>2]=T;break}T=ya+8|0;if((R|0)<0){c[T>>2]=1;Q=H3c(s,0,0,1,32)|0;if((Q|0)==0){F=110;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+24>>2]=Q;Q=H3c(s,0,0,1,32)|0;if((Q|0)==0){F=112;break g}c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;c[ya+28>>2]=Q;break}else{c[T>>2]=0;T=L+8|0;Q=c[T>>2]|0;U=L+4|0;W=c[U>>2]|0;ea=H3c(s,0,0,1,64)|0;if((ea|0)==0){F=115;break g}fa=ea;c[ea>>2]=Q;c[ea+4>>2]=R;c[ea+8>>2]=W;c[ea+20>>2]=0;c[ea+24>>2]=0;W=ea+28|0;ea=ya+24|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[ea>>2]=fa;fa=c[T>>2]|0;T=c[L>>2]|0;ea=c[U>>2]|0;U=c[L+12>>2]|0;W=c[L+16>>2]|0;L=H3c(s,0,0,1,64)|0;if((L|0)==0){F=117;break g}R=L;c[L>>2]=fa;c[L+4>>2]=T;c[L+8>>2]=ea;c[L+20>>2]=U;c[L+24>>2]=W;W=L+28|0;L=ya+28|0;c[W+0>>2]=-1;c[W+4>>2]=-1;c[W+8>>2]=-1;c[W+12>>2]=-1;c[L>>2]=R;break}}else if((M|0)==2){M=x3c(q,ya)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=x3c(q,3)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=x3c(q,c[c[ya+4>>2]>>2]|0)|0;if((M|0)!=0){z=0;A=M;B=0;C=D;break a}M=x3c(q,0)|0;if((M|0)==0){break}else{z=0;A=M;B=0;C=D;break a}}else{break}}else if((S|0)==3){M=c[ya+4>>2]|0;R=c[M>>2]|0;do{if((c[M+4>>2]|0)==0){F=141}else{if((c[R+8>>2]|0)!=0){F=141;break}c[ya+8>>2]=0}}while(0);if((F|0)==141){F=0;c[ya+8>>2]=1}c[ya+24>>2]=c[R+24>>2];c[ya+28>>2]=c[(c[M>>2]|0)+28>>2]}else if((S|0)==2){L=c[ya+4>>2]|0;W=c[L>>2]|0;U=W+8|0;if((c[U>>2]|0)==0){za=0}else{za=(c[(c[L+4>>2]|0)+8>>2]|0)!=0|0}c[ya+8>>2]=za;if((c[U>>2]|0)==0){c[ya+24>>2]=c[W+24>>2];Aa=L+4|0}else{U=w3c(q,W,0,0,g)|0;if((U|0)!=0){z=0;A=U;B=0;C=D;break a}Ba=h4c((c[g>>2]<<2)+4|0)|0;U=Ba;if((Ba|0)==0){z=0;A=12;B=0;C=D;break a}c[Ba>>2]=-1;c[h>>2]=0;Ca=w3c(q,c[L>>2]|0,U,h,0)|0;if((Ca|0)!=0){F=150;break g}W=L+4|0;ea=v3c(s,c[(c[W>>2]|0)+24>>2]|0,c[(c[L>>2]|0)+24>>2]|0,U,c[h>>2]|0)|0;U=ya+24|0;c[U>>2]=ea;i4c(Ba);if((c[U>>2]|0)==0){z=0;A=12;B=0;C=D;break a}else{Aa=W}}W=c[Aa>>2]|0;if((c[W+8>>2]|0)==0){c[ya+28>>2]=c[W+28>>2];break}U=w3c(q,W,0,0,g)|0;if((U|0)!=0){z=0;A=U;B=0;C=D;break a}Da=h4c((c[g>>2]<<2)+4|0)|0;U=Da;if((Da|0)==0){z=0;A=12;B=0;C=D;break a}c[Da>>2]=-1;c[h>>2]=0;Ea=w3c(q,c[Aa>>2]|0,U,h,0)|0;if((Ea|0)!=0){F=157;break g}W=v3c(s,c[(c[L>>2]|0)+28>>2]|0,c[(c[Aa>>2]|0)+28>>2]|0,U,c[h>>2]|0)|0;U=ya+28|0;c[U>>2]=W;i4c(Da);if((c[U>>2]|0)==0){z=0;A=12;B=0;C=D;break a}}else if((S|0)==1){U=c[ya+4>>2]|0;W=c[U>>2]|0;L=U+4|0;ea=c[L>>2]|0;if((c[W+8>>2]|0)==0){Fa=(c[ea+8>>2]|0)!=0|0}else{Fa=1}c[ya+8>>2]=Fa;T=v3c(s,c[W+24>>2]|0,c[ea+24>>2]|0,0,0)|0;c[ya+24>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}T=v3c(s,c[(c[U>>2]|0)+28>>2]|0,c[(c[L>>2]|0)+28>>2]|0,0,0)|0;c[ya+28>>2]=T;if((T|0)==0){z=0;A=12;B=0;C=D;break a}}}while(0);N=c[u>>2]|0;if((N|0)<=(E|0)){break f}}if((F|0)==104){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==106){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==110){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==112){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==115){c[ya+24>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==117){c[ya+28>>2]=0;z=0;A=12;B=0;C=D;break a}else if((F|0)==150){i4c(Ba);z=0;A=Ca;B=0;C=D;break a}else if((F|0)==157){i4c(Da);z=0;A=Ea;B=0;C=D;break a}}}while(0);E=c[H>>2]|0;u=E<<2;O=h4c(u)|0;x=O;if((O|0)==0){z=x;A=12;B=0;C=D;break}N=h4c(u)|0;u=N;if((N|0)==0){z=x;A=12;B=u;C=D;break}if((E|0)>0){P4c(O|0,0,((E|0)>1?E<<2:4)|0)|0}s3c(y,0,x,0)|0;E=c[H>>2]|0;if((E|0)>0){K=0;S=0;while(1){c[N+(S<<2)>>2]=K;T=O+(S<<2)|0;L=K+1+(c[T>>2]|0)|0;c[T>>2]=0;T=S+1|0;if((T|0)<(E|0)){S=T;K=L}else{Ga=L;break}}}else{Ga=0}K=j4c(Ga+1|0,32)|0;S=K;if((K|0)==0){z=x;A=12;B=u;C=D;break}c[w>>2]=S;E=w+4|0;c[E>>2]=Ga;L=s3c(y,S,x,u)|0;if((L|0)!=0){z=x;A=L;B=u;C=D;break}c[w+20>>2]=0;L=v+24|0;S=c[L>>2]|0;if((c[S>>2]|0)>-1){T=1;U=S;while(1){S=U+32|0;ea=T+1|0;if((c[S>>2]|0)>-1){U=S;T=ea}else{Ha=ea;break}}}else{Ha=1}T=j4c(Ha,32)|0;if((T|0)==0){z=x;A=12;B=u;C=D;break}c[w+8>>2]=T;U=c[L>>2]|0;y=c[U>>2]|0;if((y|0)>-1){ea=y;y=U;U=0;while(1){c[T+(U<<5)+8>>2]=K+(c[N+(ea<<2)>>2]<<5);c[T+(U<<5)+12>>2]=ea;S=T+(U<<5)+16|0;c[S>>2]=0;W=y+12|0;fa=c[W>>2]|0;if((fa|0)!=0){Q=0;while(1){Ia=Q+1|0;if((c[fa+(Q<<2)>>2]|0)>-1){Q=Ia}else{break}}Q=Ia<<2;fa=h4c(Q)|0;c[S>>2]=fa;if((fa|0)==0){z=x;A=12;B=u;C=D;break a}N4c(fa|0,c[W>>2]|0,Q|0)|0}c[T+(U<<5)+20>>2]=c[y+16>>2];Q=U+1|0;fa=y+32|0;da=c[fa>>2]|0;if((da|0)>-1){ea=da;y=fa;U=Q}else{Ja=Q;break}}}else{Ja=0}c[T+(Ja<<5)+8>>2]=0;c[E>>2]=Ga;c[w+12>>2]=K+(c[N+(c[c[v+28>>2]>>2]<<2)>>2]<<5);c[w+52>>2]=c[H>>2];c[w+56>>2]=e;G3c(s);i4c(c[p+16>>2]|0);i4c(p);i4c(O);i4c(N);c[b+4>>2]=w;r=0;i=f;return r|0}else{z=0;A=t;B=0;C=0}}while(0);G3c(s);i4c(c[p+16>>2]|0);i4c(p);if((z|0)!=0){i4c(z)}if((B|0)!=0){i4c(B)}c[b+4>>2]=C;t3c(b);r=A;i=f;return r|0}function q3c(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0;d=i;i=i+424|0;e=d;f=d+8|0;g=d+72|0;h=d+328|0;j=d+336|0;k=d+384|0;l=d+392|0;m=c[b+4>>2]|0;n=m+12|0;o=c[n>>2]|0;if((c[b+40>>2]|0)==0){p=b+20|0;x3c(m,c[p>>2]|0)|0;x3c(m,2)|0;c[p>>2]=(c[p>>2]|0)+1}p=x3c(m,0)|0;q=b+12|0;r=b+16|0;c[r>>2]=c[q>>2];s=c[n>>2]|0;t=(p|0)==0;a:do{if((s|0)>(o|0)&t){u=m+16|0;v=b+36|0;w=b;x=b+24|0;y=b+20|0;z=g;A=f;B=b+28|0;C=l;D=k;E=k+1|0;F=j;G=b;H=j+12|0;I=j+40|0;J=j+24|0;K=j+8|0;L=s;M=0;N=0;b:while(1){O=L+ -1|0;c[n>>2]=O;P=c[u>>2]|0;c:do{switch(c[P+(O<<2)>>2]|0){case 4:{Q=x3c(m,9)|0;if((Q|0)!=0){R=M;S=Q;T=6;break b}U=M;V=N;W=x3c(m,1)|0;break};case 5:{Q=c[q>>2]|0;X=a[Q]|0;if(X<<24>>24==0){U=M;V=N;W=0;break c}Y=c[v>>2]&1;Z=(Y|0)!=0;if(Z&X<<24>>24==124){U=M;V=N;W=0;break c}do{if(!(Z&X<<24>>24==41&(M|0)>0)){if((Y|0)==0&X<<24>>24==92){if((a[Q+1|0]|0)==41){break}}_=x3c(m,5)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=x3c(m,N)|0;if((_|0)!=0){R=M;S=_;T=6;break b}_=x3c(m,6)|0;if((_|0)!=0){R=M;S=_;T=6;break b}U=M;V=N;W=x3c(m,4)|0;break c}}while(0);X=(Y|M|0)==0?8:0;Z=M+ -1|0;if((Y|0)!=0){U=Z;V=N;W=X;break c}c[q>>2]=Q+2;U=Z;V=N;W=X;break};case 6:{X=L+ -2|0;c[n>>2]=X;Z=c[P+(X<<2)>>2]|0;X=c[w>>2]|0;_=H3c(X,0,0,1,32)|0;if((_|0)==0){$=12;T=294;break b}aa=H3c(X,0,0,1,8)|0;X=_+4|0;c[X>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[_>>2]=1;c[_+8>>2]=-1;c[_+12>>2]=-1;c[aa>>2]=Z;c[(c[X>>2]|0)+4>>2]=N;c[_+16>>2]=(c[N+16>>2]|0)+(c[Z+16>>2]|0);U=M;V=_;W=0;break};case 0:{if((c[v>>2]&1|0)!=0){_=x3c(m,7)|0;if((_|0)!=0){R=M;S=_;T=6;break b}}U=M;V=N;W=x3c(m,3)|0;break};case 8:{_=L+ -2|0;c[n>>2]=_;Z=c[P+(_<<2)>>2]|0;_=c[w>>2]|0;X=H3c(_,0,0,1,32)|0;if((X|0)==0){$=12;T=294;break b}aa=H3c(_,0,0,1,8)|0;_=X+4|0;c[_>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[X>>2]=3;c[X+8>>2]=-1;c[X+12>>2]=-1;c[aa>>2]=Z;c[(c[_>>2]|0)+4>>2]=N;c[X+16>>2]=(c[N+16>>2]|0)+(c[Z+16>>2]|0);U=M;V=X;W=0;break};case 9:{X=c[q>>2]|0;Z=a[X]|0;switch(Z<<24>>24|0){case 92:{_=c[v>>2]|0;if((_&1|0)!=0){U=M;V=N;W=0;break c}aa=X+1|0;if((a[aa]|0)!=123){U=M;V=N;W=0;break c}c[q>>2]=aa;ba=_;ca=aa;break};case 42:{T=41;break};case 63:case 43:{if((c[v>>2]&1|0)==0){U=M;V=N;W=0;break c}else{T=41}break};case 123:{aa=c[v>>2]|0;if((aa&1|0)==0){U=M;V=N;W=0;break c}else{ba=aa;ca=X}break};default:{U=M;V=N;W=0;break c}}if((T|0)==41){T=0;c[q>>2]=X+1;X=c[w>>2]|0;aa=H3c(X,0,0,1,32)|0;if((aa|0)==0){$=12;T=294;break b}_=H3c(X,0,0,1,16)|0;c[aa+4>>2]=_;if((_|0)==0){$=12;T=294;break b}c[aa>>2]=2;c[aa+8>>2]=-1;c[aa+12>>2]=-1;c[_>>2]=N;c[_+4>>2]=Z<<24>>24==43;c[_+8>>2]=Z<<24>>24==63?1:-1;Z=_+12|0;a[Z]=a[Z]&-2;c[aa+16>>2]=c[N+16>>2];U=M;V=aa;W=x3c(m,9)|0;break c}aa=ca+1|0;c[q>>2]=aa;Z=a[aa]|0;if((Z+ -48<<24>>24&255)<10){_=Z<<24>>24;if((_+ -48|0)>>>0<10){da=_;ea=-1;fa=aa}else{$=10;T=294;break b}while(1){_=((ea|0)<0?-48:(ea*10|0)+ -48|0)+da|0;X=fa+1|0;ga=a[X]|0;ha=ga<<24>>24;if((ha+ -48|0)>>>0<10){fa=X;ea=_;da=ha}else{ia=ga;ja=_;ka=X;break}}}else{ia=Z;ja=-1;ka=aa}do{if(ia<<24>>24==44){Q=ka+1|0;Y=a[Q]|0;X=Y<<24>>24;if((X+ -48|0)>>>0<10){la=X;ma=-1;na=Q}else{oa=Y;pa=-1;qa=Q;break}while(1){Q=((ma|0)<0?-48:(ma*10|0)+ -48|0)+la|0;Y=na+1|0;X=a[Y]|0;_=X<<24>>24;if((_+ -48|0)>>>0<10){na=Y;ma=Q;la=_}else{ra=X;sa=Q;ta=Y;T=54;break}}}else{ra=ia;sa=ja;ta=ka;T=54}}while(0);do{if((T|0)==54){T=0;if(!((sa|0)>-1)){oa=ra;pa=sa;qa=ta;break}if((ja|0)>(sa|0)|(sa|0)>255){$=10;T=294;break b}else{oa=ra;pa=sa;qa=ta}}}while(0);if(oa<<24>>24==0){$=9;T=294;break b}if((qa|0)==(aa|0)){$=10;T=294;break b}if((ba&1|0)==0){if(!(oa<<24>>24==92)){$=10;T=294;break b}if((a[qa+1|0]|0)!=125){$=10;T=294;break b}ua=qa+2|0}else{if(!(oa<<24>>24==125)){$=10;T=294;break b}ua=qa+1|0}if((pa|ja|0)==0){Z=c[w>>2]|0;Y=H3c(Z,0,0,1,32)|0;if((Y|0)==0){$=12;T=294;break b}Q=H3c(Z,0,0,1,20)|0;c[Y+4>>2]=Q;if((Q|0)==0){$=12;T=294;break b}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;va=Y}else{Y=(pa&ja|0)<0;Q=c[w>>2]|0;Z=H3c(Q,0,0,1,32)|0;if((Z|0)==0){$=12;T=294;break b}X=H3c(Q,0,0,1,16)|0;c[Z+4>>2]=X;if((X|0)==0){$=12;T=294;break b}c[Z>>2]=2;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[X>>2]=N;c[X+4>>2]=Y?1:ja;c[X+8>>2]=Y?1:pa;Y=X+12|0;a[Y]=a[Y]&-2;c[Z+16>>2]=c[N+16>>2];va=Z}c[q>>2]=ua;U=M;V=va;W=x3c(m,9)|0;break};case 10:{Z=L+ -2|0;c[n>>2]=Z;c[v>>2]=c[P+(Z<<2)>>2];U=M;V=N;W=0;break};case 2:{Z=L+ -2|0;c[n>>2]=Z;Y=c[P+(Z<<2)>>2]|0;if((c[N+12>>2]|0)>-1){Z=c[w>>2]|0;X=H3c(Z,0,0,1,32)|0;if((X|0)==0){$=12;T=294;break b}Q=H3c(Z,0,0,1,20)|0;c[X+4>>2]=Q;if((Q|0)==0){$=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Q>>2]=-1;c[Q+4>>2]=-1;c[Q+8>>2]=-1;Q=c[w>>2]|0;Z=H3c(Q,0,0,1,32)|0;if((Z|0)==0){$=12;T=294;break b}_=H3c(Q,0,0,1,8)|0;Q=Z+4|0;c[Q>>2]=_;if((_|0)==0){$=12;T=294;break b}c[Z>>2]=1;c[Z+8>>2]=-1;c[Z+12>>2]=-1;c[_>>2]=X;c[(c[Q>>2]|0)+4>>2]=N;Q=N+16|0;_=Z+16|0;c[_>>2]=(c[Q>>2]|0)+(c[X+16>>2]|0);c[_>>2]=c[Q>>2];wa=Z}else{wa=N}c[wa+12>>2]=Y;Y=wa+16|0;c[Y>>2]=(c[Y>>2]|0)+1;U=M;V=wa;W=0;break};case 7:{Y=c[q>>2]|0;Z=a[Y]|0;if((Z|0)==41){c[q>>2]=Y+1;U=M;V=N;W=0;break c}else if((Z|0)!=124){U=M;V=N;W=0;break c}Z=x3c(m,7)|0;if((Z|0)!=0){R=M;S=Z;T=6;break b}Z=x3c(m,N)|0;if((Z|0)!=0){R=M;S=Z;T=6;break b}Z=x3c(m,8)|0;if((Z|0)!=0){R=M;S=Z;T=6;break b}Z=x3c(m,3)|0;if((Z|0)!=0){R=M;S=Z;T=6;break b}c[q>>2]=(c[q>>2]|0)+1;U=M;V=N;W=0;break};case 1:{Z=c[q>>2]|0;d:do{switch(a[Z]|0){case 91:{Y=Z+1|0;c[q>>2]=Y;Q=h4c(128)|0;if((Q|0)==0){$=12;T=294;break b}if((a[Y]|0)==94){_=Z+2|0;c[q>>2]=_;xa=_;ya=1}else{xa=Y;ya=0}Y=(ya|0)==0;_=Q;Q=0;X=0;ga=32;ha=xa;e:while(1){za=a[ha]|0;if(za<<24>>24==93){if(ha>>>0>(c[q>>2]|0)>>>0){T=85;break}}else if(za<<24>>24==0){Aa=_;Ba=ha;Ca=7;T=140;break}za=l3c(e,ha,-1)|0;if((za|0)<0){c[e>>2]=-1;Da=1}else{Da=za}za=ha+Da|0;do{if((a[za]|0)==45){Ea=Da+1|0;Fa=ha+Ea|0;if((a[Fa]|0)==93){T=94;break}Ga=c[e>>2]|0;Ha=l3c(e,Fa,-1)|0;if((Ha|0)<0){c[e>>2]=-1;Ia=-1;Ja=1}else{Ia=c[e>>2]|0;Ja=Ha}Ka=0;La=Ia;Ma=Ga;Na=ha+(Ja+Ea)|0;Oa=Ga>>>0>Ia>>>0?11:0}else{T=94}}while(0);f:do{if((T|0)==94){T=0;Ga=a[ha]|0;do{if(Ga<<24>>24==45){if((a[ha+1|0]|0)==93){Pa=0;break}Pa=(c[q>>2]|0)==(ha|0)?0:11}else if(Ga<<24>>24==91){Ea=a[ha+1|0]|0;if(Ea<<24>>24==61|Ea<<24>>24==46){Aa=_;Ba=ha;Ca=3;T=140;break e}else if(!(Ea<<24>>24==58)){Pa=0;break}Ea=ha+2|0;Ha=Ea;while(1){Fa=a[Ha]|0;Qa=Fa<<24>>24==0;if(Fa<<24>>24!=58&(Qa^1)){Ha=Ha+1|0}else{break}}if(Qa){Aa=_;Ba=ha;Ca=4;T=140;break e}Fa=Ha-ha+ -2|0;Ra=(Fa|0)>63?63:Fa;W4c(A|0,Ea|0,Ra|0)|0;a[f+Ra|0]=0;Ra=X2c(A)|0;Ka=Ra;La=1114111;Ma=0;Na=Ha+2|0;Oa=(Ra|0)==0?4:0;break f}else{Pa=0}}while(0);Ga=c[e>>2]|0;Ka=0;La=Ga;Ma=Ga;Na=za;Oa=Pa}}while(0);if((Oa|0)!=0){Aa=_;Ba=Na;Ca=Oa;T=140;break}za=(Ka|0)!=0;do{if(Y|za^1){Ga=c[w>>2]|0;if((X|0)<(ga|0)){Sa=_;Ta=ga}else{if((ga|0)>1024){Aa=_;Ba=Na;Ca=12;T=140;break e}Ra=k4c(_,ga<<3)|0;if((Ra|0)==0){Aa=_;Ba=Na;Ca=12;T=140;break e}else{Sa=Ra;Ta=ga<<1}}Ra=H3c(Ga,0,0,1,32)|0;if((Ra|0)==0){T=112;break e}Fa=H3c(Ga,0,0,1,20)|0;Ga=Ra+4|0;c[Ga>>2]=Fa;if((Fa|0)==0){T=112;break e}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[Fa>>2]=Ma;c[Fa+4>>2]=La;c[Fa+8>>2]=-1;c[Sa+(X<<2)>>2]=Ra;c[(c[Ga>>2]|0)+12>>2]=Ka;Ua=Sa;Va=Q;Wa=X+1|0;Xa=Ta;Ya=0}else{if((Q|0)>63){Ua=_;Va=Q;Wa=X;Xa=ga;Ya=12;break}c[g+(Q<<2)>>2]=Ka;Ua=_;Va=Q+1|0;Wa=X;Xa=ga;Ya=0}}while(0);Ga=(Ya|0)==0;if(Ga&(((c[v>>2]&2|0)==0|za)^1)){Za=Ua;_a=Wa;$a=Xa;ab=Ma}else{if(Ga){_=Ua;Q=Va;X=Wa;ga=Xa;ha=Na;continue}else{Aa=Ua;Ba=Na;Ca=Ya;T=140;break}}while(1){Ga=ab;while(1){if(Ga>>>0>La>>>0){_=Za;Q=Va;X=_a;ga=$a;ha=Na;continue e}if((_2c(Ga)|0)!=0){T=118;break}bb=Ga+1|0;if((c3c(Ga)|0)==0){Ga=bb}else{T=129;break}}if((T|0)==118){T=0;Ra=e3c(Ga)|0;Fa=Ga+1|0;g:do{if((_2c(Fa)|0)==0){cb=Ra;db=Fa}else{eb=Ra;fb=Fa;while(1){if((e3c(fb)|0)!=(eb+1|0)|fb>>>0>La>>>0){cb=eb;db=fb;break g}gb=e3c(fb)|0;hb=fb+1|0;if((_2c(hb)|0)==0){cb=gb;db=hb;break}else{eb=gb;fb=hb}}}}while(0);Fa=c[w>>2]|0;if((_a|0)<($a|0)){ib=Za;jb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;T=140;break e}fb=k4c(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;T=140;break e}else{ib=fb;jb=$a<<1}}fb=H3c(Fa,0,0,1,32)|0;eb=fb;do{if((fb|0)==0){kb=0}else{Ha=H3c(Fa,0,0,1,20)|0;c[fb+4>>2]=Ha;if((Ha|0)==0){kb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Ha>>2]=Ra;c[Ha+4>>2]=cb;c[Ha+8>>2]=-1;kb=eb}}while(0);c[ib+(_a<<2)>>2]=kb;lb=kb;mb=ib;nb=jb;ob=db}else if((T|0)==129){T=0;eb=g3c(Ga)|0;h:do{if((c3c(bb)|0)==0){pb=eb;qb=bb}else{Ra=eb;fb=bb;while(1){if((g3c(fb)|0)!=(Ra+1|0)|fb>>>0>La>>>0){pb=Ra;qb=fb;break h}Fa=fb+1|0;Ha=g3c(fb)|0;if((c3c(Fa)|0)==0){pb=Ha;qb=Fa;break}else{Ra=Ha;fb=Fa}}}}while(0);Ga=c[w>>2]|0;if((_a|0)<($a|0)){rb=Za;sb=$a}else{if(($a|0)>1024){Aa=Za;Ba=Na;Ca=12;T=140;break e}fb=k4c(Za,$a<<3)|0;if((fb|0)==0){Aa=Za;Ba=Na;Ca=12;T=140;break e}else{rb=fb;sb=$a<<1}}fb=H3c(Ga,0,0,1,32)|0;Ra=fb;do{if((fb|0)==0){tb=0}else{Fa=H3c(Ga,0,0,1,20)|0;c[fb+4>>2]=Fa;if((Fa|0)==0){tb=0;break}c[fb>>2]=0;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[Fa>>2]=eb;c[Fa+4>>2]=pb;c[Fa+8>>2]=-1;tb=Ra}}while(0);c[rb+(_a<<2)>>2]=tb;lb=tb;mb=rb;nb=sb;ob=qb}if((lb|0)==0){T=141;break e}else{Za=mb;_a=_a+1|0;$a=nb;ab=ob}}}i:do{if((T|0)==85){T=0;c[q>>2]=ha+1;ga=(ya|0)!=0;if(ga){cc(_|0,X|0,4,62)}j:do{if((X|0)>0){Y=(Q|0)>0;za=Q<<2;Ra=za+4|0;if(ga){ub=0;vb=0;wb=0;xb=0}else{eb=0;fb=0;while(1){Ga=_+(eb<<2)|0;Fa=c[(c[Ga>>2]|0)+4>>2]|0;do{if((Fa|0)==0){yb=fb;zb=0}else{c[Fa+8>>2]=c[x>>2];if(Y){Ha=H3c(c[w>>2]|0,0,0,0,Ra)|0;Ea=Fa+16|0;c[Ea>>2]=Ha;if((Ha|0)==0){Ab=_;Bb=fb;Cb=12;break i}N4c(Ha|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(Q<<2)>>2]=0}else{c[Fa+16>>2]=0}if((fb|0)==0){yb=c[Ga>>2]|0;zb=0;break}Ea=c[w>>2]|0;Ha=c[Ga>>2]|0;hb=H3c(Ea,0,0,1,32)|0;gb=hb;do{if((hb|0)==0){Db=0}else{Eb=H3c(Ea,0,0,1,8)|0;Fb=hb+4|0;c[Fb>>2]=Eb;if((Eb|0)==0){Db=0;break}c[hb>>2]=3;c[hb+8>>2]=-1;c[hb+12>>2]=-1;c[Eb>>2]=fb;c[(c[Fb>>2]|0)+4>>2]=Ha;c[hb+16>>2]=(c[Ha+16>>2]|0)+(c[fb+16>>2]|0);Db=gb}}while(0);yb=Db;zb=(Db|0)==0?12:0}}while(0);Ga=eb+1|0;if((Ga|0)<(X|0)&(zb|0)==0){eb=Ga;fb=yb}else{Gb=0;Hb=yb;Ib=zb;break j}}}while(1){fb=_+(wb<<2)|0;eb=c[(c[fb>>2]|0)+4>>2]|0;Ga=c[eb>>2]|0;Fa=eb+4|0;gb=c[Fa>>2]|0;do{if((Ga|0)<(ub|0)){Ha=gb+1|0;Jb=(Ha|0)<(ub|0)?ub:Ha;Kb=vb;Lb=xb;Mb=0}else{if((Ga|0)<=(vb|0)){Ha=gb+1|0;Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb>>2]=vb;c[Fa>>2]=Ga+ -1;Ha=gb+1|0;if((eb|0)==0){Jb=Ha;Kb=Ha;Lb=xb;Mb=0;break}c[eb+8>>2]=c[x>>2];if(Y){hb=H3c(c[w>>2]|0,0,0,0,Ra)|0;Ea=eb+16|0;c[Ea>>2]=hb;if((hb|0)==0){Ab=_;Bb=xb;Cb=12;break i}N4c(hb|0,z|0,za|0)|0;c[(c[Ea>>2]|0)+(Q<<2)>>2]=0}else{c[eb+16>>2]=0}if((xb|0)==0){Jb=Ha;Kb=Ha;Lb=c[fb>>2]|0;Mb=0;break}Ea=c[w>>2]|0;hb=c[fb>>2]|0;Fb=H3c(Ea,0,0,1,32)|0;Eb=Fb;do{if((Fb|0)==0){Nb=0}else{Ob=H3c(Ea,0,0,1,8)|0;Pb=Fb+4|0;c[Pb>>2]=Ob;if((Ob|0)==0){Nb=0;break}c[Fb>>2]=3;c[Fb+8>>2]=-1;c[Fb+12>>2]=-1;c[Ob>>2]=xb;c[(c[Pb>>2]|0)+4>>2]=hb;c[Fb+16>>2]=(c[hb+16>>2]|0)+(c[xb+16>>2]|0);Nb=Eb}}while(0);Jb=Ha;Kb=Ha;Lb=Nb;Mb=(Nb|0)==0?12:0}}while(0);fb=wb+1|0;if((fb|0)<(X|0)&(Mb|0)==0){ub=Jb;vb=Kb;wb=fb;xb=Lb}else{Gb=Kb;Hb=Lb;Ib=Mb;break}}}else{Gb=0;Hb=0;Ib=0}}while(0);if((Ib|0)!=0|ga^1){Ab=_;Bb=Hb;Cb=Ib;break}za=c[w>>2]|0;Ra=c[x>>2]|0;Y=H3c(za,0,0,1,32)|0;fb=Y;if((Y|0)==0){Ab=_;Bb=Hb;Cb=12;break}eb=H3c(za,0,0,1,20)|0;c[Y+4>>2]=eb;if((eb|0)==0){Ab=_;Bb=Hb;Cb=12;break}c[Y>>2]=0;c[Y+8>>2]=-1;c[Y+12>>2]=-1;c[eb>>2]=Gb;c[eb+4>>2]=1114111;c[eb+8>>2]=Ra;if((Q|0)>0){Ra=Q<<2;za=H3c(c[w>>2]|0,0,0,0,Ra+4|0)|0;gb=eb+16|0;c[gb>>2]=za;if((za|0)==0){Ab=_;Bb=Hb;Cb=12;break}N4c(za|0,z|0,Ra|0)|0;c[(c[gb>>2]|0)+(Q<<2)>>2]=0}else{c[eb+16>>2]=0}if((Hb|0)==0){Ab=_;Bb=fb;Cb=0;break}eb=c[w>>2]|0;gb=H3c(eb,0,0,1,32)|0;Ra=gb;do{if((gb|0)==0){Qb=0}else{za=H3c(eb,0,0,1,8)|0;Ga=gb+4|0;c[Ga>>2]=za;if((za|0)==0){Qb=0;break}c[gb>>2]=3;c[gb+8>>2]=-1;c[gb+12>>2]=-1;c[za>>2]=Hb;c[(c[Ga>>2]|0)+4>>2]=fb;c[gb+16>>2]=(c[Y+16>>2]|0)+(c[Hb+16>>2]|0);Qb=Ra}}while(0);Ab=_;Bb=Qb;Cb=(Qb|0)==0?12:0}else if((T|0)==112){T=0;c[Sa+(X<<2)>>2]=0;Aa=Sa;Ba=Na;Ca=12;T=140}else if((T|0)==141){T=0;c[q>>2]=Na;Ab=mb;Bb=0;Cb=12}}while(0);if((T|0)==140){T=0;c[q>>2]=Ba;Ab=Aa;Bb=0;Cb=Ca}i4c(Ab);c[x>>2]=(c[x>>2]|0)+1;if((Cb|0)==0){U=M;V=Bb;W=0;break c}else{$=Cb;T=294;break b}break};case 94:{if((c[v>>2]&1|0)==0){if((Z|0)!=(c[r>>2]|0)){break d}X=x3c(m,5)|0;if((X|0)!=0){R=M;S=X;T=6;break b}}X=c[w>>2]|0;_=H3c(X,0,0,1,32)|0;if((_|0)==0){$=12;T=294;break b}Q=H3c(X,0,0,1,20)|0;c[_+4>>2]=Q;if((Q|0)==0){$=12;T=294;break b}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[Q>>2]=-2;c[Q+4>>2]=1;c[Q+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=_;W=0;break c;break};case 41:{if((M|0)!=0){T=264}break};case 63:case 43:case 123:case 124:case 42:{T=264;break};case 36:{if((c[v>>2]&1|0)==0){if((a[Z+1|0]|0)!=0){break d}}_=c[w>>2]|0;Q=H3c(_,0,0,1,32)|0;if((Q|0)==0){$=12;T=294;break b}X=H3c(_,0,0,1,20)|0;c[Q+4>>2]=X;if((X|0)==0){$=12;T=294;break b}c[Q>>2]=0;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[X>>2]=-2;c[X+4>>2]=2;c[X+8>>2]=-1;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Q;W=0;break c;break};case 46:{Q=(c[v>>2]&4|0)==0;X=c[w>>2]|0;_=c[x>>2]|0;ha=H3c(X,0,0,1,32)|0;Ra=ha;Y=(ha|0)==0;if(Q){if(Y){$=12;T=294;break b}Q=H3c(X,0,0,1,20)|0;c[ha+4>>2]=Q;if((Q|0)==0){$=12;T=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Q>>2]=0;c[Q+4>>2]=1114111;c[Q+8>>2]=_;Rb=Ra;Sb=(c[x>>2]|0)+1|0}else{if(Y){$=12;T=294;break b}Y=H3c(X,0,0,1,20)|0;c[ha+4>>2]=Y;if((Y|0)==0){$=12;T=294;break b}c[ha>>2]=0;c[ha+8>>2]=-1;c[ha+12>>2]=-1;c[Y>>2]=0;c[Y+4>>2]=9;c[Y+8>>2]=_;_=c[w>>2]|0;Y=(c[x>>2]|0)+1|0;X=H3c(_,0,0,1,32)|0;if((X|0)==0){$=12;T=294;break b}Q=H3c(_,0,0,1,20)|0;c[X+4>>2]=Q;if((Q|0)==0){$=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Q>>2]=11;c[Q+4>>2]=1114111;c[Q+8>>2]=Y;Y=c[w>>2]|0;Q=H3c(Y,0,0,1,32)|0;if((Q|0)==0){$=12;T=294;break b}_=H3c(Y,0,0,1,8)|0;Y=Q+4|0;c[Y>>2]=_;if((_|0)==0){$=12;T=294;break b}c[Q>>2]=3;c[Q+8>>2]=-1;c[Q+12>>2]=-1;c[_>>2]=Ra;c[(c[Y>>2]|0)+4>>2]=X;c[Q+16>>2]=(c[X+16>>2]|0)+(c[ha+16>>2]|0);Rb=Q;Sb=(c[x>>2]|0)+2|0}c[x>>2]=Sb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=Rb;W=0;break c;break};case 40:{if((c[v>>2]&1|0)!=0){Tb=Z;T=74}break};case 0:{T=265;break};case 92:{Q=Z+1|0;ha=a[Q]|0;do{if((c[v>>2]&1|0)==0){if(ha<<24>>24==40){c[q>>2]=Q;Tb=Q;T=74;break d}else{X=a[Z+1|0]|0;if(X<<24>>24==41){T=265;break d}else{Ub=X;break}}}else{Ub=ha}}while(0);ha=Z+1|0;Q=Ub<<24>>24==0;if(Q){$=5;T=294;break b}else{Wb=381300|0;Xb=0}while(1){X=Xb+1|0;if((a[381296+(Xb<<3)|0]|0)==Ub<<24>>24){Yb=Wb;break}Y=381300+(X<<3)|0;if((X|0)==12){Yb=Y;break}else{Wb=Y;Xb=X}}X=c[Yb>>2]|0;if((X|0)!=0){Y=F+0|0;Ra=G+0|0;_=Y+40|0;do{c[Y>>2]=c[Ra>>2];Y=Y+4|0;Ra=Ra+4|0}while((Y|0)<(_|0));c[H>>2]=X;c[I>>2]=1;Ra=q3c(j)|0;if((Ra|0)!=0){$=Ra;T=294;break b}c[q>>2]=(c[q>>2]|0)+2;c[x>>2]=c[J>>2];U=M;V=c[K>>2]|0;W=0;break c}if(Q){$=5;T=294;break b}c[q>>2]=ha;Ra=a[ha]|0;k:do{switch(Ra|0){case 98:{Y=c[w>>2]|0;_=H3c(Y,0,0,1,32)|0;gb=_;do{if((_|0)==0){Zb=0}else{fb=H3c(Y,0,0,1,20)|0;c[_+4>>2]=fb;if((fb|0)==0){Zb=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=64;c[fb+8>>2]=-1;Zb=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=Zb;break};case 66:{gb=c[w>>2]|0;_=H3c(gb,0,0,1,32)|0;Y=_;do{if((_|0)==0){$b=0}else{fb=H3c(gb,0,0,1,20)|0;c[_+4>>2]=fb;if((fb|0)==0){$b=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=128;c[fb+8>>2]=-1;$b=Y}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=$b;break};case 60:{Y=c[w>>2]|0;_=H3c(Y,0,0,1,32)|0;gb=_;do{if((_|0)==0){ac=0}else{fb=H3c(Y,0,0,1,20)|0;c[_+4>>2]=fb;if((fb|0)==0){ac=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=16;c[fb+8>>2]=-1;ac=gb}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=ac;break};case 62:{gb=c[w>>2]|0;_=H3c(gb,0,0,1,32)|0;Y=_;do{if((_|0)==0){bc=0}else{fb=H3c(gb,0,0,1,20)|0;c[_+4>>2]=fb;if((fb|0)==0){bc=0;break}c[_>>2]=0;c[_+8>>2]=-1;c[_+12>>2]=-1;c[fb>>2]=-2;c[fb+4>>2]=32;c[fb+8>>2]=-1;bc=Y}}while(0);c[q>>2]=(c[q>>2]|0)+1;_b=bc;break};case 120:{Y=Z+2|0;c[q>>2]=Y;_=a[Y]|0;if(_<<24>>24==123){Y=Z+3|0;c[q>>2]=Y;gb=Y;Y=0;while(1){fb=a[gb]|0;if(fb<<24>>24==0|fb<<24>>24==125){dc=Y;ec=gb;break}if((d3c(fb<<24>>24)|0)==0){$=9;T=294;break b}fb=c[q>>2]|0;a[l+Y|0]=a[fb]|0;eb=Y+1|0;ga=fb+1|0;c[q>>2]=ga;if(eb>>>0>31){dc=eb;ec=ga;break}else{gb=ga;Y=eb}}c[q>>2]=ec+1;a[l+dc|0]=0;Y=Vb(C|0,0,16)|0;gb=c[w>>2]|0;eb=c[x>>2]|0;ga=H3c(gb,0,0,1,32)|0;fb=ga;do{if((ga|0)==0){fc=0}else{Ga=H3c(gb,0,0,1,20)|0;c[ga+4>>2]=Ga;if((Ga|0)==0){fc=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Ga>>2]=Y;c[Ga+4>>2]=Y;c[Ga+8>>2]=eb;fc=fb}}while(0);c[x>>2]=(c[x>>2]|0)+1;_b=fc;break k}else{a[D+0|0]=0;a[D+1|0]=0;a[D+2|0]=0;fb=(d3c(_<<24>>24)|0)==0;eb=c[q>>2]|0;if(fb){gc=eb}else{a[D]=a[eb]|0;fb=eb+1|0;c[q>>2]=fb;gc=fb}if((d3c(a[gc]|0)|0)!=0){fb=c[q>>2]|0;a[E]=a[fb]|0;c[q>>2]=fb+1}fb=Vb(D|0,0,16)|0;eb=c[w>>2]|0;Y=c[x>>2]|0;ga=H3c(eb,0,0,1,32)|0;gb=ga;do{if((ga|0)==0){hc=0}else{Ga=H3c(eb,0,0,1,20)|0;c[ga+4>>2]=Ga;if((Ga|0)==0){hc=0;break}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[Ga>>2]=fb;c[Ga+4>>2]=fb;c[Ga+8>>2]=Y;hc=gb}}while(0);c[x>>2]=(c[x>>2]|0)+1;_b=hc;break k}break};default:{if((Y2c(Ra)|0)!=0){gb=(a[c[q>>2]|0]|0)+ -48|0;Y=c[w>>2]|0;fb=c[x>>2]|0;ga=H3c(Y,0,0,1,32)|0;if((ga|0)==0){$=12;T=294;break b}eb=H3c(Y,0,0,1,20)|0;c[ga+4>>2]=eb;if((eb|0)==0){$=12;T=294;break b}c[ga>>2]=0;c[ga+8>>2]=-1;c[ga+12>>2]=-1;c[eb>>2]=-4;c[eb+4>>2]=gb;c[eb+8>>2]=fb;c[x>>2]=(c[x>>2]|0)+1;fb=c[B>>2]|0;c[B>>2]=(gb|0)<(fb|0)?fb:gb;c[q>>2]=(c[q>>2]|0)+1;U=M;V=ga;W=0;break c}ga=c[w>>2]|0;gb=a[c[q>>2]|0]|0;fb=c[x>>2]|0;eb=H3c(ga,0,0,1,32)|0;Y=eb;do{if((eb|0)==0){ic=0}else{_=H3c(ga,0,0,1,20)|0;c[eb+4>>2]=_;if((_|0)==0){ic=0;break}c[eb>>2]=0;c[eb+8>>2]=-1;c[eb+12>>2]=-1;c[_>>2]=gb;c[_+4>>2]=gb;c[_+8>>2]=fb;ic=Y}}while(0);c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+1;_b=ic}}}while(0);if((_b|0)==0){$=12;T=294;break b}else{U=M;V=_b;W=0;break c}break};default:{}}}while(0);if((T|0)==74){T=0;aa=M+1|0;c[q>>2]=Tb+1;Ra=x3c(m,c[y>>2]|0)|0;if((Ra|0)!=0){R=aa;S=Ra;T=6;break b}Ra=x3c(m,2)|0;if((Ra|0)!=0){R=aa;S=Ra;T=6;break b}Ra=x3c(m,0)|0;if((Ra|0)!=0){R=aa;S=Ra;T=6;break b}c[y>>2]=(c[y>>2]|0)+1;U=aa;V=N;W=0;break c}else if((T|0)==264){T=0;if((c[v>>2]&1|0)!=0){T=265}}if((T|0)==265){T=0;aa=c[w>>2]|0;Ra=H3c(aa,0,0,1,32)|0;if((Ra|0)==0){$=12;T=294;break b}ha=H3c(aa,0,0,1,20)|0;c[Ra+4>>2]=ha;if((ha|0)==0){$=12;T=294;break b}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[ha>>2]=-1;c[ha+4>>2]=-1;c[ha+8>>2]=-1;U=M;V=Ra;W=0;break c}Ra=l3c(h,Z,-1)|0;if((Ra|0)<0){c[h>>2]=-1;jc=1}else{jc=Ra}do{if((c[v>>2]&2|0)==0){T=280}else{if((c3c(c[h>>2]|0)|0)==0){if((_2c(c[h>>2]|0)|0)==0){T=280;break}}Ra=c[w>>2]|0;ha=e3c(c[h>>2]|0)|0;aa=e3c(c[h>>2]|0)|0;Q=c[x>>2]|0;X=H3c(Ra,0,0,1,32)|0;if((X|0)==0){$=12;T=294;break b}Y=H3c(Ra,0,0,1,20)|0;c[X+4>>2]=Y;if((Y|0)==0){$=12;T=294;break b}c[X>>2]=0;c[X+8>>2]=-1;c[X+12>>2]=-1;c[Y>>2]=ha;c[Y+4>>2]=aa;c[Y+8>>2]=Q;Q=c[w>>2]|0;Y=g3c(c[h>>2]|0)|0;aa=g3c(c[h>>2]|0)|0;ha=c[x>>2]|0;Ra=H3c(Q,0,0,1,32)|0;if((Ra|0)==0){$=12;T=294;break b}fb=H3c(Q,0,0,1,20)|0;c[Ra+4>>2]=fb;if((fb|0)==0){$=12;T=294;break b}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[fb>>2]=Y;c[fb+4>>2]=aa;c[fb+8>>2]=ha;ha=c[w>>2]|0;fb=H3c(ha,0,0,1,32)|0;if((fb|0)==0){$=12;T=294;break b}aa=H3c(ha,0,0,1,8)|0;ha=fb+4|0;c[ha>>2]=aa;if((aa|0)==0){$=12;T=294;break b}c[fb>>2]=3;c[fb+8>>2]=-1;c[fb+12>>2]=-1;c[aa>>2]=X;c[(c[ha>>2]|0)+4>>2]=Ra;c[fb+16>>2]=(c[Ra+16>>2]|0)+(c[X+16>>2]|0);kc=fb}}while(0);if((T|0)==280){T=0;Z=c[w>>2]|0;fb=c[h>>2]|0;X=c[x>>2]|0;Ra=H3c(Z,0,0,1,32)|0;if((Ra|0)==0){$=12;T=294;break b}ha=H3c(Z,0,0,1,20)|0;c[Ra+4>>2]=ha;if((ha|0)==0){$=12;T=294;break b}c[Ra>>2]=0;c[Ra+8>>2]=-1;c[Ra+12>>2]=-1;c[ha>>2]=fb;c[ha+4>>2]=fb;c[ha+8>>2]=X;kc=Ra}c[x>>2]=(c[x>>2]|0)+1;c[q>>2]=(c[q>>2]|0)+jc;U=M;V=kc;W=0;break};case 3:{Ra=x3c(m,5)|0;if((Ra|0)!=0){R=M;S=Ra;T=6;break b}U=M;V=N;W=x3c(m,4)|0;break};default:{U=M;V=N;W=0}}}while(0);P=c[n>>2]|0;O=(W|0)==0;if((P|0)>(o|0)&O){L=P;M=U;N=V}else{lc=O;mc=U;nc=V;oc=W;break a}}if((T|0)==6){lc=(S|0)==0;mc=R;nc=N;oc=S;break}else if((T|0)==294){i=d;return $|0}}else{lc=t;mc=0;nc=0;oc=p}}while(0);p=(mc|0)>0;if(p|lc^1){$=p?8:oc;i=d;return $|0}c[b+8>>2]=nc;$=0;i=d;return $|0}function r3c(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0;g=i;h=d+12|0;j=c[h>>2]|0;k=(b|0)==0|(f|0)==0;if(!k){c[f+48>>2]=0;c[c[f+36>>2]>>2]=-1}l=c[f+28>>2]|0;m=h4c((l<<3)+8|0)|0;n=m;if((m|0)==0){o=12;i=g;return o|0}c[m>>2]=-1;p=h4c((l<<2)+4|0)|0;if((p|0)==0){i4c(m);o=12;i=g;return o|0}c[p>>2]=-1;q=0;while(1){if(q>>>0>l>>>0){break}else{q=q+1|0}}x3c(d,e)|0;e=x3c(d,0)|0;q=c[h>>2]|0;a:do{if((q|0)>(j|0)&(e|0)==0){l=d+16|0;r=f+32|0;s=f+16|0;t=f+36|0;u=q;v=0;w=-1;x=1;y=0;z=0;A=n;B=0;while(1){C=u+ -1|0;c[h>>2]=C;D=c[l>>2]|0;b:do{switch(c[D+(C<<2)>>2]|0){case 0:{E=u+ -2|0;c[h>>2]=E;F=c[D+(E<<2)>>2]|0;E=F;G=F+12|0;H=c[G>>2]|0;if((H|0)>-1){I=0;do{J=A+(I<<2)|0;I=I+1|0}while((c[J>>2]|0)>-1);c[J>>2]=H<<1;c[A+(I<<2)>>2]=-1;do{if(!k){K=0;while(1){if((c[p+(K<<2)>>2]|0)>-1){K=K+1|0}else{break}}c[(c[s>>2]|0)+(H*12|0)+8>>2]=0;if((K|0)<=0){break}L=h4c((K<<2)+4|0)|0;M=L;if((L|0)==0){N=w;O=y;P=z;Q=A;R=12;S=B;break a}c[(c[s>>2]|0)+(H*12|0)+8>>2]=M;T=c[p>>2]|0;if((T|0)>-1){U=M;V=T;T=0;while(1){c[U>>2]=V;W=T+1|0;X=c[p+(W<<2)>>2]|0;Y=L+(W<<2)|0;if((X|0)>-1){T=W;V=X;U=Y}else{Z=Y;break}}}else{Z=M}c[Z>>2]=-1}}while(0);H=x3c(d,c[G>>2]|0)|0;if((H|0)!=0){N=w;O=y;P=z;Q=A;R=H;S=B;break a}H=x3c(d,6)|0;if((H|0)!=0){N=w;O=y;P=z;Q=A;R=H;S=B;break a}}H=c[F>>2]|0;do{if((H|0)==0){I=c[c[F+4>>2]>>2]|0;if(!((I|0)>-1|(I|0)==-4)){_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}if(!((c[A>>2]|0)>-1)){_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}if(k){c[F+20>>2]=1;fa=w;ga=y;ha=0}else{I=z3c(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){U=c[t>>2]|0;V=0;while(1){ia=U+(V<<2)|0;ja=V+1|0;if((c[ia>>2]|0)>-1){V=ja}else{break}}c[ia>>2]=B;c[U+(ja<<2)>>2]=w;c[U+(V+2<<2)>>2]=-1;ka=-1;la=y+1|0}else{ka=w;la=y}M=c[A>>2]|0;if((M|0)>-1){T=c[s>>2]|0;L=M;M=0;do{K=(L|0)/2|0;if((L&1|0)==0){c[T+(K*12|0)>>2]=B}else{c[T+(K*12|0)+4>>2]=B}M=M+1|0;L=c[A+(M<<2)>>2]|0;}while((L|0)>-1)}c[A>>2]=-1;fa=ka;ga=la;ha=I}c[A>>2]=-1;_=v;$=fa;aa=x+1|0;ba=ga;ca=z+1|0;da=ha;ea=x}else if((H|0)==2){L=c[F+4>>2]|0;if(k){if((c[A>>2]|0)>-1){ma=1}else{ma=a[L+12|0]&1}M=x3c(d,ma)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}}else{M=x3c(d,B)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=x3c(d,a[L+12|0]&1)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}}M=x3c(d,F)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=x3c(d,1)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=x3c(d,c[L>>2]|0)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}M=x3c(d,0)|0;if((M|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=M;ea=B;break}if(!((c[A>>2]|0)>-1)){if((a[L+12|0]&1)==0){_=0;$=w;aa=x;ba=y;ca=z;da=0;ea=B;break}}if(k){na=w;oa=y;pa=0}else{M=z3c(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=(a[L+12|0]&1)==0?v:1;if((w|0)>-1){L=c[t>>2]|0;T=0;while(1){qa=L+(T<<2)|0;ra=T+1|0;if((c[qa>>2]|0)>-1){T=ra}else{break}}c[qa>>2]=B;c[L+(ra<<2)>>2]=w;c[L+(T+2<<2)>>2]=-1;sa=-1;ta=y+1|0}else{sa=w;ta=y}I=c[A>>2]|0;if((I|0)>-1){V=c[s>>2]|0;U=I;I=0;do{K=(U|0)/2|0;if((U&1|0)==0){c[V+(K*12|0)>>2]=B}else{c[V+(K*12|0)+4>>2]=B}I=I+1|0;U=c[A+(I<<2)>>2]|0;}while((U|0)>-1)}c[A>>2]=-1;na=sa;oa=ta;pa=M}c[A>>2]=-1;_=0;$=na;aa=x+1|0;ba=oa;ca=z+1|0;da=pa;ea=x}else if((H|0)==3){U=c[F+4>>2]|0;I=c[U>>2]|0;V=c[U+4>>2]|0;U=(c[A>>2]|0)>-1;T=x+1|0;L=x3c(d,U?T:x)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=x3c(d,U?x:B)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=x3c(d,A)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=x3c(d,(c[A>>2]|0)>>>31^1)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=x3c(d,F)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}L=V;V=x3c(d,L)|0;if((V|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=V;ea=B;break}V=I;I=x3c(d,V)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=x3c(d,3)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=x3c(d,L)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=x3c(d,0)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=x3c(d,2)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=x3c(d,V)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}I=x3c(d,0)|0;if((I|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=I;ea=B;break}if((c[A>>2]|0)>-1){if(k){ua=w;va=y;wa=0}else{I=z3c(b,E,B)|0;c[(c[r>>2]|0)+(B<<2)>>2]=v;if((w|0)>-1){V=c[t>>2]|0;L=0;while(1){xa=V+(L<<2)|0;ya=L+1|0;if((c[xa>>2]|0)>-1){L=ya}else{break}}c[xa>>2]=B;c[V+(ya<<2)>>2]=w;c[V+(L+2<<2)>>2]=-1;za=-1;Aa=y+1|0}else{za=w;Aa=y}M=c[A>>2]|0;if((M|0)>-1){U=c[s>>2]|0;K=M;M=0;do{Y=(K|0)/2|0;if((K&1|0)==0){c[U+(Y*12|0)>>2]=B}else{c[U+(Y*12|0)+4>>2]=B}M=M+1|0;K=c[A+(M<<2)>>2]|0;}while((K|0)>-1)}c[A>>2]=-1;ua=za;va=Aa;wa=I}c[A>>2]=-1;Ba=ua;Ca=T;Da=va;Ea=z+1|0;Fa=wa;Ga=x}else{Ba=w;Ca=x;Da=y;Ea=z;Fa=0;Ga=B}if((c[F+16>>2]|0)<=0){_=v;$=Ba;aa=Ca;ba=Da;ca=Ea;da=Fa;ea=Ga;break}_=v;$=Ba;aa=Ca+2|0;ba=Da;ca=Ea;da=Fa;ea=Ca+1|0}else if((H|0)==1){K=c[F+4>>2]|0;M=c[K>>2]|0;U=c[K+4>>2]|0;K=x3c(d,F)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=x3c(d,5)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=x3c(d,U)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=x3c(d,0)|0;if((K|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=K;ea=B;break}K=M+20|0;L=x3c(d,(c[K>>2]|0)+x|0)|0;if((L|0)!=0){_=v;$=w;aa=x;ba=y;ca=z;da=L;ea=B;break}if((c[K>>2]|0)>0){K=(c[U+20>>2]|0)>0;Ha=(K&1)+x|0;Ia=K?x:-1}else{Ha=x;Ia=-1}K=x3c(d,Ia)|0;if((K|0)!=0){_=v;$=w;aa=Ha;ba=y;ca=z;da=K;ea=B;break}K=x3c(d,4)|0;if((K|0)!=0){_=v;$=w;aa=Ha;ba=y;ca=z;da=K;ea=B;break}K=x3c(d,M)|0;if((K|0)!=0){_=v;$=w;aa=Ha;ba=y;ca=z;da=K;ea=B;break}_=v;$=w;aa=Ha;ba=y;ca=z;da=x3c(d,0)|0;ea=B}else{_=v;$=w;aa=x;ba=y;ca=z;da=0;ea=B}}while(0);F=c[G>>2]|0;if((F|0)>-1){Ja=0}else{Ka=_;La=$;Ma=aa;Na=ba;Oa=ca;Pa=A;Qa=da;Ra=ea;break b}do{Sa=p+(Ja<<2)|0;Ja=Ja+1|0}while((c[Sa>>2]|0)>-1);c[Sa>>2]=F;c[p+(Ja<<2)>>2]=-1;Ka=_;La=$;Ma=aa;Na=ba;Oa=ca;Pa=A;Qa=da;Ra=ea;break};case 5:{G=u+ -2|0;c[h>>2]=G;H=c[D+(G<<2)>>2]|0;if(!k){Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}G=c[H+4>>2]|0;c[H+20>>2]=(c[(c[G+4>>2]|0)+20>>2]|0)+(c[(c[G>>2]|0)+20>>2]|0);Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break};case 1:{G=u+ -2|0;c[h>>2]=G;H=c[D+(G<<2)>>2]|0;if(k){G=c[(c[c[H+4>>2]>>2]|0)+20>>2]|0;E=u+ -3|0;c[h>>2]=E;c[H+20>>2]=(c[D+(E<<2)>>2]|0)+G;Ka=v;La=-1;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}else{G=u+ -3|0;c[h>>2]=G;E=c[D+(G<<2)>>2]|0;G=u+ -4|0;c[h>>2]=G;H=(E|0)==0;Ka=H&1;La=H?w:c[D+(G<<2)>>2]|0;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break b}break};case 4:{G=u+ -2|0;c[h>>2]=G;H=c[D+(G<<2)>>2]|0;G=u+ -3|0;c[h>>2]=G;Ka=v;La=w;Ma=c[D+(G<<2)>>2]|0;Na=y;Oa=z;Pa=A;Qa=0;Ra=(H|0)>-1?H:B;break};case 2:{H=A;while(1){if((c[H>>2]|0)>-1){H=H+4|0}else{Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=H;Qa=0;Ra=B;break}}break};case 3:{H=c[D+(u+ -2<<2)>>2]|0;F=c[D+(u+ -3<<2)>>2]|0;G=c[D+(u+ -4<<2)>>2]|0;E=u+ -5|0;c[h>>2]=E;if(k){K=c[G+4>>2]|0;M=G+16|0;c[G+20>>2]=(c[(c[K>>2]|0)+20>>2]|0)+(c[D+(E<<2)>>2]|0)+(c[(c[K+4>>2]|0)+20>>2]|0)+((c[M>>2]|0)>0?2:0);Ta=M;Ua=c[h>>2]|0}else{Ta=G+16|0;Ua=E}E=c[D+(Ua+ -1<<2)>>2]|0;G=Ua+ -2|0;c[h>>2]=G;M=c[D+(G<<2)>>2]|0;G=Ua+ -3|0;c[h>>2]=G;K=c[D+(G<<2)>>2]|0;if((c[Ta>>2]|0)<=0){Ka=1;La=w;Ma=x;Na=y;Oa=z;Pa=E;Qa=0;Ra=B;break b}if(k){Va=0}else{A3c(b,H,M)|0;c[(c[r>>2]|0)+(M<<2)>>2]=1;M=A3c(b,F,K)|0;c[(c[r>>2]|0)+(K<<2)>>2]=1;Va=M}Ka=1;La=w;Ma=x;Na=y;Oa=z+2|0;Pa=E;Qa=Va;Ra=B;break};case 6:{E=u+ -2|0;c[h>>2]=E;M=c[D+(E<<2)>>2]|0;E=0;do{Wa=A+(E<<2)|0;E=E+1|0}while((c[Wa>>2]|0)>-1);c[Wa>>2]=M<<1|1;c[A+(E<<2)>>2]=-1;K=0;while(1){if((c[p+(K<<2)>>2]|0)>-1){K=K+1|0}else{break}}c[p+(K+ -1<<2)>>2]=-1;Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B;break};default:{Ka=v;La=w;Ma=x;Na=y;Oa=z;Pa=A;Qa=0;Ra=B}}}while(0);D=c[h>>2]|0;if((D|0)>(j|0)&(Qa|0)==0){u=D;v=Ka;w=La;x=Ma;y=Na;z=Oa;A=Pa;B=Ra}else{N=La;O=Na;P=Oa;Q=Pa;R=Qa;S=Ra;break a}}}else{N=-1;O=0;P=0;Q=n;R=e;S=0}}while(0);do{if(k){Xa=O}else{e=c[Q>>2]|0;if((e|0)>-1){n=c[f+16>>2]|0;Ra=e;e=0;do{Qa=(Ra|0)/2|0;if((Ra&1|0)==0){c[n+(Qa*12|0)>>2]=S}else{c[n+(Qa*12|0)+4>>2]=S}e=e+1|0;Ra=c[Q+(e<<2)>>2]|0;}while((Ra|0)>-1)}c[Q>>2]=-1;if(!((N|0)>-1)){Xa=O;break}Ra=c[f+36>>2]|0;e=0;while(1){Ya=Ra+(e<<2)|0;Za=e+1|0;if((c[Ya>>2]|0)>-1){e=Za}else{break}}c[Ya>>2]=S;c[Ra+(Za<<2)>>2]=N;c[Ra+(e+2<<2)>>2]=-1;Xa=O+1|0}}while(0);c[f+48>>2]=P;c[f+40>>2]=P;c[f+44>>2]=Xa;i4c(m);i4c(p);o=R;i=g;return o|0}function s3c(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;f=i;g=a;a:while(1){a=c[g>>2]|0;do{if((a|0)==2){h=c[g+4>>2]|0;j=h;if(!((c[h+8>>2]|0)==-1)){k=j;break}l=c[h>>2]|0;h=u3c(c[l+28>>2]|0,c[l+24>>2]|0,b,d,e)|0;if((h|0)==0){k=j}else{m=h;n=10;break a}}else if((a|0)==3){h=c[g+4>>2]|0;j=s3c(c[h>>2]|0,b,d,e)|0;if((j|0)!=0){m=j;n=10;break a}k=h+4|0}else if((a|0)==1){h=c[g+4>>2]|0;j=h+4|0;l=u3c(c[(c[h>>2]|0)+28>>2]|0,c[(c[j>>2]|0)+24>>2]|0,b,d,e)|0;if((l|0)!=0){m=l;n=10;break a}l=s3c(c[h>>2]|0,b,d,e)|0;if((l|0)==0){k=j}else{m=l;n=10;break a}}else{m=0;n=10;break a}}while(0);g=c[k>>2]|0}if((n|0)==10){i=f;return m|0}return 0}function t3c(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=c[a+4>>2]|0;if((d|0)==0){i=b;return}a=d+4|0;e=c[d>>2]|0;if((c[a>>2]|0)==0){f=e}else{g=e;e=0;while(1){do{if((c[g+(e<<5)+8>>2]|0)==0){h=g}else{j=c[g+(e<<5)+16>>2]|0;if((j|0)==0){k=g}else{i4c(j);k=c[d>>2]|0}j=c[k+(e<<5)+28>>2]|0;if((j|0)==0){h=k;break}i4c(j);h=c[d>>2]|0}}while(0);j=e+1|0;if(j>>>0<(c[a>>2]|0)>>>0){g=h;e=j}else{f=h;break}}}if((f|0)!=0){i4c(f)}f=d+8|0;h=c[f>>2]|0;if((h|0)!=0){if((c[h+8>>2]|0)==0){l=h}else{e=h;while(1){h=c[e+16>>2]|0;if((h|0)!=0){i4c(h)}if((c[e+40>>2]|0)==0){break}else{e=e+32|0}}l=c[f>>2]|0}i4c(l)}l=d+16|0;f=c[l>>2]|0;if((f|0)!=0){e=d+28|0;h=c[e>>2]|0;if((h|0)==0){m=f}else{g=h;h=f;f=0;while(1){a=c[h+(f*12|0)+8>>2]|0;if((a|0)==0){n=h;o=g}else{i4c(a);n=c[l>>2]|0;o=c[e>>2]|0}a=f+1|0;if(a>>>0<o>>>0){g=o;h=n;f=a}else{m=n;break}}}i4c(m)}m=c[d+32>>2]|0;if((m|0)!=0){i4c(m)}m=c[d+20>>2]|0;if((m|0)!=0){i4c(m)}m=c[d+36>>2]|0;if((m|0)!=0){i4c(m)}i4c(d);i=b;return}



function j9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87224,cCc(+h[(c[g>>2]|0)+44232>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87216]=1;i=d;return}function k9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87320]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87328,cCc(+h[(c[g>>2]|0)+44224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87320]=1;i=d;return}function l9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87432]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87440,cCc(+h[(c[g>>2]|0)+44216>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87432]=1;i=d;return}function m9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87544,cCc(+h[(c[g>>2]|0)+44208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87536]=1;i=d;return}function n9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87664,cCc(+h[(c[g>>2]|0)+44200>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87656]=1;i=d;return}function o9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87784]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1184>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(87792,eCc(c[(c[g>>2]|0)+1184>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87784]=1;i=d;return}function p9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87984]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1180>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(87992,eCc(c[(c[g>>2]|0)+1180>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[87984]=1;i=d;return}function q9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88184]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1176>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(88192,eCc(c[(c[g>>2]|0)+1176>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88184]=1;i=d;return}function r9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88384]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(88392,eCc(c[(c[g>>2]|0)+1172>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88384]=1;i=d;return}function s9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88560]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1168>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(88568,eCc(c[(c[g>>2]|0)+1168>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88560]=1;i=d;return}function t9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88736]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1164>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(88744,eCc(c[(c[g>>2]|0)+1164>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[88736]=1;i=d;return}function u9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[88912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(88920,cCc(+h[(c[g>>2]|0)+44184>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[88912]=1;i=d;return}function v9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(89040,cCc(+h[(c[g>>2]|0)+44176>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[89032]=1;i=d;return}function w9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(89168,cCc(+h[(c[g>>2]|0)+44168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[89160]=1;i=d;return}function x9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89304]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(89312,cCc(+h[(c[g>>2]|0)+44160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[89304]=1;i=d;return}function y9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89448]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(89456,eCc(c[(c[g>>2]|0)+1160>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89448]=1;i=d;return}function z9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89664]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1156>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(89672,eCc(c[(c[g>>2]|0)+1156>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89664]=1;i=d;return}function A9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[89880]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1152>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(89888,eCc(c[(c[g>>2]|0)+1152>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[89880]=1;i=d;return}function B9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90096]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(90104,eCc(c[(c[g>>2]|0)+1148>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90096]=1;i=d;return}function C9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90288]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(90296,eCc(c[(c[g>>2]|0)+1144>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90288]=1;i=d;return}function D9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90480]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1140>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(90488,eCc(c[(c[g>>2]|0)+1140>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[90480]=1;i=d;return}function E9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44152>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(90680,cCc(+h[(c[g>>2]|0)+44152>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[90672]=1;i=d;return}function F9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90816]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44144>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(90824,cCc(+h[(c[g>>2]|0)+44144>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[90816]=1;i=d;return}function G9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[90960]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44136>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(90968,cCc(+h[(c[g>>2]|0)+44136>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[90960]=1;i=d;return}function H9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91104]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91112,cCc(+h[(c[g>>2]|0)+44128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91104]=1;i=d;return}function I9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91232,cCc(+h[(c[g>>2]|0)+44120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91224]=1;i=d;return}function J9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91352,cCc(+h[(c[g>>2]|0)+44112>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91344]=1;i=d;return}function K9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91464]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44104>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91472,cCc(+h[(c[g>>2]|0)+44104>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91464]=1;i=d;return}function L9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91576]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91584,cCc(+h[(c[g>>2]|0)+44096>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91576]=1;i=d;return}function M9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91680]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91688,cCc(+h[(c[g>>2]|0)+44088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91680]=1;i=d;return}function N9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91840,cCc(+h[(c[g>>2]|0)+44080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91832]=1;i=d;return}function O9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[91976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(91984,cCc(+h[(c[g>>2]|0)+44056>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[91976]=1;i=d;return}function P9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(92088,cCc(+h[(c[g>>2]|0)+44048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[92080]=1;i=d;return}function Q9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92192]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(92200,cCc(+h[(c[g>>2]|0)+44040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[92192]=1;i=d;return}function R9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(92304,cCc(+h[(c[g>>2]|0)+44032>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[92296]=1;i=d;return}function S9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(92416,cCc(+h[(c[g>>2]|0)+44024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[92408]=1;i=d;return}function T9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92536]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(92544,eCc(c[(c[g>>2]|0)+1136>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92536]=1;i=d;return}function U9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92736]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1132>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(92744,eCc(c[(c[g>>2]|0)+1132>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92736]=1;i=d;return}function V9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[92936]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1128>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(92944,eCc(c[(c[g>>2]|0)+1128>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[92936]=1;i=d;return}function W9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93136]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(93144,eCc(c[(c[g>>2]|0)+1124>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93136]=1;i=d;return}function X9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93312]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1120>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(93320,eCc(c[(c[g>>2]|0)+1120>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93312]=1;i=d;return}function Y9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93488]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1116>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(93496,eCc(c[(c[g>>2]|0)+1116>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[93488]=1;i=d;return}function Z9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(93672,cCc(+h[(c[g>>2]|0)+44008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[93664]=1;i=d;return}function _9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(93792,cCc(+h[(c[g>>2]|0)+44e3>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[93784]=1;i=d;return}function $9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[93904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(93912,cCc(+h[(c[g>>2]|0)+43992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[93904]=1;i=d;return}function aac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(94056,cCc(+h[(c[g>>2]|0)+43984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[94048]=1;i=d;return}function bac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94192]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(94200,eCc(c[(c[g>>2]|0)+1112>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94192]=1;i=d;return}function cac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94408]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1108>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(94416,eCc(c[(c[g>>2]|0)+1108>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94408]=1;i=d;return}function dac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94624]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1104>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(94632,eCc(c[(c[g>>2]|0)+1104>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94624]=1;i=d;return}function eac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[94840]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(94848,eCc(c[(c[g>>2]|0)+1100>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[94840]=1;i=d;return}function fac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95032]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1096>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1096>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(95040,eCc(c[(c[g>>2]|0)+1096>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95032]=1;i=d;return}function gac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1092>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1092>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(95232,eCc(c[(c[g>>2]|0)+1092>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[95224]=1;i=d;return}function hac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43976>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(95424,cCc(+h[(c[g>>2]|0)+43976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[95416]=1;i=d;return}function iac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43968>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(95568,cCc(+h[(c[g>>2]|0)+43968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[95560]=1;i=d;return}function jac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43960>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(95712,cCc(+h[(c[g>>2]|0)+43960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[95704]=1;i=d;return}function kac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95848]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(95856,cCc(+h[(c[g>>2]|0)+43952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[95848]=1;i=d;return}function lac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[95968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(95976,cCc(+h[(c[g>>2]|0)+43944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[95968]=1;i=d;return}function mac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96088]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96096,cCc(+h[(c[g>>2]|0)+43936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96088]=1;i=d;return}function nac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96216,cCc(+h[(c[g>>2]|0)+43928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96208]=1;i=d;return}function oac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96320]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96328,cCc(+h[(c[g>>2]|0)+43920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96320]=1;i=d;return}function pac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96432,cCc(+h[(c[g>>2]|0)+43912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96424]=1;i=d;return}function qac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96576]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96584,cCc(+h[(c[g>>2]|0)+43904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96576]=1;i=d;return}function rac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96720]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96728,cCc(+h[(c[g>>2]|0)+43880>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96720]=1;i=d;return}function sac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96832,cCc(+h[(c[g>>2]|0)+43872>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96824]=1;i=d;return}function tac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[96936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(96944,cCc(+h[(c[g>>2]|0)+43864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[96936]=1;i=d;return}function uac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(97048,cCc(+h[(c[g>>2]|0)+43856>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[97040]=1;i=d;return}function vac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97152]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(97160,cCc(+h[(c[g>>2]|0)+43848>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[97152]=1;i=d;return}function wac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97280]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1088>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1088>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(97288,eCc(c[(c[g>>2]|0)+1088>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97280]=1;i=d;return}function xac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97480]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1084>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1084>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(97488,eCc(c[(c[g>>2]|0)+1084>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97480]=1;i=d;return}function yac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97680]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1080>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1080>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(97688,eCc(c[(c[g>>2]|0)+1080>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97680]=1;i=d;return}function zac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[97880]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1076>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1076>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(97888,eCc(c[(c[g>>2]|0)+1076>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[97880]=1;i=d;return}function Aac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1072>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1072>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(98064,eCc(c[(c[g>>2]|0)+1072>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98056]=1;i=d;return}function Bac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98232]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1068>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1068>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(98240,eCc(c[(c[g>>2]|0)+1068>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[98232]=1;i=d;return}function Cac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(98416,cCc(+h[(c[g>>2]|0)+43832>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[98408]=1;i=d;return}function Dac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98528]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(98536,cCc(+h[(c[g>>2]|0)+43824>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[98528]=1;i=d;return}function Eac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98648]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(98656,cCc(+h[(c[g>>2]|0)+43808>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[98648]=1;i=d;return}function Fac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98768]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(98776,cCc(+h[(c[g>>2]|0)+43800>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[98768]=1;i=d;return}function Gac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[98888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(98896,cCc(+h[(c[g>>2]|0)+43776>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[98888]=1;i=d;return}function Hac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(99032,cCc(+h[(c[g>>2]|0)+43768>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[99024]=1;i=d;return}function Iac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99160]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1064>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1064>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(99168,eCc(c[(c[g>>2]|0)+1064>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99160]=1;i=d;return}function Jac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99360]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1060>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1060>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(99368,eCc(c[(c[g>>2]|0)+1060>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99360]=1;i=d;return}function Kac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99560]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1056>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1056>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(99568,eCc(c[(c[g>>2]|0)+1056>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99560]=1;i=d;return}function Lac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99760]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1052>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1052>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(99768,eCc(c[(c[g>>2]|0)+1052>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99760]=1;i=d;return}function Mac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[99944]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1048>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1048>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(99952,eCc(c[(c[g>>2]|0)+1048>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[99944]=1;i=d;return}function Nac(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100128]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1044>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1044>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(100136,eCc(c[(c[g>>2]|0)+1044>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[100128]=1;i=d;return}function Oac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43760>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(100320,cCc(+h[(c[g>>2]|0)+43760>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[100312]=1;i=d;return}function Pac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100448]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43752>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(100456,cCc(+h[(c[g>>2]|0)+43752>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[100448]=1;i=d;return}function Qac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43744>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(100592,cCc(+h[(c[g>>2]|0)+43744>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[100584]=1;i=d;return}function Rac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100720]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(100728,cCc(+h[(c[g>>2]|0)+43736>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[100720]=1;i=d;return}function Sac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(100840,cCc(+h[(c[g>>2]|0)+43728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[100832]=1;i=d;return}function Tac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[100944]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(100952,cCc(+h[(c[g>>2]|0)+43720>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[100944]=1;i=d;return}function Uac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101056]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101064,cCc(+h[(c[g>>2]|0)+43712>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101056]=1;i=d;return}function Vac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101176,cCc(+h[(c[g>>2]|0)+43704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101168]=1;i=d;return}function Wac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101264]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101272,cCc(+h[(c[g>>2]|0)+43696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101264]=1;i=d;return}function Xac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101416,cCc(+h[(c[g>>2]|0)+43688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101408]=1;i=d;return}function Yac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101560,cCc(+h[(c[g>>2]|0)+43664>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101552]=1;i=d;return}function Zac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101664,cCc(+h[(c[g>>2]|0)+43656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101656]=1;i=d;return}function _ac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101768]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101776,cCc(+h[(c[g>>2]|0)+43648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101768]=1;i=d;return}function $ac(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101880,cCc(+h[(c[g>>2]|0)+43640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101872]=1;i=d;return}function abc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[101976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(101984,cCc(+h[(c[g>>2]|0)+43632>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[101976]=1;i=d;return}function bbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102096]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1040>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1040>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(102104,eCc(c[(c[g>>2]|0)+1040>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102096]=1;i=d;return}function cbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102288]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1036>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1036>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(102296,eCc(c[(c[g>>2]|0)+1036>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102288]=1;i=d;return}function dbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102480]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1032>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1032>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(102488,eCc(c[(c[g>>2]|0)+1032>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102480]=1;i=d;return}function ebc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102672]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1028>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1028>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(102680,eCc(c[(c[g>>2]|0)+1028>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102672]=1;i=d;return}function fbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[102840]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1024>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1024>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(102848,eCc(c[(c[g>>2]|0)+1024>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[102840]=1;i=d;return}function gbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103008]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1020>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1020>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(103016,eCc(c[(c[g>>2]|0)+1020>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[103008]=1;i=d;return}function hbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103176]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(103184,cCc(+h[(c[g>>2]|0)+43616>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[103176]=1;i=d;return}function ibc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(103296,cCc(+h[(c[g>>2]|0)+43608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[103288]=1;i=d;return}function jbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(103416,cCc(+h[(c[g>>2]|0)+43600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[103408]=1;i=d;return}function kbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(103568,cCc(+h[(c[g>>2]|0)+43592>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[103560]=1;i=d;return}function lbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(103712,cCc(+h[(c[g>>2]|0)+43568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[103704]=1;i=d;return}function mbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103848]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(103856,cCc(+h[(c[g>>2]|0)+43560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[103848]=1;i=d;return}function nbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[103992]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1016>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1016>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(104e3,eCc(c[(c[g>>2]|0)+1016>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[103992]=1;i=d;return}function obc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104208]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1012>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1012>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(104216,eCc(c[(c[g>>2]|0)+1012>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104208]=1;i=d;return}function pbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104424]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1008>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1008>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(104432,eCc(c[(c[g>>2]|0)+1008>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104424]=1;i=d;return}function qbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104640]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1004>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1004>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(104648,eCc(c[(c[g>>2]|0)+1004>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104640]=1;i=d;return}function rbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[104832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1e3>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1e3>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(104840,eCc(c[(c[g>>2]|0)+1e3>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[104832]=1;i=d;return}function sbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105024]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+996>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+996>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(105032,eCc(c[(c[g>>2]|0)+996>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[105024]=1;i=d;return}function tbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43552>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(105224,cCc(+h[(c[g>>2]|0)+43552>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[105216]=1;i=d;return}function ubc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105360]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43544>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(105368,cCc(+h[(c[g>>2]|0)+43544>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[105360]=1;i=d;return}function vbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105504]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43536>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(105512,cCc(+h[(c[g>>2]|0)+43536>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[105504]=1;i=d;return}function wbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105648]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(105656,cCc(+h[(c[g>>2]|0)+43528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[105648]=1;i=d;return}function xbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105768]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(105776,cCc(+h[(c[g>>2]|0)+43520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[105768]=1;i=d;return}function ybc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[105888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(105896,cCc(+h[(c[g>>2]|0)+43512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[105888]=1;i=d;return}function zbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106008]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106016,cCc(+h[(c[g>>2]|0)+43504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106008]=1;i=d;return}function Abc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106120]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106128,cCc(+h[(c[g>>2]|0)+43496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106120]=1;i=d;return}function Bbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106232,cCc(+h[(c[g>>2]|0)+43480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106224]=1;i=d;return}function Cbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106336,cCc(+h[(c[g>>2]|0)+43472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106328]=1;i=d;return}function Dbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106440]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106448,cCc(+h[(c[g>>2]|0)+43464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106440]=1;i=d;return}function Ebc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106552,cCc(+h[(c[g>>2]|0)+43456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106544]=1;i=d;return}function Fbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(106672,cCc(+h[(c[g>>2]|0)+43448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[106664]=1;i=d;return}function Gbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106792]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+992>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+992>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(106800,eCc(c[(c[g>>2]|0)+992>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[106792]=1;i=d;return}function Hbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[106992]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+988>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+988>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(107e3,eCc(c[(c[g>>2]|0)+988>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[106992]=1;i=d;return}function Ibc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107192]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+984>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+984>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(107200,eCc(c[(c[g>>2]|0)+984>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[107192]=1;i=d;return}function Jbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107392]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+980>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+980>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(107400,eCc(c[(c[g>>2]|0)+980>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[107392]=1;i=d;return}function Kbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107568]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+976>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+976>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(107576,eCc(c[(c[g>>2]|0)+976>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[107568]=1;i=d;return}function Lbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107744]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+972>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+972>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(107752,eCc(c[(c[g>>2]|0)+972>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[107744]=1;i=d;return}function Mbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[107920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(107928,cCc(+h[(c[g>>2]|0)+43432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[107920]=1;i=d;return}function Nbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108048,cCc(+h[(c[g>>2]|0)+43424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108040]=1;i=d;return}function Obc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108176,cCc(+h[(c[g>>2]|0)+43416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108168]=1;i=d;return}function Pbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108304,cCc(+h[(c[g>>2]|0)+43408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108296]=1;i=d;return}function Qbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108424,cCc(+h[(c[g>>2]|0)+43384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108416]=1;i=d;return}function Rbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108552,cCc(+h[(c[g>>2]|0)+43376>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108544]=1;i=d;return}function Sbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108672,cCc(+h[(c[g>>2]|0)+43368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108664]=1;i=d;return}function Tbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(108800,cCc(+h[(c[g>>2]|0)+43360>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[108792]=1;i=d;return}function Ubc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[108912]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2028>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2028>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(108920,eCc(c[(c[g>>2]|0)+2028>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[108912]=1;i=d;return}function Vbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(109104,cCc(+h[(c[g>>2]|0)+43336>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[109096]=1;i=d;return}function Wbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(109232,cCc(+h[(c[g>>2]|0)+43328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[109224]=1;i=d;return}function Xbc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109344]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2024>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2024>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(109352,eCc(c[(c[g>>2]|0)+2024>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=211424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[109344]=1;i=d;return}function Ybc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(109552,cCc(+h[(c[g>>2]|0)+43224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=176904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[109544]=1;i=d;return}function Zbc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(109664,cCc(+h[(c[g>>2]|0)+43208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[109656]=1;i=d;return}function _bc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(109792,cCc(+h[(c[g>>2]|0)+43200>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[109784]=1;i=d;return}function $bc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[109904]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+968>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+968>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(109912,eCc(c[(c[g>>2]|0)+968>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[109904]=1;i=d;return}function acc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110080]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+964>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+964>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(110088,eCc(c[(c[g>>2]|0)+964>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[110080]=1;i=d;return}function bcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110256]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+960>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+960>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(110264,eCc(c[(c[g>>2]|0)+960>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[110256]=1;i=d;return}function ccc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110432]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2020>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2020>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(110440,eCc(c[(c[g>>2]|0)+2020>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[110432]=1;i=d;return}function dcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(110752,cCc(+h[(c[g>>2]|0)+43168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[110744]=1;i=d;return}function ecc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(110880,cCc(+h[(c[g>>2]|0)+43160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[110872]=1;i=d;return}function fcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[110992]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+956>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+956>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(111e3,eCc(c[(c[g>>2]|0)+956>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[110992]=1;i=d;return}function gcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111168]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+952>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+952>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(111176,eCc(c[(c[g>>2]|0)+952>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[111168]=1;i=d;return}function hcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111344]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+948>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+948>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(111352,eCc(c[(c[g>>2]|0)+948>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[111344]=1;i=d;return}function icc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111520]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2016>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2016>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(111528,eCc(c[(c[g>>2]|0)+2016>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[111520]=1;i=d;return}function jcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(111840,cCc(+h[(c[g>>2]|0)+43128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[111832]=1;i=d;return}function kcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[111976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(111984,cCc(+h[(c[g>>2]|0)+43120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[111976]=1;i=d;return}function lcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112112]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+944>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+944>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(112120,eCc(c[(c[g>>2]|0)+944>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[112112]=1;i=d;return}function mcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112312]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+940>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+940>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(112320,eCc(c[(c[g>>2]|0)+940>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[112312]=1;i=d;return}function ncc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112512]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+936>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+936>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(112520,eCc(c[(c[g>>2]|0)+936>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[112512]=1;i=d;return}function occ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[112712]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2012>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2012>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(112720,eCc(c[(c[g>>2]|0)+2012>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[112712]=1;i=d;return}function pcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(113056,cCc(+h[(c[g>>2]|0)+43088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[113048]=1;i=d;return}function qcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(113168,cCc(+h[(c[g>>2]|0)+43080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[113160]=1;i=d;return}function rcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113264]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(113272,cCc(+h[(c[g>>2]|0)+43056>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[113264]=1;i=d;return}function scc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(113424,cCc(+h[(c[g>>2]|0)+43048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[113416]=1;i=d;return}function tcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(113568,cCc(+h[(c[g>>2]|0)+43024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[113560]=1;i=d;return}function ucc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(113712,cCc(+h[(c[g>>2]|0)+43016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[113704]=1;i=d;return}function vcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[113848]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+932>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+932>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(113856,eCc(c[(c[g>>2]|0)+932>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[113848]=1;i=d;return}function wcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114064]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+928>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+928>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(114072,eCc(c[(c[g>>2]|0)+928>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[114064]=1;i=d;return}function xcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114280]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+924>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+924>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(114288,eCc(c[(c[g>>2]|0)+924>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[114280]=1;i=d;return}function ycc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114496]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+920>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+920>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(114504,eCc(c[(c[g>>2]|0)+920>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[114496]=1;i=d;return}function zcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114688]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+916>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+916>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(114696,eCc(c[(c[g>>2]|0)+916>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[114688]=1;i=d;return}function Acc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[114880]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+912>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+912>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(114888,eCc(c[(c[g>>2]|0)+912>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[114880]=1;i=d;return}function Bcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43008>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(115080,cCc(+h[(c[g>>2]|0)+43008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115072]=1;i=d;return}function Ccc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+43e3>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(115224,cCc(+h[(c[g>>2]|0)+43e3>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115216]=1;i=d;return}function Dcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115360]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42992>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(115368,cCc(+h[(c[g>>2]|0)+42992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115360]=1;i=d;return}function Ecc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115504]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(115512,cCc(+h[(c[g>>2]|0)+42984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115504]=1;i=d;return}function Fcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115624]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(115632,cCc(+h[(c[g>>2]|0)+42976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115624]=1;i=d;return}function Gcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(115752,cCc(+h[(c[g>>2]|0)+42968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115744]=1;i=d;return}function Hcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115864]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(115872,cCc(+h[(c[g>>2]|0)+42960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115864]=1;i=d;return}function Icc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[115976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(115984,cCc(+h[(c[g>>2]|0)+42952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[115976]=1;i=d;return}function Jcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(116088,cCc(+h[(c[g>>2]|0)+42936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[116080]=1;i=d;return}function Kcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116184]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(116192,cCc(+h[(c[g>>2]|0)+42928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[116184]=1;i=d;return}function Lcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(116304,cCc(+h[(c[g>>2]|0)+42920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[116296]=1;i=d;return}function Mcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(116408,cCc(+h[(c[g>>2]|0)+42912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[116400]=1;i=d;return}function Ncc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116520]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(116528,cCc(+h[(c[g>>2]|0)+42904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[116520]=1;i=d;return}function Occ(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116648]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+908>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+908>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(116656,eCc(c[(c[g>>2]|0)+908>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[116648]=1;i=d;return}function Pcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[116848]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+904>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+904>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(116856,eCc(c[(c[g>>2]|0)+904>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[116848]=1;i=d;return}function Qcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117048]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+900>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+900>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(117056,eCc(c[(c[g>>2]|0)+900>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[117048]=1;i=d;return}function Rcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117248]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+896>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+896>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(117256,eCc(c[(c[g>>2]|0)+896>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[117248]=1;i=d;return}function Scc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117424]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+892>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+892>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(117432,eCc(c[(c[g>>2]|0)+892>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[117424]=1;i=d;return}function Tcc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117600]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+888>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+888>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(117608,eCc(c[(c[g>>2]|0)+888>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[117600]=1;i=d;return}function Ucc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(117784,cCc(+h[(c[g>>2]|0)+42888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[117776]=1;i=d;return}function Vcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[117896]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(117904,cCc(+h[(c[g>>2]|0)+42880>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[117896]=1;i=d;return}function Wcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(118032,cCc(+h[(c[g>>2]|0)+42872>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[118024]=1;i=d;return}function Xcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118176]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(118184,cCc(+h[(c[g>>2]|0)+42864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[118176]=1;i=d;return}function Ycc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118320]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(118328,cCc(+h[(c[g>>2]|0)+42840>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[118320]=1;i=d;return}function Zcc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118464]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(118472,cCc(+h[(c[g>>2]|0)+42832>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[118464]=1;i=d;return}function _cc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118608]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+884>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+884>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(118616,eCc(c[(c[g>>2]|0)+884>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[118608]=1;i=d;return}function $cc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[118824]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+880>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+880>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(118832,eCc(c[(c[g>>2]|0)+880>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[118824]=1;i=d;return}function adc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119040]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+876>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+876>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(119048,eCc(c[(c[g>>2]|0)+876>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[119040]=1;i=d;return}function bdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119256]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+872>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+872>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(119264,eCc(c[(c[g>>2]|0)+872>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[119256]=1;i=d;return}function cdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119448]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+868>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+868>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(119456,eCc(c[(c[g>>2]|0)+868>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[119448]=1;i=d;return}function ddc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119640]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+864>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+864>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(119648,eCc(c[(c[g>>2]|0)+864>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[119640]=1;i=d;return}function edc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42824>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(119840,cCc(+h[(c[g>>2]|0)+42824>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[119832]=1;i=d;return}function fdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[119976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42816>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(119984,cCc(+h[(c[g>>2]|0)+42816>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[119976]=1;i=d;return}function gdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120120]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42808>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(120128,cCc(+h[(c[g>>2]|0)+42808>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120120]=1;i=d;return}function hdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120264]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120272,cCc(+h[(c[g>>2]|0)+42800>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120264]=1;i=d;return}function idc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120384]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120392,cCc(+h[(c[g>>2]|0)+42792>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120384]=1;i=d;return}function jdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120504]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120512,cCc(+h[(c[g>>2]|0)+42784>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120504]=1;i=d;return}function kdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120624]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120632,cCc(+h[(c[g>>2]|0)+42776>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120624]=1;i=d;return}function ldc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120736]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120744,cCc(+h[(c[g>>2]|0)+42768>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120736]=1;i=d;return}function mdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120848,cCc(+h[(c[g>>2]|0)+42752>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120840]=1;i=d;return}function ndc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[120944]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(120952,cCc(+h[(c[g>>2]|0)+42744>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[120944]=1;i=d;return}function odc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121056]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(121064,cCc(+h[(c[g>>2]|0)+42736>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[121056]=1;i=d;return}function pdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(121168,cCc(+h[(c[g>>2]|0)+42728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[121160]=1;i=d;return}function qdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(121288,cCc(+h[(c[g>>2]|0)+42720>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[121280]=1;i=d;return}



function rdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121408]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+860>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+860>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(121416,eCc(c[(c[g>>2]|0)+860>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[121408]=1;i=d;return}function sdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121608]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+856>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+856>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(121616,eCc(c[(c[g>>2]|0)+856>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[121608]=1;i=d;return}function tdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[121808]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+852>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+852>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(121816,eCc(c[(c[g>>2]|0)+852>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[121808]=1;i=d;return}function udc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122008]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+848>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+848>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(122016,eCc(c[(c[g>>2]|0)+848>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[122008]=1;i=d;return}function vdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122184]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+844>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+844>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(122192,eCc(c[(c[g>>2]|0)+844>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[122184]=1;i=d;return}function wdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122360]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+840>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+840>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(122368,eCc(c[(c[g>>2]|0)+840>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[122360]=1;i=d;return}function xdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(122544,cCc(+h[(c[g>>2]|0)+42704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[122536]=1;i=d;return}function ydc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(122664,cCc(+h[(c[g>>2]|0)+42696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[122656]=1;i=d;return}function zdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(122792,cCc(+h[(c[g>>2]|0)+42688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[122784]=1;i=d;return}function Adc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[122928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(122936,cCc(+h[(c[g>>2]|0)+42680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[122928]=1;i=d;return}function Bdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123072]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+836>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+836>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(123080,eCc(c[(c[g>>2]|0)+836>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[123072]=1;i=d;return}function Cdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123288]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+832>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+832>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(123296,eCc(c[(c[g>>2]|0)+832>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[123288]=1;i=d;return}function Ddc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123504]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+828>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+828>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(123512,eCc(c[(c[g>>2]|0)+828>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[123504]=1;i=d;return}function Edc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123720]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+824>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+824>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(123728,eCc(c[(c[g>>2]|0)+824>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[123720]=1;i=d;return}function Fdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[123912]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+820>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+820>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(123920,eCc(c[(c[g>>2]|0)+820>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[123912]=1;i=d;return}function Gdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124104]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+816>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+816>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(124112,eCc(c[(c[g>>2]|0)+816>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[124104]=1;i=d;return}function Hdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42672>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(124304,cCc(+h[(c[g>>2]|0)+42672>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[124296]=1;i=d;return}function Idc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124440]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42664>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(124448,cCc(+h[(c[g>>2]|0)+42664>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[124440]=1;i=d;return}function Jdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42656>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(124592,cCc(+h[(c[g>>2]|0)+42656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[124584]=1;i=d;return}function Kdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124728]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(124736,cCc(+h[(c[g>>2]|0)+42648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[124728]=1;i=d;return}function Ldc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124848]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(124856,cCc(+h[(c[g>>2]|0)+42640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[124848]=1;i=d;return}function Mdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[124968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(124976,cCc(+h[(c[g>>2]|0)+42632>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[124968]=1;i=d;return}function Ndc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125088]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125096,cCc(+h[(c[g>>2]|0)+42624>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125088]=1;i=d;return}function Odc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125208,cCc(+h[(c[g>>2]|0)+42616>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125200]=1;i=d;return}function Pdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125304]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125312,cCc(+h[(c[g>>2]|0)+42608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125304]=1;i=d;return}function Qdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125464,cCc(+h[(c[g>>2]|0)+42600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125456]=1;i=d;return}function Rdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125608,cCc(+h[(c[g>>2]|0)+42576>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125600]=1;i=d;return}function Sdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125712,cCc(+h[(c[g>>2]|0)+42568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125704]=1;i=d;return}function Tdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125816]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125824,cCc(+h[(c[g>>2]|0)+42560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125816]=1;i=d;return}function Udc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[125920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(125928,cCc(+h[(c[g>>2]|0)+42552>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[125920]=1;i=d;return}function Vdc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(126040,cCc(+h[(c[g>>2]|0)+42544>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[126032]=1;i=d;return}function Wdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126160]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+812>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+812>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(126168,eCc(c[(c[g>>2]|0)+812>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[126160]=1;i=d;return}function Xdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126360]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+808>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+808>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(126368,eCc(c[(c[g>>2]|0)+808>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[126360]=1;i=d;return}function Ydc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126560]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+804>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+804>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(126568,eCc(c[(c[g>>2]|0)+804>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[126560]=1;i=d;return}function Zdc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126760]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+800>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+800>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(126768,eCc(c[(c[g>>2]|0)+800>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[126760]=1;i=d;return}function _dc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[126936]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+796>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+796>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(126944,eCc(c[(c[g>>2]|0)+796>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[126936]=1;i=d;return}function $dc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127112]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+792>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+792>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(127120,eCc(c[(c[g>>2]|0)+792>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[127112]=1;i=d;return}function aec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(127296,cCc(+h[(c[g>>2]|0)+42528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[127288]=1;i=d;return}function bec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(127416,cCc(+h[(c[g>>2]|0)+42520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[127408]=1;i=d;return}function cec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127528]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(127536,cCc(+h[(c[g>>2]|0)+42512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[127528]=1;i=d;return}function dec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(127680,cCc(+h[(c[g>>2]|0)+42504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[127672]=1;i=d;return}function eec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[127816]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+788>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+788>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(127824,eCc(c[(c[g>>2]|0)+788>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[127816]=1;i=d;return}function fec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128032]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+784>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+784>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(128040,eCc(c[(c[g>>2]|0)+784>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[128032]=1;i=d;return}function gec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128248]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+780>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+780>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(128256,eCc(c[(c[g>>2]|0)+780>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[128248]=1;i=d;return}function hec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128464]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+776>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+776>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(128472,eCc(c[(c[g>>2]|0)+776>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[128464]=1;i=d;return}function iec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+772>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+772>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(128664,eCc(c[(c[g>>2]|0)+772>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[128656]=1;i=d;return}function jec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[128848]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+768>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+768>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(128856,eCc(c[(c[g>>2]|0)+768>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[128848]=1;i=d;return}function kec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42496>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(129048,cCc(+h[(c[g>>2]|0)+42496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129040]=1;i=d;return}function lec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129184]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42488>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(129192,cCc(+h[(c[g>>2]|0)+42488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129184]=1;i=d;return}function mec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42480>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(129336,cCc(+h[(c[g>>2]|0)+42480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129328]=1;i=d;return}function nec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129472]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(129480,cCc(+h[(c[g>>2]|0)+42472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129472]=1;i=d;return}function oec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129592]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(129600,cCc(+h[(c[g>>2]|0)+42464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129592]=1;i=d;return}function pec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129712]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(129720,cCc(+h[(c[g>>2]|0)+42456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129712]=1;i=d;return}function qec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(129840,cCc(+h[(c[g>>2]|0)+42448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129832]=1;i=d;return}function rec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[129944]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(129952,cCc(+h[(c[g>>2]|0)+42440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[129944]=1;i=d;return}function sec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130056,cCc(+h[(c[g>>2]|0)+42432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130048]=1;i=d;return}function tec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130208,cCc(+h[(c[g>>2]|0)+42424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130200]=1;i=d;return}function uec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130352,cCc(+h[(c[g>>2]|0)+42400>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130344]=1;i=d;return}function vec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130448]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130456,cCc(+h[(c[g>>2]|0)+42392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130448]=1;i=d;return}function wec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130568,cCc(+h[(c[g>>2]|0)+42384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130560]=1;i=d;return}function xec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130672,cCc(+h[(c[g>>2]|0)+42376>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130664]=1;i=d;return}function yec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(130784,cCc(+h[(c[g>>2]|0)+42368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[130776]=1;i=d;return}function zec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[130904]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+764>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+764>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(130912,eCc(c[(c[g>>2]|0)+764>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[130904]=1;i=d;return}function Aec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131104]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+760>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+760>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(131112,eCc(c[(c[g>>2]|0)+760>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[131104]=1;i=d;return}function Bec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131304]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+756>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+756>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(131312,eCc(c[(c[g>>2]|0)+756>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[131304]=1;i=d;return}function Cec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131504]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+752>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+752>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(131512,eCc(c[(c[g>>2]|0)+752>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[131504]=1;i=d;return}function Dec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131680]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+748>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+748>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(131688,eCc(c[(c[g>>2]|0)+748>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[131680]=1;i=d;return}function Eec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[131856]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+744>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+744>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(131864,eCc(c[(c[g>>2]|0)+744>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[131856]=1;i=d;return}function Fec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(132040,cCc(+h[(c[g>>2]|0)+42352>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[132032]=1;i=d;return}function Gec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132152]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(132160,cCc(+h[(c[g>>2]|0)+42344>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[132152]=1;i=d;return}function Hec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132272]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(132280,cCc(+h[(c[g>>2]|0)+42328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[132272]=1;i=d;return}function Iec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132392]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(132400,cCc(+h[(c[g>>2]|0)+42320>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[132392]=1;i=d;return}function Jec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132512]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(132520,cCc(+h[(c[g>>2]|0)+42296>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[132512]=1;i=d;return}function Kec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132648]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(132656,cCc(+h[(c[g>>2]|0)+42288>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[132648]=1;i=d;return}function Lec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132784]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+740>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+740>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(132792,eCc(c[(c[g>>2]|0)+740>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[132784]=1;i=d;return}function Mec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[132984]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+736>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+736>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(132992,eCc(c[(c[g>>2]|0)+736>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[132984]=1;i=d;return}function Nec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133184]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+732>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+732>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(133192,eCc(c[(c[g>>2]|0)+732>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[133184]=1;i=d;return}function Oec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133384]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+728>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+728>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(133392,eCc(c[(c[g>>2]|0)+728>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[133384]=1;i=d;return}function Pec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133568]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+724>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+724>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(133576,eCc(c[(c[g>>2]|0)+724>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[133568]=1;i=d;return}function Qec(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133752]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+720>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+720>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(133760,eCc(c[(c[g>>2]|0)+720>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[133752]=1;i=d;return}function Rec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[133936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42280>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(133944,cCc(+h[(c[g>>2]|0)+42280>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[133936]=1;i=d;return}function Sec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42272>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(134080,cCc(+h[(c[g>>2]|0)+42272>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134072]=1;i=d;return}function Tec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(134216,cCc(+h[(c[g>>2]|0)+42264>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134208]=1;i=d;return}function Uec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(134352,cCc(+h[(c[g>>2]|0)+42256>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134344]=1;i=d;return}function Vec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(134464,cCc(+h[(c[g>>2]|0)+42248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134456]=1;i=d;return}function Wec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(134576,cCc(+h[(c[g>>2]|0)+42240>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134568]=1;i=d;return}function Xec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134680]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(134688,cCc(+h[(c[g>>2]|0)+42232>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134680]=1;i=d;return}function Yec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(134800,cCc(+h[(c[g>>2]|0)+42224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134792]=1;i=d;return}function Zec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[134888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(134896,cCc(+h[(c[g>>2]|0)+42216>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[134888]=1;i=d;return}function _ec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(135040,cCc(+h[(c[g>>2]|0)+42208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[135032]=1;i=d;return}function $ec(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135176]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(135184,cCc(+h[(c[g>>2]|0)+42184>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[135176]=1;i=d;return}function afc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(135288,cCc(+h[(c[g>>2]|0)+42176>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[135280]=1;i=d;return}function bfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135392]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(135400,cCc(+h[(c[g>>2]|0)+42168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[135392]=1;i=d;return}function cfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(135504,cCc(+h[(c[g>>2]|0)+42160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[135496]=1;i=d;return}function dfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(135608,cCc(+h[(c[g>>2]|0)+42152>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[135600]=1;i=d;return}function efc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135720]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+716>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+716>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(135728,eCc(c[(c[g>>2]|0)+716>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[135720]=1;i=d;return}function ffc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[135912]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+712>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+712>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(135920,eCc(c[(c[g>>2]|0)+712>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[135912]=1;i=d;return}function gfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136104]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+708>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+708>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(136112,eCc(c[(c[g>>2]|0)+708>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[136104]=1;i=d;return}function hfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136296]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+704>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+704>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(136304,eCc(c[(c[g>>2]|0)+704>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[136296]=1;i=d;return}function ifc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136464]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+700>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+700>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(136472,eCc(c[(c[g>>2]|0)+700>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[136464]=1;i=d;return}function jfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+696>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+696>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(136640,eCc(c[(c[g>>2]|0)+696>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[136632]=1;i=d;return}function kfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136800]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(136808,cCc(+h[(c[g>>2]|0)+42136>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[136800]=1;i=d;return}function lfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[136912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(136920,cCc(+h[(c[g>>2]|0)+42128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[136912]=1;i=d;return}function mfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(137040,cCc(+h[(c[g>>2]|0)+42120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[137032]=1;i=d;return}function nfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137184]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(137192,cCc(+h[(c[g>>2]|0)+42112>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[137184]=1;i=d;return}function ofc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(137336,cCc(+h[(c[g>>2]|0)+42088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[137328]=1;i=d;return}function pfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137472]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(137480,cCc(+h[(c[g>>2]|0)+42080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[137472]=1;i=d;return}function qfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+692>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+692>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(137624,eCc(c[(c[g>>2]|0)+692>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[137616]=1;i=d;return}function rfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[137832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+688>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+688>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(137840,eCc(c[(c[g>>2]|0)+688>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[137832]=1;i=d;return}function sfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138048]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+684>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+684>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(138056,eCc(c[(c[g>>2]|0)+684>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[138048]=1;i=d;return}function tfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138264]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+680>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+680>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(138272,eCc(c[(c[g>>2]|0)+680>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[138264]=1;i=d;return}function ufc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138456]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+676>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+676>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(138464,eCc(c[(c[g>>2]|0)+676>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[138456]=1;i=d;return}function vfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138648]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+672>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+672>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(138656,eCc(c[(c[g>>2]|0)+672>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[138648]=1;i=d;return}function wfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42072>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(138848,cCc(+h[(c[g>>2]|0)+42072>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[138840]=1;i=d;return}function xfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[138984]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42064>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(138992,cCc(+h[(c[g>>2]|0)+42064>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[138984]=1;i=d;return}function yfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139128]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42056>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(139136,cCc(+h[(c[g>>2]|0)+42056>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139128]=1;i=d;return}function zfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139272]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139280,cCc(+h[(c[g>>2]|0)+42048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139272]=1;i=d;return}function Afc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139392]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139400,cCc(+h[(c[g>>2]|0)+42040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139392]=1;i=d;return}function Bfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139512]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139520,cCc(+h[(c[g>>2]|0)+42032>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139512]=1;i=d;return}function Cfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139632]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139640,cCc(+h[(c[g>>2]|0)+42024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139632]=1;i=d;return}function Dfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139752,cCc(+h[(c[g>>2]|0)+42016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139744]=1;i=d;return}function Efc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139848]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+42e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139856,cCc(+h[(c[g>>2]|0)+42e3>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139848]=1;i=d;return}function Ffc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[139952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(139960,cCc(+h[(c[g>>2]|0)+41992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[139952]=1;i=d;return}function Gfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140064]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(140072,cCc(+h[(c[g>>2]|0)+41984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[140064]=1;i=d;return}function Hfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(140176,cCc(+h[(c[g>>2]|0)+41976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[140168]=1;i=d;return}function Ifc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(140296,cCc(+h[(c[g>>2]|0)+41968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[140288]=1;i=d;return}function Jfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140416]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+668>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+668>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(140424,eCc(c[(c[g>>2]|0)+668>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[140416]=1;i=d;return}function Kfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+664>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+664>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(140624,eCc(c[(c[g>>2]|0)+664>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[140616]=1;i=d;return}function Lfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[140816]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+660>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+660>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(140824,eCc(c[(c[g>>2]|0)+660>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[140816]=1;i=d;return}function Mfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141016]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+656>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+656>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(141024,eCc(c[(c[g>>2]|0)+656>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[141016]=1;i=d;return}function Nfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141192]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+652>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+652>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(141200,eCc(c[(c[g>>2]|0)+652>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[141192]=1;i=d;return}function Ofc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141368]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+648>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+648>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(141376,eCc(c[(c[g>>2]|0)+648>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[141368]=1;i=d;return}function Pfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(141552,cCc(+h[(c[g>>2]|0)+41952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[141544]=1;i=d;return}function Qfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(141672,cCc(+h[(c[g>>2]|0)+41944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[141664]=1;i=d;return}function Rfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(141800,cCc(+h[(c[g>>2]|0)+41936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[141792]=1;i=d;return}function Sfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[141920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(141928,cCc(+h[(c[g>>2]|0)+41928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[141920]=1;i=d;return}function Tfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(142048,cCc(+h[(c[g>>2]|0)+41904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[142040]=1;i=d;return}function Ufc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(142176,cCc(+h[(c[g>>2]|0)+41896>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[142168]=1;i=d;return}function Vfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(142296,cCc(+h[(c[g>>2]|0)+41888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[142288]=1;i=d;return}function Wfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(142424,cCc(+h[(c[g>>2]|0)+41880>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[142416]=1;i=d;return}function Xfc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142536]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2008>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2008>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(142544,eCc(c[(c[g>>2]|0)+2008>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[142536]=1;i=d;return}function Yfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142720]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(142728,cCc(+h[(c[g>>2]|0)+41856>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[142720]=1;i=d;return}function Zfc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142848]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(142856,cCc(+h[(c[g>>2]|0)+41848>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[142848]=1;i=d;return}function _fc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[142968]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2004>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2004>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(142976,eCc(c[(c[g>>2]|0)+2004>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=211424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[142968]=1;i=d;return}function $fc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(143176,cCc(+h[(c[g>>2]|0)+41744>>3],7896)|0)|0;g=c[85376]|0;j=e;k=176904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[143168]=1;i=d;return}function agc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(143288,cCc(+h[(c[g>>2]|0)+41728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[143280]=1;i=d;return}function bgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(143416,cCc(+h[(c[g>>2]|0)+41720>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[143408]=1;i=d;return}function cgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143528]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+644>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+644>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(143536,eCc(c[(c[g>>2]|0)+644>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[143528]=1;i=d;return}function dgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143704]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+640>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+640>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(143712,eCc(c[(c[g>>2]|0)+640>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[143704]=1;i=d;return}function egc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[143880]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+636>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+636>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(143888,eCc(c[(c[g>>2]|0)+636>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[143880]=1;i=d;return}function fgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2e3>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2e3>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(144064,eCc(c[(c[g>>2]|0)+2e3>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[144056]=1;i=d;return}function ggc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144368]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(144376,cCc(+h[(c[g>>2]|0)+41688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[144368]=1;i=d;return}function hgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(144504,cCc(+h[(c[g>>2]|0)+41680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[144496]=1;i=d;return}function igc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+632>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+632>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(144624,eCc(c[(c[g>>2]|0)+632>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[144616]=1;i=d;return}function jgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144792]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+628>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+628>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(144800,eCc(c[(c[g>>2]|0)+628>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[144792]=1;i=d;return}function kgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[144968]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+624>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+624>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(144976,eCc(c[(c[g>>2]|0)+624>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[144968]=1;i=d;return}function lgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145144]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1996>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1996>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(145152,eCc(c[(c[g>>2]|0)+1996>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[145144]=1;i=d;return}function mgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(145464,cCc(+h[(c[g>>2]|0)+41648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[145456]=1;i=d;return}function ngc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(145608,cCc(+h[(c[g>>2]|0)+41640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[145600]=1;i=d;return}function ogc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145736]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+620>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+620>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(145744,eCc(c[(c[g>>2]|0)+620>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[145736]=1;i=d;return}function pgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[145936]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+616>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+616>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(145944,eCc(c[(c[g>>2]|0)+616>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[145936]=1;i=d;return}function qgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146136]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+612>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+612>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(146144,eCc(c[(c[g>>2]|0)+612>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[146136]=1;i=d;return}function rgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146336]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1992>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1992>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(146344,eCc(c[(c[g>>2]|0)+1992>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[146336]=1;i=d;return}function sgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(146680,cCc(+h[(c[g>>2]|0)+41608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[146672]=1;i=d;return}function tgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(146792,cCc(+h[(c[g>>2]|0)+41600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[146784]=1;i=d;return}function ugc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[146888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(146896,cCc(+h[(c[g>>2]|0)+41576>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[146888]=1;i=d;return}function vgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(147048,cCc(+h[(c[g>>2]|0)+41568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[147040]=1;i=d;return}function wgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147184]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(147192,cCc(+h[(c[g>>2]|0)+41544>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[147184]=1;i=d;return}function xgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(147336,cCc(+h[(c[g>>2]|0)+41536>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[147328]=1;i=d;return}function ygc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+608>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+608>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(147480,eCc(c[(c[g>>2]|0)+608>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[147472]=1;i=d;return}function zgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147688]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+604>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+604>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(147696,eCc(c[(c[g>>2]|0)+604>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[147688]=1;i=d;return}function Agc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[147904]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+600>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+600>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(147912,eCc(c[(c[g>>2]|0)+600>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[147904]=1;i=d;return}function Bgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148120]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+596>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+596>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(148128,eCc(c[(c[g>>2]|0)+596>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[148120]=1;i=d;return}function Cgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148312]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+592>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+592>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(148320,eCc(c[(c[g>>2]|0)+592>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[148312]=1;i=d;return}function Dgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148504]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+588>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+588>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(148512,eCc(c[(c[g>>2]|0)+588>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[148504]=1;i=d;return}function Egc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41528>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(148704,cCc(+h[(c[g>>2]|0)+41528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[148696]=1;i=d;return}function Fgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41520>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(148848,cCc(+h[(c[g>>2]|0)+41520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[148840]=1;i=d;return}function Ggc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[148984]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41512>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(148992,cCc(+h[(c[g>>2]|0)+41512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[148984]=1;i=d;return}function Hgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149128]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149136,cCc(+h[(c[g>>2]|0)+41504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149128]=1;i=d;return}function Igc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149248]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149256,cCc(+h[(c[g>>2]|0)+41496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149248]=1;i=d;return}function Jgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149368]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149376,cCc(+h[(c[g>>2]|0)+41488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149368]=1;i=d;return}function Kgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149488]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149496,cCc(+h[(c[g>>2]|0)+41480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149488]=1;i=d;return}function Lgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149608,cCc(+h[(c[g>>2]|0)+41472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149600]=1;i=d;return}function Mgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149712,cCc(+h[(c[g>>2]|0)+41456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149704]=1;i=d;return}function Ngc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149808]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149816,cCc(+h[(c[g>>2]|0)+41448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149808]=1;i=d;return}function Ogc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[149920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(149928,cCc(+h[(c[g>>2]|0)+41440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[149920]=1;i=d;return}function Pgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(150032,cCc(+h[(c[g>>2]|0)+41432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[150024]=1;i=d;return}function Qgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(150152,cCc(+h[(c[g>>2]|0)+41424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[150144]=1;i=d;return}function Rgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150272]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+584>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+584>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(150280,eCc(c[(c[g>>2]|0)+584>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[150272]=1;i=d;return}function Sgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+580>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+580>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(150480,eCc(c[(c[g>>2]|0)+580>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[150472]=1;i=d;return}function Tgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150672]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+576>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+576>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(150680,eCc(c[(c[g>>2]|0)+576>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[150672]=1;i=d;return}function Ugc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[150872]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+572>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+572>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(150880,eCc(c[(c[g>>2]|0)+572>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[150872]=1;i=d;return}function Vgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151048]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+568>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+568>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(151056,eCc(c[(c[g>>2]|0)+568>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[151048]=1;i=d;return}function Wgc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+564>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+564>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(151232,eCc(c[(c[g>>2]|0)+564>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[151224]=1;i=d;return}function Xgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(151408,cCc(+h[(c[g>>2]|0)+41408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[151400]=1;i=d;return}function Ygc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151520]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(151528,cCc(+h[(c[g>>2]|0)+41400>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[151520]=1;i=d;return}function Zgc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151648]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(151656,cCc(+h[(c[g>>2]|0)+41392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[151648]=1;i=d;return}function _gc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151800]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(151808,cCc(+h[(c[g>>2]|0)+41384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[151800]=1;i=d;return}function $gc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[151944]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(151952,cCc(+h[(c[g>>2]|0)+41360>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[151944]=1;i=d;return}function ahc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152088]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(152096,cCc(+h[(c[g>>2]|0)+41352>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[152088]=1;i=d;return}function bhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152232]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+560>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+560>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(152240,eCc(c[(c[g>>2]|0)+560>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[152232]=1;i=d;return}function chc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152448]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+556>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+556>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(152456,eCc(c[(c[g>>2]|0)+556>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[152448]=1;i=d;return}function dhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152664]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+552>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+552>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(152672,eCc(c[(c[g>>2]|0)+552>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[152664]=1;i=d;return}function ehc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[152880]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+548>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+548>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(152888,eCc(c[(c[g>>2]|0)+548>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[152880]=1;i=d;return}function fhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153072]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+544>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+544>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(153080,eCc(c[(c[g>>2]|0)+544>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[153072]=1;i=d;return}function ghc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153264]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+540>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+540>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(153272,eCc(c[(c[g>>2]|0)+540>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[153264]=1;i=d;return}function hhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41344>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(153464,cCc(+h[(c[g>>2]|0)+41344>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[153456]=1;i=d;return}function ihc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41336>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(153608,cCc(+h[(c[g>>2]|0)+41336>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[153600]=1;i=d;return}function jhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41328>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(153752,cCc(+h[(c[g>>2]|0)+41328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[153744]=1;i=d;return}function khc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[153888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(153896,cCc(+h[(c[g>>2]|0)+41320>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[153888]=1;i=d;return}function lhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154008]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154016,cCc(+h[(c[g>>2]|0)+41312>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154008]=1;i=d;return}function mhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154128]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154136,cCc(+h[(c[g>>2]|0)+41304>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154128]=1;i=d;return}function nhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154248]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154256,cCc(+h[(c[g>>2]|0)+41296>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154248]=1;i=d;return}function ohc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154360]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154368,cCc(+h[(c[g>>2]|0)+41288>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154360]=1;i=d;return}function phc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154464]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154472,cCc(+h[(c[g>>2]|0)+41272>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154464]=1;i=d;return}function qhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154576,cCc(+h[(c[g>>2]|0)+41264>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154568]=1;i=d;return}function rhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154680]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154688,cCc(+h[(c[g>>2]|0)+41256>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154680]=1;i=d;return}function shc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154792,cCc(+h[(c[g>>2]|0)+41248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154784]=1;i=d;return}function thc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[154904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(154912,cCc(+h[(c[g>>2]|0)+41240>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[154904]=1;i=d;return}function uhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155032]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+536>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+536>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(155040,eCc(c[(c[g>>2]|0)+536>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[155032]=1;i=d;return}function vhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155232]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+532>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+532>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(155240,eCc(c[(c[g>>2]|0)+532>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[155232]=1;i=d;return}function whc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155432]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+528>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+528>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(155440,eCc(c[(c[g>>2]|0)+528>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[155432]=1;i=d;return}function xhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+524>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+524>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(155640,eCc(c[(c[g>>2]|0)+524>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[155632]=1;i=d;return}



function V0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18488]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1840>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1840>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(18496,eCc(c[(c[g>>2]|0)+1840>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18488]=1;i=d;return}function W0b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18680]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1836>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1836>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(18688,eCc(c[(c[g>>2]|0)+1836>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[18680]=1;i=d;return}function X0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[18872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47264>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(18880,cCc(+h[(c[g>>2]|0)+47264>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[18872]=1;i=d;return}function Y0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47256>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(19024,cCc(+h[(c[g>>2]|0)+47256>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19016]=1;i=d;return}function Z0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47248>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(19168,cCc(+h[(c[g>>2]|0)+47248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19160]=1;i=d;return}function _0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19304]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19312,cCc(+h[(c[g>>2]|0)+47240>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19304]=1;i=d;return}function $0b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47232>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19432,cCc(+h[(c[g>>2]|0)+47232>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19424]=1;i=d;return}function a1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19552,cCc(+h[(c[g>>2]|0)+47224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19544]=1;i=d;return}function b1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19672,cCc(+h[(c[g>>2]|0)+47216>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19664]=1;i=d;return}function c1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19784,cCc(+h[(c[g>>2]|0)+47208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19776]=1;i=d;return}function d1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19888,cCc(+h[(c[g>>2]|0)+47192>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19880]=1;i=d;return}function e1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[19984]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(19992,cCc(+h[(c[g>>2]|0)+47184>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[19984]=1;i=d;return}function f1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(20104,cCc(+h[(c[g>>2]|0)+47176>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20096]=1;i=d;return}function g1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(20208,cCc(+h[(c[g>>2]|0)+47168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20200]=1;i=d;return}function h1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20320]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(20328,cCc(+h[(c[g>>2]|0)+47160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[20320]=1;i=d;return}function i1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20448]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1832>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1832>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(20456,eCc(c[(c[g>>2]|0)+1832>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[20448]=1;i=d;return}function j1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20648]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1828>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1828>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(20656,eCc(c[(c[g>>2]|0)+1828>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[20648]=1;i=d;return}function k1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[20848]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1824>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1824>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(20856,eCc(c[(c[g>>2]|0)+1824>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[20848]=1;i=d;return}function l1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21048]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1820>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1820>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(21056,eCc(c[(c[g>>2]|0)+1820>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[21048]=1;i=d;return}function m1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1816>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1816>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(21232,eCc(c[(c[g>>2]|0)+1816>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[21224]=1;i=d;return}function n1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21400]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1812>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1812>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(21408,eCc(c[(c[g>>2]|0)+1812>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[21400]=1;i=d;return}function o1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21576]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(21584,cCc(+h[(c[g>>2]|0)+47144>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21576]=1;i=d;return}function p1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(21704,cCc(+h[(c[g>>2]|0)+47136>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21696]=1;i=d;return}function q1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(21832,cCc(+h[(c[g>>2]|0)+47128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21824]=1;i=d;return}function r1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[21968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(21976,cCc(+h[(c[g>>2]|0)+47120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[21968]=1;i=d;return}function s1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22112]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1808>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1808>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(22120,eCc(c[(c[g>>2]|0)+1808>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22112]=1;i=d;return}function t1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22328]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1804>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1804>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(22336,eCc(c[(c[g>>2]|0)+1804>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22328]=1;i=d;return}function u1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22544]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1800>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1800>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(22552,eCc(c[(c[g>>2]|0)+1800>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22544]=1;i=d;return}function v1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22760]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1796>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1796>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(22768,eCc(c[(c[g>>2]|0)+1796>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22760]=1;i=d;return}function w1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[22952]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1792>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1792>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(22960,eCc(c[(c[g>>2]|0)+1792>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[22952]=1;i=d;return}function x1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23144]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1788>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1788>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(23152,eCc(c[(c[g>>2]|0)+1788>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[23144]=1;i=d;return}function y1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23336]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47112>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(23344,cCc(+h[(c[g>>2]|0)+47112>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23336]=1;i=d;return}function z1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23480]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47104>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(23488,cCc(+h[(c[g>>2]|0)+47104>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23480]=1;i=d;return}function A1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23624]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47096>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(23632,cCc(+h[(c[g>>2]|0)+47096>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23624]=1;i=d;return}function B1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23768]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(23776,cCc(+h[(c[g>>2]|0)+47088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23768]=1;i=d;return}function C1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[23888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(23896,cCc(+h[(c[g>>2]|0)+47080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[23888]=1;i=d;return}function D1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24008]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24016,cCc(+h[(c[g>>2]|0)+47072>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24008]=1;i=d;return}function E1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24128]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24136,cCc(+h[(c[g>>2]|0)+47064>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24128]=1;i=d;return}function F1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24240]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24248,cCc(+h[(c[g>>2]|0)+47056>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24240]=1;i=d;return}function G1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24352,cCc(+h[(c[g>>2]|0)+47048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24344]=1;i=d;return}function H1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24504,cCc(+h[(c[g>>2]|0)+47040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24496]=1;i=d;return}function I1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24648,cCc(+h[(c[g>>2]|0)+47016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24640]=1;i=d;return}function J1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24752,cCc(+h[(c[g>>2]|0)+47008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24744]=1;i=d;return}function K1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24856]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+47e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24864,cCc(+h[(c[g>>2]|0)+47e3>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24856]=1;i=d;return}function L1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[24960]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(24968,cCc(+h[(c[g>>2]|0)+46992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[24960]=1;i=d;return}function M1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(25080,cCc(+h[(c[g>>2]|0)+46984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[25072]=1;i=d;return}function N1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25200]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1784>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1784>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(25208,eCc(c[(c[g>>2]|0)+1784>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25200]=1;i=d;return}function O1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25400]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1780>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1780>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(25408,eCc(c[(c[g>>2]|0)+1780>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25400]=1;i=d;return}function P1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25600]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1776>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1776>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(25608,eCc(c[(c[g>>2]|0)+1776>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25600]=1;i=d;return}function Q1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25800]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1772>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1772>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(25808,eCc(c[(c[g>>2]|0)+1772>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25800]=1;i=d;return}function R1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[25976]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1768>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1768>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(25984,eCc(c[(c[g>>2]|0)+1768>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[25976]=1;i=d;return}function S1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26152]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1764>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1764>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(26160,eCc(c[(c[g>>2]|0)+1764>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26152]=1;i=d;return}function T1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(26336,cCc(+h[(c[g>>2]|0)+46968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26328]=1;i=d;return}function U1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26448]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(26456,cCc(+h[(c[g>>2]|0)+46960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26448]=1;i=d;return}function V1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(26576,cCc(+h[(c[g>>2]|0)+46952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26568]=1;i=d;return}function W1b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26712]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(26720,cCc(+h[(c[g>>2]|0)+46944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[26712]=1;i=d;return}function X1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[26856]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1760>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1760>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(26864,eCc(c[(c[g>>2]|0)+1760>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[26856]=1;i=d;return}function Y1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27072]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1756>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1756>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(27080,eCc(c[(c[g>>2]|0)+1756>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27072]=1;i=d;return}function Z1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27288]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1752>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1752>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(27296,eCc(c[(c[g>>2]|0)+1752>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27288]=1;i=d;return}function _1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27504]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1748>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1748>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(27512,eCc(c[(c[g>>2]|0)+1748>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27504]=1;i=d;return}function $1b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27696]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1744>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1744>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(27704,eCc(c[(c[g>>2]|0)+1744>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27696]=1;i=d;return}function a2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[27888]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1740>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1740>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(27896,eCc(c[(c[g>>2]|0)+1740>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[27888]=1;i=d;return}function b2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46936>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(28088,cCc(+h[(c[g>>2]|0)+46936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28080]=1;i=d;return}function c2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46928>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(28232,cCc(+h[(c[g>>2]|0)+46928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28224]=1;i=d;return}function d2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28368]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46920>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(28376,cCc(+h[(c[g>>2]|0)+46920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28368]=1;i=d;return}function e2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28512]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(28520,cCc(+h[(c[g>>2]|0)+46912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28512]=1;i=d;return}function f2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28632]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(28640,cCc(+h[(c[g>>2]|0)+46904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28632]=1;i=d;return}function g2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28752]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(28760,cCc(+h[(c[g>>2]|0)+46896>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28752]=1;i=d;return}function h2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(28880,cCc(+h[(c[g>>2]|0)+46888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28872]=1;i=d;return}function i2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28984]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(28992,cCc(+h[(c[g>>2]|0)+46880>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28984]=1;i=d;return}function j2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29088]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29096,cCc(+h[(c[g>>2]|0)+46872>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29088]=1;i=d;return}function k2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29240]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29248,cCc(+h[(c[g>>2]|0)+46864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29240]=1;i=d;return}function l2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29384]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29392,cCc(+h[(c[g>>2]|0)+46840>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29384]=1;i=d;return}function m2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29488]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29496,cCc(+h[(c[g>>2]|0)+46832>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29488]=1;i=d;return}function n2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29608,cCc(+h[(c[g>>2]|0)+46824>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29600]=1;i=d;return}function o2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29712,cCc(+h[(c[g>>2]|0)+46816>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29704]=1;i=d;return}function p2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29816]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(29824,cCc(+h[(c[g>>2]|0)+46808>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[29816]=1;i=d;return}function q2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[29944]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1736>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1736>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(29952,eCc(c[(c[g>>2]|0)+1736>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[29944]=1;i=d;return}function r2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30144]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1732>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1732>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(30152,eCc(c[(c[g>>2]|0)+1732>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30144]=1;i=d;return}function s2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30344]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1728>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1728>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(30352,eCc(c[(c[g>>2]|0)+1728>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30344]=1;i=d;return}function t2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30544]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1724>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1724>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(30552,eCc(c[(c[g>>2]|0)+1724>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30544]=1;i=d;return}function u2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30720]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1720>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1720>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(30728,eCc(c[(c[g>>2]|0)+1720>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30720]=1;i=d;return}function v2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[30896]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1716>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1716>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(30904,eCc(c[(c[g>>2]|0)+1716>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[30896]=1;i=d;return}function w2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(31080,cCc(+h[(c[g>>2]|0)+46792>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31072]=1;i=d;return}function x2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31192]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(31200,cCc(+h[(c[g>>2]|0)+46784>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31192]=1;i=d;return}function y2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(31320,cCc(+h[(c[g>>2]|0)+46768>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31312]=1;i=d;return}function z2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31432]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(31440,cCc(+h[(c[g>>2]|0)+46760>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31432]=1;i=d;return}function A2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(31560,cCc(+h[(c[g>>2]|0)+46736>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31552]=1;i=d;return}function B2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31688]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(31696,cCc(+h[(c[g>>2]|0)+46728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[31688]=1;i=d;return}function C2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[31824]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1712>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1712>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(31832,eCc(c[(c[g>>2]|0)+1712>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[31824]=1;i=d;return}function D2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32024]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1708>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1708>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(32032,eCc(c[(c[g>>2]|0)+1708>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32024]=1;i=d;return}function E2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1704>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1704>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(32232,eCc(c[(c[g>>2]|0)+1704>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32224]=1;i=d;return}function F2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32424]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1700>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1700>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(32432,eCc(c[(c[g>>2]|0)+1700>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32424]=1;i=d;return}function G2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32608]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1696>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1696>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(32616,eCc(c[(c[g>>2]|0)+1696>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32608]=1;i=d;return}function H2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32792]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1692>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1692>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(32800,eCc(c[(c[g>>2]|0)+1692>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[32792]=1;i=d;return}function I2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[32976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46720>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(32984,cCc(+h[(c[g>>2]|0)+46720>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[32976]=1;i=d;return}function J2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33112]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46712>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(33120,cCc(+h[(c[g>>2]|0)+46712>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33112]=1;i=d;return}function K2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33248]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46704>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(33256,cCc(+h[(c[g>>2]|0)+46704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33248]=1;i=d;return}function L2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33384]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(33392,cCc(+h[(c[g>>2]|0)+46696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33384]=1;i=d;return}function M2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(33504,cCc(+h[(c[g>>2]|0)+46688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33496]=1;i=d;return}function N2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33608]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(33616,cCc(+h[(c[g>>2]|0)+46680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33608]=1;i=d;return}function O2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33720]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(33728,cCc(+h[(c[g>>2]|0)+46672>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33720]=1;i=d;return}function P2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(33840,cCc(+h[(c[g>>2]|0)+46664>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33832]=1;i=d;return}function Q2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[33928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(33936,cCc(+h[(c[g>>2]|0)+46656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[33928]=1;i=d;return}function R2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(34080,cCc(+h[(c[g>>2]|0)+46648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34072]=1;i=d;return}function S2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46624>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(34224,cCc(+h[(c[g>>2]|0)+46624>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34216]=1;i=d;return}function T2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34320]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(34328,cCc(+h[(c[g>>2]|0)+46616>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34320]=1;i=d;return}function U2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34432]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(34440,cCc(+h[(c[g>>2]|0)+46608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34432]=1;i=d;return}function V2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(34544,cCc(+h[(c[g>>2]|0)+46600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34536]=1;i=d;return}function W2b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(34648,cCc(+h[(c[g>>2]|0)+46592>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[34640]=1;i=d;return}function X2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34760]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1688>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1688>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(34768,eCc(c[(c[g>>2]|0)+1688>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34760]=1;i=d;return}function Y2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[34952]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1684>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1684>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(34960,eCc(c[(c[g>>2]|0)+1684>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[34952]=1;i=d;return}function Z2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35144]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1680>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1680>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(35152,eCc(c[(c[g>>2]|0)+1680>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35144]=1;i=d;return}function _2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35336]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1676>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1676>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(35344,eCc(c[(c[g>>2]|0)+1676>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35336]=1;i=d;return}function $2b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35504]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1672>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1672>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(35512,eCc(c[(c[g>>2]|0)+1672>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35504]=1;i=d;return}function a3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35672]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1668>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1668>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(35680,eCc(c[(c[g>>2]|0)+1668>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[35672]=1;i=d;return}function b3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(35848,cCc(+h[(c[g>>2]|0)+46576>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35840]=1;i=d;return}function c3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[35952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(35960,cCc(+h[(c[g>>2]|0)+46568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[35952]=1;i=d;return}function d3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(36080,cCc(+h[(c[g>>2]|0)+46560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36072]=1;i=d;return}function e3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(36232,cCc(+h[(c[g>>2]|0)+46552>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36224]=1;i=d;return}function f3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36368]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(36376,cCc(+h[(c[g>>2]|0)+46528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36368]=1;i=d;return}function g3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36512]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(36520,cCc(+h[(c[g>>2]|0)+46520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[36512]=1;i=d;return}function h3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1664>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1664>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(36664,eCc(c[(c[g>>2]|0)+1664>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[36656]=1;i=d;return}function i3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[36872]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1660>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1660>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(36880,eCc(c[(c[g>>2]|0)+1660>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[36872]=1;i=d;return}function j3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37088]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1656>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1656>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(37096,eCc(c[(c[g>>2]|0)+1656>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[37088]=1;i=d;return}function k3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37304]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1652>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1652>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(37312,eCc(c[(c[g>>2]|0)+1652>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[37304]=1;i=d;return}function l3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37496]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1648>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1648>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(37504,eCc(c[(c[g>>2]|0)+1648>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[37496]=1;i=d;return}function m3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37688]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1644>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1644>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(37696,eCc(c[(c[g>>2]|0)+1644>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[37688]=1;i=d;return}function n3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[37880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46512>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(37888,cCc(+h[(c[g>>2]|0)+46512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[37880]=1;i=d;return}function o3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46504>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(38032,cCc(+h[(c[g>>2]|0)+46504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38024]=1;i=d;return}function p3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46496>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(38176,cCc(+h[(c[g>>2]|0)+46496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38168]=1;i=d;return}function q3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(38320,cCc(+h[(c[g>>2]|0)+46488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38312]=1;i=d;return}function r3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38432]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(38440,cCc(+h[(c[g>>2]|0)+46480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38432]=1;i=d;return}function s3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(38560,cCc(+h[(c[g>>2]|0)+46472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38552]=1;i=d;return}function t3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(38680,cCc(+h[(c[g>>2]|0)+46464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38672]=1;i=d;return}function u3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(38792,cCc(+h[(c[g>>2]|0)+46456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38784]=1;i=d;return}function v3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(38896,cCc(+h[(c[g>>2]|0)+46440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38888]=1;i=d;return}function w3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[38992]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(39e3,cCc(+h[(c[g>>2]|0)+46432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[38992]=1;i=d;return}function x3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39104]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(39112,cCc(+h[(c[g>>2]|0)+46424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39104]=1;i=d;return}function y3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(39216,cCc(+h[(c[g>>2]|0)+46416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39208]=1;i=d;return}function z3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(39336,cCc(+h[(c[g>>2]|0)+46408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[39328]=1;i=d;return}function A3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39456]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1640>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1640>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(39464,eCc(c[(c[g>>2]|0)+1640>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[39456]=1;i=d;return}function B3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1636>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1636>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(39664,eCc(c[(c[g>>2]|0)+1636>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[39656]=1;i=d;return}function C3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[39856]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1632>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1632>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(39864,eCc(c[(c[g>>2]|0)+1632>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[39856]=1;i=d;return}function D3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1628>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1628>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(40064,eCc(c[(c[g>>2]|0)+1628>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[40056]=1;i=d;return}function E3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40232]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1624>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1624>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(40240,eCc(c[(c[g>>2]|0)+1624>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[40232]=1;i=d;return}function F3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40408]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1620>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1620>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(40416,eCc(c[(c[g>>2]|0)+1620>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[40408]=1;i=d;return}function G3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(40592,cCc(+h[(c[g>>2]|0)+46392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40584]=1;i=d;return}function H3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(40712,cCc(+h[(c[g>>2]|0)+46384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40704]=1;i=d;return}function I3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(40840,cCc(+h[(c[g>>2]|0)+46376>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40832]=1;i=d;return}function J3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[40960]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(40968,cCc(+h[(c[g>>2]|0)+46368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[40960]=1;i=d;return}function K3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(41088,cCc(+h[(c[g>>2]|0)+46344>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41080]=1;i=d;return}function L3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(41304,cCc(+h[(c[g>>2]|0)+46336>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41296]=1;i=d;return}function M3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(41424,cCc(+h[(c[g>>2]|0)+46328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41416]=1;i=d;return}function N3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(41552,cCc(+h[(c[g>>2]|0)+46320>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41544]=1;i=d;return}function O3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41664]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2068>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2068>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(41672,eCc(c[(c[g>>2]|0)+2068>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[41664]=1;i=d;return}function P3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41848]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(41856,cCc(+h[(c[g>>2]|0)+46296>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41848]=1;i=d;return}function Q3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[41976]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(41984,cCc(+h[(c[g>>2]|0)+46288>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[41976]=1;i=d;return}function R3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42096]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2064>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2064>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(42104,eCc(c[(c[g>>2]|0)+2064>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=211424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[42096]=1;i=d;return}function S3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(42304,cCc(+h[(c[g>>2]|0)+46184>>3],7896)|0)|0;g=c[85376]|0;j=e;k=176904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42296]=1;i=d;return}function T3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(42416,cCc(+h[(c[g>>2]|0)+46168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42408]=1;i=d;return}function U3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(42544,cCc(+h[(c[g>>2]|0)+46160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[42536]=1;i=d;return}function V3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1616>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1616>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(42664,eCc(c[(c[g>>2]|0)+1616>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[42656]=1;i=d;return}function W3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[42832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1612>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1612>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(42840,eCc(c[(c[g>>2]|0)+1612>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[42832]=1;i=d;return}function X3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43008]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1608>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1608>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(43016,eCc(c[(c[g>>2]|0)+1608>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[43008]=1;i=d;return}function Y3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43184]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2060>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2060>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(43192,eCc(c[(c[g>>2]|0)+2060>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[43184]=1;i=d;return}function Z3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(43504,cCc(+h[(c[g>>2]|0)+46128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43496]=1;i=d;return}function _3b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43624]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(43632,cCc(+h[(c[g>>2]|0)+46120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[43624]=1;i=d;return}function $3b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43744]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1604>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1604>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(43752,eCc(c[(c[g>>2]|0)+1604>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[43744]=1;i=d;return}function a4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[43920]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1600>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1600>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(43928,eCc(c[(c[g>>2]|0)+1600>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[43920]=1;i=d;return}function b4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44096]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1596>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1596>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(44104,eCc(c[(c[g>>2]|0)+1596>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44096]=1;i=d;return}function c4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44272]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2056>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2056>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(44280,eCc(c[(c[g>>2]|0)+2056>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44272]=1;i=d;return}function d4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(44592,cCc(+h[(c[g>>2]|0)+46088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[44584]=1;i=d;return}function e4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44728]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(44736,cCc(+h[(c[g>>2]|0)+46080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[44728]=1;i=d;return}function f4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[44864]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1592>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1592>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(44872,eCc(c[(c[g>>2]|0)+1592>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[44864]=1;i=d;return}function g4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45064]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1588>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1588>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(45072,eCc(c[(c[g>>2]|0)+1588>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[45064]=1;i=d;return}function h4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45264]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1584>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1584>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(45272,eCc(c[(c[g>>2]|0)+1584>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[45264]=1;i=d;return}function i4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45464]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2052>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2052>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(45472,eCc(c[(c[g>>2]|0)+2052>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[45464]=1;i=d;return}function j4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45800]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(45808,cCc(+h[(c[g>>2]|0)+46048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45800]=1;i=d;return}function k4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[45912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(45920,cCc(+h[(c[g>>2]|0)+46040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[45912]=1;i=d;return}function l4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(46024,cCc(+h[(c[g>>2]|0)+46016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[46016]=1;i=d;return}function m4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+46008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(46176,cCc(+h[(c[g>>2]|0)+46008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[46168]=1;i=d;return}function n4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(46320,cCc(+h[(c[g>>2]|0)+45984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[46312]=1;i=d;return}function o4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(46464,cCc(+h[(c[g>>2]|0)+45976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[46456]=1;i=d;return}function p4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46600]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1580>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1580>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(46608,eCc(c[(c[g>>2]|0)+1580>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[46600]=1;i=d;return}function q4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[46816]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1576>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1576>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(46824,eCc(c[(c[g>>2]|0)+1576>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[46816]=1;i=d;return}function r4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47032]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1572>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1572>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(47040,eCc(c[(c[g>>2]|0)+1572>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[47032]=1;i=d;return}function s4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47248]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1568>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1568>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(47256,eCc(c[(c[g>>2]|0)+1568>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[47248]=1;i=d;return}function t4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47440]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1564>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1564>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(47448,eCc(c[(c[g>>2]|0)+1564>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[47440]=1;i=d;return}function u4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1560>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1560>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(47640,eCc(c[(c[g>>2]|0)+1560>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[47632]=1;i=d;return}function v4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45968>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(47832,cCc(+h[(c[g>>2]|0)+45968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47824]=1;i=d;return}function w4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[47968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45960>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(47976,cCc(+h[(c[g>>2]|0)+45960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[47968]=1;i=d;return}function x4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48112]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45952>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(48120,cCc(+h[(c[g>>2]|0)+45952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48112]=1;i=d;return}function y4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48256]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48264,cCc(+h[(c[g>>2]|0)+45944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48256]=1;i=d;return}function z4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48376]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48384,cCc(+h[(c[g>>2]|0)+45936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48376]=1;i=d;return}function A4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48504,cCc(+h[(c[g>>2]|0)+45928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48496]=1;i=d;return}function B4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48616]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48624,cCc(+h[(c[g>>2]|0)+45920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48616]=1;i=d;return}function C4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48728]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48736,cCc(+h[(c[g>>2]|0)+45912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48728]=1;i=d;return}function D4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48840,cCc(+h[(c[g>>2]|0)+45896>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48832]=1;i=d;return}function E4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[48936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(48944,cCc(+h[(c[g>>2]|0)+45888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[48936]=1;i=d;return}function F4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(49056,cCc(+h[(c[g>>2]|0)+45880>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[49048]=1;i=d;return}function G4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49152]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(49160,cCc(+h[(c[g>>2]|0)+45872>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[49152]=1;i=d;return}function H4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49272]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(49280,cCc(+h[(c[g>>2]|0)+45864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[49272]=1;i=d;return}function I4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49400]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1556>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1556>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(49408,eCc(c[(c[g>>2]|0)+1556>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49400]=1;i=d;return}function J4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49600]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1552>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1552>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(49608,eCc(c[(c[g>>2]|0)+1552>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49600]=1;i=d;return}function K4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[49800]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1548>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1548>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(49808,eCc(c[(c[g>>2]|0)+1548>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[49800]=1;i=d;return}function L4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[5e4]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1544>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1544>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(50008,eCc(c[(c[g>>2]|0)+1544>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[5e4]=1;i=d;return}function M4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50176]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1540>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1540>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(50184,eCc(c[(c[g>>2]|0)+1540>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[50176]=1;i=d;return}function N4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50352]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1536>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1536>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(50360,eCc(c[(c[g>>2]|0)+1536>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[50352]=1;i=d;return}function O4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50528]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(50536,cCc(+h[(c[g>>2]|0)+45848>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50528]=1;i=d;return}function P4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50648]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(50656,cCc(+h[(c[g>>2]|0)+45840>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50648]=1;i=d;return}function Q4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(50784,cCc(+h[(c[g>>2]|0)+45832>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50776]=1;i=d;return}function R4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[50928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(50936,cCc(+h[(c[g>>2]|0)+45824>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[50928]=1;i=d;return}function S4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45800>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(51080,cCc(+h[(c[g>>2]|0)+45800>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[51072]=1;i=d;return}function T4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(51224,cCc(+h[(c[g>>2]|0)+45792>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[51216]=1;i=d;return}function U4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51360]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1532>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1532>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(51368,eCc(c[(c[g>>2]|0)+1532>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51360]=1;i=d;return}function V4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51576]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1528>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1528>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(51584,eCc(c[(c[g>>2]|0)+1528>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51576]=1;i=d;return}function W4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[51792]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1524>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1524>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(51800,eCc(c[(c[g>>2]|0)+1524>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[51792]=1;i=d;return}function X4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52008]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1520>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1520>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(52016,eCc(c[(c[g>>2]|0)+1520>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[52008]=1;i=d;return}function Y4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52200]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1516>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1516>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(52208,eCc(c[(c[g>>2]|0)+1516>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[52200]=1;i=d;return}function Z4b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52392]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1512>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1512>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(52400,eCc(c[(c[g>>2]|0)+1512>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[52392]=1;i=d;return}function _4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45784>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(52592,cCc(+h[(c[g>>2]|0)+45784>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52584]=1;i=d;return}function $4b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52728]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45776>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(52736,cCc(+h[(c[g>>2]|0)+45776>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52728]=1;i=d;return}function a5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[52872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45768>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(52880,cCc(+h[(c[g>>2]|0)+45768>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[52872]=1;i=d;return}



function yhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155808]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+520>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+520>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(155816,eCc(c[(c[g>>2]|0)+520>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[155808]=1;i=d;return}function zhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[155984]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+516>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+516>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(155992,eCc(c[(c[g>>2]|0)+516>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[155984]=1;i=d;return}function Ahc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(156168,cCc(+h[(c[g>>2]|0)+41224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[156160]=1;i=d;return}function Bhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(156288,cCc(+h[(c[g>>2]|0)+41216>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[156280]=1;i=d;return}function Chc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(156416,cCc(+h[(c[g>>2]|0)+41208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[156408]=1;i=d;return}function Dhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(156560,cCc(+h[(c[g>>2]|0)+41200>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[156552]=1;i=d;return}function Ehc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156696]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+512>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+512>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(156704,eCc(c[(c[g>>2]|0)+512>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[156696]=1;i=d;return}function Fhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[156912]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+508>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+508>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(156920,eCc(c[(c[g>>2]|0)+508>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[156912]=1;i=d;return}function Ghc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157128]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+504>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+504>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(157136,eCc(c[(c[g>>2]|0)+504>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[157128]=1;i=d;return}function Hhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157344]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+500>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+500>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(157352,eCc(c[(c[g>>2]|0)+500>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[157344]=1;i=d;return}function Ihc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157536]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+496>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+496>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(157544,eCc(c[(c[g>>2]|0)+496>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[157536]=1;i=d;return}function Jhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157728]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+492>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+492>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(157736,eCc(c[(c[g>>2]|0)+492>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[157728]=1;i=d;return}function Khc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[157920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41192>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(157928,cCc(+h[(c[g>>2]|0)+41192>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[157920]=1;i=d;return}function Lhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158064]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41184>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(158072,cCc(+h[(c[g>>2]|0)+41184>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158064]=1;i=d;return}function Mhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41176>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(158216,cCc(+h[(c[g>>2]|0)+41176>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158208]=1;i=d;return}function Nhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(158360,cCc(+h[(c[g>>2]|0)+41168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158352]=1;i=d;return}function Ohc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158472]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(158480,cCc(+h[(c[g>>2]|0)+41160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158472]=1;i=d;return}function Phc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158592]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(158600,cCc(+h[(c[g>>2]|0)+41152>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158592]=1;i=d;return}function Qhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158712]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(158720,cCc(+h[(c[g>>2]|0)+41144>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158712]=1;i=d;return}function Rhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(158832,cCc(+h[(c[g>>2]|0)+41136>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158824]=1;i=d;return}function Shc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[158928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(158936,cCc(+h[(c[g>>2]|0)+41128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[158928]=1;i=d;return}function Thc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(159088,cCc(+h[(c[g>>2]|0)+41120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[159080]=1;i=d;return}function Uhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(159232,cCc(+h[(c[g>>2]|0)+41096>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[159224]=1;i=d;return}function Vhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159328]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(159336,cCc(+h[(c[g>>2]|0)+41088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[159328]=1;i=d;return}function Whc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159440]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(159448,cCc(+h[(c[g>>2]|0)+41080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[159440]=1;i=d;return}function Xhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(159552,cCc(+h[(c[g>>2]|0)+41072>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[159544]=1;i=d;return}function Yhc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(159664,cCc(+h[(c[g>>2]|0)+41064>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[159656]=1;i=d;return}function Zhc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159784]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+488>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+488>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(159792,eCc(c[(c[g>>2]|0)+488>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[159784]=1;i=d;return}function _hc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[159984]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+484>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+484>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(159992,eCc(c[(c[g>>2]|0)+484>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[159984]=1;i=d;return}function $hc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160184]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+480>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+480>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(160192,eCc(c[(c[g>>2]|0)+480>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[160184]=1;i=d;return}function aic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160384]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+476>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+476>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(160392,eCc(c[(c[g>>2]|0)+476>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[160384]=1;i=d;return}function bic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160560]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+472>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+472>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(160568,eCc(c[(c[g>>2]|0)+472>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[160560]=1;i=d;return}function cic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160736]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+468>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+468>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(160744,eCc(c[(c[g>>2]|0)+468>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[160736]=1;i=d;return}function dic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[160912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(160920,cCc(+h[(c[g>>2]|0)+41048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[160912]=1;i=d;return}function eic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(161040,cCc(+h[(c[g>>2]|0)+41040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[161032]=1;i=d;return}function fic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161152]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(161160,cCc(+h[(c[g>>2]|0)+41032>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[161152]=1;i=d;return}function gic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(161304,cCc(+h[(c[g>>2]|0)+41024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[161296]=1;i=d;return}function hic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161440]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+464>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+464>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(161448,eCc(c[(c[g>>2]|0)+464>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[161440]=1;i=d;return}function iic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+460>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+460>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(161664,eCc(c[(c[g>>2]|0)+460>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[161656]=1;i=d;return}function jic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[161872]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+456>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+456>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(161880,eCc(c[(c[g>>2]|0)+456>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[161872]=1;i=d;return}function kic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162088]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+452>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+452>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(162096,eCc(c[(c[g>>2]|0)+452>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[162088]=1;i=d;return}function lic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162280]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+448>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+448>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(162288,eCc(c[(c[g>>2]|0)+448>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[162280]=1;i=d;return}function mic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+444>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+444>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(162480,eCc(c[(c[g>>2]|0)+444>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[162472]=1;i=d;return}function nic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41016>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(162672,cCc(+h[(c[g>>2]|0)+41016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[162664]=1;i=d;return}function oic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162808]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41008>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(162816,cCc(+h[(c[g>>2]|0)+41008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[162808]=1;i=d;return}function pic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[162952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+41e3>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(162960,cCc(+h[(c[g>>2]|0)+41e3>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[162952]=1;i=d;return}function qic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163104,cCc(+h[(c[g>>2]|0)+40992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163096]=1;i=d;return}function ric(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163224,cCc(+h[(c[g>>2]|0)+40984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163216]=1;i=d;return}function sic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163336]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163344,cCc(+h[(c[g>>2]|0)+40976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163336]=1;i=d;return}function tic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163464,cCc(+h[(c[g>>2]|0)+40968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163456]=1;i=d;return}function uic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163576,cCc(+h[(c[g>>2]|0)+40960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163568]=1;i=d;return}function vic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163680,cCc(+h[(c[g>>2]|0)+40952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163672]=1;i=d;return}function wic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163832,cCc(+h[(c[g>>2]|0)+40944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163824]=1;i=d;return}function xic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[163968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(163976,cCc(+h[(c[g>>2]|0)+40920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[163968]=1;i=d;return}function yic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(164080,cCc(+h[(c[g>>2]|0)+40912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[164072]=1;i=d;return}function zic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164184]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(164192,cCc(+h[(c[g>>2]|0)+40904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[164184]=1;i=d;return}function Aic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(164296,cCc(+h[(c[g>>2]|0)+40896>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[164288]=1;i=d;return}function Bic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(164408,cCc(+h[(c[g>>2]|0)+40888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[164400]=1;i=d;return}function Cic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164528]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+440>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+440>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(164536,eCc(c[(c[g>>2]|0)+440>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[164528]=1;i=d;return}function Dic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164728]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+436>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+436>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(164736,eCc(c[(c[g>>2]|0)+436>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[164728]=1;i=d;return}function Eic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[164928]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+432>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+432>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(164936,eCc(c[(c[g>>2]|0)+432>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[164928]=1;i=d;return}function Fic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165128]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+428>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+428>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(165136,eCc(c[(c[g>>2]|0)+428>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[165128]=1;i=d;return}function Gic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165304]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+424>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(165312,eCc(c[(c[g>>2]|0)+424>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[165304]=1;i=d;return}function Hic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165480]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+420>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+420>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(165488,eCc(c[(c[g>>2]|0)+420>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[165480]=1;i=d;return}function Iic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(165664,cCc(+h[(c[g>>2]|0)+40872>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[165656]=1;i=d;return}function Jic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(165784,cCc(+h[(c[g>>2]|0)+40864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[165776]=1;i=d;return}function Kic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[165896]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(165904,cCc(+h[(c[g>>2]|0)+40848>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[165896]=1;i=d;return}function Lic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(166024,cCc(+h[(c[g>>2]|0)+40840>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[166016]=1;i=d;return}function Mic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166136]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(166144,cCc(+h[(c[g>>2]|0)+40816>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[166136]=1;i=d;return}function Nic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166272]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(166280,cCc(+h[(c[g>>2]|0)+40808>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[166272]=1;i=d;return}function Oic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166408]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+416>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+416>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(166416,eCc(c[(c[g>>2]|0)+416>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[166408]=1;i=d;return}function Pic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166608]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+412>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(166616,eCc(c[(c[g>>2]|0)+412>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[166608]=1;i=d;return}function Qic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[166808]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+408>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+408>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(166816,eCc(c[(c[g>>2]|0)+408>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[166808]=1;i=d;return}function Ric(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167008]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+404>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+404>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(167016,eCc(c[(c[g>>2]|0)+404>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[167008]=1;i=d;return}function Sic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167192]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+400>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+400>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(167200,eCc(c[(c[g>>2]|0)+400>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[167192]=1;i=d;return}function Tic(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167376]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+396>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+396>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(167384,eCc(c[(c[g>>2]|0)+396>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[167376]=1;i=d;return}function Uic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40800>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(167568,cCc(+h[(c[g>>2]|0)+40800>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[167560]=1;i=d;return}function Vic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40792>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(167704,cCc(+h[(c[g>>2]|0)+40792>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[167696]=1;i=d;return}function Wic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40784>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(167840,cCc(+h[(c[g>>2]|0)+40784>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[167832]=1;i=d;return}function Xic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[167968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(167976,cCc(+h[(c[g>>2]|0)+40776>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[167968]=1;i=d;return}function Yic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168088,cCc(+h[(c[g>>2]|0)+40768>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168080]=1;i=d;return}function Zic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168192]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168200,cCc(+h[(c[g>>2]|0)+40760>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168192]=1;i=d;return}function _ic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168304]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168312,cCc(+h[(c[g>>2]|0)+40752>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168304]=1;i=d;return}function $ic(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168424,cCc(+h[(c[g>>2]|0)+40744>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168416]=1;i=d;return}function ajc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168512]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168520,cCc(+h[(c[g>>2]|0)+40736>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168512]=1;i=d;return}function bjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168664,cCc(+h[(c[g>>2]|0)+40728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168656]=1;i=d;return}function cjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168800]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168808,cCc(+h[(c[g>>2]|0)+40704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168800]=1;i=d;return}function djc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[168904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(168912,cCc(+h[(c[g>>2]|0)+40696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[168904]=1;i=d;return}function ejc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(169024,cCc(+h[(c[g>>2]|0)+40688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[169016]=1;i=d;return}function fjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169120]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(169128,cCc(+h[(c[g>>2]|0)+40680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[169120]=1;i=d;return}function gjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(169232,cCc(+h[(c[g>>2]|0)+40672>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[169224]=1;i=d;return}function hjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169344]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+392>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+392>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(169352,eCc(c[(c[g>>2]|0)+392>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[169344]=1;i=d;return}function ijc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169536]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+388>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+388>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(169544,eCc(c[(c[g>>2]|0)+388>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[169536]=1;i=d;return}function jjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169728]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+384>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+384>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(169736,eCc(c[(c[g>>2]|0)+384>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[169728]=1;i=d;return}function kjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[169920]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+380>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+380>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(169928,eCc(c[(c[g>>2]|0)+380>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[169920]=1;i=d;return}function ljc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170088]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+376>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+376>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(170096,eCc(c[(c[g>>2]|0)+376>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[170088]=1;i=d;return}function mjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170256]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+372>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+372>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(170264,eCc(c[(c[g>>2]|0)+372>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[170256]=1;i=d;return}function njc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(170432,cCc(+h[(c[g>>2]|0)+40656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[170424]=1;i=d;return}function ojc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(170544,cCc(+h[(c[g>>2]|0)+40648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[170536]=1;i=d;return}function pjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(170664,cCc(+h[(c[g>>2]|0)+40640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[170656]=1;i=d;return}function qjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170808]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(170816,cCc(+h[(c[g>>2]|0)+40632>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[170808]=1;i=d;return}function rjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[170952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(170960,cCc(+h[(c[g>>2]|0)+40608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[170952]=1;i=d;return}function sjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(171104,cCc(+h[(c[g>>2]|0)+40600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[171096]=1;i=d;return}function tjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171240]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+368>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+368>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(171248,eCc(c[(c[g>>2]|0)+368>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[171240]=1;i=d;return}function ujc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171456]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+364>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(171464,eCc(c[(c[g>>2]|0)+364>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[171456]=1;i=d;return}function vjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171672]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+360>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+360>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(171680,eCc(c[(c[g>>2]|0)+360>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[171672]=1;i=d;return}function wjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[171888]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+356>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+356>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(171896,eCc(c[(c[g>>2]|0)+356>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[171888]=1;i=d;return}function xjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172080]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+352>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(172088,eCc(c[(c[g>>2]|0)+352>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[172080]=1;i=d;return}function yjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172272]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+348>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+348>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(172280,eCc(c[(c[g>>2]|0)+348>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[172272]=1;i=d;return}function zjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172464]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40592>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(172472,cCc(+h[(c[g>>2]|0)+40592>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[172464]=1;i=d;return}function Ajc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172608]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40584>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(172616,cCc(+h[(c[g>>2]|0)+40584>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[172608]=1;i=d;return}function Bjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172752]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40576>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(172760,cCc(+h[(c[g>>2]|0)+40576>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[172752]=1;i=d;return}function Cjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[172896]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(172904,cCc(+h[(c[g>>2]|0)+40568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[172896]=1;i=d;return}function Djc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173024,cCc(+h[(c[g>>2]|0)+40560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173016]=1;i=d;return}function Ejc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173136]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173144,cCc(+h[(c[g>>2]|0)+40552>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173136]=1;i=d;return}function Fjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173256]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173264,cCc(+h[(c[g>>2]|0)+40544>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173256]=1;i=d;return}function Gjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173368]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173376,cCc(+h[(c[g>>2]|0)+40536>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173368]=1;i=d;return}function Hjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173472]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173480,cCc(+h[(c[g>>2]|0)+40520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173472]=1;i=d;return}function Ijc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173576]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173584,cCc(+h[(c[g>>2]|0)+40512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173576]=1;i=d;return}function Jjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173688]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173696,cCc(+h[(c[g>>2]|0)+40504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173688]=1;i=d;return}function Kjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173800,cCc(+h[(c[g>>2]|0)+40496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173792]=1;i=d;return}function Ljc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[173912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(173920,cCc(+h[(c[g>>2]|0)+40488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[173912]=1;i=d;return}function Mjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174040]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+344>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+344>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(174048,eCc(c[(c[g>>2]|0)+344>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[174040]=1;i=d;return}function Njc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174240]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+340>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(174248,eCc(c[(c[g>>2]|0)+340>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[174240]=1;i=d;return}function Ojc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174440]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+336>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+336>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(174448,eCc(c[(c[g>>2]|0)+336>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[174440]=1;i=d;return}function Pjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174640]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+332>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+332>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(174648,eCc(c[(c[g>>2]|0)+332>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[174640]=1;i=d;return}function Qjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174816]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+328>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(174824,eCc(c[(c[g>>2]|0)+328>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[174816]=1;i=d;return}function Rjc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[174992]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+324>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+324>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(175e3,eCc(c[(c[g>>2]|0)+324>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[174992]=1;i=d;return}function Sjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175176,cCc(+h[(c[g>>2]|0)+40472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175168]=1;i=d;return}function Tjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175296,cCc(+h[(c[g>>2]|0)+40464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175288]=1;i=d;return}function Ujc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175424,cCc(+h[(c[g>>2]|0)+40456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175416]=1;i=d;return}function Vjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175552,cCc(+h[(c[g>>2]|0)+40448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175544]=1;i=d;return}function Wjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175672,cCc(+h[(c[g>>2]|0)+40424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175664]=1;i=d;return}function Xjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175800,cCc(+h[(c[g>>2]|0)+40416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175792]=1;i=d;return}function Yjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[175912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(175920,cCc(+h[(c[g>>2]|0)+40408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[175912]=1;i=d;return}function Zjc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(176048,cCc(+h[(c[g>>2]|0)+40400>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[176040]=1;i=d;return}function _jc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176160]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1988>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1988>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(176168,eCc(c[(c[g>>2]|0)+1988>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[176160]=1;i=d;return}function $jc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40376>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(176352,cCc(+h[(c[g>>2]|0)+40376>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[176344]=1;i=d;return}function akc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176472]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(176480,cCc(+h[(c[g>>2]|0)+40368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[176472]=1;i=d;return}function bkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176592]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1984>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1984>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(176600,eCc(c[(c[g>>2]|0)+1984>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=211424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[176592]=1;i=d;return}function ckc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(176800,cCc(+h[(c[g>>2]|0)+40264>>3],7896)|0)|0;g=c[85376]|0;j=e;k=176904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[176792]=1;i=d;return}function dkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[176928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(176936,cCc(+h[(c[g>>2]|0)+40248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[176928]=1;i=d;return}function ekc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177056]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40240>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(177064,cCc(+h[(c[g>>2]|0)+40240>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[177056]=1;i=d;return}function fkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177176]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+320>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+320>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(177184,eCc(c[(c[g>>2]|0)+320>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[177176]=1;i=d;return}function gkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177352]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+316>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(177360,eCc(c[(c[g>>2]|0)+316>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[177352]=1;i=d;return}function hkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177528]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+312>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(177536,eCc(c[(c[g>>2]|0)+312>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[177528]=1;i=d;return}function ikc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[177704]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1980>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1980>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(177712,eCc(c[(c[g>>2]|0)+1980>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[177704]=1;i=d;return}function jkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(178024,cCc(+h[(c[g>>2]|0)+40208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[178016]=1;i=d;return}function kkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(178152,cCc(+h[(c[g>>2]|0)+40200>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[178144]=1;i=d;return}function lkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178264]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+308>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+308>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(178272,eCc(c[(c[g>>2]|0)+308>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[178264]=1;i=d;return}function mkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178440]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+304>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(178448,eCc(c[(c[g>>2]|0)+304>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[178440]=1;i=d;return}function nkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+300>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(178624,eCc(c[(c[g>>2]|0)+300>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[178616]=1;i=d;return}function okc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[178792]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1976>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1976>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(178800,eCc(c[(c[g>>2]|0)+1976>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[178792]=1;i=d;return}function pkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179104]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(179112,cCc(+h[(c[g>>2]|0)+40168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[179104]=1;i=d;return}function qkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179272]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(179280,cCc(+h[(c[g>>2]|0)+40160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[179272]=1;i=d;return}function rkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179432]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+296>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+296>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(179440,eCc(c[(c[g>>2]|0)+296>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[179432]=1;i=d;return}function skc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+292>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(179640,eCc(c[(c[g>>2]|0)+292>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[179632]=1;i=d;return}function tkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[179832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+288>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(179840,eCc(c[(c[g>>2]|0)+288>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[179832]=1;i=d;return}function ukc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1972>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1972>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(180064,eCc(c[(c[g>>2]|0)+1972>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[180056]=1;i=d;return}function vkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(180424,cCc(+h[(c[g>>2]|0)+40128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[180416]=1;i=d;return}function wkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180528]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(180536,cCc(+h[(c[g>>2]|0)+40120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[180528]=1;i=d;return}function xkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180632]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(180640,cCc(+h[(c[g>>2]|0)+40096>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[180632]=1;i=d;return}function ykc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(180792,cCc(+h[(c[g>>2]|0)+40088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[180784]=1;i=d;return}function zkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[180928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(180936,cCc(+h[(c[g>>2]|0)+40064>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[180928]=1;i=d;return}function Akc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(181080,cCc(+h[(c[g>>2]|0)+40056>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[181072]=1;i=d;return}function Bkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181216]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+284>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+284>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(181224,eCc(c[(c[g>>2]|0)+284>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[181216]=1;i=d;return}function Ckc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181432]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+280>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(181440,eCc(c[(c[g>>2]|0)+280>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[181432]=1;i=d;return}function Dkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181648]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+276>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(181656,eCc(c[(c[g>>2]|0)+276>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[181648]=1;i=d;return}function Ekc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[181864]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+272>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+272>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(181872,eCc(c[(c[g>>2]|0)+272>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[181864]=1;i=d;return}function Fkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+268>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(182064,eCc(c[(c[g>>2]|0)+268>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[182056]=1;i=d;return}function Gkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182248]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+264>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(182256,eCc(c[(c[g>>2]|0)+264>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[182248]=1;i=d;return}function Hkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182440]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40048>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(182448,cCc(+h[(c[g>>2]|0)+40048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[182440]=1;i=d;return}function Ikc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40040>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(182592,cCc(+h[(c[g>>2]|0)+40040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[182584]=1;i=d;return}function Jkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182728]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40032>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(182736,cCc(+h[(c[g>>2]|0)+40032>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[182728]=1;i=d;return}function Kkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(182880,cCc(+h[(c[g>>2]|0)+40024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[182872]=1;i=d;return}function Lkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[182992]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183e3,cCc(+h[(c[g>>2]|0)+40016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[182992]=1;i=d;return}function Mkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183112]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+40008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183120,cCc(+h[(c[g>>2]|0)+40008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183112]=1;i=d;return}function Nkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183232]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+4e4>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183240,cCc(+h[(c[g>>2]|0)+4e4>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183232]=1;i=d;return}function Okc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183352,cCc(+h[(c[g>>2]|0)+39992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183344]=1;i=d;return}function Pkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183448]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183456,cCc(+h[(c[g>>2]|0)+39976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183448]=1;i=d;return}function Qkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183560,cCc(+h[(c[g>>2]|0)+39968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183552]=1;i=d;return}function Rkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183672,cCc(+h[(c[g>>2]|0)+39960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183664]=1;i=d;return}function Skc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183768]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183776,cCc(+h[(c[g>>2]|0)+39952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183768]=1;i=d;return}function Tkc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[183888]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(183896,cCc(+h[(c[g>>2]|0)+39944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[183888]=1;i=d;return}function Ukc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184016]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+260>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(184024,eCc(c[(c[g>>2]|0)+260>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[184016]=1;i=d;return}function Vkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184216]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+256>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(184224,eCc(c[(c[g>>2]|0)+256>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[184216]=1;i=d;return}function Wkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184416]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+252>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(184424,eCc(c[(c[g>>2]|0)+252>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[184416]=1;i=d;return}function Xkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+248>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+248>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(184624,eCc(c[(c[g>>2]|0)+248>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[184616]=1;i=d;return}function Ykc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184792]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+244>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(184800,eCc(c[(c[g>>2]|0)+244>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[184792]=1;i=d;return}function Zkc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[184968]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+240>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(184976,eCc(c[(c[g>>2]|0)+240>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[184968]=1;i=d;return}function _kc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(185152,cCc(+h[(c[g>>2]|0)+39928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[185144]=1;i=d;return}function $kc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185264]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(185272,cCc(+h[(c[g>>2]|0)+39920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[185264]=1;i=d;return}function alc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185392]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(185400,cCc(+h[(c[g>>2]|0)+39912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[185392]=1;i=d;return}function blc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(185552,cCc(+h[(c[g>>2]|0)+39904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[185544]=1;i=d;return}function clc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185688]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39880>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(185696,cCc(+h[(c[g>>2]|0)+39880>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[185688]=1;i=d;return}function dlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39872>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(185840,cCc(+h[(c[g>>2]|0)+39872>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[185832]=1;i=d;return}function elc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[185976]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+236>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+236>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(185984,eCc(c[(c[g>>2]|0)+236>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[185976]=1;i=d;return}function flc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186192]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+232>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(186200,eCc(c[(c[g>>2]|0)+232>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[186192]=1;i=d;return}function glc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186408]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+228>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(186416,eCc(c[(c[g>>2]|0)+228>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[186408]=1;i=d;return}function hlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186624]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+224>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(186632,eCc(c[(c[g>>2]|0)+224>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[186624]=1;i=d;return}function ilc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[186816]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+220>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(186824,eCc(c[(c[g>>2]|0)+220>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[186816]=1;i=d;return}function jlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187008]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+216>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+216>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(187016,eCc(c[(c[g>>2]|0)+216>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[187008]=1;i=d;return}function klc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39864>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(187208,cCc(+h[(c[g>>2]|0)+39864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187200]=1;i=d;return}function llc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39856>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(187352,cCc(+h[(c[g>>2]|0)+39856>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187344]=1;i=d;return}function mlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187488]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39848>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(187496,cCc(+h[(c[g>>2]|0)+39848>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187488]=1;i=d;return}function nlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187632]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(187640,cCc(+h[(c[g>>2]|0)+39840>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187632]=1;i=d;return}function olc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187752]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39832>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(187760,cCc(+h[(c[g>>2]|0)+39832>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187752]=1;i=d;return}function plc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39824>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(187880,cCc(+h[(c[g>>2]|0)+39824>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187872]=1;i=d;return}function qlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[187992]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188e3,cCc(+h[(c[g>>2]|0)+39816>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[187992]=1;i=d;return}function rlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188104]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188112,cCc(+h[(c[g>>2]|0)+39808>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[188104]=1;i=d;return}function slc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39792>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188216,cCc(+h[(c[g>>2]|0)+39792>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[188208]=1;i=d;return}function tlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39784>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188320,cCc(+h[(c[g>>2]|0)+39784>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[188312]=1;i=d;return}function ulc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188432,cCc(+h[(c[g>>2]|0)+39776>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[188424]=1;i=d;return}function vlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188528]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39768>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188536,cCc(+h[(c[g>>2]|0)+39768>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[188528]=1;i=d;return}function wlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188648]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(188656,cCc(+h[(c[g>>2]|0)+39760>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[188648]=1;i=d;return}function xlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188776]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+212>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(188784,eCc(c[(c[g>>2]|0)+212>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[188776]=1;i=d;return}function ylc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[188976]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+208>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(188984,eCc(c[(c[g>>2]|0)+208>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[188976]=1;i=d;return}function zlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189176]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+204>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(189184,eCc(c[(c[g>>2]|0)+204>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[189176]=1;i=d;return}function Alc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189376]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+200>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(189384,eCc(c[(c[g>>2]|0)+200>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[189376]=1;i=d;return}function Blc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189552]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+196>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(189560,eCc(c[(c[g>>2]|0)+196>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[189552]=1;i=d;return}function Clc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189728]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+192>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(189736,eCc(c[(c[g>>2]|0)+192>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[189728]=1;i=d;return}function Dlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[189904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(189912,cCc(+h[(c[g>>2]|0)+39744>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[189904]=1;i=d;return}function Elc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(190032,cCc(+h[(c[g>>2]|0)+39736>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[190024]=1;i=d;return}



function b5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45760>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53024,cCc(+h[(c[g>>2]|0)+45760>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53016]=1;i=d;return}function c5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53136]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45752>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53144,cCc(+h[(c[g>>2]|0)+45752>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53136]=1;i=d;return}function d5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53256]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45744>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53264,cCc(+h[(c[g>>2]|0)+45744>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53256]=1;i=d;return}function e5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53376]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45736>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53384,cCc(+h[(c[g>>2]|0)+45736>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53376]=1;i=d;return}function f5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53488]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53496,cCc(+h[(c[g>>2]|0)+45728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53488]=1;i=d;return}function g5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53592]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45712>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53600,cCc(+h[(c[g>>2]|0)+45712>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53592]=1;i=d;return}function h5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53704,cCc(+h[(c[g>>2]|0)+45704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53696]=1;i=d;return}function i5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53808]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45696>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53816,cCc(+h[(c[g>>2]|0)+45696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53808]=1;i=d;return}function j5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[53912]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(53920,cCc(+h[(c[g>>2]|0)+45688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[53912]=1;i=d;return}function k5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(54040,cCc(+h[(c[g>>2]|0)+45680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[54032]=1;i=d;return}function l5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54160]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1508>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1508>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(54168,eCc(c[(c[g>>2]|0)+1508>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54160]=1;i=d;return}function m5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54360]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1504>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1504>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(54368,eCc(c[(c[g>>2]|0)+1504>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54360]=1;i=d;return}function n5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54560]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1500>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1500>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(54568,eCc(c[(c[g>>2]|0)+1500>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54560]=1;i=d;return}function o5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54760]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1496>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1496>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(54768,eCc(c[(c[g>>2]|0)+1496>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54760]=1;i=d;return}function p5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[54936]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1492>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1492>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(54944,eCc(c[(c[g>>2]|0)+1492>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[54936]=1;i=d;return}function q5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55112]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1488>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1488>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(55120,eCc(c[(c[g>>2]|0)+1488>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[55112]=1;i=d;return}function r5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(55296,cCc(+h[(c[g>>2]|0)+45664>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55288]=1;i=d;return}function s5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(55416,cCc(+h[(c[g>>2]|0)+45656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55408]=1;i=d;return}function t5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(55544,cCc(+h[(c[g>>2]|0)+45648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55536]=1;i=d;return}function u5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55680]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(55688,cCc(+h[(c[g>>2]|0)+45640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[55680]=1;i=d;return}function v5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[55824]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1484>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1484>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(55832,eCc(c[(c[g>>2]|0)+1484>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[55824]=1;i=d;return}function w5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56040]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1480>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1480>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(56048,eCc(c[(c[g>>2]|0)+1480>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56040]=1;i=d;return}function x5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56256]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1476>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1476>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(56264,eCc(c[(c[g>>2]|0)+1476>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56256]=1;i=d;return}function y5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1472>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1472>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(56480,eCc(c[(c[g>>2]|0)+1472>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56472]=1;i=d;return}function z5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56664]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1468>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1468>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(56672,eCc(c[(c[g>>2]|0)+1468>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56664]=1;i=d;return}function A5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[56856]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1464>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1464>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(56864,eCc(c[(c[g>>2]|0)+1464>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[56856]=1;i=d;return}function B5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45632>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(57056,cCc(+h[(c[g>>2]|0)+45632>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57048]=1;i=d;return}function C5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57192]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45624>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(57200,cCc(+h[(c[g>>2]|0)+45624>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57192]=1;i=d;return}function D5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57336]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45616>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(57344,cCc(+h[(c[g>>2]|0)+45616>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57336]=1;i=d;return}function E5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57480]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(57488,cCc(+h[(c[g>>2]|0)+45608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57480]=1;i=d;return}function F5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(57608,cCc(+h[(c[g>>2]|0)+45600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57600]=1;i=d;return}function G5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57720]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(57728,cCc(+h[(c[g>>2]|0)+45592>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57720]=1;i=d;return}function H5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(57848,cCc(+h[(c[g>>2]|0)+45584>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57840]=1;i=d;return}function I5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[57952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(57960,cCc(+h[(c[g>>2]|0)+45576>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[57952]=1;i=d;return}function J5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58056]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58064,cCc(+h[(c[g>>2]|0)+45568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58056]=1;i=d;return}function K5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58216,cCc(+h[(c[g>>2]|0)+45560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58208]=1;i=d;return}function L5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58360,cCc(+h[(c[g>>2]|0)+45536>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58352]=1;i=d;return}function M5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58464,cCc(+h[(c[g>>2]|0)+45528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58456]=1;i=d;return}function N5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45520>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58576,cCc(+h[(c[g>>2]|0)+45520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58568]=1;i=d;return}function O5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58680,cCc(+h[(c[g>>2]|0)+45512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58672]=1;i=d;return}function P5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(58792,cCc(+h[(c[g>>2]|0)+45504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[58784]=1;i=d;return}function Q5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[58912]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1460>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1460>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(58920,eCc(c[(c[g>>2]|0)+1460>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[58912]=1;i=d;return}function R5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59112]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1456>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1456>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(59120,eCc(c[(c[g>>2]|0)+1456>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[59112]=1;i=d;return}function S5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59312]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1452>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1452>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(59320,eCc(c[(c[g>>2]|0)+1452>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[59312]=1;i=d;return}function T5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59512]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1448>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1448>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(59520,eCc(c[(c[g>>2]|0)+1448>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[59512]=1;i=d;return}function U5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59688]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1444>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1444>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(59696,eCc(c[(c[g>>2]|0)+1444>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[59688]=1;i=d;return}function V5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[59864]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1440>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1440>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(59872,eCc(c[(c[g>>2]|0)+1440>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[59864]=1;i=d;return}function W5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(60048,cCc(+h[(c[g>>2]|0)+45488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60040]=1;i=d;return}function X5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(60168,cCc(+h[(c[g>>2]|0)+45480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60160]=1;i=d;return}function Y5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(60288,cCc(+h[(c[g>>2]|0)+45472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60280]=1;i=d;return}function Z5b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(60432,cCc(+h[(c[g>>2]|0)+45464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[60424]=1;i=d;return}function _5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60568]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1436>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1436>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(60576,eCc(c[(c[g>>2]|0)+1436>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[60568]=1;i=d;return}function $5b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[60784]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1432>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1432>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(60792,eCc(c[(c[g>>2]|0)+1432>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[60784]=1;i=d;return}function a6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61e3]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1428>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1428>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(61008,eCc(c[(c[g>>2]|0)+1428>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61e3]=1;i=d;return}function b6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61216]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1424>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1424>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(61224,eCc(c[(c[g>>2]|0)+1424>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61216]=1;i=d;return}function c6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61408]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1420>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1420>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(61416,eCc(c[(c[g>>2]|0)+1420>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61408]=1;i=d;return}function d6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61600]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1416>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1416>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(61608,eCc(c[(c[g>>2]|0)+1416>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[61600]=1;i=d;return}function e6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45456>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(61800,cCc(+h[(c[g>>2]|0)+45456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61792]=1;i=d;return}function f6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[61936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45448>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(61944,cCc(+h[(c[g>>2]|0)+45448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[61936]=1;i=d;return}function g6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45440>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(62088,cCc(+h[(c[g>>2]|0)+45440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62080]=1;i=d;return}function h6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62232,cCc(+h[(c[g>>2]|0)+45432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62224]=1;i=d;return}function i6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62344]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62352,cCc(+h[(c[g>>2]|0)+45424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62344]=1;i=d;return}function j6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62464]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62472,cCc(+h[(c[g>>2]|0)+45416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62464]=1;i=d;return}function k6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62584]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62592,cCc(+h[(c[g>>2]|0)+45408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62584]=1;i=d;return}function l6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62704,cCc(+h[(c[g>>2]|0)+45400>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62696]=1;i=d;return}function m6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62800]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62808,cCc(+h[(c[g>>2]|0)+45392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62800]=1;i=d;return}function n6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[62952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(62960,cCc(+h[(c[g>>2]|0)+45384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[62952]=1;i=d;return}function o6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(63104,cCc(+h[(c[g>>2]|0)+45360>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[63096]=1;i=d;return}function p6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(63208,cCc(+h[(c[g>>2]|0)+45352>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[63200]=1;i=d;return}function q6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(63320,cCc(+h[(c[g>>2]|0)+45344>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[63312]=1;i=d;return}function r6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(63424,cCc(+h[(c[g>>2]|0)+45336>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[63416]=1;i=d;return}function s6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63528]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(63536,cCc(+h[(c[g>>2]|0)+45328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[63528]=1;i=d;return}function t6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1412>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1412>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(63664,eCc(c[(c[g>>2]|0)+1412>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63656]=1;i=d;return}function u6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[63856]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1408>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1408>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(63864,eCc(c[(c[g>>2]|0)+1408>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[63856]=1;i=d;return}function v6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1404>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1404>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(64064,eCc(c[(c[g>>2]|0)+1404>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[64056]=1;i=d;return}function w6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64256]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1400>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1400>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(64264,eCc(c[(c[g>>2]|0)+1400>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[64256]=1;i=d;return}function x6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64432]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1396>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1396>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(64440,eCc(c[(c[g>>2]|0)+1396>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[64432]=1;i=d;return}function y6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64608]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1392>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1392>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(64616,eCc(c[(c[g>>2]|0)+1392>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[64608]=1;i=d;return}function z6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(64792,cCc(+h[(c[g>>2]|0)+45312>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64784]=1;i=d;return}function A6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[64904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45304>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(64912,cCc(+h[(c[g>>2]|0)+45304>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[64904]=1;i=d;return}function B6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(65032,cCc(+h[(c[g>>2]|0)+45288>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[65024]=1;i=d;return}function C6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(65152,cCc(+h[(c[g>>2]|0)+45280>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[65144]=1;i=d;return}function D6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65264]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(65272,cCc(+h[(c[g>>2]|0)+45256>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[65264]=1;i=d;return}function E6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(65408,cCc(+h[(c[g>>2]|0)+45248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[65400]=1;i=d;return}function F6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65536]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1388>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1388>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(65544,eCc(c[(c[g>>2]|0)+1388>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65536]=1;i=d;return}function G6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65736]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1384>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1384>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(65744,eCc(c[(c[g>>2]|0)+1384>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65736]=1;i=d;return}function H6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[65936]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1380>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1380>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(65944,eCc(c[(c[g>>2]|0)+1380>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[65936]=1;i=d;return}function I6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66136]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1376>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1376>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(66144,eCc(c[(c[g>>2]|0)+1376>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[66136]=1;i=d;return}function J6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66320]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1372>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1372>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(66328,eCc(c[(c[g>>2]|0)+1372>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[66320]=1;i=d;return}function K6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66504]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1368>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1368>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(66512,eCc(c[(c[g>>2]|0)+1368>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[66504]=1;i=d;return}function L6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66688]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45240>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(66696,cCc(+h[(c[g>>2]|0)+45240>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66688]=1;i=d;return}function M6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45232>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(66832,cCc(+h[(c[g>>2]|0)+45232>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66824]=1;i=d;return}function N6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[66960]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45224>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(66968,cCc(+h[(c[g>>2]|0)+45224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[66960]=1;i=d;return}function O6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67104,cCc(+h[(c[g>>2]|0)+45216>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67096]=1;i=d;return}function P6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67216,cCc(+h[(c[g>>2]|0)+45208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67208]=1;i=d;return}function Q6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67320]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67328,cCc(+h[(c[g>>2]|0)+45200>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67320]=1;i=d;return}function R6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67432]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67440,cCc(+h[(c[g>>2]|0)+45192>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67432]=1;i=d;return}function S6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45184>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67552,cCc(+h[(c[g>>2]|0)+45184>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67544]=1;i=d;return}function T6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67648,cCc(+h[(c[g>>2]|0)+45176>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67640]=1;i=d;return}function U6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67792,cCc(+h[(c[g>>2]|0)+45168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67784]=1;i=d;return}function V6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[67928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45144>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(67936,cCc(+h[(c[g>>2]|0)+45144>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[67928]=1;i=d;return}function W6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45136>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(68040,cCc(+h[(c[g>>2]|0)+45136>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[68032]=1;i=d;return}function X6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(68152,cCc(+h[(c[g>>2]|0)+45128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[68144]=1;i=d;return}function Y6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68248]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(68256,cCc(+h[(c[g>>2]|0)+45120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[68248]=1;i=d;return}function Z6b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(68360,cCc(+h[(c[g>>2]|0)+45112>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[68352]=1;i=d;return}function _6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1364>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1364>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(68480,eCc(c[(c[g>>2]|0)+1364>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68472]=1;i=d;return}function $6b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68664]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1360>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1360>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(68672,eCc(c[(c[g>>2]|0)+1360>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68664]=1;i=d;return}function a7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[68856]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1356>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1356>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(68864,eCc(c[(c[g>>2]|0)+1356>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[68856]=1;i=d;return}function b7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69048]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1352>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1352>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(69056,eCc(c[(c[g>>2]|0)+1352>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[69048]=1;i=d;return}function c7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69216]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1348>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1348>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(69224,eCc(c[(c[g>>2]|0)+1348>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[69216]=1;i=d;return}function d7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69384]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1344>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1344>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(69392,eCc(c[(c[g>>2]|0)+1344>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[69384]=1;i=d;return}function e7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45096>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(69560,cCc(+h[(c[g>>2]|0)+45096>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69552]=1;i=d;return}function f7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(69672,cCc(+h[(c[g>>2]|0)+45088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69664]=1;i=d;return}function g7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69784]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(69792,cCc(+h[(c[g>>2]|0)+45080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69784]=1;i=d;return}function h7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[69936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(69944,cCc(+h[(c[g>>2]|0)+45072>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[69936]=1;i=d;return}function i7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45048>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(70088,cCc(+h[(c[g>>2]|0)+45048>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[70080]=1;i=d;return}function j7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70224]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(70232,cCc(+h[(c[g>>2]|0)+45040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[70224]=1;i=d;return}function k7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70368]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1340>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1340>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(70376,eCc(c[(c[g>>2]|0)+1340>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70368]=1;i=d;return}function l7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70584]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1336>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1336>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(70592,eCc(c[(c[g>>2]|0)+1336>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70584]=1;i=d;return}function m7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[70800]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1332>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1332>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(70808,eCc(c[(c[g>>2]|0)+1332>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[70800]=1;i=d;return}function n7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71016]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1328>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1328>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(71024,eCc(c[(c[g>>2]|0)+1328>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[71016]=1;i=d;return}function o7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71208]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1324>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1324>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(71216,eCc(c[(c[g>>2]|0)+1324>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[71208]=1;i=d;return}function p7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71400]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1320>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1320>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(71408,eCc(c[(c[g>>2]|0)+1320>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[71400]=1;i=d;return}function q7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71592]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45032>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(71600,cCc(+h[(c[g>>2]|0)+45032>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71592]=1;i=d;return}function r7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71736]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45024>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(71744,cCc(+h[(c[g>>2]|0)+45024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71736]=1;i=d;return}function s7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[71880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45016>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(71888,cCc(+h[(c[g>>2]|0)+45016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[71880]=1;i=d;return}function t7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72032,cCc(+h[(c[g>>2]|0)+45008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72024]=1;i=d;return}function u7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+45e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72152,cCc(+h[(c[g>>2]|0)+45e3>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72144]=1;i=d;return}function v7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72264]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72272,cCc(+h[(c[g>>2]|0)+44992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72264]=1;i=d;return}function w7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72384]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72392,cCc(+h[(c[g>>2]|0)+44984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72384]=1;i=d;return}function x7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72504,cCc(+h[(c[g>>2]|0)+44976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72496]=1;i=d;return}function y7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44960>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72608,cCc(+h[(c[g>>2]|0)+44960>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72600]=1;i=d;return}function z7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72704]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44952>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72712,cCc(+h[(c[g>>2]|0)+44952>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72704]=1;i=d;return}function A7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72816]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72824,cCc(+h[(c[g>>2]|0)+44944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72816]=1;i=d;return}function B7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[72920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(72928,cCc(+h[(c[g>>2]|0)+44936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[72920]=1;i=d;return}function C7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(73048,cCc(+h[(c[g>>2]|0)+44928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[73040]=1;i=d;return}function D7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73168]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1316>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1316>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(73176,eCc(c[(c[g>>2]|0)+1316>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73168]=1;i=d;return}function E7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73368]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1312>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1312>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(73376,eCc(c[(c[g>>2]|0)+1312>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73368]=1;i=d;return}function F7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73568]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1308>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1308>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(73576,eCc(c[(c[g>>2]|0)+1308>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73568]=1;i=d;return}function G7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73768]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1304>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1304>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(73776,eCc(c[(c[g>>2]|0)+1304>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73768]=1;i=d;return}function H7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[73944]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1300>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1300>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(73952,eCc(c[(c[g>>2]|0)+1300>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[73944]=1;i=d;return}function I7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74120]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1296>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1296>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(74128,eCc(c[(c[g>>2]|0)+1296>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[74120]=1;i=d;return}function J7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44912>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(74304,cCc(+h[(c[g>>2]|0)+44912>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74296]=1;i=d;return}function K7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44904>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(74424,cCc(+h[(c[g>>2]|0)+44904>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74416]=1;i=d;return}function L7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(74552,cCc(+h[(c[g>>2]|0)+44896>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74544]=1;i=d;return}function M7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(74680,cCc(+h[(c[g>>2]|0)+44888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74672]=1;i=d;return}function N7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44864>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(74800,cCc(+h[(c[g>>2]|0)+44864>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74792]=1;i=d;return}function O7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[74920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44856>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(74928,cCc(+h[(c[g>>2]|0)+44856>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[74920]=1;i=d;return}function P7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44848>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(75048,cCc(+h[(c[g>>2]|0)+44848>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75040]=1;i=d;return}function Q7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75168]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44840>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(75176,cCc(+h[(c[g>>2]|0)+44840>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75168]=1;i=d;return}function R7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75288]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2048>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2048>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(75296,eCc(c[(c[g>>2]|0)+2048>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[75288]=1;i=d;return}function S7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75472]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44816>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(75480,cCc(+h[(c[g>>2]|0)+44816>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75472]=1;i=d;return}function T7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75600]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44808>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(75608,cCc(+h[(c[g>>2]|0)+44808>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75600]=1;i=d;return}function U7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75720]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2044>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2044>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(75728,eCc(c[(c[g>>2]|0)+2044>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=211424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[75720]=1;i=d;return}function V7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[75920]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44704>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(75928,cCc(+h[(c[g>>2]|0)+44704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=176904;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[75920]=1;i=d;return}function W7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(76040,cCc(+h[(c[g>>2]|0)+44688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76032]=1;i=d;return}function X7b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(76168,cCc(+h[(c[g>>2]|0)+44680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[76160]=1;i=d;return}function Y7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76280]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1292>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1292>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(76288,eCc(c[(c[g>>2]|0)+1292>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[76280]=1;i=d;return}function Z7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76456]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1288>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1288>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(76464,eCc(c[(c[g>>2]|0)+1288>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[76456]=1;i=d;return}function _7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1284>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1284>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(76640,eCc(c[(c[g>>2]|0)+1284>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[76632]=1;i=d;return}function $7b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[76808]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2040>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2040>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(76816,eCc(c[(c[g>>2]|0)+2040>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[76808]=1;i=d;return}function a8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77120]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(77128,cCc(+h[(c[g>>2]|0)+44648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[77120]=1;i=d;return}function b8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77248]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(77256,cCc(+h[(c[g>>2]|0)+44640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[77248]=1;i=d;return}function c8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77368]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1280>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1280>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(77376,eCc(c[(c[g>>2]|0)+1280>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77368]=1;i=d;return}function d8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77544]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1276>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1276>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(77552,eCc(c[(c[g>>2]|0)+1276>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77544]=1;i=d;return}function e8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77720]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1272>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1272>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(77728,eCc(c[(c[g>>2]|0)+1272>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77720]=1;i=d;return}function f8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[77896]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2036>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2036>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(77904,eCc(c[(c[g>>2]|0)+2036>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[77896]=1;i=d;return}function g8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(78216,cCc(+h[(c[g>>2]|0)+44608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78208]=1;i=d;return}function h8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(78360,cCc(+h[(c[g>>2]|0)+44600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=179408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[78352]=1;i=d;return}function i8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78488]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1268>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1268>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(78496,eCc(c[(c[g>>2]|0)+1268>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[78488]=1;i=d;return}function j8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78688]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1264>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1264>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(78696,eCc(c[(c[g>>2]|0)+1264>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[78688]=1;i=d;return}function k8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[78888]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1260>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1260>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(78896,eCc(c[(c[g>>2]|0)+1260>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[78888]=1;i=d;return}function l8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79088]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+2032>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+2032>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(79096,eCc(c[(c[g>>2]|0)+2032>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=180392;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[79088]=1;i=d;return}function m8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(79432,cCc(+h[(c[g>>2]|0)+44568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79424]=1;i=d;return}function n8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79536]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(79544,cCc(+h[(c[g>>2]|0)+44560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79536]=1;i=d;return}function o8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(79648,cCc(+h[(c[g>>2]|0)+44536>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79640]=1;i=d;return}function p8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44528>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(79800,cCc(+h[(c[g>>2]|0)+44528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79792]=1;i=d;return}function q8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[79936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(79944,cCc(+h[(c[g>>2]|0)+44504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[79936]=1;i=d;return}function r8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(80088,cCc(+h[(c[g>>2]|0)+44496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[80080]=1;i=d;return}function s8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1256>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1256>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(80232,eCc(c[(c[g>>2]|0)+1256>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80224]=1;i=d;return}function t8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80440]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1252>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1252>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(80448,eCc(c[(c[g>>2]|0)+1252>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80440]=1;i=d;return}function u8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1248>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1248>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(80664,eCc(c[(c[g>>2]|0)+1248>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80656]=1;i=d;return}function v8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[80872]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1244>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1244>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(80880,eCc(c[(c[g>>2]|0)+1244>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[80872]=1;i=d;return}function w8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81064]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1240>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1240>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(81072,eCc(c[(c[g>>2]|0)+1240>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[81064]=1;i=d;return}function x8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81256]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1236>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1236>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(81264,eCc(c[(c[g>>2]|0)+1236>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[81256]=1;i=d;return}function y8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81448]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44488>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(81456,cCc(+h[(c[g>>2]|0)+44488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81448]=1;i=d;return}function z8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81592]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44480>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(81600,cCc(+h[(c[g>>2]|0)+44480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81592]=1;i=d;return}function A8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81736]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44472>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(81744,cCc(+h[(c[g>>2]|0)+44472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81736]=1;i=d;return}function B8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[81880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(81888,cCc(+h[(c[g>>2]|0)+44464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[81880]=1;i=d;return}function C8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82e3]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44456>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82008,cCc(+h[(c[g>>2]|0)+44456>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82e3]=1;i=d;return}function D8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82120]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82128,cCc(+h[(c[g>>2]|0)+44448>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82120]=1;i=d;return}function E8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82240]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82248,cCc(+h[(c[g>>2]|0)+44440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82240]=1;i=d;return}function F8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82360,cCc(+h[(c[g>>2]|0)+44432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82352]=1;i=d;return}function G8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82464,cCc(+h[(c[g>>2]|0)+44416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82456]=1;i=d;return}function H8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82560]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82568,cCc(+h[(c[g>>2]|0)+44408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82560]=1;i=d;return}function I8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44400>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82680,cCc(+h[(c[g>>2]|0)+44400>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82672]=1;i=d;return}function J8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82784,cCc(+h[(c[g>>2]|0)+44392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82776]=1;i=d;return}function K8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[82896]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(82904,cCc(+h[(c[g>>2]|0)+44384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[82896]=1;i=d;return}function L8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83024]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1232>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1232>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(83032,eCc(c[(c[g>>2]|0)+1232>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83024]=1;i=d;return}function M8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1228>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1228>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(83232,eCc(c[(c[g>>2]|0)+1228>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83224]=1;i=d;return}function N8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83424]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1224>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1224>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(83432,eCc(c[(c[g>>2]|0)+1224>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83424]=1;i=d;return}function O8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83624]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1220>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1220>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(83632,eCc(c[(c[g>>2]|0)+1220>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83624]=1;i=d;return}function P8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83800]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1216>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1216>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(83808,eCc(c[(c[g>>2]|0)+1216>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83800]=1;i=d;return}function Q8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[83976]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1212>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1212>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(83984,eCc(c[(c[g>>2]|0)+1212>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[83976]=1;i=d;return}function R8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84152]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(84160,cCc(+h[(c[g>>2]|0)+44368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84152]=1;i=d;return}function S8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84272]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(84280,cCc(+h[(c[g>>2]|0)+44360>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84272]=1;i=d;return}function T8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44352>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(84408,cCc(+h[(c[g>>2]|0)+44352>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84400]=1;i=d;return}function U8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44344>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(84560,cCc(+h[(c[g>>2]|0)+44344>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84552]=1;i=d;return}function V8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44320>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(84704,cCc(+h[(c[g>>2]|0)+44320>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84696]=1;i=d;return}function W8b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(84848,cCc(+h[(c[g>>2]|0)+44312>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[84840]=1;i=d;return}function X8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[84984]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1208>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1208>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(84992,eCc(c[(c[g>>2]|0)+1208>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[84984]=1;i=d;return}function Y8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85200]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1204>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1204>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(85208,eCc(c[(c[g>>2]|0)+1204>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[85200]=1;i=d;return}function Z8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85416]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1200>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1200>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(85424,eCc(c[(c[g>>2]|0)+1200>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[85416]=1;i=d;return}function _8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1196>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1196>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(85640,eCc(c[(c[g>>2]|0)+1196>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[85632]=1;i=d;return}function $8b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[85824]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1192>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1192>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(85832,eCc(c[(c[g>>2]|0)+1192>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[85824]=1;i=d;return}function a9b(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86016]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1188>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(86024,eCc(c[(c[g>>2]|0)+1188>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[86016]=1;i=d;return}function b9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86208]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44304>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(86216,cCc(+h[(c[g>>2]|0)+44304>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86208]=1;i=d;return}function c9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44296>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(86360,cCc(+h[(c[g>>2]|0)+44296>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86352]=1;i=d;return}function d9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44288>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(86504,cCc(+h[(c[g>>2]|0)+44288>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86496]=1;i=d;return}function e9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(86648,cCc(+h[(c[g>>2]|0)+44280>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86640]=1;i=d;return}function f9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86760]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(86768,cCc(+h[(c[g>>2]|0)+44272>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86760]=1;i=d;return}function g9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[86880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(86888,cCc(+h[(c[g>>2]|0)+44264>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[86880]=1;i=d;return}function h9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87e3]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87008,cCc(+h[(c[g>>2]|0)+44256>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87e3]=1;i=d;return}function i9b(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[87112]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+44248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(87120,cCc(+h[(c[g>>2]|0)+44248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[87112]=1;i=d;return}



function OEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;b=i;d=a+4|0;e=c[d>>2]|0;f=0;do{g=c[e+(f<<2)>>2]|0;i4c(c[g+8>>2]|0);i4c(c[g+12>>2]|0);i4c(c[g+16>>2]|0);i4c(c[g+20>>2]|0);f=f+1|0;e=c[d>>2]|0}while(f>>>0<3);i4c(e);KCc(c[a>>2]|0);e=a+116|0;f=a+8|0;d=c[f>>2]|0;if((c[e>>2]|0)==0){h=d}else{g=d;d=0;while(1){fDc(g+(d*112|0)|0);j=d+1|0;k=c[f>>2]|0;if(j>>>0<(c[e>>2]|0)>>>0){d=j;g=k}else{h=k;break}}}i4c(h);h=a+124|0;g=a+12|0;d=c[g>>2]|0;if((c[h>>2]|0)==0){l=d}else{e=d;d=0;while(1){fDc(e+(d*60|0)|0);f=d+1|0;k=c[g>>2]|0;if(f>>>0<(c[h>>2]|0)>>>0){d=f;e=k}else{l=k;break}}}i4c(l);l=a+128|0;e=a+16|0;d=c[e>>2]|0;if((c[l>>2]|0)==0){m=d}else{h=d;d=0;while(1){fDc(h+(d*48|0)|0);g=d+1|0;k=c[e>>2]|0;if(g>>>0<(c[l>>2]|0)>>>0){d=g;h=k}else{m=k;break}}}i4c(m);m=a+132|0;h=a+20|0;d=c[h>>2]|0;if((c[m>>2]|0)==0){n=d}else{l=d;d=0;while(1){fDc(l+(d*52|0)|0);e=d+1|0;k=c[h>>2]|0;if(e>>>0<(c[m>>2]|0)>>>0){d=e;l=k}else{n=k;break}}}i4c(n);n=a+136|0;l=a+24|0;d=c[l>>2]|0;if((c[n>>2]|0)==0){o=d}else{m=d;d=0;while(1){fDc(m+(d*112|0)|0);h=d+1|0;k=c[l>>2]|0;if(h>>>0<(c[n>>2]|0)>>>0){d=h;m=k}else{o=k;break}}}i4c(o);o=a+140|0;m=a+28|0;d=c[m>>2]|0;if((c[o>>2]|0)==0){p=d}else{n=d;d=0;while(1){fDc(n+(d*60|0)|0);l=d+1|0;k=c[m>>2]|0;if(l>>>0<(c[o>>2]|0)>>>0){d=l;n=k}else{p=k;break}}}i4c(p);p=a+144|0;n=a+32|0;d=c[n>>2]|0;if((c[p>>2]|0)==0){q=d}else{o=d;d=0;while(1){fDc(o+(d*48|0)|0);m=d+1|0;k=c[n>>2]|0;if(m>>>0<(c[p>>2]|0)>>>0){d=m;o=k}else{q=k;break}}}i4c(q);q=a+148|0;o=a+36|0;d=c[o>>2]|0;if((c[q>>2]|0)==0){r=d}else{p=d;d=0;while(1){fDc(p+(d*52|0)|0);n=d+1|0;k=c[o>>2]|0;if(n>>>0<(c[q>>2]|0)>>>0){d=n;p=k}else{r=k;break}}}i4c(r);r=a+216|0;p=a+40|0;d=c[p>>2]|0;if((c[r>>2]|0)==0){s=d}else{q=d;d=0;while(1){fDc(q+(d*52|0)+12|0);o=d+1|0;k=c[p>>2]|0;if(o>>>0<(c[r>>2]|0)>>>0){d=o;q=k}else{s=k;break}}}i4c(s);s=a+220|0;q=a+44|0;d=c[q>>2]|0;if((c[s>>2]|0)==0){t=d}else{r=d;d=0;while(1){fDc(r+(d*52|0)+12|0);p=d+1|0;k=c[q>>2]|0;if(p>>>0<(c[s>>2]|0)>>>0){d=p;r=k}else{t=k;break}}}i4c(t);t=a+224|0;r=a+48|0;d=c[r>>2]|0;if((c[t>>2]|0)==0){u=d}else{s=d;d=0;while(1){fDc(s+(d*52|0)+12|0);q=d+1|0;k=c[r>>2]|0;if(q>>>0<(c[t>>2]|0)>>>0){d=q;s=k}else{u=k;break}}}i4c(u);u=a+228|0;s=a+52|0;d=c[s>>2]|0;if((c[u>>2]|0)==0){v=d}else{t=d;d=0;while(1){fDc(t+(d*52|0)+12|0);r=d+1|0;k=c[s>>2]|0;if(r>>>0<(c[u>>2]|0)>>>0){d=r;t=k}else{v=k;break}}}i4c(v);i4c(c[a+108>>2]|0);i4c(c[a+336>>2]|0);i4c(c[a+340>>2]|0);i4c(c[a+344>>2]|0);i4c(c[a+348>>2]|0);i4c(c[a+352>>2]|0);i4c(c[a+356>>2]|0);i4c(c[a+360>>2]|0);i4c(c[a+368>>2]|0);i4c(c[a+384>>2]|0);i4c(c[a+388>>2]|0);i4c(c[a+392>>2]|0);i4c(c[a+396>>2]|0);i4c(c[a+400>>2]|0);i4c(c[a+404>>2]|0);i4c(c[a+408>>2]|0);i4c(c[a+412>>2]|0);i4c(c[a+416>>2]|0);i4c(c[a+420>>2]|0);i4c(c[a+424>>2]|0);i4c(c[a+428>>2]|0);i4c(c[a+488>>2]|0);i4c(c[a+484>>2]|0);i4c(c[a+476>>2]|0);i4c(c[a+468>>2]|0);i4c(c[a+464>>2]|0);i4c(c[a+432>>2]|0);i4c(c[a+436>>2]|0);i4c(c[a+320>>2]|0);i4c(c[a+516>>2]|0);i4c(c[a+520>>2]|0);BTc(a+56|0);v=a+172|0;t=a+504|0;a=c[t>>2]|0;if((c[v>>2]|0)==0){w=a;x=w;i4c(x);i=b;return}else{y=a;z=0}while(1){KCc(c[y+(z<<2)>>2]|0);a=z+1|0;d=c[t>>2]|0;if(a>>>0<(c[v>>2]|0)>>>0){z=a;y=d}else{w=d;break}}x=w;i4c(x);i=b;return}function PEc(a){a=+a;var b=0,d=0,e=0.0,f=0;b=i;i=i+8|0;d=b;e=a*1.0e-4;h[40483]=e;f=d;h[k>>3]=e;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];EBc(8,0,323872,d);i=b;return}function QEc(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[40483];f=e+e*+U(+(d?b:a));if(d){g=f}else{g=-f}i=i;return a-b<=g|0}function REc(a,b,c){a=+a;b=+b;c=c|0;var d=0,e=0.0,f=0.0,g=0.0;d=c<<24>>24!=0;e=+h[40483];f=e+e*+U(+(d?a:b));if(d){g=-f}else{g=f}i=i;return a-b>=g|0}function SEc(a,b){a=+a;b=+b;i=i;return a<b|0}function TEc(a,b){a=+a;b=+b;i=i;return a<=b|0}function UEc(a,b){a=+a;b=+b;i=i;return a>b|0}function VEc(a,b){a=+a;b=+b;i=i;return a>=b|0}function WEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){j=c[e+(h*40|0)>>2]|0;k=j<<2;c[e+(h*40|0)+20>>2]=h4c(k)|0;c[e+(h*40|0)+24>>2]=h4c(k)|0;if((c[g>>2]|0)!=1){l=5;break}ZEc(j,e+(h*40|0)+28|0)|0;j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{l=6;break}}if((l|0)==5){IBc(c[a+536>>2]|0,323928,d)}else if((l|0)==6){i=b;return 0}return 0}function XEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+484>>2]|0;f=a+192|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+296|0;h=0;while(1){i4c(c[e+(h*40|0)+20>>2]|0);i4c(c[e+(h*40|0)+24>>2]|0);if((c[g>>2]|0)!=1){j=5;break}k=e+(h*40|0)+28|0;_Ec(k)|0;i4c(c[k>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{j=6;break}}if((j|0)==5){IBc(c[a+536>>2]|0,323928,d)}else if((j|0)==6){i=b;return 0}return 0}function YEc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+484>>2]|0;o=b+192|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+4|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p*40|0)+36|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[292372>>2]|c[73074]|0)==0){z=w;A=1;break}zTc(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];GBc(17,1,323960,g);zTc(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;zTc(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;GBc(17,0,323992,f);zTc(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[73214]&1023](17);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function ZEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=i;i=i+8|0;f=h4c(20)|0;c[b>>2]=f;HBc(0,(f|0)!=0|0,324e3,e);e=h4c(a)|0;c[f>>2]=e;e=h4c(a)|0;c[f+4>>2]=e;e=h4c(a)|0;c[f+8>>2]=e;e=h4c(a)|0;c[f+16>>2]=e;HBc(0,(c[b>>2]|0)!=0|0,324032,d);i=d;return 0}function _Ec(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;i4c(c[d>>2]|0);i4c(c[d+4>>2]|0);i4c(c[d+8>>2]|0);i4c(c[d+16>>2]|0);i=b;return 0}function $Ec(a,b){a=a|0;b=b|0;b=i;i=i+8|0;IBc(c[a+536>>2]|0,324080,b);return 0}function aFc(a){a=a|0;a=i;i=i+8|0;IBc(0,324080,a);return 0}function bFc(a,b){a=a|0;b=b|0;b=i;i=i+8|0;IBc(c[a+536>>2]|0,324080,b);return 0}function cFc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){j=c[e+(h<<6)+16>>2]|0;k=c[e+(h<<6)+12>>2]|0;l=j<<3;c[e+(h<<6)+28>>2]=h4c(l)|0;c[e+(h<<6)+36>>2]=h4c(l)|0;m=c[g>>2]|0;if((m|0)==1){c[e+(h<<6)+32>>2]=h4c(fa(l,j)|0)|0;c[e+(h<<6)+8>>2]=1;iFc(j,e+(h<<6)+24|0)|0}else if((m|0)==2){c[e+(h<<6)+8>>2]=2;lFc(j,j,k,e+(h<<6)+24|0)|0}else{n=6;break}k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=8;break}}if((n|0)==6){IBc(c[a+536>>2]|0,324120,d)}else if((n|0)==8){i=b;return 0}return 0}function dFc(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=(fa(c[f+16>>2]|0,b)|0)+a|0;h[(c[f+32>>2]|0)+(e<<3)>>3]=d;i=i;return}function eFc(a,b,d,e,f){a=a|0;b=b|0;d=+d;e=e|0;f=f|0;e=i;vb(0,a|0,b|0,+d,c[c[f+24>>2]>>2]|0)|0;i=e;return}function fFc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=c[a+476>>2]|0;f=a+196|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+292|0;h=0;while(1){i4c(c[e+(h<<6)+28>>2]|0);i4c(c[e+(h<<6)+36>>2]|0);j=c[g>>2]|0;if((j|0)==2){mFc(e+(h<<6)+24|0)|0}else if((j|0)==1){jFc(e+(h<<6)+24|0)|0;i4c(c[e+(h<<6)+32>>2]|0)}else{k=6;break}i4c(c[e+(h<<6)+24>>2]|0);j=h+1|0;if((j|0)<(c[f>>2]|0)){h=j}else{k=8;break}}if((k|0)==6){IBc(c[a+536>>2]|0,324120,d)}else if((k|0)==8){i=b;return 0}return 0}function gFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+8|0;f=e;g=c[b+476>>2]|0;h=c[b+292>>2]|0;if((h|0)==1){j=kFc(b,d)|0}else if((h|0)==2){j=nFc(b,d)|0}else{IBc(c[b+536>>2]|0,324120,f)}a[g+(d<<6)+56|0]=j;i=e;return 0}function hFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;j=i;i=i+24|0;l=i;i=i+24|0;m=i;i=i+24|0;n=c[b+476>>2]|0;o=b+196|0;p=c[o>>2]|0;if((p|0)<=0){q=0;i=e;return q|0}r=(d|0)==0;d=b+56|0;s=n+20|0;t=j+8|0;u=b+4|0;b=l+12|0;v=m+16|0;w=p;p=0;x=0;while(1){y=(a[n+(p<<6)+56|0]|0)!=0;do{if(y|r){z=w;A=y?x:1}else{if((c[292364>>2]|c[73074]|0)==0){z=w;A=1;break}zTc(j,d,c[s>>2]|0);B=+h[c[c[u>>2]>>2]>>3];c[g>>2]=c[t>>2];C=g+4|0;h[k>>3]=B;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];GBc(15,1,324152,g);zTc(l,d,c[s>>2]|0);if((c[b>>2]|0)>0){C=0;while(1){D=C+1|0;zTc(m,d,c[s>>2]|0);E=c[(c[(c[v>>2]|0)+(C<<2)>>2]|0)+4>>2]|0;c[f>>2]=D;c[f+4>>2]=E;GBc(15,0,324184,f);zTc(l,d,c[s>>2]|0);if((D|0)<(c[b>>2]|0)){C=D}else{break}}}fe[c[73214]&1023](15);z=c[o>>2]|0;A=1}}while(0);y=p+1|0;if((y|0)<(z|0)){w=z;p=y;x=A}else{q=A;break}}i=e;return q|0}function iFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+8|0;e=h4c(12)|0;f=h4c(a<<2)|0;c[e>>2]=f;HBc(0,(f|0)!=0|0,324192,d);c[e+4>>2]=1;c[e+8>>2]=0;c[b>>2]=e;i=d;return 0}function jFc(a){a=a|0;var b=0;b=i;i4c(c[c[a>>2]>>2]|0);i=b;return 0}function kFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+16384|0;v=i;i=i+4096|0;w=c[b+476>>2]|0;x=w+(d<<6)|0;y=c[w+(d<<6)+24>>2]|0;z=w+(d<<6)+16|0;A=c[z>>2]|0;B=w+(d<<6)+32|0;P4c(c[B>>2]|0,0,fa(A<<3,A)|0)|0;C=b;D=x;ge[c[x>>2]&255](C,D);ge[c[w+(d<<6)+4>>2]&255](C,D);if((c[292368>>2]|0)!=0){D=u;c[t>>2]=A;c[t+4>>2]=A;EBc(16,1,324248,t);t=(A|0)>0;do{if(t){u=0;do{a[D]=0;C=0;do{x=(fa(C,A)|0)+u|0;E=+h[(c[B>>2]|0)+(x<<3)>>3];c[r>>2]=D;x=r+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,324272,r|0)|0;C=C+1|0;}while((C|0)<(A|0));c[q>>2]=D;EBc(16,0,324288,q);u=u+1|0;}while((u|0)<(A|0));c[p>>2]=A;EBc(16,1,324296,p);if(!t){break}u=w+(d<<6)+36|0;C=0;do{a[D]=0;E=+h[(c[u>>2]|0)+(C<<3)>>3];c[o>>2]=D;x=o+4|0;h[k>>3]=E;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];hc(D|0,324272,o|0)|0;c[n>>2]=D;EBc(16,0,324288,n);C=C+1|0;}while((C|0)<(A|0))}else{c[s>>2]=A;EBc(16,1,324296,s)}}while(0);fe[c[73214]&1023](16)}s=w+(d<<6)+36|0;A=y+8|0;pwc(z,y+4|0,c[B>>2]|0,z,c[y>>2]|0,c[s>>2]|0,z,A)|0;y=c[A>>2]|0;if((y|0)<0){E=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[w+(d<<6)+20>>2];A=m+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];c[m+12>>2]=y;GBc(1,0,324312,m);F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;N4c(M|0,O|0,Q|0)|0;i=e;return F|0}if((y|0)<=0){F=1;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;N4c(M|0,O|0,Q|0)|0;i=e;return F|0}E=+h[c[c[b+4>>2]>>2]>>3];b=y+1|0;c[l>>2]=c[w+(d<<6)+20>>2];y=l+4|0;h[k>>3]=E;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];c[l+12>>2]=b;c[l+16>>2]=b;GBc(1,0,324400,l);if((c[292364>>2]|0)==0){F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;N4c(M|0,O|0,Q|0)|0;i=e;return F|0}l=v;v=(c[z>>2]|0)>0;a[l]=0;if(v){v=0;do{b=c[z>>2]|0;if((b|0)>0){y=b;m=0;while(1){A=(fa(y,m)|0)+v|0;E=+h[(c[B>>2]|0)+(A<<3)>>3];c[j>>2]=l;A=j+4|0;h[k>>3]=E;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];hc(l|0,324504,j|0)|0;A=m+1|0;n=c[z>>2]|0;if((A|0)<(n|0)){m=A;y=n}else{R=n;break}}}else{R=b}v=v+1|0;a[l]=0}while((v|0)<(R|0))}if((c[z>>2]|0)>0){R=0;do{E=+h[(c[s>>2]|0)+(R<<3)>>3];c[g>>2]=l;v=g+4|0;h[k>>3]=E;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];hc(l|0,324504,g|0)|0;R=R+1|0;}while((R|0)<(c[z>>2]|0))}a[l]=0;if((c[z>>2]|0)>0){S=0}else{F=0;G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;N4c(M|0,O|0,Q|0)|0;i=e;return F|0}while(1){E=+h[(c[s>>2]|0)+(S<<3)>>3];c[f>>2]=l;R=f+4|0;h[k>>3]=E;c[R>>2]=c[k>>2];c[R+4>>2]=c[k+4>>2];hc(l|0,324504,f|0)|0;R=S+1|0;if((R|0)<(c[z>>2]|0)){S=R}else{F=0;break}}G=w;H=d<<6;I=G+H|0;J=I+28|0;K=J;L=c[K>>2]|0;M=L;N=c[s>>2]|0;O=N;P=c[z>>2]|0;Q=P<<3;N4c(M|0,O|0,Q|0)|0;i=e;return F|0}function lFc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;f=i;i=i+8|0;g=h4c(32)|0;HBc(0,(g|0)!=0|0,324512,f);c[g+20>>2]=b;b=g+24|0;c[b>>2]=a;c[g+28>>2]=d;d=g+8|0;Yd(0,d|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;Yd(0,g+4|0)|0;Nd(c[d>>2]|0,c[b>>2]|0,0)|0;b=g+12|0;bb(b|0)|0;Lb(324560,c[b>>2]|0)|0;c[e>>2]=g;i=f;return 0}function mFc(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;zd(c[d+12>>2]|0)|0;Kb(c[d+8>>2]|0)|0;Kb(c[d+4>>2]|0)|0;i=b;return 0}function nFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[a+476>>2]|0;f=e+(b<<6)|0;g=c[e+(b<<6)+24>>2]|0;ld(c[g>>2]|0)|0;Ud(0,g|0)|0;j=g+24|0;Pb(c[g>>2]|0,c[j>>2]|0,0)|0;k=a;a=f;ge[c[f>>2]&255](k,a);Vc(c[g>>2]|0,1)|0;Ua(c[g>>2]|0)|0;ge[c[e+(b<<6)+4>>2]&255](k,a);if((c[j>>2]|0)>0){a=e+(b<<6)+36|0;k=g+8|0;f=k;l=0;while(1){gd(0,l|0,+(+h[(c[a>>2]|0)+(l<<3)>>3]),c[k>>2]|0)|0;m=l+1|0;if((m|0)<(c[j>>2]|0)){l=m}else{n=f;break}}}else{n=g+8|0}f=g+4|0;l=(mc(c[g>>2]|0,c[n>>2]|0,c[f>>2]|0,c[g+12>>2]|0)|0)==0|0;Jb(c[f>>2]|0,0,c[g+20>>2]|0,c[e+(b<<6)+28>>2]|0)|0;ld(c[g>>2]|0)|0;i=d;return l|0}function oFc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=c[a+468>>2]|0;h=a+200|0;if((c[h>>2]|0)<=0){i=b;return 0}j=a+536|0;k=a;l=a+300|0;m=0;a:while(1){n=g+(m*80|0)|0;o=c[n>>2]|0;HBc(c[j>>2]|0,(c[g+(m*80|0)+32>>2]|0)!=0|0,324728,f);p=g+(m*80|0)+28|0;do{if(!((c[p>>2]|0)==-1)){HBc(c[j>>2]|0,(c[g+(m*80|0)+20>>2]|0)!=0|0,324768,e);if((ie[c[g+(m*80|0)+24>>2]&127](k)|0)==0){break}c[p>>2]=-1}}while(0);p=o<<3;c[g+(m*80|0)+44>>2]=h4c(p)|0;c[g+(m*80|0)+52>>2]=h4c(p)|0;c[g+(m*80|0)+48>>2]=h4c(p)|0;c[g+(m*80|0)+16>>2]=h4c(p)|0;c[g+(m*80|0)+8>>2]=h4c(p)|0;c[g+(m*80|0)+12>>2]=h4c(p)|0;ge[c[g+(m*80|0)+36>>2]&255](k,n);do{if((c[g+(m*80|0)+56>>2]|0)==1){BFc(o,g+(m*80|0)+40|0)|0}else{p=c[l>>2]|0;if((p|0)==2){$Ec(a,n)|0;break}else if((p|0)==3){BFc(o,g+(m*80|0)+40|0)|0;break}else if((p|0)==1){tFc(o,g+(m*80|0)+40|0)|0;break}else{q=12;break a}}}while(0);o=m+1|0;if((o|0)<(c[h>>2]|0)){m=o}else{q=14;break}}if((q|0)==12){IBc(c[j>>2]|0,324808,d)}else if((q|0)==14){i=b;return 0}return 0}function pFc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=b;e=c[a+468>>2]|0;f=a+200|0;if((c[f>>2]|0)<=0){i=b;return 0}g=a+300|0;h=0;a:while(1){j=e+(h*80|0)|0;i4c(c[e+(h*80|0)+44>>2]|0);i4c(c[e+(h*80|0)+52>>2]|0);i4c(c[e+(h*80|0)+48>>2]|0);i4c(c[e+(h*80|0)+16>>2]|0);i4c(c[e+(h*80|0)+8>>2]|0);i4c(c[e+(h*80|0)+12>>2]|0);do{if((c[e+(h*80|0)+56>>2]|0)==1){k=e+(h*80|0)+40|0;CFc(k)|0;l=k}else{k=c[g>>2]|0;if((k|0)==3){m=e+(h*80|0)+40|0;CFc(m)|0;l=m;break}else if((k|0)==2){n=7;break a}else if((k|0)==1){k=e+(h*80|0)+40|0;uFc(k)|0;l=k;break}else{n=9;break a}}}while(0);i4c(c[l>>2]|0);k=h+1|0;if((k|0)<(c[f>>2]|0)){h=k}else{n=11;break}}if((n|0)==7){aFc(j)|0}else if((n|0)==9){IBc(c[a+536>>2]|0,324808,d)}else if((n|0)==11){i=b;return 0}return 0}function qFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;e=i;i=i+8|0;f=e;g=c[b+468>>2]|0;c[b+472>>2]=d;h=b+319|0;a[h]=1;do{if((c[g+(d*80|0)+56>>2]|0)==1){j=(EFc(b,d)|0)&255}else{k=c[b+300>>2]|0;if((k|0)==1){l=b+536|0;m=(c[l>>2]|0)+84|0;n=c[m>>2]|0;c[m>>2]=3;m=vFc(b,d)|0;c[(c[l>>2]|0)+84>>2]=n;j=m&255;break}else if((k|0)==3){j=(EFc(b,d)|0)&255;break}else if((k|0)==2){j=(bFc(b,d)|0)&255;break}else{IBc(c[b+536>>2]|0,324808,f)}}}while(0);a[g+(d*80|0)+72|0]=j;a[h]=0;i=e;return 0}function rFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0.0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+24|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+24|0;t=i;i=i+24|0;u=c[b+468>>2]|0;v=c[b+200>>2]|0;if((v|0)>0){w=0}else{x=0;i=e;return x|0}while(1){y=w+1|0;if((a[u+(w*80|0)+72|0]|0)==0){break}if((y|0)<(v|0)){w=y}else{x=0;z=22;break}}if((z|0)==22){i=e;return x|0}v=u+(w*80|0)+4|0;w=c[v>>2]|0;u=n;c[u>>2]=1;c[n+4>>2]=w;if((d|0)==0){x=1;i=e;return x|0}d=b+56|0;zTc(o,d,w);A=+h[c[c[b+4>>2]>>2]>>3];c[m>>2]=c[o+8>>2];o=m+4|0;h[k>>3]=A;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];FBc(17,1,u,324840,m);do{if((a[b+312|0]|0)==0){zTc(s,d,c[v>>2]|0);m=s+12|0;if((c[m>>2]|0)<=0){break}u=t+16|0;o=0;while(1){w=o+1|0;zTc(t,d,c[v>>2]|0);n=c[(c[(c[u>>2]|0)+(o<<2)>>2]|0)+4>>2]|0;c[f>>2]=w;c[f+4>>2]=n;GBc(17,0,325040,f);zTc(s,d,c[v>>2]|0);if((w|0)<(c[m>>2]|0)){o=w}else{break}}}else{GBc(17,1,324880,l);zTc(p,d,c[v>>2]|0);o=p+12|0;if((c[o>>2]|0)>0){m=b+116|0;u=r+16|0;w=b+8|0;n=q+16|0;y=0;while(1){a:do{if((c[m>>2]|0)>0){B=y+1|0;C=0;while(1){D=c[(c[w>>2]|0)+(C*112|0)+4>>2]|0;zTc(q,d,c[v>>2]|0);if((H4c(D,c[(c[(c[n>>2]|0)+(y<<2)>>2]|0)+4>>2]|0)|0)==0){break}D=C+1|0;if((D|0)<(c[m>>2]|0)){C=D}else{z=15;break a}}D=c[w>>2]|0;E=c[D+(C*112|0)+4>>2]|0;A=+h[D+(C*112|0)+96>>3];F=+h[D+(C*112|0)+80>>3];c[j>>2]=B;c[j+4>>2]=E;E=j+8|0;h[k>>3]=A;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=j+16|0;h[k>>3]=F;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];GBc(17,0,324960,j);G=y+1|0}else{z=15}}while(0);if((z|0)==15){z=0;E=y+1|0;zTc(r,d,c[v>>2]|0);D=c[(c[(c[u>>2]|0)+(y<<2)>>2]|0)+4>>2]|0;c[g>>2]=E;c[g+4>>2]=D;GBc(17,0,325e3,g);G=E}zTc(p,d,c[v>>2]|0);if((G|0)<(c[o>>2]|0)){y=G}else{break}}}if((c[292372>>2]|c[73074]|0)==0){break}fe[c[73214]&1023](17)}}while(0);if((c[292372>>2]|c[73074]|0)==0){x=1;i=e;return x|0}fe[c[73214]&1023](17);x=1;i=e;return x|0}function sFc(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0.0,j=0.0,k=0.0;e=i;f=c[a+4>>2]|0;g=+h[c[f+4>>2]>>3];j=+h[c[f+8>>2]>>3];if(g==j){k=b;i=e;return+k}k=(b-d)*((+h[c[f>>2]>>3]-j)/(g-j))+d;i=e;return+k}function tFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=i;i=i+8|0;f=h4c(144)|0;c[b>>2]=f;HBc(0,(f|0)!=0|0,325056,e);c[f>>2]=0;e=a<<3;g=h4c(e)|0;c[f+4>>2]=g;g=h4c(e)|0;c[f+16>>2]=g;c[f+8>>2]=1;g=h4c(e)|0;c[f+12>>2]=g;c[f+20>>2]=a;g=h4c(e)|0;c[f+24>>2]=g;g=j4c(a,8)|0;c[f+28>>2]=g;h[f+32>>3]=1.0e-12;c[f+40>>2]=a*1e4;g=a+ -1|0;c[f+44>>2]=g;c[f+48>>2]=g;h[f+56>>3]=1.0e-12;g=h4c(e)|0;c[f+64>>2]=g;g=h4c(e)|0;c[f+68>>2]=g;c[f+72>>2]=1;h[f+80>>3]=100.0;c[f+88>>2]=-1;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;g=fa(a,a)|0;j=j4c(g,8)|0;c[f+104>>2]=j;j=j4c(g,8)|0;c[f+108>>2]=j;c[f+112>>2]=a;j=(fa(a+1|0,a)|0)/2|0;a=h4c(j<<3)|0;c[f+116>>2]=a;c[f+120>>2]=j;j=h4c(e)|0;c[f+124>>2]=j;j=h4c(e)|0;c[f+128>>2]=j;j=h4c(e)|0;c[f+132>>2]=j;j=h4c(e)|0;c[f+136>>2]=j;j=h4c(e)|0;c[f+140>>2]=j;HBc(0,(c[b>>2]|0)!=0|0,325088,d);i=d;return 0}function uFc(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;i4c(c[d+4>>2]|0);i4c(c[d+16>>2]|0);i4c(c[d+12>>2]|0);i4c(c[d+24>>2]|0);i4c(c[d+28>>2]|0);i4c(c[d+64>>2]|0);i4c(c[d+68>>2]|0);i4c(c[d+104>>2]|0);i4c(c[d+108>>2]|0);i4c(c[d+116>>2]|0);i4c(c[d+124>>2]|0);i4c(c[d+128>>2]|0);i4c(c[d+132>>2]|0);i4c(c[d+136>>2]|0);i4c(c[d+140>>2]|0);i=b;return 0}function vFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0,Z=0,_=0.0,$=0,aa=0,ba=0,ca=0,da=0,ea=0.0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0.0,ib=0,jb=0,kb=0;e=i;i=i+56|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+24|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+24|0;N=i;i=i+24|0;O=i;i=i+4096|0;P=i;i=i+24|0;Q=c[b+468>>2]|0;R=c[Q+(d*80|0)+40>>2]|0;S=R;T=c[Q+(d*80|0)+4>>2]|0;c[I>>2]=1;V=R+80|0;W=V;X=+h[V>>3];c[L>>2]=0;Y=b+164|0;Z=h4c(c[Y>>2]|0)|0;if((c[292372>>2]|0)!=0){zTc(M,b+56|0,T);_=+h[c[c[b+4>>2]>>2]>>3];c[H>>2]=c[M+8>>2];M=H+4|0;h[k>>3]=_;c[M>>2]=c[k>>2];c[M+4>>2]=c[k+4>>2];EBc(17,1,325128,H);H=R+20|0;if((c[H>>2]|0)>0){M=Q+(d*80|0)+44|0;$=Q+(d*80|0)+16|0;aa=Q+(d*80|0)+48|0;ba=Q+(d*80|0)+52|0;ca=0;do{_=+h[(c[M>>2]|0)+(ca<<3)>>3];c[G>>2]=ca;da=G+4|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];EBc(17,1,325184,G);_=+h[(c[aa>>2]|0)+(ca<<3)>>3];ea=+h[(c[ba>>2]|0)+(ca<<3)>>3];da=F;h[k>>3]=+h[(c[$>>2]|0)+(ca<<3)>>3];c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+8|0;h[k>>3]=_;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];da=F+16|0;h[k>>3]=ea;c[da>>2]=c[k>>2];c[da+4>>2]=c[k+4>>2];EBc(17,0,325200,F);fe[c[73214]&1023](17);ca=ca+1|0;}while((ca|0)<(c[H>>2]|0))}fe[c[73214]&1023](17)}H=b+314|0;ca=R+24|0;F=c[ca>>2]|0;if((a[H]|0)==0){N4c(F|0,c[Q+(d*80|0)+52>>2]|0,c[R+20>>2]<<3|0)|0}else{N4c(F|0,c[Q+(d*80|0)+44>>2]|0,c[R+20>>2]<<3|0)|0}F=R+20|0;$=F;ba=c[F>>2]|0;if((ba|0)>0){aa=c[ca>>2]|0;G=c[Q+(d*80|0)+16>>2]|0;M=c[R+12>>2]|0;da=0;do{ea=+U(+(+h[aa+(da<<3)>>3]));h[M+(da<<3)>>3]=+td(+ea,+(+h[G+(da<<3)>>3]));da=da+1|0;}while((da|0)<(ba|0))}ba=R+8|0;da=(c[ba>>2]|0)!=0;if(da){c[ba>>2]=0}G=R+28|0;M=R+104|0;aa=R+112|0;ga=b;wFc($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(da){c[ba>>2]=1}da=b+318|0;ha=R+32|0;ia=R+40|0;ja=R+64|0;ka=R+72|0;la=ka;ma=R+88|0;na=R+92|0;oa=na;pa=R+96|0;qa=pa;ra=R+100|0;sa=R+116|0;ta=R+120|0;ua=R+124|0;va=R+128|0;wa=R+132|0;xa=R+136|0;ya=R+140|0;za=b+56|0;Aa=b+4|0;Ba=Q+(d*80|0)+52|0;Ca=Q+(d*80|0)+44|0;Da=Q+(d*80|0)+48|0;Ea=Q+(d*80|0)+16|0;Q=R+12|0;Fa=b+356|0;Ga=R+4|0;Ha=b+312|0;Ia=R+16|0;Ja=O;O=R+108|0;R=1;ea=1.0e-12;Ka=0;La=0;Ma=0;Na=0;a:while(1){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=c[Ea>>2]|0;Ra=c[Q>>2]|0;Sa=0;do{_=+U(+(+h[Pa+(Sa<<3)>>3]));h[Ra+(Sa<<3)>>3]=+td(+_,+(+h[Qa+(Sa<<3)>>3]));Sa=Sa+1|0;}while((Sa|0)<(Oa|0))}if((c[292376>>2]|0)!=0){xFc(c[Q>>2]|0,$,18,325240);xFc(c[ca>>2]|0,$,18,325272)}do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Sa=c[Q>>2]|0;Qa=c[ca>>2]|0;Ra=0;do{Pa=Qa+(Ra<<3)|0;h[Pa>>3]=1.0/+h[Sa+(Ra<<3)>>3]*+h[Pa>>3];Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}}while(0);if((c[292376>>2]|0)!=0){xFc(c[ca>>2]|0,$,18,325304)}a[da]=R;LDc(10,$,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,ha,ia,c[ja>>2]|0,la,W,ma,oa,qa,ra,c[sa>>2]|0,ta,c[ua>>2]|0,c[va>>2]|0,c[wa>>2]|0,c[xa>>2]|0,c[ya>>2]|0,ga,d)|0;a[da]=R^1;do{if((c[ba>>2]|0)!=0){Oa=c[F>>2]|0;if((Oa|0)<=0){break}Ra=c[ca>>2]|0;Sa=c[Q>>2]|0;Qa=0;do{Pa=Ra+(Qa<<3)|0;h[Pa>>3]=+h[Pa>>3]*+h[Sa+(Qa<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}}while(0);Oa=c[na>>2]|0;if((Oa|0)==0){zTc(N,za,T);_=+h[c[c[Aa>>2]>>2]>>3];Qa=g;Sa=N;c[Qa+0>>2]=c[Sa+0>>2];c[Qa+4>>2]=c[Sa+4>>2];c[Qa+8>>2]=c[Sa+8>>2];c[Qa+12>>2]=c[Sa+12>>2];c[Qa+16>>2]=c[Sa+16>>2];eDc(3,g,_);Ta=c[na>>2]|0}else{Ta=Oa}do{if(!((Ta|0)==-1)){if((a[H]|0)==0){Ua=Ta}else{if((c[ba>>2]|0)==0){a[da]=0;wFc($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0}else{c[ba>>2]=0;a[da]=0;wFc($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;c[ba>>2]=1}zEc(b);Ua=c[na>>2]|0}if((Ua|0)==-1){break}Oa=c[F>>2]|0;if((Oa|0)>0){Sa=c[Ga>>2]|0;Qa=c[G>>2]|0;Ra=c[Ia>>2]|0;Pa=0;Va=0;while(1){Wa=Sa+(Pa<<3)|0;h[Wa>>3]=1.0e-16;Xa=c[O>>2]|0;Ya=(Oa|0)>1?Oa:1;_=1.0e-16;Za=0;_a=Va;while(1){$a=+U(+(+h[Xa+(_a<<3)>>3]));ab=$a>_?$a:_;h[Wa>>3]=ab;bb=Za+1|0;if((bb|0)<(Oa|0)){_a=_a+1|0;Za=bb;_=ab}else{break}}h[Ra+(Pa<<3)>>3]=+h[Qa+(Pa<<3)>>3]*(1.0/ab);Za=Pa+1|0;if((Za|0)<(Oa|0)){Pa=Za;Va=Va+Ya|0}else{break}}}if((c[292376>>2]|0)!=0){EBc(18,1,325344,E);if((c[F>>2]|0)>0){Va=0;do{_=+h[(c[Ia>>2]|0)+(Va<<3)>>3];c[D>>2]=Va;Pa=D+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];EBc(18,1,325384,D);_=+h[(c[Ga>>2]|0)+(Va<<3)>>3];c[C>>2]=Va;Pa=C+4|0;h[k>>3]=_;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];EBc(18,0,325416,C);fe[c[73214]&1023](18);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[73214]&1023](18)}if((c[292380>>2]|0)!=0){Va=c[F>>2]|0;c[B>>2]=Va;c[B+4>>2]=Va;EBc(19,1,325448,B);if((c[F>>2]|0)>0){Va=0;do{a[Ja]=0;Pa=c[F>>2]|0;if((Pa|0)>0){Oa=Pa;Pa=0;do{Qa=(fa(Oa,Va)|0)+Pa|0;_=+h[(c[O>>2]|0)+(Qa<<3)>>3];c[A>>2]=Ja;Qa=A+4|0;h[k>>3]=_;c[Qa>>2]=c[k>>2];c[Qa+4>>2]=c[k+4>>2];hc(Ja|0,325472,A|0)|0;Pa=Pa+1|0;Oa=c[F>>2]|0;}while((Pa|0)<(Oa|0))}c[z>>2]=Ja;EBc(19,0,325480,z);Va=Va+1|0;}while((Va|0)<(c[F>>2]|0))}fe[c[73214]&1023](19)}h[K>>3]=+KDc($,c[Ia>>2]|0);h[J>>3]=+KDc($,c[G>>2]|0)}}while(0);do{if((Ka|0)==0){cb=0}else{if(!(+h[J>>3]>ea)){cb=Ka;break}if(!(+h[K>>3]>ea)){cb=Ka;break}N4c(c[Fa>>2]|0,Z|0,c[Y>>2]|0)|0;cb=0}}while(0);Va=c[na>>2]|0;_=+h[J>>3];b:do{if((Va|0)<4){do{if(_>ea){if(!(+h[K>>3]>ea)){break}c[na>>2]=4;db=4;break b}}while(0);if((Va|0)==1){eb=68;break a}else{db=Va}}else{db=Va}}while(0);if(_<=ea){eb=68;break}if(+h[K>>3]<=ea){eb=68;break}Va=(db+ -4|0)>>>0<2;if(Va&(La|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}$a=+h[V>>3]/10.0;h[V>>3]=$a;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}Pa=w;h[k>>3]=$a;c[Pa>>2]=c[k>>2];c[Pa+4>>2]=c[k+4>>2];EBc(17,0,325528,w);yFc(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<4){Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[Ea>>2]|0;Ya=c[ca>>2]|0;Qa=0;do{Ra=Ya+(Qa<<3)|0;h[Ra>>3]=+h[Pa+(Qa<<3)>>3]*.1+ +h[Ra>>3];Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}h[V>>3]=X;Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}EBc(17,0,325600,v);yFc(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Da>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Ra=0;do{_=+U(+(+h[Qa+(Ra<<3)>>3]));h[Ya+(Ra<<3)>>3]=+td(+_,+(+h[Pa+(Ra<<3)>>3]));Ra=Ra+1|0;}while((Ra|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}EBc(17,0,325664,u);yFc(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}if(Va&(La|0)<6){Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}if((c[ba>>2]|0)!=0){c[ba>>2]=0}Oa=c[F>>2]|0;if((Oa|0)>0){Ra=c[ca>>2]|0;Pa=c[Ea>>2]|0;Ya=c[Q>>2]|0;Qa=0;do{_=+U(+(+h[Ra+(Qa<<3)>>3]));h[Ya+(Qa<<3)>>3]=+td(+_,+(+h[Pa+(Qa<<3)>>3]));Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=La+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}EBc(17,0,325736,t);yFc(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;ib=R;Ka=cb;La=Oa;Na=fb;Ma=gb;ea=hb;R=ib;continue}do{if(Va&(La|0)<7){if((a[H]|0)==0){break}N4c(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;Oa=La+1|0;N4c(Z|0,c[Fa>>2]|0,c[Y>>2]|0)|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}EBc(17,0,325800,s);yFc(S,L,J,K,18);fb=Na;gb=Ma;hb=ea;R=0;Ka=1;La=Oa;Na=fb;Ma=gb;ea=hb;continue a}}while(0);if(Va&(Ma|0)<1){N4c(c[ca>>2]|0,c[Da>>2]|0,c[F>>2]<<3|0)|0;if((c[ba>>2]|0)==0){c[ba>>2]=1}h[V>>3]=X;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}EBc(17,0,325872,r);yFc(S,L,J,K,18);fb=Na;hb=ea;R=1;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;continue}if(Va&(Ma|0)<2){Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[ca>>2]|0;Pa=0;do{Ya=Qa+(Pa<<3)|0;h[Ya>>3]=+h[Ya>>3]*1.01;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}EBc(17,0,325944,q);yFc(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<3){Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Pa=c[ca>>2]|0;Qa=0;do{Ya=Pa+(Qa<<3)|0;h[Ya>>3]=+h[Ya>>3]*.99;Qa=Qa+1|0;}while((Qa|0)<(Oa|0))}Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}EBc(17,0,326016,p);yFc(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<4){N4c(c[ca>>2]|0,c[Ea>>2]|0,c[F>>2]<<3|0)|0;Oa=Ma+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}EBc(17,0,326080,o);yFc(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(Va&(Ma|0)<5){Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Qa=c[Ga>>2]|0;Pa=c[ja>>2]|0;Ya=0;do{_=+U(+(+h[Qa+(Ya<<3)>>3]));h[Pa+(Ya<<3)>>3]=!(_<=1.0e-16)?_:1.0e-16;Ya=Ya+1|0;}while((Ya|0)<(Oa|0))}Oa=Ma+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}EBc(17,0,326152,n);yFc(S,L,J,K,18);fb=Na;hb=ea;ib=R;Ka=cb;La=0;Ma=Oa;Na=fb;ea=hb;R=ib;continue}if(!(Va&(Na|0)<1)){if(!(Va&(Na|0)<6)){eb=160;break}Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}_=ea*10.0;h[V>>3]=X;c[ka>>2]=1;Oa=Na+1|0;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Ya=l;h[k>>3]=_;c[Ya>>2]=c[k>>2];c[Ya+4>>2]=c[k+4>>2];EBc(17,0,326288,l);yFc(S,L,J,K,18);ib=R;ea=_;Ka=cb;La=0;Ma=0;Na=Oa;R=ib;continue}Oa=c[ca>>2]|0;if((a[H]|0)==0){N4c(Oa|0,c[Ba>>2]|0,c[F>>2]<<3|0)|0}else{N4c(Oa|0,c[Ca>>2]|0,c[F>>2]<<3|0)|0}Oa=c[F>>2]|0;if((Oa|0)>0){Ya=c[ja>>2]|0;Pa=0;do{h[Ya+(Pa<<3)>>3]=1.0;Pa=Pa+1|0;}while((Pa|0)<(Oa|0))}c[ba>>2]=1;Oa=Na+1|0;c[ka>>2]=2;c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)==0){hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib;continue}EBc(17,0,326216,m);yFc(S,L,J,K,18);hb=ea;ib=R;Ka=cb;La=0;Ma=0;Na=Oa;ea=hb;R=ib}if((eb|0)==68){c[L>>2]=(c[L>>2]|0)+(c[pa>>2]|0);if((c[292372>>2]|0)!=0){EBc(17,1,325488,y);c[x>>2]=La;c[x+4>>2]=Na+Ma;EBc(17,0,325504,x);fe[c[73214]&1023](17);yFc(S,L,J,K,17)}x=(c[ba>>2]|0)!=0;if(x){c[ba>>2]=0;jb=x}else{jb=0}N4c(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;wFc($,c[ca>>2]|0,c[G>>2]|0,c[M>>2]|0,aa,I,ga,d)|0;if(!jb){kb=1;h[V>>3]=X;c[ka>>2]=1;i4c(Z);i=e;return kb|0}c[ba>>2]=1;kb=1;h[V>>3]=X;c[ka>>2]=1;i4c(Z);i=e;return kb|0}else if((eb|0)==160){if(!((db+ -2|0)>>>0<4)){kb=0;h[V>>3]=X;c[ka>>2]=1;i4c(Z);i=e;return kb|0}if((a[Ha]|0)==0){zTc(P,za,T);hb=+h[c[c[Aa>>2]>>2]>>3];Aa=f;T=P;c[Aa+0>>2]=c[T+0>>2];c[Aa+4>>2]=c[T+4>>2];c[Aa+8>>2]=c[T+8>>2];c[Aa+12>>2]=c[T+12>>2];c[Aa+16>>2]=c[T+16>>2];eDc(0,f,hb);}if((c[292372>>2]|0)!=0){c[j>>2]=fa(fa(Ma,La)|0,Na)|0;EBc(17,0,326360,j);yFc(S,L,J,K,17)}N4c(c[Ca>>2]|0,c[ca>>2]|0,c[F>>2]<<3|0)|0;kb=0;h[V>>3]=X;c[ka>>2]=1;i4c(Z);i=e;return kb|0}return 0}function wFc(b,d,e,f,g,j,l,m){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0;g=i;i=i+8|0;n=g;o=i;i=i+8|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16384|0;w=l;x=c[l+468>>2]|0;y=c[x+(m*80|0)+40>>2]|0;z=l+318|0;A=c[j>>2]|0;if((A|0)==2){B=(a[z]|0)!=0;if(B){a[z]=0}if((c[292384>>2]|0)!=0){EBc(20,0,326712,s)}if((c[x+(m*80|0)+28>>2]|0)==-1){AFc(w,f,d,e,m)}else{zFc(w,f,m)}do{if((c[292384>>2]|0)!=0){EBc(20,0,326752,r);if((c[292380>>2]|0)==0){break}w=v;s=c[b>>2]|0;c[q>>2]=s;c[q+4>>2]=s;EBc(19,1,325448,q);s=c[b>>2]|0;if((s|0)>0){C=y+20|0;D=s;s=0;do{a[w]=0;if((D|0)>0){E=0;do{F=+h[f+((fa(c[C>>2]|0,s)|0)+E<<3)>>3];c[p>>2]=w;G=p+4|0;h[k>>3]=F;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];hc(w|0,326784,p|0)|0;E=E+1|0;}while((E|0)<(c[b>>2]|0))}c[o>>2]=w;EBc(19,0,325480,o);s=s+1|0;D=c[b>>2]|0;}while((s|0)<(D|0))}fe[c[73214]&1023](19)}}while(0);if(!B){i=g;return 0}a[z]=1;i=g;return 0}else if((A|0)==1){z=y+8|0;do{if((c[z>>2]|0)!=0){B=c[b>>2]|0;if((B|0)<=0){break}o=c[y+12>>2]|0;p=0;do{f=d+(p<<3)|0;h[f>>3]=+h[f>>3]*+h[o+(p<<3)>>3];p=p+1|0;}while((p|0)<(B|0))}}while(0);if((c[292384>>2]|0)!=0){c[u>>2]=c[y+96>>2];EBc(20,0,326608,u);xFc(d,b,20,326640)}Ie[c[x+(m*80|0)+32>>2]&63](l,d,e,j);if((c[292384>>2]|0)!=0){xFc(e,b,20,326656);c[t>>2]=c[y+96>>2];EBc(20,0,326672,t)}if((c[z>>2]|0)==0){i=g;return 0}z=c[b>>2]|0;if((z|0)<=0){i=g;return 0}b=c[y+12>>2]|0;y=0;do{t=d+(y<<3)|0;h[t>>3]=1.0/+h[b+(y<<3)>>3]*+h[t>>3];y=y+1|0;}while((y|0)<(z|0));i=g;return 0}else{g=c[l+536>>2]|0;c[n>>2]=A;IBc(g,326800,n)}return 0}function xFc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0.0;f=i;i=i+16|0;g=f;j=i;i=i+8|0;if((c[292304+(d<<2)>>2]|0)==0){i=f;return}c[j>>2]=e;EBc(d,1,325480,j);if((c[b>>2]|0)>0){j=0;do{l=+h[a+(j<<3)>>3];c[g>>2]=j;e=g+4|0;h[k>>3]=l;c[e>>2]=c[k>>2];c[e+4>>2]=c[k+4>>2];EBc(d,0,326592,g);j=j+1|0;}while((j|0)<(c[b>>2]|0))}fe[c[73214]&1023](d);i=f;return}function yFc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0;g=i;i=i+24|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+24|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[292304+(f<<2)>>2]|0)==0){i=g;return}EBc(f,1,326400,q);EBc(f,1,326416,p);p=a+20|0;if((c[p>>2]|0)>0){q=a+24|0;r=a+64|0;s=0;do{t=+h[(c[q>>2]|0)+(s<<3)>>3];u=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=s;v=o+4|0;h[k>>3]=t;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];v=o+12|0;h[k>>3]=u;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];EBc(f,0,326432,o);s=s+1|0;}while((s|0)<(c[p>>2]|0))}fe[c[73214]&1023](f);EBc(f,1,326472,n);if((c[p>>2]|0)>0){n=a+28|0;s=a+4|0;a=0;do{u=+h[(c[n>>2]|0)+(a<<3)>>3];t=+h[(c[s>>2]|0)+(a<<3)>>3];c[m>>2]=a;o=m+4|0;h[k>>3]=u;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=m+12|0;h[k>>3]=t;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];EBc(f,0,326488,m);a=a+1|0;}while((a|0)<(c[p>>2]|0))}fe[c[73214]&1023](f);EBc(f,1,326528,l);t=+h[d>>3];u=+h[e>>3];c[j>>2]=c[b>>2];b=j+4|0;h[k>>3]=t;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];b=j+12|0;h[k>>3]=u;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];EBc(f,0,326544,j);fe[c[73214]&1023](f);fe[c[73214]&1023](f);i=g;return}function zFc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0.0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+40>>2]|0;j=c[f+(d*80|0)+28>>2]|0;k=g+20|0;l=c[k>>2]|0;P4c(b|0,0,fa(l<<3,l)|0)|0;l=g+108|0;g=c[k>>2]|0;P4c(c[l>>2]|0,0,fa(g<<3,g)|0)|0;g=a+464|0;k=c[g>>2]|0;if((c[k+(j*44|0)+24>>2]|0)==0){i=e;return}m=f+(d*80|0)+20|0;d=a;a=c[k+(j*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[f+(j*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(j*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[m>>2]&127](d)|0;f=c[g>>2]|0;a=c[f+(j*44|0)>>2]|0;if((a|0)!=0){n=c[f+(j*44|0)+20>>2]|0;o=c[f+(j*44|0)+28>>2]|0;p=0;do{q=o+(p<<3)|0;do{if(+h[q>>3]==1.0){if((p|0)==0){r=f+(j*44|0)+8|0;s=0}else{t=f+(j*44|0)+8|0;r=t;s=c[(c[t>>2]|0)+(p+ -1<<2)>>2]|0}t=c[(c[r>>2]|0)+(p<<2)>>2]|0;if(!(s>>>0<t>>>0)){break}u=c[l>>2]|0;v=c[f+(j*44|0)+12>>2]|0;w=c[f+(j*44|0)+4>>2]|0;x=c[f+(j*44|0)+36>>2]|0;y=s;do{z=c[v+(y<<2)>>2]|0;A=(fa(w,p)|0)+z|0;B=+h[x+(z<<3)>>3];h[b+(A<<3)>>3]=B;h[u+(A<<3)>>3]=B;y=y+1|0;}while(y>>>0<t>>>0)}}while(0);if(((c[n+(p<<2)>>2]|0)+ -1|0)==(k|0)){h[q>>3]=0.0}p=p+1|0;}while(p>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(j*44|0)+24>>2]|0)>>>0);i=e;return}function AFc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0.0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0,B=0,C=0,D=0,E=0;g=i;i=i+8|0;j=g;k=c[(c[a+468>>2]|0)+(f*80|0)+40>>2]|0;l=k+56|0;m=+h[l>>3];n=+V(+m);c[j>>2]=1;o=k+20|0;p=o;if((c[o>>2]|0)<=0){i=g;return}q=k+128|0;r=k+108|0;s=k+112|0;k=a;t=m;a=0;while(1){m=+h[e+(a<<3)>>3];u=t*m;v=d+(a<<3)|0;w=+h[v>>3];if(!(w>=0.0)){x=-w}else{x=w}if(!(u>=0.0)){y=-u}else{y=u}u=+td(+(n*+td(+x,+y)),+n);if(!(m>=0.0)){z=-u}else{z=u}u=z+w-w;m=1.0/u;h[v>>3]=w+u;wFc(p,d,c[q>>2]|0,c[r>>2]|0,s,j,k,f)|0;A=c[o>>2]|0;if((A|0)>0){B=c[q>>2]|0;C=c[r>>2]|0;D=0;do{E=(fa(A,a)|0)+D|0;u=m*(+h[B+(D<<3)>>3]- +h[e+(D<<3)>>3]);h[b+(E<<3)>>3]=u;h[C+(E<<3)>>3]=u;D=D+1|0;}while((D|0)<(A|0))}h[v>>3]=w;D=a+1|0;if((D|0)>=(A|0)){break}t=+h[l>>3];a=D}i=g;return}function BFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=i;i=i+8|0;f=h4c(80)|0;c[b>>2]=f;HBc(0,(f|0)!=0|0,326880,e);c[f>>2]=0;e=a<<3;g=h4c(e)|0;c[f+4>>2]=g;g=h4c(e)|0;c[f+8>>2]=g;c[f+12>>2]=a;g=h4c(e)|0;c[f+16>>2]=g;g=j4c(a,8)|0;c[f+20>>2]=g;h[f+24>>3]=1.0e-8;h[f+32>>3]=1.0e-8;c[f+44>>2]=a*100;h[f+56>>3]=2.220446049250313e-16;g=h4c(fa(e,a)|0)|0;c[f+64>>2]=g;g=h4c(e)|0;c[f+68>>2]=g;g=h4c(a<<2)|0;c[f+72>>2]=g;HBc(0,(c[b>>2]|0)!=0|0,326912,d);i=d;return 0}function CFc(a){a=a|0;var b=0,d=0;b=i;d=c[a>>2]|0;i4c(c[d+4>>2]|0);i4c(c[d+8>>2]|0);i4c(c[d+16>>2]|0);i4c(c[d+20>>2]|0);i4c(c[d+64>>2]|0);i4c(c[d+68>>2]|0);i4c(c[d+72>>2]|0);i=b;return 0}function DFc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;e=i;f=c[a+468>>2]|0;g=c[f+(d*80|0)+28>>2]|0;j=c[(c[f+(d*80|0)+40>>2]|0)+12>>2]|0;P4c(b|0,0,fa(j<<3,j)|0)|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=e;return 0}l=f+(d*80|0)+20|0;d=a;a=c[k+(g*44|0)>>2]|0;f=k;k=0;do{if((a|0)!=0){m=0;do{if(((c[(c[f+(g*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[f+(g*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[l>>2]&127](d)|0;f=c[j>>2]|0;a=c[f+(g*44|0)>>2]|0;if((a|0)!=0){m=c[f+(g*44|0)+20>>2]|0;n=c[f+(g*44|0)+28>>2]|0;o=0;do{p=n+(o<<3)|0;do{if(+h[p>>3]==1.0){if((o|0)==0){q=f+(g*44|0)+8|0;r=0}else{s=f+(g*44|0)+8|0;q=s;r=c[(c[s>>2]|0)+(o+ -1<<2)>>2]|0}s=c[(c[q>>2]|0)+(o<<2)>>2]|0;if(!(r>>>0<s>>>0)){break}t=c[f+(g*44|0)+12>>2]|0;u=c[f+(g*44|0)+4>>2]|0;v=c[f+(g*44|0)+36>>2]|0;w=r;do{x=c[t+(w<<2)>>2]|0;y=(fa(u,o)|0)+x|0;h[b+(y<<3)>>3]=+h[v+(x<<3)>>3];w=w+1|0;}while(w>>>0<s>>>0)}}while(0);if(((c[m+(o<<2)>>2]|0)+ -1|0)==(k|0)){h[p>>3]=0.0}o=o+1|0;}while(o>>>0<a>>>0)}k=k+1|0;}while(k>>>0<(c[f+(g*44|0)+24>>2]|0)>>>0);i=e;return 0}function EFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0,O=0,P=0.0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0.0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0;e=i;i=i+72|0;f=e;g=e+24|0;j=e+48|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+24|0;r=i;i=i+24|0;s=i;i=i+8|0;t=i;i=i+24|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+24|0;x=i;i=i+24|0;y=i;i=i+24|0;z=c[b+468>>2]|0;A=c[z+(d*80|0)+40>>2]|0;B=c[z+(d*80|0)+4>>2]|0;C=A+40|0;D=C;c[C>>2]=0;E=A+16|0;F=z+(d*80|0)+52|0;G=A+12|0;H=G;N4c(c[E>>2]|0,c[F>>2]|0,c[G>>2]<<3|0)|0;I=b+56|0;if((c[292372>>2]|0)==0){J=b+4|0}else{zTc(w,I,B);K=b+4|0;L=+h[c[c[K>>2]>>2]>>3];c[v>>2]=c[w+8>>2];w=v+4|0;h[k>>3]=L;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];EBc(17,1,326952,v);if((c[G>>2]|0)>0){v=z+(d*80|0)+44|0;w=z+(d*80|0)+16|0;M=z+(d*80|0)+48|0;N=0;do{L=+h[(c[v>>2]|0)+(N<<3)>>3];c[u>>2]=N;O=u+4|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];EBc(17,1,327024,u);L=+h[(c[M>>2]|0)+(N<<3)>>3];P=+h[(c[F>>2]|0)+(N<<3)>>3];O=t;h[k>>3]=+h[(c[w>>2]|0)+(N<<3)>>3];c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+8|0;h[k>>3]=L;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];O=t+16|0;h[k>>3]=P;c[O>>2]=c[k>>2];c[O+4>>2]=c[k+4>>2];EBc(17,0,327040,t);fe[c[73214]&1023](17);N=N+1|0;}while((N|0)<(c[G>>2]|0))}fe[c[73214]&1023](17);J=K}K=b+318|0;N=A+20|0;t=A+24|0;w=A+56|0;F=A+44|0;M=A+64|0;u=A+68|0;v=A+72|0;O=A+48|0;Q=O;R=b;b=A+4|0;S=A+32|0;A=z+(d*80|0)+48|0;T=z+(d*80|0)+16|0;U=0;V=0;a:while(1){a[K]=1;W=c[E>>2]|0;X=c[N>>2]|0;Y=c[M>>2]|0;Z=c[u>>2]|0;_=c[v>>2]|0;c[k>>2]=c[t>>2];c[k+4>>2]=c[t+4>>2];FFc(H,W,X,+h[k>>3],w,c[F>>2]|0,D,Y,Z,_,Q,R,d);a[K]=0;if((c[O>>2]|0)==0){zTc(x,I,B);P=+h[c[c[J>>2]>>2]>>3];_=g;Z=x;c[_+0>>2]=c[Z+0>>2];c[_+4>>2]=c[Z+4>>2];c[_+8>>2]=c[Z+8>>2];c[_+12>>2]=c[Z+12>>2];c[_+16>>2]=c[Z+16>>2];eDc(3,g,P);}$=+KDc(H,c[b>>2]|0);aa=+KDc(H,c[N>>2]|0);P=+h[S>>3];if(!(!(aa<=P)&!($<=P))){if((c[O>>2]|0)>0){ba=12;break}}do{if((V|0)<1){N4c(c[E>>2]|0,c[A>>2]|0,c[G>>2]<<3|0)|0;Z=c[C>>2]|0;EBc(17,0,327216,p);ca=Z}else{if((V|0)<2){Z=c[G>>2]|0;if((Z|0)>0){_=c[T>>2]|0;Y=c[E>>2]|0;X=0;do{W=Y+(X<<3)|0;h[W>>3]=+h[_+(X<<3)>>3]*.01+ +h[W>>3];X=X+1|0;}while((X|0)<(Z|0))}Z=c[C>>2]|0;EBc(17,0,327272,o);ca=Z;break}if((V|0)>=3){ba=28;break a}Z=c[G>>2]|0;if((Z|0)>0){X=c[T>>2]|0;_=c[E>>2]|0;Y=0;do{h[_+(Y<<3)>>3]=+h[X+(Y<<3)>>3];Y=Y+1|0;}while((Y|0)<(Z|0))}Z=c[C>>2]|0;EBc(17,0,327336,n);ca=Z}}while(0);U=ca+U|0;V=V+1|0}do{if((ba|0)==12){if((c[292372>>2]|0)==0){da=1;break}ca=(c[C>>2]|0)+U|0;c[s>>2]=V;EBc(17,0,327088,s);c[r>>2]=ca;ca=r+4|0;h[k>>3]=aa;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=r+12|0;h[k>>3]=$;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];EBc(17,0,327128,r);if((c[G>>2]|0)>0){ea=0}else{da=1;break}while(1){P=+h[(c[E>>2]|0)+(ea<<3)>>3];L=+h[(c[N>>2]|0)+(ea<<3)>>3];c[q>>2]=ea;ca=q+4|0;h[k>>3]=P;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];ca=q+12|0;h[k>>3]=L;c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];EBc(17,0,327184,q);ca=ea+1|0;if((ca|0)<(c[G>>2]|0)){ea=ca}else{da=1;break}}}else if((ba|0)==28){zTc(y,I,B);L=+h[c[c[J>>2]>>2]>>3];ca=f;n=y;c[ca+0>>2]=c[n+0>>2];c[ca+4>>2]=c[n+4>>2];c[ca+8>>2]=c[n+8>>2];c[ca+12>>2]=c[n+12>>2];c[ca+16>>2]=c[n+16>>2];eDc(0,f,L);if((c[292372>>2]|0)==0){da=0;break}c[m>>2]=V;EBc(17,0,327416,m);c[l>>2]=U;n=l+4|0;h[k>>3]=aa;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=l+12|0;h[k>>3]=$;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];EBc(17,0,327128,l);if((c[292372>>2]|0)==0){da=0;break}if((c[G>>2]|0)>0){fa=0}else{da=0;break}while(1){L=+h[(c[E>>2]|0)+(fa<<3)>>3];P=+h[(c[N>>2]|0)+(fa<<3)>>3];c[j>>2]=fa;n=j+4|0;h[k>>3]=L;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];n=j+12|0;h[k>>3]=P;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];EBc(17,0,327184,j);n=fa+1|0;if((n|0)<(c[G>>2]|0)){fa=n}else{da=0;break}}}}while(0);if((c[292372>>2]|0)==0){ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;N4c(ma|0,oa|0,qa|0)|0;i=e;return da|0}fe[c[73214]&1023](17);ga=z;ha=d*80|0;ia=ga+ha|0;ja=ia+44|0;ka=ja;la=c[ka>>2]|0;ma=la;na=c[E>>2]|0;oa=na;pa=c[G>>2]|0;qa=pa<<3;N4c(ma|0,oa|0,qa|0)|0;i=e;return da|0}function FFc(b,d,e,f,g,j,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0;s=i;i=i+8|0;t=s;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+4096|0;E=q;F=c[q+468>>2]|0;G=c[F+(r*80|0)+40>>2]|0;H=+h[G+32>>3];c[B>>2]=1;c[C>>2]=1;do{if((c[292376>>2]|0)!=0){c[z>>2]=j;EBc(18,0,327456,z);if((c[b>>2]|0)>0){I=0}else{break}do{J=+h[d+(I<<3)>>3];c[y>>2]=I;K=y+4|0;h[k>>3]=J;c[K>>2]=c[k>>2];c[K+4>>2]=c[k+4>>2];EBc(18,0,327504,y);I=I+1|0;}while((I|0)<(c[b>>2]|0))}}while(0);c[p>>2]=1;I=F+(r*80|0)+28|0;F=D;D=G+12|0;y=G+8|0;z=G+4|0;K=G+20|0;L=G+64|0;G=j;a:while(1){GFc(d,e,A,q,r)|0;c[l>>2]=(c[l>>2]|0)+1;if((c[I>>2]|0)==-1){HFc(b,d,e,m,+h[g>>3],A,n,q,r);c[l>>2]=(c[b>>2]|0)+(c[l>>2]|0)}else{DFc(E,m,r)|0}if((c[292380>>2]|0)!=0){j=c[b>>2]|0;c[x>>2]=j;c[x+4>>2]=j;EBc(19,1,327520,x);if((c[D>>2]|0)>0){j=0;do{a[F]=0;if((c[D>>2]|0)>0){M=0;do{J=+h[m+((fa(c[b>>2]|0,j)|0)+M<<3)>>3];c[w>>2]=F;N=w+4|0;h[k>>3]=J;c[N>>2]=c[k>>2];c[N+4>>2]=c[k+4>>2];hc(F|0,327544,w|0)|0;M=M+1|0;}while((M|0)<(c[D>>2]|0))}c[v>>2]=F;EBc(19,0,327552,v);j=j+1|0;}while((j|0)<(c[D>>2]|0))}fe[c[73214]&1023](19)}j=c[D>>2]|0;if((j|0)>0){M=c[z>>2]|0;N=c[K>>2]|0;O=c[y>>2]|0;P=0;Q=0;while(1){R=M+(P<<3)|0;h[R>>3]=1.0e-16;S=c[L>>2]|0;T=(j|0)>1?j:1;J=1.0e-16;V=0;W=Q;while(1){X=+U(+(+h[S+(W<<3)>>3]));Y=X>J?X:J;h[R>>3]=Y;Z=V+1|0;if((Z|0)<(j|0)){W=W+1|0;V=Z;J=Y}else{break}}h[O+(P<<3)>>3]=+h[N+(P<<3)>>3]*(1.0/Y);V=P+1|0;if((V|0)<(j|0)){P=V;Q=Q+T|0}else{_=O;break}}}else{_=c[y>>2]|0}J=+KDc(b,_);if(!(!(J<=H)&!(+KDc(b,e)<=H))){$=31;break}pwc(b,B,m,b,o,e,b,C)|0;O=c[C>>2]|0;do{if((O|0)>0){c[p>>2]=-1;GBc(17,0,327560,u)}else{if((O|0)<0){c[p>>2]=-1;c[t>>2]=O;GBc(17,0,327592,t);break}Q=c[b>>2]|0;if((Q|0)>0){P=0;do{j=d+(P<<3)|0;h[j>>3]=+h[j>>3]- +h[e+(P<<3)>>3];P=P+1|0;}while((P|0)<(Q|0))}if(+KDc(b,e)<=f){$=31;break a}}}while(0);if((G|0)<1){$=30;break}if((c[p>>2]|0)>-1){G=G+ -1|0}else{$=31;break}}if(($|0)==30){c[p>>2]=-1;i=s;return}else if(($|0)==31){i=s;return}}function GFc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0;g=i;Ie[c[(c[e+468>>2]|0)+(f*80|0)+32>>2]&63](e,a,b,d);i=g;return 0}function HFc(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0.0,o=0,p=0,q=0.0,r=0.0,s=0.0,t=0.0,u=0,v=0,w=0,x=0;m=i;n=+V(+f);if((c[a>>2]|0)<=0){i=m;return}o=(c[(c[k+468>>2]|0)+(l*80|0)+56>>2]|0)==0;p=0;do{f=+h[b+(p<<3)>>3];if(o){if(!(f>=0.0)){q=-f}else{q=f}r=n*+td(1.0,+q);if(!(+h[d+(p<<3)>>3]>=0.0)){s=-r}else{s=r}t=s+f-f}else{t=1.0}u=b+(p<<3)|0;h[u>>3]=t+f;r=1.0/t;GFc(b,j,g,k,l)|0;v=c[a>>2]|0;if((v|0)>0){w=0;do{x=(fa(v,p)|0)+w|0;h[e+(x<<3)>>3]=r*(+h[j+(w<<3)>>3]- +h[d+(w<<3)>>3]);w=w+1|0;}while((w|0)<(v|0))}h[u>>3]=f;p=p+1|0;}while((p|0)<(v|0));i=m;return}function IFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;e=c[b+24>>2]|0;if((e|0)==2){JFc(a,b);f=0;i=d;return f|0}else if((e|0)==4){te[c[(c[a+540>>2]|0)+56>>2]&1](a,+h[b+8>>3])|0;h[b>>3]=+h[c[c[a+4>>2]>>2]>>3];f=0;i=d;return f|0}else if((e|0)==3){f=aEc(a,b)|0;i=d;return f|0}else if((e|0)==1){e=c[a+4>>2]|0;g=c[e+4>>2]|0;KFc(c[e>>2]|0,+h[g>>3],c[g+8>>2]|0,c[a+112>>2]|0,b);f=0;i=d;return f|0}else{f=1;i=d;return f|0}return 0}function JFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0.0,z=0,A=0.0;d=i;e=c[c[b+48>>2]>>2]|0;f=c[a+4>>2]|0;g=c[f>>2]|0;j=c[f+4>>2]|0;f=g+8|0;k=c[f>>2]|0;l=a+112|0;m=c[l>>2]|0;n=j+8|0;o=c[n>>2]|0;p=j;j=b+8|0;q=b;h[q>>3]=+h[p>>3]+ +h[j>>3];if((m|0)>0){b=c[e>>2]|0;r=0;do{h[b+(r<<3)>>3]=+h[o+(r+m<<3)>>3];r=r+1|0;}while((r|0)<(m|0))}r=g;g=a+540|0;o=m;b=1;do{if((o|0)>0){s=c[n>>2]|0;t=+h[327624+(b<<3)>>3];u=c[e+(b+ -1<<2)>>2]|0;v=c[f>>2]|0;w=0;while(1){h[v+(w<<3)>>3]=+h[s+(w<<3)>>3]+ +h[j>>3]*t*+h[u+(w<<3)>>3];x=w+1|0;if((x|0)<(o|0)){w=x}else{y=t;break}}}else{y=+h[327624+(b<<3)>>3]}h[r>>3]=+h[p>>3]+y*+h[j>>3];ie[c[(c[g>>2]|0)+28>>2]&127](a)|0;o=c[l>>2]|0;z=(o|0)>0;if(z){w=c[e+(b<<2)>>2]|0;u=0;do{h[w+(u<<3)>>3]=+h[k+(u+m<<3)>>3];u=u+1|0;}while((u|0)<(o|0))}b=b+1|0;}while((b|0)<4);if(!z){A=+h[q>>3];h[r>>3]=A;i=d;return}z=c[n>>2]|0;n=c[f>>2]|0;f=c[e>>2]|0;b=c[e+4>>2]|0;m=c[e+8>>2]|0;k=c[e+12>>2]|0;e=0;do{h[n+(e<<3)>>3]=+h[z+(e<<3)>>3]+(+h[f+(e<<3)>>3]*.16666666666666666+0.0+ +h[b+(e<<3)>>3]*.3333333333333333+ +h[m+(e<<3)>>3]*.3333333333333333+ +h[k+(e<<3)>>3]*.16666666666666666)*+h[j>>3];e=e+1|0;}while((e|0)<(o|0));A=+h[q>>3];h[r>>3]=A;i=d;return}function KFc(a,b,d,e,f){a=a|0;b=+b;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0,r=0;g=i;j=f+8|0;k=+h[j>>3];l=k+b;m=f;h[m>>3]=l;if((e|0)<=0){n=l;o=a;p=o;h[p>>3]=n;i=g;return}f=c[a+8>>2]|0;l=k;q=0;while(1){h[f+(q<<3)>>3]=+h[d+(q<<3)>>3]+ +h[d+(q+e<<3)>>3]*l;r=q+1|0;if((r|0)>=(e|0)){break}l=+h[j>>3];q=r}n=+h[m>>3];o=a;p=o;h[p>>3]=n;i=g;return}function LFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+8|0;h[d>>3]=+h[b+240>>3];h[d+8>>3]=+h[b+264>>3];h[d+16>>3]=0.0;a[d+28|0]=0;c[d+32>>2]=LBc(4)|0;c[d+36>>2]=0;c[d+40>>2]=0;c[d+44>>2]=0;f=c[d+24>>2]|0;a:do{if((f|0)==3){g=h4c(88)|0;EBc(23,0,327656,e);j=_Dc(b,d,g)|0;c[d+48>>2]=g;k=j}else if((f|0)==2){j=h4c(8)|0;c[j+4>>2]=4;g=h4c(20)|0;c[j>>2]=g;l=c[b+112>>2]|0;m=g;g=0;while(1){c[m+(g<<2)>>2]=j4c(l,8)|0;if((g|0)>=4){break}m=c[j>>2]|0;g=g+1|0}c[d+48>>2]=j;k=0}else if((f|0)==4){g=c[590]|0;m=h4c(g<<2)|0;c[81920]=m;if((g|0)<=0){k=0;break}l=c[b+116>>2]|0;n=m;m=0;while(1){c[n+(m<<2)>>2]=j4c(l,8)|0;o=m+1|0;if((o|0)>=(g|0)){k=0;break a}n=c[81920]|0;m=o}}else{k=0}}while(0);YFc(b)|0;if((c[2]|0)==0){i=e;return k|0}bDc(6);_Cc(1);i=e;return k|0}function MFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;d=i;e=c[b+24>>2]|0;if((e|0)==4){f=c[590]|0;g=c[81920]|0;if((f|0)>0){h=g;j=0;while(1){i4c(c[h+(j<<2)>>2]|0);k=j+1|0;l=c[81920]|0;if((k|0)<(f|0)){j=k;h=l}else{m=l;break}}}else{m=g}i4c(m)}else if((e|0)==2){m=b+48|0;g=c[m>>2]|0;h=c[g>>2]|0;if((c[g+4>>2]|0)>-1){g=h;j=0;while(1){i4c(c[g+(j<<2)>>2]|0);f=c[m>>2]|0;l=c[f>>2]|0;if((j|0)<(c[f+4>>2]|0)){j=j+1|0;g=l}else{n=l;break}}}else{n=h}i4c(n);i4c(c[m>>2]|0)}else if((e|0)==3){$Dc(c[b+48>>2]|0)|0}ZFc(a)|0;TFc(a);i=d;return 0}function NFc(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+168|0;c[o>>2]=0;p=i;i=i+160|0;q=b+536|0;r=c[q>>2]|0;u=0;pa(753,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){t=Y4c(c[s>>2]|0,o)|0;if((t|0)==0){eb(s|0,v|0)}J=v}else{t=-1}do{if((t|0)==1){w=0;x=0;y=0;z=0;A=J}else{u=0;sa(97,b|0)|0;s=u;u=0;if((s|0)!=0&(v|0)!=0){B=Y4c(c[s>>2]|0,o)|0;if((B|0)==0){eb(s|0,v|0)}J=v}else{B=-1}if((B|0)==1){w=0;x=0;y=0;z=0;A=J;break}s=b+540|0;u=0;sa(c[(c[s>>2]|0)+40>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){D=Y4c(c[C>>2]|0,o)|0;if((D|0)==0){eb(C|0,v|0)}J=v}else{D=-1}if((D|0)==1){w=0;x=0;y=0;z=0;A=J;break}if((a[b+440|0]|0)!=0){u=0;sa(c[(c[s>>2]|0)+44>>2]|0,b|0)|0;C=u;u=0;if((C|0)!=0&(v|0)!=0){E=Y4c(c[C>>2]|0,o)|0;if((E|0)==0){eb(C|0,v|0)}J=v}else{E=-1}if((E|0)==1){w=0;x=0;y=0;z=0;A=J;break}}C=b+240|0;h[c[c[b+4>>2]>>2]>>3]=+h[C>>3];u=0;pa(c[(c[s>>2]|0)+4>>2]|0,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){F=Y4c(c[s>>2]|0,o)|0;if((F|0)==0){eb(s|0,v|0)}J=v}else{F=-1}if((F|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;pa(754,b|0);s=u;u=0;if((s|0)!=0&(v|0)!=0){G=Y4c(c[s>>2]|0,o)|0;if((G|0)==0){eb(s|0,v|0)}J=v}else{G=-1}if((G|0)==1){w=0;x=0;y=0;z=C;A=J;break}u=0;oa(1,+(+h[b+272>>3]));s=u;u=0;if((s|0)!=0&(v|0)!=0){H=Y4c(c[s>>2]|0,o)|0;if((H|0)==0){eb(s|0,v|0)}J=v}else{H=-1}if((H|0)==1){w=0;x=0;y=0;z=C;A=J;break}c[(c[q>>2]|0)+84>>2]=1;s=p;I=r+80|0;K=c[I>>2]|0;c[I>>2]=p;K4c(p,1,o|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Y4c(c[L>>2]|0,o)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}if((M|0)==1){w=K;x=I;y=s;z=C;A=J;break}w=K;x=I;y=s;z=C;A=0}}while(0);a:while(1){do{if((A|0)==0){u=0;M=Ja(1,b|0,d|0,e|0,f|0,+g,j|0)|0;p=u;u=0;if((p|0)!=0&(v|0)!=0){N=Y4c(c[p>>2]|0,o)|0;if((N|0)==0){eb(p|0,v|0)}J=v}else{N=-1}if((N|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}if((M|0)==0){S=0;T=1;break}u=0;Sa(14,1,0,327688,n|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){U=Y4c(c[M>>2]|0,o)|0;if((U|0)==0){eb(M|0,v|0)}J=v}else{U=-1}if((U|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue a}h[b+248>>3]=+h[z>>3];S=-1;T=1}else{S=0;T=0}}while(0);c[x>>2]=w;u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Y4c(c[M>>2]|0,o)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}if((V|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if(T){W=S}else{u=0;Sa(15,2,0,327784,m|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){X=Y4c(c[M>>2]|0,o)|0;if((X|0)==0){eb(M|0,v|0)}J=v}else{X=-1}if((X|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}W=-1}u=0;qa(c[333904>>2]|0,333880,b|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Y=Y4c(c[M>>2]|0,o)|0;if((Y|0)==0){eb(M|0,v|0)}J=v}else{Y=-1}if((Y|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}u=0;Sa(15,23,0,327840,l|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){Z=Y4c(c[M>>2]|0,o)|0;if((Z|0)==0){eb(M|0,v|0)}J=v}else{Z=-1}if((Z|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R;continue}if((c[2]|0)==0){_=26;break}u=0;pa(755,1);M=u;u=0;if((M|0)!=0&(v|0)!=0){$=Y4c(c[M>>2]|0,o)|0;if(($|0)==0){eb(M|0,v|0)}J=v}else{$=-1}if(($|0)==1){O=z;P=y;Q=x;R=w;A=J;z=O;y=P;x=Q;w=R}else{break}}if((_|0)==26){i=k;return W|0}i=k;return W|0}function OFc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0.0,I=0,J=0.0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=+h[d>>3];do{if(H>=+h[b+248>>3]){if((c[d+24>>2]|0)==5){break}I=G;h[k>>3]=H;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];EBc(8,0,327936,G);I=b+313|0;a[I]=1;yEc(b);if((c[349212>>2]|0)==0){ge[c[333900>>2]&255](333880,b)}a[I]=0}}while(0);if((e|0)!=0){PFc(Ad(e|0)|0,b)}if((c[292404>>2]|0)==0){i=f;return 0}bDc(0);EBc(25,0,327984,F);EBc(25,1,328008,E);H=+VCc(6);J=+VCc(6);K=J/+VCc(0)*100.0;E=D;h[k>>3]=H;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];E=D+8|0;h[k>>3]=K;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];EBc(25,0,328016,D);K=+VCc(1);H=+VCc(1);J=H/+VCc(0)*100.0;D=C;h[k>>3]=K;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];D=C+8|0;h[k>>3]=J;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];EBc(25,0,328056,C);J=+VCc(2);K=+VCc(2);H=K/+VCc(0)*100.0;C=B;h[k>>3]=J;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=B+8|0;h[k>>3]=H;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];EBc(25,0,328088,B);H=+VCc(3);J=+VCc(3);K=J/+VCc(0)*100.0;B=A;h[k>>3]=H;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];B=A+8|0;h[k>>3]=K;c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];EBc(25,0,328112,A);K=+VCc(4);H=+VCc(4);J=H/+VCc(0)*100.0;A=z;h[k>>3]=K;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=J;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];EBc(25,0,328152,z);J=+VCc(7);K=+VCc(7);H=K/+VCc(0)*100.0;z=y;h[k>>3]=J;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=y+8|0;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(25,0,328184,y);y=d+24|0;z=(c[y>>2]|0)==5;H=+VCc(0);J=H- +VCc(7);H=J- +VCc(4);J=H- +VCc(3);H=J- +VCc(2);J=H- +VCc(1);H=J- +VCc(6);J=+VCc(0);K=J- +VCc(7);J=K- +VCc(4);K=J- +VCc(3);J=K- +VCc(2);K=J- +VCc(1);J=K- +VCc(6);K=J/+VCc(0)*100.0;if(z){z=w;h[k>>3]=H;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];z=w+8|0;h[k>>3]=K;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(25,0,328248,w)}else{w=x;h[k>>3]=H;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=x+8|0;h[k>>3]=K;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];EBc(25,0,328216,x)}K=+VCc(0);H=+VCc(0);J=H/+VCc(0)*100.0;x=v;h[k>>3]=K;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];x=v+8|0;h[k>>3]=J;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];EBc(25,0,328280,v);fe[c[73214]&1023](25);EBc(25,1,328304,u);c[t>>2]=c[d+40>>2];EBc(25,0,328312,t);c[s>>2]=c[d+44>>2];EBc(25,0,328336,s);fe[c[73214]&1023](25);s=c[y>>2]|0;if((s|0)==3){y=d+48|0;d=c[y>>2]|0;t=c[d+8>>2]|0;u=c[d+4>>2]|0;c[u>>2]=(c[u>>2]|0)+(c[t>>2]|0);d=u+4|0;c[d>>2]=(c[d>>2]|0)+(c[t+4>>2]|0);d=u+8|0;c[d>>2]=(c[d>>2]|0)+(c[t+8>>2]|0);d=u+12|0;c[d>>2]=(c[d>>2]|0)+(c[t+12>>2]|0);d=u+16|0;c[d>>2]=(c[d>>2]|0)+(c[t+16>>2]|0);EBc(25,1,328360,r);c[q>>2]=c[c[(c[y>>2]|0)+4>>2]>>2];EBc(25,0,328376,q);c[p>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+4>>2];EBc(25,0,328392,p);c[o>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+8>>2];EBc(25,0,328424,o);c[n>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+12>>2];EBc(25,0,328456,n);c[m>>2]=c[(c[(c[y>>2]|0)+4>>2]|0)+16>>2];EBc(25,0,328480,m);fe[c[73214]&1023](25)}else if((s|0)!=5){EBc(25,1,328512,l);EBc(25,0,328520,j);fe[c[73214]&1023](25)}EBc(25,0,328584,g);_Cc(0);i=f;return 0}function PFc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+16|0;y=i;i=i+8|0;z=Xb(b|0,329056)|0;b=c[t>>2]|0;A=d+4|0;B=y;h[k>>3]=+h[c[c[A>>2]>>2]>>3];c[B>>2]=c[k>>2];c[B+4>>2]=c[k+4>>2];wd(b|0,329064,y|0)|0;if((z|0)==0){C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}y=d+116|0;B=d+124|0;E=d+128|0;F=d+132|0;G=d+216|0;H=d+220|0;I=d+224|0;J=d+228|0;K=d+136|0;L=d+140|0;M=d+144|0;N=d+148|0;O=d+36|0;P=d+428|0;Q=d+32|0;R=d+424|0;S=d+28|0;T=d+420|0;U=d+24|0;V=d+416|0;W=d+52|0;X=d+48|0;Y=d+44|0;Z=d+40|0;_=d+20|0;$=d+16|0;aa=d+12|0;ba=d+8|0;d=z;do{z=c[y>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[ba>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];c[x>>2]=d;ea=x+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,329080,x|0)|0;fa=c[y>>2]|0}else{fa=ca}ea=z+1|0;if((ea|0)<(fa|0)){ca=fa;z=ea}else{break}}}z=c[B>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[aa>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(z<<2)>>2]|0;c[w>>2]=d;c[w+4>>2]=ea;wd(b|0,329096,w|0)|0;ga=c[B>>2]|0}else{ga=ca}ea=z+1|0;if((ea|0)<(ga|0)){ca=ga;z=ea}else{break}}}z=c[E>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[$>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+z|0]|0;c[v>>2]=d;c[v+4>>2]=ea;wd(b|0,329104,v|0)|0;ha=c[E>>2]|0}else{ha=ca}ea=z+1|0;if((ea|0)<(ha|0)){ca=ha;z=ea}else{break}}}z=c[F>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[_>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(z<<2)>>2]|0;c[u>>2]=d;c[u+4>>2]=ea;wd(b|0,329112,u|0)|0;ia=c[F>>2]|0}else{ia=ca}ea=z+1|0;if((ea|0)<(ia|0)){ca=ia;z=ea}else{break}}}if((c[G>>2]|0)>0){z=0;do{ca=c[Z>>2]|0;do{if((H4c(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){da=+h[(c[(c[c[A>>2]>>2]|0)+8>>2]|0)+(c[ca+(z*52|0)+4>>2]<<3)>>3];if((c[ca+(z*52|0)>>2]|0)==0){c[r>>2]=d;ea=r+4|0;h[k>>3]=da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,329080,r|0)|0;break}else{c[s>>2]=d;ea=s+4|0;h[k>>3]=-da;c[ea>>2]=c[k>>2];c[ea+4>>2]=c[k+4>>2];wd(b|0,329080,s|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[G>>2]|0))}if((c[H>>2]|0)>0){z=0;do{ca=c[Y>>2]|0;do{if((H4c(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=c[(c[(c[c[A>>2]>>2]|0)+12>>2]|0)+(c[ca+(z*52|0)+4>>2]<<2)>>2]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[p>>2]=d;c[p+4>>2]=ea;wd(b|0,329096,p|0)|0;break}else{c[q>>2]=d;c[q+4>>2]=0-ea;wd(b|0,329096,q|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[H>>2]|0))}if((c[I>>2]|0)>0){z=0;do{ca=c[X>>2]|0;do{if((H4c(d,c[ca+(z*52|0)+16>>2]|0)|0)==0){ea=a[(c[(c[c[A>>2]>>2]|0)+16>>2]|0)+(c[ca+(z*52|0)+4>>2]|0)|0]|0;if((c[ca+(z*52|0)>>2]|0)==0){c[n>>2]=d;c[n+4>>2]=ea;wd(b|0,329104,n|0)|0;break}else{c[o>>2]=d;c[o+4>>2]=0-ea;wd(b|0,329104,o|0)|0;break}}}while(0);z=z+1|0;}while((z|0)<(c[I>>2]|0))}z=c[J>>2]|0;if((z|0)>0){ca=z;z=0;while(1){ea=c[W>>2]|0;if((H4c(d,c[ea+(z*52|0)+16>>2]|0)|0)==0){ja=c[(c[(c[c[A>>2]>>2]|0)+20>>2]|0)+(c[ea+(z*52|0)+4>>2]<<2)>>2]|0;c[m>>2]=d;c[m+4>>2]=ja;wd(b|0,329112,m|0)|0;ka=c[J>>2]|0}else{ka=ca}ja=z+1|0;if((ja|0)<(ka|0)){ca=ka;z=ja}else{break}}}z=c[K>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[U>>2]|0)+(z*112|0)+4>>2]|0)|0)==0){da=+h[(c[V>>2]|0)+(z<<3)>>3];c[l>>2]=d;ja=l+4|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];wd(b|0,329080,l|0)|0;la=c[K>>2]|0}else{la=ca}ja=z+1|0;if((ja|0)<(la|0)){ca=la;z=ja}else{break}}}z=c[L>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[S>>2]|0)+(z*60|0)+4>>2]|0)|0)==0){ja=c[(c[T>>2]|0)+(z<<2)>>2]|0;c[j>>2]=d;c[j+4>>2]=ja;wd(b|0,329096,j|0)|0;ma=c[L>>2]|0}else{ma=ca}ja=z+1|0;if((ja|0)<(ma|0)){ca=ma;z=ja}else{break}}}z=c[M>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[Q>>2]|0)+(z*48|0)+4>>2]|0)|0)==0){ja=a[(c[R>>2]|0)+z|0]|0;c[g>>2]=d;c[g+4>>2]=ja;wd(b|0,329104,g|0)|0;na=c[M>>2]|0}else{na=ca}ja=z+1|0;if((ja|0)<(na|0)){ca=na;z=ja}else{break}}}z=c[N>>2]|0;if((z|0)>0){ca=z;z=0;while(1){if((H4c(d,c[(c[O>>2]|0)+(z*52|0)+4>>2]|0)|0)==0){ja=c[(c[P>>2]|0)+(z<<2)>>2]|0;c[f>>2]=d;c[f+4>>2]=ja;wd(b|0,329112,f|0)|0;oa=c[N>>2]|0}else{oa=ca}ja=z+1|0;if((ja|0)<(oa|0)){ca=oa;z=ja}else{break}}}d=Xb(0,329056)|0;}while((d|0)!=0);C=Sd(10,b|0)|0;D=ud(b|0)|0;i=e;return}function QFc(a,b,d,e,f,g,j,l){a=a|0;b=b|0;d=d|0;e=e|0;f=+f;g=g|0;j=j|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0;m=i;i=i+16|0;n=m;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+56|0;t=s;u=s+24|0;c[u>>2]=j;a:do{switch(j|0){case 4:{v=c[588]|0;if((v|0)!=0){if((H4c(v,328720)|0)==0){break a}}EBc(23,0,328736,p);w=1;i=m;return w|0};case 17:case 16:case 15:case 14:case 13:case 12:{c[u>>2]=3;break};case 5:{GBc(1,0,328680,q);w=1;i=m;return w|0};case 18:{v=c[588]|0;do{if((v|0)!=0){if((H4c(v,328864)|0)!=0){break}c[u>>2]=4;break a}}while(0);EBc(23,0,328888,o);w=1;i=m;return w|0};case 11:case 10:case 9:case 6:case 7:case 8:{GBc(1,0,328608,r);w=1;i=m;return w|0};default:{}}}while(0);r=LFc(a,s)|0;Ce[c[293204>>2]&7]()|0;do{if((r|0)==0){o=NFc(a,b,d,e,f,g)|0;Ce[c[293204>>2]&7]()|0;if((o|0)!=0){x=o;break}if((c[u>>2]|0)!=5){ge[c[333900>>2]&255](333880,a);IEc(a)}y=+h[a+248>>3];o=n;h[k>>3]=+h[a+240>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=y;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];EBc(23,0,329016,n);o=xe[c[c[a+540>>2]>>2]&63](a,t)|0;Ce[c[293204>>2]&7]()|0;OFc(a,s,l)|0;Ce[c[293204>>2]&7]()|0;x=o}else{Ce[c[293204>>2]&7]()|0;x=r}}while(0);MFc(a,s)|0;w=x;i=m;return w|0}function RFc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0;b=i;i=i+8|0;d=b;e=a+204|0;if((c[e>>2]|0)<=0){SFc(a);i=b;return}f=a+488|0;g=a;h=0;while(1){j=h+1|0;if((ie[c[(c[f>>2]|0)+(h*48|0)+40>>2]&127](g)|0)!=0){k=5;break}if((j|0)<(c[e>>2]|0)){h=j}else{k=6;break}}if((k|0)==5){IBc(c[a+536>>2]|0,329128,d)}else if((k|0)==6){SFc(a);i=b;return}}function SFc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;f=a+12|0;g=a+4|0;a=0;do{h=c[e>>2]|0;j=(c[c[h+(a*48|0)+12>>2]>>2]|0)-(c[c[f>>2]>>2]|0)|0;k=c[(c[c[g>>2]>>2]|0)+12>>2]|0;l=h+(a*48|0)|0;m=h+(a*48|0)+4|0;P4c(k+(j<<2)|0,0,fa(c[l>>2]<<2,c[m>>2]|0)|0)|0;n=h+(a*48|0)+8|0;if((c[n>>2]|0)>0){o=c[h+(a*48|0)+16>>2]|0;p=0;do{c[o+(p<<2)>>2]=p;p=p+1|0;}while((p|0)<(c[n>>2]|0))}n=c[l>>2]|0;if((n|0)>0){p=c[h+(a*48|0)+20>>2]|0;o=n;n=0;do{c[p+(n<<2)>>2]=o+~n;n=n+1|0;o=c[l>>2]|0;}while((n|0)<(o|0))}o=c[m>>2]|0;if((o|0)>0){n=o;o=0;do{c[k+(o+j+(fa(n,o)|0)<<2)>>2]=1;o=o+1|0;n=c[m>>2]|0;}while((o|0)<(n|0))}a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function TFc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+204|0;if((c[d>>2]|0)<=0){i=b;return}e=a+488|0;a=0;do{f=c[e>>2]|0;i4c(c[f+(a*48|0)+28>>2]|0);i4c(c[f+(a*48|0)+32>>2]|0);i4c(c[f+(a*48|0)+16>>2]|0);i4c(c[f+(a*48|0)+20>>2]|0);i4c(c[f+(a*48|0)+24>>2]|0);a=a+1|0;}while((a|0)<(c[d>>2]|0));i=b;return}function UFc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+4096|0;p=b+204|0;if((c[p>>2]|0)<=0){q=0;i=f;return q|0}r=b+488|0;s=d<<24>>24==0;d=(e|0)==0;t=0;u=0;while(1){v=c[r>>2]|0;w=v+(u*48|0)|0;x=h4c(c[w>>2]<<2)|0;y=v+(u*48|0)+8|0;z=h4c(c[y>>2]<<2)|0;VFc(b,u);A=v+(u*48|0)+20|0;B=c[A>>2]|0;C=c[w>>2]|0;N4c(x|0,B|0,C<<2|0)|0;D=v+(u*48|0)+16|0;E=c[D>>2]|0;F=c[y>>2]|0;N4c(z|0,E|0,F<<2|0)|0;G=v+(u*48|0)+24|0;if(!((ZDc(c[G>>2]|0,F,C,E,B)|0)==0|s)){break}B=WFc(x,c[A>>2]|0,c[w>>2]|0,c[y>>2]|0,c[v+(u*48|0)+4>>2]|0,c[v+(u*48|0)+12>>2]|0,c[v+(u*48|0)+28>>2]|0,c[v+(u*48|0)+32>>2]|0,b,e)|0;if(d){N4c(c[A>>2]|0,x|0,c[w>>2]<<2|0)|0;N4c(c[D>>2]|0,z|0,c[y>>2]<<2|0)|0}y=(B|0)==0?t:1;i4c(x);i4c(z);z=u+1|0;if((z|0)<(c[p>>2]|0)){t=y;u=z}else{q=y;H=15;break}}if((H|0)==15){i=f;return q|0}q=o;o=v+(u*48|0)+44|0;f=c[o>>2]|0;H=b+464|0;t=c[H>>2]|0;p=c[t+(f*44|0)>>2]|0;c[n>>2]=c[t+(f*44|0)+4>>2];c[n+4>>2]=p;c[n+8>>2]=f;GBc(5,1,329184,n);n=c[H>>2]|0;if((c[n+((c[o>>2]|0)*44|0)+4>>2]|0)!=0){f=n;n=0;do{a[q]=0;p=c[f+((c[o>>2]|0)*44|0)>>2]|0;if((p|0)!=0){t=p;p=0;do{d=(fa(t,n)|0)+p|0;I=+h[(c[G>>2]|0)+(d<<3)>>3];c[m>>2]=q;d=m+4|0;h[k>>3]=I;c[d>>2]=c[k>>2];c[d+4>>2]=c[k+4>>2];hc(q|0,329216,m|0)|0;p=p+1|0;t=c[(c[H>>2]|0)+((c[o>>2]|0)*44|0)>>2]|0;}while(p>>>0<t>>>0)}c[l>>2]=q;GBc(5,0,329224,l);n=n+1|0;f=c[H>>2]|0;}while(n>>>0<(c[f+((c[o>>2]|0)*44|0)+4>>2]|0)>>>0)}if((c[w>>2]|0)<=0){J=292856;K=c[73214]|0;fe[K&1023](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=329232;aa=$;IBc(O,aa,g)}o=v+(u*48|0)+32|0;u=0;do{c[j>>2]=c[(c[(c[o>>2]|0)+(u<<2)>>2]|0)+4>>2];GBc(5,0,329224,j);u=u+1|0;}while((u|0)<(c[w>>2]|0));J=292856;K=c[73214]|0;fe[K&1023](5);L=b;M=L+536|0;N=M;O=c[N>>2]|0;P=b;Q=P+4|0;R=Q;S=c[R>>2]|0;T=c[S>>2]|0;U=T;V=U;W=+h[V>>3];X=g;Y=X;h[k>>3]=W;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];Z=5;_=Z;$=329232;aa=$;IBc(O,aa,g);return 0}function VFc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0;d=i;e=a+488|0;f=c[e>>2]|0;g=c[f+(b*48|0)+44>>2]|0;j=a+464|0;k=c[j>>2]|0;l=c[f+(b*48|0)+24>>2]|0;P4c(l|0,0,fa(c[k+(g*44|0)+4>>2]<<3,c[k+(g*44|0)>>2]|0)|0)|0;k=c[j>>2]|0;if((c[k+(g*44|0)+24>>2]|0)==0){i=d;return}f=a;a=c[k+(g*44|0)>>2]|0;m=k;k=0;do{if((a|0)!=0){n=0;do{if(((c[(c[m+(g*44|0)+20>>2]|0)+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=1.0}n=n+1|0;}while(n>>>0<a>>>0)}ie[c[(c[e>>2]|0)+(b*48|0)+36>>2]&127](f)|0;m=c[j>>2]|0;a=c[m+(g*44|0)>>2]|0;do{if((a|0)!=0){n=c[m+(g*44|0)+28>>2]|0;o=0;do{do{if(+h[n+(o<<3)>>3]==1.0){if((o|0)==0){p=m+(g*44|0)+8|0;q=0}else{r=m+(g*44|0)+8|0;p=r;q=c[(c[r>>2]|0)+(o+ -1<<2)>>2]|0}r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if(!(q>>>0<r>>>0)){break}s=c[m+(g*44|0)+12>>2]|0;t=c[m+(g*44|0)+4>>2]|0;u=c[m+(g*44|0)+36>>2]|0;v=q;do{w=c[s+(v<<2)>>2]|0;x=(fa(t,o)|0)+w|0;h[l+(x<<3)>>3]=+h[u+(w<<3)>>3];v=v+1|0;}while(v>>>0<r>>>0)}}while(0);o=o+1|0;}while(o>>>0<a>>>0);if((a|0)==0){break}o=c[m+(g*44|0)+20>>2]|0;n=0;do{if(((c[o+(n<<2)>>2]|0)+ -1|0)==(k|0)){h[(c[m+(g*44|0)+28>>2]|0)+(n<<3)>>3]=0.0}n=n+1|0;}while(n>>>0<a>>>0)}}while(0);k=k+1|0;}while(k>>>0<(c[m+(g*44|0)+24>>2]|0)>>>0);i=d;return}function WFc(a,b,d,e,f,g,j,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;o=i;i=i+8|0;p=o;q=j4c(d,4)|0;r=j4c(d,4)|0;s=r;t=(d|0)>0;if(t){u=0}else{v=0;i4c(q);i4c(r);i=o;return v|0}do{w=(u|0)<(e|0)?1:2;c[r+(c[b+(u<<2)>>2]<<2)>>2]=w;c[q+(c[a+(u<<2)>>2]<<2)>>2]=w;u=u+1|0;}while((u|0)<(d|0));if(t){x=0}else{v=0;i4c(q);i4c(r);i=o;return v|0}while(1){t=x+1|0;if((c[r+(x<<2)>>2]|0)!=(c[q+(x<<2)>>2]|0)){break}if((t|0)<(d|0)){x=t}else{v=0;y=9;break}}if((y|0)==9){i4c(q);i4c(r);i=o;return v|0}if((n|0)==0){v=-1;i4c(q);i4c(r);i=o;return v|0}n=p;h[k>>3]=+h[c[c[m+4>>2]>>2]>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];EBc(5,1,329336,p);XFc(s,d,f,c[g>>2]|0,j,l,m);if((c[292324>>2]|0)==0){v=-1;i4c(q);i4c(r);i=o;return v|0}fe[c[73214]&1023](5);v=-1;i4c(q);i4c(r);i=o;return v|0}function XFc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;k=i;i=i+8|0;l=k;m=e-(c[c[j+12>>2]>>2]|0)|0;e=j+4|0;n=c[(c[c[e>>2]>>2]|0)+12>>2]|0;P4c(n+(m<<2)|0,0,fa(b<<2,d)|0)|0;if((b|0)<=0){i=k;return}o=j+8|0;j=0;p=0;while(1){if((c[a+(j<<2)>>2]|0)==2){q=c[c[o>>2]>>2]|0;r=c[g+(j<<2)>>2]|0;s=(c[r>>2]|0)-q|0;t=(c[c[f+(p<<2)>>2]>>2]|0)-q|0;c[l>>2]=c[r+4>>2];EBc(5,0,329368,l);c[n+(p+m+(fa(j,d)|0)<<2)>>2]=1;r=c[(c[c[e>>2]>>2]|0)+8>>2]|0;h[r+(t<<3)>>3]=+h[r+(s<<3)>>3];u=p+1|0}else{u=p}s=j+1|0;if((s|0)<(b|0)){j=s;p=u}else{break}}i=k;return}function YFc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0;d=i;i=i+16|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=ic(329384,329408)|0;o=(n|0)!=0;a[b+440|0]=o&1;if(o){p=0}else{i=d;return 0}a:while(1){while(1){o=dd(n|0)|0;if((o|0)==10){break}else if((o|0)==-1){break a}}p=p+1|0}o=p+ -1|0;p=b+456|0;c[p>>2]=o;c[b+452>>2]=o;pb(n|0);do{}while((dd(n|0)|0)!=10);q=c[b+152>>2]|0;r=j4c(o,4)|0;o=b+444|0;c[o>>2]=r;s=c[p>>2]|0;t=(s|0)>0;b:do{if(t){u=r;v=0;while(1){c[u+(v<<2)>>2]=j4c(q,8)|0;w=v+1|0;if((w|0)>=(s|0)){break}u=c[o>>2]|0;v=w}v=j4c(s,8)|0;u=b+448|0;c[u>>2]=v;if(!t){x=u;break}w=(q|0)>0;y=v;v=0;while(1){c[m>>2]=y+(v<<3);z=Od(n|0,329416,m|0)|0;if(w){A=0;while(1){c[l>>2]=(c[(c[o>>2]|0)+(v<<2)>>2]|0)+(A<<3);B=Od(n|0,329416,l|0)|0;C=A+1|0;if((C|0)<(q|0)){A=C}else{D=B;break}}}else{D=z}if((D|0)<0){c[p>>2]=v;E=v}else{E=c[p>>2]|0}A=v+1|0;if((A|0)>=(E|0)){x=u;break b}y=c[u>>2]|0;v=A}}else{v=b+448|0;c[v>>2]=j4c(s,8)|0;x=v}}while(0);gc(329424,j|0)|0;gc(329480,g|0)|0;if((c[p>>2]|0)>0){g=(q|0)>0;j=0;do{s=f;h[k>>3]=+h[(c[x>>2]|0)+(j<<3)>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];gc(329440,f|0)|0;if(g){s=0;while(1){E=s+1|0;F=+h[(c[(c[o>>2]|0)+(j<<2)>>2]|0)+(s<<3)>>3];c[e>>2]=E;D=e+4|0;h[k>>3]=F;c[D>>2]=c[k>>2];c[D+4>>2]=c[k+4>>2];gc(329464,e|0)|0;if((E|0)<(q|0)){s=E}else{break}}}j=j+1|0;}while((j|0)<(c[p>>2]|0))}tb(329480)|0;Yc(n|0)|0;c[b+460>>2]=0;i=d;return 0}function ZFc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;if((a[b+440|0]|0)==0){i=d;return 0}i4c(c[b+448>>2]|0);e=b+452|0;f=b+444|0;b=c[f>>2]|0;if((c[e>>2]|0)>0){g=b;h=0;while(1){i4c(c[g+(h<<2)>>2]|0);j=h+1|0;k=c[f>>2]|0;if((j|0)<(c[e>>2]|0)){h=j;g=k}else{l=k;break}}}else{l=b}i4c(l);i=d;return 0}function _Fc(b){b=b|0;var d=0,e=0,f=0.0,g=0,j=0,k=0,l=0.0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0;d=i;if((a[b+440|0]|0)==0){e=-1;i=d;return e|0}f=+h[c[c[b+4>>2]>>2]>>3];g=b+460|0;j=c[g>>2]|0;k=c[b+448>>2]|0;l=+h[k+(j<<3)>>3];if(f==l){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;p=0;while(1){h[o+(p<<3)>>3]=+h[n+(p<<3)>>3];q=p+1|0;if((q|0)<(m|0)){p=q}else{e=1;break}}i=d;return e|0}p=j+1|0;r=+h[k+(p<<3)>>3];if(f==r){m=c[b+152>>2]|0;if((m|0)<=0){e=1;i=d;return e|0}n=c[(c[b+444>>2]|0)+(j<<2)>>2]|0;o=c[b+432>>2]|0;q=0;while(1){s=q+1|0;h[o+(q<<3)>>3]=+h[n+(s<<3)>>3];if((s|0)<(m|0)){q=s}else{e=1;break}}i=d;return e|0}a:do{if(f>r){q=(c[b+456>>2]|0)+ -1|0;m=j;n=p;while(1){if((n|0)>=(q|0)){t=m;break a}c[g>>2]=n;o=n+1|0;if(f>+h[k+(o<<3)>>3]){s=n;n=o;m=s}else{t=n;break}}}else{t=j}}while(0);j=t+1|0;r=+h[k+(j<<3)>>3]- +h[k+(t<<3)>>3];k=c[b+152>>2]|0;if((k|0)<=0){e=0;i=d;return e|0}g=c[b+444>>2]|0;p=c[g+(t<<2)>>2]|0;t=c[g+(j<<2)>>2]|0;u=l+r;j=b+432|0;v=u-f;w=f-l;b=0;while(1){x=+h[p+(b<<3)>>3];y=+h[t+(b<<3)>>3];do{if(x!=y){if(x>0.0){z=1}else{z=(x<0.0)<<31>>31}if(y>0.0){A=1}else{A=(y<0.0)<<31>>31}if((z|0)==(A|0)){h[(c[j>>2]|0)+(b<<3)>>3]=(u*x+f*y-(f*x+l*y))/r;break}else{h[(c[j>>2]|0)+(b<<3)>>3]=(v*x+w*y)/r;break}}else{h[(c[j>>2]|0)+(b<<3)>>3]=x}}while(0);g=b+1|0;if((g|0)<(k|0)){b=g}else{e=0;break}}i=d;return e|0}function $Fc(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,l=0,m=0,n=0,o=0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=+aGc(a,1.0);if(!(f>1.0e-5)){g=0;i=b;return g|0}if((c[292340>>2]|0)==0){g=1;i=b;return g|0}j=e;h[k>>3]=f;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];EBc(9,1,329544,e);e=a+16|0;j=c[e>>2]|0;if((j|0)>0){l=a+48|0;a=j;j=0;while(1){f=+h[(c[l>>2]|0)+(j<<3)>>3];m=j+1|0;if(+U(+f)>1.0e-5){c[d>>2]=m;n=d+4|0;h[k>>3]=f;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];EBc(9,0,329656,d);o=c[e>>2]|0}else{o=a}if((m|0)<(o|0)){a=o;j=m}else{break}}}fe[c[73214]&1023](9);g=1;i=b;return g|0}function aGc(b,d){b=b|0;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0.0,p=0.0,q=0.0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0,x=0,y=0,z=0.0,A=0.0,B=0,C=0.0,D=0,E=0,F=0.0,G=0.0,H=0,I=0.0,J=0,K=0,L=0.0;e=i;f=c[b+60>>2]|0;pGc(b);g=f+540|0;ie[c[(c[g>>2]|0)+84>>2]&127](f)|0;ie[c[(c[g>>2]|0)+36>>2]&127](f)|0;ie[c[(c[g>>2]|0)+32>>2]&127](f)|0;j=b+48|0;xe[c[(c[g>>2]|0)+68>>2]&63](f,c[j>>2]|0)|0;g=f+8|0;k=c[f+184>>2]|0;if((k|0)>0){l=c[b+52>>2]|0;m=(l|0)==0;n=c[j>>2]|0;o=0.0;j=0;while(1){if(m){p=1.0}else{p=+h[l+(j<<3)>>3]}q=+h[n+(j<<3)>>3]/p;r=o+q*q;s=j+1|0;if((s|0)<(k|0)){o=r;j=s}else{t=r;break}}}else{t=0.0}if(!(d<1.0)){u=t;i=e;return+u}o=t*d;j=c[f+116>>2]|0;if((j|0)>0){k=c[g>>2]|0;n=b+56|0;t=1.0-d;l=f+4|0;p=o;m=0;s=0;while(1){if((a[k+(m*112|0)+88|0]|0)==0){v=p;w=s}else{x=c[n>>2]|0;if((x|0)==0){y=s;z=1.0}else{y=s+1|0;z=+h[x+(s<<3)>>3]}r=(+h[k+(m*112|0)+96>>3]- +h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+(m<<3)>>3])/z;v=p+r*t*r;w=y}x=m+1|0;if((x|0)<(j|0)){p=v;m=x;s=w}else{A=v;B=w;break}}}else{A=o;B=0}w=c[f+136>>2]|0;if((w|0)>0){s=c[f+24>>2]|0;m=b+56|0;o=1.0-d;y=f+416|0;v=A;l=0;k=B;while(1){do{if((a[s+(l*112|0)+88|0]|0)==0){C=v;D=k}else{if((a[s+(l*112|0)+72|0]|0)!=0){C=v;D=k;break}n=c[m>>2]|0;if((n|0)==0){E=k;F=1.0}else{E=k+1|0;F=+h[n+(k<<3)>>3]}p=(+h[s+(l*112|0)+96>>3]- +h[(c[y>>2]|0)+(l<<3)>>3])/F;C=v+p*o*p;D=E}}while(0);n=l+1|0;if((n|0)<(w|0)){v=C;l=n;k=D}else{G=C;H=D;break}}}else{G=A;H=B}B=c[f+120>>2]|0;D=j-B|0;if((D|0)>=(B|0)){u=G;i=e;return+u}j=c[g>>2]|0;g=b+56|0;A=1.0-d;b=f+416|0;d=G;f=D;D=H;while(1){do{if((a[j+(f*112|0)+88|0]|0)==0){I=d;J=D}else{if((a[j+(f*112|0)+72|0]|0)!=0){I=d;J=D;break}H=c[g>>2]|0;if((H|0)==0){K=D;L=1.0}else{K=D+1|0;L=+h[H+(D<<3)>>3]}G=(+h[j+(f*112|0)+96>>3]- +h[(c[b>>2]|0)+(f<<3)>>3])/L;I=d+G*A*G;J=K}}while(0);H=f+1|0;if((H|0)<(B|0)){d=I;f=H;D=J}else{u=I;break}}i=e;return+u}function bGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0.0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0,F=0,G=0,H=0,I=0,J=0;d=i;i=i+16|0;e=d;f=i;i=i+24|0;g=i;i=i+8|0;j=i;i=i+16|0;l=i;i=i+24|0;m=i;i=i+16|0;n=i;i=i+24|0;o=i;i=i+16|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+16|0;t=i;i=i+8|0;u=+aGc(b,1.0);if((c[292340>>2]|0)==0){i=d;return}v=b+16|0;w=c[v>>2]|0;if((w|0)>0){x=c[b+48>>2]|0;y=0.0;z=0;while(1){A=+h[x+(z<<3)>>3];B=y+A*A;C=z+1|0;if((C|0)<(w|0)){z=C;y=B}else{D=B;break}}}else{D=0.0}EBc(9,1,329680,t);t=b+52|0;if((c[t>>2]|0)==0){z=r;h[k>>3]=D;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(9,0,329744,r)}else{r=s;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=s+8|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(9,0,329704,s)}EBc(9,1,329768,q);q=b+4|0;s=c[q>>2]|0;if((s|0)>0){r=b+40|0;z=b+24|0;w=b+44|0;x=0;while(1){C=c[r>>2]|0;E=x+1|0;u=+h[(c[z>>2]|0)+(x<<3)>>3];F=c[(c[w>>2]|0)+(x<<2)>>2]|0;if((C|0)==0){c[o>>2]=E;G=o+4|0;h[k>>3]=u;c[G>>2]=c[k>>2];c[G+4>>2]=c[k+4>>2];c[o+12>>2]=F;EBc(9,0,329840,o)}else{D=+h[C+(x<<3)>>3];c[p>>2]=E;C=p+4|0;h[k>>3]=u;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[p+12>>2]=F;F=p+16|0;h[k>>3]=D;c[F>>2]=c[k>>2];c[F+4>>2]=c[k+4>>2];EBc(9,0,329792,p)}F=c[q>>2]|0;if((E|0)<(F|0)){x=E}else{H=F;I=E;break}}}else{H=s;I=0}s=b+8|0;if((I|0)<((c[s>>2]|0)+H|0)){H=b+40|0;x=b+24|0;p=b+44|0;o=I;while(1){w=c[H>>2]|0;z=o+1|0;D=+h[(c[x>>2]|0)+(o<<3)>>3];r=c[(c[p>>2]|0)+(o<<2)>>2]|0;if((w|0)==0){c[m>>2]=z;E=m+4|0;h[k>>3]=D;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];c[m+12>>2]=r;EBc(9,0,329928,m)}else{u=+h[w+(o<<3)>>3];c[n>>2]=z;w=n+4|0;h[k>>3]=D;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[n+12>>2]=r;r=n+16|0;h[k>>3]=u;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(9,0,329864,n)}if((z|0)<((c[s>>2]|0)+(c[q>>2]|0)|0)){o=z}else{J=z;break}}}else{J=I}I=b;if((J|0)<(c[I>>2]|0)){o=b+40|0;q=b+24|0;s=b+44|0;n=J;while(1){J=c[o>>2]|0;m=n+1|0;u=+h[(c[q>>2]|0)+(n<<3)>>3];p=c[(c[s>>2]|0)+(n<<2)>>2]|0;if((J|0)==0){c[j>>2]=m;x=j+4|0;h[k>>3]=u;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];c[j+12>>2]=p;EBc(9,0,330016,j)}else{D=+h[J+(n<<3)>>3];c[l>>2]=m;J=l+4|0;h[k>>3]=u;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];c[l+12>>2]=p;p=l+16|0;h[k>>3]=D;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];EBc(9,0,329960,l)}if((m|0)<(c[I>>2]|0)){n=m}else{break}}}fe[c[73214]&1023](9);EBc(9,1,330048,g);if((c[v>>2]|0)>0){g=b+48|0;b=a+540|0;a=0;while(1){n=(c[t>>2]|0)==0;I=a+1|0;D=+h[(c[g>>2]|0)+(a<<3)>>3];l=ie[c[(c[b>>2]|0)+64>>2]&127](a)|0;if(n){c[e>>2]=I;n=e+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[e+12>>2]=l;EBc(9,0,329840,e)}else{u=+h[(c[t>>2]|0)+(a<<3)>>3];c[f>>2]=I;n=f+4|0;h[k>>3]=D;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];c[f+12>>2]=l;l=f+16|0;h[k>>3]=u;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];EBc(9,0,329792,f)}if((I|0)<(c[v>>2]|0)){a=I}else{break}}}fe[c[73214]&1023](9);fe[c[73214]&1023](9);i=d;return}function cGc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0;d=i;i=i+24|0;e=d;f=i;i=i+8|0;g=i;i=i+24|0;j=i;i=i+8|0;l=i;i=i+24|0;m=i;i=i+8|0;n=i;i=i+40|0;o=i;i=i+8|0;p=i;i=i+24|0;q=i;i=i+8|0;r=i;i=i+40|0;s=i;i=i+8|0;t=i;i=i+8|0;u=b+8|0;if((c[292340>>2]|0)!=0){JEc(b,9)}if((c[292400>>2]|0)==0){i=d;return}EBc(24,1,330072,t);t=b+112|0;v=c[t>>2]|0;do{if((v|0)>0){EBc(24,1,330112,s);if((c[t>>2]|0)>0){w=u;x=b+4|0;y=b+400|0;z=0;while(1){A=z+1|0;B=c[w>>2]|0;C=c[B+(z*112|0)+4>>2]|0;D=+h[B+(z*112|0)+96>>3];E=+h[B+(z*112|0)+80>>3];F=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];G=+h[(c[y>>2]|0)+(z<<3)>>3];c[r>>2]=A;c[r+4>>2]=C;C=r+8|0;h[k>>3]=D;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+16|0;h[k>>3]=E;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+24|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=r+32|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];EBc(24,0,330136,r);if((A|0)<(c[t>>2]|0)){z=A}else{break}}}fe[c[73214]&1023](24);z=c[t>>2]|0;if((z|0)<=0){H=z;break}EBc(24,1,330192,q);z=c[t>>2]|0;if((z|0)<(z<<1|0)){y=u;x=b+4|0;w=b+400|0;A=z;while(1){z=A+1|0;C=c[(c[y>>2]|0)+(A*112|0)+4>>2]|0;G=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];F=+h[(c[w>>2]|0)+(A<<3)>>3];c[p>>2]=z;c[p+4>>2]=C;C=p+8|0;h[k>>3]=G;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];C=p+16|0;h[k>>3]=F;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];EBc(24,0,330216,p);if((z|0)<(c[t>>2]<<1|0)){A=z}else{break}}}fe[c[73214]&1023](24);H=c[t>>2]|0}else{H=v}}while(0);v=b+116|0;if((H<<1|0)<(c[v>>2]|0)){EBc(24,1,330248,o);o=c[t>>2]<<1;if((o|0)<(c[v>>2]|0)){t=u;u=b+4|0;H=b+400|0;p=o;while(1){o=p+1|0;q=c[t>>2]|0;r=c[q+(p*112|0)+4>>2]|0;F=+h[q+(p*112|0)+96>>3];G=+h[q+(p*112|0)+80>>3];E=+h[(c[(c[c[u>>2]>>2]|0)+8>>2]|0)+(p<<3)>>3];D=+h[(c[H>>2]|0)+(p<<3)>>3];c[n>>2]=o;c[n+4>>2]=r;r=n+8|0;h[k>>3]=F;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+16|0;h[k>>3]=G;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+24|0;h[k>>3]=E;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];r=n+32|0;h[k>>3]=D;c[r>>2]=c[k>>2];c[r+4>>2]=c[k+4>>2];EBc(24,0,330136,n);if((o|0)<(c[v>>2]|0)){p=o}else{break}}}fe[c[73214]&1023](24)}p=b+124|0;if((c[p>>2]|0)>0){EBc(24,1,330272,m);if((c[p>>2]|0)>0){m=b+12|0;v=b+4|0;n=b+404|0;H=0;while(1){u=H+1|0;t=c[m>>2]|0;o=c[t+(H*60|0)+4>>2]|0;r=c[t+(H*60|0)+52>>2]|0;t=c[(c[(c[c[v>>2]>>2]|0)+12>>2]|0)+(H<<2)>>2]|0;q=c[(c[n>>2]|0)+(H<<2)>>2]|0;c[l>>2]=u;c[l+4>>2]=o;c[l+8>>2]=r;c[l+12>>2]=t;c[l+16>>2]=q;EBc(24,0,330296,l);if((u|0)<(c[p>>2]|0)){H=u}else{break}}}fe[c[73214]&1023](24)}H=b+128|0;if((c[H>>2]|0)>0){EBc(24,1,330344,j);if((c[H>>2]|0)>0){j=b+16|0;p=b+4|0;l=b+408|0;n=0;while(1){v=n+1|0;m=c[j>>2]|0;u=c[m+(n*48|0)+4>>2]|0;q=(a[m+(n*48|0)+42|0]|0)!=0?330416:330424;m=(a[(c[(c[c[p>>2]>>2]|0)+16>>2]|0)+n|0]|0)!=0?330416:330424;t=(a[(c[l>>2]|0)+n|0]|0)!=0?330416:330424;c[g>>2]=v;c[g+4>>2]=u;c[g+8>>2]=q;c[g+12>>2]=m;c[g+16>>2]=t;EBc(24,0,330368,g);if((v|0)<(c[H>>2]|0)){n=v}else{break}}}fe[c[73214]&1023](24)}n=b+132|0;if((c[n>>2]|0)>0){EBc(24,1,330432,f);if((c[n>>2]|0)>0){f=b+20|0;H=b+4|0;g=b+412|0;b=0;while(1){l=b+1|0;p=c[f>>2]|0;j=c[p+(b*52|0)+4>>2]|0;v=c[p+(b*52|0)+44>>2]|0;p=c[(c[(c[c[H>>2]>>2]|0)+20>>2]|0)+(b<<2)>>2]|0;t=c[(c[g>>2]|0)+(b<<2)>>2]|0;c[e>>2]=l;c[e+4>>2]=j;c[e+8>>2]=v;c[e+12>>2]=p;c[e+16>>2]=t;EBc(24,0,330456,e);if((l|0)<(c[n>>2]|0)){b=l}else{break}}}fe[c[73214]&1023](24)}fe[c[73214]&1023](24);i=d;return}function dGc(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0.0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0;k=i;i=i+8|0;l=k;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=b+540|0;B=(c[(c[A>>2]|0)+72>>2]|0)!=0?3:2;EBc(9,0,330504,z);if((f|0)==0){GEc(b);HEc(b);C=6}else{if((a[f]|0)!=0){eGc(b,f,g)}GEc(b);HEc(b);if((a[f]|0)==0){C=6}}if((C|0)==6){ie[c[(c[A>>2]|0)+84>>2]&127](b)|0;ie[c[(c[A>>2]|0)+60>>2]&127](b)|0}do{if((d|0)==0){D=B}else{if((a[d]|0)==0){D=B;break}C=(H4c(d,331992)|0)==0|0;f=(H4c(d,332e3)|0)==0;z=(H4c(d,332008)|0)==0;E=z?3:f?2:C;if((E|0)!=0){D=E;break}c[y>>2]=d;GBc(1,0,330552,y);GBc(1,0,330584,x);c[w>>2]=331992;c[w+4>>2]=331800;GBc(1,0,330608,w);c[v>>2]=332e3;c[v+4>>2]=331880;GBc(1,0,330608,v);c[u>>2]=332008;c[u+4>>2]=331928;GBc(1,0,330608,u);IBc(c[b+536>>2]|0,330640,t)}}while(0);do{if((e|0)==0){F=3}else{if((a[e]|0)==0){F=3;break}else{G=1;H=0}do{t=(H4c(e,c[330664+(G<<2)>>2]|0)|0)==0;H=t?G:H;G=G+1|0;}while((G|0)<7);if((H|0)!=0){F=H;break}c[s>>2]=e;GBc(1,0,330696,s);GBc(1,0,330584,r);t=1;do{u=c[330728+(t<<2)>>2]|0;c[q>>2]=c[330664+(t<<2)>>2];c[q+4>>2]=u;GBc(1,0,330608,q);t=t+1|0;}while((t|0)<7);IBc(c[b+536>>2]|0,330640,p)}}while(0);p=c[330624+(D<<2)>>2]|0;c[o>>2]=c[330536+(D<<2)>>2];c[o+4>>2]=p;EBc(9,0,330760,o);o=(D|0)==2;if(o){p=c[330728+(F<<2)>>2]|0;c[n>>2]=c[330664+(F<<2)>>2];c[n+4>>2]=p;EBc(9,0,330800,n)}n=b+312|0;a[n]=1;p=b+200|0;if((c[p>>2]|0)>0){q=b+468|0;r=0;do{a[(c[q>>2]|0)+(r*80|0)+72|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}p=b+196|0;if((c[p>>2]|0)>0){r=b+476|0;q=0;do{a[(c[r>>2]|0)+(q<<6)+56|0]=1;q=q+1|0;}while((q|0)<(c[p>>2]|0))}p=b+192|0;if((c[p>>2]|0)>0){q=b+484|0;r=0;do{a[(c[q>>2]|0)+(r*40|0)+36|0]=1;r=r+1|0;}while((r|0)<(c[p>>2]|0))}do{if((D|0)==1){I=0}else{if(o){I=fGc(b,F,j)|0;break}if((D|0)==3){gGc(b,j);I=0;break}else{IBc(c[b+536>>2]|0,330840,m)}}}while(0);if((rFc(b,1)|0)!=0){J=-2;cGc(b);K=15;L=K;M=330864;N=M;EBc(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];pEc(b,R,V);W=750;DEc(b);X=756;IEc(b);Y=751;yEc(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=759;EEc(b);i=k;return J|0}if((hFc(b,1)|0)!=0){J=-3;cGc(b);K=15;L=K;M=330864;N=M;EBc(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];pEc(b,R,V);W=750;DEc(b);X=756;IEc(b);Y=751;yEc(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=759;EEc(b);i=k;return J|0}m=(YEc(b,1)|0)==0;J=m?I:-4;cGc(b);K=15;L=K;M=330864;N=M;EBc(9,0,N,l);a[n]=0;O=b;P=O+240|0;Q=P;R=+h[Q>>3];S=b;T=S+248|0;U=T;V=+h[U>>3];pEc(b,R,V);W=750;DEc(b);X=756;IEc(b);Y=751;yEc(b);Z=c[A>>2]|0;_=Z;$=_+52|0;aa=$;ba=c[aa>>2]|0;ca=ie[ba&127](b)|0;da=c[A>>2]|0;ea=da;fa=ea+96|0;ga=fa;ha=c[ga>>2]|0;ia=xe[ha&63](b,1)|0;ja=759;EEc(b);i=k;return J|0}function eGc(b,d,e){b=b|0;d=d|0;e=+e;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0,K=0,L=0,M=0,N=0,O=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+16|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+16|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+16|0;A=i;i=i+48|0;B=i;i=i+8|0;c[z>>2]=d;C=z+4|0;h[k>>3]=e;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];EBc(9,0,332024,z);z=lCc(d,A)|0;if((z|0)!=0){C=c[b+536>>2]|0;c[y>>2]=d;c[y+4>>2]=z;IBc(C,332064,y)}EBc(9,0,332104,x);x=b+116|0;if((c[x>>2]|0)>0){y=b+8|0;C=0;do{z=mCc(A,c[(c[y>>2]|0)+(C*112|0)+4>>2]|0)|0;d=c[y>>2]|0;do{if((z|0)==0){D=jGc(c[d+(C*112|0)+4>>2]|0)|0;E=mCc(A,D)|0;i4c(D);D=c[y>>2]|0;if((E|0)!=0){F=D;G=E;H=7;break}E=c[D+(C*112|0)+4>>2]|0;if((I4c(E,332144,6)|0)==0){if((c[292340>>2]|0)==0){break}}else{D=I4c(E,332152,6)|0;if((c[292340>>2]|D|0)==0){break}}c[v>>2]=E;GBc(9,0,332160,v)}else{F=d;G=z;H=7}}while(0);if((H|0)==7){H=0;sCc(F+(C*112|0)+96|0,A,G,e)|0;z=c[y>>2]|0;I=+h[z+(C*112|0)+96>>3];c[w>>2]=c[z+(C*112|0)+4>>2];z=w+4|0;h[k>>3]=I;c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];EBc(9,0,332128,w)}C=C+1|0;}while((C|0)<(c[x>>2]|0))}EBc(9,0,332216,u);u=b+136|0;if((c[u>>2]|0)>0){C=b+24|0;w=0;do{y=mCc(A,c[(c[C>>2]|0)+(w*112|0)+4>>2]|0)|0;G=c[C>>2]|0;do{if((y|0)==0){F=jGc(c[G+(w*112|0)+4>>2]|0)|0;v=mCc(A,F)|0;i4c(F);F=c[C>>2]|0;if((v|0)!=0){J=F;K=v;H=17;break}c[s>>2]=c[F+(w*112|0)+4>>2];GBc(9,0,332240,s)}else{J=G;K=y;H=17}}while(0);if((H|0)==17){H=0;sCc(J+(w*112|0)+96|0,A,K,e)|0;y=c[C>>2]|0;I=+h[y+(w*112|0)+96>>3];c[t>>2]=c[y+(w*112|0)+4>>2];y=t+4|0;h[k>>3]=I;c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];EBc(9,0,332128,t)}w=w+1|0;}while((w|0)<(c[u>>2]|0))}EBc(9,0,332296,r);r=b+120|0;u=c[r>>2]|0;w=(c[x>>2]|0)-u|0;if((w|0)<(u|0)){u=b+24|0;x=w;do{w=mCc(A,c[(c[u>>2]|0)+(x*112|0)+4>>2]|0)|0;t=c[u>>2]|0;do{if((w|0)==0){C=jGc(c[t+(x*112|0)+4>>2]|0)|0;K=mCc(A,C)|0;i4c(C);C=c[u>>2]|0;if((K|0)!=0){L=C;M=K;H=24;break}c[p>>2]=c[C+(x*112|0)+4>>2];GBc(9,0,332240,p)}else{L=t;M=w;H=24}}while(0);if((H|0)==24){H=0;sCc(L+(x*112|0)+96|0,A,M,e)|0;w=c[u>>2]|0;I=+h[w+(x*112|0)+96>>3];c[q>>2]=c[w+(x*112|0)+4>>2];w=q+4|0;h[k>>3]=I;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];EBc(9,0,332128,q)}x=x+1|0;}while((x|0)<(c[r>>2]|0))}EBc(9,0,332320,o);o=b+140|0;if((c[o>>2]|0)>0){r=b+28|0;x=0;do{q=mCc(A,c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;do{if((q|0)==0){u=jGc(c[(c[r>>2]|0)+(x*60|0)+4>>2]|0)|0;M=mCc(A,u)|0;i4c(u);if((M|0)!=0){N=M;H=31;break}c[m>>2]=c[(c[r>>2]|0)+(x*60|0)+4>>2];GBc(9,0,332368,m)}else{N=q;H=31}}while(0);if((H|0)==31){H=0;sCc(B,A,N,e)|0;q=~~+h[B>>3];M=c[r>>2]|0;c[M+(x*60|0)+52>>2]=q;c[n>>2]=c[M+(x*60|0)+4>>2];c[n+4>>2]=q;EBc(9,0,332352,n)}x=x+1|0;}while((x|0)<(c[o>>2]|0))}EBc(9,0,332424,l);l=b+144|0;if((c[l>>2]|0)<=0){jCc(A);i=f;return}o=b+32|0;b=0;do{x=mCc(A,c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;do{if((x|0)==0){n=jGc(c[(c[o>>2]|0)+(b*48|0)+4>>2]|0)|0;r=mCc(A,n)|0;i4c(n);if((r|0)!=0){O=r;H=38;break}c[g>>2]=c[(c[o>>2]|0)+(b*48|0)+4>>2];GBc(9,0,332472,g)}else{O=x;H=38}}while(0);if((H|0)==38){H=0;sCc(B,A,O,e)|0;a[(c[o>>2]|0)+(b*48|0)+42|0]=~~+h[B>>3];x=c[o>>2]|0;r=(a[x+(b*48|0)+42|0]|0)!=0?330416:330424;c[j>>2]=c[x+(b*48|0)+4>>2];c[j+4>>2]=r;EBc(9,0,332456,j)}b=b+1|0;}while((b|0)<(c[l>>2]|0));jCc(A);i=f;return}function fGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;oEc(a,+h[a+240>>3]);DEc(a);IEc(a);yEc(a);KEc(a);SFc(a);zEc(a);DEc(a);e=hGc(a,b,c)|0;IEc(a);yEc(a);EEc(a);IEc(a);i=d;return e|0}function gGc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,J=0.0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+4096|0;oEc(b,+h[b+240>>3]);DEc(b);IEc(b);UFc(b,0,1)|0;v=b+540|0;w=c[v>>2]|0;if((c[w+76>>2]|0)!=0&(d|0)>1){x=u;u=b+8|0;y=b+116|0;z=j4c(c[y>>2]|0,8)|0;A=b+124|0;B=j4c(c[A>>2]|0,4)|0;C=b+128|0;D=j4c(c[C>>2]|0,1)|0;E=b+132|0;F=j4c(c[E>>2]|0,4)|0;G=b+536|0;HBc(c[G>>2]|0,(z|0)!=0|0,330896,t);HBc(c[G>>2]|0,(B|0)!=0|0,330896,s);HBc(c[G>>2]|0,(D|0)!=0|0,330896,r);HBc(c[G>>2]|0,(F|0)!=0|0,330896,q);q=c[y>>2]|0;if((q|0)>0){G=c[u>>2]|0;r=0;do{h[z+(r<<3)>>3]=+h[G+(r*112|0)+96>>3];r=r+1|0;}while((r|0)<(q|0))}q=c[A>>2]|0;if((q|0)>0){r=c[b+12>>2]|0;G=0;do{c[B+(G<<2)>>2]=c[r+(G*60|0)+52>>2];G=G+1|0;}while((G|0)<(q|0))}q=c[C>>2]|0;if((q|0)>0){G=c[b+16>>2]|0;r=0;do{a[D+r|0]=a[G+(r*48|0)+42|0]|0;r=r+1|0;}while((r|0)<(q|0))}q=c[E>>2]|0;if((q|0)>0){r=c[b+20>>2]|0;G=0;do{c[F+(G<<2)>>2]=c[r+(G*52|0)+44>>2];G=G+1|0;}while((G|0)<(q|0))}if((c[292340>>2]|0)==0){H=0}else{c[p>>2]=c[b+88>>2];hc(x|0,330912,p|0)|0;p=ic(x|0,330928)|0;c[o>>2]=330944;wd(p|0,330936,o|0)|0;if((c[y>>2]|0)>0){o=u;x=0;do{c[n>>2]=c[(c[o>>2]|0)+(x*112|0)+4>>2];wd(p|0,330936,n|0)|0;x=x+1|0;}while((x|0)<(c[y>>2]|0))}Sd(10,p|0)|0;H=p}EBc(9,1,330952,m);a:do{if((d|0)>0){I=+(d+ -1|0);m=b+304|0;p=b+4|0;x=0;do{J=+(x|0)/I;h[m>>3]=J>1.0?1.0:J;ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;n=l;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];EBc(9,0,330976,l);if((c[292340>>2]|0)!=0){n=j;h[k>>3]=+h[m>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(H|0,331e3,j|0)|0;if((c[y>>2]|0)>0){n=0;do{o=g;h[k>>3]=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+(n<<3)>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];wd(H|0,331e3,g|0)|0;n=n+1|0;}while((n|0)<(c[y>>2]|0))}Sd(10,H|0)|0}if((rFc(b,0)|0)!=0){break a}if((hFc(b,0)|0)!=0){break a}if((YEc(b,0)|0)!=0){break a}LEc(b);x=x+1|0;}while((x|0)<(d|0))}}while(0);fe[c[73214]&1023](9);if((c[292340>>2]|0)!=0){Yc(H|0)|0}H=c[y>>2]|0;if((H|0)>0){y=c[u>>2]|0;u=0;do{h[y+(u*112|0)+96>>3]=+h[z+(u<<3)>>3];u=u+1|0;}while((u|0)<(H|0))}if((c[A>>2]|0)>0){H=c[b+12>>2]|0;u=0;do{c[H+(u*60|0)+52>>2]=c[B+(u<<2)>>2];u=u+1|0;}while((u|0)<(c[A>>2]|0))}if((c[C>>2]|0)>0){A=b+16|0;u=0;do{a[(c[A>>2]|0)+(u*48|0)+42|0]=a[D+u|0]|0;u=u+1|0;}while((u|0)<(c[C>>2]|0))}C=c[E>>2]|0;if((C|0)>0){E=b+20|0;u=0;do{c[(c[E>>2]|0)+(u*52|0)+44>>2]=c[F+(u<<2)>>2];u=u+1|0;}while((u|0)<(C|0))}i4c(z);i4c(B);i4c(D);i4c(F)}else{h[b+304>>3]=1.0;ie[c[w+80>>2]&127](b)|0}AEc(b);if((UFc(b,1,1)|0)!=1){i=e;return}ie[c[(c[v>>2]|0)+80>>2]&127](b)|0;AEc(b);if((UFc(b,1,1)|0)!=1){i=e;return}GBc(1,0,331008,f);i=e;return}function hGc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=kGc(b)|0;w=v;x=c[w>>2]|0;if((x|0)==0){EBc(9,0,331112,u);if((c[b+184>>2]|0)==0){xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0}i4c(v);y=0;i=f;return y|0}u=b+184|0;z=c[u>>2]|0;if((z|0)==0){EBc(9,0,331144,t);xe[c[(c[b+540>>2]|0)+68>>2]&63](b,c[v+48>>2]|0)|0;i4c(v);y=0;i=f;return y|0}do{if((c[v+16>>2]|0)<(x|0)){EBc(9,1,331216,s);t=h4c(c[w>>2]<<3)|0;A=v+40|0;B=c[A>>2]|0;c[A>>2]=0;C=+aGc(v,1.0);c[A>>2]=B;D=c[w>>2]|0;if((D|0)>0){E=v+24|0;F=c[E>>2]|0;G=0;while(1){H=F+(G<<3)|0;h[H>>3]=+h[H>>3]+1.0e-6;c[A>>2]=0;h[t+(G<<3)>>3]=+U(+(+aGc(v,1.0)-C))/1.0e-6;c[A>>2]=B;H=c[E>>2]|0;I=H+(G<<3)|0;h[I>>3]=+h[I>>3]+-1.0e-6;I=G+1|0;J=c[w>>2]|0;if((I|0)<(J|0)){G=I;F=H}else{K=J;break}}}else{K=D}F=c[u>>2]|0;if((F|0)>0){G=(K|0)>1;E=0;do{if(G){B=1;A=0;while(1){J=+h[t+(B<<3)>>3]>+h[t+(A<<3)>>3]?B:A;H=B+1|0;if((H|0)<(K|0)){A=J;B=H}else{L=J;break}}}else{L=0}h[t+(L<<3)>>3]=-1.0;E=E+1|0;}while((E|0)<(F|0))}EBc(9,1,331240,r);F=b+112|0;E=c[F>>2]|0;if((E|0)>0){G=b+8|0;D=v+44|0;B=v+24|0;A=E;E=0;J=0;while(1){H=(c[G>>2]|0)+(E*112|0)+72|0;if((a[H]|0)==0){if(!(+h[t+(J<<3)>>3]>=0.0)){M=A}else{a[H]=1;C=+h[(c[B>>2]|0)+(J<<3)>>3];c[q>>2]=c[(c[D>>2]|0)+(J<<2)>>2];H=q+4|0;h[k>>3]=C;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];EBc(9,0,331264,q);M=c[F>>2]|0}N=M;O=J+1|0}else{N=A;O=J}H=E+1|0;if((H|0)<(N|0)){A=N;E=H;J=O}else{P=O;break}}}else{P=0}J=b+136|0;if((c[J>>2]|0)>0){E=b+24|0;A=v+44|0;F=v+24|0;D=b+116|0;B=b+120|0;G=0;H=P;while(1){I=(c[E>>2]|0)+(G*112|0)+72|0;if((a[I]|0)==0){if(+h[t+(H<<3)>>3]>=0.0){a[I]=1;C=+h[(c[F>>2]|0)+(H<<3)>>3];c[p>>2]=c[(c[A>>2]|0)+(H<<2)>>2];I=p+4|0;h[k>>3]=C;c[I>>2]=c[k>>2];c[I+4>>2]=c[k+4>>2];EBc(9,0,331264,p)}Q=H+1|0}else{Q=H}I=c[B>>2]|0;R=(c[D>>2]|0)-I|0;if((R|0)<(I|0)){S=I;I=R;T=Q;while(1){V=(c[E>>2]|0)+(I*112|0)+72|0;if((a[V]|0)==0){if(!(+h[t+(T<<3)>>3]>=0.0)){W=S}else{a[V]=1;C=+h[(c[F>>2]|0)+(T<<3)>>3];c[o>>2]=c[(c[A>>2]|0)+(T<<2)>>2];V=o+4|0;h[k>>3]=C;c[V>>2]=c[k>>2];c[V+4>>2]=c[k+4>>2];EBc(9,0,331264,o);W=c[B>>2]|0}X=W;Y=T+1|0}else{X=S;Y=T}V=I+1|0;if((V|0)<(X|0)){S=X;I=V;T=Y}else{Z=V;_=Y;break}}}else{Z=R;_=Q}T=Z+1|0;if((T|0)<(c[J>>2]|0)){G=T;H=_}else{break}}}if((c[292340>>2]|0)!=0){fe[c[73214]&1023](9);fe[c[73214]&1023](9)}i4c(t);lGc(v);H=kGc(b)|0;if((c[H>>2]|0)!=0){$=H;break}EBc(9,0,331288,n);i4c(H);y=0;i=f;return y|0}else{if((z|0)<=(x|0)){$=v;break}EBc(9,0,331320,m);$=v}}while(0);do{if((d|0)==3|(d|0)==5){EBc(9,0,331336,l);iGc($,d,1,e);bGc(b,$);v=c[$>>2]|0;if((v|0)<=0){break}m=c[$+24>>2]|0;x=c[$+28>>2]|0;z=0;do{h[x+(z<<3)>>3]=+h[m+(z<<3)>>3];z=z+1|0;}while((z|0)<(v|0))}}while(0);if(+aGc($,1.0)>1.0e-9){l=$+40|0;v=c[l>>2]|0;if((v|0)!=0){i4c(v);c[l>>2]=0}l=$+52|0;v=c[l>>2]|0;if((v|0)!=0){i4c(v);c[l>>2]=0}l=$+56|0;v=c[l>>2]|0;if((v|0)!=0){i4c(v);c[l>>2]=0}iGc($,d,0,e);bGc(b,$);+aGc($,1.0)}else{EBc(9,0,331360,j)}EBc(9,1,331384,g);bGc(b,$);b=$Fc($)|0;if((c[292340>>2]|0)!=0){fe[c[73214]&1023](9)}lGc($);y=b;i=f;return y|0}function iGc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=c[a+60>>2]|0;h[n>>3]=0.0;p=a;q=h4c(c[p>>2]<<3)|0;r=q;s=+aGc(a,1.0);t=c[p>>2]|0;if((t|0)>0){u=c[a+28>>2]|0;v=c[a+24>>2]|0;w=0;do{x=+h[u+(w<<3)>>3];h[v+(w<<3)>>3]=x;h[q+(w<<3)>>3]=x;w=w+1|0;}while((w|0)<(t|0))}if(!(s>1.0e-12)){y=1;nGc(a,r);i4c(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=331512;F=E;EBc(9,0,F,g);i=f;return}t=(d|0)==0;d=a+24|0;x=s;w=1;a:while(1){c[m>>2]=w;EBc(9,0,331424,m);if(!t){mGc(a)}switch(b|0){case 6:{G=14;break a;break};case 5:{G=13;break a;break};case 4:{G=12;break a;break};case 1:{H=uGc(a)|0;break};case 2:{H=sGc(a)|0;break};case 3:{H=wGc(a,n,e)|0;break};default:{G=15;break a}}IEc(o);yEc(o);EEc(o);IEc(o);s=+aGc(a,1.0);v=(H|0)>-1;if(v&s<x){u=c[p>>2]|0;if((u|0)>0){I=c[d>>2]|0;J=0;do{h[q+(J<<3)>>3]=+h[I+(J<<3)>>3];J=J+1|0;}while((J|0)<(u|0))}EBc(9,0,331472,k);bGc(o,a);K=s}else{EBc(9,0,331488,j);if(v&s==x){y=w;G=23;break}else{K=x}}u=w+1|0;if((u|0)<201&s>1.0e-12){x=K;w=u}else{y=u;G=23;break}}if((G|0)==12){rGc(a)|0}else if((G|0)==13){rGc(a)|0}else if((G|0)==14){qGc(o,a,0)|0}else if((G|0)==15){IBc(c[o+536>>2]|0,331448,l)}else if((G|0)==23){nGc(a,r);i4c(q);z=y+ -1|0;A=g;B=A;c[B>>2]=z;C=15;D=C;E=331512;F=E;EBc(9,0,F,g);i=f;return}}function jGc(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;c=i;d=L4c(b|0)|0;do{if((d|0)==0){e=h4c(1)|0;f=0}else{g=0;h=0;j=d;while(1){k=a[b+g|0]|0;if(k<<24>>24==93){l=h+ -1|0}else if(k<<24>>24==91){l=h+1|0}else{l=h}if((l|0)!=0&k<<24>>24==44){m=((a[b+(g+1)|0]|0)!=32)+j|0}else{m=j}k=g+1|0;if(k>>>0<d>>>0){g=k;h=l;j=m}else{break}}j=h4c(m+1|0)|0;if((m|0)==0){e=j;f=0;break}else{n=0;o=0;p=l}while(1){h=a[b+o|0]|0;if(h<<24>>24==93){q=p+ -1|0}else if(h<<24>>24==91){q=p+1|0}else{q=p}a[j+n|0]=h;do{if((q|0)!=0&h<<24>>24==44){if((a[b+(o+1)|0]|0)==32){r=n;break}g=n+1|0;a[j+g|0]=32;r=g}else{r=n}}while(0);h=r+1|0;if(h>>>0<m>>>0){n=h;o=o+1|0;p=q}else{e=j;f=m;break}}}}while(0);a[e+f|0]=0;if((G4c(e,332528,4)|0)!=0){i=c;return e|0}m=f>>>0>3;q=e+4|0;while(1){a:do{if(m){p=f;while(1){o=p+ -1|0;if((a[e+p|0]|0)==46){s=p;break a}if(o>>>0>3){p=o}else{s=o;break}}}else{s=f}}while(0);if((s|0)==3){t=24;break}p=s+ -3|0;N4c(e|0,q|0,p|0)|0;o=e+p|0;a[o]=678585700;a[o+1|0]=2650725;a[o+2|0]=10354;a[o+3|0]=40;if((G4c(e,332528,4)|0)!=0){t=24;break}}if((t|0)==24){i=c;return e|0}return 0}function kGc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+32|0;n=i;i=i+32|0;o=i;i=i+32|0;p=i;i=i+16|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=h4c(64)|0;z=y;HBc(0,(y|0)!=0|0,332536,x);x=y+4|0;A=y+8|0;B=y+12|0;C=y+16|0;D=y+20|0;E=y+24|0;F=y+28|0;G=y+32|0;H=y+36|0;I=y+40|0;J=y+44|0;K=y+48|0;L=y+52|0;M=y+56|0;N=y+60|0;O=y+0|0;P=O+60|0;do{c[O>>2]=0;O=O+4|0}while((O|0)<(P|0));c[N>>2]=b;N=b+8|0;O=b+112|0;P=c[O>>2]|0;if((P|0)>0){Q=c[N>>2]|0;R=0;S=0;while(1){if((a[Q+(S*112|0)+72|0]|0)==0){T=R+1|0;c[x>>2]=T;V=T}else{V=R}T=S+1|0;if((T|0)<(P|0)){R=V;S=T}else{W=V;break}}}else{W=0}V=b+136|0;S=c[V>>2]|0;if((S|0)>0){R=c[b+24>>2]|0;P=0;x=0;while(1){if((a[R+(x*112|0)+72|0]|0)==0){Q=P+1|0;c[A>>2]=Q;X=Q}else{X=P}Q=x+1|0;if((Q|0)<(S|0)){P=X;x=Q}else{Y=X;break}}}else{Y=0}X=b+116|0;x=b+120|0;P=c[x>>2]|0;if((P|0)>0){S=c[X>>2]|0;A=c[N>>2]|0;R=0;Q=S-P|0;while(1){if((a[A+(Q*112|0)+72|0]|0)==0){P=R+1|0;c[B>>2]=P;Z=P}else{Z=R}P=Q+1|0;if((P|0)<(S|0)){R=Z;Q=P}else{_=Z;break}}}else{_=0}Z=Y+W+_|0;c[y>>2]=Z;if((Z|0)==0){i=d;return z|0}y=j4c(Z,8)|0;c[E>>2]=y;HBc(0,(y|0)!=0|0,332536,w);w=j4c(Z,8)|0;c[F>>2]=w;HBc(0,(w|0)!=0|0,332536,v);v=j4c(Z,8)|0;c[G>>2]=v;HBc(0,(v|0)!=0|0,332536,u);u=j4c(Z,8)|0;c[H>>2]=u;HBc(0,(u|0)!=0|0,332536,t);t=j4c(Z,8)|0;c[I>>2]=t;HBc(0,(t|0)!=0|0,332536,s);s=j4c(Z,4)|0;t=s;c[J>>2]=t;HBc(0,(s|0)!=0|0,332536,r);EBc(9,0,332552,q);c[p>>2]=Z;c[p+4>>2]=W;c[p+8>>2]=Y;c[p+12>>2]=_;EBc(9,0,332576,p);p=c[O>>2]|0;if((p|0)>0){_=N;Y=p;p=t;W=0;Z=0;while(1){q=c[_>>2]|0;if((a[q+(W*112|0)+72|0]|0)==0){c[p+(Z<<2)>>2]=c[q+(W*112|0)+4>>2];q=c[_>>2]|0;do{if((a[q+(W*112|0)+73|0]|0)==0){$=(c[I>>2]|0)+(Z<<3)|0;aa=1.0}else{ba=+h[q+(W*112|0)+80>>3];ca=+U(+ba);r=(c[I>>2]|0)+(Z<<3)|0;if(!(ba==0.0)){$=r;aa=ca;break}$=r;aa=1.0}}while(0);h[$>>3]=aa;r=q+(W*112|0)+96|0;s=(c[E>>2]|0)+(Z<<3)|0;h[s>>3]=+h[r>>3];u=(c[F>>2]|0)+(Z<<3)|0;h[u>>3]=+h[r>>3];h[(c[G>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+56>>3];h[(c[H>>2]|0)+(Z<<3)>>3]=+h[q+(W*112|0)+64>>3];r=Z+1|0;v=c[J>>2]|0;w=c[v+(Z<<2)>>2]|0;ca=+h[u>>3];ba=+h[$>>3];da=+h[s>>3];c[o>>2]=r;c[o+4>>2]=w;w=o+8|0;h[k>>3]=ca;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+16|0;h[k>>3]=ba;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=o+24|0;h[k>>3]=da;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];EBc(9,0,332664,o);ea=c[O>>2]|0;fa=v;ga=r}else{ea=Y;fa=p;ga=Z}r=W+1|0;if((r|0)<(ea|0)){Y=ea;p=fa;W=r;Z=ga}else{ha=fa;ia=ga;break}}}else{ha=t;ia=0}t=c[V>>2]|0;if((t|0)>0){ga=b+24|0;fa=t;t=ha;Z=0;W=ia;while(1){p=c[ga>>2]|0;if((a[p+(Z*112|0)+72|0]|0)==0){c[t+(W<<2)>>2]=c[p+(Z*112|0)+4>>2];p=c[ga>>2]|0;aa=+h[p+(Z*112|0)+80>>3];da=+U(+aa);ea=(c[I>>2]|0)+(W<<3)|0;h[ea>>3]=aa==0.0?1.0:da;Y=p+(Z*112|0)+96|0;O=(c[E>>2]|0)+(W<<3)|0;h[O>>3]=+h[Y>>3];o=(c[F>>2]|0)+(W<<3)|0;h[o>>3]=+h[Y>>3];h[(c[G>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+56>>3];h[(c[H>>2]|0)+(W<<3)>>3]=+h[p+(Z*112|0)+64>>3];p=W+1|0;Y=c[J>>2]|0;$=c[Y+(W<<2)>>2]|0;da=+h[o>>3];aa=+h[ea>>3];ba=+h[O>>3];c[n>>2]=p;c[n+4>>2]=$;$=n+8|0;h[k>>3]=da;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+16|0;h[k>>3]=aa;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];$=n+24|0;h[k>>3]=ba;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];EBc(9,0,332712,n);ja=c[V>>2]|0;ka=Y;la=p}else{ja=fa;ka=t;la=W}p=Z+1|0;if((p|0)<(ja|0)){fa=ja;t=ka;Z=p;W=la}else{ma=ka;na=la;break}}}else{ma=ha;na=ia}ia=c[x>>2]|0;if((ia|0)>0){ha=c[X>>2]|0;la=N;ka=ha;W=ma;ma=ha-ia|0;ia=na;while(1){na=c[la>>2]|0;if((a[na+(ma*112|0)+72|0]|0)==0){c[W+(ia<<2)>>2]=c[na+(ma*112|0)+4>>2];na=c[la>>2]|0;do{if((a[na+(ma*112|0)+73|0]|0)==0){oa=(c[I>>2]|0)+(ia<<3)|0;pa=1.0}else{ba=+h[na+(ma*112|0)+80>>3];aa=+U(+ba);ha=(c[I>>2]|0)+(ia<<3)|0;if(!(ba==0.0)){oa=ha;pa=aa;break}oa=ha;pa=1.0}}while(0);h[oa>>3]=pa;q=na+(ma*112|0)+96|0;ha=(c[E>>2]|0)+(ia<<3)|0;h[ha>>3]=+h[q>>3];Z=(c[F>>2]|0)+(ia<<3)|0;h[Z>>3]=+h[q>>3];h[(c[G>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+56>>3];h[(c[H>>2]|0)+(ia<<3)>>3]=+h[na+(ma*112|0)+64>>3];q=ia+1|0;t=c[J>>2]|0;ja=c[t+(ia<<2)>>2]|0;aa=+h[Z>>3];ba=+h[oa>>3];da=+h[ha>>3];c[m>>2]=q;c[m+4>>2]=ja;ja=m+8|0;h[k>>3]=aa;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+16|0;h[k>>3]=ba;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];ja=m+24|0;h[k>>3]=da;c[ja>>2]=c[k>>2];c[ja+4>>2]=c[k+4>>2];EBc(9,0,332768,m);qa=c[X>>2]|0;ra=t;sa=q}else{qa=ka;ra=W;sa=ia}q=ma+1|0;if((q|0)<(qa|0)){ka=qa;W=ra;ma=q;ia=sa}else{break}}}sa=c[b+184>>2]|0;c[C>>2]=sa;c[D>>2]=0;C=c[X>>2]|0;if((C|0)>0){X=c[N>>2]|0;ia=0;ma=0;while(1){if((a[X+(ma*112|0)+88|0]|0)==0){ta=ia}else{ra=ia+1|0;c[D>>2]=ra;ta=ra}ra=ma+1|0;if((ra|0)<(C|0)){ia=ta;ma=ra}else{ua=ta;break}}}else{ua=0}ta=c[V>>2]|0;if((ta|0)>0){V=c[b+24>>2]|0;ma=ua;ia=0;while(1){do{if((a[V+(ia*112|0)+88|0]|0)==0){va=ma}else{if((a[V+(ia*112|0)+72|0]|0)!=0){va=ma;break}X=ma+1|0;c[D>>2]=X;va=X}}while(0);na=ia+1|0;if((na|0)<(ta|0)){ma=va;ia=na}else{wa=va;break}}}else{wa=ua}ua=c[x>>2]|0;if((ua|0)>0){x=c[N>>2]|0;N=wa;va=C-ua|0;while(1){do{if((a[x+(va*112|0)+88|0]|0)==0){xa=N}else{if((a[x+(va*112|0)+72|0]|0)!=0){xa=N;break}ua=N+1|0;c[D>>2]=ua;xa=ua}}while(0);ua=va+1|0;if((ua|0)<(C|0)){N=xa;va=ua}else{ya=xa;break}}}else{ya=wa}wa=c[b+176>>2]|0;xa=c[b+180>>2]|0;c[l>>2]=sa;c[l+4>>2]=wa;c[l+8>>2]=xa;EBc(9,0,332824,l);c[j>>2]=ya;EBc(9,0,332896,j);j=j4c(sa,8)|0;c[K>>2]=j;HBc(0,(j|0)!=0|0,332536,g);g=h4c(sa<<3)|0;c[L>>2]=g;HBc(0,(g|0)!=0|0,332536,f);f=h4c(ya<<3)|0;c[M>>2]=f;HBc(0,(f|0)!=0|0,332536,e);if((sa|0)>0){e=0;do{h[g+(e<<3)>>3]=1.0;e=e+1|0;}while((e|0)<(sa|0))}if((ya|0)>0){za=0}else{i=d;return z|0}do{h[f+(za<<3)>>3]=1.0;za=za+1|0;}while((za|0)<(ya|0));i=d;return z|0}function lGc(a){a=a|0;var b=0,d=0,e=0;b=i;d=c[a+24>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+28>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+32>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+36>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+40>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+44>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+48>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+52>>2]|0;if((d|0)!=0){i4c(d)}d=c[a+56>>2]|0;if((d|0)==0){e=a;i4c(e);i=b;return}i4c(d);e=a;i4c(e);i=b;return}



function Flc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190152]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39728>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(190160,cCc(+h[(c[g>>2]|0)+39728>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[190152]=1;i=d;return}function Glc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190296]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(190304,cCc(+h[(c[g>>2]|0)+39720>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[190296]=1;i=d;return}function Hlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190440]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+188>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+188>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(190448,eCc(c[(c[g>>2]|0)+188>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[190440]=1;i=d;return}function Ilc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190656]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+184>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+184>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(190664,eCc(c[(c[g>>2]|0)+184>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[190656]=1;i=d;return}function Jlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[190872]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+180>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+180>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(190880,eCc(c[(c[g>>2]|0)+180>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[190872]=1;i=d;return}function Klc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191088]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+176>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+176>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(191096,eCc(c[(c[g>>2]|0)+176>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[191088]=1;i=d;return}function Llc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191280]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+172>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+172>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(191288,eCc(c[(c[g>>2]|0)+172>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[191280]=1;i=d;return}function Mlc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+168>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+168>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(191480,eCc(c[(c[g>>2]|0)+168>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[191472]=1;i=d;return}function Nlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191664]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39712>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(191672,cCc(+h[(c[g>>2]|0)+39712>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[191664]=1;i=d;return}function Olc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191808]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39704>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(191816,cCc(+h[(c[g>>2]|0)+39704>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[191808]=1;i=d;return}function Plc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[191952]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39696>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(191960,cCc(+h[(c[g>>2]|0)+39696>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[191952]=1;i=d;return}function Qlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192096]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39688>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192104,cCc(+h[(c[g>>2]|0)+39688>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192096]=1;i=d;return}function Rlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192216]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39680>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192224,cCc(+h[(c[g>>2]|0)+39680>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192216]=1;i=d;return}function Slc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192336]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39672>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192344,cCc(+h[(c[g>>2]|0)+39672>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192336]=1;i=d;return}function Tlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192456]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39664>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192464,cCc(+h[(c[g>>2]|0)+39664>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192456]=1;i=d;return}function Ulc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192576,cCc(+h[(c[g>>2]|0)+39656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192568]=1;i=d;return}function Vlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192672]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192680,cCc(+h[(c[g>>2]|0)+39648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192672]=1;i=d;return}function Wlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192832,cCc(+h[(c[g>>2]|0)+39640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192824]=1;i=d;return}function Xlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[192968]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39616>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(192976,cCc(+h[(c[g>>2]|0)+39616>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[192968]=1;i=d;return}function Ylc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39608>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(193080,cCc(+h[(c[g>>2]|0)+39608>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[193072]=1;i=d;return}function Zlc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193184]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(193192,cCc(+h[(c[g>>2]|0)+39600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[193184]=1;i=d;return}function _lc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193288]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(193296,cCc(+h[(c[g>>2]|0)+39592>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[193288]=1;i=d;return}function $lc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39584>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(193408,cCc(+h[(c[g>>2]|0)+39584>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[193400]=1;i=d;return}function amc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193528]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+164>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+164>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(193536,eCc(c[(c[g>>2]|0)+164>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[193528]=1;i=d;return}function bmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193728]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+160>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+160>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(193736,eCc(c[(c[g>>2]|0)+160>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[193728]=1;i=d;return}function cmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[193928]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+156>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+156>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(193936,eCc(c[(c[g>>2]|0)+156>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[193928]=1;i=d;return}function dmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194128]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+152>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+152>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(194136,eCc(c[(c[g>>2]|0)+152>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[194128]=1;i=d;return}function emc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194304]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+148>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+148>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(194312,eCc(c[(c[g>>2]|0)+148>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[194304]=1;i=d;return}function fmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194480]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+144>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+144>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(194488,eCc(c[(c[g>>2]|0)+144>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[194480]=1;i=d;return}function gmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194656]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(194664,cCc(+h[(c[g>>2]|0)+39568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[194656]=1;i=d;return}function hmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194776]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(194784,cCc(+h[(c[g>>2]|0)+39560>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[194776]=1;i=d;return}function imc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[194896]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39552>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(194904,cCc(+h[(c[g>>2]|0)+39552>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[194896]=1;i=d;return}function jmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195040]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39544>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(195048,cCc(+h[(c[g>>2]|0)+39544>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[195040]=1;i=d;return}function kmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195184]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+140>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+140>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(195192,eCc(c[(c[g>>2]|0)+140>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[195184]=1;i=d;return}function lmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195400]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+136>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+136>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(195408,eCc(c[(c[g>>2]|0)+136>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[195400]=1;i=d;return}function mmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+132>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+132>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(195624,eCc(c[(c[g>>2]|0)+132>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[195616]=1;i=d;return}function nmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[195832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+128>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+128>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(195840,eCc(c[(c[g>>2]|0)+128>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[195832]=1;i=d;return}function omc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196024]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+124>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+124>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(196032,eCc(c[(c[g>>2]|0)+124>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[196024]=1;i=d;return}function pmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196216]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+120>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+120>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(196224,eCc(c[(c[g>>2]|0)+120>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[196216]=1;i=d;return}function qmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196408]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39536>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(196416,cCc(+h[(c[g>>2]|0)+39536>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[196408]=1;i=d;return}function rmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196552]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39528>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(196560,cCc(+h[(c[g>>2]|0)+39528>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[196552]=1;i=d;return}function smc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39520>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(196704,cCc(+h[(c[g>>2]|0)+39520>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[196696]=1;i=d;return}function tmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196840]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39512>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(196848,cCc(+h[(c[g>>2]|0)+39512>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[196840]=1;i=d;return}function umc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[196960]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39504>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(196968,cCc(+h[(c[g>>2]|0)+39504>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[196960]=1;i=d;return}function vmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39496>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197088,cCc(+h[(c[g>>2]|0)+39496>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197080]=1;i=d;return}function wmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39488>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197208,cCc(+h[(c[g>>2]|0)+39488>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197200]=1;i=d;return}function xmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197312]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39480>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197320,cCc(+h[(c[g>>2]|0)+39480>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197312]=1;i=d;return}function ymc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197416]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39472>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197424,cCc(+h[(c[g>>2]|0)+39472>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197416]=1;i=d;return}function zmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39464>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197576,cCc(+h[(c[g>>2]|0)+39464>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197568]=1;i=d;return}function Amc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197712]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39440>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197720,cCc(+h[(c[g>>2]|0)+39440>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197712]=1;i=d;return}function Bmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197816]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39432>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197824,cCc(+h[(c[g>>2]|0)+39432>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197816]=1;i=d;return}function Cmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[197928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(197936,cCc(+h[(c[g>>2]|0)+39424>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[197928]=1;i=d;return}function Dmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198032]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39416>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(198040,cCc(+h[(c[g>>2]|0)+39416>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[198032]=1;i=d;return}function Emc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198144]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39408>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(198152,cCc(+h[(c[g>>2]|0)+39408>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[198144]=1;i=d;return}function Fmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198272]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+116>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+116>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(198280,eCc(c[(c[g>>2]|0)+116>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[198272]=1;i=d;return}function Gmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198472]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+112>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+112>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(198480,eCc(c[(c[g>>2]|0)+112>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[198472]=1;i=d;return}function Hmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198672]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+108>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+108>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(198680,eCc(c[(c[g>>2]|0)+108>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[198672]=1;i=d;return}function Imc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[198872]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+104>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+104>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(198880,eCc(c[(c[g>>2]|0)+104>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[198872]=1;i=d;return}function Jmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199048]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+100>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+100>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(199056,eCc(c[(c[g>>2]|0)+100>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[199048]=1;i=d;return}function Kmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+96>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+96>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(199232,eCc(c[(c[g>>2]|0)+96>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[199224]=1;i=d;return}function Lmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199400]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39392>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(199408,cCc(+h[(c[g>>2]|0)+39392>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[199400]=1;i=d;return}function Mmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199520]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39384>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(199528,cCc(+h[(c[g>>2]|0)+39384>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[199520]=1;i=d;return}function Nmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39368>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(199648,cCc(+h[(c[g>>2]|0)+39368>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[199640]=1;i=d;return}function Omc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199760]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39360>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(199768,cCc(+h[(c[g>>2]|0)+39360>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[199760]=1;i=d;return}function Pmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[199880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(199888,cCc(+h[(c[g>>2]|0)+39336>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[199880]=1;i=d;return}function Qmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200016]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39328>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(200024,cCc(+h[(c[g>>2]|0)+39328>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[200016]=1;i=d;return}function Rmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200152]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+92>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+92>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(200160,eCc(c[(c[g>>2]|0)+92>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[200152]=1;i=d;return}function Smc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200352]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+88>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+88>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(200360,eCc(c[(c[g>>2]|0)+88>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[200352]=1;i=d;return}function Tmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200552]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+84>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+84>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(200560,eCc(c[(c[g>>2]|0)+84>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[200552]=1;i=d;return}function Umc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200752]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+80>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+80>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(200760,eCc(c[(c[g>>2]|0)+80>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[200752]=1;i=d;return}function Vmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[200936]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+76>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+76>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(200944,eCc(c[(c[g>>2]|0)+76>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[200936]=1;i=d;return}function Wmc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201120]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+72>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+72>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(201128,eCc(c[(c[g>>2]|0)+72>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[201120]=1;i=d;return}function Xmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201304]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39320>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(201312,cCc(+h[(c[g>>2]|0)+39320>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[201304]=1;i=d;return}function Ymc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201440]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39312>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(201448,cCc(+h[(c[g>>2]|0)+39312>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[201440]=1;i=d;return}function Zmc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201576]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39304>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(201584,cCc(+h[(c[g>>2]|0)+39304>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[201576]=1;i=d;return}function _mc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201712]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39296>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(201720,cCc(+h[(c[g>>2]|0)+39296>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[201712]=1;i=d;return}function $mc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201824]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39288>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(201832,cCc(+h[(c[g>>2]|0)+39288>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[201824]=1;i=d;return}function anc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[201936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39280>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(201944,cCc(+h[(c[g>>2]|0)+39280>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[201936]=1;i=d;return}function bnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39272>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202056,cCc(+h[(c[g>>2]|0)+39272>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202048]=1;i=d;return}function cnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202160]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39264>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202168,cCc(+h[(c[g>>2]|0)+39264>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202160]=1;i=d;return}function dnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39256>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202288,cCc(+h[(c[g>>2]|0)+39256>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202280]=1;i=d;return}function enc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202424]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39248>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202432,cCc(+h[(c[g>>2]|0)+39248>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202424]=1;i=d;return}function fnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202568]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202576,cCc(+h[(c[g>>2]|0)+39224>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202672;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202568]=1;i=d;return}function gnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202696]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39216>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202704,cCc(+h[(c[g>>2]|0)+39216>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202808;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202696]=1;i=d;return}function hnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202832]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39208>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202840,cCc(+h[(c[g>>2]|0)+39208>>3],7896)|0)|0;g=c[85376]|0;j=e;k=202936;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202832]=1;i=d;return}function inc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[202960]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(202968,cCc(+h[(c[g>>2]|0)+39200>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203064;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[202960]=1;i=d;return}function jnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203088]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39192>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(203096,cCc(+h[(c[g>>2]|0)+39192>>3],7896)|0)|0;g=c[85376]|0;j=e;k=203208;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[203088]=1;i=d;return}function knc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203232]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+68>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+68>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(203240,eCc(c[(c[g>>2]|0)+68>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[203232]=1;i=d;return}function lnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203424]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+64>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+64>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(203432,eCc(c[(c[g>>2]|0)+64>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[203424]=1;i=d;return}function mnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+60>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+60>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(203624,eCc(c[(c[g>>2]|0)+60>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=203808;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[203616]=1;i=d;return}function nnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[203832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+56>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+56>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(203840,eCc(c[(c[g>>2]|0)+56>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[203832]=1;i=d;return}function onc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204e3]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+52>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+52>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(204008,eCc(c[(c[g>>2]|0)+52>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[204e3]=1;i=d;return}function pnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204168]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+48>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+48>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(204176,eCc(c[(c[g>>2]|0)+48>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=204336;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[204168]=1;i=d;return}function qnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204360]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39176>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(204368,cCc(+h[(c[g>>2]|0)+39176>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[204360]=1;i=d;return}function rnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39168>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(204504,cCc(+h[(c[g>>2]|0)+39168>>3],7896)|0)|0;g=c[85376]|0;j=e;k=204616;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[204496]=1;i=d;return}function snc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204640]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39160>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(204648,cCc(+h[(c[g>>2]|0)+39160>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[204640]=1;i=d;return}function tnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204792]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39152>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(204800,cCc(+h[(c[g>>2]|0)+39152>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[204792]=1;i=d;return}function unc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[204936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39128>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(204944,cCc(+h[(c[g>>2]|0)+39128>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205080;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[204936]=1;i=d;return}function vnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205104]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39120>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(205112,cCc(+h[(c[g>>2]|0)+39120>>3],7896)|0)|0;g=c[85376]|0;j=e;k=205248;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[205104]=1;i=d;return}function wnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205272]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+44>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+44>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(205280,eCc(c[(c[g>>2]|0)+44>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[205272]=1;i=d;return}function xnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205488]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+40>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+40>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(205496,eCc(c[(c[g>>2]|0)+40>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[205488]=1;i=d;return}function ync(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205704]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+36>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+36>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(205712,eCc(c[(c[g>>2]|0)+36>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=205920;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[205704]=1;i=d;return}function znc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[205944]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+32>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+32>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(205952,eCc(c[(c[g>>2]|0)+32>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[205944]=1;i=d;return}function Anc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206136]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+28>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+28>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(206144,eCc(c[(c[g>>2]|0)+28>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[206136]=1;i=d;return}function Bnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206328]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+24>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+24>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(206336,eCc(c[(c[g>>2]|0)+24>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=206520;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[206328]=1;i=d;return}function Cnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206544]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39112>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(206552,cCc(+h[(c[g>>2]|0)+39112>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206688;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[206544]=1;i=d;return}function Dnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206712]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39104>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(206720,cCc(+h[(c[g>>2]|0)+39104>>3],7896)|0)|0;g=c[85376]|0;j=e;k=206856;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[206712]=1;i=d;return}function Enc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[206880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39096>>3],-1.0e+60)|0)<<24>>24==0)){i=d;return}b=gCc(206888,cCc(+h[(c[g>>2]|0)+39096>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207024;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[206880]=1;i=d;return}function Fnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207048]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207056,cCc(+h[(c[g>>2]|0)+39088>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207168;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207048]=1;i=d;return}function Gnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207192]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39080>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207200,cCc(+h[(c[g>>2]|0)+39080>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207312;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207192]=1;i=d;return}function Hnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207336]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39072>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207344,cCc(+h[(c[g>>2]|0)+39072>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207456;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207336]=1;i=d;return}function Inc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207480]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39064>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207488,cCc(+h[(c[g>>2]|0)+39064>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207480]=1;i=d;return}function Jnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207616]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39056>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207624,cCc(+h[(c[g>>2]|0)+39056>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207720;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207616]=1;i=d;return}function Knc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207744]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39040>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207752,cCc(+h[(c[g>>2]|0)+39040>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207848;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207744]=1;i=d;return}function Lnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[207872]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39032>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(207880,cCc(+h[(c[g>>2]|0)+39032>>3],7896)|0)|0;g=c[85376]|0;j=e;k=207984;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[207872]=1;i=d;return}function Mnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208008]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39024>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(208016,cCc(+h[(c[g>>2]|0)+39024>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[208008]=1;i=d;return}function Nnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208136]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39016>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(208144,cCc(+h[(c[g>>2]|0)+39016>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208256;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[208136]=1;i=d;return}function Onc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208280]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+39008>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(208288,cCc(+h[(c[g>>2]|0)+39008>>3],7896)|0)|0;g=c[85376]|0;j=e;k=208408;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[208280]=1;i=d;return}function Pnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208432]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+20>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+20>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(208440,eCc(c[(c[g>>2]|0)+20>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[208432]=1;i=d;return}function Qnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208632]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+16>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+16>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(208640,eCc(c[(c[g>>2]|0)+16>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[208632]=1;i=d;return}function Rnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[208832]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+12>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+12>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(208840,eCc(c[(c[g>>2]|0)+12>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209032;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[208832]=1;i=d;return}function Snc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209056]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+8>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+8>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(209064,eCc(c[(c[g>>2]|0)+8>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[209056]=1;i=d;return}function Tnc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209232]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+4>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+4>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(209240,eCc(c[(c[g>>2]|0)+4>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[209232]=1;i=d;return}function Unc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209408]&1){i=d;return}g=b+420|0;b=VEc(+(c[c[g>>2]>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[c[g>>2]>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(209416,eCc(c[c[g>>2]>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=209584;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[209408]=1;i=d;return}function Vnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209608]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38992>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(209616,cCc(+h[(c[g>>2]|0)+38992>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209728;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[209608]=1;i=d;return}function Wnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209752]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38984>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(209760,cCc(+h[(c[g>>2]|0)+38984>>3],7896)|0)|0;g=c[85376]|0;j=e;k=209880;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[209752]=1;i=d;return}function Xnc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[209904]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(209912,cCc(+h[(c[g>>2]|0)+38976>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210032;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[209904]=1;i=d;return}function Ync(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210056]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38968>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(210064,cCc(+h[(c[g>>2]|0)+38968>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[210056]=1;i=d;return}function Znc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38944>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(210208,cCc(+h[(c[g>>2]|0)+38944>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210328;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[210200]=1;i=d;return}function _nc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210352]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38936>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(210360,cCc(+h[(c[g>>2]|0)+38936>>3],7896)|0)|0;g=c[85376]|0;j=e;k=210472;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[210352]=1;i=d;return}function $nc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210496]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38928>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(210504,cCc(+h[(c[g>>2]|0)+38928>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[210496]=1;i=d;return}function aoc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210624]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38920>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(210632,cCc(+h[(c[g>>2]|0)+38920>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[210624]=1;i=d;return}function boc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210744]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1968>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1968>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(210752,eCc(c[(c[g>>2]|0)+1968>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[210744]=1;i=d;return}function coc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[210928]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38896>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(210936,cCc(+h[(c[g>>2]|0)+38896>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211056;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[210928]=1;i=d;return}function doc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211080]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38888>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(211088,cCc(+h[(c[g>>2]|0)+38888>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211200;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[211080]=1;i=d;return}function eoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211224]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1964>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1964>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(211232,eCc(c[(c[g>>2]|0)+1964>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=211424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[211224]=1;i=d;return}function foc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211448]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38776>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(211456,cCc(+h[(c[g>>2]|0)+38776>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211656;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[211448]=1;i=d;return}function goc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211680]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38720>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(211688,cCc(+h[(c[g>>2]|0)+38720>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211784;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[211680]=1;i=d;return}function hoc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211808]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38656>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(211816,cCc(+h[(c[g>>2]|0)+38656>>3],7896)|0)|0;g=c[85376]|0;j=e;k=211912;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[211808]=1;i=d;return}function ioc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[211936]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38648>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(211944,cCc(+h[(c[g>>2]|0)+38648>>3],7896)|0)|0;g=c[85376]|0;j=e;k=212048;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[211936]=1;i=d;return}function joc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212072]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38640>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(212080,cCc(+h[(c[g>>2]|0)+38640>>3],7896)|0)|0;g=c[85376]|0;j=e;k=212176;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[212072]=1;i=d;return}function koc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212200]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38632>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(212208,cCc(+h[(c[g>>2]|0)+38632>>3],7896)|0)|0;g=c[85376]|0;j=e;k=212336;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[212200]=1;i=d;return}function loc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212360]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38600>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(212368,cCc(+h[(c[g>>2]|0)+38600>>3],7896)|0)|0;g=c[85376]|0;j=e;k=212480;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[212360]=1;i=d;return}function moc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212504]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38592>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(212512,cCc(+h[(c[g>>2]|0)+38592>>3],7896)|0)|0;g=c[85376]|0;j=e;k=212592;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[212504]=1;i=d;return}function noc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212616]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1948>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1948>>2]|0),3.0)|0)<<24>>24==0)){i=d;return}b=gCc(212624,eCc(c[(c[g>>2]|0)+1948>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=212856;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[212616]=1;i=d;return}function ooc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[212880]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38576>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(212888,cCc(+h[(c[g>>2]|0)+38576>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213e3;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[212880]=1;i=d;return}function poc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213024]&1){i=d;return}g=b+416|0;if(!((VEc(+h[(c[g>>2]|0)+38568>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(213032,cCc(+h[(c[g>>2]|0)+38568>>3],7896)|0)|0;g=c[85376]|0;j=e;k=213136;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[213024]=1;i=d;return}function qoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213160]&1){i=d;return}g=b+420|0;b=VEc(+(c[(c[g>>2]|0)+1944>>2]|0),1.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[g>>2]|0)+1944>>2]|0),5.0)|0)<<24>>24==0)){i=d;return}b=gCc(213168,eCc(c[(c[g>>2]|0)+1944>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=213328;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[213160]=1;i=d;return}function roc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213352]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1556>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1556>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(213360,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1556>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[213352]=1;i=d;return}function soc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213520]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1552>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1552>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(213528,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1552>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[213520]=1;i=d;return}function toc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213688]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1548>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1548>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(213696,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1548>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[213688]=1;i=d;return}function uoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[213856]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1544>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1544>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(213864,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1544>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[213856]=1;i=d;return}function voc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214024]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1540>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1540>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(214032,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1540>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[214024]=1;i=d;return}function woc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214192]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1536>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1536>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(214200,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1536>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[214192]=1;i=d;return}function xoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214360]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1532>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1532>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(214368,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1532>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[214360]=1;i=d;return}function yoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214552]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1528>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1528>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(214560,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1528>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[214552]=1;i=d;return}function zoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214744]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1524>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1524>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(214752,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1524>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[214744]=1;i=d;return}function Aoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[214936]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1520>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1520>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(214944,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1520>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[214936]=1;i=d;return}function Boc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215080]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1516>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1516>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(215088,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1516>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[215080]=1;i=d;return}function Coc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215224]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1512>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1512>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(215232,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1512>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[215224]=1;i=d;return}function Doc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215368]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1508>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1508>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(215376,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1508>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[215368]=1;i=d;return}function Eoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215520]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1504>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1504>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(215528,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1504>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[215520]=1;i=d;return}function Foc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215672]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1500>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1500>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(215680,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1500>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[215672]=1;i=d;return}function Goc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[215824]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1496>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1496>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(215832,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1496>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[215824]=1;i=d;return}function Hoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216008]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1492>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1492>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(216016,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1492>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[216008]=1;i=d;return}function Ioc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216192]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1488>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1488>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(216200,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1488>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[216192]=1;i=d;return}function Joc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216376]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1484>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1484>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(216384,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1484>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[216376]=1;i=d;return}function Koc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1480>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1480>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(216536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1480>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[216528]=1;i=d;return}function Loc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216680]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1476>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1476>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(216688,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1476>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[216680]=1;i=d;return}function Moc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[216832]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1472>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1472>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(216840,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1472>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[216832]=1;i=d;return}function Noc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217016]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1468>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1468>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(217024,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1468>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[217016]=1;i=d;return}function Ooc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217200]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1464>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1464>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(217208,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1464>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[217200]=1;i=d;return}function Poc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217384]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1460>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1460>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(217392,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1460>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[217384]=1;i=d;return}function Qoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217568]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1456>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1456>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(217576,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1456>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[217568]=1;i=d;return}function Roc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217752]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1452>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1452>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(217760,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1452>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[217752]=1;i=d;return}function Soc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[217936]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1448>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1448>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(217944,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1448>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[217936]=1;i=d;return}function Toc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218088]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1444>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1444>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(218096,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1444>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[218088]=1;i=d;return}function Uoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218240]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1440>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1440>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(218248,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1440>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[218240]=1;i=d;return}function Voc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218392]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1436>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1436>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(218400,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1436>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[218392]=1;i=d;return}function Woc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218576]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1432>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1432>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(218584,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1432>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[218576]=1;i=d;return}function Xoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218760]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1428>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1428>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(218768,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1428>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[218760]=1;i=d;return}function Yoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[218944]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1424>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1424>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(218952,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1424>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[218944]=1;i=d;return}function Zoc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219096]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1420>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1420>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(219104,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1420>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[219096]=1;i=d;return}function _oc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219248]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1416>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1416>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(219256,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1416>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[219248]=1;i=d;return}function $oc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219400]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1412>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1412>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(219408,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1412>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[219400]=1;i=d;return}function apc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219560]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1408>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1408>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(219568,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1408>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[219560]=1;i=d;return}function bpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219720]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1404>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1404>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(219728,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1404>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[219720]=1;i=d;return}function cpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[219880]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1400>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1400>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(219888,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1400>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[219880]=1;i=d;return}function dpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220056]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1396>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1396>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(220064,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1396>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220056]=1;i=d;return}function epc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220232]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1392>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1392>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(220240,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1392>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220232]=1;i=d;return}function fpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220408]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1388>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1388>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(220416,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1388>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220408]=1;i=d;return}function gpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220552]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1384>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1384>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(220560,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1384>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220552]=1;i=d;return}function hpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220696]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1380>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1380>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(220704,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1380>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220696]=1;i=d;return}function ipc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220840]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1376>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1376>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(220848,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1376>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220840]=1;i=d;return}function jpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[220992]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1372>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1372>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(221e3,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1372>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[220992]=1;i=d;return}function kpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221144]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1368>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1368>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(221152,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1368>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[221144]=1;i=d;return}function lpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221296]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1364>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1364>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(221304,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1364>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[221296]=1;i=d;return}function mpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221480]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1360>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1360>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(221488,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1360>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[221480]=1;i=d;return}function npc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221664]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1356>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1356>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(221672,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1356>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[221664]=1;i=d;return}function opc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[221848]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1352>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1352>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(221856,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1352>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[221848]=1;i=d;return}function ppc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222016]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1348>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1348>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(222024,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1348>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[222016]=1;i=d;return}function qpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222184]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1344>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1344>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(222192,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1344>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[222184]=1;i=d;return}function rpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222352]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1340>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1340>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(222360,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1340>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[222352]=1;i=d;return}function spc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222520]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1336>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1336>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(222528,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1336>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[222520]=1;i=d;return}function tpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222688]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1332>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1332>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(222696,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1332>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[222688]=1;i=d;return}function upc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[222856]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1328>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1328>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(222864,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1328>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[222856]=1;i=d;return}function vpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223024]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1324>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1324>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(223032,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1324>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[223024]=1;i=d;return}function wpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223192]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1320>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1320>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(223200,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1320>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[223192]=1;i=d;return}function xpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223360]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1316>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1316>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(223368,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1316>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[223360]=1;i=d;return}



function gDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0,na=0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0.0,Wa=0.0,Xa=0,Ya=0.0,Za=0.0,_a=0.0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0.0,gb=0.0,hb=0.0,ib=0.0,jb=0.0,kb=0.0,lb=0,mb=0.0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0.0,ub=0.0,vb=0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;z=~y;h[37698]=.5;h[37684]=1.0;h[37721]=.25;h[37696]=2.0;h[37723]=6.283185307179586;A=w+ -1-(c[b>>2]|0)|0;c[75404]=A;B=c[d>>2]|0;c[75334]=1;if((B|0)>=1){C=1;while(1){h[p+(C+ -1+(c[b>>2]|0)<<3)>>3]=0.0;D=C+1|0;c[75334]=D;if((C|0)<(B|0)){C=D}else{break}}}c[75332]=1;if((A|0)>=1){C=1;while(1){B=fa(C,w)|0;E=+h[j+(B+x+(c[n>>2]|0)<<3)>>3];h[37699]=E;if((C|0)<(c[k>>2]|0)){F=-E;h[37699]=F;G=F}else{G=E}D=c[d>>2]|0;c[75334]=1;a:do{if((D|0)>=1){E=G;H=1;while(1){I=p+(H+ -1+(c[b>>2]|0)<<3)|0;h[I>>3]=E*+h[j+(H+x+B<<3)>>3]+ +h[I>>3];I=H+1|0;c[75334]=I;if((H|0)>=(D|0)){break a}E=+h[37699];H=I}}}while(0);D=C+1|0;c[75332]=D;if((C|0)<(A|0)){C=D}else{break}}}C=c[b>>2]|0;h[37703]=+h[p+(C+ -1+(c[n>>2]|0)<<3)>>3];h[37668]=0.0;h[37670]=0.0;h[37674]=0.0;h[37731]=0.0;c[75330]=1;if((C|0)<1){J=0.0;K=0.0;L=0.0}else{G=0.0;A=1;while(1){D=A+ -1|0;B=o+(D<<3)|0;E=+h[B>>3];h[37668]=G+E*E;E=+h[f+((c[n>>2]|0)+x+(fa(A,w)|0)<<3)>>3];H=e+(D<<3)|0;F=E- +h[H>>3];I=s+(D<<3)|0;h[I>>3]=F;E=+h[37670]+ +h[B>>3]*F;h[37670]=E;F=+h[I>>3];M=+h[37674]+F*F;h[37674]=M;F=+h[H>>3];h[37731]=+h[37731]+F*F;H=A+1|0;c[75330]=H;F=+h[37668];if((A|0)<(C|0)){A=H;G=F}else{J=M;K=F;L=E;break}}}G=L*L;do{if(G>K*.99*J){A=c[n>>2]|0;c[75400]=A;E=G/J;h[37720]=E;C=c[d>>2]|0;c[75334]=1;if((C|0)<1){N=J;O=L;P=A}else{F=J;M=L;Q=E;H=A;A=1;while(1){do{if((A|0)==(c[m>>2]|0)){R=F;S=M;T=Q;U=H}else{h[37728]=0.0;h[37730]=0.0;I=c[b>>2]|0;c[75330]=1;if((I|0)<1){W=0.0;Z=0.0}else{E=0.0;_=0.0;B=1;while(1){$=+h[f+((fa(B,w)|0)+x+A<<3)>>3];aa=$- +h[e+(B+ -1<<3)>>3];h[37697]=aa;ba=_+aa*+h[o+(B+ -1<<3)>>3];h[37728]=ba;ca=E+aa*aa;h[37730]=ca;if((B|0)<(I|0)){B=B+1|0;_=ba;E=ca}else{break}}c[75330]=I+1;W=ca;Z=ba}E=Z*Z/W;if(!(E<Q)){R=F;S=M;T=Q;U=H;break}c[75400]=A;h[37720]=E;h[37670]=Z;h[37674]=W;R=W;S=Z;T=E;U=A}}while(0);B=A+1|0;c[75334]=B;if((A|0)<(C|0)){F=R;M=S;Q=T;H=U;A=B}else{N=R;O=S;P=U;break}}}A=c[b>>2]|0;c[75330]=1;if((A|0)<1){da=O;ea=N;ga=K;break}else{ha=1}while(1){Q=+h[f+((fa(ha,w)|0)+x+P<<3)>>3];H=ha+ -1|0;h[s+(H<<3)>>3]=Q- +h[e+(H<<3)>>3];if((ha|0)<(A|0)){ha=ha+1|0}else{break}}c[75330]=A+1;da=+h[37670];ea=+h[37674];ga=+h[37668]}else{da=L;ea=J;ga=K}}while(0);K=ga*ea-da*da;h[37719]=K;c[75428]=0;h[37727]=0.0;ha=(y<<1)+z|0;P=(y<<2)+z|0;U=(y*3|0)+z|0;H=(y*5|0)+z|0;ea=da;da=ga;ga=K;C=1;while(1){c[75428]=C;K=+h[37684]/+V(+ga);h[37699]=K;h[37722]=0.0;h[37724]=0.0;B=c[b>>2]|0;c[75330]=1;if((B|0)<1){ia=da;ja=0.0;ka=0.0}else{J=ea;L=da;N=K;D=1;la=0;while(1){ma=s+(la<<3)|0;h[ma>>3]=N*(L*+h[ma>>3]-J*+h[o+(la<<3)>>3]);ma=D+ -1|0;na=e+(ma<<3)|0;oa=+h[37722]+ +h[na>>3]*+h[o+(ma<<3)>>3];h[37722]=oa;pa=+h[37724]+ +h[na>>3]*+h[s+(ma<<3)>>3];h[37724]=pa;if((D|0)>=(B|0)){break}ma=D;J=+h[37670];L=+h[37668];N=+h[37699];D=D+1|0;la=ma}c[75330]=B+1;ia=+h[37668];ja=pa;ka=oa}N=+h[37698];L=ka*N*ka;h[37715]=L;J=ja*N*ja;h[37716]=J;h[37675]=J+(L+ia*(+h[37731]+ia*N));N=+h[37696];h[301408>>3]=N*ka*ia;h[301416>>3]=N*ja*ia;h[301424>>3]=L-J;h[301432>>3]=ka*ja;la=301440|0;c[la+0>>2]=0;c[la+4>>2]=0;c[la+8>>2]=0;c[la+12>>2]=0;c[la+16>>2]=0;c[la+20>>2]=0;c[la+24>>2]=0;c[la+28>>2]=0;c[75330]=10;la=c[d>>2]|0;c[75334]=1;if((la|0)>=1){D=1;while(1){h[37715]=0.0;h[37716]=0.0;h[37717]=0.0;A=c[b>>2]|0;c[75330]=1;if((A|0)<1){qa=0.0;ra=0.0}else{ma=D+x|0;J=0.0;L=0.0;N=0.0;na=1;while(1){K=+h[f+((fa(na,w)|0)+x+D<<3)>>3];sa=N+K*+h[o+(na+ -1<<3)>>3];h[37715]=sa;ta=f+(ma+(fa(na,w)|0)<<3)|0;ua=na+ -1|0;va=L+ +h[ta>>3]*+h[s+(ua<<3)>>3];h[37716]=va;K=J+ +h[ta>>3]*+h[e+(ua<<3)>>3];h[37717]=K;if((na|0)<(A|0)){na=na+1|0;N=sa;L=va;J=K}else{break}}c[75330]=A+1;qa=va;ra=sa}h[t+(D+ -1<<3)>>3]=+h[37721]*(ra*ra+qa*qa);h[t+(ha+D<<3)>>3]=+h[37715]*+h[37717];h[t+(U+D<<3)>>3]=+h[37716]*+h[37717];J=+h[37715];L=+h[37716];h[t+(P+D<<3)>>3]=+h[37721]*(J*J-L*L);h[t+(H+D<<3)>>3]=+h[37698]*+h[37715]*+h[37716];na=D+1|0;c[75334]=na;if((D|0)<(la|0)){D=na}else{break}}}D=c[b>>2]|0;c[75330]=1;if((D|0)>=1){la=1;while(1){B=(c[d>>2]|0)+la|0;c[75342]=B;h[t+(B+ -1<<3)>>3]=0.0;na=la+ -1|0;h[t+(ha+B<<3)>>3]=+h[o+(na<<3)>>3];h[t+(U+B<<3)>>3]=+h[s+(na<<3)>>3];h[t+(P+B<<3)>>3]=0.0;h[t+(H+B<<3)>>3]=0.0;B=la+1|0;c[75330]=B;if((la|0)<(D|0)){la=B}else{break}}}c[75338]=1;la=1;do{D=c[d>>2]|0;c[75346]=D;if((la&-2|0)==2){B=c[l>>2]|0;c[75346]=B;wa=B}else{wa=D}D=c[d>>2]|0;c[75334]=1;if((D|0)>=1){B=fa(la,y)|0;na=1;while(1){h[u+(na+z+B<<3)>>3]=0.0;if((na|0)<(D|0)){na=na+1|0}else{break}}c[75334]=D+1}na=c[75404]|0;c[75332]=1;if((na|0)<1){xa=la}else{B=1;A=la;while(1){h[37695]=0.0;ma=c[d>>2]|0;c[75334]=1;if((ma|0)<1){ya=0.0;za=A}else{ua=fa(la,y)|0;L=0.0;ta=1;while(1){J=+h[j+(ta+x+(fa(B,w)|0)<<3)>>3];Aa=L+J*+h[t+(ta+z+ua<<3)>>3];h[37695]=Aa;if((ta|0)<(ma|0)){ta=ta+1|0;L=Aa}else{break}}c[75334]=ma+1;ya=Aa;za=la}if((B|0)<(c[k>>2]|0)){L=-ya;h[37695]=L;Ba=L}else{Ba=ya}ta=c[d>>2]|0;c[75334]=1;if((ta|0)>=1){ua=fa(B,w)|0;I=fa(za,y)|0;L=Ba;Ca=1;while(1){Da=u+(Ca+z+I<<3)|0;h[Da>>3]=L*+h[j+(Ca+x+ua<<3)>>3]+ +h[Da>>3];if((Ca|0)>=(ta|0)){break}L=+h[37695];Ca=Ca+1|0}c[75334]=ta+1}Ca=B+1|0;c[75332]=Ca;if((B|0)<(na|0)){B=Ca;A=za}else{xa=za;break}}}do{if((wa|0)==(c[l>>2]|0)){A=c[d>>2]|0;c[75334]=1;if((A|0)<1){break}else{Ea=1}while(1){h[37695]=0.0;B=c[b>>2]|0;c[75332]=1;if((B|0)<1){Fa=fa(xa,y)|0;Ga=0.0}else{L=0.0;na=1;while(1){J=+h[g+((fa(na,y)|0)+z+Ea<<3)>>3];D=fa(xa,y)|0;N=L+J*+h[t+(na+z+(c[d>>2]|0)+D<<3)>>3];h[37695]=N;Ca=na+1|0;c[75332]=Ca;if((na|0)<(B|0)){na=Ca;L=N}else{Fa=D;Ga=N;break}}}na=u+(Ea+z+Fa<<3)|0;h[na>>3]=Ga+ +h[na>>3];na=Ea+1|0;c[75334]=na;if((Ea|0)<(A|0)){Ea=na}else{break}}}}while(0);A=c[b>>2]|0;c[75332]=1;if((A|0)>=1){ta=1;while(1){h[37695]=0.0;c[75330]=1;if((wa|0)<1){Ha=fa(xa,y)|0;Ia=0.0}else{na=fa(ta,y)|0;B=fa(xa,y)|0;L=0.0;D=1;while(1){Ca=D+z|0;Ja=L+ +h[g+(Ca+na<<3)>>3]*+h[t+(Ca+B<<3)>>3];h[37695]=Ja;if((D|0)<(wa|0)){D=D+1|0;L=Ja}else{break}}c[75330]=wa+1;Ha=B;Ia=Ja}h[u+((c[d>>2]|0)+z+ta+Ha<<3)>>3]=Ia;D=ta+1|0;c[75332]=D;if((ta|0)<(A|0)){ta=D}else{break}}}la=xa+1|0;c[75338]=la;}while((la|0)<6);la=c[l>>2]|0;c[75334]=1;h[37695]=0.0;c[75330]=1;L=+h[37698];if((la|0)<1){Ka=L}else{N=L;ta=1;while(1){L=0.0;A=1;do{D=(fa(A,y)|0)+z+ta|0;h[301480+(A+ -1<<3)>>3]=N*+h[u+(D<<3)>>3]*+h[t+(D<<3)>>3];L=+h[301480+(A+ -1<<3)>>3]+L;h[37695]=L;A=A+1|0;}while((A|0)<6);h[37675]=+h[37675]- +h[37685]-L;A=ta+ -1|0;D=u+(A<<3)|0;na=ha+ta|0;Ca=t+(na<<3)|0;ua=u+(na<<3)|0;na=t+(A<<3)|0;J=+h[D>>3]*+h[Ca>>3]+ +h[ua>>3]*+h[na>>3];h[37715]=J;A=P+ta|0;I=t+(A<<3)|0;ma=u+(A<<3)|0;K=+h[ua>>3]*+h[I>>3]+ +h[ma>>3]*+h[Ca>>3];h[37716]=K;A=U+ta|0;Da=u+(A<<3)|0;La=H+ta|0;Ma=t+(La<<3)|0;Na=u+(La<<3)|0;La=t+(A<<3)|0;O=+h[Da>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[La>>3];h[37717]=O;h[301408>>3]=+h[301408>>3]-J-N*(O+K);h[301440>>3]=+h[301440>>3]-N*(K-O);O=+h[D>>3]*+h[La>>3]+ +h[Da>>3]*+h[na>>3];h[37715]=O;K=+h[ua>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[Ca>>3];h[37716]=K;J=+h[Da>>3]*+h[I>>3]+ +h[ma>>3]*+h[La>>3];h[37717]=J;h[301416>>3]=+h[301416>>3]-O-N*(K-J);h[301448>>3]=+h[301448>>3]-N*(K+J);J=+h[D>>3]*+h[I>>3]+ +h[ma>>3]*+h[na>>3];h[37715]=J;h[301424>>3]=+h[301496>>3]+(+h[301424>>3]-J- +h[301488>>3]);J=+h[D>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[na>>3];h[37715]=J;K=+h[ua>>3]*+h[La>>3]+ +h[Da>>3]*+h[Ca>>3];h[37716]=K;Oa=+h[37698];h[301432>>3]=+h[301432>>3]-J-K*Oa;h[301456>>3]=+h[301456>>3]- +h[301504>>3]+ +h[301512>>3];K=+h[ma>>3]*+h[Ma>>3]+ +h[Na>>3]*+h[I>>3];h[37715]=K;h[301464>>3]=+h[301464>>3]-Oa*K;h[37695]=0.0;if((ta|0)<(la|0)){N=Oa;ta=ta+1|0}else{break}}c[75334]=la+1;c[75330]=1;Ka=Oa}N=0.0;ta=1;do{K=+h[u+((fa(ta,y)|0)+z+(c[n>>2]|0)<<3)>>3];h[301480+(ta+ -1<<3)>>3]=Ka*K*K;N=+h[301480+(ta+ -1<<3)>>3]+N;h[37695]=N;ta=ta+1|0;c[75330]=ta;}while((ta|0)<6);K=+h[37703];h[37705]=K*+h[37675]+ +h[37685]+N;J=+h[37696];ta=c[n>>2]|0;la=u+(ta+ -1<<3)|0;I=u+(ha+ta<<3)|0;O=J*+h[la>>3]*+h[I>>3];h[37715]=O;Na=u+(P+ta<<3)|0;S=+h[I>>3]*+h[Na>>3];h[37716]=S;Ma=u+(U+ta<<3)|0;ma=u+(H+ta<<3)|0;R=+h[Ma>>3]*+h[ma>>3];h[37717]=R;T=R+(K*+h[301408>>3]+O+S);h[301648>>3]=T;O=K*+h[301440>>3]+S-R;h[301680>>3]=O;R=J*+h[la>>3]*+h[Ma>>3];h[37715]=R;S=+h[I>>3]*+h[ma>>3];h[37716]=S;Z=+h[Ma>>3]*+h[Na>>3];h[37717]=Z;h[301656>>3]=K*+h[301416>>3]+R+S-Z;h[301688>>3]=K*+h[301448>>3]+S+Z;Z=J*+h[la>>3]*+h[Na>>3];h[37715]=Z;R=+h[301488>>3]+(Z+K*+h[301424>>3])- +h[301496>>3];h[301664>>3]=R;Z=J*+h[la>>3]*+h[ma>>3];h[37715]=Z;h[301672>>3]=Z+K*+h[301432>>3]+ +h[I>>3]*+h[Ma>>3];J=K*+h[301456>>3]+ +h[301504>>3]- +h[301512>>3];h[301696>>3]=J;h[301704>>3]=+h[37703]*+h[301464>>3]+ +h[Na>>3]*+h[ma>>3];K=+h[37705]+T+R+O+J;h[37695]=K;h[37725]=K;h[37726]=K;c[75436]=0;J=+h[37723]/50.0;h[37699]=J;h[37685]=+h[37684];c[75330]=1;O=K;ma=0;R=K;T=S;S=Z;Na=1;while(1){Pa=+(Na|0)*J;Z=+X(+Pa);h[301488>>3]=Z;W=+Y(+Pa);h[301496>>3]=W;ba=W;ca=Z;G=W;W=Z;Ma=4;while(1){Z=ca*W-ba*G;h[301480+(Ma+ -1<<3)>>3]=Z;Q=+h[301488>>3]*G+ +h[301496>>3]*W;h[301480+(Ma<<3)>>3]=Q;I=Ma+2|0;if((I|0)>=9){Qa=1;Ra=0.0;break}ba=+h[301496>>3];ca=+h[301488>>3];Ma=I;W=Z;G=Q}do{Ma=Qa+ -1|0;Ra=Ra+ +h[301640+(Ma<<3)>>3]*+h[301480+(Ma<<3)>>3];Qa=Qa+1|0;}while((Qa|0)<10);if(!(Ra>=0.0)){Sa=-Ra}else{Sa=Ra}if(!(R>=0.0)){Ta=-R}else{Ta=R}do{if(Sa>Ta){h[37726]=Ra;c[75436]=Na;h[37715]=O;Ua=Ra;Va=T;Wa=O;Xa=Na}else{if((Na|0)!=(ma+1|0)){Ua=R;Va=T;Wa=S;Xa=ma;break}h[37716]=Ra;Ua=R;Va=Ra;Wa=S;Xa=ma}}while(0);if((Na|0)>48){break}else{O=Ra;ma=Xa;R=Ua;T=Va;S=Wa;Na=Na+1|0}}c[75332]=10;h[37695]=Ra;h[37704]=Pa;h[37729]=O;c[75330]=50;if((Xa|0)==49){h[37716]=K;Ya=Wa;Za=K}else if((Xa|0)==0){h[37715]=Ra;Ya=Ra;Za=Va}else{Ya=Wa;Za=Va}h[37701]=0.0;if(Ya!=Za){S=Ya-Ua;h[37715]=S;T=Za-Ua;h[37716]=T;R=+h[37698]*(S-T)/(S+T);h[37701]=R;_a=R}else{_a=0.0}R=J*(+(Xa|0)+_a);h[37704]=R;T=+X(+R);h[301488>>3]=T;S=+Y(+R);h[301496>>3]=S;c[75332]=4;R=S;N=T;G=S;S=T;Na=4;while(1){T=N*S-R*G;h[301480+(Na+ -1<<3)>>3]=T;W=+h[301488>>3]*G+ +h[301496>>3]*S;h[301480+(Na<<3)>>3]=W;ma=Na+2|0;if((ma|0)>=9){break}R=+h[301496>>3];N=+h[301488>>3];Na=ma;S=T;G=W}h[r>>3]=0.0;h[37726]=0.0;c[75332]=1;Na=1;do{ma=Na+ -1|0;Ma=301480+(ma<<3)|0;h[r>>3]=+h[r>>3]+ +h[301400+(ma<<3)>>3]*+h[Ma>>3];h[37726]=+h[37726]+ +h[301640+(ma<<3)>>3]*+h[Ma>>3];Na=Na+1|0;}while((Na|0)<10);c[75332]=10;Na=c[l>>2]|0;c[75334]=1;if((Na|0)>=1){Ma=1;while(1){h[q+(Ma+ -1<<3)>>3]=0.0;ma=1;do{G=+h[u+((fa(ma,y)|0)+z+Ma<<3)>>3];I=q+(Ma+ -1<<3)|0;h[I>>3]=+h[I>>3]+G*+h[301480+(ma+ -1<<3)>>3];ma=ma+1|0;}while((ma|0)<6);if((Ma|0)<(Na|0)){Ma=Ma+1|0}else{break}}c[75332]=6;c[75334]=Na+1}h[37694]=+h[q+((c[n>>2]|0)+ -1<<3)>>3];h[37668]=0.0;h[37715]=0.0;h[37716]=0.0;Ma=c[b>>2]|0;c[75330]=1;if((Ma|0)<1){$a=0.0;ab=0.0}else{ma=1;while(1){I=ma+ -1|0;la=o+(I<<3)|0;h[la>>3]=+h[301488>>3]*+h[la>>3]+ +h[301496>>3]*+h[s+(I<<3)>>3];I=ma+ -1|0;la=o+(I<<3)|0;ta=p+(I<<3)|0;h[ta>>3]=+h[e+(I<<3)>>3]+ +h[la>>3];G=+h[la>>3];h[37668]=+h[37668]+G*G;bb=+h[37715]+ +h[la>>3]*+h[ta>>3];h[37715]=bb;G=+h[ta>>3];cb=+h[37716]+G*G;h[37716]=cb;if((ma|0)<(Ma|0)){ma=ma+1|0}else{break}}c[75330]=Ma+1;$a=cb;ab=bb}ma=c[75428]|0;Na=c[b>>2]|0;if((ma|0)>=(Na|0)){break}if((ma|0)>1){G=+h[37727];S=+h[37725];h[37727]=G>=S?G:S}S=+h[37726];if(!(S>=0.0)){db=-S}else{db=S}G=+h[37727];if(!(G>=0.0)){eb=-G}else{eb=G}if(db<=eb*1.1){break}h[37727]=S;c[75330]=1;b:do{if((Na|0)>=1){S=$a;G=ab;ta=1;while(1){la=ta+ -1|0;N=G*+h[e+(la<<3)>>3]+S*+h[o+(la<<3)>>3]- +h[q+(la+(c[d>>2]|0)<<3)>>3];h[37699]=N;R=+h[37694]*+h[g+((c[n>>2]|0)+z+(fa(ta,y)|0)<<3)>>3];h[s+(la<<3)>>3]=R+N*+h[37703];la=ta+1|0;c[75330]=la;if((ta|0)>=(Na|0)){break b}S=+h[37716];G=+h[37715];ta=la}}}while(0);Na=c[d>>2]|0;c[75334]=1;if((Na|0)>=1){Ma=1;while(1){h[37695]=0.0;ta=c[b>>2]|0;c[75332]=1;if((ta|0)<1){fb=0.0}else{G=0.0;la=1;while(1){S=+h[f+((fa(la,w)|0)+x+Ma<<3)>>3];gb=G+S*+h[p+(la+ -1<<3)>>3];h[37695]=gb;if((la|0)<(ta|0)){la=la+1|0;G=gb}else{break}}c[75332]=ta+1;fb=gb}la=c[b>>2]|0;G=fb*(+h[37694]*+h[p+(la+ -1+Ma<<3)>>3]- +h[37703]*+h[q+(Ma+ -1<<3)>>3]);h[37699]=G;c[75330]=1;if((la|0)>=1){S=G;I=1;while(1){G=S*+h[f+((fa(I,w)|0)+x+Ma<<3)>>3];Ca=s+(I+ -1<<3)|0;h[Ca>>3]=+h[Ca>>3]+G;if((I|0)>=(la|0)){break}S=+h[37699];I=I+1|0}c[75330]=la+1}I=Ma+1|0;c[75334]=I;if((Ma|0)<(Na|0)){Ma=I}else{break}}}h[37674]=0.0;h[37670]=0.0;Ma=c[b>>2]|0;c[75330]=1;if((Ma|0)<1){hb=0.0;ib=0.0}else{S=0.0;G=0.0;Na=1;while(1){N=+h[s+(Na+ -1<<3)>>3];jb=G+N*N;h[37674]=jb;I=Na+ -1|0;kb=S+ +h[o+(I<<3)>>3]*+h[s+(I<<3)>>3];h[37670]=kb;if((Na|0)<(Ma|0)){Na=Na+1|0;G=jb;S=kb}else{break}}c[75330]=Ma+1;hb=kb;ib=jb}S=+h[37668];G=S*ib-hb*hb;h[37719]=G;if(!(G>=S*1.0e-8*ib)){break}ea=hb;da=S;ga=G;C=ma+1|0}a[301376]=1;C=c[l>>2]|0;c[75334]=1;if((C|0)<1){lb=301472;mb=+h[37684];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}else{vb=1}while(1){h[p+(vb+ -1<<3)>>3]=0.0;l=1;do{ga=+h[t+((fa(l,y)|0)+z+vb<<3)>>3];s=p+(vb+ -1<<3)|0;h[s>>3]=+h[s>>3]+ga*+h[301480+(l+ -1<<3)>>3];l=l+1|0;}while((l|0)<6);if((vb|0)<(C|0)){vb=vb+1|0}else{break}}c[75332]=6;c[75334]=C+1;lb=301472;mb=+h[37684];nb=c[m>>2]|0;ob=nb+ -1|0;pb=q;qb=ob<<3;rb=pb+qb|0;sb=rb;tb=+h[sb>>3];ub=mb+tb;h[sb>>3]=ub;i=v;return 0}function hDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;var v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0,Z=0.0,_=0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0;v=i;w=c[d>>2]|0;x=~w;y=c[l>>2]|0;l=~y;h[37751]=.5;h[37747]=1.0;h[37763]=6.283185307179586;z=+h[n>>3];h[37760]=z*z;A=w+ -1-(c[b>>2]|0)|0;c[75508]=A;c[75516]=0;B=c[d>>2]|0;c[75468]=1;if((B|0)>=1){C=1;while(1){h[q+(C+ -1<<3)>>3]=0.0;if((C|0)<(B|0)){C=C+1|0}else{break}}c[75468]=B+1}c[75466]=1;B=c[m>>2]|0;if((A|0)<1){D=B}else{C=B;B=1;while(1){E=fa(B,w)|0;z=+h[j+(E+x+C<<3)>>3];h[37752]=z;if((B|0)<(c[k>>2]|0)){F=-z;h[37752]=F;G=F}else{G=z}H=c[d>>2]|0;c[75468]=1;if((H|0)>=1){z=G;I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]+z*+h[j+(I+x+E<<3)>>3];if((I|0)>=(H|0)){break}z=+h[37752];I=I+1|0}c[75468]=H+1}I=B+1|0;c[75466]=I;E=c[m>>2]|0;if((B|0)<(A|0)){C=E;B=I}else{D=E;break}}}h[p>>3]=+h[q+(D+ -1<<3)>>3];h[37735]=0.0;D=c[b>>2]|0;c[75464]=1;if((D|0)>=1){p=1;while(1){B=c[m>>2]|0;G=+h[f+((fa(p,w)|0)+x+B<<3)>>3];C=p+ -1|0;A=o+(C<<3)|0;h[A>>3]=G- +h[e+(C<<3)>>3];h[r+(C<<3)>>3]=+h[g+(B+l+(fa(p,y)|0)<<3)>>3];h[s+(C<<3)>>3]=0.0;G=+h[A>>3];h[37735]=+h[37735]+G*G;A=p+1|0;c[75464]=A;if((p|0)<(D|0)){p=A}else{break}}}p=c[d>>2]|0;c[75468]=1;if((p|0)>=1){D=1;while(1){h[37752]=0.0;h[37750]=0.0;y=c[b>>2]|0;c[75466]=1;if((y|0)<1){K=0.0;L=0.0}else{l=D+x|0;G=0.0;z=0.0;g=1;while(1){F=+h[f+((fa(g,w)|0)+x+D<<3)>>3];M=z+F*+h[e+(g+ -1<<3)>>3];h[37752]=M;F=+h[f+(l+(fa(g,w)|0)<<3)>>3];N=G+F*+h[o+(g+ -1<<3)>>3];h[37750]=N;if((g|0)<(y|0)){g=g+1|0;z=M;G=N}else{break}}c[75466]=y+1;K=M;L=N}g=q+(D+ -1<<3)|0;G=+h[g>>3]*K;h[37752]=G;h[37750]=+h[g>>3]*L;g=c[b>>2]|0;c[75464]=1;if((g|0)>=1){l=D+x|0;z=G;H=1;while(1){G=z*+h[f+((fa(H,w)|0)+x+D<<3)>>3];m=r+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;G=+h[37750]*+h[f+(l+(fa(H,w)|0)<<3)>>3];m=s+(H+ -1<<3)|0;h[m>>3]=+h[m>>3]+G;if((H|0)>=(g|0)){break}z=+h[37752];H=H+1|0}c[75464]=g+1}H=D+1|0;c[75468]=H;if((D|0)<(p|0)){D=H}else{break}}}h[37736]=0.0;h[37738]=0.0;h[37745]=0.0;D=c[b>>2]|0;c[75464]=1;if((D|0)<1){O=0.0;P=0.0;Q=0.0}else{L=0.0;K=0.0;N=0.0;p=1;while(1){M=+h[r+(p+ -1<<3)>>3];R=N+M*M;h[37736]=R;e=p+ -1|0;H=o+(e<<3)|0;S=K+ +h[H>>3]*+h[r+(e<<3)>>3];h[37738]=S;T=L+ +h[H>>3]*+h[s+(e<<3)>>3];h[37745]=T;if((p|0)<(D|0)){p=p+1|0;N=R;K=S;L=T}else{break}}c[75464]=D+1;O=R;P=T;Q=S}S=+h[37735];T=+h[n>>3]/+V(+S);if(Q*P<0.0){U=-T}else{U=T}h[37756]=U;h[37752]=0.0;if(Q*Q>S*.99*O){h[37752]=+h[37747]}if(!(Q>=0.0)){W=-Q}else{W=Q}if(!(P>=0.0)){Z=-P}else{Z=P}P=U*(W+ +h[37751]*U*Z);h[37748]=P;if(O*+h[37760]<P*P*.01){h[37752]=+h[37747]}n=c[b>>2]|0;c[75464]=1;if((n|0)<1){_=0}else{P=U;D=1;p=0;while(1){e=o+(p<<3)|0;h[e>>3]=P*+h[e>>3];e=D+ -1|0;H=s+(e<<3)|0;U=+h[37756]*+h[H>>3];h[H>>3]=U;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+ +h[37752]*U;if((D|0)>=(n|0)){break}e=D;P=+h[37756];D=D+1|0;p=e}c[75464]=n+1;_=0}while(1){n=_+1|0;c[75516]=n;h[37735]=0.0;h[37738]=0.0;h[37739]=0.0;p=c[b>>2]|0;c[75464]=1;if((p|0)<1){$=0.0;aa=0.0;ba=0.0}else{P=0.0;U=0.0;O=0.0;D=1;while(1){Z=+h[o+(D+ -1<<3)>>3];ca=O+Z*Z;h[37735]=ca;e=D+ -1|0;H=t+(e<<3)|0;da=U+ +h[o+(e<<3)>>3]*+h[H>>3];h[37738]=da;Z=+h[H>>3];ea=P+Z*Z;h[37739]=ea;if((D|0)<(p|0)){D=D+1|0;O=ca;U=da;P=ea}else{break}}c[75464]=p+1;$=da;aa=ea;ba=ca}P=ba*aa-$*$;h[37752]=P;if(P<=ba*1.0e-8*aa){ga=88;break}U=+V(+P);h[37757]=U;D=c[b>>2]|0;c[75464]=1;if((D|0)>=1){P=U;U=$;O=ba;g=1;H=0;while(1){e=t+(H<<3)|0;h[e>>3]=(O*+h[e>>3]-U*+h[o+(H<<3)>>3])/P;h[u+(g+ -1<<3)>>3]=0.0;if((g|0)>=(D|0)){break}e=g;P=+h[37757];U=+h[37738];O=+h[37735];g=g+1|0;H=e}c[75464]=D+1}H=c[d>>2]|0;c[75468]=1;if((H|0)>=1){g=1;while(1){h[37750]=0.0;p=c[b>>2]|0;c[75466]=1;if((p|0)<1){ha=0.0}else{O=0.0;e=1;while(1){U=+h[f+((fa(e,w)|0)+x+g<<3)>>3];ia=O+U*+h[t+(e+ -1<<3)>>3];h[37750]=ia;if((e|0)<(p|0)){e=e+1|0;O=ia}else{break}}c[75466]=p+1;ha=ia}O=+h[q+(g+ -1<<3)>>3]*ha;h[37750]=O;e=c[b>>2]|0;c[75464]=1;if((e|0)>=1){U=O;l=1;while(1){O=U*+h[f+((fa(l,w)|0)+x+g<<3)>>3];y=u+(l+ -1<<3)|0;h[y>>3]=+h[y>>3]+O;if((l|0)>=(e|0)){break}U=+h[37750];l=l+1|0}c[75464]=e+1}l=g+1|0;c[75468]=l;if((g|0)<(H|0)){g=l}else{break}}}h[37740]=0.0;h[37741]=0.0;h[37742]=0.0;h[37743]=0.0;h[37744]=0.0;g=c[b>>2]|0;c[75464]=1;if((g|0)<1){ja=0.0;ka=0.0;la=0.0;ma=0.0;na=0.0}else{U=0.0;O=0.0;P=0.0;Z=0.0;W=0.0;H=1;while(1){D=H+ -1|0;oa=W+ +h[t+(D<<3)>>3]*+h[u+(D<<3)>>3];h[37740]=oa;D=H+ -1|0;l=o+(D<<3)|0;p=r+(D<<3)|0;pa=Z+ +h[l>>3]*+h[p>>3];h[37741]=pa;y=t+(D<<3)|0;qa=P+ +h[y>>3]*+h[p>>3];h[37742]=qa;p=s+(D<<3)|0;ra=O+ +h[l>>3]*+h[p>>3];h[37743]=ra;sa=U+ +h[y>>3]*+h[p>>3];h[37744]=sa;if((H|0)<(g|0)){H=H+1|0;W=oa;Z=pa;P=qa;O=ra;U=sa}else{break}}c[75464]=g+1;ja=sa;ka=qa;la=pa;ma=ra;na=oa}U=+h[37751];O=U*na;h[37740]=O;P=U*ma-O;h[37743]=P;Z=O+la+P;h[37764]=Z;h[37766]=Z;h[37765]=Z;c[75518]=0;a[301896]=1;W=+h[37763]/50.0;h[37752]=W;c[75464]=1;H=0;Q=Z;S=Z;p=1;while(1){ta=+(p|0)*W;ua=+X(+ta);va=+Y(+ta);wa=O+ua*(la+ua*P)+va*(ka+ua*ja);if(!(wa>=0.0)){xa=-wa}else{xa=wa}if(!(Q>=0.0)){ya=-Q}else{ya=Q}do{if(xa>ya){h[37766]=wa;c[75518]=p;h[37761]=S;za=p;Aa=wa}else{if((p|0)!=(H+1|0)){za=H;Aa=Q;break}h[37762]=wa;za=H;Aa=Q}}while(0);e=p+1|0;if((e|0)<50){H=za;Q=Aa;p=e;S=wa}else{break}}h[37755]=ta;h[37746]=ua;h[37749]=va;h[37748]=wa;c[75464]=50;h[37765]=wa;if((za|0)==49){h[37762]=Z;Ba=Z}else if((za|0)==0){h[37761]=wa;ga=74}else{ga=74}if((ga|0)==74){ga=0;Ba=+h[37762]}h[37753]=0.0;S=+h[37761];if(S!=Ba){Q=S-Aa;h[37761]=Q;S=Ba-Aa;h[37762]=S;T=U*(Q-S)/(Q+S);h[37753]=T;Ca=T}else{Ca=0.0}T=W*(+(za|0)+Ca);h[37755]=T;S=+X(+T);h[37746]=S;Q=+Y(+T);h[37749]=Q;T=O+S*(la+S*P)+Q*(ka+S*ja);h[37748]=T;p=c[b>>2]|0;c[75464]=1;if((p|0)<1){Da=T}else{T=Q;Q=S;H=1;g=0;while(1){e=o+(g<<3)|0;h[e>>3]=Q*+h[e>>3]+T*+h[t+(g<<3)>>3];e=H+ -1|0;y=s+(e<<3)|0;S=+h[37746]*+h[y>>3]+ +h[37749]*+h[u+(e<<3)>>3];h[y>>3]=S;h[t+(e<<3)>>3]=+h[r+(e<<3)>>3]+S;if((H|0)>=(p|0)){break}e=H;T=+h[37749];Q=+h[37746];H=H+1|0;g=e}c[75464]=p+1;Da=+h[37748]}if(!(Da>=0.0)){Ea=-Da}else{Ea=Da}Q=+h[37764];if(!(Q>=0.0)){Fa=-Q}else{Fa=Q}if(Ea<=Fa*1.1){ga=88;break}if((n|0)<(c[b>>2]|0)){_=n}else{ga=88;break}}if((ga|0)==88){i=v;return 0}return 0}function iDc(b,d,e,f,g,h,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0;n=i;a[302352]=1;a[302344]=1;c[302364>>2]=6;MUc(302360)|0;e=c[d>>2]|0;c[75584]=1;if((e|0)>=1){d=1;do{bUc(302480,b+(d+ -1)|0,1)|0;o=c[75584]|0;d=o+1|0;c[75584]=d;}while((o|0)<(e|0))}uUc()|0;e=c[g>>2]|0;if((e|0)==1){c[302388>>2]=a[302344]&1?6:0;MUc(302384)|0;bUc(302480,h,4)|0;uUc()|0;p=c[g>>2]|0}else{p=e}if((p|0)==2){c[302412>>2]=a[302344]&1?6:0;MUc(302408)|0;bUc(302480,h,4)|0;bUc(302480,j,4)|0;uUc()|0}j=c[k>>2]|0;if((j|0)==1){c[302436>>2]=a[302344]&1?6:0;MUc(302432)|0;bUc(302480,l,8)|0;uUc()|0;q=c[k>>2]|0}else{q=j}if((q|0)==2){c[302460>>2]=a[302344]&1?6:0;MUc(302456)|0;bUc(302480,l,8)|0;bUc(302480,m,8)|0;uUc()|0}if((c[f>>2]|0)==2){LTc(302488,0)|0}else{i=n;return 0}return 0}function jDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0,T=0.0,U=0.0,V=0.0,W=0.0,X=0,Y=0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0,la=0,ma=0,na=0,oa=0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0.0,wa=0.0,xa=0.0,ya=0.0;y=i;i=i+8|0;z=y;A=c[k>>2]|0;a:do{if((A|0)==1){c[q+36>>2]=c[q+40>>2];B=27}else if((A|0)==-1){STc(302560,302792,80,49);C=302864;D=302872;iDc(302560,302848,302856,C,C,C,C,C,D,D,80)|0;STc(302560,302880,80,47);D=302864;C=302872;iDc(302560,302928,302936,D,302944,n,D,D,C,C,80)|0;STc(302560,302952,80,41);C=302864;D=302872;iDc(302560,303e3,303008,302944,C,C,C,C,D,D,80)|0;i=y;return 0}else if((A|0)==0){c[75626]=2;D=2;while(1){C=D+1|0;if(!((c[k+(D+ -1<<2)>>2]|0)>>>0<2)){B=210;break a}c[75626]=C;if((C|0)<12){D=C}else{break}}if((c[d>>2]|0)<1){STc(302560,304256,80,25);D=302864;C=302872;iDc(302560,304288,303040,D,302944,d,D,D,C,C,80)|0;break}c[75690]=5;C=q+8|0;do{if((c[k+32>>2]|0)==0){E=5}else{D=c[C>>2]|0;c[75690]=D;if(!((D+ -1|0)>>>0>4)){E=D;break}STc(302560,304296,80,34);D=302864;F=302872;iDc(302560,304336,303032,D,302944,302760,D,D,F,F,80)|0;break a}}while(0);c[C>>2]=E;b:do{if((c[k+20>>2]|0)==0){F=c[d>>2]|0;D=fa(F,F)|0;c[75676]=D;c[75688]=D+50+(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0);D=q+12|0;if((c[k+16>>2]|0)==0){c[D>>2]=2;break}else{c[D>>2]=1;break}}else{D=c[q>>2]|0;do{if((D|0)>=0){F=c[d>>2]|0;if((D|0)>=(F|0)){break}G=q+4|0;H=c[G>>2]|0;if(!((H|0)>-1&(H|0)<(F|0))){STc(302560,305120,80,52);I=302864;J=302872;iDc(302560,305104,305176,I,302944,G,I,I,J,J,80)|0;break a}c[75676]=fa((D<<1|1)+H|0,F)|0;F=q+12|0;if((c[k+16>>2]|0)==0){c[F>>2]=5;H=c[d>>2]|0;J=fa((c[C>>2]|0)+4|0,H)|0;c[75688]=(((H|0)/((c[q>>2]|0)+1+(c[G>>2]|0)|0)|0)<<1)+52+(c[75676]|0)+J;break b}else{c[F>>2]=4;F=(fa((c[C>>2]|0)+4|0,c[d>>2]|0)|0)+50|0;c[75688]=F+(c[75676]|0);break b}}}while(0);STc(302560,305048,80,52);D=302864;F=302872;iDc(302560,305104,305112,D,302944,q,D,D,F,F,80)|0;break a}}while(0);c[75680]=(c[d>>2]|0)+20;c[q+64>>2]=c[75676];if((c[p>>2]|0)<(c[75688]|0)){STc(302560,304344,80,60);C=302864;F=302872;iDc(302560,304408,304416,C,303040,302752,p,C,F,F,80)|0;break}if((c[r>>2]|0)<(c[75680]|0)){STc(302560,304424,80,60);F=302864;C=302872;iDc(302560,304408,304488,F,303040,302720,r,F,C,C,80)|0;break}if(+h[j>>3]==+h[e>>3]){B=227;break}if((c[w>>2]|0)<0){STc(302560,305232,80,24);C=302944;F=302864;D=302872;iDc(302560,305264,305272,C,C,w,F,F,D,D,80)|0;break}do{if((c[k+24>>2]|0)!=0){K=+h[o+8>>3];h[37835]=K;if(!(K<=0.0)){break}STc(302560,304728,80,28);D=302864;iDc(302560,303440,304760,D,D,D,D,302944,302680,302872,80)|0;break a}}while(0);c[q+60>>2]=0;D=q+36|0;c[D+0>>2]=0;c[D+4>>2]=0;c[D+8>>2]=0;c[D+12>>2]=0;c[n>>2]=1;B=27}else{B=210}}while(0);c:do{if((B|0)==27){a[302736]=0;K=+h[l>>3];h[37846]=K;L=+h[m>>3];h[37839]=L;r=c[d>>2]|0;c[75626]=1;do{if((r|0)>=1){p=k+4|0;E=0;A=1;M=L;N=K;while(1){if((c[p>>2]|0)==1){D=A+ -1|0;O=+h[l+(D<<3)>>3];h[37846]=O;P=+h[m+(D<<3)>>3];h[37839]=P;Q=O;R=P}else{Q=N;R=M}if(Q>0.0|R>0.0){a[302736]=1;S=1}else{S=E}if(Q<0.0){B=215;break}if(R<0.0){B=216;break}D=A+1|0;c[75626]=D;if((A|0)<(r|0)){E=S;A=D;M=R;N=Q}else{B=36;break}}if((B|0)==36){if(!S){break}A=c[d>>2]|0;E=A+51|0;c[75636]=E;p=E+(c[w>>2]|0)|0;c[75638]=p;E=p+(c[w>>2]|0)|0;c[75660]=E;D=E+(c[w>>2]|0)|0;c[75630]=D;F=D+(c[d>>2]|0)|0;c[75666]=F;C=F+(c[d>>2]|0)|0;c[75672]=C;c[75662]=(fa((c[q+8>>2]|0)+1|0,c[d>>2]|0)|0)+C;c[75686]=(c[q+64>>2]|0)+1;d:do{if((c[k>>2]|0)==1){F=o+64|0;h[37848]=+h[F>>3];a[302672]=0;h[37817]=+h[o+24>>3];J=o+16|0;h[37812]=+h[J>>3];do{if((c[w>>2]|0)!=0){kDc(303040,v,w,d,302536,j,f,o+(D+ -1<<3)|0,o+(C+ -1<<3)|0,o+224|0,q+28|0,o+(A+50<<3)|0,o+(p+ -1<<3)|0,o+(E+ -1<<3)|0,x,302656,F,0,o,q,s,t)|0;if((c[75756]|0)>0){i=y;return 0}if((c[75664]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];G=302944;HDc(d,o+((c[75630]|0)+ -1<<3)|0,G,g,G)|0;a[302672]=1;B=197;break d}}while(0);do{if((c[k+24>>2]|0)!=0){N=+h[37812];if(!(N>=0.0)){T=-N}else{T=N}M=T/+h[o+8>>3];if(!(M>1.0)){break}h[37812]=N/M}}while(0);M=+h[e>>3];N=+h[j>>3];if(M==N){B=227;break c}P=+h[37812];if((M-N)*P>0.0){B=220;break}F=(c[k+8>>2]|0)==1;do{if((c[k+12>>2]|0)==1){O=+h[o>>3];h[37847]=O;U=+h[37817];V=U-O;G=V*P>0.0;do{if(F){if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U- +h[e>>3])<=0.0){break}H=q+28|0;I=o+((c[75672]|0)+ -1<<3)|0;X=o+224|0;if(P*(U-W)>0.0){pDc(302536,j,f,g,d,H,I,X)|0;if((c[75756]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[302672]=1;B=197;break d}}else{Y=302536;pDc(Y,Y,f,g,d,H,I,X)|0;if((c[75756]|0)>0){i=y;return 0}else{h[e>>3]=+h[37817];c[n>>2]=1;a[302672]=1;B=197;break d}}}else{if(G){B=224;break d}W=+h[j>>3];if(P*(O-W)<0.0){B=218;break d}if(P*(U-W)<0.0){break}pDc(302536,j,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[302672]=1;B=197;break d}}}while(0);h[z>>3]=V;if(!(V>=0.0)){Z=-V}else{Z=V}if(!(U>=0.0)){_=-U}else{_=U}if(!(P>=0.0)){$=-P}else{$=P}if(Z>+h[37848]*100.0*(_+$)){if(P*(U+P-O)<=0.0){break}W=O-U;h[37812]=W;h[J>>3]=W;break}pDc(302536,302776,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){i=y;return 0}else{c[n>>2]=2;h[e>>3]=+h[37847];a[302672]=1;B=197;break d}}else{W=+h[37817];if(!F){if(P*(W-N)<0.0){break}pDc(302536,j,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[302672]=1;B=197;break d}}if(P*(W-M)<=0.0){break}G=q+28|0;X=o+((c[75672]|0)+ -1<<3)|0;I=o+224|0;if(P*(W-N)>0.0){pDc(302536,j,f,g,d,G,X,I)|0;if((c[75756]|0)>0){i=y;return 0}else{h[e>>3]=+h[j>>3];c[n>>2]=3;a[302672]=1;B=197;break d}}else{H=302536;pDc(H,H,f,g,d,G,X,I)|0;if((c[75756]|0)>0){i=y;return 0}else{h[e>>3]=+h[37817];c[n>>2]=1;a[302672]=1;B=197;break d}}}}while(0);if(a[302672]&1){B=197}else{B=128}}else{h[37817]=+h[e>>3];c[n>>2]=1;mDc(d,k+4|0,l,m,f,o+((c[75666]|0)+ -1<<3)|0,s,t)|0;F=c[d>>2]|0;c[75626]=1;e:do{if((F|0)>=1){J=c[75666]|0;I=1;while(1){X=I+1|0;if(+h[o+(I+ -2+J<<3)>>3]<=0.0){break}c[75626]=X;if((I|0)<(F|0)){I=X}else{break e}}STc(302560,304864,80,39);I=302864;J=302872;iDc(302560,304536,304904,I,I,I,I,I,J,J,80)|0;break c}}while(0);U=+tDc(303016,1);h[37848]=U;F=o+64|0;h[F>>3]=U;U=+h[e>>3];if(!(U>=0.0)){aa=-U}else{aa=U}h[z>>3]=aa;U=+h[j>>3];if(!(U>=0.0)){ba=-U}else{ba=U}U=+h[37848]*4.0*(aa>=ba?aa:ba);h[37837]=U;O=+h[j>>3]- +h[e>>3];h[z>>3]=O;if(!(O>=0.0)){ca=-O}else{ca=O}if(ca<U){STc(302560,304912,80,60);J=302864;iDc(302560,304408,304976,J,J,J,J,303040,j,e,80)|0;break c}do{if((c[k+28>>2]|0)==0){h[37816]=ca*.001;U=+nDc(d,g,o+((c[75666]|0)+ -1<<3)|0,s,t);if(U>.5/+h[37816]){h[37816]=.5/U}h[z>>3]=+h[j>>3]- +h[e>>3];U=+PTc(302528,z);h[37816]=U;da=U}else{U=+h[o+16>>3];h[37816]=U;if(U*(+h[j>>3]- +h[e>>3])<0.0){B=220;break d}if(!(U==0.0)){da=U;break}STc(302560,304816,80,29);J=302864;I=302872;iDc(302560,304848,304856,J,J,J,J,J,I,I,80)|0;break c}}while(0);do{if((c[k+24>>2]|0)==0){ea=da}else{if(!(da>=0.0)){ga=-da}else{ga=da}U=ga/+h[o+8>>3];if(!(U>1.0)){ea=da;break}O=da/U;h[37816]=O;ea=O}}while(0);if((c[k+12>>2]|0)==0){ha=ea}else{O=+h[o>>3];h[37847]=O;U=+h[e>>3];V=O-U;if(V*ea<0.0){B=224;break}if(ea*(U+ea-O)>0.0){h[37816]=V;ia=V}else{ia=ea}if((O- +h[j>>3])*ia<0.0){B=218;break}else{ha=ia}}I=k+40|0;if((c[I>>2]|0)==0){ja=ha}else{oDc(302536,f,g,d,b,u,302528,o+((c[75666]|0)+ -1<<3)|0,n,s,t,o+((c[75672]|0)+ -1<<3)|0,o+400|0,o+((c[75630]|0)+ -1<<3)|0,o+((c[75662]|0)+ -1<<3)|0,q,302696,F,k+36|0,302744)|0;if((c[75756]|0)>0){i=y;return 0}J=c[n>>2]|0;if((J|0)<0){ka=J;B=129;break}ja=+h[37816]}h[37812]=ja;h[o+16>>3]=ja;J=c[75672]|0;X=(c[d>>2]|0)+J|0;c[75682]=X;G=c[d>>2]|0;c[75626]=1;if((G|0)>=1){H=1;while(1){h[o+(H+ -2+J<<3)>>3]=+h[f+(H+ -1<<3)>>3];h[o+(H+ -2+X<<3)>>3]=+h[37812]*+h[g+(H+ -1<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[75626]=G+1}H=o+320|0;h[H>>3]=+h[e>>3];X=q+68|0;c[X>>2]=0;J=o+224|0;h[J>>3]=+h[37812];h[o+232>>3]=+h[37812]*2.0;Y=q+28|0;c[Y>>2]=1;if((c[w>>2]|0)==0){B=128;break}kDc(302944,v,w,d,e,j,f,o+((c[75630]|0)+ -1<<3)|0,o+((c[75672]|0)+ -1<<3)|0,J,Y,o+((c[75636]|0)+ -1<<3)|0,o+((c[75638]|0)+ -1<<3)|0,o+((c[75660]|0)+ -1<<3)|0,x,302656,F,0,o,q,s,t)|0;if((c[75756]|0)>0){i=y;return 0}if((c[75664]|0)!=0){STc(302560,305280,80,47);la=302864;ma=302872;iDc(302560,302928,305328,302944,la,la,la,la,ma,ma,80)|0;STc(302560,305336,80,38);ma=302864;la=302872;iDc(302560,303088,305328,302944,ma,ma,ma,ma,la,la,80)|0;break c}if((c[w>>2]|0)==0){B=128;break}if((c[I>>2]|0)==0){B=128;break}kDc(303032,v,w,d,302536,j,f,o+((c[75630]|0)+ -1<<3)|0,o+((c[75672]|0)+ -1<<3)|0,J,Y,o+((c[75636]|0)+ -1<<3)|0,o+((c[75638]|0)+ -1<<3)|0,o+((c[75660]|0)+ -1<<3)|0,x,302656,F,0,o,q,s,t)|0;if((c[75756]|0)>0){i=y;return 0}if((c[75664]|0)!=1){B=128;break}c[X>>2]=1;c[n>>2]=4;h[e>>3]=+h[H>>3];H=302944;HDc(d,o+((c[75630]|0)+ -1<<3)|0,H,g,H)|0;B=197}}while(0);if((B|0)==218){STc(302560,304656,80,54);E=302864;iDc(302560,304712,304720,E,E,E,E,303040,302776,j,80)|0;break c}else if((B|0)==220){STc(302560,304768,80,34);E=302864;iDc(302560,304336,304808,E,E,E,E,303040,j,e,80)|0;break c}else if((B|0)==224){STc(302560,304984,80,49);E=302864;iDc(302560,302848,305040,E,E,E,E,303040,302776,e,80)|0;break c}f:while(1){if((B|0)==128){B=0;ka=c[n>>2]|0;B=129;continue}else if((B|0)==129){B=0;if((ka|0)==-12){na=-12;break}if(((c[q+40>>2]|0)-(c[q+36>>2]|0)|0)>=500){B=131;break}oa=k+4|0;mDc(d,oa,l,m,o+((c[75672]|0)+ -1<<3)|0,o+((c[75666]|0)+ -1<<3)|0,s,t)|0;if((c[75756]|0)>0){B=233;break}E=c[d>>2]|0;c[75626]=1;p=c[75666]|0;if((E|0)>=1){A=1;while(1){C=A+1|0;if(!(+h[o+(A+ -2+p<<3)>>3]>0.0)){B=136;break f}c[75626]=C;if((A|0)<(E|0)){A=C}else{break}}}O=+nDc(d,o+((c[75672]|0)+ -1<<3)|0,o+(p+ -1<<3)|0,s,t)*100.0;V=+h[37848];pa=O*V;h[37814]=pa;if(!(pa<=1.0)){B=138;break}O=+h[37817];if(!(O>=0.0)){qa=-O}else{qa=O}h[z>>3]=qa;O=+h[j>>3];if(!(O>=0.0)){ra=-O}else{ra=O}h[37837]=V*4.0*(qa>=ra?qa:ra);do{if((c[k+24>>2]|0)!=0){V=+h[37812];if(!(V>=0.0)){sa=-V}else{sa=V}O=sa/+h[o+8>>3];if(!(O>1.0)){break}h[37812]=V/O}}while(0);qDc(302536,f,g,d,b,u,302496,o+((c[75666]|0)+ -1<<3)|0,k,n,s,t,o+((c[75672]|0)+ -1<<3)|0,o+400|0,o+((c[75630]|0)+ -1<<3)|0,o+((c[75662]|0)+ -1<<3)|0,q,o+80|0,o+128|0,o+176|0,o+224|0,o+272|0,o+32|0,o+40|0,o+48|0,o+56|0,302696,o+64|0,q+20|0,q+16|0,q+24|0,q+28|0,q+32|0,k+36|0,302744)|0;if((c[75756]|0)>0){B=233;break}p=c[n>>2]|0;if((p|0)<0){na=p;break}do{if((c[w>>2]|0)!=0){kDc(303032,v,w,d,302536,j,f,o+((c[75630]|0)+ -1<<3)|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0,q+28|0,o+((c[75636]|0)+ -1<<3)|0,o+((c[75638]|0)+ -1<<3)|0,o+((c[75660]|0)+ -1<<3)|0,x,302656,o+64|0,0,o,q,s,t)|0;if((c[75756]|0)>0){B=233;break f}if((c[75664]|0)!=1){break}c[q+68>>2]=1;c[n>>2]=4;h[e>>3]=+h[o+320>>3];p=302944;HDc(d,o+((c[75630]|0)+ -1<<3)|0,p,g,p)|0;B=197;continue f}}while(0);p=(c[k+8>>2]|0)!=0;O=+h[37817];V=+h[37812];U=(O- +h[j>>3])*V;if((c[k+12>>2]|0)==0){if(!p){if(U<0.0){B=128;continue}pDc(302536,j,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(!(U>=0.0)){h[e>>3]=O;c[n>>2]=1;B=197;continue}pDc(302536,j,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){B=233;break}c[n>>2]=3;h[e>>3]=+h[j>>3];B=197;continue}if(p){if(U>=0.0){pDc(302536,j,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}N=O- +h[37847];h[z>>3]=N;if(!(N>=0.0)){ta=-N}else{ta=N}if(!(O>=0.0)){ua=-O}else{ua=O}if(!(V>=0.0)){va=-V}else{va=V}if(!(ta<=+h[37848]*100.0*(ua+va))){h[e>>3]=O;c[n>>2]=1;B=197;continue}pDc(302536,302776,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[37847];B=197;continue}if(!(U<0.0)){pDc(302536,j,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){B=233;break}h[e>>3]=+h[j>>3];c[n>>2]=3;B=197;continue}U=+h[37847];N=O-U;h[z>>3]=N;if(!(N>=0.0)){wa=-N}else{wa=N}if(!(O>=0.0)){xa=-O}else{xa=O}if(!(V>=0.0)){ya=-V}else{ya=V}if(!(wa<=+h[37848]*100.0*(xa+ya))){if(V*(O+V-U)<=0.0){B=128;continue}h[37812]=U-O;B=128;continue}else{pDc(302536,302776,f,g,d,q+28|0,o+((c[75672]|0)+ -1<<3)|0,o+224|0)|0;if((c[75756]|0)>0){B=233;break}c[n>>2]=2;h[e>>3]=+h[37847];B=197;continue}}else if((B|0)==197){B=0;h[o+24>>3]=+h[37817];h[o+16>>3]=+h[37812];h[o+328>>3]=+h[e>>3];B=233;break}}do{if((B|0)==131){c[n>>2]=-1;na=-1}else if((B|0)==136){c[n>>2]=-3;na=-3}else if((B|0)==138){if((c[oa>>2]|0)!=1){h[l>>3]=pa*+h[l>>3];h[m>>3]=+h[37814]*+h[m>>3];c[n>>2]=-2;na=-2;break}p=c[d>>2]|0;c[75626]=1;if((p|0)>=1){O=pa;A=1;E=0;while(1){F=l+(E<<3)|0;h[F>>3]=O*+h[F>>3];F=m+(A+ -1<<3)|0;h[F>>3]=+h[37814]*+h[F>>3];if((A|0)>=(p|0)){break}F=A;O=+h[37814];A=A+1|0;E=F}c[75626]=p+1}c[n>>2]=-2;na=-2}else if((B|0)==233){i=y;return 0}}while(0);E=0-na|0;c[75682]=E;switch(E|0){case 2:{STc(302560,303176,80,47);E=302864;iDc(302560,302928,303224,E,E,E,E,302944,302536,302872,80)|0;STc(302560,303232,80,48);E=302864;A=302872;iDc(302560,303160,303288,E,E,E,E,E,A,A,80)|0;STc(302560,303296,80,45);A=302864;E=302872;iDc(302560,303344,303352,A,A,A,A,A,E,E,80)|0;break};case 3:{STc(302560,303360,80,38);E=302864;iDc(302560,303088,303400,E,E,E,E,302944,302536,302872,80)|0;STc(302560,303408,80,28);E=302864;A=302872;iDc(302560,303440,303448,E,E,E,E,E,A,A,80)|0;break};case 10:{STc(302560,303456,80,44);A=302864;iDc(302560,303504,303896,A,A,A,A,303040,302536,302496,80)|0;STc(302560,303904,80,45);A=302864;E=302872;iDc(302560,303344,303952,A,A,A,A,A,E,E,80)|0;STc(302560,303960,80,36);E=302864;A=302872;iDc(302560,304e3,304008,E,E,E,E,E,A,A,80)|0;break};case 11:{STc(302560,304016,80,40);A=302864;iDc(302560,304064,304072,A,A,A,A,303040,302536,302496,80)|0;STc(302560,304080,80,36);A=302864;E=302872;iDc(302560,304e3,304120,A,A,A,A,A,E,E,80)|0;break};case 12:{STc(302560,303456,80,44);E=302864;iDc(302560,303504,304128,E,E,E,E,303040,302536,302528,80)|0;STc(302560,304136,80,45);E=302864;A=302872;iDc(302560,303344,304184,E,E,E,E,E,A,A,80)|0;break};case 5:case 4:{break};case 6:{STc(302560,303456,80,44);A=302864;iDc(302560,303504,303512,A,A,A,A,303040,302536,302496,80)|0;STc(302560,303520,80,57);A=302864;E=302872;iDc(302560,303584,303592,A,A,A,A,A,E,E,80)|0;break};case 7:{STc(302560,303456,80,44);E=302864;iDc(302560,303504,303600,E,E,E,E,303040,302536,302496,80)|0;STc(302560,303608,80,48);E=302864;A=302872;iDc(302560,303160,303664,E,E,E,E,E,A,A,80)|0;STc(302560,303672,80,28);A=302864;E=302872;iDc(302560,303440,303704,A,A,A,A,A,E,E,80)|0;break};case 8:{STc(302560,303456,80,44);E=302864;iDc(302560,303504,303712,E,E,E,E,303040,302536,302496,80)|0;STc(302560,303720,80,37);E=302864;A=302872;iDc(302560,303760,303768,E,E,E,E,E,A,A,80)|0;break};case 9:{STc(302560,303456,80,44);A=302864;iDc(302560,303504,303776,A,A,A,A,303040,302536,302496,80)|0;STc(302560,303784,80,49);A=302864;E=302872;iDc(302560,302848,303840,A,A,A,A,A,E,E,80)|0;STc(302560,303848,80,38);E=302864;A=302872;iDc(302560,303088,303888,E,E,E,E,E,A,A,80)|0;break};default:{STc(302560,303048,80,38);A=302864;iDc(302560,303088,303096,A,A,A,A,302944,302536,302872,80)|0;STc(302560,303104,80,48);A=302864;E=302872;iDc(302560,303160,303168,A,A,A,A,A,E,E,80)|0}}c[k>>2]=-1;h[e>>3]=+h[37817];h[o+24>>3]=+h[37817];h[o+16>>3]=+h[37812];i=y;return 0}else if((B|0)==215){STc(302560,304496,80,39);E=302864;A=302872;iDc(302560,304536,304544,E,E,E,E,E,A,A,80)|0;break c}else if((B|0)==216){STc(302560,304552,80,39);A=302864;E=302872;iDc(302560,304536,304592,A,A,A,A,A,E,E,80)|0;break c}}}while(0);STc(302560,304600,80,47);r=302864;E=302872;iDc(302560,302928,304648,r,r,r,r,r,E,E,80)|0}else if((B|0)==210){STc(302560,304192,80,55);E=302864;r=302872;iDc(302560,304248,302944,E,E,E,E,E,r,r,80)|0}}while(0);if((B|0)==227){STc(302560,305184,80,39);B=302864;iDc(302560,304536,305224,B,B,B,B,303040,j,e,80)|0}if((c[k>>2]|0)==-1){STc(302560,305376,80,46);e=302864;j=302872;iDc(302560,305424,305432,e,e,e,e,e,j,j,80)|0;STc(302560,305440,80,47);j=302864;e=302872;iDc(302560,302928,305488,302944,j,j,j,j,e,e,80)|0;i=y;return 0}else{c[k>>2]=-1;c[n>>2]=-33;i=y;return 0}return 0}function kDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;var A=0,B=0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0,N=0.0,O=0,P=0,Q=0,R=0.0,S=0,T=0,U=0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0.0,aa=0,ba=0,ca=0,da=0,ea=0.0,fa=0,ga=0,ha=0;v=i;A=c[f>>2]|0;B=~A;C=+h[n>>3];h[38187]=C;c[t>>2]=0;D=c[e>>2]|0;c[76376]=1;if((D|0)>=1){E=1;do{c[s+(E+ -1<<2)>>2]=0;F=c[76376]|0;E=F+1|0;c[76376]=E;}while((F|0)<(D|0))}G=+h[g>>3];if(!(G>=0.0)){H=-G}else{H=G}if(!(C>=0.0)){I=-C}else{I=C}h[38194]=(H+I)*+h[u>>3]*100.0;u=c[b>>2]|0;do{if((u|0)==3){J=C;K=+h[g>>3]}else if((u|0)==2){do{if((c[x+68>>2]|0)!=0){b=w+320|0;pDc(g,b,k,l,f,o,m,n)|0;if((c[75756]|0)>0){i=v;return 0}D=d;be[D&7](f,b,k,e,p,y,z)|0;if((c[75756]|0)>0){i=v;return 0}E=x+60|0;c[E>>2]=(c[E>>2]|0)+1;a[305560]=0;F=c[e>>2]|0;c[76376]=1;if((F|0)<1){break}else{L=0;M=1}while(1){I=+h[p+(M+ -1<<3)>>3];if(!(I>=0.0)){N=-I}else{N=I}if(!(N<=0.0)){O=L}else{a[305560]=1;O=1}if((M|0)<(F|0)){L=O;M=M+1|0}else{break}}c[76376]=F+1;if(!O){break}I=+PTc(305552,305496);h[38191]=I;H=I+ +h[b>>3];h[b>>3]=H;I=+h[38187];do{if((H- +h[g>>3])*I<0.0){pDc(g,b,k,l,f,o,m,n)|0;if((c[75756]|0)<=0){break}i=v;return 0}else{G=+h[38191]/I;h[38192]=G;P=c[f>>2]|0;c[76376]=1;if((P|0)<1){break}Q=(A<<1)+B|0;R=G;S=1;while(1){T=k+(S+ -1<<3)|0;h[T>>3]=+h[T>>3]+R*+h[m+(Q+S<<3)>>3];if((S|0)>=(P|0)){break}R=+h[38192];S=S+1|0}c[76376]=P+1}}while(0);be[D&7](f,b,k,e,p,y,z)|0;if((c[75756]|0)>0){i=v;return 0}c[E>>2]=(c[E>>2]|0)+1;a[305560]=0;F=c[e>>2]|0;c[76376]=1;if((F|0)<1){break}else{U=0;V=1}while(1){S=V+ -1|0;I=+h[p+(S<<3)>>3];if(!(I>=0.0)){W=-I}else{W=I}if(W>0.0){X=U;Y=V}else{c[s+(S<<2)>>2]=1;a[305560]=1;X=1;Y=c[76376]|0}S=Y+1|0;c[76376]=S;if((Y|0)<(F|0)){U=X;V=S}else{break}}if(!X){break}c[t>>2]=1;i=v;return 0}}while(0);I=+h[g>>3];if(I==+h[w+328>>3]){i=v;return 0}else{J=+h[38187];K=I;break}}else{F=w+320|0;pDc(g,F,k,l,f,o,m,n)|0;if((c[75756]|0)>0){i=v;return 0}E=d;be[E&7](f,F,k,e,p,y,z)|0;if((c[75756]|0)>0){i=v;return 0}b=x+60|0;c[b>>2]=1;a[305560]=0;D=c[e>>2]|0;c[76376]=1;if((D|0)<1){i=v;return 0}else{Z=0;_=1}while(1){I=+h[p+(_+ -1<<3)>>3];if(!(I>=0.0)){$=-I}else{$=I}if(!($<=0.0)){aa=Z}else{a[305560]=1;aa=1}if((_|0)<(D|0)){Z=aa;_=_+1|0}else{break}}c[76376]=D+1;if(!aa){i=v;return 0}I=+PTc(305552,305496);h[38191]=I;h[F>>3]=I+ +h[F>>3];I=+h[38191]/+h[38187];h[38192]=I;S=c[f>>2]|0;c[76376]=1;if((S|0)>=1){Q=(A<<1)+B|0;H=I;T=1;while(1){ba=k+(T+ -1<<3)|0;h[ba>>3]=+h[ba>>3]+H*+h[m+(Q+T<<3)>>3];if((T|0)>=(S|0)){break}H=+h[38192];T=T+1|0}c[76376]=S+1}be[E&7](f,F,k,e,p,y,z)|0;if((c[75756]|0)>0){i=v;return 0}c[b>>2]=(c[b>>2]|0)+1;a[305560]=0;T=c[e>>2]|0;c[76376]=1;if((T|0)<1){i=v;return 0}else{ca=0;da=1}while(1){H=+h[p+(da+ -1<<3)>>3];if(!(H>=0.0)){ea=-H}else{ea=H}if(!(ea<=0.0)){fa=ca}else{a[305560]=1;fa=1}if((da|0)<(T|0)){ca=fa;da=da+1|0}else{break}}c[76376]=T+1;if(!fa){i=v;return 0}c[t>>2]=-1;i=v;return 0}}while(0);ea=+h[j>>3];do{if(!((ea-K)*J>=0.0)){h[38190]=ea;if((ea- +h[w+320>>3])*J<=0.0){i=v;return 0}pDc(g,305520,k,l,f,o,m,n)|0;if((c[75756]|0)<=0){break}i=v;return 0}else{h[38190]=K;j=c[f>>2]|0;c[76376]=1;if((j|0)<1){break}else{ga=1}while(1){fa=ga+ -1|0;h[k+(fa<<3)>>3]=+h[m+(fa<<3)>>3];if((ga|0)<(j|0)){ga=ga+1|0}else{break}}c[76376]=j+1}}while(0);ga=d;be[ga&7](f,305520,k,e,q,y,z)|0;if((c[75756]|0)>0){i=v;return 0}d=x+60|0;c[d>>2]=(c[d>>2]|0)+1;c[76386]=0;T=w+320|0;fa=x+76|0;da=x+72|0;x=w+336|0;ca=w+344|0;while(1){lDc(e,305552,305544,T,305520,p,q,r,305512,s,fa,da,x,ca)|0;if((c[75756]|0)>0){ha=76;break}if((c[76386]|0)>1){ha=73;break}pDc(g,305512,k,l,f,o,m,n)|0;if((c[75756]|0)>0){ha=76;break}be[ga&7](f,305512,k,e,r,y,z)|0;if((c[75756]|0)>0){ha=76;break}c[d>>2]=(c[d>>2]|0)+1}if((ha|0)==73){h[T>>3]=+h[38189];T=302944;HDc(e,r,T,p,T)|0;if((c[76386]|0)==4){i=v;return 0}pDc(g,305512,k,l,f,o,m,n)|0;if((c[75756]|0)>0){i=v;return 0}c[t>>2]=1;i=v;return 0}else if((ha|0)==76){i=v;return 0}return 0}function lDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0,z=0,A=0.0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0.0,I=0.0,J=0.0,K=0,L=0.0,M=0.0,N=0.0,O=0.0;s=i;do{if((c[e>>2]|0)==1){c[76402]=c[o>>2];c[o>>2]=0;h[38197]=0.0;a[305592]=0;t=c[b>>2]|0;c[76392]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;w=+h[l+(v<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}do{if(x>0.0){w=+PTc(305624,j+(v<<3)|0);if(w==+PTc(305624,l+((c[76392]|0)+ -1<<3)|0)){break}y=c[76392]|0;z=y+ -1|0;w=+h[l+(z<<3)>>3];A=w/(w- +h[j+(z<<3)>>3]);if(!(A>=0.0)){B=-A}else{B=A}if(B<=+h[38197]){break}h[38197]=B;c[o>>2]=y}else{a[305592]=1}}while(0);v=c[76392]|0;u=v+1|0;c[76392]=u;}while((v|0)<(t|0))}do{if((c[o>>2]|0)>0){a[305600]=1;c[76404]=c[p>>2];h[g>>3]=+h[r>>3];t=302944;HDc(b,l,t,k,t)|0;c[p>>2]=1;a[305584]=0;C=0}else{a[305600]=0;c[o>>2]=c[76402];c[76404]=c[p>>2];if(a[305592]&1){h[g>>3]=+h[r>>3];t=302944;HDc(b,l,t,k,t)|0;a[305584]=1;C=1;break}else{t=302944;HDc(b,l,t,j,t)|0;h[f>>3]=+h[r>>3];c[p>>2]=0;a[305584]=0;C=0;break}}}while(0);A=+h[g>>3];w=A- +h[f>>3];if(!(w>=0.0)){D=-w}else{D=w}if(!(D<=+h[d>>3])){if(!C){break}E=+h[g>>3]}else{a[305584]=1;E=A}c[e>>2]=2;h[m>>3]=E;t=302944;HDc(b,k,t,l,t)|0;t=c[b>>2]|0;c[76392]=1;if((t|0)<1){i=s;return 0}else{F=1}do{c[n+(F+ -1<<2)>>2]=0;u=(c[76392]|0)+ -1|0;A=+h[k+(u<<3)>>3];if(!(A>=0.0)){G=-A}else{G=A}do{if(G>0.0){A=+PTc(305624,j+(u<<3)|0);if(!(A!=+PTc(305624,k+((c[76392]|0)+ -1<<3)|0))){break}c[n+((c[76392]|0)+ -1<<2)>>2]=1}else{c[n+(u<<2)>>2]=1}}while(0);u=c[76392]|0;F=u+1|0;c[76392]=F;}while((u|0)<(t|0));i=s;return 0}else{c[o>>2]=0;h[38197]=0.0;a[305592]=0;t=c[b>>2]|0;c[76392]=1;if((t|0)>=1){u=1;do{v=u+ -1|0;A=+h[k+(v<<3)>>3];if(!(A>=0.0)){H=-A}else{H=A}do{if(H>0.0){A=+PTc(305624,j+(v<<3)|0);if(A==+PTc(305624,k+((c[76392]|0)+ -1<<3)|0)){break}y=c[76392]|0;z=y+ -1|0;A=+h[k+(z<<3)>>3];w=A/(A- +h[j+(z<<3)>>3]);if(!(w>=0.0)){I=-w}else{I=w}if(I<=+h[38197]){break}h[38197]=I;c[o>>2]=y}else{a[305592]=1}}while(0);v=c[76392]|0;u=v+1|0;c[76392]=u;}while((v|0)<(t|0))}t=(c[o>>2]|0)>0;a[305600]=t&1;if(t){a[305584]=0;c[76404]=0;c[p>>2]=1;break}if(!(a[305592]&1)){t=302944;HDc(b,k,t,l,t)|0;h[m>>3]=+h[g>>3];c[e>>2]=4;i=s;return 0}h[m>>3]=+h[g>>3];t=302944;HDc(b,k,t,l,t)|0;t=c[b>>2]|0;c[76392]=1;if((t|0)>=1){u=1;do{c[n+(u+ -1<<2)>>2]=0;v=c[76392]|0;y=v+ -1|0;w=+h[k+(y<<3)>>3];if(!(w>=0.0)){J=-w}else{J=w}if(!(J<=0.0)){K=v}else{c[n+(y<<2)>>2]=1;K=c[76392]|0}u=K+1|0;c[76392]=u;}while((K|0)<(t|0))}c[e>>2]=3;i=s;return 0}}while(0);K=c[76404]|0;do{if((K|0)==(c[p>>2]|0)){J=+h[q>>3];if((K|0)==0){I=J*2.0;h[q>>3]=I;L=I;break}else{I=J*.5;h[q>>3]=I;L=I;break}}else{h[q>>3]=1.0;L=1.0}}while(0);I=+h[g>>3];q=(c[o>>2]|0)+ -1|0;J=+h[k+(q<<3)>>3];H=I-(I- +h[f>>3])*J/(J-L*+h[j+(q<<3)>>3]);h[r>>3]=H;L=+h[f>>3];J=H-L;if(!(J>=0.0)){M=-J}else{M=J}J=+h[d>>3];do{if(M<J){I=+h[g>>3]-L;if(!(I>=0.0)){N=-I}else{N=I}if(!(N>J*10.0)){O=H;break}G=L+I*.1;h[r>>3]=G;O=G}else{O=H}}while(0);c[e>>2]=1;h[m>>3]=O;i=s;return 0}function mDc(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0.0,o=0.0,p=0.0;k=i;h[38206]=+h[d>>3];h[38205]=+h[e>>3];j=c[a>>2]|0;c[76408]=1;if((j|0)<1){i=k;return 0}else{l=1}while(1){if((c[b>>2]|0)==0){m=l+ -1|0;n=+h[38206]}else{a=l+ -1|0;o=+h[d+(a<<3)>>3];h[38206]=o;h[38205]=+h[e+(a<<3)>>3];m=a;n=o}o=+h[f+(m<<3)>>3];if(!(o>=0.0)){p=-o}else{p=o}h[g+(m<<3)>>3]=n*p+ +h[38205];a=l+1|0;c[76408]=a;if((l|0)<(j|0)){l=a}else{break}}i=k;return 0}function nDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0.0,j=0.0,k=0,l=0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0;f=i;h[38209]=0.0;e=c[a>>2]|0;c[76414]=1;if((e|0)<1){g=0.0;i=f;return+g}else{j=0.0;k=1}while(1){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){n=-m}else{n=m}if(n>j){l=k+ -1|0;m=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3];if(!(m>=0.0)){o=-m}else{o=m}h[38209]=o;p=o}else{p=j}if((k|0)<(e|0)){j=p;k=k+1|0}else{break}}c[76414]=e+1;if(p<=0.0){g=0.0;i=f;return+g}h[38208]=0.0;e=c[a>>2]|0;c[76414]=1;if((e|0)<1){q=0.0}else{j=0.0;k=1;while(1){l=k+ -1|0;o=+h[b+(l<<3)>>3]/+h[d+(l<<3)>>3]/p;r=j+o*o;h[38208]=r;if((k|0)<(e|0)){k=k+1|0;j=r}else{break}}c[76414]=e+1;q=r}g=p*+V(+(q/+(c[a>>2]|0)));i=f;return+g}function oDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,V=0.0,W=0.0;y=i;i=i+16|0;z=y;A=y+8|0;B=c[f>>2]|0;c[m>>2]=1;c[76432]=0;c[76430]=0;c[76436]=0;h[38221]=+h[b>>3];h[38223]=+nDc(f,d,l,0,0);C=c[f>>2]|0;c[76420]=1;D=(B<<1)+~B|0;if((C|0)>=1){B=1;while(1){E=B+ -1|0;h[p+(E<<3)>>3]=+h[d+(E<<3)>>3];h[p+(D+B<<3)>>3]=+h[e+(B+ -1<<3)>>3];if((B|0)<(C|0)){B=B+1|0}else{break}}c[76420]=C+1}C=t+44|0;B=g;E=t+48|0;F=+h[k>>3];a:while(1){h[38214]=1.0/F;h[b>>3]=+h[k>>3]+ +h[b>>3];G=c[f>>2]|0;c[76420]=1;if((G|0)>=1){H=1;while(1){I=H+ -1|0;J=d+(I<<3)|0;h[J>>3]=+h[J>>3]+ +h[k>>3]*+h[e+(I<<3)>>3];if((H|0)<(G|0)){H=H+1|0}else{break}}c[76420]=G+1}a[305776]=1;c[76422]=0;a[305792]=1;c[C>>2]=(c[C>>2]|0)+1;c[76440]=0;be[B&7](b,d,e,q,305760,n,o)|0;b:do{if((c[76440]|0)<0){K=35}else{while(1){if(a[305776]&1){c[E>>2]=(c[E>>2]|0)+1;a[305776]=0;rDc(f,b,d,e,q,305712,k,305736,l,r,s,t,g,305760,v,j,n,o,x)|0;h[38213]=1.0e6;if((c[76440]|0)<0|(c[76434]|0)!=0){K=35;break b}c[76436]=0}H=c[f>>2]|0;c[76420]=1;if((H|0)>=1){I=1;while(1){J=q+(I+ -1<<3)|0;h[J>>3]=+h[J>>3]*.75;if((I|0)<(H|0)){I=I+1|0}else{break}}c[76420]=H+1}sDc(f,q,s,t)|0;I=c[f>>2]|0;c[76420]=1;if((I|0)>=1){J=1;while(1){L=J+ -1|0;M=d+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[q+(L<<3)>>3];L=J+ -1|0;M=e+(L<<3)|0;h[M>>3]=+h[M>>3]- +h[38214]*+h[q+(L<<3)>>3];if((J|0)<(I|0)){J=J+1|0}else{break}}c[76420]=I+1}N=+nDc(f,q,l,0,0);h[38225]=N;if(N<=+h[v>>3]*100.0*+h[38223]){break}J=c[76422]|0;if((J|0)>0){h[z>>3]=N/+h[38226];h[A>>3]=1.0/+(J|0);O=+NTc(z,A);if(O>.9){K=35;break b}P=O/(1.0-O);h[38213]=P;Q=+h[38225];R=P}else{h[38226]=N;Q=N;R=+h[38213]}if(R*Q<=.33){break}J=c[76422]|0;H=J+1|0;c[76422]=H;if((J|0)>8){K=35;break b}if(((H|0)%5|0|0)==0){a[305776]=1}c[C>>2]=(c[C>>2]|0)+1;c[76440]=0;be[B&7](b,d,e,q,305760,n,o)|0;if((c[76440]|0)<0){K=35;break b}}do{if((c[w>>2]|0)!=0){H=c[f>>2]|0;c[76420]=1;if((H|0)>=1){J=1;while(1){S=+h[d+(J+ -1<<3)>>3];h[q+(J+ -1<<3)>>3]=S<=0.0?S:0.0;if((J|0)<(H|0)){J=J+1|0}else{break}}h[z>>3]=S;c[76420]=H+1}N=+nDc(f,q,l,0,0);h[38225]=N;if(N>.33){K=35;break b}J=c[f>>2]|0;c[76420]=1;if((J|0)<1){break}else{T=1}while(1){I=T+ -1|0;L=d+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[q+(I<<3)>>3];I=T+ -1|0;L=e+(I<<3)|0;h[L>>3]=+h[L>>3]- +h[38214]*+h[q+(I<<3)>>3];if((T|0)<(J|0)){T=T+1|0}else{break}}c[76420]=J+1}}while(0);if(!(a[305792]&1)){break}H=c[f>>2]|0;c[76420]=1;if((H|0)>=1){I=1;while(1){L=I+ -1|0;h[r+(L<<3)>>3]=+h[d+(L<<3)>>3]- +h[p+(L<<3)>>3];if((I|0)<(H|0)){I=I+1|0}else{break}}c[76420]=H+1}N=+nDc(f,r,l,0,0);h[38219]=N;if(N<=1.0){K=63;break a}}}while(0);if((K|0)==35){K=0;a[305792]=0}h[b>>3]=+h[38221];G=c[f>>2]|0;c[76420]=1;if((G|0)>=1){I=1;while(1){L=I+ -1|0;h[d+(L<<3)>>3]=+h[p+(L<<3)>>3];h[e+(I+ -1<<3)>>3]=+h[p+(D+I<<3)>>3];if((I|0)<(G|0)){I=I+1|0}else{break}}c[76420]=G+1}if(a[305792]&1){I=(c[76432]|0)+1|0;c[76432]=I;N=.9/(+h[38219]*2.0+1.0e-4);h[z>>3]=.1;P=N>=.5?.5:N;h[A>>3]=P;N=P<=.1?.1:P;h[38212]=N;P=+h[k>>3]*N;h[k>>3]=P;if(!(P>=0.0)){U=-P}else{U=P}if(U>=+h[u>>3]&(I|0)<10){F=P;continue}else{K=62;break}}if((c[76434]|0)!=0){I=(c[76436]|0)+1|0;c[76436]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=3){K=51;break}if(!(P>=0.0)){V=-P}else{V=P}if(!(V>=+h[u>>3])){K=51;break}else{F=P;continue}}if(!((c[76440]|0)>-2)){K=53;break}I=(c[76430]|0)+1|0;c[76430]=I;P=+h[k>>3]*.25;h[k>>3]=P;if((I|0)>=10){K=58;break}if(!(P>=0.0)){W=-P}else{W=P}if(!(W>=+h[u>>3])){K=58;break}else{F=P}}if((K|0)==51){c[m>>2]=-12;i=y;return 0}else if((K|0)==53){c[m>>2]=-12;i=y;return 0}else if((K|0)==58){c[m>>2]=-12;i=y;return 0}else if((K|0)==62){c[m>>2]=-12;i=y;return 0}else if((K|0)==63){i=y;return 0}return 0}function pDc(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0,w=0;l=i;m=c[f>>2]|0;n=~m;o=(c[g>>2]|0)+1|0;c[76466]=o;p=+h[b>>3]- +h[a>>3];h[38231]=p;a=c[f>>2]|0;c[76458]=1;if((a|0)<1){q=p}else{b=1;while(1){g=b+ -1|0;h[d+(g<<3)>>3]=+h[j+(g<<3)>>3];h[e+(b+ -1<<3)>>3]=0.0;if((b|0)<(a|0)){b=b+1|0}else{break}}c[76458]=a+1;q=+h[38231]}h[38227]=1.0;h[38228]=0.0;p=q/+h[k>>3];h[38232]=p;c[76460]=2;if((o|0)<2){i=l;return 0}else{r=q;s=1.0;t=p;u=0.0;v=2}while(1){a=k+(v+ -2<<3)|0;h[38228]=u*t+s/+h[a>>3];p=t*s;h[38227]=p;h[38232]=(r+ +h[a>>3])/+h[k+(v+ -1<<3)>>3];a=c[f>>2]|0;c[76458]=1;if((a|0)>=1){b=fa(v,m)|0;q=p;g=1;while(1){w=d+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+q*+h[j+(g+n+b<<3)>>3];w=e+(g+ -1<<3)|0;h[w>>3]=+h[w>>3]+ +h[38228]*+h[j+(g+n+b<<3)>>3];if((g|0)>=(a|0)){break}q=+h[38227];g=g+1|0}c[76458]=a+1}g=v+1|0;c[76460]=g;if((v|0)>=(o|0)){break}r=+h[38231];s=+h[38227];t=+h[38232];u=+h[38228];v=g}i=l;return 0}function qDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A,B,C,D,E,F,G,H,I,J,K,L,M){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;B=B|0;C=C|0;D=D|0;E=E|0;F=F|0;G=G|0;H=H|0;I=I|0;J=J|0;K=K|0;L=L|0;M=M|0;var N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0.0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0,na=0.0,oa=0.0,pa=0.0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0,Ca=0,Da=0.0,Ea=0,Fa=0,Ga=0.0,Ha=0;N=i;i=i+16|0;O=N;P=N+8|0;Q=c[f>>2]|0;R=~Q;c[n>>2]=1;h[38254]=+h[b>>3];c[76486]=0;c[76494]=0;c[76488]=0;S=u+52|0;if((c[m>>2]|0)==0){c[S>>2]=0;T=u+56|0;c[T>>2]=0;c[I>>2]=1;c[J>>2]=0;h[C>>3]=0.0;c[m>>2]=1;h[y>>3]=+h[k>>3];U=1.0/+h[k>>3];h[B>>3]=U;h[A>>3]=U;h[D>>3]=100.0;c[H>>2]=-1;h[38266]=1.0;c[G>>2]=0;c[K>>2]=0;V=T}else{V=u+56|0}T=u+44|0;m=g;W=u+48|0;while(1){c[76482]=(c[I>>2]|0)+1;c[76484]=(c[I>>2]|0)+2;c[76480]=(c[I>>2]|0)+ -1;h[38254]=+h[b>>3];do{if(+h[k>>3]!=+h[C>>3]){X=8}else{Y=c[I>>2]|0;if((Y|0)!=(c[J>>2]|0)){X=8;break}Z=(c[K>>2]|0)+1|0;_=Y}}while(0);if((X|0)==8){X=0;c[K>>2]=0;Z=1;_=c[J>>2]|0}Y=_+2|0;$=(Z|0)<=(Y|0)?Z:Y;c[K>>2]=$;c[76498]=$+1;$=c[76482]|0;if(($|0)>=(c[K>>2]|0)){h[w>>3]=1.0;h[v>>3]=1.0;h[38257]=+h[k>>3];h[x>>3]=0.0;h[z>>3]=1.0;c[76468]=2;if(($|0)>=2){Y=2;while(1){h[38258]=+h[y+(Y+ -2<<3)>>3];U=+h[38257];aa=Y+ -2|0;h[y+(aa<<3)>>3]=U;ba=Y+ -1|0;h[w+(ba<<3)>>3]=+h[w+(aa<<3)>>3]*U/+h[38258];U=+h[38258]+ +h[k>>3];h[38257]=U;ca=+h[k>>3]/U;h[v+(ba<<3)>>3]=ca;h[z+(ba<<3)>>3]=ca*+h[z+(aa<<3)>>3]*+(ba|0);h[x+(ba<<3)>>3]=+h[x+(aa<<3)>>3]+ +h[v+(aa<<3)>>3]/+h[k>>3];if((Y|0)<($|0)){Y=Y+1|0}else{break}}c[76468]=$+1}h[y+($+ -1<<3)>>3]=+h[38257]}h[38264]=0.0;h[38262]=0.0;Y=c[I>>2]|0;c[76468]=1;if((Y|0)<1){da=0.0}else{ca=0.0;U=0.0;aa=1;while(1){ea=U-1.0/+(aa|0);h[38264]=ea;ga=ca- +h[v+(aa+ -1<<3)>>3];h[38262]=ga;if((aa|0)<(Y|0)){aa=aa+1|0;U=ea;ca=ga}else{break}}c[76468]=Y+1;da=ea}h[38265]=+h[A>>3];h[A>>3]=-da/+h[k>>3];aa=v+($+ -1<<3)|0;ca=+h[aa>>3]+ +h[38264]- +h[38262];h[O>>3]=ca;if(!(ca>=0.0)){ha=-ca}else{ha=ca}h[38239]=ha;h[O>>3]=ha;ca=+h[aa>>3];h[P>>3]=ca;h[38239]=ha>=ca?ha:ca;h[38257]=.6;h[38258]=1.6666666666666667;ca=+h[A>>3];U=ca/+h[B>>3];if(U<.6|U>1.6666666666666667){c[H>>2]=-1}if(ca!=+h[38265]){h[D>>3]=100.0}aa=c[76482]|0;ba=c[76498]|0;if((aa|0)>=(ba|0)){c[76470]=ba;ia=ba;while(1){ba=c[f>>2]|0;c[76468]=1;if((ba|0)>=1){ja=1;while(1){ka=q+(ja+R+(fa(ia,Q)|0)<<3)|0;h[ka>>3]=+h[w+(ia+ -1<<3)>>3]*+h[ka>>3];if((ja|0)<(ba|0)){ja=ja+1|0}else{break}}c[76468]=ba+1}ja=ia+1|0;c[76470]=ja;if((ia|0)<(aa|0)){ia=ja}else{break}}}h[b>>3]=+h[k>>3]+ +h[b>>3];a:while(1){ia=c[f>>2]|0;c[76468]=1;if((ia|0)>=1){aa=1;while(1){$=aa+ -1|0;h[d+($<<3)>>3]=+h[q+($<<3)>>3];h[e+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ia|0)){aa=aa+1|0}else{break}}c[76468]=ia+1}aa=c[76482]|0;c[76470]=2;if((aa|0)>=2){ba=2;while(1){$=c[f>>2]|0;c[76468]=1;if(($|0)>=1){Y=x+(ba+ -1<<3)|0;ja=fa(ba,Q)|0;ka=ja+R|0;la=1;while(1){ma=d+(la+ -1<<3)|0;h[ma>>3]=+h[q+(la+R+ja<<3)>>3]+ +h[ma>>3];ma=e+(la+ -1<<3)|0;h[ma>>3]=+h[ma>>3]+ +h[Y>>3]*+h[q+(ka+la<<3)>>3];if((la|0)<($|0)){la=la+1|0}else{break}}c[76468]=$+1}la=ba+1|0;c[76470]=la;if((ba|0)<(aa|0)){ba=la}else{break}}}h[38261]=+nDc(f,d,l,0,0);a[306136]=1;c[76472]=0;c[T>>2]=(c[T>>2]|0)+1;c[76502]=0;be[m&7](b,d,e,r,306008,o,p)|0;if((c[76502]|0)<0){X=70;break}if((c[H>>2]|0)==-1){c[W>>2]=(c[W>>2]|0)+1;c[H>>2]=0;rDc(f,b,d,e,r,A,k,305960,l,s,t,u,g,306008,F,j,o,p,M)|0;h[B>>3]=+h[A>>3];h[D>>3]=100.0;if((c[76502]|0)<0|(c[76490]|0)!=0){X=70;break}c[76494]=0}ba=c[f>>2]|0;c[76468]=1;if((ba|0)>=1){aa=1;while(1){h[s+(aa+ -1<<3)>>3]=0.0;if((aa|0)<(ba|0)){aa=aa+1|0}else{break}}c[76468]=ba+1}while(1){ca=2.0/(+h[A>>3]/+h[B>>3]+1.0);h[38257]=ca;aa=c[f>>2]|0;c[76468]=1;if((aa|0)>=1){U=ca;ia=1;la=0;while(1){ka=r+(la<<3)|0;h[ka>>3]=U*+h[ka>>3];if((ia|0)>=(aa|0)){break}ka=ia;U=+h[38257];ia=ia+1|0;la=ka}c[76468]=aa+1}sDc(f,r,t,u)|0;la=c[f>>2]|0;c[76468]=1;if((la|0)>=1){ia=1;while(1){$=ia+ -1|0;ka=d+($<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+($<<3)>>3];$=ia+ -1|0;ka=r+($<<3)|0;Y=s+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[ka>>3];Y=e+($<<3)|0;h[Y>>3]=+h[Y>>3]- +h[A>>3]*+h[ka>>3];if((ia|0)<(la|0)){ia=ia+1|0}else{break}}c[76468]=la+1}U=+nDc(f,r,l,0,0);h[38266]=U;if(U<=+h[F>>3]*100.0*+h[38261]){X=63;break a}ia=c[76472]|0;if((ia|0)>0){h[O>>3]=U/+h[38268];h[P>>3]=1.0/+(ia|0);ca=+NTc(O,P);if(ca>.9){break}ga=ca/(1.0-ca);h[D>>3]=ga;na=+h[38266];oa=ga}else{h[38268]=U;na=U;oa=+h[D>>3]}if(oa*na<=.33){X=63;break a}ia=c[76472]|0;c[76472]=ia+1;if((ia|0)>2){break}c[T>>2]=(c[T>>2]|0)+1;c[76502]=0;be[m&7](b,d,e,r,306008,o,p)|0;if((c[76502]|0)<0){X=70;break a}}if((c[H>>2]|0)==0){X=70;break}c[H>>2]=-1}do{if((X|0)==63){X=0;if((c[L>>2]|0)==0){break}ba=c[f>>2]|0;c[76468]=1;if((ba|0)>=1){ia=1;while(1){pa=+h[d+(ia+ -1<<3)>>3];h[r+(ia+ -1<<3)>>3]=pa<=0.0?pa:0.0;if((ia|0)<(ba|0)){ia=ia+1|0}else{break}}h[O>>3]=pa;c[76468]=ba+1}U=+nDc(f,r,l,0,0);h[38266]=U;if(U>.33){X=70;break}ia=c[f>>2]|0;c[76468]=1;if((ia|0)<1){break}else{qa=1}while(1){aa=qa+ -1|0;ka=s+(aa<<3)|0;h[ka>>3]=+h[ka>>3]- +h[r+(aa<<3)>>3];if((qa|0)<(ia|0)){qa=qa+1|0}else{break}}c[76468]=ia+1}}while(0);if((X|0)==70){X=0;a[306136]=0}c[H>>2]=1;if(a[306136]&1){U=+nDc(f,s,l,0,0);h[38260]=U;ba=c[I>>2]|0;ga=U*+h[z+(ba<<3)>>3];h[38246]=ga;h[38253]=ga*+(ba+1|0);h[38248]=ga;c[76504]=ba;do{if((c[I>>2]|0)!=1){ba=c[f>>2]|0;c[76468]=1;if((ba|0)>=1){aa=fa(c[76482]|0,Q)|0;ka=1;while(1){Y=ka+ -1|0;h[r+(Y<<3)>>3]=+h[q+(ka+R+aa<<3)>>3]+ +h[s+(Y<<3)>>3];if((ka|0)<(ba|0)){ka=ka+1|0}else{break}}c[76468]=ba+1}ga=+h[z+((c[I>>2]|0)+ -1<<3)>>3];U=ga*+nDc(f,r,l,0,0);h[38255]=U;ka=c[I>>2]|0;ga=U*+(ka|0);h[38263]=ga;if((ka|0)>2){aa=c[f>>2]|0;c[76468]=1;ia=c[I>>2]|0;if((aa|0)<1){ra=ia}else{Y=ia;ia=1;while(1){ca=+h[q+(ia+R+(fa(Y,Q)|0)<<3)>>3];$=r+(ia+ -1<<3)|0;h[$>>3]=ca+ +h[$>>3];$=ia+1|0;c[76468]=$;ja=c[I>>2]|0;if((ia|0)<(aa|0)){ia=$;Y=ja}else{ra=ja;break}}}ca=+h[z+(ra+ -2<<3)>>3];sa=ca*+nDc(f,r,l,0,0);Y=c[I>>2]|0;ca=sa*+(Y+ -1|0);sa=+h[38263];if((sa>=ca?sa:ca)>+h[38253]){break}ta=+h[38255];ua=Y}else{if(!(ga<=+h[38253]*.5)){break}else{ta=U;ua=ka}}c[76504]=ua+ -1;h[38248]=ta}}while(0);if(!(+h[38239]*+h[38260]>1.0)){X=86;break}}c[G>>2]=1;h[b>>3]=+h[38254];Y=c[76482]|0;ia=c[76498]|0;if((Y|0)>=(ia|0)){c[76470]=ia;aa=ia;while(1){ca=1.0/+h[w+(aa+ -1<<3)>>3];h[38257]=ca;ia=c[f>>2]|0;c[76468]=1;if((ia|0)>=1){ba=fa(aa,Q)|0;sa=ca;ja=1;while(1){$=q+(ja+R+ba<<3)|0;h[$>>3]=sa*+h[$>>3];if((ja|0)>=(ia|0)){break}sa=+h[38257];ja=ja+1|0}c[76468]=ia+1}ja=aa+1|0;c[76470]=ja;if((aa|0)<(Y|0)){aa=ja}else{break}}}c[76468]=2;if((Y|0)>=2){aa=2;while(1){h[y+(aa+ -2<<3)>>3]=+h[y+(aa+ -1<<3)>>3]- +h[k>>3];if((aa|0)<(Y|0)){aa=aa+1|0}else{break}}c[76468]=Y+1}if(!(a[306136]&1)){c[V>>2]=(c[V>>2]|0)+1;if((c[76490]|0)!=0){aa=(c[76494]|0)+1|0;c[76494]=aa;h[38237]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=3){X=144;break}if(!(sa>=0.0)){va=-sa}else{va=sa}if(!(va>=+h[E>>3])){X=144;break}else{continue}}if(!((c[76502]|0)>-2)){X=146;break}aa=(c[76486]|0)+1|0;c[76486]=aa;h[38237]=.25;sa=+h[k>>3]*.25;h[k>>3]=sa;if((aa|0)>=10){X=151;break}if(!(sa>=0.0)){wa=-sa}else{wa=sa}if(!(wa>=+h[E>>3])){X=151;break}else{continue}}c[76488]=(c[76488]|0)+1;c[S>>2]=(c[S>>2]|0)+1;aa=c[76488]|0;if((aa|0)<=1){ja=c[76504]|0;c[I>>2]=ja;sa=+(ja+1|0);h[38258]=sa;h[O>>3]=+h[38248]*2.0+1.0e-4;h[P>>3]=-1.0/sa;sa=+NTc(O,P)*.9;h[O>>3]=.25;U=sa>=.9?.9:sa;h[P>>3]=U;sa=U<=.25?.25:U;h[38237]=sa;U=+h[k>>3]*sa;h[k>>3]=U;if(!(U>=0.0)){xa=-U}else{xa=U}if(!(xa>=+h[E>>3])){X=156;break}else{continue}}if((aa|0)>2){c[I>>2]=1;U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){ya=-U}else{ya=U}if(!(ya>=+h[E>>3])){X=165;break}else{continue}}else{c[I>>2]=c[76504];U=+h[k>>3]*.25;h[k>>3]=U;if(!(U>=0.0)){za=-U}else{za=U}if(!(za>=+h[E>>3])){X=161;break}else{continue}}}if((X|0)==86){c[n>>2]=1;E=u+40|0;c[E>>2]=(c[E>>2]|0)+1;c[76518]=(c[I>>2]|0)-(c[J>>2]|0);c[J>>2]=c[I>>2];h[C>>3]=+h[k>>3];C=c[76504]|0;E=c[76480]|0;do{if((C|0)==(E|0)){X=88}else{S=u+8|0;if((c[I>>2]|0)==(c[S>>2]|0)){X=88;break}if((c[G>>2]|0)!=0){Aa=E;Ba=C;X=90;break}c[I>>2]=c[76482];za=+h[k>>3]*2.0;h[38250]=za;Ca=S;Da=za}}while(0);if((X|0)==88){c[G>>2]=1;Aa=c[76480]|0;Ba=c[76504]|0;X=90}if((X|0)==90){do{if((Ba|0)==(Aa|0)){Ea=Aa;X=104}else{G=c[I>>2]|0;C=u+8|0;if((G|0)==(c[C>>2]|0)){Fa=G;break}if((c[76482]|0)>=(c[K>>2]|0)|(c[76518]|0)==1){Fa=G;break}G=c[f>>2]|0;c[76468]=1;if((G|0)>=1){E=fa(c[76484]|0,Q)|0;S=1;while(1){V=S+ -1|0;h[r+(V<<3)>>3]=+h[s+(V<<3)>>3]- +h[q+(S+R+E<<3)>>3];if((S|0)<(G|0)){S=S+1|0}else{break}}c[76468]=G+1}za=1.0/+((c[I>>2]|0)+2|0);ya=za*+nDc(f,r,l,0,0);h[38256]=ya;S=c[I>>2]|0;za=ya*+(S+2|0);if((S|0)>1){xa=+h[38253];E=xa<=za;if(+h[38263]<=(E?xa:za)){Ea=c[76480]|0;X=104;break}if(E){Fa=S;break}if((S|0)==(c[C>>2]|0)){Fa=S;break}}else{if(za>=+h[38253]*.5){Fa=S;break}}S=c[76482]|0;c[I>>2]=S;h[38248]=ya;Fa=S}}while(0);if((X|0)==104){c[I>>2]=Ea;h[38248]=+h[38255];Fa=Ea}h[38250]=+h[k>>3];ya=+(Fa+1|0);h[38258]=ya;h[O>>3]=+h[38248]*2.0+1.0e-4;h[P>>3]=-1.0/ya;ya=+NTc(O,P);h[38237]=ya;do{if(ya<2.0){if(ya>1.0){Ga=+h[38250];break}else{h[O>>3]=.5;za=ya>=.9?.9:ya;h[P>>3]=za;xa=za<=.5?.5:za;h[38237]=xa;za=+h[k>>3]*xa;h[38250]=za;Ga=za;break}}else{za=+h[k>>3]*2.0;h[38250]=za;Ga=za}}while(0);Ca=u+8|0;Da=Ga}h[k>>3]=Da;do{if((c[J>>2]|0)!=(c[Ca>>2]|0)){k=c[f>>2]|0;c[76468]=1;if((k|0)<1){break}u=fa(c[76484]|0,Q)|0;P=1;while(1){h[q+(P+R+u<<3)>>3]=+h[s+(P+ -1<<3)>>3];if((P|0)<(k|0)){P=P+1|0}else{break}}c[76468]=k+1}}while(0);Ca=c[f>>2]|0;c[76468]=1;if((Ca|0)>=1){J=fa(c[76482]|0,Q)|0;P=1;while(1){u=q+(P+R+J<<3)|0;h[u>>3]=+h[s+(P+ -1<<3)>>3]+ +h[u>>3];if((P|0)<(Ca|0)){P=P+1|0}else{break}}c[76468]=Ca+1}Ca=c[76482]|0;c[76476]=2;if((Ca|0)<2){i=N;return 0}else{Ha=2}while(1){P=1-Ha+Ca|0;c[76470]=P;s=c[f>>2]|0;c[76468]=1;if((s|0)>=1){J=fa(P+1|0,Q)|0;u=fa(P,Q)|0;P=1;while(1){C=P+R|0;G=q+(C+u<<3)|0;h[G>>3]=+h[q+(C+J<<3)>>3]+ +h[G>>3];if((P|0)<(s|0)){P=P+1|0}else{break}}c[76468]=s+1}P=Ha+1|0;c[76476]=P;if((Ha|0)<(Ca|0)){Ha=P}else{break}}i=N;return 0}else if((X|0)==144){c[n>>2]=-8}else if((X|0)==146){c[n>>2]=-11}else if((X|0)==151){c[n>>2]=-7;Ha=(c[76502]>>31&-3)+ -7|0;c[n>>2]=Ha;c[n>>2]=(c[76488]|0)>2?-9:Ha}else if((X|0)==156){c[n>>2]=-6}else if((X|0)==161){c[n>>2]=-6}else if((X|0)==165){c[n>>2]=-6}pDc(b,b,d,e,f,I,q,y)|0;i=N;return 0}function rDc(b,d,e,f,g,j,l,m,n,o,p,q,r,s,t,u,v,w,x){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;var y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0.0,ma=0.0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0.0,ta=0.0,ua=0.0;y=i;i=i+8|0;z=y;A=i;i=i+16|0;B=i;i=i+8|0;C=i;i=i+16|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+16|0;I=i;i=i+8|0;J=i;i=i+16|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;c[m>>2]=0;O=c[q+12>>2]|0;a:do{if((O|0)==5){P=q+4|0;Q=(c[P>>2]|0)+(c[q>>2]|0)|0;R=Q+1|0;c[76564]=R;S=c[b>>2]|0;c[76554]=(Q|0)<(S|0)?R:S;S=c[q>>2]|0;c[76572]=R+S;c[76558]=S+Q;Q=(c[b>>2]|0)/(R|0)|0;c[76568]=Q+1;R=c[x>>2]|0;c[76566]=R+ -1;c[76576]=R+Q;c[s>>2]=0;h[38281]=+V(+(+h[t>>3]));Q=c[76554]|0;c[76540]=1;if((Q|0)<1){T=75;break}R=r;S=1;while(1){U=c[b>>2]|0;W=c[76564]|0;c[76546]=S;X=(W|0)<0;b:do{if(X?(S|0)>=(U|0):(S|0)<=(U|0)){Y=W;Z=S;_=S;while(1){$=(_-Z|0)/(Y|0)|0;c[76542]=$+1;aa=_+ -1|0;ba=e+(aa<<3)|0;h[p+((c[76566]|0)+$<<3)>>3]=+h[ba>>3];ca=f+(aa<<3)|0;h[p+((c[76576]|0)+$<<3)>>3]=+h[ca>>3];da=+h[ba>>3];h[N>>3]=da;if(!(da>=0.0)){ea=-da}else{ea=da}da=+h[l>>3]*+h[ca>>3];if(!(da>=0.0)){ga=-da}else{ga=da}da=ea>=ga?ea:ga;ha=+h[n+(aa<<3)>>3];if(!(ha>=0.0)){ia=-ha}else{ia=ha}h[38278]=+h[38281]*(da>=ia?da:ia);h[N>>3]=+h[l>>3]*+h[ca>>3];da=+PTc(306224,N);h[38278]=da;ca=c[76546]|0;aa=ca+ -1|0;ba=e+(aa<<3)|0;ha=+h[ba>>3];ja=da+ha-ha;h[38278]=ja;h[ba>>3]=+h[ba>>3]+ja;ba=f+(aa<<3)|0;h[ba>>3]=+h[j>>3]*+h[38278]+ +h[ba>>3];ba=ca+W|0;c[76546]=ba;if(!(X?(ba|0)>=(U|0):(ba|0)<=(U|0))){break b}Y=c[76564]|0;Z=c[76540]|0;_=ba}}}while(0);be[R&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}U=c[b>>2]|0;X=c[76564]|0;W=c[76540]|0;c[76546]=W;_=(X|0)<0;c:do{if(_?(W|0)>=(U|0):(W|0)<=(U|0)){Z=X;Y=W;ba=W;while(1){ca=(ba-Y|0)/(Z|0)|0;c[76542]=ca+1;aa=ba+ -1|0;$=e+(aa<<3)|0;h[$>>3]=+h[p+((c[76566]|0)+ca<<3)>>3];ja=+h[p+((c[76576]|0)+ca<<3)>>3];ca=f+(aa<<3)|0;h[ca>>3]=ja;ha=+h[$>>3];h[N>>3]=ha;if(!(ha>=0.0)){ka=-ha}else{ka=ha}ha=+h[l>>3]*ja;if(!(ha>=0.0)){la=-ha}else{la=ha}ha=ka>=la?ka:la;ja=+h[n+(aa<<3)>>3];if(!(ja>=0.0)){ma=-ja}else{ma=ja}h[38278]=+h[38281]*(ha>=ma?ha:ma);h[N>>3]=+h[l>>3]*+h[ca>>3];ha=+PTc(306224,N);h[38278]=ha;ca=c[76546]|0;ja=+h[e+(ca+ -1<<3)>>3];da=ha+ja-ja;h[38278]=da;ja=1.0/da;h[38287]=ja;aa=ca-(c[P>>2]|0)|0;$=(aa|0)>1?aa:1;c[76548]=$;aa=c[b>>2]|0;na=(c[q>>2]|0)+ca|0;oa=(aa|0)<=(na|0)?aa:na;c[76550]=oa;pa=fa(c[76558]|0,ca)|0;qa=pa-(c[q>>2]|0)|0;c[76552]=qa;c[76538]=$;if(($|0)<=(oa|0)){pa=~aa;aa=~na;na=~((pa|0)>(aa|0)?pa:aa);aa=($|0)>(na|0)?$:na;da=ja;na=$;while(1){$=na+ -1|0;h[p+($+qa<<3)>>3]=(+h[o+($<<3)>>3]- +h[g+($<<3)>>3])*da;if((na|0)>=(oa|0)){break}da=+h[38287];na=na+1|0}c[76538]=aa+1}na=ca+X|0;c[76546]=na;oa=c[76540]|0;if(!(_?(na|0)>=(U|0):(na|0)<=(U|0))){ra=oa;break c}Z=c[76564]|0;Y=oa;ba=na}}else{ra=W}}while(0);W=ra+1|0;c[76540]=W;if((ra|0)<(Q|0)){S=W}else{T=75;break a}}i=y;return 0}else if((O|0)==2){c[s>>2]=0;c[76560]=0;h[38281]=+V(+(+h[t>>3]));S=c[b>>2]|0;c[76538]=1;d:do{if((S|0)>=1){Q=r;P=1;while(1){R=P+ -1|0;da=+h[e+(R<<3)>>3];h[N>>3]=da;if(!(da>=0.0)){sa=-da}else{sa=da}W=f+(R<<3)|0;da=+h[l>>3]*+h[W>>3];if(!(da>=0.0)){ta=-da}else{ta=da}da=sa>=ta?sa:ta;ja=+h[n+(R<<3)>>3];if(!(ja>=0.0)){ua=-ja}else{ua=ja}h[38278]=+h[38281]*(da>=ua?da:ua);h[N>>3]=+h[l>>3]*+h[W>>3];da=+PTc(306224,N);h[38278]=da;W=(c[76538]|0)+ -1|0;R=e+(W<<3)|0;ja=+h[R>>3];ha=da+ja-ja;h[38278]=ha;h[38285]=+h[R>>3];U=f+(W<<3)|0;h[38289]=+h[U>>3];h[R>>3]=ha+ +h[R>>3];h[U>>3]=+h[j>>3]*+h[38278]+ +h[U>>3];be[Q&7](d,e,f,o,s,v,w)|0;if((c[s>>2]|0)<0){break}ha=1.0/+h[38278];h[38287]=ha;U=c[b>>2]|0;c[76544]=1;R=c[76560]|0;if((U|0)>=1){ja=ha;W=1;_=0;while(1){h[p+(_+R<<3)>>3]=(+h[o+(_<<3)>>3]- +h[g+(_<<3)>>3])*ja;if((W|0)>=(U|0)){break}X=W;ja=+h[38287];W=W+1|0;_=X}c[76544]=U+1}c[76560]=R+(c[b>>2]|0);_=c[76538]|0;W=_+ -1|0;h[e+(W<<3)>>3]=+h[38285];h[f+(W<<3)>>3]=+h[38289];P=_+1|0;c[76538]=P;if((_|0)>=(S|0)){break d}}i=y;return 0}}while(0);if((c[w>>2]|0)==0){T=42;break}c[76560]=0;S=c[b>>2]|0;if((c[292360>>2]|0)==0){T=42;break}P=h4c(S*20|0)|0;Q=F;h[k>>3]=+h[d>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];EBc(14,1,306320,F);Q=E;h[k>>3]=+h[j>>3];c[Q>>2]=c[k>>2];c[Q+4>>2]=c[k+4>>2];EBc(14,0,306344,E);EBc(14,1,306352,D);c[76542]=0;if((c[b>>2]|0)>0){Q=0;do{ja=+h[e+(Q<<3)>>3];c[C>>2]=Q+1;_=C+4|0;h[k>>3]=ja;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];EBc(14,0,306360,C);Q=(c[76542]|0)+1|0;c[76542]=Q;}while((Q|0)<(c[b>>2]|0))}fe[c[73214]&1023](14);EBc(14,1,306416,B);c[76538]=1;if((S|0)>=1){Q=P+1|0;_=c[76560]|0;W=1;do{X=p+(W+ -1+_<<3)|0;h[X>>3]=+h[j>>3]+ +h[X>>3];a[P]=0;a[Q]=0;c[76544]=1;X=_;ba=0;while(1){ja=+h[p+(ba+X<<3)>>3];c[A>>2]=P;Y=A+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];hc(P|0,306400,A|0)|0;Y=c[76544]|0;c[76544]=Y+1;if((Y|0)>=(S|0)){break}X=c[76560]|0;ba=Y}c[z>>2]=P;EBc(14,0,306408,z);ba=c[76560]|0;X=c[76538]|0;Y=p+(ba+ -1+X<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];_=ba+(c[b>>2]|0)|0;c[76560]=_;W=X+1|0;c[76538]=W;}while((X|0)<(S|0))}fe[c[73214]&1023](14);fe[c[73214]&1023](14);i4c(P);T=42}else if((O|0)==4){S=c[q>>2]|0;W=q+4|0;_=c[W>>2]|0;Q=c[b>>2]|0;X=fa(_+1+(S<<1)|0,Q)|0;c[76538]=1;if((X|0)>=1){ba=fa(Q,_+(S<<1)+1|0)|0;S=(ba|0)<1;_=1;while(1){h[p+(_+ -1<<3)>>3]=0.0;if((_|0)<(X|0)){_=_+1|0}else{break}}c[76538]=S?2:ba+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;c[76572]=(c[W>>2]|0)+1+(c[q>>2]<<1);T=75}else if((O|0)==3){i=y;return 0}else{_=c[b>>2]|0;X=fa(_,_)|0;c[76538]=1;if((X|0)!=0){_=(X|0)<1;P=1;while(1){h[p+(P+ -1<<3)>>3]=0.0;if((P|0)<(X|0)){P=P+1|0}else{break}}c[76538]=_?2:X+1|0}he[u&7](d,e,f,g,p,j,l,n,v,w)|0;if((c[w>>2]|0)==0){T=42;break}c[76560]=0;P=c[b>>2]|0;if((c[292360>>2]|0)==0){T=42;break}W=h4c(P*20|0)|0;ba=M;h[k>>3]=+h[d>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];EBc(14,1,306320,M);ba=L;h[k>>3]=+h[j>>3];c[ba>>2]=c[k>>2];c[ba+4>>2]=c[k+4>>2];EBc(14,0,306344,L);EBc(14,1,306352,K);c[76542]=0;if((c[b>>2]|0)>0){ba=0;do{ja=+h[e+(ba<<3)>>3];c[J>>2]=ba+1;S=J+4|0;h[k>>3]=ja;c[S>>2]=c[k>>2];c[S+4>>2]=c[k+4>>2];EBc(14,0,306360,J);ba=(c[76542]|0)+1|0;c[76542]=ba;}while((ba|0)<(c[b>>2]|0))}fe[c[73214]&1023](14);EBc(14,1,306376,I);c[76538]=1;if((P|0)>=1){ba=W+1|0;X=c[76560]|0;_=1;do{S=p+(_+ -1+X<<3)|0;h[S>>3]=+h[j>>3]+ +h[S>>3];a[W]=0;a[ba]=0;c[76544]=1;S=X;Q=0;while(1){ja=+h[p+(Q+S<<3)>>3];c[H>>2]=W;Y=H+4|0;h[k>>3]=ja;c[Y>>2]=c[k>>2];c[Y+4>>2]=c[k+4>>2];hc(W|0,306400,H|0)|0;Y=c[76544]|0;c[76544]=Y+1;if((Y|0)>=(P|0)){break}S=c[76560]|0;Q=Y}c[G>>2]=W;EBc(14,0,306408,G);Q=c[76560]|0;S=c[76538]|0;Y=p+(Q+ -1+S<<3)|0;h[Y>>3]=+h[Y>>3]- +h[j>>3];X=Q+(c[b>>2]|0)|0;c[76560]=X;_=S+1|0;c[76538]=_;}while((S|0)<(P|0))}fe[c[73214]&1023](14);fe[c[73214]&1023](14);i4c(W);T=42}}while(0);if((T|0)==42){zDc(p,b,b,q+80|0,m)|0;i=y;return 0}else if((T|0)==75){FDc(p,306288,b,q,q+4|0,q+80|0,m)|0;i=y;return 0}return 0}function sDc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;f=i;g=c[e+12>>2]|0;if((g|0)==4|(g|0)==5){h=e+4|0;c[76610]=(c[h>>2]|0)+1+(c[e>>2]<<1);GDc(d,306440,a,e,h,e+80|0,b,306448)|0;i=f;return 0}else if((g|0)==3){i=f;return 0}else{DDc(d,a,a,e+80|0,b,306448)|0;i=f;return 0}return 0}function tDc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0.0;d=i;i=i+8|0;e=d;do{if(!(a[306456]&1)){a[306456]=1;uDc(306504,306472,306552,306488,306536,306560,306544,306568)|0;h[38312]=+(c[76626]|0);f=c[76618]|0;h[38308]=+(f|0);if((c[76638]|0)==0){h[38310]=0.0;c[e>>2]=1-f;g=+OTc(306496,e)}else{h[38310]=1.0;c[e>>2]=1-f;g=+OTc(306496,e)*.5}h[38311]=g;h[38315]=g*+h[38312];h[38314]=+(c[76634]|0);h[38316]=+(c[76636]|0);j=+h[38320];h[38323]=j;k=1.0/+h[38321];if(!(k>=j)){break}h[38323]=k*(g+1.0)}}while(0);if((MDc(b,306592,1,1)|0)!=0){g=+h[38311];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306600,1,1)|0)!=0){g=+h[38323];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306608,1,1)|0)!=0){g=+h[38312];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306616,1,1)|0)!=0){g=+h[38315];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306624,1,1)|0)!=0){g=+h[38308];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306632,1,1)|0)!=0){g=+h[38310];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306640,1,1)|0)!=0){g=+h[38314];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306648,1,1)|0)!=0){g=+h[38320];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306656,1,1)|0)!=0){g=+h[38316];h[38322]=g;l=g;i=d;return+l}if((MDc(b,306664,1,1)|0)==0){l=+h[38322];i=d;return+l}else{g=+h[38321];h[38322]=g;l=g;i=d;return+l}return 0.0}function uDc(b,d,e,f,g,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0,M=0.0,N=0.0,O=0.0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0;m=i;i=i+24|0;n=m;o=m+8|0;p=m+16|0;if(a[306776]&1){q=307144;r=c[76786]|0;c[b>>2]=r;s=307080;t=c[76770]|0;c[d>>2]=t;u=307120;v=c[76780]|0;c[e>>2]=v;w=307128;x=+h[38391];h[f>>3]=x;y=307160;z=c[76790]|0;c[g>>2]=z;A=307208;B=+h[38401];h[j>>3]=B;C=307168;D=c[76792]|0;c[k>>2]=D;E=307216;F=+h[38402];h[l>>3]=F;i=m;return 0}a[306776]=1;h[38392]=0.0;h[38386]=1.0;h[38387]=2.0;vDc(307144,307080,307120,307232)|0;h[38382]=+(c[76786]|0);c[n>>2]=0-(c[76770]|0);G=+OTc(307056,n);h[38381]=G;h[38391]=G;H=+h[38387];h[38382]=H/3.0;I=+h[38386];J=I*.5;h[38389]=J;K=-J;h[o>>3]=K;h[38403]=+wDc(307056,o);L=307224;h[38400]=+wDc(L,L);h[o>>3]=K;h[38382]=+wDc(307200,o);K=+wDc(307056,307224);h[38382]=K;if(!(K>=0.0)){M=-K}else{M=K}K=M<G?G:M;h[38382]=K;h[38391]=1.0;M=+h[38392];if(K<1.0&K>M){N=K;while(1){h[38391]=N;h[o>>3]=N*J;K=H*H;h[p>>3]=N*N*H*K*K;K=+wDc(o,p);h[38383]=K;h[o>>3]=-K;h[38383]=+wDc(307112,o);K=+wDc(307112,307064);h[38382]=K;h[o>>3]=-K;h[38383]=+wDc(307112,o);K=+wDc(307112,307064);h[38382]=K;if(N>K&K>M){N=K}else{O=N;break}}}else{O=1.0}if(G<O){h[38391]=G}G=I/+(c[76786]|0);h[38394]=G;h[38398]=I;c[76768]=1;p=1;O=I;do{h[o>>3]=O*G;O=+wDc(o,307136);h[38398]=O;p=p+1|0;c[76768]=p;}while((p|0)<4);h[38381]=+wDc(307088,307184);xDc(307248,307088,307144)|0;h[o>>3]=-+h[38386];xDc(307240,o,307144)|0;xDc(307192,307048,307144)|0;h[o>>3]=-+h[38381];xDc(307176,o,307144)|0;c[76776]=0;p=c[76812]|0;L=c[76810]|0;P=c[76798]|0;Q=(p|0)==(P|0);do{if((p|0)==(L|0)&(P|0)==(c[76794]|0)){if(Q){c[76790]=p;R=0;S=25;break}if((P-p|0)==3){c[76790]=p+ -1+(c[76770]|0);c[76776]=1;R=1;S=25;break}else{c[76790]=(p|0)<=(P|0)?p:P;a[306784]=1;S=26;break}}else{T=Q&(L|0)==(c[76794]|0);U=p-L|0;c[n>>2]=U;V=(((U|0)>-1?U:0-U|0)|0)==1;if(T){if(V){c[76790]=(p|0)>=(L|0)?p:L;R=0;S=25;break}else{c[76790]=(p|0)<=(L|0)?p:L;a[306784]=1;S=26;break}}T=c[76794]|0;U=(p|0)<=(L|0)?p:L;if(!(V&(P|0)==(T|0))){V=(U|0)<=(P|0)?U:P;c[n>>2]=V;c[76790]=(V|0)<=(T|0)?V:T;a[306784]=1;S=26;break}if((P-U|0)==3){c[76790]=((p|0)>=(L|0)?p:L)+ -1+(c[76770]|0);R=0;S=25;break}else{c[76790]=U;a[306784]=1;S=26;break}}}while(0);if((S|0)==25){if(a[306784]&1){S=26}else{W=R}}if((S|0)==26){a[306776]=0;MUc(307256)|0;bUc(307280,307160,4)|0;uUc()|0;W=c[76776]|0}if((W|0)==0){X=(c[76808]|0)!=0|0}else{X=1}c[76776]=X;h[38401]=1.0;X=c[76790]|0;W=1-X|0;c[n>>2]=W;c[76768]=1;if((X|0)<=0){O=+h[38394];X=1;G=1.0;while(1){h[o>>3]=G*O;I=+wDc(o,307136);h[38401]=I;n=X+1|0;c[76768]=n;if((X|0)<(W|0)){G=I;X=n}else{break}}}yDc(307144,307080,307160,307104,307168,307216)|0;q=307144;r=c[76786]|0;c[b>>2]=r;s=307080;t=c[76770]|0;c[d>>2]=t;u=307120;v=c[76780]|0;c[e>>2]=v;w=307128;x=+h[38391];h[f>>3]=x;y=307160;z=c[76790]|0;c[g>>2]=z;A=307208;B=+h[38401];h[j>>3]=B;C=307168;D=c[76792]|0;c[k>>2]=D;E=307216;F=+h[38402];h[l>>3]=F;i=m;return 0}function vDc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;if(a[306672]&1){l=a[306744]&1;m=c[76688]|0;c[b>>2]=m;n=306720;o=c[76680]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=306768;r=c[76692]|0;c[f>>2]=r;i=g;return 0}a[306672]=1;h[38341]=1.0;h[38335]=1.0;h[38337]=1.0;s=1.0;do{s=s*2.0;h[38335]=s;h[38337]=+wDc(306680,306728);h[j>>3]=-s;t=+wDc(306696,j);h[38337]=t;}while(t==1.0);h[38336]=1.0;t=+wDc(306680,306688);h[38337]=t;if(t==s){u=1.0;while(1){v=u*2.0;h[38336]=v;w=+wDc(306680,306688);h[38337]=w;if(w==s){u=v}else{x=w;break}}}else{x=t}h[38342]=.25;h[38345]=x;h[j>>3]=-s;t=+wDc(306696,j);h[38337]=t;y=~~(t+.25);c[76688]=y;t=+(y|0);h[38336]=t;u=t*.5;h[j>>3]=u;h[k>>3]=-t/100.0;h[38338]=+wDc(j,k);w=+wDc(306704,306680);h[38337]=w;z=w==s;a[306744]=z&1;h[j>>3]=u;h[k>>3]=t/100.0;h[38338]=+wDc(j,k);w=+wDc(306704,306680);h[38337]=w;if(z&w==s){a[306744]=0;A=0}else{A=z}h[j>>3]=u;w=+wDc(j,306680);h[38339]=w;h[j>>3]=u;z=w==s&+wDc(j,306760)>x;c[76692]=z?A&1:0;c[76680]=0;h[38335]=1.0;h[38337]=1.0;x=1.0;z=0;while(1){k=z+1|0;c[76680]=k;s=x*t;h[38335]=s;h[38337]=+wDc(306680,306728);h[j>>3]=-s;w=+wDc(306696,j);h[38337]=w;if(w==1.0){z=k;x=s}else{l=A;m=y;break}}c[b>>2]=m;n=306720;o=c[76680]|0;c[d>>2]=o;p=l&1;c[e>>2]=p;q=306768;r=c[76692]|0;c[f>>2]=r;i=g;return 0}function wDc(a,b){a=a|0;b=b|0;i=i;return+(+h[a>>3]+ +h[b>>3])}function xDc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0.0,j=0.0,k=0.0,l=0,m=0.0,n=0.0,o=0,p=0.0,q=0.0,r=0.0,s=0.0,t=0,u=0.0,v=0.0;e=i;i=i+8|0;f=e;g=+h[b>>3];h[38411]=g;j=1.0/+(c[d>>2]|0);h[38420]=j;h[38419]=0.0;c[a>>2]=1;h[f>>3]=g*j;k=+wDc(f,307352);h[38413]=k;h[38415]=g;h[38416]=g;h[38417]=g;h[38418]=g;if(g==g&0.0==0.0){l=0;m=k}else{i=e;return 0}while(1){c[a>>2]=l;h[38411]=m;b=c[d>>2]|0;k=+(b|0);h[f>>3]=m/k;g=+wDc(f,307352);h[38413]=g;h[f>>3]=g*k;k=+wDc(f,307352);h[38415]=k;h[38417]=0.0;c[76824]=1;if((b|0)<1){n=0.0}else{o=1;p=0.0;while(1){q=g+p;if((o|0)<(b|0)){p=q;o=o+1|0}else{break}}h[38417]=q;c[76824]=b+1;n=q}h[f>>3]=m*j;p=+wDc(f,307352);h[38414]=p;h[f>>3]=p/j;r=+wDc(f,307352);h[38416]=r;h[38418]=0.0;o=c[d>>2]|0;c[76824]=1;if((o|0)<1){s=0.0}else{t=1;u=0.0;while(1){v=p+u;if((t|0)<(o|0)){u=v;t=t+1|0}else{break}}h[38418]=v;c[76824]=o+1;s=v}if(!(k==m&r==m&n==m&s==m)){break}l=(c[a>>2]|0)+ -1|0;m=g}i=e;return 0}function yDc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0,F=0.0;j=i;i=i+8|0;k=j;c[76848]=1;c[76856]=1;l=0-(c[d>>2]|0)|0;if((l|0)<2){m=2;n=l;o=2;p=1}else{l=1;q=2;while(1){c[76848]=q;r=l+1|0;c[76856]=r;s=q<<1;t=0-(c[d>>2]|0)|0;if((s|0)>(t|0)){break}else{q=s;l=r}}m=s;n=t;o=l+2|0;p=q}if((p|0)==(n|0)){c[76852]=n;u=n}else{c[76852]=m;c[76856]=o;u=m}m=c[d>>2]|0;o=((m+u|0)>(0-(p+m)|0)?p:u)<<1;c[76858]=o;u=o+(c[d>>2]|0)|0;d=u+ -1|0;c[f>>2]=d;do{if((((c[76856]|0)+1+(c[b>>2]|0)|0)%2|0|0)==1){if((c[a>>2]|0)!=2){v=d;break}o=u+ -2|0;c[f>>2]=o;v=o}else{v=d}}while(0);if((c[e>>2]|0)!=0){c[f>>2]=v+ -1}w=+(c[a>>2]|0);x=1.0/w;h[38427]=x;y=w+-1.0;h[38423]=y;h[38422]=0.0;v=c[b>>2]|0;c[76842]=1;do{if((v|0)<1){z=0.0}else{b=1;w=0.0;A=y;while(1){B=x*A;h[38423]=B;if(w<1.0){h[38425]=w}C=+wDc(307376,307384);h[38422]=C;e=b+1|0;c[76842]=e;if((b|0)<(v|0)){b=e;w=C;A=B}else{break}}if(!(C>=1.0)){z=C;break}A=+h[38425];h[38422]=A;z=A}}while(0);v=c[f>>2]|0;c[76842]=1;if((v|0)<1){D=z;h[g>>3]=D;i=j;return 0}else{E=1;F=z}while(1){h[k>>3]=F*+(c[a>>2]|0);z=+wDc(k,307440);h[38422]=z;f=E+1|0;c[76842]=f;if((E|0)<(v|0)){F=z;E=f}else{D=z;break}}h[g>>3]=D;i=j;return 0}function zDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;g=i;i=i+16|0;j=g;k=g+8|0;l=c[b>>2]|0;b=~l;c[f>>2]=0;m=c[d>>2]|0;n=m+ -1|0;if((m|0)<2){o=m}else{c[76864]=1;m=1;do{c[76870]=m+1;c[j>>2]=(c[d>>2]|0)+1-m;p=ADc(j,a+(m+b+(fa(m,l)|0)<<3)|0,307488)|0;q=c[76864]|0;r=p+ -1+q|0;c[76866]=r;c[e+(q+ -1<<2)>>2]=r;r=c[76866]|0;q=c[76864]|0;p=fa(q,l)|0;s=+h[a+(r+b+p<<3)>>3];do{if(s==0.0){c[f>>2]=q}else{if((r|0)==(q|0)){t=r}else{h[38434]=s;u=a+(q+b+p<<3)|0;h[a+(p+b+r<<3)>>3]=+h[u>>3];h[u>>3]=+h[38434];t=q}u=fa(t,l)|0;h[38434]=-1.0/+h[a+(t+b+u<<3)>>3];c[j>>2]=(c[d>>2]|0)-t;BDc(j,307472,a+(t-l+u<<3)|0,307488)|0;u=c[d>>2]|0;c[j>>2]=u;v=c[76870]|0;c[76862]=v;if((v|0)>(u|0)){break}else{w=v}do{v=c[76866]|0;x=fa(w,l)|0;h[38434]=+h[a+(x+b+v<<3)>>3];y=c[76864]|0;if((v|0)==(y|0)){z=v}else{A=a+(y+b+x<<3)|0;h[a+(v+b+x<<3)>>3]=+h[A>>3];h[A>>3]=+h[38434];z=y}c[k>>2]=(c[d>>2]|0)-z;y=z+1|0;A=307488;CDc(k,307472,a+((fa(z,l)|0)+b+y<<3)|0,A,a+(y+b+x<<3)|0,A)|0;A=c[76862]|0;w=A+1|0;c[76862]=w;}while((A|0)<(u|0))}}while(0);q=c[76864]|0;m=q+1|0;c[76864]=m;}while((q|0)<(n|0));o=c[d>>2]|0}c[e+(o+ -1<<2)>>2]=o;o=c[d>>2]|0;if(!(+h[a+(o+b+(fa(o,l)|0)<<3)>>3]==0.0)){i=g;return 0}c[f>>2]=o;i=g;return 0}function ADc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0,n=0,o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}if((c[d>>2]|0)!=1){c[76962]=1;j=+h[b>>3];if(!(j>=0.0)){k=-j}else{k=j}h[38482]=k;l=(c[d>>2]|0)+1|0;c[76962]=l;m=c[a>>2]|0;c[76960]=2;if((m|0)<2){g=1;i=e;return g|0}else{n=2;o=k;p=l;q=1}while(1){k=+h[b+(p+ -1<<3)>>3];l=!(k>=0.0);if(l){r=-k}else{r=k}if(!(r<=o)){if(l){s=-k}else{s=k}h[38482]=s;t=s;u=n}else{t=o;u=q}l=p+(c[d>>2]|0)|0;c[76962]=l;a=n+1|0;c[76960]=a;if((n|0)<(m|0)){n=a;o=t;p=l;q=u}else{g=u;break}}i=e;return g|0}t=+h[b>>3];if(!(t>=0.0)){v=-t}else{v=t}h[38482]=v;c[76960]=2;if((f|0)<2){g=1;i=e;return g|0}else{w=v;x=2;y=1}while(1){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){z=-v}else{z=v}if(!(z<=w)){v=+h[b+(x+ -1<<3)>>3];if(!(v>=0.0)){A=-v}else{A=v}h[38482]=A;B=A;C=x}else{B=w;C=y}if((x|0)<(f|0)){w=B;x=x+1|0;y=C}else{break}}c[76960]=f+1;g=C;i=e;return g|0}function BDc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)!=1){e=fa(j,g)|0;c[76946]=1;k=(j|0)<0;if(k?(e|0)<2:(e|0)>0){l=1}else{i=f;return 0}do{m=d+(l+ -1<<3)|0;h[m>>3]=+h[b>>3]*+h[m>>3];l=l+j|0;}while(k?(l|0)>=(e|0):(l|0)<=(e|0));c[76946]=l;i=f;return 0}l=(g|0)%5|0;c[76948]=l;do{if((l|0)==0){n=c[a>>2]|0}else{c[76946]=1;if((l|0)>=1){g=1;while(1){e=d+(g+ -1<<3)|0;h[e>>3]=+h[b>>3]*+h[e>>3];if((g|0)<(l|0)){g=g+1|0}else{break}}c[76946]=l+1}g=c[a>>2]|0;if((g|0)>=5){n=g;break}i=f;return 0}}while(0);a=l+1|0;c[76946]=a;if((l|0)<(n|0)){o=a}else{i=f;return 0}do{a=d+(o+ -1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+1<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+2<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];a=d+(o+3<<3)|0;h[a>>3]=+h[b>>3]*+h[a>>3];o=o+5|0;}while((o|0)<=(n|0));c[76946]=o;i=f;return 0}function CDc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0.0,m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0;j=i;k=c[a>>2]|0;if((k|0)<1){i=j;return 0}l=+h[b>>3];if(l==0.0){i=j;return 0}do{if((c[e>>2]|0)==1){if((c[g>>2]|0)!=1){break}m=(k|0)%4|0;c[76932]=m;do{if((m|0)==0){n=c[a>>2]|0}else{c[76930]=1;if((m|0)>=1){o=l;p=1;q=0;while(1){r=f+(q<<3)|0;h[r>>3]=+h[r>>3]+o*+h[d+(q<<3)>>3];if((p|0)>=(m|0)){break}r=p;o=+h[b>>3];p=p+1|0;q=r}c[76930]=m+1}q=c[a>>2]|0;if((q|0)>=4){n=q;break}i=j;return 0}}while(0);q=m+1|0;c[76930]=q;if((m|0)<(n|0)){s=q}else{i=j;return 0}do{q=s+ -1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=f+(s<<3)|0;h[q>>3]=+h[q>>3]+ +h[b>>3]*+h[d+(s<<3)>>3];q=s+1|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];q=s+2|0;p=f+(q<<3)|0;h[p>>3]=+h[p>>3]+ +h[b>>3]*+h[d+(q<<3)>>3];s=s+4|0;}while((s|0)<=(n|0));c[76930]=s;i=j;return 0}}while(0);c[76934]=1;c[76936]=1;s=c[e>>2]|0;if((s|0)<0){n=(fa(1-(c[a>>2]|0)|0,s)|0)+1|0;c[76934]=n;t=n}else{t=1}n=c[g>>2]|0;if((n|0)<0){s=(fa(1-(c[a>>2]|0)|0,n)|0)+1|0;c[76936]=s;u=s}else{u=1}s=c[a>>2]|0;c[76930]=1;if((s|0)<1){i=j;return 0}else{v=l;w=1;x=u;y=t}while(1){t=f+(x+ -1<<3)|0;h[t>>3]=v*+h[d+(y+ -1<<3)>>3]+ +h[t>>3];t=y+(c[e>>2]|0)|0;c[76934]=t;u=x+(c[g>>2]|0)|0;c[76936]=u;a=w+1|0;c[76930]=a;if((w|0)>=(s|0)){break}v=+h[b>>3];y=t;x=u;w=a}i=j;return 0}function DDc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0.0,t=0;j=i;i=i+8|0;k=j;l=c[b>>2]|0;b=~l;m=c[d>>2]|0;n=m+ -1|0;c[76882]=n;if((c[g>>2]|0)==0){if((m|0)>=2){c[76874]=1;m=1;do{g=m+ -1|0;o=c[e+(g<<2)>>2]|0;c[76876]=o;p=f+(o+ -1<<3)|0;h[38439]=+h[p>>3];if((o|0)!=(m|0)){o=f+(g<<3)|0;h[p>>3]=+h[o>>3];h[o>>3]=+h[38439]}c[k>>2]=(c[d>>2]|0)-m;o=307488;CDc(k,307512,a+(m-l+(fa(m,l)|0)<<3)|0,o,f+(m<<3)|0,o)|0;o=c[76874]|0;m=o+1|0;c[76874]=m;}while((o|0)<(n|0))}m=c[d>>2]|0;c[76880]=1;if((m|0)<1){i=j;return 0}else{q=1}do{o=1-q+(c[d>>2]|0)|0;c[76874]=o;p=fa(o,l)|0;g=o+ -1|0;r=f+(g<<3)|0;s=+h[r>>3]/+h[a+(o+b+p<<3)>>3];h[r>>3]=s;h[38439]=-s;c[k>>2]=g;g=307488;CDc(k,307512,a+(p-l<<3)|0,g,f,g)|0;g=c[76880]|0;q=g+1|0;c[76880]=q;}while((g|0)<(m|0));i=j;return 0}m=c[d>>2]|0;c[76874]=1;if((m|0)<1){t=n}else{n=1;do{c[k>>2]=n+ -1;q=307488;s=+EDc(k,a+((fa(n,l)|0)-l<<3)|0,q,f,q);h[38439]=s;q=c[76874]|0;g=f+(q+ -1<<3)|0;h[g>>3]=(+h[g>>3]-s)/+h[a+(q+b+(fa(q,l)|0)<<3)>>3];n=q+1|0;c[76874]=n;}while((q|0)<(m|0));t=c[76882]|0}if((t|0)<1){i=j;return 0}c[76880]=1;m=1;do{n=(c[d>>2]|0)-m|0;c[76874]=n;c[k>>2]=(c[d>>2]|0)-n;b=307488;s=+EDc(k,a+(n-l+(fa(n,l)|0)<<3)|0,b,f+(n<<3)|0,b);b=c[76874]|0;n=b+ -1|0;q=f+(n<<3)|0;h[q>>3]=s+ +h[q>>3];g=c[e+(n<<2)>>2]|0;c[76876]=g;if((g|0)!=(b|0)){b=f+(g+ -1<<3)|0;h[38439]=+h[b>>3];h[b>>3]=+h[q>>3];h[q>>3]=+h[38439]}q=c[76880]|0;m=q+1|0;c[76880]=m;}while((q|0)<(t|0));i=j;return 0}function EDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0,s=0.0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0.0,B=0,C=0;g=i;h[38479]=0.0;j=c[a>>2]|0;if((j|0)<1){k=0.0;i=g;return+k}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}l=(j|0)%5|0;c[76952]=l;do{if((l|0)==0){m=c[a>>2]|0;n=0.0}else{c[76950]=1;if((l|0)<1){o=0.0}else{p=0.0;q=1;while(1){r=q+ -1|0;s=p+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3];h[38479]=s;if((q|0)<(l|0)){q=q+1|0;p=s}else{break}}c[76950]=l+1;o=s}q=c[a>>2]|0;if((q|0)<5){k=o}else{m=q;n=o;break}i=g;return+k}}while(0);q=l+1|0;c[76950]=q;if((l|0)<(m|0)){t=n;u=q}else{k=n;i=g;return+k}do{q=u+ -1|0;r=u+1|0;v=u+2|0;w=u+3|0;t=t+ +h[b+(q<<3)>>3]*+h[e+(q<<3)>>3]+ +h[b+(u<<3)>>3]*+h[e+(u<<3)>>3]+ +h[b+(r<<3)>>3]*+h[e+(r<<3)>>3]+ +h[b+(v<<3)>>3]*+h[e+(v<<3)>>3]+ +h[b+(w<<3)>>3]*+h[e+(w<<3)>>3];h[38479]=t;u=u+5|0;}while((u|0)<=(m|0));c[76950]=u;k=t;i=g;return+k}}while(0);c[76954]=1;c[76956]=1;u=c[d>>2]|0;if((u|0)<0){m=(fa(1-(c[a>>2]|0)|0,u)|0)+1|0;c[76954]=m;x=m}else{x=1}m=c[f>>2]|0;if((m|0)<0){u=(fa(1-(c[a>>2]|0)|0,m)|0)+1|0;c[76956]=u;y=u}else{y=1}u=c[a>>2]|0;c[76950]=1;if((u|0)<1){k=0.0;i=g;return+k}else{z=1;A=0.0;B=y;C=x}while(1){t=A+ +h[b+(C+ -1<<3)>>3]*+h[e+(B+ -1<<3)>>3];h[38479]=t;x=C+(c[d>>2]|0)|0;c[76954]=x;y=B+(c[f>>2]|0)|0;c[76956]=y;a=z+1|0;c[76950]=a;if((z|0)<(u|0)){C=x;B=y;A=t;z=a}else{k=t;break}}i=g;return+k}function FDc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;k=i;i=i+8|0;l=k;m=c[b>>2]|0;b=~m;c[76892]=(c[e>>2]|0)+1+(c[f>>2]|0);c[j>>2]=0;n=(c[f>>2]|0)+2|0;c[76898]=n;o=c[d>>2]|0;p=c[76892]|0;q=(o|0)>(p|0)?p:o;o=q+ -1|0;c[76900]=o;do{if((q|0)>(n|0)){c[76908]=n;if((n|0)>(o|0)){break}else{r=n}while(1){s=1-r+p|0;c[76896]=s;t=c[e>>2]|0;c[76884]=s;if((s|0)<=(t|0)){u=s;while(1){h[a+(u+b+(fa(r,m)|0)<<3)>>3]=0.0;if((u|0)<(t|0)){u=u+1|0}else{break}}c[76884]=t+1}u=r+1|0;c[76908]=u;if((r|0)<(o|0)){r=u}else{break}}c[l>>2]=t}}while(0);c[76908]=o;c[76906]=0;t=c[d>>2]|0;r=t+ -1|0;if((t|0)<2){v=t}else{c[76888]=1;t=o;o=1;while(1){c[76910]=o+1;p=t+1|0;c[76908]=p;n=c[d>>2]|0;do{if((t|0)<(n|0)){q=c[e>>2]|0;if((q|0)<1){w=n;break}c[l>>2]=q;c[76884]=1;u=fa(p,m)|0;s=1;while(1){h[a+(s+b+u<<3)>>3]=0.0;if((s|0)<(q|0)){s=s+1|0}else{break}}c[76884]=q+1;w=c[d>>2]|0}else{w=n}}while(0);n=c[e>>2]|0;p=w-o|0;s=(n|0)<=(p|0)?n:p;c[76902]=s;c[l>>2]=s+1;s=ADc(l,a+((c[76892]|0)+b+(fa(o,m)|0)<<3)|0,307488)|0;p=s+ -1|0;c[76890]=p+(c[76892]|0);s=c[76888]|0;c[g+(s+ -1<<2)>>2]=p+s;s=c[76890]|0;p=c[76888]|0;n=fa(p,m)|0;x=+h[a+(s+b+n<<3)>>3];a:do{if(x==0.0){c[j>>2]=p}else{u=c[76892]|0;if((s|0)==(u|0)){y=s}else{h[38447]=x;z=a+(u+b+n<<3)|0;h[a+(n+b+s<<3)>>3]=+h[z>>3];h[z>>3]=+h[38447];y=u}h[38447]=-1.0/+h[a+(y+b+n<<3)>>3];BDc(307608,307576,a+(y-m+n<<3)|0,307488)|0;u=c[76906]|0;z=(c[g+((c[76888]|0)+ -1<<2)>>2]|0)+(c[f>>2]|0)|0;A=(u|0)>=(z|0)?u:z;c[l>>2]=A;z=c[d>>2]|0;u=(A|0)>(z|0)?z:A;c[76906]=u;A=c[76892]|0;c[76904]=A;z=c[76910]|0;if((u|0)<(z|0)){break}c[l>>2]=u;c[76886]=z;B=z;z=A;while(1){A=(c[76890]|0)+ -1|0;c[76890]=A;C=z+ -1|0;c[76904]=C;D=fa(B,m)|0;E=a+(A+b+D<<3)|0;h[38447]=+h[E>>3];if((A|0)==(C|0)){F=A}else{A=a+(C+b+D<<3)|0;h[E>>3]=+h[A>>3];h[A>>3]=+h[38447];F=C}C=307488;CDc(307608,307576,a+((c[76892]|0)-m+(fa(c[76888]|0,m)|0)<<3)|0,C,a+(F-m+D<<3)|0,C)|0;C=c[76886]|0;D=C+1|0;c[76886]=D;if((C|0)>=(u|0)){break a}B=D;z=c[76904]|0}}}while(0);n=c[76888]|0;s=n+1|0;c[76888]=s;if((n|0)>=(r|0)){break}t=c[76908]|0;o=s}v=c[d>>2]|0}c[g+(v+ -1<<2)>>2]=v;v=c[d>>2]|0;if(!(+h[a+((c[76892]|0)+b+(fa(v,m)|0)<<3)>>3]==0.0)){i=k;return 0}c[j>>2]=v;i=k;return 0}function GDc(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0;l=i;m=c[b>>2]|0;b=~m;n=(c[f>>2]|0)+1+(c[e>>2]|0)|0;c[76916]=n;f=c[d>>2]|0;o=f+ -1|0;c[76928]=o;if((c[k>>2]|0)==0){if(!((c[e>>2]|0)==0|(f|0)<2)){c[76912]=1;f=1;do{k=c[e>>2]|0;p=(c[d>>2]|0)-f|0;c[76926]=(k|0)<=(p|0)?k:p;p=f+ -1|0;k=c[g+(p<<2)>>2]|0;c[76914]=k;q=j+(k+ -1<<3)|0;h[38459]=+h[q>>3];if((k|0)!=(f|0)){k=j+(p<<3)|0;h[q>>3]=+h[k>>3];h[k>>3]=+h[38459]}k=307488;CDc(307704,307672,a+((c[76916]|0)-m+(fa(f,m)|0)<<3)|0,k,j+(f<<3)|0,k)|0;k=c[76912]|0;f=k+1|0;c[76912]=f;}while((k|0)<(o|0))}f=c[d>>2]|0;c[76920]=1;if((f|0)<1){i=l;return 0}else{r=1}do{k=1-r+(c[d>>2]|0)|0;c[76912]=k;q=c[76916]|0;p=fa(k,m)|0;s=j+(k+ -1<<3)|0;t=+h[s>>3]/+h[a+(q+b+p<<3)>>3];h[s>>3]=t;s=((k|0)<=(q|0)?k:q)+ -1|0;c[76926]=s;u=q-s|0;c[76922]=u;q=k-s|0;c[76924]=q;h[38459]=-t;s=307488;CDc(307704,307672,a+(u+b+p<<3)|0,s,j+(q+ -1<<3)|0,s)|0;s=c[76920]|0;r=s+1|0;c[76920]=r;}while((s|0)<(f|0));i=l;return 0}f=c[d>>2]|0;c[76912]=1;if((f|0)<1){v=n;w=o}else{o=n;n=1;do{r=((n|0)<=(o|0)?n:o)+ -1|0;c[76926]=r;s=o-r|0;c[76922]=s;q=n-r|0;c[76924]=q;r=307488;t=+EDc(307704,a+((fa(n,m)|0)+b+s<<3)|0,r,j+(q+ -1<<3)|0,r);h[38459]=t;r=c[76912]|0;q=j+(r+ -1<<3)|0;o=c[76916]|0;h[q>>3]=(+h[q>>3]-t)/+h[a+((fa(r,m)|0)+b+o<<3)>>3];n=r+1|0;c[76912]=n;}while((r|0)<(f|0));v=o;w=c[76928]|0}if((c[e>>2]|0)==0|(w|0)<1){i=l;return 0}c[76920]=1;o=v;v=1;while(1){f=(c[d>>2]|0)-v|0;c[76912]=f;n=c[e>>2]|0;b=(c[d>>2]|0)-f|0;c[76926]=(n|0)<=(b|0)?n:b;b=307488;t=+EDc(307704,a+(o-m+(fa(f,m)|0)<<3)|0,b,j+(f<<3)|0,b);b=c[76912]|0;f=b+ -1|0;n=j+(f<<3)|0;h[n>>3]=t+ +h[n>>3];r=c[g+(f<<2)>>2]|0;c[76914]=r;if((r|0)!=(b|0)){b=j+(r+ -1<<3)|0;h[38459]=+h[b>>3];h[b>>3]=+h[n>>3];h[n>>3]=+h[38459]}n=c[76920]|0;b=n+1|0;c[76920]=b;if((n|0)>=(w|0)){break}o=c[76916]|0;v=b}i=l;return 0}function HDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}do{if((c[d>>2]|0)==1){if((c[f>>2]|0)!=1){break}k=(j|0)%7|0;c[76940]=k;do{if((k|0)==0){l=c[a>>2]|0}else{c[76938]=1;if((k|0)>=1){m=1;while(1){n=m+ -1|0;h[e+(n<<3)>>3]=+h[b+(n<<3)>>3];if((m|0)<(k|0)){m=m+1|0}else{break}}c[76938]=k+1}m=c[a>>2]|0;if((m|0)>=7){l=m;break}i=g;return 0}}while(0);m=k+1|0;c[76938]=m;if((k|0)<(l|0)){o=m}else{i=g;return 0}do{m=o+ -1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];h[e+(o<<3)>>3]=+h[b+(o<<3)>>3];m=o+1|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+2|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+3|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+4|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];m=o+5|0;h[e+(m<<3)>>3]=+h[b+(m<<3)>>3];o=o+7|0;}while((o|0)<=(l|0));c[76938]=o;i=g;return 0}}while(0);c[76942]=1;c[76944]=1;o=c[d>>2]|0;if((o|0)<0){l=(fa(1-(c[a>>2]|0)|0,o)|0)+1|0;c[76942]=l;p=l}else{p=1}l=c[f>>2]|0;if((l|0)<0){o=(fa(1-(c[a>>2]|0)|0,l)|0)+1|0;c[76944]=o;q=o}else{q=1}o=c[a>>2]|0;c[76938]=1;if((o|0)<1){i=g;return 0}else{r=1;s=q;t=p}while(1){h[e+(s+ -1<<3)>>3]=+h[b+(t+ -1<<3)>>3];p=t+(c[d>>2]|0)|0;c[76942]=p;q=s+(c[f>>2]|0)|0;c[76944]=q;a=r+1|0;c[76938]=a;if((r|0)<(o|0)){t=p;s=q;r=a}else{break}}i=g;return 0}function IDc(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0.0,C=0.0,D=0,E=0,F=0,G=0.0,H=0.0,I=0.0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0.0,R=0;d=i;m=+JDc(307864);n=c[a>>2]|0;o=(n|0)<1;do{if(!o){p=((fa(n+1|0,n)|0)/2|0)+1|0;q=1;while(1){r=n-q|0;s=r+1|0;t=r+2|0;u=p-q|0;if((n|0)<(t|0)){v=0.0}else{w=t;t=u;x=0.0;while(1){y=x+ +h[b+(t<<3)>>3]*+h[j+(w+ -1<<3)>>3];if((w|0)<(n|0)){x=y;t=t+1|0;w=w+1|0}else{v=y;break}}}x=+h[b+(u+ -1<<3)>>3];do{if(x!=0.0){z=x}else{if((r|0)<0){A=x}else{w=1;t=s;y=x;while(1){B=+h[b+(t+ -1<<3)>>3];if(!(B>=0.0)){C=-B}else{C=B}B=y>=C?y:C;D=t-w+n|0;if((w|0)<(s|0)){w=w+1|0;t=D;y=B}else{A=B;break}}}y=m*A;if(!(y==0.0)){z=y;break}z=m}}while(0);h[j+(r<<3)>>3]=(+h[f+(r<<3)>>3]-v)/z;if((q|0)<(n|0)){q=q+1|0;p=u}else{break}}if(o){break}else{E=1}while(1){p=E+ -1|0;h[k+(p<<3)>>3]=0.0;h[l+(p<<3)>>3]=+h[e+(p<<3)>>3]*+h[j+(p<<3)>>3];if((E|0)<(n|0)){E=E+1|0}else{break}}}}while(0);z=+KDc(a,l);if(z<=+h[g>>3]){i=d;return 0}E=c[a>>2]|0;if((E|0)>=1){n=E;o=1;p=1;while(1){q=o+ -1|0;v=+h[f+(q<<3)>>3];if((o|0)>(E|0)){F=p}else{s=o;t=p;while(1){w=k+(s+ -1<<3)|0;h[w>>3]=+h[w>>3]+v*+h[b+(t+ -1<<3)>>3];if((s|0)<(E|0)){t=t+1|0;s=s+1|0}else{break}}F=p+n|0}s=k+(q<<3)|0;h[s>>3]=+h[s>>3]/+h[e+(q<<3)>>3];if((o|0)<(E|0)){n=n+ -1|0;o=o+1|0;p=F}else{break}}}v=+KDc(a,k);m=+h[g>>3];do{if(v==0.0){G=m;H=m/z;I=0.0}else{F=c[a>>2]|0;p=(F|0)<1;do{if(!p){o=1;while(1){n=o+ -1|0;E=k+(n<<3)|0;h[E>>3]=+h[E>>3]/v/+h[e+(n<<3)>>3];if((o|0)<(F|0)){o=o+1|0}else{break}}if(p){break}else{J=F;K=1;L=1}while(1){if((K|0)>(F|0)){M=L;N=0.0}else{o=K;u=L;A=0.0;while(1){O=A+ +h[b+(u+ -1<<3)>>3]*+h[k+(o+ -1<<3)>>3];if((o|0)<(F|0)){A=O;u=u+1|0;o=o+1|0}else{break}}M=L+J|0;N=O}h[l+(K+ -1<<3)>>3]=N;if((K|0)<(F|0)){J=J+ -1|0;K=K+1|0;L=M}else{break}}}}while(0);A=+KDc(a,l);C=v/A/A;A=+h[g>>3];if(C>=A){G=A;H=0.0;I=C;break}A=+KDc(a,f);x=+h[g>>3];y=C/x;B=A/v*(A/z)*y;A=x/z;P=B-A;Q=y*y;y=1.0-Q;G=x;H=A*y/(+V(+(P*P+y*(1.0-A*A)))+(B-A*Q));I=C}}while(0);z=(1.0-H)*(!(I<=G)?G:I);g=c[a>>2]|0;if((g|0)<1){i=d;return 0}else{R=1}while(1){a=R+ -1|0;f=j+(a<<3)|0;h[f>>3]=z*+h[k+(a<<3)>>3]+H*+h[f>>3];if((R|0)<(g|0)){R=R+1|0}else{break}}i=d;return 0}function JDc(a){a=a|0;i=i;return+(+h[307872+((((c[a>>2]<<3)+ -8|0)/8|0)<<3)>>3])}function KDc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0.0,g=0.0,j=0.0,k=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0.0;d=i;e=c[a>>2]|0;f=1304.0e16/+(e|0);do{if((e|0)<1){g=0.0;j=0.0}else{a=1;k=0.0;l=0.0;m=0.0;n=0.0;o=0.0;while(1){p=+h[b+(a+ -1<<3)>>3];if(!(p>=0.0)){q=-p}else{q=p}do{if(q>3.834e-20&q<f){r=k;s=l+q*q;t=m;u=n;v=o}else{if(!(q<=3.834e-20)){if(!(q<=n)){p=n/q;r=k*p*p+1.0;s=l;t=m;u=q;v=o;break}else{p=q/n;r=k+p*p;s=l;t=m;u=n;v=o;break}}if(!(q<=o)){p=o/q;r=k;s=l;t=m*p*p+1.0;u=n;v=q;break}if(!(q!=0.0)){r=k;s=l;t=m;u=n;v=o;break}p=q/o;r=k;s=l;t=m+p*p;u=n;v=o}}while(0);if((a|0)<(e|0)){a=a+1|0;k=r;l=s;m=t;n=u;o=v}else{break}}if(!(r==0.0)){w=u*+V(+(r+s/u/u));i=d;return+w}if(s==0.0){g=t;j=v;break}if(!(s>=v)){x=0.0}else{x=+V(+(s*(t*v*(v/s)+1.0)))}if(!(s<v)){w=x;i=d;return+w}w=+V(+(v*(t*v+s/v)));i=d;return+w}}while(0);w=j*+V(+g);i=d;return+w}function LDc(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y,z,A){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;z=z|0;A=A|0;var B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0.0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0,ga=0,ha=0,ia=0.0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0,za=0.0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0.0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0.0;B=i;i=i+32|0;C=B;D=B+8|0;E=B+16|0;F=B+24|0;G=c[g>>2]|0;H=~G;I=+JDc(307904);c[p>>2]=0;c[E>>2]=0;c[q>>2]=0;c[r>>2]=0;K=c[b>>2]|0;a:do{if((K|0)<1){L=97}else{if((c[g>>2]|0)<(K|0)){L=97;break}if(+h[j>>3]<0.0){L=97;break}if((c[k>>2]|0)<1){L=97;break}if(+h[n>>3]<=0.0){L=97;break}if((c[t>>2]|0)<((fa(K+1|0,K)|0)/2|0|0)){L=97;break}if((c[m>>2]|0)==2){M=1;while(1){if(+h[l+(M+ -1<<3)>>3]<=0.0){L=97;break a}if((M|0)<(K|0)){M=M+1|0}else{break}}}c[E>>2]=1;M=a;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[q>>2]=1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}P=+KDc(b,e);c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;N=c[E>>2]|0;if((N|0)<0){O=N;L=98;break}N=C;Q=P;R=1;S=0;T=0;U=0;V=0;P=0.0;b:while(1){TDc(b,b,f,g,307912,N,307904,v,w,x)|0;do{if((R|0)==1){W=c[b>>2]|0;do{if((c[m>>2]|0)==2){L=20}else{if((W|0)<1){break}else{X=1}while(1){Y=X+ -1|0;Z=w+(Y<<3)|0;_=l+(Y<<3)|0;h[_>>3]=+h[Z>>3];if(+h[Z>>3]==0.0){h[_>>3]=1.0}if((X|0)<(W|0)){X=X+1|0}else{L=20;break}}}}while(0);do{if((L|0)==20){L=0;if((W|0)<1){break}else{$=1}while(1){_=$+ -1|0;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[d+(_<<3)>>3];if(($|0)<(W|0)){$=$+1|0}else{break}}}}while(0);aa=+KDc(b,x);ba=+h[n>>3];ca=aa*ba;h[F>>3]=ca;if(!(ca==0.0)){da=aa;break}h[F>>3]=ba;da=aa}else{da=P}}while(0);W=c[b>>2]|0;_=(W|0)<1;do{if(_){L=35}else{Z=1;while(1){Y=Z+ -1|0;h[u+(Y<<3)>>3]=+h[e+(Y<<3)>>3];if((Z|0)<(W|0)){Z=Z+1|0}else{break}}if(_){L=35;break}else{ea=1}while(1){Z=fa(ea,G)|0;aa=+h[f+(ea+H+Z<<3)>>3];do{if(!(aa==0.0)){Y=(ea|0)>(W|0);if(Y){break}ga=Z+H|0;ha=ea;ba=0.0;while(1){ia=ba+ +h[f+(ga+ha<<3)>>3]*+h[u+(ha+ -1<<3)>>3];if((ha|0)<(W|0)){ba=ia;ha=ha+1|0}else{break}}ba=-ia/aa;if(Y){break}ha=Z+H|0;ga=ea;while(1){ja=u+(ga+ -1<<3)|0;h[ja>>3]=+h[ja>>3]+ba*+h[f+(ha+ga<<3)>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}}while(0);if((ea|0)<(W|0)){ea=ea+1|0}else{break}}c[D>>2]=0;if(_){break}else{ka=0;la=1}while(1){Z=(ka|0)>1?ka:1;ga=Z+ -1|0;ha=c5c(ga|0,0,Z+ -2|0,0)|0;Z=X4c(ha|0,J&1|0,1)|0;ha=la+ -1|0;if((la|0)<2){ma=la}else{Y=(fa(la,G)|0)+H|0;ja=W+ka+(fa(ga,W+ -2|0)|0)|0;ga=1;na=la;while(1){h[s+(na+ -1<<3)>>3]=+h[f+(Y+ga<<3)>>3];if((ga|0)<(ha|0)){na=na-ga+W|0;ga=ga+1|0}else{break}}ma=ja-Z|0}ga=v+(ha<<3)|0;h[s+(ma+ -1<<3)>>3]=+h[ga>>3];if(+h[ga>>3]==0.0){c[D>>2]=1}if((la|0)<(W|0)){ka=ka+1|0;la=la+1|0}else{break}}}}while(0);if((L|0)==35){L=0;c[D>>2]=0}SDc(b,b,f,g,v)|0;do{if((c[m>>2]|0)==2){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da}else{W=c[b>>2]|0;if((W|0)<1){oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}else{wa=1}while(1){_=wa+ -1|0;ga=l+(_<<3)|0;aa=+h[ga>>3];ba=+h[w+(_<<3)>>3];h[ga>>3]=aa>=ba?aa:ba;if((wa|0)<(W|0)){wa=wa+1|0}else{oa=Q;pa=R;qa=1;ra=S;sa=T;ta=U;ua=V;va=da;break}}}}while(0);while(1){W=c[o>>2]|0;do{if((W|0)>=1){c[E>>2]=0;if(((pa+ -1|0)%(W|0)|0|0)!=0){break}Ge[M&15](b,d,e,f,g,E,z,A)|0;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}}}while(0);IDc(b,s,t,l,u,F,v,w,x)|0;W=c[b>>2]|0;if((W|0)>=1){ga=1;while(1){_=ga+ -1|0;na=v+(_<<3)|0;ba=+h[na>>3];h[na>>3]=-ba;h[w+(_<<3)>>3]=+h[d+(_<<3)>>3]-ba;h[x+(_<<3)>>3]=+h[l+(_<<3)>>3]*+h[na>>3];if((ga|0)<(W|0)){ga=ga+1|0}else{break}}}ba=+KDc(b,x);if((pa|0)==1){aa=+h[F>>3];h[F>>3]=aa<=ba?aa:ba}c[E>>2]=1;Ge[M&15](b,w,y,f,g,E,z,A)|0;c[q>>2]=(c[q>>2]|0)+1;ga=c[E>>2]|0;if((ga|0)<0){O=ga;L=98;break a}aa=+KDc(b,y);if(aa<oa){ca=aa/oa;xa=1.0-ca*ca}else{xa=-1.0}ga=c[b>>2]|0;if((ga|0)>=1){W=1;na=ga;_=1;while(1){if((W|0)>(ga|0)){ya=_;za=0.0}else{Y=W;Aa=_;ca=0.0;while(1){Ba=ca+ +h[s+(Aa+ -1<<3)>>3]*+h[v+(Y+ -1<<3)>>3];if((Y|0)<(ga|0)){ca=Ba;Aa=Aa+1|0;Y=Y+1|0}else{break}}ya=_+na|0;za=Ba}Y=W+ -1|0;h[x+(Y<<3)>>3]=za+ +h[u+(Y<<3)>>3];if((W|0)<(ga|0)){W=W+1|0;na=na+ -1|0;_=ya}else{break}}}ca=+KDc(b,x);do{if(ca<oa){Ca=ca/oa;Da=1.0-Ca*Ca;if(!(Da>0.0)){Ea=0.0;L=65;break}Ca=xa/Da;if(!(Ca>=.1)){Ea=Ca;L=65;break}_=sa+1|0;if(Ca>=.5|(sa|0)>0){Da=+h[F>>3];Fa=ba*2.0;h[F>>3]=Da>=Fa?Da:Fa}Fa=Ca+-1.0;if(!(Fa>=0.0)){Ga=-Fa}else{Ga=Fa}if(!(Ga<=.1)){Ha=0;Ia=_;Ja=Ca;break}h[F>>3]=ba*2.0;Ha=0;Ia=_;Ja=Ca}else{Ea=0.0;L=65}}while(0);if((L|0)==65){L=0;h[F>>3]=+h[F>>3]*.5;Ha=ra+1|0;Ia=0;Ja=Ea}if(Ja<1.0e-4){Ka=oa;La=pa;Ma=va}else{_=c[b>>2]|0;if((_|0)>=1){na=1;while(1){W=na+ -1|0;ga=w+(W<<3)|0;ca=+h[ga>>3];h[d+(W<<3)>>3]=ca;h[ga>>3]=ca*+h[l+(W<<3)>>3];h[e+(W<<3)>>3]=+h[y+(W<<3)>>3];if((na|0)<(_|0)){na=na+1|0}else{break}}}Ka=aa;La=pa+1|0;Ma=+KDc(b,w)}Na=!(xa>=.001)?ta+1|0:0;Oa=!(xa>=.1)?ua+qa|0:0;ca=+h[F>>3];if(ca<=Ma*+h[j>>3]|Ka==0.0){L=77;break b}if((c[p>>2]|0)!=0){L=97;break a}if((c[q>>2]|0)<(c[k>>2]|0)){Pa=0}else{c[p>>2]=2;Pa=2}Ca=ca*.1;if(!((Ca>=ba?Ca:ba)*.1<=I*Ma)){Qa=Pa}else{c[p>>2]=3;Qa=3}if((Oa|0)==5){c[p>>2]=4;Ra=4}else{Ra=Qa}if((Na|0)==10){L=86;break b}if((Ra|0)!=0){L=97;break a}if((Ha|0)==2){break}na=c[b>>2]|0;if((na|0)>=1){_=!(Ja>=1.0e-4);W=1;while(1){ga=(fa(W,G)|0)+H|0;Y=1;Ca=0.0;while(1){Sa=Ca+ +h[f+(ga+Y<<3)>>3]*+h[y+(Y+ -1<<3)>>3];if((Y|0)<(na|0)){Ca=Sa;Y=Y+1|0}else{break}}Y=W+ -1|0;h[w+(Y<<3)>>3]=(Sa- +h[x+(Y<<3)>>3])/ba;Ca=+h[l+(Y<<3)>>3];ga=v+(Y<<3)|0;h[ga>>3]=Ca*(Ca*+h[ga>>3]/ba);if(!_){h[u+(Y<<3)>>3]=Sa}if((W|0)<(na|0)){W=W+1|0}else{break}}}VDc(b,b,s,t,v,w,x,D)|0;UDc(b,b,f,g,w,x)|0;W=307904;UDc(W,b,u,W,w,x)|0;oa=Ka;pa=La;qa=0;ra=Ha;sa=Ia;ta=Na;ua=Oa;va=Ma}c[E>>2]=2;Ge[M&15](b,d,e,f,g,E,z,A)|0;c[r>>2]=(c[r>>2]|0)+1;W=c[E>>2]|0;if((W|0)<0){O=W;L=98;break a}else{Q=Ka;R=La;S=2;T=Ia;U=Na;V=Oa;P=Ma}}if((L|0)==77){c[p>>2]=1;L=97;break}else if((L|0)==86){c[p>>2]=5;L=97;break}}}while(0);if((L|0)==97){Oa=c[E>>2]|0;if((Oa|0)<0){O=Oa;L=98}}if((L|0)==98){c[p>>2]=O}c[E>>2]=0;if((c[o>>2]|0)<=0){i=B;return 0}Ge[a&15](b,d,e,f,g,E,z,A)|0;i=B;return 0}function MDc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0;g=i;if((a[b]|0)==(a[e]|0)){h=1;i=g;return h|0}a[307936]=1;f=d[b]|0;c[76980]=f;b=d[e]|0;c[76982]=b;if((f+ -97|0)>>>0<26){e=f+ -32|0;c[76980]=e;j=e}else{j=f}if((b+ -97|0)>>>0<26){f=b+ -32|0;c[76982]=f;k=f}else{k=b}h=(j|0)==(k|0)|0;i=g;return h|0}



function ypc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1312>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1312>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(223536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1312>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[223528]=1;i=d;return}function zpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223696]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1308>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1308>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(223704,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1308>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[223696]=1;i=d;return}function Apc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[223864]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1304>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1304>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(223872,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1304>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[223864]=1;i=d;return}function Bpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224032]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1300>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1300>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(224040,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1300>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[224032]=1;i=d;return}function Cpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224200]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1296>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1296>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(224208,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1296>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[224200]=1;i=d;return}function Dpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224368]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1292>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1292>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(224376,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1292>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[224368]=1;i=d;return}function Epc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224536]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1288>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1288>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(224544,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1288>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[224536]=1;i=d;return}function Fpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224704]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1284>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1284>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(224712,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1284>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[224704]=1;i=d;return}function Gpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[224872]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1280>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1280>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(224880,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1280>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[224872]=1;i=d;return}function Hpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1276>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1276>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(225072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1276>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[225064]=1;i=d;return}function Ipc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225256]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1272>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1272>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(225264,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1272>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[225256]=1;i=d;return}function Jpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225448]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1268>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1268>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(225456,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1268>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[225448]=1;i=d;return}function Kpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225592]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1264>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1264>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(225600,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1264>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[225592]=1;i=d;return}function Lpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225736]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1260>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1260>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(225744,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1260>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[225736]=1;i=d;return}function Mpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[225880]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1256>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1256>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(225888,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1256>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[225880]=1;i=d;return}function Npc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226032]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1252>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1252>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(226040,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1252>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[226032]=1;i=d;return}function Opc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226184]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1248>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(226192,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1248>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[226184]=1;i=d;return}function Ppc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226336]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1244>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(226344,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1244>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[226336]=1;i=d;return}function Qpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226520]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1240>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(226528,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1240>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[226520]=1;i=d;return}function Rpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226704]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1236>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(226712,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1236>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[226704]=1;i=d;return}function Spc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[226888]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1232>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(226896,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1232>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[226888]=1;i=d;return}function Tpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227040]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1228>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(227048,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1228>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[227040]=1;i=d;return}function Upc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227192]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1224>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(227200,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1224>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[227192]=1;i=d;return}function Vpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227344]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1220>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(227352,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1220>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[227344]=1;i=d;return}function Wpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1216>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(227536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1216>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[227528]=1;i=d;return}function Xpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227712]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(227720,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1212>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[227712]=1;i=d;return}function Ypc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[227896]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(227904,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1208>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[227896]=1;i=d;return}function Zpc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228080]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(228088,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1204>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[228080]=1;i=d;return}function _pc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228264]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(228272,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1200>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[228264]=1;i=d;return}function $pc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228448]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(228456,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1196>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[228448]=1;i=d;return}function aqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228600]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(228608,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1192>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[228600]=1;i=d;return}function bqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228752]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(228760,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1188>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[228752]=1;i=d;return}function cqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[228904]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(228912,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1184>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[228904]=1;i=d;return}function dqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[229088]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(229096,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1180>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[229088]=1;i=d;return}function eqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[229272]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(229280,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1176>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[229272]=1;i=d;return}function fqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[229456]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(229464,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1172>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[229456]=1;i=d;return}function gqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[229608]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(229616,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1168>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[229608]=1;i=d;return}function hqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[229760]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(229768,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1164>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[229760]=1;i=d;return}function iqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[229912]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(229920,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1160>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[229912]=1;i=d;return}function jqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[230072]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(230080,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1156>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[230072]=1;i=d;return}function kqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[230232]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(230240,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1152>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[230232]=1;i=d;return}function lqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[230392]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(230400,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1148>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[230392]=1;i=d;return}function mqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[230568]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(230576,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1144>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[230568]=1;i=d;return}function nqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[230744]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(230752,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1140>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[230744]=1;i=d;return}function oqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[230920]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(230928,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1136>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[230920]=1;i=d;return}function pqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(231072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1132>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231064]=1;i=d;return}function qqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231208]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(231216,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1128>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231208]=1;i=d;return}function rqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231352]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(231360,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1124>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231352]=1;i=d;return}function sqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231504]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(231512,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1120>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231504]=1;i=d;return}function tqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231656]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(231664,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1116>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231656]=1;i=d;return}function uqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231808]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(231816,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1112>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231808]=1;i=d;return}function vqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[231992]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(232e3,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1108>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[231992]=1;i=d;return}function wqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[232176]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(232184,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1104>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[232176]=1;i=d;return}function xqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[232360]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(232368,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1100>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[232360]=1;i=d;return}function yqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[232528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1096>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1096>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(232536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1096>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[232528]=1;i=d;return}function zqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[232696]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1092>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1092>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(232704,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1092>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[232696]=1;i=d;return}function Aqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[232864]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1088>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1088>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(232872,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1088>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[232864]=1;i=d;return}function Bqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[233032]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1084>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1084>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(233040,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1084>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[233032]=1;i=d;return}function Cqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[233200]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1080>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1080>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(233208,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1080>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[233200]=1;i=d;return}function Dqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[233368]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1076>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1076>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(233376,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1076>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[233368]=1;i=d;return}function Eqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[233536]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1072>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1072>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(233544,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1072>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[233536]=1;i=d;return}function Fqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[233704]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1068>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1068>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(233712,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1068>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[233704]=1;i=d;return}function Gqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[233872]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1064>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1064>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(233880,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1064>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[233872]=1;i=d;return}function Hqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[234040]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1060>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1060>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(234048,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1060>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[234040]=1;i=d;return}function Iqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[234208]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1056>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1056>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(234216,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1056>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[234208]=1;i=d;return}function Jqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[234376]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1052>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1052>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(234384,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1052>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[234376]=1;i=d;return}function Kqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[234544]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1048>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1048>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(234552,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1048>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[234544]=1;i=d;return}function Lqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[234712]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1044>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1044>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(234720,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1044>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[234712]=1;i=d;return}function Mqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[234880]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1040>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1040>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(234888,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1040>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[234880]=1;i=d;return}function Nqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[235048]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1036>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1036>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(235056,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1036>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[235048]=1;i=d;return}function Oqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[235216]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1032>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1032>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(235224,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1032>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[235216]=1;i=d;return}function Pqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[235384]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1028>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1028>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(235392,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1028>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[235384]=1;i=d;return}function Qqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[235576]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1024>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1024>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(235584,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1024>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[235576]=1;i=d;return}function Rqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[235768]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1020>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1020>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(235776,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1020>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[235768]=1;i=d;return}function Sqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[235960]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1016>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1016>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(235968,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1016>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[235960]=1;i=d;return}function Tqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[236104]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1012>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1012>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(236112,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1012>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[236104]=1;i=d;return}function Uqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[236248]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1008>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1008>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(236256,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1008>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[236248]=1;i=d;return}function Vqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[236392]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1004>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1004>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(236400,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1004>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[236392]=1;i=d;return}function Wqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[236544]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1e3>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1e3>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(236552,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+1e3>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[236544]=1;i=d;return}function Xqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[236696]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+996>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+996>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(236704,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+996>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[236696]=1;i=d;return}function Yqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[236848]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+992>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+992>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(236856,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+992>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[236848]=1;i=d;return}function Zqc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[237032]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+988>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+988>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(237040,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+988>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[237032]=1;i=d;return}function _qc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[237216]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+984>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+984>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(237224,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+984>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[237216]=1;i=d;return}function $qc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[237400]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+980>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+980>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(237408,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+980>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[237400]=1;i=d;return}function arc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[237552]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+976>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+976>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(237560,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+976>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[237552]=1;i=d;return}function brc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[237704]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+972>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+972>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(237712,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+972>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[237704]=1;i=d;return}function crc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[237856]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+968>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+968>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(237864,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+968>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[237856]=1;i=d;return}function drc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[238040]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+964>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+964>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(238048,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+964>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[238040]=1;i=d;return}function erc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[238224]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+960>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+960>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(238232,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+960>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[238224]=1;i=d;return}function frc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[238408]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+956>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+956>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(238416,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+956>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[238408]=1;i=d;return}function grc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[238592]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+952>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+952>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(238600,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+952>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[238592]=1;i=d;return}function hrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[238776]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+948>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+948>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(238784,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+948>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[238776]=1;i=d;return}function irc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[238960]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+944>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+944>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(238968,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+944>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[238960]=1;i=d;return}function jrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[239112]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+940>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+940>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(239120,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+940>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[239112]=1;i=d;return}function krc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[239264]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+936>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+936>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(239272,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+936>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[239264]=1;i=d;return}function lrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[239416]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+932>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+932>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(239424,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+932>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[239416]=1;i=d;return}function mrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[239600]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+928>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+928>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(239608,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+928>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[239600]=1;i=d;return}function nrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[239784]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+924>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+924>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(239792,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+924>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[239784]=1;i=d;return}function orc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[239968]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+920>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+920>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(239976,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+920>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[239968]=1;i=d;return}function prc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[240120]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+916>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+916>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(240128,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+916>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[240120]=1;i=d;return}function qrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[240272]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+912>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+912>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(240280,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+912>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[240272]=1;i=d;return}function rrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[240424]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+908>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+908>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(240432,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+908>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[240424]=1;i=d;return}function src(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[240584]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+904>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+904>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(240592,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+904>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[240584]=1;i=d;return}function trc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[240744]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+900>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+900>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(240752,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+900>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[240744]=1;i=d;return}function urc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[240904]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+896>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+896>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(240912,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+896>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[240904]=1;i=d;return}function vrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[241080]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+892>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+892>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(241088,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+892>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[241080]=1;i=d;return}function wrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[241256]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+888>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+888>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(241264,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+888>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[241256]=1;i=d;return}function xrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[241432]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+884>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+884>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(241440,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+884>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[241432]=1;i=d;return}function yrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[241576]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+880>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+880>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(241584,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+880>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[241576]=1;i=d;return}function zrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[241720]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+876>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+876>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(241728,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+876>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[241720]=1;i=d;return}function Arc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[241864]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+872>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+872>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(241872,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+872>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[241864]=1;i=d;return}function Brc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[242016]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+868>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+868>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(242024,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+868>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[242016]=1;i=d;return}function Crc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[242168]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+864>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+864>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(242176,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+864>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[242168]=1;i=d;return}function Drc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[242320]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+860>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+860>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(242328,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+860>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[242320]=1;i=d;return}function Erc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[242504]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+856>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+856>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(242512,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+856>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[242504]=1;i=d;return}function Frc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[242688]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+852>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+852>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(242696,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+852>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[242688]=1;i=d;return}function Grc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[242872]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+848>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+848>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(242880,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+848>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[242872]=1;i=d;return}function Hrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[243040]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+844>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+844>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(243048,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+844>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[243040]=1;i=d;return}function Irc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[243208]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+840>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+840>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(243216,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+840>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[243208]=1;i=d;return}function Jrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[243376]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+836>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+836>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(243384,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+836>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[243376]=1;i=d;return}function Krc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[243544]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+832>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+832>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(243552,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+832>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[243544]=1;i=d;return}function Lrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[243712]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+828>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+828>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(243720,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+828>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[243712]=1;i=d;return}function Mrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[243880]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+824>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+824>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(243888,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+824>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[243880]=1;i=d;return}function Nrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[244048]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+820>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+820>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(244056,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+820>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[244048]=1;i=d;return}function Orc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[244216]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+816>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+816>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(244224,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+816>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[244216]=1;i=d;return}function Prc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[244384]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+812>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+812>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(244392,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+812>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[244384]=1;i=d;return}function Qrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[244552]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+808>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+808>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(244560,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+808>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[244552]=1;i=d;return}function Rrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[244720]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+804>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+804>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(244728,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+804>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[244720]=1;i=d;return}function Src(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[244888]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+800>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+800>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(244896,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+800>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[244888]=1;i=d;return}function Trc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[245056]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+796>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+796>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(245064,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+796>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[245056]=1;i=d;return}function Urc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[245224]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+792>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+792>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(245232,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+792>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[245224]=1;i=d;return}function Vrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[245392]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+788>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+788>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(245400,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+788>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[245392]=1;i=d;return}function Wrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[245560]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+784>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+784>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(245568,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+784>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[245560]=1;i=d;return}function Xrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[245728]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+780>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+780>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(245736,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+780>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[245728]=1;i=d;return}function Yrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[245896]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+776>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+776>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(245904,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+776>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[245896]=1;i=d;return}function Zrc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[246088]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+772>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+772>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(246096,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+772>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[246088]=1;i=d;return}function _rc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[246280]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+768>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+768>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(246288,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+768>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[246280]=1;i=d;return}function $rc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[246472]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+764>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+764>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(246480,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+764>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[246472]=1;i=d;return}function asc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[246616]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+760>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+760>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(246624,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+760>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[246616]=1;i=d;return}function bsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[246760]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+756>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+756>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(246768,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+756>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[246760]=1;i=d;return}function csc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[246904]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+752>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+752>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(246912,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+752>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[246904]=1;i=d;return}function dsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[247056]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+748>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+748>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(247064,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+748>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[247056]=1;i=d;return}function esc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[247208]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+744>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+744>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(247216,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+744>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[247208]=1;i=d;return}function fsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[247360]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+740>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+740>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(247368,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+740>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[247360]=1;i=d;return}function gsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[247544]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+736>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+736>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(247552,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+736>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[247544]=1;i=d;return}function hsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[247728]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+732>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+732>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(247736,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+732>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[247728]=1;i=d;return}function isc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[247912]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+728>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+728>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(247920,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+728>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[247912]=1;i=d;return}function jsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[248064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+724>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+724>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(248072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+724>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[248064]=1;i=d;return}function ksc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[248216]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+720>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+720>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(248224,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+720>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[248216]=1;i=d;return}function lsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[248368]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+716>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+716>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(248376,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+716>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[248368]=1;i=d;return}function msc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[248552]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+712>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+712>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(248560,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+712>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[248552]=1;i=d;return}function nsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[248736]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+708>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+708>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(248744,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+708>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[248736]=1;i=d;return}function osc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[248920]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+704>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+704>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(248928,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+704>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[248920]=1;i=d;return}function psc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[249104]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+700>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+700>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(249112,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+700>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[249104]=1;i=d;return}function qsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[249288]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+696>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+696>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(249296,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+696>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[249288]=1;i=d;return}function rsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[249472]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+692>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+692>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(249480,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+692>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[249472]=1;i=d;return}function ssc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[249624]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+688>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+688>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(249632,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+688>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[249624]=1;i=d;return}function tsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[249776]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+684>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+684>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(249784,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+684>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[249776]=1;i=d;return}function usc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[249928]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+680>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+680>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(249936,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+680>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[249928]=1;i=d;return}function vsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[250112]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+676>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+676>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(250120,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+676>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[250112]=1;i=d;return}function wsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[250296]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+672>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+672>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(250304,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+672>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[250296]=1;i=d;return}function xsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[250480]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+668>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+668>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(250488,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+668>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[250480]=1;i=d;return}function ysc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[250632]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+664>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+664>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(250640,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+664>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[250632]=1;i=d;return}function zsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[250784]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+660>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+660>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(250792,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+660>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[250784]=1;i=d;return}function Asc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[250936]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+656>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+656>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(250944,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+656>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[250936]=1;i=d;return}function Bsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[251096]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+652>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+652>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(251104,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+652>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[251096]=1;i=d;return}function Csc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[251256]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+648>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+648>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(251264,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+648>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[251256]=1;i=d;return}function Dsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[251416]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+644>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+644>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(251424,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+644>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[251416]=1;i=d;return}function Esc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[251592]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+640>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+640>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(251600,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+640>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[251592]=1;i=d;return}function Fsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[251768]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+636>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+636>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(251776,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+636>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[251768]=1;i=d;return}function Gsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[251944]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+632>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+632>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(251952,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+632>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[251944]=1;i=d;return}function Hsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[252088]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+628>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+628>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(252096,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+628>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[252088]=1;i=d;return}function Isc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[252232]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+624>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+624>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(252240,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+624>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[252232]=1;i=d;return}function Jsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[252376]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+620>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+620>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(252384,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+620>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[252376]=1;i=d;return}function Ksc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[252528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+616>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+616>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(252536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+616>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[252528]=1;i=d;return}function Lsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[252680]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+612>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+612>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(252688,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+612>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[252680]=1;i=d;return}function Msc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[252832]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+608>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+608>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(252840,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+608>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[252832]=1;i=d;return}function Nsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[253016]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+604>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+604>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(253024,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+604>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[253016]=1;i=d;return}function Osc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[253200]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+600>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+600>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(253208,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+600>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[253200]=1;i=d;return}function Psc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[253384]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+596>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+596>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(253392,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+596>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[253384]=1;i=d;return}



function NDc(b,d,e,f,g,j,k,l,m,n,o,p,q){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;var r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0.0,K=0.0,L=0.0,M=0.0,N=0.0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0.0,X=0.0,Y=0.0,Z=0,_=0.0,$=0.0,aa=0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0,ha=0.0,ia=0,ja=0,ka=0.0,la=0,ma=0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0,ta=0.0,ua=0,va=0.0,wa=0.0,xa=0,ya=0.0,za=0,Aa=0,Ba=0.0,Ca=0,Da=0,Ea=0,Fa=0.0,Ga=0,Ha=0,Ia=0,Ja=0.0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0;r=i;if((c[j>>2]|0)>0){c[317468>>2]=6;MUc(317464)|0;bUc(318208,j,4)|0;uUc()|0}c[q>>2]=0;s=(c[e>>2]|0)<1?3:0;c[q>>2]=s;t=(c[l>>2]|0)<1?4:s;c[q>>2]=t;if((t|0)!=0){i=r;return 0}c[78668]=0;c[79274]=0;c[79262]=0;a[317072]=0;t=c[e>>2]|0;c[78222]=1;do{if((t|0)>=1){s=0;u=1;while(1){if(+h[d+(u+ -1<<3)>>3]!=0.0){v=s+1|0;c[78668]=v;w=v}else{w=s}if((u|0)<(t|0)){s=w;u=u+1|0}else{break}}c[78222]=t+1;if((w|0)<=0){break}u=p;s=f;a:while(1){v=c[e>>2]|0;c[78222]=1;if((v|0)>=1){x=1;while(1){h[309360+((x*21|0)+ -21<<3)>>3]=+h[b+(x+ -1<<3)>>3];if((x|0)<(v|0)){x=x+1|0}else{break}}c[78222]=v+1}c[79266]=2;x=c[e>>2]|0;c[78222]=1;if((x|0)>=1){y=2;z=1;while(1){A=z+ -1|0;B=d+(A<<3)|0;C=+h[B>>3];if(C==0.0){D=y}else{E=c[e>>2]|0;c[78224]=1;if((E|0)<1){F=C}else{G=1;while(1){h[309360+((G*21|0)+ -22+y<<3)>>3]=+h[b+(G+ -1<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[78224]=E+1;F=+h[B>>3]}h[309360+((z*21|0)+ -22+y<<3)>>3]=+h[b+(A<<3)>>3]+F;G=y+1|0;c[79266]=G;D=G}G=z+1|0;c[78222]=G;if((z|0)<(x|0)){y=D;z=G}else{break}}}z=c[78668]|0;y=z+1|0;c[78664]=y;c[78222]=1;if((z|0)>=0){z=1;do{x=c[e>>2]|0;c[78224]=1;if((x|0)>=1){v=1;while(1){h[b+(v+ -1<<3)>>3]=+h[309360+((v*21|0)+ -22+z<<3)>>3];if((v|0)<(x|0)){v=v+1|0}else{break}}c[78224]=x+1}le[u&63](e,b,312720+(z+ -1<<3)|0)|0;c[79274]=(c[79274]|0)+1;if((c[j>>2]|0)>=1){c[317492>>2]=6;MUc(317488)|0;bUc(318208,317096,4)|0;bUc(318208,312720+((c[78222]|0)+ -1<<3)|0,8)|0;v=c[e>>2]|0;c[78224]=1;if((v|0)>=1){A=1;do{bUc(318208,b+(A+ -1<<3)|0,8)|0;B=c[78224]|0;A=B+1|0;c[78224]=A;}while((B|0)<(v|0))}uUc()|0}v=c[78222]|0;z=v+1|0;c[78222]=z;}while((v|0)<(y|0))}y=c[79262]|0;b:while(1){c[79262]=y+1;c[79174]=1;c[79170]=1;C=+h[39090];h[39586]=C;h[39588]=C;z=c[78664]|0;c[78222]=2;if((z|0)<2){H=1}else{I=C;K=C;v=1;A=2;while(1){C=+h[312720+(A+ -1<<3)>>3];do{if(!(C<=K)){c[79174]=A;L=+h[312720+(A+ -1<<3)>>3];h[39586]=L;M=I;N=L;O=A}else{if(C>=I){M=I;N=K;O=v;break}c[79170]=A;L=+h[312720+(A+ -1<<3)>>3];h[39588]=L;M=L;N=K;O=v}}while(0);if((A|0)<(z|0)){I=M;K=N;v=O;A=A+1|0}else{break}}c[78222]=z+1;H=O}A=c[e>>2]|0;c[78222]=1;if((A|0)>=1){v=1;while(1){h[314840+(v+ -1<<3)>>3]=0.0;if((v|0)<(A|0)){v=v+1|0}else{break}}c[78222]=A+1}c[78222]=1;if((z|0)>=1){v=1;do{do{if((v|0)==(H|0)){P=H}else{x=c[e>>2]|0;c[78224]=1;if((x|0)<1){P=v;break}else{Q=1}while(1){B=314840+(Q+ -1<<3)|0;h[B>>3]=+h[309360+((Q*21|0)+ -22+v<<3)>>3]+ +h[B>>3];if((Q|0)<(x|0)){Q=Q+1|0}else{break}}c[78224]=x+1;P=v}}while(0);v=P+1|0;c[78222]=v;}while((P|0)<(z|0))}z=c[e>>2]|0;c[78224]=1;if((z|0)>=1){K=+(c[78668]|0);v=1;while(1){A=314840+(v+ -1<<3)|0;h[A>>3]=+h[A>>3]/K;if((v|0)<(z|0)){v=v+1|0}else{break}}c[78224]=z+1}v=c[e>>2]|0;c[78222]=1;if((v|0)>=1){A=1;while(1){B=A+ -1|0;K=+h[314840+(B<<3)>>3];h[317120+(B<<3)>>3]=K+(K- +h[309360+((A*21|0)+ -22+H<<3)>>3]);if((A|0)<(v|0)){A=A+1|0}else{break}}c[78222]=v+1}le[u&63](e,317120,317112)|0;A=(c[79274]|0)+1|0;c[79274]=A;z=c[j>>2]|0;do{if((z|0)>=1){if(((A|0)%(z|0)|0|0)!=0){break}c[317516>>2]=6;MUc(317512)|0;bUc(318208,317096,4)|0;bUc(318208,317112,8)|0;B=c[e>>2]|0;c[78224]=1;if((B|0)>=1){E=1;do{bUc(318208,317120+(E+ -1<<3)|0,8)|0;G=c[78224]|0;E=G+1|0;c[78224]=E;}while((G|0)<(B|0))}uUc()|0}}while(0);K=+h[39639];c:do{if(!(K>=+h[39588])){z=c[e>>2]|0;c[78222]=1;if((z|0)>=1){A=1;while(1){v=A+ -1|0;I=+h[314840+(v<<3)>>3];h[317288+(v<<3)>>3]=I+(+h[317120+(v<<3)>>3]-I)*2.0;if((A|0)<(z|0)){A=A+1|0}else{break}}c[78222]=z+1}le[u&63](e,317288,317280)|0;A=(c[79274]|0)+1|0;c[79274]=A;v=c[j>>2]|0;do{if((v|0)>=1){if(((A|0)%(v|0)|0|0)!=0){break}c[317540>>2]=6;MUc(317536)|0;bUc(318208,317096,4)|0;bUc(318208,317280,8)|0;B=c[e>>2]|0;c[78224]=1;if((B|0)>=1){E=1;do{bUc(318208,317288+(E+ -1<<3)|0,8)|0;G=c[78224]|0;E=G+1|0;c[78224]=E;}while((G|0)<(B|0))}uUc()|0}}while(0);I=+h[39660];if(I>=+h[39588]){R=118;break}v=c[e>>2]|0;c[78222]=1;A=c[79174]|0;if((v|0)>=1){z=1;while(1){B=z+ -1|0;if(+h[d+(B<<3)>>3]!=0.0){h[309360+((z*21|0)+ -22+A<<3)>>3]=+h[317288+(B<<3)>>3]}if((z|0)<(v|0)){z=z+1|0}else{break}}c[78222]=v+1}h[312720+(A+ -1<<3)>>3]=I}else{z=c[78664]|0;c[78222]=1;if((z|0)>=1){B=c[79174]|0;E=1;while(1){if((E|0)!=(B|0)){if(K<+h[312720+(E+ -1<<3)>>3]){R=118;break c}}x=E+1|0;c[78222]=x;if((E|0)<(z|0)){E=x}else{break}}}if(!(K>+h[39586])){E=c[e>>2]|0;c[78222]=1;z=c[79174]|0;if((E|0)>=1){B=1;while(1){A=B+ -1|0;if(+h[d+(A<<3)>>3]!=0.0){h[309360+((B*21|0)+ -22+z<<3)>>3]=+h[317120+(A<<3)>>3]}if((B|0)<(E|0)){B=B+1|0}else{break}}c[78222]=E+1}h[39586]=K;h[312720+(z+ -1<<3)>>3]=K}B=c[e>>2]|0;c[78222]=1;if((B|0)>=1){A=c[79174]|0;v=1;while(1){x=v+ -1|0;h[317288+(x<<3)>>3]=+h[309360+((v*21|0)+ -22+A<<3)>>3]*.5+ +h[314840+(x<<3)>>3]*.5;if((v|0)<(B|0)){v=v+1|0}else{break}}c[78222]=B+1}le[u&63](e,317288,317280)|0;v=(c[79274]|0)+1|0;c[79274]=v;A=c[j>>2]|0;do{if((A|0)>=1){if(((v|0)%(A|0)|0|0)!=0){break}c[317564>>2]=6;MUc(317560)|0;bUc(318208,317096,4)|0;bUc(318208,317280,8)|0;z=c[e>>2]|0;c[78224]=1;if((z|0)>=1){E=1;do{bUc(318208,317288+(E+ -1<<3)|0,8)|0;x=c[78224]|0;E=x+1|0;c[78224]=E;}while((x|0)<(z|0))}uUc()|0}}while(0);I=+h[39660];if(!(I>+h[39586])){A=c[e>>2]|0;c[78222]=1;v=c[79174]|0;if((A|0)>=1){B=1;while(1){z=B+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[309360+((B*21|0)+ -22+v<<3)>>3]=+h[317288+(z<<3)>>3]}if((B|0)<(A|0)){B=B+1|0}else{break}}c[78222]=A+1}h[312720+(v+ -1<<3)>>3]=I;break}B=c[78664]|0;c[78222]=1;if((B|0)<1){break}else{S=1}do{z=c[79170]|0;do{if((S|0)!=(z|0)){E=c[e>>2]|0;c[78224]=1;if((E|0)>=1){x=S+ -22|0;G=1;while(1){if(+h[d+(G+ -1<<3)>>3]!=0.0){T=(G*21|0)+ -22|0;U=309360+(T+S<<3)|0;h[U>>3]=(+h[U>>3]+ +h[309360+(T+z<<3)>>3])*.5}h[b+(G+ -1<<3)>>3]=+h[309360+(x+(G*21|0)<<3)>>3];if((G|0)<(E|0)){G=G+1|0}else{break}}c[78224]=E+1}le[u&63](e,b,312720+(S+ -1<<3)|0)|0;G=(c[79274]|0)+1|0;c[79274]=G;x=c[j>>2]|0;if((x|0)<1){break}if(((G|0)%(x|0)|0|0)!=0){break}c[317588>>2]=6;MUc(317584)|0;bUc(318208,317096,4)|0;bUc(318208,312720+((c[78222]|0)+ -1<<3)|0,8)|0;x=c[e>>2]|0;c[78224]=1;if((x|0)>=1){G=1;do{bUc(318208,b+(G+ -1<<3)|0,8)|0;T=c[78224]|0;G=T+1|0;c[78224]=G;}while((T|0)<(x|0))}uUc()|0}}while(0);z=c[78222]|0;S=z+1|0;c[78222]=S;}while((z|0)<(B|0))}}while(0);if((R|0)==118){R=0;B=c[e>>2]|0;c[78222]=1;v=c[79174]|0;if((B|0)>=1){A=1;while(1){z=A+ -1|0;if(+h[d+(z<<3)>>3]!=0.0){h[309360+((A*21|0)+ -22+v<<3)>>3]=+h[317120+(z<<3)>>3]}if((A|0)<(B|0)){A=A+1|0}else{break}}c[78222]=B+1}h[312720+(v+ -1<<3)>>3]=+h[39639]}A=c[79262]|0;if((A|0)<(c[l>>2]|0)){y=A;continue}h[39589]=0.0;h[39635]=0.0;A=c[78664]|0;c[78222]=1;z=(A|0)<1;do{if(z){K=+(A|0);h[39635]=0.0/K;c[78222]=1;W=K;X=0.0}else{x=1;K=0.0;while(1){Y=+h[312720+(x+ -1<<3)>>3]+K;if((x|0)<(A|0)){K=Y;x=x+1|0}else{break}}K=+(A|0);I=Y/K;h[39635]=I;c[78222]=1;if(z){W=K;X=0.0;break}else{Z=1;_=0.0}while(1){C=+h[312720+(Z+ -1<<3)>>3]-I;$=_+C*C;if((Z|0)<(A|0)){_=$;Z=Z+1|0}else{break}}h[39589]=$;c[78222]=A+1;W=K;X=$}}while(0);I=+V(+(X/W));h[39589]=I;do{if(!(I<=+h[k>>3])){if((c[79274]|0)>(c[g>>2]|0)){break}a[317072]=0;c[79262]=0;y=0;continue b}}while(0);v=c[e>>2]|0;c[78222]=1;if((v|0)>=1){B=1;while(1){x=B+ -1|0;if(!(+h[d+(x<<3)>>3]==0.0)){h[b+(x<<3)>>3]=0.0;c[78224]=1;if(z){aa=b+(B+ -1<<3)|0}else{x=B*21|0;G=b+(B+ -1<<3)|0;I=+h[G>>3];E=1;while(1){C=+h[309360+(E+ -22+x<<3)>>3]+I;h[G>>3]=C;if((E|0)<(A|0)){E=E+1|0;I=C}else{break}}c[78224]=A+1;aa=G}h[aa>>3]=+h[aa>>3]/W}if((B|0)<(v|0)){B=B+1|0}else{break}}c[78222]=v+1}le[u&63](e,b,f)|0;B=(c[79274]|0)+1|0;c[79274]=B;A=c[j>>2]|0;do{if((A|0)<1){ba=B}else{if(((B|0)%(A|0)|0|0)!=0){ba=B;break}c[317612>>2]=6;MUc(317608)|0;bUc(318208,317096,4)|0;bUc(318208,s,8)|0;z=c[e>>2]|0;c[78224]=1;if((z|0)>=1){E=1;do{bUc(318208,b+(E+ -1<<3)|0,8)|0;x=c[78224]|0;E=x+1|0;c[78224]=E;}while((x|0)<(z|0))}uUc()|0;ba=c[79274]|0}}while(0);if((ba|0)>(c[g>>2]|0)){R=150;break a}if((c[j>>2]|0)>=0){c[317732>>2]=6;MUc(317728)|0;uUc()|0;c[317756>>2]=6;MUc(317752)|0;B=c[e>>2]|0;c[78222]=1;if((B|0)>=1){A=1;do{bUc(318208,b+(A+ -1<<3)|0,8)|0;v=c[78222]|0;A=v+1|0;c[78222]=A;}while((v|0)<(B|0))}uUc()|0;c[317780>>2]=6;MUc(317776)|0;bUc(318208,s,8)|0;uUc()|0}if(a[317072]&1){I=+h[39635];K=+h[39681]-I;if(!(K>=0.0)){ca=-K}else{ca=K}if(!(ca>=+h[k>>3])){break}else{da=I}}else{a[317072]=1;da=+h[39635]}h[39681]=da;c[79262]=0;y=0}if((c[j>>2]|0)>=0){c[317804>>2]=6;MUc(317800)|0;bUc(318208,317096,4)|0;uUc()|0;c[317828>>2]=6;MUc(317824)|0;y=c[e>>2]|0;c[78222]=1;if((y|0)>=1){B=1;do{bUc(318208,b+(B+ -1<<3)|0,8)|0;A=c[78222]|0;B=A+1|0;c[78222]=B;}while((A|0)<(y|0))}uUc()|0;c[317852>>2]=6;MUc(317848)|0;bUc(318208,s,8)|0;uUc()|0}if((c[m>>2]|0)<1){R=312;break}if((c[j>>2]|0)>-1){c[317876>>2]=6;MUc(317872)|0;uUc()|0}h[39588]=+h[f>>3];c[79276]=0;y=c[78664]|0;c[78222]=1;if((y|0)>=1){B=1;while(1){A=312720+(B+ -1<<3)|0;I=+h[A>>3]- +h[f>>3];if(!(I>=0.0)){ea=-I}else{ea=I}if(ea>=+h[n>>3]){v=B+1|0;c[78222]=v;if((B|0)<(y|0)){B=v;continue}else{break}}v=c[e>>2]|0;c[78224]=1;if((v|0)>=1){z=B+ -22|0;E=1;while(1){G=E+ -1|0;if(+h[d+(G<<3)>>3]!=0.0){x=309360+((E*21|0)+ -22+B<<3)|0;I=+h[x>>3];h[x>>3]=I+(I- +h[b+(G<<3)>>3])}h[317288+(E+ -1<<3)>>3]=+h[309360+(z+(E*21|0)<<3)>>3];if((E|0)<(v|0)){E=E+1|0}else{break}}c[78224]=v+1}le[u&63](e,317288,A)|0;c[79276]=(c[79276]|0)+1;c[79274]=(c[79274]|0)+1;E=c[78222]|0;I=+h[312720+(E+ -1<<3)>>3];if(I>=+h[39588]){B=E;continue}h[39588]=I;if(!((c[j>>2]|0)>-1)){B=E;continue}c[317900>>2]=6;MUc(317896)|0;bUc(318208,317096,4)|0;bUc(318208,316704,8)|0;E=c[e>>2]|0;c[78224]=1;if((E|0)>=1){z=1;do{bUc(318208,317288+(z+ -1<<3)|0,8)|0;G=c[78224]|0;z=G+1|0;c[78224]=z;}while((G|0)<(E|0))}uUc()|0;B=c[78222]|0}}B=c[78668]|0;c[78222]=1;do{if((B|0)<1){h[39115]=+h[39090];c[78222]=1;ga=B;R=202}else{y=1;do{E=y+1|0;c[78232]=E;z=c[e>>2]|0;c[78224]=1;if((z|0)>=1){A=1;while(1){v=A*21|0;h[317120+(A+ -1<<3)>>3]=(+h[309360+(v+ -21<<3)>>3]+ +h[309360+(v+ -22+E<<3)>>3])*.5;if((A|0)<(z|0)){A=A+1|0}else{break}}c[78224]=z+1}le[u&63](e,317120,314680+(y+ -1<<3)|0)|0;c[79276]=(c[79276]|0)+1;c[79274]=(c[79274]|0)+1;A=c[78222]|0;y=A+1|0;c[78222]=y;}while((A|0)<(B|0));y=c[78668]|0;I=+h[39090];h[39115]=I;c[78222]=1;if((y|0)<1){ga=y;R=202;break}else{ha=I;ia=1}while(1){A=ia+ -1|0;c[78232]=A;c[78234]=ia+1;if((ia|0)<2){ja=ia;ka=ha}else{c[78224]=1;E=1;while(1){v=E+1|0;c[78236]=v;G=c[e>>2]|0;c[78226]=1;if((G|0)>=1){x=c[78234]|0;T=1;while(1){U=(T*21|0)+ -22|0;h[317288+(T+ -1<<3)>>3]=(+h[309360+(U+x<<3)>>3]+ +h[309360+(U+v<<3)>>3])*.5;if((T|0)<(G|0)){T=T+1|0}else{break}}c[78226]=G+1}le[u&63](e,317288,317280)|0;c[79276]=(c[79276]|0)+1;c[79274]=(c[79274]|0)+1;T=c[78222]|0;v=T+ -1|0;x=(fa(v,T)|0)/2|0;U=c[78224]|0;la=U+x|0;c[78228]=la;I=+h[39115];h[315e3+(la+ -1<<3)>>3]=(+h[39660]+I- +h[314680+(v<<3)>>3]- +h[314680+(U+ -1<<3)>>3])*2.0;v=U+1|0;c[78224]=v;if((U|0)<(A|0)){E=v}else{ja=T;ka=I;break}}}E=ja+1|0;c[78222]=E;if((ja|0)<(y|0)){ha=ka;ia=E}else{break}}y=c[78668]|0;c[78228]=0;c[78222]=1;E=(y|0)<1;if(E){c[78222]=1;ma=1;na=y;break}A=y+ -1|0;z=A<<1;T=c5c(A|0,0,y+ -2|0,0)|0;A=X4c(T|0,J&1|0,1)|0;T=0;v=1;while(1){U=T+v|0;h[315e3+(U+ -1<<3)>>3]=(+h[312720+(v<<3)>>3]+ka- +h[314680+(v+ -1<<3)>>3]*2.0)*2.0;if((v|0)<(y|0)){v=v+1|0;T=U}else{break}}c[78232]=v+1;c[78228]=(z|1)+A;c[78222]=1;if(E){ma=1;na=y;break}I=ka*3.0;T=1;while(1){U=314680+(T+ -1<<3)|0;h[U>>3]=+h[U>>3]*2.0-(+h[312720+(T<<3)>>3]+I)*.5;if((T|0)<(y|0)){T=T+1|0}else{break}}c[78232]=T+1;c[78222]=y+1;ma=E;na=y}}while(0);if((R|0)==202){R=0;c[78228]=0;c[78222]=1;ma=(ga|0)<1;na=ga}B=c[e>>2]|0;c[78222]=1;if((B|0)>=1){A=1;while(1){h[316720+(A+ -1<<3)>>3]=+h[309360+((A*21|0)+ -21<<3)>>3];if((A|0)<(B|0)){A=A+1|0}else{break}}c[78222]=B+1}c[78222]=1;do{if(ma){c[78222]=1}else{A=1;while(1){z=A+1|0;c[78232]=z;v=c[e>>2]|0;c[78224]=1;if((v|0)>=1){U=1;while(1){la=U*21|0;x=309360+(la+ -22+z<<3)|0;h[x>>3]=+h[x>>3]- +h[309360+(la+ -21<<3)>>3];if((U|0)<(v|0)){U=U+1|0}else{break}}c[78224]=v+1}c[78222]=z;if((A|0)<(na|0)){A=z}else{break}}c[78222]=1;if(ma){break}else{oa=1}while(1){A=oa+1|0;c[78232]=A;y=c[e>>2]|0;c[78224]=1;if((y|0)>=1){E=1;while(1){T=(E*21|0)+ -22|0;h[309360+(T+oa<<3)>>3]=+h[309360+(T+A<<3)>>3];if((E|0)<(y|0)){E=E+1|0}else{break}}c[78224]=y+1}c[78222]=A;if((oa|0)<(na|0)){oa=A}else{break}}}}while(0);B=315e3;ODc(B,314672,B,316880,317456,q,317040)|0;if((c[q>>2]|0)==0){R=226;break}if((c[j>>2]|0)>-1){c[317924>>2]=6;MUc(317920)|0;uUc()|0}c[q>>2]=2;if((c[79274]|0)>(c[g>>2]|0)){R=312;break}c[317948>>2]=6;MUc(317944)|0;uUc()|0;B=c[e>>2]|0;c[78222]=1;if((B|0)<1){continue}else{pa=1}while(1){E=d+(pa+ -1<<3)|0;h[E>>3]=+h[E>>3]*.5;if((pa|0)<(B|0)){pa=pa+1|0}else{break}}c[78222]=B+1}if((R|0)==150){c[q>>2]=1;if((c[j>>2]|0)<0){i=r;return 0}c[317636>>2]=6;MUc(317632)|0;bUc(318208,g,4)|0;uUc()|0;c[317660>>2]=6;MUc(317656)|0;bUc(318208,316712,8)|0;uUc()|0;c[317684>>2]=6;MUc(317680)|0;u=c[e>>2]|0;c[78222]=1;if((u|0)>=1){E=1;do{bUc(318208,b+(E+ -1<<3)|0,8)|0;z=c[78222]|0;E=z+1|0;c[78222]=E;}while((z|0)<(u|0))}uUc()|0;c[317708>>2]=6;MUc(317704)|0;bUc(318208,s,8)|0;uUc()|0;i=r;return 0}else if((R|0)==226){u=c[78668]|0;c[79272]=u-(c[79364]|0);c[78222]=1;E=(u|0)<1;do{if(E){h[39632]=0.0;c[78222]=1;qa=0.0}else{z=u+1|0;v=1;while(1){h[312720+(v+ -1<<3)>>3]=0.0;T=v+ -1|0;U=312720+(T<<3)|0;I=+h[U>>3];la=1;while(1){if((la|0)>(v|0)){x=la+ -1|0;ra=x;sa=((fa(x,la)|0)/2|0)+v|0}else{ra=la+ -1|0;sa=((fa(T,v)|0)/2|0)+la|0}ta=+h[315e3+(sa+ -1<<3)>>3]*+h[314680+(ra<<3)>>3]+I;if((la|0)<(u|0)){I=ta;la=la+1|0}else{break}}c[78228]=sa;h[U>>3]=ta;if((v|0)<(u|0)){v=v+1|0}else{break}}c[78224]=z;h[39632]=0.0;c[78222]=1;if(E){qa=0.0;break}else{ua=1;va=0.0}while(1){v=ua+ -1|0;wa=va+ +h[312720+(v<<3)>>3]*+h[314680+(v<<3)>>3];if((ua|0)<(u|0)){va=wa;ua=ua+1|0}else{break}}h[39632]=wa;c[78222]=u+1;qa=wa}}while(0);h[39632]=+h[39115]-qa;s=c[e>>2]|0;c[78222]=1;if((s|0)>=1){z=u+1|0;v=1;while(1){h[317288+(v+ -1<<3)>>3]=0.0;if(E){xa=1}else{B=v*21|0;la=317288+(v+ -1<<3)|0;T=1;I=+h[la>>3];while(1){ya=I+ +h[312720+(T+ -1<<3)>>3]*+h[309360+(T+ -22+B<<3)>>3];if((T|0)<(u|0)){I=ya;T=T+1|0}else{break}}h[la>>3]=ya;xa=z}if((v|0)<(s|0)){v=v+1|0}else{break}}c[78222]=s+1;c[78224]=xa}v=c[e>>2]|0;c[78222]=1;if((v|0)>=1){z=1;while(1){u=z+ -1|0;E=316720+(u<<3)|0;h[E>>3]=+h[E>>3]- +h[317288+(u<<3)>>3];if((z|0)<(v|0)){z=z+1|0}else{break}}c[78222]=v+1}if((c[j>>2]|0)>=0){c[317972>>2]=6;MUc(317968)|0;bUc(318208,317056,8)|0;z=c[e>>2]|0;c[78222]=1;if((z|0)>=1){s=1;do{bUc(318208,316720+(s+ -1<<3)|0,8)|0;u=c[78222]|0;s=u+1|0;c[78222]=s;}while((u|0)<(z|0))}uUc()|0;c[317996>>2]=6;MUc(317992)|0;uUc()|0}z=c[e>>2]|0;c[78222]=1;if((z|0)>=1){s=c[78668]|0;v=1;while(1){c[78224]=1;if((s|0)>=1){u=v*21|0;E=s+1|0;T=1;while(1){h[312720+(T+ -1<<3)>>3]=0.0;B=T+ -1|0;x=312720+(B<<3)|0;I=+h[x>>3];za=1;while(1){if((za|0)>(T|0)){Aa=((fa(za+ -1|0,za)|0)/2|0)+T|0}else{Aa=((fa(B,T)|0)/2|0)+za|0}Ba=I+ +h[315e3+(Aa+ -1<<3)>>3]*+h[309360+(za+ -22+u<<3)>>3]*.5;if((za|0)<(s|0)){I=Ba;za=za+1|0}else{break}}c[78228]=Aa;h[x>>3]=Ba;if((T|0)<(s|0)){T=T+1|0}else{break}}c[78226]=E;c[78224]=s+1}T=c[e>>2]|0;c[78224]=v;if((v|0)<=(T|0)){u=(s|0)<1;la=s+1|0;za=v;while(1){Ca=v+((fa(za+ -1|0,za)|0)/2|0)|0;B=312976+(Ca+ -1<<3)|0;h[B>>3]=0.0;if(u){Da=1}else{U=za*21|0;Ea=1;I=0.0;while(1){Fa=+h[312720+(Ea+ -1<<3)>>3]*+h[309360+(Ea+ -22+U<<3)>>3]+I;if((Ea|0)<(s|0)){I=Fa;Ea=Ea+1|0}else{break}}h[B>>3]=Fa;Da=la}if((za|0)<(T|0)){za=za+1|0}else{break}}c[78224]=T+1;c[78228]=Ca;c[78226]=Da}za=v+1|0;c[78222]=za;if((v|0)<(z|0)){v=za}else{break}}}c[78224]=0;v=c[e>>2]|0;c[78222]=1;if((v|0)>=1){z=1;s=0;while(1){Ga=s+z|0;h[o+(z+ -1<<3)>>3]=+h[312976+(Ga+ -1<<3)>>3];if((z|0)<(v|0)){s=Ga;z=z+1|0}else{break}}c[78224]=Ga;c[78222]=v+1}if((c[j>>2]|0)<0){i=r;return 0}c[318020>>2]=6;MUc(318016)|0;bUc(318208,317088,4)|0;uUc()|0;c[78666]=1;z=1;d:while(1){c[78228]=z;do{if((z|0)>(c[e>>2]|0)){s=c[78666]|0;if((s|0)==1){c[318044>>2]=6;MUc(318040)|0;uUc()|0;ODc(312976,314672,315e3,316880,317456,q,317040)|0;c[318068>>2]=6;MUc(318064)|0;uUc()|0;c[78666]=3;z=1;continue d}else if((s|0)==2){break d}else if((s|0)!=3){break}c[78666]=2;c[78238]=0;c[78240]=0;s=c[e>>2]|0;c[78222]=1;if((s|0)>=1){za=0;la=1;u=0;E=0;while(1){Ea=(E|0)>1?E:1;U=Ea+1|0;x=c5c(Ea+ -1|0,0,Ea+ -2|0,0)|0;Ha=X4c(x|0,J&1|0,1)|0;x=(Ea<<1)+ -1+Ha|0;Ia=u+la|0;Ha=312976+(Ia+ -1<<3)|0;I=+h[Ha>>3];if(I>0.0){Ja=1.0/+V(+I)}else{Ja=0.0}h[Ha>>3]=Ja;Ka=la+ -1|0;if((la|0)<2){La=za;Ma=1;Na=0}else{I=Ja;Oa=1;Pa=za;Qa=0;while(1){Ra=Qa+Oa|0;Sa=312976+(Pa<<3)|0;h[Sa>>3]=+h[Sa>>3]*I*+h[312976+(Ra+ -1<<3)>>3];if((Oa|0)>=(Ka|0)){break}I=+h[Ha>>3];Oa=Oa+1|0;Pa=Pa+1|0;Qa=Ra}La=za+Ea|0;Ma=U;Na=x}Ta=La+1|0;if((la|0)<(s|0)){za=Ta;la=la+1|0;E=E+1|0;u=Ia}else{break}}c[78242]=Na;c[78240]=Ta;c[78238]=Ia;c[78224]=Ma;c[78222]=s+1}c[318092>>2]=6;MUc(318088)|0;uUc()|0;c[78238]=0;u=c[e>>2]|0;c[78222]=1;if((u|0)<1){z=1;continue d}else{Ua=1;Va=0}while(1){Wa=Va+Ua|0;E=312976+(Wa+ -1<<3)|0;if(+h[E>>3]!=0.0){h[E>>3]=1.0}if((Ua|0)<(u|0)){Ua=Ua+1|0;Va=Wa}else{break}}c[78238]=Wa;c[78222]=u+1;z=1;continue d}}while(0);T=(fa(z+ -1|0,z)|0)/2|0;c[78238]=T;s=c[e>>2]|0;c[78222]=z;e:do{if((z|0)<=(s|0)){E=z;la=T;za=z;while(1){B=E+la|0;c[78232]=B;Qa=za+la|0;c[78238]=Qa;Pa=B+5|0;c[78234]=(Qa|0)<=(Pa|0)?Qa:Pa;if((c[78666]|0)==3){c[318164>>2]=6;MUc(318160)|0;Pa=c[78234]|0;Qa=c[78232]|0;c[78224]=Qa;if((Qa|0)<=(Pa|0)){B=Qa;do{bUc(318208,315e3+(B+ -1<<3)|0,8)|0;Qa=c[78224]|0;B=Qa+1|0;c[78224]=B;}while((Qa|0)<(Pa|0))}uUc()|0}else{c[318140>>2]=6;MUc(318136)|0;Pa=c[78234]|0;B=c[78232]|0;c[78224]=B;if((B|0)<=(Pa|0)){x=B;do{bUc(318208,312976+(x+ -1<<3)|0,8)|0;B=c[78224]|0;x=B+1|0;c[78224]=x;}while((B|0)<(Pa|0))}uUc()|0}Pa=c[78222]|0;x=Pa+1|0;c[78222]=x;if((Pa|0)>=(s|0)){break e}E=c[78228]|0;la=c[78238]|0;za=x}}}while(0);c[318188>>2]=6;MUc(318184)|0;uUc()|0;z=(c[78228]|0)+6|0}c[318116>>2]=6;MUc(318112)|0;bUc(318208,317104,4)|0;uUc()|0;i=r;return 0}else if((R|0)==312){i=r;return 0}}}while(0);le[p&63](e,b,f)|0;i=r;return 0}function ODc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0.0,z=0.0,A=0,B=0,C=0.0,D=0,E=0,F=0,G=0,H=0.0,I=0;k=i;c[79572]=c[b>>2];c[g>>2]=1;if((c[79572]|0)<1){i=k;return 0}c[g>>2]=0;PDc(a,318288,d,f,g,j,e)|0;if((c[g>>2]|0)!=0){i=k;return 0}g=c[79572]|0;j=g+1|0;f=(fa(j,g)|0)/2|0;c[79564]=f;c[79570]=g;c[79576]=f;a=g+ -1|0;b=f+(fa(a,1-g|0)|0)|0;l=c5c(a|0,0,g+ -2|0,0)|0;m=X4c(l|0,J&1|0,1)|0;l=b+m|0;m=0-g|0;b=f;n=g;while(1){if(+h[d+(b+ -1<<3)>>3]==0.0){c[79556]=n;if((n|0)>(g|0)){o=b}else{p=g-n|0;q=fa(p,n+1|0)|0;r=c5c(p|0,0,a-n|0,0)|0;p=X4c(r|0,J&1|0,1)|0;r=n;s=b;while(1){h[d+(s+ -1<<3)>>3]=0.0;if((r|0)<(g|0)){s=s+r|0;r=r+1|0}else{break}}c[79556]=j;o=n+b+q+p|0}t=o;u=n+ -1|0}else{c[79554]=n;if((n|0)<=(g|0)){r=n;s=b;while(1){h[e+(r+ -1<<3)>>3]=+h[d+(s+ -1<<3)>>3];if((r|0)>=(g|0)){break}v=s+r|0;r=r+1|0;s=v}c[79554]=j}c[79566]=g;c[79568]=f;c[79574]=f;s=n+ -1|0;r=e+(s<<3)|0;p=(g|0)==(n|0);q=f;v=g;w=f;while(1){h[39781]=0.0;x=(v|0)==(n|0);if(x){y=1.0/+h[r>>3];h[39781]=y;z=y}else{z=0.0}if(p){A=g;B=w;C=z}else{y=z;D=g;E=w;while(1){F=D+ -1|0;G=E+ -1|0;H=y- +h[e+(F<<3)>>3]*+h[d+(G<<3)>>3];h[39781]=H;if((G|0)>(q|0)){I=E+(1-D)|0}else{I=G}if((F|0)==(n|0)){A=n;B=I;C=H;break}else{E=I;D=F;y=H}}}h[d+(B+ -1<<3)>>3]=C/+h[r>>3];if(x){break}D=q-v|0;c[79574]=D;E=v+ -1|0;c[79566]=E;F=w+ -1|0;c[79568]=F;q=D;v=E;w=F}c[79558]=A;t=B;u=s}w=b+m|0;if((u|0)==0){break}else{m=m+1|0;b=w;n=u}}c[79560]=t;c[79570]=0;c[79576]=l-g;i=k;return 0}function PDc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0.0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0.0,H=0.0,I=0,J=0,K=0.0,L=0.0,M=0.0,N=0,O=0;k=i;h[39795]=.5;l=.5;do{l=l*.5;}while(l+1.0>1.0);m=l*2.0;h[39795]=m;c[f>>2]=1;if((c[b>>2]|0)<1){i=k;return 0}c[f>>2]=2;c[e>>2]=0;h[g>>3]=m;h[j>>3]=+h[39795];c[79580]=1;c[79582]=0;n=c[b>>2]|0;c[79594]=1;a:do{if((n|0)>=1){b=1;o=1;b:while(1){c[79584]=0;c[79596]=1;do{if((o|0)>=1){p=1;q=c[79582]|0;r=0;while(1){s=q+1|0;t=a+(q<<3)|0;m=+h[t>>3];h[39794]=m;u=(p|0)==(o|0);if(u){l=m*+h[39795];h[39796]=l*l}do{if((p|0)<1){v=m;w=r;x=b;y=1}else{l=m;z=b;A=1;B=r;while(1){C=B+1|0;if((A|0)==(p|0)){D=14;break}E=d+(B<<3)|0;F=l- +h[E>>3]*+h[d+(z+ -1<<3)>>3];h[39794]=F;if(u){G=+h[E>>3];H=G*G*+h[j+(A+ -1<<3)>>3];h[39796]=+h[39796]+H*H}I=z+1|0;J=A+1|0;if((A|0)<(p|0)){l=F;z=I;A=J;B=C}else{D=15;break}}if((D|0)==14){D=0;c[79584]=C;v=l;w=C;x=z;y=p;break}else if((D|0)==15){D=0;c[79584]=C;v=F;w=C;x=I;y=J;break}}}while(0);if(u){D=25;break}m=+h[d+(w+ -1<<3)>>3];if(m==0.0){h[d+(q<<3)>>3]=0.0;H=+h[39794];if(!(H>=0.0)){K=-H}else{K=H}H=+h[g>>3]*+h[t>>3];if(!(H>=0.0)){L=-H}else{L=H}if(K>L){break b}}else{h[d+(q<<3)>>3]=v/m}B=p+1|0;c[79596]=B;if((p|0)<(o|0)){p=B;r=w;q=s}else{D=26;break}}if((D|0)==25){D=0;c[79578]=y;c[79586]=x;c[79582]=s;break}else if((D|0)==26){D=0;c[79578]=y;c[79586]=x;c[79582]=s;break}}}while(0);m=+V(+(+h[39796]));h[39796]=m;H=+h[39794];if(!(H>=0.0)){M=-H}else{M=H}do{if(!(M<=m*5.0)){if(H<0.0){D=37;break b}G=+V(+H);h[d+((c[79582]|0)+ -1<<3)>>3]=G;G=+h[39796]/+h[39794];h[j+((c[79578]|0)+ -1<<3)>>3]=G;if(!(G>+h[g>>3])){N=b;O=o;break}h[g>>3]=G;N=b;O=o}else{h[d+((c[79582]|0)+ -1<<3)>>3]=0.0;c[e>>2]=(c[e>>2]|0)+1;N=c[79580]|0;O=c[79594]|0}}while(0);b=N+O|0;c[79580]=b;o=O+1|0;c[79594]=o;if((O|0)>=(n|0)){break a}}if((D|0)==37){i=k;return 0}c[79578]=y;c[79586]=x;c[79582]=s;i=k;return 0}}while(0);c[f>>2]=0;i=k;return 0}function QDc(b,d,e,f,g,h,j,k,l){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;m=i;n=(c[b>>2]|0)+1|0;c[79620]=n;o=(c[d>>2]|0)-n|0;c[79642]=o;p=c[d>>2]|0;q=c[b>>2]|0;r=q+2|0;do{if((p|0)>=(r|0)){if((p|0)>((fa(n,r)|0)/2|0|0)){break}s=q+p|0;c[79640]=s;a[318504]=1;t=c[b>>2]|0;u=t+1|0;c[79636]=u;v=c[b>>2]|0;w=u+v|0;c[79634]=w;u=w+(c[b>>2]|0)|0;c[79638]=u;w=(fa(c[d>>2]|0,c[b>>2]|0)|0)+u|0;c[79628]=w;x=w+(c[d>>2]|0)|0;c[79622]=x;y=x+(c[b>>2]|0)|0;c[79624]=y;z=((fa(n,c[b>>2]|0)|0)/2|0)+y|0;c[79630]=z;A=z+(c[d>>2]|0)|0;c[79644]=A;B=(fa(c[b>>2]|0,s)|0)+A|0;c[79646]=B;C=(fa(o,c[d>>2]|0)|0)+B|0;c[79618]=C;D=C+(c[b>>2]|0)|0;c[79632]=D;RDc(b,d,e,f,g,h,j,k,k+(t<<3)|0,k+(t+v<<3)|0,k+(u+ -1<<3)|0,k+(w+ -1<<3)|0,k+(x+ -1<<3)|0,k+(y+ -1<<3)|0,k+(z+ -1<<3)|0,k+(A+ -1<<3)|0,k+(B+ -1<<3)|0,318560,k+(C+ -1<<3)|0,k+(D+ -1<<3)|0,k+(s+ -1+D<<3)|0,l)|0;i=m;return 0}}while(0);MUc(318592)|0;uUc()|0;i=m;return 0}function RDc(a,b,d,e,f,g,j,k,l,m,n,o,p,q,r,s,t,u,v,w,x,y){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;s=s|0;t=t|0;u=u|0;v=v|0;w=w|0;x=x|0;y=y|0;var z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0.0,S=0,T=0,U=0,W=0.0,X=0,Y=0,Z=0.0,_=0,$=0,aa=0,ba=0.0,ca=0,da=0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0,Ja=0.0,Ka=0.0,La=0,Ma=0,Na=0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0.0,Va=0,Wa=0.0,Xa=0,Ya=0,Za=0,_a=0,$a=0.0,ab=0.0,bb=0.0,cb=0.0,db=0.0,eb=0.0,fb=0,gb=0.0,hb=0.0,ib=0,jb=0.0,kb=0.0,lb=0.0,mb=0.0,nb=0,ob=0.0,pb=0.0,qb=0.0,rb=0,sb=0.0,tb=0.0,ub=0.0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0.0,Bb=0.0,Cb=0.0,Db=0.0,Eb=0.0,Fb=0.0,Gb=0.0,Hb=0.0,Ib=0.0,Jb=0.0,Kb=0.0,Lb=0.0,Mb=0.0,Nb=0.0,Ob=0.0;z=i;i=i+8|0;A=z;B=c[b>>2]|0;C=~B;D=c[u>>2]|0;E=~D;h[39909]=.5;h[39900]=1.0;h[39940]=.1;F=(c[a>>2]|0)+1|0;c[79796]=F;G=fa(c[a>>2]|0,F)|0;H=(G|0)/2|0;c[79788]=H;I=(c[b>>2]|0)-F|0;c[79842]=I;F=c[j>>2]|0;c[79896]=(F|0)<1?1:F;F=c[a>>2]|0;c[79780]=1;if((F|0)>=1){j=1;while(1){J=j+ -1|0;h[k+(J<<3)>>3]=+h[d+(J<<3)>>3];J=c[b>>2]|0;c[79782]=1;if((J|0)>=1){K=fa(j,B)|0;L=1;while(1){h[n+(L+C+K<<3)>>3]=0.0;if((L|0)<(J|0)){L=L+1|0}else{break}}c[79782]=J+1}L=c[u>>2]|0;c[79778]=1;if((L|0)>=1){K=1;while(1){h[s+(K+E+(fa(j,D)|0)<<3)>>3]=0.0;if((K|0)<(L|0)){K=K+1|0}else{break}}c[79778]=L+1}K=j+1|0;c[79780]=K;if((j|0)<(F|0)){j=K}else{break}}}c[79784]=1;if((G|0)>=2){G=1;while(1){h[q+(G+ -1<<3)>>3]=0.0;if((G|0)<(H|0)){G=G+1|0}else{break}}c[79784]=H+1}H=c[b>>2]|0;c[79782]=1;if((H|0)>=1){G=(I|0)<1;j=I+1|0;F=1;while(1){h[r+(F+ -1<<3)>>3]=0.0;if(G){M=1}else{K=1;while(1){h[t+((fa(K,B)|0)+C+F<<3)>>3]=0.0;if((K|0)<(I|0)){K=K+1|0}else{M=j;break}}}if((F|0)<(H|0)){F=F+1|0}else{break}}c[79780]=M;c[79782]=H+1}N=+h[e>>3];O=N*N;h[39945]=O;h[39931]=+h[39900]/O;h[39932]=+V(+(+h[39909]))/O;c[79786]=0;H=y;y=A;M=0;a:while(1){c[79798]=M;F=M-(c[a>>2]|0)|0;c[79822]=F;j=M+1|0;c[79786]=j;I=c[a>>2]|0;do{if((M|0)>(I<<1|0)){G=(F+ -1|0)/(I|0)|0;c[79872]=G;K=c[a>>2]|0;L=M-(fa(K,G)|0)-K|0;c[79810]=L;K=L+G|0;c[79808]=K;if((K|0)>(c[a>>2]|0)){c[79872]=L;G=K-(c[a>>2]|0)|0;c[79810]=G;c[79808]=L;P=L;Q=G}else{P=K;Q=L}O=+h[e>>3];h[39922]=O;L=c[79796]|0;if(+h[o+(P+ -1+L<<3)>>3]<+h[o+(P<<3)>>3]){N=-O;h[39922]=N;R=N}else{R=O}O=+h[e>>3];h[39923]=O;if(+h[o+(Q+ -1+L<<3)>>3]<+h[o+(Q<<3)>>3]){h[39923]=-O}L=j+C|0;h[n+(L+(fa(P,B)|0)<<3)>>3]=R;h[n+(L+(fa(Q,B)|0)<<3)>>3]=+h[39923];S=c[a>>2]|0}else{L=(M|0)>(I|0);if(!((M|0)<1|L)){h[n+((fa(M,B)|0)+C+j<<3)>>3]=+h[e>>3];S=I;break}if(!L){S=I;break}h[n+(j+C+(fa(F,B)|0)<<3)>>3]=-+h[e>>3];S=I}}while(0);c[79780]=1;if((S|0)>=1){I=1;while(1){O=+h[n+((fa(I,B)|0)+C+j<<3)>>3];F=I+ -1|0;h[d+(F<<3)>>3]=O+ +h[k+(F<<3)>>3];if((I|0)<(S|0)){I=I+1|0}else{break}}c[79780]=S+1}if((M|0)>=(c[79896]|0)){T=j;U=159;break}while(1){le[H&63](a,d,319104)|0;if((c[g>>2]|0)==3){MUc(319632)|0;bUc(319800,319144,4)|0;bUc(319800,319104,8)|0;I=c[a>>2]|0;c[79778]=1;if((I|0)>=1){F=1;do{bUc(319800,d+(F+ -1<<3)|0,8)|0;L=c[79778]|0;F=L+1|0;c[79778]=F;}while((L|0)<(I|0))}uUc()|0}I=c[79786]|0;do{if((I|0)>(c[b>>2]|0)){F=c[79826]|0;if((F|0)==-1){break a}h[39941]=0.0;c[79784]=0;L=c[a>>2]|0;c[79780]=1;if((L|0)<1){W=0.0}else{O=0.0;K=2;G=1;J=0;while(1){X=G+ -1|0;N=O+ +h[v+(X<<3)>>3]*+h[p+(X<<3)>>3];h[39941]=N;if((G|0)<1){Y=1;Z=N;_=J}else{X=G+ -1|0;$=m+(X<<3)|0;aa=v+(X<<3)|0;ba=N;X=1;ca=J;while(1){da=X+ -1|0;N=+h[v+(da<<3)>>3]*+h[$>>3]+ +h[aa>>3]*+h[l+(da<<3)>>3];h[39914]=N;if((X|0)==(G|0)){ea=N*+h[39909];h[39914]=ea;ga=ea}else{ga=N}ha=ba+ga*+h[q+(ca<<3)>>3];h[39941]=ha;if((X|0)<(G|0)){ba=ha;X=X+1|0;ca=ca+1|0}else{break}}ca=J+G|0;c[79784]=ca;Y=K;Z=ha;_=ca}if((G|0)<(L|0)){O=Z;K=K+1|0;G=G+1|0;J=_}else{break}}c[79778]=Y;c[79780]=L+1;W=Z}J=c[b>>2]|0;c[79782]=1;if((J|0)<1){ia=W}else{O=W;G=1;while(1){K=G+ -1|0;ja=O+ +h[r+(K<<3)>>3]*+h[x+(K<<3)>>3];h[39941]=ja;if((G|0)<(J|0)){G=G+1|0;O=ja}else{break}}c[79782]=J+1;ia=ja}O=+h[39888];ba=+h[39917];N=O-ba-ia;h[39908]=N;h[39927]=+h[39926];h[39926]=+h[39925];if(!(N>=0.0)){ka=-N}else{ka=N}h[39925]=ka;if(+h[39937]>+h[39903]){c[79870]=I}h[39933]=ba;do{if(O<ba){h[39917]=O;h[39950]=0.0;G=c[a>>2]|0;c[79778]=1;if((G|0)<1){break}else{la=1}while(1){L=la+ -1|0;h[l+(L<<3)>>3]=+h[m+(L<<3)>>3];ma=+h[l+(la+ -1<<3)>>3];h[39950]=+h[39950]+ma*ma;if((la|0)<(G|0)){la=la+1|0}else{break}}c[79778]=G+1;h[A>>3]=ma}}while(0);c[79868]=F;if((F|0)<=0){O=+h[39941];if(O>=0.0){U=190;break a}ba=+h[39888];N=+h[39933];ea=(ba-N)/O;h[39938]=ea;O=+h[39940];do{if(!(ea<=O)){na=+h[39909]*+h[39930];h[A>>3]=na;oa=+h[39937];if(!(ea<=.7)){pa=oa+oa;qa=na>=pa?na:pa;h[39930]=qa;ra=qa;break}else{qa=na>=oa?na:oa;h[39930]=qa;ra=qa;break}}else{qa=+h[39909]*+h[39937];h[39930]=qa;ra=qa}}while(0);ea=+h[39903];if(!(ra<=ea*1.5)){sa=ra}else{h[39930]=ea;sa=ea}qa=O*sa;oa=qa>=ea?qa:ea;h[A>>3]=oa;ea=oa*oa;h[39945]=ea;c[79884]=0;h[39946]=0.0;if(!(ba>=N)){ta=0;ua=0.0}else{J=c[79840]|0;c[79884]=J;oa=+h[39900];h[39946]=oa;ta=J;ua=oa}J=c[b>>2]|0;c[79782]=1;if((J|0)<1){va=F}else{L=c[79842]|0;oa=ua;K=1;ca=F;while(1){h[39928]=0.0;c[79780]=1;if((L|0)<1){wa=0.0}else{X=c[79802]|0;aa=K+C|0;qa=+h[39900];na=0.0;$=1;while(1){if(($|0)<(X|0)){xa=-qa}else{xa=qa}h[39914]=xa;pa=+h[t+(aa+(fa($,B)|0)<<3)>>3];ya=na+xa*pa*pa;h[39928]=ya;if(($|0)<(L|0)){na=ya;$=$+1|0}else{break}}c[79780]=L+1;wa=ya}na=+h[w+(K+ -1<<3)>>3];qa=na*na+ +h[39910]*wa;if(!(qa>=0.0)){za=-qa}else{za=qa}h[39914]=za;h[39949]=0.0;$=c[a>>2]|0;c[79780]=1;if(($|0)<1){Aa=qa;Ba=0.0}else{qa=0.0;aa=1;while(1){na=+h[n+((fa(aa,B)|0)+C+K<<3)>>3];Ca=na- +h[l+(aa+ -1<<3)>>3];Da=qa+Ca*Ca;h[39949]=Da;if((aa|0)<($|0)){aa=aa+1|0;qa=Da}else{break}}c[79780]=$+1;Aa=Ca;Ba=Da}if(Ba>ea){qa=Ba/ea;na=za*qa*qa*qa;h[39914]=na;Ea=qa;Fa=na}else{Ea=Aa;Fa=za}if(!(Fa>oa)|(K|0)==(ta|0)){Ga=oa;Ha=ca}else{h[39946]=Fa;c[79826]=K;Ga=Fa;Ha=K}aa=K+1|0;c[79782]=aa;if((K|0)<(J|0)){oa=Ga;K=aa;ca=Ha}else{break}}h[A>>3]=Ea;va=Ha}if((va|0)==0){Ia=0;Ja=sa;Ka=O;U=286;break}}XDc(a,b,s,t,319208,u,w,319280,319304,x)|0;ca=c[79826]|0;K=ca+ -1|0;h[o+(K<<3)>>3]=+h[39888];c[79784]=0;J=c[a>>2]|0;c[79778]=1;L=r+(K<<3)|0;if((J|0)>=1){K=ca+C|0;F=2;aa=1;X=0;while(1){oa=+h[L>>3]*+h[n+((fa(aa,B)|0)+C+ca<<3)>>3];h[39914]=oa;if((aa|0)<1){La=1;Ma=X}else{ea=oa;G=1;da=X;while(1){oa=ea*+h[n+(K+(fa(G,B)|0)<<3)>>3];Na=q+(da<<3)|0;h[Na>>3]=+h[Na>>3]+oa;if((G|0)>=(aa|0)){break}ea=+h[39914];G=G+1|0;da=da+1|0}da=X+aa|0;c[79784]=da;La=F;Ma=da}if((aa|0)<(J|0)){F=F+1|0;aa=aa+1|0;X=Ma}else{break}}c[79780]=La;c[79778]=J+1}h[L>>3]=0.0;X=c[79842]|0;c[79780]=1;aa=(X|0)<1;if(!aa){F=c[79802]|0;K=1;while(1){da=fa(K,B)|0;O=+h[39908]*+h[t+(da+C+ca<<3)>>3];if((K|0)<(F|0)){Oa=-O}else{Oa=O}h[39914]=Oa;G=c[b>>2]|0;c[79782]=1;if((G|0)>=1){O=Oa;$=1;while(1){Na=r+($+ -1<<3)|0;h[Na>>3]=+h[Na>>3]+O*+h[t+($+C+da<<3)>>3];if(($|0)>=(G|0)){break}O=+h[39914];$=$+1|0}c[79782]=G+1}$=K+1|0;c[79780]=$;if((K|0)<(X|0)){K=$}else{break}}}h[39919]=0.0;K=c[a>>2]|0;c[79778]=1;if((K|0)>=1){F=1;while(1){O=+h[39908]*+h[s+((fa(F,D)|0)+E+ca<<3)>>3];L=p+(F+ -1<<3)|0;h[L>>3]=+h[L>>3]+O;L=F+ -1|0;Pa=+h[p+(L<<3)>>3];h[39919]=+h[39919]+Pa*Pa;h[n+((fa(F,B)|0)+C+ca<<3)>>3]=+h[m+(L<<3)>>3];if((F|0)<(K|0)){F=F+1|0}else{break}}c[79778]=K+1;h[A>>3]=Pa}F=c[79868]|0;do{if((F|0)==0){if(!(+h[39930]==+h[39903])){break}O=+h[39938];if(!(O>=0.0)){Qa=-O}else{Qa=O}if(Qa>.01){c[79888]=0;break}L=c[b>>2]|0;c[79782]=1;if((L|0)>=1){J=o+((c[79840]|0)+ -1<<3)|0;$=1;while(1){da=$+ -1|0;h[w+(da<<3)>>3]=+h[o+(da<<3)>>3]- +h[J>>3];if(($|0)<(L|0)){$=$+1|0}else{break}}c[79782]=L+1}h[39912]=0.0;$=c[a>>2]|0;c[79778]=1;if(($|0)<1){Ra=0.0}else{J=1;while(1){h[39906]=0.0;G=c[b>>2]|0;c[79782]=1;if((G|0)<1){Sa=0.0}else{da=fa(J,D)|0;O=0.0;Na=1;while(1){Ta=O+ +h[s+(Na+E+da<<3)>>3]*+h[w+(Na+ -1<<3)>>3];h[39906]=Ta;if((Na|0)<(G|0)){Na=Na+1|0;O=Ta}else{break}}c[79782]=G+1;Sa=Ta}h[39912]=+h[39912]+Sa*Sa;h[x+(J+ -1<<3)>>3]=Sa;Na=J+1|0;c[79778]=Na;if((J|0)<($|0)){J=Na}else{break}}Ra=+h[39912]*100.0}J=c[79888]|0;c[79888]=J+1;if(+h[39919]<Ra){c[79888]=0;break}if((J|0)<=1){break}J=c[a>>2]|0;c[79778]=1;if((J|0)>=1){$=1;while(1){L=$+ -1|0;h[p+(L<<3)>>3]=+h[x+(L<<3)>>3];if(($|0)<(J|0)){$=$+1|0}else{break}}c[79778]=J+1}$=c[79788]|0;c[79784]=1;if(($|0)>=1){L=1;while(1){h[q+(L+ -1<<3)>>3]=0.0;if((L|0)<($|0)){L=L+1|0}else{break}}c[79784]=$+1}c[79780]=1;if(!aa){L=1;while(1){J=x+(L+ -1<<3)|0;h[J>>3]=0.0;Na=c[b>>2]|0;c[79782]=1;if((Na|0)<1){Ua=0.0}else{da=fa(L,B)|0;O=0.0;Va=1;while(1){Wa=O+ +h[w+(Va+ -1<<3)>>3]*+h[t+(Va+C+da<<3)>>3];h[J>>3]=Wa;if((Va|0)<(Na|0)){Va=Va+1|0;O=Wa}else{break}}c[79782]=Na+1;Ua=Wa}if((L|0)<(c[79802]|0)){h[J>>3]=-Ua}Va=L+1|0;c[79780]=Va;if((L|0)<(X|0)){L=Va}else{break}}}L=c[b>>2]|0;c[79782]=1;if((L|0)>=1){$=X+1|0;Va=1;while(1){h[r+(Va+ -1<<3)>>3]=0.0;if(aa){Xa=1}else{da=1;while(1){O=+h[t+((fa(da,B)|0)+C+Va<<3)>>3];G=r+(Va+ -1<<3)|0;h[G>>3]=+h[G>>3]+O*+h[x+(da+ -1<<3)>>3];if((da|0)<(X|0)){da=da+1|0}else{Xa=$;break}}}if((Va|0)<(L|0)){Va=Va+1|0}else{break}}c[79780]=Xa;c[79782]=L+1}c[79888]=0}}while(0);O=+h[39888];ea=+h[39933];if(O<ea){c[79840]=ca}oa=+h[39940];if(O<=ea+oa*+h[39941]|(F|0)>0){U=54;break}c[79826]=0;Ia=0;Ja=+h[39930];Ka=oa;U=286}else{h[o+(I+ -1<<3)>>3]=+h[39888];oa=+h[39888];do{if((I|0)==1){h[39907]=oa;h[39917]=oa;c[79840]=1;Ya=1}else{if(!(oa<+h[39917])){Ya=I;break}h[39917]=oa;c[79840]=I;Ya=I}}while(0);F=c[79798]|0;ca=c[a>>2]|0;do{if((F|0)>(ca<<1|0)){X=c[79808]|0;aa=(fa(X+ -1|0,X)|0)/2|0;K=c[79810]|0;Va=K+aa|0;c[79784]=Va;if(+h[39922]<0.0){aa=X+(c[a>>2]|0)|0;c[79808]=aa;Za=aa}else{Za=X}if(+h[39923]<0.0){X=K+(c[a>>2]|0)|0;c[79810]=X;_a=X}else{_a=K}K=fa(c[79822]|0,B)|0;h[t+(K-B<<3)>>3]=+h[39931];h[t+(Ya+C+K<<3)>>3]=+h[39931];h[t+(Za-B+K<<3)>>3]=-+h[39931];h[t+(_a-B+K<<3)>>3]=-+h[39931];h[q+(Va+ -1<<3)>>3]=(+h[39907]- +h[o+(Za<<3)>>3]- +h[o+(_a<<3)>>3]+ +h[39888])/(+h[39922]*+h[39923])}else{Va=(F|0)>(ca|0);if((F|0)<1|Va){if(!Va){break}Va=c[79822]|0;K=fa(Va,D)|0;h[s+(E-ca+Ya+K<<3)>>3]=+h[39909]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=-+h[39909]/+h[e>>3];ea=+h[39932];K=fa(Va,B)|0;h[t+(K-B<<3)>>3]=-ea-ea;X=Ya+C|0;h[t+(X-ca+K<<3)>>3]=+h[39932];h[t+(X+K<<3)>>3]=+h[39932];K=(fa(Va+1|0,Va)|0)/2|0;c[79784]=K;ea=(+h[39907]- +h[39888])/+h[e>>3];h[39914]=ea;X=p+(Va+ -1<<3)|0;h[q+(K+ -1<<3)>>3]=(+h[X>>3]-ea)/+h[e>>3];h[X>>3]=+h[39909]*(+h[X>>3]+ +h[39914]);break}else{h[p+(F+ -1<<3)>>3]=(oa- +h[39907])/+h[e>>3];X=c[b>>2]|0;if((X|0)>=(ca+Ya|0)){break}K=fa(F,D)|0;h[s+(K-D<<3)>>3]=-+h[39900]/+h[e>>3];h[s+(Ya+E+K<<3)>>3]=+h[39900]/+h[e>>3];h[s+(X+E+F+K<<3)>>3]=-(+h[39909]*+h[39945]);break}}}while(0);if((Ya|0)<(c[b>>2]|0)){M=Ya;continue a}oa=+h[e>>3];h[39903]=oa;h[39930]=oa;c[79802]=1;h[39925]=0.0;h[39926]=0.0;c[79888]=0;h[39950]=0.0;F=c[a>>2]|0;c[79778]=1;if((F|0)<1){U=53;break}ca=c[79840]|0;K=1;while(1){h[l+(K+ -1<<3)>>3]=+h[n+((fa(K,B)|0)+C+ca<<3)>>3];$a=+h[l+(K+ -1<<3)>>3];h[39950]=+h[39950]+$a*$a;if((K|0)<(F|0)){K=K+1|0}else{break}}c[79778]=F+1;h[A>>3]=$a;U=53}}while(0);while(1){if((U|0)==53){U=0;c[79870]=c[79786];U=54;continue}else if((U|0)==54){U=0;c[79826]=0;I=(c[79796]|0)+ -1|0;K=c[a>>2]|0;WDc(a,b,l,n,p,q,r,319440,v,x,x+(I<<3)|0,x+(I+K<<3)|0,x+(I+(K<<1)<<3)|0,319576)|0;h[39902]=0.0;K=c[a>>2]|0;c[79778]=1;if((K|0)<1){ab=0.0}else{oa=0.0;I=1;while(1){bb=+h[v+(I+ -1<<3)>>3];cb=oa+bb*bb;h[39902]=cb;if((I|0)<(K|0)){I=I+1|0;oa=cb}else{break}}h[A>>3]=bb;c[79778]=K+1;ab=cb}oa=+h[39930];h[A>>3]=oa;ea=+V(+ab);O=oa<=ea?oa:ea;h[39937]=O;ea=+h[39903];if(!(O<+h[39909]*ea)){db=ab;U=62;break}c[79826]=-1;O=+h[39940];N=O*oa;h[39930]=N;h[39938]=-1.0;if(!(N<=ea*1.5)){eb=N}else{h[39930]=ea;eb=ea}if((c[79786]|0)<=((c[79870]|0)+2|0)){Ia=-1;Ja=eb;Ka=O;U=286;continue}N=ea*+h[39947]*.125*ea;h[39914]=N;oa=+h[39925];ba=+h[39926];na=oa>=ba?oa:ba;h[A>>3]=na;ba=+h[39927];if(!(N<=(na>=ba?na:ba))){fb=-1;gb=O;hb=ea}else{Ia=-1;Ja=eb;Ka=O;U=286;continue}}else if((U|0)==286){U=0;O=Ja*Ja*4.0;h[39949]=O;I=c[b>>2]|0;c[79782]=1;if((I|0)<1){ib=Ia}else{F=1;ea=O;ca=Ia;while(1){h[39906]=0.0;X=c[a>>2]|0;c[79780]=1;if((X|0)<1){jb=0.0}else{O=0.0;Va=1;while(1){ba=+h[n+((fa(Va,B)|0)+C+F<<3)>>3];kb=ba- +h[l+(Va+ -1<<3)>>3];lb=O+kb*kb;h[39906]=lb;if((Va|0)<(X|0)){Va=Va+1|0;O=lb}else{break}}h[A>>3]=kb;c[79780]=X+1;jb=lb}if(jb>ea){c[79826]=F;h[39949]=jb;mb=jb;nb=F}else{mb=ea;nb=ca}Va=F+1|0;c[79782]=Va;if((F|0)<(I|0)){F=Va;ea=mb;ca=nb}else{break}}if((nb|0)>0){U=294;break}else{ib=nb}}if(+h[39938]>0.0){U=54;continue}ea=+h[39937];O=+h[39903];if((Ja>=ea?Ja:ea)>O){U=54;continue}else{fb=ib;gb=Ka;hb=O}}if(!(hb>+h[f>>3])){U=309;break}O=hb*+h[39909];h[39930]=O;ea=hb/+h[f>>3];h[39938]=ea;do{if(!(ea<=16.0)){if(!(ea<=250.0)){ba=gb*hb;h[39903]=ba;ob=ba;break}else{ba=+V(+ea);na=ba*+h[f>>3];h[39903]=na;ob=na;break}}else{na=+h[f>>3];h[39903]=na;ob=na}}while(0);h[39930]=O>=ob?O:ob;ca=c[g>>2]|0;if((ca|0)<=1){U=53;continue}if((ca|0)>2){MUc(319680)|0;uUc()|0}MUc(319704)|0;bUc(319800,319224,8)|0;bUc(319800,319144,4)|0;uUc()|0;MUc(319728)|0;bUc(319800,319336,8)|0;ca=c[a>>2]|0;c[79778]=1;if((ca|0)>=1){F=1;do{I=F+ -1|0;h[A>>3]=+h[k+(I<<3)>>3]+ +h[l+(I<<3)>>3];bUc(319800,y,8)|0;I=c[79778]|0;F=I+1|0;c[79778]=F;}while((I|0)<(ca|0))}uUc()|0;U=53}if((U|0)==294){U=0;O=Ka*+V(+mb);ea=+h[39909]*Ja;na=O<=ea?O:ea;h[A>>3]=na;ea=+h[39903];O=na>=ea?na:ea;h[39939]=O;ea=O*O;h[39902]=ea;db=ea;U=62}else if((U|0)==309){U=0;if(!((fb|0)==-1)){break a}}do{if((U|0)==62){U=0;ea=+h[39950];if(db<=ea*.001){h[39943]=ea*.25;ca=c[b>>2]|0;c[79782]=1;if((ca|0)>=1){F=1;while(1){h[39906]=0.0;I=c[a>>2]|0;c[79778]=1;if((I|0)<1){pb=0.0}else{ea=0.0;K=1;while(1){O=+h[n+((fa(K,B)|0)+C+F<<3)>>3];qb=ea+O*+h[l+(K+ -1<<3)>>3];h[39906]=qb;if((K|0)<(I|0)){K=K+1|0;ea=qb}else{break}}c[79778]=I+1;pb=qb}h[39914]=+h[r+(F+ -1<<3)>>3]*pb;ea=pb- +h[39909]*+h[39950];h[39906]=ea;h[x+((c[b>>2]|0)+ -1+F<<3)>>3]=ea;K=c[a>>2]|0;c[79778]=1;if((K|0)>=1){X=1;while(1){Va=fa(X,B)|0;L=n+(Va+C+F<<3)|0;aa=X+ -1|0;$=p+(aa<<3)|0;h[$>>3]=+h[$>>3]+ +h[39914]*+h[L>>3];$=l+(aa<<3)|0;h[L>>3]=+h[L>>3]- +h[39909]*+h[$>>3];L=w+(aa<<3)|0;h[L>>3]=+h[s+(F+E+(fa(X,D)|0)<<3)>>3];ea=+h[39906]*+h[n+(F+C+Va<<3)>>3]+ +h[39943]*+h[$>>3];$=x+(aa<<3)|0;h[$>>3]=ea;aa=X+(c[b>>2]|0)|0;c[79790]=aa;c[79780]=1;if((X|0)<1){rb=X+1|0}else{O=ea;Va=1;while(1){da=s+((fa(Va,D)|0)+E+aa<<3)|0;J=Va+ -1|0;h[da>>3]=+h[da>>3]+ +h[L>>3]*+h[x+(J<<3)>>3]+O*+h[w+(J<<3)>>3];if((Va|0)>=(X|0)){break}O=+h[$>>3];Va=Va+1|0}Va=X+1|0;c[79780]=Va;rb=Va}c[79778]=rb;if((X|0)<(K|0)){X=rb}else{break}}}X=F+1|0;c[79782]=X;if((F|0)<(ca|0)){F=X}else{break}}}F=c[79842]|0;c[79782]=1;if((F|0)>=1){ca=1;while(1){h[39924]=0.0;X=c[b>>2]|0;c[79778]=1;b:do{if((X|0)>=1){O=0.0;K=1;while(1){I=t+(K+C+(fa(ca,B)|0)<<3)|0;h[39924]=+h[I>>3]+O;h[x+(K+ -1<<3)>>3]=+h[x+((c[b>>2]|0)+ -1+K<<3)>>3]*+h[I>>3];I=K+1|0;c[79778]=I;if((K|0)>=(X|0)){break b}O=+h[39924];K=I}}}while(0);X=c[a>>2]|0;c[79780]=1;if((X|0)>=1){K=1;while(1){I=K+ -1|0;O=+h[39943]*+h[39924]*+h[l+(I<<3)>>3];h[39906]=O;Va=c[b>>2]|0;c[79778]=1;if((Va|0)<1){sb=O}else{$=fa(K,B)|0;ea=O;L=1;while(1){tb=ea+ +h[x+(L+ -1<<3)>>3]*+h[n+(L+C+$<<3)>>3];h[39906]=tb;if((L|0)<(Va|0)){L=L+1|0;ea=tb}else{break}}c[79778]=Va+1;sb=tb}h[w+(I<<3)>>3]=sb;if((ca|0)<(c[79802]|0)){h[39906]=-+h[39906]}L=c[b>>2]|0;c[79778]=1;if((L|0)>=1){$=fa(ca,B)|0;aa=fa(K,D)|0;J=1;while(1){da=s+(J+E+aa<<3)|0;h[da>>3]=+h[39906]*+h[t+(J+C+$<<3)>>3]+ +h[da>>3];if((J|0)<(L|0)){J=J+1|0}else{break}}c[79778]=L+1}J=K+1|0;c[79780]=J;if((K|0)<(X|0)){K=J}else{break}}}K=c[a>>2]|0;c[79778]=1;if((K|0)>=1){X=c[79802]|0;J=1;while(1){$=(c[b>>2]|0)+J|0;c[79790]=$;ea=+h[w+(J+ -1<<3)>>3];if((ca|0)<(X|0)){ub=-ea}else{ub=ea}h[39914]=ub;c[79780]=1;if((J|0)<1){vb=J+1|0}else{ea=ub;aa=1;while(1){I=s+((fa(aa,D)|0)+E+$<<3)|0;h[I>>3]=ea*+h[w+(aa+ -1<<3)>>3]+ +h[I>>3];if((aa|0)>=(J|0)){break}ea=+h[39914];aa=aa+1|0}aa=J+1|0;c[79780]=aa;vb=aa}c[79778]=vb;if((J|0)<(K|0)){J=vb}else{break}}}J=ca+1|0;c[79782]=J;if((ca|0)<(F|0)){ca=J}else{break}}}c[79784]=0;ca=c[a>>2]|0;c[79780]=1;if((ca|0)>=1){F=0;J=1;while(1){K=J+ -1|0;X=x+(K<<3)|0;h[X>>3]=0.0;aa=c[b>>2]|0;c[79782]=1;if((aa|0)>=1){$=fa(J,B)|0;L=l+(K<<3)|0;I=$+C|0;ea=0.0;Va=1;while(1){h[X>>3]=ea+ +h[r+(Va+ -1<<3)>>3]*+h[n+(Va+C+$<<3)>>3];da=n+(I+Va<<3)|0;h[da>>3]=+h[da>>3]- +h[39909]*+h[L>>3];if((Va|0)>=(aa|0)){break}ea=+h[X>>3];Va=Va+1|0}c[79782]=aa+1}c[79778]=1;if((J|0)<1){wb=F}else{Va=1;L=F;while(1){I=L+1|0;c[79784]=I;$=(Va|0)<(J|0);da=q+(L<<3)|0;if($){Na=Va+ -1|0;G=l+(Na<<3)|0;xb=p+(K<<3)|0;h[xb>>3]=+h[xb>>3]+ +h[da>>3]*+h[G>>3];yb=G;zb=Na}else{Na=Va+ -1|0;yb=l+(Na<<3)|0;zb=Na}Na=l+(K<<3)|0;G=p+(zb<<3)|0;h[G>>3]=+h[da>>3]*+h[Na>>3]+ +h[G>>3];h[da>>3]=+h[da>>3]+ +h[x+(zb<<3)>>3]*+h[Na>>3]+ +h[yb>>3]*+h[X>>3];Na=(c[b>>2]|0)+E|0;h[s+(Na+Va+(fa(J,D)|0)<<3)>>3]=+h[s+(Na+J+(fa(Va,D)|0)<<3)>>3];Na=Va+1|0;c[79778]=Na;if($){Va=Na;L=I}else{wb=I;break}}}L=J+1|0;c[79780]=L;if((J|0)<(ca|0)){F=wb;J=L}else{break}}}J=c[a>>2]|0;c[79780]=1;if((J|0)>=1){F=1;while(1){ca=F+ -1|0;L=k+(ca<<3)|0;h[L>>3]=+h[l+(ca<<3)>>3]+ +h[L>>3];h[l+(F+ -1<<3)>>3]=0.0;if((F|0)<(J|0)){F=F+1|0}else{break}}c[79780]=J+1}h[39950]=0.0}if((c[79826]|0)>0){F=(c[79796]|0)+ -1|0;hDc(a,b,l,n,s,t,319208,u,319304,319512,v,319432,w,w+(c[b>>2]<<3)|0,x,x+(F<<3)|0,x+(F+(c[a>>2]|0)<<3)|0)|0}F=c[b>>2]|0;c[79782]=1;if((F|0)>=1){L=1;while(1){h[39915]=0.0;h[39916]=0.0;h[39906]=0.0;ca=c[a>>2]|0;c[79780]=1;if((ca|0)<1){Ab=0.0;Bb=0.0}else{Va=L+C|0;X=L+E|0;ea=0.0;O=0.0;na=0.0;K=1;while(1){ba=+h[n+((fa(K,B)|0)+C+L<<3)>>3];Cb=na+ba*+h[v+(K+ -1<<3)>>3];h[39915]=Cb;ba=+h[n+(Va+(fa(K,B)|0)<<3)>>3];aa=K+ -1|0;Db=O+ba*+h[l+(aa<<3)>>3];h[39916]=Db;ba=+h[s+(X+(fa(K,D)|0)<<3)>>3];N=ea+ba*+h[v+(aa<<3)>>3];h[39906]=N;if((K|0)<(ca|0)){K=K+1|0;na=Cb;O=Db;ea=N}else{break}}c[79780]=ca+1;Ab=Db;Bb=Cb}K=L+ -1|0;h[x+(K<<3)>>3]=Bb*(Bb*+h[39909]+Ab);h[w+(K<<3)>>3]=+h[39906];K=L+1|0;c[79782]=K;if((L|0)<(F|0)){L=K}else{break}}}h[39910]=0.0;L=c[79842]|0;c[79782]=1;if((L|0)>=1){F=1;while(1){h[39906]=0.0;J=c[b>>2]|0;c[79778]=1;if((J|0)<1){Eb=0.0}else{ea=0.0;K=1;while(1){O=+h[t+(K+C+(fa(F,B)|0)<<3)>>3];Fb=ea+O*+h[x+(K+ -1<<3)>>3];h[39906]=Fb;if((K|0)<(J|0)){K=K+1|0;ea=Fb}else{break}}c[79778]=J+1;Eb=Fb}ea=Eb*Eb;O=+h[39910];if((F|0)<(c[79802]|0)){h[39910]=O+ea;na=-Eb;h[39906]=na;Gb=na}else{h[39910]=O-ea;Gb=Eb}K=c[b>>2]|0;c[79778]=1;if((K|0)>=1){ca=fa(F,B)|0;ea=Gb;X=1;while(1){Va=w+(X+ -1<<3)|0;h[Va>>3]=+h[Va>>3]+ea*+h[t+(X+C+ca<<3)>>3];if((X|0)>=(K|0)){break}ea=+h[39906];X=X+1|0}c[79778]=K+1}X=F+1|0;c[79782]=X;if((F|0)<(L|0)){F=X}else{break}}}h[39918]=0.0;h[39897]=0.0;F=c[a>>2]|0;c[79780]=1;if((F|0)<1){Hb=0.0;Ib=0.0}else{ea=0.0;L=1;while(1){h[39906]=0.0;X=c[b>>2]|0;c[79778]=1;if((X|0)<1){Jb=0.0}else{ca=fa(L,D)|0;O=0.0;J=1;while(1){Kb=O+ +h[x+(J+ -1<<3)>>3]*+h[s+(J+E+ca<<3)>>3];h[39906]=Kb;if((J|0)<(X|0)){J=J+1|0;O=Kb}else{break}}c[79778]=X+1;Jb=Kb}J=L+ -1|0;ca=v+(J<<3)|0;h[39918]=ea+Jb*+h[ca>>3];K=L+(c[b>>2]|0)|0;c[79792]=K;Va=c[a>>2]|0;c[79782]=1;if((Va|0)<1){Lb=Jb}else{O=Jb;aa=1;while(1){na=+h[s+((fa(aa,D)|0)+E+K<<3)>>3];Mb=O+na*+h[v+(aa+ -1<<3)>>3];h[39906]=Mb;if((aa|0)<(Va|0)){aa=aa+1|0;O=Mb}else{break}}c[79782]=Va+1;Lb=Mb}h[w+(K+ -1<<3)>>3]=Lb;O=+h[39918]+ +h[39906]*+h[ca>>3];h[39918]=O;na=+h[39897]+ +h[ca>>3]*+h[l+(J<<3)>>3];h[39897]=na;aa=L+1|0;c[79780]=aa;if((L|0)<(F|0)){ea=O;L=aa}else{Hb=O;Ib=na;break}}}ea=+h[39902];h[39910]=+h[39910]+(Ib*Ib+ea*(Ib+(Ib+ +h[39950])+ea*+h[39909]))-Hb;L=w+((c[79840]|0)+ -1<<3)|0;h[L>>3]=+h[39900]+ +h[L>>3];L=c[79826]|0;if((L|0)<=0){break}ea=+h[w+(L+ -1<<3)>>3];h[A>>3]=ea;na=+h[39900]+ +h[39929]*+h[39910]/(ea*ea);h[39914]=na;if(!(na>=0.0)){Nb=-na}else{Nb=na}if(!(Nb<=.8)){break}L=c[u>>2]|0;gDc(a,b,l,n,s,t,319208,u,319360,319304,v,x,w,319280,m,x+(L<<3)|0,x+((L*6|1)+ -1<<3)|0)|0}}while(0);L=c[a>>2]|0;c[79778]=1;if((L|0)>=1){F=1;while(1){aa=F+ -1|0;h[m+(aa<<3)>>3]=+h[l+(aa<<3)>>3]+ +h[v+(aa<<3)>>3];aa=F+ -1|0;h[d+(aa<<3)>>3]=+h[k+(aa<<3)>>3]+ +h[m+(aa<<3)>>3];if((F|0)<(L|0)){F=F+1|0}else{break}}c[79778]=L+1}F=c[79786]|0;aa=F+1|0;c[79786]=aa;if((F|0)>=(c[79896]|0)){T=aa;U=159;break a}}}do{if((U|0)==159){c[79786]=T+ -1;if((c[g>>2]|0)<=0){break}MUc(319608)|0;uUc()|0}else if((U|0)==190){if((c[g>>2]|0)<=0){break}MUc(319656)|0;uUc()|0}}while(0);Nb=+h[39917];if(Nb<=+h[39888]){U=c[a>>2]|0;c[79778]=1;if((U|0)<1){Ob=Nb}else{T=1;while(1){m=T+ -1|0;h[d+(m<<3)>>3]=+h[k+(m<<3)>>3]+ +h[l+(m<<3)>>3];if((T|0)<(U|0)){T=T+1|0}else{break}}c[79778]=U+1;Ob=+h[39917]}h[39888]=Ob}if((c[g>>2]|0)<=0){i=z;return 0}MUc(319752)|0;bUc(319800,319144,4)|0;uUc()|0;MUc(319776)|0;bUc(319800,319104,8)|0;g=c[a>>2]|0;c[79778]=1;if((g|0)>=1){a=1;do{bUc(319800,d+(a+ -1<<3)|0,8)|0;U=c[79778]|0;a=U+1|0;c[79778]=a;}while((U|0)<(g|0))}uUc()|0;i=z;return 0}function SDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0.0,v=0.0,w=0.0,x=0;g=i;j=c[e>>2]|0;e=~j;k=c[a>>2]|0;l=c[b>>2]|0;m=(k|0)>(l|0)?l:k;if((m|0)<2){n=k;o=l}else{l=0;k=2;while(1){if((k|0)>=2){P4c(d+(j+(fa(j,l)|0)<<3)|0,0,(l<<3)+8|0)|0}if((k|0)<(m|0)){l=l+1|0;k=k+1|0}else{break}}n=c[a>>2]|0;o=c[b>>2]|0}b=o+1|0;if((n|0)>=(b|0)&(o|0)<(n|0)){k=(n|0)<1;l=n<<3;p=0;q=b;while(1){b=fa(q,j)|0;if(!k){P4c(d+((fa(o+p|0,j)|0)<<3)|0,0,l|0)|0}h[d+(q+e+b<<3)>>3]=1.0;if((q|0)<(n|0)){p=p+1|0;q=q+1|0}else{break}}}if((m|0)<1){i=g;return 0}q=c[a>>2]|0;a=1;while(1){p=m-a|0;n=p+1|0;l=(p|0)<(q|0);o=fa(n,j)|0;if(l){k=o+e|0;b=n;while(1){r=d+(k+b<<3)|0;h[f+(b+ -1<<3)>>3]=+h[r>>3];h[r>>3]=0.0;if((b|0)<(q|0)){b=b+1|0}else{break}}}h[d+(n+e+o<<3)>>3]=1.0;b=f+(p<<3)|0;if(!(+h[b>>3]==0.0|l^1)){k=n;while(1){r=(fa(k,j)|0)+e|0;s=n;t=0.0;while(1){u=t+ +h[d+(r+s<<3)>>3]*+h[f+(s+ -1<<3)>>3];if((s|0)>=(q|0)){break}s=s+1|0;t=u}t=+h[b>>3];v=u/t;s=(fa(k,j)|0)+e|0;w=t;r=n;while(1){x=d+(s+r<<3)|0;h[x>>3]=+h[x>>3]-v*w;if((r|0)>=(q|0)){break}w=+h[f+(r<<3)>>3];r=r+1|0}if((k|0)<(q|0)){k=k+1|0}else{break}}}if((a|0)<(m|0)){a=a+1|0}else{break}}i=g;return 0}function TDc(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0.0,G=0.0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0,R=0.0,S=0.0;j=i;i=i+16|0;n=j;o=j+8|0;p=c[e>>2]|0;e=~p;q=+JDc(319808);r=c[b>>2]|0;if((r|0)<1){s=r}else{t=1;while(1){u=+KDc(a,d+((fa(t,p)|0)-p<<3)|0);v=t+ -1|0;h[l+(v<<3)>>3]=u;h[k+(v<<3)>>3]=u;h[m+(v<<3)>>3]=u;if((c[f>>2]|0)!=0){c[g+(v<<2)>>2]=t}if((t|0)<(r|0)){t=t+1|0}else{break}}s=c[b>>2]|0}t=c[a>>2]|0;r=(t|0)>(s|0)?s:t;if((r|0)<1){i=j;return 0}else{w=1}while(1){do{if((c[f>>2]|0)!=0){t=c[b>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){break}else{x=w;y=w}while(1){z=+h[k+(x+ -1<<3)>>3]>+h[k+(y+ -1<<3)>>3]?x:y;if((x|0)<(t|0)){y=z;x=x+1|0}else{break}}if((z|0)==(w|0)){break}t=c[a>>2]|0;c[n>>2]=t;if((t|0)>=1){s=(fa(w,p)|0)+e|0;l=(fa(z,p)|0)+e|0;v=1;while(1){A=d+(s+v<<3)|0;u=+h[A>>3];B=d+(l+v<<3)|0;h[A>>3]=+h[B>>3];h[B>>3]=u;if((v|0)<(t|0)){v=v+1|0}else{break}}}v=w+ -1|0;t=z+ -1|0;h[k+(t<<3)>>3]=+h[k+(v<<3)>>3];h[m+(t<<3)>>3]=+h[m+(v<<3)>>3];l=g+(v<<2)|0;v=c[l>>2]|0;s=g+(t<<2)|0;c[l>>2]=c[s>>2];c[s>>2]=v}}while(0);c[n>>2]=1-w+(c[a>>2]|0);v=fa(w,p)|0;s=w+e|0;l=d+(s+v<<3)|0;u=+KDc(n,l);a:do{if(u==0.0){C=w+1|0;D=u}else{E=+h[l>>3];if(E<0.0){F=-u}else{F=u}t=c[a>>2]|0;c[n>>2]=t;if((w|0)>(t|0)){G=E}else{B=v+e|0;A=w;while(1){H=d+(B+A<<3)|0;h[H>>3]=+h[H>>3]/F;if((A|0)<(t|0)){A=A+1|0}else{break}}G=+h[l>>3]}h[l>>3]=G+1.0;A=w+1|0;B=c[b>>2]|0;if((B|0)<(A|0)){C=A;D=F;break}c[n>>2]=B;if((w|0)>=(B|0)){C=A;D=F;break}H=A+e|0;I=v+e|0;J=t;K=B;B=A;while(1){c[o>>2]=J;L=(w|0)>(J|0);do{if(L){c[o>>2]=J}else{M=(fa(B,p)|0)+e|0;N=w;E=0.0;while(1){O=E+ +h[d+(I+N<<3)>>3]*+h[d+(M+N<<3)>>3];if((N|0)<(J|0)){E=O;N=N+1|0}else{break}}E=O/+h[l>>3];c[o>>2]=J;if(L){break}N=(fa(B,p)|0)+e|0;M=w;while(1){P=d+(N+M<<3)|0;h[P>>3]=+h[P>>3]-E*+h[d+(I+M<<3)>>3];if((M|0)<(J|0)){M=M+1|0}else{break}}}}while(0);do{if((c[f>>2]|0)==0){Q=K}else{L=B+ -1|0;M=k+(L<<3)|0;E=+h[M>>3];if(E==0.0){Q=K;break}N=fa(B,p)|0;R=+h[d+(s+N<<3)>>3]/E;S=1.0-R*R;R=E*+V(+(S<=0.0?0.0:S));h[M>>3]=R;P=m+(L<<3)|0;S=R/+h[P>>3];if(S*S*.05>q){Q=K;break}c[o>>2]=J-w;S=+KDc(o,d+(H+N<<3)|0);h[M>>3]=S;h[P>>3]=S;Q=c[n>>2]|0}}while(0);if((B|0)>=(Q|0)){C=A;D=F;break a}J=c[a>>2]|0;K=Q;B=B+1|0}}}while(0);h[k+(w+ -1<<3)>>3]=-D;if((w|0)<(r|0)){w=C}else{break}}i=j;return 0}function UDc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0.0,p=0,q=0.0,r=0,s=0.0,t=0,u=0.0,v=0.0,w=0.0,x=0.0,y=0.0,z=0.0,A=0.0,B=0,C=0,D=0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,J=0.0,K=0.0,L=0.0;j=i;k=c[e>>2]|0;e=~k;l=c[b>>2]|0;b=l+ -1|0;if((l|0)<2){i=j;return 0}m=c[a>>2]|0;n=(m|0)<1;o=0.0;p=1;q=0.0;while(1){r=l-p|0;s=+h[f+(r+ -1<<3)>>3];t=!(s>=0.0);if(t){u=-s}else{u=s}if(u>1.0){v=1.0/s}else{v=o}if(t){w=-s}else{w=s}if(w>1.0){x=+V(+(1.0-v*v))}else{x=q}if(t){y=-s;z=!(s>=-1.0)?x:s}else{y=s;z=!(s<=1.0)?x:s}if(!(y<=1.0)){A=v}else{A=+V(+(1.0-z*z))}if(!n){t=(fa(r,k)|0)+e|0;r=fa(l,k)|0;B=1;while(1){C=d+(t+B<<3)|0;s=+h[C>>3];D=d+(B+e+r<<3)|0;E=+h[D>>3];h[D>>3]=z*s+A*E;h[C>>3]=A*s-z*E;if((B|0)<(m|0)){B=B+1|0}else{break}}}if((p|0)<(b|0)){o=A;p=p+1|0;q=z}else{break}}p=c[a>>2]|0;a=(p|0)<1;q=A;m=1;A=z;while(1){z=+h[g+(m+ -1<<3)>>3];n=!(z>=0.0);if(n){F=-z}else{F=z}if(F>1.0){G=1.0/z}else{G=q}if(n){H=-z}else{H=z}if(H>1.0){I=+V(+(1.0-G*G))}else{I=A}if(n){J=-z;K=!(z>=-1.0)?I:z}else{J=z;K=!(z<=1.0)?I:z}if(!(J<=1.0)){L=G}else{L=+V(+(1.0-K*K))}if(!a){n=(fa(m,k)|0)+e|0;f=fa(l,k)|0;B=1;while(1){r=d+(n+B<<3)|0;z=+h[r>>3];t=d+(B+e+f<<3)|0;o=+h[t>>3];h[t>>3]=L*o-K*z;h[r>>3]=L*z+K*o;if((B|0)<(p|0)){B=B+1|0}else{break}}}if((m|0)<(b|0)){q=L;m=m+1|0;A=K}else{break}}i=j;return 0}function VDc(a,b,d,e,f,g,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;var l=0.0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0,D=0.0,E=0.0,F=0.0,G=0.0,H=0.0,I=0.0,K=0.0,L=0,M=0,N=0,O=0,P=0,Q=0.0,R=0.0,S=0.0,T=0.0,U=0.0,W=0.0;e=i;l=+JDc(319816);m=c[b>>2]|0;n=c[a>>2]|0;o=(fa(1-m+(n<<1)|0,m)|0)/2|0;p=o+(m-n)|0;if((m|0)<=(n|0)){q=m;r=p;while(1){h[j+(q+ -1<<3)>>3]=+h[d+(r+ -1<<3)>>3];if((q|0)<(n|0)){r=r+1|0;q=q+1|0}else{break}}}q=m+ -1|0;r=(m|0)<2;if(r){s=p}else{t=(q|0)>1?q:1;u=t+ -1|0;v=(m<<1)+o+(fa(u,m+ -3-n|0)|0)+ -2-n|0;o=c5c(u|0,0,t+ -2|0,0)|0;t=X4c(o|0,J&1|0,1)|0;o=p;p=1;while(1){u=m-p|0;w=o+ -1+u-n|0;x=u+ -1|0;h[j+(x<<3)>>3]=0.0;y=g+(x<<3)|0;z=+h[y>>3];do{if(!(z==0.0)){x=g+(q<<3)|0;A=+h[x>>3];if(!(A>=0.0)){B=-A}else{B=A}if(!(z>=0.0)){C=-z}else{C=z}do{if(!(B>=C)){D=A/z;E=.5/+V(+(D*D*.25+.25));F=D*E;if(!(F>=0.0)){G=-F}else{G=F}if(!(l*G>1.0)){H=F;I=E;K=1.0;break}H=F;I=E;K=1.0/F}else{F=z/A;E=.5/+V(+(F*F*.25+.25));D=F*E;H=E;I=D;K=D}}while(0);h[x>>3]=I*z+H*A;h[y>>3]=K;if((u|0)>(n|0)){break}else{L=u;M=w}while(1){N=d+(M+ -1<<3)|0;D=+h[N>>3];O=j+(L+ -1<<3)|0;E=+h[O>>3];h[O>>3]=I*D+H*E;h[N>>3]=H*D-I*E;if((L|0)<(n|0)){M=M+1|0;L=L+1|0}else{break}}}}while(0);if((p|0)<(q|0)){p=p+1|0;o=w}else{break}}s=v-n-t|0}if((n|0)>=1){t=g+(q<<3)|0;g=1;while(1){v=g+ -1|0;o=j+(v<<3)|0;h[o>>3]=+h[o>>3]+ +h[t>>3]*+h[f+(v<<3)>>3];if((g|0)<(n|0)){g=g+1|0}else{break}}}c[k>>2]=0;if(r){P=s}else{r=1;g=s;while(1){s=j+(r+ -1<<3)|0;I=+h[s>>3];n=d+(g+ -1<<3)|0;if(!(I==0.0)){H=+h[n>>3];if(!(H>=0.0)){Q=-H}else{Q=H}if(!(I>=0.0)){R=-I}else{R=I}do{if(!(Q>=R)){K=H/I;G=.5/+V(+(K*K*.25+.25));C=K*G;if(!(C>=0.0)){S=-C}else{S=C}if(!(l*S>1.0)){T=C;U=G;W=1.0;break}T=C;U=G;W=1.0/C}else{C=I/H;G=.5/+V(+(C*C*.25+.25));K=C*G;T=G;U=K;W=K}}while(0);w=c[a>>2]|0;a:do{if((r|0)<=(w|0)){K=I;G=H;f=r;t=g;while(1){h[j+(f+ -1<<3)>>3]=T*K-U*G;h[d+(t+ -1<<3)>>3]=T*G+U*K;if((f|0)>=(w|0)){break a}K=+h[j+(f<<3)>>3];G=+h[d+(t<<3)>>3];f=f+1|0;t=t+1|0}}}while(0);h[s>>3]=W}if(+h[n>>3]==0.0){c[k>>2]=1}w=1-r+g+(c[a>>2]|0)|0;if((r|0)<(q|0)){r=r+1|0;g=w}else{P=w;break}}}g=c[a>>2]|0;a=c[b>>2]|0;if((a|0)<=(g|0)){b=a;a=P;while(1){h[d+(a+ -1<<3)>>3]=+h[j+(b+ -1<<3)>>3];if((b|0)<(g|0)){a=a+1|0;b=b+1|0}else{break}}}if(!(+h[d+(P+ -1<<3)>>3]==0.0)){i=e;return 0}c[k>>2]=1;i=e;return 0}function WDc(b,d,e,f,g,j,k,l,m,n,o,p,q,r){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;q=q|0;r=r|0;var s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0,D=0.0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0.0,Q=0.0,R=0.0,S=0.0,T=0,U=0.0,W=0.0,Z=0.0,_=0.0,$=0.0,aa=0.0,ba=0.0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0.0,ja=0.0,ka=0.0,la=0,ma=0.0,na=0.0,oa=0.0,pa=0.0,qa=0.0,ra=0.0,sa=0.0,ta=0.0,ua=0.0,va=0,wa=0.0,xa=0.0,ya=0.0,za=0.0,Aa=0.0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0.0,Ia=0.0,Ja=0,Ka=0,La=0.0,Ma=0.0,Na=0.0,Oa=0.0,Pa=0.0,Qa=0.0,Ra=0.0,Sa=0.0,Ta=0.0,Ua=0,Va=0;s=i;t=c[d>>2]|0;u=~t;h[39997]=.5;h[40015]=6.283185307179586;v=+h[l>>3];h[40010]=v*v;c[80016]=0;l=c[b>>2]|0;c[80034]=l;c[80032]=l;w=c[b>>2]|0;c[79956]=1;if((w|0)<1){x=l;y=0}else{z=1;while(1){A=z+ -1|0;h[n+(A<<3)>>3]=+h[e+(A<<3)>>3];if((z|0)<(w|0)){z=z+1|0}else{break}}c[79956]=w+1;x=l;y=0}a:while(1){w=c[b>>2]|0;c[79956]=1;if((w|0)>=1){z=1;while(1){h[p+(z+ -1<<3)>>3]=0.0;if((z|0)<(w|0)){z=z+1|0}else{break}}c[79956]=w+1}z=c[d>>2]|0;c[79960]=1;if((z|0)>=1){e=1;while(1){h[40001]=0.0;A=c[b>>2]|0;c[79958]=1;if((A|0)<1){B=0.0}else{v=0.0;C=1;while(1){D=+h[f+((fa(C,t)|0)+u+e<<3)>>3];E=v+D*+h[n+(C+ -1<<3)>>3];h[40001]=E;if((C|0)<(A|0)){C=C+1|0;v=E}else{break}}c[79958]=A+1;B=E}v=+h[k+(e+ -1<<3)>>3]*B;h[40001]=v;C=c[b>>2]|0;c[79956]=1;if((C|0)>=1){D=v;F=1;while(1){v=D*+h[f+((fa(F,t)|0)+u+e<<3)>>3];G=p+(F+ -1<<3)|0;h[G>>3]=+h[G>>3]+v;if((F|0)>=(C|0)){break}D=+h[40001];F=F+1|0}c[79956]=C+1}F=e+1|0;c[79960]=F;if((e|0)<(z|0)){e=F}else{break}}}c[79970]=0;e=c[b>>2]|0;c[79958]=1;if((e|0)>=1){z=1;w=0;while(1){if((z|0)<1){H=1;I=w}else{F=z+ -1|0;A=p+(F<<3)|0;G=n+(F<<3)|0;F=z+1|0;J=1;K=w;while(1){L=j+(K<<3)|0;if((J|0)<(z|0)){M=J+ -1|0;h[A>>3]=+h[A>>3]+ +h[L>>3]*+h[n+(M<<3)>>3];N=M}else{N=J+ -1|0}M=p+(N<<3)|0;h[M>>3]=+h[L>>3]*+h[G>>3]+ +h[M>>3];if((J|0)<(z|0)){J=J+1|0;K=K+1|0}else{break}}K=z+w|0;c[79970]=K;H=F;I=K}if((z|0)<(e|0)){z=z+1|0;w=I}else{break}}c[79956]=H;c[79958]=e+1}do{if((y|0)==0){h[39999]=0.0;h[39981]=0.0;w=c[b>>2]|0;c[79956]=1;if((w|0)>=1){z=1;while(1){h[m+(z+ -1<<3)>>3]=0.0;K=z+ -1|0;h[q+(K<<3)>>3]=0.0;D=+h[g+(K<<3)>>3]+ +h[p+(K<<3)>>3];h[o+(K<<3)>>3]=D;h[n+(K<<3)>>3]=-D;h[39981]=+h[39981]+D*D;if((z|0)<(w|0)){z=z+1|0}else{break}}c[79956]=w+1}h[r>>3]=0.0;D=+h[39981];if(D==0.0){O=55;break a}h[39986]=0.0;h[39989]=0.0;h[39984]=D;h[40004]=D;P=D;Q=0.0;R=0.0;S=+h[40010];T=0}else{if((y|0)>(x|0)){h[39983]=0.0;h[39990]=0.0;h[39991]=0.0;z=c[b>>2]|0;c[79956]=1;if((z|0)<1){U=0.0;W=0.0;Z=0.0}else{D=0.0;v=0.0;_=0.0;F=1;while(1){K=F+ -1|0;$=_+ +h[n+(K<<3)>>3]*+h[o+(K<<3)>>3];h[39983]=$;K=F+ -1|0;J=p+(K<<3)|0;aa=v+ +h[J>>3]*+h[n+(K<<3)>>3];h[39990]=aa;ba=D+ +h[J>>3]*+h[m+(K<<3)>>3];h[39991]=ba;if((F|0)<(z|0)){F=F+1|0;_=$;v=aa;D=ba}else{break}}c[79956]=z+1;U=ba;W=$;Z=aa}D=+h[39997];v=D*(+h[39994]-Z);h[39982]=v;_=+h[39987];ca=_+v;h[39998]=ca;h[40002]=ca;h[4e4]=ca;c[80026]=0;a[319904]=1;da=+h[40015]/50.0;h[40001]=da;c[79956]=1;F=0;ea=ca;ga=ca;w=1;while(1){ha=+(w|0)*da;ia=+X(+ha);ja=+Y(+ha);ka=ia*(_+ia*v)+ja*(W+ia*U);do{if(ka<ea){h[4e4]=ka;c[80026]=w;h[40011]=ga;la=w;ma=ka}else{if((w|0)!=(F+1|0)){la=F;ma=ea;break}h[40012]=ka;la=F;ma=ea}}while(0);K=w+1|0;if((K|0)<50){F=la;ea=ma;w=K;ga=ka}else{break}}h[40006]=ha;h[39992]=ia;h[39995]=ja;h[40003]=ka;c[79956]=50;h[40002]=ka;if((la|0)==0){h[40011]=ka;O=46}else if((la|0)==49){h[40012]=ca;na=ca}else{O=46}if((O|0)==46){O=0;na=+h[40012]}h[40006]=0.0;ga=+h[40011];if(ga!=na){ea=ga-ma;h[40011]=ea;ga=na-ma;h[40012]=ga;oa=D*(ea-ga)/(ea+ga);h[40006]=oa;pa=oa}else{pa=0.0}oa=da*(+(la|0)+pa);h[40006]=oa;ga=+X(+oa);h[39992]=ga;ea=+Y(+oa);h[39995]=ea;oa=ca-ga*(_+ga*v)-ea*(W+ga*U);h[40007]=oa;h[39984]=0.0;w=c[b>>2]|0;c[79956]=1;if((w|0)<1){qa=0.0;ra=oa}else{oa=ea;ea=ga;F=1;z=0;while(1){K=m+(z<<3)|0;h[K>>3]=ea*+h[K>>3]+oa*+h[n+(z<<3)>>3];K=F+ -1|0;J=q+(K<<3)|0;ga=+h[39992]*+h[J>>3]+ +h[39995]*+h[p+(K<<3)>>3];h[J>>3]=ga;sa=+h[o+(K<<3)>>3]+ga;ta=+h[39984]+sa*sa;h[39984]=ta;if((F|0)>=(w|0)){break}K=F;oa=+h[39995];ea=+h[39992];F=F+1|0;z=K}c[79956]=w+1;qa=ta;ra=+h[40007]}ea=ra+ +h[39999];h[39999]=ea;if((y|0)<(l|0)&ra/ea>.01){ua=qa;va=x}else{O=55;break a}}else{h[39990]=0.0;z=c[b>>2]|0;c[79958]=1;do{if((z|0)<1){ea=+h[40014];h[40005]=ea;wa=ea;xa=0.0;O=11}else{ea=0.0;F=1;while(1){K=F+ -1|0;ya=ea+ +h[n+(K<<3)>>3]*+h[p+(K<<3)>>3];h[39990]=ya;if((F|0)<(z|0)){F=F+1|0;ea=ya}else{break}}c[79958]=z+1;ea=+h[40014];h[40005]=ea;if(!(ya>0.0)){wa=ea;xa=ya;O=11;break}ea=ya/+h[39981];h[40001]=ea;if((y|0)==1){h[r>>3]=ea;za=ea;Aa=+h[40001]}else{za=+h[r>>3];Aa=ea}h[r>>3]=!(za<=Aa)?Aa:za;ea=+h[40005];oa=+h[39984];v=+h[39990];_=oa/v;ca=ea<=_?ea:_;h[40005]=ca;Ba=oa;Ca=v;Da=ca}}while(0);if((O|0)==11){O=0;Ba=+h[39984];Ca=xa;Da=wa}ca=Da*(Ba-Da*+h[39997]*Ca);h[39996]=ca;h[39999]=+h[39999]+ca;h[40009]=Ba;h[39984]=0.0;z=c[b>>2]|0;c[79956]=1;if((z|0)<1){Ea=Da;Fa=0.0}else{w=1;ca=Da;while(1){F=w+ -1|0;K=m+(F<<3)|0;h[K>>3]=+h[K>>3]+ca*+h[n+(F<<3)>>3];F=w+ -1|0;K=q+(F<<3)|0;v=+h[K>>3]+ +h[40005]*+h[p+(F<<3)>>3];h[K>>3]=v;oa=+h[o+(F<<3)>>3]+v;Ga=+h[39984]+oa*oa;h[39984]=Ga;Ha=+h[40005];if((w|0)<(z|0)){ca=Ha;w=w+1|0}else{break}}c[79956]=z+1;Ea=Ha;Fa=Ga}if(Ea<+h[40014]){if(+h[39996]<=+h[39999]*.01){O=55;break a}if(Fa<=+h[40004]*1.0e-4|(y|0)==(l|0)){O=55;break a}ca=Fa/+h[40009];h[40001]=ca;h[39981]=0.0;h[39986]=0.0;h[39989]=0.0;w=c[b>>2]|0;c[79956]=1;if((w|0)<1){O=55;break a}else{Ia=ca;Ja=1;Ka=0}while(1){F=n+(Ka<<3)|0;h[F>>3]=Ia*+h[F>>3]- +h[o+(Ka<<3)>>3]- +h[q+(Ka<<3)>>3];F=Ja+ -1|0;K=n+(F<<3)|0;ca=+h[K>>3];La=+h[39981]+ca*ca;h[39981]=La;J=m+(F<<3)|0;Ma=+h[39986]+ +h[K>>3]*+h[J>>3];h[39986]=Ma;ca=+h[J>>3];Na=+h[39989]+ca*ca;h[39989]=Na;if((Ja|0)>=(w|0)){break}J=Ja;Ia=+h[40001];Ja=Ja+1|0;Ka=J}c[79956]=w+1;if(Ma<=0.0){O=55;break a}ca=+h[40010];if(Na<ca){P=La;Q=Ma;R=Na;S=ca;T=y;break}}h[r>>3]=0.0;c[80032]=y;ua=+h[39984];va=y}if(ua<=+h[40004]*1.0e-4){O=55;break a}h[39987]=0.0;h[39994]=0.0;z=c[b>>2]|0;c[79956]=1;if((z|0)<1){Oa=0.0;Pa=0.0}else{ca=0.0;oa=0.0;J=1;while(1){K=J+ -1|0;Qa=oa+ +h[m+(K<<3)>>3]*+h[o+(K<<3)>>3];h[39987]=Qa;K=J+ -1|0;Ra=ca+ +h[m+(K<<3)>>3]*+h[q+(K<<3)>>3];h[39994]=Ra;if((J|0)<(z|0)){J=J+1|0;oa=Qa;ca=Ra}else{break}}c[79956]=z+1;Oa=Ra;Pa=Qa}ca=Pa+Oa;h[39993]=ca;oa=+h[40010];v=ua*oa;if(ca/+V(+v)<=-.99){O=55;break a}J=y+1|0;c[80016]=J;_=+V(+(v-ca*ca));h[40001]=_;v=oa/_;h[40011]=v;oa=ca/_;h[40012]=oa;w=c[b>>2]|0;c[79956]=1;if((w|0)<1){x=va;y=J;continue a}else{Sa=oa;Ta=v;Ua=1;Va=0}while(1){h[n+(Va<<3)>>3]=Ta*(+h[o+(Va<<3)>>3]+ +h[q+(Va<<3)>>3])-Sa*+h[m+(Va<<3)>>3];if((Ua|0)>=(w|0)){break}K=Ua;Sa=+h[40012];Ta=+h[40011];Ua=Ua+1|0;Va=K}c[79956]=w+1;x=va;y=J;continue a}}while(0);e=T+1|0;c[80016]=e;v=S-R;h[40001]=v;h[40014]=v/(Q+ +V(+(Q*Q+v*P)));y=e;x=x}if((O|0)==55){i=s;return 0}return 0}function XDc(b,d,e,f,g,j,k,l,m,n){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0.0,D=0.0,E=0,F=0,G=0,H=0.0,I=0.0,J=0.0,K=0,L=0,M=0,N=0.0,O=0.0,P=0.0,Q=0,R=0;o=i;p=c[d>>2]|0;q=~p;r=c[j>>2]|0;j=~r;h[40024]=1.0;s=p-(c[b>>2]|0)|0;t=s+ -1|0;c[80054]=t;c[80044]=1;c[80038]=2;if((s|0)<3){u=1}else{s=2;v=1;while(1){do{if((s|0)==(c[g>>2]|0)){c[80044]=s;w=s}else{x=c[m>>2]|0;y=fa(s,p)|0;z=+h[f+(y+q+x<<3)>>3];if(!(z!=0.0)){w=v;break}A=fa(v,p)|0;B=x+q|0;x=f+(B+A<<3)|0;C=+h[x>>3];D=+V(+(z*z+C*C));h[40026]=D;C=+h[x>>3]/D;h[40033]=C;z=+h[f+(B+y<<3)>>3]/D;h[40034]=z;B=c[d>>2]|0;c[80036]=1;if((B|0)>=1){D=z;z=C;x=1;while(1){E=x+q|0;h[40026]=z*+h[f+(E+A<<3)>>3]+D*+h[f+(E+y<<3)>>3];E=x+q|0;F=f+(E+y<<3)|0;G=f+(E+A<<3)|0;h[F>>3]=z*+h[F>>3]-D*+h[G>>3];h[G>>3]=+h[40026];if((x|0)>=(B|0)){break}D=+h[40034];z=+h[40033];x=x+1|0}c[80036]=B+1}h[f+((c[m>>2]|0)+q+y<<3)>>3]=0.0;w=v}}while(0);x=s+1|0;c[80038]=x;if((s|0)<(t|0)){s=x;v=w}else{u=w;break}}}w=c[m>>2]|0;z=+h[f+(w+ -1<<3)>>3];h[40033]=z;if((c[g>>2]|0)>1){D=-z;h[40033]=D;H=D}else{H=z}v=(u|0)>1;if(v){h[40034]=+h[f+((fa(u,p)|0)+q+w<<3)>>3]}w=c[d>>2]|0;c[80036]=1;if((w|0)>=1){s=(fa(u,p)|0)+q|0;z=H;t=1;x=0;while(1){h[n+(x<<3)>>3]=z*+h[f+(x<<3)>>3];if(v){A=n+(t+ -1<<3)|0;h[A>>3]=+h[A>>3]+ +h[40034]*+h[f+(s+t<<3)>>3]}if((t|0)>=(w|0)){break}A=t;z=+h[40033];t=t+1|0;x=A}c[80036]=w+1}w=(c[m>>2]|0)+ -1|0;z=+h[n+(w<<3)>>3];h[40031]=z;x=k+(w<<3)|0;H=+h[x>>3];h[40025]=H;D=H*H;h[40035]=D;h[40032]=D+z*+h[l>>3];h[x>>3]=+h[x>>3]- +h[40024];a[320224]=0;do{if((u|0)==1){z=+h[40032];if(!(z>=0.0)){I=-z}else{I=z}z=+V(+I);h[40026]=z;D=+h[40033]/z;h[40034]=D;H=+h[40025]/z;h[40033]=H;x=c[d>>2]|0;c[80036]=1;if((x|0)<1){J=z}else{z=D;D=H;w=1;t=0;while(1){s=f+(t<<3)|0;h[s>>3]=D*+h[s>>3]-z*+h[k+(t<<3)>>3];if((w|0)>=(x|0)){break}s=w;z=+h[40034];D=+h[40033];w=w+1|0;t=s}c[80036]=x+1;J=+h[40026]}t=c[g>>2]|0;if((t|0)==1&J<0.0){c[g>>2]=2;K=2}else{K=t}if(!((K|0)<2|!(J>=0.0))){L=46}}else{c[80040]=1;if(!(+h[l>>3]>=0.0)){M=1}else{c[80040]=u;M=u}t=u+1-M|0;c[80042]=t;w=fa(t,p)|0;t=(c[m>>2]|0)+q|0;D=+h[40032];z=+h[f+(t+w<<3)>>3]/D;h[40026]=z;h[40033]=z*+h[l>>3];H=+h[40025];h[40034]=z*H;s=fa(M,p)|0;z=+h[f+(t+s<<3)>>3];h[40026]=z;C=+h[l>>3];if(!(C>=0.0)){N=-C}else{N=C}C=+h[40024]/+V(+(+h[40035]+z*N*z));h[40029]=C;if(!(D>=0.0)){O=-D}else{O=D}h[40030]=C*+V(+O);t=c[d>>2]|0;c[80036]=1;if((t|0)<1){P=D}else{D=z;z=H;H=C;v=1;while(1){A=f+(v+q+s<<3)|0;h[A>>3]=H*(z*+h[A>>3]-D*+h[k+(v+ -1<<3)>>3]);A=f+(v+q+w<<3)|0;G=v+ -1|0;h[A>>3]=+h[40030]*(+h[A>>3]- +h[40033]*+h[n+(G<<3)>>3]- +h[40034]*+h[k+(G<<3)>>3]);if((v|0)>=(t|0)){break}D=+h[40026];z=+h[40025];H=+h[40029];v=v+1|0}c[80036]=t+1;P=+h[40032]}if(!(P<=0.0)){break}H=+h[l>>3];if(H<0.0){c[g>>2]=(c[g>>2]|0)+1}if(H>=0.0){L=46}}}while(0);do{if((L|0)==46){a[320224]=1;c[g>>2]=(c[g>>2]|0)+ -1;M=c[d>>2]|0;c[80036]=1;if((M|0)<1){break}else{Q=1}while(1){u=f+(Q+ -1<<3)|0;h[40026]=+h[u>>3];K=f+(Q+q+(fa(c[g>>2]|0,p)|0)<<3)|0;h[u>>3]=+h[K>>3];h[K>>3]=+h[40026];K=Q+1|0;c[80036]=K;if((Q|0)<(M|0)){Q=K}else{break}}}}while(0);Q=c[b>>2]|0;c[80038]=1;if((Q|0)<1){i=o;return 0}else{R=1}while(1){b=(c[d>>2]|0)+R|0;c[80046]=b;p=fa(R,r)|0;P=+h[e+((c[m>>2]|0)+j+p<<3)>>3];g=b+ -1|0;q=n+(g<<3)|0;h[q>>3]=P;f=k+(g<<3)|0;O=+h[40025];N=+h[40032];J=(+h[40031]*+h[f>>3]-O*P)/N;h[40033]=J;P=(-(+h[l>>3]*+h[q>>3])-O*+h[f>>3])/N;h[40034]=P;c[80036]=1;a:do{if((b|0)>=1){N=P;O=J;f=1;while(1){q=e+(f+j+p<<3)|0;g=f+ -1|0;I=+h[q>>3]+O*+h[k+(g<<3)>>3]+N*+h[n+(g<<3)>>3];h[q>>3]=I;q=c[d>>2]|0;if((f|0)>(q|0)){h[e+((fa(f-q|0,r)|0)+j+b<<3)>>3]=I}q=f+1|0;c[80036]=q;if((f|0)>=(b|0)){break a}N=+h[40034];O=+h[40033];f=q}}}while(0);b=R+1|0;c[80038]=b;if((R|0)<(Q|0)){R=b}else{break}}i=o;return 0}function YDc(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0.0,p=0,q=0,r=0,s=0,t=0,u=0.0,v=0,w=0,x=0.0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0,F=0.0,G=0,H=0,I=0;m=i;if((b|0)<(d|0)){n=(b|0)<(e|0);o=0.0;p=-1;q=-1;r=b;while(1){if(n){s=c[f+(r<<2)>>2]|0;t=b;u=o;v=p;w=q;while(1){x=+U(+(+h[a+((fa(c[g+(t<<2)>>2]|0,d)|0)+s<<3)>>3]));y=x>u;z=y?r:w;A=y?t:v;B=y?x:u;y=t+1|0;if((y|0)<(e|0)){w=z;v=A;u=B;t=y}else{C=B;D=A;E=z;break}}}else{C=o;D=p;E=q}t=r+1|0;if((t|0)<(d|0)){o=C;p=D;q=E;r=t}else{F=C;G=D;H=E;break}}}else{F=0.0;G=-1;H=-1}if((G|H|0)<0){I=-1;i=m;return I|0}c[j>>2]=H;c[k>>2]=G;h[l>>3]=F;I=0;i=m;return I|0}function ZDc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0;g=i;i=i+24|0;j=g;k=g+8|0;l=g+16|0;m=(b|0)<=(d|0)?b:d;if((m|0)>0){n=0}else{o=0;i=g;return o|0}while(1){p=e+(n<<2)|0;q=f+(n<<2)|0;r=+h[a+((fa(c[q>>2]|0,b)|0)+(c[p>>2]|0)<<3)>>3];if((YDc(a,n,b,d,e,f,j,k,l)|0)!=0){o=-1;s=14;break}t=+U(+r);if(+h[l>>3]>t*1.125){u=c[p>>2]|0;v=e+(c[j>>2]<<2)|0;c[p>>2]=c[v>>2];c[v>>2]=u;u=c[q>>2]|0;v=f+(c[k>>2]<<2)|0;c[q>>2]=c[v>>2];c[v>>2]=u}u=c[p>>2]|0;p=fa(c[q>>2]|0,b)|0;t=+h[a+(p+u<<3)>>3];if(!(t!=0.0)){s=7;break}q=n+1|0;if((q|0)<(b|0)){v=(q|0)<(d|0);w=q;do{x=c[e+(w<<2)>>2]|0;y=a+(p+x<<3)|0;r=+h[y>>3];do{if(r!=0.0){z=-r/t;h[y>>3]=0.0;if(v){A=q}else{break}do{B=fa(c[f+(A<<2)>>2]|0,b)|0;C=a+(B+x<<3)|0;h[C>>3]=+h[C>>3]+z*+h[a+(u+B<<3)>>3];A=A+1|0;}while((A|0)<(d|0))}}while(0);w=w+1|0;}while((w|0)<(b|0))}if((q|0)<(m|0)){n=q}else{o=0;s=14;break}}if((s|0)==7){cb(320288,320304,116,320328)}else if((s|0)==14){i=g;return o|0}return 0}function _Dc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0;f=i;i=i+8|0;g=f;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=e;c[u>>2]=0;v=b+280|0;w=c[v>>2]|0;x=1;while(1){y=x+1|0;if((H4c(w,c[320336+(x<<2)>>2]|0)|0)==0){z=4;break}if((y|0)<8){x=y}else{break}}do{if((z|0)==4){c[u>>2]=x;if((x|0)==0){break}y=c[320440+(x<<2)>>2]|0;c[q>>2]=c[320336+(x<<2)>>2];c[q+4>>2]=y;EBc(23,0,320512,q);y=b+112|0;A=e+28|0;c[A>>2]=(c[y>>2]|0)+20;B=c[y>>2]|0;C=b+160|0;D=((c[C>>2]|0)*3|0)+50+(fa(B+9|0,B)|0)|0;c[e+32>>2]=D;B=j4c(D,8)|0;c[e+40>>2]=B;D=b+536|0;HBc(c[D>>2]|0,(B|0)!=0|0,320552,p);B=j4c(c[A>>2]|0,4)|0;c[e+36>>2]=B;HBc(c[D>>2]|0,(B|0)!=0|0,320552,o);c[e+56>>2]=c[C>>2];c[e+52>>2]=0;c[e+60>>2]=j4c(c[C>>2]|0,4)|0;c[e+24>>2]=h4c(8)|0;C=h4c(4)|0;c[e+20>>2]=C;c[C>>2]=c[292360>>2];HBc(c[D>>2]|0,(C|0)!=0|0,320552,n);C=c[y>>2]<<3;B=e+48|0;c[B>>2]=h4c(C)|0;A=e+44|0;c[A>>2]=h4c(C)|0;C=j4c(15,4)|0;E=e+12|0;c[E>>2]=C;HBc(c[D>>2]|0,(C|0)!=0|0,320552,m);C=j4c(5,4)|0;c[e+4>>2]=C;HBc(c[D>>2]|0,(C|0)!=0|0,320552,l);C=j4c(5,4)|0;c[e+8>>2]=C;HBc(c[D>>2]|0,(C|0)!=0|0,320552,k);c[e+16>>2]=0;h[e+64>>3]=1.4901161193847656e-8;C=c[y>>2]<<3;c[e+72>>2]=h4c(C)|0;c[e+76>>2]=h4c(C)|0;c[e+80>>2]=h4c(C)|0;C=c[E>>2]|0;c[C+8>>2]=1;D=c[u>>2]|0;a:do{switch(D|0){case 7:case 1:case 2:case 4:case 5:case 3:{if((ie[c[(c[b+540>>2]|0)+140>>2]&127](b)|0)==0){F=c[E>>2]|0;c[F+16>>2]=1;G=F;H=c[u>>2]|0;z=17;break a}if((c[y>>2]|0)==1){EBc(23,0,320568,j)}else{EBc(1,0,320640,g)}c[u>>2]=6;z=18;break};default:{G=C;H=D;z=17}}}while(0);if((z|0)==17){if((H|0)==2){I=G}else{z=18}}if((z|0)==18){a[d+28|0]=1;I=c[E>>2]|0}c[I+4>>2]=1;D=c[y>>2]|0;if((D|0)<=0){i=f;return 0}C=b+272|0;F=c[A>>2]|0;J=c[b+8>>2]|0;K=c[B>>2]|0;L=0;do{h[F+(L<<3)>>3]=+h[C>>3];h[K+(L<<3)>>3]=+h[C>>3]*+h[J+(L*112|0)+80>>3];L=L+1|0;}while((L|0)<(D|0));i=f;return 0}}while(0);if((c[292396>>2]|c[73074]|0)==0){M=w;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=320472;W=V;IBc(Q,W,r)}c[t>>2]=w;GBc(23,1,320368,t);t=1;do{w=c[320440+(t<<2)>>2]|0;c[s>>2]=c[320336+(t<<2)>>2];c[s+4>>2]=w;GBc(23,0,320424,s);t=t+1|0;}while((t|0)<8);fe[c[73214]&1023](23);M=c[v>>2]|0;N=b;O=N+536|0;P=O;Q=c[P>>2]|0;R=r;S=R;c[S>>2]=M;T=5;U=T;V=320472;W=V;IBc(Q,W,r);return 0}function $Dc(a){a=a|0;var b=0;b=i;i4c(c[a+40>>2]|0);i4c(c[a+36>>2]|0);i4c(c[a+20>>2]|0);i4c(c[a+12>>2]|0);i4c(c[a+4>>2]|0);i4c(c[a+8>>2]|0);i4c(a);i=b;return 0}function aEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0.0,P=0,Q=0.0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0.0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;h[D>>3]=0.0;E=a+4|0;F=c[E>>2]|0;G=c[F>>2]|0;H=c[b+48>>2]|0;I=(c[F+4>>2]|0)+8|0;F=c[I>>2]|0;J=a+112|0;K=c[J>>2]|0;L=F+(K<<3)|0;M=H+24|0;c[c[M>>2]>>2]=a;c[(c[M>>2]|0)+4>>2]=H;N=a+536|0;HBc(c[N>>2]|0,(c[M>>2]|0)!=0|0,320736,C);if((c[b+36>>2]|0)!=0){c[c[H+12>>2]>>2]=0;c[H+16>>2]=0}C=b;O=+h[C>>3];P=b+8|0;Q=O+ +h[P>>3];h[D>>3]=Q;if(O-Q>=-1.0e-13){EBc(3,0,320768,B);EBc(3,0,320808,A);A=c[J>>2]|0;if((A|0)>0){B=c[I>>2]|0;I=c[G+8>>2]|0;R=0;do{h[I+(R<<3)>>3]=+h[B+(R<<3)>>3]+ +h[F+(R+K<<3)>>3]*+h[P>>3];R=R+1|0;}while((R|0)<(A|0))}h[G>>3]=+h[D>>3];ie[c[(c[a+540>>2]|0)+28>>2]&127](a)|0;h[C>>3]=+h[D>>3];S=0;i=d;return S|0}A=z;h[k>>3]=O;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=z+8|0;h[k>>3]=Q;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];EBc(3,0,320832,z);z=H+16|0;A=z;R=a;P=b+24|0;b=H+12|0;K=H+44|0;F=H+48|0;B=H+40|0;I=H+32|0;T=H+36|0;U=H+28|0;V=U;W=H+20|0;X=H+52|0;Y=H+56|0;Z=H+60|0;_=c[r>>2]|0;$=c[t>>2]|0;aa=a+248|0;ba=a+540|0;ca=G;G=L;a:while(1){Q=+h[D>>3];L=y;h[k>>3]=+h[C>>3];c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];L=y+8|0;h[k>>3]=Q;c[L>>2]=c[k>>2];c[L+4>>2]=c[k+4>>2];EBc(23,0,320872,y);if((c[z>>2]|0)==1){PCc(c[R>>2]|0,1,c[E>>2]|0);L=c[E>>2]|0;da=c[L>>2]|0;ea=(c[(c[L+4>>2]|0)+8>>2]|0)+(c[J>>2]<<3)|0;h[da>>3]=+h[C>>3];fa=da;ga=ea}else{fa=ca;ga=G}if((c[P>>2]|0)!=5){_Fc(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ea=c[H>>2]|0;b:do{switch(ea|0){case 3:{jDc(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,3,2,Y,c[Z>>2]|0)|0;break};case 6:{jDc(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,6,2,Y,c[Z>>2]|0)|0;break};case 7:{jDc(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,7,3,X,0)|0;break};case 5:{jDc(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,5,2,Y,c[Z>>2]|0)|0;break};case 4:{jDc(1,J,C,c[fa+8>>2]|0,ga,D,c[b>>2]|0,c[K>>2]|0,c[F>>2]|0,A,c[B>>2]|0,I,c[T>>2]|0,V,c[M>>2]|0,c[W>>2]|0,4,2,Y,c[Z>>2]|0)|0;break};default:{da=c[fa+8>>2]|0;L=c[b>>2]|0;ha=c[K>>2]|0;ia=c[F>>2]|0;ja=c[B>>2]|0;ka=c[T>>2]|0;la=c[M>>2]|0;ma=c[W>>2]|0;if((ea|0)==2){jDc(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,3,X,0)|0;break b}else{jDc(1,J,C,da,ga,D,L,ha,ia,A,ja,I,ka,V,la,ma,7,2,Y,c[Z>>2]|0)|0;break b}}}}while(0);ea=c[z>>2]|0;do{if((ea|0)==-1){ud(_|0)|0;ud($|0)|0;GBc(3,0,320904,x);EBc(3,0,320992,w);c[c[b>>2]>>2]=1}else{if((ea|0)<0){na=25;break a}if((ea|0)!=4){break}c[(c[N>>2]|0)+84>>2]=4}}while(0);ea=c[z>>2]|0;if((ea|0)==1){ca=fa;G=ga;continue}else if(!((ea|0)==-1)){na=31;break}Q=+h[C>>3];if(!(Q<=+h[aa>>3])){oa=Q;break}else{ca=fa;G=ga}}if((na|0)==25){ud(_|0)|0;ud($|0)|0;$=jEc(c[z>>2]|0)|0;if((c[P>>2]|0)!=5){_Fc(a)|0;ie[c[(c[ba>>2]|0)+40>>2]&127](a)|0}ie[c[(c[ba>>2]|0)+28>>2]&127](a)|0;a=v;h[k>>3]=+h[fa>>3];c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];GBc(1,0,321016,v);S=$;i=d;return S|0}else if((na|0)==31){oa=+h[C>>3]}h[fa>>3]=oa;if((c[292316>>2]|0)!=0){EBc(3,1,321048,u);c[s>>2]=c[z>>2];EBc(3,0,321072,s);s=q;h[k>>3]=+h[C>>3];c[s>>2]=c[k>>2];c[s+4>>2]=c[k+4>>2];EBc(3,0,321096,q);q=p;h[k>>3]=+h[(c[B>>2]|0)+24>>3];c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];EBc(3,0,321128,p);p=o;h[k>>3]=+h[(c[B>>2]|0)+16>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];EBc(3,0,321168,o);o=n;h[k>>3]=+h[(c[B>>2]|0)+48>>3];c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];EBc(3,0,321216,n);c[m>>2]=c[(c[T>>2]|0)+40>>2];EBc(3,0,321264,m);c[l>>2]=c[(c[T>>2]|0)+44>>2];EBc(3,0,321304,l);c[j>>2]=c[(c[T>>2]|0)+48>>2];EBc(3,0,321344,j);c[g>>2]=c[(c[T>>2]|0)+52>>2];EBc(3,0,321384,g);c[f>>2]=c[(c[T>>2]|0)+56>>2];EBc(3,0,321432,f);fe[c[73214]&1023](3)}f=c[U>>2]|0;U=H+8|0;H=0;do{g=H+10|0;if(!(g>>>0<f>>>0)){na=37;break}c[(c[U>>2]|0)+(H<<2)>>2]=c[(c[T>>2]|0)+(g<<2)>>2];H=H+1|0;}while(H>>>0<5);if((na|0)==37){cb(321472,321504,410,321536)}EBc(3,0,321552,e);S=0;i=d;return S|0}function bEc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;j=i;f=c[g>>2]|0;g=f;b=f+536|0;k=f+4|0;l=c[c[k>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[a>>3];a=(c[b>>2]|0)+84|0;l=c[a>>2]|0;c[a>>2]=2;_Fc(g)|0;a=f+540|0;ie[c[(c[a>>2]|0)+40>>2]&127](g)|0;ie[c[(c[a>>2]|0)+28>>2]&127](g)|0;g=c[f+112>>2]|0;if((g|0)<=0){n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}f=c[(c[c[k>>2]>>2]|0)+8>>2]|0;a=0;do{h[e+(a<<3)>>3]=+h[f+(g+a<<3)>>3]- +h[d+(a<<3)>>3];a=a+1|0;}while((a|0)<(g|0));n=c[b>>2]|0;o=n;p=o+84|0;q=p;c[q>>2]=l;r=c[k>>2]|0;s=c[r>>2]|0;t=s;u=t;h[u>>3]=m;i=j;return 0}function cEc(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;_Fc(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;lEc(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function dEc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0.0;j=i;e=c[g>>2]|0;g=e;d=e+536|0;a=(c[d>>2]|0)+84|0;k=c[a>>2]|0;c[a>>2]=4;a=e+4|0;l=c[c[a>>2]>>2]|0;m=+h[l>>3];h[l>>3]=+h[b>>3];_Fc(g)|0;l=e+540|0;ie[c[(c[l>>2]|0)+40>>2]&127](g)|0;ie[c[(c[l>>2]|0)+28>>2]&127](g)|0;ie[c[(c[l>>2]|0)+32>>2]&127](g)|0;le[c[(c[l>>2]|0)+92>>2]&63](g,f,b)|0;c[(c[d>>2]|0)+84>>2]=k;h[c[c[a>>2]>>2]>>3]=m;i=j;return 0}function eEc(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;mEc(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function fEc(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;m=i;k=c[l>>2]|0;l=k;j=k+4|0;e=c[c[j>>2]>>2]|0;d=e+8|0;n=c[d>>2]|0;o=e;p=+h[o>>3];h[o>>3]=+h[a>>3];c[d>>2]=b;_Fc(l)|0;b=k+540|0;ie[c[(c[b>>2]|0)+40>>2]&127](l)|0;ie[c[(c[b>>2]|0)+28>>2]&127](l)|0;kEc(l,f)|0;l=c[k+112>>2]|0;if((l|0)>0){q=0;r=0}else{s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}while(1){k=f+(r<<3)|0;h[k>>3]=+h[k>>3]- +h[g>>3];k=q+1|0;if((k|0)<(l|0)){r=r+1+l|0;q=k}else{break}}s=c[j>>2]|0;t=c[s>>2]|0;u=t;v=u+8|0;w=v;c[w>>2]=n;x=c[j>>2]|0;y=c[x>>2]|0;z=y;A=z;h[A>>3]=p;i=m;return 0}function gEc(a,b,c,d,e,f,g,h,j,k){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;i=i;return 0}function hEc(a,b,d,e,f,g,j,k,l,m){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;var n=0,o=0,p=0;m=i;n=c[l>>2]|0;nEc(n,a,b,d,e,f,0,j,k,l,0)|0;l=c[n+112>>2]|0;if((l|0)>0){o=0;p=0}else{i=m;return 0}while(1){n=f+(p<<3)|0;h[n>>3]=+h[n>>3]- +h[g>>3];n=o+1|0;if((n|0)<(l|0)){p=p+1+l|0;o=n}else{break}}i=m;return 0}function iEc(a,b,c,d,e,f,g){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;i=i;return 0}function jEc(a){a=a|0;var b=0,c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;b=i;i=i+8|0;c=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;switch(a|0){case-6:{GBc(1,0,321616,j);m=-6;i=b;return m|0};case-8:{GBc(1,0,321728,g);m=-8;i=b;return m|0};case-1:{GBc(3,0,320904,l);m=1;i=b;return m|0};case-2:{GBc(1,0,321576,k);m=-2;i=b;return m|0};case-11:{GBc(1,0,321960,d);m=-11;i=b;return m|0};case-10:{GBc(1,0,321864,e);m=-10;i=b;return m|0};case-9:{GBc(1,0,321776,f);m=-9;i=b;return m|0};case-3:{m=-3;i=b;return m|0};case-12:{GBc(1,0,322048,c);m=-12;i=b;return m|0};case-7:{GBc(1,0,321688,h);m=-7;i=b;return m|0};case-33:{GBc(1,0,322096,b);m=-33;i=b;return m|0};default:{m=-1;i=b;return m|0}}return 0}function kEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;d=i;e=a+540|0;f=c[(c[e>>2]|0)+120>>2]|0;g=a+464|0;j=c[g>>2]|0;if((c[j+(f*44|0)+24>>2]|0)==0){i=d;return 0}k=a;a=c[j+(f*44|0)>>2]|0;l=j;j=0;do{if((a|0)!=0){m=0;do{if(((c[(c[l+(f*44|0)+20>>2]|0)+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=1.0}m=m+1|0;}while(m>>>0<a>>>0)}ie[c[(c[e>>2]|0)+160>>2]&127](k)|0;l=c[g>>2]|0;a=c[l+(f*44|0)>>2]|0;do{if((a|0)!=0){m=c[l+(f*44|0)+28>>2]|0;n=0;do{do{if(+h[m+(n<<3)>>3]==1.0){if((n|0)==0){o=l+(f*44|0)+8|0;p=0}else{q=l+(f*44|0)+8|0;o=q;p=c[(c[q>>2]|0)+(n+ -1<<2)>>2]|0}q=c[(c[o>>2]|0)+(n<<2)>>2]|0;if(!(p>>>0<q>>>0)){break}r=c[l+(f*44|0)+12>>2]|0;s=c[l+(f*44|0)+4>>2]|0;t=c[l+(f*44|0)+36>>2]|0;u=p;do{v=c[r+(u<<2)>>2]|0;w=(fa(s,n)|0)+v|0;h[b+(w<<3)>>3]=+h[t+(v<<3)>>3];u=u+1|0;}while(u>>>0<q>>>0)}}while(0);n=n+1|0;}while(n>>>0<a>>>0);if((a|0)==0){break}n=c[l+(f*44|0)+20>>2]|0;m=0;do{if(((c[n+(m<<2)>>2]|0)+ -1|0)==(j|0)){h[(c[l+(f*44|0)+28>>2]|0)+(m<<3)>>3]=0.0}m=m+1|0;}while(m>>>0<a>>>0)}}while(0);j=j+1|0;}while(j>>>0<(c[l+(f*44|0)+24>>2]|0)>>>0);i=d;return 0}function lEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;d=i;e=a+540|0;f=c[e>>2]|0;g=c[f+120>>2]|0;j=a+464|0;k=c[j>>2]|0;if((c[k+(g*44|0)>>2]|0)==0){i=d;return 0}l=a;a=f;f=c[k+(g*44|0)+28>>2]|0;k=0;m=0;while(1){h[f+(k<<3)>>3]=1.0;ie[c[a+160>>2]&127](l)|0;n=c[j>>2]|0;o=c[n+(g*44|0)+4>>2]|0;if((o|0)==0){p=m}else{q=o>>>0>1?o:1;r=c[n+(g*44|0)+36>>2]|0;s=0;t=m;while(1){h[b+(t<<3)>>3]=+h[r+(s<<3)>>3];u=s+1|0;if(u>>>0<o>>>0){t=t+1|0;s=u}else{break}}p=m+q|0}s=c[n+(g*44|0)+28>>2]|0;h[s+(k<<3)>>3]=0.0;t=k+1|0;if(!(t>>>0<(c[n+(g*44|0)>>2]|0)>>>0)){break}a=c[e>>2]|0;f=s;k=t;m=p}i=d;return 0}function mEc(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0.0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0,v=0.0,w=0.0,x=0.0,y=0.0,z=0,A=0,B=0;n=i;j=c[m+4>>2]|0;o=+h[j+64>>3];p=a+112|0;a=c[p>>2]|0;if((a|0)<=0){i=n;return 0}q=j+80|0;j=a;do{j=j+ -1|0;r=+h[k>>3]*+h[e+(j<<3)>>3];a=d+(j<<3)|0;s=+h[a>>3];if(!(s>=0.0)){t=-s}else{t=s}u=r>=0.0;if(u){v=r}else{v=-r}r=+td(+t,+v);w=+h[l+(j<<3)>>3];if(!(w>=0.0)){x=-w}else{x=w}w=o*+td(+r,+x);if(u){y=w}else{y=-w}w=y+s-s;r=1.0/w;h[a>>3]=s+w;bEc(b,0,e,c[q>>2]|0,0,m,0)|0;u=c[p>>2]|0;if((u|0)>0){z=c[q>>2]|0;A=fa(u,j)|0;B=u;do{B=B+ -1|0;h[g+(A+B<<3)>>3]=r*(+h[z+(B<<3)>>3]- +h[f+(B<<3)>>3]);}while((B|0)>0)}h[a>>3]=s;}while((j|0)>0);i=n;return 0}function nEc(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0.0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0,z=0.0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0;n=i;j=c[(c[a+540>>2]|0)+120>>2]|0;o=c[m+4>>2]|0;p=+h[o+64>>3];q=c[o+76>>2]|0;r=c[o+72>>2]|0;s=a+464|0;a=c[s>>2]|0;if((c[a+(j*44|0)+24>>2]|0)==0){i=n;return 0}t=o+80|0;o=c[a+(j*44|0)>>2]|0;u=a;a=0;do{if((o|0)!=0){v=0;do{if(((c[(c[u+(j*44|0)+20>>2]|0)+(v<<2)>>2]|0)+ -1|0)==(a|0)){w=+h[k>>3]*+h[e+(v<<3)>>3];x=d+(v<<3)|0;y=+h[x>>3];if(!(y>=0.0)){z=-y}else{z=y}A=w>=0.0;if(A){B=w}else{B=-w}w=+td(+z,+B);y=+h[l+(v<<3)>>3];if(!(y>=0.0)){C=-y}else{C=y}y=p*+td(+w,+C);D=q+(v<<3)|0;h[D>>3]=y;if(A){E=y}else{E=-y}h[D>>3]=E;y=+h[x>>3];h[D>>3]=E+y-y;h[r+(v<<3)>>3]=+h[x>>3];h[x>>3]=+h[D>>3]+ +h[x>>3];h[D>>3]=1.0/+h[D>>3]}v=v+1|0;}while(v>>>0<o>>>0)}bEc(b,0,e,c[t>>2]|0,0,m,0)|0;u=c[s>>2]|0;o=c[u+(j*44|0)>>2]|0;if((o|0)!=0){v=c[u+(j*44|0)+20>>2]|0;D=0;do{if(((c[v+(D<<2)>>2]|0)+ -1|0)==(a|0)){if((D|0)==0){F=u+(j*44|0)+8|0;G=0}else{x=u+(j*44|0)+8|0;F=x;G=c[(c[x>>2]|0)+(D+ -1<<2)>>2]|0}x=c[(c[F>>2]|0)+(D<<2)>>2]|0;if(G>>>0<x>>>0){A=c[t>>2]|0;H=q+(D<<3)|0;I=c[u+(j*44|0)+12>>2]|0;J=c[u+(j*44|0)+4>>2]|0;K=G;do{L=c[I+(K<<2)>>2]|0;M=(fa(J,D)|0)+L|0;h[g+(M<<3)>>3]=(+h[A+(L<<3)>>3]- +h[f+(L<<3)>>3])*+h[H>>3];K=K+1|0;}while(K>>>0<x>>>0)}h[d+(D<<3)>>3]=+h[r+(D<<3)>>3]}D=D+1|0;}while(D>>>0<o>>>0)}a=a+1|0;}while(a>>>0<(c[u+(j*44|0)+24>>2]|0)>>>0);i=n;return 0}function oEc(a,b){a=a|0;b=+b;h[a+496>>3]=b;i=i;return}function pEc(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0,j=0,k=0,l=0.0,m=0.0,n=0.0,o=0;e=i;fe[c[(c[a+540>>2]|0)+112>>2]&1023](a);f=a+328|0;h[f>>3]=d+1.0;g=c[a+104>>2]|0;if((g|0)<=0){i=e;return}j=c[a+108>>2]|0;k=a+336|0;a=0;do{d=+h[j+(a*24|0)+8>>3];if(d>b){h[(c[k>>2]|0)+(a<<3)>>3]=d;l=d}else{m=+h[j+(a*24|0)+16>>3];n=d+m*+ea(+((b-d)/m));h[(c[k>>2]|0)+(a<<3)>>3]=n;l=n}if((a|0)==0){o=8}else{if(l<+h[f>>3]){o=8}}if((o|0)==8){o=0;h[f>>3]=l}a=a+1|0;}while((a|0)<(g|0));i=e;return}function qEc(b,c){b=b|0;c=c|0;var d=0,e=0.0,f=0,g=0.0;d=i;e=+h[c>>3];f=c+8|0;g=+h[b+328>>3];if(!(g<=e+ +h[f>>3]+1.0e-14)){i=d;return}h[f>>3]=g-e;a[b+317|0]=1;i=d;return}function rEc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0.0,q=0;d=i;i=i+8|0;e=d;f=a+160|0;if((c[f>>2]|0)<=0){g=PBc(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}l=a+540|0;m=a+344|0;n=a+348|0;o=a+368|0;a=0;do{xe[c[(c[l>>2]|0)+104>>2]&63](a,e)|0;p=+h[(c[m>>2]|0)+(a<<3)>>3];if(p==1.0){if(+h[(c[n>>2]|0)+(a<<3)>>3]==-1.0){q=7}else{q=5}}else{q=5}do{if((q|0)==5){q=0;if(!(p==-1.0)){break}if(+h[(c[n>>2]|0)+(a<<3)>>3]==1.0){q=7}}}while(0);if((q|0)==7){q=0;NBc(b,(c[o>>2]|0)+(a<<2)|0)}a=a+1|0;}while((a|0)<(c[f>>2]|0));g=PBc(b)|0;j=(g|0)>0;k=j&1;i=d;return k|0}function sEc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;e=i;g=f+32|0;do{if((rEc(b,c[g>>2]|0)|0)!=0){if((a[f+28|0]|0)!=0){break}tEc(b,c[g>>2]|0,f)}}while(0);if((a[b+317|0]|0)==1){h=1;i=e;return h|0}b=(PBc(d)|0)>0;h=b?2:0;i=e;return h|0}function tEc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0.0,A=0.0,B=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=a+112|0;q=c[p>>2]<<3;r=h4c(q)|0;s=r;t=h4c(q)|0;q=t;h[n>>3]=+h[a+376>>3];u=a+4|0;h[o>>3]=+h[c[c[u>>2]>>2]>>3];c[80714]=LBc(4)|0;if((r|0)==0){cb(322864,322880,308,322912)}if((t|0)==0){cb(322928,322880,309,322912)}v=SBc(b)|0;if((v|0)!=0){w=v;do{v=UBc(w)|0;c[l>>2]=c[v>>2];EBc(27,0,322944,l);w=TBc(w)|0;}while((w|0)!=0)}w=c[p>>2]|0;if((w|0)>0){l=c[(c[c[u>>2]>>2]|0)+8>>2]|0;v=(w|0)>1?w<<3:8;N4c(t|0,c[a+384>>2]|0,v|0)|0;N4c(r|0,l|0,v|0)|0}h[d>>3]=+wEc(a,n,o,q,s,c[80714]|0,b);do{if((PBc(c[80714]|0)|0)==0){s=QBc(b)|0;q=a+344|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));s=SBc(b)|0;if((s|0)==0){y=x}else{v=s;z=x;while(1){s=UBc(v)|0;x=+U(+(+h[(c[q>>2]|0)+(c[s>>2]<<3)>>3]));A=z>x?x:z;s=TBc(v)|0;if((s|0)==0){y=A;break}else{z=A;v=s}}}v=j;h[k>>3]=y;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];EBc(27,0,322992,j);v=SBc(b)|0;if((v|0)==0){break}else{B=v}do{v=UBc(B)|0;if(y==+U(+(+h[(c[q>>2]|0)+(c[v>>2]<<3)>>3]))){v=c[80714]|0;OBc(v,UBc(B)|0);v=UBc(B)|0;c[g>>2]=c[v>>2];EBc(27,0,323016,g)}B=TBc(B)|0;}while((B|0)!=0)}}while(0);MBc(b);if((c[292332>>2]|0)!=0){PBc(c[80714]|0)|0}if((PBc(c[80714]|0)|0)>0){B=m;do{g=QBc(c[80714]|0)|0;c[m>>2]=c[g>>2];RBc(c[80714]|0);c[f>>2]=c[m>>2];EBc(7,0,323040,f);NBc(b,B);}while((PBc(c[80714]|0)|0)>0)}h[d>>3]=+h[o>>3];o=c[c[u>>2]>>2]|0;h[o>>3]=+h[n>>3];n=c[p>>2]|0;if((n|0)>0){N4c(c[o+8>>2]|0,t|0,((n|0)>1?n<<3:8)|0)|0}Ze(a);zEc(a);a=c[c[u>>2]>>2]|0;h[a>>3]=+h[d>>3];d=c[p>>2]|0;if((d|0)<=0){i4c(t);i4c(r);i=e;return}N4c(c[a+8>>2]|0,r|0,((d|0)>1?d<<3:8)|0)|0;i4c(t);i4c(r);i=e;return}function uEc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0,r=0,s=0,t=0,u=0,v=0.0,w=0,x=0,y=0,z=0,A=0,B=0.0,C=0.0,D=0,E=0.0,F=0;g=i;i=i+32|0;j=g;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+8|0;p=b+4|0;q=+h[c[c[p>>2]>>2]>>3];r=b+317|0;do{if((a[r]|0)!=0){DEc(b);s=b+104|0;t=c[s>>2]|0;if((t|0)<=0){break}u=b+336|0;v=q+1.0e-14;w=b+340|0;x=b+108|0;y=t;t=0;while(1){if(!(+h[(c[u>>2]|0)+(t<<3)>>3]<=v)){z=y}else{a[(c[w>>2]|0)+t|0]=1;A=c[x>>2]|0;B=+h[A+(t*24|0)+8>>3];C=+h[A+(t*24|0)+16>>3];c[m>>2]=c[A+(t*24|0)>>2];A=m+4|0;h[k>>3]=B;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=m+12|0;h[k>>3]=C;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];EBc(7,0,322584,m);z=c[s>>2]|0}A=t+1|0;if((A|0)<(z|0)){y=z;t=A}else{break}}}}while(0);z=b+512|0;m=b+524|0;t=b+516|0;y=b+528|0;c[y>>2]=(c[y>>2]|0)-(c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]|0);if((PBc(d)|0)>0){h[c[c[p>>2]>>2]>>3]=+h[e>>3];do{if((c[292332>>2]|0)!=0){e=SBc(d)|0;if((e|0)==0){break}p=b+540|0;s=e;do{e=UBc(s)|0;x=c[e>>2]|0;e=xe[c[(c[p>>2]|0)+104>>2]&63](x,n)|0;w=c[n>>2]|0;c[l>>2]=x;c[l+4>>2]=e;DBc(7,0,w,322608,l);s=TBc(s)|0;}while((s|0)!=0)}}while(0);l=f+40|0;c[l>>2]=(c[l>>2]|0)+1;c[y>>2]=(c[y>>2]|0)+1;c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=1;l=c[m>>2]|0;n=c[b+520>>2]|0;h[n+(l<<3)>>3]=q;s=b+532|0;do{if((c[s>>2]|0)==0){p=c[y>>2]|0;if((p|0)!=(c[z>>2]|0)){break}v=+h[n+(((l+1|0)%(p|0)|0)<<3)>>3];w=b+264|0;if(!(q-v<+h[w>>3])){break}e=UBc(SBc(d)|0)|0;x=xe[c[(c[b+540>>2]|0)+104>>2]&63](c[e>>2]|0,o)|0;e=c[o>>2]|0;C=+h[w>>3];w=j;h[k>>3]=v;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];w=j+8|0;h[k>>3]=q;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[j+16>>2]=p;p=j+20|0;h[k>>3]=C;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];c[j+28>>2]=x;DBc(1,0,e,322624,j);c[s>>2]=1}}while(0);MBc(d)}else{c[(c[t>>2]|0)+(c[m>>2]<<2)>>2]=0}c[m>>2]=((c[m>>2]|0)+1|0)%(c[z>>2]|0)|0;yEc(b);vEc(b);if((a[r]|0)==0){i=g;return}z=b+104|0;m=c[z>>2]|0;do{if((m|0)>0){t=b+340|0;d=b+108|0;s=b+336|0;j=m;o=0;while(1){l=(c[t>>2]|0)+o|0;if((a[l]|0)==0){D=j}else{a[l]=0;l=(c[s>>2]|0)+(o<<3)|0;h[l>>3]=+h[(c[d>>2]|0)+(o*24|0)+16>>3]+ +h[l>>3];D=c[z>>2]|0}l=o+1|0;if((l|0)<(D|0)){j=D;o=l}else{break}}if((D|0)<=0){break}o=b+336|0;j=b+328|0;d=0;do{s=c[o>>2]|0;if((d|0)==0){E=+h[s>>3];F=29}else{q=+h[s+(d<<3)>>3];if(q<+h[j>>3]){E=q;F=29}}if((F|0)==29){F=0;h[j>>3]=E}d=d+1|0;}while((d|0)<(D|0))}}while(0);a[r]=0;r=f+44|0;c[r>>2]=(c[r>>2]|0)+1;i=g;return}function vEc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+8|0;EBc(27,0,323232,b);d=a+344|0;le[c[(c[a+540>>2]|0)+92>>2]&63](a,c[d>>2]|0,c[c[a+4>>2]>>2]|0)|0;e=c[a+160>>2]|0;if((e|0)<=0){i=b;return}f=c[d>>2]|0;d=c[a+348>>2]|0;a=0;do{h[d+(a<<3)>>3]=+h[f+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=b;return}function wEc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0.0,s=0.0,t=0.0,u=0.0,v=0.0,w=0.0,x=0,y=0,z=0,A=0.0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0.0;l=i;i=i+8|0;m=l;n=i;i=i+16|0;o=a+160|0;p=c[o>>2]|0;q=h4c(p<<3)|0;if((q|0)==0){cb(323048,322880,409,323064)}if((p|0)>0){N4c(q|0,c[a+344>>2]|0,((p|0)>1?p<<3:8)|0)|0}r=+h[d>>3];p=n;h[k>>3]=+h[b>>3];c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];p=n+8|0;h[k>>3]=r;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];EBc(27,0,323080,n);n=m;h[k>>3]=1.0e-9;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];EBc(27,0,323128,m);r=+h[d>>3];s=+h[b>>3];if(!(+U(+(r-s))>1.0e-9)){i4c(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}m=a+4|0;n=a+112|0;p=a+540|0;x=a+344|0;y=a+348|0;z=c[n>>2]|0;A=s;s=r;while(1){r=(s+A)*.5;B=c[c[m>>2]>>2]|0;h[B>>3]=r;if((z|0)>0){C=c[B+8>>2]|0;B=0;do{h[C+(B<<3)>>3]=(+h[e+(B<<3)>>3]+ +h[f+(B<<3)>>3])*.5;B=B+1|0;}while((B|0)<(z|0))}_Fc(a)|0;ie[c[(c[p>>2]|0)+40>>2]&127](a)|0;ie[c[(c[p>>2]|0)+28>>2]&127](a)|0;ie[c[(c[p>>2]|0)+32>>2]&127](a)|0;le[c[(c[p>>2]|0)+92>>2]&63](a,c[x>>2]|0,c[c[m>>2]>>2]|0)|0;B=(xEc(a,g,j)|0)==0;C=c[n>>2]|0;D=(C|0)>0;do{if(B){if(D){E=c[(c[c[m>>2]>>2]|0)+8>>2]|0;F=0;do{h[e+(F<<3)>>3]=+h[E+(F<<3)>>3];F=F+1|0;}while((F|0)<(C|0))}h[b>>3]=r;F=c[o>>2]|0;if((F|0)>0){E=c[x>>2]|0;G=c[y>>2]|0;H=0;do{I=E+(H<<3)|0;h[G+(H<<3)>>3]=+h[I>>3];h[I>>3]=+h[q+(H<<3)>>3];H=H+1|0;}while((H|0)<(F|0))}J=+h[d>>3]}else{if(D){F=c[(c[c[m>>2]>>2]|0)+8>>2]|0;H=0;do{h[f+(H<<3)>>3]=+h[F+(H<<3)>>3];H=H+1|0;}while((H|0)<(C|0))}h[d>>3]=r;H=c[o>>2]|0;if((H|0)<=0){J=r;break}N4c(q|0,c[x>>2]|0,((H|0)>1?H<<3:8)|0)|0;J=r}}while(0);r=+h[b>>3];if(+U(+(J-r))>1.0e-9){z=C;A=r;s=J}else{break}}i4c(q);t=+h[b>>3];u=+h[d>>3];v=t+u;w=v*.5;i=l;return+w}function xEc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;MBc(b);EBc(27,0,323152,g);g=SBc(d)|0;if((g|0)==0){j=PBc(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}d=a+344|0;m=a+348|0;a=g;do{g=UBc(a)|0;if(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){g=UBc(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==1.0){n=7}else{n=5}}else{n=5}do{if((n|0)==5){n=0;g=UBc(a)|0;if(!(+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]==1.0)){break}g=UBc(a)|0;if(+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]==-1.0){n=7}}}while(0);if((n|0)==7){n=0;g=UBc(a)|0;o=c[g>>2]|0;g=UBc(a)|0;p=+h[(c[m>>2]|0)+(c[g>>2]<<3)>>3]>0.0?322568:322576;g=UBc(a)|0;q=+h[(c[d>>2]|0)+(c[g>>2]<<3)>>3]>0.0?322568:322576;c[f>>2]=o;c[f+4>>2]=p;c[f+8>>2]=q;EBc(27,0,323192,f);NBc(b,UBc(a)|0)}a=TBc(a)|0;}while((a|0)!=0);j=PBc(b)|0;k=(j|0)>0;l=k&1;i=e;return l|0}function yEc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+8|0;e=d;f=b+315|0;a[f]=0;g=b+540|0;xe[c[(c[g>>2]|0)+96>>2]&63](b,1)|0;zEc(b);AEc(b);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;BEc(b,8);h=CEc(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;k=b+312|0;if((a[k]|0)==0){l=1;m=j;n=h}else{AEc(b);i=d;return}while(1){if((m|0)==0){if((a[f]|n)<<24>>24==0){o=7;break}}DEc(b);zEc(b);BEc(b,8);ie[c[(c[g>>2]|0)+36>>2]&127](b)|0;if((l|0)>200){o=5;break}h=CEc(b)|0;j=ie[c[(c[g>>2]|0)+100>>2]&127](b)|0;if((a[k]|0)==0){l=l+1|0;m=j;n=h}else{o=7;break}}if((o|0)==5){IBc(c[b+536>>2]|0,323272,e)}else if((o|0)==7){AEc(b);i=d;return}}function zEc(a){a=a|0;var b=0;b=i;N4c(c[a+356>>2]|0,c[a+352>>2]|0,c[a+164>>2]|0)|0;i=b;return}function AEc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;e=b+164|0;if((c[e>>2]|0)<=0){i=d;return}f=b+352|0;g=b+360|0;b=0;do{a[(c[g>>2]|0)+b|0]=(a[(c[f>>2]|0)+b|0]|0)!=0|0;b=b+1|0;}while((b|0)<(c[e>>2]|0));i=d;return}function BEc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+8|0;if((c[292304+(d<<2)>>2]|0)==0){i=e;return}EBc(d,1,323696,g);g=b+164|0;if((c[g>>2]|0)>0){h=b+540|0;j=b+352|0;k=b+356|0;b=0;do{l=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;m=(a[(c[j>>2]|0)+b|0]|0)!=0?84:70;n=ie[c[(c[h>>2]|0)+108>>2]&127](b)|0;o=(a[(c[k>>2]|0)+b|0]|0)!=0?84:70;c[f>>2]=b;c[f+4>>2]=l;c[f+8>>2]=m;c[f+12>>2]=n;c[f+16>>2]=o;EBc(d,0,323720,f);b=b+1|0;}while((b|0)<(c[g>>2]|0))}fe[c[73214]&1023](d);i=e;return}function CEc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;e=c[b+164>>2]|0;if((e|0)<=0){f=0;i=d;return f|0}g=c[b+356>>2]|0;h=c[b+352>>2]|0;b=0;while(1){j=b+1|0;if((a[g+b|0]|0)!=(a[h+b|0]|0)){f=1;k=5;break}if((j|0)<(e|0)){b=j}else{f=0;k=5;break}}if((k|0)==5){i=d;return f|0}return 0}function DEc(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;N4c(c[a+400>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;N4c(c[a+404>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;N4c(c[a+408>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;N4c(c[a+412>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function EEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;d=c[a+160>>2]|0;e=c[a+344>>2]|0;if((d|0)>0){f=c[a+348>>2]|0;g=0;do{h[f+(g<<3)>>3]=+h[e+(g<<3)>>3];g=g+1|0;}while((g|0)<(d|0))}le[c[(c[a+540>>2]|0)+92>>2]&63](a,e,c[c[a+4>>2]>>2]|0)|0;i=b;return}function FEc(a){a=a|0;var b=0;b=i;GEc(a);HEc(a);DEc(a);IEc(a);i=b;return}function GEc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=c[b+136>>2]|0;if((e|0)>0){f=c[b+24>>2]|0;g=c[b+416>>2]|0;j=0;do{h[g+(j<<3)>>3]=+h[f+(j*112|0)+96>>3];j=j+1|0;}while((j|0)<(e|0))}e=b+140|0;if((c[e>>2]|0)>0){j=c[b+28>>2]|0;f=c[b+420>>2]|0;g=0;do{c[f+(g<<2)>>2]=c[j+(g*60|0)+52>>2];g=g+1|0;}while((g|0)<(c[e>>2]|0))}e=b+144|0;if((c[e>>2]|0)>0){g=b+32|0;j=b+424|0;f=0;do{a[(c[j>>2]|0)+f|0]=a[(c[g>>2]|0)+(f*48|0)+42|0]|0;f=f+1|0;}while((f|0)<(c[e>>2]|0))}e=c[b+148>>2]|0;if((e|0)<=0){i=d;return}f=b+36|0;g=b+428|0;b=0;do{c[(c[g>>2]|0)+(b<<2)>>2]=c[(c[f>>2]|0)+(b*52|0)+44>>2];b=b+1|0;}while((b|0)<(e|0));i=d;return}function HEc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[b+8>>2]|0;j=c[e+8>>2]|0;k=0;do{h[j+(k<<3)>>3]=+h[g+(k*112|0)+96>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[b+12>>2]|0;g=c[e+12>>2]|0;j=0;do{c[g+(j<<2)>>2]=c[k+(j*60|0)+52>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=b+16|0;k=e+16|0;g=0;do{a[(c[k>>2]|0)+g|0]=a[(c[j>>2]|0)+(g*48|0)+42|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=b+20|0;b=e+20|0;e=0;do{c[(c[b>>2]|0)+(e<<2)>>2]=c[(c[g>>2]|0)+(e*52|0)+44>>2];e=e+1|0;}while((e|0)<(f|0));i=d;return}function IEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((OCc(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=a+ -1|0;m=c[e>>2]|0;n=c[m+(l<<2)>>2]|0;o=c[m+(a<<2)>>2]|0;h[o>>3]=+h[n>>3];N4c(c[o+8>>2]|0,c[n+8>>2]|0,c[f>>2]<<3|0)|0;n=c[e>>2]|0;N4c(c[(c[n+(a<<2)>>2]|0)+12>>2]|0,c[(c[n+(l<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;n=c[e>>2]|0;N4c(c[(c[n+(a<<2)>>2]|0)+16>>2]|0,c[(c[n+(l<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;n=c[e>>2]|0;N4c(c[(c[n+(a<<2)>>2]|0)+20>>2]|0,c[(c[n+(l<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(OCc(c[d>>2]|0)|0));i=b;return}function JEc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0.0;e=i;i=i+16|0;f=e;g=i;i=i+8|0;j=i;i=i+24|0;l=i;i=i+8|0;m=i;i=i+24|0;n=i;i=i+8|0;o=i;i=i+32|0;p=i;i=i+8|0;q=i;i=i+8|0;if((c[292304+(d<<2)>>2]|0)==0){i=e;return}EBc(d,1,323368,q);q=b+136|0;if((c[q>>2]|0)>0){EBc(d,1,323392,p);if((c[q>>2]|0)>0){p=b+24|0;r=b+416|0;s=0;while(1){t=s+1|0;u=c[p>>2]|0;v=c[u+(s*112|0)+4>>2]|0;w=+h[u+(s*112|0)+96>>3];x=(a[u+(s*112|0)+72|0]|0)!=0?323352:323360;y=+h[(c[r>>2]|0)+(s<<3)>>3];c[o>>2]=t;c[o+4>>2]=v;v=o+8|0;h[k>>3]=w;c[v>>2]=c[k>>2];c[v+4>>2]=c[k+4>>2];c[o+16>>2]=x;x=o+20|0;h[k>>3]=y;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];EBc(d,0,323408,o);if((t|0)<(c[q>>2]|0)){s=t}else{break}}}fe[c[73214]&1023](d)}s=b+140|0;if((c[s>>2]|0)>0){EBc(d,1,323464,n);if((c[s>>2]|0)>0){n=b+28|0;q=b+420|0;o=0;while(1){r=o+1|0;p=c[n>>2]|0;t=c[p+(o*60|0)+4>>2]|0;x=c[p+(o*60|0)+52>>2]|0;v=(a[p+(o*60|0)+48|0]|0)!=0?323352:323360;p=c[(c[q>>2]|0)+(o<<2)>>2]|0;c[m>>2]=r;c[m+4>>2]=t;c[m+8>>2]=x;c[m+12>>2]=v;c[m+16>>2]=p;EBc(d,0,323488,m);if((r|0)<(c[s>>2]|0)){o=r}else{break}}}fe[c[73214]&1023](d)}o=b+144|0;if((c[o>>2]|0)>0){EBc(d,1,323544,l);if((c[o>>2]|0)>0){l=b+32|0;s=b+424|0;m=0;while(1){q=m+1|0;n=c[l>>2]|0;r=c[n+(m*48|0)+4>>2]|0;p=(a[n+(m*48|0)+42|0]|0)!=0?323352:323360;v=(a[n+(m*48|0)+40|0]|0)!=0?323352:323360;n=(a[(c[s>>2]|0)+m|0]|0)!=0?323352:323360;c[j>>2]=q;c[j+4>>2]=r;c[j+8>>2]=p;c[j+12>>2]=v;c[j+16>>2]=n;EBc(d,0,323568,j);if((q|0)<(c[o>>2]|0)){m=q}else{break}}}fe[c[73214]&1023](d)}m=b+148|0;if((c[m>>2]|0)>0){EBc(d,1,323624,g);if((c[m>>2]|0)>0){g=b+36|0;o=b+428|0;b=0;while(1){j=b+1|0;s=c[g>>2]|0;l=c[s+(b*52|0)+4>>2]|0;q=c[s+(b*52|0)+44>>2]|0;s=c[(c[o>>2]|0)+(b<<2)>>2]|0;c[f>>2]=j;c[f+4>>2]=l;c[f+8>>2]=q;c[f+12>>2]=s;EBc(d,0,323648,f);if((j|0)<(c[m>>2]|0)){b=j}else{break}}}fe[c[73214]&1023](d)}fe[c[73214]&1023](d);i=e;return}function KEc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;b=i;d=a;if((OCc(c[d>>2]|0)|0)<=1){i=b;return}e=a+4|0;f=a+116|0;g=a+124|0;j=a+128|0;k=a+132|0;a=1;do{l=c[e>>2]|0;m=c[l+(a<<2)>>2]|0;n=a+ -1|0;o=c[l+(n<<2)>>2]|0;h[o>>3]=+h[m>>3];N4c(c[o+8>>2]|0,c[m+8>>2]|0,c[f>>2]<<3|0)|0;m=c[e>>2]|0;N4c(c[(c[m+(n<<2)>>2]|0)+12>>2]|0,c[(c[m+(a<<2)>>2]|0)+12>>2]|0,c[g>>2]<<2|0)|0;m=c[e>>2]|0;N4c(c[(c[m+(n<<2)>>2]|0)+16>>2]|0,c[(c[m+(a<<2)>>2]|0)+16>>2]|0,c[j>>2]|0)|0;m=c[e>>2]|0;N4c(c[(c[m+(n<<2)>>2]|0)+20>>2]|0,c[(c[m+(a<<2)>>2]|0)+20>>2]|0,c[k>>2]<<2|0)|0;a=a+1|0;}while((a|0)<(OCc(c[d>>2]|0)|0));i=b;return}function LEc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;e=c[c[b+4>>2]>>2]|0;f=c[b+116>>2]|0;if((f|0)>0){g=c[e+8>>2]|0;j=c[b+8>>2]|0;k=0;do{h[j+(k*112|0)+96>>3]=+h[g+(k<<3)>>3];k=k+1|0;}while((k|0)<(f|0))}f=b+124|0;if((c[f>>2]|0)>0){k=c[e+12>>2]|0;g=c[b+12>>2]|0;j=0;do{c[g+(j*60|0)+52>>2]=c[k+(j<<2)>>2];j=j+1|0;}while((j|0)<(c[f>>2]|0))}f=b+128|0;if((c[f>>2]|0)>0){j=e+16|0;k=b+16|0;g=0;do{a[(c[k>>2]|0)+(g*48|0)+42|0]=a[(c[j>>2]|0)+g|0]|0;g=g+1|0;}while((g|0)<(c[f>>2]|0))}f=c[b+132>>2]|0;if((f|0)<=0){i=d;return}g=e+20|0;e=b+20|0;b=0;do{c[(c[e>>2]|0)+(b*52|0)+44>>2]=c[(c[g>>2]|0)+(b<<2)>>2];b=b+1|0;}while((b|0)<(f|0));i=d;return}function MEc(a){a=a|0;var b=0,d=0;b=i;d=c[c[a+4>>2]>>2]|0;h[a+376>>3]=+h[d>>3];N4c(c[a+384>>2]|0,c[d+8>>2]|0,c[a+116>>2]<<3|0)|0;N4c(c[a+388>>2]|0,c[d+12>>2]|0,c[a+124>>2]<<2|0)|0;N4c(c[a+392>>2]|0,c[d+16>>2]|0,c[a+128>>2]|0)|0;N4c(c[a+396>>2]|0,c[d+20>>2]|0,c[a+132>>2]<<2|0)|0;i=b;return}function NEc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+32|0;o=b;c[o>>2]=0;p=JCc(3,32)|0;c[o>>2]=p;if((p|0)==0){IBc(c[b+536>>2]|0,323752,m)}m=n;p=b+116|0;q=n+8|0;r=b+536|0;s=b+124|0;t=n+12|0;u=b+128|0;v=n+16|0;w=b+132|0;x=n+20|0;y=n;n=0;do{h[m>>3]=0.0;z=j4c(c[p>>2]|0,8)|0;c[q>>2]=z;HBc(c[r>>2]|0,(z|0)!=0|0,323808,l);z=j4c(c[s>>2]|0,4)|0;c[t>>2]=z;HBc(c[r>>2]|0,(z|0)!=0|0,323808,k);z=j4c(c[u>>2]|0,1)|0;c[v>>2]=z;HBc(c[r>>2]|0,(z|0)!=0|0,323808,j);z=j4c(c[w>>2]|0,4)|0;c[x>>2]=z;HBc(c[r>>2]|0,(z|0)!=0|0,323808,g);NCc(c[o>>2]|0,y);n=n+1|0;}while(n>>>0<3);n=j4c(3,4)|0;c[b+4>>2]=n;PCc(c[o>>2]|0,0,n);c[b+8>>2]=j4c(c[p>>2]|0,112)|0;c[b+12>>2]=j4c(c[s>>2]|0,60)|0;c[b+16>>2]=j4c(c[u>>2]|0,48)|0;c[b+20>>2]=j4c(c[w>>2]|0,52)|0;n=b+136|0;c[b+24>>2]=j4c(c[n>>2]|0,112)|0;o=c[b+140>>2]|0;c[b+28>>2]=j4c(o,60)|0;y=c[b+144>>2]|0;c[b+32>>2]=j4c(y,48)|0;g=c[b+148>>2]|0;c[b+36>>2]=j4c(g,52)|0;c[b+40>>2]=j4c(c[b+216>>2]|0,52)|0;c[b+44>>2]=j4c(c[b+220>>2]|0,52)|0;c[b+48>>2]=j4c(c[b+224>>2]|0,52)|0;c[b+52>>2]=j4c(c[b+228>>2]|0,52)|0;x=c[b+104>>2]|0;c[b+108>>2]=j4c(x,24)|0;h[b+328>>3]=+h[b+240>>3];c[b+336>>2]=j4c(x,8)|0;c[b+340>>2]=j4c(x,1)|0;c[b+300>>2]=1;c[b+292>>2]=1;c[b+296>>2]=1;x=c[b+160>>2]|0;c[b+344>>2]=j4c(x,8)|0;c[b+348>>2]=j4c(x,8)|0;j=c[b+164>>2]|0;c[b+352>>2]=j4c(j,1)|0;c[b+356>>2]=j4c(j,1)|0;c[b+360>>2]=j4c(j,1)|0;j=h4c(x<<2)|0;c[b+368>>2]=j;c[b+364>>2]=h4c(c[b+168>>2]<<3)|0;if((x|0)!=0){v=0;do{c[j+(v<<2)>>2]=v;v=v+1|0;}while(v>>>0<x>>>0)}x=c[p>>2]|0;c[b+384>>2]=j4c(x,8)|0;p=c[s>>2]|0;c[b+388>>2]=j4c(p,4)|0;s=c[u>>2]|0;c[b+392>>2]=j4c(s,1)|0;u=c[w>>2]|0;c[b+396>>2]=j4c(u,4)|0;c[b+400>>2]=j4c(x,8)|0;c[b+404>>2]=j4c(p,4)|0;c[b+408>>2]=j4c(s,1)|0;c[b+412>>2]=j4c(u,4)|0;c[b+416>>2]=j4c(c[n>>2]|0,8)|0;c[b+420>>2]=j4c(o,4)|0;c[b+424>>2]=j4c(y,1)|0;c[b+428>>2]=j4c(g,4)|0;c[b+432>>2]=j4c(c[b+152>>2]|0,8)|0;c[b+436>>2]=j4c(c[b+156>>2]|0,8)|0;g=h4c((c[b+192>>2]|0)*40|0)|0;c[b+484>>2]=g;y=b+540|0;fe[c[(c[y>>2]|0)+20>>2]&1023](g);g=h4c((c[b+196>>2]|0)*80|0)|0;c[b+476>>2]=g;fe[c[(c[y>>2]|0)+16>>2]&1023](g);g=h4c((c[b+200>>2]|0)*80|0)|0;c[b+468>>2]=g;fe[c[(c[y>>2]|0)+12>>2]&1023](g);g=h4c((c[b+204>>2]|0)*48|0)|0;c[b+488>>2]=g;ge[c[(c[y>>2]|0)+24>>2]&255](g,b);c[b+464>>2]=h4c((c[b+232>>2]|0)*44|0)|0;c[b+76>>2]=0;c[b+80>>2]=0;g=j4c(c[b+188>>2]|0,4)|0;c[b+320>>2]=g;HBc(c[r>>2]|0,(g|0)!=0|0,323824,f);c[b+512>>2]=100;c[b+516>>2]=j4c(100,4)|0;c[b+520>>2]=j4c(100,8)|0;c[b+524>>2]=0;c[b+528>>2]=0;c[b+532>>2]=0;h[b+304>>3]=1.0;a[b+313|0]=0;a[b+312|0]=0;a[b+314|0]=0;f=b+172|0;g=b+316|0;a[g]=0;a[g+1|0]=0;a[g+2|0]=0;a[g+3|0]=0;g=h4c(c[f>>2]<<2)|0;y=b+504|0;c[y>>2]=g;HBc(c[r>>2]|0,(g|0)!=0|0,323808,e);if((c[f>>2]|0)==0){i=d;return}else{A=0}do{e=JCc(1024,16)|0;c[(c[y>>2]|0)+(A<<2)>>2]=e;A=A+1|0;}while(A>>>0<(c[f>>2]|0)>>>0);i=d;return}



function aeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17600>>3]=1.0;i=i;return}function beb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17608>>3]=0.0;i=i;return}function ceb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17632>>3]=180.0;i=i;return}function deb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17624>>3]=180.0;i=i;return}function eeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17616>>3]=180.0;i=i;return}function feb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+492>>2]=180;i=i;return}function geb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+496>>2]=180;i=i;return}function heb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+500>>2]=180;i=i;return}function ieb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+504>>2]=155;i=i;return}function jeb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+508>>2]=155;i=i;return}function keb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+512>>2]=155;i=i;return}function leb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+516>>2]=155;i=i;return}function meb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+520>>2]=155;i=i;return}function neb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+524>>2]=155;i=i;return}function oeb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+528>>2]=155;i=i;return}function peb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+532>>2]=155;i=i;return}function qeb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+536>>2]=155;i=i;return}function reb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+540>>2]=155;i=i;return}function seb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+544>>2]=155;i=i;return}function teb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+548>>2]=155;i=i;return}function ueb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17640>>3]=0.0;i=i;return}function veb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17648>>3]=0.0;i=i;return}function web(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17656>>3]=0.0;i=i;return}function xeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17664>>3]=0.0;i=i;return}function yeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17672>>3]=-1.0;i=i;return}function zeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17680>>3]=0.0;i=i;return}function Aeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17688>>3]=0.0;i=i;return}function Beb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17696>>3]=1.0;i=i;return}function Ceb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17704>>3]=0.0;i=i;return}function Deb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17728>>3]=0.0;i=i;return}function Eeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17720>>3]=0.0;i=i;return}function Feb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17712>>3]=255.0;i=i;return}function Geb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+552>>2]=255;i=i;return}function Heb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+556>>2]=0;i=i;return}function Ieb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+560>>2]=0;i=i;return}function Jeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17736>>3]=+h[(c[a+416>>2]|0)+41880>>3]*-.5;i=i;return}function Keb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17744>>3]=0.0;i=i;return}function Leb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17752>>3]=0.0;i=i;return}function Meb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17760>>3]=1.0;i=i;return}function Neb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17768>>3]=0.0;i=i;return}function Oeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17776>>3]=0.0;i=i;return}function Peb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17784>>3]=0.0;i=i;return}function Qeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17792>>3]=1.0;i=i;return}function Reb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17800>>3]=0.0;i=i;return}function Seb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17824>>3]=0.0;i=i;return}function Teb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17816>>3]=0.0;i=i;return}function Ueb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17808>>3]=255.0;i=i;return}function Veb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+564>>2]=255;i=i;return}function Web(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+568>>2]=0;i=i;return}function Xeb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+572>>2]=0;i=i;return}function Yeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17832>>3]=+h[(c[a+416>>2]|0)+41896>>3]*-.5;i=i;return}function Zeb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17840>>3]=0.0;i=i;return}function _eb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17848>>3]=0.0;i=i;return}function $eb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17856>>3]=1.0;i=i;return}function afb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17864>>3]=0.0;i=i;return}function bfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17872>>3]=0.0;i=i;return}function cfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17880>>3]=0.0;i=i;return}function dfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17888>>3]=1.0;i=i;return}function efb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17896>>3]=0.0;i=i;return}function ffb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17920>>3]=0.0;i=i;return}function gfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17912>>3]=0.0;i=i;return}function hfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17904>>3]=255.0;i=i;return}function ifb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+576>>2]=255;i=i;return}function jfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+580>>2]=0;i=i;return}function kfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+584>>2]=0;i=i;return}function lfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+588>>2]=155;i=i;return}function mfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+592>>2]=155;i=i;return}function nfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+596>>2]=155;i=i;return}function ofb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+600>>2]=0;i=i;return}function pfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+604>>2]=128;i=i;return}function qfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+608>>2]=255;i=i;return}function rfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17928>>3]=0.0;i=i;return}function sfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17936>>3]=0.0;i=i;return}function tfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17944>>3]=0.0;i=i;return}function ufb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17952>>3]=1.0;i=i;return}function vfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17960>>3]=0.0;i=i;return}function wfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17968>>3]=0.0;i=i;return}function xfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17976>>3]=0.0;i=i;return}function yfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17984>>3]=0.0;i=i;return}function zfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17992>>3]=0.0;i=i;return}function Afb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18e3>>3]=0.0;i=i;return}function Bfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18008>>3]=0.0;i=i;return}function Cfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18016>>3]=0.0;i=i;return}function Dfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18024>>3]=0.0;i=i;return}function Efb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18032>>3]=0.0;i=i;return}function Ffb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18040>>3]=.1;i=i;return}function Gfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18048>>3]=0.0;i=i;return}function Hfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18056>>3]=0.0;i=i;return}function Ifb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18064>>3]=1.0;i=i;return}function Jfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18072>>3]=0.0;i=i;return}function Kfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18096>>3]=180.0;i=i;return}function Lfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18088>>3]=180.0;i=i;return}function Mfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18080>>3]=180.0;i=i;return}function Nfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+612>>2]=180;i=i;return}function Ofb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+616>>2]=180;i=i;return}function Pfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+620>>2]=180;i=i;return}function Qfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18104>>3]=0.0;i=i;return}function Rfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18112>>3]=.22;i=i;return}function Sfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18120>>3]=0.0;i=i;return}function Tfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18128>>3]=1.0;i=i;return}function Ufb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18136>>3]=0.0;i=i;return}function Vfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18144>>3]=0.0;i=i;return}function Wfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18168>>3]=200.0;i=i;return}function Xfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18160>>3]=0.0;i=i;return}function Yfb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18152>>3]=0.0;i=i;return}function Zfb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+624>>2]=0;i=i;return}function _fb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+628>>2]=0;i=i;return}function $fb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+632>>2]=200;i=i;return}function agb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+636>>2]=0;i=i;return}function bgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+640>>2]=128;i=i;return}function cgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+644>>2]=255;i=i;return}function dgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18176>>3]=0.0;i=i;return}function egb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18184>>3]=0.0;i=i;return}function fgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18192>>3]=0.0;i=i;return}function ggb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18200>>3]=1.0;i=i;return}function hgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18208>>3]=0.0;i=i;return}function igb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18216>>3]=0.0;i=i;return}function jgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18224>>3]=0.0;i=i;return}function kgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18232>>3]=0.0;i=i;return}function lgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18240>>3]=0.0;i=i;return}function mgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18248>>3]=0.0;i=i;return}function ngb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18256>>3]=0.0;i=i;return}function ogb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18264>>3]=0.0;i=i;return}function pgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18272>>3]=0.0;i=i;return}function qgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+648>>2]=155;i=i;return}function rgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+652>>2]=155;i=i;return}function sgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+656>>2]=155;i=i;return}function tgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18280>>3]=0.0;i=i;return}function ugb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18288>>3]=-.1;i=i;return}function vgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18296>>3]=0.0;i=i;return}function wgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18304>>3]=1.0;i=i;return}function xgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18312>>3]=0.0;i=i;return}function ygb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18320>>3]=0.0;i=i;return}function zgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18344>>3]=255.0;i=i;return}function Agb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18336>>3]=128.0;i=i;return}function Bgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18328>>3]=0.0;i=i;return}function Cgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+660>>2]=0;i=i;return}function Dgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+664>>2]=128;i=i;return}function Egb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+668>>2]=255;i=i;return}function Fgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+672>>2]=0;i=i;return}function Ggb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+676>>2]=128;i=i;return}function Hgb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+680>>2]=255;i=i;return}function Igb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18352>>3]=0.0;i=i;return}function Jgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18360>>3]=0.0;i=i;return}function Kgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18368>>3]=0.0;i=i;return}function Lgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18376>>3]=1.0;i=i;return}function Mgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18384>>3]=0.0;i=i;return}function Ngb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18392>>3]=0.0;i=i;return}function Ogb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18400>>3]=0.0;i=i;return}function Pgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18408>>3]=0.0;i=i;return}function Qgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18416>>3]=0.0;i=i;return}function Rgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18424>>3]=0.0;i=i;return}function Sgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18432>>3]=0.0;i=i;return}function Tgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18440>>3]=0.0;i=i;return}function Ugb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18448>>3]=0.0;i=i;return}function Vgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18456>>3]=0.0;i=i;return}function Wgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18464>>3]=.1;i=i;return}function Xgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18472>>3]=0.0;i=i;return}function Ygb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18480>>3]=1.0;i=i;return}function Zgb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18488>>3]=0.0;i=i;return}function _gb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18496>>3]=0.0;i=i;return}function $gb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18520>>3]=255.0;i=i;return}function ahb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18512>>3]=128.0;i=i;return}function bhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18504>>3]=0.0;i=i;return}function chb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+684>>2]=0;i=i;return}function dhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+688>>2]=128;i=i;return}function ehb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+692>>2]=255;i=i;return}function fhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+696>>2]=0;i=i;return}function ghb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+700>>2]=128;i=i;return}function hhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+704>>2]=255;i=i;return}function ihb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18528>>3]=0.0;i=i;return}function jhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18536>>3]=0.0;i=i;return}function khb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18544>>3]=0.0;i=i;return}function lhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18552>>3]=1.0;i=i;return}function mhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18560>>3]=0.0;i=i;return}function nhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18568>>3]=0.0;i=i;return}function ohb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18576>>3]=0.0;i=i;return}function phb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18584>>3]=0.0;i=i;return}function qhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18592>>3]=0.0;i=i;return}function rhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18600>>3]=0.0;i=i;return}function shb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18608>>3]=0.0;i=i;return}function thb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18616>>3]=0.0;i=i;return}function uhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18624>>3]=0.0;i=i;return}function vhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+708>>2]=0;i=i;return}function whb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+712>>2]=128;i=i;return}function xhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+716>>2]=255;i=i;return}function yhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18632>>3]=0.0;i=i;return}function zhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18640>>3]=0.0;i=i;return}function Ahb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18648>>3]=0.0;i=i;return}function Bhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18656>>3]=1.0;i=i;return}function Chb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18664>>3]=0.0;i=i;return}function Dhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18672>>3]=0.0;i=i;return}function Ehb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18680>>3]=0.0;i=i;return}function Fhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18688>>3]=0.0;i=i;return}function Ghb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18696>>3]=0.0;i=i;return}function Hhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18704>>3]=0.0;i=i;return}function Ihb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18712>>3]=0.0;i=i;return}function Jhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18720>>3]=0.0;i=i;return}function Khb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18728>>3]=0.0;i=i;return}function Lhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18736>>3]=.11;i=i;return}function Mhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18744>>3]=0.0;i=i;return}function Nhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18752>>3]=0.0;i=i;return}function Ohb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18760>>3]=0.0;i=i;return}function Phb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18768>>3]=1.0;i=i;return}function Qhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18776>>3]=0.0;i=i;return}function Rhb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18800>>3]=180.0;i=i;return}function Shb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18792>>3]=180.0;i=i;return}function Thb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18784>>3]=180.0;i=i;return}function Uhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+720>>2]=180;i=i;return}function Vhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+724>>2]=180;i=i;return}function Whb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+728>>2]=180;i=i;return}function Xhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+732>>2]=0;i=i;return}function Yhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+736>>2]=128;i=i;return}function Zhb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+740>>2]=255;i=i;return}function _hb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18808>>3]=0.0;i=i;return}function $hb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18816>>3]=0.0;i=i;return}function aib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18824>>3]=0.0;i=i;return}function bib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18832>>3]=1.0;i=i;return}function cib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18840>>3]=0.0;i=i;return}function dib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18848>>3]=0.0;i=i;return}function eib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18856>>3]=0.0;i=i;return}function fib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18864>>3]=0.0;i=i;return}function gib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18872>>3]=0.0;i=i;return}function hib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18880>>3]=0.0;i=i;return}function iib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18888>>3]=0.0;i=i;return}function jib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18896>>3]=0.0;i=i;return}function kib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18904>>3]=0.0;i=i;return}function lib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18912>>3]=.11;i=i;return}function mib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18920>>3]=0.0;i=i;return}function nib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18928>>3]=0.0;i=i;return}function oib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18936>>3]=0.0;i=i;return}function pib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18944>>3]=1.0;i=i;return}function qib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18952>>3]=0.0;i=i;return}function rib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18976>>3]=180.0;i=i;return}function sib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18968>>3]=180.0;i=i;return}function tib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18960>>3]=180.0;i=i;return}function uib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+744>>2]=180;i=i;return}function vib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+748>>2]=180;i=i;return}function wib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+752>>2]=180;i=i;return}function xib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+756>>2]=155;i=i;return}function yib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+760>>2]=155;i=i;return}function zib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+764>>2]=155;i=i;return}function Aib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+768>>2]=155;i=i;return}function Bib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+772>>2]=155;i=i;return}function Cib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+776>>2]=155;i=i;return}function Dib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+780>>2]=155;i=i;return}function Eib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+784>>2]=155;i=i;return}function Fib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+788>>2]=155;i=i;return}function Gib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+792>>2]=155;i=i;return}function Hib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+796>>2]=155;i=i;return}function Iib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+800>>2]=155;i=i;return}function Jib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18984>>3]=0.0;i=i;return}function Kib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18992>>3]=0.0;i=i;return}function Lib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19e3>>3]=0.0;i=i;return}function Mib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19008>>3]=0.0;i=i;return}function Nib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19016>>3]=-1.0;i=i;return}function Oib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19024>>3]=0.0;i=i;return}function Pib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19032>>3]=0.0;i=i;return}function Qib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19040>>3]=1.0;i=i;return}function Rib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19048>>3]=0.0;i=i;return}function Sib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19072>>3]=0.0;i=i;return}function Tib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19064>>3]=0.0;i=i;return}function Uib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19056>>3]=255.0;i=i;return}function Vib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+804>>2]=255;i=i;return}function Wib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+808>>2]=0;i=i;return}function Xib(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+812>>2]=0;i=i;return}function Yib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19080>>3]=+h[(c[a+416>>2]|0)+43360>>3]*-.5;i=i;return}function Zib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19088>>3]=0.0;i=i;return}function _ib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19096>>3]=0.0;i=i;return}function $ib(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19104>>3]=1.0;i=i;return}function ajb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19112>>3]=0.0;i=i;return}function bjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19120>>3]=0.0;i=i;return}function cjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19128>>3]=0.0;i=i;return}function djb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19136>>3]=1.0;i=i;return}function ejb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19144>>3]=0.0;i=i;return}function fjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19168>>3]=0.0;i=i;return}function gjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19160>>3]=0.0;i=i;return}function hjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19152>>3]=255.0;i=i;return}function ijb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+816>>2]=255;i=i;return}function jjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+820>>2]=0;i=i;return}function kjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+824>>2]=0;i=i;return}function ljb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19176>>3]=+h[(c[a+416>>2]|0)+43376>>3]*-.5;i=i;return}function mjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19184>>3]=0.0;i=i;return}function njb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19192>>3]=0.0;i=i;return}function ojb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19200>>3]=1.0;i=i;return}function pjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19208>>3]=0.0;i=i;return}function qjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19216>>3]=0.0;i=i;return}function rjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19224>>3]=0.0;i=i;return}function sjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19232>>3]=1.0;i=i;return}function tjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19240>>3]=0.0;i=i;return}function ujb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19264>>3]=0.0;i=i;return}function vjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19256>>3]=0.0;i=i;return}function wjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19248>>3]=255.0;i=i;return}function xjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+828>>2]=255;i=i;return}function yjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+832>>2]=0;i=i;return}function zjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+836>>2]=0;i=i;return}function Ajb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+840>>2]=155;i=i;return}function Bjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+844>>2]=155;i=i;return}function Cjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+848>>2]=155;i=i;return}function Djb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+852>>2]=0;i=i;return}function Ejb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+856>>2]=128;i=i;return}function Fjb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+860>>2]=255;i=i;return}function Gjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19272>>3]=0.0;i=i;return}function Hjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19280>>3]=0.0;i=i;return}function Ijb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19288>>3]=0.0;i=i;return}function Jjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19296>>3]=1.0;i=i;return}function Kjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19304>>3]=0.0;i=i;return}function Ljb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19312>>3]=0.0;i=i;return}function Mjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19320>>3]=0.0;i=i;return}function Njb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19328>>3]=0.0;i=i;return}function Ojb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19336>>3]=0.0;i=i;return}function Pjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19344>>3]=0.0;i=i;return}function Qjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19352>>3]=0.0;i=i;return}function Rjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19360>>3]=0.0;i=i;return}function Sjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19368>>3]=0.0;i=i;return}function Tjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19376>>3]=0.0;i=i;return}function Ujb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19384>>3]=.1;i=i;return}function Vjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19392>>3]=0.0;i=i;return}function Wjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19400>>3]=0.0;i=i;return}function Xjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19408>>3]=1.0;i=i;return}function Yjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19416>>3]=0.0;i=i;return}function Zjb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19440>>3]=180.0;i=i;return}function _jb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19432>>3]=180.0;i=i;return}function $jb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19424>>3]=180.0;i=i;return}function akb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+864>>2]=180;i=i;return}function bkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+868>>2]=180;i=i;return}function ckb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+872>>2]=180;i=i;return}function dkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19448>>3]=0.0;i=i;return}function ekb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19456>>3]=.22;i=i;return}function fkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19464>>3]=0.0;i=i;return}function gkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19472>>3]=1.0;i=i;return}function hkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19480>>3]=0.0;i=i;return}function ikb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19488>>3]=0.0;i=i;return}function jkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19512>>3]=200.0;i=i;return}function kkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19504>>3]=0.0;i=i;return}function lkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19496>>3]=0.0;i=i;return}function mkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+876>>2]=0;i=i;return}function nkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+880>>2]=0;i=i;return}function okb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+884>>2]=200;i=i;return}function pkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+888>>2]=0;i=i;return}function qkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+892>>2]=128;i=i;return}function rkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+896>>2]=255;i=i;return}function skb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19520>>3]=0.0;i=i;return}function tkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19528>>3]=0.0;i=i;return}function ukb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19536>>3]=0.0;i=i;return}function vkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19544>>3]=1.0;i=i;return}function wkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19552>>3]=0.0;i=i;return}function xkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19560>>3]=0.0;i=i;return}function ykb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19568>>3]=0.0;i=i;return}function zkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19576>>3]=0.0;i=i;return}function Akb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19584>>3]=0.0;i=i;return}function Bkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19592>>3]=0.0;i=i;return}function Ckb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19600>>3]=0.0;i=i;return}function Dkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19608>>3]=0.0;i=i;return}function Ekb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19616>>3]=0.0;i=i;return}function Fkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+900>>2]=155;i=i;return}function Gkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+904>>2]=155;i=i;return}function Hkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+908>>2]=155;i=i;return}function Ikb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19624>>3]=0.0;i=i;return}function Jkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19632>>3]=-.1;i=i;return}function Kkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19640>>3]=0.0;i=i;return}function Lkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19648>>3]=1.0;i=i;return}function Mkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19656>>3]=0.0;i=i;return}function Nkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19664>>3]=0.0;i=i;return}function Okb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19688>>3]=255.0;i=i;return}function Pkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19680>>3]=128.0;i=i;return}function Qkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19672>>3]=0.0;i=i;return}function Rkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+912>>2]=0;i=i;return}function Skb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+916>>2]=128;i=i;return}function Tkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+920>>2]=255;i=i;return}function Ukb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+924>>2]=0;i=i;return}function Vkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+928>>2]=128;i=i;return}function Wkb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+932>>2]=255;i=i;return}function Xkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19696>>3]=0.0;i=i;return}function Ykb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19704>>3]=0.0;i=i;return}function Zkb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19712>>3]=0.0;i=i;return}function _kb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19720>>3]=1.0;i=i;return}function $kb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19728>>3]=0.0;i=i;return}function alb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19736>>3]=0.0;i=i;return}function blb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19744>>3]=0.0;i=i;return}function clb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19752>>3]=0.0;i=i;return}function dlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19760>>3]=0.0;i=i;return}function elb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19768>>3]=0.0;i=i;return}function flb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19776>>3]=0.0;i=i;return}function glb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19784>>3]=0.0;i=i;return}function hlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19792>>3]=0.0;i=i;return}function ilb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19800>>3]=0.0;i=i;return}function jlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19808>>3]=.1;i=i;return}function klb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19816>>3]=0.0;i=i;return}function llb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19824>>3]=1.0;i=i;return}function mlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19832>>3]=0.0;i=i;return}function nlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19840>>3]=0.0;i=i;return}function olb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19864>>3]=255.0;i=i;return}function plb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19856>>3]=128.0;i=i;return}function qlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19848>>3]=0.0;i=i;return}function rlb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+936>>2]=0;i=i;return}function slb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+940>>2]=128;i=i;return}function tlb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+944>>2]=255;i=i;return}function ulb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+948>>2]=0;i=i;return}function vlb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+952>>2]=128;i=i;return}function wlb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+956>>2]=255;i=i;return}function xlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19872>>3]=0.0;i=i;return}function ylb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19880>>3]=0.0;i=i;return}function zlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19888>>3]=0.0;i=i;return}function Alb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19896>>3]=1.0;i=i;return}function Blb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19904>>3]=0.0;i=i;return}function Clb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19912>>3]=0.0;i=i;return}function Dlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19920>>3]=0.0;i=i;return}function Elb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19928>>3]=0.0;i=i;return}function Flb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19936>>3]=0.0;i=i;return}function Glb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19944>>3]=0.0;i=i;return}function Hlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19952>>3]=0.0;i=i;return}function Ilb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19960>>3]=0.0;i=i;return}function Jlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19968>>3]=0.0;i=i;return}function Klb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+960>>2]=0;i=i;return}function Llb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+964>>2]=128;i=i;return}function Mlb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+968>>2]=255;i=i;return}function Nlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19976>>3]=0.0;i=i;return}function Olb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19984>>3]=0.0;i=i;return}function Plb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19992>>3]=0.0;i=i;return}function Qlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e4>>3]=1.0;i=i;return}function Rlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20008>>3]=0.0;i=i;return}function Slb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20016>>3]=0.0;i=i;return}function Tlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20024>>3]=0.0;i=i;return}function Ulb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20032>>3]=0.0;i=i;return}function Vlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20040>>3]=0.0;i=i;return}function Wlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20048>>3]=0.0;i=i;return}function Xlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20056>>3]=0.0;i=i;return}function Ylb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20064>>3]=0.0;i=i;return}function Zlb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20072>>3]=0.0;i=i;return}function _lb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20080>>3]=.11;i=i;return}function $lb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20088>>3]=0.0;i=i;return}function amb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20096>>3]=0.0;i=i;return}function bmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20104>>3]=0.0;i=i;return}function cmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20112>>3]=1.0;i=i;return}function dmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20120>>3]=0.0;i=i;return}function emb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20144>>3]=180.0;i=i;return}function fmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20136>>3]=180.0;i=i;return}function gmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20128>>3]=180.0;i=i;return}function hmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+972>>2]=180;i=i;return}function imb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+976>>2]=180;i=i;return}function jmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+980>>2]=180;i=i;return}function kmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+984>>2]=0;i=i;return}function lmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+988>>2]=128;i=i;return}function mmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+992>>2]=255;i=i;return}function nmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20152>>3]=0.0;i=i;return}function omb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20160>>3]=0.0;i=i;return}function pmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20168>>3]=0.0;i=i;return}function qmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20176>>3]=1.0;i=i;return}function rmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20184>>3]=0.0;i=i;return}function smb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20192>>3]=0.0;i=i;return}function tmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20200>>3]=0.0;i=i;return}function umb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20208>>3]=0.0;i=i;return}function vmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20216>>3]=0.0;i=i;return}function wmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20224>>3]=0.0;i=i;return}function xmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20232>>3]=0.0;i=i;return}function ymb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20240>>3]=0.0;i=i;return}function zmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20248>>3]=0.0;i=i;return}function Amb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20256>>3]=.11;i=i;return}function Bmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20264>>3]=0.0;i=i;return}function Cmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20272>>3]=0.0;i=i;return}function Dmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20280>>3]=0.0;i=i;return}function Emb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20288>>3]=1.0;i=i;return}function Fmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20296>>3]=0.0;i=i;return}function Gmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20320>>3]=180.0;i=i;return}function Hmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20312>>3]=180.0;i=i;return}function Imb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20304>>3]=180.0;i=i;return}function Jmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+996>>2]=180;i=i;return}function Kmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1e3>>2]=180;i=i;return}function Lmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1004>>2]=180;i=i;return}function Mmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1008>>2]=155;i=i;return}function Nmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1012>>2]=155;i=i;return}function Omb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1016>>2]=155;i=i;return}function Pmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1020>>2]=155;i=i;return}function Qmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1024>>2]=155;i=i;return}function Rmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1028>>2]=155;i=i;return}function Smb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1032>>2]=155;i=i;return}function Tmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1036>>2]=155;i=i;return}function Umb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1040>>2]=155;i=i;return}function Vmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1044>>2]=155;i=i;return}function Wmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1048>>2]=155;i=i;return}function Xmb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1052>>2]=155;i=i;return}function Ymb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20328>>3]=0.0;i=i;return}function Zmb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20336>>3]=0.0;i=i;return}function _mb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20344>>3]=0.0;i=i;return}function $mb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20352>>3]=0.0;i=i;return}function anb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20360>>3]=-1.0;i=i;return}function bnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20368>>3]=0.0;i=i;return}function cnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20376>>3]=0.0;i=i;return}function dnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20384>>3]=1.0;i=i;return}function enb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20392>>3]=0.0;i=i;return}function fnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20416>>3]=0.0;i=i;return}function gnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20408>>3]=0.0;i=i;return}function hnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20400>>3]=255.0;i=i;return}function inb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1056>>2]=255;i=i;return}function jnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1060>>2]=0;i=i;return}function knb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1064>>2]=0;i=i;return}function lnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20424>>3]=+h[(c[a+416>>2]|0)+44840>>3]*-.5;i=i;return}function mnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20432>>3]=0.0;i=i;return}function nnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20440>>3]=0.0;i=i;return}function onb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20448>>3]=1.0;i=i;return}function pnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20456>>3]=0.0;i=i;return}function qnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20464>>3]=0.0;i=i;return}function rnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20472>>3]=0.0;i=i;return}function snb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20480>>3]=1.0;i=i;return}function tnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20488>>3]=0.0;i=i;return}function unb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20512>>3]=0.0;i=i;return}function vnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20504>>3]=0.0;i=i;return}function wnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20496>>3]=255.0;i=i;return}function xnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1068>>2]=255;i=i;return}function ynb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1072>>2]=0;i=i;return}function znb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1076>>2]=0;i=i;return}function Anb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20520>>3]=+h[(c[a+416>>2]|0)+44856>>3]*-.5;i=i;return}function Bnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20528>>3]=0.0;i=i;return}function Cnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20536>>3]=0.0;i=i;return}function Dnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20544>>3]=1.0;i=i;return}function Enb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20552>>3]=0.0;i=i;return}function Fnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20560>>3]=0.0;i=i;return}function Gnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20568>>3]=0.0;i=i;return}function Hnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20576>>3]=1.0;i=i;return}function Inb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20584>>3]=0.0;i=i;return}function Jnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20608>>3]=0.0;i=i;return}function Knb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20600>>3]=0.0;i=i;return}function Lnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20592>>3]=255.0;i=i;return}function Mnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1080>>2]=255;i=i;return}function Nnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1084>>2]=0;i=i;return}function Onb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1088>>2]=0;i=i;return}function Pnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1092>>2]=155;i=i;return}function Qnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1096>>2]=155;i=i;return}function Rnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1100>>2]=155;i=i;return}function Snb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1104>>2]=0;i=i;return}function Tnb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1108>>2]=128;i=i;return}function Unb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1112>>2]=255;i=i;return}function Vnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20616>>3]=0.0;i=i;return}function Wnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20624>>3]=0.0;i=i;return}function Xnb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20632>>3]=0.0;i=i;return}function Ynb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20640>>3]=1.0;i=i;return}function Znb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20648>>3]=0.0;i=i;return}function _nb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20656>>3]=0.0;i=i;return}function $nb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20664>>3]=0.0;i=i;return}function aob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20672>>3]=0.0;i=i;return}function bob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20680>>3]=0.0;i=i;return}function cob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20688>>3]=0.0;i=i;return}function dob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20696>>3]=0.0;i=i;return}function eob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20704>>3]=0.0;i=i;return}function fob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20712>>3]=0.0;i=i;return}function gob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20720>>3]=0.0;i=i;return}function hob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20728>>3]=.1;i=i;return}function iob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20736>>3]=0.0;i=i;return}function job(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20744>>3]=0.0;i=i;return}function kob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20752>>3]=1.0;i=i;return}function lob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20760>>3]=0.0;i=i;return}function mob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20784>>3]=180.0;i=i;return}function nob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20776>>3]=180.0;i=i;return}function oob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20768>>3]=180.0;i=i;return}function pob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1116>>2]=180;i=i;return}function qob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1120>>2]=180;i=i;return}function rob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1124>>2]=180;i=i;return}function sob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20792>>3]=0.0;i=i;return}function tob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20800>>3]=.22;i=i;return}function uob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20808>>3]=0.0;i=i;return}function vob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20816>>3]=1.0;i=i;return}function wob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20824>>3]=0.0;i=i;return}function xob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20832>>3]=0.0;i=i;return}function yob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20856>>3]=200.0;i=i;return}function zob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20848>>3]=0.0;i=i;return}function Aob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20840>>3]=0.0;i=i;return}function Bob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1128>>2]=0;i=i;return}function Cob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1132>>2]=0;i=i;return}function Dob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1136>>2]=200;i=i;return}function Eob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1140>>2]=0;i=i;return}function Fob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1144>>2]=128;i=i;return}function Gob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1148>>2]=255;i=i;return}function Hob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20864>>3]=0.0;i=i;return}function Iob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20872>>3]=0.0;i=i;return}function Job(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20880>>3]=0.0;i=i;return}function Kob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20888>>3]=1.0;i=i;return}function Lob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20896>>3]=0.0;i=i;return}function Mob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20904>>3]=0.0;i=i;return}function Nob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20912>>3]=0.0;i=i;return}function Oob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20920>>3]=0.0;i=i;return}function Pob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20928>>3]=0.0;i=i;return}function Qob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20936>>3]=0.0;i=i;return}function Rob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20944>>3]=0.0;i=i;return}function Sob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20952>>3]=0.0;i=i;return}function Tob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20960>>3]=0.0;i=i;return}function Uob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1152>>2]=155;i=i;return}function Vob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1156>>2]=155;i=i;return}function Wob(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1160>>2]=155;i=i;return}function Xob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20968>>3]=0.0;i=i;return}function Yob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20976>>3]=-.1;i=i;return}function Zob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20984>>3]=0.0;i=i;return}function _ob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20992>>3]=1.0;i=i;return}function $ob(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21e3>>3]=0.0;i=i;return}function apb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21008>>3]=0.0;i=i;return}function bpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21032>>3]=255.0;i=i;return}function cpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21024>>3]=128.0;i=i;return}function dpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21016>>3]=0.0;i=i;return}function epb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1164>>2]=0;i=i;return}function fpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1168>>2]=128;i=i;return}function gpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1172>>2]=255;i=i;return}function hpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1176>>2]=0;i=i;return}function ipb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1180>>2]=128;i=i;return}function jpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1184>>2]=255;i=i;return}function kpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21040>>3]=0.0;i=i;return}function lpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21048>>3]=0.0;i=i;return}function mpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21056>>3]=0.0;i=i;return}function npb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21064>>3]=1.0;i=i;return}function opb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21072>>3]=0.0;i=i;return}function ppb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21080>>3]=0.0;i=i;return}function qpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21088>>3]=0.0;i=i;return}function rpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21096>>3]=0.0;i=i;return}function spb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21104>>3]=0.0;i=i;return}function tpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21112>>3]=0.0;i=i;return}function upb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21120>>3]=0.0;i=i;return}function vpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21128>>3]=0.0;i=i;return}function wpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21136>>3]=0.0;i=i;return}function xpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21144>>3]=0.0;i=i;return}function ypb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21152>>3]=.1;i=i;return}function zpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21160>>3]=0.0;i=i;return}function Apb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21168>>3]=1.0;i=i;return}function Bpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21176>>3]=0.0;i=i;return}function Cpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21184>>3]=0.0;i=i;return}function Dpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21208>>3]=255.0;i=i;return}function Epb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21200>>3]=128.0;i=i;return}function Fpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21192>>3]=0.0;i=i;return}function Gpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1188>>2]=0;i=i;return}function Hpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1192>>2]=128;i=i;return}function Ipb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1196>>2]=255;i=i;return}function Jpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1200>>2]=0;i=i;return}function Kpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1204>>2]=128;i=i;return}function Lpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1208>>2]=255;i=i;return}function Mpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21216>>3]=0.0;i=i;return}function Npb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21224>>3]=0.0;i=i;return}function Opb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21232>>3]=0.0;i=i;return}function Ppb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21240>>3]=1.0;i=i;return}function Qpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21248>>3]=0.0;i=i;return}function Rpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21256>>3]=0.0;i=i;return}function Spb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21264>>3]=0.0;i=i;return}function Tpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21272>>3]=0.0;i=i;return}function Upb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21280>>3]=0.0;i=i;return}function Vpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21288>>3]=0.0;i=i;return}function Wpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21296>>3]=0.0;i=i;return}function Xpb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21304>>3]=0.0;i=i;return}function Ypb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21312>>3]=0.0;i=i;return}function Zpb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1212>>2]=0;i=i;return}function _pb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1216>>2]=128;i=i;return}function $pb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1220>>2]=255;i=i;return}function aqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21320>>3]=0.0;i=i;return}function bqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21328>>3]=0.0;i=i;return}function cqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21336>>3]=0.0;i=i;return}function dqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21344>>3]=1.0;i=i;return}function eqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21352>>3]=0.0;i=i;return}function fqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21360>>3]=0.0;i=i;return}function gqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21368>>3]=0.0;i=i;return}function hqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21376>>3]=0.0;i=i;return}function iqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21384>>3]=0.0;i=i;return}function jqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21392>>3]=0.0;i=i;return}function kqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21400>>3]=0.0;i=i;return}function lqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21408>>3]=0.0;i=i;return}function mqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21416>>3]=0.0;i=i;return}function nqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21424>>3]=.11;i=i;return}function oqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21432>>3]=0.0;i=i;return}function pqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21440>>3]=0.0;i=i;return}function qqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21448>>3]=0.0;i=i;return}function rqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21456>>3]=1.0;i=i;return}function sqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21464>>3]=0.0;i=i;return}function tqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21488>>3]=180.0;i=i;return}function uqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21480>>3]=180.0;i=i;return}function vqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21472>>3]=180.0;i=i;return}function wqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1224>>2]=180;i=i;return}function xqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1228>>2]=180;i=i;return}function yqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1232>>2]=180;i=i;return}function zqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1236>>2]=0;i=i;return}function Aqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1240>>2]=128;i=i;return}function Bqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1244>>2]=255;i=i;return}function Cqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21496>>3]=0.0;i=i;return}function Dqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21504>>3]=0.0;i=i;return}function Eqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21512>>3]=0.0;i=i;return}function Fqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21520>>3]=1.0;i=i;return}function Gqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21528>>3]=0.0;i=i;return}function Hqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21536>>3]=0.0;i=i;return}function Iqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21544>>3]=0.0;i=i;return}function Jqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21552>>3]=0.0;i=i;return}function Kqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21560>>3]=0.0;i=i;return}function Lqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21568>>3]=0.0;i=i;return}function Mqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21576>>3]=0.0;i=i;return}function Nqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21584>>3]=0.0;i=i;return}function Oqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21592>>3]=0.0;i=i;return}function Pqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21600>>3]=.11;i=i;return}function Qqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21608>>3]=0.0;i=i;return}function Rqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21616>>3]=0.0;i=i;return}function Sqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21624>>3]=0.0;i=i;return}function Tqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21632>>3]=1.0;i=i;return}function Uqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21640>>3]=0.0;i=i;return}function Vqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21664>>3]=180.0;i=i;return}function Wqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21656>>3]=180.0;i=i;return}function Xqb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21648>>3]=180.0;i=i;return}function Yqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1248>>2]=180;i=i;return}function Zqb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1252>>2]=180;i=i;return}function _qb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1256>>2]=180;i=i;return}function $qb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1260>>2]=155;i=i;return}function arb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1264>>2]=155;i=i;return}function brb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1268>>2]=155;i=i;return}function crb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1272>>2]=155;i=i;return}function drb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1276>>2]=155;i=i;return}function erb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1280>>2]=155;i=i;return}function frb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1284>>2]=155;i=i;return}function grb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1288>>2]=155;i=i;return}function hrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1292>>2]=155;i=i;return}function irb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1296>>2]=155;i=i;return}function jrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1300>>2]=155;i=i;return}function krb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1304>>2]=155;i=i;return}function lrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21672>>3]=0.0;i=i;return}function mrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21680>>3]=0.0;i=i;return}function nrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21688>>3]=0.0;i=i;return}function orb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21696>>3]=0.0;i=i;return}function prb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21704>>3]=-1.0;i=i;return}function qrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21712>>3]=0.0;i=i;return}function rrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21720>>3]=0.0;i=i;return}function srb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21728>>3]=1.0;i=i;return}function trb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21736>>3]=0.0;i=i;return}function urb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21760>>3]=0.0;i=i;return}function vrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21752>>3]=0.0;i=i;return}function wrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21744>>3]=255.0;i=i;return}function xrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1308>>2]=255;i=i;return}function yrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1312>>2]=0;i=i;return}function zrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1316>>2]=0;i=i;return}function Arb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21768>>3]=+h[(c[a+416>>2]|0)+46320>>3]*-.5;i=i;return}function Brb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21776>>3]=0.0;i=i;return}function Crb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21784>>3]=0.0;i=i;return}function Drb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21792>>3]=1.0;i=i;return}function Erb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21800>>3]=0.0;i=i;return}function Frb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21808>>3]=0.0;i=i;return}function Grb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21816>>3]=0.0;i=i;return}function Hrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21824>>3]=1.0;i=i;return}function Irb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21832>>3]=0.0;i=i;return}function Jrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21856>>3]=0.0;i=i;return}function Krb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21848>>3]=0.0;i=i;return}function Lrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21840>>3]=255.0;i=i;return}function Mrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1320>>2]=255;i=i;return}function Nrb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1324>>2]=0;i=i;return}function Orb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1328>>2]=0;i=i;return}function Prb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21864>>3]=+h[(c[a+416>>2]|0)+46336>>3]*-.5;i=i;return}function Qrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21872>>3]=0.0;i=i;return}function Rrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21880>>3]=0.0;i=i;return}function Srb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21888>>3]=1.0;i=i;return}function Trb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21896>>3]=0.0;i=i;return}function Urb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21904>>3]=0.0;i=i;return}function Vrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21912>>3]=0.0;i=i;return}function Wrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21920>>3]=1.0;i=i;return}function Xrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21928>>3]=0.0;i=i;return}function Yrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21952>>3]=0.0;i=i;return}function Zrb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21944>>3]=0.0;i=i;return}function _rb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21936>>3]=255.0;i=i;return}function $rb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1332>>2]=255;i=i;return}function asb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1336>>2]=0;i=i;return}function bsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1340>>2]=0;i=i;return}function csb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1344>>2]=155;i=i;return}function dsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1348>>2]=155;i=i;return}function esb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1352>>2]=155;i=i;return}function fsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1356>>2]=0;i=i;return}function gsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1360>>2]=128;i=i;return}function hsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1364>>2]=255;i=i;return}function isb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21960>>3]=0.0;i=i;return}function jsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21968>>3]=0.0;i=i;return}function ksb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21976>>3]=0.0;i=i;return}function lsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21984>>3]=1.0;i=i;return}function msb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+21992>>3]=0.0;i=i;return}function nsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22e3>>3]=0.0;i=i;return}function osb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22008>>3]=0.0;i=i;return}function psb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22016>>3]=0.0;i=i;return}function qsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22024>>3]=0.0;i=i;return}function rsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22032>>3]=0.0;i=i;return}function ssb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22040>>3]=0.0;i=i;return}function tsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22048>>3]=0.0;i=i;return}function usb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22056>>3]=0.0;i=i;return}function vsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22064>>3]=0.0;i=i;return}function wsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22072>>3]=.1;i=i;return}function xsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22080>>3]=0.0;i=i;return}function ysb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22088>>3]=0.0;i=i;return}function zsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22096>>3]=1.0;i=i;return}function Asb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22104>>3]=0.0;i=i;return}function Bsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22128>>3]=180.0;i=i;return}function Csb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22120>>3]=180.0;i=i;return}function Dsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22112>>3]=180.0;i=i;return}function Esb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1368>>2]=180;i=i;return}function Fsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1372>>2]=180;i=i;return}function Gsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1376>>2]=180;i=i;return}function Hsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22136>>3]=0.0;i=i;return}function Isb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22144>>3]=.22;i=i;return}function Jsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22152>>3]=0.0;i=i;return}function Ksb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22160>>3]=1.0;i=i;return}function Lsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22168>>3]=0.0;i=i;return}function Msb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22176>>3]=0.0;i=i;return}function Nsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22200>>3]=200.0;i=i;return}function Osb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22192>>3]=0.0;i=i;return}function Psb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22184>>3]=0.0;i=i;return}function Qsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1380>>2]=0;i=i;return}function Rsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1384>>2]=0;i=i;return}function Ssb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1388>>2]=200;i=i;return}function Tsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1392>>2]=0;i=i;return}function Usb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1396>>2]=128;i=i;return}function Vsb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1400>>2]=255;i=i;return}function Wsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22208>>3]=0.0;i=i;return}function Xsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22216>>3]=0.0;i=i;return}function Ysb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22224>>3]=0.0;i=i;return}function Zsb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22232>>3]=1.0;i=i;return}function _sb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22240>>3]=0.0;i=i;return}function $sb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22248>>3]=0.0;i=i;return}function atb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22256>>3]=0.0;i=i;return}function btb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22264>>3]=0.0;i=i;return}function ctb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22272>>3]=0.0;i=i;return}function dtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22280>>3]=0.0;i=i;return}function etb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22288>>3]=0.0;i=i;return}function ftb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22296>>3]=0.0;i=i;return}function gtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22304>>3]=0.0;i=i;return}function htb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1404>>2]=155;i=i;return}function itb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1408>>2]=155;i=i;return}function jtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1412>>2]=155;i=i;return}function ktb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22312>>3]=0.0;i=i;return}function ltb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22320>>3]=-.1;i=i;return}function mtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22328>>3]=0.0;i=i;return}function ntb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22336>>3]=1.0;i=i;return}function otb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22344>>3]=0.0;i=i;return}function ptb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22352>>3]=0.0;i=i;return}function qtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22376>>3]=255.0;i=i;return}function rtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22368>>3]=128.0;i=i;return}function stb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22360>>3]=0.0;i=i;return}function ttb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1416>>2]=0;i=i;return}function utb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1420>>2]=128;i=i;return}function vtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1424>>2]=255;i=i;return}function wtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1428>>2]=0;i=i;return}function xtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1432>>2]=128;i=i;return}function ytb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1436>>2]=255;i=i;return}function ztb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22384>>3]=0.0;i=i;return}function Atb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22392>>3]=0.0;i=i;return}function Btb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22400>>3]=0.0;i=i;return}function Ctb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22408>>3]=1.0;i=i;return}function Dtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22416>>3]=0.0;i=i;return}function Etb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22424>>3]=0.0;i=i;return}function Ftb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22432>>3]=0.0;i=i;return}function Gtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22440>>3]=0.0;i=i;return}function Htb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22448>>3]=0.0;i=i;return}function Itb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22456>>3]=0.0;i=i;return}function Jtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22464>>3]=0.0;i=i;return}function Ktb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22472>>3]=0.0;i=i;return}function Ltb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22480>>3]=0.0;i=i;return}function Mtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22488>>3]=0.0;i=i;return}function Ntb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22496>>3]=.1;i=i;return}function Otb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22504>>3]=0.0;i=i;return}function Ptb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22512>>3]=1.0;i=i;return}function Qtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22520>>3]=0.0;i=i;return}function Rtb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22528>>3]=0.0;i=i;return}function Stb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22552>>3]=255.0;i=i;return}function Ttb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22544>>3]=128.0;i=i;return}function Utb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22536>>3]=0.0;i=i;return}function Vtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1440>>2]=0;i=i;return}function Wtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1444>>2]=128;i=i;return}function Xtb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1448>>2]=255;i=i;return}function Ytb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1452>>2]=0;i=i;return}function Ztb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1456>>2]=128;i=i;return}function _tb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1460>>2]=255;i=i;return}function $tb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22560>>3]=0.0;i=i;return}function aub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22568>>3]=0.0;i=i;return}function bub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22576>>3]=0.0;i=i;return}function cub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22584>>3]=1.0;i=i;return}function dub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22592>>3]=0.0;i=i;return}function eub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22600>>3]=0.0;i=i;return}function fub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22608>>3]=0.0;i=i;return}function gub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22616>>3]=0.0;i=i;return}function hub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22624>>3]=0.0;i=i;return}function iub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22632>>3]=0.0;i=i;return}function jub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22640>>3]=0.0;i=i;return}function kub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22648>>3]=0.0;i=i;return}function lub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22656>>3]=0.0;i=i;return}function mub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1464>>2]=0;i=i;return}function nub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1468>>2]=128;i=i;return}function oub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1472>>2]=255;i=i;return}function pub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22664>>3]=0.0;i=i;return}function qub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22672>>3]=0.0;i=i;return}function rub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22680>>3]=0.0;i=i;return}function sub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22688>>3]=1.0;i=i;return}function tub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22696>>3]=0.0;i=i;return}function uub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22704>>3]=0.0;i=i;return}function vub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22712>>3]=0.0;i=i;return}function wub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22720>>3]=0.0;i=i;return}function xub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22728>>3]=0.0;i=i;return}function yub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22736>>3]=0.0;i=i;return}function zub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22744>>3]=0.0;i=i;return}function Aub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22752>>3]=0.0;i=i;return}function Bub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22760>>3]=0.0;i=i;return}function Cub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22768>>3]=.11;i=i;return}function Dub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22776>>3]=0.0;i=i;return}function Eub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22784>>3]=0.0;i=i;return}function Fub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22792>>3]=0.0;i=i;return}function Gub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22800>>3]=1.0;i=i;return}function Hub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22808>>3]=0.0;i=i;return}function Iub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22832>>3]=180.0;i=i;return}function Jub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22824>>3]=180.0;i=i;return}function Kub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22816>>3]=180.0;i=i;return}function Lub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1476>>2]=180;i=i;return}function Mub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1480>>2]=180;i=i;return}function Nub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1484>>2]=180;i=i;return}function Oub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1488>>2]=0;i=i;return}function Pub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1492>>2]=128;i=i;return}function Qub(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1496>>2]=255;i=i;return}function Rub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22840>>3]=0.0;i=i;return}function Sub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22848>>3]=0.0;i=i;return}function Tub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22856>>3]=0.0;i=i;return}function Uub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22864>>3]=1.0;i=i;return}function Vub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22872>>3]=0.0;i=i;return}function Wub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22880>>3]=0.0;i=i;return}function Xub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22888>>3]=0.0;i=i;return}function Yub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22896>>3]=0.0;i=i;return}function Zub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22904>>3]=0.0;i=i;return}function _ub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22912>>3]=0.0;i=i;return}function $ub(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22920>>3]=0.0;i=i;return}function avb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22928>>3]=0.0;i=i;return}function bvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22936>>3]=0.0;i=i;return}function cvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22944>>3]=.11;i=i;return}function dvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22952>>3]=0.0;i=i;return}function evb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22960>>3]=0.0;i=i;return}function fvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22968>>3]=0.0;i=i;return}function gvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22976>>3]=1.0;i=i;return}function hvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22984>>3]=0.0;i=i;return}function ivb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23008>>3]=180.0;i=i;return}function jvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23e3>>3]=180.0;i=i;return}function kvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+22992>>3]=180.0;i=i;return}function lvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1500>>2]=180;i=i;return}function mvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1504>>2]=180;i=i;return}function nvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1508>>2]=180;i=i;return}function ovb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1512>>2]=155;i=i;return}function pvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1516>>2]=155;i=i;return}function qvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1520>>2]=155;i=i;return}function rvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1524>>2]=155;i=i;return}function svb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1528>>2]=155;i=i;return}function tvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1532>>2]=155;i=i;return}function uvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1536>>2]=155;i=i;return}function vvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1540>>2]=155;i=i;return}function wvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1544>>2]=155;i=i;return}function xvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1548>>2]=155;i=i;return}function yvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1552>>2]=155;i=i;return}function zvb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1556>>2]=155;i=i;return}function Avb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26816>>3]=0.0;i=i;return}function Bvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26824>>3]=0.0;i=i;return}function Cvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26832>>3]=0.0;i=i;return}function Dvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26840>>3]=0.0;i=i;return}function Evb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26848>>3]=0.0;i=i;return}function Fvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26856>>3]=0.0;i=i;return}function Gvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26864>>3]=0.0;i=i;return}function Hvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23016>>3]=1.0;i=i;return}function Ivb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23832>>3]=0.0;i=i;return}function Jvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23856>>3]=0.0;i=i;return}function Kvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23056>>3]=0.0;i=i;return}function Lvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23064>>3]=0.0;i=i;return}function Mvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23072>>3]=1.0;i=i;return}function Nvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23688>>3]=0.0;i=i;return}function Ovb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23712>>3]=0.0;i=i;return}function Pvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23080>>3]=1.0;i=i;return}function Qvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23568>>3]=0.0;i=i;return}function Rvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23592>>3]=0.0;i=i;return}function Svb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23088>>3]=1.0;i=i;return}function Tvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23448>>3]=0.0;i=i;return}function Uvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23472>>3]=0.0;i=i;return}function Vvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23096>>3]=1.0;i=i;return}function Wvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23328>>3]=0.0;i=i;return}function Xvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23352>>3]=0.0;i=i;return}function Yvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23104>>3]=1.0;i=i;return}function Zvb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23208>>3]=0.0;i=i;return}function _vb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23232>>3]=0.0;i=i;return}function $vb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23112>>3]=.8660254037844387;i=i;return}function awb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23120>>3]=-.4999999999999999;i=i;return}function bwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23128>>3]=0.0;i=i;return}function cwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23136>>3]=.4999999999999999;i=i;return}function dwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23144>>3]=.8660254037844387;i=i;return}function ewb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23152>>3]=0.0;i=i;return}function fwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23176>>3]=0.0;i=i;return}function gwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23168>>3]=0.0;i=i;return}function hwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23160>>3]=0.0;i=i;return}function iwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23200>>3]=0.0;i=i;return}function jwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23192>>3]=0.0;i=i;return}function kwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23184>>3]=1.0;i=i;return}function lwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23256>>3]=.8660254037844387;i=i;return}function mwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23264>>3]=.4999999999999999;i=i;return}function nwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23272>>3]=0.0;i=i;return}function owb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23280>>3]=-.4999999999999999;i=i;return}function pwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23288>>3]=.8660254037844387;i=i;return}function qwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23296>>3]=0.0;i=i;return}function rwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23320>>3]=0.0;i=i;return}function swb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23312>>3]=0.0;i=i;return}function twb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23304>>3]=1.0;i=i;return}function uwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23376>>3]=.8660254037844387;i=i;return}function vwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23384>>3]=-.4999999999999999;i=i;return}function wwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23392>>3]=0.0;i=i;return}function xwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23400>>3]=.4999999999999999;i=i;return}function ywb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23408>>3]=.8660254037844387;i=i;return}function zwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23416>>3]=0.0;i=i;return}function Awb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23440>>3]=0.0;i=i;return}function Bwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23432>>3]=0.0;i=i;return}function Cwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23424>>3]=1.0;i=i;return}function Dwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23496>>3]=.8660254037844387;i=i;return}function Ewb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23504>>3]=.4999999999999999;i=i;return}function Fwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23512>>3]=0.0;i=i;return}function Gwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23520>>3]=-.4999999999999999;i=i;return}function Hwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23528>>3]=.8660254037844387;i=i;return}function Iwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23536>>3]=0.0;i=i;return}function Jwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23560>>3]=0.0;i=i;return}function Kwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23552>>3]=0.0;i=i;return}function Lwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23544>>3]=1.0;i=i;return}function Mwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23616>>3]=.8660254037844387;i=i;return}function Nwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23624>>3]=-.4999999999999999;i=i;return}function Owb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23632>>3]=0.0;i=i;return}function Pwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23640>>3]=.4999999999999999;i=i;return}function Qwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23648>>3]=.8660254037844387;i=i;return}function Rwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23656>>3]=0.0;i=i;return}function Swb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23680>>3]=0.0;i=i;return}function Twb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23672>>3]=0.0;i=i;return}function Uwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23664>>3]=1.0;i=i;return}function Vwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23736>>3]=.8660254037844387;i=i;return}function Wwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23744>>3]=.4999999999999999;i=i;return}function Xwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23752>>3]=0.0;i=i;return}function Ywb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23760>>3]=-.4999999999999999;i=i;return}function Zwb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23768>>3]=.8660254037844387;i=i;return}function _wb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23776>>3]=0.0;i=i;return}function $wb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23792>>3]=+h[(c[a+416>>2]|0)+5360>>3];i=i;return}function axb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23800>>3]=+h[(c[a+416>>2]|0)+5368>>3];i=i;return}function bxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23824>>3]=0.0;i=i;return}function cxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23816>>3]=0.0;i=i;return}function dxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23808>>3]=1.0;i=i;return}function exb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23912>>3]=0.0;i=i;return}function fxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23920>>3]=0.0;i=i;return}function gxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23944>>3]=0.0;i=i;return}function hxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23936>>3]=0.0;i=i;return}function ixb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23928>>3]=1.0;i=i;return}function jxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26872>>3]=0.0;i=i;return}function kxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24e3>>3]=0.0;i=i;return}function lxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24008>>3]=0.0;i=i;return}function mxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24016>>3]=1.0;i=i;return}function nxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24024>>3]=0.0;i=i;return}function oxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24032>>3]=0.0;i=i;return}function pxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24040>>3]=0.0;i=i;return}function qxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24048>>3]=0.0;i=i;return}function rxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26880>>3]=0.0;i=i;return}function sxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24056>>3]=0.0;i=i;return}function txb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24064>>3]=0.0;i=i;return}function uxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24072>>3]=1.0;i=i;return}function vxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24080>>3]=0.0;i=i;return}function wxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24088>>3]=0.0;i=i;return}function xxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24096>>3]=0.0;i=i;return}function yxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24120>>3]=0.0;i=i;return}function zxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24152>>3]=0.0;i=i;return}function Axb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24160>>3]=0.0;i=i;return}function Bxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24168>>3]=0.0;i=i;return}function Cxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24176>>3]=0.0;i=i;return}function Dxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24184>>3]=0.0;i=i;return}function Exb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24192>>3]=0.0;i=i;return}function Fxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24200>>3]=0.0;i=i;return}function Gxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24208>>3]=0.0;i=i;return}function Hxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24216>>3]=0.0;i=i;return}function Ixb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24224>>3]=0.0;i=i;return}function Jxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24232>>3]=0.0;i=i;return}function Kxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24240>>3]=0.0;i=i;return}function Lxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24248>>3]=0.0;i=i;return}function Mxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24256>>3]=0.0;i=i;return}function Nxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26888>>3]=0.0;i=i;return}function Oxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24264>>3]=0.0;i=i;return}function Pxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24272>>3]=0.0;i=i;return}function Qxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24280>>3]=1.0;i=i;return}function Rxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24288>>3]=0.0;i=i;return}function Sxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24296>>3]=0.0;i=i;return}function Txb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24304>>3]=0.0;i=i;return}function Uxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24328>>3]=0.0;i=i;return}function Vxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24360>>3]=0.0;i=i;return}function Wxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24368>>3]=0.0;i=i;return}function Xxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24376>>3]=0.0;i=i;return}function Yxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24384>>3]=0.0;i=i;return}function Zxb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24392>>3]=0.0;i=i;return}function _xb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24400>>3]=0.0;i=i;return}function $xb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24408>>3]=0.0;i=i;return}function ayb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24416>>3]=0.0;i=i;return}function byb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24424>>3]=0.0;i=i;return}function cyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24432>>3]=0.0;i=i;return}function dyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24440>>3]=0.0;i=i;return}function eyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24448>>3]=0.0;i=i;return}function fyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24456>>3]=0.0;i=i;return}function gyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24464>>3]=0.0;i=i;return}function hyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26896>>3]=0.0;i=i;return}function iyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24472>>3]=0.0;i=i;return}function jyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24480>>3]=0.0;i=i;return}function kyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24488>>3]=1.0;i=i;return}function lyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24496>>3]=0.0;i=i;return}function myb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24504>>3]=0.0;i=i;return}function nyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24512>>3]=0.0;i=i;return}function oyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24536>>3]=0.0;i=i;return}function pyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24568>>3]=0.0;i=i;return}function qyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24576>>3]=0.0;i=i;return}function ryb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24584>>3]=0.0;i=i;return}function syb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24592>>3]=0.0;i=i;return}function tyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24600>>3]=0.0;i=i;return}function uyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24608>>3]=0.0;i=i;return}function vyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24616>>3]=0.0;i=i;return}function wyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24624>>3]=0.0;i=i;return}function xyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24632>>3]=0.0;i=i;return}function yyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24640>>3]=0.0;i=i;return}function zyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24648>>3]=0.0;i=i;return}function Ayb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24656>>3]=0.0;i=i;return}function Byb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24664>>3]=0.0;i=i;return}function Cyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24672>>3]=0.0;i=i;return}function Dyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26904>>3]=0.0;i=i;return}function Eyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24680>>3]=0.0;i=i;return}function Fyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24688>>3]=0.0;i=i;return}function Gyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24696>>3]=1.0;i=i;return}function Hyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24704>>3]=0.0;i=i;return}function Iyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24712>>3]=0.0;i=i;return}function Jyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24720>>3]=0.0;i=i;return}function Kyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24744>>3]=0.0;i=i;return}function Lyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24776>>3]=0.0;i=i;return}function Myb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24784>>3]=0.0;i=i;return}function Nyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24792>>3]=0.0;i=i;return}function Oyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24800>>3]=0.0;i=i;return}function Pyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24808>>3]=0.0;i=i;return}function Qyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24816>>3]=0.0;i=i;return}function Ryb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24824>>3]=0.0;i=i;return}function Syb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24832>>3]=0.0;i=i;return}function Tyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24840>>3]=0.0;i=i;return}function Uyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24848>>3]=0.0;i=i;return}function Vyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24856>>3]=0.0;i=i;return}function Wyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24864>>3]=0.0;i=i;return}function Xyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24872>>3]=0.0;i=i;return}function Yyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24880>>3]=0.0;i=i;return}function Zyb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26912>>3]=0.0;i=i;return}function _yb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24888>>3]=0.0;i=i;return}function $yb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24896>>3]=0.0;i=i;return}function azb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24904>>3]=1.0;i=i;return}function bzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24912>>3]=0.0;i=i;return}function czb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24920>>3]=0.0;i=i;return}function dzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24928>>3]=0.0;i=i;return}function ezb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24952>>3]=0.0;i=i;return}function fzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24984>>3]=0.0;i=i;return}function gzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24992>>3]=0.0;i=i;return}function hzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25e3>>3]=0.0;i=i;return}function izb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25008>>3]=0.0;i=i;return}function jzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25016>>3]=0.0;i=i;return}function kzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25024>>3]=0.0;i=i;return}function lzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25032>>3]=0.0;i=i;return}function mzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25040>>3]=0.0;i=i;return}function nzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25048>>3]=0.0;i=i;return}function ozb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25056>>3]=0.0;i=i;return}function pzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25064>>3]=0.0;i=i;return}function qzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25072>>3]=0.0;i=i;return}function rzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25080>>3]=0.0;i=i;return}function szb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25088>>3]=0.0;i=i;return}function tzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26920>>3]=0.0;i=i;return}function uzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25096>>3]=0.0;i=i;return}function vzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25104>>3]=0.0;i=i;return}function wzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25112>>3]=1.0;i=i;return}function xzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25120>>3]=0.0;i=i;return}function yzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25128>>3]=0.0;i=i;return}function zzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25136>>3]=0.0;i=i;return}function Azb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25160>>3]=0.0;i=i;return}function Bzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25192>>3]=0.0;i=i;return}function Czb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25200>>3]=0.0;i=i;return}function Dzb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25208>>3]=0.0;i=i;return}



function rpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20744>>3]=0.0;i=i;return}function spa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20736>>3]=0.0;i=i;return}function tpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20728>>3]=.1;i=i;return}function upa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20720>>3]=0.0;i=i;return}function vpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20712>>3]=0.0;i=i;return}function wpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20704>>3]=0.0;i=i;return}function xpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20696>>3]=0.0;i=i;return}function ypa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20688>>3]=0.0;i=i;return}function zpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20680>>3]=0.0;i=i;return}function Apa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20672>>3]=0.0;i=i;return}function Bpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20664>>3]=0.0;i=i;return}function Cpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20656>>3]=0.0;i=i;return}function Dpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20648>>3]=0.0;i=i;return}function Epa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20640>>3]=1.0;i=i;return}function Fpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20632>>3]=0.0;i=i;return}function Gpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20624>>3]=0.0;i=i;return}function Hpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20616>>3]=0.0;i=i;return}function Ipa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1112>>2]=255;i=i;return}function Jpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1108>>2]=128;i=i;return}function Kpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1104>>2]=0;i=i;return}function Lpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1100>>2]=155;i=i;return}function Mpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1096>>2]=155;i=i;return}function Npa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1092>>2]=155;i=i;return}function Opa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1088>>2]=0;i=i;return}function Ppa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1084>>2]=0;i=i;return}function Qpa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1080>>2]=255;i=i;return}function Rpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20592>>3]=255.0;i=i;return}function Spa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20600>>3]=0.0;i=i;return}function Tpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20608>>3]=0.0;i=i;return}function Upa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20584>>3]=0.0;i=i;return}function Vpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20576>>3]=1.0;i=i;return}function Wpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20568>>3]=0.0;i=i;return}function Xpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20560>>3]=0.0;i=i;return}function Ypa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20552>>3]=0.0;i=i;return}function Zpa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20544>>3]=1.0;i=i;return}function _pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20536>>3]=0.0;i=i;return}function $pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20528>>3]=0.0;i=i;return}function aqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20520>>3]=+h[(c[a+416>>2]|0)+44856>>3]*-.5;i=i;return}function bqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1076>>2]=0;i=i;return}function cqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1072>>2]=0;i=i;return}function dqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1068>>2]=255;i=i;return}function eqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20496>>3]=255.0;i=i;return}function fqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20504>>3]=0.0;i=i;return}function gqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20512>>3]=0.0;i=i;return}function hqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20488>>3]=0.0;i=i;return}function iqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20480>>3]=1.0;i=i;return}function jqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20472>>3]=0.0;i=i;return}function kqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20464>>3]=0.0;i=i;return}function lqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20456>>3]=0.0;i=i;return}function mqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20448>>3]=1.0;i=i;return}function nqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20440>>3]=0.0;i=i;return}function oqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20432>>3]=0.0;i=i;return}function pqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20424>>3]=+h[(c[a+416>>2]|0)+44840>>3]*-.5;i=i;return}function qqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1064>>2]=0;i=i;return}function rqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1060>>2]=0;i=i;return}function sqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1056>>2]=255;i=i;return}function tqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20400>>3]=255.0;i=i;return}function uqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20408>>3]=0.0;i=i;return}function vqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20416>>3]=0.0;i=i;return}function wqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20392>>3]=0.0;i=i;return}function xqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20384>>3]=1.0;i=i;return}function yqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20376>>3]=0.0;i=i;return}function zqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20368>>3]=0.0;i=i;return}function Aqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20360>>3]=-1.0;i=i;return}function Bqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20352>>3]=0.0;i=i;return}function Cqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20344>>3]=0.0;i=i;return}function Dqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20336>>3]=0.0;i=i;return}function Eqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20328>>3]=0.0;i=i;return}function Fqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1052>>2]=155;i=i;return}function Gqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1048>>2]=155;i=i;return}function Hqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1044>>2]=155;i=i;return}function Iqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1040>>2]=155;i=i;return}function Jqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1036>>2]=155;i=i;return}function Kqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1032>>2]=155;i=i;return}function Lqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1028>>2]=155;i=i;return}function Mqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1024>>2]=155;i=i;return}function Nqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1020>>2]=155;i=i;return}function Oqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1016>>2]=155;i=i;return}function Pqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1012>>2]=155;i=i;return}function Qqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1008>>2]=155;i=i;return}function Rqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1004>>2]=180;i=i;return}function Sqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+1e3>>2]=180;i=i;return}function Tqa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+996>>2]=180;i=i;return}function Uqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20304>>3]=180.0;i=i;return}function Vqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20312>>3]=180.0;i=i;return}function Wqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20320>>3]=180.0;i=i;return}function Xqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20296>>3]=0.0;i=i;return}function Yqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20288>>3]=1.0;i=i;return}function Zqa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20280>>3]=0.0;i=i;return}function _qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20272>>3]=0.0;i=i;return}function $qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20264>>3]=0.0;i=i;return}function ara(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20256>>3]=.11;i=i;return}function bra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20248>>3]=0.0;i=i;return}function cra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20240>>3]=0.0;i=i;return}function dra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20232>>3]=0.0;i=i;return}function era(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20224>>3]=0.0;i=i;return}function fra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20216>>3]=0.0;i=i;return}function gra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20208>>3]=0.0;i=i;return}function hra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20200>>3]=0.0;i=i;return}function ira(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20192>>3]=0.0;i=i;return}function jra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20184>>3]=0.0;i=i;return}function kra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20176>>3]=1.0;i=i;return}function lra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20168>>3]=0.0;i=i;return}function mra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20160>>3]=0.0;i=i;return}function nra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20152>>3]=0.0;i=i;return}function ora(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+992>>2]=255;i=i;return}function pra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+988>>2]=128;i=i;return}function qra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+984>>2]=0;i=i;return}function rra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+980>>2]=180;i=i;return}function sra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+976>>2]=180;i=i;return}function tra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+972>>2]=180;i=i;return}function ura(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20128>>3]=180.0;i=i;return}function vra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20136>>3]=180.0;i=i;return}function wra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20144>>3]=180.0;i=i;return}function xra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20120>>3]=0.0;i=i;return}function yra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20112>>3]=1.0;i=i;return}function zra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20104>>3]=0.0;i=i;return}function Ara(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20096>>3]=0.0;i=i;return}function Bra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20088>>3]=0.0;i=i;return}function Cra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20080>>3]=.11;i=i;return}function Dra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20072>>3]=0.0;i=i;return}function Era(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20064>>3]=0.0;i=i;return}function Fra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20056>>3]=0.0;i=i;return}function Gra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20048>>3]=0.0;i=i;return}function Hra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20040>>3]=0.0;i=i;return}function Ira(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20032>>3]=0.0;i=i;return}function Jra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20024>>3]=0.0;i=i;return}function Kra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20016>>3]=0.0;i=i;return}function Lra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+20008>>3]=0.0;i=i;return}function Mra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+2e4>>3]=1.0;i=i;return}function Nra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19992>>3]=0.0;i=i;return}function Ora(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19984>>3]=0.0;i=i;return}function Pra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19976>>3]=0.0;i=i;return}function Qra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+968>>2]=255;i=i;return}function Rra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+964>>2]=128;i=i;return}function Sra(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+960>>2]=0;i=i;return}function Tra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19968>>3]=0.0;i=i;return}function Ura(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19960>>3]=0.0;i=i;return}function Vra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19952>>3]=0.0;i=i;return}function Wra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19944>>3]=0.0;i=i;return}function Xra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19936>>3]=0.0;i=i;return}function Yra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19928>>3]=0.0;i=i;return}function Zra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19920>>3]=0.0;i=i;return}function _ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19912>>3]=0.0;i=i;return}function $ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19904>>3]=0.0;i=i;return}function asa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19896>>3]=1.0;i=i;return}function bsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19888>>3]=0.0;i=i;return}function csa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19880>>3]=0.0;i=i;return}function dsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19872>>3]=0.0;i=i;return}function esa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+956>>2]=255;i=i;return}function fsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+952>>2]=128;i=i;return}function gsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+948>>2]=0;i=i;return}function hsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+944>>2]=255;i=i;return}function isa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+940>>2]=128;i=i;return}function jsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+936>>2]=0;i=i;return}function ksa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19848>>3]=0.0;i=i;return}function lsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19856>>3]=128.0;i=i;return}function msa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19864>>3]=255.0;i=i;return}function nsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19840>>3]=0.0;i=i;return}function osa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19832>>3]=0.0;i=i;return}function psa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19824>>3]=1.0;i=i;return}function qsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19816>>3]=0.0;i=i;return}function rsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19808>>3]=.1;i=i;return}function ssa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19800>>3]=0.0;i=i;return}function tsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19792>>3]=0.0;i=i;return}function usa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19784>>3]=0.0;i=i;return}function vsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19776>>3]=0.0;i=i;return}function wsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19768>>3]=0.0;i=i;return}function xsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19760>>3]=0.0;i=i;return}function ysa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19752>>3]=0.0;i=i;return}function zsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19744>>3]=0.0;i=i;return}function Asa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19736>>3]=0.0;i=i;return}function Bsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19728>>3]=0.0;i=i;return}function Csa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19720>>3]=1.0;i=i;return}function Dsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19712>>3]=0.0;i=i;return}function Esa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19704>>3]=0.0;i=i;return}function Fsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19696>>3]=0.0;i=i;return}function Gsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+932>>2]=255;i=i;return}function Hsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+928>>2]=128;i=i;return}function Isa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+924>>2]=0;i=i;return}function Jsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+920>>2]=255;i=i;return}function Ksa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+916>>2]=128;i=i;return}function Lsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+912>>2]=0;i=i;return}function Msa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19672>>3]=0.0;i=i;return}function Nsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19680>>3]=128.0;i=i;return}function Osa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19688>>3]=255.0;i=i;return}function Psa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19664>>3]=0.0;i=i;return}function Qsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19656>>3]=0.0;i=i;return}function Rsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19648>>3]=1.0;i=i;return}function Ssa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19640>>3]=0.0;i=i;return}function Tsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19632>>3]=-.1;i=i;return}function Usa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19624>>3]=0.0;i=i;return}function Vsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+908>>2]=155;i=i;return}function Wsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+904>>2]=155;i=i;return}function Xsa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+900>>2]=155;i=i;return}function Ysa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19616>>3]=0.0;i=i;return}function Zsa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19608>>3]=0.0;i=i;return}function _sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19600>>3]=0.0;i=i;return}function $sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19592>>3]=0.0;i=i;return}function ata(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19584>>3]=0.0;i=i;return}function bta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19576>>3]=0.0;i=i;return}function cta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19568>>3]=0.0;i=i;return}function dta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19560>>3]=0.0;i=i;return}function eta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19552>>3]=0.0;i=i;return}function fta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19544>>3]=1.0;i=i;return}function gta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19536>>3]=0.0;i=i;return}function hta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19528>>3]=0.0;i=i;return}function ita(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19520>>3]=0.0;i=i;return}function jta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+896>>2]=255;i=i;return}function kta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+892>>2]=128;i=i;return}function lta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+888>>2]=0;i=i;return}function mta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+884>>2]=200;i=i;return}function nta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+880>>2]=0;i=i;return}function ota(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+876>>2]=0;i=i;return}function pta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19496>>3]=0.0;i=i;return}function qta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19504>>3]=0.0;i=i;return}function rta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19512>>3]=200.0;i=i;return}function sta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19488>>3]=0.0;i=i;return}function tta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19480>>3]=0.0;i=i;return}function uta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19472>>3]=1.0;i=i;return}function vta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19464>>3]=0.0;i=i;return}function wta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19456>>3]=.22;i=i;return}function xta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19448>>3]=0.0;i=i;return}function yta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+872>>2]=180;i=i;return}function zta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+868>>2]=180;i=i;return}function Ata(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+864>>2]=180;i=i;return}function Bta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19424>>3]=180.0;i=i;return}function Cta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19432>>3]=180.0;i=i;return}function Dta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19440>>3]=180.0;i=i;return}function Eta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19416>>3]=0.0;i=i;return}function Fta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19408>>3]=1.0;i=i;return}function Gta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19400>>3]=0.0;i=i;return}function Hta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19392>>3]=0.0;i=i;return}function Ita(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19384>>3]=.1;i=i;return}function Jta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19376>>3]=0.0;i=i;return}function Kta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19368>>3]=0.0;i=i;return}function Lta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19360>>3]=0.0;i=i;return}function Mta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19352>>3]=0.0;i=i;return}function Nta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19344>>3]=0.0;i=i;return}function Ota(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19336>>3]=0.0;i=i;return}function Pta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19328>>3]=0.0;i=i;return}function Qta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19320>>3]=0.0;i=i;return}function Rta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19312>>3]=0.0;i=i;return}function Sta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19304>>3]=0.0;i=i;return}function Tta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19296>>3]=1.0;i=i;return}function Uta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19288>>3]=0.0;i=i;return}function Vta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19280>>3]=0.0;i=i;return}function Wta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19272>>3]=0.0;i=i;return}function Xta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+860>>2]=255;i=i;return}function Yta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+856>>2]=128;i=i;return}function Zta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+852>>2]=0;i=i;return}function _ta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+848>>2]=155;i=i;return}function $ta(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+844>>2]=155;i=i;return}function aua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+840>>2]=155;i=i;return}function bua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+836>>2]=0;i=i;return}function cua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+832>>2]=0;i=i;return}function dua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+828>>2]=255;i=i;return}function eua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19248>>3]=255.0;i=i;return}function fua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19256>>3]=0.0;i=i;return}function gua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19264>>3]=0.0;i=i;return}function hua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19240>>3]=0.0;i=i;return}function iua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19232>>3]=1.0;i=i;return}function jua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19224>>3]=0.0;i=i;return}function kua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19216>>3]=0.0;i=i;return}function lua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19208>>3]=0.0;i=i;return}function mua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19200>>3]=1.0;i=i;return}function nua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19192>>3]=0.0;i=i;return}function oua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19184>>3]=0.0;i=i;return}function pua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19176>>3]=+h[(c[a+416>>2]|0)+43376>>3]*-.5;i=i;return}function qua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+824>>2]=0;i=i;return}function rua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+820>>2]=0;i=i;return}function sua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+816>>2]=255;i=i;return}function tua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19152>>3]=255.0;i=i;return}function uua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19160>>3]=0.0;i=i;return}function vua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19168>>3]=0.0;i=i;return}function wua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19144>>3]=0.0;i=i;return}function xua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19136>>3]=1.0;i=i;return}function yua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19128>>3]=0.0;i=i;return}function zua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19120>>3]=0.0;i=i;return}function Aua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19112>>3]=0.0;i=i;return}function Bua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19104>>3]=1.0;i=i;return}function Cua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19096>>3]=0.0;i=i;return}function Dua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19088>>3]=0.0;i=i;return}function Eua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19080>>3]=+h[(c[a+416>>2]|0)+43360>>3]*-.5;i=i;return}function Fua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+812>>2]=0;i=i;return}function Gua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+808>>2]=0;i=i;return}function Hua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+804>>2]=255;i=i;return}function Iua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19056>>3]=255.0;i=i;return}function Jua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19064>>3]=0.0;i=i;return}function Kua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19072>>3]=0.0;i=i;return}function Lua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19048>>3]=0.0;i=i;return}function Mua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19040>>3]=1.0;i=i;return}function Nua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19032>>3]=0.0;i=i;return}function Oua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19024>>3]=0.0;i=i;return}function Pua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19016>>3]=-1.0;i=i;return}function Qua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19008>>3]=0.0;i=i;return}function Rua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+19e3>>3]=0.0;i=i;return}function Sua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18992>>3]=0.0;i=i;return}function Tua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18984>>3]=0.0;i=i;return}function Uua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+800>>2]=155;i=i;return}function Vua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+796>>2]=155;i=i;return}function Wua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+792>>2]=155;i=i;return}function Xua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+788>>2]=155;i=i;return}function Yua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+784>>2]=155;i=i;return}function Zua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+780>>2]=155;i=i;return}function _ua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+776>>2]=155;i=i;return}function $ua(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+772>>2]=155;i=i;return}function ava(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+768>>2]=155;i=i;return}function bva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+764>>2]=155;i=i;return}function cva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+760>>2]=155;i=i;return}function dva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+756>>2]=155;i=i;return}function eva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+752>>2]=180;i=i;return}function fva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+748>>2]=180;i=i;return}function gva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+744>>2]=180;i=i;return}function hva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18960>>3]=180.0;i=i;return}function iva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18968>>3]=180.0;i=i;return}function jva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18976>>3]=180.0;i=i;return}function kva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18952>>3]=0.0;i=i;return}function lva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18944>>3]=1.0;i=i;return}function mva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18936>>3]=0.0;i=i;return}function nva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18928>>3]=0.0;i=i;return}function ova(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18920>>3]=0.0;i=i;return}function pva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18912>>3]=.11;i=i;return}function qva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18904>>3]=0.0;i=i;return}function rva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18896>>3]=0.0;i=i;return}function sva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18888>>3]=0.0;i=i;return}function tva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18880>>3]=0.0;i=i;return}function uva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18872>>3]=0.0;i=i;return}function vva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18864>>3]=0.0;i=i;return}function wva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18856>>3]=0.0;i=i;return}function xva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18848>>3]=0.0;i=i;return}function yva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18840>>3]=0.0;i=i;return}function zva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18832>>3]=1.0;i=i;return}function Ava(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18824>>3]=0.0;i=i;return}function Bva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18816>>3]=0.0;i=i;return}function Cva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18808>>3]=0.0;i=i;return}function Dva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+740>>2]=255;i=i;return}function Eva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+736>>2]=128;i=i;return}function Fva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+732>>2]=0;i=i;return}function Gva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+728>>2]=180;i=i;return}function Hva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+724>>2]=180;i=i;return}function Iva(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+720>>2]=180;i=i;return}function Jva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18784>>3]=180.0;i=i;return}function Kva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18792>>3]=180.0;i=i;return}function Lva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18800>>3]=180.0;i=i;return}function Mva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18776>>3]=0.0;i=i;return}function Nva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18768>>3]=1.0;i=i;return}function Ova(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18760>>3]=0.0;i=i;return}function Pva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18752>>3]=0.0;i=i;return}function Qva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18744>>3]=0.0;i=i;return}function Rva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18736>>3]=.11;i=i;return}function Sva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18728>>3]=0.0;i=i;return}function Tva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18720>>3]=0.0;i=i;return}function Uva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18712>>3]=0.0;i=i;return}function Vva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18704>>3]=0.0;i=i;return}function Wva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18696>>3]=0.0;i=i;return}function Xva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18688>>3]=0.0;i=i;return}function Yva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18680>>3]=0.0;i=i;return}function Zva(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18672>>3]=0.0;i=i;return}function _va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18664>>3]=0.0;i=i;return}function $va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18656>>3]=1.0;i=i;return}function awa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18648>>3]=0.0;i=i;return}function bwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18640>>3]=0.0;i=i;return}function cwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18632>>3]=0.0;i=i;return}function dwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+716>>2]=255;i=i;return}function ewa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+712>>2]=128;i=i;return}function fwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+708>>2]=0;i=i;return}function gwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18624>>3]=0.0;i=i;return}function hwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18616>>3]=0.0;i=i;return}function iwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18608>>3]=0.0;i=i;return}function jwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18600>>3]=0.0;i=i;return}function kwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18592>>3]=0.0;i=i;return}function lwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18584>>3]=0.0;i=i;return}function mwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18576>>3]=0.0;i=i;return}function nwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18568>>3]=0.0;i=i;return}function owa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18560>>3]=0.0;i=i;return}function pwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18552>>3]=1.0;i=i;return}function qwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18544>>3]=0.0;i=i;return}function rwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18536>>3]=0.0;i=i;return}function swa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18528>>3]=0.0;i=i;return}function twa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+704>>2]=255;i=i;return}function uwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+700>>2]=128;i=i;return}function vwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+696>>2]=0;i=i;return}function wwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+692>>2]=255;i=i;return}function xwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+688>>2]=128;i=i;return}function ywa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+684>>2]=0;i=i;return}function zwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18504>>3]=0.0;i=i;return}function Awa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18512>>3]=128.0;i=i;return}function Bwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18520>>3]=255.0;i=i;return}function Cwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18496>>3]=0.0;i=i;return}function Dwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18488>>3]=0.0;i=i;return}function Ewa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18480>>3]=1.0;i=i;return}function Fwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18472>>3]=0.0;i=i;return}function Gwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18464>>3]=.1;i=i;return}function Hwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18456>>3]=0.0;i=i;return}function Iwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18448>>3]=0.0;i=i;return}function Jwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18440>>3]=0.0;i=i;return}function Kwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18432>>3]=0.0;i=i;return}function Lwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18424>>3]=0.0;i=i;return}function Mwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18416>>3]=0.0;i=i;return}function Nwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18408>>3]=0.0;i=i;return}function Owa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18400>>3]=0.0;i=i;return}function Pwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18392>>3]=0.0;i=i;return}function Qwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18384>>3]=0.0;i=i;return}function Rwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18376>>3]=1.0;i=i;return}function Swa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18368>>3]=0.0;i=i;return}function Twa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18360>>3]=0.0;i=i;return}function Uwa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18352>>3]=0.0;i=i;return}function Vwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+680>>2]=255;i=i;return}function Wwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+676>>2]=128;i=i;return}function Xwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+672>>2]=0;i=i;return}function Ywa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+668>>2]=255;i=i;return}function Zwa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+664>>2]=128;i=i;return}function _wa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+660>>2]=0;i=i;return}function $wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18328>>3]=0.0;i=i;return}function axa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18336>>3]=128.0;i=i;return}function bxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18344>>3]=255.0;i=i;return}function cxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18320>>3]=0.0;i=i;return}function dxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18312>>3]=0.0;i=i;return}function exa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18304>>3]=1.0;i=i;return}function fxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18296>>3]=0.0;i=i;return}function gxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18288>>3]=-.1;i=i;return}function hxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18280>>3]=0.0;i=i;return}function ixa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+656>>2]=155;i=i;return}function jxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+652>>2]=155;i=i;return}function kxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+648>>2]=155;i=i;return}function lxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18272>>3]=0.0;i=i;return}function mxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18264>>3]=0.0;i=i;return}function nxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18256>>3]=0.0;i=i;return}function oxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18248>>3]=0.0;i=i;return}function pxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18240>>3]=0.0;i=i;return}function qxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18232>>3]=0.0;i=i;return}function rxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18224>>3]=0.0;i=i;return}function sxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18216>>3]=0.0;i=i;return}function txa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18208>>3]=0.0;i=i;return}function uxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18200>>3]=1.0;i=i;return}function vxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18192>>3]=0.0;i=i;return}function wxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18184>>3]=0.0;i=i;return}function xxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18176>>3]=0.0;i=i;return}function yxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+644>>2]=255;i=i;return}function zxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+640>>2]=128;i=i;return}function Axa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+636>>2]=0;i=i;return}function Bxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+632>>2]=200;i=i;return}function Cxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+628>>2]=0;i=i;return}function Dxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+624>>2]=0;i=i;return}function Exa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18152>>3]=0.0;i=i;return}function Fxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18160>>3]=0.0;i=i;return}function Gxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18168>>3]=200.0;i=i;return}function Hxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18144>>3]=0.0;i=i;return}function Ixa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18136>>3]=0.0;i=i;return}function Jxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18128>>3]=1.0;i=i;return}function Kxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18120>>3]=0.0;i=i;return}function Lxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18112>>3]=.22;i=i;return}function Mxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18104>>3]=0.0;i=i;return}function Nxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+620>>2]=180;i=i;return}function Oxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+616>>2]=180;i=i;return}function Pxa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+612>>2]=180;i=i;return}function Qxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18080>>3]=180.0;i=i;return}function Rxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18088>>3]=180.0;i=i;return}function Sxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18096>>3]=180.0;i=i;return}function Txa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18072>>3]=0.0;i=i;return}function Uxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18064>>3]=1.0;i=i;return}function Vxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18056>>3]=0.0;i=i;return}function Wxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18048>>3]=0.0;i=i;return}function Xxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18040>>3]=.1;i=i;return}function Yxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18032>>3]=0.0;i=i;return}function Zxa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18024>>3]=0.0;i=i;return}function _xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18016>>3]=0.0;i=i;return}function $xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18008>>3]=0.0;i=i;return}function aya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+18e3>>3]=0.0;i=i;return}function bya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17992>>3]=0.0;i=i;return}function cya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17984>>3]=0.0;i=i;return}function dya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17976>>3]=0.0;i=i;return}function eya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17968>>3]=0.0;i=i;return}function fya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17960>>3]=0.0;i=i;return}function gya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17952>>3]=1.0;i=i;return}function hya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17944>>3]=0.0;i=i;return}function iya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17936>>3]=0.0;i=i;return}function jya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17928>>3]=0.0;i=i;return}function kya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+608>>2]=255;i=i;return}function lya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+604>>2]=128;i=i;return}function mya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+600>>2]=0;i=i;return}function nya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+596>>2]=155;i=i;return}function oya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+592>>2]=155;i=i;return}function pya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+588>>2]=155;i=i;return}function qya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+584>>2]=0;i=i;return}function rya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+580>>2]=0;i=i;return}function sya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+576>>2]=255;i=i;return}function tya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17904>>3]=255.0;i=i;return}function uya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17912>>3]=0.0;i=i;return}function vya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17920>>3]=0.0;i=i;return}function wya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17896>>3]=0.0;i=i;return}function xya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17888>>3]=1.0;i=i;return}function yya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17880>>3]=0.0;i=i;return}function zya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17872>>3]=0.0;i=i;return}function Aya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17864>>3]=0.0;i=i;return}function Bya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17856>>3]=1.0;i=i;return}function Cya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17848>>3]=0.0;i=i;return}function Dya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17840>>3]=0.0;i=i;return}function Eya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17832>>3]=+h[(c[a+416>>2]|0)+41896>>3]*-.5;i=i;return}function Fya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+572>>2]=0;i=i;return}function Gya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+568>>2]=0;i=i;return}function Hya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+564>>2]=255;i=i;return}function Iya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17808>>3]=255.0;i=i;return}function Jya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17816>>3]=0.0;i=i;return}function Kya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17824>>3]=0.0;i=i;return}function Lya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17800>>3]=0.0;i=i;return}function Mya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17792>>3]=1.0;i=i;return}function Nya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17784>>3]=0.0;i=i;return}function Oya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17776>>3]=0.0;i=i;return}function Pya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17768>>3]=0.0;i=i;return}function Qya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17760>>3]=1.0;i=i;return}function Rya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17752>>3]=0.0;i=i;return}function Sya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17744>>3]=0.0;i=i;return}function Tya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17736>>3]=+h[(c[a+416>>2]|0)+41880>>3]*-.5;i=i;return}function Uya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+560>>2]=0;i=i;return}function Vya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+556>>2]=0;i=i;return}function Wya(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+552>>2]=255;i=i;return}function Xya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17712>>3]=255.0;i=i;return}function Yya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17720>>3]=0.0;i=i;return}function Zya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17728>>3]=0.0;i=i;return}function _ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17704>>3]=0.0;i=i;return}function $ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17696>>3]=1.0;i=i;return}function aza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17688>>3]=0.0;i=i;return}function bza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17680>>3]=0.0;i=i;return}function cza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17672>>3]=-1.0;i=i;return}function dza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17664>>3]=0.0;i=i;return}function eza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17656>>3]=0.0;i=i;return}function fza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17648>>3]=0.0;i=i;return}function gza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17640>>3]=0.0;i=i;return}function hza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+548>>2]=155;i=i;return}function iza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+544>>2]=155;i=i;return}function jza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+540>>2]=155;i=i;return}function kza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+536>>2]=155;i=i;return}function lza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+532>>2]=155;i=i;return}function mza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+528>>2]=155;i=i;return}function nza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+524>>2]=155;i=i;return}function oza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+520>>2]=155;i=i;return}function pza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+516>>2]=155;i=i;return}function qza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+512>>2]=155;i=i;return}function rza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+508>>2]=155;i=i;return}function sza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+504>>2]=155;i=i;return}function tza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+500>>2]=180;i=i;return}function uza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+496>>2]=180;i=i;return}function vza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+492>>2]=180;i=i;return}function wza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17616>>3]=180.0;i=i;return}function xza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17624>>3]=180.0;i=i;return}function yza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17632>>3]=180.0;i=i;return}function zza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17608>>3]=0.0;i=i;return}function Aza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17600>>3]=1.0;i=i;return}function Bza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17592>>3]=0.0;i=i;return}function Cza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17584>>3]=0.0;i=i;return}function Dza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17576>>3]=0.0;i=i;return}function Eza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17568>>3]=.11;i=i;return}function Fza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17560>>3]=0.0;i=i;return}function Gza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17552>>3]=0.0;i=i;return}function Hza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17544>>3]=0.0;i=i;return}function Iza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17536>>3]=0.0;i=i;return}function Jza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17528>>3]=0.0;i=i;return}function Kza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17520>>3]=0.0;i=i;return}function Lza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17512>>3]=0.0;i=i;return}function Mza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17504>>3]=0.0;i=i;return}function Nza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17496>>3]=0.0;i=i;return}function Oza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17488>>3]=1.0;i=i;return}function Pza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17480>>3]=0.0;i=i;return}function Qza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17472>>3]=0.0;i=i;return}function Rza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17464>>3]=0.0;i=i;return}function Sza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+488>>2]=255;i=i;return}function Tza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+484>>2]=128;i=i;return}function Uza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+480>>2]=0;i=i;return}function Vza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+476>>2]=180;i=i;return}function Wza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+472>>2]=180;i=i;return}function Xza(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+468>>2]=180;i=i;return}function Yza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17440>>3]=180.0;i=i;return}function Zza(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17448>>3]=180.0;i=i;return}function _za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17456>>3]=180.0;i=i;return}function $za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17432>>3]=0.0;i=i;return}function aAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17424>>3]=1.0;i=i;return}function bAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17416>>3]=0.0;i=i;return}function cAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17408>>3]=0.0;i=i;return}function dAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17400>>3]=0.0;i=i;return}function eAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17392>>3]=.11;i=i;return}function fAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17384>>3]=0.0;i=i;return}function gAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17376>>3]=0.0;i=i;return}function hAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17368>>3]=0.0;i=i;return}function iAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17360>>3]=0.0;i=i;return}function jAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17352>>3]=0.0;i=i;return}function kAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17344>>3]=0.0;i=i;return}function lAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17336>>3]=0.0;i=i;return}function mAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17328>>3]=0.0;i=i;return}function nAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17320>>3]=0.0;i=i;return}function oAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17312>>3]=1.0;i=i;return}function pAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17304>>3]=0.0;i=i;return}function qAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17296>>3]=0.0;i=i;return}function rAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17288>>3]=0.0;i=i;return}function sAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+464>>2]=255;i=i;return}function tAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+460>>2]=128;i=i;return}function uAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+456>>2]=0;i=i;return}function vAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17280>>3]=0.0;i=i;return}function wAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17272>>3]=0.0;i=i;return}function xAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17264>>3]=0.0;i=i;return}function yAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17256>>3]=0.0;i=i;return}function zAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17248>>3]=0.0;i=i;return}function AAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17240>>3]=0.0;i=i;return}function BAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17232>>3]=0.0;i=i;return}function CAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17224>>3]=0.0;i=i;return}function DAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17216>>3]=0.0;i=i;return}function EAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17208>>3]=1.0;i=i;return}function FAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17200>>3]=0.0;i=i;return}function GAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17192>>3]=0.0;i=i;return}function HAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17184>>3]=0.0;i=i;return}function IAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+452>>2]=255;i=i;return}function JAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+448>>2]=128;i=i;return}function KAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+444>>2]=0;i=i;return}function LAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+440>>2]=255;i=i;return}function MAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+436>>2]=128;i=i;return}function NAa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+432>>2]=0;i=i;return}function OAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17160>>3]=0.0;i=i;return}function PAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17168>>3]=128.0;i=i;return}function QAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17176>>3]=255.0;i=i;return}function RAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17152>>3]=0.0;i=i;return}function SAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17144>>3]=0.0;i=i;return}function TAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17136>>3]=1.0;i=i;return}function UAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17128>>3]=0.0;i=i;return}function VAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17120>>3]=.1;i=i;return}function WAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17112>>3]=0.0;i=i;return}function XAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17104>>3]=0.0;i=i;return}function YAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17096>>3]=0.0;i=i;return}function ZAa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17088>>3]=0.0;i=i;return}function _Aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17080>>3]=0.0;i=i;return}function $Aa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17072>>3]=0.0;i=i;return}function aBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17064>>3]=0.0;i=i;return}function bBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17056>>3]=0.0;i=i;return}function cBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17048>>3]=0.0;i=i;return}function dBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17040>>3]=0.0;i=i;return}function eBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17032>>3]=1.0;i=i;return}function fBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17024>>3]=0.0;i=i;return}function gBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17016>>3]=0.0;i=i;return}function hBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17008>>3]=0.0;i=i;return}function iBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+428>>2]=255;i=i;return}function jBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+424>>2]=128;i=i;return}function kBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+420>>2]=0;i=i;return}function lBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+416>>2]=255;i=i;return}function mBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+412>>2]=128;i=i;return}function nBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+408>>2]=0;i=i;return}function oBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16984>>3]=0.0;i=i;return}function pBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16992>>3]=128.0;i=i;return}function qBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17e3>>3]=255.0;i=i;return}function rBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16976>>3]=0.0;i=i;return}function sBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16968>>3]=0.0;i=i;return}function tBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16960>>3]=1.0;i=i;return}function uBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16952>>3]=0.0;i=i;return}function vBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16944>>3]=-.1;i=i;return}function wBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16936>>3]=0.0;i=i;return}function xBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+404>>2]=155;i=i;return}function yBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+400>>2]=155;i=i;return}function zBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+396>>2]=155;i=i;return}function ABa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16928>>3]=0.0;i=i;return}function BBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16920>>3]=0.0;i=i;return}function CBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16912>>3]=0.0;i=i;return}function DBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16904>>3]=0.0;i=i;return}function EBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16896>>3]=0.0;i=i;return}function FBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16888>>3]=0.0;i=i;return}function GBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16880>>3]=0.0;i=i;return}function HBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16872>>3]=0.0;i=i;return}function IBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16864>>3]=0.0;i=i;return}function JBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16856>>3]=1.0;i=i;return}function KBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16848>>3]=0.0;i=i;return}function LBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16840>>3]=0.0;i=i;return}function MBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16832>>3]=0.0;i=i;return}function NBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=255;i=i;return}function OBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+388>>2]=128;i=i;return}function PBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=0;i=i;return}function QBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+380>>2]=200;i=i;return}function RBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+376>>2]=0;i=i;return}function SBa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+372>>2]=0;i=i;return}function TBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16808>>3]=0.0;i=i;return}function UBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16816>>3]=0.0;i=i;return}function VBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16824>>3]=200.0;i=i;return}function WBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16800>>3]=0.0;i=i;return}function XBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16792>>3]=0.0;i=i;return}function YBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16784>>3]=1.0;i=i;return}function ZBa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16776>>3]=0.0;i=i;return}function _Ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16768>>3]=.22;i=i;return}function $Ba(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16760>>3]=0.0;i=i;return}function aCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=180;i=i;return}function bCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+364>>2]=180;i=i;return}function cCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+360>>2]=180;i=i;return}function dCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16736>>3]=180.0;i=i;return}function eCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16744>>3]=180.0;i=i;return}function fCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16752>>3]=180.0;i=i;return}function gCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16728>>3]=0.0;i=i;return}function hCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16720>>3]=1.0;i=i;return}function iCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16712>>3]=0.0;i=i;return}function jCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16704>>3]=0.0;i=i;return}function kCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16696>>3]=.1;i=i;return}function lCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16688>>3]=0.0;i=i;return}function mCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16680>>3]=0.0;i=i;return}function nCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16672>>3]=0.0;i=i;return}function oCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16664>>3]=0.0;i=i;return}function pCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16656>>3]=0.0;i=i;return}function qCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16648>>3]=0.0;i=i;return}function rCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16640>>3]=0.0;i=i;return}function sCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16632>>3]=0.0;i=i;return}function tCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16624>>3]=0.0;i=i;return}function uCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16616>>3]=0.0;i=i;return}function vCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16608>>3]=1.0;i=i;return}function wCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16600>>3]=0.0;i=i;return}function xCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16592>>3]=0.0;i=i;return}function yCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16584>>3]=0.0;i=i;return}function zCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+356>>2]=255;i=i;return}function ACa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=128;i=i;return}function BCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+348>>2]=0;i=i;return}function CCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=155;i=i;return}function DCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+340>>2]=155;i=i;return}function ECa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+336>>2]=155;i=i;return}function FCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+332>>2]=0;i=i;return}function GCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=0;i=i;return}function HCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+324>>2]=255;i=i;return}function ICa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16560>>3]=255.0;i=i;return}function JCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16568>>3]=0.0;i=i;return}function KCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16576>>3]=0.0;i=i;return}function LCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16552>>3]=0.0;i=i;return}function MCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16544>>3]=1.0;i=i;return}function NCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16536>>3]=0.0;i=i;return}function OCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16528>>3]=0.0;i=i;return}function PCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16520>>3]=0.0;i=i;return}function QCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16512>>3]=1.0;i=i;return}function RCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16504>>3]=0.0;i=i;return}function SCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16496>>3]=0.0;i=i;return}function TCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16488>>3]=+h[(c[a+416>>2]|0)+40416>>3]*-.5;i=i;return}function UCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+320>>2]=0;i=i;return}function VCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+316>>2]=0;i=i;return}function WCa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=255;i=i;return}function XCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16464>>3]=255.0;i=i;return}function YCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16472>>3]=0.0;i=i;return}function ZCa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16480>>3]=0.0;i=i;return}function _Ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16456>>3]=0.0;i=i;return}function $Ca(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16448>>3]=1.0;i=i;return}function aDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16440>>3]=0.0;i=i;return}function bDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16432>>3]=0.0;i=i;return}function cDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16424>>3]=0.0;i=i;return}function dDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16416>>3]=1.0;i=i;return}function eDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16408>>3]=0.0;i=i;return}function fDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16400>>3]=0.0;i=i;return}function gDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16392>>3]=+h[(c[a+416>>2]|0)+40400>>3]*-.5;i=i;return}function hDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+308>>2]=0;i=i;return}function iDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=0;i=i;return}function jDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=255;i=i;return}function kDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16368>>3]=255.0;i=i;return}function lDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16376>>3]=0.0;i=i;return}function mDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16384>>3]=0.0;i=i;return}function nDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16360>>3]=0.0;i=i;return}function oDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16352>>3]=1.0;i=i;return}function pDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16344>>3]=0.0;i=i;return}function qDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16336>>3]=0.0;i=i;return}function rDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16328>>3]=-1.0;i=i;return}function sDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16320>>3]=0.0;i=i;return}function tDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16312>>3]=0.0;i=i;return}function uDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16304>>3]=0.0;i=i;return}function vDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16296>>3]=0.0;i=i;return}function wDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=155;i=i;return}function xDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=155;i=i;return}function yDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=155;i=i;return}function zDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=155;i=i;return}function ADa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=155;i=i;return}function BDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=155;i=i;return}function CDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=155;i=i;return}function DDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=155;i=i;return}function EDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=155;i=i;return}function FDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=155;i=i;return}function GDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=155;i=i;return}function HDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=155;i=i;return}function IDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=180;i=i;return}function JDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=180;i=i;return}function KDa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=180;i=i;return}function LDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16272>>3]=180.0;i=i;return}function MDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16280>>3]=180.0;i=i;return}function NDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16288>>3]=180.0;i=i;return}function ODa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16264>>3]=0.0;i=i;return}function PDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16256>>3]=1.0;i=i;return}function QDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16248>>3]=0.0;i=i;return}function RDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16240>>3]=0.0;i=i;return}function SDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16232>>3]=0.0;i=i;return}function TDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16224>>3]=.11;i=i;return}function UDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16216>>3]=0.0;i=i;return}function VDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16208>>3]=0.0;i=i;return}function WDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16200>>3]=0.0;i=i;return}function XDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16192>>3]=0.0;i=i;return}function YDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16184>>3]=0.0;i=i;return}function ZDa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16176>>3]=0.0;i=i;return}function _Da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16168>>3]=0.0;i=i;return}function $Da(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16160>>3]=0.0;i=i;return}function aEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16152>>3]=0.0;i=i;return}function bEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16144>>3]=1.0;i=i;return}function cEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16136>>3]=0.0;i=i;return}function dEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16128>>3]=0.0;i=i;return}function eEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16120>>3]=0.0;i=i;return}function fEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=255;i=i;return}function gEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=128;i=i;return}function hEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=0;i=i;return}function iEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=180;i=i;return}function jEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=180;i=i;return}function kEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=180;i=i;return}function lEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16096>>3]=180.0;i=i;return}function mEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16104>>3]=180.0;i=i;return}function nEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16112>>3]=180.0;i=i;return}function oEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16088>>3]=0.0;i=i;return}function pEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16080>>3]=1.0;i=i;return}function qEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16072>>3]=0.0;i=i;return}function rEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16064>>3]=0.0;i=i;return}function sEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16056>>3]=0.0;i=i;return}function tEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16048>>3]=.11;i=i;return}function uEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16040>>3]=0.0;i=i;return}function vEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16032>>3]=0.0;i=i;return}function wEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16024>>3]=0.0;i=i;return}function xEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16016>>3]=0.0;i=i;return}function yEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16008>>3]=0.0;i=i;return}function zEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16e3>>3]=0.0;i=i;return}function AEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15992>>3]=0.0;i=i;return}function BEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15984>>3]=0.0;i=i;return}function CEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15976>>3]=0.0;i=i;return}function DEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15968>>3]=1.0;i=i;return}function EEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15960>>3]=0.0;i=i;return}function FEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15952>>3]=0.0;i=i;return}function GEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15944>>3]=0.0;i=i;return}function HEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=255;i=i;return}function IEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=128;i=i;return}function JEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=0;i=i;return}function KEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15936>>3]=0.0;i=i;return}function LEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15928>>3]=0.0;i=i;return}function MEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15920>>3]=0.0;i=i;return}function NEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15912>>3]=0.0;i=i;return}function OEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15904>>3]=0.0;i=i;return}function PEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15896>>3]=0.0;i=i;return}function QEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15888>>3]=0.0;i=i;return}function REa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15880>>3]=0.0;i=i;return}function SEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15872>>3]=0.0;i=i;return}function TEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15864>>3]=1.0;i=i;return}function UEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15856>>3]=0.0;i=i;return}function VEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15848>>3]=0.0;i=i;return}function WEa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15840>>3]=0.0;i=i;return}function XEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function YEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function ZEa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function _Ea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=255;i=i;return}function $Ea(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=128;i=i;return}function aFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=0;i=i;return}function bFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15816>>3]=0.0;i=i;return}function cFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15824>>3]=128.0;i=i;return}function dFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15832>>3]=255.0;i=i;return}function eFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15808>>3]=0.0;i=i;return}function fFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15800>>3]=0.0;i=i;return}function gFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15792>>3]=1.0;i=i;return}function hFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15784>>3]=0.0;i=i;return}function iFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15776>>3]=.1;i=i;return}function jFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15768>>3]=0.0;i=i;return}function kFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15760>>3]=0.0;i=i;return}function lFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15752>>3]=0.0;i=i;return}function mFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15744>>3]=0.0;i=i;return}function nFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15736>>3]=0.0;i=i;return}function oFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15728>>3]=0.0;i=i;return}function pFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15720>>3]=0.0;i=i;return}function qFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15712>>3]=0.0;i=i;return}function rFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15704>>3]=0.0;i=i;return}function sFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15696>>3]=0.0;i=i;return}function tFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15688>>3]=1.0;i=i;return}function uFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15680>>3]=0.0;i=i;return}function vFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15672>>3]=0.0;i=i;return}function wFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15664>>3]=0.0;i=i;return}function xFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=255;i=i;return}function yFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=128;i=i;return}function zFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=0;i=i;return}function AFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function BFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function CFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function DFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15640>>3]=0.0;i=i;return}function EFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15648>>3]=128.0;i=i;return}function FFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15656>>3]=255.0;i=i;return}function GFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15632>>3]=0.0;i=i;return}function HFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15624>>3]=0.0;i=i;return}function IFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15616>>3]=1.0;i=i;return}function JFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15608>>3]=0.0;i=i;return}function KFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15600>>3]=-.1;i=i;return}function LFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15592>>3]=0.0;i=i;return}function MFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function NFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function OFa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function PFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15584>>3]=0.0;i=i;return}function QFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15576>>3]=0.0;i=i;return}function RFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15568>>3]=0.0;i=i;return}function SFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15560>>3]=0.0;i=i;return}function TFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15552>>3]=0.0;i=i;return}function UFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15544>>3]=0.0;i=i;return}function VFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15536>>3]=0.0;i=i;return}function WFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15528>>3]=0.0;i=i;return}function XFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15520>>3]=0.0;i=i;return}function YFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15512>>3]=1.0;i=i;return}function ZFa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15504>>3]=0.0;i=i;return}function _Fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15496>>3]=0.0;i=i;return}function $Fa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15488>>3]=0.0;i=i;return}function aGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=255;i=i;return}function bGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=128;i=i;return}function cGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=0;i=i;return}function dGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=200;i=i;return}function eGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=0;i=i;return}function fGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function gGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15464>>3]=0.0;i=i;return}function hGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15472>>3]=0.0;i=i;return}function iGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15480>>3]=200.0;i=i;return}function jGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15456>>3]=0.0;i=i;return}function kGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15448>>3]=0.0;i=i;return}function lGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15440>>3]=1.0;i=i;return}function mGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15432>>3]=0.0;i=i;return}function nGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15424>>3]=.22;i=i;return}function oGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15416>>3]=0.0;i=i;return}function pGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=180;i=i;return}function qGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=180;i=i;return}function rGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=180;i=i;return}function sGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15392>>3]=180.0;i=i;return}function tGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15400>>3]=180.0;i=i;return}function uGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15408>>3]=180.0;i=i;return}function vGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15384>>3]=0.0;i=i;return}function wGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15376>>3]=1.0;i=i;return}function xGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15368>>3]=0.0;i=i;return}function yGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15360>>3]=0.0;i=i;return}function zGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15352>>3]=.1;i=i;return}function AGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15344>>3]=0.0;i=i;return}function BGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15336>>3]=0.0;i=i;return}function CGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15328>>3]=0.0;i=i;return}function DGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15320>>3]=0.0;i=i;return}function EGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15312>>3]=0.0;i=i;return}function FGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15304>>3]=0.0;i=i;return}function GGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15296>>3]=0.0;i=i;return}function HGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15288>>3]=0.0;i=i;return}function IGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15280>>3]=0.0;i=i;return}function JGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15272>>3]=0.0;i=i;return}function KGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15264>>3]=1.0;i=i;return}function LGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15256>>3]=0.0;i=i;return}function MGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15248>>3]=0.0;i=i;return}function NGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15240>>3]=0.0;i=i;return}function OGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=255;i=i;return}function PGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=128;i=i;return}function QGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=0;i=i;return}function RGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=155;i=i;return}function SGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=155;i=i;return}function TGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=155;i=i;return}function UGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=0;i=i;return}function VGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=0;i=i;return}function WGa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=255;i=i;return}function XGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15216>>3]=255.0;i=i;return}function YGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15224>>3]=0.0;i=i;return}function ZGa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15232>>3]=0.0;i=i;return}function _Ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15208>>3]=0.0;i=i;return}function $Ga(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15200>>3]=1.0;i=i;return}function aHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15192>>3]=0.0;i=i;return}function bHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15184>>3]=0.0;i=i;return}function cHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15176>>3]=0.0;i=i;return}function dHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15168>>3]=1.0;i=i;return}function eHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15160>>3]=0.0;i=i;return}function fHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15152>>3]=0.0;i=i;return}function gHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15144>>3]=+h[(c[a+416>>2]|0)+38936>>3]*-.5;i=i;return}function hHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=0;i=i;return}function iHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=0;i=i;return}function jHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=255;i=i;return}function kHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15120>>3]=255.0;i=i;return}function lHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15128>>3]=0.0;i=i;return}function mHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15136>>3]=0.0;i=i;return}function nHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15112>>3]=0.0;i=i;return}function oHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15104>>3]=1.0;i=i;return}function pHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15096>>3]=0.0;i=i;return}function qHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15088>>3]=0.0;i=i;return}function rHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15080>>3]=0.0;i=i;return}function sHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15072>>3]=1.0;i=i;return}function tHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15064>>3]=0.0;i=i;return}function uHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15056>>3]=0.0;i=i;return}function vHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15048>>3]=+h[(c[a+416>>2]|0)+38920>>3]*-.5;i=i;return}function wHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function xHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=0;i=i;return}function yHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=255;i=i;return}function zHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15024>>3]=255.0;i=i;return}function AHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15032>>3]=0.0;i=i;return}function BHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15040>>3]=0.0;i=i;return}function CHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15016>>3]=0.0;i=i;return}function DHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15008>>3]=1.0;i=i;return}function EHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15e3>>3]=0.0;i=i;return}function FHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14992>>3]=0.0;i=i;return}function GHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14984>>3]=-1.0;i=i;return}function HHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14976>>3]=0.0;i=i;return}function IHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14968>>3]=0.0;i=i;return}function JHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14960>>3]=0.0;i=i;return}function KHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14952>>3]=0.0;i=i;return}function LHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function MHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function NHa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function OHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14928>>3]=255.0;i=i;return}function PHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14936>>3]=0.0;i=i;return}function QHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14944>>3]=0.0;i=i;return}function RHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14920>>3]=0.0;i=i;return}function SHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14912>>3]=1.0;i=i;return}function THa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14904>>3]=0.0;i=i;return}function UHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14896>>3]=0.0;i=i;return}function VHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14888>>3]=0.0;i=i;return}function WHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14880>>3]=1.0;i=i;return}function XHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14872>>3]=0.0;i=i;return}function YHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14864>>3]=0.0;i=i;return}function ZHa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14856>>3]=+h[(c[a+416>>2]|0)+38568>>3]*-.5;i=i;return}function _Ha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function $Ha(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function aIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function bIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function cIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=230;i=i;return}function dIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function eIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function fIa(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function gIa(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function hIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26808>>3]=0.0;i=i;return}function iIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26800>>3]=0.0;i=i;return}function jIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26792>>3]=0.0;i=i;return}function kIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26784>>3]=0.0;i=i;return}function lIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26776>>3]=0.0;i=i;return}function mIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26768>>3]=0.0;i=i;return}function nIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26760>>3]=0.0;i=i;return}function oIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26752>>3]=0.0;i=i;return}function pIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26744>>3]=0.0;i=i;return}function qIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26736>>3]=0.0;i=i;return}function rIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26728>>3]=0.0;i=i;return}function sIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26720>>3]=0.0;i=i;return}function tIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26712>>3]=0.0;i=i;return}function uIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26704>>3]=0.0;i=i;return}function vIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26696>>3]=0.0;i=i;return}function wIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26688>>3]=0.0;i=i;return}function xIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26680>>3]=0.0;i=i;return}function yIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26672>>3]=0.0;i=i;return}function zIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26664>>3]=0.0;i=i;return}function AIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14344>>3]=0.0;i=i;return}function BIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14336>>3]=0.0;i=i;return}function CIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14328>>3]=0.0;i=i;return}function DIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14320>>3]=0.0;i=i;return}function EIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14312>>3]=0.0;i=i;return}function FIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14304>>3]=0.0;i=i;return}function GIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14296>>3]=0.0;i=i;return}function HIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14264>>3]=0.0;i=i;return}function IIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14288>>3]=0.0;i=i;return}function JIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14272>>3]=0.0;i=i;return}function KIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14280>>3]=0.0;i=i;return}function LIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14240>>3]=0.0;i=i;return}function MIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14232>>3]=0.0;i=i;return}function NIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14224>>3]=0.0;i=i;return}function OIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14200>>3]=0.0;i=i;return}function PIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14176>>3]=0.0;i=i;return}function QIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14152>>3]=0.0;i=i;return}function RIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14128>>3]=0.0;i=i;return}function SIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14104>>3]=0.0;i=i;return}function TIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14096>>3]=0.0;i=i;return}function UIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14072>>3]=0.0;i=i;return}function VIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14064>>3]=0.0;i=i;return}function WIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14056>>3]=0.0;i=i;return}function XIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14024>>3]=0.0;i=i;return}function YIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14016>>3]=0.0;i=i;return}function ZIa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13992>>3]=0.0;i=i;return}function _Ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13984>>3]=0.0;i=i;return}function $Ia(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13976>>3]=0.0;i=i;return}function aJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13968>>3]=0.0;i=i;return}function bJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13960>>3]=0.0;i=i;return}function cJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13896>>3]=0.0;i=i;return}function dJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13888>>3]=0.0;i=i;return}function eJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13880>>3]=0.0;i=i;return}function fJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13872>>3]=0.0;i=i;return}function gJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13864>>3]=0.0;i=i;return}function hJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13856>>3]=0.0;i=i;return}function iJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13848>>3]=0.0;i=i;return}function jJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13840>>3]=0.0;i=i;return}function kJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13808>>3]=0.0;i=i;return}function lJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13832>>3]=0.0;i=i;return}function mJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13816>>3]=0.0;i=i;return}function nJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13824>>3]=0.0;i=i;return}function oJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13784>>3]=0.0;i=i;return}function pJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13776>>3]=0.0;i=i;return}function qJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13768>>3]=0.0;i=i;return}function rJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13760>>3]=0.0;i=i;return}function sJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13752>>3]=0.0;i=i;return}function tJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13696>>3]=0.0;i=i;return}function uJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13672>>3]=0.0;i=i;return}function vJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13648>>3]=0.0;i=i;return}function wJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13624>>3]=0.0;i=i;return}function xJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13600>>3]=0.0;i=i;return}function yJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13448>>3]=0.0;i=i;return}function zJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13424>>3]=0.0;i=i;return}function AJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13400>>3]=0.0;i=i;return}function BJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13440>>3]=0.0;i=i;return}function CJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13376>>3]=0.0;i=i;return}function DJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13368>>3]=0.0;i=i;return}function EJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13344>>3]=0.0;i=i;return}function FJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13336>>3]=0.0;i=i;return}function GJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13328>>3]=0.0;i=i;return}function HJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13320>>3]=0.0;i=i;return}function IJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13312>>3]=0.0;i=i;return}function JJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13248>>3]=0.0;i=i;return}function KJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13240>>3]=0.0;i=i;return}function LJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13232>>3]=0.0;i=i;return}function MJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13224>>3]=0.0;i=i;return}function NJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13216>>3]=0.0;i=i;return}function OJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13208>>3]=0.0;i=i;return}function PJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13200>>3]=0.0;i=i;return}function QJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13192>>3]=0.0;i=i;return}function RJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13160>>3]=0.0;i=i;return}function SJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13184>>3]=0.0;i=i;return}function TJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13168>>3]=0.0;i=i;return}function UJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13176>>3]=0.0;i=i;return}function VJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13136>>3]=0.0;i=i;return}function WJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13128>>3]=0.0;i=i;return}function XJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13120>>3]=0.0;i=i;return}function YJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13112>>3]=0.0;i=i;return}function ZJa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13104>>3]=0.0;i=i;return}function _Ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13048>>3]=0.0;i=i;return}function $Ja(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13024>>3]=0.0;i=i;return}function aKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13e3>>3]=0.0;i=i;return}function bKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12976>>3]=0.0;i=i;return}function cKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12952>>3]=0.0;i=i;return}function dKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12800>>3]=0.0;i=i;return}function eKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12776>>3]=0.0;i=i;return}function fKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12768>>3]=0.0;i=i;return}function gKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12760>>3]=0.0;i=i;return}function hKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12728>>3]=0.0;i=i;return}function iKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12720>>3]=0.0;i=i;return}function jKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12696>>3]=0.0;i=i;return}function kKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12688>>3]=0.0;i=i;return}function lKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12680>>3]=0.0;i=i;return}function mKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12672>>3]=0.0;i=i;return}function nKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12664>>3]=0.0;i=i;return}function oKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12600>>3]=0.0;i=i;return}function pKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12592>>3]=0.0;i=i;return}function qKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12584>>3]=0.0;i=i;return}function rKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12576>>3]=0.0;i=i;return}function sKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12568>>3]=0.0;i=i;return}function tKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12560>>3]=0.0;i=i;return}function uKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12552>>3]=0.0;i=i;return}function vKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12544>>3]=0.0;i=i;return}function wKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12512>>3]=0.0;i=i;return}function xKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12536>>3]=0.0;i=i;return}function yKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12520>>3]=0.0;i=i;return}function zKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12528>>3]=0.0;i=i;return}function AKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12488>>3]=0.0;i=i;return}function BKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12480>>3]=0.0;i=i;return}function CKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12472>>3]=0.0;i=i;return}function DKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12464>>3]=0.0;i=i;return}function EKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12456>>3]=0.0;i=i;return}function FKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12400>>3]=0.0;i=i;return}function GKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12376>>3]=0.0;i=i;return}function HKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12352>>3]=0.0;i=i;return}function IKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12328>>3]=0.0;i=i;return}function JKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12304>>3]=0.0;i=i;return}function KKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12152>>3]=0.0;i=i;return}function LKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12128>>3]=0.0;i=i;return}function MKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12120>>3]=0.0;i=i;return}function NKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12112>>3]=0.0;i=i;return}function OKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12080>>3]=0.0;i=i;return}function PKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12072>>3]=0.0;i=i;return}function QKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12048>>3]=0.0;i=i;return}function RKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12040>>3]=0.0;i=i;return}function SKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12032>>3]=0.0;i=i;return}function TKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12024>>3]=0.0;i=i;return}function UKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12016>>3]=0.0;i=i;return}function VKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11952>>3]=0.0;i=i;return}



function LUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=0.0;i=i;return}function MUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=0.0;i=i;return}function NUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function OUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=0.0;i=i;return}function PUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function QUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=0.0;i=i;return}function RUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=0.0;i=i;return}function SUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function TUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=0.0;i=i;return}function UUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=0.0;i=i;return}function VUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4624>>3]=0.0;i=i;return}function WUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=0.0;i=i;return}function XUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=0.0;i=i;return}function YUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=0.0;i=i;return}function ZUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=0.0;i=i;return}function _Ua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=0.0;i=i;return}function $Ua(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=0.0;i=i;return}function aVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=0.0;i=i;return}function bVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=0.0;i=i;return}function cVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=0.0;i=i;return}function dVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4832>>3]=0.0;i=i;return}function eVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=0.0;i=i;return}function fVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function gVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=0.0;i=i;return}function hVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=0.0;i=i;return}function iVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=0.0;i=i;return}function jVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=0.0;i=i;return}function kVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=0.0;i=i;return}function lVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function mVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=0.0;i=i;return}function nVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=0.0;i=i;return}function oVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function pVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function qVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function rVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=0.0;i=i;return}function sVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function tVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function uVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=0.0;i=i;return}function vVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function wVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=0.0;i=i;return}function xVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function yVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function zVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=0.0;i=i;return}function AVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function BVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=0.0;i=i;return}function CVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=0.0;i=i;return}function DVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function EVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function FVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=0.0;i=i;return}function GVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6624>>3]=0.0;i=i;return}function HVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=0.0;i=i;return}function IVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function JVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=0.0;i=i;return}function KVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function LVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=0.0;i=i;return}function MVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3]=0.0;i=i;return}function NVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=0.0;i=i;return}function OVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function PVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5624>>3]=0.0;i=i;return}function QVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5648>>3]=0.0;i=i;return}function RVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function SVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=0.0;i=i;return}function TVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function UVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6736>>3]=0.0;i=i;return}function VVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=0.0;i=i;return}function WVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function XVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function YVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=0.0;i=i;return}function ZVa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6760>>3]=0.0;i=i;return}function _Va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5744>>3]=0.0;i=i;return}function $Va(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=0.0;i=i;return}function aWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function bWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=0.0;i=i;return}function cWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function dWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5856>>3]=0.0;i=i;return}function eWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function fWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function gWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function hWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function iWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6832>>3]=0.0;i=i;return}function jWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function kWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function lWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function mWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function nWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=0.0;i=i;return}function oWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function pWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function qWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function rWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6064>>3]=0.0;i=i;return}function sWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6096>>3]=0.0;i=i;return}function tWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function uWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function vWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function wWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function xWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function yWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function zWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=0.0;i=i;return}function AWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function BWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=0.0;i=i;return}function CWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6232>>3]=0.0;i=i;return}function DWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6952>>3]=0.0;i=i;return}function EWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function FWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function GWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function HWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function IWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6344>>3]=0.0;i=i;return}function JWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=0.0;i=i;return}function KWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6376>>3]=0.0;i=i;return}function LWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function MWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=0.0;i=i;return}function NWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function OWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function PWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6440>>3]=0.0;i=i;return}function QWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function RWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=0.0;i=i;return}function SWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=0.0;i=i;return}function TWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function UWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6488>>3]=0.0;i=i;return}function VWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6512>>3]=0.0;i=i;return}function WWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function XWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function YWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function ZWa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=0.0;i=i;return}function _Wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6688>>3]=0.0;i=i;return}function $Wa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6616>>3]=0.0;i=i;return}function aXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6640>>3]=0.0;i=i;return}function bXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=0.0;i=i;return}function cXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6680>>3]=0.0;i=i;return}function dXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6696>>3]=0.0;i=i;return}function eXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6704>>3]=0.0;i=i;return}function fXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6712>>3]=0.0;i=i;return}function gXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=0.0;i=i;return}function hXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6784>>3]=0.0;i=i;return}function iXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6728>>3]=0.0;i=i;return}function jXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6752>>3]=0.0;i=i;return}function kXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6776>>3]=0.0;i=i;return}function lXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6792>>3]=0.0;i=i;return}function mXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6800>>3]=0.0;i=i;return}function nXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6808>>3]=0.0;i=i;return}function oXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function pXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=0.0;i=i;return}function qXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6824>>3]=0.0;i=i;return}function rXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function sXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function tXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function uXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function vXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function wXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6960>>3]=0.0;i=i;return}function xXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6976>>3]=0.0;i=i;return}function yXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6920>>3]=0.0;i=i;return}function zXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6944>>3]=0.0;i=i;return}function AXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6968>>3]=0.0;i=i;return}function BXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6984>>3]=0.0;i=i;return}function CXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=0.0;i=i;return}function DXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=0.0;i=i;return}function EXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=0.0;i=i;return}function FXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function GXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=0.0;i=i;return}function HXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function IXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=0.0;i=i;return}function JXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function KXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function LXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=0.0;i=i;return}function MXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=0.0;i=i;return}function NXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=0.0;i=i;return}function OXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=0.0;i=i;return}function PXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=0.0;i=i;return}function QXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=0.0;i=i;return}function RXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=0.0;i=i;return}function SXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=0.0;i=i;return}function TXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7200>>3]=0.0;i=i;return}function UXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=0.0;i=i;return}function VXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=0.0;i=i;return}function WXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=0.0;i=i;return}function XXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=0.0;i=i;return}function YXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7280>>3]=0.0;i=i;return}function ZXa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7304>>3]=0.0;i=i;return}function _Xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7328>>3]=0.0;i=i;return}function $Xa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=0.0;i=i;return}function aYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=0.0;i=i;return}function bYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7360>>3]=0.0;i=i;return}function cYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7384>>3]=0.0;i=i;return}function dYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=0.0;i=i;return}function eYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=0.0;i=i;return}function fYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=0.0;i=i;return}function gYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=0.0;i=i;return}function hYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7464>>3]=0.0;i=i;return}function iYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7488>>3]=0.0;i=i;return}function jYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7496>>3]=0.0;i=i;return}function kYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7504>>3]=0.0;i=i;return}function lYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7520>>3]=0.0;i=i;return}function mYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7528>>3]=0.0;i=i;return}function nYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=0.0;i=i;return}function oYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7704>>3]=0.0;i=i;return}function pYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=0.0;i=i;return}function qYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=0.0;i=i;return}function rYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=0.0;i=i;return}function sYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7920>>3]=0.0;i=i;return}function tYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7632>>3]=0.0;i=i;return}function uYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7656>>3]=0.0;i=i;return}function vYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7680>>3]=0.0;i=i;return}function wYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7696>>3]=0.0;i=i;return}function xYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7712>>3]=0.0;i=i;return}function yYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7736>>3]=0.0;i=i;return}function zYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7720>>3]=0.0;i=i;return}function AYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7744>>3]=0.0;i=i;return}function BYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7760>>3]=0.0;i=i;return}function CYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7768>>3]=0.0;i=i;return}function DYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7776>>3]=0.0;i=i;return}function EYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7800>>3]=0.0;i=i;return}function FYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3]=0.0;i=i;return}function GYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7848>>3]=0.0;i=i;return}function HYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7856>>3]=0.0;i=i;return}function IYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7864>>3]=0.0;i=i;return}function JYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7872>>3]=0.0;i=i;return}function KYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7880>>3]=0.0;i=i;return}function LYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7888>>3]=0.0;i=i;return}function MYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7896>>3]=0.0;i=i;return}function NYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7912>>3]=0.0;i=i;return}function OYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7928>>3]=0.0;i=i;return}function PYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7936>>3]=0.0;i=i;return}function QYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=0.0;i=i;return}function RYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7944>>3]=0.0;i=i;return}function SYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7968>>3]=0.0;i=i;return}function TYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7992>>3]=0.0;i=i;return}function UYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=0.0;i=i;return}function VYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8e3>>3]=0.0;i=i;return}function WYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8024>>3]=0.0;i=i;return}function XYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8048>>3]=0.0;i=i;return}function YYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8536>>3]=0.0;i=i;return}function ZYa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8560>>3]=0.0;i=i;return}function _Ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3]=0.0;i=i;return}function $Ya(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9704>>3]=0.0;i=i;return}function aZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8064>>3]=0.0;i=i;return}function bZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8088>>3]=0.0;i=i;return}function cZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8112>>3]=0.0;i=i;return}function dZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=0.0;i=i;return}function eZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8120>>3]=0.0;i=i;return}function fZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8144>>3]=0.0;i=i;return}function gZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8168>>3]=0.0;i=i;return}function hZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8584>>3]=0.0;i=i;return}function iZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8608>>3]=0.0;i=i;return}function jZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8176>>3]=0.0;i=i;return}function kZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=0.0;i=i;return}function lZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8184>>3]=0.0;i=i;return}function mZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8208>>3]=0.0;i=i;return}function nZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3]=0.0;i=i;return}function oZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10128>>3]=0.0;i=i;return}function pZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8240>>3]=0.0;i=i;return}function qZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8264>>3]=0.0;i=i;return}function rZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=0.0;i=i;return}function sZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8632>>3]=0.0;i=i;return}function tZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8656>>3]=0.0;i=i;return}function uZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8296>>3]=0.0;i=i;return}function vZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10216>>3]=0.0;i=i;return}function wZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8304>>3]=0.0;i=i;return}function xZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8328>>3]=0.0;i=i;return}function yZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8352>>3]=0.0;i=i;return}function zZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10384>>3]=0.0;i=i;return}function AZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8360>>3]=0.0;i=i;return}function BZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8384>>3]=0.0;i=i;return}function CZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8408>>3]=0.0;i=i;return}function DZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8680>>3]=0.0;i=i;return}function EZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8704>>3]=0.0;i=i;return}function FZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8416>>3]=0.0;i=i;return}function GZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=0.0;i=i;return}function HZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8424>>3]=0.0;i=i;return}function IZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8448>>3]=0.0;i=i;return}function JZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8472>>3]=0.0;i=i;return}function KZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10640>>3]=0.0;i=i;return}function LZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8480>>3]=0.0;i=i;return}function MZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8504>>3]=0.0;i=i;return}function NZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8528>>3]=0.0;i=i;return}function OZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8728>>3]=0.0;i=i;return}function PZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8752>>3]=0.0;i=i;return}function QZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8776>>3]=0.0;i=i;return}function RZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8800>>3]=0.0;i=i;return}function SZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=0.0;i=i;return}function TZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=0.0;i=i;return}function UZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function VZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8544>>3]=0.0;i=i;return}function WZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8568>>3]=0.0;i=i;return}function XZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8592>>3]=0.0;i=i;return}function YZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8616>>3]=0.0;i=i;return}function ZZa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3]=0.0;i=i;return}function _Za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8664>>3]=0.0;i=i;return}function $Za(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8688>>3]=0.0;i=i;return}function a_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8712>>3]=0.0;i=i;return}function b_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8736>>3]=0.0;i=i;return}function c_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8760>>3]=0.0;i=i;return}function d_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8784>>3]=0.0;i=i;return}function e_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8808>>3]=0.0;i=i;return}function f_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8832>>3]=0.0;i=i;return}function g_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8856>>3]=0.0;i=i;return}function h_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function i_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8552>>3]=0.0;i=i;return}function j_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8576>>3]=0.0;i=i;return}function k_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8600>>3]=0.0;i=i;return}function l_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8624>>3]=0.0;i=i;return}function m_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8648>>3]=0.0;i=i;return}function n_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8672>>3]=0.0;i=i;return}function o_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8696>>3]=0.0;i=i;return}function p_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8720>>3]=0.0;i=i;return}function q_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8744>>3]=0.0;i=i;return}function r_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8768>>3]=0.0;i=i;return}function s_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8792>>3]=0.0;i=i;return}function t_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8816>>3]=0.0;i=i;return}function u_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8840>>3]=0.0;i=i;return}function v_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8864>>3]=0.0;i=i;return}function w_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8888>>3]=0.0;i=i;return}function x_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8896>>3]=0.0;i=i;return}function y_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function z_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function A_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function B_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8928>>3]=0.0;i=i;return}function C_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8936>>3]=0.0;i=i;return}function D_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function E_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function F_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8992>>3]=0.0;i=i;return}function G_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function H_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9040>>3]=0.0;i=i;return}function I_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function J_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=0.0;i=i;return}function K_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9128>>3]=0.0;i=i;return}function L_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9136>>3]=0.0;i=i;return}function M_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9176>>3]=0.0;i=i;return}function N_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9184>>3]=0.0;i=i;return}function O_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function P_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function Q_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=0.0;i=i;return}function R_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=0.0;i=i;return}function S_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=0.0;i=i;return}function T_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=0.0;i=i;return}function U_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=0.0;i=i;return}function V_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=0.0;i=i;return}function W_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=0.0;i=i;return}function X_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=0.0;i=i;return}function Y_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function Z_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=0.0;i=i;return}function __a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=0.0;i=i;return}function $_a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=0.0;i=i;return}function a$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=0.0;i=i;return}function b$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=0.0;i=i;return}function c$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=0.0;i=i;return}function d$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function e$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=0.0;i=i;return}function f$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=0.0;i=i;return}function g$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=0.0;i=i;return}function h$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=0.0;i=i;return}function i$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=0.0;i=i;return}function j$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=0.0;i=i;return}function k$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9624>>3]=0.0;i=i;return}function l$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9632>>3]=0.0;i=i;return}function m$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=0.0;i=i;return}function n$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=0.0;i=i;return}function o$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9656>>3]=0.0;i=i;return}function p$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9664>>3]=0.0;i=i;return}function q$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9672>>3]=0.0;i=i;return}function r$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=0.0;i=i;return}function s$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=0.0;i=i;return}function t$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=0.0;i=i;return}function u$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9736>>3]=0.0;i=i;return}function v$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9720>>3]=0.0;i=i;return}function w$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9744>>3]=0.0;i=i;return}function x$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9760>>3]=0.0;i=i;return}function y$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9768>>3]=0.0;i=i;return}function z$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9776>>3]=0.0;i=i;return}function A$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9800>>3]=0.0;i=i;return}function B$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9824>>3]=0.0;i=i;return}function C$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9832>>3]=0.0;i=i;return}function D$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9840>>3]=0.0;i=i;return}function E$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9848>>3]=0.0;i=i;return}function F$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=0.0;i=i;return}function G$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=0.0;i=i;return}function H$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=0.0;i=i;return}function I$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=0.0;i=i;return}function J$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=0.0;i=i;return}function K$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=0.0;i=i;return}function L$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=0.0;i=i;return}function M$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=0.0;i=i;return}function N$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=0.0;i=i;return}function O$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=0.0;i=i;return}function P$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=0.0;i=i;return}function Q$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=0.0;i=i;return}function R$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=0.0;i=i;return}function S$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=0.0;i=i;return}function T$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10016>>3]=0.0;i=i;return}function U$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10024>>3]=0.0;i=i;return}function V$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10032>>3]=0.0;i=i;return}function W$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10056>>3]=0.0;i=i;return}function X$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10080>>3]=0.0;i=i;return}function Y$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10088>>3]=0.0;i=i;return}function Z$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10096>>3]=0.0;i=i;return}function _$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10104>>3]=0.0;i=i;return}function $$a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10120>>3]=0.0;i=i;return}function a0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10136>>3]=0.0;i=i;return}function b0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10144>>3]=0.0;i=i;return}function c0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10152>>3]=0.0;i=i;return}function d0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10160>>3]=0.0;i=i;return}function e0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10168>>3]=0.0;i=i;return}function f0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10176>>3]=0.0;i=i;return}function g0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10184>>3]=0.0;i=i;return}function h0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10192>>3]=0.0;i=i;return}function i0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10208>>3]=0.0;i=i;return}function j0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10224>>3]=0.0;i=i;return}function k0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10248>>3]=0.0;i=i;return}function l0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10232>>3]=0.0;i=i;return}function m0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10256>>3]=0.0;i=i;return}function n0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10272>>3]=0.0;i=i;return}function o0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10280>>3]=0.0;i=i;return}function p0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10288>>3]=0.0;i=i;return}function q0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10312>>3]=0.0;i=i;return}function r0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10336>>3]=0.0;i=i;return}function s0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10344>>3]=0.0;i=i;return}function t0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10352>>3]=0.0;i=i;return}function u0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10360>>3]=0.0;i=i;return}function v0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10376>>3]=0.0;i=i;return}function w0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10392>>3]=0.0;i=i;return}function x0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10400>>3]=0.0;i=i;return}function y0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10408>>3]=0.0;i=i;return}function z0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10416>>3]=0.0;i=i;return}function A0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10424>>3]=0.0;i=i;return}function B0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10432>>3]=0.0;i=i;return}function C0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10440>>3]=0.0;i=i;return}function D0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10448>>3]=0.0;i=i;return}function E0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10464>>3]=0.0;i=i;return}function F0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10480>>3]=0.0;i=i;return}function G0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10504>>3]=0.0;i=i;return}function H0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10488>>3]=0.0;i=i;return}function I0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10512>>3]=0.0;i=i;return}function J0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10528>>3]=0.0;i=i;return}function K0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10536>>3]=0.0;i=i;return}function L0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10544>>3]=0.0;i=i;return}function M0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10568>>3]=0.0;i=i;return}function N0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10592>>3]=0.0;i=i;return}function O0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10600>>3]=0.0;i=i;return}function P0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10608>>3]=0.0;i=i;return}function Q0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=0.0;i=i;return}function R0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=0.0;i=i;return}function S0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10648>>3]=0.0;i=i;return}function T0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10728>>3]=0.0;i=i;return}function U0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10736>>3]=0.0;i=i;return}function V0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10744>>3]=0.0;i=i;return}function W0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10752>>3]=0.0;i=i;return}function X0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10760>>3]=0.0;i=i;return}function Y0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10768>>3]=0.0;i=i;return}function Z0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10776>>3]=0.0;i=i;return}function _0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10784>>3]=0.0;i=i;return}function $0a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10792>>3]=0.0;i=i;return}function a1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10800>>3]=0.0;i=i;return}function b1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10808>>3]=0.0;i=i;return}function c1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10816>>3]=0.0;i=i;return}function d1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10856>>3]=0.0;i=i;return}function e1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10864>>3]=0.0;i=i;return}function f1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=0.0;i=i;return}function g1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10880>>3]=0.0;i=i;return}function h1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=0.0;i=i;return}function i1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=0.0;i=i;return}function j1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10904>>3]=0.0;i=i;return}function k1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10912>>3]=0.0;i=i;return}function l1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10920>>3]=0.0;i=i;return}function m1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10928>>3]=0.0;i=i;return}function n1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10960>>3]=0.0;i=i;return}function o1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10968>>3]=0.0;i=i;return}function p1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10976>>3]=0.0;i=i;return}function q1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11e3>>3]=0.0;i=i;return}function r1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11104>>3]=0.0;i=i;return}function s1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11128>>3]=0.0;i=i;return}function t1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11152>>3]=0.0;i=i;return}function u1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11176>>3]=0.0;i=i;return}function v1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11232>>3]=0.0;i=i;return}function w1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11240>>3]=0.0;i=i;return}function x1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11248>>3]=0.0;i=i;return}function y1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11256>>3]=0.0;i=i;return}function z1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11264>>3]=0.0;i=i;return}function A1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11304>>3]=0.0;i=i;return}function B1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11296>>3]=0.0;i=i;return}function C1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11312>>3]=0.0;i=i;return}function D1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11288>>3]=0.0;i=i;return}function E1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11320>>3]=0.0;i=i;return}function F1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11328>>3]=0.0;i=i;return}function G1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11336>>3]=0.0;i=i;return}function H1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11344>>3]=0.0;i=i;return}function I1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11352>>3]=0.0;i=i;return}function J1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23976>>3]=0.0;i=i;return}function K1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23952>>3]=0.0;i=i;return}function L1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11384>>3]=0.0;i=i;return}function M1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11392>>3]=0.0;i=i;return}function N1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11400>>3]=0.0;i=i;return}function O1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11424>>3]=0.0;i=i;return}function P1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11432>>3]=0.0;i=i;return}function Q1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11496>>3]=0.0;i=i;return}function R1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11456>>3]=0.0;i=i;return}function S1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11480>>3]=0.0;i=i;return}function T1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11504>>3]=0.0;i=i;return}function U1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11656>>3]=0.0;i=i;return}function V1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11680>>3]=0.0;i=i;return}function W1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11704>>3]=0.0;i=i;return}function X1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11728>>3]=0.0;i=i;return}function Y1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11752>>3]=0.0;i=i;return}function Z1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11808>>3]=0.0;i=i;return}function _1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11816>>3]=0.0;i=i;return}function $1a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11824>>3]=0.0;i=i;return}function a2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11832>>3]=0.0;i=i;return}function b2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11840>>3]=0.0;i=i;return}function c2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11880>>3]=0.0;i=i;return}function d2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11872>>3]=0.0;i=i;return}function e2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11888>>3]=0.0;i=i;return}function f2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11864>>3]=0.0;i=i;return}function g2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11896>>3]=0.0;i=i;return}function h2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11904>>3]=0.0;i=i;return}function i2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11912>>3]=0.0;i=i;return}function j2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11920>>3]=0.0;i=i;return}function k2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11928>>3]=0.0;i=i;return}function l2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11936>>3]=0.0;i=i;return}function m2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11944>>3]=0.0;i=i;return}function n2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11952>>3]=0.0;i=i;return}function o2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12016>>3]=0.0;i=i;return}function p2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12024>>3]=0.0;i=i;return}function q2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12032>>3]=0.0;i=i;return}function r2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12040>>3]=0.0;i=i;return}function s2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12048>>3]=0.0;i=i;return}function t2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12072>>3]=0.0;i=i;return}function u2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12080>>3]=0.0;i=i;return}function v2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12112>>3]=0.0;i=i;return}function w2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12120>>3]=0.0;i=i;return}function x2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12128>>3]=0.0;i=i;return}function y2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12152>>3]=0.0;i=i;return}function z2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12304>>3]=0.0;i=i;return}function A2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12328>>3]=0.0;i=i;return}function B2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12352>>3]=0.0;i=i;return}function C2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12376>>3]=0.0;i=i;return}function D2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12400>>3]=0.0;i=i;return}function E2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12456>>3]=0.0;i=i;return}function F2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12464>>3]=0.0;i=i;return}function G2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12472>>3]=0.0;i=i;return}function H2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12480>>3]=0.0;i=i;return}function I2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12488>>3]=0.0;i=i;return}function J2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12528>>3]=0.0;i=i;return}function K2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12520>>3]=0.0;i=i;return}function L2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12536>>3]=0.0;i=i;return}function M2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12512>>3]=0.0;i=i;return}function N2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12544>>3]=0.0;i=i;return}function O2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12552>>3]=0.0;i=i;return}function P2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12560>>3]=0.0;i=i;return}function Q2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12568>>3]=0.0;i=i;return}function R2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12576>>3]=0.0;i=i;return}function S2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12584>>3]=0.0;i=i;return}function T2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12592>>3]=0.0;i=i;return}function U2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12600>>3]=0.0;i=i;return}function V2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12664>>3]=0.0;i=i;return}function W2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12672>>3]=0.0;i=i;return}function X2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12680>>3]=0.0;i=i;return}function Y2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12688>>3]=0.0;i=i;return}function Z2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12696>>3]=0.0;i=i;return}function _2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12720>>3]=0.0;i=i;return}function $2a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12728>>3]=0.0;i=i;return}function a3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12760>>3]=0.0;i=i;return}function b3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12768>>3]=0.0;i=i;return}function c3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12776>>3]=0.0;i=i;return}function d3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12800>>3]=0.0;i=i;return}function e3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12952>>3]=0.0;i=i;return}function f3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+12976>>3]=0.0;i=i;return}function g3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13e3>>3]=0.0;i=i;return}function h3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13024>>3]=0.0;i=i;return}function i3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13048>>3]=0.0;i=i;return}function j3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13104>>3]=0.0;i=i;return}function k3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13112>>3]=0.0;i=i;return}function l3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13120>>3]=0.0;i=i;return}function m3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13128>>3]=0.0;i=i;return}function n3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13136>>3]=0.0;i=i;return}function o3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13176>>3]=0.0;i=i;return}function p3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13168>>3]=0.0;i=i;return}function q3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13184>>3]=0.0;i=i;return}function r3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13160>>3]=0.0;i=i;return}function s3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13192>>3]=0.0;i=i;return}function t3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13200>>3]=0.0;i=i;return}function u3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13208>>3]=0.0;i=i;return}function v3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13216>>3]=0.0;i=i;return}function w3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13224>>3]=0.0;i=i;return}function x3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13232>>3]=0.0;i=i;return}function y3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13240>>3]=0.0;i=i;return}function z3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13248>>3]=0.0;i=i;return}function A3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13312>>3]=0.0;i=i;return}function B3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13320>>3]=0.0;i=i;return}function C3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13328>>3]=0.0;i=i;return}function D3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13336>>3]=0.0;i=i;return}function E3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13344>>3]=0.0;i=i;return}function F3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13368>>3]=0.0;i=i;return}function G3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13376>>3]=0.0;i=i;return}function H3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13440>>3]=0.0;i=i;return}function I3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13400>>3]=0.0;i=i;return}function J3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13424>>3]=0.0;i=i;return}function K3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13448>>3]=0.0;i=i;return}function L3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13600>>3]=0.0;i=i;return}function M3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13624>>3]=0.0;i=i;return}function N3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13648>>3]=0.0;i=i;return}function O3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13672>>3]=0.0;i=i;return}function P3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13696>>3]=0.0;i=i;return}function Q3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13752>>3]=0.0;i=i;return}function R3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13760>>3]=0.0;i=i;return}function S3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13768>>3]=0.0;i=i;return}function T3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13776>>3]=0.0;i=i;return}function U3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13784>>3]=0.0;i=i;return}function V3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13824>>3]=0.0;i=i;return}function W3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13816>>3]=0.0;i=i;return}function X3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13832>>3]=0.0;i=i;return}function Y3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13808>>3]=0.0;i=i;return}function Z3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13840>>3]=0.0;i=i;return}function _3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13848>>3]=0.0;i=i;return}function $3a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13856>>3]=0.0;i=i;return}function a4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13864>>3]=0.0;i=i;return}function b4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13872>>3]=0.0;i=i;return}function c4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13880>>3]=0.0;i=i;return}function d4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13888>>3]=0.0;i=i;return}function e4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13896>>3]=0.0;i=i;return}function f4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13960>>3]=0.0;i=i;return}function g4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13968>>3]=0.0;i=i;return}function h4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13976>>3]=0.0;i=i;return}function i4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13984>>3]=0.0;i=i;return}function j4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+13992>>3]=0.0;i=i;return}function k4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14016>>3]=0.0;i=i;return}function l4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14024>>3]=0.0;i=i;return}function m4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14056>>3]=0.0;i=i;return}function n4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14064>>3]=0.0;i=i;return}function o4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14072>>3]=0.0;i=i;return}function p4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14096>>3]=0.0;i=i;return}function q4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14104>>3]=0.0;i=i;return}function r4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14128>>3]=0.0;i=i;return}function s4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14152>>3]=0.0;i=i;return}function t4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14176>>3]=0.0;i=i;return}function u4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14200>>3]=0.0;i=i;return}function v4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14224>>3]=0.0;i=i;return}function w4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14232>>3]=0.0;i=i;return}function x4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14240>>3]=0.0;i=i;return}function y4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14280>>3]=0.0;i=i;return}function z4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14272>>3]=0.0;i=i;return}function A4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14288>>3]=0.0;i=i;return}function B4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14264>>3]=0.0;i=i;return}function C4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14296>>3]=0.0;i=i;return}function D4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14304>>3]=0.0;i=i;return}function E4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14312>>3]=0.0;i=i;return}function F4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14320>>3]=0.0;i=i;return}function G4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14328>>3]=0.0;i=i;return}function H4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14336>>3]=0.0;i=i;return}function I4a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14344>>3]=0.0;i=i;return}function J4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14408>>3]=+h[b+2016>>3]+ +h[b+11768>>3];i=i;return}function K4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14696>>3]=+h[b+2016>>3]+ +h[b+8424>>3];i=i;return}function L4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14672>>3]=+h[b+14696>>3]+ +h[(c[a+416>>2]|0)+14832>>3];i=i;return}function M4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14648>>3]=+h[b+14672>>3]+ +h[(c[a+416>>2]|0)+21240>>3];i=i;return}function N4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14624>>3]=+h[b+14648>>3]+ +h[(c[a+416>>2]|0)+27648>>3];i=i;return}function O4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14600>>3]=+h[b+14624>>3]+ +h[(c[a+416>>2]|0)+37400>>3];i=i;return}function P4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10664>>3]=+h[b+14624>>3]+ +h[(c[a+416>>2]|0)+34056>>3];i=i;return}function Q4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14552>>3]=+h[b+14648>>3]+ +h[(c[a+416>>2]|0)+30992>>3];i=i;return}function R4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14504>>3]=+h[b+14672>>3]+ +h[(c[a+416>>2]|0)+24584>>3];i=i;return}function S4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14456>>3]=+h[b+14696>>3]+ +h[(c[a+416>>2]|0)+18176>>3];i=i;return}function T4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14416>>3]=+h[b+2024>>3]+ +h[b+11776>>3];i=i;return}function U4a(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14704>>3]=+h[b+2024>>3]+ +h[b+8432>>3];i=i;return}function V4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14680>>3]=+h[b+14704>>3]+ +h[(c[a+416>>2]|0)+14840>>3];i=i;return}function W4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14656>>3]=+h[b+14680>>3]+ +h[(c[a+416>>2]|0)+21248>>3];i=i;return}function X4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14632>>3]=+h[b+14656>>3]+ +h[(c[a+416>>2]|0)+27656>>3];i=i;return}function Y4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14608>>3]=+h[b+14632>>3]+ +h[(c[a+416>>2]|0)+37408>>3];i=i;return}function Z4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10672>>3]=+h[b+14632>>3]+ +h[(c[a+416>>2]|0)+34064>>3];i=i;return}function _4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14560>>3]=+h[b+14656>>3]+ +h[(c[a+416>>2]|0)+31e3>>3];i=i;return}function $4a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14512>>3]=+h[b+14680>>3]+ +h[(c[a+416>>2]|0)+24592>>3];i=i;return}function a5a(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14464>>3]=+h[b+14704>>3]+ +h[(c[a+416>>2]|0)+18184>>3];i=i;return}function b5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26664>>3]=0.0;i=i;return}function c5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26672>>3]=0.0;i=i;return}function d5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26680>>3]=0.0;i=i;return}function e5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26688>>3]=0.0;i=i;return}function f5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26696>>3]=0.0;i=i;return}function g5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26704>>3]=0.0;i=i;return}function h5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26712>>3]=0.0;i=i;return}function i5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26720>>3]=0.0;i=i;return}function j5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26728>>3]=0.0;i=i;return}function k5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26736>>3]=0.0;i=i;return}function l5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26744>>3]=0.0;i=i;return}function m5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26752>>3]=0.0;i=i;return}function n5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26760>>3]=0.0;i=i;return}function o5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26768>>3]=0.0;i=i;return}function p5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26776>>3]=0.0;i=i;return}function q5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26784>>3]=0.0;i=i;return}function r5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26792>>3]=0.0;i=i;return}function s5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26800>>3]=0.0;i=i;return}function t5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26808>>3]=0.0;i=i;return}function u5a(a){a=a|0;c[c[(c[c[a+4>>2]>>2]|0)+12>>2]>>2]=0;i=i;return}function v5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+4>>2]=230;i=i;return}function w5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+8>>2]=0;i=i;return}function x5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+12>>2]=0;i=i;return}function y5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+16>>2]=230;i=i;return}function z5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+20>>2]=0;i=i;return}function A5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+24>>2]=0;i=i;return}function B5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+28>>2]=0;i=i;return}function C5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+32>>2]=0;i=i;return}function D5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14856>>3]=+h[(c[a+416>>2]|0)+38568>>3]*-.5;i=i;return}function E5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14864>>3]=0.0;i=i;return}function F5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14872>>3]=0.0;i=i;return}function G5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14880>>3]=1.0;i=i;return}function H5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14888>>3]=0.0;i=i;return}function I5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14896>>3]=0.0;i=i;return}function J5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14904>>3]=0.0;i=i;return}function K5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14912>>3]=1.0;i=i;return}function L5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14920>>3]=0.0;i=i;return}function M5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14944>>3]=0.0;i=i;return}function N5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14936>>3]=0.0;i=i;return}function O5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14928>>3]=255.0;i=i;return}function P5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+36>>2]=255;i=i;return}function Q5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+40>>2]=0;i=i;return}function R5a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+44>>2]=0;i=i;return}function S5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14952>>3]=0.0;i=i;return}function T5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14960>>3]=0.0;i=i;return}function U5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14968>>3]=0.0;i=i;return}function V5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14976>>3]=0.0;i=i;return}function W5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14984>>3]=-1.0;i=i;return}function X5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14992>>3]=0.0;i=i;return}function Y5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15e3>>3]=0.0;i=i;return}function Z5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15008>>3]=1.0;i=i;return}function _5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15016>>3]=0.0;i=i;return}function $5a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15040>>3]=0.0;i=i;return}function a6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15032>>3]=0.0;i=i;return}function b6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15024>>3]=255.0;i=i;return}function c6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+48>>2]=255;i=i;return}function d6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+52>>2]=0;i=i;return}function e6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+56>>2]=0;i=i;return}function f6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15048>>3]=+h[(c[a+416>>2]|0)+38920>>3]*-.5;i=i;return}function g6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15056>>3]=0.0;i=i;return}function h6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15064>>3]=0.0;i=i;return}function i6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15072>>3]=1.0;i=i;return}function j6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15080>>3]=0.0;i=i;return}function k6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15088>>3]=0.0;i=i;return}function l6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15096>>3]=0.0;i=i;return}function m6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15104>>3]=1.0;i=i;return}function n6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15112>>3]=0.0;i=i;return}function o6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15136>>3]=0.0;i=i;return}function p6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15128>>3]=0.0;i=i;return}function q6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15120>>3]=255.0;i=i;return}function r6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+60>>2]=255;i=i;return}function s6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+64>>2]=0;i=i;return}function t6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+68>>2]=0;i=i;return}function u6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15144>>3]=+h[(c[a+416>>2]|0)+38936>>3]*-.5;i=i;return}function v6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15152>>3]=0.0;i=i;return}function w6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15160>>3]=0.0;i=i;return}function x6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15168>>3]=1.0;i=i;return}function y6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15176>>3]=0.0;i=i;return}function z6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15184>>3]=0.0;i=i;return}function A6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15192>>3]=0.0;i=i;return}function B6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15200>>3]=1.0;i=i;return}function C6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15208>>3]=0.0;i=i;return}function D6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15232>>3]=0.0;i=i;return}function E6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15224>>3]=0.0;i=i;return}function F6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15216>>3]=255.0;i=i;return}function G6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+72>>2]=255;i=i;return}function H6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+76>>2]=0;i=i;return}function I6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+80>>2]=0;i=i;return}function J6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+84>>2]=155;i=i;return}function K6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+88>>2]=155;i=i;return}function L6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+92>>2]=155;i=i;return}function M6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+96>>2]=0;i=i;return}function N6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+100>>2]=128;i=i;return}function O6a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+104>>2]=255;i=i;return}function P6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15240>>3]=0.0;i=i;return}function Q6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15248>>3]=0.0;i=i;return}function R6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15256>>3]=0.0;i=i;return}function S6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15264>>3]=1.0;i=i;return}function T6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15272>>3]=0.0;i=i;return}function U6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15280>>3]=0.0;i=i;return}function V6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15288>>3]=0.0;i=i;return}function W6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15296>>3]=0.0;i=i;return}function X6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15304>>3]=0.0;i=i;return}function Y6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15312>>3]=0.0;i=i;return}function Z6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15320>>3]=0.0;i=i;return}function _6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15328>>3]=0.0;i=i;return}function $6a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15336>>3]=0.0;i=i;return}function a7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15344>>3]=0.0;i=i;return}function b7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15352>>3]=.1;i=i;return}function c7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15360>>3]=0.0;i=i;return}function d7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15368>>3]=0.0;i=i;return}function e7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15376>>3]=1.0;i=i;return}function f7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15384>>3]=0.0;i=i;return}function g7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15408>>3]=180.0;i=i;return}function h7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15400>>3]=180.0;i=i;return}function i7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15392>>3]=180.0;i=i;return}function j7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+108>>2]=180;i=i;return}function k7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+112>>2]=180;i=i;return}function l7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+116>>2]=180;i=i;return}function m7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15416>>3]=0.0;i=i;return}function n7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15424>>3]=.22;i=i;return}function o7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15432>>3]=0.0;i=i;return}function p7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15440>>3]=1.0;i=i;return}function q7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15448>>3]=0.0;i=i;return}function r7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15456>>3]=0.0;i=i;return}function s7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15480>>3]=200.0;i=i;return}function t7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15472>>3]=0.0;i=i;return}function u7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15464>>3]=0.0;i=i;return}function v7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+120>>2]=0;i=i;return}function w7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+124>>2]=0;i=i;return}function x7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+128>>2]=200;i=i;return}function y7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+132>>2]=0;i=i;return}function z7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+136>>2]=128;i=i;return}function A7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+140>>2]=255;i=i;return}function B7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15488>>3]=0.0;i=i;return}function C7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15496>>3]=0.0;i=i;return}function D7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15504>>3]=0.0;i=i;return}function E7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15512>>3]=1.0;i=i;return}function F7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15520>>3]=0.0;i=i;return}function G7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15528>>3]=0.0;i=i;return}function H7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15536>>3]=0.0;i=i;return}function I7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15544>>3]=0.0;i=i;return}function J7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15552>>3]=0.0;i=i;return}function K7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15560>>3]=0.0;i=i;return}function L7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15568>>3]=0.0;i=i;return}function M7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15576>>3]=0.0;i=i;return}function N7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15584>>3]=0.0;i=i;return}function O7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+144>>2]=155;i=i;return}function P7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+148>>2]=155;i=i;return}function Q7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+152>>2]=155;i=i;return}function R7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15592>>3]=0.0;i=i;return}function S7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15600>>3]=-.1;i=i;return}function T7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15608>>3]=0.0;i=i;return}function U7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15616>>3]=1.0;i=i;return}function V7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15624>>3]=0.0;i=i;return}function W7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15632>>3]=0.0;i=i;return}function X7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15656>>3]=255.0;i=i;return}function Y7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15648>>3]=128.0;i=i;return}function Z7a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15640>>3]=0.0;i=i;return}function _7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+156>>2]=0;i=i;return}function $7a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+160>>2]=128;i=i;return}function a8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+164>>2]=255;i=i;return}function b8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+168>>2]=0;i=i;return}function c8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+172>>2]=128;i=i;return}function d8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+176>>2]=255;i=i;return}function e8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15664>>3]=0.0;i=i;return}function f8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15672>>3]=0.0;i=i;return}function g8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15680>>3]=0.0;i=i;return}function h8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15688>>3]=1.0;i=i;return}function i8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15696>>3]=0.0;i=i;return}function j8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15704>>3]=0.0;i=i;return}function k8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15712>>3]=0.0;i=i;return}function l8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15720>>3]=0.0;i=i;return}function m8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15728>>3]=0.0;i=i;return}function n8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15736>>3]=0.0;i=i;return}function o8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15744>>3]=0.0;i=i;return}function p8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15752>>3]=0.0;i=i;return}function q8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15760>>3]=0.0;i=i;return}function r8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15768>>3]=0.0;i=i;return}function s8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15776>>3]=.1;i=i;return}function t8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15784>>3]=0.0;i=i;return}function u8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15792>>3]=1.0;i=i;return}function v8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15800>>3]=0.0;i=i;return}function w8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15808>>3]=0.0;i=i;return}function x8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15832>>3]=255.0;i=i;return}function y8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15824>>3]=128.0;i=i;return}function z8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15816>>3]=0.0;i=i;return}function A8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+180>>2]=0;i=i;return}function B8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+184>>2]=128;i=i;return}function C8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+188>>2]=255;i=i;return}function D8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+192>>2]=0;i=i;return}function E8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+196>>2]=128;i=i;return}function F8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+200>>2]=255;i=i;return}function G8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15840>>3]=0.0;i=i;return}function H8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15848>>3]=0.0;i=i;return}function I8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15856>>3]=0.0;i=i;return}function J8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15864>>3]=1.0;i=i;return}function K8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15872>>3]=0.0;i=i;return}function L8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15880>>3]=0.0;i=i;return}function M8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15888>>3]=0.0;i=i;return}function N8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15896>>3]=0.0;i=i;return}function O8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15904>>3]=0.0;i=i;return}function P8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15912>>3]=0.0;i=i;return}function Q8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15920>>3]=0.0;i=i;return}function R8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15928>>3]=0.0;i=i;return}function S8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15936>>3]=0.0;i=i;return}function T8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+204>>2]=0;i=i;return}function U8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+208>>2]=128;i=i;return}function V8a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+212>>2]=255;i=i;return}function W8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15944>>3]=0.0;i=i;return}function X8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15952>>3]=0.0;i=i;return}function Y8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15960>>3]=0.0;i=i;return}function Z8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15968>>3]=1.0;i=i;return}function _8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15976>>3]=0.0;i=i;return}function $8a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15984>>3]=0.0;i=i;return}function a9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+15992>>3]=0.0;i=i;return}function b9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16e3>>3]=0.0;i=i;return}function c9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16008>>3]=0.0;i=i;return}function d9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16016>>3]=0.0;i=i;return}function e9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16024>>3]=0.0;i=i;return}function f9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16032>>3]=0.0;i=i;return}function g9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16040>>3]=0.0;i=i;return}function h9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16048>>3]=.11;i=i;return}function i9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16056>>3]=0.0;i=i;return}function j9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16064>>3]=0.0;i=i;return}function k9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16072>>3]=0.0;i=i;return}function l9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16080>>3]=1.0;i=i;return}function m9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16088>>3]=0.0;i=i;return}function n9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16112>>3]=180.0;i=i;return}function o9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16104>>3]=180.0;i=i;return}function p9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16096>>3]=180.0;i=i;return}function q9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+216>>2]=180;i=i;return}function r9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+220>>2]=180;i=i;return}function s9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+224>>2]=180;i=i;return}function t9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+228>>2]=0;i=i;return}function u9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+232>>2]=128;i=i;return}function v9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+236>>2]=255;i=i;return}function w9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16120>>3]=0.0;i=i;return}function x9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16128>>3]=0.0;i=i;return}function y9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16136>>3]=0.0;i=i;return}function z9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16144>>3]=1.0;i=i;return}function A9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16152>>3]=0.0;i=i;return}function B9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16160>>3]=0.0;i=i;return}function C9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16168>>3]=0.0;i=i;return}function D9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16176>>3]=0.0;i=i;return}function E9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16184>>3]=0.0;i=i;return}function F9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16192>>3]=0.0;i=i;return}function G9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16200>>3]=0.0;i=i;return}function H9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16208>>3]=0.0;i=i;return}function I9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16216>>3]=0.0;i=i;return}function J9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16224>>3]=.11;i=i;return}function K9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16232>>3]=0.0;i=i;return}function L9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16240>>3]=0.0;i=i;return}function M9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16248>>3]=0.0;i=i;return}function N9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16256>>3]=1.0;i=i;return}function O9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16264>>3]=0.0;i=i;return}function P9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16288>>3]=180.0;i=i;return}function Q9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16280>>3]=180.0;i=i;return}function R9a(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16272>>3]=180.0;i=i;return}function S9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+240>>2]=180;i=i;return}function T9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+244>>2]=180;i=i;return}function U9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+248>>2]=180;i=i;return}function V9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+252>>2]=155;i=i;return}function W9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+256>>2]=155;i=i;return}function X9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+260>>2]=155;i=i;return}function Y9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+264>>2]=155;i=i;return}function Z9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+268>>2]=155;i=i;return}function _9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+272>>2]=155;i=i;return}function $9a(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+276>>2]=155;i=i;return}function aab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+280>>2]=155;i=i;return}function bab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+284>>2]=155;i=i;return}function cab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+288>>2]=155;i=i;return}function dab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+292>>2]=155;i=i;return}function eab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+296>>2]=155;i=i;return}function fab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16296>>3]=0.0;i=i;return}function gab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16304>>3]=0.0;i=i;return}function hab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16312>>3]=0.0;i=i;return}function iab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16320>>3]=0.0;i=i;return}function jab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16328>>3]=-1.0;i=i;return}function kab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16336>>3]=0.0;i=i;return}function lab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16344>>3]=0.0;i=i;return}function mab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16352>>3]=1.0;i=i;return}function nab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16360>>3]=0.0;i=i;return}function oab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16384>>3]=0.0;i=i;return}function pab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16376>>3]=0.0;i=i;return}function qab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16368>>3]=255.0;i=i;return}function rab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+300>>2]=255;i=i;return}function sab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+304>>2]=0;i=i;return}function tab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+308>>2]=0;i=i;return}function uab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16392>>3]=+h[(c[a+416>>2]|0)+40400>>3]*-.5;i=i;return}function vab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16400>>3]=0.0;i=i;return}function wab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16408>>3]=0.0;i=i;return}function xab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16416>>3]=1.0;i=i;return}function yab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16424>>3]=0.0;i=i;return}function zab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16432>>3]=0.0;i=i;return}function Aab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16440>>3]=0.0;i=i;return}function Bab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16448>>3]=1.0;i=i;return}function Cab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16456>>3]=0.0;i=i;return}function Dab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16480>>3]=0.0;i=i;return}function Eab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16472>>3]=0.0;i=i;return}function Fab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16464>>3]=255.0;i=i;return}function Gab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+312>>2]=255;i=i;return}function Hab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+316>>2]=0;i=i;return}function Iab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+320>>2]=0;i=i;return}function Jab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16488>>3]=+h[(c[a+416>>2]|0)+40416>>3]*-.5;i=i;return}function Kab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16496>>3]=0.0;i=i;return}function Lab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16504>>3]=0.0;i=i;return}function Mab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16512>>3]=1.0;i=i;return}function Nab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16520>>3]=0.0;i=i;return}function Oab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16528>>3]=0.0;i=i;return}function Pab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16536>>3]=0.0;i=i;return}function Qab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16544>>3]=1.0;i=i;return}function Rab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16552>>3]=0.0;i=i;return}function Sab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16576>>3]=0.0;i=i;return}function Tab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16568>>3]=0.0;i=i;return}function Uab(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16560>>3]=255.0;i=i;return}function Vab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+324>>2]=255;i=i;return}function Wab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+328>>2]=0;i=i;return}function Xab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+332>>2]=0;i=i;return}function Yab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+336>>2]=155;i=i;return}function Zab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+340>>2]=155;i=i;return}function _ab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+344>>2]=155;i=i;return}function $ab(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+348>>2]=0;i=i;return}function abb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+352>>2]=128;i=i;return}function bbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+356>>2]=255;i=i;return}function cbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16584>>3]=0.0;i=i;return}function dbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16592>>3]=0.0;i=i;return}function ebb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16600>>3]=0.0;i=i;return}function fbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16608>>3]=1.0;i=i;return}function gbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16616>>3]=0.0;i=i;return}function hbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16624>>3]=0.0;i=i;return}function ibb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16632>>3]=0.0;i=i;return}function jbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16640>>3]=0.0;i=i;return}function kbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16648>>3]=0.0;i=i;return}function lbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16656>>3]=0.0;i=i;return}function mbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16664>>3]=0.0;i=i;return}function nbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16672>>3]=0.0;i=i;return}function obb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16680>>3]=0.0;i=i;return}function pbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16688>>3]=0.0;i=i;return}function qbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16696>>3]=.1;i=i;return}function rbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16704>>3]=0.0;i=i;return}function sbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16712>>3]=0.0;i=i;return}function tbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16720>>3]=1.0;i=i;return}function ubb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16728>>3]=0.0;i=i;return}function vbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16752>>3]=180.0;i=i;return}function wbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16744>>3]=180.0;i=i;return}function xbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16736>>3]=180.0;i=i;return}function ybb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+360>>2]=180;i=i;return}function zbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+364>>2]=180;i=i;return}function Abb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+368>>2]=180;i=i;return}function Bbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16760>>3]=0.0;i=i;return}function Cbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16768>>3]=.22;i=i;return}function Dbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16776>>3]=0.0;i=i;return}function Ebb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16784>>3]=1.0;i=i;return}function Fbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16792>>3]=0.0;i=i;return}function Gbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16800>>3]=0.0;i=i;return}function Hbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16824>>3]=200.0;i=i;return}function Ibb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16816>>3]=0.0;i=i;return}function Jbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16808>>3]=0.0;i=i;return}function Kbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+372>>2]=0;i=i;return}function Lbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+376>>2]=0;i=i;return}function Mbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+380>>2]=200;i=i;return}function Nbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+384>>2]=0;i=i;return}function Obb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+388>>2]=128;i=i;return}function Pbb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+392>>2]=255;i=i;return}function Qbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16832>>3]=0.0;i=i;return}function Rbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16840>>3]=0.0;i=i;return}function Sbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16848>>3]=0.0;i=i;return}function Tbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16856>>3]=1.0;i=i;return}function Ubb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16864>>3]=0.0;i=i;return}function Vbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16872>>3]=0.0;i=i;return}function Wbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16880>>3]=0.0;i=i;return}function Xbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16888>>3]=0.0;i=i;return}function Ybb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16896>>3]=0.0;i=i;return}function Zbb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16904>>3]=0.0;i=i;return}function _bb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16912>>3]=0.0;i=i;return}function $bb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16920>>3]=0.0;i=i;return}function acb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16928>>3]=0.0;i=i;return}function bcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+396>>2]=155;i=i;return}function ccb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+400>>2]=155;i=i;return}function dcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+404>>2]=155;i=i;return}function ecb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16936>>3]=0.0;i=i;return}function fcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16944>>3]=-.1;i=i;return}function gcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16952>>3]=0.0;i=i;return}function hcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16960>>3]=1.0;i=i;return}function icb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16968>>3]=0.0;i=i;return}function jcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16976>>3]=0.0;i=i;return}function kcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17e3>>3]=255.0;i=i;return}function lcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16992>>3]=128.0;i=i;return}function mcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16984>>3]=0.0;i=i;return}function ncb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+408>>2]=0;i=i;return}function ocb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+412>>2]=128;i=i;return}function pcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+416>>2]=255;i=i;return}function qcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+420>>2]=0;i=i;return}function rcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+424>>2]=128;i=i;return}function scb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+428>>2]=255;i=i;return}function tcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17008>>3]=0.0;i=i;return}function ucb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17016>>3]=0.0;i=i;return}function vcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17024>>3]=0.0;i=i;return}function wcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17032>>3]=1.0;i=i;return}function xcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17040>>3]=0.0;i=i;return}function ycb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17048>>3]=0.0;i=i;return}function zcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17056>>3]=0.0;i=i;return}function Acb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17064>>3]=0.0;i=i;return}function Bcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17072>>3]=0.0;i=i;return}function Ccb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17080>>3]=0.0;i=i;return}function Dcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17088>>3]=0.0;i=i;return}function Ecb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17096>>3]=0.0;i=i;return}function Fcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17104>>3]=0.0;i=i;return}function Gcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17112>>3]=0.0;i=i;return}function Hcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17120>>3]=.1;i=i;return}function Icb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17128>>3]=0.0;i=i;return}function Jcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17136>>3]=1.0;i=i;return}function Kcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17144>>3]=0.0;i=i;return}function Lcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17152>>3]=0.0;i=i;return}function Mcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17176>>3]=255.0;i=i;return}function Ncb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17168>>3]=128.0;i=i;return}function Ocb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17160>>3]=0.0;i=i;return}function Pcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+432>>2]=0;i=i;return}function Qcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+436>>2]=128;i=i;return}function Rcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+440>>2]=255;i=i;return}function Scb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+444>>2]=0;i=i;return}function Tcb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+448>>2]=128;i=i;return}function Ucb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+452>>2]=255;i=i;return}function Vcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17184>>3]=0.0;i=i;return}function Wcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17192>>3]=0.0;i=i;return}function Xcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17200>>3]=0.0;i=i;return}function Ycb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17208>>3]=1.0;i=i;return}function Zcb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17216>>3]=0.0;i=i;return}function _cb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17224>>3]=0.0;i=i;return}function $cb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17232>>3]=0.0;i=i;return}function adb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17240>>3]=0.0;i=i;return}function bdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17248>>3]=0.0;i=i;return}function cdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17256>>3]=0.0;i=i;return}function ddb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17264>>3]=0.0;i=i;return}function edb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17272>>3]=0.0;i=i;return}function fdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17280>>3]=0.0;i=i;return}function gdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+456>>2]=0;i=i;return}function hdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+460>>2]=128;i=i;return}function idb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+464>>2]=255;i=i;return}function jdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17288>>3]=0.0;i=i;return}function kdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17296>>3]=0.0;i=i;return}function ldb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17304>>3]=0.0;i=i;return}function mdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17312>>3]=1.0;i=i;return}function ndb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17320>>3]=0.0;i=i;return}function odb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17328>>3]=0.0;i=i;return}function pdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17336>>3]=0.0;i=i;return}function qdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17344>>3]=0.0;i=i;return}function rdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17352>>3]=0.0;i=i;return}function sdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17360>>3]=0.0;i=i;return}function tdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17368>>3]=0.0;i=i;return}function udb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17376>>3]=0.0;i=i;return}function vdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17384>>3]=0.0;i=i;return}function wdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17392>>3]=.11;i=i;return}function xdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17400>>3]=0.0;i=i;return}function ydb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17408>>3]=0.0;i=i;return}function zdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17416>>3]=0.0;i=i;return}function Adb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17424>>3]=1.0;i=i;return}function Bdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17432>>3]=0.0;i=i;return}function Cdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17456>>3]=180.0;i=i;return}function Ddb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17448>>3]=180.0;i=i;return}function Edb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17440>>3]=180.0;i=i;return}function Fdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+468>>2]=180;i=i;return}function Gdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+472>>2]=180;i=i;return}function Hdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+476>>2]=180;i=i;return}function Idb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+480>>2]=0;i=i;return}function Jdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+484>>2]=128;i=i;return}function Kdb(a){a=a|0;c[(c[(c[c[a+4>>2]>>2]|0)+12>>2]|0)+488>>2]=255;i=i;return}function Ldb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17464>>3]=0.0;i=i;return}function Mdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17472>>3]=0.0;i=i;return}function Ndb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17480>>3]=0.0;i=i;return}function Odb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17488>>3]=1.0;i=i;return}function Pdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17496>>3]=0.0;i=i;return}function Qdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17504>>3]=0.0;i=i;return}function Rdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17512>>3]=0.0;i=i;return}function Sdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17520>>3]=0.0;i=i;return}function Tdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17528>>3]=0.0;i=i;return}function Udb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17536>>3]=0.0;i=i;return}function Vdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17544>>3]=0.0;i=i;return}function Wdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17552>>3]=0.0;i=i;return}function Xdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17560>>3]=0.0;i=i;return}function Ydb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17568>>3]=.11;i=i;return}function Zdb(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17576>>3]=0.0;i=i;return}function _db(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17584>>3]=0.0;i=i;return}function $db(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+17592>>3]=0.0;i=i;return}



function WA(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+27640>>3]- +h[b+27664>>3];e=+h[b+27648>>3]- +h[b+27672>>3];f=+h[b+27656>>3]- +h[b+27680>>3];h[b+45272>>3]=+V(+(d*d+e*e+f*f));i=i;return}function XA(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+45272>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4472,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+45280>>3]=l;i=d;return}function YA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45288>>3]=+h[b+45280>>3];i=i;return}function ZA(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27144>>3]=+h[b+26856>>3];i=i;return}function _A(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27128>>3]=+h[b+26840>>3];i=i;return}function $A(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26848>>3]=+h[b+44752>>3];i=i;return}function aB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+26840>>3]- +h[b+26864>>3];e=+h[b+26848>>3]- +h[b+26872>>3];f=+h[b+26856>>3]- +h[b+26880>>3];h[b+45104>>3]=+V(+(d*d+e*e+f*f));i=i;return}function bB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45160>>3]=+h[b+45104>>3];i=i;return}function cB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+27136>>3]=+h[b+26848>>3];i=i;return}function dB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26760>>3]=+h[b+26080>>3];i=i;return}function eB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26744>>3]=+h[b+26064>>3];i=i;return}function fB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26072>>3]=+h[b+44744>>3];i=i;return}function gB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+26064>>3]- +h[b+26088>>3];e=+h[b+26072>>3]- +h[b+26096>>3];f=+h[b+26080>>3]- +h[b+26104>>3];h[b+44920>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+45064>>3]=+h[b+44920>>3];i=i;return}function iB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+26752>>3]=+h[b+26072>>3];i=i;return}function jB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+25976>>3]=+h[b+44736>>3];i=i;return}function kB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+25968>>3]- +h[b+25992>>3];e=+h[b+25976>>3]- +h[b+26e3>>3];f=+h[b+25984>>3]- +h[b+26008>>3];h[b+44880>>3]=+V(+(d*d+e*e+f*f));i=i;return}function lB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44880>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4480,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44888>>3]=l;i=d;return}function mB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44896>>3]=+h[b+44888>>3];i=i;return}function nB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24576>>3]=+h[b+43280>>3]+ +h[b+43296>>3]*-.5;i=i;return}function oB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+24576>>3]- +h[b+24696>>3];e=+h[b+24584>>3]- +h[b+24704>>3];f=+h[b+24592>>3]- +h[b+24712>>3];h[b+44592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function pB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4488,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44600>>3]=l;i=d;return}function qB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44608>>3]=+h[b+44600>>3];i=i;return}function rB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24480>>3]=+h[b+43296>>3]*.5;i=i;return}function sB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+24480>>3]- +h[b+24504>>3];e=+h[b+24488>>3]- +h[b+24512>>3];f=+h[b+24496>>3]- +h[b+24520>>3];h[b+44552>>3]=+V(+(d*d+e*e+f*f));i=i;return}function tB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+44552>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4496,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+44560>>3]=l;i=d;return}function uB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44568>>3]=+h[b+44560>>3];i=i;return}function vB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24400>>3]=+h[b+23720>>3];i=i;return}function wB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24392>>3]=+h[b+23712>>3];i=i;return}function xB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23704>>3]=+h[b+43280>>3]- +h[b+43296>>3];i=i;return}function yB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+24384>>3]=+h[b+23704>>3];i=i;return}function zB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23624>>3]=+h[b+22944>>3];i=i;return}function AB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23616>>3]=+h[b+22936>>3];i=i;return}function BB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22928>>3]=+h[b+43296>>3];i=i;return}function CB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+23608>>3]=+h[b+22928>>3];i=i;return}function DB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22432>>3]=+h[b+22144>>3];i=i;return}function EB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22416>>3]=+h[b+22128>>3];i=i;return}function FB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22136>>3]=+h[b+43288>>3];i=i;return}function GB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+22128>>3]- +h[b+22152>>3];e=+h[b+22136>>3]- +h[b+22160>>3];f=+h[b+22144>>3]- +h[b+22168>>3];h[b+44016>>3]=+V(+(d*d+e*e+f*f));i=i;return}function HB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44072>>3]=+h[b+44016>>3];i=i;return}function IB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+22424>>3]=+h[b+22136>>3];i=i;return}function JB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21632>>3]=+h[b+21344>>3];i=i;return}function KB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21616>>3]=+h[b+21328>>3];i=i;return}function LB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21336>>3]=-+h[b+43288>>3];i=i;return}function MB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+21328>>3]- +h[b+21352>>3];e=+h[b+21336>>3]- +h[b+21360>>3];f=+h[b+21344>>3]- +h[b+21368>>3];h[b+43840>>3]=+V(+(d*d+e*e+f*f));i=i;return}function NB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43896>>3]=+h[b+43840>>3];i=i;return}function OB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21624>>3]=+h[b+21336>>3];i=i;return}function PB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43816>>3]=+h[b+43256>>3]+(+h[b+43288>>3]+(-+h[b+43272>>3]- +h[b+43264>>3]));i=i;return}function QB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+44696>>3]=+h[b+43816>>3];i=i;return}function RB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+21232>>3]=+h[b+43280>>3];i=i;return}function SB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+21232>>3]- +h[b+21256>>3];e=+h[b+21240>>3]- +h[b+21264>>3];f=+h[b+21248>>3]- +h[b+21272>>3];h[b+43792>>3]=+V(+(d*d+e*e+f*f));i=i;return}function TB(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43792>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4504,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43800>>3]=l;i=d;return}function UB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43808>>3]=+h[b+43800>>3];i=i;return}function VB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20736>>3]=+h[b+20448>>3];i=i;return}function WB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20720>>3]=+h[b+20432>>3];i=i;return}function XB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20440>>3]=+h[b+43272>>3];i=i;return}function YB(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+20432>>3]- +h[b+20456>>3];e=+h[b+20440>>3]- +h[b+20464>>3];f=+h[b+20448>>3]- +h[b+20472>>3];h[b+43624>>3]=+V(+(d*d+e*e+f*f));i=i;return}function ZB(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43680>>3]=+h[b+43624>>3];i=i;return}function _B(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20728>>3]=+h[b+20440>>3];i=i;return}function $B(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20352>>3]=+h[b+19672>>3];i=i;return}function aC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20336>>3]=+h[b+19656>>3];i=i;return}function bC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19664>>3]=+h[b+43264>>3];i=i;return}function cC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+19656>>3]- +h[b+19680>>3];e=+h[b+19664>>3]- +h[b+19688>>3];f=+h[b+19672>>3]- +h[b+19696>>3];h[b+43440>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43584>>3]=+h[b+43440>>3];i=i;return}function eC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+20344>>3]=+h[b+19664>>3];i=i;return}function fC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+19568>>3]=+h[b+43256>>3];i=i;return}function gC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+19560>>3]- +h[b+19584>>3];e=+h[b+19568>>3]- +h[b+19592>>3];f=+h[b+19576>>3]- +h[b+19600>>3];h[b+43400>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43400>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4512,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43408>>3]=l;i=d;return}function iC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43416>>3]=+h[b+43408>>3];i=i;return}function jC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18168>>3]=+h[b+41800>>3]+ +h[b+41816>>3]*-.5;i=i;return}function kC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18168>>3]- +h[b+18288>>3];e=+h[b+18176>>3]- +h[b+18296>>3];f=+h[b+18184>>3]- +h[b+18304>>3];h[b+43112>>3]=+V(+(d*d+e*e+f*f));i=i;return}function lC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4520,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43120>>3]=l;i=d;return}function mC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43128>>3]=+h[b+43120>>3];i=i;return}function nC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+18072>>3]=+h[b+41816>>3]*.5;i=i;return}function oC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+18072>>3]- +h[b+18096>>3];e=+h[b+18080>>3]- +h[b+18104>>3];f=+h[b+18088>>3]- +h[b+18112>>3];h[b+43072>>3]=+V(+(d*d+e*e+f*f));i=i;return}function pC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+43072>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4528,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+43080>>3]=l;i=d;return}function qC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43088>>3]=+h[b+43080>>3];i=i;return}function rC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17992>>3]=+h[b+17312>>3];i=i;return}function sC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17984>>3]=+h[b+17304>>3];i=i;return}function tC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17296>>3]=+h[b+41800>>3]- +h[b+41816>>3];i=i;return}function uC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17976>>3]=+h[b+17296>>3];i=i;return}function vC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17216>>3]=+h[b+16536>>3];i=i;return}function wC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17208>>3]=+h[b+16528>>3];i=i;return}function xC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16520>>3]=+h[b+41816>>3];i=i;return}function yC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+17200>>3]=+h[b+16520>>3];i=i;return}function zC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16024>>3]=+h[b+15736>>3];i=i;return}function AC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16008>>3]=+h[b+15720>>3];i=i;return}function BC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15728>>3]=+h[b+41808>>3];i=i;return}function CC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+15720>>3]- +h[b+15744>>3];e=+h[b+15728>>3]- +h[b+15752>>3];f=+h[b+15736>>3]- +h[b+15760>>3];h[b+42536>>3]=+V(+(d*d+e*e+f*f));i=i;return}function DC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42592>>3]=+h[b+42536>>3];i=i;return}function EC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+16016>>3]=+h[b+15728>>3];i=i;return}function FC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15224>>3]=+h[b+14936>>3];i=i;return}function GC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15208>>3]=+h[b+14920>>3];i=i;return}function HC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14928>>3]=-+h[b+41808>>3];i=i;return}function IC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14920>>3]- +h[b+14944>>3];e=+h[b+14928>>3]- +h[b+14952>>3];f=+h[b+14936>>3]- +h[b+14960>>3];h[b+42360>>3]=+V(+(d*d+e*e+f*f));i=i;return}function JC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42416>>3]=+h[b+42360>>3];i=i;return}function KC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+15216>>3]=+h[b+14928>>3];i=i;return}function LC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42336>>3]=+h[b+41776>>3]+(+h[b+41808>>3]+(-+h[b+41792>>3]- +h[b+41784>>3]));i=i;return}function MC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+43216>>3]=+h[b+42336>>3];i=i;return}function NC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14824>>3]=+h[b+41800>>3];i=i;return}function OC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14824>>3]- +h[b+14848>>3];e=+h[b+14832>>3]- +h[b+14856>>3];f=+h[b+14840>>3]- +h[b+14864>>3];h[b+42312>>3]=+V(+(d*d+e*e+f*f));i=i;return}function PC(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+42312>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4536,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+42320>>3]=l;i=d;return}function QC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42328>>3]=+h[b+42320>>3];i=i;return}function RC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14328>>3]=+h[b+14040>>3];i=i;return}function SC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14312>>3]=+h[b+14024>>3];i=i;return}function TC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14032>>3]=+h[b+41792>>3];i=i;return}function UC(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+14024>>3]- +h[b+14048>>3];e=+h[b+14032>>3]- +h[b+14056>>3];f=+h[b+14040>>3]- +h[b+14064>>3];h[b+42144>>3]=+V(+(d*d+e*e+f*f));i=i;return}function VC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42200>>3]=+h[b+42144>>3];i=i;return}function WC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+14320>>3]=+h[b+14032>>3];i=i;return}function XC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13944>>3]=+h[b+13264>>3];i=i;return}function YC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13928>>3]=+h[b+13248>>3];i=i;return}function ZC(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13256>>3]=+h[b+41784>>3];i=i;return}function _C(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13248>>3]- +h[b+13272>>3];e=+h[b+13256>>3]- +h[b+13280>>3];f=+h[b+13264>>3]- +h[b+13288>>3];h[b+41960>>3]=+V(+(d*d+e*e+f*f));i=i;return}function $C(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+42104>>3]=+h[b+41960>>3];i=i;return}function aD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13936>>3]=+h[b+13256>>3];i=i;return}function bD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+13160>>3]=+h[b+41776>>3];i=i;return}function cD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+13152>>3]- +h[b+13176>>3];e=+h[b+13160>>3]- +h[b+13184>>3];f=+h[b+13168>>3]- +h[b+13192>>3];h[b+41920>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41920>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4544,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41928>>3]=l;i=d;return}function eD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41936>>3]=+h[b+41928>>3];i=i;return}function fD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11760>>3]=+h[b+40320>>3]+ +h[b+40336>>3]*-.5;i=i;return}function gD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11760>>3]- +h[b+11880>>3];e=+h[b+11768>>3]- +h[b+11888>>3];f=+h[b+11776>>3]- +h[b+11896>>3];h[b+41632>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41632>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4552,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41640>>3]=l;i=d;return}function iD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41648>>3]=+h[b+41640>>3];i=i;return}function jD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11664>>3]=+h[b+40336>>3]*.5;i=i;return}function kD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+11664>>3]- +h[b+11688>>3];e=+h[b+11672>>3]- +h[b+11696>>3];f=+h[b+11680>>3]- +h[b+11704>>3];h[b+41592>>3]=+V(+(d*d+e*e+f*f));i=i;return}function lD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+41592>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4560,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+41600>>3]=l;i=d;return}function mD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41608>>3]=+h[b+41600>>3];i=i;return}function nD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11584>>3]=+h[b+10904>>3];i=i;return}function oD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11576>>3]=+h[b+10896>>3];i=i;return}function pD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10888>>3]=+h[b+40320>>3]- +h[b+40336>>3];i=i;return}function qD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+11568>>3]=+h[b+10888>>3];i=i;return}function rD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10808>>3]=+h[b+10128>>3];i=i;return}function sD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10800>>3]=+h[b+10120>>3];i=i;return}function tD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10112>>3]=+h[b+40336>>3];i=i;return}function uD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+10792>>3]=+h[b+10112>>3];i=i;return}function vD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9616>>3]=+h[b+9328>>3];i=i;return}function wD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9600>>3]=+h[b+9312>>3];i=i;return}function xD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9320>>3]=+h[b+40328>>3];i=i;return}function yD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+9312>>3]- +h[b+9336>>3];e=+h[b+9320>>3]- +h[b+9344>>3];f=+h[b+9328>>3]- +h[b+9352>>3];h[b+41056>>3]=+V(+(d*d+e*e+f*f));i=i;return}function zD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41112>>3]=+h[b+41056>>3];i=i;return}function AD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+9608>>3]=+h[b+9320>>3];i=i;return}function BD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8816>>3]=+h[b+8528>>3];i=i;return}function CD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8800>>3]=+h[b+8512>>3];i=i;return}function DD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8520>>3]=-+h[b+40328>>3];i=i;return}function ED(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8512>>3]- +h[b+8536>>3];e=+h[b+8520>>3]- +h[b+8544>>3];f=+h[b+8528>>3]- +h[b+8552>>3];h[b+40880>>3]=+V(+(d*d+e*e+f*f));i=i;return}function FD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40936>>3]=+h[b+40880>>3];i=i;return}function GD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8808>>3]=+h[b+8520>>3];i=i;return}function HD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40856>>3]=+h[b+40296>>3]+(+h[b+40328>>3]+(-+h[b+40312>>3]- +h[b+40304>>3]));i=i;return}function ID(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+41736>>3]=+h[b+40856>>3];i=i;return}function JD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+8416>>3]=+h[b+40320>>3];i=i;return}function KD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+8416>>3]- +h[b+8440>>3];e=+h[b+8424>>3]- +h[b+8448>>3];f=+h[b+8432>>3]- +h[b+8456>>3];h[b+40832>>3]=+V(+(d*d+e*e+f*f));i=i;return}function LD(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40832>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4568,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40840>>3]=l;i=d;return}function MD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40848>>3]=+h[b+40840>>3];i=i;return}function ND(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7920>>3]=+h[b+7632>>3];i=i;return}function OD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7904>>3]=+h[b+7616>>3];i=i;return}function PD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7624>>3]=+h[b+40312>>3];i=i;return}function QD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+7616>>3]- +h[b+7640>>3];e=+h[b+7624>>3]- +h[b+7648>>3];f=+h[b+7632>>3]- +h[b+7656>>3];h[b+40664>>3]=+V(+(d*d+e*e+f*f));i=i;return}function RD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40720>>3]=+h[b+40664>>3];i=i;return}function SD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7912>>3]=+h[b+7624>>3];i=i;return}function TD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7536>>3]=+h[b+6856>>3];i=i;return}function UD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7520>>3]=+h[b+6840>>3];i=i;return}function VD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6848>>3]=+h[b+40304>>3];i=i;return}function WD(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6840>>3]- +h[b+6864>>3];e=+h[b+6848>>3]- +h[b+6872>>3];f=+h[b+6856>>3]- +h[b+6880>>3];h[b+40480>>3]=+V(+(d*d+e*e+f*f));i=i;return}function XD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40624>>3]=+h[b+40480>>3];i=i;return}function YD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+7528>>3]=+h[b+6848>>3];i=i;return}function ZD(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+6752>>3]=+h[b+40296>>3];i=i;return}function _D(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+6744>>3]- +h[b+6768>>3];e=+h[b+6752>>3]- +h[b+6776>>3];f=+h[b+6760>>3]- +h[b+6784>>3];h[b+40440>>3]=+V(+(d*d+e*e+f*f));i=i;return}function $D(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40440>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4576,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40448>>3]=l;i=d;return}function aE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40456>>3]=+h[b+40448>>3];i=i;return}function bE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5352>>3]=+h[b+38840>>3]+ +h[b+38856>>3]*-.5;i=i;return}function cE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5352>>3]- +h[b+5472>>3];e=+h[b+5360>>3]- +h[b+5480>>3];f=+h[b+5368>>3]- +h[b+5488>>3];h[b+40152>>3]=+V(+(d*d+e*e+f*f));i=i;return}function dE(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40152>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4584,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40160>>3]=l;i=d;return}function eE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40168>>3]=+h[b+40160>>3];i=i;return}function fE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5256>>3]=+h[b+38856>>3]*.5;i=i;return}function gE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+5256>>3]- +h[b+5280>>3];e=+h[b+5264>>3]- +h[b+5288>>3];f=+h[b+5272>>3]- +h[b+5296>>3];h[b+40112>>3]=+V(+(d*d+e*e+f*f));i=i;return}function hE(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+40112>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4592,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+40120>>3]=l;i=d;return}function iE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40128>>3]=+h[b+40120>>3];i=i;return}function jE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5176>>3]=+h[b+4496>>3];i=i;return}function kE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5168>>3]=+h[b+4488>>3];i=i;return}function lE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4480>>3]=+h[b+38840>>3]- +h[b+38856>>3];i=i;return}function mE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+5160>>3]=+h[b+4480>>3];i=i;return}function nE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4400>>3]=+h[b+3720>>3];i=i;return}function oE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4392>>3]=+h[b+3712>>3];i=i;return}function pE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3704>>3]=+h[b+38856>>3];i=i;return}function qE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+4384>>3]=+h[b+3704>>3];i=i;return}function rE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3208>>3]=+h[b+2920>>3];i=i;return}function sE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3192>>3]=+h[b+2904>>3];i=i;return}function tE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2912>>3]=+h[b+38848>>3];i=i;return}function uE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2904>>3]- +h[b+2928>>3];e=+h[b+2912>>3]- +h[b+2936>>3];f=+h[b+2920>>3]- +h[b+2944>>3];h[b+39576>>3]=+V(+(d*d+e*e+f*f));i=i;return}function vE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39632>>3]=+h[b+39576>>3];i=i;return}function wE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+3200>>3]=+h[b+2912>>3];i=i;return}function xE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2408>>3]=+h[b+2120>>3];i=i;return}function yE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2392>>3]=+h[b+2104>>3];i=i;return}function zE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2112>>3]=-+h[b+38848>>3];i=i;return}function AE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2104>>3]- +h[b+2128>>3];e=+h[b+2112>>3]- +h[b+2136>>3];f=+h[b+2120>>3]- +h[b+2144>>3];h[b+39400>>3]=+V(+(d*d+e*e+f*f));i=i;return}function BE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39456>>3]=+h[b+39400>>3];i=i;return}function CE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2400>>3]=+h[b+2112>>3];i=i;return}function DE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39376>>3]=+h[b+38816>>3]+(+h[b+38848>>3]+(-+h[b+38832>>3]- +h[b+38824>>3]));i=i;return}function EE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+40256>>3]=+h[b+39376>>3];i=i;return}function FE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+2008>>3]=+h[b+38840>>3];i=i;return}function GE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+2008>>3]- +h[b+2032>>3];e=+h[b+2016>>3]- +h[b+2040>>3];f=+h[b+2024>>3]- +h[b+2048>>3];h[b+39352>>3]=+V(+(d*d+e*e+f*f));i=i;return}function HE(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+39352>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4600,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+39360>>3]=l;i=d;return}function IE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39368>>3]=+h[b+39360>>3];i=i;return}function JE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1512>>3]=+h[b+1224>>3];i=i;return}function KE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1496>>3]=+h[b+1208>>3];i=i;return}function LE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1216>>3]=+h[b+38832>>3];i=i;return}function ME(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+1208>>3]- +h[b+1232>>3];e=+h[b+1216>>3]- +h[b+1240>>3];f=+h[b+1224>>3]- +h[b+1248>>3];h[b+39184>>3]=+V(+(d*d+e*e+f*f));i=i;return}function NE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39240>>3]=+h[b+39184>>3];i=i;return}function OE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1504>>3]=+h[b+1216>>3];i=i;return}function PE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1128>>3]=+h[b+448>>3];i=i;return}function QE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1112>>3]=+h[b+432>>3];i=i;return}function RE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+440>>3]=+h[b+38824>>3];i=i;return}function SE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+432>>3]- +h[b+456>>3];e=+h[b+440>>3]- +h[b+464>>3];f=+h[b+448>>3]- +h[b+472>>3];h[b+39e3>>3]=+V(+(d*d+e*e+f*f));i=i;return}function TE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+39144>>3]=+h[b+39e3>>3];i=i;return}function UE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+1120>>3]=+h[b+440>>3];i=i;return}function VE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+344>>3]=+h[b+38816>>3];i=i;return}function WE(a){a=a|0;var b=0,d=0.0,e=0.0,f=0.0;b=c[a+416>>2]|0;d=+h[b+336>>3]- +h[b+360>>3];e=+h[b+344>>3]- +h[b+368>>3];f=+h[b+352>>3]- +h[b+376>>3];h[b+38960>>3]=+V(+(d*d+e*e+f*f));i=i;return}function XE(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0.0,k=0,l=0.0,m=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+38616>>3];j=+h[f+38960>>3];do{if(g!=0.0){k=f;l=j/g}else{if(j==0.0){k=f;l=j;break}m=j/+KBc(c[b+536>>2]|0,g,4400,4608,+h[c[c[b+4>>2]>>2]>>3],(a[b+319|0]|0)!=0|0);k=c[e>>2]|0;l=m}}while(0);h[k+38968>>3]=l;i=d;return}function YE(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[b+38976>>3]=+h[b+38968>>3];i=i;return}function ZE(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23800>>3]=+h[(c[a+416>>2]|0)+5368>>3];i=i;return}function _E(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23792>>3]=+h[(c[a+416>>2]|0)+5360>>3];i=i;return}function $E(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23784>>3]=+h[(c[a+416>>2]|0)+5352>>3];i=i;return}function aF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14832>>3]=+h[b+5736>>3]+ +h[b+5160>>3];i=i;return}function bF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14808>>3]=+h[b+14832>>3]+ +h[(c[a+416>>2]|0)+3192>>3];i=i;return}function cF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14784>>3]=+h[b+14808>>3]+ +h[(c[a+416>>2]|0)+4384>>3];i=i;return}function dF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14760>>3]=+h[b+14808>>3]+ +h[(c[a+416>>2]|0)+5256>>3];i=i;return}function eF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14736>>3]=+h[b+14784>>3]+ +h[(c[a+416>>2]|0)+2392>>3];i=i;return}function fF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14712>>3]=+h[b+14736>>3]+ +h[(c[a+416>>2]|0)+6120>>3];i=i;return}function gF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14704>>3]=+h[b+2024>>3]+ +h[b+8432>>3];i=i;return}function hF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14680>>3]=+h[b+14704>>3]+ +h[(c[a+416>>2]|0)+14840>>3];i=i;return}function iF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14656>>3]=+h[b+14680>>3]+ +h[(c[a+416>>2]|0)+21248>>3];i=i;return}function jF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14632>>3]=+h[b+14656>>3]+ +h[(c[a+416>>2]|0)+27656>>3];i=i;return}function kF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14608>>3]=+h[b+14632>>3]+ +h[(c[a+416>>2]|0)+37408>>3];i=i;return}function lF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14584>>3]=+h[b+14608>>3]+(+h[d+32384>>3]*.4999999999999999+ +h[d+32392>>3]*.8660254037844387);i=i;return}function mF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14560>>3]=+h[b+14656>>3]+ +h[(c[a+416>>2]|0)+31e3>>3];i=i;return}function nF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14536>>3]=+h[b+14560>>3]+(+h[d+25976>>3]*-.4999999999999999+ +h[d+25984>>3]*.8660254037844387);i=i;return}function oF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14512>>3]=+h[b+14680>>3]+ +h[(c[a+416>>2]|0)+24592>>3];i=i;return}function pF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14488>>3]=+h[b+14512>>3]+(+h[d+19568>>3]*.4999999999999999+ +h[d+19576>>3]*.8660254037844387);i=i;return}function qF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14464>>3]=+h[b+14704>>3]+ +h[(c[a+416>>2]|0)+18184>>3];i=i;return}function rF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14440>>3]=+h[b+14464>>3]+(+h[d+13160>>3]*-.4999999999999999+ +h[d+13168>>3]*.8660254037844387);i=i;return}function sF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14416>>3]=+h[b+2024>>3]+ +h[b+11776>>3];i=i;return}function tF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14392>>3]=+h[b+14416>>3]+(+h[d+6752>>3]*.4999999999999999+ +h[d+6760>>3]*.8660254037844387);i=i;return}function uF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14696>>3]=+h[b+2016>>3]+ +h[b+8424>>3];i=i;return}function vF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14672>>3]=+h[b+14696>>3]+ +h[(c[a+416>>2]|0)+14832>>3];i=i;return}function wF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14648>>3]=+h[b+14672>>3]+ +h[(c[a+416>>2]|0)+21240>>3];i=i;return}function xF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14624>>3]=+h[b+14648>>3]+ +h[(c[a+416>>2]|0)+27648>>3];i=i;return}function yF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14600>>3]=+h[b+14624>>3]+ +h[(c[a+416>>2]|0)+37400>>3];i=i;return}function zF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14576>>3]=+h[b+14600>>3]+(+h[d+32384>>3]*.8660254037844387+ +h[d+32392>>3]*-.4999999999999999);i=i;return}function AF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14552>>3]=+h[b+14648>>3]+ +h[(c[a+416>>2]|0)+30992>>3];i=i;return}function BF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14528>>3]=+h[b+14552>>3]+(+h[d+25976>>3]*.8660254037844387+ +h[d+25984>>3]*.4999999999999999);i=i;return}function CF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14504>>3]=+h[b+14672>>3]+ +h[(c[a+416>>2]|0)+24584>>3];i=i;return}function DF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14480>>3]=+h[b+14504>>3]+(+h[d+19568>>3]*.8660254037844387+ +h[d+19576>>3]*-.4999999999999999);i=i;return}function EF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14456>>3]=+h[b+14696>>3]+ +h[(c[a+416>>2]|0)+18176>>3];i=i;return}function FF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14432>>3]=+h[b+14456>>3]+(+h[d+13160>>3]*.8660254037844387+ +h[d+13168>>3]*.4999999999999999);i=i;return}function GF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14408>>3]=+h[b+2016>>3]+ +h[b+11768>>3];i=i;return}function HF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14384>>3]=+h[b+14408>>3]+(+h[d+6752>>3]*.8660254037844387+ +h[d+6760>>3]*-.4999999999999999);i=i;return}function IF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14688>>3]=+h[b+2008>>3]+ +h[b+8416>>3];i=i;return}function JF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14664>>3]=+h[b+14688>>3]+ +h[(c[a+416>>2]|0)+14824>>3];i=i;return}function KF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14640>>3]=+h[b+14664>>3]+ +h[(c[a+416>>2]|0)+21232>>3];i=i;return}function LF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14616>>3]=+h[b+14640>>3]+ +h[(c[a+416>>2]|0)+27640>>3];i=i;return}function MF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14592>>3]=+h[b+14616>>3]+ +h[(c[a+416>>2]|0)+37392>>3];i=i;return}function NF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14568>>3]=+h[b+14592>>3]+ +h[(c[a+416>>2]|0)+32376>>3];i=i;return}function OF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14544>>3]=+h[b+14640>>3]+ +h[(c[a+416>>2]|0)+30984>>3];i=i;return}function PF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14520>>3]=+h[b+14544>>3]+ +h[(c[a+416>>2]|0)+25968>>3];i=i;return}function QF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14496>>3]=+h[b+14664>>3]+ +h[(c[a+416>>2]|0)+24576>>3];i=i;return}function RF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14472>>3]=+h[b+14496>>3]+ +h[(c[a+416>>2]|0)+19560>>3];i=i;return}function SF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14448>>3]=+h[b+14688>>3]+ +h[(c[a+416>>2]|0)+18168>>3];i=i;return}function TF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14424>>3]=+h[b+14448>>3]+ +h[(c[a+416>>2]|0)+13152>>3];i=i;return}function UF(a){a=a|0;var b=0;b=c[a+416>>2]|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+14400>>3]=+h[b+2008>>3]+ +h[b+11760>>3];i=i;return}function VF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14376>>3]=+h[b+14400>>3]+ +h[(c[a+416>>2]|0)+6744>>3];i=i;return}function WF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14368>>3]=+h[b+23800>>3]+(+h[d+344>>3]*-.4999999999999999+ +h[d+352>>3]*.8660254037844387);i=i;return}function XF(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14360>>3]=+h[b+23792>>3]+(+h[d+344>>3]*.8660254037844387+ +h[d+352>>3]*.4999999999999999);i=i;return}function YF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+14352>>3]=+h[b+23784>>3]+ +h[(c[a+416>>2]|0)+336>>3];i=i;return}function ZF(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13904>>3]=+h[b+14712>>3]+ +h[(c[a+416>>2]|0)+12144>>3];i=i;return}function _F(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13576>>3]=+h[b+13904>>3]+ +h[(c[a+416>>2]|0)+11568>>3];i=i;return}function $F(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13552>>3]=+h[b+13576>>3]+ +h[(c[a+416>>2]|0)+9600>>3];i=i;return}function aG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13528>>3]=+h[b+13552>>3]+ +h[(c[a+416>>2]|0)+10792>>3];i=i;return}function bG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13504>>3]=+h[b+13528>>3]+ +h[(c[a+416>>2]|0)+8800>>3];i=i;return}function cG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13480>>3]=+h[b+13552>>3]+ +h[(c[a+416>>2]|0)+11664>>3];i=i;return}function dG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13456>>3]=+h[b+13504>>3]+ +h[(c[a+416>>2]|0)+12528>>3];i=i;return}function eG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13256>>3]=+h[b+13456>>3]+ +h[(c[a+416>>2]|0)+18552>>3];i=i;return}function fG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12928>>3]=+h[b+13256>>3]+ +h[(c[a+416>>2]|0)+17976>>3];i=i;return}function gG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12904>>3]=+h[b+12928>>3]+ +h[(c[a+416>>2]|0)+16008>>3];i=i;return}function hG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12880>>3]=+h[b+12904>>3]+ +h[(c[a+416>>2]|0)+17200>>3];i=i;return}function iG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12856>>3]=+h[b+12880>>3]+ +h[(c[a+416>>2]|0)+15208>>3];i=i;return}function jG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12832>>3]=+h[b+12904>>3]+ +h[(c[a+416>>2]|0)+18072>>3];i=i;return}function kG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12808>>3]=+h[b+12856>>3]+ +h[(c[a+416>>2]|0)+18936>>3];i=i;return}function lG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12608>>3]=+h[b+12808>>3]+ +h[(c[a+416>>2]|0)+24960>>3];i=i;return}function mG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12280>>3]=+h[b+12608>>3]+ +h[(c[a+416>>2]|0)+24384>>3];i=i;return}function nG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12256>>3]=+h[b+12280>>3]+ +h[(c[a+416>>2]|0)+22416>>3];i=i;return}function oG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12232>>3]=+h[b+12256>>3]+ +h[(c[a+416>>2]|0)+23608>>3];i=i;return}function pG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12208>>3]=+h[b+12232>>3]+ +h[(c[a+416>>2]|0)+21616>>3];i=i;return}function qG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12184>>3]=+h[b+12256>>3]+ +h[(c[a+416>>2]|0)+24480>>3];i=i;return}function rG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12160>>3]=+h[b+12208>>3]+ +h[(c[a+416>>2]|0)+25344>>3];i=i;return}function sG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11960>>3]=+h[b+12160>>3]+ +h[(c[a+416>>2]|0)+31368>>3];i=i;return}function tG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11632>>3]=+h[b+11960>>3]+ +h[(c[a+416>>2]|0)+30792>>3];i=i;return}function uG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11608>>3]=+h[b+11632>>3]+ +h[(c[a+416>>2]|0)+28824>>3];i=i;return}function vG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11584>>3]=+h[b+11608>>3]+ +h[(c[a+416>>2]|0)+30016>>3];i=i;return}function wG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11560>>3]=+h[b+11584>>3]+ +h[(c[a+416>>2]|0)+28024>>3];i=i;return}function xG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11536>>3]=+h[b+11608>>3]+ +h[(c[a+416>>2]|0)+30888>>3];i=i;return}function yG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11512>>3]=+h[b+11560>>3]+ +h[(c[a+416>>2]|0)+31752>>3];i=i;return}function zG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11360>>3]=+h[b+11512>>3]+ +h[(c[a+416>>2]|0)+37776>>3];i=i;return}function AG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11080>>3]=+h[b+11360>>3]+ +h[(c[a+416>>2]|0)+37200>>3];i=i;return}function BG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11056>>3]=+h[b+11080>>3]+ +h[(c[a+416>>2]|0)+35232>>3];i=i;return}function CG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11032>>3]=+h[b+11056>>3]+ +h[(c[a+416>>2]|0)+36424>>3];i=i;return}function DG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11008>>3]=+h[b+11056>>3]+ +h[(c[a+416>>2]|0)+37296>>3];i=i;return}function EG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10704>>3]=+h[b+11032>>3]+ +h[(c[a+416>>2]|0)+34432>>3];i=i;return}function FG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10680>>3]=+h[b+10704>>3]+ +h[(c[a+416>>2]|0)+38160>>3];i=i;return}function GG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10672>>3]=+h[b+14632>>3]+ +h[(c[a+416>>2]|0)+34064>>3];i=i;return}function HG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10664>>3]=+h[b+14624>>3]+ +h[(c[a+416>>2]|0)+34056>>3];i=i;return}function IG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10656>>3]=+h[b+14616>>3]+ +h[(c[a+416>>2]|0)+34048>>3];i=i;return}function JG(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24>>3]=0.0;i=i;return}function KG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23880>>3]=+X(+(+h[b+24>>3]));i=i;return}function LG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23888>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function MG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23896>>3]=+Y(+(+h[b+24>>3]));i=i;return}function NG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23024>>3]=+h[b+23896>>3]*.4999999999999999+ +h[b+23880>>3]*.8660254037844387;i=i;return}function OG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23040>>3]=+h[b+23896>>3]*.8660254037844387+ +h[b+23880>>3]*-.4999999999999999;i=i;return}function PG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13928>>3]=+h[b+23040>>3]*-.4999999999999999+ +h[b+23024>>3]*.8660254037844387;i=i;return}function QG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13944>>3]=+h[b+23040>>3]*.8660254037844387+ +h[b+23024>>3]*.4999999999999999;i=i;return}function RG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13720>>3]=+h[b+13928>>3]*6.123233995736766e-17- +h[b+13944>>3];i=i;return}function SG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13736>>3]=+h[b+13944>>3]*6.123233995736766e-17+ +h[b+13928>>3];i=i;return}function TG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13280>>3]=+h[b+13736>>3]+ +h[b+13720>>3]*6.123233995736766e-17;i=i;return}function UG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13296>>3]=+h[b+13736>>3]*6.123233995736766e-17- +h[b+13720>>3];i=i;return}function VG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13072>>3]=+h[b+13296>>3]*.5000000000000001+ +h[b+13280>>3]*-.8660254037844386;i=i;return}function WG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13088>>3]=+h[b+13296>>3]*-.8660254037844386+ +h[b+13280>>3]*-.5000000000000001;i=i;return}function XG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12632>>3]=+h[b+13088>>3]*-.5000000000000001+ +h[b+13072>>3]*-.8660254037844386;i=i;return}function YG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12648>>3]=+h[b+13088>>3]*-.8660254037844386+ +h[b+13072>>3]*.5000000000000001;i=i;return}function ZG(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12424>>3]=+h[b+12648>>3]*.5000000000000001+ +h[b+12632>>3]*-.8660254037844386;i=i;return}function _G(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12440>>3]=+h[b+12648>>3]*-.8660254037844386+ +h[b+12632>>3]*-.5000000000000001;i=i;return}function $G(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11984>>3]=+h[b+12440>>3]*-.5000000000000001+ +h[b+12424>>3]*-.8660254037844386;i=i;return}function aH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12e3>>3]=+h[b+12440>>3]*-.8660254037844386+ +h[b+12424>>3]*.5000000000000001;i=i;return}function bH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11776>>3]=+h[b+11984>>3]*6.123233995736766e-17- +h[b+12e3>>3];i=i;return}function cH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11792>>3]=+h[b+12e3>>3]*6.123233995736766e-17+ +h[b+11984>>3];i=i;return}function dH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23992>>3]=+h[b+11792>>3]+ +h[b+11776>>3]*6.123233995736766e-17;i=i;return}function eH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23968>>3]=+h[b+11792>>3]*6.123233995736766e-17- +h[b+11776>>3];i=i;return}function fH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11200>>3]=+h[b+23968>>3]*.4999999999999999+ +h[b+23992>>3]*.8660254037844387;i=i;return}function gH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11216>>3]=+h[b+23968>>3]*.8660254037844387+ +h[b+23992>>3]*-.4999999999999999;i=i;return}function hH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10840>>3]=+h[b+11216>>3]*.8660254037844387+ +h[b+11200>>3]*.4999999999999999;i=i;return}function iH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10824>>3]=+h[b+11216>>3]*-.4999999999999999+ +h[b+11200>>3]*.8660254037844387;i=i;return}function jH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3136>>3]=+h[b+23896>>3]*+h[d+5744>>3]+ +h[b+23880>>3]*+h[d+5752>>3];i=i;return}function kH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14848>>3]=+h[b+3136>>3]+(+h[b+23040>>3]*+h[d+5168>>3]+ +h[b+23024>>3]*+h[d+5176>>3]);i=i;return}function lH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14824>>3]=+h[b+14848>>3]+(+h[b+23040>>3]*+h[d+3200>>3]+ +h[b+23024>>3]*+h[d+3208>>3]);i=i;return}function mH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14776>>3]=+h[b+14824>>3]+(+h[b+23040>>3]*+h[d+5264>>3]+ +h[b+23024>>3]*+h[d+5272>>3]);i=i;return}function nH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14800>>3]=+h[b+14824>>3]+(+h[b+23040>>3]*+h[d+4392>>3]+ +h[b+23024>>3]*+h[d+4400>>3]);i=i;return}function oH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14752>>3]=+h[b+14800>>3]+(+h[b+23040>>3]*+h[d+2400>>3]+ +h[b+23024>>3]*+h[d+2408>>3]);i=i;return}function pH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14728>>3]=+h[b+14752>>3]+(+h[b+23040>>3]*+h[d+6128>>3]+ +h[b+23024>>3]*+h[d+6136>>3]);i=i;return}function qH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13920>>3]=+h[b+14728>>3]+(+h[b+13944>>3]*+h[d+12152>>3]+ +h[b+13928>>3]*+h[d+12160>>3]);i=i;return}function rH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13592>>3]=+h[b+13920>>3]+(+h[b+13736>>3]*+h[d+11576>>3]+ +h[b+13720>>3]*+h[d+11584>>3]);i=i;return}function sH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13568>>3]=+h[b+13592>>3]+(+h[b+13736>>3]*+h[d+9608>>3]+ +h[b+13720>>3]*+h[d+9616>>3]);i=i;return}function tH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13496>>3]=+h[b+13568>>3]+(+h[b+13736>>3]*+h[d+11672>>3]+ +h[b+13720>>3]*+h[d+11680>>3]);i=i;return}function uH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13544>>3]=+h[b+13568>>3]+(+h[b+13736>>3]*+h[d+10800>>3]+ +h[b+13720>>3]*+h[d+10808>>3]);i=i;return}function vH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13520>>3]=+h[b+13544>>3]+(+h[b+13736>>3]*+h[d+8808>>3]+ +h[b+13720>>3]*+h[d+8816>>3]);i=i;return}function wH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13472>>3]=+h[b+13520>>3]+(+h[b+13736>>3]*+h[d+12536>>3]+ +h[b+13720>>3]*+h[d+12544>>3]);i=i;return}function xH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13272>>3]=+h[b+13472>>3]+(+h[b+13296>>3]*+h[d+18560>>3]+ +h[b+13280>>3]*+h[d+18568>>3]);i=i;return}function yH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12944>>3]=+h[b+13272>>3]+(+h[b+13088>>3]*+h[d+17984>>3]+ +h[b+13072>>3]*+h[d+17992>>3]);i=i;return}function zH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12920>>3]=+h[b+12944>>3]+(+h[b+13088>>3]*+h[d+16016>>3]+ +h[b+13072>>3]*+h[d+16024>>3]);i=i;return}function AH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12848>>3]=+h[b+12920>>3]+(+h[b+13088>>3]*+h[d+18080>>3]+ +h[b+13072>>3]*+h[d+18088>>3]);i=i;return}function BH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12896>>3]=+h[b+12920>>3]+(+h[b+13088>>3]*+h[d+17208>>3]+ +h[b+13072>>3]*+h[d+17216>>3]);i=i;return}function CH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12872>>3]=+h[b+12896>>3]+(+h[b+13088>>3]*+h[d+15216>>3]+ +h[b+13072>>3]*+h[d+15224>>3]);i=i;return}function DH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12824>>3]=+h[b+12872>>3]+(+h[b+13088>>3]*+h[d+18944>>3]+ +h[b+13072>>3]*+h[d+18952>>3]);i=i;return}function EH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12624>>3]=+h[b+12824>>3]+(+h[b+12648>>3]*+h[d+24968>>3]+ +h[b+12632>>3]*+h[d+24976>>3]);i=i;return}function FH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12296>>3]=+h[b+12624>>3]+(+h[b+12440>>3]*+h[d+24392>>3]+ +h[b+12424>>3]*+h[d+24400>>3]);i=i;return}function GH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12272>>3]=+h[b+12296>>3]+(+h[b+12440>>3]*+h[d+22424>>3]+ +h[b+12424>>3]*+h[d+22432>>3]);i=i;return}function HH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12200>>3]=+h[b+12272>>3]+(+h[b+12440>>3]*+h[d+24488>>3]+ +h[b+12424>>3]*+h[d+24496>>3]);i=i;return}function IH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12248>>3]=+h[b+12272>>3]+(+h[b+12440>>3]*+h[d+23616>>3]+ +h[b+12424>>3]*+h[d+23624>>3]);i=i;return}function JH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12224>>3]=+h[b+12248>>3]+(+h[b+12440>>3]*+h[d+21624>>3]+ +h[b+12424>>3]*+h[d+21632>>3]);i=i;return}function KH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12176>>3]=+h[b+12224>>3]+(+h[b+12440>>3]*+h[d+25352>>3]+ +h[b+12424>>3]*+h[d+25360>>3]);i=i;return}function LH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11976>>3]=+h[b+12176>>3]+(+h[b+12e3>>3]*+h[d+31376>>3]+ +h[b+11984>>3]*+h[d+31384>>3]);i=i;return}function MH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11648>>3]=+h[b+11976>>3]+(+h[b+11792>>3]*+h[d+30800>>3]+ +h[b+11776>>3]*+h[d+30808>>3]);i=i;return}function NH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11624>>3]=+h[b+11648>>3]+(+h[b+11792>>3]*+h[d+28832>>3]+ +h[b+11776>>3]*+h[d+28840>>3]);i=i;return}function OH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11552>>3]=+h[b+11624>>3]+(+h[b+11792>>3]*+h[d+30896>>3]+ +h[b+11776>>3]*+h[d+30904>>3]);i=i;return}function PH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11600>>3]=+h[b+11624>>3]+(+h[b+11792>>3]*+h[d+30024>>3]+ +h[b+11776>>3]*+h[d+30032>>3]);i=i;return}function QH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11576>>3]=+h[b+11600>>3]+(+h[b+11792>>3]*+h[d+28032>>3]+ +h[b+11776>>3]*+h[d+28040>>3]);i=i;return}function RH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11528>>3]=+h[b+11576>>3]+(+h[b+11792>>3]*+h[d+31760>>3]+ +h[b+11776>>3]*+h[d+31768>>3]);i=i;return}function SH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11376>>3]=+h[b+11528>>3]+(+h[b+23968>>3]*+h[d+37784>>3]+ +h[b+23992>>3]*+h[d+37792>>3]);i=i;return}function TH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11096>>3]=+h[b+11376>>3]+(+h[b+11216>>3]*+h[d+37208>>3]+ +h[b+11200>>3]*+h[d+37216>>3]);i=i;return}function UH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11072>>3]=+h[b+11096>>3]+(+h[b+11216>>3]*+h[d+35240>>3]+ +h[b+11200>>3]*+h[d+35248>>3]);i=i;return}function VH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11024>>3]=+h[b+11072>>3]+(+h[b+11216>>3]*+h[d+37304>>3]+ +h[b+11200>>3]*+h[d+37312>>3]);i=i;return}function WH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11048>>3]=+h[b+11072>>3]+(+h[b+11216>>3]*+h[d+36432>>3]+ +h[b+11200>>3]*+h[d+36440>>3]);i=i;return}function XH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10720>>3]=+h[b+11048>>3]+(+h[b+11216>>3]*+h[d+34440>>3]+ +h[b+11200>>3]*+h[d+34448>>3]);i=i;return}function YH(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10696>>3]=+h[b+10720>>3]+(+h[b+11216>>3]*+h[d+38168>>3]+ +h[b+11200>>3]*+h[d+38176>>3]);i=i;return}function ZH(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23904>>3]=+X(+(+h[b+24>>3]));i=i;return}function _H(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23032>>3]=+h[b+23904>>3]*.4999999999999999+ +h[b+23888>>3]*.8660254037844387;i=i;return}function $H(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23048>>3]=+h[b+23904>>3]*.8660254037844387+ +h[b+23888>>3]*-.4999999999999999;i=i;return}function aI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13936>>3]=+h[b+23048>>3]*-.4999999999999999+ +h[b+23032>>3]*.8660254037844387;i=i;return}function bI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13952>>3]=+h[b+23048>>3]*.8660254037844387+ +h[b+23032>>3]*.4999999999999999;i=i;return}function cI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13728>>3]=+h[b+13936>>3]*6.123233995736766e-17- +h[b+13952>>3];i=i;return}function dI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13744>>3]=+h[b+13952>>3]*6.123233995736766e-17+ +h[b+13936>>3];i=i;return}function eI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13288>>3]=+h[b+13744>>3]+ +h[b+13728>>3]*6.123233995736766e-17;i=i;return}function fI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13304>>3]=+h[b+13744>>3]*6.123233995736766e-17- +h[b+13728>>3];i=i;return}function gI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13080>>3]=+h[b+13304>>3]*.5000000000000001+ +h[b+13288>>3]*-.8660254037844386;i=i;return}function hI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13096>>3]=+h[b+13304>>3]*-.8660254037844386+ +h[b+13288>>3]*-.5000000000000001;i=i;return}function iI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12640>>3]=+h[b+13096>>3]*-.5000000000000001+ +h[b+13080>>3]*-.8660254037844386;i=i;return}function jI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12656>>3]=+h[b+13096>>3]*-.8660254037844386+ +h[b+13080>>3]*.5000000000000001;i=i;return}function kI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12432>>3]=+h[b+12656>>3]*.5000000000000001+ +h[b+12640>>3]*-.8660254037844386;i=i;return}function lI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12448>>3]=+h[b+12656>>3]*-.8660254037844386+ +h[b+12640>>3]*-.5000000000000001;i=i;return}function mI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11992>>3]=+h[b+12448>>3]*-.5000000000000001+ +h[b+12432>>3]*-.8660254037844386;i=i;return}function nI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12008>>3]=+h[b+12448>>3]*-.8660254037844386+ +h[b+12432>>3]*.5000000000000001;i=i;return}function oI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11784>>3]=+h[b+11992>>3]*6.123233995736766e-17- +h[b+12008>>3];i=i;return}function pI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11800>>3]=+h[b+12008>>3]*6.123233995736766e-17+ +h[b+11992>>3];i=i;return}function qI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23984>>3]=+h[b+11800>>3]+ +h[b+11784>>3]*6.123233995736766e-17;i=i;return}function rI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23960>>3]=+h[b+11800>>3]*6.123233995736766e-17- +h[b+11784>>3];i=i;return}function sI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11208>>3]=+h[b+23960>>3]*.4999999999999999+ +h[b+23984>>3]*.8660254037844387;i=i;return}function tI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11224>>3]=+h[b+23960>>3]*.8660254037844387+ +h[b+23984>>3]*-.4999999999999999;i=i;return}function uI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10848>>3]=+h[b+11224>>3]*.8660254037844387+ +h[b+11208>>3]*.4999999999999999;i=i;return}function vI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10832>>3]=+h[b+11224>>3]*-.4999999999999999+ +h[b+11208>>3]*.8660254037844387;i=i;return}function wI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3144>>3]=+h[b+23904>>3]*+h[d+5744>>3]+ +h[b+23888>>3]*+h[d+5752>>3];i=i;return}function xI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14840>>3]=+h[b+3144>>3]+(+h[b+23048>>3]*+h[d+5168>>3]+ +h[b+23032>>3]*+h[d+5176>>3]);i=i;return}function yI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14816>>3]=+h[b+14840>>3]+(+h[b+23048>>3]*+h[d+3200>>3]+ +h[b+23032>>3]*+h[d+3208>>3]);i=i;return}function zI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14768>>3]=+h[b+14816>>3]+(+h[b+23048>>3]*+h[d+5264>>3]+ +h[b+23032>>3]*+h[d+5272>>3]);i=i;return}function AI(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,0)|0;d=c[(c[a+476>>2]|0)+28>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3416>>3]=+h[d>>3];h[e+3408>>3]=+h[d+8>>3];i=b;return}function BI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+44>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3592>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3592|0;h[c[g+48>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3592>>3]);e=c[f>>2]|0;h[c[e+52>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+44>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26608>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26608|0;h[(c[e+48>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26608>>3]);j=c[f>>2]|0;h[(c[j+52>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+44>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26592>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26592|0;h[(c[j+48>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26592>>3]);h[(c[(c[f>>2]|0)+52>>2]|0)+16>>3]=k;qFc(a,0)|0;g=c[(c[f>>2]|0)+44>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+3592>>3]=+h[g>>3];h[f+26608>>3]=+h[g+8>>3];h[f+26592>>3]=+h[g+16>>3];wu(a);xu(a);yu(a);zu(a);Au(a);Bu(a);Cu(a);Du(a);Eu(a);Fu(a);Gu(a);Hu(a);Iu(a);i=b;return}function CI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=+h[b+23864>>3]*+h[b+23048>>3]+ +h[b+23872>>3]*+h[b+23040>>3];i=i;return}function DI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7840>>3]=+h[b+23864>>3]*+h[b+23032>>3]+ +h[b+23872>>3]*+h[b+23024>>3];i=i;return}function EI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=+h[b+23840>>3]*+h[b+23048>>3]+ +h[b+23848>>3]*+h[b+23040>>3];i=i;return}function FI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=+h[b+23840>>3]*+h[b+23032>>3]+ +h[b+23848>>3]*+h[b+23024>>3];i=i;return}function GI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3448>>3]=+h[b+3592>>3]- +h[(c[a+416>>2]|0)+1112>>3];i=i;return}function HI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3400>>3]=+h[b+3448>>3]- +h[(c[a+416>>2]|0)+1496>>3];i=i;return}function II(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24144>>3]=+h[b+3400>>3]- +h[b+14760>>3];i=i;return}function JI(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26608>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26600|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26608>>3];g=e;j=g+26600|0;k=j;h[k>>3]=f;i=b;return}function KI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26584>>3]=+h[(c[a+416>>2]|0)+38880>>3]- +h[b+26608>>3];i=i;return}function LI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+40256>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26584>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26568|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26568|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,4624,4616,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26568|0;q=p;h[q>>3]=n;i=d;return}function MI(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+40256>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26584>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,4624,4648,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26576>>3]=m+1.0;i=d;return}function NI(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26544>>3]=+h[b+40272>>3]+ +h[b+40280>>3]*(1.0- +h[d+26576>>3]);i=i;return}function OI(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26544>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26560|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,4664,4656,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26560|0;p=o;h[p>>3]=m;i=d;return}function PI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14792>>3]=+h[b+14816>>3]+(+h[b+23048>>3]*+h[d+4392>>3]+ +h[b+23032>>3]*+h[d+4400>>3]);i=i;return}function QI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14744>>3]=+h[b+14792>>3]+(+h[b+23048>>3]*+h[d+2400>>3]+ +h[b+23032>>3]*+h[d+2408>>3]);i=i;return}function RI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14720>>3]=+h[b+14744>>3]+(+h[b+23048>>3]*+h[d+6128>>3]+ +h[b+23032>>3]*+h[d+6136>>3]);i=i;return}function SI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13912>>3]=+h[b+14720>>3]+(+h[b+13952>>3]*+h[d+12152>>3]+ +h[b+13936>>3]*+h[d+12160>>3]);i=i;return}function TI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13584>>3]=+h[b+13912>>3]+(+h[b+13744>>3]*+h[d+11576>>3]+ +h[b+13728>>3]*+h[d+11584>>3]);i=i;return}function UI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13560>>3]=+h[b+13584>>3]+(+h[b+13744>>3]*+h[d+9608>>3]+ +h[b+13728>>3]*+h[d+9616>>3]);i=i;return}function VI(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13488>>3]=+h[b+13560>>3]+(+h[b+13744>>3]*+h[d+11672>>3]+ +h[b+13728>>3]*+h[d+11680>>3]);i=i;return}function WI(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,1)|0;d=c[(c[a+476>>2]|0)+92>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+2832>>3]=+h[d>>3];h[e+2840>>3]=+h[d+8>>3];i=b;return}function XI(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+124>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3e3>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3e3|0;h[c[g+128>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3e3>>3]);e=c[f>>2]|0;h[c[e+132>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+124>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26496>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26496|0;h[(c[e+128>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26496>>3]);j=c[f>>2]|0;h[(c[j+132>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+124>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26480>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26480|0;h[(c[j+128>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26480>>3]);h[(c[(c[f>>2]|0)+132>>2]|0)+16>>3]=k;qFc(a,1)|0;g=c[(c[f>>2]|0)+124>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+3e3>>3]=+h[g>>3];h[f+26496>>3]=+h[g+8>>3];h[f+26480>>3]=+h[g+16>>3];Lu(a);Mu(a);Nu(a);Ou(a);Pu(a);Qu(a);Ru(a);Su(a);Tu(a);Uu(a);Vu(a);Wu(a);Xu(a);i=b;return}function YI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9536>>3]=+h[b+23720>>3]*+h[b+13744>>3]+ +h[b+23728>>3]*+h[b+13736>>3];i=i;return}function ZI(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9560>>3]=+h[b+23720>>3]*+h[b+13728>>3]+ +h[b+23728>>3]*+h[b+13720>>3];i=i;return}function _I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9528>>3]=+h[b+23696>>3]*+h[b+13744>>3]+ +h[b+23704>>3]*+h[b+13736>>3];i=i;return}function $I(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9552>>3]=+h[b+23696>>3]*+h[b+13728>>3]+ +h[b+23704>>3]*+h[b+13720>>3];i=i;return}function aJ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26496>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26488|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26496>>3];g=e;j=g+26488|0;k=j;h[k>>3]=f;i=b;return}function bJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26472>>3]=+h[(c[a+416>>2]|0)+40360>>3]- +h[b+26496>>3];i=i;return}function cJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+41736>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26472>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26456|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26456|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,4696,4688,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26456|0;q=p;h[q>>3]=n;i=d;return}function dJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+41736>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26472>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,4696,4720,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26464>>3]=m+1.0;i=d;return}function eJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26432>>3]=+h[b+41752>>3]+ +h[b+41760>>3]*(1.0- +h[d+26464>>3]);i=i;return}function fJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26432>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26448|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,4736,4728,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26448|0;p=o;h[p>>3]=m;i=d;return}function gJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=+h[b+3e3>>3]- +h[(c[a+416>>2]|0)+7520>>3];i=i;return}function hJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=+h[b+2872>>3]- +h[(c[a+416>>2]|0)+7904>>3];i=i;return}function iJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24352>>3]=+h[b+2824>>3]- +h[b+13480>>3];i=i;return}function jJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13536>>3]=+h[b+13560>>3]+(+h[b+13744>>3]*+h[d+10800>>3]+ +h[b+13728>>3]*+h[d+10808>>3]);i=i;return}function kJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13512>>3]=+h[b+13536>>3]+(+h[b+13744>>3]*+h[d+8808>>3]+ +h[b+13728>>3]*+h[d+8816>>3]);i=i;return}function lJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13464>>3]=+h[b+13512>>3]+(+h[b+13744>>3]*+h[d+12536>>3]+ +h[b+13728>>3]*+h[d+12544>>3]);i=i;return}function mJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13264>>3]=+h[b+13464>>3]+(+h[b+13304>>3]*+h[d+18560>>3]+ +h[b+13288>>3]*+h[d+18568>>3]);i=i;return}function nJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12936>>3]=+h[b+13264>>3]+(+h[b+13096>>3]*+h[d+17984>>3]+ +h[b+13080>>3]*+h[d+17992>>3]);i=i;return}function oJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12912>>3]=+h[b+12936>>3]+(+h[b+13096>>3]*+h[d+16016>>3]+ +h[b+13080>>3]*+h[d+16024>>3]);i=i;return}function pJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12840>>3]=+h[b+12912>>3]+(+h[b+13096>>3]*+h[d+18080>>3]+ +h[b+13080>>3]*+h[d+18088>>3]);i=i;return}function qJ(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,2)|0;d=c[(c[a+476>>2]|0)+156>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+2224>>3]=+h[d>>3];h[e+2232>>3]=+h[d+8>>3];i=b;return}function rJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+204>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2392>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2392|0;h[c[g+208>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2392>>3]);e=c[f>>2]|0;h[c[e+212>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+204>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26384>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26384|0;h[(c[e+208>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26384>>3]);j=c[f>>2]|0;h[(c[j+212>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+204>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26368>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26368|0;h[(c[j+208>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26368>>3]);h[(c[(c[f>>2]|0)+212>>2]|0)+16>>3]=k;qFc(a,2)|0;g=c[(c[f>>2]|0)+204>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2392>>3]=+h[g>>3];h[f+26384>>3]=+h[g+8>>3];h[f+26368>>3]=+h[g+16>>3];_u(a);$u(a);av(a);bv(a);cv(a);dv(a);ev(a);fv(a);gv(a);hv(a);iv(a);jv(a);kv(a);i=b;return}function sJ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26384>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26376|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26384>>3];g=e;j=g+26376|0;k=j;h[k>>3]=f;i=b;return}function tJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26360>>3]=+h[(c[a+416>>2]|0)+41840>>3]- +h[b+26384>>3];i=i;return}function uJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+43216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26360>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26344|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26344|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,4768,4760,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26344|0;q=p;h[q>>3]=n;i=d;return}function vJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+43216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26360>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,4768,4792,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26352>>3]=m+1.0;i=d;return}function wJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26320>>3]=+h[b+43232>>3]+ +h[b+43240>>3]*(1.0- +h[d+26352>>3]);i=i;return}function xJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26320>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26336|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,4808,4800,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26336|0;p=o;h[p>>3]=m;i=d;return}function yJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9784>>3]=+h[b+23576>>3]*+h[b+13096>>3]+ +h[b+23584>>3]*+h[b+13088>>3];i=i;return}function zJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9808>>3]=+h[b+23576>>3]*+h[b+13080>>3]+ +h[b+23584>>3]*+h[b+13072>>3];i=i;return}function AJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9792>>3]=+h[b+23600>>3]*+h[b+13096>>3]+ +h[b+23608>>3]*+h[b+13088>>3];i=i;return}function BJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9816>>3]=+h[b+23600>>3]*+h[b+13080>>3]+ +h[b+23608>>3]*+h[b+13072>>3];i=i;return}function CJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2264>>3]=+h[b+2392>>3]- +h[(c[a+416>>2]|0)+13928>>3];i=i;return}function DJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+2264>>3]- +h[(c[a+416>>2]|0)+14312>>3];i=i;return}function EJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24560>>3]=+h[b+2216>>3]- +h[b+12832>>3];i=i;return}function FJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12888>>3]=+h[b+12912>>3]+(+h[b+13096>>3]*+h[d+17208>>3]+ +h[b+13080>>3]*+h[d+17216>>3]);i=i;return}function GJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12864>>3]=+h[b+12888>>3]+(+h[b+13096>>3]*+h[d+15216>>3]+ +h[b+13080>>3]*+h[d+15224>>3]);i=i;return}function HJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12816>>3]=+h[b+12864>>3]+(+h[b+13096>>3]*+h[d+18944>>3]+ +h[b+13080>>3]*+h[d+18952>>3]);i=i;return}function IJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12616>>3]=+h[b+12816>>3]+(+h[b+12656>>3]*+h[d+24968>>3]+ +h[b+12640>>3]*+h[d+24976>>3]);i=i;return}function JJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12288>>3]=+h[b+12616>>3]+(+h[b+12448>>3]*+h[d+24392>>3]+ +h[b+12432>>3]*+h[d+24400>>3]);i=i;return}function KJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12264>>3]=+h[b+12288>>3]+(+h[b+12448>>3]*+h[d+22424>>3]+ +h[b+12432>>3]*+h[d+22432>>3]);i=i;return}function LJ(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12192>>3]=+h[b+12264>>3]+(+h[b+12448>>3]*+h[d+24488>>3]+ +h[b+12432>>3]*+h[d+24496>>3]);i=i;return}function MJ(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,3)|0;d=c[(c[a+476>>2]|0)+220>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1608>>3]=+h[d>>3];h[e+1600>>3]=+h[d+8>>3];i=b;return}function NJ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+284>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1768>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1768|0;h[c[g+288>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1768>>3]);e=c[f>>2]|0;h[c[e+292>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+284>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26272>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26272|0;h[(c[e+288>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26272>>3]);j=c[f>>2]|0;h[(c[j+292>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+284>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26256>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26256|0;h[(c[j+288>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26256>>3]);h[(c[(c[f>>2]|0)+292>>2]|0)+16>>3]=k;qFc(a,3)|0;g=c[(c[f>>2]|0)+284>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1768>>3]=+h[g>>3];h[f+26272>>3]=+h[g+8>>3];h[f+26256>>3]=+h[g+16>>3];nv(a);ov(a);pv(a);qv(a);rv(a);sv(a);tv(a);uv(a);vv(a);wv(a);xv(a);yv(a);zv(a);i=b;return}function OJ(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26272>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26264|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26272>>3];g=e;j=g+26264|0;k=j;h[k>>3]=f;i=b;return}function PJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26248>>3]=+h[(c[a+416>>2]|0)+43320>>3]- +h[b+26272>>3];i=i;return}function QJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+44696>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26248>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26232|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26232|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,4840,4832,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26232|0;q=p;h[q>>3]=n;i=d;return}function RJ(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+44696>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26248>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,4840,4864,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26240>>3]=m+1.0;i=d;return}function SJ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26208>>3]=+h[b+44712>>3]+ +h[b+44720>>3]*(1.0- +h[d+26240>>3]);i=i;return}function TJ(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26208>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26224|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,4880,4872,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26224|0;p=o;h[p>>3]=m;i=d;return}function UJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+1768>>3]- +h[(c[a+416>>2]|0)+20336>>3];i=i;return}function VJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+1640>>3]- +h[(c[a+416>>2]|0)+20720>>3];i=i;return}function WJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24768>>3]=+h[b+1592>>3]- +h[b+12184>>3];i=i;return}function XJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10040>>3]=+h[b+23456>>3]*+h[b+12448>>3]+ +h[b+23464>>3]*+h[b+12440>>3];i=i;return}function YJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10064>>3]=+h[b+23456>>3]*+h[b+12432>>3]+ +h[b+23464>>3]*+h[b+12424>>3];i=i;return}function ZJ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10048>>3]=+h[b+23480>>3]*+h[b+12448>>3]+ +h[b+23488>>3]*+h[b+12440>>3];i=i;return}function _J(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10072>>3]=+h[b+23480>>3]*+h[b+12432>>3]+ +h[b+23488>>3]*+h[b+12424>>3];i=i;return}function $J(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12240>>3]=+h[b+12264>>3]+(+h[b+12448>>3]*+h[d+23616>>3]+ +h[b+12432>>3]*+h[d+23624>>3]);i=i;return}function aK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12216>>3]=+h[b+12240>>3]+(+h[b+12448>>3]*+h[d+21624>>3]+ +h[b+12432>>3]*+h[d+21632>>3]);i=i;return}function bK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12168>>3]=+h[b+12216>>3]+(+h[b+12448>>3]*+h[d+25352>>3]+ +h[b+12432>>3]*+h[d+25360>>3]);i=i;return}function cK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11968>>3]=+h[b+12168>>3]+(+h[b+12008>>3]*+h[d+31376>>3]+ +h[b+11992>>3]*+h[d+31384>>3]);i=i;return}function dK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11640>>3]=+h[b+11968>>3]+(+h[b+11800>>3]*+h[d+30800>>3]+ +h[b+11784>>3]*+h[d+30808>>3]);i=i;return}function eK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11616>>3]=+h[b+11640>>3]+(+h[b+11800>>3]*+h[d+28832>>3]+ +h[b+11784>>3]*+h[d+28840>>3]);i=i;return}function fK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11544>>3]=+h[b+11616>>3]+(+h[b+11800>>3]*+h[d+30896>>3]+ +h[b+11784>>3]*+h[d+30904>>3]);i=i;return}function gK(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,4)|0;d=c[(c[a+476>>2]|0)+284>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+984>>3]=+h[d>>3];h[e+976>>3]=+h[d+8>>3];i=b;return}function hK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+364>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1144>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1144|0;h[c[g+368>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1144>>3]);e=c[f>>2]|0;h[c[e+372>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+364>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26160>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26160|0;h[(c[e+368>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26160>>3]);j=c[f>>2]|0;h[(c[j+372>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+364>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26144>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26144|0;h[(c[j+368>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26144>>3]);h[(c[(c[f>>2]|0)+372>>2]|0)+16>>3]=k;qFc(a,4)|0;g=c[(c[f>>2]|0)+364>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1144>>3]=+h[g>>3];h[f+26160>>3]=+h[g+8>>3];h[f+26144>>3]=+h[g+16>>3];Cv(a);Dv(a);Ev(a);Fv(a);Gv(a);Hv(a);Iv(a);Jv(a);Kv(a);Lv(a);Mv(a);Nv(a);Ov(a);i=b;return}function iK(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26160>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26152|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26160>>3];g=e;j=g+26152|0;k=j;h[k>>3]=f;i=b;return}function jK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26136>>3]=+h[(c[a+416>>2]|0)+44800>>3]- +h[b+26160>>3];i=i;return}function kK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+46176>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26136>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26120|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26120|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,4912,4904,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26120|0;q=p;h[q>>3]=n;i=d;return}function lK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+46176>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26136>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,4912,4936,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26128>>3]=m+1.0;i=d;return}function mK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26096>>3]=+h[b+46192>>3]+ +h[b+46200>>3]*(1.0- +h[d+26128>>3]);i=i;return}function nK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26096>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26112|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,4952,4944,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26112|0;p=o;h[p>>3]=m;i=d;return}function oK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10296>>3]=+h[b+23336>>3]*+h[b+11800>>3]+ +h[b+23344>>3]*+h[b+11792>>3];i=i;return}function pK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10320>>3]=+h[b+23336>>3]*+h[b+11784>>3]+ +h[b+23344>>3]*+h[b+11776>>3];i=i;return}function qK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10304>>3]=+h[b+23360>>3]*+h[b+11800>>3]+ +h[b+23368>>3]*+h[b+11792>>3];i=i;return}function rK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10328>>3]=+h[b+23360>>3]*+h[b+11784>>3]+ +h[b+23368>>3]*+h[b+11776>>3];i=i;return}function sK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+1144>>3]- +h[(c[a+416>>2]|0)+26744>>3];i=i;return}function tK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+1016>>3]- +h[(c[a+416>>2]|0)+27128>>3];i=i;return}function uK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24976>>3]=+h[b+968>>3]- +h[b+11536>>3];i=i;return}function vK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11592>>3]=+h[b+11616>>3]+(+h[b+11800>>3]*+h[d+30024>>3]+ +h[b+11784>>3]*+h[d+30032>>3]);i=i;return}function wK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11568>>3]=+h[b+11592>>3]+(+h[b+11800>>3]*+h[d+28032>>3]+ +h[b+11784>>3]*+h[d+28040>>3]);i=i;return}function xK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11520>>3]=+h[b+11568>>3]+(+h[b+11800>>3]*+h[d+31760>>3]+ +h[b+11784>>3]*+h[d+31768>>3]);i=i;return}function yK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11368>>3]=+h[b+11520>>3]+(+h[b+23960>>3]*+h[d+37784>>3]+ +h[b+23984>>3]*+h[d+37792>>3]);i=i;return}function zK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11088>>3]=+h[b+11368>>3]+(+h[b+11224>>3]*+h[d+37208>>3]+ +h[b+11208>>3]*+h[d+37216>>3]);i=i;return}function AK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11064>>3]=+h[b+11088>>3]+(+h[b+11224>>3]*+h[d+35240>>3]+ +h[b+11208>>3]*+h[d+35248>>3]);i=i;return}function BK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11016>>3]=+h[b+11064>>3]+(+h[b+11224>>3]*+h[d+37304>>3]+ +h[b+11208>>3]*+h[d+37312>>3]);i=i;return}function CK(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,5)|0;d=c[(c[a+476>>2]|0)+348>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+376>>3]=+h[d>>3];h[e+384>>3]=+h[d+8>>3];i=b;return}function DK(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+444>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+520|0;h[c[g+448>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+520>>3]);e=c[f>>2]|0;h[c[e+452>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+444>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26048>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26048|0;h[(c[e+448>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26048>>3]);j=c[f>>2]|0;h[(c[j+452>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+444>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26032>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26032|0;h[(c[j+448>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26032>>3]);h[(c[(c[f>>2]|0)+452>>2]|0)+16>>3]=k;qFc(a,5)|0;g=c[(c[f>>2]|0)+444>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+520>>3]=+h[g>>3];h[f+26048>>3]=+h[g+8>>3];h[f+26032>>3]=+h[g+16>>3];Rv(a);Sv(a);Tv(a);Uv(a);Vv(a);Wv(a);Xv(a);Yv(a);Zv(a);_v(a);$v(a);aw(a);bw(a);i=b;return}function EK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10552>>3]=+h[b+23216>>3]*+h[b+11224>>3]+ +h[b+23224>>3]*+h[b+11216>>3];i=i;return}function FK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10576>>3]=+h[b+23216>>3]*+h[b+11208>>3]+ +h[b+23224>>3]*+h[b+11200>>3];i=i;return}function GK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10560>>3]=+h[b+23240>>3]*+h[b+11224>>3]+ +h[b+23248>>3]*+h[b+11216>>3];i=i;return}function HK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10584>>3]=+h[b+23240>>3]*+h[b+11208>>3]+ +h[b+23248>>3]*+h[b+11200>>3];i=i;return}function IK(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26048>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26040|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26048>>3];g=e;j=g+26040|0;k=j;h[k>>3]=f;i=b;return}function JK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26024>>3]=+h[(c[a+416>>2]|0)+46280>>3]- +h[b+26048>>3];i=i;return}function KK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+47656>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26024>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26008|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26008|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,4984,4976,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26008|0;q=p;h[q>>3]=n;i=d;return}function LK(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+47656>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26024>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,4984,5008,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26016>>3]=m+1.0;i=d;return}function MK(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+25984>>3]=+h[b+47672>>3]+ +h[b+47680>>3]*(1.0- +h[d+26016>>3]);i=i;return}function NK(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+25984>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26e3|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,5024,5016,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26e3|0;p=o;h[p>>3]=m;i=d;return}function OK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=+h[b+520>>3]- +h[(c[a+416>>2]|0)+33152>>3];i=i;return}function PK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+416>>3]- +h[(c[a+416>>2]|0)+33536>>3];i=i;return}function QK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25184>>3]=+h[b+368>>3]- +h[b+11008>>3];i=i;return}function RK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11040>>3]=+h[b+11064>>3]+(+h[b+11224>>3]*+h[d+36432>>3]+ +h[b+11208>>3]*+h[d+36440>>3]);i=i;return}function SK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10712>>3]=+h[b+11040>>3]+(+h[b+11224>>3]*+h[d+34440>>3]+ +h[b+11208>>3]*+h[d+34448>>3]);i=i;return}function TK(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10688>>3]=+h[b+10712>>3]+(+h[b+11224>>3]*+h[d+38168>>3]+ +h[b+11208>>3]*+h[d+38176>>3]);i=i;return}function UK(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+16>>3]=10.0;i=i;return}function VK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26656>>3]=+h[b+16>>3]*9.549296585513721;i=i;return}function WK(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+16>>3];i=i;return}function XK(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47712>>3];j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+16>>3];do{if(g!=0.0){n=l;o=f;p=m/g}else{if(m==0.0){n=l;o=f;p=m;break}q=m/+KBc(c[b+536>>2]|0,g,5056,5048,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=c[e>>2]|0;p=q}}while(0);h[n+25952>>3]=p*p*+h[o+47704>>3];i=d;return}function YK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+4104>>3]=-(d*+h[b+16>>3]);i=i;return}function ZK(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+4112>>3]=d*+h[b+16>>3];i=i;return}function _K(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+4120>>3]=-(d*+h[b+16>>3]);i=i;return}function $K(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+4104>>3]*.4999999999999999+ +h[b+4120>>3]*.8660254037844387;i=i;return}function aL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+4104>>3]*.8660254037844387+ +h[b+4120>>3]*-.4999999999999999;i=i;return}function bL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9400>>3]=+h[b+4072>>3]*-.4999999999999999+ +h[b+4088>>3]*.8660254037844387;i=i;return}function cL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9384>>3]=+h[b+4072>>3]*.8660254037844387+ +h[b+4088>>3]*.4999999999999999;i=i;return}function dL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9352>>3]=+h[b+9400>>3]*6.123233995736766e-17- +h[b+9384>>3];i=i;return}function eL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9336>>3]=+h[b+9384>>3]*6.123233995736766e-17+ +h[b+9400>>3];i=i;return}function fL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9304>>3]=+h[b+9336>>3]+ +h[b+9352>>3]*6.123233995736766e-17;i=i;return}function gL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9288>>3]=+h[b+9336>>3]*6.123233995736766e-17- +h[b+9352>>3];i=i;return}function hL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9256>>3]=+h[b+9288>>3]*.5000000000000001+ +h[b+9304>>3]*-.8660254037844386;i=i;return}function iL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9240>>3]=+h[b+9288>>3]*-.8660254037844386+ +h[b+9304>>3]*-.5000000000000001;i=i;return}function jL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9208>>3]=+h[b+9240>>3]*-.5000000000000001+ +h[b+9256>>3]*-.8660254037844386;i=i;return}function kL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9192>>3]=+h[b+9240>>3]*-.8660254037844386+ +h[b+9256>>3]*.5000000000000001;i=i;return}function lL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9160>>3]=+h[b+9192>>3]*.5000000000000001+ +h[b+9208>>3]*-.8660254037844386;i=i;return}function mL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9144>>3]=+h[b+9192>>3]*-.8660254037844386+ +h[b+9208>>3]*-.5000000000000001;i=i;return}function nL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=+h[b+9144>>3]*-.5000000000000001+ +h[b+9160>>3]*-.8660254037844386;i=i;return}function oL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=+h[b+9144>>3]*-.8660254037844386+ +h[b+9160>>3]*.5000000000000001;i=i;return}function pL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9064>>3]=+h[b+9112>>3]*6.123233995736766e-17- +h[b+9096>>3];i=i;return}function qL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9048>>3]=+h[b+9096>>3]*6.123233995736766e-17+ +h[b+9112>>3];i=i;return}function rL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9016>>3]=+h[b+9048>>3]+ +h[b+9064>>3]*6.123233995736766e-17;i=i;return}function sL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9e3>>3]=+h[b+9048>>3]*6.123233995736766e-17- +h[b+9064>>3];i=i;return}function tL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8968>>3]=+h[b+9e3>>3]*.4999999999999999+ +h[b+9016>>3]*.8660254037844387;i=i;return}function uL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=+h[b+9e3>>3]*.8660254037844387+ +h[b+9016>>3]*-.4999999999999999;i=i;return}function vL(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+4128>>3]=-(d*+h[b+16>>3]);i=i;return}function wL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+4112>>3]*.4999999999999999+ +h[b+4128>>3]*.8660254037844387;i=i;return}function xL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+4112>>3]*.8660254037844387+ +h[b+4128>>3]*-.4999999999999999;i=i;return}function yL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9408>>3]=+h[b+4080>>3]*-.4999999999999999+ +h[b+4096>>3]*.8660254037844387;i=i;return}function zL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9392>>3]=+h[b+4080>>3]*.8660254037844387+ +h[b+4096>>3]*.4999999999999999;i=i;return}function AL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9360>>3]=+h[b+9408>>3]*6.123233995736766e-17- +h[b+9392>>3];i=i;return}function BL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9344>>3]=+h[b+9392>>3]*6.123233995736766e-17+ +h[b+9408>>3];i=i;return}function CL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9312>>3]=+h[b+9344>>3]+ +h[b+9360>>3]*6.123233995736766e-17;i=i;return}function DL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9296>>3]=+h[b+9344>>3]*6.123233995736766e-17- +h[b+9360>>3];i=i;return}function EL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9264>>3]=+h[b+9296>>3]*.5000000000000001+ +h[b+9312>>3]*-.8660254037844386;i=i;return}function FL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9248>>3]=+h[b+9296>>3]*-.8660254037844386+ +h[b+9312>>3]*-.5000000000000001;i=i;return}function GL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9216>>3]=+h[b+9248>>3]*-.5000000000000001+ +h[b+9264>>3]*-.8660254037844386;i=i;return}function HL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9200>>3]=+h[b+9248>>3]*-.8660254037844386+ +h[b+9264>>3]*.5000000000000001;i=i;return}function IL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9168>>3]=+h[b+9200>>3]*.5000000000000001+ +h[b+9216>>3]*-.8660254037844386;i=i;return}function JL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9152>>3]=+h[b+9200>>3]*-.8660254037844386+ +h[b+9216>>3]*-.5000000000000001;i=i;return}function KL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=+h[b+9152>>3]*-.5000000000000001+ +h[b+9168>>3]*-.8660254037844386;i=i;return}function LL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9104>>3]=+h[b+9152>>3]*-.8660254037844386+ +h[b+9168>>3]*.5000000000000001;i=i;return}function ML(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9072>>3]=+h[b+9120>>3]*6.123233995736766e-17- +h[b+9104>>3];i=i;return}function NL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9056>>3]=+h[b+9104>>3]*6.123233995736766e-17+ +h[b+9120>>3];i=i;return}function OL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9024>>3]=+h[b+9056>>3]+ +h[b+9072>>3]*6.123233995736766e-17;i=i;return}function PL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9008>>3]=+h[b+9056>>3]*6.123233995736766e-17- +h[b+9072>>3];i=i;return}function QL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8976>>3]=+h[b+9008>>3]*.4999999999999999+ +h[b+9024>>3]*.8660254037844387;i=i;return}



function Je(a){a=a|0;var b=0;b=i;i=i+a|0;i=i+7&-8;return b|0}function Ke(){return i|0}function Le(a){a=a|0;i=a}function Me(a,b){a=a|0;b=b|0;if((u|0)==0){u=a;v=b}}function Ne(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0]}function Oe(b){b=b|0;a[k]=a[b];a[k+1|0]=a[b+1|0];a[k+2|0]=a[b+2|0];a[k+3|0]=a[b+3|0];a[k+4|0]=a[b+4|0];a[k+5|0]=a[b+5|0];a[k+6|0]=a[b+6|0];a[k+7|0]=a[b+7|0]}function Pe(a){a=a|0;J=a}function Qe(a){a=a|0;K=a}function Re(a){a=a|0;L=a}function Se(a){a=a|0;M=a}function Te(a){a=a|0;N=a}function Ue(a){a=a|0;O=a}function Ve(a){a=a|0;P=a}function We(a){a=a|0;Q=a}function Xe(a){a=a|0;R=a}function Ye(a){a=a|0;S=a}function Ze(a){a=a|0;var b=0,d=0;b=i;_Fc(a)|0;d=a+540|0;ie[c[(c[d>>2]|0)+40>>2]&127](a)|0;ie[c[(c[d>>2]|0)+28>>2]&127](a)|0;ie[c[(c[d>>2]|0)+32>>2]&127](a)|0;ie[c[(c[d>>2]|0)+48>>2]&127](a)|0;ie[c[(c[d>>2]|0)+52>>2]&127](a)|0;DEc(a);i=b;return}function _e(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0.0,Y=0.0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0;e=i;i=i+32|0;f=e;g=e+24|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+16|0;r=i;i=i+24|0;s=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;c[v>>2]=0;y=b+240|0;z=d;h[z>>3]=+h[y>>3];if((c[2]|0)==0){A=0}else{B=c[b+88>>2]|0;C=L4c(B|0)|0;D=h4c(C+11|0)|0;W4c(D|0,B|0,C|0)|0;B=D+C+0|0;C=16|0;E=B+11|0;do{a[B]=a[C]|0;B=B+1|0;C=C+1|0}while((B|0)<(E|0));C=ic(D|0,32)|0;if((C|0)==0){B=Wd(c[(Nc()|0)>>2]|0)|0;c[u>>2]=D;c[u+4>>2]=B;GBc(23,0,40,u);Yc(0)|0;F=0}else{F=C}i4c(D);A=F}F=b+248|0;D=b+536|0;C=b;u=b+4|0;B=d+36|0;E=d+16|0;G=b+256|0;H=d+8|0;I=d+24|0;J=d+32|0;K=b+540|0;L=d+48|0;M=c[t>>2]|0;N=v;O=w;P=b+64|0;Q=b+72|0;R=x;S=0;T=A;while(1){if(!(+h[z>>3]<+h[F>>3])){U=T;V=0;break}Ce[c[293204>>2]&7]()|0;c[(c[D>>2]|0)+84>>2]=1;if((c[2]|0)!=0){if(((c[Q>>2]|0)+(c[P>>2]|0)|0)>0){A=0;do{$Cc(A+9|0);A=A+1|0;}while((A|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0))}$Cc(2);_Cc(2)}PCc(c[C>>2]|0,1,c[u>>2]|0);if((c[B>>2]|0)==1){A=s;h[k>>3]=+h[z>>3]- +h[E>>3];c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];EBc(23,0,104,s);W=S}else{W=S+1|0}X=+h[y>>3];h[H>>3]=X+ +(W>>>0)*(+h[F>>3]-X)/+(c[G>>2]|0)- +h[z>>3];qEc(b,d);X=+h[z>>3];Y=+h[H>>3];A=r;h[k>>3]=X;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+8|0;h[k>>3]=X+Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];A=r+16|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];EBc(23,1,144,r);Z=IFc(b,d)|0;if((c[I>>2]|0)==5){U=T;V=0;break}Ze(b);EEc(b);if((c[292396>>2]|0)!=0){fe[c[73214]&1023](23)}if((c[2]|0)!=0){_Cc(4)}A=sEc(b,c[J>>2]|0,z,d)|0;if((A|0)>0){c[(c[D>>2]|0)+84>>2]=4;Y=+h[z>>3];c[q>>2]=(A|0)==1?224:232;A=q+4|0;h[k>>3]=Y;c[A>>2]=c[k>>2];c[A+4>>2]=c[k+4>>2];EBc(7,1,200,q);if((c[349212>>2]|0)==0){ge[c[333900>>2]&255](333880,b)}uEc(b,c[J>>2]|0,z,d);if((c[292332>>2]|0)!=0){fe[c[73214]&1023](7)}c[(c[D>>2]|0)+84>>2]=1;c[B>>2]=1;IEc(b)}else{h[E>>3]=+h[z>>3];c[B>>2]=0}if((c[2]|0)!=0){bDc(4)}if((UFc(b,1,1)|0)!=0){c[B>>2]=1;IEc(b)}ie[c[(c[K>>2]|0)+88>>2]&127](b)|0;DEc(b);MEc(b);EEc(b);do{if((T|0)==0){_=0}else{_Cc(7);bDc(2);A=(rc(N|0,4,1,T|0)|0)==1;c[v>>2]=(c[v>>2]|0)+1;do{if(A){$=(rc(c[c[u>>2]>>2]|0,8,1,T|0)|0)==1;h[w>>3]=+VCc(2);if(!$){aa=0;break}aa=(rc(O|0,8,1,T|0)|0)==1|0}else{h[w>>3]=+VCc(2);aa=0}}while(0);A=c[P>>2]|0;$=c[Q>>2]|0;if(($+A|0)>0){ba=aa;ca=0;while(1){c[x>>2]=QCc(ca+9|0)|0;if((ba|0)==0){da=0}else{da=(rc(R|0,4,1,T|0)|0)==1|0}ea=ca+1|0;fa=c[P>>2]|0;ga=c[Q>>2]|0;if((ea|0)<(ga+fa|0)){ba=da;ca=ea}else{ha=ga;ia=fa;ja=da;break}}}else{ha=$;ia=A;ja=aa}if((ha+ia|0)>0){ca=ja;ba=0;while(1){h[w>>3]=+VCc(ba+9|0);if((ca|0)==0){ka=0}else{ka=(rc(O|0,8,1,T|0)|0)==1|0}fa=ba+1|0;if((fa|0)<((c[Q>>2]|0)+(c[P>>2]|0)|0)){ca=ka;ba=fa}else{la=ka;break}}}else{la=ja}bDc(7);if((la|0)!=0){_=T;break}c[p>>2]=Wd(c[(Nc()|0)>>2]|0)|0;GBc(23,0,240,p);Yc(T|0)|0;_=0}}while(0);if((c[349212>>2]|0)==0){ma=47}else{ba=c[B>>2]|0;if((ba|0)==0){ma=47}else{na=ba}}if((ma|0)==47){ma=0;ge[c[333900>>2]&255](333880,b);na=c[B>>2]|0}do{if((na|0)==1){if((c[I>>2]|0)!=3){break}ba=c[L>>2]|0;ca=c[ba+8>>2]|0;A=c[ba+4>>2]|0;c[A>>2]=(c[A>>2]|0)+(c[ca>>2]|0);ba=A+4|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+4>>2]|0);ba=A+8|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+8>>2]|0);ba=A+12|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+12>>2]|0);ba=A+16|0;c[ba>>2]=(c[ba>>2]|0)+(c[ca+16>>2]|0)}}while(0);if((c[84870]|0)!=0){ca=f;ba=339488;c[ca+0>>2]=c[ba+0>>2];c[ca+4>>2]=c[ba+4>>2];c[ca+8>>2]=c[ba+8>>2];c[ca+12>>2]=c[ba+12>>2];c[ca+16>>2]=c[ba+16>>2];c[ca+20>>2]=c[ba+20>>2];wBc(M,f);Sd(10,M|0)|0;ba=c[84878]|0;ca=o;h[k>>3]=+h[c[c[u>>2]>>2]>>3];c[ca>>2]=c[k>>2];c[ca+4>>2]=c[k+4>>2];c[o+8>>2]=ba;EBc(1,0,320,o);h[F>>3]=+h[z>>3]}if((Z|0)!=0){ma=57;break}if((rFc(b,0)|0)!=0){ma=58;break}if((hFc(b,0)|0)!=0){ma=58;break}if((YEc(b,0)|0)==0){S=W;T=_}else{ma=58;break}}do{if((ma|0)==57){T=n;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];EBc(1,0,376,n);U=_;V=Z+ -1|0}else if((ma|0)==58){if((rFc(b,0)|0)!=0){T=m;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];EBc(1,0,448,m);U=_;V=-2;break}if((hFc(b,0)|0)!=0){T=l;h[k>>3]=+h[z>>3];c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];EBc(1,0,536,l);U=_;V=-3;break}T=(YEc(b,0)|0)==0;Y=+h[z>>3];if(T){T=g;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];EBc(1,0,712,g);U=_;V=-1;break}else{T=j;h[k>>3]=Y;c[T>>2]=c[k>>2];c[T+4>>2]=c[k+4>>2];EBc(1,0,624,j);U=_;V=-3;break}}}while(0);if((U|0)==0){i=e;return V|0}Yc(U|0)|0;i=e;return V|0}function $e(a){a=a|0;i=i;return 0}function af(a){a=a|0;i=i;return 0}function bf(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+436>>2]|0;h[d>>3]=+h[b+26640>>3];h[d+8>>3]=+h[b+26648>>3];h[d+16>>3]=+h[b+26656>>3];i=i;return 0}function cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26656>>3]=+h[b+16>>3]*9.549296585513721;i=i;return}function df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+56>>3]=+h[b+16>>3];i=i;return}function ef(b){b=b|0;var d=0,e=0,f=0,g=0.0,j=0,k=0,l=0,m=0.0,n=0,o=0,p=0.0,q=0.0;d=i;e=b+416|0;f=c[e>>2]|0;g=+h[f+47712>>3];j=b+4|0;k=c[c[j>>2]>>2]|0;l=c[k+8>>2]|0;m=+h[l+16>>3];do{if(g!=0.0){n=l;o=f;p=m/g}else{if(m==0.0){n=l;o=f;p=m;break}q=m/+KBc(c[b+536>>2]|0,g,872,864,+h[k>>3],(a[b+319|0]|0)!=0|0);n=c[(c[c[j>>2]>>2]|0)+8>>2]|0;o=c[e>>2]|0;p=q}}while(0);h[n+25952>>3]=p*p*+h[o+47704>>3];i=d;return}function ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+40>>3]=(+h[b>>3]- +h[b+8>>3])*+h[(c[a+416>>2]|0)+47744>>3];i=i;return}function gf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+4104>>3]=-(d*+h[b+16>>3]);i=i;return}function hf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+4112>>3]=d*+h[b+16>>3];i=i;return}function jf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+24>>3]));h[b+4120>>3]=-(d*+h[b+16>>3]);i=i;return}function kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4072>>3]=+h[b+4104>>3]*.8660254037844387+ +h[b+4120>>3]*-.4999999999999999;i=i;return}function lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4088>>3]=+h[b+4104>>3]*.4999999999999999+ +h[b+4120>>3]*.8660254037844387;i=i;return}function mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9384>>3]=+h[b+4072>>3]*.8660254037844387+ +h[b+4088>>3]*.4999999999999999;i=i;return}function nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9400>>3]=+h[b+4072>>3]*-.4999999999999999+ +h[b+4088>>3]*.8660254037844387;i=i;return}function of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9336>>3]=+h[b+9384>>3]*6.123233995736766e-17+ +h[b+9400>>3];i=i;return}function pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9352>>3]=+h[b+9400>>3]*6.123233995736766e-17- +h[b+9384>>3];i=i;return}function qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9288>>3]=+h[b+9336>>3]*6.123233995736766e-17- +h[b+9352>>3];i=i;return}function rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9304>>3]=+h[b+9336>>3]+ +h[b+9352>>3]*6.123233995736766e-17;i=i;return}function sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9240>>3]=+h[b+9288>>3]*-.8660254037844386+ +h[b+9304>>3]*-.5000000000000001;i=i;return}function tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9256>>3]=+h[b+9288>>3]*.5000000000000001+ +h[b+9304>>3]*-.8660254037844386;i=i;return}function uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9192>>3]=+h[b+9240>>3]*-.8660254037844386+ +h[b+9256>>3]*.5000000000000001;i=i;return}function vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9208>>3]=+h[b+9240>>3]*-.5000000000000001+ +h[b+9256>>3]*-.8660254037844386;i=i;return}function wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9144>>3]=+h[b+9192>>3]*-.8660254037844386+ +h[b+9208>>3]*-.5000000000000001;i=i;return}function xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9160>>3]=+h[b+9192>>3]*.5000000000000001+ +h[b+9208>>3]*-.8660254037844386;i=i;return}function yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9096>>3]=+h[b+9144>>3]*-.8660254037844386+ +h[b+9160>>3]*.5000000000000001;i=i;return}function zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9112>>3]=+h[b+9144>>3]*-.5000000000000001+ +h[b+9160>>3]*-.8660254037844386;i=i;return}function Af(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9048>>3]=+h[b+9096>>3]*6.123233995736766e-17+ +h[b+9112>>3];i=i;return}function Bf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9064>>3]=+h[b+9112>>3]*6.123233995736766e-17- +h[b+9096>>3];i=i;return}function Cf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9e3>>3]=+h[b+9048>>3]*6.123233995736766e-17- +h[b+9064>>3];i=i;return}function Df(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9016>>3]=+h[b+9048>>3]+ +h[b+9064>>3]*6.123233995736766e-17;i=i;return}function Ef(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8952>>3]=+h[b+9e3>>3]*.8660254037844387+ +h[b+9016>>3]*-.4999999999999999;i=i;return}function Ff(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8968>>3]=+h[b+9e3>>3]*.4999999999999999+ +h[b+9016>>3]*.8660254037844387;i=i;return}function Gf(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+24>>3]));h[b+4128>>3]=-(d*+h[b+16>>3]);i=i;return}function Hf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4080>>3]=+h[b+4112>>3]*.8660254037844387+ +h[b+4128>>3]*-.4999999999999999;i=i;return}function If(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4096>>3]=+h[b+4112>>3]*.4999999999999999+ +h[b+4128>>3]*.8660254037844387;i=i;return}function Jf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9392>>3]=+h[b+4080>>3]*.8660254037844387+ +h[b+4096>>3]*.4999999999999999;i=i;return}function Kf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9408>>3]=+h[b+4080>>3]*-.4999999999999999+ +h[b+4096>>3]*.8660254037844387;i=i;return}function Lf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9344>>3]=+h[b+9392>>3]*6.123233995736766e-17+ +h[b+9408>>3];i=i;return}function Mf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9360>>3]=+h[b+9408>>3]*6.123233995736766e-17- +h[b+9392>>3];i=i;return}function Nf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9296>>3]=+h[b+9344>>3]*6.123233995736766e-17- +h[b+9360>>3];i=i;return}function Of(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9312>>3]=+h[b+9344>>3]+ +h[b+9360>>3]*6.123233995736766e-17;i=i;return}function Pf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9248>>3]=+h[b+9296>>3]*-.8660254037844386+ +h[b+9312>>3]*-.5000000000000001;i=i;return}function Qf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9264>>3]=+h[b+9296>>3]*.5000000000000001+ +h[b+9312>>3]*-.8660254037844386;i=i;return}function Rf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9200>>3]=+h[b+9248>>3]*-.8660254037844386+ +h[b+9264>>3]*.5000000000000001;i=i;return}function Sf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9216>>3]=+h[b+9248>>3]*-.5000000000000001+ +h[b+9264>>3]*-.8660254037844386;i=i;return}function Tf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9152>>3]=+h[b+9200>>3]*-.8660254037844386+ +h[b+9216>>3]*-.5000000000000001;i=i;return}function Uf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9168>>3]=+h[b+9200>>3]*.5000000000000001+ +h[b+9216>>3]*-.8660254037844386;i=i;return}function Vf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9104>>3]=+h[b+9152>>3]*-.8660254037844386+ +h[b+9168>>3]*.5000000000000001;i=i;return}function Wf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9120>>3]=+h[b+9152>>3]*-.5000000000000001+ +h[b+9168>>3]*-.8660254037844386;i=i;return}function Xf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9056>>3]=+h[b+9104>>3]*6.123233995736766e-17+ +h[b+9120>>3];i=i;return}function Yf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9072>>3]=+h[b+9120>>3]*6.123233995736766e-17- +h[b+9104>>3];i=i;return}function Zf(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9008>>3]=+h[b+9056>>3]*6.123233995736766e-17- +h[b+9072>>3];i=i;return}function _f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9024>>3]=+h[b+9056>>3]+ +h[b+9072>>3]*6.123233995736766e-17;i=i;return}function $f(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=+h[b+9008>>3]*.8660254037844387+ +h[b+9024>>3]*-.4999999999999999;i=i;return}function ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8976>>3]=+h[b+9008>>3]*.4999999999999999+ +h[b+9024>>3]*.8660254037844387;i=i;return}function bg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26640>>3]=+h[b+8>>3];i=i;return}function cg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23880>>3]=+X(+(+h[b+24>>3]));i=i;return}function dg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23888>>3]=-+Y(+(+h[b+24>>3]));i=i;return}function eg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23896>>3]=+Y(+(+h[b+24>>3]));i=i;return}function fg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3136>>3]=+h[b+23896>>3]*+h[d+5744>>3]+ +h[b+23880>>3]*+h[d+5752>>3];i=i;return}function gg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14256>>3]=+h[b+23880>>3]*d*+h[e+5744>>3]- +h[b+23896>>3]*d*+h[e+5752>>3];i=i;return}function hg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23040>>3]=+h[b+23896>>3]*.8660254037844387+ +h[b+23880>>3]*-.4999999999999999;i=i;return}function ig(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23024>>3]=+h[b+23896>>3]*.4999999999999999+ +h[b+23880>>3]*.8660254037844387;i=i;return}function jg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14216>>3]=+h[b+14256>>3]+(+h[b+23024>>3]*d*+h[e+5168>>3]- +h[b+23040>>3]*d*+h[e+5176>>3]);i=i;return}function kg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14192>>3]=+h[b+14216>>3]+(+h[b+23024>>3]*d*+h[e+3200>>3]- +h[b+23040>>3]*d*+h[e+3208>>3]);i=i;return}function lg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14168>>3]=+h[b+14192>>3]+(+h[b+23024>>3]*d*+h[e+5264>>3]- +h[b+23040>>3]*d*+h[e+5272>>3]);i=i;return}function mg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14144>>3]=+h[b+14192>>3]+(+h[b+23024>>3]*d*+h[e+4392>>3]- +h[b+23040>>3]*d*+h[e+4400>>3]);i=i;return}function ng(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14120>>3]=+h[b+14144>>3]+(+h[b+23024>>3]*d*+h[e+2400>>3]- +h[b+23040>>3]*d*+h[e+2408>>3]);i=i;return}function og(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14848>>3]=+h[b+3136>>3]+(+h[b+23040>>3]*+h[d+5168>>3]+ +h[b+23024>>3]*+h[d+5176>>3]);i=i;return}function pg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14824>>3]=+h[b+14848>>3]+(+h[b+23040>>3]*+h[d+3200>>3]+ +h[b+23024>>3]*+h[d+3208>>3]);i=i;return}function qg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14800>>3]=+h[b+14824>>3]+(+h[b+23040>>3]*+h[d+4392>>3]+ +h[b+23024>>3]*+h[d+4400>>3]);i=i;return}function rg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14752>>3]=+h[b+14800>>3]+(+h[b+23040>>3]*+h[d+2400>>3]+ +h[b+23024>>3]*+h[d+2408>>3]);i=i;return}function sg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14776>>3]=+h[b+14824>>3]+(+h[b+23040>>3]*+h[d+5264>>3]+ +h[b+23024>>3]*+h[d+5272>>3]);i=i;return}function tg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14728>>3]=+h[b+14752>>3]+(+h[b+23040>>3]*+h[d+6128>>3]+ +h[b+23024>>3]*+h[d+6136>>3]);i=i;return}function ug(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14008>>3]=+h[b+14120>>3]+(+h[b+23024>>3]*d*+h[e+6128>>3]- +h[b+23040>>3]*d*+h[e+6136>>3]);i=i;return}function vg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13944>>3]=+h[b+23040>>3]*.8660254037844387+ +h[b+23024>>3]*.4999999999999999;i=i;return}function wg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13928>>3]=+h[b+23040>>3]*-.4999999999999999+ +h[b+23024>>3]*.8660254037844387;i=i;return}function xg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13920>>3]=+h[b+14728>>3]+(+h[b+13944>>3]*+h[d+12152>>3]+ +h[b+13928>>3]*+h[d+12160>>3]);i=i;return}function yg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13800>>3]=+h[b+14008>>3]+(+h[b+13928>>3]*d*+h[e+12152>>3]- +h[b+13944>>3]*d*+h[e+12160>>3]);i=i;return}function zg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13736>>3]=+h[b+13944>>3]*6.123233995736766e-17+ +h[b+13928>>3];i=i;return}function Ag(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13720>>3]=+h[b+13928>>3]*6.123233995736766e-17- +h[b+13944>>3];i=i;return}function Bg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13712>>3]=+h[b+13800>>3]+(+h[b+13720>>3]*d*+h[e+11576>>3]- +h[b+13736>>3]*d*+h[e+11584>>3]);i=i;return}function Cg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13688>>3]=+h[b+13712>>3]+(+h[b+13720>>3]*d*+h[e+9608>>3]- +h[b+13736>>3]*d*+h[e+9616>>3]);i=i;return}function Dg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13664>>3]=+h[b+13688>>3]+(+h[b+13720>>3]*d*+h[e+11672>>3]- +h[b+13736>>3]*d*+h[e+11680>>3]);i=i;return}function Eg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13640>>3]=+h[b+13688>>3]+(+h[b+13720>>3]*d*+h[e+10800>>3]- +h[b+13736>>3]*d*+h[e+10808>>3]);i=i;return}function Fg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13616>>3]=+h[b+13640>>3]+(+h[b+13720>>3]*d*+h[e+8808>>3]- +h[b+13736>>3]*d*+h[e+8816>>3]);i=i;return}function Gg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13592>>3]=+h[b+13920>>3]+(+h[b+13736>>3]*+h[d+11576>>3]+ +h[b+13720>>3]*+h[d+11584>>3]);i=i;return}function Hg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13568>>3]=+h[b+13592>>3]+(+h[b+13736>>3]*+h[d+9608>>3]+ +h[b+13720>>3]*+h[d+9616>>3]);i=i;return}function Ig(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13544>>3]=+h[b+13568>>3]+(+h[b+13736>>3]*+h[d+10800>>3]+ +h[b+13720>>3]*+h[d+10808>>3]);i=i;return}function Jg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13520>>3]=+h[b+13544>>3]+(+h[b+13736>>3]*+h[d+8808>>3]+ +h[b+13720>>3]*+h[d+8816>>3]);i=i;return}function Kg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13496>>3]=+h[b+13568>>3]+(+h[b+13736>>3]*+h[d+11672>>3]+ +h[b+13720>>3]*+h[d+11680>>3]);i=i;return}function Lg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13472>>3]=+h[b+13520>>3]+(+h[b+13736>>3]*+h[d+12536>>3]+ +h[b+13720>>3]*+h[d+12544>>3]);i=i;return}function Mg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13360>>3]=+h[b+13616>>3]+(+h[b+13720>>3]*d*+h[e+12536>>3]- +h[b+13736>>3]*d*+h[e+12544>>3]);i=i;return}function Ng(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13296>>3]=+h[b+13736>>3]*6.123233995736766e-17- +h[b+13720>>3];i=i;return}function Og(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13280>>3]=+h[b+13736>>3]+ +h[b+13720>>3]*6.123233995736766e-17;i=i;return}function Pg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13272>>3]=+h[b+13472>>3]+(+h[b+13296>>3]*+h[d+18560>>3]+ +h[b+13280>>3]*+h[d+18568>>3]);i=i;return}function Qg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13152>>3]=+h[b+13360>>3]+(+h[b+13280>>3]*d*+h[e+18560>>3]- +h[b+13296>>3]*d*+h[e+18568>>3]);i=i;return}function Rg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13088>>3]=+h[b+13296>>3]*-.8660254037844386+ +h[b+13280>>3]*-.5000000000000001;i=i;return}function Sg(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13072>>3]=+h[b+13296>>3]*.5000000000000001+ +h[b+13280>>3]*-.8660254037844386;i=i;return}function Tg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13064>>3]=+h[b+13152>>3]+(+h[b+13072>>3]*d*+h[e+17984>>3]- +h[b+13088>>3]*d*+h[e+17992>>3]);i=i;return}function Ug(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13040>>3]=+h[b+13064>>3]+(+h[b+13072>>3]*d*+h[e+16016>>3]- +h[b+13088>>3]*d*+h[e+16024>>3]);i=i;return}function Vg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13016>>3]=+h[b+13040>>3]+(+h[b+13072>>3]*d*+h[e+18080>>3]- +h[b+13088>>3]*d*+h[e+18088>>3]);i=i;return}function Wg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12992>>3]=+h[b+13040>>3]+(+h[b+13072>>3]*d*+h[e+17208>>3]- +h[b+13088>>3]*d*+h[e+17216>>3]);i=i;return}function Xg(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12968>>3]=+h[b+12992>>3]+(+h[b+13072>>3]*d*+h[e+15216>>3]- +h[b+13088>>3]*d*+h[e+15224>>3]);i=i;return}function Yg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12944>>3]=+h[b+13272>>3]+(+h[b+13088>>3]*+h[d+17984>>3]+ +h[b+13072>>3]*+h[d+17992>>3]);i=i;return}function Zg(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12920>>3]=+h[b+12944>>3]+(+h[b+13088>>3]*+h[d+16016>>3]+ +h[b+13072>>3]*+h[d+16024>>3]);i=i;return}function _g(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12896>>3]=+h[b+12920>>3]+(+h[b+13088>>3]*+h[d+17208>>3]+ +h[b+13072>>3]*+h[d+17216>>3]);i=i;return}function $g(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12872>>3]=+h[b+12896>>3]+(+h[b+13088>>3]*+h[d+15216>>3]+ +h[b+13072>>3]*+h[d+15224>>3]);i=i;return}function ah(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12848>>3]=+h[b+12920>>3]+(+h[b+13088>>3]*+h[d+18080>>3]+ +h[b+13072>>3]*+h[d+18088>>3]);i=i;return}function bh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12824>>3]=+h[b+12872>>3]+(+h[b+13088>>3]*+h[d+18944>>3]+ +h[b+13072>>3]*+h[d+18952>>3]);i=i;return}function ch(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12712>>3]=+h[b+12968>>3]+(+h[b+13072>>3]*d*+h[e+18944>>3]- +h[b+13088>>3]*d*+h[e+18952>>3]);i=i;return}function dh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12648>>3]=+h[b+13088>>3]*-.8660254037844386+ +h[b+13072>>3]*.5000000000000001;i=i;return}function eh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12632>>3]=+h[b+13088>>3]*-.5000000000000001+ +h[b+13072>>3]*-.8660254037844386;i=i;return}function fh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12624>>3]=+h[b+12824>>3]+(+h[b+12648>>3]*+h[d+24968>>3]+ +h[b+12632>>3]*+h[d+24976>>3]);i=i;return}function gh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12504>>3]=+h[b+12712>>3]+(+h[b+12632>>3]*d*+h[e+24968>>3]- +h[b+12648>>3]*d*+h[e+24976>>3]);i=i;return}function hh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12440>>3]=+h[b+12648>>3]*-.8660254037844386+ +h[b+12632>>3]*-.5000000000000001;i=i;return}function ih(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12424>>3]=+h[b+12648>>3]*.5000000000000001+ +h[b+12632>>3]*-.8660254037844386;i=i;return}function jh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12416>>3]=+h[b+12504>>3]+(+h[b+12424>>3]*d*+h[e+24392>>3]- +h[b+12440>>3]*d*+h[e+24400>>3]);i=i;return}function kh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12392>>3]=+h[b+12416>>3]+(+h[b+12424>>3]*d*+h[e+22424>>3]- +h[b+12440>>3]*d*+h[e+22432>>3]);i=i;return}function lh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12368>>3]=+h[b+12392>>3]+(+h[b+12424>>3]*d*+h[e+24488>>3]- +h[b+12440>>3]*d*+h[e+24496>>3]);i=i;return}function mh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12344>>3]=+h[b+12392>>3]+(+h[b+12424>>3]*d*+h[e+23616>>3]- +h[b+12440>>3]*d*+h[e+23624>>3]);i=i;return}function nh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12320>>3]=+h[b+12344>>3]+(+h[b+12424>>3]*d*+h[e+21624>>3]- +h[b+12440>>3]*d*+h[e+21632>>3]);i=i;return}function oh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12296>>3]=+h[b+12624>>3]+(+h[b+12440>>3]*+h[d+24392>>3]+ +h[b+12424>>3]*+h[d+24400>>3]);i=i;return}function ph(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12272>>3]=+h[b+12296>>3]+(+h[b+12440>>3]*+h[d+22424>>3]+ +h[b+12424>>3]*+h[d+22432>>3]);i=i;return}function qh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12248>>3]=+h[b+12272>>3]+(+h[b+12440>>3]*+h[d+23616>>3]+ +h[b+12424>>3]*+h[d+23624>>3]);i=i;return}function rh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12224>>3]=+h[b+12248>>3]+(+h[b+12440>>3]*+h[d+21624>>3]+ +h[b+12424>>3]*+h[d+21632>>3]);i=i;return}function sh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12200>>3]=+h[b+12272>>3]+(+h[b+12440>>3]*+h[d+24488>>3]+ +h[b+12424>>3]*+h[d+24496>>3]);i=i;return}function th(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12176>>3]=+h[b+12224>>3]+(+h[b+12440>>3]*+h[d+25352>>3]+ +h[b+12424>>3]*+h[d+25360>>3]);i=i;return}function uh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12064>>3]=+h[b+12320>>3]+(+h[b+12424>>3]*d*+h[e+25352>>3]- +h[b+12440>>3]*d*+h[e+25360>>3]);i=i;return}function vh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12e3>>3]=+h[b+12440>>3]*-.8660254037844386+ +h[b+12424>>3]*.5000000000000001;i=i;return}function wh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11984>>3]=+h[b+12440>>3]*-.5000000000000001+ +h[b+12424>>3]*-.8660254037844386;i=i;return}function xh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11976>>3]=+h[b+12176>>3]+(+h[b+12e3>>3]*+h[d+31376>>3]+ +h[b+11984>>3]*+h[d+31384>>3]);i=i;return}function yh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11856>>3]=+h[b+12064>>3]+(+h[b+11984>>3]*d*+h[e+31376>>3]- +h[b+12e3>>3]*d*+h[e+31384>>3]);i=i;return}function zh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11792>>3]=+h[b+12e3>>3]*6.123233995736766e-17+ +h[b+11984>>3];i=i;return}function Ah(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11776>>3]=+h[b+11984>>3]*6.123233995736766e-17- +h[b+12e3>>3];i=i;return}function Bh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11768>>3]=+h[b+11856>>3]+(+h[b+11776>>3]*d*+h[e+30800>>3]- +h[b+11792>>3]*d*+h[e+30808>>3]);i=i;return}function Ch(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11744>>3]=+h[b+11768>>3]+(+h[b+11776>>3]*d*+h[e+28832>>3]- +h[b+11792>>3]*d*+h[e+28840>>3]);i=i;return}function Dh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11720>>3]=+h[b+11744>>3]+(+h[b+11776>>3]*d*+h[e+30896>>3]- +h[b+11792>>3]*d*+h[e+30904>>3]);i=i;return}function Eh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11696>>3]=+h[b+11744>>3]+(+h[b+11776>>3]*d*+h[e+30024>>3]- +h[b+11792>>3]*d*+h[e+30032>>3]);i=i;return}function Fh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11672>>3]=+h[b+11696>>3]+(+h[b+11776>>3]*d*+h[e+28032>>3]- +h[b+11792>>3]*d*+h[e+28040>>3]);i=i;return}function Gh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11648>>3]=+h[b+11976>>3]+(+h[b+11792>>3]*+h[d+30800>>3]+ +h[b+11776>>3]*+h[d+30808>>3]);i=i;return}function Hh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11624>>3]=+h[b+11648>>3]+(+h[b+11792>>3]*+h[d+28832>>3]+ +h[b+11776>>3]*+h[d+28840>>3]);i=i;return}function Ih(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11600>>3]=+h[b+11624>>3]+(+h[b+11792>>3]*+h[d+30024>>3]+ +h[b+11776>>3]*+h[d+30032>>3]);i=i;return}function Jh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11576>>3]=+h[b+11600>>3]+(+h[b+11792>>3]*+h[d+28032>>3]+ +h[b+11776>>3]*+h[d+28040>>3]);i=i;return}function Kh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11552>>3]=+h[b+11624>>3]+(+h[b+11792>>3]*+h[d+30896>>3]+ +h[b+11776>>3]*+h[d+30904>>3]);i=i;return}function Lh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11528>>3]=+h[b+11576>>3]+(+h[b+11792>>3]*+h[d+31760>>3]+ +h[b+11776>>3]*+h[d+31768>>3]);i=i;return}function Mh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11416>>3]=+h[b+11672>>3]+(+h[b+11776>>3]*d*+h[e+31760>>3]- +h[b+11792>>3]*d*+h[e+31768>>3]);i=i;return}function Nh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23968>>3]=+h[b+11792>>3]*6.123233995736766e-17- +h[b+11776>>3];i=i;return}function Oh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23992>>3]=+h[b+11792>>3]+ +h[b+11776>>3]*6.123233995736766e-17;i=i;return}function Ph(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11376>>3]=+h[b+11528>>3]+(+h[b+23968>>3]*+h[d+37784>>3]+ +h[b+23992>>3]*+h[d+37792>>3]);i=i;return}function Qh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11280>>3]=+h[b+11416>>3]+(+h[b+23992>>3]*d*+h[e+37784>>3]- +h[b+23968>>3]*d*+h[e+37792>>3]);i=i;return}function Rh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11216>>3]=+h[b+23968>>3]*.8660254037844387+ +h[b+23992>>3]*-.4999999999999999;i=i;return}function Sh(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11200>>3]=+h[b+23968>>3]*.4999999999999999+ +h[b+23992>>3]*.8660254037844387;i=i;return}function Th(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11192>>3]=+h[b+11280>>3]+(+h[b+11200>>3]*d*+h[e+37208>>3]- +h[b+11216>>3]*d*+h[e+37216>>3]);i=i;return}function Uh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11168>>3]=+h[b+11192>>3]+(+h[b+11200>>3]*d*+h[e+35240>>3]- +h[b+11216>>3]*d*+h[e+35248>>3]);i=i;return}function Vh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11144>>3]=+h[b+11168>>3]+(+h[b+11200>>3]*d*+h[e+37304>>3]- +h[b+11216>>3]*d*+h[e+37312>>3]);i=i;return}function Wh(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11120>>3]=+h[b+11168>>3]+(+h[b+11200>>3]*d*+h[e+36432>>3]- +h[b+11216>>3]*d*+h[e+36440>>3]);i=i;return}function Xh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11096>>3]=+h[b+11376>>3]+(+h[b+11216>>3]*+h[d+37208>>3]+ +h[b+11200>>3]*+h[d+37216>>3]);i=i;return}function Yh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11072>>3]=+h[b+11096>>3]+(+h[b+11216>>3]*+h[d+35240>>3]+ +h[b+11200>>3]*+h[d+35248>>3]);i=i;return}function Zh(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11048>>3]=+h[b+11072>>3]+(+h[b+11216>>3]*+h[d+36432>>3]+ +h[b+11200>>3]*+h[d+36440>>3]);i=i;return}function _h(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11024>>3]=+h[b+11072>>3]+(+h[b+11216>>3]*+h[d+37304>>3]+ +h[b+11200>>3]*+h[d+37312>>3]);i=i;return}function $h(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10824>>3]=+h[b+11216>>3]*-.4999999999999999+ +h[b+11200>>3]*.8660254037844387;i=i;return}function ai(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10840>>3]=+h[b+11216>>3]*.8660254037844387+ +h[b+11200>>3]*.4999999999999999;i=i;return}function bi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10720>>3]=+h[b+11048>>3]+(+h[b+11216>>3]*+h[d+34440>>3]+ +h[b+11200>>3]*+h[d+34448>>3]);i=i;return}function ci(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10696>>3]=+h[b+10720>>3]+(+h[b+11216>>3]*+h[d+38168>>3]+ +h[b+11200>>3]*+h[d+38176>>3]);i=i;return}function di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23904>>3]=+X(+(+h[b+24>>3]));i=i;return}function ei(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3144>>3]=+h[b+23904>>3]*+h[d+5744>>3]+ +h[b+23888>>3]*+h[d+5752>>3];i=i;return}function fi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14248>>3]=+h[b+23888>>3]*d*+h[e+5744>>3]- +h[b+23904>>3]*d*+h[e+5752>>3];i=i;return}function gi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23048>>3]=+h[b+23904>>3]*.8660254037844387+ +h[b+23888>>3]*-.4999999999999999;i=i;return}function hi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23032>>3]=+h[b+23904>>3]*.4999999999999999+ +h[b+23888>>3]*.8660254037844387;i=i;return}function ii(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14208>>3]=+h[b+14248>>3]+(+h[b+23032>>3]*d*+h[e+5168>>3]- +h[b+23048>>3]*d*+h[e+5176>>3]);i=i;return}function ji(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14184>>3]=+h[b+14208>>3]+(+h[b+23032>>3]*d*+h[e+3200>>3]- +h[b+23048>>3]*d*+h[e+3208>>3]);i=i;return}function ki(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14160>>3]=+h[b+14184>>3]+(+h[b+23032>>3]*d*+h[e+5264>>3]- +h[b+23048>>3]*d*+h[e+5272>>3]);i=i;return}function li(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14136>>3]=+h[b+14184>>3]+(+h[b+23032>>3]*d*+h[e+4392>>3]- +h[b+23048>>3]*d*+h[e+4400>>3]);i=i;return}function mi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14112>>3]=+h[b+14136>>3]+(+h[b+23032>>3]*d*+h[e+2400>>3]- +h[b+23048>>3]*d*+h[e+2408>>3]);i=i;return}function ni(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14840>>3]=+h[b+3144>>3]+(+h[b+23048>>3]*+h[d+5168>>3]+ +h[b+23032>>3]*+h[d+5176>>3]);i=i;return}function oi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14816>>3]=+h[b+14840>>3]+(+h[b+23048>>3]*+h[d+3200>>3]+ +h[b+23032>>3]*+h[d+3208>>3]);i=i;return}function pi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14792>>3]=+h[b+14816>>3]+(+h[b+23048>>3]*+h[d+4392>>3]+ +h[b+23032>>3]*+h[d+4400>>3]);i=i;return}function qi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14744>>3]=+h[b+14792>>3]+(+h[b+23048>>3]*+h[d+2400>>3]+ +h[b+23032>>3]*+h[d+2408>>3]);i=i;return}function ri(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14768>>3]=+h[b+14816>>3]+(+h[b+23048>>3]*+h[d+5264>>3]+ +h[b+23032>>3]*+h[d+5272>>3]);i=i;return}function si(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+14720>>3]=+h[b+14744>>3]+(+h[b+23048>>3]*+h[d+6128>>3]+ +h[b+23032>>3]*+h[d+6136>>3]);i=i;return}function ti(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,19)|0;d=c[(c[a+476>>2]|0)+1244>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+3416>>3]=+h[d>>3];h[e+3408>>3]=+h[d+8>>3];i=b;return}function ui(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+524>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3592>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3592|0;h[c[g+528>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3592>>3]);e=c[f>>2]|0;h[c[e+532>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+524>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26608>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26608|0;h[(c[e+528>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26608>>3]);j=c[f>>2]|0;h[(c[j+532>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+524>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26592>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26592|0;h[(c[j+528>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26592>>3]);h[(c[(c[f>>2]|0)+532>>2]|0)+16>>3]=k;qFc(a,6)|0;g=c[(c[f>>2]|0)+524>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+3592>>3]=+h[g>>3];h[f+26608>>3]=+h[g+8>>3];h[f+26592>>3]=+h[g+16>>3];ew(a);fw(a);gw(a);hw(a);iw(a);jw(a);kw(a);lw(a);mw(a);nw(a);ow(a);pw(a);qw(a);i=b;return}function vi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26584>>3]=+h[(c[a+416>>2]|0)+38880>>3]- +h[b+26608>>3];i=i;return}function wi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+40256>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26584>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,896,888,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26576>>3]=m+1.0;i=d;return}function xi(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26544>>3]=+h[b+40272>>3]+ +h[b+40280>>3]*(1.0- +h[d+26576>>3]);i=i;return}function yi(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26544>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26560|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,928,920,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26560|0;p=o;h[p>>3]=m;i=d;return}function zi(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+40256>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26584>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26568|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26568|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,896,952,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26568|0;q=p;h[q>>3]=n;i=d;return}function Ai(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26608>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26600|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26608>>3];g=e;j=g+26600|0;k=j;h[k>>3]=f;i=b;return}function Bi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3448>>3]=+h[b+3592>>3]- +h[(c[a+416>>2]|0)+1112>>3];i=i;return}function Ci(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3400>>3]=+h[b+3448>>3]- +h[(c[a+416>>2]|0)+1496>>3];i=i;return}function Di(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24144>>3]=+h[b+3400>>3]- +h[b+14760>>3];i=i;return}function Ei(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7808>>3]=+h[b+23840>>3]*+h[b+23048>>3]+ +h[b+23848>>3]*+h[b+23040>>3];i=i;return}function Fi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7816>>3]=+h[b+23864>>3]*+h[b+23048>>3]+ +h[b+23872>>3]*+h[b+23040>>3];i=i;return}function Gi(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,20)|0;d=c[(c[a+476>>2]|0)+1308>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+14032>>3]=+h[d>>3];h[e+14040>>3]=+h[d+8>>3];i=b;return}function Hi(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,21)|0;d=c[(c[a+476>>2]|0)+1372>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+14048>>3]=+h[d>>3];h[e+14080>>3]=+h[d+8>>3];h[e+26528>>3]=+h[d+16>>3];h[e+14088>>3]=+h[d+24>>3];i=b;return}function Ii(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7752>>3]=+h[b+14048>>3]- +h[b+16>>3];i=i;return}function Ji(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26592>>3]));h[b+4160>>3]=-(d*+h[b+14048>>3]);i=i;return}function Ki(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26592>>3]));h[b+4152>>3]=-(d*+h[b+14048>>3]);i=i;return}function Li(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3896>>3]=+h[b+4152>>3]*.8660254037844387+ +h[b+4160>>3]*.4999999999999999;i=i;return}function Mi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3904>>3]=+h[b+4152>>3]*-.4999999999999999+ +h[b+4160>>3]*.8660254037844387;i=i;return}function Ni(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26592>>3]));h[b+4144>>3]=d*+h[b+14048>>3];i=i;return}function Oi(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26592>>3]));h[b+4136>>3]=-(d*+h[b+14048>>3]);i=i;return}function Pi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3880>>3]=+h[b+4136>>3]*.8660254037844387+ +h[b+4144>>3]*.4999999999999999;i=i;return}function Qi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3888>>3]=+h[b+4136>>3]*-.4999999999999999+ +h[b+4144>>3]*.8660254037844387;i=i;return}function Ri(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+17|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26576>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26576>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26576>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26576>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+16|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26576>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26576>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26576>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26576>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26576>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}}}function Si(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26552>>3]=+h[b+26520>>3]*1.0e-5;i=i;return}function Ti(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+40264>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26616>>3]=b*b*+h[d+26552>>3]*-78539.81633974482;i=i;return}function Ui(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+40288>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26520>>3]*+h[j+26544>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26536|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,968,960,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26536|0;p=o;h[p>>3]=m;i=d;return}function Vi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14e3>>3]=+h[b+14112>>3]+(+h[b+23032>>3]*d*+h[e+6128>>3]- +h[b+23048>>3]*d*+h[e+6136>>3]);i=i;return}function Wi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13952>>3]=+h[b+23048>>3]*.8660254037844387+ +h[b+23032>>3]*.4999999999999999;i=i;return}function Xi(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13936>>3]=+h[b+23048>>3]*-.4999999999999999+ +h[b+23032>>3]*.8660254037844387;i=i;return}function Yi(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13912>>3]=+h[b+14720>>3]+(+h[b+13952>>3]*+h[d+12152>>3]+ +h[b+13936>>3]*+h[d+12160>>3]);i=i;return}function Zi(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13792>>3]=+h[b+14e3>>3]+(+h[b+13936>>3]*d*+h[e+12152>>3]- +h[b+13952>>3]*d*+h[e+12160>>3]);i=i;return}function _i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13744>>3]=+h[b+13952>>3]*6.123233995736766e-17+ +h[b+13936>>3];i=i;return}function $i(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13728>>3]=+h[b+13936>>3]*6.123233995736766e-17- +h[b+13952>>3];i=i;return}function aj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13704>>3]=+h[b+13792>>3]+(+h[b+13728>>3]*d*+h[e+11576>>3]- +h[b+13744>>3]*d*+h[e+11584>>3]);i=i;return}function bj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13680>>3]=+h[b+13704>>3]+(+h[b+13728>>3]*d*+h[e+9608>>3]- +h[b+13744>>3]*d*+h[e+9616>>3]);i=i;return}function cj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13656>>3]=+h[b+13680>>3]+(+h[b+13728>>3]*d*+h[e+11672>>3]- +h[b+13744>>3]*d*+h[e+11680>>3]);i=i;return}function dj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13632>>3]=+h[b+13680>>3]+(+h[b+13728>>3]*d*+h[e+10800>>3]- +h[b+13744>>3]*d*+h[e+10808>>3]);i=i;return}function ej(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13608>>3]=+h[b+13632>>3]+(+h[b+13728>>3]*d*+h[e+8808>>3]- +h[b+13744>>3]*d*+h[e+8816>>3]);i=i;return}function fj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13584>>3]=+h[b+13912>>3]+(+h[b+13744>>3]*+h[d+11576>>3]+ +h[b+13728>>3]*+h[d+11584>>3]);i=i;return}function gj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13560>>3]=+h[b+13584>>3]+(+h[b+13744>>3]*+h[d+9608>>3]+ +h[b+13728>>3]*+h[d+9616>>3]);i=i;return}function hj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13536>>3]=+h[b+13560>>3]+(+h[b+13744>>3]*+h[d+10800>>3]+ +h[b+13728>>3]*+h[d+10808>>3]);i=i;return}function ij(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13512>>3]=+h[b+13536>>3]+(+h[b+13744>>3]*+h[d+8808>>3]+ +h[b+13728>>3]*+h[d+8816>>3]);i=i;return}function jj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13488>>3]=+h[b+13560>>3]+(+h[b+13744>>3]*+h[d+11672>>3]+ +h[b+13728>>3]*+h[d+11680>>3]);i=i;return}function kj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13464>>3]=+h[b+13512>>3]+(+h[b+13744>>3]*+h[d+12536>>3]+ +h[b+13728>>3]*+h[d+12544>>3]);i=i;return}function lj(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,22)|0;d=c[(c[a+476>>2]|0)+1436>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+2832>>3]=+h[d>>3];h[e+2840>>3]=+h[d+8>>3];i=b;return}function mj(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+604>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+3e3>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+3e3|0;h[c[g+608>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+3e3>>3]);e=c[f>>2]|0;h[c[e+612>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+604>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26496>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26496|0;h[(c[e+608>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26496>>3]);j=c[f>>2]|0;h[(c[j+612>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+604>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26480>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26480|0;h[(c[j+608>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26480>>3]);h[(c[(c[f>>2]|0)+612>>2]|0)+16>>3]=k;qFc(a,7)|0;g=c[(c[f>>2]|0)+604>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+3e3>>3]=+h[g>>3];h[f+26496>>3]=+h[g+8>>3];h[f+26480>>3]=+h[g+16>>3];tw(a);uw(a);vw(a);ww(a);xw(a);yw(a);zw(a);Aw(a);Bw(a);Cw(a);Dw(a);Ew(a);Fw(a);i=b;return}function nj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9528>>3]=+h[b+23696>>3]*+h[b+13744>>3]+ +h[b+23704>>3]*+h[b+13736>>3];i=i;return}function oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9536>>3]=+h[b+23720>>3]*+h[b+13744>>3]+ +h[b+23728>>3]*+h[b+13736>>3];i=i;return}function pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2872>>3]=+h[b+3e3>>3]- +h[(c[a+416>>2]|0)+7520>>3];i=i;return}function qj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2824>>3]=+h[b+2872>>3]- +h[(c[a+416>>2]|0)+7904>>3];i=i;return}function rj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24352>>3]=+h[b+2824>>3]- +h[b+13480>>3];i=i;return}function sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26472>>3]=+h[(c[a+416>>2]|0)+40360>>3]- +h[b+26496>>3];i=i;return}function tj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+41736>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26472>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,1e3,992,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26464>>3]=m+1.0;i=d;return}function uj(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26432>>3]=+h[b+41752>>3]+ +h[b+41760>>3]*(1.0- +h[d+26464>>3]);i=i;return}function vj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26432>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26448|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,1032,1024,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26448|0;p=o;h[p>>3]=m;i=d;return}function wj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+41736>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26472>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26456|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26456|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,1e3,1056,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26456|0;q=p;h[q>>3]=n;i=d;return}function xj(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26496>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26488|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26496>>3];g=e;j=g+26488|0;k=j;h[k>>3]=f;i=b;return}function yj(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,23)|0;d=c[(c[a+476>>2]|0)+1500>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+13384>>3]=+h[d>>3];h[e+13392>>3]=+h[d+8>>3];i=b;return}function zj(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,24)|0;d=c[(c[a+476>>2]|0)+1564>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+13432>>3]=+h[d>>3];h[e+13408>>3]=+h[d+8>>3];h[e+26416>>3]=+h[d+16>>3];h[e+13416>>3]=+h[d+24>>3];i=b;return}function Aj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9496>>3]=+h[b+13432>>3]- +h[b+16>>3];i=i;return}function Bj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26480>>3]));h[b+4192>>3]=-(d*+h[b+13432>>3]);i=i;return}function Cj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26480>>3]));h[b+4184>>3]=-(d*+h[b+13432>>3]);i=i;return}function Dj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+4184>>3]*.8660254037844387+ +h[b+4192>>3]*-.4999999999999999;i=i;return}function Ej(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+4184>>3]*.4999999999999999+ +h[b+4192>>3]*.8660254037844387;i=i;return}function Fj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26480>>3]));h[b+4176>>3]=d*+h[b+13432>>3];i=i;return}function Gj(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26480>>3]));h[b+4168>>3]=-(d*+h[b+13432>>3]);i=i;return}function Hj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3912>>3]=+h[b+4168>>3]*.8660254037844387+ +h[b+4176>>3]*-.4999999999999999;i=i;return}function Ij(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+4168>>3]*.4999999999999999+ +h[b+4176>>3]*.8660254037844387;i=i;return}function Jj(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+14|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26464>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26464>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26464>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26464>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+13|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26464>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26464>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26464>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26464>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26464>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}}}function Kj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26440>>3]=+h[b+26408>>3]*1.0e-5;i=i;return}function Lj(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+41744>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26504>>3]=b*b*+h[d+26440>>3]*-78539.81633974482;i=i;return}function Mj(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+41768>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26408>>3]*+h[j+26432>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26424|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,1072,1064,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26424|0;p=o;h[p>>3]=m;i=d;return}function Nj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13352>>3]=+h[b+13608>>3]+(+h[b+13728>>3]*d*+h[e+12536>>3]- +h[b+13744>>3]*d*+h[e+12544>>3]);i=i;return}function Oj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13304>>3]=+h[b+13744>>3]*6.123233995736766e-17- +h[b+13728>>3];i=i;return}function Pj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13288>>3]=+h[b+13744>>3]+ +h[b+13728>>3]*6.123233995736766e-17;i=i;return}function Qj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+13264>>3]=+h[b+13464>>3]+(+h[b+13304>>3]*+h[d+18560>>3]+ +h[b+13288>>3]*+h[d+18568>>3]);i=i;return}function Rj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13144>>3]=+h[b+13352>>3]+(+h[b+13288>>3]*d*+h[e+18560>>3]- +h[b+13304>>3]*d*+h[e+18568>>3]);i=i;return}function Sj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13096>>3]=+h[b+13304>>3]*-.8660254037844386+ +h[b+13288>>3]*-.5000000000000001;i=i;return}function Tj(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+13080>>3]=+h[b+13304>>3]*.5000000000000001+ +h[b+13288>>3]*-.8660254037844386;i=i;return}function Uj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13056>>3]=+h[b+13144>>3]+(+h[b+13080>>3]*d*+h[e+17984>>3]- +h[b+13096>>3]*d*+h[e+17992>>3]);i=i;return}function Vj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13032>>3]=+h[b+13056>>3]+(+h[b+13080>>3]*d*+h[e+16016>>3]- +h[b+13096>>3]*d*+h[e+16024>>3]);i=i;return}function Wj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13008>>3]=+h[b+13032>>3]+(+h[b+13080>>3]*d*+h[e+18080>>3]- +h[b+13096>>3]*d*+h[e+18088>>3]);i=i;return}function Xj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12984>>3]=+h[b+13032>>3]+(+h[b+13080>>3]*d*+h[e+17208>>3]- +h[b+13096>>3]*d*+h[e+17216>>3]);i=i;return}function Yj(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12960>>3]=+h[b+12984>>3]+(+h[b+13080>>3]*d*+h[e+15216>>3]- +h[b+13096>>3]*d*+h[e+15224>>3]);i=i;return}function Zj(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12936>>3]=+h[b+13264>>3]+(+h[b+13096>>3]*+h[d+17984>>3]+ +h[b+13080>>3]*+h[d+17992>>3]);i=i;return}function _j(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12912>>3]=+h[b+12936>>3]+(+h[b+13096>>3]*+h[d+16016>>3]+ +h[b+13080>>3]*+h[d+16024>>3]);i=i;return}function $j(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12888>>3]=+h[b+12912>>3]+(+h[b+13096>>3]*+h[d+17208>>3]+ +h[b+13080>>3]*+h[d+17216>>3]);i=i;return}function ak(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12864>>3]=+h[b+12888>>3]+(+h[b+13096>>3]*+h[d+15216>>3]+ +h[b+13080>>3]*+h[d+15224>>3]);i=i;return}function bk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12840>>3]=+h[b+12912>>3]+(+h[b+13096>>3]*+h[d+18080>>3]+ +h[b+13080>>3]*+h[d+18088>>3]);i=i;return}function ck(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12816>>3]=+h[b+12864>>3]+(+h[b+13096>>3]*+h[d+18944>>3]+ +h[b+13080>>3]*+h[d+18952>>3]);i=i;return}function dk(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,25)|0;d=c[(c[a+476>>2]|0)+1628>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+2232>>3]=+h[d>>3];h[e+2224>>3]=+h[d+8>>3];i=b;return}function ek(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+684>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+2392>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+2392|0;h[c[g+688>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+2392>>3]);e=c[f>>2]|0;h[c[e+692>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+684>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26384>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26384|0;h[(c[e+688>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26384>>3]);j=c[f>>2]|0;h[(c[j+692>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+684>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26368>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26368|0;h[(c[j+688>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26368>>3]);h[(c[(c[f>>2]|0)+692>>2]|0)+16>>3]=k;qFc(a,8)|0;g=c[(c[f>>2]|0)+684>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+2392>>3]=+h[g>>3];h[f+26384>>3]=+h[g+8>>3];h[f+26368>>3]=+h[g+16>>3];Iw(a);Jw(a);Kw(a);Lw(a);Mw(a);Nw(a);Ow(a);Pw(a);Qw(a);Rw(a);Sw(a);Tw(a);Uw(a);i=b;return}function fk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9792>>3]=+h[b+23600>>3]*+h[b+13096>>3]+ +h[b+23608>>3]*+h[b+13088>>3];i=i;return}function gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2264>>3]=+h[b+2392>>3]- +h[(c[a+416>>2]|0)+13928>>3];i=i;return}function hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2216>>3]=+h[b+2264>>3]- +h[(c[a+416>>2]|0)+14312>>3];i=i;return}function ik(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24560>>3]=+h[b+2216>>3]- +h[b+12832>>3];i=i;return}function jk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26360>>3]=+h[(c[a+416>>2]|0)+41840>>3]- +h[b+26384>>3];i=i;return}function kk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+43216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26360>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,1104,1096,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26352>>3]=m+1.0;i=d;return}function lk(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26320>>3]=+h[b+43232>>3]+ +h[b+43240>>3]*(1.0- +h[d+26352>>3]);i=i;return}function mk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26320>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26336|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,1136,1128,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26336|0;p=o;h[p>>3]=m;i=d;return}function nk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+43216>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26360>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26344|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26344|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,1104,1160,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26344|0;q=p;h[q>>3]=n;i=d;return}function ok(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26384>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26376|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26384>>3];g=e;j=g+26376|0;k=j;h[k>>3]=f;i=b;return}function pk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9784>>3]=+h[b+23576>>3]*+h[b+13096>>3]+ +h[b+23584>>3]*+h[b+13088>>3];i=i;return}function qk(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,26)|0;d=c[(c[a+476>>2]|0)+1692>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12736>>3]=+h[d>>3];h[e+12744>>3]=+h[d+8>>3];i=b;return}function rk(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,27)|0;d=c[(c[a+476>>2]|0)+1756>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12792>>3]=+h[d>>3];h[e+26304>>3]=+h[d+8>>3];h[e+12784>>3]=+h[d+16>>3];h[e+12752>>3]=+h[d+24>>3];i=b;return}function sk(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+11|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26352>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26352>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26352>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26352>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26352>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26352>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26352>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26352>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26352>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}}}function tk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26328>>3]=+h[b+26296>>3]*1.0e-5;i=i;return}function uk(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+43224>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26392>>3]=b*b*+h[d+26328>>3]*-78539.81633974482;i=i;return}function vk(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+43248>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26296>>3]*+h[j+26320>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26312|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,1176,1168,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26312|0;p=o;h[p>>3]=m;i=d;return}function wk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9752>>3]=+h[b+12752>>3]- +h[b+16>>3];i=i;return}function xk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26368>>3]));h[b+4224>>3]=-(d*+h[b+12752>>3]);i=i;return}function yk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26368>>3]));h[b+4216>>3]=-(d*+h[b+12752>>3]);i=i;return}function zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+4216>>3]*.8660254037844387+ +h[b+4224>>3]*.4999999999999999;i=i;return}function Ak(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+4216>>3]*-.4999999999999999+ +h[b+4224>>3]*.8660254037844387;i=i;return}function Bk(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26368>>3]));h[b+4208>>3]=d*+h[b+12752>>3];i=i;return}function Ck(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26368>>3]));h[b+4200>>3]=-(d*+h[b+12752>>3]);i=i;return}function Dk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=+h[b+4200>>3]*.8660254037844387+ +h[b+4208>>3]*.4999999999999999;i=i;return}function Ek(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+4200>>3]*-.4999999999999999+ +h[b+4208>>3]*.8660254037844387;i=i;return}function Fk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12704>>3]=+h[b+12960>>3]+(+h[b+13080>>3]*d*+h[e+18944>>3]- +h[b+13096>>3]*d*+h[e+18952>>3]);i=i;return}function Gk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12656>>3]=+h[b+13096>>3]*-.8660254037844386+ +h[b+13080>>3]*.5000000000000001;i=i;return}function Hk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12640>>3]=+h[b+13096>>3]*-.5000000000000001+ +h[b+13080>>3]*-.8660254037844386;i=i;return}function Ik(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12616>>3]=+h[b+12816>>3]+(+h[b+12656>>3]*+h[d+24968>>3]+ +h[b+12640>>3]*+h[d+24976>>3]);i=i;return}function Jk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12496>>3]=+h[b+12704>>3]+(+h[b+12640>>3]*d*+h[e+24968>>3]- +h[b+12656>>3]*d*+h[e+24976>>3]);i=i;return}function Kk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12448>>3]=+h[b+12656>>3]*-.8660254037844386+ +h[b+12640>>3]*-.5000000000000001;i=i;return}function Lk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12432>>3]=+h[b+12656>>3]*.5000000000000001+ +h[b+12640>>3]*-.8660254037844386;i=i;return}function Mk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12408>>3]=+h[b+12496>>3]+(+h[b+12432>>3]*d*+h[e+24392>>3]- +h[b+12448>>3]*d*+h[e+24400>>3]);i=i;return}function Nk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12384>>3]=+h[b+12408>>3]+(+h[b+12432>>3]*d*+h[e+22424>>3]- +h[b+12448>>3]*d*+h[e+22432>>3]);i=i;return}function Ok(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12360>>3]=+h[b+12384>>3]+(+h[b+12432>>3]*d*+h[e+24488>>3]- +h[b+12448>>3]*d*+h[e+24496>>3]);i=i;return}function Pk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12336>>3]=+h[b+12384>>3]+(+h[b+12432>>3]*d*+h[e+23616>>3]- +h[b+12448>>3]*d*+h[e+23624>>3]);i=i;return}function Qk(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12312>>3]=+h[b+12336>>3]+(+h[b+12432>>3]*d*+h[e+21624>>3]- +h[b+12448>>3]*d*+h[e+21632>>3]);i=i;return}function Rk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12288>>3]=+h[b+12616>>3]+(+h[b+12448>>3]*+h[d+24392>>3]+ +h[b+12432>>3]*+h[d+24400>>3]);i=i;return}function Sk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12264>>3]=+h[b+12288>>3]+(+h[b+12448>>3]*+h[d+22424>>3]+ +h[b+12432>>3]*+h[d+22432>>3]);i=i;return}function Tk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12240>>3]=+h[b+12264>>3]+(+h[b+12448>>3]*+h[d+23616>>3]+ +h[b+12432>>3]*+h[d+23624>>3]);i=i;return}function Uk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12216>>3]=+h[b+12240>>3]+(+h[b+12448>>3]*+h[d+21624>>3]+ +h[b+12432>>3]*+h[d+21632>>3]);i=i;return}function Vk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12192>>3]=+h[b+12264>>3]+(+h[b+12448>>3]*+h[d+24488>>3]+ +h[b+12432>>3]*+h[d+24496>>3]);i=i;return}function Wk(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+12168>>3]=+h[b+12216>>3]+(+h[b+12448>>3]*+h[d+25352>>3]+ +h[b+12432>>3]*+h[d+25360>>3]);i=i;return}function Xk(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,28)|0;d=c[(c[a+476>>2]|0)+1820>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+1600>>3]=+h[d>>3];h[e+1608>>3]=+h[d+8>>3];i=b;return}function Yk(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+764>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1768>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1768|0;h[c[g+768>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1768>>3]);e=c[f>>2]|0;h[c[e+772>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+764>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26272>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26272|0;h[(c[e+768>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26272>>3]);j=c[f>>2]|0;h[(c[j+772>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+764>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26256>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26256|0;h[(c[j+768>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26256>>3]);h[(c[(c[f>>2]|0)+772>>2]|0)+16>>3]=k;qFc(a,9)|0;g=c[(c[f>>2]|0)+764>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1768>>3]=+h[g>>3];h[f+26272>>3]=+h[g+8>>3];h[f+26256>>3]=+h[g+16>>3];Xw(a);Yw(a);Zw(a);_w(a);$w(a);ax(a);bx(a);cx(a);dx(a);ex(a);fx(a);gx(a);hx(a);i=b;return}function Zk(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10048>>3]=+h[b+23480>>3]*+h[b+12448>>3]+ +h[b+23488>>3]*+h[b+12440>>3];i=i;return}function _k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10040>>3]=+h[b+23456>>3]*+h[b+12448>>3]+ +h[b+23464>>3]*+h[b+12440>>3];i=i;return}function $k(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26248>>3]=+h[(c[a+416>>2]|0)+43320>>3]- +h[b+26272>>3];i=i;return}function al(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+44696>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26248>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,1208,1200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26240>>3]=m+1.0;i=d;return}function bl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26208>>3]=+h[b+44712>>3]+ +h[b+44720>>3]*(1.0- +h[d+26240>>3]);i=i;return}function cl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26208>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26224|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,1240,1232,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26224|0;p=o;h[p>>3]=m;i=d;return}function dl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+44696>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26248>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26232|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26232|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,1208,1264,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26232|0;q=p;h[q>>3]=n;i=d;return}function el(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26272>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26264|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26272>>3];g=e;j=g+26264|0;k=j;h[k>>3]=f;i=b;return}function fl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1640>>3]=+h[b+1768>>3]- +h[(c[a+416>>2]|0)+20336>>3];i=i;return}function gl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1592>>3]=+h[b+1640>>3]- +h[(c[a+416>>2]|0)+20720>>3];i=i;return}function hl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24768>>3]=+h[b+1592>>3]- +h[b+12184>>3];i=i;return}function il(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,29)|0;d=c[(c[a+476>>2]|0)+1884>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12088>>3]=+h[d>>3];h[e+12096>>3]=+h[d+8>>3];i=b;return}function jl(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,30)|0;d=c[(c[a+476>>2]|0)+1948>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12144>>3]=+h[d>>3];h[e+26192>>3]=+h[d+8>>3];h[e+12136>>3]=+h[d+16>>3];h[e+12104>>3]=+h[d+24>>3];i=b;return}function kl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+8|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26240>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26240>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26240>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26240>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+7|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26240>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26240>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26240>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26240>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26240>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}}}function ll(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26216>>3]=+h[b+26184>>3]*1.0e-5;i=i;return}function ml(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+44704>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26280>>3]=b*b*+h[d+26216>>3]*-78539.81633974482;i=i;return}function nl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+44728>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26184>>3]*+h[j+26208>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26200|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,1280,1272,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26200|0;p=o;h[p>>3]=m;i=d;return}function ol(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10008>>3]=+h[b+12104>>3]- +h[b+16>>3];i=i;return}function pl(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26256>>3]));h[b+4256>>3]=-(d*+h[b+12104>>3]);i=i;return}function ql(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26256>>3]));h[b+4248>>3]=-(d*+h[b+12104>>3]);i=i;return}function rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3992>>3]=+h[b+4248>>3]*.8660254037844387+ +h[b+4256>>3]*-.4999999999999999;i=i;return}function sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+4248>>3]*.4999999999999999+ +h[b+4256>>3]*.8660254037844387;i=i;return}function tl(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26256>>3]));h[b+4240>>3]=d*+h[b+12104>>3];i=i;return}function ul(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26256>>3]));h[b+4232>>3]=-(d*+h[b+12104>>3]);i=i;return}function vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3976>>3]=+h[b+4232>>3]*.8660254037844387+ +h[b+4240>>3]*-.4999999999999999;i=i;return}function wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3984>>3]=+h[b+4232>>3]*.4999999999999999+ +h[b+4240>>3]*.8660254037844387;i=i;return}function xl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12056>>3]=+h[b+12312>>3]+(+h[b+12432>>3]*d*+h[e+25352>>3]- +h[b+12448>>3]*d*+h[e+25360>>3]);i=i;return}function yl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+12008>>3]=+h[b+12448>>3]*-.8660254037844386+ +h[b+12432>>3]*.5000000000000001;i=i;return}function zl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11992>>3]=+h[b+12448>>3]*-.5000000000000001+ +h[b+12432>>3]*-.8660254037844386;i=i;return}function Al(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11968>>3]=+h[b+12168>>3]+(+h[b+12008>>3]*+h[d+31376>>3]+ +h[b+11992>>3]*+h[d+31384>>3]);i=i;return}function Bl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11848>>3]=+h[b+12056>>3]+(+h[b+11992>>3]*d*+h[e+31376>>3]- +h[b+12008>>3]*d*+h[e+31384>>3]);i=i;return}function Cl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11800>>3]=+h[b+12008>>3]*6.123233995736766e-17+ +h[b+11992>>3];i=i;return}function Dl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11784>>3]=+h[b+11992>>3]*6.123233995736766e-17- +h[b+12008>>3];i=i;return}function El(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11760>>3]=+h[b+11848>>3]+(+h[b+11784>>3]*d*+h[e+30800>>3]- +h[b+11800>>3]*d*+h[e+30808>>3]);i=i;return}function Fl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11736>>3]=+h[b+11760>>3]+(+h[b+11784>>3]*d*+h[e+28832>>3]- +h[b+11800>>3]*d*+h[e+28840>>3]);i=i;return}function Gl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11712>>3]=+h[b+11736>>3]+(+h[b+11784>>3]*d*+h[e+30896>>3]- +h[b+11800>>3]*d*+h[e+30904>>3]);i=i;return}function Hl(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11688>>3]=+h[b+11736>>3]+(+h[b+11784>>3]*d*+h[e+30024>>3]- +h[b+11800>>3]*d*+h[e+30032>>3]);i=i;return}function Il(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11664>>3]=+h[b+11688>>3]+(+h[b+11784>>3]*d*+h[e+28032>>3]- +h[b+11800>>3]*d*+h[e+28040>>3]);i=i;return}function Jl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11640>>3]=+h[b+11968>>3]+(+h[b+11800>>3]*+h[d+30800>>3]+ +h[b+11784>>3]*+h[d+30808>>3]);i=i;return}function Kl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11616>>3]=+h[b+11640>>3]+(+h[b+11800>>3]*+h[d+28832>>3]+ +h[b+11784>>3]*+h[d+28840>>3]);i=i;return}function Ll(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11592>>3]=+h[b+11616>>3]+(+h[b+11800>>3]*+h[d+30024>>3]+ +h[b+11784>>3]*+h[d+30032>>3]);i=i;return}function Ml(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11568>>3]=+h[b+11592>>3]+(+h[b+11800>>3]*+h[d+28032>>3]+ +h[b+11784>>3]*+h[d+28040>>3]);i=i;return}function Nl(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11544>>3]=+h[b+11616>>3]+(+h[b+11800>>3]*+h[d+30896>>3]+ +h[b+11784>>3]*+h[d+30904>>3]);i=i;return}function Ol(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11520>>3]=+h[b+11568>>3]+(+h[b+11800>>3]*+h[d+31760>>3]+ +h[b+11784>>3]*+h[d+31768>>3]);i=i;return}function Pl(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,31)|0;d=c[(c[a+476>>2]|0)+2012>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+976>>3]=+h[d>>3];h[e+984>>3]=+h[d+8>>3];i=b;return}function Ql(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+844>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+1144>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+1144|0;h[c[g+848>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+1144>>3]);e=c[f>>2]|0;h[c[e+852>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+844>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26160>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26160|0;h[(c[e+848>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26160>>3]);j=c[f>>2]|0;h[(c[j+852>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+844>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26144>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26144|0;h[(c[j+848>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26144>>3]);h[(c[(c[f>>2]|0)+852>>2]|0)+16>>3]=k;qFc(a,10)|0;g=c[(c[f>>2]|0)+844>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+1144>>3]=+h[g>>3];h[f+26160>>3]=+h[g+8>>3];h[f+26144>>3]=+h[g+16>>3];kx(a);lx(a);mx(a);nx(a);ox(a);px(a);qx(a);rx(a);sx(a);tx(a);ux(a);vx(a);wx(a);i=b;return}function Rl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1016>>3]=+h[b+1144>>3]- +h[(c[a+416>>2]|0)+26744>>3];i=i;return}function Sl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+968>>3]=+h[b+1016>>3]- +h[(c[a+416>>2]|0)+27128>>3];i=i;return}function Tl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24976>>3]=+h[b+968>>3]- +h[b+11536>>3];i=i;return}function Ul(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10296>>3]=+h[b+23336>>3]*+h[b+11800>>3]+ +h[b+23344>>3]*+h[b+11792>>3];i=i;return}function Vl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10304>>3]=+h[b+23360>>3]*+h[b+11800>>3]+ +h[b+23368>>3]*+h[b+11792>>3];i=i;return}function Wl(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26136>>3]=+h[(c[a+416>>2]|0)+44800>>3]- +h[b+26160>>3];i=i;return}function Xl(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+46176>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26136>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,1312,1304,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26128>>3]=m+1.0;i=d;return}function Yl(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26096>>3]=+h[b+46192>>3]+ +h[b+46200>>3]*(1.0- +h[d+26128>>3]);i=i;return}function Zl(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+26096>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26112|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,1344,1336,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26112|0;p=o;h[p>>3]=m;i=d;return}function _l(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+46176>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26136>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26120|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26120|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,1312,1368,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26120|0;q=p;h[q>>3]=n;i=d;return}function $l(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26160>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26152|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26160>>3];g=e;j=g+26152|0;k=j;h[k>>3]=f;i=b;return}function am(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,32)|0;d=c[(c[a+476>>2]|0)+2076>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+11440>>3]=+h[d>>3];h[e+11448>>3]=+h[d+8>>3];i=b;return}function bm(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,33)|0;d=c[(c[a+476>>2]|0)+2140>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+11488>>3]=+h[d>>3];h[e+11464>>3]=+h[d+8>>3];h[e+26080>>3]=+h[d+16>>3];h[e+11472>>3]=+h[d+24>>3];i=b;return}function cm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10264>>3]=+h[b+11488>>3]- +h[b+16>>3];i=i;return}function dm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26144>>3]));h[b+4288>>3]=-(d*+h[b+11488>>3]);i=i;return}function em(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26144>>3]));h[b+4280>>3]=-(d*+h[b+11488>>3]);i=i;return}function fm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[b+4280>>3]*.8660254037844387+ +h[b+4288>>3]*.4999999999999999;i=i;return}function gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=+h[b+4280>>3]*-.4999999999999999+ +h[b+4288>>3]*.8660254037844387;i=i;return}function hm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26144>>3]));h[b+4272>>3]=d*+h[b+11488>>3];i=i;return}function im(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26144>>3]));h[b+4264>>3]=-(d*+h[b+11488>>3]);i=i;return}function jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=+h[b+4264>>3]*.8660254037844387+ +h[b+4272>>3]*.4999999999999999;i=i;return}function km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=+h[b+4264>>3]*-.4999999999999999+ +h[b+4272>>3]*.8660254037844387;i=i;return}



function lm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+5|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26128>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26128>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26128>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26128>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+4|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26128>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26128>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26128>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26128>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26128>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}}}function mm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26104>>3]=+h[b+26072>>3]*1.0e-5;i=i;return}function nm(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+46184>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26168>>3]=b*b*+h[d+26104>>3]*-78539.81633974482;i=i;return}function om(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+46208>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26072>>3]*+h[j+26096>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26088|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,1384,1376,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26088|0;p=o;h[p>>3]=m;i=d;return}function pm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11408>>3]=+h[b+11664>>3]+(+h[b+11784>>3]*d*+h[e+31760>>3]- +h[b+11800>>3]*d*+h[e+31768>>3]);i=i;return}function qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23960>>3]=+h[b+11800>>3]*6.123233995736766e-17- +h[b+11784>>3];i=i;return}function rm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23984>>3]=+h[b+11800>>3]+ +h[b+11784>>3]*6.123233995736766e-17;i=i;return}function sm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11368>>3]=+h[b+11520>>3]+(+h[b+23960>>3]*+h[d+37784>>3]+ +h[b+23984>>3]*+h[d+37792>>3]);i=i;return}function tm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11272>>3]=+h[b+11408>>3]+(+h[b+23984>>3]*d*+h[e+37784>>3]- +h[b+23960>>3]*d*+h[e+37792>>3]);i=i;return}function um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11224>>3]=+h[b+23960>>3]*.8660254037844387+ +h[b+23984>>3]*-.4999999999999999;i=i;return}function vm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+11208>>3]=+h[b+23960>>3]*.4999999999999999+ +h[b+23984>>3]*.8660254037844387;i=i;return}function wm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11184>>3]=+h[b+11272>>3]+(+h[b+11208>>3]*d*+h[e+37208>>3]- +h[b+11224>>3]*d*+h[e+37216>>3]);i=i;return}function xm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11160>>3]=+h[b+11184>>3]+(+h[b+11208>>3]*d*+h[e+35240>>3]- +h[b+11224>>3]*d*+h[e+35248>>3]);i=i;return}function ym(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11136>>3]=+h[b+11160>>3]+(+h[b+11208>>3]*d*+h[e+37304>>3]- +h[b+11224>>3]*d*+h[e+37312>>3]);i=i;return}function zm(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11112>>3]=+h[b+11160>>3]+(+h[b+11208>>3]*d*+h[e+36432>>3]- +h[b+11224>>3]*d*+h[e+36440>>3]);i=i;return}function Am(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11088>>3]=+h[b+11368>>3]+(+h[b+11224>>3]*+h[d+37208>>3]+ +h[b+11208>>3]*+h[d+37216>>3]);i=i;return}function Bm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11064>>3]=+h[b+11088>>3]+(+h[b+11224>>3]*+h[d+35240>>3]+ +h[b+11208>>3]*+h[d+35248>>3]);i=i;return}function Cm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11040>>3]=+h[b+11064>>3]+(+h[b+11224>>3]*+h[d+36432>>3]+ +h[b+11208>>3]*+h[d+36440>>3]);i=i;return}function Dm(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+11016>>3]=+h[b+11064>>3]+(+h[b+11224>>3]*+h[d+37304>>3]+ +h[b+11208>>3]*+h[d+37312>>3]);i=i;return}function Em(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,34)|0;d=c[(c[a+476>>2]|0)+2204>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+384>>3]=+h[d>>3];h[e+376>>3]=+h[d+8>>3];i=b;return}function Fm(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0.0;b=i;d=a+4|0;e=c[d>>2]|0;f=a+468|0;g=c[f>>2]|0;h[c[g+924>>2]>>3]=+h[(c[(c[e>>2]|0)+8>>2]|0)+520>>3];j=(c[(c[e+4>>2]|0)+8>>2]|0)+520|0;h[c[g+928>>2]>>3]=+h[j>>3];k=+sFc(a,+h[j>>3],+h[(c[(c[e+8>>2]|0)+8>>2]|0)+520>>3]);e=c[f>>2]|0;h[c[e+932>>2]>>3]=k;j=c[d>>2]|0;h[(c[e+924>>2]|0)+8>>3]=+h[(c[(c[j>>2]|0)+8>>2]|0)+26048>>3];g=(c[(c[j+4>>2]|0)+8>>2]|0)+26048|0;h[(c[e+928>>2]|0)+8>>3]=+h[g>>3];k=+sFc(a,+h[g>>3],+h[(c[(c[j+8>>2]|0)+8>>2]|0)+26048>>3]);j=c[f>>2]|0;h[(c[j+932>>2]|0)+8>>3]=k;g=c[d>>2]|0;h[(c[j+924>>2]|0)+16>>3]=+h[(c[(c[g>>2]|0)+8>>2]|0)+26032>>3];e=(c[(c[g+4>>2]|0)+8>>2]|0)+26032|0;h[(c[j+928>>2]|0)+16>>3]=+h[e>>3];k=+sFc(a,+h[e>>3],+h[(c[(c[g+8>>2]|0)+8>>2]|0)+26032>>3]);h[(c[(c[f>>2]|0)+932>>2]|0)+16>>3]=k;qFc(a,11)|0;g=c[(c[f>>2]|0)+924>>2]|0;f=c[(c[c[d>>2]>>2]|0)+8>>2]|0;h[f+520>>3]=+h[g>>3];h[f+26048>>3]=+h[g+8>>3];h[f+26032>>3]=+h[g+16>>3];zx(a);Ax(a);Bx(a);Cx(a);Dx(a);Ex(a);Fx(a);Gx(a);Hx(a);Ix(a);Jx(a);Kx(a);Lx(a);i=b;return}function Gm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10552>>3]=+h[b+23216>>3]*+h[b+11224>>3]+ +h[b+23224>>3]*+h[b+11216>>3];i=i;return}function Hm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+416>>3]=+h[b+520>>3]- +h[(c[a+416>>2]|0)+33152>>3];i=i;return}function Im(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+368>>3]=+h[b+416>>3]- +h[(c[a+416>>2]|0)+33536>>3];i=i;return}function Jm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25184>>3]=+h[b+368>>3]- +h[b+11008>>3];i=i;return}function Km(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26024>>3]=+h[(c[a+416>>2]|0)+46280>>3]- +h[b+26048>>3];i=i;return}function Lm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0.0;d=i;e=+h[(c[b+416>>2]|0)+47656>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26024>>3];do{if(e!=0.0){l=j;m=k/e}else{if(k==0.0){l=j;m=k;break}n=k/+KBc(c[b+536>>2]|0,e,1416,1408,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=n}}while(0);h[l+26016>>3]=m+1.0;i=d;return}function Mm(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+25984>>3]=+h[b+47672>>3]+ +h[b+47680>>3]*(1.0- +h[d+26016>>3]);i=i;return}function Nm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0.0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=b+4|0;f=c[c[e>>2]>>2]|0;g=c[f+8>>2]|0;j=+h[g+25984>>3];if(j!=0.0){k=j;l=g;m=1.0/k;n=l;o=n+26e3|0;p=o;h[p>>3]=m;i=d;return}q=+KBc(c[b+536>>2]|0,j,1448,1440,+h[f>>3],(a[b+319|0]|0)!=0|0);k=q;l=c[(c[c[e>>2]>>2]|0)+8>>2]|0;m=1.0/k;n=l;o=n+26e3|0;p=o;h[p>>3]=m;i=d;return}function Om(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0.0,m=0,n=0.0,o=0,p=0,q=0;d=i;e=+h[(c[b+416>>2]|0)+47656>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26024>>3];l=-k;if(e!=0.0){m=j;n=l/e;o=m;p=o+26008|0;q=p;h[q>>3]=n;i=d;return}if(k==-0.0){m=j;n=l;o=m;p=o+26008|0;q=p;h[q>>3]=n;i=d;return}k=l/+KBc(c[b+536>>2]|0,e,1416,1472,+h[g>>3],(a[b+319|0]|0)!=0|0);m=c[(c[c[f>>2]>>2]|0)+8>>2]|0;n=k;o=m;p=o+26008|0;q=p;h[q>>3]=n;i=d;return}function Pm(a){a=a|0;var b=0,d=0,e=0,f=0.0,g=0,j=0,k=0;b=i;d=a+4|0;a=(UEc(+U(+(+h[(c[(c[c[d>>2]>>2]|0)+8>>2]|0)+26048>>3])),1.0e-6)|0)<<24>>24==0;e=c[(c[c[d>>2]>>2]|0)+8>>2]|0;if(a){f=1.0e-6;g=e;j=g+26040|0;k=j;h[k>>3]=f;i=b;return}f=+h[e+26048>>3];g=e;j=g+26040|0;k=j;h[k>>3]=f;i=b;return}function Qm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10560>>3]=+h[b+23240>>3]*+h[b+11224>>3]+ +h[b+23248>>3]*+h[b+11216>>3];i=i;return}function Rm(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,35)|0;d=c[(c[a+476>>2]|0)+2268>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+10936>>3]=+h[d>>3];h[e+10944>>3]=+h[d+8>>3];i=b;return}function Sm(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,36)|0;d=c[(c[a+476>>2]|0)+2332>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+10992>>3]=+h[d>>3];h[e+25968>>3]=+h[d+8>>3];h[e+10984>>3]=+h[d+16>>3];h[e+10952>>3]=+h[d+24>>3];i=b;return}function Tm(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+2|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26016>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26016>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26016>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26016>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+1|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26016>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26016>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26016>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26016>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26016>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}}}function Um(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25992>>3]=+h[b+25960>>3]*1.0e-5;i=i;return}function Vm(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+47664>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26056>>3]=b*b*+h[d+25992>>3]*-78539.81633974482;i=i;return}function Wm(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+47688>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+25960>>3]*+h[j+25984>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+25976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+25976|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,1488,1480,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+25976|0;p=o;h[p>>3]=m;i=d;return}function Xm(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10520>>3]=+h[b+10952>>3]- +h[b+16>>3];i=i;return}function Ym(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26032>>3]));h[b+4320>>3]=-(d*+h[b+10952>>3]);i=i;return}function Zm(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26032>>3]));h[b+4312>>3]=-(d*+h[b+10952>>3]);i=i;return}function _m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+4312>>3]*.8660254037844387+ +h[b+4320>>3]*-.4999999999999999;i=i;return}function $m(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+4312>>3]*.4999999999999999+ +h[b+4320>>3]*.8660254037844387;i=i;return}function an(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26032>>3]));h[b+4304>>3]=d*+h[b+10952>>3];i=i;return}function bn(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26032>>3]));h[b+4296>>3]=-(d*+h[b+10952>>3]);i=i;return}function cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=+h[b+4296>>3]*.8660254037844387+ +h[b+4304>>3]*-.4999999999999999;i=i;return}function dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4048>>3]=+h[b+4296>>3]*.4999999999999999+ +h[b+4304>>3]*.8660254037844387;i=i;return}function en(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10832>>3]=+h[b+11224>>3]*-.4999999999999999+ +h[b+11208>>3]*.8660254037844387;i=i;return}function fn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10848>>3]=+h[b+11224>>3]*.8660254037844387+ +h[b+11208>>3]*.4999999999999999;i=i;return}function gn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10712>>3]=+h[b+11040>>3]+(+h[b+11224>>3]*+h[d+34440>>3]+ +h[b+11208>>3]*+h[d+34448>>3]);i=i;return}function hn(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+10688>>3]=+h[b+10712>>3]+(+h[b+11224>>3]*+h[d+38168>>3]+ +h[b+11208>>3]*+h[d+38176>>3]);i=i;return}function jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10584>>3]=+h[b+23240>>3]*+h[b+11208>>3]+ +h[b+23248>>3]*+h[b+11200>>3];i=i;return}function kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10576>>3]=+h[b+23216>>3]*+h[b+11208>>3]+ +h[b+23224>>3]*+h[b+11200>>3];i=i;return}function ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10328>>3]=+h[b+23360>>3]*+h[b+11784>>3]+ +h[b+23368>>3]*+h[b+11776>>3];i=i;return}function mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10320>>3]=+h[b+23336>>3]*+h[b+11784>>3]+ +h[b+23344>>3]*+h[b+11776>>3];i=i;return}function nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10072>>3]=+h[b+23480>>3]*+h[b+12432>>3]+ +h[b+23488>>3]*+h[b+12424>>3];i=i;return}function on(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10064>>3]=+h[b+23456>>3]*+h[b+12432>>3]+ +h[b+23464>>3]*+h[b+12424>>3];i=i;return}function pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9816>>3]=+h[b+23600>>3]*+h[b+13080>>3]+ +h[b+23608>>3]*+h[b+13072>>3];i=i;return}function qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9808>>3]=+h[b+23576>>3]*+h[b+13080>>3]+ +h[b+23584>>3]*+h[b+13072>>3];i=i;return}function rn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9560>>3]=+h[b+23720>>3]*+h[b+13728>>3]+ +h[b+23728>>3]*+h[b+13720>>3];i=i;return}function sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9552>>3]=+h[b+23696>>3]*+h[b+13728>>3]+ +h[b+23704>>3]*+h[b+13720>>3];i=i;return}function tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7840>>3]=+h[b+23864>>3]*+h[b+23032>>3]+ +h[b+23872>>3]*+h[b+23024>>3];i=i;return}function un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7832>>3]=+h[b+23840>>3]*+h[b+23032>>3]+ +h[b+23848>>3]*+h[b+23024>>3];i=i;return}function vn(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;gFc(a,37)|0;d=a+476|0;e=c[(c[d>>2]|0)+2396>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+744>>3]=+h[e>>3];h[a+632>>3]=+h[e+8>>3];h[a+1368>>3]=+h[e+16>>3];h[a+1256>>3]=+h[e+24>>3];h[a+1992>>3]=+h[e+32>>3];h[a+1880>>3]=+h[e+40>>3];h[a+2600>>3]=+h[e+48>>3];h[a+2504>>3]=+h[e+56>>3];h[a+3224>>3]=+h[e+64>>3];h[a+3112>>3]=+h[e+72>>3];h[a+7240>>3]=+h[e+80>>3];h[a+7264>>3]=+h[e+88>>3];h[a+7144>>3]=+h[e+96>>3];h[a+7312>>3]=+h[e+104>>3];h[a+7336>>3]=+h[e+112>>3];h[a+7448>>3]=+h[e+120>>3];h[a+7288>>3]=+h[e+128>>3];h[a+7296>>3]=+h[e+136>>3];h[a+7248>>3]=+h[e+144>>3];h[a+7216>>3]=+h[e+152>>3];h[a+7376>>3]=+h[e+160>>3];h[a+7224>>3]=+h[e+168>>3];h[a+7272>>3]=+h[e+176>>3];h[a+7616>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+7536>>3]=+h[e+192>>3];h[a+7640>>3]=+h[e+200>>3];h[a+7664>>3]=+h[e+208>>3];h[a+26624>>3]=+h[e+216>>3];h[a+7672>>3]=+h[e+224>>3];h[a+7728>>3]=+h[e+232>>3];h[a+7584>>3]=+h[e+240>>3];h[a+7784>>3]=+h[e+248>>3];h[a+7560>>3]=+h[e+256>>3];h[a+7568>>3]=+h[e+264>>3];h[a+7688>>3]=+h[e+272>>3];h[a+25344>>3]=+h[e+280>>3];h[a+3064>>3]=+h[e+288>>3];h[a+25336>>3]=+h[e+296>>3];h[a+7792>>3]=+h[e+304>>3];h[a+7592>>3]=+h[e+312>>3];h[a+7608>>3]=+h[e+320>>3];h[a+7152>>3]=+h[e+328>>3];h[a+7320>>3]=+h[e+336>>3];h[a+7176>>3]=+h[e+344>>3];h[a+7352>>3]=+h[e+352>>3];h[a+7184>>3]=+h[e+360>>3];h[a+7344>>3]=+h[e+368>>3];h[a+7480>>3]=+h[e+376>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+7112>>3]=+h[e+384>>3];h[a+7120>>3]=+h[e+392>>3];h[a+3840>>3]=+h[e+400>>3];h[a+2768>>3]=+h[e+408>>3];h[a+3856>>3]=+h[e+416>>3];h[a+2632>>3]=+h[e+424>>3];h[a+2720>>3]=+h[e+432>>3];h[a+6592>>3]=+h[e+440>>3];h[a+6544>>3]=+h[e+448>>3];h[a+6552>>3]=+h[e+456>>3];h[a+6520>>3]=+h[e+464>>3];h[a+6528>>3]=+h[e+472>>3];h[a+3832>>3]=+h[e+480>>3];h[a+6496>>3]=+h[e+488>>3];h[a+7032>>3]=+h[e+496>>3];h[a+6504>>3]=+h[e+504>>3];h[a+2760>>3]=+h[e+512>>3];h[a+7984>>3]=+h[e+520>>3];h[a+6360>>3]=+h[e+528>>3];h[a+8008>>3]=+h[e+536>>3];h[a+8032>>3]=+h[e+544>>3];h[a+26512>>3]=+h[e+552>>3];h[a+8040>>3]=+h[e+560>>3];h[a+9472>>3]=+h[e+568>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+7952>>3]=+h[e+576>>3];h[a+6392>>3]=+h[e+584>>3];h[a+6408>>3]=+h[e+592>>3];h[a+6384>>3]=+h[e+600>>3];h[a+9432>>3]=+h[e+608>>3];h[a+25408>>3]=+h[e+616>>3];h[a+2456>>3]=+h[e+624>>3];h[a+25416>>3]=+h[e+632>>3];h[a+6416>>3]=+h[e+640>>3];h[a+7960>>3]=+h[e+648>>3];h[a+7976>>3]=+h[e+656>>3];h[a+3848>>3]=+h[e+664>>3];h[a+2624>>3]=+h[e+672>>3];h[a+6448>>3]=+h[e+680>>3];h[a+7008>>3]=+h[e+688>>3];h[a+6456>>3]=+h[e+696>>3];h[a+2712>>3]=+h[e+704>>3];h[a+6600>>3]=+h[e+712>>3];h[a+3872>>3]=+h[e+720>>3];h[a+3864>>3]=+h[e+728>>3];h[a+3792>>3]=+h[e+736>>3];h[a+2160>>3]=+h[e+744>>3];h[a+3808>>3]=+h[e+752>>3];h[a+2024>>3]=+h[e+760>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2112>>3]=+h[e+768>>3];h[a+1912>>3]=+h[e+776>>3];h[a+6296>>3]=+h[e+784>>3];h[a+6304>>3]=+h[e+792>>3];h[a+6272>>3]=+h[e+800>>3];h[a+6280>>3]=+h[e+808>>3];h[a+3784>>3]=+h[e+816>>3];h[a+6248>>3]=+h[e+824>>3];h[a+6936>>3]=+h[e+832>>3];h[a+6256>>3]=+h[e+840>>3];h[a+2152>>3]=+h[e+848>>3];h[a+8104>>3]=+h[e+856>>3];h[a+6112>>3]=+h[e+864>>3];h[a+8128>>3]=+h[e+872>>3];h[a+8152>>3]=+h[e+880>>3];h[a+26400>>3]=+h[e+888>>3];h[a+8160>>3]=+h[e+896>>3];h[a+9728>>3]=+h[e+904>>3];h[a+8072>>3]=+h[e+912>>3];h[a+6160>>3]=+h[e+920>>3];h[a+6136>>3]=+h[e+928>>3];h[a+6144>>3]=+h[e+936>>3];h[a+9688>>3]=+h[e+944>>3];h[a+25480>>3]=+h[e+952>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1832>>3]=+h[e+960>>3];h[a+25488>>3]=+h[e+968>>3];h[a+6168>>3]=+h[e+976>>3];h[a+8080>>3]=+h[e+984>>3];h[a+8096>>3]=+h[e+992>>3];h[a+3800>>3]=+h[e+1e3>>3];h[a+2016>>3]=+h[e+1008>>3];h[a+6200>>3]=+h[e+1016>>3];h[a+6912>>3]=+h[e+1024>>3];h[a+6208>>3]=+h[e+1032>>3];h[a+2104>>3]=+h[e+1040>>3];h[a+1904>>3]=+h[e+1048>>3];h[a+3824>>3]=+h[e+1056>>3];h[a+3816>>3]=+h[e+1064>>3];h[a+3744>>3]=+h[e+1072>>3];h[a+1536>>3]=+h[e+1080>>3];h[a+3760>>3]=+h[e+1088>>3];h[a+1400>>3]=+h[e+1096>>3];h[a+1488>>3]=+h[e+1104>>3];h[a+1288>>3]=+h[e+1112>>3];h[a+6048>>3]=+h[e+1120>>3];h[a+6056>>3]=+h[e+1128>>3];h[a+6024>>3]=+h[e+1136>>3];h[a+6032>>3]=+h[e+1144>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3736>>3]=+h[e+1152>>3];h[a+6e3>>3]=+h[e+1160>>3];h[a+6840>>3]=+h[e+1168>>3];h[a+6008>>3]=+h[e+1176>>3];h[a+1528>>3]=+h[e+1184>>3];h[a+8216>>3]=+h[e+1192>>3];h[a+5864>>3]=+h[e+1200>>3];h[a+8248>>3]=+h[e+1208>>3];h[a+9984>>3]=+h[e+1216>>3];h[a+8272>>3]=+h[e+1224>>3];h[a+26288>>3]=+h[e+1232>>3];h[a+8280>>3]=+h[e+1240>>3];h[a+8192>>3]=+h[e+1248>>3];h[a+5912>>3]=+h[e+1256>>3];h[a+5888>>3]=+h[e+1264>>3];h[a+5896>>3]=+h[e+1272>>3];h[a+9944>>3]=+h[e+1280>>3];h[a+25560>>3]=+h[e+1288>>3];h[a+1208>>3]=+h[e+1296>>3];h[a+25552>>3]=+h[e+1304>>3];h[a+5920>>3]=+h[e+1312>>3];h[a+8200>>3]=+h[e+1320>>3];h[a+8224>>3]=+h[e+1328>>3];h[a+3752>>3]=+h[e+1336>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1392>>3]=+h[e+1344>>3];h[a+5952>>3]=+h[e+1352>>3];h[a+6816>>3]=+h[e+1360>>3];h[a+5960>>3]=+h[e+1368>>3];h[a+1480>>3]=+h[e+1376>>3];h[a+1280>>3]=+h[e+1384>>3];h[a+3776>>3]=+h[e+1392>>3];h[a+3768>>3]=+h[e+1400>>3];h[a+3696>>3]=+h[e+1408>>3];h[a+912>>3]=+h[e+1416>>3];h[a+3712>>3]=+h[e+1424>>3];h[a+776>>3]=+h[e+1432>>3];h[a+864>>3]=+h[e+1440>>3];h[a+664>>3]=+h[e+1448>>3];h[a+5800>>3]=+h[e+1456>>3];h[a+5808>>3]=+h[e+1464>>3];h[a+5776>>3]=+h[e+1472>>3];h[a+5784>>3]=+h[e+1480>>3];h[a+3688>>3]=+h[e+1488>>3];h[a+5752>>3]=+h[e+1496>>3];h[a+6744>>3]=+h[e+1504>>3];h[a+5760>>3]=+h[e+1512>>3];h[a+904>>3]=+h[e+1520>>3];h[a+3704>>3]=+h[e+1528>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+768>>3]=+h[e+1536>>3];h[a+5704>>3]=+h[e+1544>>3];h[a+6720>>3]=+h[e+1552>>3];h[a+5712>>3]=+h[e+1560>>3];h[a+856>>3]=+h[e+1568>>3];h[a+656>>3]=+h[e+1576>>3];h[a+3728>>3]=+h[e+1584>>3];h[a+3720>>3]=+h[e+1592>>3];h[a+144>>3]=+h[e+1600>>3];h[a+5664>>3]=+h[e+1608>>3];h[a+5672>>3]=+h[e+1616>>3];h[a+136>>3]=+h[e+1624>>3];h[a+224>>3]=+h[e+1632>>3];h[a+112>>3]=+h[e+1640>>3];h[a+360>>3]=+h[e+1648>>3];h[a+256>>3]=+h[e+1656>>3];h[a+320>>3]=+h[e+1664>>3];h[a+5632>>3]=+h[e+1672>>3];h[a+5640>>3]=+h[e+1680>>3];h[a+296>>3]=+h[e+1688>>3];h[a+5600>>3]=+h[e+1696>>3];h[a+6632>>3]=+h[e+1704>>3];h[a+264>>3]=+h[e+1712>>3];h[a+200>>3]=+h[e+1720>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+288>>3]=+h[e+1728>>3];h[a+5608>>3]=+h[e+1736>>3];h[a+352>>3]=+h[e+1744>>3];h[a+248>>3]=+h[e+1752>>3];h[a+5536>>3]=+h[e+1760>>3];h[a+6608>>3]=+h[e+1768>>3];h[a+5544>>3]=+h[e+1776>>3];h[a+312>>3]=+h[e+1784>>3];h[a+3680>>3]=+h[e+1792>>3];h[a+8456>>3]=+h[e+1800>>3];h[a+4632>>3]=+h[e+1808>>3];h[a+8488>>3]=+h[e+1816>>3];h[a+10496>>3]=+h[e+1824>>3];h[a+8512>>3]=+h[e+1832>>3];h[a+26064>>3]=+h[e+1840>>3];h[a+8520>>3]=+h[e+1848>>3];h[a+8432>>3]=+h[e+1856>>3];h[a+4680>>3]=+h[e+1864>>3];h[a+4664>>3]=+h[e+1872>>3];h[a+4656>>3]=+h[e+1880>>3];h[a+10456>>3]=+h[e+1888>>3];h[a+5496>>3]=+h[e+1896>>3];h[a+5520>>3]=+h[e+1904>>3];h[a+5584>>3]=+h[e+1912>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5464>>3]=+h[e+1920>>3];h[a+840>>3]=+h[e+1928>>3];h[a+5416>>3]=+h[e+1936>>3];h[a+5440>>3]=+h[e+1944>>3];h[a+832>>3]=+h[e+1952>>3];h[a+5424>>3]=+h[e+1960>>3];h[a+5448>>3]=+h[e+1968>>3];h[a+5472>>3]=+h[e+1976>>3];h[a+5488>>3]=+h[e+1984>>3];h[a+5512>>3]=+h[e+1992>>3];h[a+5576>>3]=+h[e+2e3>>3];h[a+25696>>3]=+h[e+2008>>3];h[a+808>>3]=+h[e+2016>>3];h[a+720>>3]=+h[e+2024>>3];h[a+784>>3]=+h[e+2032>>3];h[a+896>>3]=+h[e+2040>>3];h[a+920>>3]=+h[e+2048>>3];h[a+496>>3]=+h[e+2056>>3];h[a+176>>3]=+h[e+2064>>3];h[a+88>>3]=+h[e+2072>>3];h[a+152>>3]=+h[e+2080>>3];h[a+304>>3]=+h[e+2088>>3];h[a+328>>3]=+h[e+2096>>3];h[a+64>>3]=+h[e+2104>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+25704>>3]=+h[e+2112>>3];h[a+4688>>3]=+h[e+2120>>3];h[a+8440>>3]=+h[e+2128>>3];h[a+8464>>3]=+h[e+2136>>3];h[a+3672>>3]=+h[e+2144>>3];h[a+26648>>3]=+h[e+2152>>3];h[a+26632>>3]=+h[e+2160>>3];h[a+8336>>3]=+h[e+2168>>3];h[a+4552>>3]=+h[e+2176>>3];h[a+4520>>3]=+h[e+2184>>3];h[a+8368>>3]=+h[e+2192>>3];h[a+10240>>3]=+h[e+2200>>3];h[a+8392>>3]=+h[e+2208>>3];h[a+26176>>3]=+h[e+2216>>3];h[a+8400>>3]=+h[e+2224>>3];h[a+8312>>3]=+h[e+2232>>3];h[a+8344>>3]=+h[e+2240>>3];h[a+4576>>3]=+h[e+2248>>3];h[a+8320>>3]=+h[e+2256>>3];h[a+10200>>3]=+h[e+2264>>3];h[a+4544>>3]=+h[e+2272>>3];h[a+4568>>3]=+h[e+2280>>3];h[a+5208>>3]=+h[e+2288>>3];h[a+5232>>3]=+h[e+2296>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5256>>3]=+h[e+2304>>3];h[a+1456>>3]=+h[e+2312>>3];h[a+5280>>3]=+h[e+2320>>3];h[a+5304>>3]=+h[e+2328>>3];h[a+5320>>3]=+h[e+2336>>3];h[a+5352>>3]=+h[e+2344>>3];h[a+5376>>3]=+h[e+2352>>3];h[a+5400>>3]=+h[e+2360>>3];h[a+25632>>3]=+h[e+2368>>3];h[a+872>>3]=+h[e+2376>>3];h[a+584>>3]=+h[e+2384>>3];h[a+25624>>3]=+h[e+2392>>3];h[a+672>>3]=+h[e+2400>>3];h[a+848>>3]=+h[e+2408>>3];h[a+5392>>3]=+h[e+2416>>3];h[a+696>>3]=+h[e+2424>>3];h[a+608>>3]=+h[e+2432>>3];h[a+5368>>3]=+h[e+2440>>3];h[a+5344>>3]=+h[e+2448>>3];h[a+1096>>3]=+h[e+2456>>3];h[a+5328>>3]=+h[e+2464>>3];h[a+1320>>3]=+h[e+2472>>3];h[a+1232>>3]=+h[e+2480>>3];h[a+1296>>3]=+h[e+2488>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1472>>3]=+h[e+2496>>3];h[a+1496>>3]=+h[e+2504>>3];h[a+1432>>3]=+h[e+2512>>3];h[a+1344>>3]=+h[e+2520>>3];h[a+1408>>3]=+h[e+2528>>3];h[a+1520>>3]=+h[e+2536>>3];h[a+1544>>3]=+h[e+2544>>3];h[a+5296>>3]=+h[e+2552>>3];h[a+5272>>3]=+h[e+2560>>3];h[a+1464>>3]=+h[e+2568>>3];h[a+5248>>3]=+h[e+2576>>3];h[a+5224>>3]=+h[e+2584>>3];h[a+5064>>3]=+h[e+2592>>3];h[a+5088>>3]=+h[e+2600>>3];h[a+5112>>3]=+h[e+2608>>3];h[a+2080>>3]=+h[e+2616>>3];h[a+5136>>3]=+h[e+2624>>3];h[a+5160>>3]=+h[e+2632>>3];h[a+5176>>3]=+h[e+2640>>3];h[a+5200>>3]=+h[e+2648>>3];h[a+1720>>3]=+h[e+2656>>3];h[a+5184>>3]=+h[e+2664>>3];h[a+1944>>3]=+h[e+2672>>3];h[a+1856>>3]=+h[e+2680>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+1920>>3]=+h[e+2688>>3];h[a+2096>>3]=+h[e+2696>>3];h[a+2120>>3]=+h[e+2704>>3];h[a+2056>>3]=+h[e+2712>>3];h[a+1968>>3]=+h[e+2720>>3];h[a+2032>>3]=+h[e+2728>>3];h[a+2144>>3]=+h[e+2736>>3];h[a+2168>>3]=+h[e+2744>>3];h[a+5152>>3]=+h[e+2752>>3];h[a+5128>>3]=+h[e+2760>>3];h[a+2088>>3]=+h[e+2768>>3];h[a+5104>>3]=+h[e+2776>>3];h[a+5080>>3]=+h[e+2784>>3];h[a+5032>>3]=+h[e+2792>>3];h[a+5056>>3]=+h[e+2800>>3];h[a+2344>>3]=+h[e+2808>>3];h[a+4896>>3]=+h[e+2816>>3];h[a+4912>>3]=+h[e+2824>>3];h[a+4936>>3]=+h[e+2832>>3];h[a+4960>>3]=+h[e+2840>>3];h[a+2696>>3]=+h[e+2848>>3];h[a+4984>>3]=+h[e+2856>>3];h[a+5008>>3]=+h[e+2864>>3];h[a+5040>>3]=+h[e+2872>>3];e=c[(c[d>>2]|0)+2396>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2640>>3]=+h[e+2880>>3];h[a+2752>>3]=+h[e+2888>>3];h[a+2776>>3]=+h[e+2896>>3];h[a+5016>>3]=+h[e+2904>>3];h[a+2728>>3]=+h[e+2912>>3];h[a+2664>>3]=+h[e+2920>>3];h[a+2576>>3]=+h[e+2928>>3];h[a+4992>>3]=+h[e+2936>>3];h[a+2688>>3]=+h[e+2944>>3];h[a+2528>>3]=+h[e+2952>>3];h[a+2704>>3]=+h[e+2960>>3];h[a+4968>>3]=+h[e+2968>>3];h[a+2552>>3]=+h[e+2976>>3];h[a+2480>>3]=+h[e+2984>>3];h[a+4944>>3]=+h[e+2992>>3];h[a+4920>>3]=+h[e+3e3>>3];h[a+2952>>3]=+h[e+3008>>3];h[a+4768>>3]=+h[e+3016>>3];h[a+4792>>3]=+h[e+3024>>3];h[a+4816>>3]=+h[e+3032>>3];h[a+3304>>3]=+h[e+3040>>3];h[a+4840>>3]=+h[e+3048>>3];h[a+4864>>3]=+h[e+3056>>3];h[a+4888>>3]=+h[e+3064>>3];e=c[(c[d>>2]|0)+2396>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+3248>>3]=+h[e+3072>>3];h[d+3344>>3]=+h[e+3080>>3];h[d+3352>>3]=+h[e+3088>>3];h[d+4872>>3]=+h[e+3096>>3];h[d+3320>>3]=+h[e+3104>>3];h[d+3272>>3]=+h[e+3112>>3];h[d+3200>>3]=+h[e+3120>>3];h[d+4848>>3]=+h[e+3128>>3];h[d+3296>>3]=+h[e+3136>>3];h[d+3152>>3]=+h[e+3144>>3];h[d+3312>>3]=+h[e+3152>>3];h[d+4824>>3]=+h[e+3160>>3];h[d+4752>>3]=+h[e+3168>>3];h[d+4776>>3]=+h[e+3176>>3];h[d+4744>>3]=+h[e+3184>>3];h[d+3176>>3]=+h[e+3192>>3];h[d+3088>>3]=+h[e+3200>>3];h[d+4800>>3]=+h[e+3208>>3];h[d+7456>>3]=+h[e+3216>>3];h[d+7472>>3]=+h[e+3224>>3];i=b;return}function wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3128>>3]=+h[b+7448>>3]*.05;i=i;return}function xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3240>>3]=+h[b+7288>>3]*.05;i=i;return}function yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3232>>3]=+h[b+7296>>3]*-.05;i=i;return}function zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7648>>3]=((+h[b+7664>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*.4999999999999999+ +h[b+7672>>3]*.8660254037844387)*6.047565858160353;i=i;return}function An(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7904>>3]=+h[b+7648>>3]*.05;i=i;return}function Bn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=-+h[b+7904>>3]- +h[(c[a+416>>2]|0)+38912>>3];i=i;return}function Cn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3424>>3]=-(+h[(c[a+416>>2]|0)+1496>>3]*+h[b+7560>>3]);i=i;return}function Dn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+24112>>3]*+h[b+7560>>3]+ +h[b+24136>>3]*+h[b+7568>>3];i=i;return}function En(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+7648>>3]+ +h[b+7544>>3];i=i;return}function Fn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3480>>3]=-(+h[b+1120>>3]*+h[d+7512>>3])- +h[d+3440>>3]- +h[b+1128>>3]*+h[d+26616>>3];i=i;return}function Gn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[b+3480>>3]- +h[b+7512>>3]*+h[b+26608>>3];i=i;return}function Hn(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3488>>3]=+h[b+344>>3]*+h[d+7512>>3]+(+h[b+352>>3]*+h[d+26616>>3]+ +h[d+3624>>3]);i=i;return}function In(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+26616>>3]*-.8660254037844387+ +h[b+7512>>3]*.4999999999999999;i=i;return}function Jn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6576>>3]=+h[b+26616>>3]*.4999999999999999+ +h[b+7512>>3]*.8660254037844387;i=i;return}function Kn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[(c[a+416>>2]|0)+1496>>3]*+h[b+7568>>3];i=i;return}function Ln(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+24104>>3]*+h[b+3432>>3]+ +h[b+24128>>3]*+h[b+3424>>3];i=i;return}function Mn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[(c[a+416>>2]|0)+1112>>3]*+h[b+7512>>3]+ +h[b+3520>>3];i=i;return}function Nn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3496>>3]=+h[b+3472>>3]- +h[(c[a+416>>2]|0)+336>>3]*+h[b+7512>>3];i=i;return}function On(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3512>>3]=+h[b+24112>>3]*+h[b+3432>>3]+ +h[b+24136>>3]*+h[b+3424>>3];i=i;return}function Pn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3616>>3]=+h[(c[a+416>>2]|0)+1112>>3]*+h[b+26616>>3]+ +h[b+3512>>3];i=i;return}function Qn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3504>>3]=+h[b+3616>>3]- +h[(c[a+416>>2]|0)+336>>3]*+h[b+26616>>3];i=i;return}function Rn(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+6576>>3];l=+h[a+6568>>3];m=+h[a+3488>>3]+(+h[f+5360>>3]*j- +h[f+5368>>3]*l);n=+h[f+5352>>3];o=+h[a+3496>>3];p=+h[a+3504>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3040|0);i=b;return}function Sn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3072>>3]=-(+h[(c[a+416>>2]|0)+5256>>3]*+h[b+25344>>3]);i=i;return}function Tn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3080>>3]=+h[(c[a+416>>2]|0)+5256>>3]*+h[b+25336>>3];i=i;return}function Un(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+6544>>3]*.05;i=i;return}function Vn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2512>>3]=+h[b+6552>>3]*-.05;i=i;return}function Wn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+6520>>3]*.05;i=i;return}function Xn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+6528>>3]*-.05;i=i;return}function Yn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=((+h[b+8032>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*-.4999999999999999+ +h[b+8040>>3]*.8660254037844387)*6.047565858160353;i=i;return}function Zn(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9600>>3]=+h[b+8016>>3]*.05;i=i;return}function _n(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2864>>3]=-+h[b+9600>>3]- +h[(c[a+416>>2]|0)+40392>>3];i=i;return}function $n(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=+h[(c[a+416>>2]|0)+7904>>3]*+h[b+6392>>3];i=i;return}function ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6368>>3]=+h[b+24320>>3]*+h[b+6384>>3]+ +h[b+24344>>3]*+h[b+6392>>3];i=i;return}function bo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6336>>3]=+h[b+8016>>3]+ +h[b+6368>>3];i=i;return}function co(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2904>>3]=-(+h[b+7528>>3]*+h[d+6336>>3])- +h[d+2864>>3]- +h[b+7536>>3]*+h[d+26504>>3];i=i;return}function eo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3032>>3]=+h[b+2904>>3]- +h[b+6336>>3]*+h[b+26496>>3];i=i;return}function fo(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2912>>3]=+h[b+6752>>3]*+h[d+6336>>3]+(+h[b+6760>>3]*+h[d+26504>>3]+ +h[d+3032>>3]);i=i;return}function go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6320>>3]=+h[b+26504>>3]*-.8660254037844387+ +h[b+6336>>3]*-.4999999999999999;i=i;return}function ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6328>>3]=+h[b+26504>>3]*-.4999999999999999+ +h[b+6336>>3]*.8660254037844387;i=i;return}function io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=-(+h[(c[a+416>>2]|0)+7904>>3]*+h[b+6384>>3]);i=i;return}function jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2944>>3]=+h[b+24312>>3]*+h[b+2856>>3]+ +h[b+24336>>3]*+h[b+2848>>3];i=i;return}function ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2896>>3]=+h[(c[a+416>>2]|0)+7520>>3]*+h[b+6336>>3]+ +h[b+2944>>3];i=i;return}function lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2920>>3]=+h[b+2896>>3]- +h[(c[a+416>>2]|0)+6744>>3]*+h[b+6336>>3];i=i;return}function mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2936>>3]=+h[b+24320>>3]*+h[b+2856>>3]+ +h[b+24344>>3]*+h[b+2848>>3];i=i;return}function no(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[(c[a+416>>2]|0)+7520>>3]*+h[b+26504>>3]+ +h[b+2936>>3];i=i;return}function oo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2928>>3]=+h[b+3024>>3]- +h[(c[a+416>>2]|0)+6744>>3]*+h[b+26504>>3];i=i;return}function po(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+6328>>3];l=+h[a+6320>>3];m=+h[a+2912>>3]+(+h[f+11768>>3]*j- +h[f+11776>>3]*l);n=+h[f+11760>>3];o=+h[a+2920>>3];p=+h[a+2928>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*-.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2432|0);i=b;return}function qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2472>>3]=+h[(c[a+416>>2]|0)+11664>>3]*+h[b+25408>>3];i=i;return}function ro(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=-(+h[(c[a+416>>2]|0)+11664>>3]*+h[b+25416>>3]);i=i;return}function so(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+6296>>3]*.05;i=i;return}function to(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+6304>>3]*-.05;i=i;return}function uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+6272>>3]*.05;i=i;return}function vo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+6280>>3]*-.05;i=i;return}function wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=((+h[b+8152>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*.4999999999999999+ +h[b+8160>>3]*.8660254037844387)*6.047565858160353;i=i;return}function xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9856>>3]=+h[b+8136>>3]*.05;i=i;return}function yo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2256>>3]=-+h[b+9856>>3]- +h[(c[a+416>>2]|0)+41872>>3];i=i;return}function zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=-(+h[(c[a+416>>2]|0)+14312>>3]*+h[b+6136>>3]);i=i;return}function Ao(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6120>>3]=+h[b+24528>>3]*+h[b+6136>>3]+ +h[b+24552>>3]*+h[b+6144>>3];i=i;return}function Bo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6088>>3]=+h[b+8136>>3]+ +h[b+6120>>3];i=i;return}function Co(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2296>>3]=-(+h[b+13936>>3]*+h[d+6088>>3])- +h[d+2256>>3]- +h[b+13944>>3]*+h[d+26392>>3];i=i;return}function Do(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2424>>3]=+h[b+2296>>3]- +h[b+6088>>3]*+h[b+26384>>3];i=i;return}function Eo(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2304>>3]=+h[b+13160>>3]*+h[d+6088>>3]+(+h[b+13168>>3]*+h[d+26392>>3]+ +h[d+2424>>3]);i=i;return}function Fo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6072>>3]=+h[b+26392>>3]*-.8660254037844387+ +h[b+6088>>3]*.4999999999999999;i=i;return}function Go(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6080>>3]=+h[b+26392>>3]*.4999999999999999+ +h[b+6088>>3]*.8660254037844387;i=i;return}function Ho(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=+h[(c[a+416>>2]|0)+14312>>3]*+h[b+6144>>3];i=i;return}function Io(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+24520>>3]*+h[b+2248>>3]+ +h[b+24544>>3]*+h[b+2240>>3];i=i;return}function Jo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2288>>3]=+h[(c[a+416>>2]|0)+13928>>3]*+h[b+6088>>3]+ +h[b+2336>>3];i=i;return}function Ko(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+2288>>3]- +h[(c[a+416>>2]|0)+13152>>3]*+h[b+6088>>3];i=i;return}function Lo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2328>>3]=+h[b+24528>>3]*+h[b+2248>>3]+ +h[b+24552>>3]*+h[b+2240>>3];i=i;return}function Mo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=+h[(c[a+416>>2]|0)+13928>>3]*+h[b+26392>>3]+ +h[b+2328>>3];i=i;return}function No(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2320>>3]=+h[b+2416>>3]- +h[(c[a+416>>2]|0)+13152>>3]*+h[b+26392>>3];i=i;return}function Oo(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+6080>>3];l=+h[a+6072>>3];m=+h[a+2304>>3]+(+h[f+18176>>3]*j- +h[f+18184>>3]*l);n=+h[f+18168>>3];o=+h[a+2312>>3];p=+h[a+2320>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808|0);i=b;return}function Po(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[(c[a+416>>2]|0)+18072>>3]*+h[b+25480>>3];i=i;return}function Qo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1840>>3]=-(+h[(c[a+416>>2]|0)+18072>>3]*+h[b+25488>>3]);i=i;return}function Ro(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[b+6048>>3]*.05;i=i;return}function So(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1264>>3]=+h[b+6056>>3]*-.05;i=i;return}function To(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1384>>3]=+h[b+6024>>3]*.05;i=i;return}function Uo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1376>>3]=+h[b+6032>>3]*-.05;i=i;return}function Vo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=((+h[b+8272>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*-.4999999999999999+ +h[b+8280>>3]*.8660254037844387)*6.047565858160353;i=i;return}function Wo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10112>>3]=+h[b+8256>>3]*.05;i=i;return}function Xo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=-+h[b+10112>>3]- +h[(c[a+416>>2]|0)+43352>>3];i=i;return}function Yo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=-(+h[(c[a+416>>2]|0)+20720>>3]*+h[b+5888>>3]);i=i;return}function Zo(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5872>>3]=+h[b+24736>>3]*+h[b+5888>>3]+ +h[b+24760>>3]*+h[b+5896>>3];i=i;return}function _o(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5840>>3]=+h[b+8256>>3]+ +h[b+5872>>3];i=i;return}function $o(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1672>>3]=-(+h[b+20344>>3]*+h[d+5840>>3])- +h[d+1632>>3]- +h[b+20352>>3]*+h[d+26280>>3];i=i;return}function ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+1672>>3]- +h[b+5840>>3]*+h[b+26272>>3];i=i;return}function bp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1680>>3]=+h[b+19568>>3]*+h[d+5840>>3]+(+h[b+19576>>3]*+h[d+26280>>3]+ +h[d+1800>>3]);i=i;return}function cp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5824>>3]=+h[b+26280>>3]*-.8660254037844387+ +h[b+5840>>3]*-.4999999999999999;i=i;return}function dp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5832>>3]=+h[b+26280>>3]*-.4999999999999999+ +h[b+5840>>3]*.8660254037844387;i=i;return}function ep(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1624>>3]=+h[(c[a+416>>2]|0)+20720>>3]*+h[b+5896>>3];i=i;return}function fp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1712>>3]=+h[b+24728>>3]*+h[b+1624>>3]+ +h[b+24752>>3]*+h[b+1616>>3];i=i;return}function gp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[(c[a+416>>2]|0)+20336>>3]*+h[b+5840>>3]+ +h[b+1712>>3];i=i;return}function hp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1688>>3]=+h[b+1664>>3]- +h[(c[a+416>>2]|0)+19560>>3]*+h[b+5840>>3];i=i;return}function ip(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1704>>3]=+h[b+24736>>3]*+h[b+1624>>3]+ +h[b+24760>>3]*+h[b+1616>>3];i=i;return}function jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=+h[(c[a+416>>2]|0)+20336>>3]*+h[b+26280>>3]+ +h[b+1704>>3];i=i;return}function kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1696>>3]=+h[b+1792>>3]- +h[(c[a+416>>2]|0)+19560>>3]*+h[b+26280>>3];i=i;return}function lp(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+5832>>3];l=+h[a+5824>>3];m=+h[a+1680>>3]+(+h[f+24584>>3]*j- +h[f+24592>>3]*l);n=+h[f+24576>>3];o=+h[a+1688>>3];p=+h[a+1696>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*-.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1184|0);i=b;return}function mp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=-(+h[(c[a+416>>2]|0)+24480>>3]*+h[b+25560>>3]);i=i;return}function np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1224>>3]=+h[(c[a+416>>2]|0)+24480>>3]*+h[b+25552>>3];i=i;return}function op(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+5800>>3]*.05;i=i;return}function pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+5808>>3]*-.05;i=i;return}function qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+760>>3]=+h[b+5776>>3]*.05;i=i;return}function rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+752>>3]=+h[b+5784>>3]*-.05;i=i;return}function sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+128>>3]=+h[b+5664>>3]*.05;i=i;return}function tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+120>>3]=+h[b+5672>>3]*-.05;i=i;return}function up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+240>>3]=+h[b+5632>>3]*.05;i=i;return}function vp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+232>>3]=+h[b+5640>>3]*-.05;i=i;return}function wp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+216>>3]=-(+h[(c[a+416>>2]|0)+36424>>3]*+h[b+5600>>3]);i=i;return}function xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+280>>3]=+h[b+240>>3]+ +h[b+216>>3];i=i;return}function yp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+208>>3]=+h[(c[a+416>>2]|0)+36424>>3]*+h[b+5608>>3];i=i;return}function zp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+272>>3]=+h[b+232>>3]+ +h[b+208>>3];i=i;return}function Ap(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=((+h[b+8512>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*-.4999999999999999+ +h[b+8520>>3]*.8660254037844387)*6.047565858160353;i=i;return}function Bp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10624>>3]=+h[b+8496>>3]*.05;i=i;return}function Cp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=-+h[b+10624>>3]- +h[(c[a+416>>2]|0)+46312>>3];i=i;return}function Dp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[(c[a+416>>2]|0)+33536>>3]*+h[b+4664>>3];i=i;return}function Ep(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4640>>3]=+h[b+25152>>3]*+h[b+4656>>3]+ +h[b+25176>>3]*+h[b+4664>>3];i=i;return}function Fp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4608>>3]=+h[b+8496>>3]+ +h[b+4640>>3];i=i;return}function Gp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+448>>3]=-(+h[b+33160>>3]*+h[d+4608>>3])- +h[d+408>>3]- +h[b+33168>>3]*+h[d+26056>>3];i=i;return}function Hp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+552>>3]=+h[b+448>>3]- +h[b+4608>>3]*+h[b+26048>>3];i=i;return}function Ip(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+456>>3]=+h[b+32384>>3]*+h[d+4608>>3]+(+h[b+32392>>3]*+h[d+26056>>3]+ +h[d+552>>3]);i=i;return}function Jp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4592>>3]=+h[b+26056>>3]*.8660254037844387+ +h[b+4608>>3]*.4999999999999999;i=i;return}function Kp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4600>>3]=+h[b+26056>>3]*.4999999999999999+ +h[b+4608>>3]*-.8660254037844387;i=i;return}function Lp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1120>>3]=+h[b+37400>>3]*+h[d+4600>>3]- +h[b+37408>>3]*+h[d+4592>>3]- +h[d+456>>3];i=i;return}function Mp(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+944>>3]=+h[b+27656>>3]*+h[d+4592>>3]+(-(+h[b+27648>>3]*+h[d+4600>>3])- +h[d+1120>>3]);i=i;return}function Np(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=-(+h[(c[a+416>>2]|0)+33536>>3]*+h[b+4656>>3]);i=i;return}function Op(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+25144>>3]*+h[b+400>>3]+ +h[b+25168>>3]*+h[b+392>>3];i=i;return}function Pp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[(c[a+416>>2]|0)+33152>>3]*+h[b+4608>>3]+ +h[b+488>>3];i=i;return}function Qp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+440>>3]- +h[(c[a+416>>2]|0)+32376>>3]*+h[b+4608>>3];i=i;return}function Rp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+25152>>3]*+h[b+400>>3]+ +h[b+25176>>3]*+h[b+392>>3];i=i;return}function Sp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[(c[a+416>>2]|0)+33152>>3]*+h[b+26056>>3]+ +h[b+480>>3];i=i;return}function Tp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+544>>3]- +h[(c[a+416>>2]|0)+32376>>3]*+h[b+26056>>3];i=i;return}function Up(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1128>>3]=+h[b+464>>3]*-.8660254037844387+(+h[b+472>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+37392>>3]*+h[b+4600>>3]);i=i;return}function Vp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[(c[a+416>>2]|0)+27640>>3]*+h[b+4600>>3]- +h[b+1128>>3];i=i;return}function Wp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+464>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+37392>>3]*+h[b+4592>>3]+ +h[b+472>>3]*-.8660254037844387);i=i;return}function Xp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=-+h[b+1136>>3]- +h[(c[a+416>>2]|0)+27640>>3]*+h[b+4592>>3];i=i;return}function Yp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+80>>3]=+h[(c[a+416>>2]|0)+37296>>3]*+h[b+25696>>3];i=i;return}function Zp(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+344>>3]=-+h[b+280>>3]- +h[b+80>>3];i=i;return}function _p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+168>>3]=+h[b+344>>3]+ +h[(c[a+416>>2]|0)+35232>>3]*+h[b+5576>>3];i=i;return}function $p(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+104>>3]=-+h[b+168>>3]- +h[(c[a+416>>2]|0)+37200>>3]*+h[b+5512>>3];i=i;return}function aq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+192>>3]=+h[b+128>>3]+ +h[b+104>>3];i=i;return}function bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+72>>3]=-(+h[(c[a+416>>2]|0)+37296>>3]*+h[b+25704>>3]);i=i;return}function cq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+336>>3]=-+h[b+272>>3]- +h[b+72>>3];i=i;return}function dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+160>>3]=+h[b+336>>3]- +h[(c[a+416>>2]|0)+35232>>3]*+h[b+5584>>3];i=i;return}function eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+96>>3]=+h[(c[a+416>>2]|0)+37200>>3]*+h[b+5520>>3]- +h[b+160>>3];i=i;return}function fq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+184>>3]=+h[b+120>>3]+ +h[b+96>>3];i=i;return}function gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+512>>3]=+h[b+184>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+37776>>3]*+h[b+5464>>3]+ +h[b+192>>3]*.8660254037844387);i=i;return}function hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+504>>3]=+h[b+184>>3]*.8660254037844387+(+h[b+192>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+37776>>3]*+h[b+5472>>3]);i=i;return}function iq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+928>>3]=+h[b+504>>3]*-6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+31752>>3]*+h[b+5448>>3])- +h[b+512>>3]);i=i;return}function jq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+792>>3]=+h[b+928>>3]- +h[(c[a+416>>2]|0)+28024>>3]*+h[b+5448>>3];i=i;return}function kq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+728>>3]=+h[(c[a+416>>2]|0)+30016>>3]*+h[b+5424>>3]- +h[b+792>>3];i=i;return}function lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+816>>3]=+h[b+752>>3]+ +h[b+728>>3];i=i;return}function mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+936>>3]=+h[b+512>>3]*-6.123233995736766e-17+(+h[b+504>>3]+ +h[(c[a+416>>2]|0)+31752>>3]*+h[b+5440>>3]);i=i;return}function nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+800>>3]=+h[b+936>>3]+ +h[(c[a+416>>2]|0)+28024>>3]*+h[b+5440>>3];i=i;return}function oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+736>>3]=-+h[b+800>>3]- +h[(c[a+416>>2]|0)+30016>>3]*+h[b+5416>>3];i=i;return}function pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+824>>3]=+h[b+760>>3]+ +h[b+736>>3];i=i;return}function qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+32>>3]=(+h[b+26648>>3]- +h[b>>3])*+h[(c[a+416>>2]|0)+47744>>3];i=i;return}function rq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+26632>>3];i=i;return}function sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[(c[a+416>>2]|0)+27128>>3]*+h[b+4552>>3];i=i;return}function tq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8376>>3]=((+h[b+8392>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*.4999999999999999+ +h[b+8400>>3]*.8660254037844387)*6.047565858160353;i=i;return}function uq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10368>>3]=+h[b+8376>>3]*.05;i=i;return}function vq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=-+h[b+10368>>3]- +h[(c[a+416>>2]|0)+44832>>3];i=i;return}function wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4528>>3]=+h[b+24944>>3]*+h[b+4544>>3]+ +h[b+24968>>3]*+h[b+4552>>3];i=i;return}function xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4496>>3]=+h[b+8376>>3]+ +h[b+4528>>3];i=i;return}function yq(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1048>>3]=-(+h[b+26752>>3]*+h[d+4496>>3])- +h[d+1008>>3]- +h[b+26760>>3]*+h[d+26168>>3];i=i;return}function zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1176>>3]=+h[b+1048>>3]- +h[b+4496>>3]*+h[b+26160>>3];i=i;return}function Aq(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1056>>3]=+h[b+25976>>3]*+h[d+4496>>3]+(+h[b+25984>>3]*+h[d+26168>>3]+ +h[d+1176>>3]);i=i;return}function Bq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+26168>>3]*-.8660254037844387+ +h[b+4496>>3]*.4999999999999999;i=i;return}function Cq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4456>>3]=+h[b+4592>>3]- +h[b+4480>>3];i=i;return}function Dq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4432>>3]=+h[b+4456>>3]- +h[b+5824>>3];i=i;return}function Eq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=+h[b+4432>>3]- +h[b+6072>>3];i=i;return}function Fq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=+h[b+4408>>3]- +h[b+6320>>3];i=i;return}function Gq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=+h[b+6568>>3]- +h[b+4384>>3];i=i;return}function Hq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+26168>>3]*.4999999999999999+ +h[b+4496>>3]*.8660254037844387;i=i;return}function Iq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+4600>>3]- +h[b+4488>>3];i=i;return}function Jq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4440>>3]=+h[b+4464>>3]- +h[b+5832>>3];i=i;return}function Kq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4416>>3]=+h[b+4440>>3]- +h[b+6080>>3];i=i;return}function Lq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4392>>3]=+h[b+4416>>3]- +h[b+6328>>3];i=i;return}function Mq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+6576>>3]- +h[b+4392>>3];i=i;return}function Nq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=-(+h[(c[a+416>>2]|0)+27128>>3]*+h[b+4544>>3]);i=i;return}function Oq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+24936>>3]*+h[b+1e3>>3]+ +h[b+24960>>3]*+h[b+992>>3];i=i;return}function Pq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[(c[a+416>>2]|0)+26744>>3]*+h[b+4496>>3]+ +h[b+1088>>3];i=i;return}function Qq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=+h[b+1040>>3]- +h[(c[a+416>>2]|0)+25968>>3]*+h[b+4496>>3];i=i;return}function Rq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+24944>>3]*+h[b+1e3>>3]+ +h[b+24968>>3]*+h[b+992>>3];i=i;return}function Sq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1168>>3]=+h[(c[a+416>>2]|0)+26744>>3]*+h[b+26168>>3]+ +h[b+1080>>3];i=i;return}function Tq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+1168>>3]- +h[(c[a+416>>2]|0)+25968>>3]*+h[b+26168>>3];i=i;return}function Uq(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+4488>>3];l=+h[a+4480>>3];m=+h[a+1056>>3]+(+h[f+30992>>3]*j- +h[f+31e3>>3]*l);n=+h[f+30984>>3];o=+h[a+1064>>3];p=+h[a+1072>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560|0);i=b;return}function Vq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=-+h[b+960>>3]- +h[b+576>>3];i=i;return}function Wq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=-+h[b+1760>>3]- +h[(c[a+416>>2]|0)+21232>>3]*+h[b+4456>>3];i=i;return}function Xq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=-+h[b+1584>>3]- +h[b+1200>>3];i=i;return}function Yq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=-+h[b+2384>>3]- +h[(c[a+416>>2]|0)+14824>>3]*+h[b+4432>>3];i=i;return}function Zq(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=-+h[b+2208>>3]- +h[b+1824>>3];i=i;return}function _q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2816>>3]=-+h[b+2992>>3]- +h[(c[a+416>>2]|0)+8416>>3]*+h[b+4408>>3];i=i;return}function $q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3560>>3]=-+h[b+2816>>3]- +h[b+2448>>3];i=i;return}function ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3392>>3]=-+h[b+3560>>3]- +h[(c[a+416>>2]|0)+2008>>3]*+h[b+4384>>3];i=i;return}function br(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3584>>3]=+h[b+3392>>3]+ +h[b+3056>>3];i=i;return}function cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=-+h[b+952>>3]- +h[b+568>>3];i=i;return}function dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[(c[a+416>>2]|0)+21232>>3]*+h[b+4464>>3]- +h[b+1752>>3];i=i;return}function er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=-+h[b+1576>>3]- +h[b+1192>>3];i=i;return}function fr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=+h[(c[a+416>>2]|0)+14824>>3]*+h[b+4440>>3]- +h[b+2376>>3];i=i;return}function gr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2984>>3]=-+h[b+2200>>3]- +h[b+1816>>3];i=i;return}function hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=+h[(c[a+416>>2]|0)+8416>>3]*+h[b+4416>>3]- +h[b+2984>>3];i=i;return}function ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3552>>3]=-+h[b+2808>>3]- +h[b+2440>>3];i=i;return}function jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3384>>3]=+h[(c[a+416>>2]|0)+2008>>3]*+h[b+4392>>3]- +h[b+3552>>3];i=i;return}function kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[b+3384>>3]+ +h[b+3048>>3];i=i;return}function lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1744>>3]=-+h[b+944>>3]- +h[b+560>>3];i=i;return}function mr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1568>>3]=+h[b+21248>>3]*+h[d+4456>>3]+(-(+h[b+21240>>3]*+h[d+4464>>3])- +h[d+1744>>3]);i=i;return}function nr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2368>>3]=-+h[b+1568>>3]- +h[b+1184>>3];i=i;return}function or(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2192>>3]=+h[b+14840>>3]*+h[d+4432>>3]+(-(+h[b+14832>>3]*+h[d+4440>>3])- +h[d+2368>>3]);i=i;return}function pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2976>>3]=-+h[b+2192>>3]- +h[b+1808>>3];i=i;return}function qr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2800>>3]=+h[b+8432>>3]*+h[d+4408>>3]+(-(+h[b+8424>>3]*+h[d+4416>>3])- +h[d+2976>>3]);i=i;return}function rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3544>>3]=-+h[b+2800>>3]- +h[b+2432>>3];i=i;return}function sr(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3376>>3]=+h[b+2024>>3]*+h[d+4384>>3]+(-(+h[b+2016>>3]*+h[d+4392>>3])- +h[d+3544>>3]);i=i;return}function tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3568>>3]=+h[b+3376>>3]+ +h[b+3040>>3];i=i;return}function ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3632>>3]=+h[b+26648>>3]- +h[b+3568>>3];i=i;return}function vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=-(+h[(c[a+416>>2]|0)+30888>>3]*+h[b+25632>>3]);i=i;return}function wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+880>>3]=-+h[b+816>>3]- +h[b+592>>3];i=i;return}function xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+680>>3]=+h[b+880>>3]- +h[(c[a+416>>2]|0)+28824>>3]*+h[b+5400>>3];i=i;return}function yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+616>>3]=+h[(c[a+416>>2]|0)+30792>>3]*+h[b+5376>>3]- +h[b+680>>3];i=i;return}function zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+704>>3]=+h[b+640>>3]+ +h[b+616>>3];i=i;return}function Ar(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[(c[a+416>>2]|0)+30888>>3]*+h[b+25624>>3];i=i;return}function Br(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+888>>3]=-+h[b+824>>3]- +h[b+600>>3];i=i;return}function Cr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+688>>3]=+h[b+888>>3]+ +h[(c[a+416>>2]|0)+28824>>3]*+h[b+5392>>3];i=i;return}function Dr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+624>>3]=-+h[b+688>>3]- +h[(c[a+416>>2]|0)+30792>>3]*+h[b+5368>>3];i=i;return}function Er(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+712>>3]=+h[b+648>>3]+ +h[b+624>>3];i=i;return}function Fr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1112>>3]=+h[b+712>>3]*6.123233995736766e-17+(+h[b+704>>3]+ +h[(c[a+416>>2]|0)+31368>>3]*+h[b+5320>>3]);i=i;return}function Gr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1104>>3]=+h[b+704>>3]*6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+31368>>3]*+h[b+5328>>3])- +h[b+712>>3]);i=i;return}function Hr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1552>>3]=+h[b+1104>>3]*.8660254037844386+(+h[b+1112>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+25344>>3]*+h[b+5304>>3]);i=i;return}function Ir(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1416>>3]=+h[b+1552>>3]- +h[(c[a+416>>2]|0)+21616>>3]*+h[b+5304>>3];i=i;return}function Jr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1352>>3]=+h[(c[a+416>>2]|0)+23608>>3]*+h[b+5280>>3]- +h[b+1416>>3];i=i;return}function Kr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1440>>3]=+h[b+1376>>3]+ +h[b+1352>>3];i=i;return}function Lr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1504>>3]=-+h[b+1440>>3]- +h[b+1216>>3];i=i;return}function Mr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1304>>3]=+h[b+1504>>3]- +h[(c[a+416>>2]|0)+22416>>3]*+h[b+5256>>3];i=i;return}function Nr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1240>>3]=+h[(c[a+416>>2]|0)+24384>>3]*+h[b+5232>>3]- +h[b+1304>>3];i=i;return}function Or(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1328>>3]=+h[b+1264>>3]+ +h[b+1240>>3];i=i;return}function Pr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1560>>3]=+h[b+1104>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+25344>>3]*+h[b+5296>>3]+ +h[b+1112>>3]*.8660254037844386);i=i;return}function Qr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1424>>3]=+h[b+1560>>3]+ +h[(c[a+416>>2]|0)+21616>>3]*+h[b+5296>>3];i=i;return}function Rr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1360>>3]=-+h[b+1424>>3]- +h[(c[a+416>>2]|0)+23608>>3]*+h[b+5272>>3];i=i;return}function Sr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1448>>3]=+h[b+1384>>3]+ +h[b+1360>>3];i=i;return}function Tr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1512>>3]=-+h[b+1448>>3]- +h[b+1224>>3];i=i;return}function Ur(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1312>>3]=+h[b+1512>>3]+ +h[(c[a+416>>2]|0)+22416>>3]*+h[b+5248>>3];i=i;return}function Vr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1248>>3]=-+h[b+1312>>3]- +h[(c[a+416>>2]|0)+24384>>3]*+h[b+5224>>3];i=i;return}function Wr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1336>>3]=+h[b+1272>>3]+ +h[b+1248>>3];i=i;return}function Xr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1736>>3]=+h[b+1328>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+24960>>3]*+h[b+5176>>3]+ +h[b+1336>>3]*-.8660254037844386);i=i;return}function Yr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1728>>3]=+h[b+1328>>3]*-.8660254037844386+(+h[b+1336>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+24960>>3]*+h[b+5184>>3]);i=i;return}function Zr(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2176>>3]=+h[b+1728>>3]*.8660254037844386+(+h[b+1736>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+18936>>3]*+h[b+5160>>3]);i=i;return}function _r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2040>>3]=+h[b+2176>>3]- +h[(c[a+416>>2]|0)+15208>>3]*+h[b+5160>>3];i=i;return}function $r(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1976>>3]=+h[(c[a+416>>2]|0)+17200>>3]*+h[b+5136>>3]- +h[b+2040>>3];i=i;return}function as(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2064>>3]=+h[b+2e3>>3]+ +h[b+1976>>3];i=i;return}function bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2128>>3]=-+h[b+2064>>3]- +h[b+1840>>3];i=i;return}function cs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1928>>3]=+h[b+2128>>3]- +h[(c[a+416>>2]|0)+16008>>3]*+h[b+5112>>3];i=i;return}function ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1864>>3]=+h[(c[a+416>>2]|0)+17976>>3]*+h[b+5088>>3]- +h[b+1928>>3];i=i;return}function es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1952>>3]=+h[b+1888>>3]+ +h[b+1864>>3];i=i;return}function fs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2184>>3]=+h[b+1728>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+18936>>3]*+h[b+5152>>3]+ +h[b+1736>>3]*.8660254037844386);i=i;return}function gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2048>>3]=+h[b+2184>>3]+ +h[(c[a+416>>2]|0)+15208>>3]*+h[b+5152>>3];i=i;return}function hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1984>>3]=-+h[b+2048>>3]- +h[(c[a+416>>2]|0)+17200>>3]*+h[b+5128>>3];i=i;return}function is(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2072>>3]=+h[b+2008>>3]+ +h[b+1984>>3];i=i;return}function js(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2136>>3]=-+h[b+2072>>3]- +h[b+1848>>3];i=i;return}function ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1936>>3]=+h[b+2136>>3]+ +h[(c[a+416>>2]|0)+16008>>3]*+h[b+5104>>3];i=i;return}function ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1872>>3]=-+h[b+1936>>3]- +h[(c[a+416>>2]|0)+17976>>3]*+h[b+5080>>3];i=i;return}function ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1960>>3]=+h[b+1896>>3]+ +h[b+1872>>3];i=i;return}function ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2360>>3]=+h[b+1952>>3]*-.5000000000000001+(+h[(c[a+416>>2]|0)+18552>>3]*+h[b+5032>>3]+ +h[b+1960>>3]*-.8660254037844386);i=i;return}function os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2352>>3]=+h[b+1952>>3]*-.8660254037844386+(+h[b+1960>>3]*.5000000000000001- +h[(c[a+416>>2]|0)+18552>>3]*+h[b+5040>>3]);i=i;return}function ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2792>>3]=+h[b+2360>>3]*-6.123233995736766e-17+(+h[b+2352>>3]+ +h[(c[a+416>>2]|0)+12528>>3]*+h[b+5008>>3]);i=i;return}function qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2656>>3]=+h[b+2792>>3]+ +h[(c[a+416>>2]|0)+8800>>3]*+h[b+5008>>3];i=i;return}function rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2592>>3]=-+h[b+2656>>3]- +h[(c[a+416>>2]|0)+10792>>3]*+h[b+4984>>3];i=i;return}function ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2680>>3]=+h[b+2616>>3]+ +h[b+2592>>3];i=i;return}function ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2744>>3]=-+h[b+2680>>3]- +h[b+2472>>3];i=i;return}function us(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2544>>3]=+h[b+2744>>3]+ +h[(c[a+416>>2]|0)+9600>>3]*+h[b+4960>>3];i=i;return}function vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2496>>3]=-+h[b+2544>>3]- +h[(c[a+416>>2]|0)+11568>>3]*+h[b+4936>>3];i=i;return}function ws(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2568>>3]=+h[b+2520>>3]+ +h[b+2496>>3];i=i;return}function xs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2784>>3]=+h[b+2352>>3]*-6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+12528>>3]*+h[b+5016>>3])- +h[b+2360>>3]);i=i;return}function ys(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2648>>3]=+h[b+2784>>3]- +h[(c[a+416>>2]|0)+8800>>3]*+h[b+5016>>3];i=i;return}function zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2584>>3]=+h[(c[a+416>>2]|0)+10792>>3]*+h[b+4992>>3]- +h[b+2648>>3];i=i;return}function As(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2672>>3]=+h[b+2608>>3]+ +h[b+2584>>3];i=i;return}function Bs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2736>>3]=-+h[b+2672>>3]- +h[b+2464>>3];i=i;return}function Cs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2536>>3]=+h[b+2736>>3]- +h[(c[a+416>>2]|0)+9600>>3]*+h[b+4968>>3];i=i;return}function Ds(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2488>>3]=+h[(c[a+416>>2]|0)+11568>>3]*+h[b+4944>>3]- +h[b+2536>>3];i=i;return}function Es(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2560>>3]=+h[b+2512>>3]+ +h[b+2488>>3];i=i;return}function Fs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2960>>3]=+h[b+2560>>3]*6.123233995736766e-17+(-(+h[(c[a+416>>2]|0)+12144>>3]*+h[b+4896>>3])- +h[b+2568>>3]);i=i;return}function Gs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2968>>3]=+h[b+2568>>3]*6.123233995736766e-17+(+h[b+2560>>3]+ +h[(c[a+416>>2]|0)+12144>>3]*+h[b+4888>>3]);i=i;return}function Hs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3368>>3]=+h[b+2960>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+6120>>3]*+h[b+4864>>3]+ +h[b+2968>>3]*-.8660254037844387);i=i;return}function Is(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3264>>3]=+h[b+3368>>3]+ +h[(c[a+416>>2]|0)+2392>>3]*+h[b+4864>>3];i=i;return}function Js(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3216>>3]=-+h[b+3264>>3]- +h[(c[a+416>>2]|0)+4384>>3]*+h[b+4840>>3];i=i;return}function Ks(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3288>>3]=+h[b+3240>>3]+ +h[b+3216>>3];i=i;return}function Ls(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3336>>3]=-+h[b+3288>>3]- +h[b+3080>>3];i=i;return}function Ms(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3168>>3]=+h[b+3336>>3]+ +h[(c[a+416>>2]|0)+3192>>3]*+h[b+4816>>3];i=i;return}function Ns(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3104>>3]=-+h[b+3168>>3]- +h[(c[a+416>>2]|0)+5160>>3]*+h[b+4792>>3];i=i;return}function Os(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3192>>3]=+h[b+3128>>3]+ +h[b+3104>>3];i=i;return}function Ps(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3360>>3]=+h[b+2960>>3]*-.8660254037844387+(+h[b+2968>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+6120>>3]*+h[b+4872>>3]);i=i;return}function Qs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3256>>3]=+h[b+3360>>3]- +h[(c[a+416>>2]|0)+2392>>3]*+h[b+4872>>3];i=i;return}function Rs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3208>>3]=+h[(c[a+416>>2]|0)+4384>>3]*+h[b+4848>>3]- +h[b+3256>>3];i=i;return}function Ss(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3280>>3]=+h[b+3232>>3]+ +h[b+3208>>3];i=i;return}function Ts(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3328>>3]=-+h[b+3280>>3]- +h[b+3072>>3];i=i;return}function Us(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3160>>3]=+h[b+3328>>3]- +h[(c[a+416>>2]|0)+3192>>3]*+h[b+4824>>3];i=i;return}function Vs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4728>>3]=+h[b+23896>>3]*+h[b+4744>>3]+ +h[b+23880>>3]*+h[b+4752>>3];i=i;return}function Ws(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4344>>3]=-+h[b+4728>>3]- +h[b+4368>>3];i=i;return}function Xs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3096>>3]=+h[(c[a+416>>2]|0)+5160>>3]*+h[b+4800>>3]- +h[b+3160>>3];i=i;return}function Ys(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3120>>3]=+h[b+7456>>3]*-.05;i=i;return}function Zs(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3184>>3]=+h[b+3120>>3]+ +h[b+3096>>3];i=i;return}function _s(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3528>>3]=+h[b+3184>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+5736>>3]*+h[b+4744>>3]+ +h[b+3192>>3]*.8660254037844387);i=i;return}function $s(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3536>>3]=+h[b+3184>>3]*.8660254037844387+(+h[b+3192>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+5736>>3]*+h[b+4752>>3]);i=i;return}function at(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3656>>3]=+h[b+23896>>3]*+h[b+3536>>3]+ +h[b+23880>>3]*+h[b+3528>>3];i=i;return}function bt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3648>>3]=-+h[b+3656>>3]- +h[b+3584>>3];i=i;return}function ct(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4720>>3]=+h[b+23904>>3]*+h[b+4744>>3]+ +h[b+23888>>3]*+h[b+4752>>3];i=i;return}function dt(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4336>>3]=-+h[b+4720>>3]- +h[b+4360>>3];i=i;return}function et(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3664>>3]=+h[b+23904>>3]*+h[b+3536>>3]+ +h[b+23888>>3]*+h[b+3528>>3];i=i;return}function ft(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3640>>3]=-+h[b+3664>>3]- +h[b+3576>>3];i=i;return}function gt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((TEc(+U(+(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24144>>3])),1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2256;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,1600,e);i=b;return}function ht(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+38984>>3],+h[f+39016>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function it(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+39168>>3],+h[f+39200>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+39192>>3],+h[f+39216>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+39384>>3],+h[f+39416>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function lt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+39408>>3],+h[f+39432>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+39560>>3],+h[f+39592>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+39584>>3],+h[f+39608>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function ot(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+39736>>3],+h[f+39768>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function pt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+39920>>3],+h[f+39952>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function qt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((TEc(+U(+(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24352>>3])),1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2256;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,1600,e);i=b;return}function rt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+40464>>3],+h[f+40496>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function st(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+40648>>3],+h[f+40680>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function tt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+40672>>3],+h[f+40696>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function ut(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+40864>>3],+h[f+40896>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function vt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+40888>>3],+h[f+40912>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function wt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+41040>>3],+h[f+41072>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+41064>>3],+h[f+41088>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function yt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+41216>>3],+h[f+41248>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+41400>>3],+h[f+41432>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function At(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((TEc(+U(+(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24560>>3])),1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2256;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,1600,e);i=b;return}function Bt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+41944>>3],+h[f+41976>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Ct(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+42128>>3],+h[f+42160>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Dt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+42152>>3],+h[f+42176>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function Et(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+42344>>3],+h[f+42376>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Ft(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+42368>>3],+h[f+42392>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function Gt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+42520>>3],+h[f+42552>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Ht(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+42544>>3],+h[f+42568>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function It(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+42696>>3],+h[f+42728>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Jt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+42880>>3],+h[f+42912>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Kt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((TEc(+U(+(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24768>>3])),1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2256;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,1600,e);i=b;return}function Lt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+43424>>3],+h[f+43456>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Mt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+43608>>3],+h[f+43640>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Nt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+43632>>3],+h[f+43656>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function Ot(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+43824>>3],+h[f+43856>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}



function WKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Xb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Zc=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+8|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;V=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+8|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+16|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+200|0;ra=i;i=i+16|0;sa=i;i=i+16|0;ta=i;i=i+8|0;ua=i;i=i+16|0;va=i;i=i+8|0;wa=i;i=i+8|0;xa=i;i=i+8|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=i;i=i+1024|0;Ba=i;i=i+8|0;Ca=i;i=i+16|0;Da=i;i=i+8|0;Ea=i;i=i+16|0;Fa=i;i=i+16|0;Ga=i;i=i+16|0;Ha=i;i=i+16|0;Ia=i;i=i+16|0;Ja=i;i=i+16|0;Ka=i;i=i+16|0;La=i;i=i+16|0;Ma=i;i=i+16|0;Na=i;i=i+16|0;Oa=i;i=i+16|0;Pa=i;i=i+16|0;Qa=i;i=i+16|0;Ra=i;i=i+16|0;Sa=i;i=i+16|0;Ta=i;i=i+16|0;Ua=i;i=i+16|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+8|0;Ya=i;i=i+8|0;Za=i;i=i+8|0;_a=i;i=i+8|0;$a=i;i=i+8|0;ab=i;i=i+8|0;bb=i;i=i+8|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+16|0;fb=i;i=i+16|0;gb=i;i=i+16|0;hb=i;i=i+16|0;ib=i;i=i+16|0;jb=i;i=i+16|0;kb=i;i=i+16|0;lb=i;i=i+16|0;mb=i;i=i+16|0;nb=i;i=i+16|0;ob=i;i=i+16|0;pb=i;i=i+16|0;qb=i;i=i+16|0;rb=i;i=i+16|0;tb=i;i=i+16|0;ub=i;i=i+16|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+16|0;zb=i;i=i+8|0;Ab=i;i=i+16|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+16|0;Fb=i;i=i+8|0;Gb=i;i=i+16|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+16|0;Lb=i;i=i+8|0;Mb=i;i=i+16|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+16|0;Rb=i;i=i+8|0;Sb=i;i=i+16|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+16|0;Xb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+16|0;_b=i;i=i+8|0;$b=i;i=i+16|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;dc=i;i=i+16|0;ec=i;i=i+8|0;fc=i;i=i+16|0;gc=i;i=i+8|0;hc=i;i=i+8|0;jc=i;i=i+16|0;kc=i;i=i+16|0;lc=i;i=i+8|0;mc=i;i=i+16|0;nc=i;i=i+16|0;oc=i;i=i+8|0;pc=i;i=i+16|0;qc=i;i=i+16|0;rc=i;i=i+8|0;sc=i;i=i+16|0;tc=i;i=i+8|0;uc=i;i=i+8|0;vc=i;i=i+16|0;wc=i;i=i+16|0;xc=i;i=i+8|0;yc=i;i=i+16|0;zc=i;i=i+16|0;Ac=i;i=i+8|0;Bc=i;i=i+16|0;Cc=i;i=i+16|0;Dc=i;i=i+8|0;Ec=i;i=i+16|0;Fc=i;i=i+8|0;Gc=i;i=i+8|0;Hc=i;i=i+16|0;Ic=i;i=i+16|0;Jc=i;i=i+8|0;Kc=i;i=i+16|0;Lc=i;i=i+16|0;Mc=i;i=i+8|0;Nc=i;i=i+16|0;Oc=i;i=i+16|0;Pc=i;i=i+8|0;Qc=i;i=i+16|0;Rc=i;i=i+8|0;Sc=i;i=i+8|0;Tc=i;i=i+16|0;Uc=i;i=i+16|0;Vc=qa;XKc(qa);SVc(ra);YKc(sa,ta);YKc(ua,va);va=b+92|0;do{if((c[va>>2]|0)==0){if((c[349136>>2]|0)==0){YVc(za,c[b+80>>2]|0);ZKc(ya,za,336176);dWc(ra,ya)|0;cWc(ya);cWc(za)}else{eWc(ra,c[349264>>2]|0)|0}ta=ic(zWc(ra)|0,336192)|0;if((ta|0)!=0){Wc=ta;break}c[pa>>2]=zWc(ra)|0;IBc(0,336200,pa)}else{Wc=0}}while(0);pa=xwc(0)|0;if((pa|0)==0){Yc(Wc|0)|0;IBc(0,336304,oa)}Iwc(pa,Vc);Jwc(pa,8,132);Vc=c[va>>2]|0;do{if((Vc|0)==0){oa=Aa;P4c(oa|0,0,1024)|0;while(1){za=sb(oa|0,1,1024,Wc|0)|0;ya=za>>>0<1024;if((Kwc(pa,oa,za,ya&1)|0)==0){Xc=12;break}if(ya){Xc=14;break}}if((Xc|0)==12){Yc(Wc|0)|0;oa=zWc(ra)|0;ya=Swc(Pwc(pa)|0)|0;za=Qwc(pa)|0;c[na>>2]=oa;c[na+4>>2]=ya;c[na+8>>2]=za;GBc(1,0,336384,na);Ewc(pa);IBc(0,336472,ma)}else if((Xc|0)==14){Yc(Wc|0)|0;break}}else{if((Kwc(pa,Vc,L4c(Vc|0)|0,1)|0)!=0){break}za=c[r>>2]|0;ya=c[va>>2]|0;oa=Swc(Pwc(pa)|0)|0;ta=Qwc(pa)|0;c[la>>2]=ya;c[la+4>>2]=oa;c[la+8>>2]=ta;wd(za|0,336496,la|0)|0;za=c[va>>2]|0;ta=Swc(Pwc(pa)|0)|0;oa=Qwc(pa)|0;c[ka>>2]=za;c[ka+4>>2]=ta;c[ka+8>>2]=oa;GBc(1,0,336512,ka);Ewc(pa);IBc(0,336472,ja)}}while(0);ja=qa;YVc(Ca,336600);bLc(Ba,ja,Ca);cLc(Da,ja);ka=aLc(Ba,Da)|0;cWc(Ca);Ca=b+88|0;Da=c[Ca>>2]|0;do{if(ka){Ba=zWc(ra)|0;c[ia>>2]=Da;c[ia+4>>2]=Ba;GBc(1,0,336608,ia)}else{YVc(Ea,336600);Ba=H4c(Da,zWc(NKc(ja,Ea)|0)|0)|0;cWc(Ea);if((Ba|0)==0){break}Ewc(pa);YVc(Fa,336600);Ba=zWc(NKc(ja,Fa)|0)|0;va=zWc(ra)|0;la=c[Ca>>2]|0;c[ha>>2]=Ba;c[ha+4>>2]=va;c[ha+8>>2]=la;GBc(1,0,336656,ha);cWc(Fa);IBc(0,336472,ga)}}while(0);dLc(qa,b,c[349348>>2]|0,c[349352>>2]|0);EBc(23,1,336752,fa);fa=qa+12|0;YVc(Ha,336792);UVc(Ga,NKc(fa,Ha)|0);ga=d;SKc(Ga,ga,0.0);cWc(Ga);cWc(Ha);Ha=ea;h[k>>3]=+h[ga>>3];c[Ha>>2]=c[k>>2];c[Ha+4>>2]=c[k+4>>2];EBc(23,0,336808,ea);YVc(Ja,336824);UVc(Ia,NKc(fa,Ja)|0);ea=d+8|0;SKc(Ia,ea,1.0);cWc(Ia);cWc(Ja);Ja=da;h[k>>3]=+h[ea>>3];c[Ja>>2]=c[k>>2];c[Ja+4>>2]=c[k+4>>2];EBc(23,0,336840,da);YVc(La,336856);UVc(Ka,NKc(fa,La)|0);da=d+24|0;SKc(Ka,da,(+h[ea>>3]- +h[ga>>3])/500.0);cWc(Ka);cWc(La);La=ca;h[k>>3]=+h[da>>3];c[La>>2]=c[k>>2];c[La+4>>2]=c[k+4>>2];EBc(23,0,336872,ca);YVc(Na,336888);UVc(Ma,NKc(fa,Na)|0);ca=d+32|0;SKc(Ma,ca,1.0e-5);cWc(Ma);cWc(Na);Na=ba;h[k>>3]=+h[ca>>3];c[Na>>2]=c[k>>2];c[Na+4>>2]=c[k+4>>2];EBc(23,0,336904,ba);YVc(Pa,336920);UVc(Oa,NKc(fa,Pa)|0);ba=d+40|0;MKc(Oa,ba);cWc(Oa);cWc(Pa);c[aa>>2]=c[ba>>2];EBc(23,0,336928,aa);YVc(Ra,336952);UVc(Qa,NKc(fa,Ra)|0);aa=d+44|0;MKc(Qa,aa);cWc(Qa);cWc(Ra);c[$>>2]=c[aa>>2];EBc(23,0,336968,$);YVc(Ta,336992);UVc(Sa,NKc(fa,Ta)|0);fa=d+48|0;MKc(Sa,fa);cWc(Sa);cWc(Ta);c[_>>2]=c[fa>>2];EBc(23,0,337008,_);YVc(Va,337032);UVc(Ua,NKc(ja,Va)|0);_=d+268|0;MKc(Ua,_);cWc(Ua);cWc(Va);c[Z>>2]=c[_>>2];EBc(23,0,337056,Z);if((c[292396>>2]|0)!=0){fe[c[73214]&1023](23)}YVc(eb,337080);UVc(db,NKc(ja,eb)|0);PKc(db,Wa,0);cWc(db);cWc(eb);YVc(gb,337112);UVc(fb,NKc(ja,gb)|0);PKc(fb,Xa,0);cWc(fb);cWc(gb);YVc(ib,337144);UVc(hb,NKc(ja,ib)|0);PKc(hb,Ya,0);cWc(hb);cWc(ib);YVc(kb,337168);UVc(jb,NKc(ja,kb)|0);PKc(jb,_a,0);cWc(jb);cWc(kb);YVc(mb,337200);UVc(lb,NKc(ja,mb)|0);PKc(lb,Za,0);cWc(lb);cWc(mb);YVc(ob,337240);UVc(nb,NKc(ja,ob)|0);PKc(nb,ab,0);cWc(nb);cWc(ob);YVc(qb,337272);UVc(pb,NKc(ja,qb)|0);PKc(pb,$a,0);cWc(pb);cWc(qb);YVc(tb,337312);UVc(rb,NKc(ja,tb)|0);PKc(rb,cb,0);cWc(rb);cWc(tb);YVc(vb,337344);UVc(ub,NKc(ja,vb)|0);PKc(ub,bb,0);cWc(ub);cWc(vb);vb=c[Wa>>2]|0;Wa=b+104|0;do{if((vb|0)==(c[Wa>>2]|0)){ub=b+108|0;if((c[Xa>>2]|0)!=((c[ub>>2]|0)-(vb<<1)|0)){break}ja=b+128|0;if((c[Ya>>2]|0)!=(c[ja>>2]|0)){break}tb=b+132|0;if((c[_a>>2]|0)!=(c[tb>>2]|0)){break}rb=b+116|0;if((c[Za>>2]|0)!=(c[rb>>2]|0)){break}qb=b+136|0;if((c[ab>>2]|0)!=(c[qb>>2]|0)){break}pb=b+120|0;if((c[$a>>2]|0)!=(c[pb>>2]|0)){break}ob=b+140|0;if((c[cb>>2]|0)!=(c[ob>>2]|0)){break}nb=b+124|0;if((c[bb>>2]|0)!=(c[nb>>2]|0)){break}c[O>>2]=337888;EBc(4,1,337864,O);if((c[Wa>>2]|0)>0){mb=b;lb=qa+24|0;kb=0;do{jb=c[mb>>2]|0;c[wb>>2]=kb;ib=eLc(lb,wb)|0;LKc(ib,jb+(kb*112|0)|0);QKc(ib,jb+(kb*112|0)+40|0);hb=jb+(kb*112|0)+4|0;do{if((a[c[hb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(xb,337904);jb=(CWc(NKc(ib,xb)|0,336040)|0)==0;cWc(xb);if(!jb){break}c[N>>2]=c[hb>>2];EBc(4,0,337920,N);a[(c[mb>>2]|0)+(kb*112|0)+104|0]=1}}while(0);YVc(yb,c[hb>>2]|0);c[(fLc(sa,yb)|0)>>2]=kb;cWc(yb);kb=kb+1|0;}while((kb|0)<(c[Wa>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[M>>2]=337952;EBc(4,1,337864,M);kb=c[Wa>>2]|0;if((kb|0)>0){mb=b;lb=qa+36|0;ib=kb;kb=0;do{jb=ib+kb|0;gb=c[mb>>2]|0;c[zb>>2]=kb;fb=eLc(lb,zb)|0;LKc(fb,gb+(jb*112|0)|0);QKc(fb,gb+(jb*112|0)+40|0);eb=gb+(jb*112|0)+4|0;do{if((a[c[eb>>2]|0]|0)==36){a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Ab,337904);gb=(CWc(NKc(fb,Ab)|0,336040)|0)==0;cWc(Ab);if(!gb){break}c[L>>2]=c[eb>>2];EBc(4,0,337920,L);a[(c[mb>>2]|0)+(jb*112|0)+104|0]=1}}while(0);YVc(Bb,c[eb>>2]|0);c[(fLc(sa,Bb)|0)>>2]=jb;cWc(Bb);kb=kb+1|0;ib=c[Wa>>2]|0;}while((kb|0)<(ib|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[K>>2]=337976;EBc(4,1,337864,K);ib=c[Wa>>2]<<1;if(((c[ub>>2]|0)-ib|0)>0){kb=b;mb=qa+48|0;lb=ib;ib=0;do{fb=lb+ib|0;hb=c[kb>>2]|0;c[Cb>>2]=ib;gb=eLc(mb,Cb)|0;LKc(gb,hb+(fb*112|0)|0);QKc(gb,hb+(fb*112|0)+40|0);db=hb+(fb*112|0)+4|0;do{if((a[c[db>>2]|0]|0)==36){a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Db,337904);hb=(CWc(NKc(gb,Db)|0,336040)|0)==0;cWc(Db);if(!hb){break}c[J>>2]=c[db>>2];EBc(4,0,337920,J);a[(c[kb>>2]|0)+(fb*112|0)+104|0]=1}}while(0);YVc(Eb,c[db>>2]|0);c[(fLc(sa,Eb)|0)>>2]=fb;cWc(Eb);ib=ib+1|0;lb=c[Wa>>2]<<1;}while((ib|0)<((c[ub>>2]|0)-lb|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[I>>2]=337992;EBc(4,1,337864,I);if((c[rb>>2]|0)>0){lb=b+4|0;ub=qa+84|0;ib=0;do{kb=c[lb>>2]|0;c[Fb>>2]=ib;mb=eLc(ub,Fb)|0;LKc(mb,kb+(ib*60|0)|0);TKc(mb,kb+(ib*60|0)+36|0);gb=kb+(ib*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Gb,337904);kb=(CWc(NKc(mb,Gb)|0,336040)|0)==0;cWc(Gb);if(!kb){break}c[H>>2]=c[gb>>2];EBc(4,0,337920,H);a[(c[lb>>2]|0)+(ib*60|0)+56|0]=1}}while(0);YVc(Hb,c[gb>>2]|0);c[(fLc(sa,Hb)|0)>>2]=ib;cWc(Hb);ib=ib+1|0;}while((ib|0)<(c[rb>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[G>>2]=338016;EBc(4,1,337864,G);if((c[pb>>2]|0)>0){rb=b+8|0;ib=qa+120|0;lb=0;do{ub=c[rb>>2]|0;c[Ib>>2]=lb;mb=eLc(ib,Ib)|0;LKc(mb,ub+(lb*48|0)|0);UKc(mb,ub+(lb*48|0)+36|0);fb=ub+(lb*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Jb,337904);ub=(CWc(NKc(mb,Jb)|0,336040)|0)==0;cWc(Jb);if(!ub){break}c[F>>2]=c[fb>>2];EBc(4,0,337920,F);a[(c[rb>>2]|0)+(lb*48|0)+44|0]=1}}while(0);YVc(Kb,c[fb>>2]|0);c[(fLc(sa,Kb)|0)>>2]=lb;cWc(Kb);lb=lb+1|0;}while((lb|0)<(c[pb>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[E>>2]=338040;EBc(4,1,337864,E);if((c[nb>>2]|0)>0){pb=b+12|0;lb=qa+156|0;rb=0;do{ib=c[pb>>2]|0;c[Lb>>2]=rb;mb=eLc(lb,Lb)|0;LKc(mb,ib+(rb*52|0)|0);VKc(mb,ib+(rb*52|0)+36|0);gb=ib+(rb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Mb,337904);ib=(CWc(NKc(mb,Mb)|0,336040)|0)==0;cWc(Mb);if(!ib){break}c[D>>2]=c[gb>>2];EBc(4,0,337920,D);a[(c[pb>>2]|0)+(rb*52|0)+48|0]=1}}while(0);YVc(Nb,c[gb>>2]|0);c[(fLc(sa,Nb)|0)>>2]=rb;cWc(Nb);rb=rb+1|0;}while((rb|0)<(c[nb>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[C>>2]=338064;EBc(4,1,337864,C);if((c[ja>>2]|0)>0){nb=b+16|0;rb=qa+60|0;pb=0;do{lb=c[nb>>2]|0;c[Ob>>2]=pb;mb=eLc(rb,Ob)|0;LKc(mb,lb+(pb*112|0)|0);QKc(mb,lb+(pb*112|0)+40|0);fb=lb+(pb*112|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Pb,337904);lb=(CWc(NKc(mb,Pb)|0,336040)|0)==0;cWc(Pb);if(!lb){break}c[B>>2]=c[fb>>2];EBc(4,0,337920,B);a[(c[nb>>2]|0)+(pb*112|0)+104|0]=1}}while(0);YVc(Qb,c[fb>>2]|0);c[(fLc(ua,Qb)|0)>>2]=pb;cWc(Qb);pb=pb+1|0;}while((pb|0)<(c[ja>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[A>>2]=338080;EBc(4,1,337864,A);if((c[tb>>2]|0)>0){ja=b+20|0;pb=qa+96|0;nb=0;do{rb=c[ja>>2]|0;c[Rb>>2]=nb;mb=eLc(pb,Rb)|0;LKc(mb,rb+(nb*60|0)|0);TKc(mb,rb+(nb*60|0)+36|0);gb=rb+(nb*60|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Sb,337904);rb=(CWc(NKc(mb,Sb)|0,336040)|0)==0;cWc(Sb);if(!rb){break}c[z>>2]=c[gb>>2];EBc(4,0,337920,z);a[(c[ja>>2]|0)+(nb*60|0)+56|0]=1}}while(0);YVc(Tb,c[gb>>2]|0);c[(fLc(ua,Tb)|0)>>2]=nb;cWc(Tb);nb=nb+1|0;}while((nb|0)<(c[tb>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[y>>2]=338104;EBc(4,1,337864,y);if((c[qb>>2]|0)>0){tb=b+24|0;nb=qa+132|0;ja=0;do{pb=c[tb>>2]|0;c[Ub>>2]=ja;mb=eLc(nb,Ub)|0;LKc(mb,pb+(ja*48|0)|0);UKc(mb,pb+(ja*48|0)+36|0);fb=pb+(ja*48|0)+4|0;do{if((a[c[fb>>2]|0]|0)==36){a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Vb,337904);pb=(CWc(NKc(mb,Vb)|0,336040)|0)==0;cWc(Vb);if(!pb){break}c[x>>2]=c[fb>>2];EBc(4,0,337920,x);a[(c[tb>>2]|0)+(ja*48|0)+44|0]=1}}while(0);YVc(Wb,c[fb>>2]|0);c[(fLc(ua,Wb)|0)>>2]=ja;cWc(Wb);ja=ja+1|0;}while((ja|0)<(c[qb>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}c[w>>2]=338128;EBc(4,1,337864,w);if((c[ob>>2]|0)>0){qb=b+28|0;ja=qa+168|0;tb=0;do{nb=c[qb>>2]|0;c[Xb>>2]=tb;mb=eLc(ja,Xb)|0;LKc(mb,nb+(tb*52|0)|0);VKc(mb,nb+(tb*52|0)+36|0);gb=nb+(tb*52|0)+4|0;do{if((a[c[gb>>2]|0]|0)==36){a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}else{if((c[349132>>2]|0)!=0){break}YVc(Yb,337904);nb=(CWc(NKc(mb,Yb)|0,336040)|0)==0;cWc(Yb);if(!nb){break}c[v>>2]=c[gb>>2];EBc(4,0,337920,v);a[(c[qb>>2]|0)+(tb*52|0)+48|0]=1}}while(0);YVc(Zb,c[gb>>2]|0);c[(fLc(ua,Zb)|0)>>2]=tb;cWc(Zb);tb=tb+1|0;}while((tb|0)<(c[ob>>2]|0))}if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}EBc(4,1,338152,u);ob=b+208|0;a:do{if((c[ob>>2]|0)>0){tb=qa+72|0;qb=b+32|0;ja=0;b:while(1){c[_b>>2]=ja;mb=eLc(tb,_b)|0;LKc(mb,(c[qb>>2]|0)+(ja*52|0)+12|0);SVc($b);c[bc>>2]=ja;mb=eLc(tb,bc)|0;YVc(cc,338192);UVc(ac,NKc(mb,cc)|0);gLc(ac,$b);cWc(ac);cWc(cc);mb=(CWc($b,338200)|0)==0;fb=c[qb>>2]|0;nb=mb&1;c[fb+(ja*52|0)>>2]=nb;c[t>>2]=c[fb+(ja*52|0)+16>>2];c[t+4>>2]=nb;EBc(4,0,338216,t);nb=c[qb>>2]|0;if((a[c[nb+(ja*52|0)+16>>2]|0]|0)==36){a[nb+(ja*52|0)+48|0]=1}c[ec>>2]=ja;nb=eLc(tb,ec)|0;YVc(fc,338256);UVc(dc,NKc(nb,fc)|0);gLc(dc,$b);cWc(dc);cWc(fc);hLc(wa,sa,$b);hLc(xa,ua,$b);jLc(gc,sa);do{if(iLc(wa,gc)|0){nb=c[(kLc(wa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(ja*52|0)+4>>2]=nb;a[fb+(ja*52|0)+8|0]=0}else{jLc(hc,ua);if(iLc(xa,hc)|0){fb=c[(kLc(xa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=fb;a[nb+(ja*52|0)+8|0]=1;break}if((CWc($b,338272)|0)!=0){break b}a[(c[qb>>2]|0)+(ja*52|0)+8|0]=2}}while(0);cWc($b);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break a}}NWc(kc,338280,$b);ZKc(jc,kc,338304);cWc(kc);c[s>>2]=zWc(jc)|0;IBc(0,338320,s)}}while(0);if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}EBc(4,1,338328,q);ob=b+212|0;c:do{if((c[ob>>2]|0)>0){ja=qa+108|0;qb=b+36|0;tb=0;while(1){c[lc>>2]=tb;gb=eLc(ja,lc)|0;LKc(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);SVc(mc);c[oc>>2]=tb;gb=eLc(ja,oc)|0;YVc(pc,338192);UVc(nc,NKc(gb,pc)|0);gLc(nc,mc);cWc(nc);cWc(pc);gb=(CWc(mc,338200)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[p>>2]=c[nb+(tb*52|0)+16>>2];c[p+4>>2]=fb;EBc(4,0,338216,p);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[rc>>2]=tb;fb=eLc(ja,rc)|0;YVc(sc,338256);UVc(qc,NKc(fb,sc)|0);gLc(qc,mc);cWc(qc);cWc(sc);hLc(wa,sa,mc);hLc(xa,ua,mc);jLc(tc,sa);if(iLc(wa,tc)|0){fb=c[(kLc(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{jLc(uc,ua);if(!(iLc(xa,uc)|0)){break}nb=c[(kLc(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}cWc(mc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break c}}NWc(wc,338368,mc);ZKc(vc,wc,338304);cWc(wc);c[o>>2]=zWc(vc)|0;IBc(0,338320,o)}}while(0);if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}EBc(4,1,338392,n);ob=b+216|0;d:do{if((c[ob>>2]|0)>0){tb=qa+144|0;qb=b+40|0;ja=0;while(1){c[xc>>2]=ja;fb=eLc(tb,xc)|0;LKc(fb,(c[qb>>2]|0)+(ja*52|0)+12|0);SVc(yc);c[Ac>>2]=ja;fb=eLc(tb,Ac)|0;YVc(Bc,338192);UVc(zc,NKc(fb,Bc)|0);gLc(zc,yc);cWc(zc);cWc(Bc);fb=(CWc(yc,338200)|0)==0;nb=c[qb>>2]|0;gb=fb&1;c[nb+(ja*52|0)>>2]=gb;c[m>>2]=c[nb+(ja*52|0)+16>>2];c[m+4>>2]=gb;EBc(4,0,338216,m);gb=c[qb>>2]|0;if((a[c[gb+(ja*52|0)+16>>2]|0]|0)==36){a[gb+(ja*52|0)+48|0]=1}c[Dc>>2]=ja;gb=eLc(tb,Dc)|0;YVc(Ec,338256);UVc(Cc,NKc(gb,Ec)|0);gLc(Cc,yc);cWc(Cc);cWc(Ec);hLc(wa,sa,yc);hLc(xa,ua,yc);jLc(Fc,sa);if(iLc(wa,Fc)|0){gb=c[(kLc(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(ja*52|0)+4>>2]=gb;a[nb+(ja*52|0)+8|0]=0}else{jLc(Gc,ua);if(!(iLc(xa,Gc)|0)){break}nb=c[(kLc(xa)|0)+12>>2]|0;gb=c[qb>>2]|0;c[gb+(ja*52|0)+4>>2]=nb;a[gb+(ja*52|0)+8|0]=1}cWc(yc);ja=ja+1|0;if((ja|0)>=(c[ob>>2]|0)){break d}}NWc(Ic,338432,yc);ZKc(Hc,Ic,338304);cWc(Ic);c[l>>2]=zWc(Hc)|0;IBc(0,338320,l)}}while(0);if((c[292320>>2]|0)!=0){fe[c[73214]&1023](4)}EBc(4,1,338456,j);ob=b+220|0;e:do{if((c[ob>>2]|0)>0){ja=qa+180|0;qb=b+44|0;tb=0;while(1){c[Jc>>2]=tb;gb=eLc(ja,Jc)|0;LKc(gb,(c[qb>>2]|0)+(tb*52|0)+12|0);SVc(Kc);c[Mc>>2]=tb;gb=eLc(ja,Mc)|0;YVc(Nc,338192);UVc(Lc,NKc(gb,Nc)|0);gLc(Lc,Kc);cWc(Lc);cWc(Nc);gb=(CWc(Kc,338200)|0)==0;nb=c[qb>>2]|0;fb=gb&1;c[nb+(tb*52|0)>>2]=fb;c[g>>2]=c[nb+(tb*52|0)+16>>2];c[g+4>>2]=fb;EBc(4,0,338216,g);fb=c[qb>>2]|0;if((a[c[fb+(tb*52|0)+16>>2]|0]|0)==36){a[fb+(tb*52|0)+48|0]=1}c[Pc>>2]=tb;fb=eLc(ja,Pc)|0;YVc(Qc,338256);UVc(Oc,NKc(fb,Qc)|0);gLc(Oc,Kc);cWc(Oc);cWc(Qc);hLc(wa,sa,Kc);hLc(xa,ua,Kc);jLc(Rc,sa);if(iLc(wa,Rc)|0){fb=c[(kLc(wa)|0)+12>>2]|0;nb=c[qb>>2]|0;c[nb+(tb*52|0)+4>>2]=fb;a[nb+(tb*52|0)+8|0]=0}else{jLc(Sc,ua);if(!(iLc(xa,Sc)|0)){break}nb=c[(kLc(xa)|0)+12>>2]|0;fb=c[qb>>2]|0;c[fb+(tb*52|0)+4>>2]=nb;a[fb+(tb*52|0)+8|0]=1}cWc(Kc);tb=tb+1|0;if((tb|0)>=(c[ob>>2]|0)){break e}}NWc(Uc,338496,Kc);ZKc(Tc,Uc,338304);cWc(Uc);c[f>>2]=zWc(Tc)|0;IBc(0,338320,f)}}while(0);if((c[292320>>2]|0)==0){Ewc(pa);lLc(ua);lLc(sa);cWc(ra);mLc(qa);i=e;return}fe[c[73214]&1023](4);Ewc(pa);lLc(ua);lLc(sa);cWc(ra);mLc(qa);i=e;return}}while(0);if((c[292392>>2]|c[73074]|0)==0){Ewc(pa);Zc=ud(0)|0;Cd(-1)}GBc(22,1,337384,Y);Y=c[Wa>>2]|0;c[X>>2]=vb;c[X+4>>2]=Y;GBc(22,0,337432,X);X=(c[b+108>>2]|0)-(c[Wa>>2]<<1)|0;c[W>>2]=c[Xa>>2];c[W+4>>2]=X;GBc(22,0,337480,W);W=c[b+128>>2]|0;c[V>>2]=c[Ya>>2];c[V+4>>2]=W;GBc(22,0,337528,V);V=c[b+132>>2]|0;c[U>>2]=c[_a>>2];c[U+4>>2]=V;GBc(22,0,337576,U);U=c[b+116>>2]|0;c[T>>2]=c[Za>>2];c[T+4>>2]=U;GBc(22,0,337624,T);T=c[b+136>>2]|0;c[S>>2]=c[ab>>2];c[S+4>>2]=T;GBc(22,0,337672,S);S=c[b+120>>2]|0;c[R>>2]=c[$a>>2];c[R+4>>2]=S;GBc(22,0,337720,R);R=c[b+140>>2]|0;c[Q>>2]=c[cb>>2];c[Q+4>>2]=R;GBc(22,0,337768,Q);Q=c[b+124>>2]|0;c[P>>2]=c[bb>>2];c[P+4>>2]=Q;GBc(22,0,337816,P);fe[c[73214]&1023](22);Ewc(pa);Zc=ud(0)|0;Cd(-1)}function XKc(a){a=a|0;var b=0;b=i;XRc(a);i=b;return}function YKc(a,b){a=a|0;b=b|0;b=i;CNc(a,0);i=b;return}function ZKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;TVc(a,d);e=aWc(b)|0;f=MLc(c)|0;DWc(a,bWc(b)|0,e,f+e|0);vWc(a,c,f)|0;i=d;return}function _Kc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0;e=i;i=i+8|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+8|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;if((H4c(b,339128)|0)==0){t=c[d>>2]|0;if((t|0)==0){i=e;return}u=a;v=t;t=0;do{YVc(g,v);w=NKc(u,g)|0;eWc(w,c[d+((t|1)<<2)>>2]|0)|0;cWc(g);t=t+2|0;v=c[d+(t<<2)>>2]|0;}while((v|0)!=0);i=e;return}if((H4c(b,339152)|0)==0){v=c[d>>2]|0;if((v|0)==0){i=e;return}t=a+12|0;g=v;v=0;do{YVc(h,g);u=NKc(t,h)|0;eWc(u,c[d+((v|1)<<2)>>2]|0)|0;cWc(h);v=v+2|0;g=c[d+(v<<2)>>2]|0;}while((g|0)!=0);i=e;return}if((H4c(b,339176)|0)!=0){do{if((H4c(b,339432)|0)!=0){if((H4c(b,339440)|0)==0){break}if((H4c(b,339448)|0)==0){break}if((H4c(b,339456)|0)==0){break}i=e;return}}while(0);g=(c[d>>2]|0)==0;v=a+196|0;h=a+192|0;t=eLc(c[v>>2]|0,h)|0;if(g){x=t}else{g=t;t=d;u=0;while(1){YVc(r,c[t>>2]|0);w=NKc(g,r)|0;eWc(w,c[d+((u|1)<<2)>>2]|0)|0;cWc(r);w=u+2|0;y=d+(w<<2)|0;z=(c[y>>2]|0)==0;A=eLc(c[v>>2]|0,h)|0;if(z){x=A;break}else{u=w;t=y;g=A}}}YVc(s,339464);eWc(NKc(x,s)|0,b)|0;cWc(s);i=e;return}nLc(j,k);SVc(l);SVc(m);k=a+192|0;s=k;c[k>>2]=-1;b=a+196|0;c[b>>2]=0;x=c[d>>2]|0;if((x|0)!=0){g=x;x=0;do{YVc(n,g);t=NKc(j,n)|0;eWc(t,c[d+((x|1)<<2)>>2]|0)|0;cWc(n);x=x+2|0;g=c[d+(x<<2)>>2]|0;}while((g|0)!=0)}YVc(o,339192);dWc(l,NKc(j,o)|0)|0;cWc(o);YVc(p,339208);dWc(m,NKc(j,p)|0)|0;cWc(p);c[k>>2]=Fc(zWc(l)|0)|0;if((CWc(m,339224)|0)==0){B=a+24|0}else{B=c[b>>2]|0}c[b>>2]=B;if((CWc(m,339232)|0)==0){C=a+36|0}else{C=c[b>>2]|0}c[b>>2]=C;if((CWc(m,339240)|0)==0){D=a+48|0}else{D=c[b>>2]|0}c[b>>2]=D;if((CWc(m,339248)|0)==0){E=a+60|0}else{E=c[b>>2]|0}c[b>>2]=E;if((CWc(m,339256)|0)==0){F=a+72|0}else{F=c[b>>2]|0}c[b>>2]=F;if((CWc(m,339264)|0)==0){G=a+84|0}else{G=c[b>>2]|0}c[b>>2]=G;if((CWc(m,339272)|0)==0){H=a+96|0}else{H=c[b>>2]|0}c[b>>2]=H;if((CWc(m,339280)|0)==0){I=a+108|0}else{I=c[b>>2]|0}c[b>>2]=I;if((CWc(m,339288)|0)==0){J=a+120|0}else{J=c[b>>2]|0}c[b>>2]=J;if((CWc(m,339296)|0)==0){K=a+132|0}else{K=c[b>>2]|0}c[b>>2]=K;if((CWc(m,339304)|0)==0){L=a+144|0}else{L=c[b>>2]|0}c[b>>2]=L;if((CWc(m,339312)|0)==0){M=a+156|0}else{M=c[b>>2]|0}c[b>>2]=M;if((CWc(m,339320)|0)==0){N=a+168|0}else{N=c[b>>2]|0}c[b>>2]=N;if((CWc(m,339328)|0)==0){O=a+180|0}else{O=c[b>>2]|0}c[b>>2]=O;a=zWc(m)|0;YVc(q,335752);N=zWc(NKc(j,q)|0)|0;c[f>>2]=a;c[f+4>>2]=N;HBc(0,(O|0)!=0|0,339336,f);cWc(q);AQc(eLc(c[b>>2]|0,s)|0,j)|0;cWc(m);cWc(l);vLc(j);i=e;return}function $Kc(a,b){a=a|0;b=b|0;i=i;return}function aLc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=lNc(a,b)|0;i=c;return d|0}function bLc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;uNc(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];mNc(a,f);i=e;return}function cLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;nNc(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];mNc(a,e);i=d;return}function dLc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0,Ca=0,Da=0,Ea=0,Fa=0,Ga=0,Ha=0,Ia=0,Ja=0,Ka=0,La=0,Ma=0,Na=0,Oa=0,Pa=0,Qa=0,Ra=0,Sa=0,Ta=0,Ua=0,Va=0,Wa=0,Xa=0,Ya=0,Za=0,_a=0,$a=0,ab=0,bb=0,cb=0,db=0,eb=0,fb=0,gb=0,hb=0,ib=0,jb=0,kb=0,lb=0,mb=0,nb=0,ob=0,pb=0,qb=0,rb=0,sb=0,tb=0,ub=0,vb=0,wb=0,xb=0,yb=0,zb=0,Ab=0,Bb=0,Cb=0,Db=0,Eb=0,Fb=0,Gb=0,Hb=0,Ib=0,Jb=0,Kb=0,Lb=0,Mb=0,Nb=0,Ob=0,Pb=0,Qb=0,Rb=0,Sb=0,Tb=0,Ub=0,Vb=0,Wb=0,Yb=0,Zb=0,_b=0,$b=0,ac=0,bc=0,cc=0,dc=0,ec=0,fc=0,gc=0,hc=0,ic=0,jc=0,kc=0,lc=0,mc=0,nc=0,oc=0,pc=0,qc=0,rc=0,sc=0,tc=0,uc=0,vc=0,wc=0,xc=0,yc=0,zc=0,Ac=0,Bc=0,Cc=0,Dc=0,Ec=0,Fc=0,Gc=0,Hc=0,Ic=0,Jc=0,Kc=0,Lc=0,Mc=0,Nc=0,Oc=0,Pc=0,Qc=0,Rc=0,Sc=0,Tc=0,Uc=0,Vc=0,Wc=0,Xc=0,Yc=0,Zc=0,_c=0,$c=0,ad=0,bd=0,cd=0,dd=0,ed=0,fd=0,gd=0,hd=0,id=0,jd=0,kd=0,ld=0,md=0,nd=0,od=0,pd=0;f=i;i=i+8|0;g=f;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+16|0;p=i;i=i+8|0;q=i;i=i+192|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=i;i=i+16|0;H=i;i=i+16|0;I=i;i=i+16|0;J=i;i=i+16|0;K=i;i=i+16|0;L=i;i=i+16|0;M=i;i=i+16|0;N=i;i=i+16|0;O=i;i=i+16|0;P=i;i=i+16|0;Q=i;i=i+16|0;R=i;i=i+16|0;S=i;i=i+16|0;T=i;i=i+16|0;U=i;i=i+16|0;V=i;i=i+16|0;W=i;i=i+16|0;X=i;i=i+16|0;Y=i;i=i+16|0;Z=i;i=i+16|0;_=i;i=i+8|0;$=i;i=i+16|0;aa=i;i=i+8|0;ba=i;i=i+16|0;ca=i;i=i+8|0;da=i;i=i+16|0;ea=i;i=i+8|0;fa=i;i=i+16|0;ga=i;i=i+8|0;ha=i;i=i+16|0;ia=i;i=i+8|0;ja=i;i=i+16|0;ka=i;i=i+8|0;la=i;i=i+16|0;ma=i;i=i+8|0;na=i;i=i+16|0;oa=i;i=i+8|0;pa=i;i=i+16|0;qa=i;i=i+8|0;ra=i;i=i+16|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+8|0;va=i;i=i+16|0;wa=i;i=i+8|0;xa=i;i=i+16|0;ya=i;i=i+8|0;za=i;i=i+16|0;Aa=i;i=i+8|0;Ba=i;i=i+16|0;Ca=i;i=i+8|0;Da=i;i=i+16|0;Ea=i;i=i+8|0;Fa=i;i=i+16|0;Ga=i;i=i+8|0;Ha=i;i=i+16|0;Ia=i;i=i+8|0;Ja=i;i=i+16|0;Ka=i;i=i+8|0;La=i;i=i+16|0;Ma=i;i=i+8|0;Na=i;i=i+16|0;Oa=i;i=i+8|0;Pa=i;i=i+16|0;Qa=i;i=i+8|0;Ra=i;i=i+16|0;Sa=i;i=i+8|0;Ta=i;i=i+16|0;Ua=i;i=i+8|0;Va=i;i=i+16|0;Wa=i;i=i+8|0;Xa=i;i=i+16|0;Ya=i;i=i+8|0;Za=i;i=i+16|0;_a=i;i=i+8|0;$a=i;i=i+16|0;ab=i;i=i+8|0;bb=i;i=i+16|0;cb=i;i=i+8|0;db=i;i=i+16|0;eb=i;i=i+8|0;fb=i;i=i+16|0;gb=i;i=i+8|0;hb=i;i=i+16|0;ib=i;i=i+8|0;jb=i;i=i+16|0;kb=i;i=i+8|0;lb=i;i=i+16|0;mb=i;i=i+8|0;nb=i;i=i+16|0;ob=i;i=i+8|0;pb=i;i=i+16|0;qb=i;i=i+8|0;rb=i;i=i+16|0;sb=i;i=i+8|0;tb=i;i=i+16|0;ub=i;i=i+8|0;vb=i;i=i+16|0;wb=i;i=i+8|0;xb=i;i=i+16|0;yb=i;i=i+8|0;zb=i;i=i+16|0;Ab=i;i=i+8|0;Bb=i;i=i+16|0;Cb=i;i=i+8|0;Db=i;i=i+16|0;Eb=i;i=i+8|0;Fb=i;i=i+16|0;Gb=i;i=i+8|0;Hb=i;i=i+16|0;Ib=i;i=i+8|0;Jb=i;i=i+16|0;Kb=i;i=i+8|0;Lb=i;i=i+16|0;Mb=i;i=i+8|0;Nb=i;i=i+16|0;Ob=i;i=i+8|0;Pb=i;i=i+16|0;Qb=i;i=i+8|0;Rb=i;i=i+16|0;Sb=i;i=i+8|0;Tb=i;i=i+16|0;Ub=i;i=i+8|0;Vb=i;i=i+16|0;Wb=i;i=i+8|0;Yb=i;i=i+16|0;Zb=i;i=i+8|0;_b=i;i=i+16|0;$b=i;i=i+8|0;ac=i;i=i+16|0;bc=i;i=i+8|0;cc=i;i=i+16|0;nLc(o,p);p=(d|0)!=0;dc=(e|0)==0;if(!(dc|p^1)){IBc(0,338520,n)}if(p){ec=Ad(d|0)|0}else{ec=0}if(dc){fc=ec}else{c[m>>2]=e;EBc(23,0,338664,m);oLc(q);pLc(q,e,8);if(!(qLc(q)|0)){c[l>>2]=e;IBc(0,338704,l)}SVc(r);l=q;rLc(l,r)|0;UVc(s,r);while(1){e=rLc(l,r)|0;if(!(OWc(e+(c[(c[e>>2]|0)+ -12>>2]|0)|0)|0)){break}NWc(t,338784,r);tWc(s,t)|0;cWc(t)}t=Ad(zWc(s)|0)|0;sLc(q);cWc(s);cWc(r);tLc(q);fc=t}if((fc|0)==0){EBc(23,0,338872,g);vLc(o);i=f;return}SVc(u);SVc(v);c[k>>2]=fc;EBc(23,0,338792,k);k=Xb(fc|0,338784)|0;if((k|0)!=0){g=k;do{k=n4c(12)|0;YVc(k,g);t=AWc(k,338824,0)|0;yWc(w,k,0,t);dWc(u,w)|0;cWc(w);yWc(x,k,t+1|0,(jWc(k)|0)+~t|0);dWc(v,x)|0;cWc(x);dWc(NKc(o,u)|0,v)|0;t=zWc(u)|0;k=zWc(v)|0;c[j>>2]=t;c[j+4>>2]=k;EBc(23,0,338832,j);g=Xb(0,338784)|0;}while((g|0)!=0)}i4c(fc);fc=a+12|0;YVc(y,336920);g=NKc(fc,y)|0;YVc(z,336920);if((uLc(o,z)|0)==0){YVc(B,336920);gc=1;hc=0;ic=NKc(fc,B)|0}else{YVc(A,336920);gc=0;hc=1;ic=NKc(o,A)|0}dWc(g,ic)|0;if(gc){cWc(B)}if(hc){cWc(A)}cWc(z);cWc(y);YVc(C,336792);y=NKc(fc,C)|0;YVc(D,336792);if((uLc(o,D)|0)==0){YVc(F,336792);jc=1;kc=0;lc=NKc(fc,F)|0}else{YVc(E,336792);jc=0;kc=1;lc=NKc(o,E)|0}dWc(y,lc)|0;if(jc){cWc(F)}if(kc){cWc(E)}cWc(D);cWc(C);YVc(G,336824);C=NKc(fc,G)|0;YVc(H,336824);if((uLc(o,H)|0)==0){YVc(J,336824);mc=1;nc=0;oc=NKc(fc,J)|0}else{YVc(I,336824);mc=0;nc=1;oc=NKc(o,I)|0}dWc(C,oc)|0;if(mc){cWc(J)}if(nc){cWc(I)}cWc(H);cWc(G);YVc(K,336856);G=NKc(fc,K)|0;YVc(L,336856);if((uLc(o,L)|0)==0){YVc(N,336856);pc=0;qc=1;rc=NKc(fc,N)|0}else{YVc(M,336856);pc=1;qc=0;rc=NKc(o,M)|0}dWc(G,rc)|0;if(qc){cWc(N)}if(pc){cWc(M)}cWc(L);cWc(K);YVc(O,336888);K=NKc(fc,O)|0;YVc(P,336888);if((uLc(o,P)|0)==0){YVc(R,336888);sc=1;tc=0;uc=NKc(fc,R)|0}else{YVc(Q,336888);sc=0;tc=1;uc=NKc(o,Q)|0}dWc(K,uc)|0;if(sc){cWc(R)}if(tc){cWc(Q)}cWc(P);cWc(O);YVc(S,336952);O=NKc(fc,S)|0;YVc(T,336952);if((uLc(o,T)|0)==0){YVc(V,336952);vc=1;wc=0;xc=NKc(fc,V)|0}else{YVc(U,336952);vc=0;wc=1;xc=NKc(o,U)|0}dWc(O,xc)|0;if(vc){cWc(V)}if(wc){cWc(U)}cWc(T);cWc(S);YVc(W,336992);S=NKc(fc,W)|0;YVc(X,336992);if((uLc(o,X)|0)==0){YVc(Z,336992);yc=1;zc=0;Ac=NKc(fc,Z)|0}else{YVc(Y,336992);yc=0;zc=1;Ac=NKc(o,Y)|0}dWc(S,Ac)|0;if(yc){cWc(Z)}if(zc){cWc(Y)}cWc(X);cWc(W);W=b+104|0;X=c[W>>2]|0;if((X|0)>0){Y=a+24|0;zc=a+36|0;Z=0;while(1){c[_>>2]=Z;yc=eLc(Y,_)|0;YVc($,335896);Ac=NKc(yc,$)|0;c[aa>>2]=Z;yc=eLc(Y,aa)|0;YVc(ba,335752);if((uLc(o,NKc(yc,ba)|0)|0)==0){c[ea>>2]=Z;yc=eLc(Y,ea)|0;YVc(fa,335896);Bc=1;Cc=0;Dc=NKc(yc,fa)|0}else{c[ca>>2]=Z;yc=eLc(Y,ca)|0;YVc(da,335752);Bc=0;Cc=1;Dc=NKc(o,NKc(yc,da)|0)|0}dWc(Ac,Dc)|0;if(Bc){cWc(fa)}if(Cc){cWc(da)}cWc(ba);cWc($);c[ga>>2]=Z;Ac=eLc(zc,ga)|0;YVc(ha,335896);yc=NKc(Ac,ha)|0;c[ia>>2]=Z;Ac=eLc(zc,ia)|0;YVc(ja,335752);if((uLc(o,NKc(Ac,ja)|0)|0)==0){c[ma>>2]=Z;Ac=eLc(zc,ma)|0;YVc(na,335896);Ec=1;Fc=0;Gc=NKc(Ac,na)|0}else{c[ka>>2]=Z;Ac=eLc(zc,ka)|0;YVc(la,335752);Ec=0;Fc=1;Gc=NKc(o,NKc(Ac,la)|0)|0}dWc(yc,Gc)|0;if(Ec){cWc(na)}if(Fc){cWc(la)}cWc(ja);cWc(ha);yc=Z+1|0;Ac=c[W>>2]|0;if((yc|0)<(Ac|0)){Z=yc}else{Hc=Ac;break}}}else{Hc=X}X=b+108|0;if(((c[X>>2]|0)-(Hc<<1)|0)>0){Hc=a+48|0;Z=0;do{c[oa>>2]=Z;ha=eLc(Hc,oa)|0;YVc(pa,335896);ja=NKc(ha,pa)|0;c[qa>>2]=Z;ha=eLc(Hc,qa)|0;YVc(ra,335752);if((uLc(o,NKc(ha,ra)|0)|0)==0){c[ua>>2]=Z;ha=eLc(Hc,ua)|0;YVc(va,335896);Ic=1;Jc=0;Kc=NKc(ha,va)|0}else{c[sa>>2]=Z;ha=eLc(Hc,sa)|0;YVc(ta,335752);Ic=0;Jc=1;Kc=NKc(o,NKc(ha,ta)|0)|0}dWc(ja,Kc)|0;if(Ic){cWc(va)}if(Jc){cWc(ta)}cWc(ra);cWc(pa);Z=Z+1|0;}while((Z|0)<((c[X>>2]|0)-(c[W>>2]<<1)|0))}W=b+116|0;if((c[W>>2]|0)>0){X=a+84|0;Z=0;do{c[wa>>2]=Z;pa=eLc(X,wa)|0;YVc(xa,335896);ra=NKc(pa,xa)|0;c[ya>>2]=Z;pa=eLc(X,ya)|0;YVc(za,335752);if((uLc(o,NKc(pa,za)|0)|0)==0){c[Ca>>2]=Z;pa=eLc(X,Ca)|0;YVc(Da,335896);Lc=1;Mc=0;Nc=NKc(pa,Da)|0}else{c[Aa>>2]=Z;pa=eLc(X,Aa)|0;YVc(Ba,335752);Lc=0;Mc=1;Nc=NKc(o,NKc(pa,Ba)|0)|0}dWc(ra,Nc)|0;if(Lc){cWc(Da)}if(Mc){cWc(Ba)}cWc(za);cWc(xa);Z=Z+1|0;}while((Z|0)<(c[W>>2]|0))}W=b+120|0;if((c[W>>2]|0)>0){Z=a+120|0;xa=0;do{c[Ea>>2]=xa;za=eLc(Z,Ea)|0;YVc(Fa,335896);Ba=NKc(za,Fa)|0;c[Ga>>2]=xa;za=eLc(Z,Ga)|0;YVc(Ha,335752);if((uLc(o,NKc(za,Ha)|0)|0)==0){c[Ka>>2]=xa;za=eLc(Z,Ka)|0;YVc(La,335896);Oc=1;Pc=0;Qc=NKc(za,La)|0}else{c[Ia>>2]=xa;za=eLc(Z,Ia)|0;YVc(Ja,335752);Oc=0;Pc=1;Qc=NKc(o,NKc(za,Ja)|0)|0}dWc(Ba,Qc)|0;if(Oc){cWc(La)}if(Pc){cWc(Ja)}cWc(Ha);cWc(Fa);xa=xa+1|0;}while((xa|0)<(c[W>>2]|0))}W=b+124|0;if((c[W>>2]|0)>0){xa=a+156|0;Fa=0;do{c[Ma>>2]=Fa;Ha=eLc(xa,Ma)|0;YVc(Na,335896);Ja=NKc(Ha,Na)|0;c[Oa>>2]=Fa;Ha=eLc(xa,Oa)|0;YVc(Pa,335752);if((uLc(o,NKc(Ha,Pa)|0)|0)==0){c[Sa>>2]=Fa;Ha=eLc(xa,Sa)|0;YVc(Ta,335896);Rc=1;Sc=0;Tc=NKc(Ha,Ta)|0}else{c[Qa>>2]=Fa;Ha=eLc(xa,Qa)|0;YVc(Ra,335752);Rc=0;Sc=1;Tc=NKc(o,NKc(Ha,Ra)|0)|0}dWc(Ja,Tc)|0;if(Rc){cWc(Ta)}if(Sc){cWc(Ra)}cWc(Pa);cWc(Na);Fa=Fa+1|0;}while((Fa|0)<(c[W>>2]|0))}W=b+128|0;if((c[W>>2]|0)>0){Fa=a+60|0;Na=0;do{c[Ua>>2]=Na;Pa=eLc(Fa,Ua)|0;YVc(Va,335896);Ra=NKc(Pa,Va)|0;c[Wa>>2]=Na;Pa=eLc(Fa,Wa)|0;YVc(Xa,335752);if((uLc(o,NKc(Pa,Xa)|0)|0)==0){c[_a>>2]=Na;Pa=eLc(Fa,_a)|0;YVc($a,335896);Uc=1;Vc=0;Wc=NKc(Pa,$a)|0}else{c[Ya>>2]=Na;Pa=eLc(Fa,Ya)|0;YVc(Za,335752);Uc=0;Vc=1;Wc=NKc(o,NKc(Pa,Za)|0)|0}dWc(Ra,Wc)|0;if(Uc){cWc($a)}if(Vc){cWc(Za)}cWc(Xa);cWc(Va);Na=Na+1|0;}while((Na|0)<(c[W>>2]|0))}W=b+132|0;if((c[W>>2]|0)>0){Na=a+96|0;Va=0;do{c[ab>>2]=Va;Xa=eLc(Na,ab)|0;YVc(bb,335896);Za=NKc(Xa,bb)|0;c[cb>>2]=Va;Xa=eLc(Na,cb)|0;YVc(db,335752);if((uLc(o,NKc(Xa,db)|0)|0)==0){c[gb>>2]=Va;Xa=eLc(Na,gb)|0;YVc(hb,335896);Xc=1;Yc=0;Zc=NKc(Xa,hb)|0}else{c[eb>>2]=Va;Xa=eLc(Na,eb)|0;YVc(fb,335752);Xc=0;Yc=1;Zc=NKc(o,NKc(Xa,fb)|0)|0}dWc(Za,Zc)|0;if(Xc){cWc(hb)}if(Yc){cWc(fb)}cWc(db);cWc(bb);Va=Va+1|0;}while((Va|0)<(c[W>>2]|0))}W=b+136|0;if((c[W>>2]|0)>0){Va=a+132|0;bb=0;do{c[ib>>2]=bb;db=eLc(Va,ib)|0;YVc(jb,335896);fb=NKc(db,jb)|0;c[kb>>2]=bb;db=eLc(Va,kb)|0;YVc(lb,335752);if((uLc(o,NKc(db,lb)|0)|0)==0){c[ob>>2]=bb;db=eLc(Va,ob)|0;YVc(pb,335896);_c=1;$c=0;ad=NKc(db,pb)|0}else{c[mb>>2]=bb;db=eLc(Va,mb)|0;YVc(nb,335752);_c=0;$c=1;ad=NKc(o,NKc(db,nb)|0)|0}dWc(fb,ad)|0;if(_c){cWc(pb)}if($c){cWc(nb)}cWc(lb);cWc(jb);bb=bb+1|0;}while((bb|0)<(c[W>>2]|0))}W=b+140|0;if((c[W>>2]|0)>0){bb=a+168|0;jb=0;do{c[qb>>2]=jb;lb=eLc(bb,qb)|0;YVc(rb,335896);nb=NKc(lb,rb)|0;c[sb>>2]=jb;lb=eLc(bb,sb)|0;YVc(tb,335752);if((uLc(o,NKc(lb,tb)|0)|0)==0){c[wb>>2]=jb;lb=eLc(bb,wb)|0;YVc(xb,335896);bd=1;cd=0;dd=NKc(lb,xb)|0}else{c[ub>>2]=jb;lb=eLc(bb,ub)|0;YVc(vb,335752);bd=0;cd=1;dd=NKc(o,NKc(lb,vb)|0)|0}dWc(nb,dd)|0;if(bd){cWc(xb)}if(cd){cWc(vb)}cWc(tb);cWc(rb);jb=jb+1|0;}while((jb|0)<(c[W>>2]|0))}W=b+208|0;if((c[W>>2]|0)>0){jb=a+72|0;rb=0;do{c[yb>>2]=rb;tb=eLc(jb,yb)|0;YVc(zb,335896);vb=NKc(tb,zb)|0;c[Ab>>2]=rb;tb=eLc(jb,Ab)|0;YVc(Bb,335752);if((uLc(o,NKc(tb,Bb)|0)|0)==0){c[Eb>>2]=rb;tb=eLc(jb,Eb)|0;YVc(Fb,335896);ed=1;fd=0;gd=NKc(tb,Fb)|0}else{c[Cb>>2]=rb;tb=eLc(jb,Cb)|0;YVc(Db,335752);ed=0;fd=1;gd=NKc(o,NKc(tb,Db)|0)|0}dWc(vb,gd)|0;if(ed){cWc(Fb)}if(fd){cWc(Db)}cWc(Bb);cWc(zb);rb=rb+1|0;}while((rb|0)<(c[W>>2]|0))}W=b+212|0;if((c[W>>2]|0)>0){rb=a+108|0;zb=0;do{c[Gb>>2]=zb;Bb=eLc(rb,Gb)|0;YVc(Hb,335896);Db=NKc(Bb,Hb)|0;c[Ib>>2]=zb;Bb=eLc(rb,Ib)|0;YVc(Jb,335752);if((uLc(o,NKc(Bb,Jb)|0)|0)==0){c[Mb>>2]=zb;Bb=eLc(rb,Mb)|0;YVc(Nb,335896);hd=0;id=1;jd=NKc(Bb,Nb)|0}else{c[Kb>>2]=zb;Bb=eLc(rb,Kb)|0;YVc(Lb,335752);hd=1;id=0;jd=NKc(o,NKc(Bb,Lb)|0)|0}dWc(Db,jd)|0;if(id){cWc(Nb)}if(hd){cWc(Lb)}cWc(Jb);cWc(Hb);zb=zb+1|0;}while((zb|0)<(c[W>>2]|0))}W=b+216|0;if((c[W>>2]|0)>0){zb=a+144|0;Hb=0;do{c[Ob>>2]=Hb;Jb=eLc(zb,Ob)|0;YVc(Pb,335896);Lb=NKc(Jb,Pb)|0;c[Qb>>2]=Hb;Jb=eLc(zb,Qb)|0;YVc(Rb,335752);if((uLc(o,NKc(Jb,Rb)|0)|0)==0){c[Ub>>2]=Hb;Jb=eLc(zb,Ub)|0;YVc(Vb,335896);kd=1;ld=0;md=NKc(Jb,Vb)|0}else{c[Sb>>2]=Hb;Jb=eLc(zb,Sb)|0;YVc(Tb,335752);kd=0;ld=1;md=NKc(o,NKc(Jb,Tb)|0)|0}dWc(Lb,md)|0;if(kd){cWc(Vb)}if(ld){cWc(Tb)}cWc(Rb);cWc(Pb);Hb=Hb+1|0;}while((Hb|0)<(c[W>>2]|0))}W=b+220|0;if((c[W>>2]|0)>0){b=a+180|0;a=0;do{c[Wb>>2]=a;Hb=eLc(b,Wb)|0;YVc(Yb,335896);Pb=NKc(Hb,Yb)|0;c[Zb>>2]=a;Hb=eLc(b,Zb)|0;YVc(_b,335752);if((uLc(o,NKc(Hb,_b)|0)|0)==0){c[bc>>2]=a;Hb=eLc(b,bc)|0;YVc(cc,335896);nd=1;od=0;pd=NKc(Hb,cc)|0}else{c[$b>>2]=a;Hb=eLc(b,$b)|0;YVc(ac,335752);nd=0;od=1;pd=NKc(o,NKc(Hb,ac)|0)|0}dWc(Pb,pd)|0;if(nd){cWc(cc)}if(od){cWc(ac)}cWc(_b);cWc(Yb);a=a+1|0;}while((a|0)<(c[W>>2]|0))}EBc(23,0,338856,h);cWc(v);cWc(u);vLc(o);i=f;return}function eLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=LNc(a,f,b)|0;l=c[k>>2]|0;xHc(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}NNc(j,a,b);ONc(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];MNc(g,e);PNc(j);j=c[f>>2]|0;QNc(a,j,k,RNc(g)|0);k=SNc(g)|0;PNc(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function fLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=nMc(a,f,b)|0;l=c[k>>2]|0;xHc(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}pMc(j,a,b);qMc(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];oMc(g,e);rMc(j);j=c[f>>2]|0;sMc(a,j,k,tMc(g)|0);k=uMc(g)|0;rMc(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function gLc(a,b){a=a|0;b=b|0;var c=0;c=i;dWc(b,a)|0;i=c;return}function hLc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;eMc(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];YLc(a,f);i=e;return}function iLc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=WLc(a,b)|0;i=c;return d|0}function jLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;ZLc(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];YLc(a,e);i=d;return}function kLc(a){a=a|0;var b=0,c=0;b=i;c=TLc(a)|0;i=b;return c|0}function lLc(a){a=a|0;var b=0;b=i;qQc(a);i=b;return}function mLc(a){a=a|0;var b=0;b=i;dQc(a);i=b;return}function nLc(a,b){a=a|0;b=b|0;b=i;MOc(a,0);i=b;return}function oLc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+108|0;$Wc(d);e=a;c[e>>2]=338924;f=d;c[f>>2]=338944;d=a+8|0;TXc(a,338956|0,d);c[e>>2]=338924;c[f>>2]=338944;eKc(d);i=b;return}function pLc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(FHc(a+8|0,b,d|8)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){SWc(d,4);i=e;return}else{QWc(d,0);i=e;return}}function qLc(a){a=a|0;var b=0,c=0;b=i;c=OLc(a+8|0)|0;i=b;return c|0}function rLc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=NLc(a,b,ZWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;i=d;return e|0}function sLc(a){a=a|0;var b=0;b=i;if((HHc(a+8|0)|0)!=0){i=b;return}SWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function tLc(a){a=a|0;var b=0;b=i;SLc(a,338952);WWc(a+108|0);i=b;return}function uLc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=wLc(a,b)|0;i=c;return d|0}function vLc(a){a=a|0;var b=0;b=i;UPc(a);i=b;return}function wLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+8|0;e=d;f=yLc(a)|0;xHc(e);if((f|0)==0){g=0;i=d;return g|0}h=zLc(a)|0;a=f;while(1){f=a+16|0;if(ALc(h,b,f)|0){j=a}else{if(!(BLc(h,f,b)|0)){g=1;k=8;break}j=a+4|0}f=c[j>>2]|0;xHc(e);if((f|0)==0){g=0;k=8;break}else{a=f}}if((k|0)==8){i=d;return g|0}return 0}function xLc(a){a=a|0;var b=0,c=0;b=i;c=iHc(HLc(a+4|0)|0)|0;i=b;return c|0}function yLc(a){a=a|0;var b=0,d=0;b=i;d=c[(xLc(a)|0)>>2]|0;i=b;return d|0}function zLc(a){a=a|0;var b=0,c=0;b=i;c=FLc(a+8|0)|0;i=b;return c|0}function ALc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=CLc(0,b,c)|0;i=a;return d|0}function BLc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=CLc(0,b,c)|0;i=a;return d|0}function CLc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=DLc(b,c)|0;i=a;return d|0}function DLc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(BWc(a,b)|0)<0;i=c;return d|0}function ELc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;e=G4c(a,b,c)|0;i=d;return e|0}function FLc(a){a=a|0;var b=0,c=0;b=i;c=GLc(a)|0;i=b;return c|0}function GLc(a){a=a|0;i=i;return a|0}function HLc(a){a=a|0;var b=0,c=0;b=i;c=ILc(a)|0;i=b;return c|0}function ILc(a){a=a|0;i=i;return a|0}function JLc(a,b){a=a|0;b=b|0;var c=0;a=i;c=LLc(0,b,0)|0;i=a;return c|0}function KLc(b,c){b=b|0;c=c|0;a[b]=a[c]|0;i=i;return}function LLc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=n4c(b)|0;i=c;return a|0}function MLc(a){a=a|0;var b=0,c=0;b=i;c=L4c(a|0)|0;i=b;return c|0}function NLc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;YXc(f,a,1);if(!($Xc(f)|0)){i=e;return a|0}sWc(b);f=0;while(1){g=fXc(XWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0)|0)|0;if(rIc(g,-1)|0){h=2;j=f;break}k=f+1|0;l=sIc(g)|0;if(wIc(l,d)|0){h=0;j=k;break}uWc(b,l);if((aWc(b)|0)==-17){h=4;j=k;break}else{f=k}}SWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,(j|0)==0?h|4:h);i=e;return a|0}function OLc(a){a=a|0;i=i;return(c[a+64>>2]|0)!=0|0}function PLc(a){a=a|0;var b=0;b=i;tLc(a);p4c(a);i=b;return}function QLc(a){a=a|0;var b=0;b=i;tLc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function RLc(a){a=a|0;var b=0;b=i;PLc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function SLc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];fIc(a+8|0);i=d;return}function TLc(a){a=a|0;var b=0,d=0;b=i;d=ULc((c[a>>2]|0)+16|0)|0;i=b;return d|0}function ULc(a){a=a|0;var b=0,c=0;b=i;c=VLc(a)|0;i=b;return c|0}function VLc(a){a=a|0;i=i;return a|0}function WLc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(XLc(a,b)|0)^1;i=c;return d|0}function XLc(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function YLc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];dMc(a,e);i=d;return}function ZLc(a,b){a=a|0;b=b|0;var c=0;c=i;_Lc(a,$Lc(b)|0);i=c;return}function _Lc(a,b){a=a|0;b=b|0;var c=0;c=i;cMc(a,b);i=c;return}function $Lc(a){a=a|0;var b=0,c=0;b=i;c=iHc(aMc(a+4|0)|0)|0;i=b;return c|0}function aMc(a){a=a|0;var b=0,c=0;b=i;c=bMc(a)|0;i=b;return c|0}function bMc(a){a=a|0;i=i;return a|0}function cMc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function dMc(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function eMc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=gMc(b)|0;fMc(f,b,d,h,$Lc(b)|0);ZLc(g,b);do{if(WLc(f,g)|0){h=hMc(b)|0;if(iMc(h,d,jMc(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);ZLc(a,b);i=e;return}function fMc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;xHc(h);a:do{if((e|0)==0){j=f}else{k=hMc(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(mMc(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;xHc(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;xHc(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);_Lc(a,j);i=g;return}function gMc(a){a=a|0;var b=0,d=0;b=i;d=c[($Lc(a)|0)>>2]|0;i=b;return d|0}function hMc(a){a=a|0;var b=0,c=0;b=i;c=kMc(a+8|0)|0;i=b;return c|0}function iMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=CLc(0,b,c)|0;i=a;return d|0}function jMc(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function kMc(a){a=a|0;var b=0,c=0;b=i;c=lMc(a)|0;i=b;return c|0}function lMc(a){a=a|0;i=i;return a|0}function mMc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=CLc(0,b,c)|0;i=a;return d|0}function nMc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=gMc(h)|0;xHc(e);if((a|0)==0){j=$Lc(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(CLc(0,d,a)|0){m=l;j=c[m>>2]|0;xHc(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(CLc(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;xHc(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function oMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];jNc(a,e);i=d;return}function pMc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=QMc(d)|0;d=SMc(n,1)|0;TMc(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];RMc(j,d,h);UMc(0,JMc((VMc(j)|0)+16|0)|0,e);e=WMc(j)|0;a[e+4|0]=1;XMc(0,HMc((VMc(j)|0)+28|0)|0);a[e+5|0]=1;YMc(m,j);qMc(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];oMc(b,g);rMc(m);rMc(j);i=f;return}function qMc(a,b){a=a|0;b=b|0;var c=0;c=i;OMc(a,b);i=c;return}function rMc(a){a=a|0;var b=0;b=i;DMc(a);i=b;return}function sMc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;xHc(f);c[e>>2]=0;xHc(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=zMc(a)|0;b=c[c[e>>2]>>2]|0;xHc(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[($Lc(a)|0)>>2]|0;hJc(e,c[d>>2]|0);d=AMc(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function tMc(a){a=a|0;var b=0,d=0;b=i;d=c[(xMc(a)|0)>>2]|0;i=b;return d|0}function uMc(a){a=a|0;var b=0,d=0;b=i;d=vMc(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function vMc(a){a=a|0;var b=0,c=0;b=i;c=wMc(a)|0;i=b;return c|0}function wMc(a){a=a|0;i=i;return a|0}function xMc(a){a=a|0;var b=0,c=0;b=i;c=yMc(a)|0;i=b;return c|0}function yMc(a){a=a|0;i=i;return a|0}function zMc(a){a=a|0;i=i;return a|0}function AMc(a){a=a|0;var b=0,c=0;b=i;c=BMc(a+8|0)|0;i=b;return c|0}function BMc(a){a=a|0;var b=0,c=0;b=i;c=CMc(a)|0;i=b;return c|0}function CMc(a){a=a|0;i=i;return a|0}function DMc(a){a=a|0;var b=0;b=i;EMc(a,0);i=b;return}function EMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=vMc(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}GMc(FMc(e)|0,f);i=d;return}function FMc(a){a=a|0;var b=0,c=0;b=i;c=NMc(a)|0;i=b;return c|0}function GMc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;IMc(f,JMc(d+16|0)|0)}if((d|0)==0){i=e;return}KMc(c[b>>2]|0,d,1);i=e;return}function HMc(a){a=a|0;i=i;return a|0}function IMc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;MMc(d,0,c);i=b;return}function JMc(a){a=a|0;i=i;return a|0}function KMc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;LMc(0,b,0);i=c;return}function LMc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;p4c(b);i=c;return}function MMc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;cWc(c);i=b;return}function NMc(a){a=a|0;i=i;return a+4|0}function OMc(a,b){a=a|0;b=b|0;var c=0;c=i;PMc(a,b);i=c;return}function PMc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function QMc(a){a=a|0;var b=0,c=0;b=i;c=hNc(a+4|0)|0;i=b;return c|0}function RMc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];$Mc(a,b,f);i=e;return}function SMc(a,b){a=a|0;b=b|0;var c=0;a=i;c=_Mc(0,b,0)|0;i=a;return c|0}function TMc(a,b){a=a|0;b=b|0;var c=0;c=i;ZMc(a,b);i=c;return}function UMc(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}UVc(b,c);i=a;return}function VMc(a){a=a|0;var b=0,d=0;b=i;d=c[(xMc(a)|0)>>2]|0;i=b;return d|0}function WMc(a){a=a|0;var b=0,c=0;b=i;c=FMc(a)|0;i=b;return c|0}function XMc(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function YMc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;OMc(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];oMc(h,f);qMc(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];oMc(a,e);rMc(h);i=d;return}function ZMc(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function _Mc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=n4c(b<<5)|0;i=c;return a|0}function $Mc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(bNc(g)|0)>>2]|0;g=cNc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];aNc(b,a,f);i=e;return}function aNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];dNc(a,b,f);i=e;return}function bNc(a){a=a|0;i=i;return a|0}function cNc(a){a=a|0;i=i;return a|0}function dNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(fNc(g)|0)>>2]|0;g=gNc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];eNc(b,a,f);i=e;return}function eNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(fNc(f)|0)>>2];f=gNc(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function fNc(a){a=a|0;i=i;return a|0}function gNc(a){a=a|0;i=i;return a|0}function hNc(a){a=a|0;var b=0,c=0;b=i;c=iNc(a)|0;i=b;return c|0}function iNc(a){a=a|0;i=i;return a|0}function jNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=uMc(kNc(b)|0)|0;h=gNc(WMc(kNc(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];aNc(g,a,e);i=d;return}function kNc(a){a=a|0;i=i;return c[a>>2]|0}function lNc(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function mNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];tNc(a,e);i=d;return}function nNc(a,b){a=a|0;b=b|0;var c=0;c=i;oNc(a,pNc(b)|0);i=c;return}function oNc(a,b){a=a|0;b=b|0;var c=0;c=i;sNc(a,b);i=c;return}function pNc(a){a=a|0;var b=0,c=0;b=i;c=iHc(qNc(a+4|0)|0)|0;i=b;return c|0}function qNc(a){a=a|0;var b=0,c=0;b=i;c=rNc(a)|0;i=b;return c|0}function rNc(a){a=a|0;i=i;return a|0}function sNc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function tNc(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function uNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=wNc(b)|0;vNc(f,b,d,h,pNc(b)|0);nNc(g,b);do{if(xNc(f,g)|0){h=yNc(b)|0;if(ALc(h,d,zNc(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);nNc(a,b);i=e;return}function vNc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;xHc(h);a:do{if((e|0)==0){j=f}else{k=yNc(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(BLc(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;xHc(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;xHc(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);oNc(a,j);i=g;return}function wNc(a){a=a|0;var b=0,d=0;b=i;d=c[(pNc(a)|0)>>2]|0;i=b;return d|0}function xNc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(lNc(a,b)|0)^1;i=c;return d|0}function yNc(a){a=a|0;var b=0,c=0;b=i;c=ANc(a+8|0)|0;i=b;return c|0}function zNc(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function ANc(a){a=a|0;var b=0,c=0;b=i;c=BNc(a)|0;i=b;return c|0}function BNc(a){a=a|0;i=i;return a|0}function CNc(a,b){a=a|0;b=b|0;b=i;i=i+8|0;DNc(a,b);i=b;return}function DNc(a,b){a=a|0;b=b|0;b=i;ENc(a,0);i=b;return}function ENc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;FNc(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;GNc(f,0,e);e=$Lc(b)|0;c[(zMc(b)|0)>>2]=e;i=d;return}function FNc(a){a=a|0;var b=0;b=i;JNc(a);i=b;return}function GNc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;HNc(b,c,f);i=e;return}function HNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[($Jc(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;INc(d,b,f);i=e;return}function INc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[($Jc(e)|0)>>2];i=d;return}function JNc(a){a=a|0;var b=0;b=i;KNc(a);i=b;return}function KNc(a){a=a|0;var b=0;b=i;cKc(a);i=b;return}function LNc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=LOc(h)|0;xHc(e);if((a|0)==0){j=YNc(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(uHc(0,d,a)|0){m=l;j=c[m>>2]|0;xHc(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(uHc(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;xHc(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function MNc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];JOc(a,e);i=d;return}function NNc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=oOc(d)|0;d=qOc(n,1)|0;rOc(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];pOc(j,d,h);sOc(0,tJc((tOc(j)|0)+16|0)|0,e);e=uOc(j)|0;a[e+4|0]=1;vOc(0,hOc((tOc(j)|0)+20|0)|0);a[e+5|0]=1;wOc(m,j);ONc(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];MNc(b,g);PNc(m);PNc(j);i=f;return}function ONc(a,b){a=a|0;b=b|0;var c=0;c=i;mOc(a,b);i=c;return}function PNc(a){a=a|0;var b=0;b=i;cOc(a);i=b;return}function QNc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;xHc(f);c[e>>2]=0;xHc(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=XNc(a)|0;b=c[c[e>>2]>>2]|0;xHc(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(YNc(a)|0)>>2]|0;hJc(e,c[d>>2]|0);d=ZNc(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function RNc(a){a=a|0;var b=0,d=0;b=i;d=c[(VNc(a)|0)>>2]|0;i=b;return d|0}function SNc(a){a=a|0;var b=0,d=0;b=i;d=TNc(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function TNc(a){a=a|0;var b=0,c=0;b=i;c=UNc(a)|0;i=b;return c|0}function UNc(a){a=a|0;i=i;return a|0}function VNc(a){a=a|0;var b=0,c=0;b=i;c=WNc(a)|0;i=b;return c|0}function WNc(a){a=a|0;i=i;return a|0}function XNc(a){a=a|0;i=i;return a|0}function YNc(a){a=a|0;var b=0,c=0;b=i;c=iHc(aOc(a+4|0)|0)|0;i=b;return c|0}function ZNc(a){a=a|0;var b=0,c=0;b=i;c=_Nc(a+8|0)|0;i=b;return c|0}function _Nc(a){a=a|0;var b=0,c=0;b=i;c=$Nc(a)|0;i=b;return c|0}function $Nc(a){a=a|0;i=i;return a|0}function aOc(a){a=a|0;var b=0,c=0;b=i;c=bOc(a)|0;i=b;return c|0}function bOc(a){a=a|0;i=i;return a|0}function cOc(a){a=a|0;var b=0;b=i;dOc(a,0);i=b;return}function dOc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=TNc(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}fOc(eOc(e)|0,f);i=d;return}function eOc(a){a=a|0;var b=0,c=0;b=i;c=lOc(a)|0;i=b;return c|0}function fOc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;gOc(f,hOc(d+20|0)|0)}if((d|0)==0){i=e;return}iOc(c[b>>2]|0,d,1);i=e;return}function gOc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;kOc(d,0,c);i=b;return}function hOc(a){a=a|0;i=i;return a|0}function iOc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;jOc(0,b,0);i=c;return}function jOc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;p4c(b);i=c;return}function kOc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;vLc(c);i=b;return}function lOc(a){a=a|0;i=i;return a+4|0}function mOc(a,b){a=a|0;b=b|0;var c=0;c=i;nOc(a,b);i=c;return}function nOc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function oOc(a){a=a|0;var b=0,c=0;b=i;c=HOc(a+4|0)|0;i=b;return c|0}function pOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];zOc(a,b,f);i=e;return}function qOc(a,b){a=a|0;b=b|0;var c=0;a=i;c=yOc(0,b,0)|0;i=a;return c|0}function rOc(a,b){a=a|0;b=b|0;var c=0;c=i;xOc(a,b);i=c;return}function sOc(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function tOc(a){a=a|0;var b=0,d=0;b=i;d=c[(VNc(a)|0)>>2]|0;i=b;return d|0}function uOc(a){a=a|0;var b=0,c=0;b=i;c=eOc(a)|0;i=b;return c|0}function vOc(a,b){a=a|0;b=b|0;a=i;i=i+8|0;if((b|0)==0){i=a;return}nLc(b,a);i=a;return}function wOc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;mOc(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];MNc(h,f);ONc(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];MNc(a,e);PNc(h);i=d;return}function xOc(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function yOc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=n4c(b<<5)|0;i=c;return a|0}function zOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(BOc(g)|0)>>2]|0;g=COc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];AOc(b,a,f);i=e;return}function AOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];DOc(a,b,f);i=e;return}function BOc(a){a=a|0;i=i;return a|0}function COc(a){a=a|0;i=i;return a|0}function DOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(FOc(g)|0)>>2]|0;g=GOc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];EOc(b,a,f);i=e;return}function EOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(FOc(f)|0)>>2];f=GOc(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function FOc(a){a=a|0;i=i;return a|0}function GOc(a){a=a|0;i=i;return a|0}function HOc(a){a=a|0;var b=0,c=0;b=i;c=IOc(a)|0;i=b;return c|0}function IOc(a){a=a|0;i=i;return a|0}function JOc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=SNc(KOc(b)|0)|0;h=GOc(uOc(KOc(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];AOc(g,a,e);i=d;return}function KOc(a){a=a|0;i=i;return c[a>>2]|0}function LOc(a){a=a|0;var b=0,d=0;b=i;d=c[(YNc(a)|0)>>2]|0;i=b;return d|0}function MOc(a,b){a=a|0;b=b|0;b=i;i=i+8|0;NOc(a,b);i=b;return}function NOc(a,b){a=a|0;b=b|0;b=i;OOc(a,0);i=b;return}function OOc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;POc(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;QOc(f,0,e);e=pNc(b)|0;c[(ROc(b)|0)>>2]=e;i=d;return}function POc(a){a=a|0;var b=0;b=i;UOc(a);i=b;return}function QOc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;SOc(b,c,f);i=e;return}function ROc(a){a=a|0;i=i;return a|0}function SOc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[($Jc(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;TOc(d,b,f);i=e;return}function TOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[($Jc(e)|0)>>2];i=d;return}function UOc(a){a=a|0;var b=0;b=i;VOc(a);i=b;return}function VOc(a){a=a|0;var b=0;b=i;cKc(a);i=b;return}function WOc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=wNc(h)|0;xHc(e);if((a|0)==0){j=pNc(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(CLc(0,d,a)|0){m=l;j=c[m>>2]|0;xHc(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(CLc(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;xHc(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function XOc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];SPc(a,e);i=d;return}function YOc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=xPc(d)|0;d=zPc(n,1)|0;APc(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];yPc(j,d,h);BPc(0,JMc((CPc(j)|0)+16|0)|0,e);e=DPc(j)|0;a[e+4|0]=1;EPc(0,oPc((CPc(j)|0)+28|0)|0);a[e+5|0]=1;FPc(m,j);ZOc(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];XOc(b,g);_Oc(m);_Oc(j);i=f;return}function ZOc(a,b){a=a|0;b=b|0;var c=0;c=i;vPc(a,b);i=c;return}function _Oc(a){a=a|0;var b=0;b=i;jPc(a);i=b;return}function $Oc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;xHc(f);c[e>>2]=0;xHc(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=ROc(a)|0;b=c[c[e>>2]>>2]|0;xHc(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(pNc(a)|0)>>2]|0;hJc(e,c[d>>2]|0);d=gPc(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function aPc(a){a=a|0;var b=0,d=0;b=i;d=c[(ePc(a)|0)>>2]|0;i=b;return d|0}function bPc(a){a=a|0;var b=0,d=0;b=i;d=cPc(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function cPc(a){a=a|0;var b=0,c=0;b=i;c=dPc(a)|0;i=b;return c|0}function dPc(a){a=a|0;i=i;return a|0}function ePc(a){a=a|0;var b=0,c=0;b=i;c=fPc(a)|0;i=b;return c|0}function fPc(a){a=a|0;i=i;return a|0}function gPc(a){a=a|0;var b=0,c=0;b=i;c=hPc(a+8|0)|0;i=b;return c|0}function hPc(a){a=a|0;var b=0,c=0;b=i;c=iPc(a)|0;i=b;return c|0}function iPc(a){a=a|0;i=i;return a|0}function jPc(a){a=a|0;var b=0;b=i;kPc(a,0);i=b;return}function kPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=cPc(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}mPc(lPc(e)|0,f);i=d;return}function lPc(a){a=a|0;var b=0,c=0;b=i;c=uPc(a)|0;i=b;return c|0}function mPc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+5|0]|0)!=0){f=c[b>>2]|0;nPc(f,oPc(d+28|0)|0)}if((a[b+4|0]|0)!=0){f=c[b>>2]|0;pPc(f,JMc(d+16|0)|0)}if((d|0)==0){i=e;return}qPc(c[b>>2]|0,d,1);i=e;return}function nPc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;tPc(d,0,c);i=b;return}function oPc(a){a=a|0;i=i;return a|0}function pPc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;sPc(d,0,c);i=b;return}function qPc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;rPc(0,b,0);i=c;return}function rPc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;p4c(b);i=c;return}function sPc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;cWc(c);i=b;return}function tPc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;cWc(c);i=b;return}function uPc(a){a=a|0;i=i;return a+4|0}function vPc(a,b){a=a|0;b=b|0;var c=0;c=i;wPc(a,b);i=c;return}function wPc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function xPc(a){a=a|0;var b=0,c=0;b=i;c=QPc(a+4|0)|0;i=b;return c|0}function yPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];IPc(a,b,f);i=e;return}function zPc(a,b){a=a|0;b=b|0;var c=0;a=i;c=HPc(0,b,0)|0;i=a;return c|0}function APc(a,b){a=a|0;b=b|0;var c=0;c=i;GPc(a,b);i=c;return}function BPc(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}UVc(b,c);i=a;return}function CPc(a){a=a|0;var b=0,d=0;b=i;d=c[(ePc(a)|0)>>2]|0;i=b;return d|0}function DPc(a){a=a|0;var b=0,c=0;b=i;c=lPc(a)|0;i=b;return c|0}function EPc(a,b){a=a|0;b=b|0;a=i;if((b|0)==0){i=a;return}SVc(b);i=a;return}function FPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;vPc(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];XOc(h,f);ZOc(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];XOc(a,e);_Oc(h);i=d;return}function GPc(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function HPc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=n4c(b*40|0)|0;i=c;return a|0}function IPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(KPc(g)|0)>>2]|0;g=LPc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];JPc(b,a,f);i=e;return}function JPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];MPc(a,b,f);i=e;return}function KPc(a){a=a|0;i=i;return a|0}function LPc(a){a=a|0;i=i;return a|0}function MPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(OPc(g)|0)>>2]|0;g=PPc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];NPc(b,a,f);i=e;return}function NPc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(OPc(f)|0)>>2];f=PPc(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function OPc(a){a=a|0;i=i;return a|0}function PPc(a){a=a|0;i=i;return a|0}function QPc(a){a=a|0;var b=0,c=0;b=i;c=RPc(a)|0;i=b;return c|0}function RPc(a){a=a|0;i=i;return a|0}function SPc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=bPc(TPc(b)|0)|0;h=PPc(DPc(TPc(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];JPc(g,a,e);i=d;return}function TPc(a){a=a|0;i=i;return c[a>>2]|0}function UPc(a){a=a|0;var b=0;b=i;VPc(a);i=b;return}function VPc(a){a=a|0;var b=0;b=i;WPc(a);i=b;return}function WPc(a){a=a|0;var b=0;b=i;XPc(a,wNc(a)|0);i=b;return}function XPc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;xHc(d);if((b|0)==0){i=d;return}XPc(a,c[b>>2]|0);XPc(a,c[b+4>>2]|0);e=xPc(a)|0;YPc(e,ZPc(b+16|0)|0);qPc(e,b,1);i=d;return}function YPc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;_Pc(d,0,c);i=b;return}function ZPc(a){a=a|0;i=i;return a|0}function _Pc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;$Pc(c);i=b;return}function $Pc(a){a=a|0;var b=0;b=i;aQc(a);i=b;return}function aQc(a){a=a|0;var b=0;b=i;bQc(a);i=b;return}function bQc(a){a=a|0;var b=0;b=i;cQc(a);i=b;return}function cQc(a){a=a|0;var b=0;b=i;cWc(a+12|0);cWc(a);i=b;return}function dQc(a){a=a|0;var b=0;b=i;eQc(a+180|0);eQc(a+168|0);eQc(a+156|0);eQc(a+144|0);eQc(a+132|0);eQc(a+120|0);eQc(a+108|0);eQc(a+96|0);eQc(a+84|0);eQc(a+72|0);eQc(a+60|0);eQc(a+48|0);eQc(a+36|0);eQc(a+24|0);vLc(a+12|0);vLc(a);i=b;return}function eQc(a){a=a|0;var b=0;b=i;fQc(a);i=b;return}function fQc(a){a=a|0;var b=0;b=i;gQc(a);i=b;return}function gQc(a){a=a|0;var b=0;b=i;hQc(a);i=b;return}function hQc(a){a=a|0;var b=0;b=i;iQc(a,LOc(a)|0);i=b;return}function iQc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;xHc(d);if((b|0)==0){i=d;return}iQc(a,c[b>>2]|0);iQc(a,c[b+4>>2]|0);e=oOc(a)|0;jQc(e,kQc(b+16|0)|0);iOc(e,b,1);i=d;return}function jQc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;lQc(d,0,c);i=b;return}function kQc(a){a=a|0;i=i;return a|0}function lQc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;mQc(c);i=b;return}function mQc(a){a=a|0;var b=0;b=i;nQc(a);i=b;return}function nQc(a){a=a|0;var b=0;b=i;oQc(a);i=b;return}function oQc(a){a=a|0;var b=0;b=i;pQc(a);i=b;return}function pQc(a){a=a|0;var b=0;b=i;vLc(a+4|0);i=b;return}function qQc(a){a=a|0;var b=0;b=i;rQc(a);i=b;return}function rQc(a){a=a|0;var b=0;b=i;sQc(a);i=b;return}function sQc(a){a=a|0;var b=0;b=i;tQc(a,gMc(a)|0);i=b;return}function tQc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+8|0;xHc(d);if((b|0)==0){i=d;return}tQc(a,c[b>>2]|0);tQc(a,c[b+4>>2]|0);e=QMc(a)|0;uQc(e,VLc(b+16|0)|0);KMc(e,b,1);i=d;return}function uQc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0;b=i;i=i+16|0;d=b;e=d;f=b+8|0;a[e+0|0]=a[f+0|0]|0;vQc(d,0,c);i=b;return}function vQc(a,b,c){a=a|0;b=b|0;c=c|0;b=i;wQc(c);i=b;return}function wQc(a){a=a|0;var b=0;b=i;xQc(a);i=b;return}function xQc(a){a=a|0;var b=0;b=i;yQc(a);i=b;return}function yQc(a){a=a|0;var b=0;b=i;zQc(a);i=b;return}function zQc(a){a=a|0;var b=0;b=i;cWc(a);i=b;return}function AQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;BQc(a);DQc(g,b);EQc(h,b);b=f;j=g;c[b+0>>2]=c[j+0>>2];j=e;b=h;c[j+0>>2]=c[b+0>>2];CQc(a,f,e);i=d;return a|0}function BQc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;XPc(a,wNc(a)|0);c[(gPc(a)|0)>>2]=0;d=pNc(a)|0;c[(ROc(a)|0)>>2]=d;xHc(b);c[d>>2]=0;i=b;return}function CQc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;e=i;i=i+48|0;f=e;g=e+8|0;h=e+16|0;j=e+24|0;k=e+32|0;l=e+40|0;MQc(h,a);if(!(NQc(b,d)|0)){i=e;return}m=c[h>>2]|0;h=k;do{c[h>>2]=m;n=g;o=k;c[n+0>>2]=c[o+0>>2];FQc(j,g);o=PQc(b)|0;n=f;p=j;c[n+0>>2]=c[p+0>>2];OQc(l,a,f,o);QQc(b)|0;}while(NQc(b,d)|0);i=e;return}function DQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;KQc(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];FQc(a,e);i=d;return}function EQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;GQc(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];FQc(a,e);i=d;return}function FQc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];JQc(a,e);i=d;return}function GQc(a,b){a=a|0;b=b|0;var c=0;c=i;HQc(a,xLc(b)|0);i=c;return}function HQc(a,b){a=a|0;b=b|0;var c=0;c=i;IQc(a,b);i=c;return}function IQc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function JQc(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function KQc(a,b){a=a|0;b=b|0;var d=0;d=i;HQc(a,c[(LQc(b)|0)>>2]|0);i=d;return}function LQc(a){a=a|0;i=i;return a|0}function MQc(a,b){a=a|0;b=b|0;var c=0;c=i;EQc(a,b);i=c;return}function NQc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=WRc(a,b)|0;i=c;return d|0}function OQc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+56|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=b;c[k>>2]=c[d>>2];YQc(l,e);e=h;d=k;c[e+0>>2]=c[d+0>>2];XQc(j,m,h,l);h=g;m=j;c[h+0>>2]=c[m+0>>2];mNc(a,g);$Pc(l);i=f;return}function PQc(a){a=a|0;var b=0,c=0;b=i;c=UQc(a)|0;i=b;return c|0}function QQc(a){a=a|0;var b=0;b=i;RQc(a)|0;i=b;return a|0}function RQc(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=SQc(c[d>>2]|0)|0;i=b;return a|0}function SQc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;xHc(b);if((e|0)==0){e=a;while(1){a=lJc(e)|0;f=c[e+8>>2]|0;if(a){g=f;break}else{e=f}}i=b;return g|0}else{g=TQc(c[d>>2]|0)|0;i=b;return g|0}return 0}function TQc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a;f=c[e>>2]|0;xHc(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e;f=c[a>>2]|0;xHc(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function UQc(a){a=a|0;var b=0,d=0;b=i;d=VQc((c[a>>2]|0)+16|0)|0;i=b;return d|0}function VQc(a){a=a|0;var b=0,c=0;b=i;c=WQc(a)|0;i=b;return c|0}function WQc(a){a=a|0;i=i;return a|0}function XQc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;f=i;i=i+80|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+56|0;o=f+64|0;c[k>>2]=c[d>>2];d=h;p=k;c[d+0>>2]=c[p+0>>2];p=aRc(b,h,j,e)|0;h=c[p>>2]|0;xHc(l);if((h|0)!=0){q=h;oNc(a,q);i=f;return}cRc(o,b,e);dRc(n,o);e=g;h=n;c[e+0>>2]=c[h+0>>2];bRc(m,g);eRc(o);o=c[j>>2]|0;$Oc(b,o,p,fRc(m)|0);p=gRc(m)|0;eRc(m);q=p;oNc(a,q);i=f;return}function YQc(a,b){a=a|0;b=b|0;var c=0;c=i;ZQc(a,b);i=c;return}function ZQc(a,b){a=a|0;b=b|0;var c=0;c=i;_Qc(a,b);i=c;return}function _Qc(a,b){a=a|0;b=b|0;var c=0;c=i;$Qc(a,b);i=c;return}function $Qc(a,b){a=a|0;b=b|0;var c=0;c=i;UVc(a,b);UVc(a+12|0,b+12|0);i=c;return}function aRc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;f=i;i=i+120|0;g=f;h=f+8|0;j=f+16|0;k=f+24|0;l=f+32|0;m=f+40|0;n=f+48|0;o=f+56|0;p=f+64|0;q=f+72|0;r=f+80|0;s=f+88|0;t=f+96|0;u=f+104|0;v=f+112|0;nNc(m,a);w=k;x=m;c[w+0>>2]=c[x+0>>2];KRc(l,k);do{if(!(JRc(b,l)|0)){k=yNc(a)|0;x=MRc(b)|0;if(LRc(k,e,x)|0){break}w=LRc(k,x,e)|0;x=c[b>>2]|0;if(!w){c[d>>2]=x;y=d;i=f;return y|0}c[s>>2]=x;w=h;m=s;c[w+0>>2]=c[m+0>>2];QRc(r,h,1,0);nNc(u,a);m=g;w=u;c[m+0>>2]=c[w+0>>2];KRc(t,g);do{if(!(JRc(r,t)|0)){if(LRc(k,e,MRc(r)|0)|0){break}y=PRc(a,d,e)|0;i=f;return y|0}}while(0);k=x+4|0;w=c[k>>2]|0;xHc(v);if((w|0)==0){c[d>>2]=x;y=k;i=f;return y|0}else{k=c[r>>2]|0;c[d>>2]=k;y=k;i=f;return y|0}}}while(0);r=c[b>>2]|0;b=n;c[b>>2]=r;NRc(p,a);v=j;t=p;c[v+0>>2]=c[t+0>>2];KRc(o,j);do{if(!(JRc(n,o)|0)){j=yNc(a)|0;if(LRc(j,MRc(ORc(n)|0)|0,e)|0){break}y=PRc(a,d,e)|0;i=f;return y|0}}while(0);e=r;a=c[e>>2]|0;xHc(q);if((a|0)==0){c[d>>2]=r;y=e;i=f;return y|0}else{e=c[b>>2]|0;c[d>>2]=e;y=e+4|0;i=f;return y|0}return 0}function bRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];HRc(a,e);i=d;return}function cRc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=xPc(d)|0;d=zPc(n,1)|0;tRc(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];sRc(j,d,h);uRc(0,ZPc((vRc(j)|0)+16|0)|0,e);a[(wRc(j)|0)+4|0]=1;xRc(m,j);dRc(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];bRc(b,g);eRc(m);eRc(j);i=f;return}function dRc(a,b){a=a|0;b=b|0;var c=0;c=i;qRc(a,b);i=c;return}function eRc(a){a=a|0;var b=0;b=i;lRc(a);i=b;return}function fRc(a){a=a|0;var b=0,d=0;b=i;d=c[(jRc(a)|0)>>2]|0;i=b;return d|0}function gRc(a){a=a|0;var b=0,d=0;b=i;d=hRc(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function hRc(a){a=a|0;var b=0,c=0;b=i;c=iRc(a)|0;i=b;return c|0}function iRc(a){a=a|0;i=i;return a|0}function jRc(a){a=a|0;var b=0,c=0;b=i;c=kRc(a)|0;i=b;return c|0}function kRc(a){a=a|0;i=i;return a|0}function lRc(a){a=a|0;var b=0;b=i;mRc(a,0);i=b;return}function mRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=hRc(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}oRc(nRc(e)|0,f);i=d;return}function nRc(a){a=a|0;var b=0,c=0;b=i;c=pRc(a)|0;i=b;return c|0}function oRc(b,d){b=b|0;d=d|0;var e=0,f=0;e=i;if((a[b+4|0]|0)!=0){f=c[b>>2]|0;YPc(f,ZPc(d+16|0)|0)}if((d|0)==0){i=e;return}qPc(c[b>>2]|0,d,1);i=e;return}function pRc(a){a=a|0;i=i;return a+4|0}function qRc(a,b){a=a|0;b=b|0;var c=0;c=i;rRc(a,b);i=c;return}function rRc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function sRc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];BRc(a,b,f);i=e;return}function tRc(a,b){a=a|0;b=b|0;var c=0;c=i;ARc(a,b);i=c;return}function uRc(a,b,c){a=a|0;b=b|0;c=c|0;a=i;if((b|0)==0){i=a;return}yRc(b,c);i=a;return}function vRc(a){a=a|0;var b=0,d=0;b=i;d=c[(jRc(a)|0)>>2]|0;i=b;return d|0}function wRc(a){a=a|0;var b=0,c=0;b=i;c=nRc(a)|0;i=b;return c|0}function xRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;qRc(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];bRc(h,f);dRc(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];bRc(a,e);eRc(h);i=d;return}function yRc(a,b){a=a|0;b=b|0;var c=0;c=i;zRc(a,b);i=c;return}function zRc(a,b){a=a|0;b=b|0;var c=0;c=i;_Qc(a,b);i=c;return}function ARc(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;i=i;return}function BRc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(KPc(g)|0)>>2]|0;g=DRc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];CRc(b,a,f);i=e;return}function CRc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];ERc(a,b,f);i=e;return}function DRc(a){a=a|0;i=i;return a|0}function ERc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(OPc(g)|0)>>2]|0;g=GRc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];FRc(b,a,f);i=e;return}function FRc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(OPc(f)|0)>>2];f=GRc(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function GRc(a){a=a|0;i=i;return a|0}function HRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=gRc(IRc(b)|0)|0;h=GRc(wRc(IRc(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];CRc(g,a,e);i=d;return}function IRc(a){a=a|0;i=i;return c[a>>2]|0}function JRc(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function KRc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];VRc(a,e);i=d;return}function LRc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=CLc(0,b,c)|0;i=a;return d|0}function MRc(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function NRc(a,b){a=a|0;b=b|0;var d=0;d=i;oNc(a,c[(ROc(b)|0)>>2]|0);i=d;return}function ORc(a){a=a|0;var b=0,d=0;b=i;d=a;c[d>>2]=TRc(c[d>>2]|0)|0;i=b;return a|0}function PRc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=wNc(a)|0;xHc(e);if((h|0)==0){j=pNc(a)|0;c[b>>2]=j;k=j;i=e;return k|0}j=yNc(a)|0;a=h;while(1){h=a+16|0;if(LRc(j,d,h)|0){l=a;m=c[l>>2]|0;xHc(f);if((m|0)==0){n=5;break}else{o=l}}else{p=a;if(!(LRc(j,h,d)|0)){n=10;break}q=a+4|0;h=c[q>>2]|0;xHc(g);if((h|0)==0){n=9;break}else{o=q}}a=c[o>>2]|0}if((n|0)==5){c[b>>2]=a;k=l;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==10){c[b>>2]=p;k=b;i=e;return k|0}return 0}function QRc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;RRc(b,d);c[a>>2]=c[b>>2];i=e;return}function RRc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;SRc(b,c,e);i=d;return}function SRc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;c=i;if(!((b|0)>-1)){d=b;do{ORc(a)|0;d=d+1|0;}while((d|0)<0);i=c;return}if((b|0)>0){e=b}else{i=c;return}do{RQc(a)|0;e=e+ -1|0;}while((e|0)>0);i=c;return}function TRc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;xHc(b);if((e|0)==0){e=a;while(1){a=lJc(e)|0;f=c[e+8>>2]|0;if(a){e=f}else{g=f;break}}i=b;return g|0}else{g=URc(c[d>>2]|0)|0;i=b;return g|0}return 0}function URc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+4|0;f=c[e>>2]|0;xHc(d);if((f|0)==0){g=a;i=b;return g|0}else{h=e}while(1){e=c[h>>2]|0;a=e+4|0;f=c[a>>2]|0;xHc(d);if((f|0)==0){g=e;break}else{h=a}}i=b;return g|0}function VRc(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function WRc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(JRc(a,b)|0)^1;i=c;return d|0}function XRc(a){a=a|0;var b=0;b=i;i=i+128|0;nLc(a,b);nLc(a+12|0,b+8|0);YRc(a+24|0,b+16|0);YRc(a+36|0,b+24|0);YRc(a+48|0,b+32|0);YRc(a+60|0,b+40|0);YRc(a+72|0,b+48|0);YRc(a+84|0,b+56|0);YRc(a+96|0,b+64|0);YRc(a+108|0,b+72|0);YRc(a+120|0,b+80|0);YRc(a+132|0,b+88|0);YRc(a+144|0,b+96|0);YRc(a+156|0,b+104|0);YRc(a+168|0,b+112|0);YRc(a+180|0,b+120|0);i=b;return}function YRc(a,b){a=a|0;b=b|0;b=i;ZRc(a,0);i=b;return}function ZRc(a,b){a=a|0;b=b|0;b=i;i=i+8|0;_Rc(a,b);i=b;return}function _Rc(a,b){a=a|0;b=b|0;b=i;$Rc(a,0);i=b;return}function $Rc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;aSc(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;bSc(f,0,e);e=YNc(b)|0;c[(XNc(b)|0)>>2]=e;i=d;return}function aSc(a){a=a|0;var b=0;b=i;eSc(a);i=b;return}function bSc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;cSc(b,c,f);i=e;return}function cSc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[($Jc(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;dSc(d,b,f);i=e;return}function dSc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[($Jc(e)|0)>>2];i=d;return}function eSc(a){a=a|0;var b=0;b=i;fSc(a);i=b;return}function fSc(a){a=a|0;var b=0;b=i;cKc(a);i=b;return}function gSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=c[349324>>2]|0;if((m|0)==0){n=0}else{o=n4c(12)|0;YVc(o,m);n=o}if((c[349240>>2]|0)!=0){c[73074]=1}if((n|0)==0){c[292308>>2]=1;c[292312>>2]=1;i=b;return}do{if((AWc(n,339528,0)|0)==-1){UVc(g,n);SVc(h);o=c[72648]|0;m=(o|0)<28;while(1){p=AWc(g,339536,0)|0;q=(p|0)!=-1;if(q){yWc(j,g,0,p);dWc(h,j)|0;cWc(j);yWc(k,g,p+1|0,-1);dWc(g,k)|0;cWc(k)}else{dWc(h,g)|0}if(m){r=1;s=o}else{t=20;break}while(1){YVc(l,c[291008+(s<<2)>>2]|0);p=hSc(h,l)|0;cWc(l);if(p){c[292304+(s<<2)>>2]=1;u=0}else{u=r}p=s+1|0;if((p|0)<28){r=u;s=p}else{break}}if((u|0)!=0){t=18;break}if(!q){t=23;break}}if((t|0)==18){GBc(1,1,339544,f);if(m){v=o}else{w=292856;x=c[73214]|0;fe[x&1023](1);y=zWc(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=339584;E=D;IBc(0,E,a)}do{p=c[292176+(v<<2)>>2]|0;c[e>>2]=c[291008+(v<<2)>>2];c[e+4>>2]=p;GBc(1,0,339568,e);v=v+1|0;}while((v|0)<28);w=292856;x=c[73214]|0;fe[x&1023](1);y=zWc(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=339584;E=D;IBc(0,E,a)}else if((t|0)==20){GBc(1,1,339544,d);w=292856;x=c[73214]|0;fe[x&1023](1);y=zWc(n)|0;z=a;A=z;c[A>>2]=y;B=5;C=B;D=339584;E=D;IBc(0,E,a)}else if((t|0)==23){cWc(h);cWc(g);break}}else{o=1;do{c[292304+(o<<2)>>2]=1;o=o+1|0;}while((o|0)<28)}}while(0);c[292308>>2]=1;c[292312>>2]=1;if((c[292340>>2]|0)!=0){c[292400>>2]=1}if((c[292396>>2]|0)==1){c[292404>>2]=1}if((c[292376>>2]|0)!=0){c[292372>>2]=1}if((c[292384>>2]|0)!=0){c[292372>>2]=1}if((c[292336>>2]|0)!=0){c[292332>>2]=1}if((c[292380>>2]|0)!=0){c[292372>>2]=1}if((c[292328>>2]|0)!=0){c[292324>>2]=1}cWc(n);p4c(n);i=b;return}function hSc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;e=aWc(b)|0;if((e|0)!=(aWc(c)|0)){f=0;i=d;return f|0}g=bWc(b)|0;h=bWc(c)|0;if(VVc(b)|0){f=(ELc(g,h,e)|0)==0;i=d;return f|0}if((e|0)==0){f=1;i=d;return f|0}else{j=e;k=g;l=h}while(1){if((a[k]|0)!=(a[l]|0)){f=0;m=7;break}h=j+ -1|0;if((h|0)==0){f=1;m=7;break}else{j=h;k=k+1|0;l=l+1|0}}if((m|0)==7){i=d;return f|0}return 0}function iSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;a=b;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;h=c[349332>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=n4c(12)|0;l=k;YVc(l,h);if((k|0)==0){j=1;i=b;return j|0}else{m=1}while(1){k=m+1|0;if(jSc(l,c[324624+(m<<2)>>2]|0)|0){j=m;n=6;break}if((k|0)<4){m=k}else{n=5;break}}if((n|0)==5){c[g>>2]=zWc(l)|0;GBc(1,1,339616,g);g=c[324708>>2]|0;c[f>>2]=c[324628>>2];c[f+4>>2]=g;GBc(1,0,339568,f);f=c[324712>>2]|0;c[e>>2]=c[324632>>2];c[e+4>>2]=f;GBc(1,0,339568,e);e=c[324716>>2]|0;c[d>>2]=c[324636>>2];c[d+4>>2]=e;GBc(1,0,339568,d);fe[c[73214]&1023](1);IBc(0,339672,a)}else if((n|0)==6){i=b;return j|0}return 0}function jSc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(CWc(a,b)|0)==0;i=c;return d|0}function kSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;b=i;i=i+8|0;a=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+16|0;g=i;i=i+16|0;h=c[349316>>2]|0;if((h|0)==0){j=1;i=b;return j|0}k=n4c(12)|0;l=k;YVc(l,h);if((k|0)==0){j=1;i=b;return j|0}YVc(f,339696);k=hSc(l,f)|0;cWc(f);if(k){j=1;i=b;return j|0}YVc(g,339704);k=hSc(l,g)|0;cWc(g);if(k){j=2;i=b;return j|0}else{c[e>>2]=zWc(l)|0;GBc(1,1,339712,e);c[d>>2]=339696;c[d+4>>2]=339768;GBc(1,0,339568,d);c[a>>2]=339704;c[a+4>>2]=339784;GBc(1,0,339568,a);fe[c[73214]&1023](1);IBc(0,339672,b)}return 0}function lSc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+32|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;lYc(f,a);if(!(oYc(f)|0)){mYc(f);i=d;return a|0}j=MLc(b)|0;ySc(g,a);k=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;l=k;if(((BHc(l)|0)&176|0)==32){m=b+j|0}else{m=b}n=YWc(k)|0;k=b+j|0;j=e;o=g;c[j+0>>2]=c[o+0>>2];BSc(h,e,b,m,k,l,n);if(!(zSc(h)|0)){mYc(f);i=d;return a|0}SWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,5);mYc(f);i=d;return a|0}function mSc(a){a=a|0;var b=0;b=i;rYc(a,ZWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,10)|0)|0;_Xc(a)|0;i=b;return a|0}function nSc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;f=i;i=i+2128|0;g=f;h=f+32|0;j=f+48|0;k=f+64|0;l=f+80|0;YVc(h,d);NWc(k,339792,h);ZKc(j,k,339800);cWc(k);k=zWc(j)|0;d=b+104|0;do{if((c[d>>2]|0)>0){m=b;n=c[m>>2]|0;if((H4c(c[n+4>>2]|0,339808)|0)!=0){break}a[n+104|0]=1;a[(c[m>>2]|0)+((c[d>>2]|0)*112|0)+104|0]=1}}while(0);if((H4c(k,339816)|0)==0){cWc(j);cWc(h);i=f;return}d=p3c(g,k,1)|0;if((d|0)!=0){m=l;P4c(m|0,0,2048)|0;C3c(d,g,m,2048)|0;pYc(lSc(lSc(lSc(lSc(lSc(361720,339824)|0,k)|0,339864)|0,m)|0,339880)|0,103)|0;cWc(j);cWc(h);i=f;return}m=b+108|0;k=c[m>>2]|0;if((k|0)>0){d=b;l=k;k=0;while(1){n=c[d>>2]|0;if((a[n+(k*112|0)+104|0]|0)==0){o=(D3c(g,c[n+(k*112|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(k*112|0)+104|0]=o;p=c[m>>2]|0}else{p=l}o=k+1|0;if((o|0)<(p|0)){l=p;k=o}else{break}}}k=b+208|0;if((c[k>>2]|0)>0){p=b+32|0;l=b;m=(e|0)==0;d=b+16|0;o=0;do{n=c[p>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){q=a[n+(o*52|0)+8|0]|0;if(q<<24>>24==0){r=(D3c(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=r;r=c[p>>2]|0;if((a[r+(o*52|0)+48|0]|0)!=0){break}a[(c[l>>2]|0)+((c[r+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else if(q<<24>>24==1){q=(D3c(g,c[n+(o*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[p>>2]|0)+(o*52|0)+48|0]=q;q=c[p>>2]|0;if((a[q+(o*52|0)+48|0]|0)!=0|m){break}a[(c[d>>2]|0)+((c[q+(o*52|0)+4>>2]|0)*112|0)+104|0]=0;break}else{break}}}while(0);o=o+1|0;}while((o|0)<(c[k>>2]|0))}k=b+116|0;o=c[k>>2]|0;if((o|0)>0){d=b+4|0;m=o;o=0;while(1){p=c[d>>2]|0;if((a[p+(o*60|0)+56|0]|0)==0){l=(D3c(g,c[p+(o*60|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(o*60|0)+56|0]=l;s=c[k>>2]|0}else{s=m}l=o+1|0;if((l|0)<(s|0)){m=s;o=l}else{break}}}o=b+212|0;if((c[o>>2]|0)>0){s=b+36|0;m=b+4|0;k=(e|0)==0;d=b+20|0;l=0;do{p=c[s>>2]|0;do{if((a[p+(l*52|0)+48|0]|0)==0){n=a[p+(l*52|0)+8|0]|0;if(n<<24>>24==0){q=(D3c(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=q;q=c[s>>2]|0;if((a[q+(l*52|0)+48|0]|0)!=0){break}a[(c[m>>2]|0)+((c[q+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else if(n<<24>>24==1){n=(D3c(g,c[p+(l*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[s>>2]|0)+(l*52|0)+48|0]=n;n=c[s>>2]|0;if((a[n+(l*52|0)+48|0]|0)!=0|k){break}a[(c[d>>2]|0)+((c[n+(l*52|0)+4>>2]|0)*60|0)+56|0]=0;break}else{break}}}while(0);l=l+1|0;}while((l|0)<(c[o>>2]|0))}o=b+120|0;l=c[o>>2]|0;if((l|0)>0){d=b+8|0;k=l;l=0;while(1){s=c[d>>2]|0;if((a[s+(l*48|0)+44|0]|0)==0){m=(D3c(g,c[s+(l*48|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[d>>2]|0)+(l*48|0)+44|0]=m;t=c[o>>2]|0}else{t=k}m=l+1|0;if((m|0)<(t|0)){k=t;l=m}else{break}}}l=b+216|0;if((c[l>>2]|0)>0){t=b+40|0;k=b+8|0;o=(e|0)==0;d=b+24|0;m=0;do{s=c[t>>2]|0;do{if((a[s+(m*52|0)+48|0]|0)==0){p=a[s+(m*52|0)+8|0]|0;if(p<<24>>24==1){n=(D3c(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=n;n=c[t>>2]|0;if((a[n+(m*52|0)+48|0]|0)!=0|o){break}a[(c[d>>2]|0)+((c[n+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else if(p<<24>>24==0){p=(D3c(g,c[s+(m*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[t>>2]|0)+(m*52|0)+48|0]=p;p=c[t>>2]|0;if((a[p+(m*52|0)+48|0]|0)!=0){break}a[(c[k>>2]|0)+((c[p+(m*52|0)+4>>2]|0)*48|0)+44|0]=0;break}else{break}}}while(0);m=m+1|0;}while((m|0)<(c[l>>2]|0))}l=b+124|0;m=c[l>>2]|0;if((m|0)>0){k=b+12|0;t=m;m=0;while(1){d=c[k>>2]|0;if((a[d+(m*52|0)+48|0]|0)==0){o=(D3c(g,c[d+(m*52|0)+4>>2]|0,0,0,0)|0)!=0|0;a[(c[k>>2]|0)+(m*52|0)+48|0]=o;u=c[l>>2]|0}else{u=t}o=m+1|0;if((o|0)<(u|0)){t=u;m=o}else{break}}}m=b+220|0;if((c[m>>2]|0)>0){u=b+44|0;t=b+12|0;l=(e|0)==0;e=b+28|0;b=0;do{k=c[u>>2]|0;do{if((a[k+(b*52|0)+48|0]|0)==0){o=a[k+(b*52|0)+8|0]|0;if(o<<24>>24==0){d=(D3c(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=d;d=c[u>>2]|0;if((a[d+(b*52|0)+48|0]|0)!=0){break}a[(c[t>>2]|0)+((c[d+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else if(o<<24>>24==1){o=(D3c(g,c[k+(b*52|0)+16>>2]|0,0,0,0)|0)!=0|0;a[(c[u>>2]|0)+(b*52|0)+48|0]=o;o=c[u>>2]|0;if((a[o+(b*52|0)+48|0]|0)!=0|l){break}a[(c[e>>2]|0)+((c[o+(b*52|0)+4>>2]|0)*52|0)+48|0]=0;break}else{break}}}while(0);b=b+1|0;}while((b|0)<(c[m>>2]|0))}t3c(g);cWc(j);cWc(h);i=f;return}function oSc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0.0,O=0.0,P=0,Q=0,R=0;b=i;i=i+8|0;a=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;y=i;i=i+16|0;z=i;i=i+16|0;A=i;i=i+16|0;B=i;i=i+16|0;C=i;i=i+16|0;D=i;i=i+16|0;E=i;i=i+16|0;F=i;i=i+16|0;G=c[349180>>2]|0;H=c[349308>>2]|0;I=c[2]|0;if((c[292404>>2]|0)==0){if(!((c[349128>>2]|0)==0|(I|0)!=0)){J=3}}else{J=3}if((J|0)==3){c[2]=1}J=d+248|0;K=d+240|0;L=~~+Bb(+((+h[J>>3]- +h[K>>3])/+h[d+264>>3]));c[d+256>>2]=L;c[l>>2]=L;EBc(23,0,339928,l);l=c[349252>>2]|0;do{if((l|0)==0){M=0}else{if((H4c(l,339952)|0)==0){M=1;break}if((H4c(l,339960)|0)==0){M=0;break}if((H4c(l,339968)|0)==0){M=2;break}c[j>>2]=l;GBc(1,0,339976,j);M=0}}while(0);if((ZCc(M)|0)!=0){c[g>>2]=l;GBc(1,0,340048,g)}if((c[2]|0)!=0){wTc(d+56|0);cDc((c[d+64>>2]|0)+13+(c[d+68>>2]|0)+(c[d+72>>2]|0)|0);_Cc(0);_Cc(6);$Cc(3);$Cc(4);$Cc(1)}g=(G|0)!=0;if(g){if((H|0)==0){N=+h[K>>3]}else{N=+D4c(H)}h[J>>3]=N;J=f;h[k>>3]=N;c[J>>2]=c[k>>2];c[J+4>>2]=c[k+4>>2];EBc(1,0,340136,f)}do{if((c[349236>>2]|0)!=0){f=n4c(12)|0;J=f;YVc(J,c[349364>>2]|0);if((f|0)==0){break}f=zWc(J)|0;c[d+280>>2]=f;c[e>>2]=f;EBc(23,0,340192,e)}}while(0);e=c[349360>>2]|0;SVc(m);if((e|0)==0){YVc(p,c[d+88>>2]|0);YVc(q,340240);pSc(o,p,q);ZKc(n,o,c[d+284>>2]|0);dWc(m,n)|0;cWc(n);cWc(o);cWc(q);cWc(p)}else{eWc(m,e)|0}YVc(r,340248);YVc(s,340248);YVc(t,340248);YVc(u,340248);YVc(v,340248);YVc(w,340248);e=c[349128>>2]|0;if((c[349148>>2]|0)!=0){eWc(r,c[349276>>2]|0)|0}if((c[349164>>2]|0)!=0){eWc(s,c[349292>>2]|0)|0}if((c[349144>>2]|0)!=0){eWc(t,c[349272>>2]|0)|0}if((c[349152>>2]|0)==0){O=0.0}else{eWc(u,c[349280>>2]|0)|0;O=+D4c(zWc(u)|0)}if((c[349156>>2]|0)==0){P=1}else{eWc(v,c[349284>>2]|0)|0;P=Fc(zWc(v)|0)|0}if((c[349216>>2]|0)!=0){eWc(w,c[349344>>2]|0)|0}UVc(x,m);UVc(y,r);UVc(z,s);UVc(A,t);UVc(B,w);p=qSc(d,x,y,z,A,O,P,B,e)|0;cWc(B);cWc(A);cWc(z);cWc(y);cWc(x);if((p|0)!=0|g^1){Q=p}else{_Cc(5);p=NSc(d)|0;bDc(5);EBc(1,0,340256,a);Q=p}c[2]=I;if(!((Q|0)==0&(I|0)!=0)){R=Q;cWc(w);cWc(v);cWc(u);cWc(t);cWc(s);cWc(r);cWc(m);i=b;return R|0}Q=d+88|0;YVc(D,c[Q>>2]|0);ZKc(C,D,340288);cWc(D);YVc(F,c[Q>>2]|0);ZKc(E,F,340304);cWc(F);bDc(0);F=c[349328>>2]|0;Q=zWc(C)|0;D=zWc(E)|0;I=c[d+280>>2]|0;p=c[d+284>>2]|0;kTc(d,Q,D,(F|0)!=0?F:340320,I,p,zWc(m)|0)|0;cWc(E);cWc(C);R=0;cWc(w);cWc(v);cWc(u);cWc(t);cWc(s);cWc(r);cWc(m);i=b;return R|0}function pSc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0,f=0;d=i;i=i+8|0;TVc(a,d);e=aWc(b)|0;f=aWc(c)|0;DWc(a,bWc(b)|0,e,f+e|0);vWc(a,bWc(c)|0,f)|0;i=d;return}function qSc(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=+g;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;l=i;i=i+8|0;m=l;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;if((aWc(j)|0)==0){u=0}else{u=zWc(j)|0}UVc(r,b);b=(rSc(a,r,k)|0)==0;cWc(r);if(!b){v=-1;i=l;return v|0}YVc(s,340248);b=a+280|0;r=jSc(s,c[b>>2]|0)|0;cWc(s);do{if(r){w=3}else{s=1;k=0;do{YVc(t,c[340464+(s<<2)>>2]|0);j=jSc(t,c[b>>2]|0)|0;cWc(t);k=j?s:k;s=s+1|0;}while((s|0)<20);if((k|0)!=0){w=k;break}c[q>>2]=c[b>>2];GBc(1,0,340544,q);GBc(1,0,339544,p);s=1;do{j=c[340576+(s<<2)>>2]|0;c[o>>2]=c[340464+(s<<2)>>2];c[o+4>>2]=j;GBc(1,0,339568,o);s=s+1|0;}while((s|0)<20);IBc(c[a+536>>2]|0,339672,n)}}while(0);c[m>>2]=c[340464+(w<<2)>>2];EBc(23,0,340656,m);m=zWc(d)|0;d=zWc(e)|0;e=QFc(a,m,d,zWc(f)|0,g,h,w,u)|0;ge[c[333908>>2]&255](333880,a);v=e;i=l;return v|0}



function mGc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0.0,T=0,V=0,W=0;d=i;i=i+8|0;e=d;f=c[b+60>>2]|0;g=b+40|0;if((c[g>>2]|0)==0){i=d;return}j=b+52|0;k=c[j>>2]|0;if((k|0)==0){i=d;return}l=b+56|0;m=c[l>>2]|0;if((m|0)==0){i=d;return}n=b+16|0;o=c[n>>2]|0;p=j4c(o,8)|0;q=j4c(o,8)|0;r=b+20|0;s=c[r>>2]|0;t=j4c(s,8)|0;u=j4c(s,8)|0;v=j4c(o,8)|0;w=j4c(s,8)|0;if((o|0)>0){x=0;do{h[k+(x<<3)>>3]=1.0;x=x+1|0;}while((x|0)<(o|0))}if((s|0)>0){o=0;do{h[m+(o<<3)>>3]=1.0;o=o+1|0;}while((o|0)<(s|0))}+aGc(b,1.0);s=c[n>>2]|0;if((s|0)>0){N4c(p|0,c[b+48>>2]|0,((s|0)>1?s<<3:8)|0)|0}o=f+8|0;m=f+116|0;x=c[m>>2]|0;if((x|0)>0){k=c[o>>2]|0;y=f+4|0;z=0;A=0;while(1){if((a[k+(z*112|0)+88|0]|0)==0){B=A}else{h[t+(A<<3)>>3]=+h[k+(z*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(z<<3)>>3];B=A+1|0}C=z+1|0;if((C|0)<(x|0)){z=C;A=B}else{D=B;break}}}else{D=0}B=f+136|0;A=c[B>>2]|0;if((A|0)>0){z=c[f+24>>2]|0;y=f+4|0;k=0;C=D;while(1){do{if((a[z+(k*112|0)+88|0]|0)==0){E=C}else{if((a[z+(k*112|0)+72|0]|0)!=0){E=C;break}h[t+(C<<3)>>3]=+h[z+(k*112|0)+96>>3]- +h[(c[(c[c[y>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3];E=C+1|0}}while(0);F=k+1|0;if((F|0)<(A|0)){k=F;C=E}else{G=E;break}}}else{G=D}D=f+120|0;E=c[D>>2]|0;if((E|0)>0){C=c[o>>2]|0;k=f+4|0;A=x-E|0;E=G;while(1){do{if((a[C+(A*112|0)+88|0]|0)==0){H=E}else{if((a[C+(A*112|0)+72|0]|0)!=0){H=E;break}h[t+(E<<3)>>3]=+h[C+(A*112|0)+96>>3]- +h[(c[(c[c[k>>2]>>2]|0)+8>>2]|0)+(A<<3)>>3];H=E+1|0}}while(0);G=A+1|0;if((G|0)<(x|0)){A=G;E=H}else{break}}}H=b;if((c[H>>2]|0)>0){E=b+24|0;A=o;o=f+4|0;x=f+24|0;f=b+48|0;k=c[E>>2]|0;C=0;while(1){G=k+(C<<3)|0;h[G>>3]=+h[G>>3]+1.0e-6;+aGc(b,1.0);G=c[n>>2]|0;y=(G|0)>0;if(y){N4c(q|0,c[f>>2]|0,((G|0)>1?G<<3:8)|0)|0}z=c[m>>2]|0;if((z|0)>0){F=c[A>>2]|0;I=0;J=0;while(1){if((a[F+(J*112|0)+88|0]|0)==0){K=I}else{h[u+(I<<3)>>3]=+h[F+(J*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(J<<3)>>3];K=I+1|0}L=J+1|0;if((L|0)<(z|0)){I=K;J=L}else{M=K;break}}}else{M=0}J=c[B>>2]|0;if((J|0)>0){I=c[x>>2]|0;F=M;L=0;while(1){do{if((a[I+(L*112|0)+88|0]|0)==0){N=F}else{if((a[I+(L*112|0)+72|0]|0)!=0){N=F;break}h[u+(F<<3)>>3]=+h[I+(L*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(L<<3)>>3];N=F+1|0}}while(0);O=L+1|0;if((O|0)<(J|0)){F=N;L=O}else{P=N;break}}}else{P=M}L=c[D>>2]|0;if((L|0)>0){F=c[A>>2]|0;J=P;I=z-L|0;while(1){do{if((a[F+(I*112|0)+88|0]|0)==0){Q=J}else{if((a[F+(I*112|0)+72|0]|0)!=0){Q=J;break}h[u+(J<<3)>>3]=+h[F+(I*112|0)+96>>3]- +h[(c[(c[c[o>>2]>>2]|0)+8>>2]|0)+(I<<3)>>3];Q=J+1|0}}while(0);L=I+1|0;if((L|0)<(z|0)){J=Q;I=L}else{break}}}if(y){R=+h[(c[g>>2]|0)+(C<<3)>>3];I=0;do{S=+U(+(R*(+h[q+(I<<3)>>3]- +h[p+(I<<3)>>3])/1.0e-6));J=v+(I<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}I=I+1|0;}while((I|0)<(G|0))}I=c[r>>2]|0;if((I|0)>0){R=+h[(c[g>>2]|0)+(C<<3)>>3];y=0;do{S=+U(+(R*(+h[u+(y<<3)>>3]- +h[t+(y<<3)>>3])/1.0e-6));J=w+(y<<3)|0;if(S>+h[J>>3]){h[J>>3]=S}y=y+1|0;}while((y|0)<(I|0))}I=c[E>>2]|0;y=I+(C<<3)|0;h[y>>3]=+h[y>>3]+-1.0e-6;y=C+1|0;if((y|0)<(c[H>>2]|0)){k=I;C=y}else{T=G;break}}}else{T=s}if((T|0)>0){s=T;T=0;while(1){R=+h[v+(T<<3)>>3];C=(c[j>>2]|0)+(T<<3)|0;if(R<1.0e-42){h[C>>3]=1.0;k=T+1|0;c[e>>2]=k;EBc(9,0,332936,e);V=k;W=c[n>>2]|0}else{h[C>>3]=R;V=T+1|0;W=s}if((V|0)<(W|0)){s=W;T=V}else{break}}}V=c[r>>2]|0;if((V|0)>0){r=c[l>>2]|0;l=0;do{R=+h[w+(l<<3)>>3];h[r+(l<<3)>>3]=R<1.0e-42?1.0:R;l=l+1|0;}while((l|0)<(V|0))}i4c(p);i4c(q);i4c(t);i4c(u);i4c(v);i4c(w);i=d;return}function nGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+24>>2]|0;a=0;do{h[f+(a<<3)>>3]=+h[b+(a<<3)>>3];a=a+1|0;}while((a|0)<(e|0));i=d;return}function oGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0.0,l=0.0;d=i;e=c[a>>2]|0;if((e|0)<=0){i=d;return}f=c[a+40>>2]|0;g=(f|0)==0;j=c[a+24>>2]|0;a=0;do{k=+h[b+(a<<3)>>3];if(g){l=k}else{l=k*+h[f+(a<<3)>>3]}h[j+(a<<3)>>3]=l;a=a+1|0;}while((a|0)<(e|0));i=d;return}function pGc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;e=c[b+60>>2]|0;f=c[e+112>>2]|0;if((f|0)>0){g=b+24|0;j=c[e+8>>2]|0;k=0;l=0;while(1){if((a[j+(k*112|0)+72|0]|0)==0){h[(c[(c[c[e+4>>2]>>2]|0)+8>>2]|0)+(k<<3)>>3]=+h[(c[g>>2]|0)+(l<<3)>>3];m=l+1|0}else{m=l}n=k+1|0;if((n|0)<(f|0)){k=n;l=m}else{o=m;break}}}else{o=0}m=c[e+136>>2]|0;if((m|0)>0){l=b+24|0;k=c[e+24>>2]|0;f=0;g=o;while(1){if((a[k+(f*112|0)+72|0]|0)==0){h[(c[e+416>>2]|0)+(f<<3)>>3]=+h[(c[l>>2]|0)+(g<<3)>>3];p=g+1|0}else{p=g}j=f+1|0;if((j|0)<(m|0)){f=j;g=p}else{q=p;break}}}else{q=o}o=c[e+116>>2]|0;p=c[e+120>>2]|0;if((p|0)<=0){i=d;return}g=b+24|0;b=c[e+8>>2]|0;f=o-p|0;p=q;while(1){if((a[b+(f*112|0)+72|0]|0)==0){h[(c[e+400>>2]|0)+(f<<3)>>3]=+h[(c[g>>2]|0)+(p<<3)>>3];r=p+1|0}else{r=p}q=f+1|0;if((q|0)<(o|0)){f=q;p=r}else{break}}i=d;return}function qGc(a,b,d){a=a|0;b=b|0;d=d|0;d=i;i=i+8|0;IBc(c[a+536>>2]|0,333008,d);return 0}function rGc(a){a=a|0;a=i;i=i+8|0;IBc(0,333040,a);return 0}function sGc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0;b=i;i=i+8|0;d=i;i=i+8|0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;c[d>>2]=(c[292340>>2]|0)!=0?1e3:0;k=a;l=c[k>>2]|0;c[e>>2]=l*1e3;h[f>>3]=1.0e-12;h[g>>3]=10.0;m=l<<1|1;c[j>>2]=m;n=j4c((fa(m+13|0,m+l|0)|0)+((fa(l*3|0,l+3|0)|0)/2|0)|0,8)|0;HBc(0,(n|0)!=0|0,333080,b);c[83274]=c[a+60>>2];c[83276]=c[a+48>>2];QDc(k,j,c[a+24>>2]|0,g,f,d,e,n,6)|0;i4c(n);c[83274]=0;c[83276]=0;n=$Fc(a)|0;i=b;return n|0}function tGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[83276];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[83274];h[d>>3]=+aGc(f,1.0);i=e;return}function uGc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0.0,D=0.0,E=0,F=0;b=i;i=i+8|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;h[o>>3]=0.0;h[p>>3]=0.0;h[q>>3]=0.0;c[r>>2]=0;c[s>>2]=0;c[t>>2]=0;c[u>>2]=0;c[v>>2]=0;w=a;x=c[w>>2]<<3;y=h4c(x)|0;z=y;A=h4c(x)|0;x=A;HBc(0,(y|0)!=0|0,333112,n);HBc(0,(A|0)!=0|0,333112,m);m=c[w>>2]|0;if((m|0)>0){n=c[a+24>>2]|0;B=0;do{C=+h[n+(B<<3)>>3];if(C!=0.0){D=+U(+C)/1.0e3}else{D=1.0}h[y+(B<<3)>>3]=D;h[A+(B<<3)>>3]=0.0;B=B+1|0;}while((B|0)<(m|0))}B=m*1e3|0;c[v>>2]=B;if((c[292340>>2]|0)==0){E=-1}else{E=(B|0)/10|0}c[r>>2]=E;h[p>>3]=1.0e-12;c[s>>2]=m;c[t>>2]=0;h[q>>3]=1.0e-12;D=+aGc(a,1.0);h[o>>3]=D;if(D!=0.0){c[83282]=c[a+60>>2];c[83284]=c[a+48>>2];NDc(c[a+24>>2]|0,z,w,o,v,r,p,s,t,q,x,7,u)|0;c[83282]=0;c[83284]=0}else{x=l;h[k>>3]=D;c[x>>2]=c[k>>2];c[x+4>>2]=c[k+4>>2];EBc(9,0,333144,l)}D=+aGc(a,1.0);h[o>>3]=D;l=j;h[k>>3]=D;c[l>>2]=c[k>>2];c[l+4>>2]=c[k+4>>2];EBc(9,0,333248,j);j=c[u>>2]|0;do{if((j|0)==1){if(!(+h[q>>3]<+h[o>>3])){break}c[g>>2]=c[v>>2];GBc(9,0,333264,g);F=-1;i=b;return F|0}else if((j|0)==3){GBc(9,0,333408,e);F=-3;i=b;return F|0}else if((j|0)==2){GBc(9,0,333344,f);F=-2;i=b;return F|0}else if((j|0)==4){GBc(9,0,333480,d);F=-4;i=b;return F|0}}while(0);F=$Fc(a)|0;i=b;return F|0}function vGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+64|0;f=e;c[f>>2]=c[a>>2];c[f+4>>2]=-1;c[f+8>>2]=-1;c[f+16>>2]=0;c[f+20>>2]=0;c[f+24>>2]=b;b=f+28|0;c[b+0>>2]=0;c[b+4>>2]=0;c[b+8>>2]=0;c[b+12>>2]=0;c[b+16>>2]=0;c[f+48>>2]=c[83284];c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=c[83282];h[d>>3]=+aGc(f,1.0);i=e;return}function wGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=fa(d*1e3|0,c[a>>2]|0)|0;c[j>>2]=0;EBc(9,1,333536,g);if((c[292340>>2]|0)==0){l=0}else{l=(k|0)/10|0}xGc(a,d,k,l,b,j);c[f>>2]=c[j>>2];EBc(9,0,333560,f);fe[c[73214]&1023](9);if(+h[b>>3]<1.0){m=-1;i=e;return m|0}b=$Fc(a)|0;if((b|0)==0){m=0;i=e;return m|0}GBc(9,0,333576,e);m=b;i=e;return m|0}function xGc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,V=0,W=0,X=0,Y=0.0,Z=0,_=0,$=0,aa=0.0,ba=0,ca=0.0,da=0.0,ea=0.0,ga=0.0,ha=0.0,ia=0,ja=0,ka=0,la=0,ma=0.0,na=0,oa=0,pa=0,qa=0.0,ra=0,sa=0.0,ta=0,ua=0,va=0.0,wa=0,xa=0.0,ya=0.0,za=0.0,Aa=0,Ba=0.0,Ca=0;j=i;i=i+8|0;l=j;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+24|0;v=i;i=i+32|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+8|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+8|0;J=i;i=i+4096|0;K=a;L=c[K>>2]|0;M=L+1|0;N=L<<3;O=h4c(fa(N,M)|0)|0;P=h4c(M<<3)|0;Q=h4c(N)|0;R=Q;S=h4c(N)|0;T=S;V=h4c(N)|0;W=V;X=h4c(N)|0;Y=+h[f>>3];if((c[292340>>2]|0)!=0&Y<1.0){N=J;c[I>>2]=c[(c[a+60>>2]|0)+88>>2];hc(N|0,333624,I|0)|0;I=ic(N|0,333640)|0;c[H>>2]=333656;wd(I|0,333648,H|0)|0;c[G>>2]=333672;wd(I|0,333648,G|0)|0;if((c[K>>2]|0)>0){G=a+44|0;H=0;do{c[F>>2]=c[(c[G>>2]|0)+(H<<2)>>2];wd(I|0,333648,F|0)|0;H=H+1|0;}while((H|0)<(c[K>>2]|0))}Sd(10,I|0)|0;c[E>>2]=0;wd(I|0,333680,E|0)|0;E=D;h[k>>3]=Y;c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(I|0,333688,D|0)|0;if((c[K>>2]|0)>0){D=a+24|0;E=0;do{H=C;h[k>>3]=+h[(c[D>>2]|0)+(E<<3)>>3];c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];wd(I|0,333688,C|0)|0;E=E+1|0;}while((E|0)<(c[K>>2]|0))}Sd(10,I|0)|0;Z=I}else{Z=0}HBc(0,(O|0)!=0|0,333696,B);HBc(0,(P|0)!=0|0,333696,A);HBc(0,(Q|0)!=0|0,333696,z);HBc(0,(S|0)!=0|0,333696,y);HBc(0,(V|0)!=0|0,333696,x);HBc(0,(X|0)!=0|0,333696,w);w=c[a+40>>2]|0;x=(L|0)>0;do{if((w|0)==0){if(!x){_=0;break}y=a+24|0;z=0;while(1){A=(c[y>>2]|0)+(z<<3)|0;B=0;do{h[O+((fa(B,L)|0)+z<<3)>>3]=+h[A>>3];B=B+1|0;}while((B|0)<(M|0));B=z+1|0;if((B|0)<(L|0)){z=B}else{$=14;break}}}else{if(!x){_=0;break}z=c[a+24>>2]|0;y=0;while(1){aa=+h[z+(y<<3)>>3]/+h[w+(y<<3)>>3];B=0;do{h[O+((fa(B,L)|0)+y<<3)>>3]=aa;B=B+1|0;}while((B|0)<(M|0));B=y+1|0;if((B|0)<(L|0)){y=B}else{$=14;break}}}}while(0);do{if(($|0)==14){w=(L|0)>0;if(w){ba=0}else{_=0;break}while(1){x=O+((fa(ba,L)|0)+ba<<3)|0;h[x>>3]=+h[x>>3]+1.0;x=ba+1|0;if((x|0)<(L|0)){ba=x}else{_=w;break}}}}while(0);ba=(L|0)>-1;w=a+16|0;aa=+(M|0);ca=+(L|0);x=(e|0)==0;y=a+48|0;da=1.0/+(b+ -1|0);b=(Z|0)==0;z=a+24|0;B=L<<3;ea=0.0;A=0;ga=Y;a:while(1){I=!(ga>=1.0);E=ga<1.0;ha=ea;C=A;b:while(1){D=C;c:while(1){ia=D+1|0;if(ba){H=0;do{oGc(a,O+((fa(H,L)|0)<<3)|0);h[P+(H<<3)>>3]=+aGc(a,ga);H=H+1|0;}while((H|0)<(M|0))}if(_){H=1;F=0;while(1){G=+h[P+(H<<3)>>3]<+h[P+(F<<3)>>3]?H:F;N=H+1|0;if((N|0)<(M|0)){F=G;H=N}else{ja=G;break}}}else{ja=0}ka=fa(ja,L)|0;la=O+(ka<<3)|0;oGc(a,la);+aGc(a,ga);H=c[w>>2]|0;if((H|0)>0){F=c[y>>2]|0;Y=0.0;G=0;do{ma=+U(+(+h[F+(G<<3)>>3]));Y=ma>Y?ma:Y;G=G+1|0;}while((G|0)<(H|0));na=!(Y<1.0e-12)}else{na=0}if(!((na|I)&(D|0)<(d|0))){break a}do{if(ba){H=0;G=ja;F=ja;while(1){ma=+h[P+(H<<3)>>3];N=ma>+h[P+(G<<3)>>3];oa=N?H:G;J=N?G:F;pa=!(ma>+h[P+(J<<3)>>3])|(H|0)==(oa|0)?J:H;J=H+1|0;if((J|0)<(M|0)){F=pa;G=oa;H=J}else{break}}if(ba){qa=0.0;ra=0}else{sa=0.0;ta=oa;ua=pa;break}do{qa=qa+ +h[P+(ra<<3)>>3];ra=ra+1|0;}while((ra|0)<(M|0));ma=qa/aa;if(ba){va=0.0;wa=0}else{sa=0.0;ta=oa;ua=pa;break}while(1){xa=+h[P+(wa<<3)>>3]-ma;ya=va+xa*xa;H=wa+1|0;if((H|0)<(M|0)){wa=H;va=ya}else{sa=ya;ta=oa;ua=pa;break}}}else{sa=0.0;ta=ja;ua=ja}}while(0);Y=sa/ca;do{if(!x){if(((ia|0)%(e|0)|0|0)!=0){break}ma=+h[P+(ja<<3)>>3];ya=+h[P+(ta<<3)>>3];H=v;h[k>>3]=ga;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];c[v+8>>2]=ia;H=v+12|0;h[k>>3]=ma;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];H=v+20|0;h[k>>3]=ya;c[H>>2]=c[k>>2];c[H+4>>2]=c[k+4>>2];EBc(9,0,333712,v)}}while(0);if(Y<1.0e-8&E){break b}if(_){P4c(X|0,0,B|0)|0}if(ba){H=0;do{if(!((H|0)==(ta|0)|_^1)){G=fa(H,L)|0;F=0;do{J=X+(F<<3)|0;h[J>>3]=+h[O+(F+G<<3)>>3]+ +h[J>>3];F=F+1|0;}while((F|0)<(L|0))}H=H+1|0;}while((H|0)<(M|0))}do{if(_){H=0;do{F=X+(H<<3)|0;h[F>>3]=+h[F>>3]/ca;H=H+1|0;}while((H|0)<(L|0));if(!_){break}H=fa(ta,L)|0;F=0;do{Y=+h[X+(F<<3)>>3];h[Q+(F<<3)>>3]=Y+(Y- +h[O+(F+H<<3)>>3]);F=F+1|0;}while((F|0)<(L|0))}}while(0);oGc(a,R);za=+aGc(a,ga);Y=+h[P+(ja<<3)>>3];do{if(Y<=za){if(!(za<=+h[P+(ua<<3)>>3])){break}if(!_){Aa=ia;D=Aa;continue c}N4c(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue c}}while(0);if(!(za<=Y)){break}if(_){F=0;do{ya=+h[X+(F<<3)>>3];h[S+(F<<3)>>3]=ya+(+h[Q+(F<<3)>>3]-ya)*2.0;F=F+1|0;}while((F|0)<(L|0))}oGc(a,T);if(+aGc(a,ga)<za){if(!_){Aa=ia;D=Aa;continue}N4c(O+(fa(B,ta)|0)|0,S|0,B|0)|0;Aa=ia;D=Aa;continue}else{if(!_){Aa=ia;D=Aa;continue}N4c(O+(fa(B,ta)|0)|0,Q|0,B|0)|0;Aa=ia;D=Aa;continue}}if(!(+h[P+(ua<<3)>>3]<=za)){$=89;break a}Y=+h[P+(ta<<3)>>3];if(!(za>=Y)){if(_){D=0;do{ya=+h[X+(D<<3)>>3];h[V+(D<<3)>>3]=ya+(+h[Q+(D<<3)>>3]-ya)*.5;D=D+1|0;}while((D|0)<(L|0))}oGc(a,W);Ba=+aGc(a,ga)}else{if(_){D=fa(ta,L)|0;F=0;do{ya=+h[X+(F<<3)>>3];h[V+(F<<3)>>3]=ya+(+h[O+(F+D<<3)>>3]-ya)*.5;F=F+1|0;}while((F|0)<(L|0))}oGc(a,W);Ba=+aGc(a,ga)}if(Ba<Y){if(!_){ha=Ba;C=ia;continue}N4c(O+(fa(B,ta)|0)|0,V|0,B|0)|0;ha=Ba;C=ia;continue}if(ba){Ca=0}else{ha=Ba;C=ia;continue}while(1){if(_){F=fa(Ca,L)|0;D=0;do{H=O+(D+F<<3)|0;h[H>>3]=(+h[H>>3]+ +h[O+(D+ka<<3)>>3])*.5;D=D+1|0;}while((D|0)<(L|0))}D=Ca+1|0;if((D|0)<(M|0)){Ca=D}else{ha=Ba;C=ia;continue b}}}Y=ga+da;ya=Y>1.0?1.0:Y;Y=+h[P+(ja<<3)>>3];C=u;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];c[u+8>>2]=ia;C=u+12|0;h[k>>3]=Y;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];EBc(9,0,333752,u);if(b){ea=ha;A=ia;ga=ya;continue}c[t>>2]=ia;wd(Z|0,333680,t|0)|0;C=s;h[k>>3]=ya;c[C>>2]=c[k>>2];c[C+4>>2]=c[k+4>>2];wd(Z|0,333688,s|0)|0;if((c[K>>2]|0)>0){C=0;do{E=r;h[k>>3]=+h[(c[z>>2]|0)+(C<<3)>>3];c[E>>2]=c[k>>2];c[E+4>>2]=c[k+4>>2];wd(Z|0,333688,r|0)|0;C=C+1|0;}while((C|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;ea=ha;A=ia;ga=ya}if(($|0)==89){$=q;h[k>>3]=za;c[$>>2]=c[k>>2];c[$+4>>2]=c[k+4>>2];GBc(9,0,333800,q);q=p;h[k>>3]=ha;c[q>>2]=c[k>>2];c[q+4>>2]=c[k+4>>2];GBc(9,0,333816,p);IBc(0,333832,o)}oGc(a,la);if((f|0)!=0){h[f>>3]=ga}if((g|0)!=0){c[g>>2]=ia}if(b){i4c(S);i4c(Q);i4c(V);i4c(X);i4c(P);i4c(O);i=j;return}c[n>>2]=ia;wd(Z|0,333680,n|0)|0;n=m;h[k>>3]=ga;c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,333688,m|0)|0;if((c[K>>2]|0)>0){m=0;do{n=l;h[k>>3]=+h[(c[z>>2]|0)+(m<<3)>>3];c[n>>2]=c[k>>2];c[n+4>>2]=c[k+4>>2];wd(Z|0,333688,l|0)|0;m=m+1|0;}while((m|0)<(c[K>>2]|0))}Sd(10,Z|0)|0;Yc(Z|0)|0;i4c(S);i4c(Q);i4c(V);i4c(X);i4c(P);i4c(O);i=j;return}function yGc(a,b){a=a|0;b=b|0;i=i;return}function zGc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0.0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=c[b+12>>2]|0;_Cc(3);bDc(0);w=+VCc(0);_Cc(0);x=d+4|0;y=u;h[k>>3]=+h[c[c[x>>2]>>2]>>3];c[y>>2]=c[k>>2];c[y+4>>2]=c[k+4>>2];wd(v|0,333912,u|0)|0;if((c[b+8>>2]|0)!=0){b=t;h[k>>3]=w;c[b>>2]=c[k>>2];c[b+4>>2]=c[k+4>>2];wd(v|0,333912,t|0)|0}t=d+116|0;b=c[t>>2]|0;if((b|0)>0){u=d+8|0;y=b;b=0;while(1){if((a[(c[u>>2]|0)+(b*112|0)+104|0]|0)==0){z=s;h[k>>3]=+h[(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(b<<3)>>3];c[z>>2]=c[k>>2];c[z+4>>2]=c[k+4>>2];wd(v|0,333912,s|0)|0;A=c[t>>2]|0}else{A=y}z=b+1|0;if((z|0)<(A|0)){y=A;b=z}else{break}}}b=d+124|0;A=c[b>>2]|0;if((A|0)>0){y=d+12|0;t=A;A=0;while(1){if((a[(c[y>>2]|0)+(A*60|0)+56|0]|0)==0){c[r>>2]=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(A<<2)>>2];wd(v|0,333920,r|0)|0;B=c[b>>2]|0}else{B=t}s=A+1|0;if((s|0)<(B|0)){t=B;A=s}else{break}}}A=d+128|0;B=c[A>>2]|0;if((B|0)>0){t=d+16|0;b=B;B=0;while(1){if((a[(c[t>>2]|0)+(B*48|0)+44|0]|0)==0){c[q>>2]=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+B|0]|0;wd(v|0,333920,q|0)|0;C=c[A>>2]|0}else{C=b}r=B+1|0;if((r|0)<(C|0)){b=C;B=r}else{break}}}B=d+132|0;C=c[B>>2]|0;if((C|0)>0){b=d+20|0;A=C;C=0;while(1){if((a[(c[b>>2]|0)+(C*52|0)+48|0]|0)==0){c[p>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(C<<2)>>2];wd(v|0,333928,p|0)|0;D=c[B>>2]|0}else{D=A}q=C+1|0;if((q|0)<(D|0)){A=D;C=q}else{break}}}C=d+216|0;if((c[C>>2]|0)>0){D=d+40|0;A=0;do{B=c[D>>2]|0;do{if((a[B+(A*52|0)+48|0]|0)==0){p=a[B+(A*52|0)+8|0]|0;if(p<<24>>24==1){break}else if(p<<24>>24==2){E=c[c[x>>2]>>2]|0}else{E=(c[(c[c[x>>2]>>2]|0)+8>>2]|0)+(c[B+(A*52|0)+4>>2]<<3)|0}w=+h[E>>3];if((c[B+(A*52|0)>>2]|0)==0){p=n;h[k>>3]=w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,333912,n|0)|0;break}else{p=o;h[k>>3]=-w;c[p>>2]=c[k>>2];c[p+4>>2]=c[k+4>>2];wd(v|0,333912,o|0)|0;break}}}while(0);A=A+1|0;}while((A|0)<(c[C>>2]|0))}C=d+220|0;if((c[C>>2]|0)>0){A=d+44|0;o=0;do{n=c[A>>2]|0;do{if((a[n+(o*52|0)+48|0]|0)==0){if((a[n+(o*52|0)+8|0]|0)==1){break}E=c[(c[(c[c[x>>2]>>2]|0)+12>>2]|0)+(c[n+(o*52|0)+4>>2]<<2)>>2]|0;if((c[n+(o*52|0)>>2]|0)==0){c[l>>2]=E;wd(v|0,333920,l|0)|0;break}else{c[m>>2]=0-E;wd(v|0,333920,m|0)|0;break}}}while(0);o=o+1|0;}while((o|0)<(c[C>>2]|0))}C=d+224|0;if((c[C>>2]|0)>0){o=d+48|0;m=0;do{l=c[o>>2]|0;do{if((a[l+(m*52|0)+48|0]|0)==0){if((a[l+(m*52|0)+8|0]|0)==1){break}A=a[(c[(c[c[x>>2]>>2]|0)+16>>2]|0)+(c[l+(m*52|0)+4>>2]|0)|0]|0;if((c[l+(m*52|0)>>2]|0)==0){c[g>>2]=A<<24>>24;wd(v|0,333920,g|0)|0;break}else{c[j>>2]=A<<24>>24!=1;wd(v|0,333920,j|0)|0;break}}}while(0);m=m+1|0;}while((m|0)<(c[C>>2]|0))}C=d+228|0;m=c[C>>2]|0;if((m|0)<=0){F=Sd(10,v|0)|0;bDc(3);i=e;return}j=d+52|0;d=m;m=0;while(1){g=c[j>>2]|0;do{if((a[g+(m*52|0)+48|0]|0)==0){if((a[g+(m*52|0)+8|0]|0)==1){G=d;break}c[f>>2]=c[(c[(c[c[x>>2]>>2]|0)+20>>2]|0)+(c[g+(m*52|0)+4>>2]<<2)>>2];wd(v|0,333928,f|0)|0;G=c[C>>2]|0}else{G=d}}while(0);g=m+1|0;if((g|0)<(G|0)){d=G;m=g}else{break}}F=Sd(10,v|0)|0;bDc(3);i=e;return}function AGc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;h=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b;s=ic(c[r>>2]|0,333936)|0;t=c[d+536>>2]|0;u=c[r>>2]|0;r=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=u;c[q+4>>2]=r;HBc(t,(s|0)!=0|0,333944,q);c[p>>2]=334e3;wd(s|0,333928,p|0)|0;if((c[b+8>>2]|0)!=0){c[o>>2]=334008;wd(s|0,333928,o|0)|0}o=d+116|0;p=c[o>>2]|0;if((p|0)>0){q=d+8|0;t=p;p=0;while(1){r=c[q>>2]|0;if((a[r+(p*112|0)+104|0]|0)==0){c[n>>2]=c[r+(p*112|0)+4>>2];wd(s|0,333928,n|0)|0;v=c[o>>2]|0}else{v=t}r=p+1|0;if((r|0)<(v|0)){t=v;p=r}else{break}}}p=d+124|0;v=c[p>>2]|0;if((v|0)>0){t=d+12|0;o=v;v=0;while(1){n=c[t>>2]|0;if((a[n+(v*60|0)+56|0]|0)==0){c[m>>2]=c[n+(v*60|0)+4>>2];wd(s|0,333928,m|0)|0;w=c[p>>2]|0}else{w=o}n=v+1|0;if((n|0)<(w|0)){o=w;v=n}else{break}}}v=d+128|0;w=c[v>>2]|0;if((w|0)>0){o=d+16|0;p=w;w=0;while(1){m=c[o>>2]|0;if((a[m+(w*48|0)+44|0]|0)==0){c[l>>2]=c[m+(w*48|0)+4>>2];wd(s|0,333928,l|0)|0;x=c[v>>2]|0}else{x=p}m=w+1|0;if((m|0)<(x|0)){p=x;w=m}else{break}}}w=d+132|0;x=c[w>>2]|0;if((x|0)>0){p=d+20|0;v=x;x=0;while(1){l=c[p>>2]|0;if((a[l+(x*52|0)+48|0]|0)==0){c[k>>2]=c[l+(x*52|0)+4>>2];wd(s|0,333928,k|0)|0;y=c[w>>2]|0}else{y=v}l=x+1|0;if((l|0)<(y|0)){v=y;x=l}else{break}}}x=d+216|0;y=c[x>>2]|0;if((y|0)>0){v=d+40|0;w=y;y=0;while(1){k=c[v>>2]|0;do{if((a[k+(y*52|0)+48|0]|0)==0){if((a[k+(y*52|0)+8|0]|0)==1){z=w;break}c[j>>2]=c[k+(y*52|0)+16>>2];wd(s|0,333928,j|0)|0;z=c[x>>2]|0}else{z=w}}while(0);k=y+1|0;if((k|0)<(z|0)){w=z;y=k}else{break}}}y=d+220|0;z=c[y>>2]|0;if((z|0)>0){w=d+44|0;x=z;z=0;while(1){j=c[w>>2]|0;do{if((a[j+(z*52|0)+48|0]|0)==0){if((a[j+(z*52|0)+8|0]|0)==1){A=x;break}c[h>>2]=c[j+(z*52|0)+16>>2];wd(s|0,333928,h|0)|0;A=c[y>>2]|0}else{A=x}}while(0);j=z+1|0;if((j|0)<(A|0)){x=A;z=j}else{break}}}z=d+224|0;A=c[z>>2]|0;if((A|0)>0){x=d+48|0;y=A;A=0;while(1){h=c[x>>2]|0;do{if((a[h+(A*52|0)+48|0]|0)==0){if((a[h+(A*52|0)+8|0]|0)==1){B=y;break}c[g>>2]=c[h+(A*52|0)+16>>2];wd(s|0,333928,g|0)|0;B=c[z>>2]|0}else{B=y}}while(0);h=A+1|0;if((h|0)<(B|0)){y=B;A=h}else{break}}}A=d+228|0;B=c[A>>2]|0;if((B|0)<=0){C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}y=d+52|0;d=B;B=0;while(1){z=c[y>>2]|0;do{if((a[z+(B*52|0)+48|0]|0)==0){if((a[z+(B*52|0)+8|0]|0)==1){H=d;break}c[f>>2]=c[z+(B*52|0)+16>>2];wd(s|0,333928,f|0)|0;H=c[A>>2]|0}else{H=d}}while(0);z=B+1|0;if((z|0)<(H|0)){d=H;B=z}else{break}}C=Sd(10,s|0)|0;D=s;E=b;F=E+12|0;G=F;c[G>>2]=D;i=e;return}function BGc(a,b){a=a|0;b=b|0;var d=0;b=i;d=c[a+12>>2]|0;_Cc(3);Yc(d|0)|0;bDc(3);i=b;return}function CGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d;f=d+16|0;g=d+32|0;j=d+40|0;k=d+48|0;l=d+56|0;m=d+72|0;n=d+88|0;o=c[a+12>>2]|0;c[k>>2]=0;p=o;tYc(l,p);q=o+184|0;r=m;c[r+0>>2]=c[q+0>>2];c[r+4>>2]=c[q+4>>2];c[r+8>>2]=c[q+8>>2];c[r+12>>2]=c[q+12>>2];q=f;r=m;c[q+0>>2]=c[r+0>>2];c[q+4>>2]=c[r+4>>2];c[q+8>>2]=c[r+8>>2];c[q+12>>2]=c[r+12>>2];uYc(p,f)|0;DGc(b,k,g,j,+h[o+224>>3],+h[o+232>>3]);o=c[k>>2]|0;EGc(a,b,334024,c[j>>2]|0,c[g>>2]|0,o,8);i4c(o);c[k>>2]=0;k=n;o=l;c[k+0>>2]=c[o+0>>2];c[k+4>>2]=c[o+4>>2];c[k+8>>2]=c[o+8>>2];c[k+12>>2]=c[o+12>>2];o=e;k=n;c[o+0>>2]=c[k+0>>2];c[o+4>>2]=c[k+4>>2];c[o+8>>2]=c[k+8>>2];c[o+12>>2]=c[k+12>>2];uYc(p,e)|0;i=d;return}function DGc(b,d,e,f,g,j){b=b|0;d=d|0;e=e|0;f=f|0;g=+g;j=+j;var k=0,l=0,m=0,n=0,o=0,p=0;k=i;i=i+8|0;c[e>>2]=2;l=b+136|0;m=b+140|0;n=b+144|0;o=(c[l>>2]|0)+1+(c[m>>2]|0)+(c[n>>2]|0)|0;c[f>>2]=o;p=j4c(fa(c[e>>2]|0,o)|0,8)|0;c[d>>2]=p;HBc(c[b+536>>2]|0,(p|0)!=0|0,334304,k);p=c[d>>2]|0;h[p>>3]=g;d=c[f>>2]|0;h[p+(d<<3)>>3]=j;f=c[l>>2]|0;if((f|0)>0){l=c[b+416>>2]|0;o=0;do{e=l+(o<<3)|0;o=o+1|0;h[p+(o<<3)>>3]=+h[e>>3];h[p+(d+o<<3)>>3]=+h[e>>3];}while((o|0)<(f|0))}o=f+1|0;f=c[m>>2]|0;if((f|0)>0){m=c[b+420>>2]|0;l=0;do{j=+(c[m+(l<<2)>>2]|0);e=l+o|0;h[p+(e<<3)>>3]=j;h[p+(d+e<<3)>>3]=j;l=l+1|0;}while((l|0)<(f|0))}l=f+o|0;o=c[n>>2]|0;if((o|0)<=0){i=k;return}n=c[b+424>>2]|0;b=0;do{f=n+b|0;m=l+b|0;h[p+(m<<3)>>3]=+(a[f]|0);h[p+(d+m<<3)>>3]=+(a[f]|0);b=b+1|0;}while((b|0)<(o|0));i=k;return}function EGc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0;j=i;i=i+8|0;k=j;l=c[a+12>>2]|0;PGc(a,b,d,e,f,h);sYc(l,g,fa(fa(f,e)|0,h)|0)|0;if(PWc(l+(c[(c[l>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];IBc(l,334256,k)}else{i=j;return}}function FGc(a){a=a|0;var b=0;b=i;if((HHc(a+4|0)|0)!=0){i=b;return}SWc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0,4);i=b;return}function GGc(a){a=a|0;Rc(a|0)|0;Ya()}function HGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=n4c(320)|0;P4c(q|0,0,320)|0;IGc(q);r=a+12|0;c[r>>2]=q;s=(c[b+140>>2]|0)+(c[b+136>>2]|0)+(c[b+144>>2]|0)|0;c[f>>2]=0;c[k>>2]=0;c[l>>2]=0;_Cc(3);t=a+8|0;u=JGc(c[t>>2]|0,c[r>>2]|0,b)|0;r=q+316|0;c[r>>2]=u;v=KGc(a,b,u+s|0)|0;u=q+184|0;LGc(m,-1,-1);w=m;c[u+0>>2]=c[w+0>>2];c[u+4>>2]=c[w+4>>2];c[u+8>>2]=c[w+8>>2];c[u+12>>2]=c[w+12>>2];w=q+200|0;LGc(n,-1,-1);m=n;c[w+0>>2]=c[m+0>>2];c[w+4>>2]=c[m+4>>2];c[w+8>>2]=c[m+8>>2];c[w+12>>2]=c[m+12>>2];c[q+216>>2]=0;m=q+224|0;h[m>>3]=+h[b+240>>3];n=q+232|0;h[n>>3]=+h[b+248>>3];x=a;MGc(q,c[x>>2]|0,36);if(PWc(q+(c[(c[q>>2]|0)+ -12>>2]|0)|0)|0){y=c[b+536>>2]|0;c[e>>2]=c[x>>2];IBc(y,334080,e)}else{EGc(a,b,334112,4,11,334032,1);NGc((c[r>>2]|0)+s|0,v,f,g,j,0,0)|0;e=c[f>>2]|0;EGc(a,b,334120,c[g>>2]|0,c[j>>2]|0,e,1);i4c(e);c[f>>2]=0;NGc((c[r>>2]|0)+s|0,v,f,g,j,0,1)|0;e=c[f>>2]|0;EGc(a,b,334128,c[g>>2]|0,c[j>>2]|0,e,1);i4c(e);c[f>>2]=0;OGc(a,b,k,g,j,c[r>>2]|0,s);EGc(a,b,334144,c[j>>2]|0,c[g>>2]|0,c[k>>2]|0,4);s=q;tYc(o,s);r=o;c[u+0>>2]=c[r+0>>2];c[u+4>>2]=c[r+4>>2];c[u+8>>2]=c[r+8>>2];c[u+12>>2]=c[r+12>>2];DGc(b,l,g,j,+h[m>>3],+h[n>>3]);n=c[l>>2]|0;EGc(a,b,334024,c[j>>2]|0,c[g>>2]|0,n,8);tYc(p,s);g=p;c[w+0>>2]=c[g+0>>2];c[w+4>>2]=c[g+4>>2];c[w+8>>2]=c[g+8>>2];c[w+12>>2]=c[g+12>>2];g=QGc(q+240|0)|0;w=QGc(q+264|0)|0;p=QGc(q+288|0)|0;PGc(a,b,334160,g+1+w+p+(c[q+312>>2]|0)+(c[t>>2]|0)|0,0,8);i4c(n);i4c(c[k>>2]|0);c[l>>2]=0;c[k>>2]=0;_Xc(s)|0;i4c(v);bDc(3);i=d;return}}function IGc(a){a=a|0;var b=0;b=i;RJc(a);i=b;return}function JGc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=(b|0)==0?1:2;c[g>>2]=0;b=e+116|0;l=c[b>>2]|0;if((l|0)>0){m=e+8|0;n=d+240|0;o=l;l=0;p=k;while(1){if((a[(c[m>>2]|0)+(l*112|0)+104|0]|0)==0){c[(VIc(n,g)|0)>>2]=p;q=c[b>>2]|0;r=c[g>>2]|0;s=p+1|0}else{q=o;r=l;s=p}t=r+1|0;c[g>>2]=t;if((t|0)<(q|0)){o=q;l=t;p=s}else{u=s;break}}}else{u=k}c[h>>2]=0;k=e+124|0;s=c[k>>2]|0;if((s|0)>0){p=e+12|0;l=d+264|0;q=s;s=0;o=u;while(1){if((a[(c[p>>2]|0)+(s*60|0)+56|0]|0)==0){c[(VIc(l,h)|0)>>2]=o;v=c[k>>2]|0;w=c[h>>2]|0;x=o+1|0}else{v=q;w=s;x=o}g=w+1|0;c[h>>2]=g;if((g|0)<(v|0)){q=v;s=g;o=x}else{y=x;break}}}else{y=u}c[j>>2]=0;u=e+128|0;x=c[u>>2]|0;if((x|0)>0){o=e+16|0;s=d+288|0;v=x;x=0;q=y;while(1){if((a[(c[o>>2]|0)+(x*48|0)+44|0]|0)==0){c[(VIc(s,j)|0)>>2]=q;z=c[u>>2]|0;A=c[j>>2]|0;B=q+1|0}else{z=v;A=x;B=q}h=A+1|0;c[j>>2]=h;if((h|0)<(z|0)){v=z;x=h;q=B}else{C=B;break}}}else{C=y}y=c[e+216>>2]|0;if((y|0)>0){B=c[e+40>>2]|0;q=0;x=C;while(1){z=((a[B+(q*52|0)+48|0]|0)==0)+x|0;v=q+1|0;if((v|0)<(y|0)){x=z;q=v}else{D=z;break}}}else{D=C}C=c[e+220>>2]|0;if((C|0)>0){q=c[e+44>>2]|0;x=0;y=D;while(1){B=((a[q+(x*52|0)+48|0]|0)==0)+y|0;z=x+1|0;if((z|0)<(C|0)){y=B;x=z}else{E=B;break}}}else{E=D}D=d+312|0;c[D>>2]=0;d=c[e+224>>2]|0;if((d|0)<=0){F=E;i=f;return F|0}x=c[e+48>>2]|0;e=0;y=0;C=E;while(1){if((a[x+(y*52|0)+48|0]|0)==0){if((c[x+(y*52|0)>>2]|0)==0){G=e}else{E=e+1|0;c[D>>2]=E;G=E}H=G;I=C+1|0}else{H=e;I=C}E=y+1|0;if((E|0)<(d|0)){e=H;y=E;C=I}else{F=I;break}}i=f;return F|0}function KGc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0;f=i;i=i+24|0;g=f;h=f+8|0;j=f+16|0;k=c[b+12>>2]|0;l=h4c(e<<2)|0;e=l;c[l>>2]=334712;if((c[b+8>>2]|0)==0){m=1}else{c[l+4>>2]=334752;m=2}b=c[d+116>>2]|0;if((b|0)>0){n=c[d+8>>2]|0;o=m;p=0;while(1){if((a[n+(p*112|0)+104|0]|0)==0){c[l+(o<<2)>>2]=n+(p*112|0);q=o+1|0}else{q=o}r=p+1|0;if((r|0)<(b|0)){o=q;p=r}else{s=q;break}}}else{s=m}m=c[d+124>>2]|0;if((m|0)>0){q=c[d+12>>2]|0;p=s;o=0;while(1){if((a[q+(o*60|0)+56|0]|0)==0){c[l+(p<<2)>>2]=q+(o*60|0);t=p+1|0}else{t=p}b=o+1|0;if((b|0)<(m|0)){p=t;o=b}else{u=t;break}}}else{u=s}s=c[d+128>>2]|0;if((s|0)>0){t=c[d+16>>2]|0;o=u;p=0;while(1){if((a[t+(p*48|0)+44|0]|0)==0){c[l+(o<<2)>>2]=t+(p*48|0);v=o+1|0}else{v=o}m=p+1|0;if((m|0)<(s|0)){o=v;p=m}else{w=v;break}}}else{w=u}u=c[d+216>>2]|0;if((u|0)>0){v=c[d+40>>2]|0;p=w;o=0;while(1){if((a[v+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=v+(o*52|0)+12;x=p+1|0}else{x=p}s=o+1|0;if((s|0)<(u|0)){p=x;o=s}else{y=x;break}}}else{y=w}w=c[d+220>>2]|0;if((w|0)>0){x=c[d+44>>2]|0;o=y;p=0;while(1){if((a[x+(p*52|0)+48|0]|0)==0){c[l+(o<<2)>>2]=x+(p*52|0)+12;z=o+1|0}else{z=o}u=p+1|0;if((u|0)<(w|0)){o=z;p=u}else{A=z;break}}}else{A=y}y=c[d+224>>2]|0;if((y|0)>0){z=c[d+48>>2]|0;p=A;o=0;while(1){if((a[z+(o*52|0)+48|0]|0)==0){c[l+(p<<2)>>2]=z+(o*52|0)+12;B=p+1|0}else{B=p}w=o+1|0;if((w|0)<(y|0)){p=B;o=w}else{C=B;break}}}else{C=A}c[g>>2]=0;A=d+136|0;if((c[A>>2]|0)>0){B=d+24|0;o=k+252|0;p=C;y=0;z=1;while(1){w=p+1|0;c[l+(p<<2)>>2]=(c[B>>2]|0)+(y*112|0);c[(VIc(o,g)|0)>>2]=z;x=z+1|0;u=(c[g>>2]|0)+1|0;c[g>>2]=u;if((u|0)<(c[A>>2]|0)){z=x;y=u;p=w}else{D=w;E=x;break}}}else{D=C;E=1}c[h>>2]=0;C=d+140|0;if((c[C>>2]|0)>0){p=d+28|0;y=k+276|0;z=D;A=0;g=E;while(1){o=z+1|0;c[l+(z<<2)>>2]=(c[p>>2]|0)+(A*60|0);c[(VIc(y,h)|0)>>2]=g;B=g+1|0;x=(c[h>>2]|0)+1|0;c[h>>2]=x;if((x|0)<(c[C>>2]|0)){g=B;A=x;z=o}else{F=o;G=B;break}}}else{F=D;G=E}c[j>>2]=0;E=d+144|0;if((c[E>>2]|0)<=0){i=f;return e|0}D=d+32|0;d=k+300|0;k=F;F=0;z=G;while(1){c[l+(k<<2)>>2]=(c[D>>2]|0)+(F*48|0);c[(VIc(d,j)|0)>>2]=z;G=(c[j>>2]|0)+1|0;c[j>>2]=G;if((G|0)<(c[E>>2]|0)){z=z+1|0;F=G;k=k+1|0}else{break}}i=f;return e|0}function LGc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;GHc(a,b,c);i=d;return}function MGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;f=(FHc(a+4|0,b,d|16)|0)==0;d=a+(c[(c[a>>2]|0)+ -12>>2]|0)|0;if(f){SWc(d,4);i=e;return}else{QWc(d,0);i=e;return}}function NGc(a,b,d,e,f,g,h){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;j=i;i=i+8|0;k=j;l=i;i=i+8|0;c[f>>2]=a;c[e>>2]=0;m=(a|0)>0;do{if(m){n=0;o=0;while(1){p=c[b+(o<<2)>>2]|0;q=L4c(c[(h?p+8|0:p+4|0)>>2]|0)|0;if((q|0)>(n|0)){c[e>>2]=q;r=q}else{r=n}q=o+1|0;if((q|0)<(a|0)){n=r;o=q}else{break}}o=j4c((fa(c[f>>2]|0,r)|0)+1|0,1)|0;c[d>>2]=o;HBc(0,(o|0)!=0|0,334232,l);if(!m){break}o=c[e>>2]|0;n=0;q=c[d>>2]|0;while(1){p=b+(n<<2)|0;s=c[p>>2]|0;W4c(q|0,c[(h?s+8|0:s+4|0)>>2]|0,o+1|0)|0;if(g){s=c[p>>2]|0;UGc(q,L4c(c[(h?s+8|0:s+4|0)>>2]|0)|0)}s=c[e>>2]|0;p=n+1|0;if((p|0)<(a|0)){o=s;n=p;q=q+s|0}else{t=s;break}}u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}else{q=j4c(1,1)|0;c[d>>2]=q;HBc(0,(q|0)!=0|0,334232,k)}}while(0);t=c[e>>2]|0;u=c[f>>2]|0;v=fa(u,t)|0;i=j;return v|0}function OGc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=c[b+12>>2]|0;c[f>>2]=j+h;c[g>>2]=4;g=j4c(c[f>>2]<<2,4)|0;c[e>>2]=g;HBc(c[d+536>>2]|0,(g|0)!=0|0,334280,k);g=s+240|0;f=QGc(g)|0;h=s+264|0;t=QGc(h)|0;u=s+288|0;v=QGc(u)|0;w=b+8|0;if((f+1+t+v|0)==(0-(c[w>>2]|0)|0)){x=0;y=1}else{v=c[e>>2]|0;t=0;f=0;b=1;while(1){c[v+(t<<2)>>2]=2;c[v+((t|1)<<2)>>2]=b;c[v+((t|2)<<2)>>2]=0;z=t+4|0;c[v+((t|3)<<2)>>2]=-1;A=b+1|0;B=f+1|0;C=QGc(g)|0;D=QGc(h)|0;E=QGc(u)|0;if(B>>>0<(C+1+D+E+(c[w>>2]|0)|0)>>>0){b=A;f=B;t=z}else{x=z;y=A;break}}}t=d+216|0;if((c[t>>2]|0)>0){f=d+40|0;b=s+252|0;w=x;v=0;while(1){A=c[f>>2]|0;do{if((a[A+(v*52|0)+48|0]|0)==0){z=a[A+(v*52|0)+8|0]|0;if(z<<24>>24==1){VGc(l,b,A+(v*52|0)+4|0);XGc(n,b);if(!(WGc(l,n)|0)){F=w;break}G=(c[(YGc(l)|0)+4>>2]|0)+1|0;H=1}else if(z<<24>>24==0){VGc(l,g,A+(v*52|0)+4|0);XGc(m,g);if(!(WGc(l,m)|0)){F=w;break}G=(c[(YGc(l)|0)+4>>2]|0)+1|0;H=2}else if(z<<24>>24==2){G=1;H=2}else{F=w;break}z=c[e>>2]|0;c[z+(w<<2)>>2]=H;if((c[(c[f>>2]|0)+(v*52|0)>>2]|0)==0){c[z+(w+1<<2)>>2]=G}else{c[z+(w+1<<2)>>2]=0-G}c[z+(w+2<<2)>>2]=0;c[z+(w+3<<2)>>2]=-1;F=w+4|0}else{F=w}}while(0);A=v+1|0;if((A|0)<(c[t>>2]|0)){w=F;v=A}else{I=F;break}}}else{I=x}x=d+220|0;if((c[x>>2]|0)>0){F=d+44|0;v=s+276|0;w=I;t=0;while(1){G=c[F>>2]|0;do{if((a[G+(t*52|0)+48|0]|0)==0){f=a[G+(t*52|0)+8|0]|0;if(f<<24>>24==0){VGc(l,h,G+(t*52|0)+4|0);XGc(o,h);H=WGc(l,o)|0;J=H?2:0}else if(f<<24>>24==1){VGc(l,v,G+(t*52|0)+4|0);XGc(p,v);J=(WGc(l,p)|0)&1}else{K=w;break}if((J|0)==0){K=w;break}f=c[e>>2]|0;c[f+(w<<2)>>2]=J;H=(c[(c[F>>2]|0)+(t*52|0)>>2]|0)==0;m=c[(YGc(l)|0)+4>>2]|0;if(H){c[f+(w+1<<2)>>2]=m+1}else{c[f+(w+1<<2)>>2]=~m}c[f+(w+2<<2)>>2]=0;c[f+(w+3<<2)>>2]=-1;K=w+4|0}else{K=w}}while(0);G=t+1|0;if((G|0)<(c[x>>2]|0)){w=K;t=G}else{L=K;break}}}else{L=I}I=d+224|0;if((c[I>>2]|0)>0){K=d+48|0;d=s+300|0;s=L;t=0;w=y;while(1){y=c[K>>2]|0;do{if((a[y+(t*52|0)+48|0]|0)==0){if((c[y+(t*52|0)>>2]|0)==0){x=a[y+(t*52|0)+8|0]|0;if(x<<24>>24==0){VGc(l,u,y+(t*52|0)+4|0);XGc(q,u);F=WGc(l,q)|0;M=F?2:0}else if(x<<24>>24==1){VGc(l,d,y+(t*52|0)+4|0);XGc(r,d);M=(WGc(l,r)|0)&1}else{N=s;O=w;break}if((M|0)==0){N=s;O=w;break}P=c[K>>2]|0;Q=M}else{P=y;Q=2}x=c[e>>2]|0;c[x+(s<<2)>>2]=Q;if((c[P+(t*52|0)>>2]|0)==0){c[x+(s+1<<2)>>2]=(c[(YGc(l)|0)+4>>2]|0)+1;R=w}else{c[x+(s+1<<2)>>2]=w;R=w+1|0}c[x+(s+2<<2)>>2]=0;c[x+(s+3<<2)>>2]=-1;N=s+4|0;O=R}else{N=s;O=w}}while(0);y=t+1|0;if((y|0)<(c[I>>2]|0)){s=N;t=y;w=O}else{S=N;break}}}else{S=L}if((j|0)==0){i=k;return}L=c[e>>2]|0;e=0;do{N=(e<<2)+S|0;c[L+(N<<2)>>2]=1;c[L+(N+1<<2)>>2]=e+2;c[L+(N+2<<2)>>2]=0;c[L+(N+3<<2)>>2]=0;e=e+1|0;}while(e>>>0<j>>>0);i=k;return}function PGc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0;h=i;i=i+8|0;j=h;k=i;i=i+8|0;l=i;i=i+24|0;m=c[a+12>>2]|0;c[l>>2]=(g|0)==4?20:(g|0)==1?51:0;c[l+4>>2]=e;c[l+8>>2]=f;c[l+12>>2]=0;f=l+16|0;c[f>>2]=(L4c(d|0)|0)+1;e=m;sYc(e,l,20)|0;if(PWc(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){l=c[b+536>>2]|0;c[k>>2]=c[a>>2];IBc(l,334256,k)}sYc(e,d,c[f>>2]|0)|0;if(PWc(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){m=c[b+536>>2]|0;c[j>>2]=c[a>>2];IBc(m,334256,j)}else{i=h;return}}function QGc(a){a=a|0;var b=0,d=0;b=i;d=c[(CHc(a)|0)>>2]|0;i=b;return d|0}function RGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+32|0;e=d;f=d+16|0;g=a+12|0;h=c[g>>2]|0;j=h;_Cc(3);do{if(OWc(h+(c[(c[h>>2]|0)+ -12>>2]|0)|0)|0){k=h;l=h+200|0;m=f;c[m+0>>2]=c[l+0>>2];c[m+4>>2]=c[l+4>>2];c[m+8>>2]=c[l+8>>2];c[m+12>>2]=c[l+12>>2];l=e;m=f;c[l+0>>2]=c[m+0>>2];c[l+4>>2]=c[m+4>>2];c[l+8>>2]=c[m+8>>2];c[l+12>>2]=c[m+12>>2];uYc(k,e)|0;k=QGc(h+240|0)|0;m=QGc(h+264|0)|0;l=QGc(h+288|0)|0;PGc(a,b,334160,k+1+m+l+(c[h+312>>2]|0)+(c[a+8>>2]|0)|0,c[h+216>>2]|0,8);FGc(h)}else{if((h|0)!=0){break}c[g>>2]=0;bDc(3);i=d;return}}while(0);SGc(j);p4c(h);c[g>>2]=0;bDc(3);i=d;return}function SGc(a){a=a|0;var b=0;b=i;_Hc(a);i=b;return}function TGc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=c[b+12>>2]|0;h[g>>3]=0.0;_Cc(3);bDc(0);h[j>>3]=+VCc(0);_Cc(0);l=k;m=d+4|0;sYc(l,c[c[m>>2]>>2]|0,8)|0;if((c[b+8>>2]|0)!=0){sYc(l,j,8)|0}j=d+116|0;n=c[j>>2]|0;if((n|0)>0){o=d+8|0;p=n;n=0;while(1){if((a[(c[o>>2]|0)+(n*112|0)+104|0]|0)==0){sYc(l,(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+(n<<3)|0,8)|0;q=c[j>>2]|0}else{q=p}r=n+1|0;if((r|0)<(q|0)){p=q;n=r}else{break}}}n=d+124|0;q=c[n>>2]|0;if((q|0)>0){p=d+12|0;j=g;o=q;q=0;while(1){if((a[(c[p>>2]|0)+(q*60|0)+56|0]|0)==0){h[g>>3]=+(c[(c[(c[c[m>>2]>>2]|0)+12>>2]|0)+(q<<2)>>2]|0);sYc(l,j,8)|0;s=c[n>>2]|0}else{s=o}r=q+1|0;if((r|0)<(s|0)){o=s;q=r}else{break}}}q=d+128|0;s=c[q>>2]|0;if((s|0)>0){o=d+16|0;n=g;j=s;s=0;while(1){if((a[(c[o>>2]|0)+(s*48|0)+44|0]|0)==0){h[g>>3]=+(a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+s|0]|0);sYc(l,n,8)|0;t=c[q>>2]|0}else{t=j}p=s+1|0;if((p|0)<(t|0)){j=t;s=p}else{break}}}s=d+224|0;t=c[s>>2]|0;if((t|0)>0){j=d+48|0;q=g;n=t;t=0;while(1){o=c[j>>2]|0;do{if((a[o+(t*52|0)+48|0]|0)==0){if((c[o+(t*52|0)>>2]|0)==0){u=n;break}h[g>>3]=+((a[(c[(c[c[m>>2]>>2]|0)+16>>2]|0)+(c[o+(t*52|0)+4>>2]|0)|0]|0)!=1|0);sYc(l,q,8)|0;u=c[s>>2]|0}else{u=n}}while(0);o=t+1|0;if((o|0)<(u|0)){n=u;t=o}else{break}}}if(PWc(k+(c[(c[k>>2]|0)+ -12>>2]|0)|0)|0){t=c[d+536>>2]|0;c[f>>2]=c[b>>2];IBc(t,334200,f)}else{f=k+216|0;c[f>>2]=(c[f>>2]|0)+1;bDc(3);i=e;return}}function UGc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;if(c>>>0<6){i=d;return}if((I4c(b,334416,4)|0)!=0){i=d;return}c=b;while(1){e=Va(b|0,46)|0;if((e|0)==0){f=8;break}g=e-c|0;e=g+1|0;if(e>>>0>4){h=4;do{a[b+(h+ -4)|0]=a[b+h|0]|0;h=h+1|0;}while(h>>>0<e>>>0)}e=b+(g+ -3)|0;a[e]=678585700;a[e+1|0]=2650725;a[e+2|0]=10354;a[e+3|0]=40;if((I4c(b,334416,4)|0)!=0){f=8;break}}if((f|0)==8){i=d;return}}function VGc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;oHc(g,b,d);d=f;b=g;c[d+0>>2]=c[b+0>>2];eHc(a,f);i=e;return}function WGc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=cHc(a,b)|0;i=c;return d|0}function XGc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=d+8|0;fHc(f,b);b=e;g=f;c[b+0>>2]=c[g+0>>2];eHc(a,e);i=d;return}function YGc(a){a=a|0;var b=0,c=0;b=i;c=ZGc(_Gc(a)|0)|0;i=b;return c|0}function ZGc(a){a=a|0;var b=0,c=0;b=i;c=bHc(a)|0;i=b;return c|0}function _Gc(a){a=a|0;var b=0,d=0;b=i;d=$Gc((c[a>>2]|0)+16|0)|0;i=b;return d|0}function $Gc(a){a=a|0;var b=0,c=0;b=i;c=aHc(a)|0;i=b;return c|0}function aHc(a){a=a|0;i=i;return a|0}function bHc(a){a=a|0;i=i;return a|0}function cHc(a,b){a=a|0;b=b|0;var c=0,d=0;c=i;d=(dHc(a,b)|0)^1;i=c;return d|0}function dHc(a,b){a=a|0;b=b|0;i=i;return(c[a>>2]|0)==(c[b>>2]|0)|0}function eHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];nHc(a,e);i=d;return}function fHc(a,b){a=a|0;b=b|0;var c=0;c=i;gHc(a,hHc(b)|0);i=c;return}function gHc(a,b){a=a|0;b=b|0;var c=0;c=i;mHc(a,b);i=c;return}function hHc(a){a=a|0;var b=0,c=0;b=i;c=iHc(jHc(a+4|0)|0)|0;i=b;return c|0}function iHc(a){a=a|0;var b=0,c=0;b=i;c=lHc(a)|0;i=b;return c|0}function jHc(a){a=a|0;var b=0,c=0;b=i;c=kHc(a)|0;i=b;return c|0}function kHc(a){a=a|0;i=i;return a|0}function lHc(a){a=a|0;i=i;return a|0}function mHc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function nHc(a,b){a=a|0;b=b|0;c[a>>2]=c[b>>2];i=i;return}function oHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+16|0;f=e;g=e+8|0;h=qHc(b)|0;pHc(f,b,d,h,hHc(b)|0);fHc(g,b);do{if(cHc(f,g)|0){h=rHc(b)|0;if(sHc(h,d,tHc(f)|0)|0){break}c[a>>2]=c[f>>2];i=e;return}}while(0);fHc(a,b);i=e;return}function pHc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;g=i;i=i+8|0;h=g;xHc(h);a:do{if((e|0)==0){j=f}else{k=rHc(b)|0;l=f;m=e;while(1){n=m;while(1){if(!(yHc(k,n+16|0,d)|0)){break}o=c[n+4>>2]|0;xHc(h);if((o|0)==0){j=l;break a}else{n=o}}o=c[n>>2]|0;xHc(h);if((o|0)==0){j=n;break}else{l=n;m=o}}}}while(0);gHc(a,j);i=g;return}function qHc(a){a=a|0;var b=0,d=0;b=i;d=c[(hHc(a)|0)>>2]|0;i=b;return d|0}function rHc(a){a=a|0;var b=0,c=0;b=i;c=vHc(a+8|0)|0;i=b;return c|0}function sHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uHc(0,b,c)|0;i=a;return d|0}function tHc(a){a=a|0;i=i;return(c[a>>2]|0)+16|0}function uHc(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function vHc(a){a=a|0;var b=0,c=0;b=i;c=wHc(a)|0;i=b;return c|0}function wHc(a){a=a|0;i=i;return a|0}function xHc(a){a=a|0;var b=0;b=i;zHc(a,-1);i=b;return}function yHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;a=i;d=uHc(0,b,c)|0;i=a;return d|0}function zHc(a,b){a=a|0;b=b|0;b=i;AHc(a,0);i=b;return}function AHc(a,b){a=a|0;b=b|0;c[a>>2]=0;i=i;return}function BHc(a){a=a|0;i=i;return c[a+4>>2]|0}function CHc(a){a=a|0;var b=0,c=0;b=i;c=DHc(a+8|0)|0;i=b;return c|0}function DHc(a){a=a|0;var b=0,c=0;b=i;c=EHc(a)|0;i=b;return c|0}function EHc(a){a=a|0;i=i;return a|0}function FHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;f=a+64|0;if((c[f>>2]|0)!=0){g=0;i=e;return g|0}switch(d&-3|0){case 8:{h=334336;break};case 12:{h=334384;break};case 52:case 20:{h=334368;break};case 9:case 25:{h=334360;break};case 28:{h=334392;break};case 1:case 17:{h=334328;break};case 5:case 21:{h=334376;break};case 60:{h=334400;break};case 24:{h=334344;break};case 13:case 29:{h=334408;break};case 48:case 16:{h=334320;break};case 56:{h=334352;break};default:{g=0;i=e;return g|0}}if((a|0)==0){g=0;i=e;return g|0}j=ic(b|0,h|0)|0;c[f>>2]=j;if((j|0)==0){g=0;i=e;return g|0}c[a+88>>2]=d;if((d&2|0)==0){g=a;i=e;return g|0}if((Wc(j|0,0,2)|0)==0){g=a;i=e;return g|0}Yc(c[f>>2]|0)|0;c[f>>2]=0;g=0;i=e;return g|0}function GHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=a;c[e>>2]=0;c[e+4>>2]=0;e=a+8|0;c[e>>2]=b;c[e+4>>2]=d;i=i;return}function HHc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=b;e=a+64|0;f=c[e>>2]|0;if((f|0)==0){g=0;i=b;return g|0}IHc(d,f,102);f=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;if((Yc(JHc(d)|0)|0)==0){c[e>>2]=0;h=(f|0)==0?a:0}else{h=0}KHc(d);g=h;i=b;return g|0}function IHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;RHc(a,b,c);i=d;return}function JHc(a){a=a|0;var b=0,d=0;b=i;d=NHc(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function KHc(a){a=a|0;var b=0;b=i;LHc(a);i=b;return}function LHc(a){a=a|0;var b=0;b=i;MHc(a,0);i=b;return}function MHc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=NHc(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}ie[c[(OHc(e)|0)>>2]&127](f)|0;i=d;return}function NHc(a){a=a|0;var b=0,c=0;b=i;c=QHc(a)|0;i=b;return c|0}function OHc(a){a=a|0;var b=0,c=0;b=i;c=PHc(a)|0;i=b;return c|0}function PHc(a){a=a|0;i=i;return a+4|0}function QHc(a){a=a|0;i=i;return a|0}function RHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(THc(f)|0)>>2]|0;SHc(a,d,c[(UHc(g)|0)>>2]|0);i=e;return}function SHc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;VHc(a,b,c);i=d;return}function THc(a){a=a|0;i=i;return a|0}function UHc(a){a=a|0;i=i;return a|0}function VHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;d=c[(XHc(f)|0)>>2]|0;WHc(a,d,c[(YHc(g)|0)>>2]|0);i=e;return}function WHc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=e+8|0;c[f>>2]=b;c[g>>2]=d;c[a>>2]=c[(XHc(f)|0)>>2];c[a+4>>2]=c[(YHc(g)|0)>>2];i=e;return}function XHc(a){a=a|0;i=i;return a|0}function YHc(a){a=a|0;i=i;return a|0}function ZHc(a){a=a|0;var b=0,d=0;b=i;d=a+8|0;J=c[d+4>>2]|0;i=b;return c[d>>2]|0}function _Hc(a){a=a|0;var b=0;b=i;$Hc(a+300|0);$Hc(a+288|0);$Hc(a+276|0);$Hc(a+264|0);$Hc(a+252|0);$Hc(a+240|0);aIc(a);i=b;return}function $Hc(a){a=a|0;var b=0;b=i;MIc(a);i=b;return}function aIc(a){a=a|0;var b=0;b=i;bIc(a,334464);WWc(a+104|0);i=b;return}function bIc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[b>>2]|0;c[a>>2]=e;c[a+(c[e+ -12>>2]|0)>>2]=c[b+12>>2];fIc(a+4|0);i=d;return}function cIc(a){a=a|0;var b=0;b=i;aIc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function dIc(a){a=a|0;var b=0;b=i;aIc(a);p4c(a);i=b;return}function eIc(a){a=a|0;var b=0;b=i;dIc(a+(c[(c[a>>2]|0)+ -12>>2]|0)|0);i=b;return}function fIc(a){a=a|0;var b=0;b=i;gIc(a);i=b;return}function gIc(b){b=b|0;var d=0,e=0;d=i;c[b>>2]=334592;HHc(b)|0;do{if((a[b+96|0]|0)!=0){e=c[b+32>>2]|0;if((e|0)==0){break}q4c(e)}}while(0);do{if((a[b+97|0]|0)!=0){e=c[b+56>>2]|0;if((e|0)==0){break}q4c(e)}}while(0);dXc(b);i=d;return}function hIc(a){a=a|0;var b=0;b=i;fIc(a);p4c(a);i=b;return}function iIc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0;e=i;ie[c[(c[b>>2]|0)+24>>2]&127](b)|0;f=KIc(d)|0;c[b+68>>2]=f;d=b+98|0;g=a[d]|0;h=LIc(f)|0;a[d]=h&1;if((g&255|0)==(h&1|0)){i=e;return}h=b;nXc(h,0,0,0);sXc(h,0,0);h=b+96|0;g=(a[h]|0)!=0;if((a[d]|0)!=0){d=b+32|0;do{if(g){f=c[d>>2]|0;if((f|0)==0){break}q4c(f)}}while(0);f=b+97|0;a[h]=a[f]|0;j=b+60|0;c[b+52>>2]=c[j>>2];k=b+56|0;c[d>>2]=c[k>>2];c[j>>2]=0;c[k>>2]=0;a[f]=0;i=e;return}do{if(!g){f=b+32|0;k=c[f>>2]|0;if((k|0)==(b+44|0)){break}j=c[b+52>>2]|0;c[b+60>>2]=j;c[b+56>>2]=k;a[b+97|0]=0;c[f>>2]=o4c(j)|0;a[h]=1;i=e;return}}while(0);h=c[b+52>>2]|0;c[b+60>>2]=h;c[b+56>>2]=o4c(h)|0;a[b+97|0]=1;i=e;return}function jIc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+16|0;g=f;h=f+8|0;c[g>>2]=e;e=b;nXc(e,0,0,0);sXc(e,0,0);j=b+96|0;do{if((a[j]|0)!=0){k=c[b+32>>2]|0;if((k|0)==0){break}q4c(k)}}while(0);k=b+97|0;do{if((a[k]|0)!=0){l=c[b+56>>2]|0;if((l|0)==0){break}q4c(l)}}while(0);l=c[g>>2]|0;m=b+52|0;c[m>>2]=l;do{if(l>>>0>8){n=a[b+98|0]|0;if(n<<24>>24==0|(d|0)==0){c[b+32>>2]=o4c(l)|0;a[j]=1;o=n;break}else{c[b+32>>2]=d;a[j]=0;o=n;break}}else{c[b+32>>2]=b+44;c[m>>2]=8;a[j]=0;o=a[b+98|0]|0}}while(0);if(!(o<<24>>24==0)){c[b+60>>2]=0;c[b+56>>2]=0;a[k]=0;i=f;return e|0}c[h>>2]=8;o=c[(HIc(g,h)|0)>>2]|0;c[b+60>>2]=o;if((d|0)!=0&o>>>0>7){c[b+56>>2]=d;a[k]=0;i=f;return e|0}else{c[b+56>>2]=o4c(o)|0;a[k]=1;i=f;return e|0}return 0}function kIc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+32|0;h=g;j=g+8|0;k=g+24|0;l=k;m=c[b+68>>2]|0;if((m|0)==0){n=Ec(4)|0;O3c(n);Td(n|0,381920,127)}n=DIc(m)|0;m=b+64|0;do{if((c[m>>2]|0)!=0){o=(n|0)>0;if(!(o|(d|0)==0&(e|0)==0)){break}if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}if(!(f>>>0<3)){LGc(a,-1,-1);i=g;return}p=c[m>>2]|0;if(o){o=c5c(n|0,((n|0)<0)<<31>>31|0,d|0,e|0)|0;q=o}else{q=0}if((Wc(p|0,q|0,f|0)|0)==0){p=yb(c[m>>2]|0)|0;LGc(j,p,((p|0)<0)<<31>>31);p=b+72|0;o=c[p+4>>2]|0;r=k;c[r>>2]=c[p>>2];c[r+4>>2]=o;o=h;r=l;c[o+0>>2]=c[r+0>>2];c[o+4>>2]=c[r+4>>2];GIc(j,h);r=a;o=j;c[r+0>>2]=c[o+0>>2];c[r+4>>2]=c[o+4>>2];c[r+8>>2]=c[o+8>>2];c[r+12>>2]=c[o+12>>2];i=g;return}else{LGc(a,-1,-1);i=g;return}}}while(0);LGc(a,-1,-1);i=g;return}function lIc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+8|0;f=e;g=f;h=b+64|0;do{if((c[h>>2]|0)!=0){if((ie[c[(c[b>>2]|0)+24>>2]&127](b)|0)!=0){break}j=c[h>>2]|0;k=ZHc(d)|0;if((Wc(j|0,k|0,0)|0)==0){FIc(g,d);k=f;j=c[k+4>>2]|0;l=b+72|0;c[l>>2]=c[k>>2];c[l+4>>2]=j;j=a;l=d;c[j+0>>2]=c[l+0>>2];c[j+4>>2]=c[l+4>>2];c[j+8>>2]=c[l+8>>2];c[j+12>>2]=c[l+12>>2];i=e;return}else{LGc(a,-1,-1);i=e;return}}}while(0);LGc(a,-1,-1);i=e;return}function mIc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+16|0;e=d;f=d+8|0;g=f;h=b+64|0;if((c[h>>2]|0)==0){j=0;i=d;return j|0}k=b+68|0;l=c[k>>2]|0;if((l|0)==0){m=Ec(4)|0;O3c(m);Td(m|0,381920,127)}m=b+92|0;n=c[m>>2]|0;do{if((n&16|0)==0){if((n&8|0)==0){break}o=b+80|0;p=c[o+4>>2]|0;q=f;c[q>>2]=c[o>>2];c[q+4>>2]=p;do{if((a[b+98|0]|0)==0){p=DIc(l)|0;q=b+36|0;o=c[q>>2]|0;r=(c[b+40>>2]|0)-o|0;s=b;if((p|0)>0){t=lXc(s)|0;u=(fa(t-(kXc(s)|0)|0,p)|0)+r|0;v=0;break}p=kXc(s)|0;if((p|0)==(lXc(s)|0)){u=r;v=0;break}t=c[k>>2]|0;w=b+32|0;x=c[w>>2]|0;y=EIc(t,g,x,o,p-(jXc(s)|0)|0)|0;u=r-y+(c[q>>2]|0)-(c[w>>2]|0)|0;v=1}else{w=b;q=lXc(w)|0;u=q-(kXc(w)|0)|0;v=0}}while(0);if((Wc(c[h>>2]|0,0-u|0,1)|0)!=0){j=-1;i=d;return j|0}if(v){w=f;q=c[w+4>>2]|0;y=b+72|0;c[y>>2]=c[w>>2];c[y+4>>2]=q}q=c[b+32>>2]|0;c[b+40>>2]=q;c[b+36>>2]=q;nXc(b,0,0,0);c[m>>2]=0}else{q=b;y=pXc(q)|0;do{if((y|0)!=(oXc(q)|0)){if((xe[c[(c[b>>2]|0)+52>>2]&63](b,-1)|0)==-1){j=-1}else{break}i=d;return j|0}}while(0);q=b+72|0;y=b+32|0;w=b+52|0;while(1){r=c[y>>2]|0;s=CIc(c[k>>2]|0,q,r,r+(c[w>>2]|0)|0,e)|0;r=c[y>>2]|0;p=(c[e>>2]|0)-r|0;if((rc(r|0,1,p|0,c[h>>2]|0)|0)!=(p|0)){j=-1;z=23;break}if((s|0)==2){j=-1;z=23;break}else if((s|0)!=1){z=10;break}}if((z|0)==10){if((ud(c[h>>2]|0)|0)==0){break}else{j=-1}i=d;return j|0}else if((z|0)==23){i=d;return j|0}}}while(0);j=0;i=d;return j|0}function nIc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+32|0;k=d+40|0;l=b+64|0;if((c[l>>2]|0)==0){m=-1;i=d;return m|0}n=xIc(b)|0;o=b;if((kXc(o)|0)==0){p=e+1|0;nXc(o,e,p,p)}if(n){q=0}else{n=lXc(o)|0;c[f>>2]=(n-(jXc(o)|0)|0)/2|0;c[g>>2]=4;q=c[(yIc(f,g)|0)>>2]|0}g=kXc(o)|0;do{if((g|0)==(lXc(o)|0)){O4c(jXc(o)|0,g+(0-q)|0,q|0)|0;if((a[b+98|0]|0)!=0){f=lXc(o)|0;n=jXc(o)|0;p=sb(n+q|0,1,f-q-n|0,c[l>>2]|0)|0;if((p|0)==0){r=-1;break}n=jXc(o)|0;nXc(o,n,n+q|0,n+(p+q)|0);r=vIc(a[kXc(o)|0]|0)|0;break}p=b+32|0;n=b+36|0;f=c[n>>2]|0;s=b+40|0;O4c(c[p>>2]|0,f|0,(c[s>>2]|0)-f|0)|0;f=c[p>>2]|0;t=f+((c[s>>2]|0)-(c[n>>2]|0))|0;c[n>>2]=t;if((f|0)==(b+44|0)){u=8}else{u=c[b+52>>2]|0}v=f+u|0;c[s>>2]=v;f=b+60|0;c[h>>2]=(c[f>>2]|0)-q;c[j>>2]=v-t;v=c[(yIc(h,j)|0)>>2]|0;w=b+72|0;x=w;y=c[x+4>>2]|0;z=b+80|0;c[z>>2]=c[x>>2];c[z+4>>2]=y;y=sb(t|0,1,v|0,c[l>>2]|0)|0;if((y|0)==0){r=-1;break}v=c[b+68>>2]|0;if((v|0)==0){t=Ec(4)|0;O3c(t);Td(t|0,381920,127)}t=(c[n>>2]|0)+y|0;c[s>>2]=t;y=c[p>>2]|0;z=jXc(o)|0;if((zIc(v,w,y,t,n,z+q|0,z+(c[f>>2]|0)|0,k)|0)==3){f=c[p>>2]|0;nXc(o,f,f,c[s>>2]|0);r=vIc(a[kXc(o)|0]|0)|0;break}s=c[k>>2]|0;f=jXc(o)|0;p=f+q|0;if((s|0)==(p|0)){r=-1;break}nXc(o,f,p,s);r=vIc(a[kXc(o)|0]|0)|0}else{r=vIc(a[g]|0)|0}}while(0);if((jXc(o)|0)!=(e|0)){m=r;i=d;return m|0}nXc(o,0,0,0);m=r;i=d;return m|0}function oIc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;if((c[b+64>>2]|0)==0){f=-1;i=e;return f|0}g=b;h=jXc(g)|0;j=kXc(g)|0;if(!(h>>>0<j>>>0)){f=-1;i=e;return f|0}if(rIc(d,-1)|0){mXc(g,-1);f=uIc(d)|0;i=e;return f|0}h=(c[b+88>>2]&16|0)==0;b=sIc(d)|0;do{if(h){if(wIc(b,a[j+ -1|0]|0)|0){break}else{f=-1}i=e;return f|0}}while(0);mXc(g,-1);a[kXc(g)|0]=b;f=d;i=e;return f|0}function pIc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=b+64|0;if((c[j>>2]|0)==0){k=-1;i=e;return k|0}qIc(b);l=b;m=oXc(l)|0;n=qXc(l)|0;if(!(rIc(d,-1)|0)){if((pXc(l)|0)==0){sXc(l,f,f+1|0)}f=sIc(d)|0;a[pXc(l)|0]=f;rXc(l,1)}f=pXc(l)|0;o=oXc(l)|0;if((f|0)!=(o|0)){a:do{if((a[b+98|0]|0)==0){p=b+32|0;q=c[p>>2]|0;c[g>>2]=q;r=b+68|0;s=c[r>>2]|0;if((s|0)==0){t=Ec(4)|0;u=t;O3c(u);v=381920;w=127;Td(t|0,v|0,w|0)}x=b+72|0;y=b+52|0;z=q;q=s;while(1){s=oXc(l)|0;A=pXc(l)|0;B=tIc(q,x,s,A,h,z,z+(c[y>>2]|0)|0,g)|0;A=c[h>>2]|0;C=oXc(l)|0;if((A|0)==(C|0)){k=-1;D=22;break}if((B|0)==3){D=14;break}if(!(B>>>0<2)){k=-1;D=22;break}A=c[p>>2]|0;s=(c[g>>2]|0)-A|0;if((rc(A|0,1,s|0,c[j>>2]|0)|0)!=(s|0)){k=-1;D=22;break}if((B|0)!=1){break a}B=c[h>>2]|0;sXc(l,B,pXc(l)|0);B=qXc(l)|0;rXc(l,B-(oXc(l)|0)|0);B=c[r>>2]|0;if((B|0)==0){D=11;break}z=c[p>>2]|0;q=B}if((D|0)==11){t=Ec(4)|0;u=t;O3c(u);v=381920;w=127;Td(t|0,v|0,w|0)}else if((D|0)==14){q=(pXc(l)|0)-C|0;if((rc(C|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}else if((D|0)==22){i=e;return k|0}}else{q=f-o|0;if((rc(o|0,1,q|0,c[j>>2]|0)|0)==(q|0)){break}else{k=-1}i=e;return k|0}}while(0);sXc(l,m,n)}k=uIc(d)|0;i=e;return k|0}function qIc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;e=b+92|0;if((c[e>>2]&16|0)!=0){i=d;return}f=b;nXc(f,0,0,0);g=c[b+52>>2]|0;do{if(g>>>0>8){if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;sXc(f,h,h+((c[b+60>>2]|0)+ -1)|0);break}else{h=c[b+32>>2]|0;sXc(f,h,h+(g+ -1)|0);break}}else{sXc(f,0,0)}}while(0);c[e>>2]=16;i=d;return}function rIc(a,b){a=a|0;b=b|0;i=i;return(a|0)==(b|0)|0}function sIc(a){a=a|0;i=i;return a&255|0}function tIc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+12>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function uIc(a){a=a|0;var b=0,c=0;b=i;c=rIc(a,-1)|0;i=b;return(c?0:a)|0}function vIc(a){a=a|0;i=i;return a&255|0}function wIc(a,b){a=a|0;b=b|0;i=i;return a<<24>>24==b<<24>>24|0}function xIc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;e=b+92|0;if((c[e>>2]&8|0)!=0){f=0;i=d;return f|0}g=b;sXc(g,0,0);if((a[b+98|0]|0)==0){h=c[b+56>>2]|0;j=h+(c[b+60>>2]|0)|0;nXc(g,h,j,j)}else{j=c[b+32>>2]|0;h=j+(c[b+52>>2]|0)|0;nXc(g,j,h,h)}c[e>>2]=8;f=1;i=d;return f|0}function yIc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=AIc(b,c,e)|0;i=d;return g|0}function zIc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0;k=i;l=Ge[c[(c[a>>2]|0)+16>>2]&15](a,b,d,e,f,g,h,j)|0;i=k;return l|0}function AIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=BIc(0,b,a)|0;i=c;return(d?b:a)|0}function BIc(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)>>>0<(c[d>>2]|0)>>>0|0}function CIc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+20>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function DIc(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+24>>2]&127](a)|0;i=b;return d|0}function EIc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0;g=i;h=ye[c[(c[a>>2]|0)+32>>2]&63](a,b,d,e,f)|0;i=g;return h|0}function FIc(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function GIc(a,b){a=a|0;b=b|0;var d=0,e=0;d=b;b=c[d+4>>2]|0;e=a;c[e>>2]=c[d>>2];c[e+4>>2]=b;i=i;return}function HIc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=d;f=e;g=d+8|0;a[f+0|0]=a[g+0|0]|0;g=IIc(b,c,e)|0;i=d;return g|0}function IIc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;c=i;d=JIc(0,a,b)|0;i=c;return(d?b:a)|0}function JIc(a,b,d){a=a|0;b=b|0;d=d|0;i=i;return(c[b>>2]|0)<(c[d>>2]|0)|0}function KIc(a){a=a|0;var b=0,c=0;b=i;c=O0c(a,366424)|0;i=b;return c|0}function LIc(a){a=a|0;var b=0,d=0;b=i;d=ie[c[(c[a>>2]|0)+28>>2]&127](a)|0;i=b;return d|0}function MIc(a){a=a|0;var b=0;b=i;NIc(a);i=b;return}function NIc(a){a=a|0;var b=0;b=i;OIc(a);i=b;return}function OIc(a){a=a|0;var b=0;b=i;PIc(a,qHc(a)|0);i=b;return}function PIc(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;xHc(d);if((b|0)==0){i=d;return}PIc(a,c[b>>2]|0);PIc(a,c[b+4>>2]|0);RIc(QIc(a)|0,b,1);i=d;return}function QIc(a){a=a|0;var b=0,c=0;b=i;c=TIc(a+4|0)|0;i=b;return c|0}function RIc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;SIc(0,b,0);i=c;return}function SIc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;p4c(b);i=c;return}function TIc(a){a=a|0;var b=0,c=0;b=i;c=UIc(a)|0;i=b;return c|0}function UIc(a){a=a|0;i=i;return a|0}function VIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=WIc(a,f,b)|0;l=c[k>>2]|0;xHc(d+16|0);if((l|0)!=0){m=l;n=m;o=n+20|0;p=o;i=d;return p|0}YIc(j,a,b);ZIc(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];XIc(g,e);_Ic(j);j=c[f>>2]|0;$Ic(a,j,k,aJc(g)|0);k=bJc(g)|0;_Ic(g);m=k;n=m;o=n+20|0;p=o;i=d;return p|0}function WIc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+24|0;f=e+8|0;g=e+16|0;h=a;a=qHc(h)|0;xHc(e);if((a|0)==0){j=hHc(h)|0;c[b>>2]=j;k=j;i=e;return k|0}else{l=a}while(1){a=l+16|0;if(uHc(0,d,a)|0){m=l;j=c[m>>2]|0;xHc(f);if((j|0)==0){n=4;break}else{o=m}}else{p=l;if(!(uHc(0,a,d)|0)){n=9;break}q=l+4|0;a=c[q>>2]|0;xHc(g);if((a|0)==0){n=8;break}else{o=q}}l=c[o>>2]|0}if((n|0)==4){c[b>>2]=l;k=m;i=e;return k|0}else if((n|0)==8){c[b>>2]=p;k=q;i=e;return k|0}else if((n|0)==9){c[b>>2]=p;k=b;i=e;return k|0}return 0}function XIc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+8|0;e=d;f=e;g=b;c[f+0>>2]=c[g+0>>2];PJc(a,e);i=d;return}function YIc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+64|0;g=f;h=f+8|0;j=f+16|0;k=f+32|0;l=f+40|0;m=f+48|0;n=QIc(d)|0;d=yJc(n,1)|0;zJc(k,n);n=h;o=k;c[n+0>>2]=c[o+0>>2];c[n+4>>2]=c[o+4>>2];xJc(j,d,h);AJc(0,tJc((BJc(j)|0)+16|0)|0,e);e=CJc(j)|0;a[e+4|0]=1;DJc(0,sJc((BJc(j)|0)+20|0)|0);a[e+5|0]=1;EJc(m,j);ZIc(l,m);e=g;h=l;c[e+0>>2]=c[h+0>>2];XIc(b,g);_Ic(m);_Ic(j);i=f;return}function ZIc(a,b){a=a|0;b=b|0;var c=0;c=i;vJc(a,b);i=c;return}function _Ic(a){a=a|0;var b=0;b=i;oJc(a);i=b;return}function $Ic(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0;f=i;i=i+24|0;xHc(f);c[e>>2]=0;xHc(f+8|0);c[e+4>>2]=0;c[e+8>>2]=b;c[d>>2]=e;e=gJc(a)|0;b=c[c[e>>2]>>2]|0;xHc(f+16|0);if((b|0)!=0){c[e>>2]=c[c[e>>2]>>2]}e=c[(hHc(a)|0)>>2]|0;hJc(e,c[d>>2]|0);d=iJc(a)|0;c[d>>2]=(c[d>>2]|0)+1;i=f;return}function aJc(a){a=a|0;var b=0,d=0;b=i;d=c[(eJc(a)|0)>>2]|0;i=b;return d|0}function bJc(a){a=a|0;var b=0,d=0;b=i;d=cJc(a)|0;a=c[d>>2]|0;c[d>>2]=0;i=b;return a|0}function cJc(a){a=a|0;var b=0,c=0;b=i;c=dJc(a)|0;i=b;return c|0}function dJc(a){a=a|0;i=i;return a|0}function eJc(a){a=a|0;var b=0,c=0;b=i;c=fJc(a)|0;i=b;return c|0}function fJc(a){a=a|0;i=i;return a|0}function gJc(a){a=a|0;i=i;return a|0}function hJc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0;e=i;i=i+16|0;f=e;g=e+8|0;h=(d|0)==(b|0);a[d+12|0]=h&1;if(h){i=e;return}else{j=d}while(1){k=j+8|0;d=c[k>>2]|0;if((a[d+12|0]|0)!=0){l=17;break}h=lJc(d)|0;m=c[d+8>>2]|0;if(h){h=c[m+4>>2]|0;xHc(f);if((h|0)==0){l=7;break}d=h+12|0;if((a[d]|0)!=0){l=7;break}h=c[k>>2]|0;a[h+12|0]=1;n=c[h+8>>2]|0;a[n+12|0]=(n|0)==(b|0)|0;a[d]=1;o=n}else{n=c[m>>2]|0;xHc(g);if((n|0)==0){l=14;break}m=n+12|0;if((a[m]|0)!=0){l=14;break}n=c[k>>2]|0;a[n+12|0]=1;d=c[n+8>>2]|0;a[d+12|0]=(d|0)==(b|0)|0;a[m]=1;o=d}if((o|0)==(b|0)){l=17;break}else{j=o}}if((l|0)==7){if(lJc(j)|0){p=j}else{o=c[k>>2]|0;mJc(o);p=o}o=c[p+8>>2]|0;a[o+12|0]=1;p=c[o+8>>2]|0;a[p+12|0]=0;nJc(p);i=e;return}else if((l|0)==14){if(lJc(j)|0){p=c[k>>2]|0;nJc(p);q=p}else{q=j}j=c[q+8>>2]|0;a[j+12|0]=1;q=c[j+8>>2]|0;a[q+12|0]=0;mJc(q);i=e;return}else if((l|0)==17){i=e;return}}function iJc(a){a=a|0;var b=0,c=0;b=i;c=jJc(a+8|0)|0;i=b;return c|0}function jJc(a){a=a|0;var b=0,c=0;b=i;c=kJc(a)|0;i=b;return c|0}function kJc(a){a=a|0;i=i;return a|0}function lJc(a){a=a|0;i=i;return(c[c[a+8>>2]>>2]|0)==(a|0)|0}function mJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a+4|0;e=c[d>>2]|0;f=e;g=c[f>>2]|0;c[d>>2]=g;xHc(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=lJc(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function nJc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+8|0;d=a;e=c[d>>2]|0;f=e+4|0;g=c[f>>2]|0;c[d>>2]=g;xHc(b);if((g|0)!=0){c[(c[d>>2]|0)+8>>2]=a}d=a+8|0;c[e+8>>2]=c[d>>2];g=lJc(a)|0;h=c[d>>2]|0;if(g){c[h>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}else{c[h+4>>2]=e;c[f>>2]=a;c[d>>2]=e;i=b;return}}function oJc(a){a=a|0;var b=0;b=i;pJc(a,0);i=b;return}function pJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=a;a=cJc(e)|0;f=c[a>>2]|0;c[a>>2]=b;if((f|0)==0){i=d;return}rJc(qJc(e)|0,f);i=d;return}function qJc(a){a=a|0;var b=0,c=0;b=i;c=uJc(a)|0;i=b;return c|0}function rJc(a,b){a=a|0;b=b|0;var d=0;d=i;if((b|0)==0){i=d;return}RIc(c[a>>2]|0,b,1);i=d;return}function sJc(a){a=a|0;i=i;return a|0}function tJc(a){a=a|0;i=i;return a|0}function uJc(a){a=a|0;i=i;return a+4|0}function vJc(a,b){a=a|0;b=b|0;var c=0;c=i;wJc(a,b);i=c;return}function wJc(a,b){a=a|0;b=b|0;c[a>>2]=b;i=i;return}function xJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];HJc(a,b,f);i=e;return}function yJc(a,b){a=a|0;b=b|0;var c=0;a=i;c=GJc(0,b,0)|0;i=a;return c|0}function zJc(a,b){a=a|0;b=b|0;var c=0;c=i;FJc(a,b);i=c;return}function AJc(a,b,d){a=a|0;b=b|0;d=d|0;if((b|0)!=0){c[b>>2]=c[d>>2]}i=i;return}function BJc(a){a=a|0;var b=0,d=0;b=i;d=c[(eJc(a)|0)>>2]|0;i=b;return d|0}function CJc(a){a=a|0;var b=0,c=0;b=i;c=qJc(a)|0;i=b;return c|0}function DJc(a,b){a=a|0;b=b|0;if((b|0)!=0){c[b>>2]=0}i=i;return}function EJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0;d=i;i=i+48|0;e=d;f=d+8|0;g=d+16|0;h=d+24|0;j=d+40|0;vJc(j,b);b=f;k=j;c[b+0>>2]=c[k+0>>2];XIc(h,f);ZIc(g,h);f=e;k=g;c[f+0>>2]=c[k+0>>2];XIc(a,e);_Ic(h);i=d;return}function FJc(b,d){b=b|0;d=d|0;c[b>>2]=d;a[b+4|0]=0;a[b+5|0]=0;i=i;return}function GJc(a,b,c){a=a|0;b=b|0;c=c|0;c=i;a=n4c(b*24|0)|0;i=c;return a|0}function HJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(JJc(g)|0)>>2]|0;g=KJc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];IJc(b,a,f);i=e;return}function IJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;c[g+0>>2]=c[h+0>>2];c[g+4>>2]=c[h+4>>2];LJc(a,b,f);i=e;return}function JJc(a){a=a|0;i=i;return a|0}function KJc(a){a=a|0;i=i;return a|0}function LJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;c[g>>2]=b;b=a;a=c[(NJc(g)|0)>>2]|0;g=OJc(d)|0;d=g;g=c[d+4>>2]|0;j=h;c[j>>2]=c[d>>2];c[j+4>>2]=g;g=f;j=h;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];MJc(b,a,f);i=e;return}function MJc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+8|0;f=e;c[f>>2]=b;c[a>>2]=c[(NJc(f)|0)>>2];f=OJc(d)|0;d=f;f=c[d+4>>2]|0;b=a+4|0;c[b>>2]=c[d>>2];c[b+4>>2]=f;i=e;return}function NJc(a){a=a|0;i=i;return a|0}function OJc(a){a=a|0;i=i;return a|0}function PJc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+16|0;e=d;f=d+8|0;g=a;a=bJc(QJc(b)|0)|0;h=OJc(CJc(QJc(b)|0)|0)|0;b=h;h=c[b+4>>2]|0;j=f;c[j>>2]=c[b>>2];c[j+4>>2]=h;h=e;j=f;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];IJc(g,a,e);i=d;return}function QJc(a){a=a|0;i=i;return c[a>>2]|0}function RJc(a){a=a|0;var b=0;b=i;i=i+48|0;SJc(a);LGc(a+184|0,0,0);LGc(a+200|0,0,0);TJc(a+240|0,b);TJc(a+252|0,b+8|0);TJc(a+264|0,b+16|0);TJc(a+276|0,b+24|0);TJc(a+288|0,b+32|0);TJc(a+300|0,b+40|0);i=b;return}function SJc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;d=a+104|0;$Wc(d);e=a;c[e>>2]=334436;f=d;c[f>>2]=334456;d=a+4|0;gYc(a,334468|0,d);c[e>>2]=334436;c[f>>2]=334456;eKc(d);i=b;return}function TJc(a,b){a=a|0;b=b|0;b=i;UJc(a,0);i=b;return}function UJc(a,b){a=a|0;b=b|0;b=i;i=i+8|0;VJc(a,b);i=b;return}function VJc(a,b){a=a|0;b=b|0;b=i;WJc(a,0);i=b;return}function WJc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0;d=i;i=i+16|0;e=d;XJc(b+4|0);f=b+8|0;g=e;h=d+8|0;a[g+0|0]=a[h+0|0]|0;YJc(f,0,e);e=hHc(b)|0;c[(gJc(b)|0)>>2]=e;i=d;return}function XJc(a){a=a|0;var b=0;b=i;aKc(a);i=b;return}function YJc(b,c,d){b=b|0;c=c|0;d=d|0;var e=0,f=0,g=0,h=0;e=i;i=i+8|0;f=e;g=f;h=d;a[g+0|0]=a[h+0|0]|0;ZJc(b,c,f);i=e;return}function ZJc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0;e=i;i=i+24|0;f=e;g=e+8|0;c[g>>2]=d;d=b;b=c[($Jc(g)|0)>>2]|0;g=f;h=e+16|0;a[g+0|0]=a[h+0|0]|0;_Jc(d,b,f);i=e;return}function _Jc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;d=i;i=i+8|0;e=d;c[e>>2]=b;c[a>>2]=c[($Jc(e)|0)>>2];i=d;return}function $Jc(a){a=a|0;i=i;return a|0}function aKc(a){a=a|0;var b=0;b=i;bKc(a);i=b;return}function bKc(a){a=a|0;var b=0;b=i;cKc(a);i=b;return}function cKc(a){a=a|0;var b=0;b=i;dKc(a);i=b;return}function dKc(a){a=a|0;c[a>>2]=0;i=i;return}function eKc(a){a=a|0;var b=0;b=i;fKc(a);i=b;return}function fKc(d){d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+24|0;f=e;g=e+8|0;h=e+16|0;j=d;iXc(j);c[d>>2]=334592;c[d+32>>2]=0;c[d+36>>2]=0;c[d+40>>2]=0;k=d+68|0;l=d+52|0;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;xHc(f);f=d+98|0;l=k;c[l+0>>2]=0;c[l+4>>2]=0;c[l+8>>2]=0;c[l+12>>2]=0;c[l+16>>2]=0;c[l+20>>2]=0;c[l+24>>2]=0;b[l+28>>1]=0;a[l+30|0]=0;eXc(g,j);l=gKc(g)|0;M0c(g);if(!l){m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}eXc(h,j);c[k>>2]=KIc(h)|0;M0c(h);a[f]=(LIc(c[k>>2]|0)|0)&1;m=d;n=c[d>>2]|0;o=n;p=o+12|0;q=p;r=c[q>>2]|0;s=le[r&63](d,0,4096)|0;i=e;return}function gKc(a){a=a|0;var b=0,c=0;b=i;c=N0c(a,366424)|0;i=b;return c|0}function hKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+8|0;e=d;f=c[a+12>>2]|0;_Cc(3);g=f+8|0;h=g;j=c[g>>2]|0;g=f+12|0;k=c[g>>2]|0;if((j|0)<(k|0)){iKc(a,b,c[f>>2]|0,h);bDc(3);i=d;return}l=~~(+(k|0)*1.4+ +(k-j|0)+2.0e3);c[g>>2]=l;j=f+16|0;k=k4c(c[f>>2]|0,fa(l<<3,c[j>>2]|0)|0)|0;l=k;c[f>>2]=l;if((k|0)==0){k=c[b+536>>2]|0;c[e>>2]=fa(c[j>>2]|0,c[g>>2]|0)|0;IBc(k,334864,e)}iKc(a,b,l,h);bDc(3);i=d;return}function iKc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0.0,l=0,m=0,n=0.0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0;g=i;j=c[b+12>>2]|0;bDc(0);k=+VCc(0);_Cc(0);l=c[c[d+4>>2]>>2]|0;m=l;n=+h[m>>3];o=j+4|0;j=c[o>>2]|0;p=j+1|0;c[o>>2]=p;h[e+(j<<3)>>3]=n;if((c[b+8>>2]|0)==0){q=p}else{b=j+2|0;c[o>>2]=b;h[e+(p<<3)>>3]=k;q=b}b=d+116|0;p=c[b>>2]|0;if((p|0)>0){j=c[d+8>>2]|0;r=p;p=q;s=0;while(1){if((a[j+(s*112|0)+104|0]|0)==0){k=+h[(c[l+8>>2]|0)+(s<<3)>>3];t=p+1|0;c[o>>2]=t;h[e+(p<<3)>>3]=k;u=c[b>>2]|0;v=t}else{u=r;v=p}t=s+1|0;if((t|0)<(u|0)){r=u;p=v;s=t}else{w=v;break}}}else{w=q}q=d+124|0;v=c[q>>2]|0;if((v|0)>0){s=c[d+12>>2]|0;p=v;v=w;u=0;while(1){if((a[s+(u*60|0)+56|0]|0)==0){k=+(c[(c[l+12>>2]|0)+(u<<2)>>2]|0);r=v+1|0;c[o>>2]=r;h[e+(v<<3)>>3]=k;x=c[q>>2]|0;y=r}else{x=p;y=v}r=u+1|0;if((r|0)<(x|0)){p=x;v=y;u=r}else{z=y;break}}}else{z=w}w=d+128|0;y=c[w>>2]|0;if((y|0)>0){u=c[d+16>>2]|0;v=y;y=z;x=0;while(1){if((a[u+(x*48|0)+44|0]|0)==0){k=+(a[(c[l+16>>2]|0)+x|0]|0);p=y+1|0;c[o>>2]=p;h[e+(y<<3)>>3]=k;A=c[w>>2]|0;B=p}else{A=v;B=y}p=x+1|0;if((p|0)<(A|0)){v=A;y=B;x=p}else{C=B;break}}}else{C=z}z=d+216|0;if((c[z>>2]|0)>0){B=d+416|0;x=c[d+40>>2]|0;y=C;A=0;while(1){do{if((a[x+(A*52|0)+48|0]|0)==0){v=a[x+(A*52|0)+8|0]|0;do{if(v<<24>>24==2){D=m}else{w=c[x+(A*52|0)+4>>2]|0;if(v<<24>>24==1){D=(c[B>>2]|0)+(w<<3)|0;break}else{D=(c[l+8>>2]|0)+(w<<3)|0;break}}}while(0);k=+h[D>>3];if((c[x+(A*52|0)>>2]|0)==0){v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=k;E=v;break}else{v=y+1|0;c[o>>2]=v;h[e+(y<<3)>>3]=-k;E=v;break}}else{E=y}}while(0);v=A+1|0;if((v|0)<(c[z>>2]|0)){y=E;A=v}else{F=E;break}}}else{F=C}C=d+220|0;if((c[C>>2]|0)>0){E=d+40|0;A=d+420|0;y=c[d+44>>2]|0;z=F;x=0;while(1){do{if((a[y+(x*52|0)+48|0]|0)==0){D=c[(c[((a[y+(x*52|0)+8|0]|0)==1?A:l+12|0)>>2]|0)+(c[(c[E>>2]|0)+(x*52|0)+4>>2]<<2)>>2]|0;if((c[y+(x*52|0)>>2]|0)==0){B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(D|0);G=B;break}else{B=z+1|0;c[o>>2]=B;h[e+(z<<3)>>3]=+(0-D|0);G=B;break}}else{G=z}}while(0);B=x+1|0;if((B|0)<(c[C>>2]|0)){z=G;x=B}else{H=G;break}}}else{H=F}F=d+224|0;if((c[F>>2]|0)<=0){I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}G=d+44|0;x=d+40|0;z=d+424|0;C=c[d+48>>2]|0;d=H;H=0;while(1){do{if((a[C+(H*52|0)+48|0]|0)==0){y=a[(c[((a[(c[G>>2]|0)+(H*52|0)+8|0]|0)==1?z:l+16|0)>>2]|0)+(c[(c[x>>2]|0)+(H*52|0)+4>>2]|0)|0]|0;if((c[C+(H*52|0)>>2]|0)==0){E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24);K=E;break}else{E=d+1|0;c[o>>2]=E;h[e+(d<<3)>>3]=+(y<<24>>24!=1|0);K=E;break}}else{K=d}}while(0);E=H+1|0;if((E|0)<(c[F>>2]|0)){d=K;H=E}else{break}}I=c[f>>2]|0;J=I+1|0;c[f>>2]=J;i=g;return}function jKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;d=i;i=i+8|0;e=d;f=i;i=i+8|0;g=h4c(24)|0;_Cc(3);c[g>>2]=0;h=g+4|0;c[h>>2]=0;c[g+8>>2]=0;j=g+16|0;c[j>>2]=0;k=a+4|0;l=c[k>>2]|0;c[g+12>>2]=l;m=b+536|0;HBc(c[m>>2]|0,l>>>31^1,334920,f);f=b+8|0;b=c[a+8>>2]|0;l=kKc(b,f)|0;c[g+20>>2]=l;l=kKc(b,f)|0;c[j>>2]=l;j=c[k>>2]|0;k=h4c(fa(l<<3,j)|0)|0;c[g>>2]=k;if((k|0)==0){k=c[m>>2]|0;c[e>>2]=fa(l,j)|0;IBc(k,335e3,e)}else{c[h>>2]=0;c[a+12>>2]=g;bDc(3);i=d;return}}function kKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;e=i;f=(b|0)==0?1:2;b=c[d+108>>2]|0;if((b|0)>0){g=c[d>>2]|0;h=0;j=f;while(1){k=((a[g+(h*112|0)+104|0]|0)==0)+j|0;l=h+1|0;if((l|0)<(b|0)){j=k;h=l}else{m=k;break}}}else{m=f}f=c[d+116>>2]|0;if((f|0)>0){h=c[d+4>>2]|0;j=0;b=m;while(1){g=((a[h+(j*60|0)+56|0]|0)==0)+b|0;k=j+1|0;if((k|0)<(f|0)){b=g;j=k}else{n=g;break}}}else{n=m}m=c[d+120>>2]|0;if((m|0)>0){j=c[d+8>>2]|0;b=0;f=n;while(1){h=((a[j+(b*48|0)+44|0]|0)==0)+f|0;g=b+1|0;if((g|0)<(m|0)){f=h;b=g}else{o=h;break}}}else{o=n}n=c[d+208>>2]|0;if((n|0)>0){b=c[d+32>>2]|0;f=0;m=o;while(1){j=((a[b+(f*52|0)+48|0]|0)==0)+m|0;h=f+1|0;if((h|0)<(n|0)){m=j;f=h}else{p=j;break}}}else{p=o}o=c[d+212>>2]|0;if((o|0)>0){f=c[d+36>>2]|0;m=0;n=p;while(1){b=((a[f+(m*52|0)+48|0]|0)==0)+n|0;j=m+1|0;if((j|0)<(o|0)){n=b;m=j}else{q=b;break}}}else{q=p}p=c[d+216>>2]|0;if((p|0)<=0){r=q;i=e;return r|0}m=c[d+40>>2]|0;d=0;n=q;while(1){q=((a[m+(d*52|0)+48|0]|0)==0)+n|0;o=d+1|0;if((o|0)<(p|0)){n=q;d=o}else{r=q;break}}i=e;return r|0}function lKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0;e=i;i=i+8|0;f=e;g=i;i=i+8|0;j=i;i=i+8|0;k=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;n=i;i=i+8|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=b+12|0;s=c[r>>2]|0;t=s;_Cc(3);u=b;v=ic(c[u>>2]|0,335064)|0;if((v|0)==0){mKc(t);w=c[d+536>>2]|0;x=c[u>>2]|0;y=Wd(c[(Nc()|0)>>2]|0)|0;c[q>>2]=x;c[q+4>>2]=y;IBc(w,335072,q)}rc(335128,46,1,v|0)|0;q=s+20|0;c[p>>2]=c[q>>2];wd(v|0,335176,p|0)|0;p=s+8|0;c[o>>2]=c[p>>2];wd(v|0,335200,o|0)|0;rc(335224,40,1,v|0)|0;rc(335272,11,1,v|0)|0;rc(335288,14,1,v|0)|0;if((c[p>>2]|0)>0){o=0;do{w=fa(c[q>>2]|0,o)|0;z=+h[(c[s>>2]|0)+(w<<3)>>3];nKc(v,z,z);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;if((c[b+8>>2]|0)==0){A=1}else{rc(335304,18,1,v|0)|0;if((c[p>>2]|0)>0){b=0;do{o=fa(c[q>>2]|0,b)|0;w=c[s>>2]|0;nKc(v,+h[w+(o<<3)>>3],+h[w+(o+1<<3)>>3]);b=b+1|0;}while((b|0)<(c[p>>2]|0))}Sd(10,v|0)|0;A=2}b=d+116|0;o=c[b>>2]|0;if((o|0)>0){w=d+8|0;y=o;o=0;x=A;while(1){B=c[w>>2]|0;if((a[B+(o*112|0)+104|0]|0)==0){c[n>>2]=c[B+(o*112|0)+4>>2];wd(v|0,335328,n|0)|0;if((c[p>>2]|0)>0){B=0;do{C=fa(c[q>>2]|0,B)|0;D=c[s>>2]|0;nKc(v,+h[D+(C<<3)>>3],+h[D+(C+x<<3)>>3]);B=B+1|0;}while((B|0)<(c[p>>2]|0))}Sd(10,v|0)|0;E=c[b>>2]|0;F=x+1|0}else{E=y;F=x}B=o+1|0;if((B|0)<(E|0)){y=E;o=B;x=F}else{G=F;break}}}else{G=A}A=d+124|0;F=c[A>>2]|0;if((F|0)>0){x=d+12|0;o=F;F=0;E=G;while(1){y=c[x>>2]|0;if((a[y+(F*60|0)+56|0]|0)==0){c[m>>2]=c[y+(F*60|0)+4>>2];wd(v|0,335328,m|0)|0;if((c[p>>2]|0)>0){y=0;do{b=fa(c[q>>2]|0,y)|0;n=c[s>>2]|0;nKc(v,+h[n+(b<<3)>>3],+h[n+(b+E<<3)>>3]);y=y+1|0;}while((y|0)<(c[p>>2]|0))}Sd(10,v|0)|0;H=c[A>>2]|0;I=E+1|0}else{H=o;I=E}y=F+1|0;if((y|0)<(H|0)){o=H;F=y;E=I}else{J=I;break}}}else{J=G}G=d+128|0;I=c[G>>2]|0;if((I|0)>0){E=d+16|0;F=I;I=0;H=J;while(1){o=c[E>>2]|0;if((a[o+(I*48|0)+44|0]|0)==0){c[l>>2]=c[o+(I*48|0)+4>>2];wd(v|0,335328,l|0)|0;if((c[p>>2]|0)>0){o=0;do{A=fa(c[q>>2]|0,o)|0;m=c[s>>2]|0;nKc(v,+h[m+(A<<3)>>3],+h[m+(A+H<<3)>>3]);o=o+1|0;}while((o|0)<(c[p>>2]|0))}Sd(10,v|0)|0;K=c[G>>2]|0;L=H+1|0}else{K=F;L=H}o=I+1|0;if((o|0)<(K|0)){F=K;I=o;H=L}else{M=L;break}}}else{M=J}J=d+216|0;L=c[J>>2]|0;if((L|0)>0){H=d+40|0;I=L;L=0;K=M;while(1){F=c[H>>2]|0;if((a[F+(L*52|0)+48|0]|0)==0){c[k>>2]=c[F+(L*52|0)+16>>2];wd(v|0,335328,k|0)|0;if((c[p>>2]|0)>0){F=0;do{G=fa(c[q>>2]|0,F)|0;l=c[s>>2]|0;nKc(v,+h[l+(G<<3)>>3],+h[l+(G+K<<3)>>3]);F=F+1|0;}while((F|0)<(c[p>>2]|0))}Sd(10,v|0)|0;N=c[J>>2]|0;O=K+1|0}else{N=I;O=K}F=L+1|0;if((F|0)<(N|0)){I=N;L=F;K=O}else{P=O;break}}}else{P=M}M=d+220|0;O=c[M>>2]|0;if((O|0)>0){K=d+44|0;L=O;O=0;N=P;while(1){I=c[K>>2]|0;if((a[I+(O*52|0)+48|0]|0)==0){c[j>>2]=c[I+(O*52|0)+16>>2];wd(v|0,335328,j|0)|0;if((c[p>>2]|0)>0){I=0;do{J=fa(c[q>>2]|0,I)|0;k=c[s>>2]|0;nKc(v,+h[k+(J<<3)>>3],+h[k+(J+N<<3)>>3]);I=I+1|0;}while((I|0)<(c[p>>2]|0))}Sd(10,v|0)|0;Q=c[M>>2]|0;R=N+1|0}else{Q=L;R=N}I=O+1|0;if((I|0)<(Q|0)){L=Q;O=I;N=R}else{S=R;break}}}else{S=P}P=d+224|0;R=c[P>>2]|0;if((R|0)>0){N=d+48|0;O=R;R=0;Q=S;while(1){S=c[N>>2]|0;if((a[S+(R*52|0)+48|0]|0)==0){c[g>>2]=c[S+(R*52|0)+16>>2];wd(v|0,335328,g|0)|0;if((c[p>>2]|0)>0){S=0;do{L=fa(c[q>>2]|0,S)|0;M=c[s>>2]|0;nKc(v,+h[M+(L<<3)>>3],+h[M+(L+Q<<3)>>3]);S=S+1|0;}while((S|0)<(c[p>>2]|0))}Sd(10,v|0)|0;T=c[P>>2]|0;U=Q+1|0}else{T=O;U=Q}S=R+1|0;if((S|0)<(T|0)){O=T;R=S;Q=U}else{break}}}mKc(t);if((Yc(v|0)|0)==0){i4c(c[r>>2]|0);c[r>>2]=0;bDc(3);i=e;return}else{e=c[d+536>>2]|0;c[f>>2]=c[u>>2];IBc(e,335344,f)}}function mKc(a){a=a|0;var b=0,d=0;b=i;d=a;a=c[d>>2]|0;if((a|0)==0){i=b;return}i4c(a);c[d>>2]=0;i=b;return}function nKc(a,b,d){a=a|0;b=+b;d=+d;var e=0,f=0,g=0;e=i;i=i+16|0;f=e;g=f;h[k>>3]=b;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];g=f+8|0;h[k>>3]=d;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];wd(a|0,335392,f|0)|0;i=e;return}function oKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+40|0;e=d;f=d+16|0;g=d+32|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=n4c(192)|0;P4c(m|0,0,192)|0;pKc(m);c[a+12>>2]=m;n=m;o=a;MGc(n,c[o>>2]|0,36);if(PWc(m+(c[(c[m>>2]|0)+ -12>>2]|0)|0)|0){a=c[b+536>>2]|0;c[g>>2]=c[o>>2];IBc(a,335432,g)}else{g=m;sYc(g,335408,14)|0;tYc(h,g);a=ZHc(h)|0;h=m+184|0;c[h>>2]=a;sYc(g,335424,4)|0;qKc(n,b+8|0);tYc(j,g);b=ZHc(j)|0;j=m+188|0;c[j>>2]=b;m=c[h>>2]|0;LGc(k,m,((m|0)<0)<<31>>31);h=f;a=k;c[h+0>>2]=c[a+0>>2];c[h+4>>2]=c[a+4>>2];c[h+8>>2]=c[a+8>>2];c[h+12>>2]=c[a+12>>2];uYc(g,f)|0;rKc(n,-4-m+b|0);b=c[j>>2]|0;LGc(l,b,((b|0)<0)<<31>>31);b=e;j=l;c[b+0>>2]=c[j+0>>2];c[b+4>>2]=c[j+4>>2];c[b+8>>2]=c[j+8>>2];c[b+12>>2]=c[j+12>>2];uYc(g,e)|0;bDc(3);i=d;return}}function pKc(a){a=a|0;var b=0;b=i;KKc(a);i=b;return}function qKc(a,b){a=a|0;b=b|0;var c=0;c=i;tKc(a,3);uKc(a,335608);tKc(a,0);uKc(a,335616);tKc(a,2);FKc(a,b);GKc(a,b);uKc(a,335624);tKc(a,0);i=c;return}function rKc(a,b){a=a|0;b=b|0;var d=0;d=i;c[83900]=Hd(b|0)|0;sYc(a,335600,4)|0;i=d;return}function sKc(b,d,e,f){b=b|0;d=+d;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;g=i;i=i+112|0;j=g;k=g+16|0;l=g+32|0;m=g+48|0;n=g+64|0;o=g+80|0;p=g+96|0;q=b;tYc(l,q);r=ZHc(l)|0;rKc(b,0);tYc(m,q);l=ZHc(m)|0;tKc(b,1);uKc(b,335496);m=e+128|0;s=e+132|0;t=e+136|0;u=e+140|0;vKc(b,(c[m>>2]|0)+1+(c[s>>2]|0)+(c[t>>2]|0)+(c[u>>2]|0)|0);wKc(b,d);if((c[m>>2]|0)>0){e=f+176|0;v=0;do{wKc(b,+h[(c[e>>2]|0)+(v<<3)>>3]);v=v+1|0;}while((v|0)<(c[m>>2]|0))}if((c[s>>2]|0)>0){m=f+180|0;v=0;do{xKc(b,c[(c[m>>2]|0)+(v<<2)>>2]|0);v=v+1|0;}while((v|0)<(c[s>>2]|0))}if((c[t>>2]|0)>0){s=f+184|0;v=0;do{yKc(b,(a[(c[s>>2]|0)+v|0]|0)!=0);v=v+1|0;}while((v|0)<(c[t>>2]|0))}if((c[u>>2]|0)>0){t=f+188|0;f=0;do{uKc(b,c[(c[t>>2]|0)+(f<<2)>>2]|0);f=f+1|0;}while((f|0)<(c[u>>2]|0))}tYc(n,q);u=ZHc(n)|0;n=M4c(0,r|0,32)|0;LGc(o,n,J);n=k;r=o;c[n+0>>2]=c[r+0>>2];c[n+4>>2]=c[r+4>>2];c[n+8>>2]=c[r+8>>2];c[n+12>>2]=c[r+12>>2];uYc(q,k)|0;rKc(b,u-l|0);LGc(p,u,((u|0)<0)<<31>>31);u=j;l=p;c[u+0>>2]=c[l+0>>2];c[u+4>>2]=c[l+4>>2];c[u+8>>2]=c[l+8>>2];c[u+12>>2]=c[l+12>>2];uYc(q,j)|0;i=g;return}function tKc(b,d){b=b|0;d=d|0;var e=0;e=i;a[335584]=-33;c[83898]=Hd(d|0)|0;d=b;sYc(d,335584,1)|0;sYc(d,335592,4)|0;i=e;return}function uKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+8|0;f=e;c[f>>2]=Hd(L4c(d|0)|0)|0;a[335576]=-37;g=b;sYc(g,335576,1)|0;sYc(g,f,4)|0;sYc(g,d,L4c(d|0)|0)|0;i=e;return}function vKc(b,d){b=b|0;d=d|0;var e=0;e=i;a[335560]=-35;c[83892]=Hd(d|0)|0;d=b;sYc(d,335560,1)|0;sYc(d,335568,4)|0;i=e;return}function wKc(b,c){b=b|0;c=+c;var d=0,e=0;d=i;a[335544]=-53;EKc(c);e=b;sYc(e,335544,1)|0;sYc(e,335552,8)|0;i=d;return}function xKc(b,d){b=b|0;d=d|0;var e=0;e=i;a[335528]=-46;c[83884]=Hd(d|0)|0;d=b;sYc(d,335528,1)|0;sYc(d,335536,4)|0;i=e;return}function yKc(b,c){b=b|0;c=c|0;var d=0;d=i;a[335520]=c?-61:-62;sYc(b,335520,1)|0;i=d;return}function zKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=c[a+12>>2]|0;a=b+8|0;f=b+240|0;sKc(e,+h[f>>3],a,f);sKc(e,+h[b+248>>3],a,f);i=d;return}function AKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;e=i;i=i+112|0;f=e;g=e+16|0;j=e+32|0;k=e+48|0;l=e+64|0;m=e+80|0;n=e+96|0;o=c[b+12>>2]|0;b=o;p=o;tYc(j,p);o=ZHc(j)|0;rKc(b,0);tYc(k,p);j=ZHc(k)|0;tKc(b,1);uKc(b,335504);k=d+116|0;q=d+124|0;r=d+128|0;s=d+132|0;vKc(b,(c[k>>2]|0)+1+(c[q>>2]|0)+(c[r>>2]|0)+(c[s>>2]|0)|0);t=d+4|0;wKc(b,+h[c[c[t>>2]>>2]>>3]);if((c[k>>2]|0)>0){d=0;do{wKc(b,+h[(c[(c[c[t>>2]>>2]|0)+8>>2]|0)+(d<<3)>>3]);d=d+1|0;}while((d|0)<(c[k>>2]|0))}if((c[q>>2]|0)>0){k=0;do{xKc(b,c[(c[(c[c[t>>2]>>2]|0)+12>>2]|0)+(k<<2)>>2]|0);k=k+1|0;}while((k|0)<(c[q>>2]|0))}if((c[r>>2]|0)>0){q=0;do{yKc(b,(a[(c[(c[c[t>>2]>>2]|0)+16>>2]|0)+q|0]|0)!=0);q=q+1|0;}while((q|0)<(c[r>>2]|0))}if((c[s>>2]|0)>0){r=0;do{uKc(b,c[(c[(c[c[t>>2]>>2]|0)+20>>2]|0)+(r<<2)>>2]|0);r=r+1|0;}while((r|0)<(c[s>>2]|0))}tYc(l,p);s=ZHc(l)|0;l=M4c(0,o|0,32)|0;LGc(m,l,J);l=g;o=m;c[l+0>>2]=c[o+0>>2];c[l+4>>2]=c[o+4>>2];c[l+8>>2]=c[o+8>>2];c[l+12>>2]=c[o+12>>2];uYc(p,g)|0;rKc(b,s-j|0);LGc(n,s,((s|0)<0)<<31>>31);s=f;j=n;c[s+0>>2]=c[j+0>>2];c[s+4>>2]=c[j+4>>2];c[s+8>>2]=c[j+8>>2];c[s+12>>2]=c[j+12>>2];uYc(p,f)|0;i=e;return}function BKc(a,b){a=a|0;b=b|0;var d=0;b=i;d=a+12|0;a=c[d>>2]|0;FGc(a);_Cc(3);if((a|0)!=0){CKc(a);p4c(a)}c[d>>2]=0;bDc(3);i=b;return}function CKc(a){a=a|0;var b=0;b=i;DKc(a);i=b;return}function DKc(a){a=a|0;var b=0;b=i;aIc(a);i=b;return}function EKc(b){b=+b;var d=0,e=0,f=0,g=0,j=0;d=i;i=i+8|0;e=d;h[e>>3]=b;if((Hd(1)|0)==1){f=e;g=c[f+4>>2]|0;j=335552;c[j>>2]=c[f>>2];c[j+4>>2]=g;i=d;return}h[k>>3]=b;g=c[k>>2]&255;j=0;while(1){a[335552+(7-j)|0]=g;f=j+1|0;if((f|0)>=8){break}g=a[e+f|0]|0;j=f}i=d;return}function FKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+16|0;e=d;uKc(a,335496);tKc(a,4);uKc(a,335632);tKc(a,0);uKc(a,335640);f=b+128|0;g=b+132|0;h=b+136|0;j=b+140|0;vKc(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);uKc(a,335648);if((c[f>>2]|0)>0){k=b+16|0;l=0;do{uKc(a,c[(c[k>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){l=b+20|0;k=0;do{uKc(a,c[(c[l>>2]|0)+(k*60|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){k=b+24|0;l=0;do{uKc(a,c[(c[k>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)>0){l=b+28|0;k=0;do{uKc(a,c[(c[l>>2]|0)+(k*52|0)+4>>2]|0);k=k+1|0;}while((k|0)<(c[j>>2]|0))}k=e;l=335736;c[k+0>>2]=c[l+0>>2];c[k+4>>2]=c[l+4>>2];c[k+8>>2]=c[l+8>>2];HKc(a,b,e);uKc(a,335672);tKc(a,(c[f>>2]|0)+1+(c[g>>2]|0)+(c[h>>2]|0)+(c[j>>2]|0)|0);IKc(a,335648,335680);if((c[f>>2]|0)>0){e=b+16|0;l=0;do{k=c[e>>2]|0;IKc(a,c[k+(l*112|0)+4>>2]|0,c[k+(l*112|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[g>>2]|0)>0){f=b+20|0;l=0;do{e=c[f>>2]|0;IKc(a,c[e+(l*60|0)+4>>2]|0,c[e+(l*60|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[g>>2]|0))}if((c[h>>2]|0)>0){g=b+24|0;l=0;do{f=c[g>>2]|0;IKc(a,c[f+(l*48|0)+4>>2]|0,c[f+(l*48|0)+8>>2]|0);l=l+1|0;}while((l|0)<(c[h>>2]|0))}if((c[j>>2]|0)<=0){i=d;return}h=b+28|0;b=0;do{l=c[h>>2]|0;IKc(a,c[l+(b*52|0)+4>>2]|0,c[l+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[j>>2]|0));i=d;return}function GKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;d=i;i=i+16|0;e=d;f=b+108|0;g=c[f>>2]|0;h=b+116|0;j=c[h>>2]|0;k=b+120|0;l=c[k>>2]|0;m=b+124|0;n=c[m>>2]|0;uKc(a,335504);tKc(a,4);uKc(a,335632);tKc(a,0);uKc(a,335640);o=g+1+j+l+n|0;vKc(a,o);uKc(a,335648);if((c[f>>2]|0)>0){n=b;l=0;do{uKc(a,c[(c[n>>2]|0)+(l*112|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){l=b+4|0;n=0;do{uKc(a,c[(c[l>>2]|0)+(n*60|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){n=b+8|0;l=0;do{uKc(a,c[(c[n>>2]|0)+(l*48|0)+4>>2]|0);l=l+1|0;}while((l|0)<(c[k>>2]|0))}if((c[m>>2]|0)>0){l=b+12|0;n=0;do{uKc(a,c[(c[l>>2]|0)+(n*52|0)+4>>2]|0);n=n+1|0;}while((n|0)<(c[m>>2]|0))}n=e;l=335656;c[n+0>>2]=c[l+0>>2];c[n+4>>2]=c[l+4>>2];c[n+8>>2]=c[l+8>>2];HKc(a,b,e);uKc(a,335672);tKc(a,o);IKc(a,335648,335680);if((c[f>>2]|0)>0){o=b;e=0;do{l=c[o>>2]|0;IKc(a,c[l+(e*112|0)+4>>2]|0,c[l+(e*112|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[f>>2]|0))}if((c[h>>2]|0)>0){f=b+4|0;e=0;do{o=c[f>>2]|0;IKc(a,c[o+(e*60|0)+4>>2]|0,c[o+(e*60|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[h>>2]|0))}if((c[k>>2]|0)>0){h=b+8|0;e=0;do{f=c[h>>2]|0;IKc(a,c[f+(e*48|0)+4>>2]|0,c[f+(e*48|0)+8>>2]|0);e=e+1|0;}while((e|0)<(c[k>>2]|0))}if((c[m>>2]|0)<=0){i=d;return}k=b+12|0;b=0;do{e=c[k>>2]|0;IKc(a,c[e+(b*52|0)+4>>2]|0,c[e+(b*52|0)+8>>2]|0);b=b+1|0;}while((b|0)<(c[m>>2]|0));i=d;return}function HKc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0;f=i;uKc(b,335704);g=d+208|0;h=c[g>>2]|0;if((h|0)>0){j=c[d+32>>2]|0;k=0;l=0;while(1){m=(c[e+(a[j+(k*52|0)+8|0]<<2)>>2]|0)+l|0;n=k+1|0;if((n|0)<(h|0)){l=m;k=n}else{o=m;break}}}else{o=0}k=d+212|0;l=c[k>>2]|0;if((l|0)>0){h=c[d+36>>2]|0;j=0;m=o;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{q=n;break}}}else{q=o}o=d+216|0;j=c[o>>2]|0;if((j|0)>0){m=c[d+40>>2]|0;l=0;h=q;while(1){n=(c[e+(a[m+(l*52|0)+8|0]<<2)>>2]|0)+h|0;p=l+1|0;if((p|0)<(j|0)){h=n;l=p}else{r=n;break}}}else{r=q}q=d+220|0;l=c[q>>2]|0;if((l|0)>0){h=c[d+44>>2]|0;j=0;m=r;while(1){n=(c[e+(a[h+(j*52|0)+8|0]<<2)>>2]|0)+m|0;p=j+1|0;if((p|0)<(l|0)){m=n;j=p}else{s=n;break}}}else{s=r}tKc(b,s);s=c[g>>2]|0;if((s|0)>0){r=d+32|0;j=d+16|0;m=d;l=s;s=0;h=0;while(1){n=c[r>>2]|0;p=a[n+(s*52|0)+8|0]|0;if((c[e+(p<<24>>24<<2)>>2]|0)==0){t=l;u=h}else{v=p<<24>>24==2?335648:h;if(p<<24>>24==1){w=c[(c[j>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else if(p<<24>>24==0){w=c[(c[m>>2]|0)+((c[n+(s*52|0)+4>>2]|0)*112|0)+4>>2]|0}else{w=v}JKc(b,c[n+(s*52|0)+16>>2]|0,w,(c[n+(s*52|0)>>2]|0)!=0);t=c[g>>2]|0;u=w}n=s+1|0;if((n|0)<(t|0)){l=t;s=n;h=u}else{x=u;break}}}else{x=0}u=c[k>>2]|0;if((u|0)>0){h=d+36|0;s=d+20|0;t=d+4|0;l=u;u=0;w=x;while(1){g=c[h>>2]|0;m=a[g+(u*52|0)+8|0]|0;if((c[e+(m<<24>>24<<2)>>2]|0)==0){y=l;z=w}else{j=m<<24>>24==2?335648:w;if(m<<24>>24==1){A=c[(c[s>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else if(m<<24>>24==0){A=c[(c[t>>2]|0)+((c[g+(u*52|0)+4>>2]|0)*60|0)+4>>2]|0}else{A=j}JKc(b,c[g+(u*52|0)+16>>2]|0,A,(c[g+(u*52|0)>>2]|0)!=0);y=c[k>>2]|0;z=A}g=u+1|0;if((g|0)<(y|0)){l=y;u=g;w=z}else{B=z;break}}}else{B=x}x=c[o>>2]|0;if((x|0)>0){z=d+40|0;w=d+24|0;u=d+8|0;y=x;x=0;l=B;while(1){A=c[z>>2]|0;k=a[A+(x*52|0)+8|0]|0;if((c[e+(k<<24>>24<<2)>>2]|0)==0){C=y;D=l}else{t=k<<24>>24==2?335648:l;if(k<<24>>24==1){E=c[(c[w>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else if(k<<24>>24==0){E=c[(c[u>>2]|0)+((c[A+(x*52|0)+4>>2]|0)*48|0)+4>>2]|0}else{E=t}JKc(b,c[A+(x*52|0)+16>>2]|0,E,(c[A+(x*52|0)>>2]|0)!=0);C=c[o>>2]|0;D=E}A=x+1|0;if((A|0)<(C|0)){y=C;x=A;l=D}else{F=D;break}}}else{F=B}B=c[q>>2]|0;if((B|0)<=0){i=f;return}D=d+44|0;l=d+28|0;x=d+12|0;d=B;B=0;C=F;while(1){F=c[D>>2]|0;y=a[F+(B*52|0)+8|0]|0;if((c[e+(y<<24>>24<<2)>>2]|0)==0){G=d;H=C}else{E=y<<24>>24==2?335648:C;if(y<<24>>24==1){I=c[(c[l>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else if(y<<24>>24==0){I=c[(c[x>>2]|0)+((c[F+(B*52|0)+4>>2]|0)*52|0)+4>>2]|0}else{I=E}JKc(b,c[F+(B*52|0)+16>>2]|0,I,(c[F+(B*52|0)>>2]|0)!=0);G=c[q>>2]|0;H=I}F=B+1|0;if((F|0)<(G|0)){d=G;B=F;C=H}else{break}}i=f;return}function IKc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0;d=i;uKc(a,b);tKc(a,1);uKc(a,335688);uKc(a,c);i=d;return}function JKc(a,b,c,d){a=a|0;b=b|0;c=c|0;d=d|0;var e=0;e=i;uKc(a,b);tKc(a,d?2:1);uKc(a,335712);uKc(a,c);if(!d){i=e;return}uKc(a,335720);uKc(a,335728);i=e;return}function KKc(a){a=a|0;var b=0;b=i;SJc(a);i=b;return}function LKc(a,b){a=a|0;b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0;c=i;i=i+288|0;d=c;e=c+16|0;f=c+32|0;g=c+48|0;h=c+64|0;j=c+80|0;k=c+96|0;l=c+112|0;m=c+128|0;n=c+144|0;o=c+160|0;p=c+176|0;q=c+192|0;r=c+208|0;s=c+224|0;t=c+240|0;u=c+256|0;v=c+272|0;YVc(e,335752);UVc(d,NKc(a,e)|0);MKc(d,b+4|0);cWc(d);cWc(e);YVc(g,335760);UVc(f,NKc(a,g)|0);OKc(f,b);cWc(f);cWc(g);YVc(j,335776);UVc(h,NKc(a,j)|0);MKc(h,b+8|0);cWc(h);cWc(j);YVc(l,335792);UVc(k,NKc(a,l)|0);MKc(k,b+12|0);cWc(k);cWc(l);YVc(n,335808);UVc(m,NKc(a,n)|0);PKc(m,b+16|0,0);cWc(m);cWc(n);YVc(p,335824);UVc(o,NKc(a,p)|0);PKc(o,b+20|0,0);cWc(o);cWc(p);YVc(r,335840);UVc(q,NKc(a,r)|0);PKc(q,b+24|0,0);cWc(q);cWc(r);YVc(t,335848);UVc(s,NKc(a,t)|0);PKc(s,b+28|0,0);cWc(s);cWc(t);YVc(v,335864);UVc(u,NKc(a,v)|0);PKc(u,b+32|0,0);cWc(u);cWc(v);i=c;return}function MKc(a,b){a=a|0;b=b|0;var d=0;d=i;i=i+8|0;if((b|0)==0){GBc(22,0,339072,d);i=d;return}else{c[b>>2]=Ad(zWc(a)|0)|0;i=d;return}}function NKc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=i;i=i+64|0;e=d;f=d+8|0;g=d+24|0;h=d+40|0;j=d+48|0;k=WOc(a,f,b)|0;l=c[k>>2]|0;xHc(d+16|0);if((l|0)!=0){m=l;n=m;o=n+28|0;p=o;i=d;return p|0}YOc(j,a,b);ZOc(h,j);b=e;l=h;c[b+0>>2]=c[l+0>>2];XOc(g,e);_Oc(j);j=c[f>>2]|0;$Oc(a,j,k,aPc(g)|0);k=bPc(g)|0;_Oc(g);m=k;n=m;o=n+28|0;p=o;i=d;return p|0}function OKc(a,b){a=a|0;b=b|0;var d=0;d=i;if((CWc(a,336040)|0)==0){c[b>>2]=1;i=d;return}if((CWc(a,336048)|0)==0){c[b>>2]=0;i=d;return}else{c[b>>2]=Fc(zWc(a)|0)|0;i=d;return}}function PKc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0;e=i;if((CWc(a,336016)|0)==0){c[b>>2]=d}if((CWc(a,336040)|0)==0){c[b>>2]=1;i=e;return}if((CWc(a,336048)|0)==0){c[b>>2]=0;i=e;return}else{c[b>>2]=Fc(zWc(a)|0)|0;i=e;return}}function QKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0.0,A=0.0,B=0.0,C=0.0;e=i;i=i+56|0;f=e;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;s=i;i=i+16|0;t=i;i=i+16|0;u=i;i=i+16|0;v=i;i=i+16|0;w=i;i=i+16|0;x=i;i=i+16|0;YVc(j,335880);UVc(g,NKc(b,j)|0);y=d+48|0;RKc(g,y);cWc(g);cWc(j);YVc(m,335896);UVc(l,NKc(b,m)|0);j=d+56|0;SKc(l,j,0.0);cWc(l);cWc(m);YVc(o,335904);UVc(n,NKc(b,o)|0);m=d+32|0;RKc(n,m);cWc(n);cWc(o);YVc(q,335912);UVc(p,NKc(b,q)|0);o=d+33|0;RKc(p,o);cWc(p);cWc(q);YVc(s,335928);UVc(r,NKc(b,s)|0);q=d+40|0;SKc(r,q,1.0);cWc(r);cWc(s);YVc(u,335936);UVc(t,NKc(b,u)|0);s=d+16|0;SKc(t,s,-1.7976931348623157e+308);cWc(t);cWc(u);YVc(w,335944);UVc(v,NKc(b,w)|0);u=d+24|0;SKc(v,u,1.7976931348623157e+308);cWc(v);cWc(w);YVc(x,335752);w=zWc(NKc(b,x)|0)|0;b=(a[y]|0)!=0;z=+h[j>>3];j=(a[m]|0)!=0?336040:336048;m=(a[o]|0)!=0;A=+h[q>>3];B=+h[s>>3];C=+h[u>>3];c[f>>2]=w;c[f+4>>2]=b?336016:336024;w=f+8|0;h[k>>3]=z;c[w>>2]=c[k>>2];c[w+4>>2]=c[k+4>>2];c[f+16>>2]=b?336016:336032;c[f+20>>2]=j;c[f+24>>2]=m?336016:336024;j=f+28|0;h[k>>3]=A;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];c[f+36>>2]=m?336016:336032;m=f+40|0;h[k>>3]=B;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];m=f+48|0;h[k>>3]=C;c[m>>2]=c[k>>2];c[m+4>>2]=c[k+4>>2];EBc(4,0,335952,f);cWc(x);i=e;return}function RKc(b,c){b=b|0;c=c|0;var d=0;d=i;a[c]=(CWc(b,336040)|0)==0|0;i=d;return}function SKc(a,b,c){a=a|0;b=b|0;c=+c;var d=0;d=i;if((CWc(a,336016)|0)==0){h[b>>3]=c;i=d;return}if((CWc(a,336040)|0)==0){h[b>>3]=1.0;i=d;return}if((CWc(a,336048)|0)==0){h[b>>3]=0.0;i=d;return}else{h[b>>3]=+D4c(zWc(a)|0);i=d;return}}function TKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+32|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=i;i=i+16|0;q=i;i=i+16|0;r=i;i=i+16|0;YVc(h,335880);UVc(g,NKc(b,h)|0);s=d+13|0;RKc(g,s);cWc(g);cWc(h);YVc(k,335896);UVc(j,NKc(b,k)|0);h=d+16|0;PKc(j,h,0);cWc(j);cWc(k);YVc(m,335904);UVc(l,NKc(b,m)|0);k=d+12|0;RKc(l,k);cWc(l);cWc(m);YVc(o,335936);UVc(n,NKc(b,o)|0);m=d+4|0;PKc(n,m,-2147483648);cWc(n);cWc(o);YVc(q,335944);UVc(p,NKc(b,q)|0);o=d+8|0;PKc(p,o,2147483647);cWc(p);cWc(q);YVc(r,335752);q=zWc(NKc(b,r)|0)|0;b=(a[s]|0)!=0;s=c[h>>2]|0;h=(a[k]|0)!=0?336040:336048;k=c[m>>2]|0;m=c[o>>2]|0;c[f>>2]=q;c[f+4>>2]=b?336016:336024;c[f+8>>2]=s;c[f+12>>2]=b?336016:336032;c[f+16>>2]=h;c[f+20>>2]=k;c[f+24>>2]=m;EBc(4,0,336056,f);cWc(r);i=e;return}function UKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+24|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;YVc(h,335880);UVc(g,NKc(b,h)|0);o=d+5|0;RKc(g,o);cWc(g);cWc(h);YVc(k,335896);UVc(j,NKc(b,k)|0);h=d+6|0;RKc(j,h);cWc(j);cWc(k);YVc(m,335904);UVc(l,NKc(b,m)|0);k=d+4|0;RKc(l,k);cWc(l);cWc(m);YVc(n,335752);m=zWc(NKc(b,n)|0)|0;b=(a[o]|0)!=0;o=(a[h]|0)!=0?336040:336048;h=(a[k]|0)!=0?336040:336048;c[f>>2]=m;c[f+4>>2]=b?336016:336024;c[f+8>>2]=o;c[f+12>>2]=b?336016:336032;c[f+16>>2]=h;EBc(4,0,336112,f);cWc(n);i=e;return}function VKc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+16|0;f=e;g=i;i=i+16|0;h=i;i=i+16|0;j=i;i=i+16|0;k=i;i=i+16|0;l=i;i=i+16|0;YVc(h,335880);UVc(g,NKc(b,h)|0);m=d+4|0;RKc(g,m);cWc(g);cWc(h);YVc(k,335896);UVc(j,NKc(b,k)|0);h=d+8|0;MKc(j,h);cWc(j);cWc(k);YVc(l,335752);k=zWc(NKc(b,l)|0)|0;b=(a[m]|0)!=0;m=c[h>>2]|0;c[f>>2]=k;c[f+4>>2]=b?336016:336024;c[f+8>>2]=m;c[f+12>>2]=b?336016:336032;EBc(4,0,336152,f);cWc(l);i=e;return}



function RL(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8960>>3]=+h[b+9008>>3]*.8660254037844387+ +h[b+9024>>3]*-.4999999999999999;i=i;return}function SL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14248>>3]=+h[b+23888>>3]*d*+h[e+5744>>3]- +h[b+23904>>3]*d*+h[e+5752>>3];i=i;return}function TL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14208>>3]=+h[b+14248>>3]+(+h[b+23032>>3]*d*+h[e+5168>>3]- +h[b+23048>>3]*d*+h[e+5176>>3]);i=i;return}function UL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14184>>3]=+h[b+14208>>3]+(+h[b+23032>>3]*d*+h[e+3200>>3]- +h[b+23048>>3]*d*+h[e+3208>>3]);i=i;return}function VL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14136>>3]=+h[b+14184>>3]+(+h[b+23032>>3]*d*+h[e+4392>>3]- +h[b+23048>>3]*d*+h[e+4400>>3]);i=i;return}function WL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14112>>3]=+h[b+14136>>3]+(+h[b+23032>>3]*d*+h[e+2400>>3]- +h[b+23048>>3]*d*+h[e+2408>>3]);i=i;return}function XL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14e3>>3]=+h[b+14112>>3]+(+h[b+23032>>3]*d*+h[e+6128>>3]- +h[b+23048>>3]*d*+h[e+6136>>3]);i=i;return}function YL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13792>>3]=+h[b+14e3>>3]+(+h[b+13936>>3]*d*+h[e+12152>>3]- +h[b+13952>>3]*d*+h[e+12160>>3]);i=i;return}function ZL(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13704>>3]=+h[b+13792>>3]+(+h[b+13728>>3]*d*+h[e+11576>>3]- +h[b+13744>>3]*d*+h[e+11584>>3]);i=i;return}function _L(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13680>>3]=+h[b+13704>>3]+(+h[b+13728>>3]*d*+h[e+9608>>3]- +h[b+13744>>3]*d*+h[e+9616>>3]);i=i;return}function $L(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13632>>3]=+h[b+13680>>3]+(+h[b+13728>>3]*d*+h[e+10800>>3]- +h[b+13744>>3]*d*+h[e+10808>>3]);i=i;return}function aM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13608>>3]=+h[b+13632>>3]+(+h[b+13728>>3]*d*+h[e+8808>>3]- +h[b+13744>>3]*d*+h[e+8816>>3]);i=i;return}function bM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13352>>3]=+h[b+13608>>3]+(+h[b+13728>>3]*d*+h[e+12536>>3]- +h[b+13744>>3]*d*+h[e+12544>>3]);i=i;return}function cM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13144>>3]=+h[b+13352>>3]+(+h[b+13288>>3]*d*+h[e+18560>>3]- +h[b+13304>>3]*d*+h[e+18568>>3]);i=i;return}function dM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13056>>3]=+h[b+13144>>3]+(+h[b+13080>>3]*d*+h[e+17984>>3]- +h[b+13096>>3]*d*+h[e+17992>>3]);i=i;return}function eM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13032>>3]=+h[b+13056>>3]+(+h[b+13080>>3]*d*+h[e+16016>>3]- +h[b+13096>>3]*d*+h[e+16024>>3]);i=i;return}function fM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12984>>3]=+h[b+13032>>3]+(+h[b+13080>>3]*d*+h[e+17208>>3]- +h[b+13096>>3]*d*+h[e+17216>>3]);i=i;return}function gM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12960>>3]=+h[b+12984>>3]+(+h[b+13080>>3]*d*+h[e+15216>>3]- +h[b+13096>>3]*d*+h[e+15224>>3]);i=i;return}function hM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12704>>3]=+h[b+12960>>3]+(+h[b+13080>>3]*d*+h[e+18944>>3]- +h[b+13096>>3]*d*+h[e+18952>>3]);i=i;return}function iM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12496>>3]=+h[b+12704>>3]+(+h[b+12640>>3]*d*+h[e+24968>>3]- +h[b+12656>>3]*d*+h[e+24976>>3]);i=i;return}function jM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12408>>3]=+h[b+12496>>3]+(+h[b+12432>>3]*d*+h[e+24392>>3]- +h[b+12448>>3]*d*+h[e+24400>>3]);i=i;return}function kM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12384>>3]=+h[b+12408>>3]+(+h[b+12432>>3]*d*+h[e+22424>>3]- +h[b+12448>>3]*d*+h[e+22432>>3]);i=i;return}function lM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12336>>3]=+h[b+12384>>3]+(+h[b+12432>>3]*d*+h[e+23616>>3]- +h[b+12448>>3]*d*+h[e+23624>>3]);i=i;return}function mM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12312>>3]=+h[b+12336>>3]+(+h[b+12432>>3]*d*+h[e+21624>>3]- +h[b+12448>>3]*d*+h[e+21632>>3]);i=i;return}function nM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12056>>3]=+h[b+12312>>3]+(+h[b+12432>>3]*d*+h[e+25352>>3]- +h[b+12448>>3]*d*+h[e+25360>>3]);i=i;return}function oM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11848>>3]=+h[b+12056>>3]+(+h[b+11992>>3]*d*+h[e+31376>>3]- +h[b+12008>>3]*d*+h[e+31384>>3]);i=i;return}function pM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11760>>3]=+h[b+11848>>3]+(+h[b+11784>>3]*d*+h[e+30800>>3]- +h[b+11800>>3]*d*+h[e+30808>>3]);i=i;return}function qM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11736>>3]=+h[b+11760>>3]+(+h[b+11784>>3]*d*+h[e+28832>>3]- +h[b+11800>>3]*d*+h[e+28840>>3]);i=i;return}function rM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11688>>3]=+h[b+11736>>3]+(+h[b+11784>>3]*d*+h[e+30024>>3]- +h[b+11800>>3]*d*+h[e+30032>>3]);i=i;return}function sM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11664>>3]=+h[b+11688>>3]+(+h[b+11784>>3]*d*+h[e+28032>>3]- +h[b+11800>>3]*d*+h[e+28040>>3]);i=i;return}function tM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11408>>3]=+h[b+11664>>3]+(+h[b+11784>>3]*d*+h[e+31760>>3]- +h[b+11800>>3]*d*+h[e+31768>>3]);i=i;return}function uM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11272>>3]=+h[b+11408>>3]+(+h[b+23984>>3]*d*+h[e+37784>>3]- +h[b+23960>>3]*d*+h[e+37792>>3]);i=i;return}function vM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11184>>3]=+h[b+11272>>3]+(+h[b+11208>>3]*d*+h[e+37208>>3]- +h[b+11224>>3]*d*+h[e+37216>>3]);i=i;return}function wM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11160>>3]=+h[b+11184>>3]+(+h[b+11208>>3]*d*+h[e+35240>>3]- +h[b+11224>>3]*d*+h[e+35248>>3]);i=i;return}function xM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11112>>3]=+h[b+11160>>3]+(+h[b+11208>>3]*d*+h[e+36432>>3]- +h[b+11224>>3]*d*+h[e+36440>>3]);i=i;return}function yM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11136>>3]=+h[b+11160>>3]+(+h[b+11208>>3]*d*+h[e+37304>>3]- +h[b+11224>>3]*d*+h[e+37312>>3]);i=i;return}function zM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11712>>3]=+h[b+11736>>3]+(+h[b+11784>>3]*d*+h[e+30896>>3]- +h[b+11800>>3]*d*+h[e+30904>>3]);i=i;return}function AM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12360>>3]=+h[b+12384>>3]+(+h[b+12432>>3]*d*+h[e+24488>>3]- +h[b+12448>>3]*d*+h[e+24496>>3]);i=i;return}function BM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13008>>3]=+h[b+13032>>3]+(+h[b+13080>>3]*d*+h[e+18080>>3]- +h[b+13096>>3]*d*+h[e+18088>>3]);i=i;return}function CM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13656>>3]=+h[b+13680>>3]+(+h[b+13728>>3]*d*+h[e+11672>>3]- +h[b+13744>>3]*d*+h[e+11680>>3]);i=i;return}function DM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14160>>3]=+h[b+14184>>3]+(+h[b+23032>>3]*d*+h[e+5264>>3]- +h[b+23048>>3]*d*+h[e+5272>>3]);i=i;return}function EM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14256>>3]=+h[b+23880>>3]*d*+h[e+5744>>3]- +h[b+23896>>3]*d*+h[e+5752>>3];i=i;return}function FM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14216>>3]=+h[b+14256>>3]+(+h[b+23024>>3]*d*+h[e+5168>>3]- +h[b+23040>>3]*d*+h[e+5176>>3]);i=i;return}function GM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14192>>3]=+h[b+14216>>3]+(+h[b+23024>>3]*d*+h[e+3200>>3]- +h[b+23040>>3]*d*+h[e+3208>>3]);i=i;return}function HM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14144>>3]=+h[b+14192>>3]+(+h[b+23024>>3]*d*+h[e+4392>>3]- +h[b+23040>>3]*d*+h[e+4400>>3]);i=i;return}function IM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14120>>3]=+h[b+14144>>3]+(+h[b+23024>>3]*d*+h[e+2400>>3]- +h[b+23040>>3]*d*+h[e+2408>>3]);i=i;return}function JM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14008>>3]=+h[b+14120>>3]+(+h[b+23024>>3]*d*+h[e+6128>>3]- +h[b+23040>>3]*d*+h[e+6136>>3]);i=i;return}function KM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13800>>3]=+h[b+14008>>3]+(+h[b+13928>>3]*d*+h[e+12152>>3]- +h[b+13944>>3]*d*+h[e+12160>>3]);i=i;return}function LM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13712>>3]=+h[b+13800>>3]+(+h[b+13720>>3]*d*+h[e+11576>>3]- +h[b+13736>>3]*d*+h[e+11584>>3]);i=i;return}function MM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13688>>3]=+h[b+13712>>3]+(+h[b+13720>>3]*d*+h[e+9608>>3]- +h[b+13736>>3]*d*+h[e+9616>>3]);i=i;return}function NM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13640>>3]=+h[b+13688>>3]+(+h[b+13720>>3]*d*+h[e+10800>>3]- +h[b+13736>>3]*d*+h[e+10808>>3]);i=i;return}function OM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13616>>3]=+h[b+13640>>3]+(+h[b+13720>>3]*d*+h[e+8808>>3]- +h[b+13736>>3]*d*+h[e+8816>>3]);i=i;return}function PM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13360>>3]=+h[b+13616>>3]+(+h[b+13720>>3]*d*+h[e+12536>>3]- +h[b+13736>>3]*d*+h[e+12544>>3]);i=i;return}function QM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13152>>3]=+h[b+13360>>3]+(+h[b+13280>>3]*d*+h[e+18560>>3]- +h[b+13296>>3]*d*+h[e+18568>>3]);i=i;return}function RM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13064>>3]=+h[b+13152>>3]+(+h[b+13072>>3]*d*+h[e+17984>>3]- +h[b+13088>>3]*d*+h[e+17992>>3]);i=i;return}function SM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13040>>3]=+h[b+13064>>3]+(+h[b+13072>>3]*d*+h[e+16016>>3]- +h[b+13088>>3]*d*+h[e+16024>>3]);i=i;return}function TM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12992>>3]=+h[b+13040>>3]+(+h[b+13072>>3]*d*+h[e+17208>>3]- +h[b+13088>>3]*d*+h[e+17216>>3]);i=i;return}function UM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12968>>3]=+h[b+12992>>3]+(+h[b+13072>>3]*d*+h[e+15216>>3]- +h[b+13088>>3]*d*+h[e+15224>>3]);i=i;return}function VM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12712>>3]=+h[b+12968>>3]+(+h[b+13072>>3]*d*+h[e+18944>>3]- +h[b+13088>>3]*d*+h[e+18952>>3]);i=i;return}function WM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12504>>3]=+h[b+12712>>3]+(+h[b+12632>>3]*d*+h[e+24968>>3]- +h[b+12648>>3]*d*+h[e+24976>>3]);i=i;return}function XM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12416>>3]=+h[b+12504>>3]+(+h[b+12424>>3]*d*+h[e+24392>>3]- +h[b+12440>>3]*d*+h[e+24400>>3]);i=i;return}function YM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12392>>3]=+h[b+12416>>3]+(+h[b+12424>>3]*d*+h[e+22424>>3]- +h[b+12440>>3]*d*+h[e+22432>>3]);i=i;return}function ZM(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12344>>3]=+h[b+12392>>3]+(+h[b+12424>>3]*d*+h[e+23616>>3]- +h[b+12440>>3]*d*+h[e+23624>>3]);i=i;return}function _M(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12320>>3]=+h[b+12344>>3]+(+h[b+12424>>3]*d*+h[e+21624>>3]- +h[b+12440>>3]*d*+h[e+21632>>3]);i=i;return}function $M(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12064>>3]=+h[b+12320>>3]+(+h[b+12424>>3]*d*+h[e+25352>>3]- +h[b+12440>>3]*d*+h[e+25360>>3]);i=i;return}function aN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11856>>3]=+h[b+12064>>3]+(+h[b+11984>>3]*d*+h[e+31376>>3]- +h[b+12e3>>3]*d*+h[e+31384>>3]);i=i;return}function bN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11768>>3]=+h[b+11856>>3]+(+h[b+11776>>3]*d*+h[e+30800>>3]- +h[b+11792>>3]*d*+h[e+30808>>3]);i=i;return}function cN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11744>>3]=+h[b+11768>>3]+(+h[b+11776>>3]*d*+h[e+28832>>3]- +h[b+11792>>3]*d*+h[e+28840>>3]);i=i;return}function dN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11696>>3]=+h[b+11744>>3]+(+h[b+11776>>3]*d*+h[e+30024>>3]- +h[b+11792>>3]*d*+h[e+30032>>3]);i=i;return}function eN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11672>>3]=+h[b+11696>>3]+(+h[b+11776>>3]*d*+h[e+28032>>3]- +h[b+11792>>3]*d*+h[e+28040>>3]);i=i;return}function fN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11416>>3]=+h[b+11672>>3]+(+h[b+11776>>3]*d*+h[e+31760>>3]- +h[b+11792>>3]*d*+h[e+31768>>3]);i=i;return}function gN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11280>>3]=+h[b+11416>>3]+(+h[b+23992>>3]*d*+h[e+37784>>3]- +h[b+23968>>3]*d*+h[e+37792>>3]);i=i;return}function hN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11192>>3]=+h[b+11280>>3]+(+h[b+11200>>3]*d*+h[e+37208>>3]- +h[b+11216>>3]*d*+h[e+37216>>3]);i=i;return}function iN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11168>>3]=+h[b+11192>>3]+(+h[b+11200>>3]*d*+h[e+35240>>3]- +h[b+11216>>3]*d*+h[e+35248>>3]);i=i;return}function jN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11120>>3]=+h[b+11168>>3]+(+h[b+11200>>3]*d*+h[e+36432>>3]- +h[b+11216>>3]*d*+h[e+36440>>3]);i=i;return}function kN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11144>>3]=+h[b+11168>>3]+(+h[b+11200>>3]*d*+h[e+37304>>3]- +h[b+11216>>3]*d*+h[e+37312>>3]);i=i;return}function lN(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,6)|0;d=c[(c[a+476>>2]|0)+412>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+10936>>3]=+h[d>>3];h[e+10944>>3]=+h[d+8>>3];i=b;return}function mN(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,7)|0;d=c[(c[a+476>>2]|0)+476>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+10984>>3]=+h[d>>3];h[e+25968>>3]=+h[d+8>>3];h[e+10992>>3]=+h[d+16>>3];h[e+10952>>3]=+h[d+24>>3];i=b;return}function nN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26032>>3]));h[b+4296>>3]=-(d*+h[b+10952>>3]);i=i;return}function oN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26032>>3]));h[b+4304>>3]=d*+h[b+10952>>3];i=i;return}function pN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4048>>3]=+h[b+4296>>3]*.4999999999999999+ +h[b+4304>>3]*.8660254037844387;i=i;return}function qN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4040>>3]=+h[b+4296>>3]*.8660254037844387+ +h[b+4304>>3]*-.4999999999999999;i=i;return}function rN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26032>>3]));h[b+4312>>3]=-(d*+h[b+10952>>3]);i=i;return}function sN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26032>>3]));h[b+4320>>3]=-(d*+h[b+10952>>3]);i=i;return}function tN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4064>>3]=+h[b+4312>>3]*.4999999999999999+ +h[b+4320>>3]*.8660254037844387;i=i;return}function uN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4056>>3]=+h[b+4312>>3]*.8660254037844387+ +h[b+4320>>3]*-.4999999999999999;i=i;return}function vN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10520>>3]=+h[b+10952>>3]- +h[b+16>>3];i=i;return}function wN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[c[b+356>>2]|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[c[b+356>>2]|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0,a[c[b+360>>2]|0]|0)|0;a[c[b+352>>2]|0]=j;f=j;break}}else{if(g){g=a[c[b+356>>2]|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0)|0;a[c[b+352>>2]|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+25968>>3],0.0)|0;a[c[b+352>>2]|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+2|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26016>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26016>>3],.93,a[(c[b+360>>2]|0)+2|0]|0)|0;a[(c[b+352>>2]|0)+2|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+2|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26016>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26016>>3],.93)|0;a[(c[b+352>>2]|0)+2|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26016>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+1|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26016>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26016>>3],.987,a[(c[b+360>>2]|0)+1|0]|0)|0;a[(c[b+352>>2]|0)+1|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+1|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26016>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26016>>3],.987)|0;a[(c[b+352>>2]|0)+1|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26016>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+25960|0;v=u;h[v>>3]=s;i=d;return}}}function xN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+47688>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+25960>>3]*+h[j+25984>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+25976|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+25976|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,5080,5072,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+25976|0;p=o;h[p>>3]=m;i=d;return}function yN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25992>>3]=+h[b+25960>>3]*1.0e-5;i=i;return}function zN(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+47664>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26056>>3]=b*b*+h[d+25992>>3]*-78539.81633974482;i=i;return}function AN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+11720>>3]=+h[b+11744>>3]+(+h[b+11776>>3]*d*+h[e+30896>>3]- +h[b+11792>>3]*d*+h[e+30904>>3]);i=i;return}function BN(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,8)|0;d=c[(c[a+476>>2]|0)+540>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+11448>>3]=+h[d>>3];h[e+11440>>3]=+h[d+8>>3];i=b;return}function CN(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,9)|0;d=c[(c[a+476>>2]|0)+604>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+11488>>3]=+h[d>>3];h[e+11464>>3]=+h[d+8>>3];h[e+26080>>3]=+h[d+16>>3];h[e+11472>>3]=+h[d+24>>3];i=b;return}function DN(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+3|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+3|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0,a[(c[b+360>>2]|0)+3|0]|0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+3|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26080>>3],0.0)|0;a[(c[b+352>>2]|0)+3|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+5|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26128>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26128>>3],.93,a[(c[b+360>>2]|0)+5|0]|0)|0;a[(c[b+352>>2]|0)+5|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+5|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26128>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26128>>3],.93)|0;a[(c[b+352>>2]|0)+5|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26128>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+4|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26128>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26128>>3],.987,a[(c[b+360>>2]|0)+4|0]|0)|0;a[(c[b+352>>2]|0)+4|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+4|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26128>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26128>>3],.987)|0;a[(c[b+352>>2]|0)+4|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26128>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26072|0;v=u;h[v>>3]=s;i=d;return}}}function EN(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+46208>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26072>>3]*+h[j+26096>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26088|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26088|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,5112,5104,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26088|0;p=o;h[p>>3]=m;i=d;return}function FN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26104>>3]=+h[b+26072>>3]*1.0e-5;i=i;return}function GN(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+46184>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26168>>3]=b*b*+h[d+26104>>3]*-78539.81633974482;i=i;return}function HN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26144>>3]));h[b+4264>>3]=-(d*+h[b+11488>>3]);i=i;return}function IN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26144>>3]));h[b+4272>>3]=d*+h[b+11488>>3];i=i;return}function JN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4016>>3]=+h[b+4264>>3]*-.4999999999999999+ +h[b+4272>>3]*.8660254037844387;i=i;return}function KN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4008>>3]=+h[b+4264>>3]*.8660254037844387+ +h[b+4272>>3]*.4999999999999999;i=i;return}function LN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26144>>3]));h[b+4280>>3]=-(d*+h[b+11488>>3]);i=i;return}function MN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26144>>3]));h[b+4288>>3]=-(d*+h[b+11488>>3]);i=i;return}function NN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4032>>3]=+h[b+4280>>3]*-.4999999999999999+ +h[b+4288>>3]*.8660254037844387;i=i;return}function ON(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4024>>3]=+h[b+4280>>3]*.8660254037844387+ +h[b+4288>>3]*.4999999999999999;i=i;return}function PN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10264>>3]=+h[b+11488>>3]- +h[b+16>>3];i=i;return}function QN(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+12368>>3]=+h[b+12392>>3]+(+h[b+12424>>3]*d*+h[e+24488>>3]- +h[b+12440>>3]*d*+h[e+24496>>3]);i=i;return}function RN(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,10)|0;d=c[(c[a+476>>2]|0)+668>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12096>>3]=+h[d>>3];h[e+12088>>3]=+h[d+8>>3];i=b;return}function SN(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,11)|0;d=c[(c[a+476>>2]|0)+732>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12144>>3]=+h[d>>3];h[e+26192>>3]=+h[d+8>>3];h[e+12136>>3]=+h[d+16>>3];h[e+12104>>3]=+h[d+24>>3];i=b;return}function TN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26256>>3]));h[b+4232>>3]=-(d*+h[b+12104>>3]);i=i;return}function UN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26256>>3]));h[b+4240>>3]=d*+h[b+12104>>3];i=i;return}function VN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3984>>3]=+h[b+4232>>3]*.4999999999999999+ +h[b+4240>>3]*.8660254037844387;i=i;return}function WN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3976>>3]=+h[b+4232>>3]*.8660254037844387+ +h[b+4240>>3]*-.4999999999999999;i=i;return}function XN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26256>>3]));h[b+4248>>3]=-(d*+h[b+12104>>3]);i=i;return}function YN(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26256>>3]));h[b+4256>>3]=-(d*+h[b+12104>>3]);i=i;return}function ZN(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4e3>>3]=+h[b+4248>>3]*.4999999999999999+ +h[b+4256>>3]*.8660254037844387;i=i;return}function _N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3992>>3]=+h[b+4248>>3]*.8660254037844387+ +h[b+4256>>3]*-.4999999999999999;i=i;return}function $N(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10008>>3]=+h[b+12104>>3]- +h[b+16>>3];i=i;return}function aO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+6|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+6|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0,a[(c[b+360>>2]|0)+6|0]|0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+6|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26192>>3],0.0)|0;a[(c[b+352>>2]|0)+6|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+8|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26240>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26240>>3],.93,a[(c[b+360>>2]|0)+8|0]|0)|0;a[(c[b+352>>2]|0)+8|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+8|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26240>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26240>>3],.93)|0;a[(c[b+352>>2]|0)+8|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26240>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+7|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26240>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26240>>3],.987,a[(c[b+360>>2]|0)+7|0]|0)|0;a[(c[b+352>>2]|0)+7|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+7|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26240>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26240>>3],.987)|0;a[(c[b+352>>2]|0)+7|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26240>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26184|0;v=u;h[v>>3]=s;i=d;return}}}function bO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+44728>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26184>>3]*+h[j+26208>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26200|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26200|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,5144,5136,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26200|0;p=o;h[p>>3]=m;i=d;return}function cO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26216>>3]=+h[b+26184>>3]*1.0e-5;i=i;return}function dO(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+44704>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26280>>3]=b*b*+h[d+26216>>3]*-78539.81633974482;i=i;return}function eO(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13016>>3]=+h[b+13040>>3]+(+h[b+13072>>3]*d*+h[e+18080>>3]- +h[b+13088>>3]*d*+h[e+18088>>3]);i=i;return}function fO(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,12)|0;d=c[(c[a+476>>2]|0)+796>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12744>>3]=+h[d>>3];h[e+12736>>3]=+h[d+8>>3];i=b;return}function gO(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,13)|0;d=c[(c[a+476>>2]|0)+860>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+12752>>3]=+h[d>>3];h[e+12784>>3]=+h[d+8>>3];h[e+26304>>3]=+h[d+16>>3];h[e+12792>>3]=+h[d+24>>3];i=b;return}function hO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+9|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+9|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0,a[(c[b+360>>2]|0)+9|0]|0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+9|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26304>>3],0.0)|0;a[(c[b+352>>2]|0)+9|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+11|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26352>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26352>>3],.93,a[(c[b+360>>2]|0)+11|0]|0)|0;a[(c[b+352>>2]|0)+11|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+11|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26352>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26352>>3],.93)|0;a[(c[b+352>>2]|0)+11|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26352>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+10|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26352>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26352>>3],.987,a[(c[b+360>>2]|0)+10|0]|0)|0;a[(c[b+352>>2]|0)+10|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+10|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26352>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26352>>3],.987)|0;a[(c[b+352>>2]|0)+10|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26352>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26296|0;v=u;h[v>>3]=s;i=d;return}}}function iO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+43248>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26296>>3]*+h[j+26320>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26312|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26312|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,5176,5168,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26312|0;p=o;h[p>>3]=m;i=d;return}function jO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26328>>3]=+h[b+26296>>3]*1.0e-5;i=i;return}function kO(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+43224>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26392>>3]=b*b*+h[d+26328>>3]*-78539.81633974482;i=i;return}function lO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26368>>3]));h[b+4200>>3]=-(d*+h[b+12752>>3]);i=i;return}function mO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26368>>3]));h[b+4208>>3]=d*+h[b+12752>>3];i=i;return}function nO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3952>>3]=+h[b+4200>>3]*-.4999999999999999+ +h[b+4208>>3]*.8660254037844387;i=i;return}function oO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3944>>3]=+h[b+4200>>3]*.8660254037844387+ +h[b+4208>>3]*.4999999999999999;i=i;return}function pO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26368>>3]));h[b+4216>>3]=-(d*+h[b+12752>>3]);i=i;return}function qO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26368>>3]));h[b+4224>>3]=-(d*+h[b+12752>>3]);i=i;return}function rO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3968>>3]=+h[b+4216>>3]*-.4999999999999999+ +h[b+4224>>3]*.8660254037844387;i=i;return}function sO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3960>>3]=+h[b+4216>>3]*.8660254037844387+ +h[b+4224>>3]*.4999999999999999;i=i;return}function tO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9752>>3]=+h[b+12752>>3]- +h[b+16>>3];i=i;return}function uO(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+13664>>3]=+h[b+13688>>3]+(+h[b+13720>>3]*d*+h[e+11672>>3]- +h[b+13736>>3]*d*+h[e+11680>>3]);i=i;return}function vO(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,14)|0;d=c[(c[a+476>>2]|0)+924>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+13384>>3]=+h[d>>3];h[e+13392>>3]=+h[d+8>>3];i=b;return}function wO(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,15)|0;d=c[(c[a+476>>2]|0)+988>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+13408>>3]=+h[d>>3];h[e+26416>>3]=+h[d+8>>3];h[e+13416>>3]=+h[d+16>>3];h[e+13432>>3]=+h[d+24>>3];i=b;return}function xO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26480>>3]));h[b+4168>>3]=-(d*+h[b+13432>>3]);i=i;return}function yO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26480>>3]));h[b+4176>>3]=d*+h[b+13432>>3];i=i;return}function zO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3920>>3]=+h[b+4168>>3]*.4999999999999999+ +h[b+4176>>3]*.8660254037844387;i=i;return}function AO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3912>>3]=+h[b+4168>>3]*.8660254037844387+ +h[b+4176>>3]*-.4999999999999999;i=i;return}function BO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+X(+(+h[b+26480>>3]));h[b+4184>>3]=-(d*+h[b+13432>>3]);i=i;return}function CO(a){a=a|0;var b=0,d=0.0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+Y(+(+h[b+26480>>3]));h[b+4192>>3]=-(d*+h[b+13432>>3]);i=i;return}function DO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3936>>3]=+h[b+4184>>3]*.4999999999999999+ +h[b+4192>>3]*.8660254037844387;i=i;return}function EO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3928>>3]=+h[b+4184>>3]*.8660254037844387+ +h[b+4192>>3]*-.4999999999999999;i=i;return}function FO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9496>>3]=+h[b+13432>>3]- +h[b+16>>3];i=i;return}function GO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+12|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+12|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0,a[(c[b+360>>2]|0)+12|0]|0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+12|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26416>>3],0.0)|0;a[(c[b+352>>2]|0)+12|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+14|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26464>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26464>>3],.93,a[(c[b+360>>2]|0)+14|0]|0)|0;a[(c[b+352>>2]|0)+14|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+14|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26464>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26464>>3],.93)|0;a[(c[b+352>>2]|0)+14|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26464>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+13|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26464>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26464>>3],.987,a[(c[b+360>>2]|0)+13|0]|0)|0;a[(c[b+352>>2]|0)+13|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+13|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26464>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26464>>3],.987)|0;a[(c[b+352>>2]|0)+13|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26464>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26408|0;v=u;h[v>>3]=s;i=d;return}}}function HO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+41768>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26408>>3]*+h[j+26432>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26424|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26424|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,5208,5200,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26424|0;p=o;h[p>>3]=m;i=d;return}function IO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26440>>3]=+h[b+26408>>3]*1.0e-5;i=i;return}function JO(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+41744>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26504>>3]=b*b*+h[d+26440>>3]*-78539.81633974482;i=i;return}function KO(a){a=a|0;var b=0,d=0.0,e=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=+h[b+16>>3];e=c[a+416>>2]|0;h[b+14168>>3]=+h[b+14192>>3]+(+h[b+23024>>3]*d*+h[e+5264>>3]- +h[b+23040>>3]*d*+h[e+5272>>3]);i=i;return}function LO(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,16)|0;d=c[(c[a+476>>2]|0)+1052>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+14032>>3]=+h[d>>3];h[e+14040>>3]=+h[d+8>>3];i=b;return}function MO(a){a=a|0;var b=0,d=0,e=0;b=i;gFc(a,17)|0;d=c[(c[a+476>>2]|0)+1116>>2]|0;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[e+14048>>3]=+h[d>>3];h[e+14088>>3]=+h[d+8>>3];h[e+26528>>3]=+h[d+16>>3];h[e+14080>>3]=+h[d+24>>3];i=b;return}function NO(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0.0,o=0.0,p=0.0,q=0,r=0.0,s=0.0,t=0,u=0,v=0,w=0,x=0;d=i;e=b+314|0;do{if((a[e]|0)==0){f=a[(c[b+356>>2]|0)+15|0]|0}else{g=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(g){j=a[(c[b+356>>2]|0)+15|0]|0;k=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=k;f=j;break}else{j=QEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0,a[(c[b+360>>2]|0)+15|0]|0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=j;break}}else{if(g){g=a[(c[b+356>>2]|0)+15|0]|0;j=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=j;f=g;break}else{g=SEc(+h[(c[(c[c[b+4>>2]>>2]|0)+8>>2]|0)+26528>>3],0.0)|0;a[(c[b+352>>2]|0)+15|0]=g;f=g;break}}}}while(0);g=(a[e]|0)==0;if(f<<24>>24==0){do{if(g){l=b+4|0;m=a[(c[b+356>>2]|0)+17|0]|0}else{f=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(f){e=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;k=REc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26576>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=k;l=j;m=e;break}else{e=b+4|0;j=REc(+h[(c[(c[c[e>>2]>>2]|0)+8>>2]|0)+26576>>3],.93,a[(c[b+360>>2]|0)+17|0]|0)|0;a[(c[b+352>>2]|0)+17|0]=j;l=e;m=j;break}}else{if(f){f=a[(c[b+356>>2]|0)+17|0]|0;j=b+4|0;e=UEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26576>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=e;l=j;m=f;break}else{f=b+4|0;j=UEc(+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+26576>>3],.93)|0;a[(c[b+352>>2]|0)+17|0]=j;l=f;m=j;break}}}}while(0);j=c[(c[c[l>>2]>>2]|0)+8>>2]|0;n=+h[j+26576>>3];o=n*n;p=o*o;if(m<<24>>24==0){q=j;r=p*145.93+(n*o*-131.707+(n*17.9272+o*17.3438))+2.4;s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}else{q=j;r=p*-3929704.0+(n*o*14748765.0+(o*-20747.0e3+(n*12964477.0+-3036495.0)));s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}}else{do{if(g){w=b+4|0;x=a[(c[b+356>>2]|0)+16|0]|0}else{j=(a[b+318|0]|0)!=0;if((a[b+312|0]|0)==0){if(j){m=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;f=QEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26576>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=f;w=l;x=m;break}else{m=b+4|0;l=QEc(+h[(c[(c[c[m>>2]>>2]|0)+8>>2]|0)+26576>>3],.987,a[(c[b+360>>2]|0)+16|0]|0)|0;a[(c[b+352>>2]|0)+16|0]=l;w=m;x=l;break}}else{if(j){j=a[(c[b+356>>2]|0)+16|0]|0;l=b+4|0;m=SEc(+h[(c[(c[c[l>>2]>>2]|0)+8>>2]|0)+26576>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=m;w=l;x=j;break}else{j=b+4|0;l=SEc(+h[(c[(c[c[j>>2]>>2]|0)+8>>2]|0)+26576>>3],.987)|0;a[(c[b+352>>2]|0)+16|0]=l;w=j;x=l;break}}}}while(0);b=c[(c[c[w>>2]>>2]|0)+8>>2]|0;n=+h[b+26576>>3];o=n*n;p=o*o;if(x<<24>>24==0){q=b;r=p*2836360.0+(n*o*-10569296.0+(n*-9158505.0+o*14761814.0))+2129670.0;s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}else{q=b;r=p*177.4132+(n*o*-287.2189+(n*-24.9973+o*151.8252))+2.4;s=r*1.0e5;t=q;u=t+26520|0;v=u;h[v>>3]=s;i=d;return}}}function OO(b){b=b|0;var d=0,e=0.0,f=0,g=0,j=0,k=0.0,l=0,m=0.0,n=0,o=0,p=0,q=0.0;d=i;e=+h[(c[b+416>>2]|0)+40288>>3];f=b+4|0;g=c[c[f>>2]>>2]|0;j=c[g+8>>2]|0;k=+h[j+26520>>3]*+h[j+26544>>3]*1.0e-5;if(e!=0.0){l=j;m=k/e;n=l;o=n+26536|0;p=o;h[p>>3]=m;i=d;return}if(k==0.0){l=j;m=k;n=l;o=n+26536|0;p=o;h[p>>3]=m;i=d;return}q=k/+KBc(c[b+536>>2]|0,e,5240,5232,+h[g>>3],(a[b+319|0]|0)!=0|0);l=c[(c[c[f>>2]>>2]|0)+8>>2]|0;m=q;n=l;o=n+26536|0;p=o;h[p>>3]=m;i=d;return}function PO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+26552>>3]=+h[b+26520>>3]*1.0e-5;i=i;return}function QO(a){a=a|0;var b=0.0,d=0;b=+h[(c[a+416>>2]|0)+40264>>3];d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+26616>>3]=b*b*+h[d+26552>>3]*-78539.81633974482;i=i;return}function RO(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;gFc(a,18)|0;d=a+476|0;e=c[(c[d>>2]|0)+1180>>2]|0;f=a+4|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+7664>>3]=+h[e>>3];h[a+26624>>3]=+h[e+8>>3];h[a+26648>>3]=+h[e+16>>3];h[a+112>>3]=+h[e+24>>3];h[a+224>>3]=+h[e+32>>3];h[a+7456>>3]=+h[e+40>>3];h[a+7448>>3]=+h[e+48>>3];h[a+7480>>3]=+h[e+56>>3];h[a+7176>>3]=+h[e+64>>3];h[a+7344>>3]=+h[e+72>>3];h[a+7184>>3]=+h[e+80>>3];h[a+7352>>3]=+h[e+88>>3];h[a+7296>>3]=+h[e+96>>3];h[a+3304>>3]=+h[e+104>>3];h[a+7288>>3]=+h[e+112>>3];h[a+7320>>3]=+h[e+120>>3];h[a+7152>>3]=+h[e+128>>3];h[a+7216>>3]=+h[e+136>>3];h[a+7272>>3]=+h[e+144>>3];h[a+7224>>3]=+h[e+152>>3];h[a+7376>>3]=+h[e+160>>3];h[a+7008>>3]=+h[e+168>>3];h[a+6456>>3]=+h[e+176>>3];h[a+6448>>3]=+h[e+184>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+7960>>3]=+h[e+192>>3];h[a+9432>>3]=+h[e+200>>3];h[a+8040>>3]=+h[e+208>>3];h[a+26512>>3]=+h[e+216>>3];h[a+2456>>3]=+h[e+224>>3];h[a+25408>>3]=+h[e+232>>3];h[a+6416>>3]=+h[e+240>>3];h[a+6384>>3]=+h[e+248>>3];h[a+6392>>3]=+h[e+256>>3];h[a+6360>>3]=+h[e+264>>3];h[a+8008>>3]=+h[e+272>>3];h[a+8032>>3]=+h[e+280>>3];h[a+9472>>3]=+h[e+288>>3];h[a+7984>>3]=+h[e+296>>3];h[a+3848>>3]=+h[e+304>>3];h[a+3800>>3]=+h[e+312>>3];h[a+3752>>3]=+h[e+320>>3];h[a+3704>>3]=+h[e+328>>3];h[a+3672>>3]=+h[e+336>>3];h[a+352>>3]=+h[e+344>>3];h[a+248>>3]=+h[e+352>>3];h[a+312>>3]=+h[e+360>>3];h[a+136>>3]=+h[e+368>>3];h[a+3720>>3]=+h[e+376>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+3688>>3]=+h[e+384>>3];h[a+904>>3]=+h[e+392>>3];h[a+768>>3]=+h[e+400>>3];h[a+856>>3]=+h[e+408>>3];h[a+656>>3]=+h[e+416>>3];h[a+3768>>3]=+h[e+424>>3];h[a+3736>>3]=+h[e+432>>3];h[a+1528>>3]=+h[e+440>>3];h[a+1392>>3]=+h[e+448>>3];h[a+1480>>3]=+h[e+456>>3];h[a+1280>>3]=+h[e+464>>3];h[a+3816>>3]=+h[e+472>>3];h[a+3784>>3]=+h[e+480>>3];h[a+2152>>3]=+h[e+488>>3];h[a+2016>>3]=+h[e+496>>3];h[a+2104>>3]=+h[e+504>>3];h[a+1904>>3]=+h[e+512>>3];h[a+3864>>3]=+h[e+520>>3];h[a+3832>>3]=+h[e+528>>3];h[a+2760>>3]=+h[e+536>>3];h[a+6528>>3]=+h[e+544>>3];h[a+6520>>3]=+h[e+552>>3];h[a+2624>>3]=+h[e+560>>3];h[a+2712>>3]=+h[e+568>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+6552>>3]=+h[e+576>>3];h[a+6544>>3]=+h[e+584>>3];h[a+6600>>3]=+h[e+592>>3];h[a+7120>>3]=+h[e+600>>3];h[a+7248>>3]=+h[e+608>>3];h[a+3112>>3]=+h[e+616>>3];h[a+3224>>3]=+h[e+624>>3];h[a+2504>>3]=+h[e+632>>3];h[a+2600>>3]=+h[e+640>>3];h[a+1880>>3]=+h[e+648>>3];h[a+1992>>3]=+h[e+656>>3];h[a+1256>>3]=+h[e+664>>3];h[a+1368>>3]=+h[e+672>>3];h[a+632>>3]=+h[e+680>>3];h[a+744>>3]=+h[e+688>>3];h[a+26632>>3]=+h[e+696>>3];h[a+7472>>3]=+h[e+704>>3];h[a+7336>>3]=+h[e+712>>3];h[a+7616>>3]=+h[e+720>>3];h[a+7584>>3]=+h[e+728>>3];h[a+7592>>3]=+h[e+736>>3];h[a+4768>>3]=+h[e+744>>3];h[a+4792>>3]=+h[e+752>>3];h[a+4816>>3]=+h[e+760>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+25336>>3]=+h[e+768>>3];h[a+7792>>3]=+h[e+776>>3];h[a+7568>>3]=+h[e+784>>3];h[a+7688>>3]=+h[e+792>>3];h[a+7728>>3]=+h[e+800>>3];h[a+7608>>3]=+h[e+808>>3];h[a+7144>>3]=+h[e+816>>3];h[a+7312>>3]=+h[e+824>>3];h[a+7264>>3]=+h[e+832>>3];h[a+7240>>3]=+h[e+840>>3];h[a+7112>>3]=+h[e+848>>3];h[a+6592>>3]=+h[e+856>>3];h[a+2720>>3]=+h[e+864>>3];h[a+7032>>3]=+h[e+872>>3];h[a+6504>>3]=+h[e+880>>3];h[a+6496>>3]=+h[e+888>>3];h[a+6304>>3]=+h[e+896>>3];h[a+6296>>3]=+h[e+904>>3];h[a+6912>>3]=+h[e+912>>3];h[a+6208>>3]=+h[e+920>>3];h[a+6200>>3]=+h[e+928>>3];h[a+6280>>3]=+h[e+936>>3];h[a+6272>>3]=+h[e+944>>3];h[a+8104>>3]=+h[e+952>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+8072>>3]=+h[e+960>>3];h[a+8080>>3]=+h[e+968>>3];h[a+9688>>3]=+h[e+976>>3];h[a+9728>>3]=+h[e+984>>3];h[a+8160>>3]=+h[e+992>>3];h[a+26400>>3]=+h[e+1e3>>3];h[a+6168>>3]=+h[e+1008>>3];h[a+25480>>3]=+h[e+1016>>3];h[a+1832>>3]=+h[e+1024>>3];h[a+25488>>3]=+h[e+1032>>3];h[a+6160>>3]=+h[e+1040>>3];h[a+6136>>3]=+h[e+1048>>3];h[a+6144>>3]=+h[e+1056>>3];h[a+6112>>3]=+h[e+1064>>3];h[a+8128>>3]=+h[e+1072>>3];h[a+8152>>3]=+h[e+1080>>3];h[a+8096>>3]=+h[e+1088>>3];h[a+3808>>3]=+h[e+1096>>3];h[a+6936>>3]=+h[e+1104>>3];h[a+6256>>3]=+h[e+1112>>3];h[a+6248>>3]=+h[e+1120>>3];h[a+6056>>3]=+h[e+1128>>3];h[a+6048>>3]=+h[e+1136>>3];h[a+6816>>3]=+h[e+1144>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5960>>3]=+h[e+1152>>3];h[a+5952>>3]=+h[e+1160>>3];h[a+6032>>3]=+h[e+1168>>3];h[a+6024>>3]=+h[e+1176>>3];h[a+8216>>3]=+h[e+1184>>3];h[a+8192>>3]=+h[e+1192>>3];h[a+8200>>3]=+h[e+1200>>3];h[a+9944>>3]=+h[e+1208>>3];h[a+9984>>3]=+h[e+1216>>3];h[a+8272>>3]=+h[e+1224>>3];h[a+26288>>3]=+h[e+1232>>3];h[a+5920>>3]=+h[e+1240>>3];h[a+25560>>3]=+h[e+1248>>3];h[a+1208>>3]=+h[e+1256>>3];h[a+25552>>3]=+h[e+1264>>3];h[a+5912>>3]=+h[e+1272>>3];h[a+5888>>3]=+h[e+1280>>3];h[a+5896>>3]=+h[e+1288>>3];h[a+5864>>3]=+h[e+1296>>3];h[a+8248>>3]=+h[e+1304>>3];h[a+8280>>3]=+h[e+1312>>3];h[a+8224>>3]=+h[e+1320>>3];h[a+3760>>3]=+h[e+1328>>3];h[a+6840>>3]=+h[e+1336>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+6008>>3]=+h[e+1344>>3];h[a+6e3>>3]=+h[e+1352>>3];h[a+5808>>3]=+h[e+1360>>3];h[a+5800>>3]=+h[e+1368>>3];h[a+6720>>3]=+h[e+1376>>3];h[a+5712>>3]=+h[e+1384>>3];h[a+5704>>3]=+h[e+1392>>3];h[a+5784>>3]=+h[e+1400>>3];h[a+5776>>3]=+h[e+1408>>3];h[a+8312>>3]=+h[e+1416>>3];h[a+10200>>3]=+h[e+1424>>3];h[a+8320>>3]=+h[e+1432>>3];h[a+10240>>3]=+h[e+1440>>3];h[a+8392>>3]=+h[e+1448>>3];h[a+26176>>3]=+h[e+1456>>3];h[a+4576>>3]=+h[e+1464>>3];h[a+584>>3]=+h[e+1472>>3];h[a+25632>>3]=+h[e+1480>>3];h[a+25624>>3]=+h[e+1488>>3];h[a+4568>>3]=+h[e+1496>>3];h[a+4544>>3]=+h[e+1504>>3];h[a+4552>>3]=+h[e+1512>>3];h[a+4520>>3]=+h[e+1520>>3];h[a+8368>>3]=+h[e+1528>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+8400>>3]=+h[e+1536>>3];h[a+8344>>3]=+h[e+1544>>3];h[a+8336>>3]=+h[e+1552>>3];h[a+3712>>3]=+h[e+1560>>3];h[a+6744>>3]=+h[e+1568>>3];h[a+5760>>3]=+h[e+1576>>3];h[a+5752>>3]=+h[e+1584>>3];h[a+6608>>3]=+h[e+1592>>3];h[a+5544>>3]=+h[e+1600>>3];h[a+5536>>3]=+h[e+1608>>3];h[a+8456>>3]=+h[e+1616>>3];h[a+8432>>3]=+h[e+1624>>3];h[a+8440>>3]=+h[e+1632>>3];h[a+10456>>3]=+h[e+1640>>3];h[a+10496>>3]=+h[e+1648>>3];h[a+8512>>3]=+h[e+1656>>3];h[a+26064>>3]=+h[e+1664>>3];h[a+4688>>3]=+h[e+1672>>3];h[a+25696>>3]=+h[e+1680>>3];h[a+64>>3]=+h[e+1688>>3];h[a+25704>>3]=+h[e+1696>>3];h[a+4680>>3]=+h[e+1704>>3];h[a+4656>>3]=+h[e+1712>>3];h[a+4664>>3]=+h[e+1720>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+4632>>3]=+h[e+1728>>3];h[a+8488>>3]=+h[e+1736>>3];h[a+8520>>3]=+h[e+1744>>3];h[a+8464>>3]=+h[e+1752>>3];h[a+3680>>3]=+h[e+1760>>3];h[a+5640>>3]=+h[e+1768>>3];h[a+5632>>3]=+h[e+1776>>3];h[a+5520>>3]=+h[e+1784>>3];h[a+5584>>3]=+h[e+1792>>3];h[a+288>>3]=+h[e+1800>>3];h[a+6632>>3]=+h[e+1808>>3];h[a+5608>>3]=+h[e+1816>>3];h[a+328>>3]=+h[e+1824>>3];h[a+264>>3]=+h[e+1832>>3];h[a+200>>3]=+h[e+1840>>3];h[a+5512>>3]=+h[e+1848>>3];h[a+176>>3]=+h[e+1856>>3];h[a+88>>3]=+h[e+1864>>3];h[a+152>>3]=+h[e+1872>>3];h[a+304>>3]=+h[e+1880>>3];h[a+5576>>3]=+h[e+1888>>3];h[a+296>>3]=+h[e+1896>>3];h[a+5600>>3]=+h[e+1904>>3];h[a+360>>3]=+h[e+1912>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+256>>3]=+h[e+1920>>3];h[a+320>>3]=+h[e+1928>>3];h[a+5496>>3]=+h[e+1936>>3];h[a+5672>>3]=+h[e+1944>>3];h[a+5472>>3]=+h[e+1952>>3];h[a+496>>3]=+h[e+1960>>3];h[a+5352>>3]=+h[e+1968>>3];h[a+5376>>3]=+h[e+1976>>3];h[a+5400>>3]=+h[e+1984>>3];h[a+832>>3]=+h[e+1992>>3];h[a+5424>>3]=+h[e+2e3>>3];h[a+5448>>3]=+h[e+2008>>3];h[a+920>>3]=+h[e+2016>>3];h[a+784>>3]=+h[e+2024>>3];h[a+896>>3]=+h[e+2032>>3];h[a+872>>3]=+h[e+2040>>3];h[a+808>>3]=+h[e+2048>>3];h[a+720>>3]=+h[e+2056>>3];h[a+672>>3]=+h[e+2064>>3];h[a+848>>3]=+h[e+2072>>3];h[a+696>>3]=+h[e+2080>>3];h[a+608>>3]=+h[e+2088>>3];h[a+5328>>3]=+h[e+2096>>3];h[a+5200>>3]=+h[e+2104>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5224>>3]=+h[e+2112>>3];h[a+5248>>3]=+h[e+2120>>3];h[a+1464>>3]=+h[e+2128>>3];h[a+5272>>3]=+h[e+2136>>3];h[a+5296>>3]=+h[e+2144>>3];h[a+1096>>3]=+h[e+2152>>3];h[a+1544>>3]=+h[e+2160>>3];h[a+1408>>3]=+h[e+2168>>3];h[a+1520>>3]=+h[e+2176>>3];h[a+1496>>3]=+h[e+2184>>3];h[a+1432>>3]=+h[e+2192>>3];h[a+1344>>3]=+h[e+2200>>3];h[a+1296>>3]=+h[e+2208>>3];h[a+1472>>3]=+h[e+2216>>3];h[a+1320>>3]=+h[e+2224>>3];h[a+1232>>3]=+h[e+2232>>3];h[a+5176>>3]=+h[e+2240>>3];h[a+5056>>3]=+h[e+2248>>3];h[a+5080>>3]=+h[e+2256>>3];h[a+5104>>3]=+h[e+2264>>3];h[a+2088>>3]=+h[e+2272>>3];h[a+5128>>3]=+h[e+2280>>3];h[a+5152>>3]=+h[e+2288>>3];h[a+1720>>3]=+h[e+2296>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2168>>3]=+h[e+2304>>3];h[a+2032>>3]=+h[e+2312>>3];h[a+2144>>3]=+h[e+2320>>3];h[a+2120>>3]=+h[e+2328>>3];h[a+2056>>3]=+h[e+2336>>3];h[a+1968>>3]=+h[e+2344>>3];h[a+1920>>3]=+h[e+2352>>3];h[a+2096>>3]=+h[e+2360>>3];h[a+1944>>3]=+h[e+2368>>3];h[a+1856>>3]=+h[e+2376>>3];h[a+5032>>3]=+h[e+2384>>3];h[a+4912>>3]=+h[e+2392>>3];h[a+4936>>3]=+h[e+2400>>3];h[a+4960>>3]=+h[e+2408>>3];h[a+2696>>3]=+h[e+2416>>3];h[a+4984>>3]=+h[e+2424>>3];h[a+5008>>3]=+h[e+2432>>3];h[a+2344>>3]=+h[e+2440>>3];h[a+2776>>3]=+h[e+2448>>3];h[a+2640>>3]=+h[e+2456>>3];h[a+2752>>3]=+h[e+2464>>3];h[a+2552>>3]=+h[e+2472>>3];h[a+2480>>3]=+h[e+2480>>3];h[a+2528>>3]=+h[e+2488>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2704>>3]=+h[e+2496>>3];h[a+2728>>3]=+h[e+2504>>3];h[a+2664>>3]=+h[e+2512>>3];h[a+2576>>3]=+h[e+2520>>3];h[a+2688>>3]=+h[e+2528>>3];h[a+4992>>3]=+h[e+2536>>3];h[a+5016>>3]=+h[e+2544>>3];h[a+5040>>3]=+h[e+2552>>3];h[a+5064>>3]=+h[e+2560>>3];h[a+5088>>3]=+h[e+2568>>3];h[a+5112>>3]=+h[e+2576>>3];h[a+2080>>3]=+h[e+2584>>3];h[a+5136>>3]=+h[e+2592>>3];h[a+5160>>3]=+h[e+2600>>3];h[a+5184>>3]=+h[e+2608>>3];h[a+5208>>3]=+h[e+2616>>3];h[a+5232>>3]=+h[e+2624>>3];h[a+5256>>3]=+h[e+2632>>3];h[a+1456>>3]=+h[e+2640>>3];h[a+5280>>3]=+h[e+2648>>3];h[a+5304>>3]=+h[e+2656>>3];h[a+5320>>3]=+h[e+2664>>3];h[a+5344>>3]=+h[e+2672>>3];h[a+5368>>3]=+h[e+2680>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+5392>>3]=+h[e+2688>>3];h[a+840>>3]=+h[e+2696>>3];h[a+5416>>3]=+h[e+2704>>3];h[a+5440>>3]=+h[e+2712>>3];h[a+5464>>3]=+h[e+2720>>3];h[a+5488>>3]=+h[e+2728>>3];h[a+5664>>3]=+h[e+2736>>3];h[a+144>>3]=+h[e+2744>>3];h[a+3728>>3]=+h[e+2752>>3];h[a+3696>>3]=+h[e+2760>>3];h[a+912>>3]=+h[e+2768>>3];h[a+776>>3]=+h[e+2776>>3];h[a+864>>3]=+h[e+2784>>3];h[a+664>>3]=+h[e+2792>>3];h[a+3776>>3]=+h[e+2800>>3];h[a+3744>>3]=+h[e+2808>>3];h[a+1536>>3]=+h[e+2816>>3];h[a+1400>>3]=+h[e+2824>>3];h[a+1488>>3]=+h[e+2832>>3];h[a+1288>>3]=+h[e+2840>>3];h[a+3824>>3]=+h[e+2848>>3];h[a+3792>>3]=+h[e+2856>>3];h[a+2160>>3]=+h[e+2864>>3];h[a+2024>>3]=+h[e+2872>>3];e=c[(c[d>>2]|0)+1180>>2]|0;a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[a+2112>>3]=+h[e+2880>>3];h[a+1912>>3]=+h[e+2888>>3];h[a+3872>>3]=+h[e+2896>>3];h[a+3840>>3]=+h[e+2904>>3];h[a+2768>>3]=+h[e+2912>>3];h[a+2632>>3]=+h[e+2920>>3];h[a+3856>>3]=+h[e+2928>>3];h[a+7976>>3]=+h[e+2936>>3];h[a+7952>>3]=+h[e+2944>>3];h[a+6408>>3]=+h[e+2952>>3];h[a+25416>>3]=+h[e+2960>>3];h[a+4968>>3]=+h[e+2968>>3];h[a+4944>>3]=+h[e+2976>>3];h[a+2952>>3]=+h[e+2984>>3];h[a+4896>>3]=+h[e+2992>>3];h[a+4920>>3]=+h[e+3e3>>3];h[a+3352>>3]=+h[e+3008>>3];h[a+3248>>3]=+h[e+3016>>3];h[a+3344>>3]=+h[e+3024>>3];h[a+4752>>3]=+h[e+3032>>3];h[a+3320>>3]=+h[e+3040>>3];h[a+3312>>3]=+h[e+3048>>3];h[a+3152>>3]=+h[e+3056>>3];h[a+3088>>3]=+h[e+3064>>3];e=c[(c[d>>2]|0)+1180>>2]|0;d=c[(c[c[f>>2]>>2]|0)+8>>2]|0;h[d+3176>>3]=+h[e+3072>>3];h[d+4744>>3]=+h[e+3080>>3];h[d+4776>>3]=+h[e+3088>>3];h[d+4800>>3]=+h[e+3096>>3];h[d+4824>>3]=+h[e+3104>>3];h[d+3296>>3]=+h[e+3112>>3];h[d+4848>>3]=+h[e+3120>>3];h[d+4872>>3]=+h[e+3128>>3];h[d+4888>>3]=+h[e+3136>>3];h[d+4864>>3]=+h[e+3144>>3];h[d+4840>>3]=+h[e+3152>>3];h[d+3200>>3]=+h[e+3160>>3];h[d+3272>>3]=+h[e+3168>>3];h[d+3064>>3]=+h[e+3176>>3];h[d+25344>>3]=+h[e+3184>>3];h[d+7784>>3]=+h[e+3192>>3];h[d+7560>>3]=+h[e+3200>>3];h[d+7536>>3]=+h[e+3208>>3];h[d+7640>>3]=+h[e+3216>>3];h[d+7672>>3]=+h[e+3224>>3];i=b;return}function SO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7648>>3]=((+h[b+7664>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*.4999999999999999+ +h[b+7672>>3]*.8660254037844387)*6.047565858160353;i=i;return}function TO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7904>>3]=+h[b+7648>>3]*.05;i=i;return}function UO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3440>>3]=-+h[b+7904>>3]- +h[(c[a+416>>2]|0)+38912>>3];i=i;return}function VO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3424>>3]=-(+h[(c[a+416>>2]|0)+1496>>3]*+h[b+7560>>3]);i=i;return}function WO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3072>>3]=-(+h[(c[a+416>>2]|0)+5256>>3]*+h[b+25344>>3]);i=i;return}function XO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2464>>3]=-(+h[(c[a+416>>2]|0)+11664>>3]*+h[b+25416>>3]);i=i;return}function YO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+48>>3]=+h[b+26632>>3];i=i;return}function ZO(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3120>>3]=+h[b+7456>>3]*-.05;i=i;return}function _O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3128>>3]=+h[b+7448>>3]*.05;i=i;return}function $O(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3232>>3]=+h[b+7296>>3]*-.05;i=i;return}function aP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3240>>3]=+h[b+7288>>3]*.05;i=i;return}function bP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8016>>3]=((+h[b+8032>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*-.4999999999999999+ +h[b+8040>>3]*.8660254037844387)*6.047565858160353;i=i;return}function cP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9600>>3]=+h[b+8016>>3]*.05;i=i;return}function dP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2864>>3]=-+h[b+9600>>3]- +h[(c[a+416>>2]|0)+40392>>3];i=i;return}function eP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2856>>3]=+h[(c[a+416>>2]|0)+7904>>3]*+h[b+6392>>3];i=i;return}function fP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2472>>3]=+h[(c[a+416>>2]|0)+11664>>3]*+h[b+25408>>3];i=i;return}function gP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2848>>3]=-(+h[(c[a+416>>2]|0)+7904>>3]*+h[b+6384>>3]);i=i;return}function hP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2936>>3]=+h[b+24320>>3]*+h[b+2856>>3]+ +h[b+24344>>3]*+h[b+2848>>3];i=i;return}function iP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3024>>3]=+h[(c[a+416>>2]|0)+7520>>3]*+h[b+26504>>3]+ +h[b+2936>>3];i=i;return}function jP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2928>>3]=+h[b+3024>>3]- +h[(c[a+416>>2]|0)+6744>>3]*+h[b+26504>>3];i=i;return}function kP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2944>>3]=+h[b+24312>>3]*+h[b+2856>>3]+ +h[b+24336>>3]*+h[b+2848>>3];i=i;return}function lP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6368>>3]=+h[b+24320>>3]*+h[b+6384>>3]+ +h[b+24344>>3]*+h[b+6392>>3];i=i;return}function mP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6336>>3]=+h[b+8016>>3]+ +h[b+6368>>3];i=i;return}function nP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2896>>3]=+h[(c[a+416>>2]|0)+7520>>3]*+h[b+6336>>3]+ +h[b+2944>>3];i=i;return}function oP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2920>>3]=+h[b+2896>>3]- +h[(c[a+416>>2]|0)+6744>>3]*+h[b+6336>>3];i=i;return}function pP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6328>>3]=+h[b+26504>>3]*-.4999999999999999+ +h[b+6336>>3]*.8660254037844387;i=i;return}function qP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6320>>3]=+h[b+26504>>3]*-.8660254037844387+ +h[b+6336>>3]*-.4999999999999999;i=i;return}function rP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2904>>3]=-(+h[b+7528>>3]*+h[d+6336>>3])- +h[d+2864>>3]- +h[b+7536>>3]*+h[d+26504>>3];i=i;return}function sP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3032>>3]=+h[b+2904>>3]- +h[b+6336>>3]*+h[b+26496>>3];i=i;return}function tP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2912>>3]=+h[b+6752>>3]*+h[d+6336>>3]+(+h[b+6760>>3]*+h[d+26504>>3]+ +h[d+3032>>3]);i=i;return}function uP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+6328>>3];l=+h[a+6320>>3];m=+h[a+2912>>3]+(+h[f+11768>>3]*j- +h[f+11776>>3]*l);n=+h[f+11760>>3];o=+h[a+2920>>3];p=+h[a+2928>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*-.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+2432|0);i=b;return}function vP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2608>>3]=+h[b+6528>>3]*-.05;i=i;return}function wP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2616>>3]=+h[b+6520>>3]*.05;i=i;return}function xP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2512>>3]=+h[b+6552>>3]*-.05;i=i;return}function yP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2520>>3]=+h[b+6544>>3]*.05;i=i;return}function zP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3432>>3]=+h[(c[a+416>>2]|0)+1496>>3]*+h[b+7568>>3];i=i;return}function AP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3512>>3]=+h[b+24112>>3]*+h[b+3432>>3]+ +h[b+24136>>3]*+h[b+3424>>3];i=i;return}function BP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3616>>3]=+h[(c[a+416>>2]|0)+1112>>3]*+h[b+26616>>3]+ +h[b+3512>>3];i=i;return}function CP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3504>>3]=+h[b+3616>>3]- +h[(c[a+416>>2]|0)+336>>3]*+h[b+26616>>3];i=i;return}function DP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3520>>3]=+h[b+24104>>3]*+h[b+3432>>3]+ +h[b+24128>>3]*+h[b+3424>>3];i=i;return}function EP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7544>>3]=+h[b+24112>>3]*+h[b+7560>>3]+ +h[b+24136>>3]*+h[b+7568>>3];i=i;return}function FP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+7512>>3]=+h[b+7648>>3]+ +h[b+7544>>3];i=i;return}function GP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3472>>3]=+h[(c[a+416>>2]|0)+1112>>3]*+h[b+7512>>3]+ +h[b+3520>>3];i=i;return}function HP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3496>>3]=+h[b+3472>>3]- +h[(c[a+416>>2]|0)+336>>3]*+h[b+7512>>3];i=i;return}function IP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6576>>3]=+h[b+26616>>3]*.4999999999999999+ +h[b+7512>>3]*.8660254037844387;i=i;return}function JP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6568>>3]=+h[b+26616>>3]*-.8660254037844387+ +h[b+7512>>3]*.4999999999999999;i=i;return}function KP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3480>>3]=-(+h[b+1120>>3]*+h[d+7512>>3])- +h[d+3440>>3]- +h[b+1128>>3]*+h[d+26616>>3];i=i;return}function LP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3624>>3]=+h[b+3480>>3]- +h[b+7512>>3]*+h[b+26608>>3];i=i;return}function MP(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+3488>>3]=+h[b+344>>3]*+h[d+7512>>3]+(+h[b+352>>3]*+h[d+26616>>3]+ +h[d+3624>>3]);i=i;return}function NP(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+6576>>3];l=+h[a+6568>>3];m=+h[a+3488>>3]+(+h[f+5360>>3]*j- +h[f+5368>>3]*l);n=+h[f+5352>>3];o=+h[a+3496>>3];p=+h[a+3504>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+3040|0);i=b;return}function OP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3080>>3]=+h[(c[a+416>>2]|0)+5256>>3]*+h[b+25336>>3];i=i;return}function PP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1888>>3]=+h[b+6304>>3]*-.05;i=i;return}function QP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1896>>3]=+h[b+6296>>3]*.05;i=i;return}function RP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2e3>>3]=+h[b+6280>>3]*-.05;i=i;return}function SP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2008>>3]=+h[b+6272>>3]*.05;i=i;return}function TP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8136>>3]=((+h[b+8152>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*.4999999999999999+ +h[b+8160>>3]*.8660254037844387)*6.047565858160353;i=i;return}function UP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+9856>>3]=+h[b+8136>>3]*.05;i=i;return}function VP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2256>>3]=-+h[b+9856>>3]- +h[(c[a+416>>2]|0)+41872>>3];i=i;return}function WP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2248>>3]=+h[(c[a+416>>2]|0)+14312>>3]*+h[b+6144>>3];i=i;return}function XP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2240>>3]=-(+h[(c[a+416>>2]|0)+14312>>3]*+h[b+6136>>3]);i=i;return}function YP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2328>>3]=+h[b+24528>>3]*+h[b+2248>>3]+ +h[b+24552>>3]*+h[b+2240>>3];i=i;return}function ZP(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2416>>3]=+h[(c[a+416>>2]|0)+13928>>3]*+h[b+26392>>3]+ +h[b+2328>>3];i=i;return}function _P(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2320>>3]=+h[b+2416>>3]- +h[(c[a+416>>2]|0)+13152>>3]*+h[b+26392>>3];i=i;return}function $P(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2336>>3]=+h[b+24520>>3]*+h[b+2248>>3]+ +h[b+24544>>3]*+h[b+2240>>3];i=i;return}function aQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6120>>3]=+h[b+24528>>3]*+h[b+6136>>3]+ +h[b+24552>>3]*+h[b+6144>>3];i=i;return}function bQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6088>>3]=+h[b+8136>>3]+ +h[b+6120>>3];i=i;return}function cQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2288>>3]=+h[(c[a+416>>2]|0)+13928>>3]*+h[b+6088>>3]+ +h[b+2336>>3];i=i;return}function dQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2312>>3]=+h[b+2288>>3]- +h[(c[a+416>>2]|0)+13152>>3]*+h[b+6088>>3];i=i;return}function eQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6080>>3]=+h[b+26392>>3]*.4999999999999999+ +h[b+6088>>3]*.8660254037844387;i=i;return}function fQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+6072>>3]=+h[b+26392>>3]*-.8660254037844387+ +h[b+6088>>3]*.4999999999999999;i=i;return}function gQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2296>>3]=-(+h[b+13936>>3]*+h[d+6088>>3])- +h[d+2256>>3]- +h[b+13944>>3]*+h[d+26392>>3];i=i;return}function hQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2424>>3]=+h[b+2296>>3]- +h[b+6088>>3]*+h[b+26384>>3];i=i;return}function iQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+2304>>3]=+h[b+13160>>3]*+h[d+6088>>3]+(+h[b+13168>>3]*+h[d+26392>>3]+ +h[d+2424>>3]);i=i;return}function jQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+6080>>3];l=+h[a+6072>>3];m=+h[a+2304>>3]+(+h[f+18176>>3]*j- +h[f+18184>>3]*l);n=+h[f+18168>>3];o=+h[a+2312>>3];p=+h[a+2320>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1808|0);i=b;return}function kQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1840>>3]=-(+h[(c[a+416>>2]|0)+18072>>3]*+h[b+25488>>3]);i=i;return}function lQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1848>>3]=+h[(c[a+416>>2]|0)+18072>>3]*+h[b+25480>>3];i=i;return}function mQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1264>>3]=+h[b+6056>>3]*-.05;i=i;return}function nQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1272>>3]=+h[b+6048>>3]*.05;i=i;return}function oQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1376>>3]=+h[b+6032>>3]*-.05;i=i;return}function pQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1384>>3]=+h[b+6024>>3]*.05;i=i;return}function qQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8256>>3]=((+h[b+8272>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*-.4999999999999999+ +h[b+8280>>3]*.8660254037844387)*6.047565858160353;i=i;return}function rQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10112>>3]=+h[b+8256>>3]*.05;i=i;return}function sQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1632>>3]=-+h[b+10112>>3]- +h[(c[a+416>>2]|0)+43352>>3];i=i;return}function tQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1624>>3]=+h[(c[a+416>>2]|0)+20720>>3]*+h[b+5896>>3];i=i;return}function uQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1616>>3]=-(+h[(c[a+416>>2]|0)+20720>>3]*+h[b+5888>>3]);i=i;return}function vQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1704>>3]=+h[b+24736>>3]*+h[b+1624>>3]+ +h[b+24760>>3]*+h[b+1616>>3];i=i;return}function wQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1792>>3]=+h[(c[a+416>>2]|0)+20336>>3]*+h[b+26280>>3]+ +h[b+1704>>3];i=i;return}function xQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1696>>3]=+h[b+1792>>3]- +h[(c[a+416>>2]|0)+19560>>3]*+h[b+26280>>3];i=i;return}function yQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1712>>3]=+h[b+24728>>3]*+h[b+1624>>3]+ +h[b+24752>>3]*+h[b+1616>>3];i=i;return}function zQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5872>>3]=+h[b+24736>>3]*+h[b+5888>>3]+ +h[b+24760>>3]*+h[b+5896>>3];i=i;return}function AQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5840>>3]=+h[b+8256>>3]+ +h[b+5872>>3];i=i;return}function BQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1664>>3]=+h[(c[a+416>>2]|0)+20336>>3]*+h[b+5840>>3]+ +h[b+1712>>3];i=i;return}function CQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1688>>3]=+h[b+1664>>3]- +h[(c[a+416>>2]|0)+19560>>3]*+h[b+5840>>3];i=i;return}function DQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5832>>3]=+h[b+26280>>3]*-.4999999999999999+ +h[b+5840>>3]*.8660254037844387;i=i;return}function EQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+5824>>3]=+h[b+26280>>3]*-.8660254037844387+ +h[b+5840>>3]*-.4999999999999999;i=i;return}function FQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1672>>3]=-(+h[b+20344>>3]*+h[d+5840>>3])- +h[d+1632>>3]- +h[b+20352>>3]*+h[d+26280>>3];i=i;return}function GQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1800>>3]=+h[b+1672>>3]- +h[b+5840>>3]*+h[b+26272>>3];i=i;return}function HQ(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1680>>3]=+h[b+19568>>3]*+h[d+5840>>3]+(+h[b+19576>>3]*+h[d+26280>>3]+ +h[d+1800>>3]);i=i;return}function IQ(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+5832>>3];l=+h[a+5824>>3];m=+h[a+1680>>3]+(+h[f+24584>>3]*j- +h[f+24592>>3]*l);n=+h[f+24576>>3];o=+h[a+1688>>3];p=+h[a+1696>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*-.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+1184|0);i=b;return}function JQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1224>>3]=+h[(c[a+416>>2]|0)+24480>>3]*+h[b+25552>>3];i=i;return}function KQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1216>>3]=-(+h[(c[a+416>>2]|0)+24480>>3]*+h[b+25560>>3]);i=i;return}function LQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+640>>3]=+h[b+5808>>3]*-.05;i=i;return}function MQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+648>>3]=+h[b+5800>>3]*.05;i=i;return}function NQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+752>>3]=+h[b+5784>>3]*-.05;i=i;return}function OQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+760>>3]=+h[b+5776>>3]*.05;i=i;return}function PQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8376>>3]=((+h[b+8392>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*.4999999999999999+ +h[b+8400>>3]*.8660254037844387)*6.047565858160353;i=i;return}function QQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10368>>3]=+h[b+8376>>3]*.05;i=i;return}function RQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1008>>3]=-+h[b+10368>>3]- +h[(c[a+416>>2]|0)+44832>>3];i=i;return}function SQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1e3>>3]=+h[(c[a+416>>2]|0)+27128>>3]*+h[b+4552>>3];i=i;return}function TQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+992>>3]=-(+h[(c[a+416>>2]|0)+27128>>3]*+h[b+4544>>3]);i=i;return}function UQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1080>>3]=+h[b+24944>>3]*+h[b+1e3>>3]+ +h[b+24968>>3]*+h[b+992>>3];i=i;return}function VQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1168>>3]=+h[(c[a+416>>2]|0)+26744>>3]*+h[b+26168>>3]+ +h[b+1080>>3];i=i;return}function WQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1072>>3]=+h[b+1168>>3]- +h[(c[a+416>>2]|0)+25968>>3]*+h[b+26168>>3];i=i;return}function XQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1088>>3]=+h[b+24936>>3]*+h[b+1e3>>3]+ +h[b+24960>>3]*+h[b+992>>3];i=i;return}function YQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4528>>3]=+h[b+24944>>3]*+h[b+4544>>3]+ +h[b+24968>>3]*+h[b+4552>>3];i=i;return}function ZQ(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4496>>3]=+h[b+8376>>3]+ +h[b+4528>>3];i=i;return}function _Q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1040>>3]=+h[(c[a+416>>2]|0)+26744>>3]*+h[b+4496>>3]+ +h[b+1088>>3];i=i;return}function $Q(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1064>>3]=+h[b+1040>>3]- +h[(c[a+416>>2]|0)+25968>>3]*+h[b+4496>>3];i=i;return}function aR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4488>>3]=+h[b+26168>>3]*.4999999999999999+ +h[b+4496>>3]*.8660254037844387;i=i;return}function bR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4480>>3]=+h[b+26168>>3]*-.8660254037844387+ +h[b+4496>>3]*.4999999999999999;i=i;return}function cR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1048>>3]=-(+h[b+26752>>3]*+h[d+4496>>3])- +h[d+1008>>3]- +h[b+26760>>3]*+h[d+26168>>3];i=i;return}function dR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1176>>3]=+h[b+1048>>3]- +h[b+4496>>3]*+h[b+26160>>3];i=i;return}function eR(a){a=a|0;var b=0,d=0;b=c[a+416>>2]|0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[d+1056>>3]=+h[b+25976>>3]*+h[d+4496>>3]+(+h[b+25984>>3]*+h[d+26168>>3]+ +h[d+1176>>3]);i=i;return}function fR(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0.0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=c[a+416>>2]|0;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;j=+h[a+4488>>3];l=+h[a+4480>>3];m=+h[a+1056>>3]+(+h[f+30992>>3]*j- +h[f+31e3>>3]*l);n=+h[f+30984>>3];o=+h[a+1064>>3];p=+h[a+1072>>3];a=d;h[k>>3]=-(j*n)-(o*-.8660254037844387+p*-.4999999999999999);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];a=d+8|0;h[k>>3]=l*n-(o*.4999999999999999+p*-.8660254037844387);c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];DCc(e,3,m,d);ACc(e,(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+560|0);i=b;return}function gR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+600>>3]=+h[(c[a+416>>2]|0)+30888>>3]*+h[b+25624>>3];i=i;return}function hR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+592>>3]=-(+h[(c[a+416>>2]|0)+30888>>3]*+h[b+25632>>3]);i=i;return}function iR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+8496>>3]=((+h[b+8512>>3]+ +h[(c[a+416>>2]|0)+38584>>3])*-.4999999999999999+ +h[b+8520>>3]*.8660254037844387)*6.047565858160353;i=i;return}function jR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+10624>>3]=+h[b+8496>>3]*.05;i=i;return}function kR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+408>>3]=-+h[b+10624>>3]- +h[(c[a+416>>2]|0)+46312>>3];i=i;return}function lR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+400>>3]=+h[(c[a+416>>2]|0)+33536>>3]*+h[b+4664>>3];i=i;return}function mR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+392>>3]=-(+h[(c[a+416>>2]|0)+33536>>3]*+h[b+4656>>3]);i=i;return}function nR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+480>>3]=+h[b+25152>>3]*+h[b+400>>3]+ +h[b+25176>>3]*+h[b+392>>3];i=i;return}function oR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+544>>3]=+h[(c[a+416>>2]|0)+33152>>3]*+h[b+26056>>3]+ +h[b+480>>3];i=i;return}function pR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+472>>3]=+h[b+544>>3]- +h[(c[a+416>>2]|0)+32376>>3]*+h[b+26056>>3];i=i;return}function qR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+488>>3]=+h[b+25144>>3]*+h[b+400>>3]+ +h[b+25168>>3]*+h[b+392>>3];i=i;return}function rR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4640>>3]=+h[b+25152>>3]*+h[b+4656>>3]+ +h[b+25176>>3]*+h[b+4664>>3];i=i;return}function sR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4608>>3]=+h[b+8496>>3]+ +h[b+4640>>3];i=i;return}function tR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+440>>3]=+h[(c[a+416>>2]|0)+33152>>3]*+h[b+4608>>3]+ +h[b+488>>3];i=i;return}function uR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+464>>3]=+h[b+440>>3]- +h[(c[a+416>>2]|0)+32376>>3]*+h[b+4608>>3];i=i;return}function vR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4600>>3]=+h[b+26056>>3]*.4999999999999999+ +h[b+4608>>3]*-.8660254037844387;i=i;return}function wR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4464>>3]=+h[b+4600>>3]- +h[b+4488>>3];i=i;return}function xR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4440>>3]=+h[b+4464>>3]- +h[b+5832>>3];i=i;return}function yR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4416>>3]=+h[b+4440>>3]- +h[b+6080>>3];i=i;return}function zR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4392>>3]=+h[b+4416>>3]- +h[b+6328>>3];i=i;return}function AR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4368>>3]=+h[b+6576>>3]- +h[b+4392>>3];i=i;return}function BR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1128>>3]=+h[b+464>>3]*-.8660254037844387+(+h[b+472>>3]*.4999999999999999- +h[(c[a+416>>2]|0)+37392>>3]*+h[b+4600>>3]);i=i;return}function CR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+952>>3]=+h[(c[a+416>>2]|0)+27640>>3]*+h[b+4600>>3]- +h[b+1128>>3];i=i;return}function DR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1752>>3]=-+h[b+952>>3]- +h[b+568>>3];i=i;return}function ER(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1576>>3]=+h[(c[a+416>>2]|0)+21232>>3]*+h[b+4464>>3]- +h[b+1752>>3];i=i;return}function FR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2376>>3]=-+h[b+1576>>3]- +h[b+1192>>3];i=i;return}function GR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2200>>3]=+h[(c[a+416>>2]|0)+14824>>3]*+h[b+4440>>3]- +h[b+2376>>3];i=i;return}function HR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2984>>3]=-+h[b+2200>>3]- +h[b+1816>>3];i=i;return}function IR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2808>>3]=+h[(c[a+416>>2]|0)+8416>>3]*+h[b+4416>>3]- +h[b+2984>>3];i=i;return}function JR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3552>>3]=-+h[b+2808>>3]- +h[b+2440>>3];i=i;return}function KR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3384>>3]=+h[(c[a+416>>2]|0)+2008>>3]*+h[b+4392>>3]- +h[b+3552>>3];i=i;return}function LR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+3576>>3]=+h[b+3384>>3]+ +h[b+3048>>3];i=i;return}function MR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4592>>3]=+h[b+26056>>3]*.8660254037844387+ +h[b+4608>>3]*.4999999999999999;i=i;return}function NR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4456>>3]=+h[b+4592>>3]- +h[b+4480>>3];i=i;return}function OR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4432>>3]=+h[b+4456>>3]- +h[b+5824>>3];i=i;return}function PR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4408>>3]=+h[b+4432>>3]- +h[b+6072>>3];i=i;return}function QR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4384>>3]=+h[b+4408>>3]- +h[b+6320>>3];i=i;return}function RR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+4360>>3]=+h[b+6568>>3]- +h[b+4384>>3];i=i;return}function SR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1136>>3]=+h[b+464>>3]*-.4999999999999999+(+h[(c[a+416>>2]|0)+37392>>3]*+h[b+4592>>3]+ +h[b+472>>3]*-.8660254037844387);i=i;return}function TR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+960>>3]=-+h[b+1136>>3]- +h[(c[a+416>>2]|0)+27640>>3]*+h[b+4592>>3];i=i;return}function UR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1760>>3]=-+h[b+960>>3]- +h[b+576>>3];i=i;return}function VR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+1584>>3]=-+h[b+1760>>3]- +h[(c[a+416>>2]|0)+21232>>3]*+h[b+4456>>3];i=i;return}function WR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2384>>3]=-+h[b+1584>>3]- +h[b+1200>>3];i=i;return}function XR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2208>>3]=-+h[b+2384>>3]- +h[(c[a+416>>2]|0)+14824>>3]*+h[b+4432>>3];i=i;return}function YR(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+2992>>3]=-+h[b+2208>>3]- +h[b+1824>>3];i=i;return}



function twc(a,b,d,e,f,g,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0.0,G=0,H=0,I=0,J=0,K=0;k=i;l=c[d>>2]|0;d=~l;m=c[j>>2]|0;do{if((m|0)>0){n=c[e>>2]|0;o=n;p=f;q=1;r=n}else{if((m|0)<0){n=c[f>>2]|0;o=n;p=e;q=-1;r=(fa(1-n|0,m)|0)+1|0;break}else{i=k;return 0}}}while(0);e=c[p>>2]|0;p=c[a>>2]|0;f=((p|0)/32|0)<<5;if((f|0)<1){s=m;t=p}else{p=(q|0)<0;n=p?(o|0)>=(e|0):(o|0)<=(e|0);u=m;m=1;while(1){if(n){v=m+31|0;if(p){w=u;x=o;y=r;while(1){z=c[g+(y+ -1<<2)>>2]|0;if((z|0)==(x|0)){A=w}else{B=x+d|0;C=z+d|0;z=m;do{D=fa(z,l)|0;E=b+(B+D<<3)|0;F=+h[E>>3];G=b+(C+D<<3)|0;h[E>>3]=+h[G>>3];h[G>>3]=F;z=z+1|0;}while((z|0)<=(v|0));A=c[j>>2]|0}z=x+q|0;if((z|0)<(e|0)){H=A;break}else{w=A;x=z;y=A+y|0}}}else{y=u;x=o;w=r;while(1){z=c[g+(w+ -1<<2)>>2]|0;if((z|0)==(x|0)){I=y}else{C=x+d|0;B=z+d|0;z=m;do{G=fa(z,l)|0;E=b+(C+G<<3)|0;F=+h[E>>3];D=b+(B+G<<3)|0;h[E>>3]=+h[D>>3];h[D>>3]=F;z=z+1|0;}while((z|0)<=(v|0));I=c[j>>2]|0}z=x+q|0;if((z|0)>(e|0)){H=I;break}else{y=I;x=z;w=I+w|0}}}}else{H=u}w=m+32|0;if((w|0)>(f|0)){break}else{u=H;m=w}}s=H;t=c[a>>2]|0}if((f|0)==(t|0)){i=k;return 0}t=f|1;f=(q|0)<0;if(!(f?(o|0)>=(e|0):(o|0)<=(e|0))){i=k;return 0}if(f){f=s;H=o;m=r;while(1){u=c[g+(m+ -1<<2)>>2]|0;do{if((u|0)==(H|0)){J=f}else{I=c[a>>2]|0;if((t|0)>(I|0)){J=f;break}A=H+d|0;p=u+d|0;n=t;do{w=fa(n,l)|0;x=b+(A+w<<3)|0;F=+h[x>>3];y=b+(p+w<<3)|0;h[x>>3]=+h[y>>3];h[y>>3]=F;n=n+1|0;}while((n|0)<=(I|0));J=c[j>>2]|0}}while(0);u=H+q|0;if((u|0)<(e|0)){break}else{f=J;H=u;m=J+m|0}}i=k;return 0}else{m=s;s=o;o=r;while(1){r=c[g+(o+ -1<<2)>>2]|0;do{if((r|0)==(s|0)){K=m}else{J=c[a>>2]|0;if((t|0)>(J|0)){K=m;break}H=s+d|0;f=r+d|0;u=t;do{I=fa(u,l)|0;n=b+(H+I<<3)|0;F=+h[n>>3];p=b+(f+I<<3)|0;h[n>>3]=+h[p>>3];h[p>>3]=F;u=u+1|0;}while((u|0)<=(J|0));K=c[j>>2]|0}}while(0);r=s+q|0;if((r|0)>(e|0)){break}else{m=K;s=r;o=K+o|0}}i=k;return 0}return 0}function uwc(b,d,e,f,g,h,j){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;k=i;i=i+32|0;l=k;m=k+8|0;n=k+16|0;o=k+24|0;p=L4c(d|0)|0;switch(c[b>>2]|0){case 3:case 2:case 1:{q=o;STc(q,d,1,p);p=a[q]|0;do{if((p+ -97<<24>>24&255)<26){r=p+ -32<<24>>24;a[q]=r;s=o+1|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+2|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+3|0;t=a[s]|0;if((t+ -97<<24>>24&255)<26){a[s]=t+ -32<<24>>24}t=o+4|0;s=a[t]|0;if((s+ -97<<24>>24&255)<26){a[t]=s+ -32<<24>>24}s=o+5|0;t=a[s]|0;if(!((t+ -97<<24>>24&255)<26)){u=r;break}a[s]=t+ -32<<24>>24;u=r}else{u=p}}while(0);p=u<<24>>24==83;q=u<<24>>24==68;r=p|q;if(!(u<<24>>24==67|u<<24>>24==68|u<<24>>24==83|u<<24>>24==90)){v=1;i=k;return v|0}t=l;STc(t,o+1|0,1,2);l=m;STc(l,o+3|0,1,3);o=n;STc(o,m+1|0,1,2);m=c[b>>2]|0;if((m|0)==2){if((RTc(t,281336,1,2)|0)==0){if((RTc(l,281352,1,3)|0)==0){v=2;i=k;return v|0}if((RTc(l,281360,1,3)|0)==0){v=2;i=k;return v|0}if((RTc(l,281368,1,3)|0)==0){v=2;i=k;return v|0}if((RTc(l,281376,1,3)|0)==0){v=2;i=k;return v|0}if((RTc(l,281384,1,3)|0)==0){v=2;i=k;return v|0}if((RTc(l,281392,1,3)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}if((RTc(t,281416,1,2)|0)==0){n=(RTc(l,281344,1,3)|0)==0;if(n|(p|q)^1){v=n?8:2;i=k;return v|0}v=2;i=k;return v|0}if(u<<24>>24==68|u<<24>>24==83){w=94}else if(u<<24>>24==67|u<<24>>24==90){w=91}else{v=2;i=k;return v|0}do{if((w|0)==91){if((RTc(t,281440,1,2)|0)==0){v=2;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=94;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}}}while(0);do{if((w|0)==94){if((RTc(t,281448,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=2}i=k;return v|0}n=a[l]|0;if(n<<24>>24==71){if((RTc(o,281456,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281464,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281472,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281480,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281488,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281496,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==77){if((RTc(o,281456,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281464,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281472,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281480,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281488,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281496,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}}while(0);if((RTc(t,281512,1,2)|0)!=0){v=2;i=k;return v|0}n=a[l]|0;if(n<<24>>24==71){if((RTc(o,281456,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281464,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281472,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281480,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281488,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281496,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else if(n<<24>>24==77){if((RTc(o,281456,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281464,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281472,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281480,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281488,1,2)|0)==0){v=2;i=k;return v|0}if((RTc(o,281496,1,2)|0)==0){v=2;i=k;return v|0}v=2;i=k;return v|0}else{v=2;i=k;return v|0}}else if((m|0)==3){if((RTc(t,281336,1,2)|0)==0){if((RTc(l,281352,1,3)|0)==0){v=128;i=k;return v|0}if((RTc(l,281360,1,3)|0)==0){v=128;i=k;return v|0}if((RTc(l,281368,1,3)|0)==0){v=128;i=k;return v|0}if((RTc(l,281376,1,3)|0)==0){v=128;i=k;return v|0}if((RTc(l,281384,1,3)|0)==0){v=128;i=k;return v|0}m=(RTc(l,281392,1,3)|0)==0;v=m?128:0;i=k;return v|0}if((RTc(t,281416,1,2)|0)==0){if(!(u<<24>>24==68|u<<24>>24==83)){v=0;i=k;return v|0}m=(RTc(l,281424,1,3)|0)==0;v=m?32:0;i=k;return v|0}if(u<<24>>24==67|u<<24>>24==90){w=138}else if(u<<24>>24==68|u<<24>>24==83){w=141}else{v=0;i=k;return v|0}do{if((w|0)==138){if((RTc(t,281440,1,2)|0)==0){m=(RTc(l,281424,1,3)|0)==0;v=m?32:0;i=k;return v|0}else{if(u<<24>>24==68|u<<24>>24==83){w=141;break}else if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}}}while(0);do{if((w|0)==141){if((RTc(t,281448,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){break}else{v=0}i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((RTc(o,281456,1,2)|0)!=0){if((RTc(o,281464,1,2)|0)==0){break}if((RTc(o,281472,1,2)|0)==0){break}if((RTc(o,281480,1,2)|0)==0){break}if((RTc(o,281488,1,2)|0)==0){break}if((RTc(o,281496,1,2)|0)==0){break}if((RTc(o,281504,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}}while(0);if((RTc(t,281512,1,2)|0)!=0){v=0;i=k;return v|0}if((a[l]|0)!=71){v=0;i=k;return v|0}do{if((RTc(o,281456,1,2)|0)!=0){if((RTc(o,281464,1,2)|0)==0){break}if((RTc(o,281472,1,2)|0)==0){break}if((RTc(o,281480,1,2)|0)==0){break}if((RTc(o,281488,1,2)|0)==0){break}if((RTc(o,281496,1,2)|0)==0){break}if((RTc(o,281504,1,2)|0)==0){break}else{v=0}i=k;return v|0}}while(0);v=128;i=k;return v|0}else{if((RTc(t,281336,1,2)|0)==0){if((RTc(l,281344,1,3)|0)==0){v=64;i=k;return v|0}if((RTc(l,281352,1,3)|0)==0){v=32;i=k;return v|0}if((RTc(l,281360,1,3)|0)==0){v=32;i=k;return v|0}if((RTc(l,281368,1,3)|0)==0){v=32;i=k;return v|0}if((RTc(l,281376,1,3)|0)==0){v=32;i=k;return v|0}if((RTc(l,281384,1,3)|0)==0){v=32;i=k;return v|0}if((RTc(l,281392,1,3)|0)==0){v=32;i=k;return v|0}m=(RTc(l,281400,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((RTc(t,281408,1,2)|0)==0){m=(RTc(l,281344,1,3)|0)==0;v=m?64:1;i=k;return v|0}if((RTc(t,281416,1,2)|0)==0){m=(RTc(l,281344,1,3)|0)==0;if(m|r^1){v=m?64:1;i=k;return v|0}m=(RTc(l,281424,1,3)|0)==0;if(m){v=m?32:1;i=k;return v|0}m=(RTc(l,281432,1,3)|0)==0;v=m?64:1;i=k;return v|0}do{if(u<<24>>24==68|u<<24>>24==83){w=29}else if(u<<24>>24==67|u<<24>>24==90){if((RTc(t,281440,1,2)|0)!=0){if(u<<24>>24==68|u<<24>>24==83){w=29;break}else if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}if((RTc(l,281344,1,3)|0)==0){v=64;i=k;return v|0}if((RTc(l,281424,1,3)|0)==0){v=32;i=k;return v|0}m=(RTc(l,281432,1,3)|0)==0;v=m?64:1;i=k;return v|0}}while(0);do{if((w|0)==29){if((RTc(t,281448,1,2)|0)!=0){if(u<<24>>24==67|u<<24>>24==90){w=48;break}else{break}}m=a[l]|0;if(m<<24>>24==71){do{if((RTc(o,281456,1,2)|0)!=0){if((RTc(o,281464,1,2)|0)==0){break}if((RTc(o,281472,1,2)|0)==0){break}if((RTc(o,281480,1,2)|0)==0){break}if((RTc(o,281488,1,2)|0)==0){break}if((RTc(o,281496,1,2)|0)==0){break}if((RTc(o,281504,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((RTc(o,281456,1,2)|0)!=0){if((RTc(o,281464,1,2)|0)==0){break}if((RTc(o,281472,1,2)|0)==0){break}if((RTc(o,281480,1,2)|0)==0){break}if((RTc(o,281488,1,2)|0)==0){break}if((RTc(o,281496,1,2)|0)==0){break}if((RTc(o,281504,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);do{if((w|0)==48){if((RTc(t,281512,1,2)|0)!=0){break}m=a[l]|0;if(m<<24>>24==71){do{if((RTc(o,281456,1,2)|0)!=0){if((RTc(o,281464,1,2)|0)==0){break}if((RTc(o,281472,1,2)|0)==0){break}if((RTc(o,281480,1,2)|0)==0){break}if((RTc(o,281488,1,2)|0)==0){break}if((RTc(o,281496,1,2)|0)==0){break}if((RTc(o,281504,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else if(m<<24>>24==77){do{if((RTc(o,281456,1,2)|0)!=0){if((RTc(o,281464,1,2)|0)==0){break}if((RTc(o,281472,1,2)|0)==0){break}if((RTc(o,281480,1,2)|0)==0){break}if((RTc(o,281488,1,2)|0)==0){break}if((RTc(o,281496,1,2)|0)==0){break}if((RTc(o,281504,1,2)|0)==0){break}else{v=1}i=k;return v|0}}while(0);v=32;i=k;return v|0}else{v=1;i=k;return v|0}}}while(0);if((RTc(t,281520,1,2)|0)==0){if((RTc(l,281344,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[j>>2]|0)<65?1:32;i=k;return v|0}if((RTc(t,281528,1,2)|0)==0){if((RTc(l,281344,1,3)|0)!=0){v=1;i=k;return v|0}v=(c[g>>2]|0)<65?1:32;i=k;return v|0}if((RTc(t,281496,1,2)|0)==0){o=(RTc(l,281400,1,3)|0)==0;v=o?64:1;i=k;return v|0}if((RTc(t,281536,1,2)|0)==0){o=(RTc(l,281544,1,3)|0)==0;v=o?64:1;i=k;return v|0}if(!(u<<24>>24==68|u<<24>>24==83)){v=1;i=k;return v|0}if((RTc(t,281552,1,2)|0)==0){i=k;return 1}else{v=1;i=k;return v|0}}break};case 6:{t=c[f>>2]|0;u=c[g>>2]|0;v=~~(+(((t|0)>(u|0)?u:t)|0)*1.600000023841858);i=k;return v|0};case 7:{v=1;i=k;return v|0};case 8:{v=50;i=k;return v|0};case 9:{v=25;i=k;return v|0};case 10:{v=vwc(281568,281576,281584)|0;i=k;return v|0};case 11:{v=vwc(281592,281576,281584)|0;i=k;return v|0};case 16:case 15:case 14:case 13:case 12:{v=wwc(b,d,e,f,g,h,j)|0;i=k;return v|0};case 4:{v=6;i=k;return v|0};case 5:{v=2;i=k;return v|0};default:{v=-1;i=k;return v|0}}return 0}function vwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0.0,h=0.0,j=0.0,k=0,l=0.0,m=0.0,n=0.0,o=0.0,p=0.0,q=0.0;e=i;f=+g[d>>2];h=+g[b>>2];do{if(!(f/h<=f)){j=-f/h;if(j>=h){k=0;break}l=f/(f+j);if(l!=h){k=0;break}j=f/l;if(j>=h){k=0;break}m=h+l;if(m!=h){k=0;break}n=f/m;if(n<=f){k=0;break}m=j*n;if(m>=h){k=0;break}j=n*n;if(j<=f){k=0;break}if((c[a>>2]|0)==0){k=1;break}n=j+m;o=j/j;p=h*j;q=l*m;l=j/m;if(n==n&0.0==0.0|l==l&0.0==0.0|o==o&0.0==0.0|p==p&0.0==0.0|q==q&0.0==0.0){k=0;break}p=q*0.0;k=(p!=p|0.0!=0.0)&1}else{k=0}}while(0);i=e;return k|0}function wwc(a,b,d,e,f,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0,p=0;j=i;i=i+8|0;e=j;d=c[a>>2]|0;if((d|0)==16|(d|0)==13|(d|0)==15){b=(c[h>>2]|0)-(c[f>>2]|0)+1|0;if((b|0)>149){g[e>>2]=+da(+(+(b|0)))/.6931471805599453;f=(b|0)/(QTc(e)|0)|0;k=c[a>>2]|0;l=(f|0)>10?f:10}else{k=d;l=(b|0)>59?10:(b|0)>29?4:2}f=(b|0)>5999?256:(b|0)>2999?128:(b|0)>589?64:l;l=f-((f|0)%2|0)|0;m=k;n=b;o=(l|0)>2?l:2}else{m=d;n=0;o=0}switch(m|0){case 14:{p=14;i=j;return p|0};case 13:{if((n|0)<501){p=o;i=j;return p|0}p=(o*3|0)/2|0;i=j;return p|0};case 16:{n=(o|0)>13;i=j;return(n?2:n&1)|0};case 15:{p=o;i=j;return p|0};case 12:{p=75;i=j;return p|0};default:{p=-1;i=j;return p|0}}return 0}function xwc(a){a=a|0;var b=0,c=0;b=i;i=i+8|0;c=ywc(a,0,0)|0;i=b;return c|0}function ywc(a,b,c){a=a|0;b=b|0;c=c|0;var d=0,e=0;d=i;i=i+24|0;e=zwc(a,b,c,0)|0;i=d;return e|0}function zwc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+64|0;h=b;b=d;d=e;e=f;do{if((b|0)!=0){j=ie[c[b>>2]&127](500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=c[b>>2];c[f+4>>2]=c[b+4>>2];c[f+8>>2]=c[b+8>>2]}else{j=h4c(500)|0;if((j|0)==0){break}f=j+12|0;c[f>>2]=29;c[f+4>>2]=49;c[f+8>>2]=746}}while(0);b=j;if((j|0)==0){k=b;l=k;i=g;return l|0}c[b+8>>2]=0;c[j+32>>2]=0;c[j+380>>2]=16;c[j+392>>2]=ie[c[j+12>>2]&127](c[j+380>>2]<<4)|0;b=j+12|0;if((c[j+392>>2]|0)==0){fe[c[b+8>>2]&1023](j);k=0;l=k;i=g;return l|0}c[j+44>>2]=ie[c[b>>2]&127](1024)|0;b=j;if((c[j+44>>2]|0)==0){fe[c[b+20>>2]&1023](c[j+392>>2]|0);fe[c[j+20>>2]&1023](j);k=0;l=k;i=g;return l|0}c[j+48>>2]=(c[b+44>>2]|0)+1024;do{if((e|0)!=0){c[j+356>>2]=e}else{c[j+356>>2]=Kxc(j+12|0)|0;if((c[j+356>>2]|0)!=0){break}fe[c[j+20>>2]&1023](c[j+44>>2]|0);fe[c[j+20>>2]&1023](c[j+392>>2]|0);fe[c[j+20>>2]&1023](j);k=0;l=k;i=g;return l|0}}while(0);c[j+376>>2]=0;c[j+368>>2]=0;c[j+304>>2]=0;c[j+468>>2]=0;c[j+464>>2]=0;c[j+124>>2]=0;c[j+248>>2]=0;a[j+472|0]=33;a[j+236|0]=0;a[j+237|0]=0;c[j+396>>2]=0;c[j+400>>2]=0;a[j+404|0]=0;Lxc(j+416|0,j+12|0);Lxc(j+440|0,j+12|0);Bwc(j,h);do{if((h|0)!=0){if((c[j+232>>2]|0)!=0){break}Ewc(j);k=0;l=k;i=g;return l|0}}while(0);if((d|0)!=0){a[j+236|0]=1;c[j+228>>2]=dyc()|0;a[j+472|0]=a[d]|0}else{c[j+228>>2]=Wxc()|0}k=j;l=k;i=g;return l|0}function Awc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+24|0;d=a;a=c[d>>2]|0;a:do{if((c[d+4>>2]|0)!=0){e=a;while(1){if((e|0)==0){break a}f=c[e>>2]|0;c[e>>2]=c[d+4>>2];c[d+4>>2]=e;e=f}}else{c[d+4>>2]=a}}while(0);c[d>>2]=0;c[d+16>>2]=0;c[d+12>>2]=0;c[d+8>>2]=0;i=b;return}function Bwc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0;e=i;i=i+16|0;f=b;b=d;c[f+280>>2]=36;mAc(f+256|0);if((b|0)!=0){g=Cwc(f+416|0,b)|0}else{g=0}c[f+232>>2]=g;c[f+360>>2]=0;Xxc(f+148|0,f+144|0,0)|0;c[f>>2]=0;c[f+4>>2]=0;c[f+52>>2]=0;c[f+56>>2]=0;c[f+60>>2]=0;c[f+64>>2]=0;c[f+68>>2]=0;c[f+72>>2]=0;c[f+76>>2]=0;c[f+80>>2]=0;c[f+84>>2]=0;c[f+88>>2]=0;c[f+92>>2]=0;c[f+96>>2]=0;c[f+100>>2]=0;c[f+104>>2]=0;c[f+108>>2]=0;c[f+112>>2]=0;c[f+116>>2]=f;c[f+120>>2]=0;c[f+128>>2]=0;c[f+132>>2]=0;c[f+136>>2]=0;c[f+140>>2]=0;c[f+24>>2]=c[f+8>>2];c[f+28>>2]=c[f+8>>2];c[f+36>>2]=0;c[f+40>>2]=0;c[f+344>>2]=0;c[f+348>>2]=0;c[f+316>>2]=0;c[f+320>>2]=0;c[f+324>>2]=0;c[f+328>>2]=0;c[f+332>>2]=0;c[f+336>>2]=0;c[f+340>>2]=0;a[f+352|0]=0;a[f+353|0]=0;g=f+408|0;c[g+0>>2]=0;c[g+4>>2]=0;c[f+284>>2]=0;c[f+288>>2]=0;c[f+292>>2]=0;c[f+296>>2]=0;c[f+300>>2]=0;a[f+308|0]=1;c[f+312>>2]=0;c[f+364>>2]=0;c[f+372>>2]=0;c[f+384>>2]=0;c[f+240>>2]=0;c[f+252>>2]=0;c[f+244>>2]=0;c[f+476>>2]=0;c[f+480>>2]=0;a[f+488|0]=0;a[f+489|0]=0;c[f+492>>2]=0;c[f+496>>2]=0;i=e;return}function Cwc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0;e=i;i=i+24|0;f=b;b=d;while(1){if((c[f+12>>2]|0)==(c[f+8>>2]|0)){if(!((Twc(f)|0)<<24>>24!=0)){g=5;break}}d=a[b]|0;h=f+12|0;j=c[h>>2]|0;c[h>>2]=j+1;a[j]=d;d=b;b=d+1|0;if((a[d]|0)==0){g=6;break}}if((g|0)==5){k=0;l=k;i=e;return l|0}else if((g|0)==6){b=c[f+16>>2]|0;c[f+16>>2]=c[f+12>>2];k=b;l=k;i=e;return l|0}return 0}function Dwc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0;e=i;i=i+56|0;f=b;b=d;d=c[f+356>>2]|0;g=b;a:while(1){if((a[b]|0)==0){h=45;break}do{if((a[g]|0)!=12){if((a[g]|0)==0){break}j=c[f+428>>2]|0;k=f+416|0;if((a[g]|0)!=61){if((j|0)==(c[k+8>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){h=44;break a}}l=a[g]|0;m=f+428|0;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;g=g+1|0;continue a}if((j-(c[k+16>>2]|0)|0)==0){o=d+152|0}else{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){h=19;break a}}k=f+428|0;j=c[k>>2]|0;c[k>>2]=j+1;a[j]=0;o=Wwc(f,d+60|0,c[f+432>>2]|0,8)|0;if((o|0)==0){h=20;break a}if((c[o>>2]|0)==(c[f+432>>2]|0)){c[o>>2]=Cwc(d+80|0,c[o>>2]|0)|0;if((c[o>>2]|0)==0){h=23;break a}}c[f+428>>2]=c[f+432>>2]}b=g+1|0;while(1){if((a[b]|0)!=12){p=(a[b]|0)!=0}else{p=0}q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if(!p){break}if(q){if(!((Twc(f+416|0)|0)<<24>>24!=0)){h=32;break a}}j=a[b]|0;k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=j;b=b+1|0}if(q){if(!((Twc(f+416|0)|0)<<24>>24!=0)){h=36;break a}}j=f+428|0;l=c[j>>2]|0;c[j>>2]=l+1;a[l]=0;if((_wc(f,o,0,c[f+432>>2]|0,f+372|0)|0)!=0){h=37;break a}c[f+428>>2]=c[f+432>>2];if((a[b]|0)!=0){b=b+1|0}g=b;continue a}}while(0);if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){h=8;break}}l=f+428|0;j=c[l>>2]|0;c[l>>2]=j+1;a[j]=0;j=Wwc(f,d,c[f+432>>2]|0,0)|0;if((j|0)!=0){a[j+32|0]=1}if((a[g]|0)!=0){g=g+1|0}b=g;c[f+428>>2]=c[f+432>>2]}if((h|0)==8){r=0;s=r;i=e;return s|0}else if((h|0)==19){r=0;s=r;i=e;return s|0}else if((h|0)==20){r=0;s=r;i=e;return s|0}else if((h|0)==23){r=0;s=r;i=e;return s|0}else if((h|0)==32){r=0;s=r;i=e;return s|0}else if((h|0)==36){r=0;s=r;i=e;return s|0}else if((h|0)==37){r=0;s=r;i=e;return s|0}else if((h|0)==44){r=0;s=r;i=e;return s|0}else if((h|0)==45){r=1;s=r;i=e;return s|0}return 0}function Ewc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+40|0;e=b;if((e|0)==0){i=d;return}b=c[e+364>>2]|0;while(1){if((b|0)==0){f=e;if((c[e+368>>2]|0)==0){break}b=c[f+368>>2]|0;c[e+368>>2]=0}g=b;b=c[b>>2]|0;fe[c[e+20>>2]&1023](c[g+36>>2]|0);Fwc(c[g+44>>2]|0,e);fe[c[e+20>>2]&1023](g)}b=c[f+300>>2]|0;while(1){if((b|0)==0){h=e;if((c[e+304>>2]|0)==0){break}b=c[h+304>>2]|0;c[e+304>>2]=0}f=b;b=c[b+8>>2]|0;fe[c[e+20>>2]&1023](f)}Fwc(c[h+376>>2]|0,e);Fwc(c[e+372>>2]|0,e);Gwc(e+416|0);Gwc(e+440|0);do{if((a[e+488|0]|0)==0){if((c[e+356>>2]|0)==0){break}Hwc(c[e+356>>2]|0,((c[e+476>>2]|0)!=0^1)&1,e+12|0)}}while(0);fe[c[e+20>>2]&1023](c[e+392>>2]|0);fe[c[e+20>>2]&1023](c[e+464>>2]|0);fe[c[e+20>>2]&1023](c[e+8>>2]|0);fe[c[e+20>>2]&1023](c[e+44>>2]|0);fe[c[e+20>>2]&1023](c[e+396>>2]|0);fe[c[e+20>>2]&1023](c[e+240>>2]|0);if((c[e+252>>2]|0)!=0){fe[c[e+252>>2]&1023](c[e+244>>2]|0)}fe[c[e+20>>2]&1023](e);i=d;return}function Fwc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+24|0;e=a;a=b;while(1){b=e;if((b|0)==0){break}e=c[b+4>>2]|0;fe[c[a+20>>2]&1023](c[b+16>>2]|0);fe[c[a+20>>2]&1023](b)}i=d;return}function Gwc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+32|0;d=a;a=c[d>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&1023](a);a=e}a=c[d+4>>2]|0;while(1){if((a|0)==0){break}e=c[a>>2]|0;fe[c[(c[d+20>>2]|0)+8>>2]&1023](a);a=e}i=b;return}function Hwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;e=i;i=i+40|0;f=e+24|0;g=a;a=b;b=d;Uwc(f,g+20|0);while(1){d=Vwc(f)|0;if((d|0)==0){break}if((c[d+16>>2]|0)==0){continue}fe[c[b+8>>2]&1023](c[d+20>>2]|0)}Zwc(g);Zwc(g+132|0);Zwc(g+20|0);Zwc(g+40|0);Zwc(g+60|0);Gwc(g+80|0);Gwc(g+104|0);if(!(a<<24>>24!=0)){h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&1023](o);i=e;return}fe[c[b+8>>2]&1023](c[g+184>>2]|0);fe[c[b+8>>2]&1023](c[g+164>>2]|0);h=b;j=h;k=j+8|0;l=k;m=c[l>>2]|0;n=g;o=n;fe[m&1023](o);i=e;return}function Iwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;i=i+16|0;e=a;a=(c[e+4>>2]|0)==(c[e>>2]|0);f=b;c[e>>2]=f;if(!a){i=d;return}c[e+4>>2]=f;i=d;return}function Jwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0;e=i;i=i+24|0;f=a;c[f+52>>2]=b;c[f+56>>2]=d;i=e;return}function Kwc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=d;d=e;e=f;f=c[h+480>>2]|0;do{if((f|0)==2){c[h+284>>2]=36;j=0;k=j;i=g;return k|0}else if((f|0)==3){c[h+284>>2]=33;j=0;k=j;i=g;return k|0}else if((f|0)==0){if((c[h+476>>2]|0)!=0){break}if((Lwc(h)|0)<<24>>24!=0){break}c[h+284>>2]=1;j=0;k=j;i=g;return k|0}}while(0);c[h+480>>2]=1;if((d|0)!=0){f=Nwc(h,d)|0;if((f|0)==0){j=0;k=j;i=g;return k|0}else{N4c(f|0,b|0,d|0)|0;j=Owc(h,d,e)|0;k=j;i=g;return k|0}}a[h+484|0]=e;if((e|0)==0){j=1;k=j;i=g;return k|0}c[h+296>>2]=c[h+24>>2];c[h+40>>2]=c[h+28>>2];c[h+284>>2]=He[c[h+280>>2]&63](h,c[h+24>>2]|0,c[h+40>>2]|0,h+24|0)|0;e=h;if((c[h+284>>2]|0)!=0){c[h+292>>2]=c[e+288>>2];c[h+280>>2]=37;j=0;k=j;i=g;return k|0}d=c[e+480>>2]|0;if((d|0)==3){Ie[c[(c[h+144>>2]|0)+52>>2]&63](c[h+144>>2]|0,c[h+296>>2]|0,c[h+24>>2]|0,h+408|0);c[h+296>>2]=c[h+24>>2];j=2;k=j;i=g;return k|0}else if((d|0)==1|(d|0)==0){c[h+480>>2]=2}j=1;k=j;i=g;return k|0}function Lwc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+16|0;e=b;if((c[e+496>>2]|0)==0){c[e+496>>2]=Ixc()|0}if((a[e+236|0]|0)!=0){f=Dwc(e,283376)|0;g=f;i=d;return g|0}else{f=1;g=f;i=d;return g|0}return 0}function Mwc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;e=i;i=i+32|0;i=e;return c[a+284>>2]|0}function Nwc(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0;d=i;i=i+72|0;e=a;a=b;b=c[e+480>>2]|0;if((b|0)==3){c[e+284>>2]=33;f=0;g=f;i=d;return g|0}else if((b|0)==2){c[e+284>>2]=36;f=0;g=f;i=d;return g|0}else{if((a|0)>((c[e+32>>2]|0)-(c[e+28>>2]|0)|0)){b=a+((c[e+28>>2]|0)-(c[e+24>>2]|0))|0;a=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;h=a;h=(h|0)>1024?1024:a;b=b+h|0;do{if((b|0)<=((c[e+32>>2]|0)-(c[e+8>>2]|0)|0)){if((h|0)>=((c[e+24>>2]|0)-(c[e+8>>2]|0)|0)){break}a=(c[e+24>>2]|0)-(c[e+8>>2]|0)-h|0;O4c(c[e+8>>2]|0,(c[e+8>>2]|0)+a|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+h|0)|0;j=e+28|0;c[j>>2]=(c[j>>2]|0)+(0-a);j=e+24|0;c[j>>2]=(c[j>>2]|0)+(0-a)}else{a=(c[e+32>>2]|0)-(c[e+24>>2]|0)|0;j=a;j=(j|0)==0?1024:a;do{j=j<<1;}while((j|0)<(b|0));a=ie[c[e+12>>2]&127](j)|0;if((a|0)==0){c[e+284>>2]=1;f=0;g=f;i=d;return g|0}c[e+32>>2]=a+j;if((c[e+24>>2]|0)!=0){k=(c[e+24>>2]|0)-(c[e+8>>2]|0)|0;l=k;l=(l|0)>1024?1024:k;N4c(a|0,(c[e+24>>2]|0)+(0-l)|0,(c[e+28>>2]|0)-(c[e+24>>2]|0)+l|0)|0;fe[c[e+20>>2]&1023](c[e+8>>2]|0);c[e+8>>2]=a;c[e+28>>2]=(c[e+8>>2]|0)+((c[e+28>>2]|0)-(c[e+24>>2]|0))+l;c[e+24>>2]=(c[e+8>>2]|0)+l;break}else{c[e+28>>2]=a+((c[e+28>>2]|0)-(c[e+24>>2]|0));l=a;c[e+8>>2]=l;c[e+24>>2]=l;break}}}while(0);c[e+292>>2]=0;c[e+288>>2]=0;c[e+296>>2]=0}f=c[e+28>>2]|0;g=f;i=d;return g|0}return 0}function Owc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0;f=i;i=i+48|0;g=b;b=d;d=e;e=1;h=c[g+480>>2]|0;do{if((h|0)==3){c[g+284>>2]=33;j=0;k=j;i=f;return k|0}else if((h|0)==2){c[g+284>>2]=36;j=0;k=j;i=f;return k|0}else if((h|0)==0){if((c[g+476>>2]|0)!=0){break}if((Lwc(g)|0)<<24>>24!=0){break}c[g+284>>2]=1;j=0;k=j;i=f;return k|0}}while(0);c[g+480>>2]=1;h=c[g+24>>2]|0;c[g+296>>2]=h;l=g+28|0;c[l>>2]=(c[l>>2]|0)+b;c[g+40>>2]=c[g+28>>2];l=g+36|0;c[l>>2]=(c[l>>2]|0)+b;a[g+484|0]=d;c[g+284>>2]=He[c[g+280>>2]&63](g,h,c[g+40>>2]|0,g+24|0)|0;h=g;if((c[g+284>>2]|0)!=0){c[g+292>>2]=c[h+288>>2];c[g+280>>2]=37;j=0;k=j;i=f;return k|0}b=c[h+480>>2]|0;do{if((b|0)==1|(b|0)==0){if((d|0)==0){break}c[g+480>>2]=2;j=e;k=j;i=f;return k|0}else if((b|0)==3){e=2}}while(0);Ie[c[(c[g+144>>2]|0)+52>>2]&63](c[g+144>>2]|0,c[g+296>>2]|0,c[g+24>>2]|0,g+408|0);c[g+296>>2]=c[g+24>>2];j=e;k=j;i=f;return k|0}function Pwc(a){a=a|0;var b=0;b=i;i=i+8|0;i=b;return c[a+284>>2]|0}function Qwc(a){a=a|0;var b=0,d=0;b=i;i=i+8|0;d=a;do{if((c[d+288>>2]|0)!=0){if(!((c[d+288>>2]|0)>>>0>=(c[d+296>>2]|0)>>>0)){break}Ie[c[(c[d+144>>2]|0)+52>>2]&63](c[d+144>>2]|0,c[d+296>>2]|0,c[d+288>>2]|0,d+408|0);c[d+296>>2]=c[d+288>>2]}}while(0);i=b;return(c[d+408>>2]|0)+1|0}function Rwc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+16|0;j=g+48|0;k=b;b=d;c[h>>2]=e;e=f;if((a[b+72|0]|0)!=0){Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[h>>2]|0,e-(c[h>>2]|0)|0);i=g;return}f=k;if((b|0)==(c[k+144>>2]|0)){l=f+288|0;m=k+292|0}else{l=c[f+300>>2]|0;m=(c[k+300>>2]|0)+4|0}do{c[j>>2]=c[k+44>>2];ce[c[b+60>>2]&31](b,h,e,j,c[k+48>>2]|0);c[m>>2]=c[h>>2];Ee[c[k+80>>2]&15](c[k+4>>2]|0,c[k+44>>2]|0,(c[j>>2]|0)-(c[k+44>>2]|0)|0);c[l>>2]=c[h>>2];}while((c[h>>2]|0)!=(e|0));i=g;return}function Swc(a){a=a|0;var b=0,d=0,e=0,f=0;b=i;i=i+16|0;d=a;if(d>>>0>0&d>>>0<41){e=c[281600+(d<<2)>>2]|0;f=e;i=b;return f|0}else{e=0;f=e;i=b;return f|0}return 0}function Twc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;do{if((c[d+4>>2]|0)!=0){a=d;if((c[d+16>>2]|0)==0){c[d>>2]=c[a+4>>2];c[d+4>>2]=c[c[d+4>>2]>>2];c[c[d>>2]>>2]=0;c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);c[d+12>>2]=c[d+16>>2];e=1;f=e;i=b;return f|0}if(((c[a+8>>2]|0)-(c[d+16>>2]|0)|0)>=(c[(c[d+4>>2]|0)+4>>2]|0)){break}a=c[c[d+4>>2]>>2]|0;c[c[d+4>>2]>>2]=c[d>>2];c[d>>2]=c[d+4>>2];c[d+4>>2]=a;N4c((c[d>>2]|0)+8|0,c[d+16>>2]|0,(c[d+8>>2]|0)-(c[d+16>>2]|0)|0)|0;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+(c[(c[d>>2]|0)+4>>2]|0);e=1;f=e;i=b;return f|0}}while(0);do{if((c[d>>2]|0)!=0){if((c[d+16>>2]|0)!=((c[d>>2]|0)+8|0)){g=11;break}a=(c[d+8>>2]|0)-(c[d+16>>2]|0)<<1;h=xe[c[(c[d+20>>2]|0)+4>>2]&63](c[d>>2]|0,8+a|0)|0;if((h|0)!=0){c[d>>2]=h;c[(c[d>>2]|0)+4>>2]=a;c[d+12>>2]=(c[d>>2]|0)+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=(c[d>>2]|0)+8;c[d+8>>2]=(c[d+16>>2]|0)+a;break}e=0;f=e;i=b;return f|0}else{g=11}}while(0);if((g|0)==11){g=(c[d+8>>2]|0)-(c[d+16>>2]|0)|0;if((g|0)<1024){g=1024}else{g=g<<1}a=ie[c[c[d+20>>2]>>2]&127](8+g|0)|0;if((a|0)==0){e=0;f=e;i=b;return f|0}c[a+4>>2]=g;c[a>>2]=c[d>>2];c[d>>2]=a;if((c[d+12>>2]|0)!=(c[d+16>>2]|0)){N4c(a+8|0,c[d+16>>2]|0,(c[d+12>>2]|0)-(c[d+16>>2]|0)|0)|0}c[d+12>>2]=a+8+((c[d+12>>2]|0)-(c[d+16>>2]|0));c[d+16>>2]=a+8;c[d+8>>2]=a+8+g}e=1;f=e;i=b;return f|0}function Uwc(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;i=i+16|0;e=a;a=b;c[e>>2]=c[a>>2];c[e+4>>2]=(c[e>>2]|0)+(c[a+8>>2]<<2);i=d;return}function Vwc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+24|0;d=a;while(1){if((c[d>>2]|0)==(c[d+4>>2]|0)){e=5;break}a=d;f=c[a>>2]|0;c[a>>2]=f+4;g=c[f>>2]|0;if((g|0)!=0){e=4;break}}if((e|0)==4){h=g;j=h;i=b;return j|0}else if((e|0)==5){h=0;j=h;i=b;return j|0}return 0}function Wwc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0;h=i;i=i+136|0;j=b;b=e;e=f;f=g;a:do{if((c[b+8>>2]|0)==0){if((f|0)==0){k=0;l=k;i=h;return l|0}a[b+4|0]=6;c[b+8>>2]=64;g=c[b+8>>2]<<2;c[b>>2]=ie[c[c[b+16>>2]>>2]&127](g)|0;m=b;if((c[b>>2]|0)!=0){P4c(c[m>>2]|0,0,g|0)|0;g=Xwc(j,e)|0;n=g&(c[b+8>>2]|0)-1;break}c[m+8>>2]=0;k=0;l=k;i=h;return l|0}else{m=Xwc(j,e)|0;g=(c[b+8>>2]|0)-1|0;o=0;n=m&g;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break}if((Ywc(e,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0)<<24>>24!=0){p=10;break}if(!(o<<24>>24!=0)){o=((m&~g)>>>((d[b+4|0]|0)-1|0)&g>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+((c[b+8>>2]|0)-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}if((p|0)==10){k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}if((f|0)==0){k=0;l=k;i=h;return l|0}if(((c[b+12>>2]|0)>>>((d[b+4|0]|0)-1|0)|0)==0){break}g=(d[b+4|0]|0)+1&255;q=1<<(g&255);r=q-1|0;s=q<<2;t=ie[c[c[b+16>>2]>>2]&127](s)|0;if((t|0)==0){k=0;l=k;i=h;return l|0}P4c(t|0,0,s|0)|0;n=0;while(1){if(!(n>>>0<(c[b+8>>2]|0)>>>0)){break}if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){s=Xwc(j,c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]|0)|0;u=s&r;o=0;while(1){if((c[t+(u<<2)>>2]|0)==0){break}if(!(o<<24>>24!=0)){o=((s&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(u>>>0<(o&255)>>>0){u=u+(q-(o&255))|0;continue}else{u=u-(o&255)|0;continue}}c[t+(u<<2)>>2]=c[(c[b>>2]|0)+(n<<2)>>2]}n=n+1|0}fe[c[(c[b+16>>2]|0)+8>>2]&1023](c[b>>2]|0);c[b>>2]=t;a[b+4|0]=g;c[b+8>>2]=q;n=m&r;o=0;while(1){if((c[(c[b>>2]|0)+(n<<2)>>2]|0)==0){break a}if(!(o<<24>>24!=0)){o=((m&~r)>>>((g&255)-1|0)&r>>>2|1)&255}if(n>>>0<(o&255)>>>0){n=n+(q-(o&255))|0;continue}else{n=n-(o&255)|0;continue}}}}while(0);j=ie[c[c[b+16>>2]>>2]&127](f)|0;c[(c[b>>2]|0)+(n<<2)>>2]=j;if((c[(c[b>>2]|0)+(n<<2)>>2]|0)!=0){P4c(c[(c[b>>2]|0)+(n<<2)>>2]|0,0,f|0)|0;c[c[(c[b>>2]|0)+(n<<2)>>2]>>2]=e;e=b+12|0;c[e>>2]=(c[e>>2]|0)+1;k=c[(c[b>>2]|0)+(n<<2)>>2]|0;l=k;i=h;return l|0}else{k=0;l=k;i=h;return l|0}return 0}function Xwc(b,e){b=b|0;e=e|0;var f=0,g=0,h=0;f=i;i=i+24|0;g=e;e=c[b+496>>2]|0;while(1){h=e;if((a[g]|0)==0){break}b=g;g=b+1|0;e=h*1000003^d[b]}i=f;return h|0}function Ywc(b,c){b=b|0;c=c|0;var d=0,e=0,f=0,g=0,h=0;d=i;i=i+24|0;e=b;b=c;while(1){if((a[e]|0)!=(a[b]|0)){f=6;break}if((a[e]|0)==0){f=4;break}e=e+1|0;b=b+1|0}if((f|0)==4){g=1;h=g;i=d;return h|0}else if((f|0)==6){g=0;h=g;i=d;return h|0}return 0}function Zwc(a){a=a|0;var b=0,d=0,e=0;b=i;i=i+16|0;d=a;a=0;while(1){e=c[(c[d+16>>2]|0)+8>>2]|0;if(!(a>>>0<(c[d+8>>2]|0)>>>0)){break}fe[e&1023](c[(c[d>>2]|0)+(a<<2)>>2]|0);a=a+1|0}fe[e&1023](c[d>>2]|0);i=b;return}function _wc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;h=i;i=i+96|0;j=b;b=d;d=e;e=f;f=g;g=0;k=1;l=1;do{if((a[e]|0)==0){if((c[b>>2]|0)==0){break}m=28;n=m;i=h;return n|0}}while(0);do{if((c[b>>2]|0)!=0){if((a[c[b>>2]|0]|0)!=120){break}if((a[(c[b>>2]|0)+1|0]|0)!=109){break}if((a[(c[b>>2]|0)+2|0]|0)!=108){break}do{if((a[(c[b>>2]|0)+3|0]|0)==110){if((a[(c[b>>2]|0)+4|0]|0)!=115){break}if((a[(c[b>>2]|0)+5|0]|0)!=0){break}m=39;n=m;i=h;return n|0}}while(0);if((a[(c[b>>2]|0)+3|0]|0)!=0){break}g=1}}while(0);o=0;while(1){p=(k&255|0)!=0;if((a[e+o|0]|0)==0){break}do{if(p){if((o|0)<=36){if((a[e+o|0]|0)==(a[283184+o|0]|0)){break}}k=0}}while(0);do{if(!(g<<24>>24!=0)){if((l&255|0)==0){break}if((o|0)<=29){if((a[e+o|0]|0)==(a[283224+o|0]|0)){break}}l=0}}while(0);o=o+1|0}if(p){q=(o|0)==36}else{q=0}k=q&1;if((l&255|0)!=0){r=(o|0)==29}else{r=0}l=r&1;if((g&255|0)!=(k&255|0)){m=(g&255|0)!=0?38:40;n=m;i=h;return n|0}if(l<<24>>24!=0){m=40;n=m;i=h;return n|0}if((a[j+472|0]|0)!=0){o=o+1|0}l=j;do{if((c[j+376>>2]|0)!=0){s=c[l+376>>2]|0;do{if((o|0)>(c[s+24>>2]|0)){g=xe[c[j+16>>2]&63](c[s+16>>2]|0,o+24|0)|0;if((g|0)!=0){c[s+16>>2]=g;c[s+24>>2]=o+24;break}m=1;n=m;i=h;return n|0}}while(0);c[j+376>>2]=c[s+4>>2]}else{s=ie[c[l+12>>2]&127](28)|0;if((s|0)==0){m=1;n=m;i=h;return n|0}c[s+16>>2]=ie[c[j+12>>2]&127](o+24|0)|0;if((c[s+16>>2]|0)!=0){c[s+24>>2]=o+24;break}fe[c[j+20>>2]&1023](s);m=1;n=m;i=h;return n|0}}while(0);c[s+20>>2]=o;N4c(c[s+16>>2]|0,e|0,o|0)|0;if((a[j+472|0]|0)!=0){a[(c[s+16>>2]|0)+(o-1)|0]=a[j+472|0]|0}c[s>>2]=b;c[s+12>>2]=d;c[s+8>>2]=c[b+4>>2];do{if((a[e]|0)==0){if((b|0)!=((c[j+356>>2]|0)+152|0)){t=52;break}c[b+4>>2]=0}else{t=52}}while(0);if((t|0)==52){c[b+4>>2]=s}c[s+4>>2]=c[f>>2];c[f>>2]=s;do{if((d|0)!=0){if((c[j+100>>2]|0)==0){break}Ee[c[j+100>>2]&15](c[j+4>>2]|0,c[b>>2]|0,(c[b+4>>2]|0)!=0?e:0)}}while(0);m=0;n=m;i=h;return n|0}function $wc(b){b=b|0;var d=0,e=0,f=0,g=0;d=i;i=i+24|0;e=b;if((le[((a[e+236|0]&255|0)!=0?33:34)&63](e+148|0,e+144|0,c[e+232>>2]|0)|0)!=0){f=0;g=f;i=d;return g|0}else{f=Hxc(e,c[e+232>>2]|0)|0;g=f;i=d;return g|0}return 0}function axc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=g+32|0;j=b;b=d;d=e;c[h>>2]=b;e=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=bxc(j,c[j+144>>2]|0,b,d,e,c[h>>2]|0,f,((a[j+484|0]|0)!=0^1)&1)|0;i=g;return k|0}function bxc(b,e,f,g,h,j,k,l){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+368|0;n=m+48|0;o=b;b=e;e=f;f=g;g=h;c[n>>2]=j;j=k;k=l;l=c[o+356>>2]|0;h=o;if((b|0)==(c[o+144>>2]|0)){p=h+288|0;q=o+292|0}else{p=c[h+300>>2]|0;q=(c[o+300>>2]|0)+4|0}a:while(1){h=1;c[p>>2]=e;c[q>>2]=c[n>>2];b:do{if((g|0)<=0){if((k&255|0)!=0){if((g|0)!=0){r=7;break a}}switch(g|0){case 0:{r=9;break a;break};case-1:{r=10;break a;break};case-2:{r=11;break a;break};case-15:{g=0-g|0;break b;break};case-4:{r=13;break a;break};default:{g=0-g|0;c[n>>2]=f;break b}}}}while(0);s=ye[c[o+256>>2]&63](o+256|0,g,e,c[n>>2]|0,b)|0;c:do{switch(s|0){case 1:{t=cxc(o,0,e,c[n>>2]|0)|0;if((t|0)!=0){r=25;break a}b=c[o+144>>2]|0;h=0;break};case 6:{a[o+489|0]=0;c[o+316>>2]=Wwc(o,l+132|0,283256,36)|0;if((c[o+316>>2]|0)==0){r=38;break a}a[l+129|0]=1;if((c[o+84>>2]|0)==0){r=45;break c}if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=41;break a}u=dxc(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((u|0)==0){r=43;break a}exc(u);c[o+432>>2]=c[o+428>>2];c[o+328>>2]=u;h=0;r=47;break};case 4:{if((c[o+84>>2]|0)!=0){c[o+320>>2]=dxc(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+320>>2]|0)==0){r=29;break a}c[o+432>>2]=c[o+428>>2];c[o+328>>2]=0;h=0}c[o+324>>2]=0;break};case 7:{if((c[o+84>>2]|0)==0){break c}ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,1);c[o+320>>2]=0;Awc(o+416|0);h=0;break};case 57:{v=cxc(o,1,e,c[n>>2]|0)|0;if((v|0)!=0){r=35;break a}b=c[o+144>>2]|0;h=0;break};case 22:{c[o+348>>2]=hxc(o,b,e,c[n>>2]|0)|0;if((c[o+348>>2]|0)==0){r=92;break a}a[o+352|0]=0;c[o+332>>2]=0;a[o+353|0]=0;r=102;break};case 14:{r=45;break};case 8:{if((c[o+320>>2]|0)!=0){ce[c[o+84>>2]&31](c[o+4>>2]|0,c[o+320>>2]|0,c[o+324>>2]|0,c[o+328>>2]|0,0);Awc(o+416|0);h=0}if((c[o+324>>2]|0)!=0){r=57}else{if((d[o+489|0]|0)!=0){r=57}}if((r|0)==57){r=0;u=a[l+129|0]|0;a[l+129|0]=1;do{if((c[o+492>>2]|0)!=0){if((c[o+112>>2]|0)==0){break}w=Wwc(o,l+132|0,283256,36)|0;if((w|0)==0){r=60;break a}if((a[o+489|0]|0)!=0){c[w+20>>2]=c[o+360>>2]}a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)==0){r=64;break a}if((a[l+131|0]|0)==0){if((c[o+324>>2]|0)!=0){break}a[l+129|0]=u;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=69;break a}}}while(0);a[o+489|0]=0}if((c[o+88>>2]|0)==0){break c}fe[c[o+88>>2]&1023](c[o+4>>2]|0);h=0;break};case 2:{r=75;break a;break};case 34:{c[o+344>>2]=gxc(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)!=0){r=102}else{r=90;break a}break};case 32:case 31:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)!=0){x=283360}else{x=(s|0)==32?283344:283368}if((ixc(o+416|0,x)|0)==0){r=111;break a}if((jxc(o+416|0,b,e,c[n>>2]|0)|0)==0){r=113;break a}c[o+332>>2]=c[o+432>>2];h=0;break};case 23:{a[o+352|0]=1;c[o+332>>2]=283264;r=102;break};case 24:{a[o+353|0]=1;c[o+332>>2]=283272;r=102;break};case 25:{c[o+332>>2]=283280;r=102;break};case 26:{c[o+332>>2]=283288;r=102;break};case 27:{c[o+332>>2]=283296;r=102;break};case 28:{c[o+332>>2]=283304;r=102;break};case 29:{c[o+332>>2]=283320;r=102;break};case 30:{c[o+332>>2]=283328;r=102;break};case 36:case 35:{if((a[l+128|0]|0)==0){break c}if((kxc(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,a[o+353|0]|0,0,o)|0)==0){r=117;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=123}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=123}}}while(0);if((r|0)==123){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Twc(o+416|0)|0)<<24>>24!=0)){r=128;break a}}u=o+428|0;w=c[u>>2]|0;c[u>>2]=w+1;a[w]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Twc(o+416|0)|0)<<24>>24!=0)){r=128;break a}}w=o+428|0;u=c[w>>2]|0;c[w>>2]=u+1;a[u]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,0,(s|0)==36|0);Awc(o+416|0);h=0;break};case 5:{a[o+489|0]=0;a[l+129|0]=1;u=o;if((c[o+84>>2]|0)!=0){c[o+324>>2]=dxc(u+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((c[o+324>>2]|0)==0){r=156;break a}c[o+432>>2]=c[o+428>>2];h=0}else{c[u+324>>2]=283256}do{if((a[l+130|0]|0)==0){if((c[o+492>>2]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=163;break a}}}while(0);if((c[o+316>>2]|0)!=0){r=168;break c}c[o+316>>2]=Wwc(o,l+132|0,283256,36)|0;if((c[o+316>>2]|0)==0){r=166;break a}c[(c[o+316>>2]|0)+24>>2]=0;r=168;break};case 38:case 37:{if((a[l+128|0]|0)==0){break c}y=lxc(o,b,a[o+352|0]|0,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0,l+80|0)|0;if((y|0)!=0){r=132;break a}u=c[l+96>>2]|0;c[l+96>>2]=c[l+92>>2];if((kxc(c[o+344>>2]|0,c[o+348>>2]|0,a[o+352|0]|0,0,u,o)|0)==0){r=134;break a}if((c[o+132>>2]|0)==0){break c}if((c[o+332>>2]|0)==0){break c}do{if((a[c[o+332>>2]|0]|0)==40){r=140}else{if((a[c[o+332>>2]|0]|0)!=78){break}if((a[(c[o+332>>2]|0)+1|0]|0)==79){r=140}}}while(0);if((r|0)==140){r=0;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Twc(o+416|0)|0)<<24>>24!=0)){r=145;break a}}w=o+428|0;z=c[w>>2]|0;c[w>>2]=z+1;a[z]=41;if((c[o+428>>2]|0)==(c[o+424>>2]|0)){if(!((Twc(o+416|0)|0)<<24>>24!=0)){r=145;break a}}z=o+428|0;w=c[z>>2]|0;c[z>>2]=w+1;a[w]=0;c[o+332>>2]=c[o+432>>2];c[o+432>>2]=c[o+428>>2]}c[q>>2]=e;re[c[o+132>>2]&31](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,c[c[o+348>>2]>>2]|0,c[o+332>>2]|0,u,(s|0)==38|0);Awc(o+416|0);h=0;break};case 12:{if((a[l+128|0]|0)==0){break c}A=mxc(o,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;w=c[l+120>>2]|0;do{if((c[o+316>>2]|0)!=0){c[(c[o+316>>2]|0)+4>>2]=w;c[(c[o+316>>2]|0)+8>>2]=(c[l+116>>2]|0)-(c[l+120>>2]|0);c[l+120>>2]=c[l+116>>2];if((c[o+136>>2]|0)==0){break}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,c[(c[o+316>>2]|0)+4>>2]|0,c[(c[o+316>>2]|0)+8>>2]|0,c[o+360>>2]|0,0,0,0);h=0}else{c[l+116>>2]=w}}while(0);if((A|0)!=0){r=153;break a}break};case 13:{r=168;break};case 15:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,d[(c[o+316>>2]|0)+33|0]|0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,0);h=0;break};case 16:{if((d[l+128|0]|0)==0){break c}if((c[o+316>>2]|0)==0){break c}w=dxc(l+80|0,b,e,c[n>>2]|0)|0;c[(c[o+316>>2]|0)+28>>2]=w;if((c[(c[o+316>>2]|0)+28>>2]|0)==0){r=181;break a}c[l+96>>2]=c[l+92>>2];if((c[o+92>>2]|0)!=0){c[q>>2]=e;re[c[o+92>>2]&31](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break c}if((c[o+136>>2]|0)==0){break c}c[q>>2]=e;we[c[o+136>>2]&3](c[o+4>>2]|0,c[c[o+316>>2]>>2]|0,0,0,0,c[(c[o+316>>2]|0)+20>>2]|0,c[(c[o+316>>2]|0)+16>>2]|0,c[(c[o+316>>2]|0)+24>>2]|0,c[(c[o+316>>2]|0)+28>>2]|0);h=0;break};case 9:{if((le[c[b+48>>2]&63](b,e,c[n>>2]|0)|0)!=0){c[o+316>>2]=0;break c}w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=dxc(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=190;break a}c[o+316>>2]=Wwc(o,l,u,36)|0;if((c[o+316>>2]|0)==0){r=192;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=0;if((c[o+476>>2]|0)!=0){B=1}else{B=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(B^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 10:{w=l+80|0;if((a[l+128|0]|0)==0){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}u=dxc(w,b,e,c[n>>2]|0)|0;if((u|0)==0){r=202;break a}c[o+316>>2]=Wwc(o,l+132|0,u,36)|0;if((c[o+316>>2]|0)==0){r=204;break a}w=l+80|0;if((c[c[o+316>>2]>>2]|0)!=(u|0)){c[l+92>>2]=c[w+16>>2];c[o+316>>2]=0;break c}c[l+96>>2]=c[w+12>>2];c[(c[o+316>>2]|0)+24>>2]=0;a[(c[o+316>>2]|0)+33|0]=1;if((c[o+476>>2]|0)!=0){C=1}else{C=(c[o+300>>2]|0)!=0}a[(c[o+316>>2]|0)+34|0]=(C^1)&1;if((c[o+136>>2]|0)==0){break c}h=0;break};case 18:{c[o+340>>2]=0;c[o+336>>2]=0;if((c[o+96>>2]|0)==0){break c}c[o+336>>2]=dxc(o+416|0,b,e,c[n>>2]|0)|0;if((c[o+336>>2]|0)==0){r=214;break a}c[o+432>>2]=c[o+428>>2];h=0;break};case 58:{if((c[o+80>>2]|0)!=0){Rwc(o,b,e,c[n>>2]|0)}h=0;D=nxc(o,b,n,f,j,k)|0;if((D|0)!=0){r=239;break a}if((c[n>>2]|0)==0){r=241;break a}break};case 21:{if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)==0){r=217;break a}if((c[o+336>>2]|0)==0){break c}w=dxc(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=220;break a}exc(w);c[o+340>>2]=w;c[o+432>>2]=c[o+428>>2];h=0;break};case 19:{do{if((c[o+336>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}w=dxc(o+416|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((w|0)==0){r=225;break a}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,w,c[o+340>>2]|0);h=0}}while(0);Awc(o+416|0);break};case 20:{do{if((c[o+340>>2]|0)!=0){if((c[o+96>>2]|0)==0){break}c[q>>2]=e;ce[c[o+96>>2]&31](c[o+4>>2]|0,c[o+336>>2]|0,c[o+360>>2]|0,0,c[o+340>>2]|0);h=0}}while(0);Awc(o+416|0);break};case-1:{r=232;break a;break};case 44:{do{if((c[o+260>>2]|0)>>>0>=(c[o+468>>2]|0)>>>0){w=o+12|0;if((c[o+468>>2]|0)==0){u=c[w>>2]|0;c[o+468>>2]=32;c[o+464>>2]=ie[u&127](32)|0;if((c[o+464>>2]|0)!=0){break}else{r=251;break a}}u=c[w+4>>2]|0;w=c[o+464>>2]|0;z=o+468|0;E=c[z>>2]<<1;c[z>>2]=E;z=xe[u&63](w,E)|0;if((z|0)==0){r=245;break a}c[o+464>>2]=z;if((c[l+184>>2]|0)==0){break}z=xe[c[o+16>>2]&63](c[l+184>>2]|0,c[o+468>>2]<<2)|0;if((z|0)==0){r=248;break a}c[l+184>>2]=z}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=0;if((a[l+160|0]|0)==0){break c}z=pxc(o)|0;if((z|0)<0){r=254;break a}c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]=z;E=l+180|0;c[E>>2]=(c[E>>2]|0)+1;c[(c[l+164>>2]|0)+(z*28|0)>>2]=6;if((c[o+128>>2]|0)==0){break c}h=0;break};case 50:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==124){r=258;break a}a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=44;if((d[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)==0){break c}h=0;break};case 49:{if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)==44){r=263;break a}do{if((d[l+160|0]|0)!=0){if((a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]|0)!=0){break}if((c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]|0)==3){break}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=5;if((c[o+128>>2]|0)==0){break}h=0}}while(0);a[(c[o+464>>2]|0)+(c[o+260>>2]|0)|0]=124;break};case 59:case 60:{a[l+129|0]=1;z=l;do{if((c[o+492>>2]|0)!=0){E=dxc(z+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=273;break a}w=Wwc(o,l+132|0,E,0)|0;c[l+92>>2]=c[l+96>>2];do{if((c[o+272>>2]|0)!=0){if((d[l+130|0]|0)!=0){if((c[o+300>>2]|0)!=0){r=282;break}}else{if((a[l+129|0]|0)!=0){r=282;break}}if((w|0)==0){r=279;break a}if((a[w+34|0]|0)==0){r=281;break a}}else{r=282}}while(0);do{if((r|0)==282){r=0;if((w|0)!=0){break}a[l+128|0]=a[l+130|0]|0;if((s|0)!=60){break c}if((c[o+120>>2]|0)==0){break c}Ee[c[o+120>>2]&15](c[o+4>>2]|0,E,1);h=0;break c}}while(0);if((a[w+32|0]|0)!=0){r=287;break a}if((c[w+4>>2]|0)!=0){F=qxc(o,w,((s|0)==60?1:0)&255)|0;if((F|0)!=0){r=290;break a}h=0;break c}E=l;if((c[o+112>>2]|0)==0){a[l+128|0]=a[E+130|0]|0;break c}a[E+131|0]=0;a[w+32|0]=1;E=(ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[w+20>>2]|0,c[w+16>>2]|0,c[w+24>>2]|0)|0)!=0;a[w+32|0]=0;if(!E){r=294;break a}h=0;if((a[l+131|0]|0)!=0){break}a[l+128|0]=a[l+130|0]|0;break c}else{a[l+128|0]=a[z+130|0]|0}}while(0);if((a[l+130|0]|0)!=0){break c}if((c[o+108>>2]|0)==0){break c}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)==0){r=301;break a}break};case 53:{G=1;r=319;break};case 52:{G=2;r=319;break};case 54:{G=3;r=319;break};case 40:{if((c[o+128>>2]|0)==0){break c}c[o+344>>2]=gxc(o,b,e,c[n>>2]|0)|0;if((c[o+344>>2]|0)==0){r=304;break a}c[l+180>>2]=0;c[l+176>>2]=0;a[l+160|0]=1;h=0;break};case 42:case 41:{if((a[l+160|0]|0)==0){break c}if((c[o+128>>2]|0)!=0){z=ie[c[o+12>>2]&127](20)|0;if((z|0)==0){r=309;break a}c[z+4>>2]=0;c[z+8>>2]=0;c[z+12>>2]=0;c[z+16>>2]=0;c[z>>2]=(s|0)==41?2:1;c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,z);h=0}a[l+160|0]=0;break};case 43:{if((a[l+160|0]|0)==0){break c}c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+((c[l+180>>2]|0)-1<<2)>>2]|0)*28|0)>>2]=3;if((c[o+128>>2]|0)==0){break c}h=0;break};case 51:{G=0;r=319;break};case 47:{G=1;r=334;break};case 46:{G=2;r=334;break};case 48:{G=3;r=334;break};case 45:{G=0;r=334;break};case 56:{if((txc(o,b,e,c[n>>2]|0)|0)==0){r=347;break a}h=0;break};case 0:{if((g|0)!=14){break c}h=0;break};case 3:{if((c[o+84>>2]|0)==0){break c}h=0;break};case 11:{if((d[l+128|0]|0)==0){break c}if((c[o+136>>2]|0)==0){break c}h=0;break};case 55:{if((sxc(o,b,e,c[n>>2]|0)|0)==0){r=344;break a}h=0;break};case 17:{if((c[o+96>>2]|0)==0){break c}h=0;break};case 33:{if((d[l+128|0]|0)==0){break c}if((c[o+132>>2]|0)==0){break c}h=0;break};case 39:{if((c[o+128>>2]|0)==0){break c}h=0;break};default:{}}}while(0);do{if((r|0)==45){r=0;if((He[c[b+56>>2]&63](b,e,c[n>>2]|0,p)|0)!=0){r=47}else{r=46;break a}}else if((r|0)==102){r=0;if((d[l+128|0]|0)==0){break}if((c[o+132>>2]|0)==0){break}h=0}else if((r|0)==168){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}s=dxc(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;c[(c[o+316>>2]|0)+16>>2]=s;if((c[(c[o+316>>2]|0)+16>>2]|0)==0){r=171;break a}c[(c[o+316>>2]|0)+20>>2]=c[o+360>>2];c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}else if((r|0)==319){r=0;if((a[l+160|0]|0)==0){break}s=c[n>>2]|0;if((G|0)==0){H=s}else{H=s+(0-(c[b+68>>2]|0))|0}s=pxc(o)|0;if((s|0)<0){r=323;break a}c[(c[l+164>>2]|0)+(s*28|0)>>2]=4;c[(c[l+164>>2]|0)+(s*28|0)+4>>2]=G;z=gxc(o,b,e,H)|0;if((z|0)==0){r=325;break a}E=c[z>>2]|0;c[(c[l+164>>2]|0)+(s*28|0)+8>>2]=E;s=0;do{z=s;s=z+1|0;}while((a[E+z|0]|0)!=0);E=l+168|0;c[E>>2]=(c[E>>2]|0)+s;if((c[o+128>>2]|0)==0){break}h=0}else if((r|0)==334){r=0;if((a[l+160|0]|0)==0){break}if((c[o+128>>2]|0)!=0){h=0}E=l+180|0;c[E>>2]=(c[E>>2]|0)+ -1;c[(c[l+164>>2]|0)+((c[(c[l+184>>2]|0)+(c[l+180>>2]<<2)>>2]|0)*28|0)+4>>2]=G;if((c[l+180>>2]|0)!=0){break}if(!(h<<24>>24!=0)){E=rxc(o)|0;if((E|0)==0){r=340;break a}c[q>>2]=e;Ee[c[o+128>>2]&15](c[o+4>>2]|0,c[c[o+344>>2]>>2]|0,E)}a[l+160|0]=0;c[l+168>>2]=0}}while(0);do{if((r|0)==47){r=0;if((d[l+128|0]|0)==0){break}if((c[o+316>>2]|0)==0){break}E=dxc(l+80|0,b,e+(c[b+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((E|0)==0){r=50;break a}exc(E);c[(c[o+316>>2]|0)+24>>2]=E;c[l+96>>2]=c[l+92>>2];if((c[o+136>>2]|0)==0){break}h=0}}while(0);do{if((h&255|0)!=0){if((c[o+80>>2]|0)==0){break}Rwc(o,b,e,c[n>>2]|0)}}while(0);h=c[o+480>>2]|0;if((h|0)==3){r=367;break}else if((h|0)==2){r=368;break}e=c[n>>2]|0;g=He[c[b>>2]&63](b,e,f,n)|0}if((r|0)==7){c[j>>2]=e;I=0;J=I;i=m;return J|0}else if((r|0)==9){c[p>>2]=c[n>>2];I=4;J=I;i=m;return J|0}else if((r|0)==10){I=5;J=I;i=m;return J|0}else if((r|0)==11){I=6;J=I;i=m;return J|0}else if((r|0)==13){do{if((b|0)!=(c[o+144>>2]|0)){if((a[(c[o+300>>2]|0)+20|0]|0)!=0){break}c[j>>2]=e;I=0;J=I;i=m;return J|0}}while(0);do{if((d[o+488|0]|0)==0){if((b|0)!=(c[o+144>>2]|0)){break}I=3;J=I;i=m;return J|0}}while(0);if((ye[c[o+256>>2]&63](o+256|0,-4,f,f,b)|0)==-1){I=29;J=I;i=m;return J|0}else{c[j>>2]=e;I=0;J=I;i=m;return J|0}}else if((r|0)==25){I=t;J=I;i=m;return J|0}else if((r|0)==29){I=1;J=I;i=m;return J|0}else if((r|0)==35){I=v;J=I;i=m;return J|0}else if((r|0)==38){I=1;J=I;i=m;return J|0}else if((r|0)==41){I=32;J=I;i=m;return J|0}else if((r|0)==43){I=1;J=I;i=m;return J|0}else if((r|0)==46){I=32;J=I;i=m;return J|0}else if((r|0)==50){I=1;J=I;i=m;return J|0}else if((r|0)==60){I=1;J=I;i=m;return J|0}else if((r|0)==64){I=21;J=I;i=m;return J|0}else if((r|0)==69){I=22;J=I;i=m;return J|0}else if((r|0)==75){do{if((a[o+489|0]|0)!=0){v=a[l+129|0]|0;a[l+129|0]=1;if((c[o+492>>2]|0)==0){break}if((c[o+112>>2]|0)==0){break}t=Wwc(o,l+132|0,283256,36)|0;if((t|0)==0){I=1;J=I;i=m;return J|0}c[t+20>>2]=c[o+360>>2];a[l+131|0]=0;if((ye[c[o+112>>2]&63](c[o+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)==0){I=21;J=I;i=m;return J|0}if((a[l+131|0]|0)==0){a[l+129|0]=v;break}if((a[l+130|0]|0)!=0){break}if((c[o+108>>2]|0)==0){break}if((ie[c[o+108>>2]&127](c[o+4>>2]|0)|0)!=0){break}I=22;J=I;i=m;return J|0}}while(0);c[o+280>>2]=38;I=fxc(o,e,f,j)|0;J=I;i=m;return J|0}else if((r|0)==90){I=1;J=I;i=m;return J|0}else if((r|0)==92){I=1;J=I;i=m;return J|0}else if((r|0)==111){I=1;J=I;i=m;return J|0}else if((r|0)==113){I=1;J=I;i=m;return J|0}else if((r|0)==117){I=1;J=I;i=m;return J|0}else if((r|0)==128){I=1;J=I;i=m;return J|0}else if((r|0)==132){I=y;J=I;i=m;return J|0}else if((r|0)==134){I=1;J=I;i=m;return J|0}else if((r|0)==145){I=1;J=I;i=m;return J|0}else if((r|0)==153){I=A;J=I;i=m;return J|0}else if((r|0)==156){I=1;J=I;i=m;return J|0}else if((r|0)==163){I=22;J=I;i=m;return J|0}else if((r|0)==166){I=1;J=I;i=m;return J|0}else if((r|0)==171){I=1;J=I;i=m;return J|0}else if((r|0)==181){I=1;J=I;i=m;return J|0}else if((r|0)==190){I=1;J=I;i=m;return J|0}else if((r|0)==192){I=1;J=I;i=m;return J|0}else if((r|0)==202){I=1;J=I;i=m;return J|0}else if((r|0)==204){I=1;J=I;i=m;return J|0}else if((r|0)==214){I=1;J=I;i=m;return J|0}else if((r|0)==217){I=32;J=I;i=m;return J|0}else if((r|0)==220){I=1;J=I;i=m;return J|0}else if((r|0)==225){I=1;J=I;i=m;return J|0}else if((r|0)==232){A=g;if((A|0)==28){I=10;J=I;i=m;return J|0}else if((A|0)==12){I=17;J=I;i=m;return J|0}else{I=2;J=I;i=m;return J|0}}else if((r|0)==239){I=D;J=I;i=m;return J|0}else if((r|0)==241){c[o+280>>2]=39;I=D;J=I;i=m;return J|0}else if((r|0)==245){I=1;J=I;i=m;return J|0}else if((r|0)==248){I=1;J=I;i=m;return J|0}else if((r|0)==251){I=1;J=I;i=m;return J|0}else if((r|0)==254){I=1;J=I;i=m;return J|0}else if((r|0)==258){I=2;J=I;i=m;return J|0}else if((r|0)==263){I=2;J=I;i=m;return J|0}else if((r|0)==273){I=1;J=I;i=m;return J|0}else if((r|0)==279){I=11;J=I;i=m;return J|0}else if((r|0)==281){I=24;J=I;i=m;return J|0}else if((r|0)==287){I=12;J=I;i=m;return J|0}else if((r|0)==290){I=F;J=I;i=m;return J|0}else if((r|0)==294){I=21;J=I;i=m;return J|0}else if((r|0)==301){I=22;J=I;i=m;return J|0}else if((r|0)==304){I=1;J=I;i=m;return J|0}else if((r|0)==309){I=1;J=I;i=m;return J|0}else if((r|0)==323){I=1;J=I;i=m;return J|0}else if((r|0)==325){I=1;J=I;i=m;return J|0}else if((r|0)==340){I=1;J=I;i=m;return J|0}else if((r|0)==344){I=1;J=I;i=m;return J|0}else if((r|0)==347){I=1;J=I;i=m;return J|0}else if((r|0)==367){c[j>>2]=c[n>>2];I=0;J=I;i=m;return J|0}else if((r|0)==368){I=35;J=I;i=m;return J|0}return 0}function cxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0;g=i;i=i+104|0;h=g+40|0;j=g+56|0;k=g+64|0;l=g+72|0;m=g+88|0;n=b;b=d;d=e;e=f;c[h>>2]=0;f=0;c[j>>2]=0;c[k>>2]=0;o=0;c[m>>2]=-1;p=(b|0)!=0;if((he[((a[n+236|0]&255|0)!=0?1:2)&7](b,c[n+144>>2]|0,d,e,n+288|0,k,l,h,j,m)|0)==0){if(p){q=31;r=q;i=g;return r|0}else{q=30;r=q;i=g;return r|0}}do{if(!p){if((c[m>>2]|0)!=1){break}a[(c[n+356>>2]|0)+130|0]=1;if((c[n+492>>2]|0)!=1){break}c[n+492>>2]=0}}while(0);do{if((c[n+140>>2]|0)!=0){do{if((c[h>>2]|0)!=0){p=c[n+144>>2]|0;b=c[h>>2]|0;s=c[h>>2]|0;f=dxc(n+440|0,p,b,s+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){c[n+456>>2]=c[n+452>>2];break}q=1;r=q;i=g;return r|0}}while(0);do{if((c[k>>2]|0)!=0){o=dxc(n+440|0,c[n+144>>2]|0,c[k>>2]|0,(c[l>>2]|0)+(0-(c[(c[n+144>>2]|0)+68>>2]|0))|0)|0;if((o|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);Ie[c[n+140>>2]&63](c[n+4>>2]|0,o,f,c[m>>2]|0)}else{if((c[n+80>>2]|0)==0){break}Rwc(n,c[n+144>>2]|0,d,e)}}while(0);do{if((c[n+232>>2]|0)==0){if((c[j>>2]|0)!=0){if((c[(c[j>>2]|0)+68>>2]|0)==(c[(c[n+144>>2]|0)+68>>2]|0)){c[n+144>>2]=c[j>>2];break}c[n+288>>2]=c[h>>2];q=19;r=q;i=g;return r|0}if((c[h>>2]|0)==0){break}do{if((f|0)==0){e=c[n+144>>2]|0;d=c[h>>2]|0;m=c[h>>2]|0;f=dxc(n+440|0,e,d,m+(xe[c[(c[n+144>>2]|0)+32>>2]&63](c[n+144>>2]|0,c[h>>2]|0)|0)|0)|0;if((f|0)!=0){break}q=1;r=q;i=g;return r|0}}while(0);m=Hxc(n,f)|0;Awc(n+440|0);if((m|0)==18){c[n+288>>2]=c[h>>2]}q=m;r=q;i=g;return r|0}}while(0);if((f|0)!=0){t=34}else{if((o|0)!=0){t=34}}if((t|0)==34){Awc(n+440|0)}q=0;r=q;i=g;return r|0}function dxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+40|0;h=b;if((jxc(h,d,e,f)|0)==0){j=0;k=j;i=g;return k|0}do{if((c[h+12>>2]|0)==(c[h+8>>2]|0)){if((Twc(h)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);f=h+12|0;e=c[f>>2]|0;c[f>>2]=e+1;a[e]=0;j=c[h+16>>2]|0;k=j;i=g;return k|0}function exc(b){b=b|0;var c=0,d=0,e=0,f=0,g=0,h=0;c=i;i=i+24|0;d=b;b=d;e=d;while(1){if((a[e]|0)==0){break}f=a[e]|0;do{if((f|0)==10|(f|0)==13|(f|0)==32){if((b|0)==(d|0)){break}if((a[b+ -1|0]|0)==32){break}g=b;b=g+1|0;a[g]=32}else{g=b;b=g+1|0;a[g]=a[e]|0}}while(0);e=e+1|0}if((b|0)==(d|0)){h=b;a[h]=0;i=c;return}if((a[b+ -1|0]|0)!=32){h=b;a[h]=0;i=c;return}b=b+ -1|0;h=b;a[h]=0;i=c;return}function fxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0;g=i;i=i+48|0;h=b;b=wxc(h,0,c[h+144>>2]|0,d,e,f,((a[h+484|0]|0)!=0^1)&1)|0;do{if((b|0)==0){if((Exc(h)|0)<<24>>24!=0){break}j=1;k=j;i=g;return k|0}}while(0);j=b;k=j;i=g;return k|0}function gxc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=c[g+356>>2]|0;h=dxc(a+80|0,b,d,e)|0;if((h|0)==0){j=0;k=j;i=f;return k|0}e=Wwc(g,a+20|0,h,24)|0;if((e|0)==0){j=0;k=j;i=f;return k|0}d=a+80|0;do{if((c[e>>2]|0)!=(h|0)){c[a+92>>2]=c[d+16>>2]}else{c[a+96>>2]=c[d+12>>2];if((Fxc(g,e)|0)!=0){break}j=0;k=j;i=f;return k|0}}while(0);j=e;k=j;i=f;return k|0}function hxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+80|0;h=b;b=d;d=e;e=f;f=c[h+356>>2]|0;do{if((c[f+92>>2]|0)==(c[f+88>>2]|0)){if((Twc(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;m=c[l>>2]|0;c[l>>2]=m+1;a[m]=0;m=dxc(f+80|0,b,d,e)|0;if((m|0)==0){j=0;k=j;i=g;return k|0}m=m+1|0;e=Wwc(h,f+40|0,m,12)|0;if((e|0)==0){j=0;k=j;i=g;return k|0}d=f+80|0;a:do{if((c[e>>2]|0)!=(m|0)){c[f+92>>2]=c[d+16>>2]}else{c[f+96>>2]=c[d+12>>2];if((a[h+236|0]|0)==0){break}do{if((a[m]|0)==120){if((a[m+1|0]|0)!=109){break}if((a[m+2|0]|0)!=108){break}if((a[m+3|0]|0)!=110){break}if((a[m+4|0]|0)!=115){break}if((a[m+5|0]|0)!=0){if((a[m+5|0]|0)!=58){break}}if((a[m+5|0]|0)==0){c[e+4>>2]=f+152}else{c[e+4>>2]=Wwc(h,f+60|0,m+6|0,8)|0}a[e+9|0]=1;break a}}while(0);b=0;while(1){if((a[m+b|0]|0)==0){break a}if((a[m+b|0]|0)==58){break}b=b+1|0}l=0;while(1){n=(c[f+92>>2]|0)==(c[f+88>>2]|0);if((l|0)>=(b|0)){break}if(n){if(!((Twc(f+80|0)|0)<<24>>24!=0)){o=30;break}}p=a[m+l|0]|0;q=f+92|0;r=c[q>>2]|0;c[q>>2]=r+1;a[r]=p;l=l+1|0}if((o|0)==30){j=0;k=j;i=g;return k|0}do{if(n){if((Twc(f+80|0)|0)<<24>>24!=0){break}j=0;k=j;i=g;return k|0}}while(0);l=f+92|0;b=c[l>>2]|0;c[l>>2]=b+1;a[b]=0;c[e+4>>2]=Wwc(h,f+60|0,c[f+96>>2]|0,8)|0;b=f+80|0;if((c[c[e+4>>2]>>2]|0)==(c[f+96>>2]|0)){c[f+96>>2]=c[b+12>>2];break}else{c[f+92>>2]=c[b+16>>2];break}}}while(0);j=e;k=j;i=g;return k|0}function ixc(b,d){b=b|0;d=d|0;var e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0;e=i;i=i+24|0;f=b;b=d;while(1){g=f;if((a[b]|0)==0){h=7;break}if((c[g+12>>2]|0)==(c[f+8>>2]|0)){if(!((Twc(f)|0)<<24>>24!=0)){h=6;break}}d=a[b]|0;j=f+12|0;k=c[j>>2]|0;c[j>>2]=k+1;a[k]=d;b=b+1|0}if((h|0)==6){l=0;m=l;i=e;return m|0}else if((h|0)==7){l=c[g+16>>2]|0;m=l;i=e;return m|0}return 0}function jxc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0;f=i;i=i+40|0;g=f+24|0;h=a;a=b;c[g>>2]=d;d=e;do{if((c[h+12>>2]|0)==0){if((Twc(h)|0)<<24>>24!=0){break}j=0;k=j;i=f;return k|0}}while(0);while(1){ce[c[a+60>>2]&31](a,g,d,h+12|0,c[h+8>>2]|0);l=h;if((c[g>>2]|0)==(d|0)){m=7;break}if(!((Twc(l)|0)<<24>>24!=0)){m=6;break}}if((m|0)==6){j=0;k=j;i=f;return k|0}else if((m|0)==7){j=c[l+16>>2]|0;k=j;i=f;return k|0}return 0}function kxc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0;j=i;i=i+88|0;k=b;b=d;d=e;e=f;f=g;g=h;if((f|0)!=0){l=3}else{if((e&255|0)!=0){l=3}}do{if((l|0)==3){h=0;while(1){if((h|0)>=(c[k+12>>2]|0)){break}if((b|0)==(c[(c[k+20>>2]|0)+(h*12|0)>>2]|0)){l=6;break}h=h+1|0}if((l|0)==6){m=1;n=m;i=j;return n|0}if((e&255|0)==0){break}if((c[k+8>>2]|0)!=0){break}if((a[b+9|0]|0)!=0){break}c[k+8>>2]=b}}while(0);do{if((c[k+12>>2]|0)==(c[k+16>>2]|0)){e=k+16|0;if((c[k+16>>2]|0)==0){c[e>>2]=8;c[k+20>>2]=ie[c[g+12>>2]&127]((c[k+16>>2]|0)*12|0)|0;if((c[k+20>>2]|0)!=0){break}m=0;n=m;i=j;return n|0}l=c[e>>2]<<1;e=xe[c[g+16>>2]&63](c[k+20>>2]|0,l*12|0)|0;if((e|0)!=0){c[k+16>>2]=l;c[k+20>>2]=e;break}m=0;n=m;i=j;return n|0}}while(0);g=(c[k+20>>2]|0)+((c[k+12>>2]|0)*12|0)|0;c[g>>2]=b;c[g+8>>2]=f;a[g+4|0]=d;if(!(d<<24>>24!=0)){a[b+8|0]=1}b=k+12|0;c[b>>2]=(c[b>>2]|0)+1;m=1;n=m;i=j;return n|0}function lxc(b,d,e,f,g,h){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0;j=i;i=i+64|0;k=e;e=h;h=Gxc(b,d,k,f,g,e)|0;if((h|0)!=0){l=h;m=l;i=j;return m|0}do{if(!(k<<24>>24!=0)){if(((c[e+12>>2]|0)-(c[e+16>>2]|0)|0)==0){break}if((a[(c[e+12>>2]|0)+ -1|0]|0)!=32){break}h=e+12|0;c[h>>2]=(c[h>>2]|0)+ -1}}while(0);do{if((c[e+12>>2]|0)==(c[e+8>>2]|0)){if((Twc(e)|0)<<24>>24!=0){break}l=1;m=l;i=j;return m|0}}while(0);k=e+12|0;e=c[k>>2]|0;c[k>>2]=e+1;a[e]=0;l=0;m=l;i=j;return m|0}function mxc(b,e,f,g){b=b|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0;h=i;i=i+128|0;j=h+72|0;k=h+104|0;l=b;b=e;e=f;f=g;g=c[l+356>>2]|0;m=g+104|0;n=0;o=c[l+276>>2]|0;c[l+276>>2]=1;do{if((c[m>>2]|0)==0){if((Twc(m)|0)<<24>>24!=0){break}p=1;q=p;i=h;return q|0}}while(0);a:while(1){b:do{switch(He[c[b+20>>2]&63](b,e,f,j)|0){case 28:{if((d[l+488|0]|0)==0){if((b|0)==(c[l+144>>2]|0)){r=23;break a}}s=dxc(l+416|0,b,e+(c[b+68>>2]|0)|0,(c[j>>2]|0)+(0-(c[b+68>>2]|0))|0)|0;if((s|0)==0){r=8;break a}t=Wwc(l,g+132|0,s,0)|0;c[l+428>>2]=c[l+432>>2];if((t|0)==0){r=10;break a}if((a[t+32|0]|0)!=0){r=12;break a}if((c[t+16>>2]|0)==0){a[t+32|0]=1;n=mxc(l,c[l+228>>2]|0,c[t+4>>2]|0,(c[t+4>>2]|0)+(c[t+8>>2]|0)|0)|0;a[t+32|0]=0;if((n|0)!=0){break a}else{break b}}s=g;if((c[l+112>>2]|0)==0){a[g+128|0]=a[s+130|0]|0;break b}a[s+131|0]=0;a[t+32|0]=1;s=(ye[c[l+112>>2]&63](c[l+116>>2]|0,0,c[t+20>>2]|0,c[t+16>>2]|0,c[t+24>>2]|0)|0)!=0;a[t+32|0]=0;if(!s){r=18;break a}if((a[g+131|0]|0)!=0){break b}a[g+128|0]=a[g+130|0]|0;break};case 6:case 9:{if((jxc(m,b,e,c[j>>2]|0)|0)==0){r=26;break a}break};case-1:{r=46;break a;break};case-4:{r=24;break a;break};case 7:{r=28;break};case-3:{c[j>>2]=e+(c[b+68>>2]|0);r=28;break};case 0:{r=49;break a;break};case 10:{s=xe[c[b+44>>2]&63](b,e)|0;if((s|0)<0){r=33;break a}s=Nxc(s,k)|0;if((s|0)==0){r=37;break a}t=0;while(1){if((t|0)>=(s|0)){break b}if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Twc(m)|0)<<24>>24!=0)){r=44;break a}}u=a[k+t|0]|0;v=m+12|0;w=c[v>>2]|0;c[v>>2]=w+1;a[w]=u;t=t+1|0}break};default:{r=52;break a}}}while(0);if((r|0)==28){r=0;if((c[m+8>>2]|0)==(c[m+12>>2]|0)){if(!((Twc(m)|0)<<24>>24!=0)){r=30;break}}t=m+12|0;s=c[t>>2]|0;c[t>>2]=s+1;a[s]=10}e=c[j>>2]|0}if((r|0)==8){n=1}else if((r|0)==10){a[g+128|0]=a[g+130|0]|0}else if((r|0)==12){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=12}else if((r|0)==18){n=21}else if((r|0)==23){c[l+288>>2]=e;n=10}else if((r|0)==24){n=0}else if((r|0)==26){n=1}else if((r|0)==30){n=1}else if((r|0)==33){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==37){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=14}else if((r|0)==44){n=1}else if((r|0)==46){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=4}else if((r|0)==49){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=c[j>>2]}n=4}else if((r|0)==52){if((b|0)==(c[l+144>>2]|0)){c[l+288>>2]=e}n=23}c[l+276>>2]=o;p=n;q=p;i=h;return q|0}function nxc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;h=i;i=i+96|0;j=h+56|0;k=a;a=b;b=d;d=f;f=g;g=c[b>>2]|0;l=k;if((a|0)==(c[k+144>>2]|0)){m=l+288|0;c[m>>2]=g;n=k+292|0}else{m=c[l+300>>2]|0;n=(c[k+300>>2]|0)+4|0}c[m>>2]=g;c[b>>2]=0;l=He[c[a+12>>2]&63](a,g,e,j)|0;c[n>>2]=c[j>>2];switch(l|0){case-4:case-1:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=2;p=o;i=h;return p|0}break};case 0:{c[m>>2]=c[j>>2];o=4;p=o;i=h;return p|0};case-2:{if(f<<24>>24!=0){c[d>>2]=g;o=0;p=o;i=h;return p|0}else{o=6;p=o;i=h;return p|0}break};case 42:{if((c[k+80>>2]|0)!=0){Rwc(k,a,g,c[j>>2]|0)}c[b>>2]=c[j>>2];c[d>>2]=c[j>>2];if((c[k+480>>2]|0)==2){o=35;p=o;i=h;return p|0}else{o=0;p=o;i=h;return p|0}break};default:{c[m>>2]=c[j>>2];o=23;p=o;i=h;return p|0}}return 0}function oxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0;g=i;i=i+48|0;h=g+16|0;j=b;c[h>>2]=d;d=e;e=f;f=nxc(j,c[j+144>>2]|0,h,d,e,((a[j+484|0]|0)!=0^1)&1)|0;if((f|0)!=0){k=f;l=k;i=g;return l|0}if((c[h>>2]|0)!=0){c[j+280>>2]=40;k=axc(j,c[h>>2]|0,d,e)|0;l=k;i=g;return l|0}else{k=f;l=k;i=g;return l|0}return 0}function pxc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0;b=i;i=i+56|0;d=a;a=c[d+356>>2]|0;do{if((c[a+184>>2]|0)==0){c[a+184>>2]=ie[c[d+12>>2]&127](c[d+468>>2]<<2)|0;if((c[a+184>>2]|0)!=0){c[c[a+184>>2]>>2]=0;break}e=-1;f=e;i=b;return f|0}}while(0);if((c[a+176>>2]|0)>>>0>=(c[a+172>>2]|0)>>>0){g=d+12|0;do{if((c[a+164>>2]|0)!=0){h=xe[c[g+4>>2]&63](c[a+164>>2]|0,(c[a+172>>2]<<1)*28|0)|0;if((h|0)!=0){d=a+172|0;c[d>>2]=c[d>>2]<<1;break}e=-1;f=e;i=b;return f|0}else{h=ie[c[g>>2]&127](896)|0;if((h|0)!=0){c[a+172>>2]=32;break}e=-1;f=e;i=b;return f|0}}while(0);c[a+164>>2]=h}h=a+176|0;g=c[h>>2]|0;c[h>>2]=g+1;h=g;g=(c[a+164>>2]|0)+(h*28|0)|0;if((c[a+180>>2]|0)!=0){d=(c[a+164>>2]|0)+((c[(c[a+184>>2]|0)+((c[a+180>>2]|0)-1<<2)>>2]|0)*28|0)|0;if((c[d+16>>2]|0)!=0){c[(c[a+164>>2]|0)+((c[d+16>>2]|0)*28|0)+24>>2]=h}if((c[d+20>>2]|0)==0){c[d+12>>2]=h}c[d+16>>2]=h;a=d+20|0;c[a>>2]=(c[a>>2]|0)+1}c[g+24>>2]=0;c[g+20>>2]=0;c[g+16>>2]=0;c[g+12>>2]=0;e=h;f=e;i=b;return f|0}function qxc(b,d,e){b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;i=i+80|0;g=f+48|0;h=b;b=d;d=e;e=h;do{if((c[h+304>>2]|0)!=0){j=c[e+304>>2]|0;c[h+304>>2]=c[j+8>>2]}else{j=ie[c[e+12>>2]&127](24)|0;if((j|0)!=0){break}k=1;l=k;i=f;return l|0}}while(0);a[b+32|0]=1;c[b+12>>2]=0;c[j+8>>2]=c[h+300>>2];c[h+300>>2]=j;c[j+12>>2]=b;c[j+16>>2]=c[h+312>>2];a[j+20|0]=d;c[j>>2]=0;c[j+4>>2]=0;d=c[b+4>>2]|0;e=(c[b+4>>2]|0)+(c[b+8>>2]|0)|0;m=h;if((a[b+33|0]|0)!=0){n=He[c[c[m+228>>2]>>2]&63](c[h+228>>2]|0,d,e,g)|0;o=bxc(h,c[h+228>>2]|0,d,e,n,c[g>>2]|0,g,0)|0}else{o=wxc(m,c[h+312>>2]|0,c[h+228>>2]|0,d,e,g,0)|0}a:do{if((o|0)==0){do{if((e|0)!=(c[g>>2]|0)){if((c[h+480>>2]|0)!=3){break}c[b+12>>2]=(c[g>>2]|0)-d;c[h+280>>2]=41;break a}}while(0);a[b+32|0]=0;c[h+300>>2]=c[j+8>>2];c[j+8>>2]=c[h+304>>2];c[h+304>>2]=j}}while(0);k=o;l=k;i=f;return l|0}function rxc(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,h=0,j=0;b=i;i=i+56|0;d=b+32|0;e=b+40|0;f=a;a=c[f+356>>2]|0;g=ie[c[f+12>>2]&127](((c[a+176>>2]|0)*20|0)+(c[a+168>>2]|0)|0)|0;if((g|0)!=0){c[e>>2]=g+((c[a+176>>2]|0)*20|0);c[d>>2]=g+20;vxc(f,0,g,d,e);h=g;j=h;i=b;return j|0}else{h=0;j=h;i=b;return j|0}return 0}function sxc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+64|0;g=a;a=b;b=d;d=e;if((c[g+64>>2]|0)==0){if((c[g+80>>2]|0)!=0){Rwc(g,a,b,d)}h=1;j=h;i=f;return j|0}b=b+(c[a+68>>2]<<1)|0;e=b+(xe[c[a+32>>2]&63](a,b)|0)|0;k=dxc(g+416|0,a,b,e)|0;if((k|0)==0){h=0;j=h;i=f;return j|0}c[g+432>>2]=c[g+428>>2];b=xe[c[a+36>>2]&63](a,e)|0;e=dxc(g+416|0,a,b,d+(0-(c[a+68>>2]<<1))|0)|0;if((e|0)!=0){uxc(e);Ee[c[g+64>>2]&15](c[g+4>>2]|0,k,e);Awc(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function txc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,h=0,j=0,k=0;f=i;i=i+48|0;g=a;a=b;b=d;d=e;e=g;if((c[g+68>>2]|0)==0){if((c[e+80>>2]|0)!=0){Rwc(g,a,b,d)}h=1;j=h;i=f;return j|0}k=dxc(e+416|0,a,b+(c[a+68>>2]<<2)|0,d+(0-((c[a+68>>2]|0)*3|0))|0)|0;if((k|0)!=0){uxc(k);ge[c[g+68>>2]&255](c[g+4>>2]|0,k);Awc(g+416|0);h=1;j=h;i=f;return j|0}else{h=0;j=h;i=f;return j|0}return 0}function uxc(b){b=b|0;var c=0,d=0,e=0,f=0;c=i;i=i+16|0;d=b;while(1){if((a[d]|0)==0){e=12;break}f=d;if((a[d]|0)==13){break}d=f+1|0}if((e|0)==12){i=c;return}e=f;do{do{if((a[d]|0)==13){f=e;e=f+1|0;a[f]=10;f=d+1|0;d=f;if((a[f]|0)!=10){break}d=d+1|0}else{f=d;d=f+1|0;b=e;e=b+1|0;a[b]=a[f]|0}}while(0);}while((a[d]|0)!=0);a[e]=0;i=c;return}function vxc(b,d,e,f,g){b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0;h=i;i=i+72|0;j=b;b=d;d=e;e=f;f=g;g=c[j+356>>2]|0;c[d>>2]=c[(c[g+164>>2]|0)+(b*28|0)>>2];c[d+4>>2]=c[(c[g+164>>2]|0)+(b*28|0)+4>>2];if((c[d>>2]|0)==4){c[d+8>>2]=c[f>>2];k=c[(c[g+164>>2]|0)+(b*28|0)+8>>2]|0;while(1){l=a[k]|0;m=f;n=c[m>>2]|0;c[m>>2]=n+1;a[n]=l;if((a[k]|0)==0){break}k=k+1|0}c[d+12>>2]=0;c[d+16>>2]=0;i=h;return}else{c[d+12>>2]=c[(c[g+164>>2]|0)+(b*28|0)+20>>2];c[d+16>>2]=c[e>>2];k=e;c[k>>2]=(c[k>>2]|0)+((c[d+12>>2]|0)*20|0);k=0;l=c[(c[g+164>>2]|0)+(b*28|0)+12>>2]|0;while(1){if(!(k>>>0<(c[d+12>>2]|0)>>>0)){break}vxc(j,l,(c[d+16>>2]|0)+(k*20|0)|0,e,f);k=k+1|0;l=c[(c[g+164>>2]|0)+(l*28|0)+24>>2]|0}c[d+8>>2]=0;i=h;return}}function wxc(b,e,f,g,h,j,k){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0;l=i;i=i+392|0;m=l+32|0;n=l+88|0;o=l+104|0;p=l+128|0;q=l+168|0;r=l+184|0;s=l+232|0;t=l+248|0;u=l+344|0;v=l+352|0;w=l+368|0;x=l+384|0;y=b;b=e;e=f;c[m>>2]=g;g=h;h=j;j=k;k=c[y+356>>2]|0;f=y;if((e|0)==(c[y+144>>2]|0)){z=f+288|0;A=y+292|0}else{z=c[f+300>>2]|0;A=(c[y+300>>2]|0)+4|0}c[z>>2]=c[m>>2];a:while(1){c[n>>2]=c[m>>2];f=He[c[e+4>>2]&63](e,c[m>>2]|0,g,n)|0;c[A>>2]=c[n>>2];b:do{switch(f|0){case 3:case 4:{B=(c[m>>2]|0)+(c[e+68>>2]|0)|0;c[s>>2]=0;C=1;c[t>>2]=dxc(y+416|0,e,B,B+(xe[c[e+32>>2]&63](e,B)|0)|0)|0;if((c[t>>2]|0)==0){D=89;break a}c[y+432>>2]=c[y+428>>2];E=zxc(y,e,c[m>>2]|0,t,s)|0;if((E|0)!=0){D=91;break a}c[y+432>>2]=c[y+428>>2];if((c[y+52>>2]|0)!=0){Ee[c[y+52>>2]&15](c[y+4>>2]|0,c[t>>2]|0,c[y+392>>2]|0);C=0}if((c[y+56>>2]|0)!=0){if((c[y+52>>2]|0)!=0){c[z>>2]=c[A>>2]}ge[c[y+56>>2]&255](c[y+4>>2]|0,c[t>>2]|0);C=0}do{if((C&255|0)!=0){if((c[y+80>>2]|0)==0){break}Rwc(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Awc(y+416|0);while(1){if((c[s>>2]|0)==0){break}C=c[s>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&255](c[y+4>>2]|0,c[c[C>>2]>>2]|0)}c[s>>2]=c[(c[s>>2]|0)+4>>2];c[C+4>>2]=c[y+376>>2];c[y+376>>2]=C;c[(c[C>>2]|0)+4>>2]=c[C+8>>2]}if((c[y+312>>2]|0)==0){D=107;break a}break};case 11:{if((sxc(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=174;break a}break};case 13:{if((txc(y,e,c[m>>2]|0,c[n>>2]|0)|0)==0){D=176;break a}break};case 5:{if((c[y+312>>2]|0)==(b|0)){D=109;break a}C=c[y+364>>2]|0;c[y+364>>2]=c[C>>2];c[C>>2]=c[y+368>>2];c[y+368>>2]=C;F=(c[m>>2]|0)+(c[e+68>>2]<<1)|0;B=xe[c[e+32>>2]&63](e,F)|0;if((B|0)!=(c[C+8>>2]|0)){D=112;break a}if((G4c(c[C+4>>2]|0,F,B)|0)!=0){D=112;break a}B=y+312|0;c[B>>2]=(c[B>>2]|0)+ -1;do{if((c[y+56>>2]|0)!=0){B=c[C+16>>2]|0;do{if((d[y+236|0]|0)!=0){if((B|0)==0){break}G=(c[C+12>>2]|0)+(c[C+28>>2]|0)|0;while(1){if((a[B]|0)==0){break}H=B;B=H+1|0;I=G;G=I+1|0;a[I]=a[H]|0}H=c[C+20>>2]|0;c:do{if((d[y+237|0]|0)!=0){if((H|0)==0){break}I=G;G=I+1|0;a[I]=a[y+472|0]|0;while(1){if((a[H]|0)==0){break c}I=H;H=I+1|0;J=G;G=J+1|0;a[J]=a[I]|0}}}while(0);a[G]=0}}while(0);ge[c[y+56>>2]&255](c[y+4>>2]|0,c[C+12>>2]|0)}else{if((c[y+80>>2]|0)==0){break}Rwc(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);while(1){if((c[C+44>>2]|0)==0){break}B=c[C+44>>2]|0;if((c[y+104>>2]|0)!=0){ge[c[y+104>>2]&255](c[y+4>>2]|0,c[c[B>>2]>>2]|0)}c[C+44>>2]=c[(c[C+44>>2]|0)+4>>2];c[B+4>>2]=c[y+376>>2];c[y+376>>2]=B;c[(c[B>>2]|0)+4>>2]=c[B+8>>2]}if((c[y+312>>2]|0)==0){D=133;break a}break};case 12:{D=140;break a;break};case 7:{if((c[y+60>>2]|0)!=0){a[v]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,v,1);break b}if((c[y+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break};case 10:{C=xe[c[e+44>>2]&63](e,c[m>>2]|0)|0;if((C|0)<0){D=135;break a}B=y;if((c[y+60>>2]|0)!=0){H=c[B+60>>2]|0;I=c[y+4>>2]|0;J=Nxc(C,u)|0;Ee[H&15](I,u,J);break b}if((c[B+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break};case 8:{B=y;do{if((c[y+72>>2]|0)!=0){fe[c[B+72>>2]&1023](c[y+4>>2]|0)}else{if((c[B+80>>2]|0)==0){break}Rwc(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);K=Bxc(y,e,n,g,h,j)|0;if((K|0)!=0){D=150;break a}if((c[n>>2]|0)==0){D=152;break a}break};case-5:{D=153;break a;break};case 6:{B=c[y+60>>2]|0;if((B|0)==0){if((c[y+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break b}if((a[e+72|0]|0)!=0){Ee[B&15](c[y+4>>2]|0,c[m>>2]|0,(c[n>>2]|0)-(c[m>>2]|0)|0);break b}while(1){c[x>>2]=c[y+44>>2];ce[c[e+60>>2]&31](e,m,c[n>>2]|0,x,c[y+48>>2]|0);c[A>>2]=c[m>>2];Ee[B&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[x>>2]|0)-(c[y+44>>2]|0)|0);if((c[m>>2]|0)==(c[n>>2]|0)){break b}c[z>>2]=c[m>>2]}break};case-3:{D=6;break a;break};case-4:{D=17;break a;break};case 0:{D=24;break a;break};case-2:{D=28;break a;break};case-1:{D=25;break a;break};case 9:{a[p]=le[c[e+48>>2]&63](e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((a[p]|0)!=0){B=y;if((c[y+60>>2]|0)!=0){Ee[c[B+60>>2]&15](c[y+4>>2]|0,p,1);break b}if((c[B+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break b}B=dxc(k+80|0,e,(c[m>>2]|0)+(c[e+68>>2]|0)|0,(c[n>>2]|0)+(0-(c[e+68>>2]|0))|0)|0;if((B|0)==0){D=37;break a}J=Wwc(y,k,B,0)|0;c[k+92>>2]=c[k+96>>2];do{if((a[k+129|0]|0)!=0){if((d[k+130|0]|0)!=0){D=40;break}if((J|0)!=0){break}I=y;if((c[y+120>>2]|0)!=0){Ee[c[I+120>>2]&15](c[y+4>>2]|0,B,0);break b}if((c[I+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{D=40}}while(0);if((D|0)==40){D=0;if((J|0)==0){D=41;break a}if((a[J+34|0]|0)==0){D=43;break a}}if((a[J+32|0]|0)!=0){D=50;break a}if((c[J+28>>2]|0)!=0){D=52;break a}B=y;if((c[J+4>>2]|0)!=0){I=y;if((a[B+308|0]|0)!=0){L=qxc(I,J,0)|0;if((L|0)!=0){D=60;break a}else{break b}}H=y;if((c[I+120>>2]|0)!=0){Ee[c[H+120>>2]&15](c[y+4>>2]|0,c[J>>2]|0,0);break b}if((c[H+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break b}else{if((c[B+112>>2]|0)==0){if((c[y+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0);break b}a[J+32|0]=1;B=yxc(y)|0;a[J+32|0]=0;if((B|0)==0){D=63;break a}if((ye[c[y+112>>2]&63](c[y+116>>2]|0,B,c[J+20>>2]|0,c[J+16>>2]|0,c[J+24>>2]|0)|0)==0){D=65;break a}c[y+428>>2]=c[y+432>>2];break b}break};case 1:case 2:{B=y;if((c[y+368>>2]|0)!=0){M=c[B+368>>2]|0;c[y+368>>2]=c[c[y+368>>2]>>2]}else{M=ie[c[B+12>>2]&127](48)|0;if((M|0)==0){D=72;break a}c[M+36>>2]=ie[c[y+12>>2]&127](32)|0;if((c[M+36>>2]|0)==0){D=74;break a}c[M+40>>2]=(c[M+36>>2]|0)+32}c[M+44>>2]=0;c[M>>2]=c[y+364>>2];c[y+364>>2]=M;c[M+16>>2]=0;c[M+20>>2]=0;c[M+4>>2]=(c[m>>2]|0)+(c[e+68>>2]|0);c[M+8>>2]=xe[c[e+32>>2]&63](e,c[M+4>>2]|0)|0;B=y+312|0;c[B>>2]=(c[B>>2]|0)+1;B=(c[M+4>>2]|0)+(c[M+8>>2]|0)|0;c[r>>2]=c[M+4>>2];c[q>>2]=c[M+36>>2];while(1){ce[c[e+60>>2]&31](e,r,B,q,(c[M+40>>2]|0)+ -1|0);N=(c[q>>2]|0)-(c[M+36>>2]|0)|0;if((c[r>>2]|0)==(B|0)){break}H=(c[M+40>>2]|0)-(c[M+36>>2]|0)<<1;I=xe[c[y+16>>2]&63](c[M+36>>2]|0,H)|0;if((I|0)==0){D=80;break a}c[M+36>>2]=I;c[M+40>>2]=I+H;c[q>>2]=I+N}c[M+24>>2]=N;c[M+12>>2]=c[M+36>>2];a[c[q>>2]|0]=0;O=zxc(y,e,c[m>>2]|0,M+12|0,M+44|0)|0;if((O|0)!=0){D=82;break a}B=y;do{if((c[y+52>>2]|0)!=0){Ee[c[B+52>>2]&15](c[y+4>>2]|0,c[M+12>>2]|0,c[y+392>>2]|0)}else{if((c[B+80>>2]|0)==0){break}Rwc(y,e,c[m>>2]|0,c[n>>2]|0)}}while(0);Awc(y+416|0);break};default:{if((c[y+80>>2]|0)==0){break b}Rwc(y,e,c[m>>2]|0,c[n>>2]|0)}}}while(0);f=c[n>>2]|0;c[m>>2]=f;c[z>>2]=f;f=c[y+480>>2]|0;if((f|0)==3){D=180;break}else if((f|0)==2){D=181;break}}if((D|0)==6){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}c[A>>2]=g;do{if((c[y+60>>2]|0)!=0){a[o]=10;Ee[c[y+60>>2]&15](c[y+4>>2]|0,o,1)}else{if((c[y+80>>2]|0)==0){break}Rwc(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=g;P=0;Q=P;i=l;return Q|0}}else if((D|0)==17){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}if((b|0)<=0){P=3;Q=P;i=l;return Q|0}if((c[y+312>>2]|0)!=(b|0)){P=13;Q=P;i=l;return Q|0}else{c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}}else if((D|0)==24){c[z>>2]=c[n>>2];P=4;Q=P;i=l;return Q|0}else if((D|0)==25){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=5;Q=P;i=l;return Q|0}}else if((D|0)==28){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}else{P=6;Q=P;i=l;return Q|0}}else if((D|0)==37){P=1;Q=P;i=l;return Q|0}else if((D|0)==41){P=11;Q=P;i=l;return Q|0}else if((D|0)==43){P=24;Q=P;i=l;return Q|0}else if((D|0)==50){P=12;Q=P;i=l;return Q|0}else if((D|0)==52){P=15;Q=P;i=l;return Q|0}else if((D|0)==60){P=L;Q=P;i=l;return Q|0}else if((D|0)==63){P=1;Q=P;i=l;return Q|0}else if((D|0)==65){P=21;Q=P;i=l;return Q|0}else if((D|0)==72){P=1;Q=P;i=l;return Q|0}else if((D|0)==74){fe[c[y+20>>2]&1023](M);P=1;Q=P;i=l;return Q|0}else if((D|0)==80){P=1;Q=P;i=l;return Q|0}else if((D|0)==82){P=O;Q=P;i=l;return Q|0}else if((D|0)==89){P=1;Q=P;i=l;return Q|0}else if((D|0)==91){P=E;Q=P;i=l;return Q|0}else if((D|0)==107){P=Axc(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((D|0)==109){P=13;Q=P;i=l;return Q|0}else if((D|0)==112){c[z>>2]=F;P=7;Q=P;i=l;return Q|0}else if((D|0)==133){P=Axc(y,c[n>>2]|0,g,h)|0;Q=P;i=l;return Q|0}else if((D|0)==135){P=14;Q=P;i=l;return Q|0}else if((D|0)==140){P=17;Q=P;i=l;return Q|0}else if((D|0)==150){P=K;Q=P;i=l;return Q|0}else if((D|0)==152){c[y+280>>2]=42;P=K;Q=P;i=l;return Q|0}else if((D|0)==153){if(j<<24>>24!=0){c[h>>2]=c[m>>2];P=0;Q=P;i=l;return Q|0}do{if((c[y+60>>2]|0)!=0){j=y;if((a[e+72|0]|0)!=0){Ee[c[j+60>>2]&15](c[y+4>>2]|0,c[m>>2]|0,g-(c[m>>2]|0)|0);break}else{c[w>>2]=c[j+44>>2];ce[c[e+60>>2]&31](e,m,g,w,c[y+48>>2]|0);Ee[c[y+60>>2]&15](c[y+4>>2]|0,c[y+44>>2]|0,(c[w>>2]|0)-(c[y+44>>2]|0)|0);break}}else{if((c[y+80>>2]|0)==0){break}Rwc(y,e,c[m>>2]|0,g)}}while(0);if((b|0)==0){c[z>>2]=g;P=3;Q=P;i=l;return Q|0}m=g;if((c[y+312>>2]|0)!=(b|0)){c[z>>2]=m;P=13;Q=P;i=l;return Q|0}else{c[h>>2]=m;P=0;Q=P;i=l;return Q|0}}else if((D|0)==174){P=1;Q=P;i=l;return Q|0}else if((D|0)==176){P=1;Q=P;i=l;return Q|0}else if((D|0)==180){c[h>>2]=c[n>>2];P=0;Q=P;i=l;return Q|0}else if((D|0)==181){P=35;Q=P;i=l;return Q|0}return 0}function xxc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;g=i;i=i+104|0;h=g+64|0;j=b;b=d;d=e;e=f;f=c[j+300>>2]|0;if((f|0)==0){k=23;l=k;i=g;return l|0}m=c[f+12>>2]|0;n=(c[m+4>>2]|0)+(c[m+12>>2]|0)|0;o=(c[m+4>>2]|0)+(c[m+8>>2]|0)|0;p=j;if((a[m+33|0]|0)!=0){q=He[c[c[p+228>>2]>>2]&63](c[j+228>>2]|0,n,o,h)|0;r=bxc(j,c[j+228>>2]|0,n,o,q,c[h>>2]|0,h,0)|0}else{r=wxc(p,c[f+16>>2]|0,c[j+228>>2]|0,n,o,h,0)|0}if((r|0)!=0){k=r;l=k;i=g;return l|0}do{if((o|0)!=(c[h>>2]|0)){if((c[j+480>>2]|0)!=3){break}c[m+12>>2]=(c[h>>2]|0)-(c[m+4>>2]|0);k=r;l=k;i=g;return l|0}}while(0);a[m+32|0]=0;c[j+300>>2]=c[f+8>>2];c[f+8>>2]=c[j+304>>2];c[j+304>>2]=f;f=j+280|0;if((a[m+33|0]|0)!=0){c[f>>2]=40;m=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;k=bxc(j,c[j+144>>2]|0,b,d,m,c[h>>2]|0,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}else{c[f>>2]=38;k=wxc(j,(c[j+476>>2]|0)!=0?1:0,c[j+144>>2]|0,b,d,e,((a[j+484|0]|0)!=0^1)&1)|0;l=k;i=g;return l|0}return 0}function yxc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0;d=i;i=i+104|0;e=d+24|0;f=b;b=c[f+356>>2]|0;g=0;do{if((c[b+156>>2]|0)!=0){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Twc(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);k=f+428|0;l=c[k>>2]|0;c[k>>2]=l+1;a[l]=61;l=c[(c[b+156>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}k=0;while(1){if((k|0)>=(l|0)){m=13;break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){break}}n=a[(c[(c[b+156>>2]|0)+16>>2]|0)+k|0]|0;o=f+428|0;p=c[o>>2]|0;c[o>>2]=p+1;a[p]=n;k=k+1|0}if((m|0)==13){g=1;break}h=0;j=h;i=d;return j|0}}while(0);Uwc(e,b+60|0);a:while(1){k=Vwc(e)|0;if((k|0)==0){m=40;break}if((c[k+4>>2]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){m=21;break}}l=f+428|0;n=c[l>>2]|0;c[l>>2]=n+1;a[n]=12}n=c[k>>2]|0;while(1){q=(c[f+428>>2]|0)==(c[f+424>>2]|0);if((a[n]|0)==0){break}if(q){if(!((Twc(f+416|0)|0)<<24>>24!=0)){m=27;break a}}l=a[n]|0;p=f+428|0;o=c[p>>2]|0;c[p>>2]=o+1;a[o]=l;n=n+1|0}if(q){if(!((Twc(f+416|0)|0)<<24>>24!=0)){m=31;break}}n=f+428|0;l=c[n>>2]|0;c[n>>2]=l+1;a[l]=61;l=c[(c[k+4>>2]|0)+20>>2]|0;if((a[f+472|0]|0)!=0){l=l+ -1|0}n=0;while(1){if((n|0)>=(l|0)){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){m=38;break a}}o=a[(c[(c[k+4>>2]|0)+16>>2]|0)+n|0]|0;p=f+428|0;r=c[p>>2]|0;c[p>>2]=r+1;a[r]=o;n=n+1|0}g=1}if((m|0)==21){h=0;j=h;i=d;return j|0}else if((m|0)==27){h=0;j=h;i=d;return j|0}else if((m|0)==31){h=0;j=h;i=d;return j|0}else if((m|0)==38){h=0;j=h;i=d;return j|0}else if((m|0)==40){Uwc(e,b);b:while(1){b=Vwc(e)|0;if((b|0)==0){m=55;break}if((a[b+32|0]|0)==0){continue}if((g&255|0)!=0){if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){m=47;break}}q=f+428|0;n=c[q>>2]|0;c[q>>2]=n+1;a[n]=12}n=c[b>>2]|0;while(1){if((a[n]|0)==0){break}if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if(!((Twc(f+416|0)|0)<<24>>24!=0)){m=53;break b}}b=a[n]|0;q=f+428|0;k=c[q>>2]|0;c[q>>2]=k+1;a[k]=b;n=n+1|0}g=1}if((m|0)==47){h=0;j=h;i=d;return j|0}else if((m|0)==53){h=0;j=h;i=d;return j|0}else if((m|0)==55){do{if((c[f+428>>2]|0)==(c[f+424>>2]|0)){if((Twc(f+416|0)|0)<<24>>24!=0){break}h=0;j=h;i=d;return j|0}}while(0);m=f+428|0;g=c[m>>2]|0;c[m>>2]=g+1;a[g]=0;h=c[f+432>>2]|0;j=h;i=d;return j|0}}return 0}function zxc(b,e,f,g,h){b=b|0;e=e|0;f=f|0;g=g|0;h=h|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0;j=i;i=i+352|0;k=b;b=e;e=f;f=g;g=h;h=c[k+356>>2]|0;l=0;m=0;n=Wwc(k,h+20|0,c[f>>2]|0,0)|0;do{if((n|0)==0){o=Cwc(h+80|0,c[f>>2]|0)|0;if((o|0)==0){p=1;q=p;i=j;return q|0}n=Wwc(k,h+20|0,o,24)|0;if((n|0)==0){p=1;q=p;i=j;return q|0}if((d[k+236|0]|0)==0){break}if((Fxc(k,n)|0)!=0){break}p=1;q=p;i=j;return q|0}}while(0);o=c[n+12>>2]|0;r=He[c[b+40>>2]&63](b,e,c[k+380>>2]|0,c[k+392>>2]|0)|0;do{if((r+o|0)>(c[k+380>>2]|0)){s=c[k+380>>2]|0;c[k+380>>2]=r+o+16;t=xe[c[k+16>>2]&63](c[k+392>>2]|0,c[k+380>>2]<<4)|0;if((t|0)==0){p=1;q=p;i=j;return q|0}else{c[k+392>>2]=t;if((r|0)<=(s|0)){break}He[c[b+40>>2]&63](b,e,r,c[k+392>>2]|0)|0;break}}}while(0);e=c[k+392>>2]|0;s=0;a:while(1){if((s|0)>=(r|0)){u=43;break}t=(c[k+392>>2]|0)+(s<<4)|0;v=c[t>>2]|0;w=c[t>>2]|0;x=hxc(k,b,v,w+(xe[c[b+32>>2]&63](b,c[t>>2]|0)|0)|0)|0;if((x|0)==0){u=17;break}if((a[(c[x>>2]|0)+ -1|0]|0)!=0){u=19;break}a[(c[x>>2]|0)+ -1|0]=1;t=l;l=t+1|0;c[e+(t<<2)>>2]=c[x>>2];if((a[(c[k+392>>2]|0)+(s<<4)+12|0]|0)!=0){c[e+(l<<2)>>2]=dxc(k+416|0,b,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0)|0;if((c[e+(l<<2)>>2]|0)==0){u=33;break}c[k+432>>2]=c[k+428>>2]}else{t=1;b:do{if((a[x+8|0]|0)!=0){w=0;while(1){if((w|0)>=(o|0)){break b}y=w;if((x|0)==(c[(c[n+20>>2]|0)+(w*12|0)>>2]|0)){break}w=y+1|0}t=a[(c[n+20>>2]|0)+(y*12|0)+4|0]|0}}while(0);z=lxc(k,b,t,c[(c[k+392>>2]|0)+(s<<4)+4>>2]|0,c[(c[k+392>>2]|0)+(s<<4)+8>>2]|0,k+416|0)|0;if((z|0)!=0){u=30;break}c[e+(l<<2)>>2]=c[k+432>>2];c[k+432>>2]=c[k+428>>2]}do{if((c[x+4>>2]|0)!=0){if((a[x+9|0]|0)==0){l=l+1|0;m=m+1|0;a[(c[x>>2]|0)+ -1|0]=2;break}A=_wc(k,c[x+4>>2]|0,x,c[e+(l<<2)>>2]|0,g)|0;if((A|0)!=0){u=38;break a}l=l+ -1|0}else{l=l+1|0}}while(0);s=s+1|0}if((u|0)==17){p=1;q=p;i=j;return q|0}else if((u|0)==19){if((b|0)==(c[k+144>>2]|0)){c[k+288>>2]=c[(c[k+392>>2]|0)+(s<<4)>>2]}p=8;q=p;i=j;return q|0}else if((u|0)==30){p=z;q=p;i=j;return q|0}else if((u|0)==33){p=1;q=p;i=j;return q|0}else if((u|0)==38){p=A;q=p;i=j;return q|0}else if((u|0)==43){c[k+384>>2]=l;c:do{if((c[n+8>>2]|0)!=0){if((a[(c[c[n+8>>2]>>2]|0)+ -1|0]|0)==0){u=50;break}s=0;while(1){if((s|0)>=(l|0)){break c}B=s;if((c[e+(s<<2)>>2]|0)==(c[c[n+8>>2]>>2]|0)){break}s=B+2|0}c[k+388>>2]=B}else{u=50}}while(0);if((u|0)==50){c[k+388>>2]=-1}s=0;d:while(1){if((s|0)>=(o|0)){break}B=(c[n+20>>2]|0)+(s*12|0)|0;do{if((a[(c[c[B>>2]>>2]|0)+ -1|0]|0)==0){if((c[B+8>>2]|0)==0){break}A=c[B>>2]|0;if((c[(c[B>>2]|0)+4>>2]|0)==0){a[(c[A>>2]|0)+ -1|0]=1;z=l;l=z+1|0;c[e+(z<<2)>>2]=c[c[B>>2]>>2];z=l;l=z+1|0;c[e+(z<<2)>>2]=c[B+8>>2];break}if((a[A+9|0]|0)!=0){C=_wc(k,c[(c[B>>2]|0)+4>>2]|0,c[B>>2]|0,c[B+8>>2]|0,g)|0;if((C|0)!=0){u=58;break d}else{break}}else{a[(c[c[B>>2]>>2]|0)+ -1|0]=2;m=m+1|0;A=l;l=A+1|0;c[e+(A<<2)>>2]=c[c[B>>2]>>2];A=l;l=A+1|0;c[e+(A<<2)>>2]=c[B+8>>2];break}}}while(0);s=s+1|0}if((u|0)==58){p=C;q=p;i=j;return q|0}c[e+(l<<2)>>2]=0;s=0;e:do{if((m|0)!=0){C=c[k+400>>2]|0;o=1<<d[k+404|0];do{if((m<<1>>d[k+404|0]|0)!=0){do{B=k+404|0;A=a[B]|0;a[B]=A+1<<24>>24;}while((m>>(A&255)|0)!=0);if((d[k+404|0]|0)<3){a[k+404|0]=3}o=1<<d[k+404|0];A=xe[c[k+16>>2]&63](c[k+396>>2]|0,o*12|0)|0;if((A|0)!=0){c[k+396>>2]=A;C=0;break}p=1;q=p;i=j;return q|0}}while(0);f:do{if((C|0)==0){C=-1;D=o;while(1){if((D|0)==0){break f}A=D+ -1|0;D=A;c[(c[k+396>>2]|0)+(A*12|0)>>2]=C}}}while(0);A=C+ -1|0;C=A;c[k+400>>2]=A;g:while(1){if((s|0)>=(l|0)){break e}A=c[e+(s<<2)>>2]|0;if((a[A+ -1|0]|0)==2){B=c[k+496>>2]|0;a[A+ -1|0]=0;z=c[(c[(Wwc(k,h+40|0,A,0)|0)+4>>2]|0)+4>>2]|0;if((z|0)==0){u=78;break}D=0;while(1){if((D|0)>=(c[z+20>>2]|0)){break}b=a[(c[z+16>>2]|0)+D|0]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Twc(k+416|0)|0)<<24>>24!=0)){u=84;break g}}y=k+428|0;x=c[y>>2]|0;c[y>>2]=x+1;a[x]=b;B=B*1000003^b&255;D=D+1|0}do{b=A;A=b+1|0;}while((a[b]|0)!=58);do{b=a[A]|0;if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Twc(k+416|0)|0)<<24>>24!=0)){u=89;break g}}x=a[A]|0;y=k+428|0;t=c[y>>2]|0;c[y>>2]=t+1;a[t]=x;B=B*1000003^b&255;b=A;A=b+1|0;}while((a[b]|0)!=0);b=0;x=o-1|0;D=B&x;while(1){if((c[(c[k+396>>2]|0)+(D*12|0)>>2]|0)!=(C|0)){break}if((B|0)==(c[(c[k+396>>2]|0)+(D*12|0)+4>>2]|0)){t=c[k+432>>2]|0;y=c[(c[k+396>>2]|0)+(D*12|0)+8>>2]|0;while(1){if((a[t]|0)!=(a[y]|0)){break}if((a[t]|0)==0){break}t=t+1|0;y=y+1|0}if((a[t]|0)==0){u=98;break g}}if(!(b<<24>>24!=0)){b=((B&~x)>>>((d[k+404|0]|0)-1|0)&x>>>2|1)&255}if((D|0)<(b&255|0)){D=D+(o-(b&255))|0;continue}else{D=D-(b&255)|0;continue}}if((a[k+237|0]|0)!=0){a[(c[k+428>>2]|0)+ -1|0]=a[k+472|0]|0;A=c[c[z>>2]>>2]|0;do{if((c[k+428>>2]|0)==(c[k+424>>2]|0)){if(!((Twc(k+416|0)|0)<<24>>24!=0)){u=109;break g}}b=a[A]|0;x=k+428|0;y=c[x>>2]|0;c[x>>2]=y+1;a[y]=b;b=A;A=b+1|0;}while((a[b]|0)!=0)}A=c[k+432>>2]|0;c[k+432>>2]=c[k+428>>2];c[e+(s<<2)>>2]=A;c[(c[k+396>>2]|0)+(D*12|0)>>2]=C;c[(c[k+396>>2]|0)+(D*12|0)+4>>2]=B;c[(c[k+396>>2]|0)+(D*12|0)+8>>2]=A;z=m+ -1|0;m=z;if((z|0)==0){u=111;break}}else{a[A+ -1|0]=0}s=s+2|0}if((u|0)==78){p=27;q=p;i=j;return q|0}else if((u|0)==84){p=1;q=p;i=j;return q|0}else if((u|0)==89){p=1;q=p;i=j;return q|0}else if((u|0)==98){p=8;q=p;i=j;return q|0}else if((u|0)==109){p=1;q=p;i=j;return q|0}else if((u|0)==111){s=s+2|0;break}}}while(0);while(1){if((s|0)>=(l|0)){break}a[(c[e+(s<<2)>>2]|0)+ -1|0]=0;s=s+2|0}e=c[g>>2]|0;while(1){if((e|0)==0){break}a[(c[c[e+12>>2]>>2]|0)+ -1|0]=0;e=c[e+4>>2]|0}if((a[k+236|0]|0)==0){p=0;q=p;i=j;return q|0}do{if((c[n+4>>2]|0)!=0){e=c[(c[n+4>>2]|0)+4>>2]|0;if((e|0)!=0){E=c[f>>2]|0;do{g=E;E=g+1|0;}while((a[g]|0)!=58)}else{p=27;q=p;i=j;return q|0}}else{if((c[h+156>>2]|0)!=0){e=c[h+156>>2]|0;E=c[f>>2]|0;break}p=0;q=p;i=j;return q|0}}while(0);h=0;do{if((d[k+237|0]|0)!=0){if((c[c[e>>2]>>2]|0)==0){break}do{n=h;h=n+1|0;}while((a[(c[c[e>>2]>>2]|0)+n|0]|0)!=0)}}while(0);c[f+4>>2]=E;c[f+16>>2]=c[e+20>>2];c[f+8>>2]=c[c[e>>2]>>2];c[f+20>>2]=h;s=0;do{n=s;s=n+1|0;}while((a[E+n|0]|0)!=0);r=s+(c[e+20>>2]|0)+h|0;if((r|0)>(c[e+24>>2]|0)){F=ie[c[k+12>>2]&127](r+24|0)|0;if((F|0)==0){p=1;q=p;i=j;return q|0}c[e+24>>2]=r+24;N4c(F|0,c[e+16>>2]|0,c[e+20>>2]|0)|0;r=c[k+364>>2]|0;while(1){if((r|0)==0){break}if((c[r+12>>2]|0)==(c[e+16>>2]|0)){c[r+12>>2]=F}r=c[r>>2]|0}fe[c[k+20>>2]&1023](c[e+16>>2]|0);c[e+16>>2]=F}F=(c[e+16>>2]|0)+(c[e+20>>2]|0)|0;N4c(F|0,E|0,s|0)|0;if((h|0)!=0){F=F+(s-1)|0;a[F]=a[k+472|0]|0;N4c(F+1|0,c[c[e>>2]>>2]|0,h|0)|0}c[f>>2]=c[e+16>>2];p=0;q=p;i=j;return q|0}return 0}function Axc(b,d,e,f){b=b|0;d=d|0;e=e|0;f=f|0;var g=0,h=0,j=0,k=0,l=0,m=0;g=i;i=i+56|0;h=g+40|0;j=b;b=d;d=e;e=f;c[j+280>>2]=43;c[j+288>>2]=b;a:while(1){c[h>>2]=0;f=He[c[c[j+144>>2]>>2]&63](c[j+144>>2]|0,b,d,h)|0;c[j+292>>2]=c[h>>2];b:do{switch(f|0){case 13:{if((txc(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=13;break a}break};case-1:{k=15;break a;break};case-2:{k=18;break a;break};case-15:{k=3;break a;break};case 11:{if((sxc(j,c[j+144>>2]|0,b,c[h>>2]|0)|0)==0){k=11;break a}break};case 0:{k=14;break a;break};case-4:{k=7;break a;break};case 15:{if((c[j+80>>2]|0)==0){break b}Rwc(j,c[j+144>>2]|0,b,c[h>>2]|0);break};default:{k=21;break a}}}while(0);f=c[h>>2]|0;b=f;c[j+288>>2]=f;f=c[j+480>>2]|0;if((f|0)==3){k=23;break}else if((f|0)==2){k=24;break}}if((k|0)==3){do{if((c[j+80>>2]|0)!=0){Rwc(j,c[j+144>>2]|0,b,c[h>>2]|0);if((c[j+480>>2]|0)!=2){break}l=35;m=l;i=g;return m|0}}while(0);c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==7){c[e>>2]=b;l=0;m=l;i=g;return m|0}else if((k|0)==11){l=1;m=l;i=g;return m|0}else if((k|0)==13){l=1;m=l;i=g;return m|0}else if((k|0)==14){c[j+288>>2]=c[h>>2];l=4;m=l;i=g;return m|0}else if((k|0)==15){if((a[j+484|0]|0)!=0){l=5;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==18){if((a[j+484|0]|0)!=0){l=6;m=l;i=g;return m|0}else{c[e>>2]=b;l=0;m=l;i=g;return m|0}}else if((k|0)==21){l=9;m=l;i=g;return m|0}else if((k|0)==23){c[e>>2]=c[h>>2];l=0;m=l;i=g;return m|0}else if((k|0)==24){l=35;m=l;i=g;return m|0}return 0}



function Pt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+43848>>3],+h[f+43872>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function Qt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+44e3>>3],+h[f+44032>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Rt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+44024>>3],+h[f+44048>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function St(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+44176>>3],+h[f+44208>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Tt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+44360>>3],+h[f+44392>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Ut(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((TEc(+U(+(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+24976>>3])),1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2256;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,1600,e);i=b;return}function Vt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+44904>>3],+h[f+44936>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function Wt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+45088>>3],+h[f+45120>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Xt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+45112>>3],+h[f+45136>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function Yt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+45304>>3],+h[f+45336>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function Zt(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+45328>>3],+h[f+45352>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function _t(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+45480>>3],+h[f+45512>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function $t(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+45504>>3],+h[f+45528>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function au(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+45656>>3],+h[f+45688>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function bu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+45840>>3],+h[f+45872>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function cu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;if(!((TEc(+U(+(+h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+25184>>3])),1.0e-10)|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2256;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,1600,e);i=b;return}function du(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+46384>>3],+h[f+46416>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function eu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+46568>>3],+h[f+46600>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function fu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+46592>>3],+h[f+46616>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function gu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+46784>>3],+h[f+46816>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function hu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+46808>>3],+h[f+46832>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function iu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+46960>>3],+h[f+46992>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2280;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2144,e);i=b;return}function ju(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((TEc(+h[f+46984>>3],+h[f+47008>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2304;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2200,e);i=b;return}function ku(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+47136>>3],+h[f+47168>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function lu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0;b=i;i=i+32|0;d=b;e=b+24|0;f=c[a+416>>2]|0;if(!((SEc(+h[f+47320>>3],+h[f+47352>>3])|0)<<24>>24==0)){i=b;return}f=c[a+536>>2]|0;a=c[85374]|0;g=d;j=2328;c[g+0>>2]=c[j+0>>2];c[g+4>>2]=c[j+4>>2];c[g+8>>2]=c[j+8>>2];c[g+12>>2]=c[j+12>>2];c[g+16>>2]=c[j+16>>2];c[g+20>>2]=c[j+20>>2];Ie[a&63](f,d,2080,e);i=b;return}function mu(b){b=b|0;var c=0;c=i;a[b+315|0]=0;a[b+314|0]=1;cf(b);df(b);ef(b);ff(b);gf(b);hf(b);jf(b);kf(b);lf(b);mf(b);nf(b);of(b);pf(b);qf(b);rf(b);sf(b);tf(b);uf(b);vf(b);wf(b);xf(b);yf(b);zf(b);Af(b);Bf(b);Cf(b);Df(b);Ef(b);Ff(b);Gf(b);Hf(b);If(b);Jf(b);Kf(b);Lf(b);Mf(b);Nf(b);Of(b);Pf(b);Qf(b);Rf(b);Sf(b);Tf(b);Uf(b);Vf(b);Wf(b);Xf(b);Yf(b);Zf(b);_f(b);$f(b);ag(b);bg(b);cg(b);dg(b);eg(b);fg(b);gg(b);hg(b);ig(b);jg(b);kg(b);lg(b);mg(b);ng(b);og(b);pg(b);qg(b);rg(b);sg(b);tg(b);ug(b);vg(b);wg(b);xg(b);yg(b);zg(b);Ag(b);Bg(b);Cg(b);Dg(b);Eg(b);Fg(b);Gg(b);Hg(b);Ig(b);Jg(b);Kg(b);Lg(b);Mg(b);Ng(b);Og(b);Pg(b);Qg(b);Rg(b);Sg(b);Tg(b);Ug(b);Vg(b);Wg(b);Xg(b);Yg(b);Zg(b);_g(b);$g(b);ah(b);bh(b);ch(b);dh(b);eh(b);fh(b);gh(b);hh(b);ih(b);jh(b);kh(b);lh(b);mh(b);nh(b);oh(b);ph(b);qh(b);rh(b);sh(b);th(b);uh(b);vh(b);wh(b);xh(b);yh(b);zh(b);Ah(b);Bh(b);Ch(b);Dh(b);Eh(b);Fh(b);Gh(b);Hh(b);Ih(b);Jh(b);Kh(b);Lh(b);Mh(b);Nh(b);Oh(b);Ph(b);Qh(b);Rh(b);Sh(b);Th(b);Uh(b);Vh(b);Wh(b);Xh(b);Yh(b);Zh(b);_h(b);$h(b);ai(b);bi(b);ci(b);di(b);ei(b);fi(b);gi(b);hi(b);ii(b);ji(b);ki(b);li(b);mi(b);ni(b);oi(b);pi(b);qi(b);ri(b);si(b);ti(b);ui(b);vi(b);wi(b);xi(b);yi(b);zi(b);Ai(b);Bi(b);Ci(b);Di(b);Ei(b);Fi(b);Gi(b);Hi(b);Ii(b);Ji(b);Ki(b);Li(b);Mi(b);Ni(b);Oi(b);Pi(b);Qi(b);Ri(b);Si(b);Ti(b);Ui(b);Vi(b);Wi(b);Xi(b);Yi(b);Zi(b);_i(b);$i(b);aj(b);bj(b);cj(b);dj(b);ej(b);fj(b);gj(b);hj(b);ij(b);jj(b);kj(b);lj(b);mj(b);nj(b);oj(b);pj(b);qj(b);rj(b);sj(b);tj(b);uj(b);vj(b);wj(b);xj(b);yj(b);zj(b);Aj(b);Bj(b);Cj(b);Dj(b);Ej(b);Fj(b);Gj(b);Hj(b);Ij(b);Jj(b);Kj(b);Lj(b);Mj(b);Nj(b);Oj(b);Pj(b);Qj(b);Rj(b);Sj(b);Tj(b);Uj(b);Vj(b);Wj(b);Xj(b);Yj(b);Zj(b);_j(b);$j(b);ak(b);bk(b);ck(b);dk(b);ek(b);fk(b);gk(b);hk(b);ik(b);jk(b);kk(b);lk(b);mk(b);nk(b);ok(b);pk(b);qk(b);rk(b);sk(b);tk(b);uk(b);vk(b);wk(b);xk(b);yk(b);zk(b);Ak(b);Bk(b);Ck(b);Dk(b);Ek(b);Fk(b);Gk(b);Hk(b);Ik(b);Jk(b);Kk(b);Lk(b);Mk(b);Nk(b);Ok(b);Pk(b);Qk(b);Rk(b);Sk(b);Tk(b);Uk(b);Vk(b);Wk(b);Xk(b);Yk(b);Zk(b);_k(b);$k(b);al(b);bl(b);cl(b);dl(b);el(b);fl(b);gl(b);hl(b);il(b);jl(b);kl(b);ll(b);ml(b);nl(b);ol(b);pl(b);ql(b);rl(b);sl(b);tl(b);ul(b);vl(b);wl(b);xl(b);yl(b);zl(b);Al(b);Bl(b);Cl(b);Dl(b);El(b);Fl(b);Gl(b);Hl(b);Il(b);Jl(b);Kl(b);Ll(b);Ml(b);Nl(b);Ol(b);Pl(b);Ql(b);Rl(b);Sl(b);Tl(b);Ul(b);Vl(b);Wl(b);Xl(b);Yl(b);Zl(b);_l(b);$l(b);am(b);bm(b);cm(b);dm(b);em(b);fm(b);gm(b);hm(b);im(b);jm(b);km(b);lm(b);mm(b);nm(b);om(b);pm(b);qm(b);rm(b);sm(b);tm(b);um(b);vm(b);wm(b);xm(b);ym(b);zm(b);Am(b);Bm(b);Cm(b);Dm(b);Em(b);Fm(b);Gm(b);Hm(b);Im(b);Jm(b);Km(b);Lm(b);Mm(b);Nm(b);Om(b);Pm(b);Qm(b);Rm(b);Sm(b);Tm(b);Um(b);Vm(b);Wm(b);Xm(b);Ym(b);Zm(b);_m(b);$m(b);an(b);bn(b);cn(b);dn(b);en(b);fn(b);gn(b);hn(b);jn(b);kn(b);ln(b);mn(b);nn(b);on(b);pn(b);qn(b);rn(b);sn(b);tn(b);un(b);vn(b);wn(b);xn(b);yn(b);zn(b);An(b);Bn(b);Cn(b);Dn(b);En(b);Fn(b);Gn(b);Hn(b);In(b);Jn(b);Kn(b);Ln(b);Mn(b);Nn(b);On(b);Pn(b);Qn(b);Rn(b);Sn(b);Tn(b);Un(b);Vn(b);Wn(b);Xn(b);Yn(b);Zn(b);_n(b);$n(b);ao(b);bo(b);co(b);eo(b);fo(b);go(b);ho(b);io(b);jo(b);ko(b);lo(b);mo(b);no(b);oo(b);po(b);qo(b);ro(b);so(b);to(b);uo(b);vo(b);wo(b);xo(b);yo(b);zo(b);Ao(b);Bo(b);Co(b);Do(b);Eo(b);Fo(b);Go(b);Ho(b);Io(b);Jo(b);Ko(b);Lo(b);Mo(b);No(b);Oo(b);Po(b);Qo(b);Ro(b);So(b);To(b);Uo(b);Vo(b);Wo(b);Xo(b);Yo(b);Zo(b);_o(b);$o(b);ap(b);bp(b);cp(b);dp(b);ep(b);fp(b);gp(b);hp(b);ip(b);jp(b);kp(b);lp(b);mp(b);np(b);op(b);pp(b);qp(b);rp(b);sp(b);tp(b);up(b);vp(b);wp(b);xp(b);yp(b);zp(b);Ap(b);Bp(b);Cp(b);Dp(b);Ep(b);Fp(b);Gp(b);Hp(b);Ip(b);Jp(b);Kp(b);Lp(b);Mp(b);Np(b);Op(b);Pp(b);Qp(b);Rp(b);Sp(b);Tp(b);Up(b);Vp(b);Wp(b);Xp(b);Yp(b);Zp(b);_p(b);$p(b);aq(b);bq(b);cq(b);dq(b);eq(b);fq(b);gq(b);hq(b);iq(b);jq(b);kq(b);lq(b);mq(b);nq(b);oq(b);pq(b);qq(b);rq(b);sq(b);tq(b);uq(b);vq(b);wq(b);xq(b);yq(b);zq(b);Aq(b);Bq(b);Cq(b);Dq(b);Eq(b);Fq(b);Gq(b);Hq(b);Iq(b);Jq(b);Kq(b);Lq(b);Mq(b);Nq(b);Oq(b);Pq(b);Qq(b);Rq(b);Sq(b);Tq(b);Uq(b);Vq(b);Wq(b);Xq(b);Yq(b);Zq(b);_q(b);$q(b);ar(b);br(b);cr(b);dr(b);er(b);fr(b);gr(b);hr(b);ir(b);jr(b);kr(b);lr(b);mr(b);nr(b);or(b);pr(b);qr(b);rr(b);sr(b);tr(b);ur(b);vr(b);wr(b);xr(b);yr(b);zr(b);Ar(b);Br(b);Cr(b);Dr(b);Er(b);Fr(b);Gr(b);Hr(b);Ir(b);Jr(b);Kr(b);Lr(b);Mr(b);Nr(b);Or(b);Pr(b);Qr(b);Rr(b);Sr(b);Tr(b);Ur(b);Vr(b);Wr(b);Xr(b);Yr(b);Zr(b);_r(b);$r(b);as(b);bs(b);cs(b);ds(b);es(b);fs(b);gs(b);hs(b);is(b);js(b);ks(b);ls(b);ms(b);ns(b);os(b);ps(b);qs(b);rs(b);ss(b);ts(b);us(b);vs(b);ws(b);xs(b);ys(b);zs(b);As(b);Bs(b);Cs(b);Ds(b);Es(b);Fs(b);Gs(b);Hs(b);Is(b);Js(b);Ks(b);Ls(b);Ms(b);Ns(b);Os(b);Ps(b);Qs(b);Rs(b);Ss(b);Ts(b);Us(b);Vs(b);Ws(b);Xs(b);Ys(b);Zs(b);_s(b);$s(b);at(b);bt(b);ct(b);dt(b);et(b);ft(b);gt(b);ht(b);it(b);jt(b);kt(b);lt(b);mt(b);nt(b);ot(b);pt(b);qt(b);rt(b);st(b);tt(b);ut(b);vt(b);wt(b);xt(b);yt(b);zt(b);At(b);Bt(b);Ct(b);Dt(b);Et(b);Ft(b);Gt(b);Ht(b);It(b);Jt(b);Kt(b);Lt(b);Mt(b);Nt(b);Ot(b);Pt(b);Qt(b);Rt(b);St(b);Tt(b);Ut(b);Vt(b);Wt(b);Xt(b);Yt(b);Zt(b);_t(b);$t(b);au(b);bu(b);cu(b);du(b);eu(b);fu(b);gu(b);hu(b);iu(b);ju(b);ku(b);lu(b);i=c;return 0}function nu(b){b=b|0;var c=0;c=i;a[b+314|0]=0;ou(b);i=c;return 0}function ou(a){a=a|0;var b=0;b=i;df(a);ef(a);ff(a);cg(a);dg(a);eg(a);fg(a);gg(a);hg(a);ig(a);jg(a);kg(a);lg(a);mg(a);ng(a);og(a);pg(a);qg(a);rg(a);sg(a);tg(a);ug(a);vg(a);wg(a);xg(a);yg(a);zg(a);Ag(a);Bg(a);Cg(a);Dg(a);Eg(a);Fg(a);Gg(a);Hg(a);Ig(a);Jg(a);Kg(a);Lg(a);Mg(a);Ng(a);Og(a);Pg(a);Qg(a);Rg(a);Sg(a);Tg(a);Ug(a);Vg(a);Wg(a);Xg(a);Yg(a);Zg(a);_g(a);$g(a);ah(a);bh(a);ch(a);dh(a);eh(a);fh(a);gh(a);hh(a);ih(a);jh(a);kh(a);lh(a);mh(a);nh(a);oh(a);ph(a);qh(a);rh(a);sh(a);th(a);uh(a);vh(a);wh(a);xh(a);yh(a);zh(a);Ah(a);Bh(a);Ch(a);Dh(a);Eh(a);Fh(a);Gh(a);Hh(a);Ih(a);Jh(a);Kh(a);Lh(a);Mh(a);Nh(a);Oh(a);Ph(a);Qh(a);Rh(a);Sh(a);Th(a);Uh(a);Vh(a);Xh(a);Yh(a);_h(a);di(a);ei(a);fi(a);gi(a);hi(a);ii(a);ji(a);ki(a);li(a);mi(a);ni(a);oi(a);pi(a);qi(a);ri(a);si(a);ti(a);ui(a);vi(a);wi(a);Ei(a);Fi(a);Gi(a);Hi(a);Ri(a);Si(a);Ti(a);Vi(a);Wi(a);Xi(a);Yi(a);Zi(a);_i(a);$i(a);aj(a);bj(a);cj(a);dj(a);ej(a);fj(a);gj(a);hj(a);ij(a);jj(a);kj(a);lj(a);mj(a);nj(a);oj(a);sj(a);tj(a);yj(a);zj(a);Jj(a);Kj(a);Lj(a);Nj(a);Oj(a);Pj(a);Qj(a);Rj(a);Sj(a);Tj(a);Uj(a);Vj(a);Wj(a);Xj(a);Yj(a);Zj(a);_j(a);$j(a);ak(a);bk(a);ck(a);dk(a);ek(a);fk(a);jk(a);kk(a);pk(a);qk(a);rk(a);sk(a);tk(a);uk(a);Fk(a);Gk(a);Hk(a);Ik(a);Jk(a);Kk(a);Lk(a);Mk(a);Nk(a);Ok(a);Pk(a);Qk(a);Rk(a);Sk(a);Tk(a);Uk(a);Vk(a);Wk(a);Xk(a);Yk(a);Zk(a);_k(a);$k(a);al(a);il(a);jl(a);kl(a);ll(a);ml(a);xl(a);yl(a);zl(a);Al(a);Bl(a);Cl(a);Dl(a);El(a);Fl(a);Gl(a);Hl(a);Il(a);Jl(a);Kl(a);Ll(a);Ml(a);Nl(a);Ol(a);Pl(a);Ql(a);Ul(a);Vl(a);Wl(a);Xl(a);am(a);bm(a);lm(a);mm(a);nm(a);pm(a);qm(a);rm(a);sm(a);tm(a);um(a);vm(a);wm(a);xm(a);ym(a);Am(a);Bm(a);Dm(a);Em(a);Fm(a);Gm(a);Km(a);Lm(a);Qm(a);Rm(a);Sm(a);Tm(a);Um(a);Vm(a);jn(a);kn(a);ln(a);mn(a);nn(a);on(a);pn(a);qn(a);rn(a);sn(a);tn(a);un(a);vn(a);qq(a);rq(a);i=b;return}function pu(a,b){a=a|0;b=+b;i=i;return 0}function qu(a){a=a|0;var b=0;b=i;i=i+8|0;HBc(c[a+536>>2]|0,(a|0)!=0|0,2560,b);c[a+540>>2]=2368;c[a+84>>2]=2592;c[a+88>>2]=2592;c[a+92>>2]=2648;c[a+96>>2]=2736;c[a+100>>2]=0;c[a+60>>2]=0;c[a+112>>2]=4;c[a+116>>2]=3402;c[a+120>>2]=0;c[a+124>>2]=390;c[a+128>>2]=0;c[a+132>>2]=0;c[a+136>>2]=5969;c[a+140>>2]=524;c[a+144>>2]=557;c[a+148>>2]=129;c[a+152>>2]=0;c[a+156>>2]=3;c[a+232>>2]=5;c[a+216>>2]=7816;c[a+220>>2]=222;c[a+224>>2]=0;c[a+228>>2]=0;c[a+160>>2]=18;c[a+104>>2]=0;c[a+164>>2]=18;c[a+168>>2]=0;c[a+176>>2]=2;c[a+180>>2]=0;c[a+184>>2]=2;c[a+188>>2]=0;c[a+56>>2]=2776;c[a+64>>2]=3;c[a+72>>2]=0;c[a+68>>2]=11182;c[a+192>>2]=0;c[a+196>>2]=38;c[a+200>>2]=12;c[a+204>>2]=0;c[a+208>>2]=0;c[a+212>>2]=0;c[a+172>>2]=0;i=b;return}function ru(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,s=0,t=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,V=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0;d=i;e=i;i=i+168|0;c[e>>2]=0;f=i;i=i+544|0;g=i;i=i+88|0;h=i;i=i+160|0;j=i;i=i+160|0;u=0;Pa(3);k=u;u=0;if((k|0)!=0&(v|0)!=0){l=Y4c(c[k>>2]|0,e)|0;if((l|0)==0){eb(k|0,v|0)}J=v}else{l=-1}k=J;do{if((l|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=k;w=7}else if((l|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=k}else{E=293184;F=293208;c[E+0>>2]=c[F+0>>2];c[E+4>>2]=c[F+4>>2];c[E+8>>2]=c[F+8>>2];c[E+12>>2]=c[F+12>>2];c[E+16>>2]=c[F+16>>2];c[E+20>>2]=c[F+20>>2];u=0;Pa(c[73296]|0);F=u;u=0;if((F|0)!=0&(v|0)!=0){G=Y4c(c[F>>2]|0,e)|0;if((G|0)==0){eb(F|0,v|0)}J=v}else{G=-1}F=J;if((G|0)==2){m=0;n=0;o=0;p=0;q=0;s=0;t=F;w=7;break}else if((G|0)==1){x=0;y=0;z=0;A=0;B=0;C=0;D=F;break}F=g;E=F+0|0;H=E+88|0;do{c[E>>2]=0;E=E+4|0}while((E|0)<(H|0));u=0;E=sa(98,c[72532]|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){I=Y4c(c[H>>2]|0,e)|0;if((I|0)==0){eb(H|0,v|0)}J=v}else{I=-1}H=J;if((I|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((I|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}u=0;Ha(48,c[72532]|0,F|0)|0;H=u;u=0;if((H|0)!=0&(v|0)!=0){K=Y4c(c[H>>2]|0,e)|0;if((K|0)==0){eb(H|0,v|0)}J=v}else{K=-1}H=J;if((K|0)==2){m=0;n=0;o=0;p=0;q=E;s=F;t=H;w=7;break}else if((K|0)==1){x=0;y=0;z=0;A=0;B=E;C=F;D=H;break}H=h;c[g>>2]=h;K4c(h,2,e|0)|0;u=0;L=u;u=0;if((L|0)!=0&(v|0)!=0){M=Y4c(c[L>>2]|0,e)|0;if((M|0)==0){eb(L|0,v|0)}J=v}else{M=-1}L=J;if((M|0)==2){m=0;n=0;o=0;p=H;q=E;s=F;t=L;w=7;break}else if((M|0)==1){x=0;y=0;z=0;A=H;B=E;C=F;D=L;break}m=0;n=0;o=0;p=H;q=E;s=F;t=0;w=7}}while(0);while(1){if((w|0)==7){w=0;if((t|0)==0){M=j;h=g+4|0;K=c[h>>2]|0;c[h>>2]=j;K4c(j,1,e|0)|0;u=0;I=u;u=0;if((I|0)!=0&(v|0)!=0){N=Y4c(c[I>>2]|0,e)|0;if((N|0)==0){eb(I|0,v|0)}J=v}else{N=-1}I=J;if((N|0)==2){O=s;P=q;Q=p;m=K;n=h;o=M;t=I;s=O;q=P;p=Q;w=7;continue}else if((N|0)==1){x=K;y=h;z=M;A=p;B=q;C=s;D=I;continue}x=K;y=h;z=M;A=p;B=q;C=s;D=0;continue}else{u=0;Ha(48,c[72532]|0,q|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){R=Y4c(c[M>>2]|0,e)|0;if((R|0)==0){eb(M|0,v|0)}J=v}else{R=-1}M=J;if((R|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((R|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){V=Y4c(c[M>>2]|0,e)|0;if((V|0)==0){eb(M|0,v|0)}J=v}else{V=-1}M=J;if((V|0)==2){O=s;P=q;Q=p;S=o;T=n;U=m;t=M;s=O;q=P;p=Q;o=S;n=T;m=U;w=7;continue}else if((V|0)==1){x=m;y=n;z=o;A=p;B=q;C=s;D=M;continue}else{w=18;break}}}if((D|0)!=0){u=0;Pa(4);M=u;u=0;if((M|0)!=0&(v|0)!=0){W=Y4c(c[M>>2]|0,e)|0;if((W|0)==0){eb(M|0,v|0)}J=v}else{W=-1}M=J;if((W|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((W|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}M=c[r>>2]|0;u=0;Ra(34,2840,154,1,M|0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ba=Y4c(c[M>>2]|0,e)|0;if((ba|0)==0){eb(M|0,v|0)}J=v}else{ba=-1}M=J;if((ba|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ba|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;M=u;u=0;if((M|0)!=0&(v|0)!=0){ca=Y4c(c[M>>2]|0,e)|0;if((ca|0)==0){eb(M|0,v|0)}J=v}else{ca=-1}M=J;if((ca|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ca|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;M=u;u=0;if((M|0)!=0&(v|0)!=0){da=Y4c(c[M>>2]|0,e)|0;if((da|0)==0){eb(M|0,v|0)}J=v}else{da=-1}M=J;if((da|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((da|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}else{w=15;break}}u=0;pa(137,f|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ea=Y4c(c[M>>2]|0,e)|0;if((ea|0)==0){eb(M|0,v|0)}J=v}else{ea=-1}M=J;if((ea|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7;continue}else if((ea|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[f+536>>2]=g;u=0;M=va(31,a|0,b|0,f|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){fa=Y4c(c[h>>2]|0,e)|0;if((fa|0)==0){eb(h|0,v|0)}J=v}else{fa=-1}h=J;if((fa|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((fa|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}c[y>>2]=x;u=0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ga=Y4c(c[h>>2]|0,e)|0;if((ga|0)==0){eb(h|0,v|0)}J=v}else{ga=-1}h=J;if((ga|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ga|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;Ha(48,c[72532]|0,B|0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ha=Y4c(c[h>>2]|0,e)|0;if((ha|0)==0){eb(h|0,v|0)}J=v}else{ha=-1}h=J;if((ha|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ha|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ia=Y4c(c[h>>2]|0,e)|0;if((ia|0)==0){eb(h|0,v|0)}J=v}else{ia=-1}h=J;if((ia|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ia|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;sa(99,0)|0;h=u;u=0;if((h|0)!=0&(v|0)!=0){ja=Y4c(c[h>>2]|0,e)|0;if((ja|0)==0){eb(h|0,v|0)}J=v}else{ja=-1}h=J;if((ja|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=h;w=7;continue}else if((ja|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=h;C=X;B=Y;A=Z;z=_;y=$;x=aa;continue}u=0;pa(138,M|0);M=u;u=0;if((M|0)!=0&(v|0)!=0){ka=Y4c(c[M>>2]|0,e)|0;if((ka|0)==0){eb(M|0,v|0)}J=v}else{ka=-1}M=J;if((ka|0)==2){m=x;n=y;o=z;p=A;q=B;s=C;t=M;w=7}else if((ka|0)==1){X=C;Y=B;Z=A;_=z;$=y;aa=x;D=M;C=X;B=Y;A=Z;z=_;y=$;x=aa}else{w=26;break}}if((w|0)==15){la=A;ma=C;i=d;return 1}else if((w|0)==18){la=p;ma=s;i=d;return 1}return 0}function su(){var a=0;a=i;ud(0)|0;rc(3e3,18,1,c[r>>2]|0)|0;ud(0)|0;i=a;return}function tu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0,S=0,T=0,U=0,W=0,X=0,Y=0,Z=0,_=0,$=0,aa=0,ba=0,ca=0,da=0,ea=0,fa=0,ga=0,ha=0,ia=0,ja=0,ka=0,la=0,ma=0,na=0,oa=0,pa=0,qa=0,ra=0,sa=0,ta=0,ua=0,va=0,wa=0,xa=0,ya=0,za=0,Aa=0,Ba=0.0,Ca=0.0,Da=0.0,Ea=0.0,Fa=0.0,Ga=0.0,Ha=0,Ia=0.0,Ja=0.0,Ka=0.0,La=0.0,Ma=0,Na=0;f=i;i=i+120|0;g=f;j=f+24|0;l=f+48|0;m=f+72|0;n=f+96|0;o=i;i=i+8|0;p=i;i=i+8|0;q=i;i=i+8|0;r=i;i=i+8|0;s=i;i=i+8|0;t=i;i=i+8|0;u=i;i=i+8|0;v=i;i=i+8|0;w=i;i=i+8|0;x=i;i=i+8|0;y=i;i=i+8|0;z=i;i=i+8|0;A=i;i=i+24|0;B=i;i=i+8|0;C=i;i=i+8|0;D=i;i=i+8|0;E=i;i=i+8|0;F=i;i=i+8|0;G=i;i=i+8|0;H=i;i=i+8|0;I=i;i=i+24|0;J=i;i=i+8|0;K=i;i=i+8|0;L=i;i=i+8|0;M=i;i=i+8|0;N=i;i=i+8|0;O=i;i=i+8|0;P=i;i=i+8|0;Q=i;i=i+24|0;R=i;i=i+8|0;S=i;i=i+8|0;T=i;i=i+8|0;U=i;i=i+8|0;W=i;i=i+8|0;X=i;i=i+8|0;Y=i;i=i+8|0;Z=i;i=i+24|0;_=i;i=i+8|0;$=i;i=i+8|0;aa=i;i=i+8|0;ba=i;i=i+8|0;ca=i;i=i+8|0;da=i;i=i+8|0;ea=i;i=i+8|0;fa=i;i=i+8|0;ga=i;i=i+8|0;ha=i;i=i+8|0;ia=i;i=i+8|0;ja=i;i=i+8|0;ka=i;i=i+8|0;la=i;i=i+8|0;ma=i;i=i+8|0;na=i;i=i+8|0;oa=i;i=i+8|0;pa=i;i=i+8|0;qa=i;i=i+8|0;ra=i;i=i+8|0;sa=i;i=i+8|0;ta=i;i=i+16|0;ua=i;i=i+16|0;va=i;i=i+16|0;wa=i;i=i+16|0;xa=i;i=i+16|0;ya=i;i=i+16|0;za=i;i=i+16|0;Aa=ta;c[sa>>2]=4;wCc(Aa,1,sa);c[ra>>2]=4;wCc(ua,1,ra);c[qa>>2]=1;c[qa+4>>2]=1;Ba=+h[(ECc(d,2,qa)|0)>>3];c[pa>>2]=2;c[pa+4>>2]=2;Ca=-+h[(ECc(d,2,pa)|0)>>3];c[oa>>2]=3;c[oa+4>>2]=3;Da=Ba+(Ca- +h[(ECc(d,2,oa)|0)>>3])+1.0;c[na>>2]=2;c[na+4>>2]=2;Ca=+h[(ECc(d,2,na)|0)>>3];c[ma>>2]=1;c[ma+4>>2]=1;Ba=-+h[(ECc(d,2,ma)|0)>>3];c[la>>2]=3;c[la+4>>2]=3;Ea=Ca+(Ba- +h[(ECc(d,2,la)|0)>>3])+1.0;c[ka>>2]=3;c[ka+4>>2]=3;Ba=+h[(ECc(d,2,ka)|0)>>3];c[ja>>2]=1;c[ja+4>>2]=1;Ca=-+h[(ECc(d,2,ja)|0)>>3];c[ia>>2]=2;c[ia+4>>2]=2;Fa=Ba+(Ca- +h[(ECc(d,2,ia)|0)>>3])+1.0;c[ha>>2]=1;c[ha+4>>2]=1;Ca=+h[(ECc(d,2,ha)|0)>>3];c[ga>>2]=2;c[ga+4>>2]=2;Ba=+h[(ECc(d,2,ga)|0)>>3];c[fa>>2]=3;c[fa+4>>2]=3;Ga=Ca+(Ba+ +h[(ECc(d,2,fa)|0)>>3])+1.0;do{if(Ga>.04000000000000001){Ha=3}else{if(Ga>Da&Ga>Ea&Ga>Fa){Ha=3;break}if(Da>Ea&Da>Fa&Da>Ga){if(!(Da>=0.0)){fa=c[85374]|0;ga=Y;h[k>>3]=Da;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=fa;fa=l;ha=3200;c[fa+0>>2]=c[ha+0>>2];c[fa+4>>2]=c[ha+4>>2];c[fa+8>>2]=c[ha+8>>2];c[fa+12>>2]=c[ha+12>>2];c[fa+16>>2]=c[ha+16>>2];c[fa+20>>2]=c[ha+20>>2];Ie[ga&63](b,l,3088,Y);}Ba=+V(+Da)*.5;Ca=Ba*4.0;c[X>>2]=1;c[X+4>>2]=2;Ia=+h[(ECc(d,2,X)|0)>>3];c[W>>2]=2;c[W+4>>2]=1;Ja=(Ia+ +h[(ECc(d,2,W)|0)>>3])/Ca;c[U>>2]=1;c[U+4>>2]=3;Ia=+h[(ECc(d,2,U)|0)>>3];c[T>>2]=3;c[T+4>>2]=1;Ka=(Ia+ +h[(ECc(d,2,T)|0)>>3])/Ca;c[S>>2]=2;c[S+4>>2]=3;Ia=+h[(ECc(d,2,S)|0)>>3];c[R>>2]=3;c[R+4>>2]=2;La=(Ia- +h[(ECc(d,2,R)|0)>>3])/Ca;ga=Q;h[k>>3]=Ja;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+8|0;h[k>>3]=Ka;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];ga=Q+16|0;h[k>>3]=La;c[ga>>2]=c[k>>2];c[ga+4>>2]=c[k+4>>2];DCc(wa,4,Ba,Q);yCc(wa,ua);break}if(Ea>Da&Ea>Fa&Ea>Ga){if(!(Ea>=0.0)){ga=c[85374]|0;ha=P;h[k>>3]=Ea;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=ga;ga=j;fa=3200;c[ga+0>>2]=c[fa+0>>2];c[ga+4>>2]=c[fa+4>>2];c[ga+8>>2]=c[fa+8>>2];c[ga+12>>2]=c[fa+12>>2];c[ga+16>>2]=c[fa+16>>2];c[ga+20>>2]=c[fa+20>>2];Ie[ha&63](b,j,3144,P);}Ba=+V(+Ea)*.5;La=Ba*4.0;c[O>>2]=1;c[O+4>>2]=2;Ka=+h[(ECc(d,2,O)|0)>>3];c[N>>2]=2;c[N+4>>2]=1;Ja=(Ka+ +h[(ECc(d,2,N)|0)>>3])/La;c[M>>2]=2;c[M+4>>2]=3;Ka=+h[(ECc(d,2,M)|0)>>3];c[L>>2]=3;c[L+4>>2]=2;Ca=(Ka+ +h[(ECc(d,2,L)|0)>>3])/La;c[K>>2]=3;c[K+4>>2]=1;Ka=+h[(ECc(d,2,K)|0)>>3];c[J>>2]=1;c[J+4>>2]=3;Ia=(Ka- +h[(ECc(d,2,J)|0)>>3])/La;ha=I;h[k>>3]=Ba;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+8|0;h[k>>3]=Ca;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];ha=I+16|0;h[k>>3]=Ia;c[ha>>2]=c[k>>2];c[ha+4>>2]=c[k+4>>2];DCc(xa,4,Ja,I);yCc(xa,ua);break}else{if(!(Fa>=0.0)){ha=c[85374]|0;fa=H;h[k>>3]=Fa;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=ha;ha=g;ga=3200;c[ha+0>>2]=c[ga+0>>2];c[ha+4>>2]=c[ga+4>>2];c[ha+8>>2]=c[ga+8>>2];c[ha+12>>2]=c[ga+12>>2];c[ha+16>>2]=c[ga+16>>2];c[ha+20>>2]=c[ga+20>>2];Ie[fa&63](b,g,3224,H);}Ja=+V(+Fa)*.5;Ia=Ja*4.0;c[G>>2]=1;c[G+4>>2]=3;Ca=+h[(ECc(d,2,G)|0)>>3];c[F>>2]=3;c[F+4>>2]=1;Ba=(Ca+ +h[(ECc(d,2,F)|0)>>3])/Ia;c[E>>2]=2;c[E+4>>2]=3;Ca=+h[(ECc(d,2,E)|0)>>3];c[D>>2]=3;c[D+4>>2]=2;La=(Ca+ +h[(ECc(d,2,D)|0)>>3])/Ia;c[C>>2]=1;c[C+4>>2]=2;Ca=+h[(ECc(d,2,C)|0)>>3];c[B>>2]=2;c[B+4>>2]=1;Ka=(Ca- +h[(ECc(d,2,B)|0)>>3])/Ia;fa=A;h[k>>3]=La;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+8|0;h[k>>3]=Ja;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];fa=A+16|0;h[k>>3]=Ka;c[fa>>2]=c[k>>2];c[fa+4>>2]=c[k+4>>2];DCc(ya,4,Ba,A);yCc(ya,ua);break}}}while(0);if((Ha|0)==3){if(!(Ga>=0.0)){Ha=c[85374]|0;ya=ea;h[k>>3]=Ga;c[ya>>2]=c[k>>2];c[ya+4>>2]=c[k+4>>2];ya=Ha;Ha=m;A=3200;c[Ha+0>>2]=c[A+0>>2];c[Ha+4>>2]=c[A+4>>2];c[Ha+8>>2]=c[A+8>>2];c[Ha+12>>2]=c[A+12>>2];c[Ha+16>>2]=c[A+16>>2];c[Ha+20>>2]=c[A+20>>2];Ie[ya&63](b,m,3032,ea);}Fa=+V(+Ga)*.5;Ga=Fa*4.0;c[da>>2]=2;c[da+4>>2]=3;Ea=+h[(ECc(d,2,da)|0)>>3];c[ca>>2]=3;c[ca+4>>2]=2;Da=(Ea- +h[(ECc(d,2,ca)|0)>>3])/Ga;c[ba>>2]=3;c[ba+4>>2]=1;Ea=+h[(ECc(d,2,ba)|0)>>3];c[aa>>2]=1;c[aa+4>>2]=3;Ba=(Ea- +h[(ECc(d,2,aa)|0)>>3])/Ga;c[$>>2]=1;c[$+4>>2]=2;Ea=+h[(ECc(d,2,$)|0)>>3];c[_>>2]=2;c[_+4>>2]=1;Ka=(Ea- +h[(ECc(d,2,_)|0)>>3])/Ga;_=Z;h[k>>3]=Ba;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+8|0;h[k>>3]=Ka;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];_=Z+16|0;h[k>>3]=Fa;c[_>>2]=c[k>>2];c[_+4>>2]=c[k+4>>2];DCc(va,4,Da,Z);yCc(va,ua)}c[z>>2]=1;Da=+h[(ECc(ua,1,z)|0)>>3];c[y>>2]=1;Fa=Da*+h[(ECc(e,1,y)|0)>>3];c[x>>2]=2;Da=+h[(ECc(ua,1,x)|0)>>3];c[w>>2]=2;Ka=Da*+h[(ECc(e,1,w)|0)>>3];c[v>>2]=3;Da=+h[(ECc(ua,1,v)|0)>>3];c[u>>2]=3;Ba=Da*+h[(ECc(e,1,u)|0)>>3];c[t>>2]=4;Da=+h[(ECc(ua,1,t)|0)>>3];c[s>>2]=4;if(!(Fa+(Ka+(Ba+Da*+h[(ECc(e,1,s)|0)>>3]))<0.0)){yCc(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}c[r>>2]=1;Da=-+h[(ECc(ua,1,r)|0)>>3];c[q>>2]=2;Ba=-+h[(ECc(ua,1,q)|0)>>3];c[p>>2]=3;Ka=-+h[(ECc(ua,1,p)|0)>>3];c[o>>2]=4;Fa=-+h[(ECc(ua,1,o)|0)>>3];o=n;h[k>>3]=Ba;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+8|0;h[k>>3]=Ka;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];o=n+16|0;h[k>>3]=Fa;c[o>>2]=c[k>>2];c[o+4>>2]=c[k+4>>2];DCc(za,4,Da,n);yCc(za,ua);yCc(ua,Aa);Ma=a;Na=ta;c[Ma+0>>2]=c[Na+0>>2];c[Ma+4>>2]=c[Na+4>>2];c[Ma+8>>2]=c[Na+8>>2];i=f;return}function uu(a){a=a|0;var b=0;a=i;i=i+8|0;b=i;i=i+8|0;EBc(4,0,3280,b);EBc(4,0,3320,a);i=a;return}function vu(a){a=a|0;var b=0,d=0;b=i;d=a+320|0;a=c[d>>2]|0;if((a|0)==0){i=b;return}i4c(a);c[d>>2]=0;i=b;return}function wu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24136>>3]=+X(+(+h[b+26592>>3]));i=i;return}function xu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24128>>3]=-+Y(+(+h[b+26592>>3]));i=i;return}function yu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23864>>3]=+h[b+24128>>3]*.8660254037844387+ +h[b+24136>>3]*.4999999999999999;i=i;return}function zu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23872>>3]=+h[b+24128>>3]*-.4999999999999999+ +h[b+24136>>3]*.8660254037844387;i=i;return}function Au(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24112>>3]=+Y(+(+h[b+26592>>3]));i=i;return}function Bu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24104>>3]=+X(+(+h[b+26592>>3]));i=i;return}function Cu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23840>>3]=+h[b+24104>>3]*.8660254037844387+ +h[b+24112>>3]*.4999999999999999;i=i;return}function Du(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3408>>3]+(+h[b+23840>>3]*+h[d+1504>>3]+ +h[b+23864>>3]*+h[d+1512>>3]);i=i;return}function Eu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3600>>3]=+h[b+3456>>3]+(+h[d+1120>>3]*.8660254037844387+ +h[d+1128>>3]*.4999999999999999);i=i;return}function Fu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23848>>3]=+h[b+24104>>3]*-.4999999999999999+ +h[b+24112>>3]*.8660254037844387;i=i;return}function Gu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3464>>3]=+h[b+3416>>3]+(+h[b+23848>>3]*+h[d+1504>>3]+ +h[b+23872>>3]*+h[d+1512>>3]);i=i;return}function Hu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3608>>3]=+h[b+3464>>3]+(+h[d+1120>>3]*-.4999999999999999+ +h[d+1128>>3]*.8660254037844387);i=i;return}function Iu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+3592|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14352|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26608>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*-.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27192|0);i=b;return}function Ju(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+50368>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+50344>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+50352>>3];h[a+8>>3]=+h[d+372592>>3];h[e+8>>3]=+h[d+372568>>3];h[f+8>>3]=+h[d+372576>>3];h[a+16>>3]=+h[d+372368>>3];h[e+16>>3]=+h[d+372344>>3];h[f+16>>3]=+h[d+372352>>3];i=i;return}function Ku(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+3592>>3]=+h[b>>3];h[a+26608>>3]=+h[b+8>>3];h[a+26592>>3]=+h[b+16>>3];wu(f);xu(f);yu(f);zu(f);Au(f);Bu(f);Cu(f);Du(f);Eu(f);Fu(f);Gu(f);Hu(f);Iu(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27192>>3];h[d+8>>3]=+h[f+27200>>3];h[d+16>>3]=+h[f+27208>>3];i=e;return}function Lu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24344>>3]=+X(+(+h[b+26480>>3]));i=i;return}function Mu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24336>>3]=-+Y(+(+h[b+26480>>3]));i=i;return}function Nu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23720>>3]=+h[b+24336>>3]*.8660254037844387+ +h[b+24344>>3]*-.4999999999999999;i=i;return}function Ou(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23728>>3]=+h[b+24336>>3]*.4999999999999999+ +h[b+24344>>3]*.8660254037844387;i=i;return}function Pu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24312>>3]=+X(+(+h[b+26480>>3]));i=i;return}function Qu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24320>>3]=+Y(+(+h[b+26480>>3]));i=i;return}function Ru(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23696>>3]=+h[b+24312>>3]*.8660254037844387+ +h[b+24320>>3]*-.4999999999999999;i=i;return}function Su(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2880>>3]=+h[b+2832>>3]+(+h[b+23696>>3]*+h[d+7912>>3]+ +h[b+23720>>3]*+h[d+7920>>3]);i=i;return}function Tu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3008>>3]=+h[b+2880>>3]+(+h[d+7528>>3]*.8660254037844387+ +h[d+7536>>3]*-.4999999999999999);i=i;return}function Uu(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23704>>3]=+h[b+24312>>3]*.4999999999999999+ +h[b+24320>>3]*.8660254037844387;i=i;return}function Vu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2888>>3]=+h[b+2840>>3]+(+h[b+23704>>3]*+h[d+7912>>3]+ +h[b+23728>>3]*+h[d+7920>>3]);i=i;return}function Wu(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3016>>3]=+h[b+2888>>3]+(+h[d+7528>>3]*.4999999999999999+ +h[d+7536>>3]*.8660254037844387);i=i;return}function Xu(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+3e3|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14376|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26496>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27168|0);i=b;return}function Yu(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+42080>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+42056>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+42064>>3];h[a+8>>3]=+h[d+371024>>3];h[e+8>>3]=+h[d+371e3>>3];h[f+8>>3]=+h[d+371008>>3];h[a+16>>3]=+h[d+370800>>3];h[e+16>>3]=+h[d+370776>>3];h[f+16>>3]=+h[d+370784>>3];i=i;return}function Zu(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+3e3>>3]=+h[b>>3];h[a+26496>>3]=+h[b+8>>3];h[a+26480>>3]=+h[b+16>>3];Lu(f);Mu(f);Nu(f);Ou(f);Pu(f);Qu(f);Ru(f);Su(f);Tu(f);Uu(f);Vu(f);Wu(f);Xu(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27168>>3];h[d+8>>3]=+h[f+27176>>3];h[d+16>>3]=+h[f+27184>>3];i=e;return}function _u(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24544>>3]=-+Y(+(+h[b+26368>>3]));i=i;return}function $u(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24528>>3]=+Y(+(+h[b+26368>>3]));i=i;return}function av(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24552>>3]=+X(+(+h[b+26368>>3]));i=i;return}function bv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23608>>3]=+h[b+24544>>3]*-.4999999999999999+ +h[b+24552>>3]*.8660254037844387;i=i;return}function cv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23600>>3]=+h[b+24544>>3]*.8660254037844387+ +h[b+24552>>3]*.4999999999999999;i=i;return}function dv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24520>>3]=+X(+(+h[b+26368>>3]));i=i;return}function ev(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23584>>3]=+h[b+24520>>3]*-.4999999999999999+ +h[b+24528>>3]*.8660254037844387;i=i;return}function fv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23576>>3]=+h[b+24520>>3]*.8660254037844387+ +h[b+24528>>3]*.4999999999999999;i=i;return}function gv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2272>>3]=+h[b+2224>>3]+(+h[b+23576>>3]*+h[d+14320>>3]+ +h[b+23600>>3]*+h[d+14328>>3]);i=i;return}function hv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2400>>3]=+h[b+2272>>3]+(+h[d+13936>>3]*.8660254037844387+ +h[d+13944>>3]*.4999999999999999);i=i;return}function iv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2280>>3]=+h[b+2232>>3]+(+h[b+23584>>3]*+h[d+14320>>3]+ +h[b+23608>>3]*+h[d+14328>>3]);i=i;return}function jv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2408>>3]=+h[b+2280>>3]+(+h[d+13936>>3]*-.4999999999999999+ +h[d+13944>>3]*.8660254037844387);i=i;return}function kv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+2392|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14424|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26384>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*-.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27144|0);i=b;return}function lv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+33568>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+33544>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+33552>>3];h[a+8>>3]=+h[d+369456>>3];h[e+8>>3]=+h[d+369432>>3];h[f+8>>3]=+h[d+369440>>3];h[a+16>>3]=+h[d+369232>>3];h[e+16>>3]=+h[d+369208>>3];h[f+16>>3]=+h[d+369216>>3];i=i;return}function mv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+2392>>3]=+h[b>>3];h[a+26384>>3]=+h[b+8>>3];h[a+26368>>3]=+h[b+16>>3];_u(f);$u(f);av(f);bv(f);cv(f);dv(f);ev(f);fv(f);gv(f);hv(f);iv(f);jv(f);kv(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27144>>3];h[d+8>>3]=+h[f+27152>>3];h[d+16>>3]=+h[f+27160>>3];i=e;return}function nv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24752>>3]=-+Y(+(+h[b+26256>>3]));i=i;return}function ov(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24736>>3]=+Y(+(+h[b+26256>>3]));i=i;return}function pv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24760>>3]=+X(+(+h[b+26256>>3]));i=i;return}function qv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23480>>3]=+h[b+24752>>3]*.8660254037844387+ +h[b+24760>>3]*-.4999999999999999;i=i;return}function rv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23488>>3]=+h[b+24752>>3]*.4999999999999999+ +h[b+24760>>3]*.8660254037844387;i=i;return}function sv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24728>>3]=+X(+(+h[b+26256>>3]));i=i;return}function tv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23456>>3]=+h[b+24728>>3]*.8660254037844387+ +h[b+24736>>3]*-.4999999999999999;i=i;return}function uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23464>>3]=+h[b+24728>>3]*.4999999999999999+ +h[b+24736>>3]*.8660254037844387;i=i;return}function vv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1656>>3]=+h[b+1608>>3]+(+h[b+23464>>3]*+h[d+20728>>3]+ +h[b+23488>>3]*+h[d+20736>>3]);i=i;return}function wv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1784>>3]=+h[b+1656>>3]+(+h[d+20344>>3]*.4999999999999999+ +h[d+20352>>3]*.8660254037844387);i=i;return}function xv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1600>>3]+(+h[b+23456>>3]*+h[d+20728>>3]+ +h[b+23480>>3]*+h[d+20736>>3]);i=i;return}function yv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1776>>3]=+h[b+1648>>3]+(+h[d+20344>>3]*.8660254037844387+ +h[d+20352>>3]*-.4999999999999999);i=i;return}function zv(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+1768|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14472|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26272>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27120|0);i=b;return}function Av(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+24832>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+24808>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+24816>>3];h[a+8>>3]=+h[d+367888>>3];h[e+8>>3]=+h[d+367864>>3];h[f+8>>3]=+h[d+367872>>3];h[a+16>>3]=+h[d+367664>>3];h[e+16>>3]=+h[d+367640>>3];h[f+16>>3]=+h[d+367648>>3];i=i;return}function Bv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1768>>3]=+h[b>>3];h[a+26272>>3]=+h[b+8>>3];h[a+26256>>3]=+h[b+16>>3];nv(f);ov(f);pv(f);qv(f);rv(f);sv(f);tv(f);uv(f);vv(f);wv(f);xv(f);yv(f);zv(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27120>>3];h[d+8>>3]=+h[f+27128>>3];h[d+16>>3]=+h[f+27136>>3];i=e;return}function Cv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24960>>3]=-+Y(+(+h[b+26144>>3]));i=i;return}function Dv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24944>>3]=+Y(+(+h[b+26144>>3]));i=i;return}function Ev(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24968>>3]=+X(+(+h[b+26144>>3]));i=i;return}function Fv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23368>>3]=+h[b+24960>>3]*-.4999999999999999+ +h[b+24968>>3]*.8660254037844387;i=i;return}function Gv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23360>>3]=+h[b+24960>>3]*.8660254037844387+ +h[b+24968>>3]*.4999999999999999;i=i;return}function Hv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24936>>3]=+X(+(+h[b+26144>>3]));i=i;return}function Iv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23336>>3]=+h[b+24936>>3]*.8660254037844387+ +h[b+24944>>3]*.4999999999999999;i=i;return}function Jv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23344>>3]=+h[b+24936>>3]*-.4999999999999999+ +h[b+24944>>3]*.8660254037844387;i=i;return}function Kv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1032>>3]=+h[b+984>>3]+(+h[b+23344>>3]*+h[d+27136>>3]+ +h[b+23368>>3]*+h[d+27144>>3]);i=i;return}function Lv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1160>>3]=+h[b+1032>>3]+(+h[d+26752>>3]*-.4999999999999999+ +h[d+26760>>3]*.8660254037844387);i=i;return}function Mv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1024>>3]=+h[b+976>>3]+(+h[b+23336>>3]*+h[d+27136>>3]+ +h[b+23360>>3]*+h[d+27144>>3]);i=i;return}function Nv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1152>>3]=+h[b+1024>>3]+(+h[d+26752>>3]*.8660254037844387+ +h[d+26760>>3]*.4999999999999999);i=i;return}function Ov(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+1144|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14520|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26160>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*-.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27096|0);i=b;return}function Pv(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16096>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16072>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16080>>3];h[a+8>>3]=+h[d+366320>>3];h[e+8>>3]=+h[d+366296>>3];h[f+8>>3]=+h[d+366304>>3];h[a+16>>3]=+h[d+366096>>3];h[e+16>>3]=+h[d+366072>>3];h[f+16>>3]=+h[d+366080>>3];i=i;return}function Qv(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1144>>3]=+h[b>>3];h[a+26160>>3]=+h[b+8>>3];h[a+26144>>3]=+h[b+16>>3];Cv(f);Dv(f);Ev(f);Fv(f);Gv(f);Hv(f);Iv(f);Jv(f);Kv(f);Lv(f);Mv(f);Nv(f);Ov(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27096>>3];h[d+8>>3]=+h[f+27104>>3];h[d+16>>3]=+h[f+27112>>3];i=e;return}function Rv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25168>>3]=-+Y(+(+h[b+26032>>3]));i=i;return}function Sv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25152>>3]=+Y(+(+h[b+26032>>3]));i=i;return}function Tv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25144>>3]=+X(+(+h[b+26032>>3]));i=i;return}function Uv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23216>>3]=+h[b+25144>>3]*.8660254037844387+ +h[b+25152>>3]*-.4999999999999999;i=i;return}function Vv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23224>>3]=+h[b+25144>>3]*.4999999999999999+ +h[b+25152>>3]*.8660254037844387;i=i;return}function Wv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25176>>3]=+X(+(+h[b+26032>>3]));i=i;return}function Xv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23248>>3]=+h[b+25168>>3]*.4999999999999999+ +h[b+25176>>3]*.8660254037844387;i=i;return}function Yv(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23240>>3]=+h[b+25168>>3]*.8660254037844387+ +h[b+25176>>3]*-.4999999999999999;i=i;return}function Zv(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+424>>3]=+h[b+376>>3]+(+h[b+23216>>3]*+h[d+33544>>3]+ +h[b+23240>>3]*+h[d+33552>>3]);i=i;return}function _v(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+528>>3]=+h[b+424>>3]+(+h[d+33160>>3]*.8660254037844387+ +h[d+33168>>3]*-.4999999999999999);i=i;return}function $v(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+432>>3]=+h[b+384>>3]+(+h[b+23224>>3]*+h[d+33544>>3]+ +h[b+23248>>3]*+h[d+33552>>3]);i=i;return}function aw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+536>>3]=+h[b+432>>3]+(+h[d+33160>>3]*.4999999999999999+ +h[d+33168>>3]*.8660254037844387);i=i;return}function bw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+520|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14568|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26048>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27072|0);i=b;return}function cw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7344>>3];h[a+8>>3]=+h[d+364752>>3];h[e+8>>3]=+h[d+364728>>3];h[f+8>>3]=+h[d+364736>>3];h[a+16>>3]=+h[d+364528>>3];h[e+16>>3]=+h[d+364504>>3];h[f+16>>3]=+h[d+364512>>3];i=i;return}function dw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+520>>3]=+h[b>>3];h[a+26048>>3]=+h[b+8>>3];h[a+26032>>3]=+h[b+16>>3];Rv(f);Sv(f);Tv(f);Uv(f);Vv(f);Wv(f);Xv(f);Yv(f);Zv(f);_v(f);$v(f);aw(f);bw(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27072>>3];h[d+8>>3]=+h[f+27080>>3];h[d+16>>3]=+h[f+27088>>3];i=e;return}function ew(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24104>>3]=+X(+(+h[b+26592>>3]));i=i;return}function fw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24112>>3]=+Y(+(+h[b+26592>>3]));i=i;return}function gw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23840>>3]=+h[b+24104>>3]*.8660254037844387+ +h[b+24112>>3]*.4999999999999999;i=i;return}function hw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23848>>3]=+h[b+24104>>3]*-.4999999999999999+ +h[b+24112>>3]*.8660254037844387;i=i;return}function iw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24128>>3]=-+Y(+(+h[b+26592>>3]));i=i;return}function jw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24136>>3]=+X(+(+h[b+26592>>3]));i=i;return}function kw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23864>>3]=+h[b+24128>>3]*.8660254037844387+ +h[b+24136>>3]*.4999999999999999;i=i;return}function lw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23872>>3]=+h[b+24128>>3]*-.4999999999999999+ +h[b+24136>>3]*.8660254037844387;i=i;return}function mw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3464>>3]=+h[b+3416>>3]+(+h[b+23848>>3]*+h[d+1504>>3]+ +h[b+23872>>3]*+h[d+1512>>3]);i=i;return}function nw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3608>>3]=+h[b+3464>>3]+(+h[d+1120>>3]*-.4999999999999999+ +h[d+1128>>3]*.8660254037844387);i=i;return}function ow(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3456>>3]=+h[b+3408>>3]+(+h[b+23840>>3]*+h[d+1504>>3]+ +h[b+23864>>3]*+h[d+1512>>3]);i=i;return}function pw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3600>>3]=+h[b+3456>>3]+(+h[d+1120>>3]*.8660254037844387+ +h[d+1128>>3]*.4999999999999999);i=i;return}function qw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+3592|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14352|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26608>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*-.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27048|0);i=b;return}function rw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+50368>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+50344>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+50352>>3];h[a+8>>3]=+h[d+372592>>3];h[e+8>>3]=+h[d+372568>>3];h[f+8>>3]=+h[d+372576>>3];h[a+16>>3]=+h[d+372368>>3];h[e+16>>3]=+h[d+372344>>3];h[f+16>>3]=+h[d+372352>>3];i=i;return}function sw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+3592>>3]=+h[b>>3];h[a+26608>>3]=+h[b+8>>3];h[a+26592>>3]=+h[b+16>>3];ew(f);fw(f);gw(f);hw(f);iw(f);jw(f);kw(f);lw(f);mw(f);nw(f);ow(f);pw(f);qw(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27048>>3];h[d+8>>3]=+h[f+27056>>3];h[d+16>>3]=+h[f+27064>>3];i=e;return}function tw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24312>>3]=+X(+(+h[b+26480>>3]));i=i;return}function uw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24320>>3]=+Y(+(+h[b+26480>>3]));i=i;return}function vw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23704>>3]=+h[b+24312>>3]*.4999999999999999+ +h[b+24320>>3]*.8660254037844387;i=i;return}function ww(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23696>>3]=+h[b+24312>>3]*.8660254037844387+ +h[b+24320>>3]*-.4999999999999999;i=i;return}function xw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24336>>3]=-+Y(+(+h[b+26480>>3]));i=i;return}function yw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24344>>3]=+X(+(+h[b+26480>>3]));i=i;return}function zw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23720>>3]=+h[b+24336>>3]*.8660254037844387+ +h[b+24344>>3]*-.4999999999999999;i=i;return}function Aw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23728>>3]=+h[b+24336>>3]*.4999999999999999+ +h[b+24344>>3]*.8660254037844387;i=i;return}function Bw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2888>>3]=+h[b+2840>>3]+(+h[b+23704>>3]*+h[d+7912>>3]+ +h[b+23728>>3]*+h[d+7920>>3]);i=i;return}function Cw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3016>>3]=+h[b+2888>>3]+(+h[d+7528>>3]*.4999999999999999+ +h[d+7536>>3]*.8660254037844387);i=i;return}function Dw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2880>>3]=+h[b+2832>>3]+(+h[b+23696>>3]*+h[d+7912>>3]+ +h[b+23720>>3]*+h[d+7920>>3]);i=i;return}function Ew(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+3008>>3]=+h[b+2880>>3]+(+h[d+7528>>3]*.8660254037844387+ +h[d+7536>>3]*-.4999999999999999);i=i;return}function Fw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+3e3|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14376|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26496>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27024|0);i=b;return}function Gw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+42080>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+42056>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+42064>>3];h[a+8>>3]=+h[d+371024>>3];h[e+8>>3]=+h[d+371e3>>3];h[f+8>>3]=+h[d+371008>>3];h[a+16>>3]=+h[d+370800>>3];h[e+16>>3]=+h[d+370776>>3];h[f+16>>3]=+h[d+370784>>3];i=i;return}function Hw(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+3e3>>3]=+h[b>>3];h[a+26496>>3]=+h[b+8>>3];h[a+26480>>3]=+h[b+16>>3];tw(f);uw(f);vw(f);ww(f);xw(f);yw(f);zw(f);Aw(f);Bw(f);Cw(f);Dw(f);Ew(f);Fw(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27024>>3];h[d+8>>3]=+h[f+27032>>3];h[d+16>>3]=+h[f+27040>>3];i=e;return}function Iw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24552>>3]=+X(+(+h[b+26368>>3]));i=i;return}function Jw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24528>>3]=+Y(+(+h[b+26368>>3]));i=i;return}function Kw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24544>>3]=-+Y(+(+h[b+26368>>3]));i=i;return}function Lw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23600>>3]=+h[b+24544>>3]*.8660254037844387+ +h[b+24552>>3]*.4999999999999999;i=i;return}function Mw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23608>>3]=+h[b+24544>>3]*-.4999999999999999+ +h[b+24552>>3]*.8660254037844387;i=i;return}function Nw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24520>>3]=+X(+(+h[b+26368>>3]));i=i;return}function Ow(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23576>>3]=+h[b+24520>>3]*.8660254037844387+ +h[b+24528>>3]*.4999999999999999;i=i;return}function Pw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2272>>3]=+h[b+2224>>3]+(+h[b+23576>>3]*+h[d+14320>>3]+ +h[b+23600>>3]*+h[d+14328>>3]);i=i;return}function Qw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2400>>3]=+h[b+2272>>3]+(+h[d+13936>>3]*.8660254037844387+ +h[d+13944>>3]*.4999999999999999);i=i;return}function Rw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23584>>3]=+h[b+24520>>3]*-.4999999999999999+ +h[b+24528>>3]*.8660254037844387;i=i;return}function Sw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2280>>3]=+h[b+2232>>3]+(+h[b+23584>>3]*+h[d+14320>>3]+ +h[b+23608>>3]*+h[d+14328>>3]);i=i;return}function Tw(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+2408>>3]=+h[b+2280>>3]+(+h[d+13936>>3]*-.4999999999999999+ +h[d+13944>>3]*.8660254037844387);i=i;return}function Uw(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+2392|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14424|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26384>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*-.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+27e3|0);i=b;return}function Vw(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+33568>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+33544>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+33552>>3];h[a+8>>3]=+h[d+369456>>3];h[e+8>>3]=+h[d+369432>>3];h[f+8>>3]=+h[d+369440>>3];h[a+16>>3]=+h[d+369232>>3];h[e+16>>3]=+h[d+369208>>3];h[f+16>>3]=+h[d+369216>>3];i=i;return}function Ww(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+2392>>3]=+h[b>>3];h[a+26384>>3]=+h[b+8>>3];h[a+26368>>3]=+h[b+16>>3];Iw(f);Jw(f);Kw(f);Lw(f);Mw(f);Nw(f);Ow(f);Pw(f);Qw(f);Rw(f);Sw(f);Tw(f);Uw(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+27e3>>3];h[d+8>>3]=+h[f+27008>>3];h[d+16>>3]=+h[f+27016>>3];i=e;return}function Xw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24760>>3]=+X(+(+h[b+26256>>3]));i=i;return}function Yw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24736>>3]=+Y(+(+h[b+26256>>3]));i=i;return}function Zw(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24752>>3]=-+Y(+(+h[b+26256>>3]));i=i;return}function _w(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23488>>3]=+h[b+24752>>3]*.4999999999999999+ +h[b+24760>>3]*.8660254037844387;i=i;return}function $w(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23480>>3]=+h[b+24752>>3]*.8660254037844387+ +h[b+24760>>3]*-.4999999999999999;i=i;return}function ax(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24728>>3]=+X(+(+h[b+26256>>3]));i=i;return}function bx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23456>>3]=+h[b+24728>>3]*.8660254037844387+ +h[b+24736>>3]*-.4999999999999999;i=i;return}function cx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23464>>3]=+h[b+24728>>3]*.4999999999999999+ +h[b+24736>>3]*.8660254037844387;i=i;return}function dx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1656>>3]=+h[b+1608>>3]+(+h[b+23464>>3]*+h[d+20728>>3]+ +h[b+23488>>3]*+h[d+20736>>3]);i=i;return}function ex(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1784>>3]=+h[b+1656>>3]+(+h[d+20344>>3]*.4999999999999999+ +h[d+20352>>3]*.8660254037844387);i=i;return}function fx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1648>>3]=+h[b+1600>>3]+(+h[b+23456>>3]*+h[d+20728>>3]+ +h[b+23480>>3]*+h[d+20736>>3]);i=i;return}function gx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1776>>3]=+h[b+1648>>3]+(+h[d+20344>>3]*.8660254037844387+ +h[d+20352>>3]*-.4999999999999999);i=i;return}function hx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+1768|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14472|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26272>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26976|0);i=b;return}function ix(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+24832>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+24808>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+24816>>3];h[a+8>>3]=+h[d+367888>>3];h[e+8>>3]=+h[d+367864>>3];h[f+8>>3]=+h[d+367872>>3];h[a+16>>3]=+h[d+367664>>3];h[e+16>>3]=+h[d+367640>>3];h[f+16>>3]=+h[d+367648>>3];i=i;return}function jx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1768>>3]=+h[b>>3];h[a+26272>>3]=+h[b+8>>3];h[a+26256>>3]=+h[b+16>>3];Xw(f);Yw(f);Zw(f);_w(f);$w(f);ax(f);bx(f);cx(f);dx(f);ex(f);fx(f);gx(f);hx(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+26976>>3];h[d+8>>3]=+h[f+26984>>3];h[d+16>>3]=+h[f+26992>>3];i=e;return}function kx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24936>>3]=+X(+(+h[b+26144>>3]));i=i;return}function lx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24944>>3]=+Y(+(+h[b+26144>>3]));i=i;return}function mx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23344>>3]=+h[b+24936>>3]*-.4999999999999999+ +h[b+24944>>3]*.8660254037844387;i=i;return}function nx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23336>>3]=+h[b+24936>>3]*.8660254037844387+ +h[b+24944>>3]*.4999999999999999;i=i;return}function ox(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24960>>3]=-+Y(+(+h[b+26144>>3]));i=i;return}function px(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+24968>>3]=+X(+(+h[b+26144>>3]));i=i;return}function qx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23360>>3]=+h[b+24960>>3]*.8660254037844387+ +h[b+24968>>3]*.4999999999999999;i=i;return}function rx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23368>>3]=+h[b+24960>>3]*-.4999999999999999+ +h[b+24968>>3]*.8660254037844387;i=i;return}function sx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1032>>3]=+h[b+984>>3]+(+h[b+23344>>3]*+h[d+27136>>3]+ +h[b+23368>>3]*+h[d+27144>>3]);i=i;return}function tx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1160>>3]=+h[b+1032>>3]+(+h[d+26752>>3]*-.4999999999999999+ +h[d+26760>>3]*.8660254037844387);i=i;return}function ux(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1024>>3]=+h[b+976>>3]+(+h[b+23336>>3]*+h[d+27136>>3]+ +h[b+23360>>3]*+h[d+27144>>3]);i=i;return}function vx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+1152>>3]=+h[b+1024>>3]+(+h[d+26752>>3]*.8660254037844387+ +h[d+26760>>3]*.4999999999999999);i=i;return}function wx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+1144|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14520|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26160>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*-.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26952|0);i=b;return}function xx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+16096>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+16072>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+16080>>3];h[a+8>>3]=+h[d+366320>>3];h[e+8>>3]=+h[d+366296>>3];h[f+8>>3]=+h[d+366304>>3];h[a+16>>3]=+h[d+366096>>3];h[e+16>>3]=+h[d+366072>>3];h[f+16>>3]=+h[d+366080>>3];i=i;return}function yx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+1144>>3]=+h[b>>3];h[a+26160>>3]=+h[b+8>>3];h[a+26144>>3]=+h[b+16>>3];kx(f);lx(f);mx(f);nx(f);ox(f);px(f);qx(f);rx(f);sx(f);tx(f);ux(f);vx(f);wx(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+26952>>3];h[d+8>>3]=+h[f+26960>>3];h[d+16>>3]=+h[f+26968>>3];i=e;return}function zx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25144>>3]=+X(+(+h[b+26032>>3]));i=i;return}function Ax(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25152>>3]=+Y(+(+h[b+26032>>3]));i=i;return}function Bx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23224>>3]=+h[b+25144>>3]*.4999999999999999+ +h[b+25152>>3]*.8660254037844387;i=i;return}function Cx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23216>>3]=+h[b+25144>>3]*.8660254037844387+ +h[b+25152>>3]*-.4999999999999999;i=i;return}function Dx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25168>>3]=-+Y(+(+h[b+26032>>3]));i=i;return}function Ex(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+25176>>3]=+X(+(+h[b+26032>>3]));i=i;return}function Fx(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23240>>3]=+h[b+25168>>3]*.8660254037844387+ +h[b+25176>>3]*-.4999999999999999;i=i;return}function Gx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+424>>3]=+h[b+376>>3]+(+h[b+23216>>3]*+h[d+33544>>3]+ +h[b+23240>>3]*+h[d+33552>>3]);i=i;return}function Hx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+528>>3]=+h[b+424>>3]+(+h[d+33160>>3]*.8660254037844387+ +h[d+33168>>3]*-.4999999999999999);i=i;return}function Ix(a){a=a|0;var b=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;h[b+23248>>3]=+h[b+25168>>3]*.4999999999999999+ +h[b+25176>>3]*.8660254037844387;i=i;return}function Jx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+432>>3]=+h[b+384>>3]+(+h[b+23224>>3]*+h[d+33544>>3]+ +h[b+23248>>3]*+h[d+33552>>3]);i=i;return}function Kx(a){a=a|0;var b=0,d=0;b=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;d=c[a+416>>2]|0;h[b+536>>3]=+h[b+432>>3]+(+h[d+33160>>3]*.4999999999999999+ +h[d+33168>>3]*.8660254037844387);i=i;return}function Lx(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0,o=0,p=0,q=0.0;b=i;i=i+16|0;d=b;e=i;i=i+8|0;f=i;i=i+8|0;g=i;i=i+16|0;j=i;i=i+16|0;l=i;i=i+16|0;m=i;i=i+16|0;n=i;i=i+16|0;o=i;i=i+16|0;p=a+4|0;a=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+520|0;c[f>>2]=3;uCc(g,a,1,f);f=(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+14568|0;c[e>>2]=3;uCc(j,f,1,e);ICc(j,l);q=+h[(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26048>>3];j=d;h[k>>3]=q*.8660254037844387;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];j=d+8|0;h[k>>3]=q*.4999999999999999;c[j>>2]=c[k>>2];c[j+4>>2]=c[k+4>>2];DCc(m,3,0.0,d);GCc(l,m,n);GCc(g,n,o);ACc(o,(c[(c[c[p>>2]>>2]|0)+8>>2]|0)+26928|0);i=b;return}function Mx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[a+8>>2]|0;a=c[b+16>>2]|0;h[a>>3]=+h[d+7360>>3];e=c[b+8>>2]|0;h[e>>3]=+h[d+7336>>3];f=c[b+12>>2]|0;h[f>>3]=+h[d+7344>>3];h[a+8>>3]=+h[d+364752>>3];h[e+8>>3]=+h[d+364728>>3];h[f+8>>3]=+h[d+364736>>3];h[a+16>>3]=+h[d+364528>>3];h[e+16>>3]=+h[d+364504>>3];h[f+16>>3]=+h[d+364512>>3];i=i;return}function Nx(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0;e=i;f=a;g=a+4|0;a=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[a+520>>3]=+h[b>>3];h[a+26048>>3]=+h[b+8>>3];h[a+26032>>3]=+h[b+16>>3];zx(f);Ax(f);Bx(f);Cx(f);Dx(f);Ex(f);Fx(f);Gx(f);Hx(f);Ix(f);Jx(f);Kx(f);Lx(f);f=c[(c[c[g>>2]>>2]|0)+8>>2]|0;h[d>>3]=+h[f+26928>>3];h[d+8>>3]=+h[f+26936>>3];h[d+16>>3]=+h[f+26944>>3];i=e;return}function Ox(a){a=a|0;c[a+4>>2]=511;c[a>>2]=3;c[a+56>>2]=0;c[a+32>>2]=19;c[a+20>>2]=0;c[a+24>>2]=0;c[a+28>>2]=-1;c[a+36>>2]=43;c[a+84>>2]=549;c[a+80>>2]=3;c[a+136>>2]=0;c[a+112>>2]=20;c[a+100>>2]=0;c[a+104>>2]=0;c[a+108>>2]=-1;c[a+116>>2]=44;c[a+164>>2]=587;c[a+160>>2]=3;c[a+216>>2]=0;c[a+192>>2]=21;c[a+180>>2]=0;c[a+184>>2]=0;c[a+188>>2]=-1;c[a+196>>2]=45;c[a+244>>2]=625;c[a+240>>2]=3;c[a+296>>2]=0;c[a+272>>2]=22;c[a+260>>2]=0;c[a+264>>2]=0;c[a+268>>2]=-1;c[a+276>>2]=46;c[a+324>>2]=663;c[a+320>>2]=3;c[a+376>>2]=0;c[a+352>>2]=23;c[a+340>>2]=0;c[a+344>>2]=0;c[a+348>>2]=-1;c[a+356>>2]=47;c[a+404>>2]=701;c[a+400>>2]=3;c[a+456>>2]=0;c[a+432>>2]=24;c[a+420>>2]=0;c[a+424>>2]=0;c[a+428>>2]=-1;c[a+436>>2]=48;c[a+484>>2]=4892;c[a+480>>2]=3;c[a+536>>2]=0;c[a+512>>2]=25;c[a+500>>2]=0;c[a+504>>2]=0;c[a+508>>2]=-1;c[a+516>>2]=49;c[a+564>>2]=4954;c[a+560>>2]=3;c[a+616>>2]=0;c[a+592>>2]=26;c[a+580>>2]=0;c[a+584>>2]=0;c[a+588>>2]=-1;c[a+596>>2]=50;c[a+644>>2]=5016;c[a+640>>2]=3;c[a+696>>2]=0;c[a+672>>2]=27;c[a+660>>2]=0;c[a+664>>2]=0;c[a+668>>2]=-1;c[a+676>>2]=51;c[a+724>>2]=5078;c[a+720>>2]=3;c[a+776>>2]=0;c[a+752>>2]=28;c[a+740>>2]=0;c[a+744>>2]=0;c[a+748>>2]=-1;c[a+756>>2]=52;c[a+804>>2]=5140;c[a+800>>2]=3;c[a+856>>2]=0;c[a+832>>2]=29;c[a+820>>2]=0;c[a+824>>2]=0;c[a+828>>2]=-1;c[a+836>>2]=53;c[a+884>>2]=5199;c[a+880>>2]=3;c[a+936>>2]=0;c[a+912>>2]=30;c[a+900>>2]=0;c[a+904>>2]=0;c[a+908>>2]=-1;c[a+916>>2]=54;i=i;return}function Px(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23024>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23032>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23040>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23048>>3],3,b);i=d;return}function Qx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+14768|0;e=d+14776|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+23024>>3]*+h[e>>3])- +h[d+23032>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+23040>>3]*+h[e>>3])- +h[d+23048>>3]*+h[a>>3];i=i;return}function Rx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13728>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13720>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13744>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13736>>3],3,b);i=d;return}function Sx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+13488|0;e=d+13496|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+13720>>3]*+h[e>>3])- +h[d+13728>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+13736>>3]*+h[e>>3])- +h[d+13744>>3]*+h[a>>3];i=i;return}function Tx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13080>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13072>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13096>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13088>>3],3,b);i=d;return}function Ux(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+12840|0;e=d+12848|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+13072>>3]*+h[e>>3])- +h[d+13080>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+13088>>3]*+h[e>>3])- +h[d+13096>>3]*+h[a>>3];i=i;return}function Vx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12424>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12432>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12440>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12448>>3],3,b);i=d;return}function Wx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+12192|0;e=d+12200|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+12424>>3]*+h[e>>3])- +h[d+12432>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+12440>>3]*+h[e>>3])- +h[d+12448>>3]*+h[a>>3];i=i;return}function Xx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11776>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11784>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11792>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11800>>3],3,b);i=d;return}function Yx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11544|0;e=d+11552|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+11776>>3]*+h[e>>3])- +h[d+11784>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+11792>>3]*+h[e>>3])- +h[d+11800>>3]*+h[a>>3];i=i;return}function Zx(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11208>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11200>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11224>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11216>>3],3,b);i=d;return}function _x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11016|0;e=d+11024|0;f=c[b+36>>2]|0;h[f>>3]=-(+h[d+11200>>3]*+h[e>>3])- +h[d+11208>>3]*+h[a>>3];h[f+8>>3]=-(+h[d+11216>>3]*+h[e>>3])- +h[d+11224>>3]*+h[a>>3];i=i;return}function $x(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11208>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11200>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11224>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11216>>3],3,b);i=d;return}function ay(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11208|0;e=d+11136|0;f=d+11200|0;g=d+11144|0;j=d+16|0;k=d+11224|0;l=d+376|0;m=d+11016|0;n=d+11216|0;o=d+384|0;p=d+11024|0;d=c[b+36>>2]|0;h[d>>3]=-(+h[f>>3]*+h[g>>3])- +h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[a>>3]*+h[e>>3];h[d+8>>3]=+h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[n>>3]*+h[g>>3]- +h[k>>3]*+h[e>>3];i=i;return}function by(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,3,+h[g+23216>>3]*+h[a+33552>>3]- +h[g+23240>>3]*+h[a+33544>>3],1,b);se[c[e>>2]&3](1,2,1.0,2,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](1,3,+h[a+23224>>3]*+h[f+33552>>3]- +h[a+23248>>3]*+h[f+33544>>3],3,b);se[c[e>>2]&3](2,1,-.4999999999999999,4,b);se[c[e>>2]&3](2,2,1.0,5,b);se[c[e>>2]&3](3,0,1.0,6,b);se[c[e>>2]&3](3,1,-.8660254037844387,7,b);i=d;return}function cy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+10936>>3];h[a+8>>3]=+h[e+10944>>3];e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function dy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11776>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11784>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11792>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+11800>>3],3,b);i=d;return}function ey(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+11784|0;e=d+11712|0;f=d+11776|0;g=d+11720|0;j=d+16|0;k=d+11800|0;l=d+976|0;m=d+11544|0;n=d+11792|0;o=d+984|0;p=d+11552|0;d=c[b+36>>2]|0;h[d>>3]=-(+h[f>>3]*+h[g>>3])- +h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[a>>3]*+h[e>>3];h[d+8>>3]=+h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[n>>3]*+h[g>>3]- +h[k>>3]*+h[e>>3];i=i;return}function fy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,0,+h[g+23344>>3]*+h[a+27144>>3]- +h[g+23368>>3]*+h[a+27136>>3],0,b);se[c[e>>2]&3](0,3,1.0,1,b);se[c[e>>2]&3](1,2,.4999999999999999,2,b);se[c[e>>2]&3](1,3,1.0,3,b);se[c[e>>2]&3](2,1,1.0,4,b);se[c[e>>2]&3](2,2,-.8660254037844387,5,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](3,0,+h[a+23336>>3]*+h[f+27144>>3]- +h[a+23360>>3]*+h[f+27136>>3],6,b);se[c[e>>2]&3](3,1,1.0,7,b);i=d;return}function gy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+11448>>3];b=e+11440|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;h[a+24>>3]=+h[b>>3];i=d;return}function hy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12424>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12432>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12440>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+12448>>3],3,b);i=d;return}function iy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+12432|0;e=d+12360|0;f=d+12424|0;g=d+12368|0;j=d+16|0;k=d+12448|0;l=d+1600|0;m=d+12192|0;n=d+12440|0;o=d+1608|0;p=d+12200|0;d=c[b+36>>2]|0;h[d>>3]=-(+h[f>>3]*+h[g>>3])- +h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[a>>3]*+h[e>>3];h[d+8>>3]=+h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[n>>3]*+h[g>>3]- +h[k>>3]*+h[e>>3];i=i;return}function jy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,3,+h[g+23464>>3]*+h[a+20736>>3]- +h[g+23488>>3]*+h[a+20728>>3],1,b);se[c[e>>2]&3](1,2,1.0,2,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](1,3,+h[a+23456>>3]*+h[f+20736>>3]- +h[a+23480>>3]*+h[f+20728>>3],3,b);se[c[e>>2]&3](2,1,-.8660254037844387,4,b);se[c[e>>2]&3](2,2,1.0,5,b);se[c[e>>2]&3](3,0,1.0,6,b);se[c[e>>2]&3](3,1,-.4999999999999999,7,b);i=d;return}function ky(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+12096>>3];h[a+8>>3]=+h[e+12088>>3];e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function ly(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13072>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13080>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13088>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13096>>3],3,b);i=d;return}function my(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+13080|0;e=d+13008|0;f=d+13072|0;g=d+13016|0;j=d+16|0;k=d+13096|0;l=d+2224|0;m=d+12840|0;n=d+13088|0;o=d+2232|0;p=d+12848|0;d=c[b+36>>2]|0;h[d>>3]=-(+h[f>>3]*+h[g>>3])- +h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[a>>3]*+h[e>>3];h[d+8>>3]=+h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[n>>3]*+h[g>>3]- +h[k>>3]*+h[e>>3];i=i;return}function ny(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,0,+h[g+23584>>3]*+h[a+14328>>3]- +h[g+23608>>3]*+h[a+14320>>3],0,b);se[c[e>>2]&3](0,3,1.0,1,b);se[c[e>>2]&3](1,2,.4999999999999999,2,b);se[c[e>>2]&3](1,3,1.0,3,b);se[c[e>>2]&3](2,1,1.0,4,b);se[c[e>>2]&3](2,2,-.8660254037844387,5,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](3,0,+h[a+23576>>3]*+h[f+14328>>3]- +h[a+23600>>3]*+h[f+14320>>3],6,b);se[c[e>>2]&3](3,1,1.0,7,b);i=d;return}function oy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+12744>>3];b=e+12736|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;h[a+24>>3]=+h[b>>3];i=d;return}function py(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13728>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13720>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13744>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+13736>>3],3,b);i=d;return}function qy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+13728|0;e=d+13656|0;f=d+13720|0;g=d+13664|0;j=d+16|0;k=d+13744|0;l=d+2832|0;m=d+13488|0;n=d+13736|0;o=d+2840|0;p=d+13496|0;d=c[b+36>>2]|0;h[d>>3]=-(+h[f>>3]*+h[g>>3])- +h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[a>>3]*+h[e>>3];h[d+8>>3]=+h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[n>>3]*+h[g>>3]- +h[k>>3]*+h[e>>3];i=i;return}function ry(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;se[c[e>>2]&3](0,0,1.0,0,b);f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,3,+h[g+23696>>3]*+h[a+7920>>3]- +h[g+23720>>3]*+h[a+7912>>3],1,b);se[c[e>>2]&3](1,2,1.0,2,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](1,3,+h[a+23704>>3]*+h[f+7920>>3]- +h[a+23728>>3]*+h[f+7912>>3],3,b);se[c[e>>2]&3](2,1,-.4999999999999999,4,b);se[c[e>>2]&3](2,2,1.0,5,b);se[c[e>>2]&3](3,0,1.0,6,b);se[c[e>>2]&3](3,1,-.8660254037844387,7,b);i=d;return}function sy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+13384>>3];h[a+8>>3]=+h[e+13392>>3];e=a+16|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;i=d;return}function ty(a,b){a=a|0;b=b|0;var d=0,e=0,f=0;d=i;e=b+8|0;f=a+4|0;se[c[e>>2]&3](0,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23032>>3],0,b);se[c[e>>2]&3](0,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23024>>3],1,b);se[c[e>>2]&3](1,0,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23048>>3],2,b);se[c[e>>2]&3](1,1,-+h[(c[(c[c[f>>2]>>2]|0)+8>>2]|0)+23040>>3],3,b);i=d;return}function uy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0;d=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=d+23032|0;e=d+14160|0;f=d+23024|0;g=d+14168|0;j=d+16|0;k=d+23048|0;l=d+3408|0;m=d+14768|0;n=d+23040|0;o=d+3416|0;p=d+14776|0;d=c[b+36>>2]|0;h[d>>3]=-(+h[f>>3]*+h[g>>3])- +h[j>>3]*(+h[k>>3]*(+h[l>>3]- +h[m>>3])+ +h[n>>3]*(+h[o>>3]- +h[p>>3]))- +h[a>>3]*+h[e>>3];h[d+8>>3]=+h[j>>3]*(+h[a>>3]*(+h[l>>3]- +h[m>>3])+ +h[f>>3]*(+h[o>>3]- +h[p>>3]))- +h[n>>3]*+h[g>>3]- +h[k>>3]*+h[e>>3];i=i;return}function vy(a,b){a=a|0;b=b|0;var d=0,e=0,f=0,g=0,j=0;d=i;e=b+8|0;f=a+4|0;g=c[(c[c[f>>2]>>2]|0)+8>>2]|0;j=a+416|0;a=c[j>>2]|0;se[c[e>>2]&3](0,0,+h[g+23840>>3]*+h[a+1512>>3]- +h[g+23864>>3]*+h[a+1504>>3],0,b);se[c[e>>2]&3](0,3,1.0,1,b);se[c[e>>2]&3](1,2,-.8660254037844387,2,b);se[c[e>>2]&3](1,3,1.0,3,b);se[c[e>>2]&3](2,1,1.0,4,b);se[c[e>>2]&3](2,2,.4999999999999999,5,b);a=c[(c[c[f>>2]>>2]|0)+8>>2]|0;f=c[j>>2]|0;se[c[e>>2]&3](3,0,+h[a+23848>>3]*+h[f+1512>>3]- +h[a+23872>>3]*+h[f+1504>>3],6,b);se[c[e>>2]&3](3,1,1.0,7,b);i=d;return}function wy(a,b){a=a|0;b=b|0;var d=0,e=0;d=i;e=c[(c[c[a+4>>2]>>2]|0)+8>>2]|0;a=c[b+36>>2]|0;h[a>>3]=+h[e+14032>>3];b=e+14040|0;e=a+8|0;c[e+0>>2]=0;c[e+4>>2]=0;c[e+8>>2]=0;c[e+12>>2]=0;h[a+24>>3]=+h[b>>3];i=d;return}



function Qsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[253552]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+592>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+592>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(253560,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+592>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[253552]=1;i=d;return}function Rsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[253720]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+588>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+588>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(253728,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+588>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[253720]=1;i=d;return}function Ssc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[253888]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+584>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+584>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(253896,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+584>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[253888]=1;i=d;return}function Tsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[254056]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+580>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+580>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(254064,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+580>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[254056]=1;i=d;return}function Usc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[254224]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+576>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+576>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(254232,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+576>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[254224]=1;i=d;return}function Vsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[254392]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+572>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+572>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(254400,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+572>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[254392]=1;i=d;return}function Wsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[254560]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+568>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+568>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(254568,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+568>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[254560]=1;i=d;return}function Xsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[254728]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+564>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+564>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(254736,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+564>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[254728]=1;i=d;return}function Ysc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[254896]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+560>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+560>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(254904,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+560>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[254896]=1;i=d;return}function Zsc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[255064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+556>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+556>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(255072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+556>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[255064]=1;i=d;return}function _sc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[255232]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+552>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+552>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(255240,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+552>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[255232]=1;i=d;return}function $sc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[255400]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+548>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+548>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(255408,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+548>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[255400]=1;i=d;return}function atc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[255568]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+544>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+544>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(255576,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+544>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[255568]=1;i=d;return}function btc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[255736]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+540>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+540>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(255744,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+540>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[255736]=1;i=d;return}function ctc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[255904]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+536>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+536>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(255912,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+536>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[255904]=1;i=d;return}function dtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[256072]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+532>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+532>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(256080,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+532>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[256072]=1;i=d;return}function etc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[256240]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+528>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+528>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(256248,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+528>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[256240]=1;i=d;return}function ftc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[256408]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+524>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+524>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(256416,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+524>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[256408]=1;i=d;return}function gtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[256600]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+520>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+520>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(256608,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+520>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[256600]=1;i=d;return}function htc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[256792]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+516>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+516>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(256800,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+516>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[256792]=1;i=d;return}function itc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[256984]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+512>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+512>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(256992,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+512>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[256984]=1;i=d;return}function jtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[257128]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+508>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+508>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(257136,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+508>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[257128]=1;i=d;return}function ktc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[257272]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+504>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+504>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(257280,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+504>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[257272]=1;i=d;return}function ltc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[257416]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+500>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+500>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(257424,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+500>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[257416]=1;i=d;return}function mtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[257568]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+496>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+496>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(257576,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+496>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[257568]=1;i=d;return}function ntc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[257720]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+492>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+492>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(257728,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+492>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[257720]=1;i=d;return}function otc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[257872]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+488>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+488>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(257880,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+488>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[257872]=1;i=d;return}function ptc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[258056]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+484>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+484>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(258064,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+484>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[258056]=1;i=d;return}function qtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[258240]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+480>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+480>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(258248,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+480>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[258240]=1;i=d;return}function rtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[258424]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+476>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+476>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(258432,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+476>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[258424]=1;i=d;return}function stc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[258576]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+472>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+472>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(258584,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+472>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[258576]=1;i=d;return}function ttc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[258728]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+468>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+468>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(258736,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+468>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[258728]=1;i=d;return}function utc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[258880]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+464>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+464>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(258888,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+464>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[258880]=1;i=d;return}function vtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[259064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+460>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+460>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(259072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+460>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[259064]=1;i=d;return}function wtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[259248]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+456>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+456>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(259256,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+456>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[259248]=1;i=d;return}function xtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[259432]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(259440,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+452>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[259432]=1;i=d;return}function ytc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[259616]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(259624,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+448>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[259616]=1;i=d;return}function ztc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[259800]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(259808,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+444>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[259800]=1;i=d;return}function Atc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[259984]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(259992,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+440>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[259984]=1;i=d;return}function Btc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[260136]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(260144,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+436>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[260136]=1;i=d;return}function Ctc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[260288]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(260296,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+432>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[260288]=1;i=d;return}function Dtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[260440]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(260448,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+428>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[260440]=1;i=d;return}function Etc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[260624]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(260632,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+424>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[260624]=1;i=d;return}function Ftc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[260808]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(260816,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+420>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[260808]=1;i=d;return}function Gtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[260992]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261e3,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+416>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[260992]=1;i=d;return}function Htc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[261144]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261152,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+412>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[261144]=1;i=d;return}function Itc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[261296]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261304,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+408>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[261296]=1;i=d;return}function Jtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[261448]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261456,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+404>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[261448]=1;i=d;return}function Ktc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[261608]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261616,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+400>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[261608]=1;i=d;return}function Ltc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[261768]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261776,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+396>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[261768]=1;i=d;return}function Mtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[261928]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(261936,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+392>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[261928]=1;i=d;return}function Ntc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[262104]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(262112,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+388>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[262104]=1;i=d;return}function Otc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[262280]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(262288,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+384>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[262280]=1;i=d;return}function Ptc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[262456]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(262464,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+380>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[262456]=1;i=d;return}function Qtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[262600]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(262608,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+376>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[262600]=1;i=d;return}function Rtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[262744]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(262752,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+372>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[262744]=1;i=d;return}function Stc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[262888]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(262896,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+368>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[262888]=1;i=d;return}function Ttc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[263040]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(263048,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+364>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[263040]=1;i=d;return}function Utc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[263192]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(263200,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+360>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[263192]=1;i=d;return}function Vtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[263344]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(263352,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+356>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[263344]=1;i=d;return}function Wtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[263528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(263536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+352>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[263528]=1;i=d;return}function Xtc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[263712]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(263720,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+348>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[263712]=1;i=d;return}function Ytc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[263896]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(263904,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+344>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[263896]=1;i=d;return}function Ztc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[264064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(264072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+340>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[264064]=1;i=d;return}function _tc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[264232]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(264240,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+336>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[264232]=1;i=d;return}function $tc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[264400]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(264408,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+332>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[264400]=1;i=d;return}function auc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[264568]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(264576,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+328>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[264568]=1;i=d;return}function buc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[264736]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(264744,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+324>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[264736]=1;i=d;return}function cuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[264904]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(264912,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+320>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[264904]=1;i=d;return}function duc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[265072]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(265080,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+316>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[265072]=1;i=d;return}function euc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[265240]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(265248,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+312>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[265240]=1;i=d;return}function fuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[265408]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(265416,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+308>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[265408]=1;i=d;return}function guc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[265576]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(265584,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+304>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[265576]=1;i=d;return}function huc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[265744]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(265752,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+300>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[265744]=1;i=d;return}function iuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[265912]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(265920,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+296>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[265912]=1;i=d;return}function juc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[266080]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(266088,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+292>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[266080]=1;i=d;return}function kuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[266248]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(266256,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+288>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[266248]=1;i=d;return}function luc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[266416]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(266424,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+284>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[266416]=1;i=d;return}function muc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[266584]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(266592,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+280>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[266584]=1;i=d;return}function nuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[266752]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(266760,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+276>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[266752]=1;i=d;return}function ouc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[266920]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(266928,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+272>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[266920]=1;i=d;return}function puc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[267112]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(267120,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+268>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[267112]=1;i=d;return}function quc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[267304]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(267312,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+264>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=267496;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[267304]=1;i=d;return}function ruc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[267520]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(267528,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+260>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[267520]=1;i=d;return}function suc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[267664]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(267672,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+256>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[267664]=1;i=d;return}function tuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[267808]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(267816,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+252>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[267808]=1;i=d;return}function uuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[267952]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(267960,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+248>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[267952]=1;i=d;return}function vuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[268104]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(268112,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+244>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[268104]=1;i=d;return}function wuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[268256]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(268264,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+240>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[268256]=1;i=d;return}function xuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[268408]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(268416,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+236>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[268408]=1;i=d;return}function yuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[268592]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(268600,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+232>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[268592]=1;i=d;return}function zuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[268776]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(268784,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+228>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[268776]=1;i=d;return}function Auc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[268960]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(268968,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+224>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[268960]=1;i=d;return}function Buc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[269112]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(269120,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+220>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[269112]=1;i=d;return}function Cuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[269264]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(269272,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+216>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[269264]=1;i=d;return}function Duc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[269416]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(269424,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+212>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[269416]=1;i=d;return}function Euc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[269600]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(269608,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+208>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[269600]=1;i=d;return}function Fuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[269784]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(269792,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+204>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[269784]=1;i=d;return}function Guc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[269968]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(269976,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+200>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[269968]=1;i=d;return}function Huc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[270152]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(270160,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+196>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[270152]=1;i=d;return}function Iuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[270336]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(270344,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+192>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[270336]=1;i=d;return}function Juc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[270520]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(270528,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+188>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[270520]=1;i=d;return}function Kuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[270672]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(270680,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+184>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[270672]=1;i=d;return}function Luc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[270824]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(270832,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+180>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[270824]=1;i=d;return}function Muc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[270976]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(270984,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+176>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[270976]=1;i=d;return}function Nuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[271160]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(271168,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+172>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[271160]=1;i=d;return}function Ouc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[271344]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(271352,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+168>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[271344]=1;i=d;return}function Puc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[271528]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(271536,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+164>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[271528]=1;i=d;return}function Quc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[271680]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(271688,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+160>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[271680]=1;i=d;return}function Ruc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[271832]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(271840,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+156>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[271832]=1;i=d;return}function Suc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[271984]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(271992,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+152>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[271984]=1;i=d;return}function Tuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[272144]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(272152,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+148>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[272144]=1;i=d;return}function Uuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[272304]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(272312,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+144>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[272304]=1;i=d;return}function Vuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[272464]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(272472,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+140>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[272464]=1;i=d;return}function Wuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[272640]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(272648,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+136>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[272640]=1;i=d;return}function Xuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[272816]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(272824,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+132>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[272816]=1;i=d;return}function Yuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[272992]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273e3,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+128>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[272992]=1;i=d;return}function Zuc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[273136]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273144,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+124>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[273136]=1;i=d;return}function _uc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[273280]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273288,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+120>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273424;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[273280]=1;i=d;return}function $uc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[273448]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273456,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+116>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[273448]=1;i=d;return}function avc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[273600]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273608,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+112>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[273600]=1;i=d;return}function bvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[273752]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273760,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+108>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=273904;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[273752]=1;i=d;return}function cvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[273928]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(273936,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+104>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[273928]=1;i=d;return}function dvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[274112]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(274120,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+100>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[274112]=1;i=d;return}function evc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[274296]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(274304,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+96>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=274480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[274296]=1;i=d;return}function fvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[274504]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(274512,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+92>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[274504]=1;i=d;return}function gvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[274672]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(274680,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+88>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[274672]=1;i=d;return}function hvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[274840]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(274848,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+84>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275008;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[274840]=1;i=d;return}function ivc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[275032]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(275040,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+80>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[275032]=1;i=d;return}function jvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[275200]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(275208,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+76>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[275200]=1;i=d;return}function kvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[275368]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(275376,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+72>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=275536;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[275368]=1;i=d;return}function lvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[275560]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(275568,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+68>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[275560]=1;i=d;return}function mvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[275728]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(275736,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+64>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[275728]=1;i=d;return}function nvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[275896]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(275904,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+60>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[275896]=1;i=d;return}function ovc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[276064]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(276072,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+56>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[276064]=1;i=d;return}function pvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[276232]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(276240,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+52>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[276232]=1;i=d;return}function qvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[276400]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(276408,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+48>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=276568;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[276400]=1;i=d;return}function rvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[276592]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(276600,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+44>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[276592]=1;i=d;return}function svc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[276744]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(276752,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+40>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[276744]=1;i=d;return}function tvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[276896]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(276904,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+36>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277048;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[276896]=1;i=d;return}function uvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[277072]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(277080,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+32>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[277072]=1;i=d;return}function vvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[277208]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(277216,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+28>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[277208]=1;i=d;return}function wvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[277344]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(277352,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+24>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277480;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[277344]=1;i=d;return}function xvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[277504]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(277512,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+20>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[277504]=1;i=d;return}function yvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[277664]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(277672,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+16>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[277664]=1;i=d;return}function zvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[277824]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(277832,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+12>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=277984;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[277824]=1;i=d;return}function Avc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[278008]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(278016,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+8>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=278488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[278008]=1;i=d;return}function Bvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[278168]&1){i=d;return}g=b+4|0;b=VEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(278176,eCc(c[(c[(c[c[g>>2]>>2]|0)+12>>2]|0)+4>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=278488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[278168]=1;i=d;return}function Cvc(b){b=b|0;var d=0,e=0,f=0,g=0,h=0,j=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[278328]&1){i=d;return}g=b+4|0;b=VEc(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),0.0)|0;if(!(b<<24>>24==0|(TEc(+(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0),255.0)|0)<<24>>24==0)){i=d;return}b=gCc(278336,eCc(c[c[(c[c[g>>2]>>2]|0)+12>>2]>>2]|0,7592)|0)|0;g=c[85376]|0;h=e;j=278488;c[h+0>>2]=c[j+0>>2];c[h+4>>2]=c[j+4>>2];c[h+8>>2]=c[j+8>>2];c[h+12>>2]=c[j+12>>2];c[h+16>>2]=c[j+16>>2];c[h+20>>2]=c[j+20>>2];Ee[g&15](e,b,f);a[278328]=1;i=d;return}



function WKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11944>>3]=0.0;i=i;return}function XKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11936>>3]=0.0;i=i;return}function YKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11928>>3]=0.0;i=i;return}function ZKa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11920>>3]=0.0;i=i;return}function _Ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11912>>3]=0.0;i=i;return}function $Ka(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11904>>3]=0.0;i=i;return}function aLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11896>>3]=0.0;i=i;return}function bLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11864>>3]=0.0;i=i;return}function cLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11888>>3]=0.0;i=i;return}function dLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11872>>3]=0.0;i=i;return}function eLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11880>>3]=0.0;i=i;return}function fLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11840>>3]=0.0;i=i;return}function gLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11832>>3]=0.0;i=i;return}function hLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11824>>3]=0.0;i=i;return}function iLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11816>>3]=0.0;i=i;return}function jLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11808>>3]=0.0;i=i;return}function kLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11752>>3]=0.0;i=i;return}function lLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11728>>3]=0.0;i=i;return}function mLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11704>>3]=0.0;i=i;return}function nLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11680>>3]=0.0;i=i;return}function oLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11656>>3]=0.0;i=i;return}function pLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11504>>3]=0.0;i=i;return}function qLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11480>>3]=0.0;i=i;return}function rLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11456>>3]=0.0;i=i;return}function sLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11496>>3]=0.0;i=i;return}function tLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11432>>3]=0.0;i=i;return}function uLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11424>>3]=0.0;i=i;return}function vLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11400>>3]=0.0;i=i;return}function wLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11392>>3]=0.0;i=i;return}function xLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11384>>3]=0.0;i=i;return}function yLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23952>>3]=0.0;i=i;return}function zLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+23976>>3]=0.0;i=i;return}function ALa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11352>>3]=0.0;i=i;return}function BLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11344>>3]=0.0;i=i;return}function CLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11336>>3]=0.0;i=i;return}function DLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11328>>3]=0.0;i=i;return}function ELa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11320>>3]=0.0;i=i;return}function FLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11288>>3]=0.0;i=i;return}function GLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11312>>3]=0.0;i=i;return}function HLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11296>>3]=0.0;i=i;return}function ILa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11304>>3]=0.0;i=i;return}function JLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11264>>3]=0.0;i=i;return}function KLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11256>>3]=0.0;i=i;return}function LLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11248>>3]=0.0;i=i;return}function MLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11240>>3]=0.0;i=i;return}function NLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11232>>3]=0.0;i=i;return}function OLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11176>>3]=0.0;i=i;return}function PLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11152>>3]=0.0;i=i;return}function QLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11128>>3]=0.0;i=i;return}function RLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11104>>3]=0.0;i=i;return}function SLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+11e3>>3]=0.0;i=i;return}function TLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10976>>3]=0.0;i=i;return}function ULa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10968>>3]=0.0;i=i;return}function VLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10960>>3]=0.0;i=i;return}function WLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10928>>3]=0.0;i=i;return}function XLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10920>>3]=0.0;i=i;return}function YLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10912>>3]=0.0;i=i;return}function ZLa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10904>>3]=0.0;i=i;return}function _La(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10872>>3]=0.0;i=i;return}function $La(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10896>>3]=0.0;i=i;return}function aMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10880>>3]=0.0;i=i;return}function bMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10888>>3]=0.0;i=i;return}function cMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10864>>3]=0.0;i=i;return}function dMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10856>>3]=0.0;i=i;return}function eMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10816>>3]=0.0;i=i;return}function fMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10808>>3]=0.0;i=i;return}function gMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10800>>3]=0.0;i=i;return}function hMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10792>>3]=0.0;i=i;return}function iMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10784>>3]=0.0;i=i;return}function jMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10776>>3]=0.0;i=i;return}function kMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10768>>3]=0.0;i=i;return}function lMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10760>>3]=0.0;i=i;return}function mMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10752>>3]=0.0;i=i;return}function nMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10744>>3]=0.0;i=i;return}function oMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10736>>3]=0.0;i=i;return}function pMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10728>>3]=0.0;i=i;return}function qMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10648>>3]=0.0;i=i;return}function rMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10632>>3]=0.0;i=i;return}function sMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10616>>3]=0.0;i=i;return}function tMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10608>>3]=0.0;i=i;return}function uMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10600>>3]=0.0;i=i;return}function vMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10592>>3]=0.0;i=i;return}function wMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10568>>3]=0.0;i=i;return}function xMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10544>>3]=0.0;i=i;return}function yMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10536>>3]=0.0;i=i;return}function zMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10528>>3]=0.0;i=i;return}function AMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10512>>3]=0.0;i=i;return}function BMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10488>>3]=0.0;i=i;return}function CMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10504>>3]=0.0;i=i;return}function DMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10480>>3]=0.0;i=i;return}function EMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10464>>3]=0.0;i=i;return}function FMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10448>>3]=0.0;i=i;return}function GMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10440>>3]=0.0;i=i;return}function HMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10432>>3]=0.0;i=i;return}function IMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10424>>3]=0.0;i=i;return}function JMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10416>>3]=0.0;i=i;return}function KMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10408>>3]=0.0;i=i;return}function LMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10400>>3]=0.0;i=i;return}function MMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10392>>3]=0.0;i=i;return}function NMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10376>>3]=0.0;i=i;return}function OMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10360>>3]=0.0;i=i;return}function PMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10352>>3]=0.0;i=i;return}function QMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10344>>3]=0.0;i=i;return}function RMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10336>>3]=0.0;i=i;return}function SMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10312>>3]=0.0;i=i;return}function TMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10288>>3]=0.0;i=i;return}function UMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10280>>3]=0.0;i=i;return}function VMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10272>>3]=0.0;i=i;return}function WMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10256>>3]=0.0;i=i;return}function XMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10232>>3]=0.0;i=i;return}function YMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10248>>3]=0.0;i=i;return}function ZMa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10224>>3]=0.0;i=i;return}function _Ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10208>>3]=0.0;i=i;return}function $Ma(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10192>>3]=0.0;i=i;return}function aNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10184>>3]=0.0;i=i;return}function bNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10176>>3]=0.0;i=i;return}function cNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10168>>3]=0.0;i=i;return}function dNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10160>>3]=0.0;i=i;return}function eNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10152>>3]=0.0;i=i;return}function fNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10144>>3]=0.0;i=i;return}function gNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10136>>3]=0.0;i=i;return}function hNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10120>>3]=0.0;i=i;return}function iNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10104>>3]=0.0;i=i;return}function jNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10096>>3]=0.0;i=i;return}function kNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10088>>3]=0.0;i=i;return}function lNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10080>>3]=0.0;i=i;return}function mNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10056>>3]=0.0;i=i;return}function nNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10032>>3]=0.0;i=i;return}function oNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10024>>3]=0.0;i=i;return}function pNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10016>>3]=0.0;i=i;return}function qNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+1e4>>3]=0.0;i=i;return}function rNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9976>>3]=0.0;i=i;return}function sNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9992>>3]=0.0;i=i;return}function tNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9968>>3]=0.0;i=i;return}function uNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9952>>3]=0.0;i=i;return}function vNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9936>>3]=0.0;i=i;return}function wNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9928>>3]=0.0;i=i;return}function xNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9920>>3]=0.0;i=i;return}function yNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9912>>3]=0.0;i=i;return}function zNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9904>>3]=0.0;i=i;return}function ANa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9896>>3]=0.0;i=i;return}function BNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9888>>3]=0.0;i=i;return}function CNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9880>>3]=0.0;i=i;return}function DNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9864>>3]=0.0;i=i;return}function ENa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9848>>3]=0.0;i=i;return}function FNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9840>>3]=0.0;i=i;return}function GNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9832>>3]=0.0;i=i;return}function HNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9824>>3]=0.0;i=i;return}function INa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9800>>3]=0.0;i=i;return}function JNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9776>>3]=0.0;i=i;return}function KNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9768>>3]=0.0;i=i;return}function LNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9760>>3]=0.0;i=i;return}function MNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9744>>3]=0.0;i=i;return}function NNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9720>>3]=0.0;i=i;return}function ONa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9736>>3]=0.0;i=i;return}function PNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9712>>3]=0.0;i=i;return}function QNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9696>>3]=0.0;i=i;return}function RNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9680>>3]=0.0;i=i;return}function SNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9672>>3]=0.0;i=i;return}function TNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9664>>3]=0.0;i=i;return}function UNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9656>>3]=0.0;i=i;return}function VNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9648>>3]=0.0;i=i;return}function WNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9640>>3]=0.0;i=i;return}function XNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9632>>3]=0.0;i=i;return}function YNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9624>>3]=0.0;i=i;return}function ZNa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9608>>3]=0.0;i=i;return}function _Na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9592>>3]=0.0;i=i;return}function $Na(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9584>>3]=0.0;i=i;return}function aOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9576>>3]=0.0;i=i;return}function bOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9568>>3]=0.0;i=i;return}function cOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9544>>3]=0.0;i=i;return}function dOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9520>>3]=0.0;i=i;return}function eOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9512>>3]=0.0;i=i;return}function fOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9504>>3]=0.0;i=i;return}function gOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9488>>3]=0.0;i=i;return}function hOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9464>>3]=0.0;i=i;return}function iOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9480>>3]=0.0;i=i;return}function jOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9456>>3]=0.0;i=i;return}function kOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9440>>3]=0.0;i=i;return}function lOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9424>>3]=0.0;i=i;return}function mOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9416>>3]=0.0;i=i;return}function nOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9376>>3]=0.0;i=i;return}function oOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9368>>3]=0.0;i=i;return}function pOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9328>>3]=0.0;i=i;return}function qOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9320>>3]=0.0;i=i;return}function rOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9280>>3]=0.0;i=i;return}function sOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9272>>3]=0.0;i=i;return}function tOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9232>>3]=0.0;i=i;return}function uOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9224>>3]=0.0;i=i;return}function vOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9184>>3]=0.0;i=i;return}function wOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9176>>3]=0.0;i=i;return}function xOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9136>>3]=0.0;i=i;return}function yOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9128>>3]=0.0;i=i;return}function zOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9088>>3]=0.0;i=i;return}function AOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9080>>3]=0.0;i=i;return}function BOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9040>>3]=0.0;i=i;return}function COa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9032>>3]=0.0;i=i;return}function DOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8992>>3]=0.0;i=i;return}function EOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8984>>3]=0.0;i=i;return}function FOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8944>>3]=0.0;i=i;return}function GOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8936>>3]=0.0;i=i;return}function HOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8928>>3]=0.0;i=i;return}function IOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8920>>3]=0.0;i=i;return}function JOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8912>>3]=0.0;i=i;return}function KOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8904>>3]=0.0;i=i;return}function LOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8896>>3]=0.0;i=i;return}function MOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8888>>3]=0.0;i=i;return}function NOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8864>>3]=0.0;i=i;return}function OOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8840>>3]=0.0;i=i;return}function POa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8816>>3]=0.0;i=i;return}function QOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8792>>3]=0.0;i=i;return}function ROa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8768>>3]=0.0;i=i;return}function SOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8744>>3]=0.0;i=i;return}function TOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8720>>3]=0.0;i=i;return}function UOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8696>>3]=0.0;i=i;return}function VOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8672>>3]=0.0;i=i;return}function WOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8648>>3]=0.0;i=i;return}function XOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8624>>3]=0.0;i=i;return}function YOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8600>>3]=0.0;i=i;return}function ZOa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8576>>3]=0.0;i=i;return}function _Oa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8552>>3]=0.0;i=i;return}function $Oa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8880>>3]=0.0;i=i;return}function aPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8856>>3]=0.0;i=i;return}function bPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8832>>3]=0.0;i=i;return}function cPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8808>>3]=0.0;i=i;return}function dPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8784>>3]=0.0;i=i;return}function ePa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8760>>3]=0.0;i=i;return}function fPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8736>>3]=0.0;i=i;return}function gPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8712>>3]=0.0;i=i;return}function hPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8688>>3]=0.0;i=i;return}function iPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8664>>3]=0.0;i=i;return}function jPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8640>>3]=0.0;i=i;return}function kPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8616>>3]=0.0;i=i;return}function lPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8592>>3]=0.0;i=i;return}function mPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8568>>3]=0.0;i=i;return}function nPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8544>>3]=0.0;i=i;return}function oPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8872>>3]=0.0;i=i;return}function pPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8848>>3]=0.0;i=i;return}function qPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8824>>3]=0.0;i=i;return}function rPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8800>>3]=0.0;i=i;return}function sPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8776>>3]=0.0;i=i;return}function tPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8752>>3]=0.0;i=i;return}function uPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8728>>3]=0.0;i=i;return}function vPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8528>>3]=0.0;i=i;return}function wPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8504>>3]=0.0;i=i;return}function xPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8480>>3]=0.0;i=i;return}function yPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10640>>3]=0.0;i=i;return}function zPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8472>>3]=0.0;i=i;return}function APa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8448>>3]=0.0;i=i;return}function BPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8424>>3]=0.0;i=i;return}function CPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10472>>3]=0.0;i=i;return}function DPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8416>>3]=0.0;i=i;return}function EPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8704>>3]=0.0;i=i;return}function FPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8680>>3]=0.0;i=i;return}function GPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8408>>3]=0.0;i=i;return}function HPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8384>>3]=0.0;i=i;return}function IPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8360>>3]=0.0;i=i;return}function JPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10384>>3]=0.0;i=i;return}function KPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8352>>3]=0.0;i=i;return}function LPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8328>>3]=0.0;i=i;return}function MPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8304>>3]=0.0;i=i;return}function NPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10216>>3]=0.0;i=i;return}function OPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8296>>3]=0.0;i=i;return}function PPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8656>>3]=0.0;i=i;return}function QPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8632>>3]=0.0;i=i;return}function RPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8288>>3]=0.0;i=i;return}function SPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8264>>3]=0.0;i=i;return}function TPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8240>>3]=0.0;i=i;return}function UPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+10128>>3]=0.0;i=i;return}function VPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8232>>3]=0.0;i=i;return}function WPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8208>>3]=0.0;i=i;return}function XPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8184>>3]=0.0;i=i;return}function YPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9960>>3]=0.0;i=i;return}function ZPa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8176>>3]=0.0;i=i;return}function _Pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8608>>3]=0.0;i=i;return}function $Pa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8584>>3]=0.0;i=i;return}function aQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8168>>3]=0.0;i=i;return}function bQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8144>>3]=0.0;i=i;return}function cQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8120>>3]=0.0;i=i;return}function dQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9872>>3]=0.0;i=i;return}function eQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8112>>3]=0.0;i=i;return}function fQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8088>>3]=0.0;i=i;return}function gQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8064>>3]=0.0;i=i;return}function hQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9704>>3]=0.0;i=i;return}function iQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8056>>3]=0.0;i=i;return}function jQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8560>>3]=0.0;i=i;return}function kQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8536>>3]=0.0;i=i;return}function lQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8048>>3]=0.0;i=i;return}function mQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8024>>3]=0.0;i=i;return}function nQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8e3>>3]=0.0;i=i;return}function oQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9616>>3]=0.0;i=i;return}function pQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7992>>3]=0.0;i=i;return}function qQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7968>>3]=0.0;i=i;return}function rQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7944>>3]=0.0;i=i;return}function sQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+9448>>3]=0.0;i=i;return}function tQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7936>>3]=0.0;i=i;return}function uQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7928>>3]=0.0;i=i;return}function vQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7912>>3]=0.0;i=i;return}function wQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7896>>3]=0.0;i=i;return}function xQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7888>>3]=0.0;i=i;return}function yQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7880>>3]=0.0;i=i;return}function zQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7872>>3]=0.0;i=i;return}function AQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7864>>3]=0.0;i=i;return}function BQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7856>>3]=0.0;i=i;return}function CQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7848>>3]=0.0;i=i;return}function DQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7824>>3]=0.0;i=i;return}function EQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7800>>3]=0.0;i=i;return}function FQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7776>>3]=0.0;i=i;return}function GQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7768>>3]=0.0;i=i;return}function HQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7760>>3]=0.0;i=i;return}function IQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7744>>3]=0.0;i=i;return}function JQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7720>>3]=0.0;i=i;return}function KQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7736>>3]=0.0;i=i;return}function LQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7712>>3]=0.0;i=i;return}function MQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7696>>3]=0.0;i=i;return}function NQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7680>>3]=0.0;i=i;return}function OQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7656>>3]=0.0;i=i;return}function PQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7632>>3]=0.0;i=i;return}function QQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7920>>3]=0.0;i=i;return}function RQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7624>>3]=0.0;i=i;return}function SQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7600>>3]=0.0;i=i;return}function TQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7576>>3]=0.0;i=i;return}function UQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7704>>3]=0.0;i=i;return}function VQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7552>>3]=0.0;i=i;return}function WQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7528>>3]=0.0;i=i;return}function XQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7520>>3]=0.0;i=i;return}function YQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7504>>3]=0.0;i=i;return}function ZQa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7496>>3]=0.0;i=i;return}function _Qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7488>>3]=0.0;i=i;return}function $Qa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7464>>3]=0.0;i=i;return}function aRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7440>>3]=0.0;i=i;return}function bRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7432>>3]=0.0;i=i;return}function cRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7424>>3]=0.0;i=i;return}function dRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7408>>3]=0.0;i=i;return}function eRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7384>>3]=0.0;i=i;return}function fRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7360>>3]=0.0;i=i;return}function gRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7416>>3]=0.0;i=i;return}function hRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7400>>3]=0.0;i=i;return}function iRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7328>>3]=0.0;i=i;return}function jRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7304>>3]=0.0;i=i;return}function kRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7280>>3]=0.0;i=i;return}function lRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7256>>3]=0.0;i=i;return}function mRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7232>>3]=0.0;i=i;return}function nRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7208>>3]=0.0;i=i;return}function oRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7392>>3]=0.0;i=i;return}function pRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7200>>3]=0.0;i=i;return}function qRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7192>>3]=0.0;i=i;return}function rRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7168>>3]=0.0;i=i;return}function sRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7368>>3]=0.0;i=i;return}function tRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7160>>3]=0.0;i=i;return}function uRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7136>>3]=0.0;i=i;return}function vRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7128>>3]=0.0;i=i;return}function wRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7104>>3]=0.0;i=i;return}function xRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7096>>3]=0.0;i=i;return}function yRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7088>>3]=0.0;i=i;return}function zRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7080>>3]=0.0;i=i;return}function ARa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7064>>3]=0.0;i=i;return}function BRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7040>>3]=0.0;i=i;return}function CRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7016>>3]=0.0;i=i;return}function DRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7072>>3]=0.0;i=i;return}function ERa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7056>>3]=0.0;i=i;return}function FRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7e3>>3]=0.0;i=i;return}function GRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6992>>3]=0.0;i=i;return}function HRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6984>>3]=0.0;i=i;return}function IRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6968>>3]=0.0;i=i;return}function JRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6944>>3]=0.0;i=i;return}function KRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6920>>3]=0.0;i=i;return}function LRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6976>>3]=0.0;i=i;return}function MRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6960>>3]=0.0;i=i;return}function NRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6904>>3]=0.0;i=i;return}function ORa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6896>>3]=0.0;i=i;return}function PRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6888>>3]=0.0;i=i;return}function QRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6872>>3]=0.0;i=i;return}function RRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6848>>3]=0.0;i=i;return}function SRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6824>>3]=0.0;i=i;return}function TRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6880>>3]=0.0;i=i;return}function URa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6864>>3]=0.0;i=i;return}function VRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6808>>3]=0.0;i=i;return}function WRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6800>>3]=0.0;i=i;return}function XRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6792>>3]=0.0;i=i;return}function YRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6776>>3]=0.0;i=i;return}function ZRa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6752>>3]=0.0;i=i;return}function _Ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6728>>3]=0.0;i=i;return}function $Ra(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6784>>3]=0.0;i=i;return}function aSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6768>>3]=0.0;i=i;return}function bSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6712>>3]=0.0;i=i;return}function cSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6704>>3]=0.0;i=i;return}function dSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6696>>3]=0.0;i=i;return}function eSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6680>>3]=0.0;i=i;return}function fSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6664>>3]=0.0;i=i;return}function gSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6640>>3]=0.0;i=i;return}function hSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6616>>3]=0.0;i=i;return}function iSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6688>>3]=0.0;i=i;return}function jSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6672>>3]=0.0;i=i;return}function kSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6584>>3]=0.0;i=i;return}function lSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6560>>3]=0.0;i=i;return}function mSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6536>>3]=0.0;i=i;return}function nSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6512>>3]=0.0;i=i;return}function oSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6488>>3]=0.0;i=i;return}function pSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7048>>3]=0.0;i=i;return}function qSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6480>>3]=0.0;i=i;return}function rSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6472>>3]=0.0;i=i;return}function sSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6464>>3]=0.0;i=i;return}function tSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6440>>3]=0.0;i=i;return}function uSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+7024>>3]=0.0;i=i;return}function vSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6432>>3]=0.0;i=i;return}function wSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6424>>3]=0.0;i=i;return}function xSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6400>>3]=0.0;i=i;return}function ySa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6376>>3]=0.0;i=i;return}function zSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6352>>3]=0.0;i=i;return}function ASa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6344>>3]=0.0;i=i;return}function BSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6312>>3]=0.0;i=i;return}function CSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6288>>3]=0.0;i=i;return}function DSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6264>>3]=0.0;i=i;return}function ESa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6240>>3]=0.0;i=i;return}function FSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6952>>3]=0.0;i=i;return}function GSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6232>>3]=0.0;i=i;return}function HSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6224>>3]=0.0;i=i;return}function ISa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6216>>3]=0.0;i=i;return}function JSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6192>>3]=0.0;i=i;return}function KSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6928>>3]=0.0;i=i;return}function LSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6184>>3]=0.0;i=i;return}function MSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6176>>3]=0.0;i=i;return}function NSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6152>>3]=0.0;i=i;return}function OSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6128>>3]=0.0;i=i;return}function PSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6104>>3]=0.0;i=i;return}function QSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6096>>3]=0.0;i=i;return}function RSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6064>>3]=0.0;i=i;return}function SSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6040>>3]=0.0;i=i;return}function TSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6016>>3]=0.0;i=i;return}function USa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5992>>3]=0.0;i=i;return}function VSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6856>>3]=0.0;i=i;return}function WSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5984>>3]=0.0;i=i;return}function XSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5976>>3]=0.0;i=i;return}function YSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5968>>3]=0.0;i=i;return}function ZSa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5944>>3]=0.0;i=i;return}function _Sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6832>>3]=0.0;i=i;return}function $Sa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5936>>3]=0.0;i=i;return}function aTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5928>>3]=0.0;i=i;return}function bTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5904>>3]=0.0;i=i;return}function cTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5880>>3]=0.0;i=i;return}function dTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5856>>3]=0.0;i=i;return}function eTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5848>>3]=0.0;i=i;return}function fTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5816>>3]=0.0;i=i;return}function gTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5792>>3]=0.0;i=i;return}function hTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5768>>3]=0.0;i=i;return}function iTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5744>>3]=0.0;i=i;return}function jTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6760>>3]=0.0;i=i;return}function kTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5736>>3]=0.0;i=i;return}function lTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5728>>3]=0.0;i=i;return}function mTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5720>>3]=0.0;i=i;return}function nTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5696>>3]=0.0;i=i;return}function oTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6736>>3]=0.0;i=i;return}function pTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5688>>3]=0.0;i=i;return}function qTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5680>>3]=0.0;i=i;return}function rTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5656>>3]=0.0;i=i;return}function sTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5648>>3]=0.0;i=i;return}function tTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5624>>3]=0.0;i=i;return}function uTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5616>>3]=0.0;i=i;return}function vTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6656>>3]=0.0;i=i;return}function wTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6648>>3]=0.0;i=i;return}function xTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5592>>3]=0.0;i=i;return}function yTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5568>>3]=0.0;i=i;return}function zTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5560>>3]=0.0;i=i;return}function ATa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5552>>3]=0.0;i=i;return}function BTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5528>>3]=0.0;i=i;return}function CTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+6624>>3]=0.0;i=i;return}function DTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5504>>3]=0.0;i=i;return}function ETa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5480>>3]=0.0;i=i;return}function FTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5456>>3]=0.0;i=i;return}function GTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5432>>3]=0.0;i=i;return}function HTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5408>>3]=0.0;i=i;return}function ITa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5384>>3]=0.0;i=i;return}function JTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5360>>3]=0.0;i=i;return}function KTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5336>>3]=0.0;i=i;return}function LTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5312>>3]=0.0;i=i;return}function MTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5288>>3]=0.0;i=i;return}function NTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5264>>3]=0.0;i=i;return}function OTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5240>>3]=0.0;i=i;return}function PTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5216>>3]=0.0;i=i;return}function QTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5192>>3]=0.0;i=i;return}function RTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5168>>3]=0.0;i=i;return}function STa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5144>>3]=0.0;i=i;return}function TTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5120>>3]=0.0;i=i;return}function UTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5096>>3]=0.0;i=i;return}function VTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5072>>3]=0.0;i=i;return}function WTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5048>>3]=0.0;i=i;return}function XTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5024>>3]=0.0;i=i;return}function YTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+5e3>>3]=0.0;i=i;return}function ZTa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4976>>3]=0.0;i=i;return}function _Ta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4952>>3]=0.0;i=i;return}function $Ta(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4928>>3]=0.0;i=i;return}function aUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4904>>3]=0.0;i=i;return}function bUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4880>>3]=0.0;i=i;return}function cUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4856>>3]=0.0;i=i;return}function dUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4832>>3]=0.0;i=i;return}function eUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4808>>3]=0.0;i=i;return}function fUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4784>>3]=0.0;i=i;return}function gUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4760>>3]=0.0;i=i;return}function hUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4736>>3]=0.0;i=i;return}function iUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4712>>3]=0.0;i=i;return}function jUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4704>>3]=0.0;i=i;return}function kUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4696>>3]=0.0;i=i;return}function lUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4672>>3]=0.0;i=i;return}function mUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4648>>3]=0.0;i=i;return}function nUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4624>>3]=0.0;i=i;return}function oUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4616>>3]=0.0;i=i;return}function pUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4584>>3]=0.0;i=i;return}function qUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4560>>3]=0.0;i=i;return}function rUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4536>>3]=0.0;i=i;return}function sUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4512>>3]=0.0;i=i;return}function tUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4504>>3]=0.0;i=i;return}function uUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4472>>3]=0.0;i=i;return}function vUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4448>>3]=0.0;i=i;return}function wUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4424>>3]=0.0;i=i;return}function xUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4400>>3]=0.0;i=i;return}function yUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=0.0;i=i;return}function zUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function AUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=0.0;i=i;return}function BUa(b){b=b|0;var c=0,d=0;c=i;d=b+314|0;a[d]=1;tz(b);uz(b);vz(b);wz(b);xz(b);yz(b);zz(b);Az(b);Bz(b);Cz(b);Dz(b);Ez(b);Fz(b);Gz(b);Hz(b);Iz(b);Jz(b);Kz(b);Lz(b);Mz(b);Nz(b);Oz(b);Pz(b);Qz(b);Rz(b);Sz(b);Tz(b);Uz(b);Vz(b);Wz(b);Xz(b);Yz(b);Zz(b);_z(b);$z(b);aA(b);bA(b);cA(b);dA(b);eA(b);fA(b);gA(b);hA(b);iA(b);jA(b);kA(b);lA(b);mA(b);nA(b);oA(b);pA(b);qA(b);rA(b);sA(b);tA(b);uA(b);vA(b);wA(b);xA(b);yA(b);zA(b);AA(b);BA(b);CA(b);DA(b);EA(b);FA(b);GA(b);HA(b);IA(b);JA(b);KA(b);LA(b);MA(b);NA(b);OA(b);PA(b);QA(b);RA(b);SA(b);TA(b);UA(b);VA(b);WA(b);XA(b);YA(b);ZA(b);_A(b);$A(b);aB(b);bB(b);cB(b);dB(b);eB(b);fB(b);gB(b);hB(b);iB(b);jB(b);kB(b);lB(b);mB(b);nB(b);oB(b);pB(b);qB(b);rB(b);sB(b);tB(b);uB(b);vB(b);wB(b);xB(b);yB(b);zB(b);AB(b);BB(b);CB(b);DB(b);EB(b);FB(b);GB(b);HB(b);IB(b);JB(b);KB(b);LB(b);MB(b);NB(b);OB(b);PB(b);QB(b);RB(b);SB(b);TB(b);UB(b);VB(b);WB(b);XB(b);YB(b);ZB(b);_B(b);$B(b);aC(b);bC(b);cC(b);dC(b);eC(b);fC(b);gC(b);hC(b);iC(b);jC(b);kC(b);lC(b);mC(b);nC(b);oC(b);pC(b);qC(b);rC(b);sC(b);tC(b);uC(b);vC(b);wC(b);xC(b);yC(b);zC(b);AC(b);BC(b);CC(b);DC(b);EC(b);FC(b);GC(b);HC(b);IC(b);JC(b);KC(b);LC(b);MC(b);NC(b);OC(b);PC(b);QC(b);RC(b);SC(b);TC(b);UC(b);VC(b);WC(b);XC(b);YC(b);ZC(b);_C(b);$C(b);aD(b);bD(b);cD(b);dD(b);eD(b);fD(b);gD(b);hD(b);iD(b);jD(b);kD(b);lD(b);mD(b);nD(b);oD(b);pD(b);qD(b);rD(b);sD(b);tD(b);uD(b);vD(b);wD(b);xD(b);yD(b);zD(b);AD(b);BD(b);CD(b);DD(b);ED(b);FD(b);GD(b);HD(b);ID(b);JD(b);KD(b);LD(b);MD(b);ND(b);OD(b);PD(b);QD(b);RD(b);SD(b);TD(b);UD(b);VD(b);WD(b);XD(b);YD(b);ZD(b);_D(b);$D(b);aE(b);bE(b);cE(b);dE(b);eE(b);fE(b);gE(b);hE(b);iE(b);jE(b);kE(b);lE(b);mE(b);nE(b);oE(b);pE(b);qE(b);rE(b);sE(b);tE(b);uE(b);vE(b);wE(b);xE(b);yE(b);zE(b);AE(b);BE(b);CE(b);DE(b);EE(b);FE(b);GE(b);HE(b);IE(b);JE(b);KE(b);LE(b);ME(b);NE(b);OE(b);PE(b);QE(b);RE(b);SE(b);TE(b);UE(b);VE(b);WE(b);XE(b);YE(b);ZE(b);_E(b);$E(b);aF(b);bF(b);cF(b);dF(b);eF(b);fF(b);gF(b);hF(b);iF(b);jF(b);kF(b);lF(b);mF(b);nF(b);oF(b);pF(b);qF(b);rF(b);sF(b);tF(b);uF(b);vF(b);wF(b);xF(b);yF(b);zF(b);AF(b);BF(b);CF(b);DF(b);EF(b);FF(b);GF(b);HF(b);IF(b);JF(b);KF(b);LF(b);MF(b);NF(b);OF(b);PF(b);QF(b);RF(b);SF(b);TF(b);UF(b);VF(b);WF(b);XF(b);YF(b);ZF(b);_F(b);$F(b);aG(b);bG(b);cG(b);dG(b);eG(b);fG(b);gG(b);hG(b);iG(b);jG(b);kG(b);lG(b);mG(b);nG(b);oG(b);pG(b);qG(b);rG(b);sG(b);tG(b);uG(b);vG(b);wG(b);xG(b);yG(b);zG(b);AG(b);BG(b);CG(b);DG(b);EG(b);FG(b);GG(b);HG(b);IG(b);JG(b);KG(b);LG(b);MG(b);NG(b);OG(b);PG(b);QG(b);RG(b);SG(b);TG(b);UG(b);VG(b);WG(b);XG(b);YG(b);ZG(b);_G(b);$G(b);aH(b);bH(b);cH(b);dH(b);eH(b);fH(b);gH(b);hH(b);iH(b);jH(b);kH(b);lH(b);mH(b);nH(b);oH(b);pH(b);qH(b);rH(b);sH(b);tH(b);uH(b);vH(b);wH(b);xH(b);yH(b);zH(b);AH(b);BH(b);CH(b);DH(b);EH(b);FH(b);GH(b);HH(b);IH(b);JH(b);KH(b);LH(b);MH(b);NH(b);OH(b);PH(b);QH(b);RH(b);SH(b);TH(b);UH(b);VH(b);WH(b);XH(b);YH(b);ZH(b);_H(b);$H(b);aI(b);bI(b);cI(b);dI(b);eI(b);fI(b);gI(b);hI(b);iI(b);jI(b);kI(b);lI(b);mI(b);nI(b);oI(b);pI(b);qI(b);rI(b);sI(b);tI(b);uI(b);vI(b);wI(b);xI(b);yI(b);zI(b);AI(b);BI(b);CI(b);DI(b);EI(b);FI(b);GI(b);HI(b);II(b);JI(b);KI(b);LI(b);MI(b);NI(b);OI(b);PI(b);QI(b);RI(b);SI(b);TI(b);UI(b);VI(b);WI(b);XI(b);YI(b);ZI(b);_I(b);$I(b);aJ(b);bJ(b);cJ(b);dJ(b);eJ(b);fJ(b);gJ(b);hJ(b);iJ(b);jJ(b);kJ(b);lJ(b);mJ(b);nJ(b);oJ(b);pJ(b);qJ(b);rJ(b);sJ(b);tJ(b);uJ(b);vJ(b);wJ(b);xJ(b);yJ(b);zJ(b);AJ(b);BJ(b);CJ(b);DJ(b);EJ(b);FJ(b);GJ(b);HJ(b);IJ(b);JJ(b);KJ(b);LJ(b);MJ(b);NJ(b);OJ(b);PJ(b);QJ(b);RJ(b);SJ(b);TJ(b);UJ(b);VJ(b);WJ(b);XJ(b);YJ(b);ZJ(b);_J(b);$J(b);aK(b);bK(b);cK(b);dK(b);eK(b);fK(b);gK(b);hK(b);iK(b);jK(b);kK(b);lK(b);mK(b);nK(b);oK(b);pK(b);qK(b);rK(b);sK(b);tK(b);uK(b);vK(b);wK(b);xK(b);yK(b);zK(b);AK(b);BK(b);CK(b);DK(b);EK(b);FK(b);GK(b);HK(b);IK(b);JK(b);KK(b);LK(b);MK(b);NK(b);OK(b);PK(b);QK(b);RK(b);SK(b);TK(b);UK(b);VK(b);WK(b);XK(b);YK(b);ZK(b);_K(b);$K(b);aL(b);bL(b);cL(b);dL(b);eL(b);fL(b);gL(b);hL(b);iL(b);jL(b);kL(b);lL(b);mL(b);nL(b);oL(b);pL(b);qL(b);rL(b);sL(b);tL(b);uL(b);vL(b);wL(b);xL(b);yL(b);zL(b);AL(b);BL(b);CL(b);DL(b);EL(b);FL(b);GL(b);HL(b);IL(b);JL(b);KL(b);LL(b);ML(b);NL(b);OL(b);PL(b);QL(b);RL(b);SL(b);TL(b);UL(b);VL(b);WL(b);XL(b);YL(b);ZL(b);_L(b);$L(b);aM(b);bM(b);cM(b);dM(b);eM(b);fM(b);gM(b);hM(b);iM(b);jM(b);kM(b);lM(b);mM(b);nM(b);oM(b);pM(b);qM(b);rM(b);sM(b);tM(b);uM(b);vM(b);wM(b);xM(b);yM(b);zM(b);AM(b);BM(b);CM(b);DM(b);EM(b);FM(b);GM(b);HM(b);IM(b);JM(b);KM(b);LM(b);MM(b);NM(b);OM(b);PM(b);QM(b);RM(b);SM(b);TM(b);UM(b);VM(b);WM(b);XM(b);YM(b);ZM(b);_M(b);$M(b);aN(b);bN(b);cN(b);dN(b);eN(b);fN(b);gN(b);hN(b);iN(b);jN(b);kN(b);lN(b);mN(b);nN(b);oN(b);pN(b);qN(b);rN(b);sN(b);tN(b);uN(b);vN(b);wN(b);xN(b);yN(b);zN(b);AN(b);BN(b);CN(b);DN(b);EN(b);FN(b);GN(b);HN(b);IN(b);JN(b);KN(b);LN(b);MN(b);NN(b);ON(b);PN(b);QN(b);RN(b);SN(b);TN(b);UN(b);VN(b);WN(b);XN(b);YN(b);ZN(b);_N(b);$N(b);aO(b);bO(b);cO(b);dO(b);eO(b);fO(b);gO(b);hO(b);iO(b);jO(b);kO(b);lO(b);mO(b);nO(b);oO(b);pO(b);qO(b);rO(b);sO(b);tO(b);uO(b);vO(b);wO(b);xO(b);yO(b);zO(b);AO(b);BO(b);CO(b);DO(b);EO(b);FO(b);GO(b);HO(b);IO(b);JO(b);KO(b);LO(b);MO(b);NO(b);OO(b);PO(b);QO(b);RO(b);SO(b);TO(b);UO(b);VO(b);WO(b);XO(b);YO(b);ZO(b);_O(b);$O(b);aP(b);bP(b);cP(b);dP(b);eP(b);fP(b);gP(b);hP(b);iP(b);jP(b);kP(b);lP(b);mP(b);nP(b);oP(b);pP(b);qP(b);rP(b);sP(b);tP(b);uP(b);vP(b);wP(b);xP(b);yP(b);zP(b);AP(b);BP(b);CP(b);DP(b);EP(b);FP(b);GP(b);HP(b);IP(b);JP(b);KP(b);LP(b);MP(b);NP(b);OP(b);PP(b);QP(b);RP(b);SP(b);TP(b);UP(b);VP(b);WP(b);XP(b);YP(b);ZP(b);_P(b);$P(b);aQ(b);bQ(b);cQ(b);dQ(b);eQ(b);fQ(b);gQ(b);hQ(b);iQ(b);jQ(b);kQ(b);lQ(b);mQ(b);nQ(b);oQ(b);pQ(b);qQ(b);rQ(b);sQ(b);tQ(b);uQ(b);vQ(b);wQ(b);xQ(b);yQ(b);zQ(b);AQ(b);BQ(b);CQ(b);DQ(b);EQ(b);FQ(b);GQ(b);HQ(b);IQ(b);JQ(b);KQ(b);LQ(b);MQ(b);NQ(b);OQ(b);PQ(b);QQ(b);RQ(b);SQ(b);TQ(b);UQ(b);VQ(b);WQ(b);XQ(b);YQ(b);ZQ(b);_Q(b);$Q(b);aR(b);bR(b);cR(b);dR(b);eR(b);fR(b);gR(b);hR(b);iR(b);jR(b);kR(b);lR(b);mR(b);nR(b);oR(b);pR(b);qR(b);rR(b);sR(b);tR(b);uR(b);vR(b);wR(b);xR(b);yR(b);zR(b);AR(b);BR(b);CR(b);DR(b);ER(b);FR(b);GR(b);HR(b);IR(b);JR(b);KR(b);LR(b);MR(b);NR(b);OR(b);PR(b);QR(b);RR(b);SR(b);TR(b);UR(b);VR(b);WR(b);XR(b);YR(b);ZR(b);_R(b);$R(b);aS(b);bS(b);cS(b);dS(b);eS(b);fS(b);gS(b);hS(b);iS(b);jS(b);kS(b);lS(b);mS(b);nS(b);oS(b);pS(b);qS(b);rS(b);sS(b);tS(b);uS(b);vS(b);wS(b);xS(b);yS(b);zS(b);AS(b);BS(b);CS(b);DS(b);ES(b);FS(b);GS(b);HS(b);IS(b);JS(b);KS(b);LS(b);MS(b);NS(b);OS(b);PS(b);QS(b);RS(b);SS(b);TS(b);US(b);VS(b);WS(b);XS(b);YS(b);ZS(b);_S(b);$S(b);aT(b);bT(b);cT(b);dT(b);eT(b);fT(b);gT(b);hT(b);iT(b);jT(b);kT(b);lT(b);mT(b);nT(b);oT(b);pT(b);qT(b);rT(b);sT(b);tT(b);uT(b);vT(b);wT(b);xT(b);yT(b);zT(b);AT(b);BT(b);CT(b);DT(b);ET(b);FT(b);GT(b);HT(b);IT(b);JT(b);KT(b);LT(b);MT(b);NT(b);OT(b);PT(b);QT(b);RT(b);ST(b);TT(b);UT(b);VT(b);WT(b);XT(b);YT(b);ZT(b);_T(b);$T(b);aU(b);bU(b);cU(b);dU(b);eU(b);fU(b);gU(b);hU(b);iU(b);jU(b);kU(b);lU(b);mU(b);nU(b);oU(b);pU(b);qU(b);rU(b);sU(b);tU(b);uU(b);vU(b);wU(b);xU(b);yU(b);zU(b);AU(b);BU(b);CU(b);DU(b);EU(b);FU(b);GU(b);HU(b);IU(b);JU(b);KU(b);LU(b);MU(b);NU(b);OU(b);PU(b);QU(b);RU(b);SU(b);TU(b);UU(b);VU(b);WU(b);XU(b);YU(b);ZU(b);_U(b);$U(b);aV(b);bV(b);cV(b);dV(b);eV(b);fV(b);gV(b);hV(b);iV(b);jV(b);kV(b);lV(b);mV(b);nV(b);oV(b);pV(b);qV(b);rV(b);sV(b);tV(b);uV(b);vV(b);wV(b);xV(b);yV(b);zV(b);AV(b);BV(b);CV(b);DV(b);EV(b);FV(b);GV(b);HV(b);IV(b);JV(b);KV(b);LV(b);MV(b);NV(b);OV(b);PV(b);QV(b);RV(b);SV(b);TV(b);UV(b);VV(b);WV(b);XV(b);YV(b);ZV(b);_V(b);$V(b);aW(b);bW(b);cW(b);dW(b);eW(b);fW(b);gW(b);hW(b);iW(b);jW(b);kW(b);lW(b);mW(b);nW(b);oW(b);pW(b);qW(b);rW(b);sW(b);tW(b);uW(b);vW(b);wW(b);xW(b);yW(b);zW(b);AW(b);BW(b);CW(b);DW(b);EW(b);FW(b);GW(b);HW(b);IW(b);JW(b);KW(b);LW(b);MW(b);NW(b);OW(b);PW(b);QW(b);RW(b);SW(b);TW(b);UW(b);VW(b);WW(b);XW(b);YW(b);ZW(b);_W(b);$W(b);aX(b);bX(b);cX(b);dX(b);eX(b);fX(b);gX(b);hX(b);iX(b);jX(b);kX(b);lX(b);mX(b);nX(b);oX(b);pX(b);qX(b);rX(b);sX(b);tX(b);uX(b);vX(b);wX(b);xX(b);yX(b);zX(b);AX(b);BX(b);CX(b);DX(b);EX(b);FX(b);GX(b);HX(b);IX(b);JX(b);KX(b);LX(b);MX(b);NX(b);OX(b);PX(b);QX(b);RX(b);SX(b);TX(b);UX(b);VX(b);WX(b);XX(b);YX(b);ZX(b);_X(b);$X(b);aY(b);bY(b);cY(b);dY(b);eY(b);fY(b);gY(b);hY(b);iY(b);jY(b);kY(b);lY(b);mY(b);nY(b);oY(b);pY(b);qY(b);rY(b);sY(b);tY(b);uY(b);vY(b);wY(b);xY(b);yY(b);zY(b);AY(b);BY(b);CY(b);DY(b);EY(b);FY(b);GY(b);HY(b);IY(b);JY(b);KY(b);LY(b);MY(b);NY(b);OY(b);PY(b);QY(b);RY(b);SY(b);TY(b);UY(b);VY(b);WY(b);XY(b);YY(b);ZY(b);_Y(b);$Y(b);aZ(b);bZ(b);cZ(b);dZ(b);eZ(b);fZ(b);gZ(b);hZ(b);iZ(b);jZ(b);kZ(b);lZ(b);mZ(b);nZ(b);oZ(b);pZ(b);qZ(b);rZ(b);sZ(b);tZ(b);uZ(b);vZ(b);wZ(b);xZ(b);yZ(b);zZ(b);AZ(b);BZ(b);CZ(b);DZ(b);EZ(b);FZ(b);GZ(b);HZ(b);IZ(b);JZ(b);KZ(b);LZ(b);MZ(b);NZ(b);OZ(b);PZ(b);QZ(b);RZ(b);SZ(b);TZ(b);UZ(b);VZ(b);WZ(b);XZ(b);YZ(b);ZZ(b);_Z(b);$Z(b);a_(b);b_(b);c_(b);d_(b);e_(b);f_(b);g_(b);h_(b);i_(b);j_(b);k_(b);l_(b);m_(b);n_(b);o_(b);p_(b);q_(b);r_(b);s_(b);t_(b);u_(b);v_(b);w_(b);x_(b);y_(b);z_(b);A_(b);B_(b);C_(b);D_(b);E_(b);F_(b);G_(b);H_(b);I_(b);J_(b);K_(b);L_(b);M_(b);N_(b);O_(b);P_(b);Q_(b);R_(b);S_(b);T_(b);U_(b);V_(b);W_(b);X_(b);Y_(b);Z_(b);__(b);$_(b);a$(b);b$(b);c$(b);d$(b);e$(b);f$(b);g$(b);h$(b);i$(b);j$(b);k$(b);l$(b);m$(b);n$(b);o$(b);p$(b);q$(b);r$(b);s$(b);t$(b);u$(b);v$(b);w$(b);x$(b);y$(b);z$(b);A$(b);B$(b);C$(b);D$(b);E$(b);F$(b);G$(b);H$(b);I$(b);J$(b);K$(b);L$(b);M$(b);N$(b);O$(b);P$(b);Q$(b);R$(b);S$(b);T$(b);U$(b);V$(b);W$(b);X$(b);Y$(b);Z$(b);_$(b);$$(b);a0(b);b0(b);c0(b);d0(b);e0(b);f0(b);g0(b);h0(b);i0(b);j0(b);k0(b);l0(b);m0(b);n0(b);o0(b);p0(b);q0(b);r0(b);s0(b);t0(b);u0(b);v0(b);w0(b);x0(b);y0(b);z0(b);A0(b);B0(b);C0(b);D0(b);E0(b);F0(b);G0(b);H0(b);I0(b);J0(b);K0(b);L0(b);M0(b);N0(b);O0(b);P0(b);Q0(b);R0(b);S0(b);T0(b);U0(b);V0(b);W0(b);X0(b);Y0(b);Z0(b);_0(b);$0(b);a1(b);b1(b);c1(b);d1(b);e1(b);f1(b);g1(b);h1(b);i1(b);j1(b);k1(b);l1(b);m1(b);n1(b);o1(b);p1(b);q1(b);r1(b);s1(b);t1(b);u1(b);v1(b);w1(b);x1(b);y1(b);z1(b);A1(b);B1(b);C1(b);D1(b);E1(b);F1(b);G1(b);H1(b);I1(b);J1(b);K1(b);L1(b);M1(b);N1(b);O1(b);P1(b);Q1(b);R1(b);S1(b);T1(b);U1(b);V1(b);W1(b);X1(b);Y1(b);Z1(b);_1(b);$1(b);a2(b);b2(b);c2(b);d2(b);e2(b);f2(b);g2(b);h2(b);i2(b);j2(b);k2(b);l2(b);m2(b);n2(b);o2(b);p2(b);q2(b);r2(b);s2(b);t2(b);u2(b);v2(b);w2(b);x2(b);y2(b);z2(b);A2(b);B2(b);C2(b);D2(b);E2(b);F2(b);G2(b);H2(b);I2(b);J2(b);K2(b);L2(b);M2(b);N2(b);O2(b);P2(b);Q2(b);R2(b);S2(b);T2(b);U2(b);V2(b);W2(b);X2(b);Y2(b);Z2(b);_2(b);$2(b);a3(b);b3(b);c3(b);d3(b);e3(b);f3(b);g3(b);h3(b);i3(b);j3(b);k3(b);l3(b);m3(b);n3(b);o3(b);p3(b);q3(b);r3(b);s3(b);t3(b);u3(b);v3(b);w3(b);x3(b);y3(b);z3(b);A3(b);B3(b);C3(b);D3(b);E3(b);F3(b);G3(b);H3(b);I3(b);J3(b);K3(b);L3(b);M3(b);N3(b);O3(b);P3(b);Q3(b);R3(b);S3(b);T3(b);U3(b);V3(b);W3(b);X3(b);Y3(b);Z3(b);_3(b);$3(b);a4(b);b4(b);c4(b);d4(b);e4(b);f4(b);g4(b);h4(b);i4(b);j4(b);k4(b);l4(b);m4(b);n4(b);o4(b);p4(b);q4(b);r4(b);s4(b);t4(b);u4(b);v4(b);w4(b);x4(b);y4(b);z4(b);A4(b);B4(b);C4(b);D4(b);E4(b);F4(b);G4(b);H4(b);I4(b);J4(b);K4(b);L4(b);M4(b);N4(b);O4(b);P4(b);Q4(b);R4(b);S4(b);T4(b);U4(b);V4(b);W4(b);X4(b);Y4(b);Z4(b);_4(b);$4(b);a5(b);b5(b);c5(b);d5(b);e5(b);f5(b);g5(b);h5(b);i5(b);j5(b);k5(b);l5(b);m5(b);n5(b);o5(b);p5(b);q5(b);r5(b);s5(b);t5(b);u5(b);v5(b);w5(b);x5(b);y5(b);z5(b);A5(b);B5(b);C5(b);D5(b);E5(b);F5(b);G5(b);H5(b);I5(b);J5(b);K5(b);L5(b);M5(b);N5(b);O5(b);P5(b);Q5(b);R5(b);S5(b);T5(b);U5(b);V5(b);W5(b);X5(b);Y5(b);Z5(b);_5(b);$5(b);a6(b);b6(b);c6(b);d6(b);e6(b);f6(b);g6(b);h6(b);i6(b);j6(b);k6(b);l6(b);m6(b);n6(b);o6(b);p6(b);q6(b);r6(b);s6(b);t6(b);u6(b);v6(b);w6(b);x6(b);y6(b);z6(b);A6(b);B6(b);C6(b);D6(b);E6(b);F6(b);G6(b);H6(b);I6(b);J6(b);K6(b);L6(b);M6(b);N6(b);O6(b);P6(b);Q6(b);R6(b);S6(b);T6(b);U6(b);V6(b);W6(b);X6(b);Y6(b);Z6(b);_6(b);$6(b);a7(b);b7(b);c7(b);d7(b);e7(b);f7(b);g7(b);h7(b);i7(b);j7(b);k7(b);l7(b);m7(b);n7(b);o7(b);p7(b);q7(b);r7(b);s7(b);t7(b);u7(b);v7(b);w7(b);x7(b);y7(b);z7(b);A7(b);B7(b);C7(b);D7(b);E7(b);F7(b);G7(b);H7(b);I7(b);J7(b);K7(b);L7(b);M7(b);N7(b);O7(b);P7(b);Q7(b);R7(b);S7(b);T7(b);U7(b);V7(b);W7(b);X7(b);Y7(b);Z7(b);_7(b);$7(b);a8(b);b8(b);c8(b);d8(b);e8(b);f8(b);g8(b);h8(b);i8(b);j8(b);k8(b);l8(b);m8(b);n8(b);o8(b);p8(b);q8(b);r8(b);s8(b);t8(b);u8(b);v8(b);w8(b);x8(b);y8(b);z8(b);A8(b);B8(b);C8(b);D8(b);E8(b);F8(b);G8(b);H8(b);I8(b);J8(b);K8(b);L8(b);M8(b);N8(b);O8(b);P8(b);Q8(b);R8(b);S8(b);T8(b);U8(b);V8(b);W8(b);X8(b);Y8(b);Z8(b);_8(b);$8(b);a9(b);b9(b);c9(b);d9(b);e9(b);f9(b);g9(b);h9(b);i9(b);j9(b);k9(b);l9(b);m9(b);n9(b);o9(b);p9(b);q9(b);r9(b);s9(b);t9(b);u9(b);v9(b);w9(b);x9(b);y9(b);z9(b);A9(b);B9(b);C9(b);D9(b);E9(b);F9(b);G9(b);H9(b);I9(b);J9(b);K9(b);L9(b);M9(b);N9(b);O9(b);P9(b);Q9(b);R9(b);S9(b);T9(b);U9(b);V9(b);W9(b);X9(b);Y9(b);Z9(b);_9(b);$9(b);aaa(b);baa(b);caa(b);daa(b);eaa(b);faa(b);gaa(b);haa(b);iaa(b);jaa(b);kaa(b);laa(b);maa(b);naa(b);oaa(b);paa(b);qaa(b);raa(b);saa(b);taa(b);uaa(b);vaa(b);waa(b);xaa(b);yaa(b);zaa(b);Aaa(b);Baa(b);Caa(b);Daa(b);Eaa(b);Faa(b);Gaa(b);Haa(b);Iaa(b);Jaa(b);Kaa(b);Laa(b);Maa(b);Naa(b);Oaa(b);Paa(b);Qaa(b);Raa(b);Saa(b);Taa(b);Uaa(b);Vaa(b);Waa(b);Xaa(b);Yaa(b);Zaa(b);_aa(b);$aa(b);aba(b);bba(b);cba(b);dba(b);eba(b);fba(b);gba(b);hba(b);iba(b);jba(b);kba(b);lba(b);mba(b);nba(b);oba(b);pba(b);qba(b);rba(b);sba(b);tba(b);uba(b);vba(b);wba(b);xba(b);yba(b);zba(b);Aba(b);Bba(b);Cba(b);Dba(b);Eba(b);Fba(b);Gba(b);Hba(b);Iba(b);Jba(b);Kba(b);Lba(b);Mba(b);Nba(b);Oba(b);Pba(b);Qba(b);Rba(b);Sba(b);Tba(b);Uba(b);Vba(b);Wba(b);Xba(b);Yba(b);Zba(b);_ba(b);$ba(b);aca(b);bca(b);cca(b);dca(b);eca(b);fca(b);gca(b);hca(b);ica(b);jca(b);kca(b);lca(b);mca(b);nca(b);oca(b);pca(b);qca(b);rca(b);sca(b);tca(b);uca(b);vca(b);wca(b);xca(b);yca(b);zca(b);Aca(b);Bca(b);Cca(b);Dca(b);Eca(b);Fca(b);Gca(b);Hca(b);Ica(b);Jca(b);Kca(b);Lca(b);Mca(b);Nca(b);Oca(b);Pca(b);Qca(b);Rca(b);Sca(b);Tca(b);Uca(b);Vca(b);Wca(b);Xca(b);Yca(b);Zca(b);_ca(b);$ca(b);ada(b);bda(b);cda(b);dda(b);eda(b);fda(b);gda(b);hda(b);ida(b);jda(b);kda(b);lda(b);mda(b);nda(b);oda(b);pda(b);qda(b);rda(b);sda(b);tda(b);uda(b);vda(b);wda(b);xda(b);yda(b);zda(b);Ada(b);Bda(b);Cda(b);Dda(b);Eda(b);Fda(b);Gda(b);Hda(b);Ida(b);Jda(b);Kda(b);Lda(b);Mda(b);Nda(b);Oda(b);Pda(b);Qda(b);Rda(b);Sda(b);Tda(b);Uda(b);Vda(b);Wda(b);Xda(b);Yda(b);Zda(b);_da(b);$da(b);aea(b);bea(b);cea(b);dea(b);eea(b);fea(b);gea(b);hea(b);iea(b);jea(b);kea(b);lea(b);mea(b);nea(b);oea(b);pea(b);qea(b);rea(b);sea(b);tea(b);uea(b);vea(b);wea(b);xea(b);yea(b);zea(b);Aea(b);Bea(b);Cea(b);Dea(b);Eea(b);Fea(b);Gea(b);Hea(b);Iea(b);Jea(b);Kea(b);Lea(b);Mea(b);Nea(b);Oea(b);Pea(b);Qea(b);Rea(b);Sea(b);Tea(b);Uea(b);Vea(b);Wea(b);Xea(b);Yea(b);Zea(b);_ea(b);$ea(b);afa(b);bfa(b);cfa(b);dfa(b);efa(b);ffa(b);gfa(b);hfa(b);ifa(b);jfa(b);kfa(b);lfa(b);mfa(b);nfa(b);ofa(b);pfa(b);qfa(b);rfa(b);sfa(b);tfa(b);ufa(b);vfa(b);wfa(b);xfa(b);yfa(b);zfa(b);Afa(b);Bfa(b);Cfa(b);Dfa(b);Efa(b);Ffa(b);Gfa(b);Hfa(b);Ifa(b);Jfa(b);Kfa(b);Lfa(b);Mfa(b);Nfa(b);Ofa(b);Pfa(b);Qfa(b);Rfa(b);Sfa(b);Tfa(b);Ufa(b);Vfa(b);Wfa(b);Xfa(b);Yfa(b);Zfa(b);_fa(b);$fa(b);aga(b);bga(b);cga(b);dga(b);ega(b);fga(b);gga(b);hga(b);iga(b);jga(b);kga(b);lga(b);mga(b);nga(b);oga(b);pga(b);qga(b);rga(b);sga(b);tga(b);uga(b);vga(b);wga(b);xga(b);yga(b);zga(b);Aga(b);Bga(b);Cga(b);Dga(b);Ega(b);Fga(b);Gga(b);Hga(b);Iga(b);Jga(b);Kga(b);Lga(b);Mga(b);Nga(b);Oga(b);Pga(b);Qga(b);Rga(b);Sga(b);Tga(b);Uga(b);Vga(b);Wga(b);Xga(b);Yga(b);Zga(b);_ga(b);$ga(b);aha(b);bha(b);cha(b);dha(b);eha(b);fha(b);gha(b);hha(b);iha(b);jha(b);kha(b);lha(b);mha(b);nha(b);oha(b);pha(b);qha(b);rha(b);sha(b);tha(b);uha(b);vha(b);wha(b);xha(b);yha(b);zha(b);Aha(b);Bha(b);Cha(b);Dha(b);Eha(b);Fha(b);Gha(b);Hha(b);Iha(b);Jha(b);Kha(b);Lha(b);Mha(b);Nha(b);Oha(b);Pha(b);Qha(b);Rha(b);Sha(b);Tha(b);Uha(b);Vha(b);Wha(b);Xha(b);Yha(b);Zha(b);_ha(b);$ha(b);aia(b);bia(b);cia(b);dia(b);eia(b);fia(b);gia(b);hia(b);iia(b);jia(b);kia(b);lia(b);mia(b);nia(b);oia(b);pia(b);qia(b);ria(b);sia(b);tia(b);uia(b);via(b);wia(b);xia(b);yia(b);zia(b);Aia(b);Bia(b);Cia(b);Dia(b);Eia(b);Fia(b);Gia(b);Hia(b);Iia(b);Jia(b);Kia(b);Lia(b);Mia(b);Nia(b);Oia(b);Pia(b);Qia(b);Ria(b);Sia(b);Tia(b);Uia(b);Via(b);Wia(b);Xia(b);Yia(b);Zia(b);_ia(b);$ia(b);aja(b);bja(b);cja(b);dja(b);eja(b);fja(b);gja(b);hja(b);ija(b);jja(b);kja(b);lja(b);mja(b);nja(b);oja(b);pja(b);qja(b);rja(b);sja(b);tja(b);uja(b);vja(b);wja(b);xja(b);yja(b);zja(b);Aja(b);Bja(b);Cja(b);Dja(b);Eja(b);Fja(b);Gja(b);Hja(b);Ija(b);Jja(b);Kja(b);Lja(b);Mja(b);Nja(b);Oja(b);Pja(b);Qja(b);Rja(b);Sja(b);Tja(b);Uja(b);Vja(b);Wja(b);Xja(b);Yja(b);Zja(b);_ja(b);$ja(b);aka(b);bka(b);cka(b);dka(b);eka(b);fka(b);gka(b);hka(b);ika(b);jka(b);kka(b);lka(b);mka(b);nka(b);oka(b);pka(b);qka(b);rka(b);ska(b);tka(b);uka(b);vka(b);wka(b);xka(b);yka(b);zka(b);Aka(b);Bka(b);Cka(b);Dka(b);Eka(b);Fka(b);Gka(b);Hka(b);Ika(b);Jka(b);Kka(b);Lka(b);Mka(b);Nka(b);Oka(b);Pka(b);Qka(b);Rka(b);Ska(b);Tka(b);Uka(b);Vka(b);Wka(b);Xka(b);Yka(b);Zka(b);_ka(b);$ka(b);ala(b);bla(b);cla(b);dla(b);ela(b);fla(b);gla(b);hla(b);ila(b);jla(b);kla(b);lla(b);mla(b);nla(b);ola(b);pla(b);qla(b);rla(b);sla(b);tla(b);ula(b);vla(b);wla(b);xla(b);yla(b);zla(b);Ala(b);Bla(b);Cla(b);Dla(b);Ela(b);Fla(b);Gla(b);Hla(b);Ila(b);Jla(b);Kla(b);Lla(b);Mla(b);Nla(b);Ola(b);Pla(b);Qla(b);Rla(b);Sla(b);Tla(b);Ula(b);Vla(b);Wla(b);Xla(b);Yla(b);Zla(b);_la(b);$la(b);ama(b);bma(b);cma(b);dma(b);ema(b);fma(b);gma(b);hma(b);ima(b);jma(b);kma(b);lma(b);mma(b);nma(b);oma(b);pma(b);qma(b);rma(b);sma(b);tma(b);uma(b);vma(b);wma(b);xma(b);yma(b);zma(b);Ama(b);Bma(b);Cma(b);Dma(b);Ema(b);Fma(b);Gma(b);Hma(b);Ima(b);Jma(b);Kma(b);Lma(b);Mma(b);Nma(b);Oma(b);Pma(b);Qma(b);Rma(b);Sma(b);Tma(b);Uma(b);Vma(b);Wma(b);Xma(b);Yma(b);Zma(b);_ma(b);$ma(b);ana(b);bna(b);cna(b);dna(b);ena(b);fna(b);gna(b);hna(b);ina(b);jna(b);kna(b);lna(b);mna(b);nna(b);ona(b);pna(b);qna(b);rna(b);sna(b);tna(b);una(b);vna(b);wna(b);xna(b);yna(b);zna(b);Ana(b);Bna(b);Cna(b);Dna(b);Ena(b);Fna(b);Gna(b);Hna(b);Ina(b);Jna(b);Kna(b);Lna(b);Mna(b);Nna(b);Ona(b);Pna(b);Qna(b);Rna(b);Sna(b);Tna(b);Una(b);Vna(b);Wna(b);Xna(b);Yna(b);Zna(b);_na(b);$na(b);aoa(b);boa(b);coa(b);doa(b);eoa(b);foa(b);goa(b);hoa(b);ioa(b);joa(b);koa(b);loa(b);moa(b);noa(b);ooa(b);poa(b);qoa(b);roa(b);soa(b);toa(b);uoa(b);voa(b);woa(b);xoa(b);yoa(b);zoa(b);Aoa(b);Boa(b);Coa(b);Doa(b);Eoa(b);Foa(b);Goa(b);Hoa(b);Ioa(b);Joa(b);Koa(b);Loa(b);Moa(b);Noa(b);Ooa(b);Poa(b);Qoa(b);Roa(b);Soa(b);Toa(b);Uoa(b);Voa(b);Woa(b);Xoa(b);Yoa(b);Zoa(b);_oa(b);$oa(b);apa(b);bpa(b);cpa(b);dpa(b);epa(b);fpa(b);gpa(b);hpa(b);ipa(b);jpa(b);kpa(b);lpa(b);mpa(b);npa(b);opa(b);ppa(b);qpa(b);rpa(b);spa(b);tpa(b);upa(b);vpa(b);wpa(b);xpa(b);ypa(b);zpa(b);Apa(b);Bpa(b);Cpa(b);Dpa(b);Epa(b);Fpa(b);Gpa(b);Hpa(b);Ipa(b);Jpa(b);Kpa(b);Lpa(b);Mpa(b);Npa(b);Opa(b);Ppa(b);Qpa(b);Rpa(b);Spa(b);Tpa(b);Upa(b);Vpa(b);Wpa(b);Xpa(b);Ypa(b);Zpa(b);_pa(b);$pa(b);aqa(b);bqa(b);cqa(b);dqa(b);eqa(b);fqa(b);gqa(b);hqa(b);iqa(b);jqa(b);kqa(b);lqa(b);mqa(b);nqa(b);oqa(b);pqa(b);qqa(b);rqa(b);sqa(b);tqa(b);uqa(b);vqa(b);wqa(b);xqa(b);yqa(b);zqa(b);Aqa(b);Bqa(b);Cqa(b);Dqa(b);Eqa(b);Fqa(b);Gqa(b);Hqa(b);Iqa(b);Jqa(b);Kqa(b);Lqa(b);Mqa(b);Nqa(b);Oqa(b);Pqa(b);Qqa(b);Rqa(b);Sqa(b);Tqa(b);Uqa(b);Vqa(b);Wqa(b);Xqa(b);Yqa(b);Zqa(b);_qa(b);$qa(b);ara(b);bra(b);cra(b);dra(b);era(b);fra(b);gra(b);hra(b);ira(b);jra(b);kra(b);lra(b);mra(b);nra(b);ora(b);pra(b);qra(b);rra(b);sra(b);tra(b);ura(b);vra(b);wra(b);xra(b);yra(b);zra(b);Ara(b);Bra(b);Cra(b);Dra(b);Era(b);Fra(b);Gra(b);Hra(b);Ira(b);Jra(b);Kra(b);Lra(b);Mra(b);Nra(b);Ora(b);Pra(b);Qra(b);Rra(b);Sra(b);Tra(b);Ura(b);Vra(b);Wra(b);Xra(b);Yra(b);Zra(b);_ra(b);$ra(b);asa(b);bsa(b);csa(b);dsa(b);esa(b);fsa(b);gsa(b);hsa(b);isa(b);jsa(b);ksa(b);lsa(b);msa(b);nsa(b);osa(b);psa(b);qsa(b);rsa(b);ssa(b);tsa(b);usa(b);vsa(b);wsa(b);xsa(b);ysa(b);zsa(b);Asa(b);Bsa(b);Csa(b);Dsa(b);Esa(b);Fsa(b);Gsa(b);Hsa(b);Isa(b);Jsa(b);Ksa(b);Lsa(b);Msa(b);Nsa(b);Osa(b);Psa(b);Qsa(b);Rsa(b);Ssa(b);Tsa(b);Usa(b);Vsa(b);Wsa(b);Xsa(b);Ysa(b);Zsa(b);_sa(b);$sa(b);ata(b);bta(b);cta(b);dta(b);eta(b);fta(b);gta(b);hta(b);ita(b);jta(b);kta(b);lta(b);mta(b);nta(b);ota(b);pta(b);qta(b);rta(b);sta(b);tta(b);uta(b);vta(b);wta(b);xta(b);yta(b);zta(b);Ata(b);Bta(b);Cta(b);Dta(b);Eta(b);Fta(b);Gta(b);Hta(b);Ita(b);Jta(b);Kta(b);Lta(b);Mta(b);Nta(b);Ota(b);Pta(b);Qta(b);Rta(b);Sta(b);Tta(b);Uta(b);Vta(b);Wta(b);Xta(b);Yta(b);Zta(b);_ta(b);$ta(b);aua(b);bua(b);cua(b);dua(b);eua(b);fua(b);gua(b);hua(b);iua(b);jua(b);kua(b);lua(b);mua(b);nua(b);oua(b);pua(b);qua(b);rua(b);sua(b);tua(b);uua(b);vua(b);wua(b);xua(b);yua(b);zua(b);Aua(b);Bua(b);Cua(b);Dua(b);Eua(b);Fua(b);Gua(b);Hua(b);Iua(b);Jua(b);Kua(b);Lua(b);Mua(b);Nua(b);Oua(b);Pua(b);Qua(b);Rua(b);Sua(b);Tua(b);Uua(b);Vua(b);Wua(b);Xua(b);Yua(b);Zua(b);_ua(b);$ua(b);ava(b);bva(b);cva(b);dva(b);eva(b);fva(b);gva(b);hva(b);iva(b);jva(b);kva(b);lva(b);mva(b);nva(b);ova(b);pva(b);qva(b);rva(b);sva(b);tva(b);uva(b);vva(b);wva(b);xva(b);yva(b);zva(b);Ava(b);Bva(b);Cva(b);Dva(b);Eva(b);Fva(b);Gva(b);Hva(b);Iva(b);Jva(b);Kva(b);Lva(b);Mva(b);Nva(b);Ova(b);Pva(b);Qva(b);Rva(b);Sva(b);Tva(b);Uva(b);Vva(b);Wva(b);Xva(b);Yva(b);Zva(b);_va(b);$va(b);awa(b);bwa(b);cwa(b);dwa(b);ewa(b);fwa(b);gwa(b);hwa(b);iwa(b);jwa(b);kwa(b);lwa(b);mwa(b);nwa(b);owa(b);pwa(b);qwa(b);rwa(b);swa(b);twa(b);uwa(b);vwa(b);wwa(b);xwa(b);ywa(b);zwa(b);Awa(b);Bwa(b);Cwa(b);Dwa(b);Ewa(b);Fwa(b);Gwa(b);Hwa(b);Iwa(b);Jwa(b);Kwa(b);Lwa(b);Mwa(b);Nwa(b);Owa(b);Pwa(b);Qwa(b);Rwa(b);Swa(b);Twa(b);Uwa(b);Vwa(b);Wwa(b);Xwa(b);Ywa(b);Zwa(b);_wa(b);$wa(b);axa(b);bxa(b);cxa(b);dxa(b);exa(b);fxa(b);gxa(b);hxa(b);ixa(b);jxa(b);kxa(b);lxa(b);mxa(b);nxa(b);oxa(b);pxa(b);qxa(b);rxa(b);sxa(b);txa(b);uxa(b);vxa(b);wxa(b);xxa(b);yxa(b);zxa(b);Axa(b);Bxa(b);Cxa(b);Dxa(b);Exa(b);Fxa(b);Gxa(b);Hxa(b);Ixa(b);Jxa(b);Kxa(b);Lxa(b);Mxa(b);Nxa(b);Oxa(b);Pxa(b);Qxa(b);Rxa(b);Sxa(b);Txa(b);Uxa(b);Vxa(b);Wxa(b);Xxa(b);Yxa(b);Zxa(b);_xa(b);$xa(b);aya(b);bya(b);cya(b);dya(b);eya(b);fya(b);gya(b);hya(b);iya(b);jya(b);kya(b);lya(b);mya(b);nya(b);oya(b);pya(b);qya(b);rya(b);sya(b);tya(b);uya(b);vya(b);wya(b);xya(b);yya(b);zya(b);Aya(b);Bya(b);Cya(b);Dya(b);Eya(b);Fya(b);Gya(b);Hya(b);Iya(b);Jya(b);Kya(b);Lya(b);Mya(b);Nya(b);Oya(b);Pya(b);Qya(b);Rya(b);Sya(b);Tya(b);Uya(b);Vya(b);Wya(b);Xya(b);Yya(b);Zya(b);_ya(b);$ya(b);aza(b);bza(b);cza(b);dza(b);eza(b);fza(b);gza(b);hza(b);iza(b);jza(b);kza(b);lza(b);mza(b);nza(b);oza(b);pza(b);qza(b);rza(b);sza(b);tza(b);uza(b);vza(b);wza(b);xza(b);yza(b);zza(b);Aza(b);Bza(b);Cza(b);Dza(b);Eza(b);Fza(b);Gza(b);Hza(b);Iza(b);Jza(b);Kza(b);Lza(b);Mza(b);Nza(b);Oza(b);Pza(b);Qza(b);Rza(b);Sza(b);Tza(b);Uza(b);Vza(b);Wza(b);Xza(b);Yza(b);Zza(b);_za(b);$za(b);aAa(b);bAa(b);cAa(b);dAa(b);eAa(b);fAa(b);gAa(b);hAa(b);iAa(b);jAa(b);kAa(b);lAa(b);mAa(b);nAa(b);oAa(b);pAa(b);qAa(b);rAa(b);sAa(b);tAa(b);uAa(b);vAa(b);wAa(b);xAa(b);yAa(b);zAa(b);AAa(b);BAa(b);CAa(b);DAa(b);EAa(b);FAa(b);GAa(b);HAa(b);IAa(b);JAa(b);KAa(b);LAa(b);MAa(b);NAa(b);OAa(b);PAa(b);QAa(b);RAa(b);SAa(b);TAa(b);UAa(b);VAa(b);WAa(b);XAa(b);YAa(b);ZAa(b);_Aa(b);$Aa(b);aBa(b);bBa(b);cBa(b);dBa(b);eBa(b);fBa(b);gBa(b);hBa(b);iBa(b);jBa(b);kBa(b);lBa(b);mBa(b);nBa(b);oBa(b);pBa(b);qBa(b);rBa(b);sBa(b);tBa(b);uBa(b);vBa(b);wBa(b);xBa(b);yBa(b);zBa(b);ABa(b);BBa(b);CBa(b);DBa(b);EBa(b);FBa(b);GBa(b);HBa(b);IBa(b);JBa(b);KBa(b);LBa(b);MBa(b);NBa(b);OBa(b);PBa(b);QBa(b);RBa(b);SBa(b);TBa(b);UBa(b);VBa(b);WBa(b);XBa(b);YBa(b);ZBa(b);_Ba(b);$Ba(b);aCa(b);bCa(b);cCa(b);dCa(b);eCa(b);fCa(b);gCa(b);hCa(b);iCa(b);jCa(b);kCa(b);lCa(b);mCa(b);nCa(b);oCa(b);pCa(b);qCa(b);rCa(b);sCa(b);tCa(b);uCa(b);vCa(b);wCa(b);xCa(b);yCa(b);zCa(b);ACa(b);BCa(b);CCa(b);DCa(b);ECa(b);FCa(b);GCa(b);HCa(b);ICa(b);JCa(b);KCa(b);LCa(b);MCa(b);NCa(b);OCa(b);PCa(b);QCa(b);RCa(b);SCa(b);TCa(b);UCa(b);VCa(b);WCa(b);XCa(b);YCa(b);ZCa(b);_Ca(b);$Ca(b);aDa(b);bDa(b);cDa(b);dDa(b);eDa(b);fDa(b);gDa(b);hDa(b);iDa(b);jDa(b);kDa(b);lDa(b);mDa(b);nDa(b);oDa(b);pDa(b);qDa(b);rDa(b);sDa(b);tDa(b);uDa(b);vDa(b);wDa(b);xDa(b);yDa(b);zDa(b);ADa(b);BDa(b);CDa(b);DDa(b);EDa(b);FDa(b);GDa(b);HDa(b);IDa(b);JDa(b);KDa(b);LDa(b);MDa(b);NDa(b);ODa(b);PDa(b);QDa(b);RDa(b);SDa(b);TDa(b);UDa(b);VDa(b);WDa(b);XDa(b);YDa(b);ZDa(b);_Da(b);$Da(b);aEa(b);bEa(b);cEa(b);dEa(b);eEa(b);fEa(b);gEa(b);hEa(b);iEa(b);jEa(b);kEa(b);lEa(b);mEa(b);nEa(b);oEa(b);pEa(b);qEa(b);rEa(b);sEa(b);tEa(b);uEa(b);vEa(b);wEa(b);xEa(b);yEa(b);zEa(b);AEa(b);BEa(b);CEa(b);DEa(b);EEa(b);FEa(b);GEa(b);HEa(b);IEa(b);JEa(b);KEa(b);LEa(b);MEa(b);NEa(b);OEa(b);PEa(b);QEa(b);REa(b);SEa(b);TEa(b);UEa(b);VEa(b);WEa(b);XEa(b);YEa(b);ZEa(b);_Ea(b);$Ea(b);aFa(b);bFa(b);cFa(b);dFa(b);eFa(b);fFa(b);gFa(b);hFa(b);iFa(b);jFa(b);kFa(b);lFa(b);mFa(b);nFa(b);oFa(b);pFa(b);qFa(b);rFa(b);sFa(b);tFa(b);uFa(b);vFa(b);wFa(b);xFa(b);yFa(b);zFa(b);AFa(b);BFa(b);CFa(b);DFa(b);EFa(b);FFa(b);GFa(b);HFa(b);IFa(b);JFa(b);KFa(b);LFa(b);MFa(b);NFa(b);OFa(b);PFa(b);QFa(b);RFa(b);SFa(b);TFa(b);UFa(b);VFa(b);WFa(b);XFa(b);YFa(b);ZFa(b);_Fa(b);$Fa(b);aGa(b);bGa(b);cGa(b);dGa(b);eGa(b);fGa(b);gGa(b);hGa(b);iGa(b);jGa(b);kGa(b);lGa(b);mGa(b);nGa(b);oGa(b);pGa(b);qGa(b);rGa(b);sGa(b);tGa(b);uGa(b);vGa(b);wGa(b);xGa(b);yGa(b);zGa(b);AGa(b);BGa(b);CGa(b);DGa(b);EGa(b);FGa(b);GGa(b);HGa(b);IGa(b);JGa(b);KGa(b);LGa(b);MGa(b);NGa(b);OGa(b);PGa(b);QGa(b);RGa(b);SGa(b);TGa(b);UGa(b);VGa(b);WGa(b);XGa(b);YGa(b);ZGa(b);_Ga(b);$Ga(b);aHa(b);bHa(b);cHa(b);dHa(b);eHa(b);fHa(b);gHa(b);hHa(b);iHa(b);jHa(b);kHa(b);lHa(b);mHa(b);nHa(b);oHa(b);pHa(b);qHa(b);rHa(b);sHa(b);tHa(b);uHa(b);vHa(b);wHa(b);xHa(b);yHa(b);zHa(b);AHa(b);BHa(b);CHa(b);DHa(b);EHa(b);FHa(b);GHa(b);HHa(b);IHa(b);JHa(b);KHa(b);LHa(b);MHa(b);NHa(b);OHa(b);PHa(b);QHa(b);RHa(b);SHa(b);THa(b);UHa(b);VHa(b);WHa(b);XHa(b);YHa(b);ZHa(b);_Ha(b);$Ha(b);aIa(b);bIa(b);cIa(b);dIa(b);eIa(b);fIa(b);gIa(b);hIa(b);iIa(b);jIa(b);kIa(b);lIa(b);mIa(b);nIa(b);oIa(b);pIa(b);qIa(b);rIa(b);sIa(b);tIa(b);uIa(b);vIa(b);wIa(b);xIa(b);yIa(b);zIa(b);AIa(b);BIa(b);CIa(b);DIa(b);EIa(b);FIa(b);GIa(b);HIa(b);IIa(b);JIa(b);KIa(b);LIa(b);MIa(b);NIa(b);OIa(b);PIa(b);QIa(b);RIa(b);SIa(b);TIa(b);UIa(b);VIa(b);WIa(b);XIa(b);YIa(b);ZIa(b);_Ia(b);$Ia(b);aJa(b);bJa(b);cJa(b);dJa(b);eJa(b);fJa(b);gJa(b);hJa(b);iJa(b);jJa(b);kJa(b);lJa(b);mJa(b);nJa(b);oJa(b);pJa(b);qJa(b);rJa(b);sJa(b);tJa(b);uJa(b);vJa(b);wJa(b);xJa(b);yJa(b);zJa(b);AJa(b);BJa(b);CJa(b);DJa(b);EJa(b);FJa(b);GJa(b);HJa(b);IJa(b);JJa(b);KJa(b);LJa(b);MJa(b);NJa(b);OJa(b);PJa(b);QJa(b);RJa(b);SJa(b);TJa(b);UJa(b);VJa(b);WJa(b);XJa(b);YJa(b);ZJa(b);_Ja(b);$Ja(b);aKa(b);bKa(b);cKa(b);dKa(b);eKa(b);fKa(b);gKa(b);hKa(b);iKa(b);jKa(b);kKa(b);lKa(b);mKa(b);nKa(b);oKa(b);pKa(b);qKa(b);rKa(b);sKa(b);tKa(b);uKa(b);vKa(b);wKa(b);xKa(b);yKa(b);zKa(b);AKa(b);BKa(b);CKa(b);DKa(b);EKa(b);FKa(b);GKa(b);HKa(b);IKa(b);JKa(b);KKa(b);LKa(b);MKa(b);NKa(b);OKa(b);PKa(b);QKa(b);RKa(b);SKa(b);TKa(b);UKa(b);VKa(b);WKa(b);XKa(b);YKa(b);ZKa(b);_Ka(b);$Ka(b);aLa(b);bLa(b);cLa(b);dLa(b);eLa(b);fLa(b);gLa(b);hLa(b);iLa(b);jLa(b);kLa(b);lLa(b);mLa(b);nLa(b);oLa(b);pLa(b);qLa(b);rLa(b);sLa(b);tLa(b);uLa(b);vLa(b);wLa(b);xLa(b);yLa(b);zLa(b);ALa(b);BLa(b);CLa(b);DLa(b);ELa(b);FLa(b);GLa(b);HLa(b);ILa(b);JLa(b);KLa(b);LLa(b);MLa(b);NLa(b);OLa(b);PLa(b);QLa(b);RLa(b);SLa(b);TLa(b);ULa(b);VLa(b);WLa(b);XLa(b);YLa(b);ZLa(b);_La(b);$La(b);aMa(b);bMa(b);cMa(b);dMa(b);eMa(b);fMa(b);gMa(b);hMa(b);iMa(b);jMa(b);kMa(b);lMa(b);mMa(b);nMa(b);oMa(b);pMa(b);qMa(b);rMa(b);sMa(b);tMa(b);uMa(b);vMa(b);wMa(b);xMa(b);yMa(b);zMa(b);AMa(b);BMa(b);CMa(b);DMa(b);EMa(b);FMa(b);GMa(b);HMa(b);IMa(b);JMa(b);KMa(b);LMa(b);MMa(b);NMa(b);OMa(b);PMa(b);QMa(b);RMa(b);SMa(b);TMa(b);UMa(b);VMa(b);WMa(b);XMa(b);YMa(b);ZMa(b);_Ma(b);$Ma(b);aNa(b);bNa(b);cNa(b);dNa(b);eNa(b);fNa(b);gNa(b);hNa(b);iNa(b);jNa(b);kNa(b);lNa(b);mNa(b);nNa(b);oNa(b);pNa(b);qNa(b);rNa(b);sNa(b);tNa(b);uNa(b);vNa(b);wNa(b);xNa(b);yNa(b);zNa(b);ANa(b);BNa(b);CNa(b);DNa(b);ENa(b);FNa(b);GNa(b);HNa(b);INa(b);JNa(b);KNa(b);LNa(b);MNa(b);NNa(b);ONa(b);PNa(b);QNa(b);RNa(b);SNa(b);TNa(b);UNa(b);VNa(b);WNa(b);XNa(b);YNa(b);ZNa(b);_Na(b);$Na(b);aOa(b);bOa(b);cOa(b);dOa(b);eOa(b);fOa(b);gOa(b);hOa(b);iOa(b);jOa(b);kOa(b);lOa(b);mOa(b);nOa(b);oOa(b);pOa(b);qOa(b);rOa(b);sOa(b);tOa(b);uOa(b);vOa(b);wOa(b);xOa(b);yOa(b);zOa(b);AOa(b);BOa(b);COa(b);DOa(b);EOa(b);FOa(b);GOa(b);HOa(b);IOa(b);JOa(b);KOa(b);LOa(b);MOa(b);NOa(b);OOa(b);POa(b);QOa(b);ROa(b);SOa(b);TOa(b);UOa(b);VOa(b);WOa(b);XOa(b);YOa(b);ZOa(b);_Oa(b);$Oa(b);aPa(b);bPa(b);cPa(b);dPa(b);ePa(b);fPa(b);gPa(b);hPa(b);iPa(b);jPa(b);kPa(b);lPa(b);mPa(b);nPa(b);oPa(b);pPa(b);qPa(b);rPa(b);sPa(b);tPa(b);uPa(b);vPa(b);wPa(b);xPa(b);yPa(b);zPa(b);APa(b);BPa(b);CPa(b);DPa(b);EPa(b);FPa(b);GPa(b);HPa(b);IPa(b);JPa(b);KPa(b);LPa(b);MPa(b);NPa(b);OPa(b);PPa(b);QPa(b);RPa(b);SPa(b);TPa(b);UPa(b);VPa(b);WPa(b);XPa(b);YPa(b);ZPa(b);_Pa(b);$Pa(b);aQa(b);bQa(b);cQa(b);dQa(b);eQa(b);fQa(b);gQa(b);hQa(b);iQa(b);jQa(b);kQa(b);lQa(b);mQa(b);nQa(b);oQa(b);pQa(b);qQa(b);rQa(b);sQa(b);tQa(b);uQa(b);vQa(b);wQa(b);xQa(b);yQa(b);zQa(b);AQa(b);BQa(b);CQa(b);DQa(b);EQa(b);FQa(b);GQa(b);HQa(b);IQa(b);JQa(b);KQa(b);LQa(b);MQa(b);NQa(b);OQa(b);PQa(b);QQa(b);RQa(b);SQa(b);TQa(b);UQa(b);VQa(b);WQa(b);XQa(b);YQa(b);ZQa(b);_Qa(b);$Qa(b);aRa(b);bRa(b);cRa(b);dRa(b);eRa(b);fRa(b);gRa(b);hRa(b);iRa(b);jRa(b);kRa(b);lRa(b);mRa(b);nRa(b);oRa(b);pRa(b);qRa(b);rRa(b);sRa(b);tRa(b);uRa(b);vRa(b);wRa(b);xRa(b);yRa(b);zRa(b);ARa(b);BRa(b);CRa(b);DRa(b);ERa(b);FRa(b);GRa(b);HRa(b);IRa(b);JRa(b);KRa(b);LRa(b);MRa(b);NRa(b);ORa(b);PRa(b);QRa(b);RRa(b);SRa(b);TRa(b);URa(b);VRa(b);WRa(b);XRa(b);YRa(b);ZRa(b);_Ra(b);$Ra(b);aSa(b);bSa(b);cSa(b);dSa(b);eSa(b);fSa(b);gSa(b);hSa(b);iSa(b);jSa(b);kSa(b);lSa(b);mSa(b);nSa(b);oSa(b);pSa(b);qSa(b);rSa(b);sSa(b);tSa(b);uSa(b);vSa(b);wSa(b);xSa(b);ySa(b);zSa(b);ASa(b);BSa(b);CSa(b);DSa(b);ESa(b);FSa(b);GSa(b);HSa(b);ISa(b);JSa(b);KSa(b);LSa(b);MSa(b);NSa(b);OSa(b);PSa(b);QSa(b);RSa(b);SSa(b);TSa(b);USa(b);VSa(b);WSa(b);XSa(b);YSa(b);ZSa(b);_Sa(b);$Sa(b);aTa(b);bTa(b);cTa(b);dTa(b);eTa(b);fTa(b);gTa(b);hTa(b);iTa(b);jTa(b);kTa(b);lTa(b);mTa(b);nTa(b);oTa(b);pTa(b);qTa(b);rTa(b);sTa(b);tTa(b);uTa(b);vTa(b);wTa(b);xTa(b);yTa(b);zTa(b);ATa(b);BTa(b);CTa(b);DTa(b);ETa(b);FTa(b);GTa(b);HTa(b);ITa(b);JTa(b);KTa(b);LTa(b);MTa(b);NTa(b);OTa(b);PTa(b);QTa(b);RTa(b);STa(b);TTa(b);UTa(b);VTa(b);WTa(b);XTa(b);YTa(b);ZTa(b);_Ta(b);$Ta(b);aUa(b);bUa(b);cUa(b);dUa(b);eUa(b);fUa(b);gUa(b);hUa(b);iUa(b);jUa(b);kUa(b);lUa(b);mUa(b);nUa(b);oUa(b);pUa(b);qUa(b);rUa(b);sUa(b);tUa(b);uUa(b);vUa(b);wUa(b);xUa(b);yUa(b);zUa(b);AUa(b);a[d]=0;i=c;return 0}function CUa(a){a=a|0;i=i;return}function DUa(a){a=a|0;i=i;return 0}function EUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+8>>3]=+h[(c[a+416>>2]|0)+38552>>3];i=i;return}function FUa(a){a=a|0;h[c[(c[c[a+4>>2]>>2]|0)+8>>2]>>3]=+h[(c[a+416>>2]|0)+38544>>3];i=i;return}function GUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+26632>>3]=+h[(c[a+416>>2]|0)+36928>>3];i=i;return}function HUa(a){a=a|0;var b=0,d=0,e=0,f=0,g=0,j=0,l=0,m=0,n=0.0;b=i;i=i+16|0;d=b;e=i;i=i+16|0;f=i;i=i+16|0;g=i;i=i+8|0;j=i;i=i+8|0;l=i;i=i+8|0;m=i;i=i+8|0;EBc(9,1,6320,m);if((c[292340>>2]|0)!=0){fe[c[73214]&1023](9)}EBc(9,1,6344,l);if((c[292340>>2]|0)!=0){fe[c[73214]&1023](9)}EBc(9,1,6368,j);if((c[292340>>2]|0)!=0){fe[c[73214]&1023](9)}EUa(a);FUa(a);GUa(a);EBc(9,1,6392,g);g=a+4|0;n=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+8>>3];j=a+8|0;a=c[j>>2]|0;h[a+208>>3]=n;c[f>>2]=c[a+116>>2];a=f+4|0;h[k>>3]=n;c[a>>2]=c[k>>2];c[a+4>>2]=c[k+4>>2];EBc(9,0,6416,f);n=+h[c[(c[c[g>>2]>>2]|0)+8>>2]>>3];f=c[j>>2]|0;h[f+96>>3]=n;c[e>>2]=c[f+4>>2];f=e+4|0;h[k>>3]=n;c[f>>2]=c[k>>2];c[f+4>>2]=c[k+4>>2];EBc(9,0,6416,e);n=+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26632>>3];g=c[j>>2]|0;h[g+372944>>3]=n;c[d>>2]=c[g+372852>>2];g=d+4|0;h[k>>3]=n;c[g>>2]=c[k>>2];c[g+4>>2]=c[k+4>>2];EBc(9,0,6416,d);if((c[292340>>2]|0)==0){i=b;return 0}fe[c[73214]&1023](9);i=b;return 0}function IUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4328>>3]=0.0;i=i;return}function JUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4352>>3]=0.0;i=i;return}function KUa(a){a=a|0;h[(c[(c[c[a+4>>2]>>2]|0)+8>>2]|0)+4376>>3]=0.0;i=i;return}



function Dvc(a){a=a|0;var b=0;b=i;IUa(a);JUa(a);KUa(a);LUa(a);MUa(a);NUa(a);OUa(a);PUa(a);QUa(a);RUa(a);SUa(a);TUa(a);UUa(a);VUa(a);WUa(a);XUa(a);YUa(a);ZUa(a);_Ua(a);$Ua(a);aVa(a);bVa(a);cVa(a);dVa(a);eVa(a);fVa(a);gVa(a);hVa(a);iVa(a);jVa(a);kVa(a);lVa(a);mVa(a);nVa(a);oVa(a);pVa(a);qVa(a);rVa(a);sVa(a);tVa(a);uVa(a);vVa(a);wVa(a);xVa(a);yVa(a);zVa(a);AVa(a);BVa(a);CVa(a);DVa(a);EVa(a);FVa(a);GVa(a);HVa(a);IVa(a);JVa(a);KVa(a);LVa(a);MVa(a);NVa(a);OVa(a);PVa(a);QVa(a);RVa(a);SVa(a);TVa(a);UVa(a);VVa(a);WVa(a);XVa(a);YVa(a);ZVa(a);_Va(a);$Va(a);aWa(a);bWa(a);cWa(a);dWa(a);eWa(a);fWa(a);gWa(a);hWa(a);iWa(a);jWa(a);kWa(a);lWa(a);mWa(a);nWa(a);oWa(a);pWa(a);qWa(a);rWa(a);sWa(a);tWa(a);uWa(a);vWa(a);wWa(a);xWa(a);yWa(a);zWa(a);AWa(a);BWa(a);CWa(a);DWa(a);EWa(a);FWa(a);GWa(a);HWa(a);IWa(a);JWa(a);KWa(a);LWa(a);MWa(a);NWa(a);OWa(a);PWa(a);QWa(a);RWa(a);SWa(a);TWa(a);UWa(a);VWa(a);WWa(a);XWa(a);YWa(a);ZWa(a);_Wa(a);$Wa(a);aXa(a);bXa(a);cXa(a);dXa(a);eXa(a);fXa(a);gXa(a);hXa(a);iXa(a);jXa(a);kXa(a);lXa(a);mXa(a);nXa(a);oXa(a);pXa(a);qXa(a);rXa(a);sXa(a);tXa(a);uXa(a);vXa(a);wXa(a);xXa(a);yXa(a);zXa(a);AXa(a);BXa(a);CXa(a);DXa(a);EXa(a);FXa(a);GXa(a);HXa(a);IXa(a);JXa(a);KXa(a);LXa(a);MXa(a);NXa(a);OXa(a);PXa(a);QXa(a);RXa(a);SXa(a);TXa(a);UXa(a);VXa(a);WXa(a);XXa(a);YXa(a);ZXa(a);_Xa(a);$Xa(a);aYa(a);bYa(a);cYa(a);dYa(a);eYa(a);fYa(a);gYa(a);hYa(a);iYa(a);jYa(a);kYa(a);lYa(a);mYa(a);nYa(a);oYa(a);pYa(a);qYa(a);rYa(a);sYa(a);tYa(a);uYa(a);vYa(a);wYa(a);xYa(a);yYa(a);zYa(a);AYa(a);BYa(a);CYa(a);DYa(a);EYa(a);FYa(a);GYa(a);HYa(a);IYa(a);JYa(a);KYa(a);LYa(a);MYa(a);NYa(a);OYa(a);PYa(a);QYa(a);RYa(a);SYa(a);TYa(a);UYa(a);VYa(a);WYa(a);XYa(a);YYa(a);ZYa(a);_Ya(a);$Ya(a);aZa(a);bZa(a);cZa(a);dZa(a);eZa(a);fZa(a);gZa(a);hZa(a);iZa(a);jZa(a);kZa(a);lZa(a);mZa(a);nZa(a);oZa(a);pZa(a);qZa(a);rZa(a);sZa(a);tZa(a);uZa(a);vZa(a);wZa(a);xZa(a);yZa(a);zZa(a);AZa(a);BZa(a);CZa(a);DZa(a);EZa(a);FZa(a);GZa(a);HZa(a);IZa(a);JZa(a);KZa(a);LZa(a);MZa(a);NZa(a);OZa(a);PZa(a);QZa(a);RZa(a);SZa(a);TZa(a);UZa(a);VZa(a);WZa(a);XZa(a);YZa(a);ZZa(a);_Za(a);$Za(a);a_a(a);b_a(a);c_a(a);d_a(a);e_a(a);f_a(a);g_a(a);h_a(a);i_a(a);j_a(a);k_a(a);l_a(a);m_a(a);n_a(a);o_a(a);p_a(a);q_a(a);r_a(a);s_a(a);t_a(a);u_a(a);v_a(a);w_a(a);x_a(a);y_a(a);z_a(a);A_a(a);B_a(a);C_a(a);D_a(a);E_a(a);F_a(a);G_a(a);H_a(a);I_a(a);J_a(a);K_a(a);L_a(a);M_a(a);N_a(a);O_a(a);P_a(a);Q_a(a);R_a(a);S_a(a);T_a(a);U_a(a);V_a(a);W_a(a);X_a(a);Y_a(a);Z_a(a);__a(a);$_a(a);a$a(a);b$a(a);c$a(a);d$a(a);e$a(a);f$a(a);g$a(a);h$a(a);i$a(a);j$a(a);k$a(a);l$a(a);m$a(a);n$a(a);o$a(a);p$a(a);q$a(a);r$a(a);s$a(a);t$a(a);u$a(a);v$a(a);w$a(a);x$a(a);y$a(a);z$a(a);A$a(a);B$a(a);C$a(a);D$a(a);E$a(a);F$a(a);G$a(a);H$a(a);I$a(a);J$a(a);K$a(a);L$a(a);M$a(a);N$a(a);O$a(a);P$a(a);Q$a(a);R$a(a);S$a(a);T$a(a);U$a(a);V$a(a);W$a(a);X$a(a);Y$a(a);Z$a(a);_$a(a);$$a(a);a0a(a);b0a(a);c0a(a);d0a(a);e0a(a);f0a(a);g0a(a);h0a(a);i0a(a);j0a(a);k0a(a);l0a(a);m0a(a);n0a(a);o0a(a);p0a(a);q0a(a);r0a(a);s0a(a);t0a(a);u0a(a);v0a(a);w0a(a);x0a(a);y0a(a);z0a(a);A0a(a);B0a(a);C0a(a);D0a(a);E0a(a);F0a(a);G0a(a);H0a(a);I0a(a);J0a(a);K0a(a);L0a(a);M0a(a);N0a(a);O0a(a);P0a(a);Q0a(a);R0a(a);S0a(a);T0a(a);U0a(a);V0a(a);W0a(a);X0a(a);Y0a(a);Z0a(a);_0a(a);$0a(a);a1a(a);b1a(a);c1a(a);d1a(a);e1a(a);f1a(a);g1a(a);h1a(a);i1a(a);j1a(a);k1a(a);l1a(a);m1a(a);n1a(a);o1a(a);p1a(a);q1a(a);r1a(a);s1a(a);t1a(a);u1a(a);v1a(a);w1a(a);x1a(a);y1a(a);z1a(a);A1a(a);B1a(a);C1a(a);D1a(a);E1a(a);F1a(a);G1a(a);H1a(a);I1a(a);J1a(a);K1a(a);L1a(a);M1a(a);N1a(a);O1a(a);P1a(a);Q1a(a);R1a(a);S1a(a);T1a(a);U1a(a);V1a(a);W1a(a);X1a(a);Y1a(a);Z1a(a);_1a(a);$1a(a);a2a(a);b2a(a);c2a(a);d2a(a);e2a(a);f2a(a);g2a(a);h2a(a);i2a(a);j2a(a);k2a(a);l2a(a);m2a(a);n2a(a);o2a(a);p2a(a);q2a(a);r2a(a);s2a(a);t2a(a);u2a(a);v2a(a);w2a(a);x2a(a);y2a(a);z2a(a);A2a(a);B2a(a);C2a(a);D2a(a);E2a(a);F2a(a);G2a(a);H2a(a);I2a(a);J2a(a);K2a(a);L2a(a);M2a(a);N2a(a);O2a(a);P2a(a);Q2a(a);R2a(a);S2a(a);T2a(a);U2a(a);V2a(a);W2a(a);X2a(a);Y2a(a);Z2a(a);_2a(a);$2a(a);a3a(a);b3a(a);c3a(a);d3a(a);e3a(a);f3a(a);g3a(a);h3a(a);i3a(a);j3a(a);k3a(a);l3a(a);m3a(a);n3a(a);o3a(a);p3a(a);q3a(a);r3a(a);s3a(a);t3a(a);u3a(a);v3a(a);w3a(a);x3a(a);y3a(a);z3a(a);A3a(a);B3a(a);C3a(a);D3a(a);E3a(a);F3a(a);G3a(a);H3a(a);I3a(a);J3a(a);K3a(a);L3a(a);M3a(a);N3a(a);O3a(a);P3a(a);Q3a(a);R3a(a);S3a(a);T3a(a);U3a(a);V3a(a);W3a(a);X3a(a);Y3a(a);Z3a(a);_3a(a);$3a(a);a4a(a);b4a(a);c4a(a);d4a(a);e4a(a);f4a(a);g4a(a);h4a(a);i4a(a);j4a(a);k4a(a);l4a(a);m4a(a);n4a(a);o4a(a);p4a(a);q4a(a);r4a(a);s4a(a);t4a(a);u4a(a);v4a(a);w4a(a);x4a(a);y4a(a);z4a(a);A4a(a);B4a(a);C4a(a);D4a(a);E4a(a);F4a(a);G4a(a);H4a(a);I4a(a);J4a(a);K4a(a);L4a(a);M4a(a);N4a(a);O4a(a);P4a(a);Q4a(a);R4a(a);S4a(a);T4a(a);U4a(a);V4a(a);W4a(a);X4a(a);Y4a(a);Z4a(a);_4a(a);$4a(a);a5a(a);b5a(a);c5a(a);d5a(a);e5a(a);f5a(a);g5a(a);h5a(a);i5a(a);j5a(a);k5a(a);l5a(a);m5a(a);n5a(a);o5a(a);p5a(a);q5a(a);r5a(a);s5a(a);t5a(a);u5a(a);v5a(a);w5a(a);x5a(a);y5a(a);z5a(a);A5a(a);B5a(a);C5a(a);D5a(a);E5a(a);F5a(a);G5a(a);H5a(a);I5a(a);J5a(a);K5a(a);L5a(a);M5a(a);N5a(a);O5a(a);P5a(a);Q5a(a);R5a(a);S5a(a);T5a(a);U5a(a);V5a(a);W5a(a);X5a(a);Y5a(a);Z5a(a);_5a(a);$5a(a);a6a(a);b6a(a);c6a(a);d6a(a);e6a(a);f6a(a);g6a(a);h6a(a);i6a(a);j6a(a);k6a(a);l6a(a);m6a(a);n6a(a);o6a(a);p6a(a);q6a(a);r6a(a);s6a(a);t6a(a);u6a(a);v6a(a);w6a(a);x6a(a);y6a(a);z6a(a);A6a(a);B6a(a);C6a(a);D6a(a);E6a(a);F6a(a);G6a(a);H6a(a);I6a(a);J6a(a);K6a(a);L6a(a);M6a(a);N6a(a);O6a(a);P6a(a);Q6a(a);R6a(a);S6a(a);T6a(a);U6a(a);V6a(a);W6a(a);X6a(a);Y6a(a);Z6a(a);_6a(a);$6a(a);a7a(a);b7a(a);c7a(a);d7a(a);e7a(a);f7a(a);g7a(a);h7a(a);i7a(a);j7a(a);k7a(a);l7a(a);m7a(a);n7a(a);o7a(a);p7a(a);q7a(a);r7a(a);s7a(a);t7a(a);u7a(a);v7a(a);w7a(a);x7a(a);y7a(a);z7a(a);A7a(a);B7a(a);C7a(a);D7a(a);E7a(a);F7a(a);G7a(a);H7a(a);I7a(a);J7a(a);K7a(a);L7a(a);M7a(a);N7a(a);O7a(a);P7a(a);Q7a(a);R7a(a);S7a(a);T7a(a);U7a(a);V7a(a);W7a(a);X7a(a);Y7a(a);Z7a(a);_7a(a);$7a(a);a8a(a);b8a(a);c8a(a);d8a(a);e8a(a);f8a(a);g8a(a);h8a(a);i8a(a);j8a(a);k8a(a);l8a(a);m8a(a);n8a(a);o8a(a);p8a(a);q8a(a);r8a(a);s8a(a);t8a(a);u8a(a);v8a(a);w8a(a);x8a(a);y8a(a);z8a(a);A8a(a);B8a(a);C8a(a);D8a(a);E8a(a);F8a(a);G8a(a);H8a(a);I8a(a);J8a(a);K8a(a);L8a(a);M8a(a);N8a(a);O8a(a);P8a(a);Q8a(a);R8a(a);S8a(a);T8a(a);U8a(a);V8a(a);W8a(a);X8a(a);Y8a(a);Z8a(a);_8a(a);$8a(a);a9a(a);b9a(a);c9a(a);d9a(a);e9a(a);f9a(a);g9a(a);h9a(a);i9a(a);j9a(a);k9a(a);l9a(a);m9a(a);n9a(a);o9a(a);p9a(a);q9a(a);r9a(a);s9a(a);t9a(a);u9a(a);v9a(a);w9a(a);x9a(a);y9a(a);z9a(a);A9a(a);B9a(a);C9a(a);D9a(a);E9a(a);F9a(a);G9a(a);H9a(a);I9a(a);J9a(a);K9a(a);L9a(a);M9a(a);N9a(a);O9a(a);P9a(a);Q9a(a);R9a(a);S9a(a);T9a(a);U9a(a);V9a(a);W9a(a);X9a(a);Y9a(a);Z9a(a);_9a(a);$9a(a);aab(a);bab(a);cab(a);dab(a);eab(a);fab(a);gab(a);hab(a);iab(a);jab(a);kab(a);lab(a);mab(a);nab(a);oab(a);pab(a);qab(a);rab(a);sab(a);tab(a);uab(a);vab(a);wab(a);xab(a);yab(a);zab(a);Aab(a);Bab(a);Cab(a);Dab(a);Eab(a);Fab(a);Gab(a);Hab(a);Iab(a);Jab(a);Kab(a);Lab(a);Mab(a);Nab(a);Oab(a);Pab(a);Qab(a);Rab(a);Sab(a);Tab(a);Uab(a);Vab(a);Wab(a);Xab(a);Yab(a);Zab(a);_ab(a);$ab(a);abb(a);bbb(a);cbb(a);dbb(a);ebb(a);fbb(a);gbb(a);hbb(a);ibb(a);jbb(a);kbb(a);lbb(a);mbb(a);nbb(a);obb(a);pbb(a);qbb(a);rbb(a);sbb(a);tbb(a);ubb(a);vbb(a);wbb(a);xbb(a);ybb(a);zbb(a);Abb(a);Bbb(a);Cbb(a);Dbb(a);Ebb(a);Fbb(a);Gbb(a);Hbb(a);Ibb(a);Jbb(a);Kbb(a);Lbb(a);Mbb(a);Nbb(a);Obb(a);Pbb(a);Qbb(a);Rbb(a);Sbb(a);Tbb(a);Ubb(a);Vbb(a);Wbb(a);Xbb(a);Ybb(a);Zbb(a);_bb(a);$bb(a);acb(a);bcb(a);ccb(a);dcb(a);ecb(a);fcb(a);gcb(a);hcb(a);icb(a);jcb(a);kcb(a);lcb(a);mcb(a);ncb(a);ocb(a);pcb(a);qcb(a);rcb(a);scb(a);tcb(a);ucb(a);vcb(a);wcb(a);xcb(a);ycb(a);zcb(a);Acb(a);Bcb(a);Ccb(a);Dcb(a);Ecb(a);Fcb(a);Gcb(a);Hcb(a);Icb(a);Jcb(a);Kcb(a);Lcb(a);Mcb(a);Ncb(a);Ocb(a);Pcb(a);Qcb(a);Rcb(a);Scb(a);Tcb(a);Ucb(a);Vcb(a);Wcb(a);Xcb(a);Ycb(a);Zcb(a);_cb(a);$cb(a);adb(a);bdb(a);cdb(a);ddb(a);edb(a);fdb(a);gdb(a);hdb(a);idb(a);jdb(a);kdb(a);ldb(a);mdb(a);ndb(a);odb(a);pdb(a);qdb(a);rdb(a);sdb(a);tdb(a);udb(a);vdb(a);wdb(a);xdb(a);ydb(a);zdb(a);Adb(a);Bdb(a);Cdb(a);Ddb(a);Edb(a);Fdb(a);Gdb(a);Hdb(a);Idb(a);Jdb(a);Kdb(a);Ldb(a);Mdb(a);Ndb(a);Odb(a);Pdb(a);Qdb(a);Rdb(a);Sdb(a);Tdb(a);Udb(a);Vdb(a);Wdb(a);Xdb(a);Ydb(a);Zdb(a);_db(a);$db(a);aeb(a);beb(a);ceb(a);deb(a);eeb(a);feb(a);geb(a);heb(a);ieb(a);jeb(a);keb(a);leb(a);meb(a);neb(a);oeb(a);peb(a);qeb(a);reb(a);seb(a);teb(a);ueb(a);veb(a);web(a);xeb(a);yeb(a);zeb(a);Aeb(a);Beb(a);Ceb(a);Deb(a);Eeb(a);Feb(a);Geb(a);Heb(a);Ieb(a);Jeb(a);Keb(a);Leb(a);Meb(a);Neb(a);Oeb(a);Peb(a);Qeb(a);Reb(a);Seb(a);Teb(a);Ueb(a);Veb(a);Web(a);Xeb(a);Yeb(a);Zeb(a);_eb(a);$eb(a);afb(a);bfb(a);cfb(a);dfb(a);efb(a);ffb(a);gfb(a);hfb(a);ifb(a);jfb(a);kfb(a);lfb(a);mfb(a);nfb(a);ofb(a);pfb(a);qfb(a);rfb(a);sfb(a);tfb(a);ufb(a);vfb(a);wfb(a);xfb(a);yfb(a);zfb(a);Afb(a);Bfb(a);Cfb(a);Dfb(a);Efb(a);Ffb(a);Gfb(a);Hfb(a);Ifb(a);Jfb(a);Kfb(a);Lfb(a);Mfb(a);Nfb(a);Ofb(a);Pfb(a);Qfb(a);Rfb(a);Sfb(a);Tfb(a);Ufb(a);Vfb(a);Wfb(a);Xfb(a);Yfb(a);Zfb(a);_fb(a);$fb(a);agb(a);bgb(a);cgb(a);dgb(a);egb(a);fgb(a);ggb(a);hgb(a);igb(a);jgb(a);kgb(a);lgb(a);mgb(a);ngb(a);ogb(a);pgb(a);qgb(a);rgb(a);sgb(a);tgb(a);ugb(a);vgb(a);wgb(a);xgb(a);ygb(a);zgb(a);Agb(a);Bgb(a);Cgb(a);Dgb(a);Egb(a);Fgb(a);Ggb(a);Hgb(a);Igb(a);Jgb(a);Kgb(a);Lgb(a);Mgb(a);Ngb(a);Ogb(a);Pgb(a);Qgb(a);Rgb(a);Sgb(a);Tgb(a);Ugb(a);Vgb(a);Wgb(a);Xgb(a);Ygb(a);Zgb(a);_gb(a);$gb(a);ahb(a);bhb(a);chb(a);dhb(a);ehb(a);fhb(a);ghb(a);hhb(a);ihb(a);jhb(a);khb(a);lhb(a);mhb(a);nhb(a);ohb(a);phb(a);qhb(a);rhb(a);shb(a);thb(a);uhb(a);vhb(a);whb(a);xhb(a);yhb(a);zhb(a);Ahb(a);Bhb(a);Chb(a);Dhb(a);Ehb(a);Fhb(a);Ghb(a);Hhb(a);Ihb(a);Jhb(a);Khb(a);Lhb(a);Mhb(a);Nhb(a);Ohb(a);Phb(a);Qhb(a);Rhb(a);Shb(a);Thb(a);Uhb(a);Vhb(a);Whb(a);Xhb(a);Yhb(a);Zhb(a);_hb(a);$hb(a);aib(a);bib(a);cib(a);dib(a);eib(a);fib(a);gib(a);hib(a);iib(a);jib(a);kib(a);lib(a);mib(a);nib(a);oib(a);pib(a);qib(a);rib(a);sib(a);tib(a);uib(a);vib(a);wib(a);xib(a);yib(a);zib(a);Aib(a);Bib(a);Cib(a);Dib(a);Eib(a);Fib(a);Gib(a);Hib(a);Iib(a);Jib(a);Kib(a);Lib(a);Mib(a);Nib(a);Oib(a);Pib(a);Qib(a);Rib(a);Sib(a);Tib(a);Uib(a);Vib(a);Wib(a);Xib(a);Yib(a);Zib(a);_ib(a);$ib(a);ajb(a);bjb(a);cjb(a);djb(a);ejb(a);fjb(a);gjb(a);hjb(a);ijb(a);jjb(a);kjb(a);ljb(a);mjb(a);njb(a);ojb(a);pjb(a);qjb(a);rjb(a);sjb(a);tjb(a);ujb(a);vjb(a);wjb(a);xjb(a);yjb(a);zjb(a);Ajb(a);Bjb(a);Cjb(a);Djb(a);Ejb(a);Fjb(a);Gjb(a);Hjb(a);Ijb(a);Jjb(a);Kjb(a);Ljb(a);Mjb(a);Njb(a);Ojb(a);Pjb(a);Qjb(a);Rjb(a);Sjb(a);Tjb(a);Ujb(a);Vjb(a);Wjb(a);Xjb(a);Yjb(a);Zjb(a);_jb(a);$jb(a);akb(a);bkb(a);ckb(a);dkb(a);ekb(a);fkb(a);gkb(a);hkb(a);ikb(a);jkb(a);kkb(a);lkb(a);mkb(a);nkb(a);okb(a);pkb(a);qkb(a);rkb(a);skb(a);tkb(a);ukb(a);vkb(a);wkb(a);xkb(a);ykb(a);zkb(a);Akb(a);Bkb(a);Ckb(a);Dkb(a);Ekb(a);Fkb(a);Gkb(a);Hkb(a);Ikb(a);Jkb(a);Kkb(a);Lkb(a);Mkb(a);Nkb(a);Okb(a);Pkb(a);Qkb(a);Rkb(a);Skb(a);Tkb(a);Ukb(a);Vkb(a);Wkb(a);Xkb(a);Ykb(a);Zkb(a);_kb(a);$kb(a);alb(a);blb(a);clb(a);dlb(a);elb(a);flb(a);glb(a);hlb(a);ilb(a);jlb(a);klb(a);llb(a);mlb(a);nlb(a);olb(a);plb(a);qlb(a);rlb(a);slb(a);tlb(a);ulb(a);vlb(a);wlb(a);xlb(a);ylb(a);zlb(a);Alb(a);Blb(a);Clb(a);Dlb(a);Elb(a);Flb(a);Glb(a);Hlb(a);Ilb(a);Jlb(a);Klb(a);Llb(a);Mlb(a);Nlb(a);Olb(a);Plb(a);Qlb(a);Rlb(a);Slb(a);Tlb(a);Ulb(a);Vlb(a);Wlb(a);Xlb(a);Ylb(a);Zlb(a);_lb(a);$lb(a);amb(a);bmb(a);cmb(a);dmb(a);emb(a);fmb(a);gmb(a);hmb(a);imb(a);jmb(a);kmb(a);lmb(a);mmb(a);nmb(a);omb(a);pmb(a);qmb(a);rmb(a);smb(a);tmb(a);umb(a);vmb(a);wmb(a);xmb(a);ymb(a);zmb(a);Amb(a);Bmb(a);Cmb(a);Dmb(a);Emb(a);Fmb(a);Gmb(a);Hmb(a);Imb(a);Jmb(a);Kmb(a);Lmb(a);Mmb(a);Nmb(a);Omb(a);Pmb(a);Qmb(a);Rmb(a);Smb(a);Tmb(a);Umb(a);Vmb(a);Wmb(a);Xmb(a);Ymb(a);Zmb(a);_mb(a);$mb(a);anb(a);bnb(a);cnb(a);dnb(a);enb(a);fnb(a);gnb(a);hnb(a);inb(a);jnb(a);knb(a);lnb(a);mnb(a);nnb(a);onb(a);pnb(a);qnb(a);rnb(a);snb(a);tnb(a);unb(a);vnb(a);wnb(a);xnb(a);ynb(a);znb(a);Anb(a);Bnb(a);Cnb(a);Dnb(a);Enb(a);Fnb(a);Gnb(a);Hnb(a);Inb(a);Jnb(a);Knb(a);Lnb(a);Mnb(a);Nnb(a);Onb(a);Pnb(a);Qnb(a);Rnb(a);Snb(a);Tnb(a);Unb(a);Vnb(a);Wnb(a);Xnb(a);Ynb(a);Znb(a);_nb(a);$nb(a);aob(a);bob(a);cob(a);dob(a);eob(a);fob(a);gob(a);hob(a);iob(a);job(a);kob(a);lob(a);mob(a);nob(a);oob(a);pob(a);qob(a);rob(a);sob(a);tob(a);uob(a);vob(a);wob(a);xob(a);yob(a);zob(a);Aob(a);Bob(a);Cob(a);Dob(a);Eob(a);Fob(a);Gob(a);Hob(a);Iob(a);Job(a);Kob(a);Lob(a);Mob(a);Nob(a);Oob(a);Pob(a);Qob(a);Rob(a);Sob(a);Tob(a);Uob(a);Vob(a);Wob(a);Xob(a);Yob(a);Zob(a);_ob(a);$ob(a);apb(a);bpb(a);cpb(a);dpb(a);epb(a);fpb(a);gpb(a);hpb(a);ipb(a);jpb(a);kpb(a);lpb(a);mpb(a);npb(a);opb(a);ppb(a);qpb(a);rpb(a);spb(a);tpb(a);upb(a);vpb(a);wpb(a);xpb(a);ypb(a);zpb(a);Apb(a);Bpb(a);Cpb(a);Dpb(a);Epb(a);Fpb(a);Gpb(a);Hpb(a);Ipb(a);Jpb(a);Kpb(a);Lpb(a);Mpb(a);Npb(a);Opb(a);Ppb(a);Qpb(a);Rpb(a);Spb(a);Tpb(a);Upb(a);Vpb(a);Wpb(a);Xpb(a);Ypb(a);Zpb(a);_pb(a);$pb(a);aqb(a);bqb(a);cqb(a);dqb(a);eqb(a);fqb(a);gqb(a);hqb(a);iqb(a);jqb(a);kqb(a);lqb(a);mqb(a);nqb(a);oqb(a);pqb(a);qqb(a);rqb(a);sqb(a);tqb(a);uqb(a);vqb(a);wqb(a);xqb(a);yqb(a);zqb(a);Aqb(a);Bqb(a);Cqb(a);Dqb(a);Eqb(a);Fqb(a);Gqb(a);Hqb(a);Iqb(a);Jqb(a);Kqb(a);Lqb(a);Mqb(a);Nqb(a);Oqb(a);Pqb(a);Qqb(a);Rqb(a);Sqb(a);Tqb(a);Uqb(a);Vqb(a);Wqb(a);Xqb(a);Yqb(a);Zqb(a);_qb(a);$qb(a);arb(a);brb(a);crb(a);drb(a);erb(a);frb(a);grb(a);hrb(a);irb(a);jrb(a);krb(a);lrb(a);mrb(a);nrb(a);orb(a);prb(a);qrb(a);rrb(a);srb(a);trb(a);urb(a);vrb(a);wrb(a);xrb(a);yrb(a);zrb(a);Arb(a);Brb(a);Crb(a);Drb(a);Erb(a);Frb(a);Grb(a);Hrb(a);Irb(a);Jrb(a);Krb(a);Lrb(a);Mrb(a);Nrb(a);Orb(a);Prb(a);Qrb(a);Rrb(a);Srb(a);Trb(a);Urb(a);Vrb(a);Wrb(a);Xrb(a);Yrb(a);Zrb(a);_rb(a);$rb(a);asb(a);bsb(a);csb(a);dsb(a);esb(a);fsb(a);gsb(a);hsb(a);isb(a);jsb(a);ksb(a);lsb(a);msb(a);nsb(a);osb(a);psb(a);qsb(a);rsb(a);ssb(a);tsb(a);usb(a);vsb(a);wsb(a);xsb(a);ysb(a);zsb(a);Asb(a);Bsb(a);Csb(a);Dsb(a);Esb(a);Fsb(a);Gsb(a);Hsb(a);Isb(a);Jsb(a);Ksb(a);Lsb(a);Msb(a);Nsb(a);Osb(a);Psb(a);Qsb(a);Rsb(a);Ssb(a);Tsb(a);Usb(a);Vsb(a);Wsb(a);Xsb(a);Ysb(a);Zsb(a);_sb(a);$sb(a);atb(a);btb(a);ctb(a);dtb(a);etb(a);ftb(a);gtb(a);htb(a);itb(a);jtb(a);ktb(a);ltb(a);mtb(a);ntb(a);otb(a);ptb(a);qtb(a);rtb(a);stb(a);ttb(a);utb(a);vtb(a);wtb(a);xtb(a);ytb(a);ztb(a);Atb(a);Btb(a);Ctb(a);Dtb(a);Etb(a);Ftb(a);Gtb(a);Htb(a);Itb(a);Jtb(a);Ktb(a);Ltb(a);Mtb(a);Ntb(a);Otb(a);Ptb(a);Qtb(a);Rtb(a);Stb(a);Ttb(a);Utb(a);Vtb(a);Wtb(a);Xtb(a);Ytb(a);Ztb(a);_tb(a);$tb(a);aub(a);bub(a);cub(a);dub(a);eub(a);fub(a);gub(a);hub(a);iub(a);jub(a);kub(a);lub(a);mub(a);nub(a);oub(a);pub(a);qub(a);rub(a);sub(a);tub(a);uub(a);vub(a);wub(a);xub(a);yub(a);zub(a);Aub(a);Bub(a);Cub(a);Dub(a);Eub(a);Fub(a);Gub(a);Hub(a);Iub(a);Jub(a);Kub(a);Lub(a);Mub(a);Nub(a);Oub(a);Pub(a);Qub(a);Rub(a);Sub(a);Tub(a);Uub(a);Vub(a);Wub(a);Xub(a);Yub(a);Zub(a);_ub(a);$ub(a);avb(a);bvb(a);cvb(a);dvb(a);evb(a);fvb(a);gvb(a);hvb(a);ivb(a);jvb(a);kvb(a);lvb(a);mvb(a);nvb(a);ovb(a);pvb(a);qvb(a);rvb(a);svb(a);tvb(a);uvb(a);vvb(a);wvb(a);xvb(a);yvb(a);zvb(a);Avb(a);Bvb(a);Cvb(a);Dvb(a);Evb(a);Fvb(a);Gvb(a);Hvb(a);Ivb(a);Jvb(a);Kvb(a);Lvb(a);Mvb(a);Nvb(a);Ovb(a);Pvb(a);Qvb(a);Rvb(a);Svb(a);Tvb(a);Uvb(a);Vvb(a);Wvb(a);Xvb(a);Yvb(a);Zvb(a);_vb(a);$vb(a);awb(a);bwb(a);cwb(a);dwb(a);ewb(a);fwb(a);gwb(a);hwb(a);iwb(a);jwb(a);kwb(a);lwb(a);mwb(a);nwb(a);owb(a);pwb(a);qwb(a);rwb(a);swb(a);twb(a);uwb(a);vwb(a);wwb(a);xwb(a);ywb(a);zwb(a);Awb(a);Bwb(a);Cwb(a);Dwb(a);Ewb(a);Fwb(a);Gwb(a);Hwb(a);Iwb(a);Jwb(a);Kwb(a);Lwb(a);Mwb(a);Nwb(a);Owb(a);Pwb(a);Qwb(a);Rwb(a);Swb(a);Twb(a);Uwb(a);Vwb(a);Wwb(a);Xwb(a);Ywb(a);Zwb(a);_wb(a);$wb(a);axb(a);bxb(a);cxb(a);dxb(a);exb(a);fxb(a);gxb(a);hxb(a);ixb(a);jxb(a);kxb(a);lxb(a);mxb(a);nxb(a);oxb(a);pxb(a);qxb(a);rxb(a);sxb(a);txb(a);uxb(a);vxb(a);wxb(a);xxb(a);yxb(a);zxb(a);Axb(a);Bxb(a);Cxb(a);Dxb(a);Exb(a);Fxb(a);Gxb(a);Hxb(a);Ixb(a);Jxb(a);Kxb(a);Lxb(a);Mxb(a);Nxb(a);Oxb(a);Pxb(a);Qxb(a);Rxb(a);Sxb(a);Txb(a);Uxb(a);Vxb(a);Wxb(a);Xxb(a);Yxb(a);Zxb(a);_xb(a);$xb(a);ayb(a);byb(a);cyb(a);dyb(a);eyb(a);fyb(a);gyb(a);hyb(a);iyb(a);jyb(a);kyb(a);lyb(a);myb(a);nyb(a);oyb(a);pyb(a);qyb(a);ryb(a);syb(a);tyb(a);uyb(a);vyb(a);wyb(a);xyb(a);yyb(a);zyb(a);Ayb(a);Byb(a);Cyb(a);Dyb(a);Eyb(a);Fyb(a);Gyb(a);Hyb(a);Iyb(a);Jyb(a);Kyb(a);Lyb(a);Myb(a);Nyb(a);Oyb(a);Pyb(a);Qyb(a);Ryb(a);Syb(a);Tyb(a);Uyb(a);Vyb(a);Wyb(a);Xyb(a);Yyb(a);Zyb(a);_yb(a);$yb(a);azb(a);bzb(a);czb(a);dzb(a);ezb(a);fzb(a);gzb(a);hzb(a);izb(a);jzb(a);kzb(a);lzb(a);mzb(a);nzb(a);ozb(a);pzb(a);qzb(a);rzb(a);szb(a);tzb(a);uzb(a);vzb(a);wzb(a);xzb(a);yzb(a);zzb(a);Azb(a);Bzb(a);Czb(a);Dzb(a);Ezb(a);Fzb(a);Gzb(a);Hzb(a);Izb(a);Jzb(a);Kzb(a);Lzb(a);Mzb(a);Nzb(a);Ozb(a);Pzb(a);Qzb(a);Rzb(a);Szb(a);Tzb(a);Uzb(a);Vzb(a);Wzb(a);Xzb(a);Yzb(a);Zzb(a);_zb(a);$zb(a);aAb(a);bAb(a);cAb(a);dAb(a);eAb(a);fAb(a);gAb(a);hAb(a);iAb(a);jAb(a);kAb(a);lAb(a);mAb(a);nAb(a);oAb(a);pAb(a);qAb(a);rAb(a);sAb(a);tAb(a);uAb(a);vAb(a);wAb(a);xAb(a);yAb(a);zAb(a);AAb(a);BAb(a);CAb(a);DAb(a);EAb(a);FAb(a);GAb(a);HAb(a);IAb(a);JAb(a);KAb(a);LAb(a);MAb(a);NAb(a);OAb(a);PAb(a);QAb(a);RAb(a);SAb(a);TAb(a);UAb(a);VAb(a);WAb(a);XAb(a);YAb(a);ZAb(a);_Ab(a);$Ab(a);aBb(a);bBb(a);cBb(a);dBb(a);eBb(a);fBb(a);gBb(a);hBb(a);iBb(a);jBb(a);kBb(a);lBb(a);mBb(a);nBb(a);oBb(a);pBb(a);qBb(a);rBb(a);sBb(a);tBb(a);uBb(a);vBb(a);wBb(a);xBb(a);yBb(a);zBb(a);ABb(a);BBb(a);CBb(a);DBb(a);EBb(a);FBb(a);GBb(a);HBb(a);IBb(a);JBb(a);KBb(a);LBb(a);MBb(a);NBb(a);OBb(a);PBb(a);QBb(a);RBb(a);SBb(a);TBb(a);UBb(a);VBb(a);WBb(a);XBb(a);YBb(a);ZBb(a);_Bb(a);$Bb(a);aCb(a);bCb(a);cCb(a);dCb(a);eCb(a);fCb(a);gCb(a);hCb(a);iCb(a);jCb(a);kCb(a);lCb(a);mCb(a);nCb(a);oCb(a);pCb(a);qCb(a);rCb(a);sCb(a);tCb(a);uCb(a);vCb(a);wCb(a);xCb(a);yCb(a);zCb(a);ACb(a);BCb(a);CCb(a);DCb(a);ECb(a);FCb(a);GCb(a);HCb(a);ICb(a);JCb(a);KCb(a);LCb(a);MCb(a);NCb(a);OCb(a);PCb(a);QCb(a);RCb(a);SCb(a);TCb(a);UCb(a);VCb(a);WCb(a);XCb(a);YCb(a);ZCb(a);_Cb(a);$Cb(a);aDb(a);bDb(a);cDb(a);dDb(a);eDb(a);fDb(a);gDb(a);hDb(a);iDb(a);jDb(a);kDb(a);lDb(a);mDb(a);nDb(a);oDb(a);pDb(a);qDb(a);rDb(a);sDb(a);tDb(a);uDb(a);vDb(a);wDb(a);xDb(a);yDb(a);zDb(a);ADb(a);BDb(a);CDb(a);DDb(a);EDb(a);FDb(a);GDb(a);HDb(a);IDb(a);JDb(a);KDb(a);LDb(a);MDb(a);NDb(a);ODb(a);PDb(a);QDb(a);RDb(a);SDb(a);TDb(a);UDb(a);VDb(a);WDb(a);XDb(a);YDb(a);ZDb(a);_Db(a);$Db(a);aEb(a);bEb(a);cEb(a);dEb(a);eEb(a);fEb(a);gEb(a);hEb(a);iEb(a);jEb(a);kEb(a);lEb(a);mEb(a);nEb(a);oEb(a);pEb(a);qEb(a);rEb(a);sEb(a);tEb(a);uEb(a);vEb(a);wEb(a);xEb(a);yEb(a);zEb(a);AEb(a);BEb(a);CEb(a);DEb(a);EEb(a);FEb(a);GEb(a);HEb(a);IEb(a);JEb(a);KEb(a);LEb(a);MEb(a);NEb(a);OEb(a);PEb(a);QEb(a);REb(a);SEb(a);TEb(a);UEb(a);VEb(a);WEb(a);XEb(a);YEb(a);ZEb(a);_Eb(a);$Eb(a);aFb(a);bFb(a);cFb(a);dFb(a);eFb(a);fFb(a);gFb(a);hFb(a);iFb(a);jFb(a);kFb(a);lFb(a);mFb(a);nFb(a);oFb(a);pFb(a);qFb(a);rFb(a);sFb(a);tFb(a);uFb(a);vFb(a);wFb(a);xFb(a);yFb(a);zFb(a);AFb(a);BFb(a);CFb(a);DFb(a);EFb(a);FFb(a);GFb(a);HFb(a);IFb(a);JFb(a);KFb(a);LFb(a);MFb(a);NFb(a);OFb(a);PFb(a);QFb(a);RFb(a);SFb(a);TFb(a);UFb(a);VFb(a);WFb(a);XFb(a);YFb(a);ZFb(a);_Fb(a);$Fb(a);aGb(a);bGb(a);cGb(a);dGb(a);eGb(a);fGb(a);gGb(a);hGb(a);iGb(a);jGb(a);kGb(a);lGb(a);mGb(a);nGb(a);oGb(a);pGb(a);qGb(a);rGb(a);sGb(a);tGb(a);uGb(a);vGb(a);wGb(a);xGb(a);yGb(a);zGb(a);AGb(a);BGb(a);CGb(a);DGb(a);EGb(a);FGb(a);GGb(a);HGb(a);IGb(a);JGb(a);KGb(a);LGb(a);MGb(a);NGb(a);OGb(a);PGb(a);QGb(a);RGb(a);SGb(a);TGb(a);UGb(a);VGb(a);WGb(a);XGb(a);YGb(a);ZGb(a);_Gb(a);$Gb(a);aHb(a);bHb(a);cHb(a);dHb(a);eHb(a);fHb(a);gHb(a);hHb(a);iHb(a);jHb(a);kHb(a);lHb(a);mHb(a);nHb(a);oHb(a);pHb(a);qHb(a);rHb(a);sHb(a);tHb(a);uHb(a);vHb(a);wHb(a);xHb(a);yHb(a);zHb(a);AHb(a);BHb(a);CHb(a);DHb(a);EHb(a);FHb(a);GHb(a);HHb(a);IHb(a);JHb(a);KHb(a);LHb(a);MHb(a);NHb(a);OHb(a);PHb(a);QHb(a);RHb(a);SHb(a);THb(a);UHb(a);VHb(a);WHb(a);XHb(a);YHb(a);ZHb(a);_Hb(a);$Hb(a);aIb(a);bIb(a);cIb(a);dIb(a);c[b+8>>2]=a;c[b+24>>2]=0;c[b+28>>2]=0;_Modelica_Mechanics_MultiBody_Examples_Loops_EngineV6_updateBoundParameters$0(b);H=c[b+24>>2]|0;A=c[b+28>>2]|0;I=+g[b+28>>2];c[b+24>>2]=0;c[b+28>>2]=0;if((H|0)==6){return A|0}return 0|0;return 0}function Evc(b){b=b|0;var c=0;c=i;a[b+314|0]=0;Fvc(b);i=c;return 0}function Fvc(a){a=a|0;var b=0;b=i;cf(a);gf(a);hf(a);jf(a);kf(a);lf(a);mf(a);nf(a);of(a);pf(a);qf(a);rf(a);sf(a);tf(a);uf(a);vf(a);wf(a);xf(a);yf(a);zf(a);Af(a);Bf(a);Cf(a);Df(a);Ef(a);Ff(a);Gf(a);Hf(a);If(a);Jf(a);Kf(a);Lf(a);Mf(a);Nf(a);Of(a);Pf(a);Qf(a);Rf(a);Sf(a);Tf(a);Uf(a);Vf(a);Wf(a);Xf(a);Yf(a);Zf(a);_f(a);$f(a);ag(a);bg(a);Wh(a);Zh(a);$h(a);ai(a);bi(a);ci(a);xi(a);yi(a);zi(a);Ai(a);Bi(a);Ci(a);Di(a);Ii(a);Ji(a);Ki(a);Li(a);Mi(a);Ni(a);Oi(a);Pi(a);Qi(a);Ui(a);pj(a);qj(a);rj(a);uj(a);vj(a);wj(a);xj(a);Aj(a);Bj(a);Cj(a);Dj(a);Ej(a);Fj(a);Gj(a);Hj(a);Ij(a);Mj(a);gk(a);hk(a);ik(a);lk(a);mk(a);nk(a);ok(a);vk(a);wk(a);xk(a);yk(a);zk(a);Ak(a);Bk(a);Ck(a);Dk(a);Ek(a);bl(a);cl(a);dl(a);el(a);fl(a);gl(a);hl(a);nl(a);ol(a);pl(a);ql(a);rl(a);sl(a);tl(a);ul(a);vl(a);wl(a);Rl(a);Sl(a);Tl(a);Yl(a);Zl(a);_l(a);$l(a);cm(a);dm(a);em(a);fm(a);gm(a);hm(a);im(a);jm(a);km(a);om(a);zm(a);Cm(a);Hm(a);Im(a);Jm(a);Mm(a);Nm(a);Om(a);Pm(a);Wm(a);Xm(a);Ym(a);Zm(a);_m(a);$m(a);an(a);bn(a);cn(a);dn(a);en(a);fn(a);gn(a);hn(a);wn(a);xn(a);yn(a);zn(a);An(a);Bn(a);Cn(a);Dn(a);En(a);Fn(a);Gn(a);Hn(a);In(a);Jn(a);Kn(a);Ln(a);Mn(a);Nn(a);On(a);Pn(a);Qn(a);Rn(a);Sn(a);Tn(a);Un(a);Vn(a);Wn(a);Xn(a);Yn(a);Zn(a);_n(a);$n(a);ao(a);bo(a);co(a);eo(a);fo(a);go(a);ho(a);io(a);jo(a);ko(a);lo(a);mo(a);no(a);oo(a);po(a);qo(a);ro(a);so(a);to(a);uo(a);vo(a);wo(a);xo(a);yo(a);zo(a);Ao(a);Bo(a);Co(a);Do(a);Eo(a);Fo(a);Go(a);Ho(a);Io(a);Jo(a);Ko(a);Lo(a);Mo(a);No(a);Oo(a);Po(a);Qo(a);Ro(a);So(a);To(a);Uo(a);Vo(a);Wo(a);Xo(a);Yo(a);Zo(a);_o(a);$o(a);ap(a);bp(a);cp(a);dp(a);ep(a);fp(a);gp(a);hp(a);ip(a);jp(a);kp(a);lp(a);mp(a);np(a);op(a);pp(a);qp(a);rp(a);sp(a);tp(a);up(a);vp(a);wp(a);xp(a);yp(a);zp(a);Ap(a);Bp(a);Cp(a);Dp(a);Ep(a);Fp(a);Gp(a);Hp(a);Ip(a);Jp(a);Kp(a);Lp(a);Mp(a);Np(a);Op(a);Pp(a);Qp(a);Rp(a);Sp(a);Tp(a);Up(a);Vp(a);Wp(a);Xp(a);Yp(a);Zp(a);_p(a);$p(a);aq(a);bq(a);cq(a);dq(a);eq(a);fq(a);gq(a);hq(a);iq(a);jq(a);kq(a);lq(a);mq(a);nq(a);oq(a);pq(a);sq(a);tq(a);uq(a);vq(a);wq(a);xq(a);yq(a);zq(a);Aq(a);Bq(a);Cq(a);Dq(a);Eq(a);Fq(a);Gq(a);Hq(a);Iq(a);Jq(a);Kq(a);Lq(a);Mq(a);Nq(a);Oq(a);Pq(a);Qq(a);Rq(a);Sq(a);Tq(a);Uq(a);Vq(a);Wq(a);Xq(a);Yq(a);Zq(a);_q(a);$q(a);ar(a);br(a);cr(a);dr(a);er(a);fr(a);gr(a);hr(a);ir(a);jr(a);kr(a);lr(a);mr(a);nr(a);or(a);pr(a);qr(a);rr(a);sr(a);tr(a);ur(a);vr(a);wr(a);xr(a);yr(a);zr(a);Ar(a);Br(a);Cr(a);Dr(a);Er(a);Fr(a);Gr(a);Hr(a);Ir(a);Jr(a);Kr(a);Lr(a);Mr(a);Nr(a);Or(a);Pr(a);Qr(a);Rr(a);Sr(a);Tr(a);Ur(a);Vr(a);Wr(a);Xr(a);Yr(a);Zr(a);_r(a);$r(a);as(a);bs(a);cs(a);ds(a);es(a);fs(a);gs(a);hs(a);is(a);js(a);ks(a);ls(a);ms(a);ns(a);os(a);ps(a);qs(a);rs(a);ss(a);ts(a);us(a);vs(a);ws(a);xs(a);ys(a);zs(a);As(a);Bs(a);Cs(a);Ds(a);Es(a);Fs(a);Gs(a);Hs(a);Is(a);Js(a);Ks(a);Ls(a);Ms(a);Ns(a);Os(a);Ps(a);Qs(a);Rs(a);Ss(a);Ts(a);Us(a);Vs(a);Ws(a);Xs(a);Ys(a);Zs(a);_s(a);$s(a);at(a);bt(a);ct(a);dt(a);et(a);ft(a);gt(a);ht(a);it(a);jt(a);kt(a);lt(a);mt(a);nt(a);ot(a);pt(a);qt(a);rt(a);st(a);tt(a);ut(a);vt(a);wt(a);xt(a);yt(a);zt(a);At(a);Bt(a);Ct(a);Dt(a);Et(a);Ft(a);Gt(a);Ht(a);It(a);Jt(a);Kt(a);Lt(a);Mt(a);Nt(a);Ot(a);Pt(a);Qt(a);Rt(a);St(a);Tt(a);Ut(a);Vt(a);Wt(a);Xt(a);Yt(a);Zt(a);_t(a);$t(a);au(a);bu(a);cu(a);du(a);eu(a);fu(a);gu(a);hu(a);iu(a);ju(a);ku(a);lu(a);i=b;return}function Gvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[278632]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26560>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(278648,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26560>>3],278640)|0)|0;g=c[85376]|0;j=e;k=279976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[278632]=1;i=d;return}function Hvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[278856]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26536>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(278864,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26536>>3],278640)|0)|0;g=c[85376]|0;j=e;k=280112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[278856]=1;i=d;return}function Ivc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[278968]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26448>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(278976,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26448>>3],278640)|0)|0;g=c[85376]|0;j=e;k=279976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[278968]=1;i=d;return}function Jvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279080]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26424>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279088,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26424>>3],278640)|0)|0;g=c[85376]|0;j=e;k=280112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279080]=1;i=d;return}function Kvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279192]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26336>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279200,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26336>>3],278640)|0)|0;g=c[85376]|0;j=e;k=279976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279192]=1;i=d;return}function Lvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279304]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26312>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279312,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26312>>3],278640)|0)|0;g=c[85376]|0;j=e;k=280112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279304]=1;i=d;return}function Mvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279416]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26224>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279424,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26224>>3],278640)|0)|0;g=c[85376]|0;j=e;k=279976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279416]=1;i=d;return}function Nvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279528]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26200>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279536,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26200>>3],278640)|0)|0;g=c[85376]|0;j=e;k=280112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279528]=1;i=d;return}function Ovc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279640]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26112>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279648,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26112>>3],278640)|0)|0;g=c[85376]|0;j=e;k=279976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279640]=1;i=d;return}function Pvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279752]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26088>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279760,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26088>>3],278640)|0)|0;g=c[85376]|0;j=e;k=280112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279752]=1;i=d;return}function Qvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[279864]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26e3>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(279872,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+26e3>>3],278640)|0)|0;g=c[85376]|0;j=e;k=279976;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[279864]=1;i=d;return}function Rvc(b){b=b|0;var d=0,e=0,f=0,g=0,j=0,k=0;d=i;i=i+32|0;e=d;f=d+24|0;if(a[28e4]&1){i=d;return}g=b+4|0;if(!((VEc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+25976>>3],0.0)|0)<<24>>24==0)){i=d;return}b=gCc(280008,cCc(+h[(c[(c[c[g>>2]>>2]|0)+8>>2]|0)+25976>>3],278640)|0)|0;g=c[85376]|0;j=e;k=280112;c[j+0>>2]=c[k+0>>2];c[j+4>>2]=c[k+4>>2];c[j+8>>2]=c[k+8>>2];c[j+12>>2]=c[k+12>>2];c[j+16>>2]=c[k+16>>2];c[j+20>>2]=c[k+20>>2];Ee[g&15](e,b,f);a[28e4]=1;i=d;return}function Svc(a){a=a|0;var b=0;b=i;Gvc(a);Hvc(a);Ivc(a);Jvc(a);Kvc(a);Lvc(a);Mvc(a);Nvc(a);Ovc(a);Pvc(a);Qvc(a);Rvc(a);i=b;return 0}function Tvc(a){a=a|0;i=i;return 1}function Uvc(a){a=a|0;var b=0,d=0,e=0;b=i;d=a+464|0;a=c[d>>2]|0;c[a+44>>2]=4;c[a+48>>2]=4;c[a+72>>2]=j4c(4,8)|0;a=j4c(4,8)|0;c[(c[d>>2]|0)+80>>2]=a;a=j4c(0,8)|0;c[(c[d>>2]|0)+76>>2]=a;a=h4c(16)|0;c[(c[d>>2]|0)+52>>2]=a;a=h4c(32)|0;c[(c[d>>2]|0)+56>>2]=a;a=h4c(16)|0;c[(c[d>>2]|0)+64>>2]=a;a=c[d>>2]|0;c[a+68>>2]=3;c[a+84>>2]=0;a=c[d>>2]|0;e=c[a+52>>2]|0;c[e>>2]=2;c[e+4>>2]=3;c[e+8>>2]=6;c[e+12>>2]=8;Vvc(e,c[a+56>>2]|0);a=c[d>>2]|0;Wvc(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Xvc(c[a+52>>2]|0,c[a+56>>2]|0);a=c[d>>2]|0;Yvc(c[(c[a+52>>2]|0)+4>>2]|0,c[a+56>>2]|0);a=c[(c[d>>2]|0)+64>>2]|0;c[a+12>>2]=1;c[a+4>>2]=1;c[a+8>>2]=2;c[a>>2]=3;i=b;return 0}function Vvc(a,b){a=a|0;b=b|0;var d=0;d=a+12|0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=0;c[b+((c[d>>2]|0)+ -1<<2)>>2]=2;i=i;return}function Wvc(a,b){a=a|0;b=b|0;var d=0;d=a+8|0;c[b+((c[d>>2]|0)+ -3<<2)>>2]=0;c[b+((c[d>>2]|0)+ -2<<2)>>2]=2;c[b+((c[d>>2]|0)+ -1<<2)>>2]=3;i=i;return}function Xvc(a,b){a=a|0;b=b|0;c[b+((c[a>>2]|0)+ -2<<2)>>2]=1;c[b+((c[a>>2]|0)+ -1<<2)>>2]=0;i=i;return}function Yvc(a,b){a=a|0;b=b|0;c[b+(a+ -1<<2)>>2]=1;i=i;return}function Zvc(a){a=a|0;i=i;return 1}function _vc(a){a=a|0;i=i;return 1}function $vc(a){a=a|0;i=i;return 1}function awc(a){a=a|0;i=i;return 0}function bwc(a){a=a|0;i=i;return 0}function cwc(a){a=a|0;i=i;return 0}function dwc(a){a=a|0;i=i;return 0}function ewc(a){a=a|0;i=i;return 0}function fwc(a,b){a=a|0;b=b|0;i=i;return-1}function gwc(a,b){a=a|0;b=b|0;i=i;return-1}function hwc(a,b,c,d,e,f,g,h){a=a|0;b=b|0;c=c|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;i=i;return-1}function iwc(){i=i;return 280136}function jwc(a,b,d){a=a|0;b=b|0;d=d|0;var e=0,f=0,g=0,j=0.0,k=0.0,l=0.0,m=0,n=0,o=0,p=0.0,q=0,r=0.0,s=0,t=0.0,u=0.0,v=0.0,w=0;e=i;f=c[a>>2]|0;if((f|0)<1){g=0;i=e;return g|0}a=c[d>>2]|0;if((a|0)<1){g=0;i=e;return g|0}if((f|0)==1){g=1;i=e;return g|0}j=+h[b>>3];d=!(j>=0.0);if((a|0)==1){if(d){k=-j}else{k=j}if((f|0)<2){g=1;i=e;return g|0}else{l=k;m=2;n=1}while(1){k=+h[b+(m+ -1<<3)>>3];o=!(k>=0.0);if(o){p=-k}else{p=k}q=p<=l;if(q|o^1){r=q?l:k;s=q?n:m}else{r=-k;s=m}q=m+1|0;if((q|0)>(f|0)){g=s;break}else{l=r;m=q;n=s}}i=e;return g|0}if(d){t=-j}else{t=j}if((f|0)<2){g=1;i=e;return g|0}j=t;d=2;s=a+1|0;n=1;while(1){t=+h[b+(s+ -1<<3)>>3];m=!(t>=0.0);if(m){u=-t}else{u=t}q=u<=j;if(q|m^1){v=q?j:t;w=q?n:d}else{v=-t;w=d}q=d+1|0;if((q|0)>(f|0)){g=w;break}else{j=v;d=q;s=a+s|0;n=w}}i=e;return g|0}function kwc(a,b,d,e){a=a|0;b=b|0;d=d|0;e=e|0;var f=0,g=0,j=0,k=0,l=0,m=0,n=0,o=0;f=i;g=c[a>>2]|0;if((g|0)<1){i=f;return 0}j=c[e>>2]|0;if((j|0)<1){i=f;return 0}if((j|0)!=1){e=fa(j,g)|0;if((e|0)>0){k=1}else{i=f;return 0}do{l=d+(k+ -1<<3)|0;h[l>>3]=+h[b>>3]*+h[l>>3];k=k+j|0;}while((k|0)<=(e|0));i=f;return 0}e=(g|0)%5|0;do{if((e|0)==0){m=g}else{if((e|0)<1){n=g}else{k=1;do{j=d+(k+ -1<<3)|0;h[j>>3]=+h[b>>3]*+h[j>>3];k=k+1|0;}while((k|0)<=(e|0));n=c[a>>2]|0}if((n|0)>=5){m=n;break}i=f;return 0}}while(0);n=e+1|0;if((n|0)>(m|0)){i=f;return 0}else{o=n}do{n=d+(o+ -1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+1<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+2<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];n=d+(o+3<<3)|0;h[n>>3]=+h[b>>3]*+h[n>>3];o=o+5|0;}while((o|0)<=(m|0));i=f;return 0}function lwc(a,b,d,e,f){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;var g=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0;g=i;j=c[a>>2]|0;if((j|0)<1){i=g;return 0}k=c[d>>2]|0;do{if((k|0)==1){l=c[f>>2]|0;if((l|0)!=1){m=l;n=1;break}l=(j|0)%3|0;do{if((l|0)==0){o=j}else{if((l|0)<1){p=j}else{q=1;do{r=q+ -1|0;s=b+(r<<3)|0;t=+h[s>>3];u=e+(r<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;q=q+1|0;}while((q|0)<=(l|0));p=c[a>>2]|0}if((p|0)>=3){o=p;break}i=g;return 0}}while(0);q=l+1|0;if((q|0)>(o|0)){i=g;return 0}else{v=q}do{q=v+ -1|0;u=b+(q<<3)|0;t=+h[u>>3];s=e+(q<<3)|0;h[u>>3]=+h[s>>3];h[s>>3]=t;s=b+(v<<3)|0;t=+h[s>>3];u=e+(v<<3)|0;h[s>>3]=+h[u>>3];h[u>>3]=t;u=v+1|0;s=b+(u<<3)|0;t=+h[s>>3];q=e+(u<<3)|0;h[s>>3]=+h[q>>3];h[q>>3]=t;v=v+3|0;}while((v|0)<=(o|0));i=g;return 0}else{if((k|0)<0){w=(fa(1-j|0,k)|0)+1|0}else{w=1}m=c[f>>2]|0;n=w}}while(0);if((m|0)<0){x=1;y=n;z=(fa(1-j|0,m)|0)+1|0}else{x=1;y=n;z=1}while(1){n=b+(y+ -1<<3)|0;t=+h[n>>3];m=e+(z+ -1<<3)|0;h[n>>3]=+h[m>>3];h[m>>3]=t;m=x+1|0;if((m|0)>(j|0)){break}else{z=(c[f>>2]|0)+z|0;y=(c[d>>2]|0)+y|0;x=m}}i=g;return 0}function mwc(a,b,d,e,f,g,j,k,l){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;var m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0.0,y=0.0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0;m=i;i=i+8|0;n=m;o=c[l>>2]|0;l=~o;c[n>>2]=0;p=c[a>>2]|0;do{if((p|0)<0){c[n>>2]=1}else{q=c[b>>2]|0;if((q|0)<0){c[n>>2]=2;break}r=c[f>>2]|0;if((r|0)==0){c[n>>2]=5;break}s=c[j>>2]|0;if((s|0)==0){c[n>>2]=7;break}if((o|0)<(((p|0)>1?p:1)|0)){c[n>>2]=9;break}if((p|0)==0|(q|0)==0){i=m;return 0}if(+h[d>>3]==0.0){i=m;return 0}if((s|0)>0){t=1}else{t=1-(fa(s,q+ -1|0)|0)|0}if((r|0)==1){if((q|0)<1){i=m;return 0}else{u=s;v=1;w=t}while(1){x=+h[g+(w+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){A=u;break}B=(fa(v,o)|0)+l|0;C=1;do{D=k+(B+C<<3)|0;h[D>>3]=+h[D>>3]+y*+h[e+(C+ -1<<3)>>3];C=C+1|0;}while((C|0)<=(z|0));A=c[j>>2]|0}else{A=u}}while(0);z=v+1|0;if((z|0)>(q|0)){break}else{u=A;v=z;w=A+w|0}}i=m;return 0}if((r|0)>0){E=1}else{E=1-(fa(p+ -1|0,r)|0)|0}if((q|0)<1){i=m;return 0}else{F=s;G=1;H=t}while(1){x=+h[g+(H+ -1<<3)>>3];do{if(x!=0.0){y=x*+h[d>>3];z=c[a>>2]|0;if((z|0)<1){I=F;break}C=(fa(G,o)|0)+l|0;B=1;D=E;while(1){J=k+(C+B<<3)|0;h[J>>3]=+h[J>>3]+y*+h[e+(D+ -1<<3)>>3];J=B+1|0;if((J|0)>(z|0)){break}else{D=(c[f>>2]|0)+D|0;B=J}}I=c[j>>2]|0}else{I=F}}while(0);B=G+1|0;if((B|0)>(q|0)){break}else{F=I;G=B;H=I+H|0}}i=m;return 0}}while(0);Ab(280960,n|0)|0;i=m;return 0}function nwc(a,b,d,e,f,g,j,k,l,m,n,o,p){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;o=o|0;p=p|0;var q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0,M=0,N=0,O=0,P=0,Q=0,R=0.0,S=0,T=0.0,U=0.0,V=0,W=0.0,X=0,Y=0,Z=0,_=0,$=0,aa=0.0,ba=0.0,ca=0,da=0;q=i;i=i+8|0;r=q;s=c[k>>2]|0;t=~s;u=c[m>>2]|0;v=~u;w=c[p>>2]|0;x=~w;y=MDc(a,280968)|0;z=MDc(b,280968)|0;A=(y|0)!=0;y=c[(A?d:f)>>2]|0;B=(z|0)!=0;z=c[(B?f:e)>>2]|0;c[r>>2]=0;do{if(A){C=5}else{if((MDc(a,280976)|0)!=0){C=5;break}if((MDc(a,280984)|0)!=0){C=5;break}c[r>>2]=1}}while(0);a:do{if((C|0)==5){do{if(!B){if((MDc(b,280976)|0)!=0){break}if((MDc(b,280984)|0)!=0){break}c[r>>2]=2;break a}}while(0);a=c[d>>2]|0;if((a|0)<0){c[r>>2]=3;break}D=c[e>>2]|0;if((D|0)<0){c[r>>2]=4;break}E=c[f>>2]|0;if((E|0)<0){c[r>>2]=5;break}if((c[k>>2]|0)<(((y|0)>1?y:1)|0)){c[r>>2]=8;break}if((c[m>>2]|0)<(((z|0)>1?z:1)|0)){c[r>>2]=10;break}if((c[p>>2]|0)<(((a|0)>1?a:1)|0)){c[r>>2]=13;break}if((c[r>>2]|0)!=0){break}if((a|0)==0|(D|0)==0){i=q;return 0}F=+h[g>>3]==0.0;do{if(F|(E|0)==0){if(+h[n>>3]==1.0){i=q;return 0}if(!F){break}G=(D|0)<1;if(+h[n>>3]==0.0){if(G){i=q;return 0}else{H=a;I=0;J=2}while(1){if((H|0)>=1){P4c(o+((fa(w,I)|0)<<3)|0,0,H<<3|0)|0}if((J|0)>(D|0)){break}H=c[d>>2]|0;I=I+1|0;J=J+1|0}i=q;return 0}if(G){i=q;return 0}else{K=a;L=1}while(1){if((K|0)>=1){M=(fa(L,w)|0)+x|0;N=1;do{O=o+(M+N<<3)|0;h[O>>3]=+h[n>>3]*+h[O>>3];N=N+1|0;}while((N|0)<=(K|0))}N=L+1|0;if((N|0)>(D|0)){break}K=c[d>>2]|0;L=N}i=q;return 0}}while(0);F=(D|0)<1;if(B){if(!A){if(F){i=q;return 0}else{P=a;Q=1}while(1){if((P|0)>=1){E=(fa(Q,w)|0)+x|0;G=(fa(Q,u)|0)+v|0;N=1;do{M=c[f>>2]|0;if((M|0)<1){R=0.0}else{O=(fa(N,s)|0)+t|0;S=1;T=0.0;while(1){U=T+ +h[j+(O+S<<3)>>3]*+h[l+(G+S<<3)>>3];V=S+1|0;if((V|0)>(M|0)){R=U;break}else{T=U;S=V}}}T=+h[n>>3];U=R*+h[g>>3];S=o+(E+N<<3)|0;if(T==0.0){W=U}else{W=U+T*+h[S>>3]}h[S>>3]=W;N=N+1|0;}while((N|0)<=(P|0))}N=Q+1|0;if((N|0)>(D|0)){break}P=c[d>>2]|0;Q=N}i=q;return 0}if(F){i=q;return 0}else{X=0;Y=1}while(1){N=o+((fa(w,X)|0)<<3)|0;T=+h[n>>3];b:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}P4c(N|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}G=(fa(Y,w)|0)+x|0;U=T;S=1;while(1){M=o+(G+S<<3)|0;h[M>>3]=U*+h[M>>3];M=S+1|0;if((M|0)>(E|0)){break b}U=+h[n>>3];S=M}}}while(0);N=c[f>>2]|0;if((N|0)>=1){S=(fa(Y,u)|0)+v|0;E=(fa(Y,w)|0)+x|0;G=1;do{T=+h[l+(S+G<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];M=c[d>>2]|0;if((M|0)<1){break}O=(fa(G,s)|0)+t|0;V=1;do{Z=o+(E+V<<3)|0;h[Z>>3]=+h[Z>>3]+U*+h[j+(O+V<<3)>>3];V=V+1|0;}while((V|0)<=(M|0))}}while(0);G=G+1|0;}while((G|0)<=(N|0))}N=Y+1|0;if((N|0)>(D|0)){break}X=X+1|0;Y=N}i=q;return 0}else{if(!A){if(F){i=q;return 0}else{_=a;$=1}while(1){if((_|0)>=1){N=(fa($,w)|0)+x|0;G=$+v|0;E=1;do{S=c[f>>2]|0;if((S|0)<1){aa=0.0}else{M=(fa(E,s)|0)+t|0;V=1;T=0.0;while(1){U=T+ +h[j+(M+V<<3)>>3]*+h[l+(G+(fa(V,u)|0)<<3)>>3];O=V+1|0;if((O|0)>(S|0)){aa=U;break}else{T=U;V=O}}}T=+h[n>>3];U=aa*+h[g>>3];V=o+(N+E<<3)|0;if(T==0.0){ba=U}else{ba=U+T*+h[V>>3]}h[V>>3]=ba;E=E+1|0;}while((E|0)<=(_|0))}E=$+1|0;if((E|0)>(D|0)){break}_=c[d>>2]|0;$=E}i=q;return 0}if(F){i=q;return 0}else{ca=0;da=1}while(1){a=o+((fa(w,ca)|0)<<3)|0;T=+h[n>>3];c:do{if(T==0.0){E=c[d>>2]|0;if((E|0)<1){break}P4c(a|0,0,E<<3|0)|0}else{if(!(T!=1.0)){break}E=c[d>>2]|0;if((E|0)<1){break}N=(fa(da,w)|0)+x|0;U=T;G=1;while(1){V=o+(N+G<<3)|0;h[V>>3]=U*+h[V>>3];V=G+1|0;if((V|0)>(E|0)){break c}U=+h[n>>3];G=V}}}while(0);a=c[f>>2]|0;if((a|0)>=1){G=da+v|0;E=(fa(da,w)|0)+x|0;N=1;do{T=+h[l+(G+(fa(N,u)|0)<<3)>>3];do{if(T!=0.0){U=T*+h[g>>3];V=c[d>>2]|0;if((V|0)<1){break}S=(fa(N,s)|0)+t|0;M=1;do{O=o+(E+M<<3)|0;h[O>>3]=+h[O>>3]+U*+h[j+(S+M<<3)>>3];M=M+1|0;}while((M|0)<=(V|0))}}while(0);N=N+1|0;}while((N|0)<=(a|0))}a=da+1|0;if((a|0)>(D|0)){break}ca=ca+1|0;da=a}i=q;return 0}}}while(0);Ab(280992,r|0)|0;i=q;return 0}function owc(a,b,d,e,f,g,j,k,l,m,n){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;j=j|0;k=k|0;l=l|0;m=m|0;n=n|0;var o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0,I=0,J=0,K=0,L=0.0,M=0,N=0.0,O=0,P=0,Q=0.0,R=0,S=0.0,T=0.0,U=0,V=0.0,W=0,X=0.0,Y=0,Z=0,_=0;o=i;i=i+8|0;p=o;q=c[l>>2]|0;r=~q;s=c[n>>2]|0;t=~s;u=(MDc(a,281e3)|0)!=0;v=c[(u?f:g)>>2]|0;w=MDc(e,281008)|0;x=MDc(b,281016)|0;c[p>>2]=0;do{if(u){y=4}else{if((MDc(a,281024)|0)!=0){y=4;break}c[p>>2]=1}}while(0);a:do{if((y|0)==4){do{if((x|0)==0){if((MDc(b,281e3)|0)!=0){break}c[p>>2]=2;break a}}while(0);do{if((MDc(d,281008)|0)==0){if((MDc(d,281032)|0)!=0){break}if((MDc(d,281040)|0)!=0){break}c[p>>2]=3;break a}}while(0);do{if((MDc(e,281016)|0)==0){if((MDc(e,281008)|0)!=0){break}c[p>>2]=4;break a}}while(0);a=c[f>>2]|0;if((a|0)<0){c[p>>2]=5;break}z=c[g>>2]|0;if((z|0)<0){c[p>>2]=6;break}if((c[l>>2]|0)<(((v|0)>1?v:1)|0)){c[p>>2]=9;break}if((c[n>>2]|0)<(((a|0)>1?a:1)|0)){c[p>>2]=11;break}if((c[p>>2]|0)!=0){break}if((a|0)==0|(z|0)==0){i=o;return 0}if(+h[j>>3]==0.0){if((z|0)<1){i=o;return 0}else{A=a;B=0;C=2}while(1){if((A|0)>=1){P4c(m+((fa(s,B)|0)<<3)|0,0,A<<3|0)|0}if((C|0)>(z|0)){break}A=c[f>>2]|0;B=B+1|0;C=C+1|0}i=o;return 0}z=(MDc(d,281008)|0)!=0;a=(x|0)!=0;D=c[g>>2]|0;if(u){E=(D|0)<1;if(!z){if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{H=c[f>>2]|0;if((H|0)>=1){I=(fa(G,s)|0)+t|0;J=1;do{K=m+(I+J<<3)|0;L=+h[j>>3]*+h[K>>3];M=J+ -1|0;if((M|0)<1){N=L}else{O=(fa(J,q)|0)+r|0;P=1;Q=L;while(1){L=Q- +h[k+(O+P<<3)>>3]*+h[m+(I+P<<3)>>3];R=P+1|0;if((R|0)>(M|0)){N=L;break}else{Q=L;P=R}}}if(F){S=N}else{S=N/+h[k+(J+r+(fa(J,q)|0)<<3)>>3]}h[K>>3]=S;J=J+1|0;}while((J|0)<=(H|0))}G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{H=c[f>>2]|0;b:do{if((H|0)>0){J=(fa(F,s)|0)+t|0;I=H;P=H;while(1){M=m+(J+P<<3)|0;Q=+h[j>>3]*+h[M>>3];O=P+1|0;if((O|0)>(I|0)){T=Q}else{R=(fa(P,q)|0)+r|0;U=O;L=Q;while(1){Q=L- +h[k+(R+U<<3)>>3]*+h[m+(J+U<<3)>>3];O=U+1|0;if((O|0)>(I|0)){T=Q;break}else{L=Q;U=O}}}if(G){V=T}else{V=T/+h[k+(P+r+(fa(P,q)|0)<<3)>>3]}h[M>>3]=V;U=P+ -1|0;if((U|0)<=0){break b}I=c[f>>2]|0;P=U}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(a){if(E){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];c:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}P=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){J=m+(P+I<<3)|0;h[J>>3]=Q*+h[J>>3];J=I+1|0;if((J|0)>(H|0)){y=43;break c}Q=+h[j>>3];I=J}}else{y=43}}while(0);d:do{if((y|0)==43){y=0;I=c[f>>2]|0;if((I|0)<=0){break}H=(fa(G,s)|0)+t|0;if(F){P=I;while(1){J=m+(H+P<<3)|0;L=+h[J>>3];K=P+ -1|0;e:do{if(L!=0.0){if((K|0)<1){break d}U=(fa(P,q)|0)+r|0;Q=L;R=1;while(1){O=m+(H+R<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(U+R<<3)>>3];O=R+1|0;if((O|0)>(K|0)){break e}Q=+h[J>>3];R=O}}}while(0);if((K|0)>0){P=K}else{break d}}}else{W=I}while(1){P=m+(H+W<<3)|0;L=+h[P>>3];f:do{if(L!=0.0){Q=L/+h[k+(W+r+(fa(W,q)|0)<<3)>>3];h[P>>3]=Q;J=W+ -1|0;if((J|0)<1){break d}M=(fa(W,q)|0)+r|0;X=Q;R=1;while(1){U=m+(H+R<<3)|0;h[U>>3]=+h[U>>3]-X*+h[k+(M+R<<3)>>3];U=R+1|0;if((U|0)>(J|0)){Y=J;break f}X=+h[P>>3];R=U}}else{Y=W+ -1|0}}while(0);if((Y|0)>0){W=Y}else{break}}}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}if(E){i=o;return 0}G=(w|0)==0;F=1;do{L=+h[j>>3];g:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(F,s)|0)+t|0;X=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=X*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){y=64;break g}X=+h[j>>3];P=K}}else{y=64}}while(0);do{if((y|0)==64){y=0;P=c[f>>2]|0;if((P|0)<1){break}H=(fa(F,s)|0)+t|0;if(G){I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];h:do{if(L!=0.0){R=c[f>>2]|0;J=I+1|0;if((J|0)>(R|0)){Z=J;break}M=(fa(I,q)|0)+r|0;X=L;U=J;while(1){O=m+(H+U<<3)|0;h[O>>3]=+h[O>>3]-X*+h[k+(M+U<<3)>>3];O=U+1|0;if((O|0)>(R|0)){Z=J;break h}X=+h[K>>3];U=O}}else{Z=I+1|0}}while(0);if((Z|0)>(P|0)){break}else{I=Z}}}else{I=1;while(1){K=m+(H+I<<3)|0;L=+h[K>>3];i:do{if(L!=0.0){X=L/+h[k+(I+r+(fa(I,q)|0)<<3)>>3];h[K>>3]=X;U=c[f>>2]|0;J=I+1|0;if((J|0)>(U|0)){_=J;break}R=(fa(I,q)|0)+r|0;Q=X;M=J;while(1){O=m+(H+M<<3)|0;h[O>>3]=+h[O>>3]-Q*+h[k+(R+M<<3)>>3];O=M+1|0;if((O|0)>(U|0)){_=J;break i}Q=+h[K>>3];M=O}}else{_=I+1|0}}while(0);if((_|0)>(P|0)){break}else{I=_}}}}}while(0);F=F+1|0;}while((F|0)<=(D|0));i=o;return 0}if(!z){if(a){if((D|0)<=0){i=o;return 0}F=(w|0)==0;G=D;while(1){do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];E=c[f>>2]|0;if((E|0)<1){break}I=(fa(G,s)|0)+t|0;P=1;do{H=m+(I+P<<3)|0;h[H>>3]=L*+h[H>>3];P=P+1|0;}while((P|0)<=(E|0))}}while(0);E=G+ -1|0;if((E|0)>=1){P=(fa(G,q)|0)+r|0;I=(fa(G,s)|0)+t|0;H=1;do{L=+h[k+(P+H<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(H,s)|0)+t|0;J=1;do{U=m+(M+J<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(I+J<<3)>>3];J=J+1|0;}while((J|0)<=(K|0))}}while(0);H=H+1|0;}while((H|0)<=(E|0))}L=+h[j>>3];j:do{if(L!=1.0){H=c[f>>2]|0;if((H|0)<1){break}I=(fa(G,s)|0)+t|0;Q=L;P=1;while(1){K=m+(I+P<<3)|0;h[K>>3]=Q*+h[K>>3];K=P+1|0;if((K|0)>(H|0)){break j}Q=+h[j>>3];P=K}}}while(0);if((E|0)>0){G=E}else{break}}i=o;return 0}else{if((D|0)<1){i=o;return 0}G=(w|0)==0;F=1;while(1){do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}P=(fa(F,s)|0)+t|0;H=1;do{I=m+(P+H<<3)|0;h[I>>3]=L*+h[I>>3];H=H+1|0;}while((H|0)<=(z|0))}}while(0);E=c[g>>2]|0;z=F+1|0;if((z|0)<=(E|0)){H=(fa(F,q)|0)+r|0;P=(fa(F,s)|0)+t|0;I=z;do{L=+h[k+(H+I<<3)>>3];do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}J=(fa(I,s)|0)+t|0;M=1;do{U=m+(J+M<<3)|0;h[U>>3]=+h[U>>3]-L*+h[m+(P+M<<3)>>3];M=M+1|0;}while((M|0)<=(K|0))}}while(0);I=I+1|0;}while((I|0)<=(E|0))}L=+h[j>>3];k:do{if(L!=1.0){E=c[f>>2]|0;if((E|0)<1){break}I=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){H=m+(I+P<<3)|0;h[H>>3]=Q*+h[H>>3];H=P+1|0;if((H|0)>(E|0)){break k}Q=+h[j>>3];P=H}}}while(0);if((z|0)>(D|0)){break}else{F=z}}i=o;return 0}}if(a){if((D|0)<1){i=o;return 0}F=(w|0)==0;G=1;do{L=+h[j>>3];l:do{if(L!=1.0){P=c[f>>2]|0;if((P|0)<1){break}E=(fa(G,s)|0)+t|0;Q=L;I=1;while(1){H=m+(E+I<<3)|0;h[H>>3]=Q*+h[H>>3];H=I+1|0;if((H|0)>(P|0)){break l}Q=+h[j>>3];I=H}}}while(0);z=G+ -1|0;if((z|0)>=1){I=(fa(G,q)|0)+r|0;P=(fa(G,s)|0)+t|0;E=1;do{H=k+(I+E<<3)|0;L=+h[H>>3];m:do{if(L!=0.0){K=c[f>>2]|0;if((K|0)<1){break}M=(fa(E,s)|0)+t|0;Q=L;J=1;while(1){U=m+(P+J<<3)|0;h[U>>3]=+h[U>>3]-Q*+h[m+(M+J<<3)>>3];U=J+1|0;if((U|0)>(K|0)){break m}Q=+h[H>>3];J=U}}}while(0);E=E+1|0;}while((E|0)<=(z|0))}do{if(!F){L=1.0/+h[k+(G+r+(fa(G,q)|0)<<3)>>3];z=c[f>>2]|0;if((z|0)<1){break}E=(fa(G,s)|0)+t|0;P=1;do{I=m+(E+P<<3)|0;h[I>>3]=L*+h[I>>3];P=P+1|0;}while((P|0)<=(z|0))}}while(0);G=G+1|0;}while((G|0)<=(D|0));i=o;return 0}else{if((D|0)<=0){i=o;return 0}G=(w|0)==0;F=D;do{L=+h[j>>3];n:do{if(L!=1.0){a=c[f>>2]|0;if((a|0)<1){break}z=(fa(F,s)|0)+t|0;Q=L;P=1;while(1){E=m+(z+P<<3)|0;h[E>>3]=Q*+h[E>>3];E=P+1|0;if((E|0)>(a|0)){break n}Q=+h[j>>3];P=E}}}while(0);P=c[g>>2]|0;a=F+1|0;if((a|0)<=(P|0)){z=(fa(F,q)|0)+r|0;E=(fa(F,s)|0)+t|0;I=a;do{a=k+(z+I<<3)|0;L=+h[a>>3];o:do{if(L!=0.0){H=c[f>>2]|0;if((H|0)<1){break}J=(fa(I,s)|0)+t|0;Q=L;K=1;while(1){M=m+(E+K<<3)|0;h[M>>3]=+h[M>>3]-Q*+h[m+(J+K<<3)>>3];M=K+1|0;if((M|0)>(H|0)){break o}Q=+h[a>>3];K=M}}}while(0);I=I+1|0;}while((I|0)<=(P|0))}do{if(!G){L=1.0/+h[k+(F+r+(fa(F,q)|0)<<3)>>3];P=c[f>>2]|0;if((P|0)<1){break}I=(fa(F,s)|0)+t|0;E=1;do{z=m+(I+E<<3)|0;h[z>>3]=L*+h[z>>3];E=E+1|0;}while((E|0)<=(P|0))}}while(0);F=F+ -1|0;}while((F|0)>0);i=o;return 0}}}while(0);Ab(281048,p|0)|0;i=o;return 0}function pwc(a,b,d,e,f,g,h,j){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;var k=0,l=0,m=0,n=0,o=0;k=i;i=i+8|0;l=k;c[j>>2]=0;m=c[a>>2]|0;do{if((m|0)<0){c[j>>2]=-1;n=-1}else{if((c[b>>2]|0)<0){c[j>>2]=-2;n=-2;break}o=(m|0)>1?m:1;if((c[e>>2]|0)<(o|0)){c[j>>2]=-4;n=-4;break}if((c[h>>2]|0)<(o|0)){c[j>>2]=-7;n=-7;break}rwc(a,a,d,e,f,j)|0;if((c[j>>2]|0)!=0){i=k;return 0}swc(281064,a,b,d,e,f,g,h,j)|0;i=k;return 0}}while(0);c[l>>2]=0-n;Ab(281056,l|0)|0;i=k;return 0}function qwc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0.0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0.0,E=0.0,F=0,G=0.0,H=0,I=0;j=i;i=i+32|0;k=j;l=j+8|0;m=j+16|0;n=j+24|0;o=c[e>>2]|0;p=~o;c[g>>2]=0;q=c[a>>2]|0;do{if((q|0)<0){c[g>>2]=-1;r=-1}else{s=c[b>>2]|0;if((s|0)<0){c[g>>2]=-2;r=-2;break}if((c[e>>2]|0)<(((q|0)>1?q:1)|0)){c[g>>2]=-4;r=-4;break}if((q|0)==0|(s|0)==0){i=j;return 0}t=+tDc(281088);s=c[a>>2]|0;u=c[b>>2]|0;v=(s|0)>(u|0)?u:s;c[k>>2]=v;if((v|0)<1){i=j;return 0}else{w=s;x=1}while(1){c[l>>2]=1-x+w;s=x+ -1|0;v=fa(x,o)|0;u=x+p|0;y=u+v|0;z=d+(y<<3)|0;A=s+(jwc(l,z,281096)|0)|0;c[f+(s<<2)>>2]=A;B=v+p|0;a:do{if(+h[d+(B+A<<3)>>3]!=0.0){if((A|0)!=(x|0)){lwc(b,d+(s<<3)|0,e,d+(A+ -1<<3)|0,e)|0}C=c[a>>2]|0;if((x|0)>=(C|0)){break}D=+h[z>>3];h[n>>3]=D;if(!(D>=0.0)){E=-D}else{E=D}F=C-x|0;c[l>>2]=F;if(E>=t){h[n>>3]=1.0/D;kwc(l,n,d+(x-o+v<<3)|0,281096)|0;break}if((F|0)<1){break}else{G=D;H=1}while(1){C=d+(y+H<<3)|0;h[C>>3]=+h[C>>3]/G;C=H+1|0;if((C|0)>(F|0)){break a}G=+h[z>>3];H=C}}else{if((c[g>>2]|0)!=0){break}c[g>>2]=x}}while(0);z=c[a>>2]|0;y=c[b>>2]|0;if((x|0)<(((z|0)>(y|0)?y:z)|0)){c[l>>2]=z-x;c[m>>2]=y-x;y=x+1|0;z=fa(y,o)|0;mwc(l,m,281104,d+(B+y<<3)|0,281096,d+(u+z<<3)|0,e,d+(y+p+z<<3)|0,e)|0;I=y}else{I=x+1|0}if((I|0)>(c[k>>2]|0)){break}w=c[a>>2]|0;x=I}i=j;return 0}}while(0);c[k>>2]=0-r;Ab(281080,k|0)|0;i=j;return 0}function rwc(a,b,d,e,f,g){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;var h=0,j=0,k=0,l=0,m=0,n=0,o=0,p=0,q=0,r=0,s=0,t=0,u=0,v=0,w=0,x=0,y=0,z=0,A=0,B=0,C=0,D=0,E=0,F=0,G=0,H=0;h=i;i=i+48|0;j=h;k=h+8|0;l=h+16|0;m=h+24|0;n=h+32|0;o=h+40|0;p=c[e>>2]|0;q=~p;c[g>>2]=0;r=c[a>>2]|0;do{if((r|0)<0){c[g>>2]=-1;s=-1}else{t=c[b>>2]|0;if((t|0)<0){c[g>>2]=-2;s=-2;break}if((c[e>>2]|0)<(((r|0)>1?r:1)|0)){c[g>>2]=-4;s=-4;break}if((r|0)==0|(t|0)==0){i=h;return 0}t=281136;u=uwc(281120,281112,281128,a,b,t,t)|0;do{if((u|0)>=2){t=c[a>>2]|0;v=c[b>>2]|0;w=(t|0)>(v|0)?v:t;if((u|0)>=(w|0)){break}c[j>>2]=w;c[m>>2]=1;if((w|0)>0){x=v;y=t;z=1}else{i=h;return 0}while(1){t=((y|0)>(x|0)?x:y)-z+1|0;c[n>>2]=(t|0)<=(u|0)?t:u;c[k>>2]=y+1-z;qwc(k,n,d+(z+q+(fa(z,p)|0)<<3)|0,e,f+(z+ -1<<2)|0,o)|0;do{if((c[g>>2]|0)==0){t=c[o>>2]|0;if((t|0)<=0){break}c[g>>2]=t+ -1+(c[m>>2]|0)}}while(0);t=c[a>>2]|0;c[l>>2]=t;v=c[m>>2]|0;w=v+ -1|0;A=w+(c[n>>2]|0)|0;B=(t|0)<=(A|0)?t:A;c[k>>2]=B;if((v|0)<=(B|0)){t=v;do{v=f+(t+ -1<<2)|0;c[v>>2]=(c[v>>2]|0)+w;t=t+1|0;}while((t|0)<=(B|0))}c[k>>2]=w;c[l>>2]=A;twc(k,d,e,m,l,f,281120)|0;B=c[m>>2]|0;t=c[n>>2]|0;v=t+B|0;C=c[b>>2]|0;do{if((v|0)>(C|0)){D=B}else{c[k>>2]=1-B-t+C;c[l>>2]=v+ -1;twc(k,d+((fa(v,p)|0)-p<<3)|0,e,m,l,f,281120)|0;E=c[m>>2]|0;F=c[n>>2]|0;c[k>>2]=(c[b>>2]|0)+1-E-F;G=E+q|0;owc(281144,281152,281160,281176,n,k,281184,d+(G+(fa(E,p)|0)<<3)|0,e,d+(G+(fa(F+E|0,p)|0)<<3)|0,e)|0;E=c[m>>2]|0;F=c[n>>2]|0;G=F+E|0;H=c[a>>2]|0;if((G|0)>(H|0)){D=E;break}c[k>>2]=1-E-F+H;c[l>>2]=(c[b>>2]|0)+1-E-F;F=fa(G,p)|0;H=281160;nwc(H,H,k,l,n,281192,d+((fa(E,p)|0)+q+G<<3)|0,e,d+(E+q+F<<3)|0,e,281184,d+(G+q+F<<3)|0,e)|0;D=c[m>>2]|0}}while(0);v=D+u|0;c[m>>2]=v;if((v|0)>(c[j>>2]|0)){break}x=c[b>>2]|0;y=c[a>>2]|0;z=v}i=h;return 0}}while(0);qwc(a,b,d,e,f,g)|0;i=h;return 0}}while(0);c[j>>2]=0-s;Ab(281112,j|0)|0;i=h;return 0}function swc(a,b,d,e,f,g,h,j,k){a=a|0;b=b|0;d=d|0;e=e|0;f=f|0;g=g|0;h=h|0;j=j|0;k=k|0;var l=0,m=0,n=0,o=0,p=0,q=0,r=0;l=i;i=i+8|0;m=l;c[k>>2]=0;n=(MDc(a,281200)|0)!=0;do{if(n){o=5}else{if((MDc(a,281208)|0)!=0){o=5;break}if((MDc(a,281216)|0)!=0){o=5;break}c[k>>2]=-1;p=-1}}while(0);do{if((o|0)==5){a=c[b>>2]|0;if((a|0)<0){c[k>>2]=-2;p=-2;break}q=c[d>>2]|0;if((q|0)<0){c[k>>2]=-3;p=-3;break}r=(a|0)>1?a:1;if((c[f>>2]|0)<(r|0)){c[k>>2]=-5;p=-5;break}if((c[j>>2]|0)<(r|0)){c[k>>2]=-8;p=-8;break}r=c[k>>2]|0;if((r|0)!=0){p=r;break}if((a|0)==0|(q|0)==0){i=l;return 0}if(n){q=281232;twc(d,h,j,q,b,g,q)|0;owc(281240,281248,281256,281272,b,d,281280,e,f,h,j)|0;owc(281240,281288,281256,281296,b,d,281280,e,f,h,j)|0;i=l;return 0}else{owc(281240,281288,281312,281296,b,d,281280,e,f,h,j)|0;owc(281240,281248,281312,281272,b,d,281280,e,f,h,j)|0;twc(d,h,j,281232,b,g,281328)|0;i=l;return 0}}}while(0);c[m>>2]=0-p;Ab(281224,m|0)|0;i=l;return 0}function _Modelica_Mechanics_MultiBody_Examples_Loops_EngineV6_updateBoundParameters$0(a){a=a|0;var b=0;b=c[a+8>>2]|0;a:do{eIb(b);fIb(b);gIb(b);hIb(b);iIb(b);jIb(b);kIb(b);lIb(b);mIb(b);nIb(b);oIb(b);pIb(b);qIb(b);rIb(b);sIb(b);tIb(b);uIb(b);vIb(b);wIb(b);xIb(b);yIb(b);zIb(b);AIb(b);BIb(b);CIb(b);DIb(b);EIb(b);FIb(b);GIb(b);HIb(b);IIb(b);JIb(b);KIb(b);LIb(b);MIb(b);NIb(b);OIb(b);PIb(b);QIb(b);RIb(b);SIb(b);TIb(b);UIb(b);VIb(b);WIb(b);XIb(b);YIb(b);ZIb(b);_Ib(b);$Ib(b);aJb(b);bJb(b);cJb(b);dJb(b);eJb(b);fJb(b);gJb(b);hJb(b);iJb(b);jJb(b);kJb(b);lJb(b);mJb(b);nJb(b);oJb(b);pJb(b);qJb(b);rJb(b);sJb(b);tJb(b);uJb(b);vJb(b);wJb(b);xJb(b);yJb(b);zJb(b);AJb(b);BJb(b);CJb(b);DJb(b);EJb(b);FJb(b);GJb(b);HJb(b);IJb(b);JJb(b);KJb(b);LJb(b);MJb(b);NJb(b);OJb(b);PJb(b);QJb(b);RJb(b);SJb(b);TJb(b);UJb(b);VJb(b);WJb(b);XJb(b);YJb(b);ZJb(b);_Jb(b);$Jb(b);aKb(b);bKb(b);cKb(b);dKb(b);eKb(b);fKb(b);gKb(b);hKb(b);iKb(b);jKb(b);kKb(b);lKb(b);mKb(b);nKb(b);oKb(b);pKb(b);qKb(b);rKb(b);sKb(b);tKb(b);uKb(b);vKb(b);wKb(b);xKb(b);yKb(b);zKb(b);AKb(b);BKb(b);CKb(b);DKb(b);EKb(b);FKb(b);GKb(b);HKb(b);IKb(b);JKb(b);KKb(b);LKb(b);MKb(b);NKb(b);OKb(b);PKb(b);QKb(b);RKb(b);SKb(b);TKb(b);UKb(b);VKb(b);WKb(b);XKb(b);YKb(b);ZKb(b);_Kb(b);$Kb(b);aLb(b);bLb(b);cLb(b);dLb(b);eLb(b);fLb(b);gLb(b);hLb(b);iLb(b);jLb(b);kLb(b);lLb(b);mLb(b);nLb(b);oLb(b);pLb(b);qLb(b);rLb(b);sLb(b);tLb(b);uLb(b);vLb(b);wLb(b);xLb(b);yLb(b);zLb(b);ALb(b);BLb(b);CLb(b);DLb(b);ELb(b);FLb(b);GLb(b);HLb(b);ILb(b);JLb(b);KLb(b);LLb(b);MLb(b);NLb(b);OLb(b);PLb(b);QLb(b);RLb(b);SLb(b);TLb(b);ULb(b);VLb(b);WLb(b);XLb(b);YLb(b);ZLb(b);_Lb(b);$Lb(b);aMb(b);bMb(b);cMb(b);dMb(b);eMb(b);fMb(b);gMb(b);hMb(b);iMb(b);jMb(b);kMb(b);lMb(b);mMb(b);nMb(b);oMb(b);pMb(b);qMb(b);rMb(b);sMb(b);tMb(b);uMb(b);vMb(b);wMb(b);xMb(b);yMb(b);zMb(b);AMb(b);BMb(b);CMb(b);DMb(b);EMb(b);FMb(b);GMb(b);HMb(b);IMb(b);JMb(b);KMb(b);LMb(b);MMb(b);NMb(b);OMb(b);PMb(b);QMb(b);RMb(b);SMb(b);TMb(b);UMb(b);VMb(b);WMb(b);XMb(b);YMb(b);ZMb(b);_Mb(b);$Mb(b);aNb(b);bNb(b);cNb(b);dNb(b);eNb(b);fNb(b);gNb(b);hNb(b);iNb(b);jNb(b);kNb(b);lNb(b);mNb(b);nNb(b);oNb(b);pNb(b);qNb(b);rNb(b);sNb(b);tNb(b);uNb(b);vNb(b);wNb(b);xNb(b);yNb(b);zNb(b);ANb(b);BNb(b);CNb(b);DNb(b);ENb(b);FNb(b);GNb(b);HNb(b);INb(b);JNb(b);KNb(b);LNb(b);MNb(b);NNb(b);ONb(b);PNb(b);QNb(b);RNb(b);SNb(b);TNb(b);UNb(b);VNb(b);WNb(b);XNb(b);YNb(b);ZNb(b);_Nb(b);$Nb(b);aOb(b);bOb(b);cOb(b);dOb(b);eOb(b);fOb(b);gOb(b);hOb(b);iOb(b);jOb(b);kOb(b);lOb(b);mOb(b);nOb(b);oOb(b);pOb(b);qOb(b);rOb(b);sOb(b);tOb(b);uOb(b);vOb(b);wOb(b);xOb(b);yOb(b);zOb(b);AOb(b);BOb(b);COb(b);DOb(b);EOb(b);FOb(b);GOb(b);HOb(b);IOb(b);JOb(b);KOb(b);LOb(b);MOb(b);NOb(b);OOb(b);POb(b);QOb(b);ROb(b);SOb(b);TOb(b);UOb(b);VOb(b);WOb(b);XOb(b);YOb(b);ZOb(b);_Ob(b);$Ob(b);aPb(b);bPb(b);cPb(b);dPb(b);ePb(b);fPb(b);gPb(b);hPb(b);iPb(b);jPb(b);kPb(b);lPb(b);mPb(b);nPb(b);oPb(b);pPb(b);qPb(b);rPb(b);sPb(b);tPb(b);uPb(b);vPb(b);wPb(b);xPb(b);yPb(b);zPb(b);APb(b);BPb(b);CPb(b);DPb(b);EPb(b);FPb(b);GPb(b);HPb(b);IPb(b);JPb(b);KPb(b);LPb(b);MPb(b);NPb(b);OPb(b);PPb(b);QPb(b);RPb(b);SPb(b);TPb(b);UPb(b);VPb(b);WPb(b);XPb(b);YPb(b);ZPb(b);_Pb(b);$Pb(b);aQb(b);bQb(b);cQb(b);dQb(b);eQb(b);fQb(b);gQb(b);hQb(b);iQb(b);jQb(b);kQb(b);lQb(b);mQb(b);nQb(b);oQb(b);pQb(b);qQb(b);rQb(b);sQb(b);tQb(b);uQb(b);vQb(b);wQb(b);xQb(b);yQb(b);zQb(b);AQb(b);BQb(b);CQb(b);DQb(b);EQb(b);FQb(b);GQb(b);HQb(b);IQb(b);JQb(b);KQb(b);LQb(b);MQb(b);NQb(b);OQb(b);PQb(b);QQb(b);RQb(b);SQb(b);TQb(b);UQb(b);VQb(b);WQb(b);XQb(b);YQb(b);ZQb(b);_Qb(b);$Qb(b);aRb(b);bRb(b);cRb(b);dRb(b);eRb(b);fRb(b);gRb(b);hRb(b);iRb(b);jRb(b);kRb(b);lRb(b);mRb(b);nRb(b);oRb(b);pRb(b);qRb(b);rRb(b);sRb(b);tRb(b);uRb(b);vRb(b);wRb(b);xRb(b);yRb(b);zRb(b);ARb(b);BRb(b);CRb(b);DRb(b);ERb(b);FRb(b);GRb(b);HRb(b);IRb(b);JRb(b);KRb(b);LRb(b);MRb(b);NRb(b);ORb(b);PRb(b);QRb(b);RRb(b);SRb(b);TRb(b);URb(b);VRb(b);WRb(b);XRb(b);YRb(b);ZRb(b);_Rb(b);$Rb(b);aSb(b);bSb(b);cSb(b);dSb(b);eSb(b);fSb(b);gSb(b);hSb(b);iSb(b);jSb(b);kSb(b);lSb(b);mSb(b);nSb(b);oSb(b);pSb(b);qSb(b);rSb(b);sSb(b);tSb(b);uSb(b);vSb(b);wSb(b);xSb(b);ySb(b);zSb(b);ASb(b);BSb(b);CSb(b);DSb(b);ESb(b);FSb(b);GSb(b);HSb(b);ISb(b);JSb(b);KSb(b);LSb(b);MSb(b);NSb(b);OSb(b);PSb(b);QSb(b);RSb(b);SSb(b);TSb(b);USb(b);VSb(b);WSb(b);XSb(b);YSb(b);ZSb(b);_Sb(b);$Sb(b);aTb(b);bTb(b);cTb(b);dTb(b);eTb(b);fTb(b);gTb(b);hTb(b);iTb(b);jTb(b);kTb(b);lTb(b);mTb(b);nTb(b);oTb(b);pTb(b);qTb(b);rTb(b);sTb(b);tTb(b);uTb(b);vTb(b);wTb(b);xTb(b);yTb(b);zTb(b);ATb(b);BTb(b);CTb(b);DTb(b);ETb(b);FTb(b);GTb(b);HTb(b);ITb(b);JTb(b);KTb(b);LTb(b);MTb(b);NTb(b);OTb(b);PTb(b);QTb(b);RTb(b);STb(b);TTb(b);UTb(b);VTb(b);WTb(b);XTb(b);YTb(b);ZTb(b);_Tb(b);$Tb(b);aUb(b);bUb(b);cUb(b);dUb(b);eUb(b);fUb(b);gUb(b);hUb(b);iUb(b);jUb(b);kUb(b);lUb(b);mUb(b);nUb(b);oUb(b);pUb(b);qUb(b);rUb(b);sUb(b);tUb(b);uUb(b);vUb(b);wUb(b);xUb(b);yUb(b);zUb(b);AUb(b);BUb(b);CUb(b);DUb(b);EUb(b);FUb(b);GUb(b);HUb(b);IUb(b);JUb(b);KUb(b);LUb(b);MUb(b);NUb(b);OUb(b);PUb(b);QUb(b);RUb(b);SUb(b);TUb(b);UUb(b);VUb(b);WUb(b);XUb(b);YUb(b);ZUb(b);_Ub(b);$Ub(b);aVb(b);bVb(b);cVb(b);dVb(b);eVb(b);fVb(b);gVb(b);hVb(b);iVb(b);jVb(b);kVb(b);lVb(b);mVb(b);nVb(b);oVb(b);pVb(b);qVb(b);rVb(b);sVb(b);tVb(b);uVb(b);vVb(b);wVb(b);xVb(b);yVb(b);zVb(b);AVb(b);BVb(b);CVb(b);DVb(b);EVb(b);FVb(b);GVb(b);HVb(b);IVb(b);JVb(b);KVb(b);LVb(b);MVb(b);NVb(b);OVb(b);PVb(b);QVb(b);RVb(b);SVb(b);TVb(b);UVb(b);VVb(b);WVb(b);XVb(b);YVb(b);ZVb(b);_Vb(b);$Vb(b);aWb(b);bWb(b);cWb(b);dWb(b);eWb(b);fWb(b);gWb(b);hWb(b);iWb(b);jWb(b);kWb(b);lWb(b);mWb(b);nWb(b);oWb(b);pWb(b);qWb(b);rWb(b);sWb(b);tWb(b);uWb(b);vWb(b);wWb(b);xWb(b);yWb(b);zWb(b);AWb(b);BWb(b);CWb(b);DWb(b);EWb(b);FWb(b);GWb(b);HWb(b);IWb(b);JWb(b);KWb(b);LWb(b);MWb(b);NWb(b);OWb(b);PWb(b);QWb(b);RWb(b);SWb(b);TWb(b);UWb(b);VWb(b);WWb(b);XWb(b);YWb(b);ZWb(b);_Wb(b);$Wb(b);aXb(b);bXb(b);cXb(b);dXb(b);eXb(b);fXb(b);gXb(b);hXb(b);iXb(b);jXb(b);kXb(b);lXb(b);mXb(b);nXb(b);oXb(b);pXb(b);qXb(b);rXb(b);sXb(b);tXb(b);uXb(b);vXb(b);wXb(b);xXb(b);yXb(b);zXb(b);AXb(b);BXb(b);CXb(b);DXb(b);EXb(b);FXb(b);GXb(b);HXb(b);IXb(b);JXb(b);KXb(b);LXb(b);MXb(b);NXb(b);OXb(b);PXb(b);QXb(b);RXb(b);SXb(b);TXb(b);UXb(b);VXb(b);WXb(b);XXb(b);YXb(b);ZXb(b);_Xb(b);$Xb(b);aYb(b);bYb(b);cYb(b);dYb(b);eYb(b);fYb(b);gYb(b);hYb(b);iYb(b);jYb(b);kYb(b);lYb(b);mYb(b);nYb(b);oYb(b);pYb(b);qYb(b);rYb(b);sYb(b);tYb(b);uYb(b);vYb(b);wYb(b);xYb(b);yYb(b);zYb(b);AYb(b);BYb(b);CYb(b);DYb(b);EYb(b);FYb(b);GYb(b);HYb(b);IYb(b);JYb(b);KYb(b);LYb(b);MYb(b);NYb(b);OYb(b);PYb(b);QYb(b);RYb(b);SYb(b);TYb(b);UYb(b);VYb(b);WYb(b);XYb(b);YYb(b);ZYb(b);_Yb(b);$Yb(b);aZb(b);bZb(b);cZb(b);dZb(b);eZb(b);fZb(b);gZb(b);hZb(b);iZb(b);jZb(b);kZb(b);lZb(b);mZb(b);nZb(b);oZb(b);pZb(b);qZb(b);rZb(b);sZb(b);tZb(b);uZb(b);vZb(b);wZb(b);xZb(b);yZb(b);zZb(b);AZb(b);BZb(b);CZb(b);DZb(b);EZb(b);FZb(b);GZb(b);HZb(b);IZb(b);JZb(b);KZb(b);LZb(b);MZb(b);NZb(b);OZb(b);PZb(b);QZb(b);RZb(b);SZb(b);TZb(b);UZb(b);VZb(b);WZb(b);XZb(b);YZb(b);ZZb(b);_Zb(b);$Zb(b);a_b(b);b_b(b);c_b(b);d_b(b);e_b(b);f_b(b);g_b(b);h_b(b);i_b(b);j_b(b);k_b(b);l_b(b);m_b(b);n_b(b);o_b(b);p_b(b);q_b(b);r_b(b);s_b(b);t_b(b);u_b(b);v_b(b);w_b(b);x_b(b);y_b(b);z_b(b);A_b(b);B_b(b);C_b(b);D_b(b);E_b(b);F_b(b);G_b(b);H_b(b);I_b(b);J_b(b);K_b(b);L_b(b);M_b(b);N_b(b);O_b(b);P_b(b);Q_b(b);R_b(b);S_b(b);T_b(b);U_b(b);V_b(b);W_b(b);X_b(b);Y_b(b);Z_b(b);__b(b);$_b(b);a$b(b);b$b(b);c$b(b);d$b(b);e$b(b);f$b(b);g$b(b);h$b(b);i$b(b);j$b(b);k$b(b);l$b(b);m$b(b);n$b(b);o$b(b);p$b(b);q$b(b);r$b(b);s$b(b);t$b(b);u$b(b);v$b(b);w$b(b);x$b(b);y$b(b);z$b(b);A$b(b);B$b(b);C$b(b);D$b(b);E$b(b);F$b(b);G$b(b);H$b(b);I$b(b);J$b(b);K$b(b);L$b(b);M$b(b);N$b(b);O$b(b);P$b(b);Q$b(b);R$b(b);S$b(b);T$b(b);U$b(b);V$b(b);W$b(b);X$b(b);Y$b(b);Z$b(b);_$b(b);$$b(b);a0b(b);b0b(b);c0b(b);d0b(b);e0b(b);f0b(b);g0b(b);h0b(b);i0b(b);j0b(b);k0b(b);l0b(b);m0b(b);n0b(b);o0b(b);p0b(b);q0b(b);r0b(b);s0b(b);t0b(b);u0b(b);v0b(b);w0b(b);x0b(b);y0b(b);z0b(b);A0b(b);B0b(b);C0b(b);D0b(b);E0b(b);F0b(b);G0b(b);H0b(b);I0b(b);J0b(b);K0b(b);L0b(b);M0b(b);N0b(b);O0b(b);P0b(b);Q0b(b);R0b(b);S0b(b);T0b(b);U0b(b);V0b(b);W0b(b);X0b(b);Y0b(b);Z0b(b);_0b(b);$0b(b);a1b(b);b1b(b);c1b(b);d1b(b);e1b(b);f1b(b);g1b(b);h1b(b);i1b(b);j1b(b);k1b(b);l1b(b);m1b(b);n1b(b);o1b(b);p1b(b);q1b(b);r1b(b);s1b(b);t1b(b);u1b(b);v1b(b);w1b(b);x1b(b);y1b(b);z1b(b);A1b(b);B1b(b);C1b(b);D1b(b);E1b(b);F1b(b);G1b(b);H1b(b);I1b(b);J1b(b);K1b(b);L1b(b);M1b(b);N1b(b);O1b(b);P1b(b);Q1b(b);R1b(b);S1b(b);T1b(b);U1b(b);V1b(b);W1b(b);X1b(b);Y1b(b);Z1b(b);_1b(b);$1b(b);a2b(b);b2b(b);c2b(b);d2b(b);e2b(b);f2b(b);g2b(b);h2b(b);i2b(b);j2b(b);k2b(b);l2b(b);m2b(b);n2b(b);o2b(b);p2b(b);q2b(b);r2b(b);s2b(b);t2b(b);u2b(b);v2b(b);w2b(b);x2b(b);y2b(b);z2b(b);A2b(b);B2b(b);C2b(b);D2b(b);E2b(b);F2b(b);G2b(b);H2b(b);I2b(b);J2b(b);K2b(b);L2b(b);M2b(b);N2b(b);O2b(b);P2b(b);Q2b(b);R2b(b);S2b(b);T2b(b);U2b(b);V2b(b);W2b(b);X2b(b);Y2b(b);Z2b(b);_2b(b);$2b(b);a3b(b);b3b(b);c3b(b);d3b(b);e3b(b);f3b(b);g3b(b);h3b(b);i3b(b);j3b(b);k3b(b);l3b(b);m3b(b);n3b(b);o3b(b);p3b(b);q3b(b);r3b(b);s3b(b);t3b(b);u3b(b);v3b(b);w3b(b);x3b(b);y3b(b);z3b(b);A3b(b);B3b(b);C3b(b);D3b(b);E3b(b);F3b(b);G3b(b);H3b(b);I3b(b);J3b(b);K3b(b);L3b(b);M3b(b);N3b(b);O3b(b);P3b(b);Q3b(b);R3b(b);S3b(b);T3b(b);U3b(b);V3b(b);W3b(b);X3b(b);Y3b(b);Z3b(b);_3b(b);$3b(b);a4b(b);b4b(b);c4b(b);d4b(b);e4b(b);f4b(b);g4b(b);h4b(b);i4b(b);j4b(b);k4b(b);l4b(b);m4b(b);n4b(b);o4b(b);p4b(b);q4b(b);r4b(b);s4b(b);t4b(b);u4b(b);v4b(b);w4b(b);x4b(b);y4b(b);z4b(b);A4b(b);B4b(b);C4b(b);D4b(b);E4b(b);F4b(b);G4b(b);H4b(b);I4b(b);J4b(b);K4b(b);L4b(b);M4b(b);N4b(b);O4b(b);P4b(b);Q4b(b);R4b(b);S4b(b);T4b(b);U4b(b);V4b(b);W4b(b);X4b(b);Y4b(b);Z4b(b);_4b(b);$4b(b);a5b(b);b5b(b);c5b(b);d5b(b);e5b(b);f5b(b);g5b(b);h5b(b);i5b(b);j5b(b);k5b(b);l5b(b);m5b(b);n5b(b);o5b(b);p5b(b);q5b(b);r5b(b);s5b(b);t5b(b);u5b(b);v5b(b);w5b(b);x5b(b);y5b(b);z5b(b);A5b(b);B5b(b);C5b(b);D5b(b);E5b(b);F5b(b);G5b(b);H5b(b);I5b(b);J5b(b);K5b(b);L5b(b);M5b(b);N5b(b);O5b(b);P5b(b);Q5b(b);R5b(b);S5b(b);T5b(b);U5b(b);V5b(b);W5b(b);X5b(b);Y5b(b);Z5b(b);_5b(b);$5b(b);a6b(b);b6b(b);c6b(b);d6b(b);e6b(b);f6b(b);g6b(b);h6b(b);i6b(b);j6b(b);k6b(b);l6b(b);m6b(b);n6b(b);o6b(b);p6b(b);q6b(b);r6b(b);s6b(b);t6b(b);u6b(b);v6b(b);w6b(b);x6b(b);y6b(b);z6b(b);A6b(b);B6b(b);C6b(b);D6b(b);E6b(b);F6b(b);G6b(b);H6b(b);I6b(b);J6b(b);K6b(b);L6b(b);M6b(b);N6b(b);O6b(b);P6b(b);Q6b(b);R6b(b);S6b(b);T6b(b);U6b(b);V6b(b);W6b(b);X6b(b);Y6b(b);Z6b(b);_6b(b);$6b(b);a7b(b);b7b(b);c7b(b);d7b(b);e7b(b);f7b(b);g7b(b);h7b(b);i7b(b);j7b(b);k7b(b);l7b(b);m7b(b);n7b(b);o7b(b);p7b(b);q7b(b);r7b(b);s7b(b);t7b(b);u7b(b);v7b(b);w7b(b);x7b(b);y7b(b);z7b(b);A7b(b);B7b(b);C7b(b);D7b(b);E7b(b);F7b(b);G7b(b);H7b(b);I7b(b);J7b(b);K7b(b);L7b(b);M7b(b);N7b(b);O7b(b);P7b(b);Q7b(b);R7b(b);S7b(b);T7b(b);U7b(b);V7b(b);W7b(b);X7b(b);Y7b(b);Z7b(b);_7b(b);$7b(b);a8b(b);b8b(b);c8b(b);d8b(b);e8b(b);f8b(b);g8b(b);h8b(b);i8b(b);j8b(b);k8b(b);l8b(b);m8b(b);n8b(b);o8b(b);p8b(b);q8b(b);r8b(b);s8b(b);t8b(b);u8b(b);v8b(b);w8b(b);x8b(b);y8b(b);z8b(b);A8b(b);B8b(b);C8b(b);D8b(b);E8b(b);F8b(b);G8b(b);H8b(b);I8b(b);J8b(b);K8b(b);L8b(b);M8b(b);N8b(b);O8b(b);P8b(b);Q8b(b);R8b(b);S8b(b);T8b(b);U8b(b);V8b(b);W8b(b);X8b(b);Y8b(b);Z8b(b);_8b(b);$8b(b);a9b(b);b9b(b);c9b(b);d9b(b);e9b(b);f9b(b);g9b(b);h9b(b);i9b(b);j9b(b);k9b(b);l9b(b);m9b(b);n9b(b);o9b(b);p9b(b);q9b(b);r9b(b);s9b(b);t9b(b);u9b(b);v9b(b);w9b(b);x9b(b);y9b(b);z9b(b);A9b(b);B9b(b);C9b(b);D9b(b);E9b(b);F9b(b);G9b(b);H9b(b);I9b(b);J9b(b);K9b(b);L9b(b);M9b(b);N9b(b);O9b(b);P9b(b);Q9b(b);R9b(b);S9b(b);T9b(b);U9b(b);V9b(b);W9b(b);X9b(b);Y9b(b);Z9b(b);_9b(b);$9b(b);aac(b);bac(b);cac(b);dac(b);eac(b);fac(b);gac(b);hac(b);iac(b);jac(b);kac(b);lac(b);mac(b);nac(b);oac(b);pac(b);qac(b);rac(b);sac(b);tac(b);uac(b);vac(b);wac(b);xac(b);yac(b);zac(b);Aac(b);Bac(b);Cac(b);Dac(b);Eac(b);Fac(b);Gac(b);Hac(b);Iac(b);Jac(b);Kac(b);Lac(b);Mac(b);Nac(b);Oac(b);Pac(b);Qac(b);Rac(b);Sac(b);Tac(b);Uac(b);Vac(b);Wac(b);Xac(b);Yac(b);Zac(b);_ac(b);$ac(b);abc(b);bbc(b);cbc(b);dbc(b);ebc(b);fbc(b);gbc(b);hbc(b);ibc(b);jbc(b);kbc(b);lbc(b);mbc(b);nbc(b);obc(b);pbc(b);qbc(b);rbc(b);sbc(b);tbc(b);ubc(b);vbc(b);wbc(b);xbc(b);ybc(b);zbc(b);Abc(b);Bbc(b);Cbc(b);Dbc(b);Ebc(b);Fbc(b);Gbc(b);Hbc(b);Ibc(b);Jbc(b);Kbc(b);Lbc(b);Mbc(b);Nbc(b);Obc(b);Pbc(b);Qbc(b);Rbc(b);Sbc(b);Tbc(b);Ubc(b);Vbc(b);Wbc(b);Xbc(b);Ybc(b);Zbc(b);_bc(b);$bc(b);acc(b);bcc(b);ccc(b);dcc(b);ecc(b);fcc(b);gcc(b);hcc(b);icc(b);jcc(b);kcc(b);lcc(b);mcc(b);ncc(b);occ(b);pcc(b);qcc(b);rcc(b);scc(b);tcc(b);ucc(b);vcc(b);wcc(b);xcc(b);ycc(b);zcc(b);Acc(b);Bcc(b);Ccc(b);Dcc(b);Ecc(b);Fcc(b);Gcc(b);Hcc(b);Icc(b);Jcc(b);Kcc(b);Lcc(b);Mcc(b);Ncc(b);Occ(b);Pcc(b);Qcc(b);Rcc(b);Scc(b);Tcc(b);Ucc(b);Vcc(b);Wcc(b);Xcc(b);Ycc(b);Zcc(b);_cc(b);$cc(b);adc(b);bdc(b);cdc(b);ddc(b);edc(b);fdc(b);gdc(b);hdc(b);idc(b);jdc(b);kdc(b);ldc(b);mdc(b);ndc(b);odc(b);pdc(b);qdc(b);rdc(b);sdc(b);tdc(b);udc(b);vdc(b);wdc(b);xdc(b);ydc(b);zdc(b);Adc(b);Bdc(b);Cdc(b);Ddc(b);Edc(b);Fdc(b);Gdc(b);Hdc(b);Idc(b);Jdc(b);Kdc(b);Ldc(b);Mdc(b);Ndc(b);Odc(b);Pdc(b);Qdc(b);Rdc(b);Sdc(b);Tdc(b);Udc(b);Vdc(b);Wdc(b);Xdc(b);Ydc(b);Zdc(b);_dc(b);$dc(b);aec(b);bec(b);cec(b);dec(b);eec(b);fec(b);gec(b);hec(b);iec(b);jec(b);kec(b);lec(b);mec(b);nec(b);oec(b);pec(b);qec(b);rec(b);sec(b);tec(b);uec(b);vec(b);wec(b);xec(b);yec(b);zec(b);Aec(b);Bec(b);Cec(b);Dec(b);Eec(b);Fec(b);Gec(b);Hec(b);Iec(b);Jec(b);Kec(b);Lec(b);Mec(b);Nec(b);Oec(b);Pec(b);Qec(b);Rec(b);Sec(b);Tec(b);Uec(b);Vec(b);Wec(b);Xec(b);Yec(b);Zec(b);_ec(b);$ec(b);afc(b);bfc(b);cfc(b);dfc(b);efc(b);ffc(b);gfc(b);hfc(b);ifc(b);jfc(b);kfc(b);lfc(b);mfc(b);nfc(b);ofc(b);pfc(b);qfc(b);rfc(b);sfc(b);tfc(b);ufc(b);vfc(b);wfc(b);xfc(b);yfc(b);zfc(b);Afc(b);Bfc(b);Cfc(b);Dfc(b);Efc(b);Ffc(b);Gfc(b);Hfc(b);Ifc(b);Jfc(b);Kfc(b);Lfc(b);Mfc(b);Nfc(b);Ofc(b);Pfc(b);Qfc(b);Rfc(b);Sfc(b);Tfc(b);Ufc(b);Vfc(b);Wfc(b);Xfc(b);Yfc(b);Zfc(b);_fc(b);$fc(b);agc(b);bgc(b);cgc(b);dgc(b);egc(b);fgc(b);ggc(b);hgc(b);igc(b);jgc(b);kgc(b);lgc(b);mgc(b);ngc(b);ogc(b);pgc(b);qgc(b);rgc(b);sgc(b);tgc(b);ugc(b);vgc(b);wgc(b);xgc(b);ygc(b);zgc(b);Agc(b);Bgc(b);Cgc(b);Dgc(b);Egc(b);Fgc(b);Ggc(b);Hgc(b);Igc(b);Jgc(b);Kgc(b);Lgc(b);Mgc(b);Ngc(b);Ogc(b);Pgc(b);Qgc(b);Rgc(b);Sgc(b);Tgc(b);Ugc(b);Vgc(b);Wgc(b);Xgc(b);Ygc(b);Zgc(b);_gc(b);$gc(b);ahc(b);bhc(b);chc(b);dhc(b);ehc(b);fhc(b);ghc(b);hhc(b);ihc(b);jhc(b);khc(b);lhc(b);mhc(b);nhc(b);ohc(b);phc(b);qhc(b);rhc(b);shc(b);thc(b);uhc(b);vhc(b);whc(b);xhc(b);yhc(b);zhc(b);Ahc(b);Bhc(b);Chc(b);Dhc(b);Ehc(b);Fhc(b);Ghc(b);Hhc(b);Ihc(b);Jhc(b);Khc(b);Lhc(b);Mhc(b);Nhc(b);Ohc(b);Phc(b);Qhc(b);Rhc(b);Shc(b);Thc(b);Uhc(b);Vhc(b);Whc(b);Xhc(b);Yhc(b);Zhc(b);_hc(b);$hc(b);aic(b);bic(b);cic(b);dic(b);eic(b);fic(b);gic(b);hic(b);iic(b);jic(b);kic(b);lic(b);mic(b);nic(b);oic(b);pic(b);qic(b);ric(b);sic(b);tic(b);uic(b);vic(b);wic(b);xic(b);yic(b);zic(b);Aic(b);Bic(b);Cic(b);Dic(b);Eic(b);Fic(b);Gic(b);Hic(b);Iic(b);Jic(b);Kic(b);Lic(b);Mic(b);Nic(b);Oic(b);Pic(b);Qic(b);Ric(b);Sic(b);Tic(b);Uic(b);Vic(b);Wic(b);Xic(b);Yic(b);Zic(b);_ic(b);$ic(b);ajc(b);bjc(b);cjc(b);djc(b);ejc(b);fjc(b);gjc(b);hjc(b);ijc(b);jjc(b);kjc(b);ljc(b);mjc(b);njc(b);ojc(b);pjc(b);qjc(b);rjc(b);sjc(b);tjc(b);ujc(b);vjc(b);wjc(b);xjc(b);yjc(b);zjc(b);Ajc(b);Bjc(b);Cjc(b);Djc(b);Ejc(b);Fjc(b);Gjc(b);Hjc(b);Ijc(b);Jjc(b);Kjc(b);Ljc(b);Mjc(b);Njc(b);Ojc(b);Pjc(b);Qjc(b);Rjc(b);Sjc(b);Tjc(b);Ujc(b);Vjc(b);Wjc(b);Xjc(b);Yjc(b);Zjc(b);_jc(b);$jc(b);akc(b);bkc(b);ckc(b);dkc(b);ekc(b);fkc(b);gkc(b);hkc(b);ikc(b);jkc(b);kkc(b);lkc(b);mkc(b);nkc(b);okc(b);pkc(b);qkc(b);rkc(b);skc(b);tkc(b);ukc(b);vkc(b);wkc(b);xkc(b);ykc(b);zkc(b);Akc(b);Bkc(b);Ckc(b);Dkc(b);Ekc(b);Fkc(b);Gkc(b);Hkc(b);Ikc(b);Jkc(b);Kkc(b);Lkc(b);Mkc(b);Nkc(b);Okc(b);Pkc(b);Qkc(b);Rkc(b);Skc(b);Tkc(b);Ukc(b);Vkc(b);Wkc(b);Xkc(b);Ykc(b);Zkc(b);_kc(b);$kc(b);alc(b);blc(b);clc(b);dlc(b);elc(b);flc(b);glc(b);hlc(b);ilc(b);jlc(b);klc(b);llc(b);mlc(b);nlc(b);olc(b);plc(b);qlc(b);rlc(b);slc(b);tlc(b);ulc(b);vlc(b);wlc(b);xlc(b);ylc(b);zlc(b);Alc(b);Blc(b);Clc(b);Dlc(b);Elc(b);Flc(b);Glc(b);Hlc(b);Ilc(b);Jlc(b);Klc(b);Llc(b);Mlc(b);Nlc(b);Olc(b);Plc(b);Qlc(b);Rlc(b);Slc(b);Tlc(b);Ulc(b);Vlc(b);Wlc(b);Xlc(b);Ylc(b);Zlc(b);_lc(b);$lc(b);amc(b);bmc(b);cmc(b);dmc(b);emc(b);fmc(b);gmc(b);hmc(b);imc(b);jmc(b);kmc(b);lmc(b);mmc(b);nmc(b);omc(b);pmc(b);qmc(b);rmc(b);smc(b);tmc(b);umc(b);vmc(b);wmc(b);xmc(b);ymc(b);zmc(b);Amc(b);Bmc(b);Cmc(b);Dmc(b);Emc(b);Fmc(b);Gmc(b);Hmc(b);Imc(b);Jmc(b);Kmc(b);Lmc(b);Mmc(b);Nmc(b);Omc(b);Pmc(b);Qmc(b);Rmc(b);Smc(b);Tmc(b);Umc(b);Vmc(b);Wmc(b);Xmc(b);Ymc(b);Zmc(b);_mc(b);$mc(b);anc(b);bnc(b);cnc(b);dnc(b);enc(b);fnc(b);gnc(b);hnc(b);inc(b);jnc(b);knc(b);lnc(b);mnc(b);nnc(b);onc(b);pnc(b);qnc(b);rnc(b);snc(b);tnc(b);unc(b);vnc(b);wnc(b);xnc(b);ync(b);znc(b);Anc(b);Bnc(b);Cnc(b);Dnc(b);Enc(b);Fnc(b);Gnc(b);Hnc(b);Inc(b);Jnc(b);Knc(b);Lnc(b);Mnc(b);Nnc(b);Onc(b);Pnc(b);Qnc(b);Rnc(b);Snc(b);Tnc(b);Unc(b);Vnc(b);Wnc(b);Xnc(b);Ync(b);Znc(b);_nc(b);$nc(b);aoc(b);boc(b);coc(b);doc(b);eoc(b);foc(b);goc(b);hoc(b);ioc(b);joc(b);koc(b);loc(b);moc(b);noc(b);ooc(b);poc(b);qoc(b);roc(b);soc(b);toc(b);uoc(b);voc(b);woc(b);xoc(b);yoc(b);zoc(b);Aoc(b);Boc(b);Coc(b);Doc(b);Eoc(b);Foc(b);Goc(b);Hoc(b);Ioc(b);Joc(b);Koc(b);Loc(b);Moc(b);Noc(b);Ooc(b);Poc(b);Qoc(b);Roc(b);Soc(b);Toc(b);Uoc(b);Voc(b);Woc(b);Xoc(b);Yoc(b);Zoc(b);_oc(b);$oc(b);apc(b);bpc(b);cpc(b);dpc(b);epc(b);fpc(b);gpc(b);hpc(b);ipc(b);jpc(b);kpc(b);lpc(b);mpc(b);npc(b);opc(b);ppc(b);qpc(b);rpc(b);spc(b);tpc(b);upc(b);vpc(b);wpc(b);xpc(b);ypc(b);zpc(b);Apc(b);Bpc(b);Cpc(b);Dpc(b);Epc(b);Fpc(b);Gpc(b);Hpc(b);Ipc(b);Jpc(b);Kpc(b);Lpc(b);Mpc(b);Npc(b);Opc(b);Ppc(b);Qpc(b);Rpc(b);Spc(b);Tpc(b);Upc(b);Vpc(b);Wpc(b);Xpc(b);Ypc(b);Zpc(b);_pc(b);$pc(b);aqc(b);bqc(b);cqc(b);dqc(b);eqc(b);fqc(b);gqc(b);hqc(b);iqc(b);jqc(b);kqc(b);lqc(b);mqc(b);nqc(b);oqc(b);pqc(b);qqc(b);rqc(b);sqc(b);tqc(b);uqc(b);vqc(b);wqc(b);xqc(b);yqc(b);zqc(b);Aqc(b);Bqc(b);Cqc(b);Dqc(b);Eqc(b);Fqc(b);Gqc(b);Hqc(b);Iqc(b);Jqc(b);Kqc(b);Lqc(b);Mqc(b);Nqc(b);Oqc(b);Pqc(b);Qqc(b);Rqc(b);Sqc(b);Tqc(b);Uqc(b);Vqc(b);Wqc(b);Xqc(b);Yqc(b);Zqc(b);_qc(b);$qc(b);arc(b);brc(b);crc(b);drc(b);erc(b);frc(b);grc(b);hrc(b);irc(b);jrc(b);krc(b);lrc(b);mrc(b);nrc(b);orc(b);prc(b);qrc(b);rrc(b);src(b);trc(b);urc(b);vrc(b);wrc(b);xrc(b);yrc(b);zrc(b);Arc(b);Brc(b);Crc(b);Drc(b);Erc(b);Frc(b);Grc(b);Hrc(b);Irc(b);Jrc(b);Krc(b);Lrc(b);Mrc(b);Nrc(b);Orc(b);Prc(b);Qrc(b);Rrc(b);Src(b);Trc(b);Urc(b);Vrc(b);Wrc(b);Xrc(b);Yrc(b);Zrc(b);_rc(b);$rc(b);asc(b);bsc(b);csc(b);dsc(b);esc(b);fsc(b);gsc(b);hsc(b);isc(b);jsc(b);ksc(b);lsc(b);msc(b);nsc(b);osc(b);psc(b);qsc(b);rsc(b);ssc(b);tsc(b);usc(b);vsc(b);wsc(b);xsc(b);ysc(b);zsc(b);Asc(b);Bsc(b);Csc(b);Dsc(b);Esc(b);Fsc(b);Gsc(b);Hsc(b);Isc(b);Jsc(b);Ksc(b);Lsc(b);Msc(b);Nsc(b);Osc(b);Psc(b);Qsc(b);Rsc(b);Ssc(b);Tsc(b);Usc(b);Vsc(b);Wsc(b);Xsc(b);Ysc(b);Zsc(b);_sc(b);$sc(b);atc(b);btc(b);ctc(b);dtc(b);etc(b);ftc(b);gtc(b);htc(b);itc(b);jtc(b);ktc(b);ltc(b);mtc(b);ntc(b);otc(b);ptc(b);qtc(b);rtc(b);stc(b);ttc(b);utc(b);vtc(b);wtc(b);xtc(b);ytc(b);ztc(b);Atc(b);Btc(b);Ctc(b);Dtc(b);Etc(b);Ftc(b);Gtc(b);Htc(b);Itc(b);Jtc(b);Ktc(b);Ltc(b);Mtc(b);Ntc(b);Otc(b);Ptc(b);Qtc(b);Rtc(b);Stc(b);Ttc(b);Utc(b);Vtc(b);Wtc(b);Xtc(b);Ytc(b);Ztc(b);_tc(b);$tc(b);auc(b);buc(b);cuc(b);duc(b);euc(b);fuc(b);guc(b);huc(b);iuc(b);juc(b);kuc(b);luc(b);muc(b);nuc(b);ouc(b);puc(b);quc(b);ruc(b);suc(b);tuc(b);uuc(b);vuc(b);wuc(b);xuc(b);yuc(b);zuc(b);Auc(b);Buc(b);Cuc(b);Duc(b);Euc(b);Fuc(b);Guc(b);Huc(b);Iuc(b);Juc(b);Kuc(b);Luc(b);Muc(b);Nuc(b);Ouc(b);Puc(b);Quc(b);Ruc(b);Suc(b);Tuc(b);Uuc(b);Vuc(b);Wuc(b);Xuc(b);Yuc(b);Zuc(b);_uc(b);$uc(b);avc(b);bvc(b);cvc(b);dvc(b);evc(b);fvc(b);gvc(b);hvc(b);ivc(b);jvc(b);kvc(b);lvc(b);mvc(b);nvc(b);ovc(b);pvc(b);qvc(b);rvc(b);svc(b);tvc(b);uvc(b);vvc(b);wvc(b);xvc(b);yvc(b);zvc(b);Avc(b);Bvc(b);Cvc(b);i=a;c[a+24>>2]=6;c[a+28>>2]=0;break a}while(0)}




// EMSCRIPTEN_END_FUNCS
var be=[O5c,bEc,dEc,iEc,kTc,O5c,O5c,O5c];var ce=[P5c,Ayc,Byc,ezc,fzc,Jzc,Kzc,fAc,gAc,hAc,d4c,c4c,b4c,Uxc,Vxc,FBc,DBc,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c,P5c];var de=[Q5c,QFc];var ee=[R5c,PEc];var fe=[S5c,uu,vu,Ox,jz,CUa,lz,ABc,aIc,dIc,cIc,eIc,iYc,hYc,kYc,jYc,fIc,hIc,tLc,PLc,QLc,RLc,VXc,UXc,XXc,WXc,ISc,VSc,WSc,XSc,ZSc,$Sc,RUc,SUc,YUc,ZUc,dVc,eVc,kVc,lVc,xVc,wVc,CVc,BVc,EVc,FVc,OVc,NVc,VWc,UWc,cXc,bXc,GXc,FXc,cYc,bYc,eYc,dYc,wYc,vYc,yYc,xYc,EYc,DYc,TWc,FYc,CYc,GYc,IYc,HYc,Q0c,OYc,NYc,TYc,SYc,qZc,pZc,UZc,TZc,g_c,f_c,u_c,t_c,I_c,H_c,V_c,U_c,Y_c,X_c,a$c,$_c,l$c,k$c,w$c,v$c,H$c,G$c,S$c,R$c,a0c,$$c,i0c,h0c,o0c,n0c,u0c,t0c,z0c,y0c,I0c,H0c,e1c,d1c,D0c,v1c,a2c,$1c,c2c,b2c,JYc,P0c,S0c,n1c,D1c,O1c,Z1c,_1c,Q3c,P3c,S3c,V3c,T3c,U3c,W3c,X3c,s4c,r4c,qu,T5c,wu,xu,yu,zu,Au,Bu,Cu,Du,Eu,Fu,Gu,Hu,Iu,Lu,Mu,Nu,Ou,Pu,Qu,Ru,Su,Tu,Uu,Vu,Wu,Xu,_u,$u,av,bv,cv,dv,ev,fv,gv,hv,iv,jv,kv,nv,ov,pv,qv,rv,sv,tv,uv,vv,wv,xv,yv,zv,Cv,Dv,Ev,Fv,Gv,Hv,Iv,Jv,Kv,Lv,Mv,Nv,Ov,Rv,Sv,Tv,Uv,Vv,Wv,Xv,Yv,Zv,_v,$v,aw,bw,cf,gf,hf,jf,kf,lf,mf,nf,of,pf,qf,rf,sf,tf,uf,vf,wf,xf,yf,zf,Af,Bf,Cf,Df,Ef,Ff,Gf,Hf,If,Jf,Kf,Lf,Mf,Nf,Of,Pf,Qf,Rf,Sf,Tf,Uf,Vf,Wf,Xf,Yf,Zf,_f,$f,ag,bg,Wh,Zh,$h,ai,bi,ci,xi,yi,zi,Ai,Bi,Ci,Di,Ii,Ji,Ki,Li,Mi,Ni,Oi,Pi,Qi,Ui,pj,qj,rj,uj,vj,wj,xj,Aj,Bj,Cj,Dj,Ej,Fj,Gj,Hj,Ij,Mj,gk,hk,ik,lk,mk,nk,ok,vk,wk,xk,yk,zk,Ak,Bk,Ck,Dk,Ek,bl,cl,dl,el,fl,gl,hl,nl,ol,pl,ql,rl,sl,tl,ul,vl,wl,Rl,Sl,Tl,Yl,Zl,_l,$l,cm,dm,em,fm,gm,hm,im,jm,km,om,zm,Cm,Hm,Im,Jm,Mm,Nm,Om,Pm,Wm,Xm,Ym,Zm,_m,$m,an,bn,cn,dn,en,fn,gn,hn,wn,xn,yn,zn,An,Bn,Cn,Dn,En,Fn,Gn,Hn,In,Jn,Kn,Ln,Mn,Nn,On,Pn,Qn,Rn,Sn,Tn,Un,Vn,Wn,Xn,Yn,Zn,_n,$n,ao,bo,co,eo,fo,go,ho,io,jo,ko,lo,mo,no,oo,po,qo,ro,so,to,uo,vo,wo,xo,yo,zo,Ao,Bo,Co,Do,Eo,Fo,Go,Ho,Io,Jo,Ko,Lo,Mo,No,Oo,Po,Qo,Ro,So,To,Uo,Vo,Wo,Xo,Yo,Zo,_o,$o,ap,bp,cp,dp,ep,fp,gp,hp,ip,jp,kp,lp,mp,np,op,pp,qp,rp,sp,tp,up,vp,wp,xp,yp,zp,Ap,Bp,Cp,Dp,Ep,Fp,Gp,Hp,Ip,Jp,Kp,Lp,Mp,Np,Op,Pp,Qp,Rp,Sp,Tp,Up,Vp,Wp,Xp,Yp,Zp,_p,$p,aq,bq,cq,dq,eq,fq,gq,hq,iq,jq,kq,lq,mq,nq,oq,pq,sq,tq,uq,vq,wq,xq,yq,zq,Aq,Bq,Cq,Dq,Eq,Fq,Gq,Hq,Iq,Jq,Kq,Lq,Mq,Nq,Oq,Pq,Qq,Rq,Sq,Tq,Uq,Vq,Wq,Xq,Yq,Zq,_q,$q,ar,br,cr,dr,er,fr,gr,hr,ir,jr,kr,lr,mr,nr,or,pr,qr,rr,sr,tr,ur,vr,wr,xr,yr,zr,Ar,Br,Cr,Dr,Er,Fr,Gr,Hr,Ir,Jr,Kr,Lr,Mr,Nr,Or,Pr,Qr,Rr,Sr,Tr,Ur,Vr,Wr,Xr,Yr,Zr,_r,$r,as,bs,cs,ds,es,fs,gs,hs,is,js,ks,ls,ms,ns,os,ps,qs,rs,ss,ts,us,vs,ws,xs,ys,zs,As,Bs,Cs,Ds,Es,Fs,Gs,Hs,Is,Js,Ks,Ls,Ms,Ns,Os,Ps,Qs,Rs,Ss,Ts,Us,Vs,Ws,Xs,Ys,Zs,_s,$s,at,bt,ct,dt,et,ft,gt,ht,it,jt,kt,lt,mt,nt,ot,pt,qt,rt,st,tt,ut,vt,wt,xt,yt,zt,At,Bt,Ct,Dt,Et,Ft,Gt,Ht,It,Jt,Kt,Lt,Mt,Nt,Ot,Pt,Qt,Rt,St,Tt,Ut,Vt,Wt,Xt,Yt,Zt,_t,$t,au,bu,cu,du,eu,fu,gu,hu,iu,ju,ku,lu,i4c,CBc,Ze,zEc,DEc,yEc,TFc,FEc,RFc,bDc,IEc,GEc,HEc,EEc,KEc,SFc,LEc,AEc,NEc,tSc,OEc,pUc,QUc,R0c,K2c,U$c,R2c,Q2c,P2c,O2c,N2c,M2c,cWc,GWc,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c,S5c];var ge=[U5c,kz,yGc,iIc,tXc,TUc,_Uc,fVc,mVc,HXc,d$c,e$c,f$c,g$c,i$c,j$c,o$c,p$c,q$c,r$c,t$c,u$c,z$c,A$c,B$c,C$c,E$c,F$c,K$c,L$c,M$c,N$c,P$c,Q$c,x0c,C0c,h2c,j2c,l2c,i2c,k2c,m2c,qEc,Ju,Yu,lv,Av,Pv,cw,rw,Gw,Vw,ix,xx,Mx,Px,Qx,Rx,Sx,Tx,Ux,Vx,Wx,Xx,Yx,Zx,_x,$x,ay,by,cy,dy,ey,fy,gy,hy,iy,jy,ky,ly,my,ny,oy,py,qy,ry,sy,ty,uy,vy,wy,xy,yy,zy,Ay,By,Cy,Dy,Ey,Fy,Gy,Hy,Iy,Jy,Ky,Ly,My,Ny,Oy,Py,Qy,Ry,Sy,Ty,Uy,Vy,Wy,Xy,Yy,Zy,_y,$y,az,bz,cz,dz,ez,fz,gz,hz,iz,JEc,$Kc,AGc,zGc,BGc,HGc,TGc,CGc,RGc,oKc,AKc,zKc,BKc,jKc,hKc,lKc,yTc,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c,U5c];var he=[V5c,hyc,ayc,cEc,eEc,fEc,gEc,hEc];var ie=[W5c,nu,Evc,mu,$e,af,bf,DUa,HUa,rz,BUa,Dvc,Svc,qz,oz,Tvc,Uvc,Zvc,_vc,$vc,awc,bwc,cwc,dwc,ewc,X5c,Y5c,Z5c,WBc,h4c,_5c,mIc,yXc,nIc,BXc,xXc,cTc,UUc,MXc,OXc,PXc,LXc,$Uc,aVc,gVc,AXc,nVc,oVc,yVc,DVc,AYc,v_c,n2c,p2c,r2c,x2c,z2c,t2c,v2c,J_c,o2c,q2c,s2c,y2c,A2c,u2c,w2c,b$c,c$c,h$c,m$c,n$c,s$c,x$c,y$c,D$c,I$c,J$c,O$c,z1c,A1c,C1c,d2c,f2c,e2c,g2c,r1c,s1c,u1c,J1c,K1c,N1c,U1c,V1c,Y1c,R3c,t4c,_Fc,$5c,a6c,YFc,ZFc,b6c,mSc,NSc,WEc,cFc,oFc,XEc,fFc,pFc,IUc,C4c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c,W5c];var je=[c6c,DCc];var ke=[d6c,NDc];var le=[e6c,nz,ryc,xyc,Xyc,bzc,Azc,Gzc,jIc,zXc,DXc,uXc,IXc,NXc,VUc,RXc,hVc,IVc,JVc,MYc,RYc,v0c,A0c,g1c,i1c,l1c,T0c,Y0c,_0c,b1c,Y3c,vSc,ECc,eyc,Xxc,cyc,iyc,f6c,g6c,h6c,UFc,sSc,oSc,i6c,AUc,j6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c,e6c];var me=[k6c,RDc];var ne=[l6c,jDc];var oe=[m6c,a_c,d_c,o_c,q_c,m6c,m6c,m6c];var pe=[n6c,W_c,Z_c,T$c,X$c,b0c,d0c,n6c];var qe=[o6c,LDc];var re=[p6c,xBc,kIc,aTc,JXc,vXc,VZc,WZc,_Zc,e_c,h_c,i_c,m_c,r_c,w0c,B0c,g4c,f4c,e4c,yBc,p6c,p6c,p6c,p6c,p6c,p6c,p6c,p6c,p6c,p6c,p6c,p6c];var se=[q6c,dFc,eFc,q6c];var te=[r6c,pu];var ue=[s6c,UYc,WYc,YYc,_Yc,aZc,cZc,eZc,gZc,iZc,kZc,mZc,rZc,tZc,vZc,xZc,zZc,BZc,DZc,FZc,HZc,JZc,LZc,ZZc,$Zc,l_c,n_c,w_c,x_c,y_c,z_c,A_c,K_c,L_c,M_c,N_c,O_c,m0c,s0c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c,s6c];var ve=[t6c,j0c,p0c,t6c];var we=[u6c,B_c,P_c,u6c];var xe=[v6c,_e,sz,pz,mz,fwc,gwc,tyc,uyc,wyc,Zyc,_yc,azc,Czc,Dzc,Fzc,Lzc,Mzc,Nzc,Ozc,Pzc,Qzc,Rzc,Szc,oIc,pIc,dTc,eTc,QXc,WUc,bVc,SXc,CXc,iVc,pVc,EXc,f1c,h1c,j1c,X0c,Z0c,$0c,IFc,rFc,hFc,YEc,gFc,qFc,w6c,k4c,Rxc,Sxc,Txc,x6c,hCc,kFc,nFc,$Ec,EFc,vFc,bFc,y6c,B3c,v6c];var ye=[z6c,KYc,PYc,m1c,y1c,B1c,c1c,q1c,t1c,I1c,L1c,T1c,W1c,nAc,eBc,fBc,sAc,pAc,cBc,dBc,tAc,uAc,vAc,wAc,xAc,UAc,VAc,LAc,EAc,zAc,yAc,AAc,BAc,DAc,CAc,qAc,oAc,FAc,GAc,HAc,IAc,JAc,KAc,MAc,NAc,OAc,PAc,TAc,RAc,QAc,SAc,_Ac,WAc,XAc,YAc,ZAc,$Ac,aBc,bBc,gBc,hBc,iBc,jBc,XZc];var ze=[A6c,dGc];var Ae=[B6c,sFc];var Be=[C6c,tDc];var Ce=[D6c,iwc,E6c,XBc,NUc,OUc,LUc,D6c];var De=[F6c,QDc];var Ee=[G6c,xSc,HVc,BYc,wCc,IBc,tGc,vGc,_Kc,xTc,G6c,G6c,G6c,G6c,G6c,G6c];var Fe=[H6c,I6c,VBc,mBc,su,H6c,H6c,H6c];var Ge=[J6c,hwc,w1c,x1c,o1c,p1c,E1c,G1c,P1c,R1c,wFc,J6c,J6c,J6c,J6c,J6c];var He=[K6c,lyc,myc,nyc,oyc,pyc,qyc,syc,vyc,zyc,Ryc,Syc,Tyc,Uyc,Vyc,Wyc,Yyc,$yc,dzc,uzc,vzc,wzc,xzc,yzc,zzc,Bzc,Ezc,Izc,k1c,U0c,V0c,W0c,a1c,sEc,L6c,MDc,Jxc,Mwc,fxc,oxc,axc,xxc,Cxc,Axc,Dxc,jyc,Pxc,Zxc,_xc,fyc,gyc,oZc,b_c,M6c,K6c,K6c,K6c,K6c,K6c,K6c,K6c,K6c,K6c,K6c];var Ie=[N6c,yyc,czc,Hzc,lIc,wSc,bTc,KXc,wXc,LYc,QYc,Z3c,_3c,$3c,GBc,EBc,uEc,HBc,uCc,Ku,Zu,mv,Bv,Qv,dw,sw,Hw,Ww,jx,yx,Nx,STc,$xc,JBc,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c,N6c];return{_testSetjmp:Y4c,_saveSetjmp:K4c,_free:i4c,_main:ru,_rand_r:S4c,_realloc:k4c,_i64Add:V4c,_memmove:O4c,_bitshift64Ashr:M4c,_memset:P4c,_malloc:h4c,_strncpy:W4c,_memcpy:N4c,_strlen:L4c,_bitshift64Lshr:X4c,_bitshift64Shl:Q4c,_i64Subtract:U4c,_strcpy:R4c,_calloc:j4c,_rand:T4c,__GLOBAL__I_a:rVc,runPostSets:J4c,stackAlloc:Je,stackSave:Ke,stackRestore:Le,setThrew:Me,setTempRet0:Pe,setTempRet1:Qe,setTempRet2:Re,setTempRet3:Se,setTempRet4:Te,setTempRet5:Ue,setTempRet6:Ve,setTempRet7:We,setTempRet8:Xe,setTempRet9:Ye,dynCall_iiiiiiii:g5c,dynCall_viiiii:h5c,dynCall_iiiiidiii:i5c,dynCall_vd:j5c,dynCall_vi:k5c,dynCall_vii:l5c,dynCall_iiiiiiiiiii:m5c,dynCall_ii:n5c,dynCall_viidi:o5c,dynCall_iiiiiiiiiiiiii:p5c,dynCall_iiii:q5c,dynCall_iiiiiiiiiiiiiiiiiiiiiii:r5c,dynCall_iiiiiiiiiiiiiiiiiiiii:s5c,dynCall_viiiiid:t5c,dynCall_viiiiiiii:u5c,dynCall_iiiiiiiiiiiiiiiiiiiiiiiii:v5c,dynCall_viiiiii:w5c,dynCall_viidii:x5c,dynCall_iid:y5c,dynCall_viiiiiii:z5c,dynCall_viiiiiid:A5c,dynCall_viiiiiiiii:B5c,dynCall_iii:C5c,dynCall_iiiiii:D5c,dynCall_iiiiidi:E5c,dynCall_didd:F5c,dynCall_dii:G5c,dynCall_i:H5c,dynCall_iiiiiiiiii:I5c,dynCall_viii:J5c,dynCall_v:K5c,dynCall_iiiiiiiii:L5c,dynCall_iiiii:M5c,dynCall_viiii:N5c}})


// EMSCRIPTEN_END_ASM
({ "Math": Math, "Int8Array": Int8Array, "Int16Array": Int16Array, "Int32Array": Int32Array, "Uint8Array": Uint8Array, "Uint16Array": Uint16Array, "Uint32Array": Uint32Array, "Float32Array": Float32Array, "Float64Array": Float64Array }, { "abort": abort, "assert": assert, "asmPrintInt": asmPrintInt, "asmPrintFloat": asmPrintFloat, "min": Math_min, "invoke_iiiiiiii": invoke_iiiiiiii, "invoke_viiiii": invoke_viiiii, "invoke_iiiiidiii": invoke_iiiiidiii, "invoke_vd": invoke_vd, "invoke_vi": invoke_vi, "invoke_vii": invoke_vii, "invoke_iiiiiiiiiii": invoke_iiiiiiiiiii, "invoke_ii": invoke_ii, "invoke_viidi": invoke_viidi, "invoke_iiiiiiiiiiiiii": invoke_iiiiiiiiiiiiii, "invoke_iiii": invoke_iiii, "invoke_iiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiii, "invoke_viiiiid": invoke_viiiiid, "invoke_viiiiiiii": invoke_viiiiiiii, "invoke_iiiiiiiiiiiiiiiiiiiiiiiii": invoke_iiiiiiiiiiiiiiiiiiiiiiiii, "invoke_viiiiii": invoke_viiiiii, "invoke_viidii": invoke_viidii, "invoke_iid": invoke_iid, "invoke_viiiiiii": invoke_viiiiiii, "invoke_viiiiiid": invoke_viiiiiid, "invoke_viiiiiiiii": invoke_viiiiiiiii, "invoke_iii": invoke_iii, "invoke_iiiiii": invoke_iiiiii, "invoke_iiiiidi": invoke_iiiiidi, "invoke_didd": invoke_didd, "invoke_dii": invoke_dii, "invoke_i": invoke_i, "invoke_iiiiiiiiii": invoke_iiiiiiiiii, "invoke_viii": invoke_viii, "invoke_v": invoke_v, "invoke_iiiiiiiii": invoke_iiiiiiiii, "invoke_iiiii": invoke_iiiii, "invoke_viiii": invoke_viiii, "_fabs": _fabs, "_lis_matrix_assemble": _lis_matrix_assemble, "_strrchr": _strrchr, "_pthread_key_create": _pthread_key_create, "_vsscanf": _vsscanf, "__ZSt9terminatev": __ZSt9terminatev, "___cxa_guard_acquire": ___cxa_guard_acquire, "__reallyNegative": __reallyNegative, "_fstat": _fstat, "_pclose": _pclose, "_lis_solver_create": _lis_solver_create, "___assert_fail": ___assert_fail, "__ZSt18uncaught_exceptionv": __ZSt18uncaught_exceptionv, "_longjmp": _longjmp, "__isLeapYear": __isLeapYear, "_clock_gettime": _clock_gettime, "_fsync": _fsync, "_signal": _signal, "_GC_collect_a_little": _GC_collect_a_little, "_sbrk": _sbrk, "_strtoull": _strtoull, "_emscripten_memcpy_big": _emscripten_memcpy_big, "__parseInt64": __parseInt64, "_close": _close, "_rewind": _rewind, "_cos": _cos, "_fileno": _fileno, "_fread": _fread, "_puts": _puts, "_isatty": _isatty, "_lis_matrix_set_value": _lis_matrix_set_value, "_write": _write, "_isblank": _isblank, "_ftell": _ftell, "__ZNSt9exceptionD2Ev": __ZNSt9exceptionD2Ev, "_xerbla_": _xerbla_, "_round": _round, "___cxa_does_inherit": ___cxa_does_inherit, "_strtoll_l": _strtoll_l, "_strstr": _strstr, "___cxa_rethrow": ___cxa_rethrow, "_llvm_lifetime_end": _llvm_lifetime_end, "_catclose": _catclose, "_tmpnam": _tmpnam, "_lis_vector_get_values": _lis_vector_get_values, "_lis_vector_destroy": _lis_vector_destroy, "_lis_solver_set_option": _lis_solver_set_option, "_tmpfile": _tmpfile, "_send": _send, "_pow": _pow, "_lis_matrix_set_size": _lis_matrix_set_size, "___cxa_free_exception": ___cxa_free_exception, "___cxa_find_matching_catch": ___cxa_find_matching_catch, "_isxdigit_l": _isxdigit_l, "___cxa_guard_release": ___cxa_guard_release, "_truncate": _truncate, "_strtol": _strtol, "_sin": _sin, "_strtok": _strtok, "___setErrNo": ___setErrNo, "_newlocale": _newlocale, "_isdigit_l": _isdigit_l, "___resumeException": ___resumeException, "_freelocale": _freelocale, "_srand": _srand, "_qsort": _qsort, "_putchar": _putchar, "_floor": _floor, "_pthread_mutex_unlock": _pthread_mutex_unlock, "_printf": _printf, "_sprintf": _sprintf, "_fopen": _fopen, "_vasprintf": _vasprintf, "_emscripten_get_now": _emscripten_get_now, "_stat": _stat, "_lis_solve": _lis_solve, "_strtoull_l": _strtoull_l, "_mkport": _mkport, "_read": _read, "__addDays": __addDays, "_fwrite": _fwrite, "_time": _time, "_pthread_mutex_lock": _pthread_mutex_lock, "_catopen": _catopen, "_exit": _exit, "_GC_strdup": _GC_strdup, "_freopen": _freopen, "___ctype_b_loc": ___ctype_b_loc, "_fmod": _fmod, "_strtok_r": _strtok_r, "_lseek": _lseek, "_access": _access, "_vfprintf": _vfprintf, "___cxa_allocate_exception": ___cxa_allocate_exception, "_atoi": _atoi, "_strtoll": _strtoll, "_pwrite": _pwrite, "_localtime_r": _localtime_r, "_tzset": _tzset, "_open": _open, "_uselocale": _uselocale, "_snprintf": _snprintf, "___errno_location": ___errno_location, "_GC_malloc": _GC_malloc, "___cxa_end_catch": ___cxa_end_catch, "_perror": _perror, "___cxa_begin_catch": ___cxa_begin_catch, "_strftime": _strftime, "_ftruncate": _ftruncate, "_GC_init": _GC_init, "_lis_matrix_set_type": _lis_matrix_set_type, "_fseek": _fseek, "_isxdigit": _isxdigit, "_fclose": _fclose, "_vsnprintf": _vsnprintf, "__parseInt": __parseInt, "_log": _log, "_pthread_cond_broadcast": _pthread_cond_broadcast, "_popen": _popen, "_recv": _recv, "_fgetc": _fgetc, "_sysconf": _sysconf, "__getFloat": __getFloat, "_lis_vector_set_value": _lis_vector_set_value, "_abort": _abort, "_ceil": _ceil, "_isspace": _isspace, "_localtime": _localtime, "_lis_matrix_destroy": _lis_matrix_destroy, "_pthread_getspecific": _pthread_getspecific, "_pthread_cond_wait": _pthread_cond_wait, "_llvm_lifetime_start": _llvm_lifetime_start, "___cxa_is_number_type": ___cxa_is_number_type, "_ungetc": _ungetc, "_system": _system, "_fmin": _fmin, "_fmax": _fmax, "_fflush": _fflush, "_strftime_l": _strftime_l, "_fprintf": _fprintf, "_sscanf": _sscanf, "_catgets": _catgets, "_lis_solver_destroy": _lis_solver_destroy, "_strdup": _strdup, "_asprintf": _asprintf, "__exit": __exit, "___ctype_toupper_loc": ___ctype_toupper_loc, "_bsearch": _bsearch, "__arraySum": __arraySum, "__formatString": __formatString, "_htonl": _htonl, "___ctype_tolower_loc": ___ctype_tolower_loc, "_unlink": _unlink, "_fputs": _fputs, "_GC_malloc_atomic": _GC_malloc_atomic, "_pread": _pread, "_lis_vector_set_size": _lis_vector_set_size, "_fscanf": _fscanf, "__scanString": __scanString, "_pthread_setspecific": _pthread_setspecific, "_copysign": _copysign, "_fputc": _fputc, "___cxa_throw": ___cxa_throw, "_lis_matrix_create": _lis_matrix_create, "_isdigit": _isdigit, "_strerror": _strerror, "_emscripten_longjmp": _emscripten_longjmp, "_lis_vector_create": _lis_vector_create, "_atexit": _atexit, "_sqrt": _sqrt, "_strerror_r": _strerror_r, "STACKTOP": STACKTOP, "STACK_MAX": STACK_MAX, "tempDoublePtr": tempDoublePtr, "ABORT": ABORT, "cttz_i8": cttz_i8, "ctlz_i8": ctlz_i8, "___rand_seed": ___rand_seed, "NaN": NaN, "Infinity": Infinity, "__ZTISt9exception": __ZTISt9exception, "___dso_handle": ___dso_handle, "_stderr": _stderr, "_stdin": _stdin, "_stdout": _stdout }, buffer);
var _testSetjmp = Module["_testSetjmp"] = asm["_testSetjmp"];
var _saveSetjmp = Module["_saveSetjmp"] = asm["_saveSetjmp"];
var _free = Module["_free"] = asm["_free"];
var _main = Module["_main"] = asm["_main"];
var _rand_r = Module["_rand_r"] = asm["_rand_r"];
var _realloc = Module["_realloc"] = asm["_realloc"];
var _i64Add = Module["_i64Add"] = asm["_i64Add"];
var _memmove = Module["_memmove"] = asm["_memmove"];
var _bitshift64Ashr = Module["_bitshift64Ashr"] = asm["_bitshift64Ashr"];
var _memset = Module["_memset"] = asm["_memset"];
var _malloc = Module["_malloc"] = asm["_malloc"];
var _strncpy = Module["_strncpy"] = asm["_strncpy"];
var _memcpy = Module["_memcpy"] = asm["_memcpy"];
var _strlen = Module["_strlen"] = asm["_strlen"];
var _bitshift64Lshr = Module["_bitshift64Lshr"] = asm["_bitshift64Lshr"];
var _bitshift64Shl = Module["_bitshift64Shl"] = asm["_bitshift64Shl"];
var _i64Subtract = Module["_i64Subtract"] = asm["_i64Subtract"];
var _strcpy = Module["_strcpy"] = asm["_strcpy"];
var _calloc = Module["_calloc"] = asm["_calloc"];
var _rand = Module["_rand"] = asm["_rand"];
var __GLOBAL__I_a = Module["__GLOBAL__I_a"] = asm["__GLOBAL__I_a"];
var runPostSets = Module["runPostSets"] = asm["runPostSets"];
var dynCall_iiiiiiii = Module["dynCall_iiiiiiii"] = asm["dynCall_iiiiiiii"];
var dynCall_viiiii = Module["dynCall_viiiii"] = asm["dynCall_viiiii"];
var dynCall_iiiiidiii = Module["dynCall_iiiiidiii"] = asm["dynCall_iiiiidiii"];
var dynCall_vd = Module["dynCall_vd"] = asm["dynCall_vd"];
var dynCall_vi = Module["dynCall_vi"] = asm["dynCall_vi"];
var dynCall_vii = Module["dynCall_vii"] = asm["dynCall_vii"];
var dynCall_iiiiiiiiiii = Module["dynCall_iiiiiiiiiii"] = asm["dynCall_iiiiiiiiiii"];
var dynCall_ii = Module["dynCall_ii"] = asm["dynCall_ii"];
var dynCall_viidi = Module["dynCall_viidi"] = asm["dynCall_viidi"];
var dynCall_iiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiii"];
var dynCall_iiii = Module["dynCall_iiii"] = asm["dynCall_iiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiid = Module["dynCall_viiiiid"] = asm["dynCall_viiiiid"];
var dynCall_viiiiiiii = Module["dynCall_viiiiiiii"] = asm["dynCall_viiiiiiii"];
var dynCall_iiiiiiiiiiiiiiiiiiiiiiiii = Module["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"] = asm["dynCall_iiiiiiiiiiiiiiiiiiiiiiiii"];
var dynCall_viiiiii = Module["dynCall_viiiiii"] = asm["dynCall_viiiiii"];
var dynCall_viidii = Module["dynCall_viidii"] = asm["dynCall_viidii"];
var dynCall_iid = Module["dynCall_iid"] = asm["dynCall_iid"];
var dynCall_viiiiiii = Module["dynCall_viiiiiii"] = asm["dynCall_viiiiiii"];
var dynCall_viiiiiid = Module["dynCall_viiiiiid"] = asm["dynCall_viiiiiid"];
var dynCall_viiiiiiiii = Module["dynCall_viiiiiiiii"] = asm["dynCall_viiiiiiiii"];
var dynCall_iii = Module["dynCall_iii"] = asm["dynCall_iii"];
var dynCall_iiiiii = Module["dynCall_iiiiii"] = asm["dynCall_iiiiii"];
var dynCall_iiiiidi = Module["dynCall_iiiiidi"] = asm["dynCall_iiiiidi"];
var dynCall_didd = Module["dynCall_didd"] = asm["dynCall_didd"];
var dynCall_dii = Module["dynCall_dii"] = asm["dynCall_dii"];
var dynCall_i = Module["dynCall_i"] = asm["dynCall_i"];
var dynCall_iiiiiiiiii = Module["dynCall_iiiiiiiiii"] = asm["dynCall_iiiiiiiiii"];
var dynCall_viii = Module["dynCall_viii"] = asm["dynCall_viii"];
var dynCall_v = Module["dynCall_v"] = asm["dynCall_v"];
var dynCall_iiiiiiiii = Module["dynCall_iiiiiiiii"] = asm["dynCall_iiiiiiiii"];
var dynCall_iiiii = Module["dynCall_iiiii"] = asm["dynCall_iiiii"];
var dynCall_viiii = Module["dynCall_viiii"] = asm["dynCall_viiii"];

Runtime.stackAlloc = function(size) { return asm['stackAlloc'](size) };
Runtime.stackSave = function() { return asm['stackSave']() };
Runtime.stackRestore = function(top) { asm['stackRestore'](top) };


// TODO: strip out parts of this we do not need

//======= begin closure i64 code =======

// Copyright 2009 The Closure Library Authors. All Rights Reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS-IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @fileoverview Defines a Long class for representing a 64-bit two's-complement
 * integer value, which faithfully simulates the behavior of a Java "long". This
 * implementation is derived from LongLib in GWT.
 *
 */

var i64Math = (function() { // Emscripten wrapper
  var goog = { math: {} };


  /**
   * Constructs a 64-bit two's-complement integer, given its low and high 32-bit
   * values as *signed* integers.  See the from* functions below for more
   * convenient ways of constructing Longs.
   *
   * The internal representation of a long is the two given signed, 32-bit values.
   * We use 32-bit pieces because these are the size of integers on which
   * Javascript performs bit-operations.  For operations like addition and
   * multiplication, we split each number into 16-bit pieces, which can easily be
   * multiplied within Javascript's floating-point representation without overflow
   * or change in sign.
   *
   * In the algorithms below, we frequently reduce the negative case to the
   * positive case by negating the input(s) and then post-processing the result.
   * Note that we must ALWAYS check specially whether those values are MIN_VALUE
   * (-2^63) because -MIN_VALUE == MIN_VALUE (since 2^63 cannot be represented as
   * a positive number, it overflows back into a negative).  Not handling this
   * case would often result in infinite recursion.
   *
   * @param {number} low  The low (signed) 32 bits of the long.
   * @param {number} high  The high (signed) 32 bits of the long.
   * @constructor
   */
  goog.math.Long = function(low, high) {
    /**
     * @type {number}
     * @private
     */
    this.low_ = low | 0;  // force into 32 signed bits.

    /**
     * @type {number}
     * @private
     */
    this.high_ = high | 0;  // force into 32 signed bits.
  };


  // NOTE: Common constant values ZERO, ONE, NEG_ONE, etc. are defined below the
  // from* methods on which they depend.


  /**
   * A cache of the Long representations of small integer values.
   * @type {!Object}
   * @private
   */
  goog.math.Long.IntCache_ = {};


  /**
   * Returns a Long representing the given (32-bit) integer value.
   * @param {number} value The 32-bit integer in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromInt = function(value) {
    if (-128 <= value && value < 128) {
      var cachedObj = goog.math.Long.IntCache_[value];
      if (cachedObj) {
        return cachedObj;
      }
    }

    var obj = new goog.math.Long(value | 0, value < 0 ? -1 : 0);
    if (-128 <= value && value < 128) {
      goog.math.Long.IntCache_[value] = obj;
    }
    return obj;
  };


  /**
   * Returns a Long representing the given value, provided that it is a finite
   * number.  Otherwise, zero is returned.
   * @param {number} value The number in question.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromNumber = function(value) {
    if (isNaN(value) || !isFinite(value)) {
      return goog.math.Long.ZERO;
    } else if (value <= -goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MIN_VALUE;
    } else if (value + 1 >= goog.math.Long.TWO_PWR_63_DBL_) {
      return goog.math.Long.MAX_VALUE;
    } else if (value < 0) {
      return goog.math.Long.fromNumber(-value).negate();
    } else {
      return new goog.math.Long(
          (value % goog.math.Long.TWO_PWR_32_DBL_) | 0,
          (value / goog.math.Long.TWO_PWR_32_DBL_) | 0);
    }
  };


  /**
   * Returns a Long representing the 64-bit integer that comes by concatenating
   * the given high and low bits.  Each is assumed to use 32 bits.
   * @param {number} lowBits The low 32-bits.
   * @param {number} highBits The high 32-bits.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromBits = function(lowBits, highBits) {
    return new goog.math.Long(lowBits, highBits);
  };


  /**
   * Returns a Long representation of the given string, written using the given
   * radix.
   * @param {string} str The textual representation of the Long.
   * @param {number=} opt_radix The radix in which the text is written.
   * @return {!goog.math.Long} The corresponding Long value.
   */
  goog.math.Long.fromString = function(str, opt_radix) {
    if (str.length == 0) {
      throw Error('number format error: empty string');
    }

    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (str.charAt(0) == '-') {
      return goog.math.Long.fromString(str.substring(1), radix).negate();
    } else if (str.indexOf('-') >= 0) {
      throw Error('number format error: interior "-" character: ' + str);
    }

    // Do several (8) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 8));

    var result = goog.math.Long.ZERO;
    for (var i = 0; i < str.length; i += 8) {
      var size = Math.min(8, str.length - i);
      var value = parseInt(str.substring(i, i + size), radix);
      if (size < 8) {
        var power = goog.math.Long.fromNumber(Math.pow(radix, size));
        result = result.multiply(power).add(goog.math.Long.fromNumber(value));
      } else {
        result = result.multiply(radixToPower);
        result = result.add(goog.math.Long.fromNumber(value));
      }
    }
    return result;
  };


  // NOTE: the compiler should inline these constant values below and then remove
  // these variables, so there should be no runtime penalty for these.


  /**
   * Number used repeated below in calculations.  This must appear before the
   * first call to any from* function below.
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_16_DBL_ = 1 << 16;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_24_DBL_ = 1 << 24;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_32_DBL_ =
      goog.math.Long.TWO_PWR_16_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_31_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ / 2;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_48_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_16_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_64_DBL_ =
      goog.math.Long.TWO_PWR_32_DBL_ * goog.math.Long.TWO_PWR_32_DBL_;


  /**
   * @type {number}
   * @private
   */
  goog.math.Long.TWO_PWR_63_DBL_ =
      goog.math.Long.TWO_PWR_64_DBL_ / 2;


  /** @type {!goog.math.Long} */
  goog.math.Long.ZERO = goog.math.Long.fromInt(0);


  /** @type {!goog.math.Long} */
  goog.math.Long.ONE = goog.math.Long.fromInt(1);


  /** @type {!goog.math.Long} */
  goog.math.Long.NEG_ONE = goog.math.Long.fromInt(-1);


  /** @type {!goog.math.Long} */
  goog.math.Long.MAX_VALUE =
      goog.math.Long.fromBits(0xFFFFFFFF | 0, 0x7FFFFFFF | 0);


  /** @type {!goog.math.Long} */
  goog.math.Long.MIN_VALUE = goog.math.Long.fromBits(0, 0x80000000 | 0);


  /**
   * @type {!goog.math.Long}
   * @private
   */
  goog.math.Long.TWO_PWR_24_ = goog.math.Long.fromInt(1 << 24);


  /** @return {number} The value, assuming it is a 32-bit integer. */
  goog.math.Long.prototype.toInt = function() {
    return this.low_;
  };


  /** @return {number} The closest floating-point representation to this value. */
  goog.math.Long.prototype.toNumber = function() {
    return this.high_ * goog.math.Long.TWO_PWR_32_DBL_ +
           this.getLowBitsUnsigned();
  };


  /**
   * @param {number=} opt_radix The radix in which the text should be written.
   * @return {string} The textual representation of this value.
   */
  goog.math.Long.prototype.toString = function(opt_radix) {
    var radix = opt_radix || 10;
    if (radix < 2 || 36 < radix) {
      throw Error('radix out of range: ' + radix);
    }

    if (this.isZero()) {
      return '0';
    }

    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        // We need to change the Long value before it can be negated, so we remove
        // the bottom-most digit in this base and then recurse to do the rest.
        var radixLong = goog.math.Long.fromNumber(radix);
        var div = this.div(radixLong);
        var rem = div.multiply(radixLong).subtract(this);
        return div.toString(radix) + rem.toInt().toString(radix);
      } else {
        return '-' + this.negate().toString(radix);
      }
    }

    // Do several (6) digits each time through the loop, so as to
    // minimize the calls to the very expensive emulated div.
    var radixToPower = goog.math.Long.fromNumber(Math.pow(radix, 6));

    var rem = this;
    var result = '';
    while (true) {
      var remDiv = rem.div(radixToPower);
      var intval = rem.subtract(remDiv.multiply(radixToPower)).toInt();
      var digits = intval.toString(radix);

      rem = remDiv;
      if (rem.isZero()) {
        return digits + result;
      } else {
        while (digits.length < 6) {
          digits = '0' + digits;
        }
        result = '' + digits + result;
      }
    }
  };


  /** @return {number} The high 32-bits as a signed value. */
  goog.math.Long.prototype.getHighBits = function() {
    return this.high_;
  };


  /** @return {number} The low 32-bits as a signed value. */
  goog.math.Long.prototype.getLowBits = function() {
    return this.low_;
  };


  /** @return {number} The low 32-bits as an unsigned value. */
  goog.math.Long.prototype.getLowBitsUnsigned = function() {
    return (this.low_ >= 0) ?
        this.low_ : goog.math.Long.TWO_PWR_32_DBL_ + this.low_;
  };


  /**
   * @return {number} Returns the number of bits needed to represent the absolute
   *     value of this Long.
   */
  goog.math.Long.prototype.getNumBitsAbs = function() {
    if (this.isNegative()) {
      if (this.equals(goog.math.Long.MIN_VALUE)) {
        return 64;
      } else {
        return this.negate().getNumBitsAbs();
      }
    } else {
      var val = this.high_ != 0 ? this.high_ : this.low_;
      for (var bit = 31; bit > 0; bit--) {
        if ((val & (1 << bit)) != 0) {
          break;
        }
      }
      return this.high_ != 0 ? bit + 33 : bit + 1;
    }
  };


  /** @return {boolean} Whether this value is zero. */
  goog.math.Long.prototype.isZero = function() {
    return this.high_ == 0 && this.low_ == 0;
  };


  /** @return {boolean} Whether this value is negative. */
  goog.math.Long.prototype.isNegative = function() {
    return this.high_ < 0;
  };


  /** @return {boolean} Whether this value is odd. */
  goog.math.Long.prototype.isOdd = function() {
    return (this.low_ & 1) == 1;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long equals the other.
   */
  goog.math.Long.prototype.equals = function(other) {
    return (this.high_ == other.high_) && (this.low_ == other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long does not equal the other.
   */
  goog.math.Long.prototype.notEquals = function(other) {
    return (this.high_ != other.high_) || (this.low_ != other.low_);
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than the other.
   */
  goog.math.Long.prototype.lessThan = function(other) {
    return this.compare(other) < 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is less than or equal to the other.
   */
  goog.math.Long.prototype.lessThanOrEqual = function(other) {
    return this.compare(other) <= 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than the other.
   */
  goog.math.Long.prototype.greaterThan = function(other) {
    return this.compare(other) > 0;
  };


  /**
   * @param {goog.math.Long} other Long to compare against.
   * @return {boolean} Whether this Long is greater than or equal to the other.
   */
  goog.math.Long.prototype.greaterThanOrEqual = function(other) {
    return this.compare(other) >= 0;
  };


  /**
   * Compares this Long with the given one.
   * @param {goog.math.Long} other Long to compare against.
   * @return {number} 0 if they are the same, 1 if the this is greater, and -1
   *     if the given one is greater.
   */
  goog.math.Long.prototype.compare = function(other) {
    if (this.equals(other)) {
      return 0;
    }

    var thisNeg = this.isNegative();
    var otherNeg = other.isNegative();
    if (thisNeg && !otherNeg) {
      return -1;
    }
    if (!thisNeg && otherNeg) {
      return 1;
    }

    // at this point, the signs are the same, so subtraction will not overflow
    if (this.subtract(other).isNegative()) {
      return -1;
    } else {
      return 1;
    }
  };


  /** @return {!goog.math.Long} The negation of this value. */
  goog.math.Long.prototype.negate = function() {
    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.MIN_VALUE;
    } else {
      return this.not().add(goog.math.Long.ONE);
    }
  };


  /**
   * Returns the sum of this and the given Long.
   * @param {goog.math.Long} other Long to add to this one.
   * @return {!goog.math.Long} The sum of this and the given Long.
   */
  goog.math.Long.prototype.add = function(other) {
    // Divide each number into 4 chunks of 16 bits, and then sum the chunks.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 + b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 + b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 + b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 + b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns the difference of this and the given Long.
   * @param {goog.math.Long} other Long to subtract from this.
   * @return {!goog.math.Long} The difference of this and the given Long.
   */
  goog.math.Long.prototype.subtract = function(other) {
    return this.add(other.negate());
  };


  /**
   * Returns the product of this and the given long.
   * @param {goog.math.Long} other Long to multiply with this.
   * @return {!goog.math.Long} The product of this and the other.
   */
  goog.math.Long.prototype.multiply = function(other) {
    if (this.isZero()) {
      return goog.math.Long.ZERO;
    } else if (other.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      return other.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return this.isOdd() ? goog.math.Long.MIN_VALUE : goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().multiply(other.negate());
      } else {
        return this.negate().multiply(other).negate();
      }
    } else if (other.isNegative()) {
      return this.multiply(other.negate()).negate();
    }

    // If both longs are small, use float multiplication
    if (this.lessThan(goog.math.Long.TWO_PWR_24_) &&
        other.lessThan(goog.math.Long.TWO_PWR_24_)) {
      return goog.math.Long.fromNumber(this.toNumber() * other.toNumber());
    }

    // Divide each long into 4 chunks of 16 bits, and then add up 4x4 products.
    // We can skip products that would overflow.

    var a48 = this.high_ >>> 16;
    var a32 = this.high_ & 0xFFFF;
    var a16 = this.low_ >>> 16;
    var a00 = this.low_ & 0xFFFF;

    var b48 = other.high_ >>> 16;
    var b32 = other.high_ & 0xFFFF;
    var b16 = other.low_ >>> 16;
    var b00 = other.low_ & 0xFFFF;

    var c48 = 0, c32 = 0, c16 = 0, c00 = 0;
    c00 += a00 * b00;
    c16 += c00 >>> 16;
    c00 &= 0xFFFF;
    c16 += a16 * b00;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c16 += a00 * b16;
    c32 += c16 >>> 16;
    c16 &= 0xFFFF;
    c32 += a32 * b00;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a16 * b16;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c32 += a00 * b32;
    c48 += c32 >>> 16;
    c32 &= 0xFFFF;
    c48 += a48 * b00 + a32 * b16 + a16 * b32 + a00 * b48;
    c48 &= 0xFFFF;
    return goog.math.Long.fromBits((c16 << 16) | c00, (c48 << 16) | c32);
  };


  /**
   * Returns this Long divided by the given one.
   * @param {goog.math.Long} other Long by which to divide.
   * @return {!goog.math.Long} This Long divided by the given one.
   */
  goog.math.Long.prototype.div = function(other) {
    if (other.isZero()) {
      throw Error('division by zero');
    } else if (this.isZero()) {
      return goog.math.Long.ZERO;
    }

    if (this.equals(goog.math.Long.MIN_VALUE)) {
      if (other.equals(goog.math.Long.ONE) ||
          other.equals(goog.math.Long.NEG_ONE)) {
        return goog.math.Long.MIN_VALUE;  // recall that -MIN_VALUE == MIN_VALUE
      } else if (other.equals(goog.math.Long.MIN_VALUE)) {
        return goog.math.Long.ONE;
      } else {
        // At this point, we have |other| >= 2, so |this/other| < |MIN_VALUE|.
        var halfThis = this.shiftRight(1);
        var approx = halfThis.div(other).shiftLeft(1);
        if (approx.equals(goog.math.Long.ZERO)) {
          return other.isNegative() ? goog.math.Long.ONE : goog.math.Long.NEG_ONE;
        } else {
          var rem = this.subtract(other.multiply(approx));
          var result = approx.add(rem.div(other));
          return result;
        }
      }
    } else if (other.equals(goog.math.Long.MIN_VALUE)) {
      return goog.math.Long.ZERO;
    }

    if (this.isNegative()) {
      if (other.isNegative()) {
        return this.negate().div(other.negate());
      } else {
        return this.negate().div(other).negate();
      }
    } else if (other.isNegative()) {
      return this.div(other.negate()).negate();
    }

    // Repeat the following until the remainder is less than other:  find a
    // floating-point that approximates remainder / other *from below*, add this
    // into the result, and subtract it from the remainder.  It is critical that
    // the approximate value is less than or equal to the real value so that the
    // remainder never becomes negative.
    var res = goog.math.Long.ZERO;
    var rem = this;
    while (rem.greaterThanOrEqual(other)) {
      // Approximate the result of division. This may be a little greater or
      // smaller than the actual value.
      var approx = Math.max(1, Math.floor(rem.toNumber() / other.toNumber()));

      // We will tweak the approximate result by changing it in the 48-th digit or
      // the smallest non-fractional digit, whichever is larger.
      var log2 = Math.ceil(Math.log(approx) / Math.LN2);
      var delta = (log2 <= 48) ? 1 : Math.pow(2, log2 - 48);

      // Decrease the approximation until it is smaller than the remainder.  Note
      // that if it is too large, the product overflows and is negative.
      var approxRes = goog.math.Long.fromNumber(approx);
      var approxRem = approxRes.multiply(other);
      while (approxRem.isNegative() || approxRem.greaterThan(rem)) {
        approx -= delta;
        approxRes = goog.math.Long.fromNumber(approx);
        approxRem = approxRes.multiply(other);
      }

      // We know the answer can't be zero... and actually, zero would cause
      // infinite recursion since we would make no progress.
      if (approxRes.isZero()) {
        approxRes = goog.math.Long.ONE;
      }

      res = res.add(approxRes);
      rem = rem.subtract(approxRem);
    }
    return res;
  };


  /**
   * Returns this Long modulo the given one.
   * @param {goog.math.Long} other Long by which to mod.
   * @return {!goog.math.Long} This Long modulo the given one.
   */
  goog.math.Long.prototype.modulo = function(other) {
    return this.subtract(this.div(other).multiply(other));
  };


  /** @return {!goog.math.Long} The bitwise-NOT of this value. */
  goog.math.Long.prototype.not = function() {
    return goog.math.Long.fromBits(~this.low_, ~this.high_);
  };


  /**
   * Returns the bitwise-AND of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to AND.
   * @return {!goog.math.Long} The bitwise-AND of this and the other.
   */
  goog.math.Long.prototype.and = function(other) {
    return goog.math.Long.fromBits(this.low_ & other.low_,
                                   this.high_ & other.high_);
  };


  /**
   * Returns the bitwise-OR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to OR.
   * @return {!goog.math.Long} The bitwise-OR of this and the other.
   */
  goog.math.Long.prototype.or = function(other) {
    return goog.math.Long.fromBits(this.low_ | other.low_,
                                   this.high_ | other.high_);
  };


  /**
   * Returns the bitwise-XOR of this Long and the given one.
   * @param {goog.math.Long} other The Long with which to XOR.
   * @return {!goog.math.Long} The bitwise-XOR of this and the other.
   */
  goog.math.Long.prototype.xor = function(other) {
    return goog.math.Long.fromBits(this.low_ ^ other.low_,
                                   this.high_ ^ other.high_);
  };


  /**
   * Returns this Long with bits shifted to the left by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the left by the given amount.
   */
  goog.math.Long.prototype.shiftLeft = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var low = this.low_;
      if (numBits < 32) {
        var high = this.high_;
        return goog.math.Long.fromBits(
            low << numBits,
            (high << numBits) | (low >>> (32 - numBits)));
      } else {
        return goog.math.Long.fromBits(0, low << (numBits - 32));
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount.
   */
  goog.math.Long.prototype.shiftRight = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >> numBits);
      } else {
        return goog.math.Long.fromBits(
            high >> (numBits - 32),
            high >= 0 ? 0 : -1);
      }
    }
  };


  /**
   * Returns this Long with bits shifted to the right by the given amount, with
   * the new top bits matching the current sign bit.
   * @param {number} numBits The number of bits by which to shift.
   * @return {!goog.math.Long} This shifted to the right by the given amount, with
   *     zeros placed into the new leading bits.
   */
  goog.math.Long.prototype.shiftRightUnsigned = function(numBits) {
    numBits &= 63;
    if (numBits == 0) {
      return this;
    } else {
      var high = this.high_;
      if (numBits < 32) {
        var low = this.low_;
        return goog.math.Long.fromBits(
            (low >>> numBits) | (high << (32 - numBits)),
            high >>> numBits);
      } else if (numBits == 32) {
        return goog.math.Long.fromBits(high, 0);
      } else {
        return goog.math.Long.fromBits(high >>> (numBits - 32), 0);
      }
    }
  };

  //======= begin jsbn =======

  var navigator = { appName: 'Modern Browser' }; // polyfill a little

  // Copyright (c) 2005  Tom Wu
  // All Rights Reserved.
  // http://www-cs-students.stanford.edu/~tjw/jsbn/

  /*
   * Copyright (c) 2003-2005  Tom Wu
   * All Rights Reserved.
   *
   * Permission is hereby granted, free of charge, to any person obtaining
   * a copy of this software and associated documentation files (the
   * "Software"), to deal in the Software without restriction, including
   * without limitation the rights to use, copy, modify, merge, publish,
   * distribute, sublicense, and/or sell copies of the Software, and to
   * permit persons to whom the Software is furnished to do so, subject to
   * the following conditions:
   *
   * The above copyright notice and this permission notice shall be
   * included in all copies or substantial portions of the Software.
   *
   * THE SOFTWARE IS PROVIDED "AS-IS" AND WITHOUT WARRANTY OF ANY KIND, 
   * EXPRESS, IMPLIED OR OTHERWISE, INCLUDING WITHOUT LIMITATION, ANY 
   * WARRANTY OF MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE.  
   *
   * IN NO EVENT SHALL TOM WU BE LIABLE FOR ANY SPECIAL, INCIDENTAL,
   * INDIRECT OR CONSEQUENTIAL DAMAGES OF ANY KIND, OR ANY DAMAGES WHATSOEVER
   * RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER OR NOT ADVISED OF
   * THE POSSIBILITY OF DAMAGE, AND ON ANY THEORY OF LIABILITY, ARISING OUT
   * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
   *
   * In addition, the following condition applies:
   *
   * All redistributions must retain an intact copy of this copyright notice
   * and disclaimer.
   */

  // Basic JavaScript BN library - subset useful for RSA encryption.

  // Bits per digit
  var dbits;

  // JavaScript engine analysis
  var canary = 0xdeadbeefcafe;
  var j_lm = ((canary&0xffffff)==0xefcafe);

  // (public) Constructor
  function BigInteger(a,b,c) {
    if(a != null)
      if("number" == typeof a) this.fromNumber(a,b,c);
      else if(b == null && "string" != typeof a) this.fromString(a,256);
      else this.fromString(a,b);
  }

  // return new, unset BigInteger
  function nbi() { return new BigInteger(null); }

  // am: Compute w_j += (x*this_i), propagate carries,
  // c is initial carry, returns final carry.
  // c < 3*dvalue, x < 2*dvalue, this_i < dvalue
  // We need to select the fastest one that works in this environment.

  // am1: use a single mult and divide to get the high bits,
  // max digit bits should be 26 because
  // max internal value = 2*dvalue^2-2*dvalue (< 2^53)
  function am1(i,x,w,j,c,n) {
    while(--n >= 0) {
      var v = x*this[i++]+w[j]+c;
      c = Math.floor(v/0x4000000);
      w[j++] = v&0x3ffffff;
    }
    return c;
  }
  // am2 avoids a big mult-and-extract completely.
  // Max digit bits should be <= 30 because we do bitwise ops
  // on values up to 2*hdvalue^2-hdvalue-1 (< 2^31)
  function am2(i,x,w,j,c,n) {
    var xl = x&0x7fff, xh = x>>15;
    while(--n >= 0) {
      var l = this[i]&0x7fff;
      var h = this[i++]>>15;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x7fff)<<15)+w[j]+(c&0x3fffffff);
      c = (l>>>30)+(m>>>15)+xh*h+(c>>>30);
      w[j++] = l&0x3fffffff;
    }
    return c;
  }
  // Alternately, set max digit bits to 28 since some
  // browsers slow down when dealing with 32-bit numbers.
  function am3(i,x,w,j,c,n) {
    var xl = x&0x3fff, xh = x>>14;
    while(--n >= 0) {
      var l = this[i]&0x3fff;
      var h = this[i++]>>14;
      var m = xh*l+h*xl;
      l = xl*l+((m&0x3fff)<<14)+w[j]+c;
      c = (l>>28)+(m>>14)+xh*h;
      w[j++] = l&0xfffffff;
    }
    return c;
  }
  if(j_lm && (navigator.appName == "Microsoft Internet Explorer")) {
    BigInteger.prototype.am = am2;
    dbits = 30;
  }
  else if(j_lm && (navigator.appName != "Netscape")) {
    BigInteger.prototype.am = am1;
    dbits = 26;
  }
  else { // Mozilla/Netscape seems to prefer am3
    BigInteger.prototype.am = am3;
    dbits = 28;
  }

  BigInteger.prototype.DB = dbits;
  BigInteger.prototype.DM = ((1<<dbits)-1);
  BigInteger.prototype.DV = (1<<dbits);

  var BI_FP = 52;
  BigInteger.prototype.FV = Math.pow(2,BI_FP);
  BigInteger.prototype.F1 = BI_FP-dbits;
  BigInteger.prototype.F2 = 2*dbits-BI_FP;

  // Digit conversions
  var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
  var BI_RC = new Array();
  var rr,vv;
  rr = "0".charCodeAt(0);
  for(vv = 0; vv <= 9; ++vv) BI_RC[rr++] = vv;
  rr = "a".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;
  rr = "A".charCodeAt(0);
  for(vv = 10; vv < 36; ++vv) BI_RC[rr++] = vv;

  function int2char(n) { return BI_RM.charAt(n); }
  function intAt(s,i) {
    var c = BI_RC[s.charCodeAt(i)];
    return (c==null)?-1:c;
  }

  // (protected) copy this to r
  function bnpCopyTo(r) {
    for(var i = this.t-1; i >= 0; --i) r[i] = this[i];
    r.t = this.t;
    r.s = this.s;
  }

  // (protected) set from integer value x, -DV <= x < DV
  function bnpFromInt(x) {
    this.t = 1;
    this.s = (x<0)?-1:0;
    if(x > 0) this[0] = x;
    else if(x < -1) this[0] = x+DV;
    else this.t = 0;
  }

  // return bigint initialized to value
  function nbv(i) { var r = nbi(); r.fromInt(i); return r; }

  // (protected) set from string and radix
  function bnpFromString(s,b) {
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 256) k = 8; // byte array
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else { this.fromRadix(s,b); return; }
    this.t = 0;
    this.s = 0;
    var i = s.length, mi = false, sh = 0;
    while(--i >= 0) {
      var x = (k==8)?s[i]&0xff:intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-") mi = true;
        continue;
      }
      mi = false;
      if(sh == 0)
        this[this.t++] = x;
      else if(sh+k > this.DB) {
        this[this.t-1] |= (x&((1<<(this.DB-sh))-1))<<sh;
        this[this.t++] = (x>>(this.DB-sh));
      }
      else
        this[this.t-1] |= x<<sh;
      sh += k;
      if(sh >= this.DB) sh -= this.DB;
    }
    if(k == 8 && (s[0]&0x80) != 0) {
      this.s = -1;
      if(sh > 0) this[this.t-1] |= ((1<<(this.DB-sh))-1)<<sh;
    }
    this.clamp();
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) clamp off excess high words
  function bnpClamp() {
    var c = this.s&this.DM;
    while(this.t > 0 && this[this.t-1] == c) --this.t;
  }

  // (public) return string representation in given radix
  function bnToString(b) {
    if(this.s < 0) return "-"+this.negate().toString(b);
    var k;
    if(b == 16) k = 4;
    else if(b == 8) k = 3;
    else if(b == 2) k = 1;
    else if(b == 32) k = 5;
    else if(b == 4) k = 2;
    else return this.toRadix(b);
    var km = (1<<k)-1, d, m = false, r = "", i = this.t;
    var p = this.DB-(i*this.DB)%k;
    if(i-- > 0) {
      if(p < this.DB && (d = this[i]>>p) > 0) { m = true; r = int2char(d); }
      while(i >= 0) {
        if(p < k) {
          d = (this[i]&((1<<p)-1))<<(k-p);
          d |= this[--i]>>(p+=this.DB-k);
        }
        else {
          d = (this[i]>>(p-=k))&km;
          if(p <= 0) { p += this.DB; --i; }
        }
        if(d > 0) m = true;
        if(m) r += int2char(d);
      }
    }
    return m?r:"0";
  }

  // (public) -this
  function bnNegate() { var r = nbi(); BigInteger.ZERO.subTo(this,r); return r; }

  // (public) |this|
  function bnAbs() { return (this.s<0)?this.negate():this; }

  // (public) return + if this > a, - if this < a, 0 if equal
  function bnCompareTo(a) {
    var r = this.s-a.s;
    if(r != 0) return r;
    var i = this.t;
    r = i-a.t;
    if(r != 0) return (this.s<0)?-r:r;
    while(--i >= 0) if((r=this[i]-a[i]) != 0) return r;
    return 0;
  }

  // returns bit length of the integer x
  function nbits(x) {
    var r = 1, t;
    if((t=x>>>16) != 0) { x = t; r += 16; }
    if((t=x>>8) != 0) { x = t; r += 8; }
    if((t=x>>4) != 0) { x = t; r += 4; }
    if((t=x>>2) != 0) { x = t; r += 2; }
    if((t=x>>1) != 0) { x = t; r += 1; }
    return r;
  }

  // (public) return the number of bits in "this"
  function bnBitLength() {
    if(this.t <= 0) return 0;
    return this.DB*(this.t-1)+nbits(this[this.t-1]^(this.s&this.DM));
  }

  // (protected) r = this << n*DB
  function bnpDLShiftTo(n,r) {
    var i;
    for(i = this.t-1; i >= 0; --i) r[i+n] = this[i];
    for(i = n-1; i >= 0; --i) r[i] = 0;
    r.t = this.t+n;
    r.s = this.s;
  }

  // (protected) r = this >> n*DB
  function bnpDRShiftTo(n,r) {
    for(var i = n; i < this.t; ++i) r[i-n] = this[i];
    r.t = Math.max(this.t-n,0);
    r.s = this.s;
  }

  // (protected) r = this << n
  function bnpLShiftTo(n,r) {
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<cbs)-1;
    var ds = Math.floor(n/this.DB), c = (this.s<<bs)&this.DM, i;
    for(i = this.t-1; i >= 0; --i) {
      r[i+ds+1] = (this[i]>>cbs)|c;
      c = (this[i]&bm)<<bs;
    }
    for(i = ds-1; i >= 0; --i) r[i] = 0;
    r[ds] = c;
    r.t = this.t+ds+1;
    r.s = this.s;
    r.clamp();
  }

  // (protected) r = this >> n
  function bnpRShiftTo(n,r) {
    r.s = this.s;
    var ds = Math.floor(n/this.DB);
    if(ds >= this.t) { r.t = 0; return; }
    var bs = n%this.DB;
    var cbs = this.DB-bs;
    var bm = (1<<bs)-1;
    r[0] = this[ds]>>bs;
    for(var i = ds+1; i < this.t; ++i) {
      r[i-ds-1] |= (this[i]&bm)<<cbs;
      r[i-ds] = this[i]>>bs;
    }
    if(bs > 0) r[this.t-ds-1] |= (this.s&bm)<<cbs;
    r.t = this.t-ds;
    r.clamp();
  }

  // (protected) r = this - a
  function bnpSubTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]-a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c -= a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c -= a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c -= a.s;
    }
    r.s = (c<0)?-1:0;
    if(c < -1) r[i++] = this.DV+c;
    else if(c > 0) r[i++] = c;
    r.t = i;
    r.clamp();
  }

  // (protected) r = this * a, r != this,a (HAC 14.12)
  // "this" should be the larger one if appropriate.
  function bnpMultiplyTo(a,r) {
    var x = this.abs(), y = a.abs();
    var i = x.t;
    r.t = i+y.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < y.t; ++i) r[i+x.t] = x.am(0,y[i],r,i,0,x.t);
    r.s = 0;
    r.clamp();
    if(this.s != a.s) BigInteger.ZERO.subTo(r,r);
  }

  // (protected) r = this^2, r != this (HAC 14.16)
  function bnpSquareTo(r) {
    var x = this.abs();
    var i = r.t = 2*x.t;
    while(--i >= 0) r[i] = 0;
    for(i = 0; i < x.t-1; ++i) {
      var c = x.am(i,x[i],r,2*i,0,1);
      if((r[i+x.t]+=x.am(i+1,2*x[i],r,2*i+1,c,x.t-i-1)) >= x.DV) {
        r[i+x.t] -= x.DV;
        r[i+x.t+1] = 1;
      }
    }
    if(r.t > 0) r[r.t-1] += x.am(i,x[i],r,2*i,0,1);
    r.s = 0;
    r.clamp();
  }

  // (protected) divide this by m, quotient and remainder to q, r (HAC 14.20)
  // r != q, this != m.  q or r may be null.
  function bnpDivRemTo(m,q,r) {
    var pm = m.abs();
    if(pm.t <= 0) return;
    var pt = this.abs();
    if(pt.t < pm.t) {
      if(q != null) q.fromInt(0);
      if(r != null) this.copyTo(r);
      return;
    }
    if(r == null) r = nbi();
    var y = nbi(), ts = this.s, ms = m.s;
    var nsh = this.DB-nbits(pm[pm.t-1]);	// normalize modulus
    if(nsh > 0) { pm.lShiftTo(nsh,y); pt.lShiftTo(nsh,r); }
    else { pm.copyTo(y); pt.copyTo(r); }
    var ys = y.t;
    var y0 = y[ys-1];
    if(y0 == 0) return;
    var yt = y0*(1<<this.F1)+((ys>1)?y[ys-2]>>this.F2:0);
    var d1 = this.FV/yt, d2 = (1<<this.F1)/yt, e = 1<<this.F2;
    var i = r.t, j = i-ys, t = (q==null)?nbi():q;
    y.dlShiftTo(j,t);
    if(r.compareTo(t) >= 0) {
      r[r.t++] = 1;
      r.subTo(t,r);
    }
    BigInteger.ONE.dlShiftTo(ys,t);
    t.subTo(y,y);	// "negative" y so we can replace sub with am later
    while(y.t < ys) y[y.t++] = 0;
    while(--j >= 0) {
      // Estimate quotient digit
      var qd = (r[--i]==y0)?this.DM:Math.floor(r[i]*d1+(r[i-1]+e)*d2);
      if((r[i]+=y.am(0,qd,r,j,0,ys)) < qd) {	// Try it out
        y.dlShiftTo(j,t);
        r.subTo(t,r);
        while(r[i] < --qd) r.subTo(t,r);
      }
    }
    if(q != null) {
      r.drShiftTo(ys,q);
      if(ts != ms) BigInteger.ZERO.subTo(q,q);
    }
    r.t = ys;
    r.clamp();
    if(nsh > 0) r.rShiftTo(nsh,r);	// Denormalize remainder
    if(ts < 0) BigInteger.ZERO.subTo(r,r);
  }

  // (public) this mod a
  function bnMod(a) {
    var r = nbi();
    this.abs().divRemTo(a,null,r);
    if(this.s < 0 && r.compareTo(BigInteger.ZERO) > 0) a.subTo(r,r);
    return r;
  }

  // Modular reduction using "classic" algorithm
  function Classic(m) { this.m = m; }
  function cConvert(x) {
    if(x.s < 0 || x.compareTo(this.m) >= 0) return x.mod(this.m);
    else return x;
  }
  function cRevert(x) { return x; }
  function cReduce(x) { x.divRemTo(this.m,null,x); }
  function cMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }
  function cSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  Classic.prototype.convert = cConvert;
  Classic.prototype.revert = cRevert;
  Classic.prototype.reduce = cReduce;
  Classic.prototype.mulTo = cMulTo;
  Classic.prototype.sqrTo = cSqrTo;

  // (protected) return "-1/this % 2^DB"; useful for Mont. reduction
  // justification:
  //         xy == 1 (mod m)
  //         xy =  1+km
  //   xy(2-xy) = (1+km)(1-km)
  // x[y(2-xy)] = 1-k^2m^2
  // x[y(2-xy)] == 1 (mod m^2)
  // if y is 1/x mod m, then y(2-xy) is 1/x mod m^2
  // should reduce x and y(2-xy) by m^2 at each step to keep size bounded.
  // JS multiply "overflows" differently from C/C++, so care is needed here.
  function bnpInvDigit() {
    if(this.t < 1) return 0;
    var x = this[0];
    if((x&1) == 0) return 0;
    var y = x&3;		// y == 1/x mod 2^2
    y = (y*(2-(x&0xf)*y))&0xf;	// y == 1/x mod 2^4
    y = (y*(2-(x&0xff)*y))&0xff;	// y == 1/x mod 2^8
    y = (y*(2-(((x&0xffff)*y)&0xffff)))&0xffff;	// y == 1/x mod 2^16
    // last step - calculate inverse mod DV directly;
    // assumes 16 < DB <= 32 and assumes ability to handle 48-bit ints
    y = (y*(2-x*y%this.DV))%this.DV;		// y == 1/x mod 2^dbits
    // we really want the negative inverse, and -DV < y < DV
    return (y>0)?this.DV-y:-y;
  }

  // Montgomery reduction
  function Montgomery(m) {
    this.m = m;
    this.mp = m.invDigit();
    this.mpl = this.mp&0x7fff;
    this.mph = this.mp>>15;
    this.um = (1<<(m.DB-15))-1;
    this.mt2 = 2*m.t;
  }

  // xR mod m
  function montConvert(x) {
    var r = nbi();
    x.abs().dlShiftTo(this.m.t,r);
    r.divRemTo(this.m,null,r);
    if(x.s < 0 && r.compareTo(BigInteger.ZERO) > 0) this.m.subTo(r,r);
    return r;
  }

  // x/R mod m
  function montRevert(x) {
    var r = nbi();
    x.copyTo(r);
    this.reduce(r);
    return r;
  }

  // x = x/R mod m (HAC 14.32)
  function montReduce(x) {
    while(x.t <= this.mt2)	// pad x so am has enough room later
      x[x.t++] = 0;
    for(var i = 0; i < this.m.t; ++i) {
      // faster way of calculating u0 = x[i]*mp mod DV
      var j = x[i]&0x7fff;
      var u0 = (j*this.mpl+(((j*this.mph+(x[i]>>15)*this.mpl)&this.um)<<15))&x.DM;
      // use am to combine the multiply-shift-add into one call
      j = i+this.m.t;
      x[j] += this.m.am(0,u0,x,i,0,this.m.t);
      // propagate carry
      while(x[j] >= x.DV) { x[j] -= x.DV; x[++j]++; }
    }
    x.clamp();
    x.drShiftTo(this.m.t,x);
    if(x.compareTo(this.m) >= 0) x.subTo(this.m,x);
  }

  // r = "x^2/R mod m"; x != r
  function montSqrTo(x,r) { x.squareTo(r); this.reduce(r); }

  // r = "xy/R mod m"; x,y != r
  function montMulTo(x,y,r) { x.multiplyTo(y,r); this.reduce(r); }

  Montgomery.prototype.convert = montConvert;
  Montgomery.prototype.revert = montRevert;
  Montgomery.prototype.reduce = montReduce;
  Montgomery.prototype.mulTo = montMulTo;
  Montgomery.prototype.sqrTo = montSqrTo;

  // (protected) true iff this is even
  function bnpIsEven() { return ((this.t>0)?(this[0]&1):this.s) == 0; }

  // (protected) this^e, e < 2^32, doing sqr and mul with "r" (HAC 14.79)
  function bnpExp(e,z) {
    if(e > 0xffffffff || e < 1) return BigInteger.ONE;
    var r = nbi(), r2 = nbi(), g = z.convert(this), i = nbits(e)-1;
    g.copyTo(r);
    while(--i >= 0) {
      z.sqrTo(r,r2);
      if((e&(1<<i)) > 0) z.mulTo(r2,g,r);
      else { var t = r; r = r2; r2 = t; }
    }
    return z.revert(r);
  }

  // (public) this^e % m, 0 <= e < 2^32
  function bnModPowInt(e,m) {
    var z;
    if(e < 256 || m.isEven()) z = new Classic(m); else z = new Montgomery(m);
    return this.exp(e,z);
  }

  // protected
  BigInteger.prototype.copyTo = bnpCopyTo;
  BigInteger.prototype.fromInt = bnpFromInt;
  BigInteger.prototype.fromString = bnpFromString;
  BigInteger.prototype.clamp = bnpClamp;
  BigInteger.prototype.dlShiftTo = bnpDLShiftTo;
  BigInteger.prototype.drShiftTo = bnpDRShiftTo;
  BigInteger.prototype.lShiftTo = bnpLShiftTo;
  BigInteger.prototype.rShiftTo = bnpRShiftTo;
  BigInteger.prototype.subTo = bnpSubTo;
  BigInteger.prototype.multiplyTo = bnpMultiplyTo;
  BigInteger.prototype.squareTo = bnpSquareTo;
  BigInteger.prototype.divRemTo = bnpDivRemTo;
  BigInteger.prototype.invDigit = bnpInvDigit;
  BigInteger.prototype.isEven = bnpIsEven;
  BigInteger.prototype.exp = bnpExp;

  // public
  BigInteger.prototype.toString = bnToString;
  BigInteger.prototype.negate = bnNegate;
  BigInteger.prototype.abs = bnAbs;
  BigInteger.prototype.compareTo = bnCompareTo;
  BigInteger.prototype.bitLength = bnBitLength;
  BigInteger.prototype.mod = bnMod;
  BigInteger.prototype.modPowInt = bnModPowInt;

  // "constants"
  BigInteger.ZERO = nbv(0);
  BigInteger.ONE = nbv(1);

  // jsbn2 stuff

  // (protected) convert from radix string
  function bnpFromRadix(s,b) {
    this.fromInt(0);
    if(b == null) b = 10;
    var cs = this.chunkSize(b);
    var d = Math.pow(b,cs), mi = false, j = 0, w = 0;
    for(var i = 0; i < s.length; ++i) {
      var x = intAt(s,i);
      if(x < 0) {
        if(s.charAt(i) == "-" && this.signum() == 0) mi = true;
        continue;
      }
      w = b*w+x;
      if(++j >= cs) {
        this.dMultiply(d);
        this.dAddOffset(w,0);
        j = 0;
        w = 0;
      }
    }
    if(j > 0) {
      this.dMultiply(Math.pow(b,j));
      this.dAddOffset(w,0);
    }
    if(mi) BigInteger.ZERO.subTo(this,this);
  }

  // (protected) return x s.t. r^x < DV
  function bnpChunkSize(r) { return Math.floor(Math.LN2*this.DB/Math.log(r)); }

  // (public) 0 if this == 0, 1 if this > 0
  function bnSigNum() {
    if(this.s < 0) return -1;
    else if(this.t <= 0 || (this.t == 1 && this[0] <= 0)) return 0;
    else return 1;
  }

  // (protected) this *= n, this >= 0, 1 < n < DV
  function bnpDMultiply(n) {
    this[this.t] = this.am(0,n-1,this,0,0,this.t);
    ++this.t;
    this.clamp();
  }

  // (protected) this += n << w words, this >= 0
  function bnpDAddOffset(n,w) {
    if(n == 0) return;
    while(this.t <= w) this[this.t++] = 0;
    this[w] += n;
    while(this[w] >= this.DV) {
      this[w] -= this.DV;
      if(++w >= this.t) this[this.t++] = 0;
      ++this[w];
    }
  }

  // (protected) convert to radix string
  function bnpToRadix(b) {
    if(b == null) b = 10;
    if(this.signum() == 0 || b < 2 || b > 36) return "0";
    var cs = this.chunkSize(b);
    var a = Math.pow(b,cs);
    var d = nbv(a), y = nbi(), z = nbi(), r = "";
    this.divRemTo(d,y,z);
    while(y.signum() > 0) {
      r = (a+z.intValue()).toString(b).substr(1) + r;
      y.divRemTo(d,y,z);
    }
    return z.intValue().toString(b) + r;
  }

  // (public) return value as integer
  function bnIntValue() {
    if(this.s < 0) {
      if(this.t == 1) return this[0]-this.DV;
      else if(this.t == 0) return -1;
    }
    else if(this.t == 1) return this[0];
    else if(this.t == 0) return 0;
    // assumes 16 < DB < 32
    return ((this[1]&((1<<(32-this.DB))-1))<<this.DB)|this[0];
  }

  // (protected) r = this + a
  function bnpAddTo(a,r) {
    var i = 0, c = 0, m = Math.min(a.t,this.t);
    while(i < m) {
      c += this[i]+a[i];
      r[i++] = c&this.DM;
      c >>= this.DB;
    }
    if(a.t < this.t) {
      c += a.s;
      while(i < this.t) {
        c += this[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += this.s;
    }
    else {
      c += this.s;
      while(i < a.t) {
        c += a[i];
        r[i++] = c&this.DM;
        c >>= this.DB;
      }
      c += a.s;
    }
    r.s = (c<0)?-1:0;
    if(c > 0) r[i++] = c;
    else if(c < -1) r[i++] = this.DV+c;
    r.t = i;
    r.clamp();
  }

  BigInteger.prototype.fromRadix = bnpFromRadix;
  BigInteger.prototype.chunkSize = bnpChunkSize;
  BigInteger.prototype.signum = bnSigNum;
  BigInteger.prototype.dMultiply = bnpDMultiply;
  BigInteger.prototype.dAddOffset = bnpDAddOffset;
  BigInteger.prototype.toRadix = bnpToRadix;
  BigInteger.prototype.intValue = bnIntValue;
  BigInteger.prototype.addTo = bnpAddTo;

  //======= end jsbn =======

  // Emscripten wrapper
  var Wrapper = {
    abs: function(l, h) {
      var x = new goog.math.Long(l, h);
      var ret;
      if (x.isNegative()) {
        ret = x.negate();
      } else {
        ret = x;
      }
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
    },
    ensureTemps: function() {
      if (Wrapper.ensuredTemps) return;
      Wrapper.ensuredTemps = true;
      Wrapper.two32 = new BigInteger();
      Wrapper.two32.fromString('4294967296', 10);
      Wrapper.two64 = new BigInteger();
      Wrapper.two64.fromString('18446744073709551616', 10);
      Wrapper.temp1 = new BigInteger();
      Wrapper.temp2 = new BigInteger();
    },
    lh2bignum: function(l, h) {
      var a = new BigInteger();
      a.fromString(h.toString(), 10);
      var b = new BigInteger();
      a.multiplyTo(Wrapper.two32, b);
      var c = new BigInteger();
      c.fromString(l.toString(), 10);
      var d = new BigInteger();
      c.addTo(b, d);
      return d;
    },
    stringify: function(l, h, unsigned) {
      var ret = new goog.math.Long(l, h).toString();
      if (unsigned && ret[0] == '-') {
        // unsign slowly using jsbn bignums
        Wrapper.ensureTemps();
        var bignum = new BigInteger();
        bignum.fromString(ret, 10);
        ret = new BigInteger();
        Wrapper.two64.addTo(bignum, ret);
        ret = ret.toString(10);
      }
      return ret;
    },
    fromString: function(str, base, min, max, unsigned) {
      Wrapper.ensureTemps();
      var bignum = new BigInteger();
      bignum.fromString(str, base);
      var bigmin = new BigInteger();
      bigmin.fromString(min, 10);
      var bigmax = new BigInteger();
      bigmax.fromString(max, 10);
      if (unsigned && bignum.compareTo(BigInteger.ZERO) < 0) {
        var temp = new BigInteger();
        bignum.addTo(Wrapper.two64, temp);
        bignum = temp;
      }
      var error = false;
      if (bignum.compareTo(bigmin) < 0) {
        bignum = bigmin;
        error = true;
      } else if (bignum.compareTo(bigmax) > 0) {
        bignum = bigmax;
        error = true;
      }
      var ret = goog.math.Long.fromString(bignum.toString()); // min-max checks should have clamped this to a range goog.math.Long can handle well
      HEAP32[tempDoublePtr>>2] = ret.low_;
      HEAP32[tempDoublePtr+4>>2] = ret.high_;
      if (error) throw 'range error';
    }
  };
  return Wrapper;
})();

//======= end closure i64 code =======



// === Auto-generated postamble setup entry stuff ===

if (memoryInitializer) {
  if (ENVIRONMENT_IS_NODE || ENVIRONMENT_IS_SHELL) {
    var data = Module['readBinary'](memoryInitializer);
    HEAPU8.set(data, STATIC_BASE);
  } else {
    addRunDependency('memory initializer');
    Browser.asyncLoad(memoryInitializer, function(data) {
      HEAPU8.set(data, STATIC_BASE);
      removeRunDependency('memory initializer');
    }, function(data) {
      throw 'could not load memory initializer ' + memoryInitializer;
    });
  }
}

function ExitStatus(status) {
  this.name = "ExitStatus";
  this.message = "Program terminated with exit(" + status + ")";
  this.status = status;
};
ExitStatus.prototype = new Error();
ExitStatus.prototype.constructor = ExitStatus;

var initialStackTop;
var preloadStartTime = null;
var calledMain = false;

dependenciesFulfilled = function runCaller() {
  // If run has never been called, and we should call run (INVOKE_RUN is true, and Module.noInitialRun is not false)
  if (!Module['calledRun'] && shouldRunNow) run();
  if (!Module['calledRun']) dependenciesFulfilled = runCaller; // try this again later, after new deps are fulfilled
}

Module['callMain'] = Module.callMain = function callMain(args) {
  assert(runDependencies == 0, 'cannot call main when async dependencies remain! (listen on __ATMAIN__)');
  assert(__ATPRERUN__.length == 0, 'cannot call main when preRun functions remain to be called');

  args = args || [];

  if (ENVIRONMENT_IS_WEB && preloadStartTime !== null) {
    Module.printErr('preload time: ' + (Date.now() - preloadStartTime) + ' ms');
  }

  ensureInitRuntime();

  var argc = args.length+1;
  function pad() {
    for (var i = 0; i < 4-1; i++) {
      argv.push(0);
    }
  }
  var argv = [allocate(intArrayFromString("/bin/this.program"), 'i8', ALLOC_NORMAL) ];
  pad();
  for (var i = 0; i < argc-1; i = i + 1) {
    argv.push(allocate(intArrayFromString(args[i]), 'i8', ALLOC_NORMAL));
    pad();
  }
  argv.push(0);
  argv = allocate(argv, 'i32', ALLOC_NORMAL);

  initialStackTop = STACKTOP;

  try {

    var ret = Module['_main'](argc, argv, 0);


    // if we're not running an evented main loop, it's time to exit
    if (!Module['noExitRuntime']) {
      exit(ret);
    }
  }
  catch(e) {
    if (e instanceof ExitStatus) {
      // exit() throws this once it's done to make sure execution
      // has been stopped completely
      return;
    } else if (e == 'SimulateInfiniteLoop') {
      // running an evented main loop, don't immediately exit
      Module['noExitRuntime'] = true;
      return;
    } else {
      if (e && typeof e === 'object' && e.stack) Module.printErr('exception thrown: ' + [e, e.stack]);
      throw e;
    }
  } finally {
    calledMain = true;
  }
}




function run(args) {
  args = args || Module['arguments'];

  if (preloadStartTime === null) preloadStartTime = Date.now();

  if (runDependencies > 0) {
    Module.printErr('run() called, but dependencies remain, so not running');
    return;
  }

  preRun();

  if (runDependencies > 0) return; // a preRun added a dependency, run will be called later
  if (Module['calledRun']) return; // run may have just been called through dependencies being fulfilled just in this very frame

  function doRun() {
    if (Module['calledRun']) return; // run may have just been called while the async setStatus time below was happening
    Module['calledRun'] = true;

    ensureInitRuntime();

    preMain();

    if (Module['_main'] && shouldRunNow) {
      Module['callMain'](args);
    }

    postRun();
  }

  if (Module['setStatus']) {
    Module['setStatus']('Running...');
    setTimeout(function() {
      setTimeout(function() {
        Module['setStatus']('');
      }, 1);
      if (!ABORT) doRun();
    }, 1);
  } else {
    doRun();
  }
}
Module['run'] = Module.run = run;

function exit(status) {
  ABORT = true;
  EXITSTATUS = status;
  STACKTOP = initialStackTop;

  // exit the runtime
  exitRuntime();

  // TODO We should handle this differently based on environment.
  // In the browser, the best we can do is throw an exception
  // to halt execution, but in node we could process.exit and
  // I'd imagine SM shell would have something equivalent.
  // This would let us set a proper exit status (which
  // would be great for checking test exit statuses).
  // https://github.com/kripken/emscripten/issues/1371

  // throw an exception to halt the current execution
  throw new ExitStatus(status);
}
Module['exit'] = Module.exit = exit;

function abort(text) {
  if (text) {
    Module.print(text);
    Module.printErr(text);
  }

  ABORT = true;
  EXITSTATUS = 1;

  throw 'abort() at ' + stackTrace();
}
Module['abort'] = Module.abort = abort;

// {{PRE_RUN_ADDITIONS}}

if (Module['preInit']) {
  if (typeof Module['preInit'] == 'function') Module['preInit'] = [Module['preInit']];
  while (Module['preInit'].length > 0) {
    Module['preInit'].pop()();
  }
}

// shouldRunNow refers to calling main(), not run().
var shouldRunNow = true;
if (Module['noInitialRun']) {
  shouldRunNow = false;
}


run();

// {{POST_RUN_ADDITIONS}}






// {{MODULE_ADDITIONS}}






